<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_c3a49989e40b21e7508f29d2dc962def.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_b7a82fce77e4bbd362370838bf9090cb.php">error_estimation</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">adjoint_residual_error_estimator.C</div>  </div>
</div>
<div class="contents">
<a href="adjoint__residual__error__estimator_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id$</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="comment">// C++ includes</span>
<a name="l00022"></a>00022 
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="comment">// Local Includes</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="adjoint__residual__error__estimator_8h.php">adjoint_residual_error_estimator.h</a>&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="error__vector_8h.php">error_vector.h</a>&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="patch__recovery__error__estimator_8h.php">patch_recovery_error_estimator.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__logging_8h.php">libmesh_logging.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="numeric__vector_8h.php">numeric_vector.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="system_8h.php">system.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="qoi__set_8h.php">qoi_set.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="keyword">namespace </span>libMesh
<a name="l00035"></a>00035 {
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="comment">//-----------------------------------------------------------------</span>
<a name="l00038"></a>00038 <span class="comment">// AdjointResidualErrorEstimator implementations</span>
<a name="l00039"></a><a class="code" href="classlibMesh_1_1AdjointResidualErrorEstimator.php#a6a0f8337eae9e8c156680441d2840c24">00039</a> <a class="code" href="classlibMesh_1_1AdjointResidualErrorEstimator.php#a6a0f8337eae9e8c156680441d2840c24">AdjointResidualErrorEstimator::AdjointResidualErrorEstimator</a> () :
<a name="l00040"></a>00040   adjoint_already_solved(false),
<a name="l00041"></a>00041   error_plot_suffix(),
<a name="l00042"></a>00042   _primal_error_estimator(new <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator.php">PatchRecoveryErrorEstimator</a>()),
<a name="l00043"></a>00043   _dual_error_estimator(new <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator.php">PatchRecoveryErrorEstimator</a>()),
<a name="l00044"></a>00044   _qoi_set(<a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a>())
<a name="l00045"></a>00045 {
<a name="l00046"></a>00046 }
<a name="l00047"></a>00047 
<a name="l00048"></a>00048 
<a name="l00049"></a>00049 
<a name="l00050"></a><a class="code" href="classlibMesh_1_1AdjointResidualErrorEstimator.php#a3be60bea58f364ffa0aed5351ce23361">00050</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1AdjointResidualErrorEstimator.php#a3be60bea58f364ffa0aed5351ce23361">AdjointResidualErrorEstimator::estimate_error</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a>&amp; _system,
<a name="l00051"></a>00051                                                     <a class="code" href="classlibMesh_1_1ErrorVector.php">ErrorVector</a>&amp; error_per_cell,
<a name="l00052"></a>00052                                                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>* solution_vector,
<a name="l00053"></a>00053                                                     <span class="keywordtype">bool</span> estimate_parent_error)
<a name="l00054"></a>00054 {
<a name="l00055"></a>00055   START_LOG(<span class="stringliteral">&quot;estimate_error()&quot;</span>, <span class="stringliteral">&quot;AdjointResidualErrorEstimator&quot;</span>);
<a name="l00056"></a>00056 
<a name="l00057"></a>00057   <span class="comment">// Start by estimating the primal problem error</span>
<a name="l00058"></a>00058   <a class="code" href="classlibMesh_1_1AdjointResidualErrorEstimator.php#a0dc159e5896539cdfbab4448ef2c6de6">_primal_error_estimator</a>-&gt;estimate_error
<a name="l00059"></a>00059     (_system, error_per_cell, solution_vector, estimate_parent_error);
<a name="l00060"></a>00060 
<a name="l00061"></a>00061   <span class="comment">// Solve the dual problem if we have to</span>
<a name="l00062"></a>00062   <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1AdjointResidualErrorEstimator.php#a6c0a22af027cd007714750c7c4216791">adjoint_already_solved</a>)
<a name="l00063"></a>00063     {
<a name="l00064"></a>00064       <span class="comment">// FIXME - we&#39;ll need to change a lot of APIs to make this trick</span>
<a name="l00065"></a>00065       <span class="comment">// work with a const System...</span>
<a name="l00066"></a>00066       <a class="code" href="classlibMesh_1_1System.php">System</a>&amp;  system = <span class="keyword">const_cast&lt;</span><a class="code" href="classlibMesh_1_1System.php">System</a>&amp;<span class="keyword">&gt;</span>(_system);
<a name="l00067"></a>00067       system.<a class="code" href="classlibMesh_1_1System.php#a6e5b90b9bd6cf63a40cc77f02671a92d">adjoint_solve</a>(<a class="code" href="classlibMesh_1_1AdjointResidualErrorEstimator.php#a4d04cafa87de4f7aa6ad7bac316a7a39">_qoi_set</a>);
<a name="l00068"></a>00068     }
<a name="l00069"></a>00069 
<a name="l00070"></a>00070   <span class="comment">// This bookkeeping should now be taken care of in subestimators</span>
<a name="l00071"></a>00071   <span class="comment">// when they see a non-default solution_vector</span>
<a name="l00072"></a>00072   <span class="comment">//</span>
<a name="l00073"></a>00073   <span class="comment">// // Swap the system solution and dual solution, so our next error</span>
<a name="l00074"></a>00074   <span class="comment">// // estimate will use the latter</span>
<a name="l00075"></a>00075   <span class="comment">// // system.solution-&gt;swap(system.get_adjoint_solution());</span>
<a name="l00076"></a>00076 
<a name="l00077"></a>00077   <span class="comment">// // Don&#39;t forget to keep the current_local_solution consistent, as</span>
<a name="l00078"></a>00078   <span class="comment">// // error estimators are likely to use that!</span>
<a name="l00079"></a>00079   <span class="comment">// // system.update();</span>
<a name="l00080"></a>00080 
<a name="l00081"></a>00081   <span class="comment">// Get a separate estimate of the dual problem error</span>
<a name="l00082"></a>00082   <a class="code" href="classlibMesh_1_1ErrorVector.php">ErrorVector</a> total_dual_error_per_cell;
<a name="l00083"></a>00083 
<a name="l00084"></a>00084   <span class="comment">// Sum and weight this estimate based on our QoISet</span>
<a name="l00085"></a>00085   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i != _system.<a class="code" href="classlibMesh_1_1System.php#a33fc90917ecd01516d3b284ad67968c6">qoi</a>.size(); ++i)
<a name="l00086"></a>00086     <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1AdjointResidualErrorEstimator.php#a4d04cafa87de4f7aa6ad7bac316a7a39">_qoi_set</a>.<a class="code" href="classlibMesh_1_1QoISet.php#adcfff89b353ad16cb93a89d7af779fc0">has_index</a>(i))
<a name="l00087"></a>00087       {
<a name="l00088"></a>00088         <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> error_weight = <a class="code" href="classlibMesh_1_1AdjointResidualErrorEstimator.php#a4d04cafa87de4f7aa6ad7bac316a7a39">_qoi_set</a>.<a class="code" href="classlibMesh_1_1QoISet.php#abfcf1c89b78ec1ff01f3b6064b910401">weight</a>(i);
<a name="l00089"></a>00089 
<a name="l00090"></a>00090         <a class="code" href="classlibMesh_1_1ErrorVector.php">ErrorVector</a> dual_error_per_cell;
<a name="l00091"></a>00091         <a class="code" href="classlibMesh_1_1AdjointResidualErrorEstimator.php#ad8e104593004e8243489c129ea12afd0">_dual_error_estimator</a>-&gt;estimate_error
<a name="l00092"></a>00092           (_system, dual_error_per_cell, &amp;(_system.<a class="code" href="classlibMesh_1_1System.php#aeaf02ff714b2d9b6aca4e8d696856529">get_adjoint_solution</a>(i)),
<a name="l00093"></a>00093            estimate_parent_error);
<a name="l00094"></a>00094 
<a name="l00095"></a>00095         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> error_size = dual_error_per_cell.size();
<a name="l00096"></a>00096         libmesh_assert(!total_dual_error_per_cell.size() ||
<a name="l00097"></a>00097                        total_dual_error_per_cell.size() == error_size);
<a name="l00098"></a>00098         total_dual_error_per_cell.resize(error_size);
<a name="l00099"></a>00099         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e = 0; e != error_size; ++e)
<a name="l00100"></a>00100           total_dual_error_per_cell[e] += 
<a name="l00101"></a>00101             error_weight * dual_error_per_cell[e];
<a name="l00102"></a>00102       }
<a name="l00103"></a>00103 
<a name="l00104"></a>00104   <span class="comment">// Do some debugging plots if requested</span>
<a name="l00105"></a>00105   <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1AdjointResidualErrorEstimator.php#a40755ebde43be4598a02b45e4f1196d4">error_plot_suffix</a>.empty())
<a name="l00106"></a>00106     {
<a name="l00107"></a>00107       std::string primal_out = <span class="stringliteral">&quot;primal_&quot;</span>;
<a name="l00108"></a>00108       std::string dual_out = <span class="stringliteral">&quot;dual_&quot;</span>;
<a name="l00109"></a>00109       primal_out += <a class="code" href="classlibMesh_1_1AdjointResidualErrorEstimator.php#a40755ebde43be4598a02b45e4f1196d4">error_plot_suffix</a>;
<a name="l00110"></a>00110       dual_out += <a class="code" href="classlibMesh_1_1AdjointResidualErrorEstimator.php#a40755ebde43be4598a02b45e4f1196d4">error_plot_suffix</a>;
<a name="l00111"></a>00111       error_per_cell.<a class="code" href="classlibMesh_1_1ErrorVector.php#af42a70293b724817dd9c282642eb354c">plot_error</a>(primal_out, _system.<a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">get_mesh</a>());
<a name="l00112"></a>00112       total_dual_error_per_cell.<a class="code" href="classlibMesh_1_1ErrorVector.php#af42a70293b724817dd9c282642eb354c">plot_error</a>(dual_out, _system.<a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">get_mesh</a>());
<a name="l00113"></a>00113     }
<a name="l00114"></a>00114 
<a name="l00115"></a>00115   <span class="comment">// More bookkeeping for subestimators to do</span>
<a name="l00116"></a>00116   <span class="comment">//</span>
<a name="l00117"></a>00117   <span class="comment">// // Swap the system solution and dual solution back to their proper</span>
<a name="l00118"></a>00118   <span class="comment">// // places</span>
<a name="l00119"></a>00119   <span class="comment">// system.solution-&gt;swap(system.get_adjoint_solution());</span>
<a name="l00120"></a>00120 
<a name="l00121"></a>00121   <span class="comment">// // Don&#39;t forget to fix the current_local_solution</span>
<a name="l00122"></a>00122   <span class="comment">// system.update();</span>
<a name="l00123"></a>00123 
<a name="l00124"></a>00124   <span class="comment">// Weight the primal error by the dual error</span>
<a name="l00125"></a>00125   <span class="comment">// FIXME: we ought to thread this</span>
<a name="l00126"></a>00126   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != error_per_cell.size(); ++i)
<a name="l00127"></a>00127     error_per_cell[i] *= total_dual_error_per_cell[i];
<a name="l00128"></a>00128 
<a name="l00129"></a>00129   STOP_LOG(<span class="stringliteral">&quot;estimate_error()&quot;</span>, <span class="stringliteral">&quot;AdjointResidualErrorEstimator&quot;</span>);
<a name="l00130"></a>00130 }
<a name="l00131"></a>00131 
<a name="l00132"></a>00132 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
