<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_eaf30c8ea092d33f79a04353c3899c3f.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_1a2b14d219bf20b3bfd3aaf502c1b987.php">numerics</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">dense_matrix.h</div>  </div>
</div>
<div class="contents">
<a href="dense__matrix_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id$</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __dense_matrix_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __dense_matrix_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &lt;algorithm&gt;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">// Local Includes</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="dense__matrix__base_8h.php">dense_matrix_base.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="keyword">namespace </span>libMesh
<a name="l00034"></a>00034 {
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="comment">// Forward Declarations</span>
<a name="l00037"></a>00037 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span>DenseVector;
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 
<a name="l00049"></a>00049 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00050"></a>00050 <span class="comment">// Dense Matrix class definition</span>
<a name="l00051"></a>00051 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00052"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php">00052</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1DenseMatrixBase.php">DenseMatrixBase</a>&lt;T&gt;
<a name="l00053"></a>00053 {
<a name="l00054"></a>00054 <span class="keyword">public</span>:
<a name="l00055"></a>00055   
<a name="l00059"></a>00059   <a class="code" href="classlibMesh_1_1DenseMatrix.php#a63066c751f8498dbbcb8ca4a00a0cf14">DenseMatrix</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a68bd665fb9252382cc9a28df4099d76a">m</a>=0,
<a name="l00060"></a>00060               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a4fb8c524109fd5dff8c98855437544ee">n</a>=0);
<a name="l00061"></a>00061   
<a name="l00065"></a>00065   <span class="comment">//DenseMatrix (const DenseMatrix&lt;T&gt;&amp; other_matrix);</span>
<a name="l00066"></a>00066   
<a name="l00070"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php#a5f192c355cfed7ae7eb0df1144b8c120">00070</a>   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#a5f192c355cfed7ae7eb0df1144b8c120">~DenseMatrix</a>() {}
<a name="l00071"></a>00071   
<a name="l00072"></a>00072 
<a name="l00076"></a>00076   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#ab3e7a4e199200d0f5875fd4a5082cb7c">zero</a>();
<a name="l00077"></a>00077 
<a name="l00081"></a>00081   T <a class="code" href="classlibMesh_1_1DenseMatrix.php#a1b6afa5e746003ebf9b2b6c5ad82230c">operator() </a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00082"></a>00082                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j) <span class="keyword">const</span>;
<a name="l00083"></a>00083 
<a name="l00087"></a>00087   T &amp; <a class="code" href="classlibMesh_1_1DenseMatrix.php#a1b6afa5e746003ebf9b2b6c5ad82230c">operator() </a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00088"></a>00088                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j);
<a name="l00089"></a>00089 
<a name="l00093"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php#a6f93c5b1066687b30850e97c03ef44fb">00093</a>   <span class="keyword">virtual</span> T <a class="code" href="classlibMesh_1_1DenseMatrix.php#a6f93c5b1066687b30850e97c03ef44fb">el</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00094"></a>00094                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> (*<span class="keyword">this</span>)(i,j); }
<a name="l00095"></a>00095 
<a name="l00099"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php#a0bbdaffed797db2696e2b67a861d0484">00099</a>   <span class="keyword">virtual</span> T &amp; <a class="code" href="classlibMesh_1_1DenseMatrix.php#a6f93c5b1066687b30850e97c03ef44fb">el</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00100"></a>00100                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j)     { <span class="keywordflow">return</span> (*<span class="keyword">this</span>)(i,j); } 
<a name="l00101"></a>00101 
<a name="l00105"></a>00105   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#a6f189109a2760176e9541bce50cd216d">left_multiply</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseMatrixBase.php">DenseMatrixBase&lt;T&gt;</a>&amp; M2);
<a name="l00106"></a>00106   
<a name="l00110"></a>00110   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#a9cb161155585b412f27e6bf8103d6d48">right_multiply</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseMatrixBase.php">DenseMatrixBase&lt;T&gt;</a>&amp; M3);
<a name="l00111"></a>00111 
<a name="l00116"></a>00116   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#a493649f63f70ca2adeaee645e26a4677">vector_mult</a>(<a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T&gt;</a>&amp; dest, <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T&gt;</a>&amp; arg) <span class="keyword">const</span>;
<a name="l00117"></a>00117   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#af626c5217464782029d068369df85ae2">vector_mult2</a>(<a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T&gt;</a>&amp; dest, <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T&gt;</a>&amp; arg) <span class="keyword">const</span>;
<a name="l00118"></a>00118   
<a name="l00123"></a>00123   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#aa524e3051fffc87a03e16791d917284a">vector_mult_add</a> (<a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T&gt;</a>&amp; dest, 
<a name="l00124"></a>00124                         <span class="keyword">const</span> T factor,
<a name="l00125"></a>00125                         <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T&gt;</a>&amp; arg) <span class="keyword">const</span>;
<a name="l00126"></a>00126 
<a name="l00130"></a>00130   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#abf62d6b34b155876279d8db1564a6e14">get_principal_submatrix</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sub_m, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sub_n, <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; dest) <span class="keyword">const</span>;
<a name="l00131"></a>00131 
<a name="l00135"></a>00135   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#abf62d6b34b155876279d8db1564a6e14">get_principal_submatrix</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sub_m, <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; dest) <span class="keyword">const</span>;
<a name="l00136"></a>00136 
<a name="l00140"></a>00140   <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; <a class="code" href="classlibMesh_1_1DenseMatrix.php#ac00a4740e8613e80c7e99b361ae014ac">operator = </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; other_matrix);
<a name="l00141"></a>00141   
<a name="l00145"></a>00145   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#aa2526a1599a6b9d9b5373c41af8bce1f">swap</a>(<a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; other_matrix);
<a name="l00146"></a>00146   
<a name="l00151"></a>00151   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#ad967ca8d40990ed5cae9944a285a320d">resize</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a68bd665fb9252382cc9a28df4099d76a">m</a>,
<a name="l00152"></a>00152               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a4fb8c524109fd5dff8c98855437544ee">n</a>);
<a name="l00153"></a>00153   
<a name="l00157"></a>00157   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#acbb89f0334849faeb3be9094d547e655">scale</a> (<span class="keyword">const</span> T factor);
<a name="l00158"></a>00158 
<a name="l00162"></a>00162   <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; <a class="code" href="classlibMesh_1_1DenseMatrix.php#aeff58723e7b264b82e893abc9759cb8c">operator *= </a>(<span class="keyword">const</span> T factor);
<a name="l00163"></a>00163 
<a name="l00167"></a>00167   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#adf1b1e8773da47d9edaed6f12c6ceb9a">add</a> (<span class="keyword">const</span> T factor,
<a name="l00168"></a>00168             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; mat);
<a name="l00169"></a>00169 
<a name="l00173"></a>00173   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#a2a338baa0d16e9b5babe83769d89af90">operator== </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a> &amp;mat) <span class="keyword">const</span>;
<a name="l00174"></a>00174 
<a name="l00178"></a>00178   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#a4d683965c1325f535b5228b49b07c465">operator!= </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a> &amp;mat) <span class="keyword">const</span>;
<a name="l00179"></a>00179 
<a name="l00183"></a>00183   <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; <a class="code" href="classlibMesh_1_1DenseMatrix.php#af17218eca4586b0891314c75741a744b">operator+= </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a> &amp;mat);
<a name="l00184"></a>00184 
<a name="l00188"></a>00188   <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; <a class="code" href="classlibMesh_1_1DenseMatrix.php#aa933e5b87272195342626e6045b401f4">operator-= </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a> &amp;mat);
<a name="l00189"></a>00189 
<a name="l00195"></a>00195   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1DenseMatrix.php#afabf81db3e54bb0fe6c82c01dc8a9e69">min</a> () <span class="keyword">const</span>;
<a name="l00196"></a>00196 
<a name="l00202"></a>00202   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1DenseMatrix.php#a76f0e840cc379a27672616bf7193b5e3">max</a> () <span class="keyword">const</span>;
<a name="l00203"></a>00203 
<a name="l00214"></a>00214   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1DenseMatrix.php#ac42e257df76ea1522f0e191d21d78e7d">l1_norm</a> () <span class="keyword">const</span>;
<a name="l00215"></a>00215 
<a name="l00227"></a>00227   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1DenseMatrix.php#add745b39468415cd9d99e0acebb5237a">linfty_norm</a> () <span class="keyword">const</span>;
<a name="l00228"></a>00228 
<a name="l00232"></a>00232   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#aea84b08f2ffc1a36a5a87969287ac865">left_multiply_transpose</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; A);
<a name="l00233"></a>00233   
<a name="l00234"></a>00234 
<a name="l00238"></a>00238   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#a2936a147980a3643fdb637ab78c251c9">right_multiply_transpose</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; A);
<a name="l00239"></a>00239   
<a name="l00243"></a>00243   T <a class="code" href="classlibMesh_1_1DenseMatrix.php#a8f1a04ca0780c6327443862cae23f1d3">transpose</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00244"></a>00244                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j) <span class="keyword">const</span>;
<a name="l00245"></a>00245 
<a name="l00249"></a>00249   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#afceb0c13e5a6f9cf277a7994d541eee8">get_transpose</a>(<a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; dest) <span class="keyword">const</span>;
<a name="l00250"></a>00250   <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a> <a class="code" href="classlibMesh_1_1DenseMatrix.php#afceb0c13e5a6f9cf277a7994d541eee8">get_transpose</a> () <span class="keyword">const</span>;
<a name="l00251"></a>00251  
<a name="l00257"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php#a676d389b9cb9410e418026ec2c1a54c1">00257</a>   std::vector&lt;T&gt;&amp; <a class="code" href="classlibMesh_1_1DenseMatrix.php#a676d389b9cb9410e418026ec2c1a54c1">get_values</a>() { <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#a850c40fcb0f9d1f4994bd9ac1d094284">_val</a>; }
<a name="l00258"></a>00258 
<a name="l00262"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php#af75d60ad7d9581a015ddcd85b52209e3">00262</a>   <span class="keyword">const</span> std::vector&lt;T&gt;&amp; <a class="code" href="classlibMesh_1_1DenseMatrix.php#af75d60ad7d9581a015ddcd85b52209e3">get_values</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#a850c40fcb0f9d1f4994bd9ac1d094284">_val</a>; }
<a name="l00263"></a>00263 
<a name="l00270"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php#ae2a11c928f4640150f9df555b07ac35e">00270</a>   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#ae2a11c928f4640150f9df555b07ac35e">condense</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00271"></a>00271                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00272"></a>00272                 <span class="keyword">const</span> T val,
<a name="l00273"></a>00273                 <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T&gt;</a>&amp; rhs)
<a name="l00274"></a>00274   { <a class="code" href="classlibMesh_1_1DenseMatrix.php#ae2a11c928f4640150f9df555b07ac35e">DenseMatrixBase&lt;T&gt;::condense</a> (i, j, val, rhs); }
<a name="l00275"></a>00275 
<a name="l00281"></a>00281   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#a878b9bf0a49000c70acecd55fdcf8d74">lu_solve</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T&gt;</a>&amp; b,
<a name="l00282"></a>00282                  <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T&gt;</a>&amp; x);
<a name="l00283"></a>00283 
<a name="l00284"></a>00284 
<a name="l00285"></a>00285 
<a name="l00295"></a>00295   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00296"></a>00296   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#a6a40309a38c842ca98f3ff48bbbb265c">cholesky_solve</a>(<a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T2&gt;</a>&amp; b,
<a name="l00297"></a>00297                       <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T2&gt;</a>&amp; x);
<a name="l00298"></a>00298 
<a name="l00299"></a>00299   
<a name="l00305"></a>00305   T <a class="code" href="classlibMesh_1_1DenseMatrix.php#ab4b217cc39f4135073b5dc30b3d157e2">det</a>();
<a name="l00306"></a>00306 
<a name="l00315"></a>00315   <span class="comment">// void inverse();</span>
<a name="l00316"></a>00316 
<a name="l00322"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php#a847c530f0b4909b248aff4e6258d5b8d">00322</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#a847c530f0b4909b248aff4e6258d5b8d">use_blas_lapack</a>;
<a name="l00323"></a>00323   
<a name="l00324"></a>00324 <span class="keyword">private</span>:
<a name="l00325"></a>00325 
<a name="l00329"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php#a850c40fcb0f9d1f4994bd9ac1d094284">00329</a>   std::vector&lt;T&gt; <a class="code" href="classlibMesh_1_1DenseMatrix.php#a850c40fcb0f9d1f4994bd9ac1d094284">_val</a>;
<a name="l00330"></a>00330 
<a name="l00336"></a>00336   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#a1455b27da806fa1dbc733eab6d1cbe94">_lu_decompose</a> ();
<a name="l00337"></a>00337   
<a name="l00343"></a>00343   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#a89a35b300c65ec74fe85b3d2504508ba">_lu_back_substitute</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T&gt;</a>&amp; b,
<a name="l00344"></a>00344                             <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T&gt;</a>&amp; x) <span class="keyword">const</span>;
<a name="l00345"></a>00345   
<a name="l00352"></a>00352   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#a0d41126a4cadcf798ea3009e8dd663b2">_cholesky_decompose</a>();
<a name="l00353"></a>00353 
<a name="l00360"></a>00360   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00361"></a>00361   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#ae96215c54161e7f671a42737fc0ff873">_cholesky_back_substitute</a>(<a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T2&gt;</a>&amp; b,
<a name="l00362"></a>00362                                  <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T2&gt;</a>&amp; x) <span class="keyword">const</span>;
<a name="l00363"></a>00363 
<a name="l00371"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php#af13624c3650ea77e588478fb683bf8d9ade1cc985e6ce6f751e958231d7f3ed3e">00371</a>   <span class="keyword">enum</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#af13624c3650ea77e588478fb683bf8d9">DecompositionType</a> {<a class="code" href="classlibMesh_1_1DenseMatrix.php#af13624c3650ea77e588478fb683bf8d9a7686133778a883fd072c35d75d2c0cd7">LU</a>=0, <a class="code" href="classlibMesh_1_1DenseMatrix.php#af13624c3650ea77e588478fb683bf8d9ae678cf68eb00a1043eda7421ba358539">CHOLESKY</a>=1, <a class="code" href="classlibMesh_1_1DenseMatrix.php#af13624c3650ea77e588478fb683bf8d9a8760f5d6eac01ddcc3d2a10424114aaf">LU_BLAS_LAPACK</a>, <a class="code" href="classlibMesh_1_1DenseMatrix.php#af13624c3650ea77e588478fb683bf8d9ade1cc985e6ce6f751e958231d7f3ed3e">NONE</a>};
<a name="l00372"></a>00372 
<a name="l00377"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php#ac1da39d620cd6248899c1bf19f421083">00377</a>   <a class="code" href="classlibMesh_1_1DenseMatrix.php#af13624c3650ea77e588478fb683bf8d9">DecompositionType</a> <a class="code" href="classlibMesh_1_1DenseMatrix.php#ac1da39d620cd6248899c1bf19f421083">_decomposition_type</a>;
<a name="l00378"></a>00378 
<a name="l00383"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php#afa268fd78e9c7110ccb20872bd987653">00383</a>   <span class="keyword">enum</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#afa268fd78e9c7110ccb20872bd987653">_BLAS_Multiply_Flag</a> {
<a name="l00384"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php#afa268fd78e9c7110ccb20872bd987653afe4ed4f088f6c5dac60def9c025116e0">00384</a>     <a class="code" href="classlibMesh_1_1DenseMatrix.php#afa268fd78e9c7110ccb20872bd987653afe4ed4f088f6c5dac60def9c025116e0">LEFT_MULTIPLY</a> = 0,
<a name="l00385"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php#afa268fd78e9c7110ccb20872bd987653a02fea2659e88a03205dd1dd9d87a026c">00385</a>     <a class="code" href="classlibMesh_1_1DenseMatrix.php#afa268fd78e9c7110ccb20872bd987653a02fea2659e88a03205dd1dd9d87a026c">RIGHT_MULTIPLY</a>,
<a name="l00386"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php#afa268fd78e9c7110ccb20872bd987653a827aed689cf5dbe31c97974f3d7af975">00386</a>     <a class="code" href="classlibMesh_1_1DenseMatrix.php#afa268fd78e9c7110ccb20872bd987653a827aed689cf5dbe31c97974f3d7af975">LEFT_MULTIPLY_TRANSPOSE</a>,
<a name="l00387"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php#afa268fd78e9c7110ccb20872bd987653af63423255b4fff1e762ddb06067438d1">00387</a>     <a class="code" href="classlibMesh_1_1DenseMatrix.php#afa268fd78e9c7110ccb20872bd987653af63423255b4fff1e762ddb06067438d1">RIGHT_MULTIPLY_TRANSPOSE</a>
<a name="l00388"></a>00388   };
<a name="l00389"></a>00389   
<a name="l00397"></a>00397   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#af78dfd54eedcd8cb107a913b724395c2">_multiply_blas</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseMatrixBase.php">DenseMatrixBase&lt;T&gt;</a>&amp; other,
<a name="l00398"></a>00398                       <a class="code" href="classlibMesh_1_1DenseMatrix.php#afa268fd78e9c7110ccb20872bd987653">_BLAS_Multiply_Flag</a> flag);
<a name="l00399"></a>00399 
<a name="l00409"></a>00409   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#a752c27f2644b00a8c6b779aecd644222">_lu_decompose_lapack</a>();
<a name="l00410"></a>00410 
<a name="l00416"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php#af53ee84c9674f37b8ad1d885ca5f291c">00416</a>   std::vector&lt;int&gt; <a class="code" href="classlibMesh_1_1DenseMatrix.php#af53ee84c9674f37b8ad1d885ca5f291c">_pivots</a>;
<a name="l00417"></a>00417 
<a name="l00427"></a>00427   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#ac70a007254352725bae26a2cf41c5ef5">_lu_back_substitute_lapack</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T&gt;</a>&amp; b,
<a name="l00428"></a>00428                                    <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T&gt;</a>&amp; x);
<a name="l00429"></a>00429 
<a name="l00440"></a>00440   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#a266e533240f0c8adc83e4def52644947">_matvec_blas</a>(T alpha, T beta,
<a name="l00441"></a>00441                     <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T&gt;</a>&amp; dest,
<a name="l00442"></a>00442                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T&gt;</a>&amp; arg) <span class="keyword">const</span>;
<a name="l00443"></a>00443 };
<a name="l00444"></a>00444 
<a name="l00445"></a>00445 
<a name="l00446"></a>00446 
<a name="l00447"></a>00447 
<a name="l00448"></a>00448 
<a name="l00449"></a>00449 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00453"></a><a class="code" href="namespacelibMesh_1_1DenseMatrices.php">00453</a> <span class="comment"></span><span class="keyword">namespace </span>DenseMatrices
<a name="l00454"></a>00454 {
<a name="l00455"></a>00455 
<a name="l00460"></a><a class="code" href="namespacelibMesh_1_1DenseMatrices.php#aada1321106662747e018481072603e2d">00460</a>   <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Real&gt;</a> <a class="code" href="namespacelibMesh_1_1DenseMatrices.php#aada1321106662747e018481072603e2d">RealDenseMatrix</a>;
<a name="l00461"></a>00461 
<a name="l00471"></a><a class="code" href="namespacelibMesh_1_1DenseMatrices.php#a3515ea9802d906d8a42251845e8f7239">00471</a>   <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Complex&gt;</a> <a class="code" href="namespacelibMesh_1_1DenseMatrices.php#a3515ea9802d906d8a42251845e8f7239">ComplexDenseMatrix</a>;  
<a name="l00472"></a>00472 
<a name="l00473"></a>00473 }
<a name="l00474"></a>00474 
<a name="l00475"></a>00475 
<a name="l00476"></a>00476 
<a name="l00477"></a>00477 <span class="keyword">using namespace </span>DenseMatrices;
<a name="l00478"></a>00478 
<a name="l00479"></a>00479 
<a name="l00480"></a>00480 
<a name="l00481"></a>00481 
<a name="l00482"></a>00482 
<a name="l00483"></a>00483 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00484"></a>00484 <span class="comment">// Dense Matrix member functions</span>
<a name="l00485"></a>00485 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00486"></a>00486 <span class="keyword">inline</span>
<a name="l00487"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php#a63066c751f8498dbbcb8ca4a00a0cf14">00487</a> <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;::DenseMatrix</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m,
<a name="l00488"></a>00488                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n)
<a name="l00489"></a>00489   : <a class="code" href="classlibMesh_1_1DenseMatrixBase.php">DenseMatrixBase</a>&lt;T&gt;(m,n),
<a name="l00490"></a>00490 #if defined(LIBMESH_HAVE_PETSC) &amp;&amp; defined(LIBMESH_USE_REAL_NUMBERS)
<a name="l00491"></a>00491     use_blas_lapack(true),
<a name="l00492"></a>00492 #else
<a name="l00493"></a>00493     use_blas_lapack(false),
<a name="l00494"></a>00494 #endif
<a name="l00495"></a>00495     _decomposition_type(NONE)
<a name="l00496"></a>00496 {
<a name="l00497"></a>00497   this-&gt;<a class="code" href="classlibMesh_1_1DenseMatrix.php#ad967ca8d40990ed5cae9944a285a320d">resize</a>(m,n);
<a name="l00498"></a>00498 }
<a name="l00499"></a>00499 
<a name="l00500"></a>00500 
<a name="l00501"></a>00501 
<a name="l00502"></a>00502 <span class="comment">// FIXME[JWP]: This copy ctor has not been maintained along with</span>
<a name="l00503"></a>00503 <span class="comment">// the rest of the class...</span>
<a name="l00504"></a>00504 <span class="comment">// Can we just use the compiler-generated copy ctor here?</span>
<a name="l00505"></a>00505 <span class="comment">// template&lt;typename T&gt;</span>
<a name="l00506"></a>00506 <span class="comment">// inline</span>
<a name="l00507"></a>00507 <span class="comment">// DenseMatrix&lt;T&gt;::DenseMatrix (const DenseMatrix&lt;T&gt;&amp; other_matrix)</span>
<a name="l00508"></a>00508 <span class="comment">//   : DenseMatrixBase&lt;T&gt;(other_matrix._m, other_matrix._n)</span>
<a name="l00509"></a>00509 <span class="comment">// {</span>
<a name="l00510"></a>00510 <span class="comment">//   _val = other_matrix._val;</span>
<a name="l00511"></a>00511 <span class="comment">// }</span>
<a name="l00512"></a>00512 
<a name="l00513"></a>00513 
<a name="l00514"></a>00514 
<a name="l00515"></a>00515 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00516"></a>00516 <span class="keyword">inline</span>
<a name="l00517"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php#aa2526a1599a6b9d9b5373c41af8bce1f">00517</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#aa2526a1599a6b9d9b5373c41af8bce1f">DenseMatrix&lt;T&gt;::swap</a>(<a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; other_matrix)
<a name="l00518"></a>00518 {
<a name="l00519"></a>00519   std::swap(this-&gt;_m, other_matrix.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#aa7400426b259d1c630a4b26221205e76">_m</a>);
<a name="l00520"></a>00520   std::swap(this-&gt;_n, other_matrix.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a65ad8af64975eb0ecfc621a75743a869">_n</a>);
<a name="l00521"></a>00521   _val.swap(other_matrix.<a class="code" href="classlibMesh_1_1DenseMatrix.php#a850c40fcb0f9d1f4994bd9ac1d094284">_val</a>);
<a name="l00522"></a>00522   <a class="code" href="classlibMesh_1_1DenseMatrix.php#af13624c3650ea77e588478fb683bf8d9">DecompositionType</a> _temp = _decomposition_type;
<a name="l00523"></a>00523   _decomposition_type = other_matrix.<a class="code" href="classlibMesh_1_1DenseMatrix.php#ac1da39d620cd6248899c1bf19f421083">_decomposition_type</a>;
<a name="l00524"></a>00524   other_matrix.<a class="code" href="classlibMesh_1_1DenseMatrix.php#ac1da39d620cd6248899c1bf19f421083">_decomposition_type</a> = _temp;
<a name="l00525"></a>00525 }
<a name="l00526"></a>00526 
<a name="l00527"></a>00527 
<a name="l00528"></a>00528   
<a name="l00529"></a>00529 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00530"></a>00530 <span class="keyword">inline</span>
<a name="l00531"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php#ad967ca8d40990ed5cae9944a285a320d">00531</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#ad967ca8d40990ed5cae9944a285a320d">DenseMatrix&lt;T&gt;::resize</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m,
<a name="l00532"></a>00532                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n)
<a name="l00533"></a>00533 {
<a name="l00534"></a>00534   _val.resize(m*n);
<a name="l00535"></a>00535 
<a name="l00536"></a>00536   this-&gt;_m = m;
<a name="l00537"></a>00537   this-&gt;_n = n;
<a name="l00538"></a>00538 
<a name="l00539"></a>00539   _decomposition_type = NONE;
<a name="l00540"></a>00540   this-&gt;<a class="code" href="namespacelibMesh.php#a7384a2e49f01ab6e656cae298da85146">zero</a>();
<a name="l00541"></a>00541 }
<a name="l00542"></a>00542 
<a name="l00543"></a>00543 
<a name="l00544"></a>00544 
<a name="l00545"></a>00545 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00546"></a>00546 <span class="keyword">inline</span>
<a name="l00547"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php#ab3e7a4e199200d0f5875fd4a5082cb7c">00547</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#ab3e7a4e199200d0f5875fd4a5082cb7c">DenseMatrix&lt;T&gt;::zero</a>()
<a name="l00548"></a>00548 {
<a name="l00549"></a>00549   _decomposition_type = NONE;
<a name="l00550"></a>00550 
<a name="l00551"></a>00551   std::fill (_val.begin(), _val.end(), 0.);
<a name="l00552"></a>00552 }
<a name="l00553"></a>00553 
<a name="l00554"></a>00554 
<a name="l00555"></a>00555 
<a name="l00556"></a>00556 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00557"></a>00557 <span class="keyword">inline</span>
<a name="l00558"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php#ac00a4740e8613e80c7e99b361ae014ac">00558</a> <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; <a class="code" href="classlibMesh_1_1DenseMatrix.php#ac00a4740e8613e80c7e99b361ae014ac">DenseMatrix&lt;T&gt;::operator = </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; other_matrix)
<a name="l00559"></a>00559 {
<a name="l00560"></a>00560   this-&gt;_m = other_matrix.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#aa7400426b259d1c630a4b26221205e76">_m</a>;
<a name="l00561"></a>00561   this-&gt;_n = other_matrix.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a65ad8af64975eb0ecfc621a75743a869">_n</a>;
<a name="l00562"></a>00562 
<a name="l00563"></a>00563   _val                = other_matrix.<a class="code" href="classlibMesh_1_1DenseMatrix.php#a850c40fcb0f9d1f4994bd9ac1d094284">_val</a>;
<a name="l00564"></a>00564   _decomposition_type = other_matrix.<a class="code" href="classlibMesh_1_1DenseMatrix.php#ac1da39d620cd6248899c1bf19f421083">_decomposition_type</a>;
<a name="l00565"></a>00565 
<a name="l00566"></a>00566   <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00567"></a>00567 }
<a name="l00568"></a>00568 
<a name="l00569"></a>00569 
<a name="l00570"></a>00570 
<a name="l00571"></a>00571 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00572"></a>00572 <span class="keyword">inline</span>
<a name="l00573"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php#a1b6afa5e746003ebf9b2b6c5ad82230c">00573</a> T <a class="code" href="classlibMesh_1_1DenseMatrix.php#a1b6afa5e746003ebf9b2b6c5ad82230c">DenseMatrix&lt;T&gt;::operator () </a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00574"></a>00574                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j)<span class="keyword"> const</span>
<a name="l00575"></a>00575 <span class="keyword"></span>{
<a name="l00576"></a>00576   libmesh_assert (i*j&lt;_val.size());
<a name="l00577"></a>00577   libmesh_assert (i &lt; this-&gt;_m);
<a name="l00578"></a>00578   libmesh_assert (j &lt; this-&gt;_n);
<a name="l00579"></a>00579   
<a name="l00580"></a>00580   
<a name="l00581"></a>00581   <span class="comment">//  return _val[(i) + (this-&gt;_m)*(j)]; // col-major</span>
<a name="l00582"></a>00582   <span class="keywordflow">return</span> _val[(i)*(this-&gt;_n) + (j)]; <span class="comment">// row-major</span>
<a name="l00583"></a>00583 }
<a name="l00584"></a>00584 
<a name="l00585"></a>00585 
<a name="l00586"></a>00586 
<a name="l00587"></a>00587 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00588"></a>00588 <span class="keyword">inline</span>
<a name="l00589"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php#a1d171121a9643f970396d55f9f883e6e">00589</a> T &amp; <a class="code" href="classlibMesh_1_1DenseMatrix.php#a1b6afa5e746003ebf9b2b6c5ad82230c">DenseMatrix&lt;T&gt;::operator () </a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00590"></a>00590                                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j)
<a name="l00591"></a>00591 {
<a name="l00592"></a>00592   libmesh_assert (i*j&lt;_val.size());
<a name="l00593"></a>00593   libmesh_assert (i &lt; this-&gt;_m);
<a name="l00594"></a>00594   libmesh_assert (j &lt; this-&gt;_n);
<a name="l00595"></a>00595   
<a name="l00596"></a>00596   <span class="comment">//return _val[(i) + (this-&gt;_m)*(j)]; // col-major</span>
<a name="l00597"></a>00597   <span class="keywordflow">return</span> _val[(i)*(this-&gt;_n) + (j)]; <span class="comment">// row-major</span>
<a name="l00598"></a>00598 }
<a name="l00599"></a>00599 
<a name="l00600"></a>00600 
<a name="l00601"></a>00601      
<a name="l00602"></a>00602 
<a name="l00603"></a>00603 
<a name="l00604"></a>00604 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00605"></a>00605 <span class="keyword">inline</span>
<a name="l00606"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php#acbb89f0334849faeb3be9094d547e655">00606</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#acbb89f0334849faeb3be9094d547e655">DenseMatrix&lt;T&gt;::scale</a> (<span class="keyword">const</span> T factor)
<a name="l00607"></a>00607 {
<a name="l00608"></a>00608   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;_val.size(); i++)
<a name="l00609"></a>00609     _val[i] *= factor;
<a name="l00610"></a>00610 }
<a name="l00611"></a>00611 
<a name="l00612"></a>00612 
<a name="l00613"></a>00613 
<a name="l00614"></a>00614 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00615"></a>00615 <span class="keyword">inline</span>
<a name="l00616"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php#aeff58723e7b264b82e893abc9759cb8c">00616</a> <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; <a class="code" href="classlibMesh_1_1DenseMatrix.php#aeff58723e7b264b82e893abc9759cb8c">DenseMatrix&lt;T&gt;::operator *= </a>(<span class="keyword">const</span> T factor)
<a name="l00617"></a>00617 {
<a name="l00618"></a>00618   this-&gt;<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Modification.php#a48c03ebd8ce97c6c8aef8e2a05a94a16">scale</a>(factor);
<a name="l00619"></a>00619   <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00620"></a>00620 }
<a name="l00621"></a>00621 
<a name="l00622"></a>00622 
<a name="l00623"></a>00623 
<a name="l00624"></a>00624 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00625"></a>00625 <span class="keyword">inline</span>
<a name="l00626"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php#adf1b1e8773da47d9edaed6f12c6ceb9a">00626</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#adf1b1e8773da47d9edaed6f12c6ceb9a">DenseMatrix&lt;T&gt;::add</a> (<span class="keyword">const</span> T factor, <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; mat)
<a name="l00627"></a>00627 {
<a name="l00628"></a>00628   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;_val.size(); i++)
<a name="l00629"></a>00629     _val[i] += factor * mat.<a class="code" href="classlibMesh_1_1DenseMatrix.php#a850c40fcb0f9d1f4994bd9ac1d094284">_val</a>[i];
<a name="l00630"></a>00630 }
<a name="l00631"></a>00631 
<a name="l00632"></a>00632 
<a name="l00633"></a>00633 
<a name="l00634"></a>00634 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00635"></a>00635 <span class="keyword">inline</span>
<a name="l00636"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php#a2a338baa0d16e9b5babe83769d89af90">00636</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#a2a338baa0d16e9b5babe83769d89af90">DenseMatrix&lt;T&gt;::operator == </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a> &amp;mat)<span class="keyword"> const</span>
<a name="l00637"></a>00637 <span class="keyword"></span>{
<a name="l00638"></a>00638   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;_val.size(); i++)
<a name="l00639"></a>00639     <span class="keywordflow">if</span> (_val[i] != mat.<a class="code" href="classlibMesh_1_1DenseMatrix.php#a850c40fcb0f9d1f4994bd9ac1d094284">_val</a>[i])
<a name="l00640"></a>00640       <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00641"></a>00641 
<a name="l00642"></a>00642   <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00643"></a>00643 }
<a name="l00644"></a>00644 
<a name="l00645"></a>00645 
<a name="l00646"></a>00646 
<a name="l00647"></a>00647 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00648"></a>00648 <span class="keyword">inline</span>
<a name="l00649"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php#a4d683965c1325f535b5228b49b07c465">00649</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#a4d683965c1325f535b5228b49b07c465">DenseMatrix&lt;T&gt;::operator != </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a> &amp;mat)<span class="keyword"> const</span>
<a name="l00650"></a>00650 <span class="keyword"></span>{
<a name="l00651"></a>00651   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;_val.size(); i++)
<a name="l00652"></a>00652     <span class="keywordflow">if</span> (_val[i] != mat.<a class="code" href="classlibMesh_1_1DenseMatrix.php#a850c40fcb0f9d1f4994bd9ac1d094284">_val</a>[i])
<a name="l00653"></a>00653       <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00654"></a>00654 
<a name="l00655"></a>00655   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00656"></a>00656 }
<a name="l00657"></a>00657 
<a name="l00658"></a>00658 
<a name="l00659"></a>00659 
<a name="l00660"></a>00660 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00661"></a>00661 <span class="keyword">inline</span>
<a name="l00662"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php#af17218eca4586b0891314c75741a744b">00662</a> <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; <a class="code" href="classlibMesh_1_1DenseMatrix.php#af17218eca4586b0891314c75741a744b">DenseMatrix&lt;T&gt;::operator += </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a> &amp;mat)
<a name="l00663"></a>00663 {
<a name="l00664"></a>00664   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;_val.size(); i++)
<a name="l00665"></a>00665     _val[i] += mat.<a class="code" href="classlibMesh_1_1DenseMatrix.php#a850c40fcb0f9d1f4994bd9ac1d094284">_val</a>[i];
<a name="l00666"></a>00666 
<a name="l00667"></a>00667   <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00668"></a>00668 }
<a name="l00669"></a>00669 
<a name="l00670"></a>00670 
<a name="l00671"></a>00671 
<a name="l00672"></a>00672 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00673"></a>00673 <span class="keyword">inline</span>
<a name="l00674"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php#aa933e5b87272195342626e6045b401f4">00674</a> <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; <a class="code" href="classlibMesh_1_1DenseMatrix.php#aa933e5b87272195342626e6045b401f4">DenseMatrix&lt;T&gt;::operator -= </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a> &amp;mat)
<a name="l00675"></a>00675 {
<a name="l00676"></a>00676   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;_val.size(); i++)
<a name="l00677"></a>00677     _val[i] -= mat.<a class="code" href="classlibMesh_1_1DenseMatrix.php#a850c40fcb0f9d1f4994bd9ac1d094284">_val</a>[i];
<a name="l00678"></a>00678 
<a name="l00679"></a>00679   <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00680"></a>00680 }
<a name="l00681"></a>00681 
<a name="l00682"></a>00682 
<a name="l00683"></a>00683 
<a name="l00684"></a>00684 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00685"></a>00685 <span class="keyword">inline</span>
<a name="l00686"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php#afabf81db3e54bb0fe6c82c01dc8a9e69">00686</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1DenseMatrix.php#afabf81db3e54bb0fe6c82c01dc8a9e69">DenseMatrix&lt;T&gt;::min</a> ()<span class="keyword"> const</span>
<a name="l00687"></a>00687 <span class="keyword"></span>{
<a name="l00688"></a>00688   libmesh_assert (this-&gt;_m);
<a name="l00689"></a>00689   libmesh_assert (this-&gt;_n);
<a name="l00690"></a>00690   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> my_min = <a class="code" href="namespacelibMesh.php#aea33cac176f18504c5c4078407aadbb7">libmesh_real</a>((*<span class="keyword">this</span>)(0,0));
<a name="l00691"></a>00691 
<a name="l00692"></a>00692   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i!=this-&gt;_m; i++)
<a name="l00693"></a>00693     {
<a name="l00694"></a>00694       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j!=this-&gt;_n; j++)
<a name="l00695"></a>00695         {
<a name="l00696"></a>00696           <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> current = <a class="code" href="namespacelibMesh.php#aea33cac176f18504c5c4078407aadbb7">libmesh_real</a>((*<span class="keyword">this</span>)(i,j));
<a name="l00697"></a>00697           my_min = (my_min &lt; current? my_min : current);
<a name="l00698"></a>00698         }
<a name="l00699"></a>00699     }
<a name="l00700"></a>00700   <span class="keywordflow">return</span> my_min;
<a name="l00701"></a>00701 }
<a name="l00702"></a>00702 
<a name="l00703"></a>00703 
<a name="l00704"></a>00704 
<a name="l00705"></a>00705 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00706"></a>00706 <span class="keyword">inline</span>
<a name="l00707"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php#a76f0e840cc379a27672616bf7193b5e3">00707</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1DenseMatrix.php#a76f0e840cc379a27672616bf7193b5e3">DenseMatrix&lt;T&gt;::max</a> ()<span class="keyword"> const</span>
<a name="l00708"></a>00708 <span class="keyword"></span>{
<a name="l00709"></a>00709   libmesh_assert (this-&gt;_m);
<a name="l00710"></a>00710   libmesh_assert (this-&gt;_n);
<a name="l00711"></a>00711   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> my_max = <a class="code" href="namespacelibMesh.php#aea33cac176f18504c5c4078407aadbb7">libmesh_real</a>((*<span class="keyword">this</span>)(0,0));
<a name="l00712"></a>00712 
<a name="l00713"></a>00713   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i!=this-&gt;_m; i++)
<a name="l00714"></a>00714     {
<a name="l00715"></a>00715       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j!=this-&gt;_n; j++)
<a name="l00716"></a>00716         {
<a name="l00717"></a>00717           <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> current = <a class="code" href="namespacelibMesh.php#aea33cac176f18504c5c4078407aadbb7">libmesh_real</a>((*<span class="keyword">this</span>)(i,j));
<a name="l00718"></a>00718           my_max = (my_max &gt; current? my_max : current);
<a name="l00719"></a>00719         }
<a name="l00720"></a>00720     }
<a name="l00721"></a>00721   <span class="keywordflow">return</span> my_max;
<a name="l00722"></a>00722 }
<a name="l00723"></a>00723 
<a name="l00724"></a>00724 
<a name="l00725"></a>00725 
<a name="l00726"></a>00726 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00727"></a>00727 <span class="keyword">inline</span>
<a name="l00728"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php#ac42e257df76ea1522f0e191d21d78e7d">00728</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1DenseMatrix.php#ac42e257df76ea1522f0e191d21d78e7d">DenseMatrix&lt;T&gt;::l1_norm</a> ()<span class="keyword"> const</span>
<a name="l00729"></a>00729 <span class="keyword"></span>{
<a name="l00730"></a>00730   libmesh_assert (this-&gt;_m);
<a name="l00731"></a>00731   libmesh_assert (this-&gt;_n);
<a name="l00732"></a>00732 
<a name="l00733"></a>00733   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> columnsum = 0.;
<a name="l00734"></a>00734   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i!=this-&gt;_m; i++)
<a name="l00735"></a>00735     {
<a name="l00736"></a>00736       columnsum += std::abs((*<span class="keyword">this</span>)(i,0));
<a name="l00737"></a>00737     }
<a name="l00738"></a>00738   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> my_max = columnsum;
<a name="l00739"></a>00739   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=1; j!=this-&gt;_n; j++)
<a name="l00740"></a>00740     {
<a name="l00741"></a>00741       columnsum = 0.;
<a name="l00742"></a>00742       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i!=this-&gt;_m; i++)
<a name="l00743"></a>00743         {
<a name="l00744"></a>00744           columnsum += std::abs((*<span class="keyword">this</span>)(i,j));
<a name="l00745"></a>00745         }
<a name="l00746"></a>00746       my_max = (my_max &gt; columnsum? my_max : columnsum);
<a name="l00747"></a>00747     }
<a name="l00748"></a>00748   <span class="keywordflow">return</span> my_max;
<a name="l00749"></a>00749 }
<a name="l00750"></a>00750 
<a name="l00751"></a>00751 
<a name="l00752"></a>00752 
<a name="l00753"></a>00753 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00754"></a>00754 <span class="keyword">inline</span>
<a name="l00755"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php#add745b39468415cd9d99e0acebb5237a">00755</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1DenseMatrix.php#add745b39468415cd9d99e0acebb5237a">DenseMatrix&lt;T&gt;::linfty_norm</a> ()<span class="keyword"> const</span>
<a name="l00756"></a>00756 <span class="keyword"></span>{
<a name="l00757"></a>00757   libmesh_assert (this-&gt;_m);
<a name="l00758"></a>00758   libmesh_assert (this-&gt;_n);
<a name="l00759"></a>00759 
<a name="l00760"></a>00760   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> rowsum = 0.;
<a name="l00761"></a>00761   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j!=this-&gt;_n; j++)
<a name="l00762"></a>00762     {
<a name="l00763"></a>00763       rowsum += std::abs((*<span class="keyword">this</span>)(0,j));
<a name="l00764"></a>00764     }
<a name="l00765"></a>00765   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> my_max = rowsum;
<a name="l00766"></a>00766   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=1; i!=this-&gt;_m; i++)
<a name="l00767"></a>00767     {
<a name="l00768"></a>00768       rowsum = 0.;
<a name="l00769"></a>00769       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j!=this-&gt;_n; j++)
<a name="l00770"></a>00770         {
<a name="l00771"></a>00771           rowsum += std::abs((*<span class="keyword">this</span>)(i,j));
<a name="l00772"></a>00772         }
<a name="l00773"></a>00773       my_max = (my_max &gt; rowsum? my_max : rowsum);
<a name="l00774"></a>00774     }
<a name="l00775"></a>00775   <span class="keywordflow">return</span> my_max;
<a name="l00776"></a>00776 }
<a name="l00777"></a>00777 
<a name="l00778"></a>00778 
<a name="l00779"></a>00779 
<a name="l00780"></a>00780 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00781"></a>00781 <span class="keyword">inline</span>
<a name="l00782"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php#a8f1a04ca0780c6327443862cae23f1d3">00782</a> T <a class="code" href="classlibMesh_1_1DenseMatrix.php#a8f1a04ca0780c6327443862cae23f1d3">DenseMatrix&lt;T&gt;::transpose</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00783"></a>00783                              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j)<span class="keyword"> const</span>
<a name="l00784"></a>00784 <span class="keyword"></span>{
<a name="l00785"></a>00785   <span class="comment">// Implement in terms of operator()</span>
<a name="l00786"></a>00786   <span class="keywordflow">return</span> (*<span class="keyword">this</span>)(j,i);
<a name="l00787"></a>00787 }
<a name="l00788"></a>00788 
<a name="l00789"></a>00789 
<a name="l00790"></a>00790 
<a name="l00791"></a>00791 
<a name="l00792"></a>00792 
<a name="l00793"></a>00793 <span class="comment">// template&lt;typename T&gt;</span>
<a name="l00794"></a>00794 <span class="comment">// inline</span>
<a name="l00795"></a>00795 <span class="comment">// void DenseMatrix&lt;T&gt;::condense(const unsigned int iv,</span>
<a name="l00796"></a>00796 <span class="comment">//                            const unsigned int jv,</span>
<a name="l00797"></a>00797 <span class="comment">//                            const T val,</span>
<a name="l00798"></a>00798 <span class="comment">//                            DenseVector&lt;T&gt;&amp; rhs)</span>
<a name="l00799"></a>00799 <span class="comment">// {</span>
<a name="l00800"></a>00800 <span class="comment">//   libmesh_assert (this-&gt;_m == rhs.size());</span>
<a name="l00801"></a>00801 <span class="comment">//   libmesh_assert (iv == jv);</span>
<a name="l00802"></a>00802 
<a name="l00803"></a>00803 
<a name="l00804"></a>00804 <span class="comment">//   // move the known value into the RHS</span>
<a name="l00805"></a>00805 <span class="comment">//   // and zero the column</span>
<a name="l00806"></a>00806 <span class="comment">//   for (unsigned int i=0; i&lt;this-&gt;m(); i++)</span>
<a name="l00807"></a>00807 <span class="comment">//     {</span>
<a name="l00808"></a>00808 <span class="comment">//       rhs(i) -= ((*this)(i,jv))*val;</span>
<a name="l00809"></a>00809 <span class="comment">//       (*this)(i,jv) = 0.;</span>
<a name="l00810"></a>00810 <span class="comment">//     }</span>
<a name="l00811"></a>00811 
<a name="l00812"></a>00812 <span class="comment">//   // zero the row</span>
<a name="l00813"></a>00813 <span class="comment">//   for (unsigned int j=0; j&lt;this-&gt;n(); j++)</span>
<a name="l00814"></a>00814 <span class="comment">//     (*this)(iv,j) = 0.;</span>
<a name="l00815"></a>00815 
<a name="l00816"></a>00816 <span class="comment">//   (*this)(iv,jv) = 1.;</span>
<a name="l00817"></a>00817 <span class="comment">//   rhs(iv) = val;</span>
<a name="l00818"></a>00818   
<a name="l00819"></a>00819 <span class="comment">// }</span>
<a name="l00820"></a>00820 
<a name="l00821"></a>00821 
<a name="l00822"></a>00822 
<a name="l00823"></a>00823 
<a name="l00824"></a>00824 } <span class="comment">// namespace libMesh</span>
<a name="l00825"></a>00825 
<a name="l00826"></a>00826 
<a name="l00827"></a>00827 
<a name="l00828"></a>00828 
<a name="l00829"></a>00829 <span class="preprocessor">#endif // #ifndef __dense_matrix_h__</span>
<a name="l00830"></a>00830 <span class="preprocessor"></span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
