<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_eaf30c8ea092d33f79a04353c3899c3f.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_5a0c7151fa56969ceb962f1511f7edee.php">systems</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">derived_rb_system.h</div>  </div>
</div>
<div class="contents">
<a href="derived__rb__system_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// rbOOmit: An implementation of the Certified Reduced Basis method.</span>
<a name="l00002"></a>00002 <span class="comment">// Copyright (C) 2009, 2010 David J. Knezevic</span>
<a name="l00003"></a>00003 
<a name="l00004"></a>00004 <span class="comment">// This file is part of rbOOmit.</span>
<a name="l00005"></a>00005 
<a name="l00006"></a>00006 <span class="comment">// rbOOmit is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// rbOOmit is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="preprocessor">#ifndef __derived_rb_system_h__</span>
<a name="l00021"></a>00021 <span class="preprocessor"></span><span class="preprocessor">#define __derived_rb_system_h__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;<a class="code" href="linear__implicit__system_8h.php">linear_implicit_system.h</a>&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="code" href="dense__vector_8h.php">dense_vector.h</a>&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="dense__matrix_8h.php">dense_matrix.h</a>&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="rb__base_8h.php">rb_base.h</a>&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="fem__context_8h.php">fem_context.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="rb__system_8h.php">rb_system.h</a>&quot;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="keyword">namespace </span>libMesh
<a name="l00031"></a>00031 {
<a name="l00032"></a>00032 
<a name="l00044"></a>00044 <span class="keyword">template</span>&lt;<span class="keyword">class</span> Base&gt;
<a name="l00045"></a><a class="code" href="classlibMesh_1_1DerivedRBSystem.php">00045</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1DerivedRBSystem.php">DerivedRBSystem</a> : <span class="keyword">public</span> Base
<a name="l00046"></a>00046 {
<a name="l00047"></a>00047 <span class="keyword">public</span>:
<a name="l00048"></a>00048 
<a name="l00049"></a><a class="code" href="classlibMesh_1_1DerivedRBSystem.php#a8d124aa48b58312b93d3e46316405f32a98a0757f9b07e149a6de80e29a66b511">00049</a>   <span class="keyword">enum</span> <a class="code" href="classlibMesh_1_1DerivedRBSystem.php#a8d124aa48b58312b93d3e46316405f32">DERIVED_RESIDUAL_TYPE</a> { <a class="code" href="classlibMesh_1_1DerivedRBSystem.php#a8d124aa48b58312b93d3e46316405f32a98a0757f9b07e149a6de80e29a66b511">RESIDUAL_WRT_UBER</a>, <a class="code" href="classlibMesh_1_1DerivedRBSystem.php#a8d124aa48b58312b93d3e46316405f32afb85350ef94f7370d9ffc738eee2ee05">RESIDUAL_WRT_TRUTH</a> };
<a name="l00050"></a>00050 
<a name="l00055"></a>00055   <a class="code" href="classlibMesh_1_1DerivedRBSystem.php#afb18eceb7e74123ba16fb3834a8fd989">DerivedRBSystem</a> (<a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00056"></a>00056             <span class="keyword">const</span> std::string&amp; <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>,
<a name="l00057"></a>00057             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> number);
<a name="l00058"></a>00058 
<a name="l00062"></a><a class="code" href="classlibMesh_1_1DerivedRBSystem.php#ad4d2e8f627aa67fdd056b657a5c54b67">00062</a>   <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1DerivedRBSystem.php">DerivedRBSystem&lt;Base&gt;</a> <a class="code" href="classlibMesh_1_1DerivedRBSystem.php#ad4d2e8f627aa67fdd056b657a5c54b67">sys_type</a>;
<a name="l00063"></a>00063   
<a name="l00067"></a><a class="code" href="classlibMesh_1_1DerivedRBSystem.php#a2bce42f52403b4adfe1905ca4984c8f4">00067</a>   <a class="code" href="classlibMesh_1_1DerivedRBSystem.php">sys_type</a> &amp; <a class="code" href="classlibMesh_1_1DerivedRBSystem.php#a2bce42f52403b4adfe1905ca4984c8f4">system</a> () { <span class="keywordflow">return</span> *<span class="keyword">this</span>; }
<a name="l00068"></a>00068 
<a name="l00072"></a>00072   <span class="keyword">virtual</span> std::string <a class="code" href="classlibMesh_1_1DerivedRBSystem.php#a144c151da98bb7ff1577ad67add81cbf">system_type</a> () <span class="keyword">const</span>;
<a name="l00073"></a>00073   
<a name="l00078"></a>00078   <span class="keyword">virtual</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1DerivedRBSystem.php#acd2b06790eb3c931e2980d797534fb5d">truth_solve</a>(<span class="keywordtype">int</span> plot_solution);
<a name="l00079"></a>00079   
<a name="l00087"></a>00087   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DerivedRBSystem.php#afbb5eb10ed674dfef24626f4abb7b882">set_uber_current_parameters</a>();
<a name="l00088"></a>00088   
<a name="l00093"></a>00093   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DerivedRBSystem.php#aeb89a2e51cbc02dd6e60fb9c77eef549">load_RB_solution</a>();
<a name="l00094"></a>00094 
<a name="l00098"></a>00098   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DerivedRBSystem.php#a88bddab0eb5fdbd49779babb6e33d377">load_basis_function</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i);
<a name="l00099"></a>00099   
<a name="l00104"></a><a class="code" href="classlibMesh_1_1DerivedRBSystem.php#a8e3a170506028b81516baf84ed87dcb0">00104</a>   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DerivedRBSystem.php#a8e3a170506028b81516baf84ed87dcb0">get_n_basis_functions</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1DerivedRBSystem.php#ae4241e9ecf20bf9f231aeeb6bf65c929">derived_basis_functions</a>.size(); }
<a name="l00105"></a>00105   
<a name="l00111"></a><a class="code" href="classlibMesh_1_1DerivedRBSystem.php#a0fc41325f16f392472e6204555f1836a">00111</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DerivedRBSystem.php#a0fc41325f16f392472e6204555f1836a">set_n_basis_functions</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_bfs) { <a class="code" href="classlibMesh_1_1DerivedRBSystem.php#ae4241e9ecf20bf9f231aeeb6bf65c929">derived_basis_functions</a>.resize(n_bfs); }
<a name="l00112"></a>00112   
<a name="l00120"></a>00120   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DerivedRBSystem.php#a24142e9bfca09edbaf0bc22cd62db573">generate_residual_terms_wrt_truth</a>();
<a name="l00121"></a>00121   
<a name="l00126"></a>00126   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DerivedRBSystem.php#af7344b8f92730a64c4d6ec3f8526efe0">clear_basis_function_dependent_data</a>();
<a name="l00127"></a>00127   
<a name="l00133"></a>00133   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DerivedRBSystem.php#a82766e1c8f88a96306dcd460875cc48e">write_offline_data_to_files</a>(<span class="keyword">const</span> std::string&amp; directory_name = <span class="stringliteral">&quot;offline_data&quot;</span>);
<a name="l00134"></a>00134 
<a name="l00135"></a>00135 
<a name="l00136"></a>00136   <span class="comment">//----------- PUBLIC DATA MEMBERS -----------//</span>
<a name="l00137"></a>00137 
<a name="l00138"></a>00138   
<a name="l00143"></a><a class="code" href="classlibMesh_1_1DerivedRBSystem.php#ae4241e9ecf20bf9f231aeeb6bf65c929">00143</a>    std::vector&lt; DenseVector&lt;Number&gt; &gt; <a class="code" href="classlibMesh_1_1DerivedRBSystem.php#ae4241e9ecf20bf9f231aeeb6bf65c929">derived_basis_functions</a>;
<a name="l00144"></a>00144    
<a name="l00149"></a><a class="code" href="classlibMesh_1_1DerivedRBSystem.php#a415d99d22440f941330347b605aa31b9">00149</a>   std::string <a class="code" href="classlibMesh_1_1DerivedRBSystem.php#a415d99d22440f941330347b605aa31b9">uber_system_name</a>;
<a name="l00150"></a>00150   
<a name="l00157"></a><a class="code" href="classlibMesh_1_1DerivedRBSystem.php#a1d3a850a226f50490d3c3b706d1fccec">00157</a>   <a class="code" href="classlibMesh_1_1DerivedRBSystem.php#a8d124aa48b58312b93d3e46316405f32">DERIVED_RESIDUAL_TYPE</a> <a class="code" href="classlibMesh_1_1DerivedRBSystem.php#a1d3a850a226f50490d3c3b706d1fccec">residual_type_flag</a>;
<a name="l00158"></a>00158    
<a name="l00159"></a>00159 <span class="keyword">protected</span>:
<a name="l00160"></a>00160 
<a name="l00167"></a>00167   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DerivedRBSystem.php#a88a732b4657f70b922f14c6af5873b13">enrich_RB_space</a>();
<a name="l00168"></a>00168   
<a name="l00175"></a>00175   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DerivedRBSystem.php#a8cb1d62ed4d283109aa527619b654186">update_RB_system_matrices</a>();
<a name="l00176"></a>00176   
<a name="l00183"></a>00183   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DerivedRBSystem.php#ab1ed3c5111bc4c9d887b11715e471d22">update_residual_terms</a>(<span class="keywordtype">bool</span> compute_inner_products=<span class="keyword">true</span>);
<a name="l00184"></a>00184   
<a name="l00189"></a>00189   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DerivedRBSystem.php#a4af20839628e56c1c5712bc59f5c0f7a">write_out_basis_functions</a>(<span class="keyword">const</span> std::string&amp; directory_name,
<a name="l00190"></a>00190                                          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> precision_level);
<a name="l00191"></a>00191   
<a name="l00196"></a>00196   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DerivedRBSystem.php#a48e51dae5600428fb0f1893b5bcf3feb">read_in_basis_functions</a>(<span class="keyword">const</span> std::string&amp; directory_name);
<a name="l00197"></a>00197   
<a name="l00198"></a>00198 <span class="keyword">private</span>:
<a name="l00199"></a>00199 
<a name="l00200"></a>00200 };
<a name="l00201"></a>00201 
<a name="l00202"></a>00202 <span class="comment">// And introduce convenient typedefs</span>
<a name="l00203"></a><a class="code" href="namespacelibMesh.php#a8cac9dc169372a1b45c48782e2550624">00203</a> <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1DerivedRBSystem.php">DerivedRBSystem&lt;RBSystem&gt;</a> <a class="code" href="namespacelibMesh.php#a8cac9dc169372a1b45c48782e2550624">SteadyDerivedRBSystem</a>;
<a name="l00204"></a>00204  
<a name="l00205"></a>00205 } <span class="comment">// namespace libMesh</span>
<a name="l00206"></a>00206 
<a name="l00207"></a>00207 
<a name="l00208"></a>00208 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
