<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_eaf30c8ea092d33f79a04353c3899c3f.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_1a4c9b21777a7b572c3cbd89bb719480.php">base</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">dof_map.h</div>  </div>
</div>
<div class="contents">
<a href="dof__map_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id$</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __dof_map_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __dof_map_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ Includes   -----------------------------------</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &lt;map&gt;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &lt;string&gt;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &lt;algorithm&gt;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &lt;iterator&gt;</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="comment">// Local Includes -----------------------------------</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="enum__order_8h.php">enum_order.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="reference__counted__object_8h.php">reference_counted_object.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="libmesh_8h.php">libmesh.h</a>&quot;</span> <span class="comment">// libMesh::invalid_uint</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;<a class="code" href="variable_8h.php">variable.h</a>&quot;</span>
<a name="l00038"></a>00038 <span class="preprocessor">#include &quot;<a class="code" href="threads_8h.php">threads.h</a>&quot;</span>
<a name="l00039"></a>00039 <span class="preprocessor">#include &quot;<a class="code" href="threads__allocators_8h.php">threads_allocators.h</a>&quot;</span>
<a name="l00040"></a>00040 <span class="preprocessor">#include &quot;<a class="code" href="elem__range_8h.php">elem_range.h</a>&quot;</span>
<a name="l00041"></a>00041 
<a name="l00042"></a>00042 <span class="keyword">namespace </span>libMesh
<a name="l00043"></a>00043 {
<a name="l00044"></a>00044 
<a name="l00045"></a>00045 <span class="comment">// Forward Declarations</span>
<a name="l00046"></a>00046 <span class="keyword">class </span>CouplingMatrix;
<a name="l00047"></a>00047 <span class="keyword">class </span>DofMap;
<a name="l00048"></a>00048 <span class="keyword">class </span>DofObject;
<a name="l00049"></a>00049 <span class="keyword">class </span>Elem;
<a name="l00050"></a>00050 <span class="keyword">class </span>FEType;
<a name="l00051"></a>00051 <span class="keyword">class </span>MeshBase;
<a name="l00052"></a>00052 <span class="keyword">class </span>Mesh;
<a name="l00053"></a>00053 <span class="keyword">class </span>PeriodicBoundary;
<a name="l00054"></a>00054 <span class="keyword">class </span>PeriodicBoundaries;
<a name="l00055"></a><a class="code" href="namespacelibMesh_1_1SparsityPattern.php">00055</a> <span class="keyword">namespace </span>SparsityPattern { <span class="keyword">class </span><a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php">Build</a>; }
<a name="l00056"></a>00056 <span class="keyword">class </span><a class="code" href="classlibMesh_1_1System.php">System</a>;
<a name="l00057"></a>00057 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span><a class="code" href="classlibMesh_1_1DenseVectorBase.php">DenseVectorBase</a>;
<a name="l00058"></a>00058 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span><a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector</a>;
<a name="l00059"></a>00059 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span><a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix</a>;
<a name="l00060"></a>00060 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span><a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix</a>;
<a name="l00061"></a><a class="code" href="namespacelibMesh.php#a919b3727a9707f23ecad00949d1d1c43">00061</a> <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span><a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector</a>;
<a name="l00062"></a>00062 
<a name="l00063"></a>00063 
<a name="l00064"></a>00064 
<a name="l00065"></a>00065 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00066"></a>00066 <span class="comment">// AMR constraint matrix types</span>
<a name="l00067"></a>00067 
<a name="l00068"></a>00068 <span class="preprocessor">#if defined(LIBMESH_ENABLE_AMR) || defined(LIBMESH_ENABLE_PERIODIC)</span>
<a name="l00069"></a>00069 <span class="preprocessor"></span>
<a name="l00072"></a>00072 <span class="keyword">typedef</span> std::map&lt;<span class="keywordtype">unsigned</span> int, <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>, 
<a name="l00073"></a>00073                  std::less&lt;unsigned int&gt;, 
<a name="l00074"></a>00074                  <a class="code" href="classlibMesh_1_1Threads_1_1scalable__allocator.php">Threads::scalable_allocator&lt;std::pair&lt;const unsigned int, Real&gt;</a> &gt; &gt; <a class="code" href="namespacelibMesh.php#a919b3727a9707f23ecad00949d1d1c43">DofConstraintRow</a>;
<a name="l00075"></a>00075 
<a name="l00082"></a><a class="code" href="classlibMesh_1_1DofConstraints.php">00082</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1DofConstraints.php">DofConstraints</a> : <span class="keyword">public</span> std::<a class="code" href="classstd_1_1map.php">map</a>&lt;unsigned int, 
<a name="l00083"></a>00083                                        DofConstraintRow, 
<a name="l00084"></a>00084                                        std::less&lt;unsigned int&gt;, 
<a name="l00085"></a>00085                                        Threads::scalable_allocator&lt;std::pair&lt;const unsigned int, DofConstraintRow&gt; &gt; &gt;
<a name="l00086"></a>00086 {
<a name="l00087"></a>00087 };
<a name="l00088"></a>00088 <span class="preprocessor">#endif // LIBMESH_ENABLE_AMR || LIBMESH_ENABLE_PERIODIC</span>
<a name="l00089"></a>00089 <span class="preprocessor"></span>
<a name="l00090"></a>00090   
<a name="l00091"></a>00091   
<a name="l00092"></a>00092 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00093"></a>00093 <span class="comment">// DofMap class definition</span>
<a name="l00094"></a>00094 
<a name="l00104"></a><a class="code" href="classlibMesh_1_1DofMap.php">00104</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1DofMap.php">DofMap</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1ReferenceCountedObject.php">ReferenceCountedObject</a>&lt;DofMap&gt;
<a name="l00105"></a>00105 {
<a name="l00106"></a>00106 <span class="keyword">public</span>:
<a name="l00107"></a>00107 
<a name="l00112"></a>00112   <a class="code" href="classlibMesh_1_1DofMap.php#a6fe401e7df6dfc21a89c528cd52515ac">DofMap</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DofMap.php#a244e7a1cd82d5e6ae8780c93205ec1fa">sys_number</a>);
<a name="l00113"></a>00113 
<a name="l00117"></a>00117   <a class="code" href="classlibMesh_1_1DofMap.php#addb6136725455c3a28e17193d3edf7ee">~DofMap</a>();
<a name="l00118"></a>00118 
<a name="l00124"></a>00124   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#aa10200782a0f8fe0c4d3f7bdf10cedc6">attach_matrix</a> (<a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;Number&gt;</a>&amp; matrix);
<a name="l00125"></a>00125 
<a name="l00131"></a>00131   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#ab986eb7bbf9bbb5119a49a145306a980">distribute_dofs</a> (<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp;);
<a name="l00132"></a>00132 
<a name="l00138"></a>00138   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#a49379ce3a542eab41a8f8e44d0f154c2">compute_sparsity</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp;);
<a name="l00139"></a>00139 
<a name="l00145"></a>00145   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#a47865aeb6379c68169e926dd0ecc2b71">prepare_send_list</a> ();
<a name="l00146"></a>00146   
<a name="l00154"></a><a class="code" href="classlibMesh_1_1DofMap.php#a4e0a6909796bc3c19ca543a182ffe224">00154</a>   <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; <a class="code" href="classlibMesh_1_1DofMap.php#a4e0a6909796bc3c19ca543a182ffe224">get_send_list</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1DofMap.php#a66d63042b6f4dce2ef98a1573ff6b2ad">_send_list</a>; }
<a name="l00155"></a>00155   
<a name="l00162"></a><a class="code" href="classlibMesh_1_1DofMap.php#aa29946f60cd67530a744a022478ec19f">00162</a>   <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; <a class="code" href="classlibMesh_1_1DofMap.php#aa29946f60cd67530a744a022478ec19f">get_n_nz</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1DofMap.php#a2f1f1ad0386f846409d903d5df18f114">_n_nz</a>; }
<a name="l00163"></a>00163   
<a name="l00170"></a><a class="code" href="classlibMesh_1_1DofMap.php#a0a809b27a371bf3dbae5241b485ef530">00170</a>   <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; <a class="code" href="classlibMesh_1_1DofMap.php#a0a809b27a371bf3dbae5241b485ef530">get_n_oz</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1DofMap.php#a0b3879c0bf8ae122f12710bc32f17810">_n_oz</a>; }
<a name="l00171"></a>00171 
<a name="l00176"></a>00176   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#a99bd5717524ac8156554650eac8d2c60">add_variable</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Variable.php">Variable</a> &amp;var);
<a name="l00177"></a>00177   
<a name="l00181"></a>00181   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Variable.php">Variable</a>&amp; <a class="code" href="classlibMesh_1_1DofMap.php#ab36a0dc3c2c457fa8c01c1b0ba37facc">variable</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c) <span class="keyword">const</span>;
<a name="l00182"></a>00182 
<a name="l00186"></a>00186   <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> <a class="code" href="classlibMesh_1_1DofMap.php#a43aa131ac08b4b6aff6d865e672638da">variable_order</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c) <span class="keyword">const</span>;
<a name="l00187"></a>00187   
<a name="l00191"></a>00191   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; <a class="code" href="classlibMesh_1_1DofMap.php#a0c010bb250d4cd8d65794452f46d141a">variable_type</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c) <span class="keyword">const</span>;
<a name="l00192"></a>00192   
<a name="l00198"></a><a class="code" href="classlibMesh_1_1DofMap.php#aee89c467613b296c215421d60d5ae961">00198</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DofMap.php#aee89c467613b296c215421d60d5ae961">n_variables</a>()<span class="keyword"> const</span>
<a name="l00199"></a>00199 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1DofMap.php#a5232a8054e580a408f394ba1574c63df">_variables</a>.size(); }
<a name="l00200"></a>00200   
<a name="l00205"></a><a class="code" href="classlibMesh_1_1DofMap.php#ae014405975490bab74a4a7596c379990">00205</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DofMap.php#ae014405975490bab74a4a7596c379990">n_dofs</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1DofMap.php#a339dde44caf1af4d425d3830a20c7f54">_n_dfs</a>; }
<a name="l00209"></a><a class="code" href="classlibMesh_1_1DofMap.php#a2bb9dd194dc4de300fd315bd9edc92bd">00209</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DofMap.php#a2bb9dd194dc4de300fd315bd9edc92bd">n_SCALAR_dofs</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1DofMap.php#ae4795cf1e08ba233dec67fe06b36873b">_n_SCALAR_dofs</a>; }
<a name="l00210"></a>00210 
<a name="l00214"></a><a class="code" href="classlibMesh_1_1DofMap.php#a0066097865af69c00a98148791480d5b">00214</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DofMap.php#a0066097865af69c00a98148791480d5b">n_local_dofs</a> ()<span class="keyword"> const</span>
<a name="l00215"></a>00215 <span class="keyword">  </span>{ <span class="keywordflow">return</span> this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#a93892a922e17e271f635262a9c8acf98">n_dofs_on_processor</a> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>()); }
<a name="l00216"></a>00216 
<a name="l00220"></a><a class="code" href="classlibMesh_1_1DofMap.php#a93892a922e17e271f635262a9c8acf98">00220</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DofMap.php#a93892a922e17e271f635262a9c8acf98">n_dofs_on_processor</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc)<span class="keyword"> const</span>
<a name="l00221"></a>00221 <span class="keyword">  </span>{ libmesh_assert(proc &lt; <a class="code" href="classlibMesh_1_1DofMap.php#a6a2cc4429bc1f9ec22b85dedbee55d96">_first_df</a>.size()); <span class="keywordflow">return</span> (<a class="code" href="classlibMesh_1_1DofMap.php#ab03f023f66c9d64feddada936ae18750">_end_df</a>[proc] - <a class="code" href="classlibMesh_1_1DofMap.php#a6a2cc4429bc1f9ec22b85dedbee55d96">_first_df</a>[proc]); }
<a name="l00222"></a>00222 
<a name="l00226"></a><a class="code" href="classlibMesh_1_1DofMap.php#ad2b15648e708f656a798bd642c3ca8e3">00226</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DofMap.php#ad2b15648e708f656a798bd642c3ca8e3">first_dof</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc = <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>())<span class="keyword"> const</span>
<a name="l00227"></a>00227 <span class="keyword">  </span>{ libmesh_assert(proc &lt; <a class="code" href="classlibMesh_1_1DofMap.php#a6a2cc4429bc1f9ec22b85dedbee55d96">_first_df</a>.size()); <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1DofMap.php#a6a2cc4429bc1f9ec22b85dedbee55d96">_first_df</a>[proc]; }
<a name="l00228"></a>00228   
<a name="l00232"></a><a class="code" href="classlibMesh_1_1DofMap.php#a57c76483c978870339e943a5973e254e">00232</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DofMap.php#a57c76483c978870339e943a5973e254e">first_old_dof</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc = <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>())<span class="keyword"> const</span>
<a name="l00233"></a>00233 <span class="keyword">  </span>{ libmesh_assert(proc &lt; <a class="code" href="classlibMesh_1_1DofMap.php#abe4f7d1a32937bce6c6d8fc8b32ce0a2">_first_old_df</a>.size()); <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1DofMap.php#abe4f7d1a32937bce6c6d8fc8b32ce0a2">_first_old_df</a>[proc]; }
<a name="l00234"></a>00234   
<a name="l00240"></a><a class="code" href="classlibMesh_1_1DofMap.php#a725dd59194b6a36156219e5357104bf5">00240</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DofMap.php#a725dd59194b6a36156219e5357104bf5">last_dof</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc = <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>())<span class="keyword"> const</span>
<a name="l00241"></a>00241 <span class="keyword">  </span>{ libmesh_deprecated(); libmesh_assert(proc &lt; <a class="code" href="classlibMesh_1_1DofMap.php#ab03f023f66c9d64feddada936ae18750">_end_df</a>.size()); <span class="keywordflow">return</span> (<a class="code" href="classlibMesh_1_1DofMap.php#ab03f023f66c9d64feddada936ae18750">_end_df</a>[proc] - 1); }  
<a name="l00242"></a>00242 
<a name="l00247"></a><a class="code" href="classlibMesh_1_1DofMap.php#abf250ac3decfedbe00ddaeef85ed4de4">00247</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DofMap.php#abf250ac3decfedbe00ddaeef85ed4de4">end_dof</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc = <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>())<span class="keyword"> const</span>
<a name="l00248"></a>00248 <span class="keyword">  </span>{ libmesh_assert(proc &lt; <a class="code" href="classlibMesh_1_1DofMap.php#ab03f023f66c9d64feddada936ae18750">_end_df</a>.size()); <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1DofMap.php#ab03f023f66c9d64feddada936ae18750">_end_df</a>[proc]; }
<a name="l00249"></a>00249   
<a name="l00254"></a><a class="code" href="classlibMesh_1_1DofMap.php#af914825b77ed3620fc1e5b632d228400">00254</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DofMap.php#af914825b77ed3620fc1e5b632d228400">end_old_dof</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc = <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>())<span class="keyword"> const</span>
<a name="l00255"></a>00255 <span class="keyword">  </span>{ libmesh_assert(proc &lt; <a class="code" href="classlibMesh_1_1DofMap.php#a5c01318c85ebe04282bdaf8dff4e3528">_end_old_df</a>.size()); <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1DofMap.php#a5c01318c85ebe04282bdaf8dff4e3528">_end_old_df</a>[proc]; }
<a name="l00256"></a>00256   
<a name="l00260"></a><a class="code" href="classlibMesh_1_1DofMap.php#a1dc795b4576e48661fd850c8ed1b33f2">00260</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DofMap.php#a1dc795b4576e48661fd850c8ed1b33f2">variable_first_local_dof</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var)<span class="keyword"> const</span>
<a name="l00261"></a>00261 <span class="keyword">  </span>{ 
<a name="l00262"></a>00262     libmesh_assert ((var+1) &lt; <a class="code" href="classlibMesh_1_1DofMap.php#ac2cd47f78f1cf8bbdba640f56ef96afa">_var_first_local_df</a>.size());
<a name="l00263"></a>00263     libmesh_assert (<a class="code" href="classlibMesh_1_1DofMap.php#ac2cd47f78f1cf8bbdba640f56ef96afa">_var_first_local_df</a>[var] != <a class="code" href="classlibMesh_1_1DofObject.php#a1801e332bf034abe252086db668fee2d">DofObject::invalid_id</a>);
<a name="l00264"></a>00264     <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1DofMap.php#ac2cd47f78f1cf8bbdba640f56ef96afa">_var_first_local_df</a>[var];
<a name="l00265"></a>00265   }
<a name="l00266"></a>00266 
<a name="l00271"></a><a class="code" href="classlibMesh_1_1DofMap.php#a27a81a53cc462042ab5fb7d355bc9427">00271</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DofMap.php#a27a81a53cc462042ab5fb7d355bc9427">variable_last_local_dof</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var)<span class="keyword"> const</span>
<a name="l00272"></a>00272 <span class="keyword">  </span>{ 
<a name="l00273"></a>00273     libmesh_assert ((var+1) &lt; <a class="code" href="classlibMesh_1_1DofMap.php#ac2cd47f78f1cf8bbdba640f56ef96afa">_var_first_local_df</a>.size());
<a name="l00274"></a>00274     libmesh_assert (<a class="code" href="classlibMesh_1_1DofMap.php#ac2cd47f78f1cf8bbdba640f56ef96afa">_var_first_local_df</a>[var+1] != <a class="code" href="classlibMesh_1_1DofObject.php#a1801e332bf034abe252086db668fee2d">DofObject::invalid_id</a>);
<a name="l00275"></a>00275     <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1DofMap.php#ac2cd47f78f1cf8bbdba640f56ef96afa">_var_first_local_df</a>[var+1];
<a name="l00276"></a>00276   }
<a name="l00277"></a>00277 
<a name="l00283"></a>00283   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#a5dac22ba99a9da3563c00b7dfd2f07af">dof_indices</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <span class="keyword">const</span> elem,
<a name="l00284"></a>00284                     std::vector&lt;unsigned int&gt;&amp; di,
<a name="l00285"></a>00285                     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> vn = <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>) <span class="keyword">const</span>;
<a name="l00286"></a>00286 
<a name="l00293"></a>00293   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#af9103a52e6edce2c9f4a3d8499b9aaa3">SCALAR_dof_indices</a> (std::vector&lt;unsigned int&gt;&amp; di,
<a name="l00294"></a>00294                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> vn,
<a name="l00295"></a>00295                            <span class="keyword">const</span> <span class="keywordtype">bool</span> old_dofs=<span class="keyword">false</span>) <span class="keyword">const</span>;
<a name="l00296"></a>00296 
<a name="l00303"></a>00303   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1DofMap.php#a6a93245255b86501e09ef377b73bf089">all_semilocal_indices</a> (<span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; <a class="code" href="classlibMesh_1_1DofMap.php#a5dac22ba99a9da3563c00b7dfd2f07af">dof_indices</a>) <span class="keyword">const</span>;
<a name="l00304"></a>00304 
<a name="l00311"></a>00311   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1DofMap.php#a2489e7c067abb05feba00459ac70a1ba">use_coupled_neighbor_dofs</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>) <span class="keyword">const</span>;
<a name="l00312"></a>00312 
<a name="l00323"></a>00323   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#aa026159e90f65d37c08345a86072994f">extract_local_vector</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>&amp; Ug,
<a name="l00324"></a>00324                              <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; <a class="code" href="classlibMesh_1_1DofMap.php#a5dac22ba99a9da3563c00b7dfd2f07af">dof_indices</a>,
<a name="l00325"></a>00325                              <a class="code" href="classlibMesh_1_1DenseVectorBase.php">DenseVectorBase&lt;Number&gt;</a>&amp; Ue) <span class="keyword">const</span>;
<a name="l00326"></a>00326 
<a name="l00327"></a>00327 
<a name="l00328"></a>00328 <span class="preprocessor">#if defined(LIBMESH_ENABLE_AMR) || defined(LIBMESH_ENABLE_PERIODIC)</span>
<a name="l00329"></a>00329 <span class="preprocessor"></span>
<a name="l00330"></a>00330   <span class="comment">//--------------------------------------------------------------------</span>
<a name="l00331"></a>00331   <span class="comment">// Constraint-specific methods</span>
<a name="l00336"></a><a class="code" href="classlibMesh_1_1DofMap.php#a89d713b396dfc8dd883078c278a5b6d1">00336</a> <span class="comment"></span>  <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DofMap.php#a89d713b396dfc8dd883078c278a5b6d1">n_constrained_dofs</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1DofMap.php#af7fe4d0cf13618e6dd04ff22fdaca0ba">_dof_constraints</a>.size(); }
<a name="l00337"></a>00337 
<a name="l00341"></a>00341   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#a4dc67be5bbecf0e4947d790f6653e2d5">create_dof_constraints</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>);
<a name="l00342"></a>00342 
<a name="l00346"></a>00346   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#a2a73dfbc22045908ef2acf9045c7790f">allgather_recursive_constraints</a> ();
<a name="l00347"></a>00347 
<a name="l00355"></a>00355   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#ad48c72b8add66781d21ad77a3febe59d">process_constraints</a> ();
<a name="l00356"></a>00356 
<a name="l00361"></a>00361   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#ab49ad674c1ea5fd71d968d84db954739">add_constraint_row</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dof_number,
<a name="l00362"></a>00362                            <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#a919b3727a9707f23ecad00949d1d1c43">DofConstraintRow</a>&amp; constraint_row,
<a name="l00363"></a>00363                            <span class="keyword">const</span> <span class="keywordtype">bool</span> forbid_constraint_overwrite = <span class="keyword">true</span>);
<a name="l00364"></a>00364 
<a name="l00368"></a><a class="code" href="classlibMesh_1_1DofMap.php#ac72b84326e15a8e0b57c739f3b7c5a30">00368</a>   DofConstraints::const_iterator <a class="code" href="classlibMesh_1_1DofMap.php#ac72b84326e15a8e0b57c739f3b7c5a30">constraint_rows_begin</a>()<span class="keyword"> const</span>
<a name="l00369"></a>00369 <span class="keyword">    </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1DofMap.php#af7fe4d0cf13618e6dd04ff22fdaca0ba">_dof_constraints</a>.begin(); }
<a name="l00370"></a>00370   
<a name="l00374"></a><a class="code" href="classlibMesh_1_1DofMap.php#a5d8722d80a7bbdc6e4c3873c03d0e237">00374</a>   DofConstraints::const_iterator <a class="code" href="classlibMesh_1_1DofMap.php#a5d8722d80a7bbdc6e4c3873c03d0e237">constraint_rows_end</a>()<span class="keyword"> const</span>
<a name="l00375"></a>00375 <span class="keyword">    </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1DofMap.php#af7fe4d0cf13618e6dd04ff22fdaca0ba">_dof_constraints</a>.end(); }
<a name="l00376"></a>00376   
<a name="l00381"></a>00381   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1DofMap.php#af59487b50683e231676f836f94cde1ab">is_constrained_dof</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dof) <span class="keyword">const</span>;
<a name="l00382"></a>00382   
<a name="l00386"></a>00386   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#a9c8aef879917dfdd8a9309b7e29ed9d3">print_dof_constraints</a>(std::ostream&amp; os=<a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a>) <span class="keyword">const</span>;
<a name="l00387"></a>00387 
<a name="l00396"></a>00396   std::pair&lt;Real, Real&gt; <a class="code" href="classlibMesh_1_1DofMap.php#a8d3c9a10b0a20e889cb9c781219ef29d">max_constraint_error</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a> &amp;system,
<a name="l00397"></a>00397                                              <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> *v = NULL) <span class="keyword">const</span>;
<a name="l00398"></a>00398 
<a name="l00399"></a>00399 <span class="preprocessor">#endif // LIBMESH_ENABLE_AMR || LIBMESH_ENABLE_PERIODIC</span>
<a name="l00400"></a>00400 <span class="preprocessor"></span>
<a name="l00401"></a>00401   <span class="comment">//--------------------------------------------------------------------</span>
<a name="l00402"></a>00402   <span class="comment">// Constraint-specific methods</span>
<a name="l00403"></a>00403   <span class="comment">// Some of these methods are enabled (but inlined away to nothing)</span>
<a name="l00404"></a>00404   <span class="comment">// when constraints are disabled at configure-time.  This is to</span>
<a name="l00405"></a>00405   <span class="comment">// increase API compatibility of user code with different library</span>
<a name="l00406"></a>00406   <span class="comment">// builds.</span>
<a name="l00407"></a>00407 
<a name="l00421"></a>00421   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#a426611c953c70989bc32a792e49c3450">constrain_element_matrix</a> (<a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Number&gt;</a>&amp; matrix,
<a name="l00422"></a>00422                                  std::vector&lt;unsigned int&gt;&amp; elem_dofs,
<a name="l00423"></a>00423                                  <span class="keywordtype">bool</span> asymmetric_constraint_rows = <span class="keyword">true</span>) <span class="keyword">const</span>;
<a name="l00424"></a>00424   
<a name="l00431"></a>00431   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#a426611c953c70989bc32a792e49c3450">constrain_element_matrix</a> (<a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Number&gt;</a>&amp; matrix,
<a name="l00432"></a>00432                                  std::vector&lt;unsigned int&gt;&amp; row_dofs,
<a name="l00433"></a>00433                                  std::vector&lt;unsigned int&gt;&amp; col_dofs,
<a name="l00434"></a>00434                                  <span class="keywordtype">bool</span> asymmetric_constraint_rows = <span class="keyword">true</span>) <span class="keyword">const</span>;
<a name="l00435"></a>00435   
<a name="l00439"></a>00439   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#a29aba1bf008a1de4dd81a9a1b6f5ff41">constrain_element_vector</a> (<a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a>&amp;       rhs,
<a name="l00440"></a>00440                                  std::vector&lt;unsigned int&gt;&amp; dofs,
<a name="l00441"></a>00441                                  <span class="keywordtype">bool</span> asymmetric_constraint_rows = <span class="keyword">true</span>) <span class="keyword">const</span>;
<a name="l00442"></a>00442   
<a name="l00451"></a>00451   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#a97906aa49177873ed7ea9029dcb0cd4b">constrain_element_matrix_and_vector</a> (<a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Number&gt;</a>&amp; matrix,
<a name="l00452"></a>00452                                             <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a>&amp; rhs,
<a name="l00453"></a>00453                                             std::vector&lt;unsigned int&gt;&amp; elem_dofs,
<a name="l00454"></a>00454                                             <span class="keywordtype">bool</span> asymmetric_constraint_rows = <span class="keyword">true</span>) <span class="keyword">const</span>;
<a name="l00455"></a>00455 
<a name="l00464"></a>00464   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#ae5ccc5717b8c3a94629a306ebd4e1f17">constrain_element_dyad_matrix</a> (<a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a>&amp; v,
<a name="l00465"></a>00465                                       <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a>&amp; w,
<a name="l00466"></a>00466                                       std::vector&lt;unsigned int&gt;&amp; row_dofs,
<a name="l00467"></a>00467                                       <span class="keywordtype">bool</span> asymmetric_constraint_rows = <span class="keyword">true</span>) <span class="keyword">const</span>;
<a name="l00468"></a>00468 
<a name="l00475"></a>00475   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#a435e93c5a2f7bc911a62886eaddab082">constrain_nothing</a> (std::vector&lt;unsigned int&gt;&amp; dofs) <span class="keyword">const</span>;
<a name="l00476"></a>00476   
<a name="l00485"></a>00485   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#a938f3e6db23b740002490ac88d1bb60a">enforce_constraints_exactly</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a> &amp;system,
<a name="l00486"></a>00486                                     <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> *v = NULL) <span class="keyword">const</span>;
<a name="l00487"></a>00487   
<a name="l00488"></a>00488 
<a name="l00489"></a>00489 <span class="preprocessor">#ifdef LIBMESH_ENABLE_PERIODIC</span>
<a name="l00490"></a>00490 <span class="preprocessor"></span>
<a name="l00491"></a>00491   <span class="comment">//--------------------------------------------------------------------</span>
<a name="l00492"></a>00492   <span class="comment">// PeriodicBoundary-specific methods</span>
<a name="l00493"></a>00493 
<a name="l00497"></a>00497   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#a2f0a90f17fba3db87f78f8813e111ac2">add_periodic_boundary</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1PeriodicBoundary.php">PeriodicBoundary</a>&amp; periodic_boundary);
<a name="l00498"></a>00498 
<a name="l00505"></a>00505   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#a2f0a90f17fba3db87f78f8813e111ac2">add_periodic_boundary</a> (<a class="code" href="classlibMesh_1_1PeriodicBoundary.php">PeriodicBoundary</a> * boundary, <a class="code" href="classlibMesh_1_1PeriodicBoundary.php">PeriodicBoundary</a> * inverse_boundary);
<a name="l00506"></a>00506 
<a name="l00511"></a>00511   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1DofMap.php#a342c83f2e41c2ea88ff60644aa7f90f2">is_periodic_boundary</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> boundaryid) <span class="keyword">const</span>;
<a name="l00512"></a>00512 
<a name="l00513"></a>00513 <span class="preprocessor">#endif // LIBMESH_ENABLE_PERIODIC</span>
<a name="l00514"></a>00514 <span class="preprocessor"></span>
<a name="l00515"></a>00515 
<a name="l00516"></a>00516 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00517"></a>00517 <span class="preprocessor"></span>
<a name="l00518"></a>00518   <span class="comment">//--------------------------------------------------------------------</span>
<a name="l00519"></a>00519   <span class="comment">// AMR-specific methods</span>
<a name="l00520"></a>00520 
<a name="l00529"></a>00529   <span class="comment">// void augment_send_list_for_projection(const MeshBase &amp;);</span>
<a name="l00530"></a>00530 
<a name="l00537"></a>00537   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#ae260ebddbb3c10a932ab9e16baa5bbb3">old_dof_indices</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <span class="keyword">const</span> elem,
<a name="l00538"></a>00538                         std::vector&lt;unsigned int&gt;&amp; di,
<a name="l00539"></a>00539                         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> vn = <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>) <span class="keyword">const</span>;
<a name="l00544"></a><a class="code" href="classlibMesh_1_1DofMap.php#aff4c82b145509c7cd1b60606fa10af1d">00544</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DofMap.php#aff4c82b145509c7cd1b60606fa10af1d">n_old_dofs</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1DofMap.php#a5e406923a04ca8cce5a0a73ebedaaa36">_n_old_dfs</a>; }
<a name="l00545"></a>00545 
<a name="l00551"></a>00551   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#a1c8e17a57f38de4ae0060311b5497989">constrain_p_dofs</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var,
<a name="l00552"></a>00552                          <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *elem,
<a name="l00553"></a>00553                          <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s,
<a name="l00554"></a>00554                          <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p);
<a name="l00555"></a>00555   
<a name="l00556"></a>00556 <span class="preprocessor">#endif // LIBMESH_ENABLE_AMR</span>
<a name="l00557"></a>00557 <span class="preprocessor"></span>
<a name="l00561"></a>00561   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#abf4ed8e608b51a7a4e95935bf42ebbb1">reinit</a> (<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>);
<a name="l00562"></a>00562   
<a name="l00566"></a>00566   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#a480f80bc9234a5586711833b87a89784">clear</a> ();
<a name="l00567"></a>00567   
<a name="l00581"></a><a class="code" href="classlibMesh_1_1DofMap.php#ab276e172c5488ab3b387b235e28556cf">00581</a>   <a class="code" href="classlibMesh_1_1CouplingMatrix.php">CouplingMatrix</a>* <a class="code" href="classlibMesh_1_1DofMap.php#ab276e172c5488ab3b387b235e28556cf">_dof_coupling</a>;
<a name="l00582"></a>00582 
<a name="l00583"></a>00583   
<a name="l00584"></a>00584 <span class="keyword">private</span>:
<a name="l00585"></a>00585   
<a name="l00589"></a>00589   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DofMap.php#a244e7a1cd82d5e6ae8780c93205ec1fa">sys_number</a>() <span class="keyword">const</span>;
<a name="l00590"></a>00590 
<a name="l00594"></a>00594   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#a9cbe9d7dc9f93f266817f997562bfa7c">invalidate_dofs</a>(<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>) <span class="keyword">const</span>;
<a name="l00595"></a>00595 
<a name="l00599"></a>00599   <a class="code" href="classlibMesh_1_1DofObject.php">DofObject</a>* <a class="code" href="classlibMesh_1_1DofMap.php#ab67f7b5505959af29c3aac5bbbb9e9d2">node_ptr</a>(<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00600"></a>00600 
<a name="l00604"></a>00604   <a class="code" href="classlibMesh_1_1DofObject.php">DofObject</a>* <a class="code" href="classlibMesh_1_1DofMap.php#ab6e5067ba73e4228bbd01956805af660">elem_ptr</a>(<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00605"></a>00605 
<a name="l00609"></a>00609   <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1DofObject.php">DofObject</a>* (<a class="code" href="classlibMesh_1_1DofMap.php">DofMap</a>::*<a class="code" href="classlibMesh_1_1DofMap.php#aaca0bd6cd27307340542eb58fe3de279">dofobject_accessor</a>)
<a name="l00610"></a><a class="code" href="classlibMesh_1_1DofMap.php#aaca0bd6cd27307340542eb58fe3de279">00610</a>     (<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00611"></a>00611   
<a name="l00615"></a>00615   <span class="keyword">template</span>&lt;<span class="keyword">typename</span> iterator_type&gt;
<a name="l00616"></a>00616   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#aafa42683c20195adafb582225eefd91c">set_nonlocal_dof_objects</a>(iterator_type objects_begin,
<a name="l00617"></a>00617                                 iterator_type objects_end,
<a name="l00618"></a>00618                                 <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp;mesh,
<a name="l00619"></a>00619                                 <a class="code" href="classlibMesh_1_1DofMap.php#aaca0bd6cd27307340542eb58fe3de279">dofobject_accessor</a> objects);
<a name="l00620"></a>00620 
<a name="l00629"></a>00629   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#a55f4e20c43c4d9b726702ece1c6b9cdc">distribute_local_dofs_var_major</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&amp; next_free_dof,
<a name="l00630"></a>00630                                         <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; mesh);
<a name="l00631"></a>00631   
<a name="l00644"></a>00644   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#ad4cb3d7c654bb942da7a99c5fc645a66">distribute_local_dofs_node_major</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&amp; next_free_dof,
<a name="l00645"></a>00645                                          <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; mesh);
<a name="l00646"></a>00646     
<a name="l00651"></a>00651   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#aed8eba054300e64164af4a8257bae8d8">add_neighbors_to_send_list</a>(<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; mesh);
<a name="l00652"></a>00652 
<a name="l00653"></a>00653 <span class="preprocessor">#if defined(LIBMESH_ENABLE_AMR) || defined(LIBMESH_ENABLE_PERIODIC)</span>
<a name="l00654"></a>00654 <span class="preprocessor"></span>
<a name="l00665"></a>00665   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#ab205c45f9397a3864d915a4bc558acbf">build_constraint_matrix</a> (<a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Number&gt;</a>&amp; C,
<a name="l00666"></a>00666                                 std::vector&lt;unsigned int&gt;&amp; elem_dofs,
<a name="l00667"></a>00667                                 <span class="keyword">const</span> <span class="keywordtype">bool</span> called_recursively=<span class="keyword">false</span>) <span class="keyword">const</span>;
<a name="l00668"></a>00668 
<a name="l00673"></a>00673   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#aeb1398dca8edb951fbd22762fedd0500">find_connected_dofs</a> (std::vector&lt;unsigned int&gt; &amp;elem_dofs) <span class="keyword">const</span>;
<a name="l00674"></a>00674   
<a name="l00680"></a>00680   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#a0783b9a05a297be8f1c3e630301e0604">add_constraints_to_send_list</a>();
<a name="l00681"></a>00681 
<a name="l00682"></a>00682 <span class="preprocessor">#endif</span>
<a name="l00683"></a>00683 <span class="preprocessor"></span>
<a name="l00684"></a>00684 
<a name="l00688"></a><a class="code" href="classlibMesh_1_1DofMap.php#a5232a8054e580a408f394ba1574c63df">00688</a>   std::vector&lt;Variable&gt; <a class="code" href="classlibMesh_1_1DofMap.php#a5232a8054e580a408f394ba1574c63df">_variables</a>;
<a name="l00689"></a>00689 
<a name="l00693"></a><a class="code" href="classlibMesh_1_1DofMap.php#a32b9faf7127f48555386705a952460d6">00693</a>   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DofMap.php#a32b9faf7127f48555386705a952460d6">_sys_number</a>;
<a name="l00694"></a>00694   
<a name="l00700"></a><a class="code" href="classlibMesh_1_1DofMap.php#a29ff2098ced1859cd5296af428435d73">00700</a>   std::vector&lt;SparseMatrix&lt;Number&gt;* &gt; <a class="code" href="classlibMesh_1_1DofMap.php#a29ff2098ced1859cd5296af428435d73">_matrices</a>;
<a name="l00701"></a>00701   
<a name="l00705"></a><a class="code" href="classlibMesh_1_1DofMap.php#a6a2cc4429bc1f9ec22b85dedbee55d96">00705</a>   std::vector&lt;unsigned int&gt; <a class="code" href="classlibMesh_1_1DofMap.php#a6a2cc4429bc1f9ec22b85dedbee55d96">_first_df</a>;
<a name="l00706"></a>00706 
<a name="l00710"></a><a class="code" href="classlibMesh_1_1DofMap.php#ab03f023f66c9d64feddada936ae18750">00710</a>   std::vector&lt;unsigned int&gt; <a class="code" href="classlibMesh_1_1DofMap.php#ab03f023f66c9d64feddada936ae18750">_end_df</a>;
<a name="l00711"></a>00711 
<a name="l00715"></a><a class="code" href="classlibMesh_1_1DofMap.php#ac2cd47f78f1cf8bbdba640f56ef96afa">00715</a>   std::vector&lt;unsigned int&gt; <a class="code" href="classlibMesh_1_1DofMap.php#ac2cd47f78f1cf8bbdba640f56ef96afa">_var_first_local_df</a>;
<a name="l00716"></a>00716   
<a name="l00721"></a><a class="code" href="classlibMesh_1_1DofMap.php#a66d63042b6f4dce2ef98a1573ff6b2ad">00721</a>   std::vector&lt;unsigned int&gt; <a class="code" href="classlibMesh_1_1DofMap.php#a66d63042b6f4dce2ef98a1573ff6b2ad">_send_list</a>;
<a name="l00722"></a>00722 
<a name="l00727"></a><a class="code" href="classlibMesh_1_1DofMap.php#a2f1f1ad0386f846409d903d5df18f114">00727</a>   std::vector&lt;unsigned int&gt; <a class="code" href="classlibMesh_1_1DofMap.php#a2f1f1ad0386f846409d903d5df18f114">_n_nz</a>;
<a name="l00728"></a>00728   
<a name="l00733"></a><a class="code" href="classlibMesh_1_1DofMap.php#a0b3879c0bf8ae122f12710bc32f17810">00733</a>   std::vector&lt;unsigned int&gt; <a class="code" href="classlibMesh_1_1DofMap.php#a0b3879c0bf8ae122f12710bc32f17810">_n_oz</a>;
<a name="l00734"></a>00734 
<a name="l00738"></a><a class="code" href="classlibMesh_1_1DofMap.php#a339dde44caf1af4d425d3830a20c7f54">00738</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DofMap.php#a339dde44caf1af4d425d3830a20c7f54">_n_dfs</a>;
<a name="l00739"></a>00739 
<a name="l00744"></a><a class="code" href="classlibMesh_1_1DofMap.php#ae4795cf1e08ba233dec67fe06b36873b">00744</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DofMap.php#ae4795cf1e08ba233dec67fe06b36873b">_n_SCALAR_dofs</a>;
<a name="l00745"></a>00745 
<a name="l00746"></a>00746 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00747"></a>00747 <span class="preprocessor"></span>
<a name="l00751"></a><a class="code" href="classlibMesh_1_1DofMap.php#a5e406923a04ca8cce5a0a73ebedaaa36">00751</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DofMap.php#a5e406923a04ca8cce5a0a73ebedaaa36">_n_old_dfs</a>;
<a name="l00752"></a>00752 
<a name="l00756"></a><a class="code" href="classlibMesh_1_1DofMap.php#abe4f7d1a32937bce6c6d8fc8b32ce0a2">00756</a>   std::vector&lt;unsigned int&gt; <a class="code" href="classlibMesh_1_1DofMap.php#abe4f7d1a32937bce6c6d8fc8b32ce0a2">_first_old_df</a>;
<a name="l00757"></a>00757 
<a name="l00761"></a><a class="code" href="classlibMesh_1_1DofMap.php#a5c01318c85ebe04282bdaf8dff4e3528">00761</a>   std::vector&lt;unsigned int&gt; <a class="code" href="classlibMesh_1_1DofMap.php#a5c01318c85ebe04282bdaf8dff4e3528">_end_old_df</a>;
<a name="l00762"></a>00762 
<a name="l00763"></a>00763 <span class="preprocessor">#endif</span>
<a name="l00764"></a>00764 <span class="preprocessor"></span>
<a name="l00765"></a>00765 <span class="preprocessor">#if defined(LIBMESH_ENABLE_AMR) || defined(LIBMESH_ENABLE_PERIODIC)</span>
<a name="l00766"></a>00766 <span class="preprocessor"></span>
<a name="l00771"></a><a class="code" href="classlibMesh_1_1DofMap.php#af7fe4d0cf13618e6dd04ff22fdaca0ba">00771</a>   <a class="code" href="classlibMesh_1_1DofConstraints.php">DofConstraints</a> <a class="code" href="classlibMesh_1_1DofMap.php#af7fe4d0cf13618e6dd04ff22fdaca0ba">_dof_constraints</a>;
<a name="l00772"></a>00772 
<a name="l00773"></a>00773 <span class="preprocessor">#endif</span>
<a name="l00774"></a>00774 <span class="preprocessor"></span>
<a name="l00775"></a>00775 
<a name="l00776"></a>00776 <span class="preprocessor">#ifdef LIBMESH_ENABLE_PERIODIC</span>
<a name="l00777"></a>00777 <span class="preprocessor"></span>
<a name="l00781"></a><a class="code" href="classlibMesh_1_1DofMap.php#aa6cb04933a25a9b2a296e333a7ce3554">00781</a>   <a class="code" href="classlibMesh_1_1PeriodicBoundaries.php">PeriodicBoundaries</a> *<a class="code" href="classlibMesh_1_1DofMap.php#aa6cb04933a25a9b2a296e333a7ce3554">_periodic_boundaries</a>;
<a name="l00782"></a>00782 <span class="preprocessor">#endif</span>
<a name="l00783"></a>00783 <span class="preprocessor"></span>
<a name="l00784"></a><a class="code" href="classlibMesh_1_1DofMap.php#a298e05b1935249e7045795d918f46d70">00784</a>   <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php">SparsityPattern::Build</a>;
<a name="l00785"></a>00785 };
<a name="l00786"></a>00786 
<a name="l00787"></a>00787 
<a name="l00788"></a>00788 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00789"></a>00789 <span class="comment">// Dof Map inline member functions</span>
<a name="l00790"></a>00790 
<a name="l00791"></a>00791 <span class="preprocessor">#if defined(LIBMESH_ENABLE_AMR) || defined(LIBMESH_ENABLE_PERIODIC)</span>
<a name="l00792"></a>00792 <span class="preprocessor"></span>
<a name="l00793"></a>00793 <span class="keyword">inline</span>
<a name="l00794"></a><a class="code" href="classlibMesh_1_1DofMap.php#af59487b50683e231676f836f94cde1ab">00794</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1DofMap.php#af59487b50683e231676f836f94cde1ab">DofMap::is_constrained_dof</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dof)<span class="keyword"> const</span>
<a name="l00795"></a>00795 <span class="keyword"></span>{
<a name="l00796"></a>00796   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1DofMap.php#af7fe4d0cf13618e6dd04ff22fdaca0ba">_dof_constraints</a>.count(dof) != 0)
<a name="l00797"></a>00797     <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00798"></a>00798 
<a name="l00799"></a>00799   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00800"></a>00800 }
<a name="l00801"></a>00801 
<a name="l00802"></a>00802 <span class="preprocessor">#endif</span>
<a name="l00803"></a>00803 <span class="preprocessor"></span>
<a name="l00804"></a>00804 
<a name="l00805"></a>00805 <span class="keyword">inline</span>
<a name="l00806"></a><a class="code" href="classlibMesh_1_1DofMap.php#a244e7a1cd82d5e6ae8780c93205ec1fa">00806</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DofMap.php#a244e7a1cd82d5e6ae8780c93205ec1fa">DofMap::sys_number</a>()<span class="keyword"> const</span>
<a name="l00807"></a>00807 <span class="keyword"></span>{
<a name="l00808"></a>00808   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1DofMap.php#a32b9faf7127f48555386705a952460d6">_sys_number</a>;
<a name="l00809"></a>00809 }
<a name="l00810"></a>00810 
<a name="l00811"></a>00811 
<a name="l00812"></a>00812 <span class="preprocessor">#if !defined(LIBMESH_ENABLE_AMR) &amp;&amp; !defined(LIBMESH_ENABLE_PERIODIC)</span>
<a name="l00813"></a>00813 <span class="preprocessor"></span>  <span class="comment">//--------------------------------------------------------------------</span>
<a name="l00814"></a>00814   <span class="comment">// Constraint-specific methods get inlined into nothing if</span>
<a name="l00815"></a>00815   <span class="comment">// constraints are disabled, so there&#39;s no reason for users not to </span>
<a name="l00816"></a>00816   <span class="comment">// use them.</span>
<a name="l00817"></a>00817 
<a name="l00818"></a>00818 <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#a426611c953c70989bc32a792e49c3450">DofMap::constrain_element_matrix</a> (<a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Number&gt;</a>&amp;,
<a name="l00819"></a>00819                                               std::vector&lt;unsigned int&gt;&amp;,
<a name="l00820"></a>00820                                               <span class="keywordtype">bool</span>)<span class="keyword"> const </span>{}
<a name="l00821"></a>00821   
<a name="l00822"></a>00822 <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#a426611c953c70989bc32a792e49c3450">DofMap::constrain_element_matrix</a> (DenseMatrix&lt;Number&gt;&amp;,
<a name="l00823"></a>00823                                               std::vector&lt;unsigned int&gt;&amp;,
<a name="l00824"></a>00824                                               std::vector&lt;unsigned int&gt;&amp;,
<a name="l00825"></a>00825                                               <span class="keywordtype">bool</span>)<span class="keyword"> const </span>{}
<a name="l00826"></a>00826   
<a name="l00827"></a>00827 <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#a29aba1bf008a1de4dd81a9a1b6f5ff41">DofMap::constrain_element_vector</a> (DenseVector&lt;Number&gt;&amp;,
<a name="l00828"></a>00828                                               std::vector&lt;unsigned int&gt;&amp;,
<a name="l00829"></a>00829                                               <span class="keywordtype">bool</span>)<span class="keyword"> const </span>{}
<a name="l00830"></a>00830   
<a name="l00831"></a>00831 <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#a97906aa49177873ed7ea9029dcb0cd4b">DofMap::constrain_element_matrix_and_vector</a> (DenseMatrix&lt;Number&gt;&amp;,
<a name="l00832"></a>00832                                                          DenseVector&lt;Number&gt;&amp;,
<a name="l00833"></a>00833                                                          std::vector&lt;unsigned int&gt;&amp;,
<a name="l00834"></a>00834                                                          <span class="keywordtype">bool</span>)<span class="keyword"> const </span>{}
<a name="l00835"></a>00835 
<a name="l00836"></a>00836 <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#ae5ccc5717b8c3a94629a306ebd4e1f17">DofMap::constrain_element_dyad_matrix</a> (DenseVector&lt;Number&gt;&amp;,
<a name="l00837"></a>00837                                                    DenseVector&lt;Number&gt;&amp;,
<a name="l00838"></a>00838                                                    std::vector&lt;unsigned int&gt;&amp;,
<a name="l00839"></a>00839                                                    <span class="keywordtype">bool</span>)<span class="keyword"> const </span>{}
<a name="l00840"></a>00840 
<a name="l00841"></a>00841 <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#a938f3e6db23b740002490ac88d1bb60a">DofMap::enforce_constraints_exactly</a> (<span class="keyword">const</span> System &amp;,
<a name="l00842"></a>00842                                                  NumericVector&lt;Number&gt; *)<span class="keyword"> const </span>{}
<a name="l00843"></a>00843 
<a name="l00844"></a>00844 <span class="preprocessor">#endif // !defined(LIBMESH_ENABLE_AMR) &amp;&amp; !defined(LIBMESH_ENABLE_PERIODIC)</span>
<a name="l00845"></a>00845 <span class="preprocessor"></span>
<a name="l00846"></a>00846 } <span class="comment">// namespace libMesh</span>
<a name="l00847"></a>00847 
<a name="l00848"></a>00848 <span class="preprocessor">#endif // __dof_map_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
