<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_c3a49989e40b21e7508f29d2dc962def.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_06ddb1cadc4da963b880c5e33d5e51d4.php">base</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">dof_map_constraints.C</div>  </div>
</div>
<div class="contents">
<a href="dof__map__constraints_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id$</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="comment">// C++ Includes -------------------------------------</span>
<a name="l00021"></a>00021 <span class="preprocessor">#include &lt;set&gt;</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &lt;algorithm&gt;</span> <span class="comment">// for std::count, std::fill</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="comment">// Local Includes -----------------------------------</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="dof__map_8h.php">dof_map.h</a>&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="elem_8h.php">elem.h</a>&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="mesh__base_8h.php">mesh_base.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="fe__interface_8h.php">fe_interface.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="fe__type_8h.php">fe_type.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="dense__matrix_8h.php">dense_matrix.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="dense__vector_8h.php">dense_vector.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__logging_8h.php">libmesh_logging.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="system_8h.php">system.h</a>&quot;</span> <span class="comment">// needed by enforce_constraints_exactly()</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="numeric__vector_8h.php">numeric_vector.h</a>&quot;</span> <span class="comment">// likewise</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="parallel_8h.php">parallel.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="periodic__boundaries_8h.php">periodic_boundaries.h</a>&quot;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;<a class="code" href="point__locator__base_8h.php">point_locator_base.h</a>&quot;</span>
<a name="l00038"></a>00038 <span class="preprocessor">#include &quot;<a class="code" href="elem__range_8h.php">elem_range.h</a>&quot;</span>
<a name="l00039"></a>00039 <span class="preprocessor">#include &quot;<a class="code" href="threads_8h.php">threads.h</a>&quot;</span>
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 <span class="comment">// Anonymous namespace to hold helper classes</span>
<a name="l00044"></a>00044 <span class="keyword">namespace </span>{
<a name="l00045"></a>00045 
<a name="l00046"></a>00046 <span class="keyword">using namespace </span>libMesh;
<a name="l00047"></a>00047 
<a name="l00048"></a>00048   <span class="keyword">class </span>ComputeConstraints
<a name="l00049"></a>00049   {
<a name="l00050"></a>00050   <span class="keyword">public</span>:
<a name="l00051"></a>00051     ComputeConstraints (<a class="code" href="classlibMesh_1_1DofConstraints.php">DofConstraints</a> &amp;constraints,
<a name="l00052"></a>00052                         <a class="code" href="classlibMesh_1_1DofMap.php">DofMap</a> &amp;dof_map,
<a name="l00053"></a>00053 #ifdef LIBMESH_ENABLE_PERIODIC
<a name="l00054"></a>00054                         <a class="code" href="classlibMesh_1_1PeriodicBoundaries.php">PeriodicBoundaries</a> &amp;periodic_boundaries,
<a name="l00055"></a>00055 #endif
<a name="l00056"></a>00056                         <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp;<a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>,
<a name="l00057"></a>00057                         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> variable_number) :
<a name="l00058"></a>00058       _constraints(constraints),
<a name="l00059"></a>00059       _dof_map(dof_map),
<a name="l00060"></a>00060 #ifdef LIBMESH_ENABLE_PERIODIC
<a name="l00061"></a>00061       _periodic_boundaries(periodic_boundaries),
<a name="l00062"></a>00062 #endif
<a name="l00063"></a>00063       _mesh(mesh),
<a name="l00064"></a>00064       _variable_number(variable_number)
<a name="l00065"></a>00065     {}
<a name="l00066"></a>00066 
<a name="l00067"></a>00067     <span class="keywordtype">void</span> operator()(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1StoredRange.php">ConstElemRange</a> &amp;range)<span class="keyword"> const</span>
<a name="l00068"></a>00068 <span class="keyword">    </span>{
<a name="l00069"></a>00069       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Variable.php">Variable</a> &amp;var_description = _dof_map.variable(_variable_number);
<a name="l00070"></a>00070 
<a name="l00071"></a>00071       <span class="keywordflow">for</span> (<a class="code" href="classlibMesh_1_1StoredRange.php#a07c6e88eede585628af3437d8cad903f">ConstElemRange::const_iterator</a> it = range.<a class="code" href="classlibMesh_1_1StoredRange.php#a9687da8abb136c142c4df14f4444737b">begin</a>(); it!=range.<a class="code" href="classlibMesh_1_1StoredRange.php#aff337b550b3349015980e791dd982b21">end</a>(); ++it)
<a name="l00072"></a>00072         <span class="keywordflow">if</span> (var_description.<a class="code" href="classlibMesh_1_1Variable.php#a94ff035823801db20635514405af60be">active_on_subdomain</a>((*it)-&gt;subdomain_id()))
<a name="l00073"></a>00073           {
<a name="l00074"></a>00074 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00075"></a>00075 <span class="preprocessor"></span>            FEInterface::compute_constraints (_constraints,
<a name="l00076"></a>00076                                               _dof_map,
<a name="l00077"></a>00077                                               _variable_number,
<a name="l00078"></a>00078                                               *it);
<a name="l00079"></a>00079 <span class="preprocessor">#endif</span>
<a name="l00080"></a>00080 <span class="preprocessor"></span><span class="preprocessor">#ifdef LIBMESH_ENABLE_PERIODIC</span>
<a name="l00081"></a>00081 <span class="preprocessor"></span>            <span class="comment">// FIXME: periodic constraints won&#39;t work on a non-serial</span>
<a name="l00082"></a>00082             <span class="comment">// mesh unless it&#39;s kept ghost elements from opposing</span>
<a name="l00083"></a>00083             <span class="comment">// boundaries!</span>
<a name="l00084"></a>00084             FEInterface::compute_periodic_constraints (_constraints,
<a name="l00085"></a>00085                                                        _dof_map,
<a name="l00086"></a>00086                                                        _periodic_boundaries,
<a name="l00087"></a>00087                                                        _mesh,
<a name="l00088"></a>00088                                                        _variable_number,
<a name="l00089"></a>00089                                                        *it);
<a name="l00090"></a>00090 <span class="preprocessor">#endif</span>
<a name="l00091"></a>00091 <span class="preprocessor"></span>          }
<a name="l00092"></a>00092     }
<a name="l00093"></a>00093     
<a name="l00094"></a>00094   <span class="keyword">private</span>:
<a name="l00095"></a>00095     <a class="code" href="classlibMesh_1_1DofConstraints.php">DofConstraints</a> &amp;_constraints;
<a name="l00096"></a>00096     <a class="code" href="classlibMesh_1_1DofMap.php">DofMap</a> &amp;_dof_map;
<a name="l00097"></a>00097 <span class="preprocessor">#ifdef LIBMESH_ENABLE_PERIODIC</span>
<a name="l00098"></a>00098 <span class="preprocessor"></span>    <a class="code" href="classlibMesh_1_1PeriodicBoundaries.php">PeriodicBoundaries</a> &amp;_periodic_boundaries;
<a name="l00099"></a>00099 <span class="preprocessor">#endif</span>
<a name="l00100"></a>00100 <span class="preprocessor"></span>    <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp;_mesh;
<a name="l00101"></a>00101     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> _variable_number;    
<a name="l00102"></a>00102   };
<a name="l00103"></a>00103 }
<a name="l00104"></a>00104 
<a name="l00105"></a>00105 
<a name="l00106"></a>00106 
<a name="l00107"></a>00107 <span class="keyword">namespace </span>libMesh
<a name="l00108"></a>00108 {
<a name="l00109"></a>00109 
<a name="l00110"></a>00110 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00111"></a>00111 <span class="comment">// DofMap member functions</span>
<a name="l00112"></a>00112 
<a name="l00113"></a>00113 <span class="preprocessor">#if defined(LIBMESH_ENABLE_AMR) || defined(LIBMESH_ENABLE_PERIODIC)</span>
<a name="l00114"></a>00114 <span class="preprocessor"></span>
<a name="l00115"></a><a class="code" href="classlibMesh_1_1DofMap.php#a4dc67be5bbecf0e4947d790f6653e2d5">00115</a> <span class="keywordtype">void</span> DofMap::create_dof_constraints(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>)
<a name="l00116"></a>00116 {
<a name="l00117"></a>00117   START_LOG(<span class="stringliteral">&quot;create_dof_constraints()&quot;</span>, <span class="stringliteral">&quot;DofMap&quot;</span>);
<a name="l00118"></a>00118 
<a name="l00119"></a>00119   libmesh_assert (mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aef78858f228f672f3587b19c2bbd5fce">is_prepared</a>());
<a name="l00120"></a>00120   
<a name="l00121"></a>00121   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1bc787d29f4c496f107aed988be4b9bf">mesh_dimension</a>();
<a name="l00122"></a>00122 
<a name="l00123"></a>00123   <span class="comment">// Constraints are not necessary in 1D</span>
<a name="l00124"></a>00124   <span class="keywordflow">if</span> (dim == 1)
<a name="l00125"></a>00125   {
<a name="l00126"></a>00126     <span class="comment">// make sure we stop logging though</span>
<a name="l00127"></a>00127     STOP_LOG(<span class="stringliteral">&quot;create_dof_constraints()&quot;</span>, <span class="stringliteral">&quot;DofMap&quot;</span>);
<a name="l00128"></a>00128     <span class="keywordflow">return</span>;
<a name="l00129"></a>00129   }
<a name="l00130"></a>00130   
<a name="l00131"></a>00131   <span class="comment">// Here we build the hanging node constraints.  This is done</span>
<a name="l00132"></a>00132   <span class="comment">// by enforcing the condition u_a = u_b along hanging sides.</span>
<a name="l00133"></a>00133   <span class="comment">// u_a = u_b is collocated at the nodes of side a, which gives</span>
<a name="l00134"></a>00134   <span class="comment">// one row of the constraint matrix.</span>
<a name="l00135"></a>00135   
<a name="l00136"></a>00136   <span class="comment">// clear any existing constraints.</span>
<a name="l00137"></a>00137   _dof_constraints.clear();
<a name="l00138"></a>00138 
<a name="l00139"></a>00139   <span class="comment">// define the range of elements of interest</span>
<a name="l00140"></a>00140   <a class="code" href="classlibMesh_1_1StoredRange.php">ConstElemRange</a> range;
<a name="l00141"></a>00141   {
<a name="l00142"></a>00142     <span class="comment">// With SerialMesh or a serial ParallelMesh, every processor</span>
<a name="l00143"></a>00143     <span class="comment">// computes every constraint</span>
<a name="l00144"></a>00144     <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>
<a name="l00145"></a>00145       elem_begin = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac266e1f5eb6ac9566ccbd7e6add6c239">elements_begin</a>(),
<a name="l00146"></a>00146       elem_end   = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ae94f1bce0dc50c489c6bae9ba64d06e8">elements_end</a>();
<a name="l00147"></a>00147     
<a name="l00148"></a>00148     <span class="comment">// With a parallel ParallelMesh, processors compute only</span>
<a name="l00149"></a>00149     <span class="comment">// their local constraints</span>
<a name="l00150"></a>00150     <span class="keywordflow">if</span> (!mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a3c7d22fed3feea4c9ebd1fb41e7dbb4f">is_serial</a>())
<a name="l00151"></a>00151       {
<a name="l00152"></a>00152         elem_begin = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a5b67c2aa94e76310a6db3470cce8ef11">local_elements_begin</a>();
<a name="l00153"></a>00153         elem_end   = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ab8bd839216a1ef9c0912d523b68ae136">local_elements_end</a>(); 
<a name="l00154"></a>00154       }
<a name="l00155"></a>00155 
<a name="l00156"></a>00156     <span class="comment">// set the range to contain the specified elements</span>
<a name="l00157"></a>00157     range.<a class="code" href="classlibMesh_1_1StoredRange.php#a6769bcd5b501cb9a10cdbc85c64a2e72">reset</a> (elem_begin, elem_end);
<a name="l00158"></a>00158   }
<a name="l00159"></a>00159 
<a name="l00160"></a>00160   <span class="comment">// compute_periodic_constraints requires a point_locator() from our</span>
<a name="l00161"></a>00161   <span class="comment">// Mesh, that point_locator() construction is threaded.  Rather than</span>
<a name="l00162"></a>00162   <span class="comment">// nest threads within threads we&#39;ll make sure it&#39;s preconstructed.</span>
<a name="l00163"></a>00163 <span class="preprocessor">#ifdef LIBMESH_ENABLE_PERIODIC</span>
<a name="l00164"></a>00164 <span class="preprocessor"></span>  <span class="keywordflow">if</span> (!_periodic_boundaries-&gt;empty())
<a name="l00165"></a>00165     mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a122877d5316f9035967c6ed10d86a520">point_locator</a>();
<a name="l00166"></a>00166 <span class="preprocessor">#endif</span>
<a name="l00167"></a>00167 <span class="preprocessor"></span>  
<a name="l00168"></a>00168   <span class="comment">// Look at all the variables in the system.  Reset the element</span>
<a name="l00169"></a>00169   <span class="comment">// range at each iteration -- there is no need to reconstruct it.</span>
<a name="l00170"></a>00170   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> variable_number=0; variable_number&lt;this-&gt;n_variables();
<a name="l00171"></a>00171        ++variable_number, range.<a class="code" href="classlibMesh_1_1StoredRange.php#a6769bcd5b501cb9a10cdbc85c64a2e72">reset</a>())
<a name="l00172"></a>00172     <a class="code" href="namespacelibMesh_1_1Threads.php#a0a6259585412504a211d6d022b196221">Threads::parallel_for</a> (range,
<a name="l00173"></a>00173                            ComputeConstraints (_dof_constraints,
<a name="l00174"></a>00174                                                *<span class="keyword">this</span>,
<a name="l00175"></a>00175 #ifdef LIBMESH_ENABLE_PERIODIC
<a name="l00176"></a>00176                                                *_periodic_boundaries,
<a name="l00177"></a>00177 #endif
<a name="l00178"></a>00178                                                mesh,
<a name="l00179"></a>00179                                                variable_number));
<a name="l00180"></a>00180 
<a name="l00181"></a>00181   <span class="comment">// With a parallelized Mesh, we&#39;ve computed our local constraints,</span>
<a name="l00182"></a>00182   <span class="comment">// but they may depend on non-local constraints that we&#39;ll need to</span>
<a name="l00183"></a>00183   <span class="comment">// take into account.</span>
<a name="l00184"></a>00184   <span class="keywordflow">if</span> (!mesh.is_serial())
<a name="l00185"></a>00185     this-&gt;allgather_recursive_constraints();
<a name="l00186"></a>00186   
<a name="l00187"></a>00187   STOP_LOG(<span class="stringliteral">&quot;create_dof_constraints()&quot;</span>, <span class="stringliteral">&quot;DofMap&quot;</span>);
<a name="l00188"></a>00188 }
<a name="l00189"></a>00189 
<a name="l00190"></a>00190 
<a name="l00191"></a>00191 
<a name="l00192"></a><a class="code" href="classlibMesh_1_1DofMap.php#ab49ad674c1ea5fd71d968d84db954739">00192</a> <span class="keywordtype">void</span> DofMap::add_constraint_row (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dof_number,
<a name="l00193"></a>00193                                  <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#a919b3727a9707f23ecad00949d1d1c43">DofConstraintRow</a>&amp; constraint_row,
<a name="l00194"></a>00194                                  <span class="keyword">const</span> <span class="keywordtype">bool</span> forbid_constraint_overwrite)
<a name="l00195"></a>00195 {
<a name="l00196"></a>00196   <span class="comment">// Optionally allow the user to overwrite constraints.  Defaults to false.</span>
<a name="l00197"></a>00197   <span class="keywordflow">if</span> (forbid_constraint_overwrite)
<a name="l00198"></a>00198     <span class="keywordflow">if</span> (this-&gt;is_constrained_dof(dof_number))
<a name="l00199"></a>00199       {
<a name="l00200"></a>00200         <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: DOF &quot;</span> &lt;&lt; dof_number &lt;&lt; <span class="stringliteral">&quot; was already constrained!&quot;</span>
<a name="l00201"></a>00201                       &lt;&lt; std::endl;
<a name="l00202"></a>00202         libmesh_error();
<a name="l00203"></a>00203       }
<a name="l00204"></a>00204   
<a name="l00205"></a>00205   std::pair&lt;unsigned int, DofConstraintRow&gt; kv(dof_number, constraint_row);
<a name="l00206"></a>00206 
<a name="l00207"></a>00207   _dof_constraints.insert(kv);
<a name="l00208"></a>00208 }
<a name="l00209"></a>00209 
<a name="l00210"></a>00210 
<a name="l00211"></a>00211 
<a name="l00212"></a><a class="code" href="classlibMesh_1_1DofMap.php#a9c8aef879917dfdd8a9309b7e29ed9d3">00212</a> <span class="keywordtype">void</span> DofMap::print_dof_constraints(std::ostream&amp; os)<span class="keyword"> const</span>
<a name="l00213"></a>00213 <span class="keyword"></span>{
<a name="l00214"></a>00214   os &lt;&lt; <span class="stringliteral">&quot;DOF CONSTRAINTS OUTPUT:&quot;</span>
<a name="l00215"></a>00215      &lt;&lt; std::endl;
<a name="l00216"></a>00216   
<a name="l00217"></a>00217   <span class="keywordflow">for</span> (DofConstraints::const_iterator it=_dof_constraints.begin();
<a name="l00218"></a>00218        it != _dof_constraints.end(); ++it)
<a name="l00219"></a>00219     {
<a name="l00220"></a>00220       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = it-&gt;first;
<a name="l00221"></a>00221       <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#a919b3727a9707f23ecad00949d1d1c43">DofConstraintRow</a>&amp; row = it-&gt;second;
<a name="l00222"></a>00222 
<a name="l00223"></a>00223       os &lt;&lt; <span class="stringliteral">&quot;Constraints for DOF &quot;</span> &lt;&lt; i
<a name="l00224"></a>00224          &lt;&lt; <span class="stringliteral">&quot;: \t&quot;</span>;
<a name="l00225"></a>00225 
<a name="l00226"></a>00226       <span class="keywordflow">for</span> (DofConstraintRow::const_iterator pos=row.begin();
<a name="l00227"></a>00227            pos != row.end(); ++pos)
<a name="l00228"></a>00228         os &lt;&lt; <span class="stringliteral">&quot; (&quot;</span> &lt;&lt; pos-&gt;first &lt;&lt; <span class="stringliteral">&quot;,&quot;</span>
<a name="l00229"></a>00229            &lt;&lt; pos-&gt;second &lt;&lt; <span class="stringliteral">&quot;)\t&quot;</span>;
<a name="l00230"></a>00230 
<a name="l00231"></a>00231       os &lt;&lt; std::endl;
<a name="l00232"></a>00232     }
<a name="l00233"></a>00233 }
<a name="l00234"></a>00234 
<a name="l00235"></a>00235 
<a name="l00236"></a>00236 
<a name="l00237"></a><a class="code" href="classlibMesh_1_1DofMap.php#a426611c953c70989bc32a792e49c3450">00237</a> <span class="keywordtype">void</span> DofMap::constrain_element_matrix (<a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Number&gt;</a>&amp; matrix,
<a name="l00238"></a>00238                                        std::vector&lt;unsigned int&gt;&amp; elem_dofs,
<a name="l00239"></a>00239                                        <span class="keywordtype">bool</span> asymmetric_constraint_rows)<span class="keyword"> const</span>
<a name="l00240"></a>00240 <span class="keyword"></span>{
<a name="l00241"></a>00241   libmesh_assert (elem_dofs.size() == matrix.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a68bd665fb9252382cc9a28df4099d76a">m</a>());
<a name="l00242"></a>00242   libmesh_assert (elem_dofs.size() == matrix.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a4fb8c524109fd5dff8c98855437544ee">n</a>());
<a name="l00243"></a>00243 
<a name="l00244"></a>00244   <span class="comment">// check for easy return</span>
<a name="l00245"></a>00245   <span class="keywordflow">if</span> (this-&gt;n_constrained_dofs() == 0)
<a name="l00246"></a>00246     <span class="keywordflow">return</span>;
<a name="l00247"></a>00247     
<a name="l00248"></a>00248   <span class="comment">// The constrained matrix is built up as C^T K C.    </span>
<a name="l00249"></a>00249   <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Number&gt;</a> C;
<a name="l00250"></a>00250 
<a name="l00251"></a>00251   
<a name="l00252"></a>00252   this-&gt;build_constraint_matrix (C, elem_dofs);
<a name="l00253"></a>00253 
<a name="l00254"></a>00254   START_LOG(<span class="stringliteral">&quot;constrain_elem_matrix()&quot;</span>, <span class="stringliteral">&quot;DofMap&quot;</span>);
<a name="l00255"></a>00255   
<a name="l00256"></a>00256   <span class="comment">// It is possible that the matrix is not constrained at all.</span>
<a name="l00257"></a>00257   <span class="keywordflow">if</span> ((C.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a68bd665fb9252382cc9a28df4099d76a">m</a>() == matrix.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a68bd665fb9252382cc9a28df4099d76a">m</a>()) &amp;&amp;
<a name="l00258"></a>00258       (C.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a4fb8c524109fd5dff8c98855437544ee">n</a>() == elem_dofs.size())) <span class="comment">// It the matrix is constrained</span>
<a name="l00259"></a>00259     {
<a name="l00260"></a>00260       <span class="comment">// Compute the matrix-matrix-matrix product C^T K C</span>
<a name="l00261"></a>00261       matrix.<a class="code" href="classlibMesh_1_1DenseMatrix.php#aea84b08f2ffc1a36a5a87969287ac865">left_multiply_transpose</a>  (C);
<a name="l00262"></a>00262       matrix.<a class="code" href="classlibMesh_1_1DenseMatrix.php#a9cb161155585b412f27e6bf8103d6d48">right_multiply</a> (C);
<a name="l00263"></a>00263       
<a name="l00264"></a>00264       
<a name="l00265"></a>00265       libmesh_assert (matrix.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a68bd665fb9252382cc9a28df4099d76a">m</a>() == matrix.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a4fb8c524109fd5dff8c98855437544ee">n</a>());
<a name="l00266"></a>00266       libmesh_assert (matrix.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a68bd665fb9252382cc9a28df4099d76a">m</a>() == elem_dofs.size());
<a name="l00267"></a>00267       libmesh_assert (matrix.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a4fb8c524109fd5dff8c98855437544ee">n</a>() == elem_dofs.size());
<a name="l00268"></a>00268       
<a name="l00269"></a>00269       
<a name="l00270"></a>00270       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;elem_dofs.size(); i++)
<a name="l00271"></a>00271         <span class="comment">// If the DOF is constrained</span>
<a name="l00272"></a>00272         <span class="keywordflow">if</span> (this-&gt;is_constrained_dof(elem_dofs[i]))
<a name="l00273"></a>00273           {
<a name="l00274"></a>00274             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;matrix.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a4fb8c524109fd5dff8c98855437544ee">n</a>(); j++)
<a name="l00275"></a>00275               matrix(i,j) = 0.;
<a name="l00276"></a>00276             
<a name="l00277"></a>00277             matrix(i,i) = 1.;
<a name="l00278"></a>00278             
<a name="l00279"></a>00279             <span class="keywordflow">if</span> (asymmetric_constraint_rows)
<a name="l00280"></a>00280               {
<a name="l00281"></a>00281                 DofConstraints::const_iterator
<a name="l00282"></a>00282                   pos = _dof_constraints.find(elem_dofs[i]);
<a name="l00283"></a>00283             
<a name="l00284"></a>00284                 libmesh_assert (pos != _dof_constraints.end());
<a name="l00285"></a>00285             
<a name="l00286"></a>00286                 <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#a919b3727a9707f23ecad00949d1d1c43">DofConstraintRow</a>&amp; constraint_row = pos-&gt;second;
<a name="l00287"></a>00287             
<a name="l00288"></a>00288                 libmesh_assert (!constraint_row.empty());
<a name="l00289"></a>00289             
<a name="l00290"></a>00290                 <span class="keywordflow">for</span> (DofConstraintRow::const_iterator
<a name="l00291"></a>00291                        it=constraint_row.begin(); it != constraint_row.end();
<a name="l00292"></a>00292                      ++it)
<a name="l00293"></a>00293                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;elem_dofs.size(); j++)
<a name="l00294"></a>00294                     <span class="keywordflow">if</span> (elem_dofs[j] == it-&gt;first)
<a name="l00295"></a>00295                       matrix(i,j) = -it-&gt;second;        
<a name="l00296"></a>00296               }
<a name="l00297"></a>00297           }
<a name="l00298"></a>00298     } <span class="comment">// end if is constrained...</span>
<a name="l00299"></a>00299   
<a name="l00300"></a>00300   STOP_LOG(<span class="stringliteral">&quot;constrain_elem_matrix()&quot;</span>, <span class="stringliteral">&quot;DofMap&quot;</span>);  
<a name="l00301"></a>00301 }
<a name="l00302"></a>00302 
<a name="l00303"></a>00303 
<a name="l00304"></a>00304 
<a name="l00305"></a><a class="code" href="classlibMesh_1_1DofMap.php#a97906aa49177873ed7ea9029dcb0cd4b">00305</a> <span class="keywordtype">void</span> DofMap::constrain_element_matrix_and_vector (<a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Number&gt;</a>&amp; matrix,
<a name="l00306"></a>00306                                                   <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a>&amp; rhs,
<a name="l00307"></a>00307                                                   std::vector&lt;unsigned int&gt;&amp; elem_dofs,
<a name="l00308"></a>00308                                                   <span class="keywordtype">bool</span> asymmetric_constraint_rows)<span class="keyword"> const</span>
<a name="l00309"></a>00309 <span class="keyword"></span>{
<a name="l00310"></a>00310   libmesh_assert (elem_dofs.size() == matrix.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a68bd665fb9252382cc9a28df4099d76a">m</a>());
<a name="l00311"></a>00311   libmesh_assert (elem_dofs.size() == matrix.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a4fb8c524109fd5dff8c98855437544ee">n</a>());
<a name="l00312"></a>00312   libmesh_assert (elem_dofs.size() == rhs.<a class="code" href="classlibMesh_1_1DenseVector.php#ab124ecf2f46ee43b167f093b05d81fdb">size</a>());
<a name="l00313"></a>00313 
<a name="l00314"></a>00314   <span class="comment">// check for easy return</span>
<a name="l00315"></a>00315   <span class="keywordflow">if</span> (this-&gt;n_constrained_dofs() == 0)
<a name="l00316"></a>00316     <span class="keywordflow">return</span>;
<a name="l00317"></a>00317   
<a name="l00318"></a>00318   <span class="comment">// The constrained matrix is built up as C^T K C.</span>
<a name="l00319"></a>00319   <span class="comment">// The constrained RHS is built up as C^T F</span>
<a name="l00320"></a>00320   <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Number&gt;</a> C;
<a name="l00321"></a>00321   
<a name="l00322"></a>00322   this-&gt;build_constraint_matrix (C, elem_dofs);
<a name="l00323"></a>00323   
<a name="l00324"></a>00324   START_LOG(<span class="stringliteral">&quot;cnstrn_elem_mat_vec()&quot;</span>, <span class="stringliteral">&quot;DofMap&quot;</span>);
<a name="l00325"></a>00325   
<a name="l00326"></a>00326   <span class="comment">// It is possible that the matrix is not constrained at all.</span>
<a name="l00327"></a>00327   <span class="keywordflow">if</span> ((C.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a68bd665fb9252382cc9a28df4099d76a">m</a>() == matrix.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a68bd665fb9252382cc9a28df4099d76a">m</a>()) &amp;&amp;
<a name="l00328"></a>00328       (C.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a4fb8c524109fd5dff8c98855437544ee">n</a>() == elem_dofs.size())) <span class="comment">// It the matrix is constrained</span>
<a name="l00329"></a>00329     {
<a name="l00330"></a>00330       <span class="comment">// Compute the matrix-matrix-matrix product C^T K C</span>
<a name="l00331"></a>00331       matrix.<a class="code" href="classlibMesh_1_1DenseMatrix.php#aea84b08f2ffc1a36a5a87969287ac865">left_multiply_transpose</a>  (C);
<a name="l00332"></a>00332       matrix.<a class="code" href="classlibMesh_1_1DenseMatrix.php#a9cb161155585b412f27e6bf8103d6d48">right_multiply</a> (C);
<a name="l00333"></a>00333       
<a name="l00334"></a>00334       
<a name="l00335"></a>00335       libmesh_assert (matrix.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a68bd665fb9252382cc9a28df4099d76a">m</a>() == matrix.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a4fb8c524109fd5dff8c98855437544ee">n</a>());
<a name="l00336"></a>00336       libmesh_assert (matrix.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a68bd665fb9252382cc9a28df4099d76a">m</a>() == elem_dofs.size());
<a name="l00337"></a>00337       libmesh_assert (matrix.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a4fb8c524109fd5dff8c98855437544ee">n</a>() == elem_dofs.size());
<a name="l00338"></a>00338       
<a name="l00339"></a>00339 
<a name="l00340"></a>00340       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;elem_dofs.size(); i++)
<a name="l00341"></a>00341         <span class="keywordflow">if</span> (this-&gt;is_constrained_dof(elem_dofs[i]))
<a name="l00342"></a>00342           {
<a name="l00343"></a>00343             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;matrix.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a4fb8c524109fd5dff8c98855437544ee">n</a>(); j++)
<a name="l00344"></a>00344               matrix(i,j) = 0.;
<a name="l00345"></a>00345             
<a name="l00346"></a>00346             <span class="comment">// If the DOF is constrained</span>
<a name="l00347"></a>00347             matrix(i,i) = 1.;
<a name="l00348"></a>00348             
<a name="l00349"></a>00349             <span class="comment">// This will put a nonsymmetric entry in the constraint</span>
<a name="l00350"></a>00350             <span class="comment">// row to ensure that the linear system produces the</span>
<a name="l00351"></a>00351             <span class="comment">// correct value for the constrained DOF.</span>
<a name="l00352"></a>00352             <span class="keywordflow">if</span> (asymmetric_constraint_rows)
<a name="l00353"></a>00353               {
<a name="l00354"></a>00354                 DofConstraints::const_iterator
<a name="l00355"></a>00355                   pos = _dof_constraints.find(elem_dofs[i]);
<a name="l00356"></a>00356             
<a name="l00357"></a>00357                 libmesh_assert (pos != _dof_constraints.end());
<a name="l00358"></a>00358             
<a name="l00359"></a>00359                 <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#a919b3727a9707f23ecad00949d1d1c43">DofConstraintRow</a>&amp; constraint_row = pos-&gt;second;
<a name="l00360"></a>00360             
<a name="l00361"></a>00361 <span class="comment">// p refinement creates empty constraint rows</span>
<a name="l00362"></a>00362 <span class="comment">//          libmesh_assert (!constraint_row.empty());</span>
<a name="l00363"></a>00363             
<a name="l00364"></a>00364                 <span class="keywordflow">for</span> (DofConstraintRow::const_iterator
<a name="l00365"></a>00365                        it=constraint_row.begin(); it != constraint_row.end();
<a name="l00366"></a>00366                      ++it)
<a name="l00367"></a>00367                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;elem_dofs.size(); j++)
<a name="l00368"></a>00368                     <span class="keywordflow">if</span> (elem_dofs[j] == it-&gt;first)
<a name="l00369"></a>00369                       matrix(i,j) = -it-&gt;second;        
<a name="l00370"></a>00370               }
<a name="l00371"></a>00371           }
<a name="l00372"></a>00372 
<a name="l00373"></a>00373       
<a name="l00374"></a>00374       <span class="comment">// Compute the matrix-vector product C^T F</span>
<a name="l00375"></a>00375       <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> old_rhs(rhs);
<a name="l00376"></a>00376 
<a name="l00377"></a>00377       <span class="comment">// resize the RHS vector &amp; 0 before summation</span>
<a name="l00378"></a>00378       rhs.<a class="code" href="classlibMesh_1_1DenseVector.php#a08430ae781094632e8272cbb825d4f44">resize</a>(elem_dofs.size());
<a name="l00379"></a>00379       rhs.<a class="code" href="classlibMesh_1_1DenseVector.php#a23868ec54dca234e5893e41a8b510d68">zero</a>();
<a name="l00380"></a>00380       
<a name="l00381"></a>00381       <span class="comment">// compute matrix/vector product</span>
<a name="l00382"></a>00382       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;elem_dofs.size(); i++)
<a name="l00383"></a>00383         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;old_rhs.<a class="code" href="classlibMesh_1_1DenseVector.php#ab124ecf2f46ee43b167f093b05d81fdb">size</a>(); j++)
<a name="l00384"></a>00384           rhs(i) += C.<a class="code" href="classlibMesh_1_1DenseMatrix.php#a8f1a04ca0780c6327443862cae23f1d3">transpose</a>(i,j)*old_rhs(j);
<a name="l00385"></a>00385         
<a name="l00386"></a>00386 
<a name="l00387"></a>00387       libmesh_assert (elem_dofs.size() == rhs.<a class="code" href="classlibMesh_1_1DenseVector.php#ab124ecf2f46ee43b167f093b05d81fdb">size</a>());
<a name="l00388"></a>00388 
<a name="l00389"></a>00389       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;elem_dofs.size(); i++)
<a name="l00390"></a>00390         <span class="keywordflow">if</span> (this-&gt;is_constrained_dof(elem_dofs[i]))
<a name="l00391"></a>00391           {     
<a name="l00392"></a>00392             <span class="comment">// If the DOF is constrained</span>
<a name="l00393"></a>00393             rhs(i) = 0.;
<a name="l00394"></a>00394           }
<a name="l00395"></a>00395     } <span class="comment">// end if is constrained...</span>
<a name="l00396"></a>00396   
<a name="l00397"></a>00397   STOP_LOG(<span class="stringliteral">&quot;cnstrn_elem_mat_vec()&quot;</span>, <span class="stringliteral">&quot;DofMap&quot;</span>);  
<a name="l00398"></a>00398 }
<a name="l00399"></a>00399 
<a name="l00400"></a>00400 
<a name="l00401"></a>00401 
<a name="l00402"></a><a class="code" href="classlibMesh_1_1DofMap.php#adeaa5c51453a3de59f146452771c4e19">00402</a> <span class="keywordtype">void</span> DofMap::constrain_element_matrix (<a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Number&gt;</a>&amp; matrix,
<a name="l00403"></a>00403                                        std::vector&lt;unsigned int&gt;&amp; row_dofs,
<a name="l00404"></a>00404                                        std::vector&lt;unsigned int&gt;&amp; col_dofs,
<a name="l00405"></a>00405                                        <span class="keywordtype">bool</span> asymmetric_constraint_rows)<span class="keyword"> const</span>
<a name="l00406"></a>00406 <span class="keyword"></span>{
<a name="l00407"></a>00407   libmesh_assert (row_dofs.size() == matrix.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a68bd665fb9252382cc9a28df4099d76a">m</a>());
<a name="l00408"></a>00408   libmesh_assert (col_dofs.size() == matrix.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a4fb8c524109fd5dff8c98855437544ee">n</a>());
<a name="l00409"></a>00409 
<a name="l00410"></a>00410   <span class="comment">// check for easy return</span>
<a name="l00411"></a>00411   <span class="keywordflow">if</span> (this-&gt;n_constrained_dofs() == 0)
<a name="l00412"></a>00412     <span class="keywordflow">return</span>;
<a name="l00413"></a>00413   
<a name="l00414"></a>00414   <span class="comment">// The constrained matrix is built up as R^T K C.</span>
<a name="l00415"></a>00415   <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Number&gt;</a> R;
<a name="l00416"></a>00416   <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Number&gt;</a> C;
<a name="l00417"></a>00417 
<a name="l00418"></a>00418   <span class="comment">// Safeguard against the user passing us the same</span>
<a name="l00419"></a>00419   <span class="comment">// object for row_dofs and col_dofs.  If that is done</span>
<a name="l00420"></a>00420   <span class="comment">// the calls to build_matrix would fail</span>
<a name="l00421"></a>00421   std::vector&lt;unsigned int&gt; orig_row_dofs(row_dofs);
<a name="l00422"></a>00422   std::vector&lt;unsigned int&gt; orig_col_dofs(col_dofs);
<a name="l00423"></a>00423   
<a name="l00424"></a>00424   this-&gt;build_constraint_matrix (R, orig_row_dofs);
<a name="l00425"></a>00425   this-&gt;build_constraint_matrix (C, orig_col_dofs);
<a name="l00426"></a>00426 
<a name="l00427"></a>00427   START_LOG(<span class="stringliteral">&quot;constrain_elem_matrix()&quot;</span>, <span class="stringliteral">&quot;DofMap&quot;</span>);
<a name="l00428"></a>00428   
<a name="l00429"></a>00429   row_dofs = orig_row_dofs;
<a name="l00430"></a>00430   col_dofs = orig_col_dofs;
<a name="l00431"></a>00431   
<a name="l00432"></a>00432     
<a name="l00433"></a>00433   <span class="comment">// It is possible that the matrix is not constrained at all.</span>
<a name="l00434"></a>00434   <span class="keywordflow">if</span> ((R.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a68bd665fb9252382cc9a28df4099d76a">m</a>() == matrix.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a68bd665fb9252382cc9a28df4099d76a">m</a>()) &amp;&amp;
<a name="l00435"></a>00435       (R.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a4fb8c524109fd5dff8c98855437544ee">n</a>() == row_dofs.size()) &amp;&amp;
<a name="l00436"></a>00436       (C.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a68bd665fb9252382cc9a28df4099d76a">m</a>() == matrix.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a4fb8c524109fd5dff8c98855437544ee">n</a>()) &amp;&amp;
<a name="l00437"></a>00437       (C.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a4fb8c524109fd5dff8c98855437544ee">n</a>() == col_dofs.size())) <span class="comment">// If the matrix is constrained</span>
<a name="l00438"></a>00438     {
<a name="l00439"></a>00439       <span class="comment">// K_constrained = R^T K C</span>
<a name="l00440"></a>00440       matrix.<a class="code" href="classlibMesh_1_1DenseMatrix.php#aea84b08f2ffc1a36a5a87969287ac865">left_multiply_transpose</a>  (R);
<a name="l00441"></a>00441       matrix.<a class="code" href="classlibMesh_1_1DenseMatrix.php#a9cb161155585b412f27e6bf8103d6d48">right_multiply</a> (C);
<a name="l00442"></a>00442       
<a name="l00443"></a>00443       
<a name="l00444"></a>00444       libmesh_assert (matrix.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a68bd665fb9252382cc9a28df4099d76a">m</a>() == row_dofs.size());
<a name="l00445"></a>00445       libmesh_assert (matrix.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a4fb8c524109fd5dff8c98855437544ee">n</a>() == col_dofs.size());
<a name="l00446"></a>00446       
<a name="l00447"></a>00447       
<a name="l00448"></a>00448       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;row_dofs.size(); i++)
<a name="l00449"></a>00449         <span class="keywordflow">if</span> (this-&gt;is_constrained_dof(row_dofs[i]))
<a name="l00450"></a>00450           {
<a name="l00451"></a>00451             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;matrix.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a4fb8c524109fd5dff8c98855437544ee">n</a>(); j++)
<a name="l00452"></a>00452               matrix(i,j) = 0.;
<a name="l00453"></a>00453           
<a name="l00454"></a>00454             <span class="comment">// If the DOF is constrained</span>
<a name="l00455"></a>00455             matrix(i,i) = 1.;
<a name="l00456"></a>00456             
<a name="l00457"></a>00457             <span class="keywordflow">if</span> (asymmetric_constraint_rows)
<a name="l00458"></a>00458               {
<a name="l00459"></a>00459                 DofConstraints::const_iterator
<a name="l00460"></a>00460                   pos = _dof_constraints.find(row_dofs[i]);
<a name="l00461"></a>00461             
<a name="l00462"></a>00462                 libmesh_assert (pos != _dof_constraints.end());
<a name="l00463"></a>00463             
<a name="l00464"></a>00464                 <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#a919b3727a9707f23ecad00949d1d1c43">DofConstraintRow</a>&amp; constraint_row = pos-&gt;second;
<a name="l00465"></a>00465             
<a name="l00466"></a>00466                 libmesh_assert (!constraint_row.empty());
<a name="l00467"></a>00467             
<a name="l00468"></a>00468                 <span class="keywordflow">for</span> (DofConstraintRow::const_iterator
<a name="l00469"></a>00469                        it=constraint_row.begin(); it != constraint_row.end();
<a name="l00470"></a>00470                      ++it)
<a name="l00471"></a>00471                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;col_dofs.size(); j++)
<a name="l00472"></a>00472                     <span class="keywordflow">if</span> (col_dofs[j] == it-&gt;first)
<a name="l00473"></a>00473                       matrix(i,j) = -it-&gt;second;        
<a name="l00474"></a>00474               }
<a name="l00475"></a>00475           }
<a name="l00476"></a>00476     } <span class="comment">// end if is constrained...</span>
<a name="l00477"></a>00477   
<a name="l00478"></a>00478   STOP_LOG(<span class="stringliteral">&quot;constrain_elem_matrix()&quot;</span>, <span class="stringliteral">&quot;DofMap&quot;</span>);  
<a name="l00479"></a>00479 }
<a name="l00480"></a>00480 
<a name="l00481"></a>00481 
<a name="l00482"></a>00482 
<a name="l00483"></a><a class="code" href="classlibMesh_1_1DofMap.php#a29aba1bf008a1de4dd81a9a1b6f5ff41">00483</a> <span class="keywordtype">void</span> DofMap::constrain_element_vector (<a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a>&amp;       rhs,
<a name="l00484"></a>00484                                        std::vector&lt;unsigned int&gt;&amp; row_dofs,
<a name="l00485"></a>00485                                        <span class="keywordtype">bool</span>)<span class="keyword"> const</span>
<a name="l00486"></a>00486 <span class="keyword"></span>{
<a name="l00487"></a>00487   libmesh_assert (rhs.<a class="code" href="classlibMesh_1_1DenseVector.php#ab124ecf2f46ee43b167f093b05d81fdb">size</a>() == row_dofs.size());
<a name="l00488"></a>00488 
<a name="l00489"></a>00489   <span class="comment">// check for easy return</span>
<a name="l00490"></a>00490   <span class="keywordflow">if</span> (this-&gt;n_constrained_dofs() == 0)
<a name="l00491"></a>00491     <span class="keywordflow">return</span>;
<a name="l00492"></a>00492   
<a name="l00493"></a>00493   <span class="comment">// The constrained RHS is built up as R^T F.  </span>
<a name="l00494"></a>00494   <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Number&gt;</a> R;
<a name="l00495"></a>00495 
<a name="l00496"></a>00496   this-&gt;build_constraint_matrix (R, row_dofs);
<a name="l00497"></a>00497 
<a name="l00498"></a>00498   START_LOG(<span class="stringliteral">&quot;constrain_elem_vector()&quot;</span>, <span class="stringliteral">&quot;DofMap&quot;</span>);
<a name="l00499"></a>00499     
<a name="l00500"></a>00500   <span class="comment">// It is possible that the vector is not constrained at all.</span>
<a name="l00501"></a>00501   <span class="keywordflow">if</span> ((R.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a68bd665fb9252382cc9a28df4099d76a">m</a>() == rhs.<a class="code" href="classlibMesh_1_1DenseVector.php#ab124ecf2f46ee43b167f093b05d81fdb">size</a>()) &amp;&amp;
<a name="l00502"></a>00502       (R.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a4fb8c524109fd5dff8c98855437544ee">n</a>() == row_dofs.size())) <span class="comment">// if the RHS is constrained</span>
<a name="l00503"></a>00503     {
<a name="l00504"></a>00504       <span class="comment">// Compute the matrix-vector product</span>
<a name="l00505"></a>00505       <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> old_rhs(rhs);
<a name="l00506"></a>00506 
<a name="l00507"></a>00507       <span class="comment">// resize RHS &amp; zero before summation</span>
<a name="l00508"></a>00508       rhs.<a class="code" href="classlibMesh_1_1DenseVector.php#a08430ae781094632e8272cbb825d4f44">resize</a>(row_dofs.size());
<a name="l00509"></a>00509       rhs.<a class="code" href="classlibMesh_1_1DenseVector.php#a23868ec54dca234e5893e41a8b510d68">zero</a>();
<a name="l00510"></a>00510 
<a name="l00511"></a>00511       <span class="comment">// compute matrix/vector product</span>
<a name="l00512"></a>00512       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;row_dofs.size(); i++)
<a name="l00513"></a>00513         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;old_rhs.<a class="code" href="classlibMesh_1_1DenseVector.php#ab124ecf2f46ee43b167f093b05d81fdb">size</a>(); j++)
<a name="l00514"></a>00514           rhs(i) += R.<a class="code" href="classlibMesh_1_1DenseMatrix.php#a8f1a04ca0780c6327443862cae23f1d3">transpose</a>(i,j)*old_rhs(j);
<a name="l00515"></a>00515       
<a name="l00516"></a>00516       libmesh_assert (row_dofs.size() == rhs.<a class="code" href="classlibMesh_1_1DenseVector.php#ab124ecf2f46ee43b167f093b05d81fdb">size</a>());
<a name="l00517"></a>00517 
<a name="l00518"></a>00518       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;row_dofs.size(); i++)
<a name="l00519"></a>00519         <span class="keywordflow">if</span> (this-&gt;is_constrained_dof(row_dofs[i]))
<a name="l00520"></a>00520           {     
<a name="l00521"></a>00521             <span class="comment">// If the DOF is constrained</span>
<a name="l00522"></a>00522             rhs(i) = 0.;
<a name="l00523"></a>00523           }
<a name="l00524"></a>00524     } <span class="comment">// end if the RHS is constrained.</span>
<a name="l00525"></a>00525   
<a name="l00526"></a>00526   STOP_LOG(<span class="stringliteral">&quot;constrain_elem_vector()&quot;</span>, <span class="stringliteral">&quot;DofMap&quot;</span>);  
<a name="l00527"></a>00527 }
<a name="l00528"></a>00528 
<a name="l00529"></a>00529 
<a name="l00530"></a>00530 
<a name="l00531"></a><a class="code" href="classlibMesh_1_1DofMap.php#ae5ccc5717b8c3a94629a306ebd4e1f17">00531</a> <span class="keywordtype">void</span> DofMap::constrain_element_dyad_matrix (<a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a>&amp; v,
<a name="l00532"></a>00532                                             <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a>&amp; w,
<a name="l00533"></a>00533                                             std::vector&lt;unsigned int&gt;&amp; row_dofs,
<a name="l00534"></a>00534                                             <span class="keywordtype">bool</span>)<span class="keyword"> const</span>
<a name="l00535"></a>00535 <span class="keyword"></span>{
<a name="l00536"></a>00536   libmesh_assert (v.<a class="code" href="classlibMesh_1_1DenseVector.php#ab124ecf2f46ee43b167f093b05d81fdb">size</a>() == row_dofs.size());
<a name="l00537"></a>00537   libmesh_assert (w.<a class="code" href="classlibMesh_1_1DenseVector.php#ab124ecf2f46ee43b167f093b05d81fdb">size</a>() == row_dofs.size());
<a name="l00538"></a>00538 
<a name="l00539"></a>00539   <span class="comment">// check for easy return</span>
<a name="l00540"></a>00540   <span class="keywordflow">if</span> (this-&gt;n_constrained_dofs() == 0)
<a name="l00541"></a>00541     <span class="keywordflow">return</span>;
<a name="l00542"></a>00542   
<a name="l00543"></a>00543   <span class="comment">// The constrained RHS is built up as R^T F.  </span>
<a name="l00544"></a>00544   <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Number&gt;</a> R;
<a name="l00545"></a>00545 
<a name="l00546"></a>00546   this-&gt;build_constraint_matrix (R, row_dofs);
<a name="l00547"></a>00547 
<a name="l00548"></a>00548   START_LOG(<span class="stringliteral">&quot;cnstrn_elem_dyad_mat()&quot;</span>, <span class="stringliteral">&quot;DofMap&quot;</span>);
<a name="l00549"></a>00549     
<a name="l00550"></a>00550   <span class="comment">// It is possible that the vector is not constrained at all.</span>
<a name="l00551"></a>00551   <span class="keywordflow">if</span> ((R.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a68bd665fb9252382cc9a28df4099d76a">m</a>() == v.<a class="code" href="classlibMesh_1_1DenseVector.php#ab124ecf2f46ee43b167f093b05d81fdb">size</a>()) &amp;&amp;
<a name="l00552"></a>00552       (R.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a4fb8c524109fd5dff8c98855437544ee">n</a>() == row_dofs.size())) <span class="comment">// if the RHS is constrained</span>
<a name="l00553"></a>00553     {
<a name="l00554"></a>00554       <span class="comment">// Compute the matrix-vector products</span>
<a name="l00555"></a>00555       <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> old_v(v);
<a name="l00556"></a>00556       <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> old_w(w);
<a name="l00557"></a>00557 
<a name="l00558"></a>00558       <span class="comment">// resize RHS &amp; zero before summation</span>
<a name="l00559"></a>00559       v.<a class="code" href="classlibMesh_1_1DenseVector.php#a08430ae781094632e8272cbb825d4f44">resize</a>(row_dofs.size());
<a name="l00560"></a>00560       w.<a class="code" href="classlibMesh_1_1DenseVector.php#a08430ae781094632e8272cbb825d4f44">resize</a>(row_dofs.size());
<a name="l00561"></a>00561 
<a name="l00562"></a>00562       <span class="comment">// compute matrix/vector product</span>
<a name="l00563"></a>00563       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;row_dofs.size(); i++)
<a name="l00564"></a>00564         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;old_v.<a class="code" href="classlibMesh_1_1DenseVector.php#ab124ecf2f46ee43b167f093b05d81fdb">size</a>(); j++)
<a name="l00565"></a>00565           {
<a name="l00566"></a>00566             v(i) += R.<a class="code" href="classlibMesh_1_1DenseMatrix.php#a8f1a04ca0780c6327443862cae23f1d3">transpose</a>(i,j)*old_v(j);
<a name="l00567"></a>00567             w(i) += R.<a class="code" href="classlibMesh_1_1DenseMatrix.php#a8f1a04ca0780c6327443862cae23f1d3">transpose</a>(i,j)*old_w(j);
<a name="l00568"></a>00568           }
<a name="l00569"></a>00569       
<a name="l00570"></a>00570       libmesh_assert (row_dofs.size() == v.<a class="code" href="classlibMesh_1_1DenseVector.php#ab124ecf2f46ee43b167f093b05d81fdb">size</a>());
<a name="l00571"></a>00571       libmesh_assert (row_dofs.size() == w.<a class="code" href="classlibMesh_1_1DenseVector.php#ab124ecf2f46ee43b167f093b05d81fdb">size</a>());
<a name="l00572"></a>00572 
<a name="l00573"></a>00573       <span class="comment">/* Constrain only v, not w.  */</span>
<a name="l00574"></a>00574 
<a name="l00575"></a>00575       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;row_dofs.size(); i++)
<a name="l00576"></a>00576         <span class="keywordflow">if</span> (this-&gt;is_constrained_dof(row_dofs[i]))
<a name="l00577"></a>00577           {     
<a name="l00578"></a>00578             <span class="comment">// If the DOF is constrained</span>
<a name="l00579"></a>00579             v(i) = 0.;
<a name="l00580"></a>00580           }
<a name="l00581"></a>00581     } <span class="comment">// end if the RHS is constrained.</span>
<a name="l00582"></a>00582   
<a name="l00583"></a>00583   STOP_LOG(<span class="stringliteral">&quot;cnstrn_elem_dyad_mat()&quot;</span>, <span class="stringliteral">&quot;DofMap&quot;</span>);
<a name="l00584"></a>00584 }
<a name="l00585"></a>00585 
<a name="l00586"></a>00586 
<a name="l00587"></a>00587 
<a name="l00588"></a><a class="code" href="classlibMesh_1_1DofMap.php#a435e93c5a2f7bc911a62886eaddab082">00588</a> <span class="keywordtype">void</span> DofMap::constrain_nothing (std::vector&lt;unsigned int&gt;&amp; dofs)<span class="keyword"> const</span>
<a name="l00589"></a>00589 <span class="keyword"></span>{
<a name="l00590"></a>00590   <span class="comment">// check for easy return</span>
<a name="l00591"></a>00591   <span class="keywordflow">if</span> (this-&gt;n_constrained_dofs() == 0)
<a name="l00592"></a>00592     <span class="keywordflow">return</span>;
<a name="l00593"></a>00593 
<a name="l00594"></a>00594   <span class="comment">// All the work is done by \p build_constraint_matrix.  We just need</span>
<a name="l00595"></a>00595   <span class="comment">// a dummy matrix.</span>
<a name="l00596"></a>00596   <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Number&gt;</a> R;
<a name="l00597"></a>00597   this-&gt;build_constraint_matrix (R, dofs);
<a name="l00598"></a>00598 }
<a name="l00599"></a>00599 
<a name="l00600"></a>00600 
<a name="l00601"></a>00601 
<a name="l00602"></a><a class="code" href="classlibMesh_1_1DofMap.php#a938f3e6db23b740002490ac88d1bb60a">00602</a> <span class="keywordtype">void</span> DofMap::enforce_constraints_exactly (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a> &amp;system,
<a name="l00603"></a>00603                                           <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> *v)<span class="keyword"> const</span>
<a name="l00604"></a>00604 <span class="keyword"></span>{
<a name="l00605"></a>00605   parallel_only();
<a name="l00606"></a>00606 
<a name="l00607"></a>00607   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> local_constraints = this-&gt;n_constrained_dofs();
<a name="l00608"></a>00608   <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">Parallel::max</a>(local_constraints);
<a name="l00609"></a>00609   <span class="keywordflow">if</span> (!local_constraints)
<a name="l00610"></a>00610     <span class="keywordflow">return</span>;
<a name="l00611"></a>00611   
<a name="l00612"></a>00612   START_LOG(<span class="stringliteral">&quot;enforce_constraints_exactly()&quot;</span>,<span class="stringliteral">&quot;DofMap&quot;</span>);
<a name="l00613"></a>00613 
<a name="l00614"></a>00614   <span class="keywordflow">if</span> (!v)
<a name="l00615"></a>00615     v = system.<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>();
<a name="l00616"></a>00616 
<a name="l00617"></a>00617   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> *v_local  = NULL; <span class="comment">// will be initialized below</span>
<a name="l00618"></a>00618   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> *v_global = NULL; <span class="comment">// will be initialized below</span>
<a name="l00619"></a>00619   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;Number&gt;</a> &gt; v_built;
<a name="l00620"></a>00620   <span class="keywordflow">if</span> (v-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a3b6bc13960a5d0022beea138c4e86dc4">type</a>() == <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa333690ccec0379e5dd4ccb60db5ea0c9">SERIAL</a>)
<a name="l00621"></a>00621     {
<a name="l00622"></a>00622       v_built = <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;::build</a>();
<a name="l00623"></a>00623       v_built-&gt;init(this-&gt;n_dofs(), this-&gt;n_local_dofs(), <span class="keyword">true</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">PARALLEL</a>);
<a name="l00624"></a>00624       v_built-&gt;close();
<a name="l00625"></a>00625 
<a name="l00626"></a>00626       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=v_built-&gt;first_local_index();
<a name="l00627"></a>00627            i&lt;v_built-&gt;last_local_index(); i++)
<a name="l00628"></a>00628         v_built-&gt;set(i, (*v)(i));
<a name="l00629"></a>00629       v_built-&gt;close();
<a name="l00630"></a>00630       v_global = v_built.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>();
<a name="l00631"></a>00631 
<a name="l00632"></a>00632       v_local = v;
<a name="l00633"></a>00633       libmesh_assert (v_local-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#afa69111a678b5552c7fe586c91a6585f">closed</a>());
<a name="l00634"></a>00634     }
<a name="l00635"></a>00635   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (v-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a3b6bc13960a5d0022beea138c4e86dc4">type</a>() == <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">PARALLEL</a>)
<a name="l00636"></a>00636     {
<a name="l00637"></a>00637       v_built = <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;::build</a>();
<a name="l00638"></a>00638       v_built-&gt;init (v-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a86082d6030cb32700e7eeac6e7f26455">size</a>(), v-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a86082d6030cb32700e7eeac6e7f26455">size</a>(), <span class="keyword">true</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa333690ccec0379e5dd4ccb60db5ea0c9">SERIAL</a>);
<a name="l00639"></a>00639       v-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a7348b5b027adf716016354847e0df0b6">localize</a>(*v_built);
<a name="l00640"></a>00640       v_built-&gt;close();
<a name="l00641"></a>00641       v_local = v_built.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>();
<a name="l00642"></a>00642 
<a name="l00643"></a>00643       v_global = v;
<a name="l00644"></a>00644     }
<a name="l00645"></a>00645   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (v-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a3b6bc13960a5d0022beea138c4e86dc4">type</a>() == <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa9f12475bbe90a64ad167ec0b856ca6c1">GHOSTED</a>)
<a name="l00646"></a>00646     {
<a name="l00647"></a>00647       v_local = v;
<a name="l00648"></a>00648       v_global = v;
<a name="l00649"></a>00649     }
<a name="l00650"></a>00650   <span class="keywordflow">else</span> <span class="comment">// unknown v-&gt;type()</span>
<a name="l00651"></a>00651     {
<a name="l00652"></a>00652       <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Unknown v-&gt;type() == &quot;</span> &lt;&lt; v-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a3b6bc13960a5d0022beea138c4e86dc4">type</a>() 
<a name="l00653"></a>00653                     &lt;&lt; std::endl;
<a name="l00654"></a>00654       libmesh_error();
<a name="l00655"></a>00655     }
<a name="l00656"></a>00656 
<a name="l00657"></a>00657   <span class="comment">// We should never hit these asserts because we should error-out in</span>
<a name="l00658"></a>00658   <span class="comment">// else clause above.  Just to be sure we don&#39;t try to use v_local</span>
<a name="l00659"></a>00659   <span class="comment">// and v_global uninitialized...</span>
<a name="l00660"></a>00660   libmesh_assert(v_local);
<a name="l00661"></a>00661   libmesh_assert(v_global);
<a name="l00662"></a>00662   libmesh_assert (<span class="keyword">this</span> == &amp;(system.<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>()));
<a name="l00663"></a>00663 
<a name="l00664"></a>00664   DofConstraints::const_iterator c_it = _dof_constraints.begin();
<a name="l00665"></a>00665   <span class="keyword">const</span> DofConstraints::const_iterator c_end = _dof_constraints.end();
<a name="l00666"></a>00666 
<a name="l00667"></a>00667   <span class="keywordflow">for</span> ( ; c_it != c_end; ++c_it)
<a name="l00668"></a>00668     {
<a name="l00669"></a>00669       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> constrained_dof = c_it-&gt;first;
<a name="l00670"></a>00670       <span class="keywordflow">if</span> (constrained_dof &lt; this-&gt;first_dof() ||
<a name="l00671"></a>00671           constrained_dof &gt;= this-&gt;end_dof())
<a name="l00672"></a>00672         <span class="keywordflow">continue</span>;
<a name="l00673"></a>00673 
<a name="l00674"></a>00674       <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#a919b3727a9707f23ecad00949d1d1c43">DofConstraintRow</a> constraint_row = c_it-&gt;second;
<a name="l00675"></a>00675 
<a name="l00676"></a>00676       <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> exact_value = 0;
<a name="l00677"></a>00677       <span class="keywordflow">for</span> (DofConstraintRow::const_iterator
<a name="l00678"></a>00678            j=constraint_row.begin(); j != constraint_row.end();
<a name="l00679"></a>00679            ++j)
<a name="l00680"></a>00680         exact_value += j-&gt;second * (*v_local)(j-&gt;first);
<a name="l00681"></a>00681 
<a name="l00682"></a>00682       v_global-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a51bd7e4c6afb223573ec051777133c9b">set</a>(constrained_dof, exact_value);
<a name="l00683"></a>00683     }
<a name="l00684"></a>00684 
<a name="l00685"></a>00685   <span class="comment">// If the old vector was serial, we probably need to send our values</span>
<a name="l00686"></a>00686   <span class="comment">// to other processors</span>
<a name="l00687"></a>00687   <span class="keywordflow">if</span> (v-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a3b6bc13960a5d0022beea138c4e86dc4">type</a>() == <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa333690ccec0379e5dd4ccb60db5ea0c9">SERIAL</a>)
<a name="l00688"></a>00688     {
<a name="l00689"></a>00689       v_global-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a7348b5b027adf716016354847e0df0b6">localize</a> (*v);
<a name="l00690"></a>00690     }
<a name="l00691"></a>00691   v-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a42ea91bba70b3e7b27dad2a636ad31ae">close</a>();
<a name="l00692"></a>00692 
<a name="l00693"></a>00693   STOP_LOG(<span class="stringliteral">&quot;enforce_constraints_exactly()&quot;</span>,<span class="stringliteral">&quot;DofMap&quot;</span>);
<a name="l00694"></a>00694 }
<a name="l00695"></a>00695 
<a name="l00696"></a>00696 
<a name="l00697"></a>00697 
<a name="l00698"></a>00698 std::pair&lt;Real, Real&gt;
<a name="l00699"></a><a class="code" href="classlibMesh_1_1DofMap.php#a8d3c9a10b0a20e889cb9c781219ef29d">00699</a> DofMap::max_constraint_error (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a> &amp;system,
<a name="l00700"></a>00700                               <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> *v)<span class="keyword"> const</span>
<a name="l00701"></a>00701 <span class="keyword"></span>{
<a name="l00702"></a>00702   <span class="keywordflow">if</span> (!v)
<a name="l00703"></a>00703     v = system.<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>();
<a name="l00704"></a>00704   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp;vec = *v;
<a name="l00705"></a>00705 
<a name="l00706"></a>00706   <span class="comment">// We&#39;ll assume the vector is closed</span>
<a name="l00707"></a>00707   libmesh_assert (vec.<a class="code" href="classlibMesh_1_1NumericVector.php#afa69111a678b5552c7fe586c91a6585f">closed</a>());
<a name="l00708"></a>00708 
<a name="l00709"></a>00709   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> max_absolute_error = 0., max_relative_error = 0.;
<a name="l00710"></a>00710 
<a name="l00711"></a>00711   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp;<a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a> = system.<a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">get_mesh</a>();
<a name="l00712"></a>00712 
<a name="l00713"></a>00713   libmesh_assert (<span class="keyword">this</span> == &amp;(system.<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>()));
<a name="l00714"></a>00714 
<a name="l00715"></a>00715   <span class="comment">// indices on each element</span>
<a name="l00716"></a>00716   std::vector&lt;unsigned int&gt; local_dof_indices;
<a name="l00717"></a>00717 
<a name="l00718"></a>00718   <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>       elem_it  =
<a name="l00719"></a>00719     mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a99742bad0b034a29ccae8c5a90c6f4aa">active_local_elements_begin</a>();
<a name="l00720"></a>00720   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> elem_end =
<a name="l00721"></a>00721     mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a2e27f54d33f7539c0c06b36adae36cda">active_local_elements_end</a>(); 
<a name="l00722"></a>00722       
<a name="l00723"></a>00723   <span class="keywordflow">for</span> ( ; elem_it != elem_end; ++elem_it)
<a name="l00724"></a>00724     {
<a name="l00725"></a>00725       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = *elem_it;
<a name="l00726"></a>00726 
<a name="l00727"></a>00727       this-&gt;dof_indices(elem, local_dof_indices);
<a name="l00728"></a>00728       std::vector&lt;unsigned int&gt; raw_dof_indices = local_dof_indices;
<a name="l00729"></a>00729 
<a name="l00730"></a>00730       <span class="comment">// Constraint matrix for each element</span>
<a name="l00731"></a>00731       <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Number&gt;</a> C;
<a name="l00732"></a>00732 
<a name="l00733"></a>00733       this-&gt;build_constraint_matrix (C, local_dof_indices);
<a name="l00734"></a>00734 
<a name="l00735"></a>00735       <span class="comment">// Continue if the element is unconstrained</span>
<a name="l00736"></a>00736       <span class="keywordflow">if</span> (!C.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a68bd665fb9252382cc9a28df4099d76a">m</a>())
<a name="l00737"></a>00737         <span class="keywordflow">continue</span>;
<a name="l00738"></a>00738 
<a name="l00739"></a>00739       libmesh_assert(C.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a68bd665fb9252382cc9a28df4099d76a">m</a>() == raw_dof_indices.size());
<a name="l00740"></a>00740       libmesh_assert(C.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a4fb8c524109fd5dff8c98855437544ee">n</a>() == local_dof_indices.size());
<a name="l00741"></a>00741 
<a name="l00742"></a>00742       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i!=C.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a68bd665fb9252382cc9a28df4099d76a">m</a>(); ++i)
<a name="l00743"></a>00743         {
<a name="l00744"></a>00744           <span class="comment">// Recalculate any constrained dof owned by this processor</span>
<a name="l00745"></a>00745           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> global_dof = raw_dof_indices[i];
<a name="l00746"></a>00746           <span class="keywordflow">if</span> (this-&gt;is_constrained_dof(global_dof) &amp;&amp;
<a name="l00747"></a>00747               global_dof &gt;= vec.<a class="code" href="classlibMesh_1_1NumericVector.php#a313c2e8c69d74b3abd156b6b6fe415d1">first_local_index</a>() &amp;&amp;
<a name="l00748"></a>00748               global_dof &lt; vec.<a class="code" href="classlibMesh_1_1NumericVector.php#aaacb6f0a99a041108211ce79ea934fe2">last_local_index</a>())
<a name="l00749"></a>00749           {
<a name="l00750"></a>00750             <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> exact_value = 0;
<a name="l00751"></a>00751             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j!=C.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a4fb8c524109fd5dff8c98855437544ee">n</a>(); ++j)
<a name="l00752"></a>00752               {
<a name="l00753"></a>00753                 <span class="keywordflow">if</span> (local_dof_indices[j] != global_dof)
<a name="l00754"></a>00754                   exact_value += C(i,j) * 
<a name="l00755"></a>00755                     vec(local_dof_indices[j]);
<a name="l00756"></a>00756               }
<a name="l00757"></a>00757 
<a name="l00758"></a>00758             max_absolute_error = <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(max_absolute_error,
<a name="l00759"></a>00759               std::abs(vec(global_dof) - exact_value));
<a name="l00760"></a>00760             max_relative_error = <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(max_relative_error,
<a name="l00761"></a>00761               std::abs(vec(global_dof) - exact_value)
<a name="l00762"></a>00762               / std::abs(exact_value));
<a name="l00763"></a>00763           }
<a name="l00764"></a>00764         }
<a name="l00765"></a>00765     }
<a name="l00766"></a>00766 
<a name="l00767"></a>00767   <span class="keywordflow">return</span> std::pair&lt;Real, Real&gt;(max_absolute_error, max_relative_error);
<a name="l00768"></a>00768 }
<a name="l00769"></a>00769 
<a name="l00770"></a>00770 
<a name="l00771"></a>00771 
<a name="l00772"></a><a class="code" href="classlibMesh_1_1DofMap.php#ab205c45f9397a3864d915a4bc558acbf">00772</a> <span class="keywordtype">void</span> DofMap::build_constraint_matrix (<a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Number&gt;</a>&amp; C,
<a name="l00773"></a>00773                                       std::vector&lt;unsigned int&gt;&amp; elem_dofs,
<a name="l00774"></a>00774                                       <span class="keyword">const</span> <span class="keywordtype">bool</span> called_recursively)<span class="keyword"> const</span>
<a name="l00775"></a>00775 <span class="keyword"></span>{
<a name="l00776"></a>00776   <span class="keywordflow">if</span> (!called_recursively) START_LOG(<span class="stringliteral">&quot;build_constraint_matrix()&quot;</span>, <span class="stringliteral">&quot;DofMap&quot;</span>);
<a name="l00777"></a>00777 
<a name="l00778"></a>00778   <span class="comment">// Create a set containing the DOFs we already depend on</span>
<a name="l00779"></a>00779   <span class="keyword">typedef</span> std::set&lt;unsigned int&gt; RCSet;
<a name="l00780"></a>00780   RCSet dof_set;
<a name="l00781"></a>00781 
<a name="l00782"></a>00782   <span class="keywordtype">bool</span> we_have_constraints = <span class="keyword">false</span>;
<a name="l00783"></a>00783 
<a name="l00784"></a>00784   <span class="comment">// Next insert any other dofs the current dofs might be constrained</span>
<a name="l00785"></a>00785   <span class="comment">// in terms of.  Note that in this case we may not be done: Those</span>
<a name="l00786"></a>00786   <span class="comment">// may in turn depend on others.  So, we need to repeat this process</span>
<a name="l00787"></a>00787   <span class="comment">// in that case until the system depends only on unconstrained</span>
<a name="l00788"></a>00788   <span class="comment">// degrees of freedom.</span>
<a name="l00789"></a>00789   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;elem_dofs.size(); i++)
<a name="l00790"></a>00790     <span class="keywordflow">if</span> (this-&gt;is_constrained_dof(elem_dofs[i]))
<a name="l00791"></a>00791       {
<a name="l00792"></a>00792         we_have_constraints = <span class="keyword">true</span>;
<a name="l00793"></a>00793 
<a name="l00794"></a>00794         <span class="comment">// If the DOF is constrained</span>
<a name="l00795"></a>00795         DofConstraints::const_iterator
<a name="l00796"></a>00796           pos = _dof_constraints.find(elem_dofs[i]);
<a name="l00797"></a>00797         
<a name="l00798"></a>00798         libmesh_assert (pos != _dof_constraints.end());
<a name="l00799"></a>00799         
<a name="l00800"></a>00800         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#a919b3727a9707f23ecad00949d1d1c43">DofConstraintRow</a>&amp; constraint_row = pos-&gt;second;
<a name="l00801"></a>00801         
<a name="l00802"></a>00802 <span class="comment">// Constraint rows in p refinement may be empty</span>
<a name="l00803"></a>00803 <span class="comment">//      libmesh_assert (!constraint_row.empty());</span>
<a name="l00804"></a>00804         
<a name="l00805"></a>00805         <span class="keywordflow">for</span> (DofConstraintRow::const_iterator
<a name="l00806"></a>00806                it=constraint_row.begin(); it != constraint_row.end();
<a name="l00807"></a>00807              ++it)
<a name="l00808"></a>00808           dof_set.insert (it-&gt;first);
<a name="l00809"></a>00809       }
<a name="l00810"></a>00810 
<a name="l00811"></a>00811   <span class="comment">// May be safe to return at this point</span>
<a name="l00812"></a>00812   <span class="comment">// (but remember to stop the perflog)</span>
<a name="l00813"></a>00813   <span class="keywordflow">if</span> (!we_have_constraints)
<a name="l00814"></a>00814     {
<a name="l00815"></a>00815       STOP_LOG(<span class="stringliteral">&quot;build_constraint_matrix()&quot;</span>, <span class="stringliteral">&quot;DofMap&quot;</span>);
<a name="l00816"></a>00816       <span class="keywordflow">return</span>;
<a name="l00817"></a>00817     }
<a name="l00818"></a>00818 
<a name="l00819"></a>00819   <span class="comment">// delay inserting elem_dofs for efficiency in the case of</span>
<a name="l00820"></a>00820   <span class="comment">// no constraints.  In that case we don&#39;t get here!</span>
<a name="l00821"></a>00821   dof_set.insert (elem_dofs.begin(),
<a name="l00822"></a>00822                   elem_dofs.end());
<a name="l00823"></a>00823 
<a name="l00824"></a>00824   <span class="comment">// If we added any DOFS then we need to do this recursively.</span>
<a name="l00825"></a>00825   <span class="comment">// It is possible that we just added a DOF that is also</span>
<a name="l00826"></a>00826   <span class="comment">// constrained!</span>
<a name="l00827"></a>00827   <span class="comment">//</span>
<a name="l00828"></a>00828   <span class="comment">// Also, we need to handle the special case of an element having DOFs</span>
<a name="l00829"></a>00829   <span class="comment">// constrained in terms of other, local DOFs</span>
<a name="l00830"></a>00830   <span class="keywordflow">if</span> ((dof_set.size() != elem_dofs.size()) || <span class="comment">// case 1: constrained in terms of other DOFs</span>
<a name="l00831"></a>00831       !called_recursively)                    <span class="comment">// case 2: constrained in terms of our own DOFs</span>
<a name="l00832"></a>00832     {
<a name="l00833"></a>00833       <span class="comment">// Create a new list of element DOFs containing the</span>
<a name="l00834"></a>00834       <span class="comment">// contents of the current dof_set.</span>
<a name="l00835"></a>00835       std::vector&lt;unsigned int&gt; new_elem_dofs (dof_set.begin(),
<a name="l00836"></a>00836                                                dof_set.end());
<a name="l00837"></a>00837       
<a name="l00838"></a>00838       <span class="comment">// Now we can build the constraint matrix.</span>
<a name="l00839"></a>00839       <span class="comment">// Note that resize also zeros for a DenseMatrix&lt;Number&gt;.</span>
<a name="l00840"></a>00840       C.<a class="code" href="classlibMesh_1_1DenseMatrix.php#ad967ca8d40990ed5cae9944a285a320d">resize</a> (elem_dofs.size(), new_elem_dofs.size());
<a name="l00841"></a>00841       
<a name="l00842"></a>00842       <span class="comment">// Create the C constraint matrix.</span>
<a name="l00843"></a>00843       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;elem_dofs.size(); i++)
<a name="l00844"></a>00844         <span class="keywordflow">if</span> (this-&gt;is_constrained_dof(elem_dofs[i]))
<a name="l00845"></a>00845           {
<a name="l00846"></a>00846             <span class="comment">// If the DOF is constrained</span>
<a name="l00847"></a>00847             DofConstraints::const_iterator
<a name="l00848"></a>00848               pos = _dof_constraints.find(elem_dofs[i]);
<a name="l00849"></a>00849             
<a name="l00850"></a>00850             libmesh_assert (pos != _dof_constraints.end());
<a name="l00851"></a>00851             
<a name="l00852"></a>00852             <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#a919b3727a9707f23ecad00949d1d1c43">DofConstraintRow</a>&amp; constraint_row = pos-&gt;second;
<a name="l00853"></a>00853             
<a name="l00854"></a>00854 <span class="comment">// p refinement creates empty constraint rows</span>
<a name="l00855"></a>00855 <span class="comment">//          libmesh_assert (!constraint_row.empty());</span>
<a name="l00856"></a>00856             
<a name="l00857"></a>00857             <span class="keywordflow">for</span> (DofConstraintRow::const_iterator
<a name="l00858"></a>00858                    it=constraint_row.begin(); it != constraint_row.end();
<a name="l00859"></a>00859                  ++it)
<a name="l00860"></a>00860               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;new_elem_dofs.size(); j++)
<a name="l00861"></a>00861                 <span class="keywordflow">if</span> (new_elem_dofs[j] == it-&gt;first)
<a name="l00862"></a>00862                   C(i,j) = it-&gt;second;
<a name="l00863"></a>00863           }
<a name="l00864"></a>00864         <span class="keywordflow">else</span>
<a name="l00865"></a>00865           {
<a name="l00866"></a>00866             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;new_elem_dofs.size(); j++)
<a name="l00867"></a>00867               <span class="keywordflow">if</span> (new_elem_dofs[j] == elem_dofs[i])
<a name="l00868"></a>00868                 C(i,j) =  1.;
<a name="l00869"></a>00869           }     
<a name="l00870"></a>00870 
<a name="l00871"></a>00871       <span class="comment">// May need to do this recursively.  It is possible</span>
<a name="l00872"></a>00872       <span class="comment">// that we just replaced a constrained DOF with another</span>
<a name="l00873"></a>00873       <span class="comment">// constrained DOF.</span>
<a name="l00874"></a>00874       elem_dofs = new_elem_dofs;
<a name="l00875"></a>00875       
<a name="l00876"></a>00876       <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Number&gt;</a> Cnew;
<a name="l00877"></a>00877       
<a name="l00878"></a>00878       this-&gt;build_constraint_matrix (Cnew, elem_dofs, <span class="keyword">true</span>);
<a name="l00879"></a>00879 
<a name="l00880"></a>00880       <span class="keywordflow">if</span> ((C.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a4fb8c524109fd5dff8c98855437544ee">n</a>() == Cnew.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a68bd665fb9252382cc9a28df4099d76a">m</a>()) &amp;&amp;
<a name="l00881"></a>00881           (Cnew.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a4fb8c524109fd5dff8c98855437544ee">n</a>() == elem_dofs.size())) <span class="comment">// If the constraint matrix                                    </span>
<a name="l00882"></a>00882         C.<a class="code" href="classlibMesh_1_1DenseMatrix.php#a9cb161155585b412f27e6bf8103d6d48">right_multiply</a>(Cnew);           <span class="comment">// is constrained...</span>
<a name="l00883"></a>00883       
<a name="l00884"></a>00884       libmesh_assert (C.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a4fb8c524109fd5dff8c98855437544ee">n</a>() == elem_dofs.size());
<a name="l00885"></a>00885     }
<a name="l00886"></a>00886   
<a name="l00887"></a>00887   <span class="keywordflow">if</span> (!called_recursively) STOP_LOG(<span class="stringliteral">&quot;build_constraint_matrix()&quot;</span>, <span class="stringliteral">&quot;DofMap&quot;</span>);  
<a name="l00888"></a>00888 }
<a name="l00889"></a>00889 
<a name="l00890"></a>00890 
<a name="l00891"></a>00891 
<a name="l00892"></a><a class="code" href="classlibMesh_1_1DofMap.php#a2a73dfbc22045908ef2acf9045c7790f">00892</a> <span class="keywordtype">void</span> DofMap::allgather_recursive_constraints()
<a name="l00893"></a>00893 {
<a name="l00894"></a>00894   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00895"></a>00895   parallel_only();
<a name="l00896"></a>00896 
<a name="l00897"></a>00897   <span class="comment">// Return immediately if there&#39;s nothing to gather</span>
<a name="l00898"></a>00898   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() == 1)
<a name="l00899"></a>00899     <span class="keywordflow">return</span>;
<a name="l00900"></a>00900 
<a name="l00901"></a>00901   <span class="comment">// We might get to return immediately if none of the processors</span>
<a name="l00902"></a>00902   <span class="comment">// found any constraints</span>
<a name="l00903"></a>00903   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> has_constraints = !_dof_constraints.empty();
<a name="l00904"></a>00904   <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">Parallel::max</a>(has_constraints);
<a name="l00905"></a>00905   <span class="keywordflow">if</span> (!has_constraints)
<a name="l00906"></a>00906     <span class="keywordflow">return</span>;
<a name="l00907"></a>00907 
<a name="l00908"></a>00908   <span class="comment">// We might have calculated constraints for constrained dofs</span>
<a name="l00909"></a>00909   <span class="comment">// which live on other processors.</span>
<a name="l00910"></a>00910   <span class="comment">// Push these out first.</span>
<a name="l00911"></a>00911   {
<a name="l00912"></a>00912   std::vector&lt;std::vector&lt;unsigned int&gt; &gt; pushed_ids(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>());
<a name="l00913"></a>00913   std::vector&lt;unsigned int&gt; pushed_on_proc(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(), 0);
<a name="l00914"></a>00914 
<a name="l00915"></a>00915   <span class="comment">// Count the constraints to push to each processor</span>
<a name="l00916"></a>00916   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> push_proc_id = 0;
<a name="l00917"></a>00917   <span class="keywordflow">for</span> (DofConstraints::iterator i = _dof_constraints.begin();
<a name="l00918"></a>00918          i != _dof_constraints.end(); ++i)
<a name="l00919"></a>00919     {
<a name="l00920"></a>00920       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> constrained = i-&gt;first;
<a name="l00921"></a>00921       <span class="keywordflow">while</span> (constrained &gt;= _end_df[push_proc_id])
<a name="l00922"></a>00922         push_proc_id++;
<a name="l00923"></a>00923       pushed_on_proc[push_proc_id]++;
<a name="l00924"></a>00924     }
<a name="l00925"></a>00925   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p = 0; p != <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(); ++p)
<a name="l00926"></a>00926     pushed_ids[p].reserve(pushed_on_proc[p]);
<a name="l00927"></a>00927 
<a name="l00928"></a>00928   <span class="comment">// Collect the constraints to push to each processor</span>
<a name="l00929"></a>00929   push_proc_id = 0;
<a name="l00930"></a>00930   <span class="keywordflow">for</span> (DofConstraints::iterator i = _dof_constraints.begin();
<a name="l00931"></a>00931          i != _dof_constraints.end(); ++i)
<a name="l00932"></a>00932     {
<a name="l00933"></a>00933       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> constrained = i-&gt;first;
<a name="l00934"></a>00934       <span class="keywordflow">while</span> (constrained &gt;= _end_df[push_proc_id])
<a name="l00935"></a>00935         push_proc_id++;
<a name="l00936"></a>00936       pushed_ids[push_proc_id].push_back(constrained);
<a name="l00937"></a>00937     }
<a name="l00938"></a>00938 
<a name="l00939"></a>00939   <span class="comment">// Now trade constraint rows</span>
<a name="l00940"></a>00940   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p = 0; p != <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(); ++p)
<a name="l00941"></a>00941     {
<a name="l00942"></a>00942       <span class="comment">// Push to processor procup while receiving from procdown</span>
<a name="l00943"></a>00943       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> procup = (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() + p) %
<a name="l00944"></a>00944                              <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>();
<a name="l00945"></a>00945       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> procdown = (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() +
<a name="l00946"></a>00946                                <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() - p) %
<a name="l00947"></a>00947                                <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>();
<a name="l00948"></a>00948 
<a name="l00949"></a>00949       <span class="comment">// Pack the constraint rows to push to procup</span>
<a name="l00950"></a>00950       std::vector&lt;std::vector&lt;unsigned int&gt; &gt; pushed_keys(pushed_ids[procup].size());
<a name="l00951"></a>00951       std::vector&lt;std::vector&lt;Real&gt; &gt; pushed_vals(pushed_ids[procup].size());
<a name="l00952"></a>00952       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i != pushed_ids[procup].size(); ++i) 
<a name="l00953"></a>00953         {
<a name="l00954"></a>00954           <a class="code" href="namespacelibMesh.php#a919b3727a9707f23ecad00949d1d1c43">DofConstraintRow</a> &amp;row = _dof_constraints[pushed_ids[procup][i]];
<a name="l00955"></a>00955           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> row_size = row.size();
<a name="l00956"></a>00956           pushed_keys[i].reserve(row_size);
<a name="l00957"></a>00957           pushed_vals[i].reserve(row_size);
<a name="l00958"></a>00958           <span class="keywordflow">for</span> (DofConstraintRow::iterator j = row.begin();
<a name="l00959"></a>00959                j != row.end(); ++j)
<a name="l00960"></a>00960             {
<a name="l00961"></a>00961               pushed_keys[i].push_back(j-&gt;first);
<a name="l00962"></a>00962               pushed_vals[i].push_back(j-&gt;second);
<a name="l00963"></a>00963             }
<a name="l00964"></a>00964         }
<a name="l00965"></a>00965 
<a name="l00966"></a>00966       <span class="comment">// Trade pushed constraint rows</span>
<a name="l00967"></a>00967       std::vector&lt;unsigned int&gt; pushed_ids_to_me;
<a name="l00968"></a>00968       std::vector&lt;std::vector&lt;unsigned int&gt; &gt; pushed_keys_to_me;
<a name="l00969"></a>00969       std::vector&lt;std::vector&lt;Real&gt; &gt; pushed_vals_to_me;
<a name="l00970"></a>00970       <a class="code" href="namespacelibMesh_1_1Parallel.php#acfbfff4a15f9dc0b0abdfb081086dd3b">Parallel::send_receive</a>(procup, pushed_ids[procup],
<a name="l00971"></a>00971                              procdown, pushed_ids_to_me);
<a name="l00972"></a>00972       <a class="code" href="namespacelibMesh_1_1Parallel.php#acfbfff4a15f9dc0b0abdfb081086dd3b">Parallel::send_receive</a>(procup, pushed_keys,
<a name="l00973"></a>00973                              procdown, pushed_keys_to_me);
<a name="l00974"></a>00974       <a class="code" href="namespacelibMesh_1_1Parallel.php#acfbfff4a15f9dc0b0abdfb081086dd3b">Parallel::send_receive</a>(procup, pushed_vals,
<a name="l00975"></a>00975                              procdown, pushed_vals_to_me);
<a name="l00976"></a>00976       libmesh_assert (pushed_ids_to_me.size() == pushed_keys_to_me.size());
<a name="l00977"></a>00977       libmesh_assert (pushed_ids_to_me.size() == pushed_vals_to_me.size());
<a name="l00978"></a>00978 
<a name="l00979"></a>00979       <span class="comment">// Add the constraints that I&#39;ve been sent</span>
<a name="l00980"></a>00980       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i != pushed_ids_to_me.size(); ++i)
<a name="l00981"></a>00981         {
<a name="l00982"></a>00982           libmesh_assert (pushed_keys_to_me[i].size() == pushed_vals_to_me[i].size());
<a name="l00983"></a>00983 
<a name="l00984"></a>00984           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> constrained = pushed_ids_to_me[i];
<a name="l00985"></a>00985 
<a name="l00986"></a>00986           <span class="comment">// If we don&#39;t already have a constraint for this dof,</span>
<a name="l00987"></a>00987           <span class="comment">// add the one we were sent</span>
<a name="l00988"></a>00988           <span class="keywordflow">if</span> (!this-&gt;is_constrained_dof(constrained))
<a name="l00989"></a>00989             {
<a name="l00990"></a>00990               <a class="code" href="namespacelibMesh.php#a919b3727a9707f23ecad00949d1d1c43">DofConstraintRow</a> &amp;row = _dof_constraints[constrained];
<a name="l00991"></a>00991               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j = 0; j != pushed_keys_to_me[i].size(); ++j)
<a name="l00992"></a>00992                 {
<a name="l00993"></a>00993                   row[pushed_keys_to_me[i][j]] = pushed_vals_to_me[i][j];
<a name="l00994"></a>00994                 }
<a name="l00995"></a>00995             }
<a name="l00996"></a>00996         }
<a name="l00997"></a>00997     }
<a name="l00998"></a>00998   }
<a name="l00999"></a>00999 
<a name="l01000"></a>01000   <span class="comment">// Now start checking for any other constraints we need</span>
<a name="l01001"></a>01001   <span class="comment">// to know about, requesting them recursively.</span>
<a name="l01002"></a>01002 
<a name="l01003"></a>01003   <span class="comment">// Create a set containing the DOFs we already depend on</span>
<a name="l01004"></a>01004   <span class="keyword">typedef</span> std::set&lt;unsigned int&gt; RCSet;
<a name="l01005"></a>01005   RCSet unexpanded_set;
<a name="l01006"></a>01006 
<a name="l01007"></a>01007   <span class="keywordflow">for</span> (DofConstraints::iterator i = _dof_constraints.begin();
<a name="l01008"></a>01008          i != _dof_constraints.end(); ++i)
<a name="l01009"></a>01009     {
<a name="l01010"></a>01010       unexpanded_set.insert(i-&gt;first);
<a name="l01011"></a>01011     }
<a name="l01012"></a>01012 
<a name="l01013"></a>01013   <span class="comment">// We have to keep recursing while the unexpanded set is</span>
<a name="l01014"></a>01014   <span class="comment">// nonempty on *any* processor</span>
<a name="l01015"></a>01015   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> unexpanded_set_nonempty = !unexpanded_set.empty();
<a name="l01016"></a>01016   <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">Parallel::max</a>(unexpanded_set_nonempty);
<a name="l01017"></a>01017 
<a name="l01018"></a>01018   <span class="keywordflow">while</span> (unexpanded_set_nonempty)
<a name="l01019"></a>01019     {
<a name="l01020"></a>01020       <span class="comment">// Request set</span>
<a name="l01021"></a>01021       RCSet request_set;
<a name="l01022"></a>01022 
<a name="l01023"></a>01023       <span class="comment">// Request sets to send to each processor</span>
<a name="l01024"></a>01024       std::vector&lt;std::vector&lt;unsigned int&gt; &gt;
<a name="l01025"></a>01025         requested_ids(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>());
<a name="l01026"></a>01026 
<a name="l01027"></a>01027       <span class="comment">// And the sizes of each</span>
<a name="l01028"></a>01028       std::vector&lt;unsigned int&gt; ids_on_proc(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(), 0);
<a name="l01029"></a>01029 
<a name="l01030"></a>01030       <span class="comment">// Fill (and thereby sort and uniq!) the main request set</span>
<a name="l01031"></a>01031       <span class="keywordflow">for</span> (RCSet::iterator i = unexpanded_set.begin();
<a name="l01032"></a>01032            i != unexpanded_set.end(); ++i)
<a name="l01033"></a>01033         {
<a name="l01034"></a>01034           <a class="code" href="namespacelibMesh.php#a919b3727a9707f23ecad00949d1d1c43">DofConstraintRow</a> &amp;row = _dof_constraints[*i];
<a name="l01035"></a>01035           <span class="keywordflow">for</span> (DofConstraintRow::iterator j = row.begin();
<a name="l01036"></a>01036                j != row.end(); ++j)
<a name="l01037"></a>01037             request_set.insert(j-&gt;first);
<a name="l01038"></a>01038         }
<a name="l01039"></a>01039 
<a name="l01040"></a>01040       <span class="comment">// Clear the unexpanded constraint set; we&#39;re about to expand it</span>
<a name="l01041"></a>01041       unexpanded_set.clear();
<a name="l01042"></a>01042 
<a name="l01043"></a>01043       <span class="comment">// Count requests by processor</span>
<a name="l01044"></a>01044       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id = 0;
<a name="l01045"></a>01045       <span class="keywordflow">for</span> (RCSet::iterator i = request_set.begin();
<a name="l01046"></a>01046            i != request_set.end(); ++i)
<a name="l01047"></a>01047         {
<a name="l01048"></a>01048           <span class="keywordflow">while</span> (*i &gt;= _end_df[proc_id])
<a name="l01049"></a>01049             proc_id++;
<a name="l01050"></a>01050           ids_on_proc[proc_id]++;
<a name="l01051"></a>01051         }
<a name="l01052"></a>01052       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p = 0; p != <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(); ++p)
<a name="l01053"></a>01053         requested_ids[p].reserve(ids_on_proc[p]);
<a name="l01054"></a>01054 
<a name="l01055"></a>01055       <span class="comment">// Prepare each processor&#39;s request set</span>
<a name="l01056"></a>01056       proc_id = 0;
<a name="l01057"></a>01057       <span class="keywordflow">for</span> (RCSet::iterator i = request_set.begin();
<a name="l01058"></a>01058            i != request_set.end(); ++i)
<a name="l01059"></a>01059         {
<a name="l01060"></a>01060           <span class="keywordflow">while</span> (*i &gt;= _end_df[proc_id])
<a name="l01061"></a>01061             proc_id++;
<a name="l01062"></a>01062           requested_ids[proc_id].push_back(*i);
<a name="l01063"></a>01063         }
<a name="l01064"></a>01064 
<a name="l01065"></a>01065       <span class="comment">// Now request constraint rows from other processors</span>
<a name="l01066"></a>01066       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=1; p != <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(); ++p)
<a name="l01067"></a>01067         {
<a name="l01068"></a>01068           <span class="comment">// Trade my requests with processor procup and procdown</span>
<a name="l01069"></a>01069           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> procup = (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() + p) %
<a name="l01070"></a>01070                                  <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>();
<a name="l01071"></a>01071           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> procdown = (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() +
<a name="l01072"></a>01072                                    <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() - p) %
<a name="l01073"></a>01073                                    <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>();
<a name="l01074"></a>01074           std::vector&lt;unsigned int&gt; request_to_fill;
<a name="l01075"></a>01075           <a class="code" href="namespacelibMesh_1_1Parallel.php#acfbfff4a15f9dc0b0abdfb081086dd3b">Parallel::send_receive</a>(procup, requested_ids[procup],
<a name="l01076"></a>01076                                  procdown, request_to_fill);
<a name="l01077"></a>01077 
<a name="l01078"></a>01078           <span class="comment">// Fill those requests</span>
<a name="l01079"></a>01079           std::vector&lt;std::vector&lt;unsigned int&gt; &gt; row_keys(request_to_fill.size());
<a name="l01080"></a>01080           std::vector&lt;std::vector&lt;Real&gt; &gt; row_vals(request_to_fill.size());
<a name="l01081"></a>01081           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != request_to_fill.size(); ++i)
<a name="l01082"></a>01082             {
<a name="l01083"></a>01083               <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> constrained = request_to_fill[i];
<a name="l01084"></a>01084               <span class="keywordflow">if</span> (_dof_constraints.count(constrained))
<a name="l01085"></a>01085                 {
<a name="l01086"></a>01086                   <a class="code" href="namespacelibMesh.php#a919b3727a9707f23ecad00949d1d1c43">DofConstraintRow</a> &amp;row = _dof_constraints[constrained];
<a name="l01087"></a>01087                   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> row_size = row.size();
<a name="l01088"></a>01088                   row_keys[i].reserve(row_size);
<a name="l01089"></a>01089                   row_vals[i].reserve(row_size);
<a name="l01090"></a>01090                   <span class="keywordflow">for</span> (DofConstraintRow::iterator j = row.begin();
<a name="l01091"></a>01091                        j != row.end(); ++j)
<a name="l01092"></a>01092                     {
<a name="l01093"></a>01093                       row_keys[i].push_back(j-&gt;first);
<a name="l01094"></a>01094                       row_vals[i].push_back(j-&gt;second);
<a name="l01095"></a>01095                     }
<a name="l01096"></a>01096                 }
<a name="l01097"></a>01097             }
<a name="l01098"></a>01098 
<a name="l01099"></a>01099           <span class="comment">// Trade back the results</span>
<a name="l01100"></a>01100           std::vector&lt;std::vector&lt;unsigned int&gt; &gt; filled_keys;
<a name="l01101"></a>01101           std::vector&lt;std::vector&lt;Real&gt; &gt; filled_vals;
<a name="l01102"></a>01102           <a class="code" href="namespacelibMesh_1_1Parallel.php#acfbfff4a15f9dc0b0abdfb081086dd3b">Parallel::send_receive</a>(procdown, row_keys,
<a name="l01103"></a>01103                                  procup, filled_keys);
<a name="l01104"></a>01104           <a class="code" href="namespacelibMesh_1_1Parallel.php#acfbfff4a15f9dc0b0abdfb081086dd3b">Parallel::send_receive</a>(procdown, row_vals,
<a name="l01105"></a>01105                                  procup, filled_vals);
<a name="l01106"></a>01106           libmesh_assert (filled_keys.size() == requested_ids[procup].size());
<a name="l01107"></a>01107           libmesh_assert (filled_vals.size() == requested_ids[procup].size());
<a name="l01108"></a>01108 
<a name="l01109"></a>01109           <span class="comment">// Add any new constraint rows we&#39;ve found</span>
<a name="l01110"></a>01110           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != requested_ids[procup].size(); ++i)
<a name="l01111"></a>01111             {
<a name="l01112"></a>01112               libmesh_assert (filled_keys[i].size() == filled_vals[i].size());
<a name="l01113"></a>01113               <span class="keywordflow">if</span> (!filled_keys[i].empty())
<a name="l01114"></a>01114                 {
<a name="l01115"></a>01115                   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> constrained = requested_ids[procup][i];
<a name="l01116"></a>01116                   <a class="code" href="namespacelibMesh.php#a919b3727a9707f23ecad00949d1d1c43">DofConstraintRow</a> &amp;row = _dof_constraints[constrained];
<a name="l01117"></a>01117                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j = 0; j != filled_keys[i].size(); ++j)
<a name="l01118"></a>01118                     row[filled_keys[i][j]] = filled_vals[i][j];
<a name="l01119"></a>01119 
<a name="l01120"></a>01120                   <span class="comment">// And prepare to check for more recursive constraints</span>
<a name="l01121"></a>01121                   unexpanded_set.insert(constrained);
<a name="l01122"></a>01122                 }
<a name="l01123"></a>01123             }
<a name="l01124"></a>01124         }
<a name="l01125"></a>01125 
<a name="l01126"></a>01126       <span class="comment">// We have to keep recursing while the unexpanded set is</span>
<a name="l01127"></a>01127       <span class="comment">// nonempty on *any* processor</span>
<a name="l01128"></a>01128       unexpanded_set_nonempty = !unexpanded_set.empty();
<a name="l01129"></a>01129       <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">Parallel::max</a>(unexpanded_set_nonempty);
<a name="l01130"></a>01130     }
<a name="l01131"></a>01131 }
<a name="l01132"></a>01132 
<a name="l01133"></a>01133 
<a name="l01134"></a>01134 
<a name="l01135"></a><a class="code" href="classlibMesh_1_1DofMap.php#ad48c72b8add66781d21ad77a3febe59d">01135</a> <span class="keywordtype">void</span> DofMap::process_constraints ()
<a name="l01136"></a>01136 {
<a name="l01137"></a>01137   <span class="comment">// Create a set containing the DOFs we already depend on</span>
<a name="l01138"></a>01138   <span class="keyword">typedef</span> std::set&lt;unsigned int&gt; RCSet;
<a name="l01139"></a>01139   RCSet unexpanded_set;
<a name="l01140"></a>01140 
<a name="l01141"></a>01141   <span class="keywordflow">for</span> (DofConstraints::iterator i = _dof_constraints.begin();
<a name="l01142"></a>01142          i != _dof_constraints.end(); ++i)
<a name="l01143"></a>01143     unexpanded_set.insert(i-&gt;first);
<a name="l01144"></a>01144 
<a name="l01145"></a>01145   <span class="keywordflow">while</span> (!unexpanded_set.empty())
<a name="l01146"></a>01146     <span class="keywordflow">for</span> (RCSet::iterator i = unexpanded_set.begin();
<a name="l01147"></a>01147          i != unexpanded_set.end(); <span class="comment">/* nothing */</span>)
<a name="l01148"></a>01148       {
<a name="l01149"></a>01149         <span class="comment">// If the DOF is constrained</span>
<a name="l01150"></a>01150         DofConstraints::iterator
<a name="l01151"></a>01151           pos = _dof_constraints.find(*i);
<a name="l01152"></a>01152         
<a name="l01153"></a>01153         libmesh_assert (pos != _dof_constraints.end());
<a name="l01154"></a>01154         
<a name="l01155"></a>01155         <a class="code" href="namespacelibMesh.php#a919b3727a9707f23ecad00949d1d1c43">DofConstraintRow</a>&amp; constraint_row = pos-&gt;second;
<a name="l01156"></a>01156 
<a name="l01157"></a>01157         std::vector&lt;unsigned int&gt; constraints_to_expand;
<a name="l01158"></a>01158 
<a name="l01159"></a>01159         <span class="keywordflow">for</span> (DofConstraintRow::const_iterator
<a name="l01160"></a>01160                it=constraint_row.begin(); it != constraint_row.end();
<a name="l01161"></a>01161              ++it)
<a name="l01162"></a>01162           <span class="keywordflow">if</span> (this-&gt;is_constrained_dof(it-&gt;first))
<a name="l01163"></a>01163             {
<a name="l01164"></a>01164               unexpanded_set.insert(it-&gt;first);
<a name="l01165"></a>01165               constraints_to_expand.push_back(it-&gt;first);
<a name="l01166"></a>01166             }
<a name="l01167"></a>01167 
<a name="l01168"></a>01168         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j = 0; j != constraints_to_expand.size();
<a name="l01169"></a>01169              ++j)
<a name="l01170"></a>01170           {
<a name="l01171"></a>01171             <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> expandable = constraints_to_expand[j];
<a name="l01172"></a>01172 
<a name="l01173"></a>01173             DofConstraints::const_iterator
<a name="l01174"></a>01174               subpos = _dof_constraints.find(expandable);
<a name="l01175"></a>01175         
<a name="l01176"></a>01176             libmesh_assert (subpos != _dof_constraints.end());
<a name="l01177"></a>01177         
<a name="l01178"></a>01178             <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#a919b3727a9707f23ecad00949d1d1c43">DofConstraintRow</a>&amp; subconstraint_row = subpos-&gt;second;
<a name="l01179"></a>01179             
<a name="l01180"></a>01180             <span class="keywordflow">for</span> (DofConstraintRow::const_iterator
<a name="l01181"></a>01181                    it=subconstraint_row.begin();
<a name="l01182"></a>01182                    it != subconstraint_row.end(); ++it)
<a name="l01183"></a>01183               {
<a name="l01184"></a>01184                 constraint_row[it-&gt;first] += it-&gt;second *
<a name="l01185"></a>01185                                 constraint_row[expandable];
<a name="l01186"></a>01186               }
<a name="l01187"></a>01187             constraint_row.erase(expandable);
<a name="l01188"></a>01188           }
<a name="l01189"></a>01189 
<a name="l01190"></a>01190         <span class="keywordflow">if</span> (constraints_to_expand.empty())
<a name="l01191"></a>01191           unexpanded_set.erase(i++);
<a name="l01192"></a>01192         <span class="keywordflow">else</span>
<a name="l01193"></a>01193           i++;
<a name="l01194"></a>01194       }
<a name="l01195"></a>01195 
<a name="l01196"></a>01196   <span class="comment">// Now that we have our root constraint dependencies sorted out, add</span>
<a name="l01197"></a>01197   <span class="comment">// them to the send_list</span>
<a name="l01198"></a>01198   this-&gt;add_constraints_to_send_list();
<a name="l01199"></a>01199 }
<a name="l01200"></a>01200 
<a name="l01201"></a>01201 
<a name="l01202"></a>01202 
<a name="l01203"></a><a class="code" href="classlibMesh_1_1DofMap.php#a0783b9a05a297be8f1c3e630301e0604">01203</a> <span class="keywordtype">void</span> DofMap::add_constraints_to_send_list()
<a name="l01204"></a>01204 {
<a name="l01205"></a>01205   <span class="comment">// This function must be run on all processors at once</span>
<a name="l01206"></a>01206   parallel_only();
<a name="l01207"></a>01207 
<a name="l01208"></a>01208   <span class="comment">// Return immediately if there&#39;s nothing to gather</span>
<a name="l01209"></a>01209   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() == 1)
<a name="l01210"></a>01210     <span class="keywordflow">return</span>;
<a name="l01211"></a>01211 
<a name="l01212"></a>01212   <span class="comment">// We might get to return immediately if none of the processors</span>
<a name="l01213"></a>01213   <span class="comment">// found any constraints</span>
<a name="l01214"></a>01214   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> has_constraints = !_dof_constraints.empty();
<a name="l01215"></a>01215   <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">Parallel::max</a>(has_constraints);
<a name="l01216"></a>01216   <span class="keywordflow">if</span> (!has_constraints)
<a name="l01217"></a>01217     <span class="keywordflow">return</span>;
<a name="l01218"></a>01218 
<a name="l01219"></a>01219   <span class="keywordflow">for</span> (DofConstraints::iterator i = _dof_constraints.begin();
<a name="l01220"></a>01220          i != _dof_constraints.end(); ++i)
<a name="l01221"></a>01221     {
<a name="l01222"></a>01222       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> constrained_dof = i-&gt;first;
<a name="l01223"></a>01223 
<a name="l01224"></a>01224       <span class="comment">// We only need the dependencies of our own constrained dofs</span>
<a name="l01225"></a>01225       <span class="keywordflow">if</span> (constrained_dof &lt; this-&gt;first_dof() || 
<a name="l01226"></a>01226           constrained_dof &gt;= this-&gt;end_dof())
<a name="l01227"></a>01227         <span class="keywordflow">continue</span>;
<a name="l01228"></a>01228 
<a name="l01229"></a>01229       <a class="code" href="namespacelibMesh.php#a919b3727a9707f23ecad00949d1d1c43">DofConstraintRow</a>&amp; constraint_row = i-&gt;second;
<a name="l01230"></a>01230       <span class="keywordflow">for</span> (DofConstraintRow::const_iterator
<a name="l01231"></a>01231            j=constraint_row.begin(); j != constraint_row.end();
<a name="l01232"></a>01232            ++j)
<a name="l01233"></a>01233         {
<a name="l01234"></a>01234           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> constraint_dependency = j-&gt;first;
<a name="l01235"></a>01235 
<a name="l01236"></a>01236           <span class="comment">// No point in adding one of our own dofs to the send_list</span>
<a name="l01237"></a>01237           <span class="keywordflow">if</span> (constraint_dependency &gt;= this-&gt;first_dof() &amp;&amp; 
<a name="l01238"></a>01238               constraint_dependency &lt; this-&gt;end_dof())
<a name="l01239"></a>01239             <span class="keywordflow">continue</span>;
<a name="l01240"></a>01240 
<a name="l01241"></a>01241           _send_list.push_back(constraint_dependency);
<a name="l01242"></a>01242         }
<a name="l01243"></a>01243     }
<a name="l01244"></a>01244 }
<a name="l01245"></a>01245 
<a name="l01246"></a>01246 
<a name="l01247"></a>01247 
<a name="l01248"></a>01248 <span class="preprocessor">#endif // LIBMESH_ENABLE_AMR || LIBMESH_ENABLE_PERIODIC</span>
<a name="l01249"></a>01249 <span class="preprocessor"></span>
<a name="l01250"></a>01250 
<a name="l01251"></a>01251 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l01252"></a>01252 <span class="preprocessor"></span>
<a name="l01253"></a><a class="code" href="classlibMesh_1_1DofMap.php#a1c8e17a57f38de4ae0060311b5497989">01253</a> <span class="keywordtype">void</span> DofMap::constrain_p_dofs (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var,
<a name="l01254"></a>01254                                <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *elem,
<a name="l01255"></a>01255                                <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s,
<a name="l01256"></a>01256                                <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p)
<a name="l01257"></a>01257 {
<a name="l01258"></a>01258   <span class="comment">// We&#39;re constraining dofs on elem which correspond to p refinement</span>
<a name="l01259"></a>01259   <span class="comment">// levels above p - this only makes sense if elem&#39;s p refinement</span>
<a name="l01260"></a>01260   <span class="comment">// level is above p.</span>
<a name="l01261"></a>01261   libmesh_assert(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>() &gt; p);
<a name="l01262"></a>01262   libmesh_assert(s &lt; elem-&gt;n_sides());
<a name="l01263"></a>01263 
<a name="l01264"></a>01264   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sys_num = this-&gt;sys_number();
<a name="l01265"></a>01265   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#aa50d97d65dc379f64667da53c427b36f">dim</a>();
<a name="l01266"></a>01266   <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad06f8ac22978144723179eed42d10bae">type</a>();
<a name="l01267"></a>01267   <a class="code" href="classlibMesh_1_1FEType.php">FEType</a> low_p_fe_type = this-&gt;variable_type(var);
<a name="l01268"></a>01268   <a class="code" href="classlibMesh_1_1FEType.php">FEType</a> high_p_fe_type = this-&gt;variable_type(var);
<a name="l01269"></a>01269   low_p_fe_type.<a class="code" href="classlibMesh_1_1FEType.php#aa2484e0f6721f3e34dedebccacc48ac1">order</a> = <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a><span class="keyword">&gt;</span>(low_p_fe_type.<a class="code" href="classlibMesh_1_1FEType.php#aa2484e0f6721f3e34dedebccacc48ac1">order</a> + p);
<a name="l01270"></a>01270   high_p_fe_type.<a class="code" href="classlibMesh_1_1FEType.php#aa2484e0f6721f3e34dedebccacc48ac1">order</a> = <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a><span class="keyword">&gt;</span>(high_p_fe_type.<a class="code" href="classlibMesh_1_1FEType.php#aa2484e0f6721f3e34dedebccacc48ac1">order</a> + 
<a name="l01271"></a>01271                                             elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>());
<a name="l01272"></a>01272 
<a name="l01273"></a>01273   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="tecplot__io_8C.php#ad00604777dd9213f9627d8f12e3b2790">n_nodes</a> = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>();
<a name="l01274"></a>01274   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n = 0; n != <a class="code" href="tecplot__io_8C.php#ad00604777dd9213f9627d8f12e3b2790">n_nodes</a>; ++n)
<a name="l01275"></a>01275     <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a095386c4644b0478229289f281f2f8e4">is_node_on_side</a>(n, s))
<a name="l01276"></a>01276       {
<a name="l01277"></a>01277         <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a> * <span class="keyword">const</span> node = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(n);
<a name="l01278"></a>01278         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> low_nc =
<a name="l01279"></a>01279           FEInterface::n_dofs_at_node (dim, low_p_fe_type, type, n);
<a name="l01280"></a>01280         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> high_nc =
<a name="l01281"></a>01281           FEInterface::n_dofs_at_node (dim, high_p_fe_type, type, n);
<a name="l01282"></a>01282         
<a name="l01283"></a>01283         <span class="comment">// since we may be running this method concurretly </span>
<a name="l01284"></a>01284         <span class="comment">// on multiple threads we need to acquire a lock </span>
<a name="l01285"></a>01285         <span class="comment">// before modifying the _dof_constraints object.</span>
<a name="l01286"></a>01286         Threads::spin_mutex::scoped_lock lock(<a class="code" href="namespacelibMesh_1_1Threads.php#aba1ae5c24686d2cd2fc7ccdc9537c4f5">Threads::spin_mtx</a>);
<a name="l01287"></a>01287         
<a name="l01288"></a>01288         <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac56e382d9871ff243a781940ee13ed87">is_vertex</a>(n))
<a name="l01289"></a>01289           {
<a name="l01290"></a>01290             <span class="comment">// Add &quot;this is zero&quot; constraint rows for high p vertex</span>
<a name="l01291"></a>01291             <span class="comment">// dofs</span>
<a name="l01292"></a>01292             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = low_nc; i != high_nc; ++i)
<a name="l01293"></a>01293               _dof_constraints[node-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a99664433bae4e638f8befc83cec4eeff">dof_number</a>(sys_num,var,i)].clear();
<a name="l01294"></a>01294           }
<a name="l01295"></a>01295         <span class="keywordflow">else</span>
<a name="l01296"></a>01296           {
<a name="l01297"></a>01297             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> total_dofs = node-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a6710a2bb047a60ef54bfe702432114f8">n_comp</a>(sys_num, var);
<a name="l01298"></a>01298             libmesh_assert(total_dofs &gt;= high_nc);
<a name="l01299"></a>01299             <span class="comment">// Add &quot;this is zero&quot; constraint rows for high p</span>
<a name="l01300"></a>01300             <span class="comment">// non-vertex dofs, which are numbered in reverse</span>
<a name="l01301"></a>01301             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j = low_nc; j != high_nc; ++j)
<a name="l01302"></a>01302               {
<a name="l01303"></a>01303                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = total_dofs - j - 1;
<a name="l01304"></a>01304                 _dof_constraints[node-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a99664433bae4e638f8befc83cec4eeff">dof_number</a>(sys_num,var,i)].clear();
<a name="l01305"></a>01305               }
<a name="l01306"></a>01306           }
<a name="l01307"></a>01307       }
<a name="l01308"></a>01308 }
<a name="l01309"></a>01309 
<a name="l01310"></a>01310 <span class="preprocessor">#endif // LIBMESH_ENABLE_AMR</span>
<a name="l01311"></a>01311 <span class="preprocessor"></span>
<a name="l01312"></a>01312 
<a name="l01313"></a>01313 <span class="preprocessor">#ifdef LIBMESH_ENABLE_PERIODIC</span>
<a name="l01314"></a>01314 <span class="preprocessor"></span>
<a name="l01315"></a><a class="code" href="classlibMesh_1_1DofMap.php#a2f0a90f17fba3db87f78f8813e111ac2">01315</a> <span class="keywordtype">void</span> DofMap::add_periodic_boundary (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1PeriodicBoundary.php">PeriodicBoundary</a>&amp; periodic_boundary)
<a name="l01316"></a>01316 {
<a name="l01317"></a>01317   <a class="code" href="classlibMesh_1_1PeriodicBoundary.php">PeriodicBoundary</a> *boundary = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1PeriodicBoundary.php">PeriodicBoundary</a>(periodic_boundary);
<a name="l01318"></a>01318   <a class="code" href="classlibMesh_1_1PeriodicBoundary.php">PeriodicBoundary</a> *inverse_boundary = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1PeriodicBoundary.php">PeriodicBoundary</a>(periodic_boundary, <span class="keyword">true</span>);
<a name="l01319"></a>01319 
<a name="l01320"></a>01320   std::pair&lt;unsigned int, PeriodicBoundary *&gt; bp
<a name="l01321"></a>01321     (boundary-&gt;<a class="code" href="classlibMesh_1_1PeriodicBoundary.php#a9b672ef0d74f6179e33c13bd8632e78b">myboundary</a>, boundary);
<a name="l01322"></a>01322   std::pair&lt;unsigned int, PeriodicBoundary *&gt; ibp
<a name="l01323"></a>01323     (boundary-&gt;<a class="code" href="classlibMesh_1_1PeriodicBoundary.php#a8f33f69366325248b3b337975061ba3e">pairedboundary</a>, inverse_boundary);
<a name="l01324"></a>01324 
<a name="l01325"></a>01325   _periodic_boundaries-&gt;insert(bp);
<a name="l01326"></a>01326   _periodic_boundaries-&gt;insert(ibp);
<a name="l01327"></a>01327 }
<a name="l01328"></a>01328 
<a name="l01329"></a><a class="code" href="classlibMesh_1_1DofMap.php#ad683850a2762d9bbd2f4c8f4a12e749a">01329</a> <span class="keywordtype">void</span> DofMap::add_periodic_boundary (<a class="code" href="classlibMesh_1_1PeriodicBoundary.php">PeriodicBoundary</a> * boundary, <a class="code" href="classlibMesh_1_1PeriodicBoundary.php">PeriodicBoundary</a> * inverse_boundary)
<a name="l01330"></a>01330 {
<a name="l01331"></a>01331   libmesh_assert(boundary-&gt;<a class="code" href="classlibMesh_1_1PeriodicBoundary.php#a9b672ef0d74f6179e33c13bd8632e78b">myboundary</a> == inverse_boundary-&gt;<a class="code" href="classlibMesh_1_1PeriodicBoundary.php#a8f33f69366325248b3b337975061ba3e">pairedboundary</a>);
<a name="l01332"></a>01332   libmesh_assert(boundary-&gt;<a class="code" href="classlibMesh_1_1PeriodicBoundary.php#a8f33f69366325248b3b337975061ba3e">pairedboundary</a> == inverse_boundary-&gt;<a class="code" href="classlibMesh_1_1PeriodicBoundary.php#a9b672ef0d74f6179e33c13bd8632e78b">myboundary</a>);
<a name="l01333"></a>01333 
<a name="l01334"></a>01334   std::pair&lt;unsigned int, PeriodicBoundary *&gt; bp(boundary-&gt;<a class="code" href="classlibMesh_1_1PeriodicBoundary.php#a9b672ef0d74f6179e33c13bd8632e78b">myboundary</a>, boundary);
<a name="l01335"></a>01335   std::pair&lt;unsigned int, PeriodicBoundary *&gt; ibp(inverse_boundary-&gt;<a class="code" href="classlibMesh_1_1PeriodicBoundary.php#a9b672ef0d74f6179e33c13bd8632e78b">myboundary</a>, inverse_boundary);
<a name="l01336"></a>01336 
<a name="l01337"></a>01337   _periodic_boundaries-&gt;insert(bp);
<a name="l01338"></a>01338   _periodic_boundaries-&gt;insert(ibp);
<a name="l01339"></a>01339 }
<a name="l01340"></a>01340 
<a name="l01341"></a>01341 <span class="comment">// ------------------------------------------------------------</span>
<a name="l01342"></a>01342 <span class="comment">// PeriodicBoundaries member functions</span>
<a name="l01343"></a>01343 
<a name="l01344"></a><a class="code" href="classlibMesh_1_1PeriodicBoundaries.php#aa7921d23950abb00801648c34f389786">01344</a> PeriodicBoundaries::~PeriodicBoundaries()
<a name="l01345"></a>01345 {
<a name="l01346"></a>01346   <span class="keywordflow">for</span> (std::map&lt;unsigned, PeriodicBoundary *&gt;::iterator it = begin(); it != end(); ++it)
<a name="l01347"></a>01347     <span class="keyword">delete</span> it-&gt;second;
<a name="l01348"></a>01348 }
<a name="l01349"></a>01349 
<a name="l01350"></a><a class="code" href="classlibMesh_1_1PeriodicBoundaries.php#a4511ea486a681ba02682859339e0a5bc">01350</a> <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *PeriodicBoundaries::neighbor(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> boundary_id,
<a name="l01351"></a>01351                                          <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp;<a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>,
<a name="l01352"></a>01352                                          <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *e,
<a name="l01353"></a>01353                                          <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>)
<a name="l01354"></a>01354 {
<a name="l01355"></a>01355   <span class="comment">// Find a point on that side (and only that side)</span>
<a name="l01356"></a>01356 
<a name="l01357"></a>01357   <a class="code" href="classlibMesh_1_1Point.php">Point</a> p = e-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adf633f222ddcbe450345c98c68050fda">build_side</a>(side)-&gt;centroid();
<a name="l01358"></a>01358 
<a name="l01359"></a>01359   <a class="code" href="classlibMesh_1_1PeriodicBoundary.php">PeriodicBoundary</a> *b = this-&gt;boundary(boundary_id);
<a name="l01360"></a>01360   libmesh_assert (b);
<a name="l01361"></a>01361   p = b-&gt;<a class="code" href="classlibMesh_1_1PeriodicBoundary.php#a5783217f512a5e85501d8782794b6972">get_corresponding_pos</a>(p);
<a name="l01362"></a>01362 
<a name="l01363"></a>01363   <span class="keywordflow">return</span> mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a122877d5316f9035967c6ed10d86a520">point_locator</a>().operator()(p);
<a name="l01364"></a>01364 }
<a name="l01365"></a>01365 
<a name="l01366"></a>01366 <span class="preprocessor">#endif</span>
<a name="l01367"></a>01367 <span class="preprocessor"></span>
<a name="l01368"></a>01368 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
