<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_eaf30c8ea092d33f79a04353c3899c3f.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_5a0c7151fa56969ceb962f1511f7edee.php">systems</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">equation_systems.h</div>  </div>
</div>
<div class="contents">
<a href="equation__systems_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id$</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __equation_systems_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __equation_systems_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;set&gt;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &lt;map&gt;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &lt;string&gt;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="comment">// Local Includes</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="parameters_8h.php">parameters.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="system_8h.php">system.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="enum__xdr__mode_8h.php">enum_xdr_mode.h</a>&quot;</span>
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="comment">// HP aCC needs these for some reason</span>
<a name="l00038"></a>00038 <span class="preprocessor">#ifdef __HP_aCC</span>
<a name="l00039"></a>00039 <span class="preprocessor"></span><span class="preprocessor"># include &quot;<a class="code" href="frequency__system_8h.php">frequency_system.h</a>&quot;</span>
<a name="l00040"></a>00040 <span class="preprocessor"># include &quot;<a class="code" href="transient__system_8h.php">transient_system.h</a>&quot;</span>
<a name="l00041"></a>00041 <span class="preprocessor"># include &quot;<a class="code" href="newmark__system_8h.php">newmark_system.h</a>&quot;</span>
<a name="l00042"></a>00042 <span class="preprocessor"># include &quot;<a class="code" href="steady__system_8h.php">steady_system.h</a>&quot;</span>
<a name="l00043"></a>00043 <span class="preprocessor">#endif</span>
<a name="l00044"></a>00044 <span class="preprocessor"></span>
<a name="l00045"></a>00045 <span class="keyword">namespace </span>libMesh
<a name="l00046"></a>00046 {
<a name="l00047"></a>00047 
<a name="l00048"></a>00048 <span class="comment">// Forward Declarations</span>
<a name="l00049"></a>00049 <span class="keyword">class </span>MeshData;
<a name="l00050"></a>00050 <span class="keyword">class </span>Elem;
<a name="l00051"></a>00051 <span class="keyword">class </span>MeshBase;
<a name="l00052"></a>00052 
<a name="l00066"></a>00066 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00067"></a>00067 <span class="comment">// EquationSystems class definition</span>
<a name="l00068"></a><a class="code" href="classlibMesh_1_1EquationSystems.php">00068</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1ReferenceCountedObject.php">ReferenceCountedObject</a>&lt;EquationSystems&gt;
<a name="l00069"></a>00069 {
<a name="l00070"></a>00070 <span class="keyword">public</span>:
<a name="l00071"></a>00071 
<a name="l00075"></a><a class="code" href="classlibMesh_1_1EquationSystems.php#a9a3b0e740fd481142a43130304066e35">00075</a>   <span class="keyword">enum</span> <a class="code" href="classlibMesh_1_1EquationSystems.php#a9a3b0e740fd481142a43130304066e35">ReadFlags</a> { <a class="code" href="classlibMesh_1_1EquationSystems.php#a9a3b0e740fd481142a43130304066e35a95b7895de1a30e716b72af7155b5aa84">READ_HEADER</a>           = 1,
<a name="l00076"></a><a class="code" href="classlibMesh_1_1EquationSystems.php#a9a3b0e740fd481142a43130304066e35ac343ca4237c893115866c2c582b30f7b">00076</a>                    <a class="code" href="classlibMesh_1_1EquationSystems.php#a9a3b0e740fd481142a43130304066e35ac343ca4237c893115866c2c582b30f7b">READ_DATA</a>             = 2,
<a name="l00077"></a><a class="code" href="classlibMesh_1_1EquationSystems.php#a9a3b0e740fd481142a43130304066e35a681bafe8583d3817a7731913b8c997a5">00077</a>                    <a class="code" href="classlibMesh_1_1EquationSystems.php#a9a3b0e740fd481142a43130304066e35a681bafe8583d3817a7731913b8c997a5">READ_ADDITIONAL_DATA</a>  = 4,
<a name="l00078"></a><a class="code" href="classlibMesh_1_1EquationSystems.php#a9a3b0e740fd481142a43130304066e35a0fb381d3591f7a039ebd249d080535c0">00078</a>                    <a class="code" href="classlibMesh_1_1EquationSystems.php#a9a3b0e740fd481142a43130304066e35a0fb381d3591f7a039ebd249d080535c0">READ_LEGACY_FORMAT</a>    = 8,
<a name="l00079"></a><a class="code" href="classlibMesh_1_1EquationSystems.php#a9a3b0e740fd481142a43130304066e35a35e7008af7ae308c3a10e42cf78ebc17">00079</a>                    <a class="code" href="classlibMesh_1_1EquationSystems.php#a9a3b0e740fd481142a43130304066e35a35e7008af7ae308c3a10e42cf78ebc17">TRY_READ_IFEMS</a>        = 16 };
<a name="l00080"></a>00080 
<a name="l00084"></a><a class="code" href="classlibMesh_1_1EquationSystems.php#a6a315352a9c8f99542d4c589c45b2532">00084</a>   <span class="keyword">enum</span> <a class="code" href="classlibMesh_1_1EquationSystems.php#a6a315352a9c8f99542d4c589c45b2532">WriteFlags</a> { <a class="code" href="classlibMesh_1_1EquationSystems.php#a6a315352a9c8f99542d4c589c45b2532ab363df4400f883ee435550e14b84c2b2">WRITE_DATA</a>             = 1,
<a name="l00085"></a><a class="code" href="classlibMesh_1_1EquationSystems.php#a6a315352a9c8f99542d4c589c45b2532adb3b46d8dd4d07aad77c353eafc3e2a8">00085</a>                     <a class="code" href="classlibMesh_1_1EquationSystems.php#a6a315352a9c8f99542d4c589c45b2532adb3b46d8dd4d07aad77c353eafc3e2a8">WRITE_ADDITIONAL_DATA</a>  = 2,
<a name="l00086"></a><a class="code" href="classlibMesh_1_1EquationSystems.php#a6a315352a9c8f99542d4c589c45b2532ac1fc13fe2627f7fb98944185ae68df71">00086</a>                     <a class="code" href="classlibMesh_1_1EquationSystems.php#a6a315352a9c8f99542d4c589c45b2532ac1fc13fe2627f7fb98944185ae68df71">WRITE_PARALLEL_FILES</a>   = 4 };
<a name="l00087"></a>00087   
<a name="l00091"></a>00091   <a class="code" href="classlibMesh_1_1EquationSystems.php#a49489a225ff814ce0e2df83f153a6c06">EquationSystems</a> (<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>, <a class="code" href="classlibMesh_1_1MeshData.php">MeshData</a>* mesh_data=NULL);
<a name="l00092"></a>00092 
<a name="l00097"></a>00097   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1EquationSystems.php#a329b3f85c7dafc3df8ffd9d052584fa7">~EquationSystems</a> ();
<a name="l00098"></a>00098  
<a name="l00102"></a>00102   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EquationSystems.php#ac2353c8c83f2b9d2aafb05acfda445be">clear</a> ();
<a name="l00103"></a>00103   
<a name="l00107"></a>00107   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EquationSystems.php#aa79320b68e236ece82d5b358721ebd13">init</a> ();
<a name="l00108"></a>00108   
<a name="l00112"></a>00112   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EquationSystems.php#a1634fa5937c4d915d83c35d591ed7c05">reinit</a> ();
<a name="l00113"></a>00113 
<a name="l00117"></a>00117   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EquationSystems.php#a3f4875f0168a7c02cd09e006b7edcddf">update</a> ();
<a name="l00118"></a>00118 
<a name="l00122"></a>00122   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1EquationSystems.php#a93238b71a514e6d24f284e5f92947fbe">n_systems</a>() <span class="keyword">const</span>;
<a name="l00123"></a>00123 
<a name="l00128"></a>00128   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1EquationSystems.php#a5119f662bf0ea98b1df8f3f94ac5cf11">has_system</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>) <span class="keyword">const</span>;
<a name="l00129"></a>00129 
<a name="l00136"></a>00136   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T_sys&gt;
<a name="l00137"></a>00137   <span class="keyword">const</span> T_sys &amp; <a class="code" href="classlibMesh_1_1EquationSystems.php#a5dac23f839af25ce7dbf1fe9a6d4b67a">get_system</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>) <span class="keyword">const</span>;
<a name="l00138"></a>00138 
<a name="l00145"></a>00145   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T_sys&gt;
<a name="l00146"></a>00146   T_sys &amp; <a class="code" href="classlibMesh_1_1EquationSystems.php#a5dac23f839af25ce7dbf1fe9a6d4b67a">get_system</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>);
<a name="l00147"></a>00147 
<a name="l00154"></a>00154   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T_sys&gt;
<a name="l00155"></a>00155   <span class="keyword">const</span> T_sys &amp; <a class="code" href="classlibMesh_1_1EquationSystems.php#a5dac23f839af25ce7dbf1fe9a6d4b67a">get_system</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> num) <span class="keyword">const</span>;
<a name="l00156"></a>00156 
<a name="l00163"></a>00163   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T_sys&gt;
<a name="l00164"></a>00164   T_sys &amp; <a class="code" href="classlibMesh_1_1EquationSystems.php#a5dac23f839af25ce7dbf1fe9a6d4b67a">get_system</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> num);
<a name="l00165"></a>00165 
<a name="l00169"></a>00169   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a> &amp; <a class="code" href="classlibMesh_1_1EquationSystems.php#a5dac23f839af25ce7dbf1fe9a6d4b67a">get_system</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>) <span class="keyword">const</span>;
<a name="l00170"></a>00170 
<a name="l00174"></a>00174   <a class="code" href="classlibMesh_1_1System.php">System</a> &amp; <a class="code" href="classlibMesh_1_1EquationSystems.php#a5dac23f839af25ce7dbf1fe9a6d4b67a">get_system</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>);
<a name="l00175"></a>00175 
<a name="l00179"></a>00179   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a> &amp; <a class="code" href="classlibMesh_1_1EquationSystems.php#a5dac23f839af25ce7dbf1fe9a6d4b67a">get_system</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> num) <span class="keyword">const</span>;
<a name="l00180"></a>00180 
<a name="l00184"></a>00184   <a class="code" href="classlibMesh_1_1System.php">System</a> &amp; <a class="code" href="classlibMesh_1_1EquationSystems.php#a5dac23f839af25ce7dbf1fe9a6d4b67a">get_system</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> num);
<a name="l00185"></a>00185   
<a name="l00190"></a>00190   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1System.php">System</a> &amp; <a class="code" href="classlibMesh_1_1EquationSystems.php#a09450d5e4547d8b2e5690043da03dbd3">add_system</a> (<span class="keyword">const</span> std::string&amp; system_type,
<a name="l00191"></a>00191                                <span class="keyword">const</span> std::string&amp; <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>);
<a name="l00192"></a>00192   
<a name="l00196"></a>00196   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T_sys&gt;
<a name="l00197"></a>00197   T_sys &amp; <a class="code" href="classlibMesh_1_1EquationSystems.php#a09450d5e4547d8b2e5690043da03dbd3">add_system</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>);
<a name="l00198"></a>00198   
<a name="l00204"></a>00204   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EquationSystems.php#ace47cf459c29a740bd88c5a2d7f8b5fa">delete_system</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>);
<a name="l00205"></a>00205 
<a name="l00210"></a>00210   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1EquationSystems.php#a110251f64665b11b6c93ed293313b8e7">n_vars</a> () <span class="keyword">const</span>;
<a name="l00211"></a>00211   
<a name="l00216"></a>00216   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1EquationSystems.php#af378a53904cbe83a0dfacfa3d9f9f1a5">n_dofs</a> () <span class="keyword">const</span>;
<a name="l00217"></a>00217 
<a name="l00222"></a>00222   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1EquationSystems.php#a9b15b626660071b21314ed9018b4fc85">n_active_dofs</a>() <span class="keyword">const</span>;
<a name="l00223"></a>00223   
<a name="l00232"></a>00232   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EquationSystems.php#ae63435d018c0c5cd6d0b72547afc0032">solve</a> ();
<a name="l00233"></a>00233   
<a name="l00242"></a>00242   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EquationSystems.php#abf595c7f10f4234ab6027e6aea712935">adjoint_solve</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a>&amp; qoi_indices = <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a>());
<a name="l00243"></a>00243 
<a name="l00252"></a>00252   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EquationSystems.php#a365876dded3fa6105838e633d0f33ee4">sensitivity_solve</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ParameterVector.php">ParameterVector</a>&amp; <a class="code" href="classlibMesh_1_1EquationSystems.php#a7c02be232f564967ca0804a7824adb53">parameters</a>);
<a name="l00253"></a>00253 
<a name="l00258"></a>00258   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EquationSystems.php#aa050d0013c82f8a646d0ec583e142341">build_variable_names</a> (std::vector&lt;std::string&gt;&amp; var_names) <span class="keyword">const</span>;
<a name="l00259"></a>00259 
<a name="l00266"></a>00266   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EquationSystems.php#a2c7a089f06d24e9f42330d849ab18503">build_solution_vector</a> (std::vector&lt;Number&gt;&amp; soln,
<a name="l00267"></a>00267                               <span class="keyword">const</span> std::string&amp; system_name,
<a name="l00268"></a>00268                               <span class="keyword">const</span> std::string&amp; variable_name = <span class="stringliteral">&quot;all_vars&quot;</span>) <span class="keyword">const</span>;
<a name="l00269"></a>00269   
<a name="l00275"></a>00275   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EquationSystems.php#a2c7a089f06d24e9f42330d849ab18503">build_solution_vector</a> (std::vector&lt;Number&gt;&amp; soln) <span class="keyword">const</span>;
<a name="l00276"></a>00276   
<a name="l00282"></a>00282   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EquationSystems.php#a6916bc3c57d591cccb2e485e663df8d3">build_discontinuous_solution_vector</a> (std::vector&lt;Number&gt;&amp; soln) <span class="keyword">const</span>;
<a name="l00283"></a>00283   
<a name="l00300"></a>00300   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EquationSystems.php#a1ce9dd49162b1cd340ddcefbc0c8111f">read</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>,
<a name="l00301"></a>00301              <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8">libMeshEnums::XdrMODE</a>,
<a name="l00302"></a>00302              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> read_flags=(<a class="code" href="classlibMesh_1_1EquationSystems.php#a9a3b0e740fd481142a43130304066e35a95b7895de1a30e716b72af7155b5aa84">READ_HEADER</a> | <a class="code" href="classlibMesh_1_1EquationSystems.php#a9a3b0e740fd481142a43130304066e35ac343ca4237c893115866c2c582b30f7b">READ_DATA</a>));
<a name="l00303"></a>00303 
<a name="l00304"></a>00304   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EquationSystems.php#a1ce9dd49162b1cd340ddcefbc0c8111f">read</a> (<span class="keyword">const</span> std::string&amp; name,
<a name="l00305"></a>00305              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> read_flags=(<a class="code" href="classlibMesh_1_1EquationSystems.php#a9a3b0e740fd481142a43130304066e35a95b7895de1a30e716b72af7155b5aa84">READ_HEADER</a> | <a class="code" href="classlibMesh_1_1EquationSystems.php#a9a3b0e740fd481142a43130304066e35ac343ca4237c893115866c2c582b30f7b">READ_DATA</a>));
<a name="l00306"></a>00306 
<a name="l00322"></a>00322   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EquationSystems.php#a854ce8b16e0ea2dac288915647f73879">write</a> (<span class="keyword">const</span> std::string&amp; name,
<a name="l00323"></a>00323               <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8">libMeshEnums::XdrMODE</a>,
<a name="l00324"></a>00324               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> write_flags=(<a class="code" href="classlibMesh_1_1EquationSystems.php#a6a315352a9c8f99542d4c589c45b2532ab363df4400f883ee435550e14b84c2b2">WRITE_DATA</a>)) <span class="keyword">const</span>;
<a name="l00325"></a>00325 
<a name="l00326"></a>00326   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EquationSystems.php#a854ce8b16e0ea2dac288915647f73879">write</a> (<span class="keyword">const</span> std::string&amp; name,
<a name="l00327"></a>00327               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> write_flags=(<a class="code" href="classlibMesh_1_1EquationSystems.php#a6a315352a9c8f99542d4c589c45b2532ab363df4400f883ee435550e14b84c2b2">WRITE_DATA</a>)) <span class="keyword">const</span>;
<a name="l00328"></a>00328 
<a name="l00335"></a>00335   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1EquationSystems.php#a83e3cf47dde2b71b8340fdaabd46b6b9">compare</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; other_es, 
<a name="l00336"></a>00336                         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> threshold,
<a name="l00337"></a>00337                         <span class="keyword">const</span> <span class="keywordtype">bool</span> verbose) <span class="keyword">const</span>;
<a name="l00338"></a>00338 
<a name="l00343"></a>00343   <span class="keyword">virtual</span> std::string <a class="code" href="classlibMesh_1_1EquationSystems.php#a117c5dcec33e211dd0810ac7da8e2ecf">get_info</a>() <span class="keyword">const</span>;
<a name="l00344"></a>00344     
<a name="l00349"></a>00349   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EquationSystems.php#a06361551bf19f5f651270276703f1fcd">print_info</a> (std::ostream&amp; os=<a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a>) <span class="keyword">const</span>;
<a name="l00350"></a>00350 
<a name="l00354"></a>00354   <span class="keyword">friend</span> std::ostream&amp; <a class="code" href="classlibMesh_1_1EquationSystems.php#ae8191f2a6f0692077b46bbe60899a860">operator &lt;&lt; </a>(std::ostream&amp; os, <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es);
<a name="l00355"></a>00355 
<a name="l00359"></a>00359   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp; <a class="code" href="classlibMesh_1_1EquationSystems.php#aba1132bd8b38e9ce851abf57c3bc1e4b">get_mesh</a>() <span class="keyword">const</span>;
<a name="l00360"></a>00360 
<a name="l00364"></a>00364   <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp; <a class="code" href="classlibMesh_1_1EquationSystems.php#aba1132bd8b38e9ce851abf57c3bc1e4b">get_mesh</a>();
<a name="l00365"></a>00365 
<a name="l00370"></a>00370   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1EquationSystems.php#a8fc199c2ada9c85beb8700496c8f317f">has_mesh_data</a>() <span class="keyword">const</span>;
<a name="l00371"></a>00371 
<a name="l00375"></a>00375   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshData.php">MeshData</a> &amp; <a class="code" href="classlibMesh_1_1EquationSystems.php#a8ce886112b9179f94a449f4df1330de1">get_mesh_data</a>() <span class="keyword">const</span>;
<a name="l00376"></a>00376 
<a name="l00380"></a>00380   <a class="code" href="classlibMesh_1_1MeshData.php">MeshData</a> &amp; <a class="code" href="classlibMesh_1_1EquationSystems.php#a8ce886112b9179f94a449f4df1330de1">get_mesh_data</a>();
<a name="l00381"></a>00381 
<a name="l00386"></a>00386   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EquationSystems.php#af9e14bd8d215858c0c7046d6fdb7881b">allgather</a> ();
<a name="l00387"></a>00387 
<a name="l00388"></a>00388 
<a name="l00392"></a><a class="code" href="classlibMesh_1_1EquationSystems.php#a7c02be232f564967ca0804a7824adb53">00392</a>   <a class="code" href="classlibMesh_1_1Parameters.php">Parameters</a> <a class="code" href="classlibMesh_1_1EquationSystems.php#a7c02be232f564967ca0804a7824adb53">parameters</a>;
<a name="l00393"></a>00393 
<a name="l00394"></a>00394   
<a name="l00395"></a>00395 <span class="keyword">protected</span>:
<a name="l00396"></a>00396 
<a name="l00397"></a>00397   
<a name="l00401"></a><a class="code" href="classlibMesh_1_1EquationSystems.php#aa40db714c766361cd70548df3d06c57d">00401</a>   <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="classlibMesh_1_1EquationSystems.php#aa40db714c766361cd70548df3d06c57d">_mesh</a>;
<a name="l00402"></a>00402 
<a name="l00407"></a><a class="code" href="classlibMesh_1_1EquationSystems.php#ad878d61b2fb9a782dfbc6fa8db411589">00407</a>   <a class="code" href="classlibMesh_1_1MeshData.php">MeshData</a>* <a class="code" href="classlibMesh_1_1EquationSystems.php#ad878d61b2fb9a782dfbc6fa8db411589">_mesh_data</a>;
<a name="l00408"></a>00408 
<a name="l00412"></a><a class="code" href="classlibMesh_1_1EquationSystems.php#a7a35e87841d9f17fb7e2588ff059ec8e">00412</a>   std::map&lt;std::string, System*&gt; <a class="code" href="classlibMesh_1_1EquationSystems.php#a7a35e87841d9f17fb7e2588ff059ec8e">_systems</a>;
<a name="l00413"></a>00413 
<a name="l00417"></a><a class="code" href="classlibMesh_1_1EquationSystems.php#a4a4e902556e150e04ae72eb8f2ddd661">00417</a>   <span class="keyword">typedef</span> std::map&lt;std::string, System*&gt;::iterator       <a class="code" href="classlibMesh_1_1EquationSystems.php#a4a4e902556e150e04ae72eb8f2ddd661">system_iterator</a>;
<a name="l00418"></a>00418 
<a name="l00422"></a><a class="code" href="classlibMesh_1_1EquationSystems.php#ae02976e2d06f5ed10029f0f597bc4f15">00422</a>   <span class="keyword">typedef</span> std::map&lt;std::string, System*&gt;::const_iterator <a class="code" href="classlibMesh_1_1EquationSystems.php#ae02976e2d06f5ed10029f0f597bc4f15">const_system_iterator</a>;
<a name="l00423"></a>00423 
<a name="l00424"></a>00424 <span class="keyword">private</span>:
<a name="l00425"></a>00425     
<a name="l00430"></a>00430   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EquationSystems.php#ac75297978a98e293d40436f812f07fbd">_read_impl</a> (<span class="keyword">const</span> std::string&amp; name,
<a name="l00431"></a>00431                    <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8">libMeshEnums::XdrMODE</a>,
<a name="l00432"></a>00432                    <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> read_flags);
<a name="l00433"></a>00433 
<a name="l00440"></a>00440   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EquationSystems.php#ac5060830e5affa44351759890c3415ac">_add_system_to_nodes_and_elems</a>();
<a name="l00441"></a>00441 };
<a name="l00442"></a>00442 
<a name="l00443"></a>00443 
<a name="l00444"></a>00444 
<a name="l00445"></a>00445 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00446"></a>00446 <span class="comment">// EquationSystems inline methods</span>
<a name="l00447"></a>00447 <span class="keyword">inline</span>
<a name="l00448"></a><a class="code" href="classlibMesh_1_1EquationSystems.php#aba1132bd8b38e9ce851abf57c3bc1e4b">00448</a> <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp; <a class="code" href="classlibMesh_1_1EquationSystems.php#aba1132bd8b38e9ce851abf57c3bc1e4b">EquationSystems::get_mesh</a> ()<span class="keyword"> const</span>
<a name="l00449"></a>00449 <span class="keyword"></span>{
<a name="l00450"></a>00450   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1EquationSystems.php#aa40db714c766361cd70548df3d06c57d">_mesh</a>;
<a name="l00451"></a>00451 }
<a name="l00452"></a>00452 
<a name="l00453"></a>00453 
<a name="l00454"></a>00454 
<a name="l00455"></a>00455 <span class="keyword">inline</span>
<a name="l00456"></a><a class="code" href="classlibMesh_1_1EquationSystems.php#ab4a8d7a6f75418af046fba3942f67316">00456</a> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp; <a class="code" href="classlibMesh_1_1EquationSystems.php#aba1132bd8b38e9ce851abf57c3bc1e4b">EquationSystems::get_mesh</a> ()
<a name="l00457"></a>00457 {
<a name="l00458"></a>00458   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1EquationSystems.php#aa40db714c766361cd70548df3d06c57d">_mesh</a>;
<a name="l00459"></a>00459 }
<a name="l00460"></a>00460 
<a name="l00461"></a>00461 
<a name="l00462"></a>00462 <span class="keyword">inline</span>
<a name="l00463"></a><a class="code" href="classlibMesh_1_1EquationSystems.php#a8ce886112b9179f94a449f4df1330de1">00463</a> <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshData.php">MeshData</a> &amp; <a class="code" href="classlibMesh_1_1EquationSystems.php#a8ce886112b9179f94a449f4df1330de1">EquationSystems::get_mesh_data</a> ()<span class="keyword"> const</span>
<a name="l00464"></a>00464 <span class="keyword"></span>{
<a name="l00465"></a>00465   libmesh_assert (<a class="code" href="classlibMesh_1_1EquationSystems.php#ad878d61b2fb9a782dfbc6fa8db411589">_mesh_data</a> != NULL);
<a name="l00466"></a>00466   <span class="keywordflow">return</span> *<a class="code" href="classlibMesh_1_1EquationSystems.php#ad878d61b2fb9a782dfbc6fa8db411589">_mesh_data</a>;
<a name="l00467"></a>00467 }
<a name="l00468"></a>00468 
<a name="l00469"></a>00469 
<a name="l00470"></a>00470 <span class="keyword">inline</span>
<a name="l00471"></a><a class="code" href="classlibMesh_1_1EquationSystems.php#a47d86ac349117f7fcb76cab9e9854e75">00471</a> <a class="code" href="classlibMesh_1_1MeshData.php">MeshData</a> &amp; <a class="code" href="classlibMesh_1_1EquationSystems.php#a8ce886112b9179f94a449f4df1330de1">EquationSystems::get_mesh_data</a> ()
<a name="l00472"></a>00472 {
<a name="l00473"></a>00473   libmesh_assert (<a class="code" href="classlibMesh_1_1EquationSystems.php#ad878d61b2fb9a782dfbc6fa8db411589">_mesh_data</a> != NULL);
<a name="l00474"></a>00474   <span class="keywordflow">return</span> *<a class="code" href="classlibMesh_1_1EquationSystems.php#ad878d61b2fb9a782dfbc6fa8db411589">_mesh_data</a>;
<a name="l00475"></a>00475 }
<a name="l00476"></a>00476 
<a name="l00477"></a>00477 <span class="keyword">inline</span>
<a name="l00478"></a><a class="code" href="classlibMesh_1_1EquationSystems.php#a8fc199c2ada9c85beb8700496c8f317f">00478</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1EquationSystems.php#a8fc199c2ada9c85beb8700496c8f317f">EquationSystems::has_mesh_data</a> ()<span class="keyword"> const </span>
<a name="l00479"></a>00479 <span class="keyword"></span>{
<a name="l00480"></a>00480   <span class="keywordflow">return</span> (<a class="code" href="classlibMesh_1_1EquationSystems.php#ad878d61b2fb9a782dfbc6fa8db411589">_mesh_data</a>!=NULL);
<a name="l00481"></a>00481 }
<a name="l00482"></a>00482 
<a name="l00483"></a>00483 
<a name="l00484"></a>00484 <span class="keyword">inline</span>
<a name="l00485"></a><a class="code" href="classlibMesh_1_1EquationSystems.php#a93238b71a514e6d24f284e5f92947fbe">00485</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1EquationSystems.php#a93238b71a514e6d24f284e5f92947fbe">EquationSystems::n_systems</a> ()<span class="keyword"> const</span>
<a name="l00486"></a>00486 <span class="keyword"></span>{
<a name="l00487"></a>00487   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1EquationSystems.php#a7a35e87841d9f17fb7e2588ff059ec8e">_systems</a>.size();
<a name="l00488"></a>00488 }
<a name="l00489"></a>00489 
<a name="l00490"></a>00490 
<a name="l00491"></a>00491 
<a name="l00492"></a>00492 
<a name="l00493"></a>00493 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T_sys&gt;
<a name="l00494"></a>00494 <span class="keyword">inline</span>
<a name="l00495"></a><a class="code" href="classlibMesh_1_1EquationSystems.php#a6cc3c3dd50883f2173188af258361849">00495</a> T_sys &amp; <a class="code" href="classlibMesh_1_1EquationSystems.php#a09450d5e4547d8b2e5690043da03dbd3">EquationSystems::add_system</a> (<span class="keyword">const</span> std::string&amp; name)
<a name="l00496"></a>00496 {
<a name="l00497"></a>00497   T_sys* ptr = NULL;
<a name="l00498"></a>00498   
<a name="l00499"></a>00499   <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1EquationSystems.php#a7a35e87841d9f17fb7e2588ff059ec8e">_systems</a>.count(name))
<a name="l00500"></a>00500     {
<a name="l00501"></a>00501       ptr = <span class="keyword">new</span> T_sys(*<span class="keyword">this</span>, name, this-&gt;<a class="code" href="classlibMesh_1_1EquationSystems.php#a93238b71a514e6d24f284e5f92947fbe">n_systems</a>());
<a name="l00502"></a>00502 
<a name="l00503"></a>00503       <a class="code" href="classlibMesh_1_1EquationSystems.php#a7a35e87841d9f17fb7e2588ff059ec8e">_systems</a>.insert (std::make_pair(name, ptr));   
<a name="l00504"></a>00504 
<a name="l00505"></a>00505       <span class="comment">// Tell all the \p DofObject entities to add a system.</span>
<a name="l00506"></a>00506       this-&gt;<a class="code" href="classlibMesh_1_1EquationSystems.php#ac5060830e5affa44351759890c3415ac">_add_system_to_nodes_and_elems</a>();
<a name="l00507"></a>00507     }
<a name="l00508"></a>00508   <span class="keywordflow">else</span>
<a name="l00509"></a>00509     {
<a name="l00510"></a>00510       <span class="comment">// We now allow redundant add_system calls, to make it</span>
<a name="l00511"></a>00511       <span class="comment">// easier to load data from files for user-derived system</span>
<a name="l00512"></a>00512       <span class="comment">// subclasses</span>
<a name="l00513"></a>00513 <span class="comment">//      libMesh::err &lt;&lt; &quot;ERROR: There was already a system&quot;</span>
<a name="l00514"></a>00514 <span class="comment">//              &lt;&lt; &quot; named &quot; &lt;&lt; name</span>
<a name="l00515"></a>00515 <span class="comment">//              &lt;&lt; std::endl;</span>
<a name="l00516"></a>00516 
<a name="l00517"></a>00517 <span class="comment">//      libmesh_error();</span>
<a name="l00518"></a>00518 
<a name="l00519"></a>00519       ptr = &amp;(this-&gt;get_system&lt;T_sys&gt;(<a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>));
<a name="l00520"></a>00520     }
<a name="l00521"></a>00521 
<a name="l00522"></a>00522   <span class="comment">// Return a dynamically casted reference to the newly added System.</span>
<a name="l00523"></a>00523   <span class="keywordflow">return</span> *ptr;
<a name="l00524"></a>00524 }
<a name="l00525"></a>00525 
<a name="l00526"></a>00526 
<a name="l00527"></a>00527 
<a name="l00528"></a>00528 <span class="keyword">inline</span>
<a name="l00529"></a><a class="code" href="classlibMesh_1_1EquationSystems.php#a5119f662bf0ea98b1df8f3f94ac5cf11">00529</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1EquationSystems.php#a5119f662bf0ea98b1df8f3f94ac5cf11">EquationSystems::has_system</a> (<span class="keyword">const</span> std::string&amp; name)<span class="keyword"> const</span>
<a name="l00530"></a>00530 <span class="keyword"></span>{
<a name="l00531"></a>00531   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1EquationSystems.php#a7a35e87841d9f17fb7e2588ff059ec8e">_systems</a>.find(name) == <a class="code" href="classlibMesh_1_1EquationSystems.php#a7a35e87841d9f17fb7e2588ff059ec8e">_systems</a>.end())
<a name="l00532"></a>00532     <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00533"></a>00533   <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00534"></a>00534 }
<a name="l00535"></a>00535 
<a name="l00536"></a>00536 
<a name="l00537"></a>00537 
<a name="l00538"></a>00538 
<a name="l00539"></a>00539 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T_sys&gt;
<a name="l00540"></a>00540 <span class="keyword">inline</span>
<a name="l00541"></a><a class="code" href="classlibMesh_1_1EquationSystems.php#abcef45a93b2e2405e22f79a21bfa7b00">00541</a> <span class="keyword">const</span> T_sys &amp; <a class="code" href="classlibMesh_1_1EquationSystems.php#a5dac23f839af25ce7dbf1fe9a6d4b67a">EquationSystems::get_system</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> num)<span class="keyword"> const</span>
<a name="l00542"></a>00542 <span class="keyword"></span>{
<a name="l00543"></a>00543   libmesh_assert (num &lt; this-&gt;<a class="code" href="classlibMesh_1_1EquationSystems.php#a93238b71a514e6d24f284e5f92947fbe">n_systems</a>());
<a name="l00544"></a>00544 
<a name="l00545"></a>00545 
<a name="l00546"></a>00546   <a class="code" href="classlibMesh_1_1EquationSystems.php#ae02976e2d06f5ed10029f0f597bc4f15">const_system_iterator</a>       pos = <a class="code" href="classlibMesh_1_1EquationSystems.php#a7a35e87841d9f17fb7e2588ff059ec8e">_systems</a>.begin();
<a name="l00547"></a>00547   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1EquationSystems.php#ae02976e2d06f5ed10029f0f597bc4f15">const_system_iterator</a> end = <a class="code" href="classlibMesh_1_1EquationSystems.php#a7a35e87841d9f17fb7e2588ff059ec8e">_systems</a>.end();
<a name="l00548"></a>00548 
<a name="l00549"></a>00549   <span class="keywordflow">for</span> (; pos != end; ++pos)
<a name="l00550"></a>00550     <span class="keywordflow">if</span> (pos-&gt;second-&gt;number() == num)
<a name="l00551"></a>00551       <span class="keywordflow">break</span>;
<a name="l00552"></a>00552 
<a name="l00553"></a>00553   <span class="comment">// Check for errors</span>
<a name="l00554"></a>00554   <span class="keywordflow">if</span> (pos == end)
<a name="l00555"></a>00555     {
<a name="l00556"></a>00556       <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: no system number &quot;</span> &lt;&lt; num &lt;&lt; <span class="stringliteral">&quot; found!&quot;</span>
<a name="l00557"></a>00557                     &lt;&lt; std::endl;
<a name="l00558"></a>00558       libmesh_error();
<a name="l00559"></a>00559     }
<a name="l00560"></a>00560 
<a name="l00561"></a>00561   <span class="comment">// Attempt dynamic cast</span>
<a name="l00562"></a>00562   T_sys* ptr = <span class="keyword">dynamic_cast&lt;</span>T_sys*<span class="keyword">&gt;</span>(pos-&gt;second);
<a name="l00563"></a>00563 
<a name="l00564"></a>00564   <span class="comment">// Check for failure of dynamic cast</span>
<a name="l00565"></a>00565   <span class="keywordflow">if</span> (ptr == NULL)
<a name="l00566"></a>00566     {
<a name="l00567"></a>00567       <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: cannot convert system &quot;</span>
<a name="l00568"></a>00568                     &lt;&lt; num &lt;&lt; <span class="stringliteral">&quot; to requested type!&quot;</span>
<a name="l00569"></a>00569                     &lt;&lt; std::endl;
<a name="l00570"></a>00570       libmesh_error();
<a name="l00571"></a>00571     }
<a name="l00572"></a>00572   
<a name="l00573"></a>00573   <span class="keywordflow">return</span> *ptr;
<a name="l00574"></a>00574 }
<a name="l00575"></a>00575 
<a name="l00576"></a>00576 
<a name="l00577"></a>00577 
<a name="l00578"></a>00578 
<a name="l00579"></a>00579 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T_sys&gt;
<a name="l00580"></a>00580 <span class="keyword">inline</span>
<a name="l00581"></a><a class="code" href="classlibMesh_1_1EquationSystems.php#adca1fe2b79426c4f8137763a9934fbef">00581</a> T_sys &amp; <a class="code" href="classlibMesh_1_1EquationSystems.php#a5dac23f839af25ce7dbf1fe9a6d4b67a">EquationSystems::get_system</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> num)
<a name="l00582"></a>00582 {
<a name="l00583"></a>00583   libmesh_assert (num &lt; this-&gt;<a class="code" href="classlibMesh_1_1EquationSystems.php#a93238b71a514e6d24f284e5f92947fbe">n_systems</a>());
<a name="l00584"></a>00584   
<a name="l00585"></a>00585   <a class="code" href="classlibMesh_1_1EquationSystems.php#ae02976e2d06f5ed10029f0f597bc4f15">const_system_iterator</a>       pos = <a class="code" href="classlibMesh_1_1EquationSystems.php#a7a35e87841d9f17fb7e2588ff059ec8e">_systems</a>.begin();
<a name="l00586"></a>00586   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1EquationSystems.php#ae02976e2d06f5ed10029f0f597bc4f15">const_system_iterator</a> end = <a class="code" href="classlibMesh_1_1EquationSystems.php#a7a35e87841d9f17fb7e2588ff059ec8e">_systems</a>.end();
<a name="l00587"></a>00587 
<a name="l00588"></a>00588   <span class="keywordflow">for</span> (; pos != end; ++pos)
<a name="l00589"></a>00589     <span class="keywordflow">if</span> (pos-&gt;second-&gt;number() == num)
<a name="l00590"></a>00590       <span class="keywordflow">break</span>;
<a name="l00591"></a>00591 
<a name="l00592"></a>00592   <span class="comment">// Check for errors</span>
<a name="l00593"></a>00593   <span class="keywordflow">if</span> (pos == end)
<a name="l00594"></a>00594     {
<a name="l00595"></a>00595       <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: no system number &quot;</span> &lt;&lt; num &lt;&lt; <span class="stringliteral">&quot; found!&quot;</span>
<a name="l00596"></a>00596                     &lt;&lt; std::endl;
<a name="l00597"></a>00597       libmesh_error();
<a name="l00598"></a>00598     }
<a name="l00599"></a>00599 
<a name="l00600"></a>00600   <span class="comment">// Attempt dynamic cast</span>
<a name="l00601"></a>00601   T_sys* ptr = <span class="keyword">dynamic_cast&lt;</span>T_sys*<span class="keyword">&gt;</span>(pos-&gt;second);
<a name="l00602"></a>00602 
<a name="l00603"></a>00603   <span class="comment">// Check for failure of dynamic cast</span>
<a name="l00604"></a>00604   <span class="keywordflow">if</span> (ptr == NULL)
<a name="l00605"></a>00605     {
<a name="l00606"></a>00606       LIBMESH_THROW(<a class="code" href="classlibMesh_1_1DynamicCastFailure.php">libMesh::DynamicCastFailure</a>());
<a name="l00607"></a>00607     }
<a name="l00608"></a>00608 
<a name="l00609"></a>00609   <span class="keywordflow">return</span> *ptr; 
<a name="l00610"></a>00610 }
<a name="l00611"></a>00611 
<a name="l00612"></a>00612 
<a name="l00613"></a>00613 
<a name="l00614"></a>00614 
<a name="l00615"></a>00615 
<a name="l00616"></a>00616 
<a name="l00617"></a>00617 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T_sys&gt;
<a name="l00618"></a>00618 <span class="keyword">inline</span>
<a name="l00619"></a><a class="code" href="classlibMesh_1_1EquationSystems.php#a5dac23f839af25ce7dbf1fe9a6d4b67a">00619</a> <span class="keyword">const</span> T_sys &amp; <a class="code" href="classlibMesh_1_1EquationSystems.php#a5dac23f839af25ce7dbf1fe9a6d4b67a">EquationSystems::get_system</a> (<span class="keyword">const</span> std::string&amp; name)<span class="keyword"> const</span>
<a name="l00620"></a>00620 <span class="keyword"></span>{
<a name="l00621"></a>00621   <a class="code" href="classlibMesh_1_1EquationSystems.php#ae02976e2d06f5ed10029f0f597bc4f15">const_system_iterator</a> pos = <a class="code" href="classlibMesh_1_1EquationSystems.php#a7a35e87841d9f17fb7e2588ff059ec8e">_systems</a>.find(name);
<a name="l00622"></a>00622 
<a name="l00623"></a>00623   <span class="comment">// Check for errors</span>
<a name="l00624"></a>00624   <span class="keywordflow">if</span> (pos == <a class="code" href="classlibMesh_1_1EquationSystems.php#a7a35e87841d9f17fb7e2588ff059ec8e">_systems</a>.end())
<a name="l00625"></a>00625     {
<a name="l00626"></a>00626       <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: no system named \&quot;&quot;</span> &lt;&lt; name &lt;&lt; <span class="stringliteral">&quot;\&quot; found!&quot;</span>
<a name="l00627"></a>00627                     &lt;&lt; std::endl;
<a name="l00628"></a>00628       libmesh_error();
<a name="l00629"></a>00629     }
<a name="l00630"></a>00630 
<a name="l00631"></a>00631   <span class="comment">// Attempt dynamic cast</span>
<a name="l00632"></a>00632   T_sys* ptr = <span class="keyword">dynamic_cast&lt;</span>T_sys*<span class="keyword">&gt;</span>(pos-&gt;second);
<a name="l00633"></a>00633 
<a name="l00634"></a>00634   <span class="comment">// Check for failure of dynamic cast</span>
<a name="l00635"></a>00635   <span class="keywordflow">if</span> (ptr == NULL)
<a name="l00636"></a>00636     {
<a name="l00637"></a>00637       LIBMESH_THROW(<a class="code" href="classlibMesh_1_1DynamicCastFailure.php">libMesh::DynamicCastFailure</a>());
<a name="l00638"></a>00638     }
<a name="l00639"></a>00639 
<a name="l00640"></a>00640   <span class="keywordflow">return</span> *ptr; 
<a name="l00641"></a>00641 }
<a name="l00642"></a>00642 
<a name="l00643"></a>00643 
<a name="l00644"></a>00644 
<a name="l00645"></a>00645 
<a name="l00646"></a>00646 
<a name="l00647"></a>00647 
<a name="l00648"></a>00648 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T_sys&gt;
<a name="l00649"></a>00649 <span class="keyword">inline</span>
<a name="l00650"></a><a class="code" href="classlibMesh_1_1EquationSystems.php#a91b8b9994ebb3a8aa830ff96f0d55f13">00650</a> T_sys &amp; <a class="code" href="classlibMesh_1_1EquationSystems.php#a5dac23f839af25ce7dbf1fe9a6d4b67a">EquationSystems::get_system</a> (<span class="keyword">const</span> std::string&amp; name)
<a name="l00651"></a>00651 {
<a name="l00652"></a>00652   <a class="code" href="classlibMesh_1_1EquationSystems.php#a4a4e902556e150e04ae72eb8f2ddd661">system_iterator</a> pos = <a class="code" href="classlibMesh_1_1EquationSystems.php#a7a35e87841d9f17fb7e2588ff059ec8e">_systems</a>.find(name);
<a name="l00653"></a>00653 
<a name="l00654"></a>00654   <span class="comment">// Check for errors</span>
<a name="l00655"></a>00655   <span class="keywordflow">if</span> (pos == <a class="code" href="classlibMesh_1_1EquationSystems.php#a7a35e87841d9f17fb7e2588ff059ec8e">_systems</a>.end())
<a name="l00656"></a>00656     {
<a name="l00657"></a>00657       <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: no system named &quot;</span> &lt;&lt; name &lt;&lt; <span class="stringliteral">&quot; found!&quot;</span>
<a name="l00658"></a>00658                     &lt;&lt; std::endl;
<a name="l00659"></a>00659       libmesh_error();
<a name="l00660"></a>00660     }
<a name="l00661"></a>00661 
<a name="l00662"></a>00662   <span class="comment">// Attempt dynamic cast</span>
<a name="l00663"></a>00663   T_sys* ptr = <span class="keyword">dynamic_cast&lt;</span>T_sys*<span class="keyword">&gt;</span>(pos-&gt;second);
<a name="l00664"></a>00664 
<a name="l00665"></a>00665   <span class="comment">// Check for failure of dynamic cast</span>
<a name="l00666"></a>00666   <span class="keywordflow">if</span> (ptr == NULL)
<a name="l00667"></a>00667     {
<a name="l00668"></a>00668       std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: cannot convert system \&quot;&quot;</span>
<a name="l00669"></a>00669                 &lt;&lt; name &lt;&lt; <span class="stringliteral">&quot;\&quot; to requested type!&quot;</span>
<a name="l00670"></a>00670                 &lt;&lt; std::endl;
<a name="l00671"></a>00671       libmesh_error();
<a name="l00672"></a>00672     }
<a name="l00673"></a>00673 
<a name="l00674"></a>00674   <span class="keywordflow">return</span> *ptr; 
<a name="l00675"></a>00675 }
<a name="l00676"></a>00676 
<a name="l00677"></a>00677 
<a name="l00678"></a>00678 
<a name="l00679"></a>00679 
<a name="l00680"></a>00680 
<a name="l00681"></a>00681 
<a name="l00682"></a>00682 
<a name="l00683"></a>00683 <span class="keyword">inline</span>
<a name="l00684"></a>00684 <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a> &amp; <a class="code" href="classlibMesh_1_1EquationSystems.php#a5dac23f839af25ce7dbf1fe9a6d4b67a">EquationSystems::get_system</a> (<span class="keyword">const</span> std::string&amp; name)<span class="keyword"> const</span>
<a name="l00685"></a>00685 <span class="keyword"></span>{
<a name="l00686"></a>00686   <span class="keywordflow">return</span> this-&gt;get_system&lt;System&gt;(<a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>);
<a name="l00687"></a>00687 }
<a name="l00688"></a>00688 
<a name="l00689"></a>00689 
<a name="l00690"></a>00690 
<a name="l00691"></a>00691 <span class="keyword">inline</span>
<a name="l00692"></a>00692 System &amp; <a class="code" href="classlibMesh_1_1EquationSystems.php#a5dac23f839af25ce7dbf1fe9a6d4b67a">EquationSystems::get_system</a> (<span class="keyword">const</span> std::string&amp; name)
<a name="l00693"></a>00693 {
<a name="l00694"></a>00694   <span class="keywordflow">return</span> this-&gt;get_system&lt;System&gt;(<a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>);
<a name="l00695"></a>00695 }
<a name="l00696"></a>00696 
<a name="l00697"></a>00697 
<a name="l00698"></a>00698 
<a name="l00699"></a>00699 <span class="keyword">inline</span>
<a name="l00700"></a>00700 <span class="keyword">const</span> System &amp; <a class="code" href="classlibMesh_1_1EquationSystems.php#a5dac23f839af25ce7dbf1fe9a6d4b67a">EquationSystems::get_system</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> num)<span class="keyword"> const</span>
<a name="l00701"></a>00701 <span class="keyword"></span>{
<a name="l00702"></a>00702   <span class="keywordflow">return</span> this-&gt;get_system&lt;System&gt;(num);
<a name="l00703"></a>00703 }
<a name="l00704"></a>00704 
<a name="l00705"></a>00705 
<a name="l00706"></a>00706 
<a name="l00707"></a>00707 <span class="keyword">inline</span>
<a name="l00708"></a>00708 System &amp; <a class="code" href="classlibMesh_1_1EquationSystems.php#a5dac23f839af25ce7dbf1fe9a6d4b67a">EquationSystems::get_system</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> num)
<a name="l00709"></a>00709 {
<a name="l00710"></a>00710   <span class="keywordflow">return</span> this-&gt;get_system&lt;System&gt;(num);
<a name="l00711"></a>00711 }
<a name="l00712"></a>00712 
<a name="l00713"></a>00713 
<a name="l00714"></a>00714 } <span class="comment">// namespace libMesh</span>
<a name="l00715"></a>00715 
<a name="l00716"></a>00716 
<a name="l00717"></a>00717 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
