<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_c3a49989e40b21e7508f29d2dc962def.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_94af86d0ee7ff5a2af0627e1a0ea6efa.php">systems</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">equation_systems_io.C</div>  </div>
</div>
<div class="contents">
<a href="equation__systems__io_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id$</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__logging_8h.php">libmesh_logging.h</a>&quot;</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 <span class="comment">// C++ Includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;cstdio&gt;</span> <span class="comment">// for std::sprintf</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="comment">// Local Includes</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="equation__systems_8h.php">equation_systems.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="mesh__base_8h.php">mesh_base.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="mesh__tools_8h.php">mesh_tools.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="parallel__mesh_8h.php">parallel_mesh.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="parallel_8h.php">parallel.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="serial__mesh_8h.php">serial_mesh.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="xdr__cxx_8h.php">xdr_cxx.h</a>&quot;</span>
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="keyword">namespace </span>libMesh
<a name="l00038"></a>00038 {
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 <span class="comment">// Forward Declarations</span>
<a name="l00041"></a>00041 
<a name="l00042"></a>00042 <span class="comment">// Anonymous namespace for implementation details.</span>
<a name="l00043"></a>00043 <span class="keyword">namespace </span>{
<a name="l00044"></a>00044   std::string local_file_name (<span class="keyword">const</span> std::string &amp;<a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>)
<a name="l00045"></a>00045   {
<a name="l00046"></a>00046     std::string basename(name);
<a name="l00047"></a>00047     <span class="keywordtype">char</span> buf[256];
<a name="l00048"></a>00048 
<a name="l00049"></a>00049     <span class="keywordflow">if</span> (basename.size() - basename.rfind(<span class="stringliteral">&quot;.bz2&quot;</span>) == 4)
<a name="l00050"></a>00050       {
<a name="l00051"></a>00051         basename.erase(basename.end()-4, basename.end());
<a name="l00052"></a>00052         std::sprintf(buf, <span class="stringliteral">&quot;%s.%04d.bz2&quot;</span>, basename.c_str(), <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>());
<a name="l00053"></a>00053       }
<a name="l00054"></a>00054     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (basename.size() - basename.rfind(<span class="stringliteral">&quot;.gz&quot;</span>) == 3)
<a name="l00055"></a>00055       {
<a name="l00056"></a>00056         basename.erase(basename.end()-3, basename.end());
<a name="l00057"></a>00057         std::sprintf(buf, <span class="stringliteral">&quot;%s.%04d.gz&quot;</span>, basename.c_str(), <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>());
<a name="l00058"></a>00058       }
<a name="l00059"></a>00059     <span class="keywordflow">else</span>
<a name="l00060"></a>00060       std::sprintf(buf, <span class="stringliteral">&quot;%s.%04d&quot;</span>, basename.c_str(), <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>());
<a name="l00061"></a>00061       
<a name="l00062"></a>00062     <span class="keywordflow">return</span> std::string(buf);
<a name="l00063"></a>00063   }
<a name="l00064"></a>00064 }
<a name="l00065"></a>00065 
<a name="l00066"></a>00066 
<a name="l00067"></a>00067 
<a name="l00068"></a>00068 
<a name="l00069"></a>00069 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00070"></a>00070 <span class="comment">// EquationSystem class implementation</span>
<a name="l00071"></a><a class="code" href="classlibMesh_1_1EquationSystems.php#a1bb5ab24c1b1e09a2bed7b489f55dcac">00071</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EquationSystems.php#a1ce9dd49162b1cd340ddcefbc0c8111f">EquationSystems::read</a> (<span class="keyword">const</span> std::string&amp; name,
<a name="l00072"></a>00072                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> read_flags)
<a name="l00073"></a>00073 {
<a name="l00074"></a>00074   <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8">libMeshEnums::XdrMODE</a> mode = <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8acd5c7906bd7fea7650acc4c8cde09d48">READ</a>;
<a name="l00075"></a>00075   <span class="keywordflow">if</span> (name.find(<span class="stringliteral">&quot;.xdr&quot;</span>) != std::string::npos)
<a name="l00076"></a>00076     mode = <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a2632308739033bf9f82ea90cdf92231e">DECODE</a>;
<a name="l00077"></a>00077   this-&gt;<a class="code" href="classlibMesh_1_1EquationSystems.php#a1ce9dd49162b1cd340ddcefbc0c8111f">read</a>(name, mode, read_flags);
<a name="l00078"></a>00078 }
<a name="l00079"></a>00079 
<a name="l00080"></a>00080 
<a name="l00081"></a>00081 
<a name="l00082"></a><a class="code" href="classlibMesh_1_1EquationSystems.php#a1ce9dd49162b1cd340ddcefbc0c8111f">00082</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EquationSystems.php#a1ce9dd49162b1cd340ddcefbc0c8111f">EquationSystems::read</a> (<span class="keyword">const</span> std::string&amp; name,
<a name="l00083"></a>00083                             <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8">libMeshEnums::XdrMODE</a> mode,
<a name="l00084"></a>00084                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> read_flags)
<a name="l00085"></a>00085 {
<a name="l00086"></a>00086 <span class="preprocessor">#ifdef LIBMESH_ENABLE_EXCEPTIONS</span>
<a name="l00087"></a>00087 <span class="preprocessor"></span>
<a name="l00088"></a>00088   <span class="comment">// If we have exceptions enabled we can be considerate and try</span>
<a name="l00089"></a>00089   <span class="comment">// to read old restart files which contain infinite element</span>
<a name="l00090"></a>00090   <span class="comment">// information but do not have the &quot; with infinite elements&quot;</span>
<a name="l00091"></a>00091   <span class="comment">// string in the version information.</span>
<a name="l00092"></a>00092   
<a name="l00093"></a>00093   <span class="comment">// First try the read the user requested</span>
<a name="l00094"></a>00094   <span class="keywordflow">try</span>
<a name="l00095"></a>00095     {
<a name="l00096"></a>00096       this-&gt;<a class="code" href="classlibMesh_1_1EquationSystems.php#ac75297978a98e293d40436f812f07fbd">_read_impl</a> (name, mode, read_flags);
<a name="l00097"></a>00097     }
<a name="l00098"></a>00098 
<a name="l00099"></a>00099   <span class="comment">// If that fails, try it again but explicitly request we look for infinite element info      </span>
<a name="l00100"></a>00100   <span class="keywordflow">catch</span> (...)
<a name="l00101"></a>00101     {
<a name="l00102"></a>00102       <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;\n*********************************************************************\n&quot;</span>
<a name="l00103"></a>00103                     &lt;&lt; <span class="stringliteral">&quot;READING THE FILE \&quot;&quot;</span> &lt;&lt; name &lt;&lt; <span class="stringliteral">&quot;\&quot; FAILED.\n&quot;</span>
<a name="l00104"></a>00104                     &lt;&lt; <span class="stringliteral">&quot;It is possible this file contains infinite element information,\n&quot;</span>
<a name="l00105"></a>00105                     &lt;&lt; <span class="stringliteral">&quot;but the version string does not contain \&quot; with infinite elements\&quot;\n&quot;</span>
<a name="l00106"></a>00106                     &lt;&lt; <span class="stringliteral">&quot;Let&#39;s try this again, but looking for infinite element information...\n&quot;</span>
<a name="l00107"></a>00107                     &lt;&lt; <span class="stringliteral">&quot;*********************************************************************\n&quot;</span>
<a name="l00108"></a>00108                     &lt;&lt; std::endl;
<a name="l00109"></a>00109 
<a name="l00110"></a>00110       <span class="keywordflow">try</span>
<a name="l00111"></a>00111         {
<a name="l00112"></a>00112           this-&gt;<a class="code" href="classlibMesh_1_1EquationSystems.php#ac75297978a98e293d40436f812f07fbd">_read_impl</a> (name, mode, read_flags | <a class="code" href="classlibMesh_1_1EquationSystems.php#a9a3b0e740fd481142a43130304066e35a35e7008af7ae308c3a10e42cf78ebc17">EquationSystems::TRY_READ_IFEMS</a>);
<a name="l00113"></a>00113         }
<a name="l00114"></a>00114 
<a name="l00115"></a>00115       <span class="comment">// If all that failed, we are out of ideas here...</span>
<a name="l00116"></a>00116       <span class="keywordflow">catch</span> (...)
<a name="l00117"></a>00117         {
<a name="l00118"></a>00118           <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;\n*********************************************************************\n&quot;</span>
<a name="l00119"></a>00119                         &lt;&lt; <span class="stringliteral">&quot;Well, at least we tried!\n&quot;</span>
<a name="l00120"></a>00120                         &lt;&lt; <span class="stringliteral">&quot;Good Luck!!\n&quot;</span>
<a name="l00121"></a>00121                         &lt;&lt; <span class="stringliteral">&quot;*********************************************************************\n&quot;</span>
<a name="l00122"></a>00122                         &lt;&lt; std::endl;
<a name="l00123"></a>00123           <span class="keywordflow">throw</span>;
<a name="l00124"></a>00124         }
<a name="l00125"></a>00125     }
<a name="l00126"></a>00126 
<a name="l00127"></a>00127 <span class="preprocessor">#else</span>
<a name="l00128"></a>00128 <span class="preprocessor"></span>
<a name="l00129"></a>00129   <span class="comment">// no exceptions - cross your fingers...</span>
<a name="l00130"></a>00130   this-&gt;<a class="code" href="classlibMesh_1_1EquationSystems.php#ac75297978a98e293d40436f812f07fbd">_read_impl</a> (name, mode, read_flags);
<a name="l00131"></a>00131   
<a name="l00132"></a>00132 <span class="preprocessor">#endif // #ifdef LIBMESH_ENABLE_EXCEPTIONS</span>
<a name="l00133"></a>00133 <span class="preprocessor"></span>}
<a name="l00134"></a>00134 
<a name="l00135"></a>00135 
<a name="l00136"></a>00136 
<a name="l00137"></a><a class="code" href="classlibMesh_1_1EquationSystems.php#ac75297978a98e293d40436f812f07fbd">00137</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EquationSystems.php#ac75297978a98e293d40436f812f07fbd">EquationSystems::_read_impl</a> (<span class="keyword">const</span> std::string&amp; name,
<a name="l00138"></a>00138                                   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8">libMeshEnums::XdrMODE</a> mode,
<a name="l00139"></a>00139                                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> read_flags)
<a name="l00140"></a>00140 {
<a name="l00204"></a>00204    <span class="comment">// Set booleans from the read_flags argument</span>
<a name="l00205"></a>00205    <span class="keyword">const</span> <span class="keywordtype">bool</span> read_header          = read_flags &amp; <a class="code" href="classlibMesh_1_1EquationSystems.php#a9a3b0e740fd481142a43130304066e35a95b7895de1a30e716b72af7155b5aa84">EquationSystems::READ_HEADER</a>;
<a name="l00206"></a>00206    <span class="keyword">const</span> <span class="keywordtype">bool</span> read_data            = read_flags &amp; <a class="code" href="classlibMesh_1_1EquationSystems.php#a9a3b0e740fd481142a43130304066e35ac343ca4237c893115866c2c582b30f7b">EquationSystems::READ_DATA</a>;
<a name="l00207"></a>00207    <span class="keyword">const</span> <span class="keywordtype">bool</span> read_additional_data = read_flags &amp; <a class="code" href="classlibMesh_1_1EquationSystems.php#a9a3b0e740fd481142a43130304066e35a681bafe8583d3817a7731913b8c997a5">EquationSystems::READ_ADDITIONAL_DATA</a>;
<a name="l00208"></a>00208    <span class="keyword">const</span> <span class="keywordtype">bool</span> read_legacy_format   = read_flags &amp; <a class="code" href="classlibMesh_1_1EquationSystems.php#a9a3b0e740fd481142a43130304066e35a0fb381d3591f7a039ebd249d080535c0">EquationSystems::READ_LEGACY_FORMAT</a>;
<a name="l00209"></a>00209    <span class="keyword">const</span> <span class="keywordtype">bool</span> try_read_ifems       = read_flags &amp; <a class="code" href="classlibMesh_1_1EquationSystems.php#a9a3b0e740fd481142a43130304066e35a35e7008af7ae308c3a10e42cf78ebc17">EquationSystems::TRY_READ_IFEMS</a>;
<a name="l00210"></a>00210          <span class="keywordtype">bool</span> read_parallel_files  = <span class="keyword">false</span>;
<a name="l00211"></a>00211          
<a name="l00212"></a>00212   <span class="comment">// This will unzip a file with .bz2 as the extension, otherwise it</span>
<a name="l00213"></a>00213   <span class="comment">// simply returns the name if the file need not be unzipped.</span>
<a name="l00214"></a>00214   <a class="code" href="classlibMesh_1_1Xdr.php">Xdr</a> io ((<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0) ? name : <span class="stringliteral">&quot;&quot;</span>, mode);
<a name="l00215"></a>00215   libmesh_assert (io.<a class="code" href="classlibMesh_1_1Xdr.php#aec343c8dd879abda1c8706342ff0cbfe">reading</a>());
<a name="l00216"></a>00216           
<a name="l00217"></a>00217   {
<a name="l00218"></a>00218     <span class="comment">// 1.)</span>
<a name="l00219"></a>00219     <span class="comment">// Read the version header.</span>
<a name="l00220"></a>00220     std::string version = <span class="stringliteral">&quot;legacy&quot;</span>;
<a name="l00221"></a>00221     <span class="keywordflow">if</span> (!read_legacy_format)
<a name="l00222"></a>00222       {
<a name="l00223"></a>00223         <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0) io.<a class="code" href="classlibMesh_1_1Xdr.php#a8d41e3ea5b2559f8a73d83ad06a14cad">data</a>(version);     
<a name="l00224"></a>00224         <a class="code" href="namespacelibMesh_1_1Parallel.php#a0856815f9d1ce56771e340b45ef80e6c">Parallel::broadcast</a>(version);
<a name="l00225"></a>00225         
<a name="l00226"></a>00226         <span class="comment">// All processors have the version header, if it does not contain</span>
<a name="l00227"></a>00227         <span class="comment">// &quot;libMesh&quot; something then it is a legacy file.</span>
<a name="l00228"></a>00228         <span class="keywordflow">if</span> (!(version.find(<span class="stringliteral">&quot;libMesh&quot;</span>) &lt; version.size()))
<a name="l00229"></a>00229           {
<a name="l00230"></a>00230             io.<a class="code" href="classlibMesh_1_1Xdr.php#aec6e011b6f52a182c8f181c2290456de">close</a>();
<a name="l00231"></a>00231             
<a name="l00232"></a>00232             <span class="comment">// Recursively call this read() function but with the </span>
<a name="l00233"></a>00233             <span class="comment">// EquationSystems::READ_LEGACY_FORMAT bit set.</span>
<a name="l00234"></a>00234             this-&gt;<a class="code" href="classlibMesh_1_1EquationSystems.php#a1ce9dd49162b1cd340ddcefbc0c8111f">read</a> (name, mode, (read_flags | EquationSystems::READ_LEGACY_FORMAT));
<a name="l00235"></a>00235             <span class="keywordflow">return</span>;
<a name="l00236"></a>00236           }
<a name="l00237"></a>00237 
<a name="l00238"></a>00238         read_parallel_files = (version.rfind(<span class="stringliteral">&quot; parallel&quot;</span>) &lt; version.size());
<a name="l00239"></a>00239 
<a name="l00240"></a>00240         <span class="comment">// If requested that we try to read infinite element information,</span>
<a name="l00241"></a>00241         <span class="comment">// and the string &quot; with infinite elements&quot; is not in the version,</span>
<a name="l00242"></a>00242         <span class="comment">// then tack it on.  This is for compatibility reading ifem</span>
<a name="l00243"></a>00243         <span class="comment">// files written prior to 11/10/2008 - BSK</span>
<a name="l00244"></a>00244         <span class="keywordflow">if</span> (try_read_ifems)
<a name="l00245"></a>00245           <span class="keywordflow">if</span> (!(version.rfind(<span class="stringliteral">&quot; with infinite elements&quot;</span>) &lt; version.size()))
<a name="l00246"></a>00246             version += <span class="stringliteral">&quot; with infinite elements&quot;</span>;
<a name="l00247"></a>00247         
<a name="l00248"></a>00248       }
<a name="l00249"></a>00249     <span class="keywordflow">else</span>
<a name="l00250"></a>00250       libmesh_deprecated();
<a name="l00251"></a>00251 
<a name="l00252"></a>00252   START_LOG(<span class="stringliteral">&quot;read()&quot;</span>,<span class="stringliteral">&quot;EquationSystems&quot;</span>);
<a name="l00253"></a>00253       
<a name="l00254"></a>00254     <span class="comment">// 2.)  </span>
<a name="l00255"></a>00255     <span class="comment">// Read the number of equation systems</span>
<a name="l00256"></a>00256     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_sys=0;
<a name="l00257"></a>00257     <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0) io.<a class="code" href="classlibMesh_1_1Xdr.php#a8d41e3ea5b2559f8a73d83ad06a14cad">data</a> (n_sys);
<a name="l00258"></a>00258     <a class="code" href="namespacelibMesh_1_1Parallel.php#a0856815f9d1ce56771e340b45ef80e6c">Parallel::broadcast</a>(n_sys);
<a name="l00259"></a>00259 
<a name="l00260"></a>00260     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sys=0; sys&lt;n_sys; sys++)
<a name="l00261"></a>00261       {
<a name="l00262"></a>00262         <span class="comment">// 3.)</span>
<a name="l00263"></a>00263         <span class="comment">// Read the name of the sys-th equation system</span>
<a name="l00264"></a>00264         std::string sys_name;      
<a name="l00265"></a>00265         <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0) io.<a class="code" href="classlibMesh_1_1Xdr.php#a8d41e3ea5b2559f8a73d83ad06a14cad">data</a> (sys_name);
<a name="l00266"></a>00266         <a class="code" href="namespacelibMesh_1_1Parallel.php#a0856815f9d1ce56771e340b45ef80e6c">Parallel::broadcast</a>(sys_name);
<a name="l00267"></a>00267         
<a name="l00268"></a>00268         <span class="comment">// 4.)</span>
<a name="l00269"></a>00269         <span class="comment">// Read the type of the sys-th equation system</span>
<a name="l00270"></a>00270         std::string sys_type;   
<a name="l00271"></a>00271         <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0) io.<a class="code" href="classlibMesh_1_1Xdr.php#a8d41e3ea5b2559f8a73d83ad06a14cad">data</a> (sys_type);
<a name="l00272"></a>00272         <a class="code" href="namespacelibMesh_1_1Parallel.php#a0856815f9d1ce56771e340b45ef80e6c">Parallel::broadcast</a>(sys_type);
<a name="l00273"></a>00273         
<a name="l00274"></a>00274         <span class="keywordflow">if</span> (read_header)
<a name="l00275"></a>00275           this-&gt;<a class="code" href="classlibMesh_1_1EquationSystems.php#a09450d5e4547d8b2e5690043da03dbd3">add_system</a> (sys_type, sys_name);
<a name="l00276"></a>00276 
<a name="l00277"></a>00277         <span class="comment">// 5.) - 9.)</span>
<a name="l00278"></a>00278         <span class="comment">// Let System::read_header() do the job</span>
<a name="l00279"></a>00279         <a class="code" href="classlibMesh_1_1System.php">System</a>&amp; new_system = this-&gt;<a class="code" href="classlibMesh_1_1EquationSystems.php#a5dac23f839af25ce7dbf1fe9a6d4b67a">get_system</a>(sys_name);          
<a name="l00280"></a>00280         new_system.<a class="code" href="classlibMesh_1_1System.php#a80a2d705f01a0e18de74e02ccf43bb83">read_header</a> (io,
<a name="l00281"></a>00281                                 version,
<a name="l00282"></a>00282                                 read_header,
<a name="l00283"></a>00283                                 read_additional_data,
<a name="l00284"></a>00284                                 read_legacy_format);
<a name="l00285"></a>00285       }
<a name="l00286"></a>00286   }
<a name="l00287"></a>00287       
<a name="l00288"></a>00288 
<a name="l00289"></a>00289 
<a name="l00290"></a>00290   <span class="comment">// Now we are ready to initialize the underlying data</span>
<a name="l00291"></a>00291   <span class="comment">// structures. This will initialize the vectors for </span>
<a name="l00292"></a>00292   <span class="comment">// storage, the dof_map, etc...</span>
<a name="l00293"></a>00293   <span class="keywordflow">if</span> (read_header) 
<a name="l00294"></a>00294     this-&gt;<a class="code" href="classlibMesh_1_1EquationSystems.php#aa79320b68e236ece82d5b358721ebd13">init</a>();
<a name="l00295"></a>00295 
<a name="l00296"></a>00296   <span class="comment">// 10.) &amp; 11.)</span>
<a name="l00297"></a>00297   <span class="comment">// Read and set the numeric vector values</span>
<a name="l00298"></a>00298   <span class="keywordflow">if</span> (read_data)
<a name="l00299"></a>00299     {
<a name="l00300"></a>00300       <span class="comment">// the EquationSystems::read() method should look constant from the mesh</span>
<a name="l00301"></a>00301       <span class="comment">// perspective, but we need to assign a temporary numbering to the nodes</span>
<a name="l00302"></a>00302       <span class="comment">// and elements in the mesh, which requires that we abuse const_cast</span>
<a name="l00303"></a>00303       <span class="keywordflow">if</span> (!read_legacy_format)
<a name="l00304"></a>00304         {
<a name="l00305"></a>00305           <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp;<a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a> = <span class="keyword">const_cast&lt;</span><a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp;<span class="keyword">&gt;</span>(this-&gt;<a class="code" href="classlibMesh_1_1EquationSystems.php#aba1132bd8b38e9ce851abf57c3bc1e4b">get_mesh</a>());
<a name="l00306"></a>00306           <a class="code" href="namespacelibMesh_1_1MeshTools_1_1Private.php#a6250f59b9180229182c52939a4511363">MeshTools::Private::globally_renumber_nodes_and_elements</a>(mesh);
<a name="l00307"></a>00307         }
<a name="l00308"></a>00308 
<a name="l00309"></a>00309       <a class="code" href="classlibMesh_1_1Xdr.php">Xdr</a> local_io (read_parallel_files ? local_file_name(name) : <span class="stringliteral">&quot;&quot;</span>, mode);
<a name="l00310"></a>00310    
<a name="l00311"></a>00311       std::map&lt;std::string, System*&gt;::iterator
<a name="l00312"></a>00312         pos = <a class="code" href="classlibMesh_1_1EquationSystems.php#a7a35e87841d9f17fb7e2588ff059ec8e">_systems</a>.begin();
<a name="l00313"></a>00313       
<a name="l00314"></a>00314       <span class="keywordflow">for</span> (; pos != <a class="code" href="classlibMesh_1_1EquationSystems.php#a7a35e87841d9f17fb7e2588ff059ec8e">_systems</a>.end(); ++pos)
<a name="l00315"></a>00315         <span class="keywordflow">if</span> (read_legacy_format)
<a name="l00316"></a>00316           {
<a name="l00317"></a>00317             libmesh_deprecated();
<a name="l00318"></a>00318             pos-&gt;second-&gt;read_legacy_data (io, read_additional_data);
<a name="l00319"></a>00319           }
<a name="l00320"></a>00320         <span class="keywordflow">else</span>
<a name="l00321"></a>00321           <span class="keywordflow">if</span> (read_parallel_files)
<a name="l00322"></a>00322             pos-&gt;second-&gt;read_parallel_data   (local_io, read_additional_data);
<a name="l00323"></a>00323           <span class="keywordflow">else</span>
<a name="l00324"></a>00324             pos-&gt;second-&gt;read_serialized_data (io, read_additional_data);
<a name="l00325"></a>00325 
<a name="l00326"></a>00326       
<a name="l00327"></a>00327       <span class="comment">// Undo the temporary numbering.</span>
<a name="l00328"></a>00328       <span class="keywordflow">if</span> (!read_legacy_format)
<a name="l00329"></a>00329         {
<a name="l00330"></a>00330           <span class="keywordflow">if</span> (dynamic_cast&lt;ParallelMesh*&gt;(const_cast&lt;MeshBase*&gt;(&amp;<a class="code" href="classlibMesh_1_1EquationSystems.php#aa40db714c766361cd70548df3d06c57d">_mesh</a>)))
<a name="l00331"></a>00331             {
<a name="l00332"></a>00332               <a class="code" href="classlibMesh_1_1ParallelMesh.php">ParallelMesh</a> *<a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a> = <span class="keyword">dynamic_cast&lt;</span><a class="code" href="classlibMesh_1_1ParallelMesh.php">ParallelMesh</a>*<span class="keyword">&gt;</span>(<span class="keyword">const_cast&lt;</span><a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>*<span class="keyword">&gt;</span>(&amp;<a class="code" href="classlibMesh_1_1EquationSystems.php#aa40db714c766361cd70548df3d06c57d">_mesh</a>));    
<a name="l00333"></a>00333               <a class="code" href="namespacelibMesh_1_1MeshTools_1_1Private.php#a767e57ef66c9f372a1ee424e8caadd0d">MeshTools::Private::fix_broken_node_and_element_numbering</a>(*mesh);
<a name="l00334"></a>00334             }
<a name="l00335"></a>00335           <span class="keywordflow">else</span> <span class="keywordflow">if</span> (dynamic_cast&lt;SerialMesh*&gt;(const_cast&lt;MeshBase*&gt;(&amp;<a class="code" href="classlibMesh_1_1EquationSystems.php#aa40db714c766361cd70548df3d06c57d">_mesh</a>)))
<a name="l00336"></a>00336             {
<a name="l00337"></a>00337               <a class="code" href="classlibMesh_1_1SerialMesh.php">SerialMesh</a> *<a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a> = <span class="keyword">dynamic_cast&lt;</span><a class="code" href="classlibMesh_1_1SerialMesh.php">SerialMesh</a>*<span class="keyword">&gt;</span>(<span class="keyword">const_cast&lt;</span><a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>*<span class="keyword">&gt;</span>(&amp;<a class="code" href="classlibMesh_1_1EquationSystems.php#aa40db714c766361cd70548df3d06c57d">_mesh</a>));    
<a name="l00338"></a>00338               <a class="code" href="namespacelibMesh_1_1MeshTools_1_1Private.php#a767e57ef66c9f372a1ee424e8caadd0d">MeshTools::Private::fix_broken_node_and_element_numbering</a>(*mesh);
<a name="l00339"></a>00339             }
<a name="l00340"></a>00340           <span class="keywordflow">else</span>
<a name="l00341"></a>00341             {
<a name="l00342"></a>00342               <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR:  dynamic_cast&lt;&gt; to ParallelMesh and SerialMesh failed!&quot;</span>
<a name="l00343"></a>00343                             &lt;&lt; std::endl;
<a name="l00344"></a>00344               libmesh_error();
<a name="l00345"></a>00345             }     
<a name="l00346"></a>00346         }
<a name="l00347"></a>00347     }  
<a name="l00348"></a>00348 
<a name="l00349"></a>00349   STOP_LOG(<span class="stringliteral">&quot;read()&quot;</span>,<span class="stringliteral">&quot;EquationSystems&quot;</span>);
<a name="l00350"></a>00350   
<a name="l00351"></a>00351   <span class="comment">// Localize each system&#39;s data</span>
<a name="l00352"></a>00352   this-&gt;<a class="code" href="classlibMesh_1_1EquationSystems.php#a3f4875f0168a7c02cd09e006b7edcddf">update</a>();
<a name="l00353"></a>00353 }
<a name="l00354"></a>00354 
<a name="l00355"></a>00355 
<a name="l00356"></a>00356 
<a name="l00357"></a><a class="code" href="classlibMesh_1_1EquationSystems.php#af4332831eed41ec5819f7f241247c1fb">00357</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EquationSystems.php#a854ce8b16e0ea2dac288915647f73879">EquationSystems::write</a>(<span class="keyword">const</span> std::string&amp; name,
<a name="l00358"></a>00358                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> write_flags)<span class="keyword"> const</span>
<a name="l00359"></a>00359 <span class="keyword"></span>{
<a name="l00360"></a>00360   <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8">libMeshEnums::XdrMODE</a> mode = <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a47f4bcd4fcf418da5ec74d3d8e2c3bc4">WRITE</a>;
<a name="l00361"></a>00361   <span class="keywordflow">if</span> (name.find(<span class="stringliteral">&quot;.xdr&quot;</span>) != std::string::npos)
<a name="l00362"></a>00362     mode = <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8ae5559170d41d912b449375bb4e3468f6">ENCODE</a>;
<a name="l00363"></a>00363   this-&gt;<a class="code" href="classlibMesh_1_1EquationSystems.php#a854ce8b16e0ea2dac288915647f73879">write</a>(name, mode, write_flags);
<a name="l00364"></a>00364 }
<a name="l00365"></a>00365 
<a name="l00366"></a>00366 
<a name="l00367"></a>00367 
<a name="l00368"></a><a class="code" href="classlibMesh_1_1EquationSystems.php#a854ce8b16e0ea2dac288915647f73879">00368</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EquationSystems.php#a854ce8b16e0ea2dac288915647f73879">EquationSystems::write</a>(<span class="keyword">const</span> std::string&amp; name,
<a name="l00369"></a>00369                             <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8">libMeshEnums::XdrMODE</a> mode,
<a name="l00370"></a>00370                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> write_flags)<span class="keyword"> const</span>
<a name="l00371"></a>00371 <span class="keyword"></span>{
<a name="l00435"></a>00435   <span class="comment">// the EquationSystems::write() method should look constant,</span>
<a name="l00436"></a>00436   <span class="comment">// but we need to assign a temporary numbering to the nodes</span>
<a name="l00437"></a>00437   <span class="comment">// and elements in the mesh, which requires that we abuse const_cast</span>
<a name="l00438"></a>00438   {
<a name="l00439"></a>00439     <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp;<a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a> = <span class="keyword">const_cast&lt;</span><a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp;<span class="keyword">&gt;</span>(this-&gt;<a class="code" href="classlibMesh_1_1EquationSystems.php#aba1132bd8b38e9ce851abf57c3bc1e4b">get_mesh</a>());
<a name="l00440"></a>00440     <a class="code" href="namespacelibMesh_1_1MeshTools_1_1Private.php#a6250f59b9180229182c52939a4511363">MeshTools::Private::globally_renumber_nodes_and_elements</a>(mesh);
<a name="l00441"></a>00441   }
<a name="l00442"></a>00442   
<a name="l00443"></a>00443    <span class="comment">// set booleans from write_flags argument</span>
<a name="l00444"></a>00444    <span class="keyword">const</span> <span class="keywordtype">bool</span> write_data            = write_flags &amp; <a class="code" href="classlibMesh_1_1EquationSystems.php#a6a315352a9c8f99542d4c589c45b2532ab363df4400f883ee435550e14b84c2b2">EquationSystems::WRITE_DATA</a>;
<a name="l00445"></a>00445    <span class="keyword">const</span> <span class="keywordtype">bool</span> write_parallel_files  = write_flags &amp; <a class="code" href="classlibMesh_1_1EquationSystems.php#a6a315352a9c8f99542d4c589c45b2532ac1fc13fe2627f7fb98944185ae68df71">EquationSystems::WRITE_PARALLEL_FILES</a>;
<a name="l00446"></a>00446    <span class="keyword">const</span> <span class="keywordtype">bool</span> write_additional_data = write_flags &amp; <a class="code" href="classlibMesh_1_1EquationSystems.php#a6a315352a9c8f99542d4c589c45b2532adb3b46d8dd4d07aad77c353eafc3e2a8">EquationSystems::WRITE_ADDITIONAL_DATA</a>;
<a name="l00447"></a>00447 
<a name="l00448"></a>00448   <span class="comment">// New scope so that io will close before we try to zip the file</span>
<a name="l00449"></a>00449   {
<a name="l00450"></a>00450     <a class="code" href="classlibMesh_1_1Xdr.php">Xdr</a> io((<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>()==0) ? name : <span class="stringliteral">&quot;&quot;</span>, mode);    
<a name="l00451"></a>00451     libmesh_assert (io.<a class="code" href="classlibMesh_1_1Xdr.php#a55d24a44020695db1d5ea3d11d80ef77">writing</a>());
<a name="l00452"></a>00452     
<a name="l00453"></a>00453     START_LOG(<span class="stringliteral">&quot;write()&quot;</span>,<span class="stringliteral">&quot;EquationSystems&quot;</span>);
<a name="l00454"></a>00454 
<a name="l00455"></a>00455     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id = <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>();
<a name="l00456"></a>00456     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_sys         = this-&gt;<a class="code" href="classlibMesh_1_1EquationSystems.php#a93238b71a514e6d24f284e5f92947fbe">n_systems</a>();
<a name="l00457"></a>00457     
<a name="l00458"></a>00458     std::map&lt;std::string, System*&gt;::const_iterator
<a name="l00459"></a>00459       pos = <a class="code" href="classlibMesh_1_1EquationSystems.php#a7a35e87841d9f17fb7e2588ff059ec8e">_systems</a>.begin();
<a name="l00460"></a>00460     
<a name="l00461"></a>00461     std::string comment;
<a name="l00462"></a>00462     <span class="keywordtype">char</span> buf[256];
<a name="l00463"></a>00463     
<a name="l00464"></a>00464     <span class="comment">// Only write the header information</span>
<a name="l00465"></a>00465     <span class="comment">// if we are processor 0.</span>
<a name="l00466"></a>00466     <span class="keywordflow">if</span> (proc_id == 0) 
<a name="l00467"></a>00467       {
<a name="l00468"></a>00468         <span class="comment">// 1.)</span>
<a name="l00469"></a>00469         <span class="comment">// Write the version header</span>
<a name="l00470"></a>00470         std::string version = <span class="stringliteral">&quot;libMesh-0.7.0+&quot;</span>;
<a name="l00471"></a>00471         <span class="keywordflow">if</span> (write_parallel_files) version += <span class="stringliteral">&quot; parallel&quot;</span>;
<a name="l00472"></a>00472         
<a name="l00473"></a>00473 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00474"></a>00474 <span class="preprocessor"></span>        version += <span class="stringliteral">&quot; with infinite elements&quot;</span>;
<a name="l00475"></a>00475 <span class="preprocessor">#endif</span>
<a name="l00476"></a>00476 <span class="preprocessor"></span>        io.<a class="code" href="classlibMesh_1_1Xdr.php#a8d41e3ea5b2559f8a73d83ad06a14cad">data</a> (version, <span class="stringliteral">&quot;# File Format Identifier&quot;</span>);
<a name="l00477"></a>00477         
<a name="l00478"></a>00478         <span class="comment">// 2.)  </span>
<a name="l00479"></a>00479         <span class="comment">// Write the number of equation systems</span>
<a name="l00480"></a>00480         io.<a class="code" href="classlibMesh_1_1Xdr.php#a8d41e3ea5b2559f8a73d83ad06a14cad">data</a> (n_sys, <span class="stringliteral">&quot;# No. of Equation Systems&quot;</span>);
<a name="l00481"></a>00481         
<a name="l00482"></a>00482         <span class="keywordflow">while</span> (pos != <a class="code" href="classlibMesh_1_1EquationSystems.php#a7a35e87841d9f17fb7e2588ff059ec8e">_systems</a>.end())
<a name="l00483"></a>00483           {
<a name="l00484"></a>00484             <span class="comment">// 3.)</span>
<a name="l00485"></a>00485             <span class="comment">// Write the name of the sys_num-th system</span>
<a name="l00486"></a>00486             {
<a name="l00487"></a>00487               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sys_num = pos-&gt;second-&gt;number();
<a name="l00488"></a>00488               std::string sys_name       = pos-&gt;first;
<a name="l00489"></a>00489               
<a name="l00490"></a>00490               comment =  <span class="stringliteral">&quot;# Name, System No. &quot;</span>;
<a name="l00491"></a>00491               std::sprintf(buf, <span class="stringliteral">&quot;%d&quot;</span>, sys_num);
<a name="l00492"></a>00492               comment += buf;
<a name="l00493"></a>00493           
<a name="l00494"></a>00494               io.<a class="code" href="classlibMesh_1_1Xdr.php#a8d41e3ea5b2559f8a73d83ad06a14cad">data</a> (sys_name, comment.c_str());
<a name="l00495"></a>00495             }
<a name="l00496"></a>00496           
<a name="l00497"></a>00497             <span class="comment">// 4.)</span>
<a name="l00498"></a>00498             <span class="comment">// Write the type of system handled</span>
<a name="l00499"></a>00499             {
<a name="l00500"></a>00500               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sys_num = pos-&gt;second-&gt;number();
<a name="l00501"></a>00501               std::string sys_type       = pos-&gt;second-&gt;system_type();
<a name="l00502"></a>00502 
<a name="l00503"></a>00503               comment =  <span class="stringliteral">&quot;# Type, System No. &quot;</span>;
<a name="l00504"></a>00504               std::sprintf(buf, <span class="stringliteral">&quot;%d&quot;</span>, sys_num);
<a name="l00505"></a>00505               comment += buf;
<a name="l00506"></a>00506           
<a name="l00507"></a>00507               io.<a class="code" href="classlibMesh_1_1Xdr.php#a8d41e3ea5b2559f8a73d83ad06a14cad">data</a> (sys_type, comment.c_str());
<a name="l00508"></a>00508             }
<a name="l00509"></a>00509         
<a name="l00510"></a>00510             <span class="comment">// 5.) - 9.)</span>
<a name="l00511"></a>00511             <span class="comment">// Let System::write_header() do the job</span>
<a name="l00512"></a>00512             pos-&gt;second-&gt;write_header (io, version, write_additional_data);
<a name="l00513"></a>00513             
<a name="l00514"></a>00514             ++pos;
<a name="l00515"></a>00515           }
<a name="l00516"></a>00516       }
<a name="l00517"></a>00517 
<a name="l00518"></a>00518     <span class="comment">// Start from the first system, again,</span>
<a name="l00519"></a>00519     <span class="comment">// to write vectors to disk, if wanted</span>
<a name="l00520"></a>00520     <span class="keywordflow">if</span> (write_data)
<a name="l00521"></a>00521       {
<a name="l00522"></a>00522         <span class="comment">// open a parallel buffer if warranted.</span>
<a name="l00523"></a>00523         <a class="code" href="classlibMesh_1_1Xdr.php">Xdr</a> local_io (write_parallel_files ? local_file_name(name) : <span class="stringliteral">&quot;&quot;</span>, mode);
<a name="l00524"></a>00524         
<a name="l00525"></a>00525         <span class="keywordflow">for</span> (pos = <a class="code" href="classlibMesh_1_1EquationSystems.php#a7a35e87841d9f17fb7e2588ff059ec8e">_systems</a>.begin(); pos != <a class="code" href="classlibMesh_1_1EquationSystems.php#a7a35e87841d9f17fb7e2588ff059ec8e">_systems</a>.end(); ++pos) 
<a name="l00526"></a>00526           {
<a name="l00527"></a>00527             <span class="comment">// 10.) + 11.)</span>
<a name="l00528"></a>00528             <span class="keywordflow">if</span> (write_parallel_files)
<a name="l00529"></a>00529               pos-&gt;second-&gt;write_parallel_data (local_io,write_additional_data);
<a name="l00530"></a>00530             <span class="keywordflow">else</span>
<a name="l00531"></a>00531               pos-&gt;second-&gt;write_serialized_data (io,write_additional_data);
<a name="l00532"></a>00532           }
<a name="l00533"></a>00533       }
<a name="l00534"></a>00534         
<a name="l00535"></a>00535     STOP_LOG(<span class="stringliteral">&quot;write()&quot;</span>,<span class="stringliteral">&quot;EquationSystems&quot;</span>);
<a name="l00536"></a>00536   }
<a name="l00537"></a>00537  
<a name="l00538"></a>00538   <span class="comment">// the EquationSystems::write() method should look constant,</span>
<a name="l00539"></a>00539   <span class="comment">// but we need to undo the temporary numbering of the nodes</span>
<a name="l00540"></a>00540   <span class="comment">// and elements in the mesh, which requires that we abuse const_cast</span>
<a name="l00541"></a>00541   <span class="keywordflow">if</span> (dynamic_cast&lt;ParallelMesh*&gt;(const_cast&lt;MeshBase*&gt;(&amp;<a class="code" href="classlibMesh_1_1EquationSystems.php#aa40db714c766361cd70548df3d06c57d">_mesh</a>)))
<a name="l00542"></a>00542     {
<a name="l00543"></a>00543       <a class="code" href="classlibMesh_1_1ParallelMesh.php">ParallelMesh</a> *<a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a> = <span class="keyword">dynamic_cast&lt;</span><a class="code" href="classlibMesh_1_1ParallelMesh.php">ParallelMesh</a>*<span class="keyword">&gt;</span>(<span class="keyword">const_cast&lt;</span><a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>*<span class="keyword">&gt;</span>(&amp;<a class="code" href="classlibMesh_1_1EquationSystems.php#aa40db714c766361cd70548df3d06c57d">_mesh</a>));    
<a name="l00544"></a>00544       <a class="code" href="namespacelibMesh_1_1MeshTools_1_1Private.php#a767e57ef66c9f372a1ee424e8caadd0d">MeshTools::Private::fix_broken_node_and_element_numbering</a>(*mesh);
<a name="l00545"></a>00545     }
<a name="l00546"></a>00546   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (dynamic_cast&lt;SerialMesh*&gt;(const_cast&lt;MeshBase*&gt;(&amp;<a class="code" href="classlibMesh_1_1EquationSystems.php#aa40db714c766361cd70548df3d06c57d">_mesh</a>)))
<a name="l00547"></a>00547     {
<a name="l00548"></a>00548       <a class="code" href="classlibMesh_1_1SerialMesh.php">SerialMesh</a> *<a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a> = <span class="keyword">dynamic_cast&lt;</span><a class="code" href="classlibMesh_1_1SerialMesh.php">SerialMesh</a>*<span class="keyword">&gt;</span>(<span class="keyword">const_cast&lt;</span><a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>*<span class="keyword">&gt;</span>(&amp;<a class="code" href="classlibMesh_1_1EquationSystems.php#aa40db714c766361cd70548df3d06c57d">_mesh</a>));    
<a name="l00549"></a>00549       <a class="code" href="namespacelibMesh_1_1MeshTools_1_1Private.php#a767e57ef66c9f372a1ee424e8caadd0d">MeshTools::Private::fix_broken_node_and_element_numbering</a>(*mesh);
<a name="l00550"></a>00550     }
<a name="l00551"></a>00551   <span class="keywordflow">else</span>
<a name="l00552"></a>00552     {
<a name="l00553"></a>00553       <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR:  dynamic_cast&lt;&gt; to ParallelMesh and SerialMesh failed!&quot;</span>
<a name="l00554"></a>00554                     &lt;&lt; std::endl;
<a name="l00555"></a>00555       libmesh_error();
<a name="l00556"></a>00556     }
<a name="l00557"></a>00557 }
<a name="l00558"></a>00558 
<a name="l00559"></a>00559 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
