<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_c3a49989e40b21e7508f29d2dc962def.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_32bb88e3eb1b93402cfe508abee484a3.php">mesh</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">exodusII_io.C</div>  </div>
</div>
<div class="contents">
<a href="exodusII__io_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id$</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="comment">// C++ includes</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &lt;fstream&gt;</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &lt;cstring&gt;</span>
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 <span class="comment">// Local includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="exodusII__io_8h.php">exodusII_io.h</a>&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="boundary__info_8h.php">boundary_info.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="mesh__base_8h.php">mesh_base.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="enum__elem__type_8h.php">enum_elem_type.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="elem_8h.php">elem.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="equation__systems_8h.php">equation_systems.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="system_8h.php">system.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="numeric__vector_8h.php">numeric_vector.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="exodusII__io__helper_8h.php">exodusII_io_helper.h</a>&quot;</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="keyword">namespace </span>libMesh
<a name="l00037"></a>00037 {
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00044"></a>00044 <span class="comment">// ExodusII_IO class members</span>
<a name="l00045"></a><a class="code" href="classlibMesh_1_1ExodusII__IO.php#a37202ae96a19aac1b48ec207dea0b37f">00045</a> <a class="code" href="classlibMesh_1_1ExodusII__IO.php#a37202ae96a19aac1b48ec207dea0b37f">ExodusII_IO::ExodusII_IO</a> (<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>) :
<a name="l00046"></a>00046   <a class="code" href="classlibMesh_1_1MeshInput.php">MeshInput</a>&lt;<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&gt; (mesh),
<a name="l00047"></a>00047   <a class="code" href="classlibMesh_1_1MeshOutput.php">MeshOutput</a>&lt;<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&gt; (mesh),
<a name="l00048"></a>00048 #ifdef LIBMESH_HAVE_EXODUS_API
<a name="l00049"></a>00049   exio_helper(new <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php">ExodusII_IO_Helper</a>),
<a name="l00050"></a>00050 #endif
<a name="l00051"></a>00051   _timestep(1),
<a name="l00052"></a>00052   _verbose (false)
<a name="l00053"></a>00053 {
<a name="l00054"></a>00054 }
<a name="l00055"></a>00055 
<a name="l00056"></a>00056 
<a name="l00057"></a>00057 
<a name="l00058"></a><a class="code" href="classlibMesh_1_1ExodusII__IO.php#a704f17fe5f371dfbe4b472d01bafa595">00058</a> <a class="code" href="classlibMesh_1_1ExodusII__IO.php#a704f17fe5f371dfbe4b472d01bafa595">ExodusII_IO::~ExodusII_IO</a> ()
<a name="l00059"></a>00059 {
<a name="l00060"></a>00060 <span class="preprocessor">#ifndef LIBMESH_HAVE_EXODUS_API</span>
<a name="l00061"></a>00061 <span class="preprocessor"></span>
<a name="l00062"></a>00062   <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt;  <span class="stringliteral">&quot;ERROR, ExodusII API is not defined.\n&quot;</span>
<a name="l00063"></a>00063                 &lt;&lt; std::endl;
<a name="l00064"></a>00064   libmesh_error();
<a name="l00065"></a>00065     
<a name="l00066"></a>00066 <span class="preprocessor">#else</span>
<a name="l00067"></a>00067 <span class="preprocessor"></span>  
<a name="l00068"></a>00068   <span class="keywordflow">if</span>(<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l00069"></a>00069     <a class="code" href="classlibMesh_1_1ExodusII__IO.php#af4c35286542c22438da363ed7e8bc591">exio_helper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#ac6fdd71b06584b8fb6d1e0fe3e271964">close</a>();
<a name="l00070"></a>00070 
<a name="l00071"></a>00071   <span class="keyword">delete</span> <a class="code" href="classlibMesh_1_1ExodusII__IO.php#af4c35286542c22438da363ed7e8bc591">exio_helper</a>;
<a name="l00072"></a>00072   
<a name="l00073"></a>00073 <span class="preprocessor">#endif</span>
<a name="l00074"></a>00074 <span class="preprocessor"></span>}
<a name="l00075"></a>00075 
<a name="l00076"></a>00076 
<a name="l00077"></a>00077 
<a name="l00078"></a><a class="code" href="classlibMesh_1_1ExodusII__IO.php#a3c93dad68213877369e9a5a336d005fc">00078</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExodusII__IO.php#a3c93dad68213877369e9a5a336d005fc">ExodusII_IO::verbose</a> (<span class="keywordtype">bool</span> set_verbosity)
<a name="l00079"></a>00079 {
<a name="l00080"></a>00080   <a class="code" href="classlibMesh_1_1ExodusII__IO.php#a33ee8571dc3cbfb11ca8c3f0b13009f5">_verbose</a> = set_verbosity;
<a name="l00081"></a>00081 
<a name="l00082"></a>00082 <span class="preprocessor">#ifdef LIBMESH_HAVE_EXODUS_API</span>
<a name="l00083"></a>00083 <span class="preprocessor"></span>  <span class="comment">// Set the verbose flag in the helper object</span>
<a name="l00084"></a>00084   <span class="comment">// as well.</span>
<a name="l00085"></a>00085   <a class="code" href="classlibMesh_1_1ExodusII__IO.php#af4c35286542c22438da363ed7e8bc591">exio_helper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a0a486e1d944ba2dcea784255c5652499">verbose</a>(<a class="code" href="classlibMesh_1_1ExodusII__IO.php#a33ee8571dc3cbfb11ca8c3f0b13009f5">_verbose</a>);
<a name="l00086"></a>00086 <span class="preprocessor">#endif</span>
<a name="l00087"></a>00087 <span class="preprocessor"></span>}
<a name="l00088"></a>00088 
<a name="l00089"></a>00089 
<a name="l00090"></a>00090 
<a name="l00091"></a><a class="code" href="classlibMesh_1_1ExodusII__IO.php#a5c8740e7197ba48ac0cd7d91d753f0f1">00091</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExodusII__IO.php#a5c8740e7197ba48ac0cd7d91d753f0f1">ExodusII_IO::read</a> (<span class="keyword">const</span> std::string&amp; fname)
<a name="l00092"></a>00092 {
<a name="l00093"></a>00093   <span class="comment">// This is a serial-only process for now;</span>
<a name="l00094"></a>00094   <span class="comment">// the Mesh should be read on processor 0 and</span>
<a name="l00095"></a>00095   <span class="comment">// broadcast later</span>
<a name="l00096"></a>00096 <span class="comment">//  libmesh_assert(libMesh::processor_id() == 0);</span>
<a name="l00097"></a>00097 
<a name="l00098"></a>00098 <span class="preprocessor">#ifndef LIBMESH_HAVE_EXODUS_API</span>
<a name="l00099"></a>00099 <span class="preprocessor"></span>
<a name="l00100"></a>00100   <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt;  <span class="stringliteral">&quot;ERROR, ExodusII API is not defined.\n&quot;</span>
<a name="l00101"></a>00101                 &lt;&lt; <span class="stringliteral">&quot;Input file &quot;</span> &lt;&lt; fname &lt;&lt; <span class="stringliteral">&quot; cannot be read&quot;</span>
<a name="l00102"></a>00102                 &lt;&lt; std::endl;
<a name="l00103"></a>00103   libmesh_error();
<a name="l00104"></a>00104     
<a name="l00105"></a>00105 <span class="preprocessor">#else</span>
<a name="l00106"></a>00106 <span class="preprocessor"></span>  
<a name="l00107"></a>00107   <span class="comment">// Get a reference to the mesh we are reading</span>
<a name="l00108"></a>00108   <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="classlibMesh_1_1MeshInput.php#ac18df20ac8c6a96bc404d08bae1e481b">mesh</a> = <a class="code" href="classlibMesh_1_1MeshInput.php#ac18df20ac8c6a96bc404d08bae1e481b">MeshInput&lt;MeshBase&gt;::mesh</a>();
<a name="l00109"></a>00109   
<a name="l00110"></a>00110   <span class="comment">// Clear any existing mesh data</span>
<a name="l00111"></a>00111   mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a96d8f46093558e6c54de2743570c778d">clear</a>();
<a name="l00112"></a>00112   
<a name="l00113"></a>00113   <span class="comment">// Keep track of what kinds of elements this file contains</span>
<a name="l00114"></a>00114   <a class="code" href="classlibMesh_1_1MeshInput.php#aa674e5327727692fac891ae85f2c211a">elems_of_dimension</a>.clear();
<a name="l00115"></a>00115   <a class="code" href="classlibMesh_1_1MeshInput.php#aa674e5327727692fac891ae85f2c211a">elems_of_dimension</a>.resize(4, <span class="keyword">false</span>);
<a name="l00116"></a>00116   
<a name="l00117"></a>00117 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00118"></a>00118 <span class="preprocessor"></span>  this-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO.php#a3c93dad68213877369e9a5a336d005fc">verbose</a>(<span class="keyword">true</span>);
<a name="l00119"></a>00119 <span class="preprocessor">#endif</span>
<a name="l00120"></a>00120 <span class="preprocessor"></span>
<a name="l00121"></a>00121   
<a name="l00122"></a>00122   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php">ExodusII_IO_Helper::ElementMaps</a> em;     <span class="comment">// Instantiate the ElementMaps interface</span>
<a name="l00123"></a>00123     
<a name="l00124"></a>00124   <a class="code" href="classlibMesh_1_1ExodusII__IO.php#af4c35286542c22438da363ed7e8bc591">exio_helper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a9bf6deacca92641b0d30d7749a06b887">open</a>(fname.c_str());       <span class="comment">// Open the exodus file, if possible</span>
<a name="l00125"></a>00125   <a class="code" href="classlibMesh_1_1ExodusII__IO.php#af4c35286542c22438da363ed7e8bc591">exio_helper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#ad33f14d5154d71c0bf8339e44b801997">read_header</a>();             <span class="comment">// Get header information from exodus file</span>
<a name="l00126"></a>00126   <a class="code" href="classlibMesh_1_1ExodusII__IO.php#af4c35286542c22438da363ed7e8bc591">exio_helper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#aa57b23eb3af94898729cb25919b3123c">print_header</a>();            <span class="comment">// Print header information</span>
<a name="l00127"></a>00127 
<a name="l00128"></a>00128   <span class="comment">//assertion fails due to inconsistent mesh dimension</span>
<a name="l00129"></a>00129 <span class="comment">//  libmesh_assert(static_cast&lt;unsigned int&gt;(exio_helper-&gt;get_num_dim()) == mesh.mesh_dimension()); // Be sure number of dimensions</span>
<a name="l00130"></a>00130                                                                                 <span class="comment">// is equal to the number of </span>
<a name="l00131"></a>00131                                                                                 <span class="comment">// dimensions in the mesh supplied.</span>
<a name="l00132"></a>00132   
<a name="l00133"></a>00133   <a class="code" href="classlibMesh_1_1ExodusII__IO.php#af4c35286542c22438da363ed7e8bc591">exio_helper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a6442ae2187f05185649d88efef41c000">read_nodes</a>();                        <span class="comment">// Read nodes from the exodus file</span>
<a name="l00134"></a>00134   mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a722dd88d208fbb89fa685118a46d6773">reserve_nodes</a>(<a class="code" href="classlibMesh_1_1ExodusII__IO.php#af4c35286542c22438da363ed7e8bc591">exio_helper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a7280541fd27d1d0ecd0d9e7fbe6ef5fb">get_num_nodes</a>()); <span class="comment">// Reserve space for the nodes.</span>
<a name="l00135"></a>00135   
<a name="l00136"></a>00136   <span class="comment">// Loop over the nodes, create Nodes with local processor_id 0.</span>
<a name="l00137"></a>00137   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1ExodusII__IO.php#af4c35286542c22438da363ed7e8bc591">exio_helper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a7280541fd27d1d0ecd0d9e7fbe6ef5fb">get_num_nodes</a>(); i++)
<a name="l00138"></a>00138     mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ab07787f7933b2fbe29bc2bef32401fdc">add_point</a> (<a class="code" href="classlibMesh_1_1Point.php">Point</a>(<a class="code" href="classlibMesh_1_1ExodusII__IO.php#af4c35286542c22438da363ed7e8bc591">exio_helper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a417aaa97299b4bd266897885972bc1d1">get_x</a>(i),
<a name="l00139"></a>00139                           <a class="code" href="classlibMesh_1_1ExodusII__IO.php#af4c35286542c22438da363ed7e8bc591">exio_helper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a133f0ec35710b694aa1d279e2e566f31">get_y</a>(i),
<a name="l00140"></a>00140                           <a class="code" href="classlibMesh_1_1ExodusII__IO.php#af4c35286542c22438da363ed7e8bc591">exio_helper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a06debfd48c4ba7f0f0d87fc29e578b8f">get_z</a>(i)), i);
<a name="l00141"></a>00141   
<a name="l00142"></a>00142   libmesh_assert (static_cast&lt;unsigned int&gt;(<a class="code" href="classlibMesh_1_1ExodusII__IO.php#af4c35286542c22438da363ed7e8bc591">exio_helper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a7280541fd27d1d0ecd0d9e7fbe6ef5fb">get_num_nodes</a>()) == mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aff7b82001829828de180cf961df93ea1">n_nodes</a>());
<a name="l00143"></a>00143 
<a name="l00144"></a>00144   <a class="code" href="classlibMesh_1_1ExodusII__IO.php#af4c35286542c22438da363ed7e8bc591">exio_helper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a025711d210123880b8cdac91184ab45b">read_block_info</a>();                 <span class="comment">// Get information about all the blocks</span>
<a name="l00145"></a>00145   mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#af5d5be0906f6129f3f3bd9b4878789c4">reserve_elem</a>(<a class="code" href="classlibMesh_1_1ExodusII__IO.php#af4c35286542c22438da363ed7e8bc591">exio_helper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#aabaf749380214fc6db08c3bcfe7a0e80">get_num_elem</a>()); <span class="comment">// Reserve space for the elements</span>
<a name="l00146"></a>00146    
<a name="l00147"></a>00147 
<a name="l00148"></a>00148   <span class="comment">// Read in the element connectivity for each block.</span>
<a name="l00149"></a>00149   <span class="keywordtype">int</span> nelem_last_block = 0;
<a name="l00150"></a>00150 
<a name="l00151"></a>00151   std::map&lt;int, unsigned int&gt; exodus_id_to_mesh_id;
<a name="l00152"></a>00152 
<a name="l00153"></a>00153   <span class="comment">// Loop over all the blocks</span>
<a name="l00154"></a>00154   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1ExodusII__IO.php#af4c35286542c22438da363ed7e8bc591">exio_helper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a5baa687c81b853f37bcec2f833d2f195">get_num_elem_blk</a>(); i++)
<a name="l00155"></a>00155     {
<a name="l00156"></a>00156       <span class="comment">// Read the information for block i</span>
<a name="l00157"></a>00157       <a class="code" href="classlibMesh_1_1ExodusII__IO.php#af4c35286542c22438da363ed7e8bc591">exio_helper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#afc3acc1e28f081a9f8a3c3a160715387">read_elem_in_block</a> (i);
<a name="l00158"></a>00158       <span class="keywordtype">int</span> subdomain_id = <a class="code" href="classlibMesh_1_1ExodusII__IO.php#af4c35286542c22438da363ed7e8bc591">exio_helper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a5add1e7f7ce8f31ab39b9c5a429771f4">get_block_id</a>(i);
<a name="l00159"></a>00159 
<a name="l00160"></a>00160       <span class="comment">// Set any relevant node/edge maps for this element</span>
<a name="l00161"></a>00161       <span class="keyword">const</span> std::string type_str (<a class="code" href="classlibMesh_1_1ExodusII__IO.php#af4c35286542c22438da363ed7e8bc591">exio_helper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a1346e40c076822fad7292898dc8a5a80">get_elem_type</a>());
<a name="l00162"></a>00162       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1Conversion.php">ExodusII_IO_Helper::Conversion</a> conv = em.<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#ad7bd06525087dfbddb663f5330f1882f">assign_conversion</a>(type_str); 
<a name="l00163"></a>00163       <span class="comment">//if (_verbose)</span>
<a name="l00164"></a>00164       <span class="comment">//libMesh::out &lt;&lt; &quot;Reading a block of &quot; &lt;&lt; type_str &lt;&lt; &quot; elements.&quot; &lt;&lt; std::endl;</span>
<a name="l00165"></a>00165       
<a name="l00166"></a>00166       <span class="comment">// Loop over all the faces in this block</span>
<a name="l00167"></a>00167       <span class="keywordtype">int</span> jmax = nelem_last_block+<a class="code" href="classlibMesh_1_1ExodusII__IO.php#af4c35286542c22438da363ed7e8bc591">exio_helper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#aaa7c4fca84a868ebb8ad9b4ee3e395db">get_num_elem_this_blk</a>();
<a name="l00168"></a>00168       <span class="keywordflow">for</span> (<span class="keywordtype">int</span> j=nelem_last_block; j&lt;jmax; j++)
<a name="l00169"></a>00169         {
<a name="l00170"></a>00170           <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = <a class="code" href="classlibMesh_1_1Elem.php#a68cfa73358f50660055bf07a2919b2db">Elem::build</a> (conv.get_canonical_type()).release();
<a name="l00171"></a>00171           libmesh_assert (elem);
<a name="l00172"></a>00172           elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a96faae17e7ede5aa89c687d54cefb4b3">subdomain_id</a>() = <span class="keyword">static_cast&lt;</span><a class="code" href="classlibMesh_1_1TestClass.php">subdomain_id_type</a><span class="keyword">&gt;</span>(subdomain_id) ;
<a name="l00173"></a>00173           <span class="comment">//elem-&gt;set_id(j);// Don&#39;t try to second guess the Element ID setting scheme!</span>
<a name="l00174"></a>00174 
<a name="l00175"></a>00175           <a class="code" href="classlibMesh_1_1MeshInput.php#aa674e5327727692fac891ae85f2c211a">elems_of_dimension</a>[elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#aa50d97d65dc379f64667da53c427b36f">dim</a>()] = <span class="keyword">true</span>;
<a name="l00176"></a>00176 
<a name="l00177"></a>00177           elem = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a5ab834283fa6bc335ad623d2b737ec5e">add_elem</a> (elem); <span class="comment">// Catch the Elem pointer that the Mesh throws back</span>
<a name="l00178"></a>00178 
<a name="l00179"></a>00179           exodus_id_to_mesh_id[j+1] = elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>();
<a name="l00180"></a>00180             
<a name="l00181"></a>00181           <span class="comment">// Set all the nodes for this element</span>
<a name="l00182"></a>00182           <span class="keywordflow">for</span> (<span class="keywordtype">int</span> k=0; k&lt;<a class="code" href="classlibMesh_1_1ExodusII__IO.php#af4c35286542c22438da363ed7e8bc591">exio_helper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a6da9a02553b9f9edb530b70471da077f">get_num_nodes_per_elem</a>(); k++)
<a name="l00183"></a>00183             {
<a name="l00184"></a>00184               <span class="keywordtype">int</span> gi = (j-nelem_last_block)*<a class="code" href="classlibMesh_1_1ExodusII__IO.php#af4c35286542c22438da363ed7e8bc591">exio_helper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a6da9a02553b9f9edb530b70471da077f">get_num_nodes_per_elem</a>() + conv.get_node_map(k); <span class="comment">// global index </span>
<a name="l00185"></a>00185               <span class="keywordtype">int</span> node_number   = <a class="code" href="classlibMesh_1_1ExodusII__IO.php#af4c35286542c22438da363ed7e8bc591">exio_helper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a4df6a901221fd3e98938f78240d90ed1">get_connect</a>(gi);             <span class="comment">// Global node number (1-based)</span>
<a name="l00186"></a>00186               elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(k) = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>((node_number-1)); <span class="comment">// Set node number</span>
<a name="l00187"></a>00187                                                                   <span class="comment">// Subtract 1 since</span>
<a name="l00188"></a>00188                                                                   <span class="comment">// exodus is internally 1-based</span>
<a name="l00189"></a>00189             }
<a name="l00190"></a>00190         }
<a name="l00191"></a>00191       
<a name="l00192"></a>00192       <span class="comment">// running sum of # of elements per block,</span>
<a name="l00193"></a>00193       <span class="comment">// (should equal total number of elements in the end)</span>
<a name="l00194"></a>00194       nelem_last_block += <a class="code" href="classlibMesh_1_1ExodusII__IO.php#af4c35286542c22438da363ed7e8bc591">exio_helper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#aaa7c4fca84a868ebb8ad9b4ee3e395db">get_num_elem_this_blk</a>();
<a name="l00195"></a>00195     }
<a name="l00196"></a>00196   libmesh_assert (static_cast&lt;unsigned int&gt;(nelem_last_block) == mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a89566c09cd05aba8bd7f606eba96bf6f">n_elem</a>());
<a name="l00197"></a>00197 
<a name="l00198"></a>00198   <span class="comment">// Read in sideset information -- this is useful for applying boundary conditions</span>
<a name="l00199"></a>00199   {
<a name="l00200"></a>00200     <a class="code" href="classlibMesh_1_1ExodusII__IO.php#af4c35286542c22438da363ed7e8bc591">exio_helper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a9374fbb748e06b3fcdd5ca6a25bc1cd7">read_sideset_info</a>(); <span class="comment">// Get basic information about ALL sidesets</span>
<a name="l00201"></a>00201     <span class="keywordtype">int</span> offset=0;
<a name="l00202"></a>00202     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1ExodusII__IO.php#af4c35286542c22438da363ed7e8bc591">exio_helper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a19f54aefc1d97e84171e9abcb7b5c85d">get_num_side_sets</a>(); i++)
<a name="l00203"></a>00203       {
<a name="l00204"></a>00204         offset += (i &gt; 0 ? <a class="code" href="classlibMesh_1_1ExodusII__IO.php#af4c35286542c22438da363ed7e8bc591">exio_helper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a4edc84431dc0c83e9991eb66453685f2">get_num_sides_per_set</a>(i-1) : 0); <span class="comment">// Compute new offset</span>
<a name="l00205"></a>00205         <a class="code" href="classlibMesh_1_1ExodusII__IO.php#af4c35286542c22438da363ed7e8bc591">exio_helper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a7e8af82fdd1f4fed93190bfa0c0fb2cb">read_sideset</a> (i, offset);
<a name="l00206"></a>00206       }
<a name="l00207"></a>00207     
<a name="l00208"></a>00208     <span class="keyword">const</span> std::vector&lt;int&gt;&amp; elem_list = <a class="code" href="classlibMesh_1_1ExodusII__IO.php#af4c35286542c22438da363ed7e8bc591">exio_helper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a2791be975940e6c397e468611d6e8798">get_elem_list</a>();
<a name="l00209"></a>00209     <span class="keyword">const</span> std::vector&lt;int&gt;&amp; side_list = <a class="code" href="classlibMesh_1_1ExodusII__IO.php#af4c35286542c22438da363ed7e8bc591">exio_helper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a60e82239f40a0e79335a925f6dd5f682">get_side_list</a>();
<a name="l00210"></a>00210     <span class="keyword">const</span> std::vector&lt;int&gt;&amp; id_list   = <a class="code" href="classlibMesh_1_1ExodusII__IO.php#af4c35286542c22438da363ed7e8bc591">exio_helper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a32ab0ea73058f9a343c14ce6e1eb65a4">get_id_list</a>();
<a name="l00211"></a>00211 
<a name="l00212"></a>00212     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e=0; e&lt;elem_list.size(); e++)
<a name="l00213"></a>00213       {
<a name="l00214"></a>00214         <span class="comment">// Set any relevant node/edge maps for this element</span>
<a name="l00215"></a>00215 
<a name="l00216"></a>00216         <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> * elem = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(exodus_id_to_mesh_id[elem_list[e]]);
<a name="l00217"></a>00217         
<a name="l00218"></a>00218         <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1Conversion.php">ExodusII_IO_Helper::Conversion</a> conv =
<a name="l00219"></a>00219           em.<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#ad7bd06525087dfbddb663f5330f1882f">assign_conversion</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad06f8ac22978144723179eed42d10bae">type</a>());
<a name="l00220"></a>00220         
<a name="l00221"></a>00221         mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;add_side (exodus_id_to_mesh_id[elem_list[e]],
<a name="l00222"></a>00222                                       conv.<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1Conversion.php#a476e2be06fd2a76407446400e112ec10">get_side_map</a>(side_list[e]-1),
<a name="l00223"></a>00223                                       id_list[e]);
<a name="l00224"></a>00224       }
<a name="l00225"></a>00225   }
<a name="l00226"></a>00226 
<a name="l00227"></a>00227   <span class="comment">// Read nodeset info</span>
<a name="l00228"></a>00228   {
<a name="l00229"></a>00229     <a class="code" href="classlibMesh_1_1ExodusII__IO.php#af4c35286542c22438da363ed7e8bc591">exio_helper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a08200f195605daac61ad8d56a29ec435">read_nodeset_info</a>();
<a name="l00230"></a>00230 
<a name="l00231"></a>00231     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> nodeset=0; nodeset&lt;<a class="code" href="classlibMesh_1_1ExodusII__IO.php#af4c35286542c22438da363ed7e8bc591">exio_helper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a452f165e7cfe0627066e68cdc132527f">get_num_node_sets</a>(); nodeset++)
<a name="l00232"></a>00232       {
<a name="l00233"></a>00233         <span class="keywordtype">int</span> nodeset_id = <a class="code" href="classlibMesh_1_1ExodusII__IO.php#af4c35286542c22438da363ed7e8bc591">exio_helper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#ad294983ff602b7e2d4668a58b3b7704c">get_nodeset_id</a>(nodeset);
<a name="l00234"></a>00234         
<a name="l00235"></a>00235         <a class="code" href="classlibMesh_1_1ExodusII__IO.php#af4c35286542c22438da363ed7e8bc591">exio_helper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#af6f691a32892f4eb9377dba60fe26b31">read_nodeset</a>(nodeset);
<a name="l00236"></a>00236 
<a name="l00237"></a>00237         <span class="keyword">const</span> std::vector&lt;int&gt;&amp; node_list = <a class="code" href="classlibMesh_1_1ExodusII__IO.php#af4c35286542c22438da363ed7e8bc591">exio_helper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a3cbb6a733154af7d6e5a79f44f1ee506">get_node_list</a>();
<a name="l00238"></a>00238 
<a name="l00239"></a>00239         <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> node=0; node&lt;node_list.size(); node++)
<a name="l00240"></a>00240           mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;add_node(node_list[node]-1, nodeset_id);
<a name="l00241"></a>00241       }
<a name="l00242"></a>00242   }
<a name="l00243"></a>00243 
<a name="l00244"></a>00244   <span class="comment">// Set the mesh dimension to the largest encountered for an element</span>
<a name="l00245"></a>00245   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i!=4; ++i)
<a name="l00246"></a>00246     <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1MeshInput.php#aa674e5327727692fac891ae85f2c211a">elems_of_dimension</a>[i])
<a name="l00247"></a>00247       mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#af7db7d54bc846c376d9c57a833263204">set_mesh_dimension</a>(i);
<a name="l00248"></a>00248       
<a name="l00249"></a>00249 <span class="preprocessor">#endif</span>
<a name="l00250"></a>00250 <span class="preprocessor"></span>}
<a name="l00251"></a>00251 
<a name="l00252"></a>00252 
<a name="l00253"></a>00253 
<a name="l00254"></a>00254 <span class="preprocessor">#ifndef LIBMESH_HAVE_EXODUS_API</span>
<a name="l00255"></a>00255 <span class="preprocessor"></span>
<a name="l00256"></a><a class="code" href="classlibMesh_1_1ExodusII__IO.php#a1a4d61cb9e4ceda55ab11d07917df84b">00256</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExodusII__IO.php#a1a4d61cb9e4ceda55ab11d07917df84b">ExodusII_IO::copy_nodal_solution</a>(<a class="code" href="classlibMesh_1_1System.php">System</a>&amp; , std::string, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)
<a name="l00257"></a>00257 {
<a name="l00258"></a>00258 
<a name="l00259"></a>00259   <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt;  <span class="stringliteral">&quot;ERROR, ExodusII API is not defined.\n&quot;</span>
<a name="l00260"></a>00260                 &lt;&lt; std::endl;
<a name="l00261"></a>00261   libmesh_error();
<a name="l00262"></a>00262 }
<a name="l00263"></a>00263 
<a name="l00264"></a>00264 <span class="preprocessor">#else</span>
<a name="l00265"></a>00265 <span class="preprocessor"></span>
<a name="l00266"></a>00266 <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExodusII__IO.php#a1a4d61cb9e4ceda55ab11d07917df84b">ExodusII_IO::copy_nodal_solution</a>(<a class="code" href="classlibMesh_1_1System.php">System</a>&amp; system, std::string nodal_var_name, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> timestep)
<a name="l00267"></a>00267 {
<a name="l00268"></a>00268   <span class="comment">// FIXME: Do we need to call get_time_steps() at all?</span>
<a name="l00269"></a>00269   <span class="comment">/*const std::vector&lt;double&gt;&amp; time_steps = */</span>
<a name="l00270"></a>00270   <a class="code" href="classlibMesh_1_1ExodusII__IO.php#af4c35286542c22438da363ed7e8bc591">exio_helper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#abad269308f48bf51afc8dc8b3423e117">get_time_steps</a>();
<a name="l00271"></a>00271 
<a name="l00272"></a>00272   <span class="keyword">const</span> std::vector&lt;Real&gt; &amp; nodal_values = <a class="code" href="classlibMesh_1_1ExodusII__IO.php#af4c35286542c22438da363ed7e8bc591">exio_helper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a2c1ad57fbda25ca8b03a89e3f256a79e">get_nodal_var_values</a>(nodal_var_name,timestep);
<a name="l00273"></a>00273 
<a name="l00274"></a>00274   <span class="comment">//const DofMap &amp; dof_map = system.get_dof_map();</span>
<a name="l00275"></a>00275 
<a name="l00276"></a>00276   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var_num = system.<a class="code" href="classlibMesh_1_1System.php#aeda27e9696b02cf965e2340fc9e64857">variable_number</a>(nodal_var_name);
<a name="l00277"></a>00277 
<a name="l00278"></a>00278   
<a name="l00279"></a>00279   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;nodal_values.size(); ++i)
<a name="l00280"></a>00280     {
<a name="l00281"></a>00281       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dof_index = <a class="code" href="classlibMesh_1_1MeshInput.php#ac18df20ac8c6a96bc404d08bae1e481b">MeshInput&lt;MeshBase&gt;::mesh</a>().<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(i)-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a99664433bae4e638f8befc83cec4eeff">dof_number</a>(system.<a class="code" href="classlibMesh_1_1System.php#aee5caacb487b070842733f1c84b9a2fd">number</a>(),var_num,0);
<a name="l00282"></a>00282 
<a name="l00283"></a>00283       <span class="comment">// If the dof_index is local to this processor, set the value</span>
<a name="l00284"></a>00284       <span class="keywordflow">if</span> ((dof_index &gt;= system.<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;first_local_index()) &amp;&amp; (dof_index &lt;  system.solution-&gt;last_local_index()))
<a name="l00285"></a>00285         system.<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;set (dof_index, nodal_values[i]);
<a name="l00286"></a>00286     }
<a name="l00287"></a>00287 
<a name="l00288"></a>00288   system.<a class="code" href="classlibMesh_1_1System.php#ab9d81ac9c1787c43fb87cf13d37741ee">update</a>();
<a name="l00289"></a>00289 }
<a name="l00290"></a>00290   
<a name="l00291"></a>00291 <span class="preprocessor">#endif</span>
<a name="l00292"></a>00292 <span class="preprocessor"></span>
<a name="l00293"></a>00293 
<a name="l00294"></a>00294 
<a name="l00295"></a>00295 <span class="preprocessor">#ifndef LIBMESH_HAVE_EXODUS_API</span>
<a name="l00296"></a>00296 <span class="preprocessor"></span>
<a name="l00297"></a><a class="code" href="classlibMesh_1_1ExodusII__IO.php#a7c71e054980db6100b3ebc91d4f4d13b">00297</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExodusII__IO.php#a7c71e054980db6100b3ebc91d4f4d13b">ExodusII_IO::write_nodal_data</a> (<span class="keyword">const</span> std::string&amp; ,
<a name="l00298"></a>00298                                     <span class="keyword">const</span> std::vector&lt;Number&gt;&amp; ,
<a name="l00299"></a>00299                                     <span class="keyword">const</span> std::vector&lt;std::string&gt;&amp; )
<a name="l00300"></a>00300 {
<a name="l00301"></a>00301 
<a name="l00302"></a>00302   <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt;  <span class="stringliteral">&quot;ERROR, ExodusII API is not defined.\n&quot;</span>
<a name="l00303"></a>00303                 &lt;&lt; std::endl;
<a name="l00304"></a>00304   libmesh_error();
<a name="l00305"></a>00305 }
<a name="l00306"></a>00306 
<a name="l00307"></a>00307 <span class="preprocessor">#else</span>
<a name="l00308"></a><a class="code" href="classlibMesh_1_1ExodusII__IO.php#a0dbacd8c0f06c6077b00a2514d539bbe">00308</a> <span class="preprocessor"></span><span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExodusII__IO.php#a0dbacd8c0f06c6077b00a2514d539bbe">ExodusII_IO::write_discontinuous_exodusII</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>,
<a name="l00309"></a>00309                                      <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es)
<a name="l00310"></a>00310 {
<a name="l00311"></a>00311   std::vector&lt;std::string&gt; solution_names;
<a name="l00312"></a>00312   std::vector&lt;Number&gt;      v;
<a name="l00313"></a>00313 
<a name="l00314"></a>00314   <span class="comment">// Get a reference to the mesh</span>
<a name="l00315"></a>00315   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="classlibMesh_1_1MeshInput.php#ac18df20ac8c6a96bc404d08bae1e481b">mesh</a> = <a class="code" href="classlibMesh_1_1MeshInput.php#ac18df20ac8c6a96bc404d08bae1e481b">MeshOutput&lt;MeshBase&gt;::mesh</a>();
<a name="l00316"></a>00316   
<a name="l00317"></a>00317   es.<a class="code" href="classlibMesh_1_1EquationSystems.php#aa050d0013c82f8a646d0ec583e142341">build_variable_names</a>  (solution_names);
<a name="l00318"></a>00318   es.<a class="code" href="classlibMesh_1_1EquationSystems.php#a6916bc3c57d591cccb2e485e663df8d3">build_discontinuous_solution_vector</a> (v);
<a name="l00319"></a>00319 
<a name="l00320"></a>00320   <span class="keywordflow">if</span> (mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa557872c33163622cc66645fc393c925">processor_id</a>() != 0) <span class="keywordflow">return</span>;
<a name="l00321"></a>00321 
<a name="l00322"></a>00322   this-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO.php#aea1df4307625c07f7a64c03a3d998346">write_nodal_data_discontinuous</a>(name, v, solution_names); 
<a name="l00323"></a>00323 }
<a name="l00324"></a>00324   
<a name="l00325"></a>00325 
<a name="l00326"></a><a class="code" href="classlibMesh_1_1ExodusII__IO.php#aea1df4307625c07f7a64c03a3d998346">00326</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExodusII__IO.php#aea1df4307625c07f7a64c03a3d998346">ExodusII_IO::write_nodal_data_discontinuous</a> (<span class="keyword">const</span> std::string&amp; fname,
<a name="l00327"></a>00327                                     <span class="keyword">const</span> std::vector&lt;Number&gt;&amp; soln,
<a name="l00328"></a>00328                                     <span class="keyword">const</span> std::vector&lt;std::string&gt;&amp; names) 
<a name="l00329"></a>00329 {
<a name="l00330"></a>00330   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l00331"></a>00331     {
<a name="l00332"></a>00332       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp; <a class="code" href="classlibMesh_1_1MeshInput.php#ac18df20ac8c6a96bc404d08bae1e481b">mesh</a> = <a class="code" href="classlibMesh_1_1MeshInput.php#ac18df20ac8c6a96bc404d08bae1e481b">MeshOutput&lt;MeshBase&gt;::mesh</a>();
<a name="l00333"></a>00333 
<a name="l00334"></a>00334       <span class="keywordtype">int</span> num_vars = names.size();
<a name="l00335"></a>00335       <span class="keywordtype">int</span> num_nodes = 0;
<a name="l00336"></a>00336       <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>       it  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aefa4ded9eaf654a45ab593a0963ecbf3">active_elements_begin</a>();
<a name="l00337"></a>00337       <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ae3f09f1b7556aef88919249861728e23">active_elements_end</a>(); 
<a name="l00338"></a>00338       <span class="keywordflow">for</span> ( ; it != end; ++it)
<a name="l00339"></a>00339         num_nodes += (*it)-&gt;n_nodes();
<a name="l00340"></a>00340   
<a name="l00341"></a>00341       <span class="comment">// FIXME: Will we ever _not_ need to do this?</span>
<a name="l00342"></a>00342       <span class="comment">// DRG: Yes... when writing multiple timesteps to the same file.</span>
<a name="l00343"></a>00343       <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1ExodusII__IO.php#af4c35286542c22438da363ed7e8bc591">exio_helper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a013eaef14de760ce2e4d736f0ebbb272">created</a>())
<a name="l00344"></a>00344         {
<a name="l00345"></a>00345           <a class="code" href="classlibMesh_1_1ExodusII__IO.php#af4c35286542c22438da363ed7e8bc591">exio_helper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a9daf17d8dc75021475d19e91ea1e3205">create</a>(fname);
<a name="l00346"></a>00346           <a class="code" href="classlibMesh_1_1ExodusII__IO.php#af4c35286542c22438da363ed7e8bc591">exio_helper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#ac3f01f52d7f36235a10ce8300f3ea186">initialize_discontinuous</a>(fname,mesh);
<a name="l00347"></a>00347           <a class="code" href="classlibMesh_1_1ExodusII__IO.php#af4c35286542c22438da363ed7e8bc591">exio_helper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a3fda115cb6c8778c275f030da81d91f2">write_nodal_coordinates_discontinuous</a>(mesh);
<a name="l00348"></a>00348           <a class="code" href="classlibMesh_1_1ExodusII__IO.php#af4c35286542c22438da363ed7e8bc591">exio_helper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#af75f1991e197a050f46a6566876c3314">write_elements_discontinuous</a>(mesh);
<a name="l00349"></a>00349           <a class="code" href="classlibMesh_1_1ExodusII__IO.php#af4c35286542c22438da363ed7e8bc591">exio_helper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a2fd000be6f2bc33c98ad515dd036efe5">write_sidesets</a>(mesh);
<a name="l00350"></a>00350           <a class="code" href="classlibMesh_1_1ExodusII__IO.php#af4c35286542c22438da363ed7e8bc591">exio_helper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a5bffc13cca54029728ced3d8babf25b1">write_nodesets</a>(mesh);
<a name="l00351"></a>00351           <a class="code" href="classlibMesh_1_1ExodusII__IO.php#af4c35286542c22438da363ed7e8bc591">exio_helper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#ae540e94c31f69447563279a75d8b8317">initialize_nodal_variables</a>(names);
<a name="l00352"></a>00352         }
<a name="l00353"></a>00353     
<a name="l00354"></a>00354       <span class="keywordflow">for</span> (<span class="keywordtype">int</span> c=0; c&lt;num_vars; c++)
<a name="l00355"></a>00355         {
<a name="l00356"></a>00356           std::vector&lt;Number&gt; cur_soln(num_nodes);
<a name="l00357"></a>00357 
<a name="l00358"></a>00358           <span class="comment">//Copy out this variable&#39;s solution</span>
<a name="l00359"></a>00359           <span class="keywordflow">for</span>(<span class="keywordtype">int</span> i=0; i&lt;num_nodes; i++)
<a name="l00360"></a>00360             cur_soln[i] = soln[i*num_vars + c];<span class="comment">//c*num_nodes+i];</span>
<a name="l00361"></a>00361     
<a name="l00362"></a>00362           <a class="code" href="classlibMesh_1_1ExodusII__IO.php#af4c35286542c22438da363ed7e8bc591">exio_helper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#ae98bb0ac93b4292635959132b392d0aa">write_nodal_values</a>(c+1,cur_soln,<a class="code" href="classlibMesh_1_1ExodusII__IO.php#a2b9dab351d4149b6ac7c0df25f7f9208">_timestep</a>);
<a name="l00363"></a>00363         }  
<a name="l00364"></a>00364     }
<a name="l00365"></a>00365 }
<a name="l00366"></a>00366 
<a name="l00367"></a>00367 <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExodusII__IO.php#a7c71e054980db6100b3ebc91d4f4d13b">ExodusII_IO::write_nodal_data</a> (<span class="keyword">const</span> std::string&amp; fname,
<a name="l00368"></a>00368                                     <span class="keyword">const</span> std::vector&lt;Number&gt;&amp; soln,
<a name="l00369"></a>00369                                     <span class="keyword">const</span> std::vector&lt;std::string&gt;&amp; names)
<a name="l00370"></a>00370 {
<a name="l00371"></a>00371   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l00372"></a>00372     {
<a name="l00373"></a>00373       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp; <a class="code" href="classlibMesh_1_1MeshInput.php#ac18df20ac8c6a96bc404d08bae1e481b">mesh</a> = <a class="code" href="classlibMesh_1_1MeshInput.php#ac18df20ac8c6a96bc404d08bae1e481b">MeshOutput&lt;MeshBase&gt;::mesh</a>();
<a name="l00374"></a>00374 
<a name="l00375"></a>00375       <span class="keywordtype">int</span> num_vars = names.size();
<a name="l00376"></a>00376       <span class="keywordtype">int</span> num_nodes = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aff7b82001829828de180cf961df93ea1">n_nodes</a>();
<a name="l00377"></a>00377   
<a name="l00378"></a>00378       <span class="comment">// FIXME: Will we ever _not_ need to do this?</span>
<a name="l00379"></a>00379       <span class="comment">// DRG: Yes... when writing multiple timesteps to the same file.</span>
<a name="l00380"></a>00380       <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1ExodusII__IO.php#af4c35286542c22438da363ed7e8bc591">exio_helper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a013eaef14de760ce2e4d736f0ebbb272">created</a>())
<a name="l00381"></a>00381         {
<a name="l00382"></a>00382           <a class="code" href="classlibMesh_1_1ExodusII__IO.php#af4c35286542c22438da363ed7e8bc591">exio_helper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a9daf17d8dc75021475d19e91ea1e3205">create</a>(fname);
<a name="l00383"></a>00383           <a class="code" href="classlibMesh_1_1ExodusII__IO.php#af4c35286542c22438da363ed7e8bc591">exio_helper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a9de09b95a7b1d3d5a56e4874bae230c9">initialize</a>(fname,mesh);
<a name="l00384"></a>00384           <a class="code" href="classlibMesh_1_1ExodusII__IO.php#af4c35286542c22438da363ed7e8bc591">exio_helper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a69566f6e18d15cb9087fdc021c857c8b">write_nodal_coordinates</a>(mesh);
<a name="l00385"></a>00385           <a class="code" href="classlibMesh_1_1ExodusII__IO.php#af4c35286542c22438da363ed7e8bc591">exio_helper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a0800a235c4e380606894be67b6062225">write_elements</a>(mesh);
<a name="l00386"></a>00386           <a class="code" href="classlibMesh_1_1ExodusII__IO.php#af4c35286542c22438da363ed7e8bc591">exio_helper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a2fd000be6f2bc33c98ad515dd036efe5">write_sidesets</a>(mesh);
<a name="l00387"></a>00387           <a class="code" href="classlibMesh_1_1ExodusII__IO.php#af4c35286542c22438da363ed7e8bc591">exio_helper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a5bffc13cca54029728ced3d8babf25b1">write_nodesets</a>(mesh);
<a name="l00388"></a>00388           <a class="code" href="classlibMesh_1_1ExodusII__IO.php#af4c35286542c22438da363ed7e8bc591">exio_helper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#ae540e94c31f69447563279a75d8b8317">initialize_nodal_variables</a>(names);
<a name="l00389"></a>00389         }
<a name="l00390"></a>00390     
<a name="l00391"></a>00391       <span class="keywordflow">for</span> (<span class="keywordtype">int</span> c=0; c&lt;num_vars; c++)
<a name="l00392"></a>00392         {
<a name="l00393"></a>00393           std::vector&lt;Number&gt; cur_soln(num_nodes);
<a name="l00394"></a>00394 
<a name="l00395"></a>00395           <span class="comment">//Copy out this variable&#39;s solution</span>
<a name="l00396"></a>00396           <span class="keywordflow">for</span>(<span class="keywordtype">int</span> i=0; i&lt;num_nodes; i++)
<a name="l00397"></a>00397             cur_soln[i] = soln[i*num_vars + c];<span class="comment">//c*num_nodes+i];</span>
<a name="l00398"></a>00398     
<a name="l00399"></a>00399           <a class="code" href="classlibMesh_1_1ExodusII__IO.php#af4c35286542c22438da363ed7e8bc591">exio_helper</a>-&gt;write_nodal_values(c+1,cur_soln,<a class="code" href="classlibMesh_1_1ExodusII__IO.php#a2b9dab351d4149b6ac7c0df25f7f9208">_timestep</a>);
<a name="l00400"></a>00400         }  
<a name="l00401"></a>00401     }
<a name="l00402"></a>00402 }
<a name="l00403"></a>00403 
<a name="l00404"></a>00404 <span class="preprocessor">#endif</span>
<a name="l00405"></a>00405 <span class="preprocessor"></span>
<a name="l00406"></a>00406 <span class="preprocessor">#ifndef LIBMESH_HAVE_EXODUS_API</span>
<a name="l00407"></a>00407 <span class="preprocessor"></span>
<a name="l00408"></a><a class="code" href="classlibMesh_1_1ExodusII__IO.php#ab9bcb53927e2716e95c04d75035062b2">00408</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExodusII__IO.php#ab9bcb53927e2716e95c04d75035062b2">ExodusII_IO::write_global_data</a> (<span class="keyword">const</span> std::vector&lt;Number&gt;&amp; ,
<a name="l00409"></a>00409                                     <span class="keyword">const</span> std::vector&lt;std::string&gt;&amp; )
<a name="l00410"></a>00410 {
<a name="l00411"></a>00411 
<a name="l00412"></a>00412   <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt;  <span class="stringliteral">&quot;ERROR, ExodusII API is not defined.\n&quot;</span>
<a name="l00413"></a>00413                 &lt;&lt; std::endl;
<a name="l00414"></a>00414   libmesh_error();
<a name="l00415"></a>00415 }
<a name="l00416"></a>00416 
<a name="l00417"></a>00417 <span class="preprocessor">#else</span>
<a name="l00418"></a>00418 <span class="preprocessor"></span>
<a name="l00419"></a>00419 <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExodusII__IO.php#ab9bcb53927e2716e95c04d75035062b2">ExodusII_IO::write_global_data</a> (<span class="keyword">const</span> std::vector&lt;Number&gt;&amp; soln,
<a name="l00420"></a>00420                                      <span class="keyword">const</span> std::vector&lt;std::string&gt;&amp; names)
<a name="l00421"></a>00421 {
<a name="l00422"></a>00422   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l00423"></a>00423     {
<a name="l00424"></a>00424   
<a name="l00425"></a>00425       <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1ExodusII__IO.php#af4c35286542c22438da363ed7e8bc591">exio_helper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a013eaef14de760ce2e4d736f0ebbb272">created</a>())
<a name="l00426"></a>00426         {
<a name="l00427"></a>00427           <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR, ExodusII file must be initialized &quot;</span>
<a name="l00428"></a>00428                        &lt;&lt; <span class="stringliteral">&quot;before outputting global variables.\n&quot;</span>
<a name="l00429"></a>00429                        &lt;&lt; std::endl;
<a name="l00430"></a>00430           libmesh_error();
<a name="l00431"></a>00431         }
<a name="l00432"></a>00432 
<a name="l00433"></a>00433       <a class="code" href="classlibMesh_1_1ExodusII__IO.php#af4c35286542c22438da363ed7e8bc591">exio_helper</a>-&gt;initialize_global_variables( names );
<a name="l00434"></a>00434       <a class="code" href="classlibMesh_1_1ExodusII__IO.php#af4c35286542c22438da363ed7e8bc591">exio_helper</a>-&gt;write_global_values( soln, <a class="code" href="classlibMesh_1_1ExodusII__IO.php#a2b9dab351d4149b6ac7c0df25f7f9208">_timestep</a> );
<a name="l00435"></a>00435     }
<a name="l00436"></a>00436 }
<a name="l00437"></a>00437 
<a name="l00438"></a>00438 <span class="preprocessor">#endif</span>
<a name="l00439"></a>00439 <span class="preprocessor"></span>
<a name="l00440"></a>00440 
<a name="l00441"></a>00441 
<a name="l00442"></a>00442 <span class="preprocessor">#ifndef LIBMESH_HAVE_EXODUS_API</span>
<a name="l00443"></a>00443 <span class="preprocessor"></span>
<a name="l00444"></a><a class="code" href="classlibMesh_1_1ExodusII__IO.php#a6ae397f170c8aaebde99b273cbaeb1db">00444</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExodusII__IO.php#a6ae397f170c8aaebde99b273cbaeb1db">ExodusII_IO::write_timestep</a> (<span class="keyword">const</span> std::string&amp; ,
<a name="l00445"></a>00445                                   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; ,
<a name="l00446"></a>00446                                   <span class="keyword">const</span> <span class="keywordtype">int</span> ,
<a name="l00447"></a>00447                                   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> )
<a name="l00448"></a>00448 {
<a name="l00449"></a>00449 
<a name="l00450"></a>00450   <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt;  <span class="stringliteral">&quot;ERROR, ExodusII API is not defined.\n&quot;</span>
<a name="l00451"></a>00451                 &lt;&lt; std::endl;
<a name="l00452"></a>00452   libmesh_error();
<a name="l00453"></a>00453 }
<a name="l00454"></a>00454 
<a name="l00455"></a>00455 <span class="preprocessor">#else</span>
<a name="l00456"></a>00456 <span class="preprocessor"></span>
<a name="l00457"></a>00457 <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExodusII__IO.php#a6ae397f170c8aaebde99b273cbaeb1db">ExodusII_IO::write_timestep</a> (<span class="keyword">const</span> std::string&amp; fname,
<a name="l00458"></a>00458                                   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00459"></a>00459                                   <span class="keyword">const</span> <span class="keywordtype">int</span> timestep,
<a name="l00460"></a>00460                                   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> time)
<a name="l00461"></a>00461 {
<a name="l00462"></a>00462   <a class="code" href="classlibMesh_1_1ExodusII__IO.php#a2b9dab351d4149b6ac7c0df25f7f9208">_timestep</a>=timestep; 
<a name="l00463"></a>00463   <a class="code" href="classlibMesh_1_1MeshOutput.php#a935598198649f4b831cd341ce91b3ccb">write_equation_systems</a>(fname,es);
<a name="l00464"></a>00464 
<a name="l00465"></a>00465   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l00466"></a>00466     <a class="code" href="classlibMesh_1_1ExodusII__IO.php#af4c35286542c22438da363ed7e8bc591">exio_helper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a87f37eb3a1bc0cf5c02a247d30679bc9">write_timestep</a>(timestep, time);
<a name="l00467"></a>00467 }
<a name="l00468"></a>00468 
<a name="l00469"></a>00469 <span class="preprocessor">#endif</span>
<a name="l00470"></a>00470 <span class="preprocessor"></span>
<a name="l00471"></a>00471 
<a name="l00472"></a>00472 
<a name="l00473"></a>00473 <span class="preprocessor">#ifndef LIBMESH_HAVE_EXODUS_API</span>
<a name="l00474"></a>00474 <span class="preprocessor"></span>
<a name="l00475"></a><a class="code" href="classlibMesh_1_1ExodusII__IO.php#a4d5d6b01bd1cc3ebcbd3f80814b8b35c">00475</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExodusII__IO.php#a4d5d6b01bd1cc3ebcbd3f80814b8b35c">ExodusII_IO::write</a> (<span class="keyword">const</span> std::string&amp; )
<a name="l00476"></a>00476 {
<a name="l00477"></a>00477   <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt;  <span class="stringliteral">&quot;ERROR, ExodusII API is not defined.\n&quot;</span>
<a name="l00478"></a>00478                 &lt;&lt; std::endl;
<a name="l00479"></a>00479   libmesh_error();
<a name="l00480"></a>00480 }
<a name="l00481"></a>00481 
<a name="l00482"></a>00482 
<a name="l00483"></a>00483 <span class="preprocessor">#else</span>
<a name="l00484"></a>00484 <span class="preprocessor"></span>
<a name="l00485"></a>00485 <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExodusII__IO.php#a4d5d6b01bd1cc3ebcbd3f80814b8b35c">ExodusII_IO::write</a> (<span class="keyword">const</span> std::string&amp; fname)
<a name="l00486"></a>00486 {
<a name="l00487"></a>00487   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l00488"></a>00488     {
<a name="l00489"></a>00489       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp; mesh = <a class="code" href="classlibMesh_1_1MeshInput.php#ac18df20ac8c6a96bc404d08bae1e481b">MeshOutput&lt;MeshBase&gt;::mesh</a>();
<a name="l00490"></a>00490 
<a name="l00491"></a>00491   
<a name="l00492"></a>00492       libmesh_assert( !<a class="code" href="classlibMesh_1_1ExodusII__IO.php#af4c35286542c22438da363ed7e8bc591">exio_helper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a013eaef14de760ce2e4d736f0ebbb272">created</a>() );
<a name="l00493"></a>00493 
<a name="l00494"></a>00494       <a class="code" href="classlibMesh_1_1ExodusII__IO.php#af4c35286542c22438da363ed7e8bc591">exio_helper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a9daf17d8dc75021475d19e91ea1e3205">create</a>(fname);
<a name="l00495"></a>00495       <a class="code" href="classlibMesh_1_1ExodusII__IO.php#af4c35286542c22438da363ed7e8bc591">exio_helper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a9de09b95a7b1d3d5a56e4874bae230c9">initialize</a>(fname,mesh);
<a name="l00496"></a>00496       <a class="code" href="classlibMesh_1_1ExodusII__IO.php#af4c35286542c22438da363ed7e8bc591">exio_helper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a69566f6e18d15cb9087fdc021c857c8b">write_nodal_coordinates</a>(mesh);
<a name="l00497"></a>00497       <a class="code" href="classlibMesh_1_1ExodusII__IO.php#af4c35286542c22438da363ed7e8bc591">exio_helper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a0800a235c4e380606894be67b6062225">write_elements</a>(mesh);
<a name="l00498"></a>00498       <a class="code" href="classlibMesh_1_1ExodusII__IO.php#af4c35286542c22438da363ed7e8bc591">exio_helper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a2fd000be6f2bc33c98ad515dd036efe5">write_sidesets</a>(mesh);
<a name="l00499"></a>00499       <a class="code" href="classlibMesh_1_1ExodusII__IO.php#af4c35286542c22438da363ed7e8bc591">exio_helper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a5bffc13cca54029728ced3d8babf25b1">write_nodesets</a>(mesh);
<a name="l00500"></a>00500       <span class="comment">// Note: the file is closed automatically by the ExodusII_IO destructor.</span>
<a name="l00501"></a>00501     }
<a name="l00502"></a>00502 }
<a name="l00503"></a>00503 
<a name="l00504"></a>00504 <span class="preprocessor">#endif</span>
<a name="l00505"></a>00505 <span class="preprocessor"></span>
<a name="l00506"></a>00506 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
