<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_eaf30c8ea092d33f79a04353c3899c3f.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_27db52e6851444e0b713c4090c23f4e5.php">mesh</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">exodusII_io_helper.h</div>  </div>
</div>
<div class="contents">
<a href="exodusII__io__helper_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id$</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005 
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010 
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015 
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="preprocessor">#ifndef __exodusII_io_helper_h__</span>
<a name="l00021"></a>00021 <span class="preprocessor"></span><span class="preprocessor">#define __exodusII_io_helper_h__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>&quot;</span>
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 <span class="preprocessor">#ifdef LIBMESH_HAVE_EXODUS_API</span>
<a name="l00026"></a>00026 <span class="preprocessor"></span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &lt;iostream&gt;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &lt;string&gt;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="mesh__base_8h.php">mesh_base.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="keyword">namespace </span>libMesh
<a name="l00034"></a>00034 {
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00037"></a><a class="code" href="namespacelibMesh_1_1exII.php">00037</a> <span class="keyword">namespace </span>exII {
<a name="l00038"></a>00038   <span class="keyword">extern</span> <span class="stringliteral">&quot;C&quot;</span> {
<a name="l00039"></a>00039 <span class="preprocessor">#include &quot;exodusII.h&quot;</span> <span class="comment">// defines MAX_LINE_LENGTH, MAX_STR_LENGTH used later</span>
<a name="l00040"></a>00040   }
<a name="l00041"></a>00041 }
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 
<a name="l00050"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php">00050</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php">ExodusII_IO_Helper</a>
<a name="l00051"></a>00051 {
<a name="l00052"></a>00052 <span class="keyword">public</span>:
<a name="l00053"></a>00053 
<a name="l00059"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#ab49a53368fa3cbaeb464d200107ff210">00059</a>   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#ab49a53368fa3cbaeb464d200107ff210">ExodusII_IO_Helper</a>(<span class="keywordtype">bool</span> v=<span class="keyword">false</span>) :
<a name="l00060"></a>00060     <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a0f5eb2c6a0d73df24a4ce5881af78e3e">comp_ws</a>(sizeof(<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>)),
<a name="l00061"></a>00061     <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#ae89fbfcc501d91752083448eb1fb61db">io_ws</a>(0),
<a name="l00062"></a>00062     <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a091286ea84407aa8a4a6d8830b8e69d1">ex_id</a>(0),
<a name="l00063"></a>00063     <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a59e185c90bd5d80670856873279c0f58">ex_err</a>(0),
<a name="l00064"></a>00064     <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a61acb9bb4d7ec8cf215bce77b582395e">num_dim</a>(0),
<a name="l00065"></a>00065     <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a57d6bc333760e06a7c291ee6d5e692f8">num_globals</a>(0),
<a name="l00066"></a>00066     <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a847ee7e0854676701e1b5205bb6ed743">num_nodes</a>(0),
<a name="l00067"></a>00067     <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#af4bc089ec99edd6e62d67ed75a7d1a2a">num_elem</a>(0),
<a name="l00068"></a>00068     <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a752ec22fd9eca2dfd0b20461a6544fbc">num_elem_blk</a>(0),
<a name="l00069"></a>00069     <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a729156bcdd57603a31fb4b62ffbd37a5">num_node_sets</a>(0),
<a name="l00070"></a>00070     <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#abf7689bb0e540d2ed83d85e6f321c3c8">num_side_sets</a>(0),
<a name="l00071"></a>00071     <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a60798106904a2036379dd4988e6ceaeb">num_elem_this_blk</a>(0),
<a name="l00072"></a>00072     <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a850769b9bbd31c3825aeb967e076ba05">num_nodes_per_elem</a>(0),
<a name="l00073"></a>00073     <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#ad8f3b6956e73626540249882fb72b850">num_attr</a>(0),
<a name="l00074"></a>00074     <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#abc45b140efd492eff86f8e5b37985550">req_info</a>(0),
<a name="l00075"></a>00075     <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a71c91c6750b16720a98ab7d48ec320bc">ret_int</a>(0),
<a name="l00076"></a>00076     <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#ad7a95eb47d7c603f7f1f8d9232ccbb6a">num_elem_all_sidesets</a>(0),
<a name="l00077"></a>00077     <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a6e6a3bc8a3051c8ceb787e82d2218322">ex_version</a>(0.0),
<a name="l00078"></a>00078     <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a95a5224bfbd1971f7d98e4c0cb2ef59b">ret_float</a>(0.0),
<a name="l00079"></a>00079     <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#abc8379b7a2186efaab257e6cd905b8ea">ret_char</a>(0),
<a name="l00080"></a>00080     <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a02727aa1e0f71bcc9e20dbae243c3b9d">num_time_steps</a>(0),
<a name="l00081"></a>00081     <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#aa5fd423d103957beb37aab2a59dc5398">_created</a>(false),
<a name="l00082"></a>00082     <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a7d6450269a6f617afb432dbeaac8a2ec">_verbose</a>(v),
<a name="l00083"></a>00083     <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a227de65fc6256932ed54a0f921f339e0">_global_vars_initialized</a>(false)
<a name="l00084"></a>00084 
<a name="l00085"></a>00085   {
<a name="l00086"></a>00086     <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#aaba6c963688bcc534d5df395bd1eec22">title</a>.resize(MAX_LINE_LENGTH+1);
<a name="l00087"></a>00087     <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#afdf31751c214c456c1bb9a36516976ea">elem_type</a>.resize(MAX_STR_LENGTH);
<a name="l00088"></a>00088   }
<a name="l00089"></a>00089 
<a name="l00096"></a>00096   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a6781af765e39e49c9a244ea6628ad82d">~ExodusII_IO_Helper</a>();
<a name="l00097"></a>00097 
<a name="l00102"></a>00102   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a013eaef14de760ce2e4d736f0ebbb272">created</a>();
<a name="l00103"></a>00103 
<a name="l00107"></a>00107   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a0a486e1d944ba2dcea784255c5652499">verbose</a> (<span class="keywordtype">bool</span> set_verbosity);
<a name="l00108"></a>00108 
<a name="l00113"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#ae6e81d3697d06f48a845af405012a6f0">00113</a>   <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#ae6e81d3697d06f48a845af405012a6f0">get_num_dim</a>()<span class="keyword">                const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a61acb9bb4d7ec8cf215bce77b582395e">num_dim</a>; }
<a name="l00114"></a>00114 
<a name="l00119"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a84c5b3cdecfec687c76313f153a7cb3f">00119</a>   <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a84c5b3cdecfec687c76313f153a7cb3f">get_num_globals</a>()<span class="keyword">            const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a57d6bc333760e06a7c291ee6d5e692f8">num_globals</a>; }
<a name="l00120"></a>00120 
<a name="l00125"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a7280541fd27d1d0ecd0d9e7fbe6ef5fb">00125</a>   <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a7280541fd27d1d0ecd0d9e7fbe6ef5fb">get_num_nodes</a>()<span class="keyword">              const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a847ee7e0854676701e1b5205bb6ed743">num_nodes</a>; }
<a name="l00126"></a>00126 
<a name="l00127"></a>00127 
<a name="l00132"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#aabaf749380214fc6db08c3bcfe7a0e80">00132</a>   <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#aabaf749380214fc6db08c3bcfe7a0e80">get_num_elem</a>()<span class="keyword">               const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#af4bc089ec99edd6e62d67ed75a7d1a2a">num_elem</a>; }
<a name="l00133"></a>00133 
<a name="l00139"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a5baa687c81b853f37bcec2f833d2f195">00139</a>   <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a5baa687c81b853f37bcec2f833d2f195">get_num_elem_blk</a>()<span class="keyword">           const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a752ec22fd9eca2dfd0b20461a6544fbc">num_elem_blk</a>; }
<a name="l00140"></a>00140 
<a name="l00146"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#aaa7c4fca84a868ebb8ad9b4ee3e395db">00146</a>   <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#aaa7c4fca84a868ebb8ad9b4ee3e395db">get_num_elem_this_blk</a>()<span class="keyword">      const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a60798106904a2036379dd4988e6ceaeb">num_elem_this_blk</a>; }
<a name="l00147"></a>00147 
<a name="l00154"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a6da9a02553b9f9edb530b70471da077f">00154</a>   <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a6da9a02553b9f9edb530b70471da077f">get_num_nodes_per_elem</a>()<span class="keyword">     const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a850769b9bbd31c3825aeb967e076ba05">num_nodes_per_elem</a>; }
<a name="l00155"></a>00155 
<a name="l00162"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a19f54aefc1d97e84171e9abcb7b5c85d">00162</a>   <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a19f54aefc1d97e84171e9abcb7b5c85d">get_num_side_sets</a>()<span class="keyword">          const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#abf7689bb0e540d2ed83d85e6f321c3c8">num_side_sets</a>; }
<a name="l00163"></a>00163 
<a name="l00169"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a452f165e7cfe0627066e68cdc132527f">00169</a>   <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a452f165e7cfe0627066e68cdc132527f">get_num_node_sets</a>()<span class="keyword">          const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a729156bcdd57603a31fb4b62ffbd37a5">num_node_sets</a>; }
<a name="l00170"></a>00170 
<a name="l00171"></a>00171   <span class="comment">//     /**</span>
<a name="l00172"></a>00172   <span class="comment">//      * @returns the number of</span>
<a name="l00173"></a>00173   <span class="comment">//      * elements in all the sidesets.</span>
<a name="l00174"></a>00174   <span class="comment">//      * Effectively returns the</span>
<a name="l00175"></a>00175   <span class="comment">//      * total number of elements</span>
<a name="l00176"></a>00176   <span class="comment">//      * on the \p ExodusII mesh boundary.</span>
<a name="l00177"></a>00177   <span class="comment">//      */</span>
<a name="l00178"></a>00178   <span class="comment">//     int get_num_elem_all_sidesets()  const { return num_elem_all_sidesets; }</span>
<a name="l00179"></a>00179 
<a name="l00186"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a4df6a901221fd3e98938f78240d90ed1">00186</a>   <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a4df6a901221fd3e98938f78240d90ed1">get_connect</a>(<span class="keywordtype">int</span> i)<span class="keyword">           const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#ac0708202a0c25af8a4d04253f6bae84e">connect</a>[i]; }
<a name="l00187"></a>00187 
<a name="l00193"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a4edc84431dc0c83e9991eb66453685f2">00193</a>   <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a4edc84431dc0c83e9991eb66453685f2">get_num_sides_per_set</a>(<span class="keywordtype">int</span> i)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#aa1b6ac3ca42a05e4f577c8dc24faf68c">num_sides_per_set</a>[i]; }
<a name="l00194"></a>00194 
<a name="l00200"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a29d80c65faee384fac4f7b8b913fbdc5">00200</a>   <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a29d80c65faee384fac4f7b8b913fbdc5">get_num_nodes_per_set</a>(<span class="keywordtype">int</span> i)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a4dbc53fc232766876c94fe90a67b57b0">num_nodes_per_set</a>[i]; }
<a name="l00201"></a>00201 
<a name="l00202"></a>00202   <span class="comment">//     /**</span>
<a name="l00203"></a>00203   <span class="comment">//      * @returns the \f$ i^{th} \f$ entry</span>
<a name="l00204"></a>00204   <span class="comment">//      * in the element list.</span>
<a name="l00205"></a>00205   <span class="comment">//      * The element list contains</span>
<a name="l00206"></a>00206   <span class="comment">//      * the numbers of all elements</span>
<a name="l00207"></a>00207   <span class="comment">//      * on the boundary.</span>
<a name="l00208"></a>00208   <span class="comment">//      */</span>
<a name="l00209"></a>00209   <span class="comment">//     int get_elem_list(int i)         const { return elem_list[i]; }</span>
<a name="l00210"></a>00210 
<a name="l00214"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a2791be975940e6c397e468611d6e8798">00214</a>   <span class="keyword">const</span> std::vector&lt;int&gt;&amp; <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a2791be975940e6c397e468611d6e8798">get_elem_list</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a9c4902c6322244be6b70f927c01a6889">elem_list</a>; }
<a name="l00215"></a>00215 
<a name="l00216"></a>00216   <span class="comment">//     /**</span>
<a name="l00217"></a>00217   <span class="comment">//      * @returns the \f$ i^{th} \f$ entry in</span>
<a name="l00218"></a>00218   <span class="comment">//      * the side list.  This is</span>
<a name="l00219"></a>00219   <span class="comment">//      * effectively the &quot;side&quot;</span>
<a name="l00220"></a>00220   <span class="comment">//      * (face in 3D or edge in</span>
<a name="l00221"></a>00221   <span class="comment">//      * 2D) number which lies</span>
<a name="l00222"></a>00222   <span class="comment">//      * on the boundary.</span>
<a name="l00223"></a>00223   <span class="comment">//      */</span>
<a name="l00224"></a>00224   <span class="comment">//     int get_side_list(int i)         const { return side_list[i]; }</span>
<a name="l00225"></a>00225 
<a name="l00229"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a60e82239f40a0e79335a925f6dd5f682">00229</a>   <span class="keyword">const</span> std::vector&lt;int&gt;&amp; <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a60e82239f40a0e79335a925f6dd5f682">get_side_list</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a625fe16b1b44f7eba2cd3f792a396dba">side_list</a>; }
<a name="l00230"></a>00230 
<a name="l00234"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a3cbb6a733154af7d6e5a79f44f1ee506">00234</a>   <span class="keyword">const</span> std::vector&lt;int&gt;&amp; <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a3cbb6a733154af7d6e5a79f44f1ee506">get_node_list</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a74e1c63a8f69ef3d248e0b2f500e8c0e">node_list</a>; }
<a name="l00235"></a>00235 
<a name="l00239"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#ad294983ff602b7e2d4668a58b3b7704c">00239</a>   <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#ad294983ff602b7e2d4668a58b3b7704c">get_nodeset_id</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#acc3c2cf0e56ebc7d49fcc0ee378cec21">nodeset_ids</a>[i]; }
<a name="l00240"></a>00240 
<a name="l00241"></a>00241   <span class="comment">//     /**</span>
<a name="l00242"></a>00242   <span class="comment">//      * @returns the \f$ i^{th} \f$ entry in</span>
<a name="l00243"></a>00243   <span class="comment">//      * the id list.  This is the id</span>
<a name="l00244"></a>00244   <span class="comment">//      * for the ith face on the boundary.</span>
<a name="l00245"></a>00245   <span class="comment">//      */</span>
<a name="l00246"></a>00246   <span class="comment">//     int get_id_list(int i)         const { return id_list[i]; }</span>
<a name="l00247"></a>00247 
<a name="l00251"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a32ab0ea73058f9a343c14ce6e1eb65a4">00251</a>   <span class="keyword">const</span> std::vector&lt;int&gt;&amp; <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a32ab0ea73058f9a343c14ce6e1eb65a4">get_id_list</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a599636589599e2135c964485cecbe9d7">id_list</a>; }
<a name="l00252"></a>00252 
<a name="l00261"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a1346e40c076822fad7292898dc8a5a80">00261</a>   <span class="keyword">const</span> <span class="keywordtype">char</span>* <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a1346e40c076822fad7292898dc8a5a80">get_elem_type</a>()<span class="keyword">            const </span>{ <span class="keywordflow">return</span> &amp;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#afdf31751c214c456c1bb9a36516976ea">elem_type</a>[0]; }
<a name="l00262"></a>00262 
<a name="l00267"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a417aaa97299b4bd266897885972bc1d1">00267</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a417aaa97299b4bd266897885972bc1d1">get_x</a>(<span class="keywordtype">int</span> i)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a34773dcda6a41b34e67fce165454c530">x</a>[i]; }
<a name="l00268"></a>00268 
<a name="l00273"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a133f0ec35710b694aa1d279e2e566f31">00273</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a133f0ec35710b694aa1d279e2e566f31">get_y</a>(<span class="keywordtype">int</span> i)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a9c91b82c014b865a677fd4dea029f1d9">y</a>[i]; }
<a name="l00274"></a>00274 
<a name="l00279"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a06debfd48c4ba7f0f0d87fc29e578b8f">00279</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a06debfd48c4ba7f0f0d87fc29e578b8f">get_z</a>(<span class="keywordtype">int</span> i)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a6537a7456410505c56fd3549eb98fc07">z</a>[i]; }
<a name="l00280"></a>00280 
<a name="l00286"></a>00286   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a9bf6deacca92641b0d30d7749a06b887">open</a>(<span class="keyword">const</span> <span class="keywordtype">char</span>* filename);
<a name="l00287"></a>00287 
<a name="l00292"></a>00292   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#ad33f14d5154d71c0bf8339e44b801997">read_header</a>();
<a name="l00293"></a>00293 
<a name="l00304"></a>00304   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#aa57b23eb3af94898729cb25919b3123c">print_header</a>();
<a name="l00305"></a>00305 
<a name="l00312"></a>00312   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a6442ae2187f05185649d88efef41c000">read_nodes</a>();
<a name="l00313"></a>00313 
<a name="l00318"></a>00318   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a18cb4af65d380ec6197cceca28f755ab">read_node_num_map</a>();
<a name="l00319"></a>00319 
<a name="l00324"></a>00324   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a955739a996cd5816d38417393b8118b0">print_nodes</a>(std::ostream &amp;<a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">out</a> = <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a>);
<a name="l00325"></a>00325 
<a name="l00331"></a>00331   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a025711d210123880b8cdac91184ab45b">read_block_info</a>();
<a name="l00332"></a>00332 
<a name="l00337"></a>00337   <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a5add1e7f7ce8f31ab39b9c5a429771f4">get_block_id</a>(<span class="keywordtype">int</span> block);
<a name="l00338"></a>00338 
<a name="l00345"></a>00345   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#afc3acc1e28f081a9f8a3c3a160715387">read_elem_in_block</a>(<span class="keywordtype">int</span> block);
<a name="l00346"></a>00346 
<a name="l00351"></a>00351   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#ade4a8af03ed43f731bd6d3974bceee65">read_elem_num_map</a>();
<a name="l00352"></a>00352 
<a name="l00358"></a>00358   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a9374fbb748e06b3fcdd5ca6a25bc1cd7">read_sideset_info</a>();
<a name="l00359"></a>00359 
<a name="l00365"></a>00365   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a08200f195605daac61ad8d56a29ec435">read_nodeset_info</a>();
<a name="l00366"></a>00366 
<a name="l00374"></a>00374   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a7e8af82fdd1f4fed93190bfa0c0fb2cb">read_sideset</a>(<span class="keywordtype">int</span> <span class="keywordtype">id</span>, <span class="keywordtype">int</span> offset);
<a name="l00375"></a>00375 
<a name="l00383"></a>00383   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#af6f691a32892f4eb9377dba60fe26b31">read_nodeset</a>(<span class="keywordtype">int</span> <span class="keywordtype">id</span>);
<a name="l00384"></a>00384 
<a name="l00389"></a>00389   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#adc9062c1a713d7c16ceef1f52536f800">print_sideset_info</a>();
<a name="l00390"></a>00390 
<a name="l00395"></a>00395   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a6ada30962b883b9ced3ef5056cdabd56">print_nodeset_info</a>();
<a name="l00396"></a>00396 
<a name="l00401"></a>00401   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#ac6fdd71b06584b8fb6d1e0fe3e271964">close</a>();
<a name="l00402"></a>00402 
<a name="l00406"></a>00406   <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#ac04c6c50813ae9630e7270f930e50b8d">inquire</a>(<span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#abc45b140efd492eff86f8e5b37985550">req_info</a>, std::string error_msg=<span class="stringliteral">&quot;&quot;</span>);
<a name="l00407"></a>00407 
<a name="l00408"></a>00408 
<a name="l00409"></a>00409   <span class="comment">// For reading solutions:</span>
<a name="l00410"></a>00410   <span class="comment">/*</span>
<a name="l00411"></a>00411 <span class="comment">   * Returns an array containing the timesteps in the file</span>
<a name="l00412"></a>00412 <span class="comment">   */</span>
<a name="l00413"></a>00413   <span class="keyword">const</span> std::vector&lt;Real&gt;&amp; <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#abad269308f48bf51afc8dc8b3423e117">get_time_steps</a>();
<a name="l00414"></a>00414 
<a name="l00415"></a>00415 
<a name="l00416"></a>00416   <span class="comment">/*</span>
<a name="l00417"></a>00417 <span class="comment">   * Number of Nodal variables defined.</span>
<a name="l00418"></a>00418 <span class="comment">   */</span>
<a name="l00419"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#aad916cf2c9805f1284c84933b65dd48d">00419</a>   <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#aad916cf2c9805f1284c84933b65dd48d">get_num_nodal_vars</a>(){ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a778e11c94ca5764c5c408fef4a0b37bc">num_nodal_vars</a>; }
<a name="l00420"></a>00420 
<a name="l00421"></a>00421 
<a name="l00422"></a>00422   <span class="comment">/*</span>
<a name="l00423"></a>00423 <span class="comment">   * Returns an array containing the nodal var names in the file</span>
<a name="l00424"></a>00424 <span class="comment">   */</span>
<a name="l00425"></a>00425   <span class="keyword">const</span> std::vector&lt;std::string&gt;&amp; <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a1872d25cd6269d0ef71703cf30203d26">get_nodal_var_names</a>();
<a name="l00426"></a>00426 
<a name="l00427"></a>00427   <span class="comment">/*</span>
<a name="l00428"></a>00428 <span class="comment">   * Returns an array containing the nodal variable values</span>
<a name="l00429"></a>00429 <span class="comment">   * at the specified time</span>
<a name="l00430"></a>00430 <span class="comment">   */</span>
<a name="l00431"></a>00431   <span class="keyword">const</span> std::vector&lt;Real&gt;&amp; <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a2c1ad57fbda25ca8b03a89e3f256a79e">get_nodal_var_values</a>(std::string nodal_var_name, <span class="keywordtype">int</span> time_step);
<a name="l00432"></a>00432 
<a name="l00433"></a>00433   <span class="comment">// For Writing Solutions</span>
<a name="l00439"></a>00439 <span class="comment"></span>  <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a9daf17d8dc75021475d19e91ea1e3205">create</a>(std::string filename);
<a name="l00440"></a>00440 
<a name="l00444"></a>00444   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a9de09b95a7b1d3d5a56e4874bae230c9">initialize</a>(std::string <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#aaba6c963688bcc534d5df395bd1eec22">title</a>, <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>);
<a name="l00445"></a>00445 
<a name="l00449"></a>00449   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#ac3f01f52d7f36235a10ce8300f3ea186">initialize_discontinuous</a>(std::string <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#aaba6c963688bcc534d5df395bd1eec22">title</a>, <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>);
<a name="l00450"></a>00450 
<a name="l00454"></a>00454   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a69566f6e18d15cb9087fdc021c857c8b">write_nodal_coordinates</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>);
<a name="l00455"></a>00455 
<a name="l00459"></a>00459   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a3fda115cb6c8778c275f030da81d91f2">write_nodal_coordinates_discontinuous</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>);
<a name="l00460"></a>00460 
<a name="l00465"></a>00465   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a0800a235c4e380606894be67b6062225">write_elements</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>);
<a name="l00466"></a>00466 
<a name="l00471"></a>00471   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#af75f1991e197a050f46a6566876c3314">write_elements_discontinuous</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>);
<a name="l00472"></a>00472 
<a name="l00476"></a>00476   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a2fd000be6f2bc33c98ad515dd036efe5">write_sidesets</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>);
<a name="l00477"></a>00477 
<a name="l00481"></a>00481   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a5bffc13cca54029728ced3d8babf25b1">write_nodesets</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>);
<a name="l00482"></a>00482 
<a name="l00486"></a>00486   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#ae540e94c31f69447563279a75d8b8317">initialize_nodal_variables</a>(std::vector&lt;std::string&gt; names);
<a name="l00487"></a>00487 
<a name="l00491"></a>00491   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#aa43aa8a1c29b79464d0331b79425ea19">initialize_global_variables</a>(<span class="keyword">const</span> std::vector&lt;std::string&gt; &amp; names);
<a name="l00492"></a>00492 
<a name="l00496"></a>00496   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a87f37eb3a1bc0cf5c02a247d30679bc9">write_timestep</a>(<span class="keywordtype">int</span> timestep, <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> time);
<a name="l00497"></a>00497 
<a name="l00501"></a>00501   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#ae98bb0ac93b4292635959132b392d0aa">write_nodal_values</a>(<span class="keywordtype">int</span> var_id, <span class="keyword">const</span> std::vector&lt;Number&gt; &amp; values, <span class="keywordtype">int</span> timestep);
<a name="l00502"></a>00502 
<a name="l00506"></a>00506   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a8d1e85361d6581469bc43851d9924af0">write_global_values</a>(<span class="keyword">const</span> std::vector&lt;Number&gt; &amp; values, <span class="keywordtype">int</span> timestep);
<a name="l00507"></a>00507 
<a name="l00508"></a>00508 
<a name="l00509"></a>00509 
<a name="l00515"></a>00515   <span class="keyword">class </span>Conversion;
<a name="l00516"></a>00516 
<a name="l00523"></a>00523   <span class="keyword">class </span>ElementMaps;
<a name="l00524"></a>00524 
<a name="l00525"></a>00525 
<a name="l00526"></a>00526   <span class="comment">//private:</span>
<a name="l00527"></a>00527 
<a name="l00528"></a>00528 
<a name="l00539"></a>00539   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a5b784662aee4bd1604ef57edf4cf3f70">check_err</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> error, <span class="keyword">const</span> std::string msg);
<a name="l00540"></a>00540 
<a name="l00546"></a>00546   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a35910b940780b757912d8a890a6fcb38">message</a>(<span class="keyword">const</span> std::string msg);
<a name="l00547"></a>00547 
<a name="l00557"></a>00557   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a35910b940780b757912d8a890a6fcb38">message</a>(<span class="keyword">const</span> std::string msg, <span class="keywordtype">int</span> i);
<a name="l00558"></a>00558 
<a name="l00559"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a0f5eb2c6a0d73df24a4ce5881af78e3e">00559</a>   <span class="keywordtype">int</span>   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a0f5eb2c6a0d73df24a4ce5881af78e3e">comp_ws</a>;                       <span class="comment">// ?</span>
<a name="l00560"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#ae89fbfcc501d91752083448eb1fb61db">00560</a>   <span class="keywordtype">int</span>   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#ae89fbfcc501d91752083448eb1fb61db">io_ws</a>;                         <span class="comment">// ?</span>
<a name="l00561"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a091286ea84407aa8a4a6d8830b8e69d1">00561</a>   <span class="keywordtype">int</span>   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a091286ea84407aa8a4a6d8830b8e69d1">ex_id</a>;                         <span class="comment">// File identification flag</span>
<a name="l00562"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a59e185c90bd5d80670856873279c0f58">00562</a>   <span class="keywordtype">int</span>   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a59e185c90bd5d80670856873279c0f58">ex_err</a>;                        <span class="comment">// General error flag</span>
<a name="l00563"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a61acb9bb4d7ec8cf215bce77b582395e">00563</a>   <span class="keywordtype">int</span>   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a61acb9bb4d7ec8cf215bce77b582395e">num_dim</a>;                       <span class="comment">// Number of dimensions in the mesh</span>
<a name="l00564"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a57d6bc333760e06a7c291ee6d5e692f8">00564</a>   <span class="keywordtype">int</span>   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a57d6bc333760e06a7c291ee6d5e692f8">num_globals</a>;                   <span class="comment">// Number of global variables</span>
<a name="l00565"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a847ee7e0854676701e1b5205bb6ed743">00565</a>   <span class="keywordtype">int</span>   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a847ee7e0854676701e1b5205bb6ed743">num_nodes</a>;                     <span class="comment">// Total number of nodes in the mesh</span>
<a name="l00566"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#af4bc089ec99edd6e62d67ed75a7d1a2a">00566</a>   <span class="keywordtype">int</span>   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#af4bc089ec99edd6e62d67ed75a7d1a2a">num_elem</a>;                      <span class="comment">// Total number of elements in the mesh</span>
<a name="l00567"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a752ec22fd9eca2dfd0b20461a6544fbc">00567</a>   <span class="keywordtype">int</span>   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a752ec22fd9eca2dfd0b20461a6544fbc">num_elem_blk</a>;                  <span class="comment">// Total number of element blocks</span>
<a name="l00568"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a729156bcdd57603a31fb4b62ffbd37a5">00568</a>   <span class="keywordtype">int</span>   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a729156bcdd57603a31fb4b62ffbd37a5">num_node_sets</a>;                 <span class="comment">// Total number of node sets</span>
<a name="l00569"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#abf7689bb0e540d2ed83d85e6f321c3c8">00569</a>   <span class="keywordtype">int</span>   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#abf7689bb0e540d2ed83d85e6f321c3c8">num_side_sets</a>;                 <span class="comment">// Total number of element sets</span>
<a name="l00570"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a60798106904a2036379dd4988e6ceaeb">00570</a>   <span class="keywordtype">int</span>   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a60798106904a2036379dd4988e6ceaeb">num_elem_this_blk</a>;             <span class="comment">// Number of elements in this block</span>
<a name="l00571"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a850769b9bbd31c3825aeb967e076ba05">00571</a>   <span class="keywordtype">int</span>   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a850769b9bbd31c3825aeb967e076ba05">num_nodes_per_elem</a>;            <span class="comment">// Number of nodes in each element</span>
<a name="l00572"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#ad8f3b6956e73626540249882fb72b850">00572</a>   <span class="keywordtype">int</span>   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#ad8f3b6956e73626540249882fb72b850">num_attr</a>;                      <span class="comment">// Number of attributes for a given block</span>
<a name="l00573"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#abc45b140efd492eff86f8e5b37985550">00573</a>   <span class="keywordtype">int</span>   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#abc45b140efd492eff86f8e5b37985550">req_info</a>;                      <span class="comment">// Generic required info tag</span>
<a name="l00574"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a71c91c6750b16720a98ab7d48ec320bc">00574</a>   <span class="keywordtype">int</span>   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a71c91c6750b16720a98ab7d48ec320bc">ret_int</a>;                       <span class="comment">// Generic int returned by ex_inquire</span>
<a name="l00575"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#ad7a95eb47d7c603f7f1f8d9232ccbb6a">00575</a>   <span class="keywordtype">int</span>   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#ad7a95eb47d7c603f7f1f8d9232ccbb6a">num_elem_all_sidesets</a>;         <span class="comment">// Total number of elements in all side sets</span>
<a name="l00576"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#aba97767bd5bd1dfa25037f41d751e8d1">00576</a>   std::vector&lt;int&gt; <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#aba97767bd5bd1dfa25037f41d751e8d1">block_ids</a>;          <span class="comment">// Vector of the block identification numbers</span>
<a name="l00577"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#ac0708202a0c25af8a4d04253f6bae84e">00577</a>   std::vector&lt;int&gt; <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#ac0708202a0c25af8a4d04253f6bae84e">connect</a>;            <span class="comment">// Vector of nodes in an element</span>
<a name="l00578"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a5876356b1fe37790c999d69b5fc1fe54">00578</a>   std::vector&lt;int&gt; <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a5876356b1fe37790c999d69b5fc1fe54">ss_ids</a>;             <span class="comment">// Vector of the sideset IDs</span>
<a name="l00579"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#acc3c2cf0e56ebc7d49fcc0ee378cec21">00579</a>   std::vector&lt;int&gt; <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#acc3c2cf0e56ebc7d49fcc0ee378cec21">nodeset_ids</a>;        <span class="comment">// Vector of the nodeset IDs</span>
<a name="l00580"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#aa1b6ac3ca42a05e4f577c8dc24faf68c">00580</a>   std::vector&lt;int&gt; <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#aa1b6ac3ca42a05e4f577c8dc24faf68c">num_sides_per_set</a>;  <span class="comment">// Number of sides (edges/faces) in current set</span>
<a name="l00581"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a4dbc53fc232766876c94fe90a67b57b0">00581</a>   std::vector&lt;int&gt; <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a4dbc53fc232766876c94fe90a67b57b0">num_nodes_per_set</a>;  <span class="comment">// Number of nodes in current set</span>
<a name="l00582"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a211df8d73a9b57399c61bdd1d778a26d">00582</a>   std::vector&lt;int&gt; <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a211df8d73a9b57399c61bdd1d778a26d">num_df_per_set</a>;     <span class="comment">// Number of distribution factors per set</span>
<a name="l00583"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#aec30d2229aa8b7cde4163054b86cda2c">00583</a>   std::vector&lt;int&gt; <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#aec30d2229aa8b7cde4163054b86cda2c">num_node_df_per_set</a>;<span class="comment">// Number of distribution factors per set</span>
<a name="l00584"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a9c4902c6322244be6b70f927c01a6889">00584</a>   std::vector&lt;int&gt; <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a9c4902c6322244be6b70f927c01a6889">elem_list</a>;          <span class="comment">// List of element numbers in all sidesets</span>
<a name="l00585"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a625fe16b1b44f7eba2cd3f792a396dba">00585</a>   std::vector&lt;int&gt; <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a625fe16b1b44f7eba2cd3f792a396dba">side_list</a>;          <span class="comment">// Side (face/edge) number actually on the boundary</span>
<a name="l00586"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a74e1c63a8f69ef3d248e0b2f500e8c0e">00586</a>   std::vector&lt;int&gt; <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a74e1c63a8f69ef3d248e0b2f500e8c0e">node_list</a>;          <span class="comment">// Node number actually on the boundary</span>
<a name="l00587"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a599636589599e2135c964485cecbe9d7">00587</a>   std::vector&lt;int&gt; <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a599636589599e2135c964485cecbe9d7">id_list</a>;            <span class="comment">// Side (face/edge) id number</span>
<a name="l00588"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a6e11f33dc102e99b12ed8ea9ac677231">00588</a>   std::vector&lt;int&gt; <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a6e11f33dc102e99b12ed8ea9ac677231">node_num_map</a>;       <span class="comment">// Optional mapping from internal [0,num_nodes) to arbitrary indices</span>
<a name="l00589"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#afd686e5e7464c8d5c0fe424c9456d572">00589</a>   std::vector&lt;int&gt; <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#afd686e5e7464c8d5c0fe424c9456d572">elem_num_map</a>;       <span class="comment">// Optional mapping from internal [0,num_elem) to arbitrary indices</span>
<a name="l00590"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a6e6a3bc8a3051c8ceb787e82d2218322">00590</a>   <span class="keywordtype">float</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a6e6a3bc8a3051c8ceb787e82d2218322">ex_version</a>;                    <span class="comment">// Version of Exodus you are using</span>
<a name="l00591"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a95a5224bfbd1971f7d98e4c0cb2ef59b">00591</a>   <span class="keywordtype">float</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a95a5224bfbd1971f7d98e4c0cb2ef59b">ret_float</a>;                     <span class="comment">// Generic float returned by ex_inquire</span>
<a name="l00592"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a34773dcda6a41b34e67fce165454c530">00592</a>   std::vector&lt;Real&gt; <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a34773dcda6a41b34e67fce165454c530">x</a>;                 <span class="comment">// x locations of node points</span>
<a name="l00593"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a9c91b82c014b865a677fd4dea029f1d9">00593</a>   std::vector&lt;Real&gt; <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a9c91b82c014b865a677fd4dea029f1d9">y</a>;                 <span class="comment">// y locations of node points</span>
<a name="l00594"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a6537a7456410505c56fd3549eb98fc07">00594</a>   std::vector&lt;Real&gt; <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a6537a7456410505c56fd3549eb98fc07">z</a>;                 <span class="comment">// z locations of node points</span>
<a name="l00595"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#abc8379b7a2186efaab257e6cd905b8ea">00595</a>   <span class="keywordtype">char</span>    <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#abc8379b7a2186efaab257e6cd905b8ea">ret_char</a>;                    <span class="comment">// Generic char returned by ex_inquire</span>
<a name="l00596"></a>00596   <span class="comment">// Use vectors of char to emulate char*&#39;s</span>
<a name="l00597"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#aaba6c963688bcc534d5df395bd1eec22">00597</a>   std::vector&lt;char&gt; <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#aaba6c963688bcc534d5df395bd1eec22">title</a>;             <span class="comment">//  Problem title</span>
<a name="l00598"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#afdf31751c214c456c1bb9a36516976ea">00598</a>   std::vector&lt;char&gt; <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#afdf31751c214c456c1bb9a36516976ea">elem_type</a>;         <span class="comment">// Type of element in a given block</span>
<a name="l00599"></a>00599 
<a name="l00600"></a>00600   <span class="comment">// Maps libMesh element numbers to Exodus element numbers</span>
<a name="l00601"></a>00601   <span class="comment">// gets filled in when write_elements gets called</span>
<a name="l00602"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a422a3541894dcbd8b4f75a122706c661">00602</a>   std::map&lt;int, int&gt; <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a422a3541894dcbd8b4f75a122706c661">libmesh_elem_num_to_exodus</a>;
<a name="l00603"></a>00603 
<a name="l00604"></a>00604   <span class="comment">//Solution Data</span>
<a name="l00605"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a02727aa1e0f71bcc9e20dbae243c3b9d">00605</a>   <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a02727aa1e0f71bcc9e20dbae243c3b9d">num_time_steps</a>;
<a name="l00606"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#aaf218d72fe1d485ef9eebab6e9ae32b0">00606</a>   std::vector&lt;Real&gt; <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#aaf218d72fe1d485ef9eebab6e9ae32b0">time_steps</a>;
<a name="l00607"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a778e11c94ca5764c5c408fef4a0b37bc">00607</a>   <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a778e11c94ca5764c5c408fef4a0b37bc">num_nodal_vars</a>;
<a name="l00608"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a1ee8ea05ec89e89547c83f8005578ed1">00608</a>   std::vector&lt;std::string&gt; <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a1ee8ea05ec89e89547c83f8005578ed1">nodal_var_names</a>;
<a name="l00609"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a0e41e15161c7a8dbf23a84cd792fa4af">00609</a>   std::vector&lt;Real&gt; <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a0e41e15161c7a8dbf23a84cd792fa4af">nodal_var_values</a>;
<a name="l00610"></a>00610 
<a name="l00611"></a>00611   <span class="comment">// A pair of containers used to emulate a char** data</span>
<a name="l00612"></a>00612   <span class="comment">// structure without having to worry about dynamic memory</span>
<a name="l00613"></a>00613   <span class="comment">// allocation ourselves.</span>
<a name="l00614"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#aba600ee1f6cca59ec1ac632f798e6fe6">00614</a>   std::vector&lt;std::vector&lt;char&gt; &gt; <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#aba600ee1f6cca59ec1ac632f798e6fe6">vvc</a>;
<a name="l00615"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a3a168461e6fc6898f8ad0c5e74da249e">00615</a>   std::vector&lt;char*&gt; <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a3a168461e6fc6898f8ad0c5e74da249e">strings</a>; <span class="comment">// vector of pointers into vvc</span>
<a name="l00616"></a>00616 
<a name="l00617"></a>00617  <span class="keyword">protected</span>:
<a name="l00618"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#aa5fd423d103957beb37aab2a59dc5398">00618</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#aa5fd423d103957beb37aab2a59dc5398">_created</a>; <span class="comment">// This flag gets set after the the create() function has been successfully called.</span>
<a name="l00619"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a7d6450269a6f617afb432dbeaac8a2ec">00619</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a7d6450269a6f617afb432dbeaac8a2ec">_verbose</a>; <span class="comment">// On/Off message flag</span>
<a name="l00620"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a227de65fc6256932ed54a0f921f339e0">00620</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a227de65fc6256932ed54a0f921f339e0">_global_vars_initialized</a>; <span class="comment">// True once the global vars are initialized</span>
<a name="l00621"></a>00621 };
<a name="l00622"></a>00622 
<a name="l00623"></a>00623 
<a name="l00624"></a>00624 
<a name="l00625"></a>00625 
<a name="l00626"></a>00626 
<a name="l00627"></a>00627 
<a name="l00628"></a>00628 
<a name="l00629"></a>00629 
<a name="l00630"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1Conversion.php">00630</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1Conversion.php">ExodusII_IO_Helper::Conversion</a>
<a name="l00631"></a>00631 {
<a name="l00632"></a>00632 <span class="keyword">public</span>:
<a name="l00633"></a>00633 
<a name="l00638"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1Conversion.php#a06e298e75f79fe5f1fc0dd8ecbc8247e">00638</a>   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1Conversion.php#a06e298e75f79fe5f1fc0dd8ecbc8247e">Conversion</a>(<span class="keyword">const</span> <span class="keywordtype">int</span>* nm, <span class="keyword">const</span> <span class="keywordtype">int</span>* sm, <span class="keyword">const</span> <span class="keywordtype">int</span>* ism, <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> ct, std::string ex_type)
<a name="l00639"></a>00639     : <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1Conversion.php#a2c88b81b53da313b4800d0d2fae70a4b">node_map</a>(nm),       <span class="comment">// Node map for this element</span>
<a name="l00640"></a>00640       <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1Conversion.php#a9c2db0b275f77563dc6ef0fb904b4c23">side_map</a>(sm),
<a name="l00641"></a>00641       <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1Conversion.php#ac6dfe28051f078c67e021b138c8a3ba3">inverse_side_map</a>(ism),
<a name="l00642"></a>00642       <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1Conversion.php#aff2c456db47eb9beaada459ffaf90014">canonical_type</a>(ct),    <span class="comment">// Element type name in this code</span>
<a name="l00643"></a>00643       <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1Conversion.php#a5aeda66b0b4fa1eb3f9014b4a5c4b6c2">exodus_type</a>(ex_type)   <span class="comment">// Element type in Exodus</span>
<a name="l00644"></a>00644   {}
<a name="l00645"></a>00645 
<a name="l00651"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1Conversion.php#a84ae7256b57510e53b3d087cfc3fe0ca">00651</a>   <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1Conversion.php#a84ae7256b57510e53b3d087cfc3fe0ca">get_node_map</a>(<span class="keywordtype">int</span> i)<span class="keyword">          const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1Conversion.php#a2c88b81b53da313b4800d0d2fae70a4b">node_map</a>[i]; }
<a name="l00652"></a>00652 
<a name="l00658"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1Conversion.php#a476e2be06fd2a76407446400e112ec10">00658</a>   <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1Conversion.php#a476e2be06fd2a76407446400e112ec10">get_side_map</a>(<span class="keywordtype">int</span> i)<span class="keyword">          const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1Conversion.php#a9c2db0b275f77563dc6ef0fb904b4c23">side_map</a>[i]; }
<a name="l00659"></a>00659 
<a name="l00665"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1Conversion.php#abc8000784296b47f55b91a33e90ad1c6">00665</a>   <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1Conversion.php#abc8000784296b47f55b91a33e90ad1c6">get_inverse_side_map</a>(<span class="keywordtype">int</span> i)<span class="keyword">          const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1Conversion.php#ac6dfe28051f078c67e021b138c8a3ba3">inverse_side_map</a>[i]; }
<a name="l00666"></a>00666 
<a name="l00672"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1Conversion.php#a5ca4c8800befbbd785efaf269e668e94">00672</a>   <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1Conversion.php#a5ca4c8800befbbd785efaf269e668e94">get_canonical_type</a>()<span class="keyword">    const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1Conversion.php#aff2c456db47eb9beaada459ffaf90014">canonical_type</a>; }
<a name="l00673"></a>00673 
<a name="l00677"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1Conversion.php#a2c88b81b53da313b4800d0d2fae70a4b">00677</a>   std::string <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1Conversion.php#ad47542ad6ffc52d42d9d489531548072">exodus_elem_type</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1Conversion.php#a5aeda66b0b4fa1eb3f9014b4a5c4b6c2">exodus_type</a>; };
<a name="l00678"></a>00678 
<a name="l00679"></a>00679 
<a name="l00680"></a>00680 <span class="keyword">private</span>:
<a name="l00684"></a>00684   <span class="keyword">const</span> <span class="keywordtype">int</span>* <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1Conversion.php#a2c88b81b53da313b4800d0d2fae70a4b">node_map</a>;
<a name="l00685"></a>00685 
<a name="l00689"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1Conversion.php#a9c2db0b275f77563dc6ef0fb904b4c23">00689</a>   <span class="keyword">const</span> <span class="keywordtype">int</span>* <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1Conversion.php#a9c2db0b275f77563dc6ef0fb904b4c23">side_map</a>;
<a name="l00690"></a>00690 
<a name="l00694"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1Conversion.php#ac6dfe28051f078c67e021b138c8a3ba3">00694</a>   <span class="keyword">const</span> <span class="keywordtype">int</span>* <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1Conversion.php#ac6dfe28051f078c67e021b138c8a3ba3">inverse_side_map</a>;
<a name="l00695"></a>00695 
<a name="l00700"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1Conversion.php#aff2c456db47eb9beaada459ffaf90014">00700</a>   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1Conversion.php#aff2c456db47eb9beaada459ffaf90014">canonical_type</a>;
<a name="l00701"></a>00701 
<a name="l00705"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1Conversion.php#a5aeda66b0b4fa1eb3f9014b4a5c4b6c2">00705</a>   <span class="keyword">const</span> std::string <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1Conversion.php#a5aeda66b0b4fa1eb3f9014b4a5c4b6c2">exodus_type</a>;
<a name="l00706"></a>00706 };
<a name="l00707"></a>00707 
<a name="l00708"></a>00708 
<a name="l00709"></a>00709 
<a name="l00710"></a>00710 
<a name="l00711"></a>00711 
<a name="l00712"></a>00712 
<a name="l00713"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php">00713</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php">ExodusII_IO_Helper::ElementMaps</a>
<a name="l00714"></a>00714 {
<a name="l00715"></a>00715 <span class="keyword">public</span>:
<a name="l00716"></a>00716 
<a name="l00720"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#a4b880d8a42cfdda62c3795f62d520d36">00720</a>   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#a4b880d8a42cfdda62c3795f62d520d36">ElementMaps</a>() {}
<a name="l00721"></a>00721 
<a name="l00733"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#a2870f647fb9cf8067b123a656fb298b7">00733</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#a2870f647fb9cf8067b123a656fb298b7">quad4_node_map</a>[4];
<a name="l00734"></a>00734 
<a name="l00740"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#a664cbf81ae7ae5d7ea5c7b25b60577da">00740</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#a664cbf81ae7ae5d7ea5c7b25b60577da">quad8_node_map</a>[8];
<a name="l00741"></a>00741 
<a name="l00747"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#a6a0bf36799281222a5359235f3f92317">00747</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#a6a0bf36799281222a5359235f3f92317">quad9_node_map</a>[9];
<a name="l00748"></a>00748 
<a name="l00754"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#ac4b7cb17e2a382a1d7a2db31ebde633e">00754</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#ac4b7cb17e2a382a1d7a2db31ebde633e">tri3_node_map</a>[3];
<a name="l00755"></a>00755 
<a name="l00761"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#a546f688825c1495d1dd6908802f3fdd3">00761</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#a546f688825c1495d1dd6908802f3fdd3">tri6_node_map</a>[6];
<a name="l00762"></a>00762 
<a name="l00771"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#a9bf1c63066228938dea776e174cc7169">00771</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#a9bf1c63066228938dea776e174cc7169">tri_edge_map</a>[3];
<a name="l00772"></a>00772 
<a name="l00777"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#acaac6c3168c06642cff460091ed478dc">00777</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#acaac6c3168c06642cff460091ed478dc">quad_edge_map</a>[4];
<a name="l00778"></a>00778 
<a name="l00783"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#a48fa958b2be407467f9c2cae59f22af3">00783</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#a48fa958b2be407467f9c2cae59f22af3">tri_inverse_edge_map</a>[3];
<a name="l00784"></a>00784 
<a name="l00789"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#a54fdb2a067b3ffe561810345a36f9d3d">00789</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#a54fdb2a067b3ffe561810345a36f9d3d">quad_inverse_edge_map</a>[4];
<a name="l00790"></a>00790 
<a name="l00802"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#abf85deeb6b00664d04fc0c32617be8bb">00802</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#abf85deeb6b00664d04fc0c32617be8bb">hex8_node_map</a>[8];
<a name="l00803"></a>00803 
<a name="l00809"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#aa8673162a0c07eef68c19fdcf3bdb635">00809</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#aa8673162a0c07eef68c19fdcf3bdb635">hex20_node_map</a>[20];
<a name="l00810"></a>00810 
<a name="l00816"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#a9b0ebeecb2654e7eca0c144e0bb954f5">00816</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#a9b0ebeecb2654e7eca0c144e0bb954f5">hex27_node_map</a>[27];
<a name="l00817"></a>00817 
<a name="l00823"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#aee9a6d6f6f2b26b9aff4f6fb71c06c8e">00823</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#aee9a6d6f6f2b26b9aff4f6fb71c06c8e">tet4_node_map</a>[4];
<a name="l00824"></a>00824 
<a name="l00830"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#a0f1436239fbf2f3aea47b86edc061c9d">00830</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#a0f1436239fbf2f3aea47b86edc061c9d">tet10_node_map</a>[10];
<a name="l00831"></a>00831 
<a name="l00835"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#a698dae2bf356b77c06a3bd7a7fdec15c">00835</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#a698dae2bf356b77c06a3bd7a7fdec15c">prism6_node_map</a>[6];
<a name="l00836"></a>00836 
<a name="l00841"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#ad2c7741704ca99e07020a05bf8b9c0da">00841</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#ad2c7741704ca99e07020a05bf8b9c0da">prism15_node_map</a>[15];
<a name="l00842"></a>00842 
<a name="l00846"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#aecf1db695384ae0219d811cc89c83721">00846</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#aecf1db695384ae0219d811cc89c83721">prism18_node_map</a>[18];
<a name="l00847"></a>00847 
<a name="l00853"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#aaac4d726f9b34350e58697fd8ba00e20">00853</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#aaac4d726f9b34350e58697fd8ba00e20">pyramid5_node_map</a>[5];
<a name="l00854"></a>00854 
<a name="l00855"></a>00855 
<a name="l00864"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#a7477ab19a4ff910fe0c60e5287ccff7f">00864</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#a7477ab19a4ff910fe0c60e5287ccff7f">hex_face_map</a>[6];
<a name="l00865"></a>00865 
<a name="l00870"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#afb111b9e150f58656c5f252dfe9ebe99">00870</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#afb111b9e150f58656c5f252dfe9ebe99">hex27_face_map</a>[6];
<a name="l00871"></a>00871 
<a name="l00876"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#a99f3976a164b16f2718c256967fe5c73">00876</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#a99f3976a164b16f2718c256967fe5c73">tet_face_map</a>[4];
<a name="l00877"></a>00877 
<a name="l00882"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#a3386e0d61e879f044524b9a1809f295b">00882</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#a3386e0d61e879f044524b9a1809f295b">prism_face_map</a>[5];
<a name="l00883"></a>00883 
<a name="l00888"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#a54f7bdc9cf01417b9e850f6a83981c44">00888</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#a54f7bdc9cf01417b9e850f6a83981c44">pyramid_face_map</a>[5];
<a name="l00889"></a>00889 
<a name="l00894"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#af46b0ab31cce8bfac7567594055bb854">00894</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#af46b0ab31cce8bfac7567594055bb854">hex_inverse_face_map</a>[6];
<a name="l00895"></a>00895 
<a name="l00900"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#ab3375c6bc4a77b49392a510822f9bd0c">00900</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#ab3375c6bc4a77b49392a510822f9bd0c">hex27_inverse_face_map</a>[6];
<a name="l00901"></a>00901 
<a name="l00906"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#a9873e92bc25eed6c717554f22818c135">00906</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#a9873e92bc25eed6c717554f22818c135">tet_inverse_face_map</a>[4];
<a name="l00907"></a>00907 
<a name="l00912"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#a9f9e1e8c254843eab5c87d1110af9ccc">00912</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#a9f9e1e8c254843eab5c87d1110af9ccc">prism_inverse_face_map</a>[5];
<a name="l00913"></a>00913 
<a name="l00918"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#a459d91f313598316ccf70a2a29540f3f">00918</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#a459d91f313598316ccf70a2a29540f3f">pyramid_inverse_face_map</a>[5];
<a name="l00919"></a>00919 
<a name="l00920"></a>00920 
<a name="l00924"></a>00924   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1Conversion.php">ExodusII_IO_Helper::Conversion</a> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#ad7bd06525087dfbddb663f5330f1882f">assign_conversion</a>(<span class="keyword">const</span> std::string type_str);
<a name="l00925"></a>00925 
<a name="l00929"></a>00929   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1Conversion.php">ExodusII_IO_Helper::Conversion</a> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#ad7bd06525087dfbddb663f5330f1882f">assign_conversion</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type);
<a name="l00930"></a>00930 };
<a name="l00931"></a>00931 
<a name="l00932"></a>00932 
<a name="l00933"></a>00933 } <span class="comment">// namespace libMesh</span>
<a name="l00934"></a>00934 
<a name="l00935"></a>00935 <span class="preprocessor">#endif // LIBMESH_HAVE_EXODUS_API</span>
<a name="l00936"></a>00936 <span class="preprocessor"></span>
<a name="l00937"></a>00937 <span class="preprocessor">#endif // #ifndef __exodusII_io_helper_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
