<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_eaf30c8ea092d33f79a04353c3899c3f.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_c3e8eaa2d7e284f14f0fe642096e1f63.php">fe</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">fe_base.h</div>  </div>
</div>
<div class="contents">
<a href="fe__base_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id$</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __fe_base_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __fe_base_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="comment">// Local includes</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="reference__counted__object_8h.php">reference_counted_object.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="point_8h.php">point.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="vector__value_8h.php">vector_value.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="enum__elem__type_8h.php">enum_elem_type.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="fe__type_8h.php">fe_type.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="auto__ptr_8h.php">auto_ptr.h</a>&quot;</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00037"></a>00037 <span class="preprocessor"></span><span class="preprocessor">#include &quot;<a class="code" href="tensor__value_8h.php">tensor_value.h</a>&quot;</span>
<a name="l00038"></a>00038 <span class="preprocessor">#endif</span>
<a name="l00039"></a>00039 <span class="preprocessor"></span>
<a name="l00040"></a>00040 <span class="keyword">namespace </span>libMesh
<a name="l00041"></a>00041 {
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 
<a name="l00044"></a>00044 <span class="comment">// forward declarations</span>
<a name="l00045"></a>00045 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span>DenseMatrix;
<a name="l00046"></a>00046 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span>DenseVector;
<a name="l00047"></a>00047 <span class="keyword">class </span>BoundaryInfo;
<a name="l00048"></a>00048 <span class="keyword">class </span>DofConstraints;
<a name="l00049"></a>00049 <span class="keyword">class </span>DofMap;
<a name="l00050"></a>00050 <span class="keyword">class </span>Elem;
<a name="l00051"></a>00051 <span class="keyword">class </span>MeshBase;
<a name="l00052"></a>00052 <span class="keyword">class </span>PeriodicBoundaries;
<a name="l00053"></a>00053 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span>NumericVector;
<a name="l00054"></a>00054 <span class="keyword">class </span>QBase;
<a name="l00055"></a>00055 
<a name="l00056"></a>00056 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00057"></a>00057 <span class="preprocessor"></span>
<a name="l00058"></a>00058 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T_radial, InfMapType T_map&gt;
<a name="l00059"></a>00059 <span class="keyword">class </span>InfFE;
<a name="l00060"></a>00060 
<a name="l00061"></a>00061 <span class="preprocessor">#endif</span>
<a name="l00062"></a>00062 <span class="preprocessor"></span>
<a name="l00063"></a>00063 
<a name="l00064"></a>00064 
<a name="l00089"></a>00089 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00090"></a>00090 <span class="comment">// FEBase class definition</span>
<a name="l00091"></a><a class="code" href="classlibMesh_1_1FEBase.php">00091</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1FEBase.php">FEBase</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1ReferenceCountedObject.php">ReferenceCountedObject</a>&lt;FEBase&gt;
<a name="l00092"></a>00092 {
<a name="l00093"></a>00093 <span class="keyword">protected</span>:
<a name="l00094"></a>00094 
<a name="l00100"></a>00100   <a class="code" href="classlibMesh_1_1FEBase.php#a192af2af77761e6f1a4b4d078fee62be">FEBase</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1FEBase.php#af0fac88fc60ae6a128fd616362680e47">dim</a>,
<a name="l00101"></a>00101           <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; fet);
<a name="l00102"></a>00102   
<a name="l00103"></a>00103 <span class="keyword">public</span>:
<a name="l00104"></a>00104   
<a name="l00108"></a>00108   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1FEBase.php#a577a559c45a3f0c88bb0a9e555a90c6c">~FEBase</a>();
<a name="l00109"></a>00109 
<a name="l00115"></a>00115   <span class="keyword">static</span> <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;FEBase&gt;</a> <a class="code" href="classlibMesh_1_1FEBase.php#aa6065b49a9dd684109a87770e514ff5d">build</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim,
<a name="l00116"></a>00116                                 <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; type); 
<a name="l00117"></a>00117   
<a name="l00118"></a>00118 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00119"></a>00119 <span class="preprocessor"></span>
<a name="l00125"></a>00125   <span class="keyword">static</span> <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;FEBase&gt;</a> <a class="code" href="classlibMesh_1_1FEBase.php#a42df651089ddc60e9baea1a73633ed90">build_InfFE</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim,
<a name="l00126"></a>00126                                       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; type); 
<a name="l00127"></a>00127 
<a name="l00128"></a>00128 <span class="preprocessor">#endif</span>
<a name="l00129"></a>00129 <span class="preprocessor"></span>
<a name="l00144"></a>00144   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEBase.php#a79b7a69e06d538c334842e1db2bc1223">reinit</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem,
<a name="l00145"></a>00145                        <span class="keyword">const</span> std::vector&lt;Point&gt;* <span class="keyword">const</span> pts = NULL) = 0;
<a name="l00146"></a>00146     
<a name="l00152"></a>00152   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEBase.php#a79b7a69e06d538c334842e1db2bc1223">reinit</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem,
<a name="l00153"></a>00153                        <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>,
<a name="l00154"></a>00154                        <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> tolerance = TOLERANCE) = 0;
<a name="l00155"></a>00155   
<a name="l00161"></a>00161   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEBase.php#aa42ccc1ab793f7a1a84b808eacd536e6">edge_reinit</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem,
<a name="l00162"></a>00162                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> edge,
<a name="l00163"></a>00163                             <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> tolerance = TOLERANCE) = 0;
<a name="l00164"></a>00164   
<a name="l00172"></a>00172   <span class="keyword">static</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1FEBase.php#afde8f8b71cba1d61a14c63194c8ca68a">on_reference_element</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p,
<a name="l00173"></a>00173                                    <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> t,
<a name="l00174"></a>00174                                    <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> eps = TOLERANCE);
<a name="l00175"></a>00175 
<a name="l00176"></a>00176 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00177"></a>00177 <span class="preprocessor"></span>
<a name="l00184"></a>00184   <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEBase.php#a3c6b19b079eaa80d062c0c6e3908bed1">compute_proj_constraints</a> (<a class="code" href="classlibMesh_1_1DofConstraints.php">DofConstraints</a> &amp;constraints,
<a name="l00185"></a>00185                                         <a class="code" href="classlibMesh_1_1DofMap.php">DofMap</a> &amp;dof_map,
<a name="l00186"></a>00186                                         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> variable_number,
<a name="l00187"></a>00187                                         <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem);
<a name="l00188"></a>00188 
<a name="l00194"></a>00194   <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEBase.php#a9e8a34c7c7dada421bcf88d5c9bc9a9e">coarsened_dof_values</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp;global_vector,
<a name="l00195"></a>00195                                    <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DofMap.php">DofMap</a> &amp;dof_map,
<a name="l00196"></a>00196                                    <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *coarse_elem,
<a name="l00197"></a>00197                                    <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> &amp;coarse_dofs,
<a name="l00198"></a>00198                                    <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var,
<a name="l00199"></a>00199                                    <span class="keyword">const</span> <span class="keywordtype">bool</span> use_old_dof_indices = <span class="keyword">false</span>);
<a name="l00200"></a>00200 
<a name="l00201"></a>00201 <span class="preprocessor">#endif // #ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00202"></a>00202 <span class="preprocessor"></span>
<a name="l00203"></a>00203 <span class="preprocessor">#ifdef LIBMESH_ENABLE_PERIODIC</span>
<a name="l00204"></a>00204 <span class="preprocessor"></span>
<a name="l00210"></a>00210   <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEBase.php#a601c3215847cc9838a30cbe9c75d3bd1">compute_periodic_constraints</a> (<a class="code" href="classlibMesh_1_1DofConstraints.php">DofConstraints</a> &amp;constraints,
<a name="l00211"></a>00211                                             <a class="code" href="classlibMesh_1_1DofMap.php">DofMap</a> &amp;dof_map,
<a name="l00212"></a>00212                                             <a class="code" href="classlibMesh_1_1PeriodicBoundaries.php">PeriodicBoundaries</a> &amp;boundaries,
<a name="l00213"></a>00213                                             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>,
<a name="l00214"></a>00214                                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> variable_number,
<a name="l00215"></a>00215                                             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem);
<a name="l00216"></a>00216 
<a name="l00217"></a>00217 <span class="preprocessor">#endif // LIBMESH_ENABLE_PERIODIC</span>
<a name="l00218"></a>00218 <span class="preprocessor"></span>
<a name="l00223"></a><a class="code" href="classlibMesh_1_1FEBase.php#a916212d29016e696eb914481e3e0b3fc">00223</a>   <span class="keyword">const</span> std::vector&lt;Point&gt;&amp; <a class="code" href="classlibMesh_1_1FEBase.php#a916212d29016e696eb914481e3e0b3fc">get_xyz</a>()<span class="keyword"> const</span>
<a name="l00224"></a>00224 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#ab172fc7fa719be569a8ab67bc33755a1">xyz</a>; }
<a name="l00225"></a>00225   
<a name="l00230"></a><a class="code" href="classlibMesh_1_1FEBase.php#aa4ade299922b8d04d73ee5f902526557">00230</a>   <span class="keyword">const</span> std::vector&lt;std::vector&lt;Real&gt; &gt;&amp; <a class="code" href="classlibMesh_1_1FEBase.php#aa4ade299922b8d04d73ee5f902526557">get_phi</a>()<span class="keyword"> const</span>
<a name="l00231"></a>00231 <span class="keyword">  </span>{ libmesh_assert(!<a class="code" href="classlibMesh_1_1FEBase.php#a21086169151d3274ecfefa03039162fc">calculations_started</a> || <a class="code" href="classlibMesh_1_1FEBase.php#a5347b5c1604abaf2bf6a387eeb55f572">calculate_phi</a>);
<a name="l00232"></a>00232     <a class="code" href="classlibMesh_1_1FEBase.php#a5347b5c1604abaf2bf6a387eeb55f572">calculate_phi</a> = <span class="keyword">true</span>; <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#a17a8b5dc3944c7848af1541f07ff9963">phi</a>; }
<a name="l00233"></a>00233   
<a name="l00238"></a><a class="code" href="classlibMesh_1_1FEBase.php#a68fbad4cea951df70482739ef41354d0">00238</a>   <span class="keyword">const</span> std::vector&lt;Real&gt;&amp; <a class="code" href="classlibMesh_1_1FEBase.php#a68fbad4cea951df70482739ef41354d0">get_JxW</a>()<span class="keyword"> const</span>
<a name="l00239"></a>00239 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#ab65e73ccb67c08f9a85a67c1ab7bab5e">JxW</a>; }
<a name="l00240"></a>00240 
<a name="l00245"></a><a class="code" href="classlibMesh_1_1FEBase.php#a00032001d3a0fda4f6281952b68fa400">00245</a>   <span class="keyword">const</span> std::vector&lt;std::vector&lt;RealGradient&gt; &gt;&amp; <a class="code" href="classlibMesh_1_1FEBase.php#a00032001d3a0fda4f6281952b68fa400">get_dphi</a>()<span class="keyword"> const</span>
<a name="l00246"></a>00246 <span class="keyword">  </span>{ libmesh_assert(!<a class="code" href="classlibMesh_1_1FEBase.php#a21086169151d3274ecfefa03039162fc">calculations_started</a> || <a class="code" href="classlibMesh_1_1FEBase.php#a3aee3c1c80c3e2934f1375247d9bb431">calculate_dphi</a>); 
<a name="l00247"></a>00247     <a class="code" href="classlibMesh_1_1FEBase.php#a3aee3c1c80c3e2934f1375247d9bb431">calculate_dphi</a> = <span class="keyword">true</span>; <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#a5d3c004bf1a96cf936cc3c5db5ab8170">dphi</a>; }
<a name="l00248"></a>00248   
<a name="l00253"></a><a class="code" href="classlibMesh_1_1FEBase.php#a7f717fa3f44eec495f18a604c4e05873">00253</a>   <span class="keyword">const</span> std::vector&lt;std::vector&lt;Real&gt; &gt;&amp; <a class="code" href="classlibMesh_1_1FEBase.php#a7f717fa3f44eec495f18a604c4e05873">get_dphidx</a>()<span class="keyword"> const</span>
<a name="l00254"></a>00254 <span class="keyword">  </span>{ libmesh_assert(!<a class="code" href="classlibMesh_1_1FEBase.php#a21086169151d3274ecfefa03039162fc">calculations_started</a> || <a class="code" href="classlibMesh_1_1FEBase.php#a3aee3c1c80c3e2934f1375247d9bb431">calculate_dphi</a>); 
<a name="l00255"></a>00255     <a class="code" href="classlibMesh_1_1FEBase.php#a3aee3c1c80c3e2934f1375247d9bb431">calculate_dphi</a> = <span class="keyword">true</span>; <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#af788235b8ba5e45b88a1faab71023511">dphidx</a>; }
<a name="l00256"></a>00256   
<a name="l00261"></a><a class="code" href="classlibMesh_1_1FEBase.php#ae0d97502f4715d24e2420541f2d66cc1">00261</a>   <span class="keyword">const</span> std::vector&lt;std::vector&lt;Real&gt; &gt;&amp; <a class="code" href="classlibMesh_1_1FEBase.php#ae0d97502f4715d24e2420541f2d66cc1">get_dphidy</a>()<span class="keyword"> const</span>
<a name="l00262"></a>00262 <span class="keyword">  </span>{ libmesh_assert(!<a class="code" href="classlibMesh_1_1FEBase.php#a21086169151d3274ecfefa03039162fc">calculations_started</a> || <a class="code" href="classlibMesh_1_1FEBase.php#a3aee3c1c80c3e2934f1375247d9bb431">calculate_dphi</a>); 
<a name="l00263"></a>00263     <a class="code" href="classlibMesh_1_1FEBase.php#a3aee3c1c80c3e2934f1375247d9bb431">calculate_dphi</a> = <span class="keyword">true</span>; <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#af9dc49053521282a4b176a74df91dc0b">dphidy</a>; }
<a name="l00264"></a>00264   
<a name="l00269"></a><a class="code" href="classlibMesh_1_1FEBase.php#aa56a41bf6ea9f3eb785c6b8ac907c8b6">00269</a>   <span class="keyword">const</span> std::vector&lt;std::vector&lt;Real&gt; &gt;&amp; <a class="code" href="classlibMesh_1_1FEBase.php#aa56a41bf6ea9f3eb785c6b8ac907c8b6">get_dphidz</a>()<span class="keyword"> const</span>
<a name="l00270"></a>00270 <span class="keyword">  </span>{ libmesh_assert(!<a class="code" href="classlibMesh_1_1FEBase.php#a21086169151d3274ecfefa03039162fc">calculations_started</a> || <a class="code" href="classlibMesh_1_1FEBase.php#a3aee3c1c80c3e2934f1375247d9bb431">calculate_dphi</a>);
<a name="l00271"></a>00271     <a class="code" href="classlibMesh_1_1FEBase.php#a3aee3c1c80c3e2934f1375247d9bb431">calculate_dphi</a> = <span class="keyword">true</span>; <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#aabdefc6f2e13fa5880273c269b21b362">dphidz</a>; }
<a name="l00272"></a>00272 
<a name="l00277"></a><a class="code" href="classlibMesh_1_1FEBase.php#a00de91670d2e80ae28efd5f9d5f1e730">00277</a>   <span class="keyword">const</span> std::vector&lt;std::vector&lt;Real&gt; &gt;&amp; <a class="code" href="classlibMesh_1_1FEBase.php#a00de91670d2e80ae28efd5f9d5f1e730">get_dphidxi</a>()<span class="keyword"> const</span>
<a name="l00278"></a>00278 <span class="keyword">  </span>{ libmesh_assert(!<a class="code" href="classlibMesh_1_1FEBase.php#a21086169151d3274ecfefa03039162fc">calculations_started</a> || <a class="code" href="classlibMesh_1_1FEBase.php#a3aee3c1c80c3e2934f1375247d9bb431">calculate_dphi</a>); 
<a name="l00279"></a>00279     <a class="code" href="classlibMesh_1_1FEBase.php#a3aee3c1c80c3e2934f1375247d9bb431">calculate_dphi</a> = <span class="keyword">true</span>; <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#a55924631f827328b44a9f34b36ac80df">dphidxi</a>; }
<a name="l00280"></a>00280   
<a name="l00285"></a><a class="code" href="classlibMesh_1_1FEBase.php#a3b482a95bb38c889b7b159959514eaa2">00285</a>   <span class="keyword">const</span> std::vector&lt;std::vector&lt;Real&gt; &gt;&amp; <a class="code" href="classlibMesh_1_1FEBase.php#a3b482a95bb38c889b7b159959514eaa2">get_dphideta</a>()<span class="keyword"> const</span>
<a name="l00286"></a>00286 <span class="keyword">  </span>{ libmesh_assert(!<a class="code" href="classlibMesh_1_1FEBase.php#a21086169151d3274ecfefa03039162fc">calculations_started</a> || <a class="code" href="classlibMesh_1_1FEBase.php#a3aee3c1c80c3e2934f1375247d9bb431">calculate_dphi</a>); 
<a name="l00287"></a>00287     <a class="code" href="classlibMesh_1_1FEBase.php#a3aee3c1c80c3e2934f1375247d9bb431">calculate_dphi</a> = <span class="keyword">true</span>; <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#a5418c7b62ef30ce968b09f22f9240db7">dphideta</a>; }
<a name="l00288"></a>00288   
<a name="l00293"></a><a class="code" href="classlibMesh_1_1FEBase.php#ae7e3da68b2431109084c0b9365cfa697">00293</a>   <span class="keyword">const</span> std::vector&lt;std::vector&lt;Real&gt; &gt;&amp; <a class="code" href="classlibMesh_1_1FEBase.php#ae7e3da68b2431109084c0b9365cfa697">get_dphidzeta</a>()<span class="keyword"> const</span>
<a name="l00294"></a>00294 <span class="keyword">  </span>{ libmesh_assert(!<a class="code" href="classlibMesh_1_1FEBase.php#a21086169151d3274ecfefa03039162fc">calculations_started</a> || <a class="code" href="classlibMesh_1_1FEBase.php#a3aee3c1c80c3e2934f1375247d9bb431">calculate_dphi</a>);
<a name="l00295"></a>00295     <a class="code" href="classlibMesh_1_1FEBase.php#a3aee3c1c80c3e2934f1375247d9bb431">calculate_dphi</a> = <span class="keyword">true</span>; <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#a41ed461b364fb98c1c25ed6414ffc8db">dphidzeta</a>; }
<a name="l00296"></a>00296 
<a name="l00297"></a>00297 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00298"></a>00298 <span class="preprocessor"></span>
<a name="l00303"></a><a class="code" href="classlibMesh_1_1FEBase.php#aa844b64d6daf6512b760b9a528fc7848">00303</a>   <span class="keyword">const</span> std::vector&lt;std::vector&lt;RealTensor&gt; &gt;&amp; <a class="code" href="classlibMesh_1_1FEBase.php#aa844b64d6daf6512b760b9a528fc7848">get_d2phi</a>()<span class="keyword"> const</span>
<a name="l00304"></a>00304 <span class="keyword">  </span>{ libmesh_assert(!<a class="code" href="classlibMesh_1_1FEBase.php#a21086169151d3274ecfefa03039162fc">calculations_started</a> || <a class="code" href="classlibMesh_1_1FEBase.php#a4170551fa0860822e21475e3c098bc13">calculate_d2phi</a>); 
<a name="l00305"></a>00305     <a class="code" href="classlibMesh_1_1FEBase.php#a4170551fa0860822e21475e3c098bc13">calculate_d2phi</a> = <span class="keyword">true</span>; <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#ac30dc4874a7bf7f81ba1774e80dfc10c">d2phi</a>; }
<a name="l00306"></a>00306   
<a name="l00311"></a><a class="code" href="classlibMesh_1_1FEBase.php#adb19cd4b3a848682de61216562d46258">00311</a>   <span class="keyword">const</span> std::vector&lt;std::vector&lt;Real&gt; &gt;&amp; <a class="code" href="classlibMesh_1_1FEBase.php#adb19cd4b3a848682de61216562d46258">get_d2phidx2</a>()<span class="keyword"> const</span>
<a name="l00312"></a>00312 <span class="keyword">  </span>{ libmesh_assert(!<a class="code" href="classlibMesh_1_1FEBase.php#a21086169151d3274ecfefa03039162fc">calculations_started</a> || <a class="code" href="classlibMesh_1_1FEBase.php#a4170551fa0860822e21475e3c098bc13">calculate_d2phi</a>);
<a name="l00313"></a>00313     <a class="code" href="classlibMesh_1_1FEBase.php#a4170551fa0860822e21475e3c098bc13">calculate_d2phi</a> = <span class="keyword">true</span>; <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#ae714718de014536d22cae1025152c1bc">d2phidx2</a>; }
<a name="l00314"></a>00314   
<a name="l00319"></a><a class="code" href="classlibMesh_1_1FEBase.php#a225b0c138d9619ee1365fe883f961640">00319</a>   <span class="keyword">const</span> std::vector&lt;std::vector&lt;Real&gt; &gt;&amp; <a class="code" href="classlibMesh_1_1FEBase.php#a225b0c138d9619ee1365fe883f961640">get_d2phidxdy</a>()<span class="keyword"> const</span>
<a name="l00320"></a>00320 <span class="keyword">  </span>{ libmesh_assert(!<a class="code" href="classlibMesh_1_1FEBase.php#a21086169151d3274ecfefa03039162fc">calculations_started</a> || <a class="code" href="classlibMesh_1_1FEBase.php#a4170551fa0860822e21475e3c098bc13">calculate_d2phi</a>);
<a name="l00321"></a>00321     <a class="code" href="classlibMesh_1_1FEBase.php#a4170551fa0860822e21475e3c098bc13">calculate_d2phi</a> = <span class="keyword">true</span>; <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#aa6a1dbdf1d2b43775f970a2935c856eb">d2phidxdy</a>; }
<a name="l00322"></a>00322   
<a name="l00327"></a><a class="code" href="classlibMesh_1_1FEBase.php#a4475014e8d36378416784b975b272e9c">00327</a>   <span class="keyword">const</span> std::vector&lt;std::vector&lt;Real&gt; &gt;&amp; <a class="code" href="classlibMesh_1_1FEBase.php#a4475014e8d36378416784b975b272e9c">get_d2phidxdz</a>()<span class="keyword"> const</span>
<a name="l00328"></a>00328 <span class="keyword">  </span>{ libmesh_assert(!<a class="code" href="classlibMesh_1_1FEBase.php#a21086169151d3274ecfefa03039162fc">calculations_started</a> || <a class="code" href="classlibMesh_1_1FEBase.php#a4170551fa0860822e21475e3c098bc13">calculate_d2phi</a>);
<a name="l00329"></a>00329     <a class="code" href="classlibMesh_1_1FEBase.php#a4170551fa0860822e21475e3c098bc13">calculate_d2phi</a> = <span class="keyword">true</span>; <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#a9d886719c19dd168b673a8e4c2e0e22c">d2phidxdz</a>; }
<a name="l00330"></a>00330   
<a name="l00335"></a><a class="code" href="classlibMesh_1_1FEBase.php#a963c366d16f4e5c5a221ed3665c475f5">00335</a>   <span class="keyword">const</span> std::vector&lt;std::vector&lt;Real&gt; &gt;&amp; <a class="code" href="classlibMesh_1_1FEBase.php#a963c366d16f4e5c5a221ed3665c475f5">get_d2phidy2</a>()<span class="keyword"> const</span>
<a name="l00336"></a>00336 <span class="keyword">  </span>{ libmesh_assert(!<a class="code" href="classlibMesh_1_1FEBase.php#a21086169151d3274ecfefa03039162fc">calculations_started</a> || <a class="code" href="classlibMesh_1_1FEBase.php#a4170551fa0860822e21475e3c098bc13">calculate_d2phi</a>);
<a name="l00337"></a>00337     <a class="code" href="classlibMesh_1_1FEBase.php#a4170551fa0860822e21475e3c098bc13">calculate_d2phi</a> = <span class="keyword">true</span>; <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#a2dd94fa0428de261dccfdb1c56bbe6ff">d2phidy2</a>; }
<a name="l00338"></a>00338   
<a name="l00343"></a><a class="code" href="classlibMesh_1_1FEBase.php#afd48c473b3c4b46a60744244aaac6bab">00343</a>   <span class="keyword">const</span> std::vector&lt;std::vector&lt;Real&gt; &gt;&amp; <a class="code" href="classlibMesh_1_1FEBase.php#afd48c473b3c4b46a60744244aaac6bab">get_d2phidydz</a>()<span class="keyword"> const</span>
<a name="l00344"></a>00344 <span class="keyword">  </span>{ libmesh_assert(!<a class="code" href="classlibMesh_1_1FEBase.php#a21086169151d3274ecfefa03039162fc">calculations_started</a> || <a class="code" href="classlibMesh_1_1FEBase.php#a4170551fa0860822e21475e3c098bc13">calculate_d2phi</a>);
<a name="l00345"></a>00345     <a class="code" href="classlibMesh_1_1FEBase.php#a4170551fa0860822e21475e3c098bc13">calculate_d2phi</a> = <span class="keyword">true</span>; <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#a4062e05a6ae4409130a3e8170a6416b6">d2phidydz</a>; }
<a name="l00346"></a>00346   
<a name="l00351"></a><a class="code" href="classlibMesh_1_1FEBase.php#a0552134ae661a20780a0ffe9136f16eb">00351</a>   <span class="keyword">const</span> std::vector&lt;std::vector&lt;Real&gt; &gt;&amp; <a class="code" href="classlibMesh_1_1FEBase.php#a0552134ae661a20780a0ffe9136f16eb">get_d2phidz2</a>()<span class="keyword"> const</span>
<a name="l00352"></a>00352 <span class="keyword">  </span>{ libmesh_assert(!<a class="code" href="classlibMesh_1_1FEBase.php#a21086169151d3274ecfefa03039162fc">calculations_started</a> || <a class="code" href="classlibMesh_1_1FEBase.php#a4170551fa0860822e21475e3c098bc13">calculate_d2phi</a>);
<a name="l00353"></a>00353     <a class="code" href="classlibMesh_1_1FEBase.php#a4170551fa0860822e21475e3c098bc13">calculate_d2phi</a> = <span class="keyword">true</span>; <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#a1f0b11a1d8784fd8eb4604a9605aa421">d2phidz2</a>; }
<a name="l00354"></a>00354 
<a name="l00355"></a>00355 <span class="preprocessor">#endif</span>
<a name="l00356"></a>00356 <span class="preprocessor"></span>  
<a name="l00361"></a><a class="code" href="classlibMesh_1_1FEBase.php#a873da67ebc4a818d23dc068daa37186d">00361</a>   <span class="keyword">const</span> std::vector&lt;RealGradient&gt;&amp; <a class="code" href="classlibMesh_1_1FEBase.php#a873da67ebc4a818d23dc068daa37186d">get_dxyzdxi</a>()<span class="keyword"> const</span>
<a name="l00362"></a>00362 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#ad68d0a6127a9c54b3d6800ff91981523">dxyzdxi_map</a>; }
<a name="l00363"></a>00363 
<a name="l00368"></a><a class="code" href="classlibMesh_1_1FEBase.php#a4356aafa6fcbdf7854aceaffe1950f0f">00368</a>   <span class="keyword">const</span> std::vector&lt;RealGradient&gt;&amp; <a class="code" href="classlibMesh_1_1FEBase.php#a4356aafa6fcbdf7854aceaffe1950f0f">get_dxyzdeta</a>()<span class="keyword"> const</span>
<a name="l00369"></a>00369 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#a86d96fe77ae2c9d4887431ae86686697">dxyzdeta_map</a>; }
<a name="l00370"></a>00370 
<a name="l00375"></a><a class="code" href="classlibMesh_1_1FEBase.php#abbedad421faadc2ff3559e9ea7dc7957">00375</a>   <span class="keyword">const</span> std::vector&lt;RealGradient&gt;&amp; <a class="code" href="classlibMesh_1_1FEBase.php#abbedad421faadc2ff3559e9ea7dc7957">get_dxyzdzeta</a>()<span class="keyword"> const</span>
<a name="l00376"></a>00376 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#aa381ea7e9964780eb8cf4bad4b6fe192">dxyzdzeta_map</a>; }
<a name="l00377"></a>00377   
<a name="l00381"></a><a class="code" href="classlibMesh_1_1FEBase.php#a8613b53a9a0f75b005ca4efe80fbf5e6">00381</a>   <span class="keyword">const</span> std::vector&lt;RealGradient&gt;&amp; <a class="code" href="classlibMesh_1_1FEBase.php#a8613b53a9a0f75b005ca4efe80fbf5e6">get_d2xyzdxi2</a>()<span class="keyword"> const</span>
<a name="l00382"></a>00382 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#a9f0ecbf196b5e9d14edf43c7f1beca1c">d2xyzdxi2_map</a>; }
<a name="l00383"></a>00383 
<a name="l00387"></a><a class="code" href="classlibMesh_1_1FEBase.php#a300472022bacaecb2a5e251fc9e145f2">00387</a>   <span class="keyword">const</span> std::vector&lt;RealGradient&gt;&amp; <a class="code" href="classlibMesh_1_1FEBase.php#a300472022bacaecb2a5e251fc9e145f2">get_d2xyzdeta2</a>()<span class="keyword"> const</span>
<a name="l00388"></a>00388 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#a68f2668617657bb1041fcf25adacb225">d2xyzdeta2_map</a>; }
<a name="l00389"></a>00389 
<a name="l00390"></a>00390 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00391"></a>00391 <span class="preprocessor"></span>  
<a name="l00395"></a><a class="code" href="classlibMesh_1_1FEBase.php#ae2b689466cc98a44196ef5a1c19dbe02">00395</a>   <span class="keyword">const</span> std::vector&lt;RealGradient&gt;&amp; <a class="code" href="classlibMesh_1_1FEBase.php#ae2b689466cc98a44196ef5a1c19dbe02">get_d2xyzdzeta2</a>()<span class="keyword"> const</span>
<a name="l00396"></a>00396 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#a15bef5c694ec90dff276ec7cce06240d">d2xyzdzeta2_map</a>; }
<a name="l00397"></a>00397   
<a name="l00398"></a>00398 <span class="preprocessor">#endif</span>
<a name="l00399"></a>00399 <span class="preprocessor"></span>  
<a name="l00403"></a><a class="code" href="classlibMesh_1_1FEBase.php#a03f30ee2c26be3e8bf07d21d54c82863">00403</a>   <span class="keyword">const</span> std::vector&lt;RealGradient&gt;&amp; <a class="code" href="classlibMesh_1_1FEBase.php#a03f30ee2c26be3e8bf07d21d54c82863">get_d2xyzdxideta</a>()<span class="keyword"> const</span>
<a name="l00404"></a>00404 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#a09c2e4ca10dce4a7f565593ff527d50c">d2xyzdxideta_map</a>; }
<a name="l00405"></a>00405 
<a name="l00406"></a>00406 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00407"></a>00407 <span class="preprocessor"></span>  
<a name="l00411"></a><a class="code" href="classlibMesh_1_1FEBase.php#a8e346653c82e56c85d57f2a64a5789db">00411</a>   <span class="keyword">const</span> std::vector&lt;RealGradient&gt;&amp; <a class="code" href="classlibMesh_1_1FEBase.php#a8e346653c82e56c85d57f2a64a5789db">get_d2xyzdxidzeta</a>()<span class="keyword"> const</span>
<a name="l00412"></a>00412 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#ac682c345ba4eff977747c26ef7e9c39d">d2xyzdxidzeta_map</a>; }
<a name="l00413"></a>00413 
<a name="l00417"></a><a class="code" href="classlibMesh_1_1FEBase.php#a33943b6e4da045659c80694e66e042ee">00417</a>   <span class="keyword">const</span> std::vector&lt;RealGradient&gt;&amp; <a class="code" href="classlibMesh_1_1FEBase.php#a33943b6e4da045659c80694e66e042ee">get_d2xyzdetadzeta</a>()<span class="keyword"> const</span>
<a name="l00418"></a>00418 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#a94c958eeca969946c86b1f740a25fd33">d2xyzdetadzeta_map</a>; }
<a name="l00419"></a>00419 
<a name="l00420"></a>00420 <span class="preprocessor">#endif</span>
<a name="l00421"></a>00421 <span class="preprocessor"></span>  
<a name="l00426"></a><a class="code" href="classlibMesh_1_1FEBase.php#adacdb7abfb45f93075503c491b7ea859">00426</a>   <span class="keyword">const</span> std::vector&lt;Real&gt;&amp; <a class="code" href="classlibMesh_1_1FEBase.php#adacdb7abfb45f93075503c491b7ea859">get_dxidx</a>()<span class="keyword"> const</span>
<a name="l00427"></a>00427 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#a2bbf05f3a09e39f3580746ee0872d7dd">dxidx_map</a>; }
<a name="l00428"></a>00428 
<a name="l00433"></a><a class="code" href="classlibMesh_1_1FEBase.php#a04d49de7fd7bdda94d3b15affb1d5efa">00433</a>   <span class="keyword">const</span> std::vector&lt;Real&gt;&amp; <a class="code" href="classlibMesh_1_1FEBase.php#a04d49de7fd7bdda94d3b15affb1d5efa">get_dxidy</a>()<span class="keyword"> const</span>
<a name="l00434"></a>00434 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#a33818360df704d7bffa5918c5afc8e51">dxidy_map</a>; }
<a name="l00435"></a>00435 
<a name="l00440"></a><a class="code" href="classlibMesh_1_1FEBase.php#acdca7bdfc4364365320287eadc4833b3">00440</a>   <span class="keyword">const</span> std::vector&lt;Real&gt;&amp; <a class="code" href="classlibMesh_1_1FEBase.php#acdca7bdfc4364365320287eadc4833b3">get_dxidz</a>()<span class="keyword"> const</span>
<a name="l00441"></a>00441 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#a52734d3ba88b2602d385908b2170d19e">dxidz_map</a>; }
<a name="l00442"></a>00442 
<a name="l00447"></a><a class="code" href="classlibMesh_1_1FEBase.php#ac688428b9142e2d6ca27a0420b627533">00447</a>   <span class="keyword">const</span> std::vector&lt;Real&gt;&amp; <a class="code" href="classlibMesh_1_1FEBase.php#ac688428b9142e2d6ca27a0420b627533">get_detadx</a>()<span class="keyword"> const</span>
<a name="l00448"></a>00448 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#ab292d4400894e09b1fb0c056b98d5a31">detadx_map</a>; }
<a name="l00449"></a>00449 
<a name="l00454"></a><a class="code" href="classlibMesh_1_1FEBase.php#a5d14d85c8eca1e4cb647acbbd44daf36">00454</a>   <span class="keyword">const</span> std::vector&lt;Real&gt;&amp; <a class="code" href="classlibMesh_1_1FEBase.php#a5d14d85c8eca1e4cb647acbbd44daf36">get_detady</a>()<span class="keyword"> const</span>
<a name="l00455"></a>00455 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#af946c6bf8b1dd0e668744b825d3c455e">detady_map</a>; }
<a name="l00456"></a>00456 
<a name="l00461"></a><a class="code" href="classlibMesh_1_1FEBase.php#ae1ab8299847ae6027494cb41ae758444">00461</a>   <span class="keyword">const</span> std::vector&lt;Real&gt;&amp; <a class="code" href="classlibMesh_1_1FEBase.php#ae1ab8299847ae6027494cb41ae758444">get_detadz</a>()<span class="keyword"> const</span>
<a name="l00462"></a>00462 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#af474fdffb0815f291d7cf71563a74755">detadz_map</a>; }
<a name="l00463"></a>00463 
<a name="l00468"></a><a class="code" href="classlibMesh_1_1FEBase.php#a0070553b81441483d0dae640a290e6c2">00468</a>   <span class="keyword">const</span> std::vector&lt;Real&gt;&amp; <a class="code" href="classlibMesh_1_1FEBase.php#a0070553b81441483d0dae640a290e6c2">get_dzetadx</a>()<span class="keyword"> const</span>
<a name="l00469"></a>00469 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#a9f554c5ccb1da9ca23929d524e38e009">dzetadx_map</a>; }
<a name="l00470"></a>00470 
<a name="l00475"></a><a class="code" href="classlibMesh_1_1FEBase.php#a4b686928dad06ccae30080b74f12df4d">00475</a>   <span class="keyword">const</span> std::vector&lt;Real&gt;&amp; <a class="code" href="classlibMesh_1_1FEBase.php#a4b686928dad06ccae30080b74f12df4d">get_dzetady</a>()<span class="keyword"> const</span>
<a name="l00476"></a>00476 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#a8e6767de7f38742cadf408d467f2e944">dzetady_map</a>; }
<a name="l00477"></a>00477 
<a name="l00482"></a><a class="code" href="classlibMesh_1_1FEBase.php#ab4c52a0d85ded34b09b3dccf9674819b">00482</a>   <span class="keyword">const</span> std::vector&lt;Real&gt;&amp; <a class="code" href="classlibMesh_1_1FEBase.php#ab4c52a0d85ded34b09b3dccf9674819b">get_dzetadz</a>()<span class="keyword"> const</span>
<a name="l00483"></a>00483 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#aa6b144384c2b18bd25ee23fff52afa1b">dzetadz_map</a>; }
<a name="l00484"></a>00484   
<a name="l00485"></a>00485 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00486"></a>00486 <span class="preprocessor"></span>
<a name="l00497"></a><a class="code" href="classlibMesh_1_1FEBase.php#a60b68907bb757385086daeaeb5583840">00497</a>   <span class="keyword">const</span> std::vector&lt;RealGradient&gt;&amp; <a class="code" href="classlibMesh_1_1FEBase.php#a60b68907bb757385086daeaeb5583840">get_dphase</a>()<span class="keyword"> const</span>
<a name="l00498"></a>00498 <span class="keyword">      </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#a736b3086ae27dfdb25eea45a32d8be46">dphase</a>; }
<a name="l00499"></a>00499 
<a name="l00500"></a>00500 
<a name="l00513"></a><a class="code" href="classlibMesh_1_1FEBase.php#af2206d26dcf0a8daeb77ccede092e446">00513</a>   <span class="keyword">const</span> std::vector&lt;Real&gt;&amp; <a class="code" href="classlibMesh_1_1FEBase.php#af2206d26dcf0a8daeb77ccede092e446">get_Sobolev_weight</a>()<span class="keyword"> const</span>
<a name="l00514"></a>00514 <span class="keyword">      </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#a68e24d92c979f86161c991c5d9679efd">weight</a>; }
<a name="l00515"></a>00515 
<a name="l00521"></a><a class="code" href="classlibMesh_1_1FEBase.php#ac101983243b18de5be27f901c228f7d7">00521</a>   <span class="keyword">const</span> std::vector&lt;RealGradient&gt;&amp; <a class="code" href="classlibMesh_1_1FEBase.php#ac101983243b18de5be27f901c228f7d7">get_Sobolev_dweight</a>()<span class="keyword"> const</span>
<a name="l00522"></a>00522 <span class="keyword">      </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#a5e1ad40ece4ef6feb855628dd30217fa">dweight</a>; }
<a name="l00523"></a>00523 
<a name="l00524"></a>00524 <span class="preprocessor">#endif</span>
<a name="l00525"></a>00525 <span class="preprocessor"></span>
<a name="l00526"></a>00526   
<a name="l00530"></a><a class="code" href="classlibMesh_1_1FEBase.php#ae9881db3ec685b4abc05774f921b5c23">00530</a>   <span class="keyword">const</span> std::vector&lt;std::vector&lt;Point&gt; &gt;&amp; <a class="code" href="classlibMesh_1_1FEBase.php#ae9881db3ec685b4abc05774f921b5c23">get_tangents</a>()<span class="keyword"> const</span>
<a name="l00531"></a>00531 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#a75af7795f42767464ccf13ff1d461211">tangents</a>; }
<a name="l00532"></a>00532   
<a name="l00536"></a><a class="code" href="classlibMesh_1_1FEBase.php#a9078ec05cdd69415d6eda9a1a0d7a61f">00536</a>   <span class="keyword">const</span> std::vector&lt;Point&gt;&amp; <a class="code" href="classlibMesh_1_1FEBase.php#a9078ec05cdd69415d6eda9a1a0d7a61f">get_normals</a>()<span class="keyword"> const</span>
<a name="l00537"></a>00537 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#a7e59b6e942afe70db77d4270a2f22a92">normals</a>; }
<a name="l00538"></a>00538 
<a name="l00542"></a><a class="code" href="classlibMesh_1_1FEBase.php#a9b077a144e6a56f6e4ff481ffd3899bb">00542</a>   <span class="keyword">const</span> std::vector&lt;Real&gt;&amp; <a class="code" href="classlibMesh_1_1FEBase.php#a9b077a144e6a56f6e4ff481ffd3899bb">get_curvatures</a>()<span class="keyword"> const</span>
<a name="l00543"></a>00543 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#aac9919c0f087c1439e39de79469c3620">curvatures</a>;}
<a name="l00544"></a>00544   
<a name="l00549"></a>00549   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEBase.php#aee369a488ea99b9dbbd48b8a288e242d">attach_quadrature_rule</a> (<a class="code" href="classlibMesh_1_1QBase.php">QBase</a>* q) = 0;
<a name="l00550"></a>00550 
<a name="l00556"></a>00556   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1FEBase.php#a9b62c96b04ef966bc60698668fc50ae2">n_shape_functions</a> () <span class="keyword">const</span> = 0;
<a name="l00557"></a>00557 
<a name="l00562"></a>00562   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1FEBase.php#a4654366f3c40cf9798130ae40a3f237d">n_quadrature_points</a> () <span class="keyword">const</span> = 0;
<a name="l00563"></a>00563   
<a name="l00569"></a><a class="code" href="classlibMesh_1_1FEBase.php#ac0fc89014c1461482964913acbf3c473">00569</a>   <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> <a class="code" href="classlibMesh_1_1FEBase.php#ac0fc89014c1461482964913acbf3c473">get_type</a>()<span class="keyword">  const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#a99ba1265271c4c3a26b8c71c1c35c7e6">elem_type</a>; }
<a name="l00570"></a>00570 
<a name="l00575"></a><a class="code" href="classlibMesh_1_1FEBase.php#ad3d200ccc45670a850c9d6c3ef9cd1c5">00575</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1FEBase.php#ad3d200ccc45670a850c9d6c3ef9cd1c5">get_p_level</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#af53860e35032db7fd392c199e8d8389a">_p_level</a>; }
<a name="l00576"></a>00576 
<a name="l00580"></a><a class="code" href="classlibMesh_1_1FEBase.php#a92b2eaa1dc1b54e5dbbecce45ed732ef">00580</a>   <a class="code" href="classlibMesh_1_1FEType.php">FEType</a> <a class="code" href="classlibMesh_1_1FEBase.php#a92b2eaa1dc1b54e5dbbecce45ed732ef">get_fe_type</a>()<span class="keyword">  const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#afee01a0935bb98ce8f670c1a86c3f68a">fe_type</a>; }
<a name="l00581"></a>00581 
<a name="l00585"></a><a class="code" href="classlibMesh_1_1FEBase.php#a1b8cca9e17655605147b013f9f2f6421">00585</a>   <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> <a class="code" href="classlibMesh_1_1FEBase.php#a1b8cca9e17655605147b013f9f2f6421">get_order</a>()<span class="keyword">  const </span>{ <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a><span class="keyword">&gt;</span>(<a class="code" href="classlibMesh_1_1FEBase.php#afee01a0935bb98ce8f670c1a86c3f68a">fe_type</a>.<a class="code" href="classlibMesh_1_1FEType.php#aa2484e0f6721f3e34dedebccacc48ac1">order</a> + <a class="code" href="classlibMesh_1_1FEBase.php#af53860e35032db7fd392c199e8d8389a">_p_level</a>); }
<a name="l00586"></a>00586 
<a name="l00590"></a>00590   <span class="keyword">virtual</span> <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14">FEContinuity</a> <a class="code" href="classlibMesh_1_1FEBase.php#a8ef41afc2e271d2a4c06c62fbc6964a5">get_continuity</a>() <span class="keyword">const</span> = 0;
<a name="l00591"></a>00591 
<a name="l00596"></a>00596   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1FEBase.php#af709cad010aac366e7441fed797ebc35">is_hierarchic</a>() <span class="keyword">const</span> = 0;
<a name="l00597"></a>00597 
<a name="l00601"></a><a class="code" href="classlibMesh_1_1FEBase.php#aa5fa89a3197c8b3b10fb2abb3ddc8220">00601</a>   <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5">FEFamily</a> <a class="code" href="classlibMesh_1_1FEBase.php#aa5fa89a3197c8b3b10fb2abb3ddc8220">get_family</a>()<span class="keyword">  const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#afee01a0935bb98ce8f670c1a86c3f68a">fe_type</a>.<a class="code" href="classlibMesh_1_1FEType.php#ac437ba9b0a5253d6bf6f07ad277b9978">family</a>; }
<a name="l00602"></a>00602 
<a name="l00606"></a>00606   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEBase.php#a756e10b9e7a9c4f92531e6f8fe278795">print_JxW</a>(std::ostream&amp; os) <span class="keyword">const</span>; 
<a name="l00607"></a>00607   
<a name="l00611"></a>00611   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEBase.php#a9d95ed9fed8a96c18ff68be25d988b8f">print_phi</a>(std::ostream&amp; os) <span class="keyword">const</span>; 
<a name="l00612"></a>00612   
<a name="l00617"></a>00617   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEBase.php#a2b5d94c3ceb3f6b9a5eb589238f532b9">print_dphi</a>(std::ostream&amp; os) <span class="keyword">const</span>;
<a name="l00618"></a>00618 
<a name="l00619"></a>00619 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00620"></a>00620 <span class="preprocessor"></span>
<a name="l00625"></a>00625   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEBase.php#ac335f09834d705416b119e0a7c6d83a3">print_d2phi</a>(std::ostream&amp; os) <span class="keyword">const</span>;
<a name="l00626"></a>00626 
<a name="l00627"></a>00627 <span class="preprocessor">#endif</span>
<a name="l00628"></a>00628 <span class="preprocessor"></span>  
<a name="l00633"></a>00633   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEBase.php#ade57dae87a9086c7c30741368a47b8e5">print_xyz</a>(std::ostream&amp; os) <span class="keyword">const</span>;
<a name="l00634"></a>00634 
<a name="l00638"></a>00638   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEBase.php#af737e6b5daf21df5f3b8a850c20db32a">print_info</a>(std::ostream&amp; os) <span class="keyword">const</span>;
<a name="l00639"></a>00639 
<a name="l00643"></a>00643   <span class="keyword">friend</span> std::ostream&amp; <a class="code" href="classlibMesh_1_1FEBase.php#af707d8f04488db8220405623626a146a">operator &lt;&lt; </a>(std::ostream&amp; os, <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEBase.php">FEBase</a>&amp; fe);
<a name="l00644"></a>00644   
<a name="l00645"></a>00645   
<a name="l00646"></a>00646 <span class="keyword">protected</span>:
<a name="l00647"></a>00647 
<a name="l00648"></a>00648 
<a name="l00649"></a>00649     
<a name="l00650"></a>00650 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00651"></a>00651 <span class="preprocessor"></span>
<a name="l00657"></a>00657   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEBase.php#a3395d0d9c15aa2ad5e246efdbffa4a45">init_base_shape_functions</a>(<span class="keyword">const</span> std::vector&lt;Point&gt;&amp; qp,
<a name="l00658"></a>00658                                          <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* e) = 0;
<a name="l00659"></a>00659 
<a name="l00660"></a>00660 <span class="preprocessor">#endif</span>
<a name="l00661"></a>00661 <span class="preprocessor"></span>
<a name="l00667"></a>00667   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEBase.php#abd044b0b177027f910216e798e4436a1">compute_map</a>(<span class="keyword">const</span> std::vector&lt;Real&gt;&amp; qw,
<a name="l00668"></a>00668                    <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* e);
<a name="l00669"></a>00669   
<a name="l00676"></a>00676   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEBase.php#ab2a635bf29b6bc9d23590c1b4152b1df">compute_affine_map</a>(<span class="keyword">const</span> std::vector&lt;Real&gt;&amp; qw,
<a name="l00677"></a>00677                    <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* e);
<a name="l00678"></a>00678 
<a name="l00683"></a>00683   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEBase.php#adba0bb8c55b1c53ac0cba7b1884180b0">compute_single_point_map</a>(<span class="keyword">const</span> std::vector&lt;Real&gt;&amp; qw,
<a name="l00684"></a>00684                                 <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* e,
<a name="l00685"></a>00685                                 <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p);
<a name="l00686"></a>00686   
<a name="l00690"></a>00690   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEBase.php#ac2f2ae3020f2bd820e84221b723fcb12">resize_map_vectors</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_qp);
<a name="l00691"></a>00691 
<a name="l00695"></a>00695   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEBase.php#ab7942827e4a09c31d046859ca822c948">compute_face_map</a>(<span class="keyword">const</span> std::vector&lt;Real&gt;&amp; qw,
<a name="l00696"></a>00696                         <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* side);
<a name="l00697"></a>00697 
<a name="l00701"></a>00701   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEBase.php#a5382d1dbc9cac70126980415cafda726">compute_edge_map</a>(<span class="keyword">const</span> std::vector&lt;Real&gt;&amp; qw,
<a name="l00702"></a>00702                         <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* side);
<a name="l00703"></a>00703 
<a name="l00714"></a>00714   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEBase.php#aec0d64ab86b8d4ffcfc90588ace98524">compute_shape_functions</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>*);
<a name="l00715"></a>00715   
<a name="l00716"></a>00716 
<a name="l00722"></a><a class="code" href="classlibMesh_1_1FEBase.php#aa173e314ea4d6da0e051aba7357393b3">00722</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1FEBase.php#aa173e314ea4d6da0e051aba7357393b3">dxdxi_map</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p)<span class="keyword"> const   </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#ad68d0a6127a9c54b3d6800ff91981523">dxyzdxi_map</a>[p](0); }
<a name="l00723"></a>00723 
<a name="l00729"></a><a class="code" href="classlibMesh_1_1FEBase.php#a70c807295d3ee32f02e8db8c064c2a69">00729</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1FEBase.php#a70c807295d3ee32f02e8db8c064c2a69">dydxi_map</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p)<span class="keyword"> const   </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#ad68d0a6127a9c54b3d6800ff91981523">dxyzdxi_map</a>[p](1); }
<a name="l00730"></a>00730 
<a name="l00736"></a><a class="code" href="classlibMesh_1_1FEBase.php#add885fcfc231cb5f1bae5fa79e26b5ed">00736</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1FEBase.php#add885fcfc231cb5f1bae5fa79e26b5ed">dzdxi_map</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p)<span class="keyword"> const   </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#ad68d0a6127a9c54b3d6800ff91981523">dxyzdxi_map</a>[p](2); }
<a name="l00737"></a>00737 
<a name="l00743"></a><a class="code" href="classlibMesh_1_1FEBase.php#adbe405374738b13bcc4237c470691994">00743</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1FEBase.php#adbe405374738b13bcc4237c470691994">dxdeta_map</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p)<span class="keyword"> const  </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#a86d96fe77ae2c9d4887431ae86686697">dxyzdeta_map</a>[p](0); }
<a name="l00744"></a>00744 
<a name="l00750"></a><a class="code" href="classlibMesh_1_1FEBase.php#aa2b58e35c68f2799aa973f54ae6bf1df">00750</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1FEBase.php#aa2b58e35c68f2799aa973f54ae6bf1df">dydeta_map</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p)<span class="keyword"> const  </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#a86d96fe77ae2c9d4887431ae86686697">dxyzdeta_map</a>[p](1); } 
<a name="l00751"></a>00751 
<a name="l00757"></a><a class="code" href="classlibMesh_1_1FEBase.php#a0afe7058842193201f4754362f3e40df">00757</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1FEBase.php#a0afe7058842193201f4754362f3e40df">dzdeta_map</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p)<span class="keyword"> const  </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#a86d96fe77ae2c9d4887431ae86686697">dxyzdeta_map</a>[p](2); }
<a name="l00758"></a>00758 
<a name="l00764"></a><a class="code" href="classlibMesh_1_1FEBase.php#a1702b8d10f490aff3a311cf68237cf58">00764</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1FEBase.php#a1702b8d10f490aff3a311cf68237cf58">dxdzeta_map</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#aa381ea7e9964780eb8cf4bad4b6fe192">dxyzdzeta_map</a>[p](0); }
<a name="l00765"></a>00765 
<a name="l00771"></a><a class="code" href="classlibMesh_1_1FEBase.php#ae1d648a326b54e268be20fd640a40eb3">00771</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1FEBase.php#ae1d648a326b54e268be20fd640a40eb3">dydzeta_map</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#aa381ea7e9964780eb8cf4bad4b6fe192">dxyzdzeta_map</a>[p](1); }
<a name="l00772"></a>00772 
<a name="l00778"></a><a class="code" href="classlibMesh_1_1FEBase.php#a10703c0c0035098e9a6e0aca97beb57c">00778</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1FEBase.php#a10703c0c0035098e9a6e0aca97beb57c">dzdzeta_map</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#aa381ea7e9964780eb8cf4bad4b6fe192">dxyzdzeta_map</a>[p](2); }
<a name="l00779"></a>00779 
<a name="l00780"></a>00780 
<a name="l00781"></a>00781 
<a name="l00782"></a>00782 
<a name="l00783"></a>00783   
<a name="l00787"></a><a class="code" href="classlibMesh_1_1FEBase.php#af0fac88fc60ae6a128fd616362680e47">00787</a>   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1FEBase.php#af0fac88fc60ae6a128fd616362680e47">dim</a>;
<a name="l00788"></a>00788 
<a name="l00792"></a><a class="code" href="classlibMesh_1_1FEBase.php#ab172fc7fa719be569a8ab67bc33755a1">00792</a>   std::vector&lt;Point&gt; <a class="code" href="classlibMesh_1_1FEBase.php#ab172fc7fa719be569a8ab67bc33755a1">xyz</a>;
<a name="l00793"></a>00793 
<a name="l00794"></a>00794 
<a name="l00795"></a>00795   
<a name="l00800"></a><a class="code" href="classlibMesh_1_1FEBase.php#ad68d0a6127a9c54b3d6800ff91981523">00800</a>   std::vector&lt;RealGradient&gt; <a class="code" href="classlibMesh_1_1FEBase.php#ad68d0a6127a9c54b3d6800ff91981523">dxyzdxi_map</a>;
<a name="l00801"></a>00801 
<a name="l00806"></a><a class="code" href="classlibMesh_1_1FEBase.php#a86d96fe77ae2c9d4887431ae86686697">00806</a>   std::vector&lt;RealGradient&gt; <a class="code" href="classlibMesh_1_1FEBase.php#a86d96fe77ae2c9d4887431ae86686697">dxyzdeta_map</a>;
<a name="l00807"></a>00807 
<a name="l00812"></a><a class="code" href="classlibMesh_1_1FEBase.php#aa381ea7e9964780eb8cf4bad4b6fe192">00812</a>   std::vector&lt;RealGradient&gt; <a class="code" href="classlibMesh_1_1FEBase.php#aa381ea7e9964780eb8cf4bad4b6fe192">dxyzdzeta_map</a>;
<a name="l00813"></a>00813   
<a name="l00818"></a><a class="code" href="classlibMesh_1_1FEBase.php#a9f0ecbf196b5e9d14edf43c7f1beca1c">00818</a>   std::vector&lt;RealGradient&gt; <a class="code" href="classlibMesh_1_1FEBase.php#a9f0ecbf196b5e9d14edf43c7f1beca1c">d2xyzdxi2_map</a>;
<a name="l00819"></a>00819 
<a name="l00824"></a><a class="code" href="classlibMesh_1_1FEBase.php#a09c2e4ca10dce4a7f565593ff527d50c">00824</a>   std::vector&lt;RealGradient&gt; <a class="code" href="classlibMesh_1_1FEBase.php#a09c2e4ca10dce4a7f565593ff527d50c">d2xyzdxideta_map</a>;
<a name="l00825"></a>00825 
<a name="l00830"></a><a class="code" href="classlibMesh_1_1FEBase.php#a68f2668617657bb1041fcf25adacb225">00830</a>   std::vector&lt;RealGradient&gt; <a class="code" href="classlibMesh_1_1FEBase.php#a68f2668617657bb1041fcf25adacb225">d2xyzdeta2_map</a>;
<a name="l00831"></a>00831 
<a name="l00832"></a>00832 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00833"></a>00833 <span class="preprocessor"></span>
<a name="l00838"></a><a class="code" href="classlibMesh_1_1FEBase.php#ac682c345ba4eff977747c26ef7e9c39d">00838</a>   std::vector&lt;RealGradient&gt; <a class="code" href="classlibMesh_1_1FEBase.php#ac682c345ba4eff977747c26ef7e9c39d">d2xyzdxidzeta_map</a>;
<a name="l00839"></a>00839 
<a name="l00844"></a><a class="code" href="classlibMesh_1_1FEBase.php#a94c958eeca969946c86b1f740a25fd33">00844</a>   std::vector&lt;RealGradient&gt; <a class="code" href="classlibMesh_1_1FEBase.php#a94c958eeca969946c86b1f740a25fd33">d2xyzdetadzeta_map</a>;
<a name="l00845"></a>00845 
<a name="l00850"></a><a class="code" href="classlibMesh_1_1FEBase.php#a15bef5c694ec90dff276ec7cce06240d">00850</a>   std::vector&lt;RealGradient&gt; <a class="code" href="classlibMesh_1_1FEBase.php#a15bef5c694ec90dff276ec7cce06240d">d2xyzdzeta2_map</a>;
<a name="l00851"></a>00851 
<a name="l00852"></a>00852 <span class="preprocessor">#endif</span>
<a name="l00853"></a>00853 <span class="preprocessor"></span>  
<a name="l00858"></a><a class="code" href="classlibMesh_1_1FEBase.php#a2bbf05f3a09e39f3580746ee0872d7dd">00858</a>   std::vector&lt;Real&gt;  <a class="code" href="classlibMesh_1_1FEBase.php#a2bbf05f3a09e39f3580746ee0872d7dd">dxidx_map</a>;
<a name="l00859"></a>00859 
<a name="l00864"></a><a class="code" href="classlibMesh_1_1FEBase.php#a33818360df704d7bffa5918c5afc8e51">00864</a>   std::vector&lt;Real&gt;  <a class="code" href="classlibMesh_1_1FEBase.php#a33818360df704d7bffa5918c5afc8e51">dxidy_map</a>;
<a name="l00865"></a>00865 
<a name="l00870"></a><a class="code" href="classlibMesh_1_1FEBase.php#a52734d3ba88b2602d385908b2170d19e">00870</a>   std::vector&lt;Real&gt;  <a class="code" href="classlibMesh_1_1FEBase.php#a52734d3ba88b2602d385908b2170d19e">dxidz_map</a>;
<a name="l00871"></a>00871 
<a name="l00872"></a>00872 
<a name="l00873"></a>00873 
<a name="l00874"></a>00874   
<a name="l00879"></a><a class="code" href="classlibMesh_1_1FEBase.php#ab292d4400894e09b1fb0c056b98d5a31">00879</a>   std::vector&lt;Real&gt;  <a class="code" href="classlibMesh_1_1FEBase.php#ab292d4400894e09b1fb0c056b98d5a31">detadx_map</a>;
<a name="l00880"></a>00880 
<a name="l00885"></a><a class="code" href="classlibMesh_1_1FEBase.php#af946c6bf8b1dd0e668744b825d3c455e">00885</a>   std::vector&lt;Real&gt;  <a class="code" href="classlibMesh_1_1FEBase.php#af946c6bf8b1dd0e668744b825d3c455e">detady_map</a>;
<a name="l00886"></a>00886 
<a name="l00891"></a><a class="code" href="classlibMesh_1_1FEBase.php#af474fdffb0815f291d7cf71563a74755">00891</a>   std::vector&lt;Real&gt;  <a class="code" href="classlibMesh_1_1FEBase.php#af474fdffb0815f291d7cf71563a74755">detadz_map</a>;
<a name="l00892"></a>00892 
<a name="l00893"></a>00893 
<a name="l00894"></a>00894 
<a name="l00895"></a>00895 
<a name="l00896"></a>00896   
<a name="l00901"></a><a class="code" href="classlibMesh_1_1FEBase.php#a9f554c5ccb1da9ca23929d524e38e009">00901</a>   std::vector&lt;Real&gt;  <a class="code" href="classlibMesh_1_1FEBase.php#a9f554c5ccb1da9ca23929d524e38e009">dzetadx_map</a>;
<a name="l00902"></a>00902 
<a name="l00907"></a><a class="code" href="classlibMesh_1_1FEBase.php#a8e6767de7f38742cadf408d467f2e944">00907</a>   std::vector&lt;Real&gt;  <a class="code" href="classlibMesh_1_1FEBase.php#a8e6767de7f38742cadf408d467f2e944">dzetady_map</a>;
<a name="l00908"></a>00908 
<a name="l00913"></a><a class="code" href="classlibMesh_1_1FEBase.php#aa6b144384c2b18bd25ee23fff52afa1b">00913</a>   std::vector&lt;Real&gt;  <a class="code" href="classlibMesh_1_1FEBase.php#aa6b144384c2b18bd25ee23fff52afa1b">dzetadz_map</a>;
<a name="l00914"></a>00914 
<a name="l00918"></a><a class="code" href="classlibMesh_1_1FEBase.php#a17a8b5dc3944c7848af1541f07ff9963">00918</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classlibMesh_1_1FEBase.php#a17a8b5dc3944c7848af1541f07ff9963">phi</a>;
<a name="l00919"></a>00919 
<a name="l00924"></a><a class="code" href="classlibMesh_1_1FEBase.php#a21086169151d3274ecfefa03039162fc">00924</a>   <span class="keyword">mutable</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1FEBase.php#a21086169151d3274ecfefa03039162fc">calculations_started</a>;
<a name="l00925"></a>00925 
<a name="l00929"></a><a class="code" href="classlibMesh_1_1FEBase.php#a5347b5c1604abaf2bf6a387eeb55f572">00929</a>   <span class="keyword">mutable</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1FEBase.php#a5347b5c1604abaf2bf6a387eeb55f572">calculate_phi</a>;
<a name="l00930"></a>00930 
<a name="l00934"></a><a class="code" href="classlibMesh_1_1FEBase.php#a3aee3c1c80c3e2934f1375247d9bb431">00934</a>   <span class="keyword">mutable</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1FEBase.php#a3aee3c1c80c3e2934f1375247d9bb431">calculate_dphi</a>;
<a name="l00935"></a>00935 
<a name="l00939"></a><a class="code" href="classlibMesh_1_1FEBase.php#a4170551fa0860822e21475e3c098bc13">00939</a>   <span class="keyword">mutable</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1FEBase.php#a4170551fa0860822e21475e3c098bc13">calculate_d2phi</a>;
<a name="l00940"></a>00940 
<a name="l00944"></a><a class="code" href="classlibMesh_1_1FEBase.php#a5d3c004bf1a96cf936cc3c5db5ab8170">00944</a>   std::vector&lt;std::vector&lt;RealGradient&gt; &gt;  <a class="code" href="classlibMesh_1_1FEBase.php#a5d3c004bf1a96cf936cc3c5db5ab8170">dphi</a>;
<a name="l00945"></a>00945 
<a name="l00949"></a><a class="code" href="classlibMesh_1_1FEBase.php#a55924631f827328b44a9f34b36ac80df">00949</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classlibMesh_1_1FEBase.php#a55924631f827328b44a9f34b36ac80df">dphidxi</a>;
<a name="l00950"></a>00950 
<a name="l00954"></a><a class="code" href="classlibMesh_1_1FEBase.php#a5418c7b62ef30ce968b09f22f9240db7">00954</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classlibMesh_1_1FEBase.php#a5418c7b62ef30ce968b09f22f9240db7">dphideta</a>;
<a name="l00955"></a>00955   
<a name="l00959"></a><a class="code" href="classlibMesh_1_1FEBase.php#a41ed461b364fb98c1c25ed6414ffc8db">00959</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classlibMesh_1_1FEBase.php#a41ed461b364fb98c1c25ed6414ffc8db">dphidzeta</a>;
<a name="l00960"></a>00960 
<a name="l00964"></a><a class="code" href="classlibMesh_1_1FEBase.php#af788235b8ba5e45b88a1faab71023511">00964</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classlibMesh_1_1FEBase.php#af788235b8ba5e45b88a1faab71023511">dphidx</a>;
<a name="l00965"></a>00965 
<a name="l00969"></a><a class="code" href="classlibMesh_1_1FEBase.php#af9dc49053521282a4b176a74df91dc0b">00969</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classlibMesh_1_1FEBase.php#af9dc49053521282a4b176a74df91dc0b">dphidy</a>;
<a name="l00970"></a>00970 
<a name="l00974"></a><a class="code" href="classlibMesh_1_1FEBase.php#aabdefc6f2e13fa5880273c269b21b362">00974</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classlibMesh_1_1FEBase.php#aabdefc6f2e13fa5880273c269b21b362">dphidz</a>;
<a name="l00975"></a>00975 
<a name="l00976"></a>00976 
<a name="l00977"></a>00977 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00978"></a>00978 <span class="preprocessor"></span>  
<a name="l00982"></a><a class="code" href="classlibMesh_1_1FEBase.php#ac30dc4874a7bf7f81ba1774e80dfc10c">00982</a>   std::vector&lt;std::vector&lt;RealTensor&gt; &gt;  <a class="code" href="classlibMesh_1_1FEBase.php#ac30dc4874a7bf7f81ba1774e80dfc10c">d2phi</a>;
<a name="l00983"></a>00983 
<a name="l00987"></a><a class="code" href="classlibMesh_1_1FEBase.php#a8015bef034bd5509122b437fc1c82100">00987</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classlibMesh_1_1FEBase.php#a8015bef034bd5509122b437fc1c82100">d2phidxi2</a>;
<a name="l00988"></a>00988 
<a name="l00992"></a><a class="code" href="classlibMesh_1_1FEBase.php#a7c5f099795f3a0a1ce4ca105ecad930a">00992</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classlibMesh_1_1FEBase.php#a7c5f099795f3a0a1ce4ca105ecad930a">d2phidxideta</a>;
<a name="l00993"></a>00993   
<a name="l00997"></a><a class="code" href="classlibMesh_1_1FEBase.php#a30eceed833b0d3bc5aaff3259f1f6f32">00997</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classlibMesh_1_1FEBase.php#a30eceed833b0d3bc5aaff3259f1f6f32">d2phidxidzeta</a>;
<a name="l00998"></a>00998 
<a name="l01002"></a><a class="code" href="classlibMesh_1_1FEBase.php#af6aac6f2d35dfdc781f73a1007cfb7cb">01002</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classlibMesh_1_1FEBase.php#af6aac6f2d35dfdc781f73a1007cfb7cb">d2phideta2</a>;
<a name="l01003"></a>01003 
<a name="l01007"></a><a class="code" href="classlibMesh_1_1FEBase.php#a4aa2fe65c1c10165df3b20d2b98ed8f5">01007</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classlibMesh_1_1FEBase.php#a4aa2fe65c1c10165df3b20d2b98ed8f5">d2phidetadzeta</a>;
<a name="l01008"></a>01008   
<a name="l01012"></a><a class="code" href="classlibMesh_1_1FEBase.php#ae2c0e416e3a48d0264958a32cf120d20">01012</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classlibMesh_1_1FEBase.php#ae2c0e416e3a48d0264958a32cf120d20">d2phidzeta2</a>;
<a name="l01013"></a>01013 
<a name="l01017"></a><a class="code" href="classlibMesh_1_1FEBase.php#ae714718de014536d22cae1025152c1bc">01017</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classlibMesh_1_1FEBase.php#ae714718de014536d22cae1025152c1bc">d2phidx2</a>;
<a name="l01018"></a>01018 
<a name="l01022"></a><a class="code" href="classlibMesh_1_1FEBase.php#aa6a1dbdf1d2b43775f970a2935c856eb">01022</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classlibMesh_1_1FEBase.php#aa6a1dbdf1d2b43775f970a2935c856eb">d2phidxdy</a>;
<a name="l01023"></a>01023 
<a name="l01027"></a><a class="code" href="classlibMesh_1_1FEBase.php#a9d886719c19dd168b673a8e4c2e0e22c">01027</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classlibMesh_1_1FEBase.php#a9d886719c19dd168b673a8e4c2e0e22c">d2phidxdz</a>;
<a name="l01028"></a>01028 
<a name="l01032"></a><a class="code" href="classlibMesh_1_1FEBase.php#a2dd94fa0428de261dccfdb1c56bbe6ff">01032</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classlibMesh_1_1FEBase.php#a2dd94fa0428de261dccfdb1c56bbe6ff">d2phidy2</a>;
<a name="l01033"></a>01033 
<a name="l01037"></a><a class="code" href="classlibMesh_1_1FEBase.php#a4062e05a6ae4409130a3e8170a6416b6">01037</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classlibMesh_1_1FEBase.php#a4062e05a6ae4409130a3e8170a6416b6">d2phidydz</a>;
<a name="l01038"></a>01038 
<a name="l01042"></a><a class="code" href="classlibMesh_1_1FEBase.php#a1f0b11a1d8784fd8eb4604a9605aa421">01042</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classlibMesh_1_1FEBase.php#a1f0b11a1d8784fd8eb4604a9605aa421">d2phidz2</a>;
<a name="l01043"></a>01043   
<a name="l01044"></a>01044 <span class="preprocessor">#endif</span>
<a name="l01045"></a>01045 <span class="preprocessor"></span>
<a name="l01046"></a>01046 
<a name="l01047"></a>01047 
<a name="l01048"></a>01048   
<a name="l01052"></a><a class="code" href="classlibMesh_1_1FEBase.php#a74a01fb9954c6644dd3e42c2dff29623">01052</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classlibMesh_1_1FEBase.php#a74a01fb9954c6644dd3e42c2dff29623">phi_map</a>;
<a name="l01053"></a>01053 
<a name="l01057"></a><a class="code" href="classlibMesh_1_1FEBase.php#a4ce4aa7d641ab7d3a38bb5be8db1fa62">01057</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classlibMesh_1_1FEBase.php#a4ce4aa7d641ab7d3a38bb5be8db1fa62">dphidxi_map</a>;
<a name="l01058"></a>01058 
<a name="l01062"></a><a class="code" href="classlibMesh_1_1FEBase.php#a7cd2ca921c422d405ac9518c91d1eebf">01062</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classlibMesh_1_1FEBase.php#a7cd2ca921c422d405ac9518c91d1eebf">dphideta_map</a>;
<a name="l01063"></a>01063 
<a name="l01067"></a><a class="code" href="classlibMesh_1_1FEBase.php#a4ee95ba576c7a780f489e80a623b59b3">01067</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classlibMesh_1_1FEBase.php#a4ee95ba576c7a780f489e80a623b59b3">dphidzeta_map</a>;
<a name="l01068"></a>01068 
<a name="l01069"></a>01069 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l01070"></a>01070 <span class="preprocessor"></span>
<a name="l01074"></a><a class="code" href="classlibMesh_1_1FEBase.php#ada94b1f5b37ea3deab82c4146cb2d0aa">01074</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classlibMesh_1_1FEBase.php#ada94b1f5b37ea3deab82c4146cb2d0aa">d2phidxi2_map</a>;
<a name="l01075"></a>01075 
<a name="l01079"></a><a class="code" href="classlibMesh_1_1FEBase.php#a568b109f25df018387061568627d03e0">01079</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classlibMesh_1_1FEBase.php#a568b109f25df018387061568627d03e0">d2phidxideta_map</a>;
<a name="l01080"></a>01080 
<a name="l01084"></a><a class="code" href="classlibMesh_1_1FEBase.php#af478144998beaa1c7465ac3434b27b4a">01084</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classlibMesh_1_1FEBase.php#af478144998beaa1c7465ac3434b27b4a">d2phidxidzeta_map</a>;
<a name="l01085"></a>01085 
<a name="l01089"></a><a class="code" href="classlibMesh_1_1FEBase.php#a0d690cfc9d95b964392128e8c3e5c9af">01089</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classlibMesh_1_1FEBase.php#a0d690cfc9d95b964392128e8c3e5c9af">d2phideta2_map</a>;
<a name="l01090"></a>01090 
<a name="l01094"></a><a class="code" href="classlibMesh_1_1FEBase.php#ad27265d343c92a7f614f44b59350a4e6">01094</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classlibMesh_1_1FEBase.php#ad27265d343c92a7f614f44b59350a4e6">d2phidetadzeta_map</a>;
<a name="l01095"></a>01095 
<a name="l01099"></a><a class="code" href="classlibMesh_1_1FEBase.php#ab705352c53f9bf0a0a48f1411448d674">01099</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classlibMesh_1_1FEBase.php#ab705352c53f9bf0a0a48f1411448d674">d2phidzeta2_map</a>;
<a name="l01100"></a>01100 
<a name="l01101"></a>01101 <span class="preprocessor">#endif</span>
<a name="l01102"></a>01102 <span class="preprocessor"></span>  
<a name="l01103"></a>01103 
<a name="l01104"></a>01104 
<a name="l01105"></a>01105 
<a name="l01106"></a>01106   
<a name="l01110"></a><a class="code" href="classlibMesh_1_1FEBase.php#aa0f7b14cfaee75c87cfdcbb82a9e11fb">01110</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classlibMesh_1_1FEBase.php#aa0f7b14cfaee75c87cfdcbb82a9e11fb">psi_map</a>;
<a name="l01111"></a>01111 
<a name="l01116"></a><a class="code" href="classlibMesh_1_1FEBase.php#abc94029585d2dfa72eb2cca7416511f4">01116</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classlibMesh_1_1FEBase.php#abc94029585d2dfa72eb2cca7416511f4">dpsidxi_map</a>;
<a name="l01117"></a>01117 
<a name="l01122"></a><a class="code" href="classlibMesh_1_1FEBase.php#a20c465fb766b38e8444823e542901952">01122</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classlibMesh_1_1FEBase.php#a20c465fb766b38e8444823e542901952">dpsideta_map</a>;
<a name="l01123"></a>01123 
<a name="l01129"></a><a class="code" href="classlibMesh_1_1FEBase.php#a20b0364af51f086b305f1054f88a904d">01129</a>   std::vector&lt;std::vector&lt;Real&gt; &gt; <a class="code" href="classlibMesh_1_1FEBase.php#a20b0364af51f086b305f1054f88a904d">d2psidxi2_map</a>;
<a name="l01130"></a>01130 
<a name="l01136"></a><a class="code" href="classlibMesh_1_1FEBase.php#a099296b4316f3597d1cebab9b727b274">01136</a>   std::vector&lt;std::vector&lt;Real&gt; &gt; <a class="code" href="classlibMesh_1_1FEBase.php#a099296b4316f3597d1cebab9b727b274">d2psidxideta_map</a>;
<a name="l01137"></a>01137 
<a name="l01143"></a><a class="code" href="classlibMesh_1_1FEBase.php#a7040dce3d91c517ec4f9ccd127021c02">01143</a>   std::vector&lt;std::vector&lt;Real&gt; &gt; <a class="code" href="classlibMesh_1_1FEBase.php#a7040dce3d91c517ec4f9ccd127021c02">d2psideta2_map</a>;
<a name="l01144"></a>01144 
<a name="l01145"></a>01145   
<a name="l01146"></a>01146 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l01147"></a>01147 <span class="preprocessor"></span>
<a name="l01148"></a>01148   <span class="comment">//--------------------------------------------------------------</span>
<a name="l01149"></a>01149   <span class="comment">/* protected members for infinite elements, which are accessed </span>
<a name="l01150"></a>01150 <span class="comment">   * from the outside through some inline functions</span>
<a name="l01151"></a>01151 <span class="comment">   */</span>
<a name="l01152"></a>01152 
<a name="l01153"></a>01153 
<a name="l01159"></a><a class="code" href="classlibMesh_1_1FEBase.php#a736b3086ae27dfdb25eea45a32d8be46">01159</a>   std::vector&lt;RealGradient&gt; <a class="code" href="classlibMesh_1_1FEBase.php#a736b3086ae27dfdb25eea45a32d8be46">dphase</a>;
<a name="l01160"></a>01160 
<a name="l01166"></a><a class="code" href="classlibMesh_1_1FEBase.php#a5e1ad40ece4ef6feb855628dd30217fa">01166</a>   std::vector&lt;RealGradient&gt; <a class="code" href="classlibMesh_1_1FEBase.php#a5e1ad40ece4ef6feb855628dd30217fa">dweight</a>;
<a name="l01167"></a>01167 
<a name="l01173"></a><a class="code" href="classlibMesh_1_1FEBase.php#a68e24d92c979f86161c991c5d9679efd">01173</a>   std::vector&lt;Real&gt;  <a class="code" href="classlibMesh_1_1FEBase.php#a68e24d92c979f86161c991c5d9679efd">weight</a>;
<a name="l01174"></a>01174 
<a name="l01175"></a>01175 <span class="preprocessor">#endif</span>
<a name="l01176"></a>01176 <span class="preprocessor"></span>
<a name="l01177"></a>01177 
<a name="l01178"></a>01178 
<a name="l01179"></a>01179   
<a name="l01183"></a><a class="code" href="classlibMesh_1_1FEBase.php#a75af7795f42767464ccf13ff1d461211">01183</a>   std::vector&lt;std::vector&lt;Point&gt; &gt;  <a class="code" href="classlibMesh_1_1FEBase.php#a75af7795f42767464ccf13ff1d461211">tangents</a>;
<a name="l01184"></a>01184 
<a name="l01188"></a><a class="code" href="classlibMesh_1_1FEBase.php#a7e59b6e942afe70db77d4270a2f22a92">01188</a>   std::vector&lt;Point&gt;                <a class="code" href="classlibMesh_1_1FEBase.php#a7e59b6e942afe70db77d4270a2f22a92">normals</a>;
<a name="l01189"></a>01189 
<a name="l01195"></a><a class="code" href="classlibMesh_1_1FEBase.php#aac9919c0f087c1439e39de79469c3620">01195</a>   std::vector&lt;Real&gt;                 <a class="code" href="classlibMesh_1_1FEBase.php#aac9919c0f087c1439e39de79469c3620">curvatures</a>;
<a name="l01196"></a>01196   
<a name="l01200"></a><a class="code" href="classlibMesh_1_1FEBase.php#ab65e73ccb67c08f9a85a67c1ab7bab5e">01200</a>   std::vector&lt;Real&gt;                 <a class="code" href="classlibMesh_1_1FEBase.php#ab65e73ccb67c08f9a85a67c1ab7bab5e">JxW</a>;
<a name="l01201"></a>01201 
<a name="l01206"></a><a class="code" href="classlibMesh_1_1FEBase.php#afee01a0935bb98ce8f670c1a86c3f68a">01206</a>   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a> <a class="code" href="classlibMesh_1_1FEBase.php#afee01a0935bb98ce8f670c1a86c3f68a">fe_type</a>;
<a name="l01207"></a>01207   
<a name="l01212"></a><a class="code" href="classlibMesh_1_1FEBase.php#a99ba1265271c4c3a26b8c71c1c35c7e6">01212</a>   <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> <a class="code" href="classlibMesh_1_1FEBase.php#a99ba1265271c4c3a26b8c71c1c35c7e6">elem_type</a>;
<a name="l01213"></a>01213 
<a name="l01218"></a><a class="code" href="classlibMesh_1_1FEBase.php#af53860e35032db7fd392c199e8d8389a">01218</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1FEBase.php#af53860e35032db7fd392c199e8d8389a">_p_level</a>;
<a name="l01219"></a>01219 
<a name="l01223"></a><a class="code" href="classlibMesh_1_1FEBase.php#abcabec825c0abb699a454176b12b1b41">01223</a>   <a class="code" href="classlibMesh_1_1QBase.php">QBase</a>* <a class="code" href="classlibMesh_1_1FEBase.php#abcabec825c0abb699a454176b12b1b41">qrule</a>;
<a name="l01224"></a>01224 
<a name="l01229"></a><a class="code" href="classlibMesh_1_1FEBase.php#a02e6dd164380fe7c60cb69ed624e1220">01229</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1FEBase.php#a02e6dd164380fe7c60cb69ed624e1220">shapes_on_quadrature</a>;
<a name="l01230"></a>01230 
<a name="l01231"></a>01231 
<a name="l01232"></a>01232 <span class="keyword">private</span>:
<a name="l01233"></a>01233 
<a name="l01240"></a>01240   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1FEBase.php#aaa07e229d5bc30aa5d7e303f89c269cd">shapes_need_reinit</a>() <span class="keyword">const</span> = 0;
<a name="l01241"></a>01241 
<a name="l01242"></a>01242 
<a name="l01243"></a>01243 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l01244"></a>01244 <span class="preprocessor"></span>
<a name="l01250"></a>01250   <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> friend_Dim, FEFamily friend_T_radial, InfMapType friend_T_map&gt;
<a name="l01251"></a><a class="code" href="classlibMesh_1_1FEBase.php#a30966325e9cd5ef7b41e45148b6919ed">01251</a>   <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1InfFE.php">InfFE</a>;
<a name="l01252"></a>01252 
<a name="l01253"></a>01253 <span class="preprocessor">#endif</span>
<a name="l01254"></a>01254 <span class="preprocessor"></span>
<a name="l01255"></a>01255 
<a name="l01256"></a>01256 };
<a name="l01257"></a>01257 
<a name="l01258"></a>01258 
<a name="l01259"></a>01259 
<a name="l01260"></a>01260 
<a name="l01261"></a>01261 <span class="comment">// ------------------------------------------------------------</span>
<a name="l01262"></a>01262 <span class="comment">// FEBase class inline members</span>
<a name="l01263"></a>01263 <span class="keyword">inline</span>
<a name="l01264"></a><a class="code" href="classlibMesh_1_1FEBase.php#a192af2af77761e6f1a4b4d078fee62be">01264</a> <a class="code" href="classlibMesh_1_1FEBase.php#a192af2af77761e6f1a4b4d078fee62be">FEBase::FEBase</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> d,
<a name="l01265"></a>01265                <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; fet) :
<a name="l01266"></a>01266   dim(d),
<a name="l01267"></a>01267   calculations_started(false),
<a name="l01268"></a>01268   calculate_phi(false),
<a name="l01269"></a>01269   calculate_dphi(false),
<a name="l01270"></a>01270   calculate_d2phi(false),
<a name="l01271"></a>01271   fe_type(fet),
<a name="l01272"></a>01272   elem_type(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4518904c8c2948ef3d2869c4cb4a2b8f">INVALID_ELEM</a>),
<a name="l01273"></a>01273   _p_level(0),
<a name="l01274"></a>01274   qrule(NULL),
<a name="l01275"></a>01275   shapes_on_quadrature(false)
<a name="l01276"></a>01276 {
<a name="l01277"></a>01277 }
<a name="l01278"></a>01278 
<a name="l01279"></a>01279 
<a name="l01280"></a>01280 
<a name="l01281"></a>01281 <span class="keyword">inline</span>
<a name="l01282"></a><a class="code" href="classlibMesh_1_1FEBase.php#a577a559c45a3f0c88bb0a9e555a90c6c">01282</a> <a class="code" href="classlibMesh_1_1FEBase.php#a577a559c45a3f0c88bb0a9e555a90c6c">FEBase::~FEBase</a>()
<a name="l01283"></a>01283 {
<a name="l01284"></a>01284 }
<a name="l01285"></a>01285 
<a name="l01286"></a>01286 } <span class="comment">// namespace libMesh</span>
<a name="l01287"></a>01287 
<a name="l01288"></a>01288 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
