<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_eaf30c8ea092d33f79a04353c3899c3f.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_1a2b14d219bf20b3bfd3aaf502c1b987.php">numerics</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">laspack_vector.h</div>  </div>
</div>
<div class="contents">
<a href="laspack__vector_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id$</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 
<a name="l00023"></a>00023 <span class="preprocessor">#ifndef __laspack_vector_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span><span class="preprocessor">#define __laspack_vector_h__</span>
<a name="l00025"></a>00025 <span class="preprocessor"></span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="preprocessor">#ifdef LIBMESH_HAVE_LASPACK</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="comment">// C++ includes</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &lt;cstdio&gt;</span> <span class="comment">// for std::sprintf</span>
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="comment">// Local includes</span>
<a name="l00039"></a>00039 <span class="preprocessor">#include &quot;<a class="code" href="numeric__vector_8h.php">numeric_vector.h</a>&quot;</span>
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 
<a name="l00044"></a>00044 <span class="preprocessor">#include &lt;qvector.h&gt;</span>
<a name="l00045"></a>00045 <span class="preprocessor">#include &lt;operats.h&gt;</span>
<a name="l00046"></a>00046 
<a name="l00047"></a>00047 <span class="keyword">namespace </span>libMesh
<a name="l00048"></a>00048 {
<a name="l00049"></a>00049 
<a name="l00050"></a>00050 
<a name="l00051"></a>00051 <span class="comment">// Forward declarations</span>
<a name="l00052"></a>00052 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span>LaspackLinearSolver;
<a name="l00053"></a>00053 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span>SparseMatrix;
<a name="l00054"></a>00054 
<a name="l00055"></a>00055 
<a name="l00063"></a>00063 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; 
<a name="l00064"></a><a class="code" href="classlibMesh_1_1LaspackVector.php">00064</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1LaspackVector.php">LaspackVector</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector</a>&lt;T&gt;
<a name="l00065"></a>00065 {
<a name="l00066"></a>00066  <span class="keyword">public</span>:
<a name="l00067"></a>00067 
<a name="l00071"></a>00071   <span class="keyword">explicit</span>
<a name="l00072"></a>00072   <a class="code" href="classlibMesh_1_1LaspackVector.php#afabcd60bc4d9ffa8dde4a914e0cec9cd">LaspackVector</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> = <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa13dc964f55aa3fba644670673652bc2e">AUTOMATIC</a>);
<a name="l00073"></a>00073   
<a name="l00077"></a>00077   <span class="keyword">explicit</span>
<a name="l00078"></a>00078   <a class="code" href="classlibMesh_1_1LaspackVector.php#afabcd60bc4d9ffa8dde4a914e0cec9cd">LaspackVector</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00079"></a>00079                  <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> = <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa13dc964f55aa3fba644670673652bc2e">AUTOMATIC</a>);
<a name="l00080"></a>00080     
<a name="l00085"></a>00085   <a class="code" href="classlibMesh_1_1LaspackVector.php#afabcd60bc4d9ffa8dde4a914e0cec9cd">LaspackVector</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00086"></a>00086                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_local,
<a name="l00087"></a>00087                  <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> = <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa13dc964f55aa3fba644670673652bc2e">AUTOMATIC</a>);
<a name="l00088"></a>00088   
<a name="l00094"></a>00094   <a class="code" href="classlibMesh_1_1LaspackVector.php#afabcd60bc4d9ffa8dde4a914e0cec9cd">LaspackVector</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N,
<a name="l00095"></a>00095                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_local,
<a name="l00096"></a>00096                  <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; ghost,
<a name="l00097"></a>00097                  <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> = <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa13dc964f55aa3fba644670673652bc2e">AUTOMATIC</a>);
<a name="l00098"></a>00098     
<a name="l00103"></a>00103   <a class="code" href="classlibMesh_1_1LaspackVector.php#a802b04caa1ca39c564b36f71994ac476">~LaspackVector</a> ();
<a name="l00104"></a>00104 
<a name="l00108"></a>00108   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LaspackVector.php#a6bea36ad03b78722739f89de66436321">close</a> (); 
<a name="l00109"></a>00109 
<a name="l00113"></a>00113   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LaspackVector.php#a622aea43d4fad4032c8d379159e5f888">clear</a> ();
<a name="l00114"></a>00114   
<a name="l00119"></a>00119   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LaspackVector.php#a6f29fe9d544b1bbbc427ce69928eb2c7">zero</a> ();    
<a name="l00120"></a>00120 
<a name="l00126"></a>00126   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;T&gt;</a> &gt; <a class="code" href="classlibMesh_1_1LaspackVector.php#aa6420af6917abca53c8af78240d2107f">zero_clone</a> () <span class="keyword">const</span>;
<a name="l00127"></a>00127 
<a name="l00131"></a>00131   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;T&gt;</a> &gt; <a class="code" href="classlibMesh_1_1LaspackVector.php#af512740cb7ad450a61d2b12e97ef3107">clone</a> () <span class="keyword">const</span>;
<a name="l00132"></a>00132   
<a name="l00146"></a>00146   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LaspackVector.php#a22d733140a82da0e5eaf37bbbad89b29">init</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N,
<a name="l00147"></a>00147              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_local,
<a name="l00148"></a>00148              <span class="keyword">const</span> <span class="keywordtype">bool</span>         fast=<span class="keyword">false</span>,
<a name="l00149"></a>00149              <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> <a class="code" href="classlibMesh_1_1NumericVector.php#a3b6bc13960a5d0022beea138c4e86dc4">type</a>=<a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa13dc964f55aa3fba644670673652bc2e">AUTOMATIC</a>);
<a name="l00150"></a>00150     
<a name="l00154"></a>00154   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LaspackVector.php#a22d733140a82da0e5eaf37bbbad89b29">init</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N,
<a name="l00155"></a>00155              <span class="keyword">const</span> <span class="keywordtype">bool</span>         fast=<span class="keyword">false</span>,
<a name="l00156"></a>00156              <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> <a class="code" href="classlibMesh_1_1NumericVector.php#a3b6bc13960a5d0022beea138c4e86dc4">type</a>=<a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa13dc964f55aa3fba644670673652bc2e">AUTOMATIC</a>);
<a name="l00157"></a>00157     
<a name="l00162"></a>00162   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LaspackVector.php#a22d733140a82da0e5eaf37bbbad89b29">init</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <span class="comment">/*N*/</span>,
<a name="l00163"></a>00163              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <span class="comment">/*n_local*/</span>,
<a name="l00164"></a>00164              <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; <span class="comment">/*ghost*/</span>,
<a name="l00165"></a>00165              <span class="keyword">const</span> <span class="keywordtype">bool</span> <span class="comment">/*fast*/</span> = <span class="keyword">false</span>,
<a name="l00166"></a>00166              <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> = <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa13dc964f55aa3fba644670673652bc2e">AUTOMATIC</a>);
<a name="l00167"></a>00167 
<a name="l00172"></a>00172   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LaspackVector.php#a22d733140a82da0e5eaf37bbbad89b29">init</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; other,
<a name="l00173"></a>00173                      <span class="keyword">const</span> <span class="keywordtype">bool</span> fast = <span class="keyword">false</span>);
<a name="l00174"></a>00174     
<a name="l00178"></a>00178   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp; <a class="code" href="classlibMesh_1_1LaspackVector.php#a5b4647ebc33d010ef6f10e38d30ca18f">operator= </a>(<span class="keyword">const</span> T s);
<a name="l00179"></a>00179     
<a name="l00183"></a>00183   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp; <a class="code" href="classlibMesh_1_1LaspackVector.php#a5b4647ebc33d010ef6f10e38d30ca18f">operator= </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp;V);
<a name="l00184"></a>00184   
<a name="l00188"></a>00188   <a class="code" href="classlibMesh_1_1LaspackVector.php">LaspackVector&lt;T&gt;</a> &amp; <a class="code" href="classlibMesh_1_1LaspackVector.php#a5b4647ebc33d010ef6f10e38d30ca18f">operator= </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1LaspackVector.php">LaspackVector&lt;T&gt;</a> &amp;V);
<a name="l00189"></a>00189 
<a name="l00193"></a>00193   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp; <a class="code" href="classlibMesh_1_1LaspackVector.php#a5b4647ebc33d010ef6f10e38d30ca18f">operator= </a>(<span class="keyword">const</span> std::vector&lt;T&gt; &amp;v);
<a name="l00194"></a>00194 
<a name="l00200"></a>00200   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1LaspackVector.php#a9cb1ea8c887c62e9e74d150548cf2998">min</a> () <span class="keyword">const</span>;
<a name="l00201"></a>00201   
<a name="l00207"></a>00207   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1LaspackVector.php#a916d953c9c086fab573f55c2e795ee3a">max</a> () <span class="keyword">const</span>;
<a name="l00208"></a>00208   
<a name="l00212"></a>00212   T <a class="code" href="classlibMesh_1_1LaspackVector.php#a2844ed35c0bdbcb7b186643f28642bb6">sum</a> () <span class="keyword">const</span>; 
<a name="l00213"></a>00213 
<a name="l00218"></a>00218   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1LaspackVector.php#a3d9ababc006523e6281049f1012e3142">l1_norm</a> () <span class="keyword">const</span>;
<a name="l00219"></a>00219 
<a name="l00225"></a>00225   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1LaspackVector.php#afbe684bcc60e28d4d4877e67f52c8827">l2_norm</a> () <span class="keyword">const</span>;
<a name="l00226"></a>00226 
<a name="l00232"></a>00232   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1LaspackVector.php#a2d2a328f49e370990131ef76488384a9">linfty_norm</a> () <span class="keyword">const</span>;
<a name="l00233"></a>00233 
<a name="l00241"></a>00241   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1LaspackVector.php#a16818eaac051881a87730496cbb51d2d">size</a> () <span class="keyword">const</span>;
<a name="l00242"></a>00242 
<a name="l00247"></a>00247   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1LaspackVector.php#ae44d844be34b8617debc706e2460976a">local_size</a>() <span class="keyword">const</span>;
<a name="l00248"></a>00248 
<a name="l00253"></a>00253   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1LaspackVector.php#a58aa18db6abc2f75529bffb5829520bd">first_local_index</a>() <span class="keyword">const</span>;
<a name="l00254"></a>00254 
<a name="l00259"></a>00259   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1LaspackVector.php#a51a51cb8f4d09d66eeac10838ad616b7">last_local_index</a>() <span class="keyword">const</span>;
<a name="l00260"></a>00260     
<a name="l00264"></a>00264   T <a class="code" href="classlibMesh_1_1LaspackVector.php#ab1b7b8dcc1f3f23981e521c4849cd07a">operator() </a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00265"></a>00265     
<a name="l00270"></a>00270   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp; <a class="code" href="classlibMesh_1_1LaspackVector.php#a74a07f8ee5bde5d4e2de57c209f4e9c1">operator += </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp;V);
<a name="l00271"></a>00271 
<a name="l00276"></a>00276   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp; <a class="code" href="classlibMesh_1_1LaspackVector.php#aafa446669afcb48086bd1d66de2c1e02">operator -= </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp;V);
<a name="l00277"></a>00277     
<a name="l00281"></a>00281   <span class="keywordtype">void</span> <span class="keyword">set</span> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i, <span class="keyword">const</span> T value);
<a name="l00282"></a>00282     
<a name="l00286"></a>00286   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LaspackVector.php#af592bfcb95ac2c4d4ed838b53cd4d85b">add</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i, <span class="keyword">const</span> T value);
<a name="l00287"></a>00287     
<a name="l00293"></a>00293   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LaspackVector.php#af592bfcb95ac2c4d4ed838b53cd4d85b">add</a> (<span class="keyword">const</span> T s);
<a name="l00294"></a>00294     
<a name="l00300"></a>00300   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LaspackVector.php#af592bfcb95ac2c4d4ed838b53cd4d85b">add</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; V);
<a name="l00301"></a>00301 
<a name="l00307"></a>00307   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LaspackVector.php#af592bfcb95ac2c4d4ed838b53cd4d85b">add</a> (<span class="keyword">const</span> T a, <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; v);
<a name="l00308"></a>00308   
<a name="l00314"></a>00314   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LaspackVector.php#a44c85caff4b677fd91f26875f4f24c5f">add_vector</a> (<span class="keyword">const</span> std::vector&lt;T&gt;&amp; v,
<a name="l00315"></a>00315                    <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices);
<a name="l00316"></a>00316 
<a name="l00323"></a>00323   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LaspackVector.php#a44c85caff4b677fd91f26875f4f24c5f">add_vector</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; V,
<a name="l00324"></a>00324                    <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices);
<a name="l00325"></a>00325  
<a name="l00330"></a>00330   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LaspackVector.php#a44c85caff4b677fd91f26875f4f24c5f">add_vector</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp;,
<a name="l00331"></a>00331                    <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;T&gt;</a> &amp;);
<a name="l00332"></a>00332       
<a name="l00339"></a>00339   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LaspackVector.php#a44c85caff4b677fd91f26875f4f24c5f">add_vector</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T&gt;</a>&amp; V,
<a name="l00340"></a>00340                    <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices);
<a name="l00341"></a>00341   
<a name="l00346"></a>00346   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LaspackVector.php#a845600858cd7eaff4d57cf2dfdde6ee4">insert</a> (<span class="keyword">const</span> std::vector&lt;T&gt;&amp; v,
<a name="l00347"></a>00347                        <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices);
<a name="l00348"></a>00348 
<a name="l00355"></a>00355   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LaspackVector.php#a845600858cd7eaff4d57cf2dfdde6ee4">insert</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; V,
<a name="l00356"></a>00356                        <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices);
<a name="l00357"></a>00357       
<a name="l00363"></a>00363   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LaspackVector.php#a845600858cd7eaff4d57cf2dfdde6ee4">insert</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T&gt;</a>&amp; V,
<a name="l00364"></a>00364                        <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices);
<a name="l00365"></a>00365   
<a name="l00371"></a>00371   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LaspackVector.php#a845600858cd7eaff4d57cf2dfdde6ee4">insert</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseSubVector.php">DenseSubVector&lt;T&gt;</a>&amp; V,
<a name="l00372"></a>00372                        <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices);
<a name="l00373"></a>00373   
<a name="l00378"></a>00378   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LaspackVector.php#a941759ff0417c321a2b923cf8ce515c3">scale</a> (<span class="keyword">const</span> T factor);
<a name="l00379"></a>00379 
<a name="l00384"></a>00384   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LaspackVector.php#aa85a4f80f71a924874ca97035f0c1871">abs</a>();
<a name="l00385"></a>00385 
<a name="l00389"></a>00389   <span class="keyword">virtual</span> T <a class="code" href="classlibMesh_1_1LaspackVector.php#a266c47943c73c1b8d7443bf4bbf15f84">dot</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; V) <span class="keyword">const</span>;
<a name="l00390"></a>00390 
<a name="l00395"></a>00395   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LaspackVector.php#af62ffbe8e6d6db31fa435729d517f125">localize</a> (std::vector&lt;T&gt;&amp; v_local) <span class="keyword">const</span>;
<a name="l00396"></a>00396 
<a name="l00401"></a>00401   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LaspackVector.php#af62ffbe8e6d6db31fa435729d517f125">localize</a> (<a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; v_local) <span class="keyword">const</span>;
<a name="l00402"></a>00402 
<a name="l00408"></a>00408   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LaspackVector.php#af62ffbe8e6d6db31fa435729d517f125">localize</a> (<a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; v_local,
<a name="l00409"></a>00409                  <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; send_list) <span class="keyword">const</span>;
<a name="l00410"></a>00410     
<a name="l00415"></a>00415   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LaspackVector.php#af62ffbe8e6d6db31fa435729d517f125">localize</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> first_local_idx,
<a name="l00416"></a>00416                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> last_local_idx,
<a name="l00417"></a>00417                  <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; send_list);
<a name="l00418"></a>00418 
<a name="l00419"></a>00419   
<a name="l00426"></a>00426   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LaspackVector.php#ae4616ceb29f0804ca1070f29338c2ebe">localize_to_one</a> (std::vector&lt;T&gt;&amp; v_local,
<a name="l00427"></a>00427                         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id=0) <span class="keyword">const</span>;
<a name="l00428"></a>00428     
<a name="l00433"></a>00433   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LaspackVector.php#ac73f389f54ce899f77fc757b407a9825">pointwise_mult</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; vec1,
<a name="l00434"></a>00434                                <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; vec2);
<a name="l00435"></a>00435 
<a name="l00439"></a>00439   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LaspackVector.php#a7934b6011c1d40b4d09316a6a599a63f">swap</a> (<a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp;v);
<a name="l00440"></a>00440 
<a name="l00441"></a>00441  <span class="keyword">private</span>:
<a name="l00442"></a>00442 
<a name="l00447"></a><a class="code" href="classlibMesh_1_1LaspackVector.php#a14bd0f053f3c627cbf2eca452886ed6f">00447</a>   QVector <a class="code" href="classlibMesh_1_1LaspackVector.php#a14bd0f053f3c627cbf2eca452886ed6f">_vec</a>;
<a name="l00448"></a>00448 
<a name="l00452"></a><a class="code" href="classlibMesh_1_1LaspackVector.php#a0be0354b510b1eba31ee700b6a44408b">00452</a>   <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1LaspackLinearSolver.php">LaspackLinearSolver</a>&lt;T&gt;;
<a name="l00453"></a>00453 };
<a name="l00454"></a>00454 
<a name="l00455"></a>00455 
<a name="l00456"></a>00456 
<a name="l00457"></a>00457 <span class="comment">//----------------------- ----------------------------------</span>
<a name="l00458"></a>00458 <span class="comment">// LaspackVector inline methods</span>
<a name="l00459"></a>00459 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00460"></a>00460 <span class="keyword">inline</span>
<a name="l00461"></a><a class="code" href="classlibMesh_1_1LaspackVector.php#afabcd60bc4d9ffa8dde4a914e0cec9cd">00461</a> <a class="code" href="classlibMesh_1_1LaspackVector.php#afabcd60bc4d9ffa8dde4a914e0cec9cd">LaspackVector&lt;T&gt;::LaspackVector</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> type)
<a name="l00462"></a>00462 {
<a name="l00463"></a>00463   this-&gt;_type = type;
<a name="l00464"></a>00464 }
<a name="l00465"></a>00465 
<a name="l00466"></a>00466 
<a name="l00467"></a>00467 
<a name="l00468"></a>00468 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; 
<a name="l00469"></a>00469 <span class="keyword">inline</span>
<a name="l00470"></a><a class="code" href="classlibMesh_1_1LaspackVector.php#a0bd355fb13f1344f0b3a30fe6d15df21">00470</a> <a class="code" href="classlibMesh_1_1LaspackVector.php#afabcd60bc4d9ffa8dde4a914e0cec9cd">LaspackVector&lt;T&gt;::LaspackVector</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00471"></a>00471                                  <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> type)
<a name="l00472"></a>00472 {
<a name="l00473"></a>00473   this-&gt;<a class="code" href="namespacelibMesh.php#a74975b21077cce916d7b3e22ad49290c">init</a>(n, n, <span class="keyword">false</span>, type);
<a name="l00474"></a>00474 }
<a name="l00475"></a>00475 
<a name="l00476"></a>00476 
<a name="l00477"></a>00477 
<a name="l00478"></a>00478 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; 
<a name="l00479"></a>00479 <span class="keyword">inline</span>
<a name="l00480"></a><a class="code" href="classlibMesh_1_1LaspackVector.php#a9545b13531a22123fb9efc582657e54f">00480</a> <a class="code" href="classlibMesh_1_1LaspackVector.php#afabcd60bc4d9ffa8dde4a914e0cec9cd">LaspackVector&lt;T&gt;::LaspackVector</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00481"></a>00481                                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_local,
<a name="l00482"></a>00482                                  <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> type)
<a name="l00483"></a>00483 {
<a name="l00484"></a>00484   this-&gt;<a class="code" href="namespacelibMesh.php#a74975b21077cce916d7b3e22ad49290c">init</a>(n, n_local, <span class="keyword">false</span>, type);
<a name="l00485"></a>00485 }
<a name="l00486"></a>00486 
<a name="l00487"></a>00487 
<a name="l00488"></a>00488 
<a name="l00489"></a>00489 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; 
<a name="l00490"></a>00490 <span class="keyword">inline</span>
<a name="l00491"></a><a class="code" href="classlibMesh_1_1LaspackVector.php#afe0ff1cab5754a71e22c15ed7c7da7dd">00491</a> <a class="code" href="classlibMesh_1_1LaspackVector.php#afabcd60bc4d9ffa8dde4a914e0cec9cd">LaspackVector&lt;T&gt;::LaspackVector</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N,
<a name="l00492"></a>00492                                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_local,
<a name="l00493"></a>00493                                  <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; ghost,
<a name="l00494"></a>00494                                  <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> type)
<a name="l00495"></a>00495 {
<a name="l00496"></a>00496   this-&gt;<a class="code" href="namespacelibMesh.php#a74975b21077cce916d7b3e22ad49290c">init</a>(N, n_local, ghost, <span class="keyword">false</span>, type);
<a name="l00497"></a>00497 }
<a name="l00498"></a>00498 
<a name="l00499"></a>00499 
<a name="l00500"></a>00500 
<a name="l00501"></a>00501 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; 
<a name="l00502"></a>00502 <span class="keyword">inline</span>
<a name="l00503"></a><a class="code" href="classlibMesh_1_1LaspackVector.php#a802b04caa1ca39c564b36f71994ac476">00503</a> <a class="code" href="classlibMesh_1_1LaspackVector.php#a802b04caa1ca39c564b36f71994ac476">LaspackVector&lt;T&gt;::~LaspackVector</a> ()
<a name="l00504"></a>00504 {
<a name="l00505"></a>00505   this-&gt;clear ();
<a name="l00506"></a>00506 }
<a name="l00507"></a>00507 
<a name="l00508"></a>00508 
<a name="l00509"></a>00509 
<a name="l00510"></a>00510 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; 
<a name="l00511"></a>00511 <span class="keyword">inline</span>
<a name="l00512"></a><a class="code" href="classlibMesh_1_1LaspackVector.php#a22d733140a82da0e5eaf37bbbad89b29">00512</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LaspackVector.php#a22d733140a82da0e5eaf37bbbad89b29">LaspackVector&lt;T&gt;::init</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00513"></a>00513                              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_local,
<a name="l00514"></a>00514                              <span class="keyword">const</span> <span class="keywordtype">bool</span> fast,
<a name="l00515"></a>00515                              <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a>)
<a name="l00516"></a>00516 {
<a name="l00517"></a>00517   <span class="comment">// Laspack vectors only for serial cases,</span>
<a name="l00518"></a>00518   <span class="comment">// but can provide a &quot;parallel&quot; vector on one processor.</span>
<a name="l00519"></a>00519   libmesh_assert (n == n_local);
<a name="l00520"></a>00520 
<a name="l00521"></a>00521   this-&gt;_type = <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa333690ccec0379e5dd4ccb60db5ea0c9">SERIAL</a>;
<a name="l00522"></a>00522 
<a name="l00523"></a>00523   <span class="comment">// Clear initialized vectors</span>
<a name="l00524"></a>00524   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>())
<a name="l00525"></a>00525     this-&gt;clear();
<a name="l00526"></a>00526 
<a name="l00527"></a>00527   <span class="comment">// create a sequential vector</span>
<a name="l00528"></a>00528 
<a name="l00529"></a>00529   <span class="keyword">static</span> <span class="keywordtype">int</span> cnt = 0;
<a name="l00530"></a>00530   <span class="keywordtype">char</span> foo[80];
<a name="l00531"></a>00531   std::sprintf(foo,  <span class="stringliteral">&quot;Vec-%d&quot;</span>, cnt++); 
<a name="l00532"></a>00532 
<a name="l00533"></a>00533   V_Constr(&amp;_vec, const_cast&lt;char*&gt;(foo), n, Normal, _LPTrue);
<a name="l00534"></a>00534     
<a name="l00535"></a>00535   this-&gt;<a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#ab8b7115ea57ced35ec86d1fdfa0ab853">_is_initialized</a> = <span class="keyword">true</span>;
<a name="l00536"></a>00536   
<a name="l00537"></a>00537   <span class="comment">// Optionally zero out all components</span>
<a name="l00538"></a>00538   <span class="keywordflow">if</span> (fast == <span class="keyword">false</span>)
<a name="l00539"></a>00539     this-&gt;<a class="code" href="namespacelibMesh.php#a7384a2e49f01ab6e656cae298da85146">zero</a> ();
<a name="l00540"></a>00540   
<a name="l00541"></a>00541   <span class="keywordflow">return</span>;
<a name="l00542"></a>00542 }
<a name="l00543"></a>00543 
<a name="l00544"></a>00544 
<a name="l00545"></a>00545 
<a name="l00546"></a>00546 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; 
<a name="l00547"></a>00547 <span class="keyword">inline</span>
<a name="l00548"></a><a class="code" href="classlibMesh_1_1LaspackVector.php#a086cce0b7d8818610b5a68f6287d3c54">00548</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LaspackVector.php#a22d733140a82da0e5eaf37bbbad89b29">LaspackVector&lt;T&gt;::init</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00549"></a>00549                              <span class="keyword">const</span> <span class="keywordtype">bool</span> fast,
<a name="l00550"></a>00550                              <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> type)
<a name="l00551"></a>00551 {
<a name="l00552"></a>00552   this-&gt;<a class="code" href="namespacelibMesh.php#a74975b21077cce916d7b3e22ad49290c">init</a>(n,n,fast,type);
<a name="l00553"></a>00553 }
<a name="l00554"></a>00554 
<a name="l00555"></a>00555 
<a name="l00556"></a>00556 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; 
<a name="l00557"></a>00557 <span class="keyword">inline</span>
<a name="l00558"></a><a class="code" href="classlibMesh_1_1LaspackVector.php#aa7c4cb99a58c79700eb31da66efc3731">00558</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LaspackVector.php#a22d733140a82da0e5eaf37bbbad89b29">LaspackVector&lt;T&gt;::init</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00559"></a>00559                              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_local,
<a name="l00560"></a>00560                              <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; ghost,
<a name="l00561"></a>00561                              <span class="keyword">const</span> <span class="keywordtype">bool</span> fast,
<a name="l00562"></a>00562                              <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> type)
<a name="l00563"></a>00563 {
<a name="l00564"></a>00564   libmesh_assert(ghost.empty());
<a name="l00565"></a>00565   this-&gt;<a class="code" href="namespacelibMesh.php#a74975b21077cce916d7b3e22ad49290c">init</a>(n,n_local,fast,type);
<a name="l00566"></a>00566 }
<a name="l00567"></a>00567 
<a name="l00568"></a>00568 
<a name="l00569"></a>00569 
<a name="l00570"></a>00570 <span class="comment">/* Default implementation for solver packages for which ghosted</span>
<a name="l00571"></a>00571 <span class="comment">   vectors are not yet implemented.  */</span>
<a name="l00572"></a>00572 <span class="keyword">template</span> &lt;<span class="keyword">class</span> T&gt;
<a name="l00573"></a><a class="code" href="classlibMesh_1_1LaspackVector.php#afa0f938f7973543c94e090f23153c7cf">00573</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LaspackVector.php#a22d733140a82da0e5eaf37bbbad89b29">LaspackVector&lt;T&gt;::init</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; other,
<a name="l00574"></a>00574                              <span class="keyword">const</span> <span class="keywordtype">bool</span> fast)
<a name="l00575"></a>00575 {
<a name="l00576"></a>00576   this-&gt;<a class="code" href="namespacelibMesh.php#a74975b21077cce916d7b3e22ad49290c">init</a>(other.<a class="code" href="classlibMesh_1_1NumericVector.php#a86082d6030cb32700e7eeac6e7f26455">size</a>(),other.<a class="code" href="classlibMesh_1_1NumericVector.php#a6cc4358896c079e301a815a4ff4459eb">local_size</a>(),fast,other.<a class="code" href="classlibMesh_1_1NumericVector.php#a3b6bc13960a5d0022beea138c4e86dc4">type</a>());
<a name="l00577"></a>00577 }
<a name="l00578"></a>00578 
<a name="l00579"></a>00579 
<a name="l00580"></a>00580 
<a name="l00581"></a>00581 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; 
<a name="l00582"></a>00582 <span class="keyword">inline</span>
<a name="l00583"></a><a class="code" href="classlibMesh_1_1LaspackVector.php#a6bea36ad03b78722739f89de66436321">00583</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LaspackVector.php#a6bea36ad03b78722739f89de66436321">LaspackVector&lt;T&gt;::close</a> ()
<a name="l00584"></a>00584 {
<a name="l00585"></a>00585   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00586"></a>00586   
<a name="l00587"></a>00587   this-&gt;_is_closed = <span class="keyword">true</span>;
<a name="l00588"></a>00588 }
<a name="l00589"></a>00589 
<a name="l00590"></a>00590 
<a name="l00591"></a>00591 
<a name="l00592"></a>00592 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; 
<a name="l00593"></a>00593 <span class="keyword">inline</span>
<a name="l00594"></a><a class="code" href="classlibMesh_1_1LaspackVector.php#a622aea43d4fad4032c8d379159e5f888">00594</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LaspackVector.php#a622aea43d4fad4032c8d379159e5f888">LaspackVector&lt;T&gt;::clear</a> ()
<a name="l00595"></a>00595 {
<a name="l00596"></a>00596   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>())
<a name="l00597"></a>00597     {
<a name="l00598"></a>00598       V_Destr (&amp;_vec);
<a name="l00599"></a>00599     }
<a name="l00600"></a>00600 
<a name="l00601"></a>00601   this-&gt;_is_closed = this-&gt;<a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#ab8b7115ea57ced35ec86d1fdfa0ab853">_is_initialized</a> = <span class="keyword">false</span>;
<a name="l00602"></a>00602 }
<a name="l00603"></a>00603 
<a name="l00604"></a>00604 
<a name="l00605"></a>00605 
<a name="l00606"></a>00606 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">inline</span>
<a name="l00607"></a><a class="code" href="classlibMesh_1_1LaspackVector.php#a6f29fe9d544b1bbbc427ce69928eb2c7">00607</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LaspackVector.php#a6f29fe9d544b1bbbc427ce69928eb2c7">LaspackVector&lt;T&gt;::zero</a> ()
<a name="l00608"></a>00608 {
<a name="l00609"></a>00609   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00610"></a>00610 
<a name="l00611"></a>00611   V_SetAllCmp (&amp;_vec, 0.);
<a name="l00612"></a>00612 }
<a name="l00613"></a>00613 
<a name="l00614"></a>00614 
<a name="l00615"></a>00615 
<a name="l00616"></a>00616 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00617"></a>00617 <span class="keyword">inline</span>
<a name="l00618"></a><a class="code" href="classlibMesh_1_1LaspackVector.php#aa6420af6917abca53c8af78240d2107f">00618</a> <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;T&gt;</a> &gt; <a class="code" href="classlibMesh_1_1LaspackVector.php#aa6420af6917abca53c8af78240d2107f">LaspackVector&lt;T&gt;::zero_clone</a> ()<span class="keyword"> const</span>
<a name="l00619"></a>00619 <span class="keyword"></span>{
<a name="l00620"></a>00620   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;T&gt;</a> &gt; cloned_vector (<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1LaspackVector.php">LaspackVector&lt;T&gt;</a>);
<a name="l00621"></a>00621 
<a name="l00622"></a>00622   cloned_vector-&gt;init(*<span class="keyword">this</span>);
<a name="l00623"></a>00623 
<a name="l00624"></a>00624   <span class="keywordflow">return</span> cloned_vector;
<a name="l00625"></a>00625 }
<a name="l00626"></a>00626 
<a name="l00627"></a>00627 
<a name="l00628"></a>00628 
<a name="l00629"></a>00629 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00630"></a>00630 <span class="keyword">inline</span>
<a name="l00631"></a><a class="code" href="classlibMesh_1_1LaspackVector.php#af512740cb7ad450a61d2b12e97ef3107">00631</a> <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;T&gt;</a> &gt; <a class="code" href="classlibMesh_1_1LaspackVector.php#af512740cb7ad450a61d2b12e97ef3107">LaspackVector&lt;T&gt;::clone</a> ()<span class="keyword"> const</span>
<a name="l00632"></a>00632 <span class="keyword"></span>{
<a name="l00633"></a>00633   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;T&gt;</a> &gt; cloned_vector (<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1LaspackVector.php">LaspackVector&lt;T&gt;</a>);
<a name="l00634"></a>00634 
<a name="l00635"></a>00635   cloned_vector-&gt;init(*<span class="keyword">this</span>, <span class="keyword">true</span>);
<a name="l00636"></a>00636 
<a name="l00637"></a>00637   *cloned_vector = *<span class="keyword">this</span>;
<a name="l00638"></a>00638 
<a name="l00639"></a>00639   <span class="keywordflow">return</span> cloned_vector;
<a name="l00640"></a>00640 }
<a name="l00641"></a>00641 
<a name="l00642"></a>00642 
<a name="l00643"></a>00643 
<a name="l00644"></a>00644 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; 
<a name="l00645"></a>00645 <span class="keyword">inline</span>
<a name="l00646"></a><a class="code" href="classlibMesh_1_1LaspackVector.php#a16818eaac051881a87730496cbb51d2d">00646</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1LaspackVector.php#a16818eaac051881a87730496cbb51d2d">LaspackVector&lt;T&gt;::size</a> ()<span class="keyword"> const</span>
<a name="l00647"></a>00647 <span class="keyword"></span>{
<a name="l00648"></a>00648   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00649"></a>00649 
<a name="l00650"></a>00650   <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(V_GetDim(const_cast&lt;QVector*&gt;(&amp;_vec)));
<a name="l00651"></a>00651 }
<a name="l00652"></a>00652 
<a name="l00653"></a>00653 
<a name="l00654"></a>00654 
<a name="l00655"></a>00655 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; 
<a name="l00656"></a>00656 <span class="keyword">inline</span>
<a name="l00657"></a><a class="code" href="classlibMesh_1_1LaspackVector.php#ae44d844be34b8617debc706e2460976a">00657</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1LaspackVector.php#ae44d844be34b8617debc706e2460976a">LaspackVector&lt;T&gt;::local_size</a> ()<span class="keyword"> const</span>
<a name="l00658"></a>00658 <span class="keyword"></span>{
<a name="l00659"></a>00659   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00660"></a>00660   
<a name="l00661"></a>00661   <span class="keywordflow">return</span> this-&gt;size();
<a name="l00662"></a>00662 }
<a name="l00663"></a>00663 
<a name="l00664"></a>00664 
<a name="l00665"></a>00665 
<a name="l00666"></a>00666 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; 
<a name="l00667"></a>00667 <span class="keyword">inline</span>
<a name="l00668"></a><a class="code" href="classlibMesh_1_1LaspackVector.php#a58aa18db6abc2f75529bffb5829520bd">00668</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1LaspackVector.php#a58aa18db6abc2f75529bffb5829520bd">LaspackVector&lt;T&gt;::first_local_index</a> ()<span class="keyword"> const</span>
<a name="l00669"></a>00669 <span class="keyword"></span>{
<a name="l00670"></a>00670   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00671"></a>00671   
<a name="l00672"></a>00672   <span class="keywordflow">return</span> 0;
<a name="l00673"></a>00673 }
<a name="l00674"></a>00674 
<a name="l00675"></a>00675 
<a name="l00676"></a>00676 
<a name="l00677"></a>00677 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; 
<a name="l00678"></a>00678 <span class="keyword">inline</span>
<a name="l00679"></a><a class="code" href="classlibMesh_1_1LaspackVector.php#a51a51cb8f4d09d66eeac10838ad616b7">00679</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1LaspackVector.php#a51a51cb8f4d09d66eeac10838ad616b7">LaspackVector&lt;T&gt;::last_local_index</a> ()<span class="keyword"> const</span>
<a name="l00680"></a>00680 <span class="keyword"></span>{
<a name="l00681"></a>00681   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00682"></a>00682   
<a name="l00683"></a>00683   <span class="keywordflow">return</span> this-&gt;size();
<a name="l00684"></a>00684 }
<a name="l00685"></a>00685 
<a name="l00686"></a>00686 
<a name="l00687"></a>00687 
<a name="l00688"></a>00688 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; 
<a name="l00689"></a>00689 <span class="keyword">inline</span>
<a name="l00690"></a><a class="code" href="classlibMesh_1_1LaspackVector.php#a1ee29ae1c7244b0edf46d0d4b525ca87">00690</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LaspackVector.php#a1ee29ae1c7244b0edf46d0d4b525ca87">LaspackVector&lt;T&gt;::set</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i, <span class="keyword">const</span> T value)
<a name="l00691"></a>00691 {
<a name="l00692"></a>00692   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00693"></a>00693   libmesh_assert (i &lt; this-&gt;size());
<a name="l00694"></a>00694   
<a name="l00695"></a>00695   V_SetCmp (&amp;_vec, i+1, value);
<a name="l00696"></a>00696 }
<a name="l00697"></a>00697 
<a name="l00698"></a>00698 
<a name="l00699"></a>00699 
<a name="l00700"></a>00700 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; 
<a name="l00701"></a>00701 <span class="keyword">inline</span>
<a name="l00702"></a><a class="code" href="classlibMesh_1_1LaspackVector.php#af592bfcb95ac2c4d4ed838b53cd4d85b">00702</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LaspackVector.php#af592bfcb95ac2c4d4ed838b53cd4d85b">LaspackVector&lt;T&gt;::add</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i, <span class="keyword">const</span> T value)
<a name="l00703"></a>00703 {
<a name="l00704"></a>00704   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00705"></a>00705   libmesh_assert (i &lt; this-&gt;size());
<a name="l00706"></a>00706   
<a name="l00707"></a>00707   V_AddCmp (&amp;_vec, i+1, value);
<a name="l00708"></a>00708 }
<a name="l00709"></a>00709 
<a name="l00710"></a>00710 
<a name="l00711"></a>00711 
<a name="l00712"></a>00712 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; 
<a name="l00713"></a>00713 <span class="keyword">inline</span>
<a name="l00714"></a><a class="code" href="classlibMesh_1_1LaspackVector.php#ab1b7b8dcc1f3f23981e521c4849cd07a">00714</a> T <a class="code" href="classlibMesh_1_1LaspackVector.php#ab1b7b8dcc1f3f23981e521c4849cd07a">LaspackVector&lt;T&gt;::operator() </a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00715"></a>00715 <span class="keyword"></span>{
<a name="l00716"></a>00716   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00717"></a>00717   libmesh_assert ( ((i &gt;= this-&gt;first_local_index()) &amp;&amp;
<a name="l00718"></a>00718             (i &lt;  this-&gt;last_local_index())) );
<a name="l00719"></a>00719 
<a name="l00720"></a>00720   
<a name="l00721"></a>00721   <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span>T<span class="keyword">&gt;</span>(V_GetCmp(const_cast&lt;QVector*&gt;(&amp;_vec), i+1));
<a name="l00722"></a>00722 }
<a name="l00723"></a>00723 
<a name="l00724"></a>00724 
<a name="l00725"></a>00725 
<a name="l00726"></a>00726 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00727"></a>00727 <span class="keyword">inline</span>
<a name="l00728"></a><a class="code" href="classlibMesh_1_1LaspackVector.php#a7934b6011c1d40b4d09316a6a599a63f">00728</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LaspackVector.php#a7934b6011c1d40b4d09316a6a599a63f">LaspackVector&lt;T&gt;::swap</a> (<a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp;other)
<a name="l00729"></a>00729 {
<a name="l00730"></a>00730   <a class="code" href="classlibMesh_1_1LaspackVector.php">LaspackVector&lt;T&gt;</a>&amp; v = libmesh_cast_ref&lt;LaspackVector&lt;T&gt;&amp;&gt;(other);
<a name="l00731"></a>00731 
<a name="l00732"></a>00732   <span class="comment">// This is all grossly dependent on Laspack version...</span>
<a name="l00733"></a>00733 
<a name="l00734"></a>00734   std::swap(_vec.Name, v.<a class="code" href="classlibMesh_1_1LaspackVector.php#a14bd0f053f3c627cbf2eca452886ed6f">_vec</a>.Name);
<a name="l00735"></a>00735   std::swap(_vec.Dim, v.<a class="code" href="classlibMesh_1_1LaspackVector.php#a14bd0f053f3c627cbf2eca452886ed6f">_vec</a>.Dim);
<a name="l00736"></a>00736   std::swap(_vec.Instance, v.<a class="code" href="classlibMesh_1_1LaspackVector.php#a14bd0f053f3c627cbf2eca452886ed6f">_vec</a>.Instance);
<a name="l00737"></a>00737   std::swap(_vec.LockLevel, v.<a class="code" href="classlibMesh_1_1LaspackVector.php#a14bd0f053f3c627cbf2eca452886ed6f">_vec</a>.LockLevel);
<a name="l00738"></a>00738   std::swap(_vec.Multipl, v.<a class="code" href="classlibMesh_1_1LaspackVector.php#a14bd0f053f3c627cbf2eca452886ed6f">_vec</a>.Multipl);
<a name="l00739"></a>00739   std::swap(_vec.OwnData, v.<a class="code" href="classlibMesh_1_1LaspackVector.php#a14bd0f053f3c627cbf2eca452886ed6f">_vec</a>.OwnData);
<a name="l00740"></a>00740 
<a name="l00741"></a>00741   <span class="comment">// This should still be O(1), since _vec.Cmp is just a pointer to</span>
<a name="l00742"></a>00742   <span class="comment">// data on the heap</span>
<a name="l00743"></a>00743 
<a name="l00744"></a>00744   std::swap(_vec.Cmp, v.<a class="code" href="classlibMesh_1_1LaspackVector.php#a14bd0f053f3c627cbf2eca452886ed6f">_vec</a>.Cmp);
<a name="l00745"></a>00745 }
<a name="l00746"></a>00746 
<a name="l00747"></a>00747 
<a name="l00748"></a>00748 } <span class="comment">// namespace libMesh</span>
<a name="l00749"></a>00749 
<a name="l00750"></a>00750 
<a name="l00751"></a>00751 <span class="preprocessor">#endif // #ifdef LIBMESH_HAVE_LASPACK</span>
<a name="l00752"></a>00752 <span class="preprocessor"></span><span class="preprocessor">#endif // #ifdef __laspack_vector_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
