<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_c3a49989e40b21e7508f29d2dc962def.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_06ddb1cadc4da963b880c5e33d5e51d4.php">base</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">libmesh.C</div>  </div>
</div>
<div class="contents">
<a href="libmesh_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id$</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020  
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// C++ includes</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &lt;iostream&gt;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &lt;fstream&gt;</span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// Local includes</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="libmesh_8h.php">libmesh.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="auto__ptr_8h.php">auto_ptr.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="getpot_8h.php">getpot.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="parallel_8h.php">parallel.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="reference__counter_8h.php">reference_counter.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="remote__elem_8h.php">remote_elem.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="threads_8h.php">threads.h</a>&quot;</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="preprocessor">#if defined(LIBMESH_HAVE_MPI)</span>
<a name="l00038"></a>00038 <span class="preprocessor"></span><span class="preprocessor"># include &lt;mpi.h&gt;</span>
<a name="l00039"></a>00039 <span class="preprocessor">#endif // #if defined(LIBMESH_HAVE_MPI)</span>
<a name="l00040"></a>00040 <span class="preprocessor"></span>
<a name="l00041"></a>00041 <span class="preprocessor">#if defined(LIBMESH_HAVE_PETSC)</span>
<a name="l00042"></a>00042 <span class="preprocessor"></span><span class="preprocessor"># include &quot;<a class="code" href="petsc__macro_8h.php">petsc_macro.h</a>&quot;</span>
<a name="l00043"></a>00043 EXTERN_C_FOR_PETSC_BEGIN
<a name="l00044"></a>00044 <span class="preprocessor"># include &lt;petsc.h&gt;</span>
<a name="l00045"></a>00045 <span class="preprocessor"># include &lt;petscerror.h&gt;</span>
<a name="l00046"></a>00046 EXTERN_C_FOR_PETSC_END
<a name="l00047"></a>00047 <span class="preprocessor"># if defined(LIBMESH_HAVE_SLEPC)</span>
<a name="l00048"></a>00048 <span class="preprocessor"></span><span class="preprocessor">#  include &quot;<a class="code" href="slepc__macro_8h.php">slepc_macro.h</a>&quot;</span>
<a name="l00049"></a>00049 EXTERN_C_FOR_PETSC_BEGIN
<a name="l00050"></a>00050 <span class="preprocessor">#  include &lt;slepc.h&gt;</span>
<a name="l00051"></a>00051 EXTERN_C_FOR_PETSC_END
<a name="l00052"></a>00052 <span class="preprocessor"># endif // #if defined(LIBMESH_HAVE_SLEPC)</span>
<a name="l00053"></a>00053 <span class="preprocessor"></span><span class="preprocessor">#endif // #if defined(LIBMESH_HAVE_PETSC)</span>
<a name="l00054"></a>00054 <span class="preprocessor"></span>
<a name="l00055"></a>00055 
<a name="l00056"></a>00056 <span class="comment">// --------------------------------------------------------</span>
<a name="l00057"></a>00057 <span class="comment">// Local anonymous namespace to hold miscelaneous variables</span>
<a name="l00058"></a><a class="code" href="namespaceEXTERN__C__FOR__PETSC__END.php">00058</a> <span class="keyword">namespace </span>{
<a name="l00059"></a>00059 
<a name="l00060"></a>00060   <span class="keyword">using</span> <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">libMesh::AutoPtr</a>;
<a name="l00061"></a>00061 
<a name="l00062"></a>00062   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;GetPot&gt;</a> <a class="code" href="namespaceEXTERN__C__FOR__PETSC__END.php#aeb0594fd92da9edcd479f0736177e5c4">command_line</a> (NULL);
<a name="l00063"></a>00063   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;std::ofstream&gt;</a> <a class="code" href="namespaceEXTERN__C__FOR__PETSC__END.php#abef0573f7a973208f7c638bfc4f5690a">_ofstream</a> (NULL);
<a name="l00064"></a>00064   <span class="comment">// If std::cout and std::cerr are redirected, we need to</span>
<a name="l00065"></a>00065   <span class="comment">// be a little careful and save the original streambuf objects,</span>
<a name="l00066"></a>00066   <span class="comment">// replacing them in the destructor before program termination.</span>
<a name="l00067"></a>00067   std::streambuf* <a class="code" href="namespaceEXTERN__C__FOR__PETSC__END.php#a73b9e9115727ed61f12e3431338c1081">out_buf</a> (NULL);
<a name="l00068"></a>00068   std::streambuf* <a class="code" href="namespaceEXTERN__C__FOR__PETSC__END.php#ae5f13c94da9876ea690637d111f898a9">err_buf</a> (NULL);
<a name="l00069"></a>00069   
<a name="l00070"></a>00070   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;libMesh::Threads::task_scheduler_init&gt;</a> <a class="code" href="namespaceEXTERN__C__FOR__PETSC__END.php#ae853219c3e97c670cca0de67ca182fac">task_scheduler</a> (NULL);
<a name="l00071"></a>00071 <span class="preprocessor">#if defined(LIBMESH_HAVE_MPI)</span>
<a name="l00072"></a><a class="code" href="namespaceEXTERN__C__FOR__PETSC__END.php#ae8bedac09a6ae6f5dcc1a02090de63de">00072</a> <span class="preprocessor"></span>  <span class="keywordtype">bool</span> <a class="code" href="namespaceEXTERN__C__FOR__PETSC__END.php#ae8bedac09a6ae6f5dcc1a02090de63de">libmesh_initialized_mpi</a> = <span class="keyword">false</span>;
<a name="l00073"></a>00073 <span class="preprocessor">#endif</span>
<a name="l00074"></a>00074 <span class="preprocessor"></span><span class="preprocessor">#if defined(LIBMESH_HAVE_PETSC)</span>
<a name="l00075"></a><a class="code" href="namespaceEXTERN__C__FOR__PETSC__END.php#a0052b0ad841d7589360fb4f0bdc73e70">00075</a> <span class="preprocessor"></span>  <span class="keywordtype">bool</span> <a class="code" href="namespaceEXTERN__C__FOR__PETSC__END.php#a0052b0ad841d7589360fb4f0bdc73e70">libmesh_initialized_petsc</a> = <span class="keyword">false</span>;
<a name="l00076"></a>00076 <span class="preprocessor">#endif</span>
<a name="l00077"></a>00077 <span class="preprocessor"></span><span class="preprocessor">#if defined(LIBMESH_HAVE_SLEPC)</span>
<a name="l00078"></a><a class="code" href="namespaceEXTERN__C__FOR__PETSC__END.php#a0f83fc1317cca54d7154dfbf4e998f01">00078</a> <span class="preprocessor"></span>  <span class="keywordtype">bool</span> <a class="code" href="namespaceEXTERN__C__FOR__PETSC__END.php#a0f83fc1317cca54d7154dfbf4e998f01">libmesh_initialized_slepc</a> = <span class="keyword">false</span>;
<a name="l00079"></a>00079 <span class="preprocessor">#endif</span>
<a name="l00080"></a>00080 <span class="preprocessor"></span>}
<a name="l00081"></a>00081 
<a name="l00082"></a>00082 
<a name="l00083"></a>00083 <span class="keyword">namespace </span>libMesh
<a name="l00084"></a>00084 {
<a name="l00085"></a>00085 
<a name="l00093"></a><a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php">00093</a>   <span class="keyword">namespace </span>libMeshPrivateData {
<a name="l00094"></a>00094     
<a name="l00098"></a>00098     <span class="keyword">extern</span> <span class="keywordtype">bool</span> <a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#ab8b7115ea57ced35ec86d1fdfa0ab853">_is_initialized</a>;
<a name="l00099"></a>00099     
<a name="l00103"></a>00103     <span class="keyword">extern</span> <a class="code" href="namespacelibMeshEnums.php#a2785fa3c3529ebe4c62dc593b12b65d8">SolverPackage</a> <a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#a5595417b69d598a65c439048450f6d02">_solver_package</a>;
<a name="l00104"></a>00104   }
<a name="l00105"></a>00105 
<a name="l00106"></a>00106 
<a name="l00107"></a>00107 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00108"></a>00108 <span class="comment">// libMeshdata initialization</span>
<a name="l00109"></a>00109 <span class="preprocessor">#ifdef LIBMESH_HAVE_MPI</span>
<a name="l00110"></a><a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">00110</a> <span class="preprocessor"></span>MPI_Comm           <a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">COMM_WORLD</a> = MPI_COMM_NULL;
<a name="l00111"></a>00111 <span class="preprocessor">#else</span>
<a name="l00112"></a>00112 <span class="preprocessor"></span><span class="keywordtype">int</span>                <a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">COMM_WORLD</a> = 0;
<a name="l00113"></a>00113 <span class="preprocessor">#endif</span>
<a name="l00114"></a>00114 <span class="preprocessor"></span>
<a name="l00115"></a><a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">00115</a> <a class="code" href="classlibMesh_1_1BasicOStreamProxy.php">OStreamProxy</a> <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">out</a> = std::cout;
<a name="l00116"></a><a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">00116</a> <a class="code" href="classlibMesh_1_1BasicOStreamProxy.php">OStreamProxy</a> <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">err</a> = std::cerr;
<a name="l00117"></a>00117 
<a name="l00118"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#a0177ff6d177a879cc6d29e2f95694c91">00118</a> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php">Parallel::Communicator</a> <a class="code" href="namespacelibMesh_1_1Parallel.php#a0177ff6d177a879cc6d29e2f95694c91">Parallel::Communicator_World</a>;
<a name="l00119"></a>00119 
<a name="l00120"></a>00120 <a class="code" href="classlibMesh_1_1PerfLog.php">PerfLog</a>            <a class="code" href="namespacelibMesh.php#a898fabb4e2a583bf30bf4bd46f4c032d">perflog</a> (<span class="stringliteral">&quot;libMesh&quot;</span>,
<a name="l00121"></a>00121 #ifdef LIBMESH_ENABLE_PERFORMANCE_LOGGING
<a name="l00122"></a>00122                                      <span class="keyword">true</span>
<a name="l00123"></a>00123 #<span class="keywordflow">else</span>
<a name="l00124"></a>00124                                      <span class="keyword">false</span>
<a name="l00125"></a>00125 #endif
<a name="l00126"></a>00126                                      );
<a name="l00127"></a>00127 
<a name="l00128"></a>00128 
<a name="l00129"></a><a class="code" href="namespacelibMesh.php#a668b057121e7cf9d0c35207b7ab6bf38">00129</a> <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>         <a class="code" href="namespacelibMesh.php#a668b057121e7cf9d0c35207b7ab6bf38">pi</a> = 3.1415926535897932384626433832795029L;
<a name="l00130"></a>00130 
<a name="l00131"></a>00131 <span class="preprocessor">#ifdef LIBMESH_USE_COMPLEX_NUMBERS</span>
<a name="l00132"></a>00132 <span class="preprocessor"></span><span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a>       <a class="code" href="namespacelibMesh.php#aa2cea1b0dff98dcda202f98174e7135d">imaginary</a> (0., 1.);
<a name="l00133"></a>00133 <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a>       <a class="code" href="namespacelibMesh.php#a7384a2e49f01ab6e656cae298da85146">zero</a>      (0., 0.);
<a name="l00134"></a>00134 <span class="preprocessor">#else</span>
<a name="l00135"></a><a class="code" href="namespacelibMesh.php#a7384a2e49f01ab6e656cae298da85146">00135</a> <span class="preprocessor"></span><span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a>       <a class="code" href="namespacelibMesh.php#a7384a2e49f01ab6e656cae298da85146">zero</a> = 0.;
<a name="l00136"></a>00136 <span class="preprocessor">#endif</span>
<a name="l00137"></a>00137 <span class="preprocessor"></span>
<a name="l00138"></a><a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">00138</a> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">invalid_uint</a> = <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(-1);
<a name="l00139"></a>00139 
<a name="l00140"></a>00140 
<a name="l00141"></a>00141 
<a name="l00142"></a>00142 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00143"></a>00143 <span class="comment">// libMesh::libMeshPrivateData data initialization</span>
<a name="l00144"></a>00144 <span class="preprocessor">#ifdef LIBMESH_HAVE_MPI</span>
<a name="l00145"></a><a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#a00c96622b595157ea8b8008b725e8bb8">00145</a> <span class="preprocessor"></span><span class="keywordtype">int</span>           <a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#a00c96622b595157ea8b8008b725e8bb8">libMesh::libMeshPrivateData::_n_processors</a> = 1;
<a name="l00146"></a><a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#a6a7e7a746767771468fcc0c6e165edfc">00146</a> <span class="keywordtype">int</span>           <a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#a6a7e7a746767771468fcc0c6e165edfc">libMesh::libMeshPrivateData::_processor_id</a> = 0;
<a name="l00147"></a>00147 <span class="preprocessor">#endif</span>
<a name="l00148"></a><a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#abb33d60acc5132dd768659948ebd279a">00148</a> <span class="preprocessor"></span><span class="keywordtype">int</span>           <a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#abb33d60acc5132dd768659948ebd279a">libMesh::libMeshPrivateData::_n_threads</a> = 1; <span class="comment">/* Threads::task_scheduler_init::automatic; */</span>
<a name="l00149"></a><a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#ab8b7115ea57ced35ec86d1fdfa0ab853">00149</a> <span class="keywordtype">bool</span>          <a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#ab8b7115ea57ced35ec86d1fdfa0ab853">libMesh::libMeshPrivateData::_is_initialized</a> = <span class="keyword">false</span>;
<a name="l00150"></a><a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#a5595417b69d598a65c439048450f6d02">00150</a> <a class="code" href="namespacelibMeshEnums.php#a2785fa3c3529ebe4c62dc593b12b65d8">SolverPackage</a> <a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#a5595417b69d598a65c439048450f6d02">libMesh::libMeshPrivateData::_solver_package</a> =
<a name="l00151"></a>00151 <span class="preprocessor">#if   defined(LIBMESH_HAVE_PETSC)    // PETSc is the default</span>
<a name="l00152"></a>00152 <span class="preprocessor"></span>                                                       <a class="code" href="namespacelibMeshEnums.php#a2785fa3c3529ebe4c62dc593b12b65d8a4bb6e669bd80e3d232092e60df464572">PETSC_SOLVERS</a>;
<a name="l00153"></a>00153 <span class="preprocessor">#elif defined(LIBMESH_HAVE_TRILINOS) // Use Trilinos if PETSc isn&#39;t there</span>
<a name="l00154"></a><a class="code" href="namespacelibMesh.php#aa27e267f495ee0599f7cd8981c0cf7ad">00154</a> <span class="preprocessor"></span>                                                       <a class="code" href="namespacelibMesh.php#aa27e267f495ee0599f7cd8981c0cf7ad">TRILINOS_SOLVERS</a>;
<a name="l00155"></a>00155 <span class="preprocessor">#elif defined(LIBMESH_HAVE_LASPACK)  // Use LASPACK if neither are there</span>
<a name="l00156"></a><a class="code" href="namespacelibMesh.php#aeb2a777af969e03421c99c4afe9d68a0">00156</a> <span class="preprocessor"></span>                                                       <a class="code" href="namespacelibMesh.php#aeb2a777af969e03421c99c4afe9d68a0">LASPACK_SOLVERS</a>;
<a name="l00157"></a>00157 <span class="preprocessor">#else                        // No valid linear solver package at compile time</span>
<a name="l00158"></a><a class="code" href="namespacelibMesh.php#afc934dba6c6bb935bdd1a6788be67614">00158</a> <span class="preprocessor"></span>                                                       <a class="code" href="namespacelibMesh.php#afc934dba6c6bb935bdd1a6788be67614">INVALID_SOLVER_PACKAGE</a>;
<a name="l00159"></a>00159 <span class="preprocessor">#endif</span>
<a name="l00160"></a>00160 <span class="preprocessor"></span>
<a name="l00161"></a>00161 
<a name="l00162"></a>00162 
<a name="l00163"></a>00163 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00164"></a>00164 <span class="comment">// libMesh functions</span>
<a name="l00165"></a>00165 
<a name="l00166"></a><a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">00166</a> <span class="keywordtype">bool</span> <a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>()
<a name="l00167"></a>00167 {
<a name="l00168"></a>00168   <span class="keywordflow">return</span> <a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#ab8b7115ea57ced35ec86d1fdfa0ab853">libMeshPrivateData::_is_initialized</a>;
<a name="l00169"></a>00169 }
<a name="l00170"></a>00170 
<a name="l00171"></a>00171 
<a name="l00172"></a>00172 
<a name="l00173"></a><a class="code" href="namespacelibMesh.php#a3dc0a134260371bd023e0d0f632399e1">00173</a> <span class="keywordtype">bool</span> <a class="code" href="namespacelibMesh.php#a3dc0a134260371bd023e0d0f632399e1">closed</a>()
<a name="l00174"></a>00174 {
<a name="l00175"></a>00175   <span class="keywordflow">return</span> !<a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#ab8b7115ea57ced35ec86d1fdfa0ab853">libMeshPrivateData::_is_initialized</a>;
<a name="l00176"></a>00176 }
<a name="l00177"></a>00177 
<a name="l00178"></a>00178 
<a name="l00179"></a>00179 
<a name="l00180"></a>00180 <span class="preprocessor">#ifndef LIBMESH_HAVE_MPI</span>
<a name="l00181"></a>00181 <span class="preprocessor"></span><span class="keywordtype">void</span> <a class="code" href="namespacelibMesh.php#aad6fecb8ebe53b4daffa683eaa02d4dc">_init</a> (<span class="keywordtype">int</span> &amp;argc, <span class="keywordtype">char</span>** &amp; <a class="code" href="namespacelibMesh.php#a417881714cb540579a186977f22143a2">argv</a>)
<a name="l00182"></a>00182 <span class="preprocessor">#else</span>
<a name="l00183"></a><a class="code" href="namespacelibMesh.php#a417881714cb540579a186977f22143a2">00183</a> <span class="preprocessor"></span><span class="keywordtype">void</span> <a class="code" href="namespacelibMesh.php#aad6fecb8ebe53b4daffa683eaa02d4dc">_init</a> (<span class="keywordtype">int</span> &amp;argc, <span class="keywordtype">char</span>** &amp; argv,
<a name="l00184"></a>00184             MPI_Comm COMM_WORLD_IN)
<a name="l00185"></a>00185 <span class="preprocessor">#endif</span>
<a name="l00186"></a>00186 <span class="preprocessor"></span>{
<a name="l00187"></a>00187   <span class="comment">// should _not_ be initialized already.</span>
<a name="l00188"></a>00188   libmesh_assert (!<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">libMesh::initialized</a>());
<a name="l00189"></a>00189   
<a name="l00190"></a>00190   <span class="comment">// Build a command-line parser.</span>
<a name="l00191"></a>00191   <a class="code" href="namespaceEXTERN__C__FOR__PETSC__END.php#aeb0594fd92da9edcd479f0736177e5c4">command_line</a>.reset (<span class="keyword">new</span> GetPot (argc, argv));
<a name="l00192"></a>00192 
<a name="l00193"></a>00193   <span class="comment">// Disable performance logging upon request</span>
<a name="l00194"></a>00194   {
<a name="l00195"></a>00195     <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#ad19739ed0fdd45f048901a13954369b6">libMesh::on_command_line</a> (<span class="stringliteral">&quot;--disable-perflog&quot;</span>))
<a name="l00196"></a>00196       <a class="code" href="namespacelibMesh.php#a898fabb4e2a583bf30bf4bd46f4c032d">libMesh::perflog</a>.<a class="code" href="classlibMesh_1_1PerfLog.php#a306ad61e6df5f6380cf60541b2cd343d">disable_logging</a>();
<a name="l00197"></a>00197   }
<a name="l00198"></a>00198 
<a name="l00199"></a>00199   <span class="comment">// Build a task scheduler</span>
<a name="l00200"></a>00200   {
<a name="l00201"></a>00201     <span class="comment">// Get the requested number of threads, defaults to 1 to avoid MPI and </span>
<a name="l00202"></a>00202     <span class="comment">// multithreading competition.  If you would like to use MPI and multithreading </span>
<a name="l00203"></a>00203     <span class="comment">// at the same time then (n_mpi_processes_per_node)x(n_threads) should be the</span>
<a name="l00204"></a>00204     <span class="comment">//  number of processing cores per node.</span>
<a name="l00205"></a>00205     <a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#abb33d60acc5132dd768659948ebd279a">libMesh::libMeshPrivateData::_n_threads</a> = 
<a name="l00206"></a>00206       <a class="code" href="namespacelibMesh.php#a7cbd0ce3d26eb45284882fed440b2a09">libMesh::command_line_value</a> (<span class="stringliteral">&quot;--n_threads&quot;</span>, 1);
<a name="l00207"></a>00207 
<a name="l00208"></a>00208     <a class="code" href="namespaceEXTERN__C__FOR__PETSC__END.php#ae853219c3e97c670cca0de67ca182fac">task_scheduler</a>.reset (<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Threads_1_1task__scheduler__init.php">Threads::task_scheduler_init</a>(<a class="code" href="namespacelibMesh.php#afde701cff110e1ff2b158298c06a7d1d">libMesh::n_threads</a>()));
<a name="l00209"></a>00209   }
<a name="l00210"></a>00210 
<a name="l00211"></a>00211   <span class="comment">// Construct singletons who may be at risk of the</span>
<a name="l00212"></a>00212   <span class="comment">// &quot;static initialization order fiasco&quot;</span>
<a name="l00213"></a>00213   <span class="comment">//</span>
<a name="l00214"></a>00214   <span class="comment">// RemoteElem depends on static reference counting data</span>
<a name="l00215"></a>00215   <a class="code" href="namespacelibMesh.php#a903992f631b52b5ba05ad96a51e7b383">remote_elem</a> = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1RemoteElem.php">RemoteElem</a>();
<a name="l00216"></a>00216 
<a name="l00217"></a>00217 <span class="preprocessor">#if defined(LIBMESH_HAVE_MPI)</span>
<a name="l00218"></a>00218 <span class="preprocessor"></span>
<a name="l00219"></a>00219   <span class="comment">// Allow the user to bypass MPI initialization</span>
<a name="l00220"></a>00220   <span class="keywordflow">if</span> (!<a class="code" href="namespacelibMesh.php#ad19739ed0fdd45f048901a13954369b6">libMesh::on_command_line</a> (<span class="stringliteral">&quot;--disable-mpi&quot;</span>))
<a name="l00221"></a>00221     {
<a name="l00222"></a>00222       <span class="comment">// Check whether the calling program has already initialized</span>
<a name="l00223"></a>00223       <span class="comment">// MPI, and avoid duplicate Init/Finalize</span>
<a name="l00224"></a>00224       <span class="keywordtype">int</span> flag;
<a name="l00225"></a>00225       MPI_Initialized (&amp;flag);
<a name="l00226"></a>00226 
<a name="l00227"></a>00227       <span class="keywordflow">if</span> (!flag)
<a name="l00228"></a>00228         {
<a name="l00229"></a>00229           MPI_Init (&amp;argc, &amp;argv);
<a name="l00230"></a>00230           <a class="code" href="namespaceEXTERN__C__FOR__PETSC__END.php#ae8bedac09a6ae6f5dcc1a02090de63de">libmesh_initialized_mpi</a> = <span class="keyword">true</span>;
<a name="l00231"></a>00231         }
<a name="l00232"></a>00232       
<a name="l00233"></a>00233       <span class="comment">// Duplicate the input communicator for internal use</span>
<a name="l00234"></a>00234       MPI_Comm_dup (COMM_WORLD_IN, &amp;<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>);
<a name="l00235"></a>00235 
<a name="l00236"></a>00236       <span class="comment">// And get a Parallel::Communicator copy too, to use</span>
<a name="l00237"></a>00237       <span class="comment">// as a default for that API</span>
<a name="l00238"></a>00238       <a class="code" href="namespacelibMesh_1_1Parallel.php#a0177ff6d177a879cc6d29e2f95694c91">Parallel::Communicator_World</a> = COMM_WORLD_IN;
<a name="l00239"></a>00239 
<a name="l00240"></a>00240       <span class="comment">//MPI_Comm_set_name not supported in at least SGI MPT&#39;s MPI implementation</span>
<a name="l00241"></a>00241       <span class="comment">//MPI_Comm_set_name (libMesh::COMM_WORLD, &quot;libMesh::COMM_WORLD&quot;);</span>
<a name="l00242"></a>00242       
<a name="l00243"></a>00243       <a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#a6a7e7a746767771468fcc0c6e165edfc">libMeshPrivateData::_processor_id</a> = <a class="code" href="namespacelibMesh_1_1Parallel.php#a0177ff6d177a879cc6d29e2f95694c91">Parallel::Communicator_World</a>.rank();
<a name="l00244"></a>00244       <a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#a00c96622b595157ea8b8008b725e8bb8">libMeshPrivateData::_n_processors</a> = <a class="code" href="namespacelibMesh_1_1Parallel.php#a0177ff6d177a879cc6d29e2f95694c91">Parallel::Communicator_World</a>.size();
<a name="l00245"></a>00245     }
<a name="l00246"></a>00246 
<a name="l00247"></a>00247   <span class="comment">// Could we have gotten bad values from the above calls?</span>
<a name="l00248"></a>00248   libmesh_assert (<a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#a00c96622b595157ea8b8008b725e8bb8">libMeshPrivateData::_n_processors</a> &gt;  0);
<a name="l00249"></a>00249   libmesh_assert (<a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#a6a7e7a746767771468fcc0c6e165edfc">libMeshPrivateData::_processor_id</a> &gt;= 0);
<a name="l00250"></a>00250 
<a name="l00251"></a>00251 <span class="preprocessor">#endif</span>
<a name="l00252"></a>00252 <span class="preprocessor"></span>      
<a name="l00253"></a>00253 <span class="preprocessor">#if defined(LIBMESH_HAVE_PETSC)</span>
<a name="l00254"></a>00254 <span class="preprocessor"></span>      
<a name="l00255"></a>00255   <span class="comment">// Allow the user to bypass PETSc initialization</span>
<a name="l00256"></a>00256   <span class="keywordflow">if</span> (!<a class="code" href="namespacelibMesh.php#ad19739ed0fdd45f048901a13954369b6">libMesh::on_command_line</a> (<span class="stringliteral">&quot;--disable-petsc&quot;</span>)
<a name="l00257"></a>00257 
<a name="l00258"></a>00258 #<span class="keywordflow">if</span> defined(LIBMESH_HAVE_MPI)
<a name="l00259"></a>00259   <span class="comment">// If the user bypassed MPI, we&#39;d better be safe and assume that</span>
<a name="l00260"></a>00260   <span class="comment">// PETSc was built to require it; otherwise PETSc initialization</span>
<a name="l00261"></a>00261   <span class="comment">// dies.</span>
<a name="l00262"></a>00262       &amp;&amp; !<a class="code" href="namespacelibMesh.php#ad19739ed0fdd45f048901a13954369b6">libMesh::on_command_line</a> (<span class="stringliteral">&quot;--disable-mpi&quot;</span>)
<a name="l00263"></a>00263 #endif
<a name="l00264"></a>00264      )
<a name="l00265"></a>00265     {
<a name="l00266"></a>00266       <span class="keywordtype">int</span> ierr=0;
<a name="l00267"></a>00267           
<a name="l00268"></a>00268       PETSC_COMM_WORLD = <a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>;
<a name="l00269"></a>00269 
<a name="l00270"></a>00270       <span class="comment">// Check whether the calling program has already initialized</span>
<a name="l00271"></a>00271       <span class="comment">// PETSc, and avoid duplicate Initialize/Finalize</span>
<a name="l00272"></a>00272       <a class="code" href="petsc__macro_8h.php#a118393cd7c42d4cc73950defd0e32873">PetscBool</a> petsc_already_initialized;
<a name="l00273"></a>00273       ierr = PetscInitialized(&amp;petsc_already_initialized);
<a name="l00274"></a>00274              CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00275"></a>00275       <span class="keywordflow">if</span> (petsc_already_initialized != PETSC_TRUE)
<a name="l00276"></a>00276         <a class="code" href="namespaceEXTERN__C__FOR__PETSC__END.php#a0052b0ad841d7589360fb4f0bdc73e70">libmesh_initialized_petsc</a> = <span class="keyword">true</span>;
<a name="l00277"></a>00277 <span class="preprocessor"># if defined(LIBMESH_HAVE_SLEPC)</span>
<a name="l00278"></a>00278 <span class="preprocessor"></span>
<a name="l00279"></a>00279       <span class="comment">// If SLEPc allows us to check whether the calling program</span>
<a name="l00280"></a>00280       <span class="comment">// has already initialized it, we do that, and avoid</span>
<a name="l00281"></a>00281       <span class="comment">// duplicate Initialize/Finalize.</span>
<a name="l00282"></a>00282       <span class="comment">// We assume that SLEPc will handle PETSc appropriately,</span>
<a name="l00283"></a>00283       <span class="comment">// which it does in the versions we&#39;ve checked.</span>
<a name="l00284"></a>00284 <span class="preprocessor">#  if !SLEPC_VERSION_LESS_THAN(2,3,3)</span>
<a name="l00285"></a>00285 <span class="preprocessor"></span>      <span class="keywordflow">if</span> (!SlepcInitializeCalled)
<a name="l00286"></a>00286 <span class="preprocessor">#  endif</span>
<a name="l00287"></a>00287 <span class="preprocessor"></span>        {
<a name="l00288"></a>00288           ierr = SlepcInitialize  (&amp;argc, &amp;argv, NULL, NULL);
<a name="l00289"></a>00289                  CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00290"></a>00290           <a class="code" href="namespaceEXTERN__C__FOR__PETSC__END.php#a0f83fc1317cca54d7154dfbf4e998f01">libmesh_initialized_slepc</a> = <span class="keyword">true</span>;
<a name="l00291"></a>00291         }
<a name="l00292"></a>00292 <span class="preprocessor"># else</span>
<a name="l00293"></a>00293 <span class="preprocessor"></span>      <span class="keywordflow">if</span> (<a class="code" href="namespaceEXTERN__C__FOR__PETSC__END.php#a0052b0ad841d7589360fb4f0bdc73e70">libmesh_initialized_petsc</a>)
<a name="l00294"></a>00294         {
<a name="l00295"></a>00295           ierr = PetscInitialize (&amp;argc, &amp;argv, NULL, NULL);
<a name="l00296"></a>00296                  CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00297"></a>00297         }
<a name="l00298"></a>00298 <span class="preprocessor"># endif</span>
<a name="l00299"></a>00299 <span class="preprocessor"></span>    }
<a name="l00300"></a>00300 <span class="preprocessor">#endif</span>
<a name="l00301"></a>00301 <span class="preprocessor"></span>
<a name="l00302"></a>00302   <span class="comment">// Re-parse the command-line arguments.  Note that PETSc and MPI</span>
<a name="l00303"></a>00303   <span class="comment">// initialization above may have removed command line arguments</span>
<a name="l00304"></a>00304   <span class="comment">// that are not relevant to this application in the above calls.</span>
<a name="l00305"></a>00305   <span class="comment">// We don&#39;t want a false-positive by detecting those arguments.</span>
<a name="l00306"></a>00306   <a class="code" href="namespaceEXTERN__C__FOR__PETSC__END.php#aeb0594fd92da9edcd479f0736177e5c4">command_line</a>-&gt;parse_command_line (argc, argv);
<a name="l00307"></a>00307 
<a name="l00308"></a>00308   <span class="comment">// The following line is an optimization when simultaneous</span>
<a name="l00309"></a>00309   <span class="comment">// C and C++ style access to output streams is not required.</span>
<a name="l00310"></a>00310   <span class="comment">// The amount of benefit which occurs is probably implementation</span>
<a name="l00311"></a>00311   <span class="comment">// defined, and may be nothing.  On the other hand, I have seen</span>
<a name="l00312"></a>00312   <span class="comment">// some IO tests where IO peformance improves by a factor of two.</span>
<a name="l00313"></a>00313   <span class="keywordflow">if</span> (!<a class="code" href="namespacelibMesh.php#ad19739ed0fdd45f048901a13954369b6">libMesh::on_command_line</a> (<span class="stringliteral">&quot;--sync-with-stdio&quot;</span>))
<a name="l00314"></a>00314     std::ios::sync_with_stdio(<span class="keyword">false</span>);
<a name="l00315"></a>00315 
<a name="l00316"></a>00316   <span class="comment">// Honor the --separate-libmeshout command-line option.</span>
<a name="l00317"></a>00317   <span class="comment">// When this is specified, the library uses an independent ostream</span>
<a name="l00318"></a>00318   <span class="comment">// for libMesh::out/libMesh::err messages, and</span>
<a name="l00319"></a>00319   <span class="comment">// std::cout and std::cerr are untouched by any other options</span>
<a name="l00320"></a>00320   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#ad19739ed0fdd45f048901a13954369b6">libMesh::on_command_line</a> (<span class="stringliteral">&quot;--separate-libmeshout&quot;</span>))
<a name="l00321"></a>00321     {
<a name="l00322"></a>00322       <span class="comment">// Redirect.  We&#39;ll share streambufs with cout/cerr for now, but</span>
<a name="l00323"></a>00323       <span class="comment">// presumably anyone using this option will want to replace the</span>
<a name="l00324"></a>00324       <span class="comment">// bufs later.</span>
<a name="l00325"></a>00325       std::ostream* newout = <span class="keyword">new</span> std::ostream(std::cout.rdbuf());
<a name="l00326"></a>00326       <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> = *newout;
<a name="l00327"></a>00327       std::ostream* newerr = <span class="keyword">new</span> std::ostream(std::cerr.rdbuf());
<a name="l00328"></a>00328       <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> = *newerr;
<a name="l00329"></a>00329     }
<a name="l00330"></a>00330   
<a name="l00331"></a>00331   <span class="comment">// Honor the --redirect-stdout command-line option.</span>
<a name="l00332"></a>00332   <span class="comment">// When this is specified each processor sends</span>
<a name="l00333"></a>00333   <span class="comment">// libMesh::out/libMesh::err messages to</span>
<a name="l00334"></a>00334   <span class="comment">// stdout.processor.####</span>
<a name="l00335"></a>00335   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#ad19739ed0fdd45f048901a13954369b6">libMesh::on_command_line</a> (<span class="stringliteral">&quot;--redirect-stdout&quot;</span>))
<a name="l00336"></a>00336     {
<a name="l00337"></a>00337       <span class="keywordtype">char</span> filechar[80];
<a name="l00338"></a>00338       sprintf (filechar, <span class="stringliteral">&quot;stdout.processor.%04d&quot;</span>,
<a name="l00339"></a>00339                <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>());
<a name="l00340"></a>00340       <a class="code" href="namespaceEXTERN__C__FOR__PETSC__END.php#abef0573f7a973208f7c638bfc4f5690a">_ofstream</a>.reset (<span class="keyword">new</span> std::ofstream (filechar));
<a name="l00341"></a>00341       <span class="comment">// Redirect, saving the original streambufs!</span>
<a name="l00342"></a>00342       <a class="code" href="namespaceEXTERN__C__FOR__PETSC__END.php#a73b9e9115727ed61f12e3431338c1081">out_buf</a> = <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a>.<a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#a478441e925f5cb680368d00bb3108820">rdbuf</a> (<a class="code" href="namespaceEXTERN__C__FOR__PETSC__END.php#abef0573f7a973208f7c638bfc4f5690a">_ofstream</a>-&gt;rdbuf());
<a name="l00343"></a>00343       <a class="code" href="namespaceEXTERN__C__FOR__PETSC__END.php#ae5f13c94da9876ea690637d111f898a9">err_buf</a> = <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a>.<a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#a478441e925f5cb680368d00bb3108820">rdbuf</a> (<a class="code" href="namespaceEXTERN__C__FOR__PETSC__END.php#abef0573f7a973208f7c638bfc4f5690a">_ofstream</a>-&gt;rdbuf());
<a name="l00344"></a>00344     }
<a name="l00345"></a>00345 
<a name="l00346"></a>00346   <span class="comment">// redirect libMesh::out to nothing on all</span>
<a name="l00347"></a>00347   <span class="comment">// other processors unless explicitly told</span>
<a name="l00348"></a>00348   <span class="comment">// not to via the --keep-cout command-line argument.</span>
<a name="l00349"></a>00349   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() != 0)
<a name="l00350"></a>00350     <span class="keywordflow">if</span> (!<a class="code" href="namespacelibMesh.php#ad19739ed0fdd45f048901a13954369b6">libMesh::on_command_line</a> (<span class="stringliteral">&quot;--keep-cout&quot;</span>))
<a name="l00351"></a>00351       <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a>.rdbuf (NULL);
<a name="l00352"></a>00352 
<a name="l00353"></a>00353   <span class="comment">// Check command line to override printing</span>
<a name="l00354"></a>00354   <span class="comment">// of reference count information.</span>
<a name="l00355"></a>00355   <span class="keywordflow">if</span>(<a class="code" href="namespacelibMesh.php#ad19739ed0fdd45f048901a13954369b6">libMesh::on_command_line</a>(<span class="stringliteral">&quot;--disable-refcount-printing&quot;</span>) )
<a name="l00356"></a>00356     <a class="code" href="classlibMesh_1_1ReferenceCounter.php#a5c0a2d3d3c531f9f069b0d623d4ace0f">ReferenceCounter::disable_print_counter_info</a>();
<a name="l00357"></a>00357   
<a name="l00358"></a>00358   <span class="comment">// The library is now ready for use</span>
<a name="l00359"></a>00359   <a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#ab8b7115ea57ced35ec86d1fdfa0ab853">libMeshPrivateData::_is_initialized</a> = <span class="keyword">true</span>;
<a name="l00360"></a>00360 
<a name="l00361"></a>00361   
<a name="l00362"></a>00362   <span class="comment">// Make sure these work.  Library methods</span>
<a name="l00363"></a>00363   <span class="comment">// depend on these being implemented properly,</span>
<a name="l00364"></a>00364   <span class="comment">// so this is a good time to test them!</span>
<a name="l00365"></a>00365   libmesh_assert (<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">libMesh::initialized</a>());
<a name="l00366"></a>00366   libmesh_assert (!<a class="code" href="namespacelibMesh.php#a3dc0a134260371bd023e0d0f632399e1">libMesh::closed</a>());
<a name="l00367"></a>00367 }
<a name="l00368"></a>00368 
<a name="l00369"></a>00369 
<a name="l00370"></a>00370 
<a name="l00371"></a>00371 <span class="keywordtype">int</span> _close ()
<a name="l00372"></a>00372 {
<a name="l00373"></a>00373   <span class="comment">// We can&#39;t delete, finalize, etc. more than once without</span>
<a name="l00374"></a>00374   <span class="comment">// reinitializing in between</span>
<a name="l00375"></a>00375   libmesh_assert(!<a class="code" href="namespacelibMesh.php#a3dc0a134260371bd023e0d0f632399e1">libMesh::closed</a>());
<a name="l00376"></a>00376 
<a name="l00377"></a>00377   <span class="comment">// Delete reference counted singleton(s)</span>
<a name="l00378"></a>00378   <span class="keyword">delete</span> <a class="code" href="namespacelibMesh.php#a903992f631b52b5ba05ad96a51e7b383">remote_elem</a>;
<a name="l00379"></a>00379 
<a name="l00380"></a>00380   <span class="comment">// Clear the thread task manager we started</span>
<a name="l00381"></a>00381   <a class="code" href="namespaceEXTERN__C__FOR__PETSC__END.php#ae853219c3e97c670cca0de67ca182fac">task_scheduler</a>.reset();
<a name="l00382"></a>00382 
<a name="l00383"></a>00383 <span class="preprocessor">#if defined(LIBMESH_HAVE_MPI)</span>
<a name="l00384"></a>00384 <span class="preprocessor"></span>  <span class="comment">// We may be here in only one process,</span>
<a name="l00385"></a>00385   <span class="comment">// because an uncaught libmesh_error() exception</span>
<a name="l00386"></a>00386   <span class="comment">// called the LibMeshInit destructor.</span>
<a name="l00387"></a>00387   <span class="comment">//</span>
<a name="l00388"></a>00388   <span class="comment">// If that&#39;s the case, we need to MPI_Abort(),</span>
<a name="l00389"></a>00389   <span class="comment">// not just wait for other processes that</span>
<a name="l00390"></a>00390   <span class="comment">// might never get to MPI_Finalize()</span>
<a name="l00391"></a>00391   <span class="keywordflow">if</span> (<a class="code" href="namespaceEXTERN__C__FOR__PETSC__END.php#ae8bedac09a6ae6f5dcc1a02090de63de">libmesh_initialized_mpi</a> &amp;&amp;
<a name="l00392"></a>00392       std::uncaught_exception())
<a name="l00393"></a>00393     {
<a name="l00394"></a>00394       <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Uncaught exception - aborting&quot;</span> &lt;&lt; std::endl;
<a name="l00395"></a>00395       <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#ad19739ed0fdd45f048901a13954369b6">libMesh::on_command_line</a> (<span class="stringliteral">&quot;--disable-mpi&quot;</span>))
<a name="l00396"></a>00396         exit(1);
<a name="l00397"></a>00397       <span class="keywordflow">else</span>
<a name="l00398"></a>00398         MPI_Abort(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,1);
<a name="l00399"></a>00399     }
<a name="l00400"></a>00400 <span class="preprocessor">#endif</span>
<a name="l00401"></a>00401 <span class="preprocessor"></span>
<a name="l00402"></a>00402 <span class="preprocessor">#if defined(LIBMESH_HAVE_PETSC) </span>
<a name="l00403"></a>00403 <span class="preprocessor"></span>      <span class="comment">// Allow the user to bypass PETSc finalization</span>
<a name="l00404"></a>00404   <span class="keywordflow">if</span> (!<a class="code" href="namespacelibMesh.php#ad19739ed0fdd45f048901a13954369b6">libMesh::on_command_line</a> (<span class="stringliteral">&quot;--disable-petsc&quot;</span>)
<a name="l00405"></a>00405 #<span class="keywordflow">if</span> defined(LIBMESH_HAVE_MPI)
<a name="l00406"></a>00406       &amp;&amp; !<a class="code" href="namespacelibMesh.php#ad19739ed0fdd45f048901a13954369b6">libMesh::on_command_line</a> (<span class="stringliteral">&quot;--disable-mpi&quot;</span>)
<a name="l00407"></a>00407 #endif
<a name="l00408"></a>00408      )
<a name="l00409"></a>00409     {
<a name="l00410"></a>00410 <span class="preprocessor"># if defined(LIBMESH_HAVE_SLEPC)</span>
<a name="l00411"></a>00411 <span class="preprocessor"></span>      <span class="keywordflow">if</span> (<a class="code" href="namespaceEXTERN__C__FOR__PETSC__END.php#a0f83fc1317cca54d7154dfbf4e998f01">libmesh_initialized_slepc</a>)
<a name="l00412"></a>00412         SlepcFinalize();
<a name="l00413"></a>00413 <span class="preprocessor"># else</span>
<a name="l00414"></a>00414 <span class="preprocessor"></span>      <span class="keywordflow">if</span> (<a class="code" href="namespaceEXTERN__C__FOR__PETSC__END.php#a0052b0ad841d7589360fb4f0bdc73e70">libmesh_initialized_petsc</a>)
<a name="l00415"></a>00415         PetscFinalize();
<a name="l00416"></a>00416 <span class="preprocessor"># endif</span>
<a name="l00417"></a>00417 <span class="preprocessor"></span>    }
<a name="l00418"></a>00418 <span class="preprocessor">#endif</span>
<a name="l00419"></a>00419 <span class="preprocessor"></span>
<a name="l00420"></a>00420 <span class="preprocessor">#if defined(LIBMESH_HAVE_MPI)</span>
<a name="l00421"></a>00421 <span class="preprocessor"></span>  <span class="comment">// Allow the user to bypass MPI finalization</span>
<a name="l00422"></a>00422   <span class="keywordflow">if</span> (!<a class="code" href="namespacelibMesh.php#ad19739ed0fdd45f048901a13954369b6">libMesh::on_command_line</a> (<span class="stringliteral">&quot;--disable-mpi&quot;</span>))
<a name="l00423"></a>00423     {
<a name="l00424"></a>00424       <a class="code" href="namespacelibMesh_1_1Parallel.php#a0177ff6d177a879cc6d29e2f95694c91">Parallel::Communicator_World</a>.clear();
<a name="l00425"></a>00425       MPI_Comm_free (&amp;<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>);
<a name="l00426"></a>00426 
<a name="l00427"></a>00427       <span class="keywordflow">if</span> (<a class="code" href="namespaceEXTERN__C__FOR__PETSC__END.php#ae8bedac09a6ae6f5dcc1a02090de63de">libmesh_initialized_mpi</a>)
<a name="l00428"></a>00428         MPI_Finalize();
<a name="l00429"></a>00429     }
<a name="l00430"></a>00430 <span class="preprocessor">#endif</span>
<a name="l00431"></a>00431 <span class="preprocessor"></span>
<a name="l00432"></a>00432   <span class="comment">// Force the \p ReferenceCounter to print</span>
<a name="l00433"></a>00433   <span class="comment">// its reference count information.  This allows</span>
<a name="l00434"></a>00434   <span class="comment">// us to find memory leaks.  By default the</span>
<a name="l00435"></a>00435   <span class="comment">// \p ReferenceCounter only prints its information</span>
<a name="l00436"></a>00436   <span class="comment">// when the last created object has been destroyed.</span>
<a name="l00437"></a>00437   <span class="comment">// That does no good if we are leaking memory!</span>
<a name="l00438"></a>00438   <a class="code" href="classlibMesh_1_1ReferenceCounter.php#a6f46edb253f11a90bfc5f824b45ed596">ReferenceCounter::print_info</a> ();
<a name="l00439"></a>00439   
<a name="l00440"></a>00440 
<a name="l00441"></a>00441   <span class="comment">// Print an informative message if we detect a memory leak</span>
<a name="l00442"></a>00442   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1ReferenceCounter.php#a50e74641afc6e2870c9e1ce412f8c44f">ReferenceCounter::n_objects</a>() != 0)
<a name="l00443"></a>00443     {
<a name="l00444"></a>00444       <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Memory leak detected!&quot;</span>
<a name="l00445"></a>00445                     &lt;&lt; std::endl;
<a name="l00446"></a>00446       
<a name="l00447"></a>00447 <span class="preprocessor">#if !defined(LIBMESH_ENABLE_REFERENCE_COUNTING) || defined(NDEBUG)</span>
<a name="l00448"></a>00448 <span class="preprocessor"></span>
<a name="l00449"></a>00449       <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Compile in DEBUG mode with --enable-reference-counting&quot;</span>
<a name="l00450"></a>00450                     &lt;&lt; std::endl
<a name="l00451"></a>00451                     &lt;&lt; <span class="stringliteral">&quot;for more information&quot;</span>
<a name="l00452"></a>00452                     &lt;&lt; std::endl;
<a name="l00453"></a>00453 <span class="preprocessor">#endif</span>
<a name="l00454"></a>00454 <span class="preprocessor"></span>  
<a name="l00455"></a>00455     }
<a name="l00456"></a>00456 
<a name="l00457"></a>00457 
<a name="l00458"></a>00458   <span class="comment">// Reconnect the output streams</span>
<a name="l00459"></a>00459   <span class="comment">// (don&#39;t do this, or we will get messages from objects</span>
<a name="l00460"></a>00460   <span class="comment">//  that go out of scope after the following return)</span>
<a name="l00461"></a>00461   <span class="comment">//std::cout.rdbuf(std::cerr.rdbuf());</span>
<a name="l00462"></a>00462 
<a name="l00463"></a>00463   
<a name="l00464"></a>00464   <span class="comment">// Set the initialized() flag to false</span>
<a name="l00465"></a>00465   <a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#ab8b7115ea57ced35ec86d1fdfa0ab853">libMeshPrivateData::_is_initialized</a> = <span class="keyword">false</span>;
<a name="l00466"></a>00466 
<a name="l00467"></a>00467   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#ad19739ed0fdd45f048901a13954369b6">libMesh::on_command_line</a> (<span class="stringliteral">&quot;--redirect-stdout&quot;</span>))
<a name="l00468"></a>00468     {
<a name="l00469"></a>00469       <span class="comment">// Before handing back the std stream buffers, print the</span>
<a name="l00470"></a>00470       <span class="comment">// perflog to the individual processor&#39;s files.</span>
<a name="l00471"></a>00471       <a class="code" href="namespacelibMesh.php#a898fabb4e2a583bf30bf4bd46f4c032d">libMesh::perflog</a>.<a class="code" href="classlibMesh_1_1PerfLog.php#a77310cc500de193b6172d92a5ddbf95d">print_log</a>();
<a name="l00472"></a>00472 
<a name="l00473"></a>00473       <span class="comment">// Now clear the logging object, we don&#39;t want it to print</span>
<a name="l00474"></a>00474       <span class="comment">// a second time during the PerfLog destructor.</span>
<a name="l00475"></a>00475       <a class="code" href="namespacelibMesh.php#a898fabb4e2a583bf30bf4bd46f4c032d">libMesh::perflog</a>.<a class="code" href="classlibMesh_1_1PerfLog.php#a3d3d2147ad6667552663be7befdd35e1">clear</a>();
<a name="l00476"></a>00476       
<a name="l00477"></a>00477       <span class="comment">// If stdout/stderr were redirected to files, reset them now.</span>
<a name="l00478"></a>00478       <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a>.<a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#a478441e925f5cb680368d00bb3108820">rdbuf</a> (<a class="code" href="namespaceEXTERN__C__FOR__PETSC__END.php#a73b9e9115727ed61f12e3431338c1081">out_buf</a>);
<a name="l00479"></a>00479       <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a>.<a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#a478441e925f5cb680368d00bb3108820">rdbuf</a> (<a class="code" href="namespaceEXTERN__C__FOR__PETSC__END.php#ae5f13c94da9876ea690637d111f898a9">err_buf</a>);
<a name="l00480"></a>00480     }
<a name="l00481"></a>00481   
<a name="l00482"></a>00482   <span class="comment">// If we built our own output streams, we want to clean them up.</span>
<a name="l00483"></a>00483   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#ad19739ed0fdd45f048901a13954369b6">libMesh::on_command_line</a> (<span class="stringliteral">&quot;--separate-libmeshout&quot;</span>))
<a name="l00484"></a>00484     {
<a name="l00485"></a>00485       <span class="keyword">delete</span> <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a>.<a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#ae2d18b50fc63d23e47d46fcee630b4f5">get</a>();
<a name="l00486"></a>00486       <span class="keyword">delete</span> <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a>.<a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#ae2d18b50fc63d23e47d46fcee630b4f5">get</a>();
<a name="l00487"></a>00487 
<a name="l00488"></a>00488       <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a>.<a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#aabafe8d5f1873f911413d9e19cb2afe4">reset</a>(std::cout);
<a name="l00489"></a>00489       <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a>.<a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#aabafe8d5f1873f911413d9e19cb2afe4">reset</a>(std::cerr);
<a name="l00490"></a>00490     }
<a name="l00491"></a>00491 
<a name="l00492"></a>00492   <span class="comment">// Return the number of outstanding objects.</span>
<a name="l00493"></a>00493   <span class="comment">// This is equivalent to return 0 if all of</span>
<a name="l00494"></a>00494   <span class="comment">// the reference counted objects have been</span>
<a name="l00495"></a>00495   <span class="comment">// deleted.</span>
<a name="l00496"></a>00496   <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><span class="keywordtype">int</span><span class="keyword">&gt;</span>(<a class="code" href="classlibMesh_1_1ReferenceCounter.php#a50e74641afc6e2870c9e1ce412f8c44f">ReferenceCounter::n_objects</a>());
<a name="l00497"></a>00497 }
<a name="l00498"></a>00498 
<a name="l00499"></a>00499 
<a name="l00500"></a>00500 
<a name="l00501"></a>00501 <span class="preprocessor">#ifndef LIBMESH_HAVE_MPI</span>
<a name="l00502"></a>00502 <span class="preprocessor"></span><span class="keywordtype">void</span> <a class="code" href="namespacelibMesh.php#a74975b21077cce916d7b3e22ad49290c">init</a> (<span class="keywordtype">int</span> &amp;argc, <span class="keywordtype">char</span>** &amp; argv)
<a name="l00503"></a>00503 {
<a name="l00504"></a>00504   libmesh_deprecated();  <span class="comment">// Use LibMeshInit instead</span>
<a name="l00505"></a>00505   <a class="code" href="namespacelibMesh.php#aad6fecb8ebe53b4daffa683eaa02d4dc">libMesh::_init</a>(argc, argv);
<a name="l00506"></a>00506 }
<a name="l00507"></a>00507 <span class="preprocessor">#else</span>
<a name="l00508"></a>00508 <span class="preprocessor"></span><span class="keywordtype">void</span> <a class="code" href="namespacelibMesh.php#a74975b21077cce916d7b3e22ad49290c">init</a> (<span class="keywordtype">int</span> &amp;argc, <span class="keywordtype">char</span>** &amp; argv,
<a name="l00509"></a>00509                     MPI_Comm COMM_WORLD_IN)
<a name="l00510"></a>00510 {
<a name="l00511"></a>00511   libmesh_deprecated();  <span class="comment">// Use LibMeshInit instead</span>
<a name="l00512"></a>00512   <a class="code" href="namespacelibMesh.php#aad6fecb8ebe53b4daffa683eaa02d4dc">libMesh::_init</a>(argc, argv, COMM_WORLD_IN);
<a name="l00513"></a>00513 }
<a name="l00514"></a>00514 <span class="preprocessor">#endif</span>
<a name="l00515"></a>00515 <span class="preprocessor"></span>
<a name="l00516"></a>00516 
<a name="l00517"></a>00517 
<a name="l00518"></a>00518 
<a name="l00519"></a>00519 <span class="keywordtype">int</span> <a class="code" href="namespacelibMesh.php#a6e41d4c43a417f7b9e20302af9736247">close</a> ()
<a name="l00520"></a>00520 {
<a name="l00521"></a>00521   libmesh_deprecated();  <span class="comment">// Use LibMeshInit instead</span>
<a name="l00522"></a>00522   <span class="keywordflow">return</span> libMesh::_close();
<a name="l00523"></a>00523 }
<a name="l00524"></a>00524 
<a name="l00525"></a>00525 
<a name="l00526"></a>00526 
<a name="l00527"></a>00527 <span class="preprocessor">#ifndef LIBMESH_HAVE_MPI</span>
<a name="l00528"></a>00528 <span class="preprocessor"></span><a class="code" href="classlibMesh_1_1LibMeshInit.php#a6cc460ae7fbdbd431df558779cd101a1">LibMeshInit::LibMeshInit</a> (<span class="keywordtype">int</span> &amp;argc, <span class="keywordtype">char</span>** &amp; argv)
<a name="l00529"></a>00529 {
<a name="l00530"></a>00530   <a class="code" href="namespacelibMesh.php#aad6fecb8ebe53b4daffa683eaa02d4dc">libMesh::_init</a>(argc, argv);
<a name="l00531"></a>00531 }
<a name="l00532"></a>00532 <span class="preprocessor">#else</span>
<a name="l00533"></a>00533 <span class="preprocessor"></span><a class="code" href="classlibMesh_1_1LibMeshInit.php#a6cc460ae7fbdbd431df558779cd101a1">LibMeshInit::LibMeshInit</a> (<span class="keywordtype">int</span> &amp;argc, <span class="keywordtype">char</span>** &amp; argv,
<a name="l00534"></a>00534                           MPI_Comm COMM_WORLD_IN)
<a name="l00535"></a>00535 {
<a name="l00536"></a>00536   <a class="code" href="namespacelibMesh.php#aad6fecb8ebe53b4daffa683eaa02d4dc">libMesh::_init</a>(argc, argv, COMM_WORLD_IN);
<a name="l00537"></a>00537 }
<a name="l00538"></a>00538 <span class="preprocessor">#endif</span>
<a name="l00539"></a>00539 <span class="preprocessor"></span>
<a name="l00540"></a>00540 <a class="code" href="classlibMesh_1_1LibMeshInit.php#ace3b4148c438bc97e156a65ed9fa793c">LibMeshInit::~LibMeshInit</a>()
<a name="l00541"></a>00541 {
<a name="l00542"></a>00542   libMesh::_close();
<a name="l00543"></a>00543 }
<a name="l00544"></a>00544 
<a name="l00545"></a>00545 
<a name="l00546"></a>00546 
<a name="l00547"></a>00547 
<a name="l00548"></a>00548 <span class="keywordtype">bool</span> <a class="code" href="namespacelibMesh.php#ad19739ed0fdd45f048901a13954369b6">on_command_line</a> (<span class="keyword">const</span> std::string&amp; arg)
<a name="l00549"></a>00549 {
<a name="l00550"></a>00550   <span class="comment">// Make sure the command line parser is ready for use</span>
<a name="l00551"></a>00551   libmesh_assert (<a class="code" href="namespaceEXTERN__C__FOR__PETSC__END.php#aeb0594fd92da9edcd479f0736177e5c4">command_line</a>.get() != NULL);
<a name="l00552"></a>00552   
<a name="l00553"></a>00553   <span class="keywordflow">return</span> <a class="code" href="namespaceEXTERN__C__FOR__PETSC__END.php#aeb0594fd92da9edcd479f0736177e5c4">command_line</a>-&gt;search (arg);
<a name="l00554"></a>00554 }
<a name="l00555"></a>00555 
<a name="l00556"></a>00556 
<a name="l00557"></a>00557 
<a name="l00558"></a>00558 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00559"></a>00559 T <a class="code" href="namespacelibMesh.php#a7cbd0ce3d26eb45284882fed440b2a09">command_line_value</a> (<span class="keyword">const</span> std::string &amp;<a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>, T value)
<a name="l00560"></a>00560 {
<a name="l00561"></a>00561   <span class="comment">// Make sure the command line parser is ready for use</span>
<a name="l00562"></a>00562   libmesh_assert (<a class="code" href="namespaceEXTERN__C__FOR__PETSC__END.php#aeb0594fd92da9edcd479f0736177e5c4">command_line</a>.get() != NULL);
<a name="l00563"></a>00563   
<a name="l00564"></a>00564     <span class="comment">// only if the variable exists in the file</span>
<a name="l00565"></a>00565     <span class="keywordflow">if</span> (<a class="code" href="namespaceEXTERN__C__FOR__PETSC__END.php#aeb0594fd92da9edcd479f0736177e5c4">command_line</a>-&gt;have_variable(name.c_str()))
<a name="l00566"></a>00566       value = (*command_line)(name.c_str(), value);      
<a name="l00567"></a>00567 
<a name="l00568"></a>00568     <span class="keywordflow">return</span> value;
<a name="l00569"></a>00569 }
<a name="l00570"></a>00570 
<a name="l00571"></a>00571 
<a name="l00572"></a>00572 <a class="code" href="namespacelibMeshEnums.php#a2785fa3c3529ebe4c62dc593b12b65d8">SolverPackage</a> <a class="code" href="namespacelibMesh.php#a496c62248223cd940c7715932dd0dc2d">default_solver_package</a> ()
<a name="l00573"></a>00573 {
<a name="l00574"></a>00574   libmesh_assert (<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">libMesh::initialized</a>());
<a name="l00575"></a>00575   
<a name="l00576"></a>00576   <span class="keyword">static</span> <span class="keywordtype">bool</span> called = <span class="keyword">false</span>;
<a name="l00577"></a>00577 
<a name="l00578"></a>00578   <span class="comment">// Check the command line.  Since the command line is</span>
<a name="l00579"></a>00579   <span class="comment">// unchanging it is sufficient to do this only once.</span>
<a name="l00580"></a>00580   <span class="keywordflow">if</span> (!called)
<a name="l00581"></a>00581     {
<a name="l00582"></a>00582       called = <span class="keyword">true</span>;
<a name="l00583"></a>00583 
<a name="l00584"></a>00584 <span class="preprocessor">#ifdef LIBMESH_HAVE_PETSC</span>
<a name="l00585"></a>00585 <span class="preprocessor"></span>      <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#ad19739ed0fdd45f048901a13954369b6">libMesh::on_command_line</a> (<span class="stringliteral">&quot;--use-petsc&quot;</span>))
<a name="l00586"></a>00586         <a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#a5595417b69d598a65c439048450f6d02">libMeshPrivateData::_solver_package</a> = <a class="code" href="namespacelibMeshEnums.php#a2785fa3c3529ebe4c62dc593b12b65d8a4bb6e669bd80e3d232092e60df464572">PETSC_SOLVERS</a>;
<a name="l00587"></a>00587 <span class="preprocessor">#endif</span>
<a name="l00588"></a>00588 <span class="preprocessor"></span>
<a name="l00589"></a>00589 <span class="preprocessor">#ifdef LIBMESH_HAVE_TRILINOS</span>
<a name="l00590"></a>00590 <span class="preprocessor"></span>      <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#ad19739ed0fdd45f048901a13954369b6">libMesh::on_command_line</a> (<span class="stringliteral">&quot;--use-trilinos&quot;</span>) ||
<a name="l00591"></a>00591           <a class="code" href="namespacelibMesh.php#ad19739ed0fdd45f048901a13954369b6">libMesh::on_command_line</a> (<span class="stringliteral">&quot;--disable-petsc&quot;</span>))
<a name="l00592"></a>00592         <a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#a5595417b69d598a65c439048450f6d02">libMeshPrivateData::_solver_package</a> = <a class="code" href="namespacelibMesh.php#aa27e267f495ee0599f7cd8981c0cf7ad">TRILINOS_SOLVERS</a>;
<a name="l00593"></a>00593 <span class="preprocessor">#endif</span>
<a name="l00594"></a>00594 <span class="preprocessor"></span>      
<a name="l00595"></a>00595 <span class="preprocessor">#ifdef LIBMESH_HAVE_LASPACK</span>
<a name="l00596"></a>00596 <span class="preprocessor"></span>      <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#ad19739ed0fdd45f048901a13954369b6">libMesh::on_command_line</a> (<span class="stringliteral">&quot;--use-laspack&quot;</span>  ) ||
<a name="l00597"></a>00597           <a class="code" href="namespacelibMesh.php#ad19739ed0fdd45f048901a13954369b6">libMesh::on_command_line</a> (<span class="stringliteral">&quot;--disable-petsc&quot;</span>))
<a name="l00598"></a>00598         <a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#a5595417b69d598a65c439048450f6d02">libMeshPrivateData::_solver_package</a> = <a class="code" href="namespacelibMesh.php#aeb2a777af969e03421c99c4afe9d68a0">LASPACK_SOLVERS</a>;
<a name="l00599"></a>00599 <span class="preprocessor">#endif</span>
<a name="l00600"></a>00600 <span class="preprocessor"></span>
<a name="l00601"></a>00601       <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#ad19739ed0fdd45f048901a13954369b6">libMesh::on_command_line</a> (<span class="stringliteral">&quot;--disable-laspack&quot;</span>) &amp;&amp;
<a name="l00602"></a>00602           <a class="code" href="namespacelibMesh.php#ad19739ed0fdd45f048901a13954369b6">libMesh::on_command_line</a> (<span class="stringliteral">&quot;--disable-trilinos&quot;</span>) &amp;&amp;
<a name="l00603"></a>00603           <a class="code" href="namespacelibMesh.php#ad19739ed0fdd45f048901a13954369b6">libMesh::on_command_line</a> (<span class="stringliteral">&quot;--disable-petsc&quot;</span>))
<a name="l00604"></a>00604         <a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#a5595417b69d598a65c439048450f6d02">libMeshPrivateData::_solver_package</a> = <a class="code" href="namespacelibMesh.php#afc934dba6c6bb935bdd1a6788be67614">INVALID_SOLVER_PACKAGE</a>;
<a name="l00605"></a>00605     }
<a name="l00606"></a>00606   
<a name="l00607"></a>00607   
<a name="l00608"></a>00608   <span class="keywordflow">return</span> <a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#a5595417b69d598a65c439048450f6d02">libMeshPrivateData::_solver_package</a>;  
<a name="l00609"></a>00609 }
<a name="l00610"></a>00610 
<a name="l00611"></a>00611 
<a name="l00612"></a>00612 
<a name="l00613"></a>00613 <span class="comment">//-------------------------------------------------------------------------------</span>
<a name="l00614"></a>00614 <span class="keyword">template</span> <span class="keywordtype">int</span>          command_line_value&lt;int&gt;         (<span class="keyword">const</span> std::string&amp;, int);
<a name="l00615"></a>00615 <span class="keyword">template</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>         <a class="code" href="namespacelibMesh.php#aaf85ad5513b9d1ff94ca262e45005801">command_line_value&lt;Real&gt;</a>        (<span class="keyword">const</span> std::string&amp;, <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>);
<a name="l00616"></a>00616 <span class="keyword">template</span> std::string  command_line_value&lt;std::string&gt; (<span class="keyword">const</span> std::string&amp;, std::string);
<a name="l00617"></a>00617 
<a name="l00618"></a>00618 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
