<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_eaf30c8ea092d33f79a04353c3899c3f.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_5a0c7151fa56969ceb962f1511f7edee.php">systems</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">linear_implicit_system.h</div>  </div>
</div>
<div class="contents">
<a href="linear__implicit__system_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id$</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __linear_implicit_system_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __linear_implicit_system_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local Includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="implicit__system_8h.php">implicit_system.h</a>&quot;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="keyword">namespace </span>libMesh
<a name="l00031"></a>00031 {
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="comment">// Forward Declarations</span>
<a name="l00035"></a>00035 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span>LinearSolver;
<a name="l00036"></a>00036 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span>ShellMatrix;
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 
<a name="l00047"></a>00047 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00048"></a>00048 <span class="comment">// LinearImplicitSystem class definition</span>
<a name="l00049"></a>00049 
<a name="l00050"></a><a class="code" href="classlibMesh_1_1LinearImplicitSystem.php">00050</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1LinearImplicitSystem.php">LinearImplicitSystem</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1ImplicitSystem.php">ImplicitSystem</a>
<a name="l00051"></a>00051 {
<a name="l00052"></a>00052 <span class="keyword">public</span>:
<a name="l00053"></a>00053 
<a name="l00058"></a>00058   <a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a329460f19707462e20a6344c5f0d3d3b">LinearImplicitSystem</a> (<a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00059"></a>00059                         <span class="keyword">const</span> std::string&amp; <a class="code" href="classlibMesh_1_1System.php#af80f6b2e508821ebd9c8fcb78d443f18">name</a>,
<a name="l00060"></a>00060                         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#aee5caacb487b070842733f1c84b9a2fd">number</a>);
<a name="l00061"></a>00061 
<a name="l00065"></a>00065   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#af483d705ccd4e6287d0292287481e480">~LinearImplicitSystem</a> ();
<a name="l00066"></a>00066 
<a name="l00070"></a><a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a719f5decbfb122d49de9337cf7e03c9c">00070</a>   <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1LinearImplicitSystem.php">LinearImplicitSystem</a> <a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a719f5decbfb122d49de9337cf7e03c9c">sys_type</a>;
<a name="l00071"></a>00071 
<a name="l00075"></a><a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#afac53cc2d0e951260f33f913bde9dadf">00075</a>   <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1ImplicitSystem.php">ImplicitSystem</a> <a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#afac53cc2d0e951260f33f913bde9dadf">Parent</a>;
<a name="l00076"></a>00076   
<a name="l00080"></a><a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a850d27fb7eb90f09ff94854f462db287">00080</a>   <a class="code" href="classlibMesh_1_1ExplicitSystem.php">sys_type</a> &amp; <a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a850d27fb7eb90f09ff94854f462db287">system</a> () { <span class="keywordflow">return</span> *<span class="keyword">this</span>; }
<a name="l00081"></a>00081   
<a name="l00086"></a>00086   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a8af6a9f61922d067be46acdfcde204f1">clear</a> ();
<a name="l00087"></a>00087 
<a name="l00092"></a>00092   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#acaeb85ca820997afa82131120c45ebd8">reinit</a> ();
<a name="l00093"></a>00093    
<a name="l00100"></a><a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a6446a3daa539c257cc3d621ec0040c35">00100</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a6446a3daa539c257cc3d621ec0040c35">assemble</a> () { <a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a6446a3daa539c257cc3d621ec0040c35">ImplicitSystem::assemble</a>(); }
<a name="l00101"></a>00101  
<a name="l00105"></a>00105   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#af1de21a76860785bb1992280eb72b0db">solve</a> ();
<a name="l00106"></a>00106  
<a name="l00111"></a>00111   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1LinearSolver.php">LinearSolver&lt;Number&gt;</a> *<a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a71c8cb9e4c0153683cbdd3499eb8728d">get_linear_solver</a>() <span class="keyword">const</span>;
<a name="l00112"></a>00112 
<a name="l00117"></a>00117   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a474c50db652e175cfc55a3f6b5c6cee3">release_linear_solver</a>(<a class="code" href="classlibMesh_1_1LinearSolver.php">LinearSolver&lt;Number&gt;</a> *) <span class="keyword">const</span>;
<a name="l00118"></a>00118 
<a name="l00123"></a>00123   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#aa64262ff0919aea327cd1d298e386353">assembly</a>(<span class="keywordtype">bool</span> get_residual, <span class="keywordtype">bool</span> get_jacobian);
<a name="l00124"></a>00124 
<a name="l00129"></a><a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a714a3b76f086ff358f9184f3c3fa7168">00129</a>   <span class="keyword">virtual</span> std::string <a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a714a3b76f086ff358f9184f3c3fa7168">system_type</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="stringliteral">&quot;LinearImplicit&quot;</span>; }
<a name="l00130"></a>00130 
<a name="l00137"></a><a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a7cc68891fa9f44ded49b9b84c057cb32">00137</a>   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;LinearSolver&lt;Number&gt;</a> &gt; <a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a7cc68891fa9f44ded49b9b84c057cb32">linear_solver</a>;
<a name="l00138"></a>00138   
<a name="l00143"></a><a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#af712dbf0e285c5ff4cc346daef05423c">00143</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#af712dbf0e285c5ff4cc346daef05423c">n_linear_iterations</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a57e48b332f51b09bb0a202c18daa46f6">_n_linear_iterations</a>; }
<a name="l00144"></a>00144 
<a name="l00148"></a><a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a86b5e2954d2a2e43014bcda8810239ac">00148</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a86b5e2954d2a2e43014bcda8810239ac">final_linear_residual</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a9a2a816c2a19f12d8d2f34709940f8dc">_final_linear_residual</a>; }
<a name="l00149"></a>00149   
<a name="l00159"></a>00159   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a03b925bc4b6210f3cff6c45868d84484">attach_shell_matrix</a> (<a class="code" href="classlibMesh_1_1ShellMatrix.php">ShellMatrix&lt;Number&gt;</a>* shell_matrix);
<a name="l00160"></a>00160   
<a name="l00164"></a><a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a7799a576afae486da3721e10a42a7d49">00164</a>   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a7799a576afae486da3721e10a42a7d49">detach_shell_matrix</a> (<span class="keywordtype">void</span>) { <a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a03b925bc4b6210f3cff6c45868d84484">attach_shell_matrix</a>(NULL); }
<a name="l00165"></a>00165 
<a name="l00170"></a><a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#ac8033875ef0663fdfc1824f809811f43">00170</a>   <a class="code" href="classlibMesh_1_1ShellMatrix.php">ShellMatrix&lt;Number&gt;</a>* <a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#ac8033875ef0663fdfc1824f809811f43">get_shell_matrix</a>(<span class="keywordtype">void</span>) { <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a560d4b7b25823897fab6226b371082a0">_shell_matrix</a>; }
<a name="l00171"></a>00171   
<a name="l00172"></a>00172 <span class="keyword">protected</span>:
<a name="l00173"></a>00173   
<a name="l00178"></a><a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a57e48b332f51b09bb0a202c18daa46f6">00178</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a57e48b332f51b09bb0a202c18daa46f6">_n_linear_iterations</a>;
<a name="l00179"></a>00179 
<a name="l00183"></a><a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a9a2a816c2a19f12d8d2f34709940f8dc">00183</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a9a2a816c2a19f12d8d2f34709940f8dc">_final_linear_residual</a>;
<a name="l00184"></a>00184 
<a name="l00188"></a><a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a560d4b7b25823897fab6226b371082a0">00188</a>   <a class="code" href="classlibMesh_1_1ShellMatrix.php">ShellMatrix&lt;Number&gt;</a>* <a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a560d4b7b25823897fab6226b371082a0">_shell_matrix</a>;
<a name="l00189"></a>00189 
<a name="l00190"></a>00190 };
<a name="l00191"></a>00191 
<a name="l00192"></a>00192 
<a name="l00193"></a>00193 } <span class="comment">// namespace libMesh</span>
<a name="l00194"></a>00194 
<a name="l00195"></a>00195 
<a name="l00196"></a>00196 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00197"></a>00197 <span class="comment">// LinearImplicitSystem inline methods</span>
<a name="l00198"></a>00198 
<a name="l00199"></a>00199 
<a name="l00200"></a>00200 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
