<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_eaf30c8ea092d33f79a04353c3899c3f.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_ab48de31eb9fae6cf2d44db459e0c963.php">solvers</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">linear_solver.h</div>  </div>
</div>
<div class="contents">
<a href="linear__solver_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id$</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __linear_solver_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __linear_solver_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// C++ includes</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="comment">// Local includes</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="enum__solver__package_8h.php">enum_solver_package.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="enum__solver__type_8h.php">enum_solver_type.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="enum__preconditioner__type_8h.php">enum_preconditioner_type.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="reference__counted__object_8h.php">reference_counted_object.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="libmesh_8h.php">libmesh.h</a>&quot;</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="keyword">namespace </span>libMesh
<a name="l00037"></a>00037 {
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 <span class="comment">// forward declarations</span>
<a name="l00040"></a>00040 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span>AutoPtr;
<a name="l00041"></a>00041 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span>SparseMatrix;
<a name="l00042"></a>00042 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span>NumericVector;
<a name="l00043"></a>00043 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span>ShellMatrix;
<a name="l00044"></a>00044 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span>Preconditioner;
<a name="l00045"></a>00045 
<a name="l00046"></a>00046 
<a name="l00055"></a>00055 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00056"></a><a class="code" href="classlibMesh_1_1LinearSolver.php">00056</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1LinearSolver.php">LinearSolver</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1ReferenceCountedObject.php">ReferenceCountedObject</a>&lt;LinearSolver&lt;T&gt; &gt;
<a name="l00057"></a>00057 {
<a name="l00058"></a>00058 <span class="keyword">public</span>:
<a name="l00059"></a>00059   
<a name="l00063"></a>00063   <a class="code" href="classlibMesh_1_1LinearSolver.php#a7664a50fd17b8c7b0b3ae3aa11d1d8b5">LinearSolver</a> ();
<a name="l00064"></a>00064     
<a name="l00068"></a>00068   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1LinearSolver.php#ad9e59180733648633468f45b43fb2be0">~LinearSolver</a> ();
<a name="l00069"></a>00069   
<a name="l00074"></a>00074   <span class="keyword">static</span> <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;LinearSolver&lt;T&gt;</a> &gt; <a class="code" href="classlibMesh_1_1LinearSolver.php#a726d0a8d474d3f18cdff5485afe7d63a">build</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a2785fa3c3529ebe4c62dc593b12b65d8">SolverPackage</a> solver_package =
<a name="l00075"></a>00075                                                   <a class="code" href="namespacelibMesh.php#a496c62248223cd940c7715932dd0dc2d">libMesh::default_solver_package</a>());
<a name="l00076"></a>00076   
<a name="l00081"></a><a class="code" href="classlibMesh_1_1LinearSolver.php#ac9d7de69910e031898f5786b61816f72">00081</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1LinearSolver.php#ac9d7de69910e031898f5786b61816f72">initialized</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1LinearSolver.php#a97da17452484aa8121282f15248b8b9a">_is_initialized</a>; }
<a name="l00082"></a>00082   
<a name="l00086"></a><a class="code" href="classlibMesh_1_1LinearSolver.php#a05866150ac7a96976f194e08fd7a8af8">00086</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LinearSolver.php#a05866150ac7a96976f194e08fd7a8af8">clear</a> () {}
<a name="l00087"></a>00087 
<a name="l00091"></a>00091   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LinearSolver.php#ad5ba1eb414dab5da76cb3101595eb770">init</a> () = 0;
<a name="l00092"></a>00092 
<a name="l00096"></a><a class="code" href="classlibMesh_1_1LinearSolver.php#a56acf56ca513a30cea0a71c4391cda3a">00096</a>   <a class="code" href="namespacelibMeshEnums.php#a6ecf91f56b4ab5cda4d3d0a468733b19">SolverType</a> <a class="code" href="classlibMesh_1_1LinearSolver.php#a56acf56ca513a30cea0a71c4391cda3a">solver_type</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1LinearSolver.php#a6b64a30f2023ff38c662536f79a4451a">_solver_type</a>; }
<a name="l00097"></a>00097 
<a name="l00101"></a><a class="code" href="classlibMesh_1_1LinearSolver.php#ae2a012e2e7a62aaaaaaa15ec0fdef891">00101</a>   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LinearSolver.php#ae2a012e2e7a62aaaaaaa15ec0fdef891">set_solver_type</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a6ecf91f56b4ab5cda4d3d0a468733b19">SolverType</a> st)
<a name="l00102"></a>00102   { <a class="code" href="classlibMesh_1_1LinearSolver.php#a6b64a30f2023ff38c662536f79a4451a">_solver_type</a> = st; }
<a name="l00103"></a>00103 
<a name="l00107"></a>00107   <a class="code" href="namespacelibMeshEnums.php#a45b101a23b532f020f46f412485db0d4">PreconditionerType</a> <a class="code" href="classlibMesh_1_1LinearSolver.php#a32740239cc7991d77b4166331514f2ad">preconditioner_type</a> () <span class="keyword">const</span>;
<a name="l00108"></a>00108 
<a name="l00112"></a>00112   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LinearSolver.php#a9bacfd14b9ad9cc5a996125dace2a021">set_preconditioner_type</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a45b101a23b532f020f46f412485db0d4">PreconditionerType</a> pct);
<a name="l00113"></a>00113 
<a name="l00117"></a>00117   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LinearSolver.php#ae800697a18767330e32c14cc1c06aa91">attach_preconditioner</a>(<a class="code" href="classlibMesh_1_1Preconditioner.php">Preconditioner&lt;T&gt;</a> * preconditioner);
<a name="l00118"></a>00118 
<a name="l00125"></a>00125   <span class="keyword">virtual</span> std::pair&lt;unsigned int, Real&gt; <a class="code" href="classlibMesh_1_1LinearSolver.php#a9663fee6659bd9705e72142d5e42a02a">solve</a> (<a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;T&gt;</a>&amp;,  <span class="comment">// System Matrix</span>
<a name="l00126"></a>00126                                                <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp;, <span class="comment">// Solution vector</span>
<a name="l00127"></a>00127                                                <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp;, <span class="comment">// RHS vector</span>
<a name="l00128"></a>00128                                                <span class="keyword">const</span> <span class="keywordtype">double</span>,      <span class="comment">// Stopping tolerance</span>
<a name="l00129"></a>00129                                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>) = 0; <span class="comment">// N. Iterations</span>
<a name="l00130"></a>00130   
<a name="l00131"></a>00131 
<a name="l00132"></a>00132 
<a name="l00138"></a>00138   <span class="keyword">virtual</span> std::pair&lt;unsigned int, Real&gt; <a class="code" href="classlibMesh_1_1LinearSolver.php#a9663fee6659bd9705e72142d5e42a02a">solve</a> (<a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;T&gt;</a>&amp;,  <span class="comment">// System Matrix</span>
<a name="l00139"></a>00139                                                <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;T&gt;</a>&amp;,  <span class="comment">// Preconditioning Matrix</span>
<a name="l00140"></a>00140                                                <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp;, <span class="comment">// Solution vector</span>
<a name="l00141"></a>00141                                                <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp;, <span class="comment">// RHS vector</span>
<a name="l00142"></a>00142                                                <span class="keyword">const</span> <span class="keywordtype">double</span>,      <span class="comment">// Stopping tolerance</span>
<a name="l00143"></a>00143                                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>) = 0; <span class="comment">// N. Iterations</span>
<a name="l00144"></a>00144   
<a name="l00151"></a>00151   std::pair&lt;unsigned int, Real&gt; <a class="code" href="classlibMesh_1_1LinearSolver.php#a9663fee6659bd9705e72142d5e42a02a">solve</a> (<a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;T&gt;</a>&amp; matrix,
<a name="l00152"></a>00152                                        <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;T&gt;</a>* precond_matrix,
<a name="l00153"></a>00153                                        <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp;, <span class="comment">// Solution vector</span>
<a name="l00154"></a>00154                                        <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp;, <span class="comment">// RHS vector</span>
<a name="l00155"></a>00155                                        <span class="keyword">const</span> <span class="keywordtype">double</span>,      <span class="comment">// Stopping tolerance</span>
<a name="l00156"></a>00156                                        <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>); <span class="comment">// N. Iterations</span>
<a name="l00157"></a>00157   
<a name="l00158"></a>00158 
<a name="l00159"></a>00159 
<a name="l00163"></a>00163   <span class="keyword">virtual</span> std::pair&lt;unsigned int, Real&gt; <a class="code" href="classlibMesh_1_1LinearSolver.php#a9663fee6659bd9705e72142d5e42a02a">solve</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ShellMatrix.php">ShellMatrix&lt;T&gt;</a>&amp; shell_matrix,
<a name="l00164"></a>00164                                                <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp;, <span class="comment">// Solution vector</span>
<a name="l00165"></a>00165                                                <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp;, <span class="comment">// RHS vector</span>
<a name="l00166"></a>00166                                                <span class="keyword">const</span> <span class="keywordtype">double</span>,      <span class="comment">// Stopping tolerance</span>
<a name="l00167"></a>00167                                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>) = 0; <span class="comment">// N. Iterations</span>
<a name="l00168"></a>00168   
<a name="l00169"></a>00169 
<a name="l00170"></a>00170 
<a name="l00176"></a>00176   <span class="keyword">virtual</span> std::pair&lt;unsigned int, Real&gt; <a class="code" href="classlibMesh_1_1LinearSolver.php#a9663fee6659bd9705e72142d5e42a02a">solve</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ShellMatrix.php">ShellMatrix&lt;T&gt;</a>&amp; shell_matrix,
<a name="l00177"></a>00177                                                <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;T&gt;</a>&amp; precond_matrix,
<a name="l00178"></a>00178                                                <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp;, <span class="comment">// Solution vector</span>
<a name="l00179"></a>00179                                                <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp;, <span class="comment">// RHS vector</span>
<a name="l00180"></a>00180                                                <span class="keyword">const</span> <span class="keywordtype">double</span>,      <span class="comment">// Stopping tolerance</span>
<a name="l00181"></a>00181                                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>) = 0; <span class="comment">// N. Iterations</span>
<a name="l00182"></a>00182   
<a name="l00183"></a>00183 
<a name="l00188"></a>00188   std::pair&lt;unsigned int, Real&gt; <a class="code" href="classlibMesh_1_1LinearSolver.php#a9663fee6659bd9705e72142d5e42a02a">solve</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ShellMatrix.php">ShellMatrix&lt;T&gt;</a>&amp; matrix,
<a name="l00189"></a>00189                                        <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;T&gt;</a>* precond_matrix,
<a name="l00190"></a>00190                                        <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp;, <span class="comment">// Solution vector</span>
<a name="l00191"></a>00191                                        <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp;, <span class="comment">// RHS vector</span>
<a name="l00192"></a>00192                                        <span class="keyword">const</span> <span class="keywordtype">double</span>,      <span class="comment">// Stopping tolerance</span>
<a name="l00193"></a>00193                                        <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>); <span class="comment">// N. Iterations</span>
<a name="l00194"></a>00194 
<a name="l00195"></a>00195 
<a name="l00200"></a>00200   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LinearSolver.php#ad063b25723b72da51aa8e1e3fcf72454">print_converged_reason</a>() = 0;
<a name="l00201"></a>00201   
<a name="l00208"></a><a class="code" href="classlibMesh_1_1LinearSolver.php#a851fb44823b601cd8502fd7688266c29">00208</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1LinearSolver.php#a851fb44823b601cd8502fd7688266c29">same_preconditioner</a>;
<a name="l00209"></a>00209   
<a name="l00210"></a>00210 <span class="keyword">protected</span>:
<a name="l00211"></a>00211 
<a name="l00212"></a>00212   
<a name="l00216"></a><a class="code" href="classlibMesh_1_1LinearSolver.php#a6b64a30f2023ff38c662536f79a4451a">00216</a>   <a class="code" href="namespacelibMeshEnums.php#a6ecf91f56b4ab5cda4d3d0a468733b19">SolverType</a> <a class="code" href="classlibMesh_1_1LinearSolver.php#a6b64a30f2023ff38c662536f79a4451a">_solver_type</a>;
<a name="l00217"></a>00217 
<a name="l00221"></a><a class="code" href="classlibMesh_1_1LinearSolver.php#a866f963e86c384dc28fb3dbec70c5b39">00221</a>   <a class="code" href="namespacelibMeshEnums.php#a45b101a23b532f020f46f412485db0d4">PreconditionerType</a> <a class="code" href="classlibMesh_1_1LinearSolver.php#a866f963e86c384dc28fb3dbec70c5b39">_preconditioner_type</a>;
<a name="l00222"></a>00222   
<a name="l00226"></a><a class="code" href="classlibMesh_1_1LinearSolver.php#a97da17452484aa8121282f15248b8b9a">00226</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1LinearSolver.php#a97da17452484aa8121282f15248b8b9a">_is_initialized</a>;
<a name="l00227"></a>00227 
<a name="l00231"></a><a class="code" href="classlibMesh_1_1LinearSolver.php#a1764c79388b56d08361c785aa265add0">00231</a>   <a class="code" href="classlibMesh_1_1Preconditioner.php">Preconditioner&lt;T&gt;</a> * <a class="code" href="classlibMesh_1_1LinearSolver.php#a1764c79388b56d08361c785aa265add0">_preconditioner</a>;
<a name="l00232"></a>00232 };
<a name="l00233"></a>00233 
<a name="l00234"></a>00234 
<a name="l00235"></a>00235 
<a name="l00236"></a>00236 
<a name="l00237"></a>00237 <span class="comment">/*----------------------- inline functions ----------------------------------*/</span>
<a name="l00238"></a>00238 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00239"></a>00239 <span class="keyword">inline</span>
<a name="l00240"></a><a class="code" href="classlibMesh_1_1LinearSolver.php#a7664a50fd17b8c7b0b3ae3aa11d1d8b5">00240</a> <a class="code" href="classlibMesh_1_1LinearSolver.php#a7664a50fd17b8c7b0b3ae3aa11d1d8b5">LinearSolver&lt;T&gt;::LinearSolver</a> () :
<a name="l00241"></a>00241 
<a name="l00242"></a>00242   same_preconditioner  (false),
<a name="l00243"></a>00243   _solver_type         (<a class="code" href="namespacelibMeshEnums.php#a6ecf91f56b4ab5cda4d3d0a468733b19a28c6a4ecccca1d0e6956e5e94fa82d97">GMRES</a>),
<a name="l00244"></a>00244   _preconditioner_type (<a class="code" href="namespacelibMeshEnums.php#a45b101a23b532f020f46f412485db0d4af54549e0e69fbdd4ddd199ee316527f3">ILU_PRECOND</a>),
<a name="l00245"></a>00245   <a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#ab8b7115ea57ced35ec86d1fdfa0ab853">_is_initialized</a>      (false),
<a name="l00246"></a>00246   _preconditioner      (NULL)
<a name="l00247"></a>00247 {
<a name="l00248"></a>00248 }
<a name="l00249"></a>00249 
<a name="l00250"></a>00250 
<a name="l00251"></a>00251 
<a name="l00252"></a>00252 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00253"></a>00253 <span class="keyword">inline</span>
<a name="l00254"></a><a class="code" href="classlibMesh_1_1LinearSolver.php#ad9e59180733648633468f45b43fb2be0">00254</a> <a class="code" href="classlibMesh_1_1LinearSolver.php#ad9e59180733648633468f45b43fb2be0">LinearSolver&lt;T&gt;::~LinearSolver</a> ()
<a name="l00255"></a>00255 {
<a name="l00256"></a>00256   this-&gt;clear ();
<a name="l00257"></a>00257 }
<a name="l00258"></a>00258 
<a name="l00259"></a>00259 
<a name="l00260"></a>00260 
<a name="l00261"></a>00261 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00262"></a>00262 <span class="keyword">inline</span>
<a name="l00263"></a>00263 std::pair&lt;unsigned int, Real&gt; 
<a name="l00264"></a><a class="code" href="classlibMesh_1_1LinearSolver.php#af3da3257c681022416a6f20b94c60eed">00264</a> <a class="code" href="classlibMesh_1_1LinearSolver.php#a9663fee6659bd9705e72142d5e42a02a">LinearSolver&lt;T&gt;::solve</a> (<a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;T&gt;</a>&amp;   mat,
<a name="l00265"></a>00265                         <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;T&gt;</a>*   pc_mat,
<a name="l00266"></a>00266                         <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp;  sol,
<a name="l00267"></a>00267                         <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp;  rhs,
<a name="l00268"></a>00268                         <span class="keyword">const</span> <span class="keywordtype">double</span>       tol,
<a name="l00269"></a>00269                         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_iter)
<a name="l00270"></a>00270 {
<a name="l00271"></a>00271   <span class="keywordflow">if</span> (pc_mat)
<a name="l00272"></a>00272     <span class="keywordflow">return</span> this-&gt;solve(mat, *pc_mat, sol, rhs, tol, n_iter);
<a name="l00273"></a>00273   <span class="keywordflow">else</span>
<a name="l00274"></a>00274     <span class="keywordflow">return</span> this-&gt;solve(mat, sol, rhs, tol, n_iter);
<a name="l00275"></a>00275 }
<a name="l00276"></a>00276 
<a name="l00277"></a>00277 
<a name="l00278"></a>00278 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00279"></a>00279 <span class="keyword">inline</span>
<a name="l00280"></a>00280 std::pair&lt;unsigned int, Real&gt; 
<a name="l00281"></a><a class="code" href="classlibMesh_1_1LinearSolver.php#acc0164941ecaaf3e877fcb5fa89750f6">00281</a> <a class="code" href="classlibMesh_1_1LinearSolver.php#a9663fee6659bd9705e72142d5e42a02a">LinearSolver&lt;T&gt;::solve</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ShellMatrix.php">ShellMatrix&lt;T&gt;</a>&amp;  mat,
<a name="l00282"></a>00282                         <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;T&gt;</a>* pc_mat,
<a name="l00283"></a>00283                         <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp;      sol,
<a name="l00284"></a>00284                         <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp;      rhs,
<a name="l00285"></a>00285                         <span class="keyword">const</span> <span class="keywordtype">double</span>           tol,
<a name="l00286"></a>00286                         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>     n_iter)
<a name="l00287"></a>00287 {
<a name="l00288"></a>00288   <span class="keywordflow">if</span> (pc_mat)
<a name="l00289"></a>00289     <span class="keywordflow">return</span> this-&gt;solve(mat, *pc_mat, sol, rhs, tol, n_iter);
<a name="l00290"></a>00290   <span class="keywordflow">else</span>
<a name="l00291"></a>00291     <span class="keywordflow">return</span> this-&gt;solve(mat, sol, rhs, tol, n_iter);
<a name="l00292"></a>00292 }
<a name="l00293"></a>00293 
<a name="l00294"></a>00294 } <span class="comment">// namespace libMesh</span>
<a name="l00295"></a>00295 
<a name="l00296"></a>00296 
<a name="l00297"></a>00297 <span class="preprocessor">#endif // #ifdef __solver_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
