<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_eaf30c8ea092d33f79a04353c3899c3f.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_27db52e6851444e0b713c4090c23f4e5.php">mesh</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">mesh_output.h</div>  </div>
</div>
<div class="contents">
<a href="mesh__output_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id$</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __mesh_output_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __mesh_output_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// C++ includes</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &lt;limits&gt;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &lt;string&gt;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="comment">// Local includes</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="mesh__base_8h.php">mesh_base.h</a>&quot;</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="keyword">namespace </span>libMesh
<a name="l00036"></a>00036 {
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="comment">// Forward declares</span>
<a name="l00039"></a>00039 <span class="keyword">class </span>EquationSystems;
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 
<a name="l00052"></a>00052 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00053"></a>00053 <span class="comment">// MeshOutput class definition</span>
<a name="l00054"></a>00054 <span class="keyword">template</span> &lt;<span class="keyword">class</span> MT&gt;
<a name="l00055"></a><a class="code" href="classlibMesh_1_1MeshOutput.php">00055</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1MeshOutput.php">MeshOutput</a>
<a name="l00056"></a>00056 {
<a name="l00057"></a>00057  <span class="keyword">protected</span>:
<a name="l00058"></a>00058 
<a name="l00063"></a>00063   <a class="code" href="classlibMesh_1_1MeshOutput.php#ac2740ce5da0de308bc674ec909fabeca">MeshOutput</a> (<span class="keyword">const</span> <span class="keywordtype">bool</span> is_parallel_format = <span class="keyword">false</span>);
<a name="l00064"></a>00064   
<a name="l00069"></a>00069   <a class="code" href="classlibMesh_1_1MeshOutput.php#ac2740ce5da0de308bc674ec909fabeca">MeshOutput</a> (<span class="keyword">const</span> MT&amp;, <span class="keyword">const</span> <span class="keywordtype">bool</span> is_parallel_format = <span class="keyword">false</span>);
<a name="l00070"></a>00070 
<a name="l00071"></a>00071   
<a name="l00072"></a>00072  <span class="keyword">public</span>:
<a name="l00073"></a>00073 
<a name="l00077"></a>00077   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1MeshOutput.php#a3e41e1697e94306f2129945f92e69956">~MeshOutput</a> ();
<a name="l00078"></a>00078   
<a name="l00082"></a>00082   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshOutput.php#adfd070df2ff977f3d3816c8de1c9fede">write</a> (<span class="keyword">const</span> std::string&amp;) = 0;
<a name="l00083"></a>00083 
<a name="l00088"></a>00088   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshOutput.php#a935598198649f4b831cd341ce91b3ccb">write_equation_systems</a> (<span class="keyword">const</span> std::string&amp;,
<a name="l00089"></a>00089                                        <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp;);
<a name="l00090"></a>00090 
<a name="l00095"></a><a class="code" href="classlibMesh_1_1MeshOutput.php#af42dcec7bd619290b567ddd36f294b37">00095</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshOutput.php#af42dcec7bd619290b567ddd36f294b37">write_nodal_data</a> (<span class="keyword">const</span> std::string&amp;,
<a name="l00096"></a>00096                                  <span class="keyword">const</span> std::vector&lt;Number&gt;&amp;,
<a name="l00097"></a>00097                                  <span class="keyword">const</span> std::vector&lt;std::string&gt;&amp;)
<a name="l00098"></a>00098   { libmesh_error(); }
<a name="l00099"></a>00099 
<a name="l00107"></a>00107   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> &amp; <a class="code" href="classlibMesh_1_1MeshOutput.php#aebe297e0e168bb3429ae06f23f5f3568">ascii_precision</a> ();
<a name="l00108"></a>00108   
<a name="l00109"></a>00109  <span class="keyword">protected</span>:
<a name="l00110"></a>00110 
<a name="l00111"></a>00111 
<a name="l00115"></a>00115   <span class="keyword">const</span> MT&amp; <a class="code" href="classlibMesh_1_1MeshOutput.php#ab5720c977b43a80f3e9d29bd3eedb173">mesh</a>() <span class="keyword">const</span>;
<a name="l00116"></a>00116 
<a name="l00117"></a>00117   
<a name="l00118"></a>00118  <span class="keyword">private</span>:
<a name="l00119"></a>00119   
<a name="l00120"></a>00120 
<a name="l00125"></a><a class="code" href="classlibMesh_1_1MeshOutput.php#a94ceaebea8bedc59a04806a09acdbf09">00125</a>   <span class="keyword">const</span> MT* <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshOutput.php#a94ceaebea8bedc59a04806a09acdbf09">_obj</a>;
<a name="l00126"></a>00126 
<a name="l00130"></a><a class="code" href="classlibMesh_1_1MeshOutput.php#a2654984c149226ca61ee7d10996dd4e3">00130</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1MeshOutput.php#a2654984c149226ca61ee7d10996dd4e3">_ascii_precision</a>;
<a name="l00131"></a>00131 
<a name="l00137"></a><a class="code" href="classlibMesh_1_1MeshOutput.php#a0b28b0e8e7d99921d181c7c122384d0d">00137</a>   <span class="keyword">const</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1MeshOutput.php#a0b28b0e8e7d99921d181c7c122384d0d">_is_parallel_format</a>;
<a name="l00138"></a>00138 
<a name="l00143"></a>00143   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshOutput.php#a857527791ede849b66d75c43272cdbe3">_build_variable_names_and_solution_vector</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00144"></a>00144                                                  std::vector&lt;Number&gt;&amp; soln,
<a name="l00145"></a>00145                                                  std::vector&lt;std::string&gt;&amp; names);
<a name="l00146"></a>00146 };
<a name="l00147"></a>00147 
<a name="l00148"></a>00148 
<a name="l00149"></a>00149 
<a name="l00150"></a>00150 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00151"></a>00151 <span class="comment">// MeshOutput inline members</span>
<a name="l00152"></a>00152 <span class="keyword">template</span> &lt;<span class="keyword">class</span> MT&gt;
<a name="l00153"></a>00153 <span class="keyword">inline</span>
<a name="l00154"></a><a class="code" href="classlibMesh_1_1MeshOutput.php#ac2740ce5da0de308bc674ec909fabeca">00154</a> <a class="code" href="classlibMesh_1_1MeshOutput.php#ac2740ce5da0de308bc674ec909fabeca">MeshOutput&lt;MT&gt;::MeshOutput</a> (<span class="keyword">const</span> <span class="keywordtype">bool</span> is_parallel_format) :
<a name="l00155"></a>00155   _obj(NULL),
<a name="l00156"></a>00156   _ascii_precision (std::numeric_limits&lt;<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>&gt;::digits10 + 2),
<a name="l00157"></a>00157   _is_parallel_format(is_parallel_format)
<a name="l00158"></a>00158 {}
<a name="l00159"></a>00159 
<a name="l00160"></a>00160 
<a name="l00161"></a>00161 
<a name="l00162"></a>00162 <span class="keyword">template</span> &lt;<span class="keyword">class</span> MT&gt;
<a name="l00163"></a>00163 <span class="keyword">inline</span>
<a name="l00164"></a><a class="code" href="classlibMesh_1_1MeshOutput.php#aa958f3a4f2c40805e2dbe330eb61b42a">00164</a> <a class="code" href="classlibMesh_1_1MeshOutput.php#ac2740ce5da0de308bc674ec909fabeca">MeshOutput&lt;MT&gt;::MeshOutput</a> (<span class="keyword">const</span> MT&amp; obj, <span class="keyword">const</span> <span class="keywordtype">bool</span> is_parallel_format) :
<a name="l00165"></a>00165   _obj (&amp;obj),
<a name="l00166"></a>00166   _ascii_precision (std::numeric_limits&lt;<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>&gt;::digits10 + 2),
<a name="l00167"></a>00167   _is_parallel_format(is_parallel_format)
<a name="l00168"></a>00168 {
<a name="l00169"></a>00169   <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1MeshOutput.php#a0b28b0e8e7d99921d181c7c122384d0d">_is_parallel_format</a> &amp;&amp; !this-&gt;<a class="code" href="classlibMesh_1_1MeshOutput.php#ab5720c977b43a80f3e9d29bd3eedb173">mesh</a>().is_serial())
<a name="l00170"></a>00170     {
<a name="l00171"></a>00171       <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l00172"></a>00172         {
<a name="l00173"></a>00173           libmesh_do_once(<a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; 
<a name="l00174"></a>00174             <span class="stringliteral">&quot;Warning:  This MeshOutput subclass only support meshes which have been serialized!&quot;</span>
<a name="l00175"></a>00175             &lt;&lt; std::endl; libmesh_here(););
<a name="l00176"></a>00176         }
<a name="l00177"></a>00177 <span class="comment">//      libmesh_error();</span>
<a name="l00178"></a>00178     }
<a name="l00179"></a>00179 }
<a name="l00180"></a>00180 
<a name="l00181"></a>00181 
<a name="l00182"></a>00182 
<a name="l00183"></a>00183 <span class="keyword">template</span> &lt;<span class="keyword">class</span> MT&gt;
<a name="l00184"></a>00184 <span class="keyword">inline</span>
<a name="l00185"></a><a class="code" href="classlibMesh_1_1MeshOutput.php#a3e41e1697e94306f2129945f92e69956">00185</a> <a class="code" href="classlibMesh_1_1MeshOutput.php#a3e41e1697e94306f2129945f92e69956">MeshOutput&lt;MT&gt;::~MeshOutput</a> ()
<a name="l00186"></a>00186 {
<a name="l00187"></a>00187 }
<a name="l00188"></a>00188 
<a name="l00189"></a>00189 
<a name="l00190"></a>00190 
<a name="l00191"></a>00191 <span class="keyword">template</span> &lt;<span class="keyword">class</span> MT&gt;
<a name="l00192"></a>00192 <span class="keyword">inline</span>
<a name="l00193"></a><a class="code" href="classlibMesh_1_1MeshOutput.php#a935598198649f4b831cd341ce91b3ccb">00193</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshOutput.php#a935598198649f4b831cd341ce91b3ccb">MeshOutput&lt;MT&gt;::write_equation_systems</a> (<span class="keyword">const</span> std::string&amp; fname,
<a name="l00194"></a>00194                                              <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es)
<a name="l00195"></a>00195 {
<a name="l00196"></a>00196   <span class="comment">// Build the nodal solution values &amp; get the variable</span>
<a name="l00197"></a>00197   <span class="comment">// names from the EquationSystems object</span>
<a name="l00198"></a>00198   std::vector&lt;Number&gt;      soln;
<a name="l00199"></a>00199   std::vector&lt;std::string&gt; names;
<a name="l00200"></a>00200 
<a name="l00201"></a>00201   this-&gt;_build_variable_names_and_solution_vector(es, soln, names);
<a name="l00202"></a>00202   <span class="comment">//es.build_variable_names  (names);</span>
<a name="l00203"></a>00203   <span class="comment">//es.build_solution_vector (soln);</span>
<a name="l00204"></a>00204 
<a name="l00205"></a>00205   this-&gt;write_nodal_data (fname, soln, names);  
<a name="l00206"></a>00206 }
<a name="l00207"></a>00207 
<a name="l00208"></a>00208 
<a name="l00209"></a>00209 
<a name="l00210"></a>00210 <span class="keyword">template</span> &lt;<span class="keyword">class</span> MT&gt;
<a name="l00211"></a>00211 <span class="keyword">inline</span>
<a name="l00212"></a><a class="code" href="classlibMesh_1_1MeshOutput.php#ab5720c977b43a80f3e9d29bd3eedb173">00212</a> <span class="keyword">const</span> MT&amp; <a class="code" href="classlibMesh_1_1MeshOutput.php#ab5720c977b43a80f3e9d29bd3eedb173">MeshOutput&lt;MT&gt;::mesh</a> ()<span class="keyword"> const</span>
<a name="l00213"></a>00213 <span class="keyword"></span>{
<a name="l00214"></a>00214   libmesh_assert (_obj != NULL);
<a name="l00215"></a>00215   <span class="keywordflow">return</span> *_obj;
<a name="l00216"></a>00216 }
<a name="l00217"></a>00217 
<a name="l00218"></a>00218 
<a name="l00219"></a>00219 
<a name="l00220"></a>00220 <span class="keyword">template</span> &lt;<span class="keyword">class</span> MT&gt;
<a name="l00221"></a>00221 <span class="keyword">inline</span>
<a name="l00222"></a><a class="code" href="classlibMesh_1_1MeshOutput.php#aebe297e0e168bb3429ae06f23f5f3568">00222</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> &amp; <a class="code" href="classlibMesh_1_1MeshOutput.php#aebe297e0e168bb3429ae06f23f5f3568">MeshOutput&lt;MT&gt;::ascii_precision</a> ()
<a name="l00223"></a>00223 {
<a name="l00224"></a>00224   <span class="keywordflow">return</span> _ascii_precision;
<a name="l00225"></a>00225 }
<a name="l00226"></a>00226 
<a name="l00227"></a>00227 
<a name="l00228"></a>00228 } <span class="comment">// namespace libMesh</span>
<a name="l00229"></a>00229 
<a name="l00230"></a>00230 
<a name="l00231"></a>00231 <span class="preprocessor">#endif // #define __mesh_io_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
