<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li class="current"><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="namespaces.php"><span>Namespace&#160;List</span></a></li>
      <li><a href="namespacemembers.php"><span>Namespace&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="namespacelibMesh.php">libMesh</a>      </li>
      <li class="navelem"><a class="el" href="namespacelibMesh_1_1MeshTools.php">MeshTools</a>      </li>
      <li class="navelem"><a class="el" href="namespacelibMesh_1_1MeshTools_1_1Private.php">Private</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#func-members">Functions</a>  </div>
  <div class="headertitle">
<div class="title">libMesh::MeshTools::Private Namespace Reference</div>  </div>
</div>
<div class="contents">
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="func-members"></a>
Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacelibMesh_1_1MeshTools_1_1Private.php#a6250f59b9180229182c52939a4511363">globally_renumber_nodes_and_elements</a> (<a class="el" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp;)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacelibMesh_1_1MeshTools_1_1Private.php#a767e57ef66c9f372a1ee424e8caadd0d">fix_broken_node_and_element_numbering</a> (<a class="el" href="classlibMesh_1_1SerialMesh.php">SerialMesh</a> &amp;)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacelibMesh_1_1MeshTools_1_1Private.php#a81ab9c0c01029360801a74f33f0a048a">fix_broken_node_and_element_numbering</a> (<a class="el" href="classlibMesh_1_1ParallelMesh.php">ParallelMesh</a> &amp;)</td></tr>
</table>
<hr/><h2>Function Documentation</h2>
<a class="anchor" id="a767e57ef66c9f372a1ee424e8caadd0d"></a><!-- doxytag: member="libMesh::MeshTools::Private::fix_broken_node_and_element_numbering" ref="a767e57ef66c9f372a1ee424e8caadd0d" args="(SerialMesh &amp;)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void libMesh::MeshTools::Private::fix_broken_node_and_element_numbering </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classlibMesh_1_1SerialMesh.php">SerialMesh</a> &amp;&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>There is no reason for a user to ever call this function.</p>
<p>This function restores a previously broken element/node numbering such that <code>mesh.node(n)-&gt;id()</code> == n. </p>

<p>Definition at line <a class="el" href="mesh__tools_8C_source.php#l01021">1021</a> of file <a class="el" href="mesh__tools_8C_source.php">mesh_tools.C</a>.</p>

<p>References <a class="el" href="serial__mesh_8h_source.php#l00316">libMesh::SerialMesh::_elements</a>, and <a class="el" href="serial__mesh_8h_source.php#l00311">libMesh::SerialMesh::_nodes</a>.</p>

<p>Referenced by <a class="el" href="equation__systems__io_8C_source.php#l00137">libMesh::EquationSystems::_read_impl()</a>, and <a class="el" href="equation__systems__io_8C_source.php#l00368">libMesh::EquationSystems::write()</a>.</p>
<div class="fragment"><pre class="fragment">{
   <span class="comment">// Nodes first</span>
  <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;mesh.<a class="code" href="classlibMesh_1_1SerialMesh.php#acbd817716d57198397acb97dadf45ff8">_nodes</a>.size(); n++)
    <span class="keywordflow">if</span> (mesh.<a class="code" href="classlibMesh_1_1SerialMesh.php#acbd817716d57198397acb97dadf45ff8">_nodes</a>[n] != NULL)
      mesh.<a class="code" href="classlibMesh_1_1SerialMesh.php#acbd817716d57198397acb97dadf45ff8">_nodes</a>[n]-&gt;set_id() = n;

  <span class="comment">// Elements next</span>
  <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e=0; e&lt;mesh.<a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.size(); e++)
    <span class="keywordflow">if</span> (mesh.<a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>[e] != NULL)
      mesh.<a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>[e]-&gt;set_id() = e; 
}
</pre></div>
</div>
</div>
<a class="anchor" id="a81ab9c0c01029360801a74f33f0a048a"></a><!-- doxytag: member="libMesh::MeshTools::Private::fix_broken_node_and_element_numbering" ref="a81ab9c0c01029360801a74f33f0a048a" args="(ParallelMesh &amp;)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void libMesh::MeshTools::Private::fix_broken_node_and_element_numbering </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classlibMesh_1_1ParallelMesh.php">ParallelMesh</a> &amp;&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>There is no reason for a user to ever call this function.</p>
<p>This function restores a previously broken element/node numbering such that <code>mesh.node(n)-&gt;id()</code> == n. </p>

<p>Definition at line <a class="el" href="mesh__tools_8C_source.php#l01036">1036</a> of file <a class="el" href="mesh__tools_8C_source.php">mesh_tools.C</a>.</p>

<p>References <a class="el" href="parallel__mesh_8h_source.php#l00379">libMesh::ParallelMesh::_elements</a>, <a class="el" href="parallel__mesh_8h_source.php#l00374">libMesh::ParallelMesh::_nodes</a>, <a class="el" href="mapvector_8h_source.php#l00128">libMesh::mapvector&lt; Val &gt;::begin()</a>, and <a class="el" href="mapvector_8h_source.php#l00136">libMesh::mapvector&lt; Val &gt;::end()</a>.</p>
<div class="fragment"><pre class="fragment">{
  <span class="comment">// We need access to iterators for the underlying containers,</span>
  <span class="comment">// not the mapvector&lt;&gt; reimplementations.</span>
  <a class="code" href="classlibMesh_1_1mapvector.php">mapvector&lt;Node*&gt;::maptype</a> &amp;nodes = mesh.<a class="code" href="classlibMesh_1_1ParallelMesh.php#a93dcd617abf4505ab8628472eb1cce90">_nodes</a>;
  <a class="code" href="classlibMesh_1_1mapvector.php">mapvector&lt;Elem*&gt;::maptype</a> &amp;elem  = mesh.<a class="code" href="classlibMesh_1_1ParallelMesh.php#a0ccc1060937df3ec67ded54440e6590e">_elements</a>;
  
  <span class="comment">// Nodes first</span>
  {
    <a class="code" href="classlibMesh_1_1mapvector.php">mapvector&lt;Node*&gt;::maptype::iterator</a>
      it  = nodes.<a class="code" href="classlibMesh_1_1mapvector.php#a707b45f1d69a9ef9a214343b85d402da">begin</a>(),
      end = nodes.<a class="code" href="classlibMesh_1_1mapvector.php#a89fd9cbe464dc374f033283ecbb9d200">end</a>();

    <span class="keywordflow">for</span> (; it != end; ++it)
      <span class="keywordflow">if</span> (it-&gt;second != NULL)
        it-&gt;second-&gt;set_id() = it-&gt;first;
  }

  <span class="comment">// Elements next</span>
  {
    <a class="code" href="classlibMesh_1_1mapvector.php">mapvector&lt;Elem*&gt;::maptype::iterator</a>
      it  = elem.<a class="code" href="classlibMesh_1_1mapvector.php#a707b45f1d69a9ef9a214343b85d402da">begin</a>(),
      end = elem.<a class="code" href="classlibMesh_1_1mapvector.php#a89fd9cbe464dc374f033283ecbb9d200">end</a>();

    <span class="keywordflow">for</span> (; it != end; ++it)
      <span class="keywordflow">if</span> (it-&gt;second != NULL)
        it-&gt;second-&gt;set_id() = it-&gt;first;
  }
}
</pre></div>
</div>
</div>
<a class="anchor" id="a6250f59b9180229182c52939a4511363"></a><!-- doxytag: member="libMesh::MeshTools::Private::globally_renumber_nodes_and_elements" ref="a6250f59b9180229182c52939a4511363" args="(MeshBase &amp;)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void libMesh::MeshTools::Private::globally_renumber_nodes_and_elements </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp;&#160;</td>
          <td class="paramname"><em>mesh</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>There is no reason for a user to ever call this function.</p>
<p>This function determines partition-agnostic global indices for all nodes and elements in the mesh. Note that after this function is called the mesh will likely be in an inconsistent state, i.e. <code>mesh.nodes(i)-&gt;id()</code> != i in the nodes container. Direct node/element access via the <code>mesh.node(n)</code> or <code>mesh.elem(e)</code> functions will likely fail. The original numbering can (and should) be restored with a subsequent call to <code>fix_node_and_element_numbering()</code>. </p>

<p>Definition at line <a class="el" href="mesh__tools_8C_source.php#l01014">1014</a> of file <a class="el" href="mesh__tools_8C_source.php">mesh_tools.C</a>.</p>

<p>References <a class="el" href="mesh__communication__global__indices_8C_source.php#l00177">libMesh::MeshCommunication::assign_global_indices()</a>.</p>

<p>Referenced by <a class="el" href="equation__systems__io_8C_source.php#l00137">libMesh::EquationSystems::_read_impl()</a>, and <a class="el" href="equation__systems__io_8C_source.php#l00368">libMesh::EquationSystems::write()</a>.</p>
<div class="fragment"><pre class="fragment">{
  <a class="code" href="classlibMesh_1_1MeshCommunication.php">MeshCommunication</a>().<a class="code" href="classlibMesh_1_1MeshCommunication.php#ac07c8ba8aee328c186d853666dca4aa0">assign_global_indices</a>(mesh);
}
</pre></div>
</div>
</div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
