<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_c3a49989e40b21e7508f29d2dc962def.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_32bb88e3eb1b93402cfe508abee484a3.php">mesh</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">nemesis_io.C</div>  </div>
</div>
<div class="contents">
<a href="nemesis__io_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id$</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="comment">// C++ includes</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &lt;numeric&gt;</span> <span class="comment">// std::accumulate</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="comment">// LibMesh includes</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="elem_8h.php">elem.h</a>&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="exodusII__io_8h.php">exodusII_io.h</a>&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="nemesis__io_8h.php">nemesis_io.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="nemesis__io__helper_8h.php">nemesis_io_helper.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="node_8h.php">node.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="parallel__mesh_8h.php">parallel_mesh.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="parallel_8h.php">parallel.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="utility_8h.php">utility.h</a>&quot;</span> <span class="comment">// is_sorted, deallocate</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="keyword">namespace </span>libMesh
<a name="l00035"></a>00035 {
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="comment">//-----------------------------------------------</span>
<a name="l00039"></a>00039 <span class="comment">// anonymous namespace for implementation details</span>
<a name="l00040"></a>00040 <span class="keyword">namespace </span>{
<a name="l00041"></a>00041   <span class="keyword">struct </span>CompareGlobalIdxMappings
<a name="l00042"></a>00042   {
<a name="l00043"></a>00043     <span class="comment">// strict weak ordering for a.first -&gt; a.second mapping.  since we can only map to one</span>
<a name="l00044"></a>00044     <span class="comment">// value only order the first entry</span>
<a name="l00045"></a>00045     <span class="keywordtype">bool</span> operator()(<span class="keyword">const</span> std::pair&lt;unsigned int, unsigned int&gt; &amp;a,
<a name="l00046"></a>00046                     <span class="keyword">const</span> std::pair&lt;unsigned int, unsigned int&gt; &amp;b)<span class="keyword"> const </span>
<a name="l00047"></a>00047 <span class="keyword">    </span>{ <span class="keywordflow">return</span> a.first &lt; b.first; }
<a name="l00048"></a>00048     
<a name="l00049"></a>00049     <span class="comment">// strict weak ordering for a.first -&gt; a.second mapping.  lookups will</span>
<a name="l00050"></a>00050     <span class="comment">// be in terms of a single integer, which is why we need this method.</span>
<a name="l00051"></a>00051     <span class="keywordtype">bool</span> operator()(<span class="keyword">const</span> std::pair&lt;unsigned int, unsigned int&gt; &amp;a,
<a name="l00052"></a>00052                     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> b)<span class="keyword"> const </span>
<a name="l00053"></a>00053 <span class="keyword">    </span>{ <span class="keywordflow">return</span> a.first &lt; b; }
<a name="l00054"></a>00054   };
<a name="l00055"></a>00055 
<a name="l00056"></a>00056   <span class="comment">// Nemesis &amp; ExodusII use int for all integer values, even the ones which </span>
<a name="l00057"></a>00057   <span class="comment">// should never be negative.  we like to use unsigned as a force of habit,</span>
<a name="l00058"></a>00058   <span class="comment">// this trivial little method saves some typing &amp; also makes sure something</span>
<a name="l00059"></a>00059   <span class="comment">// is not horribly wrong.</span>
<a name="l00060"></a>00060   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00061"></a>00061   <span class="keyword">inline</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> to_uint ( <span class="keyword">const</span> T &amp;t ) 
<a name="l00062"></a>00062   {
<a name="l00063"></a>00063     libmesh_assert (t == static_cast&lt;T&gt;(static_cast&lt;unsigned int&gt;(t)));
<a name="l00064"></a>00064 
<a name="l00065"></a>00065     <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(t); 
<a name="l00066"></a>00066   }
<a name="l00067"></a>00067 
<a name="l00068"></a>00068   <span class="comment">// test equality for a.first -&gt; a.second mapping.  since we can only map to one</span>
<a name="l00069"></a>00069   <span class="comment">// value only test the first entry</span>
<a name="l00070"></a>00070   <span class="keyword">inline</span> <span class="keywordtype">bool</span> global_idx_mapping_equality (<span class="keyword">const</span> std::pair&lt;unsigned int, unsigned int&gt; &amp;a,
<a name="l00071"></a>00071                                            <span class="keyword">const</span> std::pair&lt;unsigned int, unsigned int&gt; &amp;b)
<a name="l00072"></a>00072   { <span class="keywordflow">return</span> a.first == b.first; }
<a name="l00073"></a>00073 }
<a name="l00074"></a>00074 
<a name="l00075"></a>00075 
<a name="l00076"></a>00076 
<a name="l00077"></a>00077 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00078"></a>00078 <span class="comment">// Nemesis_IO class members</span>
<a name="l00079"></a><a class="code" href="classlibMesh_1_1Nemesis__IO.php#af3b8bd661b51a9ae2ab5dc32a3751da2">00079</a> <a class="code" href="classlibMesh_1_1Nemesis__IO.php#af3b8bd661b51a9ae2ab5dc32a3751da2">Nemesis_IO::Nemesis_IO</a> (<a class="code" href="classlibMesh_1_1ParallelMesh.php">ParallelMesh</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>) :
<a name="l00080"></a>00080   <a class="code" href="classlibMesh_1_1MeshInput.php">MeshInput</a>&lt;<a class="code" href="classlibMesh_1_1ParallelMesh.php">ParallelMesh</a>&gt; (mesh, <span class="comment">/*is_parallel_format=*/</span>true),
<a name="l00081"></a>00081   <span class="comment">//MeshOutput&lt;ParallelMesh&gt; (mesh, /*is_parallel_format=*/true)</span>
<a name="l00082"></a>00082 #if defined(LIBMESH_HAVE_EXODUS_API) &amp;&amp; defined(LIBMESH_HAVE_NEMESIS_API)
<a name="l00083"></a>00083   nemhelper(new <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php">Nemesis_IO_Helper</a>),
<a name="l00084"></a>00084 #endif
<a name="l00085"></a>00085   _verbose (false)
<a name="l00086"></a>00086 {
<a name="l00087"></a>00087 }
<a name="l00088"></a>00088 
<a name="l00089"></a>00089 
<a name="l00090"></a><a class="code" href="classlibMesh_1_1Nemesis__IO.php#a30ad9757ce1d0b41e213c0366fc11a8c">00090</a> <a class="code" href="classlibMesh_1_1Nemesis__IO.php#a30ad9757ce1d0b41e213c0366fc11a8c">Nemesis_IO::~Nemesis_IO</a> ()
<a name="l00091"></a>00091 {
<a name="l00092"></a>00092 <span class="preprocessor">#if defined(LIBMESH_HAVE_EXODUS_API) &amp;&amp; defined(LIBMESH_HAVE_NEMESIS_API)</span>
<a name="l00093"></a>00093 <span class="preprocessor"></span>  <span class="keyword">delete</span> <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>;
<a name="l00094"></a>00094 <span class="preprocessor">#endif</span>
<a name="l00095"></a>00095 <span class="preprocessor"></span>}
<a name="l00096"></a>00096 
<a name="l00097"></a>00097 
<a name="l00098"></a>00098 
<a name="l00099"></a><a class="code" href="classlibMesh_1_1Nemesis__IO.php#a530d8f40acc55b2cb98b0e440e8dc40a">00099</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Nemesis__IO.php#a530d8f40acc55b2cb98b0e440e8dc40a">Nemesis_IO::verbose</a> (<span class="keywordtype">bool</span> set_verbosity)
<a name="l00100"></a>00100 {
<a name="l00101"></a>00101   <a class="code" href="classlibMesh_1_1Nemesis__IO.php#afdb38616a68787357c4f74f83ad3c3aa">_verbose</a> = set_verbosity;
<a name="l00102"></a>00102 
<a name="l00103"></a>00103 <span class="preprocessor">#if defined(LIBMESH_HAVE_EXODUS_API) &amp;&amp; defined(LIBMESH_HAVE_NEMESIS_API)</span>
<a name="l00104"></a>00104 <span class="preprocessor"></span>  <span class="comment">// Set the verbose flag in the helper object</span>
<a name="l00105"></a>00105   <span class="comment">// as well.</span>
<a name="l00106"></a>00106   <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a0a486e1d944ba2dcea784255c5652499">verbose</a>(<a class="code" href="classlibMesh_1_1Nemesis__IO.php#afdb38616a68787357c4f74f83ad3c3aa">_verbose</a>);
<a name="l00107"></a>00107 <span class="preprocessor">#endif</span>
<a name="l00108"></a>00108 <span class="preprocessor"></span>}
<a name="l00109"></a>00109 
<a name="l00110"></a>00110 
<a name="l00111"></a>00111 
<a name="l00112"></a>00112 <span class="preprocessor">#if defined(LIBMESH_HAVE_EXODUS_API) &amp;&amp; defined(LIBMESH_HAVE_NEMESIS_API)</span>
<a name="l00113"></a><a class="code" href="classlibMesh_1_1Nemesis__IO.php#a976d74c57a65812c355af28c55b6e8f5">00113</a> <span class="preprocessor"></span><span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Nemesis__IO.php#a976d74c57a65812c355af28c55b6e8f5">Nemesis_IO::read</a> (<span class="keyword">const</span> std::string&amp; base_filename)
<a name="l00114"></a>00114 {
<a name="l00115"></a>00115   <span class="comment">// On one processor, Nemesis and ExodusII should be equivalent, so</span>
<a name="l00116"></a>00116   <span class="comment">// let&#39;s cowardly defer to that implementation...</span>
<a name="l00117"></a>00117   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() == 1)
<a name="l00118"></a>00118     {                                           
<a name="l00119"></a>00119       <a class="code" href="classlibMesh_1_1ExodusII__IO.php">ExodusII_IO</a>(this-&gt;<a class="code" href="classlibMesh_1_1MeshInput.php#ac18df20ac8c6a96bc404d08bae1e481b">mesh</a>()).<a class="code" href="classlibMesh_1_1ExodusII__IO.php#a5c8740e7197ba48ac0cd7d91d753f0f1">read</a> (base_filename);
<a name="l00120"></a>00120       <span class="keywordflow">return</span>;
<a name="l00121"></a>00121     }
<a name="l00122"></a>00122 
<a name="l00123"></a>00123   START_LOG (<span class="stringliteral">&quot;read()&quot;</span>,<span class="stringliteral">&quot;Nemesis_IO&quot;</span>);
<a name="l00124"></a>00124 
<a name="l00125"></a>00125   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00126"></a>00126   parallel_only();
<a name="l00127"></a>00127   
<a name="l00128"></a>00128   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1Nemesis__IO.php#afdb38616a68787357c4f74f83ad3c3aa">_verbose</a>)
<a name="l00129"></a>00129     {
<a name="l00130"></a>00130       <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;[&quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt;&lt; <span class="stringliteral">&quot;] &quot;</span>;
<a name="l00131"></a>00131       <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Reading Nemesis file on processor: &quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt;&lt; std::endl;
<a name="l00132"></a>00132     }
<a name="l00133"></a>00133   
<a name="l00134"></a>00134   <span class="comment">// Construct a filename string for this processor.</span>
<a name="l00135"></a>00135   <span class="comment">//</span>
<a name="l00136"></a>00136   <span class="comment">// FIXME: This assumes you are reading in a mesh on exactly the</span>
<a name="l00137"></a>00137   <span class="comment">// same number of processors it was written out on!!</span>
<a name="l00138"></a>00138   <span class="comment">// This should be generalized at some point...</span>
<a name="l00139"></a>00139   std::ostringstream file_oss;
<a name="l00140"></a>00140 
<a name="l00141"></a>00141   file_oss &lt;&lt; base_filename  
<a name="l00142"></a>00142            &lt;&lt; <span class="charliteral">&#39;.&#39;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() 
<a name="l00143"></a>00143            &lt;&lt; <span class="charliteral">&#39;.&#39;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>();
<a name="l00144"></a>00144 
<a name="l00145"></a>00145   <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Opening file: &quot;</span> &lt;&lt; file_oss.str() &lt;&lt; std::endl;
<a name="l00146"></a>00146 
<a name="l00147"></a>00147   <span class="comment">// Open the Exodus file</span>
<a name="l00148"></a>00148   <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a9bf6deacca92641b0d30d7749a06b887">open</a>(file_oss.str().c_str());
<a name="l00149"></a>00149 
<a name="l00150"></a>00150   <span class="comment">// Get a reference to the ParallelMesh.  </span>
<a name="l00151"></a>00151   <a class="code" href="classlibMesh_1_1ParallelMesh.php">ParallelMesh</a>&amp; <a class="code" href="classlibMesh_1_1MeshInput.php#ac18df20ac8c6a96bc404d08bae1e481b">mesh</a> = this-&gt;<a class="code" href="classlibMesh_1_1MeshInput.php#ac18df20ac8c6a96bc404d08bae1e481b">mesh</a>();
<a name="l00152"></a>00152 
<a name="l00153"></a>00153   <span class="comment">// Local information: Read the following information from the standard Exodus header</span>
<a name="l00154"></a>00154   <span class="comment">//  title[0]</span>
<a name="l00155"></a>00155   <span class="comment">//  num_dim</span>
<a name="l00156"></a>00156   <span class="comment">//  num_nodes</span>
<a name="l00157"></a>00157   <span class="comment">//  num_elem</span>
<a name="l00158"></a>00158   <span class="comment">//  num_elem_blk</span>
<a name="l00159"></a>00159   <span class="comment">//  num_node_sets</span>
<a name="l00160"></a>00160   <span class="comment">//  num_side_sets</span>
<a name="l00161"></a>00161   <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#ad33f14d5154d71c0bf8339e44b801997">read_header</a>();
<a name="l00162"></a>00162   <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#aa57b23eb3af94898729cb25919b3123c">print_header</a>();
<a name="l00163"></a>00163   
<a name="l00164"></a>00164   <span class="comment">// Be sure number of dimensions is equal to the number of dimensions in the mesh supplied.</span>
<a name="l00165"></a>00165   mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#af7db7d54bc846c376d9c57a833263204">set_mesh_dimension</a>(static_cast&lt;unsigned int&gt;(<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a61acb9bb4d7ec8cf215bce77b582395e">num_dim</a>));
<a name="l00166"></a>00166   
<a name="l00167"></a>00167   <span class="comment">// Get global information: number of nodes, elems, blocks, nodesets and sidesets</span>
<a name="l00168"></a>00168   <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a58f32d4bd0357125c5a22778fb59650f">get_init_global</a>();
<a name="l00169"></a>00169   
<a name="l00170"></a>00170   <span class="comment">// Get &quot;load balance&quot; information.  This includes the number of internal &amp; border</span>
<a name="l00171"></a>00171   <span class="comment">// nodes and elements as well as the number of communication maps.</span>
<a name="l00172"></a>00172   <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#ae9d2c643dac85d53e610e5d2e8224a6f">get_loadbal_param</a>();
<a name="l00173"></a>00173   
<a name="l00174"></a>00174   <span class="comment">// Do some error checking</span>
<a name="l00175"></a>00175   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a1c1bb85f02b8c95ef66cb7dc40330247">num_external_nodes</a>)
<a name="l00176"></a>00176     {
<a name="l00177"></a>00177       <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: there should be no external nodes in an element-based partitioning!&quot;</span>
<a name="l00178"></a>00178                     &lt;&lt; std::endl;
<a name="l00179"></a>00179       libmesh_error();
<a name="l00180"></a>00180     }
<a name="l00181"></a>00181 
<a name="l00182"></a>00182   libmesh_assert (<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a847ee7e0854676701e1b5205bb6ed743">num_nodes</a> ==
<a name="l00183"></a>00183                   (<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a2c0c2908a3ed6a6f2efc3142db699d2b">num_internal_nodes</a> + 
<a name="l00184"></a>00184                    <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a438b6bc4e1c65aa7c46d880d2e9be65d">num_border_nodes</a>));
<a name="l00185"></a>00185   
<a name="l00186"></a>00186   libmesh_assert (<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#af4bc089ec99edd6e62d67ed75a7d1a2a">num_elem</a> ==
<a name="l00187"></a>00187                   (<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a319f0d1cac4b358ee634b888e6226927">num_internal_elems</a> +
<a name="l00188"></a>00188                    <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a06c94a0e522731c5c7d9aca265a1039d">num_border_elems</a>));
<a name="l00189"></a>00189   
<a name="l00190"></a>00190   libmesh_assert (<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a847ee7e0854676701e1b5205bb6ed743">num_nodes</a> &lt;= <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a98e66232b1d1a7af9aeb35a68e0ce7ef">num_nodes_global</a>);
<a name="l00191"></a>00191   libmesh_assert (<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#af4bc089ec99edd6e62d67ed75a7d1a2a">num_elem</a>  &lt;= <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a428c62b9b28577fb377d085b6cf3fbf3">num_elems_global</a>);
<a name="l00192"></a>00192       
<a name="l00193"></a>00193   <span class="comment">// Read nodes from the exodus file: this fills the nemhelper-&gt;x,y,z arrays.</span>
<a name="l00194"></a>00194   <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a6442ae2187f05185649d88efef41c000">read_nodes</a>();
<a name="l00195"></a>00195 
<a name="l00196"></a>00196   <span class="comment">// Reads the nemhelper-&gt;node_num_map array, node_num_map[i] is the global node number for</span>
<a name="l00197"></a>00197   <span class="comment">// local node number i.</span>
<a name="l00198"></a>00198   <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a18cb4af65d380ec6197cceca28f755ab">read_node_num_map</a>();
<a name="l00199"></a>00199   
<a name="l00200"></a>00200   <span class="comment">// The get_cmap_params() function reads in the:</span>
<a name="l00201"></a>00201   <span class="comment">//  node_cmap_ids[],</span>
<a name="l00202"></a>00202   <span class="comment">//  node_cmap_node_cnts[],</span>
<a name="l00203"></a>00203   <span class="comment">//  elem_cmap_ids[],</span>
<a name="l00204"></a>00204   <span class="comment">//  elem_cmap_elem_cnts[],</span>
<a name="l00205"></a>00205   <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a653b6229679c6fa0f56952523b3b8302">get_cmap_params</a>();
<a name="l00206"></a>00206   
<a name="l00207"></a>00207   <span class="comment">// Read the IDs of the interior, boundary, and external nodes.  This function</span>
<a name="l00208"></a>00208   <span class="comment">// fills the vectors:</span>
<a name="l00209"></a>00209   <span class="comment">//  node_mapi[],</span>
<a name="l00210"></a>00210   <span class="comment">//  node_mapb[],</span>
<a name="l00211"></a>00211   <span class="comment">//  node_mape[]</span>
<a name="l00212"></a>00212   <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a1d46473b4a62c8d11fc6beda0e3215f5">get_node_map</a>();
<a name="l00213"></a>00213   
<a name="l00214"></a>00214   <span class="comment">// Read each node communication map for this processor.  This function</span>
<a name="l00215"></a>00215   <span class="comment">// fills the vectors of vectors named:</span>
<a name="l00216"></a>00216   <span class="comment">//  node_cmap_node_ids[][]</span>
<a name="l00217"></a>00217   <span class="comment">//  node_cmap_proc_ids[][]</span>
<a name="l00218"></a>00218   <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a40274c2f13482adf02eeb441dfc298ab">get_node_cmap</a>();
<a name="l00219"></a>00219 
<a name="l00220"></a>00220   libmesh_assert (to_uint(<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a599b22b7b3f80c3135f207a970b73ef6">num_node_cmaps</a>) == <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a901623ac3547b56de3fa23d50bff9109">node_cmap_node_cnts</a>.size());
<a name="l00221"></a>00221   libmesh_assert (to_uint(<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a599b22b7b3f80c3135f207a970b73ef6">num_node_cmaps</a>) == <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#aec19670af4e2f47b1cc87a8dd4a4237c">node_cmap_node_ids</a>.size());
<a name="l00222"></a>00222   libmesh_assert (to_uint(<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a599b22b7b3f80c3135f207a970b73ef6">num_node_cmaps</a>) == <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#aac75518dad6476eb415b0c445a457f8b">node_cmap_proc_ids</a>.size());
<a name="l00223"></a>00223 
<a name="l00224"></a>00224 <span class="preprocessor">#ifndef NDEBUG</span>
<a name="l00225"></a>00225 <span class="preprocessor"></span>  <span class="comment">// We expect the communication maps to be symmetric - e.g. if processor i thinks it</span>
<a name="l00226"></a>00226   <span class="comment">// communicates with processor j, then processor j should also be expecting to</span>
<a name="l00227"></a>00227   <span class="comment">// communicate with i.  We can assert that here easily enough with an alltoall,</span>
<a name="l00228"></a>00228   <span class="comment">// but let&#39;s only do it when not in optimized mode to limit unnecessary communication.</span>
<a name="l00229"></a>00229   {
<a name="l00230"></a>00230     std::vector&lt;unsigned char&gt; pid_send_partener (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(), 0);
<a name="l00231"></a>00231 
<a name="l00232"></a>00232     <span class="comment">// strictly speaking, we should expect to communicate with ourself...</span>
<a name="l00233"></a>00233     pid_send_partener[<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>()] = 1;
<a name="l00234"></a>00234     
<a name="l00235"></a>00235     <span class="comment">// mark each processor id we reference with a node cmap </span>
<a name="l00236"></a>00236     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> cmap=0; cmap&lt;to_uint(<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a599b22b7b3f80c3135f207a970b73ef6">num_node_cmaps</a>); cmap++)
<a name="l00237"></a>00237       {
<a name="l00238"></a>00238         libmesh_assert (to_uint(<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a921bd9e930cf7690d1f23590c893fb8b">node_cmap_ids</a>[cmap]) &lt; <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>());
<a name="l00239"></a>00239 
<a name="l00240"></a>00240         pid_send_partener[<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a921bd9e930cf7690d1f23590c893fb8b">node_cmap_ids</a>[cmap]] = 1;
<a name="l00241"></a>00241       }
<a name="l00242"></a>00242 
<a name="l00243"></a>00243     <span class="comment">// Copy the send pairing so we can catch the receive paring and</span>
<a name="l00244"></a>00244     <span class="comment">// test for equality</span>
<a name="l00245"></a>00245     <span class="keyword">const</span> std::vector&lt;unsigned char&gt; pid_recv_partener (pid_send_partener);
<a name="l00246"></a>00246     
<a name="l00247"></a>00247     <a class="code" href="namespacelibMesh_1_1Parallel.php#ac132fe4daa7fdd6fb4cd5a18fbae3771">Parallel::alltoall</a> (pid_send_partener);
<a name="l00248"></a>00248 
<a name="l00249"></a>00249     libmesh_assert (pid_send_partener == pid_recv_partener);
<a name="l00250"></a>00250   }
<a name="l00251"></a>00251 <span class="preprocessor">#endif</span>
<a name="l00252"></a>00252 <span class="preprocessor"></span>  
<a name="l00253"></a>00253   <span class="comment">// We now have enough information to infer node ownership.  We start by assuming</span>
<a name="l00254"></a>00254   <span class="comment">// we own all the nodes on this processor.  We will then interrogate the </span>
<a name="l00255"></a>00255   <span class="comment">// node cmaps and see if a lower-rank processor is associated with any of</span>
<a name="l00256"></a>00256   <span class="comment">// our nodes.  If so, then that processor owns the node, not us...</span>
<a name="l00257"></a>00257   std::vector&lt;unsigned short int&gt; node_ownership (<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a2c0c2908a3ed6a6f2efc3142db699d2b">num_internal_nodes</a> +
<a name="l00258"></a>00258                                                   <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a438b6bc4e1c65aa7c46d880d2e9be65d">num_border_nodes</a>,
<a name="l00259"></a>00259                                                   libMesh::processor_id());
<a name="l00260"></a>00260 
<a name="l00261"></a>00261   <span class="comment">// a map from processor id to cmap number, to be used later</span>
<a name="l00262"></a>00262   std::map&lt;unsigned int, unsigned int&gt; pid_to_cmap_map;
<a name="l00263"></a>00263 
<a name="l00264"></a>00264   <span class="comment">// For each node_cmap...</span>
<a name="l00265"></a>00265   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> cmap=0; cmap&lt;to_uint(<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a599b22b7b3f80c3135f207a970b73ef6">num_node_cmaps</a>); cmap++)
<a name="l00266"></a>00266     {
<a name="l00267"></a>00267       <span class="comment">// Good time for error checking...</span>
<a name="l00268"></a>00268       libmesh_assert (to_uint(<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a901623ac3547b56de3fa23d50bff9109">node_cmap_node_cnts</a>[cmap]) ==
<a name="l00269"></a>00269                       <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#aec19670af4e2f47b1cc87a8dd4a4237c">node_cmap_node_ids</a>[cmap].size());
<a name="l00270"></a>00270       
<a name="l00271"></a>00271       libmesh_assert (to_uint(<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a901623ac3547b56de3fa23d50bff9109">node_cmap_node_cnts</a>[cmap]) ==
<a name="l00272"></a>00272                       <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#aac75518dad6476eb415b0c445a457f8b">node_cmap_proc_ids</a>[cmap].size());
<a name="l00273"></a>00273       
<a name="l00274"></a>00274       <span class="comment">// In all the samples I have seen, node_cmap_ids[cmap] is the processor</span>
<a name="l00275"></a>00275       <span class="comment">// rank of the remote processor...</span>
<a name="l00276"></a>00276       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> adjcnt_pid_idx = <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a921bd9e930cf7690d1f23590c893fb8b">node_cmap_ids</a>[cmap];
<a name="l00277"></a>00277 
<a name="l00278"></a>00278       libmesh_assert (adjcnt_pid_idx &lt;  <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>());
<a name="l00279"></a>00279       libmesh_assert (adjcnt_pid_idx != libMesh::processor_id());
<a name="l00280"></a>00280       
<a name="l00281"></a>00281       <span class="comment">// We only expect one cmap per adjacent processor</span>
<a name="l00282"></a>00282       libmesh_assert (!pid_to_cmap_map.count(adjcnt_pid_idx));
<a name="l00283"></a>00283                                                 
<a name="l00284"></a>00284       pid_to_cmap_map[adjcnt_pid_idx] = cmap;
<a name="l00285"></a>00285 
<a name="l00286"></a>00286       <span class="comment">// ...and each node in that cmap...</span>
<a name="l00287"></a>00287       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>=0; <a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>&lt;to_uint(<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a901623ac3547b56de3fa23d50bff9109">node_cmap_node_cnts</a>[cmap]); <a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>++)
<a name="l00288"></a>00288         {
<a name="l00289"></a>00289           <span class="comment">//  Are the node_cmap_ids and node_cmap_proc_ids really redundant?</span>
<a name="l00290"></a>00290           libmesh_assert (adjcnt_pid_idx == <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#aac75518dad6476eb415b0c445a457f8b">node_cmap_proc_ids</a>[cmap][<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>]);
<a name="l00291"></a>00291           
<a name="l00292"></a>00292           <span class="comment">// we are expecting the exodus node numbering to be 1-based...</span>
<a name="l00293"></a>00293           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> local_node_idx = <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#aec19670af4e2f47b1cc87a8dd4a4237c">node_cmap_node_ids</a>[cmap][<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>]-1;
<a name="l00294"></a>00294 
<a name="l00295"></a>00295           libmesh_assert (local_node_idx &lt; node_ownership.size());
<a name="l00296"></a>00296           
<a name="l00297"></a>00297           <span class="comment">// if the adjacent processor is lower rank than the current</span>
<a name="l00298"></a>00298           <span class="comment">// owner for this node, then it will get the node...</span>
<a name="l00299"></a>00299           node_ownership[local_node_idx] = 
<a name="l00300"></a>00300             <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(node_ownership[local_node_idx], adjcnt_pid_idx);
<a name="l00301"></a>00301         }
<a name="l00302"></a>00302     } <span class="comment">// We now should have established proper node ownership.</span>
<a name="l00303"></a>00303 
<a name="l00304"></a>00304   <span class="comment">// now that ownership is established, we can figure out how many nodes we </span>
<a name="l00305"></a>00305   <span class="comment">// will be responsible for numbering.</span>
<a name="l00306"></a>00306   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> num_nodes_i_must_number = 0;
<a name="l00307"></a>00307 
<a name="l00308"></a>00308   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>=0; <a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>&lt;node_ownership.size(); <a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>++)
<a name="l00309"></a>00309     <span class="keywordflow">if</span> (node_ownership[<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>] == libMesh::processor_id())
<a name="l00310"></a>00310       num_nodes_i_must_number++;
<a name="l00311"></a>00311 
<a name="l00312"></a>00312   <span class="comment">// more error checking...</span>
<a name="l00313"></a>00313   libmesh_assert (num_nodes_i_must_number &gt;= to_uint(<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a2c0c2908a3ed6a6f2efc3142db699d2b">num_internal_nodes</a>));
<a name="l00314"></a>00314   libmesh_assert (num_nodes_i_must_number &lt;= to_uint(<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a2c0c2908a3ed6a6f2efc3142db699d2b">num_internal_nodes</a> +
<a name="l00315"></a>00315                                                   <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a438b6bc4e1c65aa7c46d880d2e9be65d">num_border_nodes</a>));
<a name="l00316"></a>00316   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1Nemesis__IO.php#afdb38616a68787357c4f74f83ad3c3aa">_verbose</a>)
<a name="l00317"></a>00317     <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;[&quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt;&lt; <span class="stringliteral">&quot;] &quot;</span>
<a name="l00318"></a>00318                   &lt;&lt; <span class="stringliteral">&quot;num_nodes_i_must_number=&quot;</span>
<a name="l00319"></a>00319                   &lt;&lt; num_nodes_i_must_number
<a name="l00320"></a>00320                   &lt;&lt; std::endl;
<a name="l00321"></a>00321   
<a name="l00322"></a>00322   <span class="comment">// The call to get_loadbal_param() gets 7 pieces of information.  We allgather</span>
<a name="l00323"></a>00323   <span class="comment">// these now across all processors to determine some global numberings. We should</span>
<a name="l00324"></a>00324   <span class="comment">// also gather the number of nodes each processor thinks it will number so that</span>
<a name="l00325"></a>00325   <span class="comment">// we can (i) determine our offset, and (ii) do some error checking.</span>
<a name="l00326"></a>00326   std::vector&lt;int&gt; all_loadbal_data ( 8 );
<a name="l00327"></a>00327   all_loadbal_data[0] = <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a2c0c2908a3ed6a6f2efc3142db699d2b">num_internal_nodes</a>;
<a name="l00328"></a>00328   all_loadbal_data[1] = <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a438b6bc4e1c65aa7c46d880d2e9be65d">num_border_nodes</a>;
<a name="l00329"></a>00329   all_loadbal_data[2] = <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a1c1bb85f02b8c95ef66cb7dc40330247">num_external_nodes</a>;
<a name="l00330"></a>00330   all_loadbal_data[3] = <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a319f0d1cac4b358ee634b888e6226927">num_internal_elems</a>;
<a name="l00331"></a>00331   all_loadbal_data[4] = <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a06c94a0e522731c5c7d9aca265a1039d">num_border_elems</a>;
<a name="l00332"></a>00332   all_loadbal_data[5] = <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a599b22b7b3f80c3135f207a970b73ef6">num_node_cmaps</a>;
<a name="l00333"></a>00333   all_loadbal_data[6] = <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#ad47d0d6538010bd2c2aa358f7e518332">num_elem_cmaps</a>;
<a name="l00334"></a>00334   all_loadbal_data[7] = num_nodes_i_must_number;
<a name="l00335"></a>00335   
<a name="l00336"></a>00336   <a class="code" href="namespacelibMesh_1_1Parallel.php#a5d83bd3061eee7fc9ec2c58427c67aef">Parallel::allgather</a> (all_loadbal_data, <span class="comment">/* identical_buffer_sizes = */</span> <span class="keyword">true</span>);
<a name="l00337"></a>00337 
<a name="l00338"></a>00338   <span class="comment">// OK, we are now in a position to request new global indices for all the nodes</span>
<a name="l00339"></a>00339   <span class="comment">// we do not own</span>
<a name="l00340"></a>00340 
<a name="l00341"></a>00341   <span class="comment">// Let&#39;s get a unique message tag to use for send()/receive()</span>
<a name="l00342"></a>00342   <a class="code" href="classlibMesh_1_1Parallel_1_1MessageTag.php">Parallel::MessageTag</a> nodes_tag = <a class="code" href="namespacelibMesh_1_1Parallel.php#a0177ff6d177a879cc6d29e2f95694c91">Parallel::Communicator_World</a>.get_unique_tag(12345);
<a name="l00343"></a>00343 
<a name="l00344"></a>00344   std::vector&lt;std::vector&lt;int&gt; &gt; 
<a name="l00345"></a>00345     needed_node_idxs (<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a599b22b7b3f80c3135f207a970b73ef6">num_node_cmaps</a>); <span class="comment">// the indices we will ask for</span>
<a name="l00346"></a>00346     
<a name="l00347"></a>00347   std::vector&lt;Parallel::Request&gt; 
<a name="l00348"></a>00348     needed_nodes_requests (<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a599b22b7b3f80c3135f207a970b73ef6">num_node_cmaps</a>);
<a name="l00349"></a>00349   
<a name="l00350"></a>00350   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> cmap=0; cmap&lt;to_uint(<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a599b22b7b3f80c3135f207a970b73ef6">num_node_cmaps</a>); cmap++)
<a name="l00351"></a>00351     {
<a name="l00352"></a>00352       <span class="comment">// We know we will need no more indices than there are nodes</span>
<a name="l00353"></a>00353       <span class="comment">// in this cmap, but that number is an upper bound in general</span>
<a name="l00354"></a>00354       <span class="comment">// since the neighboring processor associated with the cmap</span>
<a name="l00355"></a>00355       <span class="comment">//  may not actually own it</span>
<a name="l00356"></a>00356       needed_node_idxs[cmap].reserve   (<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a901623ac3547b56de3fa23d50bff9109">node_cmap_node_cnts</a>[cmap]);
<a name="l00357"></a>00357             
<a name="l00358"></a>00358       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> adjcnt_pid_idx = <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a921bd9e930cf7690d1f23590c893fb8b">node_cmap_ids</a>[cmap];
<a name="l00359"></a>00359 
<a name="l00360"></a>00360       <span class="comment">// ...and each node in that cmap...</span>
<a name="l00361"></a>00361       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>=0; <a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>&lt;to_uint(<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a901623ac3547b56de3fa23d50bff9109">node_cmap_node_cnts</a>[cmap]); <a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>++)
<a name="l00362"></a>00362         {
<a name="l00363"></a>00363           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> 
<a name="l00364"></a>00364             local_node_idx  = <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#aec19670af4e2f47b1cc87a8dd4a4237c">node_cmap_node_ids</a>[cmap][<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>]-1,
<a name="l00365"></a>00365             owning_pid_idx  = node_ownership[local_node_idx];
<a name="l00366"></a>00366 
<a name="l00367"></a>00367           <span class="comment">// add it to the request list for its owning processor.</span>
<a name="l00368"></a>00368           <span class="keywordflow">if</span> (owning_pid_idx == adjcnt_pid_idx)
<a name="l00369"></a>00369             {
<a name="l00370"></a>00370               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>
<a name="l00371"></a>00371                 global_node_idx = <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a6e11f33dc102e99b12ed8ea9ac677231">node_num_map</a>[local_node_idx]-1;
<a name="l00372"></a>00372               needed_node_idxs[cmap].push_back(global_node_idx);
<a name="l00373"></a>00373             }
<a name="l00374"></a>00374         }
<a name="l00375"></a>00375       <span class="comment">// now post the send for this cmap</span>
<a name="l00376"></a>00376       <a class="code" href="namespacelibMesh_1_1Parallel.php#aa5a90fd8d590aaaa059158cb7d604b68">Parallel::send</a> (adjcnt_pid_idx,              <span class="comment">// destination</span>
<a name="l00377"></a>00377                       needed_node_idxs[cmap],      <span class="comment">// send buffer</span>
<a name="l00378"></a>00378                       needed_nodes_requests[cmap], <span class="comment">// request</span>
<a name="l00379"></a>00379                       nodes_tag);      
<a name="l00380"></a>00380     } <span class="comment">// all communication requests for getting updated global indices for border</span>
<a name="l00381"></a>00381       <span class="comment">// nodes have been initiated</span>
<a name="l00382"></a>00382 
<a name="l00383"></a>00383   <span class="comment">// Figure out how many nodes each processor thinks it will number and make sure</span>
<a name="l00384"></a>00384   <span class="comment">// that it adds up to the global number of nodes. Also, set up global node</span>
<a name="l00385"></a>00385   <span class="comment">// index offsets for each processor.</span>
<a name="l00386"></a>00386   std::vector&lt;unsigned int&gt;
<a name="l00387"></a>00387     all_num_nodes_i_must_number (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>());
<a name="l00388"></a>00388    
<a name="l00389"></a>00389   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pid=0; pid&lt;<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(); pid++)
<a name="l00390"></a>00390     all_num_nodes_i_must_number[pid] = all_loadbal_data[8*pid + 7];
<a name="l00391"></a>00391   
<a name="l00392"></a>00392   <span class="comment">// The sum of all the entries in this vector should sum to the number of global nodes</span>
<a name="l00393"></a>00393   libmesh_assert (std::accumulate(all_num_nodes_i_must_number.begin(),
<a name="l00394"></a>00394                                   all_num_nodes_i_must_number.end(),
<a name="l00395"></a>00395                                   0) == <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a98e66232b1d1a7af9aeb35a68e0ce7ef">num_nodes_global</a>);
<a name="l00396"></a>00396   
<a name="l00397"></a>00397   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> my_next_node = 0;
<a name="l00398"></a>00398   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pid=0; pid&lt;<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>(); pid++)
<a name="l00399"></a>00399     my_next_node += all_num_nodes_i_must_number[pid];
<a name="l00400"></a>00400   
<a name="l00401"></a>00401   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> my_node_offset = my_next_node;
<a name="l00402"></a>00402 
<a name="l00403"></a>00403   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1Nemesis__IO.php#afdb38616a68787357c4f74f83ad3c3aa">_verbose</a>)
<a name="l00404"></a>00404     <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;[&quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt;&lt; <span class="stringliteral">&quot;] &quot;</span>
<a name="l00405"></a>00405                   &lt;&lt; <span class="stringliteral">&quot;my_node_offset=&quot;</span>
<a name="l00406"></a>00406                   &lt;&lt; my_node_offset
<a name="l00407"></a>00407                   &lt;&lt; std::endl;
<a name="l00408"></a>00408   
<a name="l00409"></a>00409   <span class="comment">// Add internal nodes to the ParallelMesh, using the node ID offset we</span>
<a name="l00410"></a>00410   <span class="comment">// computed and the current processor&#39;s ID.</span>
<a name="l00411"></a>00411   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;to_uint(<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a2c0c2908a3ed6a6f2efc3142db699d2b">num_internal_nodes</a>); ++i)
<a name="l00412"></a>00412     {
<a name="l00413"></a>00413       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> 
<a name="l00414"></a>00414         local_node_idx  = <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#ad3c20099029b60abb4ba76b8b2e4b2ec">node_mapi</a>[i]-1,
<a name="l00415"></a>00415         global_node_idx = <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a6e11f33dc102e99b12ed8ea9ac677231">node_num_map</a>[local_node_idx]-1,
<a name="l00416"></a>00416         owning_pid_idx  = node_ownership[local_node_idx];
<a name="l00417"></a>00417 
<a name="l00418"></a>00418       <span class="comment">// an internal node we do not own? huh??</span>
<a name="l00419"></a>00419       libmesh_assert (owning_pid_idx == libMesh::processor_id());
<a name="l00420"></a>00420       libmesh_assert (global_node_idx &lt; to_uint(<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a98e66232b1d1a7af9aeb35a68e0ce7ef">num_nodes_global</a>));
<a name="l00421"></a>00421 
<a name="l00422"></a>00422       mesh.<a class="code" href="classlibMesh_1_1ParallelMesh.php#aaf046537db0139a6c515dec62dedaf5d">add_point</a> (<a class="code" href="classlibMesh_1_1Point.php">Point</a>(<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a34773dcda6a41b34e67fce165454c530">x</a>[local_node_idx],
<a name="l00423"></a>00423                             <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a9c91b82c014b865a677fd4dea029f1d9">y</a>[local_node_idx],
<a name="l00424"></a>00424                             <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a6537a7456410505c56fd3549eb98fc07">z</a>[local_node_idx]), 
<a name="l00425"></a>00425                       my_next_node, 
<a name="l00426"></a>00426                       libMesh::processor_id());
<a name="l00427"></a>00427 
<a name="l00428"></a>00428       <span class="comment">// update the local-&gt;global index map, when we are done</span>
<a name="l00429"></a>00429       <span class="comment">// it will be 0-based.</span>
<a name="l00430"></a>00430       <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a6e11f33dc102e99b12ed8ea9ac677231">node_num_map</a>[local_node_idx] = my_next_node++;
<a name="l00431"></a>00431     }
<a name="l00432"></a>00432 
<a name="l00433"></a>00433   <span class="comment">// Now, for the boundary nodes...  We may very well own some of them,</span>
<a name="l00434"></a>00434   <span class="comment">// but there may be others for which we have requested the new global</span>
<a name="l00435"></a>00435   <span class="comment">// id.  We expect to be asked for the ids of the ones we own, so </span>
<a name="l00436"></a>00436   <span class="comment">// we need to create a map from the old global id to the new one</span>
<a name="l00437"></a>00437   <span class="comment">// we are about to create.</span>
<a name="l00438"></a>00438   <span class="keyword">typedef</span> std::vector&lt;std::pair&lt;unsigned int, unsigned int&gt; &gt; global_idx_mapping_type;
<a name="l00439"></a>00439   global_idx_mapping_type old_global_to_new_global_map;
<a name="l00440"></a>00440   old_global_to_new_global_map.reserve (num_nodes_i_must_number <span class="comment">// total # i will have         </span>
<a name="l00441"></a>00441                                         - (my_next_node         <span class="comment">// amount i have thus far</span>
<a name="l00442"></a>00442                                            - my_node_offset));  <span class="comment">// this should be exact! </span>
<a name="l00443"></a>00443   CompareGlobalIdxMappings global_idx_mapping_comp;
<a name="l00444"></a>00444 
<a name="l00445"></a>00445   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;to_uint(<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a438b6bc4e1c65aa7c46d880d2e9be65d">num_border_nodes</a>); ++i)
<a name="l00446"></a>00446     {
<a name="l00447"></a>00447       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> 
<a name="l00448"></a>00448         local_node_idx  = <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a8bf17e199cbffdcd89250476aec05084">node_mapb</a>[i]-1,
<a name="l00449"></a>00449         owning_pid_idx  = node_ownership[local_node_idx];       
<a name="l00450"></a>00450       
<a name="l00451"></a>00451       <span class="comment">// if we own it...</span>
<a name="l00452"></a>00452       <span class="keywordflow">if</span> (owning_pid_idx == libMesh::processor_id())
<a name="l00453"></a>00453         {
<a name="l00454"></a>00454           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>
<a name="l00455"></a>00455             global_node_idx = <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a6e11f33dc102e99b12ed8ea9ac677231">node_num_map</a>[local_node_idx]-1;
<a name="l00456"></a>00456 
<a name="l00457"></a>00457           <span class="comment">// we will number it, and create a mapping from its old global index to</span>
<a name="l00458"></a>00458           <span class="comment">// the new global index, for lookup purposes when neighbors come calling</span>
<a name="l00459"></a>00459           old_global_to_new_global_map.push_back(std::make_pair(global_node_idx, 
<a name="l00460"></a>00460                                                                 my_next_node));
<a name="l00461"></a>00461           mesh.<a class="code" href="classlibMesh_1_1ParallelMesh.php#aaf046537db0139a6c515dec62dedaf5d">add_point</a> (<a class="code" href="classlibMesh_1_1Point.php">Point</a>(<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a34773dcda6a41b34e67fce165454c530">x</a>[local_node_idx],
<a name="l00462"></a>00462                                 <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a9c91b82c014b865a677fd4dea029f1d9">y</a>[local_node_idx],
<a name="l00463"></a>00463                                 <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a6537a7456410505c56fd3549eb98fc07">z</a>[local_node_idx]), 
<a name="l00464"></a>00464                           my_next_node, 
<a name="l00465"></a>00465                           libMesh::processor_id());
<a name="l00466"></a>00466 
<a name="l00467"></a>00467           <span class="comment">// update the local-&gt;global index map, when we are done</span>
<a name="l00468"></a>00468           <span class="comment">// it will be 0-based.</span>
<a name="l00469"></a>00469           <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a6e11f33dc102e99b12ed8ea9ac677231">node_num_map</a>[local_node_idx] = my_next_node++;
<a name="l00470"></a>00470         }
<a name="l00471"></a>00471     }
<a name="l00472"></a>00472   <span class="comment">// That should cover numbering all the nodes which belong to us...</span>
<a name="l00473"></a>00473   libmesh_assert (num_nodes_i_must_number == (my_next_node - my_node_offset));
<a name="l00474"></a>00474 
<a name="l00475"></a>00475   <span class="comment">// Let&#39;s sort the mapping so we can efficiently answer requests</span>
<a name="l00476"></a>00476   std::sort (old_global_to_new_global_map.begin(),
<a name="l00477"></a>00477              old_global_to_new_global_map.end(),
<a name="l00478"></a>00478              global_idx_mapping_comp);
<a name="l00479"></a>00479 
<a name="l00480"></a>00480   <span class="comment">// and it had better be unique...</span>
<a name="l00481"></a>00481   libmesh_assert (std::unique (old_global_to_new_global_map.begin(),
<a name="l00482"></a>00482                                old_global_to_new_global_map.end(),
<a name="l00483"></a>00483                                global_idx_mapping_equality) ==
<a name="l00484"></a>00484                   old_global_to_new_global_map.end());
<a name="l00485"></a>00485 
<a name="l00486"></a>00486   <span class="comment">// We can now catch incoming requests and process them. for efficiency</span>
<a name="l00487"></a>00487   <span class="comment">// let&#39;s do whatever is available next</span>
<a name="l00488"></a>00488   std::map&lt;unsigned int, std::vector&lt;int&gt; &gt; requested_node_idxs; <span class="comment">// the indices asked of us   </span>
<a name="l00489"></a>00489 
<a name="l00490"></a>00490   std::vector&lt;Parallel::Request&gt; requested_nodes_requests(<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a599b22b7b3f80c3135f207a970b73ef6">num_node_cmaps</a>);
<a name="l00491"></a>00491   
<a name="l00492"></a>00492   <span class="comment">// We know we will receive the request from a given processor before</span>
<a name="l00493"></a>00493   <span class="comment">// we receive its reply to our request. However, we may receive</span>
<a name="l00494"></a>00494   <span class="comment">// a request and a response from one processor before getting</span>
<a name="l00495"></a>00495   <span class="comment">// a request from another processor.  So what we are doing here</span>
<a name="l00496"></a>00496   <span class="comment">// is processing whatever message comes next, while recognizing </span>
<a name="l00497"></a>00497   <span class="comment">// we will receive a request from a processor before receiving</span>
<a name="l00498"></a>00498   <span class="comment">// its reply</span>
<a name="l00499"></a>00499   std::vector&lt;bool&gt; processed_cmap (<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a599b22b7b3f80c3135f207a970b73ef6">num_node_cmaps</a>, <span class="keyword">false</span>);
<a name="l00500"></a>00500 
<a name="l00501"></a>00501   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> comm_step=0; comm_step&lt;2*to_uint(<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a599b22b7b3f80c3135f207a970b73ef6">num_node_cmaps</a>); comm_step++)
<a name="l00502"></a>00502     {
<a name="l00503"></a>00503       <span class="comment">// query the first message which is available</span>
<a name="l00504"></a>00504       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Status.php">Parallel::Status</a> 
<a name="l00505"></a>00505         <a class="code" href="namespacelibMesh_1_1Parallel.php#a08ff351bea1937bbde5a1af3160b4616">status</a> (<a class="code" href="namespacelibMesh_1_1Parallel.php#a11a1391d63c3bd391913f4a71321af21">Parallel::probe</a> (<a class="code" href="namespacelibMesh_1_1Parallel.php#af036e0e449c3b43e908bb8fa22f2191b">Parallel::any_source</a>, 
<a name="l00506"></a>00506                                  nodes_tag));      
<a name="l00507"></a>00507       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> 
<a name="l00508"></a>00508         requesting_pid_idx = status.<a class="code" href="classlibMesh_1_1Parallel_1_1Status.php#aee8318932e11f49d49ad6f65768a629c">source</a>(),
<a name="l00509"></a>00509         source_pid_idx     = status.<a class="code" href="classlibMesh_1_1Parallel_1_1Status.php#aee8318932e11f49d49ad6f65768a629c">source</a>();
<a name="l00510"></a>00510 
<a name="l00511"></a>00511       <span class="comment">// this had better be from a processor we are expecting...</span>
<a name="l00512"></a>00512       libmesh_assert (pid_to_cmap_map.count(requesting_pid_idx));
<a name="l00513"></a>00513       
<a name="l00514"></a>00514       <span class="comment">// the local cmap which corresponds to the source processor</span>
<a name="l00515"></a>00515       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> cmap = pid_to_cmap_map[source_pid_idx];
<a name="l00516"></a>00516 
<a name="l00517"></a>00517       <span class="keywordflow">if</span> (!processed_cmap[cmap])
<a name="l00518"></a>00518         {
<a name="l00519"></a>00519           processed_cmap[cmap] = <span class="keyword">true</span>;
<a name="l00520"></a>00520           
<a name="l00521"></a>00521           <span class="comment">// we should only get one request per paired processor</span>
<a name="l00522"></a>00522           libmesh_assert (!requested_node_idxs.count(requesting_pid_idx));
<a name="l00523"></a>00523       
<a name="l00524"></a>00524           <span class="comment">// get a reference to the request buffer for this processor to</span>
<a name="l00525"></a>00525           <span class="comment">// avoid repeated map lookups</span>
<a name="l00526"></a>00526           std::vector&lt;int&gt; &amp;xfer_buf (requested_node_idxs[requesting_pid_idx]);
<a name="l00527"></a>00527             
<a name="l00528"></a>00528           <span class="comment">// actually receive the message.  </span>
<a name="l00529"></a>00529           <a class="code" href="namespacelibMesh_1_1Parallel.php#aff69db520530bae51afc2e02eb385724">Parallel::receive</a> (requesting_pid_idx, xfer_buf, nodes_tag);
<a name="l00530"></a>00530           
<a name="l00531"></a>00531           <span class="comment">// Fill the request</span>
<a name="l00532"></a>00532           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;xfer_buf.size(); i++)
<a name="l00533"></a>00533             {
<a name="l00534"></a>00534               <span class="comment">// the requested old global node index, *now 0-based*</span>
<a name="l00535"></a>00535               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> old_global_node_idx = xfer_buf[i];
<a name="l00536"></a>00536               
<a name="l00537"></a>00537               <span class="comment">// find the new global node index for the requested node -</span>
<a name="l00538"></a>00538               <span class="comment">// note that requesting_pid_idx thinks we own this node,</span>
<a name="l00539"></a>00539               <span class="comment">// so we better!</span>
<a name="l00540"></a>00540               <span class="keyword">const</span> global_idx_mapping_type::const_iterator it =
<a name="l00541"></a>00541                 std::lower_bound (old_global_to_new_global_map.begin(),
<a name="l00542"></a>00542                                   old_global_to_new_global_map.end(),
<a name="l00543"></a>00543                                   old_global_node_idx,
<a name="l00544"></a>00544                                   global_idx_mapping_comp);
<a name="l00545"></a>00545                 
<a name="l00546"></a>00546               libmesh_assert (it != old_global_to_new_global_map.end());
<a name="l00547"></a>00547               libmesh_assert (it-&gt;first == old_global_node_idx);
<a name="l00548"></a>00548               libmesh_assert (it-&gt;second &gt;= my_node_offset);
<a name="l00549"></a>00549               libmesh_assert (it-&gt;second &lt;  my_next_node);
<a name="l00550"></a>00550               
<a name="l00551"></a>00551               <span class="comment">// overwrite the requested old global node index with the new global index</span>
<a name="l00552"></a>00552               xfer_buf[i] = it-&gt;second;
<a name="l00553"></a>00553             }
<a name="l00554"></a>00554             
<a name="l00555"></a>00555           <span class="comment">// and send the new global indices back to the processor which asked for them</span>
<a name="l00556"></a>00556           <a class="code" href="namespacelibMesh_1_1Parallel.php#aa5a90fd8d590aaaa059158cb7d604b68">Parallel::send</a> (requesting_pid_idx,
<a name="l00557"></a>00557                           xfer_buf,
<a name="l00558"></a>00558                           requested_nodes_requests[cmap],
<a name="l00559"></a>00559                           nodes_tag);
<a name="l00560"></a>00560         } <span class="comment">// done processing the request</span>
<a name="l00561"></a>00561       
<a name="l00562"></a>00562       <span class="comment">// this is the second time we have heard from this processor, </span>
<a name="l00563"></a>00563       <span class="comment">// so it must be its reply to our request</span>
<a name="l00564"></a>00564       <span class="keywordflow">else</span>
<a name="l00565"></a>00565         {
<a name="l00566"></a>00566           <span class="comment">// a long time ago, we sent off our own requests.  now it is time to catch the </span>
<a name="l00567"></a>00567           <span class="comment">// replies and get the new global node numbering.  note that for any reply</span>
<a name="l00568"></a>00568           <span class="comment">// we receive, the corresponding nonblocking send from above *must* have been </span>
<a name="l00569"></a>00569           <span class="comment">// completed, since the reply is in response to that request!!</span>
<a name="l00570"></a>00570           
<a name="l00571"></a>00571           <span class="comment">// if we have received a reply, our send *must* have completed</span>
<a name="l00572"></a>00572           <span class="comment">// (note we never actually need to wait on the request)</span>
<a name="l00573"></a>00573           libmesh_assert (needed_nodes_requests[cmap].test());
<a name="l00574"></a>00574           libmesh_assert (to_uint(<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a921bd9e930cf7690d1f23590c893fb8b">node_cmap_ids</a>[cmap]) == source_pid_idx);
<a name="l00575"></a>00575             
<a name="l00576"></a>00576           <span class="comment">// now post the receive for this cmap</span>
<a name="l00577"></a>00577           <a class="code" href="namespacelibMesh_1_1Parallel.php#aff69db520530bae51afc2e02eb385724">Parallel::receive</a> (source_pid_idx,
<a name="l00578"></a>00578                              needed_node_idxs[cmap],
<a name="l00579"></a>00579                              nodes_tag);
<a name="l00580"></a>00580           
<a name="l00581"></a>00581           libmesh_assert (needed_node_idxs[cmap].size() &lt;= 
<a name="l00582"></a>00582                           <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#aec19670af4e2f47b1cc87a8dd4a4237c">node_cmap_node_ids</a>[cmap].size());
<a name="l00583"></a>00583           
<a name="l00584"></a>00584           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0,j=0; i&lt;<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#aec19670af4e2f47b1cc87a8dd4a4237c">node_cmap_node_ids</a>[cmap].size(); i++)
<a name="l00585"></a>00585             {
<a name="l00586"></a>00586               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> 
<a name="l00587"></a>00587                 local_node_idx  = <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#aec19670af4e2f47b1cc87a8dd4a4237c">node_cmap_node_ids</a>[cmap][i]-1,
<a name="l00588"></a>00588                 owning_pid_idx  = node_ownership[local_node_idx];       
<a name="l00589"></a>00589               
<a name="l00590"></a>00590               <span class="comment">// if this node is owned by source_pid_idx, its new global id </span>
<a name="l00591"></a>00591               <span class="comment">// is in the buffer we just received</span>
<a name="l00592"></a>00592               <span class="keywordflow">if</span> (owning_pid_idx == source_pid_idx)
<a name="l00593"></a>00593                 {
<a name="l00594"></a>00594                   libmesh_assert (j &lt; needed_node_idxs[cmap].size());
<a name="l00595"></a>00595                     
<a name="l00596"></a>00596                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <span class="comment">// now 0-based!</span>
<a name="l00597"></a>00597                     global_node_idx = needed_node_idxs[cmap][j++];
<a name="l00598"></a>00598                   
<a name="l00599"></a>00599                   mesh.<a class="code" href="classlibMesh_1_1ParallelMesh.php#aaf046537db0139a6c515dec62dedaf5d">add_point</a> (<a class="code" href="classlibMesh_1_1Point.php">Point</a>(<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a34773dcda6a41b34e67fce165454c530">x</a>[local_node_idx],
<a name="l00600"></a>00600                                         <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a9c91b82c014b865a677fd4dea029f1d9">y</a>[local_node_idx],
<a name="l00601"></a>00601                                         <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a6537a7456410505c56fd3549eb98fc07">z</a>[local_node_idx]),
<a name="l00602"></a>00602                                   global_node_idx,
<a name="l00603"></a>00603                                   source_pid_idx);
<a name="l00604"></a>00604                   
<a name="l00605"></a>00605                   <span class="comment">// update the local-&gt;global index map, when we are done</span>
<a name="l00606"></a>00606                   <span class="comment">// it will be 0-based.</span>
<a name="l00607"></a>00607                   <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a6e11f33dc102e99b12ed8ea9ac677231">node_num_map</a>[local_node_idx] = global_node_idx;
<a name="l00608"></a>00608                   
<a name="l00609"></a>00609                   <span class="comment">// we are not really going to use my_next_node again, but we can</span>
<a name="l00610"></a>00610                   <span class="comment">// keep incrimenting it to track how many nodes we have added </span>
<a name="l00611"></a>00611                   <span class="comment">// to the mesh</span>
<a name="l00612"></a>00612                   my_next_node++;
<a name="l00613"></a>00613                 }
<a name="l00614"></a>00614             }
<a name="l00615"></a>00615         }
<a name="l00616"></a>00616     } <span class="comment">// end of node index communication loop</span>
<a name="l00617"></a>00617   
<a name="l00618"></a>00618   <span class="comment">// we had better have added all the nodes we need to!</span>
<a name="l00619"></a>00619   libmesh_assert ((my_next_node - my_node_offset) == to_uint(<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a847ee7e0854676701e1b5205bb6ed743">num_nodes</a>));
<a name="l00620"></a>00620 
<a name="l00621"></a>00621   <span class="comment">// After all that, we should be done with all node-related arrays *except* the</span>
<a name="l00622"></a>00622   <span class="comment">// node_num_map, which we have transformed to use our new numbering...</span>
<a name="l00623"></a>00623   <span class="comment">// So let&#39;s clean up the arrays we are done with.</span>
<a name="l00624"></a>00624   {
<a name="l00625"></a>00625     <a class="code" href="namespacelibMesh_1_1Utility.php#a92241eb8401cf9d333223e9c95e12475">Utility::deallocate</a> (<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#ad3c20099029b60abb4ba76b8b2e4b2ec">node_mapi</a>);
<a name="l00626"></a>00626     <a class="code" href="namespacelibMesh_1_1Utility.php#a92241eb8401cf9d333223e9c95e12475">Utility::deallocate</a> (<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a8bf17e199cbffdcd89250476aec05084">node_mapb</a>);
<a name="l00627"></a>00627     <a class="code" href="namespacelibMesh_1_1Utility.php#a92241eb8401cf9d333223e9c95e12475">Utility::deallocate</a> (<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a8adf1fe9838d266d02a589b715504e84">node_mape</a>);
<a name="l00628"></a>00628     <a class="code" href="namespacelibMesh_1_1Utility.php#a92241eb8401cf9d333223e9c95e12475">Utility::deallocate</a> (<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a921bd9e930cf7690d1f23590c893fb8b">node_cmap_ids</a>);
<a name="l00629"></a>00629     <a class="code" href="namespacelibMesh_1_1Utility.php#a92241eb8401cf9d333223e9c95e12475">Utility::deallocate</a> (<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a901623ac3547b56de3fa23d50bff9109">node_cmap_node_cnts</a>);
<a name="l00630"></a>00630     <a class="code" href="namespacelibMesh_1_1Utility.php#a92241eb8401cf9d333223e9c95e12475">Utility::deallocate</a> (<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#aec19670af4e2f47b1cc87a8dd4a4237c">node_cmap_node_ids</a>);
<a name="l00631"></a>00631     <a class="code" href="namespacelibMesh_1_1Utility.php#a92241eb8401cf9d333223e9c95e12475">Utility::deallocate</a> (<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#aac75518dad6476eb415b0c445a457f8b">node_cmap_proc_ids</a>);
<a name="l00632"></a>00632     <a class="code" href="namespacelibMesh_1_1Utility.php#a92241eb8401cf9d333223e9c95e12475">Utility::deallocate</a> (<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a34773dcda6a41b34e67fce165454c530">x</a>);
<a name="l00633"></a>00633     <a class="code" href="namespacelibMesh_1_1Utility.php#a92241eb8401cf9d333223e9c95e12475">Utility::deallocate</a> (<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a9c91b82c014b865a677fd4dea029f1d9">y</a>);
<a name="l00634"></a>00634     <a class="code" href="namespacelibMesh_1_1Utility.php#a92241eb8401cf9d333223e9c95e12475">Utility::deallocate</a> (<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a6537a7456410505c56fd3549eb98fc07">z</a>);
<a name="l00635"></a>00635     <a class="code" href="namespacelibMesh_1_1Utility.php#a92241eb8401cf9d333223e9c95e12475">Utility::deallocate</a> (needed_node_idxs);
<a name="l00636"></a>00636     <a class="code" href="namespacelibMesh_1_1Utility.php#a92241eb8401cf9d333223e9c95e12475">Utility::deallocate</a> (node_ownership);
<a name="l00637"></a>00637   }
<a name="l00638"></a>00638   
<a name="l00639"></a>00639   <a class="code" href="namespacelibMesh_1_1Parallel.php#a134212c5276050e13f31cb2d22bbed8c">Parallel::wait</a> (requested_nodes_requests);
<a name="l00640"></a>00640   requested_node_idxs.clear();
<a name="l00641"></a>00641 
<a name="l00642"></a>00642   <span class="comment">// See what the node count is up to now.</span>
<a name="l00643"></a>00643   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1Nemesis__IO.php#afdb38616a68787357c4f74f83ad3c3aa">_verbose</a>)
<a name="l00644"></a>00644     {
<a name="l00645"></a>00645       <span class="comment">// Report the number of nodes which have been added locally</span>
<a name="l00646"></a>00646       <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;[&quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt;&lt; <span class="stringliteral">&quot;] &quot;</span>;
<a name="l00647"></a>00647       <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;mesh.n_nodes()=&quot;</span> &lt;&lt; mesh.<a class="code" href="classlibMesh_1_1ParallelMesh.php#afa159384231957ca748e1c3c0ea599a4">n_nodes</a>() &lt;&lt; std::endl;
<a name="l00648"></a>00648       
<a name="l00649"></a>00649       <span class="comment">// Reports the number of nodes that have been added in total.</span>
<a name="l00650"></a>00650       <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;[&quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt;&lt; <span class="stringliteral">&quot;] &quot;</span>;
<a name="l00651"></a>00651       <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;mesh.parallel_n_nodes()=&quot;</span> &lt;&lt; mesh.<a class="code" href="classlibMesh_1_1ParallelMesh.php#a9639396ca8d96b4d4bff36f22fe05370">parallel_n_nodes</a>() &lt;&lt; std::endl;
<a name="l00652"></a>00652     }
<a name="l00653"></a>00653   
<a name="l00654"></a>00654 
<a name="l00655"></a>00655 
<a name="l00656"></a>00656   <span class="comment">// --------------------------------------------------------------------------------</span>
<a name="l00657"></a>00657   <span class="comment">// --------------------------------------------------------------------------------</span>
<a name="l00658"></a>00658   <span class="comment">// --------------------------------------------------------------------------------</span>
<a name="l00659"></a>00659 
<a name="l00660"></a>00660       
<a name="l00661"></a>00661   <span class="comment">// We can now read in the elements...Exodus stores them in blocks in which all</span>
<a name="l00662"></a>00662   <span class="comment">// elements have the same geometric type.  This code is adapted directly from exodusII_io.C</span>
<a name="l00663"></a>00663 
<a name="l00664"></a>00664   <span class="comment">// Assertion: The sum of the border and internal elements on all processors</span>
<a name="l00665"></a>00665   <span class="comment">// should equal nemhelper-&gt;num_elems_global</span>
<a name="l00666"></a>00666 <span class="preprocessor">#ifndef NDEBUG</span>
<a name="l00667"></a>00667 <span class="preprocessor"></span>  {
<a name="l00668"></a>00668     <span class="keywordtype">int</span> sum_internal_elems=0, sum_border_elems=0;
<a name="l00669"></a>00669     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=3,c=0; c&lt;<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(); j+=8,++c)
<a name="l00670"></a>00670       sum_internal_elems += all_loadbal_data[j];
<a name="l00671"></a>00671     
<a name="l00672"></a>00672     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=4,c=0; c&lt;<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(); j+=8,++c)
<a name="l00673"></a>00673       sum_border_elems += all_loadbal_data[j];
<a name="l00674"></a>00674     
<a name="l00675"></a>00675     <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1Nemesis__IO.php#afdb38616a68787357c4f74f83ad3c3aa">_verbose</a>)
<a name="l00676"></a>00676       {
<a name="l00677"></a>00677         <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;[&quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt;&lt; <span class="stringliteral">&quot;] &quot;</span>;
<a name="l00678"></a>00678         <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;sum_internal_elems=&quot;</span> &lt;&lt; sum_internal_elems &lt;&lt; std::endl;
<a name="l00679"></a>00679         
<a name="l00680"></a>00680         <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;[&quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt;&lt; <span class="stringliteral">&quot;] &quot;</span>;
<a name="l00681"></a>00681         <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;sum_border_elems=&quot;</span> &lt;&lt; sum_border_elems &lt;&lt; std::endl;
<a name="l00682"></a>00682       }
<a name="l00683"></a>00683     
<a name="l00684"></a>00684     libmesh_assert(sum_internal_elems+sum_border_elems == <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a428c62b9b28577fb377d085b6cf3fbf3">num_elems_global</a>);
<a name="l00685"></a>00685   }
<a name="l00686"></a>00686 <span class="preprocessor">#endif</span>
<a name="l00687"></a>00687 <span class="preprocessor"></span>
<a name="l00688"></a>00688   <span class="comment">// Compute my_elem_offset, the amount by which to offset the local elem numbering</span>
<a name="l00689"></a>00689   <span class="comment">// on my processor.</span>
<a name="l00690"></a>00690   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> my_next_elem = 0;
<a name="l00691"></a>00691   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pid=0; pid&lt;<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>(); ++pid)
<a name="l00692"></a>00692     my_next_elem += (all_loadbal_data[8*pid + 3]+  <span class="comment">// num_internal_elems, proc pid</span>
<a name="l00693"></a>00693                      all_loadbal_data[8*pid + 4]); <span class="comment">// num_border_elems, proc pid</span>
<a name="l00694"></a>00694   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> my_elem_offset = my_next_elem;
<a name="l00695"></a>00695 
<a name="l00696"></a>00696   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1Nemesis__IO.php#afdb38616a68787357c4f74f83ad3c3aa">_verbose</a>)
<a name="l00697"></a>00697     <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;[&quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt;&lt; <span class="stringliteral">&quot;] &quot;</span>
<a name="l00698"></a>00698               &lt;&lt; <span class="stringliteral">&quot;my_elem_offset=&quot;</span> &lt;&lt; my_elem_offset &lt;&lt; std::endl;
<a name="l00699"></a>00699 
<a name="l00700"></a>00700 
<a name="l00701"></a>00701   <span class="comment">// Fills in the: </span>
<a name="l00702"></a>00702   <span class="comment">// global_elem_blk_ids[] and</span>
<a name="l00703"></a>00703   <span class="comment">// global_elem_blk_cnts[] arrays.</span>
<a name="l00704"></a>00704   <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#ac1ff2be6140d2002737acdbc30bcd885">get_eb_info_global</a>();
<a name="l00705"></a>00705 
<a name="l00706"></a>00706 <span class="comment">//   // Fills in the vectors</span>
<a name="l00707"></a>00707 <span class="comment">//   // elem_mapi[num_internal_elems]</span>
<a name="l00708"></a>00708 <span class="comment">//   // elem_mapb[num_border_elems  ]</span>
<a name="l00709"></a>00709 <span class="comment">//   // These tell which of the (locally-numbered) elements are internal and which are border elements.</span>
<a name="l00710"></a>00710 <span class="comment">//   // In our test example these arrays are sorted (but non-contiguous), which makes it possible to</span>
<a name="l00711"></a>00711 <span class="comment">//   // binary search for each element ID... however I don&#39;t think we need to distinguish between the</span>
<a name="l00712"></a>00712 <span class="comment">//   // two types, since either can have nodes the boundary!</span>
<a name="l00713"></a>00713 <span class="comment">//   nemhelper-&gt;get_elem_map();</span>
<a name="l00714"></a>00714       
<a name="l00715"></a>00715   <span class="comment">// Fills in the vectors of vectors:</span>
<a name="l00716"></a>00716   <span class="comment">// elem_cmap_elem_ids[][]</span>
<a name="l00717"></a>00717   <span class="comment">// elem_cmap_side_ids[][]</span>
<a name="l00718"></a>00718   <span class="comment">// elem_cmap_proc_ids[][]</span>
<a name="l00719"></a>00719   <span class="comment">// These arrays are of size num_elem_cmaps * elem_cmap_elem_cnts[i], i = 0..num_elem_cmaps</span>
<a name="l00720"></a>00720   <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a902f187c60c1b72216f3197894ce99d1">get_elem_cmap</a>();
<a name="l00721"></a>00721       
<a name="l00722"></a>00722   <span class="comment">// Get information about the element blocks:</span>
<a name="l00723"></a>00723   <span class="comment">// (read in the array nemhelper-&gt;block_ids[])</span>
<a name="l00724"></a>00724   <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a025711d210123880b8cdac91184ab45b">read_block_info</a>();
<a name="l00725"></a>00725 
<a name="l00726"></a>00726   <span class="comment">// Reads the nemhelper-&gt;elem_num_map array, elem_num_map[i] is the global element number for</span>
<a name="l00727"></a>00727   <span class="comment">// local element number i.</span>
<a name="l00728"></a>00728   <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#ade4a8af03ed43f731bd6d3974bceee65">read_elem_num_map</a>();
<a name="l00729"></a>00729       
<a name="l00730"></a>00730   <span class="comment">// Instantiate the ElementMaps interface.  This is what translates LibMesh&#39;s</span>
<a name="l00731"></a>00731   <span class="comment">// element numbering scheme to Exodus&#39;s.</span>
<a name="l00732"></a>00732   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php">ExodusII_IO_Helper::ElementMaps</a> em;
<a name="l00733"></a>00733       
<a name="l00734"></a>00734   <span class="comment">// Read in the element connectivity for each block by</span>
<a name="l00735"></a>00735   <span class="comment">// looping over all the blocks.</span>
<a name="l00736"></a>00736   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;to_uint(<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a752ec22fd9eca2dfd0b20461a6544fbc">num_elem_blk</a>); i++)
<a name="l00737"></a>00737     {
<a name="l00738"></a>00738       <span class="comment">// Read the information for block i:  For nemhelper-&gt;block_ids[i], reads</span>
<a name="l00739"></a>00739       <span class="comment">// elem_type</span>
<a name="l00740"></a>00740       <span class="comment">// num_elem_this_blk</span>
<a name="l00741"></a>00741       <span class="comment">// num_nodes_per_elem</span>
<a name="l00742"></a>00742       <span class="comment">// num_attr</span>
<a name="l00743"></a>00743       <span class="comment">// connect &lt;-- the nodal connectivity array for each element in the block.</span>
<a name="l00744"></a>00744       <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#afc3acc1e28f081a9f8a3c3a160715387">read_elem_in_block</a>(i);
<a name="l00745"></a>00745 
<a name="l00746"></a>00746       <span class="comment">// Note that with parallel files it is possible we have no elements in</span>
<a name="l00747"></a>00747       <span class="comment">// this block!</span>
<a name="l00748"></a>00748       <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a60798106904a2036379dd4988e6ceaeb">num_elem_this_blk</a>) <span class="keywordflow">continue</span>;
<a name="l00749"></a>00749       
<a name="l00750"></a>00750       <span class="comment">// Set subdomain ID based on the block ID.</span>
<a name="l00751"></a>00751       <span class="keywordtype">int</span> subdomain_id = <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#aba97767bd5bd1dfa25037f41d751e8d1">block_ids</a>[i];
<a name="l00752"></a>00752 
<a name="l00753"></a>00753       <span class="comment">// Create a type string (this uses the null-terminated string ctor).</span>
<a name="l00754"></a>00754       <span class="keyword">const</span> std::string type_str ( &amp;(<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#afdf31751c214c456c1bb9a36516976ea">elem_type</a>[0]) ); 
<a name="l00755"></a>00755 
<a name="l00756"></a>00756       <span class="comment">// Set any relevant node/edge maps for this element</span>
<a name="l00757"></a>00757       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1Conversion.php">ExodusII_IO_Helper::Conversion</a> conv = em.<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#ad7bd06525087dfbddb663f5330f1882f">assign_conversion</a>(type_str); 
<a name="l00758"></a>00758 
<a name="l00759"></a>00759       <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1Nemesis__IO.php#afdb38616a68787357c4f74f83ad3c3aa">_verbose</a>)
<a name="l00760"></a>00760         <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Reading a block of &quot;</span> &lt;&lt; type_str &lt;&lt; <span class="stringliteral">&quot; elements.&quot;</span> &lt;&lt; std::endl;
<a name="l00761"></a>00761       
<a name="l00762"></a>00762       <span class="comment">// Loop over all the elements in this block</span>
<a name="l00763"></a>00763       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;to_uint(<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a60798106904a2036379dd4988e6ceaeb">num_elem_this_blk</a>); j++)
<a name="l00764"></a>00764         {
<a name="l00765"></a>00765           <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = <a class="code" href="classlibMesh_1_1Elem.php#a68cfa73358f50660055bf07a2919b2db">Elem::build</a> (conv.<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1Conversion.php#a5ca4c8800befbbd785efaf269e668e94">get_canonical_type</a>()).release();
<a name="l00766"></a>00766           libmesh_assert (elem);
<a name="l00767"></a>00767 
<a name="l00768"></a>00768           <span class="comment">// Assign subdomain and processor ID to the newly-created Elem.</span>
<a name="l00769"></a>00769           <span class="comment">// Assigning the processor ID beforehand ensures that the Elem is</span>
<a name="l00770"></a>00770           <span class="comment">// not added as an &quot;unpartitioned&quot; element.  Note that the element</span>
<a name="l00771"></a>00771           <span class="comment">// numbering in Exodus is also 1-based.</span>
<a name="l00772"></a>00772           elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a96faae17e7ede5aa89c687d54cefb4b3">subdomain_id</a>() = subdomain_id;
<a name="l00773"></a>00773           elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">processor_id</a>() = <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>();
<a name="l00774"></a>00774           elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a7fe214a46de8b1773a2fa56568f826d4">set_id</a>()       = my_next_elem++;
<a name="l00775"></a>00775                 
<a name="l00776"></a>00776           <span class="comment">// Add the created Elem to the Mesh, catch the Elem</span>
<a name="l00777"></a>00777           <span class="comment">// pointer that the Mesh throws back.</span>
<a name="l00778"></a>00778           elem = mesh.<a class="code" href="classlibMesh_1_1ParallelMesh.php#ad230cc153170488ad92ab4f6ee2146c7">add_elem</a> (elem); 
<a name="l00779"></a>00779 
<a name="l00780"></a>00780           <span class="comment">// Set all the nodes for this element</span>
<a name="l00781"></a>00781           <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1Nemesis__IO.php#afdb38616a68787357c4f74f83ad3c3aa">_verbose</a>)     
<a name="l00782"></a>00782             <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;[&quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt;&lt; <span class="stringliteral">&quot;] &quot;</span>
<a name="l00783"></a>00783                           &lt;&lt; <span class="stringliteral">&quot;Setting nodes for Elem &quot;</span> &lt;&lt; elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>() &lt;&lt; std::endl;
<a name="l00784"></a>00784               
<a name="l00785"></a>00785           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k=0; k&lt;to_uint(<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a850769b9bbd31c3825aeb967e076ba05">num_nodes_per_elem</a>); k++)
<a name="l00786"></a>00786             {
<a name="l00787"></a>00787               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>
<a name="l00788"></a>00788                 gi              = (j*<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a850769b9bbd31c3825aeb967e076ba05">num_nodes_per_elem</a> +       <span class="comment">// index into connectivity array</span>
<a name="l00789"></a>00789                                    conv.<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1Conversion.php#a84ae7256b57510e53b3d087cfc3fe0ca">get_node_map</a>(k)), 
<a name="l00790"></a>00790                 local_node_idx  = <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#ac0708202a0c25af8a4d04253f6bae84e">connect</a>[gi]-1,                <span class="comment">// local node index </span>
<a name="l00791"></a>00791                 global_node_idx = <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a6e11f33dc102e99b12ed8ea9ac677231">node_num_map</a>[local_node_idx]; <span class="comment">// new global node index</span>
<a name="l00792"></a>00792                   
<a name="l00793"></a>00793               <span class="comment">// Set node number</span>
<a name="l00794"></a>00794               elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(k) = mesh.<a class="code" href="classlibMesh_1_1ParallelMesh.php#af929cf6df7403ecc4d3a7e459f646bc8">node_ptr</a>(global_node_idx);
<a name="l00795"></a>00795             }
<a name="l00796"></a>00796         } <span class="comment">// for (unsigned int j=0; j&lt;nemhelper-&gt;num_elem_this_blk; j++)     </span>
<a name="l00797"></a>00797     } <span class="comment">// end for (unsigned int i=0; i&lt;nemhelper-&gt;num_elem_blk; i++)</span>
<a name="l00798"></a>00798 
<a name="l00799"></a>00799   libmesh_assert ((my_next_elem - my_elem_offset) == to_uint(<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#af4bc089ec99edd6e62d67ed75a7d1a2a">num_elem</a>));
<a name="l00800"></a>00800 
<a name="l00801"></a>00801   <span class="comment">// See what the elem count is up to now.</span>
<a name="l00802"></a>00802   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1Nemesis__IO.php#afdb38616a68787357c4f74f83ad3c3aa">_verbose</a>)
<a name="l00803"></a>00803     {
<a name="l00804"></a>00804       <span class="comment">// Report the number of elements which have been added locally</span>
<a name="l00805"></a>00805       <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;[&quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt;&lt; <span class="stringliteral">&quot;] &quot;</span>;
<a name="l00806"></a>00806       <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;mesh.n_elem()=&quot;</span> &lt;&lt; mesh.<a class="code" href="classlibMesh_1_1ParallelMesh.php#a54f3c1d99f06946b368fea0f40111780">n_elem</a>() &lt;&lt; std::endl;
<a name="l00807"></a>00807 
<a name="l00808"></a>00808       <span class="comment">// Reports the number of elements that have been added in total.</span>
<a name="l00809"></a>00809       <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;[&quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt;&lt; <span class="stringliteral">&quot;] &quot;</span>;
<a name="l00810"></a>00810       <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;mesh.parallel_n_elem()=&quot;</span> &lt;&lt; mesh.<a class="code" href="classlibMesh_1_1ParallelMesh.php#a81c366a6f0f566d9966f2bf4f4bd4207">parallel_n_elem</a>() &lt;&lt; std::endl;
<a name="l00811"></a>00811     }
<a name="l00812"></a>00812 
<a name="l00813"></a>00813   STOP_LOG (<span class="stringliteral">&quot;read()&quot;</span>,<span class="stringliteral">&quot;Nemesis_IO&quot;</span>);
<a name="l00814"></a>00814 
<a name="l00815"></a>00815   <span class="comment">// For ParallelMesh, it seems that _is_serial is true by default.  A hack to</span>
<a name="l00816"></a>00816   <span class="comment">// make the Mesh think it&#39;s parallel might be to call:</span>
<a name="l00817"></a>00817   mesh.<a class="code" href="classlibMesh_1_1ParallelMesh.php#a01627aec710b8452f66d3610bc461a8b">delete_remote_elements</a>();
<a name="l00818"></a>00818 }
<a name="l00819"></a>00819 
<a name="l00820"></a>00820 <span class="preprocessor">#else</span>
<a name="l00821"></a>00821 <span class="preprocessor"></span>
<a name="l00822"></a>00822 <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Nemesis__IO.php#a976d74c57a65812c355af28c55b6e8f5">Nemesis_IO::read</a> (<span class="keyword">const</span> std::string&amp; )
<a name="l00823"></a>00823 {
<a name="l00824"></a>00824   <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt;  <span class="stringliteral">&quot;ERROR, Nemesis API is not defined!&quot;</span> &lt;&lt; std::endl;
<a name="l00825"></a>00825   libmesh_error();
<a name="l00826"></a>00826 }
<a name="l00827"></a>00827 
<a name="l00828"></a>00828 <span class="preprocessor">#endif</span>
<a name="l00829"></a>00829 <span class="preprocessor"></span>
<a name="l00830"></a>00830 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
