<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_eaf30c8ea092d33f79a04353c3899c3f.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_61d9f870c6c0483699f07e82d4566fda.php">utils</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">ostream_proxy.h</div>  </div>
</div>
<div class="contents">
<a href="ostream__proxy_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id$</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __ostream_proxy_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __ostream_proxy_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// C++ includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &lt;iostream&gt;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="comment">// Local Includes</span>
<a name="l00031"></a>00031 <span class="comment">// We don&#39;t use anything libMesh-specific here (yet)</span>
<a name="l00032"></a>00032 <span class="comment">// #include &quot;libmesh_common.h&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="keyword">namespace </span>libMesh
<a name="l00036"></a>00036 {
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="comment">// Forward Declarations</span>
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 
<a name="l00042"></a>00042  <span class="comment">// ------------------------------------------------------------</span>
<a name="l00043"></a>00043  <span class="comment">// OStreamProxy class definition</span>
<a name="l00044"></a>00044  <span class="comment">//</span>
<a name="l00045"></a>00045  <span class="comment">// This class is intended to be reseatable like a pointer-to-ostream</span>
<a name="l00046"></a>00046  <span class="comment">// for flexibility, but to look like a reference when used to produce</span>
<a name="l00047"></a>00047  <span class="comment">// less awkward user code.</span>
<a name="l00048"></a>00048  <span class="comment">//</span>
<a name="l00049"></a>00049  <span class="comment">// It is up to the user to ensure that the target ostream </span>
<a name="l00050"></a>00050 
<a name="l00051"></a>00051  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> <span class="keywordtype">char</span>T=<span class="keywordtype">char</span>, <span class="keyword">typename</span> traits=std::<span class="keywordtype">char</span>_traits&lt;<span class="keywordtype">char</span>T&gt; &gt;
<a name="l00052"></a><a class="code" href="classlibMesh_1_1BasicOStreamProxy.php">00052</a>  <span class="keyword">class </span><a class="code" href="classlibMesh_1_1BasicOStreamProxy.php">BasicOStreamProxy</a>
<a name="l00053"></a>00053  {
<a name="l00054"></a>00054  <span class="keyword">public</span>:
<a name="l00059"></a><a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#a127b122d810b6d0936ed057d002a50a8">00059</a>   <span class="keyword">typedef</span> std::basic_ostream&lt;charT,traits&gt; <a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#a127b122d810b6d0936ed057d002a50a8">streamT</a>;
<a name="l00060"></a>00060 
<a name="l00065"></a><a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#a2d5f0925f0a42b8711b7fdf9e833f252">00065</a>   <span class="keyword">typedef</span> std::basic_streambuf&lt;charT,traits&gt; <a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#a2d5f0925f0a42b8711b7fdf9e833f252">streambufT</a>;
<a name="l00066"></a>00066 
<a name="l00072"></a><a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#ad6961a1d712ff9c9aad14fce6c081635">00072</a>   <a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#ad6961a1d712ff9c9aad14fce6c081635">BasicOStreamProxy</a> (<a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#a127b122d810b6d0936ed057d002a50a8">streamT</a>&amp; target) : <a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#ae9088f4f276233f20a8487bfffdd4adc">_target</a>(&amp;target) {};
<a name="l00073"></a>00073 
<a name="l00077"></a><a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#a2aba5011d7ed75b5ab7e1cc839511304">00077</a>   <a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#a2aba5011d7ed75b5ab7e1cc839511304">~BasicOStreamProxy</a> () {};
<a name="l00078"></a>00078 
<a name="l00079"></a>00079   <span class="comment">// </span>
<a name="l00080"></a>00080   <span class="comment">// Functions that get passed to the proxied target:</span>
<a name="l00081"></a>00081   <span class="comment">//</span>
<a name="l00082"></a>00082 
<a name="l00087"></a><a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#afd7cb0a6f7c41248acfea02ff731031d">00087</a>   <a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#afd7cb0a6f7c41248acfea02ff731031d">operator streamT&amp;</a>() { <span class="keywordflow">return</span> *<a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#ae9088f4f276233f20a8487bfffdd4adc">_target</a>; }
<a name="l00088"></a>00088 
<a name="l00093"></a><a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#a62e3a7e9d597c8a7b08b09704287a45e">00093</a>   <a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#a62e3a7e9d597c8a7b08b09704287a45e">operator const streamT&amp;</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> *<a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#ae9088f4f276233f20a8487bfffdd4adc">_target</a>; }
<a name="l00094"></a>00094 
<a name="l00098"></a>00098   <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00099"></a><a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#ac837f431d3c1a141d69602b8f9380311">00099</a>   <a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#a127b122d810b6d0936ed057d002a50a8">streamT</a>&amp; <a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#ac837f431d3c1a141d69602b8f9380311">operator&lt;&lt; </a>(<span class="keyword">const</span> T&amp; in) {
<a name="l00100"></a>00100     <span class="keywordflow">return</span> (*<a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#ae9088f4f276233f20a8487bfffdd4adc">_target</a>) &lt;&lt; in;
<a name="l00101"></a>00101   }
<a name="l00102"></a>00102 
<a name="l00106"></a><a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#aa519b1b874a8e1c5307f255d067b01ff">00106</a>   <a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#a127b122d810b6d0936ed057d002a50a8">streamT</a>&amp; <a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#ac837f431d3c1a141d69602b8f9380311">operator&lt;&lt; </a>(<a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#a127b122d810b6d0936ed057d002a50a8">streamT</a>&amp; (*in)(<a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#a127b122d810b6d0936ed057d002a50a8">streamT</a>&amp;)) {
<a name="l00107"></a>00107     <span class="keywordflow">return</span> (*<a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#ae9088f4f276233f20a8487bfffdd4adc">_target</a>) &lt;&lt; in;
<a name="l00108"></a>00108   }
<a name="l00109"></a>00109 
<a name="l00113"></a><a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#a6c7036ddad749b8041e6234f97abaf76">00113</a>   <a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#a127b122d810b6d0936ed057d002a50a8">streamT</a>&amp; operator&lt;&lt; (std::basic_ios&lt;charT,traits&gt;&amp; (*in)(std::basic_ios&lt;charT,traits&gt;&amp;)) {
<a name="l00114"></a>00114     <span class="keywordflow">return</span> (*<a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#ae9088f4f276233f20a8487bfffdd4adc">_target</a>) &lt;&lt; in;
<a name="l00115"></a>00115   }
<a name="l00116"></a>00116 
<a name="l00120"></a><a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#af9dd6315a7a2bb41ee8815269ebb4baa">00120</a>   <a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#a127b122d810b6d0936ed057d002a50a8">streamT</a>&amp; <a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#ac837f431d3c1a141d69602b8f9380311">operator&lt;&lt; </a>(std::ios_base&amp; (*in)(std::ios_base&amp;)) {
<a name="l00121"></a>00121     <span class="keywordflow">return</span> (*<a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#ae9088f4f276233f20a8487bfffdd4adc">_target</a>) &lt;&lt; in;
<a name="l00122"></a>00122   }
<a name="l00123"></a>00123 
<a name="l00127"></a><a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#a478441e925f5cb680368d00bb3108820">00127</a>   <a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#a2d5f0925f0a42b8711b7fdf9e833f252">streambufT</a>* <a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#a478441e925f5cb680368d00bb3108820">rdbuf</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#ae9088f4f276233f20a8487bfffdd4adc">_target</a>-&gt;rdbuf(); }
<a name="l00128"></a>00128 
<a name="l00132"></a><a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#a7bec7ff4a8fb19e1d0b24ff700c5eda8">00132</a>   <a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#a2d5f0925f0a42b8711b7fdf9e833f252">streambufT</a>* <a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#a7bec7ff4a8fb19e1d0b24ff700c5eda8">rdbuf</a> ( <a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#a2d5f0925f0a42b8711b7fdf9e833f252">streambufT</a>* sb ) { <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#ae9088f4f276233f20a8487bfffdd4adc">_target</a>-&gt;rdbuf(sb); }
<a name="l00133"></a>00133 
<a name="l00137"></a><a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#a59d10db4b1779b3e6eda7f59e11404ca">00137</a>   <a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#a127b122d810b6d0936ed057d002a50a8">streamT</a>&amp; <a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#a59d10db4b1779b3e6eda7f59e11404ca">flush</a> () { <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#ae9088f4f276233f20a8487bfffdd4adc">_target</a>-&gt;flush(); }
<a name="l00138"></a>00138 
<a name="l00142"></a><a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#a2d6a009a794b5c76602fb458d3de9570">00142</a>   std::ios_base::fmtflags <a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#a2d6a009a794b5c76602fb458d3de9570">flags</a> ( )<span class="keyword"> const</span>
<a name="l00143"></a>00143 <span class="keyword">    </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#ae9088f4f276233f20a8487bfffdd4adc">_target</a>-&gt;flags(); }
<a name="l00144"></a>00144 
<a name="l00148"></a><a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#ae6f4baae0e313254a6840c247f6bc3d4">00148</a>   std::ios_base::fmtflags <a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#a2d6a009a794b5c76602fb458d3de9570">flags</a> ( std::ios_base::fmtflags fmtfl ) 
<a name="l00149"></a>00149     { <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#ae9088f4f276233f20a8487bfffdd4adc">_target</a>-&gt;flags(fmtfl); }
<a name="l00150"></a>00150 
<a name="l00154"></a><a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#a7be489dff0fb06bd015f4ab861a5f8f7">00154</a>   std::ios_base::fmtflags <a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#a7be489dff0fb06bd015f4ab861a5f8f7">setf</a> ( std::ios_base::fmtflags fmtfl ) 
<a name="l00155"></a>00155     { <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#ae9088f4f276233f20a8487bfffdd4adc">_target</a>-&gt;setf(fmtfl); }
<a name="l00156"></a>00156 
<a name="l00160"></a><a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#afcdc86f3e46a98710758e2a3dacc9637">00160</a>   std::ios_base::fmtflags <a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#a7be489dff0fb06bd015f4ab861a5f8f7">setf</a> ( std::ios_base::fmtflags fmtfl,
<a name="l00161"></a>00161                                  std::ios_base::fmtflags mask )
<a name="l00162"></a>00162     { <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#ae9088f4f276233f20a8487bfffdd4adc">_target</a>-&gt;setf(fmtfl, mask); }
<a name="l00163"></a>00163 
<a name="l00167"></a><a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#a959cfec8e67f429502f9dee0558c7b79">00167</a>   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#a959cfec8e67f429502f9dee0558c7b79">unsetf</a> ( std::ios_base::fmtflags mask ) 
<a name="l00168"></a>00168     { <a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#ae9088f4f276233f20a8487bfffdd4adc">_target</a>-&gt;unsetf(mask); }
<a name="l00169"></a>00169 
<a name="l00173"></a><a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#a1903b4c5f9397c90e2da3fba62e22516">00173</a>   std::streamsize <a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#a1903b4c5f9397c90e2da3fba62e22516">precision</a> ()<span class="keyword"> const</span>
<a name="l00174"></a>00174 <span class="keyword">    </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#ae9088f4f276233f20a8487bfffdd4adc">_target</a>-&gt;precision(); }
<a name="l00175"></a>00175 
<a name="l00179"></a><a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#afed6356342459ecc87fb218ffbe7f9dc">00179</a>   std::streamsize <a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#a1903b4c5f9397c90e2da3fba62e22516">precision</a> ( std::streamsize prec )
<a name="l00180"></a>00180     { <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#ae9088f4f276233f20a8487bfffdd4adc">_target</a>-&gt;precision(prec); }
<a name="l00181"></a>00181 
<a name="l00182"></a>00182   <span class="comment">//</span>
<a name="l00183"></a>00183   <span class="comment">// Functions that affect the Proxy class:</span>
<a name="l00184"></a>00184   <span class="comment">//</span>
<a name="l00185"></a>00185 
<a name="l00190"></a><a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#aabafe8d5f1873f911413d9e19cb2afe4">00190</a>   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#aabafe8d5f1873f911413d9e19cb2afe4">reset</a> (<a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#a127b122d810b6d0936ed057d002a50a8">streamT</a>&amp; target) { <a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#ae9088f4f276233f20a8487bfffdd4adc">_target</a> = &amp;target; }
<a name="l00191"></a>00191 
<a name="l00196"></a><a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#ae2d18b50fc63d23e47d46fcee630b4f5">00196</a>   <a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#a127b122d810b6d0936ed057d002a50a8">streamT</a>* <span class="keyword">get</span>() {
<a name="l00197"></a>00197     <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#ae9088f4f276233f20a8487bfffdd4adc">_target</a>;
<a name="l00198"></a>00198   }
<a name="l00199"></a>00199 
<a name="l00204"></a><a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#a190b02f8bff867e80d948629ea1cdea6">00204</a>   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#a127b122d810b6d0936ed057d002a50a8">streamT</a>* <span class="keyword">get</span>() <span class="keyword">const</span> {
<a name="l00205"></a>00205     <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#ae9088f4f276233f20a8487bfffdd4adc">_target</a>;
<a name="l00206"></a>00206   }
<a name="l00207"></a>00207 
<a name="l00208"></a>00208  <span class="keyword">private</span>:
<a name="l00212"></a><a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#ae9088f4f276233f20a8487bfffdd4adc">00212</a>    <a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#a127b122d810b6d0936ed057d002a50a8">streamT</a>* <a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#ae9088f4f276233f20a8487bfffdd4adc">_target</a>;
<a name="l00213"></a>00213  };
<a name="l00214"></a>00214 
<a name="l00215"></a><a class="code" href="namespacelibMesh.php#a408927c7f3c1c5f38947ba08b02ed05a">00215</a> <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1BasicOStreamProxy.php">BasicOStreamProxy&lt;&gt;</a> <a class="code" href="namespacelibMesh.php#a408927c7f3c1c5f38947ba08b02ed05a">OStreamProxy</a>;
<a name="l00216"></a>00216 
<a name="l00217"></a>00217 } <span class="comment">// namespace libMesh</span>
<a name="l00218"></a>00218 
<a name="l00219"></a>00219 <span class="preprocessor">#endif // ifndef __ostream_proxy_h__</span>
<a name="l00220"></a>00220 <span class="preprocessor"></span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
