<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_c3a49989e40b21e7508f29d2dc962def.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_32bb88e3eb1b93402cfe508abee484a3.php">mesh</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">parallel_mesh.C</div>  </div>
</div>
<div class="contents">
<a href="parallel__mesh_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id$</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// Local includes</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;<a class="code" href="boundary__info_8h.php">boundary_info.h</a>&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="code" href="elem_8h.php">elem.h</a>&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__logging_8h.php">libmesh_logging.h</a>&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="mesh__communication_8h.php">mesh_communication.h</a>&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="parallel__mesh_8h.php">parallel_mesh.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="parallel_8h.php">parallel.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="parmetis__partitioner_8h.php">parmetis_partitioner.h</a>&quot;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="keyword">namespace </span>libMesh
<a name="l00032"></a>00032 {
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00035"></a>00035 <span class="comment">// ParallelMesh class member functions</span>
<a name="l00036"></a><a class="code" href="classlibMesh_1_1ParallelMesh.php#adf412844e21c8480d126017d38bc88ee">00036</a> <a class="code" href="classlibMesh_1_1ParallelMesh.php#adf412844e21c8480d126017d38bc88ee">ParallelMesh::ParallelMesh</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> d) :
<a name="l00037"></a>00037   <a class="code" href="classlibMesh_1_1UnstructuredMesh.php">UnstructuredMesh</a> (d), _is_serial(true),
<a name="l00038"></a>00038   _n_nodes(0), _n_elem(0), _max_node_id(0), _max_elem_id(0),
<a name="l00039"></a>00039   _next_free_local_node_id(libMesh::<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">processor_id</a>()),
<a name="l00040"></a>00040   _next_free_local_elem_id(libMesh::<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">processor_id</a>()),
<a name="l00041"></a>00041   _next_free_unpartitioned_node_id(libMesh::<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">n_processors</a>()),
<a name="l00042"></a>00042   _next_free_unpartitioned_elem_id(libMesh::<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">n_processors</a>())
<a name="l00043"></a>00043 {
<a name="l00044"></a>00044   <a class="code" href="classlibMesh_1_1MeshBase.php#a23499d00522daa25ed85eeb071148512">_partitioner</a> = <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Partitioner&gt;</a>(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1ParmetisPartitioner.php">ParmetisPartitioner</a>());
<a name="l00045"></a>00045 }
<a name="l00046"></a>00046 
<a name="l00047"></a>00047 
<a name="l00048"></a><a class="code" href="classlibMesh_1_1ParallelMesh.php#ab629e768ba9b128360c7323ec1133db3">00048</a> <a class="code" href="classlibMesh_1_1ParallelMesh.php#ab629e768ba9b128360c7323ec1133db3">ParallelMesh::~ParallelMesh</a> ()
<a name="l00049"></a>00049 {
<a name="l00050"></a>00050   this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#a7649541e7576d5246ae5192293a10153">clear</a>();  <span class="comment">// Free nodes and elements</span>
<a name="l00051"></a>00051 }
<a name="l00052"></a>00052 
<a name="l00053"></a>00053 
<a name="l00054"></a>00054 <span class="comment">// This might be specialized later, but right now it&#39;s just here to</span>
<a name="l00055"></a>00055 <span class="comment">// make sure the compiler doesn&#39;t give us a default (non-deep) copy</span>
<a name="l00056"></a>00056 <span class="comment">// constructor instead.</span>
<a name="l00057"></a><a class="code" href="classlibMesh_1_1ParallelMesh.php#a7ae17d20299e5623c3a79532d5e56d92">00057</a> <a class="code" href="classlibMesh_1_1ParallelMesh.php#adf412844e21c8480d126017d38bc88ee">ParallelMesh::ParallelMesh</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ParallelMesh.php">ParallelMesh</a> &amp;other_mesh) :
<a name="l00058"></a>00058   <a class="code" href="classlibMesh_1_1UnstructuredMesh.php">UnstructuredMesh</a> (other_mesh)
<a name="l00059"></a>00059 {
<a name="l00060"></a>00060   this-&gt;<a class="code" href="classlibMesh_1_1UnstructuredMesh.php#a5fab9455dc9b3af779d83b1125ac1ed6">copy_nodes_and_elements</a>(other_mesh);
<a name="l00061"></a>00061   <a class="code" href="classlibMesh_1_1ParallelMesh.php#af70058d54e5d727f87c524dbc0013f46">_n_nodes</a> = other_mesh.<a class="code" href="classlibMesh_1_1ParallelMesh.php#afa159384231957ca748e1c3c0ea599a4">n_nodes</a>();
<a name="l00062"></a>00062   <a class="code" href="classlibMesh_1_1ParallelMesh.php#ae3bbc433435383bcde09bd28aa13818e">_n_elem</a>  = other_mesh.<a class="code" href="classlibMesh_1_1ParallelMesh.php#a54f3c1d99f06946b368fea0f40111780">n_elem</a>();
<a name="l00063"></a>00063   <a class="code" href="classlibMesh_1_1ParallelMesh.php#a4ade8de51594885d94713fe1de9efa01">_max_node_id</a> = other_mesh.<a class="code" href="classlibMesh_1_1ParallelMesh.php#ae9bacbf51c7089a8aada184b3ac01f2a">max_node_id</a>();
<a name="l00064"></a>00064   <a class="code" href="classlibMesh_1_1ParallelMesh.php#a2ff7a43f89e1ceb7bc3fc205483151be">_max_elem_id</a> = other_mesh.<a class="code" href="classlibMesh_1_1ParallelMesh.php#ac278075751b4e7501c9293dd24613ff5">max_elem_id</a>();
<a name="l00065"></a>00065 }
<a name="l00066"></a>00066 
<a name="l00067"></a>00067 
<a name="l00068"></a>00068 
<a name="l00069"></a><a class="code" href="classlibMesh_1_1ParallelMesh.php#a1e13890b4fe099387e3edde7e133a011">00069</a> <a class="code" href="classlibMesh_1_1ParallelMesh.php#adf412844e21c8480d126017d38bc88ee">ParallelMesh::ParallelMesh</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1UnstructuredMesh.php">UnstructuredMesh</a> &amp;other_mesh) :
<a name="l00070"></a>00070   <a class="code" href="classlibMesh_1_1UnstructuredMesh.php">UnstructuredMesh</a> (other_mesh)
<a name="l00071"></a>00071 {
<a name="l00072"></a>00072   this-&gt;<a class="code" href="classlibMesh_1_1UnstructuredMesh.php#a5fab9455dc9b3af779d83b1125ac1ed6">copy_nodes_and_elements</a>(other_mesh);
<a name="l00073"></a>00073   <a class="code" href="classlibMesh_1_1ParallelMesh.php#af70058d54e5d727f87c524dbc0013f46">_n_nodes</a> = other_mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aff7b82001829828de180cf961df93ea1">n_nodes</a>();
<a name="l00074"></a>00074   <a class="code" href="classlibMesh_1_1ParallelMesh.php#ae3bbc433435383bcde09bd28aa13818e">_n_elem</a>  = other_mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a89566c09cd05aba8bd7f606eba96bf6f">n_elem</a>();
<a name="l00075"></a>00075   <a class="code" href="classlibMesh_1_1ParallelMesh.php#a4ade8de51594885d94713fe1de9efa01">_max_node_id</a> = other_mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a9778fcd4d5fc7687babdf9a5ea56d882">max_node_id</a>();
<a name="l00076"></a>00076   <a class="code" href="classlibMesh_1_1ParallelMesh.php#a2ff7a43f89e1ceb7bc3fc205483151be">_max_elem_id</a> = other_mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a4553709ee4a6a6088c7b656bec34839e">max_elem_id</a>();
<a name="l00077"></a>00077 }
<a name="l00078"></a>00078 
<a name="l00079"></a>00079 
<a name="l00080"></a>00080 <span class="comment">// We use cached values for these so they can be called</span>
<a name="l00081"></a>00081 <span class="comment">// from one processor without bothering the rest, but</span>
<a name="l00082"></a>00082 <span class="comment">// we may need to update those caches before doing a full</span>
<a name="l00083"></a>00083 <span class="comment">// renumbering</span>
<a name="l00084"></a><a class="code" href="classlibMesh_1_1ParallelMesh.php#a2539e4472fc43042afc8cc0d84e10ad5">00084</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ParallelMesh.php#a2539e4472fc43042afc8cc0d84e10ad5">ParallelMesh::update_parallel_id_counts</a>()
<a name="l00085"></a>00085 {
<a name="l00086"></a>00086   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00087"></a>00087   parallel_only();
<a name="l00088"></a>00088 
<a name="l00089"></a>00089   <a class="code" href="classlibMesh_1_1ParallelMesh.php#ae3bbc433435383bcde09bd28aa13818e">_n_elem</a> = this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#a32db8a83b3c6348e1bd9142fb8e92107">n_local_elem</a>();
<a name="l00090"></a>00090   <a class="code" href="namespacelibMesh_1_1Parallel.php#a32ab26117222089e6540e66b05c06b1b">Parallel::sum</a>(<a class="code" href="classlibMesh_1_1ParallelMesh.php#ae3bbc433435383bcde09bd28aa13818e">_n_elem</a>);
<a name="l00091"></a>00091   <a class="code" href="classlibMesh_1_1ParallelMesh.php#ae3bbc433435383bcde09bd28aa13818e">_n_elem</a> += this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#ae210732141d58a19337dde4c901fc18c">n_unpartitioned_elem</a>();
<a name="l00092"></a>00092 
<a name="l00093"></a>00093   <a class="code" href="classlibMesh_1_1ParallelMesh.php#a2ff7a43f89e1ceb7bc3fc205483151be">_max_elem_id</a> = <a class="code" href="classlibMesh_1_1ParallelMesh.php#a0ccc1060937df3ec67ded54440e6590e">_elements</a>.empty() ?
<a name="l00094"></a>00094     0 : <a class="code" href="classlibMesh_1_1ParallelMesh.php#a0ccc1060937df3ec67ded54440e6590e">_elements</a>.rbegin()-&gt;first + 1;
<a name="l00095"></a>00095   <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">Parallel::max</a>(<a class="code" href="classlibMesh_1_1ParallelMesh.php#a2ff7a43f89e1ceb7bc3fc205483151be">_max_elem_id</a>);
<a name="l00096"></a>00096 
<a name="l00097"></a>00097   <a class="code" href="classlibMesh_1_1ParallelMesh.php#af70058d54e5d727f87c524dbc0013f46">_n_nodes</a> = this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#ad25082a75258d635a515e96e6860aa72">n_local_nodes</a>();
<a name="l00098"></a>00098   <a class="code" href="namespacelibMesh_1_1Parallel.php#a32ab26117222089e6540e66b05c06b1b">Parallel::sum</a>(<a class="code" href="classlibMesh_1_1ParallelMesh.php#af70058d54e5d727f87c524dbc0013f46">_n_nodes</a>);
<a name="l00099"></a>00099   <a class="code" href="classlibMesh_1_1ParallelMesh.php#af70058d54e5d727f87c524dbc0013f46">_n_nodes</a> += this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#a7c108f0e48b093fe0fc313c3875d90b6">n_unpartitioned_nodes</a>();
<a name="l00100"></a>00100 
<a name="l00101"></a>00101   <a class="code" href="classlibMesh_1_1ParallelMesh.php#a4ade8de51594885d94713fe1de9efa01">_max_node_id</a> = <a class="code" href="classlibMesh_1_1ParallelMesh.php#a93dcd617abf4505ab8628472eb1cce90">_nodes</a>.empty() ?
<a name="l00102"></a>00102     0 : <a class="code" href="classlibMesh_1_1ParallelMesh.php#a93dcd617abf4505ab8628472eb1cce90">_nodes</a>.rbegin()-&gt;first + 1;
<a name="l00103"></a>00103   <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">Parallel::max</a>(<a class="code" href="classlibMesh_1_1ParallelMesh.php#a4ade8de51594885d94713fe1de9efa01">_max_node_id</a>);
<a name="l00104"></a>00104 }
<a name="l00105"></a>00105 
<a name="l00106"></a>00106 
<a name="l00107"></a>00107 <span class="comment">// Or in debug mode we may want to test the uncached values without</span>
<a name="l00108"></a>00108 <span class="comment">// changing the cache</span>
<a name="l00109"></a><a class="code" href="classlibMesh_1_1ParallelMesh.php#a81c366a6f0f566d9966f2bf4f4bd4207">00109</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ParallelMesh.php#a81c366a6f0f566d9966f2bf4f4bd4207">ParallelMesh::parallel_n_elem</a>()<span class="keyword"> const</span>
<a name="l00110"></a>00110 <span class="keyword"></span>{
<a name="l00111"></a>00111   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00112"></a>00112   parallel_only();
<a name="l00113"></a>00113 
<a name="l00114"></a>00114   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_local = this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#a32db8a83b3c6348e1bd9142fb8e92107">n_local_elem</a>();
<a name="l00115"></a>00115   <a class="code" href="namespacelibMesh_1_1Parallel.php#a32ab26117222089e6540e66b05c06b1b">Parallel::sum</a>(n_local);
<a name="l00116"></a>00116   n_local += this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#ae210732141d58a19337dde4c901fc18c">n_unpartitioned_elem</a>();
<a name="l00117"></a>00117   <span class="keywordflow">return</span> n_local;
<a name="l00118"></a>00118 }
<a name="l00119"></a>00119 
<a name="l00120"></a>00120 
<a name="l00121"></a>00121 
<a name="l00122"></a><a class="code" href="classlibMesh_1_1ParallelMesh.php#aed4cdeb0ddd80a2621d35fa3e61a4d0c">00122</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ParallelMesh.php#aed4cdeb0ddd80a2621d35fa3e61a4d0c">ParallelMesh::parallel_max_elem_id</a>()<span class="keyword"> const</span>
<a name="l00123"></a>00123 <span class="keyword"></span>{
<a name="l00124"></a>00124   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00125"></a>00125   parallel_only();
<a name="l00126"></a>00126 
<a name="l00127"></a>00127   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> max_local = <a class="code" href="classlibMesh_1_1ParallelMesh.php#a0ccc1060937df3ec67ded54440e6590e">_elements</a>.empty() ?
<a name="l00128"></a>00128     0 : <a class="code" href="classlibMesh_1_1ParallelMesh.php#a0ccc1060937df3ec67ded54440e6590e">_elements</a>.rbegin()-&gt;first + 1;
<a name="l00129"></a>00129   <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">Parallel::max</a>(max_local);
<a name="l00130"></a>00130   <span class="keywordflow">return</span> max_local;
<a name="l00131"></a>00131 }
<a name="l00132"></a>00132 
<a name="l00133"></a>00133 
<a name="l00134"></a>00134 
<a name="l00135"></a><a class="code" href="classlibMesh_1_1ParallelMesh.php#a9639396ca8d96b4d4bff36f22fe05370">00135</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ParallelMesh.php#a9639396ca8d96b4d4bff36f22fe05370">ParallelMesh::parallel_n_nodes</a>()<span class="keyword"> const</span>
<a name="l00136"></a>00136 <span class="keyword"></span>{
<a name="l00137"></a>00137   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00138"></a>00138   parallel_only();
<a name="l00139"></a>00139 
<a name="l00140"></a>00140   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_local = this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#ad25082a75258d635a515e96e6860aa72">n_local_nodes</a>();
<a name="l00141"></a>00141   <a class="code" href="namespacelibMesh_1_1Parallel.php#a32ab26117222089e6540e66b05c06b1b">Parallel::sum</a>(n_local);
<a name="l00142"></a>00142   n_local += this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#a7c108f0e48b093fe0fc313c3875d90b6">n_unpartitioned_nodes</a>();
<a name="l00143"></a>00143   <span class="keywordflow">return</span> n_local;
<a name="l00144"></a>00144 }
<a name="l00145"></a>00145 
<a name="l00146"></a>00146 
<a name="l00147"></a>00147 
<a name="l00148"></a><a class="code" href="classlibMesh_1_1ParallelMesh.php#ab412740205d3fa7bc4580f105103255f">00148</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ParallelMesh.php#ab412740205d3fa7bc4580f105103255f">ParallelMesh::parallel_max_node_id</a>()<span class="keyword"> const</span>
<a name="l00149"></a>00149 <span class="keyword"></span>{
<a name="l00150"></a>00150   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00151"></a>00151   parallel_only();
<a name="l00152"></a>00152 
<a name="l00153"></a>00153   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> max_local = <a class="code" href="classlibMesh_1_1ParallelMesh.php#a93dcd617abf4505ab8628472eb1cce90">_nodes</a>.empty() ?
<a name="l00154"></a>00154     0 : <a class="code" href="classlibMesh_1_1ParallelMesh.php#a93dcd617abf4505ab8628472eb1cce90">_nodes</a>.rbegin()-&gt;first + 1;
<a name="l00155"></a>00155   <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">Parallel::max</a>(max_local);
<a name="l00156"></a>00156   <span class="keywordflow">return</span> max_local;
<a name="l00157"></a>00157 }
<a name="l00158"></a>00158 
<a name="l00159"></a>00159 
<a name="l00160"></a>00160 
<a name="l00161"></a><a class="code" href="classlibMesh_1_1ParallelMesh.php#aeec56d7bbe312b24d1a7fc78ee657a14">00161</a> <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; <a class="code" href="classlibMesh_1_1ParallelMesh.php#aeec56d7bbe312b24d1a7fc78ee657a14">ParallelMesh::point</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00162"></a>00162 <span class="keyword"></span>{
<a name="l00163"></a>00163   libmesh_assert (<a class="code" href="classlibMesh_1_1ParallelMesh.php#a93dcd617abf4505ab8628472eb1cce90">_nodes</a>[i] != NULL);
<a name="l00164"></a>00164   libmesh_assert (<a class="code" href="classlibMesh_1_1ParallelMesh.php#a93dcd617abf4505ab8628472eb1cce90">_nodes</a>[i]-&gt;<span class="keywordtype">id</span>() == i);  
<a name="l00165"></a>00165 
<a name="l00166"></a>00166   <span class="keywordflow">return</span> (*<a class="code" href="classlibMesh_1_1ParallelMesh.php#a93dcd617abf4505ab8628472eb1cce90">_nodes</a>[i]);
<a name="l00167"></a>00167 }
<a name="l00168"></a>00168 
<a name="l00169"></a>00169 
<a name="l00170"></a>00170 
<a name="l00171"></a>00171 
<a name="l00172"></a>00172 
<a name="l00173"></a><a class="code" href="classlibMesh_1_1ParallelMesh.php#a454136f0ecbe817adbec8ec370a1540a">00173</a> <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a>&amp; <a class="code" href="classlibMesh_1_1ParallelMesh.php#a454136f0ecbe817adbec8ec370a1540a">ParallelMesh::node</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00174"></a>00174 <span class="keyword"></span>{
<a name="l00175"></a>00175   libmesh_assert (<a class="code" href="classlibMesh_1_1ParallelMesh.php#a93dcd617abf4505ab8628472eb1cce90">_nodes</a>[i] != NULL);
<a name="l00176"></a>00176   libmesh_assert (<a class="code" href="classlibMesh_1_1ParallelMesh.php#a93dcd617abf4505ab8628472eb1cce90">_nodes</a>[i]-&gt;<span class="keywordtype">id</span>() == i);  
<a name="l00177"></a>00177   
<a name="l00178"></a>00178   <span class="keywordflow">return</span> (*<a class="code" href="classlibMesh_1_1ParallelMesh.php#a93dcd617abf4505ab8628472eb1cce90">_nodes</a>[i]);
<a name="l00179"></a>00179 }
<a name="l00180"></a>00180 
<a name="l00181"></a>00181 
<a name="l00182"></a>00182 
<a name="l00183"></a>00183 
<a name="l00184"></a>00184 
<a name="l00185"></a><a class="code" href="classlibMesh_1_1ParallelMesh.php#a572cdfe2bdfc8f52f9395b1a2e35c3ad">00185</a> <a class="code" href="classlibMesh_1_1Node.php">Node</a>&amp; <a class="code" href="classlibMesh_1_1ParallelMesh.php#a454136f0ecbe817adbec8ec370a1540a">ParallelMesh::node</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)
<a name="l00186"></a>00186 {
<a name="l00187"></a>00187   libmesh_assert (<a class="code" href="classlibMesh_1_1ParallelMesh.php#a93dcd617abf4505ab8628472eb1cce90">_nodes</a>[i] != NULL);
<a name="l00188"></a>00188   libmesh_assert (<a class="code" href="classlibMesh_1_1ParallelMesh.php#a93dcd617abf4505ab8628472eb1cce90">_nodes</a>[i]-&gt;<span class="keywordtype">id</span>() == i);  
<a name="l00189"></a>00189 
<a name="l00190"></a>00190   <span class="keywordflow">return</span> (*<a class="code" href="classlibMesh_1_1ParallelMesh.php#a93dcd617abf4505ab8628472eb1cce90">_nodes</a>[i]);
<a name="l00191"></a>00191 }
<a name="l00192"></a>00192 
<a name="l00193"></a>00193 
<a name="l00194"></a>00194 
<a name="l00195"></a><a class="code" href="classlibMesh_1_1ParallelMesh.php#af929cf6df7403ecc4d3a7e459f646bc8">00195</a> <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a>* <a class="code" href="classlibMesh_1_1ParallelMesh.php#af929cf6df7403ecc4d3a7e459f646bc8">ParallelMesh::node_ptr</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00196"></a>00196 <span class="keyword"></span>{
<a name="l00197"></a>00197 <span class="comment">//  libmesh_assert (_nodes[i] != NULL);</span>
<a name="l00198"></a>00198   libmesh_assert (<a class="code" href="classlibMesh_1_1ParallelMesh.php#a93dcd617abf4505ab8628472eb1cce90">_nodes</a>[i] == NULL || <a class="code" href="classlibMesh_1_1ParallelMesh.php#a93dcd617abf4505ab8628472eb1cce90">_nodes</a>[i]-&gt;<span class="keywordtype">id</span>() == i);  
<a name="l00199"></a>00199   
<a name="l00200"></a>00200   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1ParallelMesh.php#a93dcd617abf4505ab8628472eb1cce90">_nodes</a>[i];
<a name="l00201"></a>00201 }
<a name="l00202"></a>00202 
<a name="l00203"></a>00203 
<a name="l00204"></a>00204 
<a name="l00205"></a>00205 
<a name="l00206"></a><a class="code" href="classlibMesh_1_1ParallelMesh.php#a1ab714c74f4e9f19fb963e9d2c885dd9">00206</a> <a class="code" href="classlibMesh_1_1Node.php">Node</a>* &amp; <a class="code" href="classlibMesh_1_1ParallelMesh.php#af929cf6df7403ecc4d3a7e459f646bc8">ParallelMesh::node_ptr</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)
<a name="l00207"></a>00207 {
<a name="l00208"></a>00208 <span class="comment">//  libmesh_assert (_nodes[i] != NULL);</span>
<a name="l00209"></a>00209   libmesh_assert (<a class="code" href="classlibMesh_1_1ParallelMesh.php#a93dcd617abf4505ab8628472eb1cce90">_nodes</a>[i] == NULL || <a class="code" href="classlibMesh_1_1ParallelMesh.php#a93dcd617abf4505ab8628472eb1cce90">_nodes</a>[i]-&gt;<span class="keywordtype">id</span>() == i);
<a name="l00210"></a>00210 
<a name="l00211"></a>00211   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1ParallelMesh.php#a93dcd617abf4505ab8628472eb1cce90">_nodes</a>[i];
<a name="l00212"></a>00212 }
<a name="l00213"></a>00213 
<a name="l00214"></a>00214 
<a name="l00215"></a>00215 
<a name="l00216"></a>00216 
<a name="l00217"></a><a class="code" href="classlibMesh_1_1ParallelMesh.php#a5b15e05a7d948285783576569d00d3e3">00217</a> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <a class="code" href="classlibMesh_1_1ParallelMesh.php#a5b15e05a7d948285783576569d00d3e3">ParallelMesh::elem</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00218"></a>00218 <span class="keyword"></span>{
<a name="l00219"></a>00219 <span class="comment">//  libmesh_assert (_elements[i] != NULL);</span>
<a name="l00220"></a>00220   libmesh_assert (<a class="code" href="classlibMesh_1_1ParallelMesh.php#a0ccc1060937df3ec67ded54440e6590e">_elements</a>[i] == NULL || <a class="code" href="classlibMesh_1_1ParallelMesh.php#a0ccc1060937df3ec67ded54440e6590e">_elements</a>[i]-&gt;<span class="keywordtype">id</span>() == i);
<a name="l00221"></a>00221   
<a name="l00222"></a>00222   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1ParallelMesh.php#a0ccc1060937df3ec67ded54440e6590e">_elements</a>[i];
<a name="l00223"></a>00223 }
<a name="l00224"></a>00224 
<a name="l00225"></a>00225 
<a name="l00226"></a>00226 
<a name="l00227"></a>00227 
<a name="l00228"></a><a class="code" href="classlibMesh_1_1ParallelMesh.php#ad230cc153170488ad92ab4f6ee2146c7">00228</a> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <a class="code" href="classlibMesh_1_1ParallelMesh.php#ad230cc153170488ad92ab4f6ee2146c7">ParallelMesh::add_elem</a> (<a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *e)
<a name="l00229"></a>00229 {
<a name="l00230"></a>00230   <span class="comment">// Don&#39;t try to add NULLs!</span>
<a name="l00231"></a>00231   libmesh_assert(e);
<a name="l00232"></a>00232 
<a name="l00233"></a>00233   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> elem_procid = e-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">processor_id</a>();
<a name="l00234"></a>00234 
<a name="l00235"></a>00235   <span class="keywordflow">if</span> (!e-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#af2f7ac012e2ba614a49883ddb1bb6366">valid_id</a>())
<a name="l00236"></a>00236     {
<a name="l00237"></a>00237       <span class="comment">// Use the unpartitioned ids for unpartitioned elems,</span>
<a name="l00238"></a>00238       <span class="comment">// in serial, and temporarily for ghost elems</span>
<a name="l00239"></a>00239       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> *next_id = &amp;<a class="code" href="classlibMesh_1_1ParallelMesh.php#af2cf69eaed1ebdd13c4ede5429158649">_next_free_unpartitioned_elem_id</a>;
<a name="l00240"></a>00240       <span class="keywordflow">if</span> (elem_procid == <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &amp;&amp;
<a name="l00241"></a>00241           !this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#a6149774fe1885d2ee423f1398f50f847">is_serial</a>())
<a name="l00242"></a>00242         next_id = &amp;<a class="code" href="classlibMesh_1_1ParallelMesh.php#a576a8dc7ced081673c7ab8663752d591">_next_free_local_elem_id</a>;
<a name="l00243"></a>00243       e-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a7fe214a46de8b1773a2fa56568f826d4">set_id</a> (*next_id);
<a name="l00244"></a>00244       *next_id += <a class="code" href="classlibMesh_1_1MeshBase.php#a8b4ca46b2f69b29d670c737ba2b38600">libMesh::n_processors</a>() + 1;
<a name="l00245"></a>00245     }
<a name="l00246"></a>00246   <span class="keywordflow">else</span>
<a name="l00247"></a>00247     {
<a name="l00248"></a>00248       <span class="keywordflow">if</span> (_next_free_unpartitioned_elem_id &lt;= e-&gt;<span class="keywordtype">id</span>())
<a name="l00249"></a>00249         <a class="code" href="classlibMesh_1_1ParallelMesh.php#af2cf69eaed1ebdd13c4ede5429158649">_next_free_unpartitioned_elem_id</a> += <a class="code" href="classlibMesh_1_1MeshBase.php#a8b4ca46b2f69b29d670c737ba2b38600">libMesh::n_processors</a>() + 1;
<a name="l00250"></a>00250       <span class="keywordflow">if</span> (_next_free_local_elem_id &lt;= e-&gt;<span class="keywordtype">id</span>())
<a name="l00251"></a>00251         <a class="code" href="classlibMesh_1_1ParallelMesh.php#a576a8dc7ced081673c7ab8663752d591">_next_free_local_elem_id</a> += <a class="code" href="classlibMesh_1_1MeshBase.php#a8b4ca46b2f69b29d670c737ba2b38600">libMesh::n_processors</a>() + 1;
<a name="l00252"></a>00252     }
<a name="l00253"></a>00253 
<a name="l00254"></a>00254   <span class="comment">// Don&#39;t try to overwrite existing elems</span>
<a name="l00255"></a>00255   libmesh_assert (!<a class="code" href="classlibMesh_1_1ParallelMesh.php#a0ccc1060937df3ec67ded54440e6590e">_elements</a>[e-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()]);
<a name="l00256"></a>00256 
<a name="l00257"></a>00257   <a class="code" href="classlibMesh_1_1ParallelMesh.php#a0ccc1060937df3ec67ded54440e6590e">_elements</a>[e-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()] = e;
<a name="l00258"></a>00258 
<a name="l00259"></a>00259   <span class="comment">// Make the cached elem data more accurate</span>
<a name="l00260"></a>00260   <a class="code" href="classlibMesh_1_1ParallelMesh.php#ae3bbc433435383bcde09bd28aa13818e">_n_elem</a>++;
<a name="l00261"></a>00261   <a class="code" href="classlibMesh_1_1ParallelMesh.php#a2ff7a43f89e1ceb7bc3fc205483151be">_max_elem_id</a> = <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(<a class="code" href="classlibMesh_1_1ParallelMesh.php#a2ff7a43f89e1ceb7bc3fc205483151be">_max_elem_id</a>, e-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()+1);
<a name="l00262"></a>00262   
<a name="l00263"></a>00263 <span class="comment">// Unpartitioned elems should be added on every processor</span>
<a name="l00264"></a>00264 <span class="comment">// And shouldn&#39;t be added in the same batch as ghost elems</span>
<a name="l00265"></a>00265 <span class="comment">// But we might be just adding on processor 0 to</span>
<a name="l00266"></a>00266 <span class="comment">// broadcast later</span>
<a name="l00267"></a>00267 <span class="preprocessor">#if 0</span>
<a name="l00268"></a>00268 <span class="preprocessor"></span><span class="preprocessor">#ifdef DEBUG</span>
<a name="l00269"></a>00269 <span class="preprocessor"></span>  <span class="keywordflow">if</span> (elem_procid == <a class="code" href="classlibMesh_1_1DofObject.php#a46e3889aa741da5ebf483fe91fd1d431">DofObject::invalid_processor_id</a>)
<a name="l00270"></a>00270     {
<a name="l00271"></a>00271       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="xdr__io_8C.php#ab69c0b5b064ef16daf3f46102d138efa">elem_id</a> = e-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>();
<a name="l00272"></a>00272       <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">Parallel::max</a>(elem_id);
<a name="l00273"></a>00273       libmesh_assert(elem_id == e-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>());
<a name="l00274"></a>00274     }
<a name="l00275"></a>00275 <span class="preprocessor">#endif</span>
<a name="l00276"></a>00276 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00277"></a>00277 <span class="preprocessor"></span>
<a name="l00278"></a>00278   <span class="keywordflow">return</span> e;
<a name="l00279"></a>00279 }
<a name="l00280"></a>00280 
<a name="l00281"></a>00281 
<a name="l00282"></a>00282 
<a name="l00283"></a><a class="code" href="classlibMesh_1_1ParallelMesh.php#a467afea44aacb57e0e57eb5de3f8aa86">00283</a> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <a class="code" href="classlibMesh_1_1ParallelMesh.php#a467afea44aacb57e0e57eb5de3f8aa86">ParallelMesh::insert_elem</a> (<a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* e)
<a name="l00284"></a>00284 {
<a name="l00285"></a>00285   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1ParallelMesh.php#a0ccc1060937df3ec67ded54440e6590e">_elements</a>[e-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()])
<a name="l00286"></a>00286     this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#a18ec9841a284a6c31fb69ff6e445c35c">delete_elem</a>(<a class="code" href="classlibMesh_1_1ParallelMesh.php#a0ccc1060937df3ec67ded54440e6590e">_elements</a>[e-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()]);
<a name="l00287"></a>00287 
<a name="l00288"></a>00288   <a class="code" href="classlibMesh_1_1ParallelMesh.php#a0ccc1060937df3ec67ded54440e6590e">_elements</a>[e-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()] = e;
<a name="l00289"></a>00289 
<a name="l00290"></a>00290   <span class="keywordflow">return</span> e;
<a name="l00291"></a>00291 }
<a name="l00292"></a>00292 
<a name="l00293"></a>00293 
<a name="l00294"></a>00294 
<a name="l00295"></a><a class="code" href="classlibMesh_1_1ParallelMesh.php#a18ec9841a284a6c31fb69ff6e445c35c">00295</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ParallelMesh.php#a18ec9841a284a6c31fb69ff6e445c35c">ParallelMesh::delete_elem</a>(<a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* e)
<a name="l00296"></a>00296 {
<a name="l00297"></a>00297   libmesh_assert (e);
<a name="l00298"></a>00298 
<a name="l00299"></a>00299   <span class="comment">// Delete the element from the BoundaryInfo object</span>
<a name="l00300"></a>00300   this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;remove(e);
<a name="l00301"></a>00301 
<a name="l00302"></a>00302   <span class="comment">// But not yet from the container; we might invalidate</span>
<a name="l00303"></a>00303   <span class="comment">// an iterator that way!</span>
<a name="l00304"></a>00304 
<a name="l00305"></a>00305   <span class="comment">//_elements.erase(e-&gt;id());</span>
<a name="l00306"></a>00306 
<a name="l00307"></a>00307   <span class="comment">// Instead, we set it to NULL for now</span>
<a name="l00308"></a>00308 
<a name="l00309"></a>00309   <a class="code" href="classlibMesh_1_1ParallelMesh.php#a0ccc1060937df3ec67ded54440e6590e">_elements</a>[e-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()] = NULL;
<a name="l00310"></a>00310   
<a name="l00311"></a>00311   <span class="comment">// delete the element</span>
<a name="l00312"></a>00312   <span class="keyword">delete</span> e;
<a name="l00313"></a>00313 }
<a name="l00314"></a>00314 
<a name="l00315"></a>00315 
<a name="l00316"></a>00316 
<a name="l00317"></a><a class="code" href="classlibMesh_1_1ParallelMesh.php#a05e15401a367a0773ff8ca1eb9293f44">00317</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ParallelMesh.php#a05e15401a367a0773ff8ca1eb9293f44">ParallelMesh::renumber_elem</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> old_id,
<a name="l00318"></a>00318                                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> new_id)
<a name="l00319"></a>00319 {
<a name="l00320"></a>00320   <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *<a class="code" href="classlibMesh_1_1ParallelMesh.php#a5b15e05a7d948285783576569d00d3e3">elem</a> = <a class="code" href="classlibMesh_1_1ParallelMesh.php#a0ccc1060937df3ec67ded54440e6590e">_elements</a>[old_id];
<a name="l00321"></a>00321   libmesh_assert (elem);
<a name="l00322"></a>00322   libmesh_assert (elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>() == old_id);
<a name="l00323"></a>00323 
<a name="l00324"></a>00324   elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a7fe214a46de8b1773a2fa56568f826d4">set_id</a>(new_id);
<a name="l00325"></a>00325   libmesh_assert (!<a class="code" href="classlibMesh_1_1ParallelMesh.php#a0ccc1060937df3ec67ded54440e6590e">_elements</a>[new_id]);
<a name="l00326"></a>00326   <a class="code" href="classlibMesh_1_1ParallelMesh.php#a0ccc1060937df3ec67ded54440e6590e">_elements</a>[new_id] = <a class="code" href="classlibMesh_1_1ParallelMesh.php#a5b15e05a7d948285783576569d00d3e3">elem</a>;
<a name="l00327"></a>00327   <a class="code" href="classlibMesh_1_1ParallelMesh.php#a0ccc1060937df3ec67ded54440e6590e">_elements</a>.<a class="code" href="classlibMesh_1_1mapvector.php#a80a02556416b62e3bb87f64a0e5c21cf">erase</a>(old_id);
<a name="l00328"></a>00328 }
<a name="l00329"></a>00329 
<a name="l00330"></a>00330 
<a name="l00331"></a>00331 
<a name="l00332"></a><a class="code" href="classlibMesh_1_1ParallelMesh.php#aaf046537db0139a6c515dec62dedaf5d">00332</a> <a class="code" href="classlibMesh_1_1Node.php">Node</a>* <a class="code" href="classlibMesh_1_1ParallelMesh.php#aaf046537db0139a6c515dec62dedaf5d">ParallelMesh::add_point</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p,
<a name="l00333"></a>00333                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <span class="keywordtype">id</span>,
<a name="l00334"></a>00334                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id)
<a name="l00335"></a>00335 {  
<a name="l00336"></a>00336   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1ParallelMesh.php#a93dcd617abf4505ab8628472eb1cce90">_nodes</a>.count(<span class="keywordtype">id</span>))
<a name="l00337"></a>00337     {
<a name="l00338"></a>00338       <a class="code" href="classlibMesh_1_1Node.php">Node</a> *n = <a class="code" href="classlibMesh_1_1ParallelMesh.php#a93dcd617abf4505ab8628472eb1cce90">_nodes</a>[id];
<a name="l00339"></a>00339       libmesh_assert (n);
<a name="l00340"></a>00340       libmesh_assert (n-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>() == id);
<a name="l00341"></a>00341       
<a name="l00342"></a>00342       *n = p;
<a name="l00343"></a>00343       n-&gt;processor_id() = proc_id;
<a name="l00344"></a>00344 
<a name="l00345"></a>00345       <span class="keywordflow">return</span> n;
<a name="l00346"></a>00346     }
<a name="l00347"></a>00347 
<a name="l00348"></a>00348   <a class="code" href="classlibMesh_1_1Node.php">Node</a>* n = <a class="code" href="classlibMesh_1_1Node.php#a25a962918684ad079dfb52eac7f07132">Node::build</a>(p, <span class="keywordtype">id</span>).release();
<a name="l00349"></a>00349   n-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">processor_id</a>() = proc_id;
<a name="l00350"></a>00350 
<a name="l00351"></a>00351   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1ParallelMesh.php#a0361fbb9f7c55066ec20b45c02db63fb">ParallelMesh::add_node</a>(n);
<a name="l00352"></a>00352 }
<a name="l00353"></a>00353 
<a name="l00354"></a>00354 
<a name="l00355"></a>00355 
<a name="l00356"></a><a class="code" href="classlibMesh_1_1ParallelMesh.php#a0361fbb9f7c55066ec20b45c02db63fb">00356</a> <a class="code" href="classlibMesh_1_1Node.php">Node</a>* <a class="code" href="classlibMesh_1_1ParallelMesh.php#a0361fbb9f7c55066ec20b45c02db63fb">ParallelMesh::add_node</a> (<a class="code" href="classlibMesh_1_1Node.php">Node</a> *n)
<a name="l00357"></a>00357 {
<a name="l00358"></a>00358   <span class="comment">// Don&#39;t try to add NULLs!</span>
<a name="l00359"></a>00359   libmesh_assert(n);
<a name="l00360"></a>00360 
<a name="l00361"></a>00361   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> node_procid = n-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">processor_id</a>();
<a name="l00362"></a>00362 
<a name="l00363"></a>00363   <span class="keywordflow">if</span> (!n-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#af2f7ac012e2ba614a49883ddb1bb6366">valid_id</a>())
<a name="l00364"></a>00364     {
<a name="l00365"></a>00365       <span class="comment">// Use the unpartitioned ids for unpartitioned nodes,</span>
<a name="l00366"></a>00366       <span class="comment">// in serial, and temporarily for ghost nodes</span>
<a name="l00367"></a>00367       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> *next_id = &amp;<a class="code" href="classlibMesh_1_1ParallelMesh.php#aa84f67d0ac65d3e1cdd7afdc6f292672">_next_free_unpartitioned_node_id</a>;
<a name="l00368"></a>00368       <span class="keywordflow">if</span> (node_procid == <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &amp;&amp;
<a name="l00369"></a>00369           !this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#a6149774fe1885d2ee423f1398f50f847">is_serial</a>())
<a name="l00370"></a>00370         next_id = &amp;<a class="code" href="classlibMesh_1_1ParallelMesh.php#ac1c91b6ea0a74ee9f5a7aa21a0f77332">_next_free_local_node_id</a>;
<a name="l00371"></a>00371       n-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a7fe214a46de8b1773a2fa56568f826d4">set_id</a> (*next_id);
<a name="l00372"></a>00372       *next_id += <a class="code" href="classlibMesh_1_1MeshBase.php#a8b4ca46b2f69b29d670c737ba2b38600">libMesh::n_processors</a>() + 1;
<a name="l00373"></a>00373     }
<a name="l00374"></a>00374   <span class="keywordflow">else</span>
<a name="l00375"></a>00375     {
<a name="l00376"></a>00376       <span class="keywordflow">if</span> (_next_free_unpartitioned_node_id &lt;= n-&gt;<span class="keywordtype">id</span>())
<a name="l00377"></a>00377         <a class="code" href="classlibMesh_1_1ParallelMesh.php#aa84f67d0ac65d3e1cdd7afdc6f292672">_next_free_unpartitioned_node_id</a> += <a class="code" href="classlibMesh_1_1MeshBase.php#a8b4ca46b2f69b29d670c737ba2b38600">libMesh::n_processors</a>() + 1;
<a name="l00378"></a>00378       <span class="keywordflow">if</span> (_next_free_local_node_id &lt;= n-&gt;<span class="keywordtype">id</span>())
<a name="l00379"></a>00379         <a class="code" href="classlibMesh_1_1ParallelMesh.php#ac1c91b6ea0a74ee9f5a7aa21a0f77332">_next_free_local_node_id</a> += <a class="code" href="classlibMesh_1_1MeshBase.php#a8b4ca46b2f69b29d670c737ba2b38600">libMesh::n_processors</a>() + 1;
<a name="l00380"></a>00380     }
<a name="l00381"></a>00381 
<a name="l00382"></a>00382   <span class="comment">// Don&#39;t try to overwrite existing nodes</span>
<a name="l00383"></a>00383   libmesh_assert (!<a class="code" href="classlibMesh_1_1ParallelMesh.php#a93dcd617abf4505ab8628472eb1cce90">_nodes</a>[n-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()]);
<a name="l00384"></a>00384 
<a name="l00385"></a>00385   <a class="code" href="classlibMesh_1_1ParallelMesh.php#a93dcd617abf4505ab8628472eb1cce90">_nodes</a>[n-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()] = n;
<a name="l00386"></a>00386   
<a name="l00387"></a>00387   <span class="comment">// Make the cached elem data more accurate</span>
<a name="l00388"></a>00388   <a class="code" href="classlibMesh_1_1ParallelMesh.php#af70058d54e5d727f87c524dbc0013f46">_n_nodes</a>++;
<a name="l00389"></a>00389   <a class="code" href="classlibMesh_1_1ParallelMesh.php#a4ade8de51594885d94713fe1de9efa01">_max_node_id</a> = <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(<a class="code" href="classlibMesh_1_1ParallelMesh.php#a4ade8de51594885d94713fe1de9efa01">_max_node_id</a>, n-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()+1);
<a name="l00390"></a>00390   
<a name="l00391"></a>00391 <span class="comment">// Unpartitioned nodes should be added on every processor</span>
<a name="l00392"></a>00392 <span class="comment">// And shouldn&#39;t be added in the same batch as ghost nodes</span>
<a name="l00393"></a>00393 <span class="comment">// But we might be just adding on processor 0 to</span>
<a name="l00394"></a>00394 <span class="comment">// broadcast later</span>
<a name="l00395"></a>00395 <span class="preprocessor">#if 0</span>
<a name="l00396"></a>00396 <span class="preprocessor"></span><span class="preprocessor">#ifdef DEBUG</span>
<a name="l00397"></a>00397 <span class="preprocessor"></span>  <span class="keywordflow">if</span> (node_procid == <a class="code" href="classlibMesh_1_1DofObject.php#a46e3889aa741da5ebf483fe91fd1d431">DofObject::invalid_processor_id</a>)
<a name="l00398"></a>00398     {
<a name="l00399"></a>00399       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> node_id = n-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>();
<a name="l00400"></a>00400       <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">Parallel::max</a>(node_id);
<a name="l00401"></a>00401       libmesh_assert(node_id == n-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>());
<a name="l00402"></a>00402     }
<a name="l00403"></a>00403 <span class="preprocessor">#endif</span>
<a name="l00404"></a>00404 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00405"></a>00405 <span class="preprocessor"></span>
<a name="l00406"></a>00406   <span class="keywordflow">return</span> n;
<a name="l00407"></a>00407 }
<a name="l00408"></a>00408 
<a name="l00409"></a>00409 
<a name="l00410"></a>00410 
<a name="l00411"></a><a class="code" href="classlibMesh_1_1ParallelMesh.php#a85ef9faafacd3006a31317a7f8d8ef4c">00411</a> <a class="code" href="classlibMesh_1_1Node.php">Node</a>* <a class="code" href="classlibMesh_1_1ParallelMesh.php#a85ef9faafacd3006a31317a7f8d8ef4c">ParallelMesh::insert_node</a> (<a class="code" href="classlibMesh_1_1Node.php">Node</a>* n)
<a name="l00412"></a>00412 {
<a name="l00413"></a>00413   <span class="comment">// If we already have this node we cannot</span>
<a name="l00414"></a>00414   <span class="comment">// simply delete it, because we may have elements</span>
<a name="l00415"></a>00415   <span class="comment">// which are attached to its address.</span>
<a name="l00416"></a>00416   <span class="comment">//</span>
<a name="l00417"></a>00417   <span class="comment">// Instead, call the Node = Point assignment operator</span>
<a name="l00418"></a>00418   <span class="comment">// to overwrite the spatial coordinates (but keep its</span>
<a name="l00419"></a>00419   <span class="comment">// address), delete the provided node, and return the</span>
<a name="l00420"></a>00420   <span class="comment">// address of the one we already had.</span>
<a name="l00421"></a>00421   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1ParallelMesh.php#a93dcd617abf4505ab8628472eb1cce90">_nodes</a>.count(n-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()))
<a name="l00422"></a>00422     {
<a name="l00423"></a>00423       <a class="code" href="classlibMesh_1_1Node.php">Node</a> *my_n = <a class="code" href="classlibMesh_1_1ParallelMesh.php#a93dcd617abf4505ab8628472eb1cce90">_nodes</a>[n-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()];
<a name="l00424"></a>00424 
<a name="l00425"></a>00425       *my_n = <span class="keyword">static_cast&lt;</span><a class="code" href="classlibMesh_1_1Point.php">Point</a><span class="keyword">&gt;</span>(*n);
<a name="l00426"></a>00426       <span class="keyword">delete</span> n;
<a name="l00427"></a>00427       n = my_n;
<a name="l00428"></a>00428     }
<a name="l00429"></a>00429   <span class="keywordflow">else</span>
<a name="l00430"></a>00430     <a class="code" href="classlibMesh_1_1ParallelMesh.php#a93dcd617abf4505ab8628472eb1cce90">_nodes</a>[n-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()] = n;
<a name="l00431"></a>00431 
<a name="l00432"></a>00432   <span class="keywordflow">return</span> n;
<a name="l00433"></a>00433 }
<a name="l00434"></a>00434 
<a name="l00435"></a>00435 
<a name="l00436"></a>00436 
<a name="l00437"></a><a class="code" href="classlibMesh_1_1ParallelMesh.php#ab5499379a814832a4d8ebd8b721b2a91">00437</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ParallelMesh.php#ab5499379a814832a4d8ebd8b721b2a91">ParallelMesh::delete_node</a>(<a class="code" href="classlibMesh_1_1Node.php">Node</a>* n)
<a name="l00438"></a>00438 {
<a name="l00439"></a>00439   libmesh_assert (n != NULL);
<a name="l00440"></a>00440   libmesh_assert (<a class="code" href="classlibMesh_1_1ParallelMesh.php#a93dcd617abf4505ab8628472eb1cce90">_nodes</a>[n-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()] != NULL);
<a name="l00441"></a>00441 
<a name="l00442"></a>00442   <span class="comment">// Delete the node from the BoundaryInfo object</span>
<a name="l00443"></a>00443   this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;remove(n);
<a name="l00444"></a>00444 
<a name="l00445"></a>00445   <span class="comment">// And from the container</span>
<a name="l00446"></a>00446   <a class="code" href="classlibMesh_1_1ParallelMesh.php#a93dcd617abf4505ab8628472eb1cce90">_nodes</a>.<a class="code" href="classlibMesh_1_1mapvector.php#a80a02556416b62e3bb87f64a0e5c21cf">erase</a>(n-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>());
<a name="l00447"></a>00447   
<a name="l00448"></a>00448   <span class="comment">// delete the node</span>
<a name="l00449"></a>00449   <span class="keyword">delete</span> n;
<a name="l00450"></a>00450 }
<a name="l00451"></a>00451 
<a name="l00452"></a>00452 
<a name="l00453"></a>00453 
<a name="l00454"></a><a class="code" href="classlibMesh_1_1ParallelMesh.php#a332329d86145018a84e41e3223565a56">00454</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ParallelMesh.php#a332329d86145018a84e41e3223565a56">ParallelMesh::renumber_node</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> old_id,
<a name="l00455"></a>00455                                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> new_id)
<a name="l00456"></a>00456 {
<a name="l00457"></a>00457   <a class="code" href="classlibMesh_1_1Node.php">Node</a> *<a class="code" href="classlibMesh_1_1ParallelMesh.php#a454136f0ecbe817adbec8ec370a1540a">node</a> = <a class="code" href="classlibMesh_1_1ParallelMesh.php#a93dcd617abf4505ab8628472eb1cce90">_nodes</a>[old_id];
<a name="l00458"></a>00458   libmesh_assert (node);
<a name="l00459"></a>00459   libmesh_assert (node-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>() == old_id);
<a name="l00460"></a>00460 
<a name="l00461"></a>00461   node-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a7fe214a46de8b1773a2fa56568f826d4">set_id</a>(new_id);
<a name="l00462"></a>00462   libmesh_assert (!<a class="code" href="classlibMesh_1_1ParallelMesh.php#a93dcd617abf4505ab8628472eb1cce90">_nodes</a>[new_id]);
<a name="l00463"></a>00463   <a class="code" href="classlibMesh_1_1ParallelMesh.php#a93dcd617abf4505ab8628472eb1cce90">_nodes</a>[new_id] = <a class="code" href="classlibMesh_1_1ParallelMesh.php#a454136f0ecbe817adbec8ec370a1540a">node</a>;
<a name="l00464"></a>00464   <a class="code" href="classlibMesh_1_1ParallelMesh.php#a93dcd617abf4505ab8628472eb1cce90">_nodes</a>.<a class="code" href="classlibMesh_1_1mapvector.php#a80a02556416b62e3bb87f64a0e5c21cf">erase</a>(old_id);
<a name="l00465"></a>00465 }
<a name="l00466"></a>00466 
<a name="l00467"></a>00467 
<a name="l00468"></a>00468 
<a name="l00469"></a><a class="code" href="classlibMesh_1_1ParallelMesh.php#a7649541e7576d5246ae5192293a10153">00469</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ParallelMesh.php#a7649541e7576d5246ae5192293a10153">ParallelMesh::clear</a> ()
<a name="l00470"></a>00470 {
<a name="l00471"></a>00471   <span class="comment">// Call parent clear function</span>
<a name="l00472"></a>00472   <a class="code" href="classlibMesh_1_1ParallelMesh.php#a7649541e7576d5246ae5192293a10153">MeshBase::clear</a>();
<a name="l00473"></a>00473 
<a name="l00474"></a>00474   
<a name="l00475"></a>00475   <span class="comment">// Clear our elements and nodes</span>
<a name="l00476"></a>00476   {
<a name="l00477"></a>00477     <a class="code" href="classlibMesh_1_1ParallelMesh.php#a2dab276070364298e00df807046df55c">elem_iterator_imp</a>        it = <a class="code" href="classlibMesh_1_1ParallelMesh.php#a0ccc1060937df3ec67ded54440e6590e">_elements</a>.<a class="code" href="classlibMesh_1_1mapvector.php#a707b45f1d69a9ef9a214343b85d402da">begin</a>();
<a name="l00478"></a>00478     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ParallelMesh.php#a2dab276070364298e00df807046df55c">elem_iterator_imp</a> end = <a class="code" href="classlibMesh_1_1ParallelMesh.php#a0ccc1060937df3ec67ded54440e6590e">_elements</a>.<a class="code" href="classlibMesh_1_1mapvector.php#a89fd9cbe464dc374f033283ecbb9d200">end</a>();
<a name="l00479"></a>00479 
<a name="l00480"></a>00480     <span class="comment">// There is no need to remove the elements from</span>
<a name="l00481"></a>00481     <span class="comment">// the BoundaryInfo data structure since we</span>
<a name="l00482"></a>00482     <span class="comment">// already cleared it.</span>
<a name="l00483"></a>00483     <span class="keywordflow">for</span> (; it != end; ++it)
<a name="l00484"></a>00484       <span class="keyword">delete</span> *it;
<a name="l00485"></a>00485 
<a name="l00486"></a>00486     <a class="code" href="classlibMesh_1_1ParallelMesh.php#a0ccc1060937df3ec67ded54440e6590e">_elements</a>.clear();
<a name="l00487"></a>00487   }
<a name="l00488"></a>00488 
<a name="l00489"></a>00489   <span class="comment">// clear the nodes data structure</span>
<a name="l00490"></a>00490   {
<a name="l00491"></a>00491     <a class="code" href="classlibMesh_1_1ParallelMesh.php#a97fd0ae8092ccb5070d2baadfdb24b91">node_iterator_imp</a> it  = <a class="code" href="classlibMesh_1_1ParallelMesh.php#a93dcd617abf4505ab8628472eb1cce90">_nodes</a>.<a class="code" href="classlibMesh_1_1mapvector.php#a707b45f1d69a9ef9a214343b85d402da">begin</a>();
<a name="l00492"></a>00492     <a class="code" href="classlibMesh_1_1ParallelMesh.php#a97fd0ae8092ccb5070d2baadfdb24b91">node_iterator_imp</a> end = <a class="code" href="classlibMesh_1_1ParallelMesh.php#a93dcd617abf4505ab8628472eb1cce90">_nodes</a>.<a class="code" href="classlibMesh_1_1mapvector.php#a89fd9cbe464dc374f033283ecbb9d200">end</a>();
<a name="l00493"></a>00493 
<a name="l00494"></a>00494     <span class="comment">// There is no need to remove the nodes from</span>
<a name="l00495"></a>00495     <span class="comment">// the BoundaryInfo data structure since we</span>
<a name="l00496"></a>00496     <span class="comment">// already cleared it.</span>
<a name="l00497"></a>00497     <span class="keywordflow">for</span> (; it != end; ++it)
<a name="l00498"></a>00498       <span class="keyword">delete</span> *it;
<a name="l00499"></a>00499     
<a name="l00500"></a>00500     <a class="code" href="classlibMesh_1_1ParallelMesh.php#a93dcd617abf4505ab8628472eb1cce90">_nodes</a>.clear();
<a name="l00501"></a>00501   }
<a name="l00502"></a>00502 
<a name="l00503"></a>00503   <span class="comment">// We&#39;re no longer distributed if we were before</span>
<a name="l00504"></a>00504   <a class="code" href="classlibMesh_1_1ParallelMesh.php#aa5ec1fff0c588a69e81a84a16120efd1">_is_serial</a> = <span class="keyword">true</span>;
<a name="l00505"></a>00505 
<a name="l00506"></a>00506   <span class="comment">// Correct our caches</span>
<a name="l00507"></a>00507   <a class="code" href="classlibMesh_1_1ParallelMesh.php#af70058d54e5d727f87c524dbc0013f46">_n_nodes</a> = 0;
<a name="l00508"></a>00508   <a class="code" href="classlibMesh_1_1ParallelMesh.php#ae3bbc433435383bcde09bd28aa13818e">_n_elem</a> = 0;
<a name="l00509"></a>00509   <a class="code" href="classlibMesh_1_1ParallelMesh.php#a4ade8de51594885d94713fe1de9efa01">_max_node_id</a> = 0;
<a name="l00510"></a>00510   <a class="code" href="classlibMesh_1_1ParallelMesh.php#a2ff7a43f89e1ceb7bc3fc205483151be">_max_elem_id</a> = 0;
<a name="l00511"></a>00511   <a class="code" href="classlibMesh_1_1ParallelMesh.php#ac1c91b6ea0a74ee9f5a7aa21a0f77332">_next_free_local_node_id</a> = <a class="code" href="classlibMesh_1_1MeshBase.php#aa557872c33163622cc66645fc393c925">libMesh::processor_id</a>();
<a name="l00512"></a>00512   <a class="code" href="classlibMesh_1_1ParallelMesh.php#a576a8dc7ced081673c7ab8663752d591">_next_free_local_elem_id</a> = <a class="code" href="classlibMesh_1_1MeshBase.php#aa557872c33163622cc66645fc393c925">libMesh::processor_id</a>();
<a name="l00513"></a>00513   <a class="code" href="classlibMesh_1_1ParallelMesh.php#aa84f67d0ac65d3e1cdd7afdc6f292672">_next_free_unpartitioned_node_id</a> = <a class="code" href="classlibMesh_1_1MeshBase.php#a8b4ca46b2f69b29d670c737ba2b38600">libMesh::n_processors</a>();
<a name="l00514"></a>00514   <a class="code" href="classlibMesh_1_1ParallelMesh.php#af2cf69eaed1ebdd13c4ede5429158649">_next_free_unpartitioned_elem_id</a> = <a class="code" href="classlibMesh_1_1MeshBase.php#a8b4ca46b2f69b29d670c737ba2b38600">libMesh::n_processors</a>();
<a name="l00515"></a>00515 }
<a name="l00516"></a>00516 
<a name="l00517"></a>00517 
<a name="l00518"></a>00518 
<a name="l00519"></a>00519 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00520"></a>00520 <span class="preprocessor"></span><span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00521"></a>00521 <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ParallelMesh.php#ab203ea7e93074e74f2eb920d285bc88c">ParallelMesh::libmesh_assert_valid_parallel_object_ids</a> 
<a name="l00522"></a><a class="code" href="classlibMesh_1_1ParallelMesh.php#ab203ea7e93074e74f2eb920d285bc88c">00522</a>   (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1mapvector.php">mapvector&lt;T*&gt;</a> &amp;objects) <span class="keyword">const</span>
<a name="l00523"></a>00523 {
<a name="l00524"></a>00524   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00525"></a>00525   parallel_only();
<a name="l00526"></a>00526 
<a name="l00527"></a>00527   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pmax_elem_id = this-&gt;parallel_max_elem_id();
<a name="l00528"></a>00528 
<a name="l00529"></a>00529   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != pmax_elem_id; ++i)
<a name="l00530"></a>00530     {
<a name="l00531"></a>00531       T* obj = objects[i]; <span class="comment">// Returns NULL if there&#39;s no map entry</span>
<a name="l00532"></a>00532 
<a name="l00533"></a>00533       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dofid = obj &amp;&amp; obj-&gt;valid_id() ?
<a name="l00534"></a>00534         obj-&gt;id() : <a class="code" href="classlibMesh_1_1DofObject.php#a1801e332bf034abe252086db668fee2d">DofObject::invalid_id</a>;
<a name="l00535"></a>00535       <span class="comment">// Local lookups by id should return the requested object</span>
<a name="l00536"></a>00536       libmesh_assert(!obj || obj-&gt;id() == i);
<a name="l00537"></a>00537 
<a name="l00538"></a>00538       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> min_dofid = dofid;
<a name="l00539"></a>00539       <a class="code" href="namespacelibMesh_1_1Parallel.php#ad612bc0ffd617ebe5f47ffeecd7aae96">Parallel::min</a>(min_dofid);
<a name="l00540"></a>00540       <span class="comment">// All processors with an object should agree on id</span>
<a name="l00541"></a>00541       libmesh_assert (!obj || dofid == min_dofid);
<a name="l00542"></a>00542 
<a name="l00543"></a>00543       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> procid = obj &amp;&amp; obj-&gt;valid_processor_id() ?
<a name="l00544"></a>00544         obj-&gt;processor_id() : <a class="code" href="classlibMesh_1_1DofObject.php#a46e3889aa741da5ebf483fe91fd1d431">DofObject::invalid_processor_id</a>;
<a name="l00545"></a>00545 
<a name="l00546"></a>00546       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> min_procid = procid;
<a name="l00547"></a>00547       <a class="code" href="namespacelibMesh_1_1Parallel.php#ad612bc0ffd617ebe5f47ffeecd7aae96">Parallel::min</a>(min_procid);
<a name="l00548"></a>00548       <span class="comment">// All processors with an object should agree on processor id</span>
<a name="l00549"></a>00549       libmesh_assert (!obj || procid == min_procid);
<a name="l00550"></a>00550       <span class="comment">// I should own any object another processor thinks I do</span>
<a name="l00551"></a>00551       libmesh_assert (min_procid != <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() || obj);
<a name="l00552"></a>00552     }
<a name="l00553"></a>00553 }
<a name="l00554"></a>00554 
<a name="l00555"></a>00555 
<a name="l00556"></a>00556 
<a name="l00557"></a><a class="code" href="classlibMesh_1_1ParallelMesh.php#a71de7cc0384ce24b982c49b2276478b3">00557</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ParallelMesh.php#a71de7cc0384ce24b982c49b2276478b3">ParallelMesh::libmesh_assert_valid_parallel_ids</a> ()<span class="keyword"> const</span>
<a name="l00558"></a>00558 <span class="keyword"></span>{
<a name="l00559"></a>00559   this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#ab203ea7e93074e74f2eb920d285bc88c">libmesh_assert_valid_parallel_object_ids</a> (this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#a0ccc1060937df3ec67ded54440e6590e">_elements</a>);
<a name="l00560"></a>00560   this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#ab203ea7e93074e74f2eb920d285bc88c">libmesh_assert_valid_parallel_object_ids</a> (this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#a93dcd617abf4505ab8628472eb1cce90">_nodes</a>);
<a name="l00561"></a>00561 }
<a name="l00562"></a>00562 
<a name="l00563"></a>00563 
<a name="l00564"></a>00564 
<a name="l00565"></a><a class="code" href="classlibMesh_1_1ParallelMesh.php#a20683143bfb9f9a2d842f2aeb93835dd">00565</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ParallelMesh.php#a20683143bfb9f9a2d842f2aeb93835dd">ParallelMesh::libmesh_assert_valid_parallel_flags</a> ()<span class="keyword"> const</span>
<a name="l00566"></a>00566 <span class="keyword"></span>{
<a name="l00567"></a>00567 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00568"></a>00568 <span class="preprocessor"></span>  <span class="comment">// This function must be run on all processors at once</span>
<a name="l00569"></a>00569   parallel_only();
<a name="l00570"></a>00570 
<a name="l00571"></a>00571   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pmax_elem_id = this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#aed4cdeb0ddd80a2621d35fa3e61a4d0c">parallel_max_elem_id</a>();
<a name="l00572"></a>00572 
<a name="l00573"></a>00573   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != pmax_elem_id; ++i)
<a name="l00574"></a>00574     {
<a name="l00575"></a>00575       <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <a class="code" href="classlibMesh_1_1ParallelMesh.php#a5b15e05a7d948285783576569d00d3e3">elem</a> = <a class="code" href="classlibMesh_1_1ParallelMesh.php#a0ccc1060937df3ec67ded54440e6590e">_elements</a>[i]; <span class="comment">// Returns NULL if there&#39;s no map entry</span>
<a name="l00576"></a>00576 
<a name="l00577"></a>00577       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> refinement_flag   = elem ?
<a name="l00578"></a>00578         <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a174bfe5b3d22e2b79000bfc816f633e6">refinement_flag</a>()) : <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>;
<a name="l00579"></a>00579       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p_refinement_flag = elem ?
<a name="l00580"></a>00580         <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a53a98cf29aef9af6292c812d7b905c18">p_refinement_flag</a>()) : <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>;
<a name="l00581"></a>00581 
<a name="l00582"></a>00582       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> min_rflag = refinement_flag;
<a name="l00583"></a>00583       <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">Parallel::min</a>(min_rflag);
<a name="l00584"></a>00584       <span class="comment">// All processors with this element should agree on flag</span>
<a name="l00585"></a>00585       libmesh_assert (!elem || min_rflag == refinement_flag);
<a name="l00586"></a>00586 
<a name="l00587"></a>00587       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> min_pflag = p_refinement_flag;
<a name="l00588"></a>00588       <span class="comment">// All processors with this element should agree on flag</span>
<a name="l00589"></a>00589       libmesh_assert (!elem || min_pflag == p_refinement_flag);
<a name="l00590"></a>00590     }
<a name="l00591"></a>00591 <span class="preprocessor">#endif // LIBMESH_ENABLE_AMR</span>
<a name="l00592"></a>00592 <span class="preprocessor"></span>}
<a name="l00593"></a>00593 <span class="preprocessor">#endif // DEBUG</span>
<a name="l00594"></a>00594 <span class="preprocessor"></span>
<a name="l00595"></a>00595 
<a name="l00596"></a>00596 
<a name="l00597"></a>00597 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00598"></a><a class="code" href="classlibMesh_1_1ParallelMesh.php#a17d4240194816767b705e606062c720f">00598</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ParallelMesh.php#a17d4240194816767b705e606062c720f">ParallelMesh::renumber_dof_objects</a> (<a class="code" href="classlibMesh_1_1mapvector.php">mapvector&lt;T*&gt;</a> &amp;objects)
<a name="l00599"></a>00599 {
<a name="l00600"></a>00600   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00601"></a>00601   parallel_only();
<a name="l00602"></a>00602 
<a name="l00603"></a>00603   <span class="keyword">typedef</span> <span class="keyword">typename</span> <a class="code" href="classlibMesh_1_1mapvector_1_1veclike__iterator.php">mapvector&lt;T*&gt;::veclike_iterator</a> object_iterator;
<a name="l00604"></a>00604 
<a name="l00605"></a>00605   <span class="comment">// In parallel we may not know what objects other processors have.</span>
<a name="l00606"></a>00606   <span class="comment">// Start by figuring out how many</span>
<a name="l00607"></a>00607   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> unpartitioned_objects = 0;
<a name="l00608"></a>00608 
<a name="l00609"></a>00609   std::vector&lt;unsigned int&gt;
<a name="l00610"></a>00610     ghost_objects_from_proc(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(), 0);
<a name="l00611"></a>00611 
<a name="l00612"></a>00612   object_iterator it  = objects.<a class="code" href="classlibMesh_1_1mapvector.php#a707b45f1d69a9ef9a214343b85d402da">begin</a>();
<a name="l00613"></a>00613   object_iterator end = objects.<a class="code" href="classlibMesh_1_1mapvector.php#a89fd9cbe464dc374f033283ecbb9d200">end</a>();
<a name="l00614"></a>00614 
<a name="l00615"></a>00615   <span class="keywordflow">for</span> (; it != end;)
<a name="l00616"></a>00616     {
<a name="l00617"></a>00617       T *obj = *it;
<a name="l00618"></a>00618 
<a name="l00619"></a>00619       <span class="comment">// Remove any NULL container entries while we&#39;re here,</span>
<a name="l00620"></a>00620       <span class="comment">// being careful not to invalidate our iterator</span>
<a name="l00621"></a>00621       <span class="keywordflow">if</span> (!*it)
<a name="l00622"></a>00622         objects.<a class="code" href="classlibMesh_1_1mapvector.php#a80a02556416b62e3bb87f64a0e5c21cf">erase</a>(it++);
<a name="l00623"></a>00623       <span class="keywordflow">else</span>
<a name="l00624"></a>00624         {
<a name="l00625"></a>00625           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> obj_procid = obj-&gt;processor_id();
<a name="l00626"></a>00626           <span class="keywordflow">if</span> (obj_procid == <a class="code" href="classlibMesh_1_1DofObject.php#a46e3889aa741da5ebf483fe91fd1d431">DofObject::invalid_processor_id</a>)
<a name="l00627"></a>00627             unpartitioned_objects++;
<a name="l00628"></a>00628           <span class="keywordflow">else</span>
<a name="l00629"></a>00629             ghost_objects_from_proc[obj_procid]++;
<a name="l00630"></a>00630           ++it;
<a name="l00631"></a>00631         }
<a name="l00632"></a>00632     }
<a name="l00633"></a>00633 
<a name="l00634"></a>00634   std::vector&lt;unsigned int&gt; objects_on_proc(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(), 0);
<a name="l00635"></a>00635   <a class="code" href="classlibMesh_1_1ParallelMesh.php#ac88199c0b21d0e97e7f74c005fb24c46">Parallel::allgather</a>(ghost_objects_from_proc[<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>()],
<a name="l00636"></a>00636                       objects_on_proc);
<a name="l00637"></a>00637 
<a name="l00638"></a>00638 <span class="preprocessor">#ifndef NDEBUG</span>
<a name="l00639"></a>00639 <span class="preprocessor"></span>  <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> global_unpartitioned_objects = unpartitioned_objects;
<a name="l00640"></a>00640   <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">Parallel::max</a>(global_unpartitioned_objects);
<a name="l00641"></a>00641   libmesh_assert(global_unpartitioned_objects == unpartitioned_objects);
<a name="l00642"></a>00642   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p != <a class="code" href="classlibMesh_1_1MeshBase.php#a8b4ca46b2f69b29d670c737ba2b38600">libMesh::n_processors</a>(); ++p)
<a name="l00643"></a>00643     libmesh_assert(ghost_objects_from_proc[p] &lt;= objects_on_proc[p]);
<a name="l00644"></a>00644 <span class="preprocessor">#endif</span>
<a name="l00645"></a>00645 <span class="preprocessor"></span>
<a name="l00646"></a>00646   <span class="comment">// We&#39;ll renumber objects in blocks by processor id</span>
<a name="l00647"></a>00647   std::vector&lt;unsigned int&gt; first_object_on_proc(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>());
<a name="l00648"></a>00648   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=1; i != <a class="code" href="classlibMesh_1_1MeshBase.php#a8b4ca46b2f69b29d670c737ba2b38600">libMesh::n_processors</a>(); ++i)
<a name="l00649"></a>00649     first_object_on_proc[i] = first_object_on_proc[i-1] +
<a name="l00650"></a>00650                               objects_on_proc[i-1];
<a name="l00651"></a>00651   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> next_id = first_object_on_proc[<a class="code" href="classlibMesh_1_1MeshBase.php#aa557872c33163622cc66645fc393c925">libMesh::processor_id</a>()];
<a name="l00652"></a>00652   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> first_free_id =
<a name="l00653"></a>00653     first_object_on_proc[<a class="code" href="classlibMesh_1_1MeshBase.php#a8b4ca46b2f69b29d670c737ba2b38600">libMesh::n_processors</a>()-1] +
<a name="l00654"></a>00654     objects_on_proc[<a class="code" href="classlibMesh_1_1MeshBase.php#a8b4ca46b2f69b29d670c737ba2b38600">libMesh::n_processors</a>()-1] + 
<a name="l00655"></a>00655     unpartitioned_objects;
<a name="l00656"></a>00656 
<a name="l00657"></a>00657   <span class="comment">// First set new local object ids and build request sets </span>
<a name="l00658"></a>00658   <span class="comment">// for non-local object ids</span>
<a name="l00659"></a>00659   
<a name="l00660"></a>00660   <span class="comment">// Request sets to send to each processor</span>
<a name="l00661"></a>00661   std::vector&lt;std::vector&lt;unsigned int&gt; &gt;
<a name="l00662"></a>00662     requested_ids(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>());
<a name="l00663"></a>00663 
<a name="l00664"></a>00664   <span class="comment">// We know how many objects live on each processor, so reseve() space for</span>
<a name="l00665"></a>00665   <span class="comment">// each.</span>
<a name="l00666"></a>00666   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p != <a class="code" href="classlibMesh_1_1MeshBase.php#a8b4ca46b2f69b29d670c737ba2b38600">libMesh::n_processors</a>(); ++p)
<a name="l00667"></a>00667     <span class="keywordflow">if</span> (p != <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>())
<a name="l00668"></a>00668       requested_ids[p].reserve(ghost_objects_from_proc[p]);
<a name="l00669"></a>00669 
<a name="l00670"></a>00670   end = objects.<a class="code" href="classlibMesh_1_1mapvector.php#a89fd9cbe464dc374f033283ecbb9d200">end</a>();
<a name="l00671"></a>00671   <span class="keywordflow">for</span> (it = objects.<a class="code" href="classlibMesh_1_1mapvector.php#a707b45f1d69a9ef9a214343b85d402da">begin</a>(); it != end; ++it)
<a name="l00672"></a>00672     {
<a name="l00673"></a>00673       T *obj = *it;
<a name="l00674"></a>00674       <span class="keywordflow">if</span> (obj-&gt;processor_id() == <a class="code" href="classlibMesh_1_1MeshBase.php#aa557872c33163622cc66645fc393c925">libMesh::processor_id</a>())
<a name="l00675"></a>00675         obj-&gt;set_id(next_id++);
<a name="l00676"></a>00676       <span class="keywordflow">else</span> <span class="keywordflow">if</span> (obj-&gt;processor_id() != <a class="code" href="classlibMesh_1_1DofObject.php#a46e3889aa741da5ebf483fe91fd1d431">DofObject::invalid_processor_id</a>)
<a name="l00677"></a>00677         requested_ids[obj-&gt;processor_id()].push_back(obj-&gt;id());
<a name="l00678"></a>00678     }
<a name="l00679"></a>00679 
<a name="l00680"></a>00680   <span class="comment">// Next set ghost object ids from other processors</span>
<a name="l00681"></a>00681   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() &gt; 1)
<a name="l00682"></a>00682     {
<a name="l00683"></a>00683       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=1; p != <a class="code" href="classlibMesh_1_1MeshBase.php#a8b4ca46b2f69b29d670c737ba2b38600">libMesh::n_processors</a>(); ++p)
<a name="l00684"></a>00684         {
<a name="l00685"></a>00685           <span class="comment">// Trade my requests with processor procup and procdown</span>
<a name="l00686"></a>00686           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> procup = (<a class="code" href="classlibMesh_1_1MeshBase.php#aa557872c33163622cc66645fc393c925">libMesh::processor_id</a>() + p) %
<a name="l00687"></a>00687                                  <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>();
<a name="l00688"></a>00688           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> procdown = (<a class="code" href="classlibMesh_1_1MeshBase.php#a8b4ca46b2f69b29d670c737ba2b38600">libMesh::n_processors</a>() +
<a name="l00689"></a>00689                                    <a class="code" href="classlibMesh_1_1MeshBase.php#aa557872c33163622cc66645fc393c925">libMesh::processor_id</a>() - p) %
<a name="l00690"></a>00690                                    <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>();
<a name="l00691"></a>00691           std::vector&lt;unsigned int&gt; request_to_fill;
<a name="l00692"></a>00692           <a class="code" href="namespacelibMesh_1_1Parallel.php#acfbfff4a15f9dc0b0abdfb081086dd3b">Parallel::send_receive</a>(procup, requested_ids[procup],
<a name="l00693"></a>00693                                  procdown, request_to_fill);
<a name="l00694"></a>00694 
<a name="l00695"></a>00695           <span class="comment">// Fill those requests</span>
<a name="l00696"></a>00696           std::vector&lt;unsigned int&gt; new_ids(request_to_fill.size());
<a name="l00697"></a>00697           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != request_to_fill.size(); ++i)
<a name="l00698"></a>00698             {
<a name="l00699"></a>00699               T *obj = objects[request_to_fill[i]];
<a name="l00700"></a>00700               libmesh_assert(obj);
<a name="l00701"></a>00701               libmesh_assert(obj-&gt;processor_id() == <a class="code" href="classlibMesh_1_1MeshBase.php#aa557872c33163622cc66645fc393c925">libMesh::processor_id</a>());
<a name="l00702"></a>00702               new_ids[i] = obj-&gt;id();
<a name="l00703"></a>00703               libmesh_assert(new_ids[i] &gt;=
<a name="l00704"></a>00704                      first_object_on_proc[<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>()]);
<a name="l00705"></a>00705               libmesh_assert(new_ids[i] &lt;
<a name="l00706"></a>00706                      first_object_on_proc[<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>()] +
<a name="l00707"></a>00707                      objects_on_proc[<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>()]);
<a name="l00708"></a>00708             }
<a name="l00709"></a>00709 
<a name="l00710"></a>00710           <span class="comment">// Trade back the results</span>
<a name="l00711"></a>00711           std::vector&lt;unsigned int&gt; filled_request;
<a name="l00712"></a>00712           <a class="code" href="namespacelibMesh_1_1Parallel.php#acfbfff4a15f9dc0b0abdfb081086dd3b">Parallel::send_receive</a>(procdown, new_ids,
<a name="l00713"></a>00713                                  procup, filled_request);
<a name="l00714"></a>00714 
<a name="l00715"></a>00715           <span class="comment">// And copy the id changes we&#39;ve now been informed of</span>
<a name="l00716"></a>00716           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != filled_request.size(); ++i)
<a name="l00717"></a>00717             {
<a name="l00718"></a>00718               T *obj = objects[requested_ids[procup][i]];
<a name="l00719"></a>00719               libmesh_assert (obj);
<a name="l00720"></a>00720               libmesh_assert (obj-&gt;processor_id() == procup);
<a name="l00721"></a>00721               libmesh_assert(filled_request[i] &gt;=
<a name="l00722"></a>00722                      first_object_on_proc[procup]);
<a name="l00723"></a>00723               libmesh_assert(filled_request[i] &lt;
<a name="l00724"></a>00724                      first_object_on_proc[procup] +
<a name="l00725"></a>00725                      objects_on_proc[procup]);
<a name="l00726"></a>00726               obj-&gt;set_id(filled_request[i]);
<a name="l00727"></a>00727             }
<a name="l00728"></a>00728         }
<a name="l00729"></a>00729     }
<a name="l00730"></a>00730 
<a name="l00731"></a>00731   <span class="comment">// Next set unpartitioned object ids</span>
<a name="l00732"></a>00732   next_id = 0;
<a name="l00733"></a>00733   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != <a class="code" href="classlibMesh_1_1MeshBase.php#a8b4ca46b2f69b29d670c737ba2b38600">libMesh::n_processors</a>(); ++i)
<a name="l00734"></a>00734     next_id += objects_on_proc[i];
<a name="l00735"></a>00735   <span class="keywordflow">for</span> (it = objects.<a class="code" href="classlibMesh_1_1mapvector.php#a707b45f1d69a9ef9a214343b85d402da">begin</a>(); it != end; ++it)
<a name="l00736"></a>00736     {
<a name="l00737"></a>00737       T *obj = *it;
<a name="l00738"></a>00738       <span class="keywordflow">if</span> (obj-&gt;processor_id() == <a class="code" href="classlibMesh_1_1DofObject.php#a46e3889aa741da5ebf483fe91fd1d431">DofObject::invalid_processor_id</a>)
<a name="l00739"></a>00739         obj-&gt;set_id(next_id++);
<a name="l00740"></a>00740     }
<a name="l00741"></a>00741 
<a name="l00742"></a>00742   <span class="comment">// Finally shuffle around objects so that container indices</span>
<a name="l00743"></a>00743   <span class="comment">// match ids</span>
<a name="l00744"></a>00744   end = objects.<a class="code" href="classlibMesh_1_1mapvector.php#a89fd9cbe464dc374f033283ecbb9d200">end</a>();
<a name="l00745"></a>00745   <span class="keywordflow">for</span> (it = objects.<a class="code" href="classlibMesh_1_1mapvector.php#a707b45f1d69a9ef9a214343b85d402da">begin</a>(); it != end;)
<a name="l00746"></a>00746     {
<a name="l00747"></a>00747       T *obj = *it;
<a name="l00748"></a>00748       <span class="keywordflow">if</span> (obj) <span class="comment">// don&#39;t try shuffling already-NULL entries</span>
<a name="l00749"></a>00749         {
<a name="l00750"></a>00750           T *next = objects[obj-&gt;id()];
<a name="l00751"></a>00751           <span class="comment">// If we have to move this object</span>
<a name="l00752"></a>00752           <span class="keywordflow">if</span> (next != obj)
<a name="l00753"></a>00753             {
<a name="l00754"></a>00754               <span class="comment">// NULL out its original position for now</span>
<a name="l00755"></a>00755               <span class="comment">// (our shuffling may put another object there shortly)</span>
<a name="l00756"></a>00756               *it = NULL;
<a name="l00757"></a>00757 
<a name="l00758"></a>00758               <span class="comment">// There may already be another object with this id that</span>
<a name="l00759"></a>00759               <span class="comment">// needs to be moved itself</span>
<a name="l00760"></a>00760               <span class="keywordflow">while</span> (next)
<a name="l00761"></a>00761                 {
<a name="l00762"></a>00762                   <span class="comment">// We shouldn&#39;t be trying to give two objects the</span>
<a name="l00763"></a>00763                   <span class="comment">// same id</span>
<a name="l00764"></a>00764                   libmesh_assert (next-&gt;id() != obj-&gt;id());
<a name="l00765"></a>00765                   objects[obj-&gt;id()] = obj;
<a name="l00766"></a>00766                   obj = next;
<a name="l00767"></a>00767                   next = objects[obj-&gt;id()];
<a name="l00768"></a>00768                 }
<a name="l00769"></a>00769               objects[obj-&gt;id()] = obj;
<a name="l00770"></a>00770             }
<a name="l00771"></a>00771         }
<a name="l00772"></a>00772       <span class="comment">// Remove any container entries that were left as NULL,</span>
<a name="l00773"></a>00773       <span class="comment">// being careful not to invalidate our iterator</span>
<a name="l00774"></a>00774       <span class="keywordflow">if</span> (!*it)
<a name="l00775"></a>00775         objects.<a class="code" href="classlibMesh_1_1mapvector.php#a80a02556416b62e3bb87f64a0e5c21cf">erase</a>(it++);
<a name="l00776"></a>00776       <span class="keywordflow">else</span>
<a name="l00777"></a>00777         ++it;
<a name="l00778"></a>00778     }
<a name="l00779"></a>00779 
<a name="l00780"></a>00780   <span class="keywordflow">return</span> first_free_id;
<a name="l00781"></a>00781 }
<a name="l00782"></a>00782 
<a name="l00783"></a>00783 
<a name="l00784"></a><a class="code" href="classlibMesh_1_1ParallelMesh.php#a453795c7436d377ed4fc99b6905c363a">00784</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ParallelMesh.php#a453795c7436d377ed4fc99b6905c363a">ParallelMesh::renumber_nodes_and_elements</a> ()
<a name="l00785"></a>00785 {
<a name="l00786"></a>00786   START_LOG(<span class="stringliteral">&quot;renumber_nodes_and_elements()&quot;</span>, <span class="stringliteral">&quot;ParallelMesh&quot;</span>);
<a name="l00787"></a>00787 
<a name="l00788"></a>00788 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00789"></a>00789 <span class="preprocessor"></span><span class="comment">// Make sure our ids and flags are consistent</span>
<a name="l00790"></a>00790   this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#a71de7cc0384ce24b982c49b2276478b3">libmesh_assert_valid_parallel_ids</a>();
<a name="l00791"></a>00791   this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#a20683143bfb9f9a2d842f2aeb93835dd">libmesh_assert_valid_parallel_flags</a>();
<a name="l00792"></a>00792 <span class="preprocessor">#endif</span>
<a name="l00793"></a>00793 <span class="preprocessor"></span>
<a name="l00794"></a>00794   std::set&lt;unsigned int&gt; used_nodes;
<a name="l00795"></a>00795 
<a name="l00796"></a>00796   <span class="comment">// flag the nodes we need</span>
<a name="l00797"></a>00797   {      
<a name="l00798"></a>00798     <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">element_iterator</a>  it = <a class="code" href="classlibMesh_1_1ParallelMesh.php#a9efee9d54424295764266297f7315c88">elements_begin</a>();
<a name="l00799"></a>00799     <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">element_iterator</a> end = <a class="code" href="classlibMesh_1_1ParallelMesh.php#ae15fa4b5b62f914b11e6abcaff8f568d">elements_end</a>();
<a name="l00800"></a>00800 
<a name="l00801"></a>00801     <span class="keywordflow">for</span> (; it != end; ++it)
<a name="l00802"></a>00802       {
<a name="l00803"></a>00803         <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *<a class="code" href="classlibMesh_1_1ParallelMesh.php#a5b15e05a7d948285783576569d00d3e3">elem</a> = *it;
<a name="l00804"></a>00804 
<a name="l00805"></a>00805         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n != elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>(); ++n)
<a name="l00806"></a>00806           used_nodes.insert(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(n));
<a name="l00807"></a>00807       }
<a name="l00808"></a>00808   }
<a name="l00809"></a>00809 
<a name="l00810"></a>00810   <span class="comment">// Nodes not connected to any local elements are deleted</span>
<a name="l00811"></a>00811   {
<a name="l00812"></a>00812     <a class="code" href="classlibMesh_1_1ParallelMesh.php#a97fd0ae8092ccb5070d2baadfdb24b91">node_iterator_imp</a>  it = <a class="code" href="classlibMesh_1_1ParallelMesh.php#a93dcd617abf4505ab8628472eb1cce90">_nodes</a>.<a class="code" href="classlibMesh_1_1mapvector.php#a707b45f1d69a9ef9a214343b85d402da">begin</a>();
<a name="l00813"></a>00813     <a class="code" href="classlibMesh_1_1ParallelMesh.php#a97fd0ae8092ccb5070d2baadfdb24b91">node_iterator_imp</a> end = <a class="code" href="classlibMesh_1_1ParallelMesh.php#a93dcd617abf4505ab8628472eb1cce90">_nodes</a>.<a class="code" href="classlibMesh_1_1mapvector.php#a89fd9cbe464dc374f033283ecbb9d200">end</a>();
<a name="l00814"></a>00814 
<a name="l00815"></a>00815     <span class="keywordflow">for</span> (; it != end;)
<a name="l00816"></a>00816       {
<a name="l00817"></a>00817         <a class="code" href="classlibMesh_1_1Node.php">Node</a> *<a class="code" href="classlibMesh_1_1ParallelMesh.php#a454136f0ecbe817adbec8ec370a1540a">node</a> = *it;
<a name="l00818"></a>00818         <span class="keywordflow">if</span> (!used_nodes.count(node-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()))
<a name="l00819"></a>00819           {
<a name="l00820"></a>00820             <span class="comment">// remove any boundary information associated with</span>
<a name="l00821"></a>00821             <span class="comment">// this node</span>
<a name="l00822"></a>00822             this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;remove (node);
<a name="l00823"></a>00823 
<a name="l00824"></a>00824             <span class="comment">// delete the node</span>
<a name="l00825"></a>00825             <span class="keyword">delete</span> <a class="code" href="classlibMesh_1_1ParallelMesh.php#a454136f0ecbe817adbec8ec370a1540a">node</a>;
<a name="l00826"></a>00826 
<a name="l00827"></a>00827             <a class="code" href="classlibMesh_1_1ParallelMesh.php#a93dcd617abf4505ab8628472eb1cce90">_nodes</a>.<a class="code" href="classlibMesh_1_1mapvector.php#a80a02556416b62e3bb87f64a0e5c21cf">erase</a>(it++);
<a name="l00828"></a>00828           }
<a name="l00829"></a>00829         <span class="keywordflow">else</span>
<a name="l00830"></a>00830           ++it;
<a name="l00831"></a>00831       }
<a name="l00832"></a>00832   }
<a name="l00833"></a>00833 
<a name="l00834"></a>00834   <span class="comment">// Finally renumber all the elements</span>
<a name="l00835"></a>00835   <a class="code" href="classlibMesh_1_1ParallelMesh.php#ae3bbc433435383bcde09bd28aa13818e">_n_elem</a> = this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#a17d4240194816767b705e606062c720f">renumber_dof_objects</a> (this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#a0ccc1060937df3ec67ded54440e6590e">_elements</a>);
<a name="l00836"></a>00836   <a class="code" href="classlibMesh_1_1ParallelMesh.php#a2ff7a43f89e1ceb7bc3fc205483151be">_max_elem_id</a> = <a class="code" href="classlibMesh_1_1ParallelMesh.php#ae3bbc433435383bcde09bd28aa13818e">_n_elem</a>;
<a name="l00837"></a>00837   <a class="code" href="classlibMesh_1_1ParallelMesh.php#a576a8dc7ced081673c7ab8663752d591">_next_free_local_elem_id</a> = <a class="code" href="classlibMesh_1_1ParallelMesh.php#ae3bbc433435383bcde09bd28aa13818e">_n_elem</a>;
<a name="l00838"></a>00838 
<a name="l00839"></a>00839   <span class="comment">// and all the remaining nodes</span>
<a name="l00840"></a>00840   <a class="code" href="classlibMesh_1_1ParallelMesh.php#af70058d54e5d727f87c524dbc0013f46">_n_nodes</a> = this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#a17d4240194816767b705e606062c720f">renumber_dof_objects</a> (this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#a93dcd617abf4505ab8628472eb1cce90">_nodes</a>);
<a name="l00841"></a>00841   <a class="code" href="classlibMesh_1_1ParallelMesh.php#a4ade8de51594885d94713fe1de9efa01">_max_node_id</a> = <a class="code" href="classlibMesh_1_1ParallelMesh.php#af70058d54e5d727f87c524dbc0013f46">_n_nodes</a>;
<a name="l00842"></a>00842   <a class="code" href="classlibMesh_1_1ParallelMesh.php#ac1c91b6ea0a74ee9f5a7aa21a0f77332">_next_free_local_node_id</a> = <a class="code" href="classlibMesh_1_1ParallelMesh.php#af70058d54e5d727f87c524dbc0013f46">_n_nodes</a>;
<a name="l00843"></a>00843 
<a name="l00844"></a>00844   <span class="comment">// And figure out what IDs we should use when adding new nodes and</span>
<a name="l00845"></a>00845   <span class="comment">// new elements</span>
<a name="l00846"></a>00846   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> cycle = <a class="code" href="classlibMesh_1_1MeshBase.php#a8b4ca46b2f69b29d670c737ba2b38600">libMesh::n_processors</a>()+1;
<a name="l00847"></a>00847   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> offset = <a class="code" href="classlibMesh_1_1ParallelMesh.php#a576a8dc7ced081673c7ab8663752d591">_next_free_local_elem_id</a> % cycle;
<a name="l00848"></a>00848   <span class="keywordflow">if</span> (offset)
<a name="l00849"></a>00849     <a class="code" href="classlibMesh_1_1ParallelMesh.php#a576a8dc7ced081673c7ab8663752d591">_next_free_local_elem_id</a> += cycle - offset;
<a name="l00850"></a>00850   <a class="code" href="classlibMesh_1_1ParallelMesh.php#af2cf69eaed1ebdd13c4ede5429158649">_next_free_unpartitioned_elem_id</a> = <a class="code" href="classlibMesh_1_1ParallelMesh.php#a576a8dc7ced081673c7ab8663752d591">_next_free_local_elem_id</a> +
<a name="l00851"></a>00851                                      <a class="code" href="classlibMesh_1_1MeshBase.php#a8b4ca46b2f69b29d670c737ba2b38600">libMesh::n_processors</a>();
<a name="l00852"></a>00852   <a class="code" href="classlibMesh_1_1ParallelMesh.php#a576a8dc7ced081673c7ab8663752d591">_next_free_local_elem_id</a> += <a class="code" href="classlibMesh_1_1MeshBase.php#aa557872c33163622cc66645fc393c925">libMesh::processor_id</a>();
<a name="l00853"></a>00853 
<a name="l00854"></a>00854   offset = <a class="code" href="classlibMesh_1_1ParallelMesh.php#ac1c91b6ea0a74ee9f5a7aa21a0f77332">_next_free_local_node_id</a> % cycle;
<a name="l00855"></a>00855   <span class="keywordflow">if</span> (offset)
<a name="l00856"></a>00856     <a class="code" href="classlibMesh_1_1ParallelMesh.php#ac1c91b6ea0a74ee9f5a7aa21a0f77332">_next_free_local_node_id</a> += cycle - offset;
<a name="l00857"></a>00857   <a class="code" href="classlibMesh_1_1ParallelMesh.php#aa84f67d0ac65d3e1cdd7afdc6f292672">_next_free_unpartitioned_node_id</a> = <a class="code" href="classlibMesh_1_1ParallelMesh.php#ac1c91b6ea0a74ee9f5a7aa21a0f77332">_next_free_local_node_id</a> +
<a name="l00858"></a>00858                                      <a class="code" href="classlibMesh_1_1MeshBase.php#a8b4ca46b2f69b29d670c737ba2b38600">libMesh::n_processors</a>();
<a name="l00859"></a>00859   <a class="code" href="classlibMesh_1_1ParallelMesh.php#ac1c91b6ea0a74ee9f5a7aa21a0f77332">_next_free_local_node_id</a> += <a class="code" href="classlibMesh_1_1MeshBase.php#aa557872c33163622cc66645fc393c925">libMesh::processor_id</a>();
<a name="l00860"></a>00860 
<a name="l00861"></a>00861 <span class="comment">// Make sure our caches are up to date and our</span>
<a name="l00862"></a>00862 <span class="comment">// DofObjects are well packed</span>
<a name="l00863"></a>00863 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00864"></a>00864 <span class="preprocessor"></span>  libmesh_assert(this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#afa159384231957ca748e1c3c0ea599a4">n_nodes</a>() == this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#a9639396ca8d96b4d4bff36f22fe05370">parallel_n_nodes</a>());
<a name="l00865"></a>00865   libmesh_assert(this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#a54f3c1d99f06946b368fea0f40111780">n_elem</a>() == this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#a81c366a6f0f566d9966f2bf4f4bd4207">parallel_n_elem</a>());
<a name="l00866"></a>00866   libmesh_assert(this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#ae9bacbf51c7089a8aada184b3ac01f2a">max_node_id</a>() == this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#ab412740205d3fa7bc4580f105103255f">parallel_max_node_id</a>());
<a name="l00867"></a>00867   libmesh_assert(this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#ac278075751b4e7501c9293dd24613ff5">max_elem_id</a>() == this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#aed4cdeb0ddd80a2621d35fa3e61a4d0c">parallel_max_elem_id</a>());
<a name="l00868"></a>00868   libmesh_assert(this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#afa159384231957ca748e1c3c0ea599a4">n_nodes</a>() == this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#ae9bacbf51c7089a8aada184b3ac01f2a">max_node_id</a>());
<a name="l00869"></a>00869   libmesh_assert(this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#a54f3c1d99f06946b368fea0f40111780">n_elem</a>() == this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#ac278075751b4e7501c9293dd24613ff5">max_elem_id</a>());
<a name="l00870"></a>00870 
<a name="l00871"></a>00871 <span class="comment">// Make sure our ids and flags are consistent</span>
<a name="l00872"></a>00872   this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#a71de7cc0384ce24b982c49b2276478b3">libmesh_assert_valid_parallel_ids</a>();
<a name="l00873"></a>00873   this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#a20683143bfb9f9a2d842f2aeb93835dd">libmesh_assert_valid_parallel_flags</a>();
<a name="l00874"></a>00874 
<a name="l00875"></a>00875 <span class="comment">// And make sure we&#39;ve made our numbering monotonic</span>
<a name="l00876"></a>00876   <a class="code" href="namespacelibMesh_1_1MeshTools.php#a1968ff1c8ed3fdc7f1c23e6b8ec322f8">MeshTools::libmesh_assert_valid_elem_ids</a>(*<span class="keyword">this</span>);
<a name="l00877"></a>00877 <span class="preprocessor">#endif</span>
<a name="l00878"></a>00878 <span class="preprocessor"></span>
<a name="l00879"></a>00879   STOP_LOG(<span class="stringliteral">&quot;renumber_nodes_and_elements()&quot;</span>, <span class="stringliteral">&quot;ParallelMesh&quot;</span>);
<a name="l00880"></a>00880 }
<a name="l00881"></a>00881 
<a name="l00882"></a>00882 
<a name="l00883"></a>00883 
<a name="l00884"></a><a class="code" href="classlibMesh_1_1ParallelMesh.php#a0eda57eedc9bda3d305281fc7640aa09">00884</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ParallelMesh.php#a0eda57eedc9bda3d305281fc7640aa09">ParallelMesh::n_active_elem</a> ()<span class="keyword"> const</span>
<a name="l00885"></a>00885 <span class="keyword"></span>{
<a name="l00886"></a>00886   parallel_only();
<a name="l00887"></a>00887 
<a name="l00888"></a>00888   <span class="comment">// Get local active elements first</span>
<a name="l00889"></a>00889   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> active_elements =
<a name="l00890"></a>00890     <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(std::distance (this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#a8523aa7490f182df9ed52422b62ce1b8">active_local_elements_begin</a>(),
<a name="l00891"></a>00891                                              this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#ad64cb66d3478d53dff68cb1801e7f675">active_local_elements_end</a>()));
<a name="l00892"></a>00892   <a class="code" href="namespacelibMesh_1_1Parallel.php#a32ab26117222089e6540e66b05c06b1b">Parallel::sum</a>(active_elements);
<a name="l00893"></a>00893 
<a name="l00894"></a>00894   <span class="comment">// Then add unpartitioned active elements, which should exist on</span>
<a name="l00895"></a>00895   <span class="comment">// every processor</span>
<a name="l00896"></a>00896   active_elements +=
<a name="l00897"></a>00897     <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(std::distance
<a name="l00898"></a>00898       (this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#aa84dd911088eb2db83dece207ae50878">active_pid_elements_begin</a>(<a class="code" href="classlibMesh_1_1DofObject.php#a46e3889aa741da5ebf483fe91fd1d431">DofObject::invalid_processor_id</a>),
<a name="l00899"></a>00899        this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#a76bebba197955acced2e10deba2052f6">active_pid_elements_end</a>(<a class="code" href="classlibMesh_1_1DofObject.php#a46e3889aa741da5ebf483fe91fd1d431">DofObject::invalid_processor_id</a>)));
<a name="l00900"></a>00900   <span class="keywordflow">return</span> active_elements;
<a name="l00901"></a>00901 }
<a name="l00902"></a>00902 
<a name="l00903"></a>00903 
<a name="l00904"></a>00904 
<a name="l00905"></a><a class="code" href="classlibMesh_1_1ParallelMesh.php#a01627aec710b8452f66d3610bc461a8b">00905</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ParallelMesh.php#a01627aec710b8452f66d3610bc461a8b">ParallelMesh::delete_remote_elements</a>()
<a name="l00906"></a>00906 {
<a name="l00907"></a>00907 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00908"></a>00908 <span class="preprocessor"></span><span class="comment">// Make sure our neighbor links are all fine</span>
<a name="l00909"></a>00909   <a class="code" href="namespacelibMesh_1_1MeshTools.php#a943be6a54f82a23518dc6fc11d9bb527">MeshTools::libmesh_assert_valid_neighbors</a>(*<span class="keyword">this</span>);
<a name="l00910"></a>00910 <span class="preprocessor">#endif</span>
<a name="l00911"></a>00911 <span class="preprocessor"></span>
<a name="l00912"></a>00912   <a class="code" href="classlibMesh_1_1ParallelMesh.php#aa5ec1fff0c588a69e81a84a16120efd1">_is_serial</a> = <span class="keyword">false</span>;
<a name="l00913"></a>00913   <a class="code" href="classlibMesh_1_1MeshCommunication.php">MeshCommunication</a>().<a class="code" href="classlibMesh_1_1MeshCommunication.php#ab20e88ddffd15f85ef82065501259780">delete_remote_elements</a>(*<span class="keyword">this</span>);
<a name="l00914"></a>00914 
<a name="l00915"></a>00915 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00916"></a>00916 <span class="preprocessor"></span><span class="comment">// Make sure our caches are up to date and our</span>
<a name="l00917"></a>00917 <span class="comment">// DofObjects are well packed</span>
<a name="l00918"></a>00918   libmesh_assert(this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#afa159384231957ca748e1c3c0ea599a4">n_nodes</a>() == this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#a9639396ca8d96b4d4bff36f22fe05370">parallel_n_nodes</a>());
<a name="l00919"></a>00919   libmesh_assert(this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#a54f3c1d99f06946b368fea0f40111780">n_elem</a>() == this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#a81c366a6f0f566d9966f2bf4f4bd4207">parallel_n_elem</a>());
<a name="l00920"></a>00920   libmesh_assert(this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#ae9bacbf51c7089a8aada184b3ac01f2a">max_node_id</a>() == this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#ab412740205d3fa7bc4580f105103255f">parallel_max_node_id</a>());
<a name="l00921"></a>00921   libmesh_assert(this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#ac278075751b4e7501c9293dd24613ff5">max_elem_id</a>() == this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#aed4cdeb0ddd80a2621d35fa3e61a4d0c">parallel_max_elem_id</a>());
<a name="l00922"></a>00922   libmesh_assert(this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#afa159384231957ca748e1c3c0ea599a4">n_nodes</a>() == this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#ae9bacbf51c7089a8aada184b3ac01f2a">max_node_id</a>());
<a name="l00923"></a>00923   libmesh_assert(this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#a54f3c1d99f06946b368fea0f40111780">n_elem</a>() == this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#ac278075751b4e7501c9293dd24613ff5">max_elem_id</a>());
<a name="l00924"></a>00924 
<a name="l00925"></a>00925 <span class="comment">// Make sure our neighbor links are all fine</span>
<a name="l00926"></a>00926   <a class="code" href="namespacelibMesh_1_1MeshTools.php#a943be6a54f82a23518dc6fc11d9bb527">MeshTools::libmesh_assert_valid_neighbors</a>(*<span class="keyword">this</span>);
<a name="l00927"></a>00927 
<a name="l00928"></a>00928 <span class="comment">// Make sure our ids and flags are consistent</span>
<a name="l00929"></a>00929   this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#a71de7cc0384ce24b982c49b2276478b3">libmesh_assert_valid_parallel_ids</a>();
<a name="l00930"></a>00930   this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#a20683143bfb9f9a2d842f2aeb93835dd">libmesh_assert_valid_parallel_flags</a>();
<a name="l00931"></a>00931 
<a name="l00932"></a>00932 <span class="comment">// And make sure our numbering is still monotonic</span>
<a name="l00933"></a>00933   <a class="code" href="namespacelibMesh_1_1MeshTools.php#a1968ff1c8ed3fdc7f1c23e6b8ec322f8">MeshTools::libmesh_assert_valid_elem_ids</a>(*<span class="keyword">this</span>);
<a name="l00934"></a>00934 <span class="preprocessor">#endif</span>
<a name="l00935"></a>00935 <span class="preprocessor"></span>}
<a name="l00936"></a>00936 
<a name="l00937"></a>00937 
<a name="l00938"></a>00938 
<a name="l00939"></a><a class="code" href="classlibMesh_1_1ParallelMesh.php#ac88199c0b21d0e97e7f74c005fb24c46">00939</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ParallelMesh.php#ac88199c0b21d0e97e7f74c005fb24c46">ParallelMesh::allgather</a>()
<a name="l00940"></a>00940 {
<a name="l00941"></a>00941   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1ParallelMesh.php#aa5ec1fff0c588a69e81a84a16120efd1">_is_serial</a>)
<a name="l00942"></a>00942     <span class="keywordflow">return</span>;
<a name="l00943"></a>00943   <a class="code" href="classlibMesh_1_1ParallelMesh.php#aa5ec1fff0c588a69e81a84a16120efd1">_is_serial</a> = <span class="keyword">true</span>;
<a name="l00944"></a>00944   <a class="code" href="classlibMesh_1_1MeshCommunication.php">MeshCommunication</a>().<a class="code" href="classlibMesh_1_1MeshCommunication.php#a69151d8425723f28381fea5fdd627bdb">allgather</a>(*<span class="keyword">this</span>);
<a name="l00945"></a>00945 
<a name="l00946"></a>00946 <span class="comment">// Make sure our caches are up to date and our</span>
<a name="l00947"></a>00947 <span class="comment">// DofObjects are well packed</span>
<a name="l00948"></a>00948 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00949"></a>00949 <span class="preprocessor"></span>  libmesh_assert(this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#afa159384231957ca748e1c3c0ea599a4">n_nodes</a>() == this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#a9639396ca8d96b4d4bff36f22fe05370">parallel_n_nodes</a>());
<a name="l00950"></a>00950   libmesh_assert(this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#a54f3c1d99f06946b368fea0f40111780">n_elem</a>() == this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#a81c366a6f0f566d9966f2bf4f4bd4207">parallel_n_elem</a>());
<a name="l00951"></a>00951   libmesh_assert(this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#ae9bacbf51c7089a8aada184b3ac01f2a">max_node_id</a>() == this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#ab412740205d3fa7bc4580f105103255f">parallel_max_node_id</a>());
<a name="l00952"></a>00952   libmesh_assert(this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#ac278075751b4e7501c9293dd24613ff5">max_elem_id</a>() == this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#aed4cdeb0ddd80a2621d35fa3e61a4d0c">parallel_max_elem_id</a>());
<a name="l00953"></a>00953   libmesh_assert(this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#afa159384231957ca748e1c3c0ea599a4">n_nodes</a>() == this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#ae9bacbf51c7089a8aada184b3ac01f2a">max_node_id</a>());
<a name="l00954"></a>00954   libmesh_assert(this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#a54f3c1d99f06946b368fea0f40111780">n_elem</a>() == this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#ac278075751b4e7501c9293dd24613ff5">max_elem_id</a>());
<a name="l00955"></a>00955 
<a name="l00956"></a>00956 <span class="comment">// Make sure our neighbor links are all fine</span>
<a name="l00957"></a>00957   <a class="code" href="namespacelibMesh_1_1MeshTools.php#a943be6a54f82a23518dc6fc11d9bb527">MeshTools::libmesh_assert_valid_neighbors</a>(*<span class="keyword">this</span>);
<a name="l00958"></a>00958 
<a name="l00959"></a>00959 <span class="comment">// Make sure our ids and flags are consistent</span>
<a name="l00960"></a>00960   this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#a71de7cc0384ce24b982c49b2276478b3">libmesh_assert_valid_parallel_ids</a>();
<a name="l00961"></a>00961   this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#a20683143bfb9f9a2d842f2aeb93835dd">libmesh_assert_valid_parallel_flags</a>();
<a name="l00962"></a>00962 <span class="preprocessor">#endif</span>
<a name="l00963"></a>00963 <span class="preprocessor"></span>}
<a name="l00964"></a>00964 
<a name="l00965"></a>00965 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
