<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_eaf30c8ea092d33f79a04353c3899c3f.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_61d9f870c6c0483699f07e82d4566fda.php">utils</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">parameters.h</div>  </div>
</div>
<div class="contents">
<a href="parameters_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id$</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __parameters_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __parameters_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;typeinfo&gt;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &lt;string&gt;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &lt;map&gt;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="comment">// Local includes</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="reference__counted__object_8h.php">reference_counted_object.h</a>&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="keyword">namespace </span>libMesh
<a name="l00035"></a>00035 {
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 
<a name="l00050"></a>00050 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00051"></a>00051 <span class="comment">// Parameters class definition</span>
<a name="l00052"></a><a class="code" href="classlibMesh_1_1Parameters.php">00052</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1Parameters.php">Parameters</a> 
<a name="l00053"></a>00053 {
<a name="l00054"></a>00054 <span class="keyword">public</span>:
<a name="l00055"></a>00055 
<a name="l00059"></a><a class="code" href="classlibMesh_1_1Parameters.php#ac5734e6bb5ea29df547d7bad8f38ace4">00059</a>   <a class="code" href="classlibMesh_1_1Parameters.php#ac5734e6bb5ea29df547d7bad8f38ace4">Parameters</a> () {};
<a name="l00060"></a>00060 
<a name="l00064"></a>00064   <a class="code" href="classlibMesh_1_1Parameters.php#ac5734e6bb5ea29df547d7bad8f38ace4">Parameters</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parameters.php">Parameters</a>&amp;);
<a name="l00065"></a>00065 
<a name="l00069"></a>00069   <a class="code" href="classlibMesh_1_1Parameters.php#a2522a703f232adaa680d53973fdd28a0">~Parameters</a> ();
<a name="l00070"></a>00070 
<a name="l00075"></a>00075   <a class="code" href="classlibMesh_1_1Parameters.php">Parameters</a>&amp; <a class="code" href="classlibMesh_1_1Parameters.php#a7fd5e9f1cfb18b4a7c44bd27fc01e237">operator= </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parameters.php">Parameters</a>&amp; source);
<a name="l00076"></a>00076 
<a name="l00082"></a>00082   <a class="code" href="classlibMesh_1_1Parameters.php">Parameters</a>&amp; <a class="code" href="classlibMesh_1_1Parameters.php#a922219e963753e3efb713308bcd5717c">operator+= </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parameters.php">Parameters</a>&amp; source);
<a name="l00083"></a>00083 
<a name="l00088"></a>00088   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00089"></a>00089   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Parameters.php#a6ced71ca7796d8109dd9b62bd0e1139b">have_parameter</a> (<span class="keyword">const</span> std::string&amp;) <span class="keyword">const</span>;
<a name="l00090"></a>00090 
<a name="l00095"></a>00095   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00096"></a>00096   <span class="keyword">const</span> T&amp; <span class="keyword">get</span> (<span class="keyword">const</span> std::string&amp;) <span class="keyword">const</span>;
<a name="l00097"></a>00097 
<a name="l00104"></a>00104   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00105"></a>00105   T&amp; <span class="keyword">set</span> (<span class="keyword">const</span> std::string&amp;);
<a name="l00106"></a>00106 
<a name="l00110"></a>00110   <span class="keywordtype">void</span> <span class="keyword">remove</span> (<span class="keyword">const</span> std::string&amp;);
<a name="l00111"></a>00111 
<a name="l00115"></a><a class="code" href="classlibMesh_1_1Parameters.php#aace39d06a06ed2ebc294662327318283">00115</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Parameters.php#aace39d06a06ed2ebc294662327318283">n_parameters</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Parameters.php#a78246629ee5c1e9afffd9ca55a75939e">_values</a>.size(); }
<a name="l00116"></a>00116 
<a name="l00120"></a>00120   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00121"></a>00121   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Parameters.php#aace39d06a06ed2ebc294662327318283">n_parameters</a> () <span class="keyword">const</span>;
<a name="l00122"></a>00122   
<a name="l00126"></a>00126   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Parameters.php#a64b2d5b2367f03a30e7c37780b8c5047">clear</a> ();
<a name="l00127"></a>00127 
<a name="l00131"></a>00131   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Parameters.php#a69bdf0a000780829986785893a3b5793">print</a> (std::ostream&amp; os=<a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a>) <span class="keyword">const</span>;
<a name="l00132"></a>00132   
<a name="l00133"></a>00133 <span class="keyword">private</span>:
<a name="l00134"></a>00134 
<a name="l00138"></a><a class="code" href="classlibMesh_1_1Parameters_1_1Value.php">00138</a>   <span class="keyword">class </span><a class="code" href="classlibMesh_1_1Parameters_1_1Value.php">Value</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1ReferenceCountedObject.php">ReferenceCountedObject</a>&lt;Value&gt;
<a name="l00139"></a>00139   {
<a name="l00140"></a>00140   <span class="keyword">public</span>:
<a name="l00141"></a>00141 
<a name="l00145"></a><a class="code" href="classlibMesh_1_1Parameters_1_1Value.php#aaf881ecdec719d351426dbb3e4062b54">00145</a>     <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1Parameters_1_1Value.php#aaf881ecdec719d351426dbb3e4062b54">~Value</a>() {};
<a name="l00146"></a>00146 
<a name="l00151"></a>00151     <span class="keyword">virtual</span> std::string <a class="code" href="classlibMesh_1_1Parameters_1_1Value.php#a5e65a2be838079cea72a07c93d64bfb9">type</a> () <span class="keyword">const</span> = 0;
<a name="l00152"></a>00152 
<a name="l00157"></a>00157     <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Parameters_1_1Value.php#a864a92efcc427f702c0d2177841cee6a">print</a>(std::ostream&amp;) <span class="keyword">const</span> = 0;
<a name="l00158"></a>00158 
<a name="l00163"></a>00163     <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1Parameters_1_1Value.php">Value</a>* <a class="code" href="classlibMesh_1_1Parameters_1_1Value.php#afb343c1f7b89f8bddf338367112b772a">clone</a> () <span class="keyword">const</span> = 0;
<a name="l00164"></a>00164   };
<a name="l00165"></a>00165 
<a name="l00166"></a>00166 <span class="keyword">public</span>:
<a name="l00167"></a>00167 
<a name="l00172"></a>00172   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00173"></a><a class="code" href="classlibMesh_1_1Parameters_1_1Parameter.php">00173</a>   <span class="keyword">class </span><a class="code" href="classlibMesh_1_1Parameters_1_1Parameter.php">Parameter</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1Parameters_1_1Value.php">Value</a>
<a name="l00174"></a>00174   {
<a name="l00175"></a>00175   <span class="keyword">public</span>:
<a name="l00176"></a>00176 
<a name="l00180"></a><a class="code" href="classlibMesh_1_1Parameters_1_1Parameter.php#a15f8017b87ace12f2c94ba9d02d962a2">00180</a>     <span class="keyword">const</span> T&amp; <span class="keyword">get</span> () <span class="keyword">const</span> { <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Parameters_1_1Parameter.php#a726b5527efc3fd02f9fbda60142597b3">_value</a>; }
<a name="l00181"></a>00181     
<a name="l00185"></a><a class="code" href="classlibMesh_1_1Parameters_1_1Parameter.php#a8e620889e68002586faa0215bc73bea1">00185</a>     T&amp; <span class="keyword">set</span> () { <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Parameters_1_1Parameter.php#a726b5527efc3fd02f9fbda60142597b3">_value</a>; }
<a name="l00186"></a>00186 
<a name="l00190"></a>00190     <span class="keyword">virtual</span> std::string <a class="code" href="classlibMesh_1_1Parameters_1_1Parameter.php#a0b2494af19666ad6259cc18101f546a8">type</a> () <span class="keyword">const</span>;
<a name="l00191"></a>00191 
<a name="l00195"></a>00195     <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Parameters_1_1Parameter.php#abda0475dd556eac94864edadfad99817">print</a>(std::ostream&amp;) <span class="keyword">const</span>;
<a name="l00196"></a>00196 
<a name="l00200"></a>00200     <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1Parameters_1_1Value.php">Value</a>* <a class="code" href="classlibMesh_1_1Parameters_1_1Parameter.php#a461ad4db93c2eeb21991d55897492c83">clone</a> () <span class="keyword">const</span>; 
<a name="l00201"></a>00201     
<a name="l00202"></a>00202   <span class="keyword">private</span>:
<a name="l00203"></a>00203 
<a name="l00207"></a><a class="code" href="classlibMesh_1_1Parameters_1_1Parameter.php#a726b5527efc3fd02f9fbda60142597b3">00207</a>     T <a class="code" href="classlibMesh_1_1Parameters_1_1Parameter.php#a726b5527efc3fd02f9fbda60142597b3">_value</a>;
<a name="l00208"></a>00208   };
<a name="l00209"></a>00209 
<a name="l00213"></a><a class="code" href="classlibMesh_1_1Parameters.php#a27190068c41887096869f438ce1fef70">00213</a>   <span class="keyword">typedef</span> std::map&lt;std::string, Value*&gt;::iterator <a class="code" href="classlibMesh_1_1Parameters.php#a27190068c41887096869f438ce1fef70">iterator</a>;
<a name="l00214"></a>00214 
<a name="l00218"></a><a class="code" href="classlibMesh_1_1Parameters.php#a3d1ecf1cfcb95d326dd16172edf63f56">00218</a>   <span class="keyword">typedef</span> std::map&lt;std::string, Value*&gt;::const_iterator <a class="code" href="classlibMesh_1_1Parameters.php#a3d1ecf1cfcb95d326dd16172edf63f56">const_iterator</a>;
<a name="l00219"></a>00219 
<a name="l00223"></a>00223   <a class="code" href="classlibMesh_1_1Parameters.php#a27190068c41887096869f438ce1fef70">iterator</a> <a class="code" href="classlibMesh_1_1Parameters.php#a4a8506e50a4d10f8dfe563de87c37d80">begin</a>();
<a name="l00224"></a>00224 
<a name="l00228"></a>00228   <a class="code" href="classlibMesh_1_1Parameters.php#a3d1ecf1cfcb95d326dd16172edf63f56">const_iterator</a> <a class="code" href="classlibMesh_1_1Parameters.php#a4a8506e50a4d10f8dfe563de87c37d80">begin</a>() <span class="keyword">const</span>;
<a name="l00229"></a>00229 
<a name="l00233"></a>00233   <a class="code" href="classlibMesh_1_1Parameters.php#a27190068c41887096869f438ce1fef70">iterator</a> <a class="code" href="classlibMesh_1_1Parameters.php#a77447a8e22c51365a66d509a9ff5e6c3">end</a>();
<a name="l00234"></a>00234 
<a name="l00238"></a>00238   <a class="code" href="classlibMesh_1_1Parameters.php#a3d1ecf1cfcb95d326dd16172edf63f56">const_iterator</a> <a class="code" href="classlibMesh_1_1Parameters.php#a77447a8e22c51365a66d509a9ff5e6c3">end</a>() <span class="keyword">const</span>;
<a name="l00239"></a>00239 
<a name="l00240"></a>00240 <span class="keyword">private</span>:
<a name="l00241"></a>00241 
<a name="l00245"></a><a class="code" href="classlibMesh_1_1Parameters.php#a78246629ee5c1e9afffd9ca55a75939e">00245</a>   std::map&lt;std::string, Value*&gt; <a class="code" href="classlibMesh_1_1Parameters.php#a78246629ee5c1e9afffd9ca55a75939e">_values</a>;
<a name="l00246"></a>00246 
<a name="l00247"></a>00247 };
<a name="l00248"></a>00248 
<a name="l00249"></a>00249 
<a name="l00250"></a>00250 
<a name="l00251"></a>00251 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00252"></a>00252 <span class="comment">// Parameters::Parameter&lt;&gt; class inline methods</span>
<a name="l00253"></a>00253 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00254"></a>00254 <span class="keyword">inline</span>
<a name="l00255"></a><a class="code" href="classlibMesh_1_1Parameters_1_1Parameter.php#a0b2494af19666ad6259cc18101f546a8">00255</a> std::string <a class="code" href="classlibMesh_1_1Parameters_1_1Parameter.php#a0b2494af19666ad6259cc18101f546a8">Parameters::Parameter&lt;T&gt;::type</a> ()<span class="keyword"> const</span>
<a name="l00256"></a>00256 <span class="keyword"></span>{
<a name="l00257"></a>00257   <span class="keywordflow">return</span> <span class="keyword">typeid</span>(T).<a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>();
<a name="l00258"></a>00258 }
<a name="l00259"></a>00259 
<a name="l00260"></a>00260 
<a name="l00261"></a>00261 
<a name="l00262"></a>00262 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00263"></a>00263 <span class="keyword">inline</span>
<a name="l00264"></a><a class="code" href="classlibMesh_1_1Parameters_1_1Parameter.php#abda0475dd556eac94864edadfad99817">00264</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Parameters_1_1Parameter.php#abda0475dd556eac94864edadfad99817">Parameters::Parameter&lt;T&gt;::print</a> (std::ostream&amp; os)<span class="keyword"> const</span>
<a name="l00265"></a>00265 <span class="keyword"></span>{
<a name="l00266"></a>00266   os &lt;&lt; _value;
<a name="l00267"></a>00267 }
<a name="l00268"></a>00268 
<a name="l00269"></a>00269 
<a name="l00270"></a>00270 
<a name="l00271"></a>00271 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00272"></a>00272 <span class="keyword">inline</span>
<a name="l00273"></a><a class="code" href="classlibMesh_1_1Parameters_1_1Parameter.php#a461ad4db93c2eeb21991d55897492c83">00273</a> <a class="code" href="classlibMesh_1_1Parameters_1_1Value.php">Parameters::Value</a>* <a class="code" href="classlibMesh_1_1Parameters_1_1Parameter.php#a461ad4db93c2eeb21991d55897492c83">Parameters::Parameter&lt;T&gt;::clone</a> ()<span class="keyword"> const</span>
<a name="l00274"></a>00274 <span class="keyword"></span>{
<a name="l00275"></a>00275   <span class="comment">// No good for Solaris C++! - BSK</span>
<a name="l00276"></a>00276 <span class="comment">//  Parameters::Parameter&lt;T&gt;</span>
<a name="l00277"></a>00277 <span class="comment">//    *copy = new Parameters::Parameter&lt;T&gt;;</span>
<a name="l00278"></a>00278   <a class="code" href="classlibMesh_1_1Parameters_1_1Parameter.php">Parameter&lt;T&gt;</a>
<a name="l00279"></a>00279     *copy = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Parameters_1_1Parameter.php">Parameter&lt;T&gt;</a>;
<a name="l00280"></a>00280 
<a name="l00281"></a>00281   libmesh_assert (copy != NULL);
<a name="l00282"></a>00282   
<a name="l00283"></a>00283   copy-&gt;<a class="code" href="classlibMesh_1_1Parameters_1_1Parameter.php#a726b5527efc3fd02f9fbda60142597b3">_value</a> = _value;
<a name="l00284"></a>00284 
<a name="l00285"></a>00285   <span class="keywordflow">return</span> copy;
<a name="l00286"></a>00286 }
<a name="l00287"></a>00287 
<a name="l00288"></a>00288 
<a name="l00289"></a>00289 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00290"></a>00290 <span class="comment">// Parameters class inline methods</span>
<a name="l00291"></a>00291 <span class="keyword">inline</span>
<a name="l00292"></a><a class="code" href="classlibMesh_1_1Parameters.php#a64b2d5b2367f03a30e7c37780b8c5047">00292</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Parameters.php#a64b2d5b2367f03a30e7c37780b8c5047">Parameters::clear</a> () <span class="comment">// since this is inline we must define it</span>
<a name="l00293"></a>00293 {                         <span class="comment">// before its first use (for some compilers)</span>
<a name="l00294"></a>00294   <span class="keywordflow">while</span> (!<a class="code" href="classlibMesh_1_1Parameters.php#a78246629ee5c1e9afffd9ca55a75939e">_values</a>.empty())
<a name="l00295"></a>00295     {
<a name="l00296"></a>00296       <a class="code" href="classlibMesh_1_1Parameters.php#a27190068c41887096869f438ce1fef70">Parameters::iterator</a> it = <a class="code" href="classlibMesh_1_1Parameters.php#a78246629ee5c1e9afffd9ca55a75939e">_values</a>.begin();
<a name="l00297"></a>00297       
<a name="l00298"></a>00298       <span class="keyword">delete</span> it-&gt;second;      
<a name="l00299"></a>00299       it-&gt;second = NULL;
<a name="l00300"></a>00300       
<a name="l00301"></a>00301       <a class="code" href="classlibMesh_1_1Parameters.php#a78246629ee5c1e9afffd9ca55a75939e">_values</a>.erase(it);
<a name="l00302"></a>00302     }
<a name="l00303"></a>00303 }
<a name="l00304"></a>00304 
<a name="l00305"></a>00305 
<a name="l00306"></a>00306 
<a name="l00307"></a>00307 <span class="keyword">inline</span>
<a name="l00308"></a><a class="code" href="classlibMesh_1_1Parameters.php#a7fd5e9f1cfb18b4a7c44bd27fc01e237">00308</a> <a class="code" href="classlibMesh_1_1Parameters.php">Parameters</a>&amp; <a class="code" href="classlibMesh_1_1Parameters.php#a7fd5e9f1cfb18b4a7c44bd27fc01e237">Parameters::operator= </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parameters.php">Parameters</a>&amp; source)
<a name="l00309"></a>00309 {
<a name="l00310"></a>00310   this-&gt;<a class="code" href="classlibMesh_1_1Parameters.php#a64b2d5b2367f03a30e7c37780b8c5047">clear</a>();
<a name="l00311"></a>00311 
<a name="l00312"></a>00312   <span class="keywordflow">return</span> (*<span class="keyword">this</span> += source);
<a name="l00313"></a>00313 }
<a name="l00314"></a>00314 
<a name="l00315"></a>00315 <span class="keyword">inline</span>
<a name="l00316"></a><a class="code" href="classlibMesh_1_1Parameters.php#a922219e963753e3efb713308bcd5717c">00316</a> <a class="code" href="classlibMesh_1_1Parameters.php">Parameters</a>&amp; <a class="code" href="classlibMesh_1_1Parameters.php#a922219e963753e3efb713308bcd5717c">Parameters::operator+= </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parameters.php">Parameters</a>&amp; source)
<a name="l00317"></a>00317 {
<a name="l00318"></a>00318   <span class="keywordflow">for</span> (<a class="code" href="classlibMesh_1_1Parameters.php#a3d1ecf1cfcb95d326dd16172edf63f56">Parameters::const_iterator</a> it = source.<a class="code" href="classlibMesh_1_1Parameters.php#a78246629ee5c1e9afffd9ca55a75939e">_values</a>.begin();
<a name="l00319"></a>00319        it != source.<a class="code" href="classlibMesh_1_1Parameters.php#a78246629ee5c1e9afffd9ca55a75939e">_values</a>.end(); ++it)
<a name="l00320"></a>00320     <a class="code" href="classlibMesh_1_1Parameters.php#a78246629ee5c1e9afffd9ca55a75939e">_values</a>[it-&gt;first] = it-&gt;second-&gt;clone();
<a name="l00321"></a>00321   
<a name="l00322"></a>00322   <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00323"></a>00323 }
<a name="l00324"></a>00324 
<a name="l00325"></a>00325 <span class="keyword">inline</span>
<a name="l00326"></a><a class="code" href="classlibMesh_1_1Parameters.php#a43def9181ef506519775b47c37e91490">00326</a> <a class="code" href="classlibMesh_1_1Parameters.php#ac5734e6bb5ea29df547d7bad8f38ace4">Parameters::Parameters</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parameters.php">Parameters</a>&amp; p)
<a name="l00327"></a>00327 {
<a name="l00328"></a>00328   *<span class="keyword">this</span> = p;
<a name="l00329"></a>00329 }
<a name="l00330"></a>00330 
<a name="l00331"></a>00331 
<a name="l00332"></a>00332 
<a name="l00333"></a>00333 <span class="keyword">inline</span>
<a name="l00334"></a><a class="code" href="classlibMesh_1_1Parameters.php#a2522a703f232adaa680d53973fdd28a0">00334</a> <a class="code" href="classlibMesh_1_1Parameters.php#a2522a703f232adaa680d53973fdd28a0">Parameters::~Parameters</a> ()
<a name="l00335"></a>00335 {
<a name="l00336"></a>00336   this-&gt;<a class="code" href="classlibMesh_1_1Parameters.php#a64b2d5b2367f03a30e7c37780b8c5047">clear</a> ();
<a name="l00337"></a>00337 }
<a name="l00338"></a>00338 
<a name="l00339"></a>00339 
<a name="l00340"></a>00340 
<a name="l00341"></a>00341 <span class="keyword">inline</span>
<a name="l00342"></a><a class="code" href="classlibMesh_1_1Parameters.php#a69bdf0a000780829986785893a3b5793">00342</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Parameters.php#a69bdf0a000780829986785893a3b5793">Parameters::print</a> (std::ostream&amp; os)<span class="keyword"> const</span>
<a name="l00343"></a>00343 <span class="keyword"></span>{
<a name="l00344"></a>00344   <a class="code" href="classlibMesh_1_1Parameters.php#a3d1ecf1cfcb95d326dd16172edf63f56">Parameters::const_iterator</a> it = <a class="code" href="classlibMesh_1_1Parameters.php#a78246629ee5c1e9afffd9ca55a75939e">_values</a>.begin();
<a name="l00345"></a>00345 
<a name="l00346"></a>00346   os &lt;&lt; <span class="stringliteral">&quot;Name\t Type\t Value\n&quot;</span>
<a name="l00347"></a>00347      &lt;&lt; <span class="stringliteral">&quot;---------------------\n&quot;</span>;
<a name="l00348"></a>00348   <span class="keywordflow">while</span> (it != <a class="code" href="classlibMesh_1_1Parameters.php#a78246629ee5c1e9afffd9ca55a75939e">_values</a>.end())
<a name="l00349"></a>00349     {
<a name="l00350"></a>00350       os &lt;&lt; <span class="stringliteral">&quot; &quot;</span>   &lt;&lt; it-&gt;first
<a name="l00351"></a>00351          &lt;&lt; <span class="stringliteral">&quot;\t &quot;</span> &lt;&lt; it-&gt;second-&gt;type()
<a name="l00352"></a>00352          &lt;&lt; <span class="stringliteral">&quot;\t &quot;</span>;   it-&gt;second-&gt;print(os);      
<a name="l00353"></a>00353       os &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l00354"></a>00354 
<a name="l00355"></a>00355       ++it;
<a name="l00356"></a>00356     }
<a name="l00357"></a>00357 }
<a name="l00358"></a>00358 
<a name="l00359"></a>00359 
<a name="l00360"></a>00360 
<a name="l00361"></a>00361 <span class="comment">// Declare this now that Paramers::print() is defined.</span>
<a name="l00362"></a>00362 <span class="comment">// By declaring this early we can use it in subsequent</span>
<a name="l00363"></a>00363 <span class="comment">// methods.  Required for gcc-4.0.2 -- 11/30/2005, BSK</span>
<a name="l00364"></a>00364 <span class="keyword">inline</span>
<a name="l00365"></a><a class="code" href="namespacelibMesh.php#a3fd2331b602cad916a807b3fb715aa4e">00365</a> std::ostream&amp; <a class="code" href="namespacelibMesh.php#a546a7b5eb3d073add8e1f19af6bcaf82">operator &lt;&lt; </a>(std::ostream&amp; os, <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parameters.php">Parameters</a>&amp; p)
<a name="l00366"></a>00366 {
<a name="l00367"></a>00367   p.<a class="code" href="classlibMesh_1_1Parameters.php#a69bdf0a000780829986785893a3b5793">print</a>(os);
<a name="l00368"></a>00368   <span class="keywordflow">return</span> os;
<a name="l00369"></a>00369 }
<a name="l00370"></a>00370 
<a name="l00371"></a>00371 
<a name="l00372"></a>00372 
<a name="l00373"></a>00373 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00374"></a>00374 <span class="keyword">inline</span>
<a name="l00375"></a><a class="code" href="classlibMesh_1_1Parameters.php#a6ced71ca7796d8109dd9b62bd0e1139b">00375</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Parameters.php#a6ced71ca7796d8109dd9b62bd0e1139b">Parameters::have_parameter</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>)<span class="keyword"> const</span>
<a name="l00376"></a>00376 <span class="keyword"></span>{
<a name="l00377"></a>00377   <a class="code" href="classlibMesh_1_1Parameters.php#a3d1ecf1cfcb95d326dd16172edf63f56">Parameters::const_iterator</a> it = <a class="code" href="classlibMesh_1_1Parameters.php#a78246629ee5c1e9afffd9ca55a75939e">_values</a>.find(name);
<a name="l00378"></a>00378 
<a name="l00379"></a>00379   <span class="keywordflow">if</span> (it != <a class="code" href="classlibMesh_1_1Parameters.php#a78246629ee5c1e9afffd9ca55a75939e">_values</a>.end())
<a name="l00380"></a>00380     <span class="keywordflow">if</span> (<span class="keyword">dynamic_cast&lt;</span><span class="keyword">const </span><a class="code" href="classlibMesh_1_1Parameters_1_1Parameter.php">Parameter&lt;T&gt;</a>*<span class="keyword">&gt;</span>(it-&gt;second) != NULL)
<a name="l00381"></a>00381       <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00382"></a>00382 
<a name="l00383"></a>00383   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00384"></a>00384 }
<a name="l00385"></a>00385 
<a name="l00386"></a>00386 
<a name="l00387"></a>00387 
<a name="l00388"></a>00388 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00389"></a>00389 <span class="keyword">inline</span>
<a name="l00390"></a><a class="code" href="classlibMesh_1_1Parameters.php#ac7fa2054ee32db2c3979d48bd2103f20">00390</a> <span class="keyword">const</span> T&amp; <a class="code" href="classlibMesh_1_1Parameters.php#ac7fa2054ee32db2c3979d48bd2103f20">Parameters::get</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>)<span class="keyword"> const</span>
<a name="l00391"></a>00391 <span class="keyword"></span>{
<a name="l00392"></a>00392   <span class="keywordflow">if</span> (!this-&gt;have_parameter&lt;T&gt;(name))
<a name="l00393"></a>00393     {
<a name="l00394"></a>00394       <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: no &quot;</span>
<a name="l00395"></a>00395                     &lt;&lt; <span class="keyword">typeid</span>(T).<a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>()
<a name="l00396"></a>00396                     &lt;&lt; <span class="stringliteral">&quot; parameter named \&quot;&quot;</span>
<a name="l00397"></a>00397                     &lt;&lt; name &lt;&lt; <span class="stringliteral">&quot;\&quot;:&quot;</span> &lt;&lt; std::endl
<a name="l00398"></a>00398                     &lt;&lt; *<span class="keyword">this</span>;
<a name="l00399"></a>00399       
<a name="l00400"></a>00400       libmesh_error();
<a name="l00401"></a>00401     }
<a name="l00402"></a>00402 
<a name="l00403"></a>00403   <a class="code" href="classlibMesh_1_1Parameters.php#a3d1ecf1cfcb95d326dd16172edf63f56">Parameters::const_iterator</a> it = <a class="code" href="classlibMesh_1_1Parameters.php#a78246629ee5c1e9afffd9ca55a75939e">_values</a>.find(name);
<a name="l00404"></a>00404 
<a name="l00405"></a>00405   libmesh_assert (it != <a class="code" href="classlibMesh_1_1Parameters.php#a78246629ee5c1e9afffd9ca55a75939e">_values</a>.end());
<a name="l00406"></a>00406   libmesh_assert (it-&gt;second != NULL);
<a name="l00407"></a>00407   libmesh_assert (<span class="keyword">dynamic_cast&lt;</span><span class="keyword">const </span><a class="code" href="classlibMesh_1_1Parameters_1_1Parameter.php">Parameter&lt;T&gt;</a>*<span class="keyword">&gt;</span>(it-&gt;second) != NULL);
<a name="l00408"></a>00408   
<a name="l00409"></a>00409   <span class="keywordflow">return</span> <span class="keyword">dynamic_cast&lt;</span><a class="code" href="classlibMesh_1_1Parameters_1_1Parameter.php">Parameter&lt;T&gt;</a>*<span class="keyword">&gt;</span>(it-&gt;second)-&gt;<span class="keyword">get</span>();
<a name="l00410"></a>00410 }
<a name="l00411"></a>00411 
<a name="l00412"></a>00412 
<a name="l00413"></a>00413 
<a name="l00414"></a>00414 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00415"></a>00415 <span class="keyword">inline</span>
<a name="l00416"></a><a class="code" href="classlibMesh_1_1Parameters.php#a7036d0ddbe4965e0a638e1b9814fa549">00416</a> T&amp; <a class="code" href="classlibMesh_1_1Parameters.php#a7036d0ddbe4965e0a638e1b9814fa549">Parameters::set</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>)
<a name="l00417"></a>00417 {
<a name="l00418"></a>00418   <a class="code" href="classlibMesh_1_1Parameters_1_1Parameter.php">Parameter&lt;T&gt;</a>* param = NULL;
<a name="l00419"></a>00419   
<a name="l00420"></a>00420   <span class="keywordflow">if</span> (!this-&gt;have_parameter&lt;T&gt;(name))
<a name="l00421"></a>00421     <a class="code" href="classlibMesh_1_1Parameters.php#a78246629ee5c1e9afffd9ca55a75939e">_values</a>[<a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>] = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Parameters_1_1Parameter.php">Parameter&lt;T&gt;</a>;
<a name="l00422"></a>00422 
<a name="l00423"></a>00423   param = <span class="keyword">dynamic_cast&lt;</span><a class="code" href="classlibMesh_1_1Parameters_1_1Parameter.php">Parameter&lt;T&gt;</a>*<span class="keyword">&gt;</span>(<a class="code" href="classlibMesh_1_1Parameters.php#a78246629ee5c1e9afffd9ca55a75939e">_values</a>[<a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>]);
<a name="l00424"></a>00424 
<a name="l00425"></a>00425   libmesh_assert (param != NULL);
<a name="l00426"></a>00426   
<a name="l00427"></a>00427   <span class="keywordflow">return</span> param-&gt;<a class="code" href="classlibMesh_1_1Parameters_1_1Parameter.php#a8e620889e68002586faa0215bc73bea1">set</a>();
<a name="l00428"></a>00428 }
<a name="l00429"></a>00429 
<a name="l00430"></a>00430 
<a name="l00431"></a>00431 
<a name="l00432"></a>00432 <span class="keyword">inline</span>
<a name="l00433"></a><a class="code" href="classlibMesh_1_1Parameters.php#a06b2f9d9ec57980583bf9aad3c7e03f6">00433</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Parameters.php#a06b2f9d9ec57980583bf9aad3c7e03f6">Parameters::remove</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>)
<a name="l00434"></a>00434 {
<a name="l00435"></a>00435   <a class="code" href="classlibMesh_1_1Parameters.php#a27190068c41887096869f438ce1fef70">Parameters::iterator</a> it = <a class="code" href="classlibMesh_1_1Parameters.php#a78246629ee5c1e9afffd9ca55a75939e">_values</a>.find(name);
<a name="l00436"></a>00436 
<a name="l00437"></a>00437   <span class="keywordflow">if</span> (it != <a class="code" href="classlibMesh_1_1Parameters.php#a78246629ee5c1e9afffd9ca55a75939e">_values</a>.end())
<a name="l00438"></a>00438     {
<a name="l00439"></a>00439       <span class="keyword">delete</span> it-&gt;second;
<a name="l00440"></a>00440       it-&gt;second = NULL;
<a name="l00441"></a>00441 
<a name="l00442"></a>00442       <a class="code" href="classlibMesh_1_1Parameters.php#a78246629ee5c1e9afffd9ca55a75939e">_values</a>.erase(it);
<a name="l00443"></a>00443     }
<a name="l00444"></a>00444 }
<a name="l00445"></a>00445 
<a name="l00446"></a>00446 
<a name="l00447"></a>00447 
<a name="l00448"></a>00448 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00449"></a>00449 <span class="keyword">inline</span>
<a name="l00450"></a>00450 <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Parameters.php#aace39d06a06ed2ebc294662327318283">Parameters::n_parameters</a> ()<span class="keyword"> const</span>
<a name="l00451"></a>00451 <span class="keyword"></span>{
<a name="l00452"></a>00452   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> cnt = 0;  
<a name="l00453"></a>00453   
<a name="l00454"></a>00454   <a class="code" href="classlibMesh_1_1Parameters.php#a3d1ecf1cfcb95d326dd16172edf63f56">Parameters::const_iterator</a>       it  = <a class="code" href="classlibMesh_1_1Parameters.php#a78246629ee5c1e9afffd9ca55a75939e">_values</a>.begin();
<a name="l00455"></a>00455   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parameters.php#a3d1ecf1cfcb95d326dd16172edf63f56">Parameters::const_iterator</a> <a class="code" href="classlibMesh_1_1Parameters.php#a77447a8e22c51365a66d509a9ff5e6c3">end</a> = <a class="code" href="classlibMesh_1_1Parameters.php#a78246629ee5c1e9afffd9ca55a75939e">_values</a>.end();
<a name="l00456"></a>00456   
<a name="l00457"></a>00457   <span class="keywordflow">for</span> (; it != <a class="code" href="classlibMesh_1_1Parameters.php#a77447a8e22c51365a66d509a9ff5e6c3">end</a>; ++it)
<a name="l00458"></a>00458     <span class="keywordflow">if</span> (<span class="keyword">dynamic_cast&lt;</span>Parameter&lt;T&gt;*<span class="keyword">&gt;</span>(it-&gt;second) != NULL)
<a name="l00459"></a>00459       cnt++;
<a name="l00460"></a>00460 
<a name="l00461"></a>00461   <span class="keywordflow">return</span> cnt;    
<a name="l00462"></a>00462 }
<a name="l00463"></a>00463 
<a name="l00464"></a>00464 <span class="keyword">inline</span>
<a name="l00465"></a><a class="code" href="classlibMesh_1_1Parameters.php#a4a8506e50a4d10f8dfe563de87c37d80">00465</a> <a class="code" href="classlibMesh_1_1Parameters.php#a27190068c41887096869f438ce1fef70">Parameters::iterator</a> <a class="code" href="classlibMesh_1_1Parameters.php#a4a8506e50a4d10f8dfe563de87c37d80">Parameters::begin</a>()
<a name="l00466"></a>00466 {
<a name="l00467"></a>00467   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Parameters.php#a78246629ee5c1e9afffd9ca55a75939e">_values</a>.begin();
<a name="l00468"></a>00468 }
<a name="l00469"></a>00469 
<a name="l00470"></a>00470 <span class="keyword">inline</span>
<a name="l00471"></a><a class="code" href="classlibMesh_1_1Parameters.php#ada58f7dc0e02977cc30a46d3c5658246">00471</a> <a class="code" href="classlibMesh_1_1Parameters.php#a3d1ecf1cfcb95d326dd16172edf63f56">Parameters::const_iterator</a> <a class="code" href="classlibMesh_1_1Parameters.php#a4a8506e50a4d10f8dfe563de87c37d80">Parameters::begin</a>()<span class="keyword"> const</span>
<a name="l00472"></a>00472 <span class="keyword"></span>{
<a name="l00473"></a>00473   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Parameters.php#a78246629ee5c1e9afffd9ca55a75939e">_values</a>.begin();
<a name="l00474"></a>00474 }
<a name="l00475"></a>00475 
<a name="l00476"></a>00476 <span class="keyword">inline</span>
<a name="l00477"></a><a class="code" href="classlibMesh_1_1Parameters.php#a77447a8e22c51365a66d509a9ff5e6c3">00477</a> <a class="code" href="classlibMesh_1_1Parameters.php#a27190068c41887096869f438ce1fef70">Parameters::iterator</a> <a class="code" href="classlibMesh_1_1Parameters.php#a77447a8e22c51365a66d509a9ff5e6c3">Parameters::end</a>()
<a name="l00478"></a>00478 {
<a name="l00479"></a>00479   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Parameters.php#a78246629ee5c1e9afffd9ca55a75939e">_values</a>.end();
<a name="l00480"></a>00480 }
<a name="l00481"></a>00481 
<a name="l00482"></a>00482 <span class="keyword">inline</span>
<a name="l00483"></a><a class="code" href="classlibMesh_1_1Parameters.php#aaa8fd89bc6e2091d51bc6d622de43010">00483</a> <a class="code" href="classlibMesh_1_1Parameters.php#a3d1ecf1cfcb95d326dd16172edf63f56">Parameters::const_iterator</a> <a class="code" href="classlibMesh_1_1Parameters.php#a77447a8e22c51365a66d509a9ff5e6c3">Parameters::end</a>()<span class="keyword"> const</span>
<a name="l00484"></a>00484 <span class="keyword"></span>{
<a name="l00485"></a>00485   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Parameters.php#a78246629ee5c1e9afffd9ca55a75939e">_values</a>.end();
<a name="l00486"></a>00486 }
<a name="l00487"></a>00487 
<a name="l00488"></a>00488 } <span class="comment">// namespace libMesh</span>
<a name="l00489"></a>00489 
<a name="l00490"></a>00490 <span class="preprocessor">#endif // #define __parameters_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
