<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_c3a49989e40b21e7508f29d2dc962def.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_36c0e62e14ec08438a4c76530bb2530c.php">solvers</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">petsc_linear_solver.C</div>  </div>
</div>
<div class="contents">
<a href="petsc__linear__solver_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id$</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifdef LIBMESH_HAVE_PETSC</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span>
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;string.h&gt;</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="comment">// Local Includes</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__logging_8h.php">libmesh_logging.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="petsc__linear__solver_8h.php">petsc_linear_solver.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="shell__matrix_8h.php">shell_matrix.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="petsc__matrix_8h.php">petsc_matrix.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="petsc__preconditioner_8h.php">petsc_preconditioner.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="petsc__vector_8h.php">petsc_vector.h</a>&quot;</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="keyword">namespace </span>libMesh
<a name="l00037"></a>00037 {
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 <span class="keyword">extern</span> <span class="stringliteral">&quot;C&quot;</span>
<a name="l00040"></a>00040 {
<a name="l00041"></a>00041 <span class="preprocessor">#if PETSC_VERSION_LESS_THAN(2,2,1)</span>
<a name="l00042"></a>00042 <span class="preprocessor"></span>  <span class="keyword">typedef</span> <span class="keywordtype">int</span> <a class="code" href="namespacelibMesh.php#ae498bcd21156b9579c241812fe40c3c2">PetscErrorCode</a>;
<a name="l00043"></a>00043   <span class="keyword">typedef</span> <span class="keywordtype">int</span> <a class="code" href="namespacelibMesh.php#a7ad10af8599548704f3938639a33b5ca">PetscInt</a>;
<a name="l00044"></a>00044 <span class="preprocessor">#endif</span>
<a name="l00045"></a>00045 <span class="preprocessor"></span>
<a name="l00046"></a>00046 
<a name="l00047"></a>00047 <span class="preprocessor">#if PETSC_VERSION_LESS_THAN(3,0,1) &amp;&amp; PETSC_VERSION_RELEASE</span>
<a name="l00048"></a><a class="code" href="petsc__linear__solver_8h.php#a4737870c4c15c93547318e44dea2e463">00048</a> <span class="preprocessor"></span>  PetscErrorCode <a class="code" href="namespacelibMesh.php#a0ad4171647357ca5a2ffacb1c8ca5c6a">__libmesh_petsc_preconditioner_setup</a> (<span class="keywordtype">void</span> * ctx)
<a name="l00049"></a>00049   {
<a name="l00050"></a>00050     Preconditioner&lt;Number&gt; * preconditioner = <span class="keyword">static_cast&lt;</span>Preconditioner&lt;Number&gt;*<span class="keyword">&gt;</span>(ctx);
<a name="l00051"></a>00051     preconditioner-&gt;init();
<a name="l00052"></a>00052 
<a name="l00053"></a>00053     <span class="keywordflow">return</span> 0;
<a name="l00054"></a>00054   }
<a name="l00055"></a>00055   
<a name="l00056"></a>00056 
<a name="l00057"></a><a class="code" href="petsc__linear__solver_8h.php#a13ac63a1ac4545e7ac3bac10a8bd8677">00057</a>   PetscErrorCode <a class="code" href="namespacelibMesh.php#ae6c236ad49e5a5d8ad7f42d3f16b553e">__libmesh_petsc_preconditioner_apply</a>(<span class="keywordtype">void</span> *ctx, Vec x, Vec y)
<a name="l00058"></a>00058   {
<a name="l00059"></a>00059     Preconditioner&lt;Number&gt; * preconditioner = <span class="keyword">static_cast&lt;</span>Preconditioner&lt;Number&gt;*<span class="keyword">&gt;</span>(ctx);
<a name="l00060"></a>00060 
<a name="l00061"></a>00061     PetscVector&lt;Number&gt; x_vec(x);
<a name="l00062"></a>00062     PetscVector&lt;Number&gt; y_vec(y);
<a name="l00063"></a>00063 
<a name="l00064"></a>00064     preconditioner-&gt;apply(x_vec,y_vec);
<a name="l00065"></a>00065 
<a name="l00066"></a>00066     <span class="keywordflow">return</span> 0;
<a name="l00067"></a>00067   }
<a name="l00068"></a>00068 <span class="preprocessor">#else</span>
<a name="l00069"></a><a class="code" href="petsc__linear__solver_8h.php#a7f9050298a8ebb30a5e1998947b8653e">00069</a> <span class="preprocessor"></span>  PetscErrorCode <a class="code" href="namespacelibMesh.php#a0ad4171647357ca5a2ffacb1c8ca5c6a">__libmesh_petsc_preconditioner_setup</a> (PC pc)
<a name="l00070"></a>00070   {
<a name="l00071"></a>00071     <span class="keywordtype">void</span> *ctx;
<a name="l00072"></a>00072     PetscErrorCode ierr = PCShellGetContext(pc,&amp;ctx);CHKERRQ(ierr);
<a name="l00073"></a>00073     Preconditioner&lt;Number&gt; * preconditioner = <span class="keyword">static_cast&lt;</span>Preconditioner&lt;Number&gt;*<span class="keyword">&gt;</span>(ctx);
<a name="l00074"></a>00074     preconditioner-&gt;init();
<a name="l00075"></a>00075 
<a name="l00076"></a>00076     <span class="keywordflow">return</span> 0;
<a name="l00077"></a>00077   }
<a name="l00078"></a>00078 
<a name="l00079"></a><a class="code" href="petsc__linear__solver_8h.php#add1205beb649851a35301fb431bdb655">00079</a>   PetscErrorCode <a class="code" href="namespacelibMesh.php#ae6c236ad49e5a5d8ad7f42d3f16b553e">__libmesh_petsc_preconditioner_apply</a>(PC pc, Vec x, Vec y)
<a name="l00080"></a>00080   {
<a name="l00081"></a>00081     <span class="keywordtype">void</span> *ctx;
<a name="l00082"></a>00082     PetscErrorCode ierr = PCShellGetContext(pc,&amp;ctx);CHKERRQ(ierr);
<a name="l00083"></a>00083     Preconditioner&lt;Number&gt; * preconditioner = <span class="keyword">static_cast&lt;</span>Preconditioner&lt;Number&gt;*<span class="keyword">&gt;</span>(ctx);
<a name="l00084"></a>00084 
<a name="l00085"></a>00085     PetscVector&lt;Number&gt; x_vec(x);
<a name="l00086"></a>00086     PetscVector&lt;Number&gt; y_vec(y);
<a name="l00087"></a>00087 
<a name="l00088"></a>00088     preconditioner-&gt;apply(x_vec,y_vec);
<a name="l00089"></a>00089 
<a name="l00090"></a>00090     <span class="keywordflow">return</span> 0;
<a name="l00091"></a>00091   }
<a name="l00092"></a>00092 <span class="preprocessor">#endif</span>
<a name="l00093"></a>00093 <span class="preprocessor"></span>} <span class="comment">// end extern &quot;C&quot;</span>
<a name="l00094"></a>00094 
<a name="l00095"></a>00095 <span class="comment">/*----------------------- functions ----------------------------------*/</span>
<a name="l00096"></a>00096 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00097"></a><a class="code" href="classlibMesh_1_1PetscLinearSolver.php#adafec932e0a6a770391d756a9b21fa14">00097</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscLinearSolver.php#adafec932e0a6a770391d756a9b21fa14">PetscLinearSolver&lt;T&gt;::clear</a> ()
<a name="l00098"></a>00098 {
<a name="l00099"></a>00099   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>())
<a name="l00100"></a>00100     {
<a name="l00101"></a>00101       this-&gt;<a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#ab8b7115ea57ced35ec86d1fdfa0ab853">_is_initialized</a> = <span class="keyword">false</span>;
<a name="l00102"></a>00102 
<a name="l00103"></a>00103       <span class="keywordtype">int</span> ierr=0;
<a name="l00104"></a>00104 
<a name="l00105"></a>00105 <span class="preprocessor">#if PETSC_VERSION_LESS_THAN(2,2,0)</span>
<a name="l00106"></a>00106 <span class="preprocessor"></span>
<a name="l00107"></a>00107   <span class="comment">// 2.1.x &amp; earlier style      </span>
<a name="l00108"></a>00108   ierr = SLESDestroy(_sles);
<a name="l00109"></a>00109          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00110"></a>00110 
<a name="l00111"></a>00111 <span class="preprocessor">#else</span>
<a name="l00112"></a>00112 <span class="preprocessor"></span>
<a name="l00113"></a>00113   <span class="comment">// 2.2.0 &amp; newer style</span>
<a name="l00114"></a>00114   ierr = KSPDestroy(_ksp);
<a name="l00115"></a>00115          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00116"></a>00116 
<a name="l00117"></a>00117 <span class="preprocessor">#endif</span>
<a name="l00118"></a>00118 <span class="preprocessor"></span>
<a name="l00119"></a>00119              
<a name="l00120"></a>00120       <span class="comment">// Mimic PETSc default solver and preconditioner</span>
<a name="l00121"></a>00121       this-&gt;_solver_type           = <a class="code" href="namespacelibMeshEnums.php#a6ecf91f56b4ab5cda4d3d0a468733b19a28c6a4ecccca1d0e6956e5e94fa82d97">GMRES</a>;
<a name="l00122"></a>00122 
<a name="l00123"></a>00123       <span class="keywordflow">if</span>(!this-&gt;_preconditioner)
<a name="l00124"></a>00124       {
<a name="l00125"></a>00125         <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() == 1)
<a name="l00126"></a>00126           this-&gt;_preconditioner_type = <a class="code" href="namespacelibMeshEnums.php#a45b101a23b532f020f46f412485db0d4af54549e0e69fbdd4ddd199ee316527f3">ILU_PRECOND</a>;
<a name="l00127"></a>00127         <span class="keywordflow">else</span>
<a name="l00128"></a>00128           this-&gt;_preconditioner_type = <a class="code" href="namespacelibMeshEnums.php#a45b101a23b532f020f46f412485db0d4a8f036d61e96c69b14d585f04235613d2">BLOCK_JACOBI_PRECOND</a>;
<a name="l00129"></a>00129       }
<a name="l00130"></a>00130     }
<a name="l00131"></a>00131 }
<a name="l00132"></a>00132 
<a name="l00133"></a>00133 
<a name="l00134"></a>00134 
<a name="l00135"></a>00135 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00136"></a><a class="code" href="classlibMesh_1_1PetscLinearSolver.php#a634b1f121de9d575606291469cd325b1">00136</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscLinearSolver.php#a634b1f121de9d575606291469cd325b1">PetscLinearSolver&lt;T&gt;::init</a> ()
<a name="l00137"></a>00137 {
<a name="l00138"></a>00138   <span class="comment">// Initialize the data structures if not done so already.</span>
<a name="l00139"></a>00139   <span class="keywordflow">if</span> (!this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>())
<a name="l00140"></a>00140     {
<a name="l00141"></a>00141       this-&gt;<a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#ab8b7115ea57ced35ec86d1fdfa0ab853">_is_initialized</a> = <span class="keyword">true</span>;
<a name="l00142"></a>00142       
<a name="l00143"></a>00143       <span class="keywordtype">int</span> ierr=0;
<a name="l00144"></a>00144   
<a name="l00145"></a>00145 <span class="comment">// 2.1.x &amp; earlier style      </span>
<a name="l00146"></a>00146 <span class="preprocessor">#if PETSC_VERSION_LESS_THAN(2,2,0)</span>
<a name="l00147"></a>00147 <span class="preprocessor"></span>      
<a name="l00148"></a>00148       <span class="comment">// Create the linear solver context</span>
<a name="l00149"></a>00149       ierr = SLESCreate (<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>, &amp;_sles);
<a name="l00150"></a>00150              CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00151"></a>00151       
<a name="l00152"></a>00152       <span class="comment">// Create the Krylov subspace &amp; preconditioner contexts</span>
<a name="l00153"></a>00153       ierr = SLESGetKSP       (_sles, &amp;_ksp);
<a name="l00154"></a>00154              CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00155"></a>00155       ierr = SLESGetPC        (_sles, &amp;_pc);
<a name="l00156"></a>00156              CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00157"></a>00157       
<a name="l00158"></a>00158       <span class="comment">// Set user-specified  solver and preconditioner types</span>
<a name="l00159"></a>00159       this-&gt;set_petsc_solver_type();
<a name="l00160"></a>00160       
<a name="l00161"></a>00161       <span class="comment">// Set the options from user-input</span>
<a name="l00162"></a>00162       <span class="comment">// Set runtime options, e.g.,</span>
<a name="l00163"></a>00163       <span class="comment">//      -ksp_type &lt;type&gt; -pc_type &lt;type&gt; -ksp_monitor -ksp_rtol &lt;rtol&gt;</span>
<a name="l00164"></a>00164       <span class="comment">//  These options will override those specified above as long as</span>
<a name="l00165"></a>00165       <span class="comment">//  SLESSetFromOptions() is called _after_ any other customization</span>
<a name="l00166"></a>00166       <span class="comment">//  routines.</span>
<a name="l00167"></a>00167       
<a name="l00168"></a>00168       ierr = SLESSetFromOptions (_sles);
<a name="l00169"></a>00169              CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00170"></a>00170 
<a name="l00171"></a>00171 <span class="comment">// 2.2.0 &amp; newer style</span>
<a name="l00172"></a>00172 <span class="preprocessor">#else</span>
<a name="l00173"></a>00173 <span class="preprocessor"></span>      
<a name="l00174"></a>00174       <span class="comment">// Create the linear solver context</span>
<a name="l00175"></a>00175       ierr = KSPCreate (<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>, &amp;_ksp);
<a name="l00176"></a>00176              CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00177"></a>00177       
<a name="l00178"></a>00178       <span class="comment">// Create the preconditioner context</span>
<a name="l00179"></a>00179       ierr = KSPGetPC        (_ksp, &amp;_pc);
<a name="l00180"></a>00180              CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00181"></a>00181 
<a name="l00182"></a>00182       <span class="comment">// Set user-specified  solver and preconditioner types</span>
<a name="l00183"></a>00183       this-&gt;set_petsc_solver_type();
<a name="l00184"></a>00184 
<a name="l00185"></a>00185       <span class="comment">// Set the options from user-input</span>
<a name="l00186"></a>00186       <span class="comment">// Set runtime options, e.g.,</span>
<a name="l00187"></a>00187       <span class="comment">//      -ksp_type &lt;type&gt; -pc_type &lt;type&gt; -ksp_monitor -ksp_rtol &lt;rtol&gt;</span>
<a name="l00188"></a>00188       <span class="comment">//  These options will override those specified above as long as</span>
<a name="l00189"></a>00189       <span class="comment">//  KSPSetFromOptions() is called _after_ any other customization</span>
<a name="l00190"></a>00190       <span class="comment">//  routines.</span>
<a name="l00191"></a>00191       
<a name="l00192"></a>00192       ierr = KSPSetFromOptions (_ksp);
<a name="l00193"></a>00193       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00194"></a>00194 
<a name="l00195"></a>00195       <span class="comment">// Not sure if this is necessary, or if it is already handled by KSPSetFromOptions?</span>
<a name="l00196"></a>00196       <span class="comment">// NOT NECESSARY!!!!</span>
<a name="l00197"></a>00197       <span class="comment">//ierr = PCSetFromOptions (_pc);</span>
<a name="l00198"></a>00198       <span class="comment">//CHKERRABORT(libMesh::COMM_WORLD,ierr);</span>
<a name="l00199"></a>00199 
<a name="l00200"></a>00200                
<a name="l00201"></a>00201 <span class="preprocessor">#endif</span>
<a name="l00202"></a>00202 <span class="preprocessor"></span>             
<a name="l00203"></a>00203       <span class="comment">// Have the Krylov subspace method use our good initial guess</span>
<a name="l00204"></a>00204       <span class="comment">// rather than 0, unless the user requested a KSPType of</span>
<a name="l00205"></a>00205       <span class="comment">// preonly, which complains if asked to use initial guesses.</span>
<a name="l00206"></a>00206 <span class="preprocessor">#if PETSC_VERSION_LESS_THAN(3,0,0)</span>
<a name="l00207"></a>00207 <span class="preprocessor"></span>      KSPType ksp_type;
<a name="l00208"></a>00208 <span class="preprocessor">#else</span>
<a name="l00209"></a>00209 <span class="preprocessor"></span>      <span class="keyword">const</span> KSPType ksp_type;
<a name="l00210"></a>00210 <span class="preprocessor">#endif</span>
<a name="l00211"></a>00211 <span class="preprocessor"></span>
<a name="l00212"></a>00212       ierr = KSPGetType (_ksp, &amp;ksp_type);
<a name="l00213"></a>00213              CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00214"></a>00214 
<a name="l00215"></a>00215       <span class="keywordflow">if</span> (strcmp(ksp_type, <span class="stringliteral">&quot;preonly&quot;</span>))
<a name="l00216"></a>00216         {
<a name="l00217"></a>00217           ierr = KSPSetInitialGuessNonzero (_ksp, PETSC_TRUE);
<a name="l00218"></a>00218                  CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00219"></a>00219         }
<a name="l00220"></a>00220       
<a name="l00221"></a>00221       <span class="comment">// Notify PETSc of location to store residual history.</span>
<a name="l00222"></a>00222       <span class="comment">// This needs to be called before any solves, since</span>
<a name="l00223"></a>00223       <span class="comment">// it sets the residual history length to zero.  The default</span>
<a name="l00224"></a>00224       <span class="comment">// behavior is for PETSc to allocate (internally) an array</span>
<a name="l00225"></a>00225       <span class="comment">// of size 1000 to hold the residual norm history.</span>
<a name="l00226"></a>00226       ierr = KSPSetResidualHistory(_ksp,
<a name="l00227"></a>00227                                    PETSC_NULL,   <span class="comment">// pointer to the array which holds the history</span>
<a name="l00228"></a>00228                                    PETSC_DECIDE, <span class="comment">// size of the array holding the history</span>
<a name="l00229"></a>00229                                    PETSC_TRUE);  <span class="comment">// Whether or not to reset the history for each solve. </span>
<a name="l00230"></a>00230       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00231"></a>00231 
<a name="l00232"></a>00232       <a class="code" href="classlibMesh_1_1PetscPreconditioner.php#aab69801de7b38fc74cf110baa0bcde9b">PetscPreconditioner&lt;T&gt;::set_petsc_preconditioner_type</a>(this-&gt;_preconditioner_type,_pc);
<a name="l00233"></a>00233 
<a name="l00234"></a>00234       <span class="comment">//If there is a preconditioner object we need to set the internal setup and apply routines</span>
<a name="l00235"></a>00235       <span class="keywordflow">if</span>(this-&gt;_preconditioner)
<a name="l00236"></a>00236       {
<a name="l00237"></a>00237         PCShellSetContext(_pc,(<span class="keywordtype">void</span>*)this-&gt;_preconditioner);
<a name="l00238"></a>00238         PCShellSetSetUp(_pc,<a class="code" href="namespacelibMesh.php#a0ad4171647357ca5a2ffacb1c8ca5c6a">__libmesh_petsc_preconditioner_setup</a>);
<a name="l00239"></a>00239         PCShellSetApply(_pc,<a class="code" href="namespacelibMesh.php#ae6c236ad49e5a5d8ad7f42d3f16b553e">__libmesh_petsc_preconditioner_apply</a>);
<a name="l00240"></a>00240       }
<a name="l00241"></a>00241     }
<a name="l00242"></a>00242 }
<a name="l00243"></a>00243 
<a name="l00244"></a>00244 
<a name="l00245"></a>00245 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00246"></a><a class="code" href="classlibMesh_1_1PetscLinearSolver.php#a5043790d71e95c0c95e2c7de0b4a7cfd">00246</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscLinearSolver.php#a634b1f121de9d575606291469cd325b1">PetscLinearSolver&lt;T&gt;::init</a> ( <a class="code" href="classlibMesh_1_1PetscMatrix.php">PetscMatrix&lt;T&gt;</a>* matrix )
<a name="l00247"></a>00247 {
<a name="l00248"></a>00248   <span class="comment">// Initialize the data structures if not done so already.</span>
<a name="l00249"></a>00249   <span class="keywordflow">if</span> (!this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>())
<a name="l00250"></a>00250     {
<a name="l00251"></a>00251       this-&gt;<a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#ab8b7115ea57ced35ec86d1fdfa0ab853">_is_initialized</a> = <span class="keyword">true</span>;
<a name="l00252"></a>00252       
<a name="l00253"></a>00253       <span class="keywordtype">int</span> ierr=0;
<a name="l00254"></a>00254 
<a name="l00255"></a>00255 <span class="comment">// 2.1.x &amp; earlier style      </span>
<a name="l00256"></a>00256 <span class="preprocessor">#if PETSC_VERSION_LESS_THAN(2,2,0)</span>
<a name="l00257"></a>00257 <span class="preprocessor"></span>      
<a name="l00258"></a>00258       <span class="comment">// Create the linear solver context</span>
<a name="l00259"></a>00259       ierr = SLESCreate (<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>, &amp;_sles);
<a name="l00260"></a>00260              CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00261"></a>00261       
<a name="l00262"></a>00262       <span class="comment">// Create the Krylov subspace &amp; preconditioner contexts</span>
<a name="l00263"></a>00263       ierr = SLESGetKSP       (_sles, &amp;_ksp);
<a name="l00264"></a>00264              CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00265"></a>00265       ierr = SLESGetPC        (_sles, &amp;_pc);
<a name="l00266"></a>00266              CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00267"></a>00267       
<a name="l00268"></a>00268       <span class="comment">// Set user-specified  solver and preconditioner types</span>
<a name="l00269"></a>00269       this-&gt;set_petsc_solver_type();
<a name="l00270"></a>00270       
<a name="l00271"></a>00271       <span class="comment">// Set the options from user-input</span>
<a name="l00272"></a>00272       <span class="comment">// Set runtime options, e.g.,</span>
<a name="l00273"></a>00273       <span class="comment">//      -ksp_type &lt;type&gt; -pc_type &lt;type&gt; -ksp_monitor -ksp_rtol &lt;rtol&gt;</span>
<a name="l00274"></a>00274       <span class="comment">//  These options will override those specified above as long as</span>
<a name="l00275"></a>00275       <span class="comment">//  SLESSetFromOptions() is called _after_ any other customization</span>
<a name="l00276"></a>00276       <span class="comment">//  routines.</span>
<a name="l00277"></a>00277       
<a name="l00278"></a>00278       ierr = SLESSetFromOptions (_sles);
<a name="l00279"></a>00279              CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00280"></a>00280 
<a name="l00281"></a>00281 <span class="comment">// 2.2.0 &amp; newer style</span>
<a name="l00282"></a>00282 <span class="preprocessor">#else</span>
<a name="l00283"></a>00283 <span class="preprocessor"></span>      
<a name="l00284"></a>00284       <span class="comment">// Create the linear solver context</span>
<a name="l00285"></a>00285       ierr = KSPCreate (<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>, &amp;_ksp);
<a name="l00286"></a>00286              CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00287"></a>00287       
<a name="l00288"></a>00288     
<a name="l00289"></a>00289       <span class="comment">//ierr = PCCreate (libMesh::COMM_WORLD, &amp;_pc);</span>
<a name="l00290"></a>00290       <span class="comment">//     CHKERRABORT(libMesh::COMM_WORLD,ierr);</span>
<a name="l00291"></a>00291       
<a name="l00292"></a>00292       <span class="comment">// Create the preconditioner context</span>
<a name="l00293"></a>00293       ierr = KSPGetPC        (_ksp, &amp;_pc);
<a name="l00294"></a>00294              CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00295"></a>00295       
<a name="l00296"></a>00296       <span class="comment">// Set operators. The input matrix works as the preconditioning matrix</span>
<a name="l00297"></a>00297       ierr = KSPSetOperators(_ksp, matrix-&gt;<a class="code" href="classlibMesh_1_1PetscMatrix.php#aaca7a5afeb063716ee67fa11302c2aea">mat</a>(), matrix-&gt;<a class="code" href="classlibMesh_1_1PetscMatrix.php#aaca7a5afeb063716ee67fa11302c2aea">mat</a>(),SAME_NONZERO_PATTERN);
<a name="l00298"></a>00298              CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);       
<a name="l00299"></a>00299 
<a name="l00300"></a>00300       <span class="comment">// Set user-specified  solver and preconditioner types</span>
<a name="l00301"></a>00301       this-&gt;set_petsc_solver_type();
<a name="l00302"></a>00302 
<a name="l00303"></a>00303       <span class="comment">// Set the options from user-input</span>
<a name="l00304"></a>00304       <span class="comment">// Set runtime options, e.g.,</span>
<a name="l00305"></a>00305       <span class="comment">//      -ksp_type &lt;type&gt; -pc_type &lt;type&gt; -ksp_monitor -ksp_rtol &lt;rtol&gt;</span>
<a name="l00306"></a>00306       <span class="comment">//  These options will override those specified above as long as</span>
<a name="l00307"></a>00307       <span class="comment">//  KSPSetFromOptions() is called _after_ any other customization</span>
<a name="l00308"></a>00308       <span class="comment">//  routines.</span>
<a name="l00309"></a>00309       
<a name="l00310"></a>00310       ierr = KSPSetFromOptions (_ksp);
<a name="l00311"></a>00311       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00312"></a>00312 
<a name="l00313"></a>00313       <span class="comment">// Not sure if this is necessary, or if it is already handled by KSPSetFromOptions?</span>
<a name="l00314"></a>00314       <span class="comment">// NOT NECESSARY!!!!</span>
<a name="l00315"></a>00315       <span class="comment">//ierr = PCSetFromOptions (_pc);</span>
<a name="l00316"></a>00316       <span class="comment">//CHKERRABORT(libMesh::COMM_WORLD,ierr);</span>
<a name="l00317"></a>00317 
<a name="l00318"></a>00318                
<a name="l00319"></a>00319 <span class="preprocessor">#endif</span>
<a name="l00320"></a>00320 <span class="preprocessor"></span>             
<a name="l00321"></a>00321       <span class="comment">// Have the Krylov subspace method use our good initial guess</span>
<a name="l00322"></a>00322       <span class="comment">// rather than 0, unless the user requested a KSPType of</span>
<a name="l00323"></a>00323       <span class="comment">// preonly, which complains if asked to use initial guesses.</span>
<a name="l00324"></a>00324 <span class="preprocessor">#if PETSC_VERSION_LESS_THAN(3,0,0)</span>
<a name="l00325"></a>00325 <span class="preprocessor"></span>      KSPType ksp_type;
<a name="l00326"></a>00326 <span class="preprocessor">#else</span>
<a name="l00327"></a>00327 <span class="preprocessor"></span>      <span class="keyword">const</span> KSPType ksp_type;
<a name="l00328"></a>00328 <span class="preprocessor">#endif</span>
<a name="l00329"></a>00329 <span class="preprocessor"></span>
<a name="l00330"></a>00330       ierr = KSPGetType (_ksp, &amp;ksp_type);
<a name="l00331"></a>00331              CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00332"></a>00332 
<a name="l00333"></a>00333       <span class="keywordflow">if</span> (strcmp(ksp_type, <span class="stringliteral">&quot;preonly&quot;</span>))
<a name="l00334"></a>00334         {
<a name="l00335"></a>00335           ierr = KSPSetInitialGuessNonzero (_ksp, PETSC_TRUE);
<a name="l00336"></a>00336                  CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00337"></a>00337         }
<a name="l00338"></a>00338       
<a name="l00339"></a>00339       <span class="comment">// Notify PETSc of location to store residual history.</span>
<a name="l00340"></a>00340       <span class="comment">// This needs to be called before any solves, since</span>
<a name="l00341"></a>00341       <span class="comment">// it sets the residual history length to zero.  The default</span>
<a name="l00342"></a>00342       <span class="comment">// behavior is for PETSc to allocate (internally) an array</span>
<a name="l00343"></a>00343       <span class="comment">// of size 1000 to hold the residual norm history.</span>
<a name="l00344"></a>00344       ierr = KSPSetResidualHistory(_ksp,
<a name="l00345"></a>00345                                    PETSC_NULL,   <span class="comment">// pointer to the array which holds the history</span>
<a name="l00346"></a>00346                                    PETSC_DECIDE, <span class="comment">// size of the array holding the history</span>
<a name="l00347"></a>00347                                    PETSC_TRUE);  <span class="comment">// Whether or not to reset the history for each solve. </span>
<a name="l00348"></a>00348       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00349"></a>00349 
<a name="l00350"></a>00350       <a class="code" href="classlibMesh_1_1PetscPreconditioner.php#aab69801de7b38fc74cf110baa0bcde9b">PetscPreconditioner&lt;T&gt;::set_petsc_preconditioner_type</a>(this-&gt;_preconditioner_type,_pc);      
<a name="l00351"></a>00351       <span class="keywordflow">if</span>(this-&gt;_preconditioner)
<a name="l00352"></a>00352       {
<a name="l00353"></a>00353         this-&gt;_preconditioner-&gt;set_matrix(*matrix);
<a name="l00354"></a>00354         PCShellSetContext(_pc,(<span class="keywordtype">void</span>*)this-&gt;_preconditioner);
<a name="l00355"></a>00355         PCShellSetSetUp(_pc,<a class="code" href="namespacelibMesh.php#a0ad4171647357ca5a2ffacb1c8ca5c6a">__libmesh_petsc_preconditioner_setup</a>);
<a name="l00356"></a>00356         PCShellSetApply(_pc,<a class="code" href="namespacelibMesh.php#ae6c236ad49e5a5d8ad7f42d3f16b553e">__libmesh_petsc_preconditioner_apply</a>);
<a name="l00357"></a>00357       }
<a name="l00358"></a>00358     }
<a name="l00359"></a>00359 }
<a name="l00360"></a>00360 
<a name="l00361"></a>00361 
<a name="l00362"></a>00362 
<a name="l00363"></a>00363 
<a name="l00364"></a>00364 
<a name="l00365"></a>00365 
<a name="l00366"></a>00366 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00367"></a>00367 std::pair&lt;unsigned int, Real&gt; 
<a name="l00368"></a><a class="code" href="classlibMesh_1_1PetscLinearSolver.php#ab8db52e42db4bf42c4ccfa575a4e0632">00368</a> <a class="code" href="classlibMesh_1_1PetscLinearSolver.php#adcb5c8a344e2fd9ab1c9a39ff560d087">PetscLinearSolver&lt;T&gt;::solve</a> (<a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;T&gt;</a>&amp;  matrix_in,
<a name="l00369"></a>00369                              <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;T&gt;</a>&amp;  precond_in,
<a name="l00370"></a>00370                              <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; solution_in,
<a name="l00371"></a>00371                              <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; rhs_in,
<a name="l00372"></a>00372                              <span class="keyword">const</span> <span class="keywordtype">double</span> tol,
<a name="l00373"></a>00373                              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_its)
<a name="l00374"></a>00374 {
<a name="l00375"></a>00375   START_LOG(<span class="stringliteral">&quot;solve()&quot;</span>, <span class="stringliteral">&quot;PetscLinearSolver&quot;</span>);
<a name="l00376"></a>00376   
<a name="l00377"></a>00377   <span class="comment">// Make sure the data passed in are really of Petsc types</span>
<a name="l00378"></a>00378   <a class="code" href="classlibMesh_1_1PetscMatrix.php">PetscMatrix&lt;T&gt;</a>* matrix   = libmesh_cast_ptr&lt;PetscMatrix&lt;T&gt;*&gt;(&amp;matrix_in);
<a name="l00379"></a>00379   <a class="code" href="classlibMesh_1_1PetscMatrix.php">PetscMatrix&lt;T&gt;</a>* precond  = libmesh_cast_ptr&lt;PetscMatrix&lt;T&gt;*&gt;(&amp;precond_in);
<a name="l00380"></a>00380   <a class="code" href="classlibMesh_1_1PetscVector.php">PetscVector&lt;T&gt;</a>* solution = libmesh_cast_ptr&lt;PetscVector&lt;T&gt;*&gt;(&amp;solution_in);
<a name="l00381"></a>00381   <a class="code" href="classlibMesh_1_1PetscVector.php">PetscVector&lt;T&gt;</a>* rhs      = libmesh_cast_ptr&lt;PetscVector&lt;T&gt;*&gt;(&amp;rhs_in);
<a name="l00382"></a>00382 
<a name="l00383"></a>00383   this-&gt;<a class="code" href="namespacelibMesh.php#a74975b21077cce916d7b3e22ad49290c">init</a> (matrix);
<a name="l00384"></a>00384 
<a name="l00385"></a>00385   <span class="keywordtype">int</span> ierr=0;
<a name="l00386"></a>00386   <span class="keywordtype">int</span> its=0, max_its = <span class="keyword">static_cast&lt;</span><span class="keywordtype">int</span><span class="keyword">&gt;</span>(m_its);
<a name="l00387"></a>00387   PetscReal final_resid=0.;
<a name="l00388"></a>00388 
<a name="l00389"></a>00389   <span class="comment">// Close the matrices and vectors in case this wasn&#39;t already done.</span>
<a name="l00390"></a>00390   matrix-&gt;<a class="code" href="classlibMesh_1_1PetscMatrix.php#ab8835ee5e4160b1345fab9dbca26b52b">close</a> ();
<a name="l00391"></a>00391   precond-&gt;close ();
<a name="l00392"></a>00392   solution-&gt;close ();
<a name="l00393"></a>00393   rhs-&gt;close ();
<a name="l00394"></a>00394 
<a name="l00395"></a>00395 <span class="comment">//   // If matrix != precond, then this means we have specified a</span>
<a name="l00396"></a>00396 <span class="comment">//   // special preconditioner, so reset preconditioner type to PCMAT.</span>
<a name="l00397"></a>00397 <span class="comment">//   if (matrix != precond)</span>
<a name="l00398"></a>00398 <span class="comment">//     {</span>
<a name="l00399"></a>00399 <span class="comment">//       this-&gt;_preconditioner_type = USER_PRECOND;</span>
<a name="l00400"></a>00400 <span class="comment">//       this-&gt;set_petsc_preconditioner_type ();</span>
<a name="l00401"></a>00401 <span class="comment">//     }</span>
<a name="l00402"></a>00402 
<a name="l00403"></a>00403   <span class="keywordflow">if</span>(this-&gt;_preconditioner)
<a name="l00404"></a>00404     this-&gt;_preconditioner-&gt;set_matrix(matrix_in);
<a name="l00405"></a>00405 
<a name="l00406"></a>00406   
<a name="l00407"></a>00407 <span class="comment">// 2.1.x &amp; earlier style      </span>
<a name="l00408"></a>00408 <span class="preprocessor">#if PETSC_VERSION_LESS_THAN(2,2,0)</span>
<a name="l00409"></a>00409 <span class="preprocessor"></span>      
<a name="l00410"></a>00410   <span class="comment">// Set operators. The input matrix works as the preconditioning matrix</span>
<a name="l00411"></a>00411   ierr = SLESSetOperators(_sles, matrix-&gt;<a class="code" href="classlibMesh_1_1PetscMatrix.php#aaca7a5afeb063716ee67fa11302c2aea">mat</a>(), precond-&gt;mat(),
<a name="l00412"></a>00412                           SAME_NONZERO_PATTERN);
<a name="l00413"></a>00413          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00414"></a>00414 
<a name="l00415"></a>00415   <span class="comment">// Set the tolerances for the iterative solver.  Use the user-supplied</span>
<a name="l00416"></a>00416   <span class="comment">// tolerance for the relative residual &amp; leave the others at default values.</span>
<a name="l00417"></a>00417   ierr = KSPSetTolerances (_ksp, tol, PETSC_DEFAULT,
<a name="l00418"></a>00418                            PETSC_DEFAULT, max_its);
<a name="l00419"></a>00419          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00420"></a>00420 
<a name="l00421"></a>00421 
<a name="l00422"></a>00422   <span class="comment">// Solve the linear system</span>
<a name="l00423"></a>00423   ierr = SLESSolve (_sles, rhs-&gt;vec(), solution-&gt;vec(), &amp;its);
<a name="l00424"></a>00424          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00425"></a>00425 
<a name="l00426"></a>00426 
<a name="l00427"></a>00427   <span class="comment">// Get the norm of the final residual to return to the user.</span>
<a name="l00428"></a>00428   ierr = KSPGetResidualNorm (_ksp, &amp;final_resid);
<a name="l00429"></a>00429          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00430"></a>00430 
<a name="l00431"></a>00431 <span class="comment">// 2.2.0</span>
<a name="l00432"></a>00432 <span class="preprocessor">#elif PETSC_VERSION_LESS_THAN(2,2,1)</span>
<a name="l00433"></a>00433 <span class="preprocessor"></span>      
<a name="l00434"></a>00434   <span class="comment">// Set operators. The input matrix works as the preconditioning matrix</span>
<a name="l00435"></a>00435   <span class="comment">//ierr = KSPSetOperators(_ksp, matrix-&gt;mat(), precond-&gt;mat(),</span>
<a name="l00436"></a>00436          <span class="comment">//                      SAME_NONZERO_PATTERN);</span>
<a name="l00437"></a>00437          <span class="comment">//       CHKERRABORT(libMesh::COMM_WORLD,ierr);</span>
<a name="l00438"></a>00438 
<a name="l00439"></a>00439 
<a name="l00440"></a>00440   <span class="comment">// Set the tolerances for the iterative solver.  Use the user-supplied</span>
<a name="l00441"></a>00441   <span class="comment">// tolerance for the relative residual &amp; leave the others at default values.</span>
<a name="l00442"></a>00442   <span class="comment">// Convergence is detected at iteration k if</span>
<a name="l00443"></a>00443   <span class="comment">// ||r_k||_2 &lt; max(rtol*||b||_2 , abstol)</span>
<a name="l00444"></a>00444   <span class="comment">// where r_k is the residual vector and b is the right-hand side.  Note that</span>
<a name="l00445"></a>00445   <span class="comment">// it is the *maximum* of the two values, the larger of which will almost</span>
<a name="l00446"></a>00446   <span class="comment">// always be rtol*||b||_2. </span>
<a name="l00447"></a>00447   ierr = KSPSetTolerances (_ksp,
<a name="l00448"></a>00448                            tol,           <span class="comment">// rtol   = relative decrease in residual  (1.e-5)</span>
<a name="l00449"></a>00449                            PETSC_DEFAULT, <span class="comment">// abstol = absolute convergence tolerance (1.e-50)</span>
<a name="l00450"></a>00450                            PETSC_DEFAULT, <span class="comment">// dtol   = divergence tolerance           (1.e+5)</span>
<a name="l00451"></a>00451                            max_its);
<a name="l00452"></a>00452          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00453"></a>00453 
<a name="l00454"></a>00454 
<a name="l00455"></a>00455   <span class="comment">// Set the solution vector to use</span>
<a name="l00456"></a>00456   ierr = KSPSetSolution (_ksp, solution-&gt;vec());
<a name="l00457"></a>00457          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00458"></a>00458          
<a name="l00459"></a>00459   <span class="comment">// Set the RHS vector to use</span>
<a name="l00460"></a>00460   ierr = KSPSetRhs (_ksp, rhs-&gt;vec());
<a name="l00461"></a>00461          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00462"></a>00462    
<a name="l00463"></a>00463   <span class="comment">// Solve the linear system</span>
<a name="l00464"></a>00464   ierr = KSPSolve (_ksp);
<a name="l00465"></a>00465          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00466"></a>00466          
<a name="l00467"></a>00467   <span class="comment">// Get the number of iterations required for convergence</span>
<a name="l00468"></a>00468   ierr = KSPGetIterationNumber (_ksp, &amp;its);
<a name="l00469"></a>00469          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00470"></a>00470          
<a name="l00471"></a>00471   <span class="comment">// Get the norm of the final residual to return to the user.</span>
<a name="l00472"></a>00472   ierr = KSPGetResidualNorm (_ksp, &amp;final_resid);
<a name="l00473"></a>00473          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00474"></a>00474          
<a name="l00475"></a>00475 <span class="comment">// 2.2.1 &amp; newer style</span>
<a name="l00476"></a>00476 <span class="preprocessor">#else</span>
<a name="l00477"></a>00477 <span class="preprocessor"></span>      
<a name="l00478"></a>00478   <span class="comment">// Set operators. The input matrix works as the preconditioning matrix</span>
<a name="l00479"></a>00479   <span class="keywordflow">if</span>(!this-&gt;same_preconditioner)
<a name="l00480"></a>00480   {
<a name="l00481"></a>00481     ierr = KSPSetOperators(_ksp, matrix-&gt;<a class="code" href="classlibMesh_1_1PetscMatrix.php#aaca7a5afeb063716ee67fa11302c2aea">mat</a>(), precond-&gt;mat(),
<a name="l00482"></a>00482                            SAME_NONZERO_PATTERN);
<a name="l00483"></a>00483            CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00484"></a>00484   }
<a name="l00485"></a>00485   <span class="keywordflow">else</span>
<a name="l00486"></a>00486   {
<a name="l00487"></a>00487     ierr = KSPSetOperators(_ksp, matrix-&gt;<a class="code" href="classlibMesh_1_1PetscMatrix.php#aaca7a5afeb063716ee67fa11302c2aea">mat</a>(), precond-&gt;mat(),
<a name="l00488"></a>00488                SAME_PRECONDITIONER);
<a name="l00489"></a>00489            CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00490"></a>00490   }
<a name="l00491"></a>00491 
<a name="l00492"></a>00492   <span class="comment">// Set the tolerances for the iterative solver.  Use the user-supplied</span>
<a name="l00493"></a>00493   <span class="comment">// tolerance for the relative residual &amp; leave the others at default values.</span>
<a name="l00494"></a>00494   ierr = KSPSetTolerances (_ksp, tol, PETSC_DEFAULT,
<a name="l00495"></a>00495                            PETSC_DEFAULT, max_its);
<a name="l00496"></a>00496          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00497"></a>00497 
<a name="l00498"></a>00498   <span class="comment">// Solve the linear system</span>
<a name="l00499"></a>00499   ierr = KSPSolve (_ksp, rhs-&gt;vec(), solution-&gt;vec());
<a name="l00500"></a>00500          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00501"></a>00501          
<a name="l00502"></a>00502   <span class="comment">// Get the number of iterations required for convergence</span>
<a name="l00503"></a>00503   ierr = KSPGetIterationNumber (_ksp, &amp;its);
<a name="l00504"></a>00504          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00505"></a>00505          
<a name="l00506"></a>00506   <span class="comment">// Get the norm of the final residual to return to the user.</span>
<a name="l00507"></a>00507   ierr = KSPGetResidualNorm (_ksp, &amp;final_resid);
<a name="l00508"></a>00508          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00509"></a>00509          
<a name="l00510"></a>00510 <span class="preprocessor">#endif</span>
<a name="l00511"></a>00511 <span class="preprocessor"></span>
<a name="l00512"></a>00512   STOP_LOG(<span class="stringliteral">&quot;solve()&quot;</span>, <span class="stringliteral">&quot;PetscLinearSolver&quot;</span>);
<a name="l00513"></a>00513   <span class="comment">// return the # of its. and the final residual norm.</span>
<a name="l00514"></a>00514   <span class="keywordflow">return</span> std::make_pair(its, final_resid);
<a name="l00515"></a>00515 }
<a name="l00516"></a>00516 
<a name="l00517"></a>00517 
<a name="l00518"></a>00518 
<a name="l00519"></a>00519 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00520"></a>00520 std::pair&lt;unsigned int, Real&gt; 
<a name="l00521"></a><a class="code" href="classlibMesh_1_1PetscLinearSolver.php#ab5036322d3115ada26fe626164c08153">00521</a> <a class="code" href="classlibMesh_1_1PetscLinearSolver.php#adcb5c8a344e2fd9ab1c9a39ff560d087">PetscLinearSolver&lt;T&gt;::solve</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ShellMatrix.php">ShellMatrix&lt;T&gt;</a>&amp; shell_matrix,
<a name="l00522"></a>00522                              <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; solution_in,
<a name="l00523"></a>00523                              <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; rhs_in,
<a name="l00524"></a>00524                              <span class="keyword">const</span> <span class="keywordtype">double</span> tol,
<a name="l00525"></a>00525                              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_its)
<a name="l00526"></a>00526 {
<a name="l00527"></a>00527 
<a name="l00528"></a>00528 <span class="preprocessor">#if PETSC_VERSION_LESS_THAN(2,3,1)</span>
<a name="l00529"></a>00529 <span class="preprocessor"></span>  <span class="comment">// FIXME[JWP]: There will be a bunch of unused variable warnings</span>
<a name="l00530"></a>00530   <span class="comment">// for older PETScs here.</span>
<a name="l00531"></a>00531   <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;This method has been developed with PETSc 2.3.1.  &quot;</span>
<a name="l00532"></a>00532                 &lt;&lt; <span class="stringliteral">&quot;No one has made it backwards compatible with older &quot;</span>
<a name="l00533"></a>00533                 &lt;&lt; <span class="stringliteral">&quot;versions of PETSc so far; however, it might work &quot;</span>
<a name="l00534"></a>00534                 &lt;&lt; <span class="stringliteral">&quot;without any change with some older version.&quot;</span> &lt;&lt; std::endl;
<a name="l00535"></a>00535   libmesh_error();
<a name="l00536"></a>00536   <span class="keywordflow">return</span> std::make_pair(0,0.0);
<a name="l00537"></a>00537 
<a name="l00538"></a>00538 <span class="preprocessor">#else</span>
<a name="l00539"></a>00539 <span class="preprocessor"></span>
<a name="l00540"></a>00540   START_LOG(<span class="stringliteral">&quot;solve()&quot;</span>, <span class="stringliteral">&quot;PetscLinearSolver&quot;</span>);
<a name="l00541"></a>00541 
<a name="l00542"></a>00542   <span class="comment">// Make sure the data passed in are really of Petsc types</span>
<a name="l00543"></a>00543   <a class="code" href="classlibMesh_1_1PetscVector.php">PetscVector&lt;T&gt;</a>* solution = libmesh_cast_ptr&lt;PetscVector&lt;T&gt;*&gt;(&amp;solution_in);
<a name="l00544"></a>00544   <a class="code" href="classlibMesh_1_1PetscVector.php">PetscVector&lt;T&gt;</a>* rhs      = libmesh_cast_ptr&lt;PetscVector&lt;T&gt;*&gt;(&amp;rhs_in);
<a name="l00545"></a>00545 
<a name="l00546"></a>00546   this-&gt;<a class="code" href="namespacelibMesh.php#a74975b21077cce916d7b3e22ad49290c">init</a> ();
<a name="l00547"></a>00547 
<a name="l00548"></a>00548   <span class="keywordtype">int</span> ierr=0;
<a name="l00549"></a>00549   <span class="keywordtype">int</span> its=0, max_its = <span class="keyword">static_cast&lt;</span><span class="keywordtype">int</span><span class="keyword">&gt;</span>(m_its);
<a name="l00550"></a>00550   PetscReal final_resid=0.;
<a name="l00551"></a>00551 
<a name="l00552"></a>00552   <span class="comment">// Close the matrices and vectors in case this wasn&#39;t already done.</span>
<a name="l00553"></a>00553   solution-&gt;<a class="code" href="classlibMesh_1_1PetscVector.php#a0285829baf6ad79ddc9d4e071f5654d6">close</a> ();
<a name="l00554"></a>00554   rhs-&gt;close ();
<a name="l00555"></a>00555 
<a name="l00556"></a>00556   <span class="comment">// Prepare the matrix.</span>
<a name="l00557"></a>00557   Mat mat;
<a name="l00558"></a>00558   ierr = MatCreateShell(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,
<a name="l00559"></a>00559                         rhs_in.<a class="code" href="classlibMesh_1_1NumericVector.php#a6cc4358896c079e301a815a4ff4459eb">local_size</a>(),
<a name="l00560"></a>00560                         solution_in.<a class="code" href="classlibMesh_1_1NumericVector.php#a6cc4358896c079e301a815a4ff4459eb">local_size</a>(),
<a name="l00561"></a>00561                         rhs_in.<a class="code" href="classlibMesh_1_1NumericVector.php#a86082d6030cb32700e7eeac6e7f26455">size</a>(),
<a name="l00562"></a>00562                         solution_in.<a class="code" href="classlibMesh_1_1NumericVector.php#a86082d6030cb32700e7eeac6e7f26455">size</a>(),
<a name="l00563"></a>00563                         <span class="keyword">const_cast&lt;</span><span class="keywordtype">void</span>*<span class="keyword">&gt;</span>(<span class="keyword">static_cast&lt;</span><span class="keyword">const </span><span class="keywordtype">void</span>*<span class="keyword">&gt;</span>(&amp;shell_matrix)),
<a name="l00564"></a>00564                         &amp;mat);
<a name="l00565"></a>00565   <span class="comment">/* Note that the const_cast above is only necessary because PETSc</span>
<a name="l00566"></a>00566 <span class="comment">     does not accept a const void*.  Inside the member function</span>
<a name="l00567"></a>00567 <span class="comment">     _petsc_shell_matrix() below, the pointer is casted back to a</span>
<a name="l00568"></a>00568 <span class="comment">     const ShellMatrix&lt;T&gt;*.  */</span>
<a name="l00569"></a>00569 
<a name="l00570"></a>00570   CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00571"></a>00571   ierr = MatShellSetOperation(mat,MATOP_MULT,<span class="keyword">reinterpret_cast&lt;</span><span class="keywordtype">void</span>(*)(<span class="keywordtype">void</span>)<span class="keyword">&gt;</span>(_petsc_shell_matrix_mult));
<a name="l00572"></a>00572   ierr = MatShellSetOperation(mat,MATOP_GET_DIAGONAL,<span class="keyword">reinterpret_cast&lt;</span><span class="keywordtype">void</span>(*)(<span class="keywordtype">void</span>)<span class="keyword">&gt;</span>(_petsc_shell_matrix_get_diagonal));
<a name="l00573"></a>00573   CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00574"></a>00574 
<a name="l00575"></a>00575   <span class="comment">// Set operators. The input matrix works as the preconditioning matrix</span>
<a name="l00576"></a>00576   ierr = KSPSetOperators(_ksp, mat, mat,
<a name="l00577"></a>00577                          SAME_NONZERO_PATTERN);
<a name="l00578"></a>00578   CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00579"></a>00579 
<a name="l00580"></a>00580   <span class="comment">// Set the tolerances for the iterative solver.  Use the user-supplied</span>
<a name="l00581"></a>00581   <span class="comment">// tolerance for the relative residual &amp; leave the others at default values.</span>
<a name="l00582"></a>00582   ierr = KSPSetTolerances (_ksp, tol, PETSC_DEFAULT,
<a name="l00583"></a>00583                            PETSC_DEFAULT, max_its);
<a name="l00584"></a>00584   CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00585"></a>00585 
<a name="l00586"></a>00586   <span class="comment">// Solve the linear system</span>
<a name="l00587"></a>00587   ierr = KSPSolve (_ksp, rhs-&gt;vec(), solution-&gt;<a class="code" href="classlibMesh_1_1PetscVector.php#ada434b1090f88c405ad6d0294646a400">vec</a>());
<a name="l00588"></a>00588   CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00589"></a>00589          
<a name="l00590"></a>00590   <span class="comment">// Get the number of iterations required for convergence</span>
<a name="l00591"></a>00591   ierr = KSPGetIterationNumber (_ksp, &amp;its);
<a name="l00592"></a>00592   CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00593"></a>00593          
<a name="l00594"></a>00594   <span class="comment">// Get the norm of the final residual to return to the user.</span>
<a name="l00595"></a>00595   ierr = KSPGetResidualNorm (_ksp, &amp;final_resid);
<a name="l00596"></a>00596   CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00597"></a>00597 
<a name="l00598"></a>00598   <span class="comment">// Destroy the matrix.</span>
<a name="l00599"></a>00599   ierr = MatDestroy(mat);
<a name="l00600"></a>00600   CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00601"></a>00601          
<a name="l00602"></a>00602   STOP_LOG(<span class="stringliteral">&quot;solve()&quot;</span>, <span class="stringliteral">&quot;PetscLinearSolver&quot;</span>);
<a name="l00603"></a>00603   <span class="comment">// return the # of its. and the final residual norm.</span>
<a name="l00604"></a>00604   <span class="keywordflow">return</span> std::make_pair(its, final_resid);
<a name="l00605"></a>00605 
<a name="l00606"></a>00606 <span class="preprocessor">#endif</span>
<a name="l00607"></a>00607 <span class="preprocessor"></span>
<a name="l00608"></a>00608 }
<a name="l00609"></a>00609 
<a name="l00610"></a>00610 
<a name="l00611"></a>00611 
<a name="l00612"></a>00612 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00613"></a>00613 std::pair&lt;unsigned int, Real&gt; 
<a name="l00614"></a><a class="code" href="classlibMesh_1_1PetscLinearSolver.php#a601877cb3f2df95ddfb917d6f16ff2d3">00614</a> <a class="code" href="classlibMesh_1_1PetscLinearSolver.php#adcb5c8a344e2fd9ab1c9a39ff560d087">PetscLinearSolver&lt;T&gt;::solve</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ShellMatrix.php">ShellMatrix&lt;T&gt;</a>&amp; shell_matrix,
<a name="l00615"></a>00615                              <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;T&gt;</a>&amp; precond_matrix,
<a name="l00616"></a>00616                              <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp;solution_in,
<a name="l00617"></a>00617                              <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp;rhs_in,
<a name="l00618"></a>00618                              <span class="keyword">const</span> <span class="keywordtype">double</span> tol,
<a name="l00619"></a>00619                              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_its)
<a name="l00620"></a>00620 {
<a name="l00621"></a>00621 
<a name="l00622"></a>00622 <span class="preprocessor">#if PETSC_VERSION_LESS_THAN(2,3,1)</span>
<a name="l00623"></a>00623 <span class="preprocessor"></span>  <span class="comment">// FIXME[JWP]: There will be a bunch of unused variable warnings</span>
<a name="l00624"></a>00624   <span class="comment">// for older PETScs here.</span>
<a name="l00625"></a>00625   <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;This method has been developed with PETSc 2.3.1.  &quot;</span>
<a name="l00626"></a>00626                 &lt;&lt; <span class="stringliteral">&quot;No one has made it backwards compatible with older &quot;</span>
<a name="l00627"></a>00627                 &lt;&lt; <span class="stringliteral">&quot;versions of PETSc so far; however, it might work &quot;</span>
<a name="l00628"></a>00628                 &lt;&lt; <span class="stringliteral">&quot;without any change with some older version.&quot;</span> &lt;&lt; std::endl;
<a name="l00629"></a>00629   libmesh_error();
<a name="l00630"></a>00630   <span class="keywordflow">return</span> std::make_pair(0,0.0);
<a name="l00631"></a>00631 
<a name="l00632"></a>00632 <span class="preprocessor">#else</span>
<a name="l00633"></a>00633 <span class="preprocessor"></span>
<a name="l00634"></a>00634   START_LOG(<span class="stringliteral">&quot;solve()&quot;</span>, <span class="stringliteral">&quot;PetscLinearSolver&quot;</span>);
<a name="l00635"></a>00635 
<a name="l00636"></a>00636   <span class="comment">// Make sure the data passed in are really of Petsc types</span>
<a name="l00637"></a>00637   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1PetscMatrix.php">PetscMatrix&lt;T&gt;</a>* precond  = libmesh_cast_ptr&lt;const PetscMatrix&lt;T&gt;*&gt;(&amp;precond_matrix);
<a name="l00638"></a>00638   <a class="code" href="classlibMesh_1_1PetscVector.php">PetscVector&lt;T&gt;</a>* solution = libmesh_cast_ptr&lt;PetscVector&lt;T&gt;*&gt;(&amp;solution_in);
<a name="l00639"></a>00639   <a class="code" href="classlibMesh_1_1PetscVector.php">PetscVector&lt;T&gt;</a>* rhs      = libmesh_cast_ptr&lt;PetscVector&lt;T&gt;*&gt;(&amp;rhs_in);
<a name="l00640"></a>00640 
<a name="l00641"></a>00641   this-&gt;<a class="code" href="namespacelibMesh.php#a74975b21077cce916d7b3e22ad49290c">init</a> ();
<a name="l00642"></a>00642 
<a name="l00643"></a>00643   <span class="keywordtype">int</span> ierr=0;
<a name="l00644"></a>00644   <span class="keywordtype">int</span> its=0, max_its = <span class="keyword">static_cast&lt;</span><span class="keywordtype">int</span><span class="keyword">&gt;</span>(m_its);
<a name="l00645"></a>00645   PetscReal final_resid=0.;
<a name="l00646"></a>00646 
<a name="l00647"></a>00647   <span class="comment">// Close the matrices and vectors in case this wasn&#39;t already done.</span>
<a name="l00648"></a>00648   solution-&gt;close ();
<a name="l00649"></a>00649   rhs-&gt;close ();
<a name="l00650"></a>00650 
<a name="l00651"></a>00651   <span class="comment">// Prepare the matrix.</span>
<a name="l00652"></a>00652   Mat mat;
<a name="l00653"></a>00653   ierr = MatCreateShell(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,
<a name="l00654"></a>00654                         rhs_in.<a class="code" href="classlibMesh_1_1NumericVector.php#a6cc4358896c079e301a815a4ff4459eb">local_size</a>(),
<a name="l00655"></a>00655                         solution_in.<a class="code" href="classlibMesh_1_1NumericVector.php#a6cc4358896c079e301a815a4ff4459eb">local_size</a>(),
<a name="l00656"></a>00656                         rhs_in.<a class="code" href="classlibMesh_1_1NumericVector.php#a86082d6030cb32700e7eeac6e7f26455">size</a>(),
<a name="l00657"></a>00657                         solution_in.<a class="code" href="classlibMesh_1_1NumericVector.php#a86082d6030cb32700e7eeac6e7f26455">size</a>(),
<a name="l00658"></a>00658                         <span class="keyword">const_cast&lt;</span><span class="keywordtype">void</span>*<span class="keyword">&gt;</span>(<span class="keyword">static_cast&lt;</span><span class="keyword">const </span><span class="keywordtype">void</span>*<span class="keyword">&gt;</span>(&amp;shell_matrix)),
<a name="l00659"></a>00659                         &amp;mat);
<a name="l00660"></a>00660   <span class="comment">/* Note that the const_cast above is only necessary because PETSc</span>
<a name="l00661"></a>00661 <span class="comment">     does not accept a const void*.  Inside the member function</span>
<a name="l00662"></a>00662 <span class="comment">     _petsc_shell_matrix() below, the pointer is casted back to a</span>
<a name="l00663"></a>00663 <span class="comment">     const ShellMatrix&lt;T&gt;*.  */</span>
<a name="l00664"></a>00664 
<a name="l00665"></a>00665   CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00666"></a>00666   ierr = MatShellSetOperation(mat,MATOP_MULT,<span class="keyword">reinterpret_cast&lt;</span><span class="keywordtype">void</span>(*)(<span class="keywordtype">void</span>)<span class="keyword">&gt;</span>(_petsc_shell_matrix_mult));
<a name="l00667"></a>00667   ierr = MatShellSetOperation(mat,MATOP_GET_DIAGONAL,<span class="keyword">reinterpret_cast&lt;</span><span class="keywordtype">void</span>(*)(<span class="keywordtype">void</span>)<span class="keyword">&gt;</span>(_petsc_shell_matrix_get_diagonal));
<a name="l00668"></a>00668   CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00669"></a>00669 
<a name="l00670"></a>00670   <span class="comment">// Set operators. The input matrix works as the preconditioning matrix</span>
<a name="l00671"></a>00671   ierr = KSPSetOperators(_ksp, mat, <span class="keyword">const_cast&lt;</span><a class="code" href="classlibMesh_1_1PetscMatrix.php">PetscMatrix&lt;T&gt;</a>*<span class="keyword">&gt;</span>(precond)-&gt;mat(),
<a name="l00672"></a>00672                          DIFFERENT_NONZERO_PATTERN);
<a name="l00673"></a>00673   CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00674"></a>00674 
<a name="l00675"></a>00675   <span class="keywordflow">if</span>(this-&gt;_preconditioner)
<a name="l00676"></a>00676     this-&gt;_preconditioner-&gt;set_matrix(<span class="keyword">const_cast&lt;</span><a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;Number&gt;</a>&amp;<span class="keyword">&gt;</span>(precond_matrix));
<a name="l00677"></a>00677 
<a name="l00678"></a>00678   <span class="comment">// Set the tolerances for the iterative solver.  Use the user-supplied</span>
<a name="l00679"></a>00679   <span class="comment">// tolerance for the relative residual &amp; leave the others at default values.</span>
<a name="l00680"></a>00680   ierr = KSPSetTolerances (_ksp, tol, PETSC_DEFAULT,
<a name="l00681"></a>00681                            PETSC_DEFAULT, max_its);
<a name="l00682"></a>00682   CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00683"></a>00683 
<a name="l00684"></a>00684   <span class="comment">// Solve the linear system</span>
<a name="l00685"></a>00685   ierr = KSPSolve (_ksp, rhs-&gt;vec(), solution-&gt;vec());
<a name="l00686"></a>00686   CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00687"></a>00687          
<a name="l00688"></a>00688   <span class="comment">// Get the number of iterations required for convergence</span>
<a name="l00689"></a>00689   ierr = KSPGetIterationNumber (_ksp, &amp;its);
<a name="l00690"></a>00690   CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00691"></a>00691          
<a name="l00692"></a>00692   <span class="comment">// Get the norm of the final residual to return to the user.</span>
<a name="l00693"></a>00693   ierr = KSPGetResidualNorm (_ksp, &amp;final_resid);
<a name="l00694"></a>00694   CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00695"></a>00695 
<a name="l00696"></a>00696   <span class="comment">// Destroy the matrix.</span>
<a name="l00697"></a>00697   ierr = MatDestroy(mat);
<a name="l00698"></a>00698   CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00699"></a>00699          
<a name="l00700"></a>00700   STOP_LOG(<span class="stringliteral">&quot;solve()&quot;</span>, <span class="stringliteral">&quot;PetscLinearSolver&quot;</span>);
<a name="l00701"></a>00701   <span class="comment">// return the # of its. and the final residual norm.</span>
<a name="l00702"></a>00702   <span class="keywordflow">return</span> std::make_pair(its, final_resid);
<a name="l00703"></a>00703 
<a name="l00704"></a>00704 <span class="preprocessor">#endif</span>
<a name="l00705"></a>00705 <span class="preprocessor"></span>
<a name="l00706"></a>00706 }
<a name="l00707"></a>00707 
<a name="l00708"></a>00708 
<a name="l00709"></a>00709 
<a name="l00710"></a>00710 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00711"></a><a class="code" href="classlibMesh_1_1PetscLinearSolver.php#a1d8c73be13b0e349132fbd2f1a7e0efc">00711</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscLinearSolver.php#a1d8c73be13b0e349132fbd2f1a7e0efc">PetscLinearSolver&lt;T&gt;::get_residual_history</a>(std::vector&lt;double&gt;&amp; hist)
<a name="l00712"></a>00712 {
<a name="l00713"></a>00713   <span class="keywordtype">int</span> ierr = 0;
<a name="l00714"></a>00714   <span class="keywordtype">int</span> its  = 0;
<a name="l00715"></a>00715 
<a name="l00716"></a>00716   <span class="comment">// Fill the residual history vector with the residual norms</span>
<a name="l00717"></a>00717   <span class="comment">// Note that GetResidualHistory() does not copy any values, it</span>
<a name="l00718"></a>00718   <span class="comment">// simply sets the pointer p.  Note that for some Krylov subspace</span>
<a name="l00719"></a>00719   <span class="comment">// methods, the number of residuals returned in the history</span>
<a name="l00720"></a>00720   <span class="comment">// vector may be different from what you are expecting.  For</span>
<a name="l00721"></a>00721   <span class="comment">// example, TFQMR returns two residual values per iteration step.</span>
<a name="l00722"></a>00722   PetscReal* p;
<a name="l00723"></a>00723   ierr = KSPGetResidualHistory(_ksp, &amp;p, &amp;its);
<a name="l00724"></a>00724   CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00725"></a>00725 
<a name="l00726"></a>00726   <span class="comment">// Check for early return</span>
<a name="l00727"></a>00727   <span class="keywordflow">if</span> (its == 0) <span class="keywordflow">return</span>;
<a name="l00728"></a>00728   
<a name="l00729"></a>00729   <span class="comment">// Create space to store the result</span>
<a name="l00730"></a>00730   hist.resize(its);
<a name="l00731"></a>00731 
<a name="l00732"></a>00732   <span class="comment">// Copy history into the vector provided by the user.</span>
<a name="l00733"></a>00733   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0; i&lt;its; ++i)
<a name="l00734"></a>00734     {
<a name="l00735"></a>00735       hist[i] = *p;
<a name="l00736"></a>00736       p++;
<a name="l00737"></a>00737     }
<a name="l00738"></a>00738 }
<a name="l00739"></a>00739 
<a name="l00740"></a>00740 
<a name="l00741"></a>00741 
<a name="l00742"></a>00742 
<a name="l00743"></a>00743 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00744"></a><a class="code" href="classlibMesh_1_1PetscLinearSolver.php#a37641e5e49a89c36098322f1e5b1f0d8">00744</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1PetscLinearSolver.php#a37641e5e49a89c36098322f1e5b1f0d8">PetscLinearSolver&lt;T&gt;::get_initial_residual</a>()
<a name="l00745"></a>00745 {
<a name="l00746"></a>00746   <span class="keywordtype">int</span> ierr = 0;
<a name="l00747"></a>00747   <span class="keywordtype">int</span> its  = 0;
<a name="l00748"></a>00748 
<a name="l00749"></a>00749   <span class="comment">// Fill the residual history vector with the residual norms</span>
<a name="l00750"></a>00750   <span class="comment">// Note that GetResidualHistory() does not copy any values, it</span>
<a name="l00751"></a>00751   <span class="comment">// simply sets the pointer p.  Note that for some Krylov subspace</span>
<a name="l00752"></a>00752   <span class="comment">// methods, the number of residuals returned in the history</span>
<a name="l00753"></a>00753   <span class="comment">// vector may be different from what you are expecting.  For</span>
<a name="l00754"></a>00754   <span class="comment">// example, TFQMR returns two residual values per iteration step.</span>
<a name="l00755"></a>00755   PetscReal* p;
<a name="l00756"></a>00756   ierr = KSPGetResidualHistory(_ksp, &amp;p, &amp;its);
<a name="l00757"></a>00757   CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00758"></a>00758 
<a name="l00759"></a>00759   <span class="comment">// Check no residual history</span>
<a name="l00760"></a>00760   <span class="keywordflow">if</span> (its == 0)
<a name="l00761"></a>00761     {
<a name="l00762"></a>00762       <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;No iterations have been performed, returning 0.&quot;</span> &lt;&lt; std::endl;
<a name="l00763"></a>00763       <span class="keywordflow">return</span> 0.;
<a name="l00764"></a>00764     }
<a name="l00765"></a>00765 
<a name="l00766"></a>00766   <span class="comment">// Otherwise, return the value pointed to by p.</span>
<a name="l00767"></a>00767   <span class="keywordflow">return</span> *p;
<a name="l00768"></a>00768 }
<a name="l00769"></a>00769 
<a name="l00770"></a>00770 
<a name="l00771"></a>00771 
<a name="l00772"></a>00772 
<a name="l00773"></a>00773 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00774"></a><a class="code" href="classlibMesh_1_1PetscLinearSolver.php#a7ba2130af69add0da3a7526c79095090">00774</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscLinearSolver.php#a7ba2130af69add0da3a7526c79095090">PetscLinearSolver&lt;T&gt;::set_petsc_solver_type</a>()
<a name="l00775"></a>00775 {
<a name="l00776"></a>00776   <span class="keywordtype">int</span> ierr = 0;
<a name="l00777"></a>00777   
<a name="l00778"></a>00778   <span class="keywordflow">switch</span> (this-&gt;_solver_type)
<a name="l00779"></a>00779     {
<a name="l00780"></a>00780 
<a name="l00781"></a>00781     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6ecf91f56b4ab5cda4d3d0a468733b19af0969a6b5512fce0e1ef22d7487e23d7">CG</a>:
<a name="l00782"></a>00782       ierr = KSPSetType (_ksp, (<span class="keywordtype">char</span>*) KSPCG);         CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr); <span class="keywordflow">return</span>;
<a name="l00783"></a>00783 
<a name="l00784"></a>00784     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6ecf91f56b4ab5cda4d3d0a468733b19a201f83b26b927cf91cf1cbd3c6bc0ee2">CR</a>:
<a name="l00785"></a>00785       ierr = KSPSetType (_ksp, (<span class="keywordtype">char</span>*) KSPCR);         CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr); <span class="keywordflow">return</span>;
<a name="l00786"></a>00786 
<a name="l00787"></a>00787     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6ecf91f56b4ab5cda4d3d0a468733b19afff9553e13457ad7f271af09bc52f438">CGS</a>:
<a name="l00788"></a>00788       ierr = KSPSetType (_ksp, (<span class="keywordtype">char</span>*) KSPCGS);        CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr); <span class="keywordflow">return</span>;
<a name="l00789"></a>00789 
<a name="l00790"></a>00790     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6ecf91f56b4ab5cda4d3d0a468733b19a0dcffd9411a6eaa02f83ce1be41bcde2">BICG</a>:
<a name="l00791"></a>00791       ierr = KSPSetType (_ksp, (<span class="keywordtype">char</span>*) KSPBICG);       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr); <span class="keywordflow">return</span>;
<a name="l00792"></a>00792 
<a name="l00793"></a>00793     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6ecf91f56b4ab5cda4d3d0a468733b19a66f876695d8cb986b11fd03a6011da5c">TCQMR</a>:
<a name="l00794"></a>00794       ierr = KSPSetType (_ksp, (<span class="keywordtype">char</span>*) KSPTCQMR);      CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr); <span class="keywordflow">return</span>;
<a name="l00795"></a>00795  
<a name="l00796"></a>00796     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6ecf91f56b4ab5cda4d3d0a468733b19a64344ae8d8320983e6f24873b0f59506">TFQMR</a>:
<a name="l00797"></a>00797       ierr = KSPSetType (_ksp, (<span class="keywordtype">char</span>*) KSPTFQMR);      CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr); <span class="keywordflow">return</span>;
<a name="l00798"></a>00798 
<a name="l00799"></a>00799     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6ecf91f56b4ab5cda4d3d0a468733b19a4402b8ddf01d5b9a43a60c21b95738f6">LSQR</a>:
<a name="l00800"></a>00800       ierr = KSPSetType (_ksp, (<span class="keywordtype">char</span>*) KSPLSQR);       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr); <span class="keywordflow">return</span>;
<a name="l00801"></a>00801 
<a name="l00802"></a>00802     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6ecf91f56b4ab5cda4d3d0a468733b19ae5a5e49337074324233c300b1daf83ec">BICGSTAB</a>:
<a name="l00803"></a>00803       ierr = KSPSetType (_ksp, (<span class="keywordtype">char</span>*) KSPBCGS);       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr); <span class="keywordflow">return</span>;
<a name="l00804"></a>00804 
<a name="l00805"></a>00805     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6ecf91f56b4ab5cda4d3d0a468733b19a1c732aa5750b891b366f966a0ad1b33a">MINRES</a>:
<a name="l00806"></a>00806       ierr = KSPSetType (_ksp, (<span class="keywordtype">char</span>*) KSPMINRES);     CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr); <span class="keywordflow">return</span>;
<a name="l00807"></a>00807 
<a name="l00808"></a>00808     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6ecf91f56b4ab5cda4d3d0a468733b19a28c6a4ecccca1d0e6956e5e94fa82d97">GMRES</a>:
<a name="l00809"></a>00809       ierr = KSPSetType (_ksp, (<span class="keywordtype">char</span>*) KSPGMRES);      CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr); <span class="keywordflow">return</span>;
<a name="l00810"></a>00810 
<a name="l00811"></a>00811     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6ecf91f56b4ab5cda4d3d0a468733b19ac89e84330ee207620b12f16ed98cb31c">RICHARDSON</a>:
<a name="l00812"></a>00812       ierr = KSPSetType (_ksp, (<span class="keywordtype">char</span>*) KSPRICHARDSON); CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr); <span class="keywordflow">return</span>;
<a name="l00813"></a>00813 
<a name="l00814"></a>00814     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6ecf91f56b4ab5cda4d3d0a468733b19a7c268c55b3f99132648b5c7245896764">CHEBYSHEV</a>: 
<a name="l00815"></a>00815       ierr = KSPSetType (_ksp, (<span class="keywordtype">char</span>*) KSPCHEBYCHEV);  CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr); <span class="keywordflow">return</span>;
<a name="l00816"></a>00816 
<a name="l00817"></a>00817     <span class="keywordflow">default</span>:
<a name="l00818"></a>00818       <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR:  Unsupported PETSC Solver: &quot;</span>
<a name="l00819"></a>00819                     &lt;&lt; this-&gt;_solver_type               &lt;&lt; std::endl
<a name="l00820"></a>00820                     &lt;&lt; <span class="stringliteral">&quot;Continuing with PETSC defaults&quot;</span> &lt;&lt; std::endl;
<a name="l00821"></a>00821     }
<a name="l00822"></a>00822 }
<a name="l00823"></a>00823 
<a name="l00824"></a>00824 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00825"></a><a class="code" href="classlibMesh_1_1PetscLinearSolver.php#ae6d4b32b1157d3ac64bc48a1f0e63720">00825</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscLinearSolver.php#ae6d4b32b1157d3ac64bc48a1f0e63720">PetscLinearSolver&lt;T&gt;::print_converged_reason</a>()
<a name="l00826"></a>00826 {
<a name="l00827"></a>00827 <span class="preprocessor">#if PETSC_VERSION_LESS_THAN(2,3,1)</span>
<a name="l00828"></a>00828 <span class="preprocessor"></span>  <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;This method is currently not supported &quot;</span>
<a name="l00829"></a>00829                 &lt;&lt; <span class="stringliteral">&quot;(but may work!) for Petsc 2.3.0 and earlier.&quot;</span> &lt;&lt; std::endl;
<a name="l00830"></a>00830 <span class="preprocessor">#else</span>
<a name="l00831"></a>00831 <span class="preprocessor"></span>  KSPConvergedReason reason;
<a name="l00832"></a>00832   KSPGetConvergedReason(_ksp, &amp;reason);
<a name="l00833"></a>00833   
<a name="l00834"></a>00834   <span class="comment">//  KSP_CONVERGED_RTOL (residual 2-norm decreased by a factor of rtol, from 2-norm of right hand side)</span>
<a name="l00835"></a>00835   <span class="comment">//  KSP_CONVERGED_ATOL (residual 2-norm less than abstol)</span>
<a name="l00836"></a>00836   <span class="comment">//  KSP_CONVERGED_ITS (used by the preonly preconditioner that always uses ONE iteration) </span>
<a name="l00837"></a>00837   <span class="comment">//  KSP_CONVERGED_STEP_LENGTH</span>
<a name="l00838"></a>00838   <span class="comment">//  KSP_DIVERGED_ITS  (required more than its to reach convergence)</span>
<a name="l00839"></a>00839   <span class="comment">//  KSP_DIVERGED_DTOL (residual norm increased by a factor of divtol)</span>
<a name="l00840"></a>00840   <span class="comment">//  KSP_DIVERGED_NAN (residual norm became Not-a-number likely do to 0/0)</span>
<a name="l00841"></a>00841   <span class="comment">//  KSP_DIVERGED_BREAKDOWN (generic breakdown in method)</span>
<a name="l00842"></a>00842 
<a name="l00843"></a>00843   <span class="keywordflow">switch</span> (reason)
<a name="l00844"></a>00844     {
<a name="l00845"></a>00845     <span class="keywordflow">case</span> KSP_CONVERGED_RTOL:
<a name="l00846"></a>00846        {
<a name="l00847"></a>00847         <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Linear solver converged, relative tolerance reached.&quot;</span> &lt;&lt; std::endl;
<a name="l00848"></a>00848         <span class="keywordflow">break</span>;
<a name="l00849"></a>00849        }
<a name="l00850"></a>00850     <span class="keywordflow">case</span> KSP_CONVERGED_ATOL:
<a name="l00851"></a>00851        {
<a name="l00852"></a>00852          <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Linear solver converged, absolute tolerance reached.&quot;</span> &lt;&lt; std::endl;
<a name="l00853"></a>00853          <span class="keywordflow">break</span>;
<a name="l00854"></a>00854        }
<a name="l00855"></a>00855 
<a name="l00856"></a>00856       <span class="comment">// Divergence</span>
<a name="l00857"></a>00857     <span class="keywordflow">case</span> KSP_DIVERGED_ITS:
<a name="l00858"></a>00858        {
<a name="l00859"></a>00859          <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Linear solver diverged, max no. of iterations reached.&quot;</span> &lt;&lt; std::endl;
<a name="l00860"></a>00860          <span class="keywordflow">break</span>;
<a name="l00861"></a>00861        }
<a name="l00862"></a>00862     <span class="keywordflow">case</span> KSP_DIVERGED_DTOL:
<a name="l00863"></a>00863        {
<a name="l00864"></a>00864          <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Linear solver diverged, residual norm increase by dtol (default 1.e5).&quot;</span> &lt;&lt; std::endl;
<a name="l00865"></a>00865          <span class="keywordflow">break</span>;
<a name="l00866"></a>00866        }
<a name="l00867"></a>00867     <span class="keywordflow">case</span> KSP_DIVERGED_NAN:
<a name="l00868"></a>00868        {
<a name="l00869"></a>00869          <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Linear solver diverged, residual norm is NaN.&quot;</span> &lt;&lt; std::endl;
<a name="l00870"></a>00870          <span class="keywordflow">break</span>;
<a name="l00871"></a>00871        }
<a name="l00872"></a>00872     <span class="keywordflow">case</span> KSP_DIVERGED_BREAKDOWN:
<a name="l00873"></a>00873        {
<a name="l00874"></a>00874          <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Linear solver diverged, generic breakdown in the method.&quot;</span> &lt;&lt; std::endl;
<a name="l00875"></a>00875          <span class="keywordflow">break</span>;
<a name="l00876"></a>00876        }
<a name="l00877"></a>00877     <span class="keywordflow">default</span>:
<a name="l00878"></a>00878       {
<a name="l00879"></a>00879         <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Unknown/unsupported con(di)vergence reason: &quot;</span> &lt;&lt; reason &lt;&lt; std::endl;
<a name="l00880"></a>00880       }
<a name="l00881"></a>00881     }
<a name="l00882"></a>00882 <span class="preprocessor">#endif</span>
<a name="l00883"></a>00883 <span class="preprocessor"></span>}
<a name="l00884"></a>00884 
<a name="l00885"></a>00885 
<a name="l00886"></a>00886 
<a name="l00887"></a>00887 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00888"></a><a class="code" href="classlibMesh_1_1PetscLinearSolver.php#a74fc6258796b7724355d07fac71e335b">00888</a> <a class="code" href="namespacelibMesh.php#ae498bcd21156b9579c241812fe40c3c2">PetscErrorCode</a> <a class="code" href="classlibMesh_1_1PetscLinearSolver.php#a74fc6258796b7724355d07fac71e335b">PetscLinearSolver&lt;T&gt;::_petsc_shell_matrix_mult</a>(Mat mat, Vec arg, Vec dest)
<a name="l00889"></a>00889 {
<a name="l00890"></a>00890   <span class="comment">/* Get the matrix context.  */</span>
<a name="l00891"></a>00891   <span class="keywordtype">int</span> ierr=0;
<a name="l00892"></a>00892   <span class="keywordtype">void</span>* ctx;
<a name="l00893"></a>00893   ierr = MatShellGetContext(mat,&amp;ctx);
<a name="l00894"></a>00894   CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00895"></a>00895 
<a name="l00896"></a>00896   <span class="comment">/* Get user shell matrix object.  */</span>
<a name="l00897"></a>00897   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ShellMatrix.php">ShellMatrix&lt;T&gt;</a>&amp; shell_matrix = *<span class="keyword">static_cast&lt;</span><span class="keyword">const </span><a class="code" href="classlibMesh_1_1ShellMatrix.php">ShellMatrix&lt;T&gt;</a>*<span class="keyword">&gt;</span>(ctx);
<a name="l00898"></a>00898 
<a name="l00899"></a>00899   <span class="comment">/* Make \p NumericVector instances around the vectors.  */</span>
<a name="l00900"></a>00900   <a class="code" href="classlibMesh_1_1PetscVector.php">PetscVector&lt;T&gt;</a> arg_global(arg);
<a name="l00901"></a>00901   <a class="code" href="classlibMesh_1_1PetscVector.php">PetscVector&lt;T&gt;</a> dest_global(dest);
<a name="l00902"></a>00902 
<a name="l00903"></a>00903   <span class="comment">/* Call the user function.  */</span>
<a name="l00904"></a>00904   shell_matrix.<a class="code" href="classlibMesh_1_1ShellMatrix.php#a090ec49ccc34e8d103eba352b66cdf31">vector_mult</a>(dest_global,arg_global);
<a name="l00905"></a>00905 
<a name="l00906"></a>00906   <span class="keywordflow">return</span> ierr;
<a name="l00907"></a>00907 }
<a name="l00908"></a>00908 
<a name="l00909"></a>00909 
<a name="l00910"></a>00910 
<a name="l00911"></a>00911 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00912"></a><a class="code" href="classlibMesh_1_1PetscLinearSolver.php#a8568708754d996fda7f23f507577b4e9">00912</a> <a class="code" href="namespacelibMesh.php#ae498bcd21156b9579c241812fe40c3c2">PetscErrorCode</a> <a class="code" href="classlibMesh_1_1PetscLinearSolver.php#a8568708754d996fda7f23f507577b4e9">PetscLinearSolver&lt;T&gt;::_petsc_shell_matrix_get_diagonal</a>(Mat mat, Vec dest)
<a name="l00913"></a>00913 {
<a name="l00914"></a>00914   <span class="comment">/* Get the matrix context.  */</span>
<a name="l00915"></a>00915   <span class="keywordtype">int</span> ierr=0;
<a name="l00916"></a>00916   <span class="keywordtype">void</span>* ctx;
<a name="l00917"></a>00917   ierr = MatShellGetContext(mat,&amp;ctx);
<a name="l00918"></a>00918   CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00919"></a>00919 
<a name="l00920"></a>00920   <span class="comment">/* Get user shell matrix object.  */</span>
<a name="l00921"></a>00921   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ShellMatrix.php">ShellMatrix&lt;T&gt;</a>&amp; shell_matrix = *<span class="keyword">static_cast&lt;</span><span class="keyword">const </span><a class="code" href="classlibMesh_1_1ShellMatrix.php">ShellMatrix&lt;T&gt;</a>*<span class="keyword">&gt;</span>(ctx);
<a name="l00922"></a>00922 
<a name="l00923"></a>00923   <span class="comment">/* Make \p NumericVector instances around the vector.  */</span>
<a name="l00924"></a>00924   <a class="code" href="classlibMesh_1_1PetscVector.php">PetscVector&lt;T&gt;</a> dest_global(dest);
<a name="l00925"></a>00925 
<a name="l00926"></a>00926   <span class="comment">/* Call the user function.  */</span>
<a name="l00927"></a>00927   shell_matrix.<a class="code" href="classlibMesh_1_1ShellMatrix.php#a1516571b30e8da439c498ce0e4ac788c">get_diagonal</a>(dest_global);
<a name="l00928"></a>00928 
<a name="l00929"></a>00929   <span class="keywordflow">return</span> ierr;
<a name="l00930"></a>00930 }
<a name="l00931"></a>00931 
<a name="l00932"></a>00932 
<a name="l00933"></a>00933 
<a name="l00934"></a>00934 <span class="comment">//------------------------------------------------------------------</span>
<a name="l00935"></a>00935 <span class="comment">// Explicit instantiations</span>
<a name="l00936"></a>00936 <span class="keyword">template</span> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1PetscLinearSolver.php">PetscLinearSolver&lt;Number&gt;</a>;
<a name="l00937"></a>00937 
<a name="l00938"></a>00938 } <span class="comment">// namespace libMesh</span>
<a name="l00939"></a>00939  
<a name="l00940"></a>00940 
<a name="l00941"></a>00941 
<a name="l00942"></a>00942 <span class="preprocessor">#endif // #ifdef LIBMESH_HAVE_PETSC</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
