<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_c3a49989e40b21e7508f29d2dc962def.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_698a648ac84b115bae48c437cf17264c.php">numerics</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">petsc_matrix.C</div>  </div>
</div>
<div class="contents">
<a href="petsc__matrix_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id$</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="comment">// C++ includes</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>&quot;</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="preprocessor">#ifdef LIBMESH_HAVE_PETSC</span>
<a name="l00025"></a>00025 <span class="preprocessor"></span>
<a name="l00026"></a>00026 <span class="comment">// Local includes</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="petsc__matrix_8h.php">petsc_matrix.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="dof__map_8h.php">dof_map.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="dense__matrix_8h.php">dense_matrix.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="petsc__vector_8h.php">petsc_vector.h</a>&quot;</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="keyword">namespace </span>libMesh
<a name="l00033"></a>00033 {
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="comment">//-----------------------------------------------------------------------</span>
<a name="l00038"></a>00038 <span class="comment">// PetscMatrix members</span>
<a name="l00039"></a>00039 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00040"></a><a class="code" href="classlibMesh_1_1PetscMatrix.php#aee89e68e23f62e1ae9038e9eab3e04c1">00040</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscMatrix.php#a700a10746d757d98f55174d774832a9d">PetscMatrix&lt;T&gt;::init</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m,
<a name="l00041"></a>00041                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00042"></a>00042                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_l,
<a name="l00043"></a>00043                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_l,
<a name="l00044"></a>00044                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nnz,
<a name="l00045"></a>00045                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> noz)
<a name="l00046"></a>00046 {
<a name="l00047"></a>00047   <span class="comment">// We allow 0x0 matrices now</span>
<a name="l00048"></a>00048   <span class="comment">//if ((m==0) || (n==0))</span>
<a name="l00049"></a>00049   <span class="comment">//  return;</span>
<a name="l00050"></a>00050 
<a name="l00051"></a>00051   <span class="comment">// Clear initialized matrices</span>
<a name="l00052"></a>00052   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>())
<a name="l00053"></a>00053     this-&gt;clear();
<a name="l00054"></a>00054 
<a name="l00055"></a>00055   this-&gt;<a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#ab8b7115ea57ced35ec86d1fdfa0ab853">_is_initialized</a> = <span class="keyword">true</span>;
<a name="l00056"></a>00056 
<a name="l00057"></a>00057   
<a name="l00058"></a>00058   <span class="keywordtype">int</span> ierr     = 0;
<a name="l00059"></a>00059   <span class="keywordtype">int</span> m_global = <span class="keyword">static_cast&lt;</span><span class="keywordtype">int</span><span class="keyword">&gt;</span>(m);
<a name="l00060"></a>00060   <span class="keywordtype">int</span> n_global = <span class="keyword">static_cast&lt;</span><span class="keywordtype">int</span><span class="keyword">&gt;</span>(n);
<a name="l00061"></a>00061   <span class="keywordtype">int</span> m_local  = <span class="keyword">static_cast&lt;</span><span class="keywordtype">int</span><span class="keyword">&gt;</span>(m_l);
<a name="l00062"></a>00062   <span class="keywordtype">int</span> n_local  = <span class="keyword">static_cast&lt;</span><span class="keywordtype">int</span><span class="keyword">&gt;</span>(n_l);
<a name="l00063"></a>00063   <span class="keywordtype">int</span> n_nz     = <span class="keyword">static_cast&lt;</span><span class="keywordtype">int</span><span class="keyword">&gt;</span>(nnz);
<a name="l00064"></a>00064   <span class="keywordtype">int</span> n_oz     = <span class="keyword">static_cast&lt;</span><span class="keywordtype">int</span><span class="keyword">&gt;</span>(noz);
<a name="l00065"></a>00065   
<a name="l00066"></a>00066   <span class="comment">// create a sequential matrix on one processor</span>
<a name="l00067"></a>00067   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() == 1)
<a name="l00068"></a>00068     {
<a name="l00069"></a>00069       libmesh_assert ((m_l == m) &amp;&amp; (n_l == n));
<a name="l00070"></a>00070 
<a name="l00071"></a>00071       <span class="comment">// Create matrix.  Revisit later to do preallocation and make more efficient</span>
<a name="l00072"></a>00072       ierr = MatCreateSeqAIJ (<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>, m_global, n_global,
<a name="l00073"></a>00073                               n_nz, PETSC_NULL, &amp;_mat);
<a name="l00074"></a>00074              CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00075"></a>00075   
<a name="l00076"></a>00076       ierr = MatSetFromOptions (_mat);
<a name="l00077"></a>00077              CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00078"></a>00078     }
<a name="l00079"></a>00079 
<a name="l00080"></a>00080   <span class="keywordflow">else</span>
<a name="l00081"></a>00081     {
<a name="l00082"></a>00082       parallel_only();
<a name="l00083"></a>00083 
<a name="l00084"></a>00084       ierr = MatCreateMPIAIJ (<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>, m_local, n_local, m_global, n_global,
<a name="l00085"></a>00085                               n_nz, PETSC_NULL, n_oz, PETSC_NULL, &amp;_mat);
<a name="l00086"></a>00086              CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00087"></a>00087   
<a name="l00088"></a>00088       ierr = MatSetFromOptions (_mat);
<a name="l00089"></a>00089              CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00090"></a>00090     }
<a name="l00091"></a>00091 
<a name="l00092"></a>00092   this-&gt;<a class="code" href="namespacelibMesh.php#a7384a2e49f01ab6e656cae298da85146">zero</a> ();
<a name="l00093"></a>00093 }
<a name="l00094"></a>00094 
<a name="l00095"></a>00095 
<a name="l00096"></a>00096 
<a name="l00097"></a>00097 
<a name="l00098"></a>00098 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00099"></a><a class="code" href="classlibMesh_1_1PetscMatrix.php#a700a10746d757d98f55174d774832a9d">00099</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscMatrix.php#a700a10746d757d98f55174d774832a9d">PetscMatrix&lt;T&gt;::init</a> ()
<a name="l00100"></a>00100 {
<a name="l00101"></a>00101   libmesh_assert (this-&gt;_dof_map != NULL);
<a name="l00102"></a>00102   
<a name="l00103"></a>00103   <span class="comment">// Clear initialized matrices</span>
<a name="l00104"></a>00104   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>())
<a name="l00105"></a>00105     this-&gt;clear();
<a name="l00106"></a>00106 
<a name="l00107"></a>00107   this-&gt;<a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#ab8b7115ea57ced35ec86d1fdfa0ab853">_is_initialized</a> = <span class="keyword">true</span>;
<a name="l00108"></a>00108 
<a name="l00109"></a>00109   
<a name="l00110"></a>00110   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m   = this-&gt;_dof_map-&gt;n_dofs();
<a name="l00111"></a>00111   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n   = m;
<a name="l00112"></a>00112   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_l = this-&gt;_dof_map-&gt;n_dofs_on_processor(<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>()); 
<a name="l00113"></a>00113   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_l = n_l;
<a name="l00114"></a>00114 
<a name="l00115"></a>00115 
<a name="l00116"></a>00116   <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; n_nz = this-&gt;_dof_map-&gt;get_n_nz();
<a name="l00117"></a>00117   <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; n_oz = this-&gt;_dof_map-&gt;get_n_oz();
<a name="l00118"></a>00118 
<a name="l00119"></a>00119   <span class="comment">// Make sure the sparsity pattern isn&#39;t empty unless the matrix is 0x0</span>
<a name="l00120"></a>00120   libmesh_assert (n_nz.size() == n_l);
<a name="l00121"></a>00121   libmesh_assert (n_oz.size() == n_l);
<a name="l00122"></a>00122   
<a name="l00123"></a>00123   <span class="comment">// We allow 0x0 matrices now</span>
<a name="l00124"></a>00124   <span class="comment">//if (m==0)</span>
<a name="l00125"></a>00125   <span class="comment">//  return;</span>
<a name="l00126"></a>00126   
<a name="l00127"></a>00127   <span class="keywordtype">int</span> ierr     = 0;
<a name="l00128"></a>00128   <span class="keywordtype">int</span> m_global = <span class="keyword">static_cast&lt;</span><span class="keywordtype">int</span><span class="keyword">&gt;</span>(m);
<a name="l00129"></a>00129   <span class="keywordtype">int</span> n_global = <span class="keyword">static_cast&lt;</span><span class="keywordtype">int</span><span class="keyword">&gt;</span>(n);
<a name="l00130"></a>00130   <span class="keywordtype">int</span> m_local  = <span class="keyword">static_cast&lt;</span><span class="keywordtype">int</span><span class="keyword">&gt;</span>(m_l);
<a name="l00131"></a>00131   <span class="keywordtype">int</span> n_local  = <span class="keyword">static_cast&lt;</span><span class="keywordtype">int</span><span class="keyword">&gt;</span>(n_l);
<a name="l00132"></a>00132 
<a name="l00133"></a>00133 
<a name="l00134"></a>00134   <span class="comment">// create a sequential matrix on one processor</span>
<a name="l00135"></a>00135   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() == 1)
<a name="l00136"></a>00136     {
<a name="l00137"></a>00137       libmesh_assert ((m_l == m) &amp;&amp; (n_l == n));
<a name="l00138"></a>00138       <span class="keywordflow">if</span> (n_nz.empty())
<a name="l00139"></a>00139         ierr = MatCreateSeqAIJ (<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>, m_global, n_global,
<a name="l00140"></a>00140                                 PETSC_NULL, (<span class="keywordtype">int</span>*) PETSC_NULL, &amp;_mat);
<a name="l00141"></a>00141       <span class="keywordflow">else</span>
<a name="l00142"></a>00142         ierr = MatCreateSeqAIJ (<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>, m_global, n_global,
<a name="l00143"></a>00143                                 PETSC_NULL, (<span class="keywordtype">int</span>*) &amp;n_nz[0], &amp;_mat);
<a name="l00144"></a>00144              CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00145"></a>00145   
<a name="l00146"></a>00146       ierr = MatSetFromOptions (_mat);
<a name="l00147"></a>00147              CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00148"></a>00148     }
<a name="l00149"></a>00149 
<a name="l00150"></a>00150   <span class="keywordflow">else</span>
<a name="l00151"></a>00151     {
<a name="l00152"></a>00152       parallel_only();
<a name="l00153"></a>00153 
<a name="l00154"></a>00154       <span class="keywordflow">if</span> (n_nz.empty())
<a name="l00155"></a>00155         ierr = MatCreateMPIAIJ (<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,
<a name="l00156"></a>00156                                 m_local, n_local,
<a name="l00157"></a>00157                                 m_global, n_global,
<a name="l00158"></a>00158                                 PETSC_NULL, (<span class="keywordtype">int</span>*) PETSC_NULL,
<a name="l00159"></a>00159                                 PETSC_NULL, (<span class="keywordtype">int</span>*) PETSC_NULL, &amp;_mat);
<a name="l00160"></a>00160       <span class="keywordflow">else</span>
<a name="l00161"></a>00161         ierr = MatCreateMPIAIJ (<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,
<a name="l00162"></a>00162                                 m_local, n_local,
<a name="l00163"></a>00163                                 m_global, n_global,
<a name="l00164"></a>00164                                 PETSC_NULL, (<span class="keywordtype">int</span>*) &amp;n_nz[0],
<a name="l00165"></a>00165                                 PETSC_NULL, (<span class="keywordtype">int</span>*) &amp;n_oz[0], &amp;_mat);
<a name="l00166"></a>00166              CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00167"></a>00167   
<a name="l00168"></a>00168       ierr = MatSetFromOptions (_mat);
<a name="l00169"></a>00169              CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00170"></a>00170     }
<a name="l00171"></a>00171 
<a name="l00172"></a>00172   this-&gt;<a class="code" href="namespacelibMesh.php#a7384a2e49f01ab6e656cae298da85146">zero</a>();
<a name="l00173"></a>00173 }
<a name="l00174"></a>00174 
<a name="l00175"></a>00175 
<a name="l00176"></a>00176 
<a name="l00177"></a>00177 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00178"></a><a class="code" href="classlibMesh_1_1PetscMatrix.php#ae8ce5cac1fe09c916c52e2dcd0bea7ea">00178</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscMatrix.php#ae8ce5cac1fe09c916c52e2dcd0bea7ea">PetscMatrix&lt;T&gt;::zero</a> ()
<a name="l00179"></a>00179 {
<a name="l00180"></a>00180   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00181"></a>00181 
<a name="l00182"></a>00182   semiparallel_only();
<a name="l00183"></a>00183   
<a name="l00184"></a>00184   <span class="keywordtype">int</span> ierr=0;
<a name="l00185"></a>00185 
<a name="l00186"></a>00186   ierr = MatZeroEntries(_mat);
<a name="l00187"></a>00187          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00188"></a>00188 }
<a name="l00189"></a>00189 
<a name="l00190"></a>00190 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00191"></a><a class="code" href="classlibMesh_1_1PetscMatrix.php#ae1a8212ad0651377974d3d097f23b2fd">00191</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscMatrix.php#ae1a8212ad0651377974d3d097f23b2fd">PetscMatrix&lt;T&gt;::zero_rows</a> (std::vector&lt;int&gt; &amp; rows, T diag_value)
<a name="l00192"></a>00192 {
<a name="l00193"></a>00193   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00194"></a>00194 
<a name="l00195"></a>00195   semiparallel_only();
<a name="l00196"></a>00196 
<a name="l00197"></a>00197   <span class="keywordtype">int</span> ierr=0;
<a name="l00198"></a>00198 
<a name="l00199"></a>00199   <span class="keywordflow">if</span>(!rows.empty())
<a name="l00200"></a>00200     ierr = MatZeroRows(_mat, rows.size(), &amp;rows[0], diag_value);
<a name="l00201"></a>00201   <span class="keywordflow">else</span>
<a name="l00202"></a>00202     ierr = MatZeroRows(_mat, 0, PETSC_NULL, diag_value);
<a name="l00203"></a>00203 
<a name="l00204"></a>00204   CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00205"></a>00205 }
<a name="l00206"></a>00206 
<a name="l00207"></a>00207 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00208"></a><a class="code" href="classlibMesh_1_1PetscMatrix.php#a2126e5e36eb3f249acce205ea96995f8">00208</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscMatrix.php#a2126e5e36eb3f249acce205ea96995f8">PetscMatrix&lt;T&gt;::clear</a> ()
<a name="l00209"></a>00209 {
<a name="l00210"></a>00210   <span class="keywordtype">int</span> ierr=0;
<a name="l00211"></a>00211   
<a name="l00212"></a>00212   <span class="keywordflow">if</span> ((this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>()) &amp;&amp; (this-&gt;_destroy_mat_on_exit))
<a name="l00213"></a>00213     {
<a name="l00214"></a>00214       semiparallel_only();
<a name="l00215"></a>00215   
<a name="l00216"></a>00216       ierr = MatDestroy (_mat);
<a name="l00217"></a>00217              CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00218"></a>00218       
<a name="l00219"></a>00219       this-&gt;<a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#ab8b7115ea57ced35ec86d1fdfa0ab853">_is_initialized</a> = <span class="keyword">false</span>;
<a name="l00220"></a>00220     }
<a name="l00221"></a>00221 }
<a name="l00222"></a>00222 
<a name="l00223"></a>00223 
<a name="l00224"></a>00224 
<a name="l00225"></a>00225 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00226"></a><a class="code" href="classlibMesh_1_1PetscMatrix.php#ab528219ea3d2d9d697da233c77730cc1">00226</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1PetscMatrix.php#ab528219ea3d2d9d697da233c77730cc1">PetscMatrix&lt;T&gt;::l1_norm</a> ()<span class="keyword"> const</span>
<a name="l00227"></a>00227 <span class="keyword"></span>{
<a name="l00228"></a>00228   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00229"></a>00229   
<a name="l00230"></a>00230   semiparallel_only();
<a name="l00231"></a>00231 
<a name="l00232"></a>00232   <span class="keywordtype">int</span> ierr=0;
<a name="l00233"></a>00233   PetscReal petsc_value;
<a name="l00234"></a>00234   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> value;
<a name="l00235"></a>00235   
<a name="l00236"></a>00236   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#a3dc0a134260371bd023e0d0f632399e1">closed</a>());
<a name="l00237"></a>00237 
<a name="l00238"></a>00238   ierr = MatNorm(_mat, NORM_1, &amp;petsc_value);
<a name="l00239"></a>00239          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00240"></a>00240 
<a name="l00241"></a>00241   value = <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a><span class="keyword">&gt;</span>(petsc_value);
<a name="l00242"></a>00242 
<a name="l00243"></a>00243   <span class="keywordflow">return</span> value;
<a name="l00244"></a>00244 }
<a name="l00245"></a>00245 
<a name="l00246"></a>00246 
<a name="l00247"></a>00247 
<a name="l00248"></a>00248 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00249"></a><a class="code" href="classlibMesh_1_1PetscMatrix.php#aaa985313896c14962e9259095c56085f">00249</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1PetscMatrix.php#aaa985313896c14962e9259095c56085f">PetscMatrix&lt;T&gt;::linfty_norm</a> ()<span class="keyword"> const</span>
<a name="l00250"></a>00250 <span class="keyword"></span>{
<a name="l00251"></a>00251   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00252"></a>00252   
<a name="l00253"></a>00253   semiparallel_only();
<a name="l00254"></a>00254 
<a name="l00255"></a>00255   <span class="keywordtype">int</span> ierr=0;
<a name="l00256"></a>00256   PetscReal petsc_value;
<a name="l00257"></a>00257   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> value;
<a name="l00258"></a>00258   
<a name="l00259"></a>00259   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#a3dc0a134260371bd023e0d0f632399e1">closed</a>());
<a name="l00260"></a>00260 
<a name="l00261"></a>00261   ierr = MatNorm(_mat, NORM_INFINITY, &amp;petsc_value);
<a name="l00262"></a>00262          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00263"></a>00263 
<a name="l00264"></a>00264   value = <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a><span class="keyword">&gt;</span>(petsc_value);
<a name="l00265"></a>00265 
<a name="l00266"></a>00266   <span class="keywordflow">return</span> value;
<a name="l00267"></a>00267 }
<a name="l00268"></a>00268 
<a name="l00269"></a>00269 
<a name="l00270"></a>00270 
<a name="l00271"></a>00271 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00272"></a><a class="code" href="classlibMesh_1_1PetscMatrix.php#a999f6d560842d59fe3911cd3fdd76a29">00272</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscMatrix.php#a999f6d560842d59fe3911cd3fdd76a29">PetscMatrix&lt;T&gt;::print_matlab</a> (<span class="keyword">const</span> std::string <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>)<span class="keyword"> const</span>
<a name="l00273"></a>00273 <span class="keyword"></span>{
<a name="l00274"></a>00274   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00275"></a>00275 
<a name="l00276"></a>00276   semiparallel_only();
<a name="l00277"></a>00277 
<a name="l00278"></a>00278   <span class="comment">// libmesh_assert (this-&gt;closed());</span>
<a name="l00279"></a>00279   this-&gt;<a class="code" href="namespacelibMesh.php#a6e41d4c43a417f7b9e20302af9736247">close</a>();
<a name="l00280"></a>00280   
<a name="l00281"></a>00281   <span class="keywordtype">int</span> ierr=0; 
<a name="l00282"></a>00282   PetscViewer petsc_viewer;
<a name="l00283"></a>00283 
<a name="l00284"></a>00284 
<a name="l00285"></a>00285   ierr = PetscViewerCreate (<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,
<a name="l00286"></a>00286                             &amp;petsc_viewer);
<a name="l00287"></a>00287          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00288"></a>00288 
<a name="l00293"></a>00293   <span class="keywordflow">if</span> (name != <span class="stringliteral">&quot;NULL&quot;</span>)
<a name="l00294"></a>00294     {
<a name="l00295"></a>00295       ierr = PetscViewerASCIIOpen( <a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,
<a name="l00296"></a>00296                                    name.c_str(),
<a name="l00297"></a>00297                                    &amp;petsc_viewer);
<a name="l00298"></a>00298              CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00299"></a>00299       
<a name="l00300"></a>00300       ierr = PetscViewerSetFormat (petsc_viewer,
<a name="l00301"></a>00301                                    PETSC_VIEWER_ASCII_MATLAB);
<a name="l00302"></a>00302              CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00303"></a>00303   
<a name="l00304"></a>00304       ierr = MatView (_mat, petsc_viewer);
<a name="l00305"></a>00305              CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00306"></a>00306     }
<a name="l00307"></a>00307 
<a name="l00311"></a>00311   <span class="keywordflow">else</span>
<a name="l00312"></a>00312     {
<a name="l00313"></a>00313       ierr = PetscViewerSetFormat (PETSC_VIEWER_STDOUT_WORLD,
<a name="l00314"></a>00314                                    PETSC_VIEWER_ASCII_MATLAB);
<a name="l00315"></a>00315              CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00316"></a>00316   
<a name="l00317"></a>00317       ierr = MatView (_mat, PETSC_VIEWER_STDOUT_WORLD);
<a name="l00318"></a>00318              CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00319"></a>00319     }
<a name="l00320"></a>00320 
<a name="l00321"></a>00321 
<a name="l00325"></a>00325   ierr = PetscViewerDestroy (petsc_viewer);
<a name="l00326"></a>00326          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00327"></a>00327 }
<a name="l00328"></a>00328 
<a name="l00329"></a>00329 
<a name="l00330"></a>00330 
<a name="l00331"></a>00331 
<a name="l00332"></a>00332 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00333"></a><a class="code" href="classlibMesh_1_1PetscMatrix.php#a5b01d18992c31d067686dc76049df29d">00333</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscMatrix.php#a5b01d18992c31d067686dc76049df29d">PetscMatrix&lt;T&gt;::add_matrix</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; dm,
<a name="l00334"></a>00334                                 <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; rows,
<a name="l00335"></a>00335                                 <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; cols)
<a name="l00336"></a>00336 {
<a name="l00337"></a>00337   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00338"></a>00338   
<a name="l00339"></a>00339   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m = dm.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a68bd665fb9252382cc9a28df4099d76a">m</a>();
<a name="l00340"></a>00340   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n = dm.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a4fb8c524109fd5dff8c98855437544ee">n</a>();
<a name="l00341"></a>00341 
<a name="l00342"></a>00342   libmesh_assert (rows.size() == m);
<a name="l00343"></a>00343   libmesh_assert (cols.size() == n);
<a name="l00344"></a>00344   
<a name="l00345"></a>00345   <span class="keywordtype">int</span> ierr=0;
<a name="l00346"></a>00346 
<a name="l00347"></a>00347   <span class="comment">// These casts are required for PETSc &lt;= 2.1.5</span>
<a name="l00348"></a>00348   ierr = MatSetValues(_mat,
<a name="l00349"></a>00349                       m, (<span class="keywordtype">int</span>*) &amp;rows[0],
<a name="l00350"></a>00350                       n, (<span class="keywordtype">int</span>*) &amp;cols[0],
<a name="l00351"></a>00351                       (PetscScalar*) &amp;dm.<a class="code" href="classlibMesh_1_1DenseMatrix.php#a676d389b9cb9410e418026ec2c1a54c1">get_values</a>()[0],
<a name="l00352"></a>00352                       ADD_VALUES);
<a name="l00353"></a>00353          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00354"></a>00354 }
<a name="l00355"></a>00355 
<a name="l00356"></a>00356 
<a name="l00357"></a>00357 
<a name="l00358"></a>00358 
<a name="l00359"></a>00359 
<a name="l00360"></a>00360 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00361"></a><a class="code" href="classlibMesh_1_1PetscMatrix.php#acab00e1ff3c5ad2392f4fb4326444da4">00361</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscMatrix.php#acab00e1ff3c5ad2392f4fb4326444da4">PetscMatrix&lt;T&gt;::_get_submatrix</a>(<a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;T&gt;</a>&amp; submatrix,
<a name="l00362"></a>00362                                     <span class="keyword">const</span> std::vector&lt;unsigned int&gt; &amp;rows,
<a name="l00363"></a>00363                                     <span class="keyword">const</span> std::vector&lt;unsigned int&gt; &amp;cols,
<a name="l00364"></a>00364                                     <span class="keyword">const</span> <span class="keywordtype">bool</span> reuse_submatrix)<span class="keyword"> const</span>
<a name="l00365"></a>00365 <span class="keyword"></span>{
<a name="l00366"></a>00366   <span class="comment">// Can only extract submatrices from closed matrices</span>
<a name="l00367"></a>00367   this-&gt;<a class="code" href="namespacelibMesh.php#a6e41d4c43a417f7b9e20302af9736247">close</a>();
<a name="l00368"></a>00368 
<a name="l00369"></a>00369   <span class="comment">// Make sure the SparseMatrix passed in is really a PetscMatrix</span>
<a name="l00370"></a>00370   <a class="code" href="classlibMesh_1_1PetscMatrix.php">PetscMatrix&lt;T&gt;</a>* petsc_submatrix = libmesh_cast_ptr&lt;PetscMatrix&lt;T&gt;*&gt;(&amp;submatrix);
<a name="l00371"></a>00371 
<a name="l00372"></a>00372   <span class="comment">// If we&#39;re not reusing submatrix and submatrix is already initialized</span>
<a name="l00373"></a>00373   <span class="comment">// then we need to clear it, otherwise we get a memory leak.</span>
<a name="l00374"></a>00374   <span class="keywordflow">if</span>( !reuse_submatrix &amp;&amp; submatrix.<a class="code" href="classlibMesh_1_1SparseMatrix.php#a71ac3668357d2f61480589e2bc9c1b04">initialized</a>() )
<a name="l00375"></a>00375     submatrix.<a class="code" href="classlibMesh_1_1SparseMatrix.php#a81c9892fe2233b297993ed87dcea4c0f">clear</a>();
<a name="l00376"></a>00376   
<a name="l00377"></a>00377   <span class="comment">// Construct row and column index sets.</span>
<a name="l00378"></a>00378   <span class="keywordtype">int</span> ierr=0;
<a name="l00379"></a>00379   IS isrow, iscol;
<a name="l00380"></a>00380 
<a name="l00381"></a>00381   ierr = ISCreateLibMesh(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,
<a name="l00382"></a>00382                          rows.size(),
<a name="l00383"></a>00383                          (<span class="keywordtype">int</span>*) &amp;rows[0],
<a name="l00384"></a>00384                          PETSC_USE_POINTER,
<a name="l00385"></a>00385                          &amp;isrow); CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00386"></a>00386 
<a name="l00387"></a>00387   ierr = ISCreateLibMesh(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,
<a name="l00388"></a>00388                          cols.size(),
<a name="l00389"></a>00389                          (<span class="keywordtype">int</span>*) &amp;cols[0],
<a name="l00390"></a>00390                          PETSC_USE_POINTER,
<a name="l00391"></a>00391                          &amp;iscol); CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00392"></a>00392 
<a name="l00393"></a>00393   <span class="comment">// Extract submatrix</span>
<a name="l00394"></a>00394 <span class="preprocessor">#if !PETSC_VERSION_LESS_THAN(3,0,1) || !PETSC_VERSION_RELEASE</span>
<a name="l00395"></a>00395 <span class="preprocessor"></span>  ierr = MatGetSubMatrix(_mat,
<a name="l00396"></a>00396                          isrow,
<a name="l00397"></a>00397                          iscol,
<a name="l00398"></a>00398                          (reuse_submatrix ? MAT_REUSE_MATRIX : MAT_INITIAL_MATRIX),
<a name="l00399"></a>00399                          &amp;(petsc_submatrix-&gt;<a class="code" href="classlibMesh_1_1PetscMatrix.php#a0deeafca10aa9a80b4adeca9fe5327d2">_mat</a>));  CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00400"></a>00400 <span class="preprocessor">#else</span>
<a name="l00401"></a>00401 <span class="preprocessor"></span>  ierr = MatGetSubMatrix(_mat,
<a name="l00402"></a>00402                          isrow,
<a name="l00403"></a>00403                          iscol,
<a name="l00404"></a>00404                          PETSC_DECIDE,
<a name="l00405"></a>00405                          (reuse_submatrix ? MAT_REUSE_MATRIX : MAT_INITIAL_MATRIX),
<a name="l00406"></a>00406                          &amp;(petsc_submatrix-&gt;<a class="code" href="classlibMesh_1_1PetscMatrix.php#a0deeafca10aa9a80b4adeca9fe5327d2">_mat</a>));  CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00407"></a>00407 <span class="preprocessor">#endif</span>
<a name="l00408"></a>00408 <span class="preprocessor"></span>
<a name="l00409"></a>00409   <span class="comment">// Specify that the new submatrix is initialized and close it.</span>
<a name="l00410"></a>00410   petsc_submatrix-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#a9af4f8901ed954b3980801faf2250a55">_is_initialized</a> = <span class="keyword">true</span>;
<a name="l00411"></a>00411   petsc_submatrix-&gt;<a class="code" href="classlibMesh_1_1PetscMatrix.php#ab8835ee5e4160b1345fab9dbca26b52b">close</a>();
<a name="l00412"></a>00412 
<a name="l00413"></a>00413   <span class="comment">// Clean up PETSc data structures</span>
<a name="l00414"></a>00414   ierr = ISDestroy(isrow); CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00415"></a>00415   ierr = ISDestroy(iscol); CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00416"></a>00416 }
<a name="l00417"></a>00417 
<a name="l00418"></a>00418 
<a name="l00419"></a>00419 
<a name="l00420"></a>00420 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00421"></a><a class="code" href="classlibMesh_1_1PetscMatrix.php#a9708988038977263227f90dee91482f9">00421</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscMatrix.php#a9708988038977263227f90dee91482f9">PetscMatrix&lt;T&gt;::get_diagonal</a> (<a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; dest)<span class="keyword"> const</span>
<a name="l00422"></a>00422 <span class="keyword"></span>{
<a name="l00423"></a>00423   <span class="comment">// Make sure the NumericVector passed in is really a PetscVector</span>
<a name="l00424"></a>00424   <a class="code" href="classlibMesh_1_1PetscVector.php">PetscVector&lt;T&gt;</a>&amp; petsc_dest = libmesh_cast_ref&lt;PetscVector&lt;T&gt;&amp;&gt;(dest);
<a name="l00425"></a>00425 
<a name="l00426"></a>00426   <span class="comment">// Call PETSc function.</span>
<a name="l00427"></a>00427 
<a name="l00428"></a>00428 <span class="preprocessor">#if PETSC_VERSION_LESS_THAN(2,3,1)</span>
<a name="l00429"></a>00429 <span class="preprocessor"></span>
<a name="l00430"></a>00430   <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;This method has been developed with PETSc 2.3.1.  &quot;</span>
<a name="l00431"></a>00431                 &lt;&lt; <span class="stringliteral">&quot;No one has made it backwards compatible with older &quot;</span>
<a name="l00432"></a>00432                 &lt;&lt; <span class="stringliteral">&quot;versions of PETSc so far; however, it might work &quot;</span>
<a name="l00433"></a>00433                 &lt;&lt; <span class="stringliteral">&quot;without any change with some older version.&quot;</span> &lt;&lt; std::endl;
<a name="l00434"></a>00434   libmesh_error();
<a name="l00435"></a>00435 
<a name="l00436"></a>00436 <span class="preprocessor">#else</span>
<a name="l00437"></a>00437 <span class="preprocessor"></span>
<a name="l00438"></a>00438   <span class="comment">// Needs a const_cast since PETSc does not work with const.</span>
<a name="l00439"></a>00439   <span class="keywordtype">int</span> ierr =
<a name="l00440"></a>00440     MatGetDiagonal(<span class="keyword">const_cast&lt;</span><a class="code" href="classlibMesh_1_1PetscMatrix.php">PetscMatrix&lt;T&gt;</a>*<span class="keyword">&gt;</span>(<span class="keyword">this</span>)-&gt;mat(),petsc_dest.<a class="code" href="classlibMesh_1_1PetscVector.php#ada434b1090f88c405ad6d0294646a400">vec</a>()); CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00441"></a>00441 
<a name="l00442"></a>00442 <span class="preprocessor">#endif</span>
<a name="l00443"></a>00443 <span class="preprocessor"></span>
<a name="l00444"></a>00444 }
<a name="l00445"></a>00445 
<a name="l00446"></a>00446 
<a name="l00447"></a>00447 
<a name="l00448"></a>00448 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00449"></a><a class="code" href="classlibMesh_1_1PetscMatrix.php#a31d11117c505d898a56d70e8a5878e1c">00449</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscMatrix.php#a31d11117c505d898a56d70e8a5878e1c">PetscMatrix&lt;T&gt;::get_transpose</a> (<a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;T&gt;</a>&amp; dest)<span class="keyword"> const</span>
<a name="l00450"></a>00450 <span class="keyword"></span>{
<a name="l00451"></a>00451   <span class="comment">// Make sure the SparseMatrix passed in is really a PetscMatrix</span>
<a name="l00452"></a>00452   <a class="code" href="classlibMesh_1_1PetscMatrix.php">PetscMatrix&lt;T&gt;</a>&amp; petsc_dest = libmesh_cast_ref&lt;PetscMatrix&lt;T&gt;&amp;&gt;(dest);
<a name="l00453"></a>00453 
<a name="l00454"></a>00454   <span class="comment">// If we aren&#39;t reusing the matrix then need to clear dest,</span>
<a name="l00455"></a>00455   <span class="comment">// otherwise we get a memory leak</span>
<a name="l00456"></a>00456   <span class="keywordflow">if</span>(&amp;petsc_dest != <span class="keyword">this</span>)
<a name="l00457"></a>00457     dest.<a class="code" href="classlibMesh_1_1SparseMatrix.php#a81c9892fe2233b297993ed87dcea4c0f">clear</a>();
<a name="l00458"></a>00458 
<a name="l00459"></a>00459   <span class="keywordtype">int</span> ierr;
<a name="l00460"></a>00460 <span class="preprocessor">#if PETSC_VERSION_LESS_THAN(3,0,0)</span>
<a name="l00461"></a>00461 <span class="preprocessor"></span>  <span class="keywordflow">if</span> (&amp;petsc_dest == <span class="keyword">this</span>)
<a name="l00462"></a>00462     ierr = MatTranspose(_mat,PETSC_NULL);
<a name="l00463"></a>00463   <span class="keywordflow">else</span>
<a name="l00464"></a>00464     ierr = MatTranspose(_mat,&amp;petsc_dest.<a class="code" href="classlibMesh_1_1PetscMatrix.php#a0deeafca10aa9a80b4adeca9fe5327d2">_mat</a>);
<a name="l00465"></a>00465   CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00466"></a>00466 <span class="preprocessor">#else</span>
<a name="l00467"></a>00467 <span class="preprocessor"></span>  <span class="comment">// FIXME - we can probably use MAT_REUSE_MATRIX in more situations</span>
<a name="l00468"></a>00468   <span class="keywordflow">if</span> (&amp;petsc_dest == <span class="keyword">this</span>)
<a name="l00469"></a>00469     ierr = MatTranspose(_mat,MAT_REUSE_MATRIX,&amp;petsc_dest.<a class="code" href="classlibMesh_1_1PetscMatrix.php#a0deeafca10aa9a80b4adeca9fe5327d2">_mat</a>);
<a name="l00470"></a>00470   <span class="keywordflow">else</span>
<a name="l00471"></a>00471     ierr = MatTranspose(_mat,MAT_INITIAL_MATRIX,&amp;petsc_dest.<a class="code" href="classlibMesh_1_1PetscMatrix.php#a0deeafca10aa9a80b4adeca9fe5327d2">_mat</a>);
<a name="l00472"></a>00472   CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00473"></a>00473 <span class="preprocessor">#endif</span>
<a name="l00474"></a>00474 <span class="preprocessor"></span>
<a name="l00475"></a>00475   <span class="comment">// Specify that the transposed matrix is initialized and close it.</span>
<a name="l00476"></a>00476   petsc_dest.<a class="code" href="classlibMesh_1_1SparseMatrix.php#a9af4f8901ed954b3980801faf2250a55">_is_initialized</a> = <span class="keyword">true</span>;
<a name="l00477"></a>00477   petsc_dest.<a class="code" href="classlibMesh_1_1PetscMatrix.php#ab8835ee5e4160b1345fab9dbca26b52b">close</a>();
<a name="l00478"></a>00478 }
<a name="l00479"></a>00479 
<a name="l00480"></a>00480 
<a name="l00481"></a>00481 
<a name="l00482"></a>00482 <span class="comment">//------------------------------------------------------------------</span>
<a name="l00483"></a>00483 <span class="comment">// Explicit instantiations</span>
<a name="l00484"></a>00484 <span class="keyword">template</span> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1PetscMatrix.php">PetscMatrix&lt;Number&gt;</a>;
<a name="l00485"></a>00485 
<a name="l00486"></a>00486 } <span class="comment">// namespace libMesh</span>
<a name="l00487"></a>00487 
<a name="l00488"></a>00488 
<a name="l00489"></a>00489 <span class="preprocessor">#endif // #ifdef LIBMESH_HAVE_PETSC</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
