<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_eaf30c8ea092d33f79a04353c3899c3f.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_1a2b14d219bf20b3bfd3aaf502c1b987.php">numerics</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">petsc_vector.h</div>  </div>
</div>
<div class="contents">
<a href="petsc__vector_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id$</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 
<a name="l00023"></a>00023 <span class="preprocessor">#ifndef __petsc_vector_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span><span class="preprocessor">#define __petsc_vector_h__</span>
<a name="l00025"></a>00025 <span class="preprocessor"></span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>&quot;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="preprocessor">#ifdef LIBMESH_HAVE_PETSC</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="comment">// C++ includes</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="comment">// Local includes</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="numeric__vector_8h.php">numeric_vector.h</a>&quot;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;<a class="code" href="petsc__macro_8h.php">petsc_macro.h</a>&quot;</span>
<a name="l00038"></a>00038 
<a name="l00042"></a>00042 EXTERN_C_FOR_PETSC_BEGIN
<a name="l00043"></a>00043 <span class="preprocessor"># include &lt;petscvec.h&gt;</span>
<a name="l00044"></a>00044 EXTERN_C_FOR_PETSC_END
<a name="l00045"></a>00045 
<a name="l00046"></a>00046 <span class="keyword">namespace </span>libMesh
<a name="l00047"></a>00047 {
<a name="l00048"></a>00048 
<a name="l00049"></a>00049 
<a name="l00050"></a>00050 
<a name="l00051"></a>00051 <span class="comment">// forward declarations</span>
<a name="l00052"></a>00052 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span>SparseMatrix;
<a name="l00053"></a>00053 
<a name="l00061"></a>00061 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00062"></a><a class="code" href="classlibMesh_1_1PetscVector.php">00062</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1PetscVector.php">PetscVector</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector</a>&lt;T&gt;
<a name="l00063"></a>00063 {
<a name="l00064"></a>00064 <span class="keyword">public</span>:
<a name="l00065"></a>00065 
<a name="l00069"></a>00069   <span class="keyword">explicit</span>
<a name="l00070"></a>00070   <a class="code" href="classlibMesh_1_1PetscVector.php#a18384c047ea8f12c1c67d0a83a39d482">PetscVector</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> <a class="code" href="classlibMesh_1_1NumericVector.php#a3b6bc13960a5d0022beea138c4e86dc4">type</a> = <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa13dc964f55aa3fba644670673652bc2e">AUTOMATIC</a>);
<a name="l00071"></a>00071   
<a name="l00075"></a>00075   <span class="keyword">explicit</span>
<a name="l00076"></a>00076   <a class="code" href="classlibMesh_1_1PetscVector.php#a18384c047ea8f12c1c67d0a83a39d482">PetscVector</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00077"></a>00077                <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> <a class="code" href="classlibMesh_1_1NumericVector.php#a3b6bc13960a5d0022beea138c4e86dc4">type</a> = <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa13dc964f55aa3fba644670673652bc2e">AUTOMATIC</a>);
<a name="l00078"></a>00078     
<a name="l00083"></a>00083   <a class="code" href="classlibMesh_1_1PetscVector.php#a18384c047ea8f12c1c67d0a83a39d482">PetscVector</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00084"></a>00084                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_local,
<a name="l00085"></a>00085                <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> <a class="code" href="classlibMesh_1_1NumericVector.php#a3b6bc13960a5d0022beea138c4e86dc4">type</a> = <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa13dc964f55aa3fba644670673652bc2e">AUTOMATIC</a>);
<a name="l00086"></a>00086 
<a name="l00092"></a>00092   <a class="code" href="classlibMesh_1_1PetscVector.php#a18384c047ea8f12c1c67d0a83a39d482">PetscVector</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N,
<a name="l00093"></a>00093                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_local,
<a name="l00094"></a>00094                <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; ghost,
<a name="l00095"></a>00095                <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> <a class="code" href="classlibMesh_1_1NumericVector.php#a3b6bc13960a5d0022beea138c4e86dc4">type</a> = <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa13dc964f55aa3fba644670673652bc2e">AUTOMATIC</a>);
<a name="l00096"></a>00096   
<a name="l00104"></a>00104   <a class="code" href="classlibMesh_1_1PetscVector.php#a18384c047ea8f12c1c67d0a83a39d482">PetscVector</a>(Vec v);
<a name="l00105"></a>00105   
<a name="l00110"></a>00110   <a class="code" href="classlibMesh_1_1PetscVector.php#a47190fb6c0e223214da7a8fcec32aff3">~PetscVector</a> ();
<a name="l00111"></a>00111 
<a name="l00115"></a>00115   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a0285829baf6ad79ddc9d4e071f5654d6">close</a> (); 
<a name="l00116"></a>00116 
<a name="l00120"></a>00120   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a007ddfc6829440932987ebb6570ecbc3">clear</a> ();
<a name="l00121"></a>00121   
<a name="l00126"></a>00126   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a9c4a5fa4f97980d8d41d5e684b754ad2">zero</a> ();    
<a name="l00127"></a>00127 
<a name="l00133"></a>00133   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;T&gt;</a> &gt; <a class="code" href="classlibMesh_1_1PetscVector.php#a16ae7e736c696598f9ac6ef8fb4722f9">zero_clone</a> () <span class="keyword">const</span>;
<a name="l00134"></a>00134   
<a name="l00138"></a>00138   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;T&gt;</a> &gt; <a class="code" href="classlibMesh_1_1PetscVector.php#a2589fe9ed56966da256d17ae0ed2aaa5">clone</a> () <span class="keyword">const</span>;
<a name="l00139"></a>00139   
<a name="l00153"></a>00153   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a83f3b4d4b254651312243dfa478c4128">init</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N,
<a name="l00154"></a>00154              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_local,
<a name="l00155"></a>00155              <span class="keyword">const</span> <span class="keywordtype">bool</span>         fast=<span class="keyword">false</span>,
<a name="l00156"></a>00156              <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> <a class="code" href="classlibMesh_1_1NumericVector.php#a3b6bc13960a5d0022beea138c4e86dc4">type</a>=<a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa13dc964f55aa3fba644670673652bc2e">AUTOMATIC</a>);
<a name="l00157"></a>00157     
<a name="l00161"></a>00161   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a83f3b4d4b254651312243dfa478c4128">init</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N,
<a name="l00162"></a>00162              <span class="keyword">const</span> <span class="keywordtype">bool</span>         fast=<span class="keyword">false</span>,
<a name="l00163"></a>00163              <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> <a class="code" href="classlibMesh_1_1NumericVector.php#a3b6bc13960a5d0022beea138c4e86dc4">type</a>=<a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa13dc964f55aa3fba644670673652bc2e">AUTOMATIC</a>);
<a name="l00164"></a>00164     
<a name="l00169"></a>00169   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a83f3b4d4b254651312243dfa478c4128">init</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <span class="comment">/*N*/</span>,
<a name="l00170"></a>00170                      <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <span class="comment">/*n_local*/</span>,
<a name="l00171"></a>00171                      <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; <span class="comment">/*ghost*/</span>,
<a name="l00172"></a>00172                      <span class="keyword">const</span> <span class="keywordtype">bool</span> <span class="comment">/*fast*/</span> = <span class="keyword">false</span>,
<a name="l00173"></a>00173                      <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> = <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa13dc964f55aa3fba644670673652bc2e">AUTOMATIC</a>);
<a name="l00174"></a>00174 
<a name="l00179"></a>00179   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a83f3b4d4b254651312243dfa478c4128">init</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; other,
<a name="l00180"></a>00180                      <span class="keyword">const</span> <span class="keywordtype">bool</span> fast = <span class="keyword">false</span>);
<a name="l00181"></a>00181 
<a name="l00182"></a>00182   <span class="comment">//   /**</span>
<a name="l00183"></a>00183   <span class="comment">//    * Change the dimension to that of the</span>
<a name="l00184"></a>00184   <span class="comment">//    * vector \p V. The same applies as for</span>
<a name="l00185"></a>00185   <span class="comment">//    * the other \p init function.</span>
<a name="l00186"></a>00186   <span class="comment">//    *</span>
<a name="l00187"></a>00187   <span class="comment">//    * The elements of \p V are not copied, i.e.</span>
<a name="l00188"></a>00188   <span class="comment">//    * this function is the same as calling</span>
<a name="l00189"></a>00189   <span class="comment">//    * \p init(V.size(),fast).</span>
<a name="l00190"></a>00190   <span class="comment">//    */</span>
<a name="l00191"></a>00191   <span class="comment">//   void init (const NumericVector&lt;T&gt;&amp; V,</span>
<a name="l00192"></a>00192   <span class="comment">//         const bool fast=false);</span>
<a name="l00193"></a>00193 
<a name="l00197"></a>00197   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp; <a class="code" href="classlibMesh_1_1PetscVector.php#ae539d02f0976d2a14d78bb26fe387c05">operator= </a>(<span class="keyword">const</span> T s);
<a name="l00198"></a>00198     
<a name="l00202"></a>00202   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp; <a class="code" href="classlibMesh_1_1PetscVector.php#ae539d02f0976d2a14d78bb26fe387c05">operator= </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp;V);
<a name="l00203"></a>00203 
<a name="l00207"></a>00207   <a class="code" href="classlibMesh_1_1PetscVector.php">PetscVector&lt;T&gt;</a> &amp; <a class="code" href="classlibMesh_1_1PetscVector.php#ae539d02f0976d2a14d78bb26fe387c05">operator= </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1PetscVector.php">PetscVector&lt;T&gt;</a> &amp;V);
<a name="l00208"></a>00208 
<a name="l00212"></a>00212   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp; <a class="code" href="classlibMesh_1_1PetscVector.php#ae539d02f0976d2a14d78bb26fe387c05">operator= </a>(<span class="keyword">const</span> std::vector&lt;T&gt; &amp;v);
<a name="l00213"></a>00213 
<a name="l00219"></a>00219   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1PetscVector.php#ad6b3453051282426cf2d24a5f818694b">min</a> () <span class="keyword">const</span>;
<a name="l00220"></a>00220   
<a name="l00226"></a>00226   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1PetscVector.php#a451166e5c22db1400d10ad95663570d9">max</a> () <span class="keyword">const</span>;
<a name="l00227"></a>00227 
<a name="l00231"></a>00231   T <a class="code" href="classlibMesh_1_1PetscVector.php#a8e29eb124d4d870a5c4654e1d24ba71b">sum</a> () <span class="keyword">const</span>;
<a name="l00232"></a>00232 
<a name="l00237"></a>00237   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1PetscVector.php#abdc8865d1b68a5cce20476aadc2741b7">l1_norm</a> () <span class="keyword">const</span>;
<a name="l00238"></a>00238 
<a name="l00244"></a>00244   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1PetscVector.php#aedba6fc62aa53a8767b115abf8de5c17">l2_norm</a> () <span class="keyword">const</span>;
<a name="l00245"></a>00245 
<a name="l00251"></a>00251   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1PetscVector.php#a2cb0b9e70d671b5a713ab2e817ea2c4e">linfty_norm</a> () <span class="keyword">const</span>;
<a name="l00252"></a>00252 
<a name="l00260"></a>00260   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1PetscVector.php#ac4223fe11da95ce84aaf3187bc774544">size</a> () <span class="keyword">const</span>;
<a name="l00261"></a>00261 
<a name="l00266"></a>00266   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a9586f2b97a6c61a35b36f8fbe4c3c944">local_size</a>() <span class="keyword">const</span>;
<a name="l00267"></a>00267 
<a name="l00272"></a>00272   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a24ba974e25d6f45320e44c6b09172445">first_local_index</a>() <span class="keyword">const</span>;
<a name="l00273"></a>00273 
<a name="l00278"></a>00278   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a2e46f596e497108daaf43a994a789a25">last_local_index</a>() <span class="keyword">const</span>;
<a name="l00279"></a>00279 
<a name="l00286"></a>00286   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a03165d6ee0a36f6db8e5a7af1c794b44">map_global_to_local_index</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00287"></a>00287     
<a name="l00291"></a>00291   T <a class="code" href="classlibMesh_1_1PetscVector.php#aed023fcdc606a1397a42db67462acf74">operator() </a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00292"></a>00292     
<a name="l00298"></a>00298   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <span class="keyword">get</span>(<span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; index, std::vector&lt;T&gt;&amp; values) <span class="keyword">const</span>;
<a name="l00299"></a>00299 
<a name="l00304"></a>00304   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp; <a class="code" href="classlibMesh_1_1PetscVector.php#a427752e9e998847c55fe092669c61d10">operator += </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp;V);
<a name="l00305"></a>00305 
<a name="l00310"></a>00310   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp; <a class="code" href="classlibMesh_1_1PetscVector.php#a172b730a7ae74d8d811ae47fa253f846">operator -= </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp;V);
<a name="l00311"></a>00311     
<a name="l00315"></a>00315   <span class="keywordtype">void</span> <span class="keyword">set</span> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i, <span class="keyword">const</span> T value);
<a name="l00316"></a>00316     
<a name="l00320"></a>00320   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a56e21f9b50e79ee84da389d2fa1d6ae2">add</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i, <span class="keyword">const</span> T value);
<a name="l00321"></a>00321     
<a name="l00327"></a>00327   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a56e21f9b50e79ee84da389d2fa1d6ae2">add</a> (<span class="keyword">const</span> T s);
<a name="l00328"></a>00328     
<a name="l00334"></a>00334   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a56e21f9b50e79ee84da389d2fa1d6ae2">add</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; V);
<a name="l00335"></a>00335 
<a name="l00341"></a>00341   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a56e21f9b50e79ee84da389d2fa1d6ae2">add</a> (<span class="keyword">const</span> T a, <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; v);
<a name="l00342"></a>00342   
<a name="l00348"></a>00348   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a25816c41be95fad452146d515d831d3d">add_vector</a> (<span class="keyword">const</span> std::vector&lt;T&gt;&amp; v,
<a name="l00349"></a>00349                    <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices);
<a name="l00350"></a>00350 
<a name="l00357"></a>00357   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a25816c41be95fad452146d515d831d3d">add_vector</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; V,
<a name="l00358"></a>00358                    <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices);
<a name="l00359"></a>00359 
<a name="l00360"></a>00360 
<a name="l00365"></a>00365   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a25816c41be95fad452146d515d831d3d">add_vector</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp;V,
<a name="l00366"></a>00366                    <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;T&gt;</a> &amp;A);
<a name="l00367"></a>00367      
<a name="l00374"></a>00374   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a25816c41be95fad452146d515d831d3d">add_vector</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T&gt;</a>&amp; V,
<a name="l00375"></a>00375                    <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices);
<a name="l00376"></a>00376   
<a name="l00381"></a>00381   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a0a9cde83712f9cd2ccc1d683be85cf6f">insert</a> (<span class="keyword">const</span> std::vector&lt;T&gt;&amp; v,
<a name="l00382"></a>00382                        <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices);
<a name="l00383"></a>00383 
<a name="l00390"></a>00390   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a0a9cde83712f9cd2ccc1d683be85cf6f">insert</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; V,
<a name="l00391"></a>00391                        <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices);
<a name="l00392"></a>00392       
<a name="l00398"></a>00398   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a0a9cde83712f9cd2ccc1d683be85cf6f">insert</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T&gt;</a>&amp; V,
<a name="l00399"></a>00399                        <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices);
<a name="l00400"></a>00400     
<a name="l00406"></a>00406   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a0a9cde83712f9cd2ccc1d683be85cf6f">insert</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseSubVector.php">DenseSubVector&lt;T&gt;</a>&amp; V,
<a name="l00407"></a>00407                        <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices);
<a name="l00408"></a>00408     
<a name="l00409"></a>00409   
<a name="l00414"></a>00414   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a594b8417a43df556940509786642f8ce">scale</a> (<span class="keyword">const</span> T factor);
<a name="l00415"></a>00415 
<a name="l00420"></a>00420   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a470a96bc67762d23d0abdb8e963ca614">abs</a>();
<a name="l00421"></a>00421 
<a name="l00425"></a>00425   <span class="keyword">virtual</span> T <a class="code" href="classlibMesh_1_1PetscVector.php#a8bec8d600fe295651a58c3c59c4c0ad8">dot</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; V) <span class="keyword">const</span>;
<a name="l00426"></a>00426   
<a name="l00431"></a>00431   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a888af92342fafe21c75c6a32ce086797">localize</a> (std::vector&lt;T&gt;&amp; v_local) <span class="keyword">const</span>;
<a name="l00432"></a>00432 
<a name="l00437"></a>00437   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a888af92342fafe21c75c6a32ce086797">localize</a> (<a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; v_local) <span class="keyword">const</span>;
<a name="l00438"></a>00438 
<a name="l00444"></a>00444   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a888af92342fafe21c75c6a32ce086797">localize</a> (<a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; v_local,
<a name="l00445"></a>00445                  <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; send_list) <span class="keyword">const</span>;
<a name="l00446"></a>00446   
<a name="l00451"></a>00451   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a888af92342fafe21c75c6a32ce086797">localize</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> first_local_idx,
<a name="l00452"></a>00452                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> last_local_idx,
<a name="l00453"></a>00453                  <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; send_list);
<a name="l00454"></a>00454   
<a name="l00461"></a>00461   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a3b7b8300db75a12c23576c546207b99d">localize_to_one</a> (std::vector&lt;T&gt;&amp; v_local,
<a name="l00462"></a>00462                         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id=0) <span class="keyword">const</span>;
<a name="l00463"></a>00463   
<a name="l00468"></a>00468   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a1a7a9d46b37a104a5ddab4629d96ffb0">pointwise_mult</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; vec1,
<a name="l00469"></a>00469                                <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; vec2);
<a name="l00470"></a>00470 
<a name="l00477"></a>00477   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a41c9c9d46ed87b403c37b869dee65843">print_matlab</a>(<span class="keyword">const</span> std::string <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>=<span class="stringliteral">&quot;NULL&quot;</span>) <span class="keyword">const</span>;
<a name="l00478"></a>00478 
<a name="l00483"></a>00483   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a77e562fea6fa014f5cce1df3b68d55b4">create_subvector</a>(<a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; subvector,
<a name="l00484"></a>00484                                 <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; rows) <span class="keyword">const</span>;
<a name="l00485"></a>00485 
<a name="l00489"></a>00489   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a7ddbc3123946cc4f3d1bdf9831b10ea1">swap</a> (<a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp;v);
<a name="l00490"></a>00490 
<a name="l00496"></a><a class="code" href="classlibMesh_1_1PetscVector.php#ada434b1090f88c405ad6d0294646a400">00496</a>   Vec <a class="code" href="classlibMesh_1_1PetscVector.php#ada434b1090f88c405ad6d0294646a400">vec</a> () { libmesh_assert (<a class="code" href="classlibMesh_1_1PetscVector.php#ad5a8a89fa15de5f7bb6fb2d5ab62dea0">_vec</a> != NULL); <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1PetscVector.php#ad5a8a89fa15de5f7bb6fb2d5ab62dea0">_vec</a>; }
<a name="l00497"></a>00497 
<a name="l00498"></a>00498 
<a name="l00499"></a>00499   
<a name="l00500"></a>00500 <span class="keyword">private</span>:
<a name="l00501"></a>00501 
<a name="l00506"></a><a class="code" href="classlibMesh_1_1PetscVector.php#ad5a8a89fa15de5f7bb6fb2d5ab62dea0">00506</a>   Vec <a class="code" href="classlibMesh_1_1PetscVector.php#ad5a8a89fa15de5f7bb6fb2d5ab62dea0">_vec</a>;
<a name="l00507"></a>00507 
<a name="l00513"></a><a class="code" href="classlibMesh_1_1PetscVector.php#ae10345bff1d65f2b84f7d16c6c7b538c">00513</a>   <span class="keyword">mutable</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1PetscVector.php#ae10345bff1d65f2b84f7d16c6c7b538c">_array_is_present</a>;
<a name="l00514"></a>00514 
<a name="l00515"></a>00515 <span class="preprocessor">#ifndef NDEBUG</span>
<a name="l00516"></a>00516 <span class="preprocessor"></span>
<a name="l00521"></a><a class="code" href="classlibMesh_1_1PetscVector.php#ac25a64f1b9af2d6a1daa8cde5b71da95">00521</a>   <span class="keyword">mutable</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1PetscVector.php#ac25a64f1b9af2d6a1daa8cde5b71da95">_local_size</a>;
<a name="l00522"></a>00522 <span class="preprocessor">#endif</span>
<a name="l00523"></a>00523 <span class="preprocessor"></span>
<a name="l00529"></a><a class="code" href="classlibMesh_1_1PetscVector.php#a04af5355d6a0463f3466750d77143f02">00529</a>   <span class="keyword">mutable</span> Vec <a class="code" href="classlibMesh_1_1PetscVector.php#a04af5355d6a0463f3466750d77143f02">_local_form</a>;
<a name="l00530"></a>00530 
<a name="l00535"></a><a class="code" href="classlibMesh_1_1PetscVector.php#a6a4fcd82f63d93f1f4b8d94c154ce2ac">00535</a>   <span class="keyword">mutable</span> PetscScalar* <a class="code" href="classlibMesh_1_1PetscVector.php#a6a4fcd82f63d93f1f4b8d94c154ce2ac">_values</a>;
<a name="l00536"></a>00536 
<a name="l00541"></a>00541   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#aa2b346d42c670f3de26d2f96a0a22dcb">_get_array</a>(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00542"></a>00542 
<a name="l00547"></a>00547   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#adf26b52e8c4b03874a572389f00d4f9b">_restore_array</a>(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00548"></a>00548 
<a name="l00552"></a><a class="code" href="classlibMesh_1_1PetscVector.php#a9d1e427746f7c4e1c1aacc9d433827ab">00552</a>   <span class="keyword">typedef</span> std::map&lt;unsigned int,unsigned int&gt; <a class="code" href="classlibMesh_1_1PetscVector.php#a9d1e427746f7c4e1c1aacc9d433827ab">GlobalToLocalMap</a>;
<a name="l00553"></a>00553 
<a name="l00558"></a><a class="code" href="classlibMesh_1_1PetscVector.php#ac28fe132e16a1de3b1521b2aedef05ce">00558</a>   <a class="code" href="classlibMesh_1_1PetscVector.php#a9d1e427746f7c4e1c1aacc9d433827ab">GlobalToLocalMap</a> <a class="code" href="classlibMesh_1_1PetscVector.php#ac28fe132e16a1de3b1521b2aedef05ce">_global_to_local_map</a>;
<a name="l00559"></a>00559 
<a name="l00564"></a><a class="code" href="classlibMesh_1_1PetscVector.php#ae7bb1316f1184ca49794ba697f81be92">00564</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1PetscVector.php#ae7bb1316f1184ca49794ba697f81be92">_destroy_vec_on_exit</a>;
<a name="l00565"></a>00565 };
<a name="l00566"></a>00566 
<a name="l00567"></a>00567 
<a name="l00568"></a>00568 <span class="comment">/*----------------------- Inline functions ----------------------------------*/</span>
<a name="l00569"></a>00569 
<a name="l00570"></a>00570 
<a name="l00571"></a>00571 
<a name="l00572"></a>00572 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00573"></a>00573 <span class="keyword">inline</span>
<a name="l00574"></a><a class="code" href="classlibMesh_1_1PetscVector.php#a18384c047ea8f12c1c67d0a83a39d482">00574</a> <a class="code" href="classlibMesh_1_1PetscVector.php#a18384c047ea8f12c1c67d0a83a39d482">PetscVector&lt;T&gt;::PetscVector</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> type)
<a name="l00575"></a>00575   : _array_is_present(false),
<a name="l00576"></a>00576     _local_form(NULL),
<a name="l00577"></a>00577     _values(NULL),
<a name="l00578"></a>00578     _global_to_local_map(),
<a name="l00579"></a>00579     _destroy_vec_on_exit(true)
<a name="l00580"></a>00580 {
<a name="l00581"></a>00581   this-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a5703f5d080a4ac9c725db7660a768fb8">_type</a> = <a class="code" href="classlibMesh_1_1NumericVector.php#a3b6bc13960a5d0022beea138c4e86dc4">type</a>;
<a name="l00582"></a>00582 }
<a name="l00583"></a>00583 
<a name="l00584"></a>00584 
<a name="l00585"></a>00585 
<a name="l00586"></a>00586 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00587"></a>00587 <span class="keyword">inline</span>
<a name="l00588"></a><a class="code" href="classlibMesh_1_1PetscVector.php#a124150b16ec4e194f72d41e1c23a1f4f">00588</a> <a class="code" href="classlibMesh_1_1PetscVector.php#a18384c047ea8f12c1c67d0a83a39d482">PetscVector&lt;T&gt;::PetscVector</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00589"></a>00589                              <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> type)
<a name="l00590"></a>00590   : _array_is_present(false),
<a name="l00591"></a>00591     _local_form(NULL),
<a name="l00592"></a>00592     _values(NULL),
<a name="l00593"></a>00593     _global_to_local_map(),
<a name="l00594"></a>00594     _destroy_vec_on_exit(true)
<a name="l00595"></a>00595 {
<a name="l00596"></a>00596   this-&gt;<a class="code" href="classlibMesh_1_1PetscVector.php#a83f3b4d4b254651312243dfa478c4128">init</a>(n, n, <span class="keyword">false</span>, type);
<a name="l00597"></a>00597 }
<a name="l00598"></a>00598 
<a name="l00599"></a>00599 
<a name="l00600"></a>00600 
<a name="l00601"></a>00601 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00602"></a>00602 <span class="keyword">inline</span>
<a name="l00603"></a><a class="code" href="classlibMesh_1_1PetscVector.php#aefc9053ace1c0a25acf76351856ed517">00603</a> <a class="code" href="classlibMesh_1_1PetscVector.php#a18384c047ea8f12c1c67d0a83a39d482">PetscVector&lt;T&gt;::PetscVector</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00604"></a>00604                              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_local,
<a name="l00605"></a>00605                              <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> type)
<a name="l00606"></a>00606   : _array_is_present(false),
<a name="l00607"></a>00607     _local_form(NULL),
<a name="l00608"></a>00608     _values(NULL),
<a name="l00609"></a>00609     _global_to_local_map(),
<a name="l00610"></a>00610     _destroy_vec_on_exit(true)
<a name="l00611"></a>00611 {
<a name="l00612"></a>00612   this-&gt;<a class="code" href="classlibMesh_1_1PetscVector.php#a83f3b4d4b254651312243dfa478c4128">init</a>(n, n_local, <span class="keyword">false</span>, type);
<a name="l00613"></a>00613 }
<a name="l00614"></a>00614 
<a name="l00615"></a>00615 
<a name="l00616"></a>00616 
<a name="l00617"></a>00617 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00618"></a>00618 <span class="keyword">inline</span>
<a name="l00619"></a><a class="code" href="classlibMesh_1_1PetscVector.php#a66d3712ca545a2430bdd0926818ab906">00619</a> <a class="code" href="classlibMesh_1_1PetscVector.php#a18384c047ea8f12c1c67d0a83a39d482">PetscVector&lt;T&gt;::PetscVector</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00620"></a>00620                              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_local,
<a name="l00621"></a>00621                              <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; ghost,
<a name="l00622"></a>00622                              <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> type)
<a name="l00623"></a>00623   : _array_is_present(false),
<a name="l00624"></a>00624     _local_form(NULL),
<a name="l00625"></a>00625     _values(NULL),
<a name="l00626"></a>00626     _global_to_local_map(),
<a name="l00627"></a>00627     _destroy_vec_on_exit(true)
<a name="l00628"></a>00628 {
<a name="l00629"></a>00629   this-&gt;<a class="code" href="classlibMesh_1_1PetscVector.php#a83f3b4d4b254651312243dfa478c4128">init</a>(n, n_local, ghost, <span class="keyword">false</span>, type);
<a name="l00630"></a>00630 }
<a name="l00631"></a>00631 
<a name="l00632"></a>00632 
<a name="l00633"></a>00633 
<a name="l00634"></a>00634 
<a name="l00635"></a>00635 
<a name="l00636"></a>00636 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00637"></a>00637 <span class="keyword">inline</span>
<a name="l00638"></a><a class="code" href="classlibMesh_1_1PetscVector.php#a8e985b9752090d0edf22ce08c7d12793">00638</a> <a class="code" href="classlibMesh_1_1PetscVector.php#a18384c047ea8f12c1c67d0a83a39d482">PetscVector&lt;T&gt;::PetscVector</a> (Vec v)
<a name="l00639"></a>00639   : _array_is_present(false),
<a name="l00640"></a>00640     _local_form(NULL),
<a name="l00641"></a>00641     _values(NULL),
<a name="l00642"></a>00642     _global_to_local_map(),
<a name="l00643"></a>00643     _destroy_vec_on_exit(false)
<a name="l00644"></a>00644 {
<a name="l00645"></a>00645   this-&gt;<a class="code" href="classlibMesh_1_1PetscVector.php#ad5a8a89fa15de5f7bb6fb2d5ab62dea0">_vec</a> = v;
<a name="l00646"></a>00646   this-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a9f798c4a61662ab8486b3ddca31520a3">_is_closed</a> = <span class="keyword">true</span>;
<a name="l00647"></a>00647   this-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a7ec1792df4c8c636e5dd387534067819">_is_initialized</a> = <span class="keyword">true</span>;
<a name="l00648"></a>00648 
<a name="l00649"></a>00649   <span class="comment">/* We need to ask PETSc about the (local to global) ghost value</span>
<a name="l00650"></a>00650 <span class="comment">     mapping and create the inverse mapping out of it.  */</span>
<a name="l00651"></a>00651   <span class="keywordtype">int</span> ierr=0, petsc_size=0, petsc_local_size=0;
<a name="l00652"></a>00652   ierr = VecGetSize(<a class="code" href="classlibMesh_1_1PetscVector.php#ad5a8a89fa15de5f7bb6fb2d5ab62dea0">_vec</a>, &amp;petsc_size);
<a name="l00653"></a>00653   CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00654"></a>00654   ierr = VecGetLocalSize(<a class="code" href="classlibMesh_1_1PetscVector.php#ad5a8a89fa15de5f7bb6fb2d5ab62dea0">_vec</a>, &amp;petsc_local_size);
<a name="l00655"></a>00655   CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00656"></a>00656 
<a name="l00657"></a>00657   <span class="comment">/* \p petsc_local_size is the number of non-ghost values.  If it</span>
<a name="l00658"></a>00658 <span class="comment">     equals the global size, then we are a serial vector, and there</span>
<a name="l00659"></a>00659 <span class="comment">     are no ghost values.  */</span>
<a name="l00660"></a>00660   <span class="keywordflow">if</span>(petsc_size!=petsc_local_size)
<a name="l00661"></a>00661     {
<a name="l00662"></a>00662       ISLocalToGlobalMapping mapping = <a class="code" href="classlibMesh_1_1PetscVector.php#ad5a8a89fa15de5f7bb6fb2d5ab62dea0">_vec</a>-&gt;mapping;
<a name="l00663"></a>00663 
<a name="l00664"></a>00664       <span class="comment">// If is a sparsely stored vector, set up our new mapping</span>
<a name="l00665"></a>00665       <span class="keywordflow">if</span> (mapping)
<a name="l00666"></a>00666         {
<a name="l00667"></a>00667           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a9586f2b97a6c61a35b36f8fbe4c3c944">local_size</a> = <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(petsc_local_size);
<a name="l00668"></a>00668           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ghost_begin = <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(petsc_local_size);
<a name="l00669"></a>00669           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ghost_end = <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(mapping-&gt;n);
<a name="l00670"></a>00670           <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=ghost_begin; i&lt;ghost_end; i++)
<a name="l00671"></a>00671             <a class="code" href="classlibMesh_1_1PetscVector.php#ac28fe132e16a1de3b1521b2aedef05ce">_global_to_local_map</a>[mapping-&gt;indices[i]] = i-local_size;
<a name="l00672"></a>00672           this-&gt;_type = <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa9f12475bbe90a64ad167ec0b856ca6c1">GHOSTED</a>;
<a name="l00673"></a>00673         }
<a name="l00674"></a>00674       <span class="keywordflow">else</span>
<a name="l00675"></a>00675         this-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a5703f5d080a4ac9c725db7660a768fb8">_type</a> = <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">PARALLEL</a>;
<a name="l00676"></a>00676     }
<a name="l00677"></a>00677   <span class="keywordflow">else</span>
<a name="l00678"></a>00678     this-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a5703f5d080a4ac9c725db7660a768fb8">_type</a> = <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa333690ccec0379e5dd4ccb60db5ea0c9">SERIAL</a>;
<a name="l00679"></a>00679 
<a name="l00680"></a>00680 }
<a name="l00681"></a>00681 
<a name="l00682"></a>00682 
<a name="l00683"></a>00683 
<a name="l00684"></a>00684 
<a name="l00685"></a>00685 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00686"></a>00686 <span class="keyword">inline</span>
<a name="l00687"></a><a class="code" href="classlibMesh_1_1PetscVector.php#a47190fb6c0e223214da7a8fcec32aff3">00687</a> <a class="code" href="classlibMesh_1_1PetscVector.php#a47190fb6c0e223214da7a8fcec32aff3">PetscVector&lt;T&gt;::~PetscVector</a> ()
<a name="l00688"></a>00688 {
<a name="l00689"></a>00689   this-&gt;clear ();
<a name="l00690"></a>00690 }
<a name="l00691"></a>00691 
<a name="l00692"></a>00692 
<a name="l00693"></a>00693 
<a name="l00694"></a>00694 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00695"></a>00695 <span class="keyword">inline</span>
<a name="l00696"></a><a class="code" href="classlibMesh_1_1PetscVector.php#a83f3b4d4b254651312243dfa478c4128">00696</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a83f3b4d4b254651312243dfa478c4128">PetscVector&lt;T&gt;::init</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00697"></a>00697                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_local,
<a name="l00698"></a>00698                            <span class="keyword">const</span> <span class="keywordtype">bool</span> fast,
<a name="l00699"></a>00699                            <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> type)
<a name="l00700"></a>00700 {
<a name="l00701"></a>00701   <span class="keywordtype">int</span> ierr=0;
<a name="l00702"></a>00702   <span class="keywordtype">int</span> petsc_n=<span class="keyword">static_cast&lt;</span><span class="keywordtype">int</span><span class="keyword">&gt;</span>(n);
<a name="l00703"></a>00703   <span class="keywordtype">int</span> petsc_n_local=<span class="keyword">static_cast&lt;</span><span class="keywordtype">int</span><span class="keyword">&gt;</span>(n_local);
<a name="l00704"></a>00704 
<a name="l00705"></a>00705 
<a name="l00706"></a>00706   <span class="comment">// Clear initialized vectors </span>
<a name="l00707"></a>00707   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>())
<a name="l00708"></a>00708     this-&gt;clear();
<a name="l00709"></a>00709 
<a name="l00710"></a>00710   <span class="keywordflow">if</span> (type == <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa13dc964f55aa3fba644670673652bc2e">AUTOMATIC</a>)
<a name="l00711"></a>00711     {
<a name="l00712"></a>00712       <span class="keywordflow">if</span> (n == n_local)
<a name="l00713"></a>00713         this-&gt;_type = <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa333690ccec0379e5dd4ccb60db5ea0c9">SERIAL</a>;
<a name="l00714"></a>00714       <span class="keywordflow">else</span>
<a name="l00715"></a>00715         this-&gt;_type = <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">PARALLEL</a>;
<a name="l00716"></a>00716     }
<a name="l00717"></a>00717   <span class="keywordflow">else</span>
<a name="l00718"></a>00718     this-&gt;_type = type;
<a name="l00719"></a>00719 
<a name="l00720"></a>00720   libmesh_assert ((this-&gt;_type==<a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa333690ccec0379e5dd4ccb60db5ea0c9">SERIAL</a> &amp;&amp; n==n_local) ||
<a name="l00721"></a>00721                   this-&gt;_type==<a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">PARALLEL</a>);
<a name="l00722"></a>00722   
<a name="l00723"></a>00723   <span class="comment">// create a sequential vector if on only 1 processor </span>
<a name="l00724"></a>00724   <span class="keywordflow">if</span> (this-&gt;_type == <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa333690ccec0379e5dd4ccb60db5ea0c9">SERIAL</a>)
<a name="l00725"></a>00725     {
<a name="l00726"></a>00726       ierr = VecCreateSeq (PETSC_COMM_SELF, petsc_n, &amp;_vec);
<a name="l00727"></a>00727              CHKERRABORT(PETSC_COMM_SELF,ierr);
<a name="l00728"></a>00728       
<a name="l00729"></a>00729       ierr = VecSetFromOptions (_vec);
<a name="l00730"></a>00730              CHKERRABORT(PETSC_COMM_SELF,ierr);
<a name="l00731"></a>00731     }
<a name="l00732"></a>00732   <span class="comment">// otherwise create an MPI-enabled vector</span>
<a name="l00733"></a>00733   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (this-&gt;_type == <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">PARALLEL</a>)
<a name="l00734"></a>00734     {
<a name="l00735"></a>00735 <span class="preprocessor">#ifdef LIBMESH_HAVE_MPI</span>
<a name="l00736"></a>00736 <span class="preprocessor"></span>      libmesh_assert (n_local &lt;= n);
<a name="l00737"></a>00737       ierr = VecCreateMPI (<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>, petsc_n_local, petsc_n,
<a name="l00738"></a>00738                            &amp;_vec);
<a name="l00739"></a>00739              CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00740"></a>00740 <span class="preprocessor">#else</span>
<a name="l00741"></a>00741 <span class="preprocessor"></span>      libmesh_assert (n_local == n);
<a name="l00742"></a>00742       ierr = VecCreateSeq (PETSC_COMM_SELF, petsc_n, &amp;_vec);
<a name="l00743"></a>00743              CHKERRABORT(PETSC_COMM_SELF,ierr);
<a name="l00744"></a>00744 <span class="preprocessor">#endif</span>
<a name="l00745"></a>00745 <span class="preprocessor"></span>      
<a name="l00746"></a>00746       ierr = VecSetFromOptions (_vec);
<a name="l00747"></a>00747              CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00748"></a>00748     }  
<a name="l00749"></a>00749   <span class="keywordflow">else</span>
<a name="l00750"></a>00750     libmesh_error();
<a name="l00751"></a>00751   
<a name="l00752"></a>00752   this-&gt;<a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#ab8b7115ea57ced35ec86d1fdfa0ab853">_is_initialized</a> = <span class="keyword">true</span>;
<a name="l00753"></a>00753   this-&gt;_is_closed = <span class="keyword">true</span>;
<a name="l00754"></a>00754   
<a name="l00755"></a>00755   
<a name="l00756"></a>00756   <span class="keywordflow">if</span> (fast == <span class="keyword">false</span>)
<a name="l00757"></a>00757     this-&gt;<a class="code" href="namespacelibMesh.php#a7384a2e49f01ab6e656cae298da85146">zero</a> ();
<a name="l00758"></a>00758 }
<a name="l00759"></a>00759 
<a name="l00760"></a>00760 
<a name="l00761"></a>00761 
<a name="l00762"></a>00762 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00763"></a>00763 <span class="keyword">inline</span>
<a name="l00764"></a><a class="code" href="classlibMesh_1_1PetscVector.php#ab4278753fca60ca176d8d7595629f03a">00764</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a83f3b4d4b254651312243dfa478c4128">PetscVector&lt;T&gt;::init</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00765"></a>00765                            <span class="keyword">const</span> <span class="keywordtype">bool</span> fast,
<a name="l00766"></a>00766                            <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> type)
<a name="l00767"></a>00767 {
<a name="l00768"></a>00768   this-&gt;<a class="code" href="namespacelibMesh.php#a74975b21077cce916d7b3e22ad49290c">init</a>(n,n,fast,type);
<a name="l00769"></a>00769 }
<a name="l00770"></a>00770 
<a name="l00771"></a>00771 
<a name="l00772"></a>00772 
<a name="l00773"></a>00773 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00774"></a>00774 <span class="keyword">inline</span>
<a name="l00775"></a><a class="code" href="classlibMesh_1_1PetscVector.php#aed5439f90abce9a6027dcb521740320b">00775</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a83f3b4d4b254651312243dfa478c4128">PetscVector&lt;T&gt;::init</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00776"></a>00776                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_local,
<a name="l00777"></a>00777                            <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; ghost,
<a name="l00778"></a>00778                            <span class="keyword">const</span> <span class="keywordtype">bool</span> fast,
<a name="l00779"></a>00779                            <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> type)
<a name="l00780"></a>00780 {
<a name="l00781"></a>00781   <span class="keywordtype">int</span> ierr=0;
<a name="l00782"></a>00782   <span class="keywordtype">int</span> petsc_n=<span class="keyword">static_cast&lt;</span><span class="keywordtype">int</span><span class="keyword">&gt;</span>(n);
<a name="l00783"></a>00783   <span class="keywordtype">int</span> petsc_n_local=<span class="keyword">static_cast&lt;</span><span class="keywordtype">int</span><span class="keyword">&gt;</span>(n_local);
<a name="l00784"></a>00784   <span class="keywordtype">int</span> petsc_n_ghost=<span class="keyword">static_cast&lt;</span><span class="keywordtype">int</span><span class="keyword">&gt;</span>(ghost.size());
<a name="l00785"></a>00785 
<a name="l00786"></a>00786   <span class="comment">// If the mesh is not disjoint, every processor will either have</span>
<a name="l00787"></a>00787   <span class="comment">// all the dofs, none of the dofs, or some non-zero dofs at the</span>
<a name="l00788"></a>00788   <span class="comment">// boundary between processors.</span>
<a name="l00789"></a>00789   <span class="comment">//</span>
<a name="l00790"></a>00790   <span class="comment">// However we can&#39;t assert this, because someone might want to</span>
<a name="l00791"></a>00791   <span class="comment">// construct a GHOSTED vector which doesn&#39;t include neighbor element</span>
<a name="l00792"></a>00792   <span class="comment">// dofs.  Boyce tried to do so in user code, and we&#39;re going to want</span>
<a name="l00793"></a>00793   <span class="comment">// to do so in System::project_vector().</span>
<a name="l00794"></a>00794   <span class="comment">//</span>
<a name="l00795"></a>00795   <span class="comment">// libmesh_assert(n_local == 0 || n_local == n || !ghost.empty());</span>
<a name="l00796"></a>00796 
<a name="l00797"></a>00797   <span class="keywordtype">int</span>* petsc_ghost = ghost.empty() ? PETSC_NULL :
<a name="l00798"></a>00798     <span class="keyword">const_cast&lt;</span><span class="keywordtype">int</span>*<span class="keyword">&gt;</span>(<span class="keyword">reinterpret_cast&lt;</span><span class="keyword">const </span><span class="keywordtype">int</span>*<span class="keyword">&gt;</span>(&amp;ghost[0]));
<a name="l00799"></a>00799 
<a name="l00800"></a>00800   <span class="comment">// Clear initialized vectors </span>
<a name="l00801"></a>00801   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>())
<a name="l00802"></a>00802     this-&gt;clear();
<a name="l00803"></a>00803 
<a name="l00804"></a>00804   libmesh_assert(type == <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa13dc964f55aa3fba644670673652bc2e">AUTOMATIC</a> || type == <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa9f12475bbe90a64ad167ec0b856ca6c1">GHOSTED</a>);
<a name="l00805"></a>00805   this-&gt;_type = <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa9f12475bbe90a64ad167ec0b856ca6c1">GHOSTED</a>;
<a name="l00806"></a>00806 
<a name="l00807"></a>00807   <span class="comment">/* Make the global-to-local ghost cell map.  */</span>
<a name="l00808"></a>00808   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;ghost.size(); i++)
<a name="l00809"></a>00809     {
<a name="l00810"></a>00810       _global_to_local_map[ghost[i]] = i;
<a name="l00811"></a>00811     }
<a name="l00812"></a>00812 
<a name="l00813"></a>00813   <span class="comment">/* Create vector.  */</span>
<a name="l00814"></a>00814   ierr = VecCreateGhost (<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>, petsc_n_local, petsc_n,
<a name="l00815"></a>00815                          petsc_n_ghost, petsc_ghost,
<a name="l00816"></a>00816                          &amp;_vec);
<a name="l00817"></a>00817   CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00818"></a>00818   
<a name="l00819"></a>00819   ierr = VecSetFromOptions (_vec);
<a name="l00820"></a>00820   CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00821"></a>00821   
<a name="l00822"></a>00822   this-&gt;<a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#ab8b7115ea57ced35ec86d1fdfa0ab853">_is_initialized</a> = <span class="keyword">true</span>;
<a name="l00823"></a>00823   this-&gt;_is_closed = <span class="keyword">true</span>;
<a name="l00824"></a>00824   
<a name="l00825"></a>00825   <span class="keywordflow">if</span> (fast == <span class="keyword">false</span>)
<a name="l00826"></a>00826     this-&gt;<a class="code" href="namespacelibMesh.php#a7384a2e49f01ab6e656cae298da85146">zero</a> ();
<a name="l00827"></a>00827 }
<a name="l00828"></a>00828 
<a name="l00829"></a>00829 
<a name="l00830"></a>00830 
<a name="l00831"></a>00831 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00832"></a>00832 <span class="keyword">inline</span>
<a name="l00833"></a><a class="code" href="classlibMesh_1_1PetscVector.php#a1a9ed9f54cab101da906d976e0b7bea1">00833</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a83f3b4d4b254651312243dfa478c4128">PetscVector&lt;T&gt;::init</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; other,
<a name="l00834"></a>00834                            <span class="keyword">const</span> <span class="keywordtype">bool</span> fast)
<a name="l00835"></a>00835 {
<a name="l00836"></a>00836   <span class="comment">// Clear initialized vectors </span>
<a name="l00837"></a>00837   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>())
<a name="l00838"></a>00838     this-&gt;clear();
<a name="l00839"></a>00839 
<a name="l00840"></a>00840   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1PetscVector.php">PetscVector&lt;T&gt;</a>&amp; v = libmesh_cast_ref&lt;const PetscVector&lt;T&gt;&amp;&gt;(other);
<a name="l00841"></a>00841 
<a name="l00842"></a>00842   <span class="comment">// Other vector should restore array.</span>
<a name="l00843"></a>00843   <span class="keywordflow">if</span>(v.<a class="code" href="classlibMesh_1_1NumericVector.php#a02791337b6c509228fdf3e72320b56d3">initialized</a>())
<a name="l00844"></a>00844     {
<a name="l00845"></a>00845       v.<a class="code" href="classlibMesh_1_1PetscVector.php#adf26b52e8c4b03874a572389f00d4f9b">_restore_array</a>();
<a name="l00846"></a>00846     }
<a name="l00847"></a>00847 
<a name="l00848"></a>00848   this-&gt;_global_to_local_map = v.<a class="code" href="classlibMesh_1_1PetscVector.php#ac28fe132e16a1de3b1521b2aedef05ce">_global_to_local_map</a>;
<a name="l00849"></a>00849   this-&gt;_is_closed      = v.<a class="code" href="classlibMesh_1_1NumericVector.php#a9f798c4a61662ab8486b3ddca31520a3">_is_closed</a>;
<a name="l00850"></a>00850   this-&gt;<a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#ab8b7115ea57ced35ec86d1fdfa0ab853">_is_initialized</a> = v.<a class="code" href="classlibMesh_1_1NumericVector.php#a7ec1792df4c8c636e5dd387534067819">_is_initialized</a>;
<a name="l00851"></a>00851   this-&gt;_type = v.<a class="code" href="classlibMesh_1_1NumericVector.php#a5703f5d080a4ac9c725db7660a768fb8">_type</a>;
<a name="l00852"></a>00852 
<a name="l00853"></a>00853   <span class="keywordflow">if</span> (v.<a class="code" href="classlibMesh_1_1PetscVector.php#ac4223fe11da95ce84aaf3187bc774544">size</a>() != 0)
<a name="l00854"></a>00854     {
<a name="l00855"></a>00855       <span class="keywordtype">int</span> ierr = 0;
<a name="l00856"></a>00856 
<a name="l00857"></a>00857       ierr = VecDuplicate (v.<a class="code" href="classlibMesh_1_1PetscVector.php#ad5a8a89fa15de5f7bb6fb2d5ab62dea0">_vec</a>, &amp;this-&gt;_vec);
<a name="l00858"></a>00858       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00859"></a>00859     }
<a name="l00860"></a>00860   
<a name="l00861"></a>00861   <span class="keywordflow">if</span> (fast == <span class="keyword">false</span>)
<a name="l00862"></a>00862     this-&gt;<a class="code" href="namespacelibMesh.php#a7384a2e49f01ab6e656cae298da85146">zero</a> ();
<a name="l00863"></a>00863 }
<a name="l00864"></a>00864 
<a name="l00865"></a>00865 
<a name="l00866"></a>00866 
<a name="l00867"></a>00867 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00868"></a>00868 <span class="keyword">inline</span>
<a name="l00869"></a><a class="code" href="classlibMesh_1_1PetscVector.php#a0285829baf6ad79ddc9d4e071f5654d6">00869</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a0285829baf6ad79ddc9d4e071f5654d6">PetscVector&lt;T&gt;::close</a> ()
<a name="l00870"></a>00870 {
<a name="l00871"></a>00871   this-&gt;_restore_array();
<a name="l00872"></a>00872   
<a name="l00873"></a>00873   <span class="keywordtype">int</span> ierr=0;
<a name="l00874"></a>00874   
<a name="l00875"></a>00875   ierr = VecAssemblyBegin(_vec);
<a name="l00876"></a>00876   CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00877"></a>00877   ierr = VecAssemblyEnd(_vec);
<a name="l00878"></a>00878   CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00879"></a>00879 
<a name="l00880"></a>00880   <span class="keywordflow">if</span>(this-&gt;type() == <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa9f12475bbe90a64ad167ec0b856ca6c1">GHOSTED</a>)
<a name="l00881"></a>00881     {
<a name="l00882"></a>00882       ierr = VecGhostUpdateBegin(_vec,INSERT_VALUES,SCATTER_FORWARD);
<a name="l00883"></a>00883       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00884"></a>00884       ierr = VecGhostUpdateEnd(_vec,INSERT_VALUES,SCATTER_FORWARD);
<a name="l00885"></a>00885       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00886"></a>00886     }
<a name="l00887"></a>00887 
<a name="l00888"></a>00888   this-&gt;_is_closed = <span class="keyword">true</span>;
<a name="l00889"></a>00889 }
<a name="l00890"></a>00890 
<a name="l00891"></a>00891 
<a name="l00892"></a>00892 
<a name="l00893"></a>00893 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00894"></a>00894 <span class="keyword">inline</span>
<a name="l00895"></a><a class="code" href="classlibMesh_1_1PetscVector.php#a007ddfc6829440932987ebb6570ecbc3">00895</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a007ddfc6829440932987ebb6570ecbc3">PetscVector&lt;T&gt;::clear</a> ()
<a name="l00896"></a>00896 {
<a name="l00897"></a>00897   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>())
<a name="l00898"></a>00898     this-&gt;_restore_array();
<a name="l00899"></a>00899 
<a name="l00900"></a>00900   <span class="keywordflow">if</span> ((this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>()) &amp;&amp; (this-&gt;_destroy_vec_on_exit))
<a name="l00901"></a>00901     {
<a name="l00902"></a>00902       <span class="keywordtype">int</span> ierr=0;
<a name="l00903"></a>00903 
<a name="l00904"></a>00904       ierr = VecDestroy(_vec);
<a name="l00905"></a>00905              CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00906"></a>00906     }
<a name="l00907"></a>00907 
<a name="l00908"></a>00908   this-&gt;_is_closed = this-&gt;<a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#ab8b7115ea57ced35ec86d1fdfa0ab853">_is_initialized</a> = <span class="keyword">false</span>;
<a name="l00909"></a>00909 
<a name="l00910"></a>00910   _global_to_local_map.clear();
<a name="l00911"></a>00911 }
<a name="l00912"></a>00912 
<a name="l00913"></a>00913 
<a name="l00914"></a>00914 
<a name="l00915"></a>00915 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00916"></a>00916 <span class="keyword">inline</span>
<a name="l00917"></a><a class="code" href="classlibMesh_1_1PetscVector.php#a9c4a5fa4f97980d8d41d5e684b754ad2">00917</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a9c4a5fa4f97980d8d41d5e684b754ad2">PetscVector&lt;T&gt;::zero</a> ()
<a name="l00918"></a>00918 {
<a name="l00919"></a>00919   this-&gt;_restore_array();
<a name="l00920"></a>00920   
<a name="l00921"></a>00921   <span class="keywordtype">int</span> ierr=0;
<a name="l00922"></a>00922 
<a name="l00923"></a>00923   PetscScalar z=0.;
<a name="l00924"></a>00924 
<a name="l00925"></a>00925   <span class="keywordflow">if</span>(this-&gt;type() != <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa9f12475bbe90a64ad167ec0b856ca6c1">GHOSTED</a>)
<a name="l00926"></a>00926     {
<a name="l00927"></a>00927 <span class="preprocessor">#if PETSC_VERSION_LESS_THAN(2,3,0)  </span>
<a name="l00928"></a>00928 <span class="preprocessor"></span>      <span class="comment">// 2.2.x &amp; earlier style</span>
<a name="l00929"></a>00929       ierr = VecSet (&amp;z, _vec);
<a name="l00930"></a>00930       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00931"></a>00931 <span class="preprocessor">#else</span>
<a name="l00932"></a>00932 <span class="preprocessor"></span>      <span class="comment">// 2.3.x &amp; newer</span>
<a name="l00933"></a>00933       ierr = VecSet (_vec, z);
<a name="l00934"></a>00934       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00935"></a>00935 <span class="preprocessor">#endif</span>
<a name="l00936"></a>00936 <span class="preprocessor"></span>    }
<a name="l00937"></a>00937   <span class="keywordflow">else</span>
<a name="l00938"></a>00938     {
<a name="l00939"></a>00939       <span class="comment">/* Vectors that include ghost values require a special</span>
<a name="l00940"></a>00940 <span class="comment">         handling.  */</span>
<a name="l00941"></a>00941       Vec loc_vec;
<a name="l00942"></a>00942       ierr = VecGhostGetLocalForm (_vec,&amp;loc_vec);
<a name="l00943"></a>00943       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00944"></a>00944 <span class="preprocessor">#if PETSC_VERSION_LESS_THAN(2,3,0)  </span>
<a name="l00945"></a>00945 <span class="preprocessor"></span>      <span class="comment">// 2.2.x &amp; earlier style</span>
<a name="l00946"></a>00946       ierr = VecSet (&amp;z, loc_vec);
<a name="l00947"></a>00947       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00948"></a>00948 <span class="preprocessor">#else</span>
<a name="l00949"></a>00949 <span class="preprocessor"></span>      <span class="comment">// 2.3.x &amp; newer</span>
<a name="l00950"></a>00950       ierr = VecSet (loc_vec, z);
<a name="l00951"></a>00951       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00952"></a>00952 <span class="preprocessor">#endif</span>
<a name="l00953"></a>00953 <span class="preprocessor"></span>      ierr = VecGhostRestoreLocalForm (_vec,&amp;loc_vec);
<a name="l00954"></a>00954       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00955"></a>00955     }
<a name="l00956"></a>00956 }
<a name="l00957"></a>00957 
<a name="l00958"></a>00958 
<a name="l00959"></a>00959 
<a name="l00960"></a>00960 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00961"></a>00961 <span class="keyword">inline</span>
<a name="l00962"></a><a class="code" href="classlibMesh_1_1PetscVector.php#a16ae7e736c696598f9ac6ef8fb4722f9">00962</a> <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;T&gt;</a> &gt; <a class="code" href="classlibMesh_1_1PetscVector.php#a16ae7e736c696598f9ac6ef8fb4722f9">PetscVector&lt;T&gt;::zero_clone</a> ()<span class="keyword"> const</span>
<a name="l00963"></a>00963 <span class="keyword"></span>{
<a name="l00964"></a>00964   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;T&gt;</a> &gt; cloned_vector (<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1PetscVector.php">PetscVector&lt;T&gt;</a>);
<a name="l00965"></a>00965 
<a name="l00966"></a>00966   cloned_vector-&gt;init(*<span class="keyword">this</span>);
<a name="l00967"></a>00967 
<a name="l00968"></a>00968   <span class="keywordflow">return</span> cloned_vector;
<a name="l00969"></a>00969 }
<a name="l00970"></a>00970 
<a name="l00971"></a>00971 
<a name="l00972"></a>00972 
<a name="l00973"></a>00973 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00974"></a>00974 <span class="keyword">inline</span>
<a name="l00975"></a><a class="code" href="classlibMesh_1_1PetscVector.php#a2589fe9ed56966da256d17ae0ed2aaa5">00975</a> <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;T&gt;</a> &gt; <a class="code" href="classlibMesh_1_1PetscVector.php#a2589fe9ed56966da256d17ae0ed2aaa5">PetscVector&lt;T&gt;::clone</a> ()<span class="keyword"> const</span>
<a name="l00976"></a>00976 <span class="keyword"></span>{
<a name="l00977"></a>00977   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;T&gt;</a> &gt; cloned_vector (<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1PetscVector.php">PetscVector&lt;T&gt;</a>);
<a name="l00978"></a>00978 
<a name="l00979"></a>00979   cloned_vector-&gt;init(*<span class="keyword">this</span>, <span class="keyword">true</span>);
<a name="l00980"></a>00980 
<a name="l00981"></a>00981   *cloned_vector = *<span class="keyword">this</span>;
<a name="l00982"></a>00982 
<a name="l00983"></a>00983   <span class="keywordflow">return</span> cloned_vector;
<a name="l00984"></a>00984 }
<a name="l00985"></a>00985 
<a name="l00986"></a>00986 
<a name="l00987"></a>00987 
<a name="l00988"></a>00988 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00989"></a>00989 <span class="keyword">inline</span>
<a name="l00990"></a><a class="code" href="classlibMesh_1_1PetscVector.php#ac4223fe11da95ce84aaf3187bc774544">00990</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1PetscVector.php#ac4223fe11da95ce84aaf3187bc774544">PetscVector&lt;T&gt;::size</a> ()<span class="keyword"> const</span>
<a name="l00991"></a>00991 <span class="keyword"></span>{
<a name="l00992"></a>00992   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00993"></a>00993   
<a name="l00994"></a>00994   <span class="keywordtype">int</span> ierr=0, petsc_size=0;
<a name="l00995"></a>00995   
<a name="l00996"></a>00996   <span class="keywordflow">if</span> (!this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>())
<a name="l00997"></a>00997     <span class="keywordflow">return</span> 0;
<a name="l00998"></a>00998   
<a name="l00999"></a>00999   ierr = VecGetSize(_vec, &amp;petsc_size);
<a name="l01000"></a>01000          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01001"></a>01001 
<a name="l01002"></a>01002   <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(petsc_size);
<a name="l01003"></a>01003 }
<a name="l01004"></a>01004 
<a name="l01005"></a>01005 
<a name="l01006"></a>01006 
<a name="l01007"></a>01007 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01008"></a>01008 <span class="keyword">inline</span>
<a name="l01009"></a><a class="code" href="classlibMesh_1_1PetscVector.php#a9586f2b97a6c61a35b36f8fbe4c3c944">01009</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a9586f2b97a6c61a35b36f8fbe4c3c944">PetscVector&lt;T&gt;::local_size</a> ()<span class="keyword"> const</span>
<a name="l01010"></a>01010 <span class="keyword"></span>{
<a name="l01011"></a>01011   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l01012"></a>01012   
<a name="l01013"></a>01013   <span class="keywordtype">int</span> ierr=0, petsc_size=0;
<a name="l01014"></a>01014   
<a name="l01015"></a>01015   ierr = VecGetLocalSize(_vec, &amp;petsc_size);
<a name="l01016"></a>01016          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01017"></a>01017   
<a name="l01018"></a>01018   <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(petsc_size);
<a name="l01019"></a>01019 }
<a name="l01020"></a>01020 
<a name="l01021"></a>01021 
<a name="l01022"></a>01022 
<a name="l01023"></a>01023 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01024"></a>01024 <span class="keyword">inline</span>
<a name="l01025"></a><a class="code" href="classlibMesh_1_1PetscVector.php#a24ba974e25d6f45320e44c6b09172445">01025</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a24ba974e25d6f45320e44c6b09172445">PetscVector&lt;T&gt;::first_local_index</a> ()<span class="keyword"> const</span>
<a name="l01026"></a>01026 <span class="keyword"></span>{
<a name="l01027"></a>01027   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l01028"></a>01028   
<a name="l01029"></a>01029   <span class="keywordtype">int</span> ierr=0, petsc_first=0, petsc_last=0;
<a name="l01030"></a>01030   
<a name="l01031"></a>01031   ierr = VecGetOwnershipRange (_vec, &amp;petsc_first, &amp;petsc_last);
<a name="l01032"></a>01032          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01033"></a>01033   
<a name="l01034"></a>01034   <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(petsc_first);
<a name="l01035"></a>01035 }
<a name="l01036"></a>01036 
<a name="l01037"></a>01037 
<a name="l01038"></a>01038 
<a name="l01039"></a>01039 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01040"></a>01040 <span class="keyword">inline</span>
<a name="l01041"></a><a class="code" href="classlibMesh_1_1PetscVector.php#a2e46f596e497108daaf43a994a789a25">01041</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a2e46f596e497108daaf43a994a789a25">PetscVector&lt;T&gt;::last_local_index</a> ()<span class="keyword"> const</span>
<a name="l01042"></a>01042 <span class="keyword"></span>{
<a name="l01043"></a>01043   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l01044"></a>01044   
<a name="l01045"></a>01045   <span class="keywordtype">int</span> ierr=0, petsc_first=0, petsc_last=0;
<a name="l01046"></a>01046   
<a name="l01047"></a>01047   ierr = VecGetOwnershipRange (_vec, &amp;petsc_first, &amp;petsc_last);
<a name="l01048"></a>01048          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01049"></a>01049   
<a name="l01050"></a>01050   <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(petsc_last);
<a name="l01051"></a>01051 }
<a name="l01052"></a>01052 
<a name="l01053"></a>01053 
<a name="l01054"></a>01054 
<a name="l01055"></a>01055 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01056"></a>01056 <span class="keyword">inline</span>
<a name="l01057"></a><a class="code" href="classlibMesh_1_1PetscVector.php#a03165d6ee0a36f6db8e5a7af1c794b44">01057</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a03165d6ee0a36f6db8e5a7af1c794b44">PetscVector&lt;T&gt;::map_global_to_local_index</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l01058"></a>01058 <span class="keyword"></span>{
<a name="l01059"></a>01059   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l01060"></a>01060 
<a name="l01061"></a>01061   <span class="keywordtype">int</span> ierr=0, petsc_first=0, petsc_last=0;
<a name="l01062"></a>01062   ierr = VecGetOwnershipRange (_vec, &amp;petsc_first, &amp;petsc_last);
<a name="l01063"></a>01063   CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01064"></a>01064   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> first = <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(petsc_first);
<a name="l01065"></a>01065   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> last = <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(petsc_last);
<a name="l01066"></a>01066 
<a name="l01067"></a>01067   <span class="keywordflow">if</span>((i&gt;=first) &amp;&amp; (i&lt;last))
<a name="l01068"></a>01068     {
<a name="l01069"></a>01069       <span class="keywordflow">return</span> i-first;
<a name="l01070"></a>01070     }
<a name="l01071"></a>01071 
<a name="l01072"></a>01072   GlobalToLocalMap::const_iterator it = _global_to_local_map.find(i);
<a name="l01073"></a>01073   libmesh_assert (it!=_global_to_local_map.end());
<a name="l01074"></a>01074   <span class="keywordflow">return</span> it-&gt;second+last-first;
<a name="l01075"></a>01075 }
<a name="l01076"></a>01076 
<a name="l01077"></a>01077 
<a name="l01078"></a>01078 
<a name="l01079"></a>01079 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01080"></a>01080 <span class="keyword">inline</span>
<a name="l01081"></a><a class="code" href="classlibMesh_1_1PetscVector.php#aed023fcdc606a1397a42db67462acf74">01081</a> T <a class="code" href="classlibMesh_1_1PetscVector.php#aed023fcdc606a1397a42db67462acf74">PetscVector&lt;T&gt;::operator() </a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l01082"></a>01082 <span class="keyword"></span>{
<a name="l01083"></a>01083   this-&gt;_get_array();
<a name="l01084"></a>01084 
<a name="l01085"></a>01085   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> local_index = this-&gt;map_global_to_local_index(i);
<a name="l01086"></a>01086 
<a name="l01087"></a>01087 <span class="preprocessor">#ifndef NDEBUG</span>
<a name="l01088"></a>01088 <span class="preprocessor"></span>  <span class="keywordflow">if</span>(this-&gt;type() == <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa9f12475bbe90a64ad167ec0b856ca6c1">GHOSTED</a>)
<a name="l01089"></a>01089     {
<a name="l01090"></a>01090       libmesh_assert(local_index&lt;_local_size);
<a name="l01091"></a>01091     }
<a name="l01092"></a>01092 <span class="preprocessor">#endif</span>
<a name="l01093"></a>01093 <span class="preprocessor"></span>  
<a name="l01094"></a>01094   <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span>T<span class="keyword">&gt;</span>(_values[local_index]);
<a name="l01095"></a>01095 }
<a name="l01096"></a>01096 
<a name="l01097"></a>01097 
<a name="l01098"></a>01098 
<a name="l01099"></a>01099 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01100"></a>01100 <span class="keyword">inline</span>
<a name="l01101"></a><a class="code" href="classlibMesh_1_1PetscVector.php#a68dacce6f7d72004375933057460ee8c">01101</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a68dacce6f7d72004375933057460ee8c">PetscVector&lt;T&gt;::get</a>(<span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; index, std::vector&lt;T&gt;&amp; values)<span class="keyword"> const</span>
<a name="l01102"></a>01102 <span class="keyword"></span>{
<a name="l01103"></a>01103   this-&gt;_get_array();
<a name="l01104"></a>01104 
<a name="l01105"></a>01105   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> num = index.size();
<a name="l01106"></a>01106   values.resize(num);
<a name="l01107"></a>01107 
<a name="l01108"></a>01108   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;num; i++)
<a name="l01109"></a>01109     {
<a name="l01110"></a>01110       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> local_index = this-&gt;map_global_to_local_index(index[i]);
<a name="l01111"></a>01111 <span class="preprocessor">#ifndef NDEBUG</span>
<a name="l01112"></a>01112 <span class="preprocessor"></span>      <span class="keywordflow">if</span>(this-&gt;type() == <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa9f12475bbe90a64ad167ec0b856ca6c1">GHOSTED</a>)
<a name="l01113"></a>01113         {
<a name="l01114"></a>01114           libmesh_assert(local_index&lt;_local_size);
<a name="l01115"></a>01115         }
<a name="l01116"></a>01116 <span class="preprocessor">#endif</span>
<a name="l01117"></a>01117 <span class="preprocessor"></span>      values[i] = <span class="keyword">static_cast&lt;</span>T<span class="keyword">&gt;</span>(_values[local_index]);
<a name="l01118"></a>01118     }
<a name="l01119"></a>01119 }
<a name="l01120"></a>01120 
<a name="l01121"></a>01121 
<a name="l01122"></a>01122 
<a name="l01123"></a>01123 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01124"></a>01124 <span class="keyword">inline</span>
<a name="l01125"></a><a class="code" href="classlibMesh_1_1PetscVector.php#ad6b3453051282426cf2d24a5f818694b">01125</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1PetscVector.php#ad6b3453051282426cf2d24a5f818694b">PetscVector&lt;T&gt;::min</a> ()<span class="keyword"> const</span>
<a name="l01126"></a>01126 <span class="keyword"></span>{
<a name="l01127"></a>01127   this-&gt;_restore_array();
<a name="l01128"></a>01128 
<a name="l01129"></a>01129   <span class="keywordtype">int</span> index=0, ierr=0;
<a name="l01130"></a>01130   PetscReal <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">min</a>=0.;
<a name="l01131"></a>01131 
<a name="l01132"></a>01132   ierr = VecMin (_vec, &amp;index, &amp;min);
<a name="l01133"></a>01133          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01134"></a>01134 
<a name="l01135"></a>01135   <span class="comment">// this return value is correct: VecMin returns a PetscReal</span>
<a name="l01136"></a>01136   <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a><span class="keyword">&gt;</span>(<a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">min</a>);
<a name="l01137"></a>01137 }
<a name="l01138"></a>01138 
<a name="l01139"></a>01139 
<a name="l01140"></a>01140 
<a name="l01141"></a>01141 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01142"></a>01142 <span class="keyword">inline</span>
<a name="l01143"></a><a class="code" href="classlibMesh_1_1PetscVector.php#a451166e5c22db1400d10ad95663570d9">01143</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1PetscVector.php#a451166e5c22db1400d10ad95663570d9">PetscVector&lt;T&gt;::max</a>()<span class="keyword"> const</span>
<a name="l01144"></a>01144 <span class="keyword"></span>{
<a name="l01145"></a>01145   this-&gt;_restore_array();
<a name="l01146"></a>01146 
<a name="l01147"></a>01147   <span class="keywordtype">int</span> index=0, ierr=0;
<a name="l01148"></a>01148   PetscReal <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">max</a>=0.;
<a name="l01149"></a>01149 
<a name="l01150"></a>01150   ierr = VecMax (_vec, &amp;index, &amp;max);
<a name="l01151"></a>01151          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01152"></a>01152 
<a name="l01153"></a>01153   <span class="comment">// this return value is correct: VecMax returns a PetscReal</span>
<a name="l01154"></a>01154   <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a><span class="keyword">&gt;</span>(<a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">max</a>);
<a name="l01155"></a>01155 }
<a name="l01156"></a>01156 
<a name="l01157"></a>01157 
<a name="l01158"></a>01158 
<a name="l01159"></a>01159 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01160"></a>01160 <span class="keyword">inline</span>
<a name="l01161"></a><a class="code" href="classlibMesh_1_1PetscVector.php#a7ddbc3123946cc4f3d1bdf9831b10ea1">01161</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a7ddbc3123946cc4f3d1bdf9831b10ea1">PetscVector&lt;T&gt;::swap</a> (<a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp;other)
<a name="l01162"></a>01162 {
<a name="l01163"></a>01163   <a class="code" href="classlibMesh_1_1NumericVector.php#a4a3bb09ff24810391b15da006ba39cb4">NumericVector&lt;T&gt;::swap</a>(other);
<a name="l01164"></a>01164 
<a name="l01165"></a>01165   <a class="code" href="classlibMesh_1_1PetscVector.php">PetscVector&lt;T&gt;</a>&amp; v = libmesh_cast_ref&lt;PetscVector&lt;T&gt;&amp;&gt;(other);
<a name="l01166"></a>01166 
<a name="l01167"></a>01167   std::swap(_vec, v.<a class="code" href="classlibMesh_1_1PetscVector.php#ad5a8a89fa15de5f7bb6fb2d5ab62dea0">_vec</a>);
<a name="l01168"></a>01168   std::swap(_destroy_vec_on_exit, v.<a class="code" href="classlibMesh_1_1PetscVector.php#ae7bb1316f1184ca49794ba697f81be92">_destroy_vec_on_exit</a>);
<a name="l01169"></a>01169   std::swap(_global_to_local_map, v.<a class="code" href="classlibMesh_1_1PetscVector.php#ac28fe132e16a1de3b1521b2aedef05ce">_global_to_local_map</a>);
<a name="l01170"></a>01170   std::swap(_array_is_present, v.<a class="code" href="classlibMesh_1_1PetscVector.php#ae10345bff1d65f2b84f7d16c6c7b538c">_array_is_present</a>);
<a name="l01171"></a>01171   std::swap(_local_form, v.<a class="code" href="classlibMesh_1_1PetscVector.php#a04af5355d6a0463f3466750d77143f02">_local_form</a>);
<a name="l01172"></a>01172   std::swap(_values, v.<a class="code" href="classlibMesh_1_1PetscVector.php#a6a4fcd82f63d93f1f4b8d94c154ce2ac">_values</a>);
<a name="l01173"></a>01173 }
<a name="l01174"></a>01174 
<a name="l01175"></a>01175 
<a name="l01176"></a>01176 
<a name="l01177"></a>01177 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01178"></a>01178 <span class="keyword">inline</span>
<a name="l01179"></a><a class="code" href="classlibMesh_1_1PetscVector.php#aa2b346d42c670f3de26d2f96a0a22dcb">01179</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#aa2b346d42c670f3de26d2f96a0a22dcb">PetscVector&lt;T&gt;::_get_array</a>(<span class="keywordtype">void</span>)<span class="keyword"> const</span>
<a name="l01180"></a>01180 <span class="keyword"></span>{
<a name="l01181"></a>01181   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l01182"></a>01182   <span class="keywordflow">if</span>(!_array_is_present)
<a name="l01183"></a>01183     {
<a name="l01184"></a>01184       <span class="keywordtype">int</span> ierr=0;
<a name="l01185"></a>01185       <span class="keywordflow">if</span>(this-&gt;type() != <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa9f12475bbe90a64ad167ec0b856ca6c1">GHOSTED</a>)
<a name="l01186"></a>01186         {
<a name="l01187"></a>01187           ierr = VecGetArray(_vec, &amp;_values);
<a name="l01188"></a>01188           CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01189"></a>01189         }
<a name="l01190"></a>01190       <span class="keywordflow">else</span>
<a name="l01191"></a>01191         {
<a name="l01192"></a>01192           ierr = VecGhostGetLocalForm (_vec,&amp;_local_form);
<a name="l01193"></a>01193           CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01194"></a>01194           ierr = VecGetArray(_local_form, &amp;_values);
<a name="l01195"></a>01195           CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01196"></a>01196 <span class="preprocessor">#ifndef NDEBUG</span>
<a name="l01197"></a>01197 <span class="preprocessor"></span>          <span class="keywordtype">int</span> local_size = 0;
<a name="l01198"></a>01198           ierr = VecGetLocalSize(_local_form, &amp;local_size);
<a name="l01199"></a>01199           CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01200"></a>01200           _local_size = <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(local_size);
<a name="l01201"></a>01201 <span class="preprocessor">#endif</span>
<a name="l01202"></a>01202 <span class="preprocessor"></span>        }
<a name="l01203"></a>01203       _array_is_present = <span class="keyword">true</span>;
<a name="l01204"></a>01204     }
<a name="l01205"></a>01205 }
<a name="l01206"></a>01206 
<a name="l01207"></a>01207 
<a name="l01208"></a>01208 
<a name="l01209"></a>01209 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01210"></a>01210 <span class="keyword">inline</span>
<a name="l01211"></a><a class="code" href="classlibMesh_1_1PetscVector.php#adf26b52e8c4b03874a572389f00d4f9b">01211</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#adf26b52e8c4b03874a572389f00d4f9b">PetscVector&lt;T&gt;::_restore_array</a>(<span class="keywordtype">void</span>)<span class="keyword"> const</span>
<a name="l01212"></a>01212 <span class="keyword"></span>{
<a name="l01213"></a>01213   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l01214"></a>01214   <span class="keywordflow">if</span>(_array_is_present)
<a name="l01215"></a>01215     {
<a name="l01216"></a>01216       <span class="keywordtype">int</span> ierr=0;
<a name="l01217"></a>01217       <span class="keywordflow">if</span>(this-&gt;type() != <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa9f12475bbe90a64ad167ec0b856ca6c1">GHOSTED</a>)
<a name="l01218"></a>01218         {
<a name="l01219"></a>01219           ierr = VecRestoreArray (_vec, &amp;_values);
<a name="l01220"></a>01220           CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01221"></a>01221           _values = NULL;
<a name="l01222"></a>01222         }
<a name="l01223"></a>01223       <span class="keywordflow">else</span>
<a name="l01224"></a>01224         {
<a name="l01225"></a>01225           ierr = VecRestoreArray (_local_form, &amp;_values);
<a name="l01226"></a>01226           CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01227"></a>01227           _values = NULL;
<a name="l01228"></a>01228           ierr = VecGhostRestoreLocalForm (_vec,&amp;_local_form);
<a name="l01229"></a>01229           CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01230"></a>01230           _local_form = NULL;
<a name="l01231"></a>01231 <span class="preprocessor">#ifndef NDEBUG</span>
<a name="l01232"></a>01232 <span class="preprocessor"></span>          _local_size = 0;
<a name="l01233"></a>01233 <span class="preprocessor">#endif</span>
<a name="l01234"></a>01234 <span class="preprocessor"></span>        }
<a name="l01235"></a>01235       _array_is_present = <span class="keyword">false</span>;
<a name="l01236"></a>01236     }
<a name="l01237"></a>01237 }
<a name="l01238"></a>01238 
<a name="l01239"></a>01239 
<a name="l01240"></a>01240 } <span class="comment">// namespace libMesh</span>
<a name="l01241"></a>01241 
<a name="l01242"></a>01242 
<a name="l01243"></a>01243 <span class="preprocessor">#endif // #ifdef LIBMESH_HAVE_PETSC</span>
<a name="l01244"></a>01244 <span class="preprocessor"></span><span class="preprocessor">#endif // #ifdef __petsc_vector_h__</span>
<a name="l01245"></a>01245 <span class="preprocessor"></span>
<a name="l01246"></a>01246 
<a name="l01247"></a>01247 
<a name="l01248"></a>01248 
<a name="l01249"></a>01249 
<a name="l01250"></a>01250 
<a name="l01251"></a>01251 
<a name="l01252"></a>01252 
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
