<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_c3a49989e40b21e7508f29d2dc962def.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_94af86d0ee7ff5a2af0627e1a0ea6efa.php">systems</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">qn_transient_rb_context.C</div>  </div>
</div>
<div class="contents">
<a href="qn__transient__rb__context_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// rbOOmit: An implementation of the Certified Reduced Basis method.</span>
<a name="l00002"></a>00002 <span class="comment">// Copyright (C) 2009, 2010 David J. Knezevic</span>
<a name="l00003"></a>00003 
<a name="l00004"></a>00004 <span class="comment">// This file is part of rbOOmit.</span>
<a name="l00005"></a>00005 
<a name="l00006"></a>00006 <span class="comment">// rbOOmit is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// rbOOmit is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="comment">// Configuration data</span>
<a name="l00021"></a>00021 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>&quot;</span>
<a name="l00022"></a>00022 
<a name="l00023"></a>00023 <span class="comment">// Depends on the QNTransientRBSystem, which requires SLEPC</span>
<a name="l00024"></a>00024 <span class="preprocessor">#if defined(LIBMESH_HAVE_SLEPC) &amp;&amp; (LIBMESH_HAVE_GLPK)</span>
<a name="l00025"></a>00025 <span class="preprocessor"></span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="qn__transient__rb__context_8h.php">qn_transient_rb_context.h</a>&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="qn__transient__rb__system_8h.php">qn_transient_rb_system.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="dof__map_8h.php">dof_map.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="elem_8h.php">elem.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="fe__base_8h.php">fe_base.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="fe__interface_8h.php">fe_interface.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="keyword">namespace </span>libMesh
<a name="l00034"></a>00034 {
<a name="l00035"></a>00035 
<a name="l00036"></a><a class="code" href="classlibMesh_1_1QNTransientRBContext.php#a4e332833e7a6cb349fe61a8e1fb68908">00036</a> <a class="code" href="classlibMesh_1_1QNTransientRBContext.php#a4e332833e7a6cb349fe61a8e1fb68908">QNTransientRBContext::QNTransientRBContext</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php">QNTransientRBSystem</a>&amp; sys) :
<a name="l00037"></a>00037   <a class="code" href="classlibMesh_1_1FEMContext.php">FEMContext</a>(sys)
<a name="l00038"></a>00038 {
<a name="l00039"></a>00039   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="tecplot__io_8C.php#ac001e4247887b98c2aa5b8ec5107ca0d">n_vars</a> = sys.<a class="code" href="classlibMesh_1_1System.php#a4cf032eda109fe32a7fcde672ef5726e">n_vars</a>();
<a name="l00040"></a>00040   <a class="code" href="classlibMesh_1_1QNTransientRBContext.php#ab79361d5f71905c8b31c27def2e891d3">elem_old_subsolutions</a>.reserve(n_vars);
<a name="l00041"></a>00041 
<a name="l00042"></a>00042   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != <a class="code" href="tecplot__io_8C.php#ac001e4247887b98c2aa5b8ec5107ca0d">n_vars</a>; ++i)
<a name="l00043"></a>00043   {
<a name="l00044"></a>00044     <a class="code" href="classlibMesh_1_1QNTransientRBContext.php#ab79361d5f71905c8b31c27def2e891d3">elem_old_subsolutions</a>.push_back(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1DenseSubVector.php">DenseSubVector&lt;Number&gt;</a>(<a class="code" href="classlibMesh_1_1QNTransientRBContext.php#a38a0fddb45edcb81bd0c01a47bb302aa">elem_old_solution</a>));
<a name="l00045"></a>00045   }
<a name="l00046"></a>00046 }
<a name="l00047"></a>00047 
<a name="l00048"></a><a class="code" href="classlibMesh_1_1QNTransientRBContext.php#ada36cab88e482fbd0b2de8c6b825205f">00048</a> <a class="code" href="classlibMesh_1_1QNTransientRBContext.php#ada36cab88e482fbd0b2de8c6b825205f">QNTransientRBContext::~QNTransientRBContext</a> ()
<a name="l00049"></a>00049 {
<a name="l00050"></a>00050   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != <a class="code" href="classlibMesh_1_1QNTransientRBContext.php#ab79361d5f71905c8b31c27def2e891d3">elem_old_subsolutions</a>.size(); ++i)
<a name="l00051"></a>00051   {
<a name="l00052"></a>00052     <span class="keyword">delete</span> <a class="code" href="classlibMesh_1_1QNTransientRBContext.php#ab79361d5f71905c8b31c27def2e891d3">elem_old_subsolutions</a>[i];
<a name="l00053"></a>00053   }
<a name="l00054"></a>00054 }
<a name="l00055"></a>00055 
<a name="l00056"></a><a class="code" href="classlibMesh_1_1QNTransientRBContext.php#a860b5ca32726d0490f5ceb9646f5cbc4">00056</a> <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> <a class="code" href="classlibMesh_1_1QNTransientRBContext.php#a860b5ca32726d0490f5ceb9646f5cbc4">QNTransientRBContext::old_interior_value</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp)
<a name="l00057"></a>00057 {
<a name="l00058"></a>00058   <span class="comment">// Get local-to-global dof index lookup</span>
<a name="l00059"></a>00059   libmesh_assert (<a class="code" href="classlibMesh_1_1DiffContext.php#a66eb0ba364350d256552d872f30c9b34">dof_indices</a>.size() &gt; var);
<a name="l00060"></a>00060   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_dofs = <a class="code" href="classlibMesh_1_1DiffContext.php#a7d609caec46d2087753fffc144da7264">dof_indices_var</a>[var].size();
<a name="l00061"></a>00061 
<a name="l00062"></a>00062   <span class="comment">// Get current local coefficients</span>
<a name="l00063"></a>00063   libmesh_assert (<a class="code" href="classlibMesh_1_1QNTransientRBContext.php#ab79361d5f71905c8b31c27def2e891d3">elem_old_subsolutions</a>.size() &gt; var);
<a name="l00064"></a>00064   libmesh_assert (<a class="code" href="classlibMesh_1_1QNTransientRBContext.php#ab79361d5f71905c8b31c27def2e891d3">elem_old_subsolutions</a>[var] != NULL);
<a name="l00065"></a>00065   <a class="code" href="classlibMesh_1_1DenseSubVector.php">DenseSubVector&lt;Number&gt;</a> &amp;coef = *<a class="code" href="classlibMesh_1_1QNTransientRBContext.php#ab79361d5f71905c8b31c27def2e891d3">elem_old_subsolutions</a>[var];
<a name="l00066"></a>00066 
<a name="l00067"></a>00067   <span class="comment">// Get shape function values at quadrature point</span>
<a name="l00068"></a>00068   <span class="keyword">const</span> std::vector&lt;std::vector&lt;Real&gt; &gt; &amp;phi =
<a name="l00069"></a>00069     <a class="code" href="classlibMesh_1_1FEMContext.php#ab383f19798c04ded72cff9f031c7e626">element_fe_var</a>[var]-&gt;get_phi();
<a name="l00070"></a>00070 
<a name="l00071"></a>00071   <span class="comment">// Accumulate solution value</span>
<a name="l00072"></a>00072   <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> u_old = 0.;
<a name="l00073"></a>00073 
<a name="l00074"></a>00074   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> l=0; l != n_dofs; l++)
<a name="l00075"></a>00075     u_old += phi[l][qp] * coef(l);
<a name="l00076"></a>00076 
<a name="l00077"></a>00077   <span class="keywordflow">return</span> u_old;
<a name="l00078"></a>00078 }
<a name="l00079"></a>00079 
<a name="l00080"></a><a class="code" href="classlibMesh_1_1QNTransientRBContext.php#a1d381eef8a20340a90245f60f764ca7d">00080</a> <a class="code" href="classlibMesh_1_1VectorValue.php">Gradient</a> <a class="code" href="classlibMesh_1_1QNTransientRBContext.php#a1d381eef8a20340a90245f60f764ca7d">QNTransientRBContext::old_interior_gradient</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp)
<a name="l00081"></a>00081 {
<a name="l00082"></a>00082   <span class="comment">// Get local-to-global dof index lookup</span>
<a name="l00083"></a>00083   libmesh_assert (<a class="code" href="classlibMesh_1_1DiffContext.php#a66eb0ba364350d256552d872f30c9b34">dof_indices</a>.size() &gt; var);
<a name="l00084"></a>00084   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_dofs = <a class="code" href="classlibMesh_1_1DiffContext.php#a7d609caec46d2087753fffc144da7264">dof_indices_var</a>[var].size();
<a name="l00085"></a>00085 
<a name="l00086"></a>00086   <span class="comment">// Get current local coefficients</span>
<a name="l00087"></a>00087   libmesh_assert (<a class="code" href="classlibMesh_1_1QNTransientRBContext.php#ab79361d5f71905c8b31c27def2e891d3">elem_old_subsolutions</a>.size() &gt; var);
<a name="l00088"></a>00088   libmesh_assert (<a class="code" href="classlibMesh_1_1QNTransientRBContext.php#ab79361d5f71905c8b31c27def2e891d3">elem_old_subsolutions</a>[var] != NULL);
<a name="l00089"></a>00089   <a class="code" href="classlibMesh_1_1DenseSubVector.php">DenseSubVector&lt;Number&gt;</a> &amp;coef = *<a class="code" href="classlibMesh_1_1QNTransientRBContext.php#ab79361d5f71905c8b31c27def2e891d3">elem_old_subsolutions</a>[var];
<a name="l00090"></a>00090 
<a name="l00091"></a>00091   <span class="comment">// Get shape function values at quadrature point</span>
<a name="l00092"></a>00092   <span class="keyword">const</span> std::vector&lt;std::vector&lt;RealGradient&gt; &gt; &amp;dphi =
<a name="l00093"></a>00093     <a class="code" href="classlibMesh_1_1FEMContext.php#ab383f19798c04ded72cff9f031c7e626">element_fe_var</a>[var]-&gt;get_dphi();
<a name="l00094"></a>00094 
<a name="l00095"></a>00095   <span class="comment">// Accumulate solution derivatives</span>
<a name="l00096"></a>00096   <a class="code" href="classlibMesh_1_1VectorValue.php">Gradient</a> old_du;
<a name="l00097"></a>00097 
<a name="l00098"></a>00098   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> l=0; l != n_dofs; l++)
<a name="l00099"></a>00099     old_du.<a class="code" href="classlibMesh_1_1TypeVector.php#aaf2f65f39d9cdb06500baa2d571dc27f">add_scaled</a>(dphi[l][qp], coef(l));
<a name="l00100"></a>00100 
<a name="l00101"></a>00101   <span class="keywordflow">return</span> old_du;
<a name="l00102"></a>00102 }
<a name="l00103"></a>00103 
<a name="l00104"></a><a class="code" href="classlibMesh_1_1QNTransientRBContext.php#ab537fd4ba735523e9eab295023da86fe">00104</a> <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> <a class="code" href="classlibMesh_1_1QNTransientRBContext.php#ab537fd4ba735523e9eab295023da86fe">QNTransientRBContext::old_side_value</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp)
<a name="l00105"></a>00105 {
<a name="l00106"></a>00106   <span class="comment">// Get local-to-global dof index lookup</span>
<a name="l00107"></a>00107   libmesh_assert (<a class="code" href="classlibMesh_1_1DiffContext.php#a66eb0ba364350d256552d872f30c9b34">dof_indices</a>.size() &gt; var);
<a name="l00108"></a>00108   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_dofs = <a class="code" href="classlibMesh_1_1DiffContext.php#a7d609caec46d2087753fffc144da7264">dof_indices_var</a>[var].size();
<a name="l00109"></a>00109 
<a name="l00110"></a>00110   <span class="comment">// Get current local coefficients</span>
<a name="l00111"></a>00111   libmesh_assert (<a class="code" href="classlibMesh_1_1QNTransientRBContext.php#ab79361d5f71905c8b31c27def2e891d3">elem_old_subsolutions</a>.size() &gt; var);
<a name="l00112"></a>00112   libmesh_assert (<a class="code" href="classlibMesh_1_1QNTransientRBContext.php#ab79361d5f71905c8b31c27def2e891d3">elem_old_subsolutions</a>[var] != NULL);
<a name="l00113"></a>00113   <a class="code" href="classlibMesh_1_1DenseSubVector.php">DenseSubVector&lt;Number&gt;</a> &amp;coef = *<a class="code" href="classlibMesh_1_1QNTransientRBContext.php#ab79361d5f71905c8b31c27def2e891d3">elem_old_subsolutions</a>[var];
<a name="l00114"></a>00114 
<a name="l00115"></a>00115   <span class="comment">// Get shape function values at quadrature point</span>
<a name="l00116"></a>00116   <span class="keyword">const</span> std::vector&lt;std::vector&lt;Real&gt; &gt; &amp;phi =
<a name="l00117"></a>00117     <a class="code" href="classlibMesh_1_1FEMContext.php#aa644b54642e805d250857318efddb969">side_fe_var</a>[var]-&gt;get_phi();
<a name="l00118"></a>00118 
<a name="l00119"></a>00119   <span class="comment">// Accumulate solution value</span>
<a name="l00120"></a>00120   <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> u_old = 0.;
<a name="l00121"></a>00121 
<a name="l00122"></a>00122   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> l=0; l != n_dofs; l++)
<a name="l00123"></a>00123     u_old += phi[l][qp] * coef(l);
<a name="l00124"></a>00124 
<a name="l00125"></a>00125   <span class="keywordflow">return</span> u_old;
<a name="l00126"></a>00126 }
<a name="l00127"></a>00127 
<a name="l00128"></a><a class="code" href="classlibMesh_1_1QNTransientRBContext.php#a158eafc9e798500f9457b38199102b81">00128</a> <a class="code" href="classlibMesh_1_1VectorValue.php">Gradient</a> <a class="code" href="classlibMesh_1_1QNTransientRBContext.php#a158eafc9e798500f9457b38199102b81">QNTransientRBContext::old_side_gradient</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp)
<a name="l00129"></a>00129 {
<a name="l00130"></a>00130   <span class="comment">// Get local-to-global dof index lookup</span>
<a name="l00131"></a>00131   libmesh_assert (<a class="code" href="classlibMesh_1_1DiffContext.php#a66eb0ba364350d256552d872f30c9b34">dof_indices</a>.size() &gt; var);
<a name="l00132"></a>00132   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_dofs = <a class="code" href="classlibMesh_1_1DiffContext.php#a7d609caec46d2087753fffc144da7264">dof_indices_var</a>[var].size();
<a name="l00133"></a>00133 
<a name="l00134"></a>00134   <span class="comment">// Get current local coefficients</span>
<a name="l00135"></a>00135   libmesh_assert (<a class="code" href="classlibMesh_1_1QNTransientRBContext.php#ab79361d5f71905c8b31c27def2e891d3">elem_old_subsolutions</a>.size() &gt; var);
<a name="l00136"></a>00136   libmesh_assert (<a class="code" href="classlibMesh_1_1QNTransientRBContext.php#ab79361d5f71905c8b31c27def2e891d3">elem_old_subsolutions</a>[var] != NULL);
<a name="l00137"></a>00137   <a class="code" href="classlibMesh_1_1DenseSubVector.php">DenseSubVector&lt;Number&gt;</a> &amp;coef = *<a class="code" href="classlibMesh_1_1QNTransientRBContext.php#ab79361d5f71905c8b31c27def2e891d3">elem_old_subsolutions</a>[var];
<a name="l00138"></a>00138 
<a name="l00139"></a>00139   <span class="comment">// Get shape function values at quadrature point</span>
<a name="l00140"></a>00140   <span class="keyword">const</span> std::vector&lt;std::vector&lt;RealGradient&gt; &gt; &amp;dphi =
<a name="l00141"></a>00141     <a class="code" href="classlibMesh_1_1FEMContext.php#aa644b54642e805d250857318efddb969">side_fe_var</a>[var]-&gt;get_dphi();
<a name="l00142"></a>00142 
<a name="l00143"></a>00143   <span class="comment">// Accumulate solution derivatives</span>
<a name="l00144"></a>00144   <a class="code" href="classlibMesh_1_1VectorValue.php">Gradient</a> du_old;
<a name="l00145"></a>00145 
<a name="l00146"></a>00146   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> l=0; l != n_dofs; l++)
<a name="l00147"></a>00147     du_old.<a class="code" href="classlibMesh_1_1TypeVector.php#aaf2f65f39d9cdb06500baa2d571dc27f">add_scaled</a>(dphi[l][qp], coef(l));
<a name="l00148"></a>00148 
<a name="l00149"></a>00149   <span class="keywordflow">return</span> du_old;
<a name="l00150"></a>00150 }
<a name="l00151"></a>00151 
<a name="l00152"></a><a class="code" href="classlibMesh_1_1QNTransientRBContext.php#ab0ce4e9ab65a50f75f388b9825d47d26">00152</a> <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> <a class="code" href="classlibMesh_1_1QNTransientRBContext.php#ab0ce4e9ab65a50f75f388b9825d47d26">QNTransientRBContext::old_point_value</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var, <a class="code" href="classlibMesh_1_1Point.php">Point</a> &amp;p)
<a name="l00153"></a>00153 {
<a name="l00154"></a>00154   <span class="comment">// Get local-to-global dof index lookup</span>
<a name="l00155"></a>00155   libmesh_assert (<a class="code" href="classlibMesh_1_1DiffContext.php#a66eb0ba364350d256552d872f30c9b34">dof_indices</a>.size() &gt; var);
<a name="l00156"></a>00156   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_dofs = <a class="code" href="classlibMesh_1_1DiffContext.php#a7d609caec46d2087753fffc144da7264">dof_indices_var</a>[var].size();
<a name="l00157"></a>00157 
<a name="l00158"></a>00158 
<a name="l00159"></a>00159   <span class="comment">// Get current local coefficients</span>
<a name="l00160"></a>00160   libmesh_assert (<a class="code" href="classlibMesh_1_1QNTransientRBContext.php#ab79361d5f71905c8b31c27def2e891d3">elem_old_subsolutions</a>.size() &gt; var);
<a name="l00161"></a>00161   libmesh_assert (<a class="code" href="classlibMesh_1_1QNTransientRBContext.php#ab79361d5f71905c8b31c27def2e891d3">elem_old_subsolutions</a>[var] != NULL);
<a name="l00162"></a>00162   <a class="code" href="classlibMesh_1_1DenseSubVector.php">DenseSubVector&lt;Number&gt;</a> &amp;coef = *<a class="code" href="classlibMesh_1_1QNTransientRBContext.php#ab79361d5f71905c8b31c27def2e891d3">elem_old_subsolutions</a>[var];
<a name="l00163"></a>00163 
<a name="l00164"></a>00164   <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> u_old = 0.;
<a name="l00165"></a>00165 
<a name="l00166"></a>00166   <a class="code" href="classlibMesh_1_1FEType.php">FEType</a> fe_type = <a class="code" href="classlibMesh_1_1FEMContext.php#ab383f19798c04ded72cff9f031c7e626">element_fe_var</a>[var]-&gt;get_fe_type();
<a name="l00167"></a>00167   <a class="code" href="classlibMesh_1_1Point.php">Point</a> p_master = <a class="code" href="classlibMesh_1_1FEInterface.php#aa4cd7cde33c7f4b7f873d2fdad6fb635">FEInterface::inverse_map</a>(<a class="code" href="classlibMesh_1_1FEMContext.php#a0f3b4c6fec7a890efe1ceebcec8ad2e9">dim</a>, fe_type, <a class="code" href="classlibMesh_1_1FEMContext.php#ab6f9bf4e40120dd6b18e6da4f12c3cc8">elem</a>, p);
<a name="l00168"></a>00168 
<a name="l00169"></a>00169   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> l=0; l != n_dofs; l++)
<a name="l00170"></a>00170     u_old += <a class="code" href="classlibMesh_1_1FEInterface.php#a17412c020fcf8e4cba13e2da4ec39ef8">FEInterface::shape</a>(<a class="code" href="classlibMesh_1_1FEMContext.php#a0f3b4c6fec7a890efe1ceebcec8ad2e9">dim</a>, fe_type, <a class="code" href="classlibMesh_1_1FEMContext.php#ab6f9bf4e40120dd6b18e6da4f12c3cc8">elem</a>, l, p_master)
<a name="l00171"></a>00171          * coef(l);
<a name="l00172"></a>00172 
<a name="l00173"></a>00173   <span class="keywordflow">return</span> u_old;
<a name="l00174"></a>00174 }
<a name="l00175"></a>00175 
<a name="l00176"></a><a class="code" href="classlibMesh_1_1QNTransientRBContext.php#a799f91a3681004e67e3cef1a79032605">00176</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QNTransientRBContext.php#a799f91a3681004e67e3cef1a79032605">QNTransientRBContext::pre_fe_reinit</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a> &amp;sys, <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *e)
<a name="l00177"></a>00177 {
<a name="l00178"></a>00178   <a class="code" href="classlibMesh_1_1QNTransientRBContext.php#a799f91a3681004e67e3cef1a79032605">FEMContext::pre_fe_reinit</a>(sys, e);
<a name="l00179"></a>00179         
<a name="l00180"></a>00180   <span class="comment">// sys must be a QNTransientRBSystem</span>
<a name="l00181"></a>00181   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php">QNTransientRBSystem</a>&amp; qn_system = libmesh_cast_ref&lt;const QNTransientRBSystem&amp;&gt;(sys);
<a name="l00182"></a>00182 
<a name="l00183"></a>00183   <a class="code" href="classlibMesh_1_1FEMContext.php#ab6f9bf4e40120dd6b18e6da4f12c3cc8">elem</a> = e;
<a name="l00184"></a>00184   <span class="comment">// Initialize the per-element data for elem.</span>
<a name="l00185"></a>00185   qn_system.<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>().<a class="code" href="classlibMesh_1_1DofMap.php#a5dac22ba99a9da3563c00b7dfd2f07af">dof_indices</a> (elem, <a class="code" href="classlibMesh_1_1DiffContext.php#a66eb0ba364350d256552d872f30c9b34">dof_indices</a>);
<a name="l00186"></a>00186   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_dofs = <a class="code" href="classlibMesh_1_1DiffContext.php#a66eb0ba364350d256552d872f30c9b34">dof_indices</a>.size();
<a name="l00187"></a>00187 
<a name="l00188"></a>00188   <a class="code" href="classlibMesh_1_1QNTransientRBContext.php#a38a0fddb45edcb81bd0c01a47bb302aa">elem_old_solution</a>.<a class="code" href="classlibMesh_1_1DenseVector.php#a08430ae781094632e8272cbb825d4f44">resize</a>(n_dofs);
<a name="l00189"></a>00189 
<a name="l00190"></a>00190   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != n_dofs; ++i)
<a name="l00191"></a>00191   {
<a name="l00192"></a>00192     <a class="code" href="classlibMesh_1_1QNTransientRBContext.php#a38a0fddb45edcb81bd0c01a47bb302aa">elem_old_solution</a>(i) = qn_system.<a class="code" href="classlibMesh_1_1TransientSystem.php#a6fd0aa7c5dc3b811b96a5ece10ecf0cd">old_solution</a>(<a class="code" href="classlibMesh_1_1DiffContext.php#a66eb0ba364350d256552d872f30c9b34">dof_indices</a>[i]);
<a name="l00193"></a>00193 
<a name="l00194"></a>00194     <span class="comment">// overwrite with current_newton_iterate data</span>
<a name="l00195"></a>00195     <a class="code" href="classlibMesh_1_1DiffContext.php#a37ecd0ccb2abf2abe8f5dbbff52daf4a">elem_solution</a>(i) = (*qn_system.<a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#acb60710609da05611e7d440eb79a66ff">current_newton_iterate</a>)(<a class="code" href="classlibMesh_1_1DiffContext.php#a66eb0ba364350d256552d872f30c9b34">dof_indices</a>[i]);
<a name="l00196"></a>00196   }
<a name="l00197"></a>00197 
<a name="l00198"></a>00198   <span class="comment">// Initialize the per-variable data for elem.</span>
<a name="l00199"></a>00199   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sub_dofs = 0;
<a name="l00200"></a>00200   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != qn_system.<a class="code" href="classlibMesh_1_1System.php#a4cf032eda109fe32a7fcde672ef5726e">n_vars</a>(); ++i)
<a name="l00201"></a>00201     {
<a name="l00202"></a>00202       qn_system.<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>().<a class="code" href="classlibMesh_1_1DofMap.php#a5dac22ba99a9da3563c00b7dfd2f07af">dof_indices</a> (elem, <a class="code" href="classlibMesh_1_1DiffContext.php#a7d609caec46d2087753fffc144da7264">dof_indices_var</a>[i], i);
<a name="l00203"></a>00203 
<a name="l00204"></a>00204       <a class="code" href="classlibMesh_1_1QNTransientRBContext.php#ab79361d5f71905c8b31c27def2e891d3">elem_old_subsolutions</a>[i]-&gt;reposition
<a name="l00205"></a>00205         (sub_dofs, <a class="code" href="classlibMesh_1_1DiffContext.php#a7d609caec46d2087753fffc144da7264">dof_indices_var</a>[i].size());
<a name="l00206"></a>00206 
<a name="l00207"></a>00207       sub_dofs += <a class="code" href="classlibMesh_1_1DiffContext.php#a7d609caec46d2087753fffc144da7264">dof_indices_var</a>[i].size();
<a name="l00208"></a>00208     }
<a name="l00209"></a>00209   libmesh_assert(sub_dofs == n_dofs);
<a name="l00210"></a>00210 }
<a name="l00211"></a>00211 
<a name="l00212"></a>00212 } <span class="comment">// namespace libMesh</span>
<a name="l00213"></a>00213 
<a name="l00214"></a>00214 
<a name="l00215"></a>00215 <span class="preprocessor">#endif // LIBMESH_HAVE_SLEPC &amp;&amp; LIBMESH_HAVE_GLPK</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
