<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_eaf30c8ea092d33f79a04353c3899c3f.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_5a0c7151fa56969ceb962f1511f7edee.php">systems</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">qn_transient_rb_context.h</div>  </div>
</div>
<div class="contents">
<a href="qn__transient__rb__context_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// rbOOmit: An implementation of the Certified Reduced Basis method.</span>
<a name="l00002"></a>00002 <span class="comment">// Copyright (C) 2009, 2010 David J. Knezevic</span>
<a name="l00003"></a>00003 
<a name="l00004"></a>00004 <span class="comment">// This file is part of rbOOmit.</span>
<a name="l00005"></a>00005 
<a name="l00006"></a>00006 <span class="comment">// rbOOmit is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// rbOOmit is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="preprocessor">#ifndef __qn_transient_rb_context_h__</span>
<a name="l00021"></a>00021 <span class="preprocessor"></span><span class="preprocessor">#define __qn_transient_rb_context_h__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span>
<a name="l00023"></a>00023 <span class="comment">// Configuration data</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>&quot;</span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// Depends on the QNTransientRBSystem, which requires SLEPC</span>
<a name="l00027"></a>00027 <span class="preprocessor">#if defined(LIBMESH_HAVE_SLEPC) &amp;&amp; (LIBMESH_HAVE_GLPK)</span>
<a name="l00028"></a>00028 <span class="preprocessor"></span>
<a name="l00029"></a>00029 <span class="comment">// Local Includes</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="elem_8h.php">elem.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="fe__type_8h.php">fe_type.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="fem__context_8h.php">fem_context.h</a>&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="keyword">namespace </span>libMesh
<a name="l00035"></a>00035 {
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="comment">// Forward declaration</span>
<a name="l00038"></a>00038 <span class="keyword">class </span>QNTransientRBSystem;
<a name="l00039"></a>00039 <span class="keyword">class </span>FEBase;
<a name="l00040"></a>00040 <span class="keyword">class </span>QBase;
<a name="l00041"></a>00041 
<a name="l00051"></a>00051 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00052"></a>00052 <span class="comment">// QNTransientRBContext class definition</span>
<a name="l00053"></a>00053 
<a name="l00054"></a><a class="code" href="classlibMesh_1_1QNTransientRBContext.php">00054</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1QNTransientRBContext.php">QNTransientRBContext</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1FEMContext.php">FEMContext</a>
<a name="l00055"></a>00055 {
<a name="l00056"></a>00056 <span class="keyword">public</span>:
<a name="l00057"></a>00057 
<a name="l00062"></a>00062   <a class="code" href="classlibMesh_1_1QNTransientRBContext.php#a4e332833e7a6cb349fe61a8e1fb68908">QNTransientRBContext</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php">QNTransientRBSystem</a> &amp;);
<a name="l00063"></a>00063 
<a name="l00067"></a>00067   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1QNTransientRBContext.php#ada36cab88e482fbd0b2de8c6b825205f">~QNTransientRBContext</a> ();
<a name="l00068"></a>00068 
<a name="l00073"></a>00073   <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> <a class="code" href="classlibMesh_1_1QNTransientRBContext.php#a860b5ca32726d0490f5ceb9646f5cbc4">old_interior_value</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp);
<a name="l00074"></a>00074 
<a name="l00079"></a>00079   <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> <a class="code" href="classlibMesh_1_1QNTransientRBContext.php#ab537fd4ba735523e9eab295023da86fe">old_side_value</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp);
<a name="l00080"></a>00080 
<a name="l00085"></a>00085   <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> <a class="code" href="classlibMesh_1_1QNTransientRBContext.php#ab0ce4e9ab65a50f75f388b9825d47d26">old_point_value</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var, <a class="code" href="classlibMesh_1_1Point.php">Point</a> &amp;p);
<a name="l00086"></a>00086 
<a name="l00091"></a>00091   <a class="code" href="classlibMesh_1_1VectorValue.php">Gradient</a> <a class="code" href="classlibMesh_1_1QNTransientRBContext.php#a1d381eef8a20340a90245f60f764ca7d">old_interior_gradient</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp);
<a name="l00092"></a>00092 
<a name="l00097"></a>00097   <a class="code" href="classlibMesh_1_1VectorValue.php">Gradient</a> <a class="code" href="classlibMesh_1_1QNTransientRBContext.php#a158eafc9e798500f9457b38199102b81">old_side_gradient</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp);
<a name="l00098"></a>00098 
<a name="l00105"></a>00105   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QNTransientRBContext.php#a799f91a3681004e67e3cef1a79032605">pre_fe_reinit</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a>&amp;, <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>*);
<a name="l00106"></a>00106 
<a name="l00111"></a><a class="code" href="classlibMesh_1_1QNTransientRBContext.php#a38a0fddb45edcb81bd0c01a47bb302aa">00111</a>   <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> <a class="code" href="classlibMesh_1_1QNTransientRBContext.php#a38a0fddb45edcb81bd0c01a47bb302aa">elem_old_solution</a>;
<a name="l00112"></a><a class="code" href="classlibMesh_1_1QNTransientRBContext.php#ab79361d5f71905c8b31c27def2e891d3">00112</a>   std::vector&lt;DenseSubVector&lt;Number&gt; *&gt; <a class="code" href="classlibMesh_1_1QNTransientRBContext.php#ab79361d5f71905c8b31c27def2e891d3">elem_old_subsolutions</a>;
<a name="l00113"></a>00113 };
<a name="l00114"></a>00114 
<a name="l00115"></a>00115 } <span class="comment">// namespace libMesh</span>
<a name="l00116"></a>00116 
<a name="l00117"></a>00117 <span class="preprocessor">#endif // LIBMESH_HAVE_SLEPC &amp;&amp; LIBMESH_HAVE_GLPK</span>
<a name="l00118"></a>00118 <span class="preprocessor"></span>
<a name="l00119"></a>00119 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
