<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_c3a49989e40b21e7508f29d2dc962def.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_94af86d0ee7ff5a2af0627e1a0ea6efa.php">systems</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">qn_transient_rb_param_subdomain_node.C</div>  </div>
</div>
<div class="contents">
<a href="qn__transient__rb__param__subdomain__node_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// rbOOmit: An implementation of the Certified Reduced Basis method.</span>
<a name="l00002"></a>00002 <span class="comment">// Copyright (C) 2009, 2010 David J. Knezevic</span>
<a name="l00003"></a>00003 
<a name="l00004"></a>00004 <span class="comment">// This file is part of rbOOmit.</span>
<a name="l00005"></a>00005 
<a name="l00006"></a>00006 <span class="comment">// rbOOmit is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// rbOOmit is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="comment">// Configuration data</span>
<a name="l00021"></a>00021 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>&quot;</span>
<a name="l00022"></a>00022 
<a name="l00023"></a>00023 <span class="preprocessor">#if defined(LIBMESH_HAVE_SLEPC) &amp;&amp; (LIBMESH_HAVE_GLPK)</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="qn__transient__rb__param__subdomain__node_8h.php">qn_transient_rb_param_subdomain_node.h</a>&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="qn__transient__rb__param__subdomain__tree_8h.php">qn_transient_rb_param_subdomain_tree.h</a>&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="qn__transient__scm__system_8h.php">qn_transient_scm_system.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__logging_8h.php">libmesh_logging.h</a>&quot;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="keyword">namespace </span>libMesh
<a name="l00031"></a>00031 {
<a name="l00032"></a>00032 
<a name="l00033"></a><a class="code" href="classlibMesh_1_1QNTransientRBParamSubdomainNode.php#a9e35226cc41a13c0d68cb16e52fd9951">00033</a> <a class="code" href="classlibMesh_1_1QNTransientRBParamSubdomainNode.php#a9e35226cc41a13c0d68cb16e52fd9951">QNTransientRBParamSubdomainNode::QNTransientRBParamSubdomainNode</a>(<a class="code" href="classlibMesh_1_1QNTransientRBParamSubdomainTree.php">QNTransientRBParamSubdomainTree</a>&amp; tree,
<a name="l00034"></a>00034                                                                  <span class="keyword">const</span> std::vector&lt;Real&gt;&amp; anchor)
<a name="l00035"></a>00035   : <a class="code" href="classlibMesh_1_1TransientRBParamSubdomainNode.php">Parent</a>(tree, anchor),
<a name="l00036"></a>00036     _scm_system(tree._scm_system)
<a name="l00037"></a>00037 {
<a name="l00038"></a>00038 }
<a name="l00039"></a>00039 
<a name="l00040"></a><a class="code" href="classlibMesh_1_1QNTransientRBParamSubdomainNode.php#ac0f4b7672dfe5f2d4aef0889fd15e801">00040</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QNTransientRBParamSubdomainNode.php#ac0f4b7672dfe5f2d4aef0889fd15e801">QNTransientRBParamSubdomainNode::add_child</a>(<span class="keyword">const</span> std::vector&lt;Real&gt;&amp; new_anchor, <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#ad1f33d84f4d4e5b49515a5cd84a7f18d">Child</a> c)
<a name="l00041"></a>00041 {
<a name="l00042"></a>00042   START_LOG(<span class="stringliteral">&quot;add_child()&quot;</span>, <span class="stringliteral">&quot;QNTransientRBParamSubdomainNode&quot;</span>);
<a name="l00043"></a>00043 
<a name="l00044"></a>00044   <span class="comment">// cast the tree reference to a QNTransientRBParamSubdomainTree</span>
<a name="l00045"></a>00045   <a class="code" href="classlibMesh_1_1QNTransientRBParamSubdomainTree.php">QNTransientRBParamSubdomainTree</a>&amp; qn_tree =
<a name="l00046"></a>00046     libmesh_cast_ref&lt;QNTransientRBParamSubdomainTree&amp;&gt;(<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a8261232adfa2e3c67b36772e9bbb1304">_tree</a>);
<a name="l00047"></a>00047 
<a name="l00048"></a>00048   <span class="keywordflow">if</span>(c == <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#ad1f33d84f4d4e5b49515a5cd84a7f18dae0b682b625e6a6f6274c37cc8baf789c">LEFT</a>)
<a name="l00049"></a>00049   {
<a name="l00050"></a>00050     <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a914fa2d276aa527935e111c4bd39fdff">left_child</a> != NULL)
<a name="l00051"></a>00051     {
<a name="l00052"></a>00052       <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Error: Child already exists!&quot;</span>
<a name="l00053"></a>00053                    &lt;&lt; std::endl;
<a name="l00054"></a>00054       libmesh_error();
<a name="l00055"></a>00055     }
<a name="l00056"></a>00056     <span class="keywordflow">else</span>
<a name="l00057"></a>00057     {
<a name="l00058"></a>00058       <span class="comment">// Allocate a new child node</span>
<a name="l00059"></a>00059       <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a914fa2d276aa527935e111c4bd39fdff">left_child</a> = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1QNTransientRBParamSubdomainNode.php#a9e35226cc41a13c0d68cb16e52fd9951">QNTransientRBParamSubdomainNode</a>(qn_tree, new_anchor);
<a name="l00060"></a>00060     }
<a name="l00061"></a>00061   }
<a name="l00062"></a>00062 
<a name="l00063"></a>00063   <span class="keywordflow">if</span>(c == <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#ad1f33d84f4d4e5b49515a5cd84a7f18daeec71da1ac45404e962a18da04fb96cb">RIGHT</a>)
<a name="l00064"></a>00064   {
<a name="l00065"></a>00065     <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a85f1796c2ef55cc35166347a2c76ec12">right_child</a> != NULL)
<a name="l00066"></a>00066     {
<a name="l00067"></a>00067       <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Error: Child already exists!&quot;</span>
<a name="l00068"></a>00068                    &lt;&lt; std::endl;
<a name="l00069"></a>00069       libmesh_error();
<a name="l00070"></a>00070     }
<a name="l00071"></a>00071     <span class="keywordflow">else</span>
<a name="l00072"></a>00072     {
<a name="l00073"></a>00073       <span class="comment">// Allocate a new child node</span>
<a name="l00074"></a>00074       <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a85f1796c2ef55cc35166347a2c76ec12">right_child</a> = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1QNTransientRBParamSubdomainNode.php#a9e35226cc41a13c0d68cb16e52fd9951">QNTransientRBParamSubdomainNode</a>(qn_tree, new_anchor);
<a name="l00075"></a>00075     }
<a name="l00076"></a>00076   }
<a name="l00077"></a>00077 
<a name="l00078"></a>00078   STOP_LOG(<span class="stringliteral">&quot;add_child()&quot;</span>, <span class="stringliteral">&quot;QNTransientRBParamSubdomainNode&quot;</span>);
<a name="l00079"></a>00079 }
<a name="l00080"></a>00080 
<a name="l00081"></a><a class="code" href="classlibMesh_1_1QNTransientRBParamSubdomainNode.php#af2b9a4c409ebc3eed92b6ae8590018c6">00081</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QNTransientRBParamSubdomainNode.php#af2b9a4c409ebc3eed92b6ae8590018c6">QNTransientRBParamSubdomainNode::write_subdomain_data_to_files</a>()
<a name="l00082"></a>00082 {
<a name="l00083"></a>00083   START_LOG(<span class="stringliteral">&quot;write_subdomain_data_to_files()&quot;</span>, <span class="stringliteral">&quot;QNTransientRBParamSubdomainNode&quot;</span>);
<a name="l00084"></a>00084 
<a name="l00085"></a>00085   <a class="code" href="classlibMesh_1_1QNTransientRBParamSubdomainNode.php#af2b9a4c409ebc3eed92b6ae8590018c6">RBParamSubdomainNode::write_subdomain_data_to_files</a>();
<a name="l00086"></a>00086   
<a name="l00087"></a>00087   <span class="comment">// Finally, perform the SCM stage on this subdomain</span>
<a name="l00088"></a>00088   <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; std::endl &lt;&lt; <span class="stringliteral">&quot;Perform SCM greedy for leaf subdomain &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a8261232adfa2e3c67b36772e9bbb1304">_tree</a>.<a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#a7fa296aaec53be8a43777fd13f179f43">leaf_node_index</a>
<a name="l00089"></a>00089                &lt;&lt; std::endl &lt;&lt; std::endl;
<a name="l00090"></a>00090   <a class="code" href="classlibMesh_1_1QNTransientRBParamSubdomainNode.php#a6e28b56b359b9ed5ee8e47df55f19e23">_scm_system</a>.<a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#ab24885744cf843c0bc3056d4ba43c8ac">resize_to_new_n_bfs</a>();
<a name="l00091"></a>00091   <a class="code" href="classlibMesh_1_1QNTransientRBParamSubdomainNode.php#a6e28b56b359b9ed5ee8e47df55f19e23">_scm_system</a>.<a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a6a62b451558cce9cc3ed16ae2cc76bb5">load_training_set</a>(this-&gt;<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#ac0430d470355eb02db9c5c7813dec26d">training_set</a>);
<a name="l00092"></a>00092   <a class="code" href="classlibMesh_1_1QNTransientRBParamSubdomainNode.php#a6e28b56b359b9ed5ee8e47df55f19e23">_scm_system</a>.<a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a81855c551eb78f6d01aabbbbdb261767">perform_SCM_greedy</a>();
<a name="l00093"></a>00093 
<a name="l00094"></a>00094   <span class="comment">// and write out the SCM data as well.</span>
<a name="l00095"></a>00095   std::stringstream dir_name_stream;
<a name="l00096"></a>00096   dir_name_stream &lt;&lt; <span class="stringliteral">&quot;offline_data_hp&quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a8261232adfa2e3c67b36772e9bbb1304">_tree</a>.<a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#a7fa296aaec53be8a43777fd13f179f43">leaf_node_index</a>;
<a name="l00097"></a>00097   <span class="keyword">const</span> std::string&amp; directory_name = dir_name_stream.str();
<a name="l00098"></a>00098   <a class="code" href="classlibMesh_1_1QNTransientRBParamSubdomainNode.php#a6e28b56b359b9ed5ee8e47df55f19e23">_scm_system</a>.<a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a94ec0c361ec67da56ccb53128ce76d48">write_offline_data_to_files</a>(directory_name);
<a name="l00099"></a>00099 
<a name="l00100"></a>00100   STOP_LOG(<span class="stringliteral">&quot;write_subdomain_data_to_files()&quot;</span>, <span class="stringliteral">&quot;QNTransientRBParamSubdomainNode&quot;</span>);
<a name="l00101"></a>00101 }
<a name="l00102"></a>00102 
<a name="l00103"></a>00103 } <span class="comment">// namespace libMesh</span>
<a name="l00104"></a>00104 
<a name="l00105"></a>00105 <span class="preprocessor">#endif // LIBMESH_HAVE_SLEPC &amp;&amp; LIBMESH_HAVE_GLPK</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
