<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_eaf30c8ea092d33f79a04353c3899c3f.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_5a0c7151fa56969ceb962f1511f7edee.php">systems</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">qn_transient_rb_param_subdomain_node.h</div>  </div>
</div>
<div class="contents">
<a href="qn__transient__rb__param__subdomain__node_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// rbOOmit: An implementation of the Certified Reduced Basis method.</span>
<a name="l00002"></a>00002 <span class="comment">// Copyright (C) 2009, 2010 David J. Knezevic</span>
<a name="l00003"></a>00003 
<a name="l00004"></a>00004 <span class="comment">// This file is part of rbOOmit.</span>
<a name="l00005"></a>00005 
<a name="l00006"></a>00006 <span class="comment">// rbOOmit is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// rbOOmit is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="preprocessor">#ifndef __qn_transient_rb_param_subdomain_node_h__</span>
<a name="l00021"></a>00021 <span class="preprocessor"></span><span class="preprocessor">#define __qn_transient_rb_param_subdomain_node_h__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span>
<a name="l00023"></a>00023 <span class="comment">// Configuration data</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>&quot;</span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// This class depends on QNTransientSCMSystem, which is only</span>
<a name="l00027"></a>00027 <span class="comment">// available if SLEPc is defined.</span>
<a name="l00028"></a>00028 <span class="preprocessor">#if defined(LIBMESH_HAVE_SLEPC) &amp;&amp; (LIBMESH_HAVE_GLPK)</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="transient__rb__param__subdomain__node_8h.php">transient_rb_param_subdomain_node.h</a>&quot;</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="keyword">namespace </span>libMesh
<a name="l00033"></a>00033 {
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="comment">// Forward declaration</span>
<a name="l00036"></a>00036 <span class="keyword">class </span>QNTransientSCMSystem;
<a name="l00037"></a>00037 <span class="keyword">class </span>QNTransientRBParamSubdomainTree;
<a name="l00038"></a>00038 
<a name="l00049"></a>00049 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00050"></a>00050 <span class="comment">// RBParamSubdomainNode class definition</span>
<a name="l00051"></a>00051 
<a name="l00052"></a><a class="code" href="classlibMesh_1_1QNTransientRBParamSubdomainNode.php">00052</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1QNTransientRBParamSubdomainNode.php">QNTransientRBParamSubdomainNode</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1TransientRBParamSubdomainNode.php">TransientRBParamSubdomainNode</a>
<a name="l00053"></a>00053 {
<a name="l00054"></a>00054 <span class="keyword">public</span>:
<a name="l00055"></a>00055 
<a name="l00060"></a>00060   <a class="code" href="classlibMesh_1_1QNTransientRBParamSubdomainNode.php#a9e35226cc41a13c0d68cb16e52fd9951">QNTransientRBParamSubdomainNode</a> (<a class="code" href="classlibMesh_1_1QNTransientRBParamSubdomainTree.php">QNTransientRBParamSubdomainTree</a>&amp; tree, <span class="keyword">const</span> std::vector&lt;Real&gt;&amp; <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a271e33d157314a8f221ef14150812924">anchor</a>);
<a name="l00061"></a>00061 
<a name="l00065"></a><a class="code" href="classlibMesh_1_1QNTransientRBParamSubdomainNode.php#ad2f55bbd1ef1d1034a514f37348d5b59">00065</a>   <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1TransientRBParamSubdomainNode.php">TransientRBParamSubdomainNode</a> <a class="code" href="classlibMesh_1_1QNTransientRBParamSubdomainNode.php#ad2f55bbd1ef1d1034a514f37348d5b59">Parent</a>;
<a name="l00066"></a>00066 
<a name="l00071"></a>00071   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QNTransientRBParamSubdomainNode.php#ac0f4b7672dfe5f2d4aef0889fd15e801">add_child</a>(<span class="keyword">const</span> std::vector&lt;Real&gt;&amp; child_anchor, <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#ad1f33d84f4d4e5b49515a5cd84a7f18d">Child</a> c);
<a name="l00072"></a>00072 
<a name="l00078"></a>00078   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QNTransientRBParamSubdomainNode.php#af2b9a4c409ebc3eed92b6ae8590018c6">write_subdomain_data_to_files</a>();
<a name="l00079"></a>00079 
<a name="l00084"></a><a class="code" href="classlibMesh_1_1QNTransientRBParamSubdomainNode.php#a6e28b56b359b9ed5ee8e47df55f19e23">00084</a>   <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php">QNTransientSCMSystem</a>&amp; <a class="code" href="classlibMesh_1_1QNTransientRBParamSubdomainNode.php#a6e28b56b359b9ed5ee8e47df55f19e23">_scm_system</a>;
<a name="l00085"></a>00085 
<a name="l00086"></a>00086 };
<a name="l00087"></a>00087 
<a name="l00088"></a>00088 } <span class="comment">// namespace libMesh</span>
<a name="l00089"></a>00089 
<a name="l00090"></a>00090 <span class="preprocessor">#endif // LIBMESH_HAVE_SLEPC &amp;&amp; LIBMESH_HAVE_GLPK</span>
<a name="l00091"></a>00091 <span class="preprocessor"></span>
<a name="l00092"></a>00092 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
