<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_eaf30c8ea092d33f79a04353c3899c3f.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_5a0c7151fa56969ceb962f1511f7edee.php">systems</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">qn_transient_rb_system.h</div>  </div>
</div>
<div class="contents">
<a href="qn__transient__rb__system_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// rbOOmit: An implementation of the Certified Reduced Basis method.</span>
<a name="l00002"></a>00002 <span class="comment">// Copyright (C) 2009, 2010 David J. Knezevic</span>
<a name="l00003"></a>00003 
<a name="l00004"></a>00004 <span class="comment">// This file is part of rbOOmit.</span>
<a name="l00005"></a>00005 
<a name="l00006"></a>00006 <span class="comment">// rbOOmit is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// rbOOmit is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="preprocessor">#ifndef __qn_transient_rb_system_h__</span>
<a name="l00021"></a>00021 <span class="preprocessor"></span><span class="preprocessor">#define __qn_transient_rb_system_h__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span>
<a name="l00023"></a>00023 <span class="comment">// Configuration data</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>&quot;</span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// This class requires QNTransientSCMSystem, which is not</span>
<a name="l00027"></a>00027 <span class="comment">// defined if SLEPc is not present.</span>
<a name="l00028"></a>00028 <span class="preprocessor">#if defined(LIBMESH_HAVE_SLEPC) &amp;&amp; (LIBMESH_HAVE_GLPK)</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="transient__rb__system_8h.php">transient_rb_system.h</a>&quot;</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="keyword">namespace </span>libMesh
<a name="l00033"></a>00033 {
<a name="l00034"></a>00034 
<a name="l00046"></a>00046 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00047"></a>00047 <span class="comment">// QNTransientRBSystem class definition</span>
<a name="l00048"></a>00048 
<a name="l00049"></a><a class="code" href="classlibMesh_1_1QNTransientRBSystem.php">00049</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1QNTransientRBSystem.php">QNTransientRBSystem</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php">TransientRBSystem</a>
<a name="l00050"></a>00050 {
<a name="l00051"></a>00051 <span class="keyword">public</span>:
<a name="l00052"></a>00052 
<a name="l00053"></a>00053 
<a name="l00058"></a>00058   <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a7e0918f4925e284afdbe935ad56c0615">QNTransientRBSystem</a> (<a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00059"></a>00059                        <span class="keyword">const</span> std::string&amp; <a class="code" href="classlibMesh_1_1System.php#af80f6b2e508821ebd9c8fcb78d443f18">name</a>,
<a name="l00060"></a>00060                        <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#aee5caacb487b070842733f1c84b9a2fd">number</a>);
<a name="l00061"></a>00061 
<a name="l00065"></a>00065   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a6fbff9110eebd538cca2b5680639a9bb">~QNTransientRBSystem</a> ();
<a name="l00066"></a>00066 
<a name="l00070"></a><a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a8c61d0d919cb6c6d03c22061ab11434d">00070</a>   <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php">QNTransientRBSystem</a> <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a8c61d0d919cb6c6d03c22061ab11434d">sys_type</a>;
<a name="l00071"></a>00071 
<a name="l00075"></a><a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#ac16b9002d0aa7365a4103a9665508446">00075</a>   <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php">TransientRBSystem</a> <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#ac16b9002d0aa7365a4103a9665508446">Parent</a>;
<a name="l00076"></a>00076 
<a name="l00081"></a>00081   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a85fcde0fb3099dd206cefa44155efcd6">clear</a> ();
<a name="l00082"></a>00082 
<a name="l00088"></a>00088   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a8fca7a0caa100a307367d3f9d70728a0">clear_basis_function_dependent_data</a>();
<a name="l00089"></a>00089   
<a name="l00094"></a>00094   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a56981c8a6972d63d6926a4e7cc902072">initialize_RB_system</a>(<span class="keywordtype">bool</span> online_mode);
<a name="l00095"></a>00095 
<a name="l00100"></a>00100   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#aa86181b359bfc9f13fa9d5cebb210e63">attach_C</a>(<a class="code" href="namespacelibMesh.php#aa62736885c7a9bb67eda65b54ee20107">theta_q_fptr</a> theta_q_c, <a class="code" href="namespacelibMesh.php#a18a170af3a9d5eff6f43eb3409d0e296">affine_assembly_fptr</a> <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a0bd74afcd8112ac109b91f02c870a28a">C_assembly</a>);
<a name="l00101"></a>00101 
<a name="l00106"></a>00106   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a6b0546f02800c2b03094f441d10a5620">attach_truth_assembly</a>(<a class="code" href="namespacelibMesh.php#a18a170af3a9d5eff6f43eb3409d0e296">affine_assembly_fptr</a> <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#af3de81b6715f0ff5ea0f1916d5ae90fc">truth_intrr_assembly</a>,
<a name="l00107"></a>00107                              <a class="code" href="namespacelibMesh.php#a18a170af3a9d5eff6f43eb3409d0e296">affine_assembly_fptr</a> <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a48e249153e5977052febec98cde4fe64">truth_bndry_assembly</a>);
<a name="l00108"></a>00108 
<a name="l00112"></a>00112   <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a01234fb8ef324bdc9679e36895c5f5cc">eval_theta_c</a>();
<a name="l00113"></a>00113 
<a name="l00119"></a>00119   <span class="keyword">virtual</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#ac6bc46978e210bad86a1bf676bdb87d4">truth_solve</a>(<span class="keywordtype">int</span> write_interval);
<a name="l00120"></a>00120 
<a name="l00127"></a>00127   <span class="keyword">virtual</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a1680488164f8f4f740eaf333aa792625">RB_solve</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N);
<a name="l00128"></a>00128 
<a name="l00133"></a><a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a732c03317f867080093e900f2090ee2f">00133</a>   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a732c03317f867080093e900f2090ee2f">set_nonlinear_tolerance</a>(<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#abd9e16b48c18c57baeed6ac2a0c3cffa">nonlinear_tolerance</a>)
<a name="l00134"></a>00134     { this-&gt;nonlinear_tolerance = <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#abd9e16b48c18c57baeed6ac2a0c3cffa">nonlinear_tolerance</a>; }
<a name="l00135"></a>00135     
<a name="l00140"></a><a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#aa559107172b57c8a6d879a5e5f3aa252">00140</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#aa559107172b57c8a6d879a5e5f3aa252">get_nonlinear_tolerance</a>()
<a name="l00141"></a>00141     { <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#abd9e16b48c18c57baeed6ac2a0c3cffa">nonlinear_tolerance</a>; }
<a name="l00142"></a>00142 
<a name="l00147"></a><a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#afe274a988404c86e43287fd9dd7a2800">00147</a>   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#afe274a988404c86e43287fd9dd7a2800">set_n_newton_steps</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_newton_steps_in)
<a name="l00148"></a>00148     { this-&gt;<a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a6898b18e56f0ef28ce3e2b33c6e6ac95">n_newton_steps</a> = n_newton_steps_in; }
<a name="l00149"></a>00149     
<a name="l00154"></a><a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a7d86a313bf3063f8afb3d4460db276e4">00154</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a7d86a313bf3063f8afb3d4460db276e4">get_n_newton_steps</a>()
<a name="l00155"></a>00155     { <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a6898b18e56f0ef28ce3e2b33c6e6ac95">n_newton_steps</a>; }
<a name="l00156"></a>00156 
<a name="l00162"></a>00162   <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;Number&gt;</a>* <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a2b3a94130fa95eb33de4dd62d457d5ef">get_C_n</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n);
<a name="l00163"></a>00163 
<a name="l00169"></a><a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a312837f008a2f699eed61498e1ba612c">00169</a>   <span class="keyword">virtual</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a312837f008a2f699eed61498e1ba612c">get_nominal_rho_LB</a>() { <span class="keywordflow">return</span> 1.; }
<a name="l00170"></a>00170 
<a name="l00175"></a>00175   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a05c3a6cadebd4f91ff576e86faaf9585">assemble_C_n_matrix</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n, <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;Number&gt;</a>* input_matrix);
<a name="l00176"></a>00176 
<a name="l00181"></a>00181   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a18c78570401eb41027d51e62743feb1f">add_scaled_Cn</a>(<a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> scalar, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n, <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;Number&gt;</a>* input_matrix, <span class="keywordtype">bool</span> symmetrize);
<a name="l00182"></a>00182 
<a name="l00188"></a>00188   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a56c58a2fe4fe93ccb1911bfc7d4a6f84">add_scaled_current_C</a>(<a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> scalar, <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;Number&gt;</a>* input_matrix, <span class="keywordtype">bool</span> symmetrize);
<a name="l00189"></a>00189 
<a name="l00193"></a>00193   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a28166f6db60d1c5d7e5b5479798f1f8e">set_context_solution_vec</a>(<a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>&amp; vec);
<a name="l00194"></a>00194 
<a name="l00200"></a>00200   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a95d8333ed2c6da4d76033bc343cca7a4">update_all_trilinear_form_operators</a>();
<a name="l00201"></a>00201 
<a name="l00207"></a>00207   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#af5896e03cfcc54a32c8c6a54a13e81d4">write_offline_data_to_files</a>(<span class="keyword">const</span> std::string&amp; directory_name = <span class="stringliteral">&quot;offline_data&quot;</span>);
<a name="l00208"></a>00208 
<a name="l00214"></a>00214   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a11fbad0ec4505c6f1cc3be89fb981db6">read_offline_data_from_files</a>(<span class="keyword">const</span> std::string&amp; directory_name = <span class="stringliteral">&quot;offline_data&quot;</span>);
<a name="l00215"></a>00215 
<a name="l00216"></a>00216 
<a name="l00217"></a>00217   <span class="comment">//----------- PUBLIC DATA MEMBERS -----------//</span>
<a name="l00218"></a>00218 
<a name="l00219"></a>00219 
<a name="l00223"></a><a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#acb60710609da05611e7d440eb79a66ff">00223</a>   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt; NumericVector&lt;Number&gt;</a> &gt; <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#acb60710609da05611e7d440eb79a66ff">current_newton_iterate</a>;
<a name="l00224"></a>00224 
<a name="l00229"></a><a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a6d593306c3c2c3ddede6a33b0943e7c4">00229</a>   std::vector&lt; std::vector&lt; std::vector&lt;Number&gt; &gt; &gt; <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a6d593306c3c2c3ddede6a33b0943e7c4">RB_trilinear_form</a>;
<a name="l00230"></a>00230 
<a name="l00236"></a><a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a67bc1822ac61799f781695660b2e0754">00236</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a67bc1822ac61799f781695660b2e0754">use_nominal_rho_LB</a>;
<a name="l00237"></a>00237 
<a name="l00242"></a><a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a4a09ca818297079cbe924bdf61062ec3">00242</a>   std::vector&lt;Real&gt; <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a4a09ca818297079cbe924bdf61062ec3">rho_LB_vector</a>;
<a name="l00243"></a><a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a810d69ca39e539ddd9b56492d3af7b25">00243</a>   std::vector&lt;Real&gt; <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a810d69ca39e539ddd9b56492d3af7b25">rho_UB_vector</a>;
<a name="l00244"></a>00244 
<a name="l00249"></a><a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#aad10b1ffeb99e8261e99892ce0d209e5">00249</a>   std::vector&lt; std::vector&lt; NumericVector&lt;Number&gt;* &gt; &gt; <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#aad10b1ffeb99e8261e99892ce0d209e5">C_representor</a>;
<a name="l00250"></a>00250 
<a name="l00255"></a><a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#adb9ca8229335af78caf0b47b83285254">00255</a>   std::vector&lt; std::vector&lt; std::vector&lt;Number&gt; &gt; &gt; <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#adb9ca8229335af78caf0b47b83285254">Fq_C_representor_norms</a>;
<a name="l00256"></a><a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a39a9f2064c99ea89337c13afa0d59211">00256</a>   std::vector&lt; std::vector&lt; std::vector&lt; std::vector&lt;Number&gt; &gt; &gt; &gt; <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a39a9f2064c99ea89337c13afa0d59211">Mq_C_representor_norms</a>;
<a name="l00257"></a><a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#aa148f5aef2298825abbe912e80d6f3b7">00257</a>   std::vector&lt; std::vector&lt; std::vector&lt; std::vector&lt;Number&gt; &gt; &gt; &gt; <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#aa148f5aef2298825abbe912e80d6f3b7">Aq_C_representor_norms</a>;
<a name="l00258"></a><a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a626bab2fd06b6ac9e5498c9ad3098c98">00258</a>   std::vector&lt; std::vector&lt; std::vector&lt; std::vector&lt;Number&gt; &gt; &gt; &gt; <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a626bab2fd06b6ac9e5498c9ad3098c98">C_C_representor_norms</a>;
<a name="l00259"></a>00259 
<a name="l00260"></a>00260 <span class="keyword">protected</span>:
<a name="l00261"></a>00261 
<a name="l00266"></a>00266   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a173e7f3adc83c98812712d1bb9238d35">init_data</a> ();
<a name="l00267"></a>00267 
<a name="l00273"></a>00273   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;FEMContext&gt;</a> <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a99cb482521d5c2ee5ba03d3fc5c5fa0d">build_context</a>();
<a name="l00274"></a>00274 
<a name="l00278"></a>00278   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#acf2db6d212f85598337c42eddb9b66d3">update_system</a>();
<a name="l00279"></a>00279 
<a name="l00283"></a>00283   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a91e4688ad8292008de8fa05a02f31481">update_RB_system_matrices</a>();
<a name="l00284"></a>00284 
<a name="l00289"></a>00289   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a125b067cb931ba8223a76c414c46a903">update_residual_terms</a>(<span class="keywordtype">bool</span> compute_inner_products);
<a name="l00290"></a>00290 
<a name="l00296"></a>00296   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a20ca0f91b2fb06a2fa0ed63e6151d8bf">update_trilinear_form_operators</a>();
<a name="l00297"></a>00297 
<a name="l00301"></a>00301   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#ab3d82f282253972001d4a6d6c94cb42b">initialize_truth</a>();
<a name="l00302"></a>00302 
<a name="l00308"></a>00308   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#aee9ad3841915a8daee375ea3b85a2c20">truth_assembly</a>();
<a name="l00309"></a>00309 
<a name="l00315"></a>00315   <span class="keyword">virtual</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a1fd014607285e48d48b02106f0fcc9f1">compute_residual_dual_norm</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N);
<a name="l00316"></a>00316 
<a name="l00321"></a>00321   <span class="keyword">virtual</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a6a72e8968c88bee95ed7742ab853d55c">get_SCM_lower_bound</a>();
<a name="l00322"></a>00322 
<a name="l00327"></a>00327   <span class="keyword">virtual</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a9df81dce8a528580a53ea943176ba483">get_SCM_upper_bound</a>();
<a name="l00328"></a>00328 
<a name="l00329"></a>00329 <span class="keyword">private</span>:
<a name="l00330"></a>00330 
<a name="l00331"></a>00331   <span class="comment">//----------- PRIVATE DATA MEMBERS -----------//</span>
<a name="l00332"></a>00332 
<a name="l00336"></a><a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#abd9e16b48c18c57baeed6ac2a0c3cffa">00336</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#abd9e16b48c18c57baeed6ac2a0c3cffa">nonlinear_tolerance</a>;
<a name="l00337"></a>00337 
<a name="l00341"></a><a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a6898b18e56f0ef28ce3e2b33c6e6ac95">00341</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a6898b18e56f0ef28ce3e2b33c6e6ac95">n_newton_steps</a>;
<a name="l00342"></a>00342 
<a name="l00346"></a><a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a6560d33a85365fd45ef4d9cd54e8e120">00346</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a6560d33a85365fd45ef4d9cd54e8e120">use_eisenstat</a>;   <span class="comment">/* if false, a fixed tolerance of eisenstat_eta0 will be used */</span>
<a name="l00347"></a><a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a8981c27ff565fd5434de91db6b758221">00347</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a8981c27ff565fd5434de91db6b758221">eisenstat_eta0</a>;  <span class="comment">/* 0.1, 0.01, 1e-3 */</span>
<a name="l00348"></a><a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a779aa4c52fff79bd12b8ead2cd650a1b">00348</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a779aa4c52fff79bd12b8ead2cd650a1b">eisenstat_gamma</a>; <span class="comment">/* .9, 1 */</span>
<a name="l00349"></a><a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a53d4512a39a08fdf383a398b2cde1cf4">00349</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a53d4512a39a08fdf383a398b2cde1cf4">eisenstat_alpha</a>; <span class="comment">/* 2, 0.5*(1.+std::sqrt(5.)) */</span>
<a name="l00350"></a>00350 
<a name="l00354"></a><a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a6befde9564b470c5908912bb7258e726">00354</a>   std::vector&lt; SparseMatrix&lt;Number&gt;* &gt; <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a6befde9564b470c5908912bb7258e726">C_n_vector</a>;
<a name="l00355"></a>00355 
<a name="l00360"></a><a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a0bd74afcd8112ac109b91f02c870a28a">00360</a>   <a class="code" href="namespacelibMesh.php#a18a170af3a9d5eff6f43eb3409d0e296">affine_assembly_fptr</a> <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a0bd74afcd8112ac109b91f02c870a28a">C_assembly</a>;
<a name="l00361"></a>00361 
<a name="l00366"></a><a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#af3de81b6715f0ff5ea0f1916d5ae90fc">00366</a>   <a class="code" href="namespacelibMesh.php#a18a170af3a9d5eff6f43eb3409d0e296">affine_assembly_fptr</a> <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#af3de81b6715f0ff5ea0f1916d5ae90fc">truth_intrr_assembly</a>;
<a name="l00367"></a>00367 
<a name="l00372"></a><a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a48e249153e5977052febec98cde4fe64">00372</a>   <a class="code" href="namespacelibMesh.php#a18a170af3a9d5eff6f43eb3409d0e296">affine_assembly_fptr</a> <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a48e249153e5977052febec98cde4fe64">truth_bndry_assembly</a>;
<a name="l00373"></a>00373 
<a name="l00377"></a><a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a45f28a803b5af2e6c65d386a4b66e0bb">00377</a>   <a class="code" href="namespacelibMesh.php#aa62736885c7a9bb67eda65b54ee20107">theta_q_fptr</a> <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a45f28a803b5af2e6c65d386a4b66e0bb">theta_c</a>;
<a name="l00378"></a>00378 
<a name="l00379"></a>00379 };
<a name="l00380"></a>00380 
<a name="l00381"></a>00381 } <span class="comment">// namespace libMesh</span>
<a name="l00382"></a>00382 
<a name="l00383"></a>00383 <span class="preprocessor">#endif // LIBMESH_HAVE_SLEPC &amp;&amp; LIBMESH_HAVE_GLPK</span>
<a name="l00384"></a>00384 <span class="preprocessor"></span>
<a name="l00385"></a>00385 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
