<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_c3a49989e40b21e7508f29d2dc962def.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_94af86d0ee7ff5a2af0627e1a0ea6efa.php">systems</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">qn_transient_scm_system.C</div>  </div>
</div>
<div class="contents">
<a href="qn__transient__scm__system_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// rbOOmit: An implementation of the Certified Reduced Basis method.</span>
<a name="l00002"></a>00002 <span class="comment">// Copyright (C) 2009, 2010 David J. Knezevic</span>
<a name="l00003"></a>00003 
<a name="l00004"></a>00004 <span class="comment">// This file is part of rbOOmit.</span>
<a name="l00005"></a>00005 
<a name="l00006"></a>00006 <span class="comment">// rbOOmit is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// rbOOmit is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="comment">// Configuration data</span>
<a name="l00021"></a>00021 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>&quot;</span>
<a name="l00022"></a>00022 
<a name="l00023"></a>00023 <span class="comment">// This class derives from RBSCMSystem, which requires SLEPC</span>
<a name="l00024"></a>00024 <span class="preprocessor">#if defined(LIBMESH_HAVE_SLEPC) &amp;&amp; (LIBMESH_HAVE_GLPK)</span>
<a name="l00025"></a>00025 <span class="preprocessor"></span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="qn__transient__scm__system_8h.php">qn_transient_scm_system.h</a>&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="qn__transient__rb__system_8h.php">qn_transient_rb_system.h</a>&quot;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="numeric__vector_8h.php">numeric_vector.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__logging_8h.php">libmesh_logging.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="dof__map_8h.php">dof_map.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="getpot_8h.php">getpot.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="equation__systems_8h.php">equation_systems.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="parallel_8h.php">parallel.h</a>&quot;</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="keyword">namespace </span>libMesh
<a name="l00037"></a>00037 {
<a name="l00038"></a>00038 
<a name="l00039"></a><a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a7ad95d02c6e1d46f05aef47f02a8ab93">00039</a> <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a7ad95d02c6e1d46f05aef47f02a8ab93">QNTransientSCMSystem::QNTransientSCMSystem</a> (<a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00040"></a>00040                                             <span class="keyword">const</span> std::string&amp; <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>,
<a name="l00041"></a>00041                                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> number)
<a name="l00042"></a>00042   : <a class="code" href="classlibMesh_1_1System.php">Parent</a>(es, name, number),
<a name="l00043"></a>00043     n_bfs(0),
<a name="l00044"></a>00044     _k(0),
<a name="l00045"></a>00045     _K(0),
<a name="l00046"></a>00046     dt(0.05),
<a name="l00047"></a>00047     n_time_samples(1)
<a name="l00048"></a>00048 {
<a name="l00049"></a>00049   <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a2204539de9bd3f86bea8bdafbad71ade">training_RB_coeffs</a>.clear();
<a name="l00050"></a>00050 }
<a name="l00051"></a>00051 
<a name="l00052"></a><a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a06bf5f4dc3247e7c69e5b20524c8b646">00052</a> <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a06bf5f4dc3247e7c69e5b20524c8b646">QNTransientSCMSystem::~QNTransientSCMSystem</a> ()
<a name="l00053"></a>00053 {
<a name="l00054"></a>00054   this-&gt;<a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#aa651225664680bcadca315b27fb83bb5">clear</a>();
<a name="l00055"></a>00055 }
<a name="l00056"></a>00056 
<a name="l00057"></a><a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#aa651225664680bcadca315b27fb83bb5">00057</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#aa651225664680bcadca315b27fb83bb5">QNTransientSCMSystem::clear</a>()
<a name="l00058"></a>00058 {
<a name="l00059"></a>00059   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a2204539de9bd3f86bea8bdafbad71ade">training_RB_coeffs</a>.size(); i++)
<a name="l00060"></a>00060   {
<a name="l00061"></a>00061     <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a2204539de9bd3f86bea8bdafbad71ade">training_RB_coeffs</a>[i])
<a name="l00062"></a>00062     {
<a name="l00063"></a>00063       <span class="keyword">delete</span> <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a2204539de9bd3f86bea8bdafbad71ade">training_RB_coeffs</a>[i];
<a name="l00064"></a>00064       <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a2204539de9bd3f86bea8bdafbad71ade">training_RB_coeffs</a>[i] = NULL;
<a name="l00065"></a>00065     }
<a name="l00066"></a>00066   }
<a name="l00067"></a>00067   <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a2204539de9bd3f86bea8bdafbad71ade">training_RB_coeffs</a>.resize(0);
<a name="l00068"></a>00068 
<a name="l00069"></a>00069   <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a8450f0e561356e2e86e30f0910b98bf7">Parent::clear</a>();
<a name="l00070"></a>00070 }
<a name="l00071"></a>00071 
<a name="l00072"></a><a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a975c38891550058063784a203927881f">00072</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a975c38891550058063784a203927881f">QNTransientSCMSystem::init_data</a>()
<a name="l00073"></a>00073 {
<a name="l00074"></a>00074   <span class="comment">// Set parameters before calling Parent::init</span>
<a name="l00075"></a>00075   GetPot infile(<a class="code" href="classlibMesh_1_1RBSCMSystem.php#a4ddbdc1eeb20c9e7b0c34acccc0af214">parameters_filename</a>);
<a name="l00076"></a>00076 
<a name="l00077"></a>00077   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> K_in     = infile(<span class="stringliteral">&quot;K&quot;</span>, <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a5af76d22e754265f7a88b9953be8c087">_K</a>);
<a name="l00078"></a>00078   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> dt_in            = infile(<span class="stringliteral">&quot;dt&quot;</span>, <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#abab60a7f9eb736eb17b7d493e754b6ec">dt</a>);
<a name="l00079"></a>00079 
<a name="l00080"></a>00080   <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a7519526c1b275b60fce9417df37ac25c">set_K</a>(K_in);
<a name="l00081"></a>00081   <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a3976812cee1255142c7fe82ce97e58ab">set_dt</a>(dt_in);
<a name="l00082"></a>00082 
<a name="l00083"></a>00083   <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a425e8de7389490bedcfa3226b1689116">n_time_samples</a> = infile(<span class="stringliteral">&quot;n_SCM_time_samples&quot;</span>, <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a425e8de7389490bedcfa3226b1689116">n_time_samples</a>);
<a name="l00084"></a>00084 
<a name="l00085"></a>00085   <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a9cb7939f5f4edc3094c01d994d04fcff">Parent::init_data</a>();
<a name="l00086"></a>00086 
<a name="l00087"></a>00087   <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; std::endl &lt;&lt; <span class="stringliteral">&quot;QNTransientSCMSystem parameters:&quot;</span> &lt;&lt; std::endl;
<a name="l00088"></a>00088   <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;K: &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a4290cdfe2edd05ae008f4b039df32573">get_K</a>() &lt;&lt; std::endl;
<a name="l00089"></a>00089   <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;dt: &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a440ac231a8036e9222052ecf01ffb6d0">get_dt</a>() &lt;&lt; std::endl;
<a name="l00090"></a>00090   <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Number of training samples in time for each parameter: &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a425e8de7389490bedcfa3226b1689116">n_time_samples</a> &lt;&lt; std::endl;
<a name="l00091"></a>00091   <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; std::endl;
<a name="l00092"></a>00092 }
<a name="l00093"></a>00093 
<a name="l00094"></a>00094 
<a name="l00095"></a><a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#ab24885744cf843c0bc3056d4ba43c8ac">00095</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#ab24885744cf843c0bc3056d4ba43c8ac">QNTransientSCMSystem::resize_to_new_n_bfs</a>()
<a name="l00096"></a>00096 {
<a name="l00097"></a>00097   <a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es = this-&gt;<a class="code" href="classlibMesh_1_1System.php#ac5ca6b1f3adcfac56982982e90dc905b">get_equation_systems</a>();
<a name="l00098"></a>00098   <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php">QNTransientRBSystem</a>&amp; RB_system = es.<a class="code" href="classlibMesh_1_1EquationSystems.php#a5dac23f839af25ce7dbf1fe9a6d4b67a">get_system</a>&lt;<a class="code" href="classlibMesh_1_1QNTransientRBSystem.php">QNTransientRBSystem</a>&gt;(<a class="code" href="classlibMesh_1_1RBSCMSystem.php#a3427a19ee940f3b5eb5a953c3a833e5a">RB_system_name</a>);
<a name="l00099"></a>00099 
<a name="l00100"></a>00100   <span class="comment">// Set n_bfs to be the number of basis functions in the</span>
<a name="l00101"></a>00101   <span class="comment">// associated RB system</span>
<a name="l00102"></a>00102   this-&gt;<a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a797da17429456d51d4ea5e90cd63dda9">set_n_basis_functions</a>(RB_system.<a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>());
<a name="l00103"></a>00103 
<a name="l00104"></a>00104   <span class="comment">// Clear and resize training_RB_coeffs</span>
<a name="l00105"></a>00105   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a2204539de9bd3f86bea8bdafbad71ade">training_RB_coeffs</a>.size(); i++)
<a name="l00106"></a>00106   {
<a name="l00107"></a>00107     <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a2204539de9bd3f86bea8bdafbad71ade">training_RB_coeffs</a>[i])
<a name="l00108"></a>00108     {
<a name="l00109"></a>00109       <span class="keyword">delete</span> <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a2204539de9bd3f86bea8bdafbad71ade">training_RB_coeffs</a>[i];
<a name="l00110"></a>00110       <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a2204539de9bd3f86bea8bdafbad71ade">training_RB_coeffs</a>[i] = NULL;
<a name="l00111"></a>00111     }
<a name="l00112"></a>00112   }
<a name="l00113"></a>00113   <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a2204539de9bd3f86bea8bdafbad71ade">training_RB_coeffs</a>.resize(<a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a88ea7d267ff9e995bd6716852e8a6ec9">get_n_basis_functions</a>());
<a name="l00114"></a>00114   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a88ea7d267ff9e995bd6716852e8a6ec9">get_n_basis_functions</a>(); i++)
<a name="l00115"></a>00115   {
<a name="l00116"></a>00116     <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a2204539de9bd3f86bea8bdafbad71ade">training_RB_coeffs</a>[i] = <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;::build</a>().release();
<a name="l00117"></a>00117     <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a2204539de9bd3f86bea8bdafbad71ade">training_RB_coeffs</a>[i]-&gt;init(<a class="code" href="classlibMesh_1_1RBBase.php#a584ecef007a7992b6317db58f857e9e0">get_n_training_samples</a>(), <a class="code" href="classlibMesh_1_1RBBase.php#a9695753c1fd434bccef96e258c6d1a40">get_local_n_training_samples</a>(), <span class="keyword">false</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">libMeshEnums::PARALLEL</a>);
<a name="l00118"></a>00118   }
<a name="l00119"></a>00119 
<a name="l00120"></a>00120   <span class="comment">// Need to resize the vectors storing SCM data such as B_min/B_max</span>
<a name="l00121"></a>00121   this-&gt;<a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#ae9957965d3c040fe444ecf1f38a9907b">resize_SCM_vectors</a>();
<a name="l00122"></a>00122 }
<a name="l00123"></a>00123 
<a name="l00124"></a><a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#ae9957965d3c040fe444ecf1f38a9907b">00124</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#ae9957965d3c040fe444ecf1f38a9907b">QNTransientSCMSystem::resize_SCM_vectors</a>()
<a name="l00125"></a>00125 {
<a name="l00126"></a>00126   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a3a16673187a444a53c6585e89865bda4">C_J_RB_coeffs</a>.size(); i++)
<a name="l00127"></a>00127     <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a3a16673187a444a53c6585e89865bda4">C_J_RB_coeffs</a>[i].<a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#aa651225664680bcadca315b27fb83bb5">clear</a>();
<a name="l00128"></a>00128   <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a3a16673187a444a53c6585e89865bda4">C_J_RB_coeffs</a>.clear();
<a name="l00129"></a>00129 
<a name="l00130"></a>00130   <a class="code" href="classlibMesh_1_1RBSCMSystem.php#ace55884aa4081bb6d00ccec765db31e1">Parent::resize_SCM_vectors</a>();
<a name="l00131"></a>00131 }
<a name="l00132"></a>00132 
<a name="l00133"></a><a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a81855c551eb78f6d01aabbbbdb261767">00133</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a81855c551eb78f6d01aabbbbdb261767">QNTransientSCMSystem::perform_SCM_greedy</a>()
<a name="l00134"></a>00134 {
<a name="l00135"></a>00135   <span class="comment">// Solve the RB system at each different mu in the SCM training set</span>
<a name="l00136"></a>00136   <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Performing RB solves at each parameter in SCM training set...&quot;</span> &lt;&lt; std::endl &lt;&lt; std::endl;
<a name="l00137"></a>00137   <a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es = this-&gt;<a class="code" href="classlibMesh_1_1System.php#ac5ca6b1f3adcfac56982982e90dc905b">get_equation_systems</a>();
<a name="l00138"></a>00138   <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php">QNTransientRBSystem</a>&amp; RB_system = es.<a class="code" href="classlibMesh_1_1EquationSystems.php#a5dac23f839af25ce7dbf1fe9a6d4b67a">get_system</a>&lt;<a class="code" href="classlibMesh_1_1QNTransientRBSystem.php">QNTransientRBSystem</a>&gt;(<a class="code" href="classlibMesh_1_1RBSCMSystem.php#a3427a19ee940f3b5eb5a953c3a833e5a">RB_system_name</a>);
<a name="l00139"></a>00139   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> RB_size = RB_system.<a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>();
<a name="l00140"></a>00140 
<a name="l00141"></a>00141   <span class="comment">// Now resize the system based on the number of basis functions in the</span>
<a name="l00142"></a>00142   <span class="comment">// associated RBSystem</span>
<a name="l00143"></a>00143   <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#ab24885744cf843c0bc3056d4ba43c8ac">resize_to_new_n_bfs</a>();
<a name="l00144"></a>00144 
<a name="l00145"></a>00145   std::vector&lt;Real&gt; previous_mu(<a class="code" href="classlibMesh_1_1RBBase.php#a2c3f951cf69b5da83a67734be6b01972">get_n_params</a>()-1);
<a name="l00146"></a>00146   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=this-&gt;<a class="code" href="classlibMesh_1_1RBBase.php#a12552cd94e8487531fc5b7d7d461fb84">get_first_local_training_index</a>();
<a name="l00147"></a>00147                    i&lt;this-&gt;<a class="code" href="classlibMesh_1_1RBBase.php#ab525b1169126b05cbbc6d0b435342eb3">get_last_local_training_index</a>(); i++)
<a name="l00148"></a>00148   {
<a name="l00149"></a>00149     <span class="comment">// Construct a parameter vector that does not include time</span>
<a name="l00150"></a>00150     <span class="comment">// so we can pass it to system</span>
<a name="l00151"></a>00151     std::vector&lt;Real&gt; eigen_mu = this-&gt;<a class="code" href="classlibMesh_1_1RBBase.php#a4e6e0ae8de711c3b46b26c914a7c2507">get_training_parameter</a>(i);
<a name="l00152"></a>00152     std::vector&lt;Real&gt; mu(this-&gt;<a class="code" href="classlibMesh_1_1RBBase.php#a2c3f951cf69b5da83a67734be6b01972">get_n_params</a>()-1);
<a name="l00153"></a>00153     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;mu.size(); j++)
<a name="l00154"></a>00154       mu[j] = eigen_mu[j];
<a name="l00155"></a>00155 
<a name="l00156"></a>00156     <span class="comment">// Create a bool that indicates whether previous_mu == mu</span>
<a name="l00157"></a>00157     <span class="keywordtype">bool</span> same_mu;
<a name="l00158"></a>00158     <span class="keywordflow">if</span>(i == this-&gt;<a class="code" href="classlibMesh_1_1RBBase.php#a12552cd94e8487531fc5b7d7d461fb84">get_first_local_training_index</a>())
<a name="l00159"></a>00159       same_mu = <span class="keyword">false</span>;
<a name="l00160"></a>00160     <span class="keywordflow">else</span>
<a name="l00161"></a>00161     {
<a name="l00162"></a>00162       same_mu = <span class="keyword">true</span>;
<a name="l00163"></a>00163       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;mu.size(); j++)
<a name="l00164"></a>00164         same_mu = same_mu &amp;&amp; (previous_mu[j] == mu[j]);
<a name="l00165"></a>00165     }
<a name="l00166"></a>00166 
<a name="l00167"></a>00167     <span class="comment">// Don&#39;t need to re-solve unless mu has changed!</span>
<a name="l00168"></a>00168     <span class="keywordflow">if</span>( !same_mu )
<a name="l00169"></a>00169     {
<a name="l00170"></a>00170       RB_system.<a class="code" href="classlibMesh_1_1RBBase.php#a04037fe5c23e9d9e5652936888cb8f0f">set_current_parameters</a>(mu);
<a name="l00171"></a>00171       RB_system.<a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a1680488164f8f4f740eaf333aa792625">RB_solve</a>(RB_size);
<a name="l00172"></a>00172     }
<a name="l00173"></a>00173 
<a name="l00174"></a>00174     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> time_level = <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a463cd8ae3fb64976ef18d0b4cbf459cb">round</a>( eigen_mu[this-&gt;<a class="code" href="classlibMesh_1_1RBBase.php#a2c3f951cf69b5da83a67734be6b01972">get_n_params</a>()-1] );
<a name="l00175"></a>00175 
<a name="l00176"></a>00176     std::vector&lt;Number&gt; RB_u_euler_theta(RB_size);
<a name="l00177"></a>00177     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;RB_size; j++)
<a name="l00178"></a>00178     {
<a name="l00179"></a>00179       <span class="comment">// The training parameters should be generated such that</span>
<a name="l00180"></a>00180       <span class="comment">// we never get time_level == 0</span>
<a name="l00181"></a>00181       libmesh_assert(time_level &gt; 0);
<a name="l00182"></a>00182 
<a name="l00183"></a>00183       RB_u_euler_theta[j] = RB_system.<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a546f47bca2dec636e0fe9c095c3dc3dd">get_euler_theta</a>() *RB_system.<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a475a0b22e1808293b4d209f35f60914f">RB_temporal_solution_data</a>[time_level]  (j)
<a name="l00184"></a>00184                 + (1.-RB_system.<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a546f47bca2dec636e0fe9c095c3dc3dd">get_euler_theta</a>())*RB_system.<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a475a0b22e1808293b4d209f35f60914f">RB_temporal_solution_data</a>[time_level-1](j);
<a name="l00185"></a>00185     }
<a name="l00186"></a>00186     this-&gt;<a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a5d4f0e95b169dca87aede15c26c9d098">set_training_RB_coeffs</a>(i, RB_u_euler_theta);
<a name="l00187"></a>00187 
<a name="l00188"></a>00188     previous_mu = RB_system.<a class="code" href="classlibMesh_1_1RBBase.php#af3bb451bd612eb5e7e8f0684f4b9cc97">get_current_parameters</a>();
<a name="l00189"></a>00189   }
<a name="l00190"></a>00190 
<a name="l00191"></a>00191   <a class="code" href="classlibMesh_1_1RBSCMSystem.php#af7e4f77971d064fa4e614a8a098459af">Parent::perform_SCM_greedy</a>();
<a name="l00192"></a>00192 }
<a name="l00193"></a>00193 
<a name="l00194"></a><a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#ade07e8220b5a523623c95ad03109e8e2">00194</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#ade07e8220b5a523623c95ad03109e8e2">QNTransientSCMSystem::attach_theta_c</a>(<a class="code" href="namespacelibMesh.php#aa62736885c7a9bb67eda65b54ee20107">theta_q_fptr</a> theta_c_in)
<a name="l00195"></a>00195 {
<a name="l00196"></a>00196   <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a012562178846a38a983b1c028f7f48cd">theta_c</a> = theta_c_in;
<a name="l00197"></a>00197 }
<a name="l00198"></a>00198 
<a name="l00199"></a><a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#af2ebfa615af4ff74f41a2fa932e9f68c">00199</a> <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#af2ebfa615af4ff74f41a2fa932e9f68c">QNTransientSCMSystem::eval_theta_c</a>()
<a name="l00200"></a>00200 {
<a name="l00201"></a>00201   libmesh_assert(<a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a012562178846a38a983b1c028f7f48cd">theta_c</a> != NULL);
<a name="l00202"></a>00202 
<a name="l00203"></a>00203   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a012562178846a38a983b1c028f7f48cd">theta_c</a>(*<a class="code" href="classlibMesh_1_1RBBase.php#ab2c1a2771ccd818046de826adbe3beb6">theta_data</a>);
<a name="l00204"></a>00204 }
<a name="l00205"></a>00205 
<a name="l00206"></a><a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a5a77999f9ab006b1bab0288a81adba7d">00206</a> <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a5a77999f9ab006b1bab0288a81adba7d">QNTransientSCMSystem::eval_theta_q_a</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q)
<a name="l00207"></a>00207 {
<a name="l00208"></a>00208   <span class="keywordflow">if</span>(q &lt; <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a88ea7d267ff9e995bd6716852e8a6ec9">get_n_basis_functions</a>())
<a name="l00209"></a>00209   {
<a name="l00210"></a>00210     libmesh_assert(<a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a012562178846a38a983b1c028f7f48cd">theta_c</a> != NULL);
<a name="l00211"></a>00211     <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#af2ebfa615af4ff74f41a2fa932e9f68c">eval_theta_c</a>()*<a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a12786f3880f33e4ffd2fd5c786e347db">current_RB_coeffs</a>[q];
<a name="l00212"></a>00212   }
<a name="l00213"></a>00213   <span class="keywordflow">else</span>
<a name="l00214"></a>00214   {
<a name="l00215"></a>00215     <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1RBBase.php#aeeb46ce2b390bf820f954976ee9da7ce">Parent::eval_theta_q_a</a>(q-<a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a88ea7d267ff9e995bd6716852e8a6ec9">get_n_basis_functions</a>());
<a name="l00216"></a>00216   }
<a name="l00217"></a>00217 }
<a name="l00218"></a>00218 
<a name="l00219"></a><a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#adf9d3371dedbbac9065f05821d3b4b58">00219</a> std::vector&lt;Number&gt; <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#adf9d3371dedbbac9065f05821d3b4b58">QNTransientSCMSystem::get_training_RB_coeffs</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index)
<a name="l00220"></a>00220 {
<a name="l00221"></a>00221   libmesh_assert(<a class="code" href="classlibMesh_1_1RBBase.php#acd3759e618b59d145fbc4d8668aa2564">training_parameters_initialized</a>);
<a name="l00222"></a>00222 
<a name="l00223"></a>00223   libmesh_assert( (this-&gt;<a class="code" href="classlibMesh_1_1RBBase.php#a12552cd94e8487531fc5b7d7d461fb84">get_first_local_training_index</a>() &lt;= index) &amp;&amp;
<a name="l00224"></a>00224                   (index &lt; this-&gt;<a class="code" href="classlibMesh_1_1RBBase.php#ab525b1169126b05cbbc6d0b435342eb3">get_last_local_training_index</a>()) );
<a name="l00225"></a>00225 
<a name="l00226"></a>00226   std::vector&lt;Number&gt; coeffs(this-&gt;<a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a88ea7d267ff9e995bd6716852e8a6ec9">get_n_basis_functions</a>());
<a name="l00227"></a>00227   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;coeffs.size(); i++)
<a name="l00228"></a>00228     coeffs[i] = (*<a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a2204539de9bd3f86bea8bdafbad71ade">training_RB_coeffs</a>[i])(index);
<a name="l00229"></a>00229 
<a name="l00230"></a>00230   <span class="keywordflow">return</span> coeffs;
<a name="l00231"></a>00231 }
<a name="l00232"></a>00232 
<a name="l00233"></a><a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a5d4f0e95b169dca87aede15c26c9d098">00233</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a5d4f0e95b169dca87aede15c26c9d098">QNTransientSCMSystem::set_training_RB_coeffs</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index, std::vector&lt;Number&gt; coeffs)
<a name="l00234"></a>00234 {
<a name="l00235"></a>00235   libmesh_assert(<a class="code" href="classlibMesh_1_1RBBase.php#acd3759e618b59d145fbc4d8668aa2564">training_parameters_initialized</a>);
<a name="l00236"></a>00236 
<a name="l00237"></a>00237   libmesh_assert( (this-&gt;<a class="code" href="classlibMesh_1_1RBBase.php#a12552cd94e8487531fc5b7d7d461fb84">get_first_local_training_index</a>() &lt;= index) &amp;&amp;
<a name="l00238"></a>00238                   (index &lt; this-&gt;<a class="code" href="classlibMesh_1_1RBBase.php#ab525b1169126b05cbbc6d0b435342eb3">get_last_local_training_index</a>()) );
<a name="l00239"></a>00239 
<a name="l00240"></a>00240   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;coeffs.size(); i++)
<a name="l00241"></a>00241   {
<a name="l00242"></a>00242     <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a2204539de9bd3f86bea8bdafbad71ade">training_RB_coeffs</a>[i]-&gt;set(index, coeffs[i]);
<a name="l00243"></a>00243   }
<a name="l00244"></a>00244 }
<a name="l00245"></a>00245 
<a name="l00246"></a><a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a8bb31a567fe1d428bd22ede5e10d49c3">00246</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a8bb31a567fe1d428bd22ede5e10d49c3">QNTransientSCMSystem::add_scaled_symm_Aq</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_a, <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> scalar)
<a name="l00247"></a>00247 {
<a name="l00248"></a>00248   START_LOG(<span class="stringliteral">&quot;add_scaled_symm_Aq()&quot;</span>, <span class="stringliteral">&quot;QNTransientSCMSystem&quot;</span>);
<a name="l00249"></a>00249 
<a name="l00250"></a>00250   <span class="keywordflow">if</span>(q_a &lt; <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a88ea7d267ff9e995bd6716852e8a6ec9">get_n_basis_functions</a>())
<a name="l00251"></a>00251   {
<a name="l00252"></a>00252     <span class="comment">// Load the trilinear form operators from the RBSystem</span>
<a name="l00253"></a>00253     <a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es = this-&gt;<a class="code" href="classlibMesh_1_1System.php#ac5ca6b1f3adcfac56982982e90dc905b">get_equation_systems</a>();
<a name="l00254"></a>00254     <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php">QNTransientRBSystem</a>&amp; rb_system = es.<a class="code" href="classlibMesh_1_1EquationSystems.php#a5dac23f839af25ce7dbf1fe9a6d4b67a">get_system</a>&lt;<a class="code" href="classlibMesh_1_1QNTransientRBSystem.php">QNTransientRBSystem</a>&gt;(<a class="code" href="classlibMesh_1_1RBSCMSystem.php#a3427a19ee940f3b5eb5a953c3a833e5a">RB_system_name</a>);
<a name="l00255"></a>00255 
<a name="l00256"></a>00256     rb_system.<a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a18c78570401eb41027d51e62743feb1f">add_scaled_Cn</a>(scalar, q_a, <a class="code" href="classlibMesh_1_1EigenSystem.php#a01a29a78830ad7813cdf0f64997b586f">matrix_A</a>, <span class="keyword">true</span>);
<a name="l00257"></a>00257   }
<a name="l00258"></a>00258   <span class="keywordflow">else</span>
<a name="l00259"></a>00259   {
<a name="l00260"></a>00260     <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a2b9680a829301afd6357b5550b685896">Parent::add_scaled_symm_Aq</a>(q_a-<a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a88ea7d267ff9e995bd6716852e8a6ec9">get_n_basis_functions</a>(), scalar);
<a name="l00261"></a>00261   }
<a name="l00262"></a>00262 
<a name="l00263"></a>00263   STOP_LOG(<span class="stringliteral">&quot;add_scaled_symm_Aq()&quot;</span>, <span class="stringliteral">&quot;QNTransientSCMSystem&quot;</span>);
<a name="l00264"></a>00264 }
<a name="l00265"></a>00265 
<a name="l00266"></a><a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#ab54ac25b83ed03b4f62d0d1bb9d08929">00266</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#ab54ac25b83ed03b4f62d0d1bb9d08929">QNTransientSCMSystem::load_training_parameter_locally</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index)
<a name="l00267"></a>00267 {
<a name="l00268"></a>00268   <a class="code" href="classlibMesh_1_1RBBase.php#a0d982ba07d961cb438fa783bf17517e7">Parent::load_training_parameter_locally</a>(index);
<a name="l00269"></a>00269 
<a name="l00270"></a>00270   <span class="comment">// Also, load RB_coeffs</span>
<a name="l00271"></a>00271   <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a07e0ef2d5546ee2beb4f5ae4e3d3a7dc">set_current_RB_coeffs</a>( <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#adf9d3371dedbbac9065f05821d3b4b58">get_training_RB_coeffs</a>(index) );
<a name="l00272"></a>00272 }
<a name="l00273"></a>00273 
<a name="l00274"></a><a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a75570766c94b2bd7894d4d84ef524fd8">00274</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a75570766c94b2bd7894d4d84ef524fd8">QNTransientSCMSystem::load_training_parameter_globally</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index)
<a name="l00275"></a>00275 {
<a name="l00276"></a>00276   <a class="code" href="classlibMesh_1_1RBBase.php#a54e4e9c609bcf66c7a95a0307e6b5a78">Parent::load_training_parameter_globally</a>(index);
<a name="l00277"></a>00277 
<a name="l00278"></a>00278   <span class="comment">// Also, load RB_coeffs</span>
<a name="l00279"></a>00279   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> root_id = 0;
<a name="l00280"></a>00280   std::vector&lt;Number&gt; new_RB_coeffs(<a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a88ea7d267ff9e995bd6716852e8a6ec9">get_n_basis_functions</a>());
<a name="l00281"></a>00281   <span class="keywordflow">if</span>( (this-&gt;<a class="code" href="classlibMesh_1_1RBBase.php#a12552cd94e8487531fc5b7d7d461fb84">get_first_local_training_index</a>() &lt;= index) &amp;&amp;
<a name="l00282"></a>00282       (index &lt; this-&gt;<a class="code" href="classlibMesh_1_1RBBase.php#ab525b1169126b05cbbc6d0b435342eb3">get_last_local_training_index</a>()) )
<a name="l00283"></a>00283   {
<a name="l00284"></a>00284     new_RB_coeffs = <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#adf9d3371dedbbac9065f05821d3b4b58">get_training_RB_coeffs</a>(index);
<a name="l00285"></a>00285     root_id = <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>(); <span class="comment">// Only non-zero on one processor</span>
<a name="l00286"></a>00286   }
<a name="l00287"></a>00287   <a class="code" href="namespacelibMesh_1_1Parallel.php#a32ab26117222089e6540e66b05c06b1b">Parallel::sum</a>(root_id);
<a name="l00288"></a>00288   <a class="code" href="namespacelibMesh_1_1Parallel.php#a0856815f9d1ce56771e340b45ef80e6c">Parallel::broadcast</a>(new_RB_coeffs, root_id);
<a name="l00289"></a>00289 
<a name="l00290"></a>00290   <span class="comment">// Store in C_J_RB_coeffs</span>
<a name="l00291"></a>00291   <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a3a16673187a444a53c6585e89865bda4">C_J_RB_coeffs</a>.push_back( new_RB_coeffs );
<a name="l00292"></a>00292 
<a name="l00293"></a>00293   <span class="comment">// and set current_RB_coeffs</span>
<a name="l00294"></a>00294   <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a07e0ef2d5546ee2beb4f5ae4e3d3a7dc">set_current_RB_coeffs</a>( new_RB_coeffs );
<a name="l00295"></a>00295 }
<a name="l00296"></a>00296 
<a name="l00297"></a><a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a833a3f37b2177dd99b33d4788c5cb377">00297</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a833a3f37b2177dd99b33d4788c5cb377">QNTransientSCMSystem::save_current_parameters</a>()
<a name="l00298"></a>00298 {
<a name="l00299"></a>00299   <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a213d1404621821585eeca3e60b71dda2">Parent::save_current_parameters</a>();
<a name="l00300"></a>00300 
<a name="l00301"></a>00301   <span class="comment">// Also, save RB_coeffs</span>
<a name="l00302"></a>00302   <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a5a3bd1c494a136c2f783679ec496da9d">saved_RB_coeffs</a> = <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a12786f3880f33e4ffd2fd5c786e347db">current_RB_coeffs</a>;
<a name="l00303"></a>00303 }
<a name="l00304"></a>00304 
<a name="l00305"></a><a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a9bef97a1ed76bfe53367af9898d33cad">00305</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a9bef97a1ed76bfe53367af9898d33cad">QNTransientSCMSystem::reload_current_parameters</a>()
<a name="l00306"></a>00306 {
<a name="l00307"></a>00307   <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a256ff6e79bd7bf85111f78aa703d1868">Parent::reload_current_parameters</a>();
<a name="l00308"></a>00308 
<a name="l00309"></a>00309   <span class="comment">// Also, reload RB_coeffs</span>
<a name="l00310"></a>00310   <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a07e0ef2d5546ee2beb4f5ae4e3d3a7dc">set_current_RB_coeffs</a>( <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a5a3bd1c494a136c2f783679ec496da9d">saved_RB_coeffs</a> );
<a name="l00311"></a>00311 }
<a name="l00312"></a>00312 
<a name="l00313"></a><a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a611e2301ed68d973c6a99a16d43aed80">00313</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a611e2301ed68d973c6a99a16d43aed80">QNTransientSCMSystem::set_current_parameters_from_C_J</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> C_J_index)
<a name="l00314"></a>00314 {
<a name="l00315"></a>00315   <a class="code" href="classlibMesh_1_1RBSCMSystem.php#af187e480f971ff7fc1ae862fd62f5d63">Parent::set_current_parameters_from_C_J</a>(C_J_index);
<a name="l00316"></a>00316 
<a name="l00317"></a>00317   <span class="comment">// Also, set RB_coeffs</span>
<a name="l00318"></a>00318   <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a12786f3880f33e4ffd2fd5c786e347db">current_RB_coeffs</a> = <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a3a16673187a444a53c6585e89865bda4">C_J_RB_coeffs</a>[C_J_index];
<a name="l00319"></a>00319 }
<a name="l00320"></a>00320 
<a name="l00321"></a><a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a38dbf6839616b02997921fe9e4306c36">00321</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a38dbf6839616b02997921fe9e4306c36">QNTransientSCMSystem::initialize_training_parameters</a>(<span class="keyword">const</span> std::vector&lt;Real&gt;&amp; mu_min_vector,
<a name="l00322"></a>00322                                                           <span class="keyword">const</span> std::vector&lt;Real&gt;&amp; mu_max_vector,
<a name="l00323"></a>00323                                                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_param_samples,
<a name="l00324"></a>00324                                                           <span class="keyword">const</span> std::vector&lt;bool&gt; log_param_scale,
<a name="l00325"></a>00325                                                           <span class="keyword">const</span> <span class="keywordtype">bool</span> deterministic)
<a name="l00326"></a>00326 {
<a name="l00327"></a>00327   <span class="keywordflow">if</span>( (<a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a5af76d22e754265f7a88b9953be8c087">_K</a> % <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a425e8de7389490bedcfa3226b1689116">n_time_samples</a>) != 0)
<a name="l00328"></a>00328   {
<a name="l00329"></a>00329     <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: K must be divisible by n_SCM_time_samples&quot;</span> &lt;&lt; std::endl;
<a name="l00330"></a>00330     libmesh_error();
<a name="l00331"></a>00331   }
<a name="l00332"></a>00332 
<a name="l00333"></a>00333   this-&gt;mu_min_vector = <a class="code" href="classlibMesh_1_1RBBase.php#aa54633a8a1d87dc76bbce3cec5e80421">mu_min_vector</a>;
<a name="l00334"></a>00334   this-&gt;mu_max_vector = <a class="code" href="classlibMesh_1_1RBBase.php#a908713cda5467ba29a8141ee97d3a49d">mu_max_vector</a>;
<a name="l00335"></a>00335 
<a name="l00336"></a>00336   <span class="comment">// Since time is a parameter here, we need at least one other parameter</span>
<a name="l00337"></a>00337   libmesh_assert(<a class="code" href="classlibMesh_1_1RBBase.php#a2c3f951cf69b5da83a67734be6b01972">get_n_params</a>() &gt; 1);
<a name="l00338"></a>00338 
<a name="l00339"></a>00339   <span class="comment">// Initialize a temporary training set (distributed across processors)</span>
<a name="l00340"></a>00340   <span class="comment">// that doesn&#39;t include time</span>
<a name="l00341"></a>00341   std::vector&lt; NumericVector&lt;Number&gt;* &gt; dist_temp_training_parameters;
<a name="l00342"></a>00342 
<a name="l00343"></a>00343   <span class="comment">// Strip off the time parameter from log_param_scale, mu_min/max_vector</span>
<a name="l00344"></a>00344   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> temp_n_params = log_param_scale.size()-1;
<a name="l00345"></a>00345   std::vector&lt;bool&gt; temp_log_param_scale(temp_n_params);
<a name="l00346"></a>00346   std::vector&lt;Real&gt; temp_mu_min_vector(temp_n_params);
<a name="l00347"></a>00347   std::vector&lt;Real&gt; temp_mu_max_vector(temp_n_params);
<a name="l00348"></a>00348   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;temp_n_params; i++)
<a name="l00349"></a>00349   {
<a name="l00350"></a>00350     temp_log_param_scale[i] = log_param_scale[i];
<a name="l00351"></a>00351     temp_mu_min_vector[i]   = mu_min_vector[i];
<a name="l00352"></a>00352     temp_mu_max_vector[i]   = mu_max_vector[i];
<a name="l00353"></a>00353   }
<a name="l00354"></a>00354 
<a name="l00355"></a>00355   <span class="keywordflow">if</span>(deterministic)
<a name="l00356"></a>00356   {
<a name="l00357"></a>00357     <a class="code" href="classlibMesh_1_1RBBase.php#acbaa8999c6d2296cd16b987a60b1b356">generate_training_parameters_deterministic</a>(temp_log_param_scale,
<a name="l00358"></a>00358                                                dist_temp_training_parameters,
<a name="l00359"></a>00359                                                n_param_samples,
<a name="l00360"></a>00360                                                temp_mu_min_vector,
<a name="l00361"></a>00361                                                temp_mu_max_vector);
<a name="l00362"></a>00362   }
<a name="l00363"></a>00363   <span class="keywordflow">else</span>
<a name="l00364"></a>00364   {
<a name="l00365"></a>00365     <a class="code" href="classlibMesh_1_1RBBase.php#a22c4ebd789154b075bfb09b148deea1e">generate_training_parameters_random</a>(temp_log_param_scale,
<a name="l00366"></a>00366                                         dist_temp_training_parameters,
<a name="l00367"></a>00367                                         n_param_samples,
<a name="l00368"></a>00368                                         temp_mu_min_vector,
<a name="l00369"></a>00369                                         temp_mu_max_vector,
<a name="l00370"></a>00370                                         this-&gt;<a class="code" href="classlibMesh_1_1RBBase.php#aa2f4297e83e21e49a5cc7dc2ad2bda44">training_parameters_random_seed</a>);
<a name="l00371"></a>00371   }
<a name="l00372"></a>00372 
<a name="l00373"></a>00373   <span class="comment">// dist_temp_training_parameters is now a distributed training set, so</span>
<a name="l00374"></a>00374   <span class="comment">// first localize and then delete the distributed vectors</span>
<a name="l00375"></a>00375   std::vector&lt; std::vector&lt;Number&gt; &gt;
<a name="l00376"></a>00376     temp_training_parameters( dist_temp_training_parameters.size() );
<a name="l00377"></a>00377   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;dist_temp_training_parameters.size(); i++)
<a name="l00378"></a>00378   {
<a name="l00379"></a>00379     dist_temp_training_parameters[i]-&gt;localize( temp_training_parameters[i] );
<a name="l00380"></a>00380     <span class="keyword">delete</span> dist_temp_training_parameters[i];
<a name="l00381"></a>00381     dist_temp_training_parameters[i] = NULL;
<a name="l00382"></a>00382   }
<a name="l00383"></a>00383   dist_temp_training_parameters.clear();
<a name="l00384"></a>00384 
<a name="l00385"></a>00385   <span class="comment">// Now add time to the parameter training set...</span>
<a name="l00386"></a>00386   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_training_samples_in = n_time_samples*n_param_samples;
<a name="l00387"></a>00387 
<a name="l00388"></a>00388   <span class="comment">// Calculate the number of training parameters local to this processor</span>
<a name="l00389"></a>00389   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_local_training_samples;
<a name="l00390"></a>00390   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> quotient  = n_training_samples_in/<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>();
<a name="l00391"></a>00391   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> remainder = n_training_samples_in%<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>();
<a name="l00392"></a>00392   <span class="keywordflow">if</span>(<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt; remainder)
<a name="l00393"></a>00393     n_local_training_samples = (quotient + 1);
<a name="l00394"></a>00394   <span class="keywordflow">else</span>
<a name="l00395"></a>00395     n_local_training_samples = quotient;
<a name="l00396"></a>00396 
<a name="l00397"></a>00397   <span class="comment">// Initialize num_params NumericVectors</span>
<a name="l00398"></a>00398   <a class="code" href="classlibMesh_1_1RBBase.php#a299d5b623e51dd672d8b4d183a68bce8">training_parameters</a>.resize(<a class="code" href="classlibMesh_1_1RBBase.php#a2c3f951cf69b5da83a67734be6b01972">get_n_params</a>());
<a name="l00399"></a>00399 
<a name="l00400"></a>00400   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1RBBase.php#a2c3f951cf69b5da83a67734be6b01972">get_n_params</a>(); i++)
<a name="l00401"></a>00401   {
<a name="l00402"></a>00402     <a class="code" href="classlibMesh_1_1RBBase.php#a299d5b623e51dd672d8b4d183a68bce8">training_parameters</a>[i] = <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;::build</a>().release();
<a name="l00403"></a>00403     <a class="code" href="classlibMesh_1_1RBBase.php#a299d5b623e51dd672d8b4d183a68bce8">training_parameters</a>[i]-&gt;init(n_training_samples_in, n_local_training_samples, <span class="keyword">false</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">libMeshEnums::PARALLEL</a>);
<a name="l00404"></a>00404   }
<a name="l00405"></a>00405 
<a name="l00406"></a>00406   <span class="keywordtype">int</span> time_step_size = <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a463cd8ae3fb64976ef18d0b4cbf459cb">round</a> ( <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a5af76d22e754265f7a88b9953be8c087">_K</a> / n_time_samples );
<a name="l00407"></a>00407 
<a name="l00408"></a>00408   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> first_local_index = <a class="code" href="classlibMesh_1_1RBBase.php#a299d5b623e51dd672d8b4d183a68bce8">training_parameters</a>[0]-&gt;first_local_index();
<a name="l00409"></a>00409   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> last_local_index  = <a class="code" href="classlibMesh_1_1RBBase.php#a299d5b623e51dd672d8b4d183a68bce8">training_parameters</a>[0]-&gt;last_local_index();
<a name="l00410"></a>00410   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> count = 0;
<a name="l00411"></a>00411   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;temp_training_parameters[0].size(); i++)
<a name="l00412"></a>00412   {
<a name="l00413"></a>00413     std::vector&lt;Real&gt; params_i( <a class="code" href="classlibMesh_1_1RBBase.php#a2c3f951cf69b5da83a67734be6b01972">get_n_params</a>()-1 );
<a name="l00414"></a>00414     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;(<a class="code" href="classlibMesh_1_1RBBase.php#a2c3f951cf69b5da83a67734be6b01972">get_n_params</a>()-1); j++)
<a name="l00415"></a>00415       params_i[j] = <a class="code" href="namespacelibMesh.php#aea33cac176f18504c5c4078407aadbb7">libmesh_real</a>(temp_training_parameters[j][i]);
<a name="l00416"></a>00416     params_i.push_back(0.);
<a name="l00417"></a>00417 
<a name="l00418"></a>00418     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=1; j&lt;=<a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a425e8de7389490bedcfa3226b1689116">n_time_samples</a>; j++)
<a name="l00419"></a>00419     {
<a name="l00420"></a>00420       <span class="keywordflow">if</span>( (first_local_index &lt;= count) &amp;&amp; (count &lt; last_local_index) )
<a name="l00421"></a>00421       {
<a name="l00422"></a>00422         <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index=0; index&lt;(<a class="code" href="classlibMesh_1_1RBBase.php#a2c3f951cf69b5da83a67734be6b01972">get_n_params</a>()-1); index++)
<a name="l00423"></a>00423         {
<a name="l00424"></a>00424           <a class="code" href="classlibMesh_1_1RBBase.php#a299d5b623e51dd672d8b4d183a68bce8">training_parameters</a>[index]-&gt;set(count, params_i[index]);
<a name="l00425"></a>00425         }
<a name="l00426"></a>00426 
<a name="l00427"></a>00427         <span class="comment">// Now overwrite the time entry with the appropriate value</span>
<a name="l00428"></a>00428         <a class="code" href="classlibMesh_1_1RBBase.php#a299d5b623e51dd672d8b4d183a68bce8">training_parameters</a>[<a class="code" href="classlibMesh_1_1RBBase.php#a2c3f951cf69b5da83a67734be6b01972">get_n_params</a>()-1]-&gt;set(count, j*time_step_size);
<a name="l00429"></a>00429       }
<a name="l00430"></a>00430       count++;
<a name="l00431"></a>00431     }
<a name="l00432"></a>00432   }
<a name="l00433"></a>00433 
<a name="l00434"></a>00434   <a class="code" href="classlibMesh_1_1RBBase.php#acd3759e618b59d145fbc4d8668aa2564">training_parameters_initialized</a> = <span class="keyword">true</span>;
<a name="l00435"></a>00435 }
<a name="l00436"></a>00436 
<a name="l00437"></a><a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a6a62b451558cce9cc3ed16ae2cc76bb5">00437</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a6a62b451558cce9cc3ed16ae2cc76bb5">QNTransientSCMSystem::load_training_set</a>(std::vector&lt; std::vector&lt;Number&gt; &gt;&amp; new_training_set)
<a name="l00438"></a>00438 {
<a name="l00439"></a>00439   <span class="comment">// First, make sure that an initial training set has already been</span>
<a name="l00440"></a>00440   <span class="comment">// generated</span>
<a name="l00441"></a>00441   <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBBase.php#acd3759e618b59d145fbc4d8668aa2564">training_parameters_initialized</a>)
<a name="l00442"></a>00442   {
<a name="l00443"></a>00443     <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Error: load_training_set cannot be used to initialize parameters&quot;</span>
<a name="l00444"></a>00444                  &lt;&lt; std::endl;
<a name="l00445"></a>00445     libmesh_error();
<a name="l00446"></a>00446   }
<a name="l00447"></a>00447 
<a name="l00448"></a>00448   <span class="comment">// Make sure that the training set has the correct number of parameters</span>
<a name="l00449"></a>00449   <span class="comment">// (excluding the time &quot;parameter&quot;)</span>
<a name="l00450"></a>00450   <span class="keywordflow">if</span>(new_training_set.size() != (<a class="code" href="classlibMesh_1_1RBBase.php#a2c3f951cf69b5da83a67734be6b01972">get_n_params</a>()-1))
<a name="l00451"></a>00451   {
<a name="l00452"></a>00452     <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Error: Incorrect number of parameters in load_training_set.&quot;</span>
<a name="l00453"></a>00453                  &lt;&lt; std::endl;
<a name="l00454"></a>00454     libmesh_error();
<a name="l00455"></a>00455   }
<a name="l00456"></a>00456 
<a name="l00457"></a>00457   <span class="comment">// Make sure n_time_samples is valid</span>
<a name="l00458"></a>00458   <span class="keywordflow">if</span>( (<a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a5af76d22e754265f7a88b9953be8c087">_K</a> % <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a425e8de7389490bedcfa3226b1689116">n_time_samples</a>) != 0)
<a name="l00459"></a>00459   {
<a name="l00460"></a>00460     <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: K must be divisible by n_SCM_time_samples&quot;</span> &lt;&lt; std::endl;
<a name="l00461"></a>00461     libmesh_error();
<a name="l00462"></a>00462   }
<a name="l00463"></a>00463 
<a name="l00464"></a>00464   <span class="comment">// Initialize a temporary training set (distributed across processors)</span>
<a name="l00465"></a>00465   <span class="comment">// that doesn&#39;t include time. This is where we load the training set into.</span>
<a name="l00466"></a>00466   std::vector&lt; NumericVector&lt;Number&gt;* &gt; dist_temp_training_parameters(<a class="code" href="classlibMesh_1_1RBBase.php#a2c3f951cf69b5da83a67734be6b01972">get_n_params</a>()-1);
<a name="l00467"></a>00467   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_global_training_samples;
<a name="l00468"></a>00468 
<a name="l00469"></a>00469   {
<a name="l00470"></a>00470     <span class="comment">// Get the number of local and global training parameters</span>
<a name="l00471"></a>00471     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_local_training_samples  = new_training_set[0].size();
<a name="l00472"></a>00472     n_global_training_samples = n_local_training_samples;
<a name="l00473"></a>00473     <a class="code" href="namespacelibMesh_1_1Parallel.php#a32ab26117222089e6540e66b05c06b1b">Parallel::sum</a>(n_global_training_samples);
<a name="l00474"></a>00474 
<a name="l00475"></a>00475     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;dist_temp_training_parameters.size(); i++)
<a name="l00476"></a>00476     {
<a name="l00477"></a>00477       dist_temp_training_parameters[i] = <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;::build</a>().release();
<a name="l00478"></a>00478       dist_temp_training_parameters[i]-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#aba2b1e60a94162764c07732626a8231b">init</a>(n_global_training_samples, n_local_training_samples, <span class="keyword">false</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">libMeshEnums::PARALLEL</a>);
<a name="l00479"></a>00479     }
<a name="l00480"></a>00480 
<a name="l00481"></a>00481     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;dist_temp_training_parameters.size(); j++)
<a name="l00482"></a>00482     {
<a name="l00483"></a>00483       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> first_index = dist_temp_training_parameters[j]-&gt;first_local_index();
<a name="l00484"></a>00484       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_local_training_samples; i++)
<a name="l00485"></a>00485       {
<a name="l00486"></a>00486         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index = first_index + i;
<a name="l00487"></a>00487         dist_temp_training_parameters[j]-&gt;set(index, new_training_set[j][i]);
<a name="l00488"></a>00488       }
<a name="l00489"></a>00489     }
<a name="l00490"></a>00490   }
<a name="l00491"></a>00491 
<a name="l00492"></a>00492   <span class="comment">// THE CODE BELOW IS MOSTLY COPIED FROM QNTransientSCMSystem::initialize_training_parameters</span>
<a name="l00493"></a>00493   <span class="comment">// dist_temp_training_parameters is now a distributed training set, so</span>
<a name="l00494"></a>00494   <span class="comment">// first localize and then delete the distributed vectors</span>
<a name="l00495"></a>00495   std::vector&lt; std::vector&lt;Number&gt; &gt;
<a name="l00496"></a>00496     temp_training_parameters( dist_temp_training_parameters.size() );
<a name="l00497"></a>00497   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;dist_temp_training_parameters.size(); i++)
<a name="l00498"></a>00498   {
<a name="l00499"></a>00499     dist_temp_training_parameters[i]-&gt;localize( temp_training_parameters[i] );
<a name="l00500"></a>00500     <span class="keyword">delete</span> dist_temp_training_parameters[i];
<a name="l00501"></a>00501     dist_temp_training_parameters[i] = NULL;
<a name="l00502"></a>00502   }
<a name="l00503"></a>00503   dist_temp_training_parameters.clear();
<a name="l00504"></a>00504 
<a name="l00505"></a>00505   <span class="comment">// Now add time to the parameter training set...</span>
<a name="l00506"></a>00506   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_training_samples_in = n_time_samples*n_global_training_samples;
<a name="l00507"></a>00507 
<a name="l00508"></a>00508   <span class="comment">// Calculate the number of training parameters local to this processor</span>
<a name="l00509"></a>00509   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_local_training_samples;
<a name="l00510"></a>00510   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> quotient  = n_training_samples_in/<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>();
<a name="l00511"></a>00511   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> remainder = n_training_samples_in%<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>();
<a name="l00512"></a>00512   <span class="keywordflow">if</span>(<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt; remainder)
<a name="l00513"></a>00513     n_local_training_samples = (quotient + 1);
<a name="l00514"></a>00514   <span class="keywordflow">else</span>
<a name="l00515"></a>00515     n_local_training_samples = quotient;
<a name="l00516"></a>00516 
<a name="l00517"></a>00517   <span class="comment">// Clear the training set</span>
<a name="l00518"></a>00518   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1RBBase.php#a299d5b623e51dd672d8b4d183a68bce8">training_parameters</a>.size(); i++)
<a name="l00519"></a>00519   {
<a name="l00520"></a>00520     <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBBase.php#a299d5b623e51dd672d8b4d183a68bce8">training_parameters</a>[i])
<a name="l00521"></a>00521     {
<a name="l00522"></a>00522       <span class="keyword">delete</span> <a class="code" href="classlibMesh_1_1RBBase.php#a299d5b623e51dd672d8b4d183a68bce8">training_parameters</a>[i];
<a name="l00523"></a>00523       <a class="code" href="classlibMesh_1_1RBBase.php#a299d5b623e51dd672d8b4d183a68bce8">training_parameters</a>[i] = NULL;
<a name="l00524"></a>00524     }
<a name="l00525"></a>00525   }
<a name="l00526"></a>00526 
<a name="l00527"></a>00527   <span class="comment">// Reinitialize the training set</span>
<a name="l00528"></a>00528   <a class="code" href="classlibMesh_1_1RBBase.php#a299d5b623e51dd672d8b4d183a68bce8">training_parameters</a>.resize(<a class="code" href="classlibMesh_1_1RBBase.php#a2c3f951cf69b5da83a67734be6b01972">get_n_params</a>());
<a name="l00529"></a>00529   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1RBBase.php#a2c3f951cf69b5da83a67734be6b01972">get_n_params</a>(); i++)
<a name="l00530"></a>00530   {
<a name="l00531"></a>00531     <a class="code" href="classlibMesh_1_1RBBase.php#a299d5b623e51dd672d8b4d183a68bce8">training_parameters</a>[i] = <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;::build</a>().release();
<a name="l00532"></a>00532     <a class="code" href="classlibMesh_1_1RBBase.php#a299d5b623e51dd672d8b4d183a68bce8">training_parameters</a>[i]-&gt;init(n_training_samples_in, n_local_training_samples, <span class="keyword">false</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">libMeshEnums::PARALLEL</a>);
<a name="l00533"></a>00533   }
<a name="l00534"></a>00534 
<a name="l00535"></a>00535   <span class="keywordtype">int</span> time_step_size = <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a463cd8ae3fb64976ef18d0b4cbf459cb">round</a> ( <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a5af76d22e754265f7a88b9953be8c087">_K</a> / n_time_samples );
<a name="l00536"></a>00536 
<a name="l00537"></a>00537   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> first_local_index = <a class="code" href="classlibMesh_1_1RBBase.php#a299d5b623e51dd672d8b4d183a68bce8">training_parameters</a>[0]-&gt;first_local_index();
<a name="l00538"></a>00538   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> last_local_index  = <a class="code" href="classlibMesh_1_1RBBase.php#a299d5b623e51dd672d8b4d183a68bce8">training_parameters</a>[0]-&gt;last_local_index();
<a name="l00539"></a>00539   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> count = 0;
<a name="l00540"></a>00540   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;temp_training_parameters[0].size(); i++)
<a name="l00541"></a>00541   {
<a name="l00542"></a>00542     std::vector&lt;Real&gt; params_i( <a class="code" href="classlibMesh_1_1RBBase.php#a2c3f951cf69b5da83a67734be6b01972">get_n_params</a>()-1 );
<a name="l00543"></a>00543     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;(<a class="code" href="classlibMesh_1_1RBBase.php#a2c3f951cf69b5da83a67734be6b01972">get_n_params</a>()-1); j++)
<a name="l00544"></a>00544       params_i[j] = <a class="code" href="namespacelibMesh.php#aea33cac176f18504c5c4078407aadbb7">libmesh_real</a>(temp_training_parameters[j][i]);
<a name="l00545"></a>00545     params_i.push_back(0.);
<a name="l00546"></a>00546 
<a name="l00547"></a>00547     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=1; j&lt;=<a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a425e8de7389490bedcfa3226b1689116">n_time_samples</a>; j++)
<a name="l00548"></a>00548     {
<a name="l00549"></a>00549       <span class="keywordflow">if</span>( (first_local_index &lt;= count) &amp;&amp; (count &lt; last_local_index) )
<a name="l00550"></a>00550       {
<a name="l00551"></a>00551         <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index=0; index&lt;(<a class="code" href="classlibMesh_1_1RBBase.php#a2c3f951cf69b5da83a67734be6b01972">get_n_params</a>()-1); index++)
<a name="l00552"></a>00552         {
<a name="l00553"></a>00553           <a class="code" href="classlibMesh_1_1RBBase.php#a299d5b623e51dd672d8b4d183a68bce8">training_parameters</a>[index]-&gt;set(count, params_i[index]);
<a name="l00554"></a>00554         }
<a name="l00555"></a>00555 
<a name="l00556"></a>00556         <span class="comment">// Now overwrite the time entry with the appropriate value</span>
<a name="l00557"></a>00557         <a class="code" href="classlibMesh_1_1RBBase.php#a299d5b623e51dd672d8b4d183a68bce8">training_parameters</a>[<a class="code" href="classlibMesh_1_1RBBase.php#a2c3f951cf69b5da83a67734be6b01972">get_n_params</a>()-1]-&gt;set(count, j*time_step_size);
<a name="l00558"></a>00558       }
<a name="l00559"></a>00559       count++;
<a name="l00560"></a>00560     }
<a name="l00561"></a>00561   }
<a name="l00562"></a>00562 
<a name="l00563"></a>00563 <span class="comment">//  // Print out the training set</span>
<a name="l00564"></a>00564 <span class="comment">//  libMesh::out &lt;&lt; &quot;n_training_samples = &quot; &lt;&lt; n_training_samples_in &lt;&lt; std::endl;</span>
<a name="l00565"></a>00565 <span class="comment">//  for(unsigned int index=0; index&lt;n_training_samples_in; index++)</span>
<a name="l00566"></a>00566 <span class="comment">//  {</span>
<a name="l00567"></a>00567 <span class="comment">//    libMesh::out &lt;&lt; &quot;training parameters for index=&quot;&lt;&lt;index&lt;&lt;&quot;:&quot;&lt;&lt;std::endl;</span>
<a name="l00568"></a>00568 <span class="comment">//    for(unsigned int param=0; param&lt;get_n_params(); param++)</span>
<a name="l00569"></a>00569 <span class="comment">//    {</span>
<a name="l00570"></a>00570 <span class="comment">//      libMesh::out &lt;&lt; &quot; &quot; &lt;&lt; (*training_parameters[param])(index);</span>
<a name="l00571"></a>00571 <span class="comment">//    }</span>
<a name="l00572"></a>00572 <span class="comment">//    libMesh::out &lt;&lt; std::endl &lt;&lt; std::endl;</span>
<a name="l00573"></a>00573 <span class="comment">//  }</span>
<a name="l00574"></a>00574 
<a name="l00575"></a>00575   <span class="comment">// Finally, clear and reinitialize vectors to store the RB coefficients</span>
<a name="l00576"></a>00576   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a2204539de9bd3f86bea8bdafbad71ade">training_RB_coeffs</a>.size(); i++)
<a name="l00577"></a>00577   {
<a name="l00578"></a>00578     <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a2204539de9bd3f86bea8bdafbad71ade">training_RB_coeffs</a>[i])
<a name="l00579"></a>00579     {
<a name="l00580"></a>00580       <span class="keyword">delete</span> <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a2204539de9bd3f86bea8bdafbad71ade">training_RB_coeffs</a>[i];
<a name="l00581"></a>00581       <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a2204539de9bd3f86bea8bdafbad71ade">training_RB_coeffs</a>[i] = NULL;
<a name="l00582"></a>00582     }
<a name="l00583"></a>00583   }
<a name="l00584"></a>00584   <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a2204539de9bd3f86bea8bdafbad71ade">training_RB_coeffs</a>.resize(<a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a88ea7d267ff9e995bd6716852e8a6ec9">get_n_basis_functions</a>());
<a name="l00585"></a>00585   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a88ea7d267ff9e995bd6716852e8a6ec9">get_n_basis_functions</a>(); i++)
<a name="l00586"></a>00586   {
<a name="l00587"></a>00587     <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a2204539de9bd3f86bea8bdafbad71ade">training_RB_coeffs</a>[i] = <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;::build</a>().release();
<a name="l00588"></a>00588     <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a2204539de9bd3f86bea8bdafbad71ade">training_RB_coeffs</a>[i]-&gt;init(n_training_samples_in, n_local_training_samples, <span class="keyword">false</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">libMeshEnums::PARALLEL</a>);
<a name="l00589"></a>00589   }
<a name="l00590"></a>00590 
<a name="l00591"></a>00591   <a class="code" href="classlibMesh_1_1RBBase.php#acd3759e618b59d145fbc4d8668aa2564">training_parameters_initialized</a> = <span class="keyword">true</span>;
<a name="l00592"></a>00592 }
<a name="l00593"></a>00593 
<a name="l00594"></a><a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a94ec0c361ec67da56ccb53128ce76d48">00594</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a94ec0c361ec67da56ccb53128ce76d48">QNTransientSCMSystem::write_offline_data_to_files</a>(<span class="keyword">const</span> std::string&amp; directory_name)
<a name="l00595"></a>00595 {
<a name="l00596"></a>00596   START_LOG(<span class="stringliteral">&quot;write_offline_data_to_files()&quot;</span>, <span class="stringliteral">&quot;QNTransientSCMSystem&quot;</span>);
<a name="l00597"></a>00597 
<a name="l00598"></a>00598   <a class="code" href="classlibMesh_1_1RBSCMSystem.php#ad30371584074d6efd903cd311576c5f9">Parent::write_offline_data_to_files</a>(directory_name);
<a name="l00599"></a>00599 
<a name="l00600"></a>00600   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> precision_level = 14;
<a name="l00601"></a>00601 
<a name="l00602"></a>00602   <span class="keywordflow">if</span>(<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l00603"></a>00603   {
<a name="l00604"></a>00604     <span class="comment">// Write out C_J_RB_coeffs</span>
<a name="l00605"></a>00605     std::ofstream C_J_RB_coeffs_out;
<a name="l00606"></a>00606     {
<a name="l00607"></a>00607       <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l00608"></a>00608       file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/C_J_RB_coeffs.dat&quot;</span>;
<a name="l00609"></a>00609       C_J_RB_coeffs_out.open(file_name.str().c_str());
<a name="l00610"></a>00610     }
<a name="l00611"></a>00611     <span class="keywordflow">if</span> ( !C_J_RB_coeffs_out.good() )
<a name="l00612"></a>00612     {
<a name="l00613"></a>00613       <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening C_J_RB_coeffs.dat&quot;</span> &lt;&lt; std::endl;
<a name="l00614"></a>00614       libmesh_error();
<a name="l00615"></a>00615     }
<a name="l00616"></a>00616     C_J_RB_coeffs_out.precision(precision_level);
<a name="l00617"></a>00617     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a3a16673187a444a53c6585e89865bda4">C_J_RB_coeffs</a>.size(); i++)
<a name="l00618"></a>00618     {
<a name="l00619"></a>00619       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;<a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a88ea7d267ff9e995bd6716852e8a6ec9">get_n_basis_functions</a>(); j++)
<a name="l00620"></a>00620       {
<a name="l00621"></a>00621         C_J_RB_coeffs_out &lt;&lt; std::scientific &lt;&lt; <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a3a16673187a444a53c6585e89865bda4">C_J_RB_coeffs</a>[i][j] &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l00622"></a>00622       }
<a name="l00623"></a>00623     }
<a name="l00624"></a>00624     C_J_RB_coeffs_out &lt;&lt; std::endl;
<a name="l00625"></a>00625     C_J_RB_coeffs_out.close();
<a name="l00626"></a>00626   }
<a name="l00627"></a>00627 
<a name="l00628"></a>00628   STOP_LOG(<span class="stringliteral">&quot;write_offline_data_to_files()&quot;</span>, <span class="stringliteral">&quot;QNTransientSCMSystem&quot;</span>);
<a name="l00629"></a>00629 }
<a name="l00630"></a>00630 
<a name="l00631"></a><a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a0a8375152befbf34ecb9abc91f08f40b">00631</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a0a8375152befbf34ecb9abc91f08f40b">QNTransientSCMSystem::read_offline_data_from_files</a>(<span class="keyword">const</span> std::string&amp; directory_name)
<a name="l00632"></a>00632 {
<a name="l00633"></a>00633   START_LOG(<span class="stringliteral">&quot;read_offline_data_from_files()&quot;</span>, <span class="stringliteral">&quot;QNTransientSCMSystem&quot;</span>);
<a name="l00634"></a>00634 
<a name="l00635"></a>00635   <span class="comment">// Need to make sure we know how many basis functions are in the associated system</span>
<a name="l00636"></a>00636   <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#ab24885744cf843c0bc3056d4ba43c8ac">resize_to_new_n_bfs</a>();
<a name="l00637"></a>00637   <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a88ea7d267ff9e995bd6716852e8a6ec9">get_n_basis_functions</a>() == 0)
<a name="l00638"></a>00638   {
<a name="l00639"></a>00639     <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Error: The RBSystem associated to this QNTransientSCMSystem needs to be initialized first.&quot;</span>;
<a name="l00640"></a>00640     libmesh_error();
<a name="l00641"></a>00641   }
<a name="l00642"></a>00642 
<a name="l00643"></a>00643   <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a1fc44cbf71f7e98ba7fad0a3c0236c87">Parent::read_offline_data_from_files</a>(directory_name);
<a name="l00644"></a>00644 
<a name="l00645"></a>00645   <span class="comment">// Read in C_J_RB_coeffs</span>
<a name="l00646"></a>00646   std::ifstream C_J_RB_coeffs_in;
<a name="l00647"></a>00647   {
<a name="l00648"></a>00648     <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l00649"></a>00649     file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/C_J_RB_coeffs.dat&quot;</span>;
<a name="l00650"></a>00650     C_J_RB_coeffs_in.open(file_name.str().c_str());
<a name="l00651"></a>00651   }
<a name="l00652"></a>00652   <span class="keywordflow">if</span> ( !C_J_RB_coeffs_in.good() )
<a name="l00653"></a>00653   {
<a name="l00654"></a>00654     <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening C_J_RB_coeffs.dat&quot;</span> &lt;&lt; std::endl;
<a name="l00655"></a>00655     libmesh_error();
<a name="l00656"></a>00656   }
<a name="l00657"></a>00657   <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a3a16673187a444a53c6585e89865bda4">C_J_RB_coeffs</a>.resize( <a class="code" href="classlibMesh_1_1RBSCMSystem.php#af66df67db4690fe68eb82028ee0fcf24">C_J_stability_vector</a>.size() );
<a name="l00658"></a>00658   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a3a16673187a444a53c6585e89865bda4">C_J_RB_coeffs</a>.size(); i++)
<a name="l00659"></a>00659   {
<a name="l00660"></a>00660     <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a3a16673187a444a53c6585e89865bda4">C_J_RB_coeffs</a>[i].resize(<a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a88ea7d267ff9e995bd6716852e8a6ec9">get_n_basis_functions</a>());
<a name="l00661"></a>00661     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;<a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a88ea7d267ff9e995bd6716852e8a6ec9">get_n_basis_functions</a>(); j++)
<a name="l00662"></a>00662     {
<a name="l00663"></a>00663       C_J_RB_coeffs_in &gt;&gt; <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a3a16673187a444a53c6585e89865bda4">C_J_RB_coeffs</a>[i][j];
<a name="l00664"></a>00664     }
<a name="l00665"></a>00665   }
<a name="l00666"></a>00666   C_J_RB_coeffs_in.close();
<a name="l00667"></a>00667 
<a name="l00668"></a>00668   STOP_LOG(<span class="stringliteral">&quot;read_offline_data_from_files()&quot;</span>, <span class="stringliteral">&quot;QNTransientSCMSystem&quot;</span>);
<a name="l00669"></a>00669 }
<a name="l00670"></a>00670 
<a name="l00671"></a>00671 } <span class="comment">// namespace libMesh</span>
<a name="l00672"></a>00672 
<a name="l00673"></a>00673 <span class="preprocessor">#endif // LIBMESH_HAVE_SLEPC &amp;&amp; LIBMESH_HAVE_GLPK</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
