<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_eaf30c8ea092d33f79a04353c3899c3f.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_5a0c7151fa56969ceb962f1511f7edee.php">systems</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">qn_transient_scm_system.h</div>  </div>
</div>
<div class="contents">
<a href="qn__transient__scm__system_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// rbOOmit: An implementation of the Certified Reduced Basis method.</span>
<a name="l00002"></a>00002 <span class="comment">// Copyright (C) 2009, 2010 David J. Knezevic</span>
<a name="l00003"></a>00003 
<a name="l00004"></a>00004 <span class="comment">// This file is part of rbOOmit.</span>
<a name="l00005"></a>00005 
<a name="l00006"></a>00006 <span class="comment">// rbOOmit is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// rbOOmit is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="preprocessor">#ifndef __qn_transient_scm_system_h__</span>
<a name="l00021"></a>00021 <span class="preprocessor"></span><span class="preprocessor">#define __qn_transient_scm_system_h__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span>
<a name="l00023"></a>00023 <span class="comment">// Configuration data</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>&quot;</span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// This class derives from RBSCMSystem, which requires SLEPC</span>
<a name="l00027"></a>00027 <span class="preprocessor">#if defined(LIBMESH_HAVE_SLEPC) &amp;&amp; (LIBMESH_HAVE_GLPK)</span>
<a name="l00028"></a>00028 <span class="preprocessor"></span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="rb__scm__system_8h.php">rb_scm_system.h</a>&quot;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="keyword">namespace </span>libMesh
<a name="l00032"></a>00032 {
<a name="l00033"></a>00033 
<a name="l00044"></a>00044 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00045"></a>00045 <span class="comment">// QNTransientSCMSystem class definition</span>
<a name="l00046"></a>00046 
<a name="l00047"></a><a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php">00047</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php">QNTransientSCMSystem</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1RBSCMSystem.php">RBSCMSystem</a>
<a name="l00048"></a>00048 {
<a name="l00049"></a>00049 <span class="keyword">public</span>:
<a name="l00050"></a>00050 
<a name="l00055"></a>00055   <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a7ad95d02c6e1d46f05aef47f02a8ab93">QNTransientSCMSystem</a> (<a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00056"></a>00056                         <span class="keyword">const</span> std::string&amp; <a class="code" href="classlibMesh_1_1System.php#af80f6b2e508821ebd9c8fcb78d443f18">name</a>,
<a name="l00057"></a>00057                         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#aee5caacb487b070842733f1c84b9a2fd">number</a>);
<a name="l00058"></a>00058 
<a name="l00062"></a>00062   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a06bf5f4dc3247e7c69e5b20524c8b646">~QNTransientSCMSystem</a> ();
<a name="l00063"></a>00063 
<a name="l00067"></a><a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a48a4ac49cc5d16d50597004fc58ca8e3">00067</a>   <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php">QNTransientSCMSystem</a> <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a48a4ac49cc5d16d50597004fc58ca8e3">sys_type</a>;
<a name="l00068"></a>00068 
<a name="l00072"></a><a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#aff0f794ece4bf3dd08853ccdaa25f06d">00072</a>   <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1RBSCMSystem.php">RBSCMSystem</a> <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#aff0f794ece4bf3dd08853ccdaa25f06d">Parent</a>;
<a name="l00073"></a>00073 
<a name="l00078"></a>00078   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#aa651225664680bcadca315b27fb83bb5">clear</a> ();
<a name="l00079"></a>00079 
<a name="l00085"></a>00085   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#ab24885744cf843c0bc3056d4ba43c8ac">resize_to_new_n_bfs</a>();
<a name="l00086"></a>00086 
<a name="l00091"></a>00091   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#ae9957965d3c040fe444ecf1f38a9907b">resize_SCM_vectors</a> ();
<a name="l00092"></a>00092 
<a name="l00099"></a>00099   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a81855c551eb78f6d01aabbbbdb261767">perform_SCM_greedy</a>();
<a name="l00100"></a>00100 
<a name="l00105"></a>00105   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#ade07e8220b5a523623c95ad03109e8e2">attach_theta_c</a>(<a class="code" href="namespacelibMesh.php#aa62736885c7a9bb67eda65b54ee20107">theta_q_fptr</a> theta_c_in);
<a name="l00106"></a>00106 
<a name="l00110"></a>00110   <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#af2ebfa615af4ff74f41a2fa932e9f68c">eval_theta_c</a>();
<a name="l00111"></a>00111 
<a name="l00117"></a>00117   <span class="keyword">virtual</span> <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a5a77999f9ab006b1bab0288a81adba7d">eval_theta_q_a</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q);
<a name="l00118"></a>00118 
<a name="l00122"></a><a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#ab2f0ad027838c08cb62de3dd6da8c35b">00122</a>   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#ab2f0ad027838c08cb62de3dd6da8c35b">get_Q_a</a>() { <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">Parent::get_Q_a</a>() + <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a88ea7d267ff9e995bd6716852e8a6ec9">get_n_basis_functions</a>(); }
<a name="l00123"></a>00123 
<a name="l00128"></a>00128   std::vector&lt;Number&gt; <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#adf9d3371dedbbac9065f05821d3b4b58">get_training_RB_coeffs</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index);
<a name="l00129"></a>00129 
<a name="l00134"></a>00134   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a5d4f0e95b169dca87aede15c26c9d098">set_training_RB_coeffs</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index, std::vector&lt;Number&gt; coeffs);
<a name="l00135"></a>00135 
<a name="l00139"></a><a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a07e0ef2d5546ee2beb4f5ae4e3d3a7dc">00139</a>   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a07e0ef2d5546ee2beb4f5ae4e3d3a7dc">set_current_RB_coeffs</a>(std::vector&lt;Number&gt; coeffs) { <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a12786f3880f33e4ffd2fd5c786e347db">current_RB_coeffs</a> = coeffs; }
<a name="l00140"></a>00140 
<a name="l00145"></a><a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a797da17429456d51d4ea5e90cd63dda9">00145</a>   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a797da17429456d51d4ea5e90cd63dda9">set_n_basis_functions</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_bfs_in) { this-&gt;<a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a2c79a411a872db6c3cf24f1a57a51c1f">n_bfs</a> = n_bfs_in; }
<a name="l00146"></a><a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a88ea7d267ff9e995bd6716852e8a6ec9">00146</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a88ea7d267ff9e995bd6716852e8a6ec9">get_n_basis_functions</a>()              { <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a2c79a411a872db6c3cf24f1a57a51c1f">n_bfs</a>; }
<a name="l00147"></a>00147 
<a name="l00151"></a><a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a4290cdfe2edd05ae008f4b039df32573">00151</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a4290cdfe2edd05ae008f4b039df32573">get_K</a>() { <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a5af76d22e754265f7a88b9953be8c087">_K</a>; }
<a name="l00152"></a><a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a7519526c1b275b60fce9417df37ac25c">00152</a>   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a7519526c1b275b60fce9417df37ac25c">set_K</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> K) { this-&gt;<a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a5af76d22e754265f7a88b9953be8c087">_K</a> = K; }
<a name="l00153"></a>00153 
<a name="l00157"></a><a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a440ac231a8036e9222052ecf01ffb6d0">00157</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a440ac231a8036e9222052ecf01ffb6d0">get_dt</a>() { <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#abab60a7f9eb736eb17b7d493e754b6ec">dt</a>; }
<a name="l00158"></a><a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a3976812cee1255142c7fe82ce97e58ab">00158</a>   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a3976812cee1255142c7fe82ce97e58ab">set_dt</a>(<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#abab60a7f9eb736eb17b7d493e754b6ec">dt</a>) { this-&gt;dt = <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#abab60a7f9eb736eb17b7d493e754b6ec">dt</a>; }
<a name="l00159"></a>00159 
<a name="l00167"></a><a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a12b8f9243ea6b09d8ea11f579671ec24">00167</a>   <span class="keyword">virtual</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a12b8f9243ea6b09d8ea11f579671ec24">compute_truth_stability_constant</a>() { libmesh_not_implemented(); <span class="keywordflow">return</span> 0.; }
<a name="l00168"></a>00168 
<a name="l00173"></a>00173   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a38dbf6839616b02997921fe9e4306c36">initialize_training_parameters</a>(<span class="keyword">const</span> std::vector&lt;Real&gt;&amp; <a class="code" href="classlibMesh_1_1RBBase.php#aa54633a8a1d87dc76bbce3cec5e80421">mu_min_vector</a>,
<a name="l00174"></a>00174                                               <span class="keyword">const</span> std::vector&lt;Real&gt;&amp; <a class="code" href="classlibMesh_1_1RBBase.php#a908713cda5467ba29a8141ee97d3a49d">mu_max_vector</a>,
<a name="l00175"></a>00175                                               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_param_samples,
<a name="l00176"></a>00176                                               <span class="keyword">const</span> std::vector&lt;bool&gt; log_param_scale,
<a name="l00177"></a>00177                                               <span class="keyword">const</span> <span class="keywordtype">bool</span> deterministic=<span class="keyword">true</span>);
<a name="l00178"></a>00178 
<a name="l00183"></a>00183   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a6a62b451558cce9cc3ed16ae2cc76bb5">load_training_set</a>(std::vector&lt; std::vector&lt;Number&gt; &gt;&amp; new_training_set);
<a name="l00184"></a>00184 
<a name="l00189"></a>00189   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a94ec0c361ec67da56ccb53128ce76d48">write_offline_data_to_files</a>(<span class="keyword">const</span> std::string&amp; directory_name = <span class="stringliteral">&quot;offline_data&quot;</span>);
<a name="l00190"></a>00190 
<a name="l00195"></a>00195   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a0a8375152befbf34ecb9abc91f08f40b">read_offline_data_from_files</a>(<span class="keyword">const</span> std::string&amp; directory_name = <span class="stringliteral">&quot;offline_data&quot;</span>);
<a name="l00196"></a>00196 
<a name="l00197"></a>00197 <span class="keyword">protected</span>:
<a name="l00198"></a>00198 
<a name="l00203"></a>00203   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a975c38891550058063784a203927881f">init_data</a> ();
<a name="l00204"></a>00204 
<a name="l00209"></a>00209   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a8bb31a567fe1d428bd22ede5e10d49c3">add_scaled_symm_Aq</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_a, <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> scalar);
<a name="l00210"></a>00210 
<a name="l00215"></a>00215   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#ab54ac25b83ed03b4f62d0d1bb9d08929">load_training_parameter_locally</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index);
<a name="l00216"></a>00216 
<a name="l00221"></a>00221   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a75570766c94b2bd7894d4d84ef524fd8">load_training_parameter_globally</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index);
<a name="l00222"></a>00222 
<a name="l00227"></a>00227   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a611e2301ed68d973c6a99a16d43aed80">set_current_parameters_from_C_J</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> C_J_index);
<a name="l00228"></a>00228 
<a name="l00233"></a>00233   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a833a3f37b2177dd99b33d4788c5cb377">save_current_parameters</a>();
<a name="l00234"></a>00234 
<a name="l00239"></a>00239   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a9bef97a1ed76bfe53367af9898d33cad">reload_current_parameters</a>();
<a name="l00240"></a>00240 
<a name="l00245"></a><a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a463cd8ae3fb64976ef18d0b4cbf459cb">00245</a>   <span class="keyword">static</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a463cd8ae3fb64976ef18d0b4cbf459cb">round</a>(<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> x)
<a name="l00246"></a>00246   {
<a name="l00247"></a>00247     <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><span class="keywordtype">int</span><span class="keyword">&gt;</span>(x &gt; 0.0 ? x + 0.5 : x - 0.5);
<a name="l00248"></a>00248   }
<a name="l00249"></a>00249 
<a name="l00250"></a>00250   <span class="comment">//----------- PROTECTED DATA MEMBERS -----------//</span>
<a name="l00251"></a>00251 
<a name="l00255"></a><a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a12786f3880f33e4ffd2fd5c786e347db">00255</a>   std::vector&lt;Number&gt; <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a12786f3880f33e4ffd2fd5c786e347db">current_RB_coeffs</a>;
<a name="l00256"></a>00256 
<a name="l00260"></a><a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a3a16673187a444a53c6585e89865bda4">00260</a>   std::vector&lt; std::vector&lt;Number&gt; &gt; <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a3a16673187a444a53c6585e89865bda4">C_J_RB_coeffs</a>;
<a name="l00261"></a>00261 
<a name="l00266"></a><a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a2204539de9bd3f86bea8bdafbad71ade">00266</a>   std::vector&lt; NumericVector&lt;Number&gt;* &gt; <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a2204539de9bd3f86bea8bdafbad71ade">training_RB_coeffs</a>;
<a name="l00267"></a>00267 
<a name="l00272"></a><a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a5a3bd1c494a136c2f783679ec496da9d">00272</a>   std::vector&lt;Number&gt; <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a5a3bd1c494a136c2f783679ec496da9d">saved_RB_coeffs</a>;
<a name="l00273"></a>00273 
<a name="l00277"></a><a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a2c79a411a872db6c3cf24f1a57a51c1f">00277</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a2c79a411a872db6c3cf24f1a57a51c1f">n_bfs</a>;
<a name="l00278"></a>00278 
<a name="l00279"></a>00279 <span class="keyword">private</span>:
<a name="l00280"></a>00280 
<a name="l00281"></a>00281   <span class="comment">//----------- PRIVATE DATA MEMBERS -----------//</span>
<a name="l00282"></a>00282 
<a name="l00283"></a>00283 
<a name="l00287"></a><a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#aebd5d7875e1f29dd2806a99ad208e689">00287</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#aebd5d7875e1f29dd2806a99ad208e689">_k</a>;
<a name="l00288"></a>00288 
<a name="l00292"></a><a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a5af76d22e754265f7a88b9953be8c087">00292</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a5af76d22e754265f7a88b9953be8c087">_K</a>;
<a name="l00293"></a>00293 
<a name="l00297"></a><a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#abab60a7f9eb736eb17b7d493e754b6ec">00297</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#abab60a7f9eb736eb17b7d493e754b6ec">dt</a>;
<a name="l00298"></a>00298 
<a name="l00304"></a><a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a425e8de7389490bedcfa3226b1689116">00304</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a425e8de7389490bedcfa3226b1689116">n_time_samples</a>;
<a name="l00305"></a>00305 
<a name="l00309"></a><a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a012562178846a38a983b1c028f7f48cd">00309</a>   <a class="code" href="namespacelibMesh.php#aa62736885c7a9bb67eda65b54ee20107">theta_q_fptr</a> <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a012562178846a38a983b1c028f7f48cd">theta_c</a>;
<a name="l00310"></a>00310 
<a name="l00311"></a>00311 };
<a name="l00312"></a>00312 
<a name="l00313"></a>00313 } <span class="comment">// namespace libMesh</span>
<a name="l00314"></a>00314 
<a name="l00315"></a>00315 <span class="preprocessor">#endif // LIBMESH_HAVE_SLEPC &amp;&amp; LIBMESH_HAVE_GLPK</span>
<a name="l00316"></a>00316 <span class="preprocessor"></span>
<a name="l00317"></a>00317 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
