<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_c3a49989e40b21e7508f29d2dc962def.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_94af86d0ee7ff5a2af0627e1a0ea6efa.php">systems</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">rb_eim_system.C</div>  </div>
</div>
<div class="contents">
<a href="rb__eim__system_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// rbOOmit: An implementation of the Certified Reduced Basis method.</span>
<a name="l00002"></a>00002 <span class="comment">// Copyright (C) 2009, 2010 David J. Knezevic</span>
<a name="l00003"></a>00003 
<a name="l00004"></a>00004 <span class="comment">// This file is part of rbOOmit.</span>
<a name="l00005"></a>00005 
<a name="l00006"></a>00006 <span class="comment">// rbOOmit is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// rbOOmit is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="comment">// LibMesh includes</span>
<a name="l00021"></a>00021 <span class="preprocessor">#include &quot;<a class="code" href="sparse__matrix_8h.php">sparse_matrix.h</a>&quot;</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &quot;<a class="code" href="numeric__vector_8h.php">numeric_vector.h</a>&quot;</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;<a class="code" href="dense__matrix_8h.php">dense_matrix.h</a>&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="code" href="dense__vector_8h.php">dense_vector.h</a>&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="dof__map_8h.php">dof_map.h</a>&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__logging_8h.php">libmesh_logging.h</a>&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="equation__systems_8h.php">equation_systems.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="parallel_8h.php">parallel.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="fe_8h.php">fe.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="quadrature_8h.php">quadrature.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="utility_8h.php">utility.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="fe__interface_8h.php">fe_interface.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="fe__compute__data_8h.php">fe_compute_data.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="getpot_8h.php">getpot.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &lt;fstream&gt;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &lt;sstream&gt;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;<a class="code" href="o__string__stream_8h.php">o_string_stream.h</a>&quot;</span>
<a name="l00038"></a>00038 <span class="preprocessor">#include &quot;<a class="code" href="gmv__io_8h.php">gmv_io.h</a>&quot;</span>
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 <span class="preprocessor">#include &quot;<a class="code" href="fem__context_8h.php">fem_context.h</a>&quot;</span>
<a name="l00041"></a>00041 <span class="preprocessor">#include &quot;<a class="code" href="rb__eim__system_8h.php">rb_eim_system.h</a>&quot;</span>
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 <span class="keyword">namespace </span>libMesh
<a name="l00044"></a>00044 {
<a name="l00045"></a>00045 
<a name="l00046"></a><a class="code" href="classlibMesh_1_1RBEIMSystem.php#a0d88b29db222d7f31a7038027a246823">00046</a> <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a0d88b29db222d7f31a7038027a246823">RBEIMSystem::RBEIMSystem</a> (<a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00047"></a>00047                           <span class="keyword">const</span> std::string&amp; <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>,
<a name="l00048"></a>00048                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> number)
<a name="l00049"></a>00049   : <a class="code" href="classlibMesh_1_1System.php">Parent</a>(es, name, number),
<a name="l00050"></a>00050     best_fit_type_flag(PROJECTION_BEST_FIT),
<a name="l00051"></a>00051     mesh_function(NULL),
<a name="l00052"></a>00052     performing_extra_greedy_step(false),
<a name="l00053"></a>00053     current_variable_number(0),
<a name="l00054"></a>00054     eval_error_estimate(false)
<a name="l00055"></a>00055 {}
<a name="l00056"></a>00056 
<a name="l00057"></a><a class="code" href="classlibMesh_1_1RBEIMSystem.php#a657429362f0e847d79290452089e3dce">00057</a> <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a657429362f0e847d79290452089e3dce">RBEIMSystem::~RBEIMSystem</a> ()
<a name="l00058"></a>00058 {
<a name="l00059"></a>00059   <span class="keyword">delete</span> <a class="code" href="classlibMesh_1_1RBEIMSystem.php#acc26e4d0d9bce27a33ce4f956304b8c4">mesh_function</a>;
<a name="l00060"></a>00060   <a class="code" href="classlibMesh_1_1RBEIMSystem.php#acc26e4d0d9bce27a33ce4f956304b8c4">mesh_function</a> = NULL;
<a name="l00061"></a>00061 }
<a name="l00062"></a>00062 
<a name="l00063"></a><a class="code" href="classlibMesh_1_1RBEIMSystem.php#a3a12e0ed7f06c4864b00c5b8bd35013c">00063</a> std::string <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a3a12e0ed7f06c4864b00c5b8bd35013c">RBEIMSystem::system_type</a> ()<span class="keyword"> const</span>
<a name="l00064"></a>00064 <span class="keyword"></span>{
<a name="l00065"></a>00065   <span class="keywordflow">return</span> <span class="stringliteral">&quot;RBEIMSystem&quot;</span>;
<a name="l00066"></a>00066 }
<a name="l00067"></a>00067 
<a name="l00068"></a><a class="code" href="classlibMesh_1_1RBEIMSystem.php#a89f5f9965126cd2172b21e96a139d8b0">00068</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a89f5f9965126cd2172b21e96a139d8b0">RBEIMSystem::init_data</a> ()
<a name="l00069"></a>00069 {
<a name="l00070"></a>00070   <span class="comment">// Indicate that we need to compute the RB</span>
<a name="l00071"></a>00071   <span class="comment">// inner product matrix in this case</span>
<a name="l00072"></a>00072   <a class="code" href="classlibMesh_1_1RBSystem.php#a52ba5c957ff8b7f85ae16707df632b67">compute_RB_inner_product</a> = <span class="keyword">true</span>;
<a name="l00073"></a>00073   
<a name="l00074"></a>00074   <span class="comment">// Indicate that we need the training set</span>
<a name="l00075"></a>00075   <span class="comment">// for the Greedy to be the same on all</span>
<a name="l00076"></a>00076   <span class="comment">// processors</span>
<a name="l00077"></a>00077   <a class="code" href="classlibMesh_1_1RBBase.php#a74dbe751421fdf4cc63fba5498fbc5c5">serial_training_set</a> = <span class="keyword">true</span>;
<a name="l00078"></a>00078 
<a name="l00079"></a>00079   <a class="code" href="classlibMesh_1_1RBSystem.php#a5c2eb48dd263d846086cb2ca5b6a88a3">Parent::init_data</a>();
<a name="l00080"></a>00080   
<a name="l00081"></a>00081   <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1System.php#a4cf032eda109fe32a7fcde672ef5726e">n_vars</a>() != <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a48ecfe2c8fc98bf0a17e730e786467bd">get_n_parametrized_functions</a>() )
<a name="l00082"></a>00082   {
<a name="l00083"></a>00083     <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Error: The number of parametrized_functions must match n_vars in RBEIMSystem.&quot;</span>
<a name="l00084"></a>00084                  &lt;&lt; std::endl;
<a name="l00085"></a>00085     libmesh_error();
<a name="l00086"></a>00086   }
<a name="l00087"></a>00087   
<a name="l00088"></a>00088   GetPot infile(<a class="code" href="classlibMesh_1_1RBSystem.php#a3aa3cce2414d86488881e1bbe4adcd00">parameters_filename</a>);
<a name="l00089"></a>00089   
<a name="l00090"></a>00090   std::string best_fit_type_string = infile(<span class="stringliteral">&quot;best_fit_type&quot;</span>,<span class="stringliteral">&quot;projection&quot;</span>);
<a name="l00091"></a>00091   
<a name="l00092"></a>00092   <span class="keywordflow">if</span>(best_fit_type_string == <span class="stringliteral">&quot;projection&quot;</span>)
<a name="l00093"></a>00093   {
<a name="l00094"></a>00094     <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a59e0e07c97341f774dfe93b8ca87c17d">best_fit_type_flag</a> = <a class="code" href="classlibMesh_1_1RBEIMSystem.php#af69284437ee73022900134a07d029d2aa077a557c95c17e5a4546e5e325f5bdab">PROJECTION_BEST_FIT</a>;
<a name="l00095"></a>00095   }
<a name="l00096"></a>00096   <span class="keywordflow">else</span>
<a name="l00097"></a>00097   <span class="keywordflow">if</span>(best_fit_type_string == <span class="stringliteral">&quot;eim&quot;</span>)
<a name="l00098"></a>00098   {
<a name="l00099"></a>00099     <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a59e0e07c97341f774dfe93b8ca87c17d">best_fit_type_flag</a> = <a class="code" href="classlibMesh_1_1RBEIMSystem.php#af69284437ee73022900134a07d029d2aac8315f0606b381d2e4584ded33323e94">EIM_BEST_FIT</a>;
<a name="l00100"></a>00100   }
<a name="l00101"></a>00101   <span class="keywordflow">else</span>
<a name="l00102"></a>00102   {
<a name="l00103"></a>00103     <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Error: invalid best_fit_type in input file&quot;</span> &lt;&lt; std::endl;
<a name="l00104"></a>00104     libmesh_error();
<a name="l00105"></a>00105   }
<a name="l00106"></a>00106   
<a name="l00107"></a>00107   <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; std::endl &lt;&lt; <span class="stringliteral">&quot;RBEIMSystem parameters:&quot;</span> &lt;&lt; std::endl;
<a name="l00108"></a>00108   <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;best fit type: &quot;</span> &lt;&lt; best_fit_type_string &lt;&lt; std::endl;
<a name="l00109"></a>00109   <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;number of parametrized functions: &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a48ecfe2c8fc98bf0a17e730e786467bd">get_n_parametrized_functions</a>() &lt;&lt; std::endl;
<a name="l00110"></a>00110   <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; std::endl;
<a name="l00111"></a>00111 }
<a name="l00112"></a>00112 
<a name="l00113"></a><a class="code" href="classlibMesh_1_1RBEIMSystem.php#a9ffb12f992dfb9ea7693436957460d08">00113</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a9ffb12f992dfb9ea7693436957460d08">RBEIMSystem::initialize_RB_system</a>(<span class="keywordtype">bool</span> online_mode)
<a name="l00114"></a>00114 {
<a name="l00115"></a>00115   <a class="code" href="classlibMesh_1_1RBSystem.php#a5911f7b778db3b2791ca89d4e9820125">Parent::initialize_RB_system</a>(online_mode);
<a name="l00116"></a>00116   
<a name="l00117"></a>00117   <span class="comment">// Resize the data structures relevant to the EIM system</span>
<a name="l00118"></a>00118   <a class="code" href="classlibMesh_1_1RBEIMSystem.php#adb0d071273574e43edca763b079258b6">interpolation_points</a>.clear();
<a name="l00119"></a>00119   <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a0f88e3b126beb2a43560548d6b3954a5">interpolation_points_var</a>.clear();
<a name="l00120"></a>00120   <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a2b51235d643d5709569ed51cd448116a">interpolation_matrix</a>.<a class="code" href="classlibMesh_1_1DenseMatrix.php#ad967ca8d40990ed5cae9944a285a320d">resize</a>(<a class="code" href="classlibMesh_1_1RBSystem.php#ab47d6a963c4f68b5a3d1eea7905257f5">Nmax</a>,<a class="code" href="classlibMesh_1_1RBSystem.php#ab47d6a963c4f68b5a3d1eea7905257f5">Nmax</a>);
<a name="l00121"></a>00121   
<a name="l00122"></a>00122   <span class="comment">// Resize the &quot;extra&quot; row due to the &quot;extra Greedy step&quot;</span>
<a name="l00123"></a>00123   <a class="code" href="classlibMesh_1_1RBEIMSystem.php#ae2030b74d4bab5c59b084ae52816ff12">extra_interpolation_matrix_row</a>.<a class="code" href="classlibMesh_1_1DenseVector.php#a08430ae781094632e8272cbb825d4f44">resize</a>(<a class="code" href="classlibMesh_1_1RBSystem.php#ab47d6a963c4f68b5a3d1eea7905257f5">Nmax</a>);
<a name="l00124"></a>00124   
<a name="l00125"></a>00125   <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBBase.php#a11c4b80a15c0e9ea1d822f5e04545059">initialize_calN_dependent_data</a>)
<a name="l00126"></a>00126   {
<a name="l00127"></a>00127     <span class="comment">// initialize a serial vector that we will use for MeshFunction evaluations</span>
<a name="l00128"></a>00128     <a class="code" href="classlibMesh_1_1RBEIMSystem.php#ab0de301ef87beaca8ad3e97e70105743">serialized_vector</a> = <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;::build</a>();
<a name="l00129"></a>00129     <a class="code" href="classlibMesh_1_1RBEIMSystem.php#ab0de301ef87beaca8ad3e97e70105743">serialized_vector</a>-&gt;init (this-&gt;<a class="code" href="classlibMesh_1_1System.php#a90dbb901f00c14ff18399f4afabcebe5">n_dofs</a>(), <span class="keyword">false</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa333690ccec0379e5dd4ccb60db5ea0c9">SERIAL</a>);
<a name="l00130"></a>00130 
<a name="l00131"></a>00131     <span class="comment">// Initialize the MeshFunction for interpolating the</span>
<a name="l00132"></a>00132     <span class="comment">// solution vector at quadrature points</span>
<a name="l00133"></a>00133     std::vector&lt;unsigned int&gt; vars(<a class="code" href="classlibMesh_1_1System.php#a4cf032eda109fe32a7fcde672ef5726e">n_vars</a>());
<a name="l00134"></a>00134     <a class="code" href="namespacelibMesh_1_1Utility.php#a40269b7cf3ba8157ed6b3c2399e62809">Utility::iota</a>(vars.begin(), vars.end(), 0); <span class="comment">// By default use all variables</span>
<a name="l00135"></a>00135     <a class="code" href="classlibMesh_1_1RBEIMSystem.php#acc26e4d0d9bce27a33ce4f956304b8c4">mesh_function</a> = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1MeshFunction.php">MeshFunction</a>(<a class="code" href="classlibMesh_1_1System.php#ac5ca6b1f3adcfac56982982e90dc905b">get_equation_systems</a>(), *<a class="code" href="classlibMesh_1_1RBEIMSystem.php#ab0de301ef87beaca8ad3e97e70105743">serialized_vector</a>, <a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>(), vars);
<a name="l00136"></a>00136     mesh_function-&gt;init();
<a name="l00137"></a>00137     
<a name="l00138"></a>00138     <span class="comment">// initialize the vector that stores the _current_ basis function,</span>
<a name="l00139"></a>00139     <span class="comment">// i.e. the basis funciton that is interpolated by evaluate_current_affine_function</span>
<a name="l00140"></a>00140     <a class="code" href="classlibMesh_1_1RBEIMSystem.php#af575f6d6a8fea8a3cdc385aba4779766">current_ghosted_bf</a> = <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;::build</a>();
<a name="l00141"></a>00141 <span class="preprocessor">#ifdef LIBMESH_ENABLE_GHOSTED</span>
<a name="l00142"></a>00142 <span class="preprocessor"></span>    <a class="code" href="classlibMesh_1_1RBEIMSystem.php#af575f6d6a8fea8a3cdc385aba4779766">current_ghosted_bf</a>-&gt;init (this-&gt;<a class="code" href="classlibMesh_1_1System.php#a90dbb901f00c14ff18399f4afabcebe5">n_dofs</a>(), this-&gt;<a class="code" href="classlibMesh_1_1System.php#ae3aeb82e65b06789823d41da3c5df7a2">n_local_dofs</a>(),
<a name="l00143"></a>00143                               <a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>().get_send_list(), <span class="keyword">false</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa9f12475bbe90a64ad167ec0b856ca6c1">GHOSTED</a>);
<a name="l00144"></a>00144 <span class="preprocessor">#else</span>
<a name="l00145"></a>00145 <span class="preprocessor"></span>    <a class="code" href="classlibMesh_1_1RBEIMSystem.php#af575f6d6a8fea8a3cdc385aba4779766">current_ghosted_bf</a>-&gt;init (this-&gt;<a class="code" href="classlibMesh_1_1System.php#a90dbb901f00c14ff18399f4afabcebe5">n_dofs</a>(), <span class="keyword">false</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa333690ccec0379e5dd4ccb60db5ea0c9">SERIAL</a>);
<a name="l00146"></a>00146 <span class="preprocessor">#endif</span>
<a name="l00147"></a>00147 <span class="preprocessor"></span>
<a name="l00148"></a>00148     <span class="keywordflow">if</span>(!online_mode)
<a name="l00149"></a>00149     {
<a name="l00150"></a>00150       <span class="comment">// Load up the inner product matrix</span>
<a name="l00151"></a>00151       <span class="comment">// We only need one matrix in this class, so we</span>
<a name="l00152"></a>00152       <span class="comment">// can set matrix to inner_product_matrix here</span>
<a name="l00153"></a>00153       <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a>)
<a name="l00154"></a>00154       {
<a name="l00155"></a>00155         <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#a966e0a6479f33c2518937e7d0f54602f">zero</a>();
<a name="l00156"></a>00156         <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#a401beeed965b80425730050a61de5c21">add</a>(1., *<a class="code" href="classlibMesh_1_1RBSystem.php#a330478ef4e1a158dc7b6f08530e10ff3">inner_product_matrix</a>);
<a name="l00157"></a>00157       }
<a name="l00158"></a>00158       <span class="keywordflow">else</span>
<a name="l00159"></a>00159       {
<a name="l00160"></a>00160         <a class="code" href="classlibMesh_1_1RBSystem.php#a2bde84b5899642d6bb6ba2f6ac4a51f9">assemble_inner_product_matrix</a>(<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>);
<a name="l00161"></a>00161       }
<a name="l00162"></a>00162     }
<a name="l00163"></a>00163 
<a name="l00164"></a>00164   }
<a name="l00165"></a>00165 }
<a name="l00166"></a>00166 
<a name="l00167"></a><a class="code" href="classlibMesh_1_1RBEIMSystem.php#a9d72a25b6a85986018ec297a73bd8f97">00167</a> <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a9d72a25b6a85986018ec297a73bd8f97">RBEIMSystem::evaluate_parametrized_function</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var, <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p)
<a name="l00168"></a>00168 {
<a name="l00169"></a>00169   <span class="keywordflow">if</span>(var &gt;= <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a48ecfe2c8fc98bf0a17e730e786467bd">get_n_parametrized_functions</a>())
<a name="l00170"></a>00170   {
<a name="l00171"></a>00171     <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error: We must have var &lt; get_n_parametrized_functions() in evaluate_parametrized_function.&quot;</span>
<a name="l00172"></a>00172                  &lt;&lt; std::endl;
<a name="l00173"></a>00173     libmesh_error();
<a name="l00174"></a>00174   }
<a name="l00175"></a>00175 
<a name="l00176"></a>00176   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1RBEIMSystem.php#abcf8520a990282f876f26a164c74687f">parametrized_functions</a>[var](p, *<span class="keyword">this</span>);
<a name="l00177"></a>00177 }
<a name="l00178"></a>00178 
<a name="l00179"></a><a class="code" href="classlibMesh_1_1RBEIMSystem.php#a1fe41b9f0c69104eb59220166afb929c">00179</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a1fe41b9f0c69104eb59220166afb929c">RBEIMSystem::get_n_affine_functions</a>()<span class="keyword"> const</span>
<a name="l00180"></a>00180 <span class="keyword"></span>{
<a name="l00181"></a>00181   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1System.php#a4cf032eda109fe32a7fcde672ef5726e">n_vars</a>() * <a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>();
<a name="l00182"></a>00182 }
<a name="l00183"></a>00183 
<a name="l00184"></a><a class="code" href="classlibMesh_1_1RBEIMSystem.php#a3c90ab10e1378d26ea0db2094ad37f17">00184</a> std::vector&lt;Number&gt; <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a3c90ab10e1378d26ea0db2094ad37f17">RBEIMSystem::evaluate_current_affine_function</a>(<a class="code" href="classlibMesh_1_1Elem.php">Elem</a>&amp; element,
<a name="l00185"></a>00185                                                                   <span class="keyword">const</span> std::vector&lt;Point&gt;&amp; qpoints)
<a name="l00186"></a>00186 {
<a name="l00187"></a>00187   START_LOG(<span class="stringliteral">&quot;evaluate_current_affine_function()&quot;</span>, <span class="stringliteral">&quot;RBEIMSystem&quot;</span>);
<a name="l00188"></a>00188 
<a name="l00189"></a>00189   <span class="comment">// Get local coordinates to feed these into compute_data().  </span>
<a name="l00190"></a>00190   <span class="comment">// Note that the fe_type can safely be used from the 0-variable,</span>
<a name="l00191"></a>00191   <span class="comment">// since the inverse mapping is the same for all FEFamilies</span>
<a name="l00192"></a>00192   std::vector&lt;Point&gt; mapped_qpoints;
<a name="l00193"></a>00193   <a class="code" href="classlibMesh_1_1FEInterface.php#aa4cd7cde33c7f4b7f873d2fdad6fb635">FEInterface::inverse_map</a> (<a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">get_mesh</a>().mesh_dimension(), 
<a name="l00194"></a>00194                             <a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>().<a class="code" href="classlibMesh_1_1System.php#ab321ab954fa1284069a647b311ff6d17">variable_type</a>(0),
<a name="l00195"></a>00195                             &amp;element, 
<a name="l00196"></a>00196                             qpoints,
<a name="l00197"></a>00197                             mapped_qpoints);
<a name="l00198"></a>00198 
<a name="l00199"></a>00199   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; fe_type = <a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>().<a class="code" href="classlibMesh_1_1DofMap.php#a0c010bb250d4cd8d65794452f46d141a">variable_type</a>(<a class="code" href="classlibMesh_1_1RBEIMSystem.php#a6d851240aacbb38297f861d98c6487a3">current_variable_number</a>);
<a name="l00200"></a>00200   
<a name="l00201"></a>00201   std::vector&lt;unsigned int&gt; dof_indices_var;
<a name="l00202"></a>00202   <a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>().<a class="code" href="classlibMesh_1_1DofMap.php#a5dac22ba99a9da3563c00b7dfd2f07af">dof_indices</a> (&amp;element, dof_indices_var, <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a6d851240aacbb38297f861d98c6487a3">current_variable_number</a>);
<a name="l00203"></a>00203 
<a name="l00204"></a>00204   std::vector&lt;Number&gt; values(dof_indices_var.size());
<a name="l00205"></a>00205 
<a name="l00206"></a>00206   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp=0; qp&lt;mapped_qpoints.size(); qp++)
<a name="l00207"></a>00207   {
<a name="l00208"></a>00208     <a class="code" href="classlibMesh_1_1FEComputeData.php">FEComputeData</a> data (<a class="code" href="classlibMesh_1_1System.php#ac5ca6b1f3adcfac56982982e90dc905b">get_equation_systems</a>(), mapped_qpoints[qp]);
<a name="l00209"></a>00209     <a class="code" href="classlibMesh_1_1FEInterface.php#a73ff41d651b8412ccca780cf0b8c356d">FEInterface::compute_data</a> (<a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">get_mesh</a>().mesh_dimension(), fe_type, &amp;element, data);
<a name="l00210"></a>00210 
<a name="l00211"></a>00211     values[qp] = 0.;
<a name="l00212"></a>00212     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;dof_indices_var.size(); i++)
<a name="l00213"></a>00213       values[qp] += (*<a class="code" href="classlibMesh_1_1RBEIMSystem.php#af575f6d6a8fea8a3cdc385aba4779766">current_ghosted_bf</a>)(dof_indices_var[i]) * data.<a class="code" href="classlibMesh_1_1FEComputeData.php#abcadcf6c89c2ca5258e5c1f53c321bfe">shape</a>[i];
<a name="l00214"></a>00214   }
<a name="l00215"></a>00215 
<a name="l00216"></a>00216   STOP_LOG(<span class="stringliteral">&quot;evaluate_current_affine_function()&quot;</span>, <span class="stringliteral">&quot;RBEIMSystem&quot;</span>);
<a name="l00217"></a>00217 
<a name="l00218"></a>00218   <span class="keywordflow">return</span> values;
<a name="l00219"></a>00219 }
<a name="l00220"></a>00220 
<a name="l00221"></a><a class="code" href="classlibMesh_1_1RBEIMSystem.php#a46b55bb7ba6c15b09d42c0b3e6feacda">00221</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a46b55bb7ba6c15b09d42c0b3e6feacda">RBEIMSystem::cache_ghosted_basis_function</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> function_index)
<a name="l00222"></a>00222 {
<a name="l00223"></a>00223   START_LOG(<span class="stringliteral">&quot;cache_ghosted_basis_function()&quot;</span>, <span class="stringliteral">&quot;RBEIMSystem&quot;</span>);
<a name="l00224"></a>00224 
<a name="l00225"></a>00225   <span class="keywordflow">if</span>(function_index &gt; <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a1fe41b9f0c69104eb59220166afb929c">get_n_affine_functions</a>())
<a name="l00226"></a>00226   {
<a name="l00227"></a>00227     <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Error: index cannot be larger than the number of affine functions in evaluate_affine_function&quot;</span>
<a name="l00228"></a>00228                  &lt;&lt; std::endl;
<a name="l00229"></a>00229     libmesh_error();
<a name="l00230"></a>00230   }
<a name="l00231"></a>00231         
<a name="l00232"></a>00232   <span class="comment">// First determine the basis function index implied by function_index</span>
<a name="l00233"></a>00233   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> bf_index  = function_index/<a class="code" href="classlibMesh_1_1System.php#a4cf032eda109fe32a7fcde672ef5726e">n_vars</a>();
<a name="l00234"></a>00234   
<a name="l00235"></a>00235   <span class="comment">// and create a ghosted version of the appropriate basis function</span>
<a name="l00236"></a>00236   <a class="code" href="classlibMesh_1_1RBSystem.php#abfe6d67ed23243d225f12747f355f105">basis_functions</a>[bf_index]-&gt;localize
<a name="l00237"></a>00237     (*<a class="code" href="classlibMesh_1_1RBEIMSystem.php#af575f6d6a8fea8a3cdc385aba4779766">current_ghosted_bf</a>, this-&gt;<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>().get_send_list());
<a name="l00238"></a>00238     
<a name="l00239"></a>00239   <span class="comment">// Finally, store the index of the variable number that we will be considering</span>
<a name="l00240"></a>00240   <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a6d851240aacbb38297f861d98c6487a3">current_variable_number</a> = function_index % <a class="code" href="classlibMesh_1_1System.php#a4cf032eda109fe32a7fcde672ef5726e">n_vars</a>();
<a name="l00241"></a>00241   
<a name="l00242"></a>00242   STOP_LOG(<span class="stringliteral">&quot;cache_ghosted_basis_function()&quot;</span>, <span class="stringliteral">&quot;RBEIMSystem&quot;</span>);
<a name="l00243"></a>00243 }
<a name="l00244"></a>00244 
<a name="l00245"></a><a class="code" href="classlibMesh_1_1RBEIMSystem.php#a46cea2966644f4c6dc0c812e1e8e59ed">00245</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a46cea2966644f4c6dc0c812e1e8e59ed">RBEIMSystem::RB_solve</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N)
<a name="l00246"></a>00246 {
<a name="l00247"></a>00247   START_LOG(<span class="stringliteral">&quot;RB_solve()&quot;</span>, <span class="stringliteral">&quot;RBEIMSystem&quot;</span>);
<a name="l00248"></a>00248 
<a name="l00249"></a>00249   <span class="keywordflow">if</span>(N &gt; <a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>())
<a name="l00250"></a>00250   {
<a name="l00251"></a>00251     <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: N cannot be larger than the number &quot;</span>
<a name="l00252"></a>00252                  &lt;&lt; <span class="stringliteral">&quot;of basis functions in RB_solve&quot;</span> &lt;&lt; std::endl;
<a name="l00253"></a>00253     libmesh_error();
<a name="l00254"></a>00254   }
<a name="l00255"></a>00255   <span class="keywordflow">if</span>(N==0)
<a name="l00256"></a>00256   {
<a name="l00257"></a>00257     <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: N must be greater than 0 in RB_solve&quot;</span> &lt;&lt; std::endl;
<a name="l00258"></a>00258     libmesh_error();
<a name="l00259"></a>00259   }
<a name="l00260"></a>00260 
<a name="l00261"></a>00261   <span class="comment">// Get the rhs by sampling parametrized_function</span>
<a name="l00262"></a>00262   <span class="comment">// at the first N interpolation_points</span>
<a name="l00263"></a>00263   <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> EIM_rhs(N);
<a name="l00264"></a>00264   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;N; i++)
<a name="l00265"></a>00265   {
<a name="l00266"></a>00266     EIM_rhs(i) = <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a9d72a25b6a85986018ec297a73bd8f97">evaluate_parametrized_function</a>(<a class="code" href="classlibMesh_1_1RBEIMSystem.php#a0f88e3b126beb2a43560548d6b3954a5">interpolation_points_var</a>[i], <a class="code" href="classlibMesh_1_1RBEIMSystem.php#adb0d071273574e43edca763b079258b6">interpolation_points</a>[i]);
<a name="l00267"></a>00267   }
<a name="l00268"></a>00268   
<a name="l00269"></a>00269   
<a name="l00270"></a>00270 
<a name="l00271"></a>00271   <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Number&gt;</a> interpolation_matrix_N;
<a name="l00272"></a>00272   <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a2b51235d643d5709569ed51cd448116a">interpolation_matrix</a>.<a class="code" href="classlibMesh_1_1DenseMatrix.php#abf62d6b34b155876279d8db1564a6e14">get_principal_submatrix</a>(N, interpolation_matrix_N);
<a name="l00273"></a>00273   
<a name="l00274"></a>00274   interpolation_matrix_N.<a class="code" href="classlibMesh_1_1DenseMatrix.php#a878b9bf0a49000c70acecd55fdcf8d74">lu_solve</a>(EIM_rhs, <a class="code" href="classlibMesh_1_1RBSystem.php#a201af52facfa4da38bc636ee2cf41c67">RB_solution</a>);
<a name="l00275"></a>00275 
<a name="l00276"></a>00276   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> error_estimate = -1.;
<a name="l00277"></a>00277   <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBEIMSystem.php#a49536f1b30de5b44b86f2361f52dd925">eval_error_estimate</a>)
<a name="l00278"></a>00278   {
<a name="l00279"></a>00279     <span class="comment">// Compute the a posteriori error bound</span>
<a name="l00280"></a>00280     <span class="comment">// First, sample the parametrized function at x_{N+1}</span>
<a name="l00281"></a>00281     <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> g_at_next_x;
<a name="l00282"></a>00282     <span class="keywordflow">if</span>(N == <a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>())
<a name="l00283"></a>00283       g_at_next_x = <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a9d72a25b6a85986018ec297a73bd8f97">evaluate_parametrized_function</a>(<a class="code" href="classlibMesh_1_1RBEIMSystem.php#a381f17c720b57759259c185a1f88d6f3">extra_interpolation_point_var</a>, <a class="code" href="classlibMesh_1_1RBEIMSystem.php#afdf0d637dac9e3d4268b878bfcca4982">extra_interpolation_point</a>);
<a name="l00284"></a>00284     <span class="keywordflow">else</span>
<a name="l00285"></a>00285       g_at_next_x = <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a9d72a25b6a85986018ec297a73bd8f97">evaluate_parametrized_function</a>(<a class="code" href="classlibMesh_1_1RBEIMSystem.php#a0f88e3b126beb2a43560548d6b3954a5">interpolation_points_var</a>[N], <a class="code" href="classlibMesh_1_1RBEIMSystem.php#adb0d071273574e43edca763b079258b6">interpolation_points</a>[N]);
<a name="l00286"></a>00286 
<a name="l00287"></a>00287     <span class="comment">// Next, evaluate the EIM approximation at x_{N+1}</span>
<a name="l00288"></a>00288     <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> EIM_approx_at_next_x = 0.;
<a name="l00289"></a>00289     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;N; j++)
<a name="l00290"></a>00290       <span class="keywordflow">if</span>(N == <a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>())
<a name="l00291"></a>00291         EIM_approx_at_next_x += <a class="code" href="classlibMesh_1_1RBSystem.php#a201af52facfa4da38bc636ee2cf41c67">RB_solution</a>(j) * <a class="code" href="classlibMesh_1_1RBEIMSystem.php#ae2030b74d4bab5c59b084ae52816ff12">extra_interpolation_matrix_row</a>(j);
<a name="l00292"></a>00292       <span class="keywordflow">else</span>
<a name="l00293"></a>00293         EIM_approx_at_next_x += <a class="code" href="classlibMesh_1_1RBSystem.php#a201af52facfa4da38bc636ee2cf41c67">RB_solution</a>(j) * <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a2b51235d643d5709569ed51cd448116a">interpolation_matrix</a>(N,j);
<a name="l00294"></a>00294       
<a name="l00295"></a>00295     error_estimate = std::abs(g_at_next_x - EIM_approx_at_next_x);
<a name="l00296"></a>00296   }
<a name="l00297"></a>00297   
<a name="l00298"></a>00298   STOP_LOG(<span class="stringliteral">&quot;RB_solve()&quot;</span>, <span class="stringliteral">&quot;RBEIMSystem&quot;</span>);
<a name="l00299"></a>00299   
<a name="l00300"></a>00300   <span class="keywordflow">return</span> error_estimate;
<a name="l00301"></a>00301 }
<a name="l00302"></a>00302 
<a name="l00303"></a><a class="code" href="classlibMesh_1_1RBEIMSystem.php#a6a2875a3fd602602fe8b39ba159e64f1">00303</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a46cea2966644f4c6dc0c812e1e8e59ed">RBEIMSystem::RB_solve</a>(<a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a>&amp; EIM_rhs)
<a name="l00304"></a>00304 {
<a name="l00305"></a>00305   START_LOG(<span class="stringliteral">&quot;RB_solve()&quot;</span>, <span class="stringliteral">&quot;RBEIMSystem&quot;</span>);
<a name="l00306"></a>00306   
<a name="l00307"></a>00307   <span class="keywordflow">if</span>(EIM_rhs.<a class="code" href="classlibMesh_1_1DenseVector.php#ab124ecf2f46ee43b167f093b05d81fdb">size</a>() &gt; <a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>())
<a name="l00308"></a>00308   {
<a name="l00309"></a>00309     <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: N cannot be larger than the number &quot;</span>
<a name="l00310"></a>00310                  &lt;&lt; <span class="stringliteral">&quot;of basis functions in RB_solve&quot;</span> &lt;&lt; std::endl;
<a name="l00311"></a>00311     libmesh_error();
<a name="l00312"></a>00312   }
<a name="l00313"></a>00313   <span class="keywordflow">if</span>(EIM_rhs.<a class="code" href="classlibMesh_1_1DenseVector.php#ab124ecf2f46ee43b167f093b05d81fdb">size</a>()==0)
<a name="l00314"></a>00314   {
<a name="l00315"></a>00315     <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: N must be greater than 0 in RB_solve&quot;</span> &lt;&lt; std::endl;
<a name="l00316"></a>00316     libmesh_error();
<a name="l00317"></a>00317   }
<a name="l00318"></a>00318   
<a name="l00319"></a>00319   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N = EIM_rhs.<a class="code" href="classlibMesh_1_1DenseVector.php#ab124ecf2f46ee43b167f093b05d81fdb">size</a>();
<a name="l00320"></a>00320   <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Number&gt;</a> interpolation_matrix_N;
<a name="l00321"></a>00321   <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a2b51235d643d5709569ed51cd448116a">interpolation_matrix</a>.<a class="code" href="classlibMesh_1_1DenseMatrix.php#abf62d6b34b155876279d8db1564a6e14">get_principal_submatrix</a>(N, interpolation_matrix_N);
<a name="l00322"></a>00322   
<a name="l00323"></a>00323   interpolation_matrix_N.<a class="code" href="classlibMesh_1_1DenseMatrix.php#a878b9bf0a49000c70acecd55fdcf8d74">lu_solve</a>(EIM_rhs, <a class="code" href="classlibMesh_1_1RBSystem.php#a201af52facfa4da38bc636ee2cf41c67">RB_solution</a>);
<a name="l00324"></a>00324   
<a name="l00325"></a>00325   STOP_LOG(<span class="stringliteral">&quot;RB_solve()&quot;</span>, <span class="stringliteral">&quot;RBEIMSystem&quot;</span>);
<a name="l00326"></a>00326 }
<a name="l00327"></a>00327 
<a name="l00328"></a><a class="code" href="classlibMesh_1_1RBEIMSystem.php#a54ece7bd74376f951c01c33f10c891b6">00328</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a54ece7bd74376f951c01c33f10c891b6">RBEIMSystem::enrich_RB_space</a>()
<a name="l00329"></a>00329 {
<a name="l00330"></a>00330   START_LOG(<span class="stringliteral">&quot;enrich_RB_space()&quot;</span>, <span class="stringliteral">&quot;RBEIMSystem&quot;</span>);
<a name="l00331"></a>00331   
<a name="l00332"></a>00332   <span class="comment">// If we have at least one basis function we need to use</span>
<a name="l00333"></a>00333   <span class="comment">// RB_solve, otherwise just use new_bf as is</span>
<a name="l00334"></a>00334   <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>() &gt; 0)
<a name="l00335"></a>00335   {
<a name="l00336"></a>00336     <span class="comment">// get the right-hand side vector for the EIM approximation</span>
<a name="l00337"></a>00337     <span class="comment">// by sampling the parametrized function (stored in solution)</span>
<a name="l00338"></a>00338     <span class="comment">// at the interpolation points</span>
<a name="l00339"></a>00339     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> RB_size = <a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>();
<a name="l00340"></a>00340     <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> EIM_rhs(RB_size);
<a name="l00341"></a>00341     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;RB_size; i++)
<a name="l00342"></a>00342     {
<a name="l00343"></a>00343       EIM_rhs(i) = (*mesh_function)(<a class="code" href="classlibMesh_1_1RBEIMSystem.php#adb0d071273574e43edca763b079258b6">interpolation_points</a>[i]);
<a name="l00344"></a>00344     }
<a name="l00345"></a>00345   
<a name="l00346"></a>00346     <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a46cea2966644f4c6dc0c812e1e8e59ed">RB_solve</a>(EIM_rhs);
<a name="l00347"></a>00347 
<a name="l00348"></a>00348     <span class="comment">// Load the &quot;EIM residual&quot; into solution by subtracting</span>
<a name="l00349"></a>00349     <span class="comment">// the EIM approximation</span>
<a name="l00350"></a>00350     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>(); i++)
<a name="l00351"></a>00351     {
<a name="l00352"></a>00352       <a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;add(-<a class="code" href="classlibMesh_1_1RBSystem.php#a201af52facfa4da38bc636ee2cf41c67">RB_solution</a>(i), *<a class="code" href="classlibMesh_1_1RBSystem.php#abfe6d67ed23243d225f12747f355f105">basis_functions</a>[i]);
<a name="l00353"></a>00353     }
<a name="l00354"></a>00354   }
<a name="l00355"></a>00355 
<a name="l00356"></a>00356   <span class="comment">// need to update since context uses current_local_solution</span>
<a name="l00357"></a>00357   <a class="code" href="classlibMesh_1_1System.php#ab9d81ac9c1787c43fb87cf13d37741ee">update</a>();
<a name="l00358"></a>00358 
<a name="l00359"></a>00359   <span class="comment">// Find the quadrature point at which solution (which now stores</span>
<a name="l00360"></a>00360   <span class="comment">// the &quot;EIM residual&quot;) has maximum absolute value</span>
<a name="l00361"></a>00361   <span class="comment">// by looping over the mesh</span>
<a name="l00362"></a>00362   <a class="code" href="classlibMesh_1_1Point.php">Point</a> optimal_point;
<a name="l00363"></a>00363   <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> optimal_value = 0.;
<a name="l00364"></a>00364   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> optimal_var;
<a name="l00365"></a>00365   
<a name="l00366"></a>00366   <span class="comment">// Compute truth representation via projection</span>
<a name="l00367"></a>00367   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a> = this-&gt;<a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">get_mesh</a>();
<a name="l00368"></a>00368 
<a name="l00369"></a>00369   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;FEMContext&gt;</a> c = this-&gt;<a class="code" href="classlibMesh_1_1RBSystem.php#aab5505a99e58300d0e4e17b31943f162">build_context</a>();
<a name="l00370"></a>00370   <a class="code" href="classlibMesh_1_1FEMContext.php">FEMContext</a> &amp;context  = libmesh_cast_ref&lt;FEMContext&amp;&gt;(*c);
<a name="l00371"></a>00371 
<a name="l00372"></a>00372   this-&gt;<a class="code" href="classlibMesh_1_1RBEIMSystem.php#ac2cf12446f8194fa22c2b3c9a7b1fca2">init_context</a>(context);
<a name="l00373"></a>00373 
<a name="l00374"></a>00374   <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>       el     = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a99742bad0b034a29ccae8c5a90c6f4aa">active_local_elements_begin</a>();
<a name="l00375"></a>00375   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end_el = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a2e27f54d33f7539c0c06b36adae36cda">active_local_elements_end</a>();
<a name="l00376"></a>00376 
<a name="l00377"></a>00377   <span class="keywordflow">for</span> ( ; el != end_el; ++el)
<a name="l00378"></a>00378   {
<a name="l00379"></a>00379     context.<a class="code" href="classlibMesh_1_1FEMContext.php#a4f3f3300b191500571bf8e05bc0cf38e">pre_fe_reinit</a>(*<span class="keyword">this</span>, *el);
<a name="l00380"></a>00380     context.<a class="code" href="classlibMesh_1_1FEMContext.php#a24f0889875c6cfa85f45e0b1d0986651">elem_fe_reinit</a>();
<a name="l00381"></a>00381       
<a name="l00382"></a>00382     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var=0; var&lt;<a class="code" href="classlibMesh_1_1System.php#a4cf032eda109fe32a7fcde672ef5726e">n_vars</a>(); var++)
<a name="l00383"></a>00383     {
<a name="l00384"></a>00384       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_qpoints = context.<a class="code" href="classlibMesh_1_1FEMContext.php#ae13cf73442456b127e9a209e26dd163e">element_qrule</a>-&gt;<a class="code" href="classlibMesh_1_1QBase.php#ac0395144dc0b41dd27689f303c1eba2b">n_points</a>();
<a name="l00385"></a>00385 
<a name="l00386"></a>00386       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp=0; qp&lt;n_qpoints; qp++)
<a name="l00387"></a>00387       {
<a name="l00388"></a>00388         <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> value = context.<a class="code" href="classlibMesh_1_1FEMContext.php#a15df99c408b61d4d93bc18c5ecbde22c">interior_value</a>(var, qp);
<a name="l00389"></a>00389         
<a name="l00390"></a>00390         <span class="keywordflow">if</span>( std::abs(value) &gt; std::abs(optimal_value) )
<a name="l00391"></a>00391         {
<a name="l00392"></a>00392           optimal_value = value;
<a name="l00393"></a>00393           optimal_point = context.<a class="code" href="classlibMesh_1_1FEMContext.php#ab383f19798c04ded72cff9f031c7e626">element_fe_var</a>[var]-&gt;get_xyz()[qp];
<a name="l00394"></a>00394           optimal_var = var;
<a name="l00395"></a>00395         }
<a name="l00396"></a>00396 
<a name="l00397"></a>00397       }
<a name="l00398"></a>00398     }
<a name="l00399"></a>00399   }
<a name="l00400"></a>00400   
<a name="l00401"></a>00401   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> global_abs_value = std::abs(optimal_value);
<a name="l00402"></a>00402   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_ID_index;
<a name="l00403"></a>00403   <a class="code" href="namespacelibMesh_1_1Parallel.php#a8ff1ccdddae18e342bb192e5000821bf">Parallel::maxloc</a>(global_abs_value, proc_ID_index);
<a name="l00404"></a>00404   
<a name="l00405"></a>00405   <span class="comment">// Broadcast the optimal point from proc_ID_index</span>
<a name="l00406"></a>00406   <span class="comment">// First need to store optimal_point as a vector</span>
<a name="l00407"></a>00407   std::vector&lt;Real&gt; global_optimal_point(3);
<a name="l00408"></a>00408   global_optimal_point[0] = optimal_point(0);
<a name="l00409"></a>00409   global_optimal_point[1] = optimal_point(1);
<a name="l00410"></a>00410   global_optimal_point[2] = optimal_point(2);
<a name="l00411"></a>00411   <a class="code" href="namespacelibMesh_1_1Parallel.php#a0856815f9d1ce56771e340b45ef80e6c">Parallel::broadcast</a>(global_optimal_point, proc_ID_index);
<a name="l00412"></a>00412   optimal_point(0) = global_optimal_point[0];
<a name="l00413"></a>00413   optimal_point(1) = global_optimal_point[1];
<a name="l00414"></a>00414   optimal_point(2) = global_optimal_point[2];
<a name="l00415"></a>00415   <span class="comment">// Also broadcast the corresponding optimal_var and optimal_value</span>
<a name="l00416"></a>00416   <a class="code" href="namespacelibMesh_1_1Parallel.php#a0856815f9d1ce56771e340b45ef80e6c">Parallel::broadcast</a>(optimal_var, proc_ID_index);
<a name="l00417"></a>00417   <a class="code" href="namespacelibMesh_1_1Parallel.php#a0856815f9d1ce56771e340b45ef80e6c">Parallel::broadcast</a>(optimal_value, proc_ID_index);
<a name="l00418"></a>00418 
<a name="l00419"></a>00419   <span class="comment">// Scale the solution</span>
<a name="l00420"></a>00420   <a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;scale(1./optimal_value);
<a name="l00421"></a>00421 
<a name="l00422"></a>00422   <span class="comment">// Store optimal point in interpolation_points</span>
<a name="l00423"></a>00423   <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBEIMSystem.php#abe224818af2634670a90d9dfa2f53686">performing_extra_greedy_step</a>)
<a name="l00424"></a>00424   {
<a name="l00425"></a>00425     <a class="code" href="classlibMesh_1_1RBEIMSystem.php#adb0d071273574e43edca763b079258b6">interpolation_points</a>.push_back(optimal_point);
<a name="l00426"></a>00426     <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a0f88e3b126beb2a43560548d6b3954a5">interpolation_points_var</a>.push_back(optimal_var);
<a name="l00427"></a>00427 
<a name="l00428"></a>00428     <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>* new_bf = <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;::build</a>().release();
<a name="l00429"></a>00429     new_bf-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#aba2b1e60a94162764c07732626a8231b">init</a> (this-&gt;<a class="code" href="classlibMesh_1_1System.php#a90dbb901f00c14ff18399f4afabcebe5">n_dofs</a>(), this-&gt;<a class="code" href="classlibMesh_1_1System.php#ae3aeb82e65b06789823d41da3c5df7a2">n_local_dofs</a>(), <span class="keyword">false</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">libMeshEnums::PARALLEL</a>);
<a name="l00430"></a>00430     *new_bf = *<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>;
<a name="l00431"></a>00431     <a class="code" href="classlibMesh_1_1RBSystem.php#abfe6d67ed23243d225f12747f355f105">basis_functions</a>.push_back( new_bf );
<a name="l00432"></a>00432   }
<a name="l00433"></a>00433   <span class="keywordflow">else</span>
<a name="l00434"></a>00434   {
<a name="l00435"></a>00435     <a class="code" href="classlibMesh_1_1RBEIMSystem.php#afdf0d637dac9e3d4268b878bfcca4982">extra_interpolation_point</a> = optimal_point;
<a name="l00436"></a>00436     <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a381f17c720b57759259c185a1f88d6f3">extra_interpolation_point_var</a> = optimal_var;
<a name="l00437"></a>00437   }
<a name="l00438"></a>00438   
<a name="l00439"></a>00439   STOP_LOG(<span class="stringliteral">&quot;enrich_RB_space()&quot;</span>, <span class="stringliteral">&quot;RBEIMSystem&quot;</span>);
<a name="l00440"></a>00440 }
<a name="l00441"></a>00441 
<a name="l00442"></a><a class="code" href="classlibMesh_1_1RBEIMSystem.php#a9697d17d54f4349389032bcd12b89683">00442</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a9697d17d54f4349389032bcd12b89683">RBEIMSystem::compute_best_fit_error</a>()
<a name="l00443"></a>00443 {
<a name="l00444"></a>00444   START_LOG(<span class="stringliteral">&quot;compute_best_fit_error()&quot;</span>, <span class="stringliteral">&quot;RBEIMSystem&quot;</span>);
<a name="l00445"></a>00445   
<a name="l00446"></a>00446   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> RB_size = <a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>();
<a name="l00447"></a>00447   
<a name="l00448"></a>00448   <span class="comment">// load the parametrized function into the solution vector</span>
<a name="l00449"></a>00449   <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a09bc2cb1397e774b2e792d565ce40a21">truth_solve</a>(-1);
<a name="l00450"></a>00450 
<a name="l00451"></a>00451   <span class="keywordflow">switch</span>(<a class="code" href="classlibMesh_1_1RBEIMSystem.php#a59e0e07c97341f774dfe93b8ca87c17d">best_fit_type_flag</a>)
<a name="l00452"></a>00452   {
<a name="l00453"></a>00453     <span class="keywordflow">case</span>(<a class="code" href="classlibMesh_1_1RBEIMSystem.php#af69284437ee73022900134a07d029d2aa077a557c95c17e5a4546e5e325f5bdab">PROJECTION_BEST_FIT</a>):
<a name="l00454"></a>00454     {
<a name="l00455"></a>00455       <span class="comment">// compute the rhs by performing inner products</span>
<a name="l00456"></a>00456       <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> best_fit_rhs(RB_size);
<a name="l00457"></a>00457       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;RB_size; i++)
<a name="l00458"></a>00458       {
<a name="l00459"></a>00459         <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a>)
<a name="l00460"></a>00460         {
<a name="l00461"></a>00461           <a class="code" href="classlibMesh_1_1RBSystem.php#a330478ef4e1a158dc7b6f08530e10ff3">inner_product_matrix</a>-&gt;vector_mult(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>, *<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>);
<a name="l00462"></a>00462         }
<a name="l00463"></a>00463         <span class="keywordflow">else</span> <span class="comment">// In low memory mode we loaded the inner-product matrix into matrix during initialization</span>
<a name="l00464"></a>00464         {
<a name="l00465"></a>00465           <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#adaccc5857f1a5d5ca264ded0b8bfb986">vector_mult</a>(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>, *<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>);
<a name="l00466"></a>00466         }
<a name="l00467"></a>00467         best_fit_rhs(i) = <a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>-&gt;dot(*<a class="code" href="classlibMesh_1_1RBSystem.php#abfe6d67ed23243d225f12747f355f105">basis_functions</a>[i]);
<a name="l00468"></a>00468       }
<a name="l00469"></a>00469 
<a name="l00470"></a>00470       <span class="comment">// Now compute the best fit by an LU solve</span>
<a name="l00471"></a>00471       <a class="code" href="classlibMesh_1_1RBSystem.php#a201af52facfa4da38bc636ee2cf41c67">RB_solution</a>.<a class="code" href="classlibMesh_1_1DenseVector.php#a08430ae781094632e8272cbb825d4f44">resize</a>(RB_size);
<a name="l00472"></a>00472       <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Number&gt;</a> RB_inner_product_matrix_N(RB_size);
<a name="l00473"></a>00473       <a class="code" href="classlibMesh_1_1RBSystem.php#a5aeb48dc4ed2a429e89bdeffdd1f1564">RB_inner_product_matrix</a>.<a class="code" href="classlibMesh_1_1DenseMatrix.php#abf62d6b34b155876279d8db1564a6e14">get_principal_submatrix</a>(RB_size, RB_inner_product_matrix_N);
<a name="l00474"></a>00474 
<a name="l00475"></a>00475       RB_inner_product_matrix_N.<a class="code" href="classlibMesh_1_1DenseMatrix.php#a878b9bf0a49000c70acecd55fdcf8d74">lu_solve</a>(best_fit_rhs, <a class="code" href="classlibMesh_1_1RBSystem.php#a201af52facfa4da38bc636ee2cf41c67">RB_solution</a>);
<a name="l00476"></a>00476       <span class="keywordflow">break</span>;
<a name="l00477"></a>00477     }
<a name="l00478"></a>00478     <span class="keywordflow">case</span>(<a class="code" href="classlibMesh_1_1RBEIMSystem.php#af69284437ee73022900134a07d029d2aac8315f0606b381d2e4584ded33323e94">EIM_BEST_FIT</a>):
<a name="l00479"></a>00479     {
<a name="l00480"></a>00480       <span class="comment">// Turn off error estimation here, we use the linfty norm instead</span>
<a name="l00481"></a>00481       <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a49536f1b30de5b44b86f2361f52dd925">eval_error_estimate</a> = <span class="keyword">false</span>;
<a name="l00482"></a>00482       <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a46cea2966644f4c6dc0c812e1e8e59ed">RB_solve</a>(RB_size);
<a name="l00483"></a>00483       <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a49536f1b30de5b44b86f2361f52dd925">eval_error_estimate</a> = <span class="keyword">true</span>;
<a name="l00484"></a>00484       <span class="keywordflow">break</span>;
<a name="l00485"></a>00485     }
<a name="l00486"></a>00486     <span class="keywordflow">default</span>:
<a name="l00487"></a>00487     {
<a name="l00488"></a>00488       <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Should not reach here&quot;</span> &lt;&lt; std::endl;
<a name="l00489"></a>00489       libmesh_error();
<a name="l00490"></a>00490     }
<a name="l00491"></a>00491   }
<a name="l00492"></a>00492   
<a name="l00493"></a>00493   <span class="comment">// load the error into solution</span>
<a name="l00494"></a>00494   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>(); i++)
<a name="l00495"></a>00495   {
<a name="l00496"></a>00496     <a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;add(-<a class="code" href="classlibMesh_1_1RBSystem.php#a201af52facfa4da38bc636ee2cf41c67">RB_solution</a>(i), *<a class="code" href="classlibMesh_1_1RBSystem.php#abfe6d67ed23243d225f12747f355f105">basis_functions</a>[i]);
<a name="l00497"></a>00497   }
<a name="l00498"></a>00498 
<a name="l00499"></a>00499   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> best_fit_error = <a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;linfty_norm();
<a name="l00500"></a>00500   
<a name="l00501"></a>00501   STOP_LOG(<span class="stringliteral">&quot;compute_best_fit_error()&quot;</span>, <span class="stringliteral">&quot;RBEIMSystem&quot;</span>);
<a name="l00502"></a>00502   
<a name="l00503"></a>00503   <span class="keywordflow">return</span> best_fit_error;
<a name="l00504"></a>00504 }
<a name="l00505"></a>00505 
<a name="l00506"></a><a class="code" href="classlibMesh_1_1RBEIMSystem.php#a09bc2cb1397e774b2e792d565ce40a21">00506</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a09bc2cb1397e774b2e792d565ce40a21">RBEIMSystem::truth_solve</a>(<span class="keywordtype">int</span> plot_solution)
<a name="l00507"></a>00507 {
<a name="l00508"></a>00508   START_LOG(<span class="stringliteral">&quot;truth_solve()&quot;</span>, <span class="stringliteral">&quot;RBEIMSystem&quot;</span>);
<a name="l00509"></a>00509         
<a name="l00510"></a>00510   <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBBase.php#a11c4b80a15c0e9ea1d822f5e04545059">initialize_calN_dependent_data</a>)
<a name="l00511"></a>00511   {
<a name="l00512"></a>00512     <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error: We must initialize the calN dependent &quot;</span>
<a name="l00513"></a>00513                  &lt;&lt; <span class="stringliteral">&quot;data structures in order to load the truth solution.&quot;</span>
<a name="l00514"></a>00514                  &lt;&lt; std::endl;
<a name="l00515"></a>00515     libmesh_error();
<a name="l00516"></a>00516   }
<a name="l00517"></a>00517   
<a name="l00518"></a>00518 <span class="comment">//  matrix should have been set to inner_product_matrix during initialization</span>
<a name="l00519"></a>00519 <span class="comment">//  if(!low_memory_mode)</span>
<a name="l00520"></a>00520 <span class="comment">//  {</span>
<a name="l00521"></a>00521 <span class="comment">//    matrix-&gt;zero();</span>
<a name="l00522"></a>00522 <span class="comment">//    matrix-&gt;add(1., *inner_product_matrix);</span>
<a name="l00523"></a>00523 <span class="comment">//  }</span>
<a name="l00524"></a>00524 <span class="comment">//  else</span>
<a name="l00525"></a>00525 <span class="comment">//  {</span>
<a name="l00526"></a>00526 <span class="comment">//    assemble_inner_product_matrix(matrix);</span>
<a name="l00527"></a>00527 <span class="comment">//  }</span>
<a name="l00528"></a>00528 
<a name="l00529"></a>00529   <span class="comment">// Compute truth representation via projection</span>
<a name="l00530"></a>00530   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a> = this-&gt;<a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">get_mesh</a>();
<a name="l00531"></a>00531 
<a name="l00532"></a>00532   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;FEMContext&gt;</a> c = this-&gt;<a class="code" href="classlibMesh_1_1RBSystem.php#aab5505a99e58300d0e4e17b31943f162">build_context</a>();
<a name="l00533"></a>00533   <a class="code" href="classlibMesh_1_1FEMContext.php">FEMContext</a> &amp;context  = libmesh_cast_ref&lt;FEMContext&amp;&gt;(*c);
<a name="l00534"></a>00534 
<a name="l00535"></a>00535   this-&gt;<a class="code" href="classlibMesh_1_1RBEIMSystem.php#ac2cf12446f8194fa22c2b3c9a7b1fca2">init_context</a>(context);
<a name="l00536"></a>00536   
<a name="l00537"></a>00537   <a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a85b3d4a53413e3745e6ecf1c8b96ca65">zero</a>();
<a name="l00538"></a>00538 
<a name="l00539"></a>00539   <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>       el     = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a99742bad0b034a29ccae8c5a90c6f4aa">active_local_elements_begin</a>();
<a name="l00540"></a>00540   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end_el = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a2e27f54d33f7539c0c06b36adae36cda">active_local_elements_end</a>();
<a name="l00541"></a>00541 
<a name="l00542"></a>00542   <span class="keywordflow">for</span> ( ; el != end_el; ++el)
<a name="l00543"></a>00543   {
<a name="l00544"></a>00544     context.<a class="code" href="classlibMesh_1_1FEMContext.php#a4f3f3300b191500571bf8e05bc0cf38e">pre_fe_reinit</a>(*<span class="keyword">this</span>, *el);
<a name="l00545"></a>00545     context.<a class="code" href="classlibMesh_1_1FEMContext.php#a24f0889875c6cfa85f45e0b1d0986651">elem_fe_reinit</a>();
<a name="l00546"></a>00546       
<a name="l00547"></a>00547     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var=0; var&lt;<a class="code" href="classlibMesh_1_1System.php#a4cf032eda109fe32a7fcde672ef5726e">n_vars</a>(); var++)
<a name="l00548"></a>00548     {
<a name="l00549"></a>00549       <span class="keyword">const</span> std::vector&lt;Real&gt; &amp;JxW =
<a name="l00550"></a>00550         context.<a class="code" href="classlibMesh_1_1FEMContext.php#ab383f19798c04ded72cff9f031c7e626">element_fe_var</a>[var]-&gt;get_JxW();
<a name="l00551"></a>00551 
<a name="l00552"></a>00552       <span class="keyword">const</span> std::vector&lt;std::vector&lt;Real&gt; &gt;&amp; phi =
<a name="l00553"></a>00553         context.<a class="code" href="classlibMesh_1_1FEMContext.php#ab383f19798c04ded72cff9f031c7e626">element_fe_var</a>[var]-&gt;get_phi();
<a name="l00554"></a>00554 
<a name="l00555"></a>00555       <span class="keyword">const</span> std::vector&lt;Point&gt; &amp;xyz =
<a name="l00556"></a>00556         context.<a class="code" href="classlibMesh_1_1FEMContext.php#ab383f19798c04ded72cff9f031c7e626">element_fe_var</a>[var]-&gt;get_xyz();
<a name="l00557"></a>00557 
<a name="l00558"></a>00558       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_qpoints = context.<a class="code" href="classlibMesh_1_1FEMContext.php#ae13cf73442456b127e9a209e26dd163e">element_qrule</a>-&gt;<a class="code" href="classlibMesh_1_1QBase.php#ac0395144dc0b41dd27689f303c1eba2b">n_points</a>();
<a name="l00559"></a>00559       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_var_dofs = context.<a class="code" href="classlibMesh_1_1DiffContext.php#a7d609caec46d2087753fffc144da7264">dof_indices_var</a>[var].size();
<a name="l00560"></a>00560 
<a name="l00561"></a>00561       <a class="code" href="classlibMesh_1_1DenseSubVector.php">DenseSubVector&lt;Number&gt;</a>&amp; subresidual_var = *context.<a class="code" href="classlibMesh_1_1DiffContext.php#af7c90c20ab2a20247cb4f194a8f92604">elem_subresiduals</a>[var];
<a name="l00562"></a>00562 
<a name="l00563"></a>00563       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp=0; qp&lt;n_qpoints; qp++)
<a name="l00564"></a>00564         <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != n_var_dofs; i++)
<a name="l00565"></a>00565           subresidual_var(i) += JxW[qp] * <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a9d72a25b6a85986018ec297a73bd8f97">evaluate_parametrized_function</a>(var, xyz[qp]) * phi[i][qp];
<a name="l00566"></a>00566     }
<a name="l00567"></a>00567 
<a name="l00568"></a>00568     <span class="comment">// Apply constraints, e.g. periodic constraints</span>
<a name="l00569"></a>00569     this-&gt;<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>().<a class="code" href="classlibMesh_1_1DofMap.php#a29aba1bf008a1de4dd81a9a1b6f5ff41">constrain_element_vector</a>(context.<a class="code" href="classlibMesh_1_1DiffContext.php#ae8ee506ab5362a9fa6cb5c012d7c72b2">elem_residual</a>, context.<a class="code" href="classlibMesh_1_1DiffContext.php#a66eb0ba364350d256552d872f30c9b34">dof_indices</a>);
<a name="l00570"></a>00570 
<a name="l00571"></a>00571     <span class="comment">// Add element vector to global vector</span>
<a name="l00572"></a>00572     <a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#adbbff7081d24abefefad1497882b03ab">add_vector</a>(context.<a class="code" href="classlibMesh_1_1DiffContext.php#ae8ee506ab5362a9fa6cb5c012d7c72b2">elem_residual</a>, context.<a class="code" href="classlibMesh_1_1DiffContext.php#a66eb0ba364350d256552d872f30c9b34">dof_indices</a>);
<a name="l00573"></a>00573   }
<a name="l00574"></a>00574   
<a name="l00575"></a>00575   <span class="comment">// Solve to find the best fit, then solution stores the truth representation</span>
<a name="l00576"></a>00576   <span class="comment">// of the function to be approximated</span>
<a name="l00577"></a>00577   <a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#af1de21a76860785bb1992280eb72b0db">solve</a>();
<a name="l00578"></a>00578   <a class="code" href="classlibMesh_1_1System.php#ab9d81ac9c1787c43fb87cf13d37741ee">update</a>(); <span class="comment">// put the solution into current_local_solution as well in case we want to plot it</span>
<a name="l00579"></a>00579   <a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;localize(*<a class="code" href="classlibMesh_1_1RBEIMSystem.php#ab0de301ef87beaca8ad3e97e70105743">serialized_vector</a>);
<a name="l00580"></a>00580   
<a name="l00581"></a>00581   <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBSystem.php#a61f47d68b0df487674a9001d13d77c88">reuse_preconditioner</a>)
<a name="l00582"></a>00582   {
<a name="l00583"></a>00583     <span class="comment">// After we&#39;ve done a solve we can now reuse the preconditioner</span>
<a name="l00584"></a>00584     <span class="comment">// because the matrix is not changing</span>
<a name="l00585"></a>00585     <a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a7cc68891fa9f44ded49b9b84c057cb32">linear_solver</a>-&gt;same_preconditioner = <span class="keyword">true</span>;
<a name="l00586"></a>00586   }
<a name="l00587"></a>00587   
<a name="l00588"></a>00588   <span class="comment">// Make sure we didn&#39;t max out the number of iterations</span>
<a name="l00589"></a>00589   <span class="keywordflow">if</span>( (this-&gt;<a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#af712dbf0e285c5ff4cc346daef05423c">n_linear_iterations</a>() &gt;=
<a name="l00590"></a>00590        this-&gt;<a class="code" href="classlibMesh_1_1System.php#ac5ca6b1f3adcfac56982982e90dc905b">get_equation_systems</a>().parameters.get&lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&gt;(<span class="stringliteral">&quot;linear solver maximum iterations&quot;</span>)) &amp;&amp;
<a name="l00591"></a>00591       (this-&gt;final_linear_residual() &gt;
<a name="l00592"></a>00592        this-&gt;<a class="code" href="classlibMesh_1_1System.php#ac5ca6b1f3adcfac56982982e90dc905b">get_equation_systems</a>().<a class="code" href="classlibMesh_1_1EquationSystems.php#a7c02be232f564967ca0804a7824adb53">parameters</a>.<a class="code" href="classlibMesh_1_1Parameters.php#ac7fa2054ee32db2c3979d48bd2103f20">get</a>&lt;<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>&gt;(<span class="stringliteral">&quot;linear solver tolerance&quot;</span>)) )
<a name="l00593"></a>00593   {
<a name="l00594"></a>00594       <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Warning: Linear solver may not have converged! Final linear residual = &quot;</span>
<a name="l00595"></a>00595                    &lt;&lt; this-&gt;<a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a86b5e2954d2a2e43014bcda8810239ac">final_linear_residual</a>() &lt;&lt; <span class="stringliteral">&quot;, number of iterations = &quot;</span>
<a name="l00596"></a>00596                    &lt;&lt; this-&gt;<a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#af712dbf0e285c5ff4cc346daef05423c">n_linear_iterations</a>() &lt;&lt; std::endl &lt;&lt; std::endl;
<a name="l00597"></a>00597 <span class="comment">//     libmesh_error();</span>
<a name="l00598"></a>00598   }
<a name="l00599"></a>00599 
<a name="l00600"></a>00600   <span class="keywordflow">if</span>(plot_solution &gt; 0)
<a name="l00601"></a>00601   {
<a name="l00602"></a>00602     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; mesh = <a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">get_mesh</a>();
<a name="l00603"></a>00603     <a class="code" href="classlibMesh_1_1GMVIO.php">GMVIO</a>(mesh).<a class="code" href="classlibMesh_1_1MeshOutput.php#a935598198649f4b831cd341ce91b3ccb">write_equation_systems</a> (<span class="stringliteral">&quot;truth.gmv&quot;</span>,
<a name="l00604"></a>00604                                         this-&gt;<a class="code" href="classlibMesh_1_1System.php#ac5ca6b1f3adcfac56982982e90dc905b">get_equation_systems</a>());
<a name="l00605"></a>00605   }
<a name="l00606"></a>00606   
<a name="l00607"></a>00607   STOP_LOG(<span class="stringliteral">&quot;truth_solve()&quot;</span>, <span class="stringliteral">&quot;RBEIMSystem&quot;</span>);
<a name="l00608"></a>00608   
<a name="l00609"></a>00609   <span class="keywordflow">return</span> 0.;
<a name="l00610"></a>00610 }
<a name="l00611"></a>00611 
<a name="l00612"></a><a class="code" href="classlibMesh_1_1RBEIMSystem.php#ac2cf12446f8194fa22c2b3c9a7b1fca2">00612</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBEIMSystem.php#ac2cf12446f8194fa22c2b3c9a7b1fca2">RBEIMSystem::init_context</a>(<a class="code" href="classlibMesh_1_1FEMContext.php">FEMContext</a> &amp;c)
<a name="l00613"></a>00613 {
<a name="l00614"></a>00614   <span class="comment">// default implementation of init_context</span>
<a name="l00615"></a>00615   <span class="comment">// for compute_best_fit</span>
<a name="l00616"></a>00616   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var=0; var&lt;<a class="code" href="classlibMesh_1_1System.php#a4cf032eda109fe32a7fcde672ef5726e">n_vars</a>(); var++)
<a name="l00617"></a>00617   {
<a name="l00618"></a>00618     c.<a class="code" href="classlibMesh_1_1FEMContext.php#ab383f19798c04ded72cff9f031c7e626">element_fe_var</a>[var]-&gt;get_JxW();
<a name="l00619"></a>00619     c.<a class="code" href="classlibMesh_1_1FEMContext.php#ab383f19798c04ded72cff9f031c7e626">element_fe_var</a>[var]-&gt;get_phi();
<a name="l00620"></a>00620     c.<a class="code" href="classlibMesh_1_1FEMContext.php#ab383f19798c04ded72cff9f031c7e626">element_fe_var</a>[var]-&gt;get_xyz();
<a name="l00621"></a>00621   }
<a name="l00622"></a>00622 }
<a name="l00623"></a>00623 
<a name="l00624"></a><a class="code" href="classlibMesh_1_1RBEIMSystem.php#a0d994ca1ea93da811b2c7b1fe3f95cb1">00624</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a0d994ca1ea93da811b2c7b1fe3f95cb1">RBEIMSystem::clear_basis_function_dependent_data</a>()
<a name="l00625"></a>00625 {
<a name="l00626"></a>00626   <a class="code" href="classlibMesh_1_1RBSystem.php#ad611f694e8d504268b101ea3266b590f">Parent::clear_basis_function_dependent_data</a>();
<a name="l00627"></a>00627   
<a name="l00628"></a>00628   <a class="code" href="classlibMesh_1_1RBEIMSystem.php#adb0d071273574e43edca763b079258b6">interpolation_points</a>.clear();
<a name="l00629"></a>00629   <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a0f88e3b126beb2a43560548d6b3954a5">interpolation_points_var</a>.clear();
<a name="l00630"></a>00630 }
<a name="l00631"></a>00631 
<a name="l00632"></a><a class="code" href="classlibMesh_1_1RBEIMSystem.php#a9816bd5cd95b053b2cbbffc7b80881ab">00632</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a9816bd5cd95b053b2cbbffc7b80881ab">RBEIMSystem::update_RB_system_matrices</a>()
<a name="l00633"></a>00633 {
<a name="l00634"></a>00634   START_LOG(<span class="stringliteral">&quot;update_RB_system_matrices()&quot;</span>, <span class="stringliteral">&quot;RBEIMSystem&quot;</span>);
<a name="l00635"></a>00635   
<a name="l00636"></a>00636   <a class="code" href="classlibMesh_1_1RBSystem.php#a22351bccb17903c68cfd546412d04f3c">Parent::update_RB_system_matrices</a>();
<a name="l00637"></a>00637 
<a name="l00638"></a>00638   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> RB_size = <a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>();
<a name="l00639"></a>00639   
<a name="l00640"></a>00640   <span class="comment">// update the EIM interpolation matrix</span>
<a name="l00641"></a>00641   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;RB_size; j++)
<a name="l00642"></a>00642   {
<a name="l00643"></a>00643     <span class="comment">// Sample the basis functions at the</span>
<a name="l00644"></a>00644     <span class="comment">// new interpolation point</span>
<a name="l00645"></a>00645     <a class="code" href="classlibMesh_1_1RBSystem.php#abfe6d67ed23243d225f12747f355f105">basis_functions</a>[j]-&gt;localize(*<a class="code" href="classlibMesh_1_1RBEIMSystem.php#ab0de301ef87beaca8ad3e97e70105743">serialized_vector</a>);
<a name="l00646"></a>00646 
<a name="l00647"></a>00647     <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBEIMSystem.php#abe224818af2634670a90d9dfa2f53686">performing_extra_greedy_step</a>)
<a name="l00648"></a>00648     {
<a name="l00649"></a>00649       <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a2b51235d643d5709569ed51cd448116a">interpolation_matrix</a>(RB_size-1,j) = (*mesh_function)(<a class="code" href="classlibMesh_1_1RBEIMSystem.php#adb0d071273574e43edca763b079258b6">interpolation_points</a>[RB_size-1]);
<a name="l00650"></a>00650     }
<a name="l00651"></a>00651     <span class="keywordflow">else</span>
<a name="l00652"></a>00652     {
<a name="l00653"></a>00653       <a class="code" href="classlibMesh_1_1RBEIMSystem.php#ae2030b74d4bab5c59b084ae52816ff12">extra_interpolation_matrix_row</a>(j) = (*mesh_function)(<a class="code" href="classlibMesh_1_1RBEIMSystem.php#afdf0d637dac9e3d4268b878bfcca4982">extra_interpolation_point</a>);
<a name="l00654"></a>00654     }
<a name="l00655"></a>00655   }
<a name="l00656"></a>00656 
<a name="l00657"></a>00657   STOP_LOG(<span class="stringliteral">&quot;update_RB_system_matrices()&quot;</span>, <span class="stringliteral">&quot;RBEIMSystem&quot;</span>);
<a name="l00658"></a>00658 }
<a name="l00659"></a>00659 
<a name="l00660"></a><a class="code" href="classlibMesh_1_1RBEIMSystem.php#aabd12f850f9e826396ec8eeffdb9fbc1">00660</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBEIMSystem.php#aabd12f850f9e826396ec8eeffdb9fbc1">RBEIMSystem::update_system</a>()
<a name="l00661"></a>00661 {
<a name="l00662"></a>00662   <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Updating RB matrices&quot;</span> &lt;&lt; std::endl;
<a name="l00663"></a>00663   <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a9816bd5cd95b053b2cbbffc7b80881ab">update_RB_system_matrices</a>();
<a name="l00664"></a>00664 }
<a name="l00665"></a>00665 
<a name="l00666"></a><a class="code" href="classlibMesh_1_1RBEIMSystem.php#a50914d7bcd2d62551b1961eca497f252">00666</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a50914d7bcd2d62551b1961eca497f252">RBEIMSystem::greedy_termination_test</a>(<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> training_greedy_error, <span class="keywordtype">int</span>)
<a name="l00667"></a>00667 {
<a name="l00668"></a>00668   <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBEIMSystem.php#abe224818af2634670a90d9dfa2f53686">performing_extra_greedy_step</a>)
<a name="l00669"></a>00669   {
<a name="l00670"></a>00670     <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Extra Greedy iteration finished.&quot;</span> &lt;&lt; std::endl;
<a name="l00671"></a>00671     <a class="code" href="classlibMesh_1_1RBEIMSystem.php#abe224818af2634670a90d9dfa2f53686">performing_extra_greedy_step</a> = <span class="keyword">false</span>;
<a name="l00672"></a>00672     <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00673"></a>00673   }
<a name="l00674"></a>00674 
<a name="l00675"></a>00675   <a class="code" href="classlibMesh_1_1RBEIMSystem.php#abe224818af2634670a90d9dfa2f53686">performing_extra_greedy_step</a> = <span class="keyword">false</span>;
<a name="l00676"></a>00676 
<a name="l00677"></a>00677   <span class="keywordflow">if</span>(training_greedy_error &lt; <a class="code" href="classlibMesh_1_1RBSystem.php#a8166ac1af73cc69a154ff5a65ed9e959">get_training_tolerance</a>())
<a name="l00678"></a>00678   {
<a name="l00679"></a>00679     <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Specified error tolerance reached.&quot;</span> &lt;&lt; std::endl
<a name="l00680"></a>00680                  &lt;&lt; <span class="stringliteral">&quot;Perform one more Greedy iteration for error bounds.&quot;</span> &lt;&lt; std::endl;
<a name="l00681"></a>00681     <a class="code" href="classlibMesh_1_1RBEIMSystem.php#abe224818af2634670a90d9dfa2f53686">performing_extra_greedy_step</a> = <span class="keyword">true</span>;
<a name="l00682"></a>00682     <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00683"></a>00683   }
<a name="l00684"></a>00684 
<a name="l00685"></a>00685   <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>() &gt;= this-&gt;<a class="code" href="classlibMesh_1_1RBSystem.php#a5acee637ff70dd65ec54de29241f0627">get_Nmax</a>())
<a name="l00686"></a>00686   {
<a name="l00687"></a>00687     <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Maximum number of basis functions reached: Nmax = &quot;</span>
<a name="l00688"></a>00688               &lt;&lt; <a class="code" href="classlibMesh_1_1RBSystem.php#a5acee637ff70dd65ec54de29241f0627">get_Nmax</a>() &lt;&lt; <span class="stringliteral">&quot;.&quot;</span> &lt;&lt; std::endl
<a name="l00689"></a>00689               &lt;&lt; <span class="stringliteral">&quot;Perform one more Greedy iteration for error bounds.&quot;</span> &lt;&lt; std::endl;
<a name="l00690"></a>00690     <a class="code" href="classlibMesh_1_1RBEIMSystem.php#abe224818af2634670a90d9dfa2f53686">performing_extra_greedy_step</a> = <span class="keyword">true</span>;
<a name="l00691"></a>00691     <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00692"></a>00692   }
<a name="l00693"></a>00693   
<a name="l00694"></a>00694   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00695"></a>00695 }
<a name="l00696"></a>00696 
<a name="l00697"></a><a class="code" href="classlibMesh_1_1RBEIMSystem.php#aeec65e2003f1fc9b2e77b751928f6ddd">00697</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBEIMSystem.php#aeec65e2003f1fc9b2e77b751928f6ddd">RBEIMSystem::write_offline_data_to_files</a>(<span class="keyword">const</span> std::string&amp; directory_name)
<a name="l00698"></a>00698 {
<a name="l00699"></a>00699   START_LOG(<span class="stringliteral">&quot;write_offline_data_to_files()&quot;</span>, <span class="stringliteral">&quot;RBEIMSystem&quot;</span>);
<a name="l00700"></a>00700 
<a name="l00701"></a>00701   <a class="code" href="classlibMesh_1_1RBSystem.php#a9382ee8b327d3e7db7e867d9cfb24fc2">Parent::write_offline_data_to_files</a>(directory_name);
<a name="l00702"></a>00702 
<a name="l00703"></a>00703   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_bfs = <a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>();
<a name="l00704"></a>00704   libmesh_assert( n_bfs &lt;= <a class="code" href="classlibMesh_1_1RBSystem.php#ab47d6a963c4f68b5a3d1eea7905257f5">Nmax</a> );
<a name="l00705"></a>00705 
<a name="l00706"></a>00706   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> precision_level = 14;
<a name="l00707"></a>00707 
<a name="l00708"></a>00708   <span class="keywordflow">if</span>(<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l00709"></a>00709   {
<a name="l00710"></a>00710     <span class="comment">// Next write out the interpolation_matrix</span>
<a name="l00711"></a>00711     std::ofstream interpolation_matrix_out;
<a name="l00712"></a>00712     {
<a name="l00713"></a>00713       <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l00714"></a>00714       file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/interpolation_matrix.dat&quot;</span>;
<a name="l00715"></a>00715       interpolation_matrix_out.open(file_name.str().c_str());
<a name="l00716"></a>00716     }
<a name="l00717"></a>00717     <span class="keywordflow">if</span> ( !interpolation_matrix_out.good() )
<a name="l00718"></a>00718     {
<a name="l00719"></a>00719       <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening interpolation_matrix.dat&quot;</span> &lt;&lt; std::endl;
<a name="l00720"></a>00720       libmesh_error();
<a name="l00721"></a>00721     }
<a name="l00722"></a>00722     interpolation_matrix_out.precision(precision_level);
<a name="l00723"></a>00723     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_bfs; i++)
<a name="l00724"></a>00724     {
<a name="l00725"></a>00725       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;=i; j++)
<a name="l00726"></a>00726       {
<a name="l00727"></a>00727         interpolation_matrix_out &lt;&lt; std::scientific
<a name="l00728"></a>00728           &lt;&lt; <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a2b51235d643d5709569ed51cd448116a">interpolation_matrix</a>(i,j) &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l00729"></a>00729       }
<a name="l00730"></a>00730     }
<a name="l00731"></a>00731     
<a name="l00732"></a>00732     <span class="comment">// Also, write out the &quot;extra&quot; row</span>
<a name="l00733"></a>00733     std::ofstream extra_interpolation_matrix_row_out;
<a name="l00734"></a>00734     {
<a name="l00735"></a>00735       <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l00736"></a>00736       file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/extra_interpolation_matrix_row.dat&quot;</span>;
<a name="l00737"></a>00737       extra_interpolation_matrix_row_out.open(file_name.str().c_str());
<a name="l00738"></a>00738     }
<a name="l00739"></a>00739     <span class="keywordflow">if</span> ( !extra_interpolation_matrix_row_out.good() )
<a name="l00740"></a>00740     {
<a name="l00741"></a>00741       <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening extra_interpolation_matrix_row.dat&quot;</span> &lt;&lt; std::endl;
<a name="l00742"></a>00742       libmesh_error();
<a name="l00743"></a>00743     }
<a name="l00744"></a>00744     extra_interpolation_matrix_row_out.precision(precision_level);
<a name="l00745"></a>00745     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;n_bfs; j++)
<a name="l00746"></a>00746       extra_interpolation_matrix_row_out &lt;&lt; std::scientific
<a name="l00747"></a>00747           &lt;&lt; <a class="code" href="classlibMesh_1_1RBEIMSystem.php#ae2030b74d4bab5c59b084ae52816ff12">extra_interpolation_matrix_row</a>(j) &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l00748"></a>00748     extra_interpolation_matrix_row_out.close();
<a name="l00749"></a>00749     
<a name="l00750"></a>00750     <span class="comment">// Next write out interpolation_points</span>
<a name="l00751"></a>00751     std::ofstream interpolation_points_out;
<a name="l00752"></a>00752     {
<a name="l00753"></a>00753       <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l00754"></a>00754       file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/interpolation_points.dat&quot;</span>;
<a name="l00755"></a>00755       interpolation_points_out.open(file_name.str().c_str());
<a name="l00756"></a>00756     }
<a name="l00757"></a>00757     <span class="keywordflow">if</span> ( !interpolation_points_out.good() )
<a name="l00758"></a>00758     {
<a name="l00759"></a>00759       <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening interpolation_points.dat&quot;</span> &lt;&lt; std::endl;
<a name="l00760"></a>00760       libmesh_error();
<a name="l00761"></a>00761     }
<a name="l00762"></a>00762     interpolation_points_out.precision(precision_level);
<a name="l00763"></a>00763     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_bfs; i++)
<a name="l00764"></a>00764       interpolation_points_out &lt;&lt; std::scientific
<a name="l00765"></a>00765           &lt;&lt; <a class="code" href="classlibMesh_1_1RBEIMSystem.php#adb0d071273574e43edca763b079258b6">interpolation_points</a>[i](0) &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00766"></a>00766           &lt;&lt; <a class="code" href="classlibMesh_1_1RBEIMSystem.php#adb0d071273574e43edca763b079258b6">interpolation_points</a>[i](1) &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00767"></a>00767           &lt;&lt; <a class="code" href="classlibMesh_1_1RBEIMSystem.php#adb0d071273574e43edca763b079258b6">interpolation_points</a>[i](2) &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l00768"></a>00768 
<a name="l00769"></a>00769     <span class="comment">// Also, write out the &quot;extra&quot; interpolation point</span>
<a name="l00770"></a>00770     std::ofstream extra_interpolation_point_out;
<a name="l00771"></a>00771     {
<a name="l00772"></a>00772       <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l00773"></a>00773       file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/extra_interpolation_point.dat&quot;</span>;
<a name="l00774"></a>00774       extra_interpolation_point_out.open(file_name.str().c_str());
<a name="l00775"></a>00775     }
<a name="l00776"></a>00776     <span class="keywordflow">if</span> ( !extra_interpolation_point_out.good() )
<a name="l00777"></a>00777     {
<a name="l00778"></a>00778       <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening extra_interpolation_point.dat&quot;</span> &lt;&lt; std::endl;
<a name="l00779"></a>00779       libmesh_error();
<a name="l00780"></a>00780     }
<a name="l00781"></a>00781     extra_interpolation_point_out.precision(precision_level);
<a name="l00782"></a>00782     extra_interpolation_point_out &lt;&lt; std::scientific
<a name="l00783"></a>00783           &lt;&lt; <a class="code" href="classlibMesh_1_1RBEIMSystem.php#afdf0d637dac9e3d4268b878bfcca4982">extra_interpolation_point</a>(0) &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00784"></a>00784           &lt;&lt; <a class="code" href="classlibMesh_1_1RBEIMSystem.php#afdf0d637dac9e3d4268b878bfcca4982">extra_interpolation_point</a>(1) &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00785"></a>00785           &lt;&lt; <a class="code" href="classlibMesh_1_1RBEIMSystem.php#afdf0d637dac9e3d4268b878bfcca4982">extra_interpolation_point</a>(2) &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l00786"></a>00786     extra_interpolation_point_out.close();
<a name="l00787"></a>00787     
<a name="l00788"></a>00788     <span class="comment">// Next write out interpolation_points_var</span>
<a name="l00789"></a>00789     std::ofstream interpolation_points_var_out;
<a name="l00790"></a>00790     {
<a name="l00791"></a>00791       <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l00792"></a>00792       file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/interpolation_points_var.dat&quot;</span>;
<a name="l00793"></a>00793       interpolation_points_var_out.open(file_name.str().c_str());
<a name="l00794"></a>00794     }
<a name="l00795"></a>00795     <span class="keywordflow">if</span> ( !interpolation_points_var_out.good() )
<a name="l00796"></a>00796     {
<a name="l00797"></a>00797       <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening interpolation_points_var.dat&quot;</span> &lt;&lt; std::endl;
<a name="l00798"></a>00798       libmesh_error();
<a name="l00799"></a>00799     }
<a name="l00800"></a>00800     interpolation_points_var_out.precision(precision_level);
<a name="l00801"></a>00801     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_bfs; i++)
<a name="l00802"></a>00802       interpolation_points_var_out &lt;&lt; std::scientific
<a name="l00803"></a>00803           &lt;&lt; <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a0f88e3b126beb2a43560548d6b3954a5">interpolation_points_var</a>[i] &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l00804"></a>00804 
<a name="l00805"></a>00805     <span class="comment">// Also, write out the &quot;extra&quot; interpolation variable</span>
<a name="l00806"></a>00806     std::ofstream extra_interpolation_point_var_out;
<a name="l00807"></a>00807     {
<a name="l00808"></a>00808       <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l00809"></a>00809       file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/extra_interpolation_point_var.dat&quot;</span>;
<a name="l00810"></a>00810       extra_interpolation_point_var_out.open(file_name.str().c_str());
<a name="l00811"></a>00811     }
<a name="l00812"></a>00812     <span class="keywordflow">if</span> ( !extra_interpolation_point_var_out.good() )
<a name="l00813"></a>00813     {
<a name="l00814"></a>00814       <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening extra_interpolation_point_var.dat&quot;</span> &lt;&lt; std::endl;
<a name="l00815"></a>00815       libmesh_error();
<a name="l00816"></a>00816     }
<a name="l00817"></a>00817     extra_interpolation_point_var_out.precision(precision_level);
<a name="l00818"></a>00818     extra_interpolation_point_var_out &lt;&lt; std::scientific
<a name="l00819"></a>00819           &lt;&lt; <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a381f17c720b57759259c185a1f88d6f3">extra_interpolation_point_var</a> &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l00820"></a>00820     extra_interpolation_point_var_out.close();
<a name="l00821"></a>00821   }
<a name="l00822"></a>00822 
<a name="l00823"></a>00823   STOP_LOG(<span class="stringliteral">&quot;write_offline_data_to_files()&quot;</span>, <span class="stringliteral">&quot;RBEIMSystem&quot;</span>);
<a name="l00824"></a>00824 }
<a name="l00825"></a>00825 
<a name="l00826"></a><a class="code" href="classlibMesh_1_1RBEIMSystem.php#a072a1fcccf8e312d9b3dc51b34311229">00826</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a072a1fcccf8e312d9b3dc51b34311229">RBEIMSystem::read_offline_data_from_files</a>(<span class="keyword">const</span> std::string&amp; directory_name)
<a name="l00827"></a>00827 {
<a name="l00828"></a>00828   START_LOG(<span class="stringliteral">&quot;read_offline_data_from_files()&quot;</span>, <span class="stringliteral">&quot;RBEIMSystem&quot;</span>);
<a name="l00829"></a>00829 
<a name="l00830"></a>00830   <a class="code" href="classlibMesh_1_1RBSystem.php#ad32589e604ce7562cc256741e87d7d3c">Parent::read_offline_data_from_files</a>(directory_name);
<a name="l00831"></a>00831   
<a name="l00832"></a>00832   <span class="comment">// First, find out how many basis functions we had when Greedy terminated</span>
<a name="l00833"></a>00833   <span class="comment">// This was set in RBSystem::read_offline_data_from_files</span>
<a name="l00834"></a>00834   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_bfs = this-&gt;<a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>();
<a name="l00835"></a>00835   
<a name="l00836"></a>00836   <span class="comment">// Read in the interpolation matrix</span>
<a name="l00837"></a>00837   std::ifstream interpolation_matrix_in;
<a name="l00838"></a>00838   {
<a name="l00839"></a>00839     <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l00840"></a>00840     file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/interpolation_matrix.dat&quot;</span>;
<a name="l00841"></a>00841     interpolation_matrix_in.open(file_name.str().c_str());
<a name="l00842"></a>00842   }
<a name="l00843"></a>00843   <span class="keywordflow">if</span> ( !interpolation_matrix_in.good() )
<a name="l00844"></a>00844   {
<a name="l00845"></a>00845     <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening interpolation_matrix.dat&quot;</span> &lt;&lt; std::endl;
<a name="l00846"></a>00846     libmesh_error();
<a name="l00847"></a>00847   }
<a name="l00848"></a>00848   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_bfs; i++)
<a name="l00849"></a>00849   {
<a name="l00850"></a>00850     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;=i; j++)
<a name="l00851"></a>00851     {
<a name="l00852"></a>00852       <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> value;
<a name="l00853"></a>00853       interpolation_matrix_in &gt;&gt; value;
<a name="l00854"></a>00854       <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a2b51235d643d5709569ed51cd448116a">interpolation_matrix</a>(i,j) = value;
<a name="l00855"></a>00855     }
<a name="l00856"></a>00856   }
<a name="l00857"></a>00857 
<a name="l00858"></a>00858   <span class="comment">// Also, read in the &quot;extra&quot; row</span>
<a name="l00859"></a>00859   std::ifstream extra_interpolation_matrix_row_in;
<a name="l00860"></a>00860   {
<a name="l00861"></a>00861     <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l00862"></a>00862     file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/extra_interpolation_matrix_row.dat&quot;</span>;
<a name="l00863"></a>00863     extra_interpolation_matrix_row_in.open(file_name.str().c_str());
<a name="l00864"></a>00864   }
<a name="l00865"></a>00865   <span class="keywordflow">if</span> ( !extra_interpolation_matrix_row_in.good() )
<a name="l00866"></a>00866   {
<a name="l00867"></a>00867     <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening extra_interpolation_matrix_row.dat&quot;</span> &lt;&lt; std::endl;
<a name="l00868"></a>00868     libmesh_error();
<a name="l00869"></a>00869   }
<a name="l00870"></a>00870   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;n_bfs; j++)
<a name="l00871"></a>00871   {
<a name="l00872"></a>00872     <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> value;
<a name="l00873"></a>00873     extra_interpolation_matrix_row_in &gt;&gt; value;
<a name="l00874"></a>00874     <a class="code" href="classlibMesh_1_1RBEIMSystem.php#ae2030b74d4bab5c59b084ae52816ff12">extra_interpolation_matrix_row</a>(j) = value;
<a name="l00875"></a>00875   }
<a name="l00876"></a>00876   extra_interpolation_matrix_row_in.close();
<a name="l00877"></a>00877 
<a name="l00878"></a>00878   <span class="comment">// Next read in interpolation_points</span>
<a name="l00879"></a>00879   std::ifstream interpolation_points_in;
<a name="l00880"></a>00880   {
<a name="l00881"></a>00881     <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l00882"></a>00882     file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/interpolation_points.dat&quot;</span>;
<a name="l00883"></a>00883     interpolation_points_in.open(file_name.str().c_str());
<a name="l00884"></a>00884   }
<a name="l00885"></a>00885   <span class="keywordflow">if</span> ( !interpolation_points_in.good() )
<a name="l00886"></a>00886   {
<a name="l00887"></a>00887     <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening interpolation_points.dat&quot;</span> &lt;&lt; std::endl;
<a name="l00888"></a>00888     libmesh_error();
<a name="l00889"></a>00889   }
<a name="l00890"></a>00890   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_bfs; i++)
<a name="l00891"></a>00891   {
<a name="l00892"></a>00892     <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> x_val, y_val, z_val;
<a name="l00893"></a>00893     interpolation_points_in &gt;&gt; x_val;
<a name="l00894"></a>00894     interpolation_points_in &gt;&gt; y_val;
<a name="l00895"></a>00895     interpolation_points_in &gt;&gt; z_val;
<a name="l00896"></a>00896     <a class="code" href="classlibMesh_1_1Point.php">Point</a> p(x_val, y_val, z_val);
<a name="l00897"></a>00897     <a class="code" href="classlibMesh_1_1RBEIMSystem.php#adb0d071273574e43edca763b079258b6">interpolation_points</a>.push_back(p);
<a name="l00898"></a>00898   }
<a name="l00899"></a>00899   interpolation_points_in.close();
<a name="l00900"></a>00900   
<a name="l00901"></a>00901   <span class="comment">// Also, read in the extra interpolation point</span>
<a name="l00902"></a>00902   std::ifstream extra_interpolation_point_in;
<a name="l00903"></a>00903   {
<a name="l00904"></a>00904     <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l00905"></a>00905     file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/extra_interpolation_point.dat&quot;</span>;
<a name="l00906"></a>00906     extra_interpolation_point_in.open(file_name.str().c_str());
<a name="l00907"></a>00907   }
<a name="l00908"></a>00908   <span class="keywordflow">if</span> ( !extra_interpolation_point_in.good() )
<a name="l00909"></a>00909   {
<a name="l00910"></a>00910     <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening extra_interpolation_point.dat&quot;</span> &lt;&lt; std::endl;
<a name="l00911"></a>00911     libmesh_error();
<a name="l00912"></a>00912   }
<a name="l00913"></a>00913   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_bfs; i++)
<a name="l00914"></a>00914   {
<a name="l00915"></a>00915     <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> x_val, y_val, z_val;
<a name="l00916"></a>00916     extra_interpolation_point_in &gt;&gt; x_val;
<a name="l00917"></a>00917     extra_interpolation_point_in &gt;&gt; y_val;
<a name="l00918"></a>00918     extra_interpolation_point_in &gt;&gt; z_val;
<a name="l00919"></a>00919     <a class="code" href="classlibMesh_1_1Point.php">Point</a> p(x_val, y_val, z_val);
<a name="l00920"></a>00920     <a class="code" href="classlibMesh_1_1RBEIMSystem.php#afdf0d637dac9e3d4268b878bfcca4982">extra_interpolation_point</a> = p;
<a name="l00921"></a>00921   }
<a name="l00922"></a>00922   extra_interpolation_point_in.close();
<a name="l00923"></a>00923   
<a name="l00924"></a>00924 
<a name="l00925"></a>00925   <span class="comment">// Next read in interpolation_points_var</span>
<a name="l00926"></a>00926   std::ifstream interpolation_points_var_in;
<a name="l00927"></a>00927   {
<a name="l00928"></a>00928     <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l00929"></a>00929     file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/interpolation_points_var.dat&quot;</span>;
<a name="l00930"></a>00930     interpolation_points_var_in.open(file_name.str().c_str());
<a name="l00931"></a>00931   }
<a name="l00932"></a>00932   <span class="keywordflow">if</span> ( !interpolation_points_var_in.good() )
<a name="l00933"></a>00933   {
<a name="l00934"></a>00934     <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening interpolation_points_var.dat&quot;</span> &lt;&lt; std::endl;
<a name="l00935"></a>00935     libmesh_error();
<a name="l00936"></a>00936   }
<a name="l00937"></a>00937   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;=n_bfs; i++)
<a name="l00938"></a>00938   {
<a name="l00939"></a>00939     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var;
<a name="l00940"></a>00940     interpolation_points_var_in &gt;&gt; var;
<a name="l00941"></a>00941     <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a0f88e3b126beb2a43560548d6b3954a5">interpolation_points_var</a>.push_back(var);
<a name="l00942"></a>00942   }
<a name="l00943"></a>00943   interpolation_points_var_in.close();
<a name="l00944"></a>00944   
<a name="l00945"></a>00945   <span class="comment">// Also, read in extra_interpolation_point_var</span>
<a name="l00946"></a>00946   std::ifstream extra_interpolation_point_var_in;
<a name="l00947"></a>00947   {
<a name="l00948"></a>00948     <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l00949"></a>00949     file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/extra_interpolation_point_var.dat&quot;</span>;
<a name="l00950"></a>00950     extra_interpolation_point_var_in.open(file_name.str().c_str());
<a name="l00951"></a>00951   }
<a name="l00952"></a>00952   <span class="keywordflow">if</span> ( !extra_interpolation_point_var_in.good() )
<a name="l00953"></a>00953   {
<a name="l00954"></a>00954     <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening extra_interpolation_point_var.dat&quot;</span> &lt;&lt; std::endl;
<a name="l00955"></a>00955     libmesh_error();
<a name="l00956"></a>00956   }
<a name="l00957"></a>00957   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;=n_bfs; i++)
<a name="l00958"></a>00958   {
<a name="l00959"></a>00959     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var;
<a name="l00960"></a>00960     extra_interpolation_point_var_in &gt;&gt; var;
<a name="l00961"></a>00961     <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a381f17c720b57759259c185a1f88d6f3">extra_interpolation_point_var</a> = var;
<a name="l00962"></a>00962   }
<a name="l00963"></a>00963   extra_interpolation_point_var_in.close();
<a name="l00964"></a>00964   
<a name="l00965"></a>00965   STOP_LOG(<span class="stringliteral">&quot;read_offline_data_from_files()&quot;</span>, <span class="stringliteral">&quot;RBEIMSystem&quot;</span>);
<a name="l00966"></a>00966 }
<a name="l00967"></a>00967 
<a name="l00968"></a>00968 } <span class="comment">// namespace libMesh</span>
<a name="l00969"></a>00969 
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
