<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_eaf30c8ea092d33f79a04353c3899c3f.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_5a0c7151fa56969ceb962f1511f7edee.php">systems</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">rb_eim_system.h</div>  </div>
</div>
<div class="contents">
<a href="rb__eim__system_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// rbOOmit: An implementation of the Certified Reduced Basis method.</span>
<a name="l00002"></a>00002 <span class="comment">// Copyright (C) 2009, 2010 David J. Knezevic</span>
<a name="l00003"></a>00003 
<a name="l00004"></a>00004 <span class="comment">// This file is part of rbOOmit.</span>
<a name="l00005"></a>00005 
<a name="l00006"></a>00006 <span class="comment">// rbOOmit is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// rbOOmit is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="preprocessor">#ifndef __rb_eim_system_h__</span>
<a name="l00021"></a>00021 <span class="preprocessor"></span><span class="preprocessor">#define __rb_eim_system_h__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;<a class="code" href="rb__system_8h.php">rb_system.h</a>&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="code" href="mesh__function_8h.php">mesh_function.h</a>&quot;</span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="keyword">namespace </span>libMesh
<a name="l00027"></a>00027 {
<a name="l00028"></a>00028 
<a name="l00042"></a><a class="code" href="namespacelibMesh.php#aedacb3429d477794325ea67817f8e395">00042</a> <span class="keyword">typedef</span> <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> (*<a class="code" href="namespacelibMesh.php#aedacb3429d477794325ea67817f8e395">parametrized_function_fptr</a>)(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp;, <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1RBSystem.php">RBSystem</a>&amp;);
<a name="l00043"></a>00043 
<a name="l00044"></a>00044 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00045"></a>00045 <span class="comment">// RBEIMSystem class definition</span>
<a name="l00046"></a>00046 
<a name="l00047"></a><a class="code" href="classlibMesh_1_1RBEIMSystem.php">00047</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1RBEIMSystem.php">RBEIMSystem</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1RBSystem.php">RBSystem</a>
<a name="l00048"></a>00048 {
<a name="l00049"></a>00049 <span class="keyword">public</span>:
<a name="l00050"></a>00050 
<a name="l00051"></a><a class="code" href="classlibMesh_1_1RBEIMSystem.php#af69284437ee73022900134a07d029d2aa077a557c95c17e5a4546e5e325f5bdab">00051</a>   <span class="keyword">enum</span> <a class="code" href="classlibMesh_1_1RBEIMSystem.php#af69284437ee73022900134a07d029d2a">BEST_FIT_TYPE</a> { <a class="code" href="classlibMesh_1_1RBEIMSystem.php#af69284437ee73022900134a07d029d2aa077a557c95c17e5a4546e5e325f5bdab">PROJECTION_BEST_FIT</a>, <a class="code" href="classlibMesh_1_1RBEIMSystem.php#af69284437ee73022900134a07d029d2aac8315f0606b381d2e4584ded33323e94">EIM_BEST_FIT</a> };
<a name="l00052"></a>00052 
<a name="l00057"></a>00057   <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a0d88b29db222d7f31a7038027a246823">RBEIMSystem</a> (<a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00058"></a>00058                <span class="keyword">const</span> std::string&amp; <a class="code" href="classlibMesh_1_1System.php#af80f6b2e508821ebd9c8fcb78d443f18">name</a>,
<a name="l00059"></a>00059                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#aee5caacb487b070842733f1c84b9a2fd">number</a>);
<a name="l00060"></a>00060 
<a name="l00064"></a>00064   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a657429362f0e847d79290452089e3dce">~RBEIMSystem</a> ();
<a name="l00065"></a>00065 
<a name="l00069"></a><a class="code" href="classlibMesh_1_1RBEIMSystem.php#afe7c405bbae10cdc5ef71ea9ac305122">00069</a>   <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1RBEIMSystem.php">RBEIMSystem</a> <a class="code" href="classlibMesh_1_1RBEIMSystem.php#afe7c405bbae10cdc5ef71ea9ac305122">sys_type</a>;
<a name="l00070"></a>00070   
<a name="l00074"></a><a class="code" href="classlibMesh_1_1RBEIMSystem.php#a75be5c788ee4549f8cf1210c602daa46">00074</a>   <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1RBSystem.php">RBSystem</a> <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a75be5c788ee4549f8cf1210c602daa46">Parent</a>;
<a name="l00075"></a>00075   
<a name="l00079"></a>00079   <span class="keyword">virtual</span> std::string <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a3a12e0ed7f06c4864b00c5b8bd35013c">system_type</a> () <span class="keyword">const</span>;
<a name="l00080"></a>00080   
<a name="l00085"></a>00085   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a9ffb12f992dfb9ea7693436957460d08">initialize_RB_system</a>(<span class="keywordtype">bool</span> online_mode);
<a name="l00086"></a>00086  
<a name="l00095"></a>00095   <span class="keyword">virtual</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a09bc2cb1397e774b2e792d565ce40a21">truth_solve</a>(<span class="keywordtype">int</span> plot_solution);
<a name="l00096"></a>00096   
<a name="l00103"></a>00103   <span class="keyword">virtual</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a46cea2966644f4c6dc0c812e1e8e59ed">RB_solve</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N);
<a name="l00104"></a>00104   
<a name="l00110"></a>00110   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a46cea2966644f4c6dc0c812e1e8e59ed">RB_solve</a>(<a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a>&amp; EIM_rhs);
<a name="l00111"></a>00111 
<a name="l00119"></a>00119   <span class="keyword">virtual</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a9697d17d54f4349389032bcd12b89683">compute_best_fit_error</a>();
<a name="l00120"></a>00120   
<a name="l00126"></a>00126   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBEIMSystem.php#ac2cf12446f8194fa22c2b3c9a7b1fca2">init_context</a>(<a class="code" href="classlibMesh_1_1FEMContext.php">FEMContext</a> &amp;c);  
<a name="l00127"></a>00127 
<a name="l00132"></a><a class="code" href="classlibMesh_1_1RBEIMSystem.php#a90a1d8ca0b8b10fe41c1854e8343ea4b">00132</a>   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a90a1d8ca0b8b10fe41c1854e8343ea4b">attach_paramerized_function</a>(<a class="code" href="namespacelibMesh.php#aedacb3429d477794325ea67817f8e395">parametrized_function_fptr</a> fptr)
<a name="l00133"></a>00133     { <a class="code" href="classlibMesh_1_1RBEIMSystem.php#abcf8520a990282f876f26a164c74687f">parametrized_functions</a>.push_back(fptr); }
<a name="l00134"></a>00134   
<a name="l00139"></a><a class="code" href="classlibMesh_1_1RBEIMSystem.php#a48ecfe2c8fc98bf0a17e730e786467bd">00139</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a48ecfe2c8fc98bf0a17e730e786467bd">get_n_parametrized_functions</a>()<span class="keyword"> const</span>
<a name="l00140"></a>00140 <span class="keyword">    </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1RBEIMSystem.php#abcf8520a990282f876f26a164c74687f">parametrized_functions</a>.size(); }
<a name="l00141"></a>00141 
<a name="l00146"></a>00146   <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a9d72a25b6a85986018ec297a73bd8f97">evaluate_parametrized_function</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var, <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p);
<a name="l00147"></a>00147   
<a name="l00153"></a>00153   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a1fe41b9f0c69104eb59220166afb929c">get_n_affine_functions</a>() <span class="keyword">const</span>;
<a name="l00154"></a>00154   
<a name="l00158"></a>00158   std::vector&lt;Number&gt; <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a3c90ab10e1378d26ea0db2094ad37f17">evaluate_current_affine_function</a>(<a class="code" href="classlibMesh_1_1Elem.php">Elem</a>&amp; element,
<a name="l00159"></a>00159                                                        <span class="keyword">const</span> std::vector&lt;Point&gt;&amp; qpoints);
<a name="l00160"></a>00160 
<a name="l00166"></a>00166   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a46b55bb7ba6c15b09d42c0b3e6feacda">cache_ghosted_basis_function</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> function_index);
<a name="l00167"></a>00167 
<a name="l00172"></a>00172   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a0d994ca1ea93da811b2c7b1fe3f95cb1">clear_basis_function_dependent_data</a>();
<a name="l00173"></a>00173   
<a name="l00178"></a>00178   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBEIMSystem.php#aeec65e2003f1fc9b2e77b751928f6ddd">write_offline_data_to_files</a>(<span class="keyword">const</span> std::string&amp; directory_name = <span class="stringliteral">&quot;offline_data&quot;</span>);
<a name="l00179"></a>00179   
<a name="l00184"></a>00184   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a072a1fcccf8e312d9b3dc51b34311229">read_offline_data_from_files</a>(<span class="keyword">const</span> std::string&amp; directory_name = <span class="stringliteral">&quot;offline_data&quot;</span>);
<a name="l00185"></a>00185 
<a name="l00186"></a>00186   <span class="comment">//----------- PUBLIC DATA MEMBERS -----------//</span>
<a name="l00187"></a>00187   
<a name="l00192"></a><a class="code" href="classlibMesh_1_1RBEIMSystem.php#a2b51235d643d5709569ed51cd448116a">00192</a>   <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Number&gt;</a> <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a2b51235d643d5709569ed51cd448116a">interpolation_matrix</a>;
<a name="l00193"></a>00193   
<a name="l00198"></a><a class="code" href="classlibMesh_1_1RBEIMSystem.php#adb0d071273574e43edca763b079258b6">00198</a>   std::vector&lt;Point&gt; <a class="code" href="classlibMesh_1_1RBEIMSystem.php#adb0d071273574e43edca763b079258b6">interpolation_points</a>;
<a name="l00199"></a>00199   
<a name="l00204"></a><a class="code" href="classlibMesh_1_1RBEIMSystem.php#a0f88e3b126beb2a43560548d6b3954a5">00204</a>   std::vector&lt;unsigned int&gt; <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a0f88e3b126beb2a43560548d6b3954a5">interpolation_points_var</a>;
<a name="l00205"></a>00205   
<a name="l00211"></a><a class="code" href="classlibMesh_1_1RBEIMSystem.php#afdf0d637dac9e3d4268b878bfcca4982">00211</a>   <a class="code" href="classlibMesh_1_1Point.php">Point</a> <a class="code" href="classlibMesh_1_1RBEIMSystem.php#afdf0d637dac9e3d4268b878bfcca4982">extra_interpolation_point</a>;
<a name="l00212"></a><a class="code" href="classlibMesh_1_1RBEIMSystem.php#a381f17c720b57759259c185a1f88d6f3">00212</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a381f17c720b57759259c185a1f88d6f3">extra_interpolation_point_var</a>;
<a name="l00213"></a>00213   
<a name="l00218"></a><a class="code" href="classlibMesh_1_1RBEIMSystem.php#ae2030b74d4bab5c59b084ae52816ff12">00218</a>   <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> <a class="code" href="classlibMesh_1_1RBEIMSystem.php#ae2030b74d4bab5c59b084ae52816ff12">extra_interpolation_matrix_row</a>;
<a name="l00219"></a>00219   
<a name="l00229"></a><a class="code" href="classlibMesh_1_1RBEIMSystem.php#a59e0e07c97341f774dfe93b8ca87c17d">00229</a>   <a class="code" href="classlibMesh_1_1RBEIMSystem.php#af69284437ee73022900134a07d029d2a">BEST_FIT_TYPE</a> <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a59e0e07c97341f774dfe93b8ca87c17d">best_fit_type_flag</a>;
<a name="l00230"></a>00230   
<a name="l00231"></a>00231 <span class="keyword">protected</span>:
<a name="l00236"></a>00236   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a89f5f9965126cd2172b21e96a139d8b0">init_data</a> ();
<a name="l00237"></a>00237 
<a name="l00242"></a>00242   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a54ece7bd74376f951c01c33f10c891b6">enrich_RB_space</a>();
<a name="l00243"></a>00243   
<a name="l00248"></a>00248   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBEIMSystem.php#aabd12f850f9e826396ec8eeffdb9fbc1">update_system</a>();
<a name="l00249"></a>00249   
<a name="l00255"></a>00255   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a9816bd5cd95b053b2cbbffc7b80881ab">update_RB_system_matrices</a>();
<a name="l00256"></a>00256   
<a name="l00261"></a><a class="code" href="classlibMesh_1_1RBEIMSystem.php#ad3093b9304c6e98973517a130bccc7f2">00261</a>   <span class="keyword">virtual</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1RBEIMSystem.php#ad3093b9304c6e98973517a130bccc7f2">get_RB_error_bound</a>() { <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a9697d17d54f4349389032bcd12b89683">compute_best_fit_error</a>(); }
<a name="l00262"></a>00262   
<a name="l00267"></a>00267   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a50914d7bcd2d62551b1961eca497f252">greedy_termination_test</a>(<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> training_greedy_error, <span class="keywordtype">int</span> count);
<a name="l00268"></a>00268   
<a name="l00269"></a>00269 <span class="keyword">private</span>:
<a name="l00270"></a>00270 
<a name="l00274"></a><a class="code" href="classlibMesh_1_1RBEIMSystem.php#acc26e4d0d9bce27a33ce4f956304b8c4">00274</a>   <a class="code" href="classlibMesh_1_1MeshFunction.php">MeshFunction</a>* <a class="code" href="classlibMesh_1_1RBEIMSystem.php#acc26e4d0d9bce27a33ce4f956304b8c4">mesh_function</a>;
<a name="l00275"></a>00275   
<a name="l00282"></a><a class="code" href="classlibMesh_1_1RBEIMSystem.php#abe224818af2634670a90d9dfa2f53686">00282</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1RBEIMSystem.php#abe224818af2634670a90d9dfa2f53686">performing_extra_greedy_step</a>;
<a name="l00283"></a>00283   
<a name="l00288"></a><a class="code" href="classlibMesh_1_1RBEIMSystem.php#abcf8520a990282f876f26a164c74687f">00288</a>   std::vector&lt;parametrized_function_fptr&gt; <a class="code" href="classlibMesh_1_1RBEIMSystem.php#abcf8520a990282f876f26a164c74687f">parametrized_functions</a>;
<a name="l00289"></a>00289   
<a name="l00295"></a><a class="code" href="classlibMesh_1_1RBEIMSystem.php#af575f6d6a8fea8a3cdc385aba4779766">00295</a>   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt; NumericVector&lt;Number&gt;</a> &gt; <a class="code" href="classlibMesh_1_1RBEIMSystem.php#af575f6d6a8fea8a3cdc385aba4779766">current_ghosted_bf</a>;
<a name="l00296"></a>00296   
<a name="l00302"></a><a class="code" href="classlibMesh_1_1RBEIMSystem.php#a6d851240aacbb38297f861d98c6487a3">00302</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a6d851240aacbb38297f861d98c6487a3">current_variable_number</a>;
<a name="l00303"></a>00303   
<a name="l00309"></a><a class="code" href="classlibMesh_1_1RBEIMSystem.php#ab0de301ef87beaca8ad3e97e70105743">00309</a>   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt; NumericVector&lt;Number&gt;</a> &gt; <a class="code" href="classlibMesh_1_1RBEIMSystem.php#ab0de301ef87beaca8ad3e97e70105743">serialized_vector</a>;
<a name="l00310"></a>00310   
<a name="l00316"></a><a class="code" href="classlibMesh_1_1RBEIMSystem.php#a49536f1b30de5b44b86f2361f52dd925">00316</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a49536f1b30de5b44b86f2361f52dd925">eval_error_estimate</a>;
<a name="l00317"></a>00317 
<a name="l00318"></a>00318 };
<a name="l00319"></a>00319 
<a name="l00320"></a>00320 } <span class="comment">// namespace libMesh</span>
<a name="l00321"></a>00321 
<a name="l00322"></a>00322 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
