<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_c3a49989e40b21e7508f29d2dc962def.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_94af86d0ee7ff5a2af0627e1a0ea6efa.php">systems</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">rb_scm_system.C</div>  </div>
</div>
<div class="contents">
<a href="rb__scm__system_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// rbOOmit: An implementation of the Certified Reduced Basis method.</span>
<a name="l00002"></a>00002 <span class="comment">// Copyright (C) 2009, 2010 David J. Knezevic</span>
<a name="l00003"></a>00003 
<a name="l00004"></a>00004 <span class="comment">// This file is part of rbOOmit.</span>
<a name="l00005"></a>00005 
<a name="l00006"></a>00006 <span class="comment">// rbOOmit is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// rbOOmit is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="comment">// Configuration data</span>
<a name="l00021"></a>00021 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>&quot;</span>
<a name="l00022"></a>00022 
<a name="l00023"></a>00023 <span class="comment">// Currently, the RBSCMSystem should only be available</span>
<a name="l00024"></a>00024 <span class="comment">// if SLEPc support is enabled.</span>
<a name="l00025"></a>00025 <span class="preprocessor">#if defined(LIBMESH_HAVE_SLEPC) &amp;&amp; (LIBMESH_HAVE_GLPK)</span>
<a name="l00026"></a>00026 <span class="preprocessor"></span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="rb__scm__system_8h.php">rb_scm_system.h</a>&quot;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__logging_8h.php">libmesh_logging.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="numeric__vector_8h.php">numeric_vector.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="sparse__matrix_8h.php">sparse_matrix.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="equation__systems_8h.php">equation_systems.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="getpot_8h.php">getpot.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="rb__system_8h.php">rb_system.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="parallel_8h.php">parallel.h</a>&quot;</span>
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="comment">// For creating a directory</span>
<a name="l00038"></a>00038 <span class="preprocessor">#include &lt;sys/types.h&gt;</span>
<a name="l00039"></a>00039 <span class="preprocessor">#include &lt;sys/stat.h&gt;</span>
<a name="l00040"></a>00040 <span class="preprocessor">#include &lt;errno.h&gt;</span>
<a name="l00041"></a>00041 
<a name="l00042"></a>00042 <span class="comment">// glpk includes</span>
<a name="l00043"></a>00043 <span class="preprocessor">#include &lt;glpk.h&gt;</span>
<a name="l00044"></a>00044 
<a name="l00045"></a>00045 <span class="keyword">namespace </span>libMesh
<a name="l00046"></a>00046 {
<a name="l00047"></a>00047 
<a name="l00048"></a><a class="code" href="classlibMesh_1_1RBSCMSystem.php#a81bd11b0a842406c6d90b79d736cf8f8">00048</a> <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a81bd11b0a842406c6d90b79d736cf8f8">RBSCMSystem::RBSCMSystem</a> (<a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00049"></a>00049                           <span class="keyword">const</span> std::string&amp; <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>,
<a name="l00050"></a>00050                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> number)
<a name="l00051"></a>00051   : <a class="code" href="classlibMesh_1_1System.php">Parent</a>(es, name, number),
<a name="l00052"></a>00052     parameters_filename(<span class="stringliteral">&quot;&quot;</span>),
<a name="l00053"></a>00053     condensed_matrix_A(<a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix</a>&lt;<a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a>&gt;::build()),
<a name="l00054"></a>00054     condensed_matrix_B(<a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix</a>&lt;<a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a>&gt;::build()),
<a name="l00055"></a>00055     SCM_eps(0.5),
<a name="l00056"></a>00056     SCM_M(1),
<a name="l00057"></a>00057     RB_system_name(<span class="stringliteral">&quot;&quot;</span>)
<a name="l00058"></a>00058 {
<a name="l00059"></a>00059 
<a name="l00060"></a>00060   <span class="comment">// set assemble_before_solve flag to false</span>
<a name="l00061"></a>00061   <span class="comment">// so that we control matrix assembly.</span>
<a name="l00062"></a>00062   <a class="code" href="classlibMesh_1_1System.php#a6b24ccb769399c64405e8f8a52491e70">assemble_before_solve</a> = <span class="keyword">false</span>;
<a name="l00063"></a>00063 
<a name="l00064"></a>00064   <span class="comment">// We symmetrize all operators hence use symmetric solvers</span>
<a name="l00065"></a>00065   <a class="code" href="classlibMesh_1_1EigenSystem.php#a0e58b2fd0efeb1fa491ff16df6403098">set_eigenproblem_type</a>(<a class="code" href="namespacelibMeshEnums.php#a834a7caabd0c61943731bb38bfc67301a2249b7b4acec69dfdd4212b7a0333c22">GHEP</a>);
<a name="l00066"></a>00066 
<a name="l00067"></a>00067   <span class="comment">// Clear SCM data vectors</span>
<a name="l00068"></a>00068   <a class="code" href="classlibMesh_1_1RBSCMSystem.php#af64954db1af6eef59ad24ccecc960a89">B_min</a>.clear();
<a name="l00069"></a>00069   <a class="code" href="classlibMesh_1_1RBSCMSystem.php#aa4214d13d5b9c1ea21b544d261e39a79">B_max</a>.clear();
<a name="l00070"></a>00070   <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a2fb14e4c9d70dd1722635ab62bb72423">C_J</a>.clear();
<a name="l00071"></a>00071   <a class="code" href="classlibMesh_1_1RBSCMSystem.php#af66df67db4690fe68eb82028ee0fcf24">C_J_stability_vector</a>.clear();
<a name="l00072"></a>00072   <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a105199f54a65f57e2c5e66de3ea07916">SCM_UB_vectors</a>.clear();
<a name="l00073"></a>00073 }
<a name="l00074"></a>00074 
<a name="l00075"></a><a class="code" href="classlibMesh_1_1RBSCMSystem.php#ab50035fb885cb1e3faaa829fb1ae46af">00075</a> <a class="code" href="classlibMesh_1_1RBSCMSystem.php#ab50035fb885cb1e3faaa829fb1ae46af">RBSCMSystem::~RBSCMSystem</a> ()
<a name="l00076"></a>00076 {
<a name="l00077"></a>00077   this-&gt;<a class="code" href="classlibMesh_1_1RBSCMSystem.php#a8450f0e561356e2e86e30f0910b98bf7">clear</a>();
<a name="l00078"></a>00078 }
<a name="l00079"></a>00079 
<a name="l00080"></a>00080 
<a name="l00081"></a><a class="code" href="classlibMesh_1_1RBSCMSystem.php#a8450f0e561356e2e86e30f0910b98bf7">00081</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a8450f0e561356e2e86e30f0910b98bf7">RBSCMSystem::clear</a>()
<a name="l00082"></a>00082 {
<a name="l00083"></a>00083   <a class="code" href="classlibMesh_1_1RBBase.php#ae9eea4c052b84a8038c348489ddcd1d9">Parent::clear</a>();
<a name="l00084"></a>00084 }
<a name="l00085"></a>00085 
<a name="l00086"></a><a class="code" href="classlibMesh_1_1RBSCMSystem.php#a9cb7939f5f4edc3094c01d994d04fcff">00086</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a9cb7939f5f4edc3094c01d994d04fcff">RBSCMSystem::init_data</a> ()
<a name="l00087"></a>00087 {
<a name="l00088"></a>00088   <span class="comment">// First read in data from parameters_filename</span>
<a name="l00089"></a>00089   GetPot infile(<a class="code" href="classlibMesh_1_1RBSCMSystem.php#a4ddbdc1eeb20c9e7b0c34acccc0af214">parameters_filename</a>);
<a name="l00090"></a>00090 
<a name="l00091"></a>00091   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_SCM_parameters = infile(<span class="stringliteral">&quot;n_SCM_parameters&quot;</span>,1);
<a name="l00092"></a>00092   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_SCM_training_samples = infile(<span class="stringliteral">&quot;n_SCM_training_samples&quot;</span>,1);
<a name="l00093"></a>00093   <span class="keyword">const</span> <span class="keywordtype">bool</span> deterministic_training = infile(<span class="stringliteral">&quot;deterministic_training&quot;</span>,<span class="keyword">false</span>);
<a name="l00094"></a>00094 
<a name="l00095"></a>00095   <span class="comment">// SCM Greedy termination tolerance</span>
<a name="l00096"></a>00096   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> SCM_eps_in = infile(<span class="stringliteral">&quot;SCM_eps&quot;</span>, <a class="code" href="classlibMesh_1_1RBSCMSystem.php#ab763cbcdecd8f0059f4a9431838a5488">SCM_eps</a>);
<a name="l00097"></a>00097   <a class="code" href="classlibMesh_1_1RBSCMSystem.php#aa156e1b58ed97ef8d3fd8595eb58699d">set_SCM_eps</a>(SCM_eps_in);
<a name="l00098"></a>00098 
<a name="l00099"></a>00099   <span class="comment">// The number of SCM stability constraints to impose</span>
<a name="l00100"></a>00100   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> SCM_M_in = infile(<span class="stringliteral">&quot;SCM_M&quot;</span>, <a class="code" href="classlibMesh_1_1RBSCMSystem.php#aae6b24b5d60fd24a348830c0b672659f">SCM_M</a>);
<a name="l00101"></a>00101   <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a6b3b8091faff7f2277bed815450f411b">set_SCM_M</a>(SCM_M_in);
<a name="l00102"></a>00102 
<a name="l00103"></a>00103   <span class="comment">// Resize the bounding box vectors</span>
<a name="l00104"></a>00104   <a class="code" href="classlibMesh_1_1RBSCMSystem.php#af64954db1af6eef59ad24ccecc960a89">B_min</a>.resize(<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>());
<a name="l00105"></a>00105   <a class="code" href="classlibMesh_1_1RBSCMSystem.php#aa4214d13d5b9c1ea21b544d261e39a79">B_max</a>.resize(<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>());
<a name="l00106"></a>00106 
<a name="l00107"></a>00107   <span class="comment">// Tell the system whether or not to initialize \calN dependent data</span>
<a name="l00108"></a>00108   <span class="comment">// structures.</span>
<a name="l00109"></a>00109   <a class="code" href="classlibMesh_1_1RBBase.php#a11c4b80a15c0e9ea1d822f5e04545059">initialize_calN_dependent_data</a> = infile(<span class="stringliteral">&quot;initialize_calN_dependent_data&quot;</span>,
<a name="l00110"></a>00110                                           <a class="code" href="classlibMesh_1_1RBBase.php#a11c4b80a15c0e9ea1d822f5e04545059">initialize_calN_dependent_data</a>);
<a name="l00111"></a>00111 
<a name="l00112"></a>00112   std::vector&lt;Real&gt; <a class="code" href="classlibMesh_1_1RBBase.php#aa54633a8a1d87dc76bbce3cec5e80421">mu_min_vector</a>(n_SCM_parameters);
<a name="l00113"></a>00113   std::vector&lt;Real&gt; <a class="code" href="classlibMesh_1_1RBBase.php#a908713cda5467ba29a8141ee97d3a49d">mu_max_vector</a>(n_SCM_parameters);
<a name="l00114"></a>00114   std::vector&lt;bool&gt; log_scaling(n_SCM_parameters);
<a name="l00115"></a>00115   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_SCM_parameters; i++)
<a name="l00116"></a>00116   {
<a name="l00117"></a>00117     <span class="comment">// Read vector-based mu_min values.</span>
<a name="l00118"></a>00118     mu_min_vector[i] = infile(<span class="stringliteral">&quot;SCM_mu_min&quot;</span>, mu_min_vector[i], i);
<a name="l00119"></a>00119 
<a name="l00120"></a>00120     <span class="comment">// Read vector-based mu_max values.</span>
<a name="l00121"></a>00121     mu_max_vector[i] = infile(<span class="stringliteral">&quot;SCM_mu_max&quot;</span>, mu_max_vector[i], i);
<a name="l00122"></a>00122 
<a name="l00123"></a>00123     <span class="comment">// Read vector-based log scaling values.  Note the intermediate conversion to</span>
<a name="l00124"></a>00124     <span class="comment">// int... this implies log_scaling = &#39;1 1 1...&#39; in the input file.</span>
<a name="l00125"></a>00125     log_scaling[i] = <span class="keyword">static_cast&lt;</span><span class="keywordtype">bool</span><span class="keyword">&gt;</span>(infile(<span class="stringliteral">&quot;SCM_log_scaling&quot;</span>, static_cast&lt;int&gt;(log_scaling[i]), i));
<a name="l00126"></a>00126   }
<a name="l00127"></a>00127 
<a name="l00128"></a>00128   <span class="comment">// Make sure this generates training parameters properly!</span>
<a name="l00129"></a>00129   <a class="code" href="classlibMesh_1_1RBBase.php#aab8ed17932e5a8eacaa00b093128d651">initialize_training_parameters</a>(mu_min_vector,
<a name="l00130"></a>00130                                  mu_max_vector,
<a name="l00131"></a>00131                                  n_SCM_training_samples,
<a name="l00132"></a>00132                                  log_scaling,
<a name="l00133"></a>00133                                  deterministic_training);
<a name="l00134"></a>00134 
<a name="l00135"></a>00135   <span class="comment">// Call the Parent&#39;s initialization routine once the parameters are all set.</span>
<a name="l00136"></a>00136   <a class="code" href="classlibMesh_1_1RBBase.php#a22845ff428edfd2a0716aaecdb3788b7">Parent::init_data</a>();
<a name="l00137"></a>00137 
<a name="l00138"></a>00138   <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; std::endl &lt;&lt; <span class="stringliteral">&quot;RBSCMSystem parameters:&quot;</span> &lt;&lt; std::endl;
<a name="l00139"></a>00139   <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;system name: &quot;</span> &lt;&lt; this-&gt;<a class="code" href="classlibMesh_1_1System.php#af80f6b2e508821ebd9c8fcb78d443f18">name</a>() &lt;&lt; std::endl;
<a name="l00140"></a>00140   <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Q_a: &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>() &lt;&lt; std::endl;
<a name="l00141"></a>00141   <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;SCM_eps: &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a4301d15802fbba97a768b978968afb41">get_SCM_eps</a>() &lt;&lt; std::endl;
<a name="l00142"></a>00142   <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;SCM_M: &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a8d829aba1d25af9b40a3eeb0418af191">get_SCM_M</a>() &lt;&lt; std::endl;
<a name="l00143"></a>00143   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_SCM_parameters; i++)
<a name="l00144"></a>00144   {
<a name="l00145"></a>00145     <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt;   <span class="stringliteral">&quot;SCM Parameter &quot;</span> &lt;&lt; i
<a name="l00146"></a>00146                  &lt;&lt; <span class="stringliteral">&quot;: Min = &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1RBBase.php#aaed8f1fe273692ff7cad1be03de720d0">get_parameter_min</a>(i)
<a name="l00147"></a>00147                  &lt;&lt; <span class="stringliteral">&quot;, Max = &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1RBBase.php#a711eff68113a6b4c6e491bef54e285fd">get_parameter_max</a>(i)
<a name="l00148"></a>00148                  &lt;&lt; <span class="stringliteral">&quot;, log scaling = &quot;</span> &lt;&lt; log_scaling[i] &lt;&lt; std::endl;
<a name="l00149"></a>00149   }
<a name="l00150"></a>00150   <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;n_training_samples: &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1RBBase.php#a584ecef007a7992b6317db58f857e9e0">get_n_training_samples</a>() &lt;&lt; std::endl;
<a name="l00151"></a>00151   <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;using deterministic training samples? &quot;</span> &lt;&lt; deterministic_training &lt;&lt; std::endl;
<a name="l00152"></a>00152   <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;initializing calN-dependent data structures &quot;</span>
<a name="l00153"></a>00153                &lt;&lt; <a class="code" href="classlibMesh_1_1RBBase.php#a11c4b80a15c0e9ea1d822f5e04545059">initialize_calN_dependent_data</a> &lt;&lt; std::endl;
<a name="l00154"></a>00154   <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; std::endl;
<a name="l00155"></a>00155 }
<a name="l00156"></a>00156 
<a name="l00157"></a><a class="code" href="classlibMesh_1_1RBSCMSystem.php#ace55884aa4081bb6d00ccec765db31e1">00157</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSCMSystem.php#ace55884aa4081bb6d00ccec765db31e1">RBSCMSystem::resize_SCM_vectors</a>()
<a name="l00158"></a>00158 {
<a name="l00159"></a>00159   <span class="comment">// Clear SCM data vectors</span>
<a name="l00160"></a>00160   <a class="code" href="classlibMesh_1_1RBSCMSystem.php#af64954db1af6eef59ad24ccecc960a89">B_min</a>.clear();
<a name="l00161"></a>00161   <a class="code" href="classlibMesh_1_1RBSCMSystem.php#aa4214d13d5b9c1ea21b544d261e39a79">B_max</a>.clear();
<a name="l00162"></a>00162   <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a2fb14e4c9d70dd1722635ab62bb72423">C_J</a>.clear();
<a name="l00163"></a>00163   <a class="code" href="classlibMesh_1_1RBSCMSystem.php#af66df67db4690fe68eb82028ee0fcf24">C_J_stability_vector</a>.clear();
<a name="l00164"></a>00164   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1RBSCMSystem.php#a105199f54a65f57e2c5e66de3ea07916">SCM_UB_vectors</a>.size(); i++)
<a name="l00165"></a>00165     <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a105199f54a65f57e2c5e66de3ea07916">SCM_UB_vectors</a>[i].<a class="code" href="classlibMesh_1_1RBSCMSystem.php#a8450f0e561356e2e86e30f0910b98bf7">clear</a>();
<a name="l00166"></a>00166   <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a105199f54a65f57e2c5e66de3ea07916">SCM_UB_vectors</a>.clear();
<a name="l00167"></a>00167 
<a name="l00168"></a>00168   <span class="comment">// Resize the bounding box vectors</span>
<a name="l00169"></a>00169   <a class="code" href="classlibMesh_1_1RBSCMSystem.php#af64954db1af6eef59ad24ccecc960a89">B_min</a>.resize(<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>());
<a name="l00170"></a>00170   <a class="code" href="classlibMesh_1_1RBSCMSystem.php#aa4214d13d5b9c1ea21b544d261e39a79">B_max</a>.resize(<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>());
<a name="l00171"></a>00171 }
<a name="l00172"></a>00172 
<a name="l00173"></a><a class="code" href="classlibMesh_1_1RBSCMSystem.php#a2b9680a829301afd6357b5550b685896">00173</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a2b9680a829301afd6357b5550b685896">RBSCMSystem::add_scaled_symm_Aq</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_a, <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> scalar)
<a name="l00174"></a>00174 {
<a name="l00175"></a>00175   START_LOG(<span class="stringliteral">&quot;add_scaled_symm_Aq()&quot;</span>, <span class="stringliteral">&quot;RBSCMSystem&quot;</span>);
<a name="l00176"></a>00176 
<a name="l00177"></a>00177   <span class="comment">// Load the operators from the RBSystem</span>
<a name="l00178"></a>00178   <a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es = this-&gt;<a class="code" href="classlibMesh_1_1System.php#ac5ca6b1f3adcfac56982982e90dc905b">get_equation_systems</a>();
<a name="l00179"></a>00179   <a class="code" href="classlibMesh_1_1RBSystem.php">RBSystem</a>&amp; rb_system = es.<a class="code" href="classlibMesh_1_1EquationSystems.php#a5dac23f839af25ce7dbf1fe9a6d4b67a">get_system</a>&lt;<a class="code" href="classlibMesh_1_1RBSystem.php">RBSystem</a>&gt;(<a class="code" href="classlibMesh_1_1RBSCMSystem.php#a3427a19ee940f3b5eb5a953c3a833e5a">RB_system_name</a>);
<a name="l00180"></a>00180 
<a name="l00181"></a>00181   rb_system.<a class="code" href="classlibMesh_1_1RBSystem.php#a7d2cb74519604f8392e318e1e9c17524">add_scaled_Aq</a>(scalar, q_a, <a class="code" href="classlibMesh_1_1EigenSystem.php#a01a29a78830ad7813cdf0f64997b586f">matrix_A</a>, <span class="keyword">true</span>);
<a name="l00182"></a>00182 
<a name="l00183"></a>00183   STOP_LOG(<span class="stringliteral">&quot;add_scaled_symm_Aq()&quot;</span>, <span class="stringliteral">&quot;RBSCMSystem&quot;</span>);
<a name="l00184"></a>00184 }
<a name="l00185"></a>00185 
<a name="l00186"></a><a class="code" href="classlibMesh_1_1RBSCMSystem.php#a59313b7794750bc37d2547f27aeaa82c">00186</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a59313b7794750bc37d2547f27aeaa82c">RBSCMSystem::solve</a>()
<a name="l00187"></a>00187 {
<a name="l00188"></a>00188   START_LOG(<span class="stringliteral">&quot;solve()&quot;</span>, <span class="stringliteral">&quot;RBSCMSystem&quot;</span>);
<a name="l00189"></a>00189 
<a name="l00190"></a>00190   <span class="comment">// Make sure we have initialized the non-Dirichlet DOFs</span>
<a name="l00191"></a>00191   libmesh_assert(!<a class="code" href="classlibMesh_1_1RBBase.php#a487a5ffe10788d69f9f5b218646fca6a">non_dirichlet_dofs_vector</a>.empty());
<a name="l00192"></a>00192 
<a name="l00193"></a>00193   <span class="comment">// Need to get a global copy of non_dirichlet_dofs_vector on all processors</span>
<a name="l00194"></a>00194   std::vector&lt;unsigned int&gt; global_non_dirichlet_dofs_vector = <a class="code" href="classlibMesh_1_1RBBase.php#a487a5ffe10788d69f9f5b218646fca6a">non_dirichlet_dofs_vector</a>;
<a name="l00195"></a>00195   <a class="code" href="namespacelibMesh_1_1Parallel.php#a5d83bd3061eee7fc9ec2c58427c67aef">Parallel::allgather</a>(global_non_dirichlet_dofs_vector);
<a name="l00196"></a>00196 
<a name="l00197"></a>00197   <a class="code" href="classlibMesh_1_1EigenSystem.php#a01a29a78830ad7813cdf0f64997b586f">matrix_A</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#ae7069ca3b5265f87438c1ffcce9470f5">create_submatrix</a>(*<a class="code" href="classlibMesh_1_1RBSCMSystem.php#a1d03aa7e464bf165ae772cfcaf4839d4">condensed_matrix_A</a>,
<a name="l00198"></a>00198                              <a class="code" href="classlibMesh_1_1RBBase.php#a487a5ffe10788d69f9f5b218646fca6a">non_dirichlet_dofs_vector</a>,
<a name="l00199"></a>00199                              global_non_dirichlet_dofs_vector);
<a name="l00200"></a>00200 
<a name="l00201"></a>00201   <a class="code" href="classlibMesh_1_1EigenSystem.php#a16b1c6094998ba06a32f5c965d0aee0b">matrix_B</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#ae7069ca3b5265f87438c1ffcce9470f5">create_submatrix</a>(*<a class="code" href="classlibMesh_1_1RBSCMSystem.php#aac7f1916613e1689148616706aa410b9">condensed_matrix_B</a>,
<a name="l00202"></a>00202                              <a class="code" href="classlibMesh_1_1RBBase.php#a487a5ffe10788d69f9f5b218646fca6a">non_dirichlet_dofs_vector</a>,
<a name="l00203"></a>00203                              global_non_dirichlet_dofs_vector);
<a name="l00204"></a>00204 
<a name="l00205"></a>00205   <span class="comment">// A reference to the EquationSystems</span>
<a name="l00206"></a>00206   <a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es = this-&gt;<a class="code" href="classlibMesh_1_1System.php#ac5ca6b1f3adcfac56982982e90dc905b">get_equation_systems</a>();
<a name="l00207"></a>00207 
<a name="l00208"></a>00208   <span class="comment">// check that necessary parameters have been set</span>
<a name="l00209"></a>00209   libmesh_assert (es.<a class="code" href="classlibMesh_1_1EquationSystems.php#a7c02be232f564967ca0804a7824adb53">parameters</a>.<a class="code" href="classlibMesh_1_1Parameters.php#a6ced71ca7796d8109dd9b62bd0e1139b">have_parameter</a>&lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&gt;(<span class="stringliteral">&quot;eigenpairs&quot;</span>));
<a name="l00210"></a>00210   libmesh_assert (es.<a class="code" href="classlibMesh_1_1EquationSystems.php#a7c02be232f564967ca0804a7824adb53">parameters</a>.<a class="code" href="classlibMesh_1_1Parameters.php#a6ced71ca7796d8109dd9b62bd0e1139b">have_parameter</a>&lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&gt;(<span class="stringliteral">&quot;basis vectors&quot;</span>));
<a name="l00211"></a>00211 
<a name="l00212"></a>00212   <span class="comment">// Get the tolerance for the solver and the maximum</span>
<a name="l00213"></a>00213   <span class="comment">// number of iterations. Here, we simply adopt the linear solver</span>
<a name="l00214"></a>00214   <span class="comment">// specific parameters.</span>
<a name="l00215"></a>00215   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> tol            =
<a name="l00216"></a>00216     es.<a class="code" href="classlibMesh_1_1EquationSystems.php#a7c02be232f564967ca0804a7824adb53">parameters</a>.<a class="code" href="classlibMesh_1_1Parameters.php#ac7fa2054ee32db2c3979d48bd2103f20">get</a>&lt;<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>&gt;(<span class="stringliteral">&quot;linear solver tolerance&quot;</span>);
<a name="l00217"></a>00217 
<a name="l00218"></a>00218   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> maxits =
<a name="l00219"></a>00219     es.<a class="code" href="classlibMesh_1_1EquationSystems.php#a7c02be232f564967ca0804a7824adb53">parameters</a>.<a class="code" href="classlibMesh_1_1Parameters.php#ac7fa2054ee32db2c3979d48bd2103f20">get</a>&lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&gt;(<span class="stringliteral">&quot;linear solver maximum iterations&quot;</span>);
<a name="l00220"></a>00220 
<a name="l00221"></a>00221   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nev    =
<a name="l00222"></a>00222     es.<a class="code" href="classlibMesh_1_1EquationSystems.php#a7c02be232f564967ca0804a7824adb53">parameters</a>.<a class="code" href="classlibMesh_1_1Parameters.php#ac7fa2054ee32db2c3979d48bd2103f20">get</a>&lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&gt;(<span class="stringliteral">&quot;eigenpairs&quot;</span>);
<a name="l00223"></a>00223 
<a name="l00224"></a>00224   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ncv    =
<a name="l00225"></a>00225     es.<a class="code" href="classlibMesh_1_1EquationSystems.php#a7c02be232f564967ca0804a7824adb53">parameters</a>.<a class="code" href="classlibMesh_1_1Parameters.php#ac7fa2054ee32db2c3979d48bd2103f20">get</a>&lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&gt;(<span class="stringliteral">&quot;basis vectors&quot;</span>);
<a name="l00226"></a>00226 
<a name="l00227"></a>00227   std::pair&lt;unsigned int, unsigned int&gt; solve_data;
<a name="l00228"></a>00228 
<a name="l00229"></a>00229   <span class="comment">// call the solver depending on the type of eigenproblem</span>
<a name="l00230"></a>00230   <span class="keywordflow">if</span> ( <a class="code" href="classlibMesh_1_1EigenSystem.php#aff9b2776cd721fc84ee71bb66b5d6f5b">generalized</a>() )
<a name="l00231"></a>00231     {
<a name="l00232"></a>00232       <span class="comment">//in case of a generalized eigenproblem</span>
<a name="l00233"></a>00233       solve_data = <a class="code" href="classlibMesh_1_1EigenSystem.php#aaee4d84c67c46084f350edd4d35d4887">eigen_solver</a>-&gt;solve_generalized
<a name="l00234"></a>00234         (*<a class="code" href="classlibMesh_1_1RBSCMSystem.php#a1d03aa7e464bf165ae772cfcaf4839d4">condensed_matrix_A</a>,*<a class="code" href="classlibMesh_1_1RBSCMSystem.php#aac7f1916613e1689148616706aa410b9">condensed_matrix_B</a>, nev, ncv, tol, maxits);
<a name="l00235"></a>00235     }
<a name="l00236"></a>00236 
<a name="l00237"></a>00237   <span class="keywordflow">else</span>
<a name="l00238"></a>00238     {
<a name="l00239"></a>00239       libmesh_assert (<a class="code" href="classlibMesh_1_1EigenSystem.php#a16b1c6094998ba06a32f5c965d0aee0b">matrix_B</a> == NULL);
<a name="l00240"></a>00240 
<a name="l00241"></a>00241       <span class="comment">//in case of a standard eigenproblem</span>
<a name="l00242"></a>00242       solve_data = <a class="code" href="classlibMesh_1_1EigenSystem.php#aaee4d84c67c46084f350edd4d35d4887">eigen_solver</a>-&gt;solve_standard (*<a class="code" href="classlibMesh_1_1RBSCMSystem.php#a1d03aa7e464bf165ae772cfcaf4839d4">condensed_matrix_A</a>, nev, ncv, tol, maxits);
<a name="l00243"></a>00243     }
<a name="l00244"></a>00244 
<a name="l00245"></a>00245   <a class="code" href="classlibMesh_1_1EigenSystem.php#a4b87a747126b87053026efe939ebc18b">set_n_converged</a>(solve_data.first);
<a name="l00246"></a>00246   <a class="code" href="classlibMesh_1_1EigenSystem.php#ae85415626f2d9b82b03788228be72edc">set_n_iterations</a>(solve_data.second);
<a name="l00247"></a>00247 
<a name="l00248"></a>00248   STOP_LOG(<span class="stringliteral">&quot;solve()&quot;</span>, <span class="stringliteral">&quot;RBSCMSystem&quot;</span>);
<a name="l00249"></a>00249 }
<a name="l00250"></a>00250 
<a name="l00251"></a>00251 
<a name="l00252"></a>00252 
<a name="l00253"></a><a class="code" href="classlibMesh_1_1RBSCMSystem.php#adcb36066d7ffea5fce8e9dd249dc1e39">00253</a> std::pair&lt;Real, Real&gt; <a class="code" href="classlibMesh_1_1RBSCMSystem.php#adcb36066d7ffea5fce8e9dd249dc1e39">RBSCMSystem::get_eigenpair</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)
<a name="l00254"></a>00254 {
<a name="l00255"></a>00255   START_LOG(<span class="stringliteral">&quot;get_eigenpair()&quot;</span>, <span class="stringliteral">&quot;RBSCMSystem&quot;</span>);
<a name="l00256"></a>00256 
<a name="l00257"></a>00257   <span class="comment">// This function assumes that condensed_solve has just been called.</span>
<a name="l00258"></a>00258   <span class="comment">// If this is not the case, then we will trip an asset in get_eigenpair</span>
<a name="l00259"></a>00259   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt; NumericVector&lt;Number&gt;</a> &gt; temp = <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;::build</a>();
<a name="l00260"></a>00260   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_local = <a class="code" href="classlibMesh_1_1RBBase.php#a487a5ffe10788d69f9f5b218646fca6a">non_dirichlet_dofs_vector</a>.size();
<a name="l00261"></a>00261   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n       = n_local;
<a name="l00262"></a>00262   <a class="code" href="namespacelibMesh_1_1Parallel.php#a32ab26117222089e6540e66b05c06b1b">Parallel::sum</a>(n);
<a name="l00263"></a>00263 
<a name="l00264"></a>00264   temp-&gt;init (n, n_local, <span class="keyword">false</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">libMeshEnums::PARALLEL</a>);
<a name="l00265"></a>00265 
<a name="l00266"></a>00266   std::pair&lt;Real, Real&gt; eval = <a class="code" href="classlibMesh_1_1EigenSystem.php#aaee4d84c67c46084f350edd4d35d4887">eigen_solver</a>-&gt;get_eigenpair (i, *temp);
<a name="l00267"></a>00267 
<a name="l00268"></a>00268   <span class="comment">// Now map temp to solution. Loop over local entries of non_dirichlet_dofs_vector</span>
<a name="l00269"></a>00269   this-&gt;<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;zero();
<a name="l00270"></a>00270   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1RBBase.php#a487a5ffe10788d69f9f5b218646fca6a">non_dirichlet_dofs_vector</a>.size(); i++)
<a name="l00271"></a>00271   {
<a name="l00272"></a>00272     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index = <a class="code" href="classlibMesh_1_1RBBase.php#a487a5ffe10788d69f9f5b218646fca6a">non_dirichlet_dofs_vector</a>[i];
<a name="l00273"></a>00273     <a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;set(index,(*temp)(temp-&gt;first_local_index()+i));
<a name="l00274"></a>00274   }
<a name="l00275"></a>00275 
<a name="l00276"></a>00276   <a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;close();
<a name="l00277"></a>00277   this-&gt;<a class="code" href="classlibMesh_1_1System.php#ab9d81ac9c1787c43fb87cf13d37741ee">update</a>();
<a name="l00278"></a>00278 
<a name="l00279"></a>00279   STOP_LOG(<span class="stringliteral">&quot;get_eigenpair()&quot;</span>, <span class="stringliteral">&quot;RBSCMSystem&quot;</span>);
<a name="l00280"></a>00280 
<a name="l00281"></a>00281   <span class="keywordflow">return</span> eval;
<a name="l00282"></a>00282 }
<a name="l00283"></a>00283 
<a name="l00284"></a><a class="code" href="classlibMesh_1_1RBSCMSystem.php#af7e4f77971d064fa4e614a8a098459af">00284</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSCMSystem.php#af7e4f77971d064fa4e614a8a098459af">RBSCMSystem::perform_SCM_greedy</a>()
<a name="l00285"></a>00285 {
<a name="l00286"></a>00286   START_LOG(<span class="stringliteral">&quot;perform_SCM_greedy()&quot;</span>, <span class="stringliteral">&quot;RBSCMSystem&quot;</span>);
<a name="l00287"></a>00287 
<a name="l00288"></a>00288   <span class="comment">// Copy the local parts of the Dirichlet and</span>
<a name="l00289"></a>00289   <span class="comment">// non-Dirichlet dofs lists over from</span>
<a name="l00290"></a>00290   <span class="comment">// the associated RBSystem</span>
<a name="l00291"></a>00291   <a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es = this-&gt;<a class="code" href="classlibMesh_1_1System.php#ac5ca6b1f3adcfac56982982e90dc905b">get_equation_systems</a>();
<a name="l00292"></a>00292   <a class="code" href="classlibMesh_1_1RBSystem.php">RBSystem</a>&amp; rb_system = es.<a class="code" href="classlibMesh_1_1EquationSystems.php#a5dac23f839af25ce7dbf1fe9a6d4b67a">get_system</a>&lt;<a class="code" href="classlibMesh_1_1RBSystem.php">RBSystem</a>&gt;(<a class="code" href="classlibMesh_1_1RBSCMSystem.php#a3427a19ee940f3b5eb5a953c3a833e5a">RB_system_name</a>);
<a name="l00293"></a>00293   this-&gt;<a class="code" href="classlibMesh_1_1RBBase.php#a487a5ffe10788d69f9f5b218646fca6a">non_dirichlet_dofs_vector</a> = rb_system.<a class="code" href="classlibMesh_1_1RBBase.php#a487a5ffe10788d69f9f5b218646fca6a">non_dirichlet_dofs_vector</a>;
<a name="l00294"></a>00294   this-&gt;<a class="code" href="classlibMesh_1_1RBBase.php#a1882c0df8f854a52376363461d402b76">global_dirichlet_dofs_set</a> = rb_system.<a class="code" href="classlibMesh_1_1RBBase.php#a1882c0df8f854a52376363461d402b76">global_dirichlet_dofs_set</a>;
<a name="l00295"></a>00295 
<a name="l00296"></a>00296   <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a7b2f05d31e5405d36969902f2f42107f">load_matrix_B</a>();
<a name="l00297"></a>00297 
<a name="l00298"></a>00298   <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a925a4611f5063d5de177d1357e162d00">attach_deflation_space</a>();
<a name="l00299"></a>00299 
<a name="l00300"></a>00300   <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a6904dbd9a7abb9edca262eb194c3d9ef">compute_SCM_bounding_box</a>();
<a name="l00301"></a>00301 
<a name="l00302"></a>00302   <span class="comment">// This loads the new parameter into current_parameters</span>
<a name="l00303"></a>00303   <a class="code" href="classlibMesh_1_1RBSCMSystem.php#ac45951587c7bb4a87a5e9cf63cfd14be">enrich_C_J</a>(0);
<a name="l00304"></a>00304 
<a name="l00305"></a>00305   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> SCM_iter=0;
<a name="l00306"></a>00306   <span class="keywordflow">while</span>(<span class="keyword">true</span>)
<a name="l00307"></a>00307   {
<a name="l00308"></a>00308     <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a52a04025004a11827804c7ac8053119d">evaluate_stability_constant</a>();
<a name="l00309"></a>00309 
<a name="l00310"></a>00310     std::pair&lt;unsigned int,Real&gt; SCM_error_pair = <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a7e6bc55d8a4a009a0c67aaea9e391028">compute_SCM_bounds_on_training_set</a>();
<a name="l00311"></a>00311 
<a name="l00312"></a>00312     <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;SCM iteration &quot;</span> &lt;&lt; SCM_iter
<a name="l00313"></a>00313                  &lt;&lt; <span class="stringliteral">&quot;, max_SCM_error = &quot;</span> &lt;&lt; SCM_error_pair.second &lt;&lt; std::endl;
<a name="l00314"></a>00314 
<a name="l00315"></a>00315     <span class="keywordflow">if</span>( SCM_error_pair.second &lt; <a class="code" href="classlibMesh_1_1RBSCMSystem.php#ab763cbcdecd8f0059f4a9431838a5488">SCM_eps</a> )
<a name="l00316"></a>00316     {
<a name="l00317"></a>00317       <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; std::endl &lt;&lt; <span class="stringliteral">&quot;SCM tolerance of &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1RBSCMSystem.php#ab763cbcdecd8f0059f4a9431838a5488">SCM_eps</a> &lt;&lt; <span class="stringliteral">&quot; reached.&quot;</span>
<a name="l00318"></a>00318                    &lt;&lt; std::endl &lt;&lt; std::endl;
<a name="l00319"></a>00319       <span class="keywordflow">break</span>;
<a name="l00320"></a>00320     }
<a name="l00321"></a>00321 
<a name="l00322"></a>00322     <span class="comment">// If we need another SCM iteration, then enrich C_J</span>
<a name="l00323"></a>00323     <a class="code" href="classlibMesh_1_1RBSCMSystem.php#ac45951587c7bb4a87a5e9cf63cfd14be">enrich_C_J</a>(SCM_error_pair.first);
<a name="l00324"></a>00324 
<a name="l00325"></a>00325     <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; std::endl &lt;&lt; <span class="stringliteral">&quot;-----------------------------------&quot;</span> &lt;&lt; std::endl &lt;&lt; std::endl;
<a name="l00326"></a>00326 
<a name="l00327"></a>00327     SCM_iter++;
<a name="l00328"></a>00328   }
<a name="l00329"></a>00329 
<a name="l00330"></a>00330   STOP_LOG(<span class="stringliteral">&quot;perform_SCM_greedy()&quot;</span>, <span class="stringliteral">&quot;RBSCMSystem&quot;</span>);
<a name="l00331"></a>00331 }
<a name="l00332"></a>00332 
<a name="l00333"></a><a class="code" href="classlibMesh_1_1RBSCMSystem.php#a6904dbd9a7abb9edca262eb194c3d9ef">00333</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a6904dbd9a7abb9edca262eb194c3d9ef">RBSCMSystem::compute_SCM_bounding_box</a>()
<a name="l00334"></a>00334 {
<a name="l00335"></a>00335   START_LOG(<span class="stringliteral">&quot;compute_SCM_bounding_box()&quot;</span>, <span class="stringliteral">&quot;RBSCMSystem&quot;</span>);
<a name="l00336"></a>00336 
<a name="l00337"></a>00337   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q=0; q&lt;<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>(); q++)
<a name="l00338"></a>00338   {
<a name="l00339"></a>00339     <a class="code" href="classlibMesh_1_1EigenSystem.php#a01a29a78830ad7813cdf0f64997b586f">matrix_A</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#a966e0a6479f33c2518937e7d0f54602f">zero</a>();
<a name="l00340"></a>00340     <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a2b9680a829301afd6357b5550b685896">add_scaled_symm_Aq</a>(q, 1.);
<a name="l00341"></a>00341 
<a name="l00342"></a>00342     <span class="comment">// Compute B_min(q)</span>
<a name="l00343"></a>00343     <a class="code" href="classlibMesh_1_1EigenSystem.php#aaee4d84c67c46084f350edd4d35d4887">eigen_solver</a>-&gt;set_position_of_spectrum(<a class="code" href="namespacelibMeshEnums.php#a0630b52d8fe07f56702ddb7c6ff14d84a70d88d6415d884726e778f256c886c66">SMALLEST_REAL</a>);
<a name="l00344"></a>00344     <a class="code" href="classlibMesh_1_1RBSCMSystem.php#ae9924e8acc75b6aa416212a9b851233f">set_eigensolver_properties</a>(q);
<a name="l00345"></a>00345 
<a name="l00346"></a>00346     <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a59313b7794750bc37d2547f27aeaa82c">solve</a>();
<a name="l00347"></a>00347     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nconv = <a class="code" href="classlibMesh_1_1EigenSystem.php#ab4c0a9337a8e0243e81fbafa043cb29f">get_n_converged</a>();
<a name="l00348"></a>00348     <span class="keywordflow">if</span> (nconv != 0)
<a name="l00349"></a>00349     {
<a name="l00350"></a>00350       std::pair&lt;Real, Real&gt; eval = <a class="code" href="classlibMesh_1_1RBSCMSystem.php#adcb36066d7ffea5fce8e9dd249dc1e39">get_eigenpair</a>(0);
<a name="l00351"></a>00351 
<a name="l00352"></a>00352       <span class="comment">// ensure that the eigenvalue is real</span>
<a name="l00353"></a>00353       libmesh_assert(eval.second &lt; TOLERANCE);
<a name="l00354"></a>00354 
<a name="l00355"></a>00355       <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a2a7aed900700d71cdf584c1717531196">set_B_min</a>(q, eval.first);
<a name="l00356"></a>00356       <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; std::endl &lt;&lt; <span class="stringliteral">&quot;B_min(&quot;</span>&lt;&lt;q&lt;&lt;<span class="stringliteral">&quot;) = &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1RBSCMSystem.php#aa8d858e6d9830e531faa23d09c262f98">get_B_min</a>(q) &lt;&lt; std::endl;
<a name="l00357"></a>00357     }
<a name="l00358"></a>00358     <span class="keywordflow">else</span>
<a name="l00359"></a>00359     {
<a name="l00360"></a>00360       <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Eigen solver for computing B_min did not converge&quot;</span> &lt;&lt; std::endl;
<a name="l00361"></a>00361       libmesh_error();
<a name="l00362"></a>00362     }
<a name="l00363"></a>00363 
<a name="l00364"></a>00364     <span class="comment">// Compute B_max(q)</span>
<a name="l00365"></a>00365     <a class="code" href="classlibMesh_1_1EigenSystem.php#aaee4d84c67c46084f350edd4d35d4887">eigen_solver</a>-&gt;set_position_of_spectrum(<a class="code" href="namespacelibMeshEnums.php#a0630b52d8fe07f56702ddb7c6ff14d84a1b94059b18d6e3e5dcdcd025a8c70e3c">LARGEST_REAL</a>);
<a name="l00366"></a>00366     <a class="code" href="classlibMesh_1_1RBSCMSystem.php#ae9924e8acc75b6aa416212a9b851233f">set_eigensolver_properties</a>(q);
<a name="l00367"></a>00367 
<a name="l00368"></a>00368     <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a59313b7794750bc37d2547f27aeaa82c">solve</a>();
<a name="l00369"></a>00369     nconv = <a class="code" href="classlibMesh_1_1EigenSystem.php#ab4c0a9337a8e0243e81fbafa043cb29f">get_n_converged</a>();
<a name="l00370"></a>00370     <span class="keywordflow">if</span> (nconv != 0)
<a name="l00371"></a>00371     {
<a name="l00372"></a>00372       std::pair&lt;Real, Real&gt; eval = <a class="code" href="classlibMesh_1_1RBSCMSystem.php#adcb36066d7ffea5fce8e9dd249dc1e39">get_eigenpair</a>(0);
<a name="l00373"></a>00373 
<a name="l00374"></a>00374       <span class="comment">// ensure that the eigenvalue is real</span>
<a name="l00375"></a>00375       libmesh_assert(eval.second &lt; TOLERANCE);
<a name="l00376"></a>00376 
<a name="l00377"></a>00377       <a class="code" href="classlibMesh_1_1RBSCMSystem.php#aae597bb05fcc74eed204d35dd3824775">set_B_max</a>(q,eval.first);
<a name="l00378"></a>00378       <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;B_max(&quot;</span>&lt;&lt;q&lt;&lt;<span class="stringliteral">&quot;) = &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1RBSCMSystem.php#af6e399c8666c527e73d7c5d4368fd7b7">get_B_max</a>(q) &lt;&lt; std::endl;
<a name="l00379"></a>00379     }
<a name="l00380"></a>00380     <span class="keywordflow">else</span>
<a name="l00381"></a>00381     {
<a name="l00382"></a>00382       <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Eigen solver for computing B_max did not converge&quot;</span> &lt;&lt; std::endl;
<a name="l00383"></a>00383       libmesh_error();
<a name="l00384"></a>00384     }
<a name="l00385"></a>00385   }
<a name="l00386"></a>00386 
<a name="l00387"></a>00387   STOP_LOG(<span class="stringliteral">&quot;compute_SCM_bounding_box()&quot;</span>, <span class="stringliteral">&quot;RBSCMSystem&quot;</span>);
<a name="l00388"></a>00388 }
<a name="l00389"></a>00389 
<a name="l00390"></a><a class="code" href="classlibMesh_1_1RBSCMSystem.php#a52a04025004a11827804c7ac8053119d">00390</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a52a04025004a11827804c7ac8053119d">RBSCMSystem::evaluate_stability_constant</a>()
<a name="l00391"></a>00391 {
<a name="l00392"></a>00392   START_LOG(<span class="stringliteral">&quot;evaluate_stability_constant()&quot;</span>, <span class="stringliteral">&quot;RBSCMSystem&quot;</span>);
<a name="l00393"></a>00393 
<a name="l00394"></a>00394   <span class="comment">// Get current index of C_J</span>
<a name="l00395"></a>00395   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j = <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a2fb14e4c9d70dd1722635ab62bb72423">C_J</a>.size()-1;
<a name="l00396"></a>00396 
<a name="l00397"></a>00397   <a class="code" href="classlibMesh_1_1EigenSystem.php#aaee4d84c67c46084f350edd4d35d4887">eigen_solver</a>-&gt;set_position_of_spectrum(<a class="code" href="namespacelibMeshEnums.php#a0630b52d8fe07f56702ddb7c6ff14d84a70d88d6415d884726e778f256c886c66">SMALLEST_REAL</a>);
<a name="l00398"></a>00398 
<a name="l00399"></a>00399   <span class="comment">// We assume B is set in system assembly</span>
<a name="l00400"></a>00400   <span class="comment">// For coercive problems, B is set to the inner product matrix</span>
<a name="l00401"></a>00401   <span class="comment">// For non-coercive time-dependent problems, B is set to the mass matrix</span>
<a name="l00402"></a>00402 
<a name="l00403"></a>00403   <span class="comment">// Set matrix A corresponding to mu_star</span>
<a name="l00404"></a>00404   <a class="code" href="classlibMesh_1_1EigenSystem.php#a01a29a78830ad7813cdf0f64997b586f">matrix_A</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#a966e0a6479f33c2518937e7d0f54602f">zero</a>();
<a name="l00405"></a>00405   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q=0; q&lt;<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>(); q++)
<a name="l00406"></a>00406   {
<a name="l00407"></a>00407     <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a2b9680a829301afd6357b5550b685896">add_scaled_symm_Aq</a>(q, <a class="code" href="classlibMesh_1_1RBBase.php#aeeb46ce2b390bf820f954976ee9da7ce">eval_theta_q_a</a>(q));
<a name="l00408"></a>00408   }
<a name="l00409"></a>00409 
<a name="l00410"></a>00410   <a class="code" href="classlibMesh_1_1RBSCMSystem.php#ae9924e8acc75b6aa416212a9b851233f">set_eigensolver_properties</a>(-1);
<a name="l00411"></a>00411   <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a59313b7794750bc37d2547f27aeaa82c">solve</a>();
<a name="l00412"></a>00412   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nconv = <a class="code" href="classlibMesh_1_1EigenSystem.php#ab4c0a9337a8e0243e81fbafa043cb29f">get_n_converged</a>();
<a name="l00413"></a>00413   <span class="keywordflow">if</span> (nconv != 0)
<a name="l00414"></a>00414   {
<a name="l00415"></a>00415     std::pair&lt;Real, Real&gt; eval = <a class="code" href="classlibMesh_1_1RBSCMSystem.php#adcb36066d7ffea5fce8e9dd249dc1e39">get_eigenpair</a>(0);
<a name="l00416"></a>00416 
<a name="l00417"></a>00417     <span class="comment">// ensure that the eigenvalue is real</span>
<a name="l00418"></a>00418     libmesh_assert(eval.second &lt; TOLERANCE);
<a name="l00419"></a>00419 
<a name="l00420"></a>00420     <span class="comment">// Store the coercivity constant corresponding to mu_star</span>
<a name="l00421"></a>00421     <a class="code" href="classlibMesh_1_1RBSCMSystem.php#ad51a3d4b20f6bf643b2339d34222c94b">set_C_J_stability_constraint</a>(j,eval.first);
<a name="l00422"></a>00422     <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; std::endl &lt;&lt; <span class="stringliteral">&quot;Stability constant for C_J(&quot;</span>&lt;&lt;j&lt;&lt;<span class="stringliteral">&quot;) = &quot;</span>
<a name="l00423"></a>00423                  &lt;&lt; <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a86b972c3767ce29c2205d52aa99b6137">get_C_J_stability_constraint</a>(j) &lt;&lt; std::endl &lt;&lt; std::endl;
<a name="l00424"></a>00424 
<a name="l00425"></a>00425     <span class="comment">// Compute and store the vector y = (y_1, \ldots, y_Q) for the</span>
<a name="l00426"></a>00426     <span class="comment">// eigenvector currently stored in eigen_system.solution.</span>
<a name="l00427"></a>00427     <span class="comment">// We use this later to compute the SCM upper bounds.</span>
<a name="l00428"></a>00428     <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> norm_B2 = <a class="code" href="namespacelibMesh.php#aea33cac176f18504c5c4078407aadbb7">libmesh_real</a>( <a class="code" href="classlibMesh_1_1RBSCMSystem.php#adb44280fac91598ee1d3068e2bbcc082">B_inner_product</a>(*<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>, *<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>) );
<a name="l00429"></a>00429 
<a name="l00430"></a>00430     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q=0; q&lt;<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>(); q++)
<a name="l00431"></a>00431     {
<a name="l00432"></a>00432       <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> norm_Aq2 = <a class="code" href="namespacelibMesh.php#aea33cac176f18504c5c4078407aadbb7">libmesh_real</a>( <a class="code" href="classlibMesh_1_1RBSCMSystem.php#aae9065f20c0bb7ab443d39ce8e14b73d">Aq_inner_product</a>(q, *<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>, *<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>) );
<a name="l00433"></a>00433 
<a name="l00434"></a>00434       <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a62609d8085599af5eb1da2c2ddc4e255">set_SCM_UB_vector</a>(j,q,norm_Aq2/norm_B2);
<a name="l00435"></a>00435     }
<a name="l00436"></a>00436   }
<a name="l00437"></a>00437   <span class="keywordflow">else</span>
<a name="l00438"></a>00438   {
<a name="l00439"></a>00439     <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error: Eigensolver did not converge in evaluate_stability_constant&quot;</span>
<a name="l00440"></a>00440                  &lt;&lt; std::endl;
<a name="l00441"></a>00441     libmesh_error();
<a name="l00442"></a>00442   }
<a name="l00443"></a>00443 
<a name="l00444"></a>00444   STOP_LOG(<span class="stringliteral">&quot;evaluate_stability_constant()&quot;</span>, <span class="stringliteral">&quot;RBSCMSystem&quot;</span>);
<a name="l00445"></a>00445 }
<a name="l00446"></a>00446 
<a name="l00447"></a><a class="code" href="classlibMesh_1_1RBSCMSystem.php#adb44280fac91598ee1d3068e2bbcc082">00447</a> <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> <a class="code" href="classlibMesh_1_1RBSCMSystem.php#adb44280fac91598ee1d3068e2bbcc082">RBSCMSystem::B_inner_product</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>&amp; v, <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>&amp; w)<span class="keyword"> const</span>
<a name="l00448"></a>00448 <span class="keyword"></span>{
<a name="l00449"></a>00449   <a class="code" href="classlibMesh_1_1EigenSystem.php#a16b1c6094998ba06a32f5c965d0aee0b">matrix_B</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#adaccc5857f1a5d5ca264ded0b8bfb986">vector_mult</a>(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>, w);
<a name="l00450"></a>00450 
<a name="l00451"></a>00451   <span class="keywordflow">return</span> v.<a class="code" href="classlibMesh_1_1NumericVector.php#a1f522c421b32b75ea4dc3de6d1a95000">dot</a>(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>);
<a name="l00452"></a>00452 }
<a name="l00453"></a>00453 
<a name="l00454"></a><a class="code" href="classlibMesh_1_1RBSCMSystem.php#aae9065f20c0bb7ab443d39ce8e14b73d">00454</a> <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> <a class="code" href="classlibMesh_1_1RBSCMSystem.php#aae9065f20c0bb7ab443d39ce8e14b73d">RBSCMSystem::Aq_inner_product</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q,
<a name="l00455"></a>00455                                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>&amp; v,
<a name="l00456"></a>00456                                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>&amp; w)
<a name="l00457"></a>00457 {
<a name="l00458"></a>00458   <span class="keywordflow">if</span>(q &gt;= <a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>())
<a name="l00459"></a>00459   {
<a name="l00460"></a>00460     <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error: We must have q &lt; Q_a in Aq_inner_product.&quot;</span>
<a name="l00461"></a>00461                  &lt;&lt; std::endl;
<a name="l00462"></a>00462     libmesh_error();
<a name="l00463"></a>00463   }
<a name="l00464"></a>00464 
<a name="l00465"></a>00465   <a class="code" href="classlibMesh_1_1EigenSystem.php#a01a29a78830ad7813cdf0f64997b586f">matrix_A</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#a966e0a6479f33c2518937e7d0f54602f">zero</a>();
<a name="l00466"></a>00466   <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a2b9680a829301afd6357b5550b685896">add_scaled_symm_Aq</a>(q, 1.);
<a name="l00467"></a>00467   <a class="code" href="classlibMesh_1_1EigenSystem.php#a01a29a78830ad7813cdf0f64997b586f">matrix_A</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#adaccc5857f1a5d5ca264ded0b8bfb986">vector_mult</a>(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>, w);
<a name="l00468"></a>00468 
<a name="l00469"></a>00469   <span class="keywordflow">return</span> v.<a class="code" href="classlibMesh_1_1NumericVector.php#a1f522c421b32b75ea4dc3de6d1a95000">dot</a>(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>);
<a name="l00470"></a>00470 }
<a name="l00471"></a>00471 
<a name="l00472"></a>00472 
<a name="l00473"></a><a class="code" href="classlibMesh_1_1RBSCMSystem.php#ad51a3d4b20f6bf643b2339d34222c94b">00473</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSCMSystem.php#ad51a3d4b20f6bf643b2339d34222c94b">RBSCMSystem::set_C_J_stability_constraint</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j, <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> stability_const_in)
<a name="l00474"></a>00474 {
<a name="l00475"></a>00475   <span class="keywordflow">if</span>(j &gt;= <a class="code" href="classlibMesh_1_1RBSCMSystem.php#af66df67db4690fe68eb82028ee0fcf24">C_J_stability_vector</a>.size())
<a name="l00476"></a>00476   {
<a name="l00477"></a>00477     <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error: Input parameter j is too large in set_C_J_stability_constraint.&quot;</span>;
<a name="l00478"></a>00478     libmesh_error();
<a name="l00479"></a>00479   }
<a name="l00480"></a>00480 
<a name="l00481"></a>00481   <span class="comment">// we assume that C_J_stability_vector is resized elsewhere</span>
<a name="l00482"></a>00482   <span class="comment">// to be the same size as C_J.</span>
<a name="l00483"></a>00483   libmesh_assert(<a class="code" href="classlibMesh_1_1RBSCMSystem.php#af66df67db4690fe68eb82028ee0fcf24">C_J_stability_vector</a>.size() == <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a2fb14e4c9d70dd1722635ab62bb72423">C_J</a>.size());
<a name="l00484"></a>00484 
<a name="l00485"></a>00485   <a class="code" href="classlibMesh_1_1RBSCMSystem.php#af66df67db4690fe68eb82028ee0fcf24">C_J_stability_vector</a>[j] = stability_const_in;
<a name="l00486"></a>00486 }
<a name="l00487"></a>00487 
<a name="l00488"></a><a class="code" href="classlibMesh_1_1RBSCMSystem.php#a86b972c3767ce29c2205d52aa99b6137">00488</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a86b972c3767ce29c2205d52aa99b6137">RBSCMSystem::get_C_J_stability_constraint</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j)<span class="keyword"> const</span>
<a name="l00489"></a>00489 <span class="keyword"></span>{
<a name="l00490"></a>00490   <span class="keywordflow">if</span>(j &gt;= <a class="code" href="classlibMesh_1_1RBSCMSystem.php#af66df67db4690fe68eb82028ee0fcf24">C_J_stability_vector</a>.size())
<a name="l00491"></a>00491   {
<a name="l00492"></a>00492     <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error: Input parameter j is too large in get_C_J_stability_constraint.&quot;</span>;
<a name="l00493"></a>00493     libmesh_error();
<a name="l00494"></a>00494   }
<a name="l00495"></a>00495 
<a name="l00496"></a>00496   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1RBSCMSystem.php#af66df67db4690fe68eb82028ee0fcf24">C_J_stability_vector</a>[j];
<a name="l00497"></a>00497 }
<a name="l00498"></a>00498 
<a name="l00499"></a><a class="code" href="classlibMesh_1_1RBSCMSystem.php#a62609d8085599af5eb1da2c2ddc4e255">00499</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a62609d8085599af5eb1da2c2ddc4e255">RBSCMSystem::set_SCM_UB_vector</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q, <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> y_q)
<a name="l00500"></a>00500 {
<a name="l00501"></a>00501   <span class="comment">// First make sure that j &lt;= J</span>
<a name="l00502"></a>00502   <span class="keywordflow">if</span>(j &gt;= <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a105199f54a65f57e2c5e66de3ea07916">SCM_UB_vectors</a>.size())
<a name="l00503"></a>00503   {
<a name="l00504"></a>00504     <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error: We must have j &lt; J in set_SCM_UB_vector.&quot;</span>;
<a name="l00505"></a>00505     libmesh_error();
<a name="l00506"></a>00506   }
<a name="l00507"></a>00507   <span class="comment">// Next make sure that q &lt;= Q_a or Q_a_hat</span>
<a name="l00508"></a>00508   <span class="keywordflow">if</span>(q &gt;= <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a105199f54a65f57e2c5e66de3ea07916">SCM_UB_vectors</a>[0].size())
<a name="l00509"></a>00509   {
<a name="l00510"></a>00510     <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error: q is too large in set_SCM_UB_vector.&quot;</span>
<a name="l00511"></a>00511                  &lt;&lt; std::endl;
<a name="l00512"></a>00512     libmesh_error();
<a name="l00513"></a>00513   }
<a name="l00514"></a>00514 
<a name="l00515"></a>00515   <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a105199f54a65f57e2c5e66de3ea07916">SCM_UB_vectors</a>[j][q] = y_q;
<a name="l00516"></a>00516 }
<a name="l00517"></a>00517 
<a name="l00518"></a><a class="code" href="classlibMesh_1_1RBSCMSystem.php#abf84d8ae05cd21fa26db5f08d8cabcd1">00518</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1RBSCMSystem.php#abf84d8ae05cd21fa26db5f08d8cabcd1">RBSCMSystem::get_SCM_UB_vector</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q)
<a name="l00519"></a>00519 {
<a name="l00520"></a>00520   <span class="comment">// First make sure that j &lt;= J</span>
<a name="l00521"></a>00521   <span class="keywordflow">if</span>(j &gt;= <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a105199f54a65f57e2c5e66de3ea07916">SCM_UB_vectors</a>.size())
<a name="l00522"></a>00522   {
<a name="l00523"></a>00523     <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error: We must have j &lt; J in get_SCM_UB_vector.&quot;</span>;
<a name="l00524"></a>00524     libmesh_error();
<a name="l00525"></a>00525   }
<a name="l00526"></a>00526   <span class="keywordflow">if</span>(q &gt;= <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a105199f54a65f57e2c5e66de3ea07916">SCM_UB_vectors</a>[0].size())
<a name="l00527"></a>00527   {
<a name="l00528"></a>00528     <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error: q is too large in get_SCM_UB_vector.&quot;</span>
<a name="l00529"></a>00529                  &lt;&lt; std::endl;
<a name="l00530"></a>00530     libmesh_error();
<a name="l00531"></a>00531   }
<a name="l00532"></a>00532 
<a name="l00533"></a>00533   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a105199f54a65f57e2c5e66de3ea07916">SCM_UB_vectors</a>[j][q];
<a name="l00534"></a>00534 }
<a name="l00535"></a>00535 
<a name="l00536"></a><a class="code" href="classlibMesh_1_1RBSCMSystem.php#ac45951587c7bb4a87a5e9cf63cfd14be">00536</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSCMSystem.php#ac45951587c7bb4a87a5e9cf63cfd14be">RBSCMSystem::enrich_C_J</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> new_C_J_index)
<a name="l00537"></a>00537 {
<a name="l00538"></a>00538   START_LOG(<span class="stringliteral">&quot;enrich_C_J()&quot;</span>, <span class="stringliteral">&quot;RBSCMSystem&quot;</span>);
<a name="l00539"></a>00539 
<a name="l00540"></a>00540   <a class="code" href="classlibMesh_1_1RBBase.php#a54e4e9c609bcf66c7a95a0307e6b5a78">load_training_parameter_globally</a>(new_C_J_index);
<a name="l00541"></a>00541 
<a name="l00542"></a>00542   <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a2fb14e4c9d70dd1722635ab62bb72423">C_J</a>.push_back(<a class="code" href="classlibMesh_1_1RBBase.php#af3bb451bd612eb5e7e8f0684f4b9cc97">get_current_parameters</a>());
<a name="l00543"></a>00543 
<a name="l00544"></a>00544   <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; std::endl &lt;&lt; <span class="stringliteral">&quot;SCM: Added mu = (&quot;</span>;
<a name="l00545"></a>00545   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1RBBase.php#a2c3f951cf69b5da83a67734be6b01972">get_n_params</a>(); i++)
<a name="l00546"></a>00546   {
<a name="l00547"></a>00547     <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a2fb14e4c9d70dd1722635ab62bb72423">C_J</a>[<a class="code" href="classlibMesh_1_1RBSCMSystem.php#a2fb14e4c9d70dd1722635ab62bb72423">C_J</a>.size()-1][i];
<a name="l00548"></a>00548     <span class="keywordflow">if</span>(i &lt; (<a class="code" href="classlibMesh_1_1RBBase.php#a2c3f951cf69b5da83a67734be6b01972">get_n_params</a>()-1)) <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;,&quot;</span>;
<a name="l00549"></a>00549   }
<a name="l00550"></a>00550   <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;)&quot;</span> &lt;&lt; std::endl;
<a name="l00551"></a>00551 
<a name="l00552"></a>00552   <span class="comment">// Finally, resize C_J_stability_vector and SCM_UB_vectors</span>
<a name="l00553"></a>00553   <a class="code" href="classlibMesh_1_1RBSCMSystem.php#af66df67db4690fe68eb82028ee0fcf24">C_J_stability_vector</a>.push_back(0.);
<a name="l00554"></a>00554 
<a name="l00555"></a>00555   std::vector&lt;Real&gt; zero_vector(<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>());
<a name="l00556"></a>00556   <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a105199f54a65f57e2c5e66de3ea07916">SCM_UB_vectors</a>.push_back(zero_vector);
<a name="l00557"></a>00557 
<a name="l00558"></a>00558   STOP_LOG(<span class="stringliteral">&quot;enrich_C_J()&quot;</span>, <span class="stringliteral">&quot;RBSCMSystem&quot;</span>);
<a name="l00559"></a>00559 }
<a name="l00560"></a>00560 
<a name="l00561"></a><a class="code" href="classlibMesh_1_1RBSCMSystem.php#a18a95164c4ef874dddb37d5ee7f68d15">00561</a> std::vector&lt;Real&gt; <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a18a95164c4ef874dddb37d5ee7f68d15">RBSCMSystem::get_C_J_entry</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j)
<a name="l00562"></a>00562 {
<a name="l00563"></a>00563   <span class="keywordflow">if</span>(j &gt;= <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a2fb14e4c9d70dd1722635ab62bb72423">C_J</a>.size())
<a name="l00564"></a>00564   {
<a name="l00565"></a>00565     <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error: Input parameter j is too large in get_C_J.&quot;</span>;
<a name="l00566"></a>00566     libmesh_error();
<a name="l00567"></a>00567   }
<a name="l00568"></a>00568 
<a name="l00569"></a>00569   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a2fb14e4c9d70dd1722635ab62bb72423">C_J</a>[j];
<a name="l00570"></a>00570 }
<a name="l00571"></a>00571 
<a name="l00572"></a><a class="code" href="classlibMesh_1_1RBSCMSystem.php#aa8d858e6d9830e531faa23d09c262f98">00572</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1RBSCMSystem.php#aa8d858e6d9830e531faa23d09c262f98">RBSCMSystem::get_B_min</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q)<span class="keyword"> const</span>
<a name="l00573"></a>00573 <span class="keyword"></span>{
<a name="l00574"></a>00574   <span class="keywordflow">if</span>(q &gt;= <a class="code" href="classlibMesh_1_1RBSCMSystem.php#af64954db1af6eef59ad24ccecc960a89">B_min</a>.size())
<a name="l00575"></a>00575   {
<a name="l00576"></a>00576     <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error: q is too large in get_B_min.&quot;</span>
<a name="l00577"></a>00577                  &lt;&lt; std::endl;
<a name="l00578"></a>00578     libmesh_error();
<a name="l00579"></a>00579   }
<a name="l00580"></a>00580 
<a name="l00581"></a>00581   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1RBSCMSystem.php#af64954db1af6eef59ad24ccecc960a89">B_min</a>[q];
<a name="l00582"></a>00582 }
<a name="l00583"></a>00583 
<a name="l00584"></a>00584 
<a name="l00585"></a><a class="code" href="classlibMesh_1_1RBSCMSystem.php#af6e399c8666c527e73d7c5d4368fd7b7">00585</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1RBSCMSystem.php#af6e399c8666c527e73d7c5d4368fd7b7">RBSCMSystem::get_B_max</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q)<span class="keyword"> const</span>
<a name="l00586"></a>00586 <span class="keyword"></span>{
<a name="l00587"></a>00587   <span class="keywordflow">if</span>(q &gt;= <a class="code" href="classlibMesh_1_1RBSCMSystem.php#aa4214d13d5b9c1ea21b544d261e39a79">B_max</a>.size())
<a name="l00588"></a>00588   {
<a name="l00589"></a>00589     <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error: q is too large in get_B_max.&quot;</span>
<a name="l00590"></a>00590                  &lt;&lt; std::endl;
<a name="l00591"></a>00591     libmesh_error();
<a name="l00592"></a>00592   }
<a name="l00593"></a>00593 
<a name="l00594"></a>00594   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1RBSCMSystem.php#aa4214d13d5b9c1ea21b544d261e39a79">B_max</a>[q];
<a name="l00595"></a>00595 }
<a name="l00596"></a>00596 
<a name="l00597"></a><a class="code" href="classlibMesh_1_1RBSCMSystem.php#a2a7aed900700d71cdf584c1717531196">00597</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a2a7aed900700d71cdf584c1717531196">RBSCMSystem::set_B_min</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q, <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> B_min_val)
<a name="l00598"></a>00598 {
<a name="l00599"></a>00599   <span class="keywordflow">if</span>(q &gt;= <a class="code" href="classlibMesh_1_1RBSCMSystem.php#af64954db1af6eef59ad24ccecc960a89">B_min</a>.size())
<a name="l00600"></a>00600   {
<a name="l00601"></a>00601     <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error: q is too large in set_B_min.&quot;</span>
<a name="l00602"></a>00602                  &lt;&lt; std::endl;
<a name="l00603"></a>00603     libmesh_error();
<a name="l00604"></a>00604   }
<a name="l00605"></a>00605 
<a name="l00606"></a>00606   <a class="code" href="classlibMesh_1_1RBSCMSystem.php#af64954db1af6eef59ad24ccecc960a89">B_min</a>[q] = B_min_val;
<a name="l00607"></a>00607 }
<a name="l00608"></a>00608 
<a name="l00609"></a><a class="code" href="classlibMesh_1_1RBSCMSystem.php#aae597bb05fcc74eed204d35dd3824775">00609</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSCMSystem.php#aae597bb05fcc74eed204d35dd3824775">RBSCMSystem::set_B_max</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q, <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> B_max_val)
<a name="l00610"></a>00610 {
<a name="l00611"></a>00611   <span class="keywordflow">if</span>(q &gt;= <a class="code" href="classlibMesh_1_1RBSCMSystem.php#aa4214d13d5b9c1ea21b544d261e39a79">B_max</a>.size())
<a name="l00612"></a>00612   {
<a name="l00613"></a>00613     <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error: q is too large in set_B_max.&quot;</span>
<a name="l00614"></a>00614                  &lt;&lt; std::endl;
<a name="l00615"></a>00615     libmesh_error();
<a name="l00616"></a>00616   }
<a name="l00617"></a>00617 
<a name="l00618"></a>00618   <a class="code" href="classlibMesh_1_1RBSCMSystem.php#aa4214d13d5b9c1ea21b544d261e39a79">B_max</a>[q] = B_max_val;
<a name="l00619"></a>00619 }
<a name="l00620"></a>00620 
<a name="l00621"></a><a class="code" href="classlibMesh_1_1RBSCMSystem.php#a7e6bc55d8a4a009a0c67aaea9e391028">00621</a> std::pair&lt;unsigned int,Real&gt; <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a7e6bc55d8a4a009a0c67aaea9e391028">RBSCMSystem::compute_SCM_bounds_on_training_set</a>()
<a name="l00622"></a>00622 {
<a name="l00623"></a>00623   START_LOG(<span class="stringliteral">&quot;compute_SCM_bounds_on_training_set()&quot;</span>, <span class="stringliteral">&quot;RBSCMSystem&quot;</span>);
<a name="l00624"></a>00624 
<a name="l00625"></a>00625   <span class="comment">// Now compute the maximum bound error over training_parameters</span>
<a name="l00626"></a>00626   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> new_C_J_index = 0;
<a name="l00627"></a>00627   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> max_SCM_error = 0.;
<a name="l00628"></a>00628 
<a name="l00629"></a>00629   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> first_index = <a class="code" href="classlibMesh_1_1RBBase.php#a12552cd94e8487531fc5b7d7d461fb84">get_first_local_training_index</a>();
<a name="l00630"></a>00630   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1RBBase.php#a9695753c1fd434bccef96e258c6d1a40">get_local_n_training_samples</a>(); i++)
<a name="l00631"></a>00631   {
<a name="l00632"></a>00632     <a class="code" href="classlibMesh_1_1RBBase.php#a0d982ba07d961cb438fa783bf17517e7">load_training_parameter_locally</a>(first_index+i);
<a name="l00633"></a>00633 
<a name="l00634"></a>00634     <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> LB = <a class="code" href="classlibMesh_1_1RBSCMSystem.php#aec9345df172fa49477f94c46d9d991a0">get_SCM_LB</a>();
<a name="l00635"></a>00635     <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> UB = <a class="code" href="classlibMesh_1_1RBSCMSystem.php#ab481b656b3310e857f2a51e3e3fff497">get_SCM_UB</a>();
<a name="l00636"></a>00636 
<a name="l00637"></a>00637     <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> error_i = <a class="code" href="classlibMesh_1_1RBSCMSystem.php#ab13ee120fe84658f078555fb8293bc98">SCM_greedy_error_indicator</a>(LB, UB);
<a name="l00638"></a>00638 
<a name="l00639"></a>00639     <span class="keywordflow">if</span>( error_i &gt; max_SCM_error )
<a name="l00640"></a>00640     {
<a name="l00641"></a>00641       max_SCM_error = error_i;
<a name="l00642"></a>00642       new_C_J_index = i;
<a name="l00643"></a>00643     }
<a name="l00644"></a>00644   }
<a name="l00645"></a>00645 
<a name="l00646"></a>00646   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> global_index = first_index + new_C_J_index;
<a name="l00647"></a>00647   std::pair&lt;unsigned int,Real&gt; error_pair(global_index, max_SCM_error);
<a name="l00648"></a>00648   <a class="code" href="classlibMesh_1_1RBBase.php#a3f96fa0d87fd3f4bc00af8b403650cb3">get_global_max_error_pair</a>(error_pair);
<a name="l00649"></a>00649 
<a name="l00650"></a>00650   STOP_LOG(<span class="stringliteral">&quot;compute_SCM_bounds_on_training_set()&quot;</span>, <span class="stringliteral">&quot;RBSCMSystem&quot;</span>);
<a name="l00651"></a>00651 
<a name="l00652"></a>00652   <span class="keywordflow">return</span> error_pair;
<a name="l00653"></a>00653 }
<a name="l00654"></a>00654 
<a name="l00655"></a><a class="code" href="classlibMesh_1_1RBSCMSystem.php#aec9345df172fa49477f94c46d9d991a0">00655</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1RBSCMSystem.php#aec9345df172fa49477f94c46d9d991a0">RBSCMSystem::get_SCM_LB</a>()
<a name="l00656"></a>00656 {
<a name="l00657"></a>00657   START_LOG(<span class="stringliteral">&quot;get_SCM_LB()&quot;</span>, <span class="stringliteral">&quot;RBSCMSystem&quot;</span>);
<a name="l00658"></a>00658 
<a name="l00659"></a>00659   <span class="comment">// Initialize the LP</span>
<a name="l00660"></a>00660   glp_prob *lp;
<a name="l00661"></a>00661   lp = glp_create_prob();
<a name="l00662"></a>00662   glp_set_obj_dir(lp,GLP_MIN);
<a name="l00663"></a>00663 
<a name="l00664"></a>00664   <span class="comment">// Add columns to the LP: corresponds to</span>
<a name="l00665"></a>00665   <span class="comment">// the variables y_1,...y_Q_a.</span>
<a name="l00666"></a>00666   <span class="comment">// These are the same for each \mu in the SCM</span>
<a name="l00667"></a>00667   <span class="comment">// training set, hence can do this up front.</span>
<a name="l00668"></a>00668   glp_add_cols(lp,<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>());
<a name="l00669"></a>00669 
<a name="l00670"></a>00670   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q=0; q&lt;<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>(); q++)
<a name="l00671"></a>00671     {
<a name="l00672"></a>00672       <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBSCMSystem.php#aa4214d13d5b9c1ea21b544d261e39a79">B_max</a>[q] &lt; <a class="code" href="classlibMesh_1_1RBSCMSystem.php#af64954db1af6eef59ad24ccecc960a89">B_min</a>[q]) <span class="comment">// Invalid bound, set as free variable</span>
<a name="l00673"></a>00673       {
<a name="l00674"></a>00674         <span class="comment">// GLPK indexing is not zero based!</span>
<a name="l00675"></a>00675         glp_set_col_bnds(lp, q+1, GLP_FR, 0., 0.);
<a name="l00676"></a>00676       }
<a name="l00677"></a>00677       <span class="keywordflow">else</span>
<a name="l00678"></a>00678       {
<a name="l00679"></a>00679         <span class="comment">// GLPK indexing is not zero based!</span>
<a name="l00680"></a>00680         glp_set_col_bnds(lp, q+1, GLP_DB, <a class="code" href="classlibMesh_1_1RBSCMSystem.php#af64954db1af6eef59ad24ccecc960a89">B_min</a>[q], <a class="code" href="classlibMesh_1_1RBSCMSystem.php#aa4214d13d5b9c1ea21b544d261e39a79">B_max</a>[q]);
<a name="l00681"></a>00681       }
<a name="l00682"></a>00682 
<a name="l00683"></a>00683       <span class="comment">// If B_max is not defined, just set lower bounds...</span>
<a name="l00684"></a>00684 <span class="comment">//       glp_set_col_bnds(lp, q+1, GLP_LO, B_min[q], 0.);</span>
<a name="l00685"></a>00685     }
<a name="l00686"></a>00686 
<a name="l00687"></a>00687 
<a name="l00688"></a>00688   <span class="comment">// Add rows to the LP: corresponds to the auxiliary</span>
<a name="l00689"></a>00689   <span class="comment">// variables that define the constraints at each</span>
<a name="l00690"></a>00690   <span class="comment">// mu \in C_J_M</span>
<a name="l00691"></a>00691   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_rows = ( <a class="code" href="classlibMesh_1_1RBSCMSystem.php#aae6b24b5d60fd24a348830c0b672659f">SCM_M</a> &lt; <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a2fb14e4c9d70dd1722635ab62bb72423">C_J</a>.size()) ? <a class="code" href="classlibMesh_1_1RBSCMSystem.php#aae6b24b5d60fd24a348830c0b672659f">SCM_M</a> : <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a2fb14e4c9d70dd1722635ab62bb72423">C_J</a>.size();
<a name="l00692"></a>00692   glp_add_rows(lp, n_rows);
<a name="l00693"></a>00693 
<a name="l00694"></a>00694   <span class="comment">// Find the distance between mu and each element of C_J</span>
<a name="l00695"></a>00695   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> J = <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a2fb14e4c9d70dd1722635ab62bb72423">C_J</a>.size();
<a name="l00696"></a>00696   std::vector&lt; std::pair&lt;Real,unsigned int&gt; &gt; dist_from_mu(J);
<a name="l00697"></a>00697   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;J; j++)
<a name="l00698"></a>00698   {
<a name="l00699"></a>00699     dist_from_mu[j].first  = <a class="code" href="classlibMesh_1_1RBSCMSystem.php#af00012168d7a147c3ee3a0deb030166c">param_dist</a>(<a class="code" href="classlibMesh_1_1RBBase.php#af3bb451bd612eb5e7e8f0684f4b9cc97">get_current_parameters</a>(), <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a2fb14e4c9d70dd1722635ab62bb72423">C_J</a>[j]);
<a name="l00700"></a>00700     dist_from_mu[j].second = j;
<a name="l00701"></a>00701   }
<a name="l00702"></a>00702 
<a name="l00703"></a>00703   <span class="comment">// Now put current_parameters in saved_parameters</span>
<a name="l00704"></a>00704   <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a213d1404621821585eeca3e60b71dda2">save_current_parameters</a>();
<a name="l00705"></a>00705 
<a name="l00706"></a>00706   <span class="comment">// Now sort dist_from_mu based on the first element of each pair,</span>
<a name="l00707"></a>00707   <span class="comment">// the first M elements of this sorted list give us C_J_M.</span>
<a name="l00708"></a>00708   <span class="comment">// We use the default &quot;less than&quot; operator for std::pair, which</span>
<a name="l00709"></a>00709   <span class="comment">// compares based on the first element (which is the dist for us)</span>
<a name="l00710"></a>00710   <span class="comment">// and if they&#39;re the same, then compares the second elements.</span>
<a name="l00711"></a>00711   std::sort( dist_from_mu.begin(), dist_from_mu.end() );
<a name="l00712"></a>00712 
<a name="l00713"></a>00713 
<a name="l00714"></a>00714   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> matrix_size = n_rows*<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>();
<a name="l00715"></a>00715   std::vector&lt;int&gt; ia(matrix_size+1);
<a name="l00716"></a>00716   std::vector&lt;int&gt; ja(matrix_size+1);
<a name="l00717"></a>00717   std::vector&lt;Real&gt; ar(matrix_size+1);
<a name="l00718"></a>00718   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> count=0;
<a name="l00719"></a>00719   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m=0; m&lt;n_rows; m++)
<a name="l00720"></a>00720   {
<a name="l00721"></a>00721     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> mu_index = dist_from_mu[m].second;
<a name="l00722"></a>00722     <a class="code" href="classlibMesh_1_1RBSCMSystem.php#af187e480f971ff7fc1ae862fd62f5d63">set_current_parameters_from_C_J</a>(mu_index);
<a name="l00723"></a>00723 
<a name="l00724"></a>00724     <span class="comment">// Set the lower bound on the auxiliary variable</span>
<a name="l00725"></a>00725     <span class="comment">// due to the stability constant at mu_index</span>
<a name="l00726"></a>00726     glp_set_row_bnds(lp, m+1, GLP_LO, <a class="code" href="classlibMesh_1_1RBSCMSystem.php#af66df67db4690fe68eb82028ee0fcf24">C_J_stability_vector</a>[mu_index], 0.);
<a name="l00727"></a>00727 
<a name="l00728"></a>00728     <span class="comment">// Now define the matrix that relates the y&#39;s</span>
<a name="l00729"></a>00729     <span class="comment">// to the auxiliary variables at the current</span>
<a name="l00730"></a>00730     <span class="comment">// value of mu.</span>
<a name="l00731"></a>00731     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q=0; q&lt;<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>(); q++)
<a name="l00732"></a>00732       {
<a name="l00733"></a>00733         count++;
<a name="l00734"></a>00734 
<a name="l00735"></a>00735         ia[count] = m+1;
<a name="l00736"></a>00736         ja[count] = q+1;
<a name="l00737"></a>00737         ar[count] = <a class="code" href="namespacelibMesh.php#aea33cac176f18504c5c4078407aadbb7">libmesh_real</a>( <a class="code" href="classlibMesh_1_1RBBase.php#aeeb46ce2b390bf820f954976ee9da7ce">eval_theta_q_a</a>(q) ); <span class="comment">// This can only handle Reals right now</span>
<a name="l00738"></a>00738       }
<a name="l00739"></a>00739   }
<a name="l00740"></a>00740   glp_load_matrix(lp, matrix_size, &amp;ia[0], &amp;ja[0], &amp;ar[0]);
<a name="l00741"></a>00741 
<a name="l00742"></a>00742   <span class="comment">// Now load the original parameters back into current_parameters</span>
<a name="l00743"></a>00743   <span class="comment">// in order to set the coefficients of the objective function</span>
<a name="l00744"></a>00744   <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a256ff6e79bd7bf85111f78aa703d1868">reload_current_parameters</a>();
<a name="l00745"></a>00745   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q=0; q&lt;<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>(); q++)
<a name="l00746"></a>00746     {
<a name="l00747"></a>00747       glp_set_obj_coef(lp,q+1, <a class="code" href="namespacelibMesh.php#aea33cac176f18504c5c4078407aadbb7">libmesh_real</a>( <a class="code" href="classlibMesh_1_1RBBase.php#aeeb46ce2b390bf820f954976ee9da7ce">eval_theta_q_a</a>(q) ) );
<a name="l00748"></a>00748     }
<a name="l00749"></a>00749 
<a name="l00750"></a>00750   <span class="comment">// Use this command to initialize the basis for the LP</span>
<a name="l00751"></a>00751   <span class="comment">// since default behavior is to use the basis from</span>
<a name="l00752"></a>00752   <span class="comment">// the previous solve, but that might become singular</span>
<a name="l00753"></a>00753   <span class="comment">// if we switch the order of constraints (as can</span>
<a name="l00754"></a>00754   <span class="comment">// happen when we generate a new C_J_M)</span>
<a name="l00755"></a>00755   lpx_cpx_basis(lp); <span class="comment">//glp_cpx_basis(lp);</span>
<a name="l00756"></a>00756 
<a name="l00757"></a>00757   glp_simplex(lp, NULL);
<a name="l00758"></a>00758 
<a name="l00759"></a>00759   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> min_J_obj = glp_get_obj_val(lp);
<a name="l00760"></a>00760 
<a name="l00761"></a>00761 <span class="comment">//   int simplex_status =  glp_get_status(lp);</span>
<a name="l00762"></a>00762 <span class="comment">//   if(simplex_status == GLP_UNBND)</span>
<a name="l00763"></a>00763 <span class="comment">//   {</span>
<a name="l00764"></a>00764 <span class="comment">//     libMesh::out &lt;&lt; &quot;Simplex method gave unbounded solution.&quot; &lt;&lt; std::endl;</span>
<a name="l00765"></a>00765 <span class="comment">//     min_J_obj = std::numeric_limits&lt;Real&gt;::quiet_NaN();</span>
<a name="l00766"></a>00766 <span class="comment">//   }</span>
<a name="l00767"></a>00767 <span class="comment">//   else</span>
<a name="l00768"></a>00768 <span class="comment">//   {</span>
<a name="l00769"></a>00769 <span class="comment">//     min_J_obj = glp_get_obj_val(lp);</span>
<a name="l00770"></a>00770 <span class="comment">//   }</span>
<a name="l00771"></a>00771 
<a name="l00772"></a>00772   <span class="comment">// Destroy the LP</span>
<a name="l00773"></a>00773   glp_delete_prob(lp);
<a name="l00774"></a>00774 
<a name="l00775"></a>00775   STOP_LOG(<span class="stringliteral">&quot;get_SCM_LB()&quot;</span>, <span class="stringliteral">&quot;RBSCMSystem&quot;</span>);
<a name="l00776"></a>00776 
<a name="l00777"></a>00777   <span class="keywordflow">return</span> min_J_obj;
<a name="l00778"></a>00778 }
<a name="l00779"></a>00779 
<a name="l00780"></a><a class="code" href="classlibMesh_1_1RBSCMSystem.php#ab481b656b3310e857f2a51e3e3fff497">00780</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1RBSCMSystem.php#ab481b656b3310e857f2a51e3e3fff497">RBSCMSystem::get_SCM_UB</a>()
<a name="l00781"></a>00781 {
<a name="l00782"></a>00782   START_LOG(<span class="stringliteral">&quot;get_SCM_UB()&quot;</span>, <span class="stringliteral">&quot;RBSCMSystem&quot;</span>);
<a name="l00783"></a>00783 
<a name="l00784"></a>00784   <span class="comment">// Add rows to the LP: corresponds to the auxiliary</span>
<a name="l00785"></a>00785   <span class="comment">// variables that define the constraints at each</span>
<a name="l00786"></a>00786   <span class="comment">// mu \in C_J_M</span>
<a name="l00787"></a>00787   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_rows = ( <a class="code" href="classlibMesh_1_1RBSCMSystem.php#aae6b24b5d60fd24a348830c0b672659f">SCM_M</a> &lt; <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a2fb14e4c9d70dd1722635ab62bb72423">C_J</a>.size()) ? <a class="code" href="classlibMesh_1_1RBSCMSystem.php#aae6b24b5d60fd24a348830c0b672659f">SCM_M</a> : <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a2fb14e4c9d70dd1722635ab62bb72423">C_J</a>.size();
<a name="l00788"></a>00788 
<a name="l00789"></a>00789   <span class="comment">// Find the distance between mu and each element of C_J</span>
<a name="l00790"></a>00790   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> J = <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a2fb14e4c9d70dd1722635ab62bb72423">C_J</a>.size();
<a name="l00791"></a>00791   std::vector&lt; std::pair&lt;Real,unsigned int&gt; &gt; dist_from_mu(J);
<a name="l00792"></a>00792   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;J; j++)
<a name="l00793"></a>00793   {
<a name="l00794"></a>00794     dist_from_mu[j].first  = <a class="code" href="classlibMesh_1_1RBSCMSystem.php#af00012168d7a147c3ee3a0deb030166c">param_dist</a>(<a class="code" href="classlibMesh_1_1RBBase.php#af3bb451bd612eb5e7e8f0684f4b9cc97">get_current_parameters</a>(), <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a2fb14e4c9d70dd1722635ab62bb72423">C_J</a>[j]);
<a name="l00795"></a>00795     dist_from_mu[j].second = j;
<a name="l00796"></a>00796   }
<a name="l00797"></a>00797 
<a name="l00798"></a>00798   <span class="comment">// Now sort dist_from_mu based on the first element of each pair,</span>
<a name="l00799"></a>00799   <span class="comment">// the first M elements of this sorted list give us C_J_M.</span>
<a name="l00800"></a>00800   <span class="comment">// We use the default &quot;less than&quot; operator for std::pair, which</span>
<a name="l00801"></a>00801   <span class="comment">// compares based on the first element (which is the dist for us)</span>
<a name="l00802"></a>00802   <span class="comment">// and if they&#39;re the same, then compares the second elements.</span>
<a name="l00803"></a>00803   std::sort( dist_from_mu.begin(), dist_from_mu.end() );
<a name="l00804"></a>00804 
<a name="l00805"></a>00805   <span class="comment">// For each mu, we just find the minimum of J_obj over</span>
<a name="l00806"></a>00806   <span class="comment">// the subset of vectors in SCM_UB_vectors corresponding</span>
<a name="l00807"></a>00807   <span class="comment">// to C_J_M (SCM_UB_vectors contains vectors for all of</span>
<a name="l00808"></a>00808   <span class="comment">// C_J).</span>
<a name="l00809"></a>00809   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> min_J_obj = 0.;
<a name="l00810"></a>00810   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m=0; m&lt;n_rows; m++)
<a name="l00811"></a>00811   {
<a name="l00812"></a>00812     <span class="comment">// This is the index from C_J of the \mu in C_J_M</span>
<a name="l00813"></a>00813     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> mu_index = dist_from_mu[m].second;
<a name="l00814"></a>00814 
<a name="l00815"></a>00815     <span class="keyword">const</span> std::vector&lt;Real&gt; UB_vector = <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a105199f54a65f57e2c5e66de3ea07916">SCM_UB_vectors</a>[mu_index];
<a name="l00816"></a>00816 
<a name="l00817"></a>00817     <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> J_obj = 0.;
<a name="l00818"></a>00818     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q=0; q&lt;<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>(); q++)
<a name="l00819"></a>00819       {
<a name="l00820"></a>00820         J_obj += <a class="code" href="namespacelibMesh.php#aea33cac176f18504c5c4078407aadbb7">libmesh_real</a>( <a class="code" href="classlibMesh_1_1RBBase.php#aeeb46ce2b390bf820f954976ee9da7ce">eval_theta_q_a</a>(q) )*UB_vector[q];
<a name="l00821"></a>00821       }
<a name="l00822"></a>00822 
<a name="l00823"></a>00823     <span class="keywordflow">if</span>( (m==0) || (J_obj &lt; min_J_obj) )
<a name="l00824"></a>00824     {
<a name="l00825"></a>00825       min_J_obj = J_obj;
<a name="l00826"></a>00826     }
<a name="l00827"></a>00827   }
<a name="l00828"></a>00828 
<a name="l00829"></a>00829   STOP_LOG(<span class="stringliteral">&quot;get_SCM_UB()&quot;</span>, <span class="stringliteral">&quot;RBSCMSystem&quot;</span>);
<a name="l00830"></a>00830 
<a name="l00831"></a>00831   <span class="keywordflow">return</span> min_J_obj;
<a name="l00832"></a>00832 }
<a name="l00833"></a>00833 
<a name="l00834"></a><a class="code" href="classlibMesh_1_1RBSCMSystem.php#af187e480f971ff7fc1ae862fd62f5d63">00834</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSCMSystem.php#af187e480f971ff7fc1ae862fd62f5d63">RBSCMSystem::set_current_parameters_from_C_J</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> C_J_index)
<a name="l00835"></a>00835 {
<a name="l00836"></a>00836   <a class="code" href="classlibMesh_1_1RBBase.php#a04037fe5c23e9d9e5652936888cb8f0f">set_current_parameters</a>(<a class="code" href="classlibMesh_1_1RBSCMSystem.php#a2fb14e4c9d70dd1722635ab62bb72423">C_J</a>[C_J_index]);
<a name="l00837"></a>00837 }
<a name="l00838"></a>00838 
<a name="l00839"></a><a class="code" href="classlibMesh_1_1RBSCMSystem.php#af00012168d7a147c3ee3a0deb030166c">00839</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1RBSCMSystem.php#af00012168d7a147c3ee3a0deb030166c">RBSCMSystem::param_dist</a>(<span class="keyword">const</span> std::vector&lt;Real&gt;&amp; mu_1, <span class="keyword">const</span> std::vector&lt;Real&gt;&amp; mu_2)
<a name="l00840"></a>00840 {
<a name="l00841"></a>00841   <span class="comment">// Default distance is Euclidean norm</span>
<a name="l00842"></a>00842   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="namespacelibMesh_1_1Parallel.php#a32ab26117222089e6540e66b05c06b1b">sum</a> = 0.;
<a name="l00843"></a>00843 
<a name="l00844"></a>00844   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1RBBase.php#a2c3f951cf69b5da83a67734be6b01972">get_n_params</a>(); i++)
<a name="l00845"></a>00845   {
<a name="l00846"></a>00846     sum += <a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">pow</a>(mu_1[i] - mu_2[i],2.);
<a name="l00847"></a>00847   }
<a name="l00848"></a>00848 
<a name="l00849"></a>00849   <span class="keywordflow">return</span> sqrt(sum);
<a name="l00850"></a>00850 }
<a name="l00851"></a>00851 
<a name="l00852"></a><a class="code" href="classlibMesh_1_1RBSCMSystem.php#a213d1404621821585eeca3e60b71dda2">00852</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a213d1404621821585eeca3e60b71dda2">RBSCMSystem::save_current_parameters</a>()
<a name="l00853"></a>00853 {
<a name="l00854"></a>00854   <a class="code" href="classlibMesh_1_1RBSCMSystem.php#afceae43f1ce47e81f9b17408b3d853f9">saved_parameters</a> = <a class="code" href="classlibMesh_1_1RBBase.php#a0d38b35c6ca90b64c8b4f63769d522e2">current_parameters</a>;
<a name="l00855"></a>00855 }
<a name="l00856"></a>00856 
<a name="l00857"></a><a class="code" href="classlibMesh_1_1RBSCMSystem.php#a256ff6e79bd7bf85111f78aa703d1868">00857</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a256ff6e79bd7bf85111f78aa703d1868">RBSCMSystem::reload_current_parameters</a>()
<a name="l00858"></a>00858 {
<a name="l00859"></a>00859   <a class="code" href="classlibMesh_1_1RBBase.php#a0d38b35c6ca90b64c8b4f63769d522e2">current_parameters</a> = <a class="code" href="classlibMesh_1_1RBSCMSystem.php#afceae43f1ce47e81f9b17408b3d853f9">saved_parameters</a>;
<a name="l00860"></a>00860 }
<a name="l00861"></a>00861 
<a name="l00862"></a><a class="code" href="classlibMesh_1_1RBSCMSystem.php#ad30371584074d6efd903cd311576c5f9">00862</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSCMSystem.php#ad30371584074d6efd903cd311576c5f9">RBSCMSystem::write_offline_data_to_files</a>(<span class="keyword">const</span> std::string&amp; directory_name)
<a name="l00863"></a>00863 {
<a name="l00864"></a>00864   START_LOG(<span class="stringliteral">&quot;write_offline_data_to_files()&quot;</span>, <span class="stringliteral">&quot;RBSCMSystem&quot;</span>);
<a name="l00865"></a>00865 
<a name="l00866"></a>00866   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> precision_level = 14;
<a name="l00867"></a>00867 
<a name="l00868"></a>00868   <span class="keywordflow">if</span>(<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l00869"></a>00869   {
<a name="l00870"></a>00870     <span class="comment">// Make a directory to store all the data files</span>
<a name="l00871"></a>00871     <span class="keywordflow">if</span>( mkdir(directory_name.c_str(), 0777) == -1)
<a name="l00872"></a>00872     {
<a name="l00873"></a>00873       <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;In RBSCMSystem::write_offline_data_to_files, directory &quot;</span>
<a name="l00874"></a>00874                    &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot; already exists, overwriting contents.&quot;</span> &lt;&lt; std::endl;
<a name="l00875"></a>00875     }
<a name="l00876"></a>00876 
<a name="l00877"></a>00877     <span class="comment">// Write out the bounding box min values</span>
<a name="l00878"></a>00878     std::ofstream B_min_out;
<a name="l00879"></a>00879     {
<a name="l00880"></a>00880       <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l00881"></a>00881       file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/B_min.dat&quot;</span>;
<a name="l00882"></a>00882       B_min_out.open(file_name.str().c_str());
<a name="l00883"></a>00883     }
<a name="l00884"></a>00884     <span class="keywordflow">if</span> ( !B_min_out.good() )
<a name="l00885"></a>00885     {
<a name="l00886"></a>00886       <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening B_min.dat&quot;</span> &lt;&lt; std::endl;
<a name="l00887"></a>00887       libmesh_error();
<a name="l00888"></a>00888     }
<a name="l00889"></a>00889     B_min_out.precision(precision_level);
<a name="l00890"></a>00890     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1RBSCMSystem.php#af64954db1af6eef59ad24ccecc960a89">B_min</a>.size(); i++)
<a name="l00891"></a>00891     {
<a name="l00892"></a>00892       B_min_out &lt;&lt; std::scientific &lt;&lt; <a class="code" href="classlibMesh_1_1RBSCMSystem.php#aa8d858e6d9830e531faa23d09c262f98">get_B_min</a>(i) &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l00893"></a>00893     }
<a name="l00894"></a>00894     B_min_out &lt;&lt; std::endl;
<a name="l00895"></a>00895     B_min_out.close();
<a name="l00896"></a>00896 
<a name="l00897"></a>00897 
<a name="l00898"></a>00898     <span class="comment">// Write out the bounding box max values</span>
<a name="l00899"></a>00899     std::ofstream B_max_out;
<a name="l00900"></a>00900     {
<a name="l00901"></a>00901       <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l00902"></a>00902       file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/B_max.dat&quot;</span>;
<a name="l00903"></a>00903       B_max_out.open(file_name.str().c_str());
<a name="l00904"></a>00904     }
<a name="l00905"></a>00905     <span class="keywordflow">if</span> ( !B_max_out.good() )
<a name="l00906"></a>00906     {
<a name="l00907"></a>00907       <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening B_max.dat&quot;</span> &lt;&lt; std::endl;
<a name="l00908"></a>00908       libmesh_error();
<a name="l00909"></a>00909     }
<a name="l00910"></a>00910     B_max_out.precision(precision_level);
<a name="l00911"></a>00911     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1RBSCMSystem.php#aa4214d13d5b9c1ea21b544d261e39a79">B_max</a>.size(); i++)
<a name="l00912"></a>00912     {
<a name="l00913"></a>00913       B_max_out &lt;&lt; std::scientific &lt;&lt; <a class="code" href="classlibMesh_1_1RBSCMSystem.php#af6e399c8666c527e73d7c5d4368fd7b7">get_B_max</a>(i) &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l00914"></a>00914     }
<a name="l00915"></a>00915     B_max_out &lt;&lt; std::endl;
<a name="l00916"></a>00916     B_max_out.close();
<a name="l00917"></a>00917 
<a name="l00918"></a>00918     <span class="comment">// Write out C_J_stability_vector</span>
<a name="l00919"></a>00919     std::ofstream C_J_stability_vector_out;
<a name="l00920"></a>00920     {
<a name="l00921"></a>00921       <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l00922"></a>00922       file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/C_J_stability_vector.dat&quot;</span>;
<a name="l00923"></a>00923       C_J_stability_vector_out.open(file_name.str().c_str());
<a name="l00924"></a>00924     }
<a name="l00925"></a>00925     <span class="keywordflow">if</span> ( !C_J_stability_vector_out.good() )
<a name="l00926"></a>00926     {
<a name="l00927"></a>00927       <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening C_J_stability_vector.dat&quot;</span> &lt;&lt; std::endl;
<a name="l00928"></a>00928       libmesh_error();
<a name="l00929"></a>00929     }
<a name="l00930"></a>00930     C_J_stability_vector_out.precision(precision_level);
<a name="l00931"></a>00931     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1RBSCMSystem.php#af66df67db4690fe68eb82028ee0fcf24">C_J_stability_vector</a>.size(); i++)
<a name="l00932"></a>00932     {
<a name="l00933"></a>00933       C_J_stability_vector_out &lt;&lt; std::scientific &lt;&lt; <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a86b972c3767ce29c2205d52aa99b6137">get_C_J_stability_constraint</a>(i) &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l00934"></a>00934     }
<a name="l00935"></a>00935     C_J_stability_vector_out &lt;&lt; std::endl;
<a name="l00936"></a>00936     C_J_stability_vector_out.close();
<a name="l00937"></a>00937 
<a name="l00938"></a>00938     <span class="comment">// Write out C_J</span>
<a name="l00939"></a>00939     std::ofstream C_J_out;
<a name="l00940"></a>00940     {
<a name="l00941"></a>00941       <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l00942"></a>00942       file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/C_J.dat&quot;</span>;
<a name="l00943"></a>00943       C_J_out.open(file_name.str().c_str());
<a name="l00944"></a>00944     }
<a name="l00945"></a>00945     <span class="keywordflow">if</span> ( !C_J_out.good() )
<a name="l00946"></a>00946     {
<a name="l00947"></a>00947       <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening C_J_out.dat&quot;</span> &lt;&lt; std::endl;
<a name="l00948"></a>00948       libmesh_error();
<a name="l00949"></a>00949     }
<a name="l00950"></a>00950     C_J_out.precision(precision_level);
<a name="l00951"></a>00951     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1RBSCMSystem.php#a2fb14e4c9d70dd1722635ab62bb72423">C_J</a>.size(); i++)
<a name="l00952"></a>00952     {
<a name="l00953"></a>00953       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;<a class="code" href="classlibMesh_1_1RBBase.php#a2c3f951cf69b5da83a67734be6b01972">get_n_params</a>(); j++)
<a name="l00954"></a>00954       {
<a name="l00955"></a>00955         C_J_out &lt;&lt; std::scientific &lt;&lt; <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a2fb14e4c9d70dd1722635ab62bb72423">C_J</a>[i][j] &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l00956"></a>00956       }
<a name="l00957"></a>00957     }
<a name="l00958"></a>00958     C_J_out &lt;&lt; std::endl;
<a name="l00959"></a>00959     C_J_out.close();
<a name="l00960"></a>00960 
<a name="l00961"></a>00961     <span class="comment">// Write out SCM_UB_vectors get_SCM_UB_vector</span>
<a name="l00962"></a>00962     std::ofstream SCM_UB_vectors_out;
<a name="l00963"></a>00963     {
<a name="l00964"></a>00964       <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l00965"></a>00965       file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/SCM_UB_vectors.dat&quot;</span>;
<a name="l00966"></a>00966       SCM_UB_vectors_out.open(file_name.str().c_str());
<a name="l00967"></a>00967     }
<a name="l00968"></a>00968     <span class="keywordflow">if</span> ( !SCM_UB_vectors_out.good() )
<a name="l00969"></a>00969     {
<a name="l00970"></a>00970       <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening SCM_UB_vectors.dat&quot;</span> &lt;&lt; std::endl;
<a name="l00971"></a>00971       libmesh_error();
<a name="l00972"></a>00972     }
<a name="l00973"></a>00973     SCM_UB_vectors_out.precision(precision_level);
<a name="l00974"></a>00974     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1RBSCMSystem.php#a105199f54a65f57e2c5e66de3ea07916">SCM_UB_vectors</a>.size(); i++)
<a name="l00975"></a>00975     {
<a name="l00976"></a>00976       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>(); j++)
<a name="l00977"></a>00977       {
<a name="l00978"></a>00978         SCM_UB_vectors_out &lt;&lt; std::scientific &lt;&lt; <a class="code" href="classlibMesh_1_1RBSCMSystem.php#abf84d8ae05cd21fa26db5f08d8cabcd1">get_SCM_UB_vector</a>(i,j) &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l00979"></a>00979       }
<a name="l00980"></a>00980     }
<a name="l00981"></a>00981     SCM_UB_vectors_out &lt;&lt; std::endl;
<a name="l00982"></a>00982     SCM_UB_vectors_out.close();
<a name="l00983"></a>00983   }
<a name="l00984"></a>00984 
<a name="l00985"></a>00985   STOP_LOG(<span class="stringliteral">&quot;write_offline_data_to_files()&quot;</span>, <span class="stringliteral">&quot;RBSCMSystem&quot;</span>);
<a name="l00986"></a>00986 }
<a name="l00987"></a>00987 
<a name="l00988"></a><a class="code" href="classlibMesh_1_1RBSCMSystem.php#a1fc44cbf71f7e98ba7fad0a3c0236c87">00988</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a1fc44cbf71f7e98ba7fad0a3c0236c87">RBSCMSystem::read_offline_data_from_files</a>(<span class="keyword">const</span> std::string&amp; directory_name)
<a name="l00989"></a>00989 {
<a name="l00990"></a>00990   START_LOG(<span class="stringliteral">&quot;read_offline_data_from_files()&quot;</span>, <span class="stringliteral">&quot;RBSCMSystem&quot;</span>);
<a name="l00991"></a>00991 
<a name="l00992"></a>00992   <span class="comment">// Read in the bounding box min values</span>
<a name="l00993"></a>00993   std::ifstream B_min_in;
<a name="l00994"></a>00994   {
<a name="l00995"></a>00995     <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l00996"></a>00996     file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/B_min.dat&quot;</span>;
<a name="l00997"></a>00997     B_min_in.open(file_name.str().c_str());
<a name="l00998"></a>00998   }
<a name="l00999"></a>00999   <span class="keywordflow">if</span> ( !B_min_in.good() )
<a name="l01000"></a>01000   {
<a name="l01001"></a>01001     <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening B_min.dat&quot;</span> &lt;&lt; std::endl;
<a name="l01002"></a>01002     libmesh_error();
<a name="l01003"></a>01003   }
<a name="l01004"></a>01004   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1RBSCMSystem.php#af64954db1af6eef59ad24ccecc960a89">B_min</a>.size(); i++)
<a name="l01005"></a>01005   {
<a name="l01006"></a>01006     B_min_in &gt;&gt; <a class="code" href="classlibMesh_1_1RBSCMSystem.php#af64954db1af6eef59ad24ccecc960a89">B_min</a>[i];
<a name="l01007"></a>01007   }
<a name="l01008"></a>01008   B_min_in.close();
<a name="l01009"></a>01009 
<a name="l01010"></a>01010 
<a name="l01011"></a>01011   <span class="comment">// Read in the bounding box max values</span>
<a name="l01012"></a>01012   std::ifstream B_max_in;
<a name="l01013"></a>01013   {
<a name="l01014"></a>01014     <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l01015"></a>01015     file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/B_max.dat&quot;</span>;
<a name="l01016"></a>01016     B_max_in.open(file_name.str().c_str());
<a name="l01017"></a>01017   }
<a name="l01018"></a>01018   <span class="keywordflow">if</span> ( !B_max_in.good() )
<a name="l01019"></a>01019   {
<a name="l01020"></a>01020     <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening B_max.dat&quot;</span> &lt;&lt; std::endl;
<a name="l01021"></a>01021     libmesh_error();
<a name="l01022"></a>01022   }
<a name="l01023"></a>01023   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1RBSCMSystem.php#aa4214d13d5b9c1ea21b544d261e39a79">B_max</a>.size(); i++)
<a name="l01024"></a>01024   {
<a name="l01025"></a>01025     B_max_in &gt;&gt; <a class="code" href="classlibMesh_1_1RBSCMSystem.php#aa4214d13d5b9c1ea21b544d261e39a79">B_max</a>[i];
<a name="l01026"></a>01026   }
<a name="l01027"></a>01027   B_max_in.close();
<a name="l01028"></a>01028 
<a name="l01029"></a>01029 
<a name="l01030"></a>01030   <span class="comment">// Read in C_J_stability_vector</span>
<a name="l01031"></a>01031   std::ifstream C_J_stability_vector_in;
<a name="l01032"></a>01032   {
<a name="l01033"></a>01033     <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l01034"></a>01034     file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/C_J_stability_vector.dat&quot;</span>;
<a name="l01035"></a>01035     C_J_stability_vector_in.open(file_name.str().c_str());
<a name="l01036"></a>01036   }
<a name="l01037"></a>01037   <span class="keywordflow">if</span> ( !C_J_stability_vector_in.good() )
<a name="l01038"></a>01038   {
<a name="l01039"></a>01039     <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening C_J_stability_vector.dat&quot;</span> &lt;&lt; std::endl;
<a name="l01040"></a>01040     libmesh_error();
<a name="l01041"></a>01041   }
<a name="l01042"></a>01042   <a class="code" href="classlibMesh_1_1RBSCMSystem.php#af66df67db4690fe68eb82028ee0fcf24">C_J_stability_vector</a>.clear();
<a name="l01043"></a>01043   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> C_J_stability_val;
<a name="l01044"></a>01044   <span class="keywordflow">while</span>( C_J_stability_vector_in &gt;&gt; C_J_stability_val )
<a name="l01045"></a>01045   {
<a name="l01046"></a>01046     <a class="code" href="classlibMesh_1_1RBSCMSystem.php#af66df67db4690fe68eb82028ee0fcf24">C_J_stability_vector</a>.push_back(C_J_stability_val);
<a name="l01047"></a>01047   }
<a name="l01048"></a>01048   C_J_stability_vector_in.close();
<a name="l01049"></a>01049 
<a name="l01050"></a>01050   <span class="comment">// Read in C_J</span>
<a name="l01051"></a>01051   std::ifstream C_J_in;
<a name="l01052"></a>01052   {
<a name="l01053"></a>01053     <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l01054"></a>01054     file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/C_J.dat&quot;</span>;
<a name="l01055"></a>01055     C_J_in.open(file_name.str().c_str());
<a name="l01056"></a>01056   }
<a name="l01057"></a>01057   <span class="keywordflow">if</span> ( !C_J_in.good() )
<a name="l01058"></a>01058   {
<a name="l01059"></a>01059     <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening C_J_in.dat&quot;</span> &lt;&lt; std::endl;
<a name="l01060"></a>01060     libmesh_error();
<a name="l01061"></a>01061   }
<a name="l01062"></a>01062   <span class="comment">// Resize C_J based on C_J_stability_vector and Q_a</span>
<a name="l01063"></a>01063   <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a2fb14e4c9d70dd1722635ab62bb72423">C_J</a>.resize( <a class="code" href="classlibMesh_1_1RBSCMSystem.php#af66df67db4690fe68eb82028ee0fcf24">C_J_stability_vector</a>.size() );
<a name="l01064"></a>01064   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1RBSCMSystem.php#a2fb14e4c9d70dd1722635ab62bb72423">C_J</a>.size(); i++)
<a name="l01065"></a>01065   {
<a name="l01066"></a>01066     <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a2fb14e4c9d70dd1722635ab62bb72423">C_J</a>[i].resize(<a class="code" href="classlibMesh_1_1RBBase.php#a2c3f951cf69b5da83a67734be6b01972">get_n_params</a>());
<a name="l01067"></a>01067     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;<a class="code" href="classlibMesh_1_1RBBase.php#a2c3f951cf69b5da83a67734be6b01972">get_n_params</a>(); j++)
<a name="l01068"></a>01068     {
<a name="l01069"></a>01069       C_J_in &gt;&gt; <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a2fb14e4c9d70dd1722635ab62bb72423">C_J</a>[i][j];
<a name="l01070"></a>01070     }
<a name="l01071"></a>01071   }
<a name="l01072"></a>01072   C_J_in.close();
<a name="l01073"></a>01073 
<a name="l01074"></a>01074 
<a name="l01075"></a>01075   <span class="comment">// Read in SCM_UB_vectors get_SCM_UB_vector</span>
<a name="l01076"></a>01076   std::ifstream SCM_UB_vectors_in;
<a name="l01077"></a>01077   {
<a name="l01078"></a>01078     <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l01079"></a>01079     file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/SCM_UB_vectors.dat&quot;</span>;
<a name="l01080"></a>01080     SCM_UB_vectors_in.open(file_name.str().c_str());
<a name="l01081"></a>01081   }
<a name="l01082"></a>01082   <span class="keywordflow">if</span> ( !SCM_UB_vectors_in.good() )
<a name="l01083"></a>01083   {
<a name="l01084"></a>01084     <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening SCM_UB_vectors.dat&quot;</span> &lt;&lt; std::endl;
<a name="l01085"></a>01085     libmesh_error();
<a name="l01086"></a>01086   }
<a name="l01087"></a>01087   <span class="comment">// Resize SCM_UB_vectors based on C_J_stability_vector and Q_a</span>
<a name="l01088"></a>01088   <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a105199f54a65f57e2c5e66de3ea07916">SCM_UB_vectors</a>.resize( <a class="code" href="classlibMesh_1_1RBSCMSystem.php#af66df67db4690fe68eb82028ee0fcf24">C_J_stability_vector</a>.size() );
<a name="l01089"></a>01089   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1RBSCMSystem.php#a105199f54a65f57e2c5e66de3ea07916">SCM_UB_vectors</a>.size(); i++)
<a name="l01090"></a>01090   {
<a name="l01091"></a>01091     <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a105199f54a65f57e2c5e66de3ea07916">SCM_UB_vectors</a>[i].resize( <a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>() );
<a name="l01092"></a>01092     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>(); j++)
<a name="l01093"></a>01093     {
<a name="l01094"></a>01094       SCM_UB_vectors_in &gt;&gt; <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a105199f54a65f57e2c5e66de3ea07916">SCM_UB_vectors</a>[i][j];
<a name="l01095"></a>01095     }
<a name="l01096"></a>01096   }
<a name="l01097"></a>01097   SCM_UB_vectors_in.close();
<a name="l01098"></a>01098 
<a name="l01099"></a>01099   STOP_LOG(<span class="stringliteral">&quot;read_offline_data_from_files()&quot;</span>, <span class="stringliteral">&quot;RBSCMSystem&quot;</span>);
<a name="l01100"></a>01100 }
<a name="l01101"></a>01101 
<a name="l01102"></a>01102 } <span class="comment">// namespace libMesh</span>
<a name="l01103"></a>01103 
<a name="l01104"></a>01104 <span class="preprocessor">#endif // LIBMESH_HAVE_SLEPC &amp;&amp; LIBMESH_HAVE_GLPK</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
