<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_eaf30c8ea092d33f79a04353c3899c3f.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_5a0c7151fa56969ceb962f1511f7edee.php">systems</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">rb_system.h</div>  </div>
</div>
<div class="contents">
<a href="rb__system_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// rbOOmit: An implementation of the Certified Reduced Basis method.</span>
<a name="l00002"></a>00002 <span class="comment">// Copyright (C) 2009, 2010 David J. Knezevic</span>
<a name="l00003"></a>00003 
<a name="l00004"></a>00004 <span class="comment">// This file is part of rbOOmit.</span>
<a name="l00005"></a>00005 
<a name="l00006"></a>00006 <span class="comment">// rbOOmit is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// rbOOmit is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="preprocessor">#ifndef __rb_system_h__</span>
<a name="l00021"></a>00021 <span class="preprocessor"></span><span class="preprocessor">#define __rb_system_h__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;<a class="code" href="linear__implicit__system_8h.php">linear_implicit_system.h</a>&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="code" href="dense__vector_8h.php">dense_vector.h</a>&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="dense__matrix_8h.php">dense_matrix.h</a>&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="rb__base_8h.php">rb_base.h</a>&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="fem__context_8h.php">fem_context.h</a>&quot;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="keyword">namespace </span>libMesh
<a name="l00030"></a>00030 {
<a name="l00031"></a>00031 
<a name="l00045"></a><a class="code" href="namespacelibMesh.php#a18a170af3a9d5eff6f43eb3409d0e296">00045</a> <span class="keyword">typedef</span> void (*<a class="code" href="namespacelibMesh.php#a18a170af3a9d5eff6f43eb3409d0e296">affine_assembly_fptr</a>)(<a class="code" href="classlibMesh_1_1FEMContext.php">FEMContext</a>&amp;, <a class="code" href="classlibMesh_1_1System.php">System</a>&amp;);
<a name="l00046"></a>00046 
<a name="l00052"></a><a class="code" href="namespacelibMesh.php#a81103ec3bcd9ba1f89f544623d5b7318">00052</a> <span class="keyword">typedef</span> void (*<a class="code" href="namespacelibMesh.php#a81103ec3bcd9ba1f89f544623d5b7318">dirichlet_list_fptr</a>)(<a class="code" href="classlibMesh_1_1FEMContext.php">FEMContext</a>&amp;, <a class="code" href="classlibMesh_1_1System.php">System</a>&amp;, std::set&lt;unsigned int&gt;&amp;);
<a name="l00053"></a>00053 
<a name="l00054"></a>00054 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00055"></a>00055 <span class="comment">// RBSystem class definition</span>
<a name="l00056"></a>00056 
<a name="l00057"></a><a class="code" href="classlibMesh_1_1RBSystem.php">00057</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1RBSystem.php">RBSystem</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1RBBase.php">RBBase</a>&lt;LinearImplicitSystem&gt;
<a name="l00058"></a>00058 {
<a name="l00059"></a>00059 <span class="keyword">public</span>:
<a name="l00060"></a>00060 
<a name="l00065"></a>00065   <a class="code" href="classlibMesh_1_1RBSystem.php#a8f0b6f6507452d097f4c98e98ed49ecf">RBSystem</a> (<a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00066"></a>00066             <span class="keyword">const</span> std::string&amp; <a class="code" href="classlibMesh_1_1System.php#af80f6b2e508821ebd9c8fcb78d443f18">name</a>,
<a name="l00067"></a>00067             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#aee5caacb487b070842733f1c84b9a2fd">number</a>);
<a name="l00068"></a>00068 
<a name="l00072"></a>00072   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1RBSystem.php#ace52091502758766654923323e89e66e">~RBSystem</a> ();
<a name="l00073"></a>00073 
<a name="l00077"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a878915c13cc8f3971f504b32b04055ad">00077</a>   <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1RBSystem.php">RBSystem</a> <a class="code" href="classlibMesh_1_1RBSystem.php#a878915c13cc8f3971f504b32b04055ad">sys_type</a>;
<a name="l00078"></a>00078 
<a name="l00082"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a6b0991d8d341b25a9e311cbc4ae5b569">00082</a>   <a class="code" href="classlibMesh_1_1ExplicitSystem.php">sys_type</a> &amp; <a class="code" href="classlibMesh_1_1RBSystem.php#a6b0991d8d341b25a9e311cbc4ae5b569">system</a> () { <span class="keywordflow">return</span> *<span class="keyword">this</span>; }
<a name="l00083"></a>00083 
<a name="l00087"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a1487ed2f96c2dbb400d41bc0f32ded96">00087</a>   <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1RBBase.php">RBBase&lt;LinearImplicitSystem&gt;</a> <a class="code" href="classlibMesh_1_1RBSystem.php#a1487ed2f96c2dbb400d41bc0f32ded96">Parent</a>;
<a name="l00088"></a>00088 
<a name="l00093"></a>00093   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#ad9de9f8d888f8b9072402b5fe656a30d">clear</a> ();
<a name="l00094"></a>00094 
<a name="l00098"></a>00098   <span class="keyword">virtual</span> std::string <a class="code" href="classlibMesh_1_1RBSystem.php#a6e385de97a2d50358ef9cc4ff0f11e53">system_type</a> () <span class="keyword">const</span>;
<a name="l00099"></a>00099 
<a name="l00104"></a>00104   <span class="keyword">virtual</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1RBSystem.php#af57b8bd010cb9280eb9d295e8a63cffe">RB_solve</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N);
<a name="l00105"></a>00105 
<a name="l00112"></a>00112   <span class="keyword">virtual</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1RBSystem.php#a6e3df26cf5cd4b4343483129a3d958df">truth_solve</a>(<span class="keywordtype">int</span> plot_solution);
<a name="l00113"></a>00113 
<a name="l00125"></a>00125   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1RBSystem.php#aa4881a599b045f666d63f824e86b5054">train_reduced_basis</a>(<span class="keyword">const</span> std::string&amp; directory_name = <span class="stringliteral">&quot;offline_data&quot;</span>);
<a name="l00126"></a>00126 
<a name="l00132"></a>00132   <span class="keyword">virtual</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1RBSystem.php#a798528f51e8a431936d4262778218067">compute_max_error_bound</a>();
<a name="l00133"></a>00133 
<a name="l00138"></a>00138   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#ad611f694e8d504268b101ea3266b590f">clear_basis_function_dependent_data</a>();
<a name="l00139"></a>00139 
<a name="l00144"></a>00144   std::vector&lt;Real&gt; <a class="code" href="classlibMesh_1_1RBSystem.php#aa30b66f0a86c1c1b58216db87022766c">get_greedy_parameter</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i);
<a name="l00145"></a>00145 
<a name="l00149"></a>00149   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a6d4f87f01e24e2dfa0a8b44314707116">set_eigen_system_name</a>(<span class="keyword">const</span> std::string&amp; name);
<a name="l00150"></a>00150 
<a name="l00154"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a3178424e9ea7e39bdf7f4db2404c9eba">00154</a>   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a3178424e9ea7e39bdf7f4db2404c9eba">set_training_tolerance</a>(<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1RBSystem.php#a56a24996be9d774563f1a8e6165ed038">training_tolerance</a>)
<a name="l00155"></a>00155     {this-&gt;training_tolerance = <a class="code" href="classlibMesh_1_1RBSystem.php#a56a24996be9d774563f1a8e6165ed038">training_tolerance</a>; }
<a name="l00156"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a8166ac1af73cc69a154ff5a65ed9e959">00156</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1RBSystem.php#a8166ac1af73cc69a154ff5a65ed9e959">get_training_tolerance</a>() { <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a56a24996be9d774563f1a8e6165ed038">training_tolerance</a>; }
<a name="l00157"></a>00157 
<a name="l00162"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a5acee637ff70dd65ec54de29241f0627">00162</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a5acee637ff70dd65ec54de29241f0627">get_Nmax</a>()<span class="keyword"> const    </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1RBSystem.php#ab47d6a963c4f68b5a3d1eea7905257f5">Nmax</a>; }
<a name="l00163"></a>00163   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a0eedc533ec1db115433f692dbcd33e1f">set_Nmax</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1RBSystem.php#ab47d6a963c4f68b5a3d1eea7905257f5">Nmax</a>);
<a name="l00164"></a>00164 
<a name="l00169"></a><a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">00169</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1RBSystem.php#acc90dcf523c055fc294bc71b67dfe876">theta_q_f_vector</a>.size() + <a class="code" href="classlibMesh_1_1RBSystem.php#a8d33ac93600827567a3c5fd0b7c5741c">get_n_F_EIM_functions</a>(); }
<a name="l00170"></a>00170 
<a name="l00175"></a>00175   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1RBSystem.php#ac1e04bfe35245ea3e225fc5865621fb0">get_n_F_EIM_systems</a>() <span class="keyword">const</span>;
<a name="l00176"></a>00176 
<a name="l00180"></a>00180   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a8d33ac93600827567a3c5fd0b7c5741c">get_n_F_EIM_functions</a>() <span class="keyword">const</span>;
<a name="l00181"></a>00181 
<a name="l00185"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a80b9e06a7c60b3bb2f5870b0ff66a2ca">00185</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a80b9e06a7c60b3bb2f5870b0ff66a2ca">get_n_outputs</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a1fa2b8ea817cae06f0d2e0bdbdd8b273">theta_q_l_vector</a>.size(); }
<a name="l00186"></a>00186   
<a name="l00190"></a>00190   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1RBSystem.php#ab7f0b2268a9716189225e0446b519911">get_Q_l</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> output_index) <span class="keyword">const</span>;
<a name="l00191"></a>00191 
<a name="l00197"></a><a class="code" href="classlibMesh_1_1RBSystem.php#afdb77262c71be7af51003d99c92bc2f9">00197</a>   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#afdb77262c71be7af51003d99c92bc2f9">set_quiet</a>(<span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1RBSystem.php#adec856bc209f0533639d76767bd5ebbc">quiet</a>)
<a name="l00198"></a>00198     { this-&gt;quiet = <a class="code" href="classlibMesh_1_1RBSystem.php#adec856bc209f0533639d76767bd5ebbc">quiet</a>; }
<a name="l00199"></a>00199 
<a name="l00204"></a>00204   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#af6e478cdf9c08312cdf7ca6a53349922">load_basis_function</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i);
<a name="l00205"></a>00205 
<a name="l00209"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">00209</a>   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1RBSystem.php#abfe6d67ed23243d225f12747f355f105">basis_functions</a>.size(); }
<a name="l00210"></a>00210   
<a name="l00215"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a63377b4ff459ba8a31fb610fb9c3eaf2">00215</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a63377b4ff459ba8a31fb610fb9c3eaf2">set_n_basis_functions</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_bfs) { <a class="code" href="classlibMesh_1_1RBSystem.php#abfe6d67ed23243d225f12747f355f105">basis_functions</a>.resize(n_bfs); }
<a name="l00216"></a>00216 
<a name="l00220"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a9ded22447be4ab3c0724bd060bfd9899">00220</a>   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp; <a class="code" href="classlibMesh_1_1RBSystem.php#a9ded22447be4ab3c0724bd060bfd9899">get_bf</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00221"></a>00221 <span class="keyword">    </span>{ libmesh_assert(i&lt;=<a class="code" href="classlibMesh_1_1RBSystem.php#abfe6d67ed23243d225f12747f355f105">basis_functions</a>.size());
<a name="l00222"></a>00222       <span class="keywordflow">return</span> *<a class="code" href="classlibMesh_1_1RBSystem.php#abfe6d67ed23243d225f12747f355f105">basis_functions</a>[i]; };
<a name="l00223"></a>00223 
<a name="l00228"></a>00228   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a24fc309a7bfce6fb9380e242d4fdd5bc">load_RB_solution</a>();
<a name="l00229"></a>00229 
<a name="l00234"></a>00234   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a3410f47eeb503ae9f34ceec97d7436b1">attach_dirichlet_dof_initialization</a> (<a class="code" href="namespacelibMesh.php#a81103ec3bcd9ba1f89f544623d5b7318">dirichlet_list_fptr</a> dirichlet_init);
<a name="l00235"></a>00235 
<a name="l00239"></a>00239   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#add5ef1d37331766d1b46208bb4e952fb">initialize_dirichlet_dofs</a>();
<a name="l00240"></a>00240 
<a name="l00245"></a><a class="code" href="classlibMesh_1_1RBSystem.php#abcf4b7dfba970793d37abb490e288b19">00245</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#abcf4b7dfba970793d37abb490e288b19">attach_theta_q_a</a>(<a class="code" href="namespacelibMesh.php#aa62736885c7a9bb67eda65b54ee20107">theta_q_fptr</a> )
<a name="l00246"></a>00246   {
<a name="l00247"></a>00247     <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Error: Cannot use attach_theta_q_a in RBSystem. Use attach_A_q instead.&quot;</span> &lt;&lt; std::endl;
<a name="l00248"></a>00248     libmesh_error();
<a name="l00249"></a>00249   }
<a name="l00250"></a>00250 
<a name="l00255"></a><a class="code" href="classlibMesh_1_1RBSystem.php#ac4acf0baeb2751763420084c197c2c38">00255</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#ac4acf0baeb2751763420084c197c2c38">attach_A_EIM_system</a>(<a class="code" href="classlibMesh_1_1RBEIMSystem.php">RBEIMSystem</a>*)
<a name="l00256"></a>00256   {
<a name="l00257"></a>00257     <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Error: Cannot use attach_theta_q_a in RBSystem. Use attach_A_q instead.&quot;</span> &lt;&lt; std::endl;
<a name="l00258"></a>00258     libmesh_error();
<a name="l00259"></a>00259   }
<a name="l00260"></a>00260 
<a name="l00265"></a>00265   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#af32bc9a0c5fe34e1a0f3f097506ca15a">attach_A_q</a>(<a class="code" href="namespacelibMesh.php#aa62736885c7a9bb67eda65b54ee20107">theta_q_fptr</a> theta_q_a,
<a name="l00266"></a>00266                   <a class="code" href="namespacelibMesh.php#a18a170af3a9d5eff6f43eb3409d0e296">affine_assembly_fptr</a> A_q_intrr_assembly,
<a name="l00267"></a>00267                   <a class="code" href="namespacelibMesh.php#a18a170af3a9d5eff6f43eb3409d0e296">affine_assembly_fptr</a> A_q_bndry_assembly);
<a name="l00268"></a>00268 
<a name="l00273"></a>00273   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a725f3a18ed697b39bdd724ae95916f07">attach_F_q</a>(<a class="code" href="namespacelibMesh.php#aa62736885c7a9bb67eda65b54ee20107">theta_q_fptr</a> theta_q_f,
<a name="l00274"></a>00274                   <a class="code" href="namespacelibMesh.php#a18a170af3a9d5eff6f43eb3409d0e296">affine_assembly_fptr</a> F_q_intrr_assembly,
<a name="l00275"></a>00275                   <a class="code" href="namespacelibMesh.php#a18a170af3a9d5eff6f43eb3409d0e296">affine_assembly_fptr</a> F_q_bdnry_assembly);
<a name="l00276"></a>00276 
<a name="l00282"></a>00282   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#abccfc951179c22c92c8a8ee2d33d8ff5">attach_A_EIM_operators</a>(<a class="code" href="classlibMesh_1_1RBEIMSystem.php">RBEIMSystem</a>* eim_system,
<a name="l00283"></a>00283                                 <a class="code" href="namespacelibMesh.php#a18a170af3a9d5eff6f43eb3409d0e296">affine_assembly_fptr</a> EIM_intrr_assembly,
<a name="l00284"></a>00284                                 <a class="code" href="namespacelibMesh.php#a18a170af3a9d5eff6f43eb3409d0e296">affine_assembly_fptr</a> EIM_bndry_assembly);
<a name="l00285"></a>00285   
<a name="l00291"></a>00291   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#ac943bfc401b46640c6780760216aeaa5">attach_F_EIM_vectors</a>(<a class="code" href="classlibMesh_1_1RBEIMSystem.php">RBEIMSystem</a>* eim_system,
<a name="l00292"></a>00292                               <a class="code" href="namespacelibMesh.php#a18a170af3a9d5eff6f43eb3409d0e296">affine_assembly_fptr</a> EIM_intrr_assembly,
<a name="l00293"></a>00293                               <a class="code" href="namespacelibMesh.php#a18a170af3a9d5eff6f43eb3409d0e296">affine_assembly_fptr</a> EIM_bndry_assembly);
<a name="l00294"></a>00294 
<a name="l00299"></a>00299   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a21aca93ce10d2135a08c36a8a38b2c8a">is_F_EIM_function</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q);
<a name="l00300"></a>00300 
<a name="l00305"></a>00305   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a9c316631be4ba78acd6c6cbc47126a76">attach_inner_prod_assembly</a>(<a class="code" href="namespacelibMesh.php#a18a170af3a9d5eff6f43eb3409d0e296">affine_assembly_fptr</a> IP_assembly, <a class="code" href="namespacelibMesh.php#a18a170af3a9d5eff6f43eb3409d0e296">affine_assembly_fptr</a> IP_bndry_assembly=NULL);
<a name="l00306"></a>00306 
<a name="l00311"></a>00311   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a3a82d87dc184e5ae474696f9e847d7d6">attach_constraint_assembly</a>(<a class="code" href="namespacelibMesh.php#a18a170af3a9d5eff6f43eb3409d0e296">affine_assembly_fptr</a> constraint_assembly_in);
<a name="l00312"></a>00312 
<a name="l00318"></a>00318   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#aa1eabdea15878ea1a4d3665152313d29">attach_output</a>(std::vector&lt;theta_q_fptr&gt; theta_q_l,
<a name="l00319"></a>00319                      std::vector&lt;affine_assembly_fptr&gt; output_intrr_assembly,
<a name="l00320"></a>00320                      std::vector&lt;affine_assembly_fptr&gt; output_bndry_assembly);
<a name="l00321"></a>00321 
<a name="l00328"></a>00328   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#aa1eabdea15878ea1a4d3665152313d29">attach_output</a>(<a class="code" href="namespacelibMesh.php#aa62736885c7a9bb67eda65b54ee20107">theta_q_fptr</a> theta_q_l,
<a name="l00329"></a>00329                      <a class="code" href="namespacelibMesh.php#a18a170af3a9d5eff6f43eb3409d0e296">affine_assembly_fptr</a> output_intrr_assembly,
<a name="l00330"></a>00330                      <a class="code" href="namespacelibMesh.php#a18a170af3a9d5eff6f43eb3409d0e296">affine_assembly_fptr</a> output_bndry_assembly);
<a name="l00331"></a>00331 
<a name="l00335"></a>00335   <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;Number&gt;</a>* <a class="code" href="classlibMesh_1_1RBSystem.php#aef1516ea2eb482f28578cab98bd53097">get_A_q</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q);
<a name="l00336"></a>00336   
<a name="l00340"></a>00340   <a class="code" href="classlibMesh_1_1RBEIMSystem.php">RBEIMSystem</a>&amp; <a class="code" href="classlibMesh_1_1RBSystem.php#a9136cc9298d4aeda4145fc61a76dd980">get_A_EIM_system</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index);
<a name="l00341"></a>00341   
<a name="l00345"></a>00345   <a class="code" href="classlibMesh_1_1RBEIMSystem.php">RBEIMSystem</a>&amp; <a class="code" href="classlibMesh_1_1RBSystem.php#a5d80df31baa1197b3823040f1e85f585">get_F_EIM_system</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index);
<a name="l00346"></a>00346   
<a name="l00353"></a>00353   std::vector&lt;Number&gt; <a class="code" href="classlibMesh_1_1RBSystem.php#a2a8e92bd42f6ea347ef9c82b595648ac">evaluate_current_EIM_function</a>(<a class="code" href="classlibMesh_1_1Elem.php">Elem</a>&amp; element,
<a name="l00354"></a>00354                                                     <span class="keyword">const</span> std::vector&lt;Point&gt;&amp; qpoints);
<a name="l00355"></a>00355 
<a name="l00359"></a>00359   <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> <a class="code" href="classlibMesh_1_1RBSystem.php#a0fd951279c9b851ac38443156b4b18bd">eval_theta_q_f</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q);
<a name="l00360"></a>00360 
<a name="l00364"></a>00364   <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> <a class="code" href="classlibMesh_1_1RBSystem.php#a3ab4b896903320a2b313f73efc2aaad1">eval_theta_q_l</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> output_index, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_l);
<a name="l00365"></a>00365 
<a name="l00373"></a>00373   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a5911f7b778db3b2791ca89d4e9820125">initialize_RB_system</a>(<span class="keywordtype">bool</span> online_mode);
<a name="l00374"></a>00374 
<a name="l00378"></a>00378   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>* <a class="code" href="classlibMesh_1_1RBSystem.php#a1b3f04b60e3464d779c140c280e1010e">get_F_q</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q);
<a name="l00379"></a>00379 
<a name="l00383"></a>00383   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>* <a class="code" href="classlibMesh_1_1RBSystem.php#a956b276ef7de8606c78698fcfa338343">get_output_vector</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_l);
<a name="l00384"></a>00384 
<a name="l00388"></a>00388   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a2bde84b5899642d6bb6ba2f6ac4a51f9">assemble_inner_product_matrix</a>(<a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;Number&gt;</a>* input_matrix);
<a name="l00389"></a>00389 
<a name="l00393"></a>00393   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#aad586433d469565565b32a115573df81">assemble_constraint_matrix</a>(<a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;Number&gt;</a>* input_matrix);
<a name="l00394"></a>00394 
<a name="l00398"></a>00398   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a27c29a32ebf67c226b8dc3ae3f682a28">assemble_and_add_constraint_matrix</a>(<a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;Number&gt;</a>* input_matrix);
<a name="l00399"></a>00399 
<a name="l00403"></a>00403   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#af8d2c48f29c4102d4c9378258b90e7d9">assemble_Aq_matrix</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q, <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;Number&gt;</a>* input_matrix);
<a name="l00404"></a>00404 
<a name="l00409"></a>00409   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a7d2cb74519604f8392e318e1e9c17524">add_scaled_Aq</a>(<a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> scalar, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_a,
<a name="l00410"></a>00410                      <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;Number&gt;</a>* input_matrix,
<a name="l00411"></a>00411                      <span class="keywordtype">bool</span> symmetrize);
<a name="l00412"></a>00412 
<a name="l00417"></a>00417   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a9382ee8b327d3e7db7e867d9cfb24fc2">write_offline_data_to_files</a>(<span class="keyword">const</span> std::string&amp; directory_name = <span class="stringliteral">&quot;offline_data&quot;</span>);
<a name="l00418"></a>00418 
<a name="l00423"></a>00423   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#ad32589e604ce7562cc256741e87d7d3c">read_offline_data_from_files</a>(<span class="keyword">const</span> std::string&amp; directory_name = <span class="stringliteral">&quot;offline_data&quot;</span>);
<a name="l00424"></a>00424   
<a name="l00429"></a>00429   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a6cff791ce311e33e9e3f5a529de9c13f">recompute_all_residual_terms</a>();
<a name="l00430"></a>00430 
<a name="l00431"></a>00431 
<a name="l00432"></a>00432   <span class="comment">//----------- PUBLIC DATA MEMBERS -----------//</span>
<a name="l00433"></a>00433 
<a name="l00434"></a>00434 
<a name="l00442"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a406e42df7eb0a8eda5b95b67ba5840fb">00442</a>   std::vector&lt;Real&gt; <a class="code" href="classlibMesh_1_1RBSystem.php#a406e42df7eb0a8eda5b95b67ba5840fb">training_error_bounds</a>;
<a name="l00443"></a>00443 
<a name="l00447"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a330478ef4e1a158dc7b6f08530e10ff3">00447</a>   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt; SparseMatrix&lt;Number&gt;</a> &gt; <a class="code" href="classlibMesh_1_1RBSystem.php#a330478ef4e1a158dc7b6f08530e10ff3">inner_product_matrix</a>;
<a name="l00448"></a>00448 
<a name="l00453"></a><a class="code" href="classlibMesh_1_1RBSystem.php#aa7a3439518c1b8a421a79064e819f5c8">00453</a>   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt; SparseMatrix&lt;Number&gt;</a> &gt; <a class="code" href="classlibMesh_1_1RBSystem.php#aa7a3439518c1b8a421a79064e819f5c8">constraint_matrix</a>;
<a name="l00454"></a>00454 
<a name="l00459"></a><a class="code" href="classlibMesh_1_1RBSystem.php#abfe6d67ed23243d225f12747f355f105">00459</a>   std::vector&lt; NumericVector&lt;Number&gt;* &gt; <a class="code" href="classlibMesh_1_1RBSystem.php#abfe6d67ed23243d225f12747f355f105">basis_functions</a>;
<a name="l00460"></a>00460 
<a name="l00467"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a5aeb48dc4ed2a429e89bdeffdd1f1564">00467</a>   <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Number&gt;</a> <a class="code" href="classlibMesh_1_1RBSystem.php#a5aeb48dc4ed2a429e89bdeffdd1f1564">RB_inner_product_matrix</a>;
<a name="l00468"></a>00468 
<a name="l00472"></a><a class="code" href="classlibMesh_1_1RBSystem.php#adadaf9a427ffbace640455436a4d4b26">00472</a>   std::vector&lt; DenseMatrix&lt;Number&gt; &gt; <a class="code" href="classlibMesh_1_1RBSystem.php#adadaf9a427ffbace640455436a4d4b26">RB_A_q_vector</a>;
<a name="l00473"></a>00473 
<a name="l00477"></a><a class="code" href="classlibMesh_1_1RBSystem.php#ac2da8c5c36be49686429e74b4f9def1c">00477</a>   std::vector&lt; DenseVector&lt;Number&gt; &gt; <a class="code" href="classlibMesh_1_1RBSystem.php#ac2da8c5c36be49686429e74b4f9def1c">RB_F_q_vector</a>;
<a name="l00478"></a>00478 
<a name="l00482"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a201af52facfa4da38bc636ee2cf41c67">00482</a>   <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> <a class="code" href="classlibMesh_1_1RBSystem.php#a201af52facfa4da38bc636ee2cf41c67">RB_solution</a>;
<a name="l00483"></a>00483 
<a name="l00488"></a><a class="code" href="classlibMesh_1_1RBSystem.php#abef8df30d43713bb06b2a83b89a0ed29">00488</a>   std::vector&lt; Number &gt; <a class="code" href="classlibMesh_1_1RBSystem.php#abef8df30d43713bb06b2a83b89a0ed29">truth_outputs</a>;
<a name="l00489"></a>00489 
<a name="l00494"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a2e3592b7167280ef4dd92cfb4a131c62">00494</a>   std::vector&lt; std::vector&lt; Number &gt; &gt; <a class="code" href="classlibMesh_1_1RBSystem.php#a2e3592b7167280ef4dd92cfb4a131c62">output_dual_norms</a>;
<a name="l00495"></a>00495 
<a name="l00499"></a><a class="code" href="classlibMesh_1_1RBSystem.php#ab868a08069961fcde36a760e0094708a">00499</a>   std::vector&lt; std::vector&lt; DenseVector&lt;Number&gt; &gt; &gt; <a class="code" href="classlibMesh_1_1RBSystem.php#ab868a08069961fcde36a760e0094708a">RB_output_vectors</a>;
<a name="l00500"></a>00500 
<a name="l00505"></a><a class="code" href="classlibMesh_1_1RBSystem.php#ac099cfc76fb098f528982f9322f5780a">00505</a>   std::vector&lt; Number &gt; <a class="code" href="classlibMesh_1_1RBSystem.php#ac099cfc76fb098f528982f9322f5780a">RB_outputs</a>;
<a name="l00506"></a><a class="code" href="classlibMesh_1_1RBSystem.php#aec3ecea1d8b509fe52ecb7a8b7893f27">00506</a>   std::vector&lt; Real &gt; <a class="code" href="classlibMesh_1_1RBSystem.php#aec3ecea1d8b509fe52ecb7a8b7893f27">RB_output_error_bounds</a>;
<a name="l00507"></a>00507 
<a name="l00511"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a9dd1607766f97d79b0abcfcf37193a11">00511</a>   std::vector&lt; std::vector&lt;Real&gt; &gt; <a class="code" href="classlibMesh_1_1RBSystem.php#a9dd1607766f97d79b0abcfcf37193a11">greedy_param_list</a>;
<a name="l00512"></a>00512 
<a name="l00516"></a><a class="code" href="classlibMesh_1_1RBSystem.php#acd91cfaa84058427cda2885e4d6d30ce">00516</a>   std::vector&lt; NumericVector&lt;Number&gt;* &gt; <a class="code" href="classlibMesh_1_1RBSystem.php#acd91cfaa84058427cda2885e4d6d30ce">F_q_representor</a>;
<a name="l00517"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a9c8fb2a4cb5b77e59e36bfff438aed01">00517</a>   std::vector&lt; std::vector&lt; NumericVector&lt;Number&gt;* &gt; &gt; <a class="code" href="classlibMesh_1_1RBSystem.php#a9c8fb2a4cb5b77e59e36bfff438aed01">A_q_representor</a>;
<a name="l00518"></a>00518 
<a name="l00523"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a567c86950bb6d2ab2800ac0b14ed3dd2">00523</a>   std::vector&lt;Number&gt; <a class="code" href="classlibMesh_1_1RBSystem.php#a567c86950bb6d2ab2800ac0b14ed3dd2">Fq_representor_norms</a>;
<a name="l00524"></a><a class="code" href="classlibMesh_1_1RBSystem.php#ac3d546a3eaa362377494da087e711608">00524</a>   std::vector&lt; std::vector&lt; std::vector&lt;Number&gt; &gt; &gt; <a class="code" href="classlibMesh_1_1RBSystem.php#ac3d546a3eaa362377494da087e711608">Fq_Aq_representor_norms</a>;
<a name="l00525"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a668fed2dcb2e98adb2e7eea5bc7d853e">00525</a>   std::vector&lt; std::vector&lt; std::vector&lt;Number&gt; &gt; &gt; <a class="code" href="classlibMesh_1_1RBSystem.php#a668fed2dcb2e98adb2e7eea5bc7d853e">Aq_Aq_representor_norms</a>;
<a name="l00526"></a>00526 
<a name="l00531"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a28b1348023897cb1517724d6ac30a21d">00531</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a28b1348023897cb1517724d6ac30a21d">constrained_problem</a>;
<a name="l00532"></a>00532 
<a name="l00537"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a740fd251422d685fa5b1256022c29a06">00537</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a740fd251422d685fa5b1256022c29a06">store_basis_functions</a>;
<a name="l00538"></a>00538 
<a name="l00545"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a5ac870aac52f838bd28ee088ddc095b0">00545</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a5ac870aac52f838bd28ee088ddc095b0">store_representors</a>;
<a name="l00546"></a>00546 
<a name="l00551"></a><a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">00551</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a>;
<a name="l00552"></a>00552 
<a name="l00557"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a61f47d68b0df487674a9001d13d77c88">00557</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a61f47d68b0df487674a9001d13d77c88">reuse_preconditioner</a>;
<a name="l00558"></a>00558 
<a name="l00563"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a56ab5090b2d6e6322742ade2772330e7">00563</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a56ab5090b2d6e6322742ade2772330e7">return_rel_error_bound</a>;
<a name="l00564"></a>00564 
<a name="l00570"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a5d9cd7b5d9de8e0d7b6efde6252c449c">00570</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a5d9cd7b5d9de8e0d7b6efde6252c449c">write_data_during_training</a>;
<a name="l00571"></a>00571 
<a name="l00577"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a254e2165b576bf932eaa57e726a6bebf">00577</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a254e2165b576bf932eaa57e726a6bebf">impose_internal_dirichlet_BCs</a>;
<a name="l00578"></a>00578 
<a name="l00583"></a><a class="code" href="classlibMesh_1_1RBSystem.php#ab76a069a5cb7bb72afe582be842d8e04">00583</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1RBSystem.php#ab76a069a5cb7bb72afe582be842d8e04">impose_internal_fluxes</a>;
<a name="l00584"></a>00584   
<a name="l00588"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a52ba5c957ff8b7f85ae16707df632b67">00588</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a52ba5c957ff8b7f85ae16707df632b67">compute_RB_inner_product</a>;
<a name="l00589"></a>00589 
<a name="l00594"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a3aa3cce2414d86488881e1bbe4adcd00">00594</a>   std::string <a class="code" href="classlibMesh_1_1RBSystem.php#a3aa3cce2414d86488881e1bbe4adcd00">parameters_filename</a>;
<a name="l00595"></a>00595   
<a name="l00602"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a185d55184fb6f7c1705066908d642319">00602</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a185d55184fb6f7c1705066908d642319">enforce_constraints_exactly</a>;
<a name="l00603"></a>00603 
<a name="l00604"></a>00604 <span class="keyword">protected</span>:
<a name="l00609"></a>00609   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a5c2eb48dd263d846086cb2ca5b6a88a3">init_data</a> ();
<a name="l00610"></a>00610 
<a name="l00615"></a>00615   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a58274b561dcb5823736406bb7b9efadc">truth_assembly</a>();
<a name="l00616"></a>00616 
<a name="l00621"></a>00621   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;FEMContext&gt;</a> <a class="code" href="classlibMesh_1_1RBSystem.php#aab5505a99e58300d0e4e17b31943f162">build_context</a>();
<a name="l00622"></a>00622   
<a name="l00628"></a>00628   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#ab3721f4dcfe7b60950382a6e03607fe9">assemble_matrix_for_output_dual_solves</a>();
<a name="l00629"></a>00629   
<a name="l00634"></a>00634   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1RBSystem.php#a6cae03a0338b32c65938db1f805deb3c">eval_output_dual_norm</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n);
<a name="l00635"></a>00635 
<a name="l00640"></a>00640   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a79eb03faea6389086e2ccbb032569243">greedy_termination_test</a>(<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> training_greedy_error, <span class="keywordtype">int</span> count);
<a name="l00641"></a>00641 
<a name="l00646"></a>00646   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a8a840ace6f0385a830ad6ab4b4edcb49">update_greedy_param_list</a>();
<a name="l00647"></a>00647 
<a name="l00655"></a>00655   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a4a1243f45ea36fbd2a10ad6956c62deb">add_scaled_matrix_and_vector</a>(<a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> scalar,
<a name="l00656"></a>00656                                     <a class="code" href="namespacelibMesh.php#a18a170af3a9d5eff6f43eb3409d0e296">affine_assembly_fptr</a> intrr_assembly,
<a name="l00657"></a>00657                                     <a class="code" href="namespacelibMesh.php#a18a170af3a9d5eff6f43eb3409d0e296">affine_assembly_fptr</a> bndry_assembly,
<a name="l00658"></a>00658                                     <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;Number&gt;</a>* input_matrix,
<a name="l00659"></a>00659                                     <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>* input_vector,
<a name="l00660"></a>00660                                     <span class="keywordtype">bool</span> symmetrize=<span class="keyword">false</span>);
<a name="l00661"></a>00661 
<a name="l00667"></a>00667   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a5231ac40d0bea4c48f6b734fcff1b4c7">set_context_solution_vec</a>(<a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>&amp; vec);
<a name="l00668"></a>00668 
<a name="l00674"></a>00674   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a568b302f96140c76530b9412c1b87b38">assemble_scaled_matvec</a>(<a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> scalar,
<a name="l00675"></a>00675                               <a class="code" href="namespacelibMesh.php#a18a170af3a9d5eff6f43eb3409d0e296">affine_assembly_fptr</a> intrr_assembly,
<a name="l00676"></a>00676                               <a class="code" href="namespacelibMesh.php#a18a170af3a9d5eff6f43eb3409d0e296">affine_assembly_fptr</a> bndry_assembly,
<a name="l00677"></a>00677                               <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>&amp; dest,
<a name="l00678"></a>00678                               <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>&amp; arg);
<a name="l00679"></a>00679 
<a name="l00686"></a>00686   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a2fef453705e8c61cfe86eced45603dad">assemble_misc_matrices</a>();
<a name="l00687"></a>00687 
<a name="l00692"></a>00692   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#af03382bc15075589cbfa15caf75b8b92">assemble_all_affine_operators</a>();
<a name="l00693"></a>00693 
<a name="l00697"></a>00697   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a1af76f5d23ae7d1af03f6c1666673db6">assemble_all_affine_vectors</a>();
<a name="l00698"></a>00698 
<a name="l00702"></a>00702   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#aac92e937e2de9cd586d8fcb92967c739">assemble_all_output_vectors</a>();
<a name="l00703"></a>00703 
<a name="l00708"></a>00708   <span class="keyword">virtual</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1RBSystem.php#aacdbb059e6ab25ff140d34cdc13ab253">compute_residual_dual_norm</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N);
<a name="l00709"></a>00709 
<a name="l00713"></a>00713   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a8718bf6f56c88f4ccab7521f334e6a2c">compute_output_dual_norms</a>();
<a name="l00714"></a>00714 
<a name="l00719"></a>00719   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#ada44f7c1f672088d8ef2b6b8abc35cd5">enrich_RB_space</a>();
<a name="l00720"></a>00720 
<a name="l00725"></a>00725   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#af539556a1dac63314567b39e46fa9a08">update_system</a>();
<a name="l00726"></a>00726   
<a name="l00731"></a><a class="code" href="classlibMesh_1_1RBSystem.php#ade32dc013fdad1eca4b1e03839651928">00731</a>   <span class="keyword">virtual</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1RBSystem.php#ade32dc013fdad1eca4b1e03839651928">get_RB_error_bound</a>() { <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1RBSystem.php#af57b8bd010cb9280eb9d295e8a63cffe">RB_solve</a>(<a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>()); }
<a name="l00732"></a>00732 
<a name="l00736"></a>00736   <span class="keyword">virtual</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1RBSystem.php#a572b94b57df61e1670254e91233e5c8a">get_SCM_lower_bound</a>();
<a name="l00737"></a>00737 
<a name="l00741"></a>00741   <span class="keyword">virtual</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1RBSystem.php#af8bc520e41a0833e9a1ac853af41ce27">get_SCM_upper_bound</a>();
<a name="l00742"></a>00742 
<a name="l00748"></a>00748   <span class="keyword">virtual</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1RBSystem.php#a763e47c3abb2cafc44d68812042a6f73">residual_scaling_denom</a>(<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> alpha_LB);
<a name="l00749"></a>00749 
<a name="l00753"></a>00753   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a22351bccb17903c68cfd546412d04f3c">update_RB_system_matrices</a>();
<a name="l00754"></a>00754 
<a name="l00762"></a>00762   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a07341a81eabf77b919f6835638228946">update_residual_terms</a>(<span class="keywordtype">bool</span> compute_inner_products=<span class="keyword">true</span>);
<a name="l00763"></a>00763   
<a name="l00768"></a>00768   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a3e76f211b8f215f86e8d96c0d371e3d8">write_out_basis_functions</a>(<span class="keyword">const</span> std::string&amp; directory_name, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> precision_level);
<a name="l00769"></a>00769   
<a name="l00773"></a>00773   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a8ce3d2464a0adbcb7fe97a5d62a76e8c">read_in_basis_functions</a>(<span class="keyword">const</span> std::string&amp; directory_name);
<a name="l00774"></a>00774 
<a name="l00781"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a2a9e0cb788597d488aa73e9108147ef2">00781</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a2a9e0cb788597d488aa73e9108147ef2">init_context</a>(<a class="code" href="classlibMesh_1_1FEMContext.php">FEMContext</a>&amp; ) {}
<a name="l00782"></a>00782 
<a name="l00788"></a>00788   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a85c25bbd66bed6e4111e44566e91b5ff">zero_dirichlet_dofs_on_rhs</a>();
<a name="l00789"></a>00789 
<a name="l00795"></a>00795   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a002530dbacbc566d7c86bad54ee1138d">zero_dirichlet_dofs_on_vector</a>(<a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>&amp; temp);
<a name="l00796"></a>00796   
<a name="l00801"></a>00801   std::pair&lt;unsigned int, unsigned int&gt; <a class="code" href="classlibMesh_1_1RBSystem.php#a6f1c9a07eabe425ffbc8ebf2155bb187">get_F_EIM_indices</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q);
<a name="l00802"></a>00802 
<a name="l00803"></a>00803 
<a name="l00804"></a>00804   <span class="comment">//----------- PROTECTED DATA MEMBERS -----------//</span>
<a name="l00805"></a>00805 
<a name="l00810"></a><a class="code" href="classlibMesh_1_1RBSystem.php#ab47d6a963c4f68b5a3d1eea7905257f5">00810</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1RBSystem.php#ab47d6a963c4f68b5a3d1eea7905257f5">Nmax</a>;
<a name="l00811"></a>00811 
<a name="l00816"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a36ba489bd3158bbff48a5607e1d21d30">00816</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a36ba489bd3158bbff48a5607e1d21d30">delta_N</a>;
<a name="l00817"></a>00817 
<a name="l00823"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a1378ada675cf004646e15be203e631c6">00823</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a1378ada675cf004646e15be203e631c6">write_binary_basis_functions</a>;
<a name="l00824"></a>00824 
<a name="l00832"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a03fa5b207add059829b08f156320369d">00832</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a03fa5b207add059829b08f156320369d">read_binary_basis_functions</a>;
<a name="l00833"></a>00833 
<a name="l00839"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a399f7ee60adcc350ce7f27e8c60ed9de">00839</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a399f7ee60adcc350ce7f27e8c60ed9de">write_binary_residual_representors</a>;
<a name="l00840"></a>00840 
<a name="l00848"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a6be264f3a81564aa2cf7144b54d74552">00848</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a6be264f3a81564aa2cf7144b54d74552">read_binary_residual_representors</a>;
<a name="l00849"></a>00849 
<a name="l00854"></a><a class="code" href="classlibMesh_1_1RBSystem.php#adec856bc209f0533639d76767bd5ebbc">00854</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1RBSystem.php#adec856bc209f0533639d76767bd5ebbc">quiet</a>;
<a name="l00855"></a>00855 
<a name="l00860"></a><a class="code" href="classlibMesh_1_1RBSystem.php#ab53684df668b4dbad08d68fd6be1fd37">00860</a>   std::string <a class="code" href="classlibMesh_1_1RBSystem.php#ab53684df668b4dbad08d68fd6be1fd37">eigen_system_name</a>;
<a name="l00861"></a>00861 
<a name="l00866"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a2adf4c8625618eada7158c65cdc5f6f3">00866</a>   <a class="code" href="namespacelibMesh.php#a18a170af3a9d5eff6f43eb3409d0e296">affine_assembly_fptr</a> <a class="code" href="classlibMesh_1_1RBSystem.php#a2adf4c8625618eada7158c65cdc5f6f3">inner_prod_assembly</a>;
<a name="l00867"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a5baa4e96684907e89ee18cb00afb5502">00867</a>   <a class="code" href="namespacelibMesh.php#a18a170af3a9d5eff6f43eb3409d0e296">affine_assembly_fptr</a> <a class="code" href="classlibMesh_1_1RBSystem.php#a5baa4e96684907e89ee18cb00afb5502">inner_prod_bndry_assembly</a>;
<a name="l00868"></a>00868 
<a name="l00873"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a9c6da671e41886e26c7e88aae82f4358">00873</a>   <a class="code" href="namespacelibMesh.php#a18a170af3a9d5eff6f43eb3409d0e296">affine_assembly_fptr</a> <a class="code" href="classlibMesh_1_1RBSystem.php#a9c6da671e41886e26c7e88aae82f4358">constraint_assembly</a>;
<a name="l00874"></a>00874 
<a name="l00880"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a2e5fa41dea513013a95ac9cdc5a61f0c">00880</a>   std::vector&lt;affine_assembly_fptr&gt; <a class="code" href="classlibMesh_1_1RBSystem.php#a2e5fa41dea513013a95ac9cdc5a61f0c">A_q_intrr_assembly_vector</a>;
<a name="l00881"></a><a class="code" href="classlibMesh_1_1RBSystem.php#af494bdce91a9247fae8014b49ff42296">00881</a>   std::vector&lt;affine_assembly_fptr&gt; <a class="code" href="classlibMesh_1_1RBSystem.php#af494bdce91a9247fae8014b49ff42296">A_q_bndry_assembly_vector</a>;
<a name="l00882"></a>00882 
<a name="l00887"></a><a class="code" href="classlibMesh_1_1RBSystem.php#afabf274dd4fced20cd745e982bbd6e83">00887</a>   std::vector&lt;affine_assembly_fptr&gt; <a class="code" href="classlibMesh_1_1RBSystem.php#afabf274dd4fced20cd745e982bbd6e83">F_q_intrr_assembly_vector</a>;
<a name="l00888"></a>00888 
<a name="l00893"></a><a class="code" href="classlibMesh_1_1RBSystem.php#aa9f3638bb29d1be5eb80a4555217d943">00893</a>   std::vector&lt;affine_assembly_fptr&gt; <a class="code" href="classlibMesh_1_1RBSystem.php#aa9f3638bb29d1be5eb80a4555217d943">F_q_bndry_assembly_vector</a>;
<a name="l00894"></a>00894 
<a name="l00899"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a228200ea93fc638ba249a979078eeb10">00899</a>   std::vector&lt; std::vector&lt;affine_assembly_fptr&gt; &gt; <a class="code" href="classlibMesh_1_1RBSystem.php#a228200ea93fc638ba249a979078eeb10">output_intrr_assembly_vector</a>;
<a name="l00900"></a>00900 
<a name="l00905"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a27d85bffcf0b50eab3c08dc0d17d21f2">00905</a>   std::vector&lt; std::vector&lt;affine_assembly_fptr&gt; &gt; <a class="code" href="classlibMesh_1_1RBSystem.php#a27d85bffcf0b50eab3c08dc0d17d21f2">output_bndry_assembly_vector</a>;
<a name="l00906"></a>00906 
<a name="l00912"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a88a28e5658cc0bf37e3df863a46a9e7b">00912</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a88a28e5658cc0bf37e3df863a46a9e7b">update_residual_terms_called</a>;
<a name="l00913"></a>00913 
<a name="l00914"></a>00914 <span class="keyword">private</span>:
<a name="l00915"></a>00915 
<a name="l00920"></a>00920   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#ad29734395747e3a7390db90eec361398">clear_basis_helper</a>();
<a name="l00921"></a>00921 
<a name="l00922"></a>00922   <span class="comment">//----------- PRIVATE DATA MEMBERS -----------//</span>
<a name="l00923"></a>00923 
<a name="l00927"></a><a class="code" href="classlibMesh_1_1RBSystem.php#acc90dcf523c055fc294bc71b67dfe876">00927</a>   std::vector&lt;theta_q_fptr&gt; <a class="code" href="classlibMesh_1_1RBSystem.php#acc90dcf523c055fc294bc71b67dfe876">theta_q_f_vector</a>;
<a name="l00928"></a>00928 
<a name="l00932"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a1fa2b8ea817cae06f0d2e0bdbdd8b273">00932</a>   std::vector&lt; std::vector&lt;theta_q_fptr&gt; &gt; <a class="code" href="classlibMesh_1_1RBSystem.php#a1fa2b8ea817cae06f0d2e0bdbdd8b273">theta_q_l_vector</a>;
<a name="l00933"></a>00933   
<a name="l00938"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a1c0266ace79018f4fe863549db995171">00938</a>   std::vector&lt; RBEIMSystem* &gt; <a class="code" href="classlibMesh_1_1RBSystem.php#a1c0266ace79018f4fe863549db995171">F_EIM_systems_vector</a>;
<a name="l00939"></a>00939 
<a name="l00944"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a3b5f0e356b5a09e31e03f65400704cdc">00944</a>   std::vector&lt;affine_assembly_fptr&gt; <a class="code" href="classlibMesh_1_1RBSystem.php#a3b5f0e356b5a09e31e03f65400704cdc">A_EIM_intrr_assembly_vector</a>;
<a name="l00945"></a><a class="code" href="classlibMesh_1_1RBSystem.php#ad0e9f0de3570c5ed42777fcf9f7aebbc">00945</a>   std::vector&lt;affine_assembly_fptr&gt; <a class="code" href="classlibMesh_1_1RBSystem.php#ad0e9f0de3570c5ed42777fcf9f7aebbc">A_EIM_bndry_assembly_vector</a>;
<a name="l00946"></a>00946 
<a name="l00951"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a49be51b5a280a82e03e4bc3d40abb147">00951</a>   std::vector&lt;affine_assembly_fptr&gt; <a class="code" href="classlibMesh_1_1RBSystem.php#a49be51b5a280a82e03e4bc3d40abb147">F_EIM_intrr_assembly_vector</a>;
<a name="l00952"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a2d9f5f3318fb1e891e50b0778496d257">00952</a>   std::vector&lt;affine_assembly_fptr&gt; <a class="code" href="classlibMesh_1_1RBSystem.php#a2d9f5f3318fb1e891e50b0778496d257">F_EIM_bndry_assembly_vector</a>;
<a name="l00953"></a>00953 
<a name="l00957"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a2950621ecac9122266a6893e18735778">00957</a>   std::vector&lt; SparseMatrix&lt;Number&gt;* &gt; <a class="code" href="classlibMesh_1_1RBSystem.php#a2950621ecac9122266a6893e18735778">A_q_vector</a>;
<a name="l00958"></a>00958 
<a name="l00963"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a6c86729bd0f4556a8574e3638282fc01">00963</a>   std::vector&lt; NumericVector&lt;Number&gt;* &gt; <a class="code" href="classlibMesh_1_1RBSystem.php#a6c86729bd0f4556a8574e3638282fc01">F_q_vector</a>;
<a name="l00964"></a>00964 
<a name="l00969"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a3060a5cc6031acfef4808df71e3eda08">00969</a>   std::vector&lt; std::vector&lt; NumericVector&lt;Number&gt;* &gt; &gt; <a class="code" href="classlibMesh_1_1RBSystem.php#a3060a5cc6031acfef4808df71e3eda08">outputs_vector</a>;
<a name="l00970"></a>00970 
<a name="l00974"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a56a24996be9d774563f1a8e6165ed038">00974</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1RBSystem.php#a56a24996be9d774563f1a8e6165ed038">training_tolerance</a>;
<a name="l00975"></a>00975 
<a name="l00980"></a><a class="code" href="classlibMesh_1_1RBSystem.php#ad74afd2cad6c52cbc299f1f3e623c70c">00980</a>   <a class="code" href="namespacelibMesh.php#a81103ec3bcd9ba1f89f544623d5b7318">dirichlet_list_fptr</a> <a class="code" href="classlibMesh_1_1RBSystem.php#ad74afd2cad6c52cbc299f1f3e623c70c">_dirichlet_list_init</a>;
<a name="l00981"></a>00981 
<a name="l00986"></a><a class="code" href="classlibMesh_1_1RBSystem.php#af3d84b1c9662e32972e37314f1a81353">00986</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1RBSystem.php#af3d84b1c9662e32972e37314f1a81353">initial_Nmax</a>;
<a name="l00987"></a>00987 
<a name="l00991"></a><a class="code" href="classlibMesh_1_1RBSystem.php#ac5a6b09c8f4e8d788be2ad45dc1bfb05">00991</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1RBSystem.php#ac5a6b09c8f4e8d788be2ad45dc1bfb05">RB_system_initialized</a>;
<a name="l00992"></a>00992   
<a name="l00999"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a9343f08e1c88fd8a6eb290038383ae6d">00999</a>   <a class="code" href="classlibMesh_1_1RBEIMSystem.php">RBEIMSystem</a>* <a class="code" href="classlibMesh_1_1RBSystem.php#a9343f08e1c88fd8a6eb290038383ae6d">current_EIM_system</a>;
<a name="l01000"></a>01000 };
<a name="l01001"></a>01001 
<a name="l01002"></a>01002 } <span class="comment">// namespace libMesh</span>
<a name="l01003"></a>01003 
<a name="l01004"></a>01004 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
