<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_c3a49989e40b21e7508f29d2dc962def.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_94af86d0ee7ff5a2af0627e1a0ea6efa.php">systems</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">steady_derived_rb_system.C</div>  </div>
</div>
<div class="contents">
<a href="steady__derived__rb__system_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// specialization for Base = RBSystem</span>
<a name="l00002"></a>00002 <span class="comment">// which is typedef&#39;d to SteadyDerivedRBSystem</span>
<a name="l00003"></a>00003 
<a name="l00004"></a>00004 <span class="preprocessor">#include &quot;<a class="code" href="derived__rb__system_8h.php">derived_rb_system.h</a>&quot;</span>
<a name="l00005"></a>00005 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__logging_8h.php">libmesh_logging.h</a>&quot;</span>
<a name="l00006"></a>00006 <span class="preprocessor">#include &quot;<a class="code" href="equation__systems_8h.php">equation_systems.h</a>&quot;</span>
<a name="l00007"></a>00007 <span class="preprocessor">#include &quot;<a class="code" href="mesh__base_8h.php">mesh_base.h</a>&quot;</span>
<a name="l00008"></a>00008 <span class="preprocessor">#include &quot;<a class="code" href="gmv__io_8h.php">gmv_io.h</a>&quot;</span>
<a name="l00009"></a>00009 
<a name="l00010"></a>00010 <span class="keyword">namespace </span>libMesh
<a name="l00011"></a>00011 {
<a name="l00012"></a>00012 
<a name="l00013"></a>00013 <span class="keyword">template</span> &lt;&gt;
<a name="l00014"></a><a class="code" href="classlibMesh_1_1DerivedRBSystem.php#a967109badb70e905ab04192ffcbe58ba">00014</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1DerivedRBSystem.php#acd2b06790eb3c931e2980d797534fb5d">DerivedRBSystem&lt;RBSystem&gt;::truth_solve</a>(<span class="keywordtype">int</span> plot_solution)
<a name="l00015"></a>00015 {
<a name="l00016"></a>00016   START_LOG(<span class="stringliteral">&quot;truth_solve()&quot;</span>, <span class="stringliteral">&quot;DerivedRBSystem&quot;</span>);
<a name="l00017"></a>00017   
<a name="l00018"></a>00018   <a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es = this-&gt;get_equation_systems();
<a name="l00019"></a>00019   <a class="code" href="classlibMesh_1_1RBSystem.php">RBSystem</a>&amp; uber_system = es.<a class="code" href="classlibMesh_1_1EquationSystems.php#a5dac23f839af25ce7dbf1fe9a6d4b67a">get_system</a>&lt;<a class="code" href="classlibMesh_1_1RBSystem.php">RBSystem</a>&gt;(uber_system_name);
<a name="l00020"></a>00020 
<a name="l00021"></a>00021   set_uber_current_parameters();
<a name="l00022"></a>00022   
<a name="l00023"></a>00023   uber_system.<a class="code" href="classlibMesh_1_1RBSystem.php#af57b8bd010cb9280eb9d295e8a63cffe">RB_solve</a>(uber_system.<a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>());
<a name="l00024"></a>00024   
<a name="l00025"></a>00025   <span class="keywordflow">if</span>(plot_solution &gt; 0)
<a name="l00026"></a>00026   {
<a name="l00027"></a>00027     uber_system.<a class="code" href="classlibMesh_1_1RBSystem.php#a24fc309a7bfce6fb9380e242d4fdd5bc">load_RB_solution</a>();
<a name="l00028"></a>00028     *solution = *(uber_system.<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>);
<a name="l00029"></a>00029     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a> = get_mesh();
<a name="l00030"></a>00030     <a class="code" href="classlibMesh_1_1GMVIO.php">GMVIO</a>(mesh).<a class="code" href="classlibMesh_1_1MeshOutput.php#a935598198649f4b831cd341ce91b3ccb">write_equation_systems</a> (<span class="stringliteral">&quot;unter_uber_truth.gmv&quot;</span>,
<a name="l00031"></a>00031                                         this-&gt;get_equation_systems());
<a name="l00032"></a>00032   }
<a name="l00033"></a>00033 
<a name="l00034"></a>00034   STOP_LOG(<span class="stringliteral">&quot;truth_solve()&quot;</span>, <span class="stringliteral">&quot;DerivedRBSystem&quot;</span>);
<a name="l00035"></a>00035   
<a name="l00036"></a>00036   <span class="comment">// Don&#39;t bother returning the norm of the uber solution</span>
<a name="l00037"></a>00037   <span class="keywordflow">return</span> 0.;
<a name="l00038"></a>00038 }
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 <span class="keyword">template</span> &lt;&gt;
<a name="l00041"></a><a class="code" href="classlibMesh_1_1DerivedRBSystem.php#a848d65795c2b418384f6206e221e1d8c">00041</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DerivedRBSystem.php#a88a732b4657f70b922f14c6af5873b13">DerivedRBSystem&lt;RBSystem&gt;::enrich_RB_space</a>()
<a name="l00042"></a>00042 {
<a name="l00043"></a>00043   START_LOG(<span class="stringliteral">&quot;enrich_RB_space()&quot;</span>, <span class="stringliteral">&quot;DerivedRBSystem&quot;</span>);
<a name="l00044"></a>00044   
<a name="l00045"></a>00045   <a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es = this-&gt;get_equation_systems();
<a name="l00046"></a>00046   <a class="code" href="classlibMesh_1_1RBSystem.php">RBSystem</a>&amp; uber_system = es.<a class="code" href="classlibMesh_1_1EquationSystems.php#a5dac23f839af25ce7dbf1fe9a6d4b67a">get_system</a>&lt;<a class="code" href="classlibMesh_1_1RBSystem.php">RBSystem</a>&gt;(uber_system_name);
<a name="l00047"></a>00047   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> uber_size = uber_system.<a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>();
<a name="l00048"></a>00048 
<a name="l00049"></a>00049   <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> new_bf = uber_system.<a class="code" href="classlibMesh_1_1RBSystem.php#a201af52facfa4da38bc636ee2cf41c67">RB_solution</a>;
<a name="l00050"></a>00050 
<a name="l00051"></a>00051   <span class="comment">// compute Gram-Schmidt orthogonalization</span>
<a name="l00052"></a>00052   <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> proj_sum(uber_size);
<a name="l00053"></a>00053   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index=0; index&lt;get_n_basis_functions(); index++)
<a name="l00054"></a>00054   {
<a name="l00055"></a>00055     <span class="comment">// orthogonalize using the Identity matrix as the inner product,</span>
<a name="l00056"></a>00056     <span class="comment">// since the uber basis functions should be orthogonal already</span>
<a name="l00057"></a>00057     <span class="comment">// (i.e. neglect possible rounding errors in uber orthogonalization)</span>
<a name="l00058"></a>00058     <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> scalar = new_bf.<a class="code" href="classlibMesh_1_1DenseVector.php#a740926ab2815bb507a1e33b659414be1">dot</a>(derived_basis_functions[index]);
<a name="l00059"></a>00059     proj_sum.<a class="code" href="classlibMesh_1_1DenseVector.php#ac131f04240149a0548e56a17adb7fb3f">add</a>(scalar, derived_basis_functions[index]);
<a name="l00060"></a>00060   }
<a name="l00061"></a>00061   new_bf -= proj_sum;
<a name="l00062"></a>00062   new_bf.<a class="code" href="classlibMesh_1_1DenseVector.php#af9c240ca08d420f6c949e6d1295e1fbe">scale</a>(1./new_bf.<a class="code" href="classlibMesh_1_1DenseVector.php#aba21b1716e029687d91f20e44ac7ae93">l2_norm</a>());
<a name="l00063"></a>00063 
<a name="l00064"></a>00064   <span class="comment">// load the new basis function into the basis_functions vector.</span>
<a name="l00065"></a>00065   derived_basis_functions.push_back( new_bf );
<a name="l00066"></a>00066 
<a name="l00067"></a>00067   STOP_LOG(<span class="stringliteral">&quot;enrich_RB_space()&quot;</span>, <span class="stringliteral">&quot;DerivedRBSystem&quot;</span>);
<a name="l00068"></a>00068 }
<a name="l00069"></a>00069 
<a name="l00070"></a>00070 
<a name="l00071"></a>00071 <span class="keyword">template</span> &lt;&gt;
<a name="l00072"></a><a class="code" href="classlibMesh_1_1DerivedRBSystem.php#ae43ecad584e5ecfcb2fd240ab649c91b">00072</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DerivedRBSystem.php#a8cb1d62ed4d283109aa527619b654186">DerivedRBSystem&lt;RBSystem&gt;::update_RB_system_matrices</a>()
<a name="l00073"></a>00073 {
<a name="l00074"></a>00074   START_LOG(<span class="stringliteral">&quot;update_RB_system_matrices()&quot;</span>, <span class="stringliteral">&quot;DerivedRBSystem&quot;</span>);
<a name="l00075"></a>00075   
<a name="l00076"></a>00076   <a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es = this-&gt;get_equation_systems();
<a name="l00077"></a>00077   <a class="code" href="classlibMesh_1_1RBSystem.php">RBSystem</a>&amp; uber_system = es.<a class="code" href="classlibMesh_1_1EquationSystems.php#a5dac23f839af25ce7dbf1fe9a6d4b67a">get_system</a>&lt;<a class="code" href="classlibMesh_1_1RBSystem.php">RBSystem</a>&gt;(uber_system_name);
<a name="l00078"></a>00078 
<a name="l00079"></a>00079   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> derived_RB_size = get_n_basis_functions();
<a name="l00080"></a>00080   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> uber_RB_size    = uber_system.<a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>();
<a name="l00081"></a>00081   
<a name="l00082"></a>00082   <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> temp_vector;
<a name="l00083"></a>00083   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_f=0; q_f&lt;get_Q_f(); q_f++)
<a name="l00084"></a>00084   {
<a name="l00085"></a>00085     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=(derived_RB_size-delta_N); i&lt;derived_RB_size; i++)
<a name="l00086"></a>00086     {
<a name="l00087"></a>00087       uber_system.<a class="code" href="classlibMesh_1_1RBSystem.php#ac2da8c5c36be49686429e74b4f9def1c">RB_F_q_vector</a>[q_f].get_principal_subvector(uber_RB_size, temp_vector);
<a name="l00088"></a>00088       RB_F_q_vector[q_f](i) = temp_vector.<a class="code" href="classlibMesh_1_1DenseVector.php#a740926ab2815bb507a1e33b659414be1">dot</a>(derived_basis_functions[i]);
<a name="l00089"></a>00089     }
<a name="l00090"></a>00090   }
<a name="l00091"></a>00091 
<a name="l00092"></a>00092   <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Number&gt;</a> temp_matrix;
<a name="l00093"></a>00093   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=(derived_RB_size-delta_N); i&lt;derived_RB_size; i++)
<a name="l00094"></a>00094   {
<a name="l00095"></a>00095     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;get_n_outputs(); n++)
<a name="l00096"></a>00096       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_l=0; q_l&lt;get_Q_l(n); q_l++)
<a name="l00097"></a>00097       {
<a name="l00098"></a>00098         uber_system.<a class="code" href="classlibMesh_1_1RBSystem.php#ab868a08069961fcde36a760e0094708a">RB_output_vectors</a>[n][q_l].get_principal_subvector(uber_RB_size, temp_vector);
<a name="l00099"></a>00099         RB_output_vectors[n][q_l](i) = temp_vector.<a class="code" href="classlibMesh_1_1DenseVector.php#a740926ab2815bb507a1e33b659414be1">dot</a>(derived_basis_functions[i]);
<a name="l00100"></a>00100       }
<a name="l00101"></a>00101 
<a name="l00102"></a>00102     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;derived_RB_size; j++)
<a name="l00103"></a>00103     {
<a name="l00104"></a>00104       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_a=0; q_a&lt;get_Q_a(); q_a++)
<a name="l00105"></a>00105       {
<a name="l00106"></a>00106         <span class="comment">// Compute reduced A_q matrix</span>
<a name="l00107"></a>00107         uber_system.<a class="code" href="classlibMesh_1_1RBSystem.php#adadaf9a427ffbace640455436a4d4b26">RB_A_q_vector</a>[q_a].get_principal_submatrix(uber_RB_size, temp_matrix);
<a name="l00108"></a>00108         temp_matrix.<a class="code" href="classlibMesh_1_1DenseMatrix.php#a493649f63f70ca2adeaee645e26a4677">vector_mult</a>(temp_vector, derived_basis_functions[j]);
<a name="l00109"></a>00109         RB_A_q_vector[q_a](i,j) = derived_basis_functions[i].dot(temp_vector);
<a name="l00110"></a>00110 
<a name="l00111"></a>00111         <span class="keywordflow">if</span>(i!=j)
<a name="l00112"></a>00112         {
<a name="l00113"></a>00113           temp_vector.<a class="code" href="classlibMesh_1_1DenseVector.php#a23868ec54dca234e5893e41a8b510d68">zero</a>();
<a name="l00114"></a>00114           temp_matrix.<a class="code" href="classlibMesh_1_1DenseMatrix.php#a493649f63f70ca2adeaee645e26a4677">vector_mult</a>(temp_vector, derived_basis_functions[i]);
<a name="l00115"></a>00115           RB_A_q_vector[q_a](j,i) = (derived_basis_functions[j]).dot(temp_vector);
<a name="l00116"></a>00116         }
<a name="l00117"></a>00117       }
<a name="l00118"></a>00118     }
<a name="l00119"></a>00119   }
<a name="l00120"></a>00120 
<a name="l00121"></a>00121   STOP_LOG(<span class="stringliteral">&quot;update_RB_system_matrices()&quot;</span>, <span class="stringliteral">&quot;DerivedRBSystem&quot;</span>);
<a name="l00122"></a>00122 }
<a name="l00123"></a>00123 
<a name="l00124"></a>00124 
<a name="l00125"></a>00125 <span class="keyword">template</span> &lt;&gt;
<a name="l00126"></a><a class="code" href="classlibMesh_1_1DerivedRBSystem.php#aadd62c118504ba1c3eabd05709f621bc">00126</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DerivedRBSystem.php#ab1ed3c5111bc4c9d887b11715e471d22">DerivedRBSystem&lt;RBSystem&gt;::update_residual_terms</a>(<span class="keywordtype">bool</span> compute_inner_products)
<a name="l00127"></a>00127 {
<a name="l00128"></a>00128   START_LOG(<span class="stringliteral">&quot;update_residual_terms()&quot;</span>, <span class="stringliteral">&quot;DerivedRBSystem&quot;</span>);
<a name="l00129"></a>00129   
<a name="l00130"></a>00130   <a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es = this-&gt;get_equation_systems();
<a name="l00131"></a>00131   <a class="code" href="classlibMesh_1_1RBSystem.php">RBSystem</a>&amp; uber_system = es.<a class="code" href="classlibMesh_1_1EquationSystems.php#a5dac23f839af25ce7dbf1fe9a6d4b67a">get_system</a>&lt;<a class="code" href="classlibMesh_1_1RBSystem.php">RBSystem</a>&gt;(uber_system_name);
<a name="l00132"></a>00132   
<a name="l00133"></a>00133   <span class="keywordflow">switch</span>(residual_type_flag)
<a name="l00134"></a>00134   {
<a name="l00135"></a>00135     <span class="keywordflow">case</span>(RESIDUAL_WRT_UBER):
<a name="l00136"></a>00136     {
<a name="l00137"></a>00137       <span class="comment">// First we need to compute the representors of</span>
<a name="l00138"></a>00138       <span class="comment">// each basis function using inner_product_matrix</span>
<a name="l00139"></a>00139 
<a name="l00140"></a>00140       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> derived_RB_size = get_n_basis_functions();
<a name="l00141"></a>00141       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> uber_RB_size = uber_system.<a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>();
<a name="l00142"></a>00142       <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> temp_vector1, temp_vector2;
<a name="l00143"></a>00143 
<a name="l00144"></a>00144       <span class="comment">// We only need to compute the representors for</span>
<a name="l00145"></a>00145       <span class="comment">// the right-hand side once.  Note: this will be called at least</span>
<a name="l00146"></a>00146       <span class="comment">// once even after a restart, in which case F_q_representor[0]</span>
<a name="l00147"></a>00147       <span class="comment">// will already be set.</span>
<a name="l00148"></a>00148       <span class="keywordflow">if</span>(!update_residual_terms_called)
<a name="l00149"></a>00149       {
<a name="l00150"></a>00150 
<a name="l00151"></a>00151         <span class="comment">// Assume inner product matrix is the identity, hence don&#39;t need to</span>
<a name="l00152"></a>00152         <span class="comment">// do any solves</span>
<a name="l00153"></a>00153         <span class="keywordflow">if</span> (compute_inner_products)
<a name="l00154"></a>00154         {
<a name="l00155"></a>00155           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q=0;
<a name="l00156"></a>00156           <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_f1=0; q_f1&lt;get_Q_f(); q_f1++)
<a name="l00157"></a>00157           {
<a name="l00158"></a>00158             <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_f2=q_f1; q_f2&lt;get_Q_f(); q_f2++)
<a name="l00159"></a>00159               {
<a name="l00160"></a>00160                 uber_system.<a class="code" href="classlibMesh_1_1RBSystem.php#ac2da8c5c36be49686429e74b4f9def1c">RB_F_q_vector</a>[q_f2].get_principal_subvector(uber_RB_size, temp_vector1);
<a name="l00161"></a>00161                 uber_system.<a class="code" href="classlibMesh_1_1RBSystem.php#ac2da8c5c36be49686429e74b4f9def1c">RB_F_q_vector</a>[q_f1].get_principal_subvector(uber_RB_size, temp_vector2);
<a name="l00162"></a>00162                 Fq_representor_norms[q] = temp_vector1.<a class="code" href="classlibMesh_1_1DenseVector.php#a740926ab2815bb507a1e33b659414be1">dot</a>( temp_vector2 );
<a name="l00163"></a>00163                 q++;
<a name="l00164"></a>00164               }
<a name="l00165"></a>00165           }
<a name="l00166"></a>00166         } <span class="comment">// end if (compute_inner_products)</span>
<a name="l00167"></a>00167 
<a name="l00168"></a>00168       } <span class="comment">// end if(!update_residual_terms_called)</span>
<a name="l00169"></a>00169 
<a name="l00170"></a>00170       <span class="comment">// Now compute and store the inner products (if requested)</span>
<a name="l00171"></a>00171       <span class="keywordflow">if</span> (compute_inner_products)
<a name="l00172"></a>00172       {
<a name="l00173"></a>00173 
<a name="l00174"></a>00174         <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Number&gt;</a> temp_matrix;
<a name="l00175"></a>00175         <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_f=0; q_f&lt;get_Q_f(); q_f++)
<a name="l00176"></a>00176           {
<a name="l00177"></a>00177             <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_a=0; q_a&lt;get_Q_a(); q_a++)
<a name="l00178"></a>00178               {
<a name="l00179"></a>00179                 <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=(derived_RB_size-delta_N); i&lt;derived_RB_size; i++)
<a name="l00180"></a>00180                   {
<a name="l00181"></a>00181                     uber_system.<a class="code" href="classlibMesh_1_1RBSystem.php#adadaf9a427ffbace640455436a4d4b26">RB_A_q_vector</a>[q_a].get_principal_submatrix(uber_RB_size, temp_matrix);
<a name="l00182"></a>00182                     temp_matrix.<a class="code" href="classlibMesh_1_1DenseMatrix.php#a493649f63f70ca2adeaee645e26a4677">vector_mult</a>(temp_vector1, derived_basis_functions[i]);
<a name="l00183"></a>00183                     uber_system.<a class="code" href="classlibMesh_1_1RBSystem.php#ac2da8c5c36be49686429e74b4f9def1c">RB_F_q_vector</a>[q_f].get_principal_subvector(uber_RB_size, temp_vector2);
<a name="l00184"></a>00184                     Fq_Aq_representor_norms[q_f][q_a][i] = -temp_vector1.<a class="code" href="classlibMesh_1_1DenseVector.php#a740926ab2815bb507a1e33b659414be1">dot</a>(temp_vector2);
<a name="l00185"></a>00185                   }
<a name="l00186"></a>00186               }
<a name="l00187"></a>00187           }
<a name="l00188"></a>00188 
<a name="l00189"></a>00189         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q=0;
<a name="l00190"></a>00190         <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_a1=0; q_a1&lt;get_Q_a(); q_a1++)
<a name="l00191"></a>00191           {
<a name="l00192"></a>00192             <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_a2=q_a1; q_a2&lt;get_Q_a(); q_a2++)
<a name="l00193"></a>00193               {
<a name="l00194"></a>00194                 <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=(derived_RB_size-delta_N); i&lt;derived_RB_size; i++)
<a name="l00195"></a>00195                   {
<a name="l00196"></a>00196                     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;derived_RB_size; j++)
<a name="l00197"></a>00197                       {
<a name="l00198"></a>00198                         uber_system.<a class="code" href="classlibMesh_1_1RBSystem.php#adadaf9a427ffbace640455436a4d4b26">RB_A_q_vector</a>[q_a1].get_principal_submatrix(uber_RB_size, temp_matrix);
<a name="l00199"></a>00199                         temp_matrix.<a class="code" href="classlibMesh_1_1DenseMatrix.php#a493649f63f70ca2adeaee645e26a4677">vector_mult</a>(temp_vector1, derived_basis_functions[i]);
<a name="l00200"></a>00200                         uber_system.<a class="code" href="classlibMesh_1_1RBSystem.php#adadaf9a427ffbace640455436a4d4b26">RB_A_q_vector</a>[q_a2].get_principal_submatrix(uber_RB_size, temp_matrix);
<a name="l00201"></a>00201                         temp_matrix.<a class="code" href="classlibMesh_1_1DenseMatrix.php#a493649f63f70ca2adeaee645e26a4677">vector_mult</a>(temp_vector2, derived_basis_functions[j]);
<a name="l00202"></a>00202                         Aq_Aq_representor_norms[q][i][j] = temp_vector1.<a class="code" href="classlibMesh_1_1DenseVector.php#a740926ab2815bb507a1e33b659414be1">dot</a>(temp_vector2);
<a name="l00203"></a>00203 
<a name="l00204"></a>00204                         <span class="keywordflow">if</span>(i != j)
<a name="l00205"></a>00205                           {
<a name="l00206"></a>00206                             uber_system.<a class="code" href="classlibMesh_1_1RBSystem.php#adadaf9a427ffbace640455436a4d4b26">RB_A_q_vector</a>[q_a1].get_principal_submatrix(uber_RB_size, temp_matrix);
<a name="l00207"></a>00207                             temp_matrix.<a class="code" href="classlibMesh_1_1DenseMatrix.php#a493649f63f70ca2adeaee645e26a4677">vector_mult</a>(temp_vector1, derived_basis_functions[j]);
<a name="l00208"></a>00208                             uber_system.<a class="code" href="classlibMesh_1_1RBSystem.php#adadaf9a427ffbace640455436a4d4b26">RB_A_q_vector</a>[q_a2].get_principal_submatrix(uber_RB_size, temp_matrix);
<a name="l00209"></a>00209                             temp_matrix.<a class="code" href="classlibMesh_1_1DenseMatrix.php#a493649f63f70ca2adeaee645e26a4677">vector_mult</a>(temp_vector2, derived_basis_functions[i]);
<a name="l00210"></a>00210                             Aq_Aq_representor_norms[q][j][i] = temp_vector1.<a class="code" href="classlibMesh_1_1DenseVector.php#a740926ab2815bb507a1e33b659414be1">dot</a>(temp_vector2);
<a name="l00211"></a>00211                           }
<a name="l00212"></a>00212                       }
<a name="l00213"></a>00213                   }
<a name="l00214"></a>00214                 q++;
<a name="l00215"></a>00215               }
<a name="l00216"></a>00216           }
<a name="l00217"></a>00217       } <span class="comment">// end if (compute_inner_products)</span>
<a name="l00218"></a>00218   
<a name="l00219"></a>00219       update_residual_terms_called = <span class="keyword">true</span>;
<a name="l00220"></a>00220       <span class="keywordflow">break</span>;
<a name="l00221"></a>00221     }
<a name="l00222"></a>00222           
<a name="l00223"></a>00223     <span class="keywordflow">case</span>(RESIDUAL_WRT_TRUTH):
<a name="l00224"></a>00224     {
<a name="l00225"></a>00225       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> RB_size = get_n_basis_functions();
<a name="l00226"></a>00226 
<a name="l00227"></a>00227       <span class="keywordflow">if</span>(!update_residual_terms_called)
<a name="l00228"></a>00228       {
<a name="l00229"></a>00229         <span class="comment">// Copy the output terms over from uber_system</span>
<a name="l00230"></a>00230         <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;get_n_outputs(); n++)
<a name="l00231"></a>00231         {
<a name="l00232"></a>00232           output_dual_norms[n] = uber_system.<a class="code" href="classlibMesh_1_1RBSystem.php#a2e3592b7167280ef4dd92cfb4a131c62">output_dual_norms</a>[n];
<a name="l00233"></a>00233         }
<a name="l00234"></a>00234 
<a name="l00235"></a>00235         <span class="comment">// Copy the Fq terms over from uber_system</span>
<a name="l00236"></a>00236         Fq_representor_norms = uber_system.<a class="code" href="classlibMesh_1_1RBSystem.php#a567c86950bb6d2ab2800ac0b14ed3dd2">Fq_representor_norms</a>;
<a name="l00237"></a>00237       }
<a name="l00238"></a>00238 
<a name="l00239"></a>00239       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_f=0; q_f&lt;get_Q_f(); q_f++)
<a name="l00240"></a>00240       {
<a name="l00241"></a>00241         <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_a=0; q_a&lt;get_Q_a(); q_a++)
<a name="l00242"></a>00242         {
<a name="l00243"></a>00243           <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=(RB_size-delta_N); i&lt;RB_size; i++)
<a name="l00244"></a>00244           {
<a name="l00245"></a>00245             Fq_Aq_representor_norms[q_f][q_a][i] = 0.;
<a name="l00246"></a>00246             <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;uber_system.<a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>(); j++) <span class="comment">// Evaluate the dot product</span>
<a name="l00247"></a>00247             {
<a name="l00248"></a>00248               Fq_Aq_representor_norms[q_f][q_a][i] +=
<a name="l00249"></a>00249                 uber_system.<a class="code" href="classlibMesh_1_1RBSystem.php#ac3d546a3eaa362377494da087e711608">Fq_Aq_representor_norms</a>[q_f][q_a][j] * derived_basis_functions[i](j);
<a name="l00250"></a>00250             }
<a name="l00251"></a>00251           }
<a name="l00252"></a>00252         }
<a name="l00253"></a>00253       }
<a name="l00254"></a>00254 
<a name="l00255"></a>00255       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q=0;
<a name="l00256"></a>00256       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_a1=0; q_a1&lt;get_Q_a(); q_a1++)
<a name="l00257"></a>00257       {
<a name="l00258"></a>00258         <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_a2=q_a1; q_a2&lt;get_Q_a(); q_a2++)
<a name="l00259"></a>00259         {
<a name="l00260"></a>00260           <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=(RB_size-delta_N); i&lt;RB_size; i++)
<a name="l00261"></a>00261           {
<a name="l00262"></a>00262             <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;RB_size; j++)
<a name="l00263"></a>00263             {
<a name="l00264"></a>00264 
<a name="l00265"></a>00265               Aq_Aq_representor_norms[q][i][j] = 0.;
<a name="l00266"></a>00266               <span class="keywordflow">if</span>(i != j)
<a name="l00267"></a>00267                 Aq_Aq_representor_norms[q][j][i] = 0.;
<a name="l00268"></a>00268 
<a name="l00269"></a>00269               <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k=0; k&lt;uber_system.<a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>(); k++)
<a name="l00270"></a>00270                 <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k_prime=0; k_prime&lt;uber_system.<a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>(); k_prime++)
<a name="l00271"></a>00271                 {
<a name="l00272"></a>00272                   Aq_Aq_representor_norms[q][i][j] += derived_basis_functions[i](k)*derived_basis_functions[j](k_prime)*
<a name="l00273"></a>00273                                                       uber_system.<a class="code" href="classlibMesh_1_1RBSystem.php#a668fed2dcb2e98adb2e7eea5bc7d853e">Aq_Aq_representor_norms</a>[q][k][k_prime];
<a name="l00274"></a>00274                                                  
<a name="l00275"></a>00275                   <span class="keywordflow">if</span>(i != j)
<a name="l00276"></a>00276                   {
<a name="l00277"></a>00277                     Aq_Aq_representor_norms[q][j][i] += derived_basis_functions[j](k)*derived_basis_functions[i](k_prime)*
<a name="l00278"></a>00278                                                         uber_system.<a class="code" href="classlibMesh_1_1RBSystem.php#a668fed2dcb2e98adb2e7eea5bc7d853e">Aq_Aq_representor_norms</a>[q][k][k_prime];
<a name="l00279"></a>00279                   }
<a name="l00280"></a>00280                 }
<a name="l00281"></a>00281             }
<a name="l00282"></a>00282           }
<a name="l00283"></a>00283           q++;
<a name="l00284"></a>00284         }
<a name="l00285"></a>00285       }
<a name="l00286"></a>00286 
<a name="l00287"></a>00287       update_residual_terms_called = <span class="keyword">true</span>;
<a name="l00288"></a>00288 
<a name="l00289"></a>00289       <span class="keywordflow">break</span>;
<a name="l00290"></a>00290     }
<a name="l00291"></a>00291 
<a name="l00292"></a>00292     <span class="keywordflow">default</span>:
<a name="l00293"></a>00293     {
<a name="l00294"></a>00294       <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Invalid RESIDUAL_TYPE in update_residual_terms&quot;</span> &lt;&lt; std::endl;
<a name="l00295"></a>00295       <span class="keywordflow">break</span>;
<a name="l00296"></a>00296     }
<a name="l00297"></a>00297   }
<a name="l00298"></a>00298 
<a name="l00299"></a>00299   STOP_LOG(<span class="stringliteral">&quot;update_residual_terms()&quot;</span>, <span class="stringliteral">&quot;DerivedRBSystem&quot;</span>);
<a name="l00300"></a>00300 }
<a name="l00301"></a>00301 
<a name="l00302"></a>00302 <span class="keyword">template</span>&lt;&gt;
<a name="l00303"></a><a class="code" href="classlibMesh_1_1DerivedRBSystem.php#a85c1ee302c186a0f44448279ee3da9ec">00303</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DerivedRBSystem.php#aeb89a2e51cbc02dd6e60fb9c77eef549">DerivedRBSystem&lt;RBSystem&gt;::load_RB_solution</a>()
<a name="l00304"></a>00304 {
<a name="l00305"></a>00305   START_LOG(<span class="stringliteral">&quot;load_RB_solution()&quot;</span>, <span class="stringliteral">&quot;DerivedRBSystem&quot;</span>);
<a name="l00306"></a>00306 
<a name="l00307"></a>00307   <span class="keywordflow">if</span>(!initialize_calN_dependent_data)
<a name="l00308"></a>00308   {
<a name="l00309"></a>00309     <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error: We must initialize the calN dependent &quot;</span>
<a name="l00310"></a>00310                  &lt;&lt; <span class="stringliteral">&quot;data structures in order to load RB solution.&quot;</span>
<a name="l00311"></a>00311                  &lt;&lt; std::endl;
<a name="l00312"></a>00312     libmesh_error();
<a name="l00313"></a>00313   }
<a name="l00314"></a>00314 
<a name="l00315"></a>00315   solution-&gt;zero();
<a name="l00316"></a>00316 
<a name="l00317"></a>00317   <span class="keywordflow">if</span>(RB_solution.size() &gt; get_n_basis_functions())
<a name="l00318"></a>00318   {
<a name="l00319"></a>00319     <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: System contains &quot;</span> &lt;&lt; get_n_basis_functions() &lt;&lt; <span class="stringliteral">&quot; basis functions.&quot;</span>
<a name="l00320"></a>00320                  &lt;&lt; <span class="stringliteral">&quot; RB_solution vector constains &quot;</span> &lt;&lt; RB_solution.size() &lt;&lt; <span class="stringliteral">&quot; entries.&quot;</span>
<a name="l00321"></a>00321                  &lt;&lt; <span class="stringliteral">&quot; RB_solution in RBSystem::load_RB_solution is too long!&quot;</span> &lt;&lt; std::endl;
<a name="l00322"></a>00322     libmesh_error();
<a name="l00323"></a>00323   }
<a name="l00324"></a>00324 
<a name="l00325"></a>00325   <a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es = this-&gt;get_equation_systems();
<a name="l00326"></a>00326   <a class="code" href="classlibMesh_1_1RBSystem.php">RBSystem</a>&amp; uber_system = es.<a class="code" href="classlibMesh_1_1EquationSystems.php#a5dac23f839af25ce7dbf1fe9a6d4b67a">get_system</a>&lt;<a class="code" href="classlibMesh_1_1RBSystem.php">RBSystem</a>&gt;(uber_system_name);
<a name="l00327"></a>00327 
<a name="l00328"></a>00328   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;RB_solution.size(); i++)
<a name="l00329"></a>00329     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;uber_system.<a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>(); j++)
<a name="l00330"></a>00330     {
<a name="l00331"></a>00331       solution-&gt;add(RB_solution(i)*derived_basis_functions[i](j), uber_system.<a class="code" href="classlibMesh_1_1RBSystem.php#a9ded22447be4ab3c0724bd060bfd9899">get_bf</a>(j));
<a name="l00332"></a>00332     }
<a name="l00333"></a>00333 
<a name="l00334"></a>00334   update();
<a name="l00335"></a>00335 
<a name="l00336"></a>00336   STOP_LOG(<span class="stringliteral">&quot;load_RB_solution()&quot;</span>, <span class="stringliteral">&quot;DerivedRBSystem&quot;</span>);
<a name="l00337"></a>00337 }
<a name="l00338"></a>00338 
<a name="l00339"></a>00339 }
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
