<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_eaf30c8ea092d33f79a04353c3899c3f.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_a22c90aabe52501ecb49e6e410e51a16.php">geom</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">stored_range.h</div>  </div>
</div>
<div class="contents">
<a href="stored__range_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id$</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __stored_range_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __stored_range_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="comment">// Local includes</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="threads_8h.php">threads.h</a>&quot;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="keyword">namespace </span>libMesh
<a name="l00032"></a>00032 {
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 
<a name="l00052"></a>00052 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> iterator_type, <span class="keyword">typename</span> <span class="keywordtype">object</span>_type&gt;
<a name="l00053"></a><a class="code" href="classlibMesh_1_1StoredRange.php">00053</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1StoredRange.php">StoredRange</a> 
<a name="l00054"></a>00054 {
<a name="l00055"></a>00055 <span class="keyword">public</span>:
<a name="l00059"></a><a class="code" href="classlibMesh_1_1StoredRange.php#a07c6e88eede585628af3437d8cad903f">00059</a>   <span class="keyword">typedef</span> <span class="keyword">typename</span> std::vector&lt;object_type&gt;::const_iterator <a class="code" href="classlibMesh_1_1StoredRange.php#a07c6e88eede585628af3437d8cad903f">const_iterator</a>;
<a name="l00060"></a>00060 
<a name="l00066"></a><a class="code" href="classlibMesh_1_1StoredRange.php#a3a1dfbb26a0bef88bfa38806c5f53bd3">00066</a>   <a class="code" href="classlibMesh_1_1StoredRange.php#a3a1dfbb26a0bef88bfa38806c5f53bd3">StoredRange</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1StoredRange.php#a6b8ccdf79669d164dddcf09cc3b1991b">grainsize</a> = 1000) :
<a name="l00067"></a>00067   <a class="code" href="classlibMesh_1_1StoredRange.php#a0dd7748951852d34cffcc9c2feea03a6">_grainsize</a>(<a class="code" href="classlibMesh_1_1StoredRange.php#a6b8ccdf79669d164dddcf09cc3b1991b">grainsize</a>)
<a name="l00068"></a>00068   {}
<a name="l00069"></a>00069 
<a name="l00076"></a><a class="code" href="classlibMesh_1_1StoredRange.php#a458013c6429e39b247b0a27ddc4925c8">00076</a>   <a class="code" href="classlibMesh_1_1StoredRange.php#a3a1dfbb26a0bef88bfa38806c5f53bd3">StoredRange</a> (<span class="keyword">const</span> iterator_type &amp;first,
<a name="l00077"></a>00077                <span class="keyword">const</span> iterator_type &amp;last,
<a name="l00078"></a>00078                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1StoredRange.php#a6b8ccdf79669d164dddcf09cc3b1991b">grainsize</a> = 1000) :
<a name="l00079"></a>00079   <a class="code" href="classlibMesh_1_1StoredRange.php#a0dd7748951852d34cffcc9c2feea03a6">_grainsize</a>(<a class="code" href="classlibMesh_1_1StoredRange.php#a6b8ccdf79669d164dddcf09cc3b1991b">grainsize</a>)
<a name="l00080"></a>00080   {
<a name="l00081"></a>00081     this-&gt;<a class="code" href="classlibMesh_1_1StoredRange.php#a4f7c25f4b4c7883aa39749fb384191c5">reset</a>(first, last);
<a name="l00082"></a>00082   }
<a name="l00083"></a>00083 
<a name="l00097"></a><a class="code" href="classlibMesh_1_1StoredRange.php#ae3dd9b80ecbf1b72e95d7bc5c717f5cc">00097</a>   <a class="code" href="classlibMesh_1_1StoredRange.php#a3a1dfbb26a0bef88bfa38806c5f53bd3">StoredRange</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1StoredRange.php">StoredRange&lt;iterator_type,object_type&gt;</a> &amp;er):
<a name="l00098"></a>00098     <a class="code" href="classlibMesh_1_1StoredRange.php#ab33f2561d66303e52a57dcc6dfea03b1">_end</a>(er.<a class="code" href="classlibMesh_1_1StoredRange.php#ab33f2561d66303e52a57dcc6dfea03b1">_end</a>), 
<a name="l00099"></a>00099     <a class="code" href="classlibMesh_1_1StoredRange.php#afa4a75f963bd242310f245cb04e1f208">_begin</a>(er.<a class="code" href="classlibMesh_1_1StoredRange.php#afa4a75f963bd242310f245cb04e1f208">_begin</a>),
<a name="l00100"></a>00100     <a class="code" href="classlibMesh_1_1StoredRange.php#a464850e04a770f2f06dd36164d0932ab">_last</a>(er.<a class="code" href="classlibMesh_1_1StoredRange.php#a464850e04a770f2f06dd36164d0932ab">_last</a>),
<a name="l00101"></a>00101     <a class="code" href="classlibMesh_1_1StoredRange.php#ac65cfe88cbe40e52418e48a79d6b2a53">_first</a>(er.<a class="code" href="classlibMesh_1_1StoredRange.php#ac65cfe88cbe40e52418e48a79d6b2a53">_first</a>),
<a name="l00102"></a>00102     <a class="code" href="classlibMesh_1_1StoredRange.php#a0dd7748951852d34cffcc9c2feea03a6">_grainsize</a>(er.<a class="code" href="classlibMesh_1_1StoredRange.php#a0dd7748951852d34cffcc9c2feea03a6">_grainsize</a>)
<a name="l00103"></a>00103   {
<a name="l00104"></a>00104     <span class="comment">// specifically, do *not* copy the vector</span>
<a name="l00105"></a>00105   }
<a name="l00106"></a>00106     
<a name="l00112"></a><a class="code" href="classlibMesh_1_1StoredRange.php#a6b049f2fcac81ee252a456aa24a5c01f">00112</a>   <a class="code" href="classlibMesh_1_1StoredRange.php#a3a1dfbb26a0bef88bfa38806c5f53bd3">StoredRange</a> (<a class="code" href="classlibMesh_1_1StoredRange.php">StoredRange&lt;iterator_type,object_type&gt;</a> &amp;r, <a class="code" href="classlibMesh_1_1Threads_1_1split.php">Threads::split</a> ) : 
<a name="l00113"></a>00113     <a class="code" href="classlibMesh_1_1StoredRange.php#ab33f2561d66303e52a57dcc6dfea03b1">_end</a>(r.<a class="code" href="classlibMesh_1_1StoredRange.php#ab33f2561d66303e52a57dcc6dfea03b1">_end</a>),
<a name="l00114"></a>00114     <a class="code" href="classlibMesh_1_1StoredRange.php#afa4a75f963bd242310f245cb04e1f208">_begin</a>(r.<a class="code" href="classlibMesh_1_1StoredRange.php#afa4a75f963bd242310f245cb04e1f208">_begin</a>),
<a name="l00115"></a>00115     <a class="code" href="classlibMesh_1_1StoredRange.php#a464850e04a770f2f06dd36164d0932ab">_last</a>(r.<a class="code" href="classlibMesh_1_1StoredRange.php#a464850e04a770f2f06dd36164d0932ab">_last</a>),
<a name="l00116"></a>00116     <a class="code" href="classlibMesh_1_1StoredRange.php#ac65cfe88cbe40e52418e48a79d6b2a53">_first</a>(r.<a class="code" href="classlibMesh_1_1StoredRange.php#ac65cfe88cbe40e52418e48a79d6b2a53">_first</a>),
<a name="l00117"></a>00117     <a class="code" href="classlibMesh_1_1StoredRange.php#a0dd7748951852d34cffcc9c2feea03a6">_grainsize</a>(r.<a class="code" href="classlibMesh_1_1StoredRange.php#a0dd7748951852d34cffcc9c2feea03a6">_grainsize</a>)
<a name="l00118"></a>00118   {
<a name="l00119"></a>00119     <a class="code" href="classlibMesh_1_1StoredRange.php#a07c6e88eede585628af3437d8cad903f">const_iterator</a>
<a name="l00120"></a>00120       beginning = r.<a class="code" href="classlibMesh_1_1StoredRange.php#afa4a75f963bd242310f245cb04e1f208">_begin</a>,
<a name="l00121"></a>00121       ending    = r.<a class="code" href="classlibMesh_1_1StoredRange.php#ab33f2561d66303e52a57dcc6dfea03b1">_end</a>,
<a name="l00122"></a>00122       middle    = beginning + std::distance(beginning, ending)/2u;
<a name="l00123"></a>00123     
<a name="l00124"></a>00124     r.<a class="code" href="classlibMesh_1_1StoredRange.php#ab33f2561d66303e52a57dcc6dfea03b1">_end</a> = <a class="code" href="classlibMesh_1_1StoredRange.php#afa4a75f963bd242310f245cb04e1f208">_begin</a> = middle;
<a name="l00125"></a>00125 
<a name="l00126"></a>00126     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>
<a name="l00127"></a>00127       first = r.<a class="code" href="classlibMesh_1_1StoredRange.php#ac65cfe88cbe40e52418e48a79d6b2a53">_first</a>,
<a name="l00128"></a>00128       last  = r.<a class="code" href="classlibMesh_1_1StoredRange.php#a464850e04a770f2f06dd36164d0932ab">_last</a>,
<a name="l00129"></a>00129       half  = first + (last-first)/2u;
<a name="l00130"></a>00130 
<a name="l00131"></a>00131     r.<a class="code" href="classlibMesh_1_1StoredRange.php#a464850e04a770f2f06dd36164d0932ab">_last</a> = <a class="code" href="classlibMesh_1_1StoredRange.php#ac65cfe88cbe40e52418e48a79d6b2a53">_first</a> = half;
<a name="l00132"></a>00132   }
<a name="l00133"></a>00133     
<a name="l00139"></a>00139   <a class="code" href="classlibMesh_1_1StoredRange.php">StoredRange&lt;iterator_type, object_type&gt;</a> &amp; 
<a name="l00140"></a><a class="code" href="classlibMesh_1_1StoredRange.php#a6769bcd5b501cb9a10cdbc85c64a2e72">00140</a>   <a class="code" href="classlibMesh_1_1StoredRange.php#a4f7c25f4b4c7883aa39749fb384191c5">reset</a> (<span class="keyword">const</span> iterator_type &amp;first,
<a name="l00141"></a>00141          <span class="keyword">const</span> iterator_type &amp;last)
<a name="l00142"></a>00142   {
<a name="l00143"></a>00143     <a class="code" href="classlibMesh_1_1StoredRange.php#ac1c9408f46667d5496a70473ffacff33">_objs</a>.clear();
<a name="l00144"></a>00144 
<a name="l00145"></a>00145     <span class="keywordflow">for</span> (iterator_type it=first; it!=last; ++it)
<a name="l00146"></a>00146       <a class="code" href="classlibMesh_1_1StoredRange.php#ac1c9408f46667d5496a70473ffacff33">_objs</a>.push_back(*it);
<a name="l00147"></a>00147     
<a name="l00148"></a>00148     <a class="code" href="classlibMesh_1_1StoredRange.php#afa4a75f963bd242310f245cb04e1f208">_begin</a> = <a class="code" href="classlibMesh_1_1StoredRange.php#ac1c9408f46667d5496a70473ffacff33">_objs</a>.begin();
<a name="l00149"></a>00149     <a class="code" href="classlibMesh_1_1StoredRange.php#ab33f2561d66303e52a57dcc6dfea03b1">_end</a>   = <a class="code" href="classlibMesh_1_1StoredRange.php#ac1c9408f46667d5496a70473ffacff33">_objs</a>.end();
<a name="l00150"></a>00150 
<a name="l00151"></a>00151     <a class="code" href="classlibMesh_1_1StoredRange.php#ac65cfe88cbe40e52418e48a79d6b2a53">_first</a> = 0;
<a name="l00152"></a>00152     <a class="code" href="classlibMesh_1_1StoredRange.php#a464850e04a770f2f06dd36164d0932ab">_last</a>  = <a class="code" href="classlibMesh_1_1StoredRange.php#ac1c9408f46667d5496a70473ffacff33">_objs</a>.size();
<a name="l00153"></a>00153     
<a name="l00154"></a>00154     <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00155"></a>00155   }
<a name="l00156"></a>00156 
<a name="l00164"></a><a class="code" href="classlibMesh_1_1StoredRange.php#a4f7c25f4b4c7883aa39749fb384191c5">00164</a>   <a class="code" href="classlibMesh_1_1StoredRange.php">StoredRange&lt;iterator_type, object_type&gt;</a> &amp; <a class="code" href="classlibMesh_1_1StoredRange.php#a4f7c25f4b4c7883aa39749fb384191c5">reset</a> ()
<a name="l00165"></a>00165   {
<a name="l00166"></a>00166     <a class="code" href="classlibMesh_1_1StoredRange.php#afa4a75f963bd242310f245cb04e1f208">_begin</a> = <a class="code" href="classlibMesh_1_1StoredRange.php#ac1c9408f46667d5496a70473ffacff33">_objs</a>.begin();
<a name="l00167"></a>00167     <a class="code" href="classlibMesh_1_1StoredRange.php#ab33f2561d66303e52a57dcc6dfea03b1">_end</a>   = <a class="code" href="classlibMesh_1_1StoredRange.php#ac1c9408f46667d5496a70473ffacff33">_objs</a>.end();
<a name="l00168"></a>00168 
<a name="l00169"></a>00169     <a class="code" href="classlibMesh_1_1StoredRange.php#ac65cfe88cbe40e52418e48a79d6b2a53">_first</a> = 0;
<a name="l00170"></a>00170     <a class="code" href="classlibMesh_1_1StoredRange.php#a464850e04a770f2f06dd36164d0932ab">_last</a>  = <a class="code" href="classlibMesh_1_1StoredRange.php#ac1c9408f46667d5496a70473ffacff33">_objs</a>.size();
<a name="l00171"></a>00171 
<a name="l00172"></a>00172     <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00173"></a>00173   }
<a name="l00174"></a>00174   
<a name="l00178"></a><a class="code" href="classlibMesh_1_1StoredRange.php#a9687da8abb136c142c4df14f4444737b">00178</a>   <a class="code" href="classlibMesh_1_1StoredRange.php#a07c6e88eede585628af3437d8cad903f">const_iterator</a> <a class="code" href="classlibMesh_1_1StoredRange.php#a9687da8abb136c142c4df14f4444737b">begin</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1StoredRange.php#afa4a75f963bd242310f245cb04e1f208">_begin</a>; }  
<a name="l00179"></a>00179   
<a name="l00183"></a><a class="code" href="classlibMesh_1_1StoredRange.php#aff337b550b3349015980e791dd982b21">00183</a>   <a class="code" href="classlibMesh_1_1StoredRange.php#a07c6e88eede585628af3437d8cad903f">const_iterator</a> <a class="code" href="classlibMesh_1_1StoredRange.php#aff337b550b3349015980e791dd982b21">end</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1StoredRange.php#ab33f2561d66303e52a57dcc6dfea03b1">_end</a>; }
<a name="l00184"></a>00184 
<a name="l00188"></a><a class="code" href="classlibMesh_1_1StoredRange.php#ac97b17b636979aeff8b549906e36fe1a">00188</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1StoredRange.php#ac97b17b636979aeff8b549906e36fe1a">first_idx</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1StoredRange.php#ac65cfe88cbe40e52418e48a79d6b2a53">_first</a>; }
<a name="l00189"></a>00189 
<a name="l00193"></a><a class="code" href="classlibMesh_1_1StoredRange.php#a761a91693a95bcda1505c2c1770db3d7">00193</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1StoredRange.php#a761a91693a95bcda1505c2c1770db3d7">last_idx</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1StoredRange.php#a464850e04a770f2f06dd36164d0932ab">_last</a>; }
<a name="l00194"></a>00194 
<a name="l00199"></a><a class="code" href="classlibMesh_1_1StoredRange.php#a6b8ccdf79669d164dddcf09cc3b1991b">00199</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1StoredRange.php#a6b8ccdf79669d164dddcf09cc3b1991b">grainsize</a> ()<span class="keyword"> const </span>{<span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1StoredRange.php#a0dd7748951852d34cffcc9c2feea03a6">_grainsize</a>;}
<a name="l00200"></a>00200 
<a name="l00204"></a><a class="code" href="classlibMesh_1_1StoredRange.php#a84618641926b5c141a5ff8a9b4499448">00204</a>   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1StoredRange.php#a84618641926b5c141a5ff8a9b4499448">grainsize</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> &amp;gs) {<a class="code" href="classlibMesh_1_1StoredRange.php#a0dd7748951852d34cffcc9c2feea03a6">_grainsize</a> = gs;}
<a name="l00205"></a>00205 
<a name="l00209"></a><a class="code" href="classlibMesh_1_1StoredRange.php#aadde9c3b9c818aaa0f5ca8788360a291">00209</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1StoredRange.php#aadde9c3b9c818aaa0f5ca8788360a291">size</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> std::distance(<a class="code" href="classlibMesh_1_1StoredRange.php#afa4a75f963bd242310f245cb04e1f208">_begin</a>, <a class="code" href="classlibMesh_1_1StoredRange.php#ab33f2561d66303e52a57dcc6dfea03b1">_end</a>); }
<a name="l00210"></a>00210 
<a name="l00211"></a>00211   <span class="comment">//------------------------------------------------------------------------</span>
<a name="l00212"></a>00212   <span class="comment">// Methods that implement Range concept</span>
<a name="l00213"></a>00213   <span class="comment">//------------------------------------------------------------------------</span>
<a name="l00214"></a>00214 
<a name="l00218"></a><a class="code" href="classlibMesh_1_1StoredRange.php#adea84b1d6e4d76b3738b32f6dd3e7160">00218</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1StoredRange.php#adea84b1d6e4d76b3738b32f6dd3e7160">empty</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> (<a class="code" href="classlibMesh_1_1StoredRange.php#afa4a75f963bd242310f245cb04e1f208">_begin</a> == <a class="code" href="classlibMesh_1_1StoredRange.php#ab33f2561d66303e52a57dcc6dfea03b1">_end</a>); }
<a name="l00219"></a>00219 
<a name="l00223"></a><a class="code" href="classlibMesh_1_1StoredRange.php#a71d873f71f5ba1a70d14ed2b1a7c766d">00223</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1StoredRange.php#a71d873f71f5ba1a70d14ed2b1a7c766d">is_divisible</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> this-&gt;<a class="code" href="classlibMesh_1_1StoredRange.php#a6b8ccdf79669d164dddcf09cc3b1991b">grainsize</a>() &lt; <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(std::distance(<a class="code" href="classlibMesh_1_1StoredRange.php#afa4a75f963bd242310f245cb04e1f208">_begin</a>, <a class="code" href="classlibMesh_1_1StoredRange.php#ab33f2561d66303e52a57dcc6dfea03b1">_end</a>)); }
<a name="l00224"></a>00224 
<a name="l00225"></a>00225 <span class="keyword">private</span>:
<a name="l00226"></a>00226 
<a name="l00227"></a><a class="code" href="classlibMesh_1_1StoredRange.php#ab33f2561d66303e52a57dcc6dfea03b1">00227</a>   <a class="code" href="classlibMesh_1_1StoredRange.php#a07c6e88eede585628af3437d8cad903f">const_iterator</a> <a class="code" href="classlibMesh_1_1StoredRange.php#ab33f2561d66303e52a57dcc6dfea03b1">_end</a>;
<a name="l00228"></a><a class="code" href="classlibMesh_1_1StoredRange.php#afa4a75f963bd242310f245cb04e1f208">00228</a>   <a class="code" href="classlibMesh_1_1StoredRange.php#a07c6e88eede585628af3437d8cad903f">const_iterator</a> <a class="code" href="classlibMesh_1_1StoredRange.php#afa4a75f963bd242310f245cb04e1f208">_begin</a>;
<a name="l00229"></a><a class="code" href="classlibMesh_1_1StoredRange.php#a464850e04a770f2f06dd36164d0932ab">00229</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1StoredRange.php#a464850e04a770f2f06dd36164d0932ab">_last</a>;
<a name="l00230"></a><a class="code" href="classlibMesh_1_1StoredRange.php#ac65cfe88cbe40e52418e48a79d6b2a53">00230</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1StoredRange.php#ac65cfe88cbe40e52418e48a79d6b2a53">_first</a>;
<a name="l00231"></a><a class="code" href="classlibMesh_1_1StoredRange.php#a0dd7748951852d34cffcc9c2feea03a6">00231</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1StoredRange.php#a0dd7748951852d34cffcc9c2feea03a6">_grainsize</a>;
<a name="l00232"></a><a class="code" href="classlibMesh_1_1StoredRange.php#ac1c9408f46667d5496a70473ffacff33">00232</a>   std::vector&lt;object_type&gt; <a class="code" href="classlibMesh_1_1StoredRange.php#ac1c9408f46667d5496a70473ffacff33">_objs</a>;
<a name="l00233"></a>00233 };
<a name="l00234"></a>00234 
<a name="l00235"></a>00235 } <span class="comment">// namespace libMesh</span>
<a name="l00236"></a>00236 
<a name="l00237"></a>00237 <span class="preprocessor">#endif // end #ifndef __stored_range_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
