<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_eaf30c8ea092d33f79a04353c3899c3f.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_5a0c7151fa56969ceb962f1511f7edee.php">systems</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">system.h</div>  </div>
</div>
<div class="contents">
<a href="system_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id$</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __system_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __system_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &lt;set&gt;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">// Local Includes</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="auto__ptr_8h.php">auto_ptr.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="elem__range_8h.php">elem_range.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="enum__norm__type_8h.php">enum_norm_type.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="enum__xdr__mode_8h.php">enum_xdr_mode.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="enum__parallel__type_8h.php">enum_parallel_type.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="fe__type_8h.php">fe_type.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;<a class="code" href="tensor__value_8h.php">tensor_value.h</a>&quot;</span> <span class="comment">// For point_hessian</span>
<a name="l00038"></a>00038 <span class="preprocessor">#include &quot;<a class="code" href="qoi__set_8h.php">qoi_set.h</a>&quot;</span>
<a name="l00039"></a>00039 <span class="preprocessor">#include &quot;<a class="code" href="reference__counted__object_8h.php">reference_counted_object.h</a>&quot;</span>
<a name="l00040"></a>00040 <span class="preprocessor">#include &quot;<a class="code" href="variable_8h.php">variable.h</a>&quot;</span>
<a name="l00041"></a>00041 
<a name="l00042"></a>00042 <span class="keyword">namespace </span>libMesh
<a name="l00043"></a>00043 {
<a name="l00044"></a>00044 
<a name="l00045"></a>00045 <span class="comment">// Forward Declarations</span>
<a name="l00046"></a>00046 <span class="keyword">class </span>System;
<a name="l00047"></a>00047 <span class="keyword">class </span>SystemNorm;
<a name="l00048"></a>00048 <span class="keyword">class </span>EquationSystems;
<a name="l00049"></a>00049 <span class="keyword">class </span>MeshBase;
<a name="l00050"></a>00050 <span class="keyword">class </span>Xdr;
<a name="l00051"></a>00051 <span class="keyword">class </span>DofMap;
<a name="l00052"></a>00052 <span class="keyword">class </span>Parameters;
<a name="l00053"></a>00053 <span class="keyword">class </span>ParameterVector;
<a name="l00054"></a>00054 <span class="keyword">class </span>Point;
<a name="l00055"></a>00055 <span class="keyword">class </span>SensitivityData;
<a name="l00056"></a>00056 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span>NumericVector;
<a name="l00057"></a>00057 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span>VectorValue;
<a name="l00058"></a>00058 <span class="keyword">typedef</span> VectorValue&lt;Number&gt; <a class="code" href="namespacelibMesh.php#af884edb27feca745082c13277a077832">NumberVectorValue</a>;
<a name="l00059"></a>00059 <span class="keyword">typedef</span> <a class="code" href="namespacelibMesh.php#af884edb27feca745082c13277a077832">NumberVectorValue</a> <a class="code" href="namespacelibMesh.php#a4b46bf2d57c1815051b6684921702ef2">Gradient</a>;
<a name="l00060"></a>00060 
<a name="l00073"></a>00073 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00074"></a>00074 <span class="comment">// System class definition</span>
<a name="l00075"></a><a class="code" href="classlibMesh_1_1System.php">00075</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1System.php">System</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1ReferenceCountedObject.php">ReferenceCountedObject</a>&lt;System&gt;
<a name="l00076"></a>00076 {
<a name="l00077"></a>00077 <span class="keyword">protected</span>:
<a name="l00078"></a>00078 
<a name="l00084"></a>00084   <a class="code" href="classlibMesh_1_1System.php#a7bd52dc210afb90d7304101d38a46357">System</a> (<a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00085"></a>00085           <span class="keyword">const</span> std::string&amp; <a class="code" href="classlibMesh_1_1System.php#af80f6b2e508821ebd9c8fcb78d443f18">name</a>,
<a name="l00086"></a>00086           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#aee5caacb487b070842733f1c84b9a2fd">number</a>);
<a name="l00087"></a>00087   
<a name="l00088"></a>00088 <span class="keyword">public</span>:
<a name="l00089"></a>00089 
<a name="l00090"></a>00090   
<a name="l00094"></a>00094   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1System.php#a419421462d140c9d4b71d3df59ff7722">~System</a> ();
<a name="l00095"></a>00095 
<a name="l00099"></a><a class="code" href="classlibMesh_1_1System.php#a89beaa12b7f2a89c42f1a3ede9a94ced">00099</a>   <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1System.php">System</a> <a class="code" href="classlibMesh_1_1System.php#a89beaa12b7f2a89c42f1a3ede9a94ced">sys_type</a>;
<a name="l00100"></a>00100 
<a name="l00104"></a><a class="code" href="classlibMesh_1_1System.php#a9e38c75024ebd02b2f17af5fde17eb75">00104</a>   <a class="code" href="classlibMesh_1_1System.php">sys_type</a> &amp; <a class="code" href="classlibMesh_1_1System.php#a9e38c75024ebd02b2f17af5fde17eb75">system</a> () { <span class="keywordflow">return</span> *<span class="keyword">this</span>; }
<a name="l00105"></a>00105   
<a name="l00110"></a>00110   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a8b6f936ce782fbd86cb4f3922def4cf0">clear</a> ();
<a name="l00111"></a>00111   
<a name="l00116"></a>00116   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a9cbe27bf56eae7baea5c397fa88c09a3">init</a> ();
<a name="l00117"></a>00117   
<a name="l00124"></a>00124   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a1cb3b5ae4fdd2f72d8fbddcadf3d3256">reinit</a> ();
<a name="l00125"></a>00125   
<a name="l00130"></a>00130   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#ab9d81ac9c1787c43fb87cf13d37741ee">update</a> ();
<a name="l00131"></a>00131   
<a name="l00138"></a>00138   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a79e4227a9e627031fac487cbd7c17250">assemble</a> ();
<a name="l00139"></a>00139 
<a name="l00144"></a>00144   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#ab57cde3f61d1816856e1100f068a25fa">assemble_qoi</a>
<a name="l00145"></a>00145     (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a> &amp;qoi_indices = <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a>());
<a name="l00146"></a>00146  
<a name="l00151"></a>00151   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a7d69df3b46fdd7073cfaaaf0fa71fbbc">assemble_qoi_derivative</a> 
<a name="l00152"></a>00152     (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a> &amp;qoi_indices = <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a>());
<a name="l00153"></a>00153  
<a name="l00165"></a>00165   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a1cc007b379ff2997715998c01106d790">assemble_residual_derivatives</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ParameterVector.php">ParameterVector</a>&amp; parameters);
<a name="l00166"></a>00166  
<a name="l00170"></a>00170   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#ab3e63f2241fc4a3647083b8fd16d2f4c">solve</a> () = 0;
<a name="l00171"></a>00171   
<a name="l00181"></a>00181   <span class="keyword">virtual</span> std::pair&lt;unsigned int, Real&gt;
<a name="l00182"></a>00182     <a class="code" href="classlibMesh_1_1System.php#a9dba69c2da2eff36d8c161d55ddcfb2c">sensitivity_solve</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ParameterVector.php">ParameterVector</a>&amp; parameters);
<a name="l00183"></a>00183   
<a name="l00194"></a>00194   <span class="keyword">virtual</span> std::pair&lt;unsigned int, Real&gt;
<a name="l00195"></a>00195     <a class="code" href="classlibMesh_1_1System.php#a12a66f71be2f232f7136905559c1bbdb">weighted_sensitivity_solve</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ParameterVector.php">ParameterVector</a>&amp; parameters,
<a name="l00196"></a>00196                                 <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ParameterVector.php">ParameterVector</a>&amp; weights);
<a name="l00197"></a>00197  
<a name="l00208"></a>00208   <span class="keyword">virtual</span> std::pair&lt;unsigned int, Real&gt;
<a name="l00209"></a>00209     <a class="code" href="classlibMesh_1_1System.php#a6e5b90b9bd6cf63a40cc77f02671a92d">adjoint_solve</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a>&amp; qoi_indices = <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a>());
<a name="l00210"></a>00210   
<a name="l00225"></a>00225   <span class="keyword">virtual</span> std::pair&lt;unsigned int, Real&gt;
<a name="l00226"></a>00226     <a class="code" href="classlibMesh_1_1System.php#a79ae2650c56afe266ec27ee2fea57957">weighted_sensitivity_adjoint_solve</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ParameterVector.php">ParameterVector</a>&amp; parameters,
<a name="l00227"></a>00227                                         <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ParameterVector.php">ParameterVector</a>&amp; weights,
<a name="l00228"></a>00228                                         <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a>&amp; qoi_indices = <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a>());
<a name="l00229"></a>00229  
<a name="l00247"></a>00247   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a4fd540ebc82189c84815d2e50b4a04c2">qoi_parameter_sensitivity</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a>&amp; qoi_indices,
<a name="l00248"></a>00248                                           <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ParameterVector.php">ParameterVector</a>&amp; parameters,
<a name="l00249"></a>00249                                           <a class="code" href="classlibMesh_1_1SensitivityData.php">SensitivityData</a>&amp; sensitivities);
<a name="l00250"></a>00250   
<a name="l00256"></a>00256   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a16e47d56606c347fbc996072f666c1b2">adjoint_qoi_parameter_sensitivity</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a>&amp; qoi_indices,
<a name="l00257"></a>00257                                                   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ParameterVector.php">ParameterVector</a>&amp; parameters,
<a name="l00258"></a>00258                                                   <a class="code" href="classlibMesh_1_1SensitivityData.php">SensitivityData</a>&amp; sensitivities);
<a name="l00259"></a>00259   
<a name="l00265"></a>00265   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#ab19259df51db305760418290ae5b2f57">forward_qoi_parameter_sensitivity</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a>&amp; qoi_indices,
<a name="l00266"></a>00266                                                   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ParameterVector.php">ParameterVector</a>&amp; parameters,
<a name="l00267"></a>00267                                                   <a class="code" href="classlibMesh_1_1SensitivityData.php">SensitivityData</a>&amp; sensitivities);
<a name="l00268"></a>00268   
<a name="l00279"></a>00279   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a941661b0198ad8fe5f9d62cfc5f9a03b">qoi_parameter_hessian</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a>&amp; qoi_indices,
<a name="l00280"></a>00280                                      <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ParameterVector.php">ParameterVector</a>&amp; parameters,
<a name="l00281"></a>00281                                      <a class="code" href="classlibMesh_1_1SensitivityData.php">SensitivityData</a>&amp; hessian);
<a name="l00282"></a>00282 
<a name="l00295"></a>00295   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a24bec5dc18f42bc87ad135a06aada457">qoi_parameter_hessian_vector_product</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a>&amp; qoi_indices,
<a name="l00296"></a>00296                                                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ParameterVector.php">ParameterVector</a>&amp; parameters,
<a name="l00297"></a>00297                                                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ParameterVector.php">ParameterVector</a>&amp; <a class="code" href="classstd_1_1vector.php">vector</a>,
<a name="l00298"></a>00298                                                     <a class="code" href="classlibMesh_1_1SensitivityData.php">SensitivityData</a>&amp; product);
<a name="l00299"></a>00299   
<a name="l00305"></a>00305   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1System.php#a8a3e5f73bb8c49d5d69ed59849e9b20e">compare</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a>&amp; other_system, 
<a name="l00306"></a>00306                         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> threshold,
<a name="l00307"></a>00307                         <span class="keyword">const</span> <span class="keywordtype">bool</span> verbose) <span class="keyword">const</span>;
<a name="l00308"></a>00308 
<a name="l00312"></a>00312   <span class="keyword">const</span> std::string &amp; <a class="code" href="classlibMesh_1_1System.php#af80f6b2e508821ebd9c8fcb78d443f18">name</a> () <span class="keyword">const</span>;
<a name="l00313"></a>00313 
<a name="l00319"></a><a class="code" href="classlibMesh_1_1System.php#af6548563b24dc5a00d12979b9869a4bf">00319</a>   <span class="keyword">virtual</span> std::string <a class="code" href="classlibMesh_1_1System.php#af6548563b24dc5a00d12979b9869a4bf">system_type</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="stringliteral">&quot;BasicSystem&quot;</span>; }
<a name="l00320"></a>00320 
<a name="l00324"></a>00324   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a2cf57ff5d137c7be896b2e1442e9916b">project_solution</a> (<a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> fptr(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p,
<a name="l00325"></a>00325                                      <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parameters.php">Parameters</a>&amp; parameters,
<a name="l00326"></a>00326                                      <span class="keyword">const</span> std::string&amp; sys_name,
<a name="l00327"></a>00327                                      <span class="keyword">const</span> std::string&amp; unknown_name),
<a name="l00328"></a>00328                          <a class="code" href="classlibMesh_1_1VectorValue.php">Gradient</a> gptr(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p,
<a name="l00329"></a>00329                                        <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parameters.php">Parameters</a>&amp; parameters,
<a name="l00330"></a>00330                                        <span class="keyword">const</span> std::string&amp; sys_name,
<a name="l00331"></a>00331                                        <span class="keyword">const</span> std::string&amp; unknown_name),
<a name="l00332"></a>00332                          <a class="code" href="classlibMesh_1_1Parameters.php">Parameters</a>&amp; parameters) <span class="keyword">const</span>;
<a name="l00333"></a>00333 
<a name="l00337"></a>00337   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#ac31376d8fbe17c9f3a341d0a599a98c1">project_vector</a> (<a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> fptr(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p,
<a name="l00338"></a>00338                                    <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parameters.php">Parameters</a>&amp; parameters,
<a name="l00339"></a>00339                                    <span class="keyword">const</span> std::string&amp; sys_name,
<a name="l00340"></a>00340                                    <span class="keyword">const</span> std::string&amp; unknown_name),
<a name="l00341"></a>00341                        <a class="code" href="classlibMesh_1_1VectorValue.php">Gradient</a> gptr(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p,
<a name="l00342"></a>00342                                      <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parameters.php">Parameters</a>&amp; parameters,
<a name="l00343"></a>00343                                      <span class="keyword">const</span> std::string&amp; sys_name,
<a name="l00344"></a>00344                                      <span class="keyword">const</span> std::string&amp; unknown_name),
<a name="l00345"></a>00345                        <a class="code" href="classlibMesh_1_1Parameters.php">Parameters</a>&amp; parameters,
<a name="l00346"></a>00346                        <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>&amp; new_vector) <span class="keyword">const</span>;
<a name="l00347"></a>00347   
<a name="l00351"></a>00351   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#aee5caacb487b070842733f1c84b9a2fd">number</a> () <span class="keyword">const</span>;
<a name="l00352"></a>00352   
<a name="l00358"></a>00358   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#ad4975cc3fa5f1e70fd9a6073a25abc78">update_global_solution</a> (std::vector&lt;Number&gt;&amp; global_soln) <span class="keyword">const</span>;
<a name="l00359"></a>00359 
<a name="l00365"></a>00365   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#ad4975cc3fa5f1e70fd9a6073a25abc78">update_global_solution</a> (std::vector&lt;Number&gt;&amp; global_soln,
<a name="l00366"></a>00366                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dest_proc) <span class="keyword">const</span>;
<a name="l00367"></a>00367 
<a name="l00371"></a>00371   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp; <a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">get_mesh</a>() <span class="keyword">const</span>;
<a name="l00372"></a>00372   
<a name="l00376"></a>00376   <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp; <a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">get_mesh</a>();
<a name="l00377"></a>00377   
<a name="l00381"></a>00381   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DofMap.php">DofMap</a> &amp; <a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>() <span class="keyword">const</span>;
<a name="l00382"></a>00382   
<a name="l00386"></a>00386   <a class="code" href="classlibMesh_1_1DofMap.php">DofMap</a> &amp; <a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>();
<a name="l00387"></a>00387 
<a name="l00391"></a><a class="code" href="classlibMesh_1_1System.php#ac5ca6b1f3adcfac56982982e90dc905b">00391</a>   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a> &amp; <a class="code" href="classlibMesh_1_1System.php#ac5ca6b1f3adcfac56982982e90dc905b">get_equation_systems</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1System.php#a99c9ba78a233464c052accdcbcc17153">_equation_systems</a>; }
<a name="l00392"></a>00392 
<a name="l00396"></a><a class="code" href="classlibMesh_1_1System.php#a6407174ed7461749bc7fb9c453f169cf">00396</a>   <a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a> &amp; <a class="code" href="classlibMesh_1_1System.php#a6407174ed7461749bc7fb9c453f169cf">get_equation_systems</a>() { <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1System.php#a99c9ba78a233464c052accdcbcc17153">_equation_systems</a>; }
<a name="l00397"></a>00397 
<a name="l00402"></a>00402   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1System.php#a0abd752d5ad75ea99581c65e0d5c2fb7">active</a> () <span class="keyword">const</span>;
<a name="l00403"></a>00403 
<a name="l00407"></a>00407   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a2caec05f9f5fbdeee0ed4a1245f5e150">activate</a> ();
<a name="l00408"></a>00408 
<a name="l00412"></a>00412   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a9ba45875ecfb9f9151a014cadac8109c">deactivate</a> ();
<a name="l00413"></a>00413 
<a name="l00417"></a><a class="code" href="classlibMesh_1_1System.php#a6a75b971c5614203f50d5a922df9253c">00417</a>   <span class="keyword">typedef</span> std::map&lt;std::string, NumericVector&lt;Number&gt;* &gt;::iterator       <a class="code" href="classlibMesh_1_1System.php#a6a75b971c5614203f50d5a922df9253c">vectors_iterator</a>;
<a name="l00418"></a><a class="code" href="classlibMesh_1_1System.php#aa4c2b06e622c0a42bce85716cad92fbd">00418</a>   <span class="keyword">typedef</span> std::map&lt;std::string, NumericVector&lt;Number&gt;* &gt;::const_iterator <a class="code" href="classlibMesh_1_1System.php#aa4c2b06e622c0a42bce85716cad92fbd">const_vectors_iterator</a>;
<a name="l00419"></a>00419 
<a name="l00423"></a>00423   <a class="code" href="classlibMesh_1_1System.php#a6a75b971c5614203f50d5a922df9253c">vectors_iterator</a> <a class="code" href="classlibMesh_1_1System.php#a293a39e0a532954f5c643b5d3650c048">vectors_begin</a> ();
<a name="l00424"></a>00424 
<a name="l00428"></a>00428   <a class="code" href="classlibMesh_1_1System.php#aa4c2b06e622c0a42bce85716cad92fbd">const_vectors_iterator</a> <a class="code" href="classlibMesh_1_1System.php#a293a39e0a532954f5c643b5d3650c048">vectors_begin</a> () <span class="keyword">const</span>;
<a name="l00429"></a>00429 
<a name="l00433"></a>00433   <a class="code" href="classlibMesh_1_1System.php#a6a75b971c5614203f50d5a922df9253c">vectors_iterator</a> <a class="code" href="classlibMesh_1_1System.php#a8bad75f37fdc2e047d73830d182e1314">vectors_end</a> ();
<a name="l00434"></a>00434 
<a name="l00438"></a>00438   <a class="code" href="classlibMesh_1_1System.php#aa4c2b06e622c0a42bce85716cad92fbd">const_vectors_iterator</a> <a class="code" href="classlibMesh_1_1System.php#a8bad75f37fdc2e047d73830d182e1314">vectors_end</a> () <span class="keyword">const</span>;
<a name="l00439"></a>00439 
<a name="l00450"></a>00450   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp; <a class="code" href="classlibMesh_1_1System.php#a59ce4b808a4b8226da70e1cfa36dad7c">add_vector</a> (<span class="keyword">const</span> std::string&amp; vec_name,
<a name="l00451"></a>00451                                                               <span class="keyword">const</span> <span class="keywordtype">bool</span> projections=<span class="keyword">true</span>,
<a name="l00452"></a>00452                                                               <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> type = <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">PARALLEL</a>);
<a name="l00453"></a>00453 
<a name="l00459"></a><a class="code" href="classlibMesh_1_1System.php#a04a93003e559fb4b266738e81fa52585">00459</a>   <span class="keywordtype">bool</span>&amp; <a class="code" href="classlibMesh_1_1System.php#a04a93003e559fb4b266738e81fa52585">project_solution_on_reinit</a> (<span class="keywordtype">void</span>)
<a name="l00460"></a>00460     { <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1System.php#a711acee387038ac906783a0d39d8e840">_solution_projection</a>; }
<a name="l00461"></a>00461   
<a name="l00466"></a>00466   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1System.php#a3d09f6a50bbf0d99489b88091d509a0f">have_vector</a> (<span class="keyword">const</span> std::string&amp; vec_name) <span class="keyword">const</span>;
<a name="l00467"></a>00467   
<a name="l00472"></a>00472   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> * <a class="code" href="classlibMesh_1_1System.php#aa1098d22312396ab1de8256f50c5a351">request_vector</a> (<span class="keyword">const</span> std::string&amp; vec_name) <span class="keyword">const</span>;
<a name="l00473"></a>00473   
<a name="l00478"></a>00478   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> * <a class="code" href="classlibMesh_1_1System.php#aa1098d22312396ab1de8256f50c5a351">request_vector</a> (<span class="keyword">const</span> std::string&amp; vec_name);
<a name="l00479"></a>00479   
<a name="l00485"></a>00485   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> * <a class="code" href="classlibMesh_1_1System.php#aa1098d22312396ab1de8256f50c5a351">request_vector</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> vec_num) <span class="keyword">const</span>;
<a name="l00486"></a>00486 
<a name="l00492"></a>00492   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> * <a class="code" href="classlibMesh_1_1System.php#aa1098d22312396ab1de8256f50c5a351">request_vector</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> vec_num);
<a name="l00493"></a>00493 
<a name="l00499"></a>00499   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp; <a class="code" href="classlibMesh_1_1System.php#a2ac8d1d590ae4b663bb7163c709c9e7a">get_vector</a> (<span class="keyword">const</span> std::string&amp; vec_name) <span class="keyword">const</span>;
<a name="l00500"></a>00500 
<a name="l00506"></a>00506   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp; <a class="code" href="classlibMesh_1_1System.php#a2ac8d1d590ae4b663bb7163c709c9e7a">get_vector</a> (<span class="keyword">const</span> std::string&amp; vec_name);
<a name="l00507"></a>00507 
<a name="l00513"></a>00513   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp; <a class="code" href="classlibMesh_1_1System.php#a2ac8d1d590ae4b663bb7163c709c9e7a">get_vector</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> vec_num) <span class="keyword">const</span>;
<a name="l00514"></a>00514 
<a name="l00520"></a>00520   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp; <a class="code" href="classlibMesh_1_1System.php#a2ac8d1d590ae4b663bb7163c709c9e7a">get_vector</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> vec_num);
<a name="l00521"></a>00521 
<a name="l00526"></a>00526   <span class="keyword">const</span> std::string &amp; <a class="code" href="classlibMesh_1_1System.php#a63a2a2e98a9932173e5b8607ab03687e">vector_name</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> vec_num);
<a name="l00527"></a>00527 
<a name="l00533"></a>00533   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp; <a class="code" href="classlibMesh_1_1System.php#ab5777831398d0a7a0d8ef2a231824989">add_adjoint_solution</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0);
<a name="l00534"></a>00534 
<a name="l00539"></a>00539   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp; <a class="code" href="classlibMesh_1_1System.php#aeaf02ff714b2d9b6aca4e8d696856529">get_adjoint_solution</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0);
<a name="l00540"></a>00540 
<a name="l00545"></a>00545   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp; <a class="code" href="classlibMesh_1_1System.php#aeaf02ff714b2d9b6aca4e8d696856529">get_adjoint_solution</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0) <span class="keyword">const</span>;
<a name="l00546"></a>00546 
<a name="l00552"></a>00552   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp; <a class="code" href="classlibMesh_1_1System.php#a8af728122cdd5677dc5a78e698bd1b35">add_sensitivity_solution</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0);
<a name="l00553"></a>00553 
<a name="l00558"></a>00558   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp; <a class="code" href="classlibMesh_1_1System.php#a920173d7f09d6f17b4451f354b7bccac">get_sensitivity_solution</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0);
<a name="l00559"></a>00559 
<a name="l00564"></a>00564   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp; <a class="code" href="classlibMesh_1_1System.php#a920173d7f09d6f17b4451f354b7bccac">get_sensitivity_solution</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0) <span class="keyword">const</span>;
<a name="l00565"></a>00565 
<a name="l00572"></a>00572   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp; <a class="code" href="classlibMesh_1_1System.php#a16e412144b3c5c1cc59cbb9e52b9ab05">add_weighted_sensitivity_adjoint_solution</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0);
<a name="l00573"></a>00573 
<a name="l00579"></a>00579   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp; <a class="code" href="classlibMesh_1_1System.php#a497665a8b66520f587e5e5102c94420c">get_weighted_sensitivity_adjoint_solution</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0);
<a name="l00580"></a>00580 
<a name="l00586"></a>00586   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp; <a class="code" href="classlibMesh_1_1System.php#a497665a8b66520f587e5e5102c94420c">get_weighted_sensitivity_adjoint_solution</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0) <span class="keyword">const</span>;
<a name="l00587"></a>00587 
<a name="l00593"></a>00593   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp; <a class="code" href="classlibMesh_1_1System.php#ae1922f73d344e6e1bea9100fec966e54">add_weighted_sensitivity_solution</a>();
<a name="l00594"></a>00594 
<a name="l00599"></a>00599   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp; <a class="code" href="classlibMesh_1_1System.php#ad4168ae004bc141639bb8b2b44de45cc">get_weighted_sensitivity_solution</a>();
<a name="l00600"></a>00600 
<a name="l00605"></a>00605   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp; <a class="code" href="classlibMesh_1_1System.php#ad4168ae004bc141639bb8b2b44de45cc">get_weighted_sensitivity_solution</a>() <span class="keyword">const</span>;
<a name="l00606"></a>00606 
<a name="l00612"></a>00612   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp; <a class="code" href="classlibMesh_1_1System.php#ab21c031f38c12ff111865623561b6687">add_adjoint_rhs</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0);
<a name="l00613"></a>00613 
<a name="l00620"></a>00620   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp; <a class="code" href="classlibMesh_1_1System.php#afe988921e219358881c49d1fa7303507">get_adjoint_rhs</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0);
<a name="l00621"></a>00621 
<a name="l00626"></a>00626   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp; <a class="code" href="classlibMesh_1_1System.php#afe988921e219358881c49d1fa7303507">get_adjoint_rhs</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0) <span class="keyword">const</span>;
<a name="l00627"></a>00627 
<a name="l00633"></a>00633   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp; <a class="code" href="classlibMesh_1_1System.php#a65312b9004fc31ba812b7ec32515a2fa">add_sensitivity_rhs</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0);
<a name="l00634"></a>00634 
<a name="l00644"></a>00644   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp; <a class="code" href="classlibMesh_1_1System.php#aad3023ee4c1d7ff532fab06136eed63c">get_sensitivity_rhs</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0);
<a name="l00645"></a>00645 
<a name="l00650"></a>00650   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp; <a class="code" href="classlibMesh_1_1System.php#aad3023ee4c1d7ff532fab06136eed63c">get_sensitivity_rhs</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0) <span class="keyword">const</span>;
<a name="l00651"></a>00651 
<a name="l00657"></a>00657   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#a46bd8cfb070bab2dc814c33749c8c21b">n_vectors</a> () <span class="keyword">const</span>;
<a name="l00658"></a>00658 
<a name="l00662"></a>00662   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#a4cf032eda109fe32a7fcde672ef5726e">n_vars</a>() <span class="keyword">const</span>;
<a name="l00663"></a>00663 
<a name="l00667"></a>00667   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#a90dbb901f00c14ff18399f4afabcebe5">n_dofs</a>() <span class="keyword">const</span>;
<a name="l00668"></a>00668 
<a name="l00673"></a>00673   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#ab87249ec70609d4d3376b7705829fee0">n_active_dofs</a>() <span class="keyword">const</span>;
<a name="l00674"></a>00674 
<a name="l00679"></a>00679   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#af44e0a3ba6dee841752b85b0c2b64854">n_constrained_dofs</a>() <span class="keyword">const</span>;
<a name="l00680"></a>00680   
<a name="l00685"></a>00685   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#ae3aeb82e65b06789823d41da3c5df7a2">n_local_dofs</a>() <span class="keyword">const</span>;
<a name="l00686"></a>00686 
<a name="l00691"></a>00691   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#a9455625733b8137030b388772b094817">add_variable</a> (<span class="keyword">const</span> std::string&amp; var,
<a name="l00692"></a>00692                              <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; type,
<a name="l00693"></a>00693                              <span class="keyword">const</span> std::set&lt;subdomain_id_type&gt; * <span class="keyword">const</span> active_subdomains = NULL);
<a name="l00694"></a>00694 
<a name="l00700"></a>00700   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#a9455625733b8137030b388772b094817">add_variable</a> (<span class="keyword">const</span> std::string&amp; var,
<a name="l00701"></a>00701                              <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> order = <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa4b49c3582d6a0be3b89e3af4493edda7">FIRST</a>,
<a name="l00702"></a>00702                              <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5">FEFamily</a> = <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5aee6cdf9773346876504bcbb02d199ab8">LAGRANGE</a>,
<a name="l00703"></a>00703                              <span class="keyword">const</span> std::set&lt;subdomain_id_type&gt; * <span class="keyword">const</span> active_subdomains = NULL);
<a name="l00704"></a>00704 
<a name="l00708"></a>00708   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Variable.php">Variable</a> &amp; <a class="code" href="classlibMesh_1_1System.php#a56d89ed534ffce5eda02dc0137583b56">variable</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var) <span class="keyword">const</span>;
<a name="l00709"></a>00709 
<a name="l00713"></a>00713   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1System.php#a700306a949024804a0933b98f406a71b">has_variable</a>(<span class="keyword">const</span> std::string&amp; var) <span class="keyword">const</span>;
<a name="l00714"></a>00714   
<a name="l00718"></a>00718   <span class="keyword">const</span> std::string &amp; <a class="code" href="classlibMesh_1_1System.php#a9cddad5dd8b68389373567fddfbdb257">variable_name</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00719"></a>00719   
<a name="l00724"></a>00724   <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#aeda27e9696b02cf965e2340fc9e64857">variable_number</a> (<span class="keyword">const</span> std::string&amp; var) <span class="keyword">const</span>;
<a name="l00725"></a>00725 
<a name="l00729"></a>00729   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a> &amp; <a class="code" href="classlibMesh_1_1System.php#ab321ab954fa1284069a647b311ff6d17">variable_type</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00730"></a>00730 
<a name="l00734"></a>00734   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a> &amp; <a class="code" href="classlibMesh_1_1System.php#ab321ab954fa1284069a647b311ff6d17">variable_type</a> (<span class="keyword">const</span> std::string&amp; var) <span class="keyword">const</span>;
<a name="l00735"></a>00735 
<a name="l00740"></a>00740   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1System.php#a3153155431e918a782fabedcaf58e4e6">calculate_norm</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>&amp; v,
<a name="l00741"></a>00741                       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var = 0,
<a name="l00742"></a>00742                       <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098">FEMNormType</a> norm_type = <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a81428a949c80fd4e4178fe53fa94ce92">L2</a>) <span class="keyword">const</span>;
<a name="l00743"></a>00743 
<a name="l00748"></a>00748   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1System.php#a3153155431e918a782fabedcaf58e4e6">calculate_norm</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>&amp; v,
<a name="l00749"></a>00749                       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1SystemNorm.php">SystemNorm</a> &amp;norm) <span class="keyword">const</span>;
<a name="l00750"></a>00750 
<a name="l00754"></a>00754   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a80a2d705f01a0e18de74e02ccf43bb83">read_header</a> (<a class="code" href="classlibMesh_1_1Xdr.php">Xdr</a>&amp; io,
<a name="l00755"></a>00755                     <span class="keyword">const</span> std::string &amp;version,
<a name="l00756"></a>00756                     <span class="keyword">const</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1System.php#a80a2d705f01a0e18de74e02ccf43bb83">read_header</a>=<span class="keyword">true</span>,
<a name="l00757"></a>00757                     <span class="keyword">const</span> <span class="keywordtype">bool</span> read_additional_data=<span class="keyword">true</span>,
<a name="l00758"></a>00758                     <span class="keyword">const</span> <span class="keywordtype">bool</span> read_legacy_format=<span class="keyword">false</span>);
<a name="l00759"></a>00759 
<a name="l00763"></a>00763   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a01d9de7172eb9ae886bbcba4aa3f9a2a">read_legacy_data</a> (<a class="code" href="classlibMesh_1_1Xdr.php">Xdr</a>&amp; io,
<a name="l00764"></a>00764                          <span class="keyword">const</span> <span class="keywordtype">bool</span> read_additional_data=<span class="keyword">true</span>);
<a name="l00765"></a>00765 
<a name="l00770"></a>00770   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a3eb0dd9d3ef0453daf9b5eeff0819736">read_serialized_data</a> (<a class="code" href="classlibMesh_1_1Xdr.php">Xdr</a>&amp; io,
<a name="l00771"></a>00771                              <span class="keyword">const</span> <span class="keywordtype">bool</span> read_additional_data=<span class="keyword">true</span>);
<a name="l00772"></a>00772 
<a name="l00779"></a>00779   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a13f952c98690727e4168a8b03918f008">read_parallel_data</a> (<a class="code" href="classlibMesh_1_1Xdr.php">Xdr</a> &amp;io,
<a name="l00780"></a>00780                            <span class="keyword">const</span> <span class="keywordtype">bool</span> read_additional_data);
<a name="l00784"></a>00784   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#ab85bb7019eaac1ceb8603975da8325ab">write_header</a> (<a class="code" href="classlibMesh_1_1Xdr.php">Xdr</a>&amp; io,
<a name="l00785"></a>00785                      <span class="keyword">const</span> std::string &amp;version,
<a name="l00786"></a>00786                      <span class="keyword">const</span> <span class="keywordtype">bool</span> write_additional_data) <span class="keyword">const</span>;
<a name="l00787"></a>00787 
<a name="l00792"></a>00792   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#ae8063c135acc9c54240886e1ac3c9acd">write_serialized_data</a> (<a class="code" href="classlibMesh_1_1Xdr.php">Xdr</a>&amp; io,
<a name="l00793"></a>00793                               <span class="keyword">const</span> <span class="keywordtype">bool</span> write_additional_data = <span class="keyword">true</span>) <span class="keyword">const</span>;
<a name="l00794"></a>00794 
<a name="l00801"></a>00801   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a6ce0f02169af7e0f55924c488bb63ad8">write_parallel_data</a> (<a class="code" href="classlibMesh_1_1Xdr.php">Xdr</a> &amp;io,
<a name="l00802"></a>00802                             <span class="keyword">const</span> <span class="keywordtype">bool</span> write_additional_data) <span class="keyword">const</span>;
<a name="l00803"></a>00803   
<a name="l00808"></a>00808   std::string <a class="code" href="classlibMesh_1_1System.php#a4d4e901465589bb4d2f6a8ce19d4e2c5">get_info</a> () <span class="keyword">const</span>;
<a name="l00809"></a>00809 
<a name="l00813"></a>00813   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a69c99bee95fdfc5b9a38cac034861496">attach_init_function</a> (<span class="keywordtype">void</span> fptr(<a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00814"></a>00814                                        <span class="keyword">const</span> std::string&amp; name));
<a name="l00815"></a>00815   
<a name="l00820"></a>00820   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a611b54551324acd1f072a1f809f5843a">attach_assemble_function</a> (<span class="keywordtype">void</span> fptr(<a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00821"></a>00821                                            <span class="keyword">const</span> std::string&amp; name));
<a name="l00822"></a>00822   
<a name="l00826"></a>00826   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a10381e68b0376de0772a5ba07982beba">attach_constraint_function</a> (<span class="keywordtype">void</span> fptr(<a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00827"></a>00827                                              <span class="keyword">const</span> std::string&amp; name));
<a name="l00828"></a>00828   
<a name="l00833"></a>00833   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a6471fddc304ce4a3de018b4fbf821135">attach_QOI_function</a> (<span class="keywordtype">void</span> fptr(<a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00834"></a>00834                                       <span class="keyword">const</span> std::string&amp; name,
<a name="l00835"></a>00835                                       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a>&amp; qoi_indices));
<a name="l00836"></a>00836   
<a name="l00842"></a>00842   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a6674774a0f6eb6648a63901491cd1973">attach_QOI_derivative</a> (<span class="keywordtype">void</span> fptr(<a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00843"></a>00843                                         <span class="keyword">const</span> std::string&amp; name,
<a name="l00844"></a>00844                                         <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a>&amp; qoi_indices));
<a name="l00845"></a>00845   
<a name="l00850"></a>00850   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a5f7a3a1e154fe61af97e966f3ab34ae2">user_initialization</a> ();
<a name="l00851"></a>00851   
<a name="l00856"></a>00856   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a792940ed6cca41b5dcaf878429a50253">user_assembly</a> ();
<a name="l00857"></a>00857   
<a name="l00862"></a>00862   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a8e857fcc4af2756cdd0d16563dfbbe83">user_constrain</a> ();
<a name="l00863"></a>00863 
<a name="l00868"></a>00868   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a3e75c1bd2055bb1bf9f5832a62c0039d">user_QOI</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a>&amp; qoi_indices);
<a name="l00869"></a>00869 
<a name="l00874"></a>00874   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#ab181e4e31e37f117493cc3d0f74d0f25">user_QOI_derivative</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a>&amp; qoi_indices);
<a name="l00875"></a>00875 
<a name="l00881"></a>00881   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a95f76b0ddbd8084a2a01a12495ebad2d">re_update</a> ();
<a name="l00882"></a>00882 
<a name="l00886"></a>00886   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a78af7f915ad5c678e3629ddced200967">restrict_vectors</a> ();
<a name="l00887"></a>00887 
<a name="l00891"></a>00891   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a55667d016781687feed399872671c963">prolong_vectors</a> ();
<a name="l00892"></a>00892 
<a name="l00898"></a>00898   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a>* <a class="code" href="classlibMesh_1_1System.php#a039694a88131a6f186c1e19a985bcc44">get_mesh_system</a>() <span class="keyword">const</span>;
<a name="l00899"></a>00899 
<a name="l00904"></a>00904   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#adfdcfb87806718445a09dd3255379301">get_mesh_x_var</a>() <span class="keyword">const</span>;
<a name="l00905"></a>00905 
<a name="l00910"></a>00910   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#a7ae8bd453e9335a699dc853e94d39a2e">get_mesh_y_var</a>() <span class="keyword">const</span>;
<a name="l00911"></a>00911 
<a name="l00916"></a>00916   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#a643a7f15d85ed211a9cb46d73bcb60b3">get_mesh_z_var</a>() <span class="keyword">const</span>;
<a name="l00917"></a>00917 
<a name="l00937"></a><a class="code" href="classlibMesh_1_1System.php#a6b24ccb769399c64405e8f8a52491e70">00937</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1System.php#a6b24ccb769399c64405e8f8a52491e70">assemble_before_solve</a>;
<a name="l00938"></a>00938 
<a name="l00948"></a><a class="code" href="classlibMesh_1_1System.php#a1fd435eb5b5e949702d92f28df85ea6b">00948</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1System.php#a1fd435eb5b5e949702d92f28df85ea6b">use_fixed_solution</a>;
<a name="l00949"></a>00949   
<a name="l00963"></a><a class="code" href="classlibMesh_1_1System.php#a078ffa703ae75f9e2505b4177af2e530">00963</a>   <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#a078ffa703ae75f9e2505b4177af2e530">extra_quadrature_order</a>;
<a name="l00964"></a>00964 
<a name="l00965"></a>00965 
<a name="l00966"></a>00966   <span class="comment">//--------------------------------------------------</span>
<a name="l00967"></a>00967   <span class="comment">// The solution and solution access members</span>
<a name="l00968"></a>00968   
<a name="l00973"></a>00973   <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> <a class="code" href="classlibMesh_1_1System.php#adad8bac609ebbd85b0c6aaafb8d3371e">current_solution</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> global_dof_number) <span class="keyword">const</span>;
<a name="l00974"></a>00974 
<a name="l00978"></a><a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">00978</a>   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;Number&gt;</a> &gt; <a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>;
<a name="l00979"></a>00979 
<a name="l00990"></a><a class="code" href="classlibMesh_1_1System.php#a1e1bec53fb8d8a5a2163dbee844e8417">00990</a>   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;Number&gt;</a> &gt; <a class="code" href="classlibMesh_1_1System.php#a1e1bec53fb8d8a5a2163dbee844e8417">current_local_solution</a>;
<a name="l00991"></a>00991 
<a name="l01001"></a><a class="code" href="classlibMesh_1_1System.php#a90b0537fa503134bfa91865a6995742e">01001</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1System.php#a90b0537fa503134bfa91865a6995742e">time</a>;
<a name="l01002"></a>01002 
<a name="l01009"></a><a class="code" href="classlibMesh_1_1System.php#a33fc90917ecd01516d3b284ad67968c6">01009</a>   std::vector&lt;Number&gt; <a class="code" href="classlibMesh_1_1System.php#a33fc90917ecd01516d3b284ad67968c6">qoi</a>;
<a name="l01010"></a>01010 
<a name="l01024"></a>01024   <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> <a class="code" href="classlibMesh_1_1System.php#af077a1b91c8b03020f2c6da41fcb72fb">point_value</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var, <a class="code" href="classlibMesh_1_1Point.php">Point</a> &amp;p);
<a name="l01025"></a>01025 
<a name="l01039"></a>01039   <a class="code" href="classlibMesh_1_1VectorValue.php">Gradient</a> <a class="code" href="classlibMesh_1_1System.php#a4e07b8705c855e9537944dd9f35ffd30">point_gradient</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var, <a class="code" href="classlibMesh_1_1Point.php">Point</a> &amp;p);
<a name="l01040"></a>01040 
<a name="l01054"></a>01054   <a class="code" href="classlibMesh_1_1TensorValue.php">Tensor</a> <a class="code" href="classlibMesh_1_1System.php#a6ea18ca2d8af1292053329c6ced7c549">point_hessian</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var, <a class="code" href="classlibMesh_1_1Point.php">Point</a> &amp;p);
<a name="l01055"></a>01055  
<a name="l01060"></a>01060   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a7184315a233256f4d8d0591d62b28f63">local_dof_indices</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var,
<a name="l01061"></a>01061                           std::set&lt;unsigned int&gt; &amp; var_indices) <span class="keyword">const</span>;
<a name="l01062"></a>01062 
<a name="l01067"></a>01067   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a1768b0db365db97ce4486167dca4efff">zero_variable</a> (<a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>&amp; v, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var_num) <span class="keyword">const</span>;
<a name="l01068"></a>01068 
<a name="l01069"></a>01069 <span class="keyword">protected</span>:
<a name="l01070"></a>01070 
<a name="l01076"></a>01076   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#aa82956a48e464a20f18426601ad511d4">init_data</a> ();
<a name="l01077"></a>01077 
<a name="l01082"></a>01082   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#ac31376d8fbe17c9f3a341d0a599a98c1">project_vector</a> (<a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>&amp;) <span class="keyword">const</span>;
<a name="l01083"></a>01083 
<a name="l01089"></a>01089   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#ac31376d8fbe17c9f3a341d0a599a98c1">project_vector</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>&amp;,
<a name="l01090"></a>01090                        <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>&amp;) <span class="keyword">const</span>;
<a name="l01091"></a>01091 
<a name="l01095"></a><a class="code" href="classlibMesh_1_1System.php#a5c1eb01a3714bd870f38e2493e8e200a">01095</a>   <a class="code" href="classlibMesh_1_1System.php">System</a> *<a class="code" href="classlibMesh_1_1System.php#a5c1eb01a3714bd870f38e2493e8e200a">_mesh_sys</a>;
<a name="l01096"></a>01096 
<a name="l01100"></a><a class="code" href="classlibMesh_1_1System.php#abe79ee716383ee682c44083728292e44">01100</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#a4ba10714ce3d0f2f0ebea5af774c0410">_mesh_x_var</a>, <a class="code" href="classlibMesh_1_1System.php#a6e5e444236409ae047939d411925029a">_mesh_y_var</a>, <a class="code" href="classlibMesh_1_1System.php#abe79ee716383ee682c44083728292e44">_mesh_z_var</a>;
<a name="l01101"></a>01101   
<a name="l01102"></a>01102 <span class="keyword">private</span>:
<a name="l01109"></a>01109   <a class="code" href="classlibMesh_1_1System.php#a7bd52dc210afb90d7304101d38a46357">System</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a>&amp;);
<a name="l01110"></a>01110 
<a name="l01117"></a>01117   <a class="code" href="classlibMesh_1_1System.php">System</a>&amp; <a class="code" href="classlibMesh_1_1System.php#a454d9868ada86f3dbfb1bdd84971b626">operator=</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a>&amp;);
<a name="l01118"></a>01118 
<a name="l01123"></a>01123   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1System.php#a9118db90385450eddb5738ce2f9ebec0">discrete_var_norm</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>&amp; v,
<a name="l01124"></a>01124                          <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var,
<a name="l01125"></a>01125                          <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098">FEMNormType</a> norm_type) <span class="keyword">const</span>;
<a name="l01126"></a>01126 
<a name="l01132"></a>01132   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> iterator_type&gt;
<a name="l01133"></a>01133   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#a3656a2d9faf108f1e230912ea5635d4f">read_serialized_blocked_dof_objects</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var,
<a name="l01134"></a>01134                                                     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ReferenceCounter.php#a50e74641afc6e2870c9e1ce412f8c44f">n_objects</a>,
<a name="l01135"></a>01135                                                     <span class="keyword">const</span> iterator_type begin,
<a name="l01136"></a>01136                                                     <span class="keyword">const</span> iterator_type end,
<a name="l01137"></a>01137                                                     <a class="code" href="classlibMesh_1_1Xdr.php">Xdr</a> &amp;io,
<a name="l01138"></a>01138                                                     <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp;vec) <span class="keyword">const</span>;
<a name="l01139"></a>01139 
<a name="l01144"></a>01144   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#a9059cad1ef841d18f1804c4c2837d17e">read_SCALAR_dofs</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var,
<a name="l01145"></a>01145                                  <a class="code" href="classlibMesh_1_1Xdr.php">Xdr</a> &amp;io,
<a name="l01146"></a>01146                                  <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp;vec) <span class="keyword">const</span>;
<a name="l01147"></a>01147 
<a name="l01152"></a>01152   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a1abcba5d9ffb5edf18c138eb2a0214c1">read_serialized_vector</a> (<a class="code" href="classlibMesh_1_1Xdr.php">Xdr</a>&amp; io,
<a name="l01153"></a>01153                                <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp;vec);
<a name="l01154"></a>01154 
<a name="l01159"></a>01159   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> iterator_type&gt;
<a name="l01160"></a>01160   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#ad06d512307afb47317e3215c52150021">write_serialized_blocked_dof_objects</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp;vec,
<a name="l01161"></a>01161                                                      <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var,
<a name="l01162"></a>01162                                                      <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ReferenceCounter.php#a50e74641afc6e2870c9e1ce412f8c44f">n_objects</a>,
<a name="l01163"></a>01163                                                      <span class="keyword">const</span> iterator_type begin,
<a name="l01164"></a>01164                                                      <span class="keyword">const</span> iterator_type end,
<a name="l01165"></a>01165                                                      <a class="code" href="classlibMesh_1_1Xdr.php">Xdr</a> &amp;io) <span class="keyword">const</span>;
<a name="l01166"></a>01166 
<a name="l01170"></a>01170   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#a25f805c53b81067c6460dad96d0eb8f6">write_SCALAR_dofs</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp;vec,
<a name="l01171"></a>01171                                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var,
<a name="l01172"></a>01172                                   <a class="code" href="classlibMesh_1_1Xdr.php">Xdr</a> &amp;io) <span class="keyword">const</span>;
<a name="l01173"></a>01173 
<a name="l01178"></a>01178   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a477f8f5cd5acba2aa5af78affa76b955">write_serialized_vector</a> (<a class="code" href="classlibMesh_1_1Xdr.php">Xdr</a>&amp; io,
<a name="l01179"></a>01179                                 <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp;vec) <span class="keyword">const</span>;
<a name="l01180"></a>01180 
<a name="l01184"></a><a class="code" href="classlibMesh_1_1System.php#a56216973e780410f4ffaf2d45173543d">01184</a>   void (* <a class="code" href="classlibMesh_1_1System.php#a56216973e780410f4ffaf2d45173543d">_init_system</a>) (<a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es,
<a name="l01185"></a>01185                          <span class="keyword">const</span> std::string&amp; <a class="code" href="classlibMesh_1_1System.php#af80f6b2e508821ebd9c8fcb78d443f18">name</a>);
<a name="l01186"></a>01186   
<a name="l01190"></a><a class="code" href="classlibMesh_1_1System.php#a35977f13fb34bbccf0594fd88001d8ba">01190</a>   void (* <a class="code" href="classlibMesh_1_1System.php#a35977f13fb34bbccf0594fd88001d8ba">_assemble_system</a>) (<a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es,
<a name="l01191"></a>01191                              <span class="keyword">const</span> std::string&amp; <a class="code" href="classlibMesh_1_1System.php#af80f6b2e508821ebd9c8fcb78d443f18">name</a>);
<a name="l01192"></a>01192 
<a name="l01196"></a><a class="code" href="classlibMesh_1_1System.php#ab7185cc600110514edca5468e7eba9f8">01196</a>   void (* <a class="code" href="classlibMesh_1_1System.php#ab7185cc600110514edca5468e7eba9f8">_constrain_system</a>) (<a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es, 
<a name="l01197"></a>01197                               <span class="keyword">const</span> std::string&amp; <a class="code" href="classlibMesh_1_1System.php#af80f6b2e508821ebd9c8fcb78d443f18">name</a>);
<a name="l01198"></a>01198 
<a name="l01202"></a><a class="code" href="classlibMesh_1_1System.php#a96abb602a58389dccbaff1cdd2f63af2">01202</a>   void (* <a class="code" href="classlibMesh_1_1System.php#a96abb602a58389dccbaff1cdd2f63af2">_qoi_evaluate</a>) (<a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es, 
<a name="l01203"></a>01203                           <span class="keyword">const</span> std::string&amp; <a class="code" href="classlibMesh_1_1System.php#af80f6b2e508821ebd9c8fcb78d443f18">name</a>,
<a name="l01204"></a>01204                           <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a>&amp; qoi_indices);
<a name="l01205"></a>01205 
<a name="l01209"></a><a class="code" href="classlibMesh_1_1System.php#a9c50c9fcb08d2170180694f1d11173bf">01209</a>   void (* <a class="code" href="classlibMesh_1_1System.php#a9c50c9fcb08d2170180694f1d11173bf">_qoi_evaluate_derivative</a>) (<a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es, 
<a name="l01210"></a>01210                                      <span class="keyword">const</span> std::string&amp; <a class="code" href="classlibMesh_1_1System.php#af80f6b2e508821ebd9c8fcb78d443f18">name</a>,
<a name="l01211"></a>01211                                      <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a>&amp; qoi_indices);
<a name="l01212"></a>01212 
<a name="l01217"></a><a class="code" href="classlibMesh_1_1System.php#a7386701e1324744b8d08db251374926b">01217</a>   <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;DofMap&gt;</a> <a class="code" href="classlibMesh_1_1System.php#a7386701e1324744b8d08db251374926b">_dof_map</a>;
<a name="l01218"></a>01218 
<a name="l01223"></a><a class="code" href="classlibMesh_1_1System.php#a99c9ba78a233464c052accdcbcc17153">01223</a>   <a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; <a class="code" href="classlibMesh_1_1System.php#a99c9ba78a233464c052accdcbcc17153">_equation_systems</a>;
<a name="l01224"></a>01224   
<a name="l01229"></a><a class="code" href="classlibMesh_1_1System.php#a6b1d416e0d9270f47499f7cdf3db3525">01229</a>   <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="classlibMesh_1_1System.php#a6b1d416e0d9270f47499f7cdf3db3525">_mesh</a>;
<a name="l01230"></a>01230   
<a name="l01234"></a><a class="code" href="classlibMesh_1_1System.php#aa6ed4b98503185caee2e333148b8f457">01234</a>   <span class="keyword">const</span> std::string <a class="code" href="classlibMesh_1_1System.php#aa6ed4b98503185caee2e333148b8f457">_sys_name</a>;
<a name="l01235"></a>01235 
<a name="l01239"></a><a class="code" href="classlibMesh_1_1System.php#a1ea531a98e00c4ddbcc170529561d72e">01239</a>   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#a1ea531a98e00c4ddbcc170529561d72e">_sys_number</a>;
<a name="l01240"></a>01240   
<a name="l01244"></a><a class="code" href="classlibMesh_1_1System.php#a17fc76a7e9339dcc3c834a646169bf0e">01244</a>   std::vector&lt;Variable&gt; <a class="code" href="classlibMesh_1_1System.php#a17fc76a7e9339dcc3c834a646169bf0e">_variables</a>;
<a name="l01245"></a>01245 
<a name="l01250"></a><a class="code" href="classlibMesh_1_1System.php#aca4105a9e0b687784fa38b95bd999d80">01250</a>   std::map&lt;std::string, unsigned short int&gt; <a class="code" href="classlibMesh_1_1System.php#aca4105a9e0b687784fa38b95bd999d80">_variable_numbers</a>;
<a name="l01251"></a>01251 
<a name="l01255"></a><a class="code" href="classlibMesh_1_1System.php#aee881365cfab1a56929cf344a34e9585">01255</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1System.php#aee881365cfab1a56929cf344a34e9585">_active</a>;
<a name="l01256"></a>01256   
<a name="l01263"></a><a class="code" href="classlibMesh_1_1System.php#a4068a7b090c2b32e2c73c018b4e22a80">01263</a>   std::map&lt;std::string, NumericVector&lt;Number&gt;* &gt; <a class="code" href="classlibMesh_1_1System.php#a4068a7b090c2b32e2c73c018b4e22a80">_vectors</a>;
<a name="l01264"></a>01264 
<a name="l01269"></a><a class="code" href="classlibMesh_1_1System.php#a96f148e01190c571cc92789fb5cd5ca4">01269</a>   std::map&lt;std::string, bool&gt; <a class="code" href="classlibMesh_1_1System.php#a96f148e01190c571cc92789fb5cd5ca4">_vector_projections</a>;
<a name="l01270"></a>01270 
<a name="l01274"></a><a class="code" href="classlibMesh_1_1System.php#a2623509811966d32d649c6c135f43c6c">01274</a>   std::map&lt;std::string, ParallelType&gt; <a class="code" href="classlibMesh_1_1System.php#a2623509811966d32d649c6c135f43c6c">_vector_types</a>;
<a name="l01275"></a>01275 
<a name="l01281"></a><a class="code" href="classlibMesh_1_1System.php#a711acee387038ac906783a0d39d8e840">01281</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1System.php#a711acee387038ac906783a0d39d8e840">_solution_projection</a>;
<a name="l01282"></a>01282 
<a name="l01286"></a><a class="code" href="classlibMesh_1_1System.php#adc22ea07ed2a681eef304a471715cc85">01286</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1System.php#adc22ea07ed2a681eef304a471715cc85">_can_add_vectors</a>;
<a name="l01287"></a>01287 
<a name="l01293"></a><a class="code" href="classlibMesh_1_1System.php#a35519cd3073b5cdc687b8ca7ee60af98">01293</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1System.php#a35519cd3073b5cdc687b8ca7ee60af98">_additional_data_written</a>;
<a name="l01294"></a>01294 
<a name="l01295"></a>01295 
<a name="l01301"></a><a class="code" href="classlibMesh_1_1System_1_1ProjectVector.php">01301</a>   <span class="keyword">class </span><a class="code" href="classlibMesh_1_1System_1_1ProjectVector.php">ProjectVector</a> 
<a name="l01302"></a>01302   {
<a name="l01303"></a>01303   <span class="keyword">private</span>:
<a name="l01304"></a><a class="code" href="classlibMesh_1_1System_1_1ProjectVector.php#a97b60552832b10ea11d2bf1dde95d35d">01304</a>     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a>                &amp;<a class="code" href="classlibMesh_1_1System_1_1ProjectVector.php#a97b60552832b10ea11d2bf1dde95d35d">system</a>;
<a name="l01305"></a><a class="code" href="classlibMesh_1_1System_1_1ProjectVector.php#a0d9e9aada8dd86375a4b919ea5608fa3">01305</a>     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp;<a class="code" href="classlibMesh_1_1System_1_1ProjectVector.php#a0d9e9aada8dd86375a4b919ea5608fa3">old_vector</a>;
<a name="l01306"></a><a class="code" href="classlibMesh_1_1System_1_1ProjectVector.php#af68ee9baa1c1a8be5729898be236b063">01306</a>     <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>       &amp;<a class="code" href="classlibMesh_1_1System_1_1ProjectVector.php#af68ee9baa1c1a8be5729898be236b063">new_vector</a>;
<a name="l01307"></a>01307 
<a name="l01308"></a>01308   <span class="keyword">public</span>:
<a name="l01309"></a><a class="code" href="classlibMesh_1_1System_1_1ProjectVector.php#a7a3c3ab89770051b52ed06d7552803be">01309</a>     <a class="code" href="classlibMesh_1_1System_1_1ProjectVector.php#a7a3c3ab89770051b52ed06d7552803be">ProjectVector</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a> &amp;system_in,
<a name="l01310"></a>01310                    <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp;old_v_in,
<a name="l01311"></a>01311                    <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp;new_v_in) :
<a name="l01312"></a>01312     <a class="code" href="classlibMesh_1_1System_1_1ProjectVector.php#a97b60552832b10ea11d2bf1dde95d35d">system</a>(system_in),
<a name="l01313"></a>01313     <a class="code" href="classlibMesh_1_1System_1_1ProjectVector.php#a0d9e9aada8dd86375a4b919ea5608fa3">old_vector</a>(old_v_in),
<a name="l01314"></a>01314     <a class="code" href="classlibMesh_1_1System_1_1ProjectVector.php#af68ee9baa1c1a8be5729898be236b063">new_vector</a>(new_v_in)
<a name="l01315"></a>01315     {}
<a name="l01316"></a>01316     
<a name="l01317"></a>01317     <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System_1_1ProjectVector.php#aac4a001d5e37cd11933a1bd7bf7115a4">operator()</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1StoredRange.php">ConstElemRange</a> &amp;range) <span class="keyword">const</span>;
<a name="l01318"></a>01318   };
<a name="l01319"></a>01319 
<a name="l01320"></a>01320 
<a name="l01330"></a><a class="code" href="classlibMesh_1_1System_1_1BuildProjectionList.php">01330</a>   <span class="keyword">class </span><a class="code" href="classlibMesh_1_1System_1_1BuildProjectionList.php">BuildProjectionList</a>
<a name="l01331"></a>01331   {
<a name="l01332"></a>01332   <span class="keyword">private</span>:
<a name="l01333"></a><a class="code" href="classlibMesh_1_1System_1_1BuildProjectionList.php#a0c56ee775e16120d04ee8eced39d9d48">01333</a>     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a>              &amp;<a class="code" href="classlibMesh_1_1System_1_1BuildProjectionList.php#a0c56ee775e16120d04ee8eced39d9d48">system</a>;
<a name="l01334"></a>01334 
<a name="l01335"></a>01335   <span class="keyword">public</span>:
<a name="l01336"></a><a class="code" href="classlibMesh_1_1System_1_1BuildProjectionList.php#a87042251957ae12fa6934e0e41633d90">01336</a>     <a class="code" href="classlibMesh_1_1System_1_1BuildProjectionList.php#a87042251957ae12fa6934e0e41633d90">BuildProjectionList</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a> &amp;system_in) :
<a name="l01337"></a>01337     <a class="code" href="classlibMesh_1_1System_1_1BuildProjectionList.php#a0c56ee775e16120d04ee8eced39d9d48">system</a>(system_in)
<a name="l01338"></a>01338     {}
<a name="l01339"></a>01339 
<a name="l01340"></a><a class="code" href="classlibMesh_1_1System_1_1BuildProjectionList.php#a38632ff4a8aeae23d7ebcf800893282e">01340</a>     <a class="code" href="classlibMesh_1_1System_1_1BuildProjectionList.php#a87042251957ae12fa6934e0e41633d90">BuildProjectionList</a> (<a class="code" href="classlibMesh_1_1System_1_1BuildProjectionList.php">BuildProjectionList</a> &amp;other, <a class="code" href="classlibMesh_1_1Threads_1_1split.php">Threads::split</a>) :
<a name="l01341"></a>01341      <a class="code" href="classlibMesh_1_1System_1_1BuildProjectionList.php#a0c56ee775e16120d04ee8eced39d9d48">system</a>(other.<a class="code" href="classlibMesh_1_1System_1_1BuildProjectionList.php#a0c56ee775e16120d04ee8eced39d9d48">system</a>)
<a name="l01342"></a>01342     {}
<a name="l01343"></a>01343     
<a name="l01344"></a>01344     <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System_1_1BuildProjectionList.php#a688346b5a79bda8d3e3bf33641669526">unique</a>();
<a name="l01345"></a>01345     <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System_1_1BuildProjectionList.php#aeeb6917d0ff898d305f19204b4cff572">operator()</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1StoredRange.php">ConstElemRange</a> &amp;range);
<a name="l01346"></a>01346     <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System_1_1BuildProjectionList.php#a1839efc2a5864e8af4762cde5258a7c2">join</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System_1_1BuildProjectionList.php">BuildProjectionList</a> &amp;other);
<a name="l01347"></a><a class="code" href="classlibMesh_1_1System_1_1BuildProjectionList.php#a960cac38bbea936b05e469998f702d4d">01347</a>     std::vector&lt;unsigned int&gt; <a class="code" href="classlibMesh_1_1System_1_1BuildProjectionList.php#a960cac38bbea936b05e469998f702d4d">send_list</a>;
<a name="l01348"></a>01348   };
<a name="l01349"></a>01349 
<a name="l01350"></a>01350 
<a name="l01351"></a>01351 
<a name="l01357"></a><a class="code" href="classlibMesh_1_1System_1_1ProjectSolution.php">01357</a>   <span class="keyword">class </span><a class="code" href="classlibMesh_1_1System_1_1ProjectSolution.php">ProjectSolution</a>
<a name="l01358"></a>01358   {
<a name="l01359"></a>01359   <span class="keyword">private</span>:
<a name="l01360"></a><a class="code" href="classlibMesh_1_1System_1_1ProjectSolution.php#a2e8457cb0939704390ce0d04d42bc6b7">01360</a>     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a>                &amp;<a class="code" href="classlibMesh_1_1System_1_1ProjectSolution.php#a2e8457cb0939704390ce0d04d42bc6b7">system</a>;
<a name="l01361"></a>01361 
<a name="l01362"></a><a class="code" href="classlibMesh_1_1System_1_1ProjectSolution.php#ae8735452c8c41d36a9893c0851009aec">01362</a>     <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> (* <a class="code" href="classlibMesh_1_1System_1_1ProjectSolution.php#ae8735452c8c41d36a9893c0851009aec">fptr</a>)(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p,
<a name="l01363"></a>01363                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parameters.php">Parameters</a>&amp; <a class="code" href="classlibMesh_1_1System_1_1ProjectSolution.php#a916a8e4cf3af5c242e2cef1bc4c589e4">parameters</a>,
<a name="l01364"></a>01364                     <span class="keyword">const</span> std::string&amp; sys_name,
<a name="l01365"></a>01365                     <span class="keyword">const</span> std::string&amp; unknown_name);
<a name="l01366"></a>01366 
<a name="l01367"></a><a class="code" href="classlibMesh_1_1System_1_1ProjectSolution.php#a4ae24673a50a860fd242cefce09af53d">01367</a>     <a class="code" href="namespacelibMesh.php#a4b46bf2d57c1815051b6684921702ef2">Gradient</a> (* <a class="code" href="classlibMesh_1_1System_1_1ProjectSolution.php#a4ae24673a50a860fd242cefce09af53d">gptr</a>)(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p,
<a name="l01368"></a>01368                       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parameters.php">Parameters</a>&amp; <a class="code" href="classlibMesh_1_1System_1_1ProjectSolution.php#a916a8e4cf3af5c242e2cef1bc4c589e4">parameters</a>,
<a name="l01369"></a>01369                       <span class="keyword">const</span> std::string&amp; sys_name,
<a name="l01370"></a>01370                       <span class="keyword">const</span> std::string&amp; unknown_name);
<a name="l01371"></a>01371 
<a name="l01372"></a><a class="code" href="classlibMesh_1_1System_1_1ProjectSolution.php#a916a8e4cf3af5c242e2cef1bc4c589e4">01372</a>     <a class="code" href="classlibMesh_1_1Parameters.php">Parameters</a> &amp;<a class="code" href="classlibMesh_1_1System_1_1ProjectSolution.php#a916a8e4cf3af5c242e2cef1bc4c589e4">parameters</a>;
<a name="l01373"></a><a class="code" href="classlibMesh_1_1System_1_1ProjectSolution.php#a728612268b8c23d87f0bee5e45ac65ae">01373</a>     <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>       &amp;<a class="code" href="classlibMesh_1_1System_1_1ProjectSolution.php#a728612268b8c23d87f0bee5e45ac65ae">new_vector</a>;
<a name="l01374"></a>01374 
<a name="l01375"></a>01375   <span class="keyword">public</span>:
<a name="l01376"></a><a class="code" href="classlibMesh_1_1System_1_1ProjectSolution.php#a353d6f1d08d8e2802ea6430d2b58c9ac">01376</a>     <a class="code" href="classlibMesh_1_1System_1_1ProjectSolution.php#a353d6f1d08d8e2802ea6430d2b58c9ac">ProjectSolution</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a> &amp;system_in,
<a name="l01377"></a>01377                      <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> fptr_in(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p,
<a name="l01378"></a>01378                                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parameters.php">Parameters</a>&amp; parameters,
<a name="l01379"></a>01379                                     <span class="keyword">const</span> std::string&amp; sys_name,
<a name="l01380"></a>01380                                     <span class="keyword">const</span> std::string&amp; unknown_name),
<a name="l01381"></a>01381                      <a class="code" href="classlibMesh_1_1VectorValue.php">Gradient</a> gptr_in(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p,
<a name="l01382"></a>01382                                       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parameters.php">Parameters</a>&amp; parameters,
<a name="l01383"></a>01383                                       <span class="keyword">const</span> std::string&amp; sys_name,
<a name="l01384"></a>01384                                       <span class="keyword">const</span> std::string&amp; unknown_name),
<a name="l01385"></a>01385                      <a class="code" href="classlibMesh_1_1Parameters.php">Parameters</a> &amp;parameters_in,
<a name="l01386"></a>01386                      <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp;new_v_in) :
<a name="l01387"></a>01387     <a class="code" href="classlibMesh_1_1System_1_1ProjectSolution.php#a2e8457cb0939704390ce0d04d42bc6b7">system</a>(system_in),
<a name="l01388"></a>01388     <a class="code" href="classlibMesh_1_1System_1_1ProjectSolution.php#ae8735452c8c41d36a9893c0851009aec">fptr</a>(fptr_in),
<a name="l01389"></a>01389     <a class="code" href="classlibMesh_1_1System_1_1ProjectSolution.php#a4ae24673a50a860fd242cefce09af53d">gptr</a>(gptr_in),
<a name="l01390"></a>01390     parameters(parameters_in),
<a name="l01391"></a>01391     <a class="code" href="classlibMesh_1_1System_1_1ProjectSolution.php#a728612268b8c23d87f0bee5e45ac65ae">new_vector</a>(new_v_in)
<a name="l01392"></a>01392     {}
<a name="l01393"></a>01393     
<a name="l01394"></a>01394     <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System_1_1ProjectSolution.php#a91eb814c7a3e588b03b92b3a3c9af7a2">operator()</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1StoredRange.php">ConstElemRange</a> &amp;range) <span class="keyword">const</span>;
<a name="l01395"></a>01395   };
<a name="l01396"></a>01396 };
<a name="l01397"></a>01397 
<a name="l01398"></a>01398 
<a name="l01399"></a>01399 
<a name="l01400"></a>01400 <span class="comment">// ------------------------------------------------------------</span>
<a name="l01401"></a>01401 <span class="comment">// System inline methods</span>
<a name="l01402"></a>01402 <span class="keyword">inline</span>
<a name="l01403"></a><a class="code" href="classlibMesh_1_1System.php#af80f6b2e508821ebd9c8fcb78d443f18">01403</a> <span class="keyword">const</span> std::string &amp; <a class="code" href="classlibMesh_1_1System.php#af80f6b2e508821ebd9c8fcb78d443f18">System::name</a>()<span class="keyword"> const</span>
<a name="l01404"></a>01404 <span class="keyword"></span>{
<a name="l01405"></a>01405   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1System.php#aa6ed4b98503185caee2e333148b8f457">_sys_name</a>;
<a name="l01406"></a>01406 }
<a name="l01407"></a>01407 
<a name="l01408"></a>01408 
<a name="l01409"></a>01409 
<a name="l01410"></a>01410 <span class="keyword">inline</span>
<a name="l01411"></a><a class="code" href="classlibMesh_1_1System.php#aee5caacb487b070842733f1c84b9a2fd">01411</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#aee5caacb487b070842733f1c84b9a2fd">System::number</a>()<span class="keyword"> const</span>
<a name="l01412"></a>01412 <span class="keyword"></span>{
<a name="l01413"></a>01413   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1System.php#a1ea531a98e00c4ddbcc170529561d72e">_sys_number</a>;
<a name="l01414"></a>01414 }
<a name="l01415"></a>01415 
<a name="l01416"></a>01416 
<a name="l01417"></a>01417 
<a name="l01418"></a>01418 <span class="keyword">inline</span>
<a name="l01419"></a><a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">01419</a> <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp; <a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">System::get_mesh</a>()<span class="keyword"> const</span>
<a name="l01420"></a>01420 <span class="keyword"></span>{
<a name="l01421"></a>01421   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1System.php#a6b1d416e0d9270f47499f7cdf3db3525">_mesh</a>;
<a name="l01422"></a>01422 }
<a name="l01423"></a>01423 
<a name="l01424"></a>01424 
<a name="l01425"></a>01425 
<a name="l01426"></a>01426 <span class="keyword">inline</span>
<a name="l01427"></a><a class="code" href="classlibMesh_1_1System.php#ad21ba8b25570465e1262a579566375ae">01427</a> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp; <a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">System::get_mesh</a>()
<a name="l01428"></a>01428 {
<a name="l01429"></a>01429   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1System.php#a6b1d416e0d9270f47499f7cdf3db3525">_mesh</a>;
<a name="l01430"></a>01430 }
<a name="l01431"></a>01431 
<a name="l01432"></a>01432 
<a name="l01433"></a>01433 
<a name="l01434"></a>01434 <span class="keyword">inline</span>
<a name="l01435"></a><a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">01435</a> <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DofMap.php">DofMap</a> &amp; <a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">System::get_dof_map</a>()<span class="keyword"> const</span>
<a name="l01436"></a>01436 <span class="keyword"></span>{
<a name="l01437"></a>01437   <span class="keywordflow">return</span> *<a class="code" href="classlibMesh_1_1System.php#a7386701e1324744b8d08db251374926b">_dof_map</a>;
<a name="l01438"></a>01438 }
<a name="l01439"></a>01439 
<a name="l01440"></a>01440 
<a name="l01441"></a>01441 
<a name="l01442"></a>01442 <span class="keyword">inline</span>
<a name="l01443"></a><a class="code" href="classlibMesh_1_1System.php#a255709f85c1967d3670ec371048f20e7">01443</a> <a class="code" href="classlibMesh_1_1DofMap.php">DofMap</a> &amp; <a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">System::get_dof_map</a>()
<a name="l01444"></a>01444 {
<a name="l01445"></a>01445   <span class="keywordflow">return</span> *<a class="code" href="classlibMesh_1_1System.php#a7386701e1324744b8d08db251374926b">_dof_map</a>;
<a name="l01446"></a>01446 }
<a name="l01447"></a>01447 
<a name="l01448"></a>01448 
<a name="l01449"></a>01449 
<a name="l01450"></a>01450 <span class="keyword">inline</span>
<a name="l01451"></a><a class="code" href="classlibMesh_1_1System.php#a0abd752d5ad75ea99581c65e0d5c2fb7">01451</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1System.php#a0abd752d5ad75ea99581c65e0d5c2fb7">System::active</a>()<span class="keyword"> const</span>
<a name="l01452"></a>01452 <span class="keyword"></span>{
<a name="l01453"></a>01453   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1System.php#aee881365cfab1a56929cf344a34e9585">_active</a>;  
<a name="l01454"></a>01454 }
<a name="l01455"></a>01455 
<a name="l01456"></a>01456 
<a name="l01457"></a>01457 
<a name="l01458"></a>01458 <span class="keyword">inline</span>
<a name="l01459"></a><a class="code" href="classlibMesh_1_1System.php#a2caec05f9f5fbdeee0ed4a1245f5e150">01459</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a2caec05f9f5fbdeee0ed4a1245f5e150">System::activate</a> ()
<a name="l01460"></a>01460 {
<a name="l01461"></a>01461   <a class="code" href="classlibMesh_1_1System.php#aee881365cfab1a56929cf344a34e9585">_active</a> = <span class="keyword">true</span>;
<a name="l01462"></a>01462 }
<a name="l01463"></a>01463 
<a name="l01464"></a>01464 
<a name="l01465"></a>01465 
<a name="l01466"></a>01466 <span class="keyword">inline</span>
<a name="l01467"></a><a class="code" href="classlibMesh_1_1System.php#a9ba45875ecfb9f9151a014cadac8109c">01467</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a9ba45875ecfb9f9151a014cadac8109c">System::deactivate</a> ()
<a name="l01468"></a>01468 {
<a name="l01469"></a>01469   <a class="code" href="classlibMesh_1_1System.php#aee881365cfab1a56929cf344a34e9585">_active</a> = <span class="keyword">false</span>;
<a name="l01470"></a>01470 }
<a name="l01471"></a>01471 
<a name="l01472"></a>01472 
<a name="l01473"></a>01473 
<a name="l01474"></a>01474 <span class="keyword">inline</span>
<a name="l01475"></a><a class="code" href="classlibMesh_1_1System.php#a4cf032eda109fe32a7fcde672ef5726e">01475</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#a4cf032eda109fe32a7fcde672ef5726e">System::n_vars</a>()<span class="keyword"> const</span>
<a name="l01476"></a>01476 <span class="keyword"></span>{
<a name="l01477"></a>01477   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1System.php#a17fc76a7e9339dcc3c834a646169bf0e">_variables</a>.size();
<a name="l01478"></a>01478 }
<a name="l01479"></a>01479 
<a name="l01480"></a>01480 
<a name="l01481"></a>01481 
<a name="l01482"></a>01482 <span class="keyword">inline</span>
<a name="l01483"></a><a class="code" href="classlibMesh_1_1System.php#a56d89ed534ffce5eda02dc0137583b56">01483</a> <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Variable.php">Variable</a> &amp; <a class="code" href="classlibMesh_1_1System.php#a56d89ed534ffce5eda02dc0137583b56">System::variable</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l01484"></a>01484 <span class="keyword"></span>{
<a name="l01485"></a>01485   libmesh_assert (i &lt; <a class="code" href="classlibMesh_1_1System.php#a17fc76a7e9339dcc3c834a646169bf0e">_variables</a>.size());
<a name="l01486"></a>01486 
<a name="l01487"></a>01487   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1System.php#a17fc76a7e9339dcc3c834a646169bf0e">_variables</a>[i];
<a name="l01488"></a>01488 }
<a name="l01489"></a>01489 
<a name="l01490"></a>01490 
<a name="l01491"></a>01491 
<a name="l01492"></a>01492 <span class="keyword">inline</span>
<a name="l01493"></a><a class="code" href="classlibMesh_1_1System.php#a9cddad5dd8b68389373567fddfbdb257">01493</a> <span class="keyword">const</span> std::string &amp; <a class="code" href="classlibMesh_1_1System.php#a9cddad5dd8b68389373567fddfbdb257">System::variable_name</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l01494"></a>01494 <span class="keyword"></span>{
<a name="l01495"></a>01495   libmesh_assert (i &lt; <a class="code" href="classlibMesh_1_1System.php#a17fc76a7e9339dcc3c834a646169bf0e">_variables</a>.size());
<a name="l01496"></a>01496 
<a name="l01497"></a>01497   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1System.php#a17fc76a7e9339dcc3c834a646169bf0e">_variables</a>[i].name();
<a name="l01498"></a>01498 }
<a name="l01499"></a>01499 
<a name="l01500"></a>01500 
<a name="l01501"></a>01501 
<a name="l01502"></a>01502 <span class="keyword">inline</span>
<a name="l01503"></a><a class="code" href="classlibMesh_1_1System.php#ab321ab954fa1284069a647b311ff6d17">01503</a> <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a> &amp; <a class="code" href="classlibMesh_1_1System.php#ab321ab954fa1284069a647b311ff6d17">System::variable_type</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l01504"></a>01504 <span class="keyword"></span>{
<a name="l01505"></a>01505   libmesh_assert (i &lt; <a class="code" href="classlibMesh_1_1System.php#a17fc76a7e9339dcc3c834a646169bf0e">_variables</a>.size());
<a name="l01506"></a>01506   
<a name="l01507"></a>01507   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1System.php#a17fc76a7e9339dcc3c834a646169bf0e">_variables</a>[i].type();
<a name="l01508"></a>01508 }
<a name="l01509"></a>01509 
<a name="l01510"></a>01510 
<a name="l01511"></a>01511 
<a name="l01512"></a>01512 <span class="keyword">inline</span>
<a name="l01513"></a><a class="code" href="classlibMesh_1_1System.php#ae58688904ec53bf96a4a7ee2ffe6108d">01513</a> <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a> &amp; <a class="code" href="classlibMesh_1_1System.php#ab321ab954fa1284069a647b311ff6d17">System::variable_type</a> (<span class="keyword">const</span> std::string&amp; var)<span class="keyword"> const</span>
<a name="l01514"></a>01514 <span class="keyword"></span>{
<a name="l01515"></a>01515   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1System.php#a17fc76a7e9339dcc3c834a646169bf0e">_variables</a>[this-&gt;<a class="code" href="classlibMesh_1_1System.php#aeda27e9696b02cf965e2340fc9e64857">variable_number</a>(var)].type();
<a name="l01516"></a>01516 }
<a name="l01517"></a>01517 
<a name="l01518"></a>01518 
<a name="l01519"></a>01519 
<a name="l01520"></a>01520 <span class="keyword">inline</span>
<a name="l01521"></a><a class="code" href="classlibMesh_1_1System.php#ab87249ec70609d4d3376b7705829fee0">01521</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#ab87249ec70609d4d3376b7705829fee0">System::n_active_dofs</a>()<span class="keyword"> const</span>
<a name="l01522"></a>01522 <span class="keyword"></span>{
<a name="l01523"></a>01523   <span class="keywordflow">return</span> this-&gt;<a class="code" href="classlibMesh_1_1System.php#a90dbb901f00c14ff18399f4afabcebe5">n_dofs</a>() - this-&gt;<a class="code" href="classlibMesh_1_1System.php#af44e0a3ba6dee841752b85b0c2b64854">n_constrained_dofs</a>();
<a name="l01524"></a>01524 }
<a name="l01525"></a>01525 
<a name="l01526"></a>01526 
<a name="l01527"></a>01527 
<a name="l01528"></a>01528 <span class="keyword">inline</span>
<a name="l01529"></a><a class="code" href="classlibMesh_1_1System.php#a3d09f6a50bbf0d99489b88091d509a0f">01529</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1System.php#a3d09f6a50bbf0d99489b88091d509a0f">System::have_vector</a> (<span class="keyword">const</span> std::string&amp; vec_name)<span class="keyword"> const</span>
<a name="l01530"></a>01530 <span class="keyword"></span>{
<a name="l01531"></a>01531   <span class="keywordflow">return</span> (<a class="code" href="classlibMesh_1_1System.php#a4068a7b090c2b32e2c73c018b4e22a80">_vectors</a>.count(vec_name));
<a name="l01532"></a>01532 }
<a name="l01533"></a>01533 
<a name="l01534"></a>01534 
<a name="l01535"></a>01535 
<a name="l01536"></a>01536 <span class="keyword">inline</span>
<a name="l01537"></a><a class="code" href="classlibMesh_1_1System.php#a46bd8cfb070bab2dc814c33749c8c21b">01537</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#a46bd8cfb070bab2dc814c33749c8c21b">System::n_vectors</a> ()<span class="keyword"> const</span>
<a name="l01538"></a>01538 <span class="keyword"></span>{
<a name="l01539"></a>01539   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1System.php#a4068a7b090c2b32e2c73c018b4e22a80">_vectors</a>.size(); 
<a name="l01540"></a>01540 }
<a name="l01541"></a>01541 
<a name="l01542"></a>01542 <span class="keyword">inline</span>
<a name="l01543"></a><a class="code" href="classlibMesh_1_1System.php#a293a39e0a532954f5c643b5d3650c048">01543</a> <a class="code" href="classlibMesh_1_1System.php#a6a75b971c5614203f50d5a922df9253c">System::vectors_iterator</a> <a class="code" href="classlibMesh_1_1System.php#a293a39e0a532954f5c643b5d3650c048">System::vectors_begin</a> ()
<a name="l01544"></a>01544 {
<a name="l01545"></a>01545   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1System.php#a4068a7b090c2b32e2c73c018b4e22a80">_vectors</a>.begin();
<a name="l01546"></a>01546 }
<a name="l01547"></a>01547 
<a name="l01548"></a>01548 <span class="keyword">inline</span>
<a name="l01549"></a><a class="code" href="classlibMesh_1_1System.php#a0394a0bff8e3746a49eed518cc8c00c8">01549</a> <a class="code" href="classlibMesh_1_1System.php#aa4c2b06e622c0a42bce85716cad92fbd">System::const_vectors_iterator</a> <a class="code" href="classlibMesh_1_1System.php#a293a39e0a532954f5c643b5d3650c048">System::vectors_begin</a> ()<span class="keyword"> const</span>
<a name="l01550"></a>01550 <span class="keyword"></span>{
<a name="l01551"></a>01551   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1System.php#a4068a7b090c2b32e2c73c018b4e22a80">_vectors</a>.begin();
<a name="l01552"></a>01552 }
<a name="l01553"></a>01553 
<a name="l01554"></a>01554 <span class="keyword">inline</span>
<a name="l01555"></a><a class="code" href="classlibMesh_1_1System.php#a8bad75f37fdc2e047d73830d182e1314">01555</a> <a class="code" href="classlibMesh_1_1System.php#a6a75b971c5614203f50d5a922df9253c">System::vectors_iterator</a> <a class="code" href="classlibMesh_1_1System.php#a8bad75f37fdc2e047d73830d182e1314">System::vectors_end</a> ()
<a name="l01556"></a>01556 {
<a name="l01557"></a>01557   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1System.php#a4068a7b090c2b32e2c73c018b4e22a80">_vectors</a>.end();
<a name="l01558"></a>01558 }
<a name="l01559"></a>01559 
<a name="l01560"></a>01560 <span class="keyword">inline</span>
<a name="l01561"></a><a class="code" href="classlibMesh_1_1System.php#acb796e766f91a826247574816d375407">01561</a> <a class="code" href="classlibMesh_1_1System.php#aa4c2b06e622c0a42bce85716cad92fbd">System::const_vectors_iterator</a> <a class="code" href="classlibMesh_1_1System.php#a8bad75f37fdc2e047d73830d182e1314">System::vectors_end</a> ()<span class="keyword"> const</span>
<a name="l01562"></a>01562 <span class="keyword"></span>{
<a name="l01563"></a>01563   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1System.php#a4068a7b090c2b32e2c73c018b4e22a80">_vectors</a>.end();
<a name="l01564"></a>01564 }
<a name="l01565"></a>01565 
<a name="l01566"></a>01566 <span class="keyword">inline</span>
<a name="l01567"></a><a class="code" href="classlibMesh_1_1System.php#a1cc007b379ff2997715998c01106d790">01567</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a1cc007b379ff2997715998c01106d790">System::assemble_residual_derivatives</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ParameterVector.php">ParameterVector</a>&amp;)
<a name="l01568"></a>01568 {
<a name="l01569"></a>01569   libmesh_not_implemented();
<a name="l01570"></a>01570 }
<a name="l01571"></a>01571 
<a name="l01572"></a>01572 <span class="keyword">inline</span>
<a name="l01573"></a>01573 std::pair&lt;unsigned int, Real&gt;
<a name="l01574"></a><a class="code" href="classlibMesh_1_1System.php#a9dba69c2da2eff36d8c161d55ddcfb2c">01574</a> <a class="code" href="classlibMesh_1_1System.php#a9dba69c2da2eff36d8c161d55ddcfb2c">System::sensitivity_solve</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ParameterVector.php">ParameterVector</a>&amp;)
<a name="l01575"></a>01575 {
<a name="l01576"></a>01576   libmesh_not_implemented();
<a name="l01577"></a>01577 }
<a name="l01578"></a>01578 
<a name="l01579"></a>01579 <span class="keyword">inline</span>
<a name="l01580"></a>01580 std::pair&lt;unsigned int, Real&gt;
<a name="l01581"></a><a class="code" href="classlibMesh_1_1System.php#a12a66f71be2f232f7136905559c1bbdb">01581</a> <a class="code" href="classlibMesh_1_1System.php#a12a66f71be2f232f7136905559c1bbdb">System::weighted_sensitivity_solve</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ParameterVector.php">ParameterVector</a>&amp;,
<a name="l01582"></a>01582                                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ParameterVector.php">ParameterVector</a>&amp;)
<a name="l01583"></a>01583 {
<a name="l01584"></a>01584   libmesh_not_implemented();
<a name="l01585"></a>01585 }
<a name="l01586"></a>01586 
<a name="l01587"></a>01587 <span class="keyword">inline</span>
<a name="l01588"></a>01588 std::pair&lt;unsigned int, Real&gt;
<a name="l01589"></a><a class="code" href="classlibMesh_1_1System.php#a6e5b90b9bd6cf63a40cc77f02671a92d">01589</a> <a class="code" href="classlibMesh_1_1System.php#a6e5b90b9bd6cf63a40cc77f02671a92d">System::adjoint_solve</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a>&amp;)
<a name="l01590"></a>01590 {
<a name="l01591"></a>01591   libmesh_not_implemented();
<a name="l01592"></a>01592 }
<a name="l01593"></a>01593 
<a name="l01594"></a>01594 <span class="keyword">inline</span>
<a name="l01595"></a>01595 std::pair&lt;unsigned int, Real&gt;
<a name="l01596"></a><a class="code" href="classlibMesh_1_1System.php#a79ae2650c56afe266ec27ee2fea57957">01596</a> <a class="code" href="classlibMesh_1_1System.php#a79ae2650c56afe266ec27ee2fea57957">System::weighted_sensitivity_adjoint_solve</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ParameterVector.php">ParameterVector</a>&amp;,
<a name="l01597"></a>01597                                             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ParameterVector.php">ParameterVector</a>&amp;,
<a name="l01598"></a>01598                                             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a>&amp;)
<a name="l01599"></a>01599 {
<a name="l01600"></a>01600   libmesh_not_implemented();
<a name="l01601"></a>01601 }
<a name="l01602"></a>01602 
<a name="l01603"></a>01603 <span class="keyword">inline</span>
<a name="l01604"></a>01604 <span class="keywordtype">void</span>
<a name="l01605"></a><a class="code" href="classlibMesh_1_1System.php#a16e47d56606c347fbc996072f666c1b2">01605</a> <a class="code" href="classlibMesh_1_1System.php#a16e47d56606c347fbc996072f666c1b2">System::adjoint_qoi_parameter_sensitivity</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a>&amp;,
<a name="l01606"></a>01606                                            <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ParameterVector.php">ParameterVector</a>&amp;,
<a name="l01607"></a>01607                                            <a class="code" href="classlibMesh_1_1SensitivityData.php">SensitivityData</a>&amp;)
<a name="l01608"></a>01608 {
<a name="l01609"></a>01609   libmesh_not_implemented();
<a name="l01610"></a>01610 }
<a name="l01611"></a>01611 
<a name="l01612"></a>01612 <span class="keyword">inline</span>
<a name="l01613"></a>01613 <span class="keywordtype">void</span>
<a name="l01614"></a><a class="code" href="classlibMesh_1_1System.php#ab19259df51db305760418290ae5b2f57">01614</a> <a class="code" href="classlibMesh_1_1System.php#ab19259df51db305760418290ae5b2f57">System::forward_qoi_parameter_sensitivity</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a>&amp;,
<a name="l01615"></a>01615                                            <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ParameterVector.php">ParameterVector</a>&amp;,
<a name="l01616"></a>01616                                            <a class="code" href="classlibMesh_1_1SensitivityData.php">SensitivityData</a>&amp;)
<a name="l01617"></a>01617 {
<a name="l01618"></a>01618   libmesh_not_implemented();
<a name="l01619"></a>01619 }
<a name="l01620"></a>01620 
<a name="l01621"></a>01621 <span class="keyword">inline</span>
<a name="l01622"></a>01622 <span class="keywordtype">void</span>
<a name="l01623"></a><a class="code" href="classlibMesh_1_1System.php#a941661b0198ad8fe5f9d62cfc5f9a03b">01623</a> <a class="code" href="classlibMesh_1_1System.php#a941661b0198ad8fe5f9d62cfc5f9a03b">System::qoi_parameter_hessian</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a>&amp;,
<a name="l01624"></a>01624                               <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ParameterVector.php">ParameterVector</a>&amp;,
<a name="l01625"></a>01625                               <a class="code" href="classlibMesh_1_1SensitivityData.php">SensitivityData</a>&amp;)
<a name="l01626"></a>01626 {
<a name="l01627"></a>01627   libmesh_not_implemented();
<a name="l01628"></a>01628 }
<a name="l01629"></a>01629 
<a name="l01630"></a>01630 <span class="keyword">inline</span>
<a name="l01631"></a>01631 <span class="keywordtype">void</span>
<a name="l01632"></a><a class="code" href="classlibMesh_1_1System.php#a24bec5dc18f42bc87ad135a06aada457">01632</a> <a class="code" href="classlibMesh_1_1System.php#a24bec5dc18f42bc87ad135a06aada457">System::qoi_parameter_hessian_vector_product</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a>&amp;,
<a name="l01633"></a>01633                                              <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ParameterVector.php">ParameterVector</a>&amp;,
<a name="l01634"></a>01634                                              <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ParameterVector.php">ParameterVector</a>&amp;,
<a name="l01635"></a>01635                                              <a class="code" href="classlibMesh_1_1SensitivityData.php">SensitivityData</a>&amp;)
<a name="l01636"></a>01636 {
<a name="l01637"></a>01637   libmesh_not_implemented();
<a name="l01638"></a>01638 }
<a name="l01639"></a>01639 
<a name="l01640"></a>01640 <span class="keyword">inline</span>
<a name="l01641"></a><a class="code" href="classlibMesh_1_1System.php#a039694a88131a6f186c1e19a985bcc44">01641</a> <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a>* <a class="code" href="classlibMesh_1_1System.php#a039694a88131a6f186c1e19a985bcc44">System::get_mesh_system</a>()<span class="keyword"> const</span>
<a name="l01642"></a>01642 <span class="keyword"></span>{
<a name="l01643"></a>01643   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1System.php#a5c1eb01a3714bd870f38e2493e8e200a">_mesh_sys</a>;
<a name="l01644"></a>01644 }
<a name="l01645"></a>01645 
<a name="l01646"></a>01646 <span class="keyword">inline</span>
<a name="l01647"></a><a class="code" href="classlibMesh_1_1System.php#adfdcfb87806718445a09dd3255379301">01647</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#adfdcfb87806718445a09dd3255379301">System::get_mesh_x_var</a>()<span class="keyword"> const</span>
<a name="l01648"></a>01648 <span class="keyword"></span>{
<a name="l01649"></a>01649   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1System.php#a4ba10714ce3d0f2f0ebea5af774c0410">_mesh_x_var</a>;
<a name="l01650"></a>01650 }
<a name="l01651"></a>01651 
<a name="l01652"></a>01652 <span class="keyword">inline</span>
<a name="l01653"></a><a class="code" href="classlibMesh_1_1System.php#a7ae8bd453e9335a699dc853e94d39a2e">01653</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#a7ae8bd453e9335a699dc853e94d39a2e">System::get_mesh_y_var</a>()<span class="keyword"> const</span>
<a name="l01654"></a>01654 <span class="keyword"></span>{
<a name="l01655"></a>01655   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1System.php#a6e5e444236409ae047939d411925029a">_mesh_y_var</a>;
<a name="l01656"></a>01656 }
<a name="l01657"></a>01657 
<a name="l01658"></a>01658 <span class="keyword">inline</span>
<a name="l01659"></a><a class="code" href="classlibMesh_1_1System.php#a643a7f15d85ed211a9cb46d73bcb60b3">01659</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#a643a7f15d85ed211a9cb46d73bcb60b3">System::get_mesh_z_var</a>()<span class="keyword"> const</span>
<a name="l01660"></a>01660 <span class="keyword"></span>{
<a name="l01661"></a>01661   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1System.php#abe79ee716383ee682c44083728292e44">_mesh_z_var</a>;
<a name="l01662"></a>01662 }
<a name="l01663"></a>01663 
<a name="l01664"></a>01664 } <span class="comment">// namespace libMesh</span>
<a name="l01665"></a>01665 
<a name="l01666"></a>01666 <span class="preprocessor">#endif // #define __system_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
