<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_eaf30c8ea092d33f79a04353c3899c3f.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_5a0c7151fa56969ceb962f1511f7edee.php">systems</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">system_norm.h</div>  </div>
</div>
<div class="contents">
<a href="system__norm_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id$</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __system_norm_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __system_norm_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="comment">// Local includes</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span> <span class="comment">// for Real</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="enum__norm__type_8h.php">enum_norm_type.h</a>&quot;</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="keyword">namespace </span>libMesh
<a name="l00033"></a>00033 {
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="comment">// Forward Declarations</span>
<a name="l00036"></a>00036 
<a name="l00047"></a>00047 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00048"></a>00048 <span class="comment">// SystemNorm class definition</span>
<a name="l00049"></a><a class="code" href="classlibMesh_1_1SystemNorm.php">00049</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1SystemNorm.php">SystemNorm</a>
<a name="l00050"></a>00050 {
<a name="l00051"></a>00051 <span class="keyword">public</span>:
<a name="l00052"></a>00052   
<a name="l00056"></a>00056   <a class="code" href="classlibMesh_1_1SystemNorm.php#ab075ea78340017a0c6686e85075aaff9">SystemNorm</a>();
<a name="l00057"></a>00057   
<a name="l00063"></a>00063   <a class="code" href="classlibMesh_1_1SystemNorm.php#ab075ea78340017a0c6686e85075aaff9">SystemNorm</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098">FEMNormType</a> &amp;t);
<a name="l00064"></a>00064   
<a name="l00072"></a>00072   <a class="code" href="classlibMesh_1_1SystemNorm.php#ab075ea78340017a0c6686e85075aaff9">SystemNorm</a>(<span class="keyword">const</span> std::vector&lt;FEMNormType&gt; &amp;norms);
<a name="l00073"></a>00073 
<a name="l00081"></a>00081   <a class="code" href="classlibMesh_1_1SystemNorm.php#ab075ea78340017a0c6686e85075aaff9">SystemNorm</a>(<span class="keyword">const</span> std::vector&lt;FEMNormType&gt; &amp;norms, std::vector&lt;Real&gt; &amp;weights);
<a name="l00082"></a>00082 
<a name="l00086"></a>00086   <a class="code" href="classlibMesh_1_1SystemNorm.php#ab075ea78340017a0c6686e85075aaff9">SystemNorm</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1SystemNorm.php">SystemNorm</a> &amp;s);
<a name="l00087"></a>00087   
<a name="l00091"></a>00091   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1SystemNorm.php#a31678e569cf9f6c1e4d13de2315b5d64">is_discrete</a>() <span class="keyword">const</span>;
<a name="l00092"></a>00092 
<a name="l00096"></a>00096   <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098">FEMNormType</a> <a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var) <span class="keyword">const</span>;
<a name="l00097"></a>00097 
<a name="l00101"></a>00101   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1SystemNorm.php#a3950a2608908f1d3fcd314bb21086a4c">set_type</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var, <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098">FEMNormType</a>&amp; t);
<a name="l00102"></a>00102 
<a name="l00106"></a>00106   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1SystemNorm.php#ac8a59940264314511d0e4f253433e76b">weight</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var) <span class="keyword">const</span>;
<a name="l00107"></a>00107 
<a name="l00111"></a>00111   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1SystemNorm.php#a83afcff574efcefe51268faecc4309f3">set_weight</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var, <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> w);
<a name="l00112"></a>00112 
<a name="l00117"></a>00117   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1SystemNorm.php#a6c84f8dbb0f519c5abef6a47ee0a4f23">weight_sq</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var) <span class="keyword">const</span>;
<a name="l00118"></a>00118 
<a name="l00119"></a>00119 <span class="keyword">private</span>:
<a name="l00120"></a><a class="code" href="classlibMesh_1_1SystemNorm.php#a6123a2cd3b26d58f49e8b23940de09c5">00120</a>   std::vector&lt;FEMNormType&gt; <a class="code" href="classlibMesh_1_1SystemNorm.php#a6123a2cd3b26d58f49e8b23940de09c5">_norms</a>;
<a name="l00121"></a>00121 
<a name="l00122"></a><a class="code" href="classlibMesh_1_1SystemNorm.php#a938e26426c1694e34d558ec4c0beda57">00122</a>   std::vector&lt;Real&gt; <a class="code" href="classlibMesh_1_1SystemNorm.php#a938e26426c1694e34d558ec4c0beda57">_weights</a>;
<a name="l00123"></a><a class="code" href="classlibMesh_1_1SystemNorm.php#ad2d4cfa8bee893843d274f3c90534a1d">00123</a>   std::vector&lt;Real&gt; <a class="code" href="classlibMesh_1_1SystemNorm.php#ad2d4cfa8bee893843d274f3c90534a1d">_weights_sq</a>;
<a name="l00124"></a>00124 };
<a name="l00125"></a>00125 
<a name="l00126"></a>00126 
<a name="l00127"></a>00127 
<a name="l00128"></a>00128 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00129"></a>00129 <span class="comment">// SystemNorm inline methods</span>
<a name="l00130"></a>00130 
<a name="l00131"></a>00131 <span class="keyword">inline</span>
<a name="l00132"></a><a class="code" href="classlibMesh_1_1SystemNorm.php#ab075ea78340017a0c6686e85075aaff9">00132</a> <a class="code" href="classlibMesh_1_1SystemNorm.php#ab075ea78340017a0c6686e85075aaff9">SystemNorm::SystemNorm</a>() :
<a name="l00133"></a>00133     _norms(1, <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a482797897c042873f53453795347edb6">DISCRETE_L2</a>), _weights(1, 1.0), _weights_sq(1, 1.0)
<a name="l00134"></a>00134 { 
<a name="l00135"></a>00135 }
<a name="l00136"></a>00136 
<a name="l00137"></a>00137 
<a name="l00138"></a>00138 <span class="keyword">inline</span>
<a name="l00139"></a><a class="code" href="classlibMesh_1_1SystemNorm.php#a7a5a596219683f300bff4dfaffe79b59">00139</a> <a class="code" href="classlibMesh_1_1SystemNorm.php#ab075ea78340017a0c6686e85075aaff9">SystemNorm::SystemNorm</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098">FEMNormType</a> &amp;t) :
<a name="l00140"></a>00140     _norms(1, t), _weights(1, 1.0), _weights_sq(1, 1.0)
<a name="l00141"></a>00141 { 
<a name="l00142"></a>00142 }
<a name="l00143"></a>00143 
<a name="l00144"></a>00144 
<a name="l00145"></a>00145 <span class="keyword">inline</span>
<a name="l00146"></a><a class="code" href="classlibMesh_1_1SystemNorm.php#ad7e31883269c2fafae0d8b27ddcbff92">00146</a> <a class="code" href="classlibMesh_1_1SystemNorm.php#ab075ea78340017a0c6686e85075aaff9">SystemNorm::SystemNorm</a>(<span class="keyword">const</span> std::vector&lt;FEMNormType&gt; &amp;norms) :
<a name="l00147"></a>00147     _norms(norms), _weights(1, 1.0), _weights_sq(1, 1.0)
<a name="l00148"></a>00148 {
<a name="l00149"></a>00149   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1SystemNorm.php#a6123a2cd3b26d58f49e8b23940de09c5">_norms</a>.empty())
<a name="l00150"></a>00150     <a class="code" href="classlibMesh_1_1SystemNorm.php#a6123a2cd3b26d58f49e8b23940de09c5">_norms</a>.push_back(<a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a482797897c042873f53453795347edb6">DISCRETE_L2</a>);
<a name="l00151"></a>00151 }
<a name="l00152"></a>00152 
<a name="l00153"></a>00153 
<a name="l00154"></a>00154 <span class="keyword">inline</span>
<a name="l00155"></a><a class="code" href="classlibMesh_1_1SystemNorm.php#a30cdeef981035d452fd71ea37df2a7e6">00155</a> <a class="code" href="classlibMesh_1_1SystemNorm.php#ab075ea78340017a0c6686e85075aaff9">SystemNorm::SystemNorm</a>(<span class="keyword">const</span> std::vector&lt;FEMNormType&gt; &amp;norms,
<a name="l00156"></a>00156                        std::vector&lt;Real&gt; &amp;weights) :
<a name="l00157"></a>00157     _norms(norms), _weights(weights), _weights_sq(_weights.size(), 0.0)
<a name="l00158"></a>00158 {
<a name="l00159"></a>00159   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1SystemNorm.php#a6123a2cd3b26d58f49e8b23940de09c5">_norms</a>.empty())
<a name="l00160"></a>00160     <a class="code" href="classlibMesh_1_1SystemNorm.php#a6123a2cd3b26d58f49e8b23940de09c5">_norms</a>.push_back(<a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a482797897c042873f53453795347edb6">DISCRETE_L2</a>);
<a name="l00161"></a>00161 
<a name="l00162"></a>00162   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1SystemNorm.php#a938e26426c1694e34d558ec4c0beda57">_weights</a>.empty())
<a name="l00163"></a>00163     {
<a name="l00164"></a>00164       <a class="code" href="classlibMesh_1_1SystemNorm.php#a938e26426c1694e34d558ec4c0beda57">_weights</a>.push_back(1.0);
<a name="l00165"></a>00165       <a class="code" href="classlibMesh_1_1SystemNorm.php#ad2d4cfa8bee893843d274f3c90534a1d">_weights_sq</a>.push_back(1.0);
<a name="l00166"></a>00166     }
<a name="l00167"></a>00167   <span class="keywordflow">else</span>
<a name="l00168"></a>00168     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != <a class="code" href="classlibMesh_1_1SystemNorm.php#a938e26426c1694e34d558ec4c0beda57">_weights</a>.size(); ++i)
<a name="l00169"></a>00169       <a class="code" href="classlibMesh_1_1SystemNorm.php#ad2d4cfa8bee893843d274f3c90534a1d">_weights_sq</a>[i] = <a class="code" href="classlibMesh_1_1SystemNorm.php#a938e26426c1694e34d558ec4c0beda57">_weights</a>[i] * <a class="code" href="classlibMesh_1_1SystemNorm.php#a938e26426c1694e34d558ec4c0beda57">_weights</a>[i];
<a name="l00170"></a>00170 }
<a name="l00171"></a>00171 
<a name="l00172"></a>00172 
<a name="l00173"></a>00173 <span class="keyword">inline</span>
<a name="l00174"></a><a class="code" href="classlibMesh_1_1SystemNorm.php#aff7b5e7eaac2b842a90602e301b89b2e">00174</a> <a class="code" href="classlibMesh_1_1SystemNorm.php#ab075ea78340017a0c6686e85075aaff9">SystemNorm::SystemNorm</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1SystemNorm.php">SystemNorm</a> &amp;s) :
<a name="l00175"></a>00175     _norms(s._norms), _weights(s._weights), _weights_sq(s._weights_sq)
<a name="l00176"></a>00176 {
<a name="l00177"></a>00177 }
<a name="l00178"></a>00178 
<a name="l00179"></a>00179 
<a name="l00180"></a>00180 <span class="keyword">inline</span>
<a name="l00181"></a><a class="code" href="classlibMesh_1_1SystemNorm.php#a31678e569cf9f6c1e4d13de2315b5d64">00181</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1SystemNorm.php#a31678e569cf9f6c1e4d13de2315b5d64">SystemNorm::is_discrete</a>()<span class="keyword"> const</span>
<a name="l00182"></a>00182 <span class="keyword"></span>{
<a name="l00183"></a>00183   libmesh_assert (!<a class="code" href="classlibMesh_1_1SystemNorm.php#a6123a2cd3b26d58f49e8b23940de09c5">_norms</a>.empty());
<a name="l00184"></a>00184 
<a name="l00185"></a>00185   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1SystemNorm.php#a6123a2cd3b26d58f49e8b23940de09c5">_norms</a>[0] == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098ad5b9182056de3e279abd0e8120c1c774">DISCRETE_L1</a> ||
<a name="l00186"></a>00186       <a class="code" href="classlibMesh_1_1SystemNorm.php#a6123a2cd3b26d58f49e8b23940de09c5">_norms</a>[0] == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a482797897c042873f53453795347edb6">DISCRETE_L2</a> ||
<a name="l00187"></a>00187       <a class="code" href="classlibMesh_1_1SystemNorm.php#a6123a2cd3b26d58f49e8b23940de09c5">_norms</a>[0] == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098ae354be98c29a8529ca57555180313292">DISCRETE_L_INF</a>)
<a name="l00188"></a>00188     <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00189"></a>00189 
<a name="l00190"></a>00190   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00191"></a>00191 }
<a name="l00192"></a>00192 
<a name="l00193"></a>00193 
<a name="l00194"></a>00194 <span class="keyword">inline</span>
<a name="l00195"></a><a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">00195</a> <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098">FEMNormType</a> <a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">SystemNorm::type</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var)<span class="keyword"> const</span>
<a name="l00196"></a>00196 <span class="keyword"></span>{
<a name="l00197"></a>00197   libmesh_assert (!<a class="code" href="classlibMesh_1_1SystemNorm.php#a6123a2cd3b26d58f49e8b23940de09c5">_norms</a>.empty());
<a name="l00198"></a>00198 
<a name="l00199"></a>00199   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = (var &lt; <a class="code" href="classlibMesh_1_1SystemNorm.php#a6123a2cd3b26d58f49e8b23940de09c5">_norms</a>.size()) ? var : <a class="code" href="classlibMesh_1_1SystemNorm.php#a6123a2cd3b26d58f49e8b23940de09c5">_norms</a>.size() - 1;
<a name="l00200"></a>00200 
<a name="l00201"></a>00201   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1SystemNorm.php#a6123a2cd3b26d58f49e8b23940de09c5">_norms</a>[i];
<a name="l00202"></a>00202 }
<a name="l00203"></a>00203 
<a name="l00204"></a>00204 
<a name="l00205"></a>00205 
<a name="l00206"></a>00206 <span class="keyword">inline</span>
<a name="l00207"></a><a class="code" href="classlibMesh_1_1SystemNorm.php#a3950a2608908f1d3fcd314bb21086a4c">00207</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1SystemNorm.php#a3950a2608908f1d3fcd314bb21086a4c">SystemNorm::set_type</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var, <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098">FEMNormType</a> &amp;t)
<a name="l00208"></a>00208 {
<a name="l00209"></a>00209   libmesh_assert (!<a class="code" href="classlibMesh_1_1SystemNorm.php#a6123a2cd3b26d58f49e8b23940de09c5">_norms</a>.empty());
<a name="l00210"></a>00210   
<a name="l00211"></a>00211   <span class="keywordflow">if</span> (var &gt;= <a class="code" href="classlibMesh_1_1SystemNorm.php#a6123a2cd3b26d58f49e8b23940de09c5">_norms</a>.size())
<a name="l00212"></a>00212     <a class="code" href="classlibMesh_1_1SystemNorm.php#a6123a2cd3b26d58f49e8b23940de09c5">_norms</a>.resize(var+1, t);
<a name="l00213"></a>00213 
<a name="l00214"></a>00214   <a class="code" href="classlibMesh_1_1SystemNorm.php#a6123a2cd3b26d58f49e8b23940de09c5">_norms</a>[var] = t;
<a name="l00215"></a>00215 }
<a name="l00216"></a>00216 
<a name="l00217"></a>00217 
<a name="l00218"></a>00218 <span class="keyword">inline</span>
<a name="l00219"></a><a class="code" href="classlibMesh_1_1SystemNorm.php#ac8a59940264314511d0e4f253433e76b">00219</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1SystemNorm.php#ac8a59940264314511d0e4f253433e76b">SystemNorm::weight</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var)<span class="keyword"> const</span>
<a name="l00220"></a>00220 <span class="keyword"></span>{
<a name="l00221"></a>00221   libmesh_assert (!<a class="code" href="classlibMesh_1_1SystemNorm.php#a938e26426c1694e34d558ec4c0beda57">_weights</a>.empty());
<a name="l00222"></a>00222   
<a name="l00223"></a>00223   <span class="keywordflow">return</span> (var &lt; <a class="code" href="classlibMesh_1_1SystemNorm.php#a938e26426c1694e34d558ec4c0beda57">_weights</a>.size()) ? <a class="code" href="classlibMesh_1_1SystemNorm.php#a938e26426c1694e34d558ec4c0beda57">_weights</a>[var] : 1.0;
<a name="l00224"></a>00224 }
<a name="l00225"></a>00225 
<a name="l00226"></a>00226 
<a name="l00227"></a>00227 <span class="keyword">inline</span>
<a name="l00228"></a><a class="code" href="classlibMesh_1_1SystemNorm.php#a83afcff574efcefe51268faecc4309f3">00228</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1SystemNorm.php#a83afcff574efcefe51268faecc4309f3">SystemNorm::set_weight</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var, <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> w)
<a name="l00229"></a>00229 {
<a name="l00230"></a>00230   libmesh_assert (!<a class="code" href="classlibMesh_1_1SystemNorm.php#a938e26426c1694e34d558ec4c0beda57">_weights</a>.empty());
<a name="l00231"></a>00231   
<a name="l00232"></a>00232   <span class="keywordflow">if</span> (var &gt;= <a class="code" href="classlibMesh_1_1SystemNorm.php#a938e26426c1694e34d558ec4c0beda57">_weights</a>.size())
<a name="l00233"></a>00233     {
<a name="l00234"></a>00234       <a class="code" href="classlibMesh_1_1SystemNorm.php#a938e26426c1694e34d558ec4c0beda57">_weights</a>.resize(var+1, 1.0);
<a name="l00235"></a>00235       <a class="code" href="classlibMesh_1_1SystemNorm.php#ad2d4cfa8bee893843d274f3c90534a1d">_weights_sq</a>.resize(var+1, 1.0);
<a name="l00236"></a>00236     }
<a name="l00237"></a>00237 
<a name="l00238"></a>00238   <a class="code" href="classlibMesh_1_1SystemNorm.php#a938e26426c1694e34d558ec4c0beda57">_weights</a>[var] = w;
<a name="l00239"></a>00239   <a class="code" href="classlibMesh_1_1SystemNorm.php#ad2d4cfa8bee893843d274f3c90534a1d">_weights_sq</a>[var] = w*w;
<a name="l00240"></a>00240 }
<a name="l00241"></a>00241 
<a name="l00242"></a>00242 
<a name="l00243"></a>00243 <span class="keyword">inline</span>
<a name="l00244"></a><a class="code" href="classlibMesh_1_1SystemNorm.php#a6c84f8dbb0f519c5abef6a47ee0a4f23">00244</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1SystemNorm.php#a6c84f8dbb0f519c5abef6a47ee0a4f23">SystemNorm::weight_sq</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var)<span class="keyword"> const</span>
<a name="l00245"></a>00245 <span class="keyword"></span>{
<a name="l00246"></a>00246   libmesh_assert (!<a class="code" href="classlibMesh_1_1SystemNorm.php#ad2d4cfa8bee893843d274f3c90534a1d">_weights_sq</a>.empty());
<a name="l00247"></a>00247   
<a name="l00248"></a>00248   <span class="keywordflow">return</span> (var &lt; <a class="code" href="classlibMesh_1_1SystemNorm.php#ad2d4cfa8bee893843d274f3c90534a1d">_weights_sq</a>.size()) ? <a class="code" href="classlibMesh_1_1SystemNorm.php#ad2d4cfa8bee893843d274f3c90534a1d">_weights_sq</a>[var] : 1.0;
<a name="l00249"></a>00249 }
<a name="l00250"></a>00250 
<a name="l00251"></a>00251 
<a name="l00252"></a>00252 } <span class="comment">// namespace libMesh</span>
<a name="l00253"></a>00253 
<a name="l00254"></a>00254 <span class="preprocessor">#endif // #define __system_norm_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
