<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_c3a49989e40b21e7508f29d2dc962def.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_94af86d0ee7ff5a2af0627e1a0ea6efa.php">systems</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">transient_rb_param_subdomain_tree.C</div>  </div>
</div>
<div class="contents">
<a href="transient__rb__param__subdomain__tree_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// rbOOmit: An implementation of the Certified Reduced Basis method.</span>
<a name="l00002"></a>00002 <span class="comment">// Copyright (C) 2009, 2010 David J. Knezevic</span>
<a name="l00003"></a>00003 
<a name="l00004"></a>00004 <span class="comment">// This file is part of rbOOmit.</span>
<a name="l00005"></a>00005 
<a name="l00006"></a>00006 <span class="comment">// rbOOmit is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// rbOOmit is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="preprocessor">#include &quot;<a class="code" href="transient__rb__param__subdomain__tree_8h.php">transient_rb_param_subdomain_tree.h</a>&quot;</span>
<a name="l00021"></a>00021 <span class="preprocessor">#include &quot;<a class="code" href="transient__rb__param__subdomain__node_8h.php">transient_rb_param_subdomain_node.h</a>&quot;</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &quot;<a class="code" href="getpot_8h.php">getpot.h</a>&quot;</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 TransientRBParamSubdomainTree::TransientRBParamSubdomainTree
<a name="l00025"></a><a class="code" href="classlibMesh_1_1TransientRBParamSubdomainTree.php#a3943aec04d8310b45f4496817b719a15">00025</a>   (<a class="code" href="classlibMesh_1_1TransientRBSystem.php">TransientRBSystem</a>&amp; rb_system_in, <span class="keyword">const</span> std::string&amp; parameters_filename)
<a name="l00026"></a>00026   : <a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php">Parent</a>(rb_system_in, parameters_filename),
<a name="l00027"></a>00027     conserv_factor(-1.),
<a name="l00028"></a>00028     use_delta_N_in_h_stage(<span class="keyword">false</span>)
<a name="l00029"></a>00029 {
<a name="l00030"></a>00030   <span class="comment">// Read in properties from parameters_filename</span>
<a name="l00031"></a>00031   GetPot infile(parameters_filename);
<a name="l00032"></a>00032 
<a name="l00033"></a>00033   conserv_factor = infile(<span class="stringliteral">&quot;conserv_factor&quot;</span>,conserv_factor);
<a name="l00034"></a>00034   libmesh_assert(conserv_factor &gt;= 1.);
<a name="l00035"></a>00035 
<a name="l00036"></a>00036   <span class="comment">// Set the boolean that indicates whether we use delta_N or the POD_tol</span>
<a name="l00037"></a>00037   <span class="comment">// in order to determine how many basis functions we add in the h-stage</span>
<a name="l00038"></a>00038   <span class="comment">// refinement for a time-dependent problem.</span>
<a name="l00039"></a>00039   use_delta_N_in_h_stage = infile(<span class="stringliteral">&quot;use_delta_N_in_h_stage&quot;</span>,use_delta_N_in_h_stage);
<a name="l00040"></a>00040 
<a name="l00041"></a>00041   <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; std::endl &lt;&lt; <span class="stringliteral">&quot;TransientRBParamSubdomainTree parameters:&quot;</span> &lt;&lt; std::endl;
<a name="l00042"></a>00042   <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Conservativity factor: &quot;</span> &lt;&lt; conserv_factor &lt;&lt; std::endl;
<a name="l00043"></a>00043   <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Using delta_N in h-stage: &quot;</span> &lt;&lt; use_delta_N_in_h_stage &lt;&lt; std::endl;
<a name="l00044"></a>00044   <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; std::endl;
<a name="l00045"></a>00045 }
<a name="l00046"></a>00046 
<a name="l00047"></a><a class="code" href="classlibMesh_1_1TransientRBParamSubdomainTree.php#a86e6e588cd58f315187928cd0634d957">00047</a> <span class="keywordtype">void</span> TransientRBParamSubdomainTree::build_root_node()
<a name="l00048"></a>00048 {
<a name="l00049"></a>00049   libmesh_assert(root_node == NULL);
<a name="l00050"></a>00050   root_node = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1TransientRBParamSubdomainNode.php">TransientRBParamSubdomainNode</a>(*<span class="keyword">this</span>, _rb_system.get_current_parameters());
<a name="l00051"></a>00051 }
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
