<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_eaf30c8ea092d33f79a04353c3899c3f.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_5a0c7151fa56969ceb962f1511f7edee.php">systems</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">transient_rb_system.h</div>  </div>
</div>
<div class="contents">
<a href="transient__rb__system_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// rbOOmit: An implementation of the Certified Reduced Basis method.</span>
<a name="l00002"></a>00002 <span class="comment">// Copyright (C) 2009, 2010 David J. Knezevic</span>
<a name="l00003"></a>00003 
<a name="l00004"></a>00004 <span class="comment">// This file is part of rbOOmit.</span>
<a name="l00005"></a>00005 
<a name="l00006"></a>00006 <span class="comment">// rbOOmit is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// rbOOmit is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="preprocessor">#ifndef __transient_rb_system_h__</span>
<a name="l00021"></a>00021 <span class="preprocessor"></span><span class="preprocessor">#define __transient_rb_system_h__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;<a class="code" href="transient__system_8h.php">transient_system.h</a>&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="code" href="rb__system_8h.php">rb_system.h</a>&quot;</span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="keyword">namespace </span>libMesh
<a name="l00027"></a>00027 {
<a name="l00028"></a>00028 
<a name="l00039"></a>00039 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00040"></a>00040 <span class="comment">// TransientRBSystem class definition</span>
<a name="l00041"></a>00041 
<a name="l00042"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php">00042</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1TransientRBSystem.php">TransientRBSystem</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1TransientSystem.php">TransientSystem</a>&lt;RBSystem&gt;
<a name="l00043"></a>00043 {
<a name="l00044"></a>00044 <span class="keyword">public</span>:
<a name="l00045"></a>00045 
<a name="l00050"></a>00050   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a332178f1af3116ae727fbcdcb03eb686">TransientRBSystem</a> (<a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00051"></a>00051             <span class="keyword">const</span> std::string&amp; <a class="code" href="classlibMesh_1_1System.php#af80f6b2e508821ebd9c8fcb78d443f18">name</a>,
<a name="l00052"></a>00052             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#aee5caacb487b070842733f1c84b9a2fd">number</a>);
<a name="l00053"></a>00053 
<a name="l00057"></a>00057   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a66cc224cd6cf5b3fe6ea704dc956b101">~TransientRBSystem</a> ();
<a name="l00058"></a>00058 
<a name="l00062"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a4bb55247df6f0012ea8e7d4086baa50e">00062</a>   <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php">TransientRBSystem</a> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a4bb55247df6f0012ea8e7d4086baa50e">sys_type</a>;
<a name="l00063"></a>00063 
<a name="l00067"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a1687df5cea8c05ea781ab30c5c8b63d2">00067</a>   <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1TransientSystem.php">TransientSystem&lt;RBSystem&gt;</a> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a1687df5cea8c05ea781ab30c5c8b63d2">Parent</a>;
<a name="l00068"></a>00068 
<a name="l00073"></a>00073   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a7fd1249de92ea775b87fc6c26a193eb5">clear</a> ();
<a name="l00074"></a>00074 
<a name="l00079"></a>00079   <span class="keyword">virtual</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a59ff693a0090652026381ab8004731b2">RB_solve</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N);
<a name="l00080"></a>00080 
<a name="l00084"></a>00084   <span class="keyword">virtual</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a9be4b235602aceea66681766c0832210">truth_solve</a>(<span class="keywordtype">int</span> write_interval);
<a name="l00085"></a>00085 
<a name="l00090"></a>00090   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a70c663d69b94e1389703b8442f8f46e0">greedy_termination_test</a>(<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> training_greedy_error, <span class="keywordtype">int</span> count);
<a name="l00091"></a>00091 
<a name="l00096"></a>00096   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ac3af79dab200ccbb0c13ec4ee2343720">clear_basis_function_dependent_data</a>();
<a name="l00097"></a>00097 
<a name="l00102"></a>00102   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#af5a3140301d034e23caf1bd68a2e2209">assemble_all_affine_operators</a>();
<a name="l00103"></a>00103   
<a name="l00107"></a>00107   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a597eb72e0f68b4759224f0c9efcdf6df">assemble_misc_matrices</a>();
<a name="l00108"></a>00108 
<a name="l00112"></a>00112   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a0ee3e3816d13aeae07fe5212dda5f521">assemble_L2_matrix</a>(<a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;Number&gt;</a>* input_matrix);
<a name="l00113"></a>00113 
<a name="l00118"></a>00118   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a9171ce91830a0ebfddb1666078552366">assemble_mass_matrix</a>(<a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;Number&gt;</a>* input_matrix);
<a name="l00119"></a>00119   
<a name="l00124"></a>00124   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a380f4b25919a4c93733eed98862b8f7b">add_scaled_mass_matrix</a>(<a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> scalar,
<a name="l00125"></a>00125                               <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;Number&gt;</a>* input_matrix);
<a name="l00126"></a>00126 
<a name="l00131"></a>00131   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#aca376bda2868976ae336c53078c9d40c">mass_matrix_scaled_matvec</a>(<a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> scalar,
<a name="l00132"></a>00132                                  <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>&amp; dest,
<a name="l00133"></a>00133                                  <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>&amp; arg);
<a name="l00134"></a>00134 
<a name="l00142"></a>00142   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae532258d3c072f941052e4e999665070">initialize_RB_system</a>(<span class="keywordtype">bool</span> online_mode);
<a name="l00143"></a>00143   
<a name="l00148"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">00148</a>   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>() { <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae1c7dff67ddddddb8b7f2bb96e78f4ec">theta_q_m_vector</a>.size(); }
<a name="l00149"></a>00149   
<a name="l00154"></a>00154   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ac6d66066090eb439c3c36b90c59e3655">attach_L2_assembly</a>(<a class="code" href="namespacelibMesh.php#a18a170af3a9d5eff6f43eb3409d0e296">affine_assembly_fptr</a> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a046c9e8b526c6d8b4c8093c6dc35fbfa">L2_assembly</a>);
<a name="l00155"></a>00155 
<a name="l00161"></a>00161   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ad450ea11b4475aede2c56d90b0d55a0b">attach_M_q</a>(<a class="code" href="namespacelibMesh.php#aa62736885c7a9bb67eda65b54ee20107">theta_q_fptr</a> theta_q_m,
<a name="l00162"></a>00162                   <a class="code" href="namespacelibMesh.php#a18a170af3a9d5eff6f43eb3409d0e296">affine_assembly_fptr</a> M_q_intrr_assembly,
<a name="l00163"></a>00163                   <a class="code" href="namespacelibMesh.php#a18a170af3a9d5eff6f43eb3409d0e296">affine_assembly_fptr</a> M_q_bndry_assembly=NULL);
<a name="l00164"></a>00164 
<a name="l00168"></a>00168   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a0b6610b9ad630934520fa4581101668e">assemble_Mq_matrix</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q, <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;Number&gt;</a>* input_matrix);
<a name="l00169"></a>00169   
<a name="l00173"></a>00173   <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;Number&gt;</a>* <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a528a1bc40b5c1b63ee8c51375b1824dc">get_M_q</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q);
<a name="l00174"></a>00174   
<a name="l00178"></a>00178   <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a36a6aa3be4fb96b256cb9d664e5a2dfb">eval_theta_q_m</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q);
<a name="l00179"></a>00179 
<a name="l00183"></a>00183   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#aaa040e14836cebced3a91a0fc7a63400">truth_assembly</a>();
<a name="l00184"></a>00184 
<a name="l00191"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a68d017bd7128cbce35e29b64924827a4">00191</a>   <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a68d017bd7128cbce35e29b64924827a4">get_max_truth_solves</a>()<span class="keyword"> const                   </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a50ac30217ac9358f43981e9e04d930c9">max_truth_solves</a>; }
<a name="l00192"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae6b33671e8cc08ffa859f6c32ce15506">00192</a>   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae6b33671e8cc08ffa859f6c32ce15506">set_max_truth_solves</a>(<span class="keywordtype">int</span> max_truth_solves_in) { this-&gt;<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a50ac30217ac9358f43981e9e04d930c9">max_truth_solves</a> = max_truth_solves_in; }
<a name="l00193"></a>00193 
<a name="l00197"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#ab5a283a3f305fd03ee1f8e25a5f11bbc">00197</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ab5a283a3f305fd03ee1f8e25a5f11bbc">get_dt</a>()<span class="keyword"> const        </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a04397bf3cc20ccd2bb5056c22b45c9f5">dt</a>; }
<a name="l00198"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a64abf8bdf7b064b4704c09c8f4f50682">00198</a>   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a64abf8bdf7b064b4704c09c8f4f50682">set_dt</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a04397bf3cc20ccd2bb5056c22b45c9f5">dt</a>) { this-&gt;dt = <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a04397bf3cc20ccd2bb5056c22b45c9f5">dt</a>; }
<a name="l00199"></a>00199 
<a name="l00203"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a00d040b3d3e32c093838a49ae143dfc9">00203</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a00d040b3d3e32c093838a49ae143dfc9">get_POD_tol</a>()<span class="keyword"> const                </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ab631619490c50d5e4f7873b6800f5bf8">POD_tol</a>; }
<a name="l00204"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#af3a1ec2ed58b491118a32521bf9d6b55">00204</a>   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#af3a1ec2ed58b491118a32521bf9d6b55">set_POD_tol</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> POD_tol_in) { this-&gt;<a class="code" href="classlibMesh_1_1TransientRBSystem.php#ab631619490c50d5e4f7873b6800f5bf8">POD_tol</a> = POD_tol_in; }
<a name="l00205"></a>00205 
<a name="l00213"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a546f47bca2dec636e0fe9c095c3dc3dd">00213</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a546f47bca2dec636e0fe9c095c3dc3dd">get_euler_theta</a>()<span class="keyword"> const                 </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a5af426f9dc2b27772aef689c19fbf4b0">euler_theta</a>; }
<a name="l00214"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a91b4d8e4e75b43cc4958945198a39efd">00214</a>   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a91b4d8e4e75b43cc4958945198a39efd">set_euler_theta</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a5af426f9dc2b27772aef689c19fbf4b0">euler_theta</a>) { libmesh_assert((0. &lt;= euler_theta ) &amp;&amp; (euler_theta &lt;= 1.));
<a name="l00215"></a>00215                                                  this-&gt;euler_theta = <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a5af426f9dc2b27772aef689c19fbf4b0">euler_theta</a>; }
<a name="l00216"></a>00216 
<a name="l00220"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a569330d25d5c05702896779bf564490c">00220</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a569330d25d5c05702896779bf564490c">get_time_level</a>()<span class="keyword"> const       </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae8bf672ee83dac4058eb4deb5b660750">_k</a>; }
<a name="l00221"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a262def83281fa63888e8ed5e3b59d1b8">00221</a>   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a262def83281fa63888e8ed5e3b59d1b8">set_time_level</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k) { libmesh_assert(<a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae8bf672ee83dac4058eb4deb5b660750">_k</a> &lt;= <a class="code" href="classlibMesh_1_1TransientRBSystem.php#aac8858a7e9af6497f3c37a4b7956ca6a">_K</a>); this-&gt;<a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae8bf672ee83dac4058eb4deb5b660750">_k</a> = k; }
<a name="l00222"></a>00222 
<a name="l00226"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a1d6afd63f9ec53e44cf75eb982df07c4">00226</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a1d6afd63f9ec53e44cf75eb982df07c4">get_K</a>()<span class="keyword"> const       </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#aac8858a7e9af6497f3c37a4b7956ca6a">_K</a>; }
<a name="l00227"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a287beb41c8dcc60c976eb4a95146ea84">00227</a>   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a287beb41c8dcc60c976eb4a95146ea84">set_K</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> K) { this-&gt;<a class="code" href="classlibMesh_1_1TransientRBSystem.php#aac8858a7e9af6497f3c37a4b7956ca6a">_K</a> = K; }
<a name="l00228"></a>00228 
<a name="l00233"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a6eb3788340334cf4bcf9d8fa788c31f8">00233</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a6eb3788340334cf4bcf9d8fa788c31f8">get_delta_N</a>()<span class="keyword"> const       </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a36ba489bd3158bbff48a5607e1d21d30">delta_N</a>; }
<a name="l00234"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a6a0ae338e9bb14d354ee6385cb5df85f">00234</a>   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a6a0ae338e9bb14d354ee6385cb5df85f">set_delta_N</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a36ba489bd3158bbff48a5607e1d21d30">delta_N</a>) { this-&gt;delta_N = <a class="code" href="classlibMesh_1_1RBSystem.php#a36ba489bd3158bbff48a5607e1d21d30">delta_N</a>; }
<a name="l00235"></a>00235 
<a name="l00240"></a>00240   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ad23a86810dc83165bb0ed2237fa6f521">load_RB_solution</a>();
<a name="l00241"></a>00241 
<a name="l00247"></a>00247   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a2616deed6f2ad941535bcaf7fb9505a5">write_offline_data_to_files</a>(<span class="keyword">const</span> std::string&amp; directory_name=<span class="stringliteral">&quot;offline_data&quot;</span>);
<a name="l00248"></a>00248 
<a name="l00254"></a>00254   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a8d0eb6348fd67e5a619279fbdf41fa62">read_offline_data_from_files</a>(<span class="keyword">const</span> std::string&amp; directory_name=<span class="stringliteral">&quot;offline_data&quot;</span>);
<a name="l00255"></a>00255 
<a name="l00256"></a>00256 
<a name="l00257"></a>00257   <span class="comment">//----------- PUBLIC DATA MEMBERS -----------//</span>
<a name="l00258"></a>00258 
<a name="l00262"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a4e15721a62defb903900352ceb0ea367">00262</a>   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt; SparseMatrix&lt;Number&gt;</a> &gt; <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a4e15721a62defb903900352ceb0ea367">L2_matrix</a>;
<a name="l00263"></a>00263   
<a name="l00267"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a8cbf1f70128f7a173eb169aebd0f496e">00267</a>   <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Number&gt;</a> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a8cbf1f70128f7a173eb169aebd0f496e">RB_L2_matrix</a>;
<a name="l00268"></a>00268 
<a name="l00272"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a9ba330e7121f7141b7ec495b3a2370be">00272</a>   std::vector&lt; SparseMatrix&lt;Number&gt;* &gt; <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a9ba330e7121f7141b7ec495b3a2370be">M_q_vector</a>;
<a name="l00273"></a>00273 
<a name="l00277"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#aae9cbd15df988bcdf5cf2db5fcb24e5b">00277</a>   std::vector&lt; DenseMatrix&lt;Number&gt; &gt; <a class="code" href="classlibMesh_1_1TransientRBSystem.php#aae9cbd15df988bcdf5cf2db5fcb24e5b">RB_M_q_vector</a>;
<a name="l00278"></a>00278 
<a name="l00283"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#aecf2610660c4023d6c993b4c08b64be4">00283</a>   std::vector&lt;Real&gt; <a class="code" href="classlibMesh_1_1TransientRBSystem.php#aecf2610660c4023d6c993b4c08b64be4">initial_L2_error_all_N</a>;
<a name="l00284"></a>00284 
<a name="l00289"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a4b802536cffba3d792caf8f95ed04327">00289</a>   std::vector&lt; DenseVector&lt;Number&gt; &gt; <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a4b802536cffba3d792caf8f95ed04327">RB_initial_condition_all_N</a>;
<a name="l00290"></a>00290 
<a name="l00295"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a8e91d71806a187bb38f888c6541654b5">00295</a>   std::vector&lt; Real &gt; <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a8e91d71806a187bb38f888c6541654b5">error_bound_all_k</a>;
<a name="l00296"></a>00296 
<a name="l00301"></a>00301 <span class="comment">//   std::vector&lt; Number &gt; true_error_all_k;</span>
<a name="l00302"></a>00302 
<a name="l00307"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#ad5066d07edc5e25cb04b00fde9e72ec2">00307</a>   std::vector&lt; std::vector&lt;Number&gt; &gt; <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ad5066d07edc5e25cb04b00fde9e72ec2">RB_outputs_all_k</a>;
<a name="l00308"></a>00308 
<a name="l00313"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#aeb55ea3e37e65db40b8dd322f4bcb4a6">00313</a>   std::vector&lt; std::vector&lt;Real&gt; &gt; <a class="code" href="classlibMesh_1_1TransientRBSystem.php#aeb55ea3e37e65db40b8dd322f4bcb4a6">RB_output_error_bounds_all_k</a>;
<a name="l00314"></a>00314 
<a name="l00319"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a58dda0affa01e49069a725153dcf5cc6">00319</a>   std::vector&lt; std::vector&lt;Number&gt; &gt; <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a58dda0affa01e49069a725153dcf5cc6">truth_outputs_all_k</a>;
<a name="l00320"></a>00320 
<a name="l00324"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#adbbe1db7bf9fd6a56b949147cd75d79f">00324</a>   <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#adbbe1db7bf9fd6a56b949147cd75d79f">old_RB_solution</a>;
<a name="l00325"></a>00325 
<a name="l00329"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a475a0b22e1808293b4d209f35f60914f">00329</a>   std::vector&lt; DenseVector&lt;Number&gt; &gt; <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a475a0b22e1808293b4d209f35f60914f">RB_temporal_solution_data</a>;
<a name="l00330"></a>00330 
<a name="l00334"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a7b52b6d7cf4f4f9245464050e876d21b">00334</a>   std::vector&lt; std::vector&lt; NumericVector&lt;Number&gt;* &gt; &gt; <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a7b52b6d7cf4f4f9245464050e876d21b">M_q_representor</a>;
<a name="l00335"></a>00335 
<a name="l00340"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a400cfc38ee1a109d110230227d59b651">00340</a>   std::vector&lt; std::vector&lt; std::vector&lt;Number&gt; &gt; &gt; <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a400cfc38ee1a109d110230227d59b651">Fq_Mq_representor_norms</a>;
<a name="l00341"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a4ab78d5be55e56ba7170868428592f51">00341</a>   std::vector&lt; std::vector&lt; std::vector&lt;Number&gt; &gt; &gt; <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a4ab78d5be55e56ba7170868428592f51">Mq_Mq_representor_norms</a>;
<a name="l00342"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#ad2d68b220943632bcb8327ca1b388eae">00342</a>   std::vector&lt; std::vector&lt; std::vector&lt; std::vector&lt;Number&gt; &gt; &gt; &gt; <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ad2d68b220943632bcb8327ca1b388eae">Aq_Mq_representor_norms</a>;
<a name="l00343"></a>00343 
<a name="l00348"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#af0fbee2db2698376fe3a932c5a7bcc26">00348</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#af0fbee2db2698376fe3a932c5a7bcc26">nonzero_initialization</a>;
<a name="l00349"></a>00349 
<a name="l00353"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a7cfe02ecfa70244829bb835fc9f2eab6">00353</a>   std::string <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a7cfe02ecfa70244829bb835fc9f2eab6">init_filename</a>;
<a name="l00354"></a>00354 
<a name="l00355"></a>00355 <span class="keyword">protected</span>:
<a name="l00360"></a>00360   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#aaff3a14e0f537aac7289e14239c0f3e5">init_data</a> ();
<a name="l00361"></a>00361 
<a name="l00367"></a>00367   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ab455004dfc57c1a9454534ab1a761dbc">initialize_truth</a>();
<a name="l00368"></a>00368   
<a name="l00373"></a>00373   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a14c59681fde1890ec3d0e1fbc031b784">assemble_matrix_for_output_dual_solves</a>();
<a name="l00374"></a>00374 
<a name="l00379"></a>00379   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#abc7508cfa934d11004a3c61914fb496a">add_IC_to_RB_space</a>();
<a name="l00380"></a>00380 
<a name="l00386"></a>00386   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a4787525ef1c9e18634fef8c8dc85ad6a">enrich_RB_space</a>();
<a name="l00387"></a>00387 
<a name="l00391"></a>00391   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae84573a528aea2088e92485998d83969">update_system</a>();
<a name="l00392"></a>00392 
<a name="l00398"></a>00398   <span class="keyword">virtual</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#aa64721ef4384e8892eca0dca5c5e7774">compute_residual_dual_norm</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N);
<a name="l00399"></a>00399   
<a name="l00406"></a>00406   <span class="keyword">virtual</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a10c5a6e0813561fffc80d4cea195e814">uncached_compute_residual_dual_norm</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N);
<a name="l00407"></a>00407 
<a name="l00411"></a>00411   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a0bd7a0e822ac88f71f9dd7baeef179a7">update_RB_system_matrices</a>();
<a name="l00412"></a>00412 
<a name="l00417"></a>00417   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#af65ff4ed2f3257fa79a540aafd6d58bc">update_residual_terms</a>(<span class="keywordtype">bool</span> compute_inner_products);
<a name="l00418"></a>00418 
<a name="l00424"></a>00424   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a465255c39194ff391528dfa0cff68995">update_RB_initial_condition_all_N</a>();
<a name="l00425"></a>00425 
<a name="l00431"></a>00431   <span class="keyword">virtual</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae9b4ca47590dc2975de08c73aa0e3a55">residual_scaling_numer</a>(<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> alpha_LB);
<a name="l00432"></a>00432 
<a name="l00438"></a>00438   <span class="keyword">virtual</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#aa638dbd9c57a34051024bc67309f7530">residual_scaling_denom</a>(<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> alpha_LB);
<a name="l00439"></a>00439 
<a name="l00445"></a>00445   <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a1d1eb4f1214b4e26a86137ed7ba38a13">set_error_temporal_data</a>();
<a name="l00446"></a>00446   
<a name="l00447"></a>00447   
<a name="l00453"></a>00453   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a3fce0d07ebe196e79fd03727fef00c79">cache_online_residual_terms</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N);
<a name="l00454"></a>00454 
<a name="l00455"></a>00455   <span class="comment">//----------- PROTECTED DATA MEMBERS -----------//</span>
<a name="l00456"></a>00456 
<a name="l00460"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a04397bf3cc20ccd2bb5056c22b45c9f5">00460</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a04397bf3cc20ccd2bb5056c22b45c9f5">dt</a>;
<a name="l00461"></a>00461 
<a name="l00468"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a5af426f9dc2b27772aef689c19fbf4b0">00468</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a5af426f9dc2b27772aef689c19fbf4b0">euler_theta</a>;
<a name="l00469"></a>00469 
<a name="l00473"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae8bf672ee83dac4058eb4deb5b660750">00473</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae8bf672ee83dac4058eb4deb5b660750">_k</a>;
<a name="l00474"></a>00474 
<a name="l00478"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#aac8858a7e9af6497f3c37a4b7956ca6a">00478</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#aac8858a7e9af6497f3c37a4b7956ca6a">_K</a>;
<a name="l00479"></a>00479 
<a name="l00485"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#ab631619490c50d5e4f7873b6800f5bf8">00485</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ab631619490c50d5e4f7873b6800f5bf8">POD_tol</a>;
<a name="l00486"></a>00486 
<a name="l00493"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a50ac30217ac9358f43981e9e04d930c9">00493</a>   <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a50ac30217ac9358f43981e9e04d930c9">max_truth_solves</a>;
<a name="l00494"></a>00494   
<a name="l00498"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a046c9e8b526c6d8b4c8093c6dc35fbfa">00498</a>   <a class="code" href="namespacelibMesh.php#a18a170af3a9d5eff6f43eb3409d0e296">affine_assembly_fptr</a> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a046c9e8b526c6d8b4c8093c6dc35fbfa">L2_assembly</a>;
<a name="l00499"></a>00499 
<a name="l00504"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae1c7dff67ddddddb8b7f2bb96e78f4ec">00504</a>   std::vector&lt;theta_q_fptr&gt; <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae1c7dff67ddddddb8b7f2bb96e78f4ec">theta_q_m_vector</a>;
<a name="l00505"></a>00505   
<a name="l00509"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#ab0c9e56b352b41ae67ad085358b5606f">00509</a>   std::vector&lt;affine_assembly_fptr&gt; <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ab0c9e56b352b41ae67ad085358b5606f">M_q_intrr_assembly_vector</a>;
<a name="l00510"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a35b236bc4b078d83bd0cb58a4aeb274f">00510</a>   std::vector&lt;affine_assembly_fptr&gt; <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a35b236bc4b078d83bd0cb58a4aeb274f">M_q_bndry_assembly_vector</a>;
<a name="l00511"></a>00511   
<a name="l00516"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#aca06ad6a5b244bb6e8b76d53810e2eb6">00516</a>   <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#aca06ad6a5b244bb6e8b76d53810e2eb6">RB_ic_proj_rhs_all_N</a>;
<a name="l00517"></a>00517 
<a name="l00521"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a3c019c5db106e9a6bd6975094e847b9c">00521</a>   <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a3c019c5db106e9a6bd6975094e847b9c">cached_Fq_term</a>;
<a name="l00522"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a4a0ff2eb1b7fe0c2ab1fec1c4b7aa252">00522</a>   <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a4a0ff2eb1b7fe0c2ab1fec1c4b7aa252">cached_Fq_Aq_vector</a>;
<a name="l00523"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#abc8120b0ce4b87f07ea535c19a7400ac">00523</a>   <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Number&gt;</a> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#abc8120b0ce4b87f07ea535c19a7400ac">cached_Aq_Aq_matrix</a>;
<a name="l00524"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a81be81cd8209898f489c7960019aa79d">00524</a>   <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a81be81cd8209898f489c7960019aa79d">cached_Fq_Mq_vector</a>;
<a name="l00525"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a2154a1b8d3da64df7dd0a9b6ac1dc3b2">00525</a>   <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Number&gt;</a> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a2154a1b8d3da64df7dd0a9b6ac1dc3b2">cached_Aq_Mq_matrix</a>;
<a name="l00526"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a4e532c8f9567060bc9a37ce06d7e2760">00526</a>   <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Number&gt;</a> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a4e532c8f9567060bc9a37ce06d7e2760">cached_Mq_Mq_matrix</a>;
<a name="l00527"></a>00527 
<a name="l00528"></a>00528 <span class="keyword">private</span>:
<a name="l00529"></a>00529 
<a name="l00534"></a>00534   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a5c843c30351d24f939389474310d770c">clear_basis_helper</a>();
<a name="l00535"></a>00535 
<a name="l00536"></a>00536   <span class="comment">//----------- PRIVATE DATA MEMBERS -----------//</span>
<a name="l00537"></a>00537 
<a name="l00541"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a5f9a29b24cc7de2f92e0e1b8f5acbe71">00541</a>   std::vector&lt; NumericVector&lt;Number&gt;* &gt; <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a5f9a29b24cc7de2f92e0e1b8f5acbe71">temporal_data</a>;
<a name="l00542"></a>00542 
<a name="l00543"></a>00543 };
<a name="l00544"></a>00544 
<a name="l00545"></a>00545 } <span class="comment">// namespace libMesh</span>
<a name="l00546"></a>00546 
<a name="l00547"></a>00547 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
