<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_eaf30c8ea092d33f79a04353c3899c3f.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_1a2b14d219bf20b3bfd3aaf502c1b987.php">numerics</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">type_vector.h</div>  </div>
</div>
<div class="contents">
<a href="type__vector_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id$</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __type_vector_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __type_vector_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;cmath&gt;</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="comment">// Local includes</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="compare__types_8h.php">compare_types.h</a>&quot;</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="keyword">namespace </span>libMesh
<a name="l00033"></a>00033 {
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="comment">// Forward declaration for friend class</span>
<a name="l00036"></a>00036 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00037"></a>00037 <span class="keyword">class </span>TypeTensor;
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 
<a name="l00051"></a>00051 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00052"></a><a class="code" href="classlibMesh_1_1TypeVector.php">00052</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector</a>
<a name="l00053"></a>00053 {
<a name="l00054"></a>00054 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00055"></a><a class="code" href="classlibMesh_1_1TypeVector.php#a5b7a6e992ba7ac8e78e558898115964b">00055</a> <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector</a>;
<a name="l00056"></a>00056 
<a name="l00057"></a><a class="code" href="classlibMesh_1_1TypeVector.php#ae6f59a3f0fe750f907d022512acb66a9">00057</a> <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1TypeTensor.php">TypeTensor</a>&lt;T&gt;;
<a name="l00058"></a>00058 
<a name="l00059"></a>00059 <span class="keyword">protected</span>:
<a name="l00060"></a>00060 
<a name="l00065"></a>00065   <a class="code" href="classlibMesh_1_1TypeVector.php#a5b7a6e992ba7ac8e78e558898115964b">TypeVector</a>  (<span class="keyword">const</span> T x=0.,
<a name="l00066"></a>00066                <span class="keyword">const</span> T y=0.,
<a name="l00067"></a>00067                <span class="keyword">const</span> T z=0.);
<a name="l00068"></a>00068   
<a name="l00069"></a>00069 <span class="keyword">public</span>:
<a name="l00070"></a>00070 
<a name="l00074"></a>00074   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00075"></a>00075   <a class="code" href="classlibMesh_1_1TypeVector.php#a5b7a6e992ba7ac8e78e558898115964b">TypeVector</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;T2&gt;</a>&amp; p);
<a name="l00076"></a>00076   
<a name="l00080"></a>00080   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1TypeVector.php#a6d246257a5ddbe065e48751635e3cc4b">~TypeVector</a> ();
<a name="l00081"></a>00081 
<a name="l00085"></a>00085   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00086"></a>00086   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TypeVector.php#a7e5c0b91ff2ef4527d40d877eacf0cc0">assign</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;T2&gt;</a> &amp;);
<a name="l00087"></a>00087 
<a name="l00091"></a>00091   T <a class="code" href="classlibMesh_1_1TypeVector.php#a2ba8e230145b252afec0434b140c963e">operator () </a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00092"></a>00092 
<a name="l00096"></a>00096   T &amp; <a class="code" href="classlibMesh_1_1TypeVector.php#a2ba8e230145b252afec0434b140c963e">operator () </a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i);
<a name="l00097"></a>00097   
<a name="l00101"></a>00101   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00102"></a>00102   <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;typename CompareTypes&lt;T, T2&gt;::supertype</a>&gt; 
<a name="l00103"></a>00103   <a class="code" href="classlibMesh_1_1TypeVector.php#a2da0e4b1e8b8d78556d28726a872a93d">operator + </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;T2&gt;</a> &amp;) <span class="keyword">const</span>;
<a name="l00104"></a>00104 
<a name="l00108"></a>00108   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00109"></a>00109   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;T&gt;</a> &amp; <a class="code" href="classlibMesh_1_1TypeVector.php#a7714acc0fa8cbdeb5bf3c126c204b20d">operator += </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;T2&gt;</a> &amp;);
<a name="l00110"></a>00110   
<a name="l00114"></a>00114   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00115"></a>00115   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TypeVector.php#a670ef717fd81b3b529503ecec7a949da">add</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;T2&gt;</a> &amp;); 
<a name="l00116"></a>00116   
<a name="l00121"></a>00121   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00122"></a>00122   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TypeVector.php#aaf2f65f39d9cdb06500baa2d571dc27f">add_scaled</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;T2&gt;</a> &amp;, <span class="keyword">const</span> T); 
<a name="l00123"></a>00123   
<a name="l00127"></a>00127   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00128"></a>00128   <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;typename CompareTypes&lt;T, T2&gt;::supertype</a>&gt; 
<a name="l00129"></a>00129   <a class="code" href="classlibMesh_1_1TypeVector.php#aacc0e36b6b5bd587b19f819ba7495ce4">operator - </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;T2&gt;</a> &amp;) <span class="keyword">const</span>;
<a name="l00130"></a>00130 
<a name="l00134"></a>00134   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00135"></a>00135   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;T&gt;</a> &amp; <a class="code" href="classlibMesh_1_1TypeVector.php#af36d050f396df108badc7dc33d2749ef">operator -= </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;T2&gt;</a> &amp;);
<a name="l00136"></a>00136 
<a name="l00140"></a>00140   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00141"></a>00141   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TypeVector.php#ab30739276c0205115fc7803740239e5b">subtract</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;T2&gt;</a> &amp;); 
<a name="l00142"></a>00142   
<a name="l00147"></a>00147   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00148"></a>00148   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TypeVector.php#a201d687a69ab6befaac50b5c3e72a224">subtract_scaled</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;T2&gt;</a> &amp;, <span class="keyword">const</span> T); 
<a name="l00149"></a>00149   
<a name="l00153"></a>00153   <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;T&gt;</a> <a class="code" href="classlibMesh_1_1TypeVector.php#aacc0e36b6b5bd587b19f819ba7495ce4">operator - </a>() <span class="keyword">const</span>;
<a name="l00154"></a>00154   
<a name="l00158"></a>00158   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> Scalar&gt;
<a name="l00159"></a>00159   <span class="keyword">typename</span> <a class="code" href="structlibMesh_1_1boostcopy_1_1enable__if__c.php">boostcopy::enable_if_c</a>&lt;
<a name="l00160"></a>00160     <a class="code" href="structlibMesh_1_1ScalarTraits.php">ScalarTraits&lt;Scalar&gt;::value</a>,
<a name="l00161"></a>00161     <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;typename CompareTypes&lt;T, Scalar&gt;::supertype</a>&gt; &gt;::type
<a name="l00162"></a>00162   <a class="code" href="classlibMesh_1_1TypeVector.php#ab75862b27b047da6b584a3300b67a809">operator * </a>(<span class="keyword">const</span> Scalar) <span class="keyword">const</span>;
<a name="l00163"></a>00163 
<a name="l00167"></a>00167   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;T&gt;</a> &amp; <a class="code" href="classlibMesh_1_1TypeVector.php#a7bb758820cca62d712fad2c592d95f06">operator *= </a>(<span class="keyword">const</span> T);
<a name="l00168"></a>00168   
<a name="l00172"></a>00172   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> Scalar&gt;
<a name="l00173"></a>00173   <span class="keyword">typename</span> <a class="code" href="structlibMesh_1_1boostcopy_1_1enable__if__c.php">boostcopy::enable_if_c</a>&lt;
<a name="l00174"></a>00174     <a class="code" href="structlibMesh_1_1ScalarTraits.php">ScalarTraits&lt;Scalar&gt;::value</a>,
<a name="l00175"></a>00175     <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;typename CompareTypes&lt;T, Scalar&gt;::supertype</a>&gt; &gt;::type
<a name="l00176"></a>00176   <a class="code" href="classlibMesh_1_1TypeVector.php#ab49251d9ddb1ff5b05d3433d43cd646e">operator / </a>(<span class="keyword">const</span> Scalar) <span class="keyword">const</span>;
<a name="l00177"></a>00177 
<a name="l00181"></a>00181   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;T&gt;</a> &amp; <a class="code" href="classlibMesh_1_1TypeVector.php#aa58a379076d158ce69663f65b6d53083">operator /= </a>(<span class="keyword">const</span> T);
<a name="l00182"></a>00182 
<a name="l00187"></a>00187   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00188"></a>00188   <span class="keyword">typename</span> <a class="code" href="structlibMesh_1_1CompareTypes.php#ad4a5d1fd1ae6c9db9a9422258d7ca949">CompareTypes&lt;T, T2&gt;::supertype</a>
<a name="l00189"></a>00189   <a class="code" href="classlibMesh_1_1TypeVector.php#ab75862b27b047da6b584a3300b67a809">operator * </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;T2&gt;</a> &amp;) <span class="keyword">const</span>;
<a name="l00190"></a>00190 
<a name="l00194"></a>00194   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00195"></a>00195   <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;typename CompareTypes&lt;T, T2&gt;::supertype</a>&gt;
<a name="l00196"></a>00196   <a class="code" href="classlibMesh_1_1TypeVector.php#a2aec9a10f796ec4cd55c5d2a62885305">cross</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;T2&gt;</a> &amp;) <span class="keyword">const</span>;
<a name="l00197"></a>00197 
<a name="l00202"></a>00202   <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;T&gt;</a> <a class="code" href="classlibMesh_1_1TypeVector.php#af309ac3227a31641f8e8ecbe9bb972a5">unit</a>() <span class="keyword">const</span>;
<a name="l00203"></a>00203 
<a name="l00208"></a>00208   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1TypeVector.php#a8dcd4a3bff824a7cb1aeee67bdfb598d">size</a>() <span class="keyword">const</span>;
<a name="l00209"></a>00209 
<a name="l00214"></a>00214   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1TypeVector.php#a6388a8db55ae02bdf8a72d0c4df45301">size_sq</a>() <span class="keyword">const</span>;
<a name="l00215"></a>00215 
<a name="l00219"></a>00219   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TypeVector.php#a4039c6e4f87fa907b3aeaafd66c0c1ce">zero</a>();
<a name="l00220"></a>00220 
<a name="l00225"></a>00225   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1TypeVector.php#a510b7f78c908b4d0f2a1250bace34d88">relative_fuzzy_equals</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;T&gt;</a>&amp; rhs, <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> tol = TOLERANCE) <span class="keyword">const</span>;
<a name="l00226"></a>00226   
<a name="l00231"></a>00231   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1TypeVector.php#aebdea0b3d6d9b9e699a15c9a9f532d8a">absolute_fuzzy_equals</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;T&gt;</a>&amp; rhs, <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> tol = TOLERANCE) <span class="keyword">const</span>;
<a name="l00232"></a>00232   
<a name="l00237"></a>00237   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1TypeVector.php#acde2ea3b922e6de4e2de70c6a8b8a215">operator == </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;T&gt;</a>&amp; rhs) <span class="keyword">const</span>;
<a name="l00238"></a>00238   
<a name="l00243"></a>00243   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1TypeVector.php#aa259f5756ea842a985cc0ed1036e73a9">operator != </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;T&gt;</a>&amp; rhs) <span class="keyword">const</span>;
<a name="l00244"></a>00244   
<a name="l00251"></a>00251   <span class="keywordtype">bool</span> operator &lt; (const TypeVector&lt;T&gt;&amp; rhs) <span class="keyword">const</span>;
<a name="l00252"></a>00252   
<a name="l00259"></a>00259   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1TypeVector.php#a6a5023e588b873426b82b1f5dffd03f4">operator &gt; </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;T&gt;</a>&amp; rhs) <span class="keyword">const</span>;
<a name="l00260"></a>00260 
<a name="l00264"></a>00264   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TypeVector.php#a627b1940ec29f27d62c13d31658f945e">print</a>(std::ostream&amp; os = <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a>) <span class="keyword">const</span>;
<a name="l00265"></a>00265 
<a name="l00271"></a><a class="code" href="classlibMesh_1_1TypeVector.php#a7948f665d08fffeeb5e3954f91dd62a6">00271</a>   <span class="keyword">friend</span> std::ostream&amp; operator &lt;&lt; (std::ostream&amp; os, const TypeVector&lt;T&gt;&amp; t)
<a name="l00272"></a>00272   {
<a name="l00273"></a>00273     t.print(os);
<a name="l00274"></a>00274     <span class="keywordflow">return</span> os;
<a name="l00275"></a>00275   }
<a name="l00276"></a>00276   
<a name="l00282"></a>00282   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TypeVector.php#ab06b207d152da2cdc8dbf147f01b97cf">write_unformatted</a> (std::ostream &amp;<a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">out</a>, <span class="keyword">const</span> <span class="keywordtype">bool</span> newline = <span class="keyword">true</span>) <span class="keyword">const</span>;
<a name="l00283"></a>00283     
<a name="l00284"></a>00284  <span class="keyword">protected</span>:
<a name="l00285"></a>00285 
<a name="l00289"></a><a class="code" href="classlibMesh_1_1TypeVector.php#a164f4a8009b50213232b6fe9e47b5de0">00289</a>   T <a class="code" href="classlibMesh_1_1TypeVector.php#a164f4a8009b50213232b6fe9e47b5de0">_coords</a>[LIBMESH_DIM];
<a name="l00290"></a>00290 };
<a name="l00291"></a>00291 
<a name="l00292"></a>00292 
<a name="l00293"></a>00293 
<a name="l00294"></a>00294 <span class="comment">//------------------------------------------------------</span>
<a name="l00295"></a>00295 <span class="comment">// Inline functions</span>
<a name="l00296"></a>00296 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00297"></a>00297 <span class="keyword">inline</span>
<a name="l00298"></a><a class="code" href="classlibMesh_1_1TypeVector.php#a03cf0ef1e1d5d33caf2ec5f643245c0d">00298</a> <a class="code" href="classlibMesh_1_1TypeVector.php#a5b7a6e992ba7ac8e78e558898115964b">TypeVector&lt;T&gt;::TypeVector</a> (<span class="keyword">const</span> T x,
<a name="l00299"></a>00299                            <span class="keyword">const</span> T y,
<a name="l00300"></a>00300                            <span class="keyword">const</span> T z)
<a name="l00301"></a>00301 {
<a name="l00302"></a>00302   _coords[0] = x;
<a name="l00303"></a>00303 
<a name="l00304"></a>00304   <span class="keywordflow">if</span> (LIBMESH_DIM &gt; 1)
<a name="l00305"></a>00305     {
<a name="l00306"></a>00306       _coords[1] = y;
<a name="l00307"></a>00307 
<a name="l00308"></a>00308       <span class="keywordflow">if</span> (LIBMESH_DIM == 3)
<a name="l00309"></a>00309         _coords[2] = z;
<a name="l00310"></a>00310     }
<a name="l00311"></a>00311 }
<a name="l00312"></a>00312 
<a name="l00313"></a>00313 
<a name="l00314"></a>00314 
<a name="l00315"></a>00315 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00316"></a>00316 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00317"></a>00317 <span class="keyword">inline</span>
<a name="l00318"></a><a class="code" href="classlibMesh_1_1TypeVector.php#a29de71fd49a7f5eb54fe31e75a993cec">00318</a> <a class="code" href="classlibMesh_1_1TypeVector.php#a5b7a6e992ba7ac8e78e558898115964b">TypeVector&lt;T&gt;::TypeVector</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;T2&gt;</a> &amp;p)
<a name="l00319"></a>00319 {
<a name="l00320"></a>00320   <span class="comment">// copy the nodes from vector p to me</span>
<a name="l00321"></a>00321   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;LIBMESH_DIM; i++)
<a name="l00322"></a>00322     _coords[i] = p.<a class="code" href="classlibMesh_1_1TypeVector.php#a164f4a8009b50213232b6fe9e47b5de0">_coords</a>[i];
<a name="l00323"></a>00323 }
<a name="l00324"></a>00324 
<a name="l00325"></a>00325 
<a name="l00326"></a>00326 
<a name="l00327"></a>00327 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00328"></a>00328 <span class="keyword">inline</span>
<a name="l00329"></a><a class="code" href="classlibMesh_1_1TypeVector.php#a6d246257a5ddbe065e48751635e3cc4b">00329</a> <a class="code" href="classlibMesh_1_1TypeVector.php#a6d246257a5ddbe065e48751635e3cc4b">TypeVector&lt;T&gt;::~TypeVector</a> ()
<a name="l00330"></a>00330 {
<a name="l00331"></a>00331 }
<a name="l00332"></a>00332 
<a name="l00333"></a>00333 
<a name="l00334"></a>00334 
<a name="l00335"></a>00335 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00336"></a>00336 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00337"></a>00337 <span class="keyword">inline</span>
<a name="l00338"></a><a class="code" href="classlibMesh_1_1TypeVector.php#a7e5c0b91ff2ef4527d40d877eacf0cc0">00338</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TypeVector.php#a7e5c0b91ff2ef4527d40d877eacf0cc0">TypeVector&lt;T&gt;::assign</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;T2&gt;</a> &amp;p)
<a name="l00339"></a>00339 {
<a name="l00340"></a>00340   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;LIBMESH_DIM; i++)
<a name="l00341"></a>00341     _coords[i] = p.<a class="code" href="classlibMesh_1_1TypeVector.php#a164f4a8009b50213232b6fe9e47b5de0">_coords</a>[i];
<a name="l00342"></a>00342 }
<a name="l00343"></a>00343 
<a name="l00344"></a>00344 
<a name="l00345"></a>00345 
<a name="l00346"></a>00346 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00347"></a>00347 <span class="keyword">inline</span>
<a name="l00348"></a><a class="code" href="classlibMesh_1_1TypeVector.php#a2ba8e230145b252afec0434b140c963e">00348</a> T <a class="code" href="classlibMesh_1_1TypeVector.php#a2ba8e230145b252afec0434b140c963e">TypeVector&lt;T&gt;::operator () </a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00349"></a>00349 <span class="keyword"></span>{
<a name="l00350"></a>00350   libmesh_assert (i&lt;3);
<a name="l00351"></a>00351 
<a name="l00352"></a>00352 <span class="preprocessor">#if LIBMESH_DIM &lt; 3</span>
<a name="l00353"></a>00353 <span class="preprocessor"></span>  
<a name="l00354"></a>00354   <span class="keywordflow">if</span> (i &gt; (LIBMESH_DIM-1))
<a name="l00355"></a>00355     <span class="keywordflow">return</span> 0.;
<a name="l00356"></a>00356   
<a name="l00357"></a>00357 <span class="preprocessor">#endif</span>
<a name="l00358"></a>00358 <span class="preprocessor"></span>  
<a name="l00359"></a>00359   <span class="keywordflow">return</span> _coords[i];
<a name="l00360"></a>00360 }
<a name="l00361"></a>00361 
<a name="l00362"></a>00362 
<a name="l00363"></a>00363 
<a name="l00364"></a>00364 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00365"></a>00365 <span class="keyword">inline</span>
<a name="l00366"></a><a class="code" href="classlibMesh_1_1TypeVector.php#a3568df25f9c0db5decbcaa9d42420439">00366</a> T &amp; <a class="code" href="classlibMesh_1_1TypeVector.php#a2ba8e230145b252afec0434b140c963e">TypeVector&lt;T&gt;::operator () </a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)
<a name="l00367"></a>00367 {
<a name="l00368"></a>00368   libmesh_assert (i&lt;LIBMESH_DIM);
<a name="l00369"></a>00369   
<a name="l00370"></a>00370   <span class="keywordflow">return</span> _coords[i];
<a name="l00371"></a>00371 }
<a name="l00372"></a>00372 
<a name="l00373"></a>00373 
<a name="l00374"></a>00374 
<a name="l00375"></a>00375 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00376"></a>00376 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00377"></a>00377 <span class="keyword">inline</span>
<a name="l00378"></a>00378 <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;typename CompareTypes&lt;T, T2&gt;::supertype</a>&gt; 
<a name="l00379"></a><a class="code" href="classlibMesh_1_1TypeVector.php#a2da0e4b1e8b8d78556d28726a872a93d">00379</a> <a class="code" href="classlibMesh_1_1TypeVector.php#a2da0e4b1e8b8d78556d28726a872a93d">TypeVector&lt;T&gt;::operator + </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;T2&gt;</a> &amp;p)<span class="keyword"> const</span>
<a name="l00380"></a>00380 <span class="keyword"></span>{
<a name="l00381"></a>00381   <span class="keyword">typedef</span> <span class="keyword">typename</span> <a class="code" href="structlibMesh_1_1CompareTypes.php#ad4a5d1fd1ae6c9db9a9422258d7ca949">CompareTypes&lt;T, T2&gt;::supertype</a> TS;
<a name="l00382"></a>00382 <span class="preprocessor">#if LIBMESH_DIM == 1</span>
<a name="l00383"></a>00383 <span class="preprocessor"></span>  <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;TS&gt;</a> (_coords[0] + p.<a class="code" href="classlibMesh_1_1TypeVector.php#a164f4a8009b50213232b6fe9e47b5de0">_coords</a>[0]);
<a name="l00384"></a>00384 <span class="preprocessor">#endif</span>
<a name="l00385"></a>00385 <span class="preprocessor"></span>
<a name="l00386"></a>00386 <span class="preprocessor">#if LIBMESH_DIM == 2 </span>
<a name="l00387"></a>00387 <span class="preprocessor"></span>  <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;TS&gt;</a> (_coords[0] + p.<a class="code" href="classlibMesh_1_1TypeVector.php#a164f4a8009b50213232b6fe9e47b5de0">_coords</a>[0],
<a name="l00388"></a>00388                          _coords[1] + p.<a class="code" href="classlibMesh_1_1TypeVector.php#a164f4a8009b50213232b6fe9e47b5de0">_coords</a>[1]);
<a name="l00389"></a>00389 <span class="preprocessor">#endif</span>
<a name="l00390"></a>00390 <span class="preprocessor"></span>
<a name="l00391"></a>00391 <span class="preprocessor">#if LIBMESH_DIM == 3</span>
<a name="l00392"></a>00392 <span class="preprocessor"></span>  <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;TS&gt;</a> (_coords[0] + p.<a class="code" href="classlibMesh_1_1TypeVector.php#a164f4a8009b50213232b6fe9e47b5de0">_coords</a>[0],
<a name="l00393"></a>00393                          _coords[1] + p.<a class="code" href="classlibMesh_1_1TypeVector.php#a164f4a8009b50213232b6fe9e47b5de0">_coords</a>[1],
<a name="l00394"></a>00394                          _coords[2] + p.<a class="code" href="classlibMesh_1_1TypeVector.php#a164f4a8009b50213232b6fe9e47b5de0">_coords</a>[2]);
<a name="l00395"></a>00395 <span class="preprocessor">#endif</span>
<a name="l00396"></a>00396 <span class="preprocessor"></span>               
<a name="l00397"></a>00397 }
<a name="l00398"></a>00398 
<a name="l00399"></a>00399 
<a name="l00400"></a>00400 
<a name="l00401"></a>00401 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00402"></a>00402 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00403"></a>00403 <span class="keyword">inline</span>
<a name="l00404"></a><a class="code" href="classlibMesh_1_1TypeVector.php#a7714acc0fa8cbdeb5bf3c126c204b20d">00404</a> <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;T&gt;</a> &amp; <a class="code" href="classlibMesh_1_1TypeVector.php#a7714acc0fa8cbdeb5bf3c126c204b20d">TypeVector&lt;T&gt;::operator += </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;T2&gt;</a> &amp;p)
<a name="l00405"></a>00405 {
<a name="l00406"></a>00406   this-&gt;add (p);
<a name="l00407"></a>00407 
<a name="l00408"></a>00408   <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00409"></a>00409 }
<a name="l00410"></a>00410 
<a name="l00411"></a>00411 
<a name="l00412"></a>00412 
<a name="l00413"></a>00413 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00414"></a>00414 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00415"></a>00415 <span class="keyword">inline</span>
<a name="l00416"></a><a class="code" href="classlibMesh_1_1TypeVector.php#a670ef717fd81b3b529503ecec7a949da">00416</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TypeVector.php#a670ef717fd81b3b529503ecec7a949da">TypeVector&lt;T&gt;::add</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;T2&gt;</a> &amp;p)
<a name="l00417"></a>00417 {
<a name="l00418"></a>00418 <span class="preprocessor">#if LIBMESH_DIM == 1</span>
<a name="l00419"></a>00419 <span class="preprocessor"></span>  _coords[0] += p.<a class="code" href="classlibMesh_1_1TypeVector.php#a164f4a8009b50213232b6fe9e47b5de0">_coords</a>[0];
<a name="l00420"></a>00420 <span class="preprocessor">#endif</span>
<a name="l00421"></a>00421 <span class="preprocessor"></span>  
<a name="l00422"></a>00422 <span class="preprocessor">#if LIBMESH_DIM == 2</span>
<a name="l00423"></a>00423 <span class="preprocessor"></span>  _coords[0] += p.<a class="code" href="classlibMesh_1_1TypeVector.php#a164f4a8009b50213232b6fe9e47b5de0">_coords</a>[0];
<a name="l00424"></a>00424   _coords[1] += p.<a class="code" href="classlibMesh_1_1TypeVector.php#a164f4a8009b50213232b6fe9e47b5de0">_coords</a>[1];
<a name="l00425"></a>00425 <span class="preprocessor">#endif</span>
<a name="l00426"></a>00426 <span class="preprocessor"></span>  
<a name="l00427"></a>00427 <span class="preprocessor">#if LIBMESH_DIM == 3</span>
<a name="l00428"></a>00428 <span class="preprocessor"></span>  _coords[0] += p.<a class="code" href="classlibMesh_1_1TypeVector.php#a164f4a8009b50213232b6fe9e47b5de0">_coords</a>[0];
<a name="l00429"></a>00429   _coords[1] += p.<a class="code" href="classlibMesh_1_1TypeVector.php#a164f4a8009b50213232b6fe9e47b5de0">_coords</a>[1];
<a name="l00430"></a>00430   _coords[2] += p.<a class="code" href="classlibMesh_1_1TypeVector.php#a164f4a8009b50213232b6fe9e47b5de0">_coords</a>[2];
<a name="l00431"></a>00431 <span class="preprocessor">#endif</span>
<a name="l00432"></a>00432 <span class="preprocessor"></span>
<a name="l00433"></a>00433 }
<a name="l00434"></a>00434 
<a name="l00435"></a>00435 
<a name="l00436"></a>00436 
<a name="l00437"></a>00437 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00438"></a>00438 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00439"></a>00439 <span class="keyword">inline</span>
<a name="l00440"></a><a class="code" href="classlibMesh_1_1TypeVector.php#aaf2f65f39d9cdb06500baa2d571dc27f">00440</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TypeVector.php#aaf2f65f39d9cdb06500baa2d571dc27f">TypeVector&lt;T&gt;::add_scaled</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;T2&gt;</a> &amp;p, <span class="keyword">const</span> T factor)
<a name="l00441"></a>00441 {
<a name="l00442"></a>00442 <span class="preprocessor">#if LIBMESH_DIM == 1</span>
<a name="l00443"></a>00443 <span class="preprocessor"></span>  _coords[0] += factor*p(0);
<a name="l00444"></a>00444 <span class="preprocessor">#endif</span>
<a name="l00445"></a>00445 <span class="preprocessor"></span>  
<a name="l00446"></a>00446 <span class="preprocessor">#if LIBMESH_DIM == 2</span>
<a name="l00447"></a>00447 <span class="preprocessor"></span>  _coords[0] += factor*p(0);
<a name="l00448"></a>00448   _coords[1] += factor*p(1);
<a name="l00449"></a>00449 <span class="preprocessor">#endif</span>
<a name="l00450"></a>00450 <span class="preprocessor"></span>  
<a name="l00451"></a>00451 <span class="preprocessor">#if LIBMESH_DIM == 3</span>
<a name="l00452"></a>00452 <span class="preprocessor"></span>  _coords[0] += factor*p(0);
<a name="l00453"></a>00453   _coords[1] += factor*p(1);
<a name="l00454"></a>00454   _coords[2] += factor*p(2);
<a name="l00455"></a>00455 <span class="preprocessor">#endif</span>
<a name="l00456"></a>00456 <span class="preprocessor"></span>
<a name="l00457"></a>00457 }
<a name="l00458"></a>00458 
<a name="l00459"></a>00459 
<a name="l00460"></a>00460 
<a name="l00461"></a>00461 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00462"></a>00462 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00463"></a>00463 <span class="keyword">inline</span>
<a name="l00464"></a>00464 <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;typename CompareTypes&lt;T, T2&gt;::supertype</a>&gt; 
<a name="l00465"></a><a class="code" href="classlibMesh_1_1TypeVector.php#a385fd74ebe9c297aa43e60597f33f2e3">00465</a> <a class="code" href="classlibMesh_1_1TypeVector.php#aacc0e36b6b5bd587b19f819ba7495ce4">TypeVector&lt;T&gt;::operator - </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;T2&gt;</a> &amp;p)<span class="keyword"> const</span>
<a name="l00466"></a>00466 <span class="keyword"></span>{
<a name="l00467"></a>00467   <span class="keyword">typedef</span> <span class="keyword">typename</span> <a class="code" href="structlibMesh_1_1CompareTypes.php#ad4a5d1fd1ae6c9db9a9422258d7ca949">CompareTypes&lt;T, T2&gt;::supertype</a> TS;
<a name="l00468"></a>00468 
<a name="l00469"></a>00469 <span class="preprocessor">#if LIBMESH_DIM == 1</span>
<a name="l00470"></a>00470 <span class="preprocessor"></span>  <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;TS&gt;</a>(_coords[0] - p.<a class="code" href="classlibMesh_1_1TypeVector.php#a164f4a8009b50213232b6fe9e47b5de0">_coords</a>[0]);
<a name="l00471"></a>00471 <span class="preprocessor">#endif</span>
<a name="l00472"></a>00472 <span class="preprocessor"></span>
<a name="l00473"></a>00473 <span class="preprocessor">#if LIBMESH_DIM == 2 </span>
<a name="l00474"></a>00474 <span class="preprocessor"></span>  <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;TS&gt;</a>(_coords[0] - p.<a class="code" href="classlibMesh_1_1TypeVector.php#a164f4a8009b50213232b6fe9e47b5de0">_coords</a>[0],
<a name="l00475"></a>00475                         _coords[1] - p.<a class="code" href="classlibMesh_1_1TypeVector.php#a164f4a8009b50213232b6fe9e47b5de0">_coords</a>[1]);
<a name="l00476"></a>00476 <span class="preprocessor">#endif</span>
<a name="l00477"></a>00477 <span class="preprocessor"></span>
<a name="l00478"></a>00478 <span class="preprocessor">#if LIBMESH_DIM == 3</span>
<a name="l00479"></a>00479 <span class="preprocessor"></span>  <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;TS&gt;</a>(_coords[0] - p.<a class="code" href="classlibMesh_1_1TypeVector.php#a164f4a8009b50213232b6fe9e47b5de0">_coords</a>[0],
<a name="l00480"></a>00480                         _coords[1] - p.<a class="code" href="classlibMesh_1_1TypeVector.php#a164f4a8009b50213232b6fe9e47b5de0">_coords</a>[1],
<a name="l00481"></a>00481                         _coords[2] - p.<a class="code" href="classlibMesh_1_1TypeVector.php#a164f4a8009b50213232b6fe9e47b5de0">_coords</a>[2]);
<a name="l00482"></a>00482 <span class="preprocessor">#endif</span>
<a name="l00483"></a>00483 <span class="preprocessor"></span>
<a name="l00484"></a>00484 }
<a name="l00485"></a>00485 
<a name="l00486"></a>00486 
<a name="l00487"></a>00487 
<a name="l00488"></a>00488 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00489"></a>00489 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00490"></a>00490 <span class="keyword">inline</span>
<a name="l00491"></a><a class="code" href="classlibMesh_1_1TypeVector.php#af36d050f396df108badc7dc33d2749ef">00491</a> <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;T&gt;</a> &amp; <a class="code" href="classlibMesh_1_1TypeVector.php#af36d050f396df108badc7dc33d2749ef">TypeVector&lt;T&gt;::operator -= </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;T2&gt;</a> &amp;p)
<a name="l00492"></a>00492 {
<a name="l00493"></a>00493   this-&gt;subtract (p);
<a name="l00494"></a>00494 
<a name="l00495"></a>00495   <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00496"></a>00496 }
<a name="l00497"></a>00497 
<a name="l00498"></a>00498 
<a name="l00499"></a>00499 
<a name="l00500"></a>00500 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00501"></a>00501 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00502"></a>00502 <span class="keyword">inline</span>
<a name="l00503"></a><a class="code" href="classlibMesh_1_1TypeVector.php#ab30739276c0205115fc7803740239e5b">00503</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TypeVector.php#ab30739276c0205115fc7803740239e5b">TypeVector&lt;T&gt;::subtract</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;T2&gt;</a>&amp; p)
<a name="l00504"></a>00504 {
<a name="l00505"></a>00505   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;LIBMESH_DIM; i++)
<a name="l00506"></a>00506     _coords[i] -= p.<a class="code" href="classlibMesh_1_1TypeVector.php#a164f4a8009b50213232b6fe9e47b5de0">_coords</a>[i];
<a name="l00507"></a>00507 }
<a name="l00508"></a>00508 
<a name="l00509"></a>00509 
<a name="l00510"></a>00510 
<a name="l00511"></a>00511 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00512"></a>00512 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00513"></a>00513 <span class="keyword">inline</span>
<a name="l00514"></a><a class="code" href="classlibMesh_1_1TypeVector.php#a201d687a69ab6befaac50b5c3e72a224">00514</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TypeVector.php#a201d687a69ab6befaac50b5c3e72a224">TypeVector&lt;T&gt;::subtract_scaled</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;T2&gt;</a> &amp;p, <span class="keyword">const</span> T factor)
<a name="l00515"></a>00515 {
<a name="l00516"></a>00516   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;LIBMESH_DIM; i++)
<a name="l00517"></a>00517     _coords[i] -= factor*p(i);
<a name="l00518"></a>00518 }
<a name="l00519"></a>00519 
<a name="l00520"></a>00520 
<a name="l00521"></a>00521 
<a name="l00522"></a>00522 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00523"></a>00523 <span class="keyword">inline</span>
<a name="l00524"></a><a class="code" href="classlibMesh_1_1TypeVector.php#aacc0e36b6b5bd587b19f819ba7495ce4">00524</a> <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;T&gt;</a> <a class="code" href="classlibMesh_1_1TypeVector.php#aacc0e36b6b5bd587b19f819ba7495ce4">TypeVector&lt;T&gt;::operator - </a>()<span class="keyword"> const</span>
<a name="l00525"></a>00525 <span class="keyword"></span>{
<a name="l00526"></a>00526   
<a name="l00527"></a>00527 <span class="preprocessor">#if LIBMESH_DIM == 1</span>
<a name="l00528"></a>00528 <span class="preprocessor"></span>  <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector</a>(-_coords[0]);
<a name="l00529"></a>00529 <span class="preprocessor">#endif</span>
<a name="l00530"></a>00530 <span class="preprocessor"></span>
<a name="l00531"></a>00531 <span class="preprocessor">#if LIBMESH_DIM == 2 </span>
<a name="l00532"></a>00532 <span class="preprocessor"></span>  <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector</a>(-_coords[0],
<a name="l00533"></a>00533                     -_coords[1]);
<a name="l00534"></a>00534 <span class="preprocessor">#endif</span>
<a name="l00535"></a>00535 <span class="preprocessor"></span>
<a name="l00536"></a>00536 <span class="preprocessor">#if LIBMESH_DIM == 3</span>
<a name="l00537"></a>00537 <span class="preprocessor"></span>  <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector</a>(-_coords[0],
<a name="l00538"></a>00538                     -_coords[1], 
<a name="l00539"></a>00539                     -_coords[2]);
<a name="l00540"></a>00540 <span class="preprocessor">#endif</span>
<a name="l00541"></a>00541 <span class="preprocessor"></span>  
<a name="l00542"></a>00542 }
<a name="l00543"></a>00543 
<a name="l00544"></a>00544 
<a name="l00545"></a>00545 
<a name="l00546"></a>00546 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00547"></a>00547 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> Scalar&gt;
<a name="l00548"></a>00548 <span class="keyword">inline</span>
<a name="l00549"></a>00549 <span class="keyword">typename</span> <a class="code" href="structlibMesh_1_1boostcopy_1_1enable__if__c.php">boostcopy::enable_if_c</a>&lt;
<a name="l00550"></a>00550   <a class="code" href="structlibMesh_1_1ScalarTraits.php">ScalarTraits&lt;Scalar&gt;::value</a>,
<a name="l00551"></a>00551   <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;typename CompareTypes&lt;T, Scalar&gt;::supertype</a>&gt; &gt;::type
<a name="l00552"></a><a class="code" href="classlibMesh_1_1TypeVector.php#ab75862b27b047da6b584a3300b67a809">00552</a> <a class="code" href="classlibMesh_1_1TypeVector.php#ab75862b27b047da6b584a3300b67a809">TypeVector&lt;T&gt;::operator * </a>(<span class="keyword">const</span> Scalar factor)<span class="keyword"> const</span>
<a name="l00553"></a>00553 <span class="keyword"></span>{
<a name="l00554"></a>00554   <span class="keyword">typedef</span> <span class="keyword">typename</span> <a class="code" href="structlibMesh_1_1CompareTypes.php#ad4a5d1fd1ae6c9db9a9422258d7ca949">CompareTypes&lt;T, Scalar&gt;::supertype</a> TS;
<a name="l00555"></a>00555 
<a name="l00556"></a>00556 <span class="preprocessor">#if LIBMESH_DIM == 1</span>
<a name="l00557"></a>00557 <span class="preprocessor"></span>  <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;TS&gt;</a>(_coords[0]*factor);
<a name="l00558"></a>00558 <span class="preprocessor">#endif</span>
<a name="l00559"></a>00559 <span class="preprocessor"></span>  
<a name="l00560"></a>00560 <span class="preprocessor">#if LIBMESH_DIM == 2 </span>
<a name="l00561"></a>00561 <span class="preprocessor"></span>  <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;TS&gt;</a>(_coords[0]*factor,
<a name="l00562"></a>00562                         _coords[1]*factor);
<a name="l00563"></a>00563 <span class="preprocessor">#endif</span>
<a name="l00564"></a>00564 <span class="preprocessor"></span>  
<a name="l00565"></a>00565 <span class="preprocessor">#if LIBMESH_DIM == 3</span>
<a name="l00566"></a>00566 <span class="preprocessor"></span>  <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;TS&gt;</a>(_coords[0]*factor,
<a name="l00567"></a>00567                         _coords[1]*factor, 
<a name="l00568"></a>00568                         _coords[2]*factor);
<a name="l00569"></a>00569 <span class="preprocessor">#endif  </span>
<a name="l00570"></a>00570 <span class="preprocessor"></span>}
<a name="l00571"></a>00571 
<a name="l00572"></a>00572 
<a name="l00573"></a>00573 
<a name="l00574"></a>00574 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T, <span class="keyword">typename</span> Scalar&gt;
<a name="l00575"></a>00575 <span class="keyword">inline</span>
<a name="l00576"></a>00576 <span class="keyword">typename</span> <a class="code" href="structlibMesh_1_1boostcopy_1_1enable__if__c.php">boostcopy::enable_if_c</a>&lt;
<a name="l00577"></a>00577   <a class="code" href="structlibMesh_1_1ScalarTraits.php">ScalarTraits&lt;Scalar&gt;::value</a>,
<a name="l00578"></a>00578   <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;typename CompareTypes&lt;T, Scalar&gt;::supertype</a>&gt; &gt;::type
<a name="l00579"></a><a class="code" href="namespacelibMesh.php#acb2f3805788c9de73ab9146a975d4904">00579</a> <a class="code" href="namespacelibMesh.php#a0c087fb32eb3bd2530fb6d6a9dd87d74">operator * </a>(<span class="keyword">const</span> Scalar factor,
<a name="l00580"></a>00580             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;T&gt;</a> &amp;v)
<a name="l00581"></a>00581 {
<a name="l00582"></a>00582   <span class="keywordflow">return</span> v * factor;
<a name="l00583"></a>00583 }
<a name="l00584"></a>00584 
<a name="l00585"></a>00585 
<a name="l00586"></a>00586 
<a name="l00587"></a>00587 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00588"></a>00588 <span class="keyword">inline</span>
<a name="l00589"></a><a class="code" href="classlibMesh_1_1TypeVector.php#a7bb758820cca62d712fad2c592d95f06">00589</a> <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;T&gt;</a> &amp; <a class="code" href="classlibMesh_1_1TypeVector.php#a7bb758820cca62d712fad2c592d95f06">TypeVector&lt;T&gt;::operator *= </a>(<span class="keyword">const</span> T factor)
<a name="l00590"></a>00590 {
<a name="l00591"></a>00591 <span class="preprocessor">#if LIBMESH_DIM == 1</span>
<a name="l00592"></a>00592 <span class="preprocessor"></span>  _coords[0] *= factor;
<a name="l00593"></a>00593 <span class="preprocessor">#endif</span>
<a name="l00594"></a>00594 <span class="preprocessor"></span>  
<a name="l00595"></a>00595 <span class="preprocessor">#if LIBMESH_DIM == 2</span>
<a name="l00596"></a>00596 <span class="preprocessor"></span>  _coords[0] *= factor;
<a name="l00597"></a>00597   _coords[1] *= factor;
<a name="l00598"></a>00598 <span class="preprocessor">#endif</span>
<a name="l00599"></a>00599 <span class="preprocessor"></span>  
<a name="l00600"></a>00600 <span class="preprocessor">#if LIBMESH_DIM == 3</span>
<a name="l00601"></a>00601 <span class="preprocessor"></span>  _coords[0] *= factor;
<a name="l00602"></a>00602   _coords[1] *= factor;
<a name="l00603"></a>00603   _coords[2] *= factor;
<a name="l00604"></a>00604 <span class="preprocessor">#endif</span>
<a name="l00605"></a>00605 <span class="preprocessor"></span>
<a name="l00606"></a>00606   <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00607"></a>00607 }
<a name="l00608"></a>00608 
<a name="l00609"></a>00609 
<a name="l00610"></a>00610 
<a name="l00611"></a>00611 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00612"></a>00612 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> Scalar&gt;
<a name="l00613"></a>00613 <span class="keyword">inline</span>
<a name="l00614"></a>00614 <span class="keyword">typename</span> <a class="code" href="structlibMesh_1_1boostcopy_1_1enable__if__c.php">boostcopy::enable_if_c</a>&lt;
<a name="l00615"></a>00615   <a class="code" href="structlibMesh_1_1ScalarTraits.php">ScalarTraits&lt;Scalar&gt;::value</a>,
<a name="l00616"></a>00616   <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;typename CompareTypes&lt;T, Scalar&gt;::supertype</a>&gt; &gt;::type
<a name="l00617"></a><a class="code" href="classlibMesh_1_1TypeVector.php#ab49251d9ddb1ff5b05d3433d43cd646e">00617</a> <a class="code" href="classlibMesh_1_1TypeVector.php#ab49251d9ddb1ff5b05d3433d43cd646e">TypeVector&lt;T&gt;::operator / </a>(<span class="keyword">const</span> Scalar factor)<span class="keyword"> const</span>
<a name="l00618"></a>00618 <span class="keyword"></span>{
<a name="l00619"></a>00619   libmesh_assert (factor != static_cast&lt;T&gt;(0.));
<a name="l00620"></a>00620 
<a name="l00621"></a>00621   <span class="keyword">typedef</span> <span class="keyword">typename</span> <a class="code" href="structlibMesh_1_1CompareTypes.php#ad4a5d1fd1ae6c9db9a9422258d7ca949">CompareTypes&lt;T, Scalar&gt;::supertype</a> TS;
<a name="l00622"></a>00622   
<a name="l00623"></a>00623 <span class="preprocessor">#if LIBMESH_DIM == 1</span>
<a name="l00624"></a>00624 <span class="preprocessor"></span>  <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;TS&gt;</a>(_coords[0]/factor);
<a name="l00625"></a>00625 <span class="preprocessor">#endif</span>
<a name="l00626"></a>00626 <span class="preprocessor"></span>  
<a name="l00627"></a>00627 <span class="preprocessor">#if LIBMESH_DIM == 2 </span>
<a name="l00628"></a>00628 <span class="preprocessor"></span>  <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;TS&gt;</a>(_coords[0]/factor,
<a name="l00629"></a>00629                         _coords[1]/factor);
<a name="l00630"></a>00630 <span class="preprocessor">#endif</span>
<a name="l00631"></a>00631 <span class="preprocessor"></span>  
<a name="l00632"></a>00632 <span class="preprocessor">#if LIBMESH_DIM == 3</span>
<a name="l00633"></a>00633 <span class="preprocessor"></span>  <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;TS&gt;</a>(_coords[0]/factor,
<a name="l00634"></a>00634                         _coords[1]/factor, 
<a name="l00635"></a>00635                         _coords[2]/factor);
<a name="l00636"></a>00636 <span class="preprocessor">#endif</span>
<a name="l00637"></a>00637 <span class="preprocessor"></span>  
<a name="l00638"></a>00638 }
<a name="l00639"></a>00639 
<a name="l00640"></a>00640 
<a name="l00641"></a>00641 
<a name="l00642"></a>00642 
<a name="l00643"></a>00643 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00644"></a>00644 <span class="keyword">inline</span>
<a name="l00645"></a>00645 <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;T&gt;</a> &amp;
<a name="l00646"></a><a class="code" href="classlibMesh_1_1TypeVector.php#aa58a379076d158ce69663f65b6d53083">00646</a> <a class="code" href="classlibMesh_1_1TypeVector.php#aa58a379076d158ce69663f65b6d53083">TypeVector&lt;T&gt;::operator /= </a>(<span class="keyword">const</span> T factor)
<a name="l00647"></a>00647 {
<a name="l00648"></a>00648   libmesh_assert (factor != static_cast&lt;T&gt;(0.));
<a name="l00649"></a>00649   
<a name="l00650"></a>00650   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;LIBMESH_DIM; i++)
<a name="l00651"></a>00651     _coords[i] /= factor;
<a name="l00652"></a>00652 
<a name="l00653"></a>00653   <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00654"></a>00654 }
<a name="l00655"></a>00655 
<a name="l00656"></a>00656 
<a name="l00657"></a>00657 
<a name="l00658"></a>00658 
<a name="l00659"></a>00659 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00660"></a>00660 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00661"></a>00661 <span class="keyword">inline</span>
<a name="l00662"></a>00662 <span class="keyword">typename</span> <a class="code" href="structlibMesh_1_1CompareTypes.php#ad4a5d1fd1ae6c9db9a9422258d7ca949">CompareTypes&lt;T, T2&gt;::supertype</a>
<a name="l00663"></a><a class="code" href="classlibMesh_1_1TypeVector.php#a5d4723847eaa5f9d82d7ff054f599872">00663</a> <a class="code" href="classlibMesh_1_1TypeVector.php#ab75862b27b047da6b584a3300b67a809">TypeVector&lt;T&gt;::operator * </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;T2&gt;</a> &amp;p)<span class="keyword"> const</span>
<a name="l00664"></a>00664 <span class="keyword"></span>{
<a name="l00665"></a>00665 <span class="preprocessor">#if LIBMESH_DIM == 1</span>
<a name="l00666"></a>00666 <span class="preprocessor"></span>  <span class="keywordflow">return</span> _coords[0]*p.<a class="code" href="classlibMesh_1_1TypeVector.php#a164f4a8009b50213232b6fe9e47b5de0">_coords</a>[0];
<a name="l00667"></a>00667 <span class="preprocessor">#endif</span>
<a name="l00668"></a>00668 <span class="preprocessor"></span>  
<a name="l00669"></a>00669 <span class="preprocessor">#if LIBMESH_DIM == 2</span>
<a name="l00670"></a>00670 <span class="preprocessor"></span>  <span class="keywordflow">return</span> (_coords[0]*p.<a class="code" href="classlibMesh_1_1TypeVector.php#a164f4a8009b50213232b6fe9e47b5de0">_coords</a>[0] +
<a name="l00671"></a>00671           _coords[1]*p.<a class="code" href="classlibMesh_1_1TypeVector.php#a164f4a8009b50213232b6fe9e47b5de0">_coords</a>[1]);
<a name="l00672"></a>00672 <span class="preprocessor">#endif</span>
<a name="l00673"></a>00673 <span class="preprocessor"></span>  
<a name="l00674"></a>00674 <span class="preprocessor">#if LIBMESH_DIM == 3</span>
<a name="l00675"></a>00675 <span class="preprocessor"></span>  <span class="keywordflow">return</span> (_coords[0]*p(0) +
<a name="l00676"></a>00676           _coords[1]*p(1) +
<a name="l00677"></a>00677           _coords[2]*p(2));
<a name="l00678"></a>00678 <span class="preprocessor">#endif</span>
<a name="l00679"></a>00679 <span class="preprocessor"></span>}
<a name="l00680"></a>00680 
<a name="l00681"></a>00681 
<a name="l00682"></a>00682 
<a name="l00683"></a>00683 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00684"></a>00684 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00685"></a>00685 <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;typename CompareTypes&lt;T, T2&gt;::supertype</a>&gt;
<a name="l00686"></a><a class="code" href="classlibMesh_1_1TypeVector.php#a2aec9a10f796ec4cd55c5d2a62885305">00686</a> <a class="code" href="classlibMesh_1_1TypeVector.php#a2aec9a10f796ec4cd55c5d2a62885305">TypeVector&lt;T&gt;::cross</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;T2&gt;</a>&amp; p)<span class="keyword"> const</span>
<a name="l00687"></a>00687 <span class="keyword"></span>{
<a name="l00688"></a>00688   <span class="keyword">typedef</span> <span class="keyword">typename</span> <a class="code" href="structlibMesh_1_1CompareTypes.php#ad4a5d1fd1ae6c9db9a9422258d7ca949">CompareTypes&lt;T, T2&gt;::supertype</a> TS;
<a name="l00689"></a>00689   libmesh_assert (LIBMESH_DIM == 3);
<a name="l00690"></a>00690 
<a name="l00691"></a>00691   <span class="comment">// |     i          j          k    |</span>
<a name="l00692"></a>00692   <span class="comment">// |(*this)(0) (*this)(1) (*this)(2)|</span>
<a name="l00693"></a>00693   <span class="comment">// |   p(0)       p(1)       p(2)   |</span>
<a name="l00694"></a>00694 
<a name="l00695"></a>00695   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;TS&gt;</a>( _coords[1]*p.<a class="code" href="classlibMesh_1_1TypeVector.php#a164f4a8009b50213232b6fe9e47b5de0">_coords</a>[2] - _coords[2]*p.<a class="code" href="classlibMesh_1_1TypeVector.php#a164f4a8009b50213232b6fe9e47b5de0">_coords</a>[1],
<a name="l00696"></a>00696                         -_coords[0]*p.<a class="code" href="classlibMesh_1_1TypeVector.php#a164f4a8009b50213232b6fe9e47b5de0">_coords</a>[2] + _coords[2]*p.<a class="code" href="classlibMesh_1_1TypeVector.php#a164f4a8009b50213232b6fe9e47b5de0">_coords</a>[0],
<a name="l00697"></a>00697                          _coords[0]*p.<a class="code" href="classlibMesh_1_1TypeVector.php#a164f4a8009b50213232b6fe9e47b5de0">_coords</a>[1] - _coords[1]*p.<a class="code" href="classlibMesh_1_1TypeVector.php#a164f4a8009b50213232b6fe9e47b5de0">_coords</a>[0]);
<a name="l00698"></a>00698 }
<a name="l00699"></a>00699 
<a name="l00700"></a>00700 
<a name="l00701"></a>00701 
<a name="l00702"></a>00702 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00703"></a>00703 <span class="keyword">inline</span>
<a name="l00704"></a><a class="code" href="classlibMesh_1_1TypeVector.php#a8dcd4a3bff824a7cb1aeee67bdfb598d">00704</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1TypeVector.php#a8dcd4a3bff824a7cb1aeee67bdfb598d">TypeVector&lt;T&gt;::size</a>()<span class="keyword"> const</span>
<a name="l00705"></a>00705 <span class="keyword"></span>{
<a name="l00706"></a>00706   <span class="keywordflow">return</span> std::sqrt(this-&gt;size_sq());  
<a name="l00707"></a>00707 }
<a name="l00708"></a>00708 
<a name="l00709"></a>00709 
<a name="l00710"></a>00710 
<a name="l00711"></a>00711 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00712"></a>00712 <span class="keyword">inline</span>
<a name="l00713"></a><a class="code" href="classlibMesh_1_1TypeVector.php#a4039c6e4f87fa907b3aeaafd66c0c1ce">00713</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TypeVector.php#a4039c6e4f87fa907b3aeaafd66c0c1ce">TypeVector&lt;T&gt;::zero</a>()
<a name="l00714"></a>00714 {
<a name="l00715"></a>00715   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;LIBMESH_DIM; i++)
<a name="l00716"></a>00716     _coords[i] = 0.;
<a name="l00717"></a>00717 }
<a name="l00718"></a>00718 
<a name="l00719"></a>00719 
<a name="l00720"></a>00720 
<a name="l00721"></a>00721 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00722"></a>00722 <span class="keyword">inline</span>
<a name="l00723"></a><a class="code" href="classlibMesh_1_1TypeVector.php#a6388a8db55ae02bdf8a72d0c4df45301">00723</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1TypeVector.php#a6388a8db55ae02bdf8a72d0c4df45301">TypeVector&lt;T&gt;::size_sq</a>()<span class="keyword"> const</span>
<a name="l00724"></a>00724 <span class="keyword"></span>{
<a name="l00725"></a>00725 <span class="preprocessor">#if LIBMESH_DIM == 1</span>
<a name="l00726"></a>00726 <span class="preprocessor"></span>  <span class="keywordflow">return</span> (<a class="code" href="namespacelibMesh.php#a1ccf1226fe7f6e1611259752ff1ee29e">libmesh_norm</a>(_coords[0]));
<a name="l00727"></a>00727 <span class="preprocessor">#endif</span>
<a name="l00728"></a>00728 <span class="preprocessor"></span>  
<a name="l00729"></a>00729 <span class="preprocessor">#if LIBMESH_DIM == 2</span>
<a name="l00730"></a>00730 <span class="preprocessor"></span>  <span class="keywordflow">return</span> (<a class="code" href="namespacelibMesh.php#a1ccf1226fe7f6e1611259752ff1ee29e">libmesh_norm</a>(_coords[0]) +
<a name="l00731"></a>00731           <a class="code" href="namespacelibMesh.php#a1ccf1226fe7f6e1611259752ff1ee29e">libmesh_norm</a>(_coords[1]));
<a name="l00732"></a>00732 <span class="preprocessor">#endif</span>
<a name="l00733"></a>00733 <span class="preprocessor"></span>  
<a name="l00734"></a>00734 <span class="preprocessor">#if LIBMESH_DIM == 3</span>
<a name="l00735"></a>00735 <span class="preprocessor"></span>  <span class="keywordflow">return</span> (<a class="code" href="namespacelibMesh.php#a1ccf1226fe7f6e1611259752ff1ee29e">libmesh_norm</a>(_coords[0]) +
<a name="l00736"></a>00736           <a class="code" href="namespacelibMesh.php#a1ccf1226fe7f6e1611259752ff1ee29e">libmesh_norm</a>(_coords[1]) + 
<a name="l00737"></a>00737           <a class="code" href="namespacelibMesh.php#a1ccf1226fe7f6e1611259752ff1ee29e">libmesh_norm</a>(_coords[2]));
<a name="l00738"></a>00738 <span class="preprocessor">#endif</span>
<a name="l00739"></a>00739 <span class="preprocessor"></span>}
<a name="l00740"></a>00740 
<a name="l00741"></a>00741 
<a name="l00742"></a>00742 
<a name="l00743"></a>00743 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00744"></a>00744 <span class="keyword">inline</span>
<a name="l00745"></a><a class="code" href="classlibMesh_1_1TypeVector.php#aebdea0b3d6d9b9e699a15c9a9f532d8a">00745</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1TypeVector.php#aebdea0b3d6d9b9e699a15c9a9f532d8a">TypeVector&lt;T&gt;::absolute_fuzzy_equals</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;T&gt;</a>&amp; rhs, <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> tol)<span class="keyword"> const</span>
<a name="l00746"></a>00746 <span class="keyword"></span>{
<a name="l00747"></a>00747 <span class="preprocessor">#if LIBMESH_DIM == 1</span>
<a name="l00748"></a>00748 <span class="preprocessor"></span>  <span class="keywordflow">return</span> (std::abs(_coords[0] - rhs.<a class="code" href="classlibMesh_1_1TypeVector.php#a164f4a8009b50213232b6fe9e47b5de0">_coords</a>[0])
<a name="l00749"></a>00749           &lt;= tol);
<a name="l00750"></a>00750 <span class="preprocessor">#endif</span>
<a name="l00751"></a>00751 <span class="preprocessor"></span>
<a name="l00752"></a>00752 <span class="preprocessor">#if LIBMESH_DIM == 2</span>
<a name="l00753"></a>00753 <span class="preprocessor"></span>  <span class="keywordflow">return</span> (std::abs(_coords[0] - rhs.<a class="code" href="classlibMesh_1_1TypeVector.php#a164f4a8009b50213232b6fe9e47b5de0">_coords</a>[0]) +
<a name="l00754"></a>00754           std::abs(_coords[1] - rhs.<a class="code" href="classlibMesh_1_1TypeVector.php#a164f4a8009b50213232b6fe9e47b5de0">_coords</a>[1])
<a name="l00755"></a>00755           &lt;= tol);
<a name="l00756"></a>00756 <span class="preprocessor">#endif</span>
<a name="l00757"></a>00757 <span class="preprocessor"></span>
<a name="l00758"></a>00758 <span class="preprocessor">#if LIBMESH_DIM == 3</span>
<a name="l00759"></a>00759 <span class="preprocessor"></span>  <span class="keywordflow">return</span> (std::abs(_coords[0] - rhs.<a class="code" href="classlibMesh_1_1TypeVector.php#a164f4a8009b50213232b6fe9e47b5de0">_coords</a>[0]) +
<a name="l00760"></a>00760           std::abs(_coords[1] - rhs.<a class="code" href="classlibMesh_1_1TypeVector.php#a164f4a8009b50213232b6fe9e47b5de0">_coords</a>[1]) +
<a name="l00761"></a>00761           std::abs(_coords[2] - rhs.<a class="code" href="classlibMesh_1_1TypeVector.php#a164f4a8009b50213232b6fe9e47b5de0">_coords</a>[2])
<a name="l00762"></a>00762           &lt;= tol);
<a name="l00763"></a>00763 <span class="preprocessor">#endif</span>
<a name="l00764"></a>00764 <span class="preprocessor"></span>}
<a name="l00765"></a>00765 
<a name="l00766"></a>00766 
<a name="l00767"></a>00767 
<a name="l00768"></a>00768 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00769"></a>00769 <span class="keyword">inline</span>
<a name="l00770"></a><a class="code" href="classlibMesh_1_1TypeVector.php#a510b7f78c908b4d0f2a1250bace34d88">00770</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1TypeVector.php#a510b7f78c908b4d0f2a1250bace34d88">TypeVector&lt;T&gt;::relative_fuzzy_equals</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;T&gt;</a>&amp; rhs, <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> tol)<span class="keyword"> const</span>
<a name="l00771"></a>00771 <span class="keyword"></span>{
<a name="l00772"></a>00772 <span class="preprocessor">#if LIBMESH_DIM == 1</span>
<a name="l00773"></a>00773 <span class="preprocessor"></span>  <span class="keywordflow">return</span> this-&gt;absolute_fuzzy_equals(rhs, tol *
<a name="l00774"></a>00774                                      (std::abs(_coords[0]) + std::abs(rhs.<a class="code" href="classlibMesh_1_1TypeVector.php#a164f4a8009b50213232b6fe9e47b5de0">_coords</a>[0])));
<a name="l00775"></a>00775 <span class="preprocessor">#endif</span>
<a name="l00776"></a>00776 <span class="preprocessor"></span>
<a name="l00777"></a>00777 <span class="preprocessor">#if LIBMESH_DIM == 2</span>
<a name="l00778"></a>00778 <span class="preprocessor"></span>  <span class="keywordflow">return</span> this-&gt;absolute_fuzzy_equals(rhs, tol * 
<a name="l00779"></a>00779                                      (std::abs(_coords[0]) + std::abs(rhs.<a class="code" href="classlibMesh_1_1TypeVector.php#a164f4a8009b50213232b6fe9e47b5de0">_coords</a>[0]) +
<a name="l00780"></a>00780                                       std::abs(_coords[1]) + std::abs(rhs.<a class="code" href="classlibMesh_1_1TypeVector.php#a164f4a8009b50213232b6fe9e47b5de0">_coords</a>[1])));
<a name="l00781"></a>00781 <span class="preprocessor">#endif</span>
<a name="l00782"></a>00782 <span class="preprocessor"></span>
<a name="l00783"></a>00783 <span class="preprocessor">#if LIBMESH_DIM == 3</span>
<a name="l00784"></a>00784 <span class="preprocessor"></span>  <span class="keywordflow">return</span> this-&gt;absolute_fuzzy_equals(rhs, tol *
<a name="l00785"></a>00785                                      (std::abs(_coords[0]) + std::abs(rhs.<a class="code" href="classlibMesh_1_1TypeVector.php#a164f4a8009b50213232b6fe9e47b5de0">_coords</a>[0]) +
<a name="l00786"></a>00786                                       std::abs(_coords[1]) + std::abs(rhs.<a class="code" href="classlibMesh_1_1TypeVector.php#a164f4a8009b50213232b6fe9e47b5de0">_coords</a>[1]) +
<a name="l00787"></a>00787                                       std::abs(_coords[2]) + std::abs(rhs.<a class="code" href="classlibMesh_1_1TypeVector.php#a164f4a8009b50213232b6fe9e47b5de0">_coords</a>[2])));
<a name="l00788"></a>00788 <span class="preprocessor">#endif</span>
<a name="l00789"></a>00789 <span class="preprocessor"></span>}
<a name="l00790"></a>00790 
<a name="l00791"></a>00791 
<a name="l00792"></a>00792 
<a name="l00793"></a>00793 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00794"></a>00794 <span class="keyword">inline</span>
<a name="l00795"></a><a class="code" href="classlibMesh_1_1TypeVector.php#acde2ea3b922e6de4e2de70c6a8b8a215">00795</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1TypeVector.php#acde2ea3b922e6de4e2de70c6a8b8a215">TypeVector&lt;T&gt;::operator == </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;T&gt;</a>&amp; rhs)<span class="keyword"> const</span>
<a name="l00796"></a>00796 <span class="keyword"></span>{
<a name="l00797"></a>00797 <span class="preprocessor">#if LIBMESH_DIM == 1</span>
<a name="l00798"></a>00798 <span class="preprocessor"></span>  <span class="keywordflow">return</span> (_coords[0] == rhs.<a class="code" href="classlibMesh_1_1TypeVector.php#a164f4a8009b50213232b6fe9e47b5de0">_coords</a>[0]);
<a name="l00799"></a>00799 <span class="preprocessor">#endif</span>
<a name="l00800"></a>00800 <span class="preprocessor"></span>
<a name="l00801"></a>00801 <span class="preprocessor">#if LIBMESH_DIM == 2</span>
<a name="l00802"></a>00802 <span class="preprocessor"></span>  <span class="keywordflow">return</span> (_coords[0] == rhs.<a class="code" href="classlibMesh_1_1TypeVector.php#a164f4a8009b50213232b6fe9e47b5de0">_coords</a>[0] &amp;&amp;
<a name="l00803"></a>00803           _coords[1] == rhs.<a class="code" href="classlibMesh_1_1TypeVector.php#a164f4a8009b50213232b6fe9e47b5de0">_coords</a>[1]);
<a name="l00804"></a>00804 <span class="preprocessor">#endif</span>
<a name="l00805"></a>00805 <span class="preprocessor"></span>
<a name="l00806"></a>00806 <span class="preprocessor">#if LIBMESH_DIM == 3</span>
<a name="l00807"></a>00807 <span class="preprocessor"></span>  <span class="keywordflow">return</span> (_coords[0] == rhs.<a class="code" href="classlibMesh_1_1TypeVector.php#a164f4a8009b50213232b6fe9e47b5de0">_coords</a>[0] &amp;&amp;
<a name="l00808"></a>00808           _coords[1] == rhs.<a class="code" href="classlibMesh_1_1TypeVector.php#a164f4a8009b50213232b6fe9e47b5de0">_coords</a>[1] &amp;&amp;
<a name="l00809"></a>00809           _coords[2] == rhs.<a class="code" href="classlibMesh_1_1TypeVector.php#a164f4a8009b50213232b6fe9e47b5de0">_coords</a>[2]);
<a name="l00810"></a>00810 <span class="preprocessor">#endif</span>
<a name="l00811"></a>00811 <span class="preprocessor"></span>}
<a name="l00812"></a>00812 
<a name="l00813"></a>00813 
<a name="l00814"></a>00814 
<a name="l00815"></a>00815 <span class="keyword">template</span> &lt;&gt;
<a name="l00816"></a>00816 <span class="keyword">inline</span>
<a name="l00817"></a><a class="code" href="classlibMesh_1_1TypeVector.php#a05a6661895f058487b7ac8b29877b1f4">00817</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1TypeVector.php#aa259f5756ea842a985cc0ed1036e73a9">TypeVector&lt;Real&gt;::operator != </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;Real&gt;</a>&amp; rhs)<span class="keyword"> const</span>
<a name="l00818"></a>00818 <span class="keyword"></span>{
<a name="l00819"></a>00819   <span class="keywordflow">return</span> (!(*<span class="keyword">this</span> == rhs));
<a name="l00820"></a>00820 }
<a name="l00821"></a>00821 
<a name="l00822"></a>00822 } <span class="comment">// namespace libMesh</span>
<a name="l00823"></a>00823 
<a name="l00824"></a>00824 <span class="preprocessor">#endif // #define __type_vector_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
