<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_c3a49989e40b21e7508f29d2dc962def.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_32bb88e3eb1b93402cfe508abee484a3.php">mesh</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">unstructured_mesh.C</div>  </div>
</div>
<div class="contents">
<a href="unstructured__mesh_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id$</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// C++ includes</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &lt;fstream&gt;</span>
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 <span class="comment">// C includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;unistd.h&gt;</span>  <span class="comment">// for unlink()</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="comment">// Local includes</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="boundary__info_8h.php">boundary_info.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="unstructured__mesh_8h.php">unstructured_mesh.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="mesh__communication_8h.php">mesh_communication.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__logging_8h.php">libmesh_logging.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="elem_8h.php">elem.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="mesh__tools_8h.php">mesh_tools.h</a>&quot;</span> <span class="comment">// For n_levels</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="parallel_8h.php">parallel.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="remote__elem_8h.php">remote_elem.h</a>&quot;</span>
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="preprocessor">#include &quot;<a class="code" href="diva__io_8h.php">diva_io.h</a>&quot;</span>
<a name="l00039"></a>00039 <span class="preprocessor">#include &quot;<a class="code" href="exodusII__io_8h.php">exodusII_io.h</a>&quot;</span>
<a name="l00040"></a>00040 <span class="preprocessor">#include &quot;<a class="code" href="gmv__io_8h.php">gmv_io.h</a>&quot;</span>
<a name="l00041"></a>00041 <span class="preprocessor">#include &quot;<a class="code" href="tecplot__io_8h.php">tecplot_io.h</a>&quot;</span>
<a name="l00042"></a>00042 <span class="preprocessor">#include &quot;<a class="code" href="tetgen__io_8h.php">tetgen_io.h</a>&quot;</span>
<a name="l00043"></a>00043 <span class="preprocessor">#include &quot;<a class="code" href="ucd__io_8h.php">ucd_io.h</a>&quot;</span>
<a name="l00044"></a>00044 <span class="preprocessor">#include &quot;<a class="code" href="unv__io_8h.php">unv_io.h</a>&quot;</span>
<a name="l00045"></a>00045 <span class="preprocessor">#include &quot;<a class="code" href="matlab__io_8h.php">matlab_io.h</a>&quot;</span>
<a name="l00046"></a>00046 <span class="preprocessor">#include &quot;<a class="code" href="off__io_8h.php">off_io.h</a>&quot;</span>
<a name="l00047"></a>00047 <span class="preprocessor">#include &quot;<a class="code" href="medit__io_8h.php">medit_io.h</a>&quot;</span>
<a name="l00048"></a>00048 <span class="preprocessor">#include &quot;<a class="code" href="gmsh__io_8h.php">gmsh_io.h</a>&quot;</span>
<a name="l00049"></a>00049 <span class="preprocessor">#include &quot;<a class="code" href="fro__io_8h.php">fro_io.h</a>&quot;</span>
<a name="l00050"></a>00050 <span class="preprocessor">#include &quot;<a class="code" href="xdr__io_8h.php">xdr_io.h</a>&quot;</span>
<a name="l00051"></a>00051 <span class="preprocessor">#include &quot;<a class="code" href="legacy__xdr__io_8h.php">legacy_xdr_io.h</a>&quot;</span>
<a name="l00052"></a>00052 <span class="preprocessor">#include &quot;<a class="code" href="vtk__io_8h.php">vtk_io.h</a>&quot;</span>
<a name="l00053"></a>00053 
<a name="l00054"></a>00054 <span class="preprocessor">#include LIBMESH_INCLUDE_UNORDERED_MAP</span>
<a name="l00055"></a>00055 <span class="preprocessor"></span>
<a name="l00056"></a>00056 
<a name="l00057"></a>00057 
<a name="l00058"></a>00058 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00059"></a>00059 <span class="comment">// Anonymous namespace for implementation details</span>
<a name="l00060"></a>00060 <span class="keyword">namespace </span>{
<a name="l00061"></a>00061   <span class="keywordtype">bool</span> is_parallel_file_format (<span class="keyword">const</span> std::string &amp;<a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>)
<a name="l00062"></a>00062   {
<a name="l00063"></a>00063     <span class="comment">// Certain mesh formats support parallel I/O, including the</span>
<a name="l00064"></a>00064     <span class="comment">// &quot;new&quot; Xdr format.</span>
<a name="l00065"></a>00065     <span class="keywordflow">return</span> ((name.rfind(<span class="stringliteral">&quot;.xda&quot;</span>) &lt; name.size()) ||
<a name="l00066"></a>00066             (name.rfind(<span class="stringliteral">&quot;.xdr&quot;</span>) &lt; name.size())
<a name="l00067"></a>00067             );
<a name="l00068"></a>00068   }
<a name="l00069"></a>00069 }
<a name="l00070"></a>00070 
<a name="l00071"></a>00071 
<a name="l00072"></a>00072 <span class="keyword">namespace </span>libMesh
<a name="l00073"></a>00073 {
<a name="l00074"></a>00074 
<a name="l00075"></a>00075 
<a name="l00076"></a>00076 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00077"></a>00077 <span class="comment">// UnstructuredMesh class member functions</span>
<a name="l00078"></a><a class="code" href="classlibMesh_1_1UnstructuredMesh.php#a15d8ad28c2d15f3b1075618c309a848d">00078</a> <a class="code" href="classlibMesh_1_1UnstructuredMesh.php#a15d8ad28c2d15f3b1075618c309a848d">UnstructuredMesh::UnstructuredMesh</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> d) :
<a name="l00079"></a>00079   <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> (d)
<a name="l00080"></a>00080 {
<a name="l00081"></a>00081   libmesh_assert (<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">libMesh::initialized</a>());
<a name="l00082"></a>00082 }
<a name="l00083"></a>00083 
<a name="l00084"></a>00084 
<a name="l00085"></a>00085 
<a name="l00086"></a>00086 <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1UnstructuredMesh.php#a5fab9455dc9b3af779d83b1125ac1ed6">UnstructuredMesh::copy_nodes_and_elements</a> 
<a name="l00087"></a><a class="code" href="classlibMesh_1_1UnstructuredMesh.php#a5fab9455dc9b3af779d83b1125ac1ed6">00087</a>   (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1UnstructuredMesh.php">UnstructuredMesh</a>&amp; other_mesh)
<a name="l00088"></a>00088 {
<a name="l00089"></a>00089   <span class="comment">// We&#39;re assuming our subclass data needs no copy</span>
<a name="l00090"></a>00090   libmesh_assert(_n_parts == other_mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac7f0635c81f5e24e17d47aa1d4b3ff3c">_n_parts</a>);
<a name="l00091"></a>00091   libmesh_assert(_dim == other_mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ad20b418f0628a701570475c141aec0d0">_dim</a>);
<a name="l00092"></a>00092   libmesh_assert(_is_prepared == other_mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a013ceb917534084574aa2e00837331bb">_is_prepared</a>);
<a name="l00093"></a>00093 
<a name="l00094"></a>00094   <span class="comment">//Copy in Nodes</span>
<a name="l00095"></a>00095   {
<a name="l00096"></a>00096     <span class="comment">//Preallocate Memory if necessary</span>
<a name="l00097"></a>00097     this-&gt;reserve_nodes(other_mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aff7b82001829828de180cf961df93ea1">n_nodes</a>());
<a name="l00098"></a>00098     
<a name="l00099"></a>00099     <a class="code" href="structlibMesh_1_1MeshBase_1_1const__node__iterator.php">const_node_iterator</a> it = other_mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a3ab1d28a6ea1e8028ce0c06e11cfb68d">nodes_begin</a>();
<a name="l00100"></a>00100     <a class="code" href="structlibMesh_1_1MeshBase_1_1const__node__iterator.php">const_node_iterator</a> end = other_mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a47575077b6ad40d4f05292634f7615f8">nodes_end</a>();
<a name="l00101"></a>00101 
<a name="l00102"></a>00102     <span class="keywordflow">for</span> (; it != end; ++it)
<a name="l00103"></a>00103       {
<a name="l00104"></a>00104         <a class="code" href="classlibMesh_1_1Node.php">Node</a> *oldn = *it;
<a name="l00105"></a>00105 
<a name="l00106"></a>00106         <span class="comment">// Add new nodes in old node Point locations</span>
<a name="l00107"></a>00107         <a class="code" href="classlibMesh_1_1Node.php">Node</a> *newn = this-&gt;add_point(*oldn);
<a name="l00108"></a>00108 
<a name="l00109"></a>00109         <span class="comment">// And start them off in the same subdomain</span>
<a name="l00110"></a>00110         newn-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">processor_id</a>() = oldn-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">processor_id</a>();
<a name="l00111"></a>00111       }
<a name="l00112"></a>00112   }
<a name="l00113"></a>00113   
<a name="l00114"></a>00114   <span class="comment">//Copy in Elements</span>
<a name="l00115"></a>00115   {
<a name="l00116"></a>00116     <span class="comment">//Preallocate Memory if necessary</span>
<a name="l00117"></a>00117     this-&gt;reserve_elem(other_mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a89566c09cd05aba8bd7f606eba96bf6f">n_elem</a>());
<a name="l00118"></a>00118     
<a name="l00119"></a>00119     <span class="comment">// Loop over the elements</span>
<a name="l00120"></a>00120     <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> it = other_mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac266e1f5eb6ac9566ccbd7e6add6c239">elements_begin</a>();
<a name="l00121"></a>00121     <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end = other_mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ae94f1bce0dc50c489c6bae9ba64d06e8">elements_end</a>();
<a name="l00122"></a>00122 
<a name="l00123"></a>00123     <span class="comment">// FIXME: Where do we set element IDs??</span>
<a name="l00124"></a>00124     <span class="keywordflow">for</span> (; it != end; ++it)
<a name="l00125"></a>00125     {
<a name="l00126"></a>00126       <span class="comment">//Look at the old element</span>
<a name="l00127"></a>00127       <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *old = *it;
<a name="l00128"></a>00128       <span class="comment">//Build a new element</span>
<a name="l00129"></a>00129       <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *newparent = old-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a7cdd994bb4245128f8617b62d7968e35">parent</a>() ?
<a name="l00130"></a>00130           this-&gt;elem(old-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a7cdd994bb4245128f8617b62d7968e35">parent</a>()-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()) : NULL;
<a name="l00131"></a>00131       <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> ap = <a class="code" href="classlibMesh_1_1Elem.php#a68cfa73358f50660055bf07a2919b2db">Elem::build</a>(old-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad06f8ac22978144723179eed42d10bae">type</a>(), newparent);
<a name="l00132"></a>00132       <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> * elem = ap.release();
<a name="l00133"></a>00133 
<a name="l00134"></a>00134       elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a96faae17e7ede5aa89c687d54cefb4b3">subdomain_id</a>() = old-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a96faae17e7ede5aa89c687d54cefb4b3">subdomain_id</a>();
<a name="l00135"></a>00135 
<a name="l00136"></a>00136 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00137"></a>00137 <span class="preprocessor"></span>      <span class="comment">//Create the parent&#39;s child pointers if necessary</span>
<a name="l00138"></a>00138       <span class="keywordflow">if</span> (newparent)
<a name="l00139"></a>00139         {
<a name="l00140"></a>00140           <span class="comment">// Make sure we have space for those child pointers</span>
<a name="l00141"></a>00141           newparent-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ab112c6162e29ef805534c3746b3f3657">add_child</a>(elem);
<a name="l00142"></a>00142 
<a name="l00143"></a>00143           <span class="comment">// We&#39;d better be adding these in the correct order</span>
<a name="l00144"></a>00144           libmesh_assert (newparent-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad3ec91e1b0444b1d699302681b713fe1">which_child_am_i</a>(elem) ==
<a name="l00145"></a>00145                   old-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a7cdd994bb4245128f8617b62d7968e35">parent</a>()-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad3ec91e1b0444b1d699302681b713fe1">which_child_am_i</a>(old));
<a name="l00146"></a>00146         }
<a name="l00147"></a>00147       
<a name="l00148"></a>00148       <span class="comment">// Copy the refinement flags</span>
<a name="l00149"></a>00149       elem-&gt;set_refinement_flag(old-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a174bfe5b3d22e2b79000bfc816f633e6">refinement_flag</a>());
<a name="l00150"></a>00150       elem-&gt;set_p_refinement_flag(old-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a53a98cf29aef9af6292c812d7b905c18">p_refinement_flag</a>());
<a name="l00151"></a>00151 <span class="preprocessor">#endif // #ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00152"></a>00152 <span class="preprocessor"></span>
<a name="l00153"></a>00153       <span class="comment">//Assign all the nodes</span>
<a name="l00154"></a>00154       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0;i&lt;elem-&gt;n_nodes();i++)
<a name="l00155"></a>00155         elem-&gt;set_node(i) = &amp;this-&gt;node(old-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(i));
<a name="l00156"></a>00156       
<a name="l00157"></a>00157       <span class="comment">//Hold onto it</span>
<a name="l00158"></a>00158       this-&gt;add_elem(elem);
<a name="l00159"></a>00159 
<a name="l00160"></a>00160       <span class="comment">// And start it off in the same subdomain</span>
<a name="l00161"></a>00161       elem-&gt;processor_id() = old-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">processor_id</a>();
<a name="l00162"></a>00162     }
<a name="l00163"></a>00163   }
<a name="l00164"></a>00164   
<a name="l00165"></a>00165   <span class="comment">//Finally prepare the Mesh for use</span>
<a name="l00166"></a>00166   this-&gt;prepare_for_use(<span class="comment">/*skip_renumber =*/</span><span class="keyword">false</span>);
<a name="l00167"></a>00167 }
<a name="l00168"></a>00168  
<a name="l00169"></a>00169  
<a name="l00170"></a>00170 
<a name="l00171"></a><a class="code" href="classlibMesh_1_1UnstructuredMesh.php#ae79b5e964be73d1c1fd3ec8a99d07517">00171</a> <a class="code" href="classlibMesh_1_1UnstructuredMesh.php#ae79b5e964be73d1c1fd3ec8a99d07517">UnstructuredMesh::~UnstructuredMesh</a> ()
<a name="l00172"></a>00172 {
<a name="l00173"></a>00173 <span class="comment">//  this-&gt;clear ();  // Nothing to clear at this level</span>
<a name="l00174"></a>00174   
<a name="l00175"></a>00175   libmesh_assert (!<a class="code" href="namespacelibMesh.php#a3dc0a134260371bd023e0d0f632399e1">libMesh::closed</a>());
<a name="l00176"></a>00176 }
<a name="l00177"></a>00177 
<a name="l00178"></a>00178 
<a name="l00179"></a>00179 
<a name="l00180"></a><a class="code" href="classlibMesh_1_1UnstructuredMesh.php#a341e57f0c00d50bf885a10fbd6bcb903">00180</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1UnstructuredMesh.php#a341e57f0c00d50bf885a10fbd6bcb903">UnstructuredMesh::find_neighbors</a> (<span class="keyword">const</span> <span class="keywordtype">bool</span> reset_remote_elements,
<a name="l00181"></a>00181                                        <span class="keyword">const</span> <span class="keywordtype">bool</span> reset_current_list)
<a name="l00182"></a>00182 {
<a name="l00183"></a>00183   <span class="comment">// We might actually want to run this on an empty mesh</span>
<a name="l00184"></a>00184   <span class="comment">// (e.g. the boundary mesh for a nonexistant bcid!)</span>
<a name="l00185"></a>00185   <span class="comment">// libmesh_assert(this-&gt;n_nodes() != 0);</span>
<a name="l00186"></a>00186   <span class="comment">// libmesh_assert(this-&gt;n_elem()  != 0);</span>
<a name="l00187"></a>00187 
<a name="l00188"></a>00188   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00189"></a>00189   parallel_only();
<a name="l00190"></a>00190 
<a name="l00191"></a>00191   START_LOG(<span class="stringliteral">&quot;find_neighbors()&quot;</span>, <span class="stringliteral">&quot;Mesh&quot;</span>);
<a name="l00192"></a>00192   
<a name="l00193"></a>00193   
<a name="l00194"></a>00194   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">element_iterator</a> el_end = this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#ae94f1bce0dc50c489c6bae9ba64d06e8">elements_end</a>();
<a name="l00195"></a>00195       
<a name="l00196"></a>00196   <span class="comment">//TODO:[BSK] This should be removed later?!</span>
<a name="l00197"></a>00197   <span class="keywordflow">if</span> (reset_current_list)
<a name="l00198"></a>00198     <span class="keywordflow">for</span> (<a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">element_iterator</a> el = this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#ac266e1f5eb6ac9566ccbd7e6add6c239">elements_begin</a>(); el != el_end; ++el)
<a name="l00199"></a>00199       {
<a name="l00200"></a>00200         <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a> = *el;
<a name="l00201"></a>00201         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s=0; s&lt;elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adf36086a897fdef3a88deec071ca5dfd">n_neighbors</a>(); s++)
<a name="l00202"></a>00202           <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(s) != <a class="code" href="namespacelibMesh.php#a903992f631b52b5ba05ad96a51e7b383">remote_elem</a> ||
<a name="l00203"></a>00203               reset_remote_elements)
<a name="l00204"></a>00204             elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a40980d9226643eb7dfd86b1c150c888e">set_neighbor</a>(s,NULL);
<a name="l00205"></a>00205       }
<a name="l00206"></a>00206   
<a name="l00207"></a>00207   <span class="comment">// Find neighboring elements by first finding elements</span>
<a name="l00208"></a>00208   <span class="comment">// with identical side keys and then check to see if they</span>
<a name="l00209"></a>00209   <span class="comment">// are neighbors</span>
<a name="l00210"></a>00210   {
<a name="l00211"></a>00211     <span class="comment">// data structures -- Use the hash_multimap if available</span>
<a name="l00212"></a>00212     <span class="keyword">typedef</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>                    key_type;
<a name="l00213"></a>00213     <span class="keyword">typedef</span> std::pair&lt;Elem*, unsigned char&gt; val_type;
<a name="l00214"></a>00214     <span class="keyword">typedef</span> std::pair&lt;key_type, val_type&gt;   key_val_pair;
<a name="l00215"></a>00215     
<a name="l00216"></a>00216     <span class="keyword">typedef</span> LIBMESH_BEST_UNORDERED_MULTIMAP&lt;key_type, val_type&gt; map_type;    
<a name="l00217"></a>00217     
<a name="l00218"></a>00218     <span class="comment">// A map from side keys to corresponding elements &amp; side numbers  </span>
<a name="l00219"></a>00219     map_type side_to_elem_map;
<a name="l00220"></a>00220   
<a name="l00221"></a>00221 
<a name="l00222"></a>00222 
<a name="l00223"></a>00223     <span class="keywordflow">for</span> (<a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">element_iterator</a> el = this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#ac266e1f5eb6ac9566ccbd7e6add6c239">elements_begin</a>(); el != el_end; ++el)
<a name="l00224"></a>00224       {
<a name="l00225"></a>00225         <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* element = *el;
<a name="l00226"></a>00226 
<a name="l00227"></a>00227         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ms=0; ms&lt;element-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adf36086a897fdef3a88deec071ca5dfd">n_neighbors</a>(); ms++)
<a name="l00228"></a>00228           {
<a name="l00229"></a>00229           next_side:
<a name="l00230"></a>00230             <span class="comment">// If we haven&#39;t yet found a neighbor on this side, try.</span>
<a name="l00231"></a>00231             <span class="comment">// Even if we think our neighbor is remote, that</span>
<a name="l00232"></a>00232             <span class="comment">// information may be out of date.</span>
<a name="l00233"></a>00233             <span class="keywordflow">if</span> (element-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(ms) == NULL ||
<a name="l00234"></a>00234                 element-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(ms) == <a class="code" href="namespacelibMesh.php#a903992f631b52b5ba05ad96a51e7b383">remote_elem</a>)
<a name="l00235"></a>00235               {
<a name="l00236"></a>00236                 <span class="comment">// Get the key for the side of this element</span>
<a name="l00237"></a>00237                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> key = element-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a1c04722ef6d6a8f49c66278a3c89a3ec">key</a>(ms);
<a name="l00238"></a>00238                 
<a name="l00239"></a>00239                 <span class="comment">// Look for elements that have an identical side key</span>
<a name="l00240"></a>00240                 std::pair &lt;map_type::iterator, map_type::iterator&gt;
<a name="l00241"></a>00241                   bounds = side_to_elem_map.equal_range(key);
<a name="l00242"></a>00242                 
<a name="l00243"></a>00243                 <span class="comment">// May be multiple keys, check all the possible</span>
<a name="l00244"></a>00244                 <span class="comment">// elements which _might_ be neighbors.</span>
<a name="l00245"></a>00245                 <span class="keywordflow">if</span> (bounds.first != bounds.second)
<a name="l00246"></a>00246                   {
<a name="l00247"></a>00247                     <span class="comment">// Get the side for this element</span>
<a name="l00248"></a>00248                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;DofObject&gt;</a> my_side(element-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a5a4ca26b1c13e79c3845ecb21c3f71b3">side</a>(ms));
<a name="l00249"></a>00249 
<a name="l00250"></a>00250                     <span class="comment">// Look at all the entries with an equivalent key</span>
<a name="l00251"></a>00251                     <span class="keywordflow">while</span> (bounds.first != bounds.second)
<a name="l00252"></a>00252                       {
<a name="l00253"></a>00253                         <span class="comment">// Get the potential element</span>
<a name="l00254"></a>00254                         <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* neighbor = bounds.first-&gt;second.first;
<a name="l00255"></a>00255                         
<a name="l00256"></a>00256                         <span class="comment">// Get the side for the neighboring element</span>
<a name="l00257"></a>00257                         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ns = bounds.first-&gt;second.second;
<a name="l00258"></a>00258                         <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;DofObject&gt;</a> their_side(neighbor-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a5a4ca26b1c13e79c3845ecb21c3f71b3">side</a>(ns));
<a name="l00259"></a>00259                         <span class="comment">//libmesh_assert (my_side.get() != NULL);</span>
<a name="l00260"></a>00260                         <span class="comment">//libmesh_assert (their_side.get() != NULL);                    </span>
<a name="l00261"></a>00261 
<a name="l00262"></a>00262                         <span class="comment">// If found a match with my side</span>
<a name="l00263"></a>00263                         <span class="comment">//</span>
<a name="l00264"></a>00264                         <span class="comment">// We need special tests here for 1D:</span>
<a name="l00265"></a>00265                         <span class="comment">// since parents and children have an equal</span>
<a name="l00266"></a>00266                         <span class="comment">// side (i.e. a node), we need to check </span>
<a name="l00267"></a>00267                         <span class="comment">// ns != ms, and we also check level() to</span>
<a name="l00268"></a>00268                         <span class="comment">// avoid setting our neighbor pointer to</span>
<a name="l00269"></a>00269                         <span class="comment">// any of our neighbor&#39;s descendants</span>
<a name="l00270"></a>00270                         <span class="keywordflow">if</span>( (*my_side == *their_side) &amp;&amp; 
<a name="l00271"></a>00271                             (element-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a1fa3e8bb1baa330a5037487dbe9304ab">level</a>() == neighbor-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a1fa3e8bb1baa330a5037487dbe9304ab">level</a>()) &amp;&amp;
<a name="l00272"></a>00272                             ((<a class="code" href="classlibMesh_1_1MeshBase.php#ad20b418f0628a701570475c141aec0d0">_dim</a> != 1) || (ns != ms)) )
<a name="l00273"></a>00273                           {
<a name="l00274"></a>00274                             <span class="comment">// So share a side.  Is this a mixed pair</span>
<a name="l00275"></a>00275                             <span class="comment">// of subactive and active/ancestor</span>
<a name="l00276"></a>00276                             <span class="comment">// elements?</span>
<a name="l00277"></a>00277                             <span class="comment">// If not, then we&#39;re neighbors.</span>
<a name="l00278"></a>00278                             <span class="comment">// If so, then the subactive&#39;s neighbor is </span>
<a name="l00279"></a>00279 
<a name="l00280"></a>00280                               <span class="keywordflow">if</span> (element-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad1486ba6e3005fe331e4911907fadfbb">subactive</a>() ==
<a name="l00281"></a>00281                                   neighbor-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad1486ba6e3005fe331e4911907fadfbb">subactive</a>())
<a name="l00282"></a>00282                               {
<a name="l00283"></a>00283                               <span class="comment">// an element is only subactive if it has</span>
<a name="l00284"></a>00284                               <span class="comment">// been coarsened but not deleted</span>
<a name="l00285"></a>00285                                 element-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a40980d9226643eb7dfd86b1c150c888e">set_neighbor</a> (ms,neighbor);
<a name="l00286"></a>00286                                 neighbor-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a40980d9226643eb7dfd86b1c150c888e">set_neighbor</a>(ns,element);
<a name="l00287"></a>00287                               }
<a name="l00288"></a>00288                               <span class="keywordflow">else</span> <span class="keywordflow">if</span> (element-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad1486ba6e3005fe331e4911907fadfbb">subactive</a>())
<a name="l00289"></a>00289                               {
<a name="l00290"></a>00290                                 element-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a40980d9226643eb7dfd86b1c150c888e">set_neighbor</a>(ms,neighbor);
<a name="l00291"></a>00291                               }
<a name="l00292"></a>00292                               <span class="keywordflow">else</span> <span class="keywordflow">if</span> (neighbor-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad1486ba6e3005fe331e4911907fadfbb">subactive</a>())
<a name="l00293"></a>00293                               {
<a name="l00294"></a>00294                                 neighbor-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a40980d9226643eb7dfd86b1c150c888e">set_neighbor</a>(ns,element);
<a name="l00295"></a>00295                               }
<a name="l00296"></a>00296                               side_to_elem_map.erase (bounds.first);
<a name="l00297"></a>00297 
<a name="l00298"></a>00298                               <span class="comment">// get out of this nested crap</span>
<a name="l00299"></a>00299                               <span class="keywordflow">goto</span> next_side; 
<a name="l00300"></a>00300                           }
<a name="l00301"></a>00301 
<a name="l00302"></a>00302                         ++bounds.first;
<a name="l00303"></a>00303                       }
<a name="l00304"></a>00304                   }
<a name="l00305"></a>00305                     
<a name="l00306"></a>00306                 <span class="comment">// didn&#39;t find a match...</span>
<a name="l00307"></a>00307                 <span class="comment">// Build the map entry for this element</span>
<a name="l00308"></a>00308                 key_val_pair kvp;
<a name="l00309"></a>00309                 
<a name="l00310"></a>00310                 kvp.first         = key;
<a name="l00311"></a>00311                 kvp.second.first  = element;
<a name="l00312"></a>00312                 kvp.second.second = ms;
<a name="l00313"></a>00313                 
<a name="l00314"></a>00314                 <span class="comment">// use the lower bound as a hint for</span>
<a name="l00315"></a>00315                 <span class="comment">// where to put it.</span>
<a name="l00316"></a>00316 <span class="preprocessor">#if defined(LIBMESH_HAVE_UNORDERED_MAP) || defined(LIBMESH_HAVE_TR1_UNORDERED_MAP) || defined(LIBMESH_HAVE_HASH_MAP) || defined(LIBMESH_HAVE_EXT_HASH_MAP)</span>
<a name="l00317"></a>00317 <span class="preprocessor"></span>                side_to_elem_map.insert (kvp);
<a name="l00318"></a>00318 <span class="preprocessor">#else</span>
<a name="l00319"></a>00319 <span class="preprocessor"></span>                side_to_elem_map.insert (bounds.first,kvp);
<a name="l00320"></a>00320 <span class="preprocessor">#endif</span>
<a name="l00321"></a>00321 <span class="preprocessor"></span>              }
<a name="l00322"></a>00322           }
<a name="l00323"></a>00323       }
<a name="l00324"></a>00324   }
<a name="l00325"></a>00325 
<a name="l00326"></a>00326   
<a name="l00327"></a>00327   
<a name="l00328"></a>00328 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00329"></a>00329 <span class="preprocessor"></span>
<a name="l00348"></a>00348   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespacelibMesh_1_1MeshTools.php#ae15ece869d4ef3d283edb677942e8439">n_levels</a> = <a class="code" href="namespacelibMesh_1_1MeshTools.php#ae15ece869d4ef3d283edb677942e8439">MeshTools::n_levels</a>(*<span class="keyword">this</span>);
<a name="l00349"></a>00349   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level = 1; level &lt; <a class="code" href="namespacelibMesh_1_1MeshTools.php#ae15ece869d4ef3d283edb677942e8439">n_levels</a>; ++level)
<a name="l00350"></a>00350     {
<a name="l00351"></a>00351       <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">element_iterator</a> end = this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#ae94f3f5a30c83cdd0187ba02a5b8b17e">level_elements_end</a>(level);
<a name="l00352"></a>00352       <span class="keywordflow">for</span> (<a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">element_iterator</a> el = this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#a32031f5d29428cf17dad4cabaf60d298">level_elements_begin</a>(level);
<a name="l00353"></a>00353            el != end; ++el)
<a name="l00354"></a>00354         {
<a name="l00355"></a>00355           <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a> = *el;
<a name="l00356"></a>00356           libmesh_assert(elem);
<a name="l00357"></a>00357           libmesh_assert(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a7cdd994bb4245128f8617b62d7968e35">parent</a>());
<a name="l00358"></a>00358 
<a name="l00359"></a>00359           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s=0; s &lt; elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adf36086a897fdef3a88deec071ca5dfd">n_neighbors</a>(); s++)
<a name="l00360"></a>00360             <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(s) == NULL)
<a name="l00361"></a>00361 <span class="comment">// This currently leads to an infinite loop in ex10?</span>
<a name="l00362"></a>00362 <span class="comment">//            if (elem-&gt;neighbor(s) == NULL ||</span>
<a name="l00363"></a>00363 <span class="comment">//              (elem-&gt;neighbor(s) == remote_elem &amp;&amp;</span>
<a name="l00364"></a>00364 <span class="comment">//               parent-&gt;is_child_on_side(parent-&gt;which_child_am_i(elem), s)))</span>
<a name="l00365"></a>00365             {       
<a name="l00366"></a>00366               <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *neigh = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a7cdd994bb4245128f8617b62d7968e35">parent</a>()-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(s);
<a name="l00367"></a>00367 
<a name="l00368"></a>00368               <span class="comment">// If neigh was refined and had non-subactive children</span>
<a name="l00369"></a>00369               <span class="comment">// made remote earlier, then a non-subactive elem should</span>
<a name="l00370"></a>00370               <span class="comment">// actually have one of those remote children as a</span>
<a name="l00371"></a>00371               <span class="comment">// neighbor</span>
<a name="l00372"></a>00372               <span class="keywordflow">if</span> (neigh &amp;&amp; (neigh-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d132de7da15df7db92f8995cc234b87">ancestor</a>()) &amp;&amp; (!elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad1486ba6e3005fe331e4911907fadfbb">subactive</a>()))
<a name="l00373"></a>00373                 {
<a name="l00374"></a>00374 <span class="preprocessor">#ifdef DEBUG        </span>
<a name="l00375"></a>00375 <span class="preprocessor"></span>                  <span class="comment">// Let&#39;s make sure that &quot;had children made remote&quot;</span>
<a name="l00376"></a>00376                   <span class="comment">// situation is actually the case</span>
<a name="l00377"></a>00377                   libmesh_assert(neigh-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac6316ca5f7b962a8a806ac385d6c0236">has_children</a>());
<a name="l00378"></a>00378                   <span class="keywordtype">bool</span> neigh_has_remote_children = <span class="keyword">false</span>;
<a name="l00379"></a>00379                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c = 0; c != neigh-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac9df9e0213d3ea1d2d8279892f6f1094">n_children</a>(); ++c)
<a name="l00380"></a>00380                     {
<a name="l00381"></a>00381                       <span class="keywordflow">if</span> (neigh-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3966a92c6f8b6748755a94f9f3103c5a">child</a>(c) == <a class="code" href="namespacelibMesh.php#a903992f631b52b5ba05ad96a51e7b383">remote_elem</a>)
<a name="l00382"></a>00382                         neigh_has_remote_children = <span class="keyword">true</span>;
<a name="l00383"></a>00383                     }
<a name="l00384"></a>00384                   libmesh_assert(neigh_has_remote_children);
<a name="l00385"></a>00385 
<a name="l00386"></a>00386                   <span class="comment">// And let&#39;s double-check that we don&#39;t have</span>
<a name="l00387"></a>00387                   <span class="comment">// a remote_elem neighboring a local element</span>
<a name="l00388"></a>00388                   libmesh_assert(elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">processor_id</a>() !=
<a name="l00389"></a>00389                                  <a class="code" href="classlibMesh_1_1MeshBase.php#aa557872c33163622cc66645fc393c925">libMesh::processor_id</a>());
<a name="l00390"></a>00390 <span class="preprocessor">#endif // DEBUG</span>
<a name="l00391"></a>00391 <span class="preprocessor"></span>                  neigh = <span class="keyword">const_cast&lt;</span><a class="code" href="classlibMesh_1_1RemoteElem.php">RemoteElem</a>*<span class="keyword">&gt;</span>(<a class="code" href="namespacelibMesh.php#a903992f631b52b5ba05ad96a51e7b383">remote_elem</a>);
<a name="l00392"></a>00392                 }
<a name="l00393"></a>00393 
<a name="l00394"></a>00394               elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a40980d9226643eb7dfd86b1c150c888e">set_neighbor</a>(s, neigh);
<a name="l00395"></a>00395 <span class="preprocessor">#ifdef DEBUG        </span>
<a name="l00396"></a>00396 <span class="preprocessor"></span>              <span class="keywordflow">if</span> (neigh != NULL &amp;&amp; neigh != <a class="code" href="namespacelibMesh.php#a903992f631b52b5ba05ad96a51e7b383">remote_elem</a>)
<a name="l00397"></a>00397                 <span class="comment">// We ignore subactive elements here because</span>
<a name="l00398"></a>00398                 <span class="comment">// we don&#39;t care about neighbors of subactive element.</span>
<a name="l00399"></a>00399                 <span class="keywordflow">if</span> ((!neigh-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ab426ef9274eb93de879fef28b027d602">active</a>()) &amp;&amp; (!elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad1486ba6e3005fe331e4911907fadfbb">subactive</a>()))
<a name="l00400"></a>00400                 {
<a name="l00401"></a>00401                   <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;On processor &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1MeshBase.php#aa557872c33163622cc66645fc393c925">libMesh::processor_id</a>() 
<a name="l00402"></a>00402                                 &lt;&lt; std::endl;
<a name="l00403"></a>00403                   <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Bad element ID = &quot;</span> &lt;&lt; elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>() 
<a name="l00404"></a>00404                     &lt;&lt; <span class="stringliteral">&quot;, Side &quot;</span> &lt;&lt; s &lt;&lt; <span class="stringliteral">&quot;, Bad neighbor ID = &quot;</span> &lt;&lt; neigh-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>() &lt;&lt; std::endl;
<a name="l00405"></a>00405                   <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Bad element proc_ID = &quot;</span> &lt;&lt; elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">processor_id</a>() 
<a name="l00406"></a>00406                     &lt;&lt; <span class="stringliteral">&quot;, Bad neighbor proc_ID = &quot;</span> &lt;&lt; neigh-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">processor_id</a>() &lt;&lt; std::endl;
<a name="l00407"></a>00407                   <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Bad element size = &quot;</span> &lt;&lt; elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#af7712d01779f053ea14d49b017c54828">hmin</a>() 
<a name="l00408"></a>00408                     &lt;&lt; <span class="stringliteral">&quot;, Bad neighbor size = &quot;</span> &lt;&lt; neigh-&gt;<a class="code" href="classlibMesh_1_1Elem.php#af7712d01779f053ea14d49b017c54828">hmin</a>() &lt;&lt; std::endl;
<a name="l00409"></a>00409                   <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Bad element center = &quot;</span> &lt;&lt; elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a462388b471a3cd8d88e9452a00299f8e">centroid</a>() 
<a name="l00410"></a>00410                     &lt;&lt; <span class="stringliteral">&quot;, Bad neighbor center = &quot;</span> &lt;&lt; neigh-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a462388b471a3cd8d88e9452a00299f8e">centroid</a>() &lt;&lt; std::endl;
<a name="l00411"></a>00411                   <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: &quot;</span> 
<a name="l00412"></a>00412                     &lt;&lt; (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ab426ef9274eb93de879fef28b027d602">active</a>()?<span class="stringliteral">&quot;Active&quot;</span>:<span class="stringliteral">&quot;Ancestor&quot;</span>)
<a name="l00413"></a>00413                     &lt;&lt; <span class="stringliteral">&quot; Element at level &quot;</span>
<a name="l00414"></a>00414                     &lt;&lt; elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a1fa3e8bb1baa330a5037487dbe9304ab">level</a>() &lt;&lt; std::endl;
<a name="l00415"></a>00415                   <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;with &quot;</span>
<a name="l00416"></a>00416                     &lt;&lt; (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a7cdd994bb4245128f8617b62d7968e35">parent</a>()-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ab426ef9274eb93de879fef28b027d602">active</a>()?<span class="stringliteral">&quot;active&quot;</span>:
<a name="l00417"></a>00417                         (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a7cdd994bb4245128f8617b62d7968e35">parent</a>()-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad1486ba6e3005fe331e4911907fadfbb">subactive</a>()?<span class="stringliteral">&quot;subactive&quot;</span>:<span class="stringliteral">&quot;ancestor&quot;</span>))
<a name="l00418"></a>00418                     &lt;&lt; <span class="stringliteral">&quot; parent share &quot;</span>
<a name="l00419"></a>00419                     &lt;&lt; (neigh-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad1486ba6e3005fe331e4911907fadfbb">subactive</a>()?<span class="stringliteral">&quot;subactive&quot;</span>:<span class="stringliteral">&quot;ancestor&quot;</span>)
<a name="l00420"></a>00420                     &lt;&lt; <span class="stringliteral">&quot; neighbor at level &quot;</span> &lt;&lt; neigh-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a1fa3e8bb1baa330a5037487dbe9304ab">level</a>()
<a name="l00421"></a>00421                     &lt;&lt; std::endl;
<a name="l00422"></a>00422                   <a class="code" href="classlibMesh_1_1GMVIO.php">GMVIO</a>(*this).<a class="code" href="classlibMesh_1_1GMVIO.php#a0930d00f5b0ca8c5192ea678dd08d265">write</a> (<span class="stringliteral">&quot;bad_mesh.gmv&quot;</span>);
<a name="l00423"></a>00423                   libmesh_error();
<a name="l00424"></a>00424                 }
<a name="l00425"></a>00425 <span class="preprocessor">#endif // DEBUG</span>
<a name="l00426"></a>00426 <span class="preprocessor"></span>            }
<a name="l00427"></a>00427         }
<a name="l00428"></a>00428     }
<a name="l00429"></a>00429   
<a name="l00430"></a>00430 <span class="preprocessor">#endif // AMR</span>
<a name="l00431"></a>00431 <span class="preprocessor"></span>
<a name="l00432"></a>00432 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00433"></a>00433 <span class="preprocessor"></span><a class="code" href="namespacelibMesh_1_1MeshTools.php#a943be6a54f82a23518dc6fc11d9bb527">MeshTools::libmesh_assert_valid_neighbors</a>(*<span class="keyword">this</span>);
<a name="l00434"></a>00434 <span class="preprocessor">#endif</span>
<a name="l00435"></a>00435 <span class="preprocessor"></span>
<a name="l00436"></a>00436   STOP_LOG(<span class="stringliteral">&quot;find_neighbors()&quot;</span>, <span class="stringliteral">&quot;Mesh&quot;</span>);
<a name="l00437"></a>00437 }
<a name="l00438"></a>00438 
<a name="l00439"></a>00439 
<a name="l00440"></a>00440 
<a name="l00441"></a><a class="code" href="classlibMesh_1_1UnstructuredMesh.php#a66e2824ed094296417d15205ea998a71">00441</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1UnstructuredMesh.php#a66e2824ed094296417d15205ea998a71">UnstructuredMesh::read</a> (<span class="keyword">const</span> std::string&amp; name,
<a name="l00442"></a>00442                              <a class="code" href="classlibMesh_1_1MeshData.php">MeshData</a>* mesh_data,
<a name="l00443"></a>00443                              <span class="keywordtype">bool</span> skip_renumber_nodes_and_elements)
<a name="l00444"></a>00444 {
<a name="l00445"></a>00445   <span class="comment">// See if the file exists.  Perform this check on all processors</span>
<a name="l00446"></a>00446   <span class="comment">// so that the code is terminated properly in the case that the</span>
<a name="l00447"></a>00447   <span class="comment">// file does not exist.</span>
<a name="l00448"></a>00448   {
<a name="l00449"></a>00449     std::ifstream in (name.c_str());
<a name="l00450"></a>00450     
<a name="l00451"></a>00451     <span class="keywordflow">if</span> (!in.good())
<a name="l00452"></a>00452       {
<a name="l00453"></a>00453         <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: cannot locate specified file:\n\t&quot;</span>
<a name="l00454"></a>00454                       &lt;&lt; name
<a name="l00455"></a>00455                       &lt;&lt; std::endl;
<a name="l00456"></a>00456         libmesh_error();
<a name="l00457"></a>00457       }
<a name="l00458"></a>00458   }
<a name="l00459"></a>00459 
<a name="l00460"></a>00460   <span class="comment">// Set the skip_renumber_nodes_and_elements flag on all processors.</span>
<a name="l00461"></a>00461   <span class="comment">// This ensures that renumber_nodes_and_elements is *not* called</span>
<a name="l00462"></a>00462   <span class="comment">// during prepare_for_use() for certain types of mesh files.</span>
<a name="l00463"></a>00463   <span class="comment">// This is required in cases where there is an associated solution</span>
<a name="l00464"></a>00464   <span class="comment">// file which expects a certain ordering of the nodes.</span>
<a name="l00465"></a>00465   <span class="keywordflow">if</span>(name.rfind(<span class="stringliteral">&quot;.gmv&quot;</span>)+4==name.size())
<a name="l00466"></a>00466     {
<a name="l00467"></a>00467       skip_renumber_nodes_and_elements =  <span class="keyword">true</span>;
<a name="l00468"></a>00468     }
<a name="l00469"></a>00469   
<a name="l00470"></a>00470   <span class="comment">// Look for parallel formats first</span>
<a name="l00471"></a>00471   <span class="keywordflow">if</span> (is_parallel_file_format(name))
<a name="l00472"></a>00472     {      
<a name="l00473"></a>00473       <span class="comment">// no need to handling bz2 files here -- the Xdr class does that.</span>
<a name="l00474"></a>00474       <span class="keywordflow">if</span> ((name.rfind(<span class="stringliteral">&quot;.xda&quot;</span>) &lt; name.size()) ||
<a name="l00475"></a>00475           (name.rfind(<span class="stringliteral">&quot;.xdr&quot;</span>) &lt; name.size()))
<a name="l00476"></a>00476         {
<a name="l00477"></a>00477           <a class="code" href="classlibMesh_1_1XdrIO.php">XdrIO</a> xdr_io(*<span class="keyword">this</span>);
<a name="l00478"></a>00478 
<a name="l00479"></a>00479           <span class="comment">// .xda* ==&gt; bzip2/gzip/ASCII flavors</span>
<a name="l00480"></a>00480           <span class="keywordflow">if</span> (name.rfind(<span class="stringliteral">&quot;.xda&quot;</span>) &lt; name.size())
<a name="l00481"></a>00481             {
<a name="l00482"></a>00482               xdr_io.<a class="code" href="classlibMesh_1_1XdrIO.php#a06ba25e781d9a45faeb2d3325c152ee8">binary</a>() = <span class="keyword">false</span>;
<a name="l00483"></a>00483               xdr_io.<a class="code" href="classlibMesh_1_1XdrIO.php#ac5e61b735c35aecbeacf3da421c4afb6">read</a> (name);
<a name="l00484"></a>00484             }
<a name="l00485"></a>00485           <span class="keywordflow">else</span> <span class="comment">// .xdr* ==&gt; true binary XDR file</span>
<a name="l00486"></a>00486             {
<a name="l00487"></a>00487               xdr_io.<a class="code" href="classlibMesh_1_1XdrIO.php#a06ba25e781d9a45faeb2d3325c152ee8">binary</a>() = <span class="keyword">true</span>;
<a name="l00488"></a>00488               xdr_io.<a class="code" href="classlibMesh_1_1XdrIO.php#ac5e61b735c35aecbeacf3da421c4afb6">read</a> (name);
<a name="l00489"></a>00489             }
<a name="l00490"></a>00490 
<a name="l00491"></a>00491           <span class="comment">// The xdr_io object gets constructed with legacy() == false.</span>
<a name="l00492"></a>00492           <span class="comment">// if legacy() == true then it means that a legacy file was detected and</span>
<a name="l00493"></a>00493           <span class="comment">// thus processor 0 performed the read. We therefore need to broadcast the</span>
<a name="l00494"></a>00494           <span class="comment">// mesh.  Further, for this flavor of mesh solution data ordering is tied</span>
<a name="l00495"></a>00495           <span class="comment">// to the node ordering, so we better not reorder the nodes!</span>
<a name="l00496"></a>00496           <span class="keywordflow">if</span> (xdr_io.<a class="code" href="classlibMesh_1_1XdrIO.php#a8634a4e2f0d3fc91a44c12ccc20d704f">legacy</a>())
<a name="l00497"></a>00497             {
<a name="l00498"></a>00498               skip_renumber_nodes_and_elements = <span class="keyword">true</span>;
<a name="l00499"></a>00499               <a class="code" href="classlibMesh_1_1MeshCommunication.php">MeshCommunication</a>().<a class="code" href="classlibMesh_1_1MeshCommunication.php#ab9d0275f5567a8253e3b10fa0d39a623">broadcast</a>(*<span class="keyword">this</span>);
<a name="l00500"></a>00500             }
<a name="l00501"></a>00501 
<a name="l00502"></a>00502           <span class="comment">// libHilbert-enabled libMesh builds should construct files</span>
<a name="l00503"></a>00503           <span class="comment">// with a canonical node ordering, which libHilbert-enabled</span>
<a name="l00504"></a>00504           <span class="comment">// builds will be able to read in again regardless of any</span>
<a name="l00505"></a>00505           <span class="comment">// renumbering.  So in that case we&#39;re free to renumber.</span>
<a name="l00506"></a>00506           <span class="comment">// However, if either the writer or the reader of this file</span>
<a name="l00507"></a>00507           <span class="comment">// don&#39;t have libHilbert, then we&#39;ll have to skip</span>
<a name="l00508"></a>00508           <span class="comment">// renumbering because we need the numbering to remain</span>
<a name="l00509"></a>00509           <span class="comment">// consistent with any solution file we read in next.</span>
<a name="l00510"></a>00510 <span class="preprocessor">#ifdef LIBMESH_HAVE_LIBHILBERT</span>
<a name="l00511"></a>00511 <span class="preprocessor"></span>          <span class="comment">// if (!xdr_io.libhilbert_ordering())</span>
<a name="l00512"></a>00512           <span class="comment">//   skip_renumber_nodes_and_elements = true;</span>
<a name="l00513"></a>00513 <span class="preprocessor">#else</span>
<a name="l00514"></a>00514 <span class="preprocessor"></span>          skip_renumber_nodes_and_elements = <span class="keyword">true</span>;
<a name="l00515"></a>00515 <span class="preprocessor">#endif</span>
<a name="l00516"></a>00516 <span class="preprocessor"></span>        }      
<a name="l00517"></a>00517     }
<a name="l00518"></a>00518 
<a name="l00519"></a>00519   <span class="comment">// Serial mesh formats</span>
<a name="l00520"></a>00520   <span class="keywordflow">else</span>
<a name="l00521"></a>00521     {
<a name="l00522"></a>00522       START_LOG(<span class="stringliteral">&quot;read()&quot;</span>, <span class="stringliteral">&quot;Mesh&quot;</span>);  
<a name="l00523"></a>00523   
<a name="l00524"></a>00524       <span class="comment">// Read the file based on extension.  Only processor 0</span>
<a name="l00525"></a>00525       <span class="comment">// needs to read the mesh.  It will then broadcast it and</span>
<a name="l00526"></a>00526       <span class="comment">// the other processors will pick it up</span>
<a name="l00527"></a>00527       <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l00528"></a>00528         {
<a name="l00529"></a>00529           <span class="comment">// Nasty hack for reading/writing zipped files</span>
<a name="l00530"></a>00530           std::string new_name = <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>;
<a name="l00531"></a>00531           <span class="keywordflow">if</span> (name.size() - name.rfind(<span class="stringliteral">&quot;.bz2&quot;</span>) == 4)
<a name="l00532"></a>00532             {
<a name="l00533"></a>00533               new_name.erase(new_name.end() - 4, new_name.end());
<a name="l00534"></a>00534               std::string system_string = <span class="stringliteral">&quot;bunzip2 -f -k &quot;</span>;
<a name="l00535"></a>00535               system_string += <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>;
<a name="l00536"></a>00536               START_LOG(<span class="stringliteral">&quot;system(bunzip2)&quot;</span>, <span class="stringliteral">&quot;Mesh&quot;</span>);
<a name="l00537"></a>00537               <span class="keywordflow">if</span> (std::system(system_string.c_str()))
<a name="l00538"></a>00538                 libmesh_file_error(system_string);
<a name="l00539"></a>00539               STOP_LOG(<span class="stringliteral">&quot;system(bunzip2)&quot;</span>, <span class="stringliteral">&quot;Mesh&quot;</span>);
<a name="l00540"></a>00540             }
<a name="l00541"></a>00541 
<a name="l00542"></a>00542           <span class="keywordflow">if</span> (new_name.rfind(<span class="stringliteral">&quot;.mat&quot;</span>) &lt; new_name.size())
<a name="l00543"></a>00543             <a class="code" href="classlibMesh_1_1MatlabIO.php">MatlabIO</a>(*this).<a class="code" href="classlibMesh_1_1MatlabIO.php#ad7b47dbe3369efad07d3c4156bb2d45b">read</a>(new_name);
<a name="l00544"></a>00544           
<a name="l00545"></a>00545           <span class="keywordflow">else</span> <span class="keywordflow">if</span> (new_name.rfind(<span class="stringliteral">&quot;.ucd&quot;</span>) &lt; new_name.size())
<a name="l00546"></a>00546             <a class="code" href="classlibMesh_1_1UCDIO.php">UCDIO</a>(*this).<a class="code" href="classlibMesh_1_1UCDIO.php#a090ae9cd08dcdb05fbc0cf8a5a65c1b2">read</a> (new_name);
<a name="l00547"></a>00547           
<a name="l00548"></a>00548           <span class="keywordflow">else</span> <span class="keywordflow">if</span> ((new_name.rfind(<span class="stringliteral">&quot;.off&quot;</span>)  &lt; new_name.size()) ||
<a name="l00549"></a>00549                    (new_name.rfind(<span class="stringliteral">&quot;.ogl&quot;</span>)  &lt; new_name.size()) ||
<a name="l00550"></a>00550                    (new_name.rfind(<span class="stringliteral">&quot;.oogl&quot;</span>) &lt; new_name.size()))
<a name="l00551"></a>00551             <a class="code" href="classlibMesh_1_1OFFIO.php">OFFIO</a>(*this).<a class="code" href="classlibMesh_1_1OFFIO.php#af11dc54d2f39b96b67a128719a9296b3">read</a> (new_name);
<a name="l00552"></a>00552      
<a name="l00553"></a>00553           <span class="keywordflow">else</span> <span class="keywordflow">if</span> (new_name.rfind(<span class="stringliteral">&quot;.mgf&quot;</span>) &lt; new_name.size())
<a name="l00554"></a>00554             <a class="code" href="classlibMesh_1_1LegacyXdrIO.php">LegacyXdrIO</a>(*<span class="keyword">this</span>,<span class="keyword">true</span>).<a class="code" href="classlibMesh_1_1LegacyXdrIO.php#a124ef647d54bd059210280d83f92454b">read_mgf</a> (new_name);
<a name="l00555"></a>00555       
<a name="l00556"></a>00556           <span class="keywordflow">else</span> <span class="keywordflow">if</span> (new_name.rfind(<span class="stringliteral">&quot;.unv&quot;</span>) &lt; new_name.size())
<a name="l00557"></a>00557             {
<a name="l00558"></a>00558               <span class="keywordflow">if</span> (mesh_data == NULL)
<a name="l00559"></a>00559                 {
<a name="l00560"></a>00560                   <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error! You must pass a &quot;</span>
<a name="l00561"></a>00561                                 &lt;&lt; <span class="stringliteral">&quot;valid MeshData pointer to &quot;</span>
<a name="l00562"></a>00562                                 &lt;&lt; <span class="stringliteral">&quot;read UNV files!&quot;</span> &lt;&lt; std::endl;
<a name="l00563"></a>00563                   libmesh_error();
<a name="l00564"></a>00564                 }
<a name="l00565"></a>00565               <a class="code" href="classlibMesh_1_1UNVIO.php">UNVIO</a>(*<span class="keyword">this</span>, *mesh_data).<a class="code" href="classlibMesh_1_1UNVIO.php#a66258f5a1d703e345d3f3d824a0e6a01">read</a> (new_name);
<a name="l00566"></a>00566             }
<a name="l00567"></a>00567       
<a name="l00568"></a>00568           <span class="keywordflow">else</span> <span class="keywordflow">if</span> ((new_name.rfind(<span class="stringliteral">&quot;.node&quot;</span>)  &lt; new_name.size()) ||
<a name="l00569"></a>00569                    (new_name.rfind(<span class="stringliteral">&quot;.ele&quot;</span>)   &lt; new_name.size()))
<a name="l00570"></a>00570             <a class="code" href="classlibMesh_1_1TetGenIO.php">TetGenIO</a>(*<span class="keyword">this</span>,mesh_data).<a class="code" href="classlibMesh_1_1TetGenIO.php#ad06b7d388a2174c5bb513e076015b39f">read</a> (new_name);
<a name="l00571"></a>00571 
<a name="l00572"></a>00572           <span class="keywordflow">else</span> <span class="keywordflow">if</span> (new_name.rfind(<span class="stringliteral">&quot;.exd&quot;</span>) &lt; new_name.size() ||
<a name="l00573"></a>00573                    new_name.rfind(<span class="stringliteral">&quot;.e&quot;</span>) &lt; new_name.size())
<a name="l00574"></a>00574             <a class="code" href="classlibMesh_1_1ExodusII__IO.php">ExodusII_IO</a>(*this).<a class="code" href="classlibMesh_1_1ExodusII__IO.php#a5c8740e7197ba48ac0cd7d91d753f0f1">read</a> (new_name);
<a name="l00575"></a>00575           
<a name="l00576"></a>00576           <span class="keywordflow">else</span> <span class="keywordflow">if</span> (new_name.rfind(<span class="stringliteral">&quot;.msh&quot;</span>) &lt; new_name.size())
<a name="l00577"></a>00577             <a class="code" href="classlibMesh_1_1GmshIO.php">GmshIO</a>(*this).<a class="code" href="classlibMesh_1_1GmshIO.php#a9c1ba35a3e456c1d7722bfb0c2d97ae2">read</a> (new_name);
<a name="l00578"></a>00578 
<a name="l00579"></a>00579           <span class="keywordflow">else</span> <span class="keywordflow">if</span> (new_name.rfind(<span class="stringliteral">&quot;.gmv&quot;</span>) &lt; new_name.size())
<a name="l00580"></a>00580             <a class="code" href="classlibMesh_1_1GMVIO.php">GMVIO</a>(*this).<a class="code" href="classlibMesh_1_1GMVIO.php#aafac685af2a642382a3390ec469da03a">read</a> (new_name);
<a name="l00581"></a>00581 
<a name="l00582"></a>00582           <span class="keywordflow">else</span> <span class="keywordflow">if</span> (new_name.rfind(<span class="stringliteral">&quot;.vtu&quot;</span>) &lt; new_name.size())
<a name="l00583"></a>00583             <a class="code" href="classlibMesh_1_1VTKIO.php">VTKIO</a>(*this).<a class="code" href="classlibMesh_1_1VTKIO.php#a7270e6d4502408916d6107b4f32cf306">read</a>(new_name);
<a name="l00584"></a>00584       
<a name="l00585"></a>00585           <span class="keywordflow">else</span>
<a name="l00586"></a>00586             {
<a name="l00587"></a>00587               <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot; ERROR: Unrecognized file extension: &quot;</span> &lt;&lt; name
<a name="l00588"></a>00588                             &lt;&lt; <span class="stringliteral">&quot;\n   I understand the following:\n\n&quot;</span>
<a name="l00589"></a>00589                             &lt;&lt; <span class="stringliteral">&quot;     *.e    -- Sandia&#39;s ExodusII format\n&quot;</span>
<a name="l00590"></a>00590                         &lt;&lt; <span class="stringliteral">&quot;     *.exd  -- Sandia&#39;s ExodusII format\n&quot;</span>
<a name="l00591"></a>00591                         &lt;&lt; <span class="stringliteral">&quot;     *.gmv  -- LANL&#39;s General Mesh Viewer format\n&quot;</span>
<a name="l00592"></a>00592                         &lt;&lt; <span class="stringliteral">&quot;     *.mat  -- Matlab triangular ASCII file\n&quot;</span>
<a name="l00593"></a>00593                         &lt;&lt; <span class="stringliteral">&quot;     *.off  -- OOGL OFF surface format\n&quot;</span>
<a name="l00594"></a>00594                         &lt;&lt; <span class="stringliteral">&quot;     *.ucd  -- AVS&#39;s ASCII UCD format\n&quot;</span>
<a name="l00595"></a>00595                         &lt;&lt; <span class="stringliteral">&quot;     *.unv  -- I-deas Universal format\n&quot;</span>
<a name="l00596"></a>00596                         &lt;&lt; <span class="stringliteral">&quot;     *.vtu  -- Paraview VTK format\n&quot;</span>
<a name="l00597"></a>00597                         &lt;&lt; <span class="stringliteral">&quot;     *.xda  -- libMesh ASCII format\n&quot;</span>
<a name="l00598"></a>00598                         &lt;&lt; <span class="stringliteral">&quot;     *.xdr  -- libMesh binary format\n&quot;</span>
<a name="l00599"></a>00599                         &lt;&lt; <span class="stringliteral">&quot;     *.gz   -- any above format gzipped\n&quot;</span>
<a name="l00600"></a>00600                         &lt;&lt; <span class="stringliteral">&quot;     *.bz2  -- any above format bzip2&#39;ed\n&quot;</span>
<a name="l00601"></a>00601 
<a name="l00602"></a>00602                         &lt;&lt; std::endl;
<a name="l00603"></a>00603               libmesh_error();    
<a name="l00604"></a>00604             }    
<a name="l00605"></a>00605           
<a name="l00606"></a>00606           <span class="comment">// If we temporarily decompressed a .bz2 file, remove the</span>
<a name="l00607"></a>00607           <span class="comment">// uncompressed version</span>
<a name="l00608"></a>00608           <span class="keywordflow">if</span> (name.size() - name.rfind(<span class="stringliteral">&quot;.bz2&quot;</span>) == 4)
<a name="l00609"></a>00609             std::remove(new_name.c_str());
<a name="l00610"></a>00610         }
<a name="l00611"></a>00611       
<a name="l00612"></a>00612   
<a name="l00613"></a>00613       STOP_LOG(<span class="stringliteral">&quot;read()&quot;</span>, <span class="stringliteral">&quot;Mesh&quot;</span>);
<a name="l00614"></a>00614 
<a name="l00615"></a>00615       <span class="comment">// Send the mesh &amp; bcs (which are now only on processor 0) to the other</span>
<a name="l00616"></a>00616       <span class="comment">// processors</span>
<a name="l00617"></a>00617       <a class="code" href="classlibMesh_1_1MeshCommunication.php">MeshCommunication</a>().<a class="code" href="classlibMesh_1_1MeshCommunication.php#ab9d0275f5567a8253e3b10fa0d39a623">broadcast</a> (*<span class="keyword">this</span>);
<a name="l00618"></a>00618     }
<a name="l00619"></a>00619 
<a name="l00620"></a>00620   
<a name="l00621"></a>00621   <span class="comment">// Done reading the mesh.  Now prepare it for use.</span>
<a name="l00622"></a>00622   this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#a9805f1c4efa5d61188c582e58ed66a79">prepare_for_use</a>(skip_renumber_nodes_and_elements);
<a name="l00623"></a>00623 
<a name="l00624"></a>00624 }
<a name="l00625"></a>00625 
<a name="l00626"></a>00626 
<a name="l00627"></a>00627 
<a name="l00628"></a><a class="code" href="classlibMesh_1_1UnstructuredMesh.php#a7a7b9ff3b911b0037c514f31e429c79f">00628</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1UnstructuredMesh.php#a7a7b9ff3b911b0037c514f31e429c79f">UnstructuredMesh::write</a> (<span class="keyword">const</span> std::string&amp; name,
<a name="l00629"></a>00629                               <a class="code" href="classlibMesh_1_1MeshData.php">MeshData</a>* mesh_data)
<a name="l00630"></a>00630 {
<a name="l00631"></a>00631   <span class="comment">// parallel formats are special -- they may choose to write</span>
<a name="l00632"></a>00632   <span class="comment">// separate files, let&#39;s not try to handle the zipping here.</span>
<a name="l00633"></a>00633   <span class="keywordflow">if</span> (is_parallel_file_format(name))
<a name="l00634"></a>00634     {   
<a name="l00635"></a>00635       <span class="comment">// no need to handling bz2 files here -- the Xdr class does that.</span>
<a name="l00636"></a>00636       <span class="keywordflow">if</span> (name.rfind(<span class="stringliteral">&quot;.xda&quot;</span>) &lt; name.size())
<a name="l00637"></a>00637         <a class="code" href="classlibMesh_1_1XdrIO.php">XdrIO</a>(*this).<a class="code" href="classlibMesh_1_1XdrIO.php#af03ee4419d64f47236b3459bbc3f17ed">write</a>(name);
<a name="l00638"></a>00638         
<a name="l00639"></a>00639       <span class="keywordflow">else</span> <span class="keywordflow">if</span> (name.rfind(<span class="stringliteral">&quot;.xdr&quot;</span>) &lt; name.size())
<a name="l00640"></a>00640         <a class="code" href="classlibMesh_1_1XdrIO.php">XdrIO</a>(*<span class="keyword">this</span>,<span class="keyword">true</span>).<a class="code" href="classlibMesh_1_1XdrIO.php#af03ee4419d64f47236b3459bbc3f17ed">write</a>(name);
<a name="l00641"></a>00641     }
<a name="l00642"></a>00642 
<a name="l00643"></a>00643   <span class="comment">// serial file formats</span>
<a name="l00644"></a>00644   <span class="keywordflow">else</span>
<a name="l00645"></a>00645     {
<a name="l00646"></a>00646       START_LOG(<span class="stringliteral">&quot;write()&quot;</span>, <span class="stringliteral">&quot;Mesh&quot;</span>);
<a name="l00647"></a>00647 
<a name="l00648"></a>00648       <span class="comment">// Nasty hack for reading/writing zipped files</span>
<a name="l00649"></a>00649       std::string new_name = <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>;
<a name="l00650"></a>00650       <span class="keywordflow">if</span> (name.size() - name.rfind(<span class="stringliteral">&quot;.bz2&quot;</span>) == 4)
<a name="l00651"></a>00651         new_name.erase(new_name.end() - 4, new_name.end());
<a name="l00652"></a>00652   
<a name="l00653"></a>00653       <span class="comment">// New scope so that io will close before we try to zip the file</span>
<a name="l00654"></a>00654       {
<a name="l00655"></a>00655         <span class="comment">// Write the file based on extension</span>
<a name="l00656"></a>00656         <span class="keywordflow">if</span> (new_name.rfind(<span class="stringliteral">&quot;.dat&quot;</span>) &lt; new_name.size())
<a name="l00657"></a>00657           <a class="code" href="classlibMesh_1_1TecplotIO.php">TecplotIO</a>(*this).<a class="code" href="classlibMesh_1_1TecplotIO.php#a7296c0bb8b70db81ac3ae965e3101593">write</a> (new_name);
<a name="l00658"></a>00658         
<a name="l00659"></a>00659         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (new_name.rfind(<span class="stringliteral">&quot;.plt&quot;</span>) &lt; new_name.size())
<a name="l00660"></a>00660           <a class="code" href="classlibMesh_1_1TecplotIO.php">TecplotIO</a>(*<span class="keyword">this</span>,<span class="keyword">true</span>).<a class="code" href="classlibMesh_1_1TecplotIO.php#a7296c0bb8b70db81ac3ae965e3101593">write</a> (new_name);
<a name="l00661"></a>00661         
<a name="l00662"></a>00662         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (new_name.rfind(<span class="stringliteral">&quot;.ucd&quot;</span>) &lt; new_name.size())
<a name="l00663"></a>00663           <a class="code" href="classlibMesh_1_1UCDIO.php">UCDIO</a> (*this).<a class="code" href="classlibMesh_1_1UCDIO.php#a8fb6788014a837d486e5038025149447">write</a> (new_name);
<a name="l00664"></a>00664         
<a name="l00665"></a>00665         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (new_name.rfind(<span class="stringliteral">&quot;.gmv&quot;</span>) &lt; new_name.size())
<a name="l00666"></a>00666           <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#a716b4df3429a6b2a1d5386691dabe2ae">n_partitions</a>() &gt; 1)
<a name="l00667"></a>00667             <a class="code" href="classlibMesh_1_1GMVIO.php">GMVIO</a>(*this).<a class="code" href="classlibMesh_1_1GMVIO.php#a0930d00f5b0ca8c5192ea678dd08d265">write</a> (new_name);
<a name="l00668"></a>00668           <span class="keywordflow">else</span>
<a name="l00669"></a>00669             {
<a name="l00670"></a>00670               <a class="code" href="classlibMesh_1_1GMVIO.php">GMVIO</a> io(*<span class="keyword">this</span>);
<a name="l00671"></a>00671               io.<a class="code" href="classlibMesh_1_1GMVIO.php#a07b8521ab252f7063c5d6385cb7da8f6">partitioning</a>() = <span class="keyword">false</span>;
<a name="l00672"></a>00672               io.<a class="code" href="classlibMesh_1_1GMVIO.php#a0930d00f5b0ca8c5192ea678dd08d265">write</a> (new_name);
<a name="l00673"></a>00673             }
<a name="l00674"></a>00674         
<a name="l00675"></a>00675         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (new_name.rfind(<span class="stringliteral">&quot;.ugrid&quot;</span>) &lt; new_name.size())
<a name="l00676"></a>00676           <a class="code" href="classlibMesh_1_1DivaIO.php">DivaIO</a>(*this).<a class="code" href="classlibMesh_1_1DivaIO.php#ab0e952761220f84cd4acb8e67a2320fa">write</a>(new_name);
<a name="l00677"></a>00677         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (new_name.rfind(<span class="stringliteral">&quot;.exd&quot;</span>) &lt; new_name.size() ||
<a name="l00678"></a>00678                  new_name.rfind(<span class="stringliteral">&quot;.e&quot;</span>) &lt; new_name.size())
<a name="l00679"></a>00679           <a class="code" href="classlibMesh_1_1ExodusII__IO.php">ExodusII_IO</a>(*this).<a class="code" href="classlibMesh_1_1ExodusII__IO.php#a4d5d6b01bd1cc3ebcbd3f80814b8b35c">write</a>(new_name);
<a name="l00680"></a>00680         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (new_name.rfind(<span class="stringliteral">&quot;.mgf&quot;</span>)  &lt; new_name.size())
<a name="l00681"></a>00681           <a class="code" href="classlibMesh_1_1LegacyXdrIO.php">LegacyXdrIO</a>(*<span class="keyword">this</span>,<span class="keyword">true</span>).<a class="code" href="classlibMesh_1_1LegacyXdrIO.php#ad9aa839693c3022d920a6518f767cc2c">write_mgf</a>(new_name);
<a name="l00682"></a>00682         
<a name="l00683"></a>00683         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (new_name.rfind(<span class="stringliteral">&quot;.unv&quot;</span>) &lt; new_name.size())
<a name="l00684"></a>00684           {
<a name="l00685"></a>00685             <span class="keywordflow">if</span> (mesh_data == NULL)
<a name="l00686"></a>00686               {
<a name="l00687"></a>00687                 <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error! You must pass a &quot;</span>
<a name="l00688"></a>00688                               &lt;&lt; <span class="stringliteral">&quot;valid MeshData pointer to &quot;</span>
<a name="l00689"></a>00689                               &lt;&lt; <span class="stringliteral">&quot;write UNV files!&quot;</span> &lt;&lt; std::endl;
<a name="l00690"></a>00690                 libmesh_error();
<a name="l00691"></a>00691               }
<a name="l00692"></a>00692             <a class="code" href="classlibMesh_1_1UNVIO.php">UNVIO</a>(*<span class="keyword">this</span>, *mesh_data).<a class="code" href="classlibMesh_1_1UNVIO.php#adf786fd5f78f0edc656d5cfe628241de">write</a> (new_name);
<a name="l00693"></a>00693           }
<a name="l00694"></a>00694         
<a name="l00695"></a>00695         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (new_name.rfind(<span class="stringliteral">&quot;.mesh&quot;</span>) &lt; new_name.size())
<a name="l00696"></a>00696           <a class="code" href="classlibMesh_1_1MEDITIO.php">MEDITIO</a>(*this).<a class="code" href="classlibMesh_1_1MEDITIO.php#a111ff8221a0bf9ffa0060a3e3a4dcf35">write</a> (new_name);
<a name="l00697"></a>00697         
<a name="l00698"></a>00698         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (new_name.rfind(<span class="stringliteral">&quot;.poly&quot;</span>) &lt; new_name.size())
<a name="l00699"></a>00699           <a class="code" href="classlibMesh_1_1TetGenIO.php">TetGenIO</a>(*this).<a class="code" href="classlibMesh_1_1TetGenIO.php#ad6d6de8b33d18a5a9d6b09ad1e15f319">write</a> (new_name);
<a name="l00700"></a>00700         
<a name="l00701"></a>00701         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (new_name.rfind(<span class="stringliteral">&quot;.msh&quot;</span>) &lt; new_name.size())
<a name="l00702"></a>00702           <a class="code" href="classlibMesh_1_1GmshIO.php">GmshIO</a>(*this).<a class="code" href="classlibMesh_1_1GmshIO.php#a011fb192816a7c712aa03bf7afef9319">write</a> (new_name);
<a name="l00703"></a>00703         
<a name="l00704"></a>00704         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (new_name.rfind(<span class="stringliteral">&quot;.fro&quot;</span>) &lt; new_name.size())
<a name="l00705"></a>00705           <a class="code" href="classlibMesh_1_1FroIO.php">FroIO</a>(*this).<a class="code" href="classlibMesh_1_1FroIO.php#a58efbdb0178c55b5ef4aa1512b816650">write</a> (new_name);
<a name="l00706"></a>00706         
<a name="l00707"></a>00707         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (new_name.rfind(<span class="stringliteral">&quot;.vtu&quot;</span>) &lt; new_name.size())
<a name="l00708"></a>00708           <a class="code" href="classlibMesh_1_1VTKIO.php">VTKIO</a>(*this).<a class="code" href="classlibMesh_1_1VTKIO.php#a8429f9f34b853c65b3468e1b58ed2b52">write</a> (new_name);
<a name="l00709"></a>00709         
<a name="l00710"></a>00710         <span class="keywordflow">else</span>
<a name="l00711"></a>00711           {
<a name="l00712"></a>00712             <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a>
<a name="l00713"></a>00713               &lt;&lt; <span class="stringliteral">&quot; ERROR: Unrecognized file extension: &quot;</span> &lt;&lt; name
<a name="l00714"></a>00714               &lt;&lt; <span class="stringliteral">&quot;\n   I understand the following:\n\n&quot;</span>
<a name="l00715"></a>00715               &lt;&lt; <span class="stringliteral">&quot;     *.dat   -- Tecplot ASCII file\n&quot;</span>
<a name="l00716"></a>00716               &lt;&lt; <span class="stringliteral">&quot;     *.e     -- Sandia&#39;s ExodusII format\n&quot;</span>
<a name="l00717"></a>00717               &lt;&lt; <span class="stringliteral">&quot;     *.exd   -- Sandia&#39;s ExodusII format\n&quot;</span>
<a name="l00718"></a>00718               &lt;&lt; <span class="stringliteral">&quot;     *.fro   -- ACDL&#39;s surface triangulation file\n&quot;</span>
<a name="l00719"></a>00719               &lt;&lt; <span class="stringliteral">&quot;     *.gmv   -- LANL&#39;s GMV (General Mesh Viewer) format\n&quot;</span>
<a name="l00720"></a>00720               &lt;&lt; <span class="stringliteral">&quot;     *.mesh  -- MEdit mesh format\n&quot;</span>
<a name="l00721"></a>00721               &lt;&lt; <span class="stringliteral">&quot;     *.mgf   -- MGF binary mesh format\n&quot;</span>
<a name="l00722"></a>00722               &lt;&lt; <span class="stringliteral">&quot;     *.msh   -- GMSH ASCII file\n&quot;</span>
<a name="l00723"></a>00723               &lt;&lt; <span class="stringliteral">&quot;     *.plt   -- Tecplot binary file\n&quot;</span>
<a name="l00724"></a>00724               &lt;&lt; <span class="stringliteral">&quot;     *.poly  -- TetGen ASCII file\n&quot;</span>
<a name="l00725"></a>00725               &lt;&lt; <span class="stringliteral">&quot;     *.ucd   -- AVS&#39;s ASCII UCD format\n&quot;</span>
<a name="l00726"></a>00726               &lt;&lt; <span class="stringliteral">&quot;     *.ugrid -- Kelly&#39;s DIVA ASCII format\n&quot;</span>
<a name="l00727"></a>00727               &lt;&lt; <span class="stringliteral">&quot;     *.unv   -- I-deas Universal format\n&quot;</span>
<a name="l00728"></a>00728               &lt;&lt; <span class="stringliteral">&quot;     *.xda   -- libMesh ASCII format\n&quot;</span>
<a name="l00729"></a>00729               &lt;&lt; <span class="stringliteral">&quot;     *.xdr   -- libMesh binary format,\n&quot;</span>
<a name="l00730"></a>00730               &lt;&lt; std::endl
<a name="l00731"></a>00731               &lt;&lt; <span class="stringliteral">&quot;\n Exiting without writing output\n&quot;</span>;
<a name="l00732"></a>00732           }    
<a name="l00733"></a>00733       }
<a name="l00734"></a>00734   
<a name="l00735"></a>00735       <span class="comment">// Nasty hack for reading/writing zipped files</span>
<a name="l00736"></a>00736       <span class="keywordflow">if</span> (name.size() - name.rfind(<span class="stringliteral">&quot;.bz2&quot;</span>) == 4)
<a name="l00737"></a>00737         {
<a name="l00738"></a>00738           START_LOG(<span class="stringliteral">&quot;system(bzip2)&quot;</span>, <span class="stringliteral">&quot;Mesh&quot;</span>);
<a name="l00739"></a>00739           <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l00740"></a>00740             {
<a name="l00741"></a>00741               std::string system_string = <span class="stringliteral">&quot;bzip2 -f &quot;</span>;
<a name="l00742"></a>00742               system_string += new_name;
<a name="l00743"></a>00743               <span class="keywordflow">if</span> (std::system(system_string.c_str()))
<a name="l00744"></a>00744                 libmesh_file_error(system_string);
<a name="l00745"></a>00745             }
<a name="l00746"></a>00746           <a class="code" href="namespacelibMesh_1_1Parallel.php#a95416053432ed0ab6d1231070bfebeff">Parallel::barrier</a>();
<a name="l00747"></a>00747           STOP_LOG(<span class="stringliteral">&quot;system(bzip2)&quot;</span>, <span class="stringliteral">&quot;Mesh&quot;</span>);
<a name="l00748"></a>00748         }
<a name="l00749"></a>00749       
<a name="l00750"></a>00750       STOP_LOG(<span class="stringliteral">&quot;write()&quot;</span>, <span class="stringliteral">&quot;Mesh&quot;</span>);
<a name="l00751"></a>00751     }  
<a name="l00752"></a>00752 }
<a name="l00753"></a>00753 
<a name="l00754"></a>00754 
<a name="l00755"></a>00755 
<a name="l00756"></a><a class="code" href="classlibMesh_1_1UnstructuredMesh.php#a73141d030309b6e818e0e8cc33e7b35b">00756</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1UnstructuredMesh.php#a7a7b9ff3b911b0037c514f31e429c79f">UnstructuredMesh::write</a> (<span class="keyword">const</span> std::string&amp; name,
<a name="l00757"></a>00757                   <span class="keyword">const</span> std::vector&lt;Number&gt;&amp; v,
<a name="l00758"></a>00758                   <span class="keyword">const</span> std::vector&lt;std::string&gt;&amp; vn)
<a name="l00759"></a>00759 {
<a name="l00760"></a>00760   START_LOG(<span class="stringliteral">&quot;write()&quot;</span>, <span class="stringliteral">&quot;Mesh&quot;</span>);
<a name="l00761"></a>00761 
<a name="l00762"></a>00762   <span class="comment">// Write the file based on extension</span>
<a name="l00763"></a>00763   <span class="keywordflow">if</span> (name.rfind(<span class="stringliteral">&quot;.dat&quot;</span>) &lt; name.size())
<a name="l00764"></a>00764     <a class="code" href="classlibMesh_1_1TecplotIO.php">TecplotIO</a>(*this).<a class="code" href="classlibMesh_1_1TecplotIO.php#ab954506b50942efa5fe95f0b0c882b17">write_nodal_data</a> (name, v, vn);
<a name="l00765"></a>00765   
<a name="l00766"></a>00766   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (name.rfind(<span class="stringliteral">&quot;.plt&quot;</span>) &lt; name.size())
<a name="l00767"></a>00767     <a class="code" href="classlibMesh_1_1TecplotIO.php">TecplotIO</a>(*<span class="keyword">this</span>,<span class="keyword">true</span>).<a class="code" href="classlibMesh_1_1TecplotIO.php#ab954506b50942efa5fe95f0b0c882b17">write_nodal_data</a> (name, v, vn);
<a name="l00768"></a>00768   
<a name="l00769"></a>00769   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (name.rfind(<span class="stringliteral">&quot;.gmv&quot;</span>) &lt; name.size())
<a name="l00770"></a>00770     {
<a name="l00771"></a>00771       <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1MeshBase.php#a4a9a53f02f28310e99f946294a7667d0">n_subdomains</a>() &gt; 1)
<a name="l00772"></a>00772         <a class="code" href="classlibMesh_1_1GMVIO.php">GMVIO</a>(*this).<a class="code" href="classlibMesh_1_1GMVIO.php#a479a7ad380a62cf1979b0c873adb290d">write_nodal_data</a> (name, v, vn);
<a name="l00773"></a>00773       <span class="keywordflow">else</span>
<a name="l00774"></a>00774         {
<a name="l00775"></a>00775           <a class="code" href="classlibMesh_1_1GMVIO.php">GMVIO</a> io(*<span class="keyword">this</span>);
<a name="l00776"></a>00776           io.<a class="code" href="classlibMesh_1_1GMVIO.php#a07b8521ab252f7063c5d6385cb7da8f6">partitioning</a>() = <span class="keyword">false</span>;
<a name="l00777"></a>00777           io.<a class="code" href="classlibMesh_1_1GMVIO.php#a479a7ad380a62cf1979b0c873adb290d">write_nodal_data</a> (name, v, vn);
<a name="l00778"></a>00778         }
<a name="l00779"></a>00779     }    
<a name="l00780"></a>00780   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (name.rfind(<span class="stringliteral">&quot;.pvtu&quot;</span>) &lt; name.size())
<a name="l00781"></a>00781     {
<a name="l00782"></a>00782       <a class="code" href="classlibMesh_1_1VTKIO.php">VTKIO</a>(*this).<a class="code" href="classlibMesh_1_1MeshOutput.php#af42dcec7bd619290b567ddd36f294b37">write_nodal_data</a> (name, v, vn);
<a name="l00783"></a>00783     }
<a name="l00784"></a>00784   <span class="keywordflow">else</span>
<a name="l00785"></a>00785     {
<a name="l00786"></a>00786       <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a>
<a name="l00787"></a>00787         &lt;&lt; <span class="stringliteral">&quot; ERROR: Unrecognized file extension: &quot;</span> &lt;&lt; name
<a name="l00788"></a>00788         &lt;&lt; <span class="stringliteral">&quot;\n   I understand the following:\n\n&quot;</span>
<a name="l00789"></a>00789         &lt;&lt; <span class="stringliteral">&quot;     *.dat  -- Tecplot ASCII file\n&quot;</span>
<a name="l00790"></a>00790         &lt;&lt; <span class="stringliteral">&quot;     *.gmv  -- LANL&#39;s GMV (General Mesh Viewer) format\n&quot;</span>
<a name="l00791"></a>00791         &lt;&lt; <span class="stringliteral">&quot;     *.plt  -- Tecplot binary file\n&quot;</span>
<a name="l00792"></a>00792         &lt;&lt; <span class="stringliteral">&quot;     *.pvtu -- Paraview VTK file\n&quot;</span>
<a name="l00793"></a>00793         &lt;&lt; <span class="stringliteral">&quot;\n Exiting without writing output\n&quot;</span>;
<a name="l00794"></a>00794     }
<a name="l00795"></a>00795 
<a name="l00796"></a>00796   STOP_LOG(<span class="stringliteral">&quot;write()&quot;</span>, <span class="stringliteral">&quot;Mesh&quot;</span>);
<a name="l00797"></a>00797 }
<a name="l00798"></a>00798 
<a name="l00799"></a>00799 
<a name="l00800"></a>00800 
<a name="l00801"></a>00801 
<a name="l00802"></a>00802 
<a name="l00803"></a><a class="code" href="classlibMesh_1_1UnstructuredMesh.php#acaadcec9f9d14add2168c369eef4b233">00803</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1UnstructuredMesh.php#acaadcec9f9d14add2168c369eef4b233">UnstructuredMesh::create_pid_mesh</a>(<a class="code" href="classlibMesh_1_1UnstructuredMesh.php">UnstructuredMesh</a>&amp; pid_mesh,
<a name="l00804"></a>00804                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pid)<span class="keyword"> const</span>
<a name="l00805"></a>00805 <span class="keyword"></span>{
<a name="l00806"></a>00806 
<a name="l00807"></a>00807   <span class="comment">// Issue a warning if the number the number of processors</span>
<a name="l00808"></a>00808   <span class="comment">// currently available is less that that requested for</span>
<a name="l00809"></a>00809   <span class="comment">// partitioning.  This is not necessarily an error since</span>
<a name="l00810"></a>00810   <span class="comment">// you may run on one processor and still partition the</span>
<a name="l00811"></a>00811   <span class="comment">// mesh into several partitions.</span>
<a name="l00812"></a>00812 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00813"></a>00813 <span class="preprocessor"></span>  <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#a8b4ca46b2f69b29d670c737ba2b38600">n_processors</a>() &lt; pid)
<a name="l00814"></a>00814     {
<a name="l00815"></a>00815       <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;WARNING:  You are creating a &quot;</span>
<a name="l00816"></a>00816                     &lt;&lt; <span class="stringliteral">&quot;mesh for a processor id (=&quot;</span>
<a name="l00817"></a>00817                     &lt;&lt; pid
<a name="l00818"></a>00818                     &lt;&lt; <span class="stringliteral">&quot;) greater than &quot;</span>
<a name="l00819"></a>00819                     &lt;&lt; <span class="stringliteral">&quot;the number of processors available for &quot;</span>
<a name="l00820"></a>00820                     &lt;&lt; <span class="stringliteral">&quot;the calculation. (=&quot;</span>
<a name="l00821"></a>00821                     &lt;&lt; <a class="code" href="classlibMesh_1_1MeshBase.php#a8b4ca46b2f69b29d670c737ba2b38600">libMesh::n_processors</a>()
<a name="l00822"></a>00822                     &lt;&lt; <span class="stringliteral">&quot;).&quot;</span>
<a name="l00823"></a>00823                     &lt;&lt; std::endl;
<a name="l00824"></a>00824     }
<a name="l00825"></a>00825 <span class="preprocessor">#endif</span>
<a name="l00826"></a>00826 <span class="preprocessor"></span>  
<a name="l00827"></a>00827   <span class="comment">// Create iterators to loop over the list of elements</span>
<a name="l00828"></a>00828 <span class="comment">//   const_active_pid_elem_iterator       it(this-&gt;elements_begin(),   pid);</span>
<a name="l00829"></a>00829 <span class="comment">//   const const_active_pid_elem_iterator it_end(this-&gt;elements_end(), pid);</span>
<a name="l00830"></a>00830 
<a name="l00831"></a>00831   <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">const_element_iterator</a>       it     = this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#ad250f85e39b8bbdfcc6605c6006aa202">active_pid_elements_begin</a>(pid);
<a name="l00832"></a>00832   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">const_element_iterator</a> it_end = this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#adf7c40f7022d79c4b9a96f2284fce248">active_pid_elements_end</a>(pid);
<a name="l00833"></a>00833     
<a name="l00834"></a>00834   this-&gt;<a class="code" href="classlibMesh_1_1UnstructuredMesh.php#a3ee9cbc4df033089f9d202e7244173d2">create_submesh</a> (pid_mesh, it, it_end);
<a name="l00835"></a>00835 }
<a name="l00836"></a>00836 
<a name="l00837"></a>00837 
<a name="l00838"></a>00838 
<a name="l00839"></a>00839 
<a name="l00840"></a>00840 
<a name="l00841"></a>00841 
<a name="l00842"></a>00842 
<a name="l00843"></a><a class="code" href="classlibMesh_1_1UnstructuredMesh.php#a3ee9cbc4df033089f9d202e7244173d2">00843</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1UnstructuredMesh.php#a3ee9cbc4df033089f9d202e7244173d2">UnstructuredMesh::create_submesh</a> (<a class="code" href="classlibMesh_1_1UnstructuredMesh.php">UnstructuredMesh</a>&amp; new_mesh,
<a name="l00844"></a>00844                            <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">const_element_iterator</a>&amp; it,
<a name="l00845"></a>00845                            <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">const_element_iterator</a>&amp; it_end)<span class="keyword"> const</span>
<a name="l00846"></a>00846 <span class="keyword"></span>{
<a name="l00847"></a>00847   <span class="comment">// Just in case the subdomain_mesh already has some information</span>
<a name="l00848"></a>00848   <span class="comment">// in it, get rid of it.</span>
<a name="l00849"></a>00849   new_mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a96d8f46093558e6c54de2743570c778d">clear</a>();
<a name="l00850"></a>00850 
<a name="l00851"></a>00851   <span class="comment">// Fail if (*this == new_mesh), we cannot create a submesh inside ourself!</span>
<a name="l00852"></a>00852   <span class="comment">// This may happen if the user accidently passes the original mesh into</span>
<a name="l00853"></a>00853   <span class="comment">// this function!  We will check this by making sure we did not just</span>
<a name="l00854"></a>00854   <span class="comment">// clear ourself.</span>
<a name="l00855"></a>00855   libmesh_assert (this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#aff7b82001829828de180cf961df93ea1">n_nodes</a>() != 0);
<a name="l00856"></a>00856   libmesh_assert (this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#a89566c09cd05aba8bd7f606eba96bf6f">n_elem</a>()  != 0); 
<a name="l00857"></a>00857 
<a name="l00858"></a>00858   <span class="comment">// How the nodes on this mesh will be renumbered to nodes</span>
<a name="l00859"></a>00859   <span class="comment">// on the new_mesh.  </span>
<a name="l00860"></a>00860   std::vector&lt;unsigned int&gt; new_node_numbers (this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#aff7b82001829828de180cf961df93ea1">n_nodes</a>());
<a name="l00861"></a>00861 
<a name="l00862"></a>00862   std::fill (new_node_numbers.begin(),
<a name="l00863"></a>00863              new_node_numbers.end(),
<a name="l00864"></a>00864              <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>);
<a name="l00865"></a>00865 
<a name="l00866"></a>00866   
<a name="l00867"></a>00867   
<a name="l00868"></a>00868   <span class="comment">// the number of nodes on the new mesh, will be incremented</span>
<a name="l00869"></a>00869   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_new_nodes = 0;
<a name="l00870"></a>00870   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_new_elem  = 0;
<a name="l00871"></a>00871     
<a name="l00872"></a>00872   <span class="keywordflow">for</span> (; it != it_end; ++it)
<a name="l00873"></a>00873     {
<a name="l00874"></a>00874       <span class="comment">// increment the new element counter</span>
<a name="l00875"></a>00875       n_new_elem++;
<a name="l00876"></a>00876         
<a name="l00877"></a>00877       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* old_elem = *it;
<a name="l00878"></a>00878 
<a name="l00879"></a>00879       <span class="comment">// Add an equivalent element type to the new_mesh</span>
<a name="l00880"></a>00880       <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* new_elem = 
<a name="l00881"></a>00881         new_mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a5ab834283fa6bc335ad623d2b737ec5e">add_elem</a> (<a class="code" href="classlibMesh_1_1Elem.php#a68cfa73358f50660055bf07a2919b2db">Elem::build</a>(old_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad06f8ac22978144723179eed42d10bae">type</a>()).release());
<a name="l00882"></a>00882 
<a name="l00883"></a>00883       libmesh_assert (new_elem != NULL);
<a name="l00884"></a>00884         
<a name="l00885"></a>00885       <span class="comment">// Loop over the nodes on this element.  </span>
<a name="l00886"></a>00886       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;old_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>(); n++)
<a name="l00887"></a>00887         {
<a name="l00888"></a>00888           libmesh_assert (old_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(n) &lt; new_node_numbers.size());
<a name="l00889"></a>00889 
<a name="l00890"></a>00890           <span class="keywordflow">if</span> (new_node_numbers[old_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(n)] == <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>)
<a name="l00891"></a>00891             {
<a name="l00892"></a>00892               new_node_numbers[old_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(n)] = n_new_nodes;
<a name="l00893"></a>00893 
<a name="l00894"></a>00894               <span class="comment">// Add this node to the new mesh</span>
<a name="l00895"></a>00895               new_mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ab07787f7933b2fbe29bc2bef32401fdc">add_point</a> (old_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(n));
<a name="l00896"></a>00896 
<a name="l00897"></a>00897               <span class="comment">// Increment the new node counter</span>
<a name="l00898"></a>00898               n_new_nodes++;
<a name="l00899"></a>00899             }
<a name="l00900"></a>00900 
<a name="l00901"></a>00901           <span class="comment">// Define this element&#39;s connectivity on the new mesh</span>
<a name="l00902"></a>00902           libmesh_assert (new_node_numbers[old_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(n)] &lt; new_mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aff7b82001829828de180cf961df93ea1">n_nodes</a>());
<a name="l00903"></a>00903             
<a name="l00904"></a>00904           new_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(n) = new_mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a> (new_node_numbers[old_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(n)]);
<a name="l00905"></a>00905         }
<a name="l00906"></a>00906 
<a name="l00907"></a>00907       <span class="comment">// Copy ids for this element</span>
<a name="l00908"></a>00908       new_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a96faae17e7ede5aa89c687d54cefb4b3">subdomain_id</a>() = old_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a96faae17e7ede5aa89c687d54cefb4b3">subdomain_id</a>();
<a name="l00909"></a>00909       new_elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">processor_id</a>() = old_elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">processor_id</a>();
<a name="l00910"></a>00910       
<a name="l00911"></a>00911       <span class="comment">// Maybe add boundary conditions for this element</span>
<a name="l00912"></a>00912       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s=0; s&lt;old_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ae376bfa6ac14723330e07a97992b56c9">n_sides</a>(); s++)
<a name="l00913"></a>00913         <span class="keywordflow">if</span> (old_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(s) == NULL)
<a name="l00914"></a>00914           <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;boundary_id (old_elem, s) !=
<a name="l00915"></a>00915               this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;invalid_id)
<a name="l00916"></a>00916             new_mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;add_side (new_elem,
<a name="l00917"></a>00917                                              s,
<a name="l00918"></a>00918                                              this-&gt;boundary_info-&gt;boundary_id (old_elem, s));
<a name="l00919"></a>00919     } <span class="comment">// end loop over elements</span>
<a name="l00920"></a>00920   
<a name="l00921"></a>00921 
<a name="l00922"></a>00922   <span class="comment">// Prepare the new_mesh for use</span>
<a name="l00923"></a>00923   new_mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a9805f1c4efa5d61188c582e58ed66a79">prepare_for_use</a>(<span class="comment">/*skip_renumber =*/</span><span class="keyword">false</span>);
<a name="l00924"></a>00924   
<a name="l00925"></a>00925 }
<a name="l00926"></a>00926 
<a name="l00927"></a>00927 
<a name="l00928"></a>00928 
<a name="l00929"></a>00929 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00930"></a><a class="code" href="classlibMesh_1_1UnstructuredMesh.php#a47fd892108fd672f5d7c5ccd117fee31">00930</a> <span class="preprocessor"></span><span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1UnstructuredMesh.php#a47fd892108fd672f5d7c5ccd117fee31">UnstructuredMesh::contract</a> ()
<a name="l00931"></a>00931 {
<a name="l00932"></a>00932   START_LOG (<span class="stringliteral">&quot;contract()&quot;</span>, <span class="stringliteral">&quot;Mesh&quot;</span>);
<a name="l00933"></a>00933 
<a name="l00934"></a>00934   <span class="comment">// Flag indicating if this call actually changes the mesh</span>
<a name="l00935"></a>00935   <span class="keywordtype">bool</span> mesh_changed = <span class="keyword">false</span>;
<a name="l00936"></a>00936 
<a name="l00937"></a>00937   <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">element_iterator</a> in        = <a class="code" href="classlibMesh_1_1MeshBase.php#ac266e1f5eb6ac9566ccbd7e6add6c239">elements_begin</a>();
<a name="l00938"></a>00938   <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">element_iterator</a> <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">out</a>       = <a class="code" href="classlibMesh_1_1MeshBase.php#ac266e1f5eb6ac9566ccbd7e6add6c239">elements_begin</a>();
<a name="l00939"></a>00939   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">element_iterator</a> end = <a class="code" href="classlibMesh_1_1MeshBase.php#ae94f1bce0dc50c489c6bae9ba64d06e8">elements_end</a>();
<a name="l00940"></a>00940 
<a name="l00941"></a>00941 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00942"></a>00942 <span class="preprocessor"></span>  <span class="keywordflow">for</span> ( ; in != end; ++in)
<a name="l00943"></a>00943     <span class="keywordflow">if</span> (*in != NULL)
<a name="l00944"></a>00944       {
<a name="l00945"></a>00945         <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a> = *in;
<a name="l00946"></a>00946         libmesh_assert(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ab426ef9274eb93de879fef28b027d602">active</a>() || elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad1486ba6e3005fe331e4911907fadfbb">subactive</a>() || elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d132de7da15df7db92f8995cc234b87">ancestor</a>());
<a name="l00947"></a>00947       }
<a name="l00948"></a>00948   in = <a class="code" href="classlibMesh_1_1MeshBase.php#ac266e1f5eb6ac9566ccbd7e6add6c239">elements_begin</a>();
<a name="l00949"></a>00949 <span class="preprocessor">#endif</span>
<a name="l00950"></a>00950 <span class="preprocessor"></span>  
<a name="l00951"></a>00951   <span class="comment">// Loop over the elements.   </span>
<a name="l00952"></a>00952   <span class="keywordflow">for</span> ( ; in != end; ++in)
<a name="l00953"></a>00953     <span class="keywordflow">if</span> (*in != NULL)
<a name="l00954"></a>00954       {
<a name="l00955"></a>00955         <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a> = *in;
<a name="l00956"></a>00956 
<a name="l00957"></a>00957         <span class="comment">// Delete all the subactive ones</span>
<a name="l00958"></a>00958         <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad1486ba6e3005fe331e4911907fadfbb">subactive</a>())
<a name="l00959"></a>00959           {
<a name="l00960"></a>00960             <span class="comment">// No level-0 element should be subactive.</span>
<a name="l00961"></a>00961             <span class="comment">// Note that we CAN&#39;T test elem-&gt;level(), as that </span>
<a name="l00962"></a>00962             <span class="comment">// touches elem-&gt;parent()-&gt;dim(), and elem-&gt;parent()</span>
<a name="l00963"></a>00963             <span class="comment">// might have already been deleted!</span>
<a name="l00964"></a>00964             libmesh_assert (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a7cdd994bb4245128f8617b62d7968e35">parent</a>() != NULL);
<a name="l00965"></a>00965 
<a name="l00966"></a>00966             <span class="comment">// Delete the element</span>
<a name="l00967"></a>00967             <span class="comment">// This just sets a pointer to NULL, and doesn&#39;t</span>
<a name="l00968"></a>00968             <span class="comment">// invalidate any iterators</span>
<a name="l00969"></a>00969             this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#a5c7824047ed759b5a4891a6936b546cc">delete_elem</a>(elem);
<a name="l00970"></a>00970             
<a name="l00971"></a>00971             <span class="comment">// the mesh has certainly changed</span>
<a name="l00972"></a>00972             mesh_changed = <span class="keyword">true</span>;
<a name="l00973"></a>00973           }
<a name="l00974"></a>00974         <span class="keywordflow">else</span>
<a name="l00975"></a>00975           {
<a name="l00976"></a>00976             <span class="comment">// Compress all the active ones</span>
<a name="l00977"></a>00977             <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ab426ef9274eb93de879fef28b027d602">active</a>())
<a name="l00978"></a>00978               elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a190384cbf87edfe3d41219615f3b6d27">contract</a>();
<a name="l00979"></a>00979             <span class="keywordflow">else</span>
<a name="l00980"></a>00980               libmesh_assert (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d132de7da15df7db92f8995cc234b87">ancestor</a>());
<a name="l00981"></a>00981           }
<a name="l00982"></a>00982       }
<a name="l00983"></a>00983 
<a name="l00984"></a>00984   <span class="comment">// Strip any newly-created NULL voids out of the element array</span>
<a name="l00985"></a>00985   this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#a29fb19d7d0a036669ea088eb3cbc7bb9">renumber_nodes_and_elements</a>();
<a name="l00986"></a>00986 
<a name="l00987"></a>00987   STOP_LOG (<span class="stringliteral">&quot;contract()&quot;</span>, <span class="stringliteral">&quot;Mesh&quot;</span>);
<a name="l00988"></a>00988   
<a name="l00989"></a>00989   <span class="keywordflow">return</span> mesh_changed;
<a name="l00990"></a>00990 }
<a name="l00991"></a>00991 <span class="preprocessor">#endif // #ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00992"></a>00992 <span class="preprocessor"></span>
<a name="l00993"></a>00993 } <span class="comment">// namespace libMesh</span>
<a name="l00994"></a>00994 
<a name="l00995"></a>00995 
<a name="l00996"></a>00996 
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
