<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_c3a49989e40b21e7508f29d2dc962def.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_052be9f25f493d014df1dd174da94f92.php">utils</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">xdr_cxx.C</div>  </div>
</div>
<div class="contents">
<a href="xdr__cxx_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// &quot;$Id$\n&quot;</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="comment">// C/C++ includes</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &lt;cstring&gt;</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="comment">// Local includes</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="xdr__cxx_8h.php">xdr_cxx.h</a>&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__logging_8h.php">libmesh_logging.h</a>&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="o__f__stream_8h.php">o_f_stream.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifdef LIBMESH_HAVE_GZSTREAM</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor"># include &quot;gzstream.h&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#endif</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="comment">// Anonymous namespace for implementation details.</span>
<a name="l00034"></a>00034 <span class="keyword">namespace </span>{
<a name="l00035"></a>00035 
<a name="l00036"></a>00036   <span class="comment">// Nasty hacks for reading/writing zipped files</span>
<a name="l00037"></a>00037   <span class="keywordtype">void</span> zip_file (<span class="keyword">const</span> std::string &amp;unzipped_name)
<a name="l00038"></a>00038   {
<a name="l00039"></a>00039     <span class="comment">// There&#39;s no parallel bzip2 for us to call</span>
<a name="l00040"></a>00040     libmesh_assert(<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0);
<a name="l00041"></a>00041 
<a name="l00042"></a>00042 <span class="preprocessor">#ifdef LIBMESH_HAVE_BZIP</span>
<a name="l00043"></a>00043 <span class="preprocessor"></span>    START_LOG(<span class="stringliteral">&quot;system(bzip2)&quot;</span>, <span class="stringliteral">&quot;XdrIO&quot;</span>);
<a name="l00044"></a>00044 
<a name="l00045"></a>00045     std::string system_string = <span class="stringliteral">&quot;bzip2 -f &quot;</span>;
<a name="l00046"></a>00046     system_string += unzipped_name;
<a name="l00047"></a>00047     <span class="keywordflow">if</span> (std::system(system_string.c_str()))
<a name="l00048"></a>00048       libmesh_file_error(system_string);
<a name="l00049"></a>00049      
<a name="l00050"></a>00050     STOP_LOG(<span class="stringliteral">&quot;system(bzip2)&quot;</span>, <span class="stringliteral">&quot;XdrIO&quot;</span>);
<a name="l00051"></a>00051 <span class="preprocessor">#else</span>
<a name="l00052"></a>00052 <span class="preprocessor"></span>    <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: need bzip2/bunzip2 to create &quot;</span>
<a name="l00053"></a>00053                  &lt;&lt; unzipped_name &lt;&lt; <span class="stringliteral">&quot;.bz2&quot;</span>
<a name="l00054"></a>00054                  &lt;&lt; std::endl;
<a name="l00055"></a>00055     libmesh_error();
<a name="l00056"></a>00056 <span class="preprocessor">#endif</span>
<a name="l00057"></a>00057 <span class="preprocessor"></span>  }
<a name="l00058"></a>00058 
<a name="l00059"></a>00059   std::string unzip_file (<span class="keyword">const</span> std::string &amp;<a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>)
<a name="l00060"></a>00060   {
<a name="l00061"></a>00061     <span class="comment">// There&#39;s no parallel bunzip2 for us to call</span>
<a name="l00062"></a>00062     libmesh_assert(<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0);
<a name="l00063"></a>00063 
<a name="l00064"></a>00064 <span class="preprocessor">#ifdef LIBMESH_HAVE_BZIP</span>
<a name="l00065"></a>00065 <span class="preprocessor"></span>    std::string new_name = <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>;
<a name="l00066"></a>00066     <span class="keywordflow">if</span> (name.size() - name.rfind(<span class="stringliteral">&quot;.bz2&quot;</span>) == 4)
<a name="l00067"></a>00067       {
<a name="l00068"></a>00068         new_name.erase(new_name.end() - 4, new_name.end());
<a name="l00069"></a>00069         START_LOG(<span class="stringliteral">&quot;system(bunzip2)&quot;</span>, <span class="stringliteral">&quot;XdrIO&quot;</span>);
<a name="l00070"></a>00070         std::string system_string = <span class="stringliteral">&quot;bunzip2 -f -k &quot;</span>;
<a name="l00071"></a>00071         system_string += <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>;
<a name="l00072"></a>00072         <span class="keywordflow">if</span> (std::system(system_string.c_str()))
<a name="l00073"></a>00073           libmesh_file_error(system_string);
<a name="l00074"></a>00074         STOP_LOG(<span class="stringliteral">&quot;system(bunzip2)&quot;</span>, <span class="stringliteral">&quot;XdrIO&quot;</span>);
<a name="l00075"></a>00075       }
<a name="l00076"></a>00076     <span class="keywordflow">return</span> new_name;
<a name="l00077"></a>00077 <span class="preprocessor">#else</span>
<a name="l00078"></a>00078 <span class="preprocessor"></span>    <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: need bzip2/bunzip2 to open .bz2 file &quot;</span>
<a name="l00079"></a>00079                  &lt;&lt; name &lt;&lt; std::endl;
<a name="l00080"></a>00080     libmesh_error();
<a name="l00081"></a>00081     <span class="keywordflow">return</span> <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>;
<a name="l00082"></a>00082 <span class="preprocessor">#endif</span>
<a name="l00083"></a>00083 <span class="preprocessor"></span>  }
<a name="l00084"></a>00084 
<a name="l00085"></a>00085   <span class="comment">// remove an unzipped file</span>
<a name="l00086"></a>00086   <span class="keywordtype">void</span> remove_unzipped_file (<span class="keyword">const</span> std::string &amp;name)
<a name="l00087"></a>00087   {
<a name="l00088"></a>00088     <span class="comment">// If we temporarily decompressed a .bz2 file, remove the</span>
<a name="l00089"></a>00089     <span class="comment">// uncompressed version</span>
<a name="l00090"></a>00090     <span class="keywordflow">if</span> (name.size() - name.rfind(<span class="stringliteral">&quot;.bz2&quot;</span>) == 4)
<a name="l00091"></a>00091       {
<a name="l00092"></a>00092         <span class="keyword">const</span> std::string new_name(name.begin(), name.end()-4);
<a name="l00093"></a>00093         std::remove(new_name.c_str());
<a name="l00094"></a>00094       }
<a name="l00095"></a>00095   }
<a name="l00096"></a>00096 }
<a name="l00097"></a>00097 
<a name="l00098"></a>00098 <span class="keyword">namespace </span>libMesh
<a name="l00099"></a>00099 {
<a name="l00100"></a>00100 
<a name="l00101"></a>00101 <span class="comment">//-------------------------------------------------------------</span>
<a name="l00102"></a>00102 <span class="comment">// Xdr class implementation</span>
<a name="l00103"></a><a class="code" href="classlibMesh_1_1Xdr.php#a4d6da7e91e39ea1a00830942f03e51c2">00103</a> <a class="code" href="classlibMesh_1_1Xdr.php#a4d6da7e91e39ea1a00830942f03e51c2">Xdr::Xdr</a> (<span class="keyword">const</span> std::string&amp; name, <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8">XdrMODE</a> m) :
<a name="l00104"></a>00104   mode(m),
<a name="l00105"></a>00105   file_name(name),
<a name="l00106"></a>00106 #ifdef LIBMESH_HAVE_XDR
<a name="l00107"></a>00107   xdrs(NULL),
<a name="l00108"></a>00108   fp(NULL),
<a name="l00109"></a>00109 #endif
<a name="l00110"></a>00110   in(NULL),
<a name="l00111"></a>00111   <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">out</a>(NULL),
<a name="l00112"></a>00112   comm_len(xdr_MAX_STRING_LENGTH),
<a name="l00113"></a>00113   gzipped_file(false),
<a name="l00114"></a>00114   bzipped_file(false)
<a name="l00115"></a>00115 {
<a name="l00116"></a>00116   this-&gt;<a class="code" href="classlibMesh_1_1Xdr.php#a87b80f1eaa4ef62d5d97ec18da5a6be9">open</a>(name);
<a name="l00117"></a>00117 }
<a name="l00118"></a>00118 
<a name="l00119"></a>00119 
<a name="l00120"></a>00120 
<a name="l00121"></a><a class="code" href="classlibMesh_1_1Xdr.php#a81d10e761936f92f1e886cc32d63bf50">00121</a> <a class="code" href="classlibMesh_1_1Xdr.php#a81d10e761936f92f1e886cc32d63bf50">Xdr::~Xdr</a>()
<a name="l00122"></a>00122 {
<a name="l00123"></a>00123   this-&gt;<a class="code" href="classlibMesh_1_1Xdr.php#aec6e011b6f52a182c8f181c2290456de">close</a>();
<a name="l00124"></a>00124 }
<a name="l00125"></a>00125 
<a name="l00126"></a>00126 
<a name="l00127"></a>00127 
<a name="l00128"></a><a class="code" href="classlibMesh_1_1Xdr.php#a87b80f1eaa4ef62d5d97ec18da5a6be9">00128</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Xdr.php#a87b80f1eaa4ef62d5d97ec18da5a6be9">Xdr::open</a> (<span class="keyword">const</span> std::string&amp; name)
<a name="l00129"></a>00129 {
<a name="l00130"></a>00130   <a class="code" href="classlibMesh_1_1Xdr.php#a2166573cc1fc5e4c42ed041416c45da1">file_name</a> = <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>;
<a name="l00131"></a>00131 
<a name="l00132"></a>00132   <span class="keywordflow">if</span> (name == <span class="stringliteral">&quot;&quot;</span>)
<a name="l00133"></a>00133     <span class="keywordflow">return</span>;
<a name="l00134"></a>00134 
<a name="l00135"></a>00135   <span class="keywordflow">switch</span> (<a class="code" href="classlibMesh_1_1Xdr.php#a6a8c422d1ff20293804d45ae6ce8efd8">mode</a>)
<a name="l00136"></a>00136     {
<a name="l00137"></a>00137     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8ae5559170d41d912b449375bb4e3468f6">ENCODE</a>:
<a name="l00138"></a>00138     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a2632308739033bf9f82ea90cdf92231e">DECODE</a>:
<a name="l00139"></a>00139       {
<a name="l00140"></a>00140 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l00141"></a>00141 <span class="preprocessor"></span>
<a name="l00142"></a>00142         <a class="code" href="classlibMesh_1_1Xdr.php#a7380d1ad6d90509a125247441218910e">fp</a> = fopen(name.c_str(), (<a class="code" href="classlibMesh_1_1Xdr.php#a6a8c422d1ff20293804d45ae6ce8efd8">mode</a> == <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8ae5559170d41d912b449375bb4e3468f6">ENCODE</a>) ? <span class="stringliteral">&quot;w&quot;</span> : <span class="stringliteral">&quot;r&quot;</span>);
<a name="l00143"></a>00143         libmesh_assert (<a class="code" href="classlibMesh_1_1Xdr.php#a7380d1ad6d90509a125247441218910e">fp</a>);
<a name="l00144"></a>00144         <a class="code" href="classlibMesh_1_1Xdr.php#a21085b5edf0f8e659840649437da98e8">xdrs</a> = <span class="keyword">new</span> XDR;
<a name="l00145"></a>00145         xdrstdio_create (<a class="code" href="classlibMesh_1_1Xdr.php#a21085b5edf0f8e659840649437da98e8">xdrs</a>, <a class="code" href="classlibMesh_1_1Xdr.php#a7380d1ad6d90509a125247441218910e">fp</a>, (<a class="code" href="classlibMesh_1_1Xdr.php#a6a8c422d1ff20293804d45ae6ce8efd8">mode</a> == <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8ae5559170d41d912b449375bb4e3468f6">ENCODE</a>) ? XDR_ENCODE : XDR_DECODE);
<a name="l00146"></a>00146 <span class="preprocessor">#else</span>
<a name="l00147"></a>00147 <span class="preprocessor"></span>        
<a name="l00148"></a>00148         <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Functionality is not available.&quot;</span> &lt;&lt; std::endl
<a name="l00149"></a>00149                       &lt;&lt; <span class="stringliteral">&quot;Make sure LIBMESH_HAVE_XDR is defined at build time&quot;</span> 
<a name="l00150"></a>00150                       &lt;&lt; std::endl
<a name="l00151"></a>00151                       &lt;&lt; <span class="stringliteral">&quot;The XDR interface is not available in this installation&quot;</span>
<a name="l00152"></a>00152                       &lt;&lt; std::endl;
<a name="l00153"></a>00153 
<a name="l00154"></a>00154         libmesh_error();
<a name="l00155"></a>00155         
<a name="l00156"></a>00156 <span class="preprocessor">#endif</span>
<a name="l00157"></a>00157 <span class="preprocessor"></span>        <span class="keywordflow">return</span>;
<a name="l00158"></a>00158 
<a name="l00159"></a>00159       }
<a name="l00160"></a>00160 
<a name="l00161"></a>00161     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8acd5c7906bd7fea7650acc4c8cde09d48">READ</a>:
<a name="l00162"></a>00162       {
<a name="l00163"></a>00163         <a class="code" href="classlibMesh_1_1Xdr.php#ac6ac7b13397c8b728a3add588afbd77f">gzipped_file</a> = (name.size() - name.rfind(<span class="stringliteral">&quot;.gz&quot;</span>)  == 3);
<a name="l00164"></a>00164         <a class="code" href="classlibMesh_1_1Xdr.php#a23ead5481f3ed8bd7d63bfdad00e88da">bzipped_file</a> = (name.size() - name.rfind(<span class="stringliteral">&quot;.bz2&quot;</span>) == 4);
<a name="l00165"></a>00165 
<a name="l00166"></a>00166         <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1Xdr.php#ac6ac7b13397c8b728a3add588afbd77f">gzipped_file</a>)
<a name="l00167"></a>00167           {
<a name="l00168"></a>00168 <span class="preprocessor">#ifdef LIBMESH_HAVE_GZSTREAM</span>
<a name="l00169"></a>00169 <span class="preprocessor"></span>            igzstream *inf = <span class="keyword">new</span> igzstream;
<a name="l00170"></a>00170             libmesh_assert (inf != NULL);
<a name="l00171"></a>00171             <a class="code" href="classlibMesh_1_1Xdr.php#a90dea8073f1a0d8d0315c22fd408e7ec">in</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#aca7dac34d00cd798c43629794345a09c" title="Forcibly deletes the managed object.">reset</a>(inf);
<a name="l00172"></a>00172             inf-&gt;open(name.c_str(), <a class="code" href="classlibMesh_1_1Xdr.php#a90dea8073f1a0d8d0315c22fd408e7ec">std::ios::in</a>);
<a name="l00173"></a>00173 <span class="preprocessor">#else</span>
<a name="l00174"></a>00174 <span class="preprocessor"></span>            <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: need gzstream to handle .gz files!!!&quot;</span>
<a name="l00175"></a>00175                           &lt;&lt; std::endl;
<a name="l00176"></a>00176             libmesh_error();
<a name="l00177"></a>00177 <span class="preprocessor">#endif</span>
<a name="l00178"></a>00178 <span class="preprocessor"></span>          }
<a name="l00179"></a>00179         <span class="keywordflow">else</span>
<a name="l00180"></a>00180           {
<a name="l00181"></a>00181             std::ifstream *inf = <span class="keyword">new</span> std::ifstream;
<a name="l00182"></a>00182             libmesh_assert (inf != NULL);
<a name="l00183"></a>00183             <a class="code" href="classlibMesh_1_1Xdr.php#a90dea8073f1a0d8d0315c22fd408e7ec">in</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#aca7dac34d00cd798c43629794345a09c" title="Forcibly deletes the managed object.">reset</a>(inf);
<a name="l00184"></a>00184             
<a name="l00185"></a>00185             std::string new_name(<a class="code" href="classlibMesh_1_1Xdr.php#a23ead5481f3ed8bd7d63bfdad00e88da">bzipped_file</a> ? unzip_file(name) : name);
<a name="l00186"></a>00186 
<a name="l00187"></a>00187             inf-&gt;open(new_name.c_str(), <a class="code" href="classlibMesh_1_1Xdr.php#a90dea8073f1a0d8d0315c22fd408e7ec">std::ios::in</a>);
<a name="l00188"></a>00188           }
<a name="l00189"></a>00189 
<a name="l00190"></a>00190         libmesh_assert (<a class="code" href="classlibMesh_1_1Xdr.php#a90dea8073f1a0d8d0315c22fd408e7ec">in</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classlibMesh_1_1Xdr.php#a90dea8073f1a0d8d0315c22fd408e7ec">in</a>-&gt;good());
<a name="l00191"></a>00191         <span class="keywordflow">return</span>;
<a name="l00192"></a>00192       }
<a name="l00193"></a>00193 
<a name="l00194"></a>00194     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a47f4bcd4fcf418da5ec74d3d8e2c3bc4">WRITE</a>:
<a name="l00195"></a>00195       {
<a name="l00196"></a>00196         <a class="code" href="classlibMesh_1_1Xdr.php#ac6ac7b13397c8b728a3add588afbd77f">gzipped_file</a> = (name.size() - name.rfind(<span class="stringliteral">&quot;.gz&quot;</span>)  == 3);
<a name="l00197"></a>00197         <a class="code" href="classlibMesh_1_1Xdr.php#a23ead5481f3ed8bd7d63bfdad00e88da">bzipped_file</a> = (name.size() - name.rfind(<span class="stringliteral">&quot;.bz2&quot;</span>) == 4);
<a name="l00198"></a>00198 
<a name="l00199"></a>00199         <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1Xdr.php#ac6ac7b13397c8b728a3add588afbd77f">gzipped_file</a>)
<a name="l00200"></a>00200           {
<a name="l00201"></a>00201 <span class="preprocessor">#ifdef LIBMESH_HAVE_GZSTREAM</span>
<a name="l00202"></a>00202 <span class="preprocessor"></span>            ogzstream *outf = <span class="keyword">new</span> ogzstream;
<a name="l00203"></a>00203             libmesh_assert (outf != NULL);
<a name="l00204"></a>00204             <a class="code" href="classlibMesh_1_1Xdr.php#a1cc9cc60e3a68f70cd35bc7528408fd6">out</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#aca7dac34d00cd798c43629794345a09c" title="Forcibly deletes the managed object.">reset</a>(outf);
<a name="l00205"></a>00205             outf-&gt;open(name.c_str(), <a class="code" href="classlibMesh_1_1Xdr.php#a1cc9cc60e3a68f70cd35bc7528408fd6">std::ios::out</a>);
<a name="l00206"></a>00206 <span class="preprocessor">#else</span>
<a name="l00207"></a>00207 <span class="preprocessor"></span>            <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: need gzstream to handle .gz files!!!&quot;</span>
<a name="l00208"></a>00208                           &lt;&lt; std::endl;
<a name="l00209"></a>00209             libmesh_error();
<a name="l00210"></a>00210 <span class="preprocessor">#endif</span>
<a name="l00211"></a>00211 <span class="preprocessor"></span>          }
<a name="l00212"></a>00212         <span class="keywordflow">else</span>
<a name="l00213"></a>00213           {
<a name="l00214"></a>00214             std::ofstream *outf = <span class="keyword">new</span> std::ofstream;
<a name="l00215"></a>00215             libmesh_assert (outf != NULL);
<a name="l00216"></a>00216             <a class="code" href="classlibMesh_1_1Xdr.php#a1cc9cc60e3a68f70cd35bc7528408fd6">out</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#aca7dac34d00cd798c43629794345a09c" title="Forcibly deletes the managed object.">reset</a>(outf);
<a name="l00217"></a>00217 
<a name="l00218"></a>00218             std::string new_name = <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>;
<a name="l00219"></a>00219 
<a name="l00220"></a>00220             <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1Xdr.php#a23ead5481f3ed8bd7d63bfdad00e88da">bzipped_file</a>)
<a name="l00221"></a>00221               new_name.erase(new_name.end() - 4, new_name.end());
<a name="l00222"></a>00222 
<a name="l00223"></a>00223             outf-&gt;open(new_name.c_str(), <a class="code" href="classlibMesh_1_1Xdr.php#a1cc9cc60e3a68f70cd35bc7528408fd6">std::ios::out</a>);
<a name="l00224"></a>00224           }
<a name="l00225"></a>00225         
<a name="l00226"></a>00226         libmesh_assert (<a class="code" href="classlibMesh_1_1Xdr.php#a1cc9cc60e3a68f70cd35bc7528408fd6">out</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classlibMesh_1_1Xdr.php#a1cc9cc60e3a68f70cd35bc7528408fd6">out</a>-&gt;good());
<a name="l00227"></a>00227         <span class="keywordflow">return</span>;
<a name="l00228"></a>00228       }
<a name="l00229"></a>00229       
<a name="l00230"></a>00230     <span class="keywordflow">default</span>:
<a name="l00231"></a>00231       libmesh_error();
<a name="l00232"></a>00232     }  
<a name="l00233"></a>00233 }
<a name="l00234"></a>00234 
<a name="l00235"></a>00235 
<a name="l00236"></a>00236 
<a name="l00237"></a><a class="code" href="classlibMesh_1_1Xdr.php#aec6e011b6f52a182c8f181c2290456de">00237</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Xdr.php#aec6e011b6f52a182c8f181c2290456de">Xdr::close</a> ()
<a name="l00238"></a>00238 {
<a name="l00239"></a>00239   <span class="keywordflow">switch</span> (<a class="code" href="classlibMesh_1_1Xdr.php#a6a8c422d1ff20293804d45ae6ce8efd8">mode</a>)
<a name="l00240"></a>00240     {
<a name="l00241"></a>00241     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8ae5559170d41d912b449375bb4e3468f6">ENCODE</a>:
<a name="l00242"></a>00242     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a2632308739033bf9f82ea90cdf92231e">DECODE</a>:
<a name="l00243"></a>00243       {
<a name="l00244"></a>00244 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l00245"></a>00245 <span class="preprocessor"></span>
<a name="l00246"></a>00246         <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1Xdr.php#a21085b5edf0f8e659840649437da98e8">xdrs</a>)
<a name="l00247"></a>00247           {
<a name="l00248"></a>00248             xdr_destroy (<a class="code" href="classlibMesh_1_1Xdr.php#a21085b5edf0f8e659840649437da98e8">xdrs</a>);
<a name="l00249"></a>00249             <span class="keyword">delete</span> <a class="code" href="classlibMesh_1_1Xdr.php#a21085b5edf0f8e659840649437da98e8">xdrs</a>;
<a name="l00250"></a>00250             <a class="code" href="classlibMesh_1_1Xdr.php#a21085b5edf0f8e659840649437da98e8">xdrs</a> = NULL;
<a name="l00251"></a>00251           }
<a name="l00252"></a>00252         
<a name="l00253"></a>00253         <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1Xdr.php#a7380d1ad6d90509a125247441218910e">fp</a>)
<a name="l00254"></a>00254           {
<a name="l00255"></a>00255             fflush(<a class="code" href="classlibMesh_1_1Xdr.php#a7380d1ad6d90509a125247441218910e">fp</a>);
<a name="l00256"></a>00256             fclose(<a class="code" href="classlibMesh_1_1Xdr.php#a7380d1ad6d90509a125247441218910e">fp</a>);
<a name="l00257"></a>00257             <a class="code" href="classlibMesh_1_1Xdr.php#a7380d1ad6d90509a125247441218910e">fp</a> = NULL;
<a name="l00258"></a>00258           }
<a name="l00259"></a>00259 <span class="preprocessor">#else</span>
<a name="l00260"></a>00260 <span class="preprocessor"></span>        
<a name="l00261"></a>00261         <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Functionality is not available.&quot;</span> &lt;&lt; std::endl
<a name="l00262"></a>00262                       &lt;&lt; <span class="stringliteral">&quot;Make sure LIBMESH_HAVE_XDR is defined at build time&quot;</span> 
<a name="l00263"></a>00263                       &lt;&lt; std::endl
<a name="l00264"></a>00264                       &lt;&lt; <span class="stringliteral">&quot;The XDR interface is not available in this installation&quot;</span>
<a name="l00265"></a>00265                       &lt;&lt; std::endl;
<a name="l00266"></a>00266 
<a name="l00267"></a>00267         libmesh_error();
<a name="l00268"></a>00268         
<a name="l00269"></a>00269 <span class="preprocessor">#endif</span>
<a name="l00270"></a>00270 <span class="preprocessor"></span>        <a class="code" href="classlibMesh_1_1Xdr.php#a2166573cc1fc5e4c42ed041416c45da1">file_name</a> = <span class="stringliteral">&quot;&quot;</span>;
<a name="l00271"></a>00271         <span class="keywordflow">return</span>;
<a name="l00272"></a>00272       }
<a name="l00273"></a>00273       
<a name="l00274"></a>00274     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8acd5c7906bd7fea7650acc4c8cde09d48">READ</a>:
<a name="l00275"></a>00275       {
<a name="l00276"></a>00276         <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1Xdr.php#a90dea8073f1a0d8d0315c22fd408e7ec">in</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>() != NULL)
<a name="l00277"></a>00277           {
<a name="l00278"></a>00278             <a class="code" href="classlibMesh_1_1Xdr.php#a90dea8073f1a0d8d0315c22fd408e7ec">in</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#aca7dac34d00cd798c43629794345a09c" title="Forcibly deletes the managed object.">reset</a>();    
<a name="l00279"></a>00279             
<a name="l00280"></a>00280             <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1Xdr.php#a23ead5481f3ed8bd7d63bfdad00e88da">bzipped_file</a>)
<a name="l00281"></a>00281               remove_unzipped_file(<a class="code" href="classlibMesh_1_1Xdr.php#a2166573cc1fc5e4c42ed041416c45da1">file_name</a>);
<a name="l00282"></a>00282           }
<a name="l00283"></a>00283         <a class="code" href="classlibMesh_1_1Xdr.php#a2166573cc1fc5e4c42ed041416c45da1">file_name</a> = <span class="stringliteral">&quot;&quot;</span>;
<a name="l00284"></a>00284         <span class="keywordflow">return</span>;
<a name="l00285"></a>00285       }
<a name="l00286"></a>00286 
<a name="l00287"></a>00287     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a47f4bcd4fcf418da5ec74d3d8e2c3bc4">WRITE</a>:
<a name="l00288"></a>00288       {
<a name="l00289"></a>00289         <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1Xdr.php#a1cc9cc60e3a68f70cd35bc7528408fd6">out</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>() != NULL)
<a name="l00290"></a>00290           {
<a name="l00291"></a>00291             <a class="code" href="classlibMesh_1_1Xdr.php#a1cc9cc60e3a68f70cd35bc7528408fd6">out</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#aca7dac34d00cd798c43629794345a09c" title="Forcibly deletes the managed object.">reset</a>();      
<a name="l00292"></a>00292 
<a name="l00293"></a>00293             <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1Xdr.php#a23ead5481f3ed8bd7d63bfdad00e88da">bzipped_file</a>)
<a name="l00294"></a>00294               zip_file(std::string(<a class="code" href="classlibMesh_1_1Xdr.php#a2166573cc1fc5e4c42ed041416c45da1">file_name</a>.begin(), <a class="code" href="classlibMesh_1_1Xdr.php#a2166573cc1fc5e4c42ed041416c45da1">file_name</a>.end()-4));
<a name="l00295"></a>00295           }
<a name="l00296"></a>00296         <a class="code" href="classlibMesh_1_1Xdr.php#a2166573cc1fc5e4c42ed041416c45da1">file_name</a> = <span class="stringliteral">&quot;&quot;</span>;
<a name="l00297"></a>00297         <span class="keywordflow">return</span>;
<a name="l00298"></a>00298       }
<a name="l00299"></a>00299 
<a name="l00300"></a>00300     <span class="keywordflow">default</span>:
<a name="l00301"></a>00301       libmesh_error();
<a name="l00302"></a>00302     }
<a name="l00303"></a>00303 }
<a name="l00304"></a>00304 
<a name="l00305"></a>00305 
<a name="l00306"></a>00306 
<a name="l00307"></a><a class="code" href="classlibMesh_1_1Xdr.php#a065c4f3b76dccf8e30cd735d78394c64">00307</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Xdr.php#a065c4f3b76dccf8e30cd735d78394c64">Xdr::is_open</a>()<span class="keyword"> const</span>
<a name="l00308"></a>00308 <span class="keyword"></span>{
<a name="l00309"></a>00309   <span class="keywordflow">switch</span> (<a class="code" href="classlibMesh_1_1Xdr.php#a6a8c422d1ff20293804d45ae6ce8efd8">mode</a>)
<a name="l00310"></a>00310     {
<a name="l00311"></a>00311     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8ae5559170d41d912b449375bb4e3468f6">ENCODE</a>:
<a name="l00312"></a>00312     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a2632308739033bf9f82ea90cdf92231e">DECODE</a>:
<a name="l00313"></a>00313       {
<a name="l00314"></a>00314 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l00315"></a>00315 <span class="preprocessor"></span>
<a name="l00316"></a>00316         <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1Xdr.php#a7380d1ad6d90509a125247441218910e">fp</a>)
<a name="l00317"></a>00317           <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1Xdr.php#a21085b5edf0f8e659840649437da98e8">xdrs</a>)
<a name="l00318"></a>00318             <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00319"></a>00319 
<a name="l00320"></a>00320         <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00321"></a>00321 
<a name="l00322"></a>00322 <span class="preprocessor">#else</span>
<a name="l00323"></a>00323 <span class="preprocessor"></span>        
<a name="l00324"></a>00324         <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Functionality is not available.&quot;</span> &lt;&lt; std::endl
<a name="l00325"></a>00325                       &lt;&lt; <span class="stringliteral">&quot;Make sure LIBMESH_HAVE_XDR is defined at build time&quot;</span> 
<a name="l00326"></a>00326                       &lt;&lt; std::endl
<a name="l00327"></a>00327                       &lt;&lt; <span class="stringliteral">&quot;The XDR interface is not available in this installation&quot;</span>
<a name="l00328"></a>00328                       &lt;&lt; std::endl;
<a name="l00329"></a>00329 
<a name="l00330"></a>00330         libmesh_error();
<a name="l00331"></a>00331 
<a name="l00332"></a>00332         <span class="keywordflow">return</span> <span class="keyword">false</span>;   
<a name="l00333"></a>00333 
<a name="l00334"></a>00334 <span class="preprocessor">#endif</span>
<a name="l00335"></a>00335 <span class="preprocessor"></span>
<a name="l00336"></a>00336       }
<a name="l00337"></a>00337       
<a name="l00338"></a>00338     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8acd5c7906bd7fea7650acc4c8cde09d48">READ</a>:
<a name="l00339"></a>00339       {
<a name="l00340"></a>00340         <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1Xdr.php#a90dea8073f1a0d8d0315c22fd408e7ec">in</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>() != NULL)
<a name="l00341"></a>00341           <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Xdr.php#a90dea8073f1a0d8d0315c22fd408e7ec">in</a>-&gt;good();
<a name="l00342"></a>00342         <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00343"></a>00343       }
<a name="l00344"></a>00344 
<a name="l00345"></a>00345     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a47f4bcd4fcf418da5ec74d3d8e2c3bc4">WRITE</a>:
<a name="l00346"></a>00346       {
<a name="l00347"></a>00347         <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1Xdr.php#a1cc9cc60e3a68f70cd35bc7528408fd6">out</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>() != NULL)
<a name="l00348"></a>00348           <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Xdr.php#a1cc9cc60e3a68f70cd35bc7528408fd6">out</a>-&gt;good();
<a name="l00349"></a>00349         <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00350"></a>00350       }
<a name="l00351"></a>00351 
<a name="l00352"></a>00352     <span class="keywordflow">default</span>:
<a name="l00353"></a>00353       libmesh_error();
<a name="l00354"></a>00354     }
<a name="l00355"></a>00355 
<a name="l00356"></a>00356   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00357"></a>00357 }
<a name="l00358"></a>00358 
<a name="l00359"></a>00359 
<a name="l00360"></a>00360 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l00361"></a>00361 <span class="preprocessor"></span>
<a name="l00362"></a>00362 <span class="comment">// Anonymous namespace for Xdr::data helper functions</span>
<a name="l00363"></a>00363 <span class="keyword">namespace</span>
<a name="l00364"></a>00364 {
<a name="l00365"></a>00365 
<a name="l00366"></a>00366 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00367"></a>00367 xdrproc_t xdr_translator();
<a name="l00368"></a>00368 
<a name="l00369"></a>00369 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00370"></a>00370 <span class="keywordtype">bool</span> xdr_translate(XDR* x, T&amp; a) {<span class="keywordflow">return</span> (xdr_translator&lt;T&gt;())(x, &amp;a); }
<a name="l00371"></a>00371 
<a name="l00372"></a>00372 <span class="keyword">template</span> &lt;&gt;
<a name="l00373"></a>00373 <span class="keywordtype">bool</span> xdr_translate(XDR* x, std::string&amp; s) {
<a name="l00374"></a>00374   <span class="keywordtype">char</span>* sptr = <span class="keyword">new</span> <span class="keywordtype">char</span>[xdr_MAX_STRING_LENGTH+1];
<a name="l00375"></a>00375   std::copy(s.begin(), s.end(), sptr);
<a name="l00376"></a>00376   sptr[s.size()] = 0;
<a name="l00377"></a>00377   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> length = xdr_MAX_STRING_LENGTH;
<a name="l00378"></a>00378   <span class="keywordtype">bool</span> b = xdr_string(x, &amp;sptr, length);
<a name="l00379"></a>00379 
<a name="l00380"></a>00380   <span class="comment">// This is necessary when reading, but inefficient when writing...</span>
<a name="l00381"></a>00381   length = std::strlen(sptr);
<a name="l00382"></a>00382   s.resize(length);
<a name="l00383"></a>00383   std::copy(sptr, sptr+length, s.begin());
<a name="l00384"></a>00384 
<a name="l00385"></a>00385   <span class="keyword">delete</span> [] sptr;
<a name="l00386"></a>00386   <span class="keywordflow">return</span> b;
<a name="l00387"></a>00387 }
<a name="l00388"></a>00388 
<a name="l00389"></a>00389 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00390"></a>00390 <span class="keywordtype">bool</span> xdr_translate(XDR* x, std::complex&lt;T&gt;&amp; a) {
<a name="l00391"></a>00391   <span class="keywordtype">bool</span> b1 = xdr_translate(x, a.real());
<a name="l00392"></a>00392   <span class="keywordtype">bool</span> b2 = xdr_translate(x, a.imag());
<a name="l00393"></a>00393   <span class="keywordflow">return</span> (b1 &amp;&amp; b2);
<a name="l00394"></a>00394 }
<a name="l00395"></a>00395 
<a name="l00396"></a>00396 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00397"></a>00397 <span class="keywordtype">bool</span> xdr_translate(XDR* x, std::vector&lt;T&gt;&amp; a) {
<a name="l00398"></a>00398   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> length = a.size();
<a name="l00399"></a>00399   xdr_u_int(x, &amp;length);
<a name="l00400"></a>00400   a.resize(length);
<a name="l00401"></a>00401   <span class="keywordflow">return</span> xdr_vector(x, (<span class="keywordtype">char</span>*) &amp;a[0], length, <span class="keyword">sizeof</span>(T),
<a name="l00402"></a>00402                     xdr_translator&lt;T&gt;());
<a name="l00403"></a>00403 }
<a name="l00404"></a>00404 
<a name="l00405"></a>00405 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00406"></a>00406 <span class="keywordtype">bool</span> xdr_translate(XDR* x, std::vector&lt;std::complex&lt;T&gt; &gt;&amp; a) {
<a name="l00407"></a>00407   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> length = a.size();
<a name="l00408"></a>00408   <span class="keywordtype">bool</span> b = xdr_u_int(x, &amp;length);
<a name="l00409"></a>00409   a.resize(length);
<a name="l00410"></a>00410   <span class="keyword">typename</span> std::vector&lt;std::complex&lt;T&gt; &gt;::iterator iter = a.begin();
<a name="l00411"></a>00411   <span class="keywordflow">for</span> (; iter != a.end(); ++iter)
<a name="l00412"></a>00412     <span class="keywordflow">if</span> (!xdr_translate(x, *iter))
<a name="l00413"></a>00413       b = <span class="keyword">false</span>;
<a name="l00414"></a>00414   <span class="keywordflow">return</span> b;
<a name="l00415"></a>00415 }
<a name="l00416"></a>00416 
<a name="l00417"></a>00417 <span class="keyword">template</span> &lt;&gt;
<a name="l00418"></a>00418 xdrproc_t xdr_translator&lt;int&gt;() { <span class="keywordflow">return</span> (xdrproc_t)(xdr_int); }
<a name="l00419"></a>00419 
<a name="l00420"></a>00420 <span class="keyword">template</span> &lt;&gt;
<a name="l00421"></a>00421 xdrproc_t xdr_translator&lt;unsigned int&gt;() { <span class="keywordflow">return</span> (xdrproc_t)(xdr_u_int); }
<a name="l00422"></a>00422 
<a name="l00423"></a>00423 <span class="keyword">template</span> &lt;&gt;
<a name="l00424"></a>00424 xdrproc_t xdr_translator&lt;short int&gt;() { <span class="keywordflow">return</span> (xdrproc_t)(xdr_short); }
<a name="l00425"></a>00425 
<a name="l00426"></a>00426 <span class="keyword">template</span> &lt;&gt;
<a name="l00427"></a>00427 xdrproc_t xdr_translator&lt;unsigned short int&gt;() { <span class="keywordflow">return</span> (xdrproc_t)(xdr_u_short); }
<a name="l00428"></a>00428 
<a name="l00429"></a>00429 <span class="keyword">template</span> &lt;&gt;
<a name="l00430"></a>00430 xdrproc_t xdr_translator&lt;float&gt;() { <span class="keywordflow">return</span> (xdrproc_t)(xdr_float); }
<a name="l00431"></a>00431 
<a name="l00432"></a>00432 <span class="keyword">template</span> &lt;&gt;
<a name="l00433"></a>00433 xdrproc_t xdr_translator&lt;double&gt;() { <span class="keywordflow">return</span> (xdrproc_t)(xdr_double); }
<a name="l00434"></a>00434 
<a name="l00435"></a>00435 <span class="comment">// FIXME - no XDR love for long doubles?</span>
<a name="l00436"></a>00436 <span class="keyword">template</span> &lt;&gt;
<a name="l00437"></a>00437 xdrproc_t xdr_translator&lt;long double&gt;() { <span class="keywordflow">return</span> (xdrproc_t)(xdr_double); }
<a name="l00438"></a>00438 
<a name="l00439"></a>00439 } <span class="comment">// end anonymous namespace</span>
<a name="l00440"></a>00440 
<a name="l00441"></a>00441 <span class="preprocessor">#endif</span>
<a name="l00442"></a>00442 <span class="preprocessor"></span>
<a name="l00443"></a>00443 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00444"></a><a class="code" href="classlibMesh_1_1Xdr.php#a076c0e3c482eadea9c32547f27b22a0d">00444</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Xdr.php#a076c0e3c482eadea9c32547f27b22a0d">Xdr::do_read</a>(T&amp; a) {
<a name="l00445"></a>00445   *<a class="code" href="classlibMesh_1_1Xdr.php#a90dea8073f1a0d8d0315c22fd408e7ec">in</a> &gt;&gt; a; 
<a name="l00446"></a>00446   <a class="code" href="classlibMesh_1_1Xdr.php#a90dea8073f1a0d8d0315c22fd408e7ec">in</a>-&gt;getline(<a class="code" href="classlibMesh_1_1Xdr.php#a5fcf1760d922e948634032ee556e8277">comm</a>, <a class="code" href="classlibMesh_1_1Xdr.php#a5254e6bf8f5faad6b858e258e497ba6e">comm_len</a>);
<a name="l00447"></a>00447 }
<a name="l00448"></a>00448 
<a name="l00449"></a>00449 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00450"></a><a class="code" href="classlibMesh_1_1Xdr.php#a278f9c7d3609a50620acc9d9c4518507">00450</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Xdr.php#a076c0e3c482eadea9c32547f27b22a0d">Xdr::do_read</a>(std::complex&lt;T&gt;&amp; a) {
<a name="l00451"></a>00451   *<a class="code" href="classlibMesh_1_1Xdr.php#a90dea8073f1a0d8d0315c22fd408e7ec">in</a> &gt;&gt; a.real() &gt;&gt; a.imag();
<a name="l00452"></a>00452   <a class="code" href="classlibMesh_1_1Xdr.php#a90dea8073f1a0d8d0315c22fd408e7ec">in</a>-&gt;getline(<a class="code" href="classlibMesh_1_1Xdr.php#a5fcf1760d922e948634032ee556e8277">comm</a>, <a class="code" href="classlibMesh_1_1Xdr.php#a5254e6bf8f5faad6b858e258e497ba6e">comm_len</a>);
<a name="l00453"></a>00453 }
<a name="l00454"></a>00454 
<a name="l00455"></a>00455 <span class="keyword">template</span> &lt;&gt;
<a name="l00456"></a><a class="code" href="classlibMesh_1_1Xdr.php#ad6af7f0b6413930a18e2e8cf2b4e5b35">00456</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Xdr.php#a076c0e3c482eadea9c32547f27b22a0d">Xdr::do_read</a>(std::string&amp; a) {
<a name="l00457"></a>00457   <a class="code" href="classlibMesh_1_1Xdr.php#a90dea8073f1a0d8d0315c22fd408e7ec">in</a>-&gt;getline(<a class="code" href="classlibMesh_1_1Xdr.php#a5fcf1760d922e948634032ee556e8277">comm</a>, <a class="code" href="classlibMesh_1_1Xdr.php#a5254e6bf8f5faad6b858e258e497ba6e">comm_len</a>);
<a name="l00458"></a>00458 
<a name="l00459"></a>00459   a = <span class="stringliteral">&quot;&quot;</span>;
<a name="l00460"></a>00460 
<a name="l00461"></a>00461   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c&lt;std::strlen(<a class="code" href="classlibMesh_1_1Xdr.php#a5fcf1760d922e948634032ee556e8277">comm</a>); c++)
<a name="l00462"></a>00462     {
<a name="l00463"></a>00463       <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1Xdr.php#a5fcf1760d922e948634032ee556e8277">comm</a>[c] == <span class="charliteral">&#39;\t&#39;</span>) 
<a name="l00464"></a>00464         <span class="keywordflow">break</span>;
<a name="l00465"></a>00465       a.push_back(<a class="code" href="classlibMesh_1_1Xdr.php#a5fcf1760d922e948634032ee556e8277">comm</a>[c]);
<a name="l00466"></a>00466     }
<a name="l00467"></a>00467 }
<a name="l00468"></a>00468 
<a name="l00469"></a>00469 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00470"></a><a class="code" href="classlibMesh_1_1Xdr.php#ac3a863f580be8c07320d527d2c4849ef">00470</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Xdr.php#a076c0e3c482eadea9c32547f27b22a0d">Xdr::do_read</a>(std::vector&lt;T&gt;&amp; a) {
<a name="l00471"></a>00471   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> length=0;
<a name="l00472"></a>00472   <a class="code" href="classlibMesh_1_1Xdr.php#a8d41e3ea5b2559f8a73d83ad06a14cad">data</a>(length, <span class="stringliteral">&quot;# vector length&quot;</span>);
<a name="l00473"></a>00473   a.resize(length);
<a name="l00474"></a>00474 
<a name="l00475"></a>00475   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;a.size(); i++)
<a name="l00476"></a>00476     {
<a name="l00477"></a>00477       libmesh_assert (<a class="code" href="classlibMesh_1_1Xdr.php#a90dea8073f1a0d8d0315c22fd408e7ec">in</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classlibMesh_1_1Xdr.php#a90dea8073f1a0d8d0315c22fd408e7ec">in</a>-&gt;good());
<a name="l00478"></a>00478       *<a class="code" href="classlibMesh_1_1Xdr.php#a90dea8073f1a0d8d0315c22fd408e7ec">in</a> &gt;&gt; a[i]; 
<a name="l00479"></a>00479     }
<a name="l00480"></a>00480   <a class="code" href="classlibMesh_1_1Xdr.php#a90dea8073f1a0d8d0315c22fd408e7ec">in</a>-&gt;getline(<a class="code" href="classlibMesh_1_1Xdr.php#a5fcf1760d922e948634032ee556e8277">comm</a>, <a class="code" href="classlibMesh_1_1Xdr.php#a5254e6bf8f5faad6b858e258e497ba6e">comm_len</a>);
<a name="l00481"></a>00481 }
<a name="l00482"></a>00482 
<a name="l00483"></a>00483 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00484"></a><a class="code" href="classlibMesh_1_1Xdr.php#a7ea46577981dc53bb2484adcbd3c2cb2">00484</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Xdr.php#a076c0e3c482eadea9c32547f27b22a0d">Xdr::do_read</a>(std::vector&lt;std::complex&lt;T&gt; &gt;&amp; a) {
<a name="l00485"></a>00485   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> length=0;
<a name="l00486"></a>00486   <a class="code" href="classlibMesh_1_1Xdr.php#a8d41e3ea5b2559f8a73d83ad06a14cad">data</a>(length, <span class="stringliteral">&quot;# vector length x 2 (complex)&quot;</span>);
<a name="l00487"></a>00487   a.resize(length);
<a name="l00488"></a>00488 
<a name="l00489"></a>00489   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;a.size(); i++)
<a name="l00490"></a>00490     {
<a name="l00491"></a>00491       libmesh_assert (<a class="code" href="classlibMesh_1_1Xdr.php#a90dea8073f1a0d8d0315c22fd408e7ec">in</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classlibMesh_1_1Xdr.php#a90dea8073f1a0d8d0315c22fd408e7ec">in</a>-&gt;good());
<a name="l00492"></a>00492       *<a class="code" href="classlibMesh_1_1Xdr.php#a90dea8073f1a0d8d0315c22fd408e7ec">in</a> &gt;&gt; a[i].real() &gt;&gt; a[i].imag();
<a name="l00493"></a>00493     }
<a name="l00494"></a>00494 }
<a name="l00495"></a>00495 
<a name="l00496"></a>00496 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00497"></a><a class="code" href="classlibMesh_1_1Xdr.php#af684f6d64b0241bff0b33dade59c68f0">00497</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Xdr.php#af684f6d64b0241bff0b33dade59c68f0">Xdr::do_write</a>(T&amp; a) { *<a class="code" href="classlibMesh_1_1Xdr.php#a1cc9cc60e3a68f70cd35bc7528408fd6">out</a> &lt;&lt; a; }
<a name="l00498"></a>00498 
<a name="l00499"></a>00499 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00500"></a><a class="code" href="classlibMesh_1_1Xdr.php#a1a0b1d00eeb30a83ad9ce6bc39cd9711">00500</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Xdr.php#af684f6d64b0241bff0b33dade59c68f0">Xdr::do_write</a>(std::complex&lt;T&gt;&amp; a) { 
<a name="l00501"></a>00501   *<a class="code" href="classlibMesh_1_1Xdr.php#a1cc9cc60e3a68f70cd35bc7528408fd6">out</a> &lt;&lt; a.real() &lt;&lt; <span class="stringliteral">&quot;\t &quot;</span> &lt;&lt; a.imag();
<a name="l00502"></a>00502 }
<a name="l00503"></a>00503 
<a name="l00504"></a>00504 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00505"></a><a class="code" href="classlibMesh_1_1Xdr.php#a452bc02259bfad0c99faa82af5b23b27">00505</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Xdr.php#af684f6d64b0241bff0b33dade59c68f0">Xdr::do_write</a>(std::vector&lt;T&gt;&amp; a) { 
<a name="l00506"></a>00506   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> length=a.size();
<a name="l00507"></a>00507   <a class="code" href="classlibMesh_1_1Xdr.php#a8d41e3ea5b2559f8a73d83ad06a14cad">data</a>(length, <span class="stringliteral">&quot;# vector length&quot;</span>);
<a name="l00508"></a>00508 
<a name="l00509"></a>00509   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;a.size(); i++)
<a name="l00510"></a>00510     {
<a name="l00511"></a>00511       libmesh_assert (<a class="code" href="classlibMesh_1_1Xdr.php#a1cc9cc60e3a68f70cd35bc7528408fd6">out</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classlibMesh_1_1Xdr.php#a1cc9cc60e3a68f70cd35bc7528408fd6">out</a>-&gt;good());
<a name="l00512"></a>00512       this-&gt;<a class="code" href="classlibMesh_1_1Xdr.php#af684f6d64b0241bff0b33dade59c68f0">do_write</a>(a[i]);
<a name="l00513"></a>00513     }
<a name="l00514"></a>00514 }
<a name="l00515"></a>00515 
<a name="l00516"></a>00516 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00517"></a><a class="code" href="classlibMesh_1_1Xdr.php#a252cdd3b22b5431248e7f42b608cc2ed">00517</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Xdr.php#af684f6d64b0241bff0b33dade59c68f0">Xdr::do_write</a>(std::vector&lt;std::complex&lt;T&gt; &gt;&amp; a) { 
<a name="l00518"></a>00518   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> length=a.size();
<a name="l00519"></a>00519   <a class="code" href="classlibMesh_1_1Xdr.php#a8d41e3ea5b2559f8a73d83ad06a14cad">data</a>(length, <span class="stringliteral">&quot;# vector length x 2 (complex)&quot;</span>);
<a name="l00520"></a>00520 
<a name="l00521"></a>00521   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;a.size(); i++)
<a name="l00522"></a>00522     {
<a name="l00523"></a>00523       libmesh_assert (<a class="code" href="classlibMesh_1_1Xdr.php#a1cc9cc60e3a68f70cd35bc7528408fd6">out</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classlibMesh_1_1Xdr.php#a1cc9cc60e3a68f70cd35bc7528408fd6">out</a>-&gt;good());
<a name="l00524"></a>00524       this-&gt;<a class="code" href="classlibMesh_1_1Xdr.php#af684f6d64b0241bff0b33dade59c68f0">do_write</a>(a[i]);
<a name="l00525"></a>00525     }
<a name="l00526"></a>00526 }
<a name="l00527"></a>00527 
<a name="l00528"></a>00528 
<a name="l00529"></a>00529 
<a name="l00530"></a>00530 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00531"></a><a class="code" href="classlibMesh_1_1Xdr.php#a8d41e3ea5b2559f8a73d83ad06a14cad">00531</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Xdr.php#a8d41e3ea5b2559f8a73d83ad06a14cad">Xdr::data</a> (T&amp; a, <span class="keyword">const</span> <span class="keywordtype">char</span>* comment)
<a name="l00532"></a>00532 {
<a name="l00533"></a>00533   <span class="keywordflow">switch</span> (<a class="code" href="classlibMesh_1_1Xdr.php#a6a8c422d1ff20293804d45ae6ce8efd8">mode</a>)
<a name="l00534"></a>00534     {
<a name="l00535"></a>00535     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8ae5559170d41d912b449375bb4e3468f6">ENCODE</a>:
<a name="l00536"></a>00536     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a2632308739033bf9f82ea90cdf92231e">DECODE</a>:
<a name="l00537"></a>00537       {
<a name="l00538"></a>00538 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l00539"></a>00539 <span class="preprocessor"></span>
<a name="l00540"></a>00540         libmesh_assert (<a class="code" href="classlibMesh_1_1Xdr.php#a065c4f3b76dccf8e30cd735d78394c64">is_open</a>());
<a name="l00541"></a>00541 
<a name="l00542"></a>00542         xdr_translate(<a class="code" href="classlibMesh_1_1Xdr.php#a21085b5edf0f8e659840649437da98e8">xdrs</a>, a);
<a name="l00543"></a>00543 
<a name="l00544"></a>00544 <span class="preprocessor">#else</span>
<a name="l00545"></a>00545 <span class="preprocessor"></span>        
<a name="l00546"></a>00546         <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Functionality is not available.&quot;</span> &lt;&lt; std::endl
<a name="l00547"></a>00547                       &lt;&lt; <span class="stringliteral">&quot;Make sure LIBMESH_HAVE_XDR is defined at build time&quot;</span> 
<a name="l00548"></a>00548                       &lt;&lt; std::endl
<a name="l00549"></a>00549                       &lt;&lt; <span class="stringliteral">&quot;The XDR interface is not available in this installation&quot;</span>
<a name="l00550"></a>00550                       &lt;&lt; std::endl;
<a name="l00551"></a>00551 
<a name="l00552"></a>00552         libmesh_error();
<a name="l00553"></a>00553 
<a name="l00554"></a>00554 <span class="preprocessor">#endif</span>
<a name="l00555"></a>00555 <span class="preprocessor"></span>        <span class="keywordflow">return</span>;
<a name="l00556"></a>00556       }
<a name="l00557"></a>00557 
<a name="l00558"></a>00558     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8acd5c7906bd7fea7650acc4c8cde09d48">READ</a>:
<a name="l00559"></a>00559       {
<a name="l00560"></a>00560         libmesh_assert (<a class="code" href="classlibMesh_1_1Xdr.php#a90dea8073f1a0d8d0315c22fd408e7ec">in</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classlibMesh_1_1Xdr.php#a90dea8073f1a0d8d0315c22fd408e7ec">in</a>-&gt;good());
<a name="l00561"></a>00561         
<a name="l00562"></a>00562         this-&gt;<a class="code" href="classlibMesh_1_1Xdr.php#a076c0e3c482eadea9c32547f27b22a0d">do_read</a>(a);
<a name="l00563"></a>00563 
<a name="l00564"></a>00564         <span class="keywordflow">return</span>;
<a name="l00565"></a>00565       }
<a name="l00566"></a>00566 
<a name="l00567"></a>00567     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a47f4bcd4fcf418da5ec74d3d8e2c3bc4">WRITE</a>:
<a name="l00568"></a>00568       {
<a name="l00569"></a>00569         libmesh_assert (<a class="code" href="classlibMesh_1_1Xdr.php#a1cc9cc60e3a68f70cd35bc7528408fd6">out</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classlibMesh_1_1Xdr.php#a1cc9cc60e3a68f70cd35bc7528408fd6">out</a>-&gt;good());
<a name="l00570"></a>00570         
<a name="l00571"></a>00571         this-&gt;<a class="code" href="classlibMesh_1_1Xdr.php#af684f6d64b0241bff0b33dade59c68f0">do_write</a>(a);
<a name="l00572"></a>00572         *<a class="code" href="classlibMesh_1_1Xdr.php#a1cc9cc60e3a68f70cd35bc7528408fd6">out</a> &lt;&lt; <span class="stringliteral">&quot;\t &quot;</span> &lt;&lt; comment &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l00573"></a>00573 
<a name="l00574"></a>00574         <span class="keywordflow">return</span>;
<a name="l00575"></a>00575       }
<a name="l00576"></a>00576 
<a name="l00577"></a>00577     <span class="keywordflow">default</span>:
<a name="l00578"></a>00578       libmesh_error();
<a name="l00579"></a>00579     }
<a name="l00580"></a>00580 }
<a name="l00581"></a>00581 
<a name="l00582"></a>00582 
<a name="l00583"></a>00583 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00584"></a><a class="code" href="classlibMesh_1_1Xdr.php#a89f1c1a65390d6e3d168b5273913154c">00584</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Xdr.php#a89f1c1a65390d6e3d168b5273913154c">Xdr::data_stream</a> (T *val, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> len, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> line_break)
<a name="l00585"></a>00585 {
<a name="l00586"></a>00586   <span class="keywordflow">switch</span> (<a class="code" href="classlibMesh_1_1Xdr.php#a6a8c422d1ff20293804d45ae6ce8efd8">mode</a>)
<a name="l00587"></a>00587     {
<a name="l00588"></a>00588     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8ae5559170d41d912b449375bb4e3468f6">ENCODE</a>:
<a name="l00589"></a>00589       {
<a name="l00590"></a>00590 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l00591"></a>00591 <span class="preprocessor"></span>
<a name="l00592"></a>00592         libmesh_assert (this-&gt;<a class="code" href="classlibMesh_1_1Xdr.php#a065c4f3b76dccf8e30cd735d78394c64">is_open</a>());
<a name="l00593"></a>00593 
<a name="l00594"></a>00594 
<a name="l00595"></a>00595         xdr_vector(<a class="code" href="classlibMesh_1_1Xdr.php#a21085b5edf0f8e659840649437da98e8">xdrs</a>, 
<a name="l00596"></a>00596                    (<span class="keywordtype">char</span>*) val,
<a name="l00597"></a>00597                    len,
<a name="l00598"></a>00598                    <span class="keyword">sizeof</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>),
<a name="l00599"></a>00599                    (xdrproc_t) xdr_u_int);
<a name="l00600"></a>00600 
<a name="l00601"></a>00601 <span class="preprocessor">#else</span>
<a name="l00602"></a>00602 <span class="preprocessor"></span>        
<a name="l00603"></a>00603         <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Functionality is not available.&quot;</span> &lt;&lt; std::endl
<a name="l00604"></a>00604                       &lt;&lt; <span class="stringliteral">&quot;Make sure LIBMESH_HAVE_XDR is defined at build time&quot;</span> 
<a name="l00605"></a>00605                       &lt;&lt; std::endl
<a name="l00606"></a>00606                       &lt;&lt; <span class="stringliteral">&quot;The XDR interface is not available in this installation&quot;</span>
<a name="l00607"></a>00607                       &lt;&lt; std::endl;
<a name="l00608"></a>00608 
<a name="l00609"></a>00609         libmesh_error();
<a name="l00610"></a>00610 
<a name="l00611"></a>00611 <span class="preprocessor">#endif  </span>
<a name="l00612"></a>00612 <span class="preprocessor"></span>        <span class="keywordflow">return</span>;
<a name="l00613"></a>00613       }
<a name="l00614"></a>00614 
<a name="l00615"></a>00615     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a2632308739033bf9f82ea90cdf92231e">DECODE</a>:
<a name="l00616"></a>00616       {
<a name="l00617"></a>00617 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l00618"></a>00618 <span class="preprocessor"></span>
<a name="l00619"></a>00619         libmesh_assert (this-&gt;<a class="code" href="classlibMesh_1_1Xdr.php#a065c4f3b76dccf8e30cd735d78394c64">is_open</a>());
<a name="l00620"></a>00620 
<a name="l00621"></a>00621         <span class="keywordflow">if</span> (len &gt; 0)
<a name="l00622"></a>00622           xdr_vector(<a class="code" href="classlibMesh_1_1Xdr.php#a21085b5edf0f8e659840649437da98e8">xdrs</a>, 
<a name="l00623"></a>00623                      (<span class="keywordtype">char</span>*) val,
<a name="l00624"></a>00624                      len,
<a name="l00625"></a>00625                      <span class="keyword">sizeof</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>),
<a name="l00626"></a>00626                      (xdrproc_t) xdr_u_int);
<a name="l00627"></a>00627         
<a name="l00628"></a>00628 <span class="preprocessor">#else</span>
<a name="l00629"></a>00629 <span class="preprocessor"></span>        
<a name="l00630"></a>00630         <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Functionality is not available.&quot;</span> &lt;&lt; std::endl
<a name="l00631"></a>00631                       &lt;&lt; <span class="stringliteral">&quot;Make sure LIBMESH_HAVE_XDR is defined at build time&quot;</span> 
<a name="l00632"></a>00632                       &lt;&lt; std::endl
<a name="l00633"></a>00633                       &lt;&lt; <span class="stringliteral">&quot;The XDR interface is not available in this installation&quot;</span>
<a name="l00634"></a>00634                       &lt;&lt; std::endl;
<a name="l00635"></a>00635 
<a name="l00636"></a>00636         libmesh_error();
<a name="l00637"></a>00637 
<a name="l00638"></a>00638 <span class="preprocessor">#endif</span>
<a name="l00639"></a>00639 <span class="preprocessor"></span>        <span class="keywordflow">return</span>;
<a name="l00640"></a>00640       }
<a name="l00641"></a>00641 
<a name="l00642"></a>00642     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8acd5c7906bd7fea7650acc4c8cde09d48">READ</a>:
<a name="l00643"></a>00643       {
<a name="l00644"></a>00644         libmesh_assert (<a class="code" href="classlibMesh_1_1Xdr.php#a90dea8073f1a0d8d0315c22fd408e7ec">in</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classlibMesh_1_1Xdr.php#a90dea8073f1a0d8d0315c22fd408e7ec">in</a>-&gt;good());
<a name="l00645"></a>00645 
<a name="l00646"></a>00646         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;len; i++)
<a name="l00647"></a>00647           {
<a name="l00648"></a>00648             libmesh_assert (<a class="code" href="classlibMesh_1_1Xdr.php#a90dea8073f1a0d8d0315c22fd408e7ec">in</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classlibMesh_1_1Xdr.php#a90dea8073f1a0d8d0315c22fd408e7ec">in</a>-&gt;good());
<a name="l00649"></a>00649             *<a class="code" href="classlibMesh_1_1Xdr.php#a90dea8073f1a0d8d0315c22fd408e7ec">in</a> &gt;&gt; val[i];
<a name="l00650"></a>00650           }
<a name="l00651"></a>00651 
<a name="l00652"></a>00652         <span class="keywordflow">return</span>; 
<a name="l00653"></a>00653       }
<a name="l00654"></a>00654 
<a name="l00655"></a>00655     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a47f4bcd4fcf418da5ec74d3d8e2c3bc4">WRITE</a>:
<a name="l00656"></a>00656       {
<a name="l00657"></a>00657         libmesh_assert (<a class="code" href="classlibMesh_1_1Xdr.php#a1cc9cc60e3a68f70cd35bc7528408fd6">out</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classlibMesh_1_1Xdr.php#a1cc9cc60e3a68f70cd35bc7528408fd6">out</a>-&gt;good());
<a name="l00658"></a>00658 
<a name="l00659"></a>00659         <span class="keywordflow">if</span> (line_break == <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>)
<a name="l00660"></a>00660           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;len; i++)
<a name="l00661"></a>00661             {
<a name="l00662"></a>00662               libmesh_assert (<a class="code" href="classlibMesh_1_1Xdr.php#a1cc9cc60e3a68f70cd35bc7528408fd6">out</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classlibMesh_1_1Xdr.php#a1cc9cc60e3a68f70cd35bc7528408fd6">out</a>-&gt;good());
<a name="l00663"></a>00663               *<a class="code" href="classlibMesh_1_1Xdr.php#a1cc9cc60e3a68f70cd35bc7528408fd6">out</a> &lt;&lt; val[i] &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l00664"></a>00664             }
<a name="l00665"></a>00665         <span class="keywordflow">else</span>
<a name="l00666"></a>00666           {
<a name="l00667"></a>00667             <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> cnt=0;
<a name="l00668"></a>00668             <span class="keywordflow">while</span> (cnt &lt; len)
<a name="l00669"></a>00669               {
<a name="l00670"></a>00670                 <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(line_break,len); i++)
<a name="l00671"></a>00671                   {
<a name="l00672"></a>00672                     libmesh_assert (<a class="code" href="classlibMesh_1_1Xdr.php#a1cc9cc60e3a68f70cd35bc7528408fd6">out</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classlibMesh_1_1Xdr.php#a1cc9cc60e3a68f70cd35bc7528408fd6">out</a>-&gt;good());
<a name="l00673"></a>00673                     *<a class="code" href="classlibMesh_1_1Xdr.php#a1cc9cc60e3a68f70cd35bc7528408fd6">out</a> &lt;&lt; val[cnt++] &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l00674"></a>00674                   }
<a name="l00675"></a>00675                 libmesh_assert (<a class="code" href="classlibMesh_1_1Xdr.php#a1cc9cc60e3a68f70cd35bc7528408fd6">out</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classlibMesh_1_1Xdr.php#a1cc9cc60e3a68f70cd35bc7528408fd6">out</a>-&gt;good());
<a name="l00676"></a>00676                 *<a class="code" href="classlibMesh_1_1Xdr.php#a1cc9cc60e3a68f70cd35bc7528408fd6">out</a> &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l00677"></a>00677               }
<a name="l00678"></a>00678           }
<a name="l00679"></a>00679 
<a name="l00680"></a>00680         <span class="keywordflow">return</span>; 
<a name="l00681"></a>00681       }
<a name="l00682"></a>00682 
<a name="l00683"></a>00683     <span class="keywordflow">default</span>:
<a name="l00684"></a>00684       libmesh_error();
<a name="l00685"></a>00685     }
<a name="l00686"></a>00686 }
<a name="l00687"></a>00687 
<a name="l00688"></a>00688 
<a name="l00689"></a>00689 
<a name="l00690"></a>00690 <span class="keyword">template</span> &lt;&gt;
<a name="l00691"></a><a class="code" href="classlibMesh_1_1Xdr.php#abcc31aa7e6cb5989e9fad8538d703ddb">00691</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Xdr.php#a89f1c1a65390d6e3d168b5273913154c">Xdr::data_stream</a> (<span class="keywordtype">double</span> *val, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> len, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> line_break)
<a name="l00692"></a>00692 {
<a name="l00693"></a>00693   <span class="keywordflow">switch</span> (<a class="code" href="classlibMesh_1_1Xdr.php#a6a8c422d1ff20293804d45ae6ce8efd8">mode</a>)
<a name="l00694"></a>00694     {
<a name="l00695"></a>00695     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8ae5559170d41d912b449375bb4e3468f6">ENCODE</a>:
<a name="l00696"></a>00696     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a2632308739033bf9f82ea90cdf92231e">DECODE</a>:
<a name="l00697"></a>00697       {
<a name="l00698"></a>00698 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l00699"></a>00699 <span class="preprocessor"></span>
<a name="l00700"></a>00700         libmesh_assert (this-&gt;<a class="code" href="classlibMesh_1_1Xdr.php#a065c4f3b76dccf8e30cd735d78394c64">is_open</a>());
<a name="l00701"></a>00701 
<a name="l00702"></a>00702         <span class="keywordflow">if</span> (len &gt; 0)
<a name="l00703"></a>00703           xdr_vector(<a class="code" href="classlibMesh_1_1Xdr.php#a21085b5edf0f8e659840649437da98e8">xdrs</a>, 
<a name="l00704"></a>00704                      (<span class="keywordtype">char</span>*) val,
<a name="l00705"></a>00705                      len,
<a name="l00706"></a>00706                      <span class="keyword">sizeof</span>(<span class="keywordtype">double</span>),
<a name="l00707"></a>00707                      (xdrproc_t) xdr_double);
<a name="l00708"></a>00708         
<a name="l00709"></a>00709 <span class="preprocessor">#else</span>
<a name="l00710"></a>00710 <span class="preprocessor"></span>        
<a name="l00711"></a>00711         <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Functionality is not available.&quot;</span> &lt;&lt; std::endl
<a name="l00712"></a>00712                       &lt;&lt; <span class="stringliteral">&quot;Make sure LIBMESH_HAVE_XDR is defined at build time&quot;</span> 
<a name="l00713"></a>00713                       &lt;&lt; std::endl
<a name="l00714"></a>00714                       &lt;&lt; <span class="stringliteral">&quot;The XDR interface is not available in this installation&quot;</span>
<a name="l00715"></a>00715                       &lt;&lt; std::endl;
<a name="l00716"></a>00716 
<a name="l00717"></a>00717         libmesh_error();
<a name="l00718"></a>00718 
<a name="l00719"></a>00719 <span class="preprocessor">#endif</span>
<a name="l00720"></a>00720 <span class="preprocessor"></span>        <span class="keywordflow">return</span>;
<a name="l00721"></a>00721       }
<a name="l00722"></a>00722 
<a name="l00723"></a>00723     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8acd5c7906bd7fea7650acc4c8cde09d48">READ</a>:
<a name="l00724"></a>00724       {
<a name="l00725"></a>00725         libmesh_assert (<a class="code" href="classlibMesh_1_1Xdr.php#a90dea8073f1a0d8d0315c22fd408e7ec">in</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classlibMesh_1_1Xdr.php#a90dea8073f1a0d8d0315c22fd408e7ec">in</a>-&gt;good());
<a name="l00726"></a>00726 
<a name="l00727"></a>00727         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;len; i++)
<a name="l00728"></a>00728           {
<a name="l00729"></a>00729             libmesh_assert (<a class="code" href="classlibMesh_1_1Xdr.php#a90dea8073f1a0d8d0315c22fd408e7ec">in</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classlibMesh_1_1Xdr.php#a90dea8073f1a0d8d0315c22fd408e7ec">in</a>-&gt;good());
<a name="l00730"></a>00730             *<a class="code" href="classlibMesh_1_1Xdr.php#a90dea8073f1a0d8d0315c22fd408e7ec">in</a> &gt;&gt; val[i];
<a name="l00731"></a>00731           }
<a name="l00732"></a>00732 
<a name="l00733"></a>00733         <span class="keywordflow">return</span>; 
<a name="l00734"></a>00734       }
<a name="l00735"></a>00735 
<a name="l00736"></a>00736     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a47f4bcd4fcf418da5ec74d3d8e2c3bc4">WRITE</a>:
<a name="l00737"></a>00737       {
<a name="l00738"></a>00738         libmesh_assert (<a class="code" href="classlibMesh_1_1Xdr.php#a1cc9cc60e3a68f70cd35bc7528408fd6">out</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classlibMesh_1_1Xdr.php#a1cc9cc60e3a68f70cd35bc7528408fd6">out</a>-&gt;good());
<a name="l00739"></a>00739 
<a name="l00740"></a>00740         <span class="keywordflow">if</span> (line_break == <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>)
<a name="l00741"></a>00741           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;len; i++)
<a name="l00742"></a>00742             {
<a name="l00743"></a>00743               libmesh_assert (<a class="code" href="classlibMesh_1_1Xdr.php#a1cc9cc60e3a68f70cd35bc7528408fd6">out</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classlibMesh_1_1Xdr.php#a1cc9cc60e3a68f70cd35bc7528408fd6">out</a>-&gt;good());
<a name="l00744"></a>00744               OFSRealscientific(*<a class="code" href="classlibMesh_1_1Xdr.php#a1cc9cc60e3a68f70cd35bc7528408fd6">out</a>,17,val[i]) &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l00745"></a>00745             }
<a name="l00746"></a>00746         <span class="keywordflow">else</span>
<a name="l00747"></a>00747           {
<a name="l00748"></a>00748             <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> cnt=0;
<a name="l00749"></a>00749             <span class="keywordflow">while</span> (cnt &lt; len)
<a name="l00750"></a>00750               {
<a name="l00751"></a>00751                 <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(line_break,len); i++)
<a name="l00752"></a>00752                   {
<a name="l00753"></a>00753                     libmesh_assert (<a class="code" href="classlibMesh_1_1Xdr.php#a1cc9cc60e3a68f70cd35bc7528408fd6">out</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classlibMesh_1_1Xdr.php#a1cc9cc60e3a68f70cd35bc7528408fd6">out</a>-&gt;good());
<a name="l00754"></a>00754                     OFSRealscientific(*<a class="code" href="classlibMesh_1_1Xdr.php#a1cc9cc60e3a68f70cd35bc7528408fd6">out</a>,17,val[cnt++]) &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l00755"></a>00755                   }
<a name="l00756"></a>00756                 libmesh_assert (<a class="code" href="classlibMesh_1_1Xdr.php#a1cc9cc60e3a68f70cd35bc7528408fd6">out</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classlibMesh_1_1Xdr.php#a1cc9cc60e3a68f70cd35bc7528408fd6">out</a>-&gt;good());
<a name="l00757"></a>00757                 *<a class="code" href="classlibMesh_1_1Xdr.php#a1cc9cc60e3a68f70cd35bc7528408fd6">out</a> &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l00758"></a>00758               }
<a name="l00759"></a>00759           }
<a name="l00760"></a>00760 
<a name="l00761"></a>00761         <span class="keywordflow">return</span>; 
<a name="l00762"></a>00762       }
<a name="l00763"></a>00763 
<a name="l00764"></a>00764     <span class="keywordflow">default</span>:
<a name="l00765"></a>00765       libmesh_error();
<a name="l00766"></a>00766     }
<a name="l00767"></a>00767 }
<a name="l00768"></a>00768 
<a name="l00769"></a>00769 
<a name="l00770"></a>00770 <span class="keyword">template</span> &lt;&gt;
<a name="l00771"></a><a class="code" href="classlibMesh_1_1Xdr.php#ad71bb62a4c5e90b243433426ba79b00a">00771</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Xdr.php#a89f1c1a65390d6e3d168b5273913154c">Xdr::data_stream</a> (<span class="keywordtype">float</span> *val, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> len, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> line_break)
<a name="l00772"></a>00772 {
<a name="l00773"></a>00773   <span class="keywordflow">switch</span> (<a class="code" href="classlibMesh_1_1Xdr.php#a6a8c422d1ff20293804d45ae6ce8efd8">mode</a>)
<a name="l00774"></a>00774     {
<a name="l00775"></a>00775     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8ae5559170d41d912b449375bb4e3468f6">ENCODE</a>:
<a name="l00776"></a>00776     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a2632308739033bf9f82ea90cdf92231e">DECODE</a>:
<a name="l00777"></a>00777       {
<a name="l00778"></a>00778 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l00779"></a>00779 <span class="preprocessor"></span>
<a name="l00780"></a>00780         libmesh_assert (this-&gt;<a class="code" href="classlibMesh_1_1Xdr.php#a065c4f3b76dccf8e30cd735d78394c64">is_open</a>());
<a name="l00781"></a>00781 
<a name="l00782"></a>00782         <span class="comment">// FIXME[RHS]: How to implement this for float?  I don&#39;t know</span>
<a name="l00783"></a>00783         <span class="comment">// enough about xdr or have the time.  We&#39;ll error out for</span>
<a name="l00784"></a>00784         <span class="comment">// now, and anyone who needs the functionality can send me a</span>
<a name="l00785"></a>00785         <span class="comment">// patch.  ;-)</span>
<a name="l00786"></a>00786 
<a name="l00787"></a>00787         <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Writing binary XDR files with single precision is not\n&quot;</span>
<a name="l00788"></a>00788                       &lt;&lt; <span class="stringliteral">&quot;currently supported.&quot;</span> &lt;&lt; std::endl;
<a name="l00789"></a>00789 
<a name="l00790"></a>00790         libmesh_error();
<a name="l00791"></a>00791         
<a name="l00792"></a>00792 <span class="preprocessor">#else</span>
<a name="l00793"></a>00793 <span class="preprocessor"></span>        
<a name="l00794"></a>00794         <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Functionality is not available.&quot;</span> &lt;&lt; std::endl
<a name="l00795"></a>00795                       &lt;&lt; <span class="stringliteral">&quot;Make sure LIBMESH_HAVE_XDR is defined at build time&quot;</span> 
<a name="l00796"></a>00796                       &lt;&lt; std::endl
<a name="l00797"></a>00797                       &lt;&lt; <span class="stringliteral">&quot;The XDR interface is not available in this installation&quot;</span>
<a name="l00798"></a>00798                       &lt;&lt; std::endl;
<a name="l00799"></a>00799 
<a name="l00800"></a>00800         libmesh_error();
<a name="l00801"></a>00801 
<a name="l00802"></a>00802 <span class="preprocessor">#endif</span>
<a name="l00803"></a>00803 <span class="preprocessor"></span>        <span class="keywordflow">return</span>;
<a name="l00804"></a>00804       }
<a name="l00805"></a>00805 
<a name="l00806"></a>00806     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8acd5c7906bd7fea7650acc4c8cde09d48">READ</a>:
<a name="l00807"></a>00807       {
<a name="l00808"></a>00808         libmesh_assert (<a class="code" href="classlibMesh_1_1Xdr.php#a90dea8073f1a0d8d0315c22fd408e7ec">in</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classlibMesh_1_1Xdr.php#a90dea8073f1a0d8d0315c22fd408e7ec">in</a>-&gt;good());
<a name="l00809"></a>00809 
<a name="l00810"></a>00810         <span class="comment">// FIXME[RHS]: Not sure if this will work properly...</span>
<a name="l00811"></a>00811         libmesh_experimental();
<a name="l00812"></a>00812 
<a name="l00813"></a>00813         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;len; i++)
<a name="l00814"></a>00814           {
<a name="l00815"></a>00815             libmesh_assert (<a class="code" href="classlibMesh_1_1Xdr.php#a90dea8073f1a0d8d0315c22fd408e7ec">in</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classlibMesh_1_1Xdr.php#a90dea8073f1a0d8d0315c22fd408e7ec">in</a>-&gt;good());
<a name="l00816"></a>00816             *<a class="code" href="classlibMesh_1_1Xdr.php#a90dea8073f1a0d8d0315c22fd408e7ec">in</a> &gt;&gt; val[i];
<a name="l00817"></a>00817           }
<a name="l00818"></a>00818 
<a name="l00819"></a>00819         <span class="keywordflow">return</span>; 
<a name="l00820"></a>00820       }
<a name="l00821"></a>00821 
<a name="l00822"></a>00822     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a47f4bcd4fcf418da5ec74d3d8e2c3bc4">WRITE</a>:
<a name="l00823"></a>00823       {
<a name="l00824"></a>00824         libmesh_assert (<a class="code" href="classlibMesh_1_1Xdr.php#a1cc9cc60e3a68f70cd35bc7528408fd6">out</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classlibMesh_1_1Xdr.php#a1cc9cc60e3a68f70cd35bc7528408fd6">out</a>-&gt;good());
<a name="l00825"></a>00825 
<a name="l00826"></a>00826         <span class="keywordflow">if</span> (line_break == <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>)
<a name="l00827"></a>00827           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;len; i++)
<a name="l00828"></a>00828             {
<a name="l00829"></a>00829               libmesh_assert (<a class="code" href="classlibMesh_1_1Xdr.php#a1cc9cc60e3a68f70cd35bc7528408fd6">out</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classlibMesh_1_1Xdr.php#a1cc9cc60e3a68f70cd35bc7528408fd6">out</a>-&gt;good());
<a name="l00830"></a>00830               OFSRealscientific(*<a class="code" href="classlibMesh_1_1Xdr.php#a1cc9cc60e3a68f70cd35bc7528408fd6">out</a>,17,val[i]) &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l00831"></a>00831             }
<a name="l00832"></a>00832         <span class="keywordflow">else</span>
<a name="l00833"></a>00833           {
<a name="l00834"></a>00834             <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> cnt=0;
<a name="l00835"></a>00835             <span class="keywordflow">while</span> (cnt &lt; len)
<a name="l00836"></a>00836               {
<a name="l00837"></a>00837                 <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(line_break,len); i++)
<a name="l00838"></a>00838                   {
<a name="l00839"></a>00839                     libmesh_assert (<a class="code" href="classlibMesh_1_1Xdr.php#a1cc9cc60e3a68f70cd35bc7528408fd6">out</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classlibMesh_1_1Xdr.php#a1cc9cc60e3a68f70cd35bc7528408fd6">out</a>-&gt;good());
<a name="l00840"></a>00840                     OFSRealscientific(*<a class="code" href="classlibMesh_1_1Xdr.php#a1cc9cc60e3a68f70cd35bc7528408fd6">out</a>,17,val[cnt++]) &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l00841"></a>00841                   }
<a name="l00842"></a>00842                 libmesh_assert (<a class="code" href="classlibMesh_1_1Xdr.php#a1cc9cc60e3a68f70cd35bc7528408fd6">out</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classlibMesh_1_1Xdr.php#a1cc9cc60e3a68f70cd35bc7528408fd6">out</a>-&gt;good());
<a name="l00843"></a>00843                 *<a class="code" href="classlibMesh_1_1Xdr.php#a1cc9cc60e3a68f70cd35bc7528408fd6">out</a> &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l00844"></a>00844               }
<a name="l00845"></a>00845           }
<a name="l00846"></a>00846 
<a name="l00847"></a>00847         <span class="keywordflow">return</span>; 
<a name="l00848"></a>00848       }
<a name="l00849"></a>00849 
<a name="l00850"></a>00850     <span class="keywordflow">default</span>:
<a name="l00851"></a>00851       libmesh_error();
<a name="l00852"></a>00852     }
<a name="l00853"></a>00853 }
<a name="l00854"></a>00854 <span class="keyword">template</span> &lt;&gt;
<a name="l00855"></a><a class="code" href="classlibMesh_1_1Xdr.php#af6ad7c03df2d80bb1619820844de6406">00855</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Xdr.php#a89f1c1a65390d6e3d168b5273913154c">Xdr::data_stream</a> (<span class="keywordtype">long</span> <span class="keywordtype">double</span> *val, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> len, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> line_break)
<a name="l00856"></a>00856 {
<a name="l00857"></a>00857   <span class="keywordflow">switch</span> (<a class="code" href="classlibMesh_1_1Xdr.php#a6a8c422d1ff20293804d45ae6ce8efd8">mode</a>)
<a name="l00858"></a>00858     {
<a name="l00859"></a>00859     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8ae5559170d41d912b449375bb4e3468f6">ENCODE</a>:
<a name="l00860"></a>00860     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a2632308739033bf9f82ea90cdf92231e">DECODE</a>:
<a name="l00861"></a>00861       {
<a name="l00862"></a>00862 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l00863"></a>00863 <span class="preprocessor"></span>
<a name="l00864"></a>00864         libmesh_assert (this-&gt;<a class="code" href="classlibMesh_1_1Xdr.php#a065c4f3b76dccf8e30cd735d78394c64">is_open</a>());
<a name="l00865"></a>00865 
<a name="l00866"></a>00866         <span class="comment">// FIXME[JWP]: How to implement this for long double?  Mac OS</span>
<a name="l00867"></a>00867         <span class="comment">// X defines &#39;xdr_quadruple&#39; but AFAICT, it does not exist for</span>
<a name="l00868"></a>00868         <span class="comment">// Linux... for now, reading/writing XDR files with long</span>
<a name="l00869"></a>00869         <span class="comment">// doubles is disabled, but you can still write long double</span>
<a name="l00870"></a>00870         <span class="comment">// ASCII files of course.</span>
<a name="l00871"></a>00871         <span class="comment">// if (len &gt; 0)</span>
<a name="l00872"></a>00872         <span class="comment">//   xdr_vector(xdrs, </span>
<a name="l00873"></a>00873         <span class="comment">//           (char*) val,</span>
<a name="l00874"></a>00874         <span class="comment">//           len,</span>
<a name="l00875"></a>00875         <span class="comment">//           sizeof(double),</span>
<a name="l00876"></a>00876         <span class="comment">//           (xdrproc_t) xdr_quadruple);</span>
<a name="l00877"></a>00877 
<a name="l00878"></a>00878         <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Writing binary XDR files with long double&#39;s is not\n&quot;</span>
<a name="l00879"></a>00879                       &lt;&lt; <span class="stringliteral">&quot;currently supported on all platforms.&quot;</span> &lt;&lt; std::endl;
<a name="l00880"></a>00880 
<a name="l00881"></a>00881         libmesh_error();
<a name="l00882"></a>00882         
<a name="l00883"></a>00883 <span class="preprocessor">#else</span>
<a name="l00884"></a>00884 <span class="preprocessor"></span>        
<a name="l00885"></a>00885         <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Functionality is not available.&quot;</span> &lt;&lt; std::endl
<a name="l00886"></a>00886                       &lt;&lt; <span class="stringliteral">&quot;Make sure LIBMESH_HAVE_XDR is defined at build time&quot;</span> 
<a name="l00887"></a>00887                       &lt;&lt; std::endl
<a name="l00888"></a>00888                       &lt;&lt; <span class="stringliteral">&quot;The XDR interface is not available in this installation&quot;</span>
<a name="l00889"></a>00889                       &lt;&lt; std::endl;
<a name="l00890"></a>00890 
<a name="l00891"></a>00891         libmesh_error();
<a name="l00892"></a>00892 
<a name="l00893"></a>00893 <span class="preprocessor">#endif</span>
<a name="l00894"></a>00894 <span class="preprocessor"></span>        <span class="keywordflow">return</span>;
<a name="l00895"></a>00895       }
<a name="l00896"></a>00896 
<a name="l00897"></a>00897     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8acd5c7906bd7fea7650acc4c8cde09d48">READ</a>:
<a name="l00898"></a>00898       {
<a name="l00899"></a>00899         libmesh_assert (<a class="code" href="classlibMesh_1_1Xdr.php#a90dea8073f1a0d8d0315c22fd408e7ec">in</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classlibMesh_1_1Xdr.php#a90dea8073f1a0d8d0315c22fd408e7ec">in</a>-&gt;good());
<a name="l00900"></a>00900 
<a name="l00901"></a>00901         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;len; i++)
<a name="l00902"></a>00902           {
<a name="l00903"></a>00903             libmesh_assert (<a class="code" href="classlibMesh_1_1Xdr.php#a90dea8073f1a0d8d0315c22fd408e7ec">in</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classlibMesh_1_1Xdr.php#a90dea8073f1a0d8d0315c22fd408e7ec">in</a>-&gt;good());
<a name="l00904"></a>00904             *<a class="code" href="classlibMesh_1_1Xdr.php#a90dea8073f1a0d8d0315c22fd408e7ec">in</a> &gt;&gt; val[i];
<a name="l00905"></a>00905           }
<a name="l00906"></a>00906 
<a name="l00907"></a>00907         <span class="keywordflow">return</span>; 
<a name="l00908"></a>00908       }
<a name="l00909"></a>00909 
<a name="l00910"></a>00910     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a47f4bcd4fcf418da5ec74d3d8e2c3bc4">WRITE</a>:
<a name="l00911"></a>00911       {
<a name="l00912"></a>00912         libmesh_assert (<a class="code" href="classlibMesh_1_1Xdr.php#a1cc9cc60e3a68f70cd35bc7528408fd6">out</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classlibMesh_1_1Xdr.php#a1cc9cc60e3a68f70cd35bc7528408fd6">out</a>-&gt;good());
<a name="l00913"></a>00913 
<a name="l00914"></a>00914         <span class="keywordflow">if</span> (line_break == <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>)
<a name="l00915"></a>00915           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;len; i++)
<a name="l00916"></a>00916             {
<a name="l00917"></a>00917               libmesh_assert (<a class="code" href="classlibMesh_1_1Xdr.php#a1cc9cc60e3a68f70cd35bc7528408fd6">out</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classlibMesh_1_1Xdr.php#a1cc9cc60e3a68f70cd35bc7528408fd6">out</a>-&gt;good());
<a name="l00918"></a>00918               OFSRealscientific(*<a class="code" href="classlibMesh_1_1Xdr.php#a1cc9cc60e3a68f70cd35bc7528408fd6">out</a>,17,val[i]) &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l00919"></a>00919             }
<a name="l00920"></a>00920         <span class="keywordflow">else</span>
<a name="l00921"></a>00921           {
<a name="l00922"></a>00922             <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> cnt=0;
<a name="l00923"></a>00923             <span class="keywordflow">while</span> (cnt &lt; len)
<a name="l00924"></a>00924               {
<a name="l00925"></a>00925                 <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(line_break,len); i++)
<a name="l00926"></a>00926                   {
<a name="l00927"></a>00927                     libmesh_assert (<a class="code" href="classlibMesh_1_1Xdr.php#a1cc9cc60e3a68f70cd35bc7528408fd6">out</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classlibMesh_1_1Xdr.php#a1cc9cc60e3a68f70cd35bc7528408fd6">out</a>-&gt;good());
<a name="l00928"></a>00928                     OFSRealscientific(*<a class="code" href="classlibMesh_1_1Xdr.php#a1cc9cc60e3a68f70cd35bc7528408fd6">out</a>,17,val[cnt++]) &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l00929"></a>00929                   }
<a name="l00930"></a>00930                 libmesh_assert (<a class="code" href="classlibMesh_1_1Xdr.php#a1cc9cc60e3a68f70cd35bc7528408fd6">out</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classlibMesh_1_1Xdr.php#a1cc9cc60e3a68f70cd35bc7528408fd6">out</a>-&gt;good());
<a name="l00931"></a>00931                 *<a class="code" href="classlibMesh_1_1Xdr.php#a1cc9cc60e3a68f70cd35bc7528408fd6">out</a> &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l00932"></a>00932               }
<a name="l00933"></a>00933           }
<a name="l00934"></a>00934 
<a name="l00935"></a>00935         <span class="keywordflow">return</span>; 
<a name="l00936"></a>00936       }
<a name="l00937"></a>00937 
<a name="l00938"></a>00938     <span class="keywordflow">default</span>:
<a name="l00939"></a>00939       libmesh_error();
<a name="l00940"></a>00940     }
<a name="l00941"></a>00941 }
<a name="l00942"></a>00942 
<a name="l00943"></a>00943 
<a name="l00944"></a>00944 <span class="preprocessor">#ifdef LIBMESH_USE_COMPLEX_NUMBERS</span>
<a name="l00945"></a>00945 <span class="preprocessor"></span><span class="keyword">template</span> &lt;&gt;
<a name="l00946"></a><a class="code" href="classlibMesh_1_1Xdr.php#a62046234da3cadf680b5216f5ab1e894">00946</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Xdr.php#a89f1c1a65390d6e3d168b5273913154c">Xdr::data_stream</a> (std::complex&lt;double&gt; *val, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> len, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> line_break)
<a name="l00947"></a>00947 {
<a name="l00948"></a>00948   <span class="keywordflow">switch</span> (<a class="code" href="classlibMesh_1_1Xdr.php#a6a8c422d1ff20293804d45ae6ce8efd8">mode</a>)
<a name="l00949"></a>00949     {
<a name="l00950"></a>00950     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8ae5559170d41d912b449375bb4e3468f6">ENCODE</a>:
<a name="l00951"></a>00951     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a2632308739033bf9f82ea90cdf92231e">DECODE</a>:
<a name="l00952"></a>00952       {
<a name="l00953"></a>00953 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l00954"></a>00954 <span class="preprocessor"></span>
<a name="l00955"></a>00955         libmesh_assert (this-&gt;<a class="code" href="classlibMesh_1_1Xdr.php#a065c4f3b76dccf8e30cd735d78394c64">is_open</a>());
<a name="l00956"></a>00956 
<a name="l00957"></a>00957 
<a name="l00958"></a>00958         <span class="keywordflow">if</span> (len &gt; 0)
<a name="l00959"></a>00959           {
<a name="l00960"></a>00960             std::vector&lt;double&gt; io_buffer (2*len);
<a name="l00961"></a>00961             
<a name="l00962"></a>00962             <span class="comment">// Fill io_buffer if we are writing.</span>
<a name="l00963"></a>00963             <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1Xdr.php#a6a8c422d1ff20293804d45ae6ce8efd8">mode</a> == <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8ae5559170d41d912b449375bb4e3468f6">ENCODE</a>)
<a name="l00964"></a>00964               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0, cnt=0; i&lt;len; i++)
<a name="l00965"></a>00965                 {
<a name="l00966"></a>00966                   io_buffer[cnt++] = val[i].real();
<a name="l00967"></a>00967                   io_buffer[cnt++] = val[i].imag();
<a name="l00968"></a>00968                 } 
<a name="l00969"></a>00969               
<a name="l00970"></a>00970             xdr_vector(<a class="code" href="classlibMesh_1_1Xdr.php#a21085b5edf0f8e659840649437da98e8">xdrs</a>, 
<a name="l00971"></a>00971                        (<span class="keywordtype">char</span>*) &amp;io_buffer[0],
<a name="l00972"></a>00972                        2*len,
<a name="l00973"></a>00973                        <span class="keyword">sizeof</span>(<span class="keywordtype">double</span>),
<a name="l00974"></a>00974                        (xdrproc_t) xdr_double);
<a name="l00975"></a>00975             
<a name="l00976"></a>00976             <span class="comment">// Fill val array if we are reading.</span>
<a name="l00977"></a>00977             <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1Xdr.php#a6a8c422d1ff20293804d45ae6ce8efd8">mode</a> == <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a2632308739033bf9f82ea90cdf92231e">DECODE</a>)
<a name="l00978"></a>00978               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0, cnt=0; i&lt;len; i++)
<a name="l00979"></a>00979                 {
<a name="l00980"></a>00980                   val[i].real() = io_buffer[cnt++];
<a name="l00981"></a>00981                   val[i].imag() = io_buffer[cnt++];
<a name="l00982"></a>00982                 } 
<a name="l00983"></a>00983           }
<a name="l00984"></a>00984 <span class="preprocessor">#else</span>
<a name="l00985"></a>00985 <span class="preprocessor"></span>        
<a name="l00986"></a>00986         <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Functionality is not available.&quot;</span> &lt;&lt; std::endl
<a name="l00987"></a>00987                       &lt;&lt; <span class="stringliteral">&quot;Make sure LIBMESH_HAVE_XDR is defined at build time&quot;</span> 
<a name="l00988"></a>00988                       &lt;&lt; std::endl
<a name="l00989"></a>00989                       &lt;&lt; <span class="stringliteral">&quot;The XDR interface is not available in this installation&quot;</span>
<a name="l00990"></a>00990                       &lt;&lt; std::endl;
<a name="l00991"></a>00991 
<a name="l00992"></a>00992         libmesh_error();
<a name="l00993"></a>00993 
<a name="l00994"></a>00994 <span class="preprocessor">#endif</span>
<a name="l00995"></a>00995 <span class="preprocessor"></span>        <span class="keywordflow">return</span>;
<a name="l00996"></a>00996       }
<a name="l00997"></a>00997 
<a name="l00998"></a>00998     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8acd5c7906bd7fea7650acc4c8cde09d48">READ</a>:
<a name="l00999"></a>00999       {
<a name="l01000"></a>01000         libmesh_assert (<a class="code" href="classlibMesh_1_1Xdr.php#a90dea8073f1a0d8d0315c22fd408e7ec">in</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classlibMesh_1_1Xdr.php#a90dea8073f1a0d8d0315c22fd408e7ec">in</a>-&gt;good());
<a name="l01001"></a>01001 
<a name="l01002"></a>01002         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;len; i++)
<a name="l01003"></a>01003           {
<a name="l01004"></a>01004             libmesh_assert (<a class="code" href="classlibMesh_1_1Xdr.php#a90dea8073f1a0d8d0315c22fd408e7ec">in</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classlibMesh_1_1Xdr.php#a90dea8073f1a0d8d0315c22fd408e7ec">in</a>-&gt;good());
<a name="l01005"></a>01005             *<a class="code" href="classlibMesh_1_1Xdr.php#a90dea8073f1a0d8d0315c22fd408e7ec">in</a> &gt;&gt; val[i].real() &gt;&gt; val[i].imag();
<a name="l01006"></a>01006           }
<a name="l01007"></a>01007 
<a name="l01008"></a>01008         <span class="keywordflow">return</span>; 
<a name="l01009"></a>01009       }
<a name="l01010"></a>01010 
<a name="l01011"></a>01011     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a47f4bcd4fcf418da5ec74d3d8e2c3bc4">WRITE</a>:
<a name="l01012"></a>01012       {
<a name="l01013"></a>01013         libmesh_assert (<a class="code" href="classlibMesh_1_1Xdr.php#a1cc9cc60e3a68f70cd35bc7528408fd6">out</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classlibMesh_1_1Xdr.php#a1cc9cc60e3a68f70cd35bc7528408fd6">out</a>-&gt;good());
<a name="l01014"></a>01014 
<a name="l01015"></a>01015         <span class="keywordflow">if</span> (line_break == <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>)
<a name="l01016"></a>01016           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;len; i++)
<a name="l01017"></a>01017             {
<a name="l01018"></a>01018               libmesh_assert (<a class="code" href="classlibMesh_1_1Xdr.php#a1cc9cc60e3a68f70cd35bc7528408fd6">out</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classlibMesh_1_1Xdr.php#a1cc9cc60e3a68f70cd35bc7528408fd6">out</a>-&gt;good());
<a name="l01019"></a>01019               OFSRealscientific(*<a class="code" href="classlibMesh_1_1Xdr.php#a1cc9cc60e3a68f70cd35bc7528408fd6">out</a>,17,val[i].real()) &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l01020"></a>01020               OFSRealscientific(*<a class="code" href="classlibMesh_1_1Xdr.php#a1cc9cc60e3a68f70cd35bc7528408fd6">out</a>,17,val[i].imag()) &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l01021"></a>01021             }
<a name="l01022"></a>01022         <span class="keywordflow">else</span>
<a name="l01023"></a>01023           {
<a name="l01024"></a>01024             <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> cnt=0;
<a name="l01025"></a>01025             <span class="keywordflow">while</span> (cnt &lt; len)
<a name="l01026"></a>01026               {
<a name="l01027"></a>01027                 <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(line_break,len); i++)
<a name="l01028"></a>01028                   {
<a name="l01029"></a>01029                     libmesh_assert (<a class="code" href="classlibMesh_1_1Xdr.php#a1cc9cc60e3a68f70cd35bc7528408fd6">out</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classlibMesh_1_1Xdr.php#a1cc9cc60e3a68f70cd35bc7528408fd6">out</a>-&gt;good());
<a name="l01030"></a>01030                     OFSRealscientific(*<a class="code" href="classlibMesh_1_1Xdr.php#a1cc9cc60e3a68f70cd35bc7528408fd6">out</a>,17,val[cnt].real()) &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l01031"></a>01031                     OFSRealscientific(*<a class="code" href="classlibMesh_1_1Xdr.php#a1cc9cc60e3a68f70cd35bc7528408fd6">out</a>,17,val[cnt].imag()) &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l01032"></a>01032                     cnt++;
<a name="l01033"></a>01033                   }
<a name="l01034"></a>01034                 libmesh_assert (<a class="code" href="classlibMesh_1_1Xdr.php#a1cc9cc60e3a68f70cd35bc7528408fd6">out</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classlibMesh_1_1Xdr.php#a1cc9cc60e3a68f70cd35bc7528408fd6">out</a>-&gt;good());
<a name="l01035"></a>01035                 *<a class="code" href="classlibMesh_1_1Xdr.php#a1cc9cc60e3a68f70cd35bc7528408fd6">out</a> &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l01036"></a>01036               }
<a name="l01037"></a>01037           }
<a name="l01038"></a>01038 
<a name="l01039"></a>01039         <span class="keywordflow">return</span>; 
<a name="l01040"></a>01040       }
<a name="l01041"></a>01041 
<a name="l01042"></a>01042     <span class="keywordflow">default</span>:
<a name="l01043"></a>01043       libmesh_error();
<a name="l01044"></a>01044     }
<a name="l01045"></a>01045 }
<a name="l01046"></a>01046 <span class="preprocessor">#endif // # LIBMESH_USE_COMPLEX_NUMBERS</span>
<a name="l01047"></a>01047 <span class="preprocessor"></span>
<a name="l01048"></a><a class="code" href="classlibMesh_1_1Xdr.php#a9d15d2f6ba8a973de45a86402a22a059">01048</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Xdr.php#a9d15d2f6ba8a973de45a86402a22a059">Xdr::comment</a> (std::string &amp;comment)
<a name="l01049"></a>01049 {
<a name="l01050"></a>01050   <span class="keywordflow">switch</span> (<a class="code" href="classlibMesh_1_1Xdr.php#a6a8c422d1ff20293804d45ae6ce8efd8">mode</a>)
<a name="l01051"></a>01051     {
<a name="l01052"></a>01052     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8ae5559170d41d912b449375bb4e3468f6">ENCODE</a>:
<a name="l01053"></a>01053     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a2632308739033bf9f82ea90cdf92231e">DECODE</a>:
<a name="l01054"></a>01054       {
<a name="l01055"></a>01055         <span class="keywordflow">return</span>;
<a name="l01056"></a>01056       }
<a name="l01057"></a>01057 
<a name="l01058"></a>01058     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8acd5c7906bd7fea7650acc4c8cde09d48">READ</a>:
<a name="l01059"></a>01059       {
<a name="l01060"></a>01060         libmesh_assert (<a class="code" href="classlibMesh_1_1Xdr.php#a90dea8073f1a0d8d0315c22fd408e7ec">in</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classlibMesh_1_1Xdr.php#a90dea8073f1a0d8d0315c22fd408e7ec">in</a>-&gt;good());
<a name="l01061"></a>01061         <a class="code" href="classlibMesh_1_1Xdr.php#a90dea8073f1a0d8d0315c22fd408e7ec">in</a>-&gt;getline(<a class="code" href="classlibMesh_1_1Xdr.php#a5fcf1760d922e948634032ee556e8277">comm</a>, <a class="code" href="classlibMesh_1_1Xdr.php#a5254e6bf8f5faad6b858e258e497ba6e">comm_len</a>);
<a name="l01062"></a>01062         <span class="keywordflow">return</span>; 
<a name="l01063"></a>01063       }
<a name="l01064"></a>01064 
<a name="l01065"></a>01065     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a47f4bcd4fcf418da5ec74d3d8e2c3bc4">WRITE</a>:
<a name="l01066"></a>01066       {
<a name="l01067"></a>01067         libmesh_assert (<a class="code" href="classlibMesh_1_1Xdr.php#a1cc9cc60e3a68f70cd35bc7528408fd6">out</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classlibMesh_1_1Xdr.php#a1cc9cc60e3a68f70cd35bc7528408fd6">out</a>-&gt;good());
<a name="l01068"></a>01068         *<a class="code" href="classlibMesh_1_1Xdr.php#a1cc9cc60e3a68f70cd35bc7528408fd6">out</a> &lt;&lt; <span class="stringliteral">&quot;\t &quot;</span> &lt;&lt; comment &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l01069"></a>01069         <span class="keywordflow">return</span>; 
<a name="l01070"></a>01070       }
<a name="l01071"></a>01071 
<a name="l01072"></a>01072     <span class="keywordflow">default</span>:
<a name="l01073"></a>01073       libmesh_error();
<a name="l01074"></a>01074     }
<a name="l01075"></a>01075 }
<a name="l01076"></a>01076 
<a name="l01077"></a>01077 
<a name="l01078"></a>01078 <span class="preprocessor">#undef xdr_REAL</span>
<a name="l01079"></a>01079 <span class="preprocessor"></span>
<a name="l01080"></a>01080 
<a name="l01081"></a>01081 <span class="comment">//</span>
<a name="l01082"></a>01082 <span class="keyword">template</span> <span class="keywordtype">void</span> Xdr::data&lt;int&gt;                              (<span class="keywordtype">int</span>&amp;,                             <span class="keyword">const</span> <span class="keywordtype">char</span>*);
<a name="l01083"></a>01083 <span class="keyword">template</span> <span class="keywordtype">void</span> Xdr::data&lt;unsigned int&gt;                     (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&amp;,                    <span class="keyword">const</span> <span class="keywordtype">char</span>*);
<a name="l01084"></a>01084 <span class="keyword">template</span> <span class="keywordtype">void</span> Xdr::data&lt;unsigned short int&gt;               (<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span>&amp;,              <span class="keyword">const</span> <span class="keywordtype">char</span>*);
<a name="l01085"></a>01085 <span class="keyword">template</span> <span class="keywordtype">void</span> Xdr::data&lt;short int&gt;                        (<span class="keywordtype">short</span> <span class="keywordtype">int</span>&amp;,                       <span class="keyword">const</span> <span class="keywordtype">char</span>*);
<a name="l01086"></a>01086 <span class="keyword">template</span> <span class="keywordtype">void</span> Xdr::data&lt;float&gt;                            (<span class="keywordtype">float</span>&amp;,                           <span class="keyword">const</span> <span class="keywordtype">char</span>*);
<a name="l01087"></a>01087 <span class="keyword">template</span> <span class="keywordtype">void</span> Xdr::data&lt;double&gt;                           (<span class="keywordtype">double</span>&amp;,                          <span class="keyword">const</span> <span class="keywordtype">char</span>*);
<a name="l01088"></a>01088 <span class="keyword">template</span> <span class="keywordtype">void</span> Xdr::data&lt;long double&gt;                      (<span class="keywordtype">long</span> <span class="keywordtype">double</span>&amp;,                     <span class="keyword">const</span> <span class="keywordtype">char</span>*);
<a name="l01089"></a>01089 <span class="keyword">template</span> <span class="keywordtype">void</span> Xdr::data&lt;std::complex&lt;float&gt; &gt;             (std::complex&lt;float&gt;&amp;,             <span class="keyword">const</span> <span class="keywordtype">char</span>*);
<a name="l01090"></a>01090 <span class="keyword">template</span> <span class="keywordtype">void</span> Xdr::data&lt;std::complex&lt;double&gt; &gt;            (std::complex&lt;double&gt;&amp;,            <span class="keyword">const</span> <span class="keywordtype">char</span>*);
<a name="l01091"></a>01091 <span class="keyword">template</span> <span class="keywordtype">void</span> Xdr::data&lt;std::complex&lt;long double&gt; &gt;       (std::complex&lt;long double&gt;&amp;,       <span class="keyword">const</span> <span class="keywordtype">char</span>*);
<a name="l01092"></a>01092 <span class="keyword">template</span> <span class="keywordtype">void</span> Xdr::data&lt;std::string&gt;                      (std::string&amp;,                     <span class="keyword">const</span> <span class="keywordtype">char</span>*);
<a name="l01093"></a>01093 <span class="keyword">template</span> <span class="keywordtype">void</span> Xdr::data&lt;std::vector&lt;int&gt; &gt;                (std::vector&lt;int&gt;&amp;,                <span class="keyword">const</span> <span class="keywordtype">char</span>*);
<a name="l01094"></a>01094 <span class="keyword">template</span> <span class="keywordtype">void</span> Xdr::data&lt;std::vector&lt;unsigned int&gt; &gt;       (std::vector&lt;unsigned int&gt;&amp;,       <span class="keyword">const</span> <span class="keywordtype">char</span>*);
<a name="l01095"></a>01095 <span class="keyword">template</span> <span class="keywordtype">void</span> Xdr::data&lt;std::vector&lt;short int&gt; &gt;          (std::vector&lt;short int&gt;&amp;,          <span class="keyword">const</span> <span class="keywordtype">char</span>*);
<a name="l01096"></a>01096 <span class="keyword">template</span> <span class="keywordtype">void</span> Xdr::data&lt;std::vector&lt;unsigned short int&gt; &gt; (std::vector&lt;unsigned short int&gt;&amp;, <span class="keyword">const</span> <span class="keywordtype">char</span>*);
<a name="l01097"></a>01097 <span class="keyword">template</span> <span class="keywordtype">void</span> Xdr::data&lt;std::vector&lt;float&gt; &gt;              (std::vector&lt;float&gt;&amp;,              <span class="keyword">const</span> <span class="keywordtype">char</span>*);
<a name="l01098"></a>01098 <span class="keyword">template</span> <span class="keywordtype">void</span> Xdr::data&lt;std::vector&lt;double&gt; &gt;             (std::vector&lt;double&gt;&amp;,             <span class="keyword">const</span> <span class="keywordtype">char</span>*);
<a name="l01099"></a>01099 <span class="keyword">template</span> <span class="keywordtype">void</span> Xdr::data&lt;std::vector&lt;long double&gt; &gt;        (std::vector&lt;long double&gt;&amp;,        <span class="keyword">const</span> <span class="keywordtype">char</span>*);
<a name="l01100"></a>01100 <span class="keyword">template</span> <span class="keywordtype">void</span> Xdr::data&lt;std::vector&lt;std::complex&lt;float&gt; &gt; &gt;  (std::vector&lt;std::complex&lt;float&gt; &gt;&amp;,  <span class="keyword">const</span> <span class="keywordtype">char</span>*);
<a name="l01101"></a>01101 <span class="keyword">template</span> <span class="keywordtype">void</span> Xdr::data&lt;std::vector&lt;std::complex&lt;double&gt; &gt; &gt; (std::vector&lt;std::complex&lt;double&gt; &gt;&amp;, <span class="keyword">const</span> <span class="keywordtype">char</span>*);
<a name="l01102"></a>01102 <span class="keyword">template</span> <span class="keywordtype">void</span> Xdr::data&lt;std::vector&lt;std::complex&lt;long double&gt; &gt; &gt; (std::vector&lt;std::complex&lt;long double&gt; &gt;&amp;, <span class="keyword">const</span> <span class="keywordtype">char</span>*);
<a name="l01103"></a>01103 <span class="keyword">template</span> <span class="keywordtype">void</span> Xdr::data_stream&lt;int&gt;          (<span class="keywordtype">int</span> *val,          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> len, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> line_break);
<a name="l01104"></a>01104 <span class="keyword">template</span> <span class="keywordtype">void</span> Xdr::data_stream&lt;unsigned int&gt; (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> *val, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> len, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> line_break);
<a name="l01105"></a>01105 
<a name="l01106"></a>01106 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
