<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_c3a49989e40b21e7508f29d2dc962def.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_06ddb1cadc4da963b880c5e33d5e51d4.php">base</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">dof_map.C</div>  </div>
</div>
<div class="contents">
<a href="dof__map_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id$</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public  License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// C++ Includes -------------------------------------</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &lt;set&gt;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &lt;algorithm&gt;</span> <span class="comment">// for std::fill, std::equal_range, std::max, std::lower_bound, etc.</span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// Local Includes -----------------------------------</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="coupling__matrix_8h.php">coupling_matrix.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="dense__matrix_8h.php">dense_matrix.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="dense__vector__base_8h.php">dense_vector_base.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="dof__map_8h.php">dof_map.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="elem_8h.php">elem.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="fe__interface_8h.php">fe_interface.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="fe__type_8h.php">fe_type.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="fe__base_8h.php">fe_base.h</a>&quot;</span> <span class="comment">// FEBase::build() for continuity test</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__logging_8h.php">libmesh_logging.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="mesh__base_8h.php">mesh_base.h</a>&quot;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;<a class="code" href="mesh__tools_8h.php">mesh_tools.h</a>&quot;</span>
<a name="l00038"></a>00038 <span class="preprocessor">#include &quot;<a class="code" href="numeric__vector_8h.php">numeric_vector.h</a>&quot;</span>
<a name="l00039"></a>00039 <span class="preprocessor">#include &quot;<a class="code" href="parallel_8h.php">parallel.h</a>&quot;</span>
<a name="l00040"></a>00040 <span class="preprocessor">#include &quot;<a class="code" href="periodic__boundaries_8h.php">periodic_boundaries.h</a>&quot;</span>
<a name="l00041"></a>00041 <span class="preprocessor">#include &quot;<a class="code" href="sparse__matrix_8h.php">sparse_matrix.h</a>&quot;</span>
<a name="l00042"></a>00042 <span class="preprocessor">#include &quot;<a class="code" href="sparsity__pattern_8h.php">sparsity_pattern.h</a>&quot;</span>
<a name="l00043"></a>00043 <span class="preprocessor">#include &quot;<a class="code" href="string__to__enum_8h.php">string_to_enum.h</a>&quot;</span>
<a name="l00044"></a>00044 <span class="preprocessor">#include &quot;<a class="code" href="threads_8h.php">threads.h</a>&quot;</span>
<a name="l00045"></a>00045 
<a name="l00046"></a>00046 
<a name="l00047"></a><a class="code" href="namespacelibMesh.php">00047</a> <span class="keyword">namespace </span>libMesh
<a name="l00048"></a>00048 {
<a name="l00049"></a>00049 
<a name="l00050"></a>00050 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00051"></a>00051 <span class="comment">// DofMap member functions</span>
<a name="l00052"></a>00052 
<a name="l00053"></a><a class="code" href="classlibMesh_1_1DofMap.php#a6fe401e7df6dfc21a89c528cd52515ac">00053</a> <a class="code" href="classlibMesh_1_1DofMap.php#a6fe401e7df6dfc21a89c528cd52515ac">DofMap::DofMap</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> number) :
<a name="l00054"></a>00054   _dof_coupling(NULL),
<a name="l00055"></a>00055   _sys_number(number),
<a name="l00056"></a>00056 <span class="comment">//  _matrix(NULL),</span>
<a name="l00057"></a>00057   _n_dfs(0),
<a name="l00058"></a>00058   _n_SCALAR_dofs(0)
<a name="l00059"></a>00059 #ifdef LIBMESH_ENABLE_AMR
<a name="l00060"></a>00060   , _n_old_dfs(0)
<a name="l00061"></a>00061 #endif
<a name="l00062"></a>00062 #ifdef LIBMESH_ENABLE_PERIODIC
<a name="l00063"></a>00063   , _periodic_boundaries(new <a class="code" href="classlibMesh_1_1PeriodicBoundaries.php">PeriodicBoundaries</a>)
<a name="l00064"></a>00064 #endif
<a name="l00065"></a>00065 {
<a name="l00066"></a>00066   <a class="code" href="classlibMesh_1_1DofMap.php#a29ff2098ced1859cd5296af428435d73">_matrices</a>.clear();
<a name="l00067"></a>00067 }
<a name="l00068"></a>00068 
<a name="l00069"></a>00069 
<a name="l00070"></a>00070 
<a name="l00071"></a>00071 <span class="comment">// Destructor</span>
<a name="l00072"></a><a class="code" href="classlibMesh_1_1DofMap.php#addb6136725455c3a28e17193d3edf7ee">00072</a> <a class="code" href="classlibMesh_1_1DofMap.php#addb6136725455c3a28e17193d3edf7ee">DofMap::~DofMap</a>()
<a name="l00073"></a>00073 {
<a name="l00074"></a>00074   this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#a480f80bc9234a5586711833b87a89784">clear</a>();
<a name="l00075"></a>00075 <span class="preprocessor">#ifdef LIBMESH_ENABLE_PERIODIC</span>
<a name="l00076"></a>00076 <span class="preprocessor"></span>  <span class="keyword">delete</span> <a class="code" href="classlibMesh_1_1DofMap.php#aa6cb04933a25a9b2a296e333a7ce3554">_periodic_boundaries</a>;
<a name="l00077"></a>00077 <span class="preprocessor">#endif</span>
<a name="l00078"></a>00078 <span class="preprocessor"></span>}
<a name="l00079"></a>00079 
<a name="l00080"></a>00080 
<a name="l00081"></a>00081 <span class="preprocessor">#ifdef LIBMESH_ENABLE_PERIODIC</span>
<a name="l00082"></a>00082 <span class="preprocessor"></span>
<a name="l00083"></a><a class="code" href="classlibMesh_1_1DofMap.php#a342c83f2e41c2ea88ff60644aa7f90f2">00083</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1DofMap.php#a342c83f2e41c2ea88ff60644aa7f90f2">DofMap::is_periodic_boundary</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> boundaryid)<span class="keyword"> const</span>
<a name="l00084"></a>00084 <span class="keyword"></span>{
<a name="l00085"></a>00085   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1DofMap.php#aa6cb04933a25a9b2a296e333a7ce3554">_periodic_boundaries</a>-&gt;count(boundaryid) != 0)
<a name="l00086"></a>00086     <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00087"></a>00087 
<a name="l00088"></a>00088   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00089"></a>00089 }
<a name="l00090"></a>00090 
<a name="l00091"></a>00091 <span class="preprocessor">#endif</span>
<a name="l00092"></a>00092 <span class="preprocessor"></span>
<a name="l00093"></a>00093 
<a name="l00094"></a>00094 
<a name="l00095"></a><a class="code" href="classlibMesh_1_1DofMap.php#a99bd5717524ac8156554650eac8d2c60">00095</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#a99bd5717524ac8156554650eac8d2c60">DofMap::add_variable</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Variable.php">Variable</a> &amp;var)
<a name="l00096"></a>00096 {
<a name="l00097"></a>00097   <a class="code" href="classlibMesh_1_1DofMap.php#a5232a8054e580a408f394ba1574c63df">_variables</a>.push_back (var);
<a name="l00098"></a>00098 }
<a name="l00099"></a>00099 
<a name="l00100"></a>00100 
<a name="l00101"></a>00101 
<a name="l00102"></a><a class="code" href="classlibMesh_1_1DofMap.php#ab36a0dc3c2c457fa8c01c1b0ba37facc">00102</a> <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Variable.php">Variable</a> &amp; <a class="code" href="classlibMesh_1_1DofMap.php#ab36a0dc3c2c457fa8c01c1b0ba37facc">DofMap::variable</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c)<span class="keyword"> const</span>
<a name="l00103"></a>00103 <span class="keyword"></span>{
<a name="l00104"></a>00104   libmesh_assert (c &lt; <a class="code" href="classlibMesh_1_1DofMap.php#a5232a8054e580a408f394ba1574c63df">_variables</a>.size());
<a name="l00105"></a>00105 
<a name="l00106"></a>00106   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1DofMap.php#a5232a8054e580a408f394ba1574c63df">_variables</a>[c];
<a name="l00107"></a>00107 }
<a name="l00108"></a>00108 
<a name="l00109"></a>00109 
<a name="l00110"></a>00110 
<a name="l00111"></a><a class="code" href="classlibMesh_1_1DofMap.php#a43aa131ac08b4b6aff6d865e672638da">00111</a> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> <a class="code" href="classlibMesh_1_1DofMap.php#a43aa131ac08b4b6aff6d865e672638da">DofMap::variable_order</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c)<span class="keyword"> const</span>
<a name="l00112"></a>00112 <span class="keyword"></span>{
<a name="l00113"></a>00113   libmesh_assert (c &lt; <a class="code" href="classlibMesh_1_1DofMap.php#a5232a8054e580a408f394ba1574c63df">_variables</a>.size());
<a name="l00114"></a>00114 
<a name="l00115"></a>00115   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1DofMap.php#a5232a8054e580a408f394ba1574c63df">_variables</a>[c].type().order;
<a name="l00116"></a>00116 }
<a name="l00117"></a>00117 
<a name="l00118"></a>00118 
<a name="l00119"></a>00119 
<a name="l00120"></a><a class="code" href="classlibMesh_1_1DofMap.php#a0c010bb250d4cd8d65794452f46d141a">00120</a> <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; <a class="code" href="classlibMesh_1_1DofMap.php#a0c010bb250d4cd8d65794452f46d141a">DofMap::variable_type</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c)<span class="keyword"> const</span>
<a name="l00121"></a>00121 <span class="keyword"></span>{
<a name="l00122"></a>00122   libmesh_assert (c &lt; <a class="code" href="classlibMesh_1_1DofMap.php#a5232a8054e580a408f394ba1574c63df">_variables</a>.size());
<a name="l00123"></a>00123 
<a name="l00124"></a>00124   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1DofMap.php#a5232a8054e580a408f394ba1574c63df">_variables</a>[c].type();
<a name="l00125"></a>00125 }
<a name="l00126"></a>00126 
<a name="l00127"></a>00127 
<a name="l00128"></a>00128 
<a name="l00129"></a><a class="code" href="classlibMesh_1_1DofMap.php#aa10200782a0f8fe0c4d3f7bdf10cedc6">00129</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#aa10200782a0f8fe0c4d3f7bdf10cedc6">DofMap::attach_matrix</a> (<a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;Number&gt;</a>&amp; matrix)
<a name="l00130"></a>00130 {
<a name="l00131"></a>00131   <a class="code" href="classlibMesh_1_1DofMap.php#a29ff2098ced1859cd5296af428435d73">_matrices</a>.push_back(&amp;matrix);
<a name="l00132"></a>00132   
<a name="l00133"></a>00133   matrix.<a class="code" href="classlibMesh_1_1SparseMatrix.php#a327789280fc9e054844455b212d143b4">attach_dof_map</a> (*<span class="keyword">this</span>);
<a name="l00134"></a>00134 }
<a name="l00135"></a>00135 
<a name="l00136"></a>00136 
<a name="l00137"></a>00137 
<a name="l00138"></a><a class="code" href="classlibMesh_1_1DofMap.php#ab67f7b5505959af29c3aac5bbbb9e9d2">00138</a> <a class="code" href="classlibMesh_1_1DofObject.php">DofObject</a>* <a class="code" href="classlibMesh_1_1DofMap.php#ab67f7b5505959af29c3aac5bbbb9e9d2">DofMap::node_ptr</a>(<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00139"></a>00139 <span class="keyword"></span>{
<a name="l00140"></a>00140   <span class="keywordflow">return</span> mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(i);
<a name="l00141"></a>00141 }
<a name="l00142"></a>00142 
<a name="l00143"></a>00143 
<a name="l00144"></a>00144 
<a name="l00145"></a><a class="code" href="classlibMesh_1_1DofMap.php#ab6e5067ba73e4228bbd01956805af660">00145</a> <a class="code" href="classlibMesh_1_1DofObject.php">DofObject</a>* <a class="code" href="classlibMesh_1_1DofMap.php#ab6e5067ba73e4228bbd01956805af660">DofMap::elem_ptr</a>(<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00146"></a>00146 <span class="keyword"></span>{
<a name="l00147"></a>00147   <span class="keywordflow">return</span> mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(i);
<a name="l00148"></a>00148 }
<a name="l00149"></a>00149 
<a name="l00150"></a>00150 
<a name="l00151"></a>00151 
<a name="l00152"></a>00152 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> iterator_type&gt;
<a name="l00153"></a><a class="code" href="classlibMesh_1_1DofMap.php#aafa42683c20195adafb582225eefd91c">00153</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#aafa42683c20195adafb582225eefd91c">DofMap::set_nonlocal_dof_objects</a>(iterator_type objects_begin,
<a name="l00154"></a>00154                                       iterator_type objects_end,
<a name="l00155"></a>00155                                       <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp;<a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>,
<a name="l00156"></a>00156                                       dofobject_accessor objects)
<a name="l00157"></a>00157 {
<a name="l00158"></a>00158   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00159"></a>00159   parallel_only();
<a name="l00160"></a>00160 
<a name="l00161"></a>00161   <span class="comment">// First, iterate over local objects to find out how many</span>
<a name="l00162"></a>00162   <span class="comment">// are on each processor</span>
<a name="l00163"></a>00163   std::vector&lt;unsigned int&gt;
<a name="l00164"></a>00164     ghost_objects_from_proc(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(), 0);
<a name="l00165"></a>00165 
<a name="l00166"></a>00166   iterator_type it  = objects_begin;
<a name="l00167"></a>00167 
<a name="l00168"></a>00168   <span class="keywordflow">for</span> (; it != objects_end; ++it)
<a name="l00169"></a>00169     {
<a name="l00170"></a>00170       <a class="code" href="classlibMesh_1_1DofObject.php">DofObject</a> *obj = *it;
<a name="l00171"></a>00171 
<a name="l00172"></a>00172       <span class="keywordflow">if</span> (obj)
<a name="l00173"></a>00173         {
<a name="l00174"></a>00174           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> obj_procid = obj-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">processor_id</a>();
<a name="l00175"></a>00175           <span class="comment">// We&#39;d better be completely partitioned by now</span>
<a name="l00176"></a>00176           libmesh_assert(obj_procid != <a class="code" href="classlibMesh_1_1DofObject.php#a46e3889aa741da5ebf483fe91fd1d431">DofObject::invalid_processor_id</a>);
<a name="l00177"></a>00177           ghost_objects_from_proc[obj_procid]++;
<a name="l00178"></a>00178         }
<a name="l00179"></a>00179     }
<a name="l00180"></a>00180 
<a name="l00181"></a>00181   std::vector&lt;unsigned int&gt; objects_on_proc(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(), 0);
<a name="l00182"></a>00182   <a class="code" href="namespacelibMesh_1_1Parallel.php#a5d83bd3061eee7fc9ec2c58427c67aef">Parallel::allgather</a>(ghost_objects_from_proc[<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>()],
<a name="l00183"></a>00183                       objects_on_proc);
<a name="l00184"></a>00184 
<a name="l00185"></a>00185 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00186"></a>00186 <span class="preprocessor"></span>  <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p != <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(); ++p)
<a name="l00187"></a>00187     libmesh_assert(ghost_objects_from_proc[p] &lt;= objects_on_proc[p]);
<a name="l00188"></a>00188 <span class="preprocessor">#endif</span>
<a name="l00189"></a>00189 <span class="preprocessor"></span>
<a name="l00190"></a>00190   <span class="comment">// Request sets to send to each processor</span>
<a name="l00191"></a>00191   std::vector&lt;std::vector&lt;unsigned int&gt; &gt;
<a name="l00192"></a>00192     requested_ids(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>());
<a name="l00193"></a>00193 
<a name="l00194"></a>00194   <span class="comment">// We know how many of our objects live on each processor, so</span>
<a name="l00195"></a>00195   <span class="comment">// reserve() space for requests from each.</span>
<a name="l00196"></a>00196   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p != <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(); ++p)
<a name="l00197"></a>00197     <span class="keywordflow">if</span> (p != <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>())
<a name="l00198"></a>00198       requested_ids[p].reserve(ghost_objects_from_proc[p]);
<a name="l00199"></a>00199 
<a name="l00200"></a>00200   <span class="keywordflow">for</span> (it = objects_begin; it != objects_end; ++it)
<a name="l00201"></a>00201     {
<a name="l00202"></a>00202       <a class="code" href="classlibMesh_1_1DofObject.php">DofObject</a> *obj = *it;
<a name="l00203"></a>00203       <span class="keywordflow">if</span> (obj-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">processor_id</a>() != <a class="code" href="classlibMesh_1_1DofObject.php#a46e3889aa741da5ebf483fe91fd1d431">DofObject::invalid_processor_id</a>)
<a name="l00204"></a>00204         requested_ids[obj-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">processor_id</a>()].push_back(obj-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>());
<a name="l00205"></a>00205     }
<a name="l00206"></a>00206 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00207"></a>00207 <span class="preprocessor"></span>  <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p != <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(); ++p)
<a name="l00208"></a>00208     libmesh_assert(requested_ids[p].size() == ghost_objects_from_proc[p]);
<a name="l00209"></a>00209 <span class="preprocessor">#endif</span>
<a name="l00210"></a>00210 <span class="preprocessor"></span>
<a name="l00211"></a>00211   <span class="comment">// Next set ghost object n_comps from other processors</span>
<a name="l00212"></a>00212   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=1; p != <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(); ++p)
<a name="l00213"></a>00213     {
<a name="l00214"></a>00214       <span class="comment">// Trade my requests with processor procup and procdown</span>
<a name="l00215"></a>00215       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> procup = (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() + p) %
<a name="l00216"></a>00216                              <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>();
<a name="l00217"></a>00217       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> procdown = (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() +
<a name="l00218"></a>00218                                <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() - p) %
<a name="l00219"></a>00219                                <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>();
<a name="l00220"></a>00220       std::vector&lt;unsigned int&gt; request_to_fill;
<a name="l00221"></a>00221       <a class="code" href="namespacelibMesh_1_1Parallel.php#acfbfff4a15f9dc0b0abdfb081086dd3b">Parallel::send_receive</a>(procup, requested_ids[procup],
<a name="l00222"></a>00222                              procdown, request_to_fill);
<a name="l00223"></a>00223 
<a name="l00224"></a>00224       <span class="comment">// Fill those requests</span>
<a name="l00225"></a>00225       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DofMap.php#aee89c467613b296c215421d60d5ae961">n_variables</a> = this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#aee89c467613b296c215421d60d5ae961">n_variables</a>();
<a name="l00226"></a>00226 
<a name="l00227"></a>00227       std::vector&lt;unsigned int&gt; ghost_data
<a name="l00228"></a>00228         (request_to_fill.size() * 2 * <a class="code" href="classlibMesh_1_1DofMap.php#aee89c467613b296c215421d60d5ae961">n_variables</a>);
<a name="l00229"></a>00229 
<a name="l00230"></a>00230       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != request_to_fill.size(); ++i)
<a name="l00231"></a>00231         {
<a name="l00232"></a>00232           <a class="code" href="classlibMesh_1_1DofObject.php">DofObject</a> *requested = (this-&gt;*objects)(mesh, request_to_fill[i]);
<a name="l00233"></a>00233           libmesh_assert(requested);
<a name="l00234"></a>00234           libmesh_assert(requested-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">processor_id</a>() == <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>());
<a name="l00235"></a>00235           libmesh_assert(requested-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a7c666bde4f1a0a23a8661afc52621a44">n_vars</a>(this-&gt;sys_number()) == n_variables);
<a name="l00236"></a>00236           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> v=0; v != <a class="code" href="classlibMesh_1_1DofMap.php#aee89c467613b296c215421d60d5ae961">n_variables</a>; ++v)
<a name="l00237"></a>00237             {
<a name="l00238"></a>00238               <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_comp =
<a name="l00239"></a>00239                 requested-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a6710a2bb047a60ef54bfe702432114f8">n_comp</a>(this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#a244e7a1cd82d5e6ae8780c93205ec1fa">sys_number</a>(), v);
<a name="l00240"></a>00240               ghost_data[i*2*n_variables+v] = n_comp;
<a name="l00241"></a>00241               <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DofMap.php#ad2b15648e708f656a798bd642c3ca8e3">first_dof</a> = n_comp ?
<a name="l00242"></a>00242                 requested-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a99664433bae4e638f8befc83cec4eeff">dof_number</a>(this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#a244e7a1cd82d5e6ae8780c93205ec1fa">sys_number</a>(), v, 0) : 0;
<a name="l00243"></a>00243               libmesh_assert(first_dof != <a class="code" href="classlibMesh_1_1DofObject.php#a1801e332bf034abe252086db668fee2d">DofObject::invalid_id</a>);
<a name="l00244"></a>00244               ghost_data[i*2*n_variables+n_variables+v] = <a class="code" href="classlibMesh_1_1DofMap.php#ad2b15648e708f656a798bd642c3ca8e3">first_dof</a>;
<a name="l00245"></a>00245             }
<a name="l00246"></a>00246         }
<a name="l00247"></a>00247 
<a name="l00248"></a>00248       <span class="comment">// Trade back the results</span>
<a name="l00249"></a>00249       std::vector&lt;unsigned int&gt; filled_request;
<a name="l00250"></a>00250       <a class="code" href="namespacelibMesh_1_1Parallel.php#acfbfff4a15f9dc0b0abdfb081086dd3b">Parallel::send_receive</a>(procdown, ghost_data,
<a name="l00251"></a>00251                              procup, filled_request);
<a name="l00252"></a>00252 
<a name="l00253"></a>00253       <span class="comment">// And copy the id changes we&#39;ve now been informed of</span>
<a name="l00254"></a>00254       libmesh_assert(filled_request.size() ==
<a name="l00255"></a>00255              requested_ids[procup].size() * 2 * <a class="code" href="classlibMesh_1_1DofMap.php#aee89c467613b296c215421d60d5ae961">n_variables</a>);
<a name="l00256"></a>00256       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != requested_ids[procup].size(); ++i)
<a name="l00257"></a>00257         {
<a name="l00258"></a>00258           <a class="code" href="classlibMesh_1_1DofObject.php">DofObject</a> *requested = (this-&gt;*objects)(mesh, requested_ids[procup][i]);
<a name="l00259"></a>00259           libmesh_assert(requested);
<a name="l00260"></a>00260           libmesh_assert (requested-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">processor_id</a>() == procup);
<a name="l00261"></a>00261           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> v=0; v != <a class="code" href="classlibMesh_1_1DofMap.php#aee89c467613b296c215421d60d5ae961">n_variables</a>; ++v)
<a name="l00262"></a>00262             {
<a name="l00263"></a>00263               <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_comp = filled_request[i*2*n_variables+v];
<a name="l00264"></a>00264               requested-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a25df5d5f6f2436cf566954d7b97283db">set_n_comp</a>(this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#a244e7a1cd82d5e6ae8780c93205ec1fa">sys_number</a>(), v, n_comp);
<a name="l00265"></a>00265               <span class="keywordflow">if</span> (n_comp)
<a name="l00266"></a>00266                 {
<a name="l00267"></a>00267                   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DofMap.php#ad2b15648e708f656a798bd642c3ca8e3">first_dof</a> = 
<a name="l00268"></a>00268                     filled_request[i*2*n_variables+n_variables+v];
<a name="l00269"></a>00269                   libmesh_assert(first_dof != <a class="code" href="classlibMesh_1_1DofObject.php#a1801e332bf034abe252086db668fee2d">DofObject::invalid_id</a>);
<a name="l00270"></a>00270                   requested-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#ae48fb571482cb01744308449089ca6ee">set_dof_number</a>
<a name="l00271"></a>00271                     (this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#a244e7a1cd82d5e6ae8780c93205ec1fa">sys_number</a>(), v, 0, first_dof);
<a name="l00272"></a>00272                 }
<a name="l00273"></a>00273             }
<a name="l00274"></a>00274         }
<a name="l00275"></a>00275     }
<a name="l00276"></a>00276 
<a name="l00277"></a>00277 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00278"></a>00278 <span class="preprocessor"></span>  <span class="comment">// Double check for invalid dofs</span>
<a name="l00279"></a>00279   <span class="keywordflow">for</span> (it = objects_begin; it != objects_end; ++it)
<a name="l00280"></a>00280     {
<a name="l00281"></a>00281       <a class="code" href="classlibMesh_1_1DofObject.php">DofObject</a> *obj = *it;
<a name="l00282"></a>00282       libmesh_assert (obj);
<a name="l00283"></a>00283       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DofMap.php#aee89c467613b296c215421d60d5ae961">n_variables</a> = obj-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a7c666bde4f1a0a23a8661afc52621a44">n_vars</a>(this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#a244e7a1cd82d5e6ae8780c93205ec1fa">sys_number</a>());
<a name="l00284"></a>00284       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> v=0; v != <a class="code" href="classlibMesh_1_1DofMap.php#aee89c467613b296c215421d60d5ae961">n_variables</a>; ++v)
<a name="l00285"></a>00285         {
<a name="l00286"></a>00286           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_comp =
<a name="l00287"></a>00287             obj-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a6710a2bb047a60ef54bfe702432114f8">n_comp</a>(this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#a244e7a1cd82d5e6ae8780c93205ec1fa">sys_number</a>(), v);
<a name="l00288"></a>00288           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DofMap.php#ad2b15648e708f656a798bd642c3ca8e3">first_dof</a> = n_comp ?
<a name="l00289"></a>00289             obj-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a99664433bae4e638f8befc83cec4eeff">dof_number</a>(this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#a244e7a1cd82d5e6ae8780c93205ec1fa">sys_number</a>(), v, 0) : 0;
<a name="l00290"></a>00290           libmesh_assert(first_dof != <a class="code" href="classlibMesh_1_1DofObject.php#a1801e332bf034abe252086db668fee2d">DofObject::invalid_id</a>);
<a name="l00291"></a>00291         }
<a name="l00292"></a>00292     }
<a name="l00293"></a>00293 <span class="preprocessor">#endif</span>
<a name="l00294"></a>00294 <span class="preprocessor"></span>}
<a name="l00295"></a>00295 
<a name="l00296"></a>00296 
<a name="l00297"></a>00297 
<a name="l00298"></a><a class="code" href="classlibMesh_1_1DofMap.php#abf4ed8e608b51a7a4e95935bf42ebbb1">00298</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#abf4ed8e608b51a7a4e95935bf42ebbb1">DofMap::reinit</a>(<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>)
<a name="l00299"></a>00299 {
<a name="l00300"></a>00300   libmesh_assert (mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aef78858f228f672f3587b19c2bbd5fce">is_prepared</a>());
<a name="l00301"></a>00301   
<a name="l00302"></a>00302   START_LOG(<span class="stringliteral">&quot;reinit()&quot;</span>, <span class="stringliteral">&quot;DofMap&quot;</span>);
<a name="l00303"></a>00303   
<a name="l00304"></a>00304   <span class="comment">//this-&gt;clear();</span>
<a name="l00305"></a>00305 
<a name="l00306"></a>00306   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_var = this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#aee89c467613b296c215421d60d5ae961">n_variables</a>();
<a name="l00307"></a>00307 
<a name="l00308"></a>00308 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00309"></a>00309 <span class="preprocessor"></span>  
<a name="l00310"></a>00310   <span class="comment">//------------------------------------------------------------</span>
<a name="l00311"></a>00311   <span class="comment">// Clear the old_dof_objects for all the nodes</span>
<a name="l00312"></a>00312   <span class="comment">// and elements so that we can overwrite them</span>
<a name="l00313"></a>00313   {
<a name="l00314"></a>00314     <a class="code" href="structlibMesh_1_1MeshBase_1_1node__iterator.php">MeshBase::node_iterator</a>       node_it  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a3ab1d28a6ea1e8028ce0c06e11cfb68d">nodes_begin</a>();
<a name="l00315"></a>00315     <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1node__iterator.php">MeshBase::node_iterator</a> node_end = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a47575077b6ad40d4f05292634f7615f8">nodes_end</a>();
<a name="l00316"></a>00316     
<a name="l00317"></a>00317     <span class="keywordflow">for</span> ( ; node_it != node_end; ++node_it)
<a name="l00318"></a>00318       {
<a name="l00319"></a>00319         (*node_it)-&gt;clear_old_dof_object();
<a name="l00320"></a>00320         libmesh_assert ((*node_it)-&gt;old_dof_object == NULL);
<a name="l00321"></a>00321       }
<a name="l00322"></a>00322     
<a name="l00323"></a>00323     <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       elem_it  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac266e1f5eb6ac9566ccbd7e6add6c239">elements_begin</a>();
<a name="l00324"></a>00324     <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> elem_end = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ae94f1bce0dc50c489c6bae9ba64d06e8">elements_end</a>();
<a name="l00325"></a>00325     
<a name="l00326"></a>00326     <span class="keywordflow">for</span> ( ; elem_it != elem_end; ++elem_it)
<a name="l00327"></a>00327       {
<a name="l00328"></a>00328         (*elem_it)-&gt;clear_old_dof_object();
<a name="l00329"></a>00329         libmesh_assert ((*elem_it)-&gt;old_dof_object == NULL);
<a name="l00330"></a>00330       }
<a name="l00331"></a>00331   }
<a name="l00332"></a>00332 
<a name="l00333"></a>00333   
<a name="l00334"></a>00334   <span class="comment">//------------------------------------------------------------</span>
<a name="l00335"></a>00335   <span class="comment">// Set the old_dof_objects for the elements that</span>
<a name="l00336"></a>00336   <span class="comment">// weren&#39;t just created, if these old dof objects</span>
<a name="l00337"></a>00337   <span class="comment">// had variables</span>
<a name="l00338"></a>00338   {
<a name="l00339"></a>00339     <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       elem_it  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac266e1f5eb6ac9566ccbd7e6add6c239">elements_begin</a>();
<a name="l00340"></a>00340     <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> elem_end = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ae94f1bce0dc50c489c6bae9ba64d06e8">elements_end</a>();
<a name="l00341"></a>00341     
<a name="l00342"></a>00342     <span class="keywordflow">for</span> ( ; elem_it != elem_end; ++elem_it)
<a name="l00343"></a>00343       {
<a name="l00344"></a>00344         <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = *elem_it;
<a name="l00345"></a>00345 
<a name="l00346"></a>00346         <span class="comment">// Skip the elements that were just refined</span>
<a name="l00347"></a>00347         <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a174bfe5b3d22e2b79000bfc816f633e6">refinement_flag</a>() == <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a6fb8f2a3f8b6cc1a569263dbc1f1c5cf">Elem::JUST_REFINED</a>) <span class="keywordflow">continue</span>;
<a name="l00348"></a>00348 
<a name="l00349"></a>00349         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>(); n++)
<a name="l00350"></a>00350           {
<a name="l00351"></a>00351             <a class="code" href="classlibMesh_1_1Node.php">Node</a>* node = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(n);
<a name="l00352"></a>00352 
<a name="l00353"></a>00353             <span class="keywordflow">if</span> (node-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a8e674de36aaf3c03e7128dc04bac63a7">old_dof_object</a> == NULL)
<a name="l00354"></a>00354               <span class="keywordflow">if</span> (node-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a82a14ff8b37b674b380b9235c92d1ea3">has_dofs</a>())
<a name="l00355"></a>00355                 node-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a085279db05ac736c3d82b8e7f76613df">set_old_dof_object</a>();
<a name="l00356"></a>00356           }
<a name="l00357"></a>00357 
<a name="l00358"></a>00358         libmesh_assert (elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a8e674de36aaf3c03e7128dc04bac63a7">old_dof_object</a> == NULL);
<a name="l00359"></a>00359 
<a name="l00360"></a>00360         <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a82a14ff8b37b674b380b9235c92d1ea3">has_dofs</a>())
<a name="l00361"></a>00361           elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a085279db05ac736c3d82b8e7f76613df">set_old_dof_object</a>();
<a name="l00362"></a>00362       }
<a name="l00363"></a>00363   }
<a name="l00364"></a>00364 
<a name="l00365"></a>00365 <span class="preprocessor">#endif // #ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00366"></a>00366 <span class="preprocessor"></span>
<a name="l00367"></a>00367   
<a name="l00368"></a>00368   <span class="comment">//------------------------------------------------------------</span>
<a name="l00369"></a>00369   <span class="comment">// Then set the number of variables for each \p DofObject</span>
<a name="l00370"></a>00370   <span class="comment">// equal to n_variables() for this system.  This will</span>
<a name="l00371"></a>00371   <span class="comment">// handle new \p DofObjects that may have just been created</span>
<a name="l00372"></a>00372   {
<a name="l00373"></a>00373     <span class="comment">// All the nodes</span>
<a name="l00374"></a>00374     <a class="code" href="structlibMesh_1_1MeshBase_1_1node__iterator.php">MeshBase::node_iterator</a>       node_it  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a3ab1d28a6ea1e8028ce0c06e11cfb68d">nodes_begin</a>();
<a name="l00375"></a>00375     <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1node__iterator.php">MeshBase::node_iterator</a> node_end = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a47575077b6ad40d4f05292634f7615f8">nodes_end</a>();
<a name="l00376"></a>00376 
<a name="l00377"></a>00377     <span class="keywordflow">for</span> ( ; node_it != node_end; ++node_it)
<a name="l00378"></a>00378       (*node_it)-&gt;set_n_vars(this-&gt;sys_number(),n_var);
<a name="l00379"></a>00379 
<a name="l00380"></a>00380     <span class="comment">// All the elements</span>
<a name="l00381"></a>00381     <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       elem_it  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac266e1f5eb6ac9566ccbd7e6add6c239">elements_begin</a>();
<a name="l00382"></a>00382     <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> elem_end = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ae94f1bce0dc50c489c6bae9ba64d06e8">elements_end</a>();
<a name="l00383"></a>00383 
<a name="l00384"></a>00384     <span class="keywordflow">for</span> ( ; elem_it != elem_end; ++elem_it)
<a name="l00385"></a>00385       (*elem_it)-&gt;set_n_vars(this-&gt;sys_number(),n_var);
<a name="l00386"></a>00386   }
<a name="l00387"></a>00387 
<a name="l00388"></a>00388 
<a name="l00389"></a>00389   <span class="comment">// Zero _n_SCALAR_dofs, it will be updated below.</span>
<a name="l00390"></a>00390   this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#ae4795cf1e08ba233dec67fe06b36873b">_n_SCALAR_dofs</a> = 0;
<a name="l00391"></a>00391 
<a name="l00392"></a>00392   <span class="comment">//------------------------------------------------------------</span>
<a name="l00393"></a>00393   <span class="comment">// Next allocate space for the DOF indices</span>
<a name="l00394"></a>00394   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var=0; var&lt;this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#aee89c467613b296c215421d60d5ae961">n_variables</a>(); var++)
<a name="l00395"></a>00395     {
<a name="l00396"></a>00396       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Variable.php">Variable</a> &amp;var_description = this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#ab36a0dc3c2c457fa8c01c1b0ba37facc">variable</a>(var);
<a name="l00397"></a>00397       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; base_fe_type              = this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#a0c010bb250d4cd8d65794452f46d141a">variable_type</a>(var);
<a name="l00398"></a>00398 
<a name="l00399"></a>00399       <span class="comment">// Don&#39;t need to loop over elements for a SCALAR variable</span>
<a name="l00400"></a>00400       <span class="comment">// Just increment _n_SCALAR_dofs</span>
<a name="l00401"></a>00401       <span class="keywordflow">if</span>(base_fe_type.<a class="code" href="classlibMesh_1_1FEType.php#ac437ba9b0a5253d6bf6f07ad277b9978">family</a> == <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a2ab36d7da9f38141601fd010d729e893">SCALAR</a>)
<a name="l00402"></a>00402       {
<a name="l00403"></a>00403         this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#ae4795cf1e08ba233dec67fe06b36873b">_n_SCALAR_dofs</a> += base_fe_type.<a class="code" href="classlibMesh_1_1FEType.php#aa2484e0f6721f3e34dedebccacc48ac1">order</a>;
<a name="l00404"></a>00404         <span class="keywordflow">continue</span>;
<a name="l00405"></a>00405       }
<a name="l00406"></a>00406 
<a name="l00407"></a>00407       <span class="comment">// This should be constant even on p-refined elements</span>
<a name="l00408"></a>00408       <span class="keyword">const</span> <span class="keywordtype">bool</span> extra_hanging_dofs =
<a name="l00409"></a>00409         <a class="code" href="classlibMesh_1_1FEInterface.php#ac0363b6fc2b8355ff0416ac65b522066">FEInterface::extra_hanging_dofs</a>(base_fe_type);
<a name="l00410"></a>00410 
<a name="l00411"></a>00411       <span class="comment">// For all the active elements</span>
<a name="l00412"></a>00412       <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       elem_it  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aefa4ded9eaf654a45ab593a0963ecbf3">active_elements_begin</a>();
<a name="l00413"></a>00413       <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> elem_end = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ae3f09f1b7556aef88919249861728e23">active_elements_end</a>(); 
<a name="l00414"></a>00414  
<a name="l00415"></a>00415       <span class="comment">// Count vertex degrees of freedom first</span>
<a name="l00416"></a>00416       <span class="keywordflow">for</span> ( ; elem_it != elem_end; ++elem_it)
<a name="l00417"></a>00417         {
<a name="l00418"></a>00418           <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem  = *elem_it;
<a name="l00419"></a>00419           libmesh_assert (elem != NULL);
<a name="l00420"></a>00420           
<a name="l00421"></a>00421           <span class="comment">// Skip the numbering if this variable is </span>
<a name="l00422"></a>00422           <span class="comment">// not active on this element&#39;s subdoman</span>
<a name="l00423"></a>00423           <span class="keywordflow">if</span> (!var_description.<a class="code" href="classlibMesh_1_1Variable.php#a94ff035823801db20635514405af60be">active_on_subdomain</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a96faae17e7ede5aa89c687d54cefb4b3">subdomain_id</a>()))
<a name="l00424"></a>00424             <span class="keywordflow">continue</span>;
<a name="l00425"></a>00425 
<a name="l00426"></a>00426           <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad06f8ac22978144723179eed42d10bae">type</a>();
<a name="l00427"></a>00427           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#aa50d97d65dc379f64667da53c427b36f">dim</a>();
<a name="l00428"></a>00428 
<a name="l00429"></a>00429           <a class="code" href="classlibMesh_1_1FEType.php">FEType</a> fe_type = base_fe_type;
<a name="l00430"></a>00430 
<a name="l00431"></a>00431 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00432"></a>00432 <span class="preprocessor"></span>          <span class="comment">// Make sure we haven&#39;t done more p refinement than we can</span>
<a name="l00433"></a>00433           <span class="comment">// handle</span>
<a name="l00434"></a>00434           <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>() + base_fe_type.<a class="code" href="classlibMesh_1_1FEType.php#aa2484e0f6721f3e34dedebccacc48ac1">order</a> &gt;
<a name="l00435"></a>00435               <a class="code" href="classlibMesh_1_1FEInterface.php#aa931485d398b0b9a877e380444ed959c">FEInterface::max_order</a>(base_fe_type, type))
<a name="l00436"></a>00436             {
<a name="l00437"></a>00437 <span class="preprocessor">#  ifdef DEBUG</span>
<a name="l00438"></a>00438 <span class="preprocessor"></span>              <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1FEInterface.php#aa931485d398b0b9a877e380444ed959c">FEInterface::max_order</a>(base_fe_type,type) &lt;
<a name="l00439"></a>00439                   <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(base_fe_type.<a class="code" href="classlibMesh_1_1FEType.php#aa2484e0f6721f3e34dedebccacc48ac1">order</a>))
<a name="l00440"></a>00440                 {
<a name="l00441"></a>00441                   <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> 
<a name="l00442"></a>00442                     &lt;&lt; <span class="stringliteral">&quot;ERROR: Finite element &quot;</span>
<a name="l00443"></a>00443                     &lt;&lt; <a class="code" href="namespacelibMesh_1_1Utility.php#a25f058c3618843eab999cf2c376227b1">Utility::enum_to_string</a>(base_fe_type.<a class="code" href="classlibMesh_1_1FEType.php#ac437ba9b0a5253d6bf6f07ad277b9978">family</a>)
<a name="l00444"></a>00444                     &lt;&lt; <span class="stringliteral">&quot; on geometric element &quot;</span>
<a name="l00445"></a>00445                     &lt;&lt; <a class="code" href="namespacelibMesh_1_1Utility.php#a25f058c3618843eab999cf2c376227b1">Utility::enum_to_string</a>(type) &lt;&lt; std::endl
<a name="l00446"></a>00446                     &lt;&lt; <span class="stringliteral">&quot;only supports FEInterface::max_order = &quot;</span> 
<a name="l00447"></a>00447                     &lt;&lt; <a class="code" href="classlibMesh_1_1FEInterface.php#aa931485d398b0b9a877e380444ed959c">FEInterface::max_order</a>(base_fe_type,type)
<a name="l00448"></a>00448                     &lt;&lt; <span class="stringliteral">&quot;, not fe_type.order = &quot;</span> &lt;&lt; base_fe_type.<a class="code" href="classlibMesh_1_1FEType.php#aa2484e0f6721f3e34dedebccacc48ac1">order</a>
<a name="l00449"></a>00449                     &lt;&lt; std::endl;
<a name="l00450"></a>00450 
<a name="l00451"></a>00451                   libmesh_error();
<a name="l00452"></a>00452                 }
<a name="l00453"></a>00453 
<a name="l00454"></a>00454               <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a>
<a name="l00455"></a>00455                 &lt;&lt; <span class="stringliteral">&quot;WARNING: Finite element &quot;</span>
<a name="l00456"></a>00456                 &lt;&lt; <a class="code" href="namespacelibMesh_1_1Utility.php#a25f058c3618843eab999cf2c376227b1">Utility::enum_to_string</a>(base_fe_type.<a class="code" href="classlibMesh_1_1FEType.php#ac437ba9b0a5253d6bf6f07ad277b9978">family</a>)
<a name="l00457"></a>00457                 &lt;&lt; <span class="stringliteral">&quot; on geometric element &quot;</span>
<a name="l00458"></a>00458                 &lt;&lt; <a class="code" href="namespacelibMesh_1_1Utility.php#a25f058c3618843eab999cf2c376227b1">Utility::enum_to_string</a>(type) &lt;&lt; std::endl
<a name="l00459"></a>00459                 &lt;&lt; <span class="stringliteral">&quot;could not be p refined past FEInterface::max_order = &quot;</span> 
<a name="l00460"></a>00460                 &lt;&lt; <a class="code" href="classlibMesh_1_1FEInterface.php#aa931485d398b0b9a877e380444ed959c">FEInterface::max_order</a>(base_fe_type,type)
<a name="l00461"></a>00461                 &lt;&lt; std::endl;
<a name="l00462"></a>00462 <span class="preprocessor">#  endif</span>
<a name="l00463"></a>00463 <span class="preprocessor"></span>              elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#af1f504a628c96ad2d9e49cff16d69bca">set_p_level</a>(<a class="code" href="classlibMesh_1_1FEInterface.php#aa931485d398b0b9a877e380444ed959c">FEInterface::max_order</a>(base_fe_type,type)
<a name="l00464"></a>00464                                 - base_fe_type.<a class="code" href="classlibMesh_1_1FEType.php#aa2484e0f6721f3e34dedebccacc48ac1">order</a>);
<a name="l00465"></a>00465             }
<a name="l00466"></a>00466 <span class="preprocessor">#endif</span>
<a name="l00467"></a>00467 <span class="preprocessor"></span>
<a name="l00468"></a>00468           fe_type.<a class="code" href="classlibMesh_1_1FEType.php#aa2484e0f6721f3e34dedebccacc48ac1">order</a> = <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a><span class="keyword">&gt;</span>(fe_type.<a class="code" href="classlibMesh_1_1FEType.php#aa2484e0f6721f3e34dedebccacc48ac1">order</a> +
<a name="l00469"></a>00469                                              elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>());
<a name="l00470"></a>00470              
<a name="l00471"></a>00471           <span class="comment">// Allocate the vertex DOFs</span>
<a name="l00472"></a>00472           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>(); n++)
<a name="l00473"></a>00473             {
<a name="l00474"></a>00474               <a class="code" href="classlibMesh_1_1Node.php">Node</a>* node = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(n);
<a name="l00475"></a>00475 
<a name="l00476"></a>00476               <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac56e382d9871ff243a781940ee13ed87">is_vertex</a>(n))
<a name="l00477"></a>00477                 {
<a name="l00478"></a>00478                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> old_node_dofs =
<a name="l00479"></a>00479                     node-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a6710a2bb047a60ef54bfe702432114f8">n_comp</a>(this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#a244e7a1cd82d5e6ae8780c93205ec1fa">sys_number</a>(), var);
<a name="l00480"></a>00480 
<a name="l00481"></a>00481                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> vertex_dofs =
<a name="l00482"></a>00482                     <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(<a class="code" href="classlibMesh_1_1FEInterface.php#a9d448e5766ac099a401541d191439d0b">FEInterface::n_dofs_at_node</a>(dim, fe_type,
<a name="l00483"></a>00483                                                          type, n),
<a name="l00484"></a>00484                              old_node_dofs);
<a name="l00485"></a>00485                   
<a name="l00486"></a>00486                   <span class="comment">// Some discontinuous FEs have no vertex dofs</span>
<a name="l00487"></a>00487                   <span class="keywordflow">if</span> (vertex_dofs &gt; old_node_dofs)
<a name="l00488"></a>00488                     {
<a name="l00489"></a>00489                       node-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a25df5d5f6f2436cf566954d7b97283db">set_n_comp</a>(this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#a244e7a1cd82d5e6ae8780c93205ec1fa">sys_number</a>(), var,
<a name="l00490"></a>00490                                        vertex_dofs);
<a name="l00491"></a>00491                       <span class="comment">// Abusing dof_number to set a &quot;this is a</span>
<a name="l00492"></a>00492                       <span class="comment">// vertex&quot; flag</span>
<a name="l00493"></a>00493                       node-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#ae48fb571482cb01744308449089ca6ee">set_dof_number</a>(this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#a244e7a1cd82d5e6ae8780c93205ec1fa">sys_number</a>(),
<a name="l00494"></a>00494                                            var, 0, vertex_dofs);
<a name="l00495"></a>00495                     }
<a name="l00496"></a>00496                 }
<a name="l00497"></a>00497             }
<a name="l00498"></a>00498         } <span class="comment">// done counting vertex dofs</span>
<a name="l00499"></a>00499 
<a name="l00500"></a>00500       <span class="comment">// count edge &amp; face dofs next</span>
<a name="l00501"></a>00501       elem_it = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aefa4ded9eaf654a45ab593a0963ecbf3">active_elements_begin</a>();
<a name="l00502"></a>00502 
<a name="l00503"></a>00503       <span class="keywordflow">for</span> ( ; elem_it != elem_end; ++elem_it)
<a name="l00504"></a>00504         {
<a name="l00505"></a>00505           <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = *elem_it;
<a name="l00506"></a>00506           libmesh_assert (elem != NULL);
<a name="l00507"></a>00507           
<a name="l00508"></a>00508           <span class="comment">// Skip the numbering if this variable is </span>
<a name="l00509"></a>00509           <span class="comment">// not active on this element&#39;s subdoman</span>
<a name="l00510"></a>00510           <span class="keywordflow">if</span> (!var_description.<a class="code" href="classlibMesh_1_1Variable.php#a94ff035823801db20635514405af60be">active_on_subdomain</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a96faae17e7ede5aa89c687d54cefb4b3">subdomain_id</a>()))
<a name="l00511"></a>00511             <span class="keywordflow">continue</span>;
<a name="l00512"></a>00512 
<a name="l00513"></a>00513           <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad06f8ac22978144723179eed42d10bae">type</a>();
<a name="l00514"></a>00514           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#aa50d97d65dc379f64667da53c427b36f">dim</a>();
<a name="l00515"></a>00515              
<a name="l00516"></a>00516           <a class="code" href="classlibMesh_1_1FEType.php">FEType</a> fe_type = base_fe_type;
<a name="l00517"></a>00517           fe_type.<a class="code" href="classlibMesh_1_1FEType.php#aa2484e0f6721f3e34dedebccacc48ac1">order</a> = <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a><span class="keyword">&gt;</span>(fe_type.<a class="code" href="classlibMesh_1_1FEType.php#aa2484e0f6721f3e34dedebccacc48ac1">order</a> +
<a name="l00518"></a>00518                                              elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>());
<a name="l00519"></a>00519 
<a name="l00520"></a>00520           <span class="comment">// Allocate the edge and face DOFs</span>
<a name="l00521"></a>00521           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>(); n++)
<a name="l00522"></a>00522             {
<a name="l00523"></a>00523               <a class="code" href="classlibMesh_1_1Node.php">Node</a>* node = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(n);
<a name="l00524"></a>00524 
<a name="l00525"></a>00525               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> old_node_dofs =
<a name="l00526"></a>00526                 node-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a6710a2bb047a60ef54bfe702432114f8">n_comp</a>(this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#a244e7a1cd82d5e6ae8780c93205ec1fa">sys_number</a>(), var);
<a name="l00527"></a>00527 
<a name="l00528"></a>00528               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> vertex_dofs = old_node_dofs?
<a name="l00529"></a>00529                 node-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a99664433bae4e638f8befc83cec4eeff">dof_number</a> (this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#a244e7a1cd82d5e6ae8780c93205ec1fa">sys_number</a>(),var,0):0;
<a name="l00530"></a>00530 
<a name="l00531"></a>00531               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> new_node_dofs =
<a name="l00532"></a>00532                 <a class="code" href="classlibMesh_1_1FEInterface.php#a9d448e5766ac099a401541d191439d0b">FEInterface::n_dofs_at_node</a>(dim, fe_type, type, n);
<a name="l00533"></a>00533 
<a name="l00534"></a>00534               <span class="comment">// We&#39;ve already allocated vertex DOFs</span>
<a name="l00535"></a>00535               <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac56e382d9871ff243a781940ee13ed87">is_vertex</a>(n))
<a name="l00536"></a>00536                 {
<a name="l00537"></a>00537                   libmesh_assert(old_node_dofs &gt;= vertex_dofs);
<a name="l00538"></a>00538                   libmesh_assert(vertex_dofs &gt;= new_node_dofs);
<a name="l00539"></a>00539                 }
<a name="l00540"></a>00540               <span class="comment">// We need to allocate the rest</span>
<a name="l00541"></a>00541               <span class="keywordflow">else</span>
<a name="l00542"></a>00542                 {
<a name="l00543"></a>00543                   <span class="comment">// If this has no dofs yet, it needs no vertex</span>
<a name="l00544"></a>00544                   <span class="comment">// dofs, so we just give it edge or face dofs</span>
<a name="l00545"></a>00545                   <span class="keywordflow">if</span> (!old_node_dofs)
<a name="l00546"></a>00546                     {
<a name="l00547"></a>00547                       node-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a25df5d5f6f2436cf566954d7b97283db">set_n_comp</a>(this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#a244e7a1cd82d5e6ae8780c93205ec1fa">sys_number</a>(), var,
<a name="l00548"></a>00548                                        new_node_dofs);
<a name="l00549"></a>00549                       <span class="comment">// Abusing dof_number to set a &quot;this has no</span>
<a name="l00550"></a>00550                       <span class="comment">// vertex dofs&quot; flag</span>
<a name="l00551"></a>00551                       <span class="keywordflow">if</span> (new_node_dofs)
<a name="l00552"></a>00552                         node-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#ae48fb571482cb01744308449089ca6ee">set_dof_number</a>(this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#a244e7a1cd82d5e6ae8780c93205ec1fa">sys_number</a>(),
<a name="l00553"></a>00553                                              var, 0, 0);
<a name="l00554"></a>00554                     }
<a name="l00555"></a>00555 
<a name="l00556"></a>00556                   <span class="comment">// If this has dofs, but has no vertex dofs,</span>
<a name="l00557"></a>00557                   <span class="comment">// it may still need more edge or face dofs if</span>
<a name="l00558"></a>00558                   <span class="comment">// we&#39;re p-refined.</span>
<a name="l00559"></a>00559                   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (vertex_dofs == 0)
<a name="l00560"></a>00560                     {
<a name="l00561"></a>00561                       <span class="keywordflow">if</span> (new_node_dofs &gt; old_node_dofs)
<a name="l00562"></a>00562                         {
<a name="l00563"></a>00563                           node-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a25df5d5f6f2436cf566954d7b97283db">set_n_comp</a>(this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#a244e7a1cd82d5e6ae8780c93205ec1fa">sys_number</a>(), var,
<a name="l00564"></a>00564                                            new_node_dofs);
<a name="l00565"></a>00565                           node-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#ae48fb571482cb01744308449089ca6ee">set_dof_number</a>(this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#a244e7a1cd82d5e6ae8780c93205ec1fa">sys_number</a>(),
<a name="l00566"></a>00566                                                var, 0, vertex_dofs);
<a name="l00567"></a>00567                         }
<a name="l00568"></a>00568                     }
<a name="l00569"></a>00569                   <span class="comment">// If this is another element&#39;s vertex,</span>
<a name="l00570"></a>00570                   <span class="comment">// add more (non-overlapping) edge/face dofs if</span>
<a name="l00571"></a>00571                   <span class="comment">// necessary</span>
<a name="l00572"></a>00572                   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (extra_hanging_dofs)
<a name="l00573"></a>00573                     {
<a name="l00574"></a>00574                       <span class="keywordflow">if</span> (new_node_dofs &gt; old_node_dofs - vertex_dofs)
<a name="l00575"></a>00575                         {
<a name="l00576"></a>00576                           node-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a25df5d5f6f2436cf566954d7b97283db">set_n_comp</a>(this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#a244e7a1cd82d5e6ae8780c93205ec1fa">sys_number</a>(), var,
<a name="l00577"></a>00577                                            vertex_dofs + new_node_dofs);
<a name="l00578"></a>00578                           node-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#ae48fb571482cb01744308449089ca6ee">set_dof_number</a>(this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#a244e7a1cd82d5e6ae8780c93205ec1fa">sys_number</a>(),
<a name="l00579"></a>00579                                                var, 0, vertex_dofs);
<a name="l00580"></a>00580                         }
<a name="l00581"></a>00581                     }
<a name="l00582"></a>00582                   <span class="comment">// If this is another element&#39;s vertex, add any</span>
<a name="l00583"></a>00583                   <span class="comment">// (overlapping) edge/face dofs if necessary</span>
<a name="l00584"></a>00584                   <span class="keywordflow">else</span>
<a name="l00585"></a>00585                     {
<a name="l00586"></a>00586                       libmesh_assert(old_node_dofs &gt;= vertex_dofs);
<a name="l00587"></a>00587                       <span class="keywordflow">if</span> (new_node_dofs &gt; old_node_dofs)
<a name="l00588"></a>00588                         {
<a name="l00589"></a>00589                           node-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a25df5d5f6f2436cf566954d7b97283db">set_n_comp</a>(this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#a244e7a1cd82d5e6ae8780c93205ec1fa">sys_number</a>(), var,
<a name="l00590"></a>00590                                            new_node_dofs);
<a name="l00591"></a>00591                           node-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#ae48fb571482cb01744308449089ca6ee">set_dof_number</a>(this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#a244e7a1cd82d5e6ae8780c93205ec1fa">sys_number</a>(),
<a name="l00592"></a>00592                                                var, 0, vertex_dofs);
<a name="l00593"></a>00593                         }
<a name="l00594"></a>00594                     }
<a name="l00595"></a>00595                 }
<a name="l00596"></a>00596             }
<a name="l00597"></a>00597           <span class="comment">// Allocate the element DOFs</span>
<a name="l00598"></a>00598           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dofs_per_elem =
<a name="l00599"></a>00599                           <a class="code" href="classlibMesh_1_1FEInterface.php#aaf96d4ec7921d2f2a1d4cdbdbc63656a">FEInterface::n_dofs_per_elem</a>(dim, fe_type,
<a name="l00600"></a>00600                                                        type);
<a name="l00601"></a>00601 
<a name="l00602"></a>00602           elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a25df5d5f6f2436cf566954d7b97283db">set_n_comp</a>(this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#a244e7a1cd82d5e6ae8780c93205ec1fa">sys_number</a>(), var, dofs_per_elem);
<a name="l00603"></a>00603 
<a name="l00604"></a>00604         }
<a name="l00605"></a>00605     }
<a name="l00606"></a>00606 
<a name="l00607"></a>00607   <span class="comment">// Calling DofMap::reinit() by itself makes little sense,</span>
<a name="l00608"></a>00608   <span class="comment">// so we won&#39;t bother with nonlocal DofObjects.</span>
<a name="l00609"></a>00609   <span class="comment">// Those will be fixed by distribute_dofs</span>
<a name="l00610"></a>00610 <span class="comment">/*</span>
<a name="l00611"></a>00611 <span class="comment">  //------------------------------------------------------------</span>
<a name="l00612"></a>00612 <span class="comment">  // At this point, all n_comp and dof_number values on local</span>
<a name="l00613"></a>00613 <span class="comment">  // DofObjects should be correct, but a ParallelMesh might have</span>
<a name="l00614"></a>00614 <span class="comment">  // incorrect values on non-local DofObjects.  Let&#39;s request the</span>
<a name="l00615"></a>00615 <span class="comment">  // correct values from each other processor.</span>
<a name="l00616"></a>00616 <span class="comment"></span>
<a name="l00617"></a>00617 <span class="comment">  this-&gt;set_nonlocal_n_comps(mesh.nodes_begin(),</span>
<a name="l00618"></a>00618 <span class="comment">                             mesh.nodes_end(),</span>
<a name="l00619"></a>00619 <span class="comment">                             mesh,</span>
<a name="l00620"></a>00620 <span class="comment">                             &amp;DofMap::node_ptr);</span>
<a name="l00621"></a>00621 <span class="comment"></span>
<a name="l00622"></a>00622 <span class="comment">  this-&gt;set_nonlocal_n_comps(mesh.elements_begin(),</span>
<a name="l00623"></a>00623 <span class="comment">                             mesh.elements_end(),</span>
<a name="l00624"></a>00624 <span class="comment">                             mesh,</span>
<a name="l00625"></a>00625 <span class="comment">                             &amp;DofMap::elem_ptr);</span>
<a name="l00626"></a>00626 <span class="comment">*/</span>
<a name="l00627"></a>00627 
<a name="l00628"></a>00628   <span class="comment">//------------------------------------------------------------</span>
<a name="l00629"></a>00629   <span class="comment">// Finally, clear all the current DOF indices</span>
<a name="l00630"></a>00630   <span class="comment">// (distribute_dofs expects them cleared!)</span>
<a name="l00631"></a>00631   this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#a9cbe9d7dc9f93f266817f997562bfa7c">invalidate_dofs</a>(mesh);
<a name="l00632"></a>00632   
<a name="l00633"></a>00633   STOP_LOG(<span class="stringliteral">&quot;reinit()&quot;</span>, <span class="stringliteral">&quot;DofMap&quot;</span>);
<a name="l00634"></a>00634 }
<a name="l00635"></a>00635 
<a name="l00636"></a>00636 
<a name="l00637"></a>00637 
<a name="l00638"></a><a class="code" href="classlibMesh_1_1DofMap.php#a9cbe9d7dc9f93f266817f997562bfa7c">00638</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#a9cbe9d7dc9f93f266817f997562bfa7c">DofMap::invalidate_dofs</a>(<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>)<span class="keyword"> const</span>
<a name="l00639"></a>00639 <span class="keyword"></span>{
<a name="l00640"></a>00640   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sys_num = this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#a244e7a1cd82d5e6ae8780c93205ec1fa">sys_number</a>();
<a name="l00641"></a>00641 
<a name="l00642"></a>00642   <span class="comment">// All the nodes</span>
<a name="l00643"></a>00643   <a class="code" href="structlibMesh_1_1MeshBase_1_1node__iterator.php">MeshBase::node_iterator</a>       node_it  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a3ab1d28a6ea1e8028ce0c06e11cfb68d">nodes_begin</a>();
<a name="l00644"></a>00644   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1node__iterator.php">MeshBase::node_iterator</a> node_end = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a47575077b6ad40d4f05292634f7615f8">nodes_end</a>();
<a name="l00645"></a>00645 
<a name="l00646"></a>00646   <span class="keywordflow">for</span> ( ; node_it != node_end; ++node_it)
<a name="l00647"></a>00647     (*node_it)-&gt;invalidate_dofs(sys_num);
<a name="l00648"></a>00648   
<a name="l00649"></a>00649   <span class="comment">// All the elements</span>
<a name="l00650"></a>00650   <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       elem_it  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aefa4ded9eaf654a45ab593a0963ecbf3">active_elements_begin</a>();
<a name="l00651"></a>00651   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> elem_end = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ae3f09f1b7556aef88919249861728e23">active_elements_end</a>(); 
<a name="l00652"></a>00652 
<a name="l00653"></a>00653   <span class="keywordflow">for</span> ( ; elem_it != elem_end; ++elem_it)
<a name="l00654"></a>00654     (*elem_it)-&gt;invalidate_dofs(sys_num);
<a name="l00655"></a>00655 }
<a name="l00656"></a>00656 
<a name="l00657"></a>00657 
<a name="l00658"></a>00658 
<a name="l00659"></a><a class="code" href="classlibMesh_1_1DofMap.php#a480f80bc9234a5586711833b87a89784">00659</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#a480f80bc9234a5586711833b87a89784">DofMap::clear</a>()
<a name="l00660"></a>00660 {
<a name="l00661"></a>00661   <span class="comment">// we don&#39;t want to clear</span>
<a name="l00662"></a>00662   <span class="comment">// the coupling matrix!</span>
<a name="l00663"></a>00663   <span class="comment">// It should not change...</span>
<a name="l00664"></a>00664   <span class="comment">//_dof_coupling-&gt;clear();</span>
<a name="l00665"></a>00665 
<a name="l00666"></a>00666   <a class="code" href="classlibMesh_1_1DofMap.php#a5232a8054e580a408f394ba1574c63df">_variables</a>.clear();  
<a name="l00667"></a>00667   <a class="code" href="classlibMesh_1_1DofMap.php#a6a2cc4429bc1f9ec22b85dedbee55d96">_first_df</a>.clear();
<a name="l00668"></a>00668   <a class="code" href="classlibMesh_1_1DofMap.php#ab03f023f66c9d64feddada936ae18750">_end_df</a>.clear();
<a name="l00669"></a>00669   <a class="code" href="classlibMesh_1_1DofMap.php#ac2cd47f78f1cf8bbdba640f56ef96afa">_var_first_local_df</a>.clear();
<a name="l00670"></a>00670   <a class="code" href="classlibMesh_1_1DofMap.php#a66d63042b6f4dce2ef98a1573ff6b2ad">_send_list</a>.clear();
<a name="l00671"></a>00671   <a class="code" href="classlibMesh_1_1DofMap.php#a2f1f1ad0386f846409d903d5df18f114">_n_nz</a>.clear();
<a name="l00672"></a>00672   <a class="code" href="classlibMesh_1_1DofMap.php#a0b3879c0bf8ae122f12710bc32f17810">_n_oz</a>.clear();
<a name="l00673"></a>00673 
<a name="l00674"></a>00674 
<a name="l00675"></a>00675 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00676"></a>00676 <span class="preprocessor"></span>
<a name="l00677"></a>00677   <a class="code" href="classlibMesh_1_1DofMap.php#af7fe4d0cf13618e6dd04ff22fdaca0ba">_dof_constraints</a>.clear();
<a name="l00678"></a>00678   <a class="code" href="classlibMesh_1_1DofMap.php#a5e406923a04ca8cce5a0a73ebedaaa36">_n_old_dfs</a> = 0;
<a name="l00679"></a>00679   <a class="code" href="classlibMesh_1_1DofMap.php#abe4f7d1a32937bce6c6d8fc8b32ce0a2">_first_old_df</a>.clear();
<a name="l00680"></a>00680   <a class="code" href="classlibMesh_1_1DofMap.php#a5c01318c85ebe04282bdaf8dff4e3528">_end_old_df</a>.clear();
<a name="l00681"></a>00681 
<a name="l00682"></a>00682 <span class="preprocessor">#endif</span>
<a name="l00683"></a>00683 <span class="preprocessor"></span>
<a name="l00684"></a>00684   <a class="code" href="classlibMesh_1_1DofMap.php#a29ff2098ced1859cd5296af428435d73">_matrices</a>.clear();
<a name="l00685"></a>00685 
<a name="l00686"></a>00686   <a class="code" href="classlibMesh_1_1DofMap.php#a339dde44caf1af4d425d3830a20c7f54">_n_dfs</a> = 0;
<a name="l00687"></a>00687 }
<a name="l00688"></a>00688 
<a name="l00689"></a>00689 
<a name="l00690"></a>00690 
<a name="l00691"></a><a class="code" href="classlibMesh_1_1DofMap.php#ab986eb7bbf9bbb5119a49a145306a980">00691</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#ab986eb7bbf9bbb5119a49a145306a980">DofMap::distribute_dofs</a> (<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>)
<a name="l00692"></a>00692 {
<a name="l00693"></a>00693   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00694"></a>00694   parallel_only();
<a name="l00695"></a>00695 
<a name="l00696"></a>00696   <span class="comment">// Log how long it takes to distribute the degrees of freedom</span>
<a name="l00697"></a>00697   START_LOG(<span class="stringliteral">&quot;distribute_dofs()&quot;</span>, <span class="stringliteral">&quot;DofMap&quot;</span>);
<a name="l00698"></a>00698 
<a name="l00699"></a>00699   libmesh_assert (mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aef78858f228f672f3587b19c2bbd5fce">is_prepared</a>());
<a name="l00700"></a>00700 
<a name="l00701"></a>00701   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id = <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>();
<a name="l00702"></a>00702   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_proc  = <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>();
<a name="l00703"></a>00703   
<a name="l00704"></a>00704 <span class="comment">//  libmesh_assert (this-&gt;n_variables() &gt; 0);</span>
<a name="l00705"></a>00705   libmesh_assert (proc_id &lt; n_proc);
<a name="l00706"></a>00706   
<a name="l00707"></a>00707   <span class="comment">// re-init in case the mesh has changed</span>
<a name="l00708"></a>00708   this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#abf4ed8e608b51a7a4e95935bf42ebbb1">reinit</a>(mesh);
<a name="l00709"></a>00709   
<a name="l00710"></a>00710   <span class="comment">// By default distribute variables in a</span>
<a name="l00711"></a>00711   <span class="comment">// var-major fashion, but allow run-time</span>
<a name="l00712"></a>00712   <span class="comment">// specification</span>
<a name="l00713"></a>00713   <span class="keywordtype">bool</span> node_major_dofs = <a class="code" href="namespacelibMesh.php#ad19739ed0fdd45f048901a13954369b6">libMesh::on_command_line</a> (<span class="stringliteral">&quot;--node_major_dofs&quot;</span>);
<a name="l00714"></a>00714 
<a name="l00715"></a>00715   <span class="comment">// The DOF counter, will be incremented as we encounter</span>
<a name="l00716"></a>00716   <span class="comment">// new degrees of freedom</span>
<a name="l00717"></a>00717   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> next_free_dof = 0;
<a name="l00718"></a>00718 
<a name="l00719"></a>00719   <span class="comment">// Clear the send list before we rebuild it</span>
<a name="l00720"></a>00720   <a class="code" href="classlibMesh_1_1DofMap.php#a66d63042b6f4dce2ef98a1573ff6b2ad">_send_list</a>.clear();
<a name="l00721"></a>00721 
<a name="l00722"></a>00722   <span class="comment">// Set temporary DOF indices on this processor</span>
<a name="l00723"></a>00723   <span class="keywordflow">if</span> (node_major_dofs)
<a name="l00724"></a>00724     this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#ad4cb3d7c654bb942da7a99c5fc645a66">distribute_local_dofs_node_major</a> (next_free_dof, mesh);
<a name="l00725"></a>00725   <span class="keywordflow">else</span>
<a name="l00726"></a>00726     this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#a55f4e20c43c4d9b726702ece1c6b9cdc">distribute_local_dofs_var_major</a> (next_free_dof, mesh);
<a name="l00727"></a>00727 
<a name="l00728"></a>00728   <span class="comment">// Get DOF counts on all processors</span>
<a name="l00729"></a>00729   std::vector&lt;unsigned int&gt; dofs_on_proc(n_proc, 0);
<a name="l00730"></a>00730   <a class="code" href="namespacelibMesh_1_1Parallel.php#a5d83bd3061eee7fc9ec2c58427c67aef">Parallel::allgather</a>(next_free_dof, dofs_on_proc);
<a name="l00731"></a>00731 
<a name="l00732"></a>00732   <span class="comment">// Resize and fill the _first_df and _end_df arrays</span>
<a name="l00733"></a>00733 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00734"></a>00734 <span class="preprocessor"></span>  <a class="code" href="classlibMesh_1_1DofMap.php#abe4f7d1a32937bce6c6d8fc8b32ce0a2">_first_old_df</a> = <a class="code" href="classlibMesh_1_1DofMap.php#a6a2cc4429bc1f9ec22b85dedbee55d96">_first_df</a>;
<a name="l00735"></a>00735   <a class="code" href="classlibMesh_1_1DofMap.php#a5c01318c85ebe04282bdaf8dff4e3528">_end_old_df</a> = <a class="code" href="classlibMesh_1_1DofMap.php#ab03f023f66c9d64feddada936ae18750">_end_df</a>;
<a name="l00736"></a>00736 <span class="preprocessor">#endif</span>
<a name="l00737"></a>00737 <span class="preprocessor"></span>
<a name="l00738"></a>00738   <a class="code" href="classlibMesh_1_1DofMap.php#a6a2cc4429bc1f9ec22b85dedbee55d96">_first_df</a>.resize(n_proc);
<a name="l00739"></a>00739   <a class="code" href="classlibMesh_1_1DofMap.php#ab03f023f66c9d64feddada936ae18750">_end_df</a>.resize (n_proc);
<a name="l00740"></a>00740 
<a name="l00741"></a>00741   <span class="comment">// Get DOF offsets</span>
<a name="l00742"></a>00742   <a class="code" href="classlibMesh_1_1DofMap.php#a6a2cc4429bc1f9ec22b85dedbee55d96">_first_df</a>[0] = 0;
<a name="l00743"></a>00743   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=1; i &lt; n_proc; ++i)
<a name="l00744"></a>00744     <a class="code" href="classlibMesh_1_1DofMap.php#a6a2cc4429bc1f9ec22b85dedbee55d96">_first_df</a>[i] = <a class="code" href="classlibMesh_1_1DofMap.php#ab03f023f66c9d64feddada936ae18750">_end_df</a>[i-1] = <a class="code" href="classlibMesh_1_1DofMap.php#a6a2cc4429bc1f9ec22b85dedbee55d96">_first_df</a>[i-1] + dofs_on_proc[i-1];
<a name="l00745"></a>00745   <a class="code" href="classlibMesh_1_1DofMap.php#ab03f023f66c9d64feddada936ae18750">_end_df</a>[n_proc-1] = <a class="code" href="classlibMesh_1_1DofMap.php#a6a2cc4429bc1f9ec22b85dedbee55d96">_first_df</a>[n_proc-1] + dofs_on_proc[n_proc-1];
<a name="l00746"></a>00746 
<a name="l00747"></a>00747   <span class="comment">// Clear all the current DOF indices</span>
<a name="l00748"></a>00748   <span class="comment">// (distribute_dofs expects them cleared!)</span>
<a name="l00749"></a>00749   this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#a9cbe9d7dc9f93f266817f997562bfa7c">invalidate_dofs</a>(mesh);
<a name="l00750"></a>00750 
<a name="l00751"></a>00751   next_free_dof = <a class="code" href="classlibMesh_1_1DofMap.php#a6a2cc4429bc1f9ec22b85dedbee55d96">_first_df</a>[proc_id];
<a name="l00752"></a>00752 
<a name="l00753"></a>00753   <span class="comment">// Set permanent DOF indices on this processor</span>
<a name="l00754"></a>00754   <span class="keywordflow">if</span> (node_major_dofs)
<a name="l00755"></a>00755     this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#ad4cb3d7c654bb942da7a99c5fc645a66">distribute_local_dofs_node_major</a> (next_free_dof, mesh);
<a name="l00756"></a>00756   <span class="keywordflow">else</span>
<a name="l00757"></a>00757     this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#a55f4e20c43c4d9b726702ece1c6b9cdc">distribute_local_dofs_var_major</a> (next_free_dof, mesh);
<a name="l00758"></a>00758 
<a name="l00759"></a>00759   libmesh_assert(next_free_dof == <a class="code" href="classlibMesh_1_1DofMap.php#ab03f023f66c9d64feddada936ae18750">_end_df</a>[proc_id]);
<a name="l00760"></a>00760 
<a name="l00761"></a>00761   <span class="comment">//------------------------------------------------------------</span>
<a name="l00762"></a>00762   <span class="comment">// At this point, all n_comp and dof_number values on local</span>
<a name="l00763"></a>00763   <span class="comment">// DofObjects should be correct, but a ParallelMesh might have</span>
<a name="l00764"></a>00764   <span class="comment">// incorrect values on non-local DofObjects.  Let&#39;s request the</span>
<a name="l00765"></a>00765   <span class="comment">// correct values from each other processor.</span>
<a name="l00766"></a>00766 
<a name="l00767"></a>00767   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() &gt; 1)
<a name="l00768"></a>00768     {
<a name="l00769"></a>00769       this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#aafa42683c20195adafb582225eefd91c">set_nonlocal_dof_objects</a>(mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a3ab1d28a6ea1e8028ce0c06e11cfb68d">nodes_begin</a>(),
<a name="l00770"></a>00770                                      mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a47575077b6ad40d4f05292634f7615f8">nodes_end</a>(),
<a name="l00771"></a>00771                                      <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>, &amp;<a class="code" href="classlibMesh_1_1DofMap.php#ab67f7b5505959af29c3aac5bbbb9e9d2">DofMap::node_ptr</a>);
<a name="l00772"></a>00772 
<a name="l00773"></a>00773       this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#aafa42683c20195adafb582225eefd91c">set_nonlocal_dof_objects</a>(mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac266e1f5eb6ac9566ccbd7e6add6c239">elements_begin</a>(),
<a name="l00774"></a>00774                                      mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ae94f1bce0dc50c489c6bae9ba64d06e8">elements_end</a>(),
<a name="l00775"></a>00775                                      <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>, &amp;<a class="code" href="classlibMesh_1_1DofMap.php#ab6e5067ba73e4228bbd01956805af660">DofMap::elem_ptr</a>);
<a name="l00776"></a>00776     }
<a name="l00777"></a>00777   
<a name="l00778"></a>00778   <span class="comment">// Set the total number of degrees of freedom</span>
<a name="l00779"></a>00779 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00780"></a>00780 <span class="preprocessor"></span>  <a class="code" href="classlibMesh_1_1DofMap.php#a5e406923a04ca8cce5a0a73ebedaaa36">_n_old_dfs</a> = <a class="code" href="classlibMesh_1_1DofMap.php#a339dde44caf1af4d425d3830a20c7f54">_n_dfs</a>;
<a name="l00781"></a>00781 <span class="preprocessor">#endif</span>
<a name="l00782"></a>00782 <span class="preprocessor"></span>  <a class="code" href="classlibMesh_1_1DofMap.php#a339dde44caf1af4d425d3830a20c7f54">_n_dfs</a> = <a class="code" href="classlibMesh_1_1DofMap.php#ab03f023f66c9d64feddada936ae18750">_end_df</a>[n_proc-1];
<a name="l00783"></a>00783 
<a name="l00784"></a>00784   STOP_LOG(<span class="stringliteral">&quot;distribute_dofs()&quot;</span>, <span class="stringliteral">&quot;DofMap&quot;</span>);
<a name="l00785"></a>00785 
<a name="l00786"></a>00786   <span class="comment">// Note that in the add_neighbors_to_send_list nodes on processor</span>
<a name="l00787"></a>00787   <span class="comment">// boundaries that are shared by multiple elements are added for</span>
<a name="l00788"></a>00788   <span class="comment">// each element.</span>
<a name="l00789"></a>00789   this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#aed8eba054300e64164af4a8257bae8d8">add_neighbors_to_send_list</a>(mesh);
<a name="l00790"></a>00790   
<a name="l00791"></a>00791   <span class="comment">// Here we used to clean up that data structure; now System and</span>
<a name="l00792"></a>00792   <span class="comment">// EquationSystems call that for us, after we&#39;ve added constraint</span>
<a name="l00793"></a>00793   <span class="comment">// dependencies to the send_list too.</span>
<a name="l00794"></a>00794   <span class="comment">// this-&gt;sort_send_list ();</span>
<a name="l00795"></a>00795 }
<a name="l00796"></a>00796 
<a name="l00797"></a>00797 
<a name="l00798"></a><a class="code" href="classlibMesh_1_1DofMap.php#ad4cb3d7c654bb942da7a99c5fc645a66">00798</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#ad4cb3d7c654bb942da7a99c5fc645a66">DofMap::distribute_local_dofs_node_major</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> &amp;next_free_dof,
<a name="l00799"></a>00799                                               <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>)
<a name="l00800"></a>00800 {
<a name="l00801"></a>00801   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sys_num = this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#a244e7a1cd82d5e6ae8780c93205ec1fa">sys_number</a>();
<a name="l00802"></a>00802   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="tecplot__io_8C.php#ac001e4247887b98c2aa5b8ec5107ca0d">n_vars</a>  = this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#aee89c467613b296c215421d60d5ae961">n_variables</a>();
<a name="l00803"></a>00803 
<a name="l00804"></a>00804   <span class="comment">// We now only add remote dofs to the _send_list</span>
<a name="l00805"></a>00805   <span class="comment">// unsigned int send_list_size = 0;</span>
<a name="l00806"></a>00806 
<a name="l00807"></a>00807   <span class="comment">// _var_first_local_df does not work with node_major dofs</span>
<a name="l00808"></a>00808   <a class="code" href="classlibMesh_1_1DofMap.php#ac2cd47f78f1cf8bbdba640f56ef96afa">_var_first_local_df</a>.resize(n_vars+1);
<a name="l00809"></a>00809   std::fill (<a class="code" href="classlibMesh_1_1DofMap.php#ac2cd47f78f1cf8bbdba640f56ef96afa">_var_first_local_df</a>.begin(),
<a name="l00810"></a>00810              <a class="code" href="classlibMesh_1_1DofMap.php#ac2cd47f78f1cf8bbdba640f56ef96afa">_var_first_local_df</a>.end(),
<a name="l00811"></a>00811              <a class="code" href="classlibMesh_1_1DofObject.php#a1801e332bf034abe252086db668fee2d">DofObject::invalid_id</a>);
<a name="l00812"></a>00812 
<a name="l00813"></a>00813   <span class="comment">//-------------------------------------------------------------------------</span>
<a name="l00814"></a>00814   <span class="comment">// First count and assign temporary numbers to local dofs</span>
<a name="l00815"></a>00815   <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       elem_it  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a99742bad0b034a29ccae8c5a90c6f4aa">active_local_elements_begin</a>();
<a name="l00816"></a>00816   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> elem_end = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a2e27f54d33f7539c0c06b36adae36cda">active_local_elements_end</a>();  
<a name="l00817"></a>00817   
<a name="l00818"></a>00818   <span class="keywordflow">for</span> ( ; elem_it != elem_end; ++elem_it)
<a name="l00819"></a>00819     {
<a name="l00820"></a>00820       <span class="comment">// Only number dofs connected to active</span>
<a name="l00821"></a>00821       <span class="comment">// elements on this processor.</span>
<a name="l00822"></a>00822       <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem                 = *elem_it;
<a name="l00823"></a>00823       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="tecplot__io_8C.php#ad00604777dd9213f9627d8f12e3b2790">n_nodes</a> = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>();
<a name="l00824"></a>00824       
<a name="l00825"></a>00825       <span class="comment">// First number the nodal DOFS</span>
<a name="l00826"></a>00826       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;<a class="code" href="tecplot__io_8C.php#ad00604777dd9213f9627d8f12e3b2790">n_nodes</a>; n++)
<a name="l00827"></a>00827         {
<a name="l00828"></a>00828           <a class="code" href="classlibMesh_1_1Node.php">Node</a>* node = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(n);
<a name="l00829"></a>00829 
<a name="l00830"></a>00830           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> var=0; var&lt;<a class="code" href="tecplot__io_8C.php#ac001e4247887b98c2aa5b8ec5107ca0d">n_vars</a>; var++)
<a name="l00831"></a>00831           {
<a name="l00832"></a>00832               <span class="keywordflow">if</span>( (this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#ab36a0dc3c2c457fa8c01c1b0ba37facc">variable</a>(var).type().family != <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a2ab36d7da9f38141601fd010d729e893">SCALAR</a>) &amp;&amp;
<a name="l00833"></a>00833                   (this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#ab36a0dc3c2c457fa8c01c1b0ba37facc">variable</a>(var).active_on_subdomain(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a96faae17e7ede5aa89c687d54cefb4b3">subdomain_id</a>())) )
<a name="l00834"></a>00834               {
<a name="l00835"></a>00835                 <span class="comment">// assign dof numbers (all at once) if this is</span>
<a name="l00836"></a>00836                 <span class="comment">// our node and if they aren&#39;t already there</span>
<a name="l00837"></a>00837                 <span class="keywordflow">if</span> ((node-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a6710a2bb047a60ef54bfe702432114f8">n_comp</a>(sys_num,var) &gt; 0) &amp;&amp;
<a name="l00838"></a>00838                     (node-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">processor_id</a>() == <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>()) &amp;&amp;
<a name="l00839"></a>00839                     (node-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a99664433bae4e638f8befc83cec4eeff">dof_number</a>(sys_num,var,0) ==
<a name="l00840"></a>00840                      <a class="code" href="classlibMesh_1_1DofObject.php#a1801e332bf034abe252086db668fee2d">DofObject::invalid_id</a>))
<a name="l00841"></a>00841                   {
<a name="l00842"></a>00842                     node-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#ae48fb571482cb01744308449089ca6ee">set_dof_number</a>(sys_num,
<a name="l00843"></a>00843                                          var,
<a name="l00844"></a>00844                                          0,
<a name="l00845"></a>00845                                          next_free_dof);
<a name="l00846"></a>00846                     next_free_dof += node-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a6710a2bb047a60ef54bfe702432114f8">n_comp</a>(sys_num,var);
<a name="l00847"></a>00847                   }
<a name="l00848"></a>00848               }
<a name="l00849"></a>00849           }
<a name="l00850"></a>00850         }
<a name="l00851"></a>00851 
<a name="l00852"></a>00852       <span class="comment">// Now number the element DOFS</span>
<a name="l00853"></a>00853       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> var=0; var&lt;<a class="code" href="tecplot__io_8C.php#ac001e4247887b98c2aa5b8ec5107ca0d">n_vars</a>; var++)
<a name="l00854"></a>00854         <span class="keywordflow">if</span> ( (this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#ab36a0dc3c2c457fa8c01c1b0ba37facc">variable</a>(var).type().family != <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a2ab36d7da9f38141601fd010d729e893">SCALAR</a>) &amp;&amp;
<a name="l00855"></a>00855              (this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#ab36a0dc3c2c457fa8c01c1b0ba37facc">variable</a>(var).active_on_subdomain(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a96faae17e7ede5aa89c687d54cefb4b3">subdomain_id</a>())) )
<a name="l00856"></a>00856           <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a6710a2bb047a60ef54bfe702432114f8">n_comp</a>(sys_num,var) &gt; 0)
<a name="l00857"></a>00857             {
<a name="l00858"></a>00858               libmesh_assert (elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a99664433bae4e638f8befc83cec4eeff">dof_number</a>(sys_num,var,0) ==
<a name="l00859"></a>00859                               <a class="code" href="classlibMesh_1_1DofObject.php#a1801e332bf034abe252086db668fee2d">DofObject::invalid_id</a>);
<a name="l00860"></a>00860 
<a name="l00861"></a>00861               elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#ae48fb571482cb01744308449089ca6ee">set_dof_number</a>(sys_num,
<a name="l00862"></a>00862                                    var,
<a name="l00863"></a>00863                                    0,
<a name="l00864"></a>00864                                    next_free_dof);
<a name="l00865"></a>00865 
<a name="l00866"></a>00866               next_free_dof += elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a6710a2bb047a60ef54bfe702432114f8">n_comp</a>(sys_num,var);
<a name="l00867"></a>00867             }
<a name="l00868"></a>00868     } <span class="comment">// done looping over elements</span>
<a name="l00869"></a>00869 
<a name="l00870"></a>00870   <span class="comment">// Finally, count up the SCALAR dofs</span>
<a name="l00871"></a>00871   this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#ae4795cf1e08ba233dec67fe06b36873b">_n_SCALAR_dofs</a> = 0;
<a name="l00872"></a>00872   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> var=0; var&lt;<a class="code" href="tecplot__io_8C.php#ac001e4247887b98c2aa5b8ec5107ca0d">n_vars</a>; var++)
<a name="l00873"></a>00873     {
<a name="l00874"></a>00874       <span class="keywordflow">if</span>( this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#ab36a0dc3c2c457fa8c01c1b0ba37facc">variable</a>(var).type().family == <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a2ab36d7da9f38141601fd010d729e893">SCALAR</a> )
<a name="l00875"></a>00875         {
<a name="l00876"></a>00876           this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#ae4795cf1e08ba233dec67fe06b36873b">_n_SCALAR_dofs</a> += this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#ab36a0dc3c2c457fa8c01c1b0ba37facc">variable</a>(var).<a class="code" href="classlibMesh_1_1Variable.php#a8dcb07137d70a83fcf5b412e08e2783e">type</a>().<a class="code" href="classlibMesh_1_1FEType.php#aa2484e0f6721f3e34dedebccacc48ac1">order</a>;
<a name="l00877"></a>00877           <span class="keywordflow">continue</span>;
<a name="l00878"></a>00878         }
<a name="l00879"></a>00879     }
<a name="l00880"></a>00880 
<a name="l00881"></a>00881   <span class="comment">// Only increment next_free_dof if we&#39;re on the processor</span>
<a name="l00882"></a>00882   <span class="comment">// that holds this SCALAR variable</span>
<a name="l00883"></a>00883   <span class="keywordflow">if</span> ( <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>()-1) )
<a name="l00884"></a>00884     next_free_dof += <a class="code" href="classlibMesh_1_1DofMap.php#ae4795cf1e08ba233dec67fe06b36873b">_n_SCALAR_dofs</a>;
<a name="l00885"></a>00885 
<a name="l00886"></a>00886 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00887"></a>00887 <span class="preprocessor"></span><span class="comment">// Make sure we didn&#39;t miss any nodes</span>
<a name="l00888"></a>00888   <a class="code" href="namespacelibMesh_1_1MeshTools.php#a4413b39e0439b2e5535c9a9f962ea3fd">MeshTools::libmesh_assert_valid_node_procids</a>(mesh);
<a name="l00889"></a>00889 
<a name="l00890"></a>00890   <a class="code" href="structlibMesh_1_1MeshBase_1_1node__iterator.php">MeshBase::node_iterator</a>       node_it  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a7a87dbe56aaa89961e03d60a25a36e8b">local_nodes_begin</a>();
<a name="l00891"></a>00891   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1node__iterator.php">MeshBase::node_iterator</a> node_end = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ad0daaecd9c183194a99609db6507198c">local_nodes_end</a>();
<a name="l00892"></a>00892   <span class="keywordflow">for</span> (; node_it != node_end; ++node_it)
<a name="l00893"></a>00893     {
<a name="l00894"></a>00894       <a class="code" href="classlibMesh_1_1Node.php">Node</a> *obj = *node_it;
<a name="l00895"></a>00895       libmesh_assert(obj);
<a name="l00896"></a>00896       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DofMap.php#aee89c467613b296c215421d60d5ae961">n_variables</a> = obj-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a7c666bde4f1a0a23a8661afc52621a44">n_vars</a>(this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#a244e7a1cd82d5e6ae8780c93205ec1fa">sys_number</a>());
<a name="l00897"></a>00897       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> v=0; v != <a class="code" href="classlibMesh_1_1DofMap.php#aee89c467613b296c215421d60d5ae961">n_variables</a>; ++v)
<a name="l00898"></a>00898         {
<a name="l00899"></a>00899           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_comp =
<a name="l00900"></a>00900             obj-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a6710a2bb047a60ef54bfe702432114f8">n_comp</a>(this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#a244e7a1cd82d5e6ae8780c93205ec1fa">sys_number</a>(), v);
<a name="l00901"></a>00901           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DofMap.php#ad2b15648e708f656a798bd642c3ca8e3">first_dof</a> = n_comp ?
<a name="l00902"></a>00902             obj-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a99664433bae4e638f8befc83cec4eeff">dof_number</a>(this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#a244e7a1cd82d5e6ae8780c93205ec1fa">sys_number</a>(), v, 0) : 0;
<a name="l00903"></a>00903           libmesh_assert(first_dof != <a class="code" href="classlibMesh_1_1DofObject.php#a1801e332bf034abe252086db668fee2d">DofObject::invalid_id</a>);
<a name="l00904"></a>00904         }
<a name="l00905"></a>00905     }
<a name="l00906"></a>00906 <span class="preprocessor">#endif // DEBUG</span>
<a name="l00907"></a>00907 <span class="preprocessor"></span>}
<a name="l00908"></a>00908 
<a name="l00909"></a>00909 
<a name="l00910"></a>00910 
<a name="l00911"></a><a class="code" href="classlibMesh_1_1DofMap.php#a55f4e20c43c4d9b726702ece1c6b9cdc">00911</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#a55f4e20c43c4d9b726702ece1c6b9cdc">DofMap::distribute_local_dofs_var_major</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> &amp;next_free_dof,
<a name="l00912"></a>00912                                              <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>)
<a name="l00913"></a>00913 {
<a name="l00914"></a>00914   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sys_num = this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#a244e7a1cd82d5e6ae8780c93205ec1fa">sys_number</a>();
<a name="l00915"></a>00915   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="tecplot__io_8C.php#ac001e4247887b98c2aa5b8ec5107ca0d">n_vars</a>  = this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#aee89c467613b296c215421d60d5ae961">n_variables</a>();
<a name="l00916"></a>00916 
<a name="l00917"></a>00917   <span class="comment">// We now only add remote dofs to the _send_list</span>
<a name="l00918"></a>00918   <span class="comment">// unsigned int send_list_size = 0;</span>
<a name="l00919"></a>00919 
<a name="l00920"></a>00920   <span class="comment">// We will cache the first local index for each variable</span>
<a name="l00921"></a>00921   <a class="code" href="classlibMesh_1_1DofMap.php#ac2cd47f78f1cf8bbdba640f56ef96afa">_var_first_local_df</a>.clear();
<a name="l00922"></a>00922 
<a name="l00923"></a>00923   <span class="comment">//-------------------------------------------------------------------------</span>
<a name="l00924"></a>00924   <span class="comment">// First count and assign temporary numbers to local dofs</span>
<a name="l00925"></a>00925   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> var=0; var&lt;<a class="code" href="tecplot__io_8C.php#ac001e4247887b98c2aa5b8ec5107ca0d">n_vars</a>; var++)
<a name="l00926"></a>00926     {
<a name="l00927"></a>00927       <a class="code" href="classlibMesh_1_1DofMap.php#ac2cd47f78f1cf8bbdba640f56ef96afa">_var_first_local_df</a>.push_back(next_free_dof);
<a name="l00928"></a>00928 
<a name="l00929"></a>00929       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Variable.php">Variable</a> var_description = this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#ab36a0dc3c2c457fa8c01c1b0ba37facc">variable</a>(var);
<a name="l00930"></a>00930 
<a name="l00931"></a>00931       <span class="comment">// Skip the SCALAR dofs</span>
<a name="l00932"></a>00932       <span class="keywordflow">if</span>(var_description.<a class="code" href="classlibMesh_1_1Variable.php#a8dcb07137d70a83fcf5b412e08e2783e">type</a>().<a class="code" href="classlibMesh_1_1FEType.php#ac437ba9b0a5253d6bf6f07ad277b9978">family</a> == <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a2ab36d7da9f38141601fd010d729e893">SCALAR</a>)
<a name="l00933"></a>00933         <span class="keywordflow">continue</span>;
<a name="l00934"></a>00934 
<a name="l00935"></a>00935       <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       elem_it  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a99742bad0b034a29ccae8c5a90c6f4aa">active_local_elements_begin</a>();
<a name="l00936"></a>00936       <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> elem_end = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a2e27f54d33f7539c0c06b36adae36cda">active_local_elements_end</a>();
<a name="l00937"></a>00937 
<a name="l00938"></a>00938       <span class="keywordflow">for</span> ( ; elem_it != elem_end; ++elem_it)
<a name="l00939"></a>00939         {
<a name="l00940"></a>00940           <span class="comment">// Only number dofs connected to active</span>
<a name="l00941"></a>00941           <span class="comment">// elements on this processor.</span>
<a name="l00942"></a>00942           <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem  = *elem_it;
<a name="l00943"></a>00943 
<a name="l00944"></a>00944           <span class="comment">// ... and only variables which are active on</span>
<a name="l00945"></a>00945           <span class="comment">// on this element&#39;s subdomain</span>
<a name="l00946"></a>00946           <span class="keywordflow">if</span> (!var_description.<a class="code" href="classlibMesh_1_1Variable.php#a94ff035823801db20635514405af60be">active_on_subdomain</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a96faae17e7ede5aa89c687d54cefb4b3">subdomain_id</a>()))
<a name="l00947"></a>00947             <span class="keywordflow">continue</span>;
<a name="l00948"></a>00948 
<a name="l00949"></a>00949           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="tecplot__io_8C.php#ad00604777dd9213f9627d8f12e3b2790">n_nodes</a> = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>();
<a name="l00950"></a>00950           
<a name="l00951"></a>00951           <span class="comment">// First number the nodal DOFS</span>
<a name="l00952"></a>00952           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;<a class="code" href="tecplot__io_8C.php#ad00604777dd9213f9627d8f12e3b2790">n_nodes</a>; n++)
<a name="l00953"></a>00953             {
<a name="l00954"></a>00954               <a class="code" href="classlibMesh_1_1Node.php">Node</a>* node = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(n);
<a name="l00955"></a>00955               
<a name="l00956"></a>00956               <span class="comment">// assign dof numbers (all at once) if this is</span>
<a name="l00957"></a>00957               <span class="comment">// our node and if they aren&#39;t already there</span>
<a name="l00958"></a>00958               <span class="keywordflow">if</span> ((node-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a6710a2bb047a60ef54bfe702432114f8">n_comp</a>(sys_num,var) &gt; 0) &amp;&amp;
<a name="l00959"></a>00959                   (node-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">processor_id</a>() == <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>()) &amp;&amp;
<a name="l00960"></a>00960                   (node-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a99664433bae4e638f8befc83cec4eeff">dof_number</a>(sys_num,var,0) ==
<a name="l00961"></a>00961                    <a class="code" href="classlibMesh_1_1DofObject.php#a1801e332bf034abe252086db668fee2d">DofObject::invalid_id</a>))
<a name="l00962"></a>00962                 {
<a name="l00963"></a>00963                   node-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#ae48fb571482cb01744308449089ca6ee">set_dof_number</a>(sys_num,
<a name="l00964"></a>00964                                        var,
<a name="l00965"></a>00965                                        0,
<a name="l00966"></a>00966                                        next_free_dof);
<a name="l00967"></a>00967                   next_free_dof += node-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a6710a2bb047a60ef54bfe702432114f8">n_comp</a>(sys_num,var);
<a name="l00968"></a>00968                 }
<a name="l00969"></a>00969             }
<a name="l00970"></a>00970                   
<a name="l00971"></a>00971           <span class="comment">// Now number the element DOFS</span>
<a name="l00972"></a>00972           <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a6710a2bb047a60ef54bfe702432114f8">n_comp</a>(sys_num,var) &gt; 0)
<a name="l00973"></a>00973             {
<a name="l00974"></a>00974               libmesh_assert (elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a99664433bae4e638f8befc83cec4eeff">dof_number</a>(sys_num,var,0) ==
<a name="l00975"></a>00975                       <a class="code" href="classlibMesh_1_1DofObject.php#a1801e332bf034abe252086db668fee2d">DofObject::invalid_id</a>);
<a name="l00976"></a>00976 
<a name="l00977"></a>00977               elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#ae48fb571482cb01744308449089ca6ee">set_dof_number</a>(sys_num,
<a name="l00978"></a>00978                                    var,
<a name="l00979"></a>00979                                    0,
<a name="l00980"></a>00980                                    next_free_dof);
<a name="l00981"></a>00981 
<a name="l00982"></a>00982               next_free_dof += elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a6710a2bb047a60ef54bfe702432114f8">n_comp</a>(sys_num,var);
<a name="l00983"></a>00983             }
<a name="l00984"></a>00984         } <span class="comment">// end loop on elements</span>
<a name="l00985"></a>00985     } <span class="comment">// end loop on variables</span>
<a name="l00986"></a>00986 
<a name="l00987"></a>00987   <span class="comment">// Finally, count up the SCALAR dofs</span>
<a name="l00988"></a>00988   this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#ae4795cf1e08ba233dec67fe06b36873b">_n_SCALAR_dofs</a> = 0;
<a name="l00989"></a>00989   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> var=0; var&lt;<a class="code" href="tecplot__io_8C.php#ac001e4247887b98c2aa5b8ec5107ca0d">n_vars</a>; var++)
<a name="l00990"></a>00990     {
<a name="l00991"></a>00991       <span class="keywordflow">if</span>( this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#ab36a0dc3c2c457fa8c01c1b0ba37facc">variable</a>(var).type().family == <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a2ab36d7da9f38141601fd010d729e893">SCALAR</a> )
<a name="l00992"></a>00992         {
<a name="l00993"></a>00993           this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#ae4795cf1e08ba233dec67fe06b36873b">_n_SCALAR_dofs</a> += this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#ab36a0dc3c2c457fa8c01c1b0ba37facc">variable</a>(var).<a class="code" href="classlibMesh_1_1Variable.php#a8dcb07137d70a83fcf5b412e08e2783e">type</a>().<a class="code" href="classlibMesh_1_1FEType.php#aa2484e0f6721f3e34dedebccacc48ac1">order</a>;
<a name="l00994"></a>00994           <span class="keywordflow">continue</span>;
<a name="l00995"></a>00995         }
<a name="l00996"></a>00996     }
<a name="l00997"></a>00997 
<a name="l00998"></a>00998   <span class="comment">// Only increment next_free_dof if we&#39;re on the processor</span>
<a name="l00999"></a>00999   <span class="comment">// that holds this SCALAR variable</span>
<a name="l01000"></a>01000   <span class="keywordflow">if</span> ( <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>()-1) )
<a name="l01001"></a>01001     next_free_dof += <a class="code" href="classlibMesh_1_1DofMap.php#ae4795cf1e08ba233dec67fe06b36873b">_n_SCALAR_dofs</a>;
<a name="l01002"></a>01002 
<a name="l01003"></a>01003   <span class="comment">// Cache the last local dof number too</span>
<a name="l01004"></a>01004   <a class="code" href="classlibMesh_1_1DofMap.php#ac2cd47f78f1cf8bbdba640f56ef96afa">_var_first_local_df</a>.push_back(next_free_dof);
<a name="l01005"></a>01005 
<a name="l01006"></a>01006 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l01007"></a>01007 <span class="preprocessor"></span>  <span class="comment">// Make sure we didn&#39;t miss any nodes</span>
<a name="l01008"></a>01008   <a class="code" href="namespacelibMesh_1_1MeshTools.php#a4413b39e0439b2e5535c9a9f962ea3fd">MeshTools::libmesh_assert_valid_node_procids</a>(mesh);
<a name="l01009"></a>01009 
<a name="l01010"></a>01010   <a class="code" href="structlibMesh_1_1MeshBase_1_1node__iterator.php">MeshBase::node_iterator</a>       node_it  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a7a87dbe56aaa89961e03d60a25a36e8b">local_nodes_begin</a>();
<a name="l01011"></a>01011   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1node__iterator.php">MeshBase::node_iterator</a> node_end = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ad0daaecd9c183194a99609db6507198c">local_nodes_end</a>();
<a name="l01012"></a>01012   <span class="keywordflow">for</span> (; node_it != node_end; ++node_it)
<a name="l01013"></a>01013     {
<a name="l01014"></a>01014       <a class="code" href="classlibMesh_1_1Node.php">Node</a> *obj = *node_it;
<a name="l01015"></a>01015       libmesh_assert(obj);
<a name="l01016"></a>01016       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DofMap.php#aee89c467613b296c215421d60d5ae961">n_variables</a> = obj-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a7c666bde4f1a0a23a8661afc52621a44">n_vars</a>(this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#a244e7a1cd82d5e6ae8780c93205ec1fa">sys_number</a>());
<a name="l01017"></a>01017       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> v=0; v != <a class="code" href="classlibMesh_1_1DofMap.php#aee89c467613b296c215421d60d5ae961">n_variables</a>; ++v)
<a name="l01018"></a>01018         {
<a name="l01019"></a>01019           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_comp =
<a name="l01020"></a>01020             obj-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a6710a2bb047a60ef54bfe702432114f8">n_comp</a>(this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#a244e7a1cd82d5e6ae8780c93205ec1fa">sys_number</a>(), v);
<a name="l01021"></a>01021           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DofMap.php#ad2b15648e708f656a798bd642c3ca8e3">first_dof</a> = n_comp ?
<a name="l01022"></a>01022             obj-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a99664433bae4e638f8befc83cec4eeff">dof_number</a>(this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#a244e7a1cd82d5e6ae8780c93205ec1fa">sys_number</a>(), v, 0) : 0;
<a name="l01023"></a>01023           libmesh_assert(first_dof != <a class="code" href="classlibMesh_1_1DofObject.php#a1801e332bf034abe252086db668fee2d">DofObject::invalid_id</a>);
<a name="l01024"></a>01024         }
<a name="l01025"></a>01025     }
<a name="l01026"></a>01026 <span class="preprocessor">#endif // DEBUG</span>
<a name="l01027"></a>01027 <span class="preprocessor"></span>}
<a name="l01028"></a>01028 
<a name="l01029"></a>01029 
<a name="l01030"></a>01030 
<a name="l01031"></a><a class="code" href="classlibMesh_1_1DofMap.php#aed8eba054300e64164af4a8257bae8d8">01031</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#aed8eba054300e64164af4a8257bae8d8">DofMap::add_neighbors_to_send_list</a>(<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>)
<a name="l01032"></a>01032 {
<a name="l01033"></a>01033   START_LOG(<span class="stringliteral">&quot;add_neighbors_to_send_list()&quot;</span>, <span class="stringliteral">&quot;DofMap&quot;</span>);
<a name="l01034"></a>01034 
<a name="l01035"></a>01035   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sys_num = this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#a244e7a1cd82d5e6ae8780c93205ec1fa">sys_number</a>();
<a name="l01036"></a>01036   
<a name="l01037"></a>01037   <span class="comment">//-------------------------------------------------------------------------</span>
<a name="l01038"></a>01038   <span class="comment">// We need to add the DOFs from elements that live on neighboring processors</span>
<a name="l01039"></a>01039   <span class="comment">// that are neighbors of the elements on the local processor</span>
<a name="l01040"></a>01040   <span class="comment">//-------------------------------------------------------------------------</span>
<a name="l01041"></a>01041 
<a name="l01042"></a>01042   <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>       local_elem_it
<a name="l01043"></a>01043     = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a99742bad0b034a29ccae8c5a90c6f4aa">active_local_elements_begin</a>();
<a name="l01044"></a>01044   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> local_elem_end
<a name="l01045"></a>01045     = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a2e27f54d33f7539c0c06b36adae36cda">active_local_elements_end</a>(); 
<a name="l01046"></a>01046 
<a name="l01047"></a>01047   std::vector&lt;bool&gt; node_on_processor(mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a9778fcd4d5fc7687babdf9a5ea56d882">max_node_id</a>(), <span class="keyword">false</span>);
<a name="l01048"></a>01048   std::vector&lt;unsigned int&gt; di;
<a name="l01049"></a>01049   std::vector&lt;const Elem *&gt; family;
<a name="l01050"></a>01050 
<a name="l01051"></a>01051   <span class="comment">// Loop over the active local elements, adding all active elements</span>
<a name="l01052"></a>01052   <span class="comment">// that neighbor an active local element to the send list.</span>
<a name="l01053"></a>01053   <span class="keywordflow">for</span> ( ; local_elem_it != local_elem_end; ++local_elem_it)
<a name="l01054"></a>01054     {
<a name="l01055"></a>01055       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = *local_elem_it;
<a name="l01056"></a>01056 
<a name="l01057"></a>01057       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n!=elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>(); n++)
<a name="l01058"></a>01058         {
<a name="l01059"></a>01059           <span class="comment">// Flag all the nodes of active local elements as seen, so</span>
<a name="l01060"></a>01060           <span class="comment">// we can add nodal neighbor dofs to the send_list later.</span>
<a name="l01061"></a>01061           node_on_processor[elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(n)] = <span class="keyword">true</span>;
<a name="l01062"></a>01062 
<a name="l01063"></a>01063           <span class="comment">// Add all remote dofs on these nodes to the send_list.</span>
<a name="l01064"></a>01064           <span class="comment">// This is necessary in case those dofs are *not* also dofs</span>
<a name="l01065"></a>01065           <span class="comment">// on neighbors; e.g. in the case of a HIERARCHIC&#39;s local</span>
<a name="l01066"></a>01066           <span class="comment">// side which is only a vertex on the neighbor that owns it.</span>
<a name="l01067"></a>01067           <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a>* node = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(n);
<a name="l01068"></a>01068           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <a class="code" href="tecplot__io_8C.php#ac001e4247887b98c2aa5b8ec5107ca0d">n_vars</a> = node-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a7c666bde4f1a0a23a8661afc52621a44">n_vars</a>(sys_num);
<a name="l01069"></a>01069           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> v=0; v != <a class="code" href="tecplot__io_8C.php#ac001e4247887b98c2aa5b8ec5107ca0d">n_vars</a>; ++v)
<a name="l01070"></a>01070             {
<a name="l01071"></a>01071               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_comp = node-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a6710a2bb047a60ef54bfe702432114f8">n_comp</a>(sys_num, v);
<a name="l01072"></a>01072               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c != n_comp; ++c)
<a name="l01073"></a>01073                 {
<a name="l01074"></a>01074                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> di = node-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a99664433bae4e638f8befc83cec4eeff">dof_number</a>(sys_num, v, c);
<a name="l01075"></a>01075                   <span class="keywordflow">if</span> (di &lt; this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#ad2b15648e708f656a798bd642c3ca8e3">first_dof</a>() || di &gt;= this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#abf250ac3decfedbe00ddaeef85ed4de4">end_dof</a>())
<a name="l01076"></a>01076                     <a class="code" href="classlibMesh_1_1DofMap.php#a66d63042b6f4dce2ef98a1573ff6b2ad">_send_list</a>.push_back(di);
<a name="l01077"></a>01077                 }
<a name="l01078"></a>01078             }
<a name="l01079"></a>01079         }
<a name="l01080"></a>01080 
<a name="l01081"></a>01081       <span class="comment">// Loop over the neighbors of those elements</span>
<a name="l01082"></a>01082       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s=0; s&lt;elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adf36086a897fdef3a88deec071ca5dfd">n_neighbors</a>(); s++)
<a name="l01083"></a>01083         <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(s) != NULL)
<a name="l01084"></a>01084           {
<a name="l01085"></a>01085             family.clear();
<a name="l01086"></a>01086             
<a name="l01087"></a>01087             <span class="comment">// Find all the active elements that neighbor elem</span>
<a name="l01088"></a>01088 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l01089"></a>01089 <span class="preprocessor"></span>            <span class="keywordflow">if</span> (!elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(s)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ab426ef9274eb93de879fef28b027d602">active</a>())
<a name="l01090"></a>01090               elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(s)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a93229ab6804e5876a99368817120d9c3">active_family_tree_by_neighbor</a>(family, elem);
<a name="l01091"></a>01091             <span class="keywordflow">else</span>
<a name="l01092"></a>01092 <span class="preprocessor">#endif</span>
<a name="l01093"></a>01093 <span class="preprocessor"></span>              family.push_back(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(s));
<a name="l01094"></a>01094 
<a name="l01095"></a>01095             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i!=family.size(); ++i)
<a name="l01096"></a>01096               <span class="comment">// If the neighbor lives on a different processor</span>
<a name="l01097"></a>01097               <span class="keywordflow">if</span> (family[i]-&gt;<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">processor_id</a>() != <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>())
<a name="l01098"></a>01098                 {
<a name="l01099"></a>01099                   <span class="comment">// Get the DOF indices for this neighboring element</span>
<a name="l01100"></a>01100                   this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#a5dac22ba99a9da3563c00b7dfd2f07af">dof_indices</a> (family[i], di);
<a name="l01101"></a>01101 
<a name="l01102"></a>01102                   <span class="comment">// Insert the remote DOF indices into the send list</span>
<a name="l01103"></a>01103                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j != di.size(); ++j)
<a name="l01104"></a>01104                     <span class="keywordflow">if</span> (di[j] &lt; this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#ad2b15648e708f656a798bd642c3ca8e3">first_dof</a>() ||
<a name="l01105"></a>01105                         di[j] &gt;= this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#abf250ac3decfedbe00ddaeef85ed4de4">end_dof</a>())
<a name="l01106"></a>01106                       <a class="code" href="classlibMesh_1_1DofMap.php#a66d63042b6f4dce2ef98a1573ff6b2ad">_send_list</a>.push_back(di[j]);
<a name="l01107"></a>01107                 }
<a name="l01108"></a>01108           }
<a name="l01109"></a>01109     }
<a name="l01110"></a>01110 
<a name="l01111"></a>01111   <span class="comment">// Now loop over all non_local active elements and add any missing</span>
<a name="l01112"></a>01112   <span class="comment">// nodal-only neighbors.  This will also get any dofs from nonlocal</span>
<a name="l01113"></a>01113   <span class="comment">// nodes on local elements, because every nonlocal node exists on a</span>
<a name="l01114"></a>01114   <span class="comment">// nonlocal nodal neighbor element.</span>
<a name="l01115"></a>01115   <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>       elem_it
<a name="l01116"></a>01116     = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aefa4ded9eaf654a45ab593a0963ecbf3">active_elements_begin</a>();
<a name="l01117"></a>01117   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> elem_end
<a name="l01118"></a>01118     = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ae3f09f1b7556aef88919249861728e23">active_elements_end</a>();
<a name="l01119"></a>01119   
<a name="l01120"></a>01120   <span class="keywordflow">for</span> ( ; elem_it != elem_end; ++elem_it)
<a name="l01121"></a>01121     {
<a name="l01122"></a>01122       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = *elem_it;
<a name="l01123"></a>01123 
<a name="l01124"></a>01124       <span class="comment">// If this is one of our elements, we&#39;ve already added it</span>
<a name="l01125"></a>01125       <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">processor_id</a>() == <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>())
<a name="l01126"></a>01126         <span class="keywordflow">continue</span>;
<a name="l01127"></a>01127 
<a name="l01128"></a>01128       <span class="comment">// Do we need to add the element DOFs?</span>
<a name="l01129"></a>01129       <span class="keywordtype">bool</span> add_elem_dofs = <span class="keyword">false</span>;
<a name="l01130"></a>01130       
<a name="l01131"></a>01131       <span class="comment">// Check all the nodes of the element to see if it</span>
<a name="l01132"></a>01132       <span class="comment">// shares a node with us</span>
<a name="l01133"></a>01133       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n!=elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>(); n++)
<a name="l01134"></a>01134         <span class="keywordflow">if</span> (node_on_processor[elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(n)])
<a name="l01135"></a>01135           add_elem_dofs = <span class="keyword">true</span>;
<a name="l01136"></a>01136 
<a name="l01137"></a>01137       <span class="comment">// Add the element degrees of freedom if it shares at</span>
<a name="l01138"></a>01138       <span class="comment">// least one node.</span>
<a name="l01139"></a>01139       <span class="keywordflow">if</span> (add_elem_dofs)
<a name="l01140"></a>01140         {
<a name="l01141"></a>01141           <span class="comment">// Get the DOF indices for this neighboring element</span>
<a name="l01142"></a>01142           this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#a5dac22ba99a9da3563c00b7dfd2f07af">dof_indices</a> (elem, di);
<a name="l01143"></a>01143 
<a name="l01144"></a>01144           <span class="comment">// Insert the remote DOF indices into the send list</span>
<a name="l01145"></a>01145             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j != di.size(); ++j)
<a name="l01146"></a>01146               <span class="keywordflow">if</span> (di[j] &lt; this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#ad2b15648e708f656a798bd642c3ca8e3">first_dof</a>() ||
<a name="l01147"></a>01147                   di[j] &gt;= this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#abf250ac3decfedbe00ddaeef85ed4de4">end_dof</a>())
<a name="l01148"></a>01148                 <a class="code" href="classlibMesh_1_1DofMap.php#a66d63042b6f4dce2ef98a1573ff6b2ad">_send_list</a>.push_back(di[j]);
<a name="l01149"></a>01149         }
<a name="l01150"></a>01150     }
<a name="l01151"></a>01151   
<a name="l01152"></a>01152   STOP_LOG(<span class="stringliteral">&quot;add_neighbors_to_send_list()&quot;</span>, <span class="stringliteral">&quot;DofMap&quot;</span>);
<a name="l01153"></a>01153 }
<a name="l01154"></a>01154 
<a name="l01155"></a>01155 
<a name="l01156"></a>01156 
<a name="l01157"></a><a class="code" href="classlibMesh_1_1DofMap.php#a47865aeb6379c68169e926dd0ecc2b71">01157</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#a47865aeb6379c68169e926dd0ecc2b71">DofMap::prepare_send_list</a> ()
<a name="l01158"></a>01158 {
<a name="l01159"></a>01159   START_LOG(<span class="stringliteral">&quot;prepare_send_list()&quot;</span>, <span class="stringliteral">&quot;DofMap&quot;</span>);
<a name="l01160"></a>01160   
<a name="l01161"></a>01161   <span class="comment">// First sort the send list.  After this</span>
<a name="l01162"></a>01162   <span class="comment">// duplicated elements will be adjacent in the</span>
<a name="l01163"></a>01163   <span class="comment">// vector</span>
<a name="l01164"></a>01164   std::sort(<a class="code" href="classlibMesh_1_1DofMap.php#a66d63042b6f4dce2ef98a1573ff6b2ad">_send_list</a>.begin(), <a class="code" href="classlibMesh_1_1DofMap.php#a66d63042b6f4dce2ef98a1573ff6b2ad">_send_list</a>.end());
<a name="l01165"></a>01165 
<a name="l01166"></a>01166   <span class="comment">// Now use std::unique to remove duplicate entries  </span>
<a name="l01167"></a>01167   std::vector&lt;unsigned int&gt;::iterator new_end =
<a name="l01168"></a>01168     std::unique (<a class="code" href="classlibMesh_1_1DofMap.php#a66d63042b6f4dce2ef98a1573ff6b2ad">_send_list</a>.begin(), <a class="code" href="classlibMesh_1_1DofMap.php#a66d63042b6f4dce2ef98a1573ff6b2ad">_send_list</a>.end());
<a name="l01169"></a>01169 
<a name="l01170"></a>01170   <span class="comment">// Remove the end of the send_list.  Use the &quot;swap trick&quot;</span>
<a name="l01171"></a>01171   <span class="comment">// from Effective STL</span>
<a name="l01172"></a>01172   std::vector&lt;unsigned int&gt; (<a class="code" href="classlibMesh_1_1DofMap.php#a66d63042b6f4dce2ef98a1573ff6b2ad">_send_list</a>.begin(), new_end).swap (<a class="code" href="classlibMesh_1_1DofMap.php#a66d63042b6f4dce2ef98a1573ff6b2ad">_send_list</a>);
<a name="l01173"></a>01173   
<a name="l01174"></a>01174   STOP_LOG(<span class="stringliteral">&quot;prepare_send_list()&quot;</span>, <span class="stringliteral">&quot;DofMap&quot;</span>);
<a name="l01175"></a>01175 }
<a name="l01176"></a>01176 
<a name="l01177"></a>01177 
<a name="l01178"></a>01178 
<a name="l01179"></a><a class="code" href="classlibMesh_1_1DofMap.php#a2489e7c067abb05feba00459ac70a1ba">01179</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1DofMap.php#a2489e7c067abb05feba00459ac70a1ba">DofMap::use_coupled_neighbor_dofs</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>)<span class="keyword"> const</span>
<a name="l01180"></a>01180 <span class="keyword"></span>{
<a name="l01181"></a>01181   <span class="comment">// If we were asked on the command line, then we need to</span>
<a name="l01182"></a>01182   <span class="comment">// include sensitivities between neighbor degrees of freedom</span>
<a name="l01183"></a>01183   <span class="keywordtype">bool</span> implicit_neighbor_dofs = 
<a name="l01184"></a>01184     <a class="code" href="namespacelibMesh.php#ad19739ed0fdd45f048901a13954369b6">libMesh::on_command_line</a> (<span class="stringliteral">&quot;--implicit_neighbor_dofs&quot;</span>);
<a name="l01185"></a>01185 
<a name="l01186"></a>01186   <span class="comment">// look at all the variables in this system.  If every one is</span>
<a name="l01187"></a>01187   <span class="comment">// discontinuous then the user must be doing DG/FVM, so be nice</span>
<a name="l01188"></a>01188   <span class="comment">// and  force implicit_neighbor_dofs=true</span>
<a name="l01189"></a>01189   {
<a name="l01190"></a>01190     <span class="keywordtype">bool</span> all_discontinuous_dofs = <span class="keyword">true</span>;
<a name="l01191"></a>01191     
<a name="l01192"></a>01192     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var=0; var&lt;this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#aee89c467613b296c215421d60d5ae961">n_variables</a>(); var++)
<a name="l01193"></a>01193       <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1FEBase.php#aa6065b49a9dd684109a87770e514ff5d">FEBase::build</a> (mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1bc787d29f4c496f107aed988be4b9bf">mesh_dimension</a>(),
<a name="l01194"></a>01194                          this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#a0c010bb250d4cd8d65794452f46d141a">variable_type</a>(var))-&gt;get_continuity() !=  <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a06624ba73875d1537d4422952c08a782">DISCONTINUOUS</a>)
<a name="l01195"></a>01195         all_discontinuous_dofs = <span class="keyword">false</span>;
<a name="l01196"></a>01196 
<a name="l01197"></a>01197     <span class="keywordflow">if</span> (all_discontinuous_dofs)
<a name="l01198"></a>01198       implicit_neighbor_dofs = <span class="keyword">true</span>;
<a name="l01199"></a>01199   }
<a name="l01200"></a>01200   
<a name="l01201"></a>01201   <span class="keywordflow">return</span> implicit_neighbor_dofs;
<a name="l01202"></a>01202 }
<a name="l01203"></a>01203 
<a name="l01204"></a>01204 
<a name="l01205"></a>01205 
<a name="l01206"></a><a class="code" href="classlibMesh_1_1DofMap.php#a49379ce3a542eab41a8f8e44d0f154c2">01206</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#a49379ce3a542eab41a8f8e44d0f154c2">DofMap::compute_sparsity</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>)
<a name="l01207"></a>01207 {
<a name="l01208"></a>01208   libmesh_assert (mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aef78858f228f672f3587b19c2bbd5fce">is_prepared</a>());
<a name="l01209"></a>01209   libmesh_assert (this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#aee89c467613b296c215421d60d5ae961">n_variables</a>());
<a name="l01210"></a>01210 
<a name="l01211"></a>01211   START_LOG(<span class="stringliteral">&quot;compute_sparsity()&quot;</span>, <span class="stringliteral">&quot;DofMap&quot;</span>);
<a name="l01212"></a>01212 
<a name="l01213"></a>01213   <span class="comment">// Compute the sparsity structure of the global matrix.  This can be</span>
<a name="l01214"></a>01214   <span class="comment">// fed into a PetscMatrix to allocate exacly the number of nonzeros</span>
<a name="l01215"></a>01215   <span class="comment">// necessary to store the matrix.  This algorithm should be linear</span>
<a name="l01216"></a>01216   <span class="comment">// in the (# of elements)*(# nodes per element)</span>
<a name="l01217"></a>01217 
<a name="l01218"></a>01218   <span class="comment">// We can be more efficient in the threaded sparsity pattern assembly</span>
<a name="l01219"></a>01219   <span class="comment">// if we don&#39;t need the exact pattern.  For some sparse matrix formats</span>
<a name="l01220"></a>01220   <span class="comment">// a good upper bound will suffice.</span>
<a name="l01221"></a>01221   <span class="keywordtype">bool</span> need_full_sparsity_pattern=<span class="keyword">false</span>;
<a name="l01222"></a>01222   std::vector&lt;SparseMatrix&lt;Number&gt;* &gt;::iterator
<a name="l01223"></a>01223     pos = <a class="code" href="classlibMesh_1_1DofMap.php#a29ff2098ced1859cd5296af428435d73">_matrices</a>.begin(),
<a name="l01224"></a>01224     end = <a class="code" href="classlibMesh_1_1DofMap.php#a29ff2098ced1859cd5296af428435d73">_matrices</a>.end();
<a name="l01225"></a>01225       
<a name="l01226"></a>01226   <span class="keywordflow">for</span> (; pos != end; ++pos)
<a name="l01227"></a>01227     <span class="keywordflow">if</span> ((*pos)-&gt;need_full_sparsity_pattern())
<a name="l01228"></a>01228       need_full_sparsity_pattern = <span class="keyword">true</span>;
<a name="l01229"></a>01229 
<a name="l01230"></a>01230   <span class="comment">// See if we need to include sparsity pattern entries for coupling</span>
<a name="l01231"></a>01231   <span class="comment">// between neighbor dofs</span>
<a name="l01232"></a>01232   <span class="keywordtype">bool</span> implicit_neighbor_dofs = this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#a2489e7c067abb05feba00459ac70a1ba">use_coupled_neighbor_dofs</a>(mesh);
<a name="l01233"></a>01233   
<a name="l01234"></a>01234   <span class="comment">// We can compute the sparsity pattern in parallel on multiple</span>
<a name="l01235"></a>01235   <span class="comment">// threads.  The goal is for each thread to compute the full sparsity</span>
<a name="l01236"></a>01236   <span class="comment">// pattern for a subset of elements.  These sparsity patterns can</span>
<a name="l01237"></a>01237   <span class="comment">// be efficiently merged in the SparsityPattern::Build::join()</span>
<a name="l01238"></a>01238   <span class="comment">// method, especially if there is not too much overlap between them.</span>
<a name="l01239"></a>01239   <span class="comment">// Even better, if the full sparsity pattern is not needed then</span>
<a name="l01240"></a>01240   <span class="comment">// the number of nonzeros per row can be estimated from the</span>
<a name="l01241"></a>01241   <span class="comment">// sparsity patterns created on each thread.</span>
<a name="l01242"></a>01242   <a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php">SparsityPattern::Build</a> sp (mesh,
<a name="l01243"></a>01243                              *<span class="keyword">this</span>,
<a name="l01244"></a>01244                              <a class="code" href="classlibMesh_1_1DofMap.php#ab276e172c5488ab3b387b235e28556cf">_dof_coupling</a>,
<a name="l01245"></a>01245                              implicit_neighbor_dofs,
<a name="l01246"></a>01246                              need_full_sparsity_pattern);
<a name="l01247"></a>01247   
<a name="l01248"></a>01248   <a class="code" href="namespacelibMesh_1_1Threads.php#ab89ecaf19ab9f9d88629316cb341a4de">Threads::parallel_reduce</a> (<a class="code" href="classlibMesh_1_1StoredRange.php">ConstElemRange</a> (mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aefa4ded9eaf654a45ab593a0963ecbf3">active_elements_begin</a>(),
<a name="l01249"></a>01249                                             mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ae3f09f1b7556aef88919249861728e23">active_elements_end</a>()), sp);
<a name="l01250"></a>01250 
<a name="l01251"></a>01251 <span class="preprocessor">#ifndef NDEBUG</span>
<a name="l01252"></a>01252 <span class="preprocessor"></span>  <span class="comment">// Avoid declaring these variables unless asserts are enabled.</span>
<a name="l01253"></a>01253   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id        = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa557872c33163622cc66645fc393c925">processor_id</a>();
<a name="l01254"></a>01254   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_dofs_on_proc = this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#a93892a922e17e271f635262a9c8acf98">n_dofs_on_processor</a>(proc_id);
<a name="l01255"></a>01255 <span class="preprocessor">#endif</span>
<a name="l01256"></a>01256 <span class="preprocessor"></span>  libmesh_assert (sp.<a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php#a054aa3bf4ab1ff21352e2aaf2495c589">sparsity_pattern</a>.size() == n_dofs_on_proc);
<a name="l01257"></a>01257 
<a name="l01258"></a>01258   <span class="comment">// steal the n_nz and n_oz arrays from sp -- it won&#39;t need them any more,</span>
<a name="l01259"></a>01259   <span class="comment">// and this is more efficient than copying them.</span>
<a name="l01260"></a>01260   <a class="code" href="classlibMesh_1_1DofMap.php#a2f1f1ad0386f846409d903d5df18f114">_n_nz</a>.swap(sp.<a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php#a4624e244606dff65d27017738a51003f">n_nz</a>);
<a name="l01261"></a>01261   <a class="code" href="classlibMesh_1_1DofMap.php#a0b3879c0bf8ae122f12710bc32f17810">_n_oz</a>.swap(sp.<a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php#af51c83786a5f07846030c63a6d560c3f">n_oz</a>);
<a name="l01262"></a>01262   
<a name="l01263"></a>01263   STOP_LOG(<span class="stringliteral">&quot;compute_sparsity()&quot;</span>, <span class="stringliteral">&quot;DofMap&quot;</span>);
<a name="l01264"></a>01264   
<a name="l01265"></a>01265   <span class="comment">// We are done with the sparsity_pattern.  However, quite a</span>
<a name="l01266"></a>01266   <span class="comment">// lot has gone into computing it.  It is possible that some</span>
<a name="l01267"></a>01267   <span class="comment">// \p SparseMatrix implementations want to see it.  Let them</span>
<a name="l01268"></a>01268   <span class="comment">// see it before we throw it away.</span>
<a name="l01269"></a>01269   pos = <a class="code" href="classlibMesh_1_1DofMap.php#a29ff2098ced1859cd5296af428435d73">_matrices</a>.begin();
<a name="l01270"></a>01270   end = <a class="code" href="classlibMesh_1_1DofMap.php#a29ff2098ced1859cd5296af428435d73">_matrices</a>.end();
<a name="l01271"></a>01271       
<a name="l01272"></a>01272   <span class="keywordflow">for</span> (; pos != end; ++pos)
<a name="l01273"></a>01273     (*pos)-&gt;update_sparsity_pattern (sp.<a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php#a054aa3bf4ab1ff21352e2aaf2495c589">sparsity_pattern</a>);     
<a name="l01274"></a>01274 }
<a name="l01275"></a>01275 
<a name="l01276"></a>01276 
<a name="l01277"></a>01277 
<a name="l01278"></a><a class="code" href="classlibMesh_1_1DofMap.php#aa026159e90f65d37c08345a86072994f">01278</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#aa026159e90f65d37c08345a86072994f">DofMap::extract_local_vector</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>&amp; Ug,
<a name="l01279"></a>01279                                    <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices,
<a name="l01280"></a>01280                                    <a class="code" href="classlibMesh_1_1DenseVectorBase.php">DenseVectorBase&lt;Number&gt;</a>&amp; Ue)<span class="keyword"> const</span>
<a name="l01281"></a>01281 <span class="keyword"></span>{
<a name="l01282"></a>01282 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l01283"></a>01283 <span class="preprocessor"></span>
<a name="l01284"></a>01284   <span class="comment">// Trivial mapping</span>
<a name="l01285"></a>01285   libmesh_assert (dof_indices.size() == Ue.<a class="code" href="classlibMesh_1_1DenseVectorBase.php#a4ec1ad50c02f01beea21df4c29ed9736">size</a>());
<a name="l01286"></a>01286   <span class="keywordtype">bool</span> has_constrained_dofs = <span class="keyword">false</span>;
<a name="l01287"></a>01287 
<a name="l01288"></a>01288   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> il=0; il&lt;dof_indices.size(); il++)
<a name="l01289"></a>01289     {
<a name="l01290"></a>01290       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ig = dof_indices[il];
<a name="l01291"></a>01291 
<a name="l01292"></a>01292       <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#af59487b50683e231676f836f94cde1ab">is_constrained_dof</a> (ig)) has_constrained_dofs = <span class="keyword">true</span>;
<a name="l01293"></a>01293 
<a name="l01294"></a>01294       libmesh_assert (ig &lt; Ug.<a class="code" href="classlibMesh_1_1NumericVector.php#a86082d6030cb32700e7eeac6e7f26455">size</a>());
<a name="l01295"></a>01295 
<a name="l01296"></a>01296       Ue.<a class="code" href="classlibMesh_1_1DenseVectorBase.php#a35567e09039c62b9914def1fd063a73c">el</a>(il) = Ug(ig);
<a name="l01297"></a>01297     }
<a name="l01298"></a>01298 
<a name="l01299"></a>01299   <span class="comment">// If the element has any constrained DOFs then we need</span>
<a name="l01300"></a>01300   <span class="comment">// to account for them in the mapping.  This will handle</span>
<a name="l01301"></a>01301   <span class="comment">// the case that the input vector is not constrained.</span>
<a name="l01302"></a>01302   <span class="keywordflow">if</span> (has_constrained_dofs)
<a name="l01303"></a>01303     {
<a name="l01304"></a>01304       <span class="comment">// Copy the input DOF indices.</span>
<a name="l01305"></a>01305       std::vector&lt;unsigned int&gt; constrained_dof_indices(dof_indices);
<a name="l01306"></a>01306 
<a name="l01307"></a>01307       <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Number&gt;</a> C;
<a name="l01308"></a>01308 
<a name="l01309"></a>01309       this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#ab205c45f9397a3864d915a4bc558acbf">build_constraint_matrix</a> (C, constrained_dof_indices);
<a name="l01310"></a>01310 
<a name="l01311"></a>01311       libmesh_assert (dof_indices.size()             == C.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a68bd665fb9252382cc9a28df4099d76a">m</a>());
<a name="l01312"></a>01312       libmesh_assert (constrained_dof_indices.size() == C.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a4fb8c524109fd5dff8c98855437544ee">n</a>());
<a name="l01313"></a>01313 
<a name="l01314"></a>01314       <span class="comment">// zero-out Ue</span>
<a name="l01315"></a>01315       Ue.<a class="code" href="classlibMesh_1_1DenseVectorBase.php#a0c6c65a9c9b15317741c781903f45f83">zero</a>();
<a name="l01316"></a>01316 
<a name="l01317"></a>01317       <span class="comment">// compute Ue = C Ug, with proper mapping.</span>
<a name="l01318"></a>01318       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;dof_indices.size(); i++)
<a name="l01319"></a>01319         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;constrained_dof_indices.size(); j++)
<a name="l01320"></a>01320           {
<a name="l01321"></a>01321             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> jg = constrained_dof_indices[j];
<a name="l01322"></a>01322 
<a name="l01323"></a>01323             libmesh_assert ((jg &gt;= Ug.<a class="code" href="classlibMesh_1_1NumericVector.php#a313c2e8c69d74b3abd156b6b6fe415d1">first_local_index</a>()) &amp;&amp;
<a name="l01324"></a>01324                     (jg &lt;  Ug.<a class="code" href="classlibMesh_1_1NumericVector.php#aaacb6f0a99a041108211ce79ea934fe2">last_local_index</a>()));
<a name="l01325"></a>01325             
<a name="l01326"></a>01326             Ue.<a class="code" href="classlibMesh_1_1DenseVectorBase.php#a35567e09039c62b9914def1fd063a73c">el</a>(i) += C(i,j)*Ug(jg);      
<a name="l01327"></a>01327           }
<a name="l01328"></a>01328     }  
<a name="l01329"></a>01329    
<a name="l01330"></a>01330 <span class="preprocessor">#else</span>
<a name="l01331"></a>01331 <span class="preprocessor"></span>  
<a name="l01332"></a>01332   <span class="comment">// Trivial mapping</span>
<a name="l01333"></a>01333   libmesh_assert (dof_indices.size() == Ue.<a class="code" href="classlibMesh_1_1DenseVectorBase.php#a4ec1ad50c02f01beea21df4c29ed9736">size</a>());
<a name="l01334"></a>01334   
<a name="l01335"></a>01335   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> il=0; il&lt;dof_indices.size(); il++)
<a name="l01336"></a>01336     {
<a name="l01337"></a>01337       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ig = dof_indices[il];
<a name="l01338"></a>01338       
<a name="l01339"></a>01339       libmesh_assert ((ig &gt;= Ug.<a class="code" href="classlibMesh_1_1NumericVector.php#a313c2e8c69d74b3abd156b6b6fe415d1">first_local_index</a>()) &amp;&amp; (ig &lt;  Ug.<a class="code" href="classlibMesh_1_1NumericVector.php#aaacb6f0a99a041108211ce79ea934fe2">last_local_index</a>()));
<a name="l01340"></a>01340 
<a name="l01341"></a>01341       Ue.<a class="code" href="classlibMesh_1_1DenseVectorBase.php#a35567e09039c62b9914def1fd063a73c">el</a>(il) = Ug(ig);
<a name="l01342"></a>01342     }
<a name="l01343"></a>01343   
<a name="l01344"></a>01344 <span class="preprocessor">#endif</span>
<a name="l01345"></a>01345 <span class="preprocessor"></span>}
<a name="l01346"></a>01346 
<a name="l01347"></a><a class="code" href="classlibMesh_1_1DofMap.php#a5dac22ba99a9da3563c00b7dfd2f07af">01347</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#a5dac22ba99a9da3563c00b7dfd2f07af">DofMap::dof_indices</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <span class="keyword">const</span> elem,
<a name="l01348"></a>01348                           std::vector&lt;unsigned int&gt;&amp; di,
<a name="l01349"></a>01349                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> vn)<span class="keyword"> const</span>
<a name="l01350"></a>01350 <span class="keyword"></span>{
<a name="l01351"></a>01351   START_LOG(<span class="stringliteral">&quot;dof_indices()&quot;</span>, <span class="stringliteral">&quot;DofMap&quot;</span>);
<a name="l01352"></a>01352   
<a name="l01353"></a>01353   libmesh_assert (elem != NULL);
<a name="l01354"></a>01354   
<a name="l01355"></a>01355   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="tecplot__io_8C.php#ad00604777dd9213f9627d8f12e3b2790">n_nodes</a> = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>();
<a name="l01356"></a>01356   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type        = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad06f8ac22978144723179eed42d10bae">type</a>();
<a name="l01357"></a>01357   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sys_num = this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#a244e7a1cd82d5e6ae8780c93205ec1fa">sys_number</a>();
<a name="l01358"></a>01358   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="tecplot__io_8C.php#ac001e4247887b98c2aa5b8ec5107ca0d">n_vars</a>  = this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#aee89c467613b296c215421d60d5ae961">n_variables</a>();
<a name="l01359"></a>01359   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim     = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#aa50d97d65dc379f64667da53c427b36f">dim</a>();
<a name="l01360"></a>01360   
<a name="l01361"></a>01361   <span class="comment">// Clear the DOF indices vector</span>
<a name="l01362"></a>01362   di.clear();
<a name="l01363"></a>01363   
<a name="l01364"></a>01364 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l01365"></a>01365 <span class="preprocessor"></span>  <span class="comment">// Check that sizes match in DEBUG mode</span>
<a name="l01366"></a>01366   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> tot_size = 0;
<a name="l01367"></a>01367 <span class="preprocessor">#endif</span>
<a name="l01368"></a>01368 <span class="preprocessor"></span>
<a name="l01369"></a>01369   <span class="comment">// Create a vector to indicate which</span>
<a name="l01370"></a>01370   <span class="comment">// SCALAR variables have been requested</span>
<a name="l01371"></a>01371   std::vector&lt;unsigned int&gt; SCALAR_var_numbers;
<a name="l01372"></a>01372   SCALAR_var_numbers.clear();
<a name="l01373"></a>01373 
<a name="l01374"></a>01374   <span class="comment">// Get the dof numbers</span>
<a name="l01375"></a>01375   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> v=0; v&lt;<a class="code" href="tecplot__io_8C.php#ac001e4247887b98c2aa5b8ec5107ca0d">n_vars</a>; v++)
<a name="l01376"></a>01376     <span class="keywordflow">if</span> ((v == vn) || (vn == <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>))
<a name="l01377"></a>01377     {
<a name="l01378"></a>01378       <span class="keywordflow">if</span>(this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#ab36a0dc3c2c457fa8c01c1b0ba37facc">variable</a>(v).type().family == <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a2ab36d7da9f38141601fd010d729e893">SCALAR</a>)
<a name="l01379"></a>01379       {
<a name="l01380"></a>01380         <span class="comment">// We asked for this variable, so add it to the vector.</span>
<a name="l01381"></a>01381         SCALAR_var_numbers.push_back(v);
<a name="l01382"></a>01382 
<a name="l01383"></a>01383 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l01384"></a>01384 <span class="preprocessor"></span>        <a class="code" href="classlibMesh_1_1FEType.php">FEType</a> fe_type = this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#a0c010bb250d4cd8d65794452f46d141a">variable_type</a>(v);
<a name="l01385"></a>01385         tot_size += <a class="code" href="classlibMesh_1_1DofMap.php#ae014405975490bab74a4a7596c379990">FEInterface::n_dofs</a>(dim,
<a name="l01386"></a>01386                                         fe_type,
<a name="l01387"></a>01387                                         type);
<a name="l01388"></a>01388 <span class="preprocessor">#endif</span>
<a name="l01389"></a>01389 <span class="preprocessor"></span>      }
<a name="l01390"></a>01390       <span class="keywordflow">else</span>
<a name="l01391"></a>01391       <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#ab36a0dc3c2c457fa8c01c1b0ba37facc">variable</a>(v).active_on_subdomain(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a96faae17e7ede5aa89c687d54cefb4b3">subdomain_id</a>()))
<a name="l01392"></a>01392         { <span class="comment">// Do this for all the variables if one was not specified</span>
<a name="l01393"></a>01393           <span class="comment">// or just for the specified variable</span>
<a name="l01394"></a>01394 
<a name="l01395"></a>01395           <span class="comment">// Increase the polynomial order on p refined elements</span>
<a name="l01396"></a>01396           <a class="code" href="classlibMesh_1_1FEType.php">FEType</a> fe_type = this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#a0c010bb250d4cd8d65794452f46d141a">variable_type</a>(v);
<a name="l01397"></a>01397           fe_type.<a class="code" href="classlibMesh_1_1FEType.php#aa2484e0f6721f3e34dedebccacc48ac1">order</a> = <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a><span class="keyword">&gt;</span>(fe_type.<a class="code" href="classlibMesh_1_1FEType.php#aa2484e0f6721f3e34dedebccacc48ac1">order</a> +
<a name="l01398"></a>01398                                              elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>());
<a name="l01399"></a>01399 
<a name="l01400"></a>01400           <span class="keyword">const</span> <span class="keywordtype">bool</span> extra_hanging_dofs =
<a name="l01401"></a>01401             <a class="code" href="classlibMesh_1_1FEInterface.php#ac0363b6fc2b8355ff0416ac65b522066">FEInterface::extra_hanging_dofs</a>(fe_type);
<a name="l01402"></a>01402 
<a name="l01403"></a>01403 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l01404"></a>01404 <span class="preprocessor"></span>          tot_size += <a class="code" href="classlibMesh_1_1DofMap.php#ae014405975490bab74a4a7596c379990">FEInterface::n_dofs</a>(dim,
<a name="l01405"></a>01405                                           fe_type,
<a name="l01406"></a>01406                                           type);
<a name="l01407"></a>01407 <span class="preprocessor">#endif</span>
<a name="l01408"></a>01408 <span class="preprocessor"></span>        
<a name="l01409"></a>01409           <span class="comment">// Get the node-based DOF numbers</span>
<a name="l01410"></a>01410           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;<a class="code" href="tecplot__io_8C.php#ad00604777dd9213f9627d8f12e3b2790">n_nodes</a>; n++)
<a name="l01411"></a>01411             {       
<a name="l01412"></a>01412               <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a>* node      = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(n);
<a name="l01413"></a>01413             
<a name="l01414"></a>01414               <span class="comment">// There is a potential problem with h refinement.  Imagine a</span>
<a name="l01415"></a>01415               <span class="comment">// quad9 that has a linear FE on it.  Then, on the hanging side,</span>
<a name="l01416"></a>01416               <span class="comment">// it can falsely identify a DOF at the mid-edge node. This is why</span>
<a name="l01417"></a>01417               <span class="comment">// we call FEInterface instead of node-&gt;n_comp() directly.</span>
<a name="l01418"></a>01418               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nc = <a class="code" href="classlibMesh_1_1FEInterface.php#a9d448e5766ac099a401541d191439d0b">FEInterface::n_dofs_at_node</a> (dim,
<a name="l01419"></a>01419                                                                    fe_type,
<a name="l01420"></a>01420                                                                    type,
<a name="l01421"></a>01421                                                                    n);
<a name="l01422"></a>01422 
<a name="l01423"></a>01423               <span class="comment">// If this is a non-vertex on a hanging node with extra</span>
<a name="l01424"></a>01424               <span class="comment">// degrees of freedom, we use the non-vertex dofs (which</span>
<a name="l01425"></a>01425               <span class="comment">// come in reverse order starting from the end, to</span>
<a name="l01426"></a>01426               <span class="comment">// simplify p refinement)</span>
<a name="l01427"></a>01427               <span class="keywordflow">if</span> (extra_hanging_dofs &amp;&amp; !elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac56e382d9871ff243a781940ee13ed87">is_vertex</a>(n))
<a name="l01428"></a>01428                 {
<a name="l01429"></a>01429                   <span class="keyword">const</span> <span class="keywordtype">int</span> dof_offset = node-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a6710a2bb047a60ef54bfe702432114f8">n_comp</a>(sys_num,v) - nc;
<a name="l01430"></a>01430 
<a name="l01431"></a>01431                   <span class="comment">// We should never have fewer dofs than necessary on a</span>
<a name="l01432"></a>01432                   <span class="comment">// node unless we&#39;re getting indices on a parent element,</span>
<a name="l01433"></a>01433                   <span class="comment">// and we should never need the indices on such a node</span>
<a name="l01434"></a>01434                   <span class="keywordflow">if</span> (dof_offset &lt; 0)
<a name="l01435"></a>01435                     {
<a name="l01436"></a>01436                       libmesh_assert(!elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ab426ef9274eb93de879fef28b027d602">active</a>());
<a name="l01437"></a>01437                       di.resize(di.size() + nc, <a class="code" href="classlibMesh_1_1DofObject.php#a1801e332bf034abe252086db668fee2d">DofObject::invalid_id</a>);
<a name="l01438"></a>01438                     }
<a name="l01439"></a>01439                   <span class="keywordflow">else</span>
<a name="l01440"></a>01440                     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=node-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a6710a2bb047a60ef54bfe702432114f8">n_comp</a>(sys_num,v)-1; i&gt;=dof_offset; i--)
<a name="l01441"></a>01441                       {
<a name="l01442"></a>01442                         libmesh_assert (node-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a99664433bae4e638f8befc83cec4eeff">dof_number</a>(sys_num,v,i) !=
<a name="l01443"></a>01443                                         <a class="code" href="classlibMesh_1_1DofObject.php#a1801e332bf034abe252086db668fee2d">DofObject::invalid_id</a>);
<a name="l01444"></a>01444                         di.push_back(node-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a99664433bae4e638f8befc83cec4eeff">dof_number</a>(sys_num,v,i));
<a name="l01445"></a>01445                       }
<a name="l01446"></a>01446                 }
<a name="l01447"></a>01447               <span class="comment">// If this is a vertex or an element without extra hanging</span>
<a name="l01448"></a>01448               <span class="comment">// dofs, our dofs come in forward order coming from the</span>
<a name="l01449"></a>01449               <span class="comment">// beginning</span>
<a name="l01450"></a>01450               <span class="keywordflow">else</span>
<a name="l01451"></a>01451                 <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;nc; i++)
<a name="l01452"></a>01452                   {
<a name="l01453"></a>01453                     libmesh_assert (node-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a99664433bae4e638f8befc83cec4eeff">dof_number</a>(sys_num,v,i) !=
<a name="l01454"></a>01454                                     <a class="code" href="classlibMesh_1_1DofObject.php#a1801e332bf034abe252086db668fee2d">DofObject::invalid_id</a>);
<a name="l01455"></a>01455                     di.push_back(node-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a99664433bae4e638f8befc83cec4eeff">dof_number</a>(sys_num,v,i));
<a name="l01456"></a>01456                   }
<a name="l01457"></a>01457             }
<a name="l01458"></a>01458         
<a name="l01459"></a>01459           <span class="comment">// If there are any element-based DOF numbers, get them</span>
<a name="l01460"></a>01460           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nc = <a class="code" href="classlibMesh_1_1FEInterface.php#aaf96d4ec7921d2f2a1d4cdbdbc63656a">FEInterface::n_dofs_per_elem</a>(dim,
<a name="l01461"></a>01461                                                                fe_type,
<a name="l01462"></a>01462                                                                type);
<a name="l01463"></a>01463           <span class="comment">// We should never have fewer dofs than necessary on an</span>
<a name="l01464"></a>01464           <span class="comment">// element unless we&#39;re getting indices on a parent element,</span>
<a name="l01465"></a>01465           <span class="comment">// and we should never need those indices</span>
<a name="l01466"></a>01466           <span class="keywordflow">if</span> (nc != 0)
<a name="l01467"></a>01467             {
<a name="l01468"></a>01468               <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a6c321216edb625922b895e2f4b102fc5">n_systems</a>() &gt; sys_num &amp;&amp;
<a name="l01469"></a>01469                   nc &lt;= elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a6710a2bb047a60ef54bfe702432114f8">n_comp</a>(sys_num,v))
<a name="l01470"></a>01470                 {
<a name="l01471"></a>01471                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;nc; i++)
<a name="l01472"></a>01472                     {
<a name="l01473"></a>01473                       libmesh_assert (elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a99664433bae4e638f8befc83cec4eeff">dof_number</a>(sys_num,v,i) !=
<a name="l01474"></a>01474                                       <a class="code" href="classlibMesh_1_1DofObject.php#a1801e332bf034abe252086db668fee2d">DofObject::invalid_id</a>);
<a name="l01475"></a>01475                     
<a name="l01476"></a>01476                       di.push_back(elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a99664433bae4e638f8befc83cec4eeff">dof_number</a>(sys_num,v,i));
<a name="l01477"></a>01477                     }
<a name="l01478"></a>01478                 }
<a name="l01479"></a>01479               <span class="keywordflow">else</span>
<a name="l01480"></a>01480                 {
<a name="l01481"></a>01481                   libmesh_assert(!elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ab426ef9274eb93de879fef28b027d602">active</a>() || fe_type.<a class="code" href="classlibMesh_1_1FEType.php#ac437ba9b0a5253d6bf6f07ad277b9978">family</a> == <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5aee6cdf9773346876504bcbb02d199ab8">LAGRANGE</a>);
<a name="l01482"></a>01482                   di.resize(di.size() + nc, <a class="code" href="classlibMesh_1_1DofObject.php#a1801e332bf034abe252086db668fee2d">DofObject::invalid_id</a>);
<a name="l01483"></a>01483                 }
<a name="l01484"></a>01484             }
<a name="l01485"></a>01485         }
<a name="l01486"></a>01486       } <span class="comment">// end loop over variables</span>
<a name="l01487"></a>01487 
<a name="l01488"></a>01488   <span class="comment">// Finally append any SCALAR dofs that we asked for.</span>
<a name="l01489"></a>01489   std::vector&lt;unsigned int&gt; di_new;
<a name="l01490"></a>01490   std::vector&lt;unsigned int&gt;::iterator it           = SCALAR_var_numbers.begin();
<a name="l01491"></a>01491   std::vector&lt;unsigned int&gt;::const_iterator it_end = SCALAR_var_numbers.end();
<a name="l01492"></a>01492   <span class="keywordflow">for</span>( ; it != it_end; ++it)
<a name="l01493"></a>01493   {
<a name="l01494"></a>01494     this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#af9103a52e6edce2c9f4a3d8499b9aaa3">SCALAR_dof_indices</a>(di_new,*it);
<a name="l01495"></a>01495     di.insert( di.end(), di_new.begin(), di_new.end());
<a name="l01496"></a>01496   }
<a name="l01497"></a>01497 
<a name="l01498"></a>01498 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l01499"></a>01499 <span class="preprocessor"></span>    libmesh_assert (tot_size == di.size());
<a name="l01500"></a>01500 <span class="preprocessor">#endif</span>
<a name="l01501"></a>01501 <span class="preprocessor"></span>  
<a name="l01502"></a>01502   STOP_LOG(<span class="stringliteral">&quot;dof_indices()&quot;</span>, <span class="stringliteral">&quot;DofMap&quot;</span>);  
<a name="l01503"></a>01503 }
<a name="l01504"></a>01504 
<a name="l01505"></a><a class="code" href="classlibMesh_1_1DofMap.php#af9103a52e6edce2c9f4a3d8499b9aaa3">01505</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#af9103a52e6edce2c9f4a3d8499b9aaa3">DofMap::SCALAR_dof_indices</a> (std::vector&lt;unsigned int&gt;&amp; di,
<a name="l01506"></a>01506                                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> vn,
<a name="l01507"></a>01507 #ifdef LIBMESH_ENABLE_AMR
<a name="l01508"></a>01508                                  <span class="keyword">const</span> <span class="keywordtype">bool</span> old_dofs) <span class="keyword">const</span>
<a name="l01509"></a>01509 <span class="preprocessor">#else</span>
<a name="l01510"></a>01510 <span class="preprocessor"></span>                                 <span class="keyword">const</span> bool) <span class="keyword">const</span>
<a name="l01511"></a>01511 #endif
<a name="l01512"></a>01512 {
<a name="l01513"></a>01513   START_LOG(<span class="stringliteral">&quot;SCALAR_dof_indices()&quot;</span>, <span class="stringliteral">&quot;DofMap&quot;</span>);
<a name="l01514"></a>01514 
<a name="l01515"></a>01515   <span class="keywordflow">if</span>(this-&gt;variable(vn).type().family != <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a2ab36d7da9f38141601fd010d729e893">SCALAR</a>)
<a name="l01516"></a>01516   {
<a name="l01517"></a>01517     <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: SCALAR_dof_indices called for a non-SCALAR variable.&quot;</span>
<a name="l01518"></a>01518                   &lt;&lt; std::endl;
<a name="l01519"></a>01519   }
<a name="l01520"></a>01520 
<a name="l01521"></a>01521   <span class="comment">// Clear the DOF indices vector</span>
<a name="l01522"></a>01522   di.clear();
<a name="l01523"></a>01523 
<a name="l01524"></a>01524   <span class="comment">// First we need to find out the first dof</span>
<a name="l01525"></a>01525   <span class="comment">// index for each SCALAR.</span>
<a name="l01526"></a>01526 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l01527"></a>01527 <span class="preprocessor"></span>  <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> first_SCALAR_dof_index = (old_dofs ? n_old_dofs() : n_dofs()) - n_SCALAR_dofs();
<a name="l01528"></a>01528 <span class="preprocessor">#else</span>
<a name="l01529"></a>01529 <span class="preprocessor"></span>  <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> first_SCALAR_dof_index = n_dofs() - n_SCALAR_dofs();
<a name="l01530"></a>01530 <span class="preprocessor">#endif</span>
<a name="l01531"></a>01531 <span class="preprocessor"></span>  std::map&lt;unsigned int, unsigned int&gt; SCALAR_first_dof_index;
<a name="l01532"></a>01532   SCALAR_first_dof_index.clear();
<a name="l01533"></a>01533 
<a name="l01534"></a>01534   <span class="comment">// Iterate over _all_ of the SCALARs and store each one&#39;s first dof index</span>
<a name="l01535"></a>01535   <span class="comment">// We need to do this since the SCALAR dofs are packed contiguously</span>
<a name="l01536"></a>01536   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> v=0; v&lt;this-&gt;n_variables(); v++)
<a name="l01537"></a>01537     <span class="keywordflow">if</span>(this-&gt;variable(v).type().family == <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a2ab36d7da9f38141601fd010d729e893">SCALAR</a>)
<a name="l01538"></a>01538     {
<a name="l01539"></a>01539       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> current_n_SCALAR_dofs = this-&gt;variable(v).type().order;
<a name="l01540"></a>01540       SCALAR_first_dof_index.insert(
<a name="l01541"></a>01541         std::pair&lt;unsigned int, unsigned int&gt;(v,first_SCALAR_dof_index) );
<a name="l01542"></a>01542       first_SCALAR_dof_index += current_n_SCALAR_dofs;
<a name="l01543"></a>01543     }
<a name="l01544"></a>01544 
<a name="l01545"></a>01545   <span class="comment">// Now use vn to index into SCALAR_first_dof_index</span>
<a name="l01546"></a>01546   std::map&lt;unsigned int, unsigned int&gt;::const_iterator iter =
<a name="l01547"></a>01547     SCALAR_first_dof_index.find(vn);
<a name="l01548"></a>01548 
<a name="l01549"></a>01549 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l01550"></a>01550 <span class="preprocessor"></span>  libmesh_assert(iter != SCALAR_first_dof_index.end());
<a name="l01551"></a>01551 <span class="preprocessor">#endif</span>
<a name="l01552"></a>01552 <span class="preprocessor"></span>
<a name="l01553"></a>01553   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> current_first_SCALAR_dof_index = iter-&gt;second;
<a name="l01554"></a>01554 
<a name="l01555"></a>01555   <span class="comment">// Also, get the number of SCALAR dofs from the variable order</span>
<a name="l01556"></a>01556   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> current_n_SCALAR_dofs = this-&gt;variable(vn).type().order;
<a name="l01557"></a>01557 
<a name="l01558"></a>01558   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;current_n_SCALAR_dofs; j++)
<a name="l01559"></a>01559   {
<a name="l01560"></a>01560     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index = current_first_SCALAR_dof_index+j;
<a name="l01561"></a>01561     di.push_back(index);
<a name="l01562"></a>01562   }
<a name="l01563"></a>01563 
<a name="l01564"></a>01564   STOP_LOG(<span class="stringliteral">&quot;SCALAR_dof_indices()&quot;</span>, <span class="stringliteral">&quot;DofMap&quot;</span>);
<a name="l01565"></a>01565 }
<a name="l01566"></a>01566 
<a name="l01567"></a>01567 
<a name="l01568"></a>01568 
<a name="l01569"></a><a class="code" href="classlibMesh_1_1DofMap.php#a6a93245255b86501e09ef377b73bf089">01569</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1DofMap.php#a6a93245255b86501e09ef377b73bf089">DofMap::all_semilocal_indices</a> (<span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices)<span class="keyword"> const</span>
<a name="l01570"></a>01570 <span class="keyword"></span>{
<a name="l01571"></a>01571   <span class="comment">// We&#39;re all semilocal unless we find a counterexample</span>
<a name="l01572"></a>01572   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != dof_indices.size(); ++i)
<a name="l01573"></a>01573     {
<a name="l01574"></a>01574       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> di = dof_indices[i];
<a name="l01575"></a>01575       <span class="comment">// If it&#39;s not in the local indices</span>
<a name="l01576"></a>01576       <span class="keywordflow">if</span> (di &lt; this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#ad2b15648e708f656a798bd642c3ca8e3">first_dof</a>() ||
<a name="l01577"></a>01577           di &gt;= this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#abf250ac3decfedbe00ddaeef85ed4de4">end_dof</a>())
<a name="l01578"></a>01578         {
<a name="l01579"></a>01579           <span class="comment">// and if it&#39;s not in the ghost indices, then we&#39;re not</span>
<a name="l01580"></a>01580           <span class="comment">// semilocal</span>
<a name="l01581"></a>01581           <span class="keywordflow">if</span> (!std::binary_search(<a class="code" href="classlibMesh_1_1DofMap.php#a66d63042b6f4dce2ef98a1573ff6b2ad">_send_list</a>.begin(), <a class="code" href="classlibMesh_1_1DofMap.php#a66d63042b6f4dce2ef98a1573ff6b2ad">_send_list</a>.end(), di))
<a name="l01582"></a>01582             <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l01583"></a>01583         }
<a name="l01584"></a>01584     }
<a name="l01585"></a>01585 
<a name="l01586"></a>01586   <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l01587"></a>01587 }
<a name="l01588"></a>01588 
<a name="l01589"></a>01589 
<a name="l01590"></a>01590 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l01591"></a>01591 <span class="preprocessor"></span>
<a name="l01592"></a><a class="code" href="classlibMesh_1_1DofMap.php#ae260ebddbb3c10a932ab9e16baa5bbb3">01592</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#ae260ebddbb3c10a932ab9e16baa5bbb3">DofMap::old_dof_indices</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <span class="keyword">const</span> elem,
<a name="l01593"></a>01593                               std::vector&lt;unsigned int&gt;&amp; di,
<a name="l01594"></a>01594                               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> vn)<span class="keyword"> const</span>
<a name="l01595"></a>01595 <span class="keyword"></span>{
<a name="l01596"></a>01596   START_LOG(<span class="stringliteral">&quot;old_dof_indices()&quot;</span>, <span class="stringliteral">&quot;DofMap&quot;</span>);
<a name="l01597"></a>01597   
<a name="l01598"></a>01598   libmesh_assert (elem != NULL);
<a name="l01599"></a>01599   libmesh_assert (elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a8e674de36aaf3c03e7128dc04bac63a7">old_dof_object</a> != NULL);
<a name="l01600"></a>01600             
<a name="l01601"></a>01601 
<a name="l01602"></a>01602   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="tecplot__io_8C.php#ad00604777dd9213f9627d8f12e3b2790">n_nodes</a> = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>();
<a name="l01603"></a>01603   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type        = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad06f8ac22978144723179eed42d10bae">type</a>();
<a name="l01604"></a>01604   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sys_num = this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#a244e7a1cd82d5e6ae8780c93205ec1fa">sys_number</a>();
<a name="l01605"></a>01605   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="tecplot__io_8C.php#ac001e4247887b98c2aa5b8ec5107ca0d">n_vars</a>  = this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#aee89c467613b296c215421d60d5ae961">n_variables</a>();
<a name="l01606"></a>01606   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim     = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#aa50d97d65dc379f64667da53c427b36f">dim</a>();
<a name="l01607"></a>01607   
<a name="l01608"></a>01608   <span class="comment">// Clear the DOF indices vector.</span>
<a name="l01609"></a>01609   di.clear();
<a name="l01610"></a>01610 
<a name="l01611"></a>01611 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l01612"></a>01612 <span class="preprocessor"></span>  <span class="comment">// Check that sizes match</span>
<a name="l01613"></a>01613   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> tot_size = 0;
<a name="l01614"></a>01614 <span class="preprocessor">#endif</span>
<a name="l01615"></a>01615 <span class="preprocessor"></span>
<a name="l01616"></a>01616   <span class="comment">// Create a vector to indicate which</span>
<a name="l01617"></a>01617   <span class="comment">// SCALAR variables have been requested</span>
<a name="l01618"></a>01618   std::vector&lt;unsigned int&gt; SCALAR_var_numbers;
<a name="l01619"></a>01619   SCALAR_var_numbers.clear();
<a name="l01620"></a>01620 
<a name="l01621"></a>01621   <span class="comment">// Get the dof numbers</span>
<a name="l01622"></a>01622   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> v=0; v&lt;<a class="code" href="tecplot__io_8C.php#ac001e4247887b98c2aa5b8ec5107ca0d">n_vars</a>; v++)
<a name="l01623"></a>01623     <span class="keywordflow">if</span> ((v == vn) || (vn == <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>))
<a name="l01624"></a>01624     {
<a name="l01625"></a>01625       <span class="keywordflow">if</span>(this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#ab36a0dc3c2c457fa8c01c1b0ba37facc">variable</a>(v).type().family == <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a2ab36d7da9f38141601fd010d729e893">SCALAR</a>)
<a name="l01626"></a>01626         {
<a name="l01627"></a>01627           <span class="comment">// We asked for this variable, so add it to the vector.</span>
<a name="l01628"></a>01628           SCALAR_var_numbers.push_back(v);
<a name="l01629"></a>01629 
<a name="l01630"></a>01630 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l01631"></a>01631 <span class="preprocessor"></span>          <a class="code" href="classlibMesh_1_1FEType.php">FEType</a> fe_type = this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#a0c010bb250d4cd8d65794452f46d141a">variable_type</a>(v);
<a name="l01632"></a>01632           tot_size += <a class="code" href="classlibMesh_1_1DofMap.php#ae014405975490bab74a4a7596c379990">FEInterface::n_dofs</a>(dim,
<a name="l01633"></a>01633                                           fe_type,
<a name="l01634"></a>01634                                           type);
<a name="l01635"></a>01635 <span class="preprocessor">#endif</span>
<a name="l01636"></a>01636 <span class="preprocessor"></span>        }
<a name="l01637"></a>01637       <span class="keywordflow">else</span>
<a name="l01638"></a>01638       <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#ab36a0dc3c2c457fa8c01c1b0ba37facc">variable</a>(v).active_on_subdomain(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a96faae17e7ede5aa89c687d54cefb4b3">subdomain_id</a>()))
<a name="l01639"></a>01639         { <span class="comment">// Do this for all the variables if one was not specified</span>
<a name="l01640"></a>01640           <span class="comment">// or just for the specified variable</span>
<a name="l01641"></a>01641         
<a name="l01642"></a>01642           <span class="comment">// Increase the polynomial order on p refined elements,</span>
<a name="l01643"></a>01643           <span class="comment">// but make sure you get the right polynomial order for</span>
<a name="l01644"></a>01644           <span class="comment">// the OLD degrees of freedom</span>
<a name="l01645"></a>01645           <span class="keywordtype">int</span> p_adjustment = 0;
<a name="l01646"></a>01646           <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a53a98cf29aef9af6292c812d7b905c18">p_refinement_flag</a>() == <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a6fb8f2a3f8b6cc1a569263dbc1f1c5cf">Elem::JUST_REFINED</a>)
<a name="l01647"></a>01647             {
<a name="l01648"></a>01648               libmesh_assert (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>() &gt; 0);
<a name="l01649"></a>01649               p_adjustment = -1;
<a name="l01650"></a>01650             }
<a name="l01651"></a>01651           <span class="keywordflow">else</span> <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a53a98cf29aef9af6292c812d7b905c18">p_refinement_flag</a>() == <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54adec28448bd3f7297806b7d58e9625240">Elem::JUST_COARSENED</a>)
<a name="l01652"></a>01652             {
<a name="l01653"></a>01653               p_adjustment = 1;
<a name="l01654"></a>01654             }
<a name="l01655"></a>01655           <a class="code" href="classlibMesh_1_1FEType.php">FEType</a> fe_type = this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#a0c010bb250d4cd8d65794452f46d141a">variable_type</a>(v);
<a name="l01656"></a>01656           fe_type.<a class="code" href="classlibMesh_1_1FEType.php#aa2484e0f6721f3e34dedebccacc48ac1">order</a> = <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a><span class="keyword">&gt;</span>(fe_type.<a class="code" href="classlibMesh_1_1FEType.php#aa2484e0f6721f3e34dedebccacc48ac1">order</a> +
<a name="l01657"></a>01657                                              elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>() +
<a name="l01658"></a>01658                                              p_adjustment);
<a name="l01659"></a>01659 
<a name="l01660"></a>01660           <span class="keyword">const</span> <span class="keywordtype">bool</span> extra_hanging_dofs =
<a name="l01661"></a>01661             <a class="code" href="classlibMesh_1_1FEInterface.php#ac0363b6fc2b8355ff0416ac65b522066">FEInterface::extra_hanging_dofs</a>(fe_type);
<a name="l01662"></a>01662 
<a name="l01663"></a>01663 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l01664"></a>01664 <span class="preprocessor"></span>          tot_size += <a class="code" href="classlibMesh_1_1DofMap.php#ae014405975490bab74a4a7596c379990">FEInterface::n_dofs</a>(dim,
<a name="l01665"></a>01665                                           fe_type,
<a name="l01666"></a>01666                                           type);
<a name="l01667"></a>01667 <span class="preprocessor">#endif</span>
<a name="l01668"></a>01668 <span class="preprocessor"></span>        
<a name="l01669"></a>01669           <span class="comment">// Get the node-based DOF numbers</span>
<a name="l01670"></a>01670           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;<a class="code" href="tecplot__io_8C.php#ad00604777dd9213f9627d8f12e3b2790">n_nodes</a>; n++)
<a name="l01671"></a>01671             {
<a name="l01672"></a>01672               <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a>* node      = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(n);
<a name="l01673"></a>01673             
<a name="l01674"></a>01674               <span class="comment">// There is a potential problem with h refinement.  Imagine a</span>
<a name="l01675"></a>01675               <span class="comment">// quad9 that has a linear FE on it.  Then, on the hanging side,</span>
<a name="l01676"></a>01676               <span class="comment">// it can falsely identify a DOF at the mid-edge node. This is why</span>
<a name="l01677"></a>01677               <span class="comment">// we call FEInterface instead of node-&gt;n_comp() directly.</span>
<a name="l01678"></a>01678               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nc = <a class="code" href="classlibMesh_1_1FEInterface.php#a9d448e5766ac099a401541d191439d0b">FEInterface::n_dofs_at_node</a> (dim,
<a name="l01679"></a>01679                                                                    fe_type,
<a name="l01680"></a>01680                                                                    type,
<a name="l01681"></a>01681                                                                    n);
<a name="l01682"></a>01682               libmesh_assert (node-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a8e674de36aaf3c03e7128dc04bac63a7">old_dof_object</a> != NULL);
<a name="l01683"></a>01683             
<a name="l01684"></a>01684               <span class="comment">// If this is a non-vertex on a hanging node with extra</span>
<a name="l01685"></a>01685               <span class="comment">// degrees of freedom, we use the non-vertex dofs (which</span>
<a name="l01686"></a>01686               <span class="comment">// come in reverse order starting from the end, to</span>
<a name="l01687"></a>01687               <span class="comment">// simplify p refinement)</span>
<a name="l01688"></a>01688               <span class="keywordflow">if</span> (extra_hanging_dofs &amp;&amp; !elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac56e382d9871ff243a781940ee13ed87">is_vertex</a>(n))
<a name="l01689"></a>01689                 {
<a name="l01690"></a>01690                   <span class="keyword">const</span> <span class="keywordtype">int</span> dof_offset = 
<a name="l01691"></a>01691                     node-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a8e674de36aaf3c03e7128dc04bac63a7">old_dof_object</a>-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a6710a2bb047a60ef54bfe702432114f8">n_comp</a>(sys_num,v) - nc;
<a name="l01692"></a>01692             
<a name="l01693"></a>01693                   <span class="comment">// We should never have fewer dofs than necessary on a</span>
<a name="l01694"></a>01694                   <span class="comment">// node unless we&#39;re getting indices on a parent element</span>
<a name="l01695"></a>01695                   <span class="comment">// or a just-coarsened element</span>
<a name="l01696"></a>01696                   <span class="keywordflow">if</span> (dof_offset &lt; 0)
<a name="l01697"></a>01697                     {
<a name="l01698"></a>01698                       libmesh_assert(!elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ab426ef9274eb93de879fef28b027d602">active</a>() || elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a174bfe5b3d22e2b79000bfc816f633e6">refinement_flag</a>() ==
<a name="l01699"></a>01699                                      <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54adec28448bd3f7297806b7d58e9625240">Elem::JUST_COARSENED</a>);
<a name="l01700"></a>01700                       di.resize(di.size() + nc, <a class="code" href="classlibMesh_1_1DofObject.php#a1801e332bf034abe252086db668fee2d">DofObject::invalid_id</a>);
<a name="l01701"></a>01701                     }
<a name="l01702"></a>01702                   <span class="keywordflow">else</span>
<a name="l01703"></a>01703                     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=node-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a8e674de36aaf3c03e7128dc04bac63a7">old_dof_object</a>-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a6710a2bb047a60ef54bfe702432114f8">n_comp</a>(sys_num,v)-1;
<a name="l01704"></a>01704                          i&gt;=dof_offset; i--)
<a name="l01705"></a>01705                       {
<a name="l01706"></a>01706                         libmesh_assert (node-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a8e674de36aaf3c03e7128dc04bac63a7">old_dof_object</a>-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a99664433bae4e638f8befc83cec4eeff">dof_number</a>(sys_num,v,i) !=
<a name="l01707"></a>01707                                         <a class="code" href="classlibMesh_1_1DofObject.php#a1801e332bf034abe252086db668fee2d">DofObject::invalid_id</a>);
<a name="l01708"></a>01708                         di.push_back(node-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a8e674de36aaf3c03e7128dc04bac63a7">old_dof_object</a>-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a99664433bae4e638f8befc83cec4eeff">dof_number</a>(sys_num,v,i));
<a name="l01709"></a>01709                       }
<a name="l01710"></a>01710                 }
<a name="l01711"></a>01711               <span class="comment">// If this is a vertex or an element without extra hanging</span>
<a name="l01712"></a>01712               <span class="comment">// dofs, our dofs come in forward order coming from the</span>
<a name="l01713"></a>01713               <span class="comment">// beginning</span>
<a name="l01714"></a>01714               <span class="keywordflow">else</span>
<a name="l01715"></a>01715                 <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;nc; i++)
<a name="l01716"></a>01716                   {
<a name="l01717"></a>01717                     libmesh_assert (node-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a8e674de36aaf3c03e7128dc04bac63a7">old_dof_object</a>-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a99664433bae4e638f8befc83cec4eeff">dof_number</a>(sys_num,v,i) !=
<a name="l01718"></a>01718                                     <a class="code" href="classlibMesh_1_1DofObject.php#a1801e332bf034abe252086db668fee2d">DofObject::invalid_id</a>);
<a name="l01719"></a>01719                     di.push_back(node-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a8e674de36aaf3c03e7128dc04bac63a7">old_dof_object</a>-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a99664433bae4e638f8befc83cec4eeff">dof_number</a>(sys_num,v,i));
<a name="l01720"></a>01720                   }
<a name="l01721"></a>01721             }
<a name="l01722"></a>01722         
<a name="l01723"></a>01723           <span class="comment">// If there are any element-based DOF numbers, get them</span>
<a name="l01724"></a>01724           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nc = <a class="code" href="classlibMesh_1_1FEInterface.php#aaf96d4ec7921d2f2a1d4cdbdbc63656a">FEInterface::n_dofs_per_elem</a>(dim,
<a name="l01725"></a>01725                                                                fe_type,
<a name="l01726"></a>01726                                                                type);
<a name="l01727"></a>01727 
<a name="l01728"></a>01728           <span class="comment">// We should never have fewer dofs than necessary on an</span>
<a name="l01729"></a>01729           <span class="comment">// element unless we&#39;re getting indices on a parent element</span>
<a name="l01730"></a>01730           <span class="comment">// or a just-coarsened element</span>
<a name="l01731"></a>01731           <span class="keywordflow">if</span> (nc != 0)
<a name="l01732"></a>01732             {
<a name="l01733"></a>01733               <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a8e674de36aaf3c03e7128dc04bac63a7">old_dof_object</a>-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a6c321216edb625922b895e2f4b102fc5">n_systems</a>() &gt; sys_num &amp;&amp;
<a name="l01734"></a>01734                   nc &lt;= elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a8e674de36aaf3c03e7128dc04bac63a7">old_dof_object</a>-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a6710a2bb047a60ef54bfe702432114f8">n_comp</a>(sys_num,v))
<a name="l01735"></a>01735                 {
<a name="l01736"></a>01736                   libmesh_assert (elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a8e674de36aaf3c03e7128dc04bac63a7">old_dof_object</a> != NULL);
<a name="l01737"></a>01737                 
<a name="l01738"></a>01738                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;nc; i++)
<a name="l01739"></a>01739                     {
<a name="l01740"></a>01740                       libmesh_assert (elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a8e674de36aaf3c03e7128dc04bac63a7">old_dof_object</a>-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a99664433bae4e638f8befc83cec4eeff">dof_number</a>(sys_num,v,i) !=
<a name="l01741"></a>01741                                       <a class="code" href="classlibMesh_1_1DofObject.php#a1801e332bf034abe252086db668fee2d">DofObject::invalid_id</a>);
<a name="l01742"></a>01742                     
<a name="l01743"></a>01743                       di.push_back(elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a8e674de36aaf3c03e7128dc04bac63a7">old_dof_object</a>-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a99664433bae4e638f8befc83cec4eeff">dof_number</a>(sys_num,v,i));
<a name="l01744"></a>01744                     }
<a name="l01745"></a>01745                 }
<a name="l01746"></a>01746               <span class="keywordflow">else</span>
<a name="l01747"></a>01747                 {
<a name="l01748"></a>01748                   libmesh_assert(!elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ab426ef9274eb93de879fef28b027d602">active</a>() || fe_type.<a class="code" href="classlibMesh_1_1FEType.php#ac437ba9b0a5253d6bf6f07ad277b9978">family</a> == <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5aee6cdf9773346876504bcbb02d199ab8">LAGRANGE</a> ||
<a name="l01749"></a>01749                                  elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a174bfe5b3d22e2b79000bfc816f633e6">refinement_flag</a>() == <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54adec28448bd3f7297806b7d58e9625240">Elem::JUST_COARSENED</a>);
<a name="l01750"></a>01750                   di.resize(di.size() + nc, <a class="code" href="classlibMesh_1_1DofObject.php#a1801e332bf034abe252086db668fee2d">DofObject::invalid_id</a>);
<a name="l01751"></a>01751                 }
<a name="l01752"></a>01752             }
<a name="l01753"></a>01753         }
<a name="l01754"></a>01754     } <span class="comment">// end loop over variables</span>
<a name="l01755"></a>01755 
<a name="l01756"></a>01756   <span class="comment">// Finally append any SCALAR dofs that we asked for.</span>
<a name="l01757"></a>01757   std::vector&lt;unsigned int&gt; di_new;
<a name="l01758"></a>01758   std::vector&lt;unsigned int&gt;::iterator it           = SCALAR_var_numbers.begin();
<a name="l01759"></a>01759   std::vector&lt;unsigned int&gt;::const_iterator it_end = SCALAR_var_numbers.end();
<a name="l01760"></a>01760   <span class="keywordflow">for</span>( ; it != it_end; ++it)
<a name="l01761"></a>01761   {
<a name="l01762"></a>01762     this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#af9103a52e6edce2c9f4a3d8499b9aaa3">SCALAR_dof_indices</a>(di_new,*it,<span class="keyword">true</span>);
<a name="l01763"></a>01763     di.insert( di.end(), di_new.begin(), di_new.end());
<a name="l01764"></a>01764   }
<a name="l01765"></a>01765   
<a name="l01766"></a>01766 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l01767"></a>01767 <span class="preprocessor"></span>  libmesh_assert (tot_size == di.size());
<a name="l01768"></a>01768 <span class="preprocessor">#endif</span>
<a name="l01769"></a>01769 <span class="preprocessor"></span>  
<a name="l01770"></a>01770   STOP_LOG(<span class="stringliteral">&quot;old_dof_indices()&quot;</span>, <span class="stringliteral">&quot;DofMap&quot;</span>);  
<a name="l01771"></a>01771 }
<a name="l01772"></a>01772 
<a name="l01773"></a>01773 
<a name="l01774"></a>01774 
<a name="l01775"></a>01775 <span class="comment">/*</span>
<a name="l01776"></a>01776 <span class="comment">void DofMap::augment_send_list_for_projection(const MeshBase&amp; mesh)</span>
<a name="l01777"></a>01777 <span class="comment">{</span>
<a name="l01778"></a>01778 <span class="comment">  // Loop over the active local elements in the mesh.</span>
<a name="l01779"></a>01779 <span class="comment">  // If the element was just refined and its parent lives</span>
<a name="l01780"></a>01780 <span class="comment">  // on a different processor then we need to augment the</span>
<a name="l01781"></a>01781 <span class="comment">  // _send_list with the parent&#39;s DOF indices so that we</span>
<a name="l01782"></a>01782 <span class="comment">  // can access the parent&#39;s data for computing solution</span>
<a name="l01783"></a>01783 <span class="comment">  // projections, etc...</span>
<a name="l01784"></a>01784 <span class="comment"></span>
<a name="l01785"></a>01785 <span class="comment">  // The DOF indices for the parent</span>
<a name="l01786"></a>01786 <span class="comment">  std::vector&lt;unsigned int&gt; di;</span>
<a name="l01787"></a>01787 <span class="comment"></span>
<a name="l01788"></a>01788 <span class="comment">  // Flag telling us if we need to re-sort the send_list.</span>
<a name="l01789"></a>01789 <span class="comment">  // Note we won&#39;t need to re-sort unless a child with a</span>
<a name="l01790"></a>01790 <span class="comment">  // parent belonging to a different processor is found</span>
<a name="l01791"></a>01791 <span class="comment">  bool needs_sorting = false;</span>
<a name="l01792"></a>01792 <span class="comment">  </span>
<a name="l01793"></a>01793 <span class="comment">  </span>
<a name="l01794"></a>01794 <span class="comment">  MeshBase::const_element_iterator       elem_it  = mesh.active_local_elements_begin();</span>
<a name="l01795"></a>01795 <span class="comment">  const MeshBase::const_element_iterator elem_end = mesh.active_local_elements_end(); </span>
<a name="l01796"></a>01796 <span class="comment"></span>
<a name="l01797"></a>01797 <span class="comment">  for ( ; elem_it != elem_end; ++elem_it)</span>
<a name="l01798"></a>01798 <span class="comment">    {</span>
<a name="l01799"></a>01799 <span class="comment">      const Elem* const elem   = *elem_it;</span>
<a name="l01800"></a>01800 <span class="comment"></span>
<a name="l01801"></a>01801 <span class="comment">      // We only need to consider the children that</span>
<a name="l01802"></a>01802 <span class="comment">      // were just refined</span>
<a name="l01803"></a>01803 <span class="comment">      if (elem-&gt;refinement_flag() != Elem::JUST_REFINED) continue;</span>
<a name="l01804"></a>01804 <span class="comment">      </span>
<a name="l01805"></a>01805 <span class="comment">      const Elem* const parent = elem-&gt;parent();</span>
<a name="l01806"></a>01806 <span class="comment"></span>
<a name="l01807"></a>01807 <span class="comment">      // If the parent lives on another processor</span>
<a name="l01808"></a>01808 <span class="comment">      // than the child</span>
<a name="l01809"></a>01809 <span class="comment">      if (parent != NULL)</span>
<a name="l01810"></a>01810 <span class="comment">        if (parent-&gt;processor_id() != elem-&gt;processor_id())</span>
<a name="l01811"></a>01811 <span class="comment">          {</span>
<a name="l01812"></a>01812 <span class="comment">            // Get the DOF indices for the parent</span>
<a name="l01813"></a>01813 <span class="comment">            this-&gt;dof_indices (parent, di);</span>
<a name="l01814"></a>01814 <span class="comment"></span>
<a name="l01815"></a>01815 <span class="comment">            // Insert the DOF indices into the send list</span>
<a name="l01816"></a>01816 <span class="comment">            _send_list.insert (_send_list.end(),</span>
<a name="l01817"></a>01817 <span class="comment">                               di.begin(), di.end());</span>
<a name="l01818"></a>01818 <span class="comment"></span>
<a name="l01819"></a>01819 <span class="comment">            // We will need to re-sort the send list</span>
<a name="l01820"></a>01820 <span class="comment">            needs_sorting = true;           </span>
<a name="l01821"></a>01821 <span class="comment">          }</span>
<a name="l01822"></a>01822 <span class="comment">    }</span>
<a name="l01823"></a>01823 <span class="comment"></span>
<a name="l01824"></a>01824 <span class="comment">  // The send-list might need to be sorted again.</span>
<a name="l01825"></a>01825 <span class="comment">  if (needs_sorting) this-&gt;sort_send_list ();</span>
<a name="l01826"></a>01826 <span class="comment">}</span>
<a name="l01827"></a>01827 <span class="comment">*/</span>
<a name="l01828"></a>01828 
<a name="l01829"></a>01829 <span class="preprocessor">#endif // LIBMESH_ENABLE_AMR</span>
<a name="l01830"></a>01830 <span class="preprocessor"></span>
<a name="l01831"></a>01831 
<a name="l01832"></a>01832 <span class="preprocessor">#if defined(LIBMESH_ENABLE_AMR) || defined(LIBMESH_ENABLE_PERIODIC)</span>
<a name="l01833"></a>01833 <span class="preprocessor"></span>
<a name="l01834"></a><a class="code" href="classlibMesh_1_1DofMap.php#aeb1398dca8edb951fbd22762fedd0500">01834</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#aeb1398dca8edb951fbd22762fedd0500">DofMap::find_connected_dofs</a> (std::vector&lt;unsigned int&gt;&amp; elem_dofs)<span class="keyword"> const</span>
<a name="l01835"></a>01835 <span class="keyword"></span>{
<a name="l01836"></a>01836   <span class="keyword">typedef</span> std::set&lt;unsigned int&gt; RCSet;
<a name="l01837"></a>01837 
<a name="l01838"></a>01838   <span class="comment">// First insert the DOFS we already depend on into the set.  </span>
<a name="l01839"></a>01839   RCSet dof_set (elem_dofs.begin(), elem_dofs.end());
<a name="l01840"></a>01840 
<a name="l01841"></a>01841   <span class="keywordtype">bool</span> done = <span class="keyword">true</span>;
<a name="l01842"></a>01842     
<a name="l01843"></a>01843   <span class="comment">// Next insert any dofs those might be constrained in terms</span>
<a name="l01844"></a>01844   <span class="comment">// of.  Note that in this case we may not be done:  Those may</span>
<a name="l01845"></a>01845   <span class="comment">// in turn depend on others.  So, we need to repeat this process</span>
<a name="l01846"></a>01846   <span class="comment">// in that case until the system depends only on unconstrained</span>
<a name="l01847"></a>01847   <span class="comment">// degrees of freedom.</span>
<a name="l01848"></a>01848   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;elem_dofs.size(); i++)
<a name="l01849"></a>01849     <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#af59487b50683e231676f836f94cde1ab">is_constrained_dof</a>(elem_dofs[i]))
<a name="l01850"></a>01850       {
<a name="l01851"></a>01851         <span class="comment">// If the DOF is constrained</span>
<a name="l01852"></a>01852         DofConstraints::const_iterator
<a name="l01853"></a>01853           pos = <a class="code" href="classlibMesh_1_1DofMap.php#af7fe4d0cf13618e6dd04ff22fdaca0ba">_dof_constraints</a>.find(elem_dofs[i]);
<a name="l01854"></a>01854         
<a name="l01855"></a>01855         libmesh_assert (pos != <a class="code" href="classlibMesh_1_1DofMap.php#af7fe4d0cf13618e6dd04ff22fdaca0ba">_dof_constraints</a>.end());
<a name="l01856"></a>01856         
<a name="l01857"></a>01857         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#a919b3727a9707f23ecad00949d1d1c43">DofConstraintRow</a>&amp; constraint_row = pos-&gt;second;
<a name="l01858"></a>01858         
<a name="l01859"></a>01859 <span class="comment">// adaptive p refinement currently gives us lots of empty constraint</span>
<a name="l01860"></a>01860 <span class="comment">// rows - we should optimize those DoFs away in the future.  [RHS]</span>
<a name="l01861"></a>01861 <span class="comment">//      libmesh_assert (!constraint_row.empty());</span>
<a name="l01862"></a>01862         
<a name="l01863"></a>01863         DofConstraintRow::const_iterator it     = constraint_row.begin();
<a name="l01864"></a>01864         DofConstraintRow::const_iterator it_end = constraint_row.end();
<a name="l01865"></a>01865         
<a name="l01866"></a>01866         
<a name="l01867"></a>01867         <span class="comment">// Add the DOFs this dof is constrained in terms of.</span>
<a name="l01868"></a>01868         <span class="comment">// note that these dofs might also be constrained, so</span>
<a name="l01869"></a>01869         <span class="comment">// we will need to call this function recursively.</span>
<a name="l01870"></a>01870         <span class="keywordflow">for</span> ( ; it != it_end; ++it)
<a name="l01871"></a>01871           <span class="keywordflow">if</span> (!dof_set.count (it-&gt;first))
<a name="l01872"></a>01872             {
<a name="l01873"></a>01873               dof_set.insert (it-&gt;first);
<a name="l01874"></a>01874               done = <span class="keyword">false</span>;
<a name="l01875"></a>01875             }
<a name="l01876"></a>01876         }
<a name="l01877"></a>01877   
<a name="l01878"></a>01878   
<a name="l01879"></a>01879   <span class="comment">// If not done then we need to do more work</span>
<a name="l01880"></a>01880   <span class="comment">// (obviously :-) )!</span>
<a name="l01881"></a>01881   <span class="keywordflow">if</span> (!done)
<a name="l01882"></a>01882     {
<a name="l01883"></a>01883       <span class="comment">// Fill the vector with the contents of the set</span>
<a name="l01884"></a>01884       elem_dofs.clear();      
<a name="l01885"></a>01885       elem_dofs.insert (elem_dofs.end(),
<a name="l01886"></a>01886                         dof_set.begin(), dof_set.end());
<a name="l01887"></a>01887       
<a name="l01888"></a>01888 
<a name="l01889"></a>01889       <span class="comment">// May need to do this recursively.  It is possible</span>
<a name="l01890"></a>01890       <span class="comment">// that we just replaced a constrained DOF with another</span>
<a name="l01891"></a>01891       <span class="comment">// constrained DOF.</span>
<a name="l01892"></a>01892       this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#aeb1398dca8edb951fbd22762fedd0500">find_connected_dofs</a> (elem_dofs);
<a name="l01893"></a>01893       
<a name="l01894"></a>01894     } <span class="comment">// end if (!done)</span>
<a name="l01895"></a>01895 }
<a name="l01896"></a>01896 
<a name="l01897"></a>01897 <span class="preprocessor">#endif // LIBMESH_ENABLE_AMR || LIBMESH_ENABLE_PERIODIC</span>
<a name="l01898"></a>01898 <span class="preprocessor"></span>
<a name="l01899"></a>01899 
<a name="l01900"></a>01900 
<a name="l01901"></a>01901 <span class="preprocessor">#if defined(__GNUC__) &amp;&amp; (__GNUC__ &lt; 4) &amp;&amp; !defined(__INTEL_COMPILER)</span>
<a name="l01902"></a>01902 <span class="preprocessor"></span>
<a name="l01903"></a><a class="code" href="namespacelibMesh_1_1SparsityPattern.php#a859cc7fecedbd239ca60ef57d33fd1d0">01903</a> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1SparsityPattern.php#a859cc7fecedbd239ca60ef57d33fd1d0">SparsityPattern::_dummy_function</a>(<span class="keywordtype">void</span>)
<a name="l01904"></a>01904 {
<a name="l01905"></a>01905 }
<a name="l01906"></a>01906 
<a name="l01907"></a>01907 <span class="preprocessor">#endif</span>
<a name="l01908"></a>01908 <span class="preprocessor"></span>
<a name="l01909"></a>01909 
<a name="l01910"></a>01910 
<a name="l01911"></a><a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php#acc76917e49e35f190ee11ca95d319db8">01911</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php#acc76917e49e35f190ee11ca95d319db8">SparsityPattern::Build::operator()</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1StoredRange.php">ConstElemRange</a> &amp;range)
<a name="l01912"></a>01912 {
<a name="l01913"></a>01913   <span class="comment">// Compute the sparsity structure of the global matrix.  This can be</span>
<a name="l01914"></a>01914   <span class="comment">// fed into a PetscMatrix to allocate exacly the number of nonzeros</span>
<a name="l01915"></a>01915   <span class="comment">// necessary to store the matrix.  This algorithm should be linear</span>
<a name="l01916"></a>01916   <span class="comment">// in the (# of elements)*(# nodes per element)</span>
<a name="l01917"></a>01917   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id           = <a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php#a7eca2b2512224d01cb599177e5f1c8a1">mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#aa557872c33163622cc66645fc393c925">processor_id</a>();
<a name="l01918"></a>01918   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_dofs_on_proc    = <a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php#adaaeb1039af971d4376bcd896686a281">dof_map</a>.<a class="code" href="classlibMesh_1_1DofMap.php#a93892a922e17e271f635262a9c8acf98">n_dofs_on_processor</a>(proc_id);
<a name="l01919"></a>01919   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> first_dof_on_proc = <a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php#adaaeb1039af971d4376bcd896686a281">dof_map</a>.<a class="code" href="classlibMesh_1_1DofMap.php#ad2b15648e708f656a798bd642c3ca8e3">first_dof</a>(proc_id);
<a name="l01920"></a>01920   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> end_dof_on_proc   = <a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php#adaaeb1039af971d4376bcd896686a281">dof_map</a>.<a class="code" href="classlibMesh_1_1DofMap.php#abf250ac3decfedbe00ddaeef85ed4de4">end_dof</a>(proc_id);
<a name="l01921"></a>01921 
<a name="l01922"></a>01922   <a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php#a054aa3bf4ab1ff21352e2aaf2495c589">sparsity_pattern</a>.resize(n_dofs_on_proc);
<a name="l01923"></a>01923   
<a name="l01924"></a>01924   <span class="comment">// If the user did not explicitly specify the DOF coupling</span>
<a name="l01925"></a>01925   <span class="comment">// then all the DOFS are coupled to each other.  Furthermore,</span>
<a name="l01926"></a>01926   <span class="comment">// we can take a shortcut and do this more quickly here.  So</span>
<a name="l01927"></a>01927   <span class="comment">// we use an if-test.</span>
<a name="l01928"></a>01928   <span class="keywordflow">if</span> ((<a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php#a7e288ac68552ad57f0b56c9feff455b2">dof_coupling</a> == NULL) || (<a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php#a7e288ac68552ad57f0b56c9feff455b2">dof_coupling</a>-&gt;<a class="code" href="classlibMesh_1_1CouplingMatrix.php#aa4e4b91867c63a57cf985147205d82cd">empty</a>()))
<a name="l01929"></a>01929     {
<a name="l01930"></a>01930       std::vector&lt;unsigned int&gt;
<a name="l01931"></a>01931         element_dofs,
<a name="l01932"></a>01932         neighbor_dofs,
<a name="l01933"></a>01933         dofs_to_add;
<a name="l01934"></a>01934 
<a name="l01935"></a>01935       std::vector&lt;const Elem*&gt; active_neighbors;
<a name="l01936"></a>01936 
<a name="l01937"></a>01937       <span class="keywordflow">for</span> (<a class="code" href="classlibMesh_1_1StoredRange.php#a07c6e88eede585628af3437d8cad903f">ConstElemRange::const_iterator</a> elem_it = range.<a class="code" href="classlibMesh_1_1StoredRange.php#a9687da8abb136c142c4df14f4444737b">begin</a>() ; elem_it != range.<a class="code" href="classlibMesh_1_1StoredRange.php#aff337b550b3349015980e791dd982b21">end</a>(); ++elem_it)
<a name="l01938"></a>01938         {
<a name="l01939"></a>01939           <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <span class="keyword">const</span> elem = *elem_it;
<a name="l01940"></a>01940 
<a name="l01941"></a>01941           <span class="comment">// Get the global indices of the DOFs with support on this element</span>
<a name="l01942"></a>01942           <a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php#adaaeb1039af971d4376bcd896686a281">dof_map</a>.<a class="code" href="classlibMesh_1_1DofMap.php#a5dac22ba99a9da3563c00b7dfd2f07af">dof_indices</a> (elem, element_dofs);
<a name="l01943"></a>01943 <span class="preprocessor">#if defined(LIBMESH_ENABLE_AMR) || defined(LIBMESH_ENABLE_PERIODIC)</span>
<a name="l01944"></a>01944 <span class="preprocessor"></span>          <a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php#adaaeb1039af971d4376bcd896686a281">dof_map</a>.<a class="code" href="classlibMesh_1_1DofMap.php#aeb1398dca8edb951fbd22762fedd0500">find_connected_dofs</a> (element_dofs);
<a name="l01945"></a>01945 <span class="preprocessor">#endif</span>
<a name="l01946"></a>01946 <span class="preprocessor"></span>
<a name="l01947"></a>01947           <span class="comment">// We can be more efficient if we sort the element DOFs</span>
<a name="l01948"></a>01948           <span class="comment">// into increasing order</span>
<a name="l01949"></a>01949           std::sort(element_dofs.begin(), element_dofs.end());
<a name="l01950"></a>01950           
<a name="l01951"></a>01951           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_dofs_on_element = element_dofs.size();
<a name="l01952"></a>01952             
<a name="l01953"></a>01953           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_dofs_on_element; i++)
<a name="l01954"></a>01954             {
<a name="l01955"></a>01955               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ig = element_dofs[i];
<a name="l01956"></a>01956               
<a name="l01957"></a>01957               <span class="comment">// Only bother if this matrix row will be stored</span>
<a name="l01958"></a>01958               <span class="comment">// on this processor.</span>
<a name="l01959"></a>01959               <span class="keywordflow">if</span> ((ig &gt;= first_dof_on_proc) &amp;&amp;
<a name="l01960"></a>01960                   (ig &lt;  end_dof_on_proc))
<a name="l01961"></a>01961                 {
<a name="l01962"></a>01962                   <span class="comment">// This is what I mean</span>
<a name="l01963"></a>01963                   <span class="comment">// libmesh_assert ((ig - first_dof_on_proc) &gt;= 0);</span>
<a name="l01964"></a>01964                   <span class="comment">// but do the test like this because ig and</span>
<a name="l01965"></a>01965                   <span class="comment">// first_dof_on_proc are unsigned ints</span>
<a name="l01966"></a>01966                   libmesh_assert (ig &gt;= first_dof_on_proc);
<a name="l01967"></a>01967                   libmesh_assert ((ig - first_dof_on_proc) &lt; <a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php#a054aa3bf4ab1ff21352e2aaf2495c589">sparsity_pattern</a>.size());
<a name="l01968"></a>01968                   
<a name="l01969"></a>01969                   <a class="code" href="namespacelibMesh_1_1SparsityPattern.php#a2e0f69d5c103cf7baee9f8fd5929cbb7">SparsityPattern::Row</a> &amp;row = <a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php#a054aa3bf4ab1ff21352e2aaf2495c589">sparsity_pattern</a>[ig - first_dof_on_proc];
<a name="l01970"></a>01970 
<a name="l01971"></a>01971                   <span class="comment">// If the row is empty we will add *all* the element DOFs,</span>
<a name="l01972"></a>01972                   <span class="comment">// so just do that.</span>
<a name="l01973"></a>01973                   <span class="keywordflow">if</span> (row.empty())
<a name="l01974"></a>01974                     {
<a name="l01975"></a>01975                       row.insert(row.end(),
<a name="l01976"></a>01976                                  element_dofs.begin(),
<a name="l01977"></a>01977                                  element_dofs.end());
<a name="l01978"></a>01978                     }
<a name="l01979"></a>01979                   <span class="keywordflow">else</span>
<a name="l01980"></a>01980                     {             
<a name="l01981"></a>01981                       <span class="comment">// Build a list of the DOF indices not found in the</span>
<a name="l01982"></a>01982                       <span class="comment">// sparsity pattern</span>
<a name="l01983"></a>01983                       dofs_to_add.clear();
<a name="l01984"></a>01984 
<a name="l01985"></a>01985                       <span class="comment">// Cache iterators.  Low will move forward, subsequent</span>
<a name="l01986"></a>01986                       <span class="comment">// searches will be on smaller ranges</span>
<a name="l01987"></a>01987                       SparsityPattern::Row::iterator
<a name="l01988"></a>01988                         low  = std::lower_bound (row.begin(), row.end(), element_dofs.front()),
<a name="l01989"></a>01989                         high = std::upper_bound (low,         row.end(), element_dofs.back());
<a name="l01990"></a>01990                   
<a name="l01991"></a>01991                       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;n_dofs_on_element; j++)
<a name="l01992"></a>01992                         {
<a name="l01993"></a>01993                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> jg = element_dofs[j];
<a name="l01994"></a>01994                           
<a name="l01995"></a>01995                           <span class="comment">// See if jg is in the sorted range</span>
<a name="l01996"></a>01996                           std::pair&lt;SparsityPattern::Row::iterator,
<a name="l01997"></a>01997                                     SparsityPattern::Row::iterator&gt;
<a name="l01998"></a>01998                             pos = std::equal_range (low, high, jg);
<a name="l01999"></a>01999                         
<a name="l02000"></a>02000                           <span class="comment">// Must add jg if it wasn&#39;t found</span>
<a name="l02001"></a>02001                           <span class="keywordflow">if</span> (pos.first == pos.second)
<a name="l02002"></a>02002                             dofs_to_add.push_back(jg);
<a name="l02003"></a>02003                         
<a name="l02004"></a>02004                           <span class="comment">// pos.first is now a valid lower bound for any</span>
<a name="l02005"></a>02005                           <span class="comment">// remaining element DOFs. (That&#39;s why we sorted them.)</span>
<a name="l02006"></a>02006                           <span class="comment">// Use it for the next search</span>
<a name="l02007"></a>02007                           low = pos.first;
<a name="l02008"></a>02008                         }
<a name="l02009"></a>02009 
<a name="l02010"></a>02010                       <span class="comment">// Add to the sparsity pattern</span>
<a name="l02011"></a>02011                       <span class="keywordflow">if</span> (!dofs_to_add.empty())
<a name="l02012"></a>02012                         {
<a name="l02013"></a>02013                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> old_size = row.size();
<a name="l02014"></a>02014                           
<a name="l02015"></a>02015                           row.insert (row.end(),
<a name="l02016"></a>02016                                       dofs_to_add.begin(),
<a name="l02017"></a>02017                                       dofs_to_add.end());
<a name="l02018"></a>02018                       
<a name="l02019"></a>02019                           <a class="code" href="namespacelibMesh_1_1SparsityPattern.php#a3f484f3a9c8ae7878d8e91d16859c624">SparsityPattern::sort_row</a> (row.begin(), row.begin()+old_size, row.end());
<a name="l02020"></a>02020                         }
<a name="l02021"></a>02021                     }
<a name="l02022"></a>02022                   
<a name="l02023"></a>02023                   <span class="comment">// Now (possibly) add dofs from neighboring elements</span>
<a name="l02024"></a>02024                   <span class="comment">// TODO:[BSK] optimize this like above!</span>
<a name="l02025"></a>02025                   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php#a65ae2307529ece863ce1092155185762">implicit_neighbor_dofs</a>)
<a name="l02026"></a>02026                     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s=0; s&lt;elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ae376bfa6ac14723330e07a97992b56c9">n_sides</a>(); s++)
<a name="l02027"></a>02027                       <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(s) != NULL)
<a name="l02028"></a>02028                         {
<a name="l02029"></a>02029                           <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <span class="keyword">const</span> neighbor_0 = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(s);
<a name="l02030"></a>02030 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l02031"></a>02031 <span class="preprocessor"></span>                          neighbor_0-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a93229ab6804e5876a99368817120d9c3">active_family_tree_by_neighbor</a>(active_neighbors,elem);
<a name="l02032"></a>02032 <span class="preprocessor">#else</span>
<a name="l02033"></a>02033 <span class="preprocessor"></span>                          active_neighbors.clear();
<a name="l02034"></a>02034                           active_neighbors.push_back(neighbor_0);
<a name="l02035"></a>02035 <span class="preprocessor">#endif</span>
<a name="l02036"></a>02036 <span class="preprocessor"></span>                          
<a name="l02037"></a>02037                           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> a=0; a != active_neighbors.size(); ++a)
<a name="l02038"></a>02038                             {
<a name="l02039"></a>02039                               <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *neighbor = active_neighbors[a];
<a name="l02040"></a>02040                               
<a name="l02041"></a>02041                               <a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php#adaaeb1039af971d4376bcd896686a281">dof_map</a>.<a class="code" href="classlibMesh_1_1DofMap.php#a5dac22ba99a9da3563c00b7dfd2f07af">dof_indices</a> (neighbor, neighbor_dofs);
<a name="l02042"></a>02042 <span class="preprocessor">#if defined(LIBMESH_ENABLE_AMR) || defined(LIBMESH_ENABLE_PERIODIC)</span>
<a name="l02043"></a>02043 <span class="preprocessor"></span>                              <a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php#adaaeb1039af971d4376bcd896686a281">dof_map</a>.<a class="code" href="classlibMesh_1_1DofMap.php#aeb1398dca8edb951fbd22762fedd0500">find_connected_dofs</a> (neighbor_dofs);
<a name="l02044"></a>02044 <span class="preprocessor">#endif                        </span>
<a name="l02045"></a>02045 <span class="preprocessor"></span>                              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_dofs_on_neighbor = neighbor_dofs.size();
<a name="l02046"></a>02046                               
<a name="l02047"></a>02047                               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;n_dofs_on_neighbor; j++)
<a name="l02048"></a>02048                                 {
<a name="l02049"></a>02049                                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> jg = neighbor_dofs[j];
<a name="l02050"></a>02050                                   
<a name="l02051"></a>02051                                   <span class="comment">// See if jg is in the sorted range</span>
<a name="l02052"></a>02052                                   std::pair&lt;SparsityPattern::Row::iterator,
<a name="l02053"></a>02053                                             SparsityPattern::Row::iterator&gt;
<a name="l02054"></a>02054                                     pos = std::equal_range (row.begin(), row.end(), jg);
<a name="l02055"></a>02055                                 
<a name="l02056"></a>02056                                   <span class="comment">// Insert jg if it wasn&#39;t found</span>
<a name="l02057"></a>02057                                   <span class="keywordflow">if</span> (pos.first == pos.second)
<a name="l02058"></a>02058                                     row.insert (pos.first, jg);
<a name="l02059"></a>02059                                 }    
<a name="l02060"></a>02060                             }
<a name="l02061"></a>02061                         }
<a name="l02062"></a>02062                 }
<a name="l02063"></a>02063             }
<a name="l02064"></a>02064         }             
<a name="l02065"></a>02065     } 
<a name="l02066"></a>02066 
<a name="l02067"></a>02067 
<a name="l02068"></a>02068   
<a name="l02069"></a>02069   <span class="comment">// This is what we do in the case that the user has specified</span>
<a name="l02070"></a>02070   <span class="comment">// explicit DOF coupling.</span>
<a name="l02071"></a>02071   <span class="keywordflow">else</span>
<a name="l02072"></a>02072     {
<a name="l02073"></a>02073       libmesh_assert (<a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php#a7e288ac68552ad57f0b56c9feff455b2">dof_coupling</a> != NULL);
<a name="l02074"></a>02074       libmesh_assert (<a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php#a7e288ac68552ad57f0b56c9feff455b2">dof_coupling</a>-&gt;<a class="code" href="classlibMesh_1_1CouplingMatrix.php#ae185f5ff037a9a838aa18d7f9537ff6d">size</a>() ==
<a name="l02075"></a>02075                       <a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php#adaaeb1039af971d4376bcd896686a281">dof_map</a>.<a class="code" href="classlibMesh_1_1DofMap.php#aee89c467613b296c215421d60d5ae961">n_variables</a>());
<a name="l02076"></a>02076       
<a name="l02077"></a>02077       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_var = <a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php#adaaeb1039af971d4376bcd896686a281">dof_map</a>.<a class="code" href="classlibMesh_1_1DofMap.php#aee89c467613b296c215421d60d5ae961">n_variables</a>();
<a name="l02078"></a>02078       
<a name="l02079"></a>02079       std::vector&lt;unsigned int&gt;
<a name="l02080"></a>02080         element_dofs_i,
<a name="l02081"></a>02081         element_dofs_j,
<a name="l02082"></a>02082         neighbor_dofs,
<a name="l02083"></a>02083         dofs_to_add;
<a name="l02084"></a>02084 
<a name="l02085"></a>02085 
<a name="l02086"></a>02086       std::vector&lt;const Elem*&gt; active_neighbors;
<a name="l02087"></a>02087       <span class="keywordflow">for</span> (<a class="code" href="classlibMesh_1_1StoredRange.php#a07c6e88eede585628af3437d8cad903f">ConstElemRange::const_iterator</a> elem_it = range.<a class="code" href="classlibMesh_1_1StoredRange.php#a9687da8abb136c142c4df14f4444737b">begin</a>() ; elem_it != range.<a class="code" href="classlibMesh_1_1StoredRange.php#aff337b550b3349015980e791dd982b21">end</a>(); ++elem_it)
<a name="l02088"></a>02088         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> vi=0; vi&lt;n_var; vi++)
<a name="l02089"></a>02089           {
<a name="l02090"></a>02090             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <span class="keyword">const</span> elem = *elem_it;
<a name="l02091"></a>02091             
<a name="l02092"></a>02092             <span class="comment">// Find element dofs for variable vi</span>
<a name="l02093"></a>02093             <a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php#adaaeb1039af971d4376bcd896686a281">dof_map</a>.<a class="code" href="classlibMesh_1_1DofMap.php#a5dac22ba99a9da3563c00b7dfd2f07af">dof_indices</a> (elem, element_dofs_i, vi);
<a name="l02094"></a>02094 <span class="preprocessor">#if defined(LIBMESH_ENABLE_AMR) || defined(LIBMESH_ENABLE_PERIODIC)</span>
<a name="l02095"></a>02095 <span class="preprocessor"></span>            <a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php#adaaeb1039af971d4376bcd896686a281">dof_map</a>.<a class="code" href="classlibMesh_1_1DofMap.php#aeb1398dca8edb951fbd22762fedd0500">find_connected_dofs</a> (element_dofs_i);
<a name="l02096"></a>02096 <span class="preprocessor">#endif</span>
<a name="l02097"></a>02097 <span class="preprocessor"></span>
<a name="l02098"></a>02098             <span class="comment">// We can be more efficient if we sort the element DOFs</span>
<a name="l02099"></a>02099             <span class="comment">// into increasing order</span>
<a name="l02100"></a>02100             std::sort(element_dofs_i.begin(), element_dofs_i.end());
<a name="l02101"></a>02101             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_dofs_on_element_i = element_dofs_i.size();
<a name="l02102"></a>02102             
<a name="l02103"></a>02103             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> vj=0; vj&lt;n_var; vj++)
<a name="l02104"></a>02104               <span class="keywordflow">if</span> ((*<a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php#a7e288ac68552ad57f0b56c9feff455b2">dof_coupling</a>)(vi,vj)) <span class="comment">// If vi couples to vj</span>
<a name="l02105"></a>02105                 {
<a name="l02106"></a>02106                   <span class="comment">// Find element dofs for variable vj, note that</span>
<a name="l02107"></a>02107                   <span class="comment">// if vi==vj we already have the dofs.</span>
<a name="l02108"></a>02108                   <span class="keywordflow">if</span> (vi != vj)
<a name="l02109"></a>02109                     {
<a name="l02110"></a>02110                       <a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php#adaaeb1039af971d4376bcd896686a281">dof_map</a>.<a class="code" href="classlibMesh_1_1DofMap.php#a5dac22ba99a9da3563c00b7dfd2f07af">dof_indices</a> (elem, element_dofs_j, vj);
<a name="l02111"></a>02111 <span class="preprocessor">#if defined(LIBMESH_ENABLE_AMR) || defined(LIBMESH_ENABLE_PERIODIC)</span>
<a name="l02112"></a>02112 <span class="preprocessor"></span>                      <a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php#adaaeb1039af971d4376bcd896686a281">dof_map</a>.<a class="code" href="classlibMesh_1_1DofMap.php#aeb1398dca8edb951fbd22762fedd0500">find_connected_dofs</a> (element_dofs_j);
<a name="l02113"></a>02113 <span class="preprocessor">#endif</span>
<a name="l02114"></a>02114 <span class="preprocessor"></span>
<a name="l02115"></a>02115                       <span class="comment">// We can be more efficient if we sort the element DOFs</span>
<a name="l02116"></a>02116                       <span class="comment">// into increasing order</span>
<a name="l02117"></a>02117                       std::sort (element_dofs_j.begin(), element_dofs_j.end());
<a name="l02118"></a>02118                     }
<a name="l02119"></a>02119                   <span class="keywordflow">else</span>
<a name="l02120"></a>02120                     element_dofs_j = element_dofs_i;
<a name="l02121"></a>02121                   
<a name="l02122"></a>02122                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_dofs_on_element_j =
<a name="l02123"></a>02123                     element_dofs_j.size();
<a name="l02124"></a>02124                   
<a name="l02125"></a>02125                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_dofs_on_element_i; i++)
<a name="l02126"></a>02126                     {
<a name="l02127"></a>02127                       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ig = element_dofs_i[i];
<a name="l02128"></a>02128                       
<a name="l02129"></a>02129                       <span class="comment">// We are only interested in computing the sparsity pattern</span>
<a name="l02130"></a>02130                       <span class="comment">// for the rows in [range.begin(),range.end()).  So, if this</span>
<a name="l02131"></a>02131                       <span class="comment">// element&#39;s DOFs are not in that range just go ahead to the</span>
<a name="l02132"></a>02132                       <span class="comment">// next one.</span>
<a name="l02133"></a>02133                       <span class="comment">//              </span>
<a name="l02134"></a>02134                       <span class="comment">// Also, only bother if this matrix row will be stored</span>
<a name="l02135"></a>02135                       <span class="comment">// on this processor.</span>
<a name="l02136"></a>02136                       <span class="keywordflow">if</span> ((ig &gt;= first_dof_on_proc) &amp;&amp;
<a name="l02137"></a>02137                           (ig &lt;  end_dof_on_proc))                      
<a name="l02138"></a>02138                         {
<a name="l02139"></a>02139                           <span class="comment">// This is what I mean</span>
<a name="l02140"></a>02140                           <span class="comment">// libmesh_assert ((ig - first_dof_on_proc) &gt;= 0);</span>
<a name="l02141"></a>02141                           <span class="comment">// but do the test like this because ig and</span>
<a name="l02142"></a>02142                           <span class="comment">// first_dof_on_proc are unsigned ints</span>
<a name="l02143"></a>02143                           libmesh_assert (ig &gt;= first_dof_on_proc);
<a name="l02144"></a>02144                           libmesh_assert (ig &lt; (<a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php#a054aa3bf4ab1ff21352e2aaf2495c589">sparsity_pattern</a>.size() +
<a name="l02145"></a>02145                                         first_dof_on_proc));
<a name="l02146"></a>02146                           
<a name="l02147"></a>02147                           <a class="code" href="namespacelibMesh_1_1SparsityPattern.php#a2e0f69d5c103cf7baee9f8fd5929cbb7">SparsityPattern::Row</a> &amp;row = <a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php#a054aa3bf4ab1ff21352e2aaf2495c589">sparsity_pattern</a>[ig - first_dof_on_proc];
<a name="l02148"></a>02148 
<a name="l02149"></a>02149                           <span class="comment">// If the row is empty we will add *all* the element j DOFs,</span>
<a name="l02150"></a>02150                           <span class="comment">// so just do that.</span>
<a name="l02151"></a>02151                           <span class="keywordflow">if</span> (row.empty())
<a name="l02152"></a>02152                             {
<a name="l02153"></a>02153                               row.insert(row.end(),
<a name="l02154"></a>02154                                          element_dofs_j.begin(),
<a name="l02155"></a>02155                                          element_dofs_j.end());
<a name="l02156"></a>02156                             }
<a name="l02157"></a>02157                           <span class="keywordflow">else</span>
<a name="l02158"></a>02158                             {             
<a name="l02159"></a>02159                               <span class="comment">// Build a list of the DOF indices not found in the</span>
<a name="l02160"></a>02160                               <span class="comment">// sparsity pattern</span>
<a name="l02161"></a>02161                               dofs_to_add.clear();
<a name="l02162"></a>02162 
<a name="l02163"></a>02163                               <span class="comment">// Cache iterators.  Low will move forward, subsequent</span>
<a name="l02164"></a>02164                               <span class="comment">// searches will be on smaller ranges</span>
<a name="l02165"></a>02165                               SparsityPattern::Row::iterator
<a name="l02166"></a>02166                                 low  = std::lower_bound (row.begin(), row.end(), element_dofs_j.front()),
<a name="l02167"></a>02167                                 high = std::upper_bound (low,         row.end(), element_dofs_j.back());
<a name="l02168"></a>02168 
<a name="l02169"></a>02169                               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;n_dofs_on_element_j; j++)
<a name="l02170"></a>02170                                 {
<a name="l02171"></a>02171                                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> jg = element_dofs_j[j];
<a name="l02172"></a>02172                                   
<a name="l02173"></a>02173                                   <span class="comment">// See if jg is in the sorted range</span>
<a name="l02174"></a>02174                                   std::pair&lt;SparsityPattern::Row::iterator,
<a name="l02175"></a>02175                                             SparsityPattern::Row::iterator&gt;
<a name="l02176"></a>02176                                     pos = std::equal_range (low, high, jg);
<a name="l02177"></a>02177                               
<a name="l02178"></a>02178                                   <span class="comment">// Must add jg if it wasn&#39;t found</span>
<a name="l02179"></a>02179                                   <span class="keywordflow">if</span> (pos.first == pos.second)
<a name="l02180"></a>02180                                     dofs_to_add.push_back(jg);
<a name="l02181"></a>02181                                 
<a name="l02182"></a>02182                                   <span class="comment">// pos.first is now a valid lower bound for any</span>
<a name="l02183"></a>02183                                   <span class="comment">// remaining element j DOFs. (That&#39;s why we sorted them.)</span>
<a name="l02184"></a>02184                                   <span class="comment">// Use it for the next search</span>
<a name="l02185"></a>02185                                   low = pos.first;
<a name="l02186"></a>02186                                 }
<a name="l02187"></a>02187                               
<a name="l02188"></a>02188                               <span class="comment">// Add to the sparsity pattern</span>
<a name="l02189"></a>02189                               <span class="keywordflow">if</span> (!dofs_to_add.empty())
<a name="l02190"></a>02190                                 {
<a name="l02191"></a>02191                                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> old_size = row.size();
<a name="l02192"></a>02192                                   
<a name="l02193"></a>02193                                   row.insert (row.end(),
<a name="l02194"></a>02194                                               dofs_to_add.begin(),
<a name="l02195"></a>02195                                               dofs_to_add.end());
<a name="l02196"></a>02196                       
<a name="l02197"></a>02197                                   <a class="code" href="namespacelibMesh_1_1SparsityPattern.php#a3f484f3a9c8ae7878d8e91d16859c624">SparsityPattern::sort_row</a> (row.begin(), row.begin()+old_size, row.end());
<a name="l02198"></a>02198                                 }
<a name="l02199"></a>02199                             }
<a name="l02200"></a>02200                           <span class="comment">// Now (possibly) add dofs from neighboring elements</span>
<a name="l02201"></a>02201                           <span class="comment">// TODO:[BSK] optimize this like above!</span>
<a name="l02202"></a>02202                           <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php#a65ae2307529ece863ce1092155185762">implicit_neighbor_dofs</a>)
<a name="l02203"></a>02203                             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s=0; s&lt;elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ae376bfa6ac14723330e07a97992b56c9">n_sides</a>(); s++)
<a name="l02204"></a>02204                               <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(s) != NULL)
<a name="l02205"></a>02205                                 {
<a name="l02206"></a>02206                                   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <span class="keyword">const</span> neighbor_0 = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(s);
<a name="l02207"></a>02207 <span class="preprocessor">         #ifdef LIBMESH_ENABLE_AMR</span>
<a name="l02208"></a>02208 <span class="preprocessor"></span>                                  neighbor_0-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a93229ab6804e5876a99368817120d9c3">active_family_tree_by_neighbor</a>(active_neighbors,elem);
<a name="l02209"></a>02209 <span class="preprocessor">         #else</span>
<a name="l02210"></a>02210 <span class="preprocessor"></span>                                  active_neighbors.clear();
<a name="l02211"></a>02211                                   active_neighbors.push_back(neighbor_0);
<a name="l02212"></a>02212 <span class="preprocessor">         #endif</span>
<a name="l02213"></a>02213 <span class="preprocessor"></span>                                  
<a name="l02214"></a>02214                                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> a=0; a != active_neighbors.size(); ++a)
<a name="l02215"></a>02215                                     {
<a name="l02216"></a>02216                                       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *neighbor = active_neighbors[a];
<a name="l02217"></a>02217                                       
<a name="l02218"></a>02218                                       <a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php#adaaeb1039af971d4376bcd896686a281">dof_map</a>.<a class="code" href="classlibMesh_1_1DofMap.php#a5dac22ba99a9da3563c00b7dfd2f07af">dof_indices</a> (neighbor, neighbor_dofs);
<a name="l02219"></a>02219 <span class="preprocessor">     #if defined(LIBMESH_ENABLE_AMR) || defined(LIBMESH_ENABLE_PERIODIC)</span>
<a name="l02220"></a>02220 <span class="preprocessor"></span>                                    <a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php#adaaeb1039af971d4376bcd896686a281">dof_map</a>.<a class="code" href="classlibMesh_1_1DofMap.php#aeb1398dca8edb951fbd22762fedd0500">find_connected_dofs</a> (neighbor_dofs);
<a name="l02221"></a>02221 <span class="preprocessor">     #endif                           </span>
<a name="l02222"></a>02222 <span class="preprocessor"></span>                                    <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_dofs_on_neighbor = neighbor_dofs.size();
<a name="l02223"></a>02223                                     
<a name="l02224"></a>02224                                     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;n_dofs_on_neighbor; j++)
<a name="l02225"></a>02225                                       {
<a name="l02226"></a>02226                                         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> jg = neighbor_dofs[j];
<a name="l02227"></a>02227                                         
<a name="l02228"></a>02228                                         <span class="comment">// See if jg is in the sorted range</span>
<a name="l02229"></a>02229                                         std::pair&lt;SparsityPattern::Row::iterator,
<a name="l02230"></a>02230                                                   SparsityPattern::Row::iterator&gt;
<a name="l02231"></a>02231                                           pos = std::equal_range (row.begin(), row.end(), jg);
<a name="l02232"></a>02232                                        
<a name="l02233"></a>02233                                         <span class="comment">// Insert jg if it wasn&#39;t found</span>
<a name="l02234"></a>02234                                         <span class="keywordflow">if</span> (pos.first == pos.second)
<a name="l02235"></a>02235                                           row.insert (pos.first, jg);
<a name="l02236"></a>02236                                       }    
<a name="l02237"></a>02237                                   }
<a name="l02238"></a>02238                               }
<a name="l02239"></a>02239                         }
<a name="l02240"></a>02240                     }
<a name="l02241"></a>02241                 }
<a name="l02242"></a>02242           }
<a name="l02243"></a>02243     }
<a name="l02244"></a>02244   
<a name="l02245"></a>02245   <span class="comment">// Now the full sparsity structure is built for all of the</span>
<a name="l02246"></a>02246   <span class="comment">// DOFs connected to our rows of the matrix.</span>
<a name="l02247"></a>02247   <a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php#a4624e244606dff65d27017738a51003f">n_nz</a>.resize (n_dofs_on_proc);
<a name="l02248"></a>02248   <a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php#af51c83786a5f07846030c63a6d560c3f">n_oz</a>.resize (n_dofs_on_proc);
<a name="l02249"></a>02249 
<a name="l02250"></a>02250   <span class="comment">// First zero the counters.</span>
<a name="l02251"></a>02251   std::fill(<a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php#a4624e244606dff65d27017738a51003f">n_nz</a>.begin(), <a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php#a4624e244606dff65d27017738a51003f">n_nz</a>.end(), 0);
<a name="l02252"></a>02252   std::fill(<a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php#af51c83786a5f07846030c63a6d560c3f">n_oz</a>.begin(), <a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php#af51c83786a5f07846030c63a6d560c3f">n_oz</a>.end(), 0);
<a name="l02253"></a>02253   
<a name="l02254"></a>02254   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_dofs_on_proc; i++)
<a name="l02255"></a>02255     {
<a name="l02256"></a>02256       <span class="comment">// Get the row of the sparsity pattern</span>
<a name="l02257"></a>02257       <span class="keyword">const</span> <a class="code" href="namespacelibMesh_1_1SparsityPattern.php#a2e0f69d5c103cf7baee9f8fd5929cbb7">SparsityPattern::Row</a> &amp;row = <a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php#a054aa3bf4ab1ff21352e2aaf2495c589">sparsity_pattern</a>[i];
<a name="l02258"></a>02258 
<a name="l02259"></a>02259       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;row.size(); j++)
<a name="l02260"></a>02260         <span class="keywordflow">if</span> ((row[j] &lt; first_dof_on_proc) || (row[j] &gt;= end_dof_on_proc))
<a name="l02261"></a>02261           <a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php#af51c83786a5f07846030c63a6d560c3f">n_oz</a>[i]++;
<a name="l02262"></a>02262         <span class="keywordflow">else</span>
<a name="l02263"></a>02263           <a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php#a4624e244606dff65d27017738a51003f">n_nz</a>[i]++;
<a name="l02264"></a>02264     }
<a name="l02265"></a>02265 }
<a name="l02266"></a>02266 
<a name="l02267"></a>02267 
<a name="l02268"></a>02268 
<a name="l02269"></a><a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php#a0a76acc8f8e9997d9572957695835302">02269</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php#a0a76acc8f8e9997d9572957695835302">SparsityPattern::Build::join</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php">SparsityPattern::Build</a> &amp;other)
<a name="l02270"></a>02270 {
<a name="l02271"></a>02271   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id           = <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#aa557872c33163622cc66645fc393c925">processor_id</a>();
<a name="l02272"></a>02272   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_global_dofs     = dof_map.n_dofs();
<a name="l02273"></a>02273   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_dofs_on_proc    = dof_map.n_dofs_on_processor(proc_id);
<a name="l02274"></a>02274   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> first_dof_on_proc = dof_map.first_dof(proc_id);
<a name="l02275"></a>02275   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> end_dof_on_proc   = dof_map.end_dof(proc_id);
<a name="l02276"></a>02276 
<a name="l02277"></a>02277   libmesh_assert (sparsity_pattern.size() ==  other.<a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php#a054aa3bf4ab1ff21352e2aaf2495c589">sparsity_pattern</a>.size());
<a name="l02278"></a>02278   libmesh_assert (n_nz.size() == sparsity_pattern.size());
<a name="l02279"></a>02279   libmesh_assert (n_oz.size() == sparsity_pattern.size());
<a name="l02280"></a>02280   
<a name="l02281"></a>02281   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> r=0; r&lt;n_dofs_on_proc; r++)
<a name="l02282"></a>02282     {
<a name="l02283"></a>02283       <span class="comment">// incriment the number of on and off-processor nonzeros in this row</span>
<a name="l02284"></a>02284       <span class="comment">// (note this will be an upper bound unless we need the full sparsity pattern)</span>
<a name="l02285"></a>02285       n_nz[r] += other.<a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php#a4624e244606dff65d27017738a51003f">n_nz</a>[r];  n_nz[r] = <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(n_nz[r], n_dofs_on_proc);
<a name="l02286"></a>02286       n_oz[r] += other.<a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php#af51c83786a5f07846030c63a6d560c3f">n_oz</a>[r];  n_oz[r] = <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(n_oz[r], n_global_dofs-n_nz[r]);
<a name="l02287"></a>02287 
<a name="l02288"></a>02288       <span class="keywordflow">if</span> (need_full_sparsity_pattern)
<a name="l02289"></a>02289         {
<a name="l02290"></a>02290           <a class="code" href="namespacelibMesh_1_1SparsityPattern.php#a2e0f69d5c103cf7baee9f8fd5929cbb7">SparsityPattern::Row</a>       &amp;my_row    = sparsity_pattern[r];
<a name="l02291"></a>02291           <span class="keyword">const</span> <a class="code" href="namespacelibMesh_1_1SparsityPattern.php#a2e0f69d5c103cf7baee9f8fd5929cbb7">SparsityPattern::Row</a> &amp;their_row = other.<a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php#a054aa3bf4ab1ff21352e2aaf2495c589">sparsity_pattern</a>[r];
<a name="l02292"></a>02292       
<a name="l02293"></a>02293           <span class="comment">// simple copy if I have no dofs</span>
<a name="l02294"></a>02294           <span class="keywordflow">if</span> (my_row.empty())
<a name="l02295"></a>02295             my_row = their_row;
<a name="l02296"></a>02296           
<a name="l02297"></a>02297           <span class="comment">// otherwise add their DOFs to mine, resort, and re-unique the row</span>
<a name="l02298"></a>02298           <span class="keywordflow">else</span> <span class="keywordflow">if</span> (!their_row.empty()) <span class="comment">// do nothing for the trivial case where </span>
<a name="l02299"></a>02299             {                          <span class="comment">// their row is empty</span>
<a name="l02300"></a>02300               my_row.insert (my_row.end(),
<a name="l02301"></a>02301                              their_row.begin(),
<a name="l02302"></a>02302                              their_row.end());
<a name="l02303"></a>02303 
<a name="l02304"></a>02304               <span class="comment">// We cannot use SparsityPattern::sort_row() here because it expects</span>
<a name="l02305"></a>02305               <span class="comment">// the [begin,middle) [middle,end) to be non-overlapping.  This is not</span>
<a name="l02306"></a>02306               <span class="comment">// necessarily the case here, so use std::sort()</span>
<a name="l02307"></a>02307               std::sort (my_row.begin(), my_row.end());
<a name="l02308"></a>02308          
<a name="l02309"></a>02309               my_row.erase(std::unique (my_row.begin(), my_row.end()), my_row.end());
<a name="l02310"></a>02310             }
<a name="l02311"></a>02311 
<a name="l02312"></a>02312           <span class="comment">// fix the number of on and off-processor nonzeros in this row</span>
<a name="l02313"></a>02313           n_nz[r] = n_oz[r] = 0;
<a name="l02314"></a>02314           
<a name="l02315"></a>02315           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;my_row.size(); j++)
<a name="l02316"></a>02316             <span class="keywordflow">if</span> ((my_row[j] &lt; first_dof_on_proc) || (my_row[j] &gt;= end_dof_on_proc))
<a name="l02317"></a>02317               n_oz[r]++;
<a name="l02318"></a>02318             <span class="keywordflow">else</span>
<a name="l02319"></a>02319               n_nz[r]++;
<a name="l02320"></a>02320         }
<a name="l02321"></a>02321     }
<a name="l02322"></a>02322 }
<a name="l02323"></a>02323 
<a name="l02324"></a>02324 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
