<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_c3a49989e40b21e7508f29d2dc962def.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_32bb88e3eb1b93402cfe508abee484a3.php">mesh</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">mesh_refinement.C</div>  </div>
</div>
<div class="contents">
<a href="mesh__refinement_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id$</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="comment">// C++ includes</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &lt;cmath&gt;</span> <span class="comment">// for isnan(), when it&#39;s defined</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &lt;limits&gt;</span>
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 <span class="comment">// Local includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>&quot;</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="comment">// only compile these functions if the user requests AMR support</span>
<a name="l00029"></a>00029 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="boundary__info_8h.php">boundary_info.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="elem_8h.php">elem.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="error__vector_8h.php">error_vector.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__logging_8h.php">libmesh_logging.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="mesh__base_8h.php">mesh_base.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="mesh__communication_8h.php">mesh_communication.h</a>&quot;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;<a class="code" href="mesh__refinement_8h.php">mesh_refinement.h</a>&quot;</span>
<a name="l00038"></a>00038 <span class="preprocessor">#include &quot;<a class="code" href="parallel_8h.php">parallel.h</a>&quot;</span>
<a name="l00039"></a>00039 <span class="preprocessor">#include &quot;<a class="code" href="parallel__ghost__sync_8h.php">parallel_ghost_sync.h</a>&quot;</span>
<a name="l00040"></a>00040 <span class="preprocessor">#include &quot;<a class="code" href="remote__elem_8h.php">remote_elem.h</a>&quot;</span>
<a name="l00041"></a>00041 
<a name="l00042"></a>00042 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00043"></a>00043 <span class="preprocessor"></span><span class="comment">// Some extra validation for ParallelMesh</span>
<a name="l00044"></a>00044 <span class="preprocessor">#include &quot;<a class="code" href="mesh__tools_8h.php">mesh_tools.h</a>&quot;</span>
<a name="l00045"></a>00045 <span class="preprocessor">#include &quot;<a class="code" href="parallel__mesh_8h.php">parallel_mesh.h</a>&quot;</span>
<a name="l00046"></a>00046 <span class="preprocessor">#endif // DEBUG</span>
<a name="l00047"></a>00047 <span class="preprocessor"></span>
<a name="l00048"></a>00048 
<a name="l00049"></a>00049 <span class="keyword">namespace </span>libMesh
<a name="l00050"></a>00050 {
<a name="l00051"></a>00051 
<a name="l00052"></a>00052 <span class="comment">//-----------------------------------------------------------------</span>
<a name="l00053"></a>00053 <span class="comment">// Mesh refinement methods</span>
<a name="l00054"></a><a class="code" href="classlibMesh_1_1MeshRefinement.php#aa08885aefc8dbd6572f9b2478b17e92f">00054</a> <a class="code" href="classlibMesh_1_1MeshRefinement.php#aa08885aefc8dbd6572f9b2478b17e92f">MeshRefinement::MeshRefinement</a> (<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; m) :
<a name="l00055"></a>00055   _mesh(m),
<a name="l00056"></a>00056   _use_member_parameters(false),
<a name="l00057"></a>00057   _coarsen_by_parents(false),
<a name="l00058"></a>00058   _refine_fraction(0.3),
<a name="l00059"></a>00059   _coarsen_fraction(0.0),
<a name="l00060"></a>00060   _max_h_level(libMesh::<a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">invalid_uint</a>),
<a name="l00061"></a>00061   _coarsen_threshold(10),
<a name="l00062"></a>00062   _nelem_target(0),
<a name="l00063"></a>00063   _absolute_global_tolerance(0.0),
<a name="l00064"></a>00064   _face_level_mismatch_limit(1),
<a name="l00065"></a>00065   _edge_level_mismatch_limit(0),
<a name="l00066"></a>00066   _node_level_mismatch_limit(0)
<a name="l00067"></a>00067 {
<a name="l00068"></a>00068 }
<a name="l00069"></a>00069 
<a name="l00070"></a>00070 
<a name="l00071"></a>00071 
<a name="l00072"></a><a class="code" href="classlibMesh_1_1MeshRefinement.php#ac2b4fc8fbeef7897987b69fdba7d2ccc">00072</a> <a class="code" href="classlibMesh_1_1MeshRefinement.php#ac2b4fc8fbeef7897987b69fdba7d2ccc">MeshRefinement::~MeshRefinement</a> ()
<a name="l00073"></a>00073 {
<a name="l00074"></a>00074   this-&gt;<a class="code" href="classlibMesh_1_1MeshRefinement.php#ac64e4f1afa4af23fe11997dfbeae071b">clear</a>();  
<a name="l00075"></a>00075 }
<a name="l00076"></a>00076 
<a name="l00077"></a>00077 
<a name="l00078"></a>00078 
<a name="l00079"></a><a class="code" href="classlibMesh_1_1MeshRefinement.php#ac64e4f1afa4af23fe11997dfbeae071b">00079</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshRefinement.php#ac64e4f1afa4af23fe11997dfbeae071b">MeshRefinement::clear</a> ()
<a name="l00080"></a>00080 {
<a name="l00081"></a>00081   <a class="code" href="classlibMesh_1_1MeshRefinement.php#a0b34a1599da3a45c2d0eed3e19c38574">_new_nodes_map</a>.<a class="code" href="classlibMesh_1_1LocationMap.php#ad503d4fe9a00525f2d890d8175f448dd">clear</a>();
<a name="l00082"></a>00082 }
<a name="l00083"></a>00083 
<a name="l00084"></a>00084 
<a name="l00085"></a>00085 
<a name="l00086"></a><a class="code" href="classlibMesh_1_1MeshRefinement.php#a1dae39fb0b5070dc1f343f0c99ca2971">00086</a> <a class="code" href="classlibMesh_1_1Node.php">Node</a>* <a class="code" href="classlibMesh_1_1MeshRefinement.php#a1dae39fb0b5070dc1f343f0c99ca2971">MeshRefinement::add_point</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p,
<a name="l00087"></a>00087                                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">processor_id</a>,
<a name="l00088"></a>00088                                  <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> tol)
<a name="l00089"></a>00089 {
<a name="l00090"></a>00090   START_LOG(<span class="stringliteral">&quot;add_point()&quot;</span>, <span class="stringliteral">&quot;MeshRefinement&quot;</span>);
<a name="l00091"></a>00091 
<a name="l00092"></a>00092   <span class="comment">// Return the node if it already exists</span>
<a name="l00093"></a>00093   <a class="code" href="classlibMesh_1_1Node.php">Node</a> *node = <a class="code" href="classlibMesh_1_1MeshRefinement.php#a0b34a1599da3a45c2d0eed3e19c38574">_new_nodes_map</a>.<a class="code" href="classlibMesh_1_1LocationMap.php#aaf94e1934f882d48664d7496ea27cb7e">find</a>(p, tol);
<a name="l00094"></a>00094   <span class="keywordflow">if</span> (node)
<a name="l00095"></a>00095     {
<a name="l00096"></a>00096       STOP_LOG(<span class="stringliteral">&quot;add_point()&quot;</span>, <span class="stringliteral">&quot;MeshRefinement&quot;</span>);
<a name="l00097"></a>00097       <span class="keywordflow">return</span> node;
<a name="l00098"></a>00098     }
<a name="l00099"></a>00099       
<a name="l00100"></a>00100   <span class="comment">// Add the node, with a default id and the requested</span>
<a name="l00101"></a>00101   <span class="comment">// processor_id</span>
<a name="l00102"></a>00102   node = <a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#ab07787f7933b2fbe29bc2bef32401fdc">add_point</a> (p, <a class="code" href="classlibMesh_1_1DofObject.php#a1801e332bf034abe252086db668fee2d">DofObject::invalid_id</a>, processor_id);
<a name="l00103"></a>00103 
<a name="l00104"></a>00104   libmesh_assert (node != NULL);
<a name="l00105"></a>00105 
<a name="l00106"></a>00106   <span class="comment">// Add the node to the map.</span>
<a name="l00107"></a>00107   <a class="code" href="classlibMesh_1_1MeshRefinement.php#a0b34a1599da3a45c2d0eed3e19c38574">_new_nodes_map</a>.<a class="code" href="classlibMesh_1_1LocationMap.php#a89b7c1be90770909877d32b8c2481ba4">insert</a>(*node);
<a name="l00108"></a>00108 
<a name="l00109"></a>00109   <span class="comment">// Return the address of the new node</span>
<a name="l00110"></a>00110   STOP_LOG(<span class="stringliteral">&quot;add_point()&quot;</span>, <span class="stringliteral">&quot;MeshRefinement&quot;</span>);
<a name="l00111"></a>00111   <span class="keywordflow">return</span> node;
<a name="l00112"></a>00112 }
<a name="l00113"></a>00113 
<a name="l00114"></a>00114 
<a name="l00115"></a>00115 
<a name="l00116"></a><a class="code" href="classlibMesh_1_1MeshRefinement.php#a052c0307f8d231199f9a5d20b9d698ca">00116</a> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <a class="code" href="classlibMesh_1_1MeshRefinement.php#a052c0307f8d231199f9a5d20b9d698ca">MeshRefinement::add_elem</a> (<a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem)
<a name="l00117"></a>00117 {
<a name="l00118"></a>00118   libmesh_assert (elem != NULL);
<a name="l00119"></a>00119 
<a name="l00120"></a>00120   
<a name="l00121"></a>00121 <span class="comment">//   // If the unused_elements has any iterators from</span>
<a name="l00122"></a>00122 <span class="comment">//   // old elements, take the first one</span>
<a name="l00123"></a>00123 <span class="comment">//   if (!_unused_elements.empty())</span>
<a name="l00124"></a>00124 <span class="comment">//     {</span>
<a name="l00125"></a>00125 <span class="comment">//       std::vector&lt;Elem*&gt;::iterator it = _unused_elements.front();</span>
<a name="l00126"></a>00126 
<a name="l00127"></a>00127 <span class="comment">//       *it = elem;</span>
<a name="l00128"></a>00128 
<a name="l00129"></a>00129 <span class="comment">//       _unused_elements.pop_front();</span>
<a name="l00130"></a>00130 <span class="comment">//     }</span>
<a name="l00131"></a>00131 
<a name="l00132"></a>00132 <span class="comment">//   // Otherwise, use the conventional add method</span>
<a name="l00133"></a>00133 <span class="comment">//   else</span>
<a name="l00134"></a>00134 <span class="comment">//     {</span>
<a name="l00135"></a>00135 <span class="comment">//       _mesh.add_elem (elem);</span>
<a name="l00136"></a>00136 <span class="comment">//     }</span>
<a name="l00137"></a>00137 
<a name="l00138"></a>00138   <span class="comment">// The _unused_elements optimization has been turned off.</span>
<a name="l00139"></a>00139   <a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a5ab834283fa6bc335ad623d2b737ec5e">add_elem</a> (elem);
<a name="l00140"></a>00140   
<a name="l00141"></a>00141   <span class="keywordflow">return</span> elem;
<a name="l00142"></a>00142 }
<a name="l00143"></a>00143 
<a name="l00144"></a>00144 
<a name="l00145"></a>00145 
<a name="l00146"></a>00146 <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshRefinement.php#ac25b931ac102cee61e84fac044bdbf0a">MeshRefinement::create_parent_error_vector</a>
<a name="l00147"></a><a class="code" href="classlibMesh_1_1MeshRefinement.php#ac25b931ac102cee61e84fac044bdbf0a">00147</a>   (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ErrorVector.php">ErrorVector</a>&amp; error_per_cell,
<a name="l00148"></a>00148    <a class="code" href="classlibMesh_1_1ErrorVector.php">ErrorVector</a>&amp; error_per_parent,
<a name="l00149"></a>00149    <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>&amp; parent_error_min,
<a name="l00150"></a>00150    <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>&amp; parent_error_max)
<a name="l00151"></a>00151 {
<a name="l00152"></a>00152   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00153"></a>00153   parallel_only();
<a name="l00154"></a>00154 
<a name="l00155"></a>00155   <span class="comment">// Make sure the input error vector is valid</span>
<a name="l00156"></a>00156 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00157"></a>00157 <span class="preprocessor"></span>  <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != error_per_cell.size(); ++i)
<a name="l00158"></a>00158     {
<a name="l00159"></a>00159       libmesh_assert(error_per_cell[i] &gt;= 0);
<a name="l00160"></a>00160   <span class="comment">// isnan() isn&#39;t standard C++ yet</span>
<a name="l00161"></a>00161 <span class="preprocessor">  #ifdef isnan</span>
<a name="l00162"></a>00162 <span class="preprocessor"></span>      libmesh_assert(!isnan(error_per_cell[i]));
<a name="l00163"></a>00163 <span class="preprocessor">  #endif</span>
<a name="l00164"></a>00164 <span class="preprocessor"></span>    }
<a name="l00165"></a>00165 <span class="preprocessor">#endif // #ifdef DEBUG</span>
<a name="l00166"></a>00166 <span class="preprocessor"></span>
<a name="l00167"></a>00167   <span class="comment">// error values on uncoarsenable elements will be left at -1</span>
<a name="l00168"></a>00168   error_per_parent.clear();
<a name="l00169"></a>00169   error_per_parent.resize(error_per_cell.size(), 0.0);
<a name="l00170"></a>00170 
<a name="l00171"></a>00171   {
<a name="l00172"></a>00172   <span class="comment">// Find which elements are uncoarsenable</span>
<a name="l00173"></a>00173   <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       elem_it  = _mesh.active_local_elements_begin();
<a name="l00174"></a>00174   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> elem_end = _mesh.active_local_elements_end();
<a name="l00175"></a>00175   <span class="keywordflow">for</span> (; elem_it != elem_end; ++elem_it)
<a name="l00176"></a>00176     {
<a name="l00177"></a>00177       <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem   = *elem_it;
<a name="l00178"></a>00178       <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* parent = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a7cdd994bb4245128f8617b62d7968e35">parent</a>();
<a name="l00179"></a>00179 
<a name="l00180"></a>00180       <span class="comment">// Active elements are uncoarsenable</span>
<a name="l00181"></a>00181       error_per_parent[elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()] = -1.0;
<a name="l00182"></a>00182 
<a name="l00183"></a>00183       <span class="comment">// Grandparents and up are uncoarsenable</span>
<a name="l00184"></a>00184       <span class="keywordflow">while</span> (parent)
<a name="l00185"></a>00185         {
<a name="l00186"></a>00186           parent = parent-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a7cdd994bb4245128f8617b62d7968e35">parent</a>();
<a name="l00187"></a>00187           <span class="keywordflow">if</span> (parent)
<a name="l00188"></a>00188             {
<a name="l00189"></a>00189               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> parentid  = parent-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>();
<a name="l00190"></a>00190               libmesh_assert (parentid &lt; error_per_parent.size());
<a name="l00191"></a>00191               error_per_parent[parentid] = -1.0;
<a name="l00192"></a>00192             }
<a name="l00193"></a>00193         }
<a name="l00194"></a>00194     }
<a name="l00195"></a>00195 
<a name="l00196"></a>00196   <span class="comment">// Sync between processors.</span>
<a name="l00197"></a>00197   <span class="comment">// Use a reference to std::vector to avoid confusing</span>
<a name="l00198"></a>00198   <span class="comment">// Parallel::min</span>
<a name="l00199"></a>00199   std::vector&lt;ErrorVectorReal&gt; &amp;epp = error_per_parent;
<a name="l00200"></a>00200   <a class="code" href="namespacelibMesh_1_1Parallel.php#ad612bc0ffd617ebe5f47ffeecd7aae96">Parallel::min</a>(epp);
<a name="l00201"></a>00201   }
<a name="l00202"></a>00202 
<a name="l00203"></a>00203   <span class="comment">// The parent&#39;s error is defined as the square root of the</span>
<a name="l00204"></a>00204   <span class="comment">// sum of the children&#39;s errors squared, so errors that are</span>
<a name="l00205"></a>00205   <span class="comment">// Hilbert norms remain Hilbert norms.</span>
<a name="l00206"></a>00206   <span class="comment">//</span>
<a name="l00207"></a>00207   <span class="comment">// Because the children may be on different processors, we</span>
<a name="l00208"></a>00208   <span class="comment">// calculate local contributions to the parents&#39; errors squared</span>
<a name="l00209"></a>00209   <span class="comment">// first, then sum across processors and take the square roots</span>
<a name="l00210"></a>00210   <span class="comment">// second.</span>
<a name="l00211"></a>00211   {
<a name="l00212"></a>00212   <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       elem_it  = _mesh.active_local_elements_begin();
<a name="l00213"></a>00213   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> elem_end = _mesh.active_local_elements_end();
<a name="l00214"></a>00214 
<a name="l00215"></a>00215   <span class="keywordflow">for</span> (; elem_it != elem_end; ++elem_it)
<a name="l00216"></a>00216     {
<a name="l00217"></a>00217       <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem   = *elem_it;
<a name="l00218"></a>00218       <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* parent = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a7cdd994bb4245128f8617b62d7968e35">parent</a>();
<a name="l00219"></a>00219 
<a name="l00220"></a>00220       <span class="comment">// Calculate each contribution to parent cells</span>
<a name="l00221"></a>00221       <span class="keywordflow">if</span> (parent)
<a name="l00222"></a>00222         {
<a name="l00223"></a>00223           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> parentid  = parent-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>();
<a name="l00224"></a>00224           libmesh_assert (parentid &lt; error_per_parent.size());
<a name="l00225"></a>00225 
<a name="l00226"></a>00226           <span class="comment">// If the parent has grandchildren we won&#39;t be able to</span>
<a name="l00227"></a>00227           <span class="comment">// coarsen it, so forget it.  Otherwise, add this child&#39;s</span>
<a name="l00228"></a>00228           <span class="comment">// contribution to the sum of the squared child errors</span>
<a name="l00229"></a>00229           <span class="keywordflow">if</span> (error_per_parent[parentid] != -1.0)
<a name="l00230"></a>00230             error_per_parent[parentid] += (error_per_cell[elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()] *
<a name="l00231"></a>00231                                            error_per_cell[elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()]);
<a name="l00232"></a>00232         }
<a name="l00233"></a>00233     }
<a name="l00234"></a>00234   }
<a name="l00235"></a>00235 
<a name="l00236"></a>00236   <span class="comment">// Sum the vector across all processors</span>
<a name="l00237"></a>00237   <a class="code" href="namespacelibMesh_1_1Parallel.php#a32ab26117222089e6540e66b05c06b1b">Parallel::sum</a>(<span class="keyword">static_cast&lt;</span>std::vector&lt;ErrorVectorReal&gt;&amp;<span class="keyword">&gt;</span>(error_per_parent));
<a name="l00238"></a>00238 
<a name="l00239"></a>00239   <span class="comment">// Calculate the min and max as we loop</span>
<a name="l00240"></a>00240   parent_error_min = <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::numeric_limits&lt;double&gt;::max</a>();
<a name="l00241"></a>00241   parent_error_max = 0.;
<a name="l00242"></a>00242 
<a name="l00243"></a>00243   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i != error_per_parent.size(); ++i)
<a name="l00244"></a>00244     {
<a name="l00245"></a>00245       <span class="comment">// If this element isn&#39;t a coarsenable parent with error, we</span>
<a name="l00246"></a>00246       <span class="comment">// have nothing to do.  Just flag it as -1 and move on</span>
<a name="l00247"></a>00247       <span class="comment">// Note that Parallel::sum might have left uncoarsenable</span>
<a name="l00248"></a>00248       <span class="comment">// elements with error_per_parent=-n_proc, so reset it to</span>
<a name="l00249"></a>00249       <span class="comment">// error_per_parent=-1</span>
<a name="l00250"></a>00250       <span class="keywordflow">if</span> (error_per_parent[i] &lt; 0.)
<a name="l00251"></a>00251         {
<a name="l00252"></a>00252           error_per_parent[i] = -1.;
<a name="l00253"></a>00253           <span class="keywordflow">continue</span>;
<a name="l00254"></a>00254         }
<a name="l00255"></a>00255 
<a name="l00256"></a>00256       <span class="comment">// The error estimator might have already given us an</span>
<a name="l00257"></a>00257       <span class="comment">// estimate on the coarsenable parent elements; if so then</span>
<a name="l00258"></a>00258       <span class="comment">// we want to retain that estimate</span>
<a name="l00259"></a>00259       <span class="keywordflow">if</span> (error_per_cell[i])
<a name="l00260"></a>00260         {
<a name="l00261"></a>00261           error_per_parent[i] = error_per_cell[i];
<a name="l00262"></a>00262           <span class="keywordflow">continue</span>;
<a name="l00263"></a>00263         }
<a name="l00264"></a>00264       <span class="comment">// if not, then e_parent = sqrt(sum(e_child^2))</span>
<a name="l00265"></a>00265       <span class="keywordflow">else</span>
<a name="l00266"></a>00266         error_per_parent[i] = std::sqrt(error_per_parent[i]);
<a name="l00267"></a>00267 
<a name="l00268"></a>00268       parent_error_min = <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a> (parent_error_min,
<a name="l00269"></a>00269                                    error_per_parent[i]);
<a name="l00270"></a>00270       parent_error_max = <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a> (parent_error_max,
<a name="l00271"></a>00271                                    error_per_parent[i]);
<a name="l00272"></a>00272     }
<a name="l00273"></a>00273 }
<a name="l00274"></a>00274 
<a name="l00275"></a>00275 
<a name="l00276"></a>00276 
<a name="l00277"></a><a class="code" href="classlibMesh_1_1MeshRefinement.php#a2fbd7b73883ab6ad3f587a7e6e756ab0">00277</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshRefinement.php#a2fbd7b73883ab6ad3f587a7e6e756ab0">MeshRefinement::update_nodes_map</a> ()
<a name="l00278"></a>00278 {
<a name="l00279"></a>00279   this-&gt;<a class="code" href="classlibMesh_1_1MeshRefinement.php#a0b34a1599da3a45c2d0eed3e19c38574">_new_nodes_map</a>.<a class="code" href="classlibMesh_1_1LocationMap.php#abadcd2f57010852e4d343171bf225cd6">init</a>(<a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>);
<a name="l00280"></a>00280 } 
<a name="l00281"></a>00281 
<a name="l00282"></a>00282 
<a name="l00283"></a>00283 
<a name="l00284"></a><a class="code" href="classlibMesh_1_1MeshRefinement.php#a4f90c35be7bbebea889c925b6f20713a">00284</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1MeshRefinement.php#a4f90c35be7bbebea889c925b6f20713a">MeshRefinement::test_level_one</a> (<span class="keywordtype">bool</span> libmesh_assert_pass)
<a name="l00285"></a>00285 {
<a name="l00286"></a>00286   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00287"></a>00287   parallel_only();
<a name="l00288"></a>00288 
<a name="l00289"></a>00289   <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       elem_it  = <a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a99742bad0b034a29ccae8c5a90c6f4aa">active_local_elements_begin</a>();
<a name="l00290"></a>00290   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> elem_end = <a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a2e27f54d33f7539c0c06b36adae36cda">active_local_elements_end</a>();
<a name="l00291"></a>00291 
<a name="l00292"></a>00292   <span class="keywordtype">bool</span> failure = <span class="keyword">false</span>;
<a name="l00293"></a>00293 
<a name="l00294"></a>00294   <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *failed_elem = NULL;
<a name="l00295"></a>00295   <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *failed_neighbor = NULL;
<a name="l00296"></a>00296 
<a name="l00297"></a>00297   <span class="keywordflow">for</span> ( ; elem_it != elem_end &amp;&amp; !failure; ++elem_it)
<a name="l00298"></a>00298     {
<a name="l00299"></a>00299       <span class="comment">// Pointer to the element</span>
<a name="l00300"></a>00300       <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *elem = *elem_it;
<a name="l00301"></a>00301 
<a name="l00302"></a>00302       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adf36086a897fdef3a88deec071ca5dfd">n_neighbors</a>(); n++)
<a name="l00303"></a>00303         {
<a name="l00304"></a>00304           <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *neighbor = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(n);
<a name="l00305"></a>00305 
<a name="l00306"></a>00306           <span class="keywordflow">if</span> (!neighbor || !neighbor-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ab426ef9274eb93de879fef28b027d602">active</a>() ||
<a name="l00307"></a>00307               neighbor == <a class="code" href="namespacelibMesh.php#a903992f631b52b5ba05ad96a51e7b383">remote_elem</a>)
<a name="l00308"></a>00308             <span class="keywordflow">continue</span>;
<a name="l00309"></a>00309 
<a name="l00310"></a>00310           <span class="keywordflow">if</span> ((neighbor-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a1fa3e8bb1baa330a5037487dbe9304ab">level</a>() + 1 &lt; elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a1fa3e8bb1baa330a5037487dbe9304ab">level</a>()) ||
<a name="l00311"></a>00311               (neighbor-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>() + 1 &lt; elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>()) ||
<a name="l00312"></a>00312               (neighbor-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>() &gt; elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>() + 1))
<a name="l00313"></a>00313             {
<a name="l00314"></a>00314               failure = <span class="keyword">true</span>;
<a name="l00315"></a>00315               failed_elem = elem;
<a name="l00316"></a>00316               failed_neighbor = neighbor;
<a name="l00317"></a>00317               <span class="keywordflow">break</span>;
<a name="l00318"></a>00318             }
<a name="l00319"></a>00319         }
<a name="l00320"></a>00320     }
<a name="l00321"></a>00321 
<a name="l00322"></a>00322   <span class="comment">// If any processor failed, we failed globally</span>
<a name="l00323"></a>00323   <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">Parallel::max</a>(failure);
<a name="l00324"></a>00324 
<a name="l00325"></a>00325   <span class="keywordflow">if</span> (failure)
<a name="l00326"></a>00326     {
<a name="l00327"></a>00327       <span class="comment">// We didn&#39;t pass the level one test, so libmesh_assert that </span>
<a name="l00328"></a>00328       <span class="comment">// we&#39;re allowed not to</span>
<a name="l00329"></a>00329       libmesh_assert(!libmesh_assert_pass);
<a name="l00330"></a>00330       <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00331"></a>00331     }
<a name="l00332"></a>00332   <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00333"></a>00333 }
<a name="l00334"></a>00334 
<a name="l00335"></a>00335 
<a name="l00336"></a>00336 
<a name="l00337"></a><a class="code" href="classlibMesh_1_1MeshRefinement.php#a2a95dae49cbfe9cb0ab381f14ccc337c">00337</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1MeshRefinement.php#a2a95dae49cbfe9cb0ab381f14ccc337c">MeshRefinement::test_unflagged</a> (<span class="keywordtype">bool</span> libmesh_assert_pass)
<a name="l00338"></a>00338 {
<a name="l00339"></a>00339   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00340"></a>00340   parallel_only();
<a name="l00341"></a>00341 
<a name="l00342"></a>00342   <span class="keywordtype">bool</span> found_flag = <span class="keyword">false</span>;
<a name="l00343"></a>00343 
<a name="l00344"></a>00344   <span class="comment">// Search for local flags</span>
<a name="l00345"></a>00345   <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       elem_it  = <a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a99742bad0b034a29ccae8c5a90c6f4aa">active_local_elements_begin</a>();
<a name="l00346"></a>00346   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> elem_end = <a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a2e27f54d33f7539c0c06b36adae36cda">active_local_elements_end</a>();
<a name="l00347"></a>00347 
<a name="l00348"></a>00348   <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *failed_elem = NULL;
<a name="l00349"></a>00349 
<a name="l00350"></a>00350   <span class="keywordflow">for</span> ( ; elem_it != elem_end; ++elem_it)
<a name="l00351"></a>00351     {
<a name="l00352"></a>00352       <span class="comment">// Pointer to the element</span>
<a name="l00353"></a>00353       <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *elem = *elem_it;
<a name="l00354"></a>00354 
<a name="l00355"></a>00355       <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a174bfe5b3d22e2b79000bfc816f633e6">refinement_flag</a>() == <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a1511a7045e9a76eaa3b5b0f9511dd01b">Elem::REFINE</a> ||
<a name="l00356"></a>00356           elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a174bfe5b3d22e2b79000bfc816f633e6">refinement_flag</a>() == <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a7d9c31942b061618643ecf815f74dd2c">Elem::COARSEN</a> ||
<a name="l00357"></a>00357           elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a53a98cf29aef9af6292c812d7b905c18">p_refinement_flag</a>() == <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a1511a7045e9a76eaa3b5b0f9511dd01b">Elem::REFINE</a> ||
<a name="l00358"></a>00358           elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a53a98cf29aef9af6292c812d7b905c18">p_refinement_flag</a>() == <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a7d9c31942b061618643ecf815f74dd2c">Elem::COARSEN</a>)
<a name="l00359"></a>00359         {
<a name="l00360"></a>00360           found_flag = <span class="keyword">true</span>;
<a name="l00361"></a>00361           failed_elem = elem;
<a name="l00362"></a>00362           <span class="keywordflow">break</span>;
<a name="l00363"></a>00363         }
<a name="l00364"></a>00364     }
<a name="l00365"></a>00365 
<a name="l00366"></a>00366   <span class="comment">// If we found a flag on any processor, it counts</span>
<a name="l00367"></a>00367   <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">Parallel::max</a>(found_flag);
<a name="l00368"></a>00368 
<a name="l00369"></a>00369   <span class="keywordflow">if</span> (found_flag)
<a name="l00370"></a>00370     {
<a name="l00371"></a>00371       <span class="comment">// We didn&#39;t pass the &quot;elements are unflagged&quot; test,</span>
<a name="l00372"></a>00372       <span class="comment">// so libmesh_assert that we&#39;re allowed not to</span>
<a name="l00373"></a>00373       libmesh_assert(!libmesh_assert_pass);
<a name="l00374"></a>00374       <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00375"></a>00375     }
<a name="l00376"></a>00376   <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00377"></a>00377 }
<a name="l00378"></a>00378 
<a name="l00379"></a>00379 
<a name="l00380"></a>00380 
<a name="l00381"></a><a class="code" href="classlibMesh_1_1MeshRefinement.php#a0fbfad1ea615122c73e2202c7dc1cc9e">00381</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1MeshRefinement.php#a0fbfad1ea615122c73e2202c7dc1cc9e">MeshRefinement::refine_and_coarsen_elements</a> (<span class="keyword">const</span> <span class="keywordtype">bool</span> maintain_level_one)
<a name="l00382"></a>00382 {
<a name="l00383"></a>00383   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00384"></a>00384   parallel_only();
<a name="l00385"></a>00385 
<a name="l00386"></a>00386   <span class="keywordtype">bool</span> _maintain_level_one = maintain_level_one;
<a name="l00387"></a>00387 
<a name="l00388"></a>00388   <span class="comment">// If the user used non-default parameters, let&#39;s warn that they&#39;re</span>
<a name="l00389"></a>00389   <span class="comment">// deprecated</span>
<a name="l00390"></a>00390   <span class="keywordflow">if</span> (!maintain_level_one)
<a name="l00391"></a>00391     {
<a name="l00392"></a>00392       libmesh_deprecated();
<a name="l00393"></a>00393     }
<a name="l00394"></a>00394   <span class="keywordflow">else</span>
<a name="l00395"></a>00395     _maintain_level_one = <a class="code" href="classlibMesh_1_1MeshRefinement.php#a56f1015a59736175b39e4a1ca4d084bc">_face_level_mismatch_limit</a>;
<a name="l00396"></a>00396 
<a name="l00397"></a>00397   <span class="comment">// We can&#39;t yet turn a non-level-one mesh into a level-one mesh</span>
<a name="l00398"></a>00398   <span class="keywordflow">if</span> (_maintain_level_one)
<a name="l00399"></a>00399     libmesh_assert(<a class="code" href="classlibMesh_1_1MeshRefinement.php#a4f90c35be7bbebea889c925b6f20713a">test_level_one</a>(<span class="keyword">true</span>));
<a name="l00400"></a>00400 
<a name="l00401"></a>00401   <span class="comment">// Possibly clean up the refinement flags from</span>
<a name="l00402"></a>00402   <span class="comment">// a previous step</span>
<a name="l00403"></a>00403   <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       elem_it  = <a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#ac266e1f5eb6ac9566ccbd7e6add6c239">elements_begin</a>();
<a name="l00404"></a>00404   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> elem_end = <a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#ae94f1bce0dc50c489c6bae9ba64d06e8">elements_end</a>();
<a name="l00405"></a>00405 
<a name="l00406"></a>00406   <span class="keywordflow">for</span> ( ; elem_it != elem_end; ++elem_it)
<a name="l00407"></a>00407     {
<a name="l00408"></a>00408       <span class="comment">// Pointer to the element</span>
<a name="l00409"></a>00409       <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *elem = *elem_it;
<a name="l00410"></a>00410 
<a name="l00411"></a>00411       <span class="comment">// Set refinement flag to INACTIVE if the</span>
<a name="l00412"></a>00412       <span class="comment">// element isn&#39;t active</span>
<a name="l00413"></a>00413       <span class="keywordflow">if</span> ( !elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ab426ef9274eb93de879fef28b027d602">active</a>())
<a name="l00414"></a>00414         {
<a name="l00415"></a>00415           elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adb60ffafaf6ebf931978c9335d278b46">set_refinement_flag</a>(<a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54af7c2ef5bee86b20e0a4e1cebd140caef">Elem::INACTIVE</a>);
<a name="l00416"></a>00416           elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a13716b8bb2b92fa2244f6f4f375a0004">set_p_refinement_flag</a>(<a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54af7c2ef5bee86b20e0a4e1cebd140caef">Elem::INACTIVE</a>);
<a name="l00417"></a>00417         }
<a name="l00418"></a>00418 
<a name="l00419"></a>00419       <span class="comment">// This might be left over from the last step</span>
<a name="l00420"></a>00420       <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a174bfe5b3d22e2b79000bfc816f633e6">refinement_flag</a>() == <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a6fb8f2a3f8b6cc1a569263dbc1f1c5cf">Elem::JUST_REFINED</a>)
<a name="l00421"></a>00421         elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adb60ffafaf6ebf931978c9335d278b46">set_refinement_flag</a>(<a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a5a64eb29d0df43150a3b87184fb56be4">Elem::DO_NOTHING</a>);
<a name="l00422"></a>00422     }
<a name="l00423"></a>00423 
<a name="l00424"></a>00424   <span class="comment">// Parallel consistency has to come first, or coarsening</span>
<a name="l00425"></a>00425   <span class="comment">// along processor boundaries might occasionally be falsely</span>
<a name="l00426"></a>00426   <span class="comment">// prevented</span>
<a name="l00427"></a>00427   <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a3c7d22fed3feea4c9ebd1fb41e7dbb4f">is_serial</a>())
<a name="l00428"></a>00428     this-&gt;<a class="code" href="classlibMesh_1_1MeshRefinement.php#a0e925a80a9435e0d2d2a5f6113050043">make_flags_parallel_consistent</a>();
<a name="l00429"></a>00429 
<a name="l00430"></a>00430   <span class="comment">// Repeat until flag changes match on every processor</span>
<a name="l00431"></a>00431   <span class="keywordflow">do</span>
<a name="l00432"></a>00432     {
<a name="l00433"></a>00433       <span class="comment">// Repeat until coarsening &amp; refinement flags jive</span>
<a name="l00434"></a>00434       <span class="keywordtype">bool</span> satisfied = <span class="keyword">false</span>;
<a name="l00435"></a>00435       <span class="keywordflow">do</span>
<a name="l00436"></a>00436         {
<a name="l00437"></a>00437           <span class="keyword">const</span> <span class="keywordtype">bool</span> coarsening_satisfied =
<a name="l00438"></a>00438             this-&gt;<a class="code" href="classlibMesh_1_1MeshRefinement.php#a2c2b086d711b1598b82105044e73a570">make_coarsening_compatible</a>(maintain_level_one);
<a name="l00439"></a>00439 
<a name="l00440"></a>00440           <span class="keyword">const</span> <span class="keywordtype">bool</span> refinement_satisfied =
<a name="l00441"></a>00441             this-&gt;<a class="code" href="classlibMesh_1_1MeshRefinement.php#a98aad95c8d6f16674c878c8ef01dba6e">make_refinement_compatible</a>(maintain_level_one);
<a name="l00442"></a>00442 
<a name="l00443"></a>00443           <span class="keywordtype">bool</span> smoothing_satisfied = 
<a name="l00444"></a>00444             !this-&gt;<a class="code" href="classlibMesh_1_1MeshRefinement.php#a2f57c999ade430e94e7cf25bfc97eb07">eliminate_unrefined_patches</a>();
<a name="l00445"></a>00445 
<a name="l00446"></a>00446           <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1MeshRefinement.php#ae705082e7bc067be443b6792c1be54d6">_edge_level_mismatch_limit</a>)
<a name="l00447"></a>00447             smoothing_satisfied = smoothing_satisfied &amp;&amp; 
<a name="l00448"></a>00448               !this-&gt;<a class="code" href="classlibMesh_1_1MeshRefinement.php#a6726f2900feee33e74f571aa31a9d545">limit_level_mismatch_at_edge</a> (<a class="code" href="classlibMesh_1_1MeshRefinement.php#ae705082e7bc067be443b6792c1be54d6">_edge_level_mismatch_limit</a>);
<a name="l00449"></a>00449 
<a name="l00450"></a>00450           <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1MeshRefinement.php#ae794162fe8b50db70bb236ef9cbe68ab">_node_level_mismatch_limit</a>)
<a name="l00451"></a>00451             smoothing_satisfied = smoothing_satisfied &amp;&amp;
<a name="l00452"></a>00452               !this-&gt;<a class="code" href="classlibMesh_1_1MeshRefinement.php#acbc5744304854c3ce239abced653624e">limit_level_mismatch_at_node</a> (<a class="code" href="classlibMesh_1_1MeshRefinement.php#ae794162fe8b50db70bb236ef9cbe68ab">_node_level_mismatch_limit</a>);
<a name="l00453"></a>00453 
<a name="l00454"></a>00454           satisfied = (coarsening_satisfied &amp;&amp;
<a name="l00455"></a>00455                        refinement_satisfied &amp;&amp;
<a name="l00456"></a>00456                        smoothing_satisfied);
<a name="l00457"></a>00457 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00458"></a>00458 <span class="preprocessor"></span>          <span class="keywordtype">bool</span> max_satisfied = satisfied,
<a name="l00459"></a>00459                min_satisfied = satisfied;
<a name="l00460"></a>00460           <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">Parallel::max</a>(max_satisfied);
<a name="l00461"></a>00461           <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">Parallel::min</a>(min_satisfied);
<a name="l00462"></a>00462           libmesh_assert (satisfied == max_satisfied);
<a name="l00463"></a>00463           libmesh_assert (satisfied == min_satisfied);
<a name="l00464"></a>00464 <span class="preprocessor">#endif</span>
<a name="l00465"></a>00465 <span class="preprocessor"></span>        }
<a name="l00466"></a>00466       <span class="keywordflow">while</span> (!satisfied);
<a name="l00467"></a>00467     }
<a name="l00468"></a>00468   <span class="keywordflow">while</span> (!<a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a3c7d22fed3feea4c9ebd1fb41e7dbb4f">is_serial</a>() &amp;&amp; !this-&gt;<a class="code" href="classlibMesh_1_1MeshRefinement.php#a0e925a80a9435e0d2d2a5f6113050043">make_flags_parallel_consistent</a>());
<a name="l00469"></a>00469 
<a name="l00470"></a>00470   <span class="comment">// First coarsen the flagged elements.</span>
<a name="l00471"></a>00471   <span class="keyword">const</span> <span class="keywordtype">bool</span> coarsening_changed_mesh =
<a name="l00472"></a>00472     this-&gt;<a class="code" href="classlibMesh_1_1MeshRefinement.php#a46ef7ebd80c846f24998ef0f222c55e1">_coarsen_elements</a> ();
<a name="l00473"></a>00473 
<a name="l00474"></a>00474   <span class="keywordflow">if</span> (_maintain_level_one)
<a name="l00475"></a>00475     libmesh_assert(<a class="code" href="classlibMesh_1_1MeshRefinement.php#a4f90c35be7bbebea889c925b6f20713a">test_level_one</a>(<span class="keyword">true</span>));
<a name="l00476"></a>00476   libmesh_assert(this-&gt;<a class="code" href="classlibMesh_1_1MeshRefinement.php#a2c2b086d711b1598b82105044e73a570">make_coarsening_compatible</a>(maintain_level_one));
<a name="l00477"></a>00477   libmesh_assert(this-&gt;<a class="code" href="classlibMesh_1_1MeshRefinement.php#a98aad95c8d6f16674c878c8ef01dba6e">make_refinement_compatible</a>(maintain_level_one));
<a name="l00478"></a>00478 <span class="comment">// FIXME: This won&#39;t pass unless we add a redundant find_neighbors()</span>
<a name="l00479"></a>00479 <span class="comment">// call or replace find_neighbors() with on-the-fly neighbor updating</span>
<a name="l00480"></a>00480 <span class="comment">// libmesh_assert(!this-&gt;eliminate_unrefined_patches());</span>
<a name="l00481"></a>00481 
<a name="l00482"></a>00482   <span class="comment">// We can&#39;t contract the mesh ourselves anymore - a System might</span>
<a name="l00483"></a>00483   <span class="comment">// need to restrict old coefficient vectors first</span>
<a name="l00484"></a>00484   <span class="comment">// _mesh.contract();</span>
<a name="l00485"></a>00485 
<a name="l00486"></a>00486   <span class="comment">// Now refine the flagged elements.  This will</span>
<a name="l00487"></a>00487   <span class="comment">// take up some space, maybe more than what was freed.</span>
<a name="l00488"></a>00488   <span class="keyword">const</span> <span class="keywordtype">bool</span> refining_changed_mesh =
<a name="l00489"></a>00489     this-&gt;<a class="code" href="classlibMesh_1_1MeshRefinement.php#ad794507aa1e1908fea6fb373dd31c548">_refine_elements</a>();
<a name="l00490"></a>00490 
<a name="l00491"></a>00491   <span class="keywordflow">if</span> (_maintain_level_one)
<a name="l00492"></a>00492     libmesh_assert(<a class="code" href="classlibMesh_1_1MeshRefinement.php#a4f90c35be7bbebea889c925b6f20713a">test_level_one</a>(<span class="keyword">true</span>));
<a name="l00493"></a>00493   libmesh_assert(<a class="code" href="classlibMesh_1_1MeshRefinement.php#a2a95dae49cbfe9cb0ab381f14ccc337c">test_unflagged</a>(<span class="keyword">true</span>));
<a name="l00494"></a>00494   libmesh_assert(this-&gt;<a class="code" href="classlibMesh_1_1MeshRefinement.php#a2c2b086d711b1598b82105044e73a570">make_coarsening_compatible</a>(maintain_level_one));
<a name="l00495"></a>00495   libmesh_assert(this-&gt;<a class="code" href="classlibMesh_1_1MeshRefinement.php#a98aad95c8d6f16674c878c8ef01dba6e">make_refinement_compatible</a>(maintain_level_one));
<a name="l00496"></a>00496 <span class="comment">// FIXME: This won&#39;t pass unless we add a redundant find_neighbors()</span>
<a name="l00497"></a>00497 <span class="comment">// call or replace find_neighbors() with on-the-fly neighbor updating</span>
<a name="l00498"></a>00498 <span class="comment">// libmesh_assert(!this-&gt;eliminate_unrefined_patches());</span>
<a name="l00499"></a>00499 
<a name="l00500"></a>00500   <span class="comment">// Finally, the new mesh needs to be prepared for use</span>
<a name="l00501"></a>00501   <span class="keywordflow">if</span> (coarsening_changed_mesh || refining_changed_mesh)
<a name="l00502"></a>00502     {
<a name="l00503"></a>00503 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00504"></a>00504 <span class="preprocessor"></span>      <a class="code" href="classlibMesh_1_1ParallelMesh.php">ParallelMesh</a> *pmesh = <span class="keyword">dynamic_cast&lt;</span><a class="code" href="classlibMesh_1_1ParallelMesh.php">ParallelMesh</a> *<span class="keyword">&gt;</span>(&amp;<a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>);
<a name="l00505"></a>00505       <span class="keywordflow">if</span> (pmesh)
<a name="l00506"></a>00506         pmesh-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#a71de7cc0384ce24b982c49b2276478b3">libmesh_assert_valid_parallel_ids</a>();
<a name="l00507"></a>00507 <span class="preprocessor">#endif</span>
<a name="l00508"></a>00508 <span class="preprocessor"></span>      <a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a9805f1c4efa5d61188c582e58ed66a79">prepare_for_use</a> (<span class="comment">/*skip_renumber =*/</span><span class="keyword">false</span>);
<a name="l00509"></a>00509       
<a name="l00510"></a>00510       <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00511"></a>00511     }
<a name="l00512"></a>00512 
<a name="l00513"></a>00513   <span class="comment">// Otherwise there was no change in the mesh,</span>
<a name="l00514"></a>00514   <span class="comment">// let the user know.  Also, there is no need</span>
<a name="l00515"></a>00515   <span class="comment">// to prepare the mesh for use since it did not change.</span>
<a name="l00516"></a>00516   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00517"></a>00517     
<a name="l00518"></a>00518 }
<a name="l00519"></a>00519 
<a name="l00520"></a>00520 
<a name="l00521"></a>00521 
<a name="l00522"></a>00522 
<a name="l00523"></a>00523 
<a name="l00524"></a>00524 
<a name="l00525"></a>00525 
<a name="l00526"></a><a class="code" href="classlibMesh_1_1MeshRefinement.php#aca713a738c5308507a7fe9ed02147100">00526</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1MeshRefinement.php#aca713a738c5308507a7fe9ed02147100">MeshRefinement::coarsen_elements</a> (<span class="keyword">const</span> <span class="keywordtype">bool</span> maintain_level_one)
<a name="l00527"></a>00527 {
<a name="l00528"></a>00528   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00529"></a>00529   parallel_only();
<a name="l00530"></a>00530 
<a name="l00531"></a>00531   <span class="keywordtype">bool</span> _maintain_level_one = maintain_level_one;
<a name="l00532"></a>00532 
<a name="l00533"></a>00533   <span class="comment">// If the user used non-default parameters, let&#39;s warn that they&#39;re</span>
<a name="l00534"></a>00534   <span class="comment">// deprecated</span>
<a name="l00535"></a>00535   <span class="keywordflow">if</span> (!maintain_level_one)
<a name="l00536"></a>00536     {
<a name="l00537"></a>00537       libmesh_deprecated();
<a name="l00538"></a>00538     }
<a name="l00539"></a>00539   <span class="keywordflow">else</span>
<a name="l00540"></a>00540     _maintain_level_one = <a class="code" href="classlibMesh_1_1MeshRefinement.php#a56f1015a59736175b39e4a1ca4d084bc">_face_level_mismatch_limit</a>;
<a name="l00541"></a>00541 
<a name="l00542"></a>00542   <span class="comment">// We can&#39;t yet turn a non-level-one mesh into a level-one mesh</span>
<a name="l00543"></a>00543   <span class="keywordflow">if</span> (_maintain_level_one)
<a name="l00544"></a>00544     libmesh_assert(<a class="code" href="classlibMesh_1_1MeshRefinement.php#a4f90c35be7bbebea889c925b6f20713a">test_level_one</a>(<span class="keyword">true</span>));
<a name="l00545"></a>00545 
<a name="l00546"></a>00546   <span class="comment">// Possibly clean up the refinement flags from</span>
<a name="l00547"></a>00547   <span class="comment">// a previous step</span>
<a name="l00548"></a>00548   <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       elem_it  = <a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#ac266e1f5eb6ac9566ccbd7e6add6c239">elements_begin</a>();
<a name="l00549"></a>00549   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> elem_end = <a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#ae94f1bce0dc50c489c6bae9ba64d06e8">elements_end</a>();
<a name="l00550"></a>00550 
<a name="l00551"></a>00551   <span class="keywordflow">for</span> ( ; elem_it != elem_end; ++elem_it)
<a name="l00552"></a>00552     {
<a name="l00553"></a>00553       <span class="comment">// Pointer to the element</span>
<a name="l00554"></a>00554       <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = *elem_it;
<a name="l00555"></a>00555 
<a name="l00556"></a>00556       <span class="comment">// Set refinement flag to INACTIVE if the</span>
<a name="l00557"></a>00557       <span class="comment">// element isn&#39;t active</span>
<a name="l00558"></a>00558       <span class="keywordflow">if</span> ( !elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ab426ef9274eb93de879fef28b027d602">active</a>())
<a name="l00559"></a>00559         {
<a name="l00560"></a>00560           elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adb60ffafaf6ebf931978c9335d278b46">set_refinement_flag</a>(<a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54af7c2ef5bee86b20e0a4e1cebd140caef">Elem::INACTIVE</a>);
<a name="l00561"></a>00561           elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a13716b8bb2b92fa2244f6f4f375a0004">set_p_refinement_flag</a>(<a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54af7c2ef5bee86b20e0a4e1cebd140caef">Elem::INACTIVE</a>);
<a name="l00562"></a>00562         }
<a name="l00563"></a>00563 
<a name="l00564"></a>00564       <span class="comment">// This might be left over from the last step</span>
<a name="l00565"></a>00565       <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a174bfe5b3d22e2b79000bfc816f633e6">refinement_flag</a>() == <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a6fb8f2a3f8b6cc1a569263dbc1f1c5cf">Elem::JUST_REFINED</a>)
<a name="l00566"></a>00566         elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adb60ffafaf6ebf931978c9335d278b46">set_refinement_flag</a>(<a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a5a64eb29d0df43150a3b87184fb56be4">Elem::DO_NOTHING</a>);
<a name="l00567"></a>00567     }
<a name="l00568"></a>00568 
<a name="l00569"></a>00569   <span class="comment">// Parallel consistency has to come first, or coarsening</span>
<a name="l00570"></a>00570   <span class="comment">// along processor boundaries might occasionally be falsely</span>
<a name="l00571"></a>00571   <span class="comment">// prevented</span>
<a name="l00572"></a>00572   <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a3c7d22fed3feea4c9ebd1fb41e7dbb4f">is_serial</a>())
<a name="l00573"></a>00573     this-&gt;<a class="code" href="classlibMesh_1_1MeshRefinement.php#a0e925a80a9435e0d2d2a5f6113050043">make_flags_parallel_consistent</a>();
<a name="l00574"></a>00574 
<a name="l00575"></a>00575   <span class="comment">// Repeat until flag changes match on every processor</span>
<a name="l00576"></a>00576   <span class="keywordflow">do</span>
<a name="l00577"></a>00577     {
<a name="l00578"></a>00578       <span class="comment">// Repeat until the flags form a conforming mesh.</span>
<a name="l00579"></a>00579       <span class="keywordtype">bool</span> satisfied = <span class="keyword">false</span>;
<a name="l00580"></a>00580       <span class="keywordflow">do</span>
<a name="l00581"></a>00581         {
<a name="l00582"></a>00582           <span class="keyword">const</span> <span class="keywordtype">bool</span> coarsening_satisfied =
<a name="l00583"></a>00583             this-&gt;<a class="code" href="classlibMesh_1_1MeshRefinement.php#a2c2b086d711b1598b82105044e73a570">make_coarsening_compatible</a>(maintain_level_one);
<a name="l00584"></a>00584 
<a name="l00585"></a>00585           <span class="keywordtype">bool</span> smoothing_satisfied = 
<a name="l00586"></a>00586             !this-&gt;<a class="code" href="classlibMesh_1_1MeshRefinement.php#a2f57c999ade430e94e7cf25bfc97eb07">eliminate_unrefined_patches</a>();<span class="comment">// &amp;&amp;</span>
<a name="l00587"></a>00587 
<a name="l00588"></a>00588           <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1MeshRefinement.php#ae705082e7bc067be443b6792c1be54d6">_edge_level_mismatch_limit</a>)
<a name="l00589"></a>00589             smoothing_satisfied = smoothing_satisfied &amp;&amp;
<a name="l00590"></a>00590               !this-&gt;<a class="code" href="classlibMesh_1_1MeshRefinement.php#a6726f2900feee33e74f571aa31a9d545">limit_level_mismatch_at_edge</a> (<a class="code" href="classlibMesh_1_1MeshRefinement.php#ae705082e7bc067be443b6792c1be54d6">_edge_level_mismatch_limit</a>);
<a name="l00591"></a>00591 
<a name="l00592"></a>00592           <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1MeshRefinement.php#ae794162fe8b50db70bb236ef9cbe68ab">_node_level_mismatch_limit</a>)
<a name="l00593"></a>00593             smoothing_satisfied = smoothing_satisfied &amp;&amp;
<a name="l00594"></a>00594               !this-&gt;<a class="code" href="classlibMesh_1_1MeshRefinement.php#acbc5744304854c3ce239abced653624e">limit_level_mismatch_at_node</a> (<a class="code" href="classlibMesh_1_1MeshRefinement.php#ae794162fe8b50db70bb236ef9cbe68ab">_node_level_mismatch_limit</a>);
<a name="l00595"></a>00595 
<a name="l00596"></a>00596           satisfied = (coarsening_satisfied &amp;&amp;
<a name="l00597"></a>00597                        smoothing_satisfied);
<a name="l00598"></a>00598 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00599"></a>00599 <span class="preprocessor"></span>          <span class="keywordtype">bool</span> max_satisfied = satisfied,
<a name="l00600"></a>00600                min_satisfied = satisfied;
<a name="l00601"></a>00601           <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">Parallel::max</a>(max_satisfied);
<a name="l00602"></a>00602           <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">Parallel::min</a>(min_satisfied);
<a name="l00603"></a>00603           libmesh_assert (satisfied == max_satisfied);
<a name="l00604"></a>00604           libmesh_assert (satisfied == min_satisfied);
<a name="l00605"></a>00605 <span class="preprocessor">#endif</span>
<a name="l00606"></a>00606 <span class="preprocessor"></span>        }
<a name="l00607"></a>00607       <span class="keywordflow">while</span> (!satisfied);
<a name="l00608"></a>00608     }
<a name="l00609"></a>00609   <span class="keywordflow">while</span> (!<a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a3c7d22fed3feea4c9ebd1fb41e7dbb4f">is_serial</a>() &amp;&amp; !this-&gt;<a class="code" href="classlibMesh_1_1MeshRefinement.php#a0e925a80a9435e0d2d2a5f6113050043">make_flags_parallel_consistent</a>());
<a name="l00610"></a>00610 
<a name="l00611"></a>00611   <span class="comment">// Coarsen the flagged elements.</span>
<a name="l00612"></a>00612   <span class="keyword">const</span> <span class="keywordtype">bool</span> mesh_changed = 
<a name="l00613"></a>00613     this-&gt;<a class="code" href="classlibMesh_1_1MeshRefinement.php#a46ef7ebd80c846f24998ef0f222c55e1">_coarsen_elements</a> ();
<a name="l00614"></a>00614 
<a name="l00615"></a>00615   <span class="keywordflow">if</span> (_maintain_level_one)
<a name="l00616"></a>00616     libmesh_assert(<a class="code" href="classlibMesh_1_1MeshRefinement.php#a4f90c35be7bbebea889c925b6f20713a">test_level_one</a>(<span class="keyword">true</span>));
<a name="l00617"></a>00617   libmesh_assert(this-&gt;<a class="code" href="classlibMesh_1_1MeshRefinement.php#a2c2b086d711b1598b82105044e73a570">make_coarsening_compatible</a>(maintain_level_one));
<a name="l00618"></a>00618 <span class="comment">// FIXME: This won&#39;t pass unless we add a redundant find_neighbors()</span>
<a name="l00619"></a>00619 <span class="comment">// call or replace find_neighbors() with on-the-fly neighbor updating</span>
<a name="l00620"></a>00620 <span class="comment">// libmesh_assert(!this-&gt;eliminate_unrefined_patches());</span>
<a name="l00621"></a>00621     
<a name="l00622"></a>00622   <span class="comment">// We can&#39;t contract the mesh ourselves anymore - a System might</span>
<a name="l00623"></a>00623   <span class="comment">// need to restrict old coefficient vectors first</span>
<a name="l00624"></a>00624   <span class="comment">// _mesh.contract();</span>
<a name="l00625"></a>00625 
<a name="l00626"></a>00626   <span class="comment">// Finally, the new mesh may need to be prepared for use</span>
<a name="l00627"></a>00627   <span class="keywordflow">if</span> (mesh_changed)
<a name="l00628"></a>00628     <a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a9805f1c4efa5d61188c582e58ed66a79">prepare_for_use</a> (<span class="comment">/*skip_renumber =*/</span><span class="keyword">false</span>);
<a name="l00629"></a>00629 
<a name="l00630"></a>00630   <span class="keywordflow">return</span> mesh_changed;
<a name="l00631"></a>00631 }
<a name="l00632"></a>00632 
<a name="l00633"></a>00633 
<a name="l00634"></a>00634 
<a name="l00635"></a>00635 
<a name="l00636"></a>00636 
<a name="l00637"></a>00637 
<a name="l00638"></a>00638 
<a name="l00639"></a><a class="code" href="classlibMesh_1_1MeshRefinement.php#a68f01ed0485284d19a9c153572a35da9">00639</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1MeshRefinement.php#a68f01ed0485284d19a9c153572a35da9">MeshRefinement::refine_elements</a> (<span class="keyword">const</span> <span class="keywordtype">bool</span> maintain_level_one)
<a name="l00640"></a>00640 {
<a name="l00641"></a>00641   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00642"></a>00642   parallel_only();
<a name="l00643"></a>00643 
<a name="l00644"></a>00644   <span class="keywordtype">bool</span> _maintain_level_one = maintain_level_one;
<a name="l00645"></a>00645 
<a name="l00646"></a>00646   <span class="comment">// If the user used non-default parameters, let&#39;s warn that they&#39;re</span>
<a name="l00647"></a>00647   <span class="comment">// deprecated</span>
<a name="l00648"></a>00648   <span class="keywordflow">if</span> (!maintain_level_one)
<a name="l00649"></a>00649     {
<a name="l00650"></a>00650       libmesh_deprecated();
<a name="l00651"></a>00651     }
<a name="l00652"></a>00652   <span class="keywordflow">else</span>
<a name="l00653"></a>00653     _maintain_level_one = <a class="code" href="classlibMesh_1_1MeshRefinement.php#a56f1015a59736175b39e4a1ca4d084bc">_face_level_mismatch_limit</a>;
<a name="l00654"></a>00654 
<a name="l00655"></a>00655   <span class="keywordflow">if</span> (_maintain_level_one)
<a name="l00656"></a>00656     libmesh_assert(<a class="code" href="classlibMesh_1_1MeshRefinement.php#a4f90c35be7bbebea889c925b6f20713a">test_level_one</a>(<span class="keyword">true</span>));
<a name="l00657"></a>00657 
<a name="l00658"></a>00658   <span class="comment">// Possibly clean up the refinement flags from</span>
<a name="l00659"></a>00659   <span class="comment">// a previous step</span>
<a name="l00660"></a>00660   <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       elem_it  = <a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#ac266e1f5eb6ac9566ccbd7e6add6c239">elements_begin</a>();
<a name="l00661"></a>00661   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> elem_end = <a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#ae94f1bce0dc50c489c6bae9ba64d06e8">elements_end</a>();
<a name="l00662"></a>00662 
<a name="l00663"></a>00663   <span class="keywordflow">for</span> ( ; elem_it != elem_end; ++elem_it)
<a name="l00664"></a>00664     {
<a name="l00665"></a>00665       <span class="comment">// Pointer to the element</span>
<a name="l00666"></a>00666       <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *elem = *elem_it;
<a name="l00667"></a>00667 
<a name="l00668"></a>00668       <span class="comment">// Set refinement flag to INACTIVE if the</span>
<a name="l00669"></a>00669       <span class="comment">// element isn&#39;t active</span>
<a name="l00670"></a>00670       <span class="keywordflow">if</span> ( !elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ab426ef9274eb93de879fef28b027d602">active</a>())
<a name="l00671"></a>00671         {
<a name="l00672"></a>00672           elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adb60ffafaf6ebf931978c9335d278b46">set_refinement_flag</a>(<a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54af7c2ef5bee86b20e0a4e1cebd140caef">Elem::INACTIVE</a>);
<a name="l00673"></a>00673           elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a13716b8bb2b92fa2244f6f4f375a0004">set_p_refinement_flag</a>(<a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54af7c2ef5bee86b20e0a4e1cebd140caef">Elem::INACTIVE</a>);
<a name="l00674"></a>00674         }
<a name="l00675"></a>00675 
<a name="l00676"></a>00676       <span class="comment">// This might be left over from the last step</span>
<a name="l00677"></a>00677       <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a174bfe5b3d22e2b79000bfc816f633e6">refinement_flag</a>() == <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a6fb8f2a3f8b6cc1a569263dbc1f1c5cf">Elem::JUST_REFINED</a>)
<a name="l00678"></a>00678         elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adb60ffafaf6ebf931978c9335d278b46">set_refinement_flag</a>(<a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a5a64eb29d0df43150a3b87184fb56be4">Elem::DO_NOTHING</a>);
<a name="l00679"></a>00679     }
<a name="l00680"></a>00680 
<a name="l00681"></a>00681 
<a name="l00682"></a>00682   
<a name="l00683"></a>00683   <span class="comment">// Parallel consistency has to come first, or coarsening</span>
<a name="l00684"></a>00684   <span class="comment">// along processor boundaries might occasionally be falsely</span>
<a name="l00685"></a>00685   <span class="comment">// prevented</span>
<a name="l00686"></a>00686   <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a3c7d22fed3feea4c9ebd1fb41e7dbb4f">is_serial</a>())
<a name="l00687"></a>00687     this-&gt;<a class="code" href="classlibMesh_1_1MeshRefinement.php#a0e925a80a9435e0d2d2a5f6113050043">make_flags_parallel_consistent</a>();
<a name="l00688"></a>00688 
<a name="l00689"></a>00689   <span class="comment">// Repeat until flag changes match on every processor</span>
<a name="l00690"></a>00690   <span class="keywordflow">do</span>
<a name="l00691"></a>00691     {
<a name="l00692"></a>00692       <span class="comment">// Repeat until coarsening &amp; refinement flags jive</span>
<a name="l00693"></a>00693       <span class="keywordtype">bool</span> satisfied = <span class="keyword">false</span>;
<a name="l00694"></a>00694       <span class="keywordflow">do</span>
<a name="l00695"></a>00695         {
<a name="l00696"></a>00696           <span class="keyword">const</span> <span class="keywordtype">bool</span> refinement_satisfied =
<a name="l00697"></a>00697             this-&gt;<a class="code" href="classlibMesh_1_1MeshRefinement.php#a98aad95c8d6f16674c878c8ef01dba6e">make_refinement_compatible</a>(maintain_level_one);
<a name="l00698"></a>00698 
<a name="l00699"></a>00699           <span class="keywordtype">bool</span> smoothing_satisfied = 
<a name="l00700"></a>00700             !this-&gt;<a class="code" href="classlibMesh_1_1MeshRefinement.php#a2f57c999ade430e94e7cf25bfc97eb07">eliminate_unrefined_patches</a>();<span class="comment">// &amp;&amp;</span>
<a name="l00701"></a>00701 
<a name="l00702"></a>00702           <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1MeshRefinement.php#ae705082e7bc067be443b6792c1be54d6">_edge_level_mismatch_limit</a>)
<a name="l00703"></a>00703             smoothing_satisfied = smoothing_satisfied &amp;&amp;
<a name="l00704"></a>00704               !this-&gt;<a class="code" href="classlibMesh_1_1MeshRefinement.php#a6726f2900feee33e74f571aa31a9d545">limit_level_mismatch_at_edge</a> (<a class="code" href="classlibMesh_1_1MeshRefinement.php#ae705082e7bc067be443b6792c1be54d6">_edge_level_mismatch_limit</a>);
<a name="l00705"></a>00705 
<a name="l00706"></a>00706           <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1MeshRefinement.php#ae794162fe8b50db70bb236ef9cbe68ab">_node_level_mismatch_limit</a>)
<a name="l00707"></a>00707             smoothing_satisfied = smoothing_satisfied &amp;&amp;
<a name="l00708"></a>00708               !this-&gt;<a class="code" href="classlibMesh_1_1MeshRefinement.php#acbc5744304854c3ce239abced653624e">limit_level_mismatch_at_node</a> (<a class="code" href="classlibMesh_1_1MeshRefinement.php#ae794162fe8b50db70bb236ef9cbe68ab">_node_level_mismatch_limit</a>);
<a name="l00709"></a>00709 
<a name="l00710"></a>00710           satisfied = (refinement_satisfied &amp;&amp;
<a name="l00711"></a>00711                        smoothing_satisfied);
<a name="l00712"></a>00712 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00713"></a>00713 <span class="preprocessor"></span>          <span class="keywordtype">bool</span> max_satisfied = satisfied,
<a name="l00714"></a>00714                min_satisfied = satisfied;
<a name="l00715"></a>00715           <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">Parallel::max</a>(max_satisfied);
<a name="l00716"></a>00716           <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">Parallel::min</a>(min_satisfied);
<a name="l00717"></a>00717           libmesh_assert (satisfied == max_satisfied);
<a name="l00718"></a>00718           libmesh_assert (satisfied == min_satisfied);
<a name="l00719"></a>00719 <span class="preprocessor">#endif</span>
<a name="l00720"></a>00720 <span class="preprocessor"></span>        }
<a name="l00721"></a>00721       <span class="keywordflow">while</span> (!satisfied);
<a name="l00722"></a>00722     }
<a name="l00723"></a>00723   <span class="keywordflow">while</span> (!<a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a3c7d22fed3feea4c9ebd1fb41e7dbb4f">is_serial</a>() &amp;&amp; !this-&gt;<a class="code" href="classlibMesh_1_1MeshRefinement.php#a0e925a80a9435e0d2d2a5f6113050043">make_flags_parallel_consistent</a>());
<a name="l00724"></a>00724   
<a name="l00725"></a>00725   <span class="comment">// Now refine the flagged elements.  This will</span>
<a name="l00726"></a>00726   <span class="comment">// take up some space, maybe more than what was freed.</span>
<a name="l00727"></a>00727   <span class="keyword">const</span> <span class="keywordtype">bool</span> mesh_changed = 
<a name="l00728"></a>00728     this-&gt;<a class="code" href="classlibMesh_1_1MeshRefinement.php#ad794507aa1e1908fea6fb373dd31c548">_refine_elements</a>();
<a name="l00729"></a>00729 
<a name="l00730"></a>00730   <span class="keywordflow">if</span> (_maintain_level_one)
<a name="l00731"></a>00731     libmesh_assert(<a class="code" href="classlibMesh_1_1MeshRefinement.php#a4f90c35be7bbebea889c925b6f20713a">test_level_one</a>(<span class="keyword">true</span>));
<a name="l00732"></a>00732   libmesh_assert(this-&gt;<a class="code" href="classlibMesh_1_1MeshRefinement.php#a98aad95c8d6f16674c878c8ef01dba6e">make_refinement_compatible</a>(maintain_level_one));
<a name="l00733"></a>00733 <span class="comment">// FIXME: This won&#39;t pass unless we add a redundant find_neighbors()</span>
<a name="l00734"></a>00734 <span class="comment">// call or replace find_neighbors() with on-the-fly neighbor updating</span>
<a name="l00735"></a>00735 <span class="comment">// libmesh_assert(!this-&gt;eliminate_unrefined_patches());</span>
<a name="l00736"></a>00736     
<a name="l00737"></a>00737   <span class="comment">// Finally, the new mesh needs to be prepared for use</span>
<a name="l00738"></a>00738   <span class="keywordflow">if</span> (mesh_changed)
<a name="l00739"></a>00739     <a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a9805f1c4efa5d61188c582e58ed66a79">prepare_for_use</a> (<span class="comment">/*skip_renumber =*/</span><span class="keyword">false</span>);
<a name="l00740"></a>00740 
<a name="l00741"></a>00741   <span class="keywordflow">return</span> mesh_changed;
<a name="l00742"></a>00742 }
<a name="l00743"></a>00743 
<a name="l00744"></a>00744 
<a name="l00745"></a>00745 <span class="comment">// Functor for make_flags_parallel_consistent</span>
<a name="l00746"></a>00746 <span class="keyword">namespace </span>{
<a name="l00747"></a>00747 
<a name="l00748"></a>00748 <span class="keyword">struct </span>SyncRefinementFlags
<a name="l00749"></a>00749 {
<a name="l00750"></a>00750 <span class="keyword">typedef</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> datum;
<a name="l00751"></a>00751 <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54">Elem::RefinementState</a> (<a class="code" href="classlibMesh_1_1Elem.php">Elem</a>::*get_a_flag)() <span class="keyword">const</span>;
<a name="l00752"></a>00752 <span class="keyword">typedef</span> void (<a class="code" href="classlibMesh_1_1Elem.php">Elem</a>::*set_a_flag)(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54">Elem::RefinementState</a>);
<a name="l00753"></a>00753 
<a name="l00754"></a>00754 SyncRefinementFlags(<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp;_mesh,
<a name="l00755"></a>00755                     get_a_flag _getter,
<a name="l00756"></a>00756                     set_a_flag _setter) :
<a name="l00757"></a>00757   <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>(_mesh), <a class="code" href="mesh__refinement_8C.php#ac388b3791e312cc70dc936ca1521c37c">parallel_consistent</a>(true),
<a name="l00758"></a>00758   <a class="code" href="mesh__refinement_8C.php#abd1ef778b498d2e13afd024d7a33c268">get_flag</a>(_getter), <a class="code" href="mesh__refinement_8C.php#a7ff03a7f5d40832009eb5a359fcc32a2">set_flag</a>(_setter) {}
<a name="l00759"></a>00759 
<a name="l00760"></a><a class="code" href="mesh__refinement_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">00760</a> MeshBase &amp;<a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>;
<a name="l00761"></a><a class="code" href="mesh__refinement_8C.php#ac388b3791e312cc70dc936ca1521c37c">00761</a> <span class="keywordtype">bool</span> <a class="code" href="mesh__refinement_8C.php#ac388b3791e312cc70dc936ca1521c37c">parallel_consistent</a>;
<a name="l00762"></a><a class="code" href="mesh__refinement_8C.php#abd1ef778b498d2e13afd024d7a33c268">00762</a> get_a_flag <a class="code" href="mesh__refinement_8C.php#abd1ef778b498d2e13afd024d7a33c268">get_flag</a>;
<a name="l00763"></a><a class="code" href="mesh__refinement_8C.php#a7ff03a7f5d40832009eb5a359fcc32a2">00763</a> set_a_flag <a class="code" href="mesh__refinement_8C.php#a7ff03a7f5d40832009eb5a359fcc32a2">set_flag</a>;
<a name="l00764"></a>00764 <span class="comment">// References to pointers to member functions segfault?</span>
<a name="l00765"></a>00765 <span class="comment">// get_a_flag&amp; get_flag;</span>
<a name="l00766"></a>00766 <span class="comment">// set_a_flag&amp; set_flag;</span>
<a name="l00767"></a>00767 
<a name="l00768"></a>00768 <span class="comment">// Find the refinement flag on each requested element</span>
<a name="l00769"></a>00769 <span class="keywordtype">void</span> gather_data (<span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; ids,
<a name="l00770"></a>00770                   std::vector&lt;datum&gt;&amp; flags)
<a name="l00771"></a>00771 {
<a name="l00772"></a>00772   flags.resize(ids.size());
<a name="l00773"></a>00773 
<a name="l00774"></a>00774   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != ids.size(); ++i)
<a name="l00775"></a>00775     {
<a name="l00776"></a>00776       <span class="comment">// Look for this element in the mesh</span>
<a name="l00777"></a>00777       Elem *elem = <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>.elem(ids[i]);
<a name="l00778"></a>00778 
<a name="l00779"></a>00779       <span class="comment">// We&#39;d better find every element we&#39;re asked for</span>
<a name="l00780"></a>00780       libmesh_assert (elem);
<a name="l00781"></a>00781 
<a name="l00782"></a>00782       <span class="comment">// Return the element&#39;s refinement flag</span>
<a name="l00783"></a>00783       flags[i] = (elem-&gt;*<a class="code" href="mesh__refinement_8C.php#abd1ef778b498d2e13afd024d7a33c268">get_flag</a>)();
<a name="l00784"></a>00784     }
<a name="l00785"></a>00785 }
<a name="l00786"></a>00786 
<a name="l00787"></a>00787 <span class="keywordtype">void</span> act_on_data (<span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; ids,
<a name="l00788"></a>00788                   std::vector&lt;datum&gt;&amp; flags)
<a name="l00789"></a>00789 {
<a name="l00790"></a>00790   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != ids.size(); ++i)
<a name="l00791"></a>00791     {
<a name="l00792"></a>00792       Elem *elem = <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>.elem(ids[i]);
<a name="l00793"></a>00793 
<a name="l00794"></a>00794       libmesh_assert(elem);
<a name="l00795"></a>00795 
<a name="l00796"></a>00796       datum old_flag = (elem-&gt;*<a class="code" href="mesh__refinement_8C.php#abd1ef778b498d2e13afd024d7a33c268">get_flag</a>)();
<a name="l00797"></a>00797       datum &amp;new_flag = flags[i];
<a name="l00798"></a>00798 
<a name="l00799"></a>00799       <span class="keywordflow">if</span> (old_flag != new_flag)
<a name="l00800"></a>00800         {
<a name="l00801"></a>00801           <span class="comment">// It&#39;s possible for foreign flags to be (temporarily) more</span>
<a name="l00802"></a>00802           <span class="comment">// conservative than our own, such as when a refinement in</span>
<a name="l00803"></a>00803           <span class="comment">// one of the foreign processor&#39;s elements is mandated by a</span>
<a name="l00804"></a>00804           <span class="comment">// refinement in one of our neighboring elements it can see</span>
<a name="l00805"></a>00805           <span class="comment">// which was mandated by a refinement in one of our</span>
<a name="l00806"></a>00806           <span class="comment">// neighboring elements it can&#39;t see</span>
<a name="l00807"></a>00807           <span class="comment">// libmesh_assert (!(new_flag != Elem::REFINE &amp;&amp; </span>
<a name="l00808"></a>00808           <span class="comment">//                   old_flag == Elem::REFINE));</span>
<a name="l00809"></a>00809           <span class="comment">//</span>
<a name="l00810"></a>00810           (elem-&gt;*<a class="code" href="mesh__refinement_8C.php#a7ff03a7f5d40832009eb5a359fcc32a2">set_flag</a>)
<a name="l00811"></a>00811             (static_cast&lt;Elem::RefinementState&gt;(new_flag));
<a name="l00812"></a>00812           <a class="code" href="mesh__refinement_8C.php#ac388b3791e312cc70dc936ca1521c37c">parallel_consistent</a> = <span class="keyword">false</span>;
<a name="l00813"></a>00813         }
<a name="l00814"></a>00814     }
<a name="l00815"></a>00815 }
<a name="l00816"></a>00816 };
<a name="l00817"></a>00817 }
<a name="l00818"></a>00818 
<a name="l00819"></a>00819 
<a name="l00820"></a>00820 
<a name="l00821"></a><a class="code" href="classlibMesh_1_1MeshRefinement.php#a0e925a80a9435e0d2d2a5f6113050043">00821</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1MeshRefinement.php#a0e925a80a9435e0d2d2a5f6113050043">MeshRefinement::make_flags_parallel_consistent</a>()
<a name="l00822"></a>00822 {
<a name="l00823"></a>00823   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00824"></a>00824   parallel_only();
<a name="l00825"></a>00825 
<a name="l00826"></a>00826   START_LOG (<span class="stringliteral">&quot;make_flags_parallel_consistent()&quot;</span>, <span class="stringliteral">&quot;MeshRefinement&quot;</span>);
<a name="l00827"></a>00827 
<a name="l00828"></a>00828   SyncRefinementFlags hsync(<a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>, &amp;<a class="code" href="classlibMesh_1_1Elem.php#a174bfe5b3d22e2b79000bfc816f633e6">Elem::refinement_flag</a>,
<a name="l00829"></a>00829                             &amp;<a class="code" href="classlibMesh_1_1Elem.php#adb60ffafaf6ebf931978c9335d278b46">Elem::set_refinement_flag</a>);
<a name="l00830"></a>00830   <a class="code" href="namespacelibMesh_1_1Parallel.php#a8086357cefdf6ff1b849bd308af6cc6e">Parallel::sync_dofobject_data_by_id</a>
<a name="l00831"></a>00831     (<a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#ac266e1f5eb6ac9566ccbd7e6add6c239">elements_begin</a>(), <a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#ae94f1bce0dc50c489c6bae9ba64d06e8">elements_end</a>(), hsync);
<a name="l00832"></a>00832 
<a name="l00833"></a>00833   SyncRefinementFlags psync(<a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>, &amp;<a class="code" href="classlibMesh_1_1Elem.php#a53a98cf29aef9af6292c812d7b905c18">Elem::p_refinement_flag</a>,
<a name="l00834"></a>00834                             &amp;<a class="code" href="classlibMesh_1_1Elem.php#a13716b8bb2b92fa2244f6f4f375a0004">Elem::set_p_refinement_flag</a>);
<a name="l00835"></a>00835   <a class="code" href="namespacelibMesh_1_1Parallel.php#a8086357cefdf6ff1b849bd308af6cc6e">Parallel::sync_dofobject_data_by_id</a>
<a name="l00836"></a>00836     (<a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#ac266e1f5eb6ac9566ccbd7e6add6c239">elements_begin</a>(), <a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#ae94f1bce0dc50c489c6bae9ba64d06e8">elements_end</a>(), psync);
<a name="l00837"></a>00837 
<a name="l00838"></a>00838   <span class="comment">// If we weren&#39;t consistent in both h and p on every processor then</span>
<a name="l00839"></a>00839   <span class="comment">// we weren&#39;t globally consistent</span>
<a name="l00840"></a>00840   <span class="keywordtype">bool</span> <a class="code" href="mesh__refinement_8C.php#ac388b3791e312cc70dc936ca1521c37c">parallel_consistent</a> = hsync.parallel_consistent &amp;&amp;
<a name="l00841"></a>00841                              psync.parallel_consistent;
<a name="l00842"></a>00842   <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">Parallel::min</a>(parallel_consistent);
<a name="l00843"></a>00843 
<a name="l00844"></a>00844   STOP_LOG (<span class="stringliteral">&quot;make_flags_parallel_consistent()&quot;</span>, <span class="stringliteral">&quot;MeshRefinement&quot;</span>);
<a name="l00845"></a>00845 
<a name="l00846"></a>00846   <span class="keywordflow">return</span> <a class="code" href="mesh__refinement_8C.php#ac388b3791e312cc70dc936ca1521c37c">parallel_consistent</a>;
<a name="l00847"></a>00847 }
<a name="l00848"></a>00848 
<a name="l00849"></a>00849 
<a name="l00850"></a>00850 
<a name="l00851"></a><a class="code" href="classlibMesh_1_1MeshRefinement.php#a2c2b086d711b1598b82105044e73a570">00851</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1MeshRefinement.php#a2c2b086d711b1598b82105044e73a570">MeshRefinement::make_coarsening_compatible</a>(<span class="keyword">const</span> <span class="keywordtype">bool</span> maintain_level_one)
<a name="l00852"></a>00852 {
<a name="l00853"></a>00853   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00854"></a>00854   parallel_only();
<a name="l00855"></a>00855 
<a name="l00856"></a>00856   START_LOG (<span class="stringliteral">&quot;make_coarsening_compatible()&quot;</span>, <span class="stringliteral">&quot;MeshRefinement&quot;</span>);
<a name="l00857"></a>00857   
<a name="l00858"></a>00858   <span class="keywordtype">bool</span> _maintain_level_one = maintain_level_one;
<a name="l00859"></a>00859 
<a name="l00860"></a>00860   <span class="comment">// If the user used non-default parameters, let&#39;s warn that they&#39;re</span>
<a name="l00861"></a>00861   <span class="comment">// deprecated</span>
<a name="l00862"></a>00862   <span class="keywordflow">if</span> (!maintain_level_one)
<a name="l00863"></a>00863     {
<a name="l00864"></a>00864       libmesh_deprecated();
<a name="l00865"></a>00865     }
<a name="l00866"></a>00866   <span class="keywordflow">else</span>
<a name="l00867"></a>00867     _maintain_level_one = <a class="code" href="classlibMesh_1_1MeshRefinement.php#a56f1015a59736175b39e4a1ca4d084bc">_face_level_mismatch_limit</a>;
<a name="l00868"></a>00868 
<a name="l00869"></a>00869   
<a name="l00870"></a>00870   <span class="comment">// Unless we encounter a specific situation level-one</span>
<a name="l00871"></a>00871   <span class="comment">// will be satisfied after executing this loop just once   </span>
<a name="l00872"></a>00872   <span class="keywordtype">bool</span> level_one_satisfied = <span class="keyword">true</span>;
<a name="l00873"></a>00873 
<a name="l00874"></a>00874   
<a name="l00875"></a>00875   <span class="comment">// Unless we encounter a specific situation we will be compatible</span>
<a name="l00876"></a>00876   <span class="comment">// with any selected refinement flags</span>
<a name="l00877"></a>00877   <span class="keywordtype">bool</span> compatible_with_refinement = <span class="keyword">true</span>;
<a name="l00878"></a>00878 
<a name="l00879"></a>00879   
<a name="l00880"></a>00880   <span class="comment">// find the maximum h and p levels in the mesh   </span>
<a name="l00881"></a>00881   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespacelibMesh_1_1MeshTools.php#a57a0ae7fb3cba63f06621d6c701327c8">max_level</a> = 0;
<a name="l00882"></a>00882   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> max_p_level = 0;
<a name="l00883"></a>00883     
<a name="l00884"></a>00884   
<a name="l00885"></a>00885   <span class="comment">// First we look at all the active level-0 elements.  Since it doesn&#39;t make</span>
<a name="l00886"></a>00886   <span class="comment">// sense to coarsen them we must un-set their coarsen flags if</span>
<a name="l00887"></a>00887   <span class="comment">// they are set.   </span>
<a name="l00888"></a>00888   <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       el     = <a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#aefa4ded9eaf654a45ab593a0963ecbf3">active_elements_begin</a>();
<a name="l00889"></a>00889   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> end_el = <a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#ae3f09f1b7556aef88919249861728e23">active_elements_end</a>(); 
<a name="l00890"></a>00890 
<a name="l00891"></a>00891   <span class="keywordflow">for</span> (; el != end_el; ++el)
<a name="l00892"></a>00892     {      
<a name="l00893"></a>00893       <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *elem = *el;
<a name="l00894"></a>00894       max_level = <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(max_level, elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a1fa3e8bb1baa330a5037487dbe9304ab">level</a>());
<a name="l00895"></a>00895       max_p_level =
<a name="l00896"></a>00896         <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(max_p_level,
<a name="l00897"></a>00897                  static_cast&lt;unsigned int&gt;(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>()));
<a name="l00898"></a>00898       
<a name="l00899"></a>00899       <span class="keywordflow">if</span> ((elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a1fa3e8bb1baa330a5037487dbe9304ab">level</a>() == 0) &amp;&amp;
<a name="l00900"></a>00900           (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a174bfe5b3d22e2b79000bfc816f633e6">refinement_flag</a>() == <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a7d9c31942b061618643ecf815f74dd2c">Elem::COARSEN</a>))
<a name="l00901"></a>00901         elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adb60ffafaf6ebf931978c9335d278b46">set_refinement_flag</a>(<a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a5a64eb29d0df43150a3b87184fb56be4">Elem::DO_NOTHING</a>);
<a name="l00902"></a>00902 
<a name="l00903"></a>00903       <span class="keywordflow">if</span> ((elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>() == 0) &amp;&amp;
<a name="l00904"></a>00904           (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a53a98cf29aef9af6292c812d7b905c18">p_refinement_flag</a>() == <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a7d9c31942b061618643ecf815f74dd2c">Elem::COARSEN</a>))
<a name="l00905"></a>00905         elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a13716b8bb2b92fa2244f6f4f375a0004">set_p_refinement_flag</a>(<a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a5a64eb29d0df43150a3b87184fb56be4">Elem::DO_NOTHING</a>);
<a name="l00906"></a>00906     }
<a name="l00907"></a>00907   
<a name="l00908"></a>00908   <span class="comment">// if there are no refined elements on this processor then</span>
<a name="l00909"></a>00909   <span class="comment">// there is no work for us to do   </span>
<a name="l00910"></a>00910   <span class="keywordflow">if</span> (max_level == 0 &amp;&amp; max_p_level == 0)
<a name="l00911"></a>00911     {
<a name="l00912"></a>00912       STOP_LOG (<span class="stringliteral">&quot;make_coarsening_compatible()&quot;</span>, <span class="stringliteral">&quot;MeshRefinement&quot;</span>);
<a name="l00913"></a>00913 
<a name="l00914"></a>00914       <span class="comment">// But we still have to check with other processors</span>
<a name="l00915"></a>00915       <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">Parallel::min</a>(compatible_with_refinement);
<a name="l00916"></a>00916 
<a name="l00917"></a>00917       <span class="keywordflow">return</span> compatible_with_refinement;
<a name="l00918"></a>00918     }
<a name="l00919"></a>00919 
<a name="l00920"></a>00920   
<a name="l00921"></a>00921   
<a name="l00922"></a>00922   <span class="comment">// Loop over all the active elements.  If an element is marked</span>
<a name="l00923"></a>00923   <span class="comment">// for coarsening we better check its neighbors.  If ANY of these neighbors</span>
<a name="l00924"></a>00924   <span class="comment">// are marked for refinement AND are at the same level then there is a</span>
<a name="l00925"></a>00925   <span class="comment">// conflict.  By convention refinement wins, so we un-mark the element for</span>
<a name="l00926"></a>00926   <span class="comment">// coarsening.  Level-one would be violated in this case so we need to re-run</span>
<a name="l00927"></a>00927   <span class="comment">// the loop.   </span>
<a name="l00928"></a>00928   <span class="keywordflow">if</span> (_maintain_level_one)
<a name="l00929"></a>00929     {
<a name="l00930"></a>00930       
<a name="l00931"></a>00931     repeat:
<a name="l00932"></a>00932       level_one_satisfied = <span class="keyword">true</span>;
<a name="l00933"></a>00933   
<a name="l00934"></a>00934       <span class="keywordflow">do</span>
<a name="l00935"></a>00935         {
<a name="l00936"></a>00936           level_one_satisfied = <span class="keyword">true</span>;
<a name="l00937"></a>00937 
<a name="l00938"></a>00938           <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       el     = <a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#aefa4ded9eaf654a45ab593a0963ecbf3">active_elements_begin</a>();
<a name="l00939"></a>00939           <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> end_el = <a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#ae3f09f1b7556aef88919249861728e23">active_elements_end</a>(); 
<a name="l00940"></a>00940 
<a name="l00941"></a>00941           <span class="keywordflow">for</span> (; el != end_el; ++el)
<a name="l00942"></a>00942             {
<a name="l00943"></a>00943               <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = *el;
<a name="l00944"></a>00944               <span class="keywordtype">bool</span> my_flag_changed = <span class="keyword">false</span>;
<a name="l00945"></a>00945               
<a name="l00946"></a>00946               <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a174bfe5b3d22e2b79000bfc816f633e6">refinement_flag</a>() == <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a7d9c31942b061618643ecf815f74dd2c">Elem::COARSEN</a>) <span class="comment">// If the element is active and </span>
<a name="l00947"></a>00947                 <span class="comment">// the coarsen flag is set</span>
<a name="l00948"></a>00948                 {
<a name="l00949"></a>00949                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> my_level = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a1fa3e8bb1baa330a5037487dbe9304ab">level</a>();
<a name="l00950"></a>00950                   
<a name="l00951"></a>00951                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adf36086a897fdef3a88deec071ca5dfd">n_neighbors</a>(); n++)
<a name="l00952"></a>00952                     <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(n) != NULL &amp;&amp;      <span class="comment">// I have a</span>
<a name="l00953"></a>00953                         elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(n) != <a class="code" href="namespacelibMesh.php#a903992f631b52b5ba05ad96a51e7b383">remote_elem</a>) <span class="comment">// neighbor here</span>
<a name="l00954"></a>00954                       {
<a name="l00955"></a>00955                         <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(n)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ab426ef9274eb93de879fef28b027d602">active</a>()) <span class="comment">// and it is active</span>
<a name="l00956"></a>00956                           {
<a name="l00957"></a>00957                             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* neighbor = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(n);
<a name="l00958"></a>00958                           
<a name="l00959"></a>00959                             <span class="keywordflow">if</span> ((neighbor-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a1fa3e8bb1baa330a5037487dbe9304ab">level</a>() == my_level) &amp;&amp;
<a name="l00960"></a>00960                                 (neighbor-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a174bfe5b3d22e2b79000bfc816f633e6">refinement_flag</a>() == <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a1511a7045e9a76eaa3b5b0f9511dd01b">Elem::REFINE</a>)) <span class="comment">// the neighbor is at my level</span>
<a name="l00961"></a>00961                                                                                <span class="comment">// and wants to be refined</span>
<a name="l00962"></a>00962                               {
<a name="l00963"></a>00963                                 elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adb60ffafaf6ebf931978c9335d278b46">set_refinement_flag</a>(<a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a5a64eb29d0df43150a3b87184fb56be4">Elem::DO_NOTHING</a>);
<a name="l00964"></a>00964                                 my_flag_changed = <span class="keyword">true</span>;
<a name="l00965"></a>00965                                 <span class="keywordflow">break</span>;
<a name="l00966"></a>00966                               }
<a name="l00967"></a>00967                           }
<a name="l00968"></a>00968                         <span class="keywordflow">else</span> <span class="comment">// I have a neighbor and it is not active. That means it has children.</span>
<a name="l00969"></a>00969                           {  <span class="comment">// While it _may_ be possible to coarsen us if all the children of</span>
<a name="l00970"></a>00970                              <span class="comment">// that element want to be coarsened, it is impossible to know at this</span>
<a name="l00971"></a>00971                              <span class="comment">// stage.  Forget about it for the moment...  This can be handled in</span>
<a name="l00972"></a>00972                              <span class="comment">// two steps.</span>
<a name="l00973"></a>00973                             elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adb60ffafaf6ebf931978c9335d278b46">set_refinement_flag</a>(<a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a5a64eb29d0df43150a3b87184fb56be4">Elem::DO_NOTHING</a>);
<a name="l00974"></a>00974                             my_flag_changed = <span class="keyword">true</span>;
<a name="l00975"></a>00975                             <span class="keywordflow">break</span>;
<a name="l00976"></a>00976                           }
<a name="l00977"></a>00977                       }
<a name="l00978"></a>00978                 }
<a name="l00979"></a>00979               <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a53a98cf29aef9af6292c812d7b905c18">p_refinement_flag</a>() == <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a7d9c31942b061618643ecf815f74dd2c">Elem::COARSEN</a>) <span class="comment">// If</span>
<a name="l00980"></a>00980                 <span class="comment">// the element is active and the order reduction flag is set</span>
<a name="l00981"></a>00981                 {
<a name="l00982"></a>00982                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> my_p_level = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>();
<a name="l00983"></a>00983 
<a name="l00984"></a>00984                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adf36086a897fdef3a88deec071ca5dfd">n_neighbors</a>(); n++)
<a name="l00985"></a>00985                     <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(n) != NULL &amp;&amp;      <span class="comment">// I have a</span>
<a name="l00986"></a>00986                         elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(n) != <a class="code" href="namespacelibMesh.php#a903992f631b52b5ba05ad96a51e7b383">remote_elem</a>) <span class="comment">// neighbor here</span>
<a name="l00987"></a>00987                       {
<a name="l00988"></a>00988                         <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(n)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ab426ef9274eb93de879fef28b027d602">active</a>()) <span class="comment">// and it is active</span>
<a name="l00989"></a>00989                           {
<a name="l00990"></a>00990                             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* neighbor = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(n);
<a name="l00991"></a>00991 
<a name="l00992"></a>00992                             <span class="keywordflow">if</span> ((neighbor-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>() &gt; my_p_level &amp;&amp;
<a name="l00993"></a>00993                                  neighbor-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a53a98cf29aef9af6292c812d7b905c18">p_refinement_flag</a>() != <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a7d9c31942b061618643ecf815f74dd2c">Elem::COARSEN</a>)
<a name="l00994"></a>00994                                 || (neighbor-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>() == my_p_level &amp;&amp;
<a name="l00995"></a>00995                                  neighbor-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a53a98cf29aef9af6292c812d7b905c18">p_refinement_flag</a>() == <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a1511a7045e9a76eaa3b5b0f9511dd01b">Elem::REFINE</a>))
<a name="l00996"></a>00996                               {
<a name="l00997"></a>00997                                 elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a13716b8bb2b92fa2244f6f4f375a0004">set_p_refinement_flag</a>(<a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a5a64eb29d0df43150a3b87184fb56be4">Elem::DO_NOTHING</a>);
<a name="l00998"></a>00998                                 my_flag_changed = <span class="keyword">true</span>;
<a name="l00999"></a>00999                                 <span class="keywordflow">break</span>;
<a name="l01000"></a>01000                               }
<a name="l01001"></a>01001                           }
<a name="l01002"></a>01002                         <span class="keywordflow">else</span> <span class="comment">// I have a neighbor and it is not active.</span>
<a name="l01003"></a>01003                           {  <span class="comment">// We need to find which of its children</span>
<a name="l01004"></a>01004                              <span class="comment">// have me as a neighbor, and maintain</span>
<a name="l01005"></a>01005                              <span class="comment">// level one p compatibility with them.</span>
<a name="l01006"></a>01006                              <span class="comment">// Because we currently have level one h</span>
<a name="l01007"></a>01007                              <span class="comment">// compatibility, we don&#39;t need to check</span>
<a name="l01008"></a>01008                              <span class="comment">// grandchildren</span>
<a name="l01009"></a>01009                             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* neighbor = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(n);
<a name="l01010"></a>01010 
<a name="l01011"></a>01011                              libmesh_assert(neighbor-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac6316ca5f7b962a8a806ac385d6c0236">has_children</a>());
<a name="l01012"></a>01012                              <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c!=neighbor-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac9df9e0213d3ea1d2d8279892f6f1094">n_children</a>(); c++)
<a name="l01013"></a>01013                                {
<a name="l01014"></a>01014                                  <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *subneighbor = neighbor-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3966a92c6f8b6748755a94f9f3103c5a">child</a>(c);
<a name="l01015"></a>01015                                  <span class="keywordflow">if</span> (subneighbor != <a class="code" href="namespacelibMesh.php#a903992f631b52b5ba05ad96a51e7b383">remote_elem</a> &amp;&amp;
<a name="l01016"></a>01016                                      subneighbor-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ab426ef9274eb93de879fef28b027d602">active</a>() &amp;&amp;
<a name="l01017"></a>01017                                      subneighbor-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac38955440ced2b43f4aa74831d1da3f2">has_neighbor</a>(elem))
<a name="l01018"></a>01018                                    <span class="keywordflow">if</span> ((subneighbor-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>() &gt; my_p_level &amp;&amp;
<a name="l01019"></a>01019                                        subneighbor-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a53a98cf29aef9af6292c812d7b905c18">p_refinement_flag</a>() != <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a7d9c31942b061618643ecf815f74dd2c">Elem::COARSEN</a>)
<a name="l01020"></a>01020                                        || (subneighbor-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>() == my_p_level &amp;&amp;
<a name="l01021"></a>01021                                        subneighbor-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a53a98cf29aef9af6292c812d7b905c18">p_refinement_flag</a>() == <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a1511a7045e9a76eaa3b5b0f9511dd01b">Elem::REFINE</a>))
<a name="l01022"></a>01022                                      {
<a name="l01023"></a>01023                                        elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a13716b8bb2b92fa2244f6f4f375a0004">set_p_refinement_flag</a>(<a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a5a64eb29d0df43150a3b87184fb56be4">Elem::DO_NOTHING</a>);
<a name="l01024"></a>01024                                        my_flag_changed = <span class="keyword">true</span>;
<a name="l01025"></a>01025                                        <span class="keywordflow">break</span>;
<a name="l01026"></a>01026                                      }
<a name="l01027"></a>01027                                }
<a name="l01028"></a>01028                              <span class="keywordflow">if</span> (my_flag_changed)
<a name="l01029"></a>01029                                <span class="keywordflow">break</span>;
<a name="l01030"></a>01030                           }
<a name="l01031"></a>01031                       }
<a name="l01032"></a>01032                 }
<a name="l01033"></a>01033                   
<a name="l01034"></a>01034               <span class="comment">// If the current element&#39;s flag changed, we hadn&#39;t</span>
<a name="l01035"></a>01035               <span class="comment">// satisfied the level one rule.</span>
<a name="l01036"></a>01036               <span class="keywordflow">if</span> (my_flag_changed)
<a name="l01037"></a>01037                 level_one_satisfied = <span class="keyword">false</span>;
<a name="l01038"></a>01038               
<a name="l01039"></a>01039               <span class="comment">// Additionally, if it has non-local neighbors, and</span>
<a name="l01040"></a>01040               <span class="comment">// we&#39;re not in serial, then we&#39;ll eventually have to</span>
<a name="l01041"></a>01041               <span class="comment">// return compatible_with_refinement = false, because</span>
<a name="l01042"></a>01042               <span class="comment">// our change has to propagate to neighboring</span>
<a name="l01043"></a>01043               <span class="comment">// processors.</span>
<a name="l01044"></a>01044               <span class="keywordflow">if</span> (my_flag_changed &amp;&amp; !<a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a3c7d22fed3feea4c9ebd1fb41e7dbb4f">is_serial</a>())
<a name="l01045"></a>01045               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n != elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adf36086a897fdef3a88deec071ca5dfd">n_neighbors</a>(); ++n)
<a name="l01046"></a>01046                 {
<a name="l01047"></a>01047                   <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *neigh = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(n);
<a name="l01048"></a>01048                   <span class="keywordflow">if</span> (!neigh)
<a name="l01049"></a>01049                     <span class="keywordflow">continue</span>;
<a name="l01050"></a>01050                   <span class="keywordflow">if</span> (neigh == <a class="code" href="namespacelibMesh.php#a903992f631b52b5ba05ad96a51e7b383">remote_elem</a> ||
<a name="l01051"></a>01051                       neigh-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">processor_id</a>() !=
<a name="l01052"></a>01052                       <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>())
<a name="l01053"></a>01053                     {
<a name="l01054"></a>01054                       compatible_with_refinement = <span class="keyword">false</span>;
<a name="l01055"></a>01055                       <span class="keywordflow">break</span>;
<a name="l01056"></a>01056                     }
<a name="l01057"></a>01057                   <span class="comment">// FIXME - for non-level one meshes we should</span>
<a name="l01058"></a>01058                   <span class="comment">// test all descendants</span>
<a name="l01059"></a>01059                   <span class="keywordflow">if</span> (neigh-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac6316ca5f7b962a8a806ac385d6c0236">has_children</a>())
<a name="l01060"></a>01060                     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c != neigh-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac9df9e0213d3ea1d2d8279892f6f1094">n_children</a>(); ++c)
<a name="l01061"></a>01061                       <span class="keywordflow">if</span> (neigh-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3966a92c6f8b6748755a94f9f3103c5a">child</a>(c) == <a class="code" href="namespacelibMesh.php#a903992f631b52b5ba05ad96a51e7b383">remote_elem</a> ||
<a name="l01062"></a>01062                           neigh-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3966a92c6f8b6748755a94f9f3103c5a">child</a>(c)-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">processor_id</a>() !=
<a name="l01063"></a>01063                           <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>())
<a name="l01064"></a>01064                         {
<a name="l01065"></a>01065                           compatible_with_refinement = <span class="keyword">false</span>;
<a name="l01066"></a>01066                           <span class="keywordflow">break</span>;
<a name="l01067"></a>01067                         }
<a name="l01068"></a>01068                 }
<a name="l01069"></a>01069             }      
<a name="l01070"></a>01070         }
<a name="l01071"></a>01071       <span class="keywordflow">while</span> (!level_one_satisfied);
<a name="l01072"></a>01072       
<a name="l01073"></a>01073     } <span class="comment">// end if (_maintain_level_one)</span>
<a name="l01074"></a>01074   
<a name="l01075"></a>01075   
<a name="l01076"></a>01076   <span class="comment">// Next we look at all of the ancestor cells.</span>
<a name="l01077"></a>01077   <span class="comment">// If there is a parent cell with all of its children</span>
<a name="l01078"></a>01078   <span class="comment">// wanting to be unrefined then the element is a candidate</span>
<a name="l01079"></a>01079   <span class="comment">// for unrefinement.  If all the children don&#39;t</span>
<a name="l01080"></a>01080   <span class="comment">// all want to be unrefined then ALL of them need to have their</span>
<a name="l01081"></a>01081   <span class="comment">// unrefinement flags cleared.    </span>
<a name="l01082"></a>01082   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> level=(max_level); level &gt;= 0; level--)
<a name="l01083"></a>01083     {
<a name="l01084"></a>01084       <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       el     = <a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a32031f5d29428cf17dad4cabaf60d298">level_elements_begin</a>(level);
<a name="l01085"></a>01085       <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> end_el = <a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#ae94f3f5a30c83cdd0187ba02a5b8b17e">level_elements_end</a>(level); 
<a name="l01086"></a>01086       <span class="keywordflow">for</span> (; el != end_el; ++el)
<a name="l01087"></a>01087         {
<a name="l01088"></a>01088           <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *elem = *el;
<a name="l01089"></a>01089           <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d132de7da15df7db92f8995cc234b87">ancestor</a>())
<a name="l01090"></a>01090             {
<a name="l01091"></a>01091           
<a name="l01092"></a>01092               <span class="comment">// right now the element hasn&#39;t been disqualified</span>
<a name="l01093"></a>01093               <span class="comment">// as a candidate for unrefinement           </span>
<a name="l01094"></a>01094               <span class="keywordtype">bool</span> is_a_candidate = <span class="keyword">true</span>;
<a name="l01095"></a>01095               <span class="keywordtype">bool</span> found_remote_child = <span class="keyword">false</span>;
<a name="l01096"></a>01096               
<a name="l01097"></a>01097               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c&lt;elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac9df9e0213d3ea1d2d8279892f6f1094">n_children</a>(); c++)
<a name="l01098"></a>01098                 {
<a name="l01099"></a>01099                   <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *child = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3966a92c6f8b6748755a94f9f3103c5a">child</a>(c);
<a name="l01100"></a>01100                   <span class="keywordflow">if</span> (child == <a class="code" href="namespacelibMesh.php#a903992f631b52b5ba05ad96a51e7b383">remote_elem</a>)
<a name="l01101"></a>01101                     found_remote_child = <span class="keyword">true</span>;
<a name="l01102"></a>01102                   <span class="keywordflow">else</span> <span class="keywordflow">if</span> ((child-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a174bfe5b3d22e2b79000bfc816f633e6">refinement_flag</a>() != <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a7d9c31942b061618643ecf815f74dd2c">Elem::COARSEN</a>) ||
<a name="l01103"></a>01103                            !child-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ab426ef9274eb93de879fef28b027d602">active</a>() )
<a name="l01104"></a>01104                     is_a_candidate = <span class="keyword">false</span>;
<a name="l01105"></a>01105                 }
<a name="l01106"></a>01106               
<a name="l01107"></a>01107               <span class="keywordflow">if</span> (!is_a_candidate &amp;&amp; !found_remote_child)
<a name="l01108"></a>01108                 {
<a name="l01109"></a>01109                   elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adb60ffafaf6ebf931978c9335d278b46">set_refinement_flag</a>(<a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54af7c2ef5bee86b20e0a4e1cebd140caef">Elem::INACTIVE</a>);
<a name="l01110"></a>01110                   
<a name="l01111"></a>01111                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c&lt;elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac9df9e0213d3ea1d2d8279892f6f1094">n_children</a>(); c++)
<a name="l01112"></a>01112                     {
<a name="l01113"></a>01113                       <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *child = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3966a92c6f8b6748755a94f9f3103c5a">child</a>(c);
<a name="l01114"></a>01114                       <span class="keywordflow">if</span> (child == <a class="code" href="namespacelibMesh.php#a903992f631b52b5ba05ad96a51e7b383">remote_elem</a>)
<a name="l01115"></a>01115                         <span class="keywordflow">continue</span>;
<a name="l01116"></a>01116                       <span class="keywordflow">if</span> (child-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a174bfe5b3d22e2b79000bfc816f633e6">refinement_flag</a>() == <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a7d9c31942b061618643ecf815f74dd2c">Elem::COARSEN</a>)
<a name="l01117"></a>01117                         {
<a name="l01118"></a>01118                           level_one_satisfied = <span class="keyword">false</span>;
<a name="l01119"></a>01119                           child-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adb60ffafaf6ebf931978c9335d278b46">set_refinement_flag</a>(<a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a5a64eb29d0df43150a3b87184fb56be4">Elem::DO_NOTHING</a>);
<a name="l01120"></a>01120                         }
<a name="l01121"></a>01121                     }
<a name="l01122"></a>01122                 }
<a name="l01123"></a>01123             }
<a name="l01124"></a>01124          }
<a name="l01125"></a>01125      }
<a name="l01126"></a>01126      
<a name="l01127"></a>01127   <span class="keywordflow">if</span> (!level_one_satisfied &amp;&amp; _maintain_level_one) <span class="keywordflow">goto</span> repeat;
<a name="l01128"></a>01128   
<a name="l01129"></a>01129   
<a name="l01130"></a>01130   <span class="comment">// If all the children of a parent are set to be coarsened</span>
<a name="l01131"></a>01131   <span class="comment">// then flag the parent so that they can kill thier kids...   </span>
<a name="l01132"></a>01132   <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       all_el     = <a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#ac266e1f5eb6ac9566ccbd7e6add6c239">elements_begin</a>();
<a name="l01133"></a>01133   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> all_el_end = <a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#ae94f1bce0dc50c489c6bae9ba64d06e8">elements_end</a>(); 
<a name="l01134"></a>01134   <span class="keywordflow">for</span> (; all_el != all_el_end; ++all_el)
<a name="l01135"></a>01135     {
<a name="l01136"></a>01136       <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *elem = *all_el;
<a name="l01137"></a>01137         <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d132de7da15df7db92f8995cc234b87">ancestor</a>())
<a name="l01138"></a>01138           {
<a name="l01139"></a>01139         
<a name="l01140"></a>01140             <span class="comment">// Presume all the children are local and flagged for</span>
<a name="l01141"></a>01141             <span class="comment">// coarsening and then look for a contradiction      </span>
<a name="l01142"></a>01142             <span class="keywordtype">bool</span> all_children_flagged_for_coarsening = <span class="keyword">true</span>;
<a name="l01143"></a>01143             <span class="keywordtype">bool</span> found_remote_child = <span class="keyword">false</span>;
<a name="l01144"></a>01144         
<a name="l01145"></a>01145             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c&lt;elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac9df9e0213d3ea1d2d8279892f6f1094">n_children</a>(); c++)
<a name="l01146"></a>01146               {
<a name="l01147"></a>01147                 <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *child = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3966a92c6f8b6748755a94f9f3103c5a">child</a>(c);
<a name="l01148"></a>01148                 <span class="keywordflow">if</span> (child == <a class="code" href="namespacelibMesh.php#a903992f631b52b5ba05ad96a51e7b383">remote_elem</a>)
<a name="l01149"></a>01149                   found_remote_child = <span class="keyword">true</span>;
<a name="l01150"></a>01150                 <span class="keywordflow">else</span> <span class="keywordflow">if</span> (child-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a174bfe5b3d22e2b79000bfc816f633e6">refinement_flag</a>() != <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a7d9c31942b061618643ecf815f74dd2c">Elem::COARSEN</a>)
<a name="l01151"></a>01151                   all_children_flagged_for_coarsening = <span class="keyword">false</span>;
<a name="l01152"></a>01152               }
<a name="l01153"></a>01153         
<a name="l01154"></a>01154             <span class="keywordflow">if</span> (!found_remote_child &amp;&amp;
<a name="l01155"></a>01155                 all_children_flagged_for_coarsening)
<a name="l01156"></a>01156               elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adb60ffafaf6ebf931978c9335d278b46">set_refinement_flag</a>(<a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a560ee64b3c009f94569a135dce55c8b6">Elem::COARSEN_INACTIVE</a>);
<a name="l01157"></a>01157             <span class="keywordflow">else</span> <span class="keywordflow">if</span> (!found_remote_child)
<a name="l01158"></a>01158               elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adb60ffafaf6ebf931978c9335d278b46">set_refinement_flag</a>(<a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54af7c2ef5bee86b20e0a4e1cebd140caef">Elem::INACTIVE</a>);
<a name="l01159"></a>01159           }
<a name="l01160"></a>01160     }
<a name="l01161"></a>01161         
<a name="l01162"></a>01162   STOP_LOG (<span class="stringliteral">&quot;make_coarsening_compatible()&quot;</span>, <span class="stringliteral">&quot;MeshRefinement&quot;</span>);
<a name="l01163"></a>01163 
<a name="l01164"></a>01164   <span class="comment">// If one processor finds an incompatibility, we&#39;re globally</span>
<a name="l01165"></a>01165   <span class="comment">// incompatible</span>
<a name="l01166"></a>01166   <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">Parallel::min</a>(compatible_with_refinement);
<a name="l01167"></a>01167   
<a name="l01168"></a>01168   <span class="keywordflow">return</span> compatible_with_refinement;
<a name="l01169"></a>01169 }
<a name="l01170"></a>01170 
<a name="l01171"></a>01171 
<a name="l01172"></a>01172 
<a name="l01173"></a>01173 
<a name="l01174"></a>01174 
<a name="l01175"></a>01175 
<a name="l01176"></a>01176 
<a name="l01177"></a>01177 
<a name="l01178"></a><a class="code" href="classlibMesh_1_1MeshRefinement.php#a98aad95c8d6f16674c878c8ef01dba6e">01178</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1MeshRefinement.php#a98aad95c8d6f16674c878c8ef01dba6e">MeshRefinement::make_refinement_compatible</a>(<span class="keyword">const</span> <span class="keywordtype">bool</span> maintain_level_one)
<a name="l01179"></a>01179 {
<a name="l01180"></a>01180   <span class="comment">// This function must be run on all processors at once</span>
<a name="l01181"></a>01181   parallel_only();
<a name="l01182"></a>01182 
<a name="l01183"></a>01183   START_LOG (<span class="stringliteral">&quot;make_refinement_compatible()&quot;</span>, <span class="stringliteral">&quot;MeshRefinement&quot;</span>);
<a name="l01184"></a>01184   
<a name="l01185"></a>01185   <span class="keywordtype">bool</span> _maintain_level_one = maintain_level_one;
<a name="l01186"></a>01186 
<a name="l01187"></a>01187   <span class="comment">// If the user used non-default parameters, let&#39;s warn that they&#39;re</span>
<a name="l01188"></a>01188   <span class="comment">// deprecated</span>
<a name="l01189"></a>01189   <span class="keywordflow">if</span> (!maintain_level_one)
<a name="l01190"></a>01190     {
<a name="l01191"></a>01191       libmesh_deprecated();
<a name="l01192"></a>01192     }
<a name="l01193"></a>01193   <span class="keywordflow">else</span>
<a name="l01194"></a>01194     _maintain_level_one = <a class="code" href="classlibMesh_1_1MeshRefinement.php#a56f1015a59736175b39e4a1ca4d084bc">_face_level_mismatch_limit</a>;
<a name="l01195"></a>01195 
<a name="l01196"></a>01196   <span class="comment">// Unless we encounter a specific situation level-one</span>
<a name="l01197"></a>01197   <span class="comment">// will be satisfied after executing this loop just once</span>
<a name="l01198"></a>01198   <span class="keywordtype">bool</span> level_one_satisfied = <span class="keyword">true</span>;
<a name="l01199"></a>01199 
<a name="l01200"></a>01200   <span class="comment">// Unless we encounter a specific situation we will be compatible</span>
<a name="l01201"></a>01201   <span class="comment">// with any selected coarsening flags</span>
<a name="l01202"></a>01202   <span class="keywordtype">bool</span> compatible_with_coarsening = <span class="keyword">true</span>;
<a name="l01203"></a>01203 
<a name="l01204"></a>01204   <span class="comment">// This loop enforces the level-1 rule.  We should only</span>
<a name="l01205"></a>01205   <span class="comment">// execute it if the user indeed wants level-1 satisfied!   </span>
<a name="l01206"></a>01206   <span class="keywordflow">if</span> (_maintain_level_one)
<a name="l01207"></a>01207     {  
<a name="l01208"></a>01208       <span class="keywordflow">do</span>
<a name="l01209"></a>01209         {
<a name="l01210"></a>01210           level_one_satisfied = <span class="keyword">true</span>;
<a name="l01211"></a>01211           
<a name="l01212"></a>01212           <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       el     = <a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#aefa4ded9eaf654a45ab593a0963ecbf3">active_elements_begin</a>();
<a name="l01213"></a>01213           <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> end_el = <a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#ae3f09f1b7556aef88919249861728e23">active_elements_end</a>(); 
<a name="l01214"></a>01214 
<a name="l01215"></a>01215           <span class="keywordflow">for</span> (; el != end_el; ++el)
<a name="l01216"></a>01216             {
<a name="l01217"></a>01217             <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *elem = *el;
<a name="l01218"></a>01218             <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a174bfe5b3d22e2b79000bfc816f633e6">refinement_flag</a>() == <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a1511a7045e9a76eaa3b5b0f9511dd01b">Elem::REFINE</a>)  <span class="comment">// If the element is active and the</span>
<a name="l01219"></a>01219                                                           <span class="comment">// h refinement flag is set    </span>
<a name="l01220"></a>01220               {
<a name="l01221"></a>01221                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> my_level = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a1fa3e8bb1baa330a5037487dbe9304ab">level</a>();
<a name="l01222"></a>01222             
<a name="l01223"></a>01223                 <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>=0; <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a> != elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ae376bfa6ac14723330e07a97992b56c9">n_sides</a>(); <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>++)
<a name="l01224"></a>01224                   {
<a name="l01225"></a>01225                     <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* neighbor = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(<a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>);
<a name="l01226"></a>01226                     <span class="keywordflow">if</span> (neighbor != NULL        &amp;&amp; <span class="comment">// I have a</span>
<a name="l01227"></a>01227                         neighbor != <a class="code" href="namespacelibMesh.php#a903992f631b52b5ba05ad96a51e7b383">remote_elem</a> &amp;&amp; <span class="comment">// neighbor here</span>
<a name="l01228"></a>01228                         neighbor-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ab426ef9274eb93de879fef28b027d602">active</a>()) <span class="comment">// and it is active</span>
<a name="l01229"></a>01229                       {
<a name="l01230"></a>01230                         
<a name="l01231"></a>01231                         
<a name="l01232"></a>01232                         <span class="comment">// Case 1:  The neighbor is at the same level I am.</span>
<a name="l01233"></a>01233                         <span class="comment">//        1a: The neighbor will be refined       -&gt; NO PROBLEM</span>
<a name="l01234"></a>01234                         <span class="comment">//        1b: The neighbor won&#39;t be refined      -&gt; NO PROBLEM</span>
<a name="l01235"></a>01235                         <span class="comment">//        1c: The neighbor wants to be coarsened -&gt; PROBLEM                      </span>
<a name="l01236"></a>01236                         <span class="keywordflow">if</span> (neighbor-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a1fa3e8bb1baa330a5037487dbe9304ab">level</a>() == my_level)
<a name="l01237"></a>01237                           {
<a name="l01238"></a>01238                             <span class="keywordflow">if</span> (neighbor-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a174bfe5b3d22e2b79000bfc816f633e6">refinement_flag</a>() == <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a7d9c31942b061618643ecf815f74dd2c">Elem::COARSEN</a>)
<a name="l01239"></a>01239                               {
<a name="l01240"></a>01240                                 neighbor-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adb60ffafaf6ebf931978c9335d278b46">set_refinement_flag</a>(<a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a5a64eb29d0df43150a3b87184fb56be4">Elem::DO_NOTHING</a>);
<a name="l01241"></a>01241                                 <span class="keywordflow">if</span> (neighbor-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a7cdd994bb4245128f8617b62d7968e35">parent</a>())
<a name="l01242"></a>01242                                   neighbor-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a7cdd994bb4245128f8617b62d7968e35">parent</a>()-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adb60ffafaf6ebf931978c9335d278b46">set_refinement_flag</a>(<a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54af7c2ef5bee86b20e0a4e1cebd140caef">Elem::INACTIVE</a>);
<a name="l01243"></a>01243                                 compatible_with_coarsening = <span class="keyword">false</span>;
<a name="l01244"></a>01244                                 level_one_satisfied = <span class="keyword">false</span>;
<a name="l01245"></a>01245                               }
<a name="l01246"></a>01246                           }
<a name="l01247"></a>01247                         
<a name="l01248"></a>01248                         
<a name="l01249"></a>01249                         <span class="comment">// Case 2: The neighbor is one level lower than I am.</span>
<a name="l01250"></a>01250                         <span class="comment">//         The neighbor thus MUST be refined to satisfy</span>
<a name="l01251"></a>01251                         <span class="comment">//         the level-one rule, regardless of whether it</span>
<a name="l01252"></a>01252                         <span class="comment">//         was originally flagged for refinement. If it</span>
<a name="l01253"></a>01253                         <span class="comment">//         wasn&#39;t flagged already we need to repeat</span>
<a name="l01254"></a>01254                         <span class="comment">//         this process.                         </span>
<a name="l01255"></a>01255                         <span class="keywordflow">else</span> <span class="keywordflow">if</span> ((neighbor-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a1fa3e8bb1baa330a5037487dbe9304ab">level</a>()+1) == my_level)
<a name="l01256"></a>01256                           {
<a name="l01257"></a>01257                             <span class="keywordflow">if</span> (neighbor-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a174bfe5b3d22e2b79000bfc816f633e6">refinement_flag</a>() != <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a1511a7045e9a76eaa3b5b0f9511dd01b">Elem::REFINE</a>)
<a name="l01258"></a>01258                               {
<a name="l01259"></a>01259                                 neighbor-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adb60ffafaf6ebf931978c9335d278b46">set_refinement_flag</a>(<a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a1511a7045e9a76eaa3b5b0f9511dd01b">Elem::REFINE</a>);
<a name="l01260"></a>01260                                 <span class="keywordflow">if</span> (neighbor-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a7cdd994bb4245128f8617b62d7968e35">parent</a>())
<a name="l01261"></a>01261                                   neighbor-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a7cdd994bb4245128f8617b62d7968e35">parent</a>()-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adb60ffafaf6ebf931978c9335d278b46">set_refinement_flag</a>(<a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54af7c2ef5bee86b20e0a4e1cebd140caef">Elem::INACTIVE</a>);
<a name="l01262"></a>01262                                 compatible_with_coarsening = <span class="keyword">false</span>;
<a name="l01263"></a>01263                                 level_one_satisfied = <span class="keyword">false</span>; 
<a name="l01264"></a>01264                               }
<a name="l01265"></a>01265                           }
<a name="l01266"></a>01266 <span class="preprocessor">#ifdef DEBUG            </span>
<a name="l01267"></a>01267 <span class="preprocessor"></span>                        
<a name="l01268"></a>01268                         <span class="comment">// Sanity check. We should never get into a</span>
<a name="l01269"></a>01269                         <span class="comment">// case when our neighbot is more than one</span>
<a name="l01270"></a>01270                         <span class="comment">// level away.                   </span>
<a name="l01271"></a>01271                         <span class="keywordflow">else</span> <span class="keywordflow">if</span> ((neighbor-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a1fa3e8bb1baa330a5037487dbe9304ab">level</a>()+1) &lt; my_level)
<a name="l01272"></a>01272                           {
<a name="l01273"></a>01273                             libmesh_error();
<a name="l01274"></a>01274                           }
<a name="l01275"></a>01275                         
<a name="l01276"></a>01276                         
<a name="l01277"></a>01277                         <span class="comment">// Note that the only other possibility is that the</span>
<a name="l01278"></a>01278                         <span class="comment">// neighbor is already refined, in which case it isn&#39;t</span>
<a name="l01279"></a>01279                         <span class="comment">// active and we should never get here.                  </span>
<a name="l01280"></a>01280                         <span class="keywordflow">else</span>
<a name="l01281"></a>01281                           {
<a name="l01282"></a>01282                             libmesh_error();
<a name="l01283"></a>01283                           }
<a name="l01284"></a>01284 <span class="preprocessor">#endif          </span>
<a name="l01285"></a>01285 <span class="preprocessor"></span>                      } 
<a name="l01286"></a>01286                   }
<a name="l01287"></a>01287               }
<a name="l01288"></a>01288             <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a53a98cf29aef9af6292c812d7b905c18">p_refinement_flag</a>() == <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a1511a7045e9a76eaa3b5b0f9511dd01b">Elem::REFINE</a>)  <span class="comment">// If the element is active and the</span>
<a name="l01289"></a>01289                                                             <span class="comment">// p refinement flag is set    </span>
<a name="l01290"></a>01290               {
<a name="l01291"></a>01291                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> my_p_level = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>();
<a name="l01292"></a>01292 
<a name="l01293"></a>01293                 <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>=0; <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a> != elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ae376bfa6ac14723330e07a97992b56c9">n_sides</a>(); <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>++)
<a name="l01294"></a>01294                   {
<a name="l01295"></a>01295                     <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *neighbor = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(<a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>);
<a name="l01296"></a>01296                     <span class="keywordflow">if</span> (neighbor != NULL &amp;&amp;      <span class="comment">// I have a</span>
<a name="l01297"></a>01297                         neighbor != <a class="code" href="namespacelibMesh.php#a903992f631b52b5ba05ad96a51e7b383">remote_elem</a>) <span class="comment">// neighbor here</span>
<a name="l01298"></a>01298                       {
<a name="l01299"></a>01299                         <span class="keywordflow">if</span> (neighbor-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ab426ef9274eb93de879fef28b027d602">active</a>()) <span class="comment">// and it is active</span>
<a name="l01300"></a>01300                           {
<a name="l01301"></a>01301                             <span class="keywordflow">if</span> (neighbor-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>() &lt; my_p_level &amp;&amp;
<a name="l01302"></a>01302                                 neighbor-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a53a98cf29aef9af6292c812d7b905c18">p_refinement_flag</a>() != <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a1511a7045e9a76eaa3b5b0f9511dd01b">Elem::REFINE</a>)
<a name="l01303"></a>01303                               {
<a name="l01304"></a>01304                                 neighbor-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a13716b8bb2b92fa2244f6f4f375a0004">set_p_refinement_flag</a>(<a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a1511a7045e9a76eaa3b5b0f9511dd01b">Elem::REFINE</a>);
<a name="l01305"></a>01305                                 level_one_satisfied = <span class="keyword">false</span>;
<a name="l01306"></a>01306                                 compatible_with_coarsening = <span class="keyword">false</span>;
<a name="l01307"></a>01307                               }
<a name="l01308"></a>01308                             <span class="keywordflow">if</span> (neighbor-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>() == my_p_level &amp;&amp;
<a name="l01309"></a>01309                                 neighbor-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a53a98cf29aef9af6292c812d7b905c18">p_refinement_flag</a>() == <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a7d9c31942b061618643ecf815f74dd2c">Elem::COARSEN</a>)
<a name="l01310"></a>01310                               {
<a name="l01311"></a>01311                                 neighbor-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a13716b8bb2b92fa2244f6f4f375a0004">set_p_refinement_flag</a>(<a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a5a64eb29d0df43150a3b87184fb56be4">Elem::DO_NOTHING</a>);
<a name="l01312"></a>01312                                 level_one_satisfied = <span class="keyword">false</span>;
<a name="l01313"></a>01313                                 compatible_with_coarsening = <span class="keyword">false</span>;
<a name="l01314"></a>01314                               }
<a name="l01315"></a>01315                           } 
<a name="l01316"></a>01316                         <span class="keywordflow">else</span> <span class="comment">// I have an inactive neighbor</span>
<a name="l01317"></a>01317                           {
<a name="l01318"></a>01318                             libmesh_assert(neighbor-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac6316ca5f7b962a8a806ac385d6c0236">has_children</a>());
<a name="l01319"></a>01319                             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c!=neighbor-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac9df9e0213d3ea1d2d8279892f6f1094">n_children</a>(); c++)
<a name="l01320"></a>01320                               {
<a name="l01321"></a>01321                                 <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *subneighbor = neighbor-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3966a92c6f8b6748755a94f9f3103c5a">child</a>(c);
<a name="l01322"></a>01322                                 <span class="keywordflow">if</span> (subneighbor == <a class="code" href="namespacelibMesh.php#a903992f631b52b5ba05ad96a51e7b383">remote_elem</a>)
<a name="l01323"></a>01323                                   <span class="keywordflow">continue</span>;
<a name="l01324"></a>01324                                 <span class="keywordflow">if</span> (subneighbor-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ab426ef9274eb93de879fef28b027d602">active</a>() &amp;&amp;
<a name="l01325"></a>01325                                     subneighbor-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac38955440ced2b43f4aa74831d1da3f2">has_neighbor</a>(elem))
<a name="l01326"></a>01326                                   {
<a name="l01327"></a>01327                                     <span class="keywordflow">if</span> (subneighbor-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>() &lt; my_p_level &amp;&amp;
<a name="l01328"></a>01328                                         subneighbor-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a53a98cf29aef9af6292c812d7b905c18">p_refinement_flag</a>() != <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a1511a7045e9a76eaa3b5b0f9511dd01b">Elem::REFINE</a>)
<a name="l01329"></a>01329                                       {
<a name="l01330"></a>01330                                         <span class="comment">// We should already be level one</span>
<a name="l01331"></a>01331                                         <span class="comment">// compatible</span>
<a name="l01332"></a>01332                                         libmesh_assert(subneighbor-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>() + 2u &gt; 
<a name="l01333"></a>01333                                                        my_p_level);
<a name="l01334"></a>01334                                         subneighbor-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a13716b8bb2b92fa2244f6f4f375a0004">set_p_refinement_flag</a>(<a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a1511a7045e9a76eaa3b5b0f9511dd01b">Elem::REFINE</a>);
<a name="l01335"></a>01335                                         level_one_satisfied = <span class="keyword">false</span>;
<a name="l01336"></a>01336                                         compatible_with_coarsening = <span class="keyword">false</span>;
<a name="l01337"></a>01337                                       }
<a name="l01338"></a>01338                                     <span class="keywordflow">if</span> (subneighbor-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>() == my_p_level &amp;&amp;
<a name="l01339"></a>01339                                         subneighbor-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a53a98cf29aef9af6292c812d7b905c18">p_refinement_flag</a>() == <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a7d9c31942b061618643ecf815f74dd2c">Elem::COARSEN</a>)
<a name="l01340"></a>01340                                       {
<a name="l01341"></a>01341                                         subneighbor-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a13716b8bb2b92fa2244f6f4f375a0004">set_p_refinement_flag</a>(<a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a5a64eb29d0df43150a3b87184fb56be4">Elem::DO_NOTHING</a>);
<a name="l01342"></a>01342                                         level_one_satisfied = <span class="keyword">false</span>;
<a name="l01343"></a>01343                                         compatible_with_coarsening = <span class="keyword">false</span>;
<a name="l01344"></a>01344                                       }
<a name="l01345"></a>01345                                   }
<a name="l01346"></a>01346                               }
<a name="l01347"></a>01347                           } 
<a name="l01348"></a>01348                       }
<a name="l01349"></a>01349                   }
<a name="l01350"></a>01350               }
<a name="l01351"></a>01351             }
<a name="l01352"></a>01352         }
<a name="l01353"></a>01353       
<a name="l01354"></a>01354       <span class="keywordflow">while</span> (!level_one_satisfied);
<a name="l01355"></a>01355     } <span class="comment">// end if (_maintain_level_one)</span>
<a name="l01356"></a>01356 
<a name="l01357"></a>01357   <span class="comment">// If we&#39;re not compatible on one processor, we&#39;re globally not</span>
<a name="l01358"></a>01358   <span class="comment">// compatible</span>
<a name="l01359"></a>01359   <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">Parallel::min</a>(compatible_with_coarsening);
<a name="l01360"></a>01360   
<a name="l01361"></a>01361   STOP_LOG (<span class="stringliteral">&quot;make_refinement_compatible()&quot;</span>, <span class="stringliteral">&quot;MeshRefinement&quot;</span>);
<a name="l01362"></a>01362 
<a name="l01363"></a>01363   <span class="keywordflow">return</span> compatible_with_coarsening;
<a name="l01364"></a>01364 }
<a name="l01365"></a>01365 
<a name="l01366"></a>01366 
<a name="l01367"></a>01367 
<a name="l01368"></a>01368 
<a name="l01369"></a><a class="code" href="classlibMesh_1_1MeshRefinement.php#a46ef7ebd80c846f24998ef0f222c55e1">01369</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1MeshRefinement.php#a46ef7ebd80c846f24998ef0f222c55e1">MeshRefinement::_coarsen_elements</a> ()
<a name="l01370"></a>01370 {
<a name="l01371"></a>01371   <span class="comment">// This function must be run on all processors at once</span>
<a name="l01372"></a>01372   parallel_only();
<a name="l01373"></a>01373 
<a name="l01374"></a>01374   START_LOG (<span class="stringliteral">&quot;_coarsen_elements()&quot;</span>, <span class="stringliteral">&quot;MeshRefinement&quot;</span>);
<a name="l01375"></a>01375 
<a name="l01376"></a>01376   <span class="comment">// Flag indicating if this call actually changes the mesh</span>
<a name="l01377"></a>01377   <span class="keywordtype">bool</span> mesh_changed = <span class="keyword">false</span>;
<a name="l01378"></a>01378   
<a name="l01379"></a>01379   <span class="comment">// Clear the unused_elements data structure.</span>
<a name="l01380"></a>01380   <span class="comment">// The elements have been packed since it was built,</span>
<a name="l01381"></a>01381   <span class="comment">// so there are _no_ unused elements.  We cannot trust</span>
<a name="l01382"></a>01382   <span class="comment">// any iterators currently in this data structure.</span>
<a name="l01383"></a>01383   <span class="comment">// _unused_elements.clear();</span>
<a name="l01384"></a>01384 
<a name="l01385"></a>01385   <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       it  = <a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#ac266e1f5eb6ac9566ccbd7e6add6c239">elements_begin</a>();
<a name="l01386"></a>01386   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> end = <a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#ae94f1bce0dc50c489c6bae9ba64d06e8">elements_end</a>();
<a name="l01387"></a>01387 
<a name="l01388"></a>01388   <span class="comment">// Loop over the elements.   </span>
<a name="l01389"></a>01389   <span class="keywordflow">for</span> ( ; it != end; ++it)
<a name="l01390"></a>01390     {
<a name="l01391"></a>01391       <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = *it;
<a name="l01392"></a>01392 
<a name="l01393"></a>01393       <span class="comment">// Not necessary when using elem_iterator</span>
<a name="l01394"></a>01394       <span class="comment">// libmesh_assert (elem != NULL);</span>
<a name="l01395"></a>01395       
<a name="l01396"></a>01396       <span class="comment">// active elements flagged for coarsening will</span>
<a name="l01397"></a>01397       <span class="comment">// no longer be deleted until MeshRefinement::contract()</span>
<a name="l01398"></a>01398       <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a174bfe5b3d22e2b79000bfc816f633e6">refinement_flag</a>() == <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a7d9c31942b061618643ecf815f74dd2c">Elem::COARSEN</a>)
<a name="l01399"></a>01399         {
<a name="l01400"></a>01400           <span class="comment">// Huh?  no level-0 element should be active</span>
<a name="l01401"></a>01401           <span class="comment">// and flagged for coarsening.</span>
<a name="l01402"></a>01402           libmesh_assert (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a1fa3e8bb1baa330a5037487dbe9304ab">level</a>() != 0);
<a name="l01403"></a>01403           
<a name="l01404"></a>01404           <span class="comment">// Remove this element from any neighbor</span>
<a name="l01405"></a>01405           <span class="comment">// lists that point to it.</span>
<a name="l01406"></a>01406           elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a726879346cab41cf1056a9eed73e02b0">nullify_neighbors</a>();
<a name="l01407"></a>01407 
<a name="l01408"></a>01408           <span class="comment">// Remove any boundary information associated</span>
<a name="l01409"></a>01409           <span class="comment">// with this element</span>
<a name="l01410"></a>01410           <a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;remove (elem);
<a name="l01411"></a>01411               
<a name="l01412"></a>01412           <span class="comment">// Add this iterator to the _unused_elements</span>
<a name="l01413"></a>01413           <span class="comment">// data structure so we might fill it.</span>
<a name="l01414"></a>01414           <span class="comment">// The _unused_elements optimization is currently off.</span>
<a name="l01415"></a>01415           <span class="comment">// _unused_elements.push_back (it);</span>
<a name="l01416"></a>01416 
<a name="l01417"></a>01417           <span class="comment">// Don&#39;t delete the element until</span>
<a name="l01418"></a>01418           <span class="comment">// MeshRefinement::contract()</span>
<a name="l01419"></a>01419           <span class="comment">// _mesh.delete_elem(elem);</span>
<a name="l01420"></a>01420 
<a name="l01421"></a>01421           <span class="comment">// the mesh has certainly changed</span>
<a name="l01422"></a>01422           mesh_changed = <span class="keyword">true</span>;
<a name="l01423"></a>01423         }
<a name="l01424"></a>01424       
<a name="l01425"></a>01425       <span class="comment">// inactive elements flagged for coarsening</span>
<a name="l01426"></a>01426       <span class="comment">// will become active</span>
<a name="l01427"></a>01427       <span class="keywordflow">else</span> <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a174bfe5b3d22e2b79000bfc816f633e6">refinement_flag</a>() == <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a560ee64b3c009f94569a135dce55c8b6">Elem::COARSEN_INACTIVE</a>)
<a name="l01428"></a>01428         {
<a name="l01429"></a>01429           elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac54b6c6495592ce7774d01167b71dfbd">coarsen</a>();
<a name="l01430"></a>01430           libmesh_assert (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ab426ef9274eb93de879fef28b027d602">active</a>());
<a name="l01431"></a>01431 
<a name="l01432"></a>01432           <span class="comment">// the mesh has certainly changed</span>
<a name="l01433"></a>01433           mesh_changed = <span class="keyword">true</span>;
<a name="l01434"></a>01434         }
<a name="l01435"></a>01435       <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a53a98cf29aef9af6292c812d7b905c18">p_refinement_flag</a>() == <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a7d9c31942b061618643ecf815f74dd2c">Elem::COARSEN</a>)
<a name="l01436"></a>01436         {
<a name="l01437"></a>01437           <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>() &gt; 0)
<a name="l01438"></a>01438             {
<a name="l01439"></a>01439               elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a13716b8bb2b92fa2244f6f4f375a0004">set_p_refinement_flag</a>(<a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54adec28448bd3f7297806b7d58e9625240">Elem::JUST_COARSENED</a>);
<a name="l01440"></a>01440               elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#af1f504a628c96ad2d9e49cff16d69bca">set_p_level</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>() - 1);
<a name="l01441"></a>01441               mesh_changed = <span class="keyword">true</span>;
<a name="l01442"></a>01442             }
<a name="l01443"></a>01443           <span class="keywordflow">else</span>
<a name="l01444"></a>01444             {
<a name="l01445"></a>01445               elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a13716b8bb2b92fa2244f6f4f375a0004">set_p_refinement_flag</a>(<a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a5a64eb29d0df43150a3b87184fb56be4">Elem::DO_NOTHING</a>);
<a name="l01446"></a>01446             }
<a name="l01447"></a>01447         }
<a name="l01448"></a>01448     }  
<a name="l01449"></a>01449 
<a name="l01450"></a>01450   <span class="comment">// If the mesh changed on any processor, it changed globally</span>
<a name="l01451"></a>01451   <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">Parallel::max</a>(mesh_changed);
<a name="l01452"></a>01452   <span class="comment">// And we may need to update ParallelMesh values reflecting the changes</span>
<a name="l01453"></a>01453   <span class="keywordflow">if</span> (mesh_changed)
<a name="l01454"></a>01454     <a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#ae10a5f947142866d4a1c1409973b1582">update_parallel_id_counts</a>();
<a name="l01455"></a>01455 
<a name="l01456"></a>01456   <span class="comment">// Node processor ids may need to change if an element of that id</span>
<a name="l01457"></a>01457   <span class="comment">// was coarsened away</span>
<a name="l01458"></a>01458   <span class="keywordflow">if</span> (mesh_changed &amp;&amp; !<a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a3c7d22fed3feea4c9ebd1fb41e7dbb4f">is_serial</a>())
<a name="l01459"></a>01459     {
<a name="l01460"></a>01460       <span class="comment">// Update the _new_nodes_map so that processors can</span>
<a name="l01461"></a>01461       <span class="comment">// find requested nodes</span>
<a name="l01462"></a>01462       this-&gt;<a class="code" href="classlibMesh_1_1MeshRefinement.php#a2fbd7b73883ab6ad3f587a7e6e756ab0">update_nodes_map</a> ();
<a name="l01463"></a>01463 
<a name="l01464"></a>01464       <a class="code" href="classlibMesh_1_1MeshCommunication.php">MeshCommunication</a>().<a class="code" href="classlibMesh_1_1MeshCommunication.php#a4267fefd3ddfeead0f25be8fb9918af8">make_nodes_parallel_consistent</a>
<a name="l01465"></a>01465         (<a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>, <a class="code" href="classlibMesh_1_1MeshRefinement.php#a0b34a1599da3a45c2d0eed3e19c38574">_new_nodes_map</a>);
<a name="l01466"></a>01466 
<a name="l01467"></a>01467       <span class="comment">// Clear the _new_nodes_map</span>
<a name="l01468"></a>01468       this-&gt;<a class="code" href="classlibMesh_1_1MeshRefinement.php#ac64e4f1afa4af23fe11997dfbeae071b">clear</a>();
<a name="l01469"></a>01469   
<a name="l01470"></a>01470 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l01471"></a>01471 <span class="preprocessor"></span>      <a class="code" href="namespacelibMesh_1_1MeshTools.php#a4413b39e0439b2e5535c9a9f962ea3fd">MeshTools::libmesh_assert_valid_node_procids</a>(<a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>);
<a name="l01472"></a>01472 <span class="preprocessor">#endif</span>
<a name="l01473"></a>01473 <span class="preprocessor"></span>    }
<a name="l01474"></a>01474 
<a name="l01475"></a>01475   STOP_LOG (<span class="stringliteral">&quot;_coarsen_elements()&quot;</span>, <span class="stringliteral">&quot;MeshRefinement&quot;</span>);
<a name="l01476"></a>01476 
<a name="l01477"></a>01477   <span class="keywordflow">return</span> mesh_changed;
<a name="l01478"></a>01478 }
<a name="l01479"></a>01479 
<a name="l01480"></a>01480 
<a name="l01481"></a>01481 
<a name="l01482"></a><a class="code" href="classlibMesh_1_1MeshRefinement.php#ad794507aa1e1908fea6fb373dd31c548">01482</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1MeshRefinement.php#ad794507aa1e1908fea6fb373dd31c548">MeshRefinement::_refine_elements</a> ()
<a name="l01483"></a>01483 {
<a name="l01484"></a>01484   <span class="comment">// This function must be run on all processors at once</span>
<a name="l01485"></a>01485   parallel_only();
<a name="l01486"></a>01486 
<a name="l01487"></a>01487   <span class="comment">// Update the _new_nodes_map so that elements can</span>
<a name="l01488"></a>01488   <span class="comment">// find nodes to connect to.</span>
<a name="l01489"></a>01489   this-&gt;<a class="code" href="classlibMesh_1_1MeshRefinement.php#a2fbd7b73883ab6ad3f587a7e6e756ab0">update_nodes_map</a> ();
<a name="l01490"></a>01490 
<a name="l01491"></a>01491   START_LOG (<span class="stringliteral">&quot;_refine_elements()&quot;</span>, <span class="stringliteral">&quot;MeshRefinement&quot;</span>);
<a name="l01492"></a>01492 
<a name="l01493"></a>01493   <span class="comment">// Iterate over the elements, counting the elements</span>
<a name="l01494"></a>01494   <span class="comment">// flagged for h refinement.</span>
<a name="l01495"></a>01495   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_elems_flagged = 0;
<a name="l01496"></a>01496 
<a name="l01497"></a>01497   <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       it  = <a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#ac266e1f5eb6ac9566ccbd7e6add6c239">elements_begin</a>();
<a name="l01498"></a>01498   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> end = <a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#ae94f1bce0dc50c489c6bae9ba64d06e8">elements_end</a>();
<a name="l01499"></a>01499 
<a name="l01500"></a>01500   <span class="keywordflow">for</span> (; it != end; ++it)
<a name="l01501"></a>01501     {
<a name="l01502"></a>01502       <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = *it;
<a name="l01503"></a>01503       <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a174bfe5b3d22e2b79000bfc816f633e6">refinement_flag</a>() == <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a1511a7045e9a76eaa3b5b0f9511dd01b">Elem::REFINE</a>)
<a name="l01504"></a>01504         n_elems_flagged++;
<a name="l01505"></a>01505     }
<a name="l01506"></a>01506 
<a name="l01507"></a>01507   <span class="comment">// Construct a local vector of Elem* which have been</span>
<a name="l01508"></a>01508   <span class="comment">// previously marked for refinement.  We reserve enough</span>
<a name="l01509"></a>01509   <span class="comment">// space to allow for every element to be refined.</span>
<a name="l01510"></a>01510   std::vector&lt;Elem*&gt; local_copy_of_elements;
<a name="l01511"></a>01511   local_copy_of_elements.reserve(n_elems_flagged);
<a name="l01512"></a>01512 
<a name="l01513"></a>01513   <span class="comment">// Iterate over the elements, looking for elements</span>
<a name="l01514"></a>01514   <span class="comment">// flagged for refinement.</span>
<a name="l01515"></a>01515   <span class="keywordflow">for</span> (it = <a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#ac266e1f5eb6ac9566ccbd7e6add6c239">elements_begin</a>(); it != end; ++it)
<a name="l01516"></a>01516     {
<a name="l01517"></a>01517       <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = *it;
<a name="l01518"></a>01518       <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a174bfe5b3d22e2b79000bfc816f633e6">refinement_flag</a>() == <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a1511a7045e9a76eaa3b5b0f9511dd01b">Elem::REFINE</a>)
<a name="l01519"></a>01519         local_copy_of_elements.push_back(elem);
<a name="l01520"></a>01520       <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a53a98cf29aef9af6292c812d7b905c18">p_refinement_flag</a>() == <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a1511a7045e9a76eaa3b5b0f9511dd01b">Elem::REFINE</a> &amp;&amp;
<a name="l01521"></a>01521           elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ab426ef9274eb93de879fef28b027d602">active</a>())
<a name="l01522"></a>01522         {
<a name="l01523"></a>01523           elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#af1f504a628c96ad2d9e49cff16d69bca">set_p_level</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>()+1);
<a name="l01524"></a>01524           elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a13716b8bb2b92fa2244f6f4f375a0004">set_p_refinement_flag</a>(<a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a6fb8f2a3f8b6cc1a569263dbc1f1c5cf">Elem::JUST_REFINED</a>);
<a name="l01525"></a>01525         }
<a name="l01526"></a>01526     }
<a name="l01527"></a>01527 
<a name="l01528"></a>01528   <span class="comment">// Now iterate over the local copies and refine each one.</span>
<a name="l01529"></a>01529   <span class="comment">// This may resize the mesh&#39;s internal container and invalidate</span>
<a name="l01530"></a>01530   <span class="comment">// any existing iterators.</span>
<a name="l01531"></a>01531   
<a name="l01532"></a>01532   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e = 0; e != local_copy_of_elements.size(); ++e)
<a name="l01533"></a>01533     local_copy_of_elements[e]-&gt;refine(*<span class="keyword">this</span>);
<a name="l01534"></a>01534 
<a name="l01535"></a>01535   <span class="comment">// The mesh changed if there were elements h refined</span>
<a name="l01536"></a>01536   <span class="keywordtype">bool</span> mesh_changed = !local_copy_of_elements.empty();
<a name="l01537"></a>01537 
<a name="l01538"></a>01538   <span class="comment">// If the mesh changed on any processor, it changed globally</span>
<a name="l01539"></a>01539   <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">Parallel::max</a>(mesh_changed);
<a name="l01540"></a>01540 
<a name="l01541"></a>01541   <span class="comment">// And we may need to update ParallelMesh values reflecting the changes</span>
<a name="l01542"></a>01542   <span class="keywordflow">if</span> (mesh_changed)
<a name="l01543"></a>01543     <a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#ae10a5f947142866d4a1c1409973b1582">update_parallel_id_counts</a>();
<a name="l01544"></a>01544 
<a name="l01545"></a>01545   <span class="keywordflow">if</span> (mesh_changed &amp;&amp; !<a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a3c7d22fed3feea4c9ebd1fb41e7dbb4f">is_serial</a>())
<a name="l01546"></a>01546     {
<a name="l01547"></a>01547       <a class="code" href="classlibMesh_1_1MeshCommunication.php">MeshCommunication</a>().<a class="code" href="classlibMesh_1_1MeshCommunication.php#a737da6ee13b781ac7aef37851a99af58">make_elems_parallel_consistent</a> (<a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>);
<a name="l01548"></a>01548       <a class="code" href="classlibMesh_1_1MeshCommunication.php">MeshCommunication</a>().<a class="code" href="classlibMesh_1_1MeshCommunication.php#a4267fefd3ddfeead0f25be8fb9918af8">make_nodes_parallel_consistent</a>
<a name="l01549"></a>01549         (<a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>, <a class="code" href="classlibMesh_1_1MeshRefinement.php#a0b34a1599da3a45c2d0eed3e19c38574">_new_nodes_map</a>);
<a name="l01550"></a>01550 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l01551"></a>01551 <span class="preprocessor"></span>      <a class="code" href="classlibMesh_1_1ParallelMesh.php">ParallelMesh</a> *pmesh = <span class="keyword">dynamic_cast&lt;</span><a class="code" href="classlibMesh_1_1ParallelMesh.php">ParallelMesh</a> *<span class="keyword">&gt;</span>(&amp;<a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>);
<a name="l01552"></a>01552       <span class="keywordflow">if</span> (pmesh)
<a name="l01553"></a>01553         pmesh-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#a71de7cc0384ce24b982c49b2276478b3">libmesh_assert_valid_parallel_ids</a>();
<a name="l01554"></a>01554 <span class="preprocessor">#endif</span>
<a name="l01555"></a>01555 <span class="preprocessor"></span>    }
<a name="l01556"></a>01556   
<a name="l01557"></a>01557   <span class="comment">// Clear the _new_nodes_map and _unused_elements data structures.</span>
<a name="l01558"></a>01558   this-&gt;<a class="code" href="classlibMesh_1_1MeshRefinement.php#ac64e4f1afa4af23fe11997dfbeae071b">clear</a>();
<a name="l01559"></a>01559   
<a name="l01560"></a>01560   STOP_LOG (<span class="stringliteral">&quot;_refine_elements()&quot;</span>, <span class="stringliteral">&quot;MeshRefinement&quot;</span>);
<a name="l01561"></a>01561 
<a name="l01562"></a>01562   <span class="keywordflow">return</span> mesh_changed;
<a name="l01563"></a>01563 }
<a name="l01564"></a>01564 
<a name="l01565"></a>01565 
<a name="l01566"></a>01566 
<a name="l01567"></a><a class="code" href="classlibMesh_1_1MeshRefinement.php#ac8b117eccc68c96f20c0c0b4045303e8">01567</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshRefinement.php#ac8b117eccc68c96f20c0c0b4045303e8">MeshRefinement::uniformly_p_refine</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n)
<a name="l01568"></a>01568 {
<a name="l01569"></a>01569   <span class="comment">// Refine n times</span>
<a name="l01570"></a>01570   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> rstep=0; rstep&lt;n; rstep++)
<a name="l01571"></a>01571     {
<a name="l01572"></a>01572       <span class="comment">// P refine all the active elements</span>
<a name="l01573"></a>01573       <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       elem_it  = <a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#aefa4ded9eaf654a45ab593a0963ecbf3">active_elements_begin</a>();
<a name="l01574"></a>01574       <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> elem_end = <a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#ae3f09f1b7556aef88919249861728e23">active_elements_end</a>(); 
<a name="l01575"></a>01575 
<a name="l01576"></a>01576       <span class="keywordflow">for</span> ( ; elem_it != elem_end; ++elem_it)
<a name="l01577"></a>01577         {
<a name="l01578"></a>01578           (*elem_it)-&gt;set_p_level((*elem_it)-&gt;p_level()+1);
<a name="l01579"></a>01579           (*elem_it)-&gt;set_p_refinement_flag(<a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a6fb8f2a3f8b6cc1a569263dbc1f1c5cf">Elem::JUST_REFINED</a>);
<a name="l01580"></a>01580         }
<a name="l01581"></a>01581     }
<a name="l01582"></a>01582 }
<a name="l01583"></a>01583 
<a name="l01584"></a>01584 
<a name="l01585"></a>01585 
<a name="l01586"></a><a class="code" href="classlibMesh_1_1MeshRefinement.php#a19810e55f1ba17b88aa665e8c31cb5a2">01586</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshRefinement.php#a19810e55f1ba17b88aa665e8c31cb5a2">MeshRefinement::uniformly_p_coarsen</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n)
<a name="l01587"></a>01587 {
<a name="l01588"></a>01588   <span class="comment">// Coarsen p times</span>
<a name="l01589"></a>01589   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> rstep=0; rstep&lt;n; rstep++)
<a name="l01590"></a>01590     {
<a name="l01591"></a>01591       <span class="comment">// P coarsen all the active elements</span>
<a name="l01592"></a>01592       <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       elem_it  = <a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#aefa4ded9eaf654a45ab593a0963ecbf3">active_elements_begin</a>();
<a name="l01593"></a>01593       <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> elem_end = <a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#ae3f09f1b7556aef88919249861728e23">active_elements_end</a>(); 
<a name="l01594"></a>01594 
<a name="l01595"></a>01595       <span class="keywordflow">for</span> ( ; elem_it != elem_end; ++elem_it)
<a name="l01596"></a>01596         {
<a name="l01597"></a>01597           <span class="keywordflow">if</span> ((*elem_it)-&gt;p_level() &gt; 0)
<a name="l01598"></a>01598             {
<a name="l01599"></a>01599               (*elem_it)-&gt;set_p_level((*elem_it)-&gt;p_level()-1);
<a name="l01600"></a>01600               (*elem_it)-&gt;set_p_refinement_flag(<a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54adec28448bd3f7297806b7d58e9625240">Elem::JUST_COARSENED</a>);
<a name="l01601"></a>01601             }
<a name="l01602"></a>01602         }
<a name="l01603"></a>01603     }
<a name="l01604"></a>01604 }
<a name="l01605"></a>01605 
<a name="l01606"></a>01606 
<a name="l01607"></a>01607 
<a name="l01608"></a><a class="code" href="classlibMesh_1_1MeshRefinement.php#a406e53c22bd8c9e2cefa862ef02f226f">01608</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshRefinement.php#a406e53c22bd8c9e2cefa862ef02f226f">MeshRefinement::uniformly_refine</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n)
<a name="l01609"></a>01609 {
<a name="l01610"></a>01610   <span class="comment">// Refine n times</span>
<a name="l01611"></a>01611   <span class="comment">// FIXME - this won&#39;t work if n&gt;1 and the mesh </span>
<a name="l01612"></a>01612   <span class="comment">// has already been attached to an equation system</span>
<a name="l01613"></a>01613   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> rstep=0; rstep&lt;n; rstep++)
<a name="l01614"></a>01614     {
<a name="l01615"></a>01615       <span class="comment">// Clean up the refinement flags</span>
<a name="l01616"></a>01616       this-&gt;<a class="code" href="classlibMesh_1_1MeshRefinement.php#a6930cd279030a81ff6d36a40809b1fd8">clean_refinement_flags</a>();
<a name="l01617"></a>01617       
<a name="l01618"></a>01618       <span class="comment">// Flag all the active elements for refinement.       </span>
<a name="l01619"></a>01619       <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       elem_it  = <a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#aefa4ded9eaf654a45ab593a0963ecbf3">active_elements_begin</a>();
<a name="l01620"></a>01620       <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> elem_end = <a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#ae3f09f1b7556aef88919249861728e23">active_elements_end</a>(); 
<a name="l01621"></a>01621 
<a name="l01622"></a>01622       <span class="keywordflow">for</span> ( ; elem_it != elem_end; ++elem_it)
<a name="l01623"></a>01623         (*elem_it)-&gt;set_refinement_flag(<a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a1511a7045e9a76eaa3b5b0f9511dd01b">Elem::REFINE</a>);
<a name="l01624"></a>01624 
<a name="l01625"></a>01625       <span class="comment">// Refine all the elements we just flagged.</span>
<a name="l01626"></a>01626       this-&gt;<a class="code" href="classlibMesh_1_1MeshRefinement.php#ad794507aa1e1908fea6fb373dd31c548">_refine_elements</a>();
<a name="l01627"></a>01627     }
<a name="l01628"></a>01628   
<a name="l01629"></a>01629   <span class="comment">// Finally, the new mesh needs to be prepared for use</span>
<a name="l01630"></a>01630   <a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a9805f1c4efa5d61188c582e58ed66a79">prepare_for_use</a> (<span class="comment">/*skip_renumber =*/</span><span class="keyword">false</span>);
<a name="l01631"></a>01631 }
<a name="l01632"></a>01632 
<a name="l01633"></a>01633 
<a name="l01634"></a>01634 
<a name="l01635"></a><a class="code" href="classlibMesh_1_1MeshRefinement.php#a0c090a5a22834d33fa0d436fbccab795">01635</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshRefinement.php#a0c090a5a22834d33fa0d436fbccab795">MeshRefinement::uniformly_coarsen</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n)
<a name="l01636"></a>01636 {
<a name="l01637"></a>01637   <span class="comment">// Coarsen n times</span>
<a name="l01638"></a>01638   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> rstep=0; rstep&lt;n; rstep++)
<a name="l01639"></a>01639     {
<a name="l01640"></a>01640       <span class="comment">// Clean up the refinement flags</span>
<a name="l01641"></a>01641       this-&gt;<a class="code" href="classlibMesh_1_1MeshRefinement.php#a6930cd279030a81ff6d36a40809b1fd8">clean_refinement_flags</a>();
<a name="l01642"></a>01642       
<a name="l01643"></a>01643       <span class="comment">// Flag all the active elements for coarsening</span>
<a name="l01644"></a>01644       <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       elem_it  = <a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#aefa4ded9eaf654a45ab593a0963ecbf3">active_elements_begin</a>();
<a name="l01645"></a>01645       <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> elem_end = <a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#ae3f09f1b7556aef88919249861728e23">active_elements_end</a>(); 
<a name="l01646"></a>01646 
<a name="l01647"></a>01647       <span class="keywordflow">for</span> ( ; elem_it != elem_end; ++elem_it)
<a name="l01648"></a>01648         {
<a name="l01649"></a>01649           (*elem_it)-&gt;set_refinement_flag(<a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a7d9c31942b061618643ecf815f74dd2c">Elem::COARSEN</a>);
<a name="l01650"></a>01650           <span class="keywordflow">if</span> ((*elem_it)-&gt;parent()) 
<a name="l01651"></a>01651             (*elem_it)-&gt;parent()-&gt;set_refinement_flag(<a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a560ee64b3c009f94569a135dce55c8b6">Elem::COARSEN_INACTIVE</a>);
<a name="l01652"></a>01652         }
<a name="l01653"></a>01653 
<a name="l01654"></a>01654       <span class="comment">// Coarsen all the elements we just flagged.</span>
<a name="l01655"></a>01655       this-&gt;<a class="code" href="classlibMesh_1_1MeshRefinement.php#a46ef7ebd80c846f24998ef0f222c55e1">_coarsen_elements</a>();
<a name="l01656"></a>01656     }
<a name="l01657"></a>01657     
<a name="l01658"></a>01658   
<a name="l01659"></a>01659   <span class="comment">// Finally, the new mesh needs to be prepared for use</span>
<a name="l01660"></a>01660   <a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a9805f1c4efa5d61188c582e58ed66a79">prepare_for_use</a> (<span class="comment">/*skip_renumber =*/</span><span class="keyword">false</span>);
<a name="l01661"></a>01661 }
<a name="l01662"></a>01662 
<a name="l01663"></a>01663 } <span class="comment">// namespace libMesh</span>
<a name="l01664"></a>01664 
<a name="l01665"></a>01665 
<a name="l01666"></a>01666 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
