<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_c3a49989e40b21e7508f29d2dc962def.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_94af86d0ee7ff5a2af0627e1a0ea6efa.php">systems</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">qn_transient_rb_system.C</div>  </div>
</div>
<div class="contents">
<a href="qn__transient__rb__system_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// rbOOmit: An implementation of the Certified Reduced Basis method.</span>
<a name="l00002"></a>00002 <span class="comment">// Copyright (C) 2009, 2010 David J. Knezevic</span>
<a name="l00003"></a>00003 
<a name="l00004"></a>00004 <span class="comment">// This file is part of rbOOmit.</span>
<a name="l00005"></a>00005 
<a name="l00006"></a>00006 <span class="comment">// rbOOmit is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// rbOOmit is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="comment">// Configuration data</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>&quot;</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="comment">// This class requires QNTransientSCMSystem, which is not</span>
<a name="l00025"></a>00025 <span class="comment">// defined if SLEPc is not present.</span>
<a name="l00026"></a>00026 <span class="preprocessor">#if defined(LIBMESH_HAVE_SLEPC) &amp;&amp; (LIBMESH_HAVE_GLPK)</span>
<a name="l00027"></a>00027 <span class="preprocessor"></span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="qn__transient__rb__system_8h.php">qn_transient_rb_system.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="qn__transient__rb__context_8h.php">qn_transient_rb_context.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="qn__transient__scm__system_8h.php">qn_transient_scm_system.h</a>&quot;</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="equation__systems_8h.php">equation_systems.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="numeric__vector_8h.php">numeric_vector.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__logging_8h.php">libmesh_logging.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="dof__map_8h.php">dof_map.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="sparse__matrix_8h.php">sparse_matrix.h</a>&quot;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;<a class="code" href="dense__matrix_8h.php">dense_matrix.h</a>&quot;</span>
<a name="l00038"></a>00038 <span class="preprocessor">#include &quot;<a class="code" href="dense__vector_8h.php">dense_vector.h</a>&quot;</span>
<a name="l00039"></a>00039 <span class="preprocessor">#include &quot;<a class="code" href="gmv__io_8h.php">gmv_io.h</a>&quot;</span>
<a name="l00040"></a>00040 <span class="preprocessor">#include &quot;<a class="code" href="linear__solver_8h.php">linear_solver.h</a>&quot;</span>
<a name="l00041"></a>00041 <span class="preprocessor">#include &quot;<a class="code" href="getpot_8h.php">getpot.h</a>&quot;</span>
<a name="l00042"></a>00042 <span class="preprocessor">#include &quot;<a class="code" href="timestamp_8h.php">timestamp.h</a>&quot;</span>
<a name="l00043"></a>00043 <span class="preprocessor">#include &quot;<a class="code" href="xdr__cxx_8h.php">xdr_cxx.h</a>&quot;</span>
<a name="l00044"></a>00044 <span class="preprocessor">#include &quot;<a class="code" href="parallel_8h.php">parallel.h</a>&quot;</span>
<a name="l00045"></a>00045 
<a name="l00046"></a>00046 <span class="comment">// For checking for the existence of files</span>
<a name="l00047"></a>00047 <span class="preprocessor">#include &lt;sys/stat.h&gt;</span>
<a name="l00048"></a>00048 
<a name="l00049"></a>00049 <span class="keyword">namespace </span>libMesh
<a name="l00050"></a>00050 {
<a name="l00051"></a>00051 
<a name="l00052"></a><a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a7e0918f4925e284afdbe935ad56c0615">00052</a> <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a7e0918f4925e284afdbe935ad56c0615">QNTransientRBSystem::QNTransientRBSystem</a> (<a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00053"></a>00053                                           <span class="keyword">const</span> std::string&amp; <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>,
<a name="l00054"></a>00054                                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> number)
<a name="l00055"></a>00055   : <a class="code" href="classlibMesh_1_1System.php">Parent</a>(es, name, number),
<a name="l00056"></a>00056     current_newton_iterate(<a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector</a>&lt;<a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a>&gt;::build()),
<a name="l00057"></a>00057     use_nominal_rho_LB(true),
<a name="l00058"></a>00058     nonlinear_tolerance(1.e-8),
<a name="l00059"></a>00059     n_newton_steps(15),
<a name="l00060"></a>00060     use_eisenstat(false),
<a name="l00061"></a>00061     eisenstat_eta0(0.01),
<a name="l00062"></a>00062     eisenstat_gamma(0.9),
<a name="l00063"></a>00063     eisenstat_alpha(2.),
<a name="l00064"></a>00064     C_assembly(NULL),
<a name="l00065"></a>00065     truth_intrr_assembly(NULL),
<a name="l00066"></a>00066     truth_bndry_assembly(NULL)
<a name="l00067"></a>00067 {
<a name="l00068"></a>00068 }
<a name="l00069"></a>00069 
<a name="l00070"></a><a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a6fbff9110eebd538cca2b5680639a9bb">00070</a> <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a6fbff9110eebd538cca2b5680639a9bb">QNTransientRBSystem::~QNTransientRBSystem</a> ()
<a name="l00071"></a>00071 {
<a name="l00072"></a>00072   this-&gt;<a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a85fcde0fb3099dd206cefa44155efcd6">clear</a>();
<a name="l00073"></a>00073 }
<a name="l00074"></a>00074 
<a name="l00075"></a><a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a85fcde0fb3099dd206cefa44155efcd6">00075</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a85fcde0fb3099dd206cefa44155efcd6">QNTransientRBSystem::clear</a>()
<a name="l00076"></a>00076 {
<a name="l00077"></a>00077   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a7fd1249de92ea775b87fc6c26a193eb5">Parent::clear</a>();
<a name="l00078"></a>00078 
<a name="l00079"></a>00079   <span class="comment">// Don&#39;t need to call clear_basis_function_dependent_data</span>
<a name="l00080"></a>00080   <span class="comment">// since that just clears matrices/vectors, but we need</span>
<a name="l00081"></a>00081   <span class="comment">// to free the memory.</span>
<a name="l00082"></a>00082   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;<a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a6befde9564b470c5908912bb7258e726">C_n_vector</a>.size(); n++)
<a name="l00083"></a>00083   {
<a name="l00084"></a>00084     <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a6befde9564b470c5908912bb7258e726">C_n_vector</a>[n])
<a name="l00085"></a>00085     {
<a name="l00086"></a>00086       <span class="keyword">delete</span> <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a6befde9564b470c5908912bb7258e726">C_n_vector</a>[n];
<a name="l00087"></a>00087       <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a6befde9564b470c5908912bb7258e726">C_n_vector</a>[n] = NULL;
<a name="l00088"></a>00088     }
<a name="l00089"></a>00089   }
<a name="l00090"></a>00090 
<a name="l00091"></a>00091   <span class="comment">// Delete the Nmax^2 representors</span>
<a name="l00092"></a>00092   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#aad10b1ffeb99e8261e99892ce0d209e5">C_representor</a>.size(); i++)
<a name="l00093"></a>00093   {
<a name="l00094"></a>00094     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;<a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#aad10b1ffeb99e8261e99892ce0d209e5">C_representor</a>[i].size(); j++)
<a name="l00095"></a>00095     {
<a name="l00096"></a>00096       <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#aad10b1ffeb99e8261e99892ce0d209e5">C_representor</a>[i][j])
<a name="l00097"></a>00097       {
<a name="l00098"></a>00098         <span class="keyword">delete</span> <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#aad10b1ffeb99e8261e99892ce0d209e5">C_representor</a>[i][j];
<a name="l00099"></a>00099         <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#aad10b1ffeb99e8261e99892ce0d209e5">C_representor</a>[i][j] = NULL;
<a name="l00100"></a>00100       }
<a name="l00101"></a>00101     }
<a name="l00102"></a>00102   }
<a name="l00103"></a>00103 
<a name="l00104"></a>00104 }
<a name="l00105"></a>00105 
<a name="l00106"></a><a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a8fca7a0caa100a307367d3f9d70728a0">00106</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a8fca7a0caa100a307367d3f9d70728a0">QNTransientRBSystem::clear_basis_function_dependent_data</a>()
<a name="l00107"></a>00107 {
<a name="l00108"></a>00108   <span class="comment">// Clear the vector storing the C_n matrices</span>
<a name="l00109"></a>00109   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;<a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a6befde9564b470c5908912bb7258e726">C_n_vector</a>.size(); n++)
<a name="l00110"></a>00110   {
<a name="l00111"></a>00111     <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a6befde9564b470c5908912bb7258e726">C_n_vector</a>[n])
<a name="l00112"></a>00112     {
<a name="l00113"></a>00113       <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a6befde9564b470c5908912bb7258e726">C_n_vector</a>[n]-&gt;clear();
<a name="l00114"></a>00114       <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a6befde9564b470c5908912bb7258e726">C_n_vector</a>[n]-&gt;init();
<a name="l00115"></a>00115     }
<a name="l00116"></a>00116   }
<a name="l00117"></a>00117 
<a name="l00118"></a>00118   <span class="comment">// Delete the Nmax^2 representors</span>
<a name="l00119"></a>00119   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#aad10b1ffeb99e8261e99892ce0d209e5">C_representor</a>.size(); i++)
<a name="l00120"></a>00120   {
<a name="l00121"></a>00121     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;<a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#aad10b1ffeb99e8261e99892ce0d209e5">C_representor</a>[i].size(); j++)
<a name="l00122"></a>00122     {
<a name="l00123"></a>00123       <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#aad10b1ffeb99e8261e99892ce0d209e5">C_representor</a>[i][j])
<a name="l00124"></a>00124       {
<a name="l00125"></a>00125         <span class="comment">// Need to NULL this out so that it gets reinitialized properly</span>
<a name="l00126"></a>00126         <span class="keyword">delete</span> <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#aad10b1ffeb99e8261e99892ce0d209e5">C_representor</a>[i][j];
<a name="l00127"></a>00127         <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#aad10b1ffeb99e8261e99892ce0d209e5">C_representor</a>[i][j] = NULL;
<a name="l00128"></a>00128       }
<a name="l00129"></a>00129     }
<a name="l00130"></a>00130   }
<a name="l00131"></a>00131 
<a name="l00132"></a>00132   <span class="comment">// Also, need to zero RB_trilinear_form and the representor norms.</span>
<a name="l00133"></a>00133   <span class="comment">// Do this _before_ calling Parent::clear_basis_function_dependent_data()</span>
<a name="l00134"></a>00134   <span class="comment">// since we rely on RB_size.</span>
<a name="l00135"></a>00135   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> RB_size = <a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>();
<a name="l00136"></a>00136   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;RB_size; n++)
<a name="l00137"></a>00137     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;RB_size; j++)
<a name="l00138"></a>00138       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;RB_size; i++)
<a name="l00139"></a>00139         <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a6d593306c3c2c3ddede6a33b0943e7c4">RB_trilinear_form</a>[n][i][j] = 0.;
<a name="l00140"></a>00140 
<a name="l00141"></a>00141   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_f=0; q_f&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>(); q_f++)
<a name="l00142"></a>00142     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n1=0; n1&lt;RB_size; n1++)
<a name="l00143"></a>00143       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j1=0; j1&lt;RB_size; j1++)
<a name="l00144"></a>00144         <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#adb9ca8229335af78caf0b47b83285254">Fq_C_representor_norms</a>[q_f][n1][j1] = 0.;
<a name="l00145"></a>00145 
<a name="l00146"></a>00146   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_m=0; q_m&lt;<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>(); q_m++)
<a name="l00147"></a>00147     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;RB_size; i++)
<a name="l00148"></a>00148       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n1=0; n1&lt;RB_size; n1++)
<a name="l00149"></a>00149         <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j1=0; j1&lt;RB_size; j1++)
<a name="l00150"></a>00150           <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a39a9f2064c99ea89337c13afa0d59211">Mq_C_representor_norms</a>[q_m][i][n1][j1] = 0.;
<a name="l00151"></a>00151 
<a name="l00152"></a>00152   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_a=0; q_a&lt;<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>(); q_a++)
<a name="l00153"></a>00153     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;RB_size; i++)
<a name="l00154"></a>00154       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n1=0; n1&lt;RB_size; n1++)
<a name="l00155"></a>00155         <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j1=0; j1&lt;RB_size; j1++)
<a name="l00156"></a>00156           <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#aa148f5aef2298825abbe912e80d6f3b7">Aq_C_representor_norms</a>[q_a][i][n1][j1] = 0.;
<a name="l00157"></a>00157 
<a name="l00158"></a>00158   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n1=0; n1&lt;RB_size; n1++)
<a name="l00159"></a>00159     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j1=0; j1&lt;RB_size; j1++)
<a name="l00160"></a>00160       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n2=0; n2&lt;RB_size; n2++)
<a name="l00161"></a>00161         <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j2=0; j2&lt;RB_size; j2++)
<a name="l00162"></a>00162           <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a626bab2fd06b6ac9e5498c9ad3098c98">C_C_representor_norms</a>[n1][j1][n2][j2] = 0.;
<a name="l00163"></a>00163 
<a name="l00164"></a>00164   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ac3af79dab200ccbb0c13ec4ee2343720">Parent::clear_basis_function_dependent_data</a>();
<a name="l00165"></a>00165 }
<a name="l00166"></a>00166 
<a name="l00167"></a><a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a173e7f3adc83c98812712d1bb9238d35">00167</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a173e7f3adc83c98812712d1bb9238d35">QNTransientRBSystem::init_data</a> ()
<a name="l00168"></a>00168 {
<a name="l00169"></a>00169   <span class="comment">// Call the Parent&#39;s initialization routine.</span>
<a name="l00170"></a>00170   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#aaff3a14e0f537aac7289e14239c0f3e5">Parent::init_data</a>();
<a name="l00171"></a>00171 
<a name="l00172"></a>00172   <span class="comment">// Read in data from parameters_filename</span>
<a name="l00173"></a>00173   GetPot infile(<a class="code" href="classlibMesh_1_1RBSystem.php#a3aa3cce2414d86488881e1bbe4adcd00">parameters_filename</a>);
<a name="l00174"></a>00174 
<a name="l00175"></a>00175   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> nonlinear_tolerance_in    = infile(<span class="stringliteral">&quot;nonlinear_tolerance&quot;</span>,
<a name="l00176"></a>00176                                                 <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#abd9e16b48c18c57baeed6ac2a0c3cffa">nonlinear_tolerance</a>);
<a name="l00177"></a>00177   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_newton_steps_in = infile(<span class="stringliteral">&quot;n_newton_steps&quot;</span>,
<a name="l00178"></a>00178                                                 <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a6898b18e56f0ef28ce3e2b33c6e6ac95">n_newton_steps</a>);
<a name="l00179"></a>00179 
<a name="l00180"></a>00180   <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a732c03317f867080093e900f2090ee2f">set_nonlinear_tolerance</a>(nonlinear_tolerance_in);
<a name="l00181"></a>00181   <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#afe274a988404c86e43287fd9dd7a2800">set_n_newton_steps</a>(n_newton_steps_in);
<a name="l00182"></a>00182 
<a name="l00183"></a>00183   <span class="comment">// Read in and set Eisenstat formula parameters</span>
<a name="l00184"></a>00184   <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a6560d33a85365fd45ef4d9cd54e8e120">use_eisenstat</a> = infile(<span class="stringliteral">&quot;use_eisenstat&quot;</span>, <span class="keyword">false</span>);
<a name="l00185"></a>00185   <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a8981c27ff565fd5434de91db6b758221">eisenstat_eta0</a> = infile(<span class="stringliteral">&quot;eisenstat_eta0&quot;</span>, 0.01);
<a name="l00186"></a>00186   <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a779aa4c52fff79bd12b8ead2cd650a1b">eisenstat_gamma</a> = infile(<span class="stringliteral">&quot;eisenstat_gamma&quot;</span>, 0.9);
<a name="l00187"></a>00187   <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a53d4512a39a08fdf383a398b2cde1cf4">eisenstat_alpha</a> = infile(<span class="stringliteral">&quot;eisenstat_alpha&quot;</span>, 2.);
<a name="l00188"></a>00188   
<a name="l00189"></a>00189   <span class="comment">// By default we enforce constraints exactly in the nonlinear case</span>
<a name="l00190"></a>00190   <a class="code" href="classlibMesh_1_1RBSystem.php#a185d55184fb6f7c1705066908d642319">enforce_constraints_exactly</a> = <span class="keyword">true</span>;
<a name="l00191"></a>00191 
<a name="l00192"></a>00192   <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; std::endl &lt;&lt; <span class="stringliteral">&quot;QNTransientRBSystem parameters:&quot;</span> &lt;&lt; std::endl;
<a name="l00193"></a>00193   <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Nonlinear tolerance: &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#abd9e16b48c18c57baeed6ac2a0c3cffa">nonlinear_tolerance</a> &lt;&lt; std::endl;
<a name="l00194"></a>00194   <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Maximum number of Newton steps: &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a6898b18e56f0ef28ce3e2b33c6e6ac95">n_newton_steps</a> &lt;&lt; std::endl;
<a name="l00195"></a>00195   <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; std::endl;
<a name="l00196"></a>00196 }
<a name="l00197"></a>00197 
<a name="l00198"></a><a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a56981c8a6972d63d6926a4e7cc902072">00198</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a56981c8a6972d63d6926a4e7cc902072">QNTransientRBSystem::initialize_RB_system</a>(<span class="keywordtype">bool</span> online_mode)
<a name="l00199"></a>00199 {
<a name="l00200"></a>00200 
<a name="l00201"></a>00201   <span class="comment">// Resize C_n_vector</span>
<a name="l00202"></a>00202   <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a6befde9564b470c5908912bb7258e726">C_n_vector</a>.resize(<a class="code" href="classlibMesh_1_1RBSystem.php#ab47d6a963c4f68b5a3d1eea7905257f5">Nmax</a>);
<a name="l00203"></a>00203 
<a name="l00204"></a>00204   <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#aad10b1ffeb99e8261e99892ce0d209e5">C_representor</a>.resize(<a class="code" href="classlibMesh_1_1RBSystem.php#ab47d6a963c4f68b5a3d1eea7905257f5">Nmax</a>);
<a name="l00205"></a>00205   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#ab47d6a963c4f68b5a3d1eea7905257f5">Nmax</a>; i++)
<a name="l00206"></a>00206   {
<a name="l00207"></a>00207     <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#aad10b1ffeb99e8261e99892ce0d209e5">C_representor</a>[i].resize(Nmax);
<a name="l00208"></a>00208     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#ab47d6a963c4f68b5a3d1eea7905257f5">Nmax</a>; j++)
<a name="l00209"></a>00209     {
<a name="l00210"></a>00210       <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#aad10b1ffeb99e8261e99892ce0d209e5">C_representor</a>[i][j] = NULL;
<a name="l00211"></a>00211     }
<a name="l00212"></a>00212   }
<a name="l00213"></a>00213 
<a name="l00214"></a>00214   <span class="comment">// Optionally initialize the calN dependent data structures</span>
<a name="l00215"></a>00215   <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBBase.php#a11c4b80a15c0e9ea1d822f5e04545059">initialize_calN_dependent_data</a>)
<a name="l00216"></a>00216   {
<a name="l00217"></a>00217     <a class="code" href="classlibMesh_1_1DofMap.php">DofMap</a>&amp; dof_map = this-&gt;<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>();
<a name="l00218"></a>00218 
<a name="l00219"></a>00219     <span class="comment">// Initialize current_newton_iterate</span>
<a name="l00220"></a>00220     <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#acb60710609da05611e7d440eb79a66ff">current_newton_iterate</a>-&gt;init (this-&gt;<a class="code" href="classlibMesh_1_1System.php#a90dbb901f00c14ff18399f4afabcebe5">n_dofs</a>(), this-&gt;<a class="code" href="classlibMesh_1_1System.php#ae3aeb82e65b06789823d41da3c5df7a2">n_local_dofs</a>(),
<a name="l00221"></a>00221                                   dof_map.<a class="code" href="classlibMesh_1_1DofMap.php#a4e0a6909796bc3c19ca543a182ffe224">get_send_list</a>(), <span class="keyword">false</span>,
<a name="l00222"></a>00222                                   <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa9f12475bbe90a64ad167ec0b856ca6c1">GHOSTED</a>);
<a name="l00223"></a>00223 
<a name="l00224"></a>00224     <span class="comment">// If we&#39;re not in low memory mode, initialize the memory for the C_n matrices</span>
<a name="l00225"></a>00225     <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a>)
<a name="l00226"></a>00226       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#ab47d6a963c4f68b5a3d1eea7905257f5">Nmax</a>; n++)
<a name="l00227"></a>00227       {
<a name="l00228"></a>00228         <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a6befde9564b470c5908912bb7258e726">C_n_vector</a>[n] = <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;Number&gt;::build</a>().release();
<a name="l00229"></a>00229         dof_map.<a class="code" href="classlibMesh_1_1DofMap.php#aa10200782a0f8fe0c4d3f7bdf10cedc6">attach_matrix</a>(*<a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a6befde9564b470c5908912bb7258e726">C_n_vector</a>[n]);
<a name="l00230"></a>00230 
<a name="l00231"></a>00231         <span class="comment">// Initialize and zero the C_n matrices</span>
<a name="l00232"></a>00232         <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a6befde9564b470c5908912bb7258e726">C_n_vector</a>[n]-&gt;init();
<a name="l00233"></a>00233       }
<a name="l00234"></a>00234   }
<a name="l00235"></a>00235   
<a name="l00236"></a>00236   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae532258d3c072f941052e4e999665070">Parent::initialize_RB_system</a>(online_mode);
<a name="l00237"></a>00237 
<a name="l00238"></a>00238   <span class="comment">// Initialize the N (i.e. RB) dependent data structures</span>
<a name="l00239"></a>00239 
<a name="l00240"></a>00240   <span class="comment">// Resize the RB trilinear form</span>
<a name="l00241"></a>00241   <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a6d593306c3c2c3ddede6a33b0943e7c4">RB_trilinear_form</a>.resize(Nmax);
<a name="l00242"></a>00242   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#ab47d6a963c4f68b5a3d1eea7905257f5">Nmax</a>; i++)
<a name="l00243"></a>00243   {
<a name="l00244"></a>00244     <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a6d593306c3c2c3ddede6a33b0943e7c4">RB_trilinear_form</a>[i].resize(Nmax);
<a name="l00245"></a>00245     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#ab47d6a963c4f68b5a3d1eea7905257f5">Nmax</a>; j++)
<a name="l00246"></a>00246     {
<a name="l00247"></a>00247       <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a6d593306c3c2c3ddede6a33b0943e7c4">RB_trilinear_form</a>[i][j].resize(Nmax);
<a name="l00248"></a>00248       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> l=0; l&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#ab47d6a963c4f68b5a3d1eea7905257f5">Nmax</a>; l++)
<a name="l00249"></a>00249       {
<a name="l00250"></a>00250         <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a6d593306c3c2c3ddede6a33b0943e7c4">RB_trilinear_form</a>[i][j][l] = 0.;
<a name="l00251"></a>00251       }
<a name="l00252"></a>00252     }
<a name="l00253"></a>00253   }
<a name="l00254"></a>00254 
<a name="l00255"></a>00255 
<a name="l00256"></a>00256   <span class="comment">// Initialize vectors for the norms of the representors</span>
<a name="l00257"></a>00257   <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#adb9ca8229335af78caf0b47b83285254">Fq_C_representor_norms</a>.resize(<a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>());
<a name="l00258"></a>00258   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_f=0; q_f&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>(); q_f++)
<a name="l00259"></a>00259   {
<a name="l00260"></a>00260     <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#adb9ca8229335af78caf0b47b83285254">Fq_C_representor_norms</a>[q_f].resize(Nmax);
<a name="l00261"></a>00261     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n1=0; n1&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#ab47d6a963c4f68b5a3d1eea7905257f5">Nmax</a>; n1++)
<a name="l00262"></a>00262     {
<a name="l00263"></a>00263       <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#adb9ca8229335af78caf0b47b83285254">Fq_C_representor_norms</a>[q_f][n1].resize(Nmax);
<a name="l00264"></a>00264       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j1=0; j1&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#ab47d6a963c4f68b5a3d1eea7905257f5">Nmax</a>; j1++)
<a name="l00265"></a>00265       {
<a name="l00266"></a>00266         <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#adb9ca8229335af78caf0b47b83285254">Fq_C_representor_norms</a>[q_f][n1][j1] = 0.;
<a name="l00267"></a>00267       }
<a name="l00268"></a>00268     }
<a name="l00269"></a>00269   }
<a name="l00270"></a>00270 
<a name="l00271"></a>00271   <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a39a9f2064c99ea89337c13afa0d59211">Mq_C_representor_norms</a>.resize(<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>());
<a name="l00272"></a>00272   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_m=0; q_m&lt;<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>(); q_m++)
<a name="l00273"></a>00273   {
<a name="l00274"></a>00274     <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a39a9f2064c99ea89337c13afa0d59211">Mq_C_representor_norms</a>[q_m].resize(Nmax);
<a name="l00275"></a>00275     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#ab47d6a963c4f68b5a3d1eea7905257f5">Nmax</a>; i++)
<a name="l00276"></a>00276     {
<a name="l00277"></a>00277       <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a39a9f2064c99ea89337c13afa0d59211">Mq_C_representor_norms</a>[q_m][i].resize(Nmax);
<a name="l00278"></a>00278       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n1=0; n1&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#ab47d6a963c4f68b5a3d1eea7905257f5">Nmax</a>; n1++)
<a name="l00279"></a>00279       {
<a name="l00280"></a>00280         <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a39a9f2064c99ea89337c13afa0d59211">Mq_C_representor_norms</a>[q_m][i][n1].resize(Nmax);
<a name="l00281"></a>00281         <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j1=0; j1&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#ab47d6a963c4f68b5a3d1eea7905257f5">Nmax</a>; j1++)
<a name="l00282"></a>00282         {
<a name="l00283"></a>00283           <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a39a9f2064c99ea89337c13afa0d59211">Mq_C_representor_norms</a>[q_m][i][n1][j1] = 0.;
<a name="l00284"></a>00284         }
<a name="l00285"></a>00285       }
<a name="l00286"></a>00286     }
<a name="l00287"></a>00287   }
<a name="l00288"></a>00288 
<a name="l00289"></a>00289   <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#aa148f5aef2298825abbe912e80d6f3b7">Aq_C_representor_norms</a>.resize(<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>());
<a name="l00290"></a>00290   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_a=0; q_a&lt;<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>(); q_a++)
<a name="l00291"></a>00291   {
<a name="l00292"></a>00292     <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#aa148f5aef2298825abbe912e80d6f3b7">Aq_C_representor_norms</a>[q_a].resize(Nmax);
<a name="l00293"></a>00293     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#ab47d6a963c4f68b5a3d1eea7905257f5">Nmax</a>; i++)
<a name="l00294"></a>00294     {
<a name="l00295"></a>00295       <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#aa148f5aef2298825abbe912e80d6f3b7">Aq_C_representor_norms</a>[q_a][i].resize(Nmax);
<a name="l00296"></a>00296       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n1=0; n1&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#ab47d6a963c4f68b5a3d1eea7905257f5">Nmax</a>; n1++)
<a name="l00297"></a>00297       {
<a name="l00298"></a>00298         <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#aa148f5aef2298825abbe912e80d6f3b7">Aq_C_representor_norms</a>[q_a][i][n1].resize(Nmax);
<a name="l00299"></a>00299         <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j1=0; j1&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#ab47d6a963c4f68b5a3d1eea7905257f5">Nmax</a>; j1++)
<a name="l00300"></a>00300         {
<a name="l00301"></a>00301           <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#aa148f5aef2298825abbe912e80d6f3b7">Aq_C_representor_norms</a>[q_a][i][n1][j1] = 0.;
<a name="l00302"></a>00302         }
<a name="l00303"></a>00303       }
<a name="l00304"></a>00304     }
<a name="l00305"></a>00305   }
<a name="l00306"></a>00306 
<a name="l00307"></a>00307   <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a626bab2fd06b6ac9e5498c9ad3098c98">C_C_representor_norms</a>.resize(Nmax);
<a name="l00308"></a>00308   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n1=0; n1&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#ab47d6a963c4f68b5a3d1eea7905257f5">Nmax</a>; n1++)
<a name="l00309"></a>00309   {
<a name="l00310"></a>00310     <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a626bab2fd06b6ac9e5498c9ad3098c98">C_C_representor_norms</a>[n1].resize(Nmax);
<a name="l00311"></a>00311     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j1=0; j1&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#ab47d6a963c4f68b5a3d1eea7905257f5">Nmax</a>; j1++)
<a name="l00312"></a>00312     {
<a name="l00313"></a>00313       <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a626bab2fd06b6ac9e5498c9ad3098c98">C_C_representor_norms</a>[n1][j1].resize(Nmax);
<a name="l00314"></a>00314       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n2=0; n2&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#ab47d6a963c4f68b5a3d1eea7905257f5">Nmax</a>; n2++)
<a name="l00315"></a>00315       {
<a name="l00316"></a>00316         <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a626bab2fd06b6ac9e5498c9ad3098c98">C_C_representor_norms</a>[n1][j1][n2].resize(Nmax);
<a name="l00317"></a>00317         <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j2=0; j2&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#ab47d6a963c4f68b5a3d1eea7905257f5">Nmax</a>; j2++)
<a name="l00318"></a>00318         {
<a name="l00319"></a>00319           <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a626bab2fd06b6ac9e5498c9ad3098c98">C_C_representor_norms</a>[n1][j1][n2][j2] = 0.;
<a name="l00320"></a>00320         }
<a name="l00321"></a>00321       }
<a name="l00322"></a>00322     }
<a name="l00323"></a>00323   }
<a name="l00324"></a>00324 
<a name="l00325"></a>00325 }
<a name="l00326"></a>00326 
<a name="l00327"></a><a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a99cb482521d5c2ee5ba03d3fc5c5fa0d">00327</a> <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;FEMContext&gt;</a> <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a99cb482521d5c2ee5ba03d3fc5c5fa0d">QNTransientRBSystem::build_context</a> ()
<a name="l00328"></a>00328 {
<a name="l00329"></a>00329   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;FEMContext&gt;</a>(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1QNTransientRBContext.php">QNTransientRBContext</a>(*<span class="keyword">this</span>));
<a name="l00330"></a>00330 }
<a name="l00331"></a>00331 
<a name="l00332"></a><a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#aee9ad3841915a8daee375ea3b85a2c20">00332</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#aee9ad3841915a8daee375ea3b85a2c20">QNTransientRBSystem::truth_assembly</a>()
<a name="l00333"></a>00333 {
<a name="l00334"></a>00334   START_LOG(<span class="stringliteral">&quot;truth_assembly()&quot;</span>, <span class="stringliteral">&quot;QNTransientRBSystem&quot;</span>);
<a name="l00335"></a>00335 
<a name="l00336"></a>00336   <span class="comment">// Here we directly assemble the Jacobian and residual for</span>
<a name="l00337"></a>00337   <span class="comment">// the nonlinear system using user-specified assembly functions</span>
<a name="l00338"></a>00338   <span class="comment">// Just call RBSystem::add_scaled_matrix_and_vector</span>
<a name="l00339"></a>00339 
<a name="l00340"></a>00340   <span class="keywordflow">if</span>( (<a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#af3de81b6715f0ff5ea0f1916d5ae90fc">truth_intrr_assembly</a> == NULL) &amp;&amp; (<a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a48e249153e5977052febec98cde4fe64">truth_bndry_assembly</a> == NULL) )
<a name="l00341"></a>00341   {
<a name="l00342"></a>00342     <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Error: Truth assembly not attached to the system.&quot;</span> &lt;&lt; std::endl;
<a name="l00343"></a>00343     libmesh_error();
<a name="l00344"></a>00344   }
<a name="l00345"></a>00345 
<a name="l00346"></a>00346   this-&gt;<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#a966e0a6479f33c2518937e7d0f54602f">zero</a>();
<a name="l00347"></a>00347   this-&gt;<a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a85b3d4a53413e3745e6ecf1c8b96ca65">zero</a>();
<a name="l00348"></a>00348 
<a name="l00349"></a>00349   <a class="code" href="classlibMesh_1_1RBSystem.php#a4a1243f45ea36fbd2a10ad6956c62deb">RBSystem::add_scaled_matrix_and_vector</a>(1., <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#af3de81b6715f0ff5ea0f1916d5ae90fc">truth_intrr_assembly</a>, <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a48e249153e5977052febec98cde4fe64">truth_bndry_assembly</a>,
<a name="l00350"></a>00350                                          this-&gt;<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>, this-&gt;<a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a>);
<a name="l00351"></a>00351 
<a name="l00352"></a>00352   STOP_LOG(<span class="stringliteral">&quot;truth_assembly()&quot;</span>, <span class="stringliteral">&quot;QNTransientRBSystem&quot;</span>);
<a name="l00353"></a>00353 }
<a name="l00354"></a>00354 
<a name="l00355"></a><a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a01234fb8ef324bdc9679e36895c5f5cc">00355</a> <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a01234fb8ef324bdc9679e36895c5f5cc">QNTransientRBSystem::eval_theta_c</a>()
<a name="l00356"></a>00356 {
<a name="l00357"></a>00357   libmesh_assert(<a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a45f28a803b5af2e6c65d386a4b66e0bb">theta_c</a> != NULL);
<a name="l00358"></a>00358 
<a name="l00359"></a>00359   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a45f28a803b5af2e6c65d386a4b66e0bb">theta_c</a>( *<a class="code" href="classlibMesh_1_1RBBase.php#ab2c1a2771ccd818046de826adbe3beb6">theta_data</a> );
<a name="l00360"></a>00360 }
<a name="l00361"></a>00361 
<a name="l00362"></a><a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#ab3d82f282253972001d4a6d6c94cb42b">00362</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#ab3d82f282253972001d4a6d6c94cb42b">QNTransientRBSystem::initialize_truth</a> ()
<a name="l00363"></a>00363 {
<a name="l00364"></a>00364   START_LOG(<span class="stringliteral">&quot;initialize_truth()&quot;</span>, <span class="stringliteral">&quot;QNTransientRBSystem&quot;</span>);
<a name="l00365"></a>00365 
<a name="l00366"></a>00366   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1TransientRBSystem.php#af0fbee2db2698376fe3a932c5a7bcc26">nonzero_initialization</a>)
<a name="l00367"></a>00367   {
<a name="l00368"></a>00368     <span class="comment">// Put the initial condition in solution and current_local_solution</span>
<a name="l00369"></a>00369     <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ab455004dfc57c1a9454534ab1a761dbc">Parent::initialize_truth</a>();
<a name="l00370"></a>00370 
<a name="l00371"></a>00371     <span class="comment">// We have loaded the initialization into the solution</span>
<a name="l00372"></a>00372     <span class="comment">// vector, now copy to current_newton_iterate</span>
<a name="l00373"></a>00373     *<a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#acb60710609da05611e7d440eb79a66ff">current_newton_iterate</a> = *<a class="code" href="classlibMesh_1_1System.php#a1e1bec53fb8d8a5a2163dbee844e8417">current_local_solution</a>;
<a name="l00374"></a>00374   }
<a name="l00375"></a>00375   <span class="keywordflow">else</span>
<a name="l00376"></a>00376   {
<a name="l00377"></a>00377     <span class="comment">// Otherwise zero out current_newton_iterate as a default</span>
<a name="l00378"></a>00378     <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#acb60710609da05611e7d440eb79a66ff">current_newton_iterate</a>-&gt;zero();
<a name="l00379"></a>00379 
<a name="l00380"></a>00380     <span class="comment">// Also, set the solution to zero</span>
<a name="l00381"></a>00381     <span class="comment">// since we use the solution vector in</span>
<a name="l00382"></a>00382     <span class="comment">// TransientRBSystem::update_RB_initial_condition_all_N</span>
<a name="l00383"></a>00383     <a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;zero();
<a name="l00384"></a>00384   }
<a name="l00385"></a>00385 
<a name="l00386"></a>00386   STOP_LOG(<span class="stringliteral">&quot;initialize_truth()&quot;</span>, <span class="stringliteral">&quot;QNTransientRBSystem&quot;</span>);
<a name="l00387"></a>00387 }
<a name="l00388"></a>00388 
<a name="l00389"></a><a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#ac6bc46978e210bad86a1bf676bdb87d4">00389</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#ac6bc46978e210bad86a1bf676bdb87d4">QNTransientRBSystem::truth_solve</a>(<span class="keywordtype">int</span> write_interval)
<a name="l00390"></a>00390 {
<a name="l00391"></a>00391   START_LOG(<span class="stringliteral">&quot;truth_solve()&quot;</span>, <span class="stringliteral">&quot;QNTransientRBSystem&quot;</span>);
<a name="l00392"></a>00392 
<a name="l00393"></a>00393   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a> = <a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">get_mesh</a>();
<a name="l00394"></a>00394 
<a name="l00395"></a>00395   <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#ab3d82f282253972001d4a6d6c94cb42b">initialize_truth</a>();
<a name="l00396"></a>00396 
<a name="l00397"></a>00397   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a262def83281fa63888e8ed5e3b59d1b8">set_time_level</a>(0);
<a name="l00398"></a>00398 
<a name="l00399"></a>00399   <span class="comment">// Now compute the truth outputs</span>
<a name="l00400"></a>00400   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#a80b9e06a7c60b3bb2f5870b0ff66a2ca">get_n_outputs</a>(); n++)
<a name="l00401"></a>00401     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_l=0; q_l&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#ab7f0b2268a9716189225e0446b519911">get_Q_l</a>(n); q_l++)
<a name="l00402"></a>00402     {
<a name="l00403"></a>00403       <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a58dda0affa01e49069a725153dcf5cc6">truth_outputs_all_k</a>[n][<a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae8bf672ee83dac4058eb4deb5b660750">_k</a>] = <a class="code" href="classlibMesh_1_1RBSystem.php#a3ab4b896903320a2b313f73efc2aaad1">eval_theta_q_l</a>(n,q_l)*<a class="code" href="classlibMesh_1_1RBSystem.php#a956b276ef7de8606c78698fcfa338343">get_output_vector</a>(n,q_l)-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a1f522c421b32b75ea4dc3de6d1a95000">dot</a>(*<a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#acb60710609da05611e7d440eb79a66ff">current_newton_iterate</a>);
<a name="l00404"></a>00404     }
<a name="l00405"></a>00405 
<a name="l00406"></a>00406   <span class="comment">// Load initial projection error into temporal_data dense matrix</span>
<a name="l00407"></a>00407   <a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;zero();
<a name="l00408"></a>00408   <a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;add(1., *<a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#acb60710609da05611e7d440eb79a66ff">current_newton_iterate</a>);
<a name="l00409"></a>00409   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a1d1eb4f1214b4e26a86137ed7ba38a13">set_error_temporal_data</a>();
<a name="l00410"></a>00410 
<a name="l00411"></a>00411   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> time_level=1; time_level&lt;=<a class="code" href="classlibMesh_1_1TransientRBSystem.php#aac8858a7e9af6497f3c37a4b7956ca6a">_K</a>; time_level++)
<a name="l00412"></a>00412     {
<a name="l00413"></a>00413       <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a262def83281fa63888e8ed5e3b59d1b8">set_time_level</a>(time_level); <span class="comment">// update the member variable _k</span>
<a name="l00414"></a>00414 
<a name="l00415"></a>00415       <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBSystem.php#adec856bc209f0533639d76767bd5ebbc">quiet</a>)
<a name="l00416"></a>00416       {
<a name="l00417"></a>00417         <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; std::endl &lt;&lt; <span class="stringliteral">&quot;Truth solve, time step &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae8bf672ee83dac4058eb4deb5b660750">_k</a> &lt;&lt; std::endl;
<a name="l00418"></a>00418       }
<a name="l00419"></a>00419 
<a name="l00420"></a>00420       <span class="comment">// Set the old solution to be the result of the previous Newton loop</span>
<a name="l00421"></a>00421       *<a class="code" href="classlibMesh_1_1TransientSystem.php#a61cfd7f2e0a4c5133beae4a0e8c69141">old_local_solution</a> = *<a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#acb60710609da05611e7d440eb79a66ff">current_newton_iterate</a>;
<a name="l00422"></a>00422 
<a name="l00423"></a>00423       <span class="comment">// Needed for eisenstat tolerance calculation</span>
<a name="l00424"></a>00424       <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> old_rhs_norm = 0.;
<a name="l00425"></a>00425 
<a name="l00426"></a>00426       <span class="comment">// std::ostringstream event_name;</span>
<a name="l00427"></a>00427       <span class="comment">// event_name &lt;&lt; &quot;Newton iterations for timestep &quot; &lt;&lt; time_level;</span>
<a name="l00428"></a>00428       <span class="comment">// PerfLog perf_log (&quot;Newton Loop&quot;);</span>
<a name="l00429"></a>00429       <span class="comment">// perf_log.start_event(event_name.str());</span>
<a name="l00430"></a>00430 
<a name="l00431"></a>00431       <span class="comment">// Now we begin the nonlinear loop</span>
<a name="l00432"></a>00432       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> l=0; l&lt;<a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a6898b18e56f0ef28ce3e2b33c6e6ac95">n_newton_steps</a>; ++l)
<a name="l00433"></a>00433         {
<a name="l00434"></a>00434           <span class="comment">// Assemble &amp; solve the linear system.</span>
<a name="l00435"></a>00435           <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#aee9ad3841915a8daee375ea3b85a2c20">truth_assembly</a>();
<a name="l00436"></a>00436 
<a name="l00437"></a>00437           <span class="comment">// Compute norm of rhs, this is the current nonlinear residual, and</span>
<a name="l00438"></a>00438           <span class="comment">// the linear solver tolerance should (in most cases) be set based on this value.</span>
<a name="l00439"></a>00439           <a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a42ea91bba70b3e7b27dad2a636ad31ae">close</a>(); <span class="comment">// necessary?</span>
<a name="l00440"></a>00440           <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> rhs_norm = <a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a7bbf5b5a75e7aafcbfc1ea19fbc51d73">l2_norm</a>();
<a name="l00441"></a>00441 
<a name="l00442"></a>00442           <span class="comment">// If we print this out, we can compare how much the previous linear iterations</span>
<a name="l00443"></a>00443           <span class="comment">// have &quot;oversolved&quot; the system, if at all.</span>
<a name="l00444"></a>00444           <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBSystem.php#adec856bc209f0533639d76767bd5ebbc">quiet</a>)
<a name="l00445"></a>00445             <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Current nonlinear residual: &quot;</span> &lt;&lt; rhs_norm &lt;&lt; std::endl;
<a name="l00446"></a>00446 
<a name="l00447"></a>00447           <span class="comment">// Assume fixed tolerance == eisenstat_eta0</span>
<a name="l00448"></a>00448           <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> current_linear_tolerance = <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a8981c27ff565fd5434de91db6b758221">eisenstat_eta0</a>;
<a name="l00449"></a>00449 
<a name="l00450"></a>00450           <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a6560d33a85365fd45ef4d9cd54e8e120">use_eisenstat</a>)
<a name="l00451"></a>00451             {
<a name="l00452"></a>00452               <span class="comment">// 1.) Tolerance selection method of Dembo and Steihaug.  This method</span>
<a name="l00453"></a>00453               <span class="comment">// is simple, but it&#39;s not robust in practice because it depends on the</span>
<a name="l00454"></a>00454               <span class="comment">// scale of the residual norm...</span>
<a name="l00455"></a>00455               <span class="comment">// tol = min{1/(l+2), rhs_norm}</span>
<a name="l00456"></a>00456               <span class="comment">//          const Real current_linear_tolerance =</span>
<a name="l00457"></a>00457               <span class="comment">//            std::min( 1./static_cast&lt;Real&gt;(l+2), rhs_norm );</span>
<a name="l00458"></a>00458 
<a name="l00459"></a>00459               <span class="comment">// 2.) Eisenstat tolerance calculation</span>
<a name="l00460"></a>00460               <span class="keywordflow">if</span> (l!=0)
<a name="l00461"></a>00461                 {
<a name="l00462"></a>00462                   current_linear_tolerance = <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a779aa4c52fff79bd12b8ead2cd650a1b">eisenstat_gamma</a> * <a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">std::pow</a>(rhs_norm/old_rhs_norm, <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a53d4512a39a08fdf383a398b2cde1cf4">eisenstat_alpha</a>);
<a name="l00463"></a>00463 
<a name="l00464"></a>00464                   <span class="comment">// But don&#39;t let it get larger than the initial value!</span>
<a name="l00465"></a>00465                   current_linear_tolerance = <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(<a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a8981c27ff565fd5434de91db6b758221">eisenstat_eta0</a>, current_linear_tolerance);
<a name="l00466"></a>00466 
<a name="l00467"></a>00467                   <span class="comment">// Eisenstat doesn&#39;t take into account the desired *nonlinear* tolerance</span>
<a name="l00468"></a>00468                   <span class="comment">// so you will almost always oversolve the final Newton step unless you set:</span>
<a name="l00469"></a>00469                   current_linear_tolerance = <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(current_linear_tolerance, 0.1*<a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#abd9e16b48c18c57baeed6ac2a0c3cffa">nonlinear_tolerance</a>);
<a name="l00470"></a>00470                 }
<a name="l00471"></a>00471 
<a name="l00472"></a>00472               <span class="comment">// Save rhs_norm, for next iteration!</span>
<a name="l00473"></a>00473               old_rhs_norm = rhs_norm;
<a name="l00474"></a>00474             }
<a name="l00475"></a>00475 
<a name="l00476"></a>00476           this-&gt;<a class="code" href="classlibMesh_1_1System.php#ac5ca6b1f3adcfac56982982e90dc905b">get_equation_systems</a>().<a class="code" href="classlibMesh_1_1EquationSystems.php#a7c02be232f564967ca0804a7824adb53">parameters</a>.<a class="code" href="classlibMesh_1_1Parameters.php#a7036d0ddbe4965e0a638e1b9814fa549">set</a>&lt;<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>&gt;(<span class="stringliteral">&quot;linear solver tolerance&quot;</span>) = current_linear_tolerance;
<a name="l00477"></a>00477 
<a name="l00478"></a>00478           <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBSystem.php#adec856bc209f0533639d76767bd5ebbc">quiet</a>)
<a name="l00479"></a>00479             <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Using relative linear tolerance: &quot;</span> &lt;&lt; current_linear_tolerance &lt;&lt; std::endl;
<a name="l00480"></a>00480 
<a name="l00481"></a>00481           <span class="comment">// We&#39;re solving for delta_u, so set our intial guess to zero</span>
<a name="l00482"></a>00482           <a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;zero(); <span class="comment">// Do this after assembly to be sure</span>
<a name="l00483"></a>00483           <a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#af1de21a76860785bb1992280eb72b0db">solve</a>();
<a name="l00484"></a>00484 
<a name="l00485"></a>00485 <span class="preprocessor">#if defined(LIBMESH_ENABLE_AMR) || defined(LIBMESH_ENABLE_PERIODIC)</span>
<a name="l00486"></a>00486 <span class="preprocessor"></span>          <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBSystem.php#a185d55184fb6f7c1705066908d642319">enforce_constraints_exactly</a>)
<a name="l00487"></a>00487           {
<a name="l00488"></a>00488             <a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>().<a class="code" href="classlibMesh_1_1DofMap.php#a938f3e6db23b740002490ac88d1bb60a">enforce_constraints_exactly</a>(*<span class="keyword">this</span>); 
<a name="l00489"></a>00489             <a class="code" href="classlibMesh_1_1System.php#ab9d81ac9c1787c43fb87cf13d37741ee">update</a>();
<a name="l00490"></a>00490           }
<a name="l00491"></a>00491 <span class="preprocessor">#endif</span>
<a name="l00492"></a>00492 <span class="preprocessor"></span>
<a name="l00493"></a>00493           <span class="comment">// solution now holds delta_u, so update the Newton iterate</span>
<a name="l00494"></a>00494           <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#acb60710609da05611e7d440eb79a66ff">current_newton_iterate</a>-&gt;add(1., *<a class="code" href="classlibMesh_1_1System.php#a1e1bec53fb8d8a5a2163dbee844e8417">current_local_solution</a>);
<a name="l00495"></a>00495 
<a name="l00496"></a>00496           <span class="comment">// Compute the l2 norm of the difference</span>
<a name="l00497"></a>00497           <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> norm_delta = <a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;l2_norm();
<a name="l00498"></a>00498 
<a name="l00499"></a>00499           <span class="comment">// How many iterations were required to solve the linear system?</span>
<a name="l00500"></a>00500           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#af712dbf0e285c5ff4cc346daef05423c">n_linear_iterations</a> = this-&gt;<a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#af712dbf0e285c5ff4cc346daef05423c">n_linear_iterations</a>();
<a name="l00501"></a>00501 
<a name="l00502"></a>00502           <span class="comment">// What was the initial residual of the linear system?  Unfortunately,</span>
<a name="l00503"></a>00503           <span class="comment">// this is a little less straightforward to obtain: There is not a generic</span>
<a name="l00504"></a>00504           <span class="comment">// LinearSolver routine to do it, we have to cast to PetscLinearSolver...</span>
<a name="l00505"></a>00505           <span class="comment">// I like to have this value since the difference between this and</span>
<a name="l00506"></a>00506           <span class="comment">// the final linear residual from the previous step is a measure of the amount</span>
<a name="l00507"></a>00507           <span class="comment">// of oversolving.</span>
<a name="l00508"></a>00508 
<a name="l00509"></a>00509           <span class="comment">// What was the final residual of the linear system?</span>
<a name="l00510"></a>00510           <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a86b5e2954d2a2e43014bcda8810239ac">final_linear_residual</a> = this-&gt;<a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a86b5e2954d2a2e43014bcda8810239ac">final_linear_residual</a>();
<a name="l00511"></a>00511 
<a name="l00512"></a>00512           <span class="comment">// Print out convergence information for the linear and</span>
<a name="l00513"></a>00513           <span class="comment">// nonlinear iterations.</span>
<a name="l00514"></a>00514           <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBSystem.php#adec856bc209f0533639d76767bd5ebbc">quiet</a>)
<a name="l00515"></a>00515           {
<a name="l00516"></a>00516             <span class="comment">// Save cout flags</span>
<a name="l00517"></a>00517             std::ios_base::fmtflags flags = <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a>.<a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#a2d6a009a794b5c76602fb458d3de9570">flags</a>();
<a name="l00518"></a>00518 
<a name="l00519"></a>00519             <span class="comment">// Use scientific formatting for these numbers</span>
<a name="l00520"></a>00520             <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a>.<a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#a7be489dff0fb06bd015f4ab861a5f8f7">setf</a>(std::ios::scientific);
<a name="l00521"></a>00521 
<a name="l00522"></a>00522             <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Linear solver converged at step: &quot;</span>
<a name="l00523"></a>00523                       &lt;&lt; n_linear_iterations
<a name="l00524"></a>00524                       &lt;&lt; <span class="stringliteral">&quot;, final residual: &quot;</span>
<a name="l00525"></a>00525                       &lt;&lt; final_linear_residual
<a name="l00526"></a>00526                       &lt;&lt; <span class="stringliteral">&quot;  Nonlinear convergence: ||delta_u|| = &quot;</span>
<a name="l00527"></a>00527                       &lt;&lt; norm_delta
<a name="l00528"></a>00528                       &lt;&lt; std::endl;
<a name="l00529"></a>00529 
<a name="l00530"></a>00530             <span class="comment">// reset the original format flags</span>
<a name="l00531"></a>00531             <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a>.<a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#a2d6a009a794b5c76602fb458d3de9570">flags</a>(flags);
<a name="l00532"></a>00532           }
<a name="l00533"></a>00533 
<a name="l00534"></a>00534           <span class="keywordflow">if</span> ((norm_delta &lt; <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#abd9e16b48c18c57baeed6ac2a0c3cffa">nonlinear_tolerance</a>) &amp;&amp;
<a name="l00535"></a>00535               (final_linear_residual &lt; <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#abd9e16b48c18c57baeed6ac2a0c3cffa">nonlinear_tolerance</a>))
<a name="l00536"></a>00536             {
<a name="l00537"></a>00537               <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBSystem.php#adec856bc209f0533639d76767bd5ebbc">quiet</a>)
<a name="l00538"></a>00538               {
<a name="l00539"></a>00539                 <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot; Nonlinear solver converged at step &quot;</span>
<a name="l00540"></a>00540                           &lt;&lt; l
<a name="l00541"></a>00541                           &lt;&lt; std::endl &lt;&lt; std::endl &lt;&lt; std::endl;
<a name="l00542"></a>00542               }
<a name="l00543"></a>00543               <span class="keywordflow">break</span>;
<a name="l00544"></a>00544             }
<a name="l00545"></a>00545 
<a name="l00546"></a>00546           <span class="comment">// Make sure the solver converges correctly</span>
<a name="l00547"></a>00547           <span class="keywordflow">if</span>( (l==(n_newton_steps-1)) &amp;&amp;
<a name="l00548"></a>00548               ((norm_delta &gt; <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#abd9e16b48c18c57baeed6ac2a0c3cffa">nonlinear_tolerance</a>) || (final_linear_residual &gt; <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#abd9e16b48c18c57baeed6ac2a0c3cffa">nonlinear_tolerance</a>)) )
<a name="l00549"></a>00549           {
<a name="l00550"></a>00550             <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Warning: Linear solver may not have converged! Final linear residual = &quot;</span>
<a name="l00551"></a>00551                       &lt;&lt; this-&gt;<a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a86b5e2954d2a2e43014bcda8810239ac">final_linear_residual</a>() &lt;&lt; <span class="stringliteral">&quot;, number of iterations = &quot;</span>
<a name="l00552"></a>00552                       &lt;&lt; this-&gt;<a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#af712dbf0e285c5ff4cc346daef05423c">n_linear_iterations</a>() &lt;&lt; std::endl &lt;&lt; std::endl;
<a name="l00553"></a>00553 <span class="comment">//             libmesh_error();</span>
<a name="l00554"></a>00554           }
<a name="l00555"></a>00555         } <span class="comment">// end nonlinear loop</span>
<a name="l00556"></a>00556 
<a name="l00557"></a>00557       <span class="comment">// perf_log.stop_event(event_name.str());</span>
<a name="l00558"></a>00558 
<a name="l00559"></a>00559 <span class="comment">//       // Perform a truth SCM solve based on current_newton_iterate</span>
<a name="l00560"></a>00560 <span class="comment">//       EquationSystems&amp; es = this-&gt;get_equation_systems();</span>
<a name="l00561"></a>00561 <span class="comment">//       QNTransientSCMSystem&amp; eigen_system = es.get_system&lt;QNTransientSCMSystem&gt;(eigen_system_name);</span>
<a name="l00562"></a>00562 <span class="comment">//       eigen_system.compute_truth_stability_constant();</span>
<a name="l00563"></a>00563 
<a name="l00564"></a>00564       <span class="comment">// Now compute the truth outputs</span>
<a name="l00565"></a>00565       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#a80b9e06a7c60b3bb2f5870b0ff66a2ca">get_n_outputs</a>(); n++)
<a name="l00566"></a>00566         <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_l=0; q_l&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#ab7f0b2268a9716189225e0446b519911">get_Q_l</a>(n); q_l++)
<a name="l00567"></a>00567         {
<a name="l00568"></a>00568           <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a58dda0affa01e49069a725153dcf5cc6">truth_outputs_all_k</a>[n][<a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae8bf672ee83dac4058eb4deb5b660750">_k</a>] = <a class="code" href="classlibMesh_1_1RBSystem.php#a3ab4b896903320a2b313f73efc2aaad1">eval_theta_q_l</a>(n,q_l)*<a class="code" href="classlibMesh_1_1RBSystem.php#a956b276ef7de8606c78698fcfa338343">get_output_vector</a>(n,q_l)-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a1f522c421b32b75ea4dc3de6d1a95000">dot</a>(*<a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#acb60710609da05611e7d440eb79a66ff">current_newton_iterate</a>);
<a name="l00569"></a>00569         }
<a name="l00570"></a>00570 
<a name="l00571"></a>00571       <span class="keywordflow">if</span> ( (write_interval &gt; 0) &amp;&amp; (<a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae8bf672ee83dac4058eb4deb5b660750">_k</a>%write_interval == 0) )
<a name="l00572"></a>00572         {
<a name="l00573"></a>00573           <a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;zero();
<a name="l00574"></a>00574           <a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;add(1., *<a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#acb60710609da05611e7d440eb79a66ff">current_newton_iterate</a>);
<a name="l00575"></a>00575 
<a name="l00576"></a>00576           <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l00577"></a>00577 
<a name="l00578"></a>00578           <span class="comment">// We write the file name in the gmv auto-read format.</span>
<a name="l00579"></a>00579           file_name &lt;&lt; <span class="stringliteral">&quot;truth.gmv.&quot;</span>;
<a name="l00580"></a>00580           OSSRealzeroright(file_name,3,0, <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae8bf672ee83dac4058eb4deb5b660750">_k</a>);
<a name="l00581"></a>00581 
<a name="l00582"></a>00582           <a class="code" href="classlibMesh_1_1GMVIO.php">GMVIO</a>(mesh).<a class="code" href="classlibMesh_1_1MeshOutput.php#a935598198649f4b831cd341ce91b3ccb">write_equation_systems</a> (file_name.str(),
<a name="l00583"></a>00583                                               this-&gt;<a class="code" href="classlibMesh_1_1System.php#ac5ca6b1f3adcfac56982982e90dc905b">get_equation_systems</a>());
<a name="l00584"></a>00584         }
<a name="l00585"></a>00585 
<a name="l00586"></a>00586       <span class="comment">// Load projection error into temporal_data dense matrix</span>
<a name="l00587"></a>00587       <a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;zero();
<a name="l00588"></a>00588       <a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;add(1., *<a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#acb60710609da05611e7d440eb79a66ff">current_newton_iterate</a>);
<a name="l00589"></a>00589       <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a1d1eb4f1214b4e26a86137ed7ba38a13">set_error_temporal_data</a>();
<a name="l00590"></a>00590 
<a name="l00591"></a>00591     }
<a name="l00592"></a>00592 
<a name="l00593"></a>00593   <span class="comment">// Get the L2 norm of the truth solution at time-level _K</span>
<a name="l00594"></a>00594   <span class="comment">// Useful for normalizing our true error data</span>
<a name="l00595"></a>00595   <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a>)
<a name="l00596"></a>00596   {
<a name="l00597"></a>00597     <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a4e15721a62defb903900352ceb0ea367">L2_matrix</a>-&gt;vector_mult(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>, *<a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#acb60710609da05611e7d440eb79a66ff">current_newton_iterate</a>);
<a name="l00598"></a>00598   }
<a name="l00599"></a>00599   <span class="keywordflow">else</span>
<a name="l00600"></a>00600   {
<a name="l00601"></a>00601     <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a0ee3e3816d13aeae07fe5212dda5f521">assemble_L2_matrix</a>(<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>);
<a name="l00602"></a>00602     <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#adaccc5857f1a5d5ca264ded0b8bfb986">vector_mult</a>(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>, *<a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#acb60710609da05611e7d440eb79a66ff">current_newton_iterate</a>);
<a name="l00603"></a>00603   }
<a name="l00604"></a>00604 
<a name="l00605"></a>00605   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> final_truth_L2_norm = <a class="code" href="namespacelibMesh.php#aea33cac176f18504c5c4078407aadbb7">libmesh_real</a>(std::sqrt( <a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>-&gt;dot(*<a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#acb60710609da05611e7d440eb79a66ff">current_newton_iterate</a>)));
<a name="l00606"></a>00606 
<a name="l00607"></a>00607   STOP_LOG(<span class="stringliteral">&quot;truth_solve()&quot;</span>, <span class="stringliteral">&quot;QNTransientRBSystem&quot;</span>);
<a name="l00608"></a>00608 
<a name="l00609"></a>00609   <span class="keywordflow">return</span> final_truth_L2_norm;
<a name="l00610"></a>00610 }
<a name="l00611"></a>00611 
<a name="l00612"></a>00612 
<a name="l00613"></a>00613 
<a name="l00614"></a>00614 
<a name="l00615"></a>00615 
<a name="l00616"></a>00616 
<a name="l00617"></a>00617 
<a name="l00618"></a>00618 
<a name="l00619"></a><a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a1680488164f8f4f740eaf333aa792625">00619</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a1680488164f8f4f740eaf333aa792625">QNTransientRBSystem::RB_solve</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N)
<a name="l00620"></a>00620 {
<a name="l00621"></a>00621   START_LOG(<span class="stringliteral">&quot;RB_solve()&quot;</span>, <span class="stringliteral">&quot;QNTransientRBSystem&quot;</span>);
<a name="l00622"></a>00622 
<a name="l00623"></a>00623   <span class="keywordflow">if</span>(N &gt; <a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>())
<a name="l00624"></a>00624   {
<a name="l00625"></a>00625     <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: N cannot be larger than the number &quot;</span>
<a name="l00626"></a>00626                  &lt;&lt; <span class="stringliteral">&quot;of basis functions in RB_solve&quot;</span> &lt;&lt; std::endl;
<a name="l00627"></a>00627     libmesh_error();
<a name="l00628"></a>00628   }
<a name="l00629"></a>00629   <span class="keywordflow">if</span>(N==0)
<a name="l00630"></a>00630   {
<a name="l00631"></a>00631     <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: N must be greater than 0 in RB_solve&quot;</span> &lt;&lt; std::endl;
<a name="l00632"></a>00632     libmesh_error();
<a name="l00633"></a>00633   }
<a name="l00634"></a>00634 
<a name="l00635"></a>00635   <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Number&gt;</a> Base_RB_LHS_matrix(N,N);
<a name="l00636"></a>00636   Base_RB_LHS_matrix.<a class="code" href="classlibMesh_1_1DenseMatrix.php#ab3e7a4e199200d0f5875fd4a5082cb7c">zero</a>();
<a name="l00637"></a>00637 
<a name="l00638"></a>00638   <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Number&gt;</a> RB_RHS_Aq_matrix(N,N);
<a name="l00639"></a>00639   RB_RHS_Aq_matrix.<a class="code" href="classlibMesh_1_1DenseMatrix.php#ab3e7a4e199200d0f5875fd4a5082cb7c">zero</a>();
<a name="l00640"></a>00640 
<a name="l00641"></a>00641   <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Number&gt;</a> RB_mass_matrix_N(N,N);
<a name="l00642"></a>00642   RB_mass_matrix_N.<a class="code" href="classlibMesh_1_1DenseMatrix.php#ab3e7a4e199200d0f5875fd4a5082cb7c">zero</a>();
<a name="l00643"></a>00643   <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Number&gt;</a> RB_M_q_m;
<a name="l00644"></a>00644   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_m=0; q_m&lt;<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>(); q_m++)
<a name="l00645"></a>00645   {
<a name="l00646"></a>00646     <a class="code" href="classlibMesh_1_1TransientRBSystem.php#aae9cbd15df988bcdf5cf2db5fcb24e5b">RB_M_q_vector</a>[q_m].get_principal_submatrix(N, RB_M_q_m);
<a name="l00647"></a>00647     RB_mass_matrix_N.<a class="code" href="classlibMesh_1_1DenseMatrix.php#adf1b1e8773da47d9edaed6f12c6ceb9a">add</a>(<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a36a6aa3be4fb96b256cb9d664e5a2dfb">eval_theta_q_m</a>(q_m), RB_M_q_m);
<a name="l00648"></a>00648   }
<a name="l00649"></a>00649 
<a name="l00650"></a>00650   Base_RB_LHS_matrix.<a class="code" href="classlibMesh_1_1DenseMatrix.php#adf1b1e8773da47d9edaed6f12c6ceb9a">add</a>(1./<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a04397bf3cc20ccd2bb5056c22b45c9f5">dt</a>, RB_mass_matrix_N);
<a name="l00651"></a>00651 
<a name="l00652"></a>00652   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_a=0; q_a&lt;<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>(); q_a++)
<a name="l00653"></a>00653   {
<a name="l00654"></a>00654     <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> cached_theta_q_a = <a class="code" href="classlibMesh_1_1RBBase.php#aeeb46ce2b390bf820f954976ee9da7ce">eval_theta_q_a</a>(q_a);
<a name="l00655"></a>00655     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;N; i++)
<a name="l00656"></a>00656     {
<a name="l00657"></a>00657       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;N; j++)
<a name="l00658"></a>00658       {
<a name="l00659"></a>00659         Base_RB_LHS_matrix(i,j) += <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a5af426f9dc2b27772aef689c19fbf4b0">euler_theta</a>*cached_theta_q_a*<a class="code" href="classlibMesh_1_1RBSystem.php#adadaf9a427ffbace640455436a4d4b26">RB_A_q_vector</a>[q_a](i,j);
<a name="l00660"></a>00660         RB_RHS_Aq_matrix(i,j) += -cached_theta_q_a*<a class="code" href="classlibMesh_1_1RBSystem.php#adadaf9a427ffbace640455436a4d4b26">RB_A_q_vector</a>[q_a](i,j);
<a name="l00661"></a>00661       }
<a name="l00662"></a>00662     }
<a name="l00663"></a>00663   }
<a name="l00664"></a>00664 
<a name="l00665"></a>00665   <span class="comment">// Set system time level to 0</span>
<a name="l00666"></a>00666   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a8e91d71806a187bb38f888c6541654b5">error_bound_all_k</a>.resize(<a class="code" href="classlibMesh_1_1TransientRBSystem.php#aac8858a7e9af6497f3c37a4b7956ca6a">_K</a>+1);
<a name="l00667"></a>00667   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a262def83281fa63888e8ed5e3b59d1b8">set_time_level</a>(0);
<a name="l00668"></a>00668 
<a name="l00669"></a>00669   <span class="comment">// This is the actual LHS matrix</span>
<a name="l00670"></a>00670   <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Number&gt;</a> RB_LHS_matrix(N,N);
<a name="l00671"></a>00671   RB_LHS_matrix.<a class="code" href="classlibMesh_1_1DenseMatrix.php#ab3e7a4e199200d0f5875fd4a5082cb7c">zero</a>();
<a name="l00672"></a>00672 
<a name="l00673"></a>00673   <span class="comment">// Initialize a vector to store our current Newton iterate</span>
<a name="l00674"></a>00674   <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> RB_u_bar(N);
<a name="l00675"></a>00675   RB_u_bar.<a class="code" href="classlibMesh_1_1DenseVector.php#a23868ec54dca234e5893e41a8b510d68">zero</a>();
<a name="l00676"></a>00676 
<a name="l00677"></a>00677   <span class="comment">// Load the initial condition into RB_u_bar</span>
<a name="l00678"></a>00678   RB_u_bar = <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a4b802536cffba3d792caf8f95ed04327">RB_initial_condition_all_N</a>[N-1];
<a name="l00679"></a>00679 
<a name="l00680"></a>00680   <span class="comment">// Initialize solution storage vectors</span>
<a name="l00681"></a>00681   <a class="code" href="classlibMesh_1_1RBSystem.php#a201af52facfa4da38bc636ee2cf41c67">RB_solution</a>.<a class="code" href="classlibMesh_1_1DenseVector.php#a08430ae781094632e8272cbb825d4f44">resize</a>(N);
<a name="l00682"></a>00682   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#adbbe1db7bf9fd6a56b949147cd75d79f">old_RB_solution</a>.<a class="code" href="classlibMesh_1_1DenseVector.php#a08430ae781094632e8272cbb825d4f44">resize</a>(N);
<a name="l00683"></a>00683   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a475a0b22e1808293b4d209f35f60914f">RB_temporal_solution_data</a>.resize(<a class="code" href="classlibMesh_1_1TransientRBSystem.php#aac8858a7e9af6497f3c37a4b7956ca6a">_K</a>+1);
<a name="l00684"></a>00684   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> time_level=0; time_level&lt;=<a class="code" href="classlibMesh_1_1TransientRBSystem.php#aac8858a7e9af6497f3c37a4b7956ca6a">_K</a>; time_level++)
<a name="l00685"></a>00685   {
<a name="l00686"></a>00686     <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a475a0b22e1808293b4d209f35f60914f">RB_temporal_solution_data</a>[time_level].resize(N);
<a name="l00687"></a>00687   }
<a name="l00688"></a>00688   <span class="comment">// and load the _k=0 data</span>
<a name="l00689"></a>00689   <a class="code" href="classlibMesh_1_1RBSystem.php#a201af52facfa4da38bc636ee2cf41c67">RB_solution</a> = RB_u_bar;
<a name="l00690"></a>00690   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a475a0b22e1808293b4d209f35f60914f">RB_temporal_solution_data</a>[<a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae8bf672ee83dac4058eb4deb5b660750">_k</a>] = RB_u_bar;
<a name="l00691"></a>00691 
<a name="l00692"></a>00692   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> error_bound_sum = <a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">pow</a>( <a class="code" href="classlibMesh_1_1TransientRBSystem.php#aecf2610660c4023d6c993b4c08b64be4">initial_L2_error_all_N</a>[N-1], 2.);
<a name="l00693"></a>00693 
<a name="l00694"></a>00694   <span class="comment">// Set error bound at _k=0</span>
<a name="l00695"></a>00695   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a8e91d71806a187bb38f888c6541654b5">error_bound_all_k</a>[<a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae8bf672ee83dac4058eb4deb5b660750">_k</a>] = std::sqrt(error_bound_sum);
<a name="l00696"></a>00696 
<a name="l00697"></a>00697   <span class="comment">// Compute the outputs and associated error bounds at _k=0</span>
<a name="l00698"></a>00698   <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> RB_output_vector_N;
<a name="l00699"></a>00699   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#a80b9e06a7c60b3bb2f5870b0ff66a2ca">get_n_outputs</a>(); n++)
<a name="l00700"></a>00700   {
<a name="l00701"></a>00701     <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ad5066d07edc5e25cb04b00fde9e72ec2">RB_outputs_all_k</a>[n][<a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae8bf672ee83dac4058eb4deb5b660750">_k</a>] = 0.;
<a name="l00702"></a>00702     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_l=0; q_l&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#ab7f0b2268a9716189225e0446b519911">get_Q_l</a>(n); q_l++)
<a name="l00703"></a>00703     {
<a name="l00704"></a>00704       <a class="code" href="classlibMesh_1_1RBSystem.php#ab868a08069961fcde36a760e0094708a">RB_output_vectors</a>[n][q_l].get_principal_subvector(N, RB_output_vector_N);
<a name="l00705"></a>00705       <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ad5066d07edc5e25cb04b00fde9e72ec2">RB_outputs_all_k</a>[n][<a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae8bf672ee83dac4058eb4deb5b660750">_k</a>] += <a class="code" href="classlibMesh_1_1RBSystem.php#a3ab4b896903320a2b313f73efc2aaad1">eval_theta_q_l</a>(n,q_l)*RB_output_vector_N.<a class="code" href="classlibMesh_1_1DenseVector.php#a740926ab2815bb507a1e33b659414be1">dot</a>(RB_u_bar);
<a name="l00706"></a>00706     }
<a name="l00707"></a>00707 
<a name="l00708"></a>00708     <a class="code" href="classlibMesh_1_1TransientRBSystem.php#aeb55ea3e37e65db40b8dd322f4bcb4a6">RB_output_error_bounds_all_k</a>[n][<a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae8bf672ee83dac4058eb4deb5b660750">_k</a>] = <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a8e91d71806a187bb38f888c6541654b5">error_bound_all_k</a>[<a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae8bf672ee83dac4058eb4deb5b660750">_k</a>] * <a class="code" href="classlibMesh_1_1RBSystem.php#a6cae03a0338b32c65938db1f805deb3c">eval_output_dual_norm</a>(n);
<a name="l00709"></a>00709   }
<a name="l00710"></a>00710 
<a name="l00711"></a>00711   <span class="comment">// Initialize a vector to store the solution from the old time-step</span>
<a name="l00712"></a>00712   <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> RB_u_old(N);
<a name="l00713"></a>00713   RB_u_old.<a class="code" href="classlibMesh_1_1DenseVector.php#a23868ec54dca234e5893e41a8b510d68">zero</a>();
<a name="l00714"></a>00714 
<a name="l00715"></a>00715   <span class="comment">// Initialize a vector to store the Newton increment, RB_delta_u</span>
<a name="l00716"></a>00716   <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> RB_delta_u(N);
<a name="l00717"></a>00717   RB_delta_u.<a class="code" href="classlibMesh_1_1DenseVector.php#a23868ec54dca234e5893e41a8b510d68">zero</a>();
<a name="l00718"></a>00718 
<a name="l00719"></a>00719   <span class="comment">// Initialize the RB rhs</span>
<a name="l00720"></a>00720   <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> RB_rhs(N);
<a name="l00721"></a>00721   RB_rhs.<a class="code" href="classlibMesh_1_1DenseVector.php#a23868ec54dca234e5893e41a8b510d68">zero</a>();
<a name="l00722"></a>00722 
<a name="l00723"></a>00723   <span class="comment">// Initialize the RB_u_euler_theta</span>
<a name="l00724"></a>00724   <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> RB_u_euler_theta(N);
<a name="l00725"></a>00725   RB_u_euler_theta.<a class="code" href="classlibMesh_1_1DenseVector.php#a23868ec54dca234e5893e41a8b510d68">zero</a>();
<a name="l00726"></a>00726 
<a name="l00727"></a>00727   <span class="comment">// Pre-compute eval_theta_c()</span>
<a name="l00728"></a>00728   <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> cached_theta_c = <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a01234fb8ef324bdc9679e36895c5f5cc">eval_theta_c</a>();
<a name="l00729"></a>00729 
<a name="l00730"></a>00730   <span class="comment">// These vectors allow us to plot the rho upper and lower bounds</span>
<a name="l00731"></a>00731   <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a4a09ca818297079cbe924bdf61062ec3">rho_LB_vector</a>.resize(<a class="code" href="classlibMesh_1_1TransientRBSystem.php#aac8858a7e9af6497f3c37a4b7956ca6a">_K</a>+1);
<a name="l00732"></a>00732   <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a810d69ca39e539ddd9b56492d3af7b25">rho_UB_vector</a>.resize(<a class="code" href="classlibMesh_1_1TransientRBSystem.php#aac8858a7e9af6497f3c37a4b7956ca6a">_K</a>+1);
<a name="l00733"></a>00733 
<a name="l00734"></a>00734   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> time_level=1; time_level&lt;=<a class="code" href="classlibMesh_1_1TransientRBSystem.php#aac8858a7e9af6497f3c37a4b7956ca6a">_K</a>; time_level++)
<a name="l00735"></a>00735   {
<a name="l00736"></a>00736     <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a262def83281fa63888e8ed5e3b59d1b8">set_time_level</a>(time_level); <span class="comment">// update the member variable _k</span>
<a name="l00737"></a>00737 
<a name="l00738"></a>00738     <span class="comment">// Set RB_u_old to be the result of the previous Newton loop</span>
<a name="l00739"></a>00739     RB_u_old = RB_u_bar;
<a name="l00740"></a>00740 
<a name="l00741"></a>00741     <span class="comment">// Now we begin the nonlinear loop</span>
<a name="l00742"></a>00742     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> l=0; l&lt;<a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a6898b18e56f0ef28ce3e2b33c6e6ac95">n_newton_steps</a>; ++l)
<a name="l00743"></a>00743     {
<a name="l00744"></a>00744       <span class="comment">// Get u_euler_theta = euler_theta*RB_u_bar + (1-euler_theta)*RB_u_old</span>
<a name="l00745"></a>00745       RB_u_euler_theta.<a class="code" href="classlibMesh_1_1DenseVector.php#a23868ec54dca234e5893e41a8b510d68">zero</a>();
<a name="l00746"></a>00746       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;N; n++)
<a name="l00747"></a>00747       {
<a name="l00748"></a>00748         RB_u_euler_theta(n) += <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a5af426f9dc2b27772aef689c19fbf4b0">euler_theta</a>*RB_u_bar(n) + (1.-<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a5af426f9dc2b27772aef689c19fbf4b0">euler_theta</a>)*RB_u_old(n);
<a name="l00749"></a>00749       }
<a name="l00750"></a>00750 
<a name="l00751"></a>00751       <span class="comment">// Assemble the left-hand side for the RB linear system</span>
<a name="l00752"></a>00752       RB_LHS_matrix = Base_RB_LHS_matrix;
<a name="l00753"></a>00753 
<a name="l00754"></a>00754       <span class="comment">// Add the trilinear term</span>
<a name="l00755"></a>00755       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;N; i++)
<a name="l00756"></a>00756       {
<a name="l00757"></a>00757         <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;N; j++)
<a name="l00758"></a>00758         {
<a name="l00759"></a>00759           <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;N; n++)
<a name="l00760"></a>00760           {
<a name="l00761"></a>00761             RB_LHS_matrix(i,j) += cached_theta_c*<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a5af426f9dc2b27772aef689c19fbf4b0">euler_theta</a>*RB_u_euler_theta(n)*
<a name="l00762"></a>00762                                   (<a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a6d593306c3c2c3ddede6a33b0943e7c4">RB_trilinear_form</a>[n][i][j] + <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a6d593306c3c2c3ddede6a33b0943e7c4">RB_trilinear_form</a>[j][i][n]);
<a name="l00763"></a>00763           }
<a name="l00764"></a>00764         }
<a name="l00765"></a>00765       }
<a name="l00766"></a>00766 
<a name="l00767"></a>00767       <span class="comment">// Assemble the right-hand side for the RB linear system (the residual)</span>
<a name="l00768"></a>00768       <span class="comment">// First add forcing terms</span>
<a name="l00769"></a>00769       RB_rhs.<a class="code" href="classlibMesh_1_1DenseVector.php#a23868ec54dca234e5893e41a8b510d68">zero</a>();
<a name="l00770"></a>00770       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_f=0; q_f&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>(); q_f++)
<a name="l00771"></a>00771       {
<a name="l00772"></a>00772         <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> cached_theta_f = <a class="code" href="classlibMesh_1_1RBSystem.php#a0fd951279c9b851ac38443156b4b18bd">eval_theta_q_f</a>(q_f);
<a name="l00773"></a>00773         <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;N; i++)
<a name="l00774"></a>00774         {
<a name="l00775"></a>00775           RB_rhs(i) += cached_theta_f*<a class="code" href="classlibMesh_1_1RBSystem.php#ac2da8c5c36be49686429e74b4f9def1c">RB_F_q_vector</a>[q_f](i);
<a name="l00776"></a>00776         }
<a name="l00777"></a>00777       }
<a name="l00778"></a>00778 
<a name="l00779"></a>00779 
<a name="l00780"></a>00780       <span class="comment">// Now add -1./dt * M * (RB_u_bar - RB_u_old)</span>
<a name="l00781"></a>00781       RB_mass_matrix_N.<a class="code" href="classlibMesh_1_1DenseMatrix.php#aa524e3051fffc87a03e16791d917284a">vector_mult_add</a>(RB_rhs, -1./<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a04397bf3cc20ccd2bb5056c22b45c9f5">dt</a>, RB_u_bar);
<a name="l00782"></a>00782       RB_mass_matrix_N.<a class="code" href="classlibMesh_1_1DenseMatrix.php#aa524e3051fffc87a03e16791d917284a">vector_mult_add</a>(RB_rhs,  1./<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a04397bf3cc20ccd2bb5056c22b45c9f5">dt</a>, RB_u_old);
<a name="l00783"></a>00783 
<a name="l00784"></a>00784       <span class="comment">// Now add -mu*A1*u_euler_theta</span>
<a name="l00785"></a>00785       RB_RHS_Aq_matrix.<a class="code" href="classlibMesh_1_1DenseMatrix.php#aa524e3051fffc87a03e16791d917284a">vector_mult_add</a>(RB_rhs, 1., RB_u_euler_theta);
<a name="l00786"></a>00786 
<a name="l00787"></a>00787       <span class="comment">// Finally add the trilinear term</span>
<a name="l00788"></a>00788       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;N; i++)
<a name="l00789"></a>00789       {
<a name="l00790"></a>00790         <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;N; j++)
<a name="l00791"></a>00791         {
<a name="l00792"></a>00792           <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> RB_u_euler_theta_j = RB_u_euler_theta(j);
<a name="l00793"></a>00793           <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;N; n++)
<a name="l00794"></a>00794           {
<a name="l00795"></a>00795             RB_rhs(i) += -cached_theta_c*RB_u_euler_theta(n)*RB_u_euler_theta_j*<a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a6d593306c3c2c3ddede6a33b0943e7c4">RB_trilinear_form</a>[n][i][j];
<a name="l00796"></a>00796           }
<a name="l00797"></a>00797         }
<a name="l00798"></a>00798       }
<a name="l00799"></a>00799 
<a name="l00800"></a>00800       RB_LHS_matrix.<a class="code" href="classlibMesh_1_1DenseMatrix.php#a878b9bf0a49000c70acecd55fdcf8d74">lu_solve</a>(RB_rhs, RB_delta_u);
<a name="l00801"></a>00801 
<a name="l00802"></a>00802       <span class="comment">// update the Newton iterate</span>
<a name="l00803"></a>00803       RB_u_bar += RB_delta_u;
<a name="l00804"></a>00804 
<a name="l00805"></a>00805       <span class="comment">// Compute the l2 norm of RB_delta_u</span>
<a name="l00806"></a>00806       <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> RB_delta_u_norm = RB_delta_u.<a class="code" href="classlibMesh_1_1DenseVector.php#aba21b1716e029687d91f20e44ac7ae93">l2_norm</a>();
<a name="l00807"></a>00807 
<a name="l00808"></a>00808 <span class="comment">//      if(!quiet)</span>
<a name="l00809"></a>00809 <span class="comment">//      {</span>
<a name="l00810"></a>00810 <span class="comment">//        libMesh::out &lt;&lt; &quot;||RB_delta_u|| = &quot; &lt;&lt; RB_delta_u_norm &lt;&lt; std::endl;</span>
<a name="l00811"></a>00811 <span class="comment">//      }</span>
<a name="l00812"></a>00812 
<a name="l00813"></a>00813       <span class="keywordflow">if</span>( RB_delta_u_norm &lt; <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#abd9e16b48c18c57baeed6ac2a0c3cffa">nonlinear_tolerance</a>)
<a name="l00814"></a>00814       {
<a name="l00815"></a>00815 <span class="comment">//        if(!quiet)</span>
<a name="l00816"></a>00816 <span class="comment">//        {</span>
<a name="l00817"></a>00817 <span class="comment">//          libMesh::out &lt;&lt; &quot;RB Newton solve converged at step &quot; &lt;&lt; l &lt;&lt; std::endl &lt;&lt; std::endl;</span>
<a name="l00818"></a>00818 <span class="comment">//        }</span>
<a name="l00819"></a>00819         <span class="keywordflow">break</span>;
<a name="l00820"></a>00820       }
<a name="l00821"></a>00821 
<a name="l00822"></a>00822       <span class="keywordflow">if</span>( (l==(n_newton_steps-1)) &amp;&amp; (RB_delta_u_norm &gt; <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#abd9e16b48c18c57baeed6ac2a0c3cffa">nonlinear_tolerance</a>) )
<a name="l00823"></a>00823       {
<a name="l00824"></a>00824         <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: RB Newton loop did not converge&quot;</span> &lt;&lt; std::endl &lt;&lt; std::endl;
<a name="l00825"></a>00825         libmesh_error();
<a name="l00826"></a>00826       }
<a name="l00827"></a>00827     }
<a name="l00828"></a>00828 
<a name="l00829"></a>00829     <span class="comment">// Load RB_solution into RB_solution_vector for residual computation</span>
<a name="l00830"></a>00830     <a class="code" href="classlibMesh_1_1RBSystem.php#a201af52facfa4da38bc636ee2cf41c67">RB_solution</a> = RB_u_bar;
<a name="l00831"></a>00831     <a class="code" href="classlibMesh_1_1TransientRBSystem.php#adbbe1db7bf9fd6a56b949147cd75d79f">old_RB_solution</a> = RB_u_old;
<a name="l00832"></a>00832     <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a475a0b22e1808293b4d209f35f60914f">RB_temporal_solution_data</a>[<a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae8bf672ee83dac4058eb4deb5b660750">_k</a>] = RB_u_bar;
<a name="l00833"></a>00833 
<a name="l00834"></a>00834     <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> rho_LB = <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a67bc1822ac61799f781695660b2e0754">use_nominal_rho_LB</a> ? <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a312837f008a2f699eed61498e1ba612c">get_nominal_rho_LB</a>() :
<a name="l00835"></a>00835                                        <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a6a72e8968c88bee95ed7742ab853d55c">get_SCM_lower_bound</a>();
<a name="l00836"></a>00836 
<a name="l00837"></a>00837     <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a4a09ca818297079cbe924bdf61062ec3">rho_LB_vector</a>[time_level] = rho_LB;
<a name="l00838"></a>00838     <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a810d69ca39e539ddd9b56492d3af7b25">rho_UB_vector</a>[time_level] = <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a67bc1822ac61799f781695660b2e0754">use_nominal_rho_LB</a> ? 0. : <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a9df81dce8a528580a53ea943176ba483">get_SCM_upper_bound</a>();
<a name="l00839"></a>00839 
<a name="l00840"></a>00840     <span class="comment">// Evaluate the dual norm of the residual for RB_solution_vector</span>
<a name="l00841"></a>00841     <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> epsilon_N = <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a1fd014607285e48d48b02106f0fcc9f1">compute_residual_dual_norm</a>(N);
<a name="l00842"></a>00842 
<a name="l00843"></a>00843     error_bound_sum += <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae9b4ca47590dc2975de08c73aa0e3a55">residual_scaling_numer</a>(rho_LB) * <a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">pow</a>(epsilon_N, 2.);
<a name="l00844"></a>00844 
<a name="l00845"></a>00845     <span class="comment">// store error bound at time-level _k</span>
<a name="l00846"></a>00846     <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a8e91d71806a187bb38f888c6541654b5">error_bound_all_k</a>[<a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae8bf672ee83dac4058eb4deb5b660750">_k</a>] = std::sqrt(error_bound_sum/<a class="code" href="classlibMesh_1_1TransientRBSystem.php#aa638dbd9c57a34051024bc67309f7530">residual_scaling_denom</a>(rho_LB));
<a name="l00847"></a>00847 
<a name="l00848"></a>00848     <span class="comment">// Now compute the outputs and associated errors</span>
<a name="l00849"></a>00849     <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> RB_output_vector_N;
<a name="l00850"></a>00850     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#a80b9e06a7c60b3bb2f5870b0ff66a2ca">get_n_outputs</a>(); n++)
<a name="l00851"></a>00851     {
<a name="l00852"></a>00852       <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ad5066d07edc5e25cb04b00fde9e72ec2">RB_outputs_all_k</a>[n][<a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae8bf672ee83dac4058eb4deb5b660750">_k</a>] = 0.;
<a name="l00853"></a>00853       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_l=0; q_l&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#ab7f0b2268a9716189225e0446b519911">get_Q_l</a>(n); q_l++)
<a name="l00854"></a>00854       {
<a name="l00855"></a>00855         <a class="code" href="classlibMesh_1_1RBSystem.php#ab868a08069961fcde36a760e0094708a">RB_output_vectors</a>[n][q_l].get_principal_subvector(N, RB_output_vector_N);
<a name="l00856"></a>00856         <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ad5066d07edc5e25cb04b00fde9e72ec2">RB_outputs_all_k</a>[n][<a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae8bf672ee83dac4058eb4deb5b660750">_k</a>] += <a class="code" href="classlibMesh_1_1RBSystem.php#a3ab4b896903320a2b313f73efc2aaad1">eval_theta_q_l</a>(n,q_l)*RB_output_vector_N.<a class="code" href="classlibMesh_1_1DenseVector.php#a740926ab2815bb507a1e33b659414be1">dot</a>(RB_u_bar);
<a name="l00857"></a>00857       }
<a name="l00858"></a>00858 
<a name="l00859"></a>00859       <a class="code" href="classlibMesh_1_1TransientRBSystem.php#aeb55ea3e37e65db40b8dd322f4bcb4a6">RB_output_error_bounds_all_k</a>[n][<a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae8bf672ee83dac4058eb4deb5b660750">_k</a>] = <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a8e91d71806a187bb38f888c6541654b5">error_bound_all_k</a>[<a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae8bf672ee83dac4058eb4deb5b660750">_k</a>] * <a class="code" href="classlibMesh_1_1RBSystem.php#a6cae03a0338b32c65938db1f805deb3c">eval_output_dual_norm</a>(n);
<a name="l00860"></a>00860     }
<a name="l00861"></a>00861   }
<a name="l00862"></a>00862 
<a name="l00863"></a>00863   <span class="comment">// Now compute the L2 norm of the RB solution at time-level _K</span>
<a name="l00864"></a>00864   <span class="comment">// to normalize the error bound</span>
<a name="l00865"></a>00865   <span class="comment">// We reuse RB_rhs here</span>
<a name="l00866"></a>00866   RB_mass_matrix_N.<a class="code" href="classlibMesh_1_1DenseMatrix.php#a493649f63f70ca2adeaee645e26a4677">vector_mult</a>(RB_rhs, RB_u_bar);
<a name="l00867"></a>00867   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> final_RB_L2_norm = <a class="code" href="namespacelibMesh.php#aea33cac176f18504c5c4078407aadbb7">libmesh_real</a>(std::sqrt( RB_u_bar.<a class="code" href="classlibMesh_1_1DenseVector.php#a740926ab2815bb507a1e33b659414be1">dot</a>(RB_rhs) ));
<a name="l00868"></a>00868 
<a name="l00869"></a>00869   STOP_LOG(<span class="stringliteral">&quot;RB_solve()&quot;</span>, <span class="stringliteral">&quot;QNTransientRBSystem&quot;</span>);
<a name="l00870"></a>00870 
<a name="l00871"></a>00871   <span class="keywordflow">return</span> ( <a class="code" href="classlibMesh_1_1RBSystem.php#a56ab5090b2d6e6322742ade2772330e7">return_rel_error_bound</a> ? <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a8e91d71806a187bb38f888c6541654b5">error_bound_all_k</a>[<a class="code" href="classlibMesh_1_1TransientRBSystem.php#aac8858a7e9af6497f3c37a4b7956ca6a">_K</a>]/final_RB_L2_norm : <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a8e91d71806a187bb38f888c6541654b5">error_bound_all_k</a>[<a class="code" href="classlibMesh_1_1TransientRBSystem.php#aac8858a7e9af6497f3c37a4b7956ca6a">_K</a>] );
<a name="l00872"></a>00872 }
<a name="l00873"></a>00873 
<a name="l00874"></a>00874 
<a name="l00875"></a>00875 
<a name="l00876"></a>00876 
<a name="l00877"></a>00877 
<a name="l00878"></a><a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#acf2db6d212f85598337c42eddb9b66d3">00878</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#acf2db6d212f85598337c42eddb9b66d3">QNTransientRBSystem::update_system</a>()
<a name="l00879"></a>00879 {
<a name="l00880"></a>00880   <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a6eb3788340334cf4bcf9d8fa788c31f8">get_delta_N</a>() == 0)
<a name="l00881"></a>00881     <span class="keywordflow">return</span>;
<a name="l00882"></a>00882 
<a name="l00883"></a>00883   <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a>)
<a name="l00884"></a>00884   {
<a name="l00885"></a>00885     <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Updating trilinear form operators&quot;</span> &lt;&lt; std::endl;
<a name="l00886"></a>00886     <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a20ca0f91b2fb06a2fa0ed63e6151d8bf">update_trilinear_form_operators</a>();
<a name="l00887"></a>00887   }
<a name="l00888"></a>00888 
<a name="l00889"></a>00889   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae84573a528aea2088e92485998d83969">Parent::update_system</a>();
<a name="l00890"></a>00890 }
<a name="l00891"></a>00891 
<a name="l00892"></a><a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a1fd014607285e48d48b02106f0fcc9f1">00892</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a1fd014607285e48d48b02106f0fcc9f1">QNTransientRBSystem::compute_residual_dual_norm</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N)
<a name="l00893"></a>00893 {
<a name="l00894"></a>00894   START_LOG(<span class="stringliteral">&quot;compute_residual_dual_norm()&quot;</span>, <span class="stringliteral">&quot;QNTransientRBSystem&quot;</span>);
<a name="l00895"></a>00895 
<a name="l00896"></a>00896 <span class="comment">//  // This is the &quot;slow&quot; way of computing the residual, but it is useful</span>
<a name="l00897"></a>00897 <span class="comment">//  // for validating the &quot;fast&quot; way.</span>
<a name="l00898"></a>00898 <span class="comment">//  // Note that this only works in serial since otherwise each processor will</span>
<a name="l00899"></a>00899 <span class="comment">//  // have a different parameter value during the Greedy training.</span>
<a name="l00900"></a>00900 <span class="comment">//</span>
<a name="l00901"></a>00901 <span class="comment">//  // Create temporary vectors to store the system data</span>
<a name="l00902"></a>00902 <span class="comment">//  AutoPtr&lt; NumericVector&lt;Number&gt; &gt; temp1 = NumericVector&lt;Number&gt;::build();</span>
<a name="l00903"></a>00903 <span class="comment">//  temp1-&gt;init (this-&gt;n_dofs(), this-&gt;n_local_dofs(), false, libMeshEnums::PARALLEL);</span>
<a name="l00904"></a>00904 <span class="comment">//  temp1-&gt;zero();</span>
<a name="l00905"></a>00905 <span class="comment">//</span>
<a name="l00906"></a>00906 <span class="comment">//  AutoPtr&lt; NumericVector&lt;Number&gt; &gt; temp2 = NumericVector&lt;Number&gt;::build();</span>
<a name="l00907"></a>00907 <span class="comment">//  temp2-&gt;init (this-&gt;n_dofs(), this-&gt;n_local_dofs(), false, libMeshEnums::PARALLEL);</span>
<a name="l00908"></a>00908 <span class="comment">//  temp2-&gt;zero();</span>
<a name="l00909"></a>00909 <span class="comment">//</span>
<a name="l00910"></a>00910 <span class="comment">//  AutoPtr&lt; NumericVector&lt;Number&gt; &gt; ghosted_temp1 = NumericVector&lt;Number&gt;::build();</span>
<a name="l00911"></a>00911 <span class="comment">//  ghosted_temp1-&gt;init (this-&gt;n_dofs(), this-&gt;n_local_dofs(),</span>
<a name="l00912"></a>00912 <span class="comment">//                       this-&gt;get_dof_map().get_send_list(), false,</span>
<a name="l00913"></a>00913 <span class="comment">//                       GHOSTED);</span>
<a name="l00914"></a>00914 <span class="comment">//</span>
<a name="l00915"></a>00915 <span class="comment">//  AutoPtr&lt; NumericVector&lt;Number&gt; &gt; ghosted_temp2 = NumericVector&lt;Number&gt;::build();</span>
<a name="l00916"></a>00916 <span class="comment">//  ghosted_temp2-&gt;init (this-&gt;n_dofs(), this-&gt;n_local_dofs(),</span>
<a name="l00917"></a>00917 <span class="comment">//                       this-&gt;get_dof_map().get_send_list(), false,</span>
<a name="l00918"></a>00918 <span class="comment">//                       GHOSTED);</span>
<a name="l00919"></a>00919 <span class="comment">//</span>
<a name="l00920"></a>00920 <span class="comment">//  // Store old_solution, since we don&#39;t want to corrupt it in case call</span>
<a name="l00921"></a>00921 <span class="comment">//  // this function in between truth solves</span>
<a name="l00922"></a>00922 <span class="comment">//  *ghosted_temp1 = *old_local_solution;</span>
<a name="l00923"></a>00923 <span class="comment">//  *ghosted_temp2 = *current_newton_iterate;</span>
<a name="l00924"></a>00924 <span class="comment">//</span>
<a name="l00925"></a>00925 <span class="comment">//  current_newton_iterate-&gt;zero();</span>
<a name="l00926"></a>00926 <span class="comment">//  old_local_solution-&gt;zero();</span>
<a name="l00927"></a>00927 <span class="comment">//  for(unsigned int i=0; i&lt;N; i++)</span>
<a name="l00928"></a>00928 <span class="comment">//  {</span>
<a name="l00929"></a>00929 <span class="comment">//    temp1-&gt;add(RB_solution(i),     *basis_functions[i]);</span>
<a name="l00930"></a>00930 <span class="comment">//    temp2-&gt;add(old_RB_solution(i), *basis_functions[i]);</span>
<a name="l00931"></a>00931 <span class="comment">//  }</span>
<a name="l00932"></a>00932 <span class="comment">//  // Load temp1 and temp2 into current_newton_iterate and old_local_solution in order to do assembly</span>
<a name="l00933"></a>00933 <span class="comment">//  temp1-&gt;localize (*current_newton_iterate, this-&gt;get_dof_map().get_send_list());</span>
<a name="l00934"></a>00934 <span class="comment">//  temp2-&gt;localize (*old_local_solution, this-&gt;get_dof_map().get_send_list());</span>
<a name="l00935"></a>00935 <span class="comment">//</span>
<a name="l00936"></a>00936 <span class="comment">//  // Call truth assembly to put the residual in the rhs vector</span>
<a name="l00937"></a>00937 <span class="comment">//  this-&gt;truth_assembly();</span>
<a name="l00938"></a>00938 <span class="comment">//</span>
<a name="l00939"></a>00939 <span class="comment">//  // Restore current_newton_iterate and old_local_solution</span>
<a name="l00940"></a>00940 <span class="comment">//  *current_newton_iterate = *ghosted_temp1;</span>
<a name="l00941"></a>00941 <span class="comment">//  *old_local_solution     = *ghosted_temp2;</span>
<a name="l00942"></a>00942 <span class="comment">//</span>
<a name="l00943"></a>00943 <span class="comment">//  zero_dirichlet_dofs_on_rhs();</span>
<a name="l00944"></a>00944 <span class="comment">//</span>
<a name="l00945"></a>00945 <span class="comment">//  // Then solve the system to get the Reisz representor</span>
<a name="l00946"></a>00946 <span class="comment">//  matrix-&gt;zero();</span>
<a name="l00947"></a>00947 <span class="comment">//  matrix-&gt;add(1., *inner_product_matrix);</span>
<a name="l00948"></a>00948 <span class="comment">//</span>
<a name="l00949"></a>00949 <span class="comment">//  if(constrained_problem)</span>
<a name="l00950"></a>00950 <span class="comment">//    matrix-&gt;add(1., *constraint_matrix);</span>
<a name="l00951"></a>00951 <span class="comment">//</span>
<a name="l00952"></a>00952 <span class="comment">//  solution-&gt;zero();</span>
<a name="l00953"></a>00953 <span class="comment">//  solve();</span>
<a name="l00954"></a>00954 <span class="comment">//   // Make sure we didn&#39;t max out the number of iterations</span>
<a name="l00955"></a>00955 <span class="comment">//   if( (this-&gt;n_linear_iterations() &gt;=</span>
<a name="l00956"></a>00956 <span class="comment">//        this-&gt;get_equation_systems().parameters.get&lt;unsigned int&gt;(&quot;linear solver maximum iterations&quot;)) &amp;&amp;</span>
<a name="l00957"></a>00957 <span class="comment">//       (this-&gt;final_linear_residual() &gt;</span>
<a name="l00958"></a>00958 <span class="comment">//        this-&gt;get_equation_systems().parameters.get&lt;Real&gt;(&quot;linear solver tolerance&quot;)) )</span>
<a name="l00959"></a>00959 <span class="comment">//   {</span>
<a name="l00960"></a>00960 <span class="comment">//     libMesh::out &lt;&lt; &quot;Warning: Linear solver may not have converged! Final linear residual = &quot;</span>
<a name="l00961"></a>00961 <span class="comment">//                  &lt;&lt; this-&gt;final_linear_residual() &lt;&lt; &quot;, number of iterations = &quot;</span>
<a name="l00962"></a>00962 <span class="comment">//                  &lt;&lt; this-&gt;n_linear_iterations() &lt;&lt; std::endl &lt;&lt; std::endl;</span>
<a name="l00963"></a>00963 <span class="comment">// //     libmesh_error();</span>
<a name="l00964"></a>00964 <span class="comment">//   }</span>
<a name="l00965"></a>00965 <span class="comment">//</span>
<a name="l00966"></a>00966 <span class="comment">//  inner_product_matrix-&gt;vector_mult(*inner_product_storage_vector, *solution);</span>
<a name="l00967"></a>00967 <span class="comment">//  Real slow_residual_norm_sq = inner_product_storage_vector-&gt;dot(*solution);</span>
<a name="l00968"></a>00968 
<a name="l00969"></a>00969 
<a name="l00970"></a>00970   <span class="comment">// Use the stored representor inner product values</span>
<a name="l00971"></a>00971   <span class="comment">// to evaluate the residual dual norm</span>
<a name="l00972"></a>00972   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a04397bf3cc20ccd2bb5056c22b45c9f5">dt</a> = <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ab5a283a3f305fd03ee1f8e25a5f11bbc">get_dt</a>();
<a name="l00973"></a>00973 
<a name="l00974"></a>00974   <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> residual_norm_sq = 0.;
<a name="l00975"></a>00975 
<a name="l00976"></a>00976   <span class="comment">// Use TransientRBSystem to compute all the linear terms</span>
<a name="l00977"></a>00977   residual_norm_sq += <a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">pow</a>( <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a10c5a6e0813561fffc80d4cea195e814">TransientRBSystem::uncached_compute_residual_dual_norm</a>(N), 2.);
<a name="l00978"></a>00978 
<a name="l00979"></a>00979   <span class="comment">// Now just need to add the terms involving the nonlinearity</span>
<a name="l00980"></a>00980   std::vector&lt;Number&gt; RB_u_euler_theta(N);
<a name="l00981"></a>00981   std::vector&lt;Number&gt; mass_coeffs(N);
<a name="l00982"></a>00982   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;N; i++)
<a name="l00983"></a>00983   {
<a name="l00984"></a>00984     RB_u_euler_theta[i]  = <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a5af426f9dc2b27772aef689c19fbf4b0">euler_theta</a>*<a class="code" href="classlibMesh_1_1RBSystem.php#a201af52facfa4da38bc636ee2cf41c67">RB_solution</a>(i) + (1.-<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a5af426f9dc2b27772aef689c19fbf4b0">euler_theta</a>)*<a class="code" href="classlibMesh_1_1TransientRBSystem.php#adbbe1db7bf9fd6a56b949147cd75d79f">old_RB_solution</a>(i);
<a name="l00985"></a>00985     mass_coeffs[i] = -(<a class="code" href="classlibMesh_1_1RBSystem.php#a201af52facfa4da38bc636ee2cf41c67">RB_solution</a>(i) - <a class="code" href="classlibMesh_1_1TransientRBSystem.php#adbbe1db7bf9fd6a56b949147cd75d79f">old_RB_solution</a>(i))/dt;
<a name="l00986"></a>00986   }
<a name="l00987"></a>00987 
<a name="l00988"></a>00988   <span class="comment">// Pre-compute eval_theta_c()</span>
<a name="l00989"></a>00989   <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> cached_theta_c = <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a01234fb8ef324bdc9679e36895c5f5cc">eval_theta_c</a>();
<a name="l00990"></a>00990 
<a name="l00991"></a>00991   <span class="comment">// All residual terms can be treated as positive quantities...</span>
<a name="l00992"></a>00992   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_f=0; q_f&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>(); q_f++)
<a name="l00993"></a>00993   {
<a name="l00994"></a>00994     <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> cached_theta_q_f = <a class="code" href="classlibMesh_1_1RBSystem.php#a0fd951279c9b851ac38443156b4b18bd">eval_theta_q_f</a>(q_f);
<a name="l00995"></a>00995     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n1=0; n1&lt;N; n1++)
<a name="l00996"></a>00996     {
<a name="l00997"></a>00997       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j1=0; j1&lt;N; j1++)
<a name="l00998"></a>00998       {
<a name="l00999"></a>00999         residual_norm_sq += 2.*cached_theta_q_f*cached_theta_c*RB_u_euler_theta[n1]*RB_u_euler_theta[j1]
<a name="l01000"></a>01000                               *<a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#adb9ca8229335af78caf0b47b83285254">Fq_C_representor_norms</a>[q_f][n1][j1];
<a name="l01001"></a>01001       }
<a name="l01002"></a>01002     }
<a name="l01003"></a>01003   }
<a name="l01004"></a>01004 
<a name="l01005"></a>01005   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_m=0; q_m&lt;<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>(); q_m++)
<a name="l01006"></a>01006   {
<a name="l01007"></a>01007     <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> cached_theta_q_m = <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a36a6aa3be4fb96b256cb9d664e5a2dfb">eval_theta_q_m</a>(q_m);
<a name="l01008"></a>01008     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;N; i++)
<a name="l01009"></a>01009     {
<a name="l01010"></a>01010       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n1=0; n1&lt;N; n1++)
<a name="l01011"></a>01011       {
<a name="l01012"></a>01012         <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j1=0; j1&lt;N; j1++)
<a name="l01013"></a>01013         {
<a name="l01014"></a>01014           residual_norm_sq += 2.*cached_theta_q_m*cached_theta_c*
<a name="l01015"></a>01015                              mass_coeffs[i]*RB_u_euler_theta[n1]*RB_u_euler_theta[j1]*
<a name="l01016"></a>01016                              <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a39a9f2064c99ea89337c13afa0d59211">Mq_C_representor_norms</a>[q_m][i][n1][j1];
<a name="l01017"></a>01017         }
<a name="l01018"></a>01018       }
<a name="l01019"></a>01019     }
<a name="l01020"></a>01020   }
<a name="l01021"></a>01021 
<a name="l01022"></a>01022   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_a=0; q_a&lt;<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>(); q_a++)
<a name="l01023"></a>01023   {
<a name="l01024"></a>01024     <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> cached_theta_q_a = <a class="code" href="classlibMesh_1_1RBBase.php#aeeb46ce2b390bf820f954976ee9da7ce">eval_theta_q_a</a>(q_a);
<a name="l01025"></a>01025     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;N; i++)
<a name="l01026"></a>01026     {
<a name="l01027"></a>01027       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n1=0; n1&lt;N; n1++)
<a name="l01028"></a>01028       {
<a name="l01029"></a>01029         <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j1=0; j1&lt;N; j1++)
<a name="l01030"></a>01030         {
<a name="l01031"></a>01031           residual_norm_sq += 2.*cached_theta_q_a*cached_theta_c*
<a name="l01032"></a>01032                              RB_u_euler_theta[i]*RB_u_euler_theta[n1]*RB_u_euler_theta[j1]*
<a name="l01033"></a>01033                              <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#aa148f5aef2298825abbe912e80d6f3b7">Aq_C_representor_norms</a>[q_a][i][n1][j1];
<a name="l01034"></a>01034         }
<a name="l01035"></a>01035       }
<a name="l01036"></a>01036     }
<a name="l01037"></a>01037   }
<a name="l01038"></a>01038 
<a name="l01039"></a>01039   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n1=0; n1&lt;N; n1++)
<a name="l01040"></a>01040   {
<a name="l01041"></a>01041     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j1=0; j1&lt;N; j1++)
<a name="l01042"></a>01042     {
<a name="l01043"></a>01043       <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> RB_u_euler_theta_1 = RB_u_euler_theta[n1]*RB_u_euler_theta[j1];
<a name="l01044"></a>01044 
<a name="l01045"></a>01045       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n2=n1; n2&lt;N; n2++)
<a name="l01046"></a>01046       {
<a name="l01047"></a>01047         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> init_j2_index = (n2 == n1) ? j1 : 0;
<a name="l01048"></a>01048         <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j2=init_j2_index; j2&lt;N; j2++)
<a name="l01049"></a>01049         {
<a name="l01050"></a>01050           <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> RB_u_euler_theta_2 = RB_u_euler_theta[n2]*RB_u_euler_theta[j2];
<a name="l01051"></a>01051 
<a name="l01052"></a>01052           <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> delta = ( (n2 == n1) &amp;&amp; (j2 == j1) ) ? 1. : 2.;
<a name="l01053"></a>01053 
<a name="l01054"></a>01054           residual_norm_sq += delta*
<a name="l01055"></a>01055                               cached_theta_c*cached_theta_c*
<a name="l01056"></a>01056                               RB_u_euler_theta_1*RB_u_euler_theta_2*
<a name="l01057"></a>01057                               <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a626bab2fd06b6ac9e5498c9ad3098c98">C_C_representor_norms</a>[n1][j1][n2][j2];
<a name="l01058"></a>01058         }
<a name="l01059"></a>01059       }
<a name="l01060"></a>01060 
<a name="l01061"></a>01061     }
<a name="l01062"></a>01062   }
<a name="l01063"></a>01063 
<a name="l01064"></a>01064   <span class="keywordflow">if</span>(<a class="code" href="namespacelibMesh.php#aea33cac176f18504c5c4078407aadbb7">libmesh_real</a>(residual_norm_sq) &lt; 0.)
<a name="l01065"></a>01065   {
<a name="l01066"></a>01066     <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Warning: Square of residual norm is negative &quot;</span>
<a name="l01067"></a>01067                  &lt;&lt; <span class="stringliteral">&quot;in QNTransientRBSystem::compute_residual_dual_norm &quot;</span> &lt;&lt; std::endl;
<a name="l01068"></a>01068 
<a name="l01069"></a>01069     <span class="comment">// Sometimes this is negative due to rounding error,</span>
<a name="l01070"></a>01070     <span class="comment">// but this error shouldn&#39;t affect the error bound</span>
<a name="l01071"></a>01071     <span class="comment">// too much...</span>
<a name="l01072"></a>01072 <span class="comment">//     libmesh_error();</span>
<a name="l01073"></a>01073     residual_norm_sq = std::abs(residual_norm_sq);
<a name="l01074"></a>01074   }
<a name="l01075"></a>01075 
<a name="l01076"></a>01076 <span class="comment">//  libMesh::out &lt;&lt; &quot;slow residual_sq = &quot; &lt;&lt; slow_residual_norm_sq</span>
<a name="l01077"></a>01077 <span class="comment">//               &lt;&lt; &quot;, fast residual_sq = &quot; &lt;&lt; residual_norm_sq &lt;&lt; std::endl;</span>
<a name="l01078"></a>01078 
<a name="l01079"></a>01079   STOP_LOG(<span class="stringliteral">&quot;compute_residual_dual_norm()&quot;</span>, <span class="stringliteral">&quot;QNTransientRBSystem&quot;</span>);
<a name="l01080"></a>01080 
<a name="l01081"></a>01081   <span class="keywordflow">return</span> <a class="code" href="namespacelibMesh.php#aea33cac176f18504c5c4078407aadbb7">libmesh_real</a>(std::sqrt( residual_norm_sq ));
<a name="l01082"></a>01082 }
<a name="l01083"></a>01083 
<a name="l01084"></a><a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a91e4688ad8292008de8fa05a02f31481">01084</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a91e4688ad8292008de8fa05a02f31481">QNTransientRBSystem::update_RB_system_matrices</a>()
<a name="l01085"></a>01085 {
<a name="l01086"></a>01086   START_LOG(<span class="stringliteral">&quot;update_RB_system_matrices()&quot;</span>, <span class="stringliteral">&quot;QNTransientRBSystem&quot;</span>);
<a name="l01087"></a>01087   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a0bd7a0e822ac88f71f9dd7baeef179a7">Parent::update_RB_system_matrices</a>();
<a name="l01088"></a>01088 
<a name="l01089"></a>01089   <span class="comment">// Now we just need to assemble the trilinear form</span>
<a name="l01090"></a>01090   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> RB_size = <a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>();
<a name="l01091"></a>01091 
<a name="l01092"></a>01092   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;RB_size; n++)
<a name="l01093"></a>01093   {
<a name="l01094"></a>01094     <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a>)
<a name="l01095"></a>01095     {
<a name="l01096"></a>01096       <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a05c3a6cadebd4f91ff576e86faaf9585">assemble_C_n_matrix</a>(n, <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>);
<a name="l01097"></a>01097     }
<a name="l01098"></a>01098 
<a name="l01099"></a>01099     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;RB_size; j++)
<a name="l01100"></a>01100     {
<a name="l01101"></a>01101       <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a>)
<a name="l01102"></a>01102       {
<a name="l01103"></a>01103         <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a2b3a94130fa95eb33de4dd62d457d5ef">get_C_n</a>(n)-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#adaccc5857f1a5d5ca264ded0b8bfb986">vector_mult</a>(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>, <a class="code" href="classlibMesh_1_1RBSystem.php#a9ded22447be4ab3c0724bd060bfd9899">get_bf</a>(j));
<a name="l01104"></a>01104       }
<a name="l01105"></a>01105       <span class="keywordflow">else</span>
<a name="l01106"></a>01106       {
<a name="l01107"></a>01107         <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#adaccc5857f1a5d5ca264ded0b8bfb986">vector_mult</a>(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>, <a class="code" href="classlibMesh_1_1RBSystem.php#a9ded22447be4ab3c0724bd060bfd9899">get_bf</a>(j));
<a name="l01108"></a>01108       }
<a name="l01109"></a>01109 
<a name="l01110"></a>01110       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;RB_size; i++)
<a name="l01111"></a>01111       {
<a name="l01112"></a>01112         <span class="comment">// Short-circuit all entries that have already been initialized</span>
<a name="l01113"></a>01113         <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a6d593306c3c2c3ddede6a33b0943e7c4">RB_trilinear_form</a>[n][i][j] == 0.)
<a name="l01114"></a>01114         {
<a name="l01115"></a>01115           <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a6d593306c3c2c3ddede6a33b0943e7c4">RB_trilinear_form</a>[n][i][j] = <a class="code" href="classlibMesh_1_1RBSystem.php#a9ded22447be4ab3c0724bd060bfd9899">get_bf</a>(i).<a class="code" href="classlibMesh_1_1NumericVector.php#a1f522c421b32b75ea4dc3de6d1a95000">dot</a>(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>);
<a name="l01116"></a>01116         }
<a name="l01117"></a>01117       }
<a name="l01118"></a>01118     }
<a name="l01119"></a>01119   }
<a name="l01120"></a>01120 
<a name="l01121"></a>01121   STOP_LOG(<span class="stringliteral">&quot;update_RB_system_matrices()&quot;</span>, <span class="stringliteral">&quot;QNTransientRBSystem&quot;</span>);
<a name="l01122"></a>01122 }
<a name="l01123"></a>01123 
<a name="l01124"></a><a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a28166f6db60d1c5d7e5b5479798f1f8e">01124</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a28166f6db60d1c5d7e5b5479798f1f8e">QNTransientRBSystem::set_context_solution_vec</a>(<a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>&amp; vec)
<a name="l01125"></a>01125 {
<a name="l01126"></a>01126   <span class="comment">// Set current_local_solution = vec so that we can access</span>
<a name="l01127"></a>01127   <span class="comment">// vec from QNTransientRBContext during assembly</span>
<a name="l01128"></a>01128   vec.<a class="code" href="classlibMesh_1_1NumericVector.php#a7348b5b027adf716016354847e0df0b6">localize</a>
<a name="l01129"></a>01129     (*<a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#acb60710609da05611e7d440eb79a66ff">current_newton_iterate</a>, this-&gt;<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>().get_send_list());
<a name="l01130"></a>01130 }
<a name="l01131"></a>01131 
<a name="l01132"></a><a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a125b067cb931ba8223a76c414c46a903">01132</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a125b067cb931ba8223a76c414c46a903">QNTransientRBSystem::update_residual_terms</a>(<span class="keywordtype">bool</span> compute_inner_products)
<a name="l01133"></a>01133 {
<a name="l01134"></a>01134   START_LOG(<span class="stringliteral">&quot;update_residual_terms()&quot;</span>, <span class="stringliteral">&quot;QNTransientRBSystem&quot;</span>);
<a name="l01135"></a>01135 
<a name="l01136"></a>01136   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#af65ff4ed2f3257fa79a540aafd6d58bc">Parent::update_residual_terms</a>(compute_inner_products);
<a name="l01137"></a>01137 
<a name="l01138"></a>01138   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> RB_size = <a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>();
<a name="l01139"></a>01139 
<a name="l01140"></a>01140   <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a>)
<a name="l01141"></a>01141   {
<a name="l01142"></a>01142     <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#a966e0a6479f33c2518937e7d0f54602f">zero</a>();
<a name="l01143"></a>01143     <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#a401beeed965b80425730050a61de5c21">add</a>(1., *<a class="code" href="classlibMesh_1_1RBSystem.php#a330478ef4e1a158dc7b6f08530e10ff3">inner_product_matrix</a>);
<a name="l01144"></a>01144     <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBSystem.php#a28b1348023897cb1517724d6ac30a21d">constrained_problem</a>)
<a name="l01145"></a>01145       <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#a401beeed965b80425730050a61de5c21">add</a>(1., *<a class="code" href="classlibMesh_1_1RBSystem.php#aa7a3439518c1b8a421a79064e819f5c8">constraint_matrix</a>);
<a name="l01146"></a>01146   }
<a name="l01147"></a>01147   <span class="comment">// Don&#39;t need to assemble here in low-memory mode</span>
<a name="l01148"></a>01148   <span class="comment">// since we will assemble during the loop below</span>
<a name="l01149"></a>01149 
<a name="l01150"></a>01150   <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBSystem.php#a61f47d68b0df487674a9001d13d77c88">reuse_preconditioner</a>)
<a name="l01151"></a>01151   {
<a name="l01152"></a>01152     <span class="comment">// For the first solve, make sure we generate a new preconditioner</span>
<a name="l01153"></a>01153     <span class="comment">// Actually, this is not necessary as we can use the preconditioner</span>
<a name="l01154"></a>01154     <span class="comment">// generated by RBSystem::update_residual_terms()</span>
<a name="l01155"></a>01155     <a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a7cc68891fa9f44ded49b9b84c057cb32">linear_solver</a>-&gt;same_preconditioner = <span class="keyword">true</span>;
<a name="l01156"></a>01156   }
<a name="l01157"></a>01157 
<a name="l01158"></a>01158 
<a name="l01159"></a>01159   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;RB_size; n++)
<a name="l01160"></a>01160   {
<a name="l01161"></a>01161     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;RB_size; j++)
<a name="l01162"></a>01162     {
<a name="l01163"></a>01163       <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#aad10b1ffeb99e8261e99892ce0d209e5">C_representor</a>[n][j] == NULL) <span class="comment">// Short-circuit entries that are already initialized</span>
<a name="l01164"></a>01164       {
<a name="l01165"></a>01165         <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#aad10b1ffeb99e8261e99892ce0d209e5">C_representor</a>[n][j] = <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;::build</a>().release();
<a name="l01166"></a>01166         <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#aad10b1ffeb99e8261e99892ce0d209e5">C_representor</a>[n][j]-&gt;init(this-&gt;<a class="code" href="classlibMesh_1_1System.php#a90dbb901f00c14ff18399f4afabcebe5">n_dofs</a>(), this-&gt;<a class="code" href="classlibMesh_1_1System.php#ae3aeb82e65b06789823d41da3c5df7a2">n_local_dofs</a>(), <span class="keyword">false</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">libMeshEnums::PARALLEL</a>);
<a name="l01167"></a>01167 
<a name="l01168"></a>01168         <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a>)
<a name="l01169"></a>01169         {
<a name="l01170"></a>01170           <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a2b3a94130fa95eb33de4dd62d457d5ef">get_C_n</a>(n)-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#adaccc5857f1a5d5ca264ded0b8bfb986">vector_mult</a>(*<a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a>, <a class="code" href="classlibMesh_1_1RBSystem.php#a9ded22447be4ab3c0724bd060bfd9899">get_bf</a>(j));
<a name="l01171"></a>01171         }
<a name="l01172"></a>01172         <span class="keywordflow">else</span>
<a name="l01173"></a>01173         {
<a name="l01174"></a>01174           <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a05c3a6cadebd4f91ff576e86faaf9585">assemble_C_n_matrix</a>(n, <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>);
<a name="l01175"></a>01175           <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#adaccc5857f1a5d5ca264ded0b8bfb986">vector_mult</a>(*<a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a>, <a class="code" href="classlibMesh_1_1RBSystem.php#a9ded22447be4ab3c0724bd060bfd9899">get_bf</a>(j));
<a name="l01176"></a>01176 
<a name="l01177"></a>01177           <span class="comment">// Now need to restore the inner product matrix</span>
<a name="l01178"></a>01178           <a class="code" href="classlibMesh_1_1RBSystem.php#a2bde84b5899642d6bb6ba2f6ac4a51f9">assemble_inner_product_matrix</a>(<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>);
<a name="l01179"></a>01179           <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBSystem.php#a28b1348023897cb1517724d6ac30a21d">constrained_problem</a>)
<a name="l01180"></a>01180             <a class="code" href="classlibMesh_1_1RBSystem.php#a4a1243f45ea36fbd2a10ad6956c62deb">add_scaled_matrix_and_vector</a>(1., <a class="code" href="classlibMesh_1_1RBSystem.php#a9c6da671e41886e26c7e88aae82f4358">constraint_assembly</a>, NULL, <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>, NULL);
<a name="l01181"></a>01181 
<a name="l01182"></a>01182 <span class="comment">// Can&#39;t use a matvec here since we need to access two vectors</span>
<a name="l01183"></a>01183 <span class="comment">// for the trilinear form and matvec just accesses one vector</span>
<a name="l01184"></a>01184 <span class="comment">//           assemble_scaled_matvec(1.,</span>
<a name="l01185"></a>01185 <span class="comment">//                                  C_assembly,</span>
<a name="l01186"></a>01186 <span class="comment">//                                  *rhs,</span>
<a name="l01187"></a>01187 <span class="comment">//                                  *basis_functions[j]);</span>
<a name="l01188"></a>01188         }
<a name="l01189"></a>01189 
<a name="l01190"></a>01190         <a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a7efb30d08bd1bb55a91f66782238d648">scale</a>(-1.); <span class="comment">// Negate: more convenient for residual calculations</span>
<a name="l01191"></a>01191         <a class="code" href="classlibMesh_1_1RBSystem.php#a85c25bbd66bed6e4111e44566e91b5ff">zero_dirichlet_dofs_on_rhs</a>();
<a name="l01192"></a>01192 
<a name="l01193"></a>01193         <a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;zero();
<a name="l01194"></a>01194 
<a name="l01195"></a>01195         <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1RBSystem.php#adec856bc209f0533639d76767bd5ebbc">quiet</a>)
<a name="l01196"></a>01196           <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Starting solve [n][j]=[&quot;</span>
<a name="l01197"></a>01197                        &lt;&lt; n &lt;&lt;<span class="stringliteral">&quot;][&quot;</span>&lt;&lt; j &lt;&lt; <span class="stringliteral">&quot;] in QNTransientRBSystem::update_residual_terms() at &quot;</span>
<a name="l01198"></a>01198                        &lt;&lt; <a class="code" href="namespacelibMesh_1_1Utility.php#a0e4485920eb5de9a47b6f8760a11361d">Utility::get_timestamp</a>() &lt;&lt; std::endl;
<a name="l01199"></a>01199 
<a name="l01200"></a>01200         <a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#af1de21a76860785bb1992280eb72b0db">solve</a>();
<a name="l01201"></a>01201 
<a name="l01202"></a>01202         <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1RBSystem.php#adec856bc209f0533639d76767bd5ebbc">quiet</a>)
<a name="l01203"></a>01203           {
<a name="l01204"></a>01204             <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Finished solve [n][j]=[&quot;</span>
<a name="l01205"></a>01205                          &lt;&lt; n &lt;&lt;<span class="stringliteral">&quot;][&quot;</span>&lt;&lt; j &lt;&lt; <span class="stringliteral">&quot;] in QNTransientRBSystem::update_residual_terms() at &quot;</span>
<a name="l01206"></a>01206                          &lt;&lt; <a class="code" href="namespacelibMesh_1_1Utility.php#a0e4485920eb5de9a47b6f8760a11361d">Utility::get_timestamp</a>() &lt;&lt; std::endl;
<a name="l01207"></a>01207 
<a name="l01208"></a>01208             <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; this-&gt;<a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#af712dbf0e285c5ff4cc346daef05423c">n_linear_iterations</a>()
<a name="l01209"></a>01209                          &lt;&lt; <span class="stringliteral">&quot; iterations, final residual &quot;</span>
<a name="l01210"></a>01210                          &lt;&lt; this-&gt;<a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a86b5e2954d2a2e43014bcda8810239ac">final_linear_residual</a>() &lt;&lt; std::endl;
<a name="l01211"></a>01211           }
<a name="l01212"></a>01212 
<a name="l01213"></a>01213         <span class="comment">// Make sure we didn&#39;t max out the number of iterations</span>
<a name="l01214"></a>01214         <span class="keywordflow">if</span>( (this-&gt;<a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#af712dbf0e285c5ff4cc346daef05423c">n_linear_iterations</a>() &gt;=
<a name="l01215"></a>01215             this-&gt;<a class="code" href="classlibMesh_1_1System.php#ac5ca6b1f3adcfac56982982e90dc905b">get_equation_systems</a>().parameters.get&lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&gt;(<span class="stringliteral">&quot;linear solver maximum iterations&quot;</span>)) &amp;&amp;
<a name="l01216"></a>01216             (this-&gt;final_linear_residual() &gt;
<a name="l01217"></a>01217             this-&gt;<a class="code" href="classlibMesh_1_1System.php#ac5ca6b1f3adcfac56982982e90dc905b">get_equation_systems</a>().<a class="code" href="classlibMesh_1_1EquationSystems.php#a7c02be232f564967ca0804a7824adb53">parameters</a>.<a class="code" href="classlibMesh_1_1Parameters.php#ac7fa2054ee32db2c3979d48bd2103f20">get</a>&lt;<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>&gt;(<span class="stringliteral">&quot;linear solver tolerance&quot;</span>)) )
<a name="l01218"></a>01218         {
<a name="l01219"></a>01219           <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Warning: Linear solver may not have converged. Final linear residual = &quot;</span>
<a name="l01220"></a>01220                        &lt;&lt; this-&gt;<a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a86b5e2954d2a2e43014bcda8810239ac">final_linear_residual</a>() &lt;&lt; <span class="stringliteral">&quot;, number of iterations = &quot;</span>
<a name="l01221"></a>01221                        &lt;&lt; this-&gt;<a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#af712dbf0e285c5ff4cc346daef05423c">n_linear_iterations</a>() &lt;&lt; std::endl &lt;&lt; std::endl;
<a name="l01222"></a>01222 <span class="comment">//           libmesh_error();</span>
<a name="l01223"></a>01223         }
<a name="l01224"></a>01224 
<a name="l01225"></a>01225         *<a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#aad10b1ffeb99e8261e99892ce0d209e5">C_representor</a>[n][j] = *<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>;
<a name="l01226"></a>01226 
<a name="l01227"></a>01227         <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBSystem.php#a61f47d68b0df487674a9001d13d77c88">reuse_preconditioner</a>)
<a name="l01228"></a>01228         {
<a name="l01229"></a>01229           <span class="comment">// After we do a solve, tell PETSc we want to reuse the preconditioner</span>
<a name="l01230"></a>01230           <span class="comment">// since the system matrix is not changing.</span>
<a name="l01231"></a>01231           <a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a7cc68891fa9f44ded49b9b84c057cb32">linear_solver</a>-&gt;same_preconditioner = <span class="keyword">true</span>;
<a name="l01232"></a>01232         }
<a name="l01233"></a>01233       }
<a name="l01234"></a>01234     }
<a name="l01235"></a>01235   }
<a name="l01236"></a>01236 
<a name="l01237"></a>01237   <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBSystem.php#a61f47d68b0df487674a9001d13d77c88">reuse_preconditioner</a>)
<a name="l01238"></a>01238   {
<a name="l01239"></a>01239     <span class="comment">// We no longer want to reuse the preconditioner</span>
<a name="l01240"></a>01240     <a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a7cc68891fa9f44ded49b9b84c057cb32">linear_solver</a>-&gt;same_preconditioner = <span class="keyword">false</span>;
<a name="l01241"></a>01241   }
<a name="l01242"></a>01242 
<a name="l01243"></a>01243   <span class="comment">// Now compute the necessary inner products if requested</span>
<a name="l01244"></a>01244   <span class="keywordflow">if</span> (compute_inner_products)
<a name="l01245"></a>01245     {
<a name="l01246"></a>01246       <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a> &amp;&amp; <a class="code" href="classlibMesh_1_1RBSystem.php#a28b1348023897cb1517724d6ac30a21d">constrained_problem</a>)
<a name="l01247"></a>01247         <a class="code" href="classlibMesh_1_1RBSystem.php#a2bde84b5899642d6bb6ba2f6ac4a51f9">assemble_inner_product_matrix</a>(<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>);
<a name="l01248"></a>01248 
<a name="l01249"></a>01249       <span class="comment">// We short-circuit all entries that are non-zero</span>
<a name="l01250"></a>01250       <span class="comment">// to avoid re-computing inner products unnecessarily</span>
<a name="l01251"></a>01251       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_f=0; q_f&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>(); q_f++)
<a name="l01252"></a>01252         {
<a name="l01253"></a>01253           <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a>)
<a name="l01254"></a>01254             {
<a name="l01255"></a>01255               <a class="code" href="classlibMesh_1_1RBSystem.php#a330478ef4e1a158dc7b6f08530e10ff3">inner_product_matrix</a>-&gt;vector_mult(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>, *<a class="code" href="classlibMesh_1_1RBSystem.php#acd91cfaa84058427cda2885e4d6d30ce">F_q_representor</a>[q_f]);
<a name="l01256"></a>01256             }
<a name="l01257"></a>01257           <span class="keywordflow">else</span>
<a name="l01258"></a>01258             {
<a name="l01259"></a>01259               <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#adaccc5857f1a5d5ca264ded0b8bfb986">vector_mult</a>(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>, *<a class="code" href="classlibMesh_1_1RBSystem.php#acd91cfaa84058427cda2885e4d6d30ce">F_q_representor</a>[q_f]);
<a name="l01260"></a>01260             }
<a name="l01261"></a>01261 
<a name="l01262"></a>01262           <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n1=0; n1&lt;RB_size; n1++)
<a name="l01263"></a>01263             {
<a name="l01264"></a>01264               <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j1=0; j1&lt;RB_size; j1++)
<a name="l01265"></a>01265                 {
<a name="l01266"></a>01266                   <span class="keywordflow">if</span>( <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#adb9ca8229335af78caf0b47b83285254">Fq_C_representor_norms</a>[q_f][n1][j1] == 0. )
<a name="l01267"></a>01267                     {
<a name="l01268"></a>01268                       <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#adb9ca8229335af78caf0b47b83285254">Fq_C_representor_norms</a>[q_f][n1][j1] =
<a name="l01269"></a>01269                         <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#aad10b1ffeb99e8261e99892ce0d209e5">C_representor</a>[n1][j1]-&gt;dot(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>);
<a name="l01270"></a>01270                     }
<a name="l01271"></a>01271                 } <span class="comment">// end for j1</span>
<a name="l01272"></a>01272             } <span class="comment">// end for n1</span>
<a name="l01273"></a>01273         } <span class="comment">// end for q_f</span>
<a name="l01274"></a>01274 
<a name="l01275"></a>01275       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_m=0; q_m&lt;<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>(); q_m++)
<a name="l01276"></a>01276         {
<a name="l01277"></a>01277           <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;RB_size; i++)
<a name="l01278"></a>01278             {
<a name="l01279"></a>01279               <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a>)
<a name="l01280"></a>01280                 {
<a name="l01281"></a>01281                   <a class="code" href="classlibMesh_1_1RBSystem.php#a330478ef4e1a158dc7b6f08530e10ff3">inner_product_matrix</a>-&gt;vector_mult(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>, *<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a7b52b6d7cf4f4f9245464050e876d21b">M_q_representor</a>[q_m][i]);
<a name="l01282"></a>01282                 }
<a name="l01283"></a>01283               <span class="keywordflow">else</span>
<a name="l01284"></a>01284                 {
<a name="l01285"></a>01285                   <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#adaccc5857f1a5d5ca264ded0b8bfb986">vector_mult</a>(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>, *<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a7b52b6d7cf4f4f9245464050e876d21b">M_q_representor</a>[q_m][i]);
<a name="l01286"></a>01286                 }
<a name="l01287"></a>01287 
<a name="l01288"></a>01288               <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n1=0; n1&lt;RB_size; n1++)
<a name="l01289"></a>01289                 {
<a name="l01290"></a>01290                   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j1=0; j1&lt;RB_size; j1++)
<a name="l01291"></a>01291                     {
<a name="l01292"></a>01292                       <span class="keywordflow">if</span>( <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a39a9f2064c99ea89337c13afa0d59211">Mq_C_representor_norms</a>[q_m][i][n1][j1] == 0. )
<a name="l01293"></a>01293                         {
<a name="l01294"></a>01294                           <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a39a9f2064c99ea89337c13afa0d59211">Mq_C_representor_norms</a>[q_m][i][n1][j1] =
<a name="l01295"></a>01295                             <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#aad10b1ffeb99e8261e99892ce0d209e5">C_representor</a>[n1][j1]-&gt;dot(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>);
<a name="l01296"></a>01296                         }
<a name="l01297"></a>01297                     } <span class="comment">// end for j1</span>
<a name="l01298"></a>01298                 } <span class="comment">// end for n1</span>
<a name="l01299"></a>01299             } <span class="comment">// end for i</span>
<a name="l01300"></a>01300         } <span class="comment">// end for q_m</span>
<a name="l01301"></a>01301 
<a name="l01302"></a>01302       
<a name="l01303"></a>01303       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_a=0; q_a&lt;<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>(); q_a++)
<a name="l01304"></a>01304         {
<a name="l01305"></a>01305           <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;RB_size; i++)
<a name="l01306"></a>01306             {
<a name="l01307"></a>01307               <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a>)
<a name="l01308"></a>01308                 {
<a name="l01309"></a>01309                   <a class="code" href="classlibMesh_1_1RBSystem.php#a330478ef4e1a158dc7b6f08530e10ff3">inner_product_matrix</a>-&gt;vector_mult(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>, *<a class="code" href="classlibMesh_1_1RBSystem.php#a9c8fb2a4cb5b77e59e36bfff438aed01">A_q_representor</a>[q_a][i]);
<a name="l01310"></a>01310                 }
<a name="l01311"></a>01311               <span class="keywordflow">else</span>
<a name="l01312"></a>01312                 {
<a name="l01313"></a>01313                   <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#adaccc5857f1a5d5ca264ded0b8bfb986">vector_mult</a>(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>, *<a class="code" href="classlibMesh_1_1RBSystem.php#a9c8fb2a4cb5b77e59e36bfff438aed01">A_q_representor</a>[q_a][i]);
<a name="l01314"></a>01314                 }
<a name="l01315"></a>01315 
<a name="l01316"></a>01316               <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n1=0; n1&lt;RB_size; n1++)
<a name="l01317"></a>01317                 {
<a name="l01318"></a>01318                   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j1=0; j1&lt;RB_size; j1++)
<a name="l01319"></a>01319                     {
<a name="l01320"></a>01320                       <span class="keywordflow">if</span>( <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#aa148f5aef2298825abbe912e80d6f3b7">Aq_C_representor_norms</a>[q_a][i][n1][j1] == 0. )
<a name="l01321"></a>01321                         {
<a name="l01322"></a>01322                           <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#aa148f5aef2298825abbe912e80d6f3b7">Aq_C_representor_norms</a>[q_a][i][n1][j1] =
<a name="l01323"></a>01323                             <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#aad10b1ffeb99e8261e99892ce0d209e5">C_representor</a>[n1][j1]-&gt;dot(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>);
<a name="l01324"></a>01324                         }
<a name="l01325"></a>01325                     } <span class="comment">// end for j1</span>
<a name="l01326"></a>01326                 } <span class="comment">// end for n1</span>
<a name="l01327"></a>01327             } <span class="comment">// end for i</span>
<a name="l01328"></a>01328         } <span class="comment">// end for q_a</span>
<a name="l01329"></a>01329 
<a name="l01330"></a>01330       
<a name="l01331"></a>01331       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n1=0; n1&lt;RB_size; n1++)
<a name="l01332"></a>01332         {
<a name="l01333"></a>01333           <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j1=0; j1&lt;RB_size; j1++)
<a name="l01334"></a>01334             {
<a name="l01335"></a>01335               <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a>)
<a name="l01336"></a>01336                 {
<a name="l01337"></a>01337                   <a class="code" href="classlibMesh_1_1RBSystem.php#a330478ef4e1a158dc7b6f08530e10ff3">inner_product_matrix</a>-&gt;vector_mult(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>, *<a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#aad10b1ffeb99e8261e99892ce0d209e5">C_representor</a>[n1][j1]);
<a name="l01338"></a>01338                 }
<a name="l01339"></a>01339               <span class="keywordflow">else</span>
<a name="l01340"></a>01340                 {
<a name="l01341"></a>01341                   <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#adaccc5857f1a5d5ca264ded0b8bfb986">vector_mult</a>(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>, *<a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#aad10b1ffeb99e8261e99892ce0d209e5">C_representor</a>[n1][j1]);
<a name="l01342"></a>01342                 }
<a name="l01343"></a>01343 
<a name="l01344"></a>01344               <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n2=0; n2&lt;RB_size; n2++)
<a name="l01345"></a>01345                 {
<a name="l01346"></a>01346                   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j2=0; j2&lt;RB_size; j2++)
<a name="l01347"></a>01347                     {
<a name="l01348"></a>01348                       <span class="keywordflow">if</span>( <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a626bab2fd06b6ac9e5498c9ad3098c98">C_C_representor_norms</a>[n1][j1][n2][j2] == 0.)
<a name="l01349"></a>01349                         {
<a name="l01350"></a>01350                           <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a626bab2fd06b6ac9e5498c9ad3098c98">C_C_representor_norms</a>[n1][j1][n2][j2] =
<a name="l01351"></a>01351                             <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#aad10b1ffeb99e8261e99892ce0d209e5">C_representor</a>[n2][j2]-&gt;dot(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>);
<a name="l01352"></a>01352                         }
<a name="l01353"></a>01353                     } <span class="comment">// end for j2</span>
<a name="l01354"></a>01354                 } <span class="comment">// end for n2</span>
<a name="l01355"></a>01355             } <span class="comment">// end for j1</span>
<a name="l01356"></a>01356         } <span class="comment">// end for n1</span>
<a name="l01357"></a>01357     } <span class="comment">// end if (compute_inner_products)</span>
<a name="l01358"></a>01358 
<a name="l01359"></a>01359 
<a name="l01360"></a>01360   STOP_LOG(<span class="stringliteral">&quot;update_residual_terms()&quot;</span>, <span class="stringliteral">&quot;QNTransientRBSystem&quot;</span>);
<a name="l01361"></a>01361 }
<a name="l01362"></a>01362 
<a name="l01363"></a><a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#aa86181b359bfc9f13fa9d5cebb210e63">01363</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#aa86181b359bfc9f13fa9d5cebb210e63">QNTransientRBSystem::attach_C</a>(<a class="code" href="namespacelibMesh.php#aa62736885c7a9bb67eda65b54ee20107">theta_q_fptr</a> theta_c_in, <a class="code" href="namespacelibMesh.php#a18a170af3a9d5eff6f43eb3409d0e296">affine_assembly_fptr</a> C_assembly_in)
<a name="l01364"></a>01364 {
<a name="l01365"></a>01365   <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a0bd74afcd8112ac109b91f02c870a28a">C_assembly</a> = C_assembly_in;
<a name="l01366"></a>01366   <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a45f28a803b5af2e6c65d386a4b66e0bb">theta_c</a> = theta_c_in;
<a name="l01367"></a>01367 }
<a name="l01368"></a>01368 
<a name="l01369"></a><a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a6b0546f02800c2b03094f441d10a5620">01369</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a6b0546f02800c2b03094f441d10a5620">QNTransientRBSystem::attach_truth_assembly</a>(<a class="code" href="namespacelibMesh.php#a18a170af3a9d5eff6f43eb3409d0e296">affine_assembly_fptr</a> truth_intrr_assembly_in,
<a name="l01370"></a>01370                                                <a class="code" href="namespacelibMesh.php#a18a170af3a9d5eff6f43eb3409d0e296">affine_assembly_fptr</a> truth_bndry_assembly_in)
<a name="l01371"></a>01371 {
<a name="l01372"></a>01372   <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#af3de81b6715f0ff5ea0f1916d5ae90fc">truth_intrr_assembly</a> = truth_intrr_assembly_in;
<a name="l01373"></a>01373   <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a48e249153e5977052febec98cde4fe64">truth_bndry_assembly</a> = truth_bndry_assembly_in;
<a name="l01374"></a>01374 }
<a name="l01375"></a>01375 
<a name="l01376"></a><a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a20ca0f91b2fb06a2fa0ed63e6151d8bf">01376</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a20ca0f91b2fb06a2fa0ed63e6151d8bf">QNTransientRBSystem::update_trilinear_form_operators</a>()
<a name="l01377"></a>01377 {
<a name="l01378"></a>01378   START_LOG(<span class="stringliteral">&quot;update_trilinear_form_operators()&quot;</span>, <span class="stringliteral">&quot;QNTransientRBSystem&quot;</span>);
<a name="l01379"></a>01379 
<a name="l01380"></a>01380   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> RB_size = <a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>();
<a name="l01381"></a>01381   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=(RB_size-<a class="code" href="classlibMesh_1_1RBSystem.php#a36ba489bd3158bbff48a5607e1d21d30">delta_N</a>); n&lt;RB_size; n++)
<a name="l01382"></a>01382   {
<a name="l01383"></a>01383     <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a05c3a6cadebd4f91ff576e86faaf9585">assemble_C_n_matrix</a>(n, <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a2b3a94130fa95eb33de4dd62d457d5ef">get_C_n</a>(n));
<a name="l01384"></a>01384   }
<a name="l01385"></a>01385   STOP_LOG(<span class="stringliteral">&quot;update_trilinear_form_operators()&quot;</span>, <span class="stringliteral">&quot;QNTransientRBSystem&quot;</span>);
<a name="l01386"></a>01386 }
<a name="l01387"></a>01387 
<a name="l01388"></a><a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a95d8333ed2c6da4d76033bc343cca7a4">01388</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a95d8333ed2c6da4d76033bc343cca7a4">QNTransientRBSystem::update_all_trilinear_form_operators</a>()
<a name="l01389"></a>01389 {
<a name="l01390"></a>01390   <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a> &amp;&amp; <a class="code" href="classlibMesh_1_1RBBase.php#a11c4b80a15c0e9ea1d822f5e04545059">initialize_calN_dependent_data</a>)
<a name="l01391"></a>01391   {
<a name="l01392"></a>01392     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> saved_delta_N = <a class="code" href="classlibMesh_1_1RBSystem.php#a36ba489bd3158bbff48a5607e1d21d30">delta_N</a>;
<a name="l01393"></a>01393     <a class="code" href="classlibMesh_1_1RBSystem.php#a36ba489bd3158bbff48a5607e1d21d30">delta_N</a> = <a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>();
<a name="l01394"></a>01394     <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a20ca0f91b2fb06a2fa0ed63e6151d8bf">update_trilinear_form_operators</a>();
<a name="l01395"></a>01395     <a class="code" href="classlibMesh_1_1RBSystem.php#a36ba489bd3158bbff48a5607e1d21d30">delta_N</a> = saved_delta_N;
<a name="l01396"></a>01396   }
<a name="l01397"></a>01397 }
<a name="l01398"></a>01398 
<a name="l01399"></a><a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a2b3a94130fa95eb33de4dd62d457d5ef">01399</a> <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;Number&gt;</a>* <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a2b3a94130fa95eb33de4dd62d457d5ef">QNTransientRBSystem::get_C_n</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n)
<a name="l01400"></a>01400 {
<a name="l01401"></a>01401   <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a>)
<a name="l01402"></a>01402   {
<a name="l01403"></a>01403     <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error: The C matrices are not stored in low-memory mode.&quot;</span> &lt;&lt; std::endl;
<a name="l01404"></a>01404     libmesh_error();
<a name="l01405"></a>01405   }
<a name="l01406"></a>01406 
<a name="l01407"></a>01407   <span class="keywordflow">if</span>(n &gt;= <a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>())
<a name="l01408"></a>01408   {
<a name="l01409"></a>01409     <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error: We must have n &lt; get_n_basis_functions() in get_C_n.&quot;</span>
<a name="l01410"></a>01410                  &lt;&lt; std::endl;
<a name="l01411"></a>01411     libmesh_error();
<a name="l01412"></a>01412   }
<a name="l01413"></a>01413 
<a name="l01414"></a>01414   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a6befde9564b470c5908912bb7258e726">C_n_vector</a>[n];
<a name="l01415"></a>01415 }
<a name="l01416"></a>01416 
<a name="l01417"></a><a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a05c3a6cadebd4f91ff576e86faaf9585">01417</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a05c3a6cadebd4f91ff576e86faaf9585">QNTransientRBSystem::assemble_C_n_matrix</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n, <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;Number&gt;</a>* input_matrix)
<a name="l01418"></a>01418 {
<a name="l01419"></a>01419   <span class="keywordflow">if</span>(n &gt;= <a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>())
<a name="l01420"></a>01420   {
<a name="l01421"></a>01421     <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error: We must have n &lt; get_n_basis_functions() in assemble_C_n_matrix.&quot;</span>
<a name="l01422"></a>01422                  &lt;&lt; std::endl;
<a name="l01423"></a>01423     libmesh_error();
<a name="l01424"></a>01424   }
<a name="l01425"></a>01425 
<a name="l01426"></a>01426   <span class="comment">// Store basis_functions[n] in current_newton_iterate for assembly</span>
<a name="l01427"></a>01427   <a class="code" href="classlibMesh_1_1RBSystem.php#abfe6d67ed23243d225f12747f355f105">basis_functions</a>[n]-&gt;localize
<a name="l01428"></a>01428     (*<a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#acb60710609da05611e7d440eb79a66ff">current_newton_iterate</a>, this-&gt;<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>().get_send_list());
<a name="l01429"></a>01429 
<a name="l01430"></a>01430   input_matrix-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#a966e0a6479f33c2518937e7d0f54602f">zero</a>();
<a name="l01431"></a>01431   <a class="code" href="classlibMesh_1_1RBSystem.php#a4a1243f45ea36fbd2a10ad6956c62deb">add_scaled_matrix_and_vector</a>(1.,
<a name="l01432"></a>01432                                <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a0bd74afcd8112ac109b91f02c870a28a">C_assembly</a>,
<a name="l01433"></a>01433                                NULL,
<a name="l01434"></a>01434                                input_matrix,
<a name="l01435"></a>01435                                NULL);
<a name="l01436"></a>01436 }
<a name="l01437"></a>01437 
<a name="l01438"></a><a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a18c78570401eb41027d51e62743feb1f">01438</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a18c78570401eb41027d51e62743feb1f">QNTransientRBSystem::add_scaled_Cn</a>(<a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> scalar, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n, <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;Number&gt;</a>* input_matrix, <span class="keywordtype">bool</span> symmetrize)
<a name="l01439"></a>01439 {
<a name="l01440"></a>01440   START_LOG(<span class="stringliteral">&quot;add_scaled_Cn()&quot;</span>, <span class="stringliteral">&quot;QNTransientRBSystem&quot;</span>);
<a name="l01441"></a>01441 
<a name="l01442"></a>01442   <span class="keywordflow">if</span>(n &gt;= <a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>())
<a name="l01443"></a>01443   {
<a name="l01444"></a>01444     <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error: We must have n &lt; get_n_basis_functions() in add_scaled_Cn.&quot;</span>
<a name="l01445"></a>01445                  &lt;&lt; std::endl;
<a name="l01446"></a>01446     libmesh_error();
<a name="l01447"></a>01447   }
<a name="l01448"></a>01448 
<a name="l01449"></a>01449   <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a> &amp;&amp; !symmetrize)
<a name="l01450"></a>01450   {
<a name="l01451"></a>01451     input_matrix-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#a401beeed965b80425730050a61de5c21">add</a>(scalar, *<a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a2b3a94130fa95eb33de4dd62d457d5ef">get_C_n</a>(n));
<a name="l01452"></a>01452     input_matrix-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#a9a0781a7136e2f0f45b15cebef780522">close</a>();
<a name="l01453"></a>01453   }
<a name="l01454"></a>01454   <span class="keywordflow">else</span>
<a name="l01455"></a>01455   {
<a name="l01456"></a>01456     <span class="comment">// Store basis_functions[n] in current_newton_iterate for assembly</span>
<a name="l01457"></a>01457     <a class="code" href="classlibMesh_1_1RBSystem.php#abfe6d67ed23243d225f12747f355f105">basis_functions</a>[n]-&gt;localize
<a name="l01458"></a>01458       (*<a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#acb60710609da05611e7d440eb79a66ff">current_newton_iterate</a>, this-&gt;<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>().get_send_list());
<a name="l01459"></a>01459 
<a name="l01460"></a>01460     <a class="code" href="classlibMesh_1_1RBSystem.php#a4a1243f45ea36fbd2a10ad6956c62deb">add_scaled_matrix_and_vector</a>(scalar,
<a name="l01461"></a>01461                                 <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a0bd74afcd8112ac109b91f02c870a28a">C_assembly</a>,
<a name="l01462"></a>01462                                 NULL,
<a name="l01463"></a>01463                                 input_matrix,
<a name="l01464"></a>01464                                 NULL,
<a name="l01465"></a>01465                                 symmetrize);
<a name="l01466"></a>01466   }
<a name="l01467"></a>01467 
<a name="l01468"></a>01468   STOP_LOG(<span class="stringliteral">&quot;add_scaled_Cn()&quot;</span>, <span class="stringliteral">&quot;QNTransientRBSystem&quot;</span>);
<a name="l01469"></a>01469 }
<a name="l01470"></a>01470 
<a name="l01471"></a><a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a56c58a2fe4fe93ccb1911bfc7d4a6f84">01471</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a56c58a2fe4fe93ccb1911bfc7d4a6f84">QNTransientRBSystem::add_scaled_current_C</a>(<a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> scalar, <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;Number&gt;</a>* input_matrix, <span class="keywordtype">bool</span> symmetrize)
<a name="l01472"></a>01472 {
<a name="l01473"></a>01473   START_LOG(<span class="stringliteral">&quot;add_scaled_current_C()&quot;</span>, <span class="stringliteral">&quot;QNTransientRBSystem&quot;</span>);
<a name="l01474"></a>01474 
<a name="l01475"></a>01475   <span class="comment">// Assemble based on the current value of current_newton_iterate</span>
<a name="l01476"></a>01476   <a class="code" href="classlibMesh_1_1RBSystem.php#a4a1243f45ea36fbd2a10ad6956c62deb">add_scaled_matrix_and_vector</a>(scalar,
<a name="l01477"></a>01477                                <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a0bd74afcd8112ac109b91f02c870a28a">C_assembly</a>,
<a name="l01478"></a>01478                                NULL,
<a name="l01479"></a>01479                                input_matrix,
<a name="l01480"></a>01480                                NULL,
<a name="l01481"></a>01481                                symmetrize);
<a name="l01482"></a>01482 
<a name="l01483"></a>01483   STOP_LOG(<span class="stringliteral">&quot;add_scaled_current_C()&quot;</span>, <span class="stringliteral">&quot;QNTransientRBSystem&quot;</span>);
<a name="l01484"></a>01484 }
<a name="l01485"></a>01485 
<a name="l01486"></a><a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a6a72e8968c88bee95ed7742ab853d55c">01486</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a6a72e8968c88bee95ed7742ab853d55c">QNTransientRBSystem::get_SCM_lower_bound</a>()
<a name="l01487"></a>01487 {
<a name="l01488"></a>01488   <span class="comment">// Get the SCM lower bound from eigen_system</span>
<a name="l01489"></a>01489   <a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es = this-&gt;<a class="code" href="classlibMesh_1_1System.php#ac5ca6b1f3adcfac56982982e90dc905b">get_equation_systems</a>();
<a name="l01490"></a>01490   <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php">QNTransientSCMSystem</a>&amp; eigen_system = es.<a class="code" href="classlibMesh_1_1EquationSystems.php#a5dac23f839af25ce7dbf1fe9a6d4b67a">get_system</a>&lt;<a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php">QNTransientSCMSystem</a>&gt;(<a class="code" href="classlibMesh_1_1RBSystem.php#ab53684df668b4dbad08d68fd6be1fd37">eigen_system_name</a>);
<a name="l01491"></a>01491 
<a name="l01492"></a>01492   <span class="comment">// Create a parameter vector in which the current time-level</span>
<a name="l01493"></a>01493   <span class="comment">// is appended to current_parameters.</span>
<a name="l01494"></a>01494   std::vector&lt;Real&gt; params(<a class="code" href="classlibMesh_1_1RBBase.php#a2c3f951cf69b5da83a67734be6b01972">get_n_params</a>()+1);
<a name="l01495"></a>01495   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1RBBase.php#a2c3f951cf69b5da83a67734be6b01972">get_n_params</a>(); i++)
<a name="l01496"></a>01496     params[i] = <a class="code" href="classlibMesh_1_1RBBase.php#af3bb451bd612eb5e7e8f0684f4b9cc97">get_current_parameters</a>()[i];
<a name="l01497"></a>01497 
<a name="l01498"></a>01498   params[params.size()-1] = <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae8bf672ee83dac4058eb4deb5b660750">_k</a>;
<a name="l01499"></a>01499 
<a name="l01500"></a>01500   <span class="comment">// Also, construct a vector storing the RB coefficients</span>
<a name="l01501"></a>01501   std::vector&lt;Number&gt; RB_u_euler_theta(<a class="code" href="classlibMesh_1_1RBSystem.php#a201af52facfa4da38bc636ee2cf41c67">RB_solution</a>.<a class="code" href="classlibMesh_1_1DenseVector.php#ab124ecf2f46ee43b167f093b05d81fdb">size</a>());
<a name="l01502"></a>01502   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#a201af52facfa4da38bc636ee2cf41c67">RB_solution</a>.<a class="code" href="classlibMesh_1_1DenseVector.php#ab124ecf2f46ee43b167f093b05d81fdb">size</a>(); i++)
<a name="l01503"></a>01503     RB_u_euler_theta[i] = <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a5af426f9dc2b27772aef689c19fbf4b0">euler_theta</a>*<a class="code" href="classlibMesh_1_1RBSystem.php#a201af52facfa4da38bc636ee2cf41c67">RB_solution</a>(i) + (1.-<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a5af426f9dc2b27772aef689c19fbf4b0">euler_theta</a>)*<a class="code" href="classlibMesh_1_1TransientRBSystem.php#adbbe1db7bf9fd6a56b949147cd75d79f">old_RB_solution</a>(i);
<a name="l01504"></a>01504 
<a name="l01505"></a>01505   <span class="comment">// Pass params and RB_u_euler_theta to the associated SCM system</span>
<a name="l01506"></a>01506   eigen_system.<a class="code" href="classlibMesh_1_1RBBase.php#a04037fe5c23e9d9e5652936888cb8f0f">set_current_parameters</a>( params );
<a name="l01507"></a>01507   eigen_system.<a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a07e0ef2d5546ee2beb4f5ae4e3d3a7dc">set_current_RB_coeffs</a>( RB_u_euler_theta );
<a name="l01508"></a>01508   <span class="keywordflow">return</span> eigen_system.<a class="code" href="classlibMesh_1_1RBSCMSystem.php#aec9345df172fa49477f94c46d9d991a0">get_SCM_LB</a>();
<a name="l01509"></a>01509 }
<a name="l01510"></a>01510 
<a name="l01511"></a><a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a9df81dce8a528580a53ea943176ba483">01511</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a9df81dce8a528580a53ea943176ba483">QNTransientRBSystem::get_SCM_upper_bound</a>()
<a name="l01512"></a>01512 {
<a name="l01513"></a>01513   <span class="comment">// Get the SCM lower bound from eigen_system</span>
<a name="l01514"></a>01514   <a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es = this-&gt;<a class="code" href="classlibMesh_1_1System.php#ac5ca6b1f3adcfac56982982e90dc905b">get_equation_systems</a>();
<a name="l01515"></a>01515   <a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php">QNTransientSCMSystem</a>&amp; eigen_system = es.<a class="code" href="classlibMesh_1_1EquationSystems.php#a5dac23f839af25ce7dbf1fe9a6d4b67a">get_system</a>&lt;<a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php">QNTransientSCMSystem</a>&gt;(<a class="code" href="classlibMesh_1_1RBSystem.php#ab53684df668b4dbad08d68fd6be1fd37">eigen_system_name</a>);
<a name="l01516"></a>01516 
<a name="l01517"></a>01517   <span class="comment">// Create a parameter vector in which the current time-level</span>
<a name="l01518"></a>01518   <span class="comment">// is appended to current_parameters.</span>
<a name="l01519"></a>01519   std::vector&lt;Real&gt; params(<a class="code" href="classlibMesh_1_1RBBase.php#a2c3f951cf69b5da83a67734be6b01972">get_n_params</a>()+1);
<a name="l01520"></a>01520   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1RBBase.php#a2c3f951cf69b5da83a67734be6b01972">get_n_params</a>(); i++)
<a name="l01521"></a>01521     params[i] = <a class="code" href="classlibMesh_1_1RBBase.php#af3bb451bd612eb5e7e8f0684f4b9cc97">get_current_parameters</a>()[i];
<a name="l01522"></a>01522 
<a name="l01523"></a>01523   params[params.size()-1] = <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae8bf672ee83dac4058eb4deb5b660750">_k</a>;
<a name="l01524"></a>01524 
<a name="l01525"></a>01525   std::vector&lt;Number&gt; RB_u_euler_theta(<a class="code" href="classlibMesh_1_1RBSystem.php#a201af52facfa4da38bc636ee2cf41c67">RB_solution</a>.<a class="code" href="classlibMesh_1_1DenseVector.php#ab124ecf2f46ee43b167f093b05d81fdb">size</a>());
<a name="l01526"></a>01526   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#a201af52facfa4da38bc636ee2cf41c67">RB_solution</a>.<a class="code" href="classlibMesh_1_1DenseVector.php#ab124ecf2f46ee43b167f093b05d81fdb">size</a>(); i++)
<a name="l01527"></a>01527     RB_u_euler_theta[i] = <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a5af426f9dc2b27772aef689c19fbf4b0">euler_theta</a>*<a class="code" href="classlibMesh_1_1RBSystem.php#a201af52facfa4da38bc636ee2cf41c67">RB_solution</a>(i) + (1.-<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a5af426f9dc2b27772aef689c19fbf4b0">euler_theta</a>)*<a class="code" href="classlibMesh_1_1TransientRBSystem.php#adbbe1db7bf9fd6a56b949147cd75d79f">old_RB_solution</a>(i);
<a name="l01528"></a>01528 
<a name="l01529"></a>01529   eigen_system.<a class="code" href="classlibMesh_1_1RBBase.php#a04037fe5c23e9d9e5652936888cb8f0f">set_current_parameters</a>( params );
<a name="l01530"></a>01530   eigen_system.<a class="code" href="classlibMesh_1_1QNTransientSCMSystem.php#a07e0ef2d5546ee2beb4f5ae4e3d3a7dc">set_current_RB_coeffs</a>( RB_u_euler_theta );
<a name="l01531"></a>01531   <span class="keywordflow">return</span> eigen_system.<a class="code" href="classlibMesh_1_1RBSCMSystem.php#ab481b656b3310e857f2a51e3e3fff497">get_SCM_UB</a>();
<a name="l01532"></a>01532 }
<a name="l01533"></a>01533 
<a name="l01534"></a>01534 
<a name="l01535"></a>01535 
<a name="l01536"></a><a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#af5896e03cfcc54a32c8c6a54a13e81d4">01536</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#af5896e03cfcc54a32c8c6a54a13e81d4">QNTransientRBSystem::write_offline_data_to_files</a>(<span class="keyword">const</span> std::string&amp; directory_name)
<a name="l01537"></a>01537 {
<a name="l01538"></a>01538   START_LOG(<span class="stringliteral">&quot;write_offline_data_to_files()&quot;</span>, <span class="stringliteral">&quot;QNTransientRBSystem&quot;</span>);
<a name="l01539"></a>01539 
<a name="l01540"></a>01540   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a2616deed6f2ad941535bcaf7fb9505a5">Parent::write_offline_data_to_files</a>(directory_name);
<a name="l01541"></a>01541 
<a name="l01542"></a>01542   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_bfs = <a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>();
<a name="l01543"></a>01543   libmesh_assert( n_bfs &lt;= <a class="code" href="classlibMesh_1_1RBSystem.php#ab47d6a963c4f68b5a3d1eea7905257f5">Nmax</a> );
<a name="l01544"></a>01544 
<a name="l01545"></a>01545   <span class="comment">// We use a lower precision here (only 10 digits) since</span>
<a name="l01546"></a>01546   <span class="comment">// the trilinear form terms can take up a _lot_ of disk</span>
<a name="l01547"></a>01547   <span class="comment">// space</span>
<a name="l01548"></a>01548   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> precision_level = 10;
<a name="l01549"></a>01549 
<a name="l01550"></a>01550   <span class="keywordflow">if</span>(<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l01551"></a>01551   {
<a name="l01552"></a>01552     <span class="comment">// Write out the RB trilinear form</span>
<a name="l01553"></a>01553     std::ofstream RB_trilinear_form_out;
<a name="l01554"></a>01554     {
<a name="l01555"></a>01555       <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l01556"></a>01556       file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/RB_trilinear_form.dat&quot;</span>;
<a name="l01557"></a>01557       RB_trilinear_form_out.open(file_name.str().c_str());
<a name="l01558"></a>01558     }
<a name="l01559"></a>01559     <span class="keywordflow">if</span> ( !RB_trilinear_form_out.good() )
<a name="l01560"></a>01560     {
<a name="l01561"></a>01561       <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening RB_trilinear_form.dat&quot;</span> &lt;&lt; std::endl;
<a name="l01562"></a>01562       libmesh_error();
<a name="l01563"></a>01563     }
<a name="l01564"></a>01564     RB_trilinear_form_out.precision(precision_level);
<a name="l01565"></a>01565     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_bfs; i++)
<a name="l01566"></a>01566     {
<a name="l01567"></a>01567       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;n_bfs; j++)
<a name="l01568"></a>01568       {
<a name="l01569"></a>01569         <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> l=0; l&lt;n_bfs; l++)
<a name="l01570"></a>01570         {
<a name="l01571"></a>01571           RB_trilinear_form_out &lt;&lt; std::scientific &lt;&lt; <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a6d593306c3c2c3ddede6a33b0943e7c4">RB_trilinear_form</a>[i][j][l] &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l01572"></a>01572         }
<a name="l01573"></a>01573       }
<a name="l01574"></a>01574     }
<a name="l01575"></a>01575     RB_trilinear_form_out &lt;&lt; std::endl;
<a name="l01576"></a>01576     RB_trilinear_form_out.close();
<a name="l01577"></a>01577 
<a name="l01578"></a>01578     <span class="comment">// Next write out the Fq_C representor norm data</span>
<a name="l01579"></a>01579     std::ofstream RB_Fq_C_norms_out;
<a name="l01580"></a>01580     {
<a name="l01581"></a>01581       <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l01582"></a>01582       file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/Fq_C_norms.dat&quot;</span>;
<a name="l01583"></a>01583       RB_Fq_C_norms_out.open(file_name.str().c_str());
<a name="l01584"></a>01584     }
<a name="l01585"></a>01585     <span class="keywordflow">if</span> ( !RB_Fq_C_norms_out.good() )
<a name="l01586"></a>01586     {
<a name="l01587"></a>01587       <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening Fq_C_norms.dat&quot;</span> &lt;&lt; std::endl;
<a name="l01588"></a>01588       libmesh_error();
<a name="l01589"></a>01589     }
<a name="l01590"></a>01590     RB_Fq_C_norms_out.precision(precision_level);
<a name="l01591"></a>01591     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_f=0; q_f&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>(); q_f++)
<a name="l01592"></a>01592     {
<a name="l01593"></a>01593       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n1=0; n1&lt;n_bfs; n1++)
<a name="l01594"></a>01594       {
<a name="l01595"></a>01595         <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j1=0; j1&lt;n_bfs; j1++)
<a name="l01596"></a>01596         {
<a name="l01597"></a>01597           RB_Fq_C_norms_out &lt;&lt; std::scientific &lt;&lt; <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#adb9ca8229335af78caf0b47b83285254">Fq_C_representor_norms</a>[q_f][n1][j1] &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l01598"></a>01598         }
<a name="l01599"></a>01599       }
<a name="l01600"></a>01600     }
<a name="l01601"></a>01601     RB_Fq_C_norms_out.close();
<a name="l01602"></a>01602 
<a name="l01603"></a>01603     <span class="comment">// Next write out the Mq_C representor norm data</span>
<a name="l01604"></a>01604     std::ofstream RB_Mq_C_norms_out;
<a name="l01605"></a>01605     {
<a name="l01606"></a>01606       <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l01607"></a>01607       file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/Mq_C_norms.dat&quot;</span>;
<a name="l01608"></a>01608       RB_Mq_C_norms_out.open(file_name.str().c_str());
<a name="l01609"></a>01609     }
<a name="l01610"></a>01610     <span class="keywordflow">if</span> ( !RB_Mq_C_norms_out.good() )
<a name="l01611"></a>01611     {
<a name="l01612"></a>01612       <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening Mq_C_norms.dat&quot;</span> &lt;&lt; std::endl;
<a name="l01613"></a>01613       libmesh_error();
<a name="l01614"></a>01614     }
<a name="l01615"></a>01615     RB_Mq_C_norms_out.precision(precision_level);
<a name="l01616"></a>01616     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_m=0; q_m&lt;<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>(); q_m++)
<a name="l01617"></a>01617     {
<a name="l01618"></a>01618       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_bfs; i++)
<a name="l01619"></a>01619       {
<a name="l01620"></a>01620         <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n1=0; n1&lt;n_bfs; n1++)
<a name="l01621"></a>01621         {
<a name="l01622"></a>01622           <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j1=0; j1&lt;n_bfs; j1++)
<a name="l01623"></a>01623           {
<a name="l01624"></a>01624             RB_Mq_C_norms_out &lt;&lt; std::scientific &lt;&lt; <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a39a9f2064c99ea89337c13afa0d59211">Mq_C_representor_norms</a>[q_m][i][n1][j1] &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l01625"></a>01625           }
<a name="l01626"></a>01626         }
<a name="l01627"></a>01627       }
<a name="l01628"></a>01628     }
<a name="l01629"></a>01629     RB_Mq_C_norms_out.close();
<a name="l01630"></a>01630 
<a name="l01631"></a>01631     <span class="comment">// Next write out the Aq_C representor norm data</span>
<a name="l01632"></a>01632     std::ofstream RB_Aq_C_norms_out;
<a name="l01633"></a>01633     {
<a name="l01634"></a>01634       <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l01635"></a>01635       file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/Aq_C_norms.dat&quot;</span>;
<a name="l01636"></a>01636       RB_Aq_C_norms_out.open(file_name.str().c_str());
<a name="l01637"></a>01637     }
<a name="l01638"></a>01638     <span class="keywordflow">if</span> ( !RB_Aq_C_norms_out.good() )
<a name="l01639"></a>01639     {
<a name="l01640"></a>01640       <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening Aq_C_norms.dat&quot;</span> &lt;&lt; std::endl;
<a name="l01641"></a>01641       libmesh_error();
<a name="l01642"></a>01642     }
<a name="l01643"></a>01643     RB_Aq_C_norms_out.precision(precision_level);
<a name="l01644"></a>01644     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_a=0; q_a&lt;<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>(); q_a++)
<a name="l01645"></a>01645     {
<a name="l01646"></a>01646       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_bfs; i++)
<a name="l01647"></a>01647       {
<a name="l01648"></a>01648         <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n1=0; n1&lt;n_bfs; n1++)
<a name="l01649"></a>01649         {
<a name="l01650"></a>01650           <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j1=0; j1&lt;n_bfs; j1++)
<a name="l01651"></a>01651           {
<a name="l01652"></a>01652             RB_Aq_C_norms_out &lt;&lt; std::scientific &lt;&lt; <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#aa148f5aef2298825abbe912e80d6f3b7">Aq_C_representor_norms</a>[q_a][i][n1][j1] &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l01653"></a>01653           }
<a name="l01654"></a>01654         }
<a name="l01655"></a>01655       }
<a name="l01656"></a>01656     }
<a name="l01657"></a>01657     RB_Aq_C_norms_out.close();
<a name="l01658"></a>01658 
<a name="l01659"></a>01659     <span class="comment">// Next write out the C_C representor norm data</span>
<a name="l01660"></a>01660     std::ofstream RB_C_C_norms_out;
<a name="l01661"></a>01661     {
<a name="l01662"></a>01662       <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l01663"></a>01663       file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/C_C_norms.dat&quot;</span>;
<a name="l01664"></a>01664       RB_C_C_norms_out.open(file_name.str().c_str());
<a name="l01665"></a>01665     }
<a name="l01666"></a>01666     <span class="keywordflow">if</span> ( !RB_C_C_norms_out.good() )
<a name="l01667"></a>01667     {
<a name="l01668"></a>01668       <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening C_C_norms.dat&quot;</span> &lt;&lt; std::endl;
<a name="l01669"></a>01669       libmesh_error();
<a name="l01670"></a>01670     }
<a name="l01671"></a>01671     RB_C_C_norms_out.precision(precision_level);
<a name="l01672"></a>01672     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n1=0; n1&lt;n_bfs; n1++)
<a name="l01673"></a>01673     {
<a name="l01674"></a>01674       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j1=0; j1&lt;n_bfs; j1++)
<a name="l01675"></a>01675       {
<a name="l01676"></a>01676         <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n2=0; n2&lt;n_bfs; n2++)
<a name="l01677"></a>01677         {
<a name="l01678"></a>01678           <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j2=0; j2&lt;n_bfs; j2++)
<a name="l01679"></a>01679           {
<a name="l01680"></a>01680             RB_C_C_norms_out &lt;&lt; std::scientific &lt;&lt; <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a626bab2fd06b6ac9e5498c9ad3098c98">C_C_representor_norms</a>[n1][j1][n2][j2] &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l01681"></a>01681           }
<a name="l01682"></a>01682         }
<a name="l01683"></a>01683       }
<a name="l01684"></a>01684     }
<a name="l01685"></a>01685     RB_C_C_norms_out &lt;&lt; std::endl;
<a name="l01686"></a>01686     RB_C_C_norms_out.close();
<a name="l01687"></a>01687   }
<a name="l01688"></a>01688 
<a name="l01689"></a>01689   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1RBSystem.php#a5ac870aac52f838bd28ee088ddc095b0">store_representors</a>)
<a name="l01690"></a>01690     {
<a name="l01691"></a>01691       <span class="comment">// Write out C_representors.  These are useful to have when restarting,</span>
<a name="l01692"></a>01692       <span class="comment">// so you don&#39;t have to recompute them all over again.  There should be</span>
<a name="l01693"></a>01693       <span class="comment">// Nmax^2 of these, but we only write out up to N, where N is the current RB</span>
<a name="l01694"></a>01694       <span class="comment">// dimension.</span>
<a name="l01695"></a>01695       <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Writing out the C_representors...&quot;</span> &lt;&lt; std::endl;
<a name="l01696"></a>01696 
<a name="l01697"></a>01697       std::ostringstream file_name;
<a name="l01698"></a>01698       <span class="keyword">const</span> std::string residual_representor_suffix = (<a class="code" href="classlibMesh_1_1RBSystem.php#a399f7ee60adcc350ce7f27e8c60ed9de">write_binary_residual_representors</a> ? <span class="stringliteral">&quot;.xdr&quot;</span> : <span class="stringliteral">&quot;.dat&quot;</span>);
<a name="l01699"></a>01699       <span class="comment">//  struct stat stat_info;</span>
<a name="l01700"></a>01700 
<a name="l01701"></a>01701       <span class="comment">// Residual representors written out to their own separate directory</span>
<a name="l01702"></a>01702       std::string residual_representors_dir = <span class="stringliteral">&quot;residual_representors&quot;</span>;
<a name="l01703"></a>01703 
<a name="l01704"></a>01704       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> new_start_index = this-&gt;<a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>() - <a class="code" href="classlibMesh_1_1RBSystem.php#a36ba489bd3158bbff48a5607e1d21d30">delta_N</a>;
<a name="l01705"></a>01705 
<a name="l01706"></a>01706       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;this-&gt;<a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>(); ++i)
<a name="l01707"></a>01707         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;this-&gt;<a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>(); ++j)
<a name="l01708"></a>01708           {
<a name="l01709"></a>01709             <span class="comment">// if (C_representor[i][j] != NULL)</span>
<a name="l01710"></a>01710             <span class="keywordflow">if</span> ( (i &gt;= new_start_index) || <span class="comment">// do all columns in the new rows</span>
<a name="l01711"></a>01711                  (j &gt;= new_start_index) )  <span class="comment">// in old rows, just do new columns</span>
<a name="l01712"></a>01712               {
<a name="l01713"></a>01713                 <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Writing out C_representor[&quot;</span> &lt;&lt; i &lt;&lt; <span class="stringliteral">&quot;][&quot;</span> &lt;&lt; j &lt;&lt; <span class="stringliteral">&quot;]...&quot;</span> &lt;&lt; std::endl;
<a name="l01714"></a>01714                 libmesh_assert(<a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#aad10b1ffeb99e8261e99892ce0d209e5">C_representor</a>[i][j] != NULL);
<a name="l01715"></a>01715 
<a name="l01716"></a>01716                 file_name.str(<span class="stringliteral">&quot;&quot;</span>); <span class="comment">// reset filename</span>
<a name="l01717"></a>01717                 file_name &lt;&lt; residual_representors_dir
<a name="l01718"></a>01718                           &lt;&lt; <span class="stringliteral">&quot;/C_representor&quot;</span> &lt;&lt; i &lt;&lt; <span class="stringliteral">&quot;_&quot;</span> &lt;&lt; j &lt;&lt; residual_representor_suffix;
<a name="l01719"></a>01719 
<a name="l01720"></a>01720                 {
<a name="l01721"></a>01721                   <span class="comment">// No need to copy!</span>
<a name="l01722"></a>01722                   <span class="comment">// *solution = *(C_representor[i][j]);</span>
<a name="l01723"></a>01723                   <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#aad10b1ffeb99e8261e99892ce0d209e5">C_representor</a>[i][j]-&gt;swap(*<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>);
<a name="l01724"></a>01724 
<a name="l01725"></a>01725                   <a class="code" href="classlibMesh_1_1Xdr.php">Xdr</a> c_data(file_name.str(),
<a name="l01726"></a>01726                              <a class="code" href="classlibMesh_1_1RBSystem.php#a399f7ee60adcc350ce7f27e8c60ed9de">write_binary_residual_representors</a> ? <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8ae5559170d41d912b449375bb4e3468f6">ENCODE</a> : <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a47f4bcd4fcf418da5ec74d3d8e2c3bc4">WRITE</a>);
<a name="l01727"></a>01727 
<a name="l01728"></a>01728                   <a class="code" href="classlibMesh_1_1System.php#ae8063c135acc9c54240886e1ac3c9acd">write_serialized_data</a>(c_data, <span class="keyword">false</span>);
<a name="l01729"></a>01729 
<a name="l01730"></a>01730                   <span class="comment">// Synchronize before moving on</span>
<a name="l01731"></a>01731                   <a class="code" href="namespacelibMesh_1_1Parallel.php#a95416053432ed0ab6d1231070bfebeff">Parallel::barrier</a>();
<a name="l01732"></a>01732 
<a name="l01733"></a>01733                   <span class="comment">// Swap back</span>
<a name="l01734"></a>01734                   <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#aad10b1ffeb99e8261e99892ce0d209e5">C_representor</a>[i][j]-&gt;swap(*<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>);
<a name="l01735"></a>01735 
<a name="l01736"></a>01736                   <span class="comment">// TODO: bzip the resulting file?  See $LIBMESH_DIR/src/mesh/unstructured_mesh.C</span>
<a name="l01737"></a>01737                   <span class="comment">// for the system call, be sure to do it only on one processor, etc.</span>
<a name="l01738"></a>01738                 }
<a name="l01739"></a>01739               }
<a name="l01740"></a>01740           }
<a name="l01741"></a>01741     } <span class="comment">// end if (store_representors)</span>
<a name="l01742"></a>01742 
<a name="l01743"></a>01743   STOP_LOG(<span class="stringliteral">&quot;write_offline_data_to_files()&quot;</span>, <span class="stringliteral">&quot;QNTransientRBSystem&quot;</span>);
<a name="l01744"></a>01744 }
<a name="l01745"></a>01745 
<a name="l01746"></a>01746 
<a name="l01747"></a>01747 
<a name="l01748"></a>01748 
<a name="l01749"></a><a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a11fbad0ec4505c6f1cc3be89fb981db6">01749</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a11fbad0ec4505c6f1cc3be89fb981db6">QNTransientRBSystem::read_offline_data_from_files</a>(<span class="keyword">const</span> std::string&amp; directory_name)
<a name="l01750"></a>01750 {
<a name="l01751"></a>01751   START_LOG(<span class="stringliteral">&quot;read_offline_data_from_files()&quot;</span>, <span class="stringliteral">&quot;QNTransientRBSystem&quot;</span>);
<a name="l01752"></a>01752 
<a name="l01753"></a>01753   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a8d0eb6348fd67e5a619279fbdf41fa62">Parent::read_offline_data_from_files</a>(directory_name);
<a name="l01754"></a>01754 
<a name="l01755"></a>01755   <span class="comment">// First, find out how many basis functions we had when Greedy terminated</span>
<a name="l01756"></a>01756   <span class="comment">// This was set in RBSystem::read_offline_data_from_files</span>
<a name="l01757"></a>01757   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_bfs = this-&gt;<a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>();
<a name="l01758"></a>01758 
<a name="l01759"></a>01759   <span class="comment">// Read in the RB trilinear form</span>
<a name="l01760"></a>01760   std::ifstream RB_trilinear_form_in;
<a name="l01761"></a>01761   {
<a name="l01762"></a>01762     <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l01763"></a>01763     file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/RB_trilinear_form.dat&quot;</span>;
<a name="l01764"></a>01764     RB_trilinear_form_in.open(file_name.str().c_str());
<a name="l01765"></a>01765   }
<a name="l01766"></a>01766   <span class="keywordflow">if</span> ( !RB_trilinear_form_in.good() )
<a name="l01767"></a>01767   {
<a name="l01768"></a>01768     <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening RB_trilinear_form.dat&quot;</span> &lt;&lt; std::endl;
<a name="l01769"></a>01769     libmesh_error();
<a name="l01770"></a>01770   }
<a name="l01771"></a>01771   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_bfs; i++)
<a name="l01772"></a>01772   {
<a name="l01773"></a>01773     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;n_bfs; j++)
<a name="l01774"></a>01774     {
<a name="l01775"></a>01775       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> l=0; l&lt;n_bfs; l++)
<a name="l01776"></a>01776       {
<a name="l01777"></a>01777         RB_trilinear_form_in &gt;&gt; <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a6d593306c3c2c3ddede6a33b0943e7c4">RB_trilinear_form</a>[i][j][l];
<a name="l01778"></a>01778       }
<a name="l01779"></a>01779     }
<a name="l01780"></a>01780   }
<a name="l01781"></a>01781   RB_trilinear_form_in.close();
<a name="l01782"></a>01782 
<a name="l01783"></a>01783   <span class="comment">// Next read in the Fq_C representor norm data</span>
<a name="l01784"></a>01784   std::ifstream RB_Fq_C_norms_in;
<a name="l01785"></a>01785   {
<a name="l01786"></a>01786     <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l01787"></a>01787     file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/Fq_C_norms.dat&quot;</span>;
<a name="l01788"></a>01788     RB_Fq_C_norms_in.open(file_name.str().c_str());
<a name="l01789"></a>01789   }
<a name="l01790"></a>01790   <span class="keywordflow">if</span> ( !RB_Fq_C_norms_in.good() )
<a name="l01791"></a>01791   {
<a name="l01792"></a>01792     <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening Fq_C_norms.dat&quot;</span> &lt;&lt; std::endl;
<a name="l01793"></a>01793     libmesh_error();
<a name="l01794"></a>01794   }
<a name="l01795"></a>01795   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_f=0; q_f&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>(); q_f++)
<a name="l01796"></a>01796   {
<a name="l01797"></a>01797     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n1=0; n1&lt;n_bfs; n1++)
<a name="l01798"></a>01798     {
<a name="l01799"></a>01799       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j1=0; j1&lt;n_bfs; j1++)
<a name="l01800"></a>01800       {
<a name="l01801"></a>01801         RB_Fq_C_norms_in &gt;&gt; <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#adb9ca8229335af78caf0b47b83285254">Fq_C_representor_norms</a>[q_f][n1][j1];
<a name="l01802"></a>01802       }
<a name="l01803"></a>01803     }
<a name="l01804"></a>01804   }
<a name="l01805"></a>01805   RB_Fq_C_norms_in.close();
<a name="l01806"></a>01806 
<a name="l01807"></a>01807   <span class="comment">// Next read in the Mq_C representor norm data</span>
<a name="l01808"></a>01808   std::ifstream RB_Mq_C_norms_in;
<a name="l01809"></a>01809   {
<a name="l01810"></a>01810     <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l01811"></a>01811     file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/Mq_C_norms.dat&quot;</span>;
<a name="l01812"></a>01812     RB_Mq_C_norms_in.open(file_name.str().c_str());
<a name="l01813"></a>01813   }
<a name="l01814"></a>01814   <span class="keywordflow">if</span> ( !RB_Mq_C_norms_in.good() )
<a name="l01815"></a>01815   {
<a name="l01816"></a>01816     <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening Mq_C_norms.dat&quot;</span> &lt;&lt; std::endl;
<a name="l01817"></a>01817     libmesh_error();
<a name="l01818"></a>01818   }
<a name="l01819"></a>01819   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_m=0; q_m&lt;<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>(); q_m++)
<a name="l01820"></a>01820   {
<a name="l01821"></a>01821     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_bfs; i++)
<a name="l01822"></a>01822     {
<a name="l01823"></a>01823       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n1=0; n1&lt;n_bfs; n1++)
<a name="l01824"></a>01824       {
<a name="l01825"></a>01825         <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j1=0; j1&lt;n_bfs; j1++)
<a name="l01826"></a>01826         {
<a name="l01827"></a>01827           RB_Mq_C_norms_in &gt;&gt; <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a39a9f2064c99ea89337c13afa0d59211">Mq_C_representor_norms</a>[q_m][i][n1][j1];
<a name="l01828"></a>01828         }
<a name="l01829"></a>01829       }
<a name="l01830"></a>01830     }
<a name="l01831"></a>01831   }
<a name="l01832"></a>01832   RB_Mq_C_norms_in.close();
<a name="l01833"></a>01833 
<a name="l01834"></a>01834   <span class="comment">// Next read in the Aq_C representor norm data</span>
<a name="l01835"></a>01835   std::ifstream RB_Aq_C_norms_in;
<a name="l01836"></a>01836   {
<a name="l01837"></a>01837     <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l01838"></a>01838     file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/Aq_C_norms.dat&quot;</span>;
<a name="l01839"></a>01839     RB_Aq_C_norms_in.open(file_name.str().c_str());
<a name="l01840"></a>01840   }
<a name="l01841"></a>01841   <span class="keywordflow">if</span> ( !RB_Aq_C_norms_in.good() )
<a name="l01842"></a>01842   {
<a name="l01843"></a>01843     <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening Aq_C_norms.dat&quot;</span> &lt;&lt; std::endl;
<a name="l01844"></a>01844     libmesh_error();
<a name="l01845"></a>01845   }
<a name="l01846"></a>01846   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_a=0; q_a&lt;<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>(); q_a++)
<a name="l01847"></a>01847   {
<a name="l01848"></a>01848     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_bfs; i++)
<a name="l01849"></a>01849     {
<a name="l01850"></a>01850       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n1=0; n1&lt;n_bfs; n1++)
<a name="l01851"></a>01851       {
<a name="l01852"></a>01852         <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j1=0; j1&lt;n_bfs; j1++)
<a name="l01853"></a>01853         {
<a name="l01854"></a>01854           RB_Aq_C_norms_in &gt;&gt; <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#aa148f5aef2298825abbe912e80d6f3b7">Aq_C_representor_norms</a>[q_a][i][n1][j1];
<a name="l01855"></a>01855         }
<a name="l01856"></a>01856       }
<a name="l01857"></a>01857     }
<a name="l01858"></a>01858   }
<a name="l01859"></a>01859   RB_Aq_C_norms_in.close();
<a name="l01860"></a>01860 
<a name="l01861"></a>01861   <span class="comment">// Next read in the C_C representor norm data</span>
<a name="l01862"></a>01862   std::ifstream RB_C_C_norms_in;
<a name="l01863"></a>01863   {
<a name="l01864"></a>01864     <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l01865"></a>01865     file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/C_C_norms.dat&quot;</span>;
<a name="l01866"></a>01866     RB_C_C_norms_in.open(file_name.str().c_str());
<a name="l01867"></a>01867   }
<a name="l01868"></a>01868   <span class="keywordflow">if</span> ( !RB_C_C_norms_in.good() )
<a name="l01869"></a>01869   {
<a name="l01870"></a>01870     <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening C_C_norms.dat&quot;</span> &lt;&lt; std::endl;
<a name="l01871"></a>01871     libmesh_error();
<a name="l01872"></a>01872   }
<a name="l01873"></a>01873   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n1=0; n1&lt;n_bfs; n1++)
<a name="l01874"></a>01874   {
<a name="l01875"></a>01875     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j1=0; j1&lt;n_bfs; j1++)
<a name="l01876"></a>01876     {
<a name="l01877"></a>01877       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n2=0; n2&lt;n_bfs; n2++)
<a name="l01878"></a>01878       {
<a name="l01879"></a>01879         <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j2=0; j2&lt;n_bfs; j2++)
<a name="l01880"></a>01880         {
<a name="l01881"></a>01881           RB_C_C_norms_in &gt;&gt; <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a626bab2fd06b6ac9e5498c9ad3098c98">C_C_representor_norms</a>[n1][j1][n2][j2];
<a name="l01882"></a>01882         }
<a name="l01883"></a>01883       }
<a name="l01884"></a>01884     }
<a name="l01885"></a>01885   }
<a name="l01886"></a>01886   RB_C_C_norms_in.close();
<a name="l01887"></a>01887 
<a name="l01888"></a>01888   <span class="comment">// Read in the residual representors from file if requested</span>
<a name="l01889"></a>01889   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1RBSystem.php#a5ac870aac52f838bd28ee088ddc095b0">store_representors</a>)
<a name="l01890"></a>01890     {
<a name="l01891"></a>01891       <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1RBSystem.php#adec856bc209f0533639d76767bd5ebbc">quiet</a>)
<a name="l01892"></a>01892         <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Reading in the C_representors...&quot;</span> &lt;&lt; std::endl;
<a name="l01893"></a>01893 
<a name="l01894"></a>01894       <span class="keyword">const</span> std::string residual_representors_dir = <span class="stringliteral">&quot;residual_representors&quot;</span>;
<a name="l01895"></a>01895       <span class="keyword">const</span> std::string residual_representor_suffix =
<a name="l01896"></a>01896         (<a class="code" href="classlibMesh_1_1RBSystem.php#a6be264f3a81564aa2cf7144b54d74552">read_binary_residual_representors</a> ? <span class="stringliteral">&quot;.xdr&quot;</span> : <span class="stringliteral">&quot;.dat&quot;</span>);
<a name="l01897"></a>01897 
<a name="l01898"></a>01898       std::ostringstream file_name;
<a name="l01899"></a>01899       <span class="keyword">struct </span>stat stat_info;
<a name="l01900"></a>01900 
<a name="l01901"></a>01901       <span class="comment">// Read in the C_representors from file.  There should be</span>
<a name="l01902"></a>01902       <span class="comment">// this-&gt;get_n_basis_functions()^2 of these.  FIXME: Should we worry</span>
<a name="l01903"></a>01903       <span class="comment">// about memory leaks here?</span>
<a name="l01904"></a>01904       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;this-&gt;<a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>(); ++i)
<a name="l01905"></a>01905         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;this-&gt;<a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>(); ++j)
<a name="l01906"></a>01906           {
<a name="l01907"></a>01907             <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#aad10b1ffeb99e8261e99892ce0d209e5">C_representor</a>[i][j] != NULL)
<a name="l01908"></a>01908             {
<a name="l01909"></a>01909               <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Error, must delete existing C_representor before reading in from file.&quot;</span>
<a name="l01910"></a>01910                            &lt;&lt; std::endl;
<a name="l01911"></a>01911               libmesh_error();
<a name="l01912"></a>01912             }
<a name="l01913"></a>01913 
<a name="l01914"></a>01914             file_name.str(<span class="stringliteral">&quot;&quot;</span>); <span class="comment">// reset the filename</span>
<a name="l01915"></a>01915             file_name &lt;&lt; residual_representors_dir
<a name="l01916"></a>01916               &lt;&lt; <span class="stringliteral">&quot;/C_representor&quot;</span> &lt;&lt; i &lt;&lt; <span class="stringliteral">&quot;_&quot;</span> &lt;&lt; j &lt;&lt; residual_representor_suffix;
<a name="l01917"></a>01917 
<a name="l01918"></a>01918             <span class="comment">// On processor zero check to be sure the file exists</span>
<a name="l01919"></a>01919             <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l01920"></a>01920               {
<a name="l01921"></a>01921                 <span class="keywordtype">int</span> stat_result = stat(file_name.str().c_str(), &amp;stat_info);
<a name="l01922"></a>01922 
<a name="l01923"></a>01923                 <span class="keywordflow">if</span> (stat_result != 0)
<a name="l01924"></a>01924                   {
<a name="l01925"></a>01925                     <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;File does not exist: &quot;</span> &lt;&lt; file_name.str() &lt;&lt; std::endl;
<a name="l01926"></a>01926                     libmesh_error();
<a name="l01927"></a>01927                   }
<a name="l01928"></a>01928               }
<a name="l01929"></a>01929 
<a name="l01930"></a>01930             <a class="code" href="classlibMesh_1_1Xdr.php">Xdr</a> c_data(file_name.str(),
<a name="l01931"></a>01931                <a class="code" href="classlibMesh_1_1RBSystem.php#a6be264f3a81564aa2cf7144b54d74552">read_binary_residual_representors</a> ? <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a2632308739033bf9f82ea90cdf92231e">DECODE</a> : <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8acd5c7906bd7fea7650acc4c8cde09d48">READ</a>);
<a name="l01932"></a>01932 
<a name="l01933"></a>01933             <a class="code" href="classlibMesh_1_1System.php#a3eb0dd9d3ef0453daf9b5eeff0819736">read_serialized_data</a>(c_data, <span class="keyword">false</span>);
<a name="l01934"></a>01934 
<a name="l01935"></a>01935             <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#aad10b1ffeb99e8261e99892ce0d209e5">C_representor</a>[i][j] = <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;::build</a>().release();
<a name="l01936"></a>01936             <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#aad10b1ffeb99e8261e99892ce0d209e5">C_representor</a>[i][j]-&gt;init (this-&gt;<a class="code" href="classlibMesh_1_1System.php#a90dbb901f00c14ff18399f4afabcebe5">n_dofs</a>(),
<a name="l01937"></a>01937                                        this-&gt;<a class="code" href="classlibMesh_1_1System.php#ae3aeb82e65b06789823d41da3c5df7a2">n_local_dofs</a>(),
<a name="l01938"></a>01938                                        <span class="keyword">false</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">libMeshEnums::PARALLEL</a>);
<a name="l01939"></a>01939 
<a name="l01940"></a>01940             <span class="comment">// No need to copy, just swap</span>
<a name="l01941"></a>01941             <span class="comment">// *C_representor[i][j] = *solution;</span>
<a name="l01942"></a>01942             <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#aad10b1ffeb99e8261e99892ce0d209e5">C_representor</a>[i][j]-&gt;swap(*<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>);
<a name="l01943"></a>01943           }
<a name="l01944"></a>01944 
<a name="l01945"></a>01945       <span class="comment">// Finally, if we read in the representors then we must be planning to continue the basis training</span>
<a name="l01946"></a>01946       <span class="comment">// therefore if we are in high-memory mode we need to recompute all the trilinear form matrices</span>
<a name="l01947"></a>01947       <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBSystem.php#a740fd251422d685fa5b1256022c29a06">store_basis_functions</a> &amp;&amp; !<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a>)
<a name="l01948"></a>01948         {
<a name="l01949"></a>01949           <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Updating trilinear form operators&quot;</span> &lt;&lt; std::endl;
<a name="l01950"></a>01950           <a class="code" href="classlibMesh_1_1QNTransientRBSystem.php#a95d8333ed2c6da4d76033bc343cca7a4">update_all_trilinear_form_operators</a>();
<a name="l01951"></a>01951         }
<a name="l01952"></a>01952 
<a name="l01953"></a>01953     } <span class="comment">// end if (store_representors)</span>
<a name="l01954"></a>01954 
<a name="l01955"></a>01955 
<a name="l01956"></a>01956 
<a name="l01957"></a>01957   STOP_LOG(<span class="stringliteral">&quot;read_offline_data_from_files()&quot;</span>, <span class="stringliteral">&quot;QNTransientRBSystem&quot;</span>);
<a name="l01958"></a>01958 }
<a name="l01959"></a>01959 
<a name="l01960"></a>01960 } <span class="comment">// namespace libMesh</span>
<a name="l01961"></a>01961 
<a name="l01962"></a>01962 <span class="preprocessor">#endif // LIBMESH_HAVE_SLEPC &amp;&amp; LIBMESH_HAVE_GLPK</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
