<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_c3a49989e40b21e7508f29d2dc962def.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_94af86d0ee7ff5a2af0627e1a0ea6efa.php">systems</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">rb_system.C</div>  </div>
</div>
<div class="contents">
<a href="rb__system_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// rbOOmit: An implementation of the Certified Reduced Basis method.</span>
<a name="l00002"></a>00002 <span class="comment">// Copyright (C) 2009, 2010 David J. Knezevic</span>
<a name="l00003"></a>00003 
<a name="l00004"></a>00004 <span class="comment">// This file is part of rbOOmit.</span>
<a name="l00005"></a>00005 
<a name="l00006"></a>00006 <span class="comment">// rbOOmit is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// rbOOmit is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="comment">// LibMesh includes</span>
<a name="l00021"></a>00021 <span class="preprocessor">#include &quot;<a class="code" href="numeric__vector_8h.php">numeric_vector.h</a>&quot;</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &quot;<a class="code" href="sparse__matrix_8h.php">sparse_matrix.h</a>&quot;</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;<a class="code" href="dof__map_8h.php">dof_map.h</a>&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__logging_8h.php">libmesh_logging.h</a>&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="equation__systems_8h.php">equation_systems.h</a>&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="gmv__io_8h.php">gmv_io.h</a>&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="linear__solver_8h.php">linear_solver.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="getpot_8h.php">getpot.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="mesh__base_8h.php">mesh_base.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="parallel_8h.php">parallel.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="xdr__cxx_8h.php">xdr_cxx.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="timestamp_8h.php">timestamp.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="petsc__linear__solver_8h.php">petsc_linear_solver.h</a>&quot;</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="fem__context_8h.php">fem_context.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="rb__system_8h.php">rb_system.h</a>&quot;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;<a class="code" href="rb__scm__system_8h.php">rb_scm_system.h</a>&quot;</span>
<a name="l00038"></a>00038 <span class="preprocessor">#include &quot;<a class="code" href="rb__eim__system_8h.php">rb_eim_system.h</a>&quot;</span>
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 <span class="comment">// For creating a directory</span>
<a name="l00041"></a>00041 <span class="preprocessor">#include &lt;sys/types.h&gt;</span>
<a name="l00042"></a>00042 <span class="preprocessor">#include &lt;sys/stat.h&gt;</span>
<a name="l00043"></a>00043 <span class="preprocessor">#include &lt;errno.h&gt;</span>
<a name="l00044"></a>00044 
<a name="l00045"></a>00045 <span class="preprocessor">#include &quot;<a class="code" href="o__string__stream_8h.php">o_string_stream.h</a>&quot;</span>
<a name="l00046"></a>00046 <span class="preprocessor">#include &lt;fstream&gt;</span>
<a name="l00047"></a>00047 <span class="preprocessor">#include &lt;sstream&gt;</span>
<a name="l00048"></a>00048 
<a name="l00049"></a>00049 <span class="keyword">namespace </span>libMesh
<a name="l00050"></a>00050 {
<a name="l00051"></a>00051 
<a name="l00052"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a8f0b6f6507452d097f4c98e98ed49ecf">00052</a> <a class="code" href="classlibMesh_1_1RBSystem.php#a8f0b6f6507452d097f4c98e98ed49ecf">RBSystem::RBSystem</a> (<a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00053"></a>00053                     <span class="keyword">const</span> std::string&amp; <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>,
<a name="l00054"></a>00054                     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> number)
<a name="l00055"></a>00055   : <a class="code" href="classlibMesh_1_1System.php">Parent</a>(es, name, number),
<a name="l00056"></a>00056     inner_product_matrix(<a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix</a>&lt;<a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a>&gt;::build()),
<a name="l00057"></a>00057     constraint_matrix(<a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix</a>&lt;<a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a>&gt;::build()),
<a name="l00058"></a>00058     constrained_problem(false),
<a name="l00059"></a>00059     store_basis_functions(false),
<a name="l00060"></a>00060     store_representors(false),
<a name="l00061"></a>00061     low_memory_mode(false),
<a name="l00062"></a>00062     reuse_preconditioner(true),
<a name="l00063"></a>00063     return_rel_error_bound(true),
<a name="l00064"></a>00064     write_data_during_training(false),
<a name="l00065"></a>00065     impose_internal_dirichlet_BCs(false),
<a name="l00066"></a>00066     impose_internal_fluxes(false),
<a name="l00067"></a>00067     compute_RB_inner_product(false),
<a name="l00068"></a>00068     parameters_filename(<span class="stringliteral">&quot;&quot;</span>),
<a name="l00069"></a>00069     enforce_constraints_exactly(false),
<a name="l00070"></a>00070     Nmax(0),
<a name="l00071"></a>00071     delta_N(1),
<a name="l00072"></a>00072     write_binary_basis_functions(true),
<a name="l00073"></a>00073     read_binary_basis_functions(true),
<a name="l00074"></a>00074     write_binary_residual_representors(true),
<a name="l00075"></a>00075     read_binary_residual_representors(true),
<a name="l00076"></a>00076     quiet(true),
<a name="l00077"></a>00077     eigen_system_name(<span class="stringliteral">&quot;&quot;</span>),
<a name="l00078"></a>00078     inner_prod_assembly(NULL),
<a name="l00079"></a>00079     inner_prod_bndry_assembly(NULL),
<a name="l00080"></a>00080     constraint_assembly(NULL),
<a name="l00081"></a>00081     update_residual_terms_called(false),
<a name="l00082"></a>00082     training_tolerance(-1.),
<a name="l00083"></a>00083     _dirichlet_list_init(NULL),
<a name="l00084"></a>00084     initial_Nmax(0),
<a name="l00085"></a>00085     RB_system_initialized(false),
<a name="l00086"></a>00086     current_EIM_system(NULL)
<a name="l00087"></a>00087 {
<a name="l00088"></a>00088   <a class="code" href="classlibMesh_1_1RBSystem.php#a201af52facfa4da38bc636ee2cf41c67">RB_solution</a>.<a class="code" href="classlibMesh_1_1DenseVector.php#a08430ae781094632e8272cbb825d4f44">resize</a>(0);
<a name="l00089"></a>00089 
<a name="l00090"></a>00090   <a class="code" href="classlibMesh_1_1RBSystem.php#a567c86950bb6d2ab2800ac0b14ed3dd2">Fq_representor_norms</a>.clear();
<a name="l00091"></a>00091   <a class="code" href="classlibMesh_1_1RBSystem.php#ac3d546a3eaa362377494da087e711608">Fq_Aq_representor_norms</a>.clear();
<a name="l00092"></a>00092   <a class="code" href="classlibMesh_1_1RBSystem.php#a668fed2dcb2e98adb2e7eea5bc7d853e">Aq_Aq_representor_norms</a>.clear();
<a name="l00093"></a>00093 
<a name="l00094"></a>00094   <span class="comment">// Clear the theta and assembly vectors so that we can push_back</span>
<a name="l00095"></a>00095   <a class="code" href="classlibMesh_1_1RBBase.php#a297812cdf2117dc893575b48060ecab7">theta_q_a_vector</a>.clear();
<a name="l00096"></a>00096   <a class="code" href="classlibMesh_1_1RBSystem.php#a2e5fa41dea513013a95ac9cdc5a61f0c">A_q_intrr_assembly_vector</a>.clear();
<a name="l00097"></a>00097   <a class="code" href="classlibMesh_1_1RBSystem.php#af494bdce91a9247fae8014b49ff42296">A_q_bndry_assembly_vector</a>.clear();
<a name="l00098"></a>00098 
<a name="l00099"></a>00099   <a class="code" href="classlibMesh_1_1RBSystem.php#acc90dcf523c055fc294bc71b67dfe876">theta_q_f_vector</a>.clear();
<a name="l00100"></a>00100   <a class="code" href="classlibMesh_1_1RBSystem.php#afabf274dd4fced20cd745e982bbd6e83">F_q_intrr_assembly_vector</a>.clear();
<a name="l00101"></a>00101   <a class="code" href="classlibMesh_1_1RBSystem.php#aa9f3638bb29d1be5eb80a4555217d943">F_q_bndry_assembly_vector</a>.clear();
<a name="l00102"></a>00102 
<a name="l00103"></a>00103   <span class="comment">// Make sure we clear EIM vectors so we can then push_back</span>
<a name="l00104"></a>00104   <a class="code" href="classlibMesh_1_1RBSystem.php#a3b5f0e356b5a09e31e03f65400704cdc">A_EIM_intrr_assembly_vector</a>.clear();
<a name="l00105"></a>00105   <a class="code" href="classlibMesh_1_1RBSystem.php#ad0e9f0de3570c5ed42777fcf9f7aebbc">A_EIM_bndry_assembly_vector</a>.clear();
<a name="l00106"></a>00106 
<a name="l00107"></a>00107   <a class="code" href="classlibMesh_1_1RBSystem.php#a1c0266ace79018f4fe863549db995171">F_EIM_systems_vector</a>.clear();
<a name="l00108"></a>00108   <a class="code" href="classlibMesh_1_1RBSystem.php#a49be51b5a280a82e03e4bc3d40abb147">F_EIM_intrr_assembly_vector</a>.clear();
<a name="l00109"></a>00109   <a class="code" href="classlibMesh_1_1RBSystem.php#a2d9f5f3318fb1e891e50b0778496d257">F_EIM_bndry_assembly_vector</a>.clear();
<a name="l00110"></a>00110 
<a name="l00111"></a>00111   <a class="code" href="classlibMesh_1_1RBSystem.php#a1fa2b8ea817cae06f0d2e0bdbdd8b273">theta_q_l_vector</a>.clear();
<a name="l00112"></a>00112   <a class="code" href="classlibMesh_1_1RBSystem.php#a228200ea93fc638ba249a979078eeb10">output_intrr_assembly_vector</a>.clear();
<a name="l00113"></a>00113   <a class="code" href="classlibMesh_1_1RBSystem.php#a27d85bffcf0b50eab3c08dc0d17d21f2">output_bndry_assembly_vector</a>.clear();
<a name="l00114"></a>00114 
<a name="l00115"></a>00115   <span class="comment">// set assemble_before_solve flag to false</span>
<a name="l00116"></a>00116   <span class="comment">// so that we control matrix assembly.</span>
<a name="l00117"></a>00117   <a class="code" href="classlibMesh_1_1System.php#a6b24ccb769399c64405e8f8a52491e70">assemble_before_solve</a> = <span class="keyword">false</span>;
<a name="l00118"></a>00118 }
<a name="l00119"></a>00119 
<a name="l00120"></a>00120 
<a name="l00121"></a><a class="code" href="classlibMesh_1_1RBSystem.php#ace52091502758766654923323e89e66e">00121</a> <a class="code" href="classlibMesh_1_1RBSystem.php#ace52091502758766654923323e89e66e">RBSystem::~RBSystem</a> ()
<a name="l00122"></a>00122 {
<a name="l00123"></a>00123   this-&gt;<a class="code" href="classlibMesh_1_1RBSystem.php#ad9de9f8d888f8b9072402b5fe656a30d">clear</a>();
<a name="l00124"></a>00124 }
<a name="l00125"></a>00125 
<a name="l00126"></a>00126 
<a name="l00127"></a><a class="code" href="classlibMesh_1_1RBSystem.php#ad9de9f8d888f8b9072402b5fe656a30d">00127</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#ad9de9f8d888f8b9072402b5fe656a30d">RBSystem::clear</a>()
<a name="l00128"></a>00128 {
<a name="l00129"></a>00129   <a class="code" href="classlibMesh_1_1RBBase.php#ae9eea4c052b84a8038c348489ddcd1d9">Parent::clear</a>();
<a name="l00130"></a>00130 
<a name="l00131"></a>00131   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q=0; q&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#a2950621ecac9122266a6893e18735778">A_q_vector</a>.size(); q++)
<a name="l00132"></a>00132   {
<a name="l00133"></a>00133     <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBSystem.php#a2950621ecac9122266a6893e18735778">A_q_vector</a>[q])
<a name="l00134"></a>00134     {
<a name="l00135"></a>00135       <span class="keyword">delete</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a2950621ecac9122266a6893e18735778">A_q_vector</a>[q];
<a name="l00136"></a>00136       <a class="code" href="classlibMesh_1_1RBSystem.php#a2950621ecac9122266a6893e18735778">A_q_vector</a>[q] = NULL;
<a name="l00137"></a>00137     }
<a name="l00138"></a>00138   }
<a name="l00139"></a>00139 
<a name="l00140"></a>00140   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q=0; q&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#a6c86729bd0f4556a8574e3638282fc01">F_q_vector</a>.size(); q++)
<a name="l00141"></a>00141   {
<a name="l00142"></a>00142     <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBSystem.php#a6c86729bd0f4556a8574e3638282fc01">F_q_vector</a>[q])
<a name="l00143"></a>00143     {
<a name="l00144"></a>00144       <span class="keyword">delete</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a6c86729bd0f4556a8574e3638282fc01">F_q_vector</a>[q];
<a name="l00145"></a>00145       <a class="code" href="classlibMesh_1_1RBSystem.php#a6c86729bd0f4556a8574e3638282fc01">F_q_vector</a>[q] = NULL;
<a name="l00146"></a>00146     }
<a name="l00147"></a>00147   }
<a name="l00148"></a>00148 
<a name="l00149"></a>00149   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#a3060a5cc6031acfef4808df71e3eda08">outputs_vector</a>.size(); i++)
<a name="l00150"></a>00150     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_l=0; q_l&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#a3060a5cc6031acfef4808df71e3eda08">outputs_vector</a>[i].size(); q_l++)
<a name="l00151"></a>00151       <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBSystem.php#a3060a5cc6031acfef4808df71e3eda08">outputs_vector</a>[i][q_l])
<a name="l00152"></a>00152       {
<a name="l00153"></a>00153         <span class="keyword">delete</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a3060a5cc6031acfef4808df71e3eda08">outputs_vector</a>[i][q_l];
<a name="l00154"></a>00154         <a class="code" href="classlibMesh_1_1RBSystem.php#a3060a5cc6031acfef4808df71e3eda08">outputs_vector</a>[i][q_l] = NULL;
<a name="l00155"></a>00155       }
<a name="l00156"></a>00156 
<a name="l00157"></a>00157   <span class="comment">// Clear the basis functions and the</span>
<a name="l00158"></a>00158   <span class="comment">// basis-function-dependent data using</span>
<a name="l00159"></a>00159   <span class="comment">// the non-virtual helper function</span>
<a name="l00160"></a>00160   this-&gt;<a class="code" href="classlibMesh_1_1RBSystem.php#ad29734395747e3a7390db90eec361398">clear_basis_helper</a>();
<a name="l00161"></a>00161 }
<a name="l00162"></a>00162 
<a name="l00163"></a><a class="code" href="classlibMesh_1_1RBSystem.php#ad611f694e8d504268b101ea3266b590f">00163</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#ad611f694e8d504268b101ea3266b590f">RBSystem::clear_basis_function_dependent_data</a>()
<a name="l00164"></a>00164 {
<a name="l00165"></a>00165   <a class="code" href="classlibMesh_1_1RBSystem.php#a88a28e5658cc0bf37e3df863a46a9e7b">update_residual_terms_called</a> = <span class="keyword">false</span>;
<a name="l00166"></a>00166 
<a name="l00167"></a>00167   <span class="comment">// Clear the Greedy param list</span>
<a name="l00168"></a>00168   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#a9dd1607766f97d79b0abcfcf37193a11">greedy_param_list</a>.size(); i++)
<a name="l00169"></a>00169     <a class="code" href="classlibMesh_1_1RBSystem.php#a9dd1607766f97d79b0abcfcf37193a11">greedy_param_list</a>[i].<a class="code" href="classlibMesh_1_1RBSystem.php#ad9de9f8d888f8b9072402b5fe656a30d">clear</a>();
<a name="l00170"></a>00170   <a class="code" href="classlibMesh_1_1RBSystem.php#a9dd1607766f97d79b0abcfcf37193a11">greedy_param_list</a>.clear();
<a name="l00171"></a>00171 
<a name="l00172"></a>00172   <span class="comment">// Call non-virtual helper class to clear the</span>
<a name="l00173"></a>00173   <span class="comment">// basis related data</span>
<a name="l00174"></a>00174   <a class="code" href="classlibMesh_1_1RBSystem.php#ad29734395747e3a7390db90eec361398">clear_basis_helper</a>();
<a name="l00175"></a>00175 }
<a name="l00176"></a>00176 
<a name="l00177"></a><a class="code" href="classlibMesh_1_1RBSystem.php#ad29734395747e3a7390db90eec361398">00177</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#ad29734395747e3a7390db90eec361398">RBSystem::clear_basis_helper</a>()
<a name="l00178"></a>00178 {
<a name="l00179"></a>00179   <span class="comment">// Clear the basis functions</span>
<a name="l00180"></a>00180   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#abfe6d67ed23243d225f12747f355f105">basis_functions</a>.size(); i++)
<a name="l00181"></a>00181     {
<a name="l00182"></a>00182       <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1RBSystem.php#abfe6d67ed23243d225f12747f355f105">basis_functions</a>[i])
<a name="l00183"></a>00183         {
<a name="l00184"></a>00184           <a class="code" href="classlibMesh_1_1RBSystem.php#abfe6d67ed23243d225f12747f355f105">basis_functions</a>[i]-&gt;clear();
<a name="l00185"></a>00185           <span class="keyword">delete</span> <a class="code" href="classlibMesh_1_1RBSystem.php#abfe6d67ed23243d225f12747f355f105">basis_functions</a>[i];
<a name="l00186"></a>00186           <a class="code" href="classlibMesh_1_1RBSystem.php#abfe6d67ed23243d225f12747f355f105">basis_functions</a>[i] = NULL;
<a name="l00187"></a>00187         }
<a name="l00188"></a>00188     }
<a name="l00189"></a>00189   <a class="code" href="classlibMesh_1_1RBSystem.php#abfe6d67ed23243d225f12747f355f105">basis_functions</a>.resize(0);
<a name="l00190"></a>00190 
<a name="l00191"></a>00191   <span class="comment">// Also delete the representors</span>
<a name="l00192"></a>00192   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_f=0; q_f&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#acd91cfaa84058427cda2885e4d6d30ce">F_q_representor</a>.size(); q_f++)
<a name="l00193"></a>00193   {
<a name="l00194"></a>00194     <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBSystem.php#acd91cfaa84058427cda2885e4d6d30ce">F_q_representor</a>[q_f])
<a name="l00195"></a>00195     {
<a name="l00196"></a>00196       <span class="keyword">delete</span> <a class="code" href="classlibMesh_1_1RBSystem.php#acd91cfaa84058427cda2885e4d6d30ce">F_q_representor</a>[q_f];
<a name="l00197"></a>00197       <a class="code" href="classlibMesh_1_1RBSystem.php#acd91cfaa84058427cda2885e4d6d30ce">F_q_representor</a>[q_f] = NULL;
<a name="l00198"></a>00198     }
<a name="l00199"></a>00199   }
<a name="l00200"></a>00200 
<a name="l00201"></a>00201   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_a=0; q_a&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#a9c8fb2a4cb5b77e59e36bfff438aed01">A_q_representor</a>.size(); q_a++)
<a name="l00202"></a>00202   {
<a name="l00203"></a>00203     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#a9c8fb2a4cb5b77e59e36bfff438aed01">A_q_representor</a>[q_a].size(); i++)
<a name="l00204"></a>00204     {
<a name="l00205"></a>00205       <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBSystem.php#a9c8fb2a4cb5b77e59e36bfff438aed01">A_q_representor</a>[q_a][i])
<a name="l00206"></a>00206       {
<a name="l00207"></a>00207         <span class="keyword">delete</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a9c8fb2a4cb5b77e59e36bfff438aed01">A_q_representor</a>[q_a][i];
<a name="l00208"></a>00208         <a class="code" href="classlibMesh_1_1RBSystem.php#a9c8fb2a4cb5b77e59e36bfff438aed01">A_q_representor</a>[q_a][i] = NULL;
<a name="l00209"></a>00209       }
<a name="l00210"></a>00210     }
<a name="l00211"></a>00211   }
<a name="l00212"></a>00212 
<a name="l00213"></a>00213 }
<a name="l00214"></a>00214 
<a name="l00215"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a6e385de97a2d50358ef9cc4ff0f11e53">00215</a> std::string <a class="code" href="classlibMesh_1_1RBSystem.php#a6e385de97a2d50358ef9cc4ff0f11e53">RBSystem::system_type</a> ()<span class="keyword"> const</span>
<a name="l00216"></a>00216 <span class="keyword"></span>{
<a name="l00217"></a>00217   <span class="keywordflow">return</span> <span class="stringliteral">&quot;RBSystem&quot;</span>;
<a name="l00218"></a>00218 }
<a name="l00219"></a>00219 
<a name="l00220"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a5c2eb48dd263d846086cb2ca5b6a88a3">00220</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a5c2eb48dd263d846086cb2ca5b6a88a3">RBSystem::init_data</a> ()
<a name="l00221"></a>00221 {
<a name="l00222"></a>00222   <span class="comment">// First read in data from parameters_filename</span>
<a name="l00223"></a>00223   GetPot infile(<a class="code" href="classlibMesh_1_1RBSystem.php#a3aa3cce2414d86488881e1bbe4adcd00">parameters_filename</a>);
<a name="l00224"></a>00224 
<a name="l00225"></a>00225   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_parameters = infile(<span class="stringliteral">&quot;n_parameters&quot;</span>,1);
<a name="l00226"></a>00226   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_training_samples_mu = infile(<span class="stringliteral">&quot;n_training_samples_mu&quot;</span>,0);
<a name="l00227"></a>00227   <span class="keyword">const</span> <span class="keywordtype">bool</span> deterministic_training = infile(<span class="stringliteral">&quot;deterministic_training&quot;</span>,<span class="keyword">false</span>);
<a name="l00228"></a>00228 
<a name="l00229"></a>00229   <span class="comment">// String which selects an alternate pc/solver combo for the update_residual_terms solves.</span>
<a name="l00230"></a>00230   <span class="comment">// Possible values are:</span>
<a name="l00231"></a>00231   <span class="comment">// &quot;unchanged&quot; -- use whatever we were using for truth solves</span>
<a name="l00232"></a>00232   <span class="comment">// &quot;amg&quot; -- Use Boomeramg from Hypre.  DO NOT use on indefinite (Stokes) problems</span>
<a name="l00233"></a>00233   <span class="comment">// &quot;mumps&quot; -- Use the sparse</span>
<a name="l00234"></a>00234   <span class="comment">//update_residual_terms_solver = infile(&quot;update_residual_terms_solver&quot;,update_residual_terms_solver);</span>
<a name="l00235"></a>00235   <a class="code" href="classlibMesh_1_1RBBase.php#a6391dc702582601a0ff44b8742ee7b1c">alternative_solver</a> = infile(<span class="stringliteral">&quot;rb_alternative_solver&quot;</span>,<a class="code" href="classlibMesh_1_1RBBase.php#a6391dc702582601a0ff44b8742ee7b1c">alternative_solver</a>);
<a name="l00236"></a>00236 
<a name="l00237"></a>00237   <span class="comment">// Set boolean which turns on/off storing the representor residuals</span>
<a name="l00238"></a>00238   <a class="code" href="classlibMesh_1_1RBSystem.php#a5ac870aac52f838bd28ee088ddc095b0">store_representors</a> = infile(<span class="stringliteral">&quot;store_representors&quot;</span>, <a class="code" href="classlibMesh_1_1RBSystem.php#a5ac870aac52f838bd28ee088ddc095b0">store_representors</a>);
<a name="l00239"></a>00239 
<a name="l00240"></a>00240   <span class="comment">// Booleans which control whether binary (instead of ASCII) residual</span>
<a name="l00241"></a>00241   <span class="comment">// representors are written.  The store_representors boolean controls</span>
<a name="l00242"></a>00242   <span class="comment">// whether these files are written out at all.</span>
<a name="l00243"></a>00243   <a class="code" href="classlibMesh_1_1RBSystem.php#a399f7ee60adcc350ce7f27e8c60ed9de">write_binary_residual_representors</a> = infile(<span class="stringliteral">&quot;write_binary_residual_representors&quot;</span>,
<a name="l00244"></a>00244                                               <a class="code" href="classlibMesh_1_1RBSystem.php#a399f7ee60adcc350ce7f27e8c60ed9de">write_binary_residual_representors</a>);
<a name="l00245"></a>00245 
<a name="l00246"></a>00246   <a class="code" href="classlibMesh_1_1RBSystem.php#a6be264f3a81564aa2cf7144b54d74552">read_binary_residual_representors</a> = infile(<span class="stringliteral">&quot;read_binary_residual_representors&quot;</span>,
<a name="l00247"></a>00247                                               <a class="code" href="classlibMesh_1_1RBSystem.php#a6be264f3a81564aa2cf7144b54d74552">read_binary_residual_representors</a>);
<a name="l00248"></a>00248 
<a name="l00249"></a>00249 
<a name="l00250"></a>00250   <span class="comment">// Set boolean which turns on/off writing the basis functions in</span>
<a name="l00251"></a>00251   <span class="comment">// binary format.</span>
<a name="l00252"></a>00252   <a class="code" href="classlibMesh_1_1RBSystem.php#a1378ada675cf004646e15be203e631c6">write_binary_basis_functions</a> = infile(<span class="stringliteral">&quot;write_binary_basis_functions&quot;</span>,
<a name="l00253"></a>00253                                         <a class="code" href="classlibMesh_1_1RBSystem.php#a1378ada675cf004646e15be203e631c6">write_binary_basis_functions</a>);
<a name="l00254"></a>00254 
<a name="l00255"></a>00255   <span class="comment">// Set boolean which turns on/off reading the basis functions in</span>
<a name="l00256"></a>00256   <span class="comment">// binary format.</span>
<a name="l00257"></a>00257   <a class="code" href="classlibMesh_1_1RBSystem.php#a03fa5b207add059829b08f156320369d">read_binary_basis_functions</a> = infile(<span class="stringliteral">&quot;read_binary_basis_functions&quot;</span>,
<a name="l00258"></a>00258                                         <a class="code" href="classlibMesh_1_1RBSystem.php#a03fa5b207add059829b08f156320369d">read_binary_basis_functions</a>);
<a name="l00259"></a>00259 
<a name="l00260"></a>00260   <span class="comment">// Tell the system that it is constrained (i.e. we want to use</span>
<a name="l00261"></a>00261   <span class="comment">// the Stokes inner product matrix to compute Riesz representors)</span>
<a name="l00262"></a>00262   <a class="code" href="classlibMesh_1_1RBSystem.php#a28b1348023897cb1517724d6ac30a21d">constrained_problem</a> = (<a class="code" href="classlibMesh_1_1RBSystem.php#a9c6da671e41886e26c7e88aae82f4358">constraint_assembly</a> != NULL);
<a name="l00263"></a>00263 
<a name="l00264"></a>00264   <span class="comment">// Tell the system that we want to store or load the basis functions</span>
<a name="l00265"></a>00265   <a class="code" href="classlibMesh_1_1RBSystem.php#a740fd251422d685fa5b1256022c29a06">store_basis_functions</a> = infile(<span class="stringliteral">&quot;store_basis_functions&quot;</span>,
<a name="l00266"></a>00266                                  <a class="code" href="classlibMesh_1_1RBSystem.php#a740fd251422d685fa5b1256022c29a06">store_basis_functions</a>);
<a name="l00267"></a>00267 
<a name="l00268"></a>00268   <span class="comment">// Tell the system if we&#39;re in low-memory mode</span>
<a name="l00269"></a>00269   <a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a> = infile(<span class="stringliteral">&quot;low_memory_mode&quot;</span>,
<a name="l00270"></a>00270                            <a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a>);
<a name="l00271"></a>00271 
<a name="l00272"></a>00272   <span class="comment">// Tell the system to reuse the preconditioner on consecutive</span>
<a name="l00273"></a>00273   <span class="comment">// Offline solves to update residual data</span>
<a name="l00274"></a>00274   <a class="code" href="classlibMesh_1_1RBSystem.php#a61f47d68b0df487674a9001d13d77c88">reuse_preconditioner</a> = infile(<span class="stringliteral">&quot;reuse_preconditioner&quot;</span>,
<a name="l00275"></a>00275                                 <a class="code" href="classlibMesh_1_1RBSystem.php#a61f47d68b0df487674a9001d13d77c88">reuse_preconditioner</a>);
<a name="l00276"></a>00276 
<a name="l00277"></a>00277   <span class="comment">// Tell the system whether or not to return a relative error bound</span>
<a name="l00278"></a>00278   <span class="comment">// from each call to RB_solve</span>
<a name="l00279"></a>00279   <a class="code" href="classlibMesh_1_1RBSystem.php#a56ab5090b2d6e6322742ade2772330e7">return_rel_error_bound</a> = infile(<span class="stringliteral">&quot;return_rel_error_bound&quot;</span>,
<a name="l00280"></a>00280                                   <a class="code" href="classlibMesh_1_1RBSystem.php#a56ab5090b2d6e6322742ade2772330e7">return_rel_error_bound</a>);
<a name="l00281"></a>00281 
<a name="l00282"></a>00282   <span class="comment">// Tell the system whether or not to write out offline data during</span>
<a name="l00283"></a>00283   <span class="comment">// train_reduced_basis. This allows us to continue from where the</span>
<a name="l00284"></a>00284   <span class="comment">// training left off in case the computation stops for some reason.</span>
<a name="l00285"></a>00285   <a class="code" href="classlibMesh_1_1RBSystem.php#a5d9cd7b5d9de8e0d7b6efde6252c449c">write_data_during_training</a> = infile(<span class="stringliteral">&quot;write_data_during_training&quot;</span>,
<a name="l00286"></a>00286                                       <a class="code" href="classlibMesh_1_1RBSystem.php#a5d9cd7b5d9de8e0d7b6efde6252c449c">write_data_during_training</a>);
<a name="l00287"></a>00287 
<a name="l00288"></a>00288   <span class="comment">// Tell the system whether or not to initialize \calN dependent data</span>
<a name="l00289"></a>00289   <span class="comment">// structures.</span>
<a name="l00290"></a>00290   <a class="code" href="classlibMesh_1_1RBBase.php#a11c4b80a15c0e9ea1d822f5e04545059">initialize_calN_dependent_data</a> = infile(<span class="stringliteral">&quot;initialize_calN_dependent_data&quot;</span>,
<a name="l00291"></a>00291                                           <a class="code" href="classlibMesh_1_1RBBase.php#a11c4b80a15c0e9ea1d822f5e04545059">initialize_calN_dependent_data</a>);
<a name="l00292"></a>00292 
<a name="l00293"></a>00293   <span class="comment">// Set boolean which turns on/off storing the representor residuals</span>
<a name="l00294"></a>00294   <a class="code" href="classlibMesh_1_1RBSystem.php#a254e2165b576bf932eaa57e726a6bebf">impose_internal_dirichlet_BCs</a> = infile(<span class="stringliteral">&quot;impose_internal_dirichlet_BCs&quot;</span>,
<a name="l00295"></a>00295                                           <a class="code" href="classlibMesh_1_1RBSystem.php#a254e2165b576bf932eaa57e726a6bebf">impose_internal_dirichlet_BCs</a>);
<a name="l00296"></a>00296 
<a name="l00297"></a>00297   <span class="comment">// Set boolean which turns on/off storing the representor residuals</span>
<a name="l00298"></a>00298   <a class="code" href="classlibMesh_1_1RBSystem.php#ab76a069a5cb7bb72afe582be842d8e04">impose_internal_fluxes</a> = infile(<span class="stringliteral">&quot;impose_internal_fluxes&quot;</span>,
<a name="l00299"></a>00299                                    <a class="code" href="classlibMesh_1_1RBSystem.php#ab76a069a5cb7bb72afe582be842d8e04">impose_internal_fluxes</a>);
<a name="l00300"></a>00300 
<a name="l00301"></a>00301   <span class="comment">// Read in training_parameters_random_seed value.  This is used to</span>
<a name="l00302"></a>00302   <span class="comment">// seed the RNG when picking the training parameters.  By default the</span>
<a name="l00303"></a>00303   <span class="comment">// value is -1, which means use std::time to seed the RNG.</span>
<a name="l00304"></a>00304   <a class="code" href="classlibMesh_1_1RBBase.php#aa2f4297e83e21e49a5cc7dc2ad2bda44">training_parameters_random_seed</a> = infile(<span class="stringliteral">&quot;training_parameters_random_seed&quot;</span>,
<a name="l00305"></a>00305                                            <a class="code" href="classlibMesh_1_1RBBase.php#aa2f4297e83e21e49a5cc7dc2ad2bda44">training_parameters_random_seed</a>);
<a name="l00306"></a>00306   
<a name="l00307"></a>00307   <span class="comment">// Set quiet mode</span>
<a name="l00308"></a>00308   <span class="keyword">const</span> <span class="keywordtype">bool</span> quiet_in = infile(<span class="stringliteral">&quot;quiet&quot;</span>, <a class="code" href="classlibMesh_1_1RBSystem.php#adec856bc209f0533639d76767bd5ebbc">quiet</a>);
<a name="l00309"></a>00309   <a class="code" href="classlibMesh_1_1RBSystem.php#afdb77262c71be7af51003d99c92bc2f9">set_quiet</a>(quiet_in);
<a name="l00310"></a>00310 
<a name="l00311"></a>00311   <span class="comment">// Throw an error if we try to not initialize calN-dependent data</span>
<a name="l00312"></a>00312   <span class="comment">// when we also want to read in the basis functions.</span>
<a name="l00313"></a>00313   <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBBase.php#a11c4b80a15c0e9ea1d822f5e04545059">initialize_calN_dependent_data</a> &amp;&amp; <a class="code" href="classlibMesh_1_1RBSystem.php#a740fd251422d685fa5b1256022c29a06">store_basis_functions</a>)
<a name="l00314"></a>00314   {
<a name="l00315"></a>00315     <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error: We must initialize the calN dependent &quot;</span>
<a name="l00316"></a>00316                  &lt;&lt; <span class="stringliteral">&quot;data structures if we want to read in basis &quot;</span>
<a name="l00317"></a>00317                  &lt;&lt; <span class="stringliteral">&quot;functions.&quot;</span>
<a name="l00318"></a>00318                  &lt;&lt; std::endl;
<a name="l00319"></a>00319     libmesh_error();
<a name="l00320"></a>00320   }
<a name="l00321"></a>00321 
<a name="l00322"></a>00322   <span class="comment">// Initialize RB parameters</span>
<a name="l00323"></a>00323   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Nmax_in = infile(<span class="stringliteral">&quot;Nmax&quot;</span>, <a class="code" href="classlibMesh_1_1RBSystem.php#ab47d6a963c4f68b5a3d1eea7905257f5">Nmax</a>);
<a name="l00324"></a>00324   <a class="code" href="classlibMesh_1_1RBSystem.php#a0eedc533ec1db115433f692dbcd33e1f">set_Nmax</a>(Nmax_in);
<a name="l00325"></a>00325   <a class="code" href="classlibMesh_1_1RBSystem.php#af3d84b1c9662e32972e37314f1a81353">initial_Nmax</a> = <a class="code" href="classlibMesh_1_1RBSystem.php#a5acee637ff70dd65ec54de29241f0627">get_Nmax</a>();
<a name="l00326"></a>00326   
<a name="l00327"></a>00327   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> training_tolerance_in = infile(<span class="stringliteral">&quot;training_tolerance&quot;</span>,
<a name="l00328"></a>00328                                             <a class="code" href="classlibMesh_1_1RBSystem.php#a56a24996be9d774563f1a8e6165ed038">training_tolerance</a>);
<a name="l00329"></a>00329   <a class="code" href="classlibMesh_1_1RBSystem.php#a3178424e9ea7e39bdf7f4db2404c9eba">set_training_tolerance</a>(training_tolerance_in);
<a name="l00330"></a>00330 
<a name="l00331"></a>00331 
<a name="l00332"></a>00332   std::vector&lt;Real&gt; <a class="code" href="classlibMesh_1_1RBBase.php#aa54633a8a1d87dc76bbce3cec5e80421">mu_min_vector</a>(n_parameters);
<a name="l00333"></a>00333   std::vector&lt;Real&gt; <a class="code" href="classlibMesh_1_1RBBase.php#a908713cda5467ba29a8141ee97d3a49d">mu_max_vector</a>(n_parameters);
<a name="l00334"></a>00334   std::vector&lt;bool&gt; log_scaling(n_parameters);
<a name="l00335"></a>00335   std::vector&lt;Real&gt; init_mu_vector(n_parameters);
<a name="l00336"></a>00336   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_parameters; i++)
<a name="l00337"></a>00337   {
<a name="l00338"></a>00338     <span class="comment">// Read vector-based mu_min values.</span>
<a name="l00339"></a>00339     mu_min_vector[i] = infile(<span class="stringliteral">&quot;mu_min&quot;</span>, mu_min_vector[i], i);
<a name="l00340"></a>00340 
<a name="l00341"></a>00341     <span class="comment">// Read vector-based mu_max values.</span>
<a name="l00342"></a>00342     mu_max_vector[i] = infile(<span class="stringliteral">&quot;mu_max&quot;</span>, mu_max_vector[i], i);
<a name="l00343"></a>00343 
<a name="l00344"></a>00344     <span class="comment">// Read vector-based log scaling values.  Note the intermediate conversion to</span>
<a name="l00345"></a>00345     <span class="comment">// int... this implies log_scaling = &#39;1 1 1...&#39; in the input file.</span>
<a name="l00346"></a>00346     log_scaling[i] = <span class="keyword">static_cast&lt;</span><span class="keywordtype">bool</span><span class="keyword">&gt;</span>(infile(<span class="stringliteral">&quot;log_scaling&quot;</span>, static_cast&lt;int&gt;(log_scaling[i]), i));
<a name="l00347"></a>00347 
<a name="l00348"></a>00348     <span class="comment">// Read vector-based init_mu values.</span>
<a name="l00349"></a>00349     init_mu_vector[i] = infile(<span class="stringliteral">&quot;init_mu&quot;</span>, init_mu_vector[i], i);
<a name="l00350"></a>00350   }
<a name="l00351"></a>00351 
<a name="l00352"></a>00352   <a class="code" href="classlibMesh_1_1RBBase.php#aab8ed17932e5a8eacaa00b093128d651">initialize_training_parameters</a>(mu_min_vector,
<a name="l00353"></a>00353                                  mu_max_vector,
<a name="l00354"></a>00354                                  n_training_samples_mu,
<a name="l00355"></a>00355                                  log_scaling,
<a name="l00356"></a>00356                                  deterministic_training);   <span class="comment">// use deterministic parameters</span>
<a name="l00357"></a>00357 
<a name="l00358"></a>00358 
<a name="l00359"></a>00359 
<a name="l00360"></a>00360   <span class="comment">// Set the initial parameter value</span>
<a name="l00361"></a>00361   <a class="code" href="classlibMesh_1_1RBBase.php#a04037fe5c23e9d9e5652936888cb8f0f">set_current_parameters</a>(init_mu_vector);
<a name="l00362"></a>00362 
<a name="l00363"></a>00363   <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; std::endl &lt;&lt; <span class="stringliteral">&quot;RBSystem parameters:&quot;</span> &lt;&lt; std::endl;
<a name="l00364"></a>00364   <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;system name: &quot;</span> &lt;&lt; this-&gt;<a class="code" href="classlibMesh_1_1System.php#af80f6b2e508821ebd9c8fcb78d443f18">name</a>() &lt;&lt; std::endl;
<a name="l00365"></a>00365   <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;constrained_problem: &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1RBSystem.php#a28b1348023897cb1517724d6ac30a21d">constrained_problem</a> &lt;&lt; std::endl;
<a name="l00366"></a>00366   <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Nmax: &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1RBSystem.php#ab47d6a963c4f68b5a3d1eea7905257f5">Nmax</a> &lt;&lt; std::endl;
<a name="l00367"></a>00367   <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBSystem.php#a56a24996be9d774563f1a8e6165ed038">training_tolerance</a> &gt; 0.)
<a name="l00368"></a>00368     <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Basis training error tolerance: &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1RBSystem.php#a8166ac1af73cc69a154ff5a65ed9e959">get_training_tolerance</a>() &lt;&lt; std::endl;
<a name="l00369"></a>00369   <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;A_q operators attached: &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>() &lt;&lt; std::endl;
<a name="l00370"></a>00370   <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;F_q functions attached: &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>() &lt;&lt; std::endl;
<a name="l00371"></a>00371   <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Number of A EIM systems: &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1RBBase.php#a0e95ad12b80cc5a4c766532f4e0edd31">get_n_A_EIM_systems</a>() &lt;&lt; std::endl;
<a name="l00372"></a>00372   <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Number of F EIM systems: &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1RBSystem.php#ac1e04bfe35245ea3e225fc5865621fb0">get_n_F_EIM_systems</a>() &lt;&lt; std::endl;
<a name="l00373"></a>00373   <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;n_outputs: &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1RBSystem.php#a80b9e06a7c60b3bb2f5870b0ff66a2ca">get_n_outputs</a>() &lt;&lt; std::endl;
<a name="l00374"></a>00374   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#a80b9e06a7c60b3bb2f5870b0ff66a2ca">get_n_outputs</a>(); n++)
<a name="l00375"></a>00375     <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;output &quot;</span> &lt;&lt; n &lt;&lt; <span class="stringliteral">&quot;, Q_l = &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1RBSystem.php#ab7f0b2268a9716189225e0446b519911">get_Q_l</a>(n) &lt;&lt; std::endl;
<a name="l00376"></a>00376   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_parameters; i++)
<a name="l00377"></a>00377   {
<a name="l00378"></a>00378     <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt;   <span class="stringliteral">&quot;Parameter &quot;</span> &lt;&lt; i
<a name="l00379"></a>00379                  &lt;&lt; <span class="stringliteral">&quot;: Min = &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1RBBase.php#aaed8f1fe273692ff7cad1be03de720d0">get_parameter_min</a>(i)
<a name="l00380"></a>00380                  &lt;&lt; <span class="stringliteral">&quot;, Max = &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1RBBase.php#a711eff68113a6b4c6e491bef54e285fd">get_parameter_max</a>(i)
<a name="l00381"></a>00381                  &lt;&lt; <span class="stringliteral">&quot;, log scaling = &quot;</span> &lt;&lt; log_scaling[i] &lt;&lt; std::endl;
<a name="l00382"></a>00382   }
<a name="l00383"></a>00383   <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;n_training_samples: &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1RBBase.php#a584ecef007a7992b6317db58f857e9e0">get_n_training_samples</a>() &lt;&lt; std::endl;
<a name="l00384"></a>00384   <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;using deterministic training samples? &quot;</span> &lt;&lt; deterministic_training &lt;&lt; std::endl;
<a name="l00385"></a>00385   <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;store/load basis functions? &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1RBSystem.php#a740fd251422d685fa5b1256022c29a06">store_basis_functions</a> &lt;&lt; std::endl;
<a name="l00386"></a>00386   <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBSystem.php#a740fd251422d685fa5b1256022c29a06">store_basis_functions</a>)
<a name="l00387"></a>00387   {
<a name="l00388"></a>00388     <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;  write out basis functions in binary format? &quot;</span>
<a name="l00389"></a>00389                  &lt;&lt; <a class="code" href="classlibMesh_1_1RBSystem.php#a1378ada675cf004646e15be203e631c6">write_binary_basis_functions</a> &lt;&lt; std::endl;
<a name="l00390"></a>00390     <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;  read in basis functions in binary format? &quot;</span>
<a name="l00391"></a>00391                  &lt;&lt; <a class="code" href="classlibMesh_1_1RBSystem.php#a03fa5b207add059829b08f156320369d">read_binary_basis_functions</a> &lt;&lt; std::endl;
<a name="l00392"></a>00392   }
<a name="l00393"></a>00393   <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;store/load residual representors? &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1RBSystem.php#a5ac870aac52f838bd28ee088ddc095b0">store_representors</a> &lt;&lt; std::endl;
<a name="l00394"></a>00394   <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBSystem.php#a5ac870aac52f838bd28ee088ddc095b0">store_representors</a>)
<a name="l00395"></a>00395   {
<a name="l00396"></a>00396     <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;  write out residual representors in binary format? &quot;</span>
<a name="l00397"></a>00397                  &lt;&lt; <a class="code" href="classlibMesh_1_1RBSystem.php#a399f7ee60adcc350ce7f27e8c60ed9de">write_binary_residual_representors</a> &lt;&lt; std::endl;
<a name="l00398"></a>00398     <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;  read in residual representors in binary format? &quot;</span>
<a name="l00399"></a>00399                  &lt;&lt; <a class="code" href="classlibMesh_1_1RBSystem.php#a6be264f3a81564aa2cf7144b54d74552">read_binary_residual_representors</a> &lt;&lt; std::endl;
<a name="l00400"></a>00400   }
<a name="l00401"></a>00401   <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;low-memory mode? &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a> &lt;&lt; std::endl;
<a name="l00402"></a>00402   <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;reuse preconditioner? &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1RBSystem.php#a61f47d68b0df487674a9001d13d77c88">reuse_preconditioner</a> &lt;&lt; std::endl;
<a name="l00403"></a>00403   <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;return a relative error bound from RB_solve? &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1RBSystem.php#a56ab5090b2d6e6322742ade2772330e7">return_rel_error_bound</a> &lt;&lt; std::endl;
<a name="l00404"></a>00404   <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;write out data during basis training? &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1RBSystem.php#a5d9cd7b5d9de8e0d7b6efde6252c449c">write_data_during_training</a> &lt;&lt; std::endl;
<a name="l00405"></a>00405   <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;initializing calN-dependent data structures? &quot;</span>
<a name="l00406"></a>00406                &lt;&lt; <a class="code" href="classlibMesh_1_1RBBase.php#a11c4b80a15c0e9ea1d822f5e04545059">initialize_calN_dependent_data</a> &lt;&lt; std::endl;
<a name="l00407"></a>00407   <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;impose internal Dirichlet BCs? &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1RBSystem.php#a254e2165b576bf932eaa57e726a6bebf">impose_internal_dirichlet_BCs</a> &lt;&lt; std::endl;
<a name="l00408"></a>00408   <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;impose internal fluxes? &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1RBSystem.php#ab76a069a5cb7bb72afe582be842d8e04">impose_internal_fluxes</a> &lt;&lt; std::endl;
<a name="l00409"></a>00409   <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;quiet mode? &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1RBSystem.php#adec856bc209f0533639d76767bd5ebbc">quiet</a> &lt;&lt; std::endl;
<a name="l00410"></a>00410   <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;initial parameter: &quot;</span>;
<a name="l00411"></a>00411   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_parameters; i++)
<a name="l00412"></a>00412   {
<a name="l00413"></a>00413     <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;mu[&quot;</span> &lt;&lt; i &lt;&lt; <span class="stringliteral">&quot;] = &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1RBBase.php#af3bb451bd612eb5e7e8f0684f4b9cc97">get_current_parameters</a>()[i];
<a name="l00414"></a>00414     <span class="keywordflow">if</span>(i &lt; (n_parameters-1))
<a name="l00415"></a>00415       <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;, &quot;</span>;
<a name="l00416"></a>00416     <span class="keywordflow">else</span>
<a name="l00417"></a>00417       <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; std::endl;
<a name="l00418"></a>00418   }
<a name="l00419"></a>00419   <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; std::endl;
<a name="l00420"></a>00420 
<a name="l00421"></a>00421   <span class="comment">// We need Nmax to be initialized</span>
<a name="l00422"></a>00422   libmesh_assert(<a class="code" href="classlibMesh_1_1RBSystem.php#ab47d6a963c4f68b5a3d1eea7905257f5">Nmax</a> &gt; 0);
<a name="l00423"></a>00423 
<a name="l00424"></a>00424   <span class="comment">// Now that input parameters (e.g. Q_a) have been read in,</span>
<a name="l00425"></a>00425   <span class="comment">// call the Parent&#39;s initialization routine.</span>
<a name="l00426"></a>00426   <a class="code" href="classlibMesh_1_1RBBase.php#a22845ff428edfd2a0716aaecdb3788b7">Parent::init_data</a>();
<a name="l00427"></a>00427 }
<a name="l00428"></a>00428 
<a name="l00429"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a3410f47eeb503ae9f34ceec97d7436b1">00429</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a3410f47eeb503ae9f34ceec97d7436b1">RBSystem::attach_dirichlet_dof_initialization</a> (<a class="code" href="namespacelibMesh.php#a81103ec3bcd9ba1f89f544623d5b7318">dirichlet_list_fptr</a> dirichlet_init)
<a name="l00430"></a>00430 {
<a name="l00431"></a>00431   libmesh_assert (dirichlet_init != NULL);
<a name="l00432"></a>00432 
<a name="l00433"></a>00433   <a class="code" href="classlibMesh_1_1RBSystem.php#ad74afd2cad6c52cbc299f1f3e623c70c">_dirichlet_list_init</a> = dirichlet_init;
<a name="l00434"></a>00434 }
<a name="l00435"></a>00435 
<a name="l00436"></a><a class="code" href="classlibMesh_1_1RBSystem.php#add5ef1d37331766d1b46208bb4e952fb">00436</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#add5ef1d37331766d1b46208bb4e952fb">RBSystem::initialize_dirichlet_dofs</a>()
<a name="l00437"></a>00437 {
<a name="l00438"></a>00438   START_LOG(<span class="stringliteral">&quot;initialize_dirichlet_dofs()&quot;</span>, <span class="stringliteral">&quot;RBSystem&quot;</span>);
<a name="l00439"></a>00439 
<a name="l00440"></a>00440   <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBBase.php#a11c4b80a15c0e9ea1d822f5e04545059">initialize_calN_dependent_data</a>)
<a name="l00441"></a>00441   {
<a name="l00442"></a>00442     <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error: We must initialize the calN dependent &quot;</span>
<a name="l00443"></a>00443                  &lt;&lt; <span class="stringliteral">&quot;data structures in order to initialize Dirichlet dofs.&quot;</span>
<a name="l00444"></a>00444                  &lt;&lt; std::endl;
<a name="l00445"></a>00445     libmesh_error();
<a name="l00446"></a>00446   }
<a name="l00447"></a>00447 
<a name="l00448"></a>00448   <span class="comment">// Create a set to store the Dirichlet dofs on this processor</span>
<a name="l00449"></a>00449   std::set&lt;unsigned int&gt; dirichlet_dofs_set;
<a name="l00450"></a>00450   dirichlet_dofs_set.clear();
<a name="l00451"></a>00451 
<a name="l00452"></a>00452   <span class="comment">// Initialize the lists of Dirichlet and non-Dirichlet degrees-of-freedom</span>
<a name="l00453"></a>00453   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1RBSystem.php#ad74afd2cad6c52cbc299f1f3e623c70c">_dirichlet_list_init</a> != NULL)
<a name="l00454"></a>00454     {
<a name="l00455"></a>00455       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a> = this-&gt;<a class="code" href="classlibMesh_1_1System.php#ac5ca6b1f3adcfac56982982e90dc905b">get_equation_systems</a>().<a class="code" href="classlibMesh_1_1EquationSystems.php#aba1132bd8b38e9ce851abf57c3bc1e4b">get_mesh</a>();
<a name="l00456"></a>00456 
<a name="l00457"></a>00457       <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;FEMContext&gt;</a> c = this-&gt;<a class="code" href="classlibMesh_1_1RBSystem.php#aab5505a99e58300d0e4e17b31943f162">build_context</a>();
<a name="l00458"></a>00458       <a class="code" href="classlibMesh_1_1FEMContext.php">FEMContext</a> &amp;context  = libmesh_cast_ref&lt;FEMContext&amp;&gt;(*c);
<a name="l00459"></a>00459 
<a name="l00460"></a>00460       this-&gt;<a class="code" href="classlibMesh_1_1RBSystem.php#a2a9e0cb788597d488aa73e9108147ef2">init_context</a>(context);
<a name="l00461"></a>00461 
<a name="l00462"></a>00462       <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>       el     = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a99742bad0b034a29ccae8c5a90c6f4aa">active_local_elements_begin</a>();
<a name="l00463"></a>00463       <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end_el = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a2e27f54d33f7539c0c06b36adae36cda">active_local_elements_end</a>();
<a name="l00464"></a>00464 
<a name="l00465"></a>00465       <span class="keywordflow">for</span> ( ; el != end_el; ++el)
<a name="l00466"></a>00466         {
<a name="l00467"></a>00467           context.<a class="code" href="classlibMesh_1_1FEMContext.php#a4f3f3300b191500571bf8e05bc0cf38e">pre_fe_reinit</a>(*<span class="keyword">this</span>, *el);
<a name="l00468"></a>00468           context.<a class="code" href="classlibMesh_1_1FEMContext.php#a24f0889875c6cfa85f45e0b1d0986651">elem_fe_reinit</a>();
<a name="l00469"></a>00469 
<a name="l00470"></a>00470           <span class="keywordflow">for</span> (context.<a class="code" href="classlibMesh_1_1FEMContext.php#a59d031054af8f000ebe3874b0a944410">side</a> = 0;
<a name="l00471"></a>00471                context.<a class="code" href="classlibMesh_1_1FEMContext.php#a59d031054af8f000ebe3874b0a944410">side</a> != context.<a class="code" href="classlibMesh_1_1FEMContext.php#ab6f9bf4e40120dd6b18e6da4f12c3cc8">elem</a>-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ae376bfa6ac14723330e07a97992b56c9">n_sides</a>();
<a name="l00472"></a>00472                ++context.<a class="code" href="classlibMesh_1_1FEMContext.php#a59d031054af8f000ebe3874b0a944410">side</a>)
<a name="l00473"></a>00473             {
<a name="l00474"></a>00474               <span class="comment">// Skip over non-boundary sides if we don&#39;t have internal Dirichlet BCs</span>
<a name="l00475"></a>00475               <span class="keywordflow">if</span> ( (context.<a class="code" href="classlibMesh_1_1FEMContext.php#ab6f9bf4e40120dd6b18e6da4f12c3cc8">elem</a>-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(context.<a class="code" href="classlibMesh_1_1FEMContext.php#a59d031054af8f000ebe3874b0a944410">side</a>) != NULL) &amp;&amp; !<a class="code" href="classlibMesh_1_1RBSystem.php#a254e2165b576bf932eaa57e726a6bebf">impose_internal_dirichlet_BCs</a> )
<a name="l00476"></a>00476                 <span class="keywordflow">continue</span>;
<a name="l00477"></a>00477 
<a name="l00478"></a>00478               context.<a class="code" href="classlibMesh_1_1FEMContext.php#a0f7f6e01f78a5dbf532901b5198878fc">side_fe_reinit</a>();
<a name="l00479"></a>00479               <a class="code" href="classlibMesh_1_1RBSystem.php#ad74afd2cad6c52cbc299f1f3e623c70c">_dirichlet_list_init</a>(context, *<span class="keyword">this</span>, dirichlet_dofs_set);
<a name="l00480"></a>00480             }
<a name="l00481"></a>00481         }
<a name="l00482"></a>00482     }
<a name="l00483"></a>00483 
<a name="l00484"></a>00484   <span class="comment">// Initialize the dirichlet dofs vector on each processor</span>
<a name="l00485"></a>00485   std::vector&lt;unsigned int&gt; dirichlet_dofs_vector;
<a name="l00486"></a>00486   dirichlet_dofs_vector.clear();
<a name="l00487"></a>00487 
<a name="l00488"></a>00488   std::set&lt;unsigned int&gt;::iterator iter     = dirichlet_dofs_set.begin();
<a name="l00489"></a>00489   std::set&lt;unsigned int&gt;::iterator iter_end = dirichlet_dofs_set.end();
<a name="l00490"></a>00490 
<a name="l00491"></a>00491   <span class="keywordflow">for</span> ( ; iter != iter_end; ++iter)
<a name="l00492"></a>00492   {
<a name="l00493"></a>00493     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dirichlet_dof_index = *iter;
<a name="l00494"></a>00494     dirichlet_dofs_vector.push_back(dirichlet_dof_index);
<a name="l00495"></a>00495   }
<a name="l00496"></a>00496 
<a name="l00497"></a>00497   <span class="comment">// Now take the union over all processors</span>
<a name="l00498"></a>00498   <a class="code" href="namespacelibMesh_1_1Parallel.php#a5d83bd3061eee7fc9ec2c58427c67aef">Parallel::allgather</a>(dirichlet_dofs_vector);
<a name="l00499"></a>00499 
<a name="l00500"></a>00500   <span class="comment">// Put all local dofs into non_dirichlet_dofs_set and</span>
<a name="l00501"></a>00501   <span class="comment">// then erase the Dirichlet dofs</span>
<a name="l00502"></a>00502   <span class="comment">// Note that this approach automatically ignores non-local Dirichlet dofs</span>
<a name="l00503"></a>00503   std::set&lt;unsigned int&gt; non_dirichlet_dofs_set;
<a name="l00504"></a>00504   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=this-&gt;<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>().first_dof(); i&lt;this-&gt;<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>().<a class="code" href="classlibMesh_1_1DofMap.php#abf250ac3decfedbe00ddaeef85ed4de4">end_dof</a>(); i++)
<a name="l00505"></a>00505     non_dirichlet_dofs_set.insert(i);
<a name="l00506"></a>00506 
<a name="l00507"></a>00507   <span class="comment">// Also, initialize the member data structure global_dirichlet_dofs_set</span>
<a name="l00508"></a>00508   <a class="code" href="classlibMesh_1_1RBBase.php#a1882c0df8f854a52376363461d402b76">global_dirichlet_dofs_set</a>.clear();
<a name="l00509"></a>00509 
<a name="l00510"></a>00510   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ii=0; ii&lt;dirichlet_dofs_vector.size(); ii++)
<a name="l00511"></a>00511   {
<a name="l00512"></a>00512     non_dirichlet_dofs_set.erase(dirichlet_dofs_vector[ii]);
<a name="l00513"></a>00513     <a class="code" href="classlibMesh_1_1RBBase.php#a1882c0df8f854a52376363461d402b76">global_dirichlet_dofs_set</a>.insert(dirichlet_dofs_vector[ii]);
<a name="l00514"></a>00514   }
<a name="l00515"></a>00515 
<a name="l00516"></a>00516   <span class="comment">// Finally, load the non-Dirichlet dofs into the system</span>
<a name="l00517"></a>00517   iter     = non_dirichlet_dofs_set.begin();
<a name="l00518"></a>00518   iter_end = non_dirichlet_dofs_set.end();
<a name="l00519"></a>00519 
<a name="l00520"></a>00520   this-&gt;<a class="code" href="classlibMesh_1_1RBBase.php#a487a5ffe10788d69f9f5b218646fca6a">non_dirichlet_dofs_vector</a>.clear();
<a name="l00521"></a>00521 
<a name="l00522"></a>00522   <span class="keywordflow">for</span> ( ; iter != iter_end; ++iter)
<a name="l00523"></a>00523     {
<a name="l00524"></a>00524       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> non_dirichlet_dof_index = *iter;
<a name="l00525"></a>00525 
<a name="l00526"></a>00526       this-&gt;<a class="code" href="classlibMesh_1_1RBBase.php#a487a5ffe10788d69f9f5b218646fca6a">non_dirichlet_dofs_vector</a>.push_back(non_dirichlet_dof_index);
<a name="l00527"></a>00527     }
<a name="l00528"></a>00528 
<a name="l00529"></a>00529   STOP_LOG(<span class="stringliteral">&quot;initialize_dirichlet_dofs()&quot;</span>, <span class="stringliteral">&quot;RBSystem&quot;</span>);
<a name="l00530"></a>00530 }
<a name="l00531"></a>00531 
<a name="l00532"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a5911f7b778db3b2791ca89d4e9820125">00532</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a5911f7b778db3b2791ca89d4e9820125">RBSystem::initialize_RB_system</a>(<span class="keywordtype">bool</span> online_mode)
<a name="l00533"></a>00533 {
<a name="l00534"></a>00534   <span class="comment">// Resize/clear inner product matrix</span>
<a name="l00535"></a>00535   <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBSystem.php#a52ba5c957ff8b7f85ae16707df632b67">compute_RB_inner_product</a>)
<a name="l00536"></a>00536     <a class="code" href="classlibMesh_1_1RBSystem.php#a5aeb48dc4ed2a429e89bdeffdd1f1564">RB_inner_product_matrix</a>.<a class="code" href="classlibMesh_1_1DenseMatrix.php#ad967ca8d40990ed5cae9944a285a320d">resize</a>(<a class="code" href="classlibMesh_1_1RBSystem.php#ab47d6a963c4f68b5a3d1eea7905257f5">Nmax</a>,<a class="code" href="classlibMesh_1_1RBSystem.php#ab47d6a963c4f68b5a3d1eea7905257f5">Nmax</a>);
<a name="l00537"></a>00537 
<a name="l00538"></a>00538   <span class="comment">// Resize vectors for storing calN-dependent data but only</span>
<a name="l00539"></a>00539   <span class="comment">// initialize if initialize_calN_dependent_data == true</span>
<a name="l00540"></a>00540   <a class="code" href="classlibMesh_1_1RBSystem.php#a2950621ecac9122266a6893e18735778">A_q_vector</a>.resize(<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>());
<a name="l00541"></a>00541   <a class="code" href="classlibMesh_1_1RBSystem.php#a6c86729bd0f4556a8574e3638282fc01">F_q_vector</a>.resize(<a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>());
<a name="l00542"></a>00542   <a class="code" href="classlibMesh_1_1RBSystem.php#acd91cfaa84058427cda2885e4d6d30ce">F_q_representor</a>.resize(<a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>());
<a name="l00543"></a>00543   <a class="code" href="classlibMesh_1_1RBSystem.php#a9c8fb2a4cb5b77e59e36bfff438aed01">A_q_representor</a>.resize(<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>());
<a name="l00544"></a>00544   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_a=0; q_a&lt;<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>(); q_a++)
<a name="l00545"></a>00545   {
<a name="l00546"></a>00546     <a class="code" href="classlibMesh_1_1RBSystem.php#a9c8fb2a4cb5b77e59e36bfff438aed01">A_q_representor</a>[q_a].resize(<a class="code" href="classlibMesh_1_1RBSystem.php#ab47d6a963c4f68b5a3d1eea7905257f5">Nmax</a>);
<a name="l00547"></a>00547   }
<a name="l00548"></a>00548   <a class="code" href="classlibMesh_1_1RBSystem.php#a3060a5cc6031acfef4808df71e3eda08">outputs_vector</a>.resize(<a class="code" href="classlibMesh_1_1RBSystem.php#a80b9e06a7c60b3bb2f5870b0ff66a2ca">get_n_outputs</a>());
<a name="l00549"></a>00549   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#a80b9e06a7c60b3bb2f5870b0ff66a2ca">get_n_outputs</a>(); n++)
<a name="l00550"></a>00550     <a class="code" href="classlibMesh_1_1RBSystem.php#a3060a5cc6031acfef4808df71e3eda08">outputs_vector</a>[n].resize( <a class="code" href="classlibMesh_1_1RBSystem.php#ab7f0b2268a9716189225e0446b519911">get_Q_l</a>(n) );
<a name="l00551"></a>00551 
<a name="l00552"></a>00552   <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBBase.php#a11c4b80a15c0e9ea1d822f5e04545059">initialize_calN_dependent_data</a>)
<a name="l00553"></a>00553   {
<a name="l00554"></a>00554     <span class="comment">// Only initialize matrices if we&#39;re not in low-memory mode</span>
<a name="l00555"></a>00555     <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a>)
<a name="l00556"></a>00556     {
<a name="l00557"></a>00557       <a class="code" href="classlibMesh_1_1DofMap.php">DofMap</a>&amp; dof_map = this-&gt;<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>();
<a name="l00558"></a>00558 
<a name="l00559"></a>00559       dof_map.<a class="code" href="classlibMesh_1_1DofMap.php#aa10200782a0f8fe0c4d3f7bdf10cedc6">attach_matrix</a>(*<a class="code" href="classlibMesh_1_1RBSystem.php#a330478ef4e1a158dc7b6f08530e10ff3">inner_product_matrix</a>);
<a name="l00560"></a>00560       <a class="code" href="classlibMesh_1_1RBSystem.php#a330478ef4e1a158dc7b6f08530e10ff3">inner_product_matrix</a>-&gt;init();
<a name="l00561"></a>00561       <a class="code" href="classlibMesh_1_1RBSystem.php#a330478ef4e1a158dc7b6f08530e10ff3">inner_product_matrix</a>-&gt;zero();
<a name="l00562"></a>00562 
<a name="l00563"></a>00563       <span class="keywordflow">if</span>(this-&gt;<a class="code" href="classlibMesh_1_1RBSystem.php#a28b1348023897cb1517724d6ac30a21d">constrained_problem</a>)
<a name="l00564"></a>00564       {
<a name="l00565"></a>00565         dof_map.<a class="code" href="classlibMesh_1_1DofMap.php#aa10200782a0f8fe0c4d3f7bdf10cedc6">attach_matrix</a>(*<a class="code" href="classlibMesh_1_1RBSystem.php#aa7a3439518c1b8a421a79064e819f5c8">constraint_matrix</a>);
<a name="l00566"></a>00566         <a class="code" href="classlibMesh_1_1RBSystem.php#aa7a3439518c1b8a421a79064e819f5c8">constraint_matrix</a>-&gt;init();
<a name="l00567"></a>00567         <a class="code" href="classlibMesh_1_1RBSystem.php#aa7a3439518c1b8a421a79064e819f5c8">constraint_matrix</a>-&gt;zero();
<a name="l00568"></a>00568       }
<a name="l00569"></a>00569 
<a name="l00570"></a>00570       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q=0; q&lt;<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>(); q++)
<a name="l00571"></a>00571       {
<a name="l00572"></a>00572         <span class="comment">// Initialize the memory for the matrices</span>
<a name="l00573"></a>00573         <a class="code" href="classlibMesh_1_1RBSystem.php#a2950621ecac9122266a6893e18735778">A_q_vector</a>[q] = <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;Number&gt;::build</a>().release();
<a name="l00574"></a>00574         dof_map.<a class="code" href="classlibMesh_1_1DofMap.php#aa10200782a0f8fe0c4d3f7bdf10cedc6">attach_matrix</a>(*<a class="code" href="classlibMesh_1_1RBSystem.php#a2950621ecac9122266a6893e18735778">A_q_vector</a>[q]);
<a name="l00575"></a>00575         <a class="code" href="classlibMesh_1_1RBSystem.php#a2950621ecac9122266a6893e18735778">A_q_vector</a>[q]-&gt;init();
<a name="l00576"></a>00576         <a class="code" href="classlibMesh_1_1RBSystem.php#a2950621ecac9122266a6893e18735778">A_q_vector</a>[q]-&gt;zero();
<a name="l00577"></a>00577       }
<a name="l00578"></a>00578     }
<a name="l00579"></a>00579 
<a name="l00580"></a>00580     <span class="comment">// Initialize the vectors even if we are in low-memory mode</span>
<a name="l00581"></a>00581     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q=0; q&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>(); q++)
<a name="l00582"></a>00582     {
<a name="l00583"></a>00583       <span class="comment">// Initialize the memory for the vectors</span>
<a name="l00584"></a>00584       <a class="code" href="classlibMesh_1_1RBSystem.php#a6c86729bd0f4556a8574e3638282fc01">F_q_vector</a>[q] = <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;::build</a>().release();
<a name="l00585"></a>00585       <a class="code" href="classlibMesh_1_1RBSystem.php#a6c86729bd0f4556a8574e3638282fc01">F_q_vector</a>[q]-&gt;init (this-&gt;<a class="code" href="classlibMesh_1_1System.php#a90dbb901f00c14ff18399f4afabcebe5">n_dofs</a>(), this-&gt;<a class="code" href="classlibMesh_1_1System.php#ae3aeb82e65b06789823d41da3c5df7a2">n_local_dofs</a>(), <span class="keyword">false</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">libMeshEnums::PARALLEL</a>);
<a name="l00586"></a>00586     }
<a name="l00587"></a>00587 
<a name="l00588"></a>00588     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#a80b9e06a7c60b3bb2f5870b0ff66a2ca">get_n_outputs</a>(); n++)
<a name="l00589"></a>00589       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_l=0; q_l&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#ab7f0b2268a9716189225e0446b519911">get_Q_l</a>(n); q_l++)
<a name="l00590"></a>00590       {
<a name="l00591"></a>00591         <span class="comment">// Initialize the memory for the truth output vectors</span>
<a name="l00592"></a>00592         <a class="code" href="classlibMesh_1_1RBSystem.php#a3060a5cc6031acfef4808df71e3eda08">outputs_vector</a>[n][q_l] = (<a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;::build</a>().release());
<a name="l00593"></a>00593         <a class="code" href="classlibMesh_1_1RBSystem.php#a3060a5cc6031acfef4808df71e3eda08">outputs_vector</a>[n][q_l]-&gt;init (this-&gt;<a class="code" href="classlibMesh_1_1System.php#a90dbb901f00c14ff18399f4afabcebe5">n_dofs</a>(), this-&gt;<a class="code" href="classlibMesh_1_1System.php#ae3aeb82e65b06789823d41da3c5df7a2">n_local_dofs</a>(), <span class="keyword">false</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">libMeshEnums::PARALLEL</a>);
<a name="l00594"></a>00594       }
<a name="l00595"></a>00595   }
<a name="l00596"></a>00596 
<a name="l00597"></a>00597   <span class="comment">// Now allocate the N (i.e. RB) dependent data structures</span>
<a name="l00598"></a>00598 
<a name="l00599"></a>00599   <span class="comment">// Allocate dense matrices for RB solves</span>
<a name="l00600"></a>00600   <a class="code" href="classlibMesh_1_1RBSystem.php#adadaf9a427ffbace640455436a4d4b26">RB_A_q_vector</a>.resize(<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>());
<a name="l00601"></a>00601 
<a name="l00602"></a>00602   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q=0; q&lt;<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>(); q++)
<a name="l00603"></a>00603   {
<a name="l00604"></a>00604     <span class="comment">// Initialize the memory for the RB matrices</span>
<a name="l00605"></a>00605     <a class="code" href="classlibMesh_1_1RBSystem.php#adadaf9a427ffbace640455436a4d4b26">RB_A_q_vector</a>[q].resize(<a class="code" href="classlibMesh_1_1RBSystem.php#ab47d6a963c4f68b5a3d1eea7905257f5">Nmax</a>,<a class="code" href="classlibMesh_1_1RBSystem.php#ab47d6a963c4f68b5a3d1eea7905257f5">Nmax</a>);
<a name="l00606"></a>00606   }
<a name="l00607"></a>00607 
<a name="l00608"></a>00608   <a class="code" href="classlibMesh_1_1RBSystem.php#ac2da8c5c36be49686429e74b4f9def1c">RB_F_q_vector</a>.resize(<a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>());
<a name="l00609"></a>00609 
<a name="l00610"></a>00610   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q=0; q&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>(); q++)
<a name="l00611"></a>00611   {
<a name="l00612"></a>00612     <span class="comment">// Initialize the memory for the RB vectors</span>
<a name="l00613"></a>00613     <a class="code" href="classlibMesh_1_1RBSystem.php#ac2da8c5c36be49686429e74b4f9def1c">RB_F_q_vector</a>[q].resize(<a class="code" href="classlibMesh_1_1RBSystem.php#ab47d6a963c4f68b5a3d1eea7905257f5">Nmax</a>);
<a name="l00614"></a>00614   }
<a name="l00615"></a>00615 
<a name="l00616"></a>00616   <span class="comment">// Initialize vectors for the norms of the representors</span>
<a name="l00617"></a>00617   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Q_f_hat = <a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>()*(<a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>()+1)/2;
<a name="l00618"></a>00618   <a class="code" href="classlibMesh_1_1RBSystem.php#a567c86950bb6d2ab2800ac0b14ed3dd2">Fq_representor_norms</a>.resize(Q_f_hat);
<a name="l00619"></a>00619 
<a name="l00620"></a>00620   <a class="code" href="classlibMesh_1_1RBSystem.php#ac3d546a3eaa362377494da087e711608">Fq_Aq_representor_norms</a>.resize(<a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>());
<a name="l00621"></a>00621   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>(); i++)
<a name="l00622"></a>00622   {
<a name="l00623"></a>00623     <a class="code" href="classlibMesh_1_1RBSystem.php#ac3d546a3eaa362377494da087e711608">Fq_Aq_representor_norms</a>[i].resize(<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>());
<a name="l00624"></a>00624     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>(); j++)
<a name="l00625"></a>00625     {
<a name="l00626"></a>00626       <a class="code" href="classlibMesh_1_1RBSystem.php#ac3d546a3eaa362377494da087e711608">Fq_Aq_representor_norms</a>[i][j].resize(<a class="code" href="classlibMesh_1_1RBSystem.php#ab47d6a963c4f68b5a3d1eea7905257f5">Nmax</a>);
<a name="l00627"></a>00627     }
<a name="l00628"></a>00628   }
<a name="l00629"></a>00629 
<a name="l00630"></a>00630   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Q_a_hat = <a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>()*(<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>()+1)/2;
<a name="l00631"></a>00631   <a class="code" href="classlibMesh_1_1RBSystem.php#a668fed2dcb2e98adb2e7eea5bc7d853e">Aq_Aq_representor_norms</a>.resize(Q_a_hat);
<a name="l00632"></a>00632   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;Q_a_hat; i++)
<a name="l00633"></a>00633   {
<a name="l00634"></a>00634     <a class="code" href="classlibMesh_1_1RBSystem.php#a668fed2dcb2e98adb2e7eea5bc7d853e">Aq_Aq_representor_norms</a>[i].resize(<a class="code" href="classlibMesh_1_1RBSystem.php#ab47d6a963c4f68b5a3d1eea7905257f5">Nmax</a>);
<a name="l00635"></a>00635     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#ab47d6a963c4f68b5a3d1eea7905257f5">Nmax</a>; j++)
<a name="l00636"></a>00636     {
<a name="l00637"></a>00637       <a class="code" href="classlibMesh_1_1RBSystem.php#a668fed2dcb2e98adb2e7eea5bc7d853e">Aq_Aq_representor_norms</a>[i][j].resize(Nmax);
<a name="l00638"></a>00638     }
<a name="l00639"></a>00639   }
<a name="l00640"></a>00640 
<a name="l00641"></a>00641   <span class="comment">// Resize truth_outputs vector</span>
<a name="l00642"></a>00642   <a class="code" href="classlibMesh_1_1RBSystem.php#abef8df30d43713bb06b2a83b89a0ed29">truth_outputs</a>.resize(this-&gt;<a class="code" href="classlibMesh_1_1RBSystem.php#a80b9e06a7c60b3bb2f5870b0ff66a2ca">get_n_outputs</a>());
<a name="l00643"></a>00643 
<a name="l00644"></a>00644   <span class="comment">// Initialize the RB output vectors</span>
<a name="l00645"></a>00645   <a class="code" href="classlibMesh_1_1RBSystem.php#ab868a08069961fcde36a760e0094708a">RB_output_vectors</a>.resize(<a class="code" href="classlibMesh_1_1RBSystem.php#a80b9e06a7c60b3bb2f5870b0ff66a2ca">get_n_outputs</a>());
<a name="l00646"></a>00646   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#a80b9e06a7c60b3bb2f5870b0ff66a2ca">get_n_outputs</a>(); n++)
<a name="l00647"></a>00647   {
<a name="l00648"></a>00648     <a class="code" href="classlibMesh_1_1RBSystem.php#ab868a08069961fcde36a760e0094708a">RB_output_vectors</a>[n].resize(<a class="code" href="classlibMesh_1_1RBSystem.php#ab7f0b2268a9716189225e0446b519911">get_Q_l</a>(n));
<a name="l00649"></a>00649     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_l=0; q_l&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#ab7f0b2268a9716189225e0446b519911">get_Q_l</a>(n); q_l++)
<a name="l00650"></a>00650     {
<a name="l00651"></a>00651       <a class="code" href="classlibMesh_1_1RBSystem.php#ab868a08069961fcde36a760e0094708a">RB_output_vectors</a>[n][q_l].resize(<a class="code" href="classlibMesh_1_1RBSystem.php#ab47d6a963c4f68b5a3d1eea7905257f5">Nmax</a>);
<a name="l00652"></a>00652     }
<a name="l00653"></a>00653   }
<a name="l00654"></a>00654 
<a name="l00655"></a>00655   <span class="comment">// Initialize vectors storing output data</span>
<a name="l00656"></a>00656   <a class="code" href="classlibMesh_1_1RBSystem.php#a2e3592b7167280ef4dd92cfb4a131c62">output_dual_norms</a>.resize(<a class="code" href="classlibMesh_1_1RBSystem.php#a80b9e06a7c60b3bb2f5870b0ff66a2ca">get_n_outputs</a>());
<a name="l00657"></a>00657   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#a80b9e06a7c60b3bb2f5870b0ff66a2ca">get_n_outputs</a>(); n++)
<a name="l00658"></a>00658   {
<a name="l00659"></a>00659     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Q_l_hat = <a class="code" href="classlibMesh_1_1RBSystem.php#ab7f0b2268a9716189225e0446b519911">get_Q_l</a>(n)*(<a class="code" href="classlibMesh_1_1RBSystem.php#ab7f0b2268a9716189225e0446b519911">get_Q_l</a>(n)+1)/2;
<a name="l00660"></a>00660     <a class="code" href="classlibMesh_1_1RBSystem.php#a2e3592b7167280ef4dd92cfb4a131c62">output_dual_norms</a>[n].resize(Q_l_hat);
<a name="l00661"></a>00661   }
<a name="l00662"></a>00662   <a class="code" href="classlibMesh_1_1RBSystem.php#ac099cfc76fb098f528982f9322f5780a">RB_outputs</a>.resize(<a class="code" href="classlibMesh_1_1RBSystem.php#a80b9e06a7c60b3bb2f5870b0ff66a2ca">get_n_outputs</a>());
<a name="l00663"></a>00663   <a class="code" href="classlibMesh_1_1RBSystem.php#aec3ecea1d8b509fe52ecb7a8b7893f27">RB_output_error_bounds</a>.resize(<a class="code" href="classlibMesh_1_1RBSystem.php#a80b9e06a7c60b3bb2f5870b0ff66a2ca">get_n_outputs</a>());
<a name="l00664"></a>00664 
<a name="l00665"></a>00665   <a class="code" href="classlibMesh_1_1RBSystem.php#ac5a6b09c8f4e8d788be2ad45dc1bfb05">RB_system_initialized</a> = <span class="keyword">true</span>;
<a name="l00666"></a>00666 
<a name="l00667"></a>00667   <span class="keywordflow">if</span>(!online_mode)
<a name="l00668"></a>00668   {
<a name="l00669"></a>00669     <span class="comment">// Initialize the non-Dirichlet and Dirichlet dofs lists</span>
<a name="l00670"></a>00670     this-&gt;<a class="code" href="classlibMesh_1_1RBSystem.php#add5ef1d37331766d1b46208bb4e952fb">initialize_dirichlet_dofs</a>();
<a name="l00671"></a>00671 
<a name="l00672"></a>00672     <span class="comment">// Assemble and store all of the matrices if we&#39;re</span>
<a name="l00673"></a>00673     <span class="comment">// not in low-memory mode</span>
<a name="l00674"></a>00674     <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a>)
<a name="l00675"></a>00675     {
<a name="l00676"></a>00676       this-&gt;<a class="code" href="classlibMesh_1_1RBSystem.php#a2fef453705e8c61cfe86eced45603dad">assemble_misc_matrices</a>();
<a name="l00677"></a>00677       this-&gt;<a class="code" href="classlibMesh_1_1RBSystem.php#af03382bc15075589cbfa15caf75b8b92">assemble_all_affine_operators</a>();
<a name="l00678"></a>00678     }
<a name="l00679"></a>00679 
<a name="l00680"></a>00680     this-&gt;<a class="code" href="classlibMesh_1_1RBSystem.php#a1af76f5d23ae7d1af03f6c1666673db6">assemble_all_affine_vectors</a>();
<a name="l00681"></a>00681     this-&gt;<a class="code" href="classlibMesh_1_1RBSystem.php#aac92e937e2de9cd586d8fcb92967c739">assemble_all_output_vectors</a>();
<a name="l00682"></a>00682 
<a name="l00683"></a>00683     <span class="comment">// Compute the dual norms of the outputs</span>
<a name="l00684"></a>00684     this-&gt;<a class="code" href="classlibMesh_1_1RBSystem.php#a8718bf6f56c88f4ccab7521f334e6a2c">compute_output_dual_norms</a>();
<a name="l00685"></a>00685   }
<a name="l00686"></a>00686 }
<a name="l00687"></a>00687 
<a name="l00688"></a><a class="code" href="classlibMesh_1_1RBSystem.php#aab5505a99e58300d0e4e17b31943f162">00688</a> <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;FEMContext&gt;</a> <a class="code" href="classlibMesh_1_1RBSystem.php#aab5505a99e58300d0e4e17b31943f162">RBSystem::build_context</a> ()
<a name="l00689"></a>00689 {
<a name="l00690"></a>00690   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;FEMContext&gt;</a>(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1FEMContext.php">FEMContext</a>(*<span class="keyword">this</span>));
<a name="l00691"></a>00691 }
<a name="l00692"></a>00692 
<a name="l00693"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a4a1243f45ea36fbd2a10ad6956c62deb">00693</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a4a1243f45ea36fbd2a10ad6956c62deb">RBSystem::add_scaled_matrix_and_vector</a>(<a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> scalar,
<a name="l00694"></a>00694                                  <a class="code" href="namespacelibMesh.php#a18a170af3a9d5eff6f43eb3409d0e296">affine_assembly_fptr</a> intrr_assembly,
<a name="l00695"></a>00695                                  <a class="code" href="namespacelibMesh.php#a18a170af3a9d5eff6f43eb3409d0e296">affine_assembly_fptr</a> bndry_assembly,
<a name="l00696"></a>00696                                  <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;Number&gt;</a>* input_matrix,
<a name="l00697"></a>00697                                  <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>* input_vector,
<a name="l00698"></a>00698                                  <span class="keywordtype">bool</span> symmetrize)
<a name="l00699"></a>00699 {
<a name="l00700"></a>00700   START_LOG(<span class="stringliteral">&quot;add_scaled_matrix_and_vector()&quot;</span>, <span class="stringliteral">&quot;RBSystem&quot;</span>);
<a name="l00701"></a>00701 
<a name="l00702"></a>00702   <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBBase.php#a11c4b80a15c0e9ea1d822f5e04545059">initialize_calN_dependent_data</a>)
<a name="l00703"></a>00703   {
<a name="l00704"></a>00704     <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error: We must initialize the calN dependent &quot;</span>
<a name="l00705"></a>00705                  &lt;&lt; <span class="stringliteral">&quot;data structures in order to perform add_scaled_matrix_and_vector.&quot;</span>
<a name="l00706"></a>00706                  &lt;&lt; std::endl;
<a name="l00707"></a>00707     libmesh_error();
<a name="l00708"></a>00708   }
<a name="l00709"></a>00709 
<a name="l00710"></a>00710   <span class="keywordtype">bool</span> assemble_matrix = (input_matrix != NULL);
<a name="l00711"></a>00711   <span class="keywordtype">bool</span> assemble_vector = (input_vector != NULL);
<a name="l00712"></a>00712 
<a name="l00713"></a>00713   <span class="keywordflow">if</span>(!assemble_matrix &amp;&amp; !assemble_vector)
<a name="l00714"></a>00714     <span class="keywordflow">return</span>;
<a name="l00715"></a>00715 
<a name="l00716"></a>00716   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a> = this-&gt;<a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">get_mesh</a>();
<a name="l00717"></a>00717 
<a name="l00718"></a>00718   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;FEMContext&gt;</a> c = this-&gt;<a class="code" href="classlibMesh_1_1RBSystem.php#aab5505a99e58300d0e4e17b31943f162">build_context</a>();
<a name="l00719"></a>00719   <a class="code" href="classlibMesh_1_1FEMContext.php">FEMContext</a> &amp;context  = libmesh_cast_ref&lt;FEMContext&amp;&gt;(*c);
<a name="l00720"></a>00720 
<a name="l00721"></a>00721   this-&gt;<a class="code" href="classlibMesh_1_1RBSystem.php#a2a9e0cb788597d488aa73e9108147ef2">init_context</a>(context);
<a name="l00722"></a>00722 
<a name="l00723"></a>00723   <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>       el     = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a99742bad0b034a29ccae8c5a90c6f4aa">active_local_elements_begin</a>();
<a name="l00724"></a>00724   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end_el = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a2e27f54d33f7539c0c06b36adae36cda">active_local_elements_end</a>();
<a name="l00725"></a>00725 
<a name="l00726"></a>00726   <span class="keywordflow">for</span> ( ; el != end_el; ++el)
<a name="l00727"></a>00727   {
<a name="l00728"></a>00728     context.<a class="code" href="classlibMesh_1_1FEMContext.php#a4f3f3300b191500571bf8e05bc0cf38e">pre_fe_reinit</a>(*<span class="keyword">this</span>, *el);
<a name="l00729"></a>00729     context.<a class="code" href="classlibMesh_1_1FEMContext.php#a24f0889875c6cfa85f45e0b1d0986651">elem_fe_reinit</a>();
<a name="l00730"></a>00730     <span class="keywordflow">if</span>(intrr_assembly != NULL)
<a name="l00731"></a>00731       intrr_assembly(context, *<span class="keyword">this</span>);
<a name="l00732"></a>00732 
<a name="l00733"></a>00733     <span class="keywordflow">for</span> (context.<a class="code" href="classlibMesh_1_1FEMContext.php#a59d031054af8f000ebe3874b0a944410">side</a> = 0;
<a name="l00734"></a>00734           context.<a class="code" href="classlibMesh_1_1FEMContext.php#a59d031054af8f000ebe3874b0a944410">side</a> != context.<a class="code" href="classlibMesh_1_1FEMContext.php#ab6f9bf4e40120dd6b18e6da4f12c3cc8">elem</a>-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ae376bfa6ac14723330e07a97992b56c9">n_sides</a>();
<a name="l00735"></a>00735           ++context.<a class="code" href="classlibMesh_1_1FEMContext.php#a59d031054af8f000ebe3874b0a944410">side</a>)
<a name="l00736"></a>00736     {
<a name="l00737"></a>00737       <span class="comment">// May not need to apply fluxes on non-boundary elements</span>
<a name="l00738"></a>00738       <span class="keywordflow">if</span>( (context.<a class="code" href="classlibMesh_1_1FEMContext.php#ab6f9bf4e40120dd6b18e6da4f12c3cc8">elem</a>-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(context.<a class="code" href="classlibMesh_1_1FEMContext.php#a59d031054af8f000ebe3874b0a944410">side</a>) != NULL) &amp;&amp; !<a class="code" href="classlibMesh_1_1RBSystem.php#ab76a069a5cb7bb72afe582be842d8e04">impose_internal_fluxes</a> )
<a name="l00739"></a>00739         <span class="keywordflow">continue</span>;
<a name="l00740"></a>00740 
<a name="l00741"></a>00741       <span class="comment">// Impose boundary (e.g. Neumann) term</span>
<a name="l00742"></a>00742       <span class="keywordflow">if</span>( bndry_assembly != NULL )
<a name="l00743"></a>00743       {
<a name="l00744"></a>00744         context.<a class="code" href="classlibMesh_1_1FEMContext.php#a0f7f6e01f78a5dbf532901b5198878fc">side_fe_reinit</a>();
<a name="l00745"></a>00745         bndry_assembly(context, *<span class="keyword">this</span>);
<a name="l00746"></a>00746       }
<a name="l00747"></a>00747     }
<a name="l00748"></a>00748 
<a name="l00749"></a>00749     <span class="comment">// Need to symmetrize before imposing</span>
<a name="l00750"></a>00750     <span class="comment">// periodic constraints</span>
<a name="l00751"></a>00751     <span class="keywordflow">if</span>(assemble_matrix &amp;&amp; symmetrize)
<a name="l00752"></a>00752     {
<a name="l00753"></a>00753       <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Number&gt;</a> Ke_transpose;
<a name="l00754"></a>00754       context.<a class="code" href="classlibMesh_1_1DiffContext.php#aa2f012df0c5175baaf718dc4c15fb2ff">elem_jacobian</a>.<a class="code" href="classlibMesh_1_1DenseMatrix.php#a66347c890f7fd45143f6d0b8898713d1">get_transpose</a>(Ke_transpose);
<a name="l00755"></a>00755       context.<a class="code" href="classlibMesh_1_1DiffContext.php#aa2f012df0c5175baaf718dc4c15fb2ff">elem_jacobian</a> += Ke_transpose;
<a name="l00756"></a>00756       context.<a class="code" href="classlibMesh_1_1DiffContext.php#aa2f012df0c5175baaf718dc4c15fb2ff">elem_jacobian</a> *= 0.5;
<a name="l00757"></a>00757     }
<a name="l00758"></a>00758 
<a name="l00759"></a>00759     <span class="comment">// Apply constraints, e.g. periodic constraints</span>
<a name="l00760"></a>00760     this-&gt;<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>().<a class="code" href="classlibMesh_1_1DofMap.php#a97906aa49177873ed7ea9029dcb0cd4b">constrain_element_matrix_and_vector</a>
<a name="l00761"></a>00761       (context.<a class="code" href="classlibMesh_1_1DiffContext.php#aa2f012df0c5175baaf718dc4c15fb2ff">elem_jacobian</a>, context.<a class="code" href="classlibMesh_1_1DiffContext.php#ae8ee506ab5362a9fa6cb5c012d7c72b2">elem_residual</a>, context.<a class="code" href="classlibMesh_1_1DiffContext.php#a66eb0ba364350d256552d872f30c9b34">dof_indices</a>);
<a name="l00762"></a>00762       
<a name="l00763"></a>00763     <span class="comment">// Apply Dirichlet boundary conditions, we assume zero Dirichlet BCs</span>
<a name="l00764"></a>00764     <span class="comment">// Note that this cannot be inside the side-loop since non-boundary</span>
<a name="l00765"></a>00765     <span class="comment">// elements may contain boundary dofs</span>
<a name="l00766"></a>00766     std::set&lt;unsigned int&gt;::const_iterator iter;
<a name="l00767"></a>00767     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;context.<a class="code" href="classlibMesh_1_1DiffContext.php#a66eb0ba364350d256552d872f30c9b34">dof_indices</a>.size(); n++)
<a name="l00768"></a>00768     {
<a name="l00769"></a>00769       iter = <a class="code" href="classlibMesh_1_1RBBase.php#a1882c0df8f854a52376363461d402b76">global_dirichlet_dofs_set</a>.find( context.<a class="code" href="classlibMesh_1_1DiffContext.php#a66eb0ba364350d256552d872f30c9b34">dof_indices</a>[n] );
<a name="l00770"></a>00770       <span class="keywordflow">if</span>(iter != <a class="code" href="classlibMesh_1_1RBBase.php#a1882c0df8f854a52376363461d402b76">global_dirichlet_dofs_set</a>.end())
<a name="l00771"></a>00771       {
<a name="l00772"></a>00772         context.<a class="code" href="classlibMesh_1_1DiffContext.php#aa2f012df0c5175baaf718dc4c15fb2ff">elem_jacobian</a>.<a class="code" href="classlibMesh_1_1DenseMatrix.php#ae2a11c928f4640150f9df555b07ac35e">condense</a>
<a name="l00773"></a>00773           (n,n,0.,context.<a class="code" href="classlibMesh_1_1DiffContext.php#ae8ee506ab5362a9fa6cb5c012d7c72b2">elem_residual</a>);
<a name="l00774"></a>00774       }
<a name="l00775"></a>00775     }
<a name="l00776"></a>00776 
<a name="l00777"></a>00777     <span class="comment">// Scale and add to global matrix and/or vector</span>
<a name="l00778"></a>00778     context.<a class="code" href="classlibMesh_1_1DiffContext.php#aa2f012df0c5175baaf718dc4c15fb2ff">elem_jacobian</a> *= scalar;
<a name="l00779"></a>00779     context.<a class="code" href="classlibMesh_1_1DiffContext.php#ae8ee506ab5362a9fa6cb5c012d7c72b2">elem_residual</a> *= scalar;
<a name="l00780"></a>00780 
<a name="l00781"></a>00781     <span class="keywordflow">if</span>(assemble_matrix)
<a name="l00782"></a>00782       input_matrix-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#a63c5ad2e110a1873c4fd8945ad7b7e3f">add_matrix</a> (context.<a class="code" href="classlibMesh_1_1DiffContext.php#aa2f012df0c5175baaf718dc4c15fb2ff">elem_jacobian</a>,
<a name="l00783"></a>00783                                 context.<a class="code" href="classlibMesh_1_1DiffContext.php#a66eb0ba364350d256552d872f30c9b34">dof_indices</a>);
<a name="l00784"></a>00784     <span class="keywordflow">if</span>(assemble_vector)
<a name="l00785"></a>00785       input_vector-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#adbbff7081d24abefefad1497882b03ab">add_vector</a> (context.<a class="code" href="classlibMesh_1_1DiffContext.php#ae8ee506ab5362a9fa6cb5c012d7c72b2">elem_residual</a>,
<a name="l00786"></a>00786                                 context.<a class="code" href="classlibMesh_1_1DiffContext.php#a66eb0ba364350d256552d872f30c9b34">dof_indices</a>);
<a name="l00787"></a>00787   }
<a name="l00788"></a>00788 
<a name="l00789"></a>00789   <span class="keywordflow">if</span>(assemble_matrix)
<a name="l00790"></a>00790     input_matrix-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#a9a0781a7136e2f0f45b15cebef780522">close</a>();
<a name="l00791"></a>00791   <span class="keywordflow">if</span>(assemble_vector)
<a name="l00792"></a>00792     input_vector-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a42ea91bba70b3e7b27dad2a636ad31ae">close</a>();
<a name="l00793"></a>00793 
<a name="l00794"></a>00794   STOP_LOG(<span class="stringliteral">&quot;add_scaled_matrix_and_vector()&quot;</span>, <span class="stringliteral">&quot;RBSystem&quot;</span>);
<a name="l00795"></a>00795 }
<a name="l00796"></a>00796 
<a name="l00797"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a5231ac40d0bea4c48f6b734fcff1b4c7">00797</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a5231ac40d0bea4c48f6b734fcff1b4c7">RBSystem::set_context_solution_vec</a>(<a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>&amp; vec)
<a name="l00798"></a>00798 {
<a name="l00799"></a>00799   <span class="comment">// Set current_local_solution = vec so that we can access</span>
<a name="l00800"></a>00800   <span class="comment">// vec from FEMContext during assembly</span>
<a name="l00801"></a>00801   vec.<a class="code" href="classlibMesh_1_1NumericVector.php#a7348b5b027adf716016354847e0df0b6">localize</a>
<a name="l00802"></a>00802     (*<a class="code" href="classlibMesh_1_1System.php#a1e1bec53fb8d8a5a2163dbee844e8417">current_local_solution</a>, this-&gt;<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>().get_send_list());
<a name="l00803"></a>00803 }
<a name="l00804"></a>00804 
<a name="l00805"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a568b302f96140c76530b9412c1b87b38">00805</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a568b302f96140c76530b9412c1b87b38">RBSystem::assemble_scaled_matvec</a>(<a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> scalar,
<a name="l00806"></a>00806                                       <a class="code" href="namespacelibMesh.php#a18a170af3a9d5eff6f43eb3409d0e296">affine_assembly_fptr</a> intrr_assembly,
<a name="l00807"></a>00807                                       <a class="code" href="namespacelibMesh.php#a18a170af3a9d5eff6f43eb3409d0e296">affine_assembly_fptr</a> bndry_assembly,
<a name="l00808"></a>00808                                       <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>&amp; dest,
<a name="l00809"></a>00809                                       <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>&amp; arg)
<a name="l00810"></a>00810 {
<a name="l00811"></a>00811   START_LOG(<span class="stringliteral">&quot;assemble_scaled_matvec()&quot;</span>, <span class="stringliteral">&quot;RBSystem&quot;</span>);
<a name="l00812"></a>00812 
<a name="l00813"></a>00813   dest.<a class="code" href="classlibMesh_1_1NumericVector.php#a85b3d4a53413e3745e6ecf1c8b96ca65">zero</a>();
<a name="l00814"></a>00814 
<a name="l00815"></a>00815   <span class="comment">// Set current_local_solution to be arg so that we</span>
<a name="l00816"></a>00816   <span class="comment">// can access it from the FEMContext. Do this in a</span>
<a name="l00817"></a>00817   <span class="comment">// function call so that it can be overloaded as</span>
<a name="l00818"></a>00818   <span class="comment">// necessary (e.g. for QNTransientRBSystem)</span>
<a name="l00819"></a>00819   this-&gt;<a class="code" href="classlibMesh_1_1RBSystem.php#a5231ac40d0bea4c48f6b734fcff1b4c7">set_context_solution_vec</a>(arg);
<a name="l00820"></a>00820 
<a name="l00821"></a>00821   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a> = this-&gt;<a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">get_mesh</a>();
<a name="l00822"></a>00822 
<a name="l00823"></a>00823   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;FEMContext&gt;</a> c = this-&gt;<a class="code" href="classlibMesh_1_1RBSystem.php#aab5505a99e58300d0e4e17b31943f162">build_context</a>();
<a name="l00824"></a>00824   <a class="code" href="classlibMesh_1_1FEMContext.php">FEMContext</a> &amp;context  = libmesh_cast_ref&lt;FEMContext&amp;&gt;(*c);
<a name="l00825"></a>00825 
<a name="l00826"></a>00826   this-&gt;<a class="code" href="classlibMesh_1_1RBSystem.php#a2a9e0cb788597d488aa73e9108147ef2">init_context</a>(context);
<a name="l00827"></a>00827 
<a name="l00828"></a>00828   <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>       el     = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a99742bad0b034a29ccae8c5a90c6f4aa">active_local_elements_begin</a>();
<a name="l00829"></a>00829   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end_el = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a2e27f54d33f7539c0c06b36adae36cda">active_local_elements_end</a>();
<a name="l00830"></a>00830 
<a name="l00831"></a>00831   <span class="keywordflow">for</span> ( ; el != end_el; ++el)
<a name="l00832"></a>00832   {
<a name="l00833"></a>00833     context.<a class="code" href="classlibMesh_1_1FEMContext.php#a4f3f3300b191500571bf8e05bc0cf38e">pre_fe_reinit</a>(*<span class="keyword">this</span>, *el);
<a name="l00834"></a>00834     context.<a class="code" href="classlibMesh_1_1FEMContext.php#a24f0889875c6cfa85f45e0b1d0986651">elem_fe_reinit</a>();
<a name="l00835"></a>00835     <span class="keywordflow">if</span>(intrr_assembly != NULL)
<a name="l00836"></a>00836       intrr_assembly(context, *<span class="keyword">this</span>);
<a name="l00837"></a>00837 
<a name="l00838"></a>00838     <span class="keywordflow">for</span> (context.<a class="code" href="classlibMesh_1_1FEMContext.php#a59d031054af8f000ebe3874b0a944410">side</a> = 0;
<a name="l00839"></a>00839          context.<a class="code" href="classlibMesh_1_1FEMContext.php#a59d031054af8f000ebe3874b0a944410">side</a> != context.<a class="code" href="classlibMesh_1_1FEMContext.php#ab6f9bf4e40120dd6b18e6da4f12c3cc8">elem</a>-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ae376bfa6ac14723330e07a97992b56c9">n_sides</a>();
<a name="l00840"></a>00840          ++context.<a class="code" href="classlibMesh_1_1FEMContext.php#a59d031054af8f000ebe3874b0a944410">side</a>)
<a name="l00841"></a>00841     {
<a name="l00842"></a>00842       <span class="comment">// May not need to apply fluxes on non-boundary elements</span>
<a name="l00843"></a>00843       <span class="keywordflow">if</span>( (context.<a class="code" href="classlibMesh_1_1FEMContext.php#ab6f9bf4e40120dd6b18e6da4f12c3cc8">elem</a>-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(context.<a class="code" href="classlibMesh_1_1FEMContext.php#a59d031054af8f000ebe3874b0a944410">side</a>) != NULL) &amp;&amp; !<a class="code" href="classlibMesh_1_1RBSystem.php#ab76a069a5cb7bb72afe582be842d8e04">impose_internal_fluxes</a> )
<a name="l00844"></a>00844         <span class="keywordflow">continue</span>;
<a name="l00845"></a>00845 
<a name="l00846"></a>00846       <span class="keywordflow">if</span>( bndry_assembly != NULL )
<a name="l00847"></a>00847         {
<a name="l00848"></a>00848           context.<a class="code" href="classlibMesh_1_1FEMContext.php#a0f7f6e01f78a5dbf532901b5198878fc">side_fe_reinit</a>();
<a name="l00849"></a>00849           bndry_assembly(context, *<span class="keyword">this</span>);
<a name="l00850"></a>00850         }
<a name="l00851"></a>00851     }
<a name="l00852"></a>00852 
<a name="l00853"></a>00853 
<a name="l00854"></a>00854     <span class="comment">// Now perform the local matrix multiplcation</span>
<a name="l00855"></a>00855     context.<a class="code" href="classlibMesh_1_1DiffContext.php#aa2f012df0c5175baaf718dc4c15fb2ff">elem_jacobian</a>.<a class="code" href="classlibMesh_1_1DenseMatrix.php#a493649f63f70ca2adeaee645e26a4677">vector_mult</a>(context.<a class="code" href="classlibMesh_1_1DiffContext.php#ae8ee506ab5362a9fa6cb5c012d7c72b2">elem_residual</a>, context.<a class="code" href="classlibMesh_1_1DiffContext.php#a37ecd0ccb2abf2abe8f5dbbff52daf4a">elem_solution</a>);
<a name="l00856"></a>00856     context.<a class="code" href="classlibMesh_1_1DiffContext.php#ae8ee506ab5362a9fa6cb5c012d7c72b2">elem_residual</a> *= scalar;
<a name="l00857"></a>00857 
<a name="l00858"></a>00858     <span class="comment">// Apply constraints, e.g. periodic constraints</span>
<a name="l00859"></a>00859     this-&gt;<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>().<a class="code" href="classlibMesh_1_1DofMap.php#a97906aa49177873ed7ea9029dcb0cd4b">constrain_element_matrix_and_vector</a>
<a name="l00860"></a>00860       (context.<a class="code" href="classlibMesh_1_1DiffContext.php#aa2f012df0c5175baaf718dc4c15fb2ff">elem_jacobian</a>, context.<a class="code" href="classlibMesh_1_1DiffContext.php#ae8ee506ab5362a9fa6cb5c012d7c72b2">elem_residual</a>, context.<a class="code" href="classlibMesh_1_1DiffContext.php#a66eb0ba364350d256552d872f30c9b34">dof_indices</a>);
<a name="l00861"></a>00861       
<a name="l00862"></a>00862     <span class="comment">// Apply Dirichlet boundary conditions, we assume zero Dirichlet BCs</span>
<a name="l00863"></a>00863     <span class="comment">// This zeros the Dirichlet dofs in context.elem_residual</span>
<a name="l00864"></a>00864     std::set&lt;unsigned int&gt;::const_iterator iter;
<a name="l00865"></a>00865     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;context.<a class="code" href="classlibMesh_1_1DiffContext.php#a66eb0ba364350d256552d872f30c9b34">dof_indices</a>.size(); n++)
<a name="l00866"></a>00866     {
<a name="l00867"></a>00867       iter = <a class="code" href="classlibMesh_1_1RBBase.php#a1882c0df8f854a52376363461d402b76">global_dirichlet_dofs_set</a>.find( context.<a class="code" href="classlibMesh_1_1DiffContext.php#a66eb0ba364350d256552d872f30c9b34">dof_indices</a>[n] );
<a name="l00868"></a>00868       <span class="keywordflow">if</span>(iter != <a class="code" href="classlibMesh_1_1RBBase.php#a1882c0df8f854a52376363461d402b76">global_dirichlet_dofs_set</a>.end())
<a name="l00869"></a>00869       {
<a name="l00870"></a>00870         context.<a class="code" href="classlibMesh_1_1DiffContext.php#aa2f012df0c5175baaf718dc4c15fb2ff">elem_jacobian</a>.<a class="code" href="classlibMesh_1_1DenseMatrix.php#ae2a11c928f4640150f9df555b07ac35e">condense</a>
<a name="l00871"></a>00871           (n,n,0.,context.<a class="code" href="classlibMesh_1_1DiffContext.php#ae8ee506ab5362a9fa6cb5c012d7c72b2">elem_residual</a>);
<a name="l00872"></a>00872       }
<a name="l00873"></a>00873     }
<a name="l00874"></a>00874 
<a name="l00875"></a>00875     dest.<a class="code" href="classlibMesh_1_1NumericVector.php#adbbff7081d24abefefad1497882b03ab">add_vector</a> (context.<a class="code" href="classlibMesh_1_1DiffContext.php#ae8ee506ab5362a9fa6cb5c012d7c72b2">elem_residual</a>,
<a name="l00876"></a>00876                       context.<a class="code" href="classlibMesh_1_1DiffContext.php#a66eb0ba364350d256552d872f30c9b34">dof_indices</a>);
<a name="l00877"></a>00877   }
<a name="l00878"></a>00878 
<a name="l00879"></a>00879   dest.<a class="code" href="classlibMesh_1_1NumericVector.php#a42ea91bba70b3e7b27dad2a636ad31ae">close</a>();
<a name="l00880"></a>00880 
<a name="l00881"></a>00881   STOP_LOG(<span class="stringliteral">&quot;assemble_scaled_matvec()&quot;</span>, <span class="stringliteral">&quot;RBSystem&quot;</span>);
<a name="l00882"></a>00882 }
<a name="l00883"></a>00883 
<a name="l00884"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a58274b561dcb5823736406bb7b9efadc">00884</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a58274b561dcb5823736406bb7b9efadc">RBSystem::truth_assembly</a>()
<a name="l00885"></a>00885 {
<a name="l00886"></a>00886   START_LOG(<span class="stringliteral">&quot;truth_assembly()&quot;</span>, <span class="stringliteral">&quot;RBSystem&quot;</span>);
<a name="l00887"></a>00887 
<a name="l00888"></a>00888   this-&gt;<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#a966e0a6479f33c2518937e7d0f54602f">zero</a>();
<a name="l00889"></a>00889   this-&gt;<a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a85b3d4a53413e3745e6ecf1c8b96ca65">zero</a>();
<a name="l00890"></a>00890 
<a name="l00891"></a>00891   <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a>)
<a name="l00892"></a>00892   {
<a name="l00893"></a>00893     <span class="comment">// We should have already assembled the matrices</span>
<a name="l00894"></a>00894     <span class="comment">// and vectors in the affine expansion, so</span>
<a name="l00895"></a>00895     <span class="comment">// just use them</span>
<a name="l00896"></a>00896 
<a name="l00897"></a>00897     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_a=0; q_a&lt;<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>(); q_a++)
<a name="l00898"></a>00898     {
<a name="l00899"></a>00899       <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#a401beeed965b80425730050a61de5c21">add</a>(<a class="code" href="classlibMesh_1_1RBBase.php#aeeb46ce2b390bf820f954976ee9da7ce">eval_theta_q_a</a>(q_a), *<a class="code" href="classlibMesh_1_1RBSystem.php#aef1516ea2eb482f28578cab98bd53097">get_A_q</a>(q_a));
<a name="l00900"></a>00900     }
<a name="l00901"></a>00901 
<a name="l00902"></a>00902     <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt; NumericVector&lt;Number&gt;</a> &gt; temp_vec = <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;::build</a>();
<a name="l00903"></a>00903     temp_vec-&gt;init (this-&gt;<a class="code" href="classlibMesh_1_1System.php#a90dbb901f00c14ff18399f4afabcebe5">n_dofs</a>(), this-&gt;<a class="code" href="classlibMesh_1_1System.php#ae3aeb82e65b06789823d41da3c5df7a2">n_local_dofs</a>(), <span class="keyword">false</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">libMeshEnums::PARALLEL</a>);
<a name="l00904"></a>00904     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_f=0; q_f&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>(); q_f++)
<a name="l00905"></a>00905     {
<a name="l00906"></a>00906       *temp_vec = *<a class="code" href="classlibMesh_1_1RBSystem.php#a1b3f04b60e3464d779c140c280e1010e">get_F_q</a>(q_f);
<a name="l00907"></a>00907       temp_vec-&gt;scale( <a class="code" href="classlibMesh_1_1RBSystem.php#a0fd951279c9b851ac38443156b4b18bd">eval_theta_q_f</a>(q_f) );
<a name="l00908"></a>00908       <a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#aaf343defd46de8557801dc56a2884506">add</a>(*temp_vec);
<a name="l00909"></a>00909     }
<a name="l00910"></a>00910 
<a name="l00911"></a>00911     <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBSystem.php#a28b1348023897cb1517724d6ac30a21d">constrained_problem</a>)
<a name="l00912"></a>00912       <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#a401beeed965b80425730050a61de5c21">add</a>(1., *<a class="code" href="classlibMesh_1_1RBSystem.php#aa7a3439518c1b8a421a79064e819f5c8">constraint_matrix</a>);
<a name="l00913"></a>00913   }
<a name="l00914"></a>00914   <span class="keywordflow">else</span>
<a name="l00915"></a>00915   {
<a name="l00916"></a>00916     <span class="comment">// In low memory mode we do not store the matrices</span>
<a name="l00917"></a>00917     <span class="comment">// from the affine expansion, so need to assemble</span>
<a name="l00918"></a>00918 
<a name="l00919"></a>00919     <span class="comment">// For efficiency (i.e. to avoid doing Q_a+Q_f loops</span>
<a name="l00920"></a>00920     <span class="comment">// over the mesh) we do not use add_scaled_matrix_and_vector</span>
<a name="l00921"></a>00921     <span class="comment">// here</span>
<a name="l00922"></a>00922 
<a name="l00923"></a>00923     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a> = this-&gt;<a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">get_mesh</a>();
<a name="l00924"></a>00924 
<a name="l00925"></a>00925     std::vector&lt;FEMContext*&gt; Aq_context(<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>());
<a name="l00926"></a>00926     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_a=0; q_a&lt;Aq_context.size(); q_a++)
<a name="l00927"></a>00927     {
<a name="l00928"></a>00928       Aq_context[q_a] = this-&gt;<a class="code" href="classlibMesh_1_1RBSystem.php#aab5505a99e58300d0e4e17b31943f162">build_context</a>().release();
<a name="l00929"></a>00929       this-&gt;<a class="code" href="classlibMesh_1_1RBSystem.php#a2a9e0cb788597d488aa73e9108147ef2">init_context</a>(*Aq_context[q_a]);
<a name="l00930"></a>00930     }
<a name="l00931"></a>00931 
<a name="l00932"></a>00932     std::vector&lt;FEMContext*&gt; Fq_context(<a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>());
<a name="l00933"></a>00933     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_f=0; q_f&lt;Fq_context.size(); q_f++)
<a name="l00934"></a>00934     {
<a name="l00935"></a>00935       Fq_context[q_f] = this-&gt;<a class="code" href="classlibMesh_1_1RBSystem.php#aab5505a99e58300d0e4e17b31943f162">build_context</a>().release();
<a name="l00936"></a>00936       this-&gt;<a class="code" href="classlibMesh_1_1RBSystem.php#a2a9e0cb788597d488aa73e9108147ef2">init_context</a>(*Fq_context[q_f]);
<a name="l00937"></a>00937     }
<a name="l00938"></a>00938 
<a name="l00939"></a>00939     <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>       el     = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a99742bad0b034a29ccae8c5a90c6f4aa">active_local_elements_begin</a>();
<a name="l00940"></a>00940     <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end_el = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a2e27f54d33f7539c0c06b36adae36cda">active_local_elements_end</a>();
<a name="l00941"></a>00941 
<a name="l00942"></a>00942     <span class="keywordflow">for</span> ( ; el != end_el; ++el)
<a name="l00943"></a>00943     {
<a name="l00944"></a>00944       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_a=0; q_a&lt;<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>(); q_a++)
<a name="l00945"></a>00945       {
<a name="l00946"></a>00946         Aq_context[q_a]-&gt;pre_fe_reinit(*<span class="keyword">this</span>, *el);
<a name="l00947"></a>00947         Aq_context[q_a]-&gt;elem_fe_reinit();
<a name="l00948"></a>00948         <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBSystem.php#a2e5fa41dea513013a95ac9cdc5a61f0c">A_q_intrr_assembly_vector</a>[q_a] != NULL)
<a name="l00949"></a>00949           this-&gt;<a class="code" href="classlibMesh_1_1RBSystem.php#a2e5fa41dea513013a95ac9cdc5a61f0c">A_q_intrr_assembly_vector</a>[q_a](*Aq_context[q_a], *<span class="keyword">this</span>);
<a name="l00950"></a>00950       }
<a name="l00951"></a>00951 
<a name="l00952"></a>00952       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_f=0; q_f&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>(); q_f++)
<a name="l00953"></a>00953       {
<a name="l00954"></a>00954         Fq_context[q_f]-&gt;pre_fe_reinit(*<span class="keyword">this</span>, *el);
<a name="l00955"></a>00955         Fq_context[q_f]-&gt;elem_fe_reinit();
<a name="l00956"></a>00956         <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBSystem.php#afabf274dd4fced20cd745e982bbd6e83">F_q_intrr_assembly_vector</a>[q_f] != NULL)
<a name="l00957"></a>00957           this-&gt;<a class="code" href="classlibMesh_1_1RBSystem.php#afabf274dd4fced20cd745e982bbd6e83">F_q_intrr_assembly_vector</a>[q_f](*Fq_context[q_f], *<span class="keyword">this</span>);
<a name="l00958"></a>00958       }
<a name="l00959"></a>00959 
<a name="l00960"></a>00960       <span class="keywordflow">for</span> (Aq_context[0]-&gt;<a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a> = 0;
<a name="l00961"></a>00961             Aq_context[0]-&gt;side != Aq_context[0]-&gt;elem-&gt;n_sides();
<a name="l00962"></a>00962             ++Aq_context[0]-&gt;side)
<a name="l00963"></a>00963       {
<a name="l00964"></a>00964         <span class="comment">// May not need to apply fluxes on non-boundary elements</span>
<a name="l00965"></a>00965         <span class="keywordflow">if</span>( (Aq_context[0]-&gt;elem-&gt;neighbor(Aq_context[0]-&gt;side) != NULL) &amp;&amp; !<a class="code" href="classlibMesh_1_1RBSystem.php#ab76a069a5cb7bb72afe582be842d8e04">impose_internal_fluxes</a> )
<a name="l00966"></a>00966           <span class="keywordflow">continue</span>;
<a name="l00967"></a>00967 
<a name="l00968"></a>00968         <span class="comment">// Update the side information for all contexts</span>
<a name="l00969"></a>00969         <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_a=0; q_a&lt;<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>(); q_a++)
<a name="l00970"></a>00970         {
<a name="l00971"></a>00971           <span class="comment">// Update the side information for all contexts</span>
<a name="l00972"></a>00972           Aq_context[q_a]-&gt;side = Aq_context[0]-&gt;side;
<a name="l00973"></a>00973 
<a name="l00974"></a>00974           <span class="keywordflow">if</span>( <a class="code" href="classlibMesh_1_1RBSystem.php#af494bdce91a9247fae8014b49ff42296">A_q_bndry_assembly_vector</a>[q_a] != NULL )
<a name="l00975"></a>00975           {
<a name="l00976"></a>00976             Aq_context[q_a]-&gt;side_fe_reinit();
<a name="l00977"></a>00977             this-&gt;<a class="code" href="classlibMesh_1_1RBSystem.php#af494bdce91a9247fae8014b49ff42296">A_q_bndry_assembly_vector</a>[q_a](*Aq_context[q_a], *<span class="keyword">this</span>);
<a name="l00978"></a>00978           }
<a name="l00979"></a>00979         }
<a name="l00980"></a>00980 
<a name="l00981"></a>00981         <span class="comment">// Impose boundary terms, e.g. Neuman BCs</span>
<a name="l00982"></a>00982         <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_f=0; q_f&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>(); q_f++)
<a name="l00983"></a>00983         {
<a name="l00984"></a>00984           <span class="comment">// Update the side information for all contexts</span>
<a name="l00985"></a>00985           Fq_context[q_f]-&gt;side = Aq_context[0]-&gt;side;
<a name="l00986"></a>00986 
<a name="l00987"></a>00987           <span class="keywordflow">if</span>( <a class="code" href="classlibMesh_1_1RBSystem.php#aa9f3638bb29d1be5eb80a4555217d943">F_q_bndry_assembly_vector</a>[q_f] != NULL )
<a name="l00988"></a>00988           {
<a name="l00989"></a>00989             Fq_context[q_f]-&gt;side_fe_reinit();
<a name="l00990"></a>00990             this-&gt;<a class="code" href="classlibMesh_1_1RBSystem.php#aa9f3638bb29d1be5eb80a4555217d943">F_q_bndry_assembly_vector</a>[q_f](*Fq_context[q_f], *<span class="keyword">this</span>);
<a name="l00991"></a>00991           }
<a name="l00992"></a>00992         }
<a name="l00993"></a>00993       }
<a name="l00994"></a>00994 
<a name="l00995"></a>00995       <span class="comment">// Constrain the dofs to impose hanging node or periodic constraints</span>
<a name="l00996"></a>00996       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_a=0; q_a&lt;<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>(); q_a++)
<a name="l00997"></a>00997       {
<a name="l00998"></a>00998         this-&gt;<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>().<a class="code" href="classlibMesh_1_1DofMap.php#a426611c953c70989bc32a792e49c3450">constrain_element_matrix</a>
<a name="l00999"></a>00999           (Aq_context[q_a]-&gt;elem_jacobian, Aq_context[q_a]-&gt;dof_indices);
<a name="l01000"></a>01000       }
<a name="l01001"></a>01001 
<a name="l01002"></a>01002       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_f=0; q_f&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>(); q_f++)
<a name="l01003"></a>01003       {
<a name="l01004"></a>01004         this-&gt;<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>().<a class="code" href="classlibMesh_1_1DofMap.php#a29aba1bf008a1de4dd81a9a1b6f5ff41">constrain_element_vector</a>
<a name="l01005"></a>01005           (Fq_context[q_f]-&gt;elem_residual, Fq_context[q_f]-&gt;dof_indices);
<a name="l01006"></a>01006       }
<a name="l01007"></a>01007       
<a name="l01008"></a>01008       <span class="comment">// Apply Dirichlet boundary conditions, we assume zero Dirichlet BCs</span>
<a name="l01009"></a>01009       <span class="comment">// Note that this cannot be inside the side-loop since non-boundary</span>
<a name="l01010"></a>01010       <span class="comment">// elements may contain boundary dofs</span>
<a name="l01011"></a>01011       std::set&lt;unsigned int&gt;::const_iterator iter;
<a name="l01012"></a>01012       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;Aq_context[0]-&gt;dof_indices.size(); n++)
<a name="l01013"></a>01013       {
<a name="l01014"></a>01014         iter = <a class="code" href="classlibMesh_1_1RBBase.php#a1882c0df8f854a52376363461d402b76">global_dirichlet_dofs_set</a>.find( Aq_context[0]-&gt;dof_indices[n] );
<a name="l01015"></a>01015         <span class="keywordflow">if</span>(iter != <a class="code" href="classlibMesh_1_1RBBase.php#a1882c0df8f854a52376363461d402b76">global_dirichlet_dofs_set</a>.end())
<a name="l01016"></a>01016         {
<a name="l01017"></a>01017           <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_a=0; q_a&lt;<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>(); q_a++)
<a name="l01018"></a>01018           {
<a name="l01019"></a>01019             Aq_context[q_a]-&gt;elem_jacobian.condense
<a name="l01020"></a>01020               (n,n,0.,Aq_context[q_a]-&gt;elem_residual);
<a name="l01021"></a>01021           }
<a name="l01022"></a>01022 
<a name="l01023"></a>01023           <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_f=0; q_f&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>(); q_f++)
<a name="l01024"></a>01024           {
<a name="l01025"></a>01025             Fq_context[q_f]-&gt;elem_jacobian.condense
<a name="l01026"></a>01026               (n,n,0.,Fq_context[q_f]-&gt;elem_residual);
<a name="l01027"></a>01027           }
<a name="l01028"></a>01028         }
<a name="l01029"></a>01029       }
<a name="l01030"></a>01030       
<a name="l01031"></a>01031       <span class="comment">// Finally add local matrices/vectors to global system</span>
<a name="l01032"></a>01032       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_a=0; q_a&lt;<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>(); q_a++)
<a name="l01033"></a>01033       {
<a name="l01034"></a>01034         <span class="comment">// Scale by theta_q_a</span>
<a name="l01035"></a>01035         Aq_context[q_a]-&gt;elem_jacobian *= <a class="code" href="classlibMesh_1_1RBBase.php#aeeb46ce2b390bf820f954976ee9da7ce">eval_theta_q_a</a>(q_a);
<a name="l01036"></a>01036         this-&gt;<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#a63c5ad2e110a1873c4fd8945ad7b7e3f">add_matrix</a> (Aq_context[q_a]-&gt;elem_jacobian,
<a name="l01037"></a>01037                                   Aq_context[q_a]-&gt;dof_indices);
<a name="l01038"></a>01038       }
<a name="l01039"></a>01039 
<a name="l01040"></a>01040       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_f=0; q_f&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>(); q_f++)
<a name="l01041"></a>01041       {
<a name="l01042"></a>01042         <span class="comment">// Scale by theta_q_f</span>
<a name="l01043"></a>01043         Fq_context[q_f]-&gt;elem_residual *= <a class="code" href="classlibMesh_1_1RBSystem.php#a0fd951279c9b851ac38443156b4b18bd">eval_theta_q_f</a>(q_f);
<a name="l01044"></a>01044         this-&gt;<a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#adbbff7081d24abefefad1497882b03ab">add_vector</a> (Fq_context[q_f]-&gt;elem_residual,
<a name="l01045"></a>01045                               Fq_context[q_f]-&gt;dof_indices);
<a name="l01046"></a>01046       }
<a name="l01047"></a>01047     }
<a name="l01048"></a>01048 
<a name="l01049"></a>01049     <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBSystem.php#a28b1348023897cb1517724d6ac30a21d">constrained_problem</a>)
<a name="l01050"></a>01050       <a class="code" href="classlibMesh_1_1RBSystem.php#a4a1243f45ea36fbd2a10ad6956c62deb">add_scaled_matrix_and_vector</a>(1., <a class="code" href="classlibMesh_1_1RBSystem.php#a9c6da671e41886e26c7e88aae82f4358">constraint_assembly</a>, NULL, <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>, NULL);
<a name="l01051"></a>01051 
<a name="l01052"></a>01052     <span class="comment">// Delete all the ptrs to FEMContexts!</span>
<a name="l01053"></a>01053     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_a=0; q_a&lt;Aq_context.size(); q_a++)
<a name="l01054"></a>01054     {
<a name="l01055"></a>01055       <span class="keyword">delete</span> Aq_context[q_a];
<a name="l01056"></a>01056       Aq_context[q_a] = NULL;
<a name="l01057"></a>01057     }
<a name="l01058"></a>01058     Aq_context.clear();
<a name="l01059"></a>01059 
<a name="l01060"></a>01060     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_f=0; q_f&lt;Fq_context.size(); q_f++)
<a name="l01061"></a>01061     {
<a name="l01062"></a>01062       <span class="keyword">delete</span> Fq_context[q_f];
<a name="l01063"></a>01063       Fq_context[q_f];
<a name="l01064"></a>01064     }
<a name="l01065"></a>01065     Fq_context.clear();
<a name="l01066"></a>01066   }
<a name="l01067"></a>01067 
<a name="l01068"></a>01068   this-&gt;<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#a9a0781a7136e2f0f45b15cebef780522">close</a>();
<a name="l01069"></a>01069   this-&gt;<a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a42ea91bba70b3e7b27dad2a636ad31ae">close</a>();
<a name="l01070"></a>01070 
<a name="l01071"></a>01071   STOP_LOG(<span class="stringliteral">&quot;truth_assembly()&quot;</span>, <span class="stringliteral">&quot;RBSystem&quot;</span>);
<a name="l01072"></a>01072 }
<a name="l01073"></a>01073 
<a name="l01074"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a2bde84b5899642d6bb6ba2f6ac4a51f9">01074</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a2bde84b5899642d6bb6ba2f6ac4a51f9">RBSystem::assemble_inner_product_matrix</a>(<a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;Number&gt;</a>* input_matrix)
<a name="l01075"></a>01075 {
<a name="l01076"></a>01076   input_matrix-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#a966e0a6479f33c2518937e7d0f54602f">zero</a>();
<a name="l01077"></a>01077   <a class="code" href="classlibMesh_1_1RBSystem.php#a4a1243f45ea36fbd2a10ad6956c62deb">add_scaled_matrix_and_vector</a>(1., <a class="code" href="classlibMesh_1_1RBSystem.php#a2adf4c8625618eada7158c65cdc5f6f3">inner_prod_assembly</a>, <a class="code" href="classlibMesh_1_1RBSystem.php#a5baa4e96684907e89ee18cb00afb5502">inner_prod_bndry_assembly</a>, input_matrix, NULL);
<a name="l01078"></a>01078 }
<a name="l01079"></a>01079 
<a name="l01080"></a><a class="code" href="classlibMesh_1_1RBSystem.php#aad586433d469565565b32a115573df81">01080</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#aad586433d469565565b32a115573df81">RBSystem::assemble_constraint_matrix</a>(<a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;Number&gt;</a>* input_matrix)
<a name="l01081"></a>01081 {
<a name="l01082"></a>01082   input_matrix-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#a966e0a6479f33c2518937e7d0f54602f">zero</a>();
<a name="l01083"></a>01083   <a class="code" href="classlibMesh_1_1RBSystem.php#a4a1243f45ea36fbd2a10ad6956c62deb">add_scaled_matrix_and_vector</a>(1., <a class="code" href="classlibMesh_1_1RBSystem.php#a9c6da671e41886e26c7e88aae82f4358">constraint_assembly</a>, NULL, input_matrix, NULL);
<a name="l01084"></a>01084 }
<a name="l01085"></a>01085 
<a name="l01086"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a27c29a32ebf67c226b8dc3ae3f682a28">01086</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a27c29a32ebf67c226b8dc3ae3f682a28">RBSystem::assemble_and_add_constraint_matrix</a>(<a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;Number&gt;</a>* input_matrix)
<a name="l01087"></a>01087 {
<a name="l01088"></a>01088   <a class="code" href="classlibMesh_1_1RBSystem.php#a4a1243f45ea36fbd2a10ad6956c62deb">add_scaled_matrix_and_vector</a>(1., <a class="code" href="classlibMesh_1_1RBSystem.php#a9c6da671e41886e26c7e88aae82f4358">constraint_assembly</a>, NULL, input_matrix, NULL);
<a name="l01089"></a>01089 }
<a name="l01090"></a>01090 
<a name="l01091"></a><a class="code" href="classlibMesh_1_1RBSystem.php#af8d2c48f29c4102d4c9378258b90e7d9">01091</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#af8d2c48f29c4102d4c9378258b90e7d9">RBSystem::assemble_Aq_matrix</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q, <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;Number&gt;</a>* input_matrix)
<a name="l01092"></a>01092 {
<a name="l01093"></a>01093   <span class="keywordflow">if</span>(q &gt;= <a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>())
<a name="l01094"></a>01094   {
<a name="l01095"></a>01095     <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error: We must have q &lt; Q_a in assemble_Aq_matrix.&quot;</span>
<a name="l01096"></a>01096                  &lt;&lt; std::endl;
<a name="l01097"></a>01097     libmesh_error();
<a name="l01098"></a>01098   }
<a name="l01099"></a>01099 
<a name="l01100"></a>01100   input_matrix-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#a966e0a6479f33c2518937e7d0f54602f">zero</a>();
<a name="l01101"></a>01101 
<a name="l01102"></a>01102   <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBBase.php#afbb972fd9b138c16291b380796b5924b">is_A_EIM_operator</a>(q))
<a name="l01103"></a>01103   {
<a name="l01104"></a>01104     <a class="code" href="classlibMesh_1_1RBSystem.php#a4a1243f45ea36fbd2a10ad6956c62deb">add_scaled_matrix_and_vector</a>(1.,
<a name="l01105"></a>01105                                  <a class="code" href="classlibMesh_1_1RBSystem.php#a2e5fa41dea513013a95ac9cdc5a61f0c">A_q_intrr_assembly_vector</a>[q],
<a name="l01106"></a>01106                                  <a class="code" href="classlibMesh_1_1RBSystem.php#af494bdce91a9247fae8014b49ff42296">A_q_bndry_assembly_vector</a>[q],
<a name="l01107"></a>01107                                  input_matrix,
<a name="l01108"></a>01108                                  NULL);
<a name="l01109"></a>01109   }
<a name="l01110"></a>01110   <span class="keywordflow">else</span> <span class="comment">// We have an EIM function</span>
<a name="l01111"></a>01111   {
<a name="l01112"></a>01112     <span class="comment">// Find out the LHS EIM system index and the associated function index that corresponds to q</span>
<a name="l01113"></a>01113     std::pair&lt;unsigned int, unsigned int&gt; A_EIM_indices = <a class="code" href="classlibMesh_1_1RBBase.php#a7719b794672b76909fdda3e8cf6b436e">get_A_EIM_indices</a>(q);
<a name="l01114"></a>01114     
<a name="l01115"></a>01115     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> system_id = A_EIM_indices.first;
<a name="l01116"></a>01116     <a class="code" href="classlibMesh_1_1RBSystem.php#a9343f08e1c88fd8a6eb290038383ae6d">current_EIM_system</a> = <a class="code" href="classlibMesh_1_1RBBase.php#a6d45c615a2c06e710550570eb613f57f">A_EIM_systems_vector</a>[system_id];
<a name="l01117"></a>01117     
<a name="l01118"></a>01118     <span class="comment">// Cache a GHOSTED version of the EIM basis function corresponding to the current EIM function index</span>
<a name="l01119"></a>01119     <a class="code" href="classlibMesh_1_1RBSystem.php#a9343f08e1c88fd8a6eb290038383ae6d">current_EIM_system</a>-&gt;<a class="code" href="classlibMesh_1_1RBEIMSystem.php#a46b55bb7ba6c15b09d42c0b3e6feacda">cache_ghosted_basis_function</a>(A_EIM_indices.second);
<a name="l01120"></a>01120     
<a name="l01121"></a>01121     <a class="code" href="classlibMesh_1_1RBSystem.php#a4a1243f45ea36fbd2a10ad6956c62deb">add_scaled_matrix_and_vector</a>(1.,
<a name="l01122"></a>01122                                  <a class="code" href="classlibMesh_1_1RBSystem.php#a3b5f0e356b5a09e31e03f65400704cdc">A_EIM_intrr_assembly_vector</a>[system_id],
<a name="l01123"></a>01123                                  <a class="code" href="classlibMesh_1_1RBSystem.php#ad0e9f0de3570c5ed42777fcf9f7aebbc">A_EIM_bndry_assembly_vector</a>[system_id],
<a name="l01124"></a>01124                                  input_matrix,
<a name="l01125"></a>01125                                  NULL);
<a name="l01126"></a>01126   }
<a name="l01127"></a>01127 }
<a name="l01128"></a>01128 
<a name="l01129"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a7d2cb74519604f8392e318e1e9c17524">01129</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a7d2cb74519604f8392e318e1e9c17524">RBSystem::add_scaled_Aq</a>(<a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> scalar, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_a, <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;Number&gt;</a>* input_matrix, <span class="keywordtype">bool</span> symmetrize)
<a name="l01130"></a>01130 {
<a name="l01131"></a>01131   START_LOG(<span class="stringliteral">&quot;add_scaled_Aq()&quot;</span>, <span class="stringliteral">&quot;RBSystem&quot;</span>);
<a name="l01132"></a>01132 
<a name="l01133"></a>01133   <span class="keywordflow">if</span>(q_a &gt;= <a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>())
<a name="l01134"></a>01134   {
<a name="l01135"></a>01135     <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error: We must have q &lt; Q_a in add_scaled_Aq.&quot;</span>
<a name="l01136"></a>01136                  &lt;&lt; std::endl;
<a name="l01137"></a>01137     libmesh_error();
<a name="l01138"></a>01138   }
<a name="l01139"></a>01139 
<a name="l01140"></a>01140   <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a> &amp;&amp; !symmetrize)
<a name="l01141"></a>01141   {
<a name="l01142"></a>01142     input_matrix-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#a401beeed965b80425730050a61de5c21">add</a>(scalar, *<a class="code" href="classlibMesh_1_1RBSystem.php#aef1516ea2eb482f28578cab98bd53097">get_A_q</a>(q_a));
<a name="l01143"></a>01143     input_matrix-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#a9a0781a7136e2f0f45b15cebef780522">close</a>();
<a name="l01144"></a>01144   }
<a name="l01145"></a>01145   <span class="keywordflow">else</span>
<a name="l01146"></a>01146   {
<a name="l01147"></a>01147     <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBBase.php#afbb972fd9b138c16291b380796b5924b">is_A_EIM_operator</a>(q_a))
<a name="l01148"></a>01148     {
<a name="l01149"></a>01149       <a class="code" href="classlibMesh_1_1RBSystem.php#a4a1243f45ea36fbd2a10ad6956c62deb">add_scaled_matrix_and_vector</a>(scalar,
<a name="l01150"></a>01150                                    <a class="code" href="classlibMesh_1_1RBSystem.php#a2e5fa41dea513013a95ac9cdc5a61f0c">A_q_intrr_assembly_vector</a>[q_a],
<a name="l01151"></a>01151                                    <a class="code" href="classlibMesh_1_1RBSystem.php#af494bdce91a9247fae8014b49ff42296">A_q_bndry_assembly_vector</a>[q_a],
<a name="l01152"></a>01152                                    input_matrix,
<a name="l01153"></a>01153                                    NULL,
<a name="l01154"></a>01154                                    symmetrize);
<a name="l01155"></a>01155     }
<a name="l01156"></a>01156     <span class="keywordflow">else</span> <span class="comment">// We have an EIM function</span>
<a name="l01157"></a>01157     {
<a name="l01158"></a>01158       <span class="comment">// Find out the LHS EIM system index and the associated function index that corresponds to q_a</span>
<a name="l01159"></a>01159       std::pair&lt;unsigned int, unsigned int&gt; A_EIM_indices = <a class="code" href="classlibMesh_1_1RBBase.php#a7719b794672b76909fdda3e8cf6b436e">get_A_EIM_indices</a>(q_a);
<a name="l01160"></a>01160 
<a name="l01161"></a>01161       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> system_id = A_EIM_indices.first;
<a name="l01162"></a>01162       <a class="code" href="classlibMesh_1_1RBSystem.php#a9343f08e1c88fd8a6eb290038383ae6d">current_EIM_system</a> = <a class="code" href="classlibMesh_1_1RBBase.php#a6d45c615a2c06e710550570eb613f57f">A_EIM_systems_vector</a>[system_id];
<a name="l01163"></a>01163       
<a name="l01164"></a>01164       <span class="comment">// Cache a GHOSTED version of the EIM basis function corresponding to the current EIM function index</span>
<a name="l01165"></a>01165       <a class="code" href="classlibMesh_1_1RBSystem.php#a9343f08e1c88fd8a6eb290038383ae6d">current_EIM_system</a>-&gt;<a class="code" href="classlibMesh_1_1RBEIMSystem.php#a46b55bb7ba6c15b09d42c0b3e6feacda">cache_ghosted_basis_function</a>(A_EIM_indices.second);
<a name="l01166"></a>01166 
<a name="l01167"></a>01167       <a class="code" href="classlibMesh_1_1RBSystem.php#a4a1243f45ea36fbd2a10ad6956c62deb">add_scaled_matrix_and_vector</a>(scalar,
<a name="l01168"></a>01168                                    <a class="code" href="classlibMesh_1_1RBSystem.php#a3b5f0e356b5a09e31e03f65400704cdc">A_EIM_intrr_assembly_vector</a>[system_id],
<a name="l01169"></a>01169                                    <a class="code" href="classlibMesh_1_1RBSystem.php#ad0e9f0de3570c5ed42777fcf9f7aebbc">A_EIM_bndry_assembly_vector</a>[system_id],
<a name="l01170"></a>01170                                    input_matrix,
<a name="l01171"></a>01171                                    NULL,
<a name="l01172"></a>01172                                    symmetrize);
<a name="l01173"></a>01173     }
<a name="l01174"></a>01174   }
<a name="l01175"></a>01175 
<a name="l01176"></a>01176   STOP_LOG(<span class="stringliteral">&quot;add_scaled_Aq()&quot;</span>, <span class="stringliteral">&quot;RBSystem&quot;</span>);
<a name="l01177"></a>01177 }
<a name="l01178"></a>01178 
<a name="l01179"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a2fef453705e8c61cfe86eced45603dad">01179</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a2fef453705e8c61cfe86eced45603dad">RBSystem::assemble_misc_matrices</a>()
<a name="l01180"></a>01180 {
<a name="l01181"></a>01181   <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a>)
<a name="l01182"></a>01182   {
<a name="l01183"></a>01183     <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Error: Cannot store misc matrices in low-memory mode.&quot;</span> &lt;&lt; std::endl;
<a name="l01184"></a>01184     libmesh_error();
<a name="l01185"></a>01185   }
<a name="l01186"></a>01186 
<a name="l01187"></a>01187   <a class="code" href="classlibMesh_1_1RBSystem.php#a2bde84b5899642d6bb6ba2f6ac4a51f9">assemble_inner_product_matrix</a>(<a class="code" href="classlibMesh_1_1RBSystem.php#a330478ef4e1a158dc7b6f08530e10ff3">inner_product_matrix</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>());
<a name="l01188"></a>01188 
<a name="l01189"></a>01189   <span class="keywordflow">if</span>( <a class="code" href="classlibMesh_1_1RBSystem.php#a28b1348023897cb1517724d6ac30a21d">constrained_problem</a> )
<a name="l01190"></a>01190     <a class="code" href="classlibMesh_1_1RBSystem.php#aad586433d469565565b32a115573df81">assemble_constraint_matrix</a>(<a class="code" href="classlibMesh_1_1RBSystem.php#aa7a3439518c1b8a421a79064e819f5c8">constraint_matrix</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>());
<a name="l01191"></a>01191 }
<a name="l01192"></a>01192 
<a name="l01193"></a><a class="code" href="classlibMesh_1_1RBSystem.php#af03382bc15075589cbfa15caf75b8b92">01193</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#af03382bc15075589cbfa15caf75b8b92">RBSystem::assemble_all_affine_operators</a>()
<a name="l01194"></a>01194 {
<a name="l01195"></a>01195   <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a>)
<a name="l01196"></a>01196   {
<a name="l01197"></a>01197     <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Error: Cannot store affine matrices in low-memory mode.&quot;</span> &lt;&lt; std::endl;
<a name="l01198"></a>01198     libmesh_error();
<a name="l01199"></a>01199   }
<a name="l01200"></a>01200 
<a name="l01201"></a>01201   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_a=0; q_a&lt;<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>(); q_a++)
<a name="l01202"></a>01202     <a class="code" href="classlibMesh_1_1RBSystem.php#af8d2c48f29c4102d4c9378258b90e7d9">assemble_Aq_matrix</a>(q_a, <a class="code" href="classlibMesh_1_1RBSystem.php#aef1516ea2eb482f28578cab98bd53097">get_A_q</a>(q_a));
<a name="l01203"></a>01203 }
<a name="l01204"></a>01204 
<a name="l01205"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a1af76f5d23ae7d1af03f6c1666673db6">01205</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a1af76f5d23ae7d1af03f6c1666673db6">RBSystem::assemble_all_affine_vectors</a>()
<a name="l01206"></a>01206 {
<a name="l01207"></a>01207   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_f=0; q_f&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>(); q_f++)
<a name="l01208"></a>01208   {
<a name="l01209"></a>01209     <a class="code" href="classlibMesh_1_1RBSystem.php#a1b3f04b60e3464d779c140c280e1010e">get_F_q</a>(q_f)-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a85b3d4a53413e3745e6ecf1c8b96ca65">zero</a>();
<a name="l01210"></a>01210     
<a name="l01211"></a>01211     <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBSystem.php#a21aca93ce10d2135a08c36a8a38b2c8a">is_F_EIM_function</a>(q_f))
<a name="l01212"></a>01212     {
<a name="l01213"></a>01213       <a class="code" href="classlibMesh_1_1RBSystem.php#a4a1243f45ea36fbd2a10ad6956c62deb">add_scaled_matrix_and_vector</a>(1.,
<a name="l01214"></a>01214                                    <a class="code" href="classlibMesh_1_1RBSystem.php#afabf274dd4fced20cd745e982bbd6e83">F_q_intrr_assembly_vector</a>[q_f],
<a name="l01215"></a>01215                                    <a class="code" href="classlibMesh_1_1RBSystem.php#aa9f3638bb29d1be5eb80a4555217d943">F_q_bndry_assembly_vector</a>[q_f],
<a name="l01216"></a>01216                                    NULL,
<a name="l01217"></a>01217                                    <a class="code" href="classlibMesh_1_1RBSystem.php#a1b3f04b60e3464d779c140c280e1010e">get_F_q</a>(q_f));
<a name="l01218"></a>01218     }
<a name="l01219"></a>01219     <span class="keywordflow">else</span> <span class="comment">// We have an EIM function</span>
<a name="l01220"></a>01220     {
<a name="l01221"></a>01221       <span class="comment">// Find out the LHS EIM system index and the associated function index that corresponds to q</span>
<a name="l01222"></a>01222       std::pair&lt;unsigned int, unsigned int&gt; F_EIM_indices = <a class="code" href="classlibMesh_1_1RBSystem.php#a6f1c9a07eabe425ffbc8ebf2155bb187">get_F_EIM_indices</a>(q_f);
<a name="l01223"></a>01223     
<a name="l01224"></a>01224       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> system_id = F_EIM_indices.first;
<a name="l01225"></a>01225       <a class="code" href="classlibMesh_1_1RBSystem.php#a9343f08e1c88fd8a6eb290038383ae6d">current_EIM_system</a> = <a class="code" href="classlibMesh_1_1RBSystem.php#a1c0266ace79018f4fe863549db995171">F_EIM_systems_vector</a>[system_id];
<a name="l01226"></a>01226       
<a name="l01227"></a>01227       <span class="comment">// Cache a GHOSTED version of the EIM basis function corresponding to the current EIM function index</span>
<a name="l01228"></a>01228       <a class="code" href="classlibMesh_1_1RBSystem.php#a9343f08e1c88fd8a6eb290038383ae6d">current_EIM_system</a>-&gt;<a class="code" href="classlibMesh_1_1RBEIMSystem.php#a46b55bb7ba6c15b09d42c0b3e6feacda">cache_ghosted_basis_function</a>(F_EIM_indices.second);
<a name="l01229"></a>01229     
<a name="l01230"></a>01230       <a class="code" href="classlibMesh_1_1RBSystem.php#a4a1243f45ea36fbd2a10ad6956c62deb">add_scaled_matrix_and_vector</a>(1.,
<a name="l01231"></a>01231                                    <a class="code" href="classlibMesh_1_1RBSystem.php#a49be51b5a280a82e03e4bc3d40abb147">F_EIM_intrr_assembly_vector</a>[system_id],
<a name="l01232"></a>01232                                    <a class="code" href="classlibMesh_1_1RBSystem.php#a2d9f5f3318fb1e891e50b0778496d257">F_EIM_bndry_assembly_vector</a>[system_id],
<a name="l01233"></a>01233                                    NULL,
<a name="l01234"></a>01234                                    <a class="code" href="classlibMesh_1_1RBSystem.php#a1b3f04b60e3464d779c140c280e1010e">get_F_q</a>(q_f));
<a name="l01235"></a>01235     }
<a name="l01236"></a>01236   }
<a name="l01237"></a>01237 }
<a name="l01238"></a>01238 
<a name="l01239"></a><a class="code" href="classlibMesh_1_1RBSystem.php#aac92e937e2de9cd586d8fcb92967c739">01239</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#aac92e937e2de9cd586d8fcb92967c739">RBSystem::assemble_all_output_vectors</a>()
<a name="l01240"></a>01240 {
<a name="l01241"></a>01241   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#a80b9e06a7c60b3bb2f5870b0ff66a2ca">get_n_outputs</a>(); n++)
<a name="l01242"></a>01242     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_l=0; q_l&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#ab7f0b2268a9716189225e0446b519911">get_Q_l</a>(n); q_l++)
<a name="l01243"></a>01243     {
<a name="l01244"></a>01244       <a class="code" href="classlibMesh_1_1RBSystem.php#a956b276ef7de8606c78698fcfa338343">get_output_vector</a>(n, q_l)-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a85b3d4a53413e3745e6ecf1c8b96ca65">zero</a>();
<a name="l01245"></a>01245       <a class="code" href="classlibMesh_1_1RBSystem.php#a4a1243f45ea36fbd2a10ad6956c62deb">add_scaled_matrix_and_vector</a>(1., <a class="code" href="classlibMesh_1_1RBSystem.php#a228200ea93fc638ba249a979078eeb10">output_intrr_assembly_vector</a>[n][q_l],
<a name="l01246"></a>01246                                        <a class="code" href="classlibMesh_1_1RBSystem.php#a27d85bffcf0b50eab3c08dc0d17d21f2">output_bndry_assembly_vector</a>[n][q_l],
<a name="l01247"></a>01247                                        NULL,
<a name="l01248"></a>01248                                        <a class="code" href="classlibMesh_1_1RBSystem.php#a956b276ef7de8606c78698fcfa338343">get_output_vector</a>(n,q_l));
<a name="l01249"></a>01249     }
<a name="l01250"></a>01250 }
<a name="l01251"></a>01251 
<a name="l01252"></a><a class="code" href="classlibMesh_1_1RBSystem.php#aa4881a599b045f666d63f824e86b5054">01252</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1RBSystem.php#aa4881a599b045f666d63f824e86b5054">RBSystem::train_reduced_basis</a>(<span class="keyword">const</span> std::string&amp; directory_name)
<a name="l01253"></a>01253 {
<a name="l01254"></a>01254   START_LOG(<span class="stringliteral">&quot;train_reduced_basis()&quot;</span>, <span class="stringliteral">&quot;RBSystem&quot;</span>);
<a name="l01255"></a>01255 
<a name="l01256"></a>01256   <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBBase.php#a11c4b80a15c0e9ea1d822f5e04545059">initialize_calN_dependent_data</a>)
<a name="l01257"></a>01257   {
<a name="l01258"></a>01258     <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error: We must initialize the calN dependent &quot;</span>
<a name="l01259"></a>01259                  &lt;&lt; <span class="stringliteral">&quot;data structures in order to train reduced basis.&quot;</span>
<a name="l01260"></a>01260                  &lt;&lt; std::endl;
<a name="l01261"></a>01261     libmesh_error();
<a name="l01262"></a>01262   }
<a name="l01263"></a>01263 
<a name="l01264"></a>01264   <span class="keywordtype">int</span> count = 1;
<a name="l01265"></a>01265 
<a name="l01266"></a>01266   <span class="comment">// Clear the Greedy param list</span>
<a name="l01267"></a>01267   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#a9dd1607766f97d79b0abcfcf37193a11">greedy_param_list</a>.size(); i++)
<a name="l01268"></a>01268     <a class="code" href="classlibMesh_1_1RBSystem.php#a9dd1607766f97d79b0abcfcf37193a11">greedy_param_list</a>[i].<a class="code" href="classlibMesh_1_1RBSystem.php#ad9de9f8d888f8b9072402b5fe656a30d">clear</a>();
<a name="l01269"></a>01269   <a class="code" href="classlibMesh_1_1RBSystem.php#a9dd1607766f97d79b0abcfcf37193a11">greedy_param_list</a>.clear();
<a name="l01270"></a>01270 
<a name="l01271"></a>01271   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> training_greedy_error;
<a name="l01272"></a>01272 
<a name="l01273"></a>01273 
<a name="l01274"></a>01274   <span class="comment">// If we are continuing from a previous training run,</span>
<a name="l01275"></a>01275   <span class="comment">// we might already be at the max number of basis functions.</span>
<a name="l01276"></a>01276   <span class="comment">// If so, we can just return.</span>
<a name="l01277"></a>01277   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>() &gt;= <a class="code" href="classlibMesh_1_1RBSystem.php#ab47d6a963c4f68b5a3d1eea7905257f5">Nmax</a>) <span class="keywordflow">return</span> 0.;
<a name="l01278"></a>01278 
<a name="l01279"></a>01279   <span class="keywordflow">while</span>(<span class="keyword">true</span>)
<a name="l01280"></a>01280   {
<a name="l01281"></a>01281     <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; std::endl &lt;&lt; <span class="stringliteral">&quot;---- Training solve &quot;</span> &lt;&lt; count &lt;&lt; <span class="stringliteral">&quot; ----&quot;</span> &lt;&lt; std::endl;
<a name="l01282"></a>01282     <a class="code" href="classlibMesh_1_1RBBase.php#a011a675808c24a57868f9c0237575870">print_current_parameters</a>();
<a name="l01283"></a>01283 
<a name="l01284"></a>01284     <span class="comment">// Update the list of Greedily selected parameters</span>
<a name="l01285"></a>01285     this-&gt;<a class="code" href="classlibMesh_1_1RBSystem.php#a8a840ace6f0385a830ad6ab4b4edcb49">update_greedy_param_list</a>();
<a name="l01286"></a>01286 
<a name="l01287"></a>01287     <span class="comment">// Perform an Offline truth solve for the current parameter</span>
<a name="l01288"></a>01288     <a class="code" href="classlibMesh_1_1RBSystem.php#a6e3df26cf5cd4b4343483129a3d958df">truth_solve</a>(-1);
<a name="l01289"></a>01289 
<a name="l01290"></a>01290     <span class="comment">// Add orthogonal part of the snapshot to the RB space</span>
<a name="l01291"></a>01291     <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; std::endl &lt;&lt; <span class="stringliteral">&quot;Enriching the RB space&quot;</span> &lt;&lt; std::endl;
<a name="l01292"></a>01292     <a class="code" href="classlibMesh_1_1RBSystem.php#ada44f7c1f672088d8ef2b6b8abc35cd5">enrich_RB_space</a>();
<a name="l01293"></a>01293 
<a name="l01294"></a>01294     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> RB_size = <a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>();
<a name="l01295"></a>01295     <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Reduced basis dimension = &quot;</span> &lt;&lt; RB_size &lt;&lt; std::endl;
<a name="l01296"></a>01296 
<a name="l01297"></a>01297     <a class="code" href="classlibMesh_1_1RBSystem.php#af539556a1dac63314567b39e46fa9a08">update_system</a>();
<a name="l01298"></a>01298 
<a name="l01299"></a>01299     <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Performing RB solves on training set&quot;</span> &lt;&lt; std::endl;
<a name="l01300"></a>01300     training_greedy_error = <a class="code" href="classlibMesh_1_1RBSystem.php#a798528f51e8a431936d4262778218067">compute_max_error_bound</a>();
<a name="l01301"></a>01301 
<a name="l01302"></a>01302 
<a name="l01303"></a>01303     <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Maximum a posteriori error is &quot;</span>
<a name="l01304"></a>01304               &lt;&lt; training_greedy_error &lt;&lt; std::endl &lt;&lt; std::endl;
<a name="l01305"></a>01305 
<a name="l01306"></a>01306     <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBSystem.php#a5d9cd7b5d9de8e0d7b6efde6252c449c">write_data_during_training</a>)
<a name="l01307"></a>01307     {
<a name="l01308"></a>01308       <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> new_dir_name;
<a name="l01309"></a>01309       new_dir_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;_&quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>();
<a name="l01310"></a>01310       <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Writing out RB data to &quot;</span> &lt;&lt; new_dir_name.str() &lt;&lt; std::endl;
<a name="l01311"></a>01311       <a class="code" href="classlibMesh_1_1RBSystem.php#a9382ee8b327d3e7db7e867d9cfb24fc2">write_offline_data_to_files</a>(new_dir_name.str());
<a name="l01312"></a>01312     }
<a name="l01313"></a>01313 
<a name="l01314"></a>01314     <span class="comment">// Break out of training phase if we have reached Nmax</span>
<a name="l01315"></a>01315     <span class="comment">// or if the training_tolerance is satisfied.</span>
<a name="l01316"></a>01316     <span class="keywordflow">if</span>( <a class="code" href="classlibMesh_1_1RBSystem.php#a79eb03faea6389086e2ccbb032569243">greedy_termination_test</a>(training_greedy_error, count) )
<a name="l01317"></a>01317     {
<a name="l01318"></a>01318       <span class="keywordflow">break</span>;
<a name="l01319"></a>01319     }
<a name="l01320"></a>01320 
<a name="l01321"></a>01321     <span class="comment">// Increment counter</span>
<a name="l01322"></a>01322     count++;
<a name="l01323"></a>01323   }
<a name="l01324"></a>01324   this-&gt;<a class="code" href="classlibMesh_1_1RBSystem.php#a8a840ace6f0385a830ad6ab4b4edcb49">update_greedy_param_list</a>();
<a name="l01325"></a>01325   STOP_LOG(<span class="stringliteral">&quot;train_reduced_basis()&quot;</span>, <span class="stringliteral">&quot;RBSystem&quot;</span>);
<a name="l01326"></a>01326 
<a name="l01327"></a>01327   <span class="keywordflow">return</span> training_greedy_error;
<a name="l01328"></a>01328 }
<a name="l01329"></a>01329 
<a name="l01330"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a6cae03a0338b32c65938db1f805deb3c">01330</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1RBSystem.php#a6cae03a0338b32c65938db1f805deb3c">RBSystem::eval_output_dual_norm</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n)
<a name="l01331"></a>01331 {
<a name="l01332"></a>01332   <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> output_bound_sq = 0.;    
<a name="l01333"></a>01333   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q=0;
<a name="l01334"></a>01334   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_l1=0; q_l1&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#ab7f0b2268a9716189225e0446b519911">get_Q_l</a>(n); q_l1++)
<a name="l01335"></a>01335   {
<a name="l01336"></a>01336     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_l2=q_l1; q_l2&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#ab7f0b2268a9716189225e0446b519911">get_Q_l</a>(n); q_l2++)
<a name="l01337"></a>01337     {
<a name="l01338"></a>01338       <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> delta = (q_l1==q_l2) ? 1. : 2.;
<a name="l01339"></a>01339       output_bound_sq += delta * <a class="code" href="namespacelibMesh.php#aea33cac176f18504c5c4078407aadbb7">libmesh_real</a>(
<a name="l01340"></a>01340         <a class="code" href="namespacelibMesh.php#adf2cda6212d46ff664adf9f688129825">libmesh_conj</a>(<a class="code" href="classlibMesh_1_1RBSystem.php#a3ab4b896903320a2b313f73efc2aaad1">eval_theta_q_l</a>(n,q_l1))*<a class="code" href="classlibMesh_1_1RBSystem.php#a3ab4b896903320a2b313f73efc2aaad1">eval_theta_q_l</a>(n,q_l2) * <a class="code" href="classlibMesh_1_1RBSystem.php#a2e3592b7167280ef4dd92cfb4a131c62">output_dual_norms</a>[n][q] );
<a name="l01341"></a>01341       q++;
<a name="l01342"></a>01342     }
<a name="l01343"></a>01343   }
<a name="l01344"></a>01344     
<a name="l01345"></a>01345   <span class="keywordflow">return</span> <a class="code" href="namespacelibMesh.php#aea33cac176f18504c5c4078407aadbb7">libmesh_real</a>(std::sqrt( output_bound_sq ));
<a name="l01346"></a>01346 }
<a name="l01347"></a>01347 
<a name="l01348"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a79eb03faea6389086e2ccbb032569243">01348</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a79eb03faea6389086e2ccbb032569243">RBSystem::greedy_termination_test</a>(<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> training_greedy_error, <span class="keywordtype">int</span>)
<a name="l01349"></a>01349 {
<a name="l01350"></a>01350   <span class="keywordflow">if</span>(training_greedy_error &lt; this-&gt;<a class="code" href="classlibMesh_1_1RBSystem.php#a56a24996be9d774563f1a8e6165ed038">training_tolerance</a>)
<a name="l01351"></a>01351   {
<a name="l01352"></a>01352     <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Specified error tolerance reached.&quot;</span> &lt;&lt; std::endl;
<a name="l01353"></a>01353     <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l01354"></a>01354   }
<a name="l01355"></a>01355 
<a name="l01356"></a>01356   <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>() &gt;= this-&gt;<a class="code" href="classlibMesh_1_1RBSystem.php#a5acee637ff70dd65ec54de29241f0627">get_Nmax</a>())
<a name="l01357"></a>01357   {
<a name="l01358"></a>01358     <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Maximum number of basis functions reached: Nmax = &quot;</span>
<a name="l01359"></a>01359                  &lt;&lt; <a class="code" href="classlibMesh_1_1RBSystem.php#a5acee637ff70dd65ec54de29241f0627">get_Nmax</a>() &lt;&lt; std::endl;
<a name="l01360"></a>01360     <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l01361"></a>01361   }
<a name="l01362"></a>01362 
<a name="l01363"></a>01363   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l01364"></a>01364 }
<a name="l01365"></a>01365 
<a name="l01366"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a8a840ace6f0385a830ad6ab4b4edcb49">01366</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a8a840ace6f0385a830ad6ab4b4edcb49">RBSystem::update_greedy_param_list</a>()
<a name="l01367"></a>01367 {
<a name="l01368"></a>01368   <a class="code" href="classlibMesh_1_1RBSystem.php#a9dd1607766f97d79b0abcfcf37193a11">greedy_param_list</a>.push_back( <a class="code" href="classlibMesh_1_1RBBase.php#af3bb451bd612eb5e7e8f0684f4b9cc97">get_current_parameters</a>() );
<a name="l01369"></a>01369 }
<a name="l01370"></a>01370 
<a name="l01371"></a><a class="code" href="classlibMesh_1_1RBSystem.php#aa30b66f0a86c1c1b58216db87022766c">01371</a> std::vector&lt;Real&gt; <a class="code" href="classlibMesh_1_1RBSystem.php#aa30b66f0a86c1c1b58216db87022766c">RBSystem::get_greedy_parameter</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)
<a name="l01372"></a>01372 {
<a name="l01373"></a>01373   <span class="keywordflow">if</span>( i &gt;= <a class="code" href="classlibMesh_1_1RBSystem.php#a9dd1607766f97d79b0abcfcf37193a11">greedy_param_list</a>.size() )
<a name="l01374"></a>01374   {
<a name="l01375"></a>01375     <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Error: Argument in RBSystem::get_greedy_parameter is too large.&quot;</span>
<a name="l01376"></a>01376                  &lt;&lt; std::endl;
<a name="l01377"></a>01377     libmesh_error();
<a name="l01378"></a>01378   }
<a name="l01379"></a>01379 
<a name="l01380"></a>01380   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a9dd1607766f97d79b0abcfcf37193a11">greedy_param_list</a>[i];
<a name="l01381"></a>01381 }
<a name="l01382"></a>01382 
<a name="l01383"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a6e3df26cf5cd4b4343483129a3d958df">01383</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1RBSystem.php#a6e3df26cf5cd4b4343483129a3d958df">RBSystem::truth_solve</a>(<span class="keywordtype">int</span> plot_solution)
<a name="l01384"></a>01384 {
<a name="l01385"></a>01385   START_LOG(<span class="stringliteral">&quot;truth_solve()&quot;</span>, <span class="stringliteral">&quot;RBSystem&quot;</span>);
<a name="l01386"></a>01386 
<a name="l01387"></a>01387   <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBBase.php#a11c4b80a15c0e9ea1d822f5e04545059">initialize_calN_dependent_data</a>)
<a name="l01388"></a>01388   {
<a name="l01389"></a>01389     <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error: We must initialize the calN dependent &quot;</span>
<a name="l01390"></a>01390                  &lt;&lt; <span class="stringliteral">&quot;data structures in order to do a truth solve.&quot;</span>
<a name="l01391"></a>01391                  &lt;&lt; std::endl;
<a name="l01392"></a>01392     libmesh_error();
<a name="l01393"></a>01393   }
<a name="l01394"></a>01394 
<a name="l01395"></a>01395   <a class="code" href="classlibMesh_1_1RBSystem.php#a58274b561dcb5823736406bb7b9efadc">truth_assembly</a>();
<a name="l01396"></a>01396   <a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#af1de21a76860785bb1992280eb72b0db">solve</a>();
<a name="l01397"></a>01397 
<a name="l01398"></a>01398   <span class="comment">// Make sure we didn&#39;t max out the number of iterations</span>
<a name="l01399"></a>01399   <span class="keywordflow">if</span>( (this-&gt;<a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#af712dbf0e285c5ff4cc346daef05423c">n_linear_iterations</a>() &gt;=
<a name="l01400"></a>01400        this-&gt;<a class="code" href="classlibMesh_1_1System.php#ac5ca6b1f3adcfac56982982e90dc905b">get_equation_systems</a>().parameters.get&lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&gt;(<span class="stringliteral">&quot;linear solver maximum iterations&quot;</span>)) &amp;&amp;
<a name="l01401"></a>01401       (this-&gt;final_linear_residual() &gt;
<a name="l01402"></a>01402        this-&gt;<a class="code" href="classlibMesh_1_1System.php#ac5ca6b1f3adcfac56982982e90dc905b">get_equation_systems</a>().<a class="code" href="classlibMesh_1_1EquationSystems.php#a7c02be232f564967ca0804a7824adb53">parameters</a>.<a class="code" href="classlibMesh_1_1Parameters.php#ac7fa2054ee32db2c3979d48bd2103f20">get</a>&lt;<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>&gt;(<span class="stringliteral">&quot;linear solver tolerance&quot;</span>)) )
<a name="l01403"></a>01403   {
<a name="l01404"></a>01404       <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Warning: Linear solver may not have converged! Final linear residual = &quot;</span>
<a name="l01405"></a>01405                    &lt;&lt; this-&gt;<a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a86b5e2954d2a2e43014bcda8810239ac">final_linear_residual</a>() &lt;&lt; <span class="stringliteral">&quot;, number of iterations = &quot;</span>
<a name="l01406"></a>01406                    &lt;&lt; this-&gt;<a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#af712dbf0e285c5ff4cc346daef05423c">n_linear_iterations</a>() &lt;&lt; std::endl &lt;&lt; std::endl;
<a name="l01407"></a>01407 <span class="comment">//     libmesh_error();</span>
<a name="l01408"></a>01408   }
<a name="l01409"></a>01409 
<a name="l01410"></a>01410   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#a80b9e06a7c60b3bb2f5870b0ff66a2ca">get_n_outputs</a>(); n++)
<a name="l01411"></a>01411   {
<a name="l01412"></a>01412     <a class="code" href="classlibMesh_1_1RBSystem.php#abef8df30d43713bb06b2a83b89a0ed29">truth_outputs</a>[n] = 0.;
<a name="l01413"></a>01413     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_l=0; q_l&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#ab7f0b2268a9716189225e0446b519911">get_Q_l</a>(n); q_l++)
<a name="l01414"></a>01414       <a class="code" href="classlibMesh_1_1RBSystem.php#abef8df30d43713bb06b2a83b89a0ed29">truth_outputs</a>[n] += <a class="code" href="namespacelibMesh.php#adf2cda6212d46ff664adf9f688129825">libmesh_conj</a>(<a class="code" href="classlibMesh_1_1RBSystem.php#a3ab4b896903320a2b313f73efc2aaad1">eval_theta_q_l</a>(n, q_l))*<a class="code" href="classlibMesh_1_1RBSystem.php#a956b276ef7de8606c78698fcfa338343">get_output_vector</a>(n,q_l)-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a1f522c421b32b75ea4dc3de6d1a95000">dot</a>(*<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>);
<a name="l01415"></a>01415   }
<a name="l01416"></a>01416 
<a name="l01417"></a>01417   <span class="keywordflow">if</span>(plot_solution &gt; 0)
<a name="l01418"></a>01418   {
<a name="l01419"></a>01419     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a> = <a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">get_mesh</a>();
<a name="l01420"></a>01420     <a class="code" href="classlibMesh_1_1GMVIO.php">GMVIO</a>(mesh).<a class="code" href="classlibMesh_1_1MeshOutput.php#a935598198649f4b831cd341ce91b3ccb">write_equation_systems</a> (<span class="stringliteral">&quot;truth.gmv&quot;</span>,
<a name="l01421"></a>01421                                         this-&gt;<a class="code" href="classlibMesh_1_1System.php#ac5ca6b1f3adcfac56982982e90dc905b">get_equation_systems</a>());
<a name="l01422"></a>01422   }
<a name="l01423"></a>01423 
<a name="l01424"></a>01424   <span class="comment">// Get the X norm of the truth solution</span>
<a name="l01425"></a>01425   <span class="comment">// Useful for normalizing our true error data</span>
<a name="l01426"></a>01426   <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a>)
<a name="l01427"></a>01427   {
<a name="l01428"></a>01428     <a class="code" href="classlibMesh_1_1RBSystem.php#a330478ef4e1a158dc7b6f08530e10ff3">inner_product_matrix</a>-&gt;vector_mult(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>, *<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>);
<a name="l01429"></a>01429   }
<a name="l01430"></a>01430   <span class="keywordflow">else</span>
<a name="l01431"></a>01431   {
<a name="l01432"></a>01432     <a class="code" href="classlibMesh_1_1RBSystem.php#a2bde84b5899642d6bb6ba2f6ac4a51f9">assemble_inner_product_matrix</a>(<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>);
<a name="l01433"></a>01433     <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#adaccc5857f1a5d5ca264ded0b8bfb986">vector_mult</a>(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>, *<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>);
<a name="l01434"></a>01434   }
<a name="l01435"></a>01435 
<a name="l01436"></a>01436   <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> truth_X_norm = std::sqrt(<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>-&gt;dot(*<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>));
<a name="l01437"></a>01437 
<a name="l01438"></a>01438   STOP_LOG(<span class="stringliteral">&quot;truth_solve()&quot;</span>, <span class="stringliteral">&quot;RBSystem&quot;</span>);
<a name="l01439"></a>01439 
<a name="l01440"></a>01440   <span class="keywordflow">return</span> <a class="code" href="namespacelibMesh.php#aea33cac176f18504c5c4078407aadbb7">libmesh_real</a>(truth_X_norm);
<a name="l01441"></a>01441 }
<a name="l01442"></a>01442 
<a name="l01443"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a6d4f87f01e24e2dfa0a8b44314707116">01443</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a6d4f87f01e24e2dfa0a8b44314707116">RBSystem::set_eigen_system_name</a>(<span class="keyword">const</span> std::string&amp; <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>)
<a name="l01444"></a>01444 {
<a name="l01445"></a>01445   <a class="code" href="classlibMesh_1_1RBSystem.php#ab53684df668b4dbad08d68fd6be1fd37">eigen_system_name</a> = <a class="code" href="classlibMesh_1_1System.php#af80f6b2e508821ebd9c8fcb78d443f18">name</a>;
<a name="l01446"></a>01446 }
<a name="l01447"></a>01447 
<a name="l01448"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a0eedc533ec1db115433f692dbcd33e1f">01448</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a0eedc533ec1db115433f692dbcd33e1f">RBSystem::set_Nmax</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Nmax_in)
<a name="l01449"></a>01449 {
<a name="l01450"></a>01450   <span class="comment">// We assume that Nmax is initialized in</span>
<a name="l01451"></a>01451   <span class="comment">// init_data to initial_Nmax, and that it</span>
<a name="l01452"></a>01452   <span class="comment">// cannot be increased above initial_Nmax</span>
<a name="l01453"></a>01453   <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBSystem.php#ac5a6b09c8f4e8d788be2ad45dc1bfb05">RB_system_initialized</a> &amp;&amp; (Nmax_in &gt; <a class="code" href="classlibMesh_1_1RBSystem.php#af3d84b1c9662e32972e37314f1a81353">initial_Nmax</a>))
<a name="l01454"></a>01454   {
<a name="l01455"></a>01455     <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error: System was initialized with Nmax = &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1RBSystem.php#af3d84b1c9662e32972e37314f1a81353">initial_Nmax</a>
<a name="l01456"></a>01456                  &lt;&lt; <span class="stringliteral">&quot;, cannot set Nmax higher than this value.&quot;</span>  &lt;&lt; std::endl;
<a name="l01457"></a>01457     libmesh_error();
<a name="l01458"></a>01458   }
<a name="l01459"></a>01459 
<a name="l01460"></a>01460   <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBSystem.php#ac5a6b09c8f4e8d788be2ad45dc1bfb05">RB_system_initialized</a> &amp;&amp; (Nmax_in &lt; this-&gt;<a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>()))
<a name="l01461"></a>01461   {
<a name="l01462"></a>01462     <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error: Cannot set Nmax to be less than the &quot;</span>
<a name="l01463"></a>01463                  &lt;&lt; <span class="stringliteral">&quot;current number of basis functions.&quot;</span>  &lt;&lt; std::endl;
<a name="l01464"></a>01464     libmesh_error();
<a name="l01465"></a>01465   }
<a name="l01466"></a>01466 
<a name="l01467"></a>01467   this-&gt;<a class="code" href="classlibMesh_1_1RBSystem.php#ab47d6a963c4f68b5a3d1eea7905257f5">Nmax</a> = Nmax_in;
<a name="l01468"></a>01468 }
<a name="l01469"></a>01469 
<a name="l01470"></a><a class="code" href="classlibMesh_1_1RBSystem.php#ac1e04bfe35245ea3e225fc5865621fb0">01470</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1RBSystem.php#ac1e04bfe35245ea3e225fc5865621fb0">RBSystem::get_n_F_EIM_systems</a>()<span class="keyword"> const</span>
<a name="l01471"></a>01471 <span class="keyword"></span>{
<a name="l01472"></a>01472   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a1c0266ace79018f4fe863549db995171">F_EIM_systems_vector</a>.size();
<a name="l01473"></a>01473 }
<a name="l01474"></a>01474 
<a name="l01475"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a8d33ac93600827567a3c5fd0b7c5741c">01475</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a8d33ac93600827567a3c5fd0b7c5741c">RBSystem::get_n_F_EIM_functions</a>()<span class="keyword"> const</span>
<a name="l01476"></a>01476 <span class="keyword"></span>{
<a name="l01477"></a>01477   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> count = 0;
<a name="l01478"></a>01478   
<a name="l01479"></a>01479   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#a1c0266ace79018f4fe863549db995171">F_EIM_systems_vector</a>.size(); i++)
<a name="l01480"></a>01480     count += <a class="code" href="classlibMesh_1_1RBSystem.php#a1c0266ace79018f4fe863549db995171">F_EIM_systems_vector</a>[i]-&gt;get_n_affine_functions();
<a name="l01481"></a>01481 
<a name="l01482"></a>01482   <span class="keywordflow">return</span> count;
<a name="l01483"></a>01483 }
<a name="l01484"></a>01484 
<a name="l01485"></a><a class="code" href="classlibMesh_1_1RBSystem.php#af32bc9a0c5fe34e1a0f3f097506ca15a">01485</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#af32bc9a0c5fe34e1a0f3f097506ca15a">RBSystem::attach_A_q</a>(<a class="code" href="namespacelibMesh.php#aa62736885c7a9bb67eda65b54ee20107">theta_q_fptr</a> theta_q_a,
<a name="l01486"></a>01486                                    <a class="code" href="namespacelibMesh.php#a18a170af3a9d5eff6f43eb3409d0e296">affine_assembly_fptr</a> A_q_intrr_assembly,
<a name="l01487"></a>01487                                    <a class="code" href="namespacelibMesh.php#a18a170af3a9d5eff6f43eb3409d0e296">affine_assembly_fptr</a> A_q_bndry_assembly)
<a name="l01488"></a>01488 {
<a name="l01489"></a>01489   <a class="code" href="classlibMesh_1_1RBBase.php#a297812cdf2117dc893575b48060ecab7">theta_q_a_vector</a>.push_back(theta_q_a);
<a name="l01490"></a>01490   <a class="code" href="classlibMesh_1_1RBSystem.php#a2e5fa41dea513013a95ac9cdc5a61f0c">A_q_intrr_assembly_vector</a>.push_back(A_q_intrr_assembly);
<a name="l01491"></a>01491   <a class="code" href="classlibMesh_1_1RBSystem.php#af494bdce91a9247fae8014b49ff42296">A_q_bndry_assembly_vector</a>.push_back(A_q_bndry_assembly);
<a name="l01492"></a>01492 }
<a name="l01493"></a>01493 
<a name="l01494"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a725f3a18ed697b39bdd724ae95916f07">01494</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a725f3a18ed697b39bdd724ae95916f07">RBSystem::attach_F_q</a>(<a class="code" href="namespacelibMesh.php#aa62736885c7a9bb67eda65b54ee20107">theta_q_fptr</a> theta_q_f,
<a name="l01495"></a>01495                           <a class="code" href="namespacelibMesh.php#a18a170af3a9d5eff6f43eb3409d0e296">affine_assembly_fptr</a> F_q_intrr_assembly,
<a name="l01496"></a>01496                           <a class="code" href="namespacelibMesh.php#a18a170af3a9d5eff6f43eb3409d0e296">affine_assembly_fptr</a> F_q_bndry_assembly)
<a name="l01497"></a>01497 {
<a name="l01498"></a>01498   <a class="code" href="classlibMesh_1_1RBSystem.php#acc90dcf523c055fc294bc71b67dfe876">theta_q_f_vector</a>.push_back(theta_q_f);
<a name="l01499"></a>01499   <a class="code" href="classlibMesh_1_1RBSystem.php#afabf274dd4fced20cd745e982bbd6e83">F_q_intrr_assembly_vector</a>.push_back(F_q_intrr_assembly);
<a name="l01500"></a>01500   <a class="code" href="classlibMesh_1_1RBSystem.php#aa9f3638bb29d1be5eb80a4555217d943">F_q_bndry_assembly_vector</a>.push_back(F_q_bndry_assembly);
<a name="l01501"></a>01501 }
<a name="l01502"></a>01502 
<a name="l01503"></a><a class="code" href="classlibMesh_1_1RBSystem.php#abccfc951179c22c92c8a8ee2d33d8ff5">01503</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#abccfc951179c22c92c8a8ee2d33d8ff5">RBSystem::attach_A_EIM_operators</a>(<a class="code" href="classlibMesh_1_1RBEIMSystem.php">RBEIMSystem</a>* eim_system,
<a name="l01504"></a>01504                                         <a class="code" href="namespacelibMesh.php#a18a170af3a9d5eff6f43eb3409d0e296">affine_assembly_fptr</a> EIM_intrr_assembly,
<a name="l01505"></a>01505                                         <a class="code" href="namespacelibMesh.php#a18a170af3a9d5eff6f43eb3409d0e296">affine_assembly_fptr</a> EIM_bndry_assembly)
<a name="l01506"></a>01506 {
<a name="l01507"></a>01507   <a class="code" href="classlibMesh_1_1RBBase.php#a6d45c615a2c06e710550570eb613f57f">A_EIM_systems_vector</a>.push_back( eim_system );
<a name="l01508"></a>01508   <a class="code" href="classlibMesh_1_1RBSystem.php#a3b5f0e356b5a09e31e03f65400704cdc">A_EIM_intrr_assembly_vector</a>.push_back(EIM_intrr_assembly);
<a name="l01509"></a>01509   <a class="code" href="classlibMesh_1_1RBSystem.php#ad0e9f0de3570c5ed42777fcf9f7aebbc">A_EIM_bndry_assembly_vector</a>.push_back(EIM_bndry_assembly);
<a name="l01510"></a>01510 }
<a name="l01511"></a>01511 
<a name="l01512"></a><a class="code" href="classlibMesh_1_1RBSystem.php#ac943bfc401b46640c6780760216aeaa5">01512</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#ac943bfc401b46640c6780760216aeaa5">RBSystem::attach_F_EIM_vectors</a>(<a class="code" href="classlibMesh_1_1RBEIMSystem.php">RBEIMSystem</a>* eim_system,
<a name="l01513"></a>01513                                       <a class="code" href="namespacelibMesh.php#a18a170af3a9d5eff6f43eb3409d0e296">affine_assembly_fptr</a> EIM_intrr_assembly,
<a name="l01514"></a>01514                                       <a class="code" href="namespacelibMesh.php#a18a170af3a9d5eff6f43eb3409d0e296">affine_assembly_fptr</a> EIM_bndry_assembly)
<a name="l01515"></a>01515 {
<a name="l01516"></a>01516   <a class="code" href="classlibMesh_1_1RBSystem.php#a1c0266ace79018f4fe863549db995171">F_EIM_systems_vector</a>.push_back( eim_system );
<a name="l01517"></a>01517   <a class="code" href="classlibMesh_1_1RBSystem.php#a49be51b5a280a82e03e4bc3d40abb147">F_EIM_intrr_assembly_vector</a>.push_back(EIM_intrr_assembly);
<a name="l01518"></a>01518   <a class="code" href="classlibMesh_1_1RBSystem.php#a2d9f5f3318fb1e891e50b0778496d257">F_EIM_bndry_assembly_vector</a>.push_back(EIM_bndry_assembly);
<a name="l01519"></a>01519 }
<a name="l01520"></a>01520 
<a name="l01521"></a><a class="code" href="classlibMesh_1_1RBSystem.php#aa1eabdea15878ea1a4d3665152313d29">01521</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#aa1eabdea15878ea1a4d3665152313d29">RBSystem::attach_output</a>(std::vector&lt;theta_q_fptr&gt; theta_q_l,
<a name="l01522"></a>01522                              std::vector&lt;affine_assembly_fptr&gt; output_intrr_assembly,
<a name="l01523"></a>01523                              std::vector&lt;affine_assembly_fptr&gt; output_bndry_assembly)
<a name="l01524"></a>01524 {
<a name="l01525"></a>01525   <span class="comment">// Make sure the input vectors are all the same size!</span>
<a name="l01526"></a>01526   <span class="keywordflow">if</span>( (theta_q_l.size() == output_intrr_assembly.size()) &amp;&amp;
<a name="l01527"></a>01527       (output_intrr_assembly.size() == output_bndry_assembly.size()) )
<a name="l01528"></a>01528   {
<a name="l01529"></a>01529     <a class="code" href="classlibMesh_1_1RBSystem.php#a1fa2b8ea817cae06f0d2e0bdbdd8b273">theta_q_l_vector</a>.push_back(theta_q_l);
<a name="l01530"></a>01530     <a class="code" href="classlibMesh_1_1RBSystem.php#a228200ea93fc638ba249a979078eeb10">output_intrr_assembly_vector</a>.push_back(output_intrr_assembly);
<a name="l01531"></a>01531     <a class="code" href="classlibMesh_1_1RBSystem.php#a27d85bffcf0b50eab3c08dc0d17d21f2">output_bndry_assembly_vector</a>.push_back(output_bndry_assembly);
<a name="l01532"></a>01532   }
<a name="l01533"></a>01533   <span class="keywordflow">else</span>
<a name="l01534"></a>01534   {
<a name="l01535"></a>01535     <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Error: The input vectors in attach_output must all be the same size in attach_output&quot;</span>
<a name="l01536"></a>01536                  &lt;&lt; std::endl;
<a name="l01537"></a>01537     libmesh_error();
<a name="l01538"></a>01538   }
<a name="l01539"></a>01539 }
<a name="l01540"></a>01540 
<a name="l01541"></a><a class="code" href="classlibMesh_1_1RBSystem.php#af6d012f06fb88a1532da7c6a5f201139">01541</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#aa1eabdea15878ea1a4d3665152313d29">RBSystem::attach_output</a>(<a class="code" href="namespacelibMesh.php#aa62736885c7a9bb67eda65b54ee20107">theta_q_fptr</a> theta_q_l,
<a name="l01542"></a>01542                              <a class="code" href="namespacelibMesh.php#a18a170af3a9d5eff6f43eb3409d0e296">affine_assembly_fptr</a> output_intrr_assembly,
<a name="l01543"></a>01543                              <a class="code" href="namespacelibMesh.php#a18a170af3a9d5eff6f43eb3409d0e296">affine_assembly_fptr</a> output_bndry_assembly)
<a name="l01544"></a>01544 {
<a name="l01545"></a>01545   std::vector&lt;theta_q_fptr&gt; theta_l_vector(1); theta_l_vector[0] = theta_q_l;
<a name="l01546"></a>01546   std::vector&lt;affine_assembly_fptr&gt; L_intrr_vector(1); L_intrr_vector[0] = output_intrr_assembly;
<a name="l01547"></a>01547   std::vector&lt;affine_assembly_fptr&gt; L_bndry_vector(1); L_bndry_vector[0] = output_bndry_assembly;
<a name="l01548"></a>01548 
<a name="l01549"></a>01549   <a class="code" href="classlibMesh_1_1RBSystem.php#aa1eabdea15878ea1a4d3665152313d29">attach_output</a>(theta_l_vector, L_intrr_vector, L_bndry_vector);
<a name="l01550"></a>01550 }
<a name="l01551"></a>01551 
<a name="l01552"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a21aca93ce10d2135a08c36a8a38b2c8a">01552</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a21aca93ce10d2135a08c36a8a38b2c8a">RBSystem::is_F_EIM_function</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q)
<a name="l01553"></a>01553 {
<a name="l01554"></a>01554   libmesh_assert(q &lt; <a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>());
<a name="l01555"></a>01555 
<a name="l01556"></a>01556   <span class="keywordflow">return</span> (q &gt;= <a class="code" href="classlibMesh_1_1RBSystem.php#acc90dcf523c055fc294bc71b67dfe876">theta_q_f_vector</a>.size());
<a name="l01557"></a>01557 }
<a name="l01558"></a>01558 
<a name="l01559"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a9c316631be4ba78acd6c6cbc47126a76">01559</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a9c316631be4ba78acd6c6cbc47126a76">RBSystem::attach_inner_prod_assembly</a>(<a class="code" href="namespacelibMesh.php#a18a170af3a9d5eff6f43eb3409d0e296">affine_assembly_fptr</a> IP_assembly, <a class="code" href="namespacelibMesh.php#a18a170af3a9d5eff6f43eb3409d0e296">affine_assembly_fptr</a> IP_bndry_assembly)
<a name="l01560"></a>01560 {
<a name="l01561"></a>01561   <a class="code" href="classlibMesh_1_1RBSystem.php#a2adf4c8625618eada7158c65cdc5f6f3">inner_prod_assembly</a> = IP_assembly;
<a name="l01562"></a>01562   <a class="code" href="classlibMesh_1_1RBSystem.php#a5baa4e96684907e89ee18cb00afb5502">inner_prod_bndry_assembly</a> = IP_bndry_assembly;
<a name="l01563"></a>01563 }
<a name="l01564"></a>01564 
<a name="l01565"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a3a82d87dc184e5ae474696f9e847d7d6">01565</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a3a82d87dc184e5ae474696f9e847d7d6">RBSystem::attach_constraint_assembly</a>(<a class="code" href="namespacelibMesh.php#a18a170af3a9d5eff6f43eb3409d0e296">affine_assembly_fptr</a> constraint_assembly_in)
<a name="l01566"></a>01566 {
<a name="l01567"></a>01567   <a class="code" href="classlibMesh_1_1RBSystem.php#a9c6da671e41886e26c7e88aae82f4358">constraint_assembly</a> = constraint_assembly_in;
<a name="l01568"></a>01568 }
<a name="l01569"></a>01569 
<a name="l01570"></a><a class="code" href="classlibMesh_1_1RBSystem.php#ab7f0b2268a9716189225e0446b519911">01570</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1RBSystem.php#ab7f0b2268a9716189225e0446b519911">RBSystem::get_Q_l</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index)<span class="keyword"> const</span>
<a name="l01571"></a>01571 <span class="keyword"></span>{
<a name="l01572"></a>01572   <span class="keywordflow">if</span>(index &gt;= <a class="code" href="classlibMesh_1_1RBSystem.php#a80b9e06a7c60b3bb2f5870b0ff66a2ca">get_n_outputs</a>())
<a name="l01573"></a>01573   {
<a name="l01574"></a>01574     <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error: We must have index &lt; n_outputs in get_Q_l.&quot;</span>
<a name="l01575"></a>01575                  &lt;&lt; std::endl;
<a name="l01576"></a>01576     libmesh_error();
<a name="l01577"></a>01577   }
<a name="l01578"></a>01578   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a1fa2b8ea817cae06f0d2e0bdbdd8b273">theta_q_l_vector</a>[index].size();
<a name="l01579"></a>01579 }
<a name="l01580"></a>01580 
<a name="l01581"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a0fd951279c9b851ac38443156b4b18bd">01581</a> <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> <a class="code" href="classlibMesh_1_1RBSystem.php#a0fd951279c9b851ac38443156b4b18bd">RBSystem::eval_theta_q_f</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q)
<a name="l01582"></a>01582 {
<a name="l01583"></a>01583   <span class="keywordflow">if</span>(q &gt;= <a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>())
<a name="l01584"></a>01584   {
<a name="l01585"></a>01585     <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error: We must have q &lt; Q_f in eval_theta_q_f.&quot;</span>
<a name="l01586"></a>01586                  &lt;&lt; std::endl;
<a name="l01587"></a>01587     libmesh_error();
<a name="l01588"></a>01588   }
<a name="l01589"></a>01589 
<a name="l01590"></a>01590   <span class="keywordflow">if</span>( q &lt; <a class="code" href="classlibMesh_1_1RBSystem.php#acc90dcf523c055fc294bc71b67dfe876">theta_q_f_vector</a>.size() )
<a name="l01591"></a>01591   {
<a name="l01592"></a>01592     libmesh_assert(<a class="code" href="classlibMesh_1_1RBSystem.php#acc90dcf523c055fc294bc71b67dfe876">theta_q_f_vector</a>[q] != NULL);
<a name="l01593"></a>01593     <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1RBSystem.php#acc90dcf523c055fc294bc71b67dfe876">theta_q_f_vector</a>[q](*theta_data);
<a name="l01594"></a>01594   }
<a name="l01595"></a>01595   <span class="keywordflow">else</span>
<a name="l01596"></a>01596   {
<a name="l01597"></a>01597     <span class="comment">// Find out the RHS EIM system index and the associated function index that corresponds to q</span>
<a name="l01598"></a>01598     std::pair&lt;unsigned int, unsigned int&gt; F_EIM_indices = <a class="code" href="classlibMesh_1_1RBSystem.php#a6f1c9a07eabe425ffbc8ebf2155bb187">get_F_EIM_indices</a>(q);
<a name="l01599"></a>01599 
<a name="l01600"></a>01600     <a class="code" href="classlibMesh_1_1RBEIMSystem.php">RBEIMSystem</a>&amp; eim_system = *<a class="code" href="classlibMesh_1_1RBSystem.php#a1c0266ace79018f4fe863549db995171">F_EIM_systems_vector</a>[F_EIM_indices.first];
<a name="l01601"></a>01601     eim_system.<a class="code" href="classlibMesh_1_1RBBase.php#a04037fe5c23e9d9e5652936888cb8f0f">set_current_parameters</a>(<a class="code" href="classlibMesh_1_1RBBase.php#af3bb451bd612eb5e7e8f0684f4b9cc97">get_current_parameters</a>());
<a name="l01602"></a>01602     eim_system.<a class="code" href="classlibMesh_1_1RBEIMSystem.php#a46cea2966644f4c6dc0c812e1e8e59ed">RB_solve</a>(eim_system.<a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>());
<a name="l01603"></a>01603 
<a name="l01604"></a>01604     <span class="keywordflow">return</span> eim_system.<a class="code" href="classlibMesh_1_1RBSystem.php#a201af52facfa4da38bc636ee2cf41c67">RB_solution</a>(F_EIM_indices.second);
<a name="l01605"></a>01605   }
<a name="l01606"></a>01606 }
<a name="l01607"></a>01607 
<a name="l01608"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a6f1c9a07eabe425ffbc8ebf2155bb187">01608</a> std::pair&lt;unsigned int, unsigned int&gt; <a class="code" href="classlibMesh_1_1RBSystem.php#a6f1c9a07eabe425ffbc8ebf2155bb187">RBSystem::get_F_EIM_indices</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q)
<a name="l01609"></a>01609 {
<a name="l01610"></a>01610   <span class="comment">// Find out which EIM system q refers to</span>
<a name="l01611"></a>01611   <span class="keywordtype">int</span> function_index = q - <a class="code" href="classlibMesh_1_1RBSystem.php#acc90dcf523c055fc294bc71b67dfe876">theta_q_f_vector</a>.size();
<a name="l01612"></a>01612   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> system_index = 0;
<a name="l01613"></a>01613 
<a name="l01614"></a>01614   <span class="keywordflow">if</span>( function_index != 0)
<a name="l01615"></a>01615   {
<a name="l01616"></a>01616     <span class="keywordflow">for</span>(system_index = 0; system_index&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#a1c0266ace79018f4fe863549db995171">F_EIM_systems_vector</a>.size(); system_index++)
<a name="l01617"></a>01617     {
<a name="l01618"></a>01618       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> increment = <a class="code" href="classlibMesh_1_1RBSystem.php#a1c0266ace79018f4fe863549db995171">F_EIM_systems_vector</a>[system_index]-&gt;get_n_affine_functions();
<a name="l01619"></a>01619       <span class="keywordflow">if</span>( (static_cast&lt;int&gt;(function_index - increment)) &lt; 0)
<a name="l01620"></a>01620         <span class="keywordflow">break</span>;
<a name="l01621"></a>01621     
<a name="l01622"></a>01622       function_index -= increment;
<a name="l01623"></a>01623     }
<a name="l01624"></a>01624   }
<a name="l01625"></a>01625 
<a name="l01626"></a>01626   std::pair&lt;unsigned int, unsigned int&gt; EIM_indices(system_index, function_index);
<a name="l01627"></a>01627   <span class="keywordflow">return</span> EIM_indices;
<a name="l01628"></a>01628 }
<a name="l01629"></a>01629 
<a name="l01630"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a3ab4b896903320a2b313f73efc2aaad1">01630</a> <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> <a class="code" href="classlibMesh_1_1RBSystem.php#a3ab4b896903320a2b313f73efc2aaad1">RBSystem::eval_theta_q_l</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> output_index, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_l)
<a name="l01631"></a>01631 {
<a name="l01632"></a>01632   <span class="keywordflow">if</span>( (output_index &gt;= <a class="code" href="classlibMesh_1_1RBSystem.php#a80b9e06a7c60b3bb2f5870b0ff66a2ca">get_n_outputs</a>()) || (q_l &gt;= <a class="code" href="classlibMesh_1_1RBSystem.php#ab7f0b2268a9716189225e0446b519911">get_Q_l</a>(output_index)) )
<a name="l01633"></a>01633   {
<a name="l01634"></a>01634     <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error: We must have output_index &lt; n_outputs and &quot;</span>
<a name="l01635"></a>01635                  &lt;&lt; <span class="stringliteral">&quot;q_l &lt; get_Q_l(output_index) in eval_theta_q_l.&quot;</span>
<a name="l01636"></a>01636                  &lt;&lt; std::endl;
<a name="l01637"></a>01637     libmesh_error();
<a name="l01638"></a>01638   }
<a name="l01639"></a>01639 
<a name="l01640"></a>01640   libmesh_assert(<a class="code" href="classlibMesh_1_1RBSystem.php#a1fa2b8ea817cae06f0d2e0bdbdd8b273">theta_q_l_vector</a>[output_index][q_l] != NULL);
<a name="l01641"></a>01641    
<a name="l01642"></a>01642   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a1fa2b8ea817cae06f0d2e0bdbdd8b273">theta_q_l_vector</a>[output_index][q_l](*theta_data);
<a name="l01643"></a>01643 }
<a name="l01644"></a>01644 
<a name="l01645"></a><a class="code" href="classlibMesh_1_1RBSystem.php#af6e478cdf9c08312cdf7ca6a53349922">01645</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#af6e478cdf9c08312cdf7ca6a53349922">RBSystem::load_basis_function</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)
<a name="l01646"></a>01646 {
<a name="l01647"></a>01647   START_LOG(<span class="stringliteral">&quot;load_basis_function()&quot;</span>, <span class="stringliteral">&quot;RBSystem&quot;</span>);
<a name="l01648"></a>01648 
<a name="l01649"></a>01649   <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBBase.php#a11c4b80a15c0e9ea1d822f5e04545059">initialize_calN_dependent_data</a>)
<a name="l01650"></a>01650   {
<a name="l01651"></a>01651     <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error: We must initialize the calN dependent &quot;</span>
<a name="l01652"></a>01652                  &lt;&lt; <span class="stringliteral">&quot;data structures in order to load basis function.&quot;</span>
<a name="l01653"></a>01653                  &lt;&lt; std::endl;
<a name="l01654"></a>01654     libmesh_error();
<a name="l01655"></a>01655   }
<a name="l01656"></a>01656 
<a name="l01657"></a>01657   libmesh_assert(i &lt; <a class="code" href="classlibMesh_1_1RBSystem.php#abfe6d67ed23243d225f12747f355f105">basis_functions</a>.size());
<a name="l01658"></a>01658 
<a name="l01659"></a>01659   *<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a> = *<a class="code" href="classlibMesh_1_1RBSystem.php#abfe6d67ed23243d225f12747f355f105">basis_functions</a>[i];
<a name="l01660"></a>01660 
<a name="l01661"></a>01661   this-&gt;<a class="code" href="classlibMesh_1_1System.php#ab9d81ac9c1787c43fb87cf13d37741ee">update</a>();
<a name="l01662"></a>01662 
<a name="l01663"></a>01663   STOP_LOG(<span class="stringliteral">&quot;load_basis_function()&quot;</span>, <span class="stringliteral">&quot;RBSystem&quot;</span>);
<a name="l01664"></a>01664 }
<a name="l01665"></a>01665 
<a name="l01666"></a><a class="code" href="classlibMesh_1_1RBSystem.php#ada44f7c1f672088d8ef2b6b8abc35cd5">01666</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#ada44f7c1f672088d8ef2b6b8abc35cd5">RBSystem::enrich_RB_space</a>()
<a name="l01667"></a>01667 {
<a name="l01668"></a>01668   START_LOG(<span class="stringliteral">&quot;enrich_RB_space()&quot;</span>, <span class="stringliteral">&quot;RBSystem&quot;</span>);
<a name="l01669"></a>01669 
<a name="l01670"></a>01670   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>* new_bf = <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;::build</a>().release();
<a name="l01671"></a>01671   new_bf-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#aba2b1e60a94162764c07732626a8231b">init</a> (this-&gt;<a class="code" href="classlibMesh_1_1System.php#a90dbb901f00c14ff18399f4afabcebe5">n_dofs</a>(), this-&gt;<a class="code" href="classlibMesh_1_1System.php#ae3aeb82e65b06789823d41da3c5df7a2">n_local_dofs</a>(), <span class="keyword">false</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">libMeshEnums::PARALLEL</a>);
<a name="l01672"></a>01672   *new_bf = *<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>;
<a name="l01673"></a>01673 
<a name="l01674"></a>01674   <span class="comment">// compute orthogonalization</span>
<a name="l01675"></a>01675   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt; NumericVector&lt;Number&gt;</a> &gt; proj_index = <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;::build</a>();
<a name="l01676"></a>01676   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt; NumericVector&lt;Number&gt;</a> &gt; proj_sum   = <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;::build</a>();
<a name="l01677"></a>01677   proj_index-&gt;init (this-&gt;<a class="code" href="classlibMesh_1_1System.php#a90dbb901f00c14ff18399f4afabcebe5">n_dofs</a>(), this-&gt;<a class="code" href="classlibMesh_1_1System.php#ae3aeb82e65b06789823d41da3c5df7a2">n_local_dofs</a>(), <span class="keyword">false</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">libMeshEnums::PARALLEL</a>);
<a name="l01678"></a>01678   proj_sum-&gt;init (this-&gt;<a class="code" href="classlibMesh_1_1System.php#a90dbb901f00c14ff18399f4afabcebe5">n_dofs</a>(), this-&gt;<a class="code" href="classlibMesh_1_1System.php#ae3aeb82e65b06789823d41da3c5df7a2">n_local_dofs</a>(), <span class="keyword">false</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">libMeshEnums::PARALLEL</a>);
<a name="l01679"></a>01679 
<a name="l01680"></a>01680   <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a>)
<a name="l01681"></a>01681     <a class="code" href="classlibMesh_1_1RBSystem.php#a2bde84b5899642d6bb6ba2f6ac4a51f9">assemble_inner_product_matrix</a>(<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>);
<a name="l01682"></a>01682 
<a name="l01683"></a>01683   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index=0; index&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#abfe6d67ed23243d225f12747f355f105">basis_functions</a>.size(); index++)
<a name="l01684"></a>01684   {
<a name="l01685"></a>01685     <span class="comment">// invoke copy constructor for NumericVector</span>
<a name="l01686"></a>01686     *proj_index = *<a class="code" href="classlibMesh_1_1RBSystem.php#abfe6d67ed23243d225f12747f355f105">basis_functions</a>[index];
<a name="l01687"></a>01687     <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a>)
<a name="l01688"></a>01688     {
<a name="l01689"></a>01689       <a class="code" href="classlibMesh_1_1RBSystem.php#a330478ef4e1a158dc7b6f08530e10ff3">inner_product_matrix</a>-&gt;vector_mult(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>,*proj_index);
<a name="l01690"></a>01690     }
<a name="l01691"></a>01691     <span class="keywordflow">else</span>
<a name="l01692"></a>01692     {
<a name="l01693"></a>01693       <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#adaccc5857f1a5d5ca264ded0b8bfb986">vector_mult</a>(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>,*proj_index);
<a name="l01694"></a>01694     }
<a name="l01695"></a>01695     <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> scalar = <a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>-&gt;dot(*new_bf);
<a name="l01696"></a>01696     proj_sum-&gt;add( scalar, *proj_index);
<a name="l01697"></a>01697   }
<a name="l01698"></a>01698   new_bf-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#aaf343defd46de8557801dc56a2884506">add</a>(-1.,*proj_sum);
<a name="l01699"></a>01699 
<a name="l01700"></a>01700   <span class="comment">// Normalize new_bf</span>
<a name="l01701"></a>01701   <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a>)
<a name="l01702"></a>01702   {
<a name="l01703"></a>01703     <a class="code" href="classlibMesh_1_1RBSystem.php#a330478ef4e1a158dc7b6f08530e10ff3">inner_product_matrix</a>-&gt;vector_mult(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>,*new_bf);
<a name="l01704"></a>01704   }
<a name="l01705"></a>01705   <span class="keywordflow">else</span>
<a name="l01706"></a>01706   {
<a name="l01707"></a>01707     <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#adaccc5857f1a5d5ca264ded0b8bfb986">vector_mult</a>(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>,*new_bf);
<a name="l01708"></a>01708   }
<a name="l01709"></a>01709   <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> new_bf_norm = std::sqrt( <a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>-&gt;dot(*new_bf) );
<a name="l01710"></a>01710   new_bf-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a7efb30d08bd1bb55a91f66782238d648">scale</a>(1./new_bf_norm);
<a name="l01711"></a>01711 
<a name="l01712"></a>01712   <span class="comment">// load the new basis function into the basis_functions vector.</span>
<a name="l01713"></a>01713   <a class="code" href="classlibMesh_1_1RBSystem.php#abfe6d67ed23243d225f12747f355f105">basis_functions</a>.push_back( new_bf );
<a name="l01714"></a>01714 
<a name="l01715"></a>01715   STOP_LOG(<span class="stringliteral">&quot;enrich_RB_space()&quot;</span>, <span class="stringliteral">&quot;RBSystem&quot;</span>);
<a name="l01716"></a>01716 }
<a name="l01717"></a>01717 
<a name="l01718"></a><a class="code" href="classlibMesh_1_1RBSystem.php#af539556a1dac63314567b39e46fa9a08">01718</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#af539556a1dac63314567b39e46fa9a08">RBSystem::update_system</a>()
<a name="l01719"></a>01719 {
<a name="l01720"></a>01720   <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Updating RB matrices&quot;</span> &lt;&lt; std::endl;
<a name="l01721"></a>01721   <a class="code" href="classlibMesh_1_1RBSystem.php#a22351bccb17903c68cfd546412d04f3c">update_RB_system_matrices</a>();
<a name="l01722"></a>01722 
<a name="l01723"></a>01723   <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Updating RB residual terms&quot;</span> &lt;&lt; std::endl;
<a name="l01724"></a>01724 
<a name="l01725"></a>01725   <span class="comment">// Note: the solves in this function employ a single system matrix and multiple</span>
<a name="l01726"></a>01726   <span class="comment">// right-hand sides, so we may get better performance using a different</span>
<a name="l01727"></a>01727   <span class="comment">// preconditioner, or even a direct solver.</span>
<a name="l01728"></a>01728   std::pair&lt;std::string,std::string&gt; orig_solver =
<a name="l01729"></a>01729     this-&gt;<a class="code" href="classlibMesh_1_1RBBase.php#a7fd20c081ea2d46f007c1454a553198a">set_alternative_solver</a>(this-&gt;<a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a7cc68891fa9f44ded49b9b84c057cb32">linear_solver</a>);
<a name="l01730"></a>01730 
<a name="l01731"></a>01731   <a class="code" href="classlibMesh_1_1RBSystem.php#a07341a81eabf77b919f6835638228946">update_residual_terms</a>();
<a name="l01732"></a>01732 
<a name="l01733"></a>01733   <span class="comment">// Change the preconditioner, Krylov solver back to their original</span>
<a name="l01734"></a>01734   <span class="comment">// value.  Note: does nothing if RBBase::alternative_solver ==</span>
<a name="l01735"></a>01735   <span class="comment">// &quot;unchanged&quot;.</span>
<a name="l01736"></a>01736   this-&gt;<a class="code" href="classlibMesh_1_1RBBase.php#a9f236decb17000238d3e1937bf547402">reset_alternative_solver</a>(this-&gt;<a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a7cc68891fa9f44ded49b9b84c057cb32">linear_solver</a>, orig_solver);
<a name="l01737"></a>01737 }
<a name="l01738"></a>01738 
<a name="l01739"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a6cff791ce311e33e9e3f5a529de9c13f">01739</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a6cff791ce311e33e9e3f5a529de9c13f">RBSystem::recompute_all_residual_terms</a>()
<a name="l01740"></a>01740 {
<a name="l01741"></a>01741   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> saved_delta_N = <a class="code" href="classlibMesh_1_1RBSystem.php#a36ba489bd3158bbff48a5607e1d21d30">delta_N</a>;
<a name="l01742"></a>01742   <a class="code" href="classlibMesh_1_1RBSystem.php#a36ba489bd3158bbff48a5607e1d21d30">delta_N</a> = <a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>();
<a name="l01743"></a>01743 
<a name="l01744"></a>01744   <span class="comment">// Use alternative solver for residual terms solves</span>
<a name="l01745"></a>01745   std::pair&lt;std::string,std::string&gt; orig_solver =
<a name="l01746"></a>01746     this-&gt;<a class="code" href="classlibMesh_1_1RBBase.php#a7fd20c081ea2d46f007c1454a553198a">set_alternative_solver</a>(this-&gt;<a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a7cc68891fa9f44ded49b9b84c057cb32">linear_solver</a>);
<a name="l01747"></a>01747   
<a name="l01748"></a>01748   <a class="code" href="classlibMesh_1_1RBSystem.php#a07341a81eabf77b919f6835638228946">update_residual_terms</a>(<span class="comment">/*compute_inner_products=*/</span><span class="keyword">false</span>);
<a name="l01749"></a>01749 
<a name="l01750"></a>01750   <span class="comment">// Return to original solver</span>
<a name="l01751"></a>01751   this-&gt;<a class="code" href="classlibMesh_1_1RBBase.php#a9f236decb17000238d3e1937bf547402">reset_alternative_solver</a>(this-&gt;<a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a7cc68891fa9f44ded49b9b84c057cb32">linear_solver</a>, orig_solver);
<a name="l01752"></a>01752   
<a name="l01753"></a>01753   <a class="code" href="classlibMesh_1_1RBSystem.php#a36ba489bd3158bbff48a5607e1d21d30">delta_N</a> = saved_delta_N;
<a name="l01754"></a>01754 }
<a name="l01755"></a>01755 
<a name="l01756"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a798528f51e8a431936d4262778218067">01756</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1RBSystem.php#a798528f51e8a431936d4262778218067">RBSystem::compute_max_error_bound</a>()
<a name="l01757"></a>01757 {
<a name="l01758"></a>01758   START_LOG(<span class="stringliteral">&quot;compute_max_error_bound()&quot;</span>, <span class="stringliteral">&quot;RBSystem&quot;</span>);
<a name="l01759"></a>01759 
<a name="l01760"></a>01760   <a class="code" href="classlibMesh_1_1RBSystem.php#a406e42df7eb0a8eda5b95b67ba5840fb">training_error_bounds</a>.resize(this-&gt;<a class="code" href="classlibMesh_1_1RBBase.php#a9695753c1fd434bccef96e258c6d1a40">get_local_n_training_samples</a>());
<a name="l01761"></a>01761 
<a name="l01762"></a>01762   <span class="comment">// keep track of the maximum error</span>
<a name="l01763"></a>01763   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> max_err_index = 0;
<a name="l01764"></a>01764   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> max_err = 0.;
<a name="l01765"></a>01765 
<a name="l01766"></a>01766   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> first_index = <a class="code" href="classlibMesh_1_1RBBase.php#a12552cd94e8487531fc5b7d7d461fb84">get_first_local_training_index</a>();
<a name="l01767"></a>01767   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1RBBase.php#a9695753c1fd434bccef96e258c6d1a40">get_local_n_training_samples</a>(); i++)
<a name="l01768"></a>01768   {
<a name="l01769"></a>01769     <span class="comment">// Load training parameter i, this is only loaded</span>
<a name="l01770"></a>01770     <span class="comment">// locally since the RB solves are local.</span>
<a name="l01771"></a>01771     <a class="code" href="classlibMesh_1_1RBBase.php#a04037fe5c23e9d9e5652936888cb8f0f">set_current_parameters</a>( <a class="code" href="classlibMesh_1_1RBBase.php#a4e6e0ae8de711c3b46b26c914a7c2507">get_training_parameter</a>(first_index+i) );
<a name="l01772"></a>01772 
<a name="l01773"></a>01773     <a class="code" href="classlibMesh_1_1RBSystem.php#a406e42df7eb0a8eda5b95b67ba5840fb">training_error_bounds</a>[i] = <a class="code" href="classlibMesh_1_1RBSystem.php#ade32dc013fdad1eca4b1e03839651928">get_RB_error_bound</a>();
<a name="l01774"></a>01774 <span class="comment">//     libMesh::out &lt;&lt; &quot;Error bound at training index &quot; &lt;&lt; first_index+i &lt;&lt; &quot; is &quot;</span>
<a name="l01775"></a>01775 <span class="comment">//                  &lt;&lt; training_error_bounds[i] &lt;&lt; std::endl;</span>
<a name="l01776"></a>01776 
<a name="l01777"></a>01777     <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBSystem.php#a406e42df7eb0a8eda5b95b67ba5840fb">training_error_bounds</a>[i] &gt; max_err)
<a name="l01778"></a>01778     {
<a name="l01779"></a>01779       max_err_index = i;
<a name="l01780"></a>01780       max_err = <a class="code" href="classlibMesh_1_1RBSystem.php#a406e42df7eb0a8eda5b95b67ba5840fb">training_error_bounds</a>[i];
<a name="l01781"></a>01781     }
<a name="l01782"></a>01782   }
<a name="l01783"></a>01783 
<a name="l01784"></a>01784   std::pair&lt;unsigned int,Real&gt; error_pair(first_index+max_err_index, max_err);
<a name="l01785"></a>01785   <a class="code" href="classlibMesh_1_1RBBase.php#a3f96fa0d87fd3f4bc00af8b403650cb3">get_global_max_error_pair</a>(error_pair);
<a name="l01786"></a>01786 
<a name="l01787"></a>01787   <span class="comment">// Now broadcast the parameter that produced the maximum error</span>
<a name="l01788"></a>01788   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> root_id=0;
<a name="l01789"></a>01789   <span class="keywordflow">if</span>( (<a class="code" href="classlibMesh_1_1RBBase.php#a12552cd94e8487531fc5b7d7d461fb84">get_first_local_training_index</a>() &lt;= error_pair.first) &amp;&amp;
<a name="l01790"></a>01790       (error_pair.first &lt; <a class="code" href="classlibMesh_1_1RBBase.php#ab525b1169126b05cbbc6d0b435342eb3">get_last_local_training_index</a>()) )
<a name="l01791"></a>01791   {
<a name="l01792"></a>01792     <a class="code" href="classlibMesh_1_1RBBase.php#a04037fe5c23e9d9e5652936888cb8f0f">set_current_parameters</a>( <a class="code" href="classlibMesh_1_1RBBase.php#a4e6e0ae8de711c3b46b26c914a7c2507">get_training_parameter</a>(error_pair.first) );
<a name="l01793"></a>01793     root_id = <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>();
<a name="l01794"></a>01794   }
<a name="l01795"></a>01795 
<a name="l01796"></a>01796   <a class="code" href="namespacelibMesh_1_1Parallel.php#a32ab26117222089e6540e66b05c06b1b">Parallel::sum</a>(root_id); <span class="comment">// root_id is only non-zero on one processor</span>
<a name="l01797"></a>01797   <a class="code" href="classlibMesh_1_1RBBase.php#a1efd92f0f4a8d2c0e5cec5747dd933a4">broadcast_current_parameters</a>(root_id);
<a name="l01798"></a>01798 
<a name="l01799"></a>01799   STOP_LOG(<span class="stringliteral">&quot;compute_max_error_bound()&quot;</span>, <span class="stringliteral">&quot;RBSystem&quot;</span>);
<a name="l01800"></a>01800 
<a name="l01801"></a>01801   <span class="keywordflow">return</span> error_pair.second;
<a name="l01802"></a>01802 }
<a name="l01803"></a>01803 
<a name="l01804"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a572b94b57df61e1670254e91233e5c8a">01804</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1RBSystem.php#a572b94b57df61e1670254e91233e5c8a">RBSystem::get_SCM_lower_bound</a>()
<a name="l01805"></a>01805 {
<a name="l01806"></a>01806 <span class="preprocessor">#if defined(LIBMESH_HAVE_SLEPC) &amp;&amp; (LIBMESH_HAVE_GLPK)</span>
<a name="l01807"></a>01807 <span class="preprocessor"></span>  <span class="comment">// Get the SCM lower bound from eigen_system</span>
<a name="l01808"></a>01808   <a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es = this-&gt;<a class="code" href="classlibMesh_1_1System.php#ac5ca6b1f3adcfac56982982e90dc905b">get_equation_systems</a>();
<a name="l01809"></a>01809   <a class="code" href="classlibMesh_1_1RBSCMSystem.php">RBSCMSystem</a>&amp; eigen_system = es.<a class="code" href="classlibMesh_1_1EquationSystems.php#a5dac23f839af25ce7dbf1fe9a6d4b67a">get_system</a>&lt;<a class="code" href="classlibMesh_1_1RBSCMSystem.php">RBSCMSystem</a>&gt;(<a class="code" href="classlibMesh_1_1RBSystem.php#ab53684df668b4dbad08d68fd6be1fd37">eigen_system_name</a>);
<a name="l01810"></a>01810 
<a name="l01811"></a>01811   eigen_system.<a class="code" href="classlibMesh_1_1RBBase.php#a04037fe5c23e9d9e5652936888cb8f0f">set_current_parameters</a>( this-&gt;<a class="code" href="classlibMesh_1_1RBBase.php#af3bb451bd612eb5e7e8f0684f4b9cc97">get_current_parameters</a>() );
<a name="l01812"></a>01812   <span class="keywordflow">return</span> eigen_system.<a class="code" href="classlibMesh_1_1RBSCMSystem.php#aec9345df172fa49477f94c46d9d991a0">get_SCM_LB</a>();
<a name="l01813"></a>01813 <span class="preprocessor">#else</span>
<a name="l01814"></a>01814 <span class="preprocessor"></span>  <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;SLEPc and GLPK must be installed for SCM functions to work.&quot;</span> &lt;&lt; std::endl;
<a name="l01815"></a>01815   libmesh_error();
<a name="l01816"></a>01816 <span class="preprocessor">#endif // defined(LIBMESH_HAVE_SLEPC) &amp;&amp; (LIBMESH_HAVE_GLPK)</span>
<a name="l01817"></a>01817 <span class="preprocessor"></span>}
<a name="l01818"></a>01818 
<a name="l01819"></a><a class="code" href="classlibMesh_1_1RBSystem.php#af8bc520e41a0833e9a1ac853af41ce27">01819</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1RBSystem.php#af8bc520e41a0833e9a1ac853af41ce27">RBSystem::get_SCM_upper_bound</a>()
<a name="l01820"></a>01820 {
<a name="l01821"></a>01821 <span class="preprocessor">#if defined(LIBMESH_HAVE_SLEPC) &amp;&amp; (LIBMESH_HAVE_GLPK)</span>
<a name="l01822"></a>01822 <span class="preprocessor"></span>  <span class="comment">// Get the SCM lower bound from eigen_system</span>
<a name="l01823"></a>01823   <a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es = this-&gt;<a class="code" href="classlibMesh_1_1System.php#ac5ca6b1f3adcfac56982982e90dc905b">get_equation_systems</a>();
<a name="l01824"></a>01824   <a class="code" href="classlibMesh_1_1RBSCMSystem.php">RBSCMSystem</a>&amp; eigen_system = es.<a class="code" href="classlibMesh_1_1EquationSystems.php#a5dac23f839af25ce7dbf1fe9a6d4b67a">get_system</a>&lt;<a class="code" href="classlibMesh_1_1RBSCMSystem.php">RBSCMSystem</a>&gt;(<a class="code" href="classlibMesh_1_1RBSystem.php#ab53684df668b4dbad08d68fd6be1fd37">eigen_system_name</a>);
<a name="l01825"></a>01825 
<a name="l01826"></a>01826   eigen_system.<a class="code" href="classlibMesh_1_1RBBase.php#a04037fe5c23e9d9e5652936888cb8f0f">set_current_parameters</a>( this-&gt;<a class="code" href="classlibMesh_1_1RBBase.php#af3bb451bd612eb5e7e8f0684f4b9cc97">get_current_parameters</a>() );
<a name="l01827"></a>01827   <span class="keywordflow">return</span> eigen_system.<a class="code" href="classlibMesh_1_1RBSCMSystem.php#ab481b656b3310e857f2a51e3e3fff497">get_SCM_UB</a>();
<a name="l01828"></a>01828 <span class="preprocessor">#else</span>
<a name="l01829"></a>01829 <span class="preprocessor"></span>  <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;SLEPc and GLPK must be installed for SCM functions to work.&quot;</span> &lt;&lt; std::endl;
<a name="l01830"></a>01830   libmesh_error();
<a name="l01831"></a>01831 <span class="preprocessor">#endif // defined(LIBMESH_HAVE_SLEPC) &amp;&amp; (LIBMESH_HAVE_GLPK)</span>
<a name="l01832"></a>01832 <span class="preprocessor"></span>}
<a name="l01833"></a>01833 
<a name="l01834"></a>01834 
<a name="l01835"></a><a class="code" href="classlibMesh_1_1RBSystem.php#af57b8bd010cb9280eb9d295e8a63cffe">01835</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1RBSystem.php#af57b8bd010cb9280eb9d295e8a63cffe">RBSystem::RB_solve</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N)
<a name="l01836"></a>01836 {
<a name="l01837"></a>01837   START_LOG(<span class="stringliteral">&quot;RB_solve()&quot;</span>, <span class="stringliteral">&quot;RBSystem&quot;</span>);
<a name="l01838"></a>01838 
<a name="l01839"></a>01839   <span class="keywordflow">if</span>(N &gt; <a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>())
<a name="l01840"></a>01840   {
<a name="l01841"></a>01841     <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: N cannot be larger than the number &quot;</span>
<a name="l01842"></a>01842                  &lt;&lt; <span class="stringliteral">&quot;of basis functions in RB_solve&quot;</span> &lt;&lt; std::endl;
<a name="l01843"></a>01843     libmesh_error();
<a name="l01844"></a>01844   }
<a name="l01845"></a>01845   <span class="keywordflow">if</span>(N==0)
<a name="l01846"></a>01846   {
<a name="l01847"></a>01847     <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: N must be greater than 0 in RB_solve&quot;</span> &lt;&lt; std::endl;
<a name="l01848"></a>01848     libmesh_error();
<a name="l01849"></a>01849   }
<a name="l01850"></a>01850 
<a name="l01851"></a>01851   <span class="comment">// Resize (and clear) the solution vector</span>
<a name="l01852"></a>01852   <a class="code" href="classlibMesh_1_1RBSystem.php#a201af52facfa4da38bc636ee2cf41c67">RB_solution</a>.<a class="code" href="classlibMesh_1_1DenseVector.php#a08430ae781094632e8272cbb825d4f44">resize</a>(N);
<a name="l01853"></a>01853 
<a name="l01854"></a>01854   <span class="comment">// Assemble the RB system</span>
<a name="l01855"></a>01855   <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Number&gt;</a> RB_system_matrix(N,N);
<a name="l01856"></a>01856   RB_system_matrix.<a class="code" href="classlibMesh_1_1DenseMatrix.php#ab3e7a4e199200d0f5875fd4a5082cb7c">zero</a>();
<a name="l01857"></a>01857 
<a name="l01858"></a>01858   <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Number&gt;</a> RB_A_q_a;
<a name="l01859"></a>01859   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_a=0; q_a&lt;<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>(); q_a++)
<a name="l01860"></a>01860   {
<a name="l01861"></a>01861     <a class="code" href="classlibMesh_1_1RBSystem.php#adadaf9a427ffbace640455436a4d4b26">RB_A_q_vector</a>[q_a].get_principal_submatrix(N, RB_A_q_a);
<a name="l01862"></a>01862 
<a name="l01863"></a>01863     RB_system_matrix.<a class="code" href="classlibMesh_1_1DenseMatrix.php#adf1b1e8773da47d9edaed6f12c6ceb9a">add</a>(<a class="code" href="classlibMesh_1_1RBBase.php#aeeb46ce2b390bf820f954976ee9da7ce">eval_theta_q_a</a>(q_a), RB_A_q_a);
<a name="l01864"></a>01864   }
<a name="l01865"></a>01865 
<a name="l01866"></a>01866   <span class="comment">// Assemble the RB rhs</span>
<a name="l01867"></a>01867   <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> RB_rhs(N);
<a name="l01868"></a>01868   RB_rhs.<a class="code" href="classlibMesh_1_1DenseVector.php#a23868ec54dca234e5893e41a8b510d68">zero</a>();
<a name="l01869"></a>01869 
<a name="l01870"></a>01870   <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> RB_F_q_f;
<a name="l01871"></a>01871   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_f=0; q_f&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>(); q_f++)
<a name="l01872"></a>01872   {
<a name="l01873"></a>01873     <a class="code" href="classlibMesh_1_1RBSystem.php#ac2da8c5c36be49686429e74b4f9def1c">RB_F_q_vector</a>[q_f].get_principal_subvector(N, RB_F_q_f);
<a name="l01874"></a>01874 
<a name="l01875"></a>01875     RB_rhs.<a class="code" href="classlibMesh_1_1DenseVector.php#ac131f04240149a0548e56a17adb7fb3f">add</a>(<a class="code" href="classlibMesh_1_1RBSystem.php#a0fd951279c9b851ac38443156b4b18bd">eval_theta_q_f</a>(q_f), RB_F_q_f);
<a name="l01876"></a>01876   }
<a name="l01877"></a>01877   
<a name="l01878"></a>01878   <span class="comment">// Solve the linear system</span>
<a name="l01879"></a>01879   RB_system_matrix.<a class="code" href="classlibMesh_1_1DenseMatrix.php#a878b9bf0a49000c70acecd55fdcf8d74">lu_solve</a>(RB_rhs, <a class="code" href="classlibMesh_1_1RBSystem.php#a201af52facfa4da38bc636ee2cf41c67">RB_solution</a>);
<a name="l01880"></a>01880 
<a name="l01881"></a>01881   <span class="comment">// Evaluate the dual norm of the residual for RB_solution_vector</span>
<a name="l01882"></a>01882   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> epsilon_N = <a class="code" href="classlibMesh_1_1RBSystem.php#aacdbb059e6ab25ff140d34cdc13ab253">compute_residual_dual_norm</a>(N);
<a name="l01883"></a>01883 
<a name="l01884"></a>01884   <span class="comment">// Get lower bound for coercivity constant</span>
<a name="l01885"></a>01885   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> alpha_LB = <a class="code" href="classlibMesh_1_1RBSystem.php#a572b94b57df61e1670254e91233e5c8a">get_SCM_lower_bound</a>();
<a name="l01886"></a>01886   <span class="comment">// alpha_LB needs to be positive to get a valid error bound</span>
<a name="l01887"></a>01887   libmesh_assert( alpha_LB &gt; 0. );
<a name="l01888"></a>01888 
<a name="l01889"></a>01889   <span class="comment">// Store (absolute) error bound</span>
<a name="l01890"></a>01890   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> abs_error_bound = epsilon_N / <a class="code" href="classlibMesh_1_1RBSystem.php#a763e47c3abb2cafc44d68812042a6f73">residual_scaling_denom</a>(alpha_LB);
<a name="l01891"></a>01891 
<a name="l01892"></a>01892   <span class="comment">// Compute the norm of RB_solution</span>
<a name="l01893"></a>01893   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> RB_solution_norm = <a class="code" href="classlibMesh_1_1RBSystem.php#a201af52facfa4da38bc636ee2cf41c67">RB_solution</a>.<a class="code" href="classlibMesh_1_1DenseVector.php#aba21b1716e029687d91f20e44ac7ae93">l2_norm</a>();
<a name="l01894"></a>01894 
<a name="l01895"></a>01895   <span class="comment">// Now compute the outputs and associated errors</span>
<a name="l01896"></a>01896   <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> RB_output_vector_N;
<a name="l01897"></a>01897   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#a80b9e06a7c60b3bb2f5870b0ff66a2ca">get_n_outputs</a>(); n++)
<a name="l01898"></a>01898   {
<a name="l01899"></a>01899     <a class="code" href="classlibMesh_1_1RBSystem.php#ac099cfc76fb098f528982f9322f5780a">RB_outputs</a>[n] = 0.;
<a name="l01900"></a>01900     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_l=0; q_l&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#ab7f0b2268a9716189225e0446b519911">get_Q_l</a>(n); q_l++)
<a name="l01901"></a>01901     {
<a name="l01902"></a>01902       <a class="code" href="classlibMesh_1_1RBSystem.php#ab868a08069961fcde36a760e0094708a">RB_output_vectors</a>[n][q_l].get_principal_subvector(N, RB_output_vector_N);
<a name="l01903"></a>01903       <a class="code" href="classlibMesh_1_1RBSystem.php#ac099cfc76fb098f528982f9322f5780a">RB_outputs</a>[n] += <a class="code" href="namespacelibMesh.php#adf2cda6212d46ff664adf9f688129825">libmesh_conj</a>(<a class="code" href="classlibMesh_1_1RBSystem.php#a3ab4b896903320a2b313f73efc2aaad1">eval_theta_q_l</a>(n,q_l))*RB_output_vector_N.<a class="code" href="classlibMesh_1_1DenseVector.php#a740926ab2815bb507a1e33b659414be1">dot</a>(<a class="code" href="classlibMesh_1_1RBSystem.php#a201af52facfa4da38bc636ee2cf41c67">RB_solution</a>);
<a name="l01904"></a>01904     }
<a name="l01905"></a>01905 
<a name="l01906"></a>01906     <a class="code" href="classlibMesh_1_1RBSystem.php#aec3ecea1d8b509fe52ecb7a8b7893f27">RB_output_error_bounds</a>[n] = abs_error_bound * <a class="code" href="classlibMesh_1_1RBSystem.php#a6cae03a0338b32c65938db1f805deb3c">eval_output_dual_norm</a>(n);
<a name="l01907"></a>01907   }
<a name="l01908"></a>01908 
<a name="l01909"></a>01909   STOP_LOG(<span class="stringliteral">&quot;RB_solve()&quot;</span>, <span class="stringliteral">&quot;RBSystem&quot;</span>);
<a name="l01910"></a>01910 
<a name="l01911"></a>01911   <span class="keywordflow">return</span> ( <a class="code" href="classlibMesh_1_1RBSystem.php#a56ab5090b2d6e6322742ade2772330e7">return_rel_error_bound</a> ? abs_error_bound/RB_solution_norm : abs_error_bound );
<a name="l01912"></a>01912 }
<a name="l01913"></a>01913 
<a name="l01914"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a763e47c3abb2cafc44d68812042a6f73">01914</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1RBSystem.php#a763e47c3abb2cafc44d68812042a6f73">RBSystem::residual_scaling_denom</a>(<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> alpha_LB)
<a name="l01915"></a>01915 {
<a name="l01916"></a>01916   <span class="comment">// Here we implement the residual scaling for a coercive</span>
<a name="l01917"></a>01917   <span class="comment">// problem.</span>
<a name="l01918"></a>01918   <span class="keywordflow">return</span> std::sqrt(alpha_LB);
<a name="l01919"></a>01919 }
<a name="l01920"></a>01920 
<a name="l01921"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a22351bccb17903c68cfd546412d04f3c">01921</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a22351bccb17903c68cfd546412d04f3c">RBSystem::update_RB_system_matrices</a>()
<a name="l01922"></a>01922 {
<a name="l01923"></a>01923   START_LOG(<span class="stringliteral">&quot;update_RB_system_matrices()&quot;</span>, <span class="stringliteral">&quot;RBSystem&quot;</span>);
<a name="l01924"></a>01924 
<a name="l01925"></a>01925   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> RB_size = <a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>();
<a name="l01926"></a>01926 
<a name="l01927"></a>01927   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt; NumericVector&lt;Number&gt;</a> &gt; temp = <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;::build</a>();
<a name="l01928"></a>01928   temp-&gt;init (this-&gt;<a class="code" href="classlibMesh_1_1System.php#a90dbb901f00c14ff18399f4afabcebe5">n_dofs</a>(), this-&gt;<a class="code" href="classlibMesh_1_1System.php#ae3aeb82e65b06789823d41da3c5df7a2">n_local_dofs</a>(), <span class="keyword">false</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">libMeshEnums::PARALLEL</a>);
<a name="l01929"></a>01929 
<a name="l01930"></a>01930   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_f=0; q_f&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>(); q_f++)
<a name="l01931"></a>01931   {
<a name="l01932"></a>01932     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=(RB_size-<a class="code" href="classlibMesh_1_1RBSystem.php#a36ba489bd3158bbff48a5607e1d21d30">delta_N</a>); i&lt;RB_size; i++)
<a name="l01933"></a>01933     {
<a name="l01934"></a>01934       <a class="code" href="classlibMesh_1_1RBSystem.php#ac2da8c5c36be49686429e74b4f9def1c">RB_F_q_vector</a>[q_f](i) = <a class="code" href="classlibMesh_1_1RBSystem.php#a1b3f04b60e3464d779c140c280e1010e">get_F_q</a>(q_f)-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a1f522c421b32b75ea4dc3de6d1a95000">dot</a>(*<a class="code" href="classlibMesh_1_1RBSystem.php#abfe6d67ed23243d225f12747f355f105">basis_functions</a>[i]);
<a name="l01935"></a>01935     }
<a name="l01936"></a>01936   }
<a name="l01937"></a>01937 
<a name="l01938"></a>01938   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=(RB_size-<a class="code" href="classlibMesh_1_1RBSystem.php#a36ba489bd3158bbff48a5607e1d21d30">delta_N</a>); i&lt;RB_size; i++)
<a name="l01939"></a>01939   {
<a name="l01940"></a>01940     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#a80b9e06a7c60b3bb2f5870b0ff66a2ca">get_n_outputs</a>(); n++)
<a name="l01941"></a>01941       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_l=0; q_l&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#ab7f0b2268a9716189225e0446b519911">get_Q_l</a>(n); q_l++)
<a name="l01942"></a>01942       {
<a name="l01943"></a>01943         <a class="code" href="classlibMesh_1_1RBSystem.php#ab868a08069961fcde36a760e0094708a">RB_output_vectors</a>[n][q_l](i) = <a class="code" href="classlibMesh_1_1RBSystem.php#a956b276ef7de8606c78698fcfa338343">get_output_vector</a>(n,q_l)-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a1f522c421b32b75ea4dc3de6d1a95000">dot</a>(*<a class="code" href="classlibMesh_1_1RBSystem.php#abfe6d67ed23243d225f12747f355f105">basis_functions</a>[i]);
<a name="l01944"></a>01944       }
<a name="l01945"></a>01945 
<a name="l01946"></a>01946     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;RB_size; j++)
<a name="l01947"></a>01947     {
<a name="l01948"></a>01948       <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> value = 0.;
<a name="l01949"></a>01949       
<a name="l01950"></a>01950       <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBSystem.php#a52ba5c957ff8b7f85ae16707df632b67">compute_RB_inner_product</a>)
<a name="l01951"></a>01951       {
<a name="l01952"></a>01952         <span class="comment">// Compute reduced inner_product_matrix</span>
<a name="l01953"></a>01953         temp-&gt;zero();
<a name="l01954"></a>01954         <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a>)
<a name="l01955"></a>01955         {
<a name="l01956"></a>01956           <a class="code" href="classlibMesh_1_1RBSystem.php#a330478ef4e1a158dc7b6f08530e10ff3">inner_product_matrix</a>-&gt;vector_mult(*temp, *<a class="code" href="classlibMesh_1_1RBSystem.php#abfe6d67ed23243d225f12747f355f105">basis_functions</a>[j]);
<a name="l01957"></a>01957         }
<a name="l01958"></a>01958         <span class="keywordflow">else</span>
<a name="l01959"></a>01959         {
<a name="l01960"></a>01960           <a class="code" href="classlibMesh_1_1RBSystem.php#a2bde84b5899642d6bb6ba2f6ac4a51f9">assemble_inner_product_matrix</a>(<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>);
<a name="l01961"></a>01961           <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#adaccc5857f1a5d5ca264ded0b8bfb986">vector_mult</a>(*temp, *<a class="code" href="classlibMesh_1_1RBSystem.php#abfe6d67ed23243d225f12747f355f105">basis_functions</a>[j]);
<a name="l01962"></a>01962         }
<a name="l01963"></a>01963 
<a name="l01964"></a>01964         value = <a class="code" href="classlibMesh_1_1RBSystem.php#abfe6d67ed23243d225f12747f355f105">basis_functions</a>[i]-&gt;dot(*temp);
<a name="l01965"></a>01965         <a class="code" href="classlibMesh_1_1RBSystem.php#a5aeb48dc4ed2a429e89bdeffdd1f1564">RB_inner_product_matrix</a>(i,j) = value;
<a name="l01966"></a>01966         <span class="keywordflow">if</span>(i!=j)
<a name="l01967"></a>01967         {
<a name="l01968"></a>01968           <span class="comment">// The inner product matrix is assumed</span>
<a name="l01969"></a>01969           <span class="comment">// to be symmetric</span>
<a name="l01970"></a>01970           <a class="code" href="classlibMesh_1_1RBSystem.php#a5aeb48dc4ed2a429e89bdeffdd1f1564">RB_inner_product_matrix</a>(j,i) = value;
<a name="l01971"></a>01971         }
<a name="l01972"></a>01972       }
<a name="l01973"></a>01973 
<a name="l01974"></a>01974       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_a=0; q_a&lt;<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>(); q_a++)
<a name="l01975"></a>01975       {
<a name="l01976"></a>01976         <span class="comment">// Compute reduced A_q matrix</span>
<a name="l01977"></a>01977         temp-&gt;zero();
<a name="l01978"></a>01978         <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a>)
<a name="l01979"></a>01979         {
<a name="l01980"></a>01980           <a class="code" href="classlibMesh_1_1RBSystem.php#aef1516ea2eb482f28578cab98bd53097">get_A_q</a>(q_a)-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#adaccc5857f1a5d5ca264ded0b8bfb986">vector_mult</a>(*temp, *<a class="code" href="classlibMesh_1_1RBSystem.php#abfe6d67ed23243d225f12747f355f105">basis_functions</a>[j]);
<a name="l01981"></a>01981         }
<a name="l01982"></a>01982         <span class="keywordflow">else</span>
<a name="l01983"></a>01983         {
<a name="l01984"></a>01984           <a class="code" href="classlibMesh_1_1RBSystem.php#af8d2c48f29c4102d4c9378258b90e7d9">assemble_Aq_matrix</a>(q_a,<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>);
<a name="l01985"></a>01985           <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#adaccc5857f1a5d5ca264ded0b8bfb986">vector_mult</a>(*temp, *<a class="code" href="classlibMesh_1_1RBSystem.php#abfe6d67ed23243d225f12747f355f105">basis_functions</a>[j]);
<a name="l01986"></a>01986         }
<a name="l01987"></a>01987 
<a name="l01988"></a>01988         value = (*temp).dot(*<a class="code" href="classlibMesh_1_1RBSystem.php#abfe6d67ed23243d225f12747f355f105">basis_functions</a>[i]);
<a name="l01989"></a>01989         <a class="code" href="classlibMesh_1_1RBSystem.php#adadaf9a427ffbace640455436a4d4b26">RB_A_q_vector</a>[q_a](i,j) = value;
<a name="l01990"></a>01990 
<a name="l01991"></a>01991         <span class="keywordflow">if</span>(i!=j)
<a name="l01992"></a>01992         {
<a name="l01993"></a>01993           temp-&gt;zero();
<a name="l01994"></a>01994           <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a>)
<a name="l01995"></a>01995           {
<a name="l01996"></a>01996             <a class="code" href="classlibMesh_1_1RBSystem.php#aef1516ea2eb482f28578cab98bd53097">get_A_q</a>(q_a)-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#adaccc5857f1a5d5ca264ded0b8bfb986">vector_mult</a>(*temp, *<a class="code" href="classlibMesh_1_1RBSystem.php#abfe6d67ed23243d225f12747f355f105">basis_functions</a>[i]);
<a name="l01997"></a>01997           }
<a name="l01998"></a>01998           <span class="keywordflow">else</span>
<a name="l01999"></a>01999           {
<a name="l02000"></a>02000             <span class="comment">// matrix should still hold affine matrix q_a</span>
<a name="l02001"></a>02001             <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#adaccc5857f1a5d5ca264ded0b8bfb986">vector_mult</a>(*temp, *<a class="code" href="classlibMesh_1_1RBSystem.php#abfe6d67ed23243d225f12747f355f105">basis_functions</a>[i]);
<a name="l02002"></a>02002           }
<a name="l02003"></a>02003 
<a name="l02004"></a>02004           value = (*temp).dot(*<a class="code" href="classlibMesh_1_1RBSystem.php#abfe6d67ed23243d225f12747f355f105">basis_functions</a>[j]);
<a name="l02005"></a>02005           <a class="code" href="classlibMesh_1_1RBSystem.php#adadaf9a427ffbace640455436a4d4b26">RB_A_q_vector</a>[q_a](j,i) = value;
<a name="l02006"></a>02006         }
<a name="l02007"></a>02007       }
<a name="l02008"></a>02008     }
<a name="l02009"></a>02009   }
<a name="l02010"></a>02010 
<a name="l02011"></a>02011   STOP_LOG(<span class="stringliteral">&quot;update_RB_system_matrices()&quot;</span>, <span class="stringliteral">&quot;RBSystem&quot;</span>);
<a name="l02012"></a>02012 }
<a name="l02013"></a>02013 
<a name="l02014"></a>02014 
<a name="l02015"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a07341a81eabf77b919f6835638228946">02015</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a07341a81eabf77b919f6835638228946">RBSystem::update_residual_terms</a>(<span class="keywordtype">bool</span> compute_inner_products)
<a name="l02016"></a>02016 {
<a name="l02017"></a>02017   START_LOG(<span class="stringliteral">&quot;update_residual_terms()&quot;</span>, <span class="stringliteral">&quot;RBSystem&quot;</span>);
<a name="l02018"></a>02018 
<a name="l02019"></a>02019   <span class="comment">// First we need to compute the representors of</span>
<a name="l02020"></a>02020   <span class="comment">// each basis function using inner_product_matrix</span>
<a name="l02021"></a>02021 
<a name="l02022"></a>02022   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> RB_size = <a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>();
<a name="l02023"></a>02023 
<a name="l02024"></a>02024   <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a>)
<a name="l02025"></a>02025   {
<a name="l02026"></a>02026     <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#a966e0a6479f33c2518937e7d0f54602f">zero</a>();
<a name="l02027"></a>02027     <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#a401beeed965b80425730050a61de5c21">add</a>(1., *<a class="code" href="classlibMesh_1_1RBSystem.php#a330478ef4e1a158dc7b6f08530e10ff3">inner_product_matrix</a>);
<a name="l02028"></a>02028     <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBSystem.php#a28b1348023897cb1517724d6ac30a21d">constrained_problem</a>)
<a name="l02029"></a>02029       <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#a401beeed965b80425730050a61de5c21">add</a>(1., *<a class="code" href="classlibMesh_1_1RBSystem.php#aa7a3439518c1b8a421a79064e819f5c8">constraint_matrix</a>);
<a name="l02030"></a>02030   }
<a name="l02031"></a>02031 
<a name="l02032"></a>02032   <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBSystem.php#a61f47d68b0df487674a9001d13d77c88">reuse_preconditioner</a>)
<a name="l02033"></a>02033   {
<a name="l02034"></a>02034     <span class="comment">// For the first solve, make sure we generate a new preconditioner</span>
<a name="l02035"></a>02035     <a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a7cc68891fa9f44ded49b9b84c057cb32">linear_solver</a>-&gt;same_preconditioner = <span class="keyword">false</span>;
<a name="l02036"></a>02036   }
<a name="l02037"></a>02037 
<a name="l02038"></a>02038   <span class="comment">// We only need to compute the representors for</span>
<a name="l02039"></a>02039   <span class="comment">// the right-hand side once.  Note: this will be called at least</span>
<a name="l02040"></a>02040   <span class="comment">// once even after a restart, in which case F_q_representor[0]</span>
<a name="l02041"></a>02041   <span class="comment">// will already be set.</span>
<a name="l02042"></a>02042   <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBSystem.php#a88a28e5658cc0bf37e3df863a46a9e7b">update_residual_terms_called</a>)
<a name="l02043"></a>02043   {
<a name="l02044"></a>02044     <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a>)
<a name="l02045"></a>02045     {
<a name="l02046"></a>02046       <a class="code" href="classlibMesh_1_1RBSystem.php#a2bde84b5899642d6bb6ba2f6ac4a51f9">assemble_inner_product_matrix</a>(<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>);
<a name="l02047"></a>02047       <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBSystem.php#a28b1348023897cb1517724d6ac30a21d">constrained_problem</a>)
<a name="l02048"></a>02048         <a class="code" href="classlibMesh_1_1RBSystem.php#a4a1243f45ea36fbd2a10ad6956c62deb">add_scaled_matrix_and_vector</a>(1., <a class="code" href="classlibMesh_1_1RBSystem.php#a9c6da671e41886e26c7e88aae82f4358">constraint_assembly</a>, NULL, <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>, NULL);
<a name="l02049"></a>02049     }
<a name="l02050"></a>02050 
<a name="l02051"></a>02051     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_f=0; q_f&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>(); q_f++)
<a name="l02052"></a>02052       {
<a name="l02053"></a>02053         <a class="code" href="classlibMesh_1_1RBSystem.php#acd91cfaa84058427cda2885e4d6d30ce">F_q_representor</a>[q_f] = (<a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;::build</a>().release());
<a name="l02054"></a>02054         <a class="code" href="classlibMesh_1_1RBSystem.php#acd91cfaa84058427cda2885e4d6d30ce">F_q_representor</a>[q_f]-&gt;init (this-&gt;<a class="code" href="classlibMesh_1_1System.php#a90dbb901f00c14ff18399f4afabcebe5">n_dofs</a>(), this-&gt;<a class="code" href="classlibMesh_1_1System.php#ae3aeb82e65b06789823d41da3c5df7a2">n_local_dofs</a>(), <span class="keyword">false</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">libMeshEnums::PARALLEL</a>);
<a name="l02055"></a>02055 
<a name="l02056"></a>02056         <a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a85b3d4a53413e3745e6ecf1c8b96ca65">zero</a>();
<a name="l02057"></a>02057         <a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#aaf343defd46de8557801dc56a2884506">add</a>(1., *<a class="code" href="classlibMesh_1_1RBSystem.php#a1b3f04b60e3464d779c140c280e1010e">get_F_q</a>(q_f));
<a name="l02058"></a>02058         <a class="code" href="classlibMesh_1_1RBSystem.php#a85c25bbd66bed6e4111e44566e91b5ff">zero_dirichlet_dofs_on_rhs</a>();
<a name="l02059"></a>02059 
<a name="l02060"></a>02060         <a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;zero();
<a name="l02061"></a>02061 
<a name="l02062"></a>02062         <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1RBSystem.php#adec856bc209f0533639d76767bd5ebbc">quiet</a>)
<a name="l02063"></a>02063           <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Starting solve q_f=&quot;</span> &lt;&lt; q_f
<a name="l02064"></a>02064                        &lt;&lt; <span class="stringliteral">&quot; in RBSystem::update_residual_terms() at &quot;</span>
<a name="l02065"></a>02065                        &lt;&lt; <a class="code" href="namespacelibMesh_1_1Utility.php#a0e4485920eb5de9a47b6f8760a11361d">Utility::get_timestamp</a>() &lt;&lt; std::endl;
<a name="l02066"></a>02066 
<a name="l02067"></a>02067         <a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#af1de21a76860785bb1992280eb72b0db">solve</a>();
<a name="l02068"></a>02068 
<a name="l02069"></a>02069         <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1RBSystem.php#adec856bc209f0533639d76767bd5ebbc">quiet</a>)
<a name="l02070"></a>02070           {
<a name="l02071"></a>02071             <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Finished solve q_f=&quot;</span> &lt;&lt; q_f
<a name="l02072"></a>02072                          &lt;&lt; <span class="stringliteral">&quot; in RBSystem::update_residual_terms() at &quot;</span>
<a name="l02073"></a>02073                          &lt;&lt; <a class="code" href="namespacelibMesh_1_1Utility.php#a0e4485920eb5de9a47b6f8760a11361d">Utility::get_timestamp</a>() &lt;&lt; std::endl;
<a name="l02074"></a>02074 
<a name="l02075"></a>02075             <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; this-&gt;<a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#af712dbf0e285c5ff4cc346daef05423c">n_linear_iterations</a>()
<a name="l02076"></a>02076                          &lt;&lt; <span class="stringliteral">&quot; iterations, final residual &quot;</span>
<a name="l02077"></a>02077                          &lt;&lt; this-&gt;<a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a86b5e2954d2a2e43014bcda8810239ac">final_linear_residual</a>() &lt;&lt; std::endl;
<a name="l02078"></a>02078           }
<a name="l02079"></a>02079 
<a name="l02080"></a>02080         <span class="comment">// Make sure we didn&#39;t max out the number of iterations</span>
<a name="l02081"></a>02081         <span class="keywordflow">if</span>( (this-&gt;<a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#af712dbf0e285c5ff4cc346daef05423c">n_linear_iterations</a>() &gt;=
<a name="l02082"></a>02082              this-&gt;<a class="code" href="classlibMesh_1_1System.php#ac5ca6b1f3adcfac56982982e90dc905b">get_equation_systems</a>().parameters.get&lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&gt;(<span class="stringliteral">&quot;linear solver maximum iterations&quot;</span>)) &amp;&amp;
<a name="l02083"></a>02083             (this-&gt;final_linear_residual() &gt;
<a name="l02084"></a>02084              this-&gt;<a class="code" href="classlibMesh_1_1System.php#ac5ca6b1f3adcfac56982982e90dc905b">get_equation_systems</a>().<a class="code" href="classlibMesh_1_1EquationSystems.php#a7c02be232f564967ca0804a7824adb53">parameters</a>.<a class="code" href="classlibMesh_1_1Parameters.php#ac7fa2054ee32db2c3979d48bd2103f20">get</a>&lt;<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>&gt;(<span class="stringliteral">&quot;linear solver tolerance&quot;</span>)) )
<a name="l02085"></a>02085           {
<a name="l02086"></a>02086             <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Warning: Linear solver may not have converged! Final linear residual = &quot;</span>
<a name="l02087"></a>02087                          &lt;&lt; this-&gt;<a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a86b5e2954d2a2e43014bcda8810239ac">final_linear_residual</a>() &lt;&lt; <span class="stringliteral">&quot;, number of iterations = &quot;</span>
<a name="l02088"></a>02088                          &lt;&lt; this-&gt;<a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#af712dbf0e285c5ff4cc346daef05423c">n_linear_iterations</a>() &lt;&lt; std::endl &lt;&lt; std::endl;
<a name="l02089"></a>02089             <span class="comment">//         libmesh_error();</span>
<a name="l02090"></a>02090 
<a name="l02091"></a>02091           }
<a name="l02092"></a>02092         *<a class="code" href="classlibMesh_1_1RBSystem.php#acd91cfaa84058427cda2885e4d6d30ce">F_q_representor</a>[q_f] = *<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>;
<a name="l02093"></a>02093 
<a name="l02094"></a>02094         <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBSystem.php#a61f47d68b0df487674a9001d13d77c88">reuse_preconditioner</a>)
<a name="l02095"></a>02095           {
<a name="l02096"></a>02096             <span class="comment">// After we do a solve, tell PETSc we want to reuse the preconditioner</span>
<a name="l02097"></a>02097             <span class="comment">// since the system matrix is not changing.</span>
<a name="l02098"></a>02098             <a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a7cc68891fa9f44ded49b9b84c057cb32">linear_solver</a>-&gt;same_preconditioner = <span class="keyword">true</span>;
<a name="l02099"></a>02099           }
<a name="l02100"></a>02100       }
<a name="l02101"></a>02101 
<a name="l02102"></a>02102     <span class="keywordflow">if</span> (compute_inner_products)
<a name="l02103"></a>02103       {
<a name="l02104"></a>02104         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q=0;
<a name="l02105"></a>02105         <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a> &amp;&amp; <a class="code" href="classlibMesh_1_1RBSystem.php#a28b1348023897cb1517724d6ac30a21d">constrained_problem</a>)
<a name="l02106"></a>02106           <a class="code" href="classlibMesh_1_1RBSystem.php#a2bde84b5899642d6bb6ba2f6ac4a51f9">assemble_inner_product_matrix</a>(<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>);
<a name="l02107"></a>02107 
<a name="l02108"></a>02108         <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_f1=0; q_f1&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>(); q_f1++)
<a name="l02109"></a>02109           {
<a name="l02110"></a>02110             <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a>)
<a name="l02111"></a>02111               {
<a name="l02112"></a>02112                 <a class="code" href="classlibMesh_1_1RBSystem.php#a330478ef4e1a158dc7b6f08530e10ff3">inner_product_matrix</a>-&gt;vector_mult(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>, *<a class="code" href="classlibMesh_1_1RBSystem.php#acd91cfaa84058427cda2885e4d6d30ce">F_q_representor</a>[q_f1]);
<a name="l02113"></a>02113               }
<a name="l02114"></a>02114             <span class="keywordflow">else</span>
<a name="l02115"></a>02115               {
<a name="l02116"></a>02116                 <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#adaccc5857f1a5d5ca264ded0b8bfb986">vector_mult</a>(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>, *<a class="code" href="classlibMesh_1_1RBSystem.php#acd91cfaa84058427cda2885e4d6d30ce">F_q_representor</a>[q_f1]);
<a name="l02117"></a>02117               }
<a name="l02118"></a>02118 
<a name="l02119"></a>02119             <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_f2=q_f1; q_f2&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>(); q_f2++)
<a name="l02120"></a>02120               {
<a name="l02121"></a>02121                 <a class="code" href="classlibMesh_1_1RBSystem.php#a567c86950bb6d2ab2800ac0b14ed3dd2">Fq_representor_norms</a>[q] = <a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>-&gt;dot(*<a class="code" href="classlibMesh_1_1RBSystem.php#acd91cfaa84058427cda2885e4d6d30ce">F_q_representor</a>[q_f2]);
<a name="l02122"></a>02122 
<a name="l02123"></a>02123                 q++;
<a name="l02124"></a>02124               }
<a name="l02125"></a>02125           }
<a name="l02126"></a>02126       } <span class="comment">// end if (compute_inner_products)</span>
<a name="l02127"></a>02127 
<a name="l02128"></a>02128     
<a name="l02129"></a>02129   } <span class="comment">// end if(!update_residual_terms_called)</span>
<a name="l02130"></a>02130 
<a name="l02131"></a>02131 
<a name="l02132"></a>02132   <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a>)
<a name="l02133"></a>02133   {
<a name="l02134"></a>02134     <a class="code" href="classlibMesh_1_1RBSystem.php#a2bde84b5899642d6bb6ba2f6ac4a51f9">assemble_inner_product_matrix</a>(<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>);
<a name="l02135"></a>02135     <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBSystem.php#a28b1348023897cb1517724d6ac30a21d">constrained_problem</a>)
<a name="l02136"></a>02136       <a class="code" href="classlibMesh_1_1RBSystem.php#a4a1243f45ea36fbd2a10ad6956c62deb">add_scaled_matrix_and_vector</a>(1., <a class="code" href="classlibMesh_1_1RBSystem.php#a9c6da671e41886e26c7e88aae82f4358">constraint_assembly</a>, NULL, <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>, NULL);
<a name="l02137"></a>02137   }
<a name="l02138"></a>02138 
<a name="l02139"></a>02139   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_a=0; q_a&lt;<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>(); q_a++)
<a name="l02140"></a>02140   {
<a name="l02141"></a>02141     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=(RB_size-<a class="code" href="classlibMesh_1_1RBSystem.php#a36ba489bd3158bbff48a5607e1d21d30">delta_N</a>); i&lt;RB_size; i++)
<a name="l02142"></a>02142     {
<a name="l02143"></a>02143       <span class="comment">// Initialize the vector in which we&#39;ll store the representor</span>
<a name="l02144"></a>02144       <a class="code" href="classlibMesh_1_1RBSystem.php#a9c8fb2a4cb5b77e59e36bfff438aed01">A_q_representor</a>[q_a][i] = (<a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;::build</a>().release());
<a name="l02145"></a>02145       <a class="code" href="classlibMesh_1_1RBSystem.php#a9c8fb2a4cb5b77e59e36bfff438aed01">A_q_representor</a>[q_a][i]-&gt;init(this-&gt;<a class="code" href="classlibMesh_1_1System.php#a90dbb901f00c14ff18399f4afabcebe5">n_dofs</a>(), this-&gt;<a class="code" href="classlibMesh_1_1System.php#ae3aeb82e65b06789823d41da3c5df7a2">n_local_dofs</a>(), <span class="keyword">false</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">libMeshEnums::PARALLEL</a>);
<a name="l02146"></a>02146 
<a name="l02147"></a>02147       <a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a85b3d4a53413e3745e6ecf1c8b96ca65">zero</a>();
<a name="l02148"></a>02148       <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a>)
<a name="l02149"></a>02149       {
<a name="l02150"></a>02150         <a class="code" href="classlibMesh_1_1RBSystem.php#aef1516ea2eb482f28578cab98bd53097">get_A_q</a>(q_a)-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#adaccc5857f1a5d5ca264ded0b8bfb986">vector_mult</a>(*<a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a>, *<a class="code" href="classlibMesh_1_1RBSystem.php#abfe6d67ed23243d225f12747f355f105">basis_functions</a>[i]);
<a name="l02151"></a>02151       }
<a name="l02152"></a>02152       <span class="keywordflow">else</span>
<a name="l02153"></a>02153       {
<a name="l02154"></a>02154         <a class="code" href="classlibMesh_1_1RBSystem.php#a568b302f96140c76530b9412c1b87b38">assemble_scaled_matvec</a>(1.,
<a name="l02155"></a>02155                                <a class="code" href="classlibMesh_1_1RBSystem.php#a2e5fa41dea513013a95ac9cdc5a61f0c">A_q_intrr_assembly_vector</a>[q_a],
<a name="l02156"></a>02156                                <a class="code" href="classlibMesh_1_1RBSystem.php#af494bdce91a9247fae8014b49ff42296">A_q_bndry_assembly_vector</a>[q_a],
<a name="l02157"></a>02157                                *<a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a>,
<a name="l02158"></a>02158                                *<a class="code" href="classlibMesh_1_1RBSystem.php#abfe6d67ed23243d225f12747f355f105">basis_functions</a>[i]);
<a name="l02159"></a>02159       }
<a name="l02160"></a>02160       <a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a7efb30d08bd1bb55a91f66782238d648">scale</a>(-1.);
<a name="l02161"></a>02161       <a class="code" href="classlibMesh_1_1RBSystem.php#a85c25bbd66bed6e4111e44566e91b5ff">zero_dirichlet_dofs_on_rhs</a>();
<a name="l02162"></a>02162 
<a name="l02163"></a>02163       <a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;zero();
<a name="l02164"></a>02164       <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1RBSystem.php#adec856bc209f0533639d76767bd5ebbc">quiet</a>)
<a name="l02165"></a>02165             {
<a name="l02166"></a>02166         <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Starting solve [q_a][i]=[&quot;</span> &lt;&lt; q_a &lt;&lt;<span class="stringliteral">&quot;][&quot;</span>&lt;&lt; i &lt;&lt; <span class="stringliteral">&quot;] in RBSystem::update_residual_terms() at &quot;</span>
<a name="l02167"></a>02167                      &lt;&lt; <a class="code" href="namespacelibMesh_1_1Utility.php#a0e4485920eb5de9a47b6f8760a11361d">Utility::get_timestamp</a>() &lt;&lt; std::endl;
<a name="l02168"></a>02168             }
<a name="l02169"></a>02169 
<a name="l02170"></a>02170       <a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#af1de21a76860785bb1992280eb72b0db">solve</a>();
<a name="l02171"></a>02171 
<a name="l02172"></a>02172       <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1RBSystem.php#adec856bc209f0533639d76767bd5ebbc">quiet</a>)
<a name="l02173"></a>02173             {
<a name="l02174"></a>02174         <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Finished solve [q_a][i]=[&quot;</span> &lt;&lt; q_a &lt;&lt;<span class="stringliteral">&quot;][&quot;</span>&lt;&lt; i &lt;&lt; <span class="stringliteral">&quot;] in RBSystem::update_residual_terms() at &quot;</span>
<a name="l02175"></a>02175                      &lt;&lt; <a class="code" href="namespacelibMesh_1_1Utility.php#a0e4485920eb5de9a47b6f8760a11361d">Utility::get_timestamp</a>() &lt;&lt; std::endl;
<a name="l02176"></a>02176         <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; this-&gt;<a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#af712dbf0e285c5ff4cc346daef05423c">n_linear_iterations</a>() &lt;&lt; <span class="stringliteral">&quot; iterations, final residual &quot;</span>
<a name="l02177"></a>02177                      &lt;&lt; this-&gt;<a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a86b5e2954d2a2e43014bcda8810239ac">final_linear_residual</a>() &lt;&lt; std::endl;
<a name="l02178"></a>02178             }
<a name="l02179"></a>02179 
<a name="l02180"></a>02180       <span class="comment">// Make sure we didn&#39;t max out the number of iterations</span>
<a name="l02181"></a>02181       <span class="keywordflow">if</span>( (this-&gt;<a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#af712dbf0e285c5ff4cc346daef05423c">n_linear_iterations</a>() &gt;=
<a name="l02182"></a>02182           this-&gt;<a class="code" href="classlibMesh_1_1System.php#ac5ca6b1f3adcfac56982982e90dc905b">get_equation_systems</a>().parameters.get&lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&gt;(<span class="stringliteral">&quot;linear solver maximum iterations&quot;</span>)) &amp;&amp;
<a name="l02183"></a>02183           (this-&gt;final_linear_residual() &gt;
<a name="l02184"></a>02184           this-&gt;<a class="code" href="classlibMesh_1_1System.php#ac5ca6b1f3adcfac56982982e90dc905b">get_equation_systems</a>().<a class="code" href="classlibMesh_1_1EquationSystems.php#a7c02be232f564967ca0804a7824adb53">parameters</a>.<a class="code" href="classlibMesh_1_1Parameters.php#ac7fa2054ee32db2c3979d48bd2103f20">get</a>&lt;<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>&gt;(<span class="stringliteral">&quot;linear solver tolerance&quot;</span>)) )
<a name="l02185"></a>02185       {
<a name="l02186"></a>02186         <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Warning: Linear solver may not have converged! Final linear residual = &quot;</span>
<a name="l02187"></a>02187                      &lt;&lt; this-&gt;<a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a86b5e2954d2a2e43014bcda8810239ac">final_linear_residual</a>() &lt;&lt; <span class="stringliteral">&quot;, number of iterations = &quot;</span>
<a name="l02188"></a>02188                      &lt;&lt; this-&gt;<a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#af712dbf0e285c5ff4cc346daef05423c">n_linear_iterations</a>() &lt;&lt; std::endl &lt;&lt; std::endl;
<a name="l02189"></a>02189 <span class="comment">//         libmesh_error();</span>
<a name="l02190"></a>02190       }
<a name="l02191"></a>02191 
<a name="l02192"></a>02192       <span class="comment">// Store the representor</span>
<a name="l02193"></a>02193       *<a class="code" href="classlibMesh_1_1RBSystem.php#a9c8fb2a4cb5b77e59e36bfff438aed01">A_q_representor</a>[q_a][i] = *<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>;
<a name="l02194"></a>02194 
<a name="l02195"></a>02195 
<a name="l02196"></a>02196       <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBSystem.php#a61f47d68b0df487674a9001d13d77c88">reuse_preconditioner</a>)
<a name="l02197"></a>02197       {
<a name="l02198"></a>02198         <span class="comment">// set this flag again in case we didn&#39;t do any F solves</span>
<a name="l02199"></a>02199         <a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a7cc68891fa9f44ded49b9b84c057cb32">linear_solver</a>-&gt;same_preconditioner = <span class="keyword">true</span>;
<a name="l02200"></a>02200       }
<a name="l02201"></a>02201     }
<a name="l02202"></a>02202   }
<a name="l02203"></a>02203 
<a name="l02204"></a>02204   <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBSystem.php#a61f47d68b0df487674a9001d13d77c88">reuse_preconditioner</a>)
<a name="l02205"></a>02205   {
<a name="l02206"></a>02206     <a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a7cc68891fa9f44ded49b9b84c057cb32">linear_solver</a>-&gt;same_preconditioner = <span class="keyword">false</span>;
<a name="l02207"></a>02207   }
<a name="l02208"></a>02208 
<a name="l02209"></a>02209   <span class="comment">// Now compute and store the inner products (if requested)</span>
<a name="l02210"></a>02210   <span class="keywordflow">if</span> (compute_inner_products)
<a name="l02211"></a>02211     {
<a name="l02212"></a>02212       <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a> &amp;&amp; <a class="code" href="classlibMesh_1_1RBSystem.php#a28b1348023897cb1517724d6ac30a21d">constrained_problem</a>)
<a name="l02213"></a>02213         <a class="code" href="classlibMesh_1_1RBSystem.php#a2bde84b5899642d6bb6ba2f6ac4a51f9">assemble_inner_product_matrix</a>(<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>);
<a name="l02214"></a>02214 
<a name="l02215"></a>02215       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_f=0; q_f&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>(); q_f++)
<a name="l02216"></a>02216         {
<a name="l02217"></a>02217           <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a>)
<a name="l02218"></a>02218             {
<a name="l02219"></a>02219               <a class="code" href="classlibMesh_1_1RBSystem.php#a330478ef4e1a158dc7b6f08530e10ff3">inner_product_matrix</a>-&gt;vector_mult(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>,*<a class="code" href="classlibMesh_1_1RBSystem.php#acd91cfaa84058427cda2885e4d6d30ce">F_q_representor</a>[q_f]);
<a name="l02220"></a>02220             }
<a name="l02221"></a>02221           <span class="keywordflow">else</span>
<a name="l02222"></a>02222             {
<a name="l02223"></a>02223               <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#adaccc5857f1a5d5ca264ded0b8bfb986">vector_mult</a>(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>,*<a class="code" href="classlibMesh_1_1RBSystem.php#acd91cfaa84058427cda2885e4d6d30ce">F_q_representor</a>[q_f]);
<a name="l02224"></a>02224             }
<a name="l02225"></a>02225 
<a name="l02226"></a>02226           <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_a=0; q_a&lt;<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>(); q_a++)
<a name="l02227"></a>02227             {
<a name="l02228"></a>02228               <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=(RB_size-<a class="code" href="classlibMesh_1_1RBSystem.php#a36ba489bd3158bbff48a5607e1d21d30">delta_N</a>); i&lt;RB_size; i++)
<a name="l02229"></a>02229                 {
<a name="l02230"></a>02230                   <a class="code" href="classlibMesh_1_1RBSystem.php#ac3d546a3eaa362377494da087e711608">Fq_Aq_representor_norms</a>[q_f][q_a][i] =
<a name="l02231"></a>02231                     <a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>-&gt;dot(*<a class="code" href="classlibMesh_1_1RBSystem.php#a9c8fb2a4cb5b77e59e36bfff438aed01">A_q_representor</a>[q_a][i]);
<a name="l02232"></a>02232                 }
<a name="l02233"></a>02233             }
<a name="l02234"></a>02234         }
<a name="l02235"></a>02235 
<a name="l02236"></a>02236       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q=0;
<a name="l02237"></a>02237       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_a1=0; q_a1&lt;<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>(); q_a1++)
<a name="l02238"></a>02238         {
<a name="l02239"></a>02239           <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_a2=q_a1; q_a2&lt;<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>(); q_a2++)
<a name="l02240"></a>02240             {
<a name="l02241"></a>02241               <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=(RB_size-<a class="code" href="classlibMesh_1_1RBSystem.php#a36ba489bd3158bbff48a5607e1d21d30">delta_N</a>); i&lt;RB_size; i++)
<a name="l02242"></a>02242                 {
<a name="l02243"></a>02243                   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;RB_size; j++)
<a name="l02244"></a>02244                     {
<a name="l02245"></a>02245                       <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a>)
<a name="l02246"></a>02246                         {
<a name="l02247"></a>02247                           <a class="code" href="classlibMesh_1_1RBSystem.php#a330478ef4e1a158dc7b6f08530e10ff3">inner_product_matrix</a>-&gt;vector_mult(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>, *<a class="code" href="classlibMesh_1_1RBSystem.php#a9c8fb2a4cb5b77e59e36bfff438aed01">A_q_representor</a>[q_a2][j]);
<a name="l02248"></a>02248                         }
<a name="l02249"></a>02249                       <span class="keywordflow">else</span>
<a name="l02250"></a>02250                         {
<a name="l02251"></a>02251                           <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#adaccc5857f1a5d5ca264ded0b8bfb986">vector_mult</a>(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>, *<a class="code" href="classlibMesh_1_1RBSystem.php#a9c8fb2a4cb5b77e59e36bfff438aed01">A_q_representor</a>[q_a2][j]);
<a name="l02252"></a>02252                         }
<a name="l02253"></a>02253                       <a class="code" href="classlibMesh_1_1RBSystem.php#a668fed2dcb2e98adb2e7eea5bc7d853e">Aq_Aq_representor_norms</a>[q][i][j] = <a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>-&gt;dot(*<a class="code" href="classlibMesh_1_1RBSystem.php#a9c8fb2a4cb5b77e59e36bfff438aed01">A_q_representor</a>[q_a1][i]);
<a name="l02254"></a>02254 
<a name="l02255"></a>02255                       <span class="keywordflow">if</span>(i != j)
<a name="l02256"></a>02256                         {
<a name="l02257"></a>02257                           <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a>)
<a name="l02258"></a>02258                             {
<a name="l02259"></a>02259                               <a class="code" href="classlibMesh_1_1RBSystem.php#a330478ef4e1a158dc7b6f08530e10ff3">inner_product_matrix</a>-&gt;vector_mult(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>, *<a class="code" href="classlibMesh_1_1RBSystem.php#a9c8fb2a4cb5b77e59e36bfff438aed01">A_q_representor</a>[q_a2][i]);
<a name="l02260"></a>02260                             }
<a name="l02261"></a>02261                           <span class="keywordflow">else</span>
<a name="l02262"></a>02262                             {
<a name="l02263"></a>02263                               <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#adaccc5857f1a5d5ca264ded0b8bfb986">vector_mult</a>(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>, *<a class="code" href="classlibMesh_1_1RBSystem.php#a9c8fb2a4cb5b77e59e36bfff438aed01">A_q_representor</a>[q_a2][i]);
<a name="l02264"></a>02264                             }
<a name="l02265"></a>02265                           <a class="code" href="classlibMesh_1_1RBSystem.php#a668fed2dcb2e98adb2e7eea5bc7d853e">Aq_Aq_representor_norms</a>[q][j][i] = <a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>-&gt;dot(*<a class="code" href="classlibMesh_1_1RBSystem.php#a9c8fb2a4cb5b77e59e36bfff438aed01">A_q_representor</a>[q_a1][j]);
<a name="l02266"></a>02266                         }
<a name="l02267"></a>02267                     }
<a name="l02268"></a>02268                 }
<a name="l02269"></a>02269               q++;
<a name="l02270"></a>02270             }
<a name="l02271"></a>02271         }
<a name="l02272"></a>02272     } <span class="comment">// end if (compute_inner_products)</span>
<a name="l02273"></a>02273   
<a name="l02274"></a>02274   <a class="code" href="classlibMesh_1_1RBSystem.php#a88a28e5658cc0bf37e3df863a46a9e7b">update_residual_terms_called</a> = <span class="keyword">true</span>;
<a name="l02275"></a>02275 
<a name="l02276"></a>02276   STOP_LOG(<span class="stringliteral">&quot;update_residual_terms()&quot;</span>, <span class="stringliteral">&quot;RBSystem&quot;</span>);
<a name="l02277"></a>02277 }
<a name="l02278"></a>02278 
<a name="l02279"></a><a class="code" href="classlibMesh_1_1RBSystem.php#ab3721f4dcfe7b60950382a6e03607fe9">02279</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#ab3721f4dcfe7b60950382a6e03607fe9">RBSystem::assemble_matrix_for_output_dual_solves</a>()
<a name="l02280"></a>02280 {
<a name="l02281"></a>02281   <span class="comment">// By default we use the inner product matrix for steady problems</span>
<a name="l02282"></a>02282   
<a name="l02283"></a>02283   <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a>)
<a name="l02284"></a>02284   {
<a name="l02285"></a>02285     <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#a966e0a6479f33c2518937e7d0f54602f">zero</a>();
<a name="l02286"></a>02286     <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#a401beeed965b80425730050a61de5c21">add</a>(1., *<a class="code" href="classlibMesh_1_1RBSystem.php#a330478ef4e1a158dc7b6f08530e10ff3">inner_product_matrix</a>);
<a name="l02287"></a>02287   }
<a name="l02288"></a>02288   <span class="keywordflow">else</span>
<a name="l02289"></a>02289   {
<a name="l02290"></a>02290     <a class="code" href="classlibMesh_1_1RBSystem.php#a2bde84b5899642d6bb6ba2f6ac4a51f9">assemble_inner_product_matrix</a>(<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>);
<a name="l02291"></a>02291   }
<a name="l02292"></a>02292 }
<a name="l02293"></a>02293 
<a name="l02294"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a8718bf6f56c88f4ccab7521f334e6a2c">02294</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a8718bf6f56c88f4ccab7521f334e6a2c">RBSystem::compute_output_dual_norms</a>()
<a name="l02295"></a>02295 {
<a name="l02296"></a>02296   START_LOG(<span class="stringliteral">&quot;compute_output_dual_norms()&quot;</span>, <span class="stringliteral">&quot;RBSystem&quot;</span>);
<a name="l02297"></a>02297   
<a name="l02298"></a>02298   <span class="comment">// Note: the solves in this function employ a single system matrix and multiple</span>
<a name="l02299"></a>02299   <span class="comment">// right-hand sides, so we may get better performance using a different</span>
<a name="l02300"></a>02300   <span class="comment">// preconditioner, or even a direct solver.</span>
<a name="l02301"></a>02301   std::pair&lt;std::string,std::string&gt; orig_solver =
<a name="l02302"></a>02302     this-&gt;<a class="code" href="classlibMesh_1_1RBBase.php#a7fd20c081ea2d46f007c1454a553198a">set_alternative_solver</a>(this-&gt;<a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a7cc68891fa9f44ded49b9b84c057cb32">linear_solver</a>);
<a name="l02303"></a>02303 
<a name="l02304"></a>02304   <span class="comment">// Find out the largest value of Q_l</span>
<a name="l02305"></a>02305   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> max_Q_l = 0;
<a name="l02306"></a>02306   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#a80b9e06a7c60b3bb2f5870b0ff66a2ca">get_n_outputs</a>(); n++)
<a name="l02307"></a>02307     max_Q_l = (<a class="code" href="classlibMesh_1_1RBSystem.php#ab7f0b2268a9716189225e0446b519911">get_Q_l</a>(n) &gt; max_Q_l) ? <a class="code" href="classlibMesh_1_1RBSystem.php#ab7f0b2268a9716189225e0446b519911">get_Q_l</a>(n) : max_Q_l;
<a name="l02308"></a>02308 
<a name="l02309"></a>02309   std::vector&lt; NumericVector&lt;Number&gt;* &gt; L_q_representor(max_Q_l);
<a name="l02310"></a>02310   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q=0; q&lt;max_Q_l; q++)
<a name="l02311"></a>02311   {
<a name="l02312"></a>02312     L_q_representor[q] = (<a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;::build</a>().release());
<a name="l02313"></a>02313     L_q_representor[q]-&gt;init (this-&gt;<a class="code" href="classlibMesh_1_1System.php#a90dbb901f00c14ff18399f4afabcebe5">n_dofs</a>(), this-&gt;<a class="code" href="classlibMesh_1_1System.php#ae3aeb82e65b06789823d41da3c5df7a2">n_local_dofs</a>(), <span class="keyword">false</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">libMeshEnums::PARALLEL</a>);
<a name="l02314"></a>02314   }
<a name="l02315"></a>02315 
<a name="l02316"></a>02316   <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBSystem.php#a61f47d68b0df487674a9001d13d77c88">reuse_preconditioner</a>)
<a name="l02317"></a>02317   {
<a name="l02318"></a>02318     <span class="comment">// For the first solve, make sure we generate a new preconditioner</span>
<a name="l02319"></a>02319     <a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a7cc68891fa9f44ded49b9b84c057cb32">linear_solver</a>-&gt;same_preconditioner = <span class="keyword">false</span>;
<a name="l02320"></a>02320   }
<a name="l02321"></a>02321   
<a name="l02322"></a>02322   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#a80b9e06a7c60b3bb2f5870b0ff66a2ca">get_n_outputs</a>(); n++)
<a name="l02323"></a>02323   {
<a name="l02324"></a>02324     <span class="comment">// If constrained_problem, we need to reassemble to add the constraint part back in</span>
<a name="l02325"></a>02325     <span class="keywordflow">if</span>( (n==0) || <a class="code" href="classlibMesh_1_1RBSystem.php#a28b1348023897cb1517724d6ac30a21d">constrained_problem</a>)
<a name="l02326"></a>02326     {
<a name="l02327"></a>02327       <a class="code" href="classlibMesh_1_1RBSystem.php#ab3721f4dcfe7b60950382a6e03607fe9">assemble_matrix_for_output_dual_solves</a>();
<a name="l02328"></a>02328       
<a name="l02329"></a>02329       <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBSystem.php#a28b1348023897cb1517724d6ac30a21d">constrained_problem</a>)
<a name="l02330"></a>02330       {
<a name="l02331"></a>02331         <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a>)
<a name="l02332"></a>02332         {
<a name="l02333"></a>02333           <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#a401beeed965b80425730050a61de5c21">add</a>(1., *<a class="code" href="classlibMesh_1_1RBSystem.php#aa7a3439518c1b8a421a79064e819f5c8">constraint_matrix</a>);
<a name="l02334"></a>02334         }
<a name="l02335"></a>02335         <span class="keywordflow">else</span>
<a name="l02336"></a>02336         {
<a name="l02337"></a>02337           <a class="code" href="classlibMesh_1_1RBSystem.php#a4a1243f45ea36fbd2a10ad6956c62deb">add_scaled_matrix_and_vector</a>(1., <a class="code" href="classlibMesh_1_1RBSystem.php#a9c6da671e41886e26c7e88aae82f4358">constraint_assembly</a>, NULL, <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>, NULL);
<a name="l02338"></a>02338         }
<a name="l02339"></a>02339       }
<a name="l02340"></a>02340     }
<a name="l02341"></a>02341 
<a name="l02342"></a>02342     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_l=0; q_l&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#ab7f0b2268a9716189225e0446b519911">get_Q_l</a>(n); q_l++)
<a name="l02343"></a>02343     {
<a name="l02344"></a>02344       <a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a85b3d4a53413e3745e6ecf1c8b96ca65">zero</a>();
<a name="l02345"></a>02345             <a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#aaf343defd46de8557801dc56a2884506">add</a>(1., *<a class="code" href="classlibMesh_1_1RBSystem.php#a956b276ef7de8606c78698fcfa338343">get_output_vector</a>(n,q_l));
<a name="l02346"></a>02346       <a class="code" href="classlibMesh_1_1RBSystem.php#a85c25bbd66bed6e4111e44566e91b5ff">zero_dirichlet_dofs_on_rhs</a>();
<a name="l02347"></a>02347 
<a name="l02348"></a>02348       <a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;zero();
<a name="l02349"></a>02349 
<a name="l02350"></a>02350       <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1RBSystem.php#adec856bc209f0533639d76767bd5ebbc">quiet</a>)
<a name="l02351"></a>02351         <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Starting solve n=&quot;</span> &lt;&lt; n &lt;&lt; <span class="stringliteral">&quot;, q_l=&quot;</span> &lt;&lt; q_l
<a name="l02352"></a>02352                &lt;&lt; <span class="stringliteral">&quot; in RBSystem::compute_output_dual_norms() at &quot;</span>
<a name="l02353"></a>02353                &lt;&lt; <a class="code" href="namespacelibMesh_1_1Utility.php#a0e4485920eb5de9a47b6f8760a11361d">Utility::get_timestamp</a>() &lt;&lt; std::endl;
<a name="l02354"></a>02354 
<a name="l02355"></a>02355       <a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#af1de21a76860785bb1992280eb72b0db">solve</a>();
<a name="l02356"></a>02356 
<a name="l02357"></a>02357       <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1RBSystem.php#adec856bc209f0533639d76767bd5ebbc">quiet</a>)
<a name="l02358"></a>02358         {
<a name="l02359"></a>02359           <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Finished solve n=&quot;</span> &lt;&lt; n &lt;&lt; <span class="stringliteral">&quot;, q_l=&quot;</span> &lt;&lt; q_l
<a name="l02360"></a>02360                        &lt;&lt; <span class="stringliteral">&quot; in RBSystem::compute_output_dual_norms() at &quot;</span>
<a name="l02361"></a>02361                        &lt;&lt; <a class="code" href="namespacelibMesh_1_1Utility.php#a0e4485920eb5de9a47b6f8760a11361d">Utility::get_timestamp</a>() &lt;&lt; std::endl;
<a name="l02362"></a>02362 
<a name="l02363"></a>02363           <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; this-&gt;<a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#af712dbf0e285c5ff4cc346daef05423c">n_linear_iterations</a>()
<a name="l02364"></a>02364                        &lt;&lt; <span class="stringliteral">&quot; iterations, final residual &quot;</span>
<a name="l02365"></a>02365                        &lt;&lt; this-&gt;<a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a86b5e2954d2a2e43014bcda8810239ac">final_linear_residual</a>() &lt;&lt; std::endl;
<a name="l02366"></a>02366         }
<a name="l02367"></a>02367 
<a name="l02368"></a>02368       <span class="comment">// Make sure we didn&#39;t max out the number of iterations</span>
<a name="l02369"></a>02369       <span class="keywordflow">if</span>( (this-&gt;<a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#af712dbf0e285c5ff4cc346daef05423c">n_linear_iterations</a>() &gt;=
<a name="l02370"></a>02370            this-&gt;<a class="code" href="classlibMesh_1_1System.php#ac5ca6b1f3adcfac56982982e90dc905b">get_equation_systems</a>().parameters.get&lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&gt;(<span class="stringliteral">&quot;linear solver maximum iterations&quot;</span>)) &amp;&amp;
<a name="l02371"></a>02371           (this-&gt;final_linear_residual() &gt;
<a name="l02372"></a>02372            this-&gt;<a class="code" href="classlibMesh_1_1System.php#ac5ca6b1f3adcfac56982982e90dc905b">get_equation_systems</a>().<a class="code" href="classlibMesh_1_1EquationSystems.php#a7c02be232f564967ca0804a7824adb53">parameters</a>.<a class="code" href="classlibMesh_1_1Parameters.php#ac7fa2054ee32db2c3979d48bd2103f20">get</a>&lt;<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>&gt;(<span class="stringliteral">&quot;linear solver tolerance&quot;</span>)) )
<a name="l02373"></a>02373          {
<a name="l02374"></a>02374            <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Warning: Linear solver may not have converged! Final linear residual = &quot;</span>
<a name="l02375"></a>02375                         &lt;&lt; this-&gt;<a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a86b5e2954d2a2e43014bcda8810239ac">final_linear_residual</a>() &lt;&lt; <span class="stringliteral">&quot;, number of iterations = &quot;</span>
<a name="l02376"></a>02376                         &lt;&lt; this-&gt;<a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#af712dbf0e285c5ff4cc346daef05423c">n_linear_iterations</a>() &lt;&lt; std::endl &lt;&lt; std::endl;
<a name="l02377"></a>02377            <span class="comment">// libmesh_error();</span>
<a name="l02378"></a>02378 
<a name="l02379"></a>02379          }
<a name="l02380"></a>02380       *L_q_representor[q_l] = *<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>;
<a name="l02381"></a>02381 
<a name="l02382"></a>02382       <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBSystem.php#a61f47d68b0df487674a9001d13d77c88">reuse_preconditioner</a>)
<a name="l02383"></a>02383         {
<a name="l02384"></a>02384           <span class="comment">// After we do a solve, tell PETSc we want to reuse the preconditioner</span>
<a name="l02385"></a>02385           <span class="comment">// since the system matrix is not changing.</span>
<a name="l02386"></a>02386           <a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a7cc68891fa9f44ded49b9b84c057cb32">linear_solver</a>-&gt;same_preconditioner = <span class="keyword">true</span>;
<a name="l02387"></a>02387         }
<a name="l02388"></a>02388     }
<a name="l02389"></a>02389 
<a name="l02390"></a>02390     <span class="comment">// Get rid of the constraint part of the matrix before computing inner products</span>
<a name="l02391"></a>02391     <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBSystem.php#a28b1348023897cb1517724d6ac30a21d">constrained_problem</a>)
<a name="l02392"></a>02392       <a class="code" href="classlibMesh_1_1RBSystem.php#ab3721f4dcfe7b60950382a6e03607fe9">assemble_matrix_for_output_dual_solves</a>();
<a name="l02393"></a>02393 
<a name="l02394"></a>02394     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q=0;
<a name="l02395"></a>02395     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_l1=0; q_l1&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#ab7f0b2268a9716189225e0446b519911">get_Q_l</a>(n); q_l1++)
<a name="l02396"></a>02396     {
<a name="l02397"></a>02397       <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#adaccc5857f1a5d5ca264ded0b8bfb986">vector_mult</a>(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>, *L_q_representor[q_l1]);
<a name="l02398"></a>02398 
<a name="l02399"></a>02399       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_l2=q_l1; q_l2&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#ab7f0b2268a9716189225e0446b519911">get_Q_l</a>(n); q_l2++)
<a name="l02400"></a>02400       {
<a name="l02401"></a>02401         <a class="code" href="classlibMesh_1_1RBSystem.php#a2e3592b7167280ef4dd92cfb4a131c62">output_dual_norms</a>[n][q] = L_q_representor[q_l2]-&gt;dot(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>);
<a name="l02402"></a>02402         <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;output_dual_norms[&quot;</span> &lt;&lt; n &lt;&lt; <span class="stringliteral">&quot;][&quot;</span> &lt;&lt; q &lt;&lt; <span class="stringliteral">&quot;] = &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1RBSystem.php#a2e3592b7167280ef4dd92cfb4a131c62">output_dual_norms</a>[n][q] &lt;&lt; std::endl;
<a name="l02403"></a>02403         
<a name="l02404"></a>02404         q++;
<a name="l02405"></a>02405       }
<a name="l02406"></a>02406     }
<a name="l02407"></a>02407   }
<a name="l02408"></a>02408 
<a name="l02409"></a>02409   <span class="comment">// reset same_preconditioner to false once all solves are finished</span>
<a name="l02410"></a>02410   <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBSystem.php#a61f47d68b0df487674a9001d13d77c88">reuse_preconditioner</a>)
<a name="l02411"></a>02411   {
<a name="l02412"></a>02412     <a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a7cc68891fa9f44ded49b9b84c057cb32">linear_solver</a>-&gt;same_preconditioner = <span class="keyword">false</span>;
<a name="l02413"></a>02413   }
<a name="l02414"></a>02414 
<a name="l02415"></a>02415   <span class="comment">// Finally clear the L_q_representor vectors</span>
<a name="l02416"></a>02416   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q=0; q&lt;max_Q_l; q++)
<a name="l02417"></a>02417   {
<a name="l02418"></a>02418     <span class="keywordflow">if</span>(L_q_representor[q])
<a name="l02419"></a>02419     {
<a name="l02420"></a>02420       <span class="keyword">delete</span> L_q_representor[q];
<a name="l02421"></a>02421       L_q_representor[q] = NULL;
<a name="l02422"></a>02422     }
<a name="l02423"></a>02423   }
<a name="l02424"></a>02424 
<a name="l02425"></a>02425   <span class="comment">// Change the preconditioner, Krylov solver back to their original</span>
<a name="l02426"></a>02426   <span class="comment">// value.  Note: does nothing if RBBase::alternative_solver ==</span>
<a name="l02427"></a>02427   <span class="comment">// &quot;unchanged&quot;.</span>
<a name="l02428"></a>02428   this-&gt;<a class="code" href="classlibMesh_1_1RBBase.php#a9f236decb17000238d3e1937bf547402">reset_alternative_solver</a>(this-&gt;<a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a7cc68891fa9f44ded49b9b84c057cb32">linear_solver</a>, orig_solver);
<a name="l02429"></a>02429 
<a name="l02430"></a>02430   STOP_LOG(<span class="stringliteral">&quot;compute_output_dual_norms()&quot;</span>, <span class="stringliteral">&quot;RBSystem&quot;</span>);
<a name="l02431"></a>02431 }
<a name="l02432"></a>02432 
<a name="l02433"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a24fc309a7bfce6fb9380e242d4fdd5bc">02433</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a24fc309a7bfce6fb9380e242d4fdd5bc">RBSystem::load_RB_solution</a>()
<a name="l02434"></a>02434 {
<a name="l02435"></a>02435   START_LOG(<span class="stringliteral">&quot;load_RB_solution()&quot;</span>, <span class="stringliteral">&quot;RBSystem&quot;</span>);
<a name="l02436"></a>02436 
<a name="l02437"></a>02437   <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBBase.php#a11c4b80a15c0e9ea1d822f5e04545059">initialize_calN_dependent_data</a>)
<a name="l02438"></a>02438   {
<a name="l02439"></a>02439     <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error: We must initialize the calN dependent &quot;</span>
<a name="l02440"></a>02440                  &lt;&lt; <span class="stringliteral">&quot;data structures in order to load RB solution.&quot;</span>
<a name="l02441"></a>02441                  &lt;&lt; std::endl;
<a name="l02442"></a>02442     libmesh_error();
<a name="l02443"></a>02443   }
<a name="l02444"></a>02444 
<a name="l02445"></a>02445   <a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;zero();
<a name="l02446"></a>02446 
<a name="l02447"></a>02447   <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBSystem.php#a201af52facfa4da38bc636ee2cf41c67">RB_solution</a>.<a class="code" href="classlibMesh_1_1DenseVector.php#ab124ecf2f46ee43b167f093b05d81fdb">size</a>() &gt; <a class="code" href="classlibMesh_1_1RBSystem.php#abfe6d67ed23243d225f12747f355f105">basis_functions</a>.size())
<a name="l02448"></a>02448   {
<a name="l02449"></a>02449     <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: System contains &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1RBSystem.php#abfe6d67ed23243d225f12747f355f105">basis_functions</a>.size() &lt;&lt; <span class="stringliteral">&quot; basis functions.&quot;</span>
<a name="l02450"></a>02450                  &lt;&lt; <span class="stringliteral">&quot; RB_solution vector constains &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1RBSystem.php#a201af52facfa4da38bc636ee2cf41c67">RB_solution</a>.<a class="code" href="classlibMesh_1_1DenseVector.php#ab124ecf2f46ee43b167f093b05d81fdb">size</a>() &lt;&lt; <span class="stringliteral">&quot; entries.&quot;</span>
<a name="l02451"></a>02451                  &lt;&lt; <span class="stringliteral">&quot; RB_solution in RBSystem::load_RB_solution is too long!&quot;</span> &lt;&lt; std::endl;
<a name="l02452"></a>02452     libmesh_error();
<a name="l02453"></a>02453   }
<a name="l02454"></a>02454 
<a name="l02455"></a>02455   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#a201af52facfa4da38bc636ee2cf41c67">RB_solution</a>.<a class="code" href="classlibMesh_1_1DenseVector.php#ab124ecf2f46ee43b167f093b05d81fdb">size</a>(); i++)
<a name="l02456"></a>02456   {
<a name="l02457"></a>02457     <a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;add(<a class="code" href="classlibMesh_1_1RBSystem.php#a201af52facfa4da38bc636ee2cf41c67">RB_solution</a>(i), *<a class="code" href="classlibMesh_1_1RBSystem.php#abfe6d67ed23243d225f12747f355f105">basis_functions</a>[i]);
<a name="l02458"></a>02458   }
<a name="l02459"></a>02459 
<a name="l02460"></a>02460   <a class="code" href="classlibMesh_1_1System.php#ab9d81ac9c1787c43fb87cf13d37741ee">update</a>();
<a name="l02461"></a>02461 
<a name="l02462"></a>02462   STOP_LOG(<span class="stringliteral">&quot;load_RB_solution()&quot;</span>, <span class="stringliteral">&quot;RBSystem&quot;</span>);
<a name="l02463"></a>02463 }
<a name="l02464"></a>02464 
<a name="l02465"></a><a class="code" href="classlibMesh_1_1RBSystem.php#aacdbb059e6ab25ff140d34cdc13ab253">02465</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1RBSystem.php#aacdbb059e6ab25ff140d34cdc13ab253">RBSystem::compute_residual_dual_norm</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N)
<a name="l02466"></a>02466 {
<a name="l02467"></a>02467   START_LOG(<span class="stringliteral">&quot;compute_residual_dual_norm()&quot;</span>, <span class="stringliteral">&quot;RBSystem&quot;</span>);
<a name="l02468"></a>02468 
<a name="l02469"></a>02469 <span class="comment">//   // Put the residual in rhs in order to compute the norm of the Riesz representor</span>
<a name="l02470"></a>02470 <span class="comment">//   // Note that this only works in serial since otherwise each processor will</span>
<a name="l02471"></a>02471 <span class="comment">//   // have a different parameter value during the Greedy training.</span>
<a name="l02472"></a>02472 <span class="comment">//</span>
<a name="l02473"></a>02473 <span class="comment">//   AutoPtr&lt; NumericVector&lt;Number&gt; &gt; RB_sol = NumericVector&lt;Number&gt;::build();</span>
<a name="l02474"></a>02474 <span class="comment">//   RB_sol-&gt;init (this-&gt;n_dofs(), this-&gt;n_local_dofs(), false, libMeshEnums::PARALLEL);</span>
<a name="l02475"></a>02475 <span class="comment">//</span>
<a name="l02476"></a>02476 <span class="comment">//   AutoPtr&lt; NumericVector&lt;Number&gt; &gt; temp = NumericVector&lt;Number&gt;::build();</span>
<a name="l02477"></a>02477 <span class="comment">//   temp-&gt;init (this-&gt;n_dofs(), this-&gt;n_local_dofs(), false, libMeshEnums::PARALLEL);</span>
<a name="l02478"></a>02478 <span class="comment">//</span>
<a name="l02479"></a>02479 <span class="comment">//   for(unsigned int i=0; i&lt;N; i++)</span>
<a name="l02480"></a>02480 <span class="comment">//   {</span>
<a name="l02481"></a>02481 <span class="comment">//     RB_sol-&gt;add(RB_solution(i), *basis_functions[i]);</span>
<a name="l02482"></a>02482 <span class="comment">//   }</span>
<a name="l02483"></a>02483 <span class="comment">//</span>
<a name="l02484"></a>02484 <span class="comment">//   this-&gt;truth_assembly();</span>
<a name="l02485"></a>02485 <span class="comment">//   matrix-&gt;vector_mult(*temp, *RB_sol);</span>
<a name="l02486"></a>02486 <span class="comment">//   rhs-&gt;add(-1., *temp);</span>
<a name="l02487"></a>02487 <span class="comment">//</span>
<a name="l02488"></a>02488 <span class="comment">//   // Then solve to get the Reisz representor</span>
<a name="l02489"></a>02489 <span class="comment">//   matrix-&gt;zero();</span>
<a name="l02490"></a>02490 <span class="comment">//   matrix-&gt;add(1., *inner_product_matrix);</span>
<a name="l02491"></a>02491 <span class="comment">//   if(constrained_problem)</span>
<a name="l02492"></a>02492 <span class="comment">//     matrix-&gt;add(1., *constraint_matrix);</span>
<a name="l02493"></a>02493 <span class="comment">//</span>
<a name="l02494"></a>02494 <span class="comment">//   solution-&gt;zero();</span>
<a name="l02495"></a>02495 <span class="comment">//   solve();</span>
<a name="l02496"></a>02496 <span class="comment">//   // Make sure we didn&#39;t max out the number of iterations</span>
<a name="l02497"></a>02497 <span class="comment">//   if( (this-&gt;n_linear_iterations() &gt;=</span>
<a name="l02498"></a>02498 <span class="comment">//        this-&gt;get_equation_systems().parameters.get&lt;unsigned int&gt;(&quot;linear solver maximum iterations&quot;)) &amp;&amp;</span>
<a name="l02499"></a>02499 <span class="comment">//       (this-&gt;final_linear_residual() &gt;</span>
<a name="l02500"></a>02500 <span class="comment">//        this-&gt;get_equation_systems().parameters.get&lt;Real&gt;(&quot;linear solver tolerance&quot;)) )</span>
<a name="l02501"></a>02501 <span class="comment">//   {</span>
<a name="l02502"></a>02502 <span class="comment">//     libMesh::out &lt;&lt; &quot;Warning: Linear solver may not have converged! Final linear residual = &quot;</span>
<a name="l02503"></a>02503 <span class="comment">//                  &lt;&lt; this-&gt;final_linear_residual() &lt;&lt; &quot;, number of iterations = &quot;</span>
<a name="l02504"></a>02504 <span class="comment">//                  &lt;&lt; this-&gt;n_linear_iterations() &lt;&lt; std::endl &lt;&lt; std::endl;</span>
<a name="l02505"></a>02505 <span class="comment">// //     libmesh_error();</span>
<a name="l02506"></a>02506 <span class="comment">//   }</span>
<a name="l02507"></a>02507 <span class="comment">//</span>
<a name="l02508"></a>02508 <span class="comment">//   if(!low_memory_mode)</span>
<a name="l02509"></a>02509 <span class="comment">//   {</span>
<a name="l02510"></a>02510 <span class="comment">//     inner_product_matrix-&gt;vector_mult(*inner_product_storage_vector, *solution);</span>
<a name="l02511"></a>02511 <span class="comment">//   }</span>
<a name="l02512"></a>02512 <span class="comment">//   else</span>
<a name="l02513"></a>02513 <span class="comment">//   {</span>
<a name="l02514"></a>02514 <span class="comment">//     assemble_inner_product_matrix(matrix);</span>
<a name="l02515"></a>02515 <span class="comment">//     matrix-&gt;vector_mult(*inner_product_storage_vector, *solution);</span>
<a name="l02516"></a>02516 <span class="comment">//   }</span>
<a name="l02517"></a>02517 <span class="comment">//</span>
<a name="l02518"></a>02518 <span class="comment">//   Real slow_residual_norm_sq = solution-&gt;dot(*inner_product_storage_vector);</span>
<a name="l02519"></a>02519 
<a name="l02520"></a>02520 
<a name="l02521"></a>02521   <span class="comment">// Use the stored representor inner product values</span>
<a name="l02522"></a>02522   <span class="comment">// to evaluate the residual norm</span>
<a name="l02523"></a>02523   <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> residual_norm_sq = 0.;
<a name="l02524"></a>02524 
<a name="l02525"></a>02525   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q=0;
<a name="l02526"></a>02526   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_f1=0; q_f1&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>(); q_f1++)
<a name="l02527"></a>02527   {
<a name="l02528"></a>02528     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_f2=q_f1; q_f2&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>(); q_f2++)
<a name="l02529"></a>02529     {
<a name="l02530"></a>02530       <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> delta = (q_f1==q_f2) ? 1. : 2.;
<a name="l02531"></a>02531       residual_norm_sq += delta * <a class="code" href="namespacelibMesh.php#aea33cac176f18504c5c4078407aadbb7">libmesh_real</a>(
<a name="l02532"></a>02532         <a class="code" href="classlibMesh_1_1RBSystem.php#a0fd951279c9b851ac38443156b4b18bd">eval_theta_q_f</a>(q_f1) * <a class="code" href="namespacelibMesh.php#adf2cda6212d46ff664adf9f688129825">libmesh_conj</a>(<a class="code" href="classlibMesh_1_1RBSystem.php#a0fd951279c9b851ac38443156b4b18bd">eval_theta_q_f</a>(q_f2)) * <a class="code" href="classlibMesh_1_1RBSystem.php#a567c86950bb6d2ab2800ac0b14ed3dd2">Fq_representor_norms</a>[q] );
<a name="l02533"></a>02533 
<a name="l02534"></a>02534       q++;
<a name="l02535"></a>02535     }
<a name="l02536"></a>02536   }
<a name="l02537"></a>02537 
<a name="l02538"></a>02538   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_f=0; q_f&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>(); q_f++)
<a name="l02539"></a>02539   {
<a name="l02540"></a>02540     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_a=0; q_a&lt;<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>(); q_a++)
<a name="l02541"></a>02541     {
<a name="l02542"></a>02542       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;N; i++)
<a name="l02543"></a>02543       {
<a name="l02544"></a>02544         <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> delta = 2.;
<a name="l02545"></a>02545         residual_norm_sq +=
<a name="l02546"></a>02546           delta * <a class="code" href="namespacelibMesh.php#aea33cac176f18504c5c4078407aadbb7">libmesh_real</a>( <a class="code" href="classlibMesh_1_1RBSystem.php#a0fd951279c9b851ac38443156b4b18bd">eval_theta_q_f</a>(q_f) * <a class="code" href="namespacelibMesh.php#adf2cda6212d46ff664adf9f688129825">libmesh_conj</a>(<a class="code" href="classlibMesh_1_1RBBase.php#aeeb46ce2b390bf820f954976ee9da7ce">eval_theta_q_a</a>(q_a)) *
<a name="l02547"></a>02547           <a class="code" href="namespacelibMesh.php#adf2cda6212d46ff664adf9f688129825">libmesh_conj</a>(<a class="code" href="classlibMesh_1_1RBSystem.php#a201af52facfa4da38bc636ee2cf41c67">RB_solution</a>(i)) * <a class="code" href="classlibMesh_1_1RBSystem.php#ac3d546a3eaa362377494da087e711608">Fq_Aq_representor_norms</a>[q_f][q_a][i] );
<a name="l02548"></a>02548       }
<a name="l02549"></a>02549     }
<a name="l02550"></a>02550   }
<a name="l02551"></a>02551 
<a name="l02552"></a>02552   q=0;
<a name="l02553"></a>02553   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_a1=0; q_a1&lt;<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>(); q_a1++)
<a name="l02554"></a>02554   {
<a name="l02555"></a>02555     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_a2=q_a1; q_a2&lt;<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>(); q_a2++)
<a name="l02556"></a>02556     {
<a name="l02557"></a>02557       <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> delta = (q_a1==q_a2) ? 1. : 2.;
<a name="l02558"></a>02558 
<a name="l02559"></a>02559       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;N; i++)
<a name="l02560"></a>02560       {
<a name="l02561"></a>02561         <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;N; j++)
<a name="l02562"></a>02562         {
<a name="l02563"></a>02563           residual_norm_sq +=
<a name="l02564"></a>02564             delta * <a class="code" href="namespacelibMesh.php#aea33cac176f18504c5c4078407aadbb7">libmesh_real</a>( <a class="code" href="namespacelibMesh.php#adf2cda6212d46ff664adf9f688129825">libmesh_conj</a>(<a class="code" href="classlibMesh_1_1RBBase.php#aeeb46ce2b390bf820f954976ee9da7ce">eval_theta_q_a</a>(q_a1)) * <a class="code" href="classlibMesh_1_1RBBase.php#aeeb46ce2b390bf820f954976ee9da7ce">eval_theta_q_a</a>(q_a2) *
<a name="l02565"></a>02565             <a class="code" href="namespacelibMesh.php#adf2cda6212d46ff664adf9f688129825">libmesh_conj</a>(<a class="code" href="classlibMesh_1_1RBSystem.php#a201af52facfa4da38bc636ee2cf41c67">RB_solution</a>(i)) * <a class="code" href="classlibMesh_1_1RBSystem.php#a201af52facfa4da38bc636ee2cf41c67">RB_solution</a>(j) * <a class="code" href="classlibMesh_1_1RBSystem.php#a668fed2dcb2e98adb2e7eea5bc7d853e">Aq_Aq_representor_norms</a>[q][i][j] );
<a name="l02566"></a>02566         }
<a name="l02567"></a>02567       }
<a name="l02568"></a>02568 
<a name="l02569"></a>02569       q++;
<a name="l02570"></a>02570     }
<a name="l02571"></a>02571   }
<a name="l02572"></a>02572 
<a name="l02573"></a>02573 <span class="comment">//  if(libmesh_real(residual_norm_sq) &lt; 0.)</span>
<a name="l02574"></a>02574 <span class="comment">//  {</span>
<a name="l02575"></a>02575 <span class="comment">//    libMesh::out &lt;&lt; &quot;Warning: Square of residual norm is negative &quot;</span>
<a name="l02576"></a>02576 <span class="comment">//                 &lt;&lt; &quot;in RBSystem::compute_residual_dual_norm()&quot; &lt;&lt; std::endl;</span>
<a name="l02577"></a>02577 
<a name="l02578"></a>02578     <span class="comment">// Sometimes this is negative due to rounding error,</span>
<a name="l02579"></a>02579     <span class="comment">// but error is on the order of 1.e-10, so shouldn&#39;t</span>
<a name="l02580"></a>02580     <span class="comment">// affect error bound much...</span>
<a name="l02581"></a>02581 <span class="comment">//     libmesh_error();</span>
<a name="l02582"></a>02582 <span class="comment">//    residual_norm_sq = std::abs(residual_norm_sq);</span>
<a name="l02583"></a>02583 <span class="comment">//  }</span>
<a name="l02584"></a>02584 
<a name="l02585"></a>02585 <span class="comment">//   libMesh::out &lt;&lt; &quot;Slow residual norm squared = &quot; &lt;&lt; slow_residual_norm_sq</span>
<a name="l02586"></a>02586 <span class="comment">//                &lt;&lt; &quot;, fast residual norm squared = &quot; &lt;&lt; residual_norm_sq &lt;&lt; std::endl;</span>
<a name="l02587"></a>02587 
<a name="l02588"></a>02588   STOP_LOG(<span class="stringliteral">&quot;compute_residual_dual_norm()&quot;</span>, <span class="stringliteral">&quot;RBSystem&quot;</span>);
<a name="l02589"></a>02589 
<a name="l02590"></a>02590   <span class="keywordflow">return</span> std::sqrt( <a class="code" href="namespacelibMesh.php#aea33cac176f18504c5c4078407aadbb7">libmesh_real</a>(residual_norm_sq) );
<a name="l02591"></a>02591 }
<a name="l02592"></a>02592 
<a name="l02593"></a><a class="code" href="classlibMesh_1_1RBSystem.php#aef1516ea2eb482f28578cab98bd53097">02593</a> <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;Number&gt;</a>* <a class="code" href="classlibMesh_1_1RBSystem.php#aef1516ea2eb482f28578cab98bd53097">RBSystem::get_A_q</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q)
<a name="l02594"></a>02594 {
<a name="l02595"></a>02595   <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a>)
<a name="l02596"></a>02596   {
<a name="l02597"></a>02597     <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error: The affine matrices are not store in low-memory mode.&quot;</span> &lt;&lt; std::endl;
<a name="l02598"></a>02598     libmesh_error();
<a name="l02599"></a>02599   }
<a name="l02600"></a>02600 
<a name="l02601"></a>02601   <span class="keywordflow">if</span>(q &gt;= <a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>())
<a name="l02602"></a>02602   {
<a name="l02603"></a>02603     <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error: We must have q &lt; Q_a in get_A_q.&quot;</span>
<a name="l02604"></a>02604                  &lt;&lt; std::endl;
<a name="l02605"></a>02605     libmesh_error();
<a name="l02606"></a>02606   }
<a name="l02607"></a>02607 
<a name="l02608"></a>02608   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a2950621ecac9122266a6893e18735778">A_q_vector</a>[q];
<a name="l02609"></a>02609 }
<a name="l02610"></a>02610 
<a name="l02611"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a9136cc9298d4aeda4145fc61a76dd980">02611</a> <a class="code" href="classlibMesh_1_1RBEIMSystem.php">RBEIMSystem</a>&amp; <a class="code" href="classlibMesh_1_1RBSystem.php#a9136cc9298d4aeda4145fc61a76dd980">RBSystem::get_A_EIM_system</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index)
<a name="l02612"></a>02612 {
<a name="l02613"></a>02613   <span class="keywordflow">if</span>(index &gt;= <a class="code" href="classlibMesh_1_1RBBase.php#a6d45c615a2c06e710550570eb613f57f">A_EIM_systems_vector</a>.size())
<a name="l02614"></a>02614   {
<a name="l02615"></a>02615     <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error: We must have index &lt; get_n_A_EIM_systems() in get_A_EIM_system.&quot;</span>
<a name="l02616"></a>02616                  &lt;&lt; std::endl;
<a name="l02617"></a>02617     libmesh_error();
<a name="l02618"></a>02618   }
<a name="l02619"></a>02619   
<a name="l02620"></a>02620   <span class="keywordflow">return</span> *<a class="code" href="classlibMesh_1_1RBBase.php#a6d45c615a2c06e710550570eb613f57f">A_EIM_systems_vector</a>[index];
<a name="l02621"></a>02621 }
<a name="l02622"></a>02622 
<a name="l02623"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a5d80df31baa1197b3823040f1e85f585">02623</a> <a class="code" href="classlibMesh_1_1RBEIMSystem.php">RBEIMSystem</a>&amp; <a class="code" href="classlibMesh_1_1RBSystem.php#a5d80df31baa1197b3823040f1e85f585">RBSystem::get_F_EIM_system</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index)
<a name="l02624"></a>02624 {
<a name="l02625"></a>02625   <span class="keywordflow">if</span>(index &gt;= <a class="code" href="classlibMesh_1_1RBSystem.php#a1c0266ace79018f4fe863549db995171">F_EIM_systems_vector</a>.size())
<a name="l02626"></a>02626   {
<a name="l02627"></a>02627     <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error: We must have index &lt; get_n_F_EIM_systems() in get_F_EIM_system.&quot;</span>
<a name="l02628"></a>02628                  &lt;&lt; std::endl;
<a name="l02629"></a>02629     libmesh_error();
<a name="l02630"></a>02630   }
<a name="l02631"></a>02631   
<a name="l02632"></a>02632   <span class="keywordflow">return</span> *<a class="code" href="classlibMesh_1_1RBSystem.php#a1c0266ace79018f4fe863549db995171">F_EIM_systems_vector</a>[index];
<a name="l02633"></a>02633 }
<a name="l02634"></a>02634 
<a name="l02635"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a2a8e92bd42f6ea347ef9c82b595648ac">02635</a> std::vector&lt;Number&gt; <a class="code" href="classlibMesh_1_1RBSystem.php#a2a8e92bd42f6ea347ef9c82b595648ac">RBSystem::evaluate_current_EIM_function</a>(<a class="code" href="classlibMesh_1_1Elem.php">Elem</a>&amp; element, <span class="keyword">const</span> std::vector&lt;Point&gt;&amp; qpoints)
<a name="l02636"></a>02636 {
<a name="l02637"></a>02637   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a9343f08e1c88fd8a6eb290038383ae6d">current_EIM_system</a>-&gt;<a class="code" href="classlibMesh_1_1RBEIMSystem.php#a3c90ab10e1378d26ea0db2094ad37f17">evaluate_current_affine_function</a>(element, qpoints);
<a name="l02638"></a>02638 }
<a name="l02639"></a>02639 
<a name="l02640"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a1b3f04b60e3464d779c140c280e1010e">02640</a> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>* <a class="code" href="classlibMesh_1_1RBSystem.php#a1b3f04b60e3464d779c140c280e1010e">RBSystem::get_F_q</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q)
<a name="l02641"></a>02641 {
<a name="l02642"></a>02642   <span class="keywordflow">if</span>(q &gt;= <a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>())
<a name="l02643"></a>02643   {
<a name="l02644"></a>02644     <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error: We must have q &lt; Q_f in get_F_q.&quot;</span>
<a name="l02645"></a>02645                  &lt;&lt; std::endl;
<a name="l02646"></a>02646     libmesh_error();
<a name="l02647"></a>02647   }
<a name="l02648"></a>02648 
<a name="l02649"></a>02649   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a6c86729bd0f4556a8574e3638282fc01">F_q_vector</a>[q];
<a name="l02650"></a>02650 }
<a name="l02651"></a>02651 
<a name="l02652"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a956b276ef7de8606c78698fcfa338343">02652</a> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>* <a class="code" href="classlibMesh_1_1RBSystem.php#a956b276ef7de8606c78698fcfa338343">RBSystem::get_output_vector</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_l)
<a name="l02653"></a>02653 {
<a name="l02654"></a>02654   <span class="keywordflow">if</span>( (n &gt;= <a class="code" href="classlibMesh_1_1RBSystem.php#a80b9e06a7c60b3bb2f5870b0ff66a2ca">get_n_outputs</a>()) || (q_l &gt;= <a class="code" href="classlibMesh_1_1RBSystem.php#ab7f0b2268a9716189225e0446b519911">get_Q_l</a>(n)) )
<a name="l02655"></a>02655   {
<a name="l02656"></a>02656     <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error: We must have n &lt; n_outputs and &quot;</span>
<a name="l02657"></a>02657                  &lt;&lt; <span class="stringliteral">&quot;q_l &lt; get_Q_l(n) in get_output_vector.&quot;</span>
<a name="l02658"></a>02658                  &lt;&lt; std::endl;
<a name="l02659"></a>02659     libmesh_error();
<a name="l02660"></a>02660   }
<a name="l02661"></a>02661 
<a name="l02662"></a>02662   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a3060a5cc6031acfef4808df71e3eda08">outputs_vector</a>[n][q_l];
<a name="l02663"></a>02663 }
<a name="l02664"></a>02664 
<a name="l02665"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a85c25bbd66bed6e4111e44566e91b5ff">02665</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a85c25bbd66bed6e4111e44566e91b5ff">RBSystem::zero_dirichlet_dofs_on_rhs</a>()
<a name="l02666"></a>02666 {
<a name="l02667"></a>02667   START_LOG(<span class="stringliteral">&quot;zero_dirichlet_dofs_on_rhs()&quot;</span>, <span class="stringliteral">&quot;RBSystem&quot;</span>);
<a name="l02668"></a>02668 
<a name="l02669"></a>02669   this-&gt;<a class="code" href="classlibMesh_1_1RBSystem.php#a002530dbacbc566d7c86bad54ee1138d">zero_dirichlet_dofs_on_vector</a>(*<a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a>);
<a name="l02670"></a>02670 
<a name="l02671"></a>02671   STOP_LOG(<span class="stringliteral">&quot;zero_dirichlet_dofs_on_rhs()&quot;</span>, <span class="stringliteral">&quot;RBSystem&quot;</span>);
<a name="l02672"></a>02672 }
<a name="l02673"></a>02673 
<a name="l02674"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a002530dbacbc566d7c86bad54ee1138d">02674</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a002530dbacbc566d7c86bad54ee1138d">RBSystem::zero_dirichlet_dofs_on_vector</a>(<a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>&amp; temp)
<a name="l02675"></a>02675 {
<a name="l02676"></a>02676   START_LOG(<span class="stringliteral">&quot;zero_dirichlet_dofs_on_vector()&quot;</span>, <span class="stringliteral">&quot;RBSystem&quot;</span>);
<a name="l02677"></a>02677 
<a name="l02678"></a>02678   std::set&lt;unsigned int&gt;::iterator iter     = <a class="code" href="classlibMesh_1_1RBBase.php#a1882c0df8f854a52376363461d402b76">global_dirichlet_dofs_set</a>.begin();
<a name="l02679"></a>02679   std::set&lt;unsigned int&gt;::iterator iter_end = <a class="code" href="classlibMesh_1_1RBBase.php#a1882c0df8f854a52376363461d402b76">global_dirichlet_dofs_set</a>.end();
<a name="l02680"></a>02680 
<a name="l02681"></a>02681   <a class="code" href="classlibMesh_1_1DofMap.php">DofMap</a>&amp; dof_map = this-&gt;<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>();
<a name="l02682"></a>02682   <span class="keywordflow">for</span> ( ; iter != iter_end; ++iter)
<a name="l02683"></a>02683   {
<a name="l02684"></a>02684     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index = *iter;
<a name="l02685"></a>02685     <span class="keywordflow">if</span>( (dof_map.<a class="code" href="classlibMesh_1_1DofMap.php#ad2b15648e708f656a798bd642c3ca8e3">first_dof</a>() &lt;= index) &amp;&amp; (index &lt; dof_map.<a class="code" href="classlibMesh_1_1DofMap.php#abf250ac3decfedbe00ddaeef85ed4de4">end_dof</a>()) )
<a name="l02686"></a>02686       temp.<a class="code" href="classlibMesh_1_1NumericVector.php#a51bd7e4c6afb223573ec051777133c9b">set</a>(index, 0.);
<a name="l02687"></a>02687   }
<a name="l02688"></a>02688   temp.<a class="code" href="classlibMesh_1_1NumericVector.php#a42ea91bba70b3e7b27dad2a636ad31ae">close</a>();
<a name="l02689"></a>02689 
<a name="l02690"></a>02690   STOP_LOG(<span class="stringliteral">&quot;zero_dirichlet_dofs_on_vector()&quot;</span>, <span class="stringliteral">&quot;RBSystem&quot;</span>);
<a name="l02691"></a>02691 }
<a name="l02692"></a>02692 
<a name="l02693"></a>02693 
<a name="l02694"></a>02694 
<a name="l02695"></a>02695 
<a name="l02696"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a9382ee8b327d3e7db7e867d9cfb24fc2">02696</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a9382ee8b327d3e7db7e867d9cfb24fc2">RBSystem::write_offline_data_to_files</a>(<span class="keyword">const</span> std::string&amp; directory_name)
<a name="l02697"></a>02697 {
<a name="l02698"></a>02698   START_LOG(<span class="stringliteral">&quot;write_offline_data_to_files()&quot;</span>, <span class="stringliteral">&quot;RBSystem&quot;</span>);
<a name="l02699"></a>02699 
<a name="l02700"></a>02700   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> precision_level = 14;
<a name="l02701"></a>02701 
<a name="l02702"></a>02702   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_bfs = <a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>();
<a name="l02703"></a>02703   libmesh_assert( n_bfs &lt;= <a class="code" href="classlibMesh_1_1RBSystem.php#ab47d6a963c4f68b5a3d1eea7905257f5">Nmax</a> );
<a name="l02704"></a>02704 
<a name="l02705"></a>02705   <span class="keywordflow">if</span>(<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l02706"></a>02706   {
<a name="l02707"></a>02707 
<a name="l02708"></a>02708     <span class="comment">// Make a directory to store all the data files</span>
<a name="l02709"></a>02709     <span class="keywordflow">if</span>( mkdir(directory_name.c_str(), 0777) == -1)
<a name="l02710"></a>02710     {
<a name="l02711"></a>02711       <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;In RBSystem::write_offline_data_to_files, directory &quot;</span>
<a name="l02712"></a>02712                    &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot; already exists, overwriting contents.&quot;</span> &lt;&lt; std::endl;
<a name="l02713"></a>02713     }
<a name="l02714"></a>02714 
<a name="l02715"></a>02715     <span class="comment">// First, write out how many basis functions we have generated</span>
<a name="l02716"></a>02716     {
<a name="l02717"></a>02717       std::ofstream n_bfs_out;
<a name="l02718"></a>02718       {
<a name="l02719"></a>02719         <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l02720"></a>02720         file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/n_bfs.dat&quot;</span>;
<a name="l02721"></a>02721         n_bfs_out.open(file_name.str().c_str());
<a name="l02722"></a>02722       }
<a name="l02723"></a>02723       <span class="keywordflow">if</span> ( !n_bfs_out.good() )
<a name="l02724"></a>02724       {
<a name="l02725"></a>02725         <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening n_bfs.dat&quot;</span> &lt;&lt; std::endl;
<a name="l02726"></a>02726         libmesh_error();
<a name="l02727"></a>02727       }
<a name="l02728"></a>02728       n_bfs_out &lt;&lt; n_bfs;
<a name="l02729"></a>02729       n_bfs_out.close();
<a name="l02730"></a>02730     }
<a name="l02731"></a>02731 
<a name="l02732"></a>02732     <span class="comment">// Also, write out the greedily selected parameters</span>
<a name="l02733"></a>02733     {
<a name="l02734"></a>02734       std::ofstream greedy_params_out;
<a name="l02735"></a>02735       {
<a name="l02736"></a>02736         <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l02737"></a>02737         file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/greedy_params.dat&quot;</span>;
<a name="l02738"></a>02738         greedy_params_out.open(file_name.str().c_str());
<a name="l02739"></a>02739       }
<a name="l02740"></a>02740       <span class="keywordflow">if</span> ( !greedy_params_out.good() )
<a name="l02741"></a>02741       {
<a name="l02742"></a>02742         <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening greedy_params.dat&quot;</span> &lt;&lt; std::endl;
<a name="l02743"></a>02743         libmesh_error();
<a name="l02744"></a>02744       }
<a name="l02745"></a>02745       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#a9dd1607766f97d79b0abcfcf37193a11">greedy_param_list</a>.size(); i++)
<a name="l02746"></a>02746       {
<a name="l02747"></a>02747         <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;<a class="code" href="classlibMesh_1_1RBBase.php#a2c3f951cf69b5da83a67734be6b01972">get_n_params</a>(); j++)
<a name="l02748"></a>02748         {
<a name="l02749"></a>02749           greedy_params_out &lt;&lt; <a class="code" href="classlibMesh_1_1RBSystem.php#a9dd1607766f97d79b0abcfcf37193a11">greedy_param_list</a>[i][j] &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l02750"></a>02750         }
<a name="l02751"></a>02751         greedy_params_out &lt;&lt; std::endl;
<a name="l02752"></a>02752       }
<a name="l02753"></a>02753       greedy_params_out.close();
<a name="l02754"></a>02754     }
<a name="l02755"></a>02755 
<a name="l02756"></a>02756     <span class="comment">// Write out output data</span>
<a name="l02757"></a>02757     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#a80b9e06a7c60b3bb2f5870b0ff66a2ca">get_n_outputs</a>(); n++)
<a name="l02758"></a>02758     {
<a name="l02759"></a>02759       std::ofstream output_dual_norms_out;
<a name="l02760"></a>02760       {
<a name="l02761"></a>02761         <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l02762"></a>02762         file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/output_&quot;</span>;
<a name="l02763"></a>02763         OSSRealzeroright(file_name,3,0,n);
<a name="l02764"></a>02764         file_name &lt;&lt; <span class="stringliteral">&quot;_dual_norms.dat&quot;</span>;
<a name="l02765"></a>02765         output_dual_norms_out.open(file_name.str().c_str());
<a name="l02766"></a>02766       }
<a name="l02767"></a>02767       <span class="keywordflow">if</span> ( !output_dual_norms_out.good() )
<a name="l02768"></a>02768       {
<a name="l02769"></a>02769         <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening output &quot;</span> &lt;&lt; n &lt;&lt; <span class="stringliteral">&quot; dual norms file&quot;</span> &lt;&lt; std::endl;
<a name="l02770"></a>02770         libmesh_error();
<a name="l02771"></a>02771       }
<a name="l02772"></a>02772       output_dual_norms_out.precision(precision_level);
<a name="l02773"></a>02773       
<a name="l02774"></a>02774       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Q_l_hat = <a class="code" href="classlibMesh_1_1RBSystem.php#ab7f0b2268a9716189225e0446b519911">get_Q_l</a>(n)*(<a class="code" href="classlibMesh_1_1RBSystem.php#ab7f0b2268a9716189225e0446b519911">get_Q_l</a>(n)+1)/2;
<a name="l02775"></a>02775       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q=0; q&lt;Q_l_hat; q++)
<a name="l02776"></a>02776       {
<a name="l02777"></a>02777         output_dual_norms_out &lt;&lt; std::scientific &lt;&lt; <a class="code" href="classlibMesh_1_1RBSystem.php#a2e3592b7167280ef4dd92cfb4a131c62">output_dual_norms</a>[n][q] &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l02778"></a>02778       }
<a name="l02779"></a>02779       output_dual_norms_out.close();
<a name="l02780"></a>02780       
<a name="l02781"></a>02781       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_l=0; q_l&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#ab7f0b2268a9716189225e0446b519911">get_Q_l</a>(n); q_l++)
<a name="l02782"></a>02782       {
<a name="l02783"></a>02783         std::ofstream output_n_out;
<a name="l02784"></a>02784         {
<a name="l02785"></a>02785           <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l02786"></a>02786           file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/output_&quot;</span>;
<a name="l02787"></a>02787           OSSRealzeroright(file_name,3,0,n);
<a name="l02788"></a>02788           file_name &lt;&lt; <span class="stringliteral">&quot;_&quot;</span>;
<a name="l02789"></a>02789           OSSRealzeroright(file_name,3,0,q_l);
<a name="l02790"></a>02790           file_name &lt;&lt; <span class="stringliteral">&quot;.dat&quot;</span>;
<a name="l02791"></a>02791           output_n_out.open(file_name.str().c_str());
<a name="l02792"></a>02792         }
<a name="l02793"></a>02793         <span class="keywordflow">if</span>( !output_n_out.good() )
<a name="l02794"></a>02794         {
<a name="l02795"></a>02795           <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening output file for output &quot;</span> &lt;&lt; n &lt;&lt; std::endl;
<a name="l02796"></a>02796           libmesh_error();
<a name="l02797"></a>02797         }
<a name="l02798"></a>02798         output_n_out.precision(precision_level);
<a name="l02799"></a>02799 
<a name="l02800"></a>02800         <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;n_bfs; j++)
<a name="l02801"></a>02801         {
<a name="l02802"></a>02802           output_n_out &lt;&lt; std::scientific &lt;&lt; <a class="code" href="classlibMesh_1_1RBSystem.php#ab868a08069961fcde36a760e0094708a">RB_output_vectors</a>[n][q_l](j) &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l02803"></a>02803         }
<a name="l02804"></a>02804         output_n_out.close();
<a name="l02805"></a>02805       }
<a name="l02806"></a>02806     }
<a name="l02807"></a>02807     
<a name="l02808"></a>02808     <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBSystem.php#a52ba5c957ff8b7f85ae16707df632b67">compute_RB_inner_product</a>)
<a name="l02809"></a>02809     {
<a name="l02810"></a>02810       <span class="comment">// Next write out the inner product matrix</span>
<a name="l02811"></a>02811       std::ofstream RB_inner_product_matrix_out;
<a name="l02812"></a>02812       {
<a name="l02813"></a>02813         <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l02814"></a>02814         file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/RB_inner_product_matrix.dat&quot;</span>;
<a name="l02815"></a>02815         RB_inner_product_matrix_out.open(file_name.str().c_str());
<a name="l02816"></a>02816       }
<a name="l02817"></a>02817       <span class="keywordflow">if</span> ( !RB_inner_product_matrix_out.good() )
<a name="l02818"></a>02818       {
<a name="l02819"></a>02819         <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening RB_inner_product_matrix.dat&quot;</span> &lt;&lt; std::endl;
<a name="l02820"></a>02820         libmesh_error();
<a name="l02821"></a>02821       }
<a name="l02822"></a>02822       RB_inner_product_matrix_out.precision(precision_level);
<a name="l02823"></a>02823       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_bfs; i++)
<a name="l02824"></a>02824       {
<a name="l02825"></a>02825         <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;n_bfs; j++)
<a name="l02826"></a>02826         {
<a name="l02827"></a>02827           RB_inner_product_matrix_out &lt;&lt; std::scientific
<a name="l02828"></a>02828             &lt;&lt; <a class="code" href="classlibMesh_1_1RBSystem.php#a5aeb48dc4ed2a429e89bdeffdd1f1564">RB_inner_product_matrix</a>(i,j) &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l02829"></a>02829         }
<a name="l02830"></a>02830       }
<a name="l02831"></a>02831       RB_inner_product_matrix_out.close();
<a name="l02832"></a>02832     }
<a name="l02833"></a>02833 
<a name="l02834"></a>02834     <span class="comment">// Next write out the F_q vectors</span>
<a name="l02835"></a>02835     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_f=0; q_f&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>(); q_f++)
<a name="l02836"></a>02836     {
<a name="l02837"></a>02837       <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l02838"></a>02838       file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/RB_F_&quot;</span>;
<a name="l02839"></a>02839       OSSRealzeroright(file_name,3,0,q_f);
<a name="l02840"></a>02840       file_name &lt;&lt; <span class="stringliteral">&quot;.dat&quot;</span>;
<a name="l02841"></a>02841       std::ofstream RB_F_q_f_out(file_name.str().c_str());
<a name="l02842"></a>02842 
<a name="l02843"></a>02843       <span class="keywordflow">if</span> ( !RB_F_q_f_out.good() )
<a name="l02844"></a>02844       {
<a name="l02845"></a>02845         <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening RB_F_&quot;</span> &lt;&lt; q_f &lt;&lt; <span class="stringliteral">&quot;.dat&quot;</span> &lt;&lt; std::endl;
<a name="l02846"></a>02846         libmesh_error();
<a name="l02847"></a>02847       }
<a name="l02848"></a>02848 
<a name="l02849"></a>02849       RB_F_q_f_out.precision(precision_level);
<a name="l02850"></a>02850       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_bfs; i++)
<a name="l02851"></a>02851       {
<a name="l02852"></a>02852         RB_F_q_f_out &lt;&lt; std::scientific &lt;&lt; <a class="code" href="classlibMesh_1_1RBSystem.php#ac2da8c5c36be49686429e74b4f9def1c">RB_F_q_vector</a>[q_f](i) &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l02853"></a>02853       }
<a name="l02854"></a>02854       RB_F_q_f_out.close();
<a name="l02855"></a>02855     }
<a name="l02856"></a>02856 
<a name="l02857"></a>02857     <span class="comment">// Next write out the A_q matrices</span>
<a name="l02858"></a>02858     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_a=0; q_a&lt;<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>(); q_a++)
<a name="l02859"></a>02859     {
<a name="l02860"></a>02860       <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l02861"></a>02861       file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/RB_A_&quot;</span>;
<a name="l02862"></a>02862       OSSRealzeroright(file_name,3,0,q_a);
<a name="l02863"></a>02863       file_name &lt;&lt; <span class="stringliteral">&quot;.dat&quot;</span>;
<a name="l02864"></a>02864       std::ofstream RB_A_q_a_out(file_name.str().c_str());
<a name="l02865"></a>02865 
<a name="l02866"></a>02866       <span class="keywordflow">if</span> ( !RB_A_q_a_out.good() )
<a name="l02867"></a>02867       {
<a name="l02868"></a>02868         <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening RB_A_&quot;</span> &lt;&lt; q_a &lt;&lt; <span class="stringliteral">&quot;.dat&quot;</span> &lt;&lt; std::endl;
<a name="l02869"></a>02869         libmesh_error();
<a name="l02870"></a>02870       }
<a name="l02871"></a>02871 
<a name="l02872"></a>02872       RB_A_q_a_out.precision(precision_level);
<a name="l02873"></a>02873       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_bfs; i++)
<a name="l02874"></a>02874       {
<a name="l02875"></a>02875         <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;n_bfs; j++)
<a name="l02876"></a>02876         {
<a name="l02877"></a>02877           RB_A_q_a_out &lt;&lt; std::scientific &lt;&lt; <a class="code" href="classlibMesh_1_1RBSystem.php#adadaf9a427ffbace640455436a4d4b26">RB_A_q_vector</a>[q_a](i,j) &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l02878"></a>02878         }
<a name="l02879"></a>02879       }
<a name="l02880"></a>02880       RB_A_q_a_out.close();
<a name="l02881"></a>02881     }
<a name="l02882"></a>02882 
<a name="l02883"></a>02883 
<a name="l02884"></a>02884     <span class="comment">// Next write out F_q representor norm data</span>
<a name="l02885"></a>02885     std::ofstream RB_Fq_norms_out;
<a name="l02886"></a>02886     {
<a name="l02887"></a>02887       <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l02888"></a>02888       file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/Fq_norms.dat&quot;</span>;
<a name="l02889"></a>02889       RB_Fq_norms_out.open(file_name.str().c_str());
<a name="l02890"></a>02890     }
<a name="l02891"></a>02891     <span class="keywordflow">if</span> ( !RB_Fq_norms_out.good() )
<a name="l02892"></a>02892     {
<a name="l02893"></a>02893       <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening Fq_norms.dat&quot;</span> &lt;&lt; std::endl;
<a name="l02894"></a>02894       libmesh_error();
<a name="l02895"></a>02895     }
<a name="l02896"></a>02896     RB_Fq_norms_out.precision(precision_level);
<a name="l02897"></a>02897     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Q_f_hat = <a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>()*(<a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>()+1)/2;
<a name="l02898"></a>02898     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;Q_f_hat; i++)
<a name="l02899"></a>02899     {
<a name="l02900"></a>02900       RB_Fq_norms_out &lt;&lt; std::scientific &lt;&lt; <a class="code" href="classlibMesh_1_1RBSystem.php#a567c86950bb6d2ab2800ac0b14ed3dd2">Fq_representor_norms</a>[i] &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l02901"></a>02901     }
<a name="l02902"></a>02902     RB_Fq_norms_out.close();
<a name="l02903"></a>02903 
<a name="l02904"></a>02904     <span class="comment">// Next write out Fq_Aq representor norm data</span>
<a name="l02905"></a>02905     std::ofstream RB_Fq_Aq_norms_out;
<a name="l02906"></a>02906     {
<a name="l02907"></a>02907       <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l02908"></a>02908       file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/Fq_Aq_norms.dat&quot;</span>;
<a name="l02909"></a>02909       RB_Fq_Aq_norms_out.open(file_name.str().c_str());
<a name="l02910"></a>02910     }
<a name="l02911"></a>02911     <span class="keywordflow">if</span> ( !RB_Fq_Aq_norms_out.good() )
<a name="l02912"></a>02912     {
<a name="l02913"></a>02913       <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening Fq_Aq_norms.dat&quot;</span> &lt;&lt; std::endl;
<a name="l02914"></a>02914       libmesh_error();
<a name="l02915"></a>02915     }
<a name="l02916"></a>02916     RB_Fq_Aq_norms_out.precision(precision_level);
<a name="l02917"></a>02917     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_f=0; q_f&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>(); q_f++)
<a name="l02918"></a>02918     {
<a name="l02919"></a>02919       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_a=0; q_a&lt;<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>(); q_a++)
<a name="l02920"></a>02920       {
<a name="l02921"></a>02921         <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_bfs; i++)
<a name="l02922"></a>02922         {
<a name="l02923"></a>02923           RB_Fq_Aq_norms_out &lt;&lt; std::scientific &lt;&lt; <a class="code" href="classlibMesh_1_1RBSystem.php#ac3d546a3eaa362377494da087e711608">Fq_Aq_representor_norms</a>[q_f][q_a][i] &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l02924"></a>02924         }
<a name="l02925"></a>02925       }
<a name="l02926"></a>02926     }
<a name="l02927"></a>02927     RB_Fq_Aq_norms_out.close();
<a name="l02928"></a>02928 
<a name="l02929"></a>02929     <span class="comment">// Next write out Aq_Aq representor norm data</span>
<a name="l02930"></a>02930     std::ofstream RB_Aq_Aq_norms_out;
<a name="l02931"></a>02931     {
<a name="l02932"></a>02932       <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l02933"></a>02933       file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/Aq_Aq_norms.dat&quot;</span>;
<a name="l02934"></a>02934       RB_Aq_Aq_norms_out.open(file_name.str().c_str());
<a name="l02935"></a>02935     }
<a name="l02936"></a>02936     <span class="keywordflow">if</span> ( !RB_Aq_Aq_norms_out.good() )
<a name="l02937"></a>02937     {
<a name="l02938"></a>02938       <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening Aq_Aq_norms.dat&quot;</span> &lt;&lt; std::endl;
<a name="l02939"></a>02939       libmesh_error();
<a name="l02940"></a>02940     }
<a name="l02941"></a>02941     RB_Aq_Aq_norms_out.precision(precision_level);
<a name="l02942"></a>02942     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Q_a_hat = <a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>()*(<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>()+1)/2;
<a name="l02943"></a>02943     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;Q_a_hat; i++)
<a name="l02944"></a>02944     {
<a name="l02945"></a>02945       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;n_bfs; j++)
<a name="l02946"></a>02946       {
<a name="l02947"></a>02947         <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> l=0; l&lt;n_bfs; l++)
<a name="l02948"></a>02948         {
<a name="l02949"></a>02949           RB_Aq_Aq_norms_out &lt;&lt; std::scientific &lt;&lt; <a class="code" href="classlibMesh_1_1RBSystem.php#a668fed2dcb2e98adb2e7eea5bc7d853e">Aq_Aq_representor_norms</a>[i][j][l] &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l02950"></a>02950         }
<a name="l02951"></a>02951       }
<a name="l02952"></a>02952     }
<a name="l02953"></a>02953     RB_Aq_Aq_norms_out.close();
<a name="l02954"></a>02954 
<a name="l02955"></a>02955   }
<a name="l02956"></a>02956 
<a name="l02957"></a>02957   <span class="comment">// Now write out the basis functions if requested</span>
<a name="l02958"></a>02958   <a class="code" href="classlibMesh_1_1RBSystem.php#a3e76f211b8f215f86e8d96c0d371e3d8">write_out_basis_functions</a>(directory_name, precision_level);
<a name="l02959"></a>02959 
<a name="l02960"></a>02960   <span class="comment">// Write out residual representors if requested</span>
<a name="l02961"></a>02961   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1RBSystem.php#a5ac870aac52f838bd28ee088ddc095b0">store_representors</a>)
<a name="l02962"></a>02962     {
<a name="l02963"></a>02963       <span class="comment">// Write out F_q_representors.  These are useful to have when restarting,</span>
<a name="l02964"></a>02964       <span class="comment">// so you don&#39;t have to recompute them all over again.  There should be</span>
<a name="l02965"></a>02965       <span class="comment">// Q_f of these.</span>
<a name="l02966"></a>02966       <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1RBSystem.php#adec856bc209f0533639d76767bd5ebbc">quiet</a>)
<a name="l02967"></a>02967         <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Writing out the F_q_representors...&quot;</span> &lt;&lt; std::endl;
<a name="l02968"></a>02968 
<a name="l02969"></a>02969       std::ostringstream file_name;
<a name="l02970"></a>02970       <span class="keyword">const</span> std::string residual_representor_suffix = (<a class="code" href="classlibMesh_1_1RBSystem.php#a399f7ee60adcc350ce7f27e8c60ed9de">write_binary_residual_representors</a> ? <span class="stringliteral">&quot;.xdr&quot;</span> : <span class="stringliteral">&quot;.dat&quot;</span>);
<a name="l02971"></a>02971       <span class="keyword">struct </span>stat stat_info;
<a name="l02972"></a>02972 
<a name="l02973"></a>02973       <span class="comment">// Residual representors written out to their own separate directory</span>
<a name="l02974"></a>02974       std::string residual_representors_dir = <span class="stringliteral">&quot;residual_representors&quot;</span>;
<a name="l02975"></a>02975       <span class="keywordflow">if</span> ( <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l02976"></a>02976         <span class="keywordflow">if</span> ( mkdir(residual_representors_dir.c_str(), 0755) != 0)
<a name="l02977"></a>02977           <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Skipping creating residual_representors directory: &quot;</span> &lt;&lt; strerror(errno) &lt;&lt; std::endl;
<a name="l02978"></a>02978 
<a name="l02979"></a>02979       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#acd91cfaa84058427cda2885e4d6d30ce">F_q_representor</a>.size(); ++i)
<a name="l02980"></a>02980         {
<a name="l02981"></a>02981           <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1RBSystem.php#acd91cfaa84058427cda2885e4d6d30ce">F_q_representor</a>[i] != NULL)
<a name="l02982"></a>02982             {
<a name="l02983"></a>02983 
<a name="l02984"></a>02984               file_name.str(<span class="stringliteral">&quot;&quot;</span>); <span class="comment">// reset filename</span>
<a name="l02985"></a>02985               file_name &lt;&lt; residual_representors_dir &lt;&lt; <span class="stringliteral">&quot;/F_q_representor&quot;</span> &lt;&lt; i &lt;&lt; residual_representor_suffix;
<a name="l02986"></a>02986 
<a name="l02987"></a>02987               <span class="comment">// Check to see if file exists, if so, don&#39;t overwrite it, we assume it was</span>
<a name="l02988"></a>02988               <span class="comment">// there from a previous call to this function.  Note: if stat returns zero</span>
<a name="l02989"></a>02989               <span class="comment">// it means it successfully got the file attributes (and therefore the file</span>
<a name="l02990"></a>02990               <span class="comment">// exists).  Because of the following factors:</span>
<a name="l02991"></a>02991               <span class="comment">// 1.) write_serialized_data takes longer for proc 0 than it does for others,</span>
<a name="l02992"></a>02992               <span class="comment">//     so processors can get out of sync.</span>
<a name="l02993"></a>02993               <span class="comment">// 2.) The constructor for Xdr opens a (0 length) file on *all* processors,</span>
<a name="l02994"></a>02994               <span class="comment">// there are typically hundreds of 0-length files created during this loop,</span>
<a name="l02995"></a>02995               <span class="comment">// and that screws up checking for the existence of files.  One way to stay</span>
<a name="l02996"></a>02996               <span class="comment">// in sync is to but a barrier at each iteration of the loop -- not sure how</span>
<a name="l02997"></a>02997               <span class="comment">// bad this will affect performance, but it can&#39;t be much worse than serialized</span>
<a name="l02998"></a>02998               <span class="comment">// I/O already is :)</span>
<a name="l02999"></a>02999               <span class="keywordtype">int</span> stat_result = stat(file_name.str().c_str(), &amp;stat_info);
<a name="l03000"></a>03000 
<a name="l03001"></a>03001               <span class="keywordflow">if</span> ( (stat_result != 0) ||     <span class="comment">// file definitely doesn&#39;t already exist</span>
<a name="l03002"></a>03002                    (stat_info.st_size == 0)) <span class="comment">// file exists, but has zero length (can happen if another proc already opened it!)</span>
<a name="l03003"></a>03003                 {
<a name="l03004"></a>03004                   <span class="comment">// No need to copy!</span>
<a name="l03005"></a>03005                   <span class="comment">// *solution = *(F_q_representor[i]);</span>
<a name="l03006"></a>03006                   <span class="comment">// std::swap doesn&#39;t work on pointers</span>
<a name="l03007"></a>03007                   <span class="comment">//std::swap(solution.get(), F_q_representor[i]);</span>
<a name="l03008"></a>03008                   <a class="code" href="classlibMesh_1_1RBSystem.php#acd91cfaa84058427cda2885e4d6d30ce">F_q_representor</a>[i]-&gt;swap(*<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>);
<a name="l03009"></a>03009 
<a name="l03010"></a>03010                   <a class="code" href="classlibMesh_1_1Xdr.php">Xdr</a> fqr_data(file_name.str(),
<a name="l03011"></a>03011                                <a class="code" href="classlibMesh_1_1RBSystem.php#a399f7ee60adcc350ce7f27e8c60ed9de">write_binary_residual_representors</a> ? <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8ae5559170d41d912b449375bb4e3468f6">ENCODE</a> : <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a47f4bcd4fcf418da5ec74d3d8e2c3bc4">WRITE</a>);
<a name="l03012"></a>03012 
<a name="l03013"></a>03013                   <a class="code" href="classlibMesh_1_1System.php#ae8063c135acc9c54240886e1ac3c9acd">write_serialized_data</a>(fqr_data, <span class="keyword">false</span>);
<a name="l03014"></a>03014 
<a name="l03015"></a>03015                   <span class="comment">// Synchronize before moving on</span>
<a name="l03016"></a>03016                   <a class="code" href="namespacelibMesh_1_1Parallel.php#a95416053432ed0ab6d1231070bfebeff">Parallel::barrier</a>();
<a name="l03017"></a>03017 
<a name="l03018"></a>03018                   <span class="comment">// Swap back.</span>
<a name="l03019"></a>03019                   <a class="code" href="classlibMesh_1_1RBSystem.php#acd91cfaa84058427cda2885e4d6d30ce">F_q_representor</a>[i]-&gt;swap(*<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>);
<a name="l03020"></a>03020 
<a name="l03021"></a>03021                   <span class="comment">// TODO: bzip the resulting file?  See $LIBMESH_DIR/src/mesh/unstructured_mesh.C</span>
<a name="l03022"></a>03022                   <span class="comment">// for the system call, be sure to do it only on one processor, etc.</span>
<a name="l03023"></a>03023                 }
<a name="l03024"></a>03024             }
<a name="l03025"></a>03025         }
<a name="l03026"></a>03026 
<a name="l03027"></a>03027       <span class="comment">// Write out A_q_representors.  These are useful to have when restarting,</span>
<a name="l03028"></a>03028       <span class="comment">// so you don&#39;t have to recompute them all over again.  There should be</span>
<a name="l03029"></a>03029       <span class="comment">// Q_a * this-&gt;get_n_basis_functions() of these.</span>
<a name="l03030"></a>03030       <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1RBSystem.php#adec856bc209f0533639d76767bd5ebbc">quiet</a>)
<a name="l03031"></a>03031         <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Writing out the A_q_representors...&quot;</span> &lt;&lt; std::endl;
<a name="l03032"></a>03032 
<a name="l03033"></a>03033       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> jstop  = this-&gt;<a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>();
<a name="l03034"></a>03034       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> jstart = jstop-<a class="code" href="classlibMesh_1_1RBSystem.php#a36ba489bd3158bbff48a5607e1d21d30">delta_N</a>;
<a name="l03035"></a>03035       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#a9c8fb2a4cb5b77e59e36bfff438aed01">A_q_representor</a>.size(); ++i)
<a name="l03036"></a>03036         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=jstart; j&lt;jstop; ++j)
<a name="l03037"></a>03037           {
<a name="l03038"></a>03038             <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Writing out A_q_representor[&quot;</span> &lt;&lt; i &lt;&lt; <span class="stringliteral">&quot;][&quot;</span> &lt;&lt; j &lt;&lt; <span class="stringliteral">&quot;]...&quot;</span> &lt;&lt; std::endl;
<a name="l03039"></a>03039             libmesh_assert(<a class="code" href="classlibMesh_1_1RBSystem.php#a9c8fb2a4cb5b77e59e36bfff438aed01">A_q_representor</a>[i][j] != NULL);
<a name="l03040"></a>03040 
<a name="l03041"></a>03041             file_name.str(<span class="stringliteral">&quot;&quot;</span>); <span class="comment">// reset filename</span>
<a name="l03042"></a>03042             file_name &lt;&lt; residual_representors_dir
<a name="l03043"></a>03043                       &lt;&lt; <span class="stringliteral">&quot;/A_q_representor&quot;</span> &lt;&lt; i &lt;&lt; <span class="stringliteral">&quot;_&quot;</span> &lt;&lt; j &lt;&lt; residual_representor_suffix;
<a name="l03044"></a>03044 
<a name="l03045"></a>03045             {
<a name="l03046"></a>03046               <span class="comment">// No need to copy!</span>
<a name="l03047"></a>03047               <span class="comment">// *solution = *(A_q_representor[i][j]);</span>
<a name="l03048"></a>03048               <a class="code" href="classlibMesh_1_1RBSystem.php#a9c8fb2a4cb5b77e59e36bfff438aed01">A_q_representor</a>[i][j]-&gt;swap(*<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>);
<a name="l03049"></a>03049 
<a name="l03050"></a>03050               <a class="code" href="classlibMesh_1_1Xdr.php">Xdr</a> aqr_data(file_name.str(),
<a name="l03051"></a>03051                            <a class="code" href="classlibMesh_1_1RBSystem.php#a399f7ee60adcc350ce7f27e8c60ed9de">write_binary_residual_representors</a> ? <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8ae5559170d41d912b449375bb4e3468f6">ENCODE</a> : <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a47f4bcd4fcf418da5ec74d3d8e2c3bc4">WRITE</a>);
<a name="l03052"></a>03052 
<a name="l03053"></a>03053               <a class="code" href="classlibMesh_1_1System.php#ae8063c135acc9c54240886e1ac3c9acd">write_serialized_data</a>(aqr_data, <span class="keyword">false</span>);
<a name="l03054"></a>03054 
<a name="l03055"></a>03055               <span class="comment">// Synchronize before moving on</span>
<a name="l03056"></a>03056               <a class="code" href="namespacelibMesh_1_1Parallel.php#a95416053432ed0ab6d1231070bfebeff">Parallel::barrier</a>();
<a name="l03057"></a>03057 
<a name="l03058"></a>03058               <span class="comment">// Swap back.</span>
<a name="l03059"></a>03059               <a class="code" href="classlibMesh_1_1RBSystem.php#a9c8fb2a4cb5b77e59e36bfff438aed01">A_q_representor</a>[i][j]-&gt;swap(*<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>);
<a name="l03060"></a>03060 
<a name="l03061"></a>03061               <span class="comment">// TODO: bzip the resulting file?  See $LIBMESH_DIR/src/mesh/unstructured_mesh.C</span>
<a name="l03062"></a>03062               <span class="comment">// for the system call, be sure to do it only on one processor, etc.</span>
<a name="l03063"></a>03063             }
<a name="l03064"></a>03064           }
<a name="l03065"></a>03065     } <span class="comment">// end if (store_representors)</span>
<a name="l03066"></a>03066 
<a name="l03067"></a>03067   STOP_LOG(<span class="stringliteral">&quot;write_offline_data_to_files()&quot;</span>, <span class="stringliteral">&quot;RBSystem&quot;</span>);
<a name="l03068"></a>03068 }
<a name="l03069"></a>03069 
<a name="l03070"></a>03070 
<a name="l03071"></a>03071 
<a name="l03072"></a><a class="code" href="classlibMesh_1_1RBSystem.php#ad32589e604ce7562cc256741e87d7d3c">03072</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#ad32589e604ce7562cc256741e87d7d3c">RBSystem::read_offline_data_from_files</a>(<span class="keyword">const</span> std::string&amp; directory_name)
<a name="l03073"></a>03073 {
<a name="l03074"></a>03074   START_LOG(<span class="stringliteral">&quot;read_offline_data_from_files()&quot;</span>, <span class="stringliteral">&quot;RBSystem&quot;</span>);
<a name="l03075"></a>03075 
<a name="l03076"></a>03076   <span class="comment">// First, find out how many basis functions we had when Greedy terminated</span>
<a name="l03077"></a>03077   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_bfs;
<a name="l03078"></a>03078   {
<a name="l03079"></a>03079     <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l03080"></a>03080     file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/n_bfs.dat&quot;</span>;
<a name="l03081"></a>03081     std::ifstream n_bfs_in(file_name.str().c_str());
<a name="l03082"></a>03082 
<a name="l03083"></a>03083     <span class="keywordflow">if</span> ( !n_bfs_in.good() )
<a name="l03084"></a>03084     {
<a name="l03085"></a>03085       <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening n_bfs.dat&quot;</span> &lt;&lt; std::endl;
<a name="l03086"></a>03086       libmesh_error();
<a name="l03087"></a>03087     }
<a name="l03088"></a>03088 
<a name="l03089"></a>03089     n_bfs_in &gt;&gt; n_bfs;
<a name="l03090"></a>03090     n_bfs_in.close();
<a name="l03091"></a>03091   }
<a name="l03092"></a>03092   libmesh_assert( n_bfs &lt;= <a class="code" href="classlibMesh_1_1RBSystem.php#ab47d6a963c4f68b5a3d1eea7905257f5">Nmax</a> );
<a name="l03093"></a>03093 
<a name="l03094"></a>03094   <span class="comment">// Read in output data</span>
<a name="l03095"></a>03095   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#a80b9e06a7c60b3bb2f5870b0ff66a2ca">get_n_outputs</a>(); n++)
<a name="l03096"></a>03096   {
<a name="l03097"></a>03097     std::ifstream output_dual_norms_in;
<a name="l03098"></a>03098     {
<a name="l03099"></a>03099       <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l03100"></a>03100       file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/output_&quot;</span>;
<a name="l03101"></a>03101       OSSRealzeroright(file_name,3,0,n);
<a name="l03102"></a>03102       file_name &lt;&lt; <span class="stringliteral">&quot;_dual_norms.dat&quot;</span>;
<a name="l03103"></a>03103       output_dual_norms_in.open(file_name.str().c_str());
<a name="l03104"></a>03104     }
<a name="l03105"></a>03105     <span class="keywordflow">if</span> ( !output_dual_norms_in.good() )
<a name="l03106"></a>03106     {
<a name="l03107"></a>03107       <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening input &quot;</span> &lt;&lt; n &lt;&lt; <span class="stringliteral">&quot; dual norms file&quot;</span> &lt;&lt; std::endl;
<a name="l03108"></a>03108       libmesh_error();
<a name="l03109"></a>03109     }
<a name="l03110"></a>03110     
<a name="l03111"></a>03111     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Q_l_hat = <a class="code" href="classlibMesh_1_1RBSystem.php#ab7f0b2268a9716189225e0446b519911">get_Q_l</a>(n)*(<a class="code" href="classlibMesh_1_1RBSystem.php#ab7f0b2268a9716189225e0446b519911">get_Q_l</a>(n)+1)/2;
<a name="l03112"></a>03112     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q=0; q&lt;Q_l_hat; q++)
<a name="l03113"></a>03113     {
<a name="l03114"></a>03114       output_dual_norms_in &gt;&gt; <a class="code" href="classlibMesh_1_1RBSystem.php#a2e3592b7167280ef4dd92cfb4a131c62">output_dual_norms</a>[n][q];
<a name="l03115"></a>03115     }
<a name="l03116"></a>03116     output_dual_norms_in.close();
<a name="l03117"></a>03117     
<a name="l03118"></a>03118     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_l=0; q_l&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#ab7f0b2268a9716189225e0446b519911">get_Q_l</a>(n); q_l++)
<a name="l03119"></a>03119     {
<a name="l03120"></a>03120       std::ifstream output_n_in;
<a name="l03121"></a>03121       {
<a name="l03122"></a>03122         <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l03123"></a>03123         file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/output_&quot;</span>;
<a name="l03124"></a>03124         OSSRealzeroright(file_name,3,0,n);
<a name="l03125"></a>03125         file_name &lt;&lt; <span class="stringliteral">&quot;_&quot;</span>;
<a name="l03126"></a>03126         OSSRealzeroright(file_name,3,0,q_l);
<a name="l03127"></a>03127         file_name &lt;&lt; <span class="stringliteral">&quot;.dat&quot;</span>;
<a name="l03128"></a>03128         output_n_in.open(file_name.str().c_str());
<a name="l03129"></a>03129       }
<a name="l03130"></a>03130       <span class="keywordflow">if</span>( !output_n_in.good() )
<a name="l03131"></a>03131       {
<a name="l03132"></a>03132         <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening input file for output &quot;</span> &lt;&lt; n &lt;&lt; std::endl;
<a name="l03133"></a>03133         libmesh_error();
<a name="l03134"></a>03134       }
<a name="l03135"></a>03135 
<a name="l03136"></a>03136       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;n_bfs; j++)
<a name="l03137"></a>03137       {
<a name="l03138"></a>03138         <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a>  value;
<a name="l03139"></a>03139         output_n_in &gt;&gt; value;
<a name="l03140"></a>03140         <a class="code" href="classlibMesh_1_1RBSystem.php#ab868a08069961fcde36a760e0094708a">RB_output_vectors</a>[n][q_l](j) = value;
<a name="l03141"></a>03141       }
<a name="l03142"></a>03142       output_n_in.close();
<a name="l03143"></a>03143     }
<a name="l03144"></a>03144   }
<a name="l03145"></a>03145   
<a name="l03146"></a>03146   <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBSystem.php#a52ba5c957ff8b7f85ae16707df632b67">compute_RB_inner_product</a>)
<a name="l03147"></a>03147   {
<a name="l03148"></a>03148     <span class="comment">// Next read in the inner product matrix</span>
<a name="l03149"></a>03149     std::ifstream RB_inner_product_matrix_in;
<a name="l03150"></a>03150     {
<a name="l03151"></a>03151       <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l03152"></a>03152       file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/RB_inner_product_matrix.dat&quot;</span>;
<a name="l03153"></a>03153       RB_inner_product_matrix_in.open(file_name.str().c_str());
<a name="l03154"></a>03154     }
<a name="l03155"></a>03155     <span class="keywordflow">if</span> ( !RB_inner_product_matrix_in.good() )
<a name="l03156"></a>03156     {
<a name="l03157"></a>03157       <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening RB_inner_product_matrix.dat&quot;</span> &lt;&lt; std::endl;
<a name="l03158"></a>03158       libmesh_error();
<a name="l03159"></a>03159     }
<a name="l03160"></a>03160     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_bfs; i++)
<a name="l03161"></a>03161     {
<a name="l03162"></a>03162       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;n_bfs; j++)
<a name="l03163"></a>03163       {
<a name="l03164"></a>03164         <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> value;
<a name="l03165"></a>03165         RB_inner_product_matrix_in &gt;&gt; value;
<a name="l03166"></a>03166         <a class="code" href="classlibMesh_1_1RBSystem.php#a5aeb48dc4ed2a429e89bdeffdd1f1564">RB_inner_product_matrix</a>(i,j) = value;
<a name="l03167"></a>03167       }
<a name="l03168"></a>03168     }
<a name="l03169"></a>03169     RB_inner_product_matrix_in.close();
<a name="l03170"></a>03170   }
<a name="l03171"></a>03171 
<a name="l03172"></a>03172   <span class="comment">// Next read in the F_q vectors</span>
<a name="l03173"></a>03173   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_f=0; q_f&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>(); q_f++)
<a name="l03174"></a>03174   {
<a name="l03175"></a>03175     <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l03176"></a>03176     file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/RB_F_&quot;</span>;
<a name="l03177"></a>03177     OSSRealzeroright(file_name,3,0,q_f);
<a name="l03178"></a>03178     file_name &lt;&lt; <span class="stringliteral">&quot;.dat&quot;</span>;
<a name="l03179"></a>03179     std::ifstream RB_F_q_f_in(file_name.str().c_str());
<a name="l03180"></a>03180 
<a name="l03181"></a>03181     <span class="keywordflow">if</span> ( !RB_F_q_f_in.good() )
<a name="l03182"></a>03182     {
<a name="l03183"></a>03183       <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening RB_F_&quot;</span> &lt;&lt; q_f &lt;&lt; <span class="stringliteral">&quot;.dat&quot;</span> &lt;&lt; std::endl;
<a name="l03184"></a>03184       libmesh_error();
<a name="l03185"></a>03185     }
<a name="l03186"></a>03186 
<a name="l03187"></a>03187     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_bfs; i++)
<a name="l03188"></a>03188     {
<a name="l03189"></a>03189       <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a>  value;
<a name="l03190"></a>03190       RB_F_q_f_in &gt;&gt; value;
<a name="l03191"></a>03191       <a class="code" href="classlibMesh_1_1RBSystem.php#ac2da8c5c36be49686429e74b4f9def1c">RB_F_q_vector</a>[q_f](i) = value;
<a name="l03192"></a>03192     }
<a name="l03193"></a>03193     RB_F_q_f_in.close();
<a name="l03194"></a>03194   }
<a name="l03195"></a>03195 
<a name="l03196"></a>03196   <span class="comment">// Next read in the A_q matrices</span>
<a name="l03197"></a>03197   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_a=0; q_a&lt;<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>(); q_a++)
<a name="l03198"></a>03198   {
<a name="l03199"></a>03199     <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l03200"></a>03200     file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/RB_A_&quot;</span>;
<a name="l03201"></a>03201     OSSRealzeroright(file_name,3,0,q_a);
<a name="l03202"></a>03202     file_name &lt;&lt; <span class="stringliteral">&quot;.dat&quot;</span>;
<a name="l03203"></a>03203     std::ifstream RB_A_q_a_in(file_name.str().c_str());
<a name="l03204"></a>03204 
<a name="l03205"></a>03205     <span class="keywordflow">if</span> ( !RB_A_q_a_in.good() )
<a name="l03206"></a>03206     {
<a name="l03207"></a>03207       <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening RB_A_&quot;</span> &lt;&lt; q_a &lt;&lt; <span class="stringliteral">&quot;.dat&quot;</span> &lt;&lt; std::endl;
<a name="l03208"></a>03208       libmesh_error();
<a name="l03209"></a>03209     }
<a name="l03210"></a>03210 
<a name="l03211"></a>03211     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_bfs; i++)
<a name="l03212"></a>03212     {
<a name="l03213"></a>03213       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;n_bfs; j++)
<a name="l03214"></a>03214       {
<a name="l03215"></a>03215         <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a>  value;
<a name="l03216"></a>03216         RB_A_q_a_in &gt;&gt; value;
<a name="l03217"></a>03217         <a class="code" href="classlibMesh_1_1RBSystem.php#adadaf9a427ffbace640455436a4d4b26">RB_A_q_vector</a>[q_a](i,j) = value;
<a name="l03218"></a>03218       }
<a name="l03219"></a>03219     }
<a name="l03220"></a>03220     RB_A_q_a_in.close();
<a name="l03221"></a>03221   }
<a name="l03222"></a>03222 
<a name="l03223"></a>03223 
<a name="l03224"></a>03224   <span class="comment">// Next read in F_q representor norm data</span>
<a name="l03225"></a>03225   std::ifstream RB_Fq_norms_in;
<a name="l03226"></a>03226   {
<a name="l03227"></a>03227     <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l03228"></a>03228     file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/Fq_norms.dat&quot;</span>;
<a name="l03229"></a>03229     RB_Fq_norms_in.open(file_name.str().c_str());
<a name="l03230"></a>03230   }
<a name="l03231"></a>03231   <span class="keywordflow">if</span> ( !RB_Fq_norms_in.good() )
<a name="l03232"></a>03232   {
<a name="l03233"></a>03233     <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening Fq_norms.dat&quot;</span> &lt;&lt; std::endl;
<a name="l03234"></a>03234     libmesh_error();
<a name="l03235"></a>03235   }
<a name="l03236"></a>03236   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Q_f_hat = <a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>()*(<a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>()+1)/2;
<a name="l03237"></a>03237   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;Q_f_hat; i++)
<a name="l03238"></a>03238   {
<a name="l03239"></a>03239     RB_Fq_norms_in &gt;&gt; <a class="code" href="classlibMesh_1_1RBSystem.php#a567c86950bb6d2ab2800ac0b14ed3dd2">Fq_representor_norms</a>[i];
<a name="l03240"></a>03240   }
<a name="l03241"></a>03241   RB_Fq_norms_in.close();
<a name="l03242"></a>03242 
<a name="l03243"></a>03243   <span class="comment">// Next read in Fq_Aq representor norm data</span>
<a name="l03244"></a>03244   std::ifstream RB_Fq_Aq_norms_in;
<a name="l03245"></a>03245   {
<a name="l03246"></a>03246     <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l03247"></a>03247     file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/Fq_Aq_norms.dat&quot;</span>;
<a name="l03248"></a>03248     RB_Fq_Aq_norms_in.open(file_name.str().c_str());
<a name="l03249"></a>03249   }
<a name="l03250"></a>03250   <span class="keywordflow">if</span> ( !RB_Fq_Aq_norms_in.good() )
<a name="l03251"></a>03251   {
<a name="l03252"></a>03252     <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening Fq_Aq_norms.dat&quot;</span> &lt;&lt; std::endl;
<a name="l03253"></a>03253     libmesh_error();
<a name="l03254"></a>03254   }
<a name="l03255"></a>03255   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_f=0; q_f&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>(); q_f++)
<a name="l03256"></a>03256   {
<a name="l03257"></a>03257     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_a=0; q_a&lt;<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>(); q_a++)
<a name="l03258"></a>03258     {
<a name="l03259"></a>03259       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_bfs; i++)
<a name="l03260"></a>03260       {
<a name="l03261"></a>03261         RB_Fq_Aq_norms_in &gt;&gt; <a class="code" href="classlibMesh_1_1RBSystem.php#ac3d546a3eaa362377494da087e711608">Fq_Aq_representor_norms</a>[q_f][q_a][i];
<a name="l03262"></a>03262       }
<a name="l03263"></a>03263     }
<a name="l03264"></a>03264   }
<a name="l03265"></a>03265   RB_Fq_Aq_norms_in.close();
<a name="l03266"></a>03266 
<a name="l03267"></a>03267   <span class="comment">// Next read in Aq_Aq representor norm data</span>
<a name="l03268"></a>03268   std::ifstream RB_Aq_Aq_norms_in;
<a name="l03269"></a>03269   {
<a name="l03270"></a>03270     <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l03271"></a>03271     file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/Aq_Aq_norms.dat&quot;</span>;
<a name="l03272"></a>03272     RB_Aq_Aq_norms_in.open(file_name.str().c_str());
<a name="l03273"></a>03273   }
<a name="l03274"></a>03274   <span class="keywordflow">if</span> ( !RB_Aq_Aq_norms_in.good() )
<a name="l03275"></a>03275   {
<a name="l03276"></a>03276     <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening Aq_Aq_norms.dat&quot;</span> &lt;&lt; std::endl;
<a name="l03277"></a>03277     libmesh_error();
<a name="l03278"></a>03278   }
<a name="l03279"></a>03279   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Q_a_hat = <a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>()*(<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>()+1)/2;
<a name="l03280"></a>03280   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;Q_a_hat; i++)
<a name="l03281"></a>03281   {
<a name="l03282"></a>03282     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;n_bfs; j++)
<a name="l03283"></a>03283     {
<a name="l03284"></a>03284       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> l=0; l&lt;n_bfs; l++)
<a name="l03285"></a>03285       {
<a name="l03286"></a>03286         RB_Aq_Aq_norms_in &gt;&gt; <a class="code" href="classlibMesh_1_1RBSystem.php#a668fed2dcb2e98adb2e7eea5bc7d853e">Aq_Aq_representor_norms</a>[i][j][l];
<a name="l03287"></a>03287       }
<a name="l03288"></a>03288     }
<a name="l03289"></a>03289   }
<a name="l03290"></a>03290   RB_Aq_Aq_norms_in.close();
<a name="l03291"></a>03291 
<a name="l03292"></a>03292   <span class="comment">// Resize basis_functions even if we don&#39;t read them in so that</span>
<a name="l03293"></a>03293   <span class="comment">// get_n_bfs() returns the correct value. Initialize the pointers</span>
<a name="l03294"></a>03294   <span class="comment">// to NULL</span>
<a name="l03295"></a>03295   <a class="code" href="classlibMesh_1_1RBSystem.php#a63377b4ff459ba8a31fb610fb9c3eaf2">set_n_basis_functions</a>(n_bfs);
<a name="l03296"></a>03296   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#abfe6d67ed23243d225f12747f355f105">basis_functions</a>.size(); i++)
<a name="l03297"></a>03297     {
<a name="l03298"></a>03298       <a class="code" href="classlibMesh_1_1RBSystem.php#abfe6d67ed23243d225f12747f355f105">basis_functions</a>[i] = NULL;
<a name="l03299"></a>03299     }
<a name="l03300"></a>03300 
<a name="l03301"></a>03301   <span class="comment">// Read in the basis functions if requested.</span>
<a name="l03302"></a>03302   <a class="code" href="classlibMesh_1_1RBSystem.php#a8ce3d2464a0adbcb7fe97a5d62a76e8c">read_in_basis_functions</a>(directory_name);
<a name="l03303"></a>03303 
<a name="l03304"></a>03304   <span class="comment">// Read in the representor vectors if requested</span>
<a name="l03305"></a>03305   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1RBSystem.php#a5ac870aac52f838bd28ee088ddc095b0">store_representors</a>)
<a name="l03306"></a>03306     {
<a name="l03307"></a>03307       <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Reading in the F_q_representors...&quot;</span> &lt;&lt; std::endl;
<a name="l03308"></a>03308 
<a name="l03309"></a>03309       <span class="keyword">const</span> std::string residual_representors_dir = <span class="stringliteral">&quot;residual_representors&quot;</span>;
<a name="l03310"></a>03310       <span class="keyword">const</span> std::string residual_representor_suffix = (<a class="code" href="classlibMesh_1_1RBSystem.php#a6be264f3a81564aa2cf7144b54d74552">read_binary_residual_representors</a> ? <span class="stringliteral">&quot;.xdr&quot;</span> : <span class="stringliteral">&quot;.dat&quot;</span>);
<a name="l03311"></a>03311       std::ostringstream file_name;
<a name="l03312"></a>03312       <span class="keyword">struct </span>stat stat_info;
<a name="l03313"></a>03313 
<a name="l03314"></a>03314       <span class="comment">// Read in the F_q_representors.  There should be Q_f of these.  FIXME:</span>
<a name="l03315"></a>03315       <span class="comment">// should we be worried about leaks here?</span>
<a name="l03316"></a>03316       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#acd91cfaa84058427cda2885e4d6d30ce">F_q_representor</a>.size(); ++i)
<a name="l03317"></a>03317         {
<a name="l03318"></a>03318           <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1RBSystem.php#acd91cfaa84058427cda2885e4d6d30ce">F_q_representor</a>[i] != NULL)
<a name="l03319"></a>03319             {
<a name="l03320"></a>03320               <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Error, must delete existing F_q_representor before reading in from file.&quot;</span>
<a name="l03321"></a>03321                            &lt;&lt; std::endl;
<a name="l03322"></a>03322               libmesh_error();
<a name="l03323"></a>03323             }
<a name="l03324"></a>03324         }
<a name="l03325"></a>03325 
<a name="l03326"></a>03326 
<a name="l03327"></a>03327       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#acd91cfaa84058427cda2885e4d6d30ce">F_q_representor</a>.size(); i++)
<a name="l03328"></a>03328         {
<a name="l03329"></a>03329           file_name.str(<span class="stringliteral">&quot;&quot;</span>); <span class="comment">// reset filename</span>
<a name="l03330"></a>03330           file_name &lt;&lt; residual_representors_dir
<a name="l03331"></a>03331                     &lt;&lt; <span class="stringliteral">&quot;/F_q_representor&quot;</span> &lt;&lt; i &lt;&lt; residual_representor_suffix;
<a name="l03332"></a>03332 
<a name="l03333"></a>03333           <span class="comment">// On processor zero check to be sure the file exists</span>
<a name="l03334"></a>03334           <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l03335"></a>03335             {
<a name="l03336"></a>03336               <span class="keywordtype">int</span> stat_result = stat(file_name.str().c_str(), &amp;stat_info);
<a name="l03337"></a>03337 
<a name="l03338"></a>03338               <span class="keywordflow">if</span> (stat_result != 0)
<a name="l03339"></a>03339                 {
<a name="l03340"></a>03340                   <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;File does not exist: &quot;</span> &lt;&lt; file_name.str() &lt;&lt; std::endl;
<a name="l03341"></a>03341                   libmesh_error();
<a name="l03342"></a>03342                 }
<a name="l03343"></a>03343             }
<a name="l03344"></a>03344 
<a name="l03345"></a>03345           <a class="code" href="classlibMesh_1_1Xdr.php">Xdr</a> fqr_data(file_name.str(),
<a name="l03346"></a>03346                        <a class="code" href="classlibMesh_1_1RBSystem.php#a6be264f3a81564aa2cf7144b54d74552">read_binary_residual_representors</a> ? <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a2632308739033bf9f82ea90cdf92231e">DECODE</a> : <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8acd5c7906bd7fea7650acc4c8cde09d48">READ</a>);
<a name="l03347"></a>03347 
<a name="l03348"></a>03348           <a class="code" href="classlibMesh_1_1System.php#a3eb0dd9d3ef0453daf9b5eeff0819736">read_serialized_data</a>(fqr_data, <span class="keyword">false</span>);
<a name="l03349"></a>03349 
<a name="l03350"></a>03350           <a class="code" href="classlibMesh_1_1RBSystem.php#acd91cfaa84058427cda2885e4d6d30ce">F_q_representor</a>[i] = <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;::build</a>().release();
<a name="l03351"></a>03351           <a class="code" href="classlibMesh_1_1RBSystem.php#acd91cfaa84058427cda2885e4d6d30ce">F_q_representor</a>[i]-&gt;init (this-&gt;<a class="code" href="classlibMesh_1_1System.php#a90dbb901f00c14ff18399f4afabcebe5">n_dofs</a>(), this-&gt;<a class="code" href="classlibMesh_1_1System.php#ae3aeb82e65b06789823d41da3c5df7a2">n_local_dofs</a>(), <span class="keyword">false</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">libMeshEnums::PARALLEL</a>);
<a name="l03352"></a>03352 
<a name="l03353"></a>03353           <span class="comment">// No need to copy, just swap</span>
<a name="l03354"></a>03354           <span class="comment">// *F_q_representor[i] = *solution;</span>
<a name="l03355"></a>03355           <a class="code" href="classlibMesh_1_1RBSystem.php#acd91cfaa84058427cda2885e4d6d30ce">F_q_representor</a>[i]-&gt;swap(*<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>);
<a name="l03356"></a>03356         }
<a name="l03357"></a>03357 
<a name="l03358"></a>03358       <span class="comment">// Alert the update_residual_terms() function that we don&#39;t need to recompute</span>
<a name="l03359"></a>03359       <span class="comment">// the F_q_representors as we have already read them in from file!</span>
<a name="l03360"></a>03360       <a class="code" href="classlibMesh_1_1RBSystem.php#a88a28e5658cc0bf37e3df863a46a9e7b">update_residual_terms_called</a>=<span class="keyword">true</span>;
<a name="l03361"></a>03361 
<a name="l03362"></a>03362       <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Reading in the A_q_representors...&quot;</span> &lt;&lt; std::endl;
<a name="l03363"></a>03363 
<a name="l03364"></a>03364       <span class="comment">// Read in the A_q representors.  The class makes room for [Q_a][Nmax] of these.  We are going to</span>
<a name="l03365"></a>03365       <span class="comment">// read in [Q_a][this-&gt;get_n_basis_functions()].  FIXME:</span>
<a name="l03366"></a>03366       <span class="comment">// should we be worried about leaks in the locations where we&#39;re about to fill entries?</span>
<a name="l03367"></a>03367       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#a9c8fb2a4cb5b77e59e36bfff438aed01">A_q_representor</a>.size(); ++i)
<a name="l03368"></a>03368         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#a9c8fb2a4cb5b77e59e36bfff438aed01">A_q_representor</a>[i].size(); ++j)
<a name="l03369"></a>03369           {
<a name="l03370"></a>03370             <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1RBSystem.php#a9c8fb2a4cb5b77e59e36bfff438aed01">A_q_representor</a>[i][j] != NULL)
<a name="l03371"></a>03371               {
<a name="l03372"></a>03372                 <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Error, must delete existing A_q_representor before reading in from file.&quot;</span>
<a name="l03373"></a>03373                              &lt;&lt; std::endl;
<a name="l03374"></a>03374                 libmesh_error();
<a name="l03375"></a>03375               }
<a name="l03376"></a>03376           }
<a name="l03377"></a>03377 
<a name="l03378"></a>03378       <span class="comment">// Now ready to read them in from file!</span>
<a name="l03379"></a>03379       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#a9c8fb2a4cb5b77e59e36bfff438aed01">A_q_representor</a>.size(); ++i)
<a name="l03380"></a>03380         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;this-&gt;<a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>(); ++j)
<a name="l03381"></a>03381           {
<a name="l03382"></a>03382             file_name.str(<span class="stringliteral">&quot;&quot;</span>); <span class="comment">// reset filename</span>
<a name="l03383"></a>03383             file_name &lt;&lt; residual_representors_dir
<a name="l03384"></a>03384                       &lt;&lt; <span class="stringliteral">&quot;/A_q_representor&quot;</span> &lt;&lt; i &lt;&lt; <span class="stringliteral">&quot;_&quot;</span> &lt;&lt; j &lt;&lt; residual_representor_suffix;
<a name="l03385"></a>03385 
<a name="l03386"></a>03386             <span class="comment">// On processor zero check to be sure the file exists</span>
<a name="l03387"></a>03387             <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l03388"></a>03388             {
<a name="l03389"></a>03389               <span class="keywordtype">int</span> stat_result = stat(file_name.str().c_str(), &amp;stat_info);
<a name="l03390"></a>03390 
<a name="l03391"></a>03391               <span class="keywordflow">if</span> (stat_result != 0)
<a name="l03392"></a>03392                 {
<a name="l03393"></a>03393                   <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;File does not exist: &quot;</span> &lt;&lt; file_name.str() &lt;&lt; std::endl;
<a name="l03394"></a>03394                   libmesh_error();
<a name="l03395"></a>03395                 }
<a name="l03396"></a>03396             }
<a name="l03397"></a>03397 
<a name="l03398"></a>03398             <a class="code" href="classlibMesh_1_1Xdr.php">Xdr</a> aqr_data(file_name.str(),
<a name="l03399"></a>03399                          <a class="code" href="classlibMesh_1_1RBSystem.php#a6be264f3a81564aa2cf7144b54d74552">read_binary_residual_representors</a> ? <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a2632308739033bf9f82ea90cdf92231e">DECODE</a> : <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8acd5c7906bd7fea7650acc4c8cde09d48">READ</a>);
<a name="l03400"></a>03400 
<a name="l03401"></a>03401             <a class="code" href="classlibMesh_1_1System.php#a3eb0dd9d3ef0453daf9b5eeff0819736">read_serialized_data</a>(aqr_data, <span class="keyword">false</span>);
<a name="l03402"></a>03402 
<a name="l03403"></a>03403             <a class="code" href="classlibMesh_1_1RBSystem.php#a9c8fb2a4cb5b77e59e36bfff438aed01">A_q_representor</a>[i][j] = <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;::build</a>().release();
<a name="l03404"></a>03404             <a class="code" href="classlibMesh_1_1RBSystem.php#a9c8fb2a4cb5b77e59e36bfff438aed01">A_q_representor</a>[i][j]-&gt;init (this-&gt;<a class="code" href="classlibMesh_1_1System.php#a90dbb901f00c14ff18399f4afabcebe5">n_dofs</a>(), this-&gt;<a class="code" href="classlibMesh_1_1System.php#ae3aeb82e65b06789823d41da3c5df7a2">n_local_dofs</a>(),
<a name="l03405"></a>03405                                          <span class="keyword">false</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">libMeshEnums::PARALLEL</a>);
<a name="l03406"></a>03406 
<a name="l03407"></a>03407             <span class="comment">// No need to copy, just swap</span>
<a name="l03408"></a>03408             <span class="comment">//*A_q_representor[i][j] = *solution;</span>
<a name="l03409"></a>03409             <a class="code" href="classlibMesh_1_1RBSystem.php#a9c8fb2a4cb5b77e59e36bfff438aed01">A_q_representor</a>[i][j]-&gt;swap(*<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>);
<a name="l03410"></a>03410           }
<a name="l03411"></a>03411     } <span class="comment">// end if (store_representors)</span>
<a name="l03412"></a>03412   STOP_LOG(<span class="stringliteral">&quot;read_offline_data_from_files()&quot;</span>, <span class="stringliteral">&quot;RBSystem&quot;</span>);
<a name="l03413"></a>03413 }
<a name="l03414"></a>03414 
<a name="l03415"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a3e76f211b8f215f86e8d96c0d371e3d8">03415</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a3e76f211b8f215f86e8d96c0d371e3d8">RBSystem::write_out_basis_functions</a>(<span class="keyword">const</span> std::string&amp; directory_name,
<a name="l03416"></a>03416                                          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)
<a name="l03417"></a>03417 {
<a name="l03418"></a>03418   <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBSystem.php#a740fd251422d685fa5b1256022c29a06">store_basis_functions</a>)
<a name="l03419"></a>03419   {
<a name="l03420"></a>03420     <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Writing out the basis functions...&quot;</span> &lt;&lt; std::endl;
<a name="l03421"></a>03421 
<a name="l03422"></a>03422     std::ostringstream file_name;
<a name="l03423"></a>03423     <span class="keyword">const</span> std::string basis_function_suffix = (<a class="code" href="classlibMesh_1_1RBSystem.php#a1378ada675cf004646e15be203e631c6">write_binary_basis_functions</a> ? <span class="stringliteral">&quot;.xdr&quot;</span> : <span class="stringliteral">&quot;.dat&quot;</span>);
<a name="l03424"></a>03424 
<a name="l03425"></a>03425     <span class="comment">// Use System::write_serialized_data to write out the basis functions</span>
<a name="l03426"></a>03426     <span class="comment">// by copying them into this-&gt;solution one at a time.</span>
<a name="l03427"></a>03427     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#abfe6d67ed23243d225f12747f355f105">basis_functions</a>.size(); i++)
<a name="l03428"></a>03428     {
<a name="l03429"></a>03429       <span class="comment">// No need to copy, just swap</span>
<a name="l03430"></a>03430       <span class="comment">// *solution = *basis_functions[i];</span>
<a name="l03431"></a>03431       <a class="code" href="classlibMesh_1_1RBSystem.php#abfe6d67ed23243d225f12747f355f105">basis_functions</a>[i]-&gt;swap(*<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>);
<a name="l03432"></a>03432 
<a name="l03433"></a>03433       file_name.str(<span class="stringliteral">&quot;&quot;</span>); <span class="comment">// reset the string</span>
<a name="l03434"></a>03434       file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/bf&quot;</span> &lt;&lt; i &lt;&lt; basis_function_suffix;
<a name="l03435"></a>03435 
<a name="l03436"></a>03436       <a class="code" href="classlibMesh_1_1Xdr.php">Xdr</a> bf_data(file_name.str(),
<a name="l03437"></a>03437                   <a class="code" href="classlibMesh_1_1RBSystem.php#a1378ada675cf004646e15be203e631c6">write_binary_basis_functions</a> ? <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8ae5559170d41d912b449375bb4e3468f6">ENCODE</a> : <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a47f4bcd4fcf418da5ec74d3d8e2c3bc4">WRITE</a>);
<a name="l03438"></a>03438 
<a name="l03439"></a>03439       <a class="code" href="classlibMesh_1_1System.php#ae8063c135acc9c54240886e1ac3c9acd">write_serialized_data</a>(bf_data, <span class="keyword">false</span>);
<a name="l03440"></a>03440 
<a name="l03441"></a>03441       <span class="comment">// Synchronize before moving on</span>
<a name="l03442"></a>03442       <a class="code" href="namespacelibMesh_1_1Parallel.php#a95416053432ed0ab6d1231070bfebeff">Parallel::barrier</a>();
<a name="l03443"></a>03443 
<a name="l03444"></a>03444       <span class="comment">// Swap back</span>
<a name="l03445"></a>03445       <a class="code" href="classlibMesh_1_1RBSystem.php#abfe6d67ed23243d225f12747f355f105">basis_functions</a>[i]-&gt;swap(*<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>);
<a name="l03446"></a>03446     }
<a name="l03447"></a>03447   }
<a name="l03448"></a>03448 }
<a name="l03449"></a>03449 
<a name="l03450"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a8ce3d2464a0adbcb7fe97a5d62a76e8c">03450</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a8ce3d2464a0adbcb7fe97a5d62a76e8c">RBSystem::read_in_basis_functions</a>(<span class="keyword">const</span> std::string&amp; directory_name)
<a name="l03451"></a>03451 {
<a name="l03452"></a>03452   <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBSystem.php#a740fd251422d685fa5b1256022c29a06">store_basis_functions</a>)
<a name="l03453"></a>03453   {
<a name="l03454"></a>03454     <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Reading in the basis functions...&quot;</span> &lt;&lt; std::endl;
<a name="l03455"></a>03455 
<a name="l03456"></a>03456     std::ostringstream file_name;
<a name="l03457"></a>03457     <span class="keyword">const</span> std::string basis_function_suffix = (<a class="code" href="classlibMesh_1_1RBSystem.php#a03fa5b207add059829b08f156320369d">read_binary_basis_functions</a> ? <span class="stringliteral">&quot;.xdr&quot;</span> : <span class="stringliteral">&quot;.dat&quot;</span>);
<a name="l03458"></a>03458     <span class="keyword">struct </span>stat stat_info;
<a name="l03459"></a>03459 
<a name="l03460"></a>03460     <span class="comment">// Use System::read_serialized_data to read in the basis functions</span>
<a name="l03461"></a>03461     <span class="comment">// into this-&gt;solution and then swap with the appropriate</span>
<a name="l03462"></a>03462     <span class="comment">// of basis function.</span>
<a name="l03463"></a>03463     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#abfe6d67ed23243d225f12747f355f105">basis_functions</a>.size(); i++)
<a name="l03464"></a>03464     {
<a name="l03465"></a>03465       file_name.str(<span class="stringliteral">&quot;&quot;</span>); <span class="comment">// reset the string</span>
<a name="l03466"></a>03466       file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/bf&quot;</span> &lt;&lt; i &lt;&lt; basis_function_suffix;
<a name="l03467"></a>03467 
<a name="l03468"></a>03468       <span class="comment">// On processor zero check to be sure the file exists</span>
<a name="l03469"></a>03469       <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l03470"></a>03470         {
<a name="l03471"></a>03471           <span class="keywordtype">int</span> stat_result = stat(file_name.str().c_str(), &amp;stat_info);
<a name="l03472"></a>03472 
<a name="l03473"></a>03473           <span class="keywordflow">if</span> (stat_result != 0)
<a name="l03474"></a>03474             {
<a name="l03475"></a>03475               <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;File does not exist: &quot;</span> &lt;&lt; file_name.str() &lt;&lt; std::endl;
<a name="l03476"></a>03476               libmesh_error();
<a name="l03477"></a>03477             }
<a name="l03478"></a>03478         }
<a name="l03479"></a>03479 
<a name="l03480"></a>03480       <a class="code" href="classlibMesh_1_1Xdr.php">Xdr</a> bf_data(file_name.str(),
<a name="l03481"></a>03481                   <a class="code" href="classlibMesh_1_1RBSystem.php#a03fa5b207add059829b08f156320369d">read_binary_basis_functions</a> ? <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a2632308739033bf9f82ea90cdf92231e">DECODE</a> : <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8acd5c7906bd7fea7650acc4c8cde09d48">READ</a>);
<a name="l03482"></a>03482 
<a name="l03483"></a>03483       <a class="code" href="classlibMesh_1_1System.php#a3eb0dd9d3ef0453daf9b5eeff0819736">read_serialized_data</a>(bf_data, <span class="keyword">false</span>);
<a name="l03484"></a>03484 
<a name="l03485"></a>03485       <a class="code" href="classlibMesh_1_1RBSystem.php#abfe6d67ed23243d225f12747f355f105">basis_functions</a>[i] = <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;::build</a>().release();
<a name="l03486"></a>03486       <a class="code" href="classlibMesh_1_1RBSystem.php#abfe6d67ed23243d225f12747f355f105">basis_functions</a>[i]-&gt;init (this-&gt;<a class="code" href="classlibMesh_1_1System.php#a90dbb901f00c14ff18399f4afabcebe5">n_dofs</a>(), this-&gt;<a class="code" href="classlibMesh_1_1System.php#ae3aeb82e65b06789823d41da3c5df7a2">n_local_dofs</a>(), <span class="keyword">false</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">libMeshEnums::PARALLEL</a>);
<a name="l03487"></a>03487 
<a name="l03488"></a>03488       <span class="comment">// No need to copy, just swap</span>
<a name="l03489"></a>03489       <span class="comment">// *basis_functions[i] = *solution;</span>
<a name="l03490"></a>03490       <a class="code" href="classlibMesh_1_1RBSystem.php#abfe6d67ed23243d225f12747f355f105">basis_functions</a>[i]-&gt;swap(*<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>);
<a name="l03491"></a>03491     }
<a name="l03492"></a>03492 
<a name="l03493"></a>03493     <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Finished reading in the basis functions...&quot;</span> &lt;&lt; std::endl;
<a name="l03494"></a>03494   }
<a name="l03495"></a>03495 }
<a name="l03496"></a>03496 
<a name="l03497"></a>03497 } <span class="comment">// namespace libMesh</span>
<a name="l03498"></a>03498 
<a name="l03499"></a>03499 
<a name="l03500"></a>03500 
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
