<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_c3a49989e40b21e7508f29d2dc962def.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_94af86d0ee7ff5a2af0627e1a0ea6efa.php">systems</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">system.C</div>  </div>
</div>
<div class="contents">
<a href="system_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id$</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// C++ includes</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &lt;sstream&gt;</span>   <span class="comment">// for std::ostringstream</span>
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// Local includes</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="dof__map_8h.php">dof_map.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="equation__systems_8h.php">equation_systems.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__logging_8h.php">libmesh_logging.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="mesh__base_8h.php">mesh_base.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="numeric__vector_8h.php">numeric_vector.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="parameter__vector_8h.php">parameter_vector.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="point_8h.php">point.h</a>&quot;</span>              <span class="comment">// For point_value</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="point__locator__base_8h.php">point_locator_base.h</a>&quot;</span> <span class="comment">// For point_value</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="qoi__set_8h.php">qoi_set.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="string__to__enum_8h.php">string_to_enum.h</a>&quot;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;<a class="code" href="system_8h.php">system.h</a>&quot;</span>
<a name="l00038"></a>00038 <span class="preprocessor">#include &quot;<a class="code" href="system__norm_8h.php">system_norm.h</a>&quot;</span>
<a name="l00039"></a>00039 <span class="preprocessor">#include &quot;<a class="code" href="utility_8h.php">utility.h</a>&quot;</span>
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 <span class="comment">// includes for calculate_norm, point_*</span>
<a name="l00042"></a>00042 <span class="preprocessor">#include &quot;<a class="code" href="fe__base_8h.php">fe_base.h</a>&quot;</span>
<a name="l00043"></a>00043 <span class="preprocessor">#include &quot;<a class="code" href="fe__interface_8h.php">fe_interface.h</a>&quot;</span>
<a name="l00044"></a>00044 <span class="preprocessor">#include &quot;<a class="code" href="parallel_8h.php">parallel.h</a>&quot;</span>
<a name="l00045"></a>00045 <span class="preprocessor">#include &quot;<a class="code" href="quadrature_8h.php">quadrature.h</a>&quot;</span>
<a name="l00046"></a>00046 <span class="preprocessor">#include &quot;<a class="code" href="tensor__value_8h.php">tensor_value.h</a>&quot;</span>
<a name="l00047"></a>00047 <span class="preprocessor">#include &quot;<a class="code" href="vector__value_8h.php">vector_value.h</a>&quot;</span>
<a name="l00048"></a>00048 
<a name="l00049"></a>00049 <span class="keyword">namespace </span>libMesh
<a name="l00050"></a>00050 {
<a name="l00051"></a>00051 
<a name="l00052"></a>00052 
<a name="l00053"></a>00053 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00054"></a>00054 <span class="comment">// System implementation</span>
<a name="l00055"></a><a class="code" href="classlibMesh_1_1System.php#a7bd52dc210afb90d7304101d38a46357">00055</a> <a class="code" href="classlibMesh_1_1System.php#a7bd52dc210afb90d7304101d38a46357">System::System</a> (<a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00056"></a>00056                 <span class="keyword">const</span> std::string&amp; <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>,
<a name="l00057"></a>00057                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> number) :
<a name="l00058"></a>00058 
<a name="l00059"></a>00059   assemble_before_solve    (true),
<a name="l00060"></a>00060   use_fixed_solution       (false),
<a name="l00061"></a>00061   extra_quadrature_order   (0),
<a name="l00062"></a>00062   solution                 (<a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector</a>&lt;<a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a>&gt;::build()),
<a name="l00063"></a>00063   current_local_solution   (<a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector</a>&lt;<a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a>&gt;::build()),
<a name="l00064"></a>00064   time                     (0.),
<a name="l00065"></a>00065   qoi                      (0),
<a name="l00066"></a>00066   _mesh_sys                (NULL),
<a name="l00067"></a>00067   _mesh_x_var              (libMesh::<a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">invalid_uint</a>),
<a name="l00068"></a>00068   _mesh_y_var              (libMesh::<a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">invalid_uint</a>),
<a name="l00069"></a>00069   _mesh_z_var              (libMesh::<a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">invalid_uint</a>),
<a name="l00070"></a>00070   _init_system             (NULL),
<a name="l00071"></a>00071   _assemble_system         (NULL),
<a name="l00072"></a>00072   _constrain_system        (NULL),
<a name="l00073"></a>00073   _qoi_evaluate            (NULL),
<a name="l00074"></a>00074   _qoi_evaluate_derivative (NULL),
<a name="l00075"></a>00075   _dof_map                 (new <a class="code" href="classlibMesh_1_1DofMap.php">DofMap</a>(number)),
<a name="l00076"></a>00076   _equation_systems        (es),
<a name="l00077"></a>00077   _mesh                    (es.get_mesh()),
<a name="l00078"></a>00078   _sys_name                (name),
<a name="l00079"></a>00079   _sys_number              (number),
<a name="l00080"></a>00080   _active                  (true),
<a name="l00081"></a>00081   _solution_projection     (true),
<a name="l00082"></a>00082   _can_add_vectors         (true),
<a name="l00083"></a>00083   _additional_data_written (false)
<a name="l00084"></a>00084 {
<a name="l00085"></a>00085 }
<a name="l00086"></a>00086 
<a name="l00087"></a>00087 
<a name="l00088"></a>00088 
<a name="l00089"></a>00089 <span class="comment">// No copy construction of System objects!</span>
<a name="l00090"></a><a class="code" href="classlibMesh_1_1System.php#a8b5b38c01e4300416f0d4df7356abcb6">00090</a> <a class="code" href="classlibMesh_1_1System.php#a7bd52dc210afb90d7304101d38a46357">System::System</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a>&amp; other) :
<a name="l00091"></a>00091   <a class="code" href="classlibMesh_1_1ReferenceCountedObject.php">ReferenceCountedObject</a>&lt;<a class="code" href="classlibMesh_1_1System.php">System</a>&gt;(),
<a name="l00092"></a>00092   _equation_systems(other._equation_systems),
<a name="l00093"></a>00093   _mesh(other._mesh),
<a name="l00094"></a>00094   _sys_number(other._sys_number)
<a name="l00095"></a>00095 {
<a name="l00096"></a>00096   libmesh_error();
<a name="l00097"></a>00097 }
<a name="l00098"></a>00098 
<a name="l00099"></a>00099 
<a name="l00100"></a>00100 
<a name="l00101"></a><a class="code" href="classlibMesh_1_1System.php#a454d9868ada86f3dbfb1bdd84971b626">00101</a> <a class="code" href="classlibMesh_1_1System.php">System</a>&amp; <a class="code" href="classlibMesh_1_1System.php#a454d9868ada86f3dbfb1bdd84971b626">System::operator= </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a>&amp;)
<a name="l00102"></a>00102 {
<a name="l00103"></a>00103   libmesh_error();
<a name="l00104"></a>00104 }
<a name="l00105"></a>00105 
<a name="l00106"></a>00106 
<a name="l00107"></a><a class="code" href="classlibMesh_1_1System.php#a419421462d140c9d4b71d3df59ff7722">00107</a> <a class="code" href="classlibMesh_1_1System.php#a419421462d140c9d4b71d3df59ff7722">System::~System</a> ()
<a name="l00108"></a>00108 {
<a name="l00109"></a>00109   <span class="comment">// Null-out the function pointers.  Since this</span>
<a name="l00110"></a>00110   <span class="comment">// class is getting destructed it is pointless,</span>
<a name="l00111"></a>00111   <span class="comment">// but a good habit.</span>
<a name="l00112"></a>00112   <a class="code" href="classlibMesh_1_1System.php#a56216973e780410f4ffaf2d45173543d">_init_system</a> = <a class="code" href="classlibMesh_1_1System.php#a35977f13fb34bbccf0594fd88001d8ba">_assemble_system</a> = NULL;
<a name="l00113"></a>00113 
<a name="l00114"></a>00114   <span class="comment">// Clear data</span>
<a name="l00115"></a>00115   this-&gt;<a class="code" href="classlibMesh_1_1System.php#a8b6f936ce782fbd86cb4f3922def4cf0">clear</a> ();
<a name="l00116"></a>00116 
<a name="l00117"></a>00117   libmesh_assert (!<a class="code" href="namespacelibMesh.php#a3dc0a134260371bd023e0d0f632399e1">libMesh::closed</a>());
<a name="l00118"></a>00118 }
<a name="l00119"></a>00119 
<a name="l00120"></a>00120 
<a name="l00121"></a>00121 
<a name="l00122"></a><a class="code" href="classlibMesh_1_1System.php#a90dbb901f00c14ff18399f4afabcebe5">00122</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#a90dbb901f00c14ff18399f4afabcebe5">System::n_dofs</a>()<span class="keyword"> const</span>
<a name="l00123"></a>00123 <span class="keyword"></span>{
<a name="l00124"></a>00124   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1System.php#a7386701e1324744b8d08db251374926b">_dof_map</a>-&gt;n_dofs();
<a name="l00125"></a>00125 }
<a name="l00126"></a>00126 
<a name="l00127"></a>00127 
<a name="l00128"></a>00128 
<a name="l00129"></a><a class="code" href="classlibMesh_1_1System.php#af44e0a3ba6dee841752b85b0c2b64854">00129</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#af44e0a3ba6dee841752b85b0c2b64854">System::n_constrained_dofs</a>()<span class="keyword"> const</span>
<a name="l00130"></a>00130 <span class="keyword"></span>{
<a name="l00131"></a>00131 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00132"></a>00132 <span class="preprocessor"></span>
<a name="l00133"></a>00133   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1System.php#a7386701e1324744b8d08db251374926b">_dof_map</a>-&gt;n_constrained_dofs();
<a name="l00134"></a>00134 
<a name="l00135"></a>00135 <span class="preprocessor">#else</span>
<a name="l00136"></a>00136 <span class="preprocessor"></span>
<a name="l00137"></a>00137   <span class="keywordflow">return</span> 0;
<a name="l00138"></a>00138 
<a name="l00139"></a>00139 <span class="preprocessor">#endif</span>
<a name="l00140"></a>00140 <span class="preprocessor"></span>}
<a name="l00141"></a>00141 
<a name="l00142"></a>00142 
<a name="l00143"></a>00143 
<a name="l00144"></a><a class="code" href="classlibMesh_1_1System.php#ae3aeb82e65b06789823d41da3c5df7a2">00144</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#ae3aeb82e65b06789823d41da3c5df7a2">System::n_local_dofs</a>()<span class="keyword"> const</span>
<a name="l00145"></a>00145 <span class="keyword"></span>{
<a name="l00146"></a>00146   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1System.php#a7386701e1324744b8d08db251374926b">_dof_map</a>-&gt;n_dofs_on_processor (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>());
<a name="l00147"></a>00147 }
<a name="l00148"></a>00148 
<a name="l00149"></a>00149 
<a name="l00150"></a>00150 
<a name="l00151"></a><a class="code" href="classlibMesh_1_1System.php#adad8bac609ebbd85b0c6aaafb8d3371e">00151</a> <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> <a class="code" href="classlibMesh_1_1System.php#adad8bac609ebbd85b0c6aaafb8d3371e">System::current_solution</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> global_dof_number)<span class="keyword"> const</span>
<a name="l00152"></a>00152 <span class="keyword"></span>{
<a name="l00153"></a>00153   <span class="comment">// Check the sizes</span>
<a name="l00154"></a>00154   libmesh_assert (global_dof_number &lt; _dof_map-&gt;<a class="code" href="classlibMesh_1_1System.php#a90dbb901f00c14ff18399f4afabcebe5">n_dofs</a>());
<a name="l00155"></a>00155   libmesh_assert (global_dof_number &lt; current_local_solution-&gt;size());
<a name="l00156"></a>00156    
<a name="l00157"></a>00157   <span class="keywordflow">return</span> (*<a class="code" href="classlibMesh_1_1System.php#a1e1bec53fb8d8a5a2163dbee844e8417">current_local_solution</a>)(global_dof_number);
<a name="l00158"></a>00158 }
<a name="l00159"></a>00159 
<a name="l00160"></a>00160 
<a name="l00161"></a>00161 
<a name="l00162"></a><a class="code" href="classlibMesh_1_1System.php#a8b6f936ce782fbd86cb4f3922def4cf0">00162</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a8b6f936ce782fbd86cb4f3922def4cf0">System::clear</a> ()
<a name="l00163"></a>00163 {
<a name="l00164"></a>00164   <a class="code" href="classlibMesh_1_1System.php#a17fc76a7e9339dcc3c834a646169bf0e">_variables</a>.clear();
<a name="l00165"></a>00165   
<a name="l00166"></a>00166   <a class="code" href="classlibMesh_1_1System.php#aca4105a9e0b687784fa38b95bd999d80">_variable_numbers</a>.clear();
<a name="l00167"></a>00167 
<a name="l00168"></a>00168   <a class="code" href="classlibMesh_1_1System.php#a7386701e1324744b8d08db251374926b">_dof_map</a>-&gt;clear ();
<a name="l00169"></a>00169   
<a name="l00170"></a>00170   <a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;clear ();
<a name="l00171"></a>00171 
<a name="l00172"></a>00172   <a class="code" href="classlibMesh_1_1System.php#a1e1bec53fb8d8a5a2163dbee844e8417">current_local_solution</a>-&gt;clear ();
<a name="l00173"></a>00173   
<a name="l00174"></a>00174   <span class="comment">// clear any user-added vectors</span>
<a name="l00175"></a>00175   {
<a name="l00176"></a>00176     <span class="keywordflow">for</span> (<a class="code" href="classlibMesh_1_1System.php#a6a75b971c5614203f50d5a922df9253c">vectors_iterator</a> pos = <a class="code" href="classlibMesh_1_1System.php#a4068a7b090c2b32e2c73c018b4e22a80">_vectors</a>.begin(); pos != <a class="code" href="classlibMesh_1_1System.php#a4068a7b090c2b32e2c73c018b4e22a80">_vectors</a>.end(); ++pos)
<a name="l00177"></a>00177       {
<a name="l00178"></a>00178         pos-&gt;second-&gt;clear ();
<a name="l00179"></a>00179         <span class="keyword">delete</span> pos-&gt;second;
<a name="l00180"></a>00180         pos-&gt;second = NULL;
<a name="l00181"></a>00181       }
<a name="l00182"></a>00182     
<a name="l00183"></a>00183     <a class="code" href="classlibMesh_1_1System.php#a4068a7b090c2b32e2c73c018b4e22a80">_vectors</a>.clear();
<a name="l00184"></a>00184     <a class="code" href="classlibMesh_1_1System.php#a96f148e01190c571cc92789fb5cd5ca4">_vector_projections</a>.clear();
<a name="l00185"></a>00185     <a class="code" href="classlibMesh_1_1System.php#a2623509811966d32d649c6c135f43c6c">_vector_types</a>.clear();
<a name="l00186"></a>00186     <a class="code" href="classlibMesh_1_1System.php#adc22ea07ed2a681eef304a471715cc85">_can_add_vectors</a> = <span class="keyword">true</span>;
<a name="l00187"></a>00187   }
<a name="l00188"></a>00188 
<a name="l00189"></a>00189 }
<a name="l00190"></a>00190 
<a name="l00191"></a>00191 
<a name="l00192"></a>00192 
<a name="l00193"></a><a class="code" href="classlibMesh_1_1System.php#a9cbe27bf56eae7baea5c397fa88c09a3">00193</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a9cbe27bf56eae7baea5c397fa88c09a3">System::init</a> ()
<a name="l00194"></a>00194 { 
<a name="l00195"></a>00195   <span class="comment">// First initialize any required data</span>
<a name="l00196"></a>00196   this-&gt;<a class="code" href="classlibMesh_1_1System.php#aa82956a48e464a20f18426601ad511d4">init_data</a>();
<a name="l00197"></a>00197   
<a name="l00198"></a>00198   <span class="comment">//If no variables have been added to this system</span>
<a name="l00199"></a>00199   <span class="comment">//don&#39;t do anything</span>
<a name="l00200"></a>00200   <span class="keywordflow">if</span>(!this-&gt;<a class="code" href="classlibMesh_1_1System.php#a4cf032eda109fe32a7fcde672ef5726e">n_vars</a>())
<a name="l00201"></a>00201     <span class="keywordflow">return</span>;
<a name="l00202"></a>00202  
<a name="l00203"></a>00203   <span class="comment">// Then call the user-provided intialization function</span>
<a name="l00204"></a>00204   this-&gt;<a class="code" href="classlibMesh_1_1System.php#a5f7a3a1e154fe61af97e966f3ab34ae2">user_initialization</a>();
<a name="l00205"></a>00205 }
<a name="l00206"></a>00206 
<a name="l00207"></a>00207 
<a name="l00208"></a>00208 
<a name="l00209"></a><a class="code" href="classlibMesh_1_1System.php#aa82956a48e464a20f18426601ad511d4">00209</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#aa82956a48e464a20f18426601ad511d4">System::init_data</a> ()
<a name="l00210"></a>00210 {
<a name="l00211"></a>00211   <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp;<a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a> = this-&gt;<a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">get_mesh</a>();
<a name="l00212"></a>00212 
<a name="l00213"></a>00213   <span class="comment">// Distribute the degrees of freedom on the mesh</span>
<a name="l00214"></a>00214   <a class="code" href="classlibMesh_1_1System.php#a7386701e1324744b8d08db251374926b">_dof_map</a>-&gt;distribute_dofs (mesh);
<a name="l00215"></a>00215 
<a name="l00216"></a>00216 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00217"></a>00217 <span class="preprocessor"></span>
<a name="l00218"></a>00218   <span class="comment">// Recreate any hanging node constraints</span>
<a name="l00219"></a>00219   <a class="code" href="classlibMesh_1_1System.php#a7386701e1324744b8d08db251374926b">_dof_map</a>-&gt;create_dof_constraints(mesh);
<a name="l00220"></a>00220 
<a name="l00221"></a>00221   <span class="comment">// Apply any user-defined constraints</span>
<a name="l00222"></a>00222   this-&gt;<a class="code" href="classlibMesh_1_1System.php#a8e857fcc4af2756cdd0d16563dfbbe83">user_constrain</a>();
<a name="l00223"></a>00223 
<a name="l00224"></a>00224   <span class="comment">// Expand any recursive constraints</span>
<a name="l00225"></a>00225   <a class="code" href="classlibMesh_1_1System.php#a7386701e1324744b8d08db251374926b">_dof_map</a>-&gt;process_constraints();
<a name="l00226"></a>00226 
<a name="l00227"></a>00227   <span class="comment">// And clean up the send_list before we first use it</span>
<a name="l00228"></a>00228   <a class="code" href="classlibMesh_1_1System.php#a7386701e1324744b8d08db251374926b">_dof_map</a>-&gt;prepare_send_list();
<a name="l00229"></a>00229 
<a name="l00230"></a>00230 <span class="preprocessor">#endif</span>
<a name="l00231"></a>00231 <span class="preprocessor"></span>  
<a name="l00232"></a>00232   <span class="comment">// Resize the solution conformal to the current mesh</span>
<a name="l00233"></a>00233   <a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;init (this-&gt;<a class="code" href="classlibMesh_1_1System.php#a90dbb901f00c14ff18399f4afabcebe5">n_dofs</a>(), this-&gt;<a class="code" href="classlibMesh_1_1System.php#ae3aeb82e65b06789823d41da3c5df7a2">n_local_dofs</a>(), <span class="keyword">false</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">PARALLEL</a>);
<a name="l00234"></a>00234 
<a name="l00235"></a>00235   <span class="comment">// Resize the current_local_solution for the current mesh</span>
<a name="l00236"></a>00236 <span class="preprocessor">#ifdef LIBMESH_ENABLE_GHOSTED</span>
<a name="l00237"></a>00237 <span class="preprocessor"></span>  <a class="code" href="classlibMesh_1_1System.php#a1e1bec53fb8d8a5a2163dbee844e8417">current_local_solution</a>-&gt;init (this-&gt;<a class="code" href="classlibMesh_1_1System.php#a90dbb901f00c14ff18399f4afabcebe5">n_dofs</a>(), this-&gt;<a class="code" href="classlibMesh_1_1System.php#ae3aeb82e65b06789823d41da3c5df7a2">n_local_dofs</a>(),
<a name="l00238"></a>00238                                 <a class="code" href="classlibMesh_1_1System.php#a7386701e1324744b8d08db251374926b">_dof_map</a>-&gt;get_send_list(), <span class="keyword">false</span>,
<a name="l00239"></a>00239                                 <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa9f12475bbe90a64ad167ec0b856ca6c1">GHOSTED</a>);
<a name="l00240"></a>00240 <span class="preprocessor">#else</span>
<a name="l00241"></a>00241 <span class="preprocessor"></span>  <a class="code" href="classlibMesh_1_1System.php#a1e1bec53fb8d8a5a2163dbee844e8417">current_local_solution</a>-&gt;init (this-&gt;<a class="code" href="classlibMesh_1_1System.php#a90dbb901f00c14ff18399f4afabcebe5">n_dofs</a>(), <span class="keyword">false</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa333690ccec0379e5dd4ccb60db5ea0c9">SERIAL</a>);
<a name="l00242"></a>00242 <span class="preprocessor">#endif</span>
<a name="l00243"></a>00243 <span class="preprocessor"></span>
<a name="l00244"></a>00244   <span class="comment">// from now on, no chance to add additional vectors</span>
<a name="l00245"></a>00245   <a class="code" href="classlibMesh_1_1System.php#adc22ea07ed2a681eef304a471715cc85">_can_add_vectors</a> = <span class="keyword">false</span>;
<a name="l00246"></a>00246 
<a name="l00247"></a>00247   <span class="comment">// initialize &amp; zero other vectors, if necessary</span>
<a name="l00248"></a>00248   <span class="keywordflow">for</span> (<a class="code" href="classlibMesh_1_1System.php#a6a75b971c5614203f50d5a922df9253c">vectors_iterator</a> pos = <a class="code" href="classlibMesh_1_1System.php#a4068a7b090c2b32e2c73c018b4e22a80">_vectors</a>.begin(); pos != <a class="code" href="classlibMesh_1_1System.php#a4068a7b090c2b32e2c73c018b4e22a80">_vectors</a>.end(); ++pos)
<a name="l00249"></a>00249   {
<a name="l00250"></a>00250     <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> type = <a class="code" href="classlibMesh_1_1System.php#a2623509811966d32d649c6c135f43c6c">_vector_types</a>[pos-&gt;first];
<a name="l00251"></a>00251     
<a name="l00252"></a>00252     <span class="keywordflow">if</span>(type == <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa9f12475bbe90a64ad167ec0b856ca6c1">GHOSTED</a>)
<a name="l00253"></a>00253     {
<a name="l00254"></a>00254 <span class="preprocessor">#ifdef LIBMESH_ENABLE_GHOSTED</span>
<a name="l00255"></a>00255 <span class="preprocessor"></span>      pos-&gt;second-&gt;init (this-&gt;<a class="code" href="classlibMesh_1_1System.php#a90dbb901f00c14ff18399f4afabcebe5">n_dofs</a>(), this-&gt;<a class="code" href="classlibMesh_1_1System.php#ae3aeb82e65b06789823d41da3c5df7a2">n_local_dofs</a>(),
<a name="l00256"></a>00256                          <a class="code" href="classlibMesh_1_1System.php#a7386701e1324744b8d08db251374926b">_dof_map</a>-&gt;get_send_list(), <span class="keyword">false</span>,
<a name="l00257"></a>00257                          <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa9f12475bbe90a64ad167ec0b856ca6c1">GHOSTED</a>);
<a name="l00258"></a>00258 <span class="preprocessor">#else</span>
<a name="l00259"></a>00259 <span class="preprocessor"></span>      <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Cannot initialize ghosted vectors when they are not enabled.&quot;</span> &lt;&lt; std::endl;
<a name="l00260"></a>00260       libmesh_error();
<a name="l00261"></a>00261 <span class="preprocessor">#endif</span>
<a name="l00262"></a>00262 <span class="preprocessor"></span>    }
<a name="l00263"></a>00263     <span class="keywordflow">else</span>
<a name="l00264"></a>00264       pos-&gt;second-&gt;init (this-&gt;<a class="code" href="classlibMesh_1_1System.php#a90dbb901f00c14ff18399f4afabcebe5">n_dofs</a>(), this-&gt;<a class="code" href="classlibMesh_1_1System.php#ae3aeb82e65b06789823d41da3c5df7a2">n_local_dofs</a>(), <span class="keyword">false</span>, type);
<a name="l00265"></a>00265   }
<a name="l00266"></a>00266 }
<a name="l00267"></a>00267 
<a name="l00268"></a>00268 
<a name="l00269"></a>00269 
<a name="l00270"></a><a class="code" href="classlibMesh_1_1System.php#a78af7f915ad5c678e3629ddced200967">00270</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a78af7f915ad5c678e3629ddced200967">System::restrict_vectors</a> ()
<a name="l00271"></a>00271 {
<a name="l00272"></a>00272 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00273"></a>00273 <span class="preprocessor"></span>  <span class="comment">// Restrict the _vectors on the coarsened cells</span>
<a name="l00274"></a>00274   <span class="keywordflow">for</span> (<a class="code" href="classlibMesh_1_1System.php#a6a75b971c5614203f50d5a922df9253c">vectors_iterator</a> pos = <a class="code" href="classlibMesh_1_1System.php#a4068a7b090c2b32e2c73c018b4e22a80">_vectors</a>.begin(); pos != <a class="code" href="classlibMesh_1_1System.php#a4068a7b090c2b32e2c73c018b4e22a80">_vectors</a>.end(); ++pos)
<a name="l00275"></a>00275     {
<a name="l00276"></a>00276       <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>* v = pos-&gt;second;
<a name="l00277"></a>00277       
<a name="l00278"></a>00278       <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1System.php#a96f148e01190c571cc92789fb5cd5ca4">_vector_projections</a>[pos-&gt;first])
<a name="l00279"></a>00279         this-&gt;<a class="code" href="classlibMesh_1_1System.php#ac31376d8fbe17c9f3a341d0a599a98c1">project_vector</a> (*v);
<a name="l00280"></a>00280       <span class="keywordflow">else</span>
<a name="l00281"></a>00281       {
<a name="l00282"></a>00282         <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> type = <a class="code" href="classlibMesh_1_1System.php#a2623509811966d32d649c6c135f43c6c">_vector_types</a>[pos-&gt;first];
<a name="l00283"></a>00283         
<a name="l00284"></a>00284         <span class="keywordflow">if</span>(type == <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa9f12475bbe90a64ad167ec0b856ca6c1">GHOSTED</a>)
<a name="l00285"></a>00285         {
<a name="l00286"></a>00286 <span class="preprocessor">#ifdef LIBMESH_ENABLE_GHOSTED</span>
<a name="l00287"></a>00287 <span class="preprocessor"></span>          pos-&gt;second-&gt;init (this-&gt;<a class="code" href="classlibMesh_1_1System.php#a90dbb901f00c14ff18399f4afabcebe5">n_dofs</a>(), this-&gt;<a class="code" href="classlibMesh_1_1System.php#ae3aeb82e65b06789823d41da3c5df7a2">n_local_dofs</a>(),
<a name="l00288"></a>00288                          <a class="code" href="classlibMesh_1_1System.php#a7386701e1324744b8d08db251374926b">_dof_map</a>-&gt;get_send_list(), <span class="keyword">false</span>,
<a name="l00289"></a>00289                          <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa9f12475bbe90a64ad167ec0b856ca6c1">GHOSTED</a>);
<a name="l00290"></a>00290 <span class="preprocessor">#else</span>
<a name="l00291"></a>00291 <span class="preprocessor"></span>          <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Cannot initialize ghosted vectors when they are not enabled.&quot;</span> &lt;&lt; std::endl;
<a name="l00292"></a>00292           libmesh_error();
<a name="l00293"></a>00293 <span class="preprocessor">#endif</span>
<a name="l00294"></a>00294 <span class="preprocessor"></span>        }
<a name="l00295"></a>00295         <span class="keywordflow">else</span>
<a name="l00296"></a>00296           pos-&gt;second-&gt;init (this-&gt;<a class="code" href="classlibMesh_1_1System.php#a90dbb901f00c14ff18399f4afabcebe5">n_dofs</a>(), this-&gt;<a class="code" href="classlibMesh_1_1System.php#ae3aeb82e65b06789823d41da3c5df7a2">n_local_dofs</a>(), <span class="keyword">false</span>, type);
<a name="l00297"></a>00297       }
<a name="l00298"></a>00298     }
<a name="l00299"></a>00299 
<a name="l00300"></a>00300   <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; send_list = <a class="code" href="classlibMesh_1_1System.php#a7386701e1324744b8d08db251374926b">_dof_map</a>-&gt;get_send_list ();
<a name="l00301"></a>00301 
<a name="l00302"></a>00302   <span class="comment">// Restrict the solution on the coarsened cells</span>
<a name="l00303"></a>00303   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1System.php#a711acee387038ac906783a0d39d8e840">_solution_projection</a>)
<a name="l00304"></a>00304     this-&gt;<a class="code" href="classlibMesh_1_1System.php#ac31376d8fbe17c9f3a341d0a599a98c1">project_vector</a> (*<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>);
<a name="l00305"></a>00305 
<a name="l00306"></a>00306 <span class="preprocessor">#ifdef LIBMESH_ENABLE_GHOSTED</span>
<a name="l00307"></a>00307 <span class="preprocessor"></span>  <a class="code" href="classlibMesh_1_1System.php#a1e1bec53fb8d8a5a2163dbee844e8417">current_local_solution</a>-&gt;init(this-&gt;<a class="code" href="classlibMesh_1_1System.php#a90dbb901f00c14ff18399f4afabcebe5">n_dofs</a>(),
<a name="l00308"></a>00308                                this-&gt;<a class="code" href="classlibMesh_1_1System.php#ae3aeb82e65b06789823d41da3c5df7a2">n_local_dofs</a>(), send_list, 
<a name="l00309"></a>00309                                <span class="keyword">false</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa9f12475bbe90a64ad167ec0b856ca6c1">GHOSTED</a>);
<a name="l00310"></a>00310 <span class="preprocessor">#else</span>
<a name="l00311"></a>00311 <span class="preprocessor"></span>  <a class="code" href="classlibMesh_1_1System.php#a1e1bec53fb8d8a5a2163dbee844e8417">current_local_solution</a>-&gt;init(this-&gt;<a class="code" href="classlibMesh_1_1System.php#a90dbb901f00c14ff18399f4afabcebe5">n_dofs</a>());
<a name="l00312"></a>00312 <span class="preprocessor">#endif</span>
<a name="l00313"></a>00313 <span class="preprocessor"></span>
<a name="l00314"></a>00314   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1System.php#a711acee387038ac906783a0d39d8e840">_solution_projection</a>)
<a name="l00315"></a>00315     <a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;localize (*<a class="code" href="classlibMesh_1_1System.php#a1e1bec53fb8d8a5a2163dbee844e8417">current_local_solution</a>, send_list); 
<a name="l00316"></a>00316 
<a name="l00317"></a>00317 <span class="preprocessor">#endif // LIBMESH_ENABLE_AMR</span>
<a name="l00318"></a>00318 <span class="preprocessor"></span>}
<a name="l00319"></a>00319 
<a name="l00320"></a>00320 
<a name="l00321"></a>00321 
<a name="l00322"></a><a class="code" href="classlibMesh_1_1System.php#a55667d016781687feed399872671c963">00322</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a55667d016781687feed399872671c963">System::prolong_vectors</a> ()
<a name="l00323"></a>00323 {
<a name="l00324"></a>00324 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00325"></a>00325 <span class="preprocessor"></span>  <span class="comment">// Currently project_vector handles both restriction and prolongation</span>
<a name="l00326"></a>00326   this-&gt;<a class="code" href="classlibMesh_1_1System.php#a78af7f915ad5c678e3629ddced200967">restrict_vectors</a>();
<a name="l00327"></a>00327 <span class="preprocessor">#endif</span>
<a name="l00328"></a>00328 <span class="preprocessor"></span>}
<a name="l00329"></a>00329 
<a name="l00330"></a>00330 
<a name="l00331"></a>00331 
<a name="l00332"></a><a class="code" href="classlibMesh_1_1System.php#a1cb3b5ae4fdd2f72d8fbddcadf3d3256">00332</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a1cb3b5ae4fdd2f72d8fbddcadf3d3256">System::reinit</a> ()
<a name="l00333"></a>00333 {
<a name="l00334"></a>00334 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00335"></a>00335 <span class="preprocessor"></span>  <span class="comment">//If no variables have been added to this system</span>
<a name="l00336"></a>00336   <span class="comment">//don&#39;t do anything</span>
<a name="l00337"></a>00337   <span class="keywordflow">if</span>(!this-&gt;<a class="code" href="classlibMesh_1_1System.php#a4cf032eda109fe32a7fcde672ef5726e">n_vars</a>())
<a name="l00338"></a>00338     <span class="keywordflow">return</span>;
<a name="l00339"></a>00339 
<a name="l00340"></a>00340   <span class="comment">// Constraints get handled in EquationSystems::reinit now</span>
<a name="l00341"></a>00341 <span class="comment">//  _dof_map-&gt;create_dof_constraints(this-&gt;get_mesh());</span>
<a name="l00342"></a>00342 
<a name="l00343"></a>00343   <span class="comment">// Update the solution based on the projected</span>
<a name="l00344"></a>00344   <span class="comment">// current_local_solution.</span>
<a name="l00345"></a>00345   <a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;init (this-&gt;<a class="code" href="classlibMesh_1_1System.php#a90dbb901f00c14ff18399f4afabcebe5">n_dofs</a>(), this-&gt;<a class="code" href="classlibMesh_1_1System.php#ae3aeb82e65b06789823d41da3c5df7a2">n_local_dofs</a>(), <span class="keyword">true</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">PARALLEL</a>);
<a name="l00346"></a>00346         
<a name="l00347"></a>00347   libmesh_assert (<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;size() == <a class="code" href="classlibMesh_1_1System.php#a1e1bec53fb8d8a5a2163dbee844e8417">current_local_solution</a>-&gt;size());
<a name="l00348"></a>00348   <span class="comment">// Not true with ghosted vectors</span>
<a name="l00349"></a>00349   <span class="comment">// libmesh_assert (solution-&gt;size() == current_local_solution-&gt;local_size());</span>
<a name="l00350"></a>00350 
<a name="l00351"></a>00351   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> first_local_dof = <a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;first_local_index();
<a name="l00352"></a>00352   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> local_size      = <a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;local_size();
<a name="l00353"></a>00353       
<a name="l00354"></a>00354   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;local_size; i++)
<a name="l00355"></a>00355     <a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;set(i+first_local_dof,
<a name="l00356"></a>00356                   (*<a class="code" href="classlibMesh_1_1System.php#a1e1bec53fb8d8a5a2163dbee844e8417">current_local_solution</a>)(i+first_local_dof));
<a name="l00357"></a>00357 
<a name="l00358"></a>00358   <a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;close();
<a name="l00359"></a>00359 <span class="preprocessor">#endif</span>
<a name="l00360"></a>00360 <span class="preprocessor"></span>}
<a name="l00361"></a>00361 
<a name="l00362"></a>00362 
<a name="l00363"></a>00363 
<a name="l00364"></a><a class="code" href="classlibMesh_1_1System.php#ab9d81ac9c1787c43fb87cf13d37741ee">00364</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#ab9d81ac9c1787c43fb87cf13d37741ee">System::update</a> ()
<a name="l00365"></a>00365 {
<a name="l00366"></a>00366   <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; send_list = <a class="code" href="classlibMesh_1_1System.php#a7386701e1324744b8d08db251374926b">_dof_map</a>-&gt;get_send_list ();
<a name="l00367"></a>00367 
<a name="l00368"></a>00368   <span class="comment">// Check sizes</span>
<a name="l00369"></a>00369   libmesh_assert (<a class="code" href="classlibMesh_1_1System.php#a1e1bec53fb8d8a5a2163dbee844e8417">current_local_solution</a>-&gt;size() == <a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;size());
<a name="l00370"></a>00370 <span class="comment">// More processors than elements =&gt; empty send_list</span>
<a name="l00371"></a>00371 <span class="comment">//  libmesh_assert (!send_list.empty());</span>
<a name="l00372"></a>00372   libmesh_assert (send_list.size() &lt;= <a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;size());
<a name="l00373"></a>00373 
<a name="l00374"></a>00374   <span class="comment">// Create current_local_solution from solution.  This will</span>
<a name="l00375"></a>00375   <span class="comment">// put a local copy of solution into current_local_solution.</span>
<a name="l00376"></a>00376   <span class="comment">// Only the necessary values (specified by the send_list)</span>
<a name="l00377"></a>00377   <span class="comment">// are copied to minimize communication</span>
<a name="l00378"></a>00378   <a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;localize (*<a class="code" href="classlibMesh_1_1System.php#a1e1bec53fb8d8a5a2163dbee844e8417">current_local_solution</a>, send_list); 
<a name="l00379"></a>00379 }
<a name="l00380"></a>00380 
<a name="l00381"></a>00381 
<a name="l00382"></a>00382 
<a name="l00383"></a><a class="code" href="classlibMesh_1_1System.php#a95f76b0ddbd8084a2a01a12495ebad2d">00383</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a95f76b0ddbd8084a2a01a12495ebad2d">System::re_update</a> ()
<a name="l00384"></a>00384 {
<a name="l00385"></a>00385   <span class="comment">// If this system is empty... don&#39;t do anything!</span>
<a name="l00386"></a>00386   <span class="keywordflow">if</span>(!this-&gt;<a class="code" href="classlibMesh_1_1System.php#a4cf032eda109fe32a7fcde672ef5726e">n_vars</a>())
<a name="l00387"></a>00387     <span class="keywordflow">return</span>;
<a name="l00388"></a>00388 
<a name="l00389"></a>00389   <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; send_list = this-&gt;<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>().<a class="code" href="classlibMesh_1_1DofMap.php#a4e0a6909796bc3c19ca543a182ffe224">get_send_list</a> ();
<a name="l00390"></a>00390 
<a name="l00391"></a>00391   <span class="comment">// Check sizes</span>
<a name="l00392"></a>00392   libmesh_assert (<a class="code" href="classlibMesh_1_1System.php#a1e1bec53fb8d8a5a2163dbee844e8417">current_local_solution</a>-&gt;size()       == <a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;size());
<a name="l00393"></a>00393   <span class="comment">// Not true with ghosted vectors</span>
<a name="l00394"></a>00394   <span class="comment">// libmesh_assert (current_local_solution-&gt;local_size() == solution-&gt;size());</span>
<a name="l00395"></a>00395   <span class="comment">// libmesh_assert (!send_list.empty());</span>
<a name="l00396"></a>00396   libmesh_assert (send_list.size() &lt;= <a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;size());
<a name="l00397"></a>00397 
<a name="l00398"></a>00398   <span class="comment">// Create current_local_solution from solution.  This will</span>
<a name="l00399"></a>00399   <span class="comment">// put a local copy of solution into current_local_solution.</span>
<a name="l00400"></a>00400   <a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;localize (*<a class="code" href="classlibMesh_1_1System.php#a1e1bec53fb8d8a5a2163dbee844e8417">current_local_solution</a>, send_list);
<a name="l00401"></a>00401 }
<a name="l00402"></a>00402 
<a name="l00403"></a>00403 
<a name="l00404"></a>00404 
<a name="l00405"></a><a class="code" href="classlibMesh_1_1System.php#a79e4227a9e627031fac487cbd7c17250">00405</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a79e4227a9e627031fac487cbd7c17250">System::assemble</a> ()
<a name="l00406"></a>00406 {
<a name="l00407"></a>00407   <span class="comment">// Log how long the user&#39;s matrix assembly code takes</span>
<a name="l00408"></a>00408   START_LOG(<span class="stringliteral">&quot;assemble()&quot;</span>, <span class="stringliteral">&quot;System&quot;</span>);
<a name="l00409"></a>00409   
<a name="l00410"></a>00410   <span class="comment">// Call the user-specified assembly function</span>
<a name="l00411"></a>00411   this-&gt;<a class="code" href="classlibMesh_1_1System.php#a792940ed6cca41b5dcaf878429a50253">user_assembly</a>();
<a name="l00412"></a>00412 
<a name="l00413"></a>00413   <span class="comment">// Stop logging the user code</span>
<a name="l00414"></a>00414   STOP_LOG(<span class="stringliteral">&quot;assemble()&quot;</span>, <span class="stringliteral">&quot;System&quot;</span>);
<a name="l00415"></a>00415 }
<a name="l00416"></a>00416 
<a name="l00417"></a>00417 
<a name="l00418"></a>00418 
<a name="l00419"></a><a class="code" href="classlibMesh_1_1System.php#ab57cde3f61d1816856e1100f068a25fa">00419</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#ab57cde3f61d1816856e1100f068a25fa">System::assemble_qoi</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a>&amp; qoi_indices)
<a name="l00420"></a>00420 {
<a name="l00421"></a>00421   <span class="comment">// Log how long the user&#39;s matrix assembly code takes</span>
<a name="l00422"></a>00422   START_LOG(<span class="stringliteral">&quot;assemble_qoi()&quot;</span>, <span class="stringliteral">&quot;System&quot;</span>);
<a name="l00423"></a>00423   
<a name="l00424"></a>00424   <span class="comment">// Call the user-specified quantity of interest function</span>
<a name="l00425"></a>00425   this-&gt;<a class="code" href="classlibMesh_1_1System.php#a3e75c1bd2055bb1bf9f5832a62c0039d">user_QOI</a>(qoi_indices);
<a name="l00426"></a>00426 
<a name="l00427"></a>00427   <span class="comment">// Stop logging the user code</span>
<a name="l00428"></a>00428   STOP_LOG(<span class="stringliteral">&quot;assemble_qoi()&quot;</span>, <span class="stringliteral">&quot;System&quot;</span>);
<a name="l00429"></a>00429 }
<a name="l00430"></a>00430 
<a name="l00431"></a>00431 
<a name="l00432"></a>00432 
<a name="l00433"></a><a class="code" href="classlibMesh_1_1System.php#a7d69df3b46fdd7073cfaaaf0fa71fbbc">00433</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a7d69df3b46fdd7073cfaaaf0fa71fbbc">System::assemble_qoi_derivative</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a>&amp; qoi_indices)
<a name="l00434"></a>00434 {
<a name="l00435"></a>00435   <span class="comment">// Log how long the user&#39;s matrix assembly code takes</span>
<a name="l00436"></a>00436   START_LOG(<span class="stringliteral">&quot;assemble_qoi_derivative()&quot;</span>, <span class="stringliteral">&quot;System&quot;</span>);
<a name="l00437"></a>00437   
<a name="l00438"></a>00438   <span class="comment">// Call the user-specified quantity of interest function</span>
<a name="l00439"></a>00439   this-&gt;<a class="code" href="classlibMesh_1_1System.php#ab181e4e31e37f117493cc3d0f74d0f25">user_QOI_derivative</a>(qoi_indices);
<a name="l00440"></a>00440 
<a name="l00441"></a>00441   <span class="comment">// Stop logging the user code</span>
<a name="l00442"></a>00442   STOP_LOG(<span class="stringliteral">&quot;assemble_qoi_derivative()&quot;</span>, <span class="stringliteral">&quot;System&quot;</span>);
<a name="l00443"></a>00443 }
<a name="l00444"></a>00444 
<a name="l00445"></a>00445 
<a name="l00446"></a>00446 
<a name="l00447"></a>00447 <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a4fd540ebc82189c84815d2e50b4a04c2">System::qoi_parameter_sensitivity</a>
<a name="l00448"></a><a class="code" href="classlibMesh_1_1System.php#a4fd540ebc82189c84815d2e50b4a04c2">00448</a>   (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a>&amp; qoi_indices,
<a name="l00449"></a>00449    <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ParameterVector.php">ParameterVector</a>&amp; parameters,
<a name="l00450"></a>00450    <a class="code" href="classlibMesh_1_1SensitivityData.php">SensitivityData</a>&amp; sensitivities)
<a name="l00451"></a>00451 {
<a name="l00452"></a>00452   <span class="comment">// Forward sensitivities are more efficient for Nq &gt; Np</span>
<a name="l00453"></a>00453   <span class="keywordflow">if</span> (qoi_indices.<a class="code" href="classlibMesh_1_1QoISet.php#a89f3599e625d010d25012ddc308c06c8">size</a>(*<span class="keyword">this</span>) &gt; parameters.<a class="code" href="classlibMesh_1_1ParameterVector.php#a820adeed54c94a2459b154b71bd304cf">size</a>())
<a name="l00454"></a>00454     forward_qoi_parameter_sensitivity(qoi_indices, parameters, sensitivities);
<a name="l00455"></a>00455   <span class="comment">// Adjoint sensitivities are more efficient for Np &gt; Nq,</span>
<a name="l00456"></a>00456   <span class="comment">// and an adjoint may be more reusable than a forward </span>
<a name="l00457"></a>00457   <span class="comment">// solution sensitivity in the Np == Nq case.</span>
<a name="l00458"></a>00458   <span class="keywordflow">else</span>
<a name="l00459"></a>00459     adjoint_qoi_parameter_sensitivity(qoi_indices, parameters, sensitivities);
<a name="l00460"></a>00460 }
<a name="l00461"></a>00461 
<a name="l00462"></a>00462 
<a name="l00463"></a>00463 
<a name="l00464"></a><a class="code" href="classlibMesh_1_1System.php#a8a3e5f73bb8c49d5d69ed59849e9b20e">00464</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1System.php#a8a3e5f73bb8c49d5d69ed59849e9b20e">System::compare</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a>&amp; other_system, 
<a name="l00465"></a>00465                       <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> threshold,
<a name="l00466"></a>00466                       <span class="keyword">const</span> <span class="keywordtype">bool</span> verbose)<span class="keyword"> const</span>
<a name="l00467"></a>00467 <span class="keyword"></span>{
<a name="l00468"></a>00468   <span class="comment">// we do not care for matrices, but for vectors</span>
<a name="l00469"></a>00469   libmesh_assert (!<a class="code" href="classlibMesh_1_1System.php#adc22ea07ed2a681eef304a471715cc85">_can_add_vectors</a>);
<a name="l00470"></a>00470   libmesh_assert (!other_system.<a class="code" href="classlibMesh_1_1System.php#adc22ea07ed2a681eef304a471715cc85">_can_add_vectors</a>);
<a name="l00471"></a>00471 
<a name="l00472"></a>00472   <span class="keywordflow">if</span> (verbose)
<a name="l00473"></a>00473     {
<a name="l00474"></a>00474       <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;  Systems \&quot;&quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1System.php#aa6ed4b98503185caee2e333148b8f457">_sys_name</a> &lt;&lt; <span class="stringliteral">&quot;\&quot;&quot;</span> &lt;&lt; std::endl;
<a name="l00475"></a>00475       <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;   comparing matrices not supported.&quot;</span> &lt;&lt; std::endl;
<a name="l00476"></a>00476       <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;   comparing names...&quot;</span>;
<a name="l00477"></a>00477     }
<a name="l00478"></a>00478 
<a name="l00479"></a>00479   <span class="comment">// compare the name: 0 means identical</span>
<a name="l00480"></a>00480   <span class="keyword">const</span> <span class="keywordtype">int</span> name_result = <a class="code" href="classlibMesh_1_1System.php#aa6ed4b98503185caee2e333148b8f457">_sys_name</a>.compare(other_system.<a class="code" href="classlibMesh_1_1System.php#af80f6b2e508821ebd9c8fcb78d443f18">name</a>());
<a name="l00481"></a>00481   <span class="keywordflow">if</span> (verbose)
<a name="l00482"></a>00482     {
<a name="l00483"></a>00483       <span class="keywordflow">if</span> (name_result == 0)
<a name="l00484"></a>00484         <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot; identical.&quot;</span> &lt;&lt; std::endl;
<a name="l00485"></a>00485       <span class="keywordflow">else</span>
<a name="l00486"></a>00486         <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;  names not identical.&quot;</span> &lt;&lt; std::endl;
<a name="l00487"></a>00487       <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;   comparing solution vector...&quot;</span>;
<a name="l00488"></a>00488     }
<a name="l00489"></a>00489 
<a name="l00490"></a>00490 
<a name="l00491"></a>00491   <span class="comment">// compare the solution: -1 means identical</span>
<a name="l00492"></a>00492   <span class="keyword">const</span> <span class="keywordtype">int</span> solu_result = <a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;compare (*other_system.<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>(),
<a name="l00493"></a>00493                                              threshold);
<a name="l00494"></a>00494 
<a name="l00495"></a>00495   <span class="keywordflow">if</span> (verbose)
<a name="l00496"></a>00496     {
<a name="l00497"></a>00497       <span class="keywordflow">if</span> (solu_result == -1)
<a name="l00498"></a>00498         <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot; identical up to threshold.&quot;</span> &lt;&lt; std::endl;
<a name="l00499"></a>00499       <span class="keywordflow">else</span>
<a name="l00500"></a>00500         <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;  first difference occured at index = &quot;</span> 
<a name="l00501"></a>00501                   &lt;&lt; solu_result &lt;&lt; <span class="stringliteral">&quot;.&quot;</span> &lt;&lt; std::endl;
<a name="l00502"></a>00502     }
<a name="l00503"></a>00503 
<a name="l00504"></a>00504 
<a name="l00505"></a>00505   <span class="comment">// safety check, whether we handle at least the same number</span>
<a name="l00506"></a>00506   <span class="comment">// of vectors</span>
<a name="l00507"></a>00507   std::vector&lt;int&gt; ov_result;
<a name="l00508"></a>00508 
<a name="l00509"></a>00509   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1System.php#a46bd8cfb070bab2dc814c33749c8c21b">n_vectors</a>() != other_system.<a class="code" href="classlibMesh_1_1System.php#a46bd8cfb070bab2dc814c33749c8c21b">n_vectors</a>())
<a name="l00510"></a>00510     {
<a name="l00511"></a>00511       <span class="keywordflow">if</span> (verbose)
<a name="l00512"></a>00512         {
<a name="l00513"></a>00513           <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;   Fatal difference. This system handles &quot;</span> 
<a name="l00514"></a>00514                     &lt;&lt; this-&gt;<a class="code" href="classlibMesh_1_1System.php#a46bd8cfb070bab2dc814c33749c8c21b">n_vectors</a>() &lt;&lt; <span class="stringliteral">&quot; add&#39;l vectors,&quot;</span> &lt;&lt; std::endl
<a name="l00515"></a>00515                     &lt;&lt; <span class="stringliteral">&quot;   while the other system handles &quot;</span>
<a name="l00516"></a>00516                     &lt;&lt; other_system.<a class="code" href="classlibMesh_1_1System.php#a46bd8cfb070bab2dc814c33749c8c21b">n_vectors</a>() 
<a name="l00517"></a>00517                     &lt;&lt; <span class="stringliteral">&quot; add&#39;l vectors.&quot;</span> &lt;&lt; std::endl
<a name="l00518"></a>00518                     &lt;&lt; <span class="stringliteral">&quot;   Aborting comparison.&quot;</span> &lt;&lt; std::endl;
<a name="l00519"></a>00519         }
<a name="l00520"></a>00520       <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00521"></a>00521     }
<a name="l00522"></a>00522   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1System.php#a46bd8cfb070bab2dc814c33749c8c21b">n_vectors</a>() == 0)
<a name="l00523"></a>00523     {
<a name="l00524"></a>00524       <span class="comment">// there are no additional vectors...</span>
<a name="l00525"></a>00525       ov_result.clear ();
<a name="l00526"></a>00526     }
<a name="l00527"></a>00527   <span class="keywordflow">else</span>
<a name="l00528"></a>00528     {
<a name="l00529"></a>00529       <span class="comment">// compare other vectors</span>
<a name="l00530"></a>00530       <span class="keywordflow">for</span> (<a class="code" href="classlibMesh_1_1System.php#aa4c2b06e622c0a42bce85716cad92fbd">const_vectors_iterator</a> pos = <a class="code" href="classlibMesh_1_1System.php#a4068a7b090c2b32e2c73c018b4e22a80">_vectors</a>.begin();
<a name="l00531"></a>00531            pos != <a class="code" href="classlibMesh_1_1System.php#a4068a7b090c2b32e2c73c018b4e22a80">_vectors</a>.end(); ++pos)
<a name="l00532"></a>00532         {
<a name="l00533"></a>00533           <span class="keywordflow">if</span> (verbose)
<a name="l00534"></a>00534               <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;   comparing vector \&quot;&quot;</span>
<a name="l00535"></a>00535                         &lt;&lt; pos-&gt;first &lt;&lt; <span class="stringliteral">&quot;\&quot; ...&quot;</span>;
<a name="l00536"></a>00536 
<a name="l00537"></a>00537           <span class="comment">// assume they have the same name</span>
<a name="l00538"></a>00538           <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>&amp; other_system_vector = 
<a name="l00539"></a>00539               other_system.<a class="code" href="classlibMesh_1_1System.php#a2ac8d1d590ae4b663bb7163c709c9e7a">get_vector</a>(pos-&gt;first);
<a name="l00540"></a>00540 
<a name="l00541"></a>00541           ov_result.push_back(pos-&gt;second-&gt;compare (other_system_vector,
<a name="l00542"></a>00542                                                     threshold));
<a name="l00543"></a>00543 
<a name="l00544"></a>00544           <span class="keywordflow">if</span> (verbose)
<a name="l00545"></a>00545             {
<a name="l00546"></a>00546               <span class="keywordflow">if</span> (ov_result[ov_result.size()-1] == -1)
<a name="l00547"></a>00547                 <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot; identical up to threshold.&quot;</span> &lt;&lt; std::endl;
<a name="l00548"></a>00548               <span class="keywordflow">else</span>
<a name="l00549"></a>00549                 <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot; first difference occured at&quot;</span> &lt;&lt; std::endl
<a name="l00550"></a>00550                           &lt;&lt; <span class="stringliteral">&quot;   index = &quot;</span> &lt;&lt; ov_result[ov_result.size()-1] &lt;&lt; <span class="stringliteral">&quot;.&quot;</span> &lt;&lt; std::endl;
<a name="l00551"></a>00551             }
<a name="l00552"></a>00552 
<a name="l00553"></a>00553         }
<a name="l00554"></a>00554 
<a name="l00555"></a>00555     } <span class="comment">// finished comparing additional vectors</span>
<a name="l00556"></a>00556 
<a name="l00557"></a>00557 
<a name="l00558"></a>00558   <span class="keywordtype">bool</span> overall_result;
<a name="l00559"></a>00559        
<a name="l00560"></a>00560   <span class="comment">// sum up the results</span>
<a name="l00561"></a>00561   <span class="keywordflow">if</span> ((name_result==0) &amp;&amp; (solu_result==-1))
<a name="l00562"></a>00562     {
<a name="l00563"></a>00563       <span class="keywordflow">if</span> (ov_result.size()==0)
<a name="l00564"></a>00564         overall_result = <span class="keyword">true</span>;
<a name="l00565"></a>00565       <span class="keywordflow">else</span>
<a name="l00566"></a>00566         {
<a name="l00567"></a>00567           <span class="keywordtype">bool</span> ov_identical;
<a name="l00568"></a>00568           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n    = 0;
<a name="l00569"></a>00569           <span class="keywordflow">do</span>
<a name="l00570"></a>00570             {
<a name="l00571"></a>00571               ov_identical = (ov_result[n]==-1);
<a name="l00572"></a>00572               n++;
<a name="l00573"></a>00573             }
<a name="l00574"></a>00574           <span class="keywordflow">while</span> (ov_identical &amp;&amp; n&lt;ov_result.size());
<a name="l00575"></a>00575           overall_result = ov_identical;
<a name="l00576"></a>00576         }
<a name="l00577"></a>00577     }
<a name="l00578"></a>00578   <span class="keywordflow">else</span>
<a name="l00579"></a>00579     overall_result = <span class="keyword">false</span>;
<a name="l00580"></a>00580 
<a name="l00581"></a>00581   <span class="keywordflow">if</span> (verbose)
<a name="l00582"></a>00582     {
<a name="l00583"></a>00583       <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;   finished comparisons, &quot;</span>;
<a name="l00584"></a>00584       <span class="keywordflow">if</span> (overall_result)
<a name="l00585"></a>00585         <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;found no differences.&quot;</span> &lt;&lt; std::endl &lt;&lt; std::endl;
<a name="l00586"></a>00586       <span class="keywordflow">else</span> 
<a name="l00587"></a>00587         <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;found differences.&quot;</span> &lt;&lt; std::endl &lt;&lt; std::endl;
<a name="l00588"></a>00588     }
<a name="l00589"></a>00589           
<a name="l00590"></a>00590   <span class="keywordflow">return</span> overall_result;
<a name="l00591"></a>00591 }
<a name="l00592"></a>00592 
<a name="l00593"></a>00593 
<a name="l00594"></a>00594 
<a name="l00595"></a><a class="code" href="classlibMesh_1_1System.php#ad4975cc3fa5f1e70fd9a6073a25abc78">00595</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#ad4975cc3fa5f1e70fd9a6073a25abc78">System::update_global_solution</a> (std::vector&lt;Number&gt;&amp; global_soln)<span class="keyword"> const</span>
<a name="l00596"></a>00596 <span class="keyword"></span>{
<a name="l00597"></a>00597   global_soln.resize (<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;size());
<a name="l00598"></a>00598 
<a name="l00599"></a>00599   <a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;localize (global_soln);
<a name="l00600"></a>00600 }
<a name="l00601"></a>00601 
<a name="l00602"></a>00602 
<a name="l00603"></a>00603 
<a name="l00604"></a><a class="code" href="classlibMesh_1_1System.php#a8c5c7bb82eaa47ec8c59a2aef04e99c5">00604</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#ad4975cc3fa5f1e70fd9a6073a25abc78">System::update_global_solution</a> (std::vector&lt;Number&gt;&amp; global_soln,
<a name="l00605"></a>00605                                      <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>   dest_proc)<span class="keyword"> const</span>
<a name="l00606"></a>00606 <span class="keyword"></span>{
<a name="l00607"></a>00607   global_soln.resize        (<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;size());
<a name="l00608"></a>00608 
<a name="l00609"></a>00609   <a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;localize_to_one (global_soln, dest_proc);
<a name="l00610"></a>00610 }
<a name="l00611"></a>00611 
<a name="l00612"></a>00612 
<a name="l00613"></a>00613 
<a name="l00614"></a><a class="code" href="classlibMesh_1_1System.php#a59ce4b808a4b8226da70e1cfa36dad7c">00614</a> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp; <a class="code" href="classlibMesh_1_1System.php#a59ce4b808a4b8226da70e1cfa36dad7c">System::add_vector</a> (<span class="keyword">const</span> std::string&amp; vec_name,
<a name="l00615"></a>00615                                             <span class="keyword">const</span> <span class="keywordtype">bool</span> projections,
<a name="l00616"></a>00616                                             <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> type)
<a name="l00617"></a>00617 {
<a name="l00618"></a>00618   <span class="comment">// Return the vector if it is already there.</span>
<a name="l00619"></a>00619   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1System.php#a3d09f6a50bbf0d99489b88091d509a0f">have_vector</a>(vec_name))
<a name="l00620"></a>00620     <span class="keywordflow">return</span> *(<a class="code" href="classlibMesh_1_1System.php#a4068a7b090c2b32e2c73c018b4e22a80">_vectors</a>[vec_name]);
<a name="l00621"></a>00621 
<a name="l00622"></a>00622   <span class="comment">// Otherwise build the vector</span>
<a name="l00623"></a>00623   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>* buf = <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;::build</a>().release();
<a name="l00624"></a>00624   <a class="code" href="classlibMesh_1_1System.php#a4068a7b090c2b32e2c73c018b4e22a80">_vectors</a>.insert (std::make_pair (vec_name, buf));
<a name="l00625"></a>00625   <a class="code" href="classlibMesh_1_1System.php#a96f148e01190c571cc92789fb5cd5ca4">_vector_projections</a>.insert (std::make_pair (vec_name, projections));
<a name="l00626"></a>00626 
<a name="l00627"></a>00627   <a class="code" href="classlibMesh_1_1System.php#a2623509811966d32d649c6c135f43c6c">_vector_types</a>.insert (std::make_pair (vec_name, type));
<a name="l00628"></a>00628 
<a name="l00629"></a>00629   <span class="comment">// Initialize it if necessary</span>
<a name="l00630"></a>00630   <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1System.php#adc22ea07ed2a681eef304a471715cc85">_can_add_vectors</a>)
<a name="l00631"></a>00631   {
<a name="l00632"></a>00632     <span class="keywordflow">if</span>(type == <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa9f12475bbe90a64ad167ec0b856ca6c1">GHOSTED</a>)
<a name="l00633"></a>00633     {
<a name="l00634"></a>00634 <span class="preprocessor">#ifdef LIBMESH_ENABLE_GHOSTED</span>
<a name="l00635"></a>00635 <span class="preprocessor"></span>      buf-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#aba2b1e60a94162764c07732626a8231b">init</a> (this-&gt;<a class="code" href="classlibMesh_1_1System.php#a90dbb901f00c14ff18399f4afabcebe5">n_dofs</a>(), this-&gt;<a class="code" href="classlibMesh_1_1System.php#ae3aeb82e65b06789823d41da3c5df7a2">n_local_dofs</a>(),
<a name="l00636"></a>00636                  <a class="code" href="classlibMesh_1_1System.php#a7386701e1324744b8d08db251374926b">_dof_map</a>-&gt;get_send_list(), <span class="keyword">false</span>,
<a name="l00637"></a>00637                  <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa9f12475bbe90a64ad167ec0b856ca6c1">GHOSTED</a>);
<a name="l00638"></a>00638 <span class="preprocessor">#else</span>
<a name="l00639"></a>00639 <span class="preprocessor"></span>      std::cerr &lt;&lt; <span class="stringliteral">&quot;Cannot initialize ghosted vectors when they are not enabled.&quot;</span> &lt;&lt; std::endl;
<a name="l00640"></a>00640       libmesh_error();
<a name="l00641"></a>00641 <span class="preprocessor">#endif</span>
<a name="l00642"></a>00642 <span class="preprocessor"></span>    }
<a name="l00643"></a>00643     <span class="keywordflow">else</span>
<a name="l00644"></a>00644       buf-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#aba2b1e60a94162764c07732626a8231b">init</a> (this-&gt;<a class="code" href="classlibMesh_1_1System.php#a90dbb901f00c14ff18399f4afabcebe5">n_dofs</a>(), this-&gt;<a class="code" href="classlibMesh_1_1System.php#ae3aeb82e65b06789823d41da3c5df7a2">n_local_dofs</a>(), <span class="keyword">false</span>, type);
<a name="l00645"></a>00645   }
<a name="l00646"></a>00646 
<a name="l00647"></a>00647   <span class="keywordflow">return</span> *buf;
<a name="l00648"></a>00648 }
<a name="l00649"></a>00649 
<a name="l00650"></a>00650 
<a name="l00651"></a>00651 
<a name="l00652"></a><a class="code" href="classlibMesh_1_1System.php#aa1098d22312396ab1de8256f50c5a351">00652</a> <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> * <a class="code" href="classlibMesh_1_1System.php#aa1098d22312396ab1de8256f50c5a351">System::request_vector</a> (<span class="keyword">const</span> std::string&amp; vec_name)<span class="keyword"> const</span>
<a name="l00653"></a>00653 <span class="keyword"></span>{
<a name="l00654"></a>00654   <a class="code" href="classlibMesh_1_1System.php#aa4c2b06e622c0a42bce85716cad92fbd">const_vectors_iterator</a> pos = <a class="code" href="classlibMesh_1_1System.php#a4068a7b090c2b32e2c73c018b4e22a80">_vectors</a>.find(vec_name);
<a name="l00655"></a>00655   
<a name="l00656"></a>00656   <span class="keywordflow">if</span> (pos == <a class="code" href="classlibMesh_1_1System.php#a4068a7b090c2b32e2c73c018b4e22a80">_vectors</a>.end())
<a name="l00657"></a>00657     <span class="keywordflow">return</span> NULL;
<a name="l00658"></a>00658   
<a name="l00659"></a>00659   <span class="keywordflow">return</span> pos-&gt;second;
<a name="l00660"></a>00660 }
<a name="l00661"></a>00661 
<a name="l00662"></a>00662 
<a name="l00663"></a>00663 
<a name="l00664"></a><a class="code" href="classlibMesh_1_1System.php#a941e30c1444b1226150a1e0e8b3111ef">00664</a> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> * <a class="code" href="classlibMesh_1_1System.php#aa1098d22312396ab1de8256f50c5a351">System::request_vector</a> (<span class="keyword">const</span> std::string&amp; vec_name)
<a name="l00665"></a>00665 {
<a name="l00666"></a>00666   <a class="code" href="classlibMesh_1_1System.php#a6a75b971c5614203f50d5a922df9253c">vectors_iterator</a> pos = <a class="code" href="classlibMesh_1_1System.php#a4068a7b090c2b32e2c73c018b4e22a80">_vectors</a>.find(vec_name);
<a name="l00667"></a>00667   
<a name="l00668"></a>00668   <span class="keywordflow">if</span> (pos == <a class="code" href="classlibMesh_1_1System.php#a4068a7b090c2b32e2c73c018b4e22a80">_vectors</a>.end())
<a name="l00669"></a>00669     <span class="keywordflow">return</span> NULL;
<a name="l00670"></a>00670   
<a name="l00671"></a>00671   <span class="keywordflow">return</span> pos-&gt;second;
<a name="l00672"></a>00672 }
<a name="l00673"></a>00673 
<a name="l00674"></a>00674 
<a name="l00675"></a>00675 
<a name="l00676"></a><a class="code" href="classlibMesh_1_1System.php#a5d1b6411c265710301c4decf4b14c31b">00676</a> <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> * <a class="code" href="classlibMesh_1_1System.php#aa1098d22312396ab1de8256f50c5a351">System::request_vector</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> vec_num)<span class="keyword"> const</span>
<a name="l00677"></a>00677 <span class="keyword"></span>{
<a name="l00678"></a>00678   <a class="code" href="classlibMesh_1_1System.php#aa4c2b06e622c0a42bce85716cad92fbd">const_vectors_iterator</a> v = <a class="code" href="classlibMesh_1_1System.php#a293a39e0a532954f5c643b5d3650c048">vectors_begin</a>();
<a name="l00679"></a>00679   <a class="code" href="classlibMesh_1_1System.php#aa4c2b06e622c0a42bce85716cad92fbd">const_vectors_iterator</a> v_end = <a class="code" href="classlibMesh_1_1System.php#a8bad75f37fdc2e047d73830d182e1314">vectors_end</a>();
<a name="l00680"></a>00680   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> num = 0;
<a name="l00681"></a>00681   <span class="keywordflow">while</span>((num&lt;vec_num) &amp;&amp; (v!=v_end))
<a name="l00682"></a>00682     {
<a name="l00683"></a>00683       num++;
<a name="l00684"></a>00684       ++v;
<a name="l00685"></a>00685     }
<a name="l00686"></a>00686   <span class="keywordflow">if</span> (v==v_end)
<a name="l00687"></a>00687     <span class="keywordflow">return</span> NULL;
<a name="l00688"></a>00688   <span class="keywordflow">return</span> v-&gt;second;
<a name="l00689"></a>00689 }
<a name="l00690"></a>00690 
<a name="l00691"></a>00691 
<a name="l00692"></a>00692 
<a name="l00693"></a><a class="code" href="classlibMesh_1_1System.php#a7a4c16924aa396c1e27f1e2697bb859b">00693</a> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> * <a class="code" href="classlibMesh_1_1System.php#aa1098d22312396ab1de8256f50c5a351">System::request_vector</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> vec_num)
<a name="l00694"></a>00694 {
<a name="l00695"></a>00695   <a class="code" href="classlibMesh_1_1System.php#a6a75b971c5614203f50d5a922df9253c">vectors_iterator</a> v = <a class="code" href="classlibMesh_1_1System.php#a293a39e0a532954f5c643b5d3650c048">vectors_begin</a>();
<a name="l00696"></a>00696   <a class="code" href="classlibMesh_1_1System.php#a6a75b971c5614203f50d5a922df9253c">vectors_iterator</a> v_end = <a class="code" href="classlibMesh_1_1System.php#a8bad75f37fdc2e047d73830d182e1314">vectors_end</a>();
<a name="l00697"></a>00697   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> num = 0;
<a name="l00698"></a>00698   <span class="keywordflow">while</span>((num&lt;vec_num) &amp;&amp; (v!=v_end))
<a name="l00699"></a>00699     {
<a name="l00700"></a>00700       num++;
<a name="l00701"></a>00701       ++v;
<a name="l00702"></a>00702     }
<a name="l00703"></a>00703   <span class="keywordflow">if</span> (v==v_end)
<a name="l00704"></a>00704     <span class="keywordflow">return</span> NULL;
<a name="l00705"></a>00705   <span class="keywordflow">return</span> v-&gt;second;
<a name="l00706"></a>00706 }
<a name="l00707"></a>00707 
<a name="l00708"></a>00708 
<a name="l00709"></a>00709 
<a name="l00710"></a><a class="code" href="classlibMesh_1_1System.php#a2ac8d1d590ae4b663bb7163c709c9e7a">00710</a> <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp; <a class="code" href="classlibMesh_1_1System.php#a2ac8d1d590ae4b663bb7163c709c9e7a">System::get_vector</a> (<span class="keyword">const</span> std::string&amp; vec_name)<span class="keyword"> const</span>
<a name="l00711"></a>00711 <span class="keyword"></span>{
<a name="l00712"></a>00712   <span class="comment">// Make sure the vector exists</span>
<a name="l00713"></a>00713   <a class="code" href="classlibMesh_1_1System.php#aa4c2b06e622c0a42bce85716cad92fbd">const_vectors_iterator</a> pos = <a class="code" href="classlibMesh_1_1System.php#a4068a7b090c2b32e2c73c018b4e22a80">_vectors</a>.find(vec_name);
<a name="l00714"></a>00714   
<a name="l00715"></a>00715   <span class="keywordflow">if</span> (pos == <a class="code" href="classlibMesh_1_1System.php#a4068a7b090c2b32e2c73c018b4e22a80">_vectors</a>.end())
<a name="l00716"></a>00716     {
<a name="l00717"></a>00717       <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: vector &quot;</span>
<a name="l00718"></a>00718                     &lt;&lt; vec_name
<a name="l00719"></a>00719                     &lt;&lt; <span class="stringliteral">&quot; does not exist in this system!&quot;</span>
<a name="l00720"></a>00720                     &lt;&lt; std::endl;      
<a name="l00721"></a>00721       libmesh_error();
<a name="l00722"></a>00722     }
<a name="l00723"></a>00723   
<a name="l00724"></a>00724   <span class="keywordflow">return</span> *(pos-&gt;second);
<a name="l00725"></a>00725 }
<a name="l00726"></a>00726 
<a name="l00727"></a>00727 
<a name="l00728"></a>00728 
<a name="l00729"></a><a class="code" href="classlibMesh_1_1System.php#a805848aa7c59454145ed90b124130413">00729</a> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp; <a class="code" href="classlibMesh_1_1System.php#a2ac8d1d590ae4b663bb7163c709c9e7a">System::get_vector</a> (<span class="keyword">const</span> std::string&amp; vec_name)
<a name="l00730"></a>00730 {
<a name="l00731"></a>00731   <span class="comment">// Make sure the vector exists</span>
<a name="l00732"></a>00732   <a class="code" href="classlibMesh_1_1System.php#a6a75b971c5614203f50d5a922df9253c">vectors_iterator</a> pos = <a class="code" href="classlibMesh_1_1System.php#a4068a7b090c2b32e2c73c018b4e22a80">_vectors</a>.find(vec_name);
<a name="l00733"></a>00733   
<a name="l00734"></a>00734   <span class="keywordflow">if</span> (pos == <a class="code" href="classlibMesh_1_1System.php#a4068a7b090c2b32e2c73c018b4e22a80">_vectors</a>.end())
<a name="l00735"></a>00735     {
<a name="l00736"></a>00736       <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: vector &quot;</span>
<a name="l00737"></a>00737                     &lt;&lt; vec_name
<a name="l00738"></a>00738                     &lt;&lt; <span class="stringliteral">&quot; does not exist in this system!&quot;</span>
<a name="l00739"></a>00739                     &lt;&lt; std::endl;      
<a name="l00740"></a>00740       libmesh_error();
<a name="l00741"></a>00741     }
<a name="l00742"></a>00742   
<a name="l00743"></a>00743   <span class="keywordflow">return</span> *(pos-&gt;second);
<a name="l00744"></a>00744 }
<a name="l00745"></a>00745 
<a name="l00746"></a>00746 
<a name="l00747"></a>00747 
<a name="l00748"></a><a class="code" href="classlibMesh_1_1System.php#aa61673ce724fff56da3e6fc2913684db">00748</a> <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp; <a class="code" href="classlibMesh_1_1System.php#a2ac8d1d590ae4b663bb7163c709c9e7a">System::get_vector</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> vec_num)<span class="keyword"> const</span>
<a name="l00749"></a>00749 <span class="keyword"></span>{
<a name="l00750"></a>00750   <a class="code" href="classlibMesh_1_1System.php#aa4c2b06e622c0a42bce85716cad92fbd">const_vectors_iterator</a> v = <a class="code" href="classlibMesh_1_1System.php#a293a39e0a532954f5c643b5d3650c048">vectors_begin</a>();
<a name="l00751"></a>00751   <a class="code" href="classlibMesh_1_1System.php#aa4c2b06e622c0a42bce85716cad92fbd">const_vectors_iterator</a> v_end = <a class="code" href="classlibMesh_1_1System.php#a8bad75f37fdc2e047d73830d182e1314">vectors_end</a>();
<a name="l00752"></a>00752   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> num = 0;
<a name="l00753"></a>00753   <span class="keywordflow">while</span>((num&lt;vec_num) &amp;&amp; (v!=v_end))
<a name="l00754"></a>00754     {
<a name="l00755"></a>00755       num++;
<a name="l00756"></a>00756       ++v;
<a name="l00757"></a>00757     }
<a name="l00758"></a>00758   libmesh_assert(v!=v_end);
<a name="l00759"></a>00759   <span class="keywordflow">return</span> *(v-&gt;second);
<a name="l00760"></a>00760 }
<a name="l00761"></a>00761 
<a name="l00762"></a>00762 
<a name="l00763"></a>00763 
<a name="l00764"></a><a class="code" href="classlibMesh_1_1System.php#a5eecf3fc4893f55bb46d783af3d85baf">00764</a> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp; <a class="code" href="classlibMesh_1_1System.php#a2ac8d1d590ae4b663bb7163c709c9e7a">System::get_vector</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> vec_num)
<a name="l00765"></a>00765 {
<a name="l00766"></a>00766   <a class="code" href="classlibMesh_1_1System.php#a6a75b971c5614203f50d5a922df9253c">vectors_iterator</a> v = <a class="code" href="classlibMesh_1_1System.php#a293a39e0a532954f5c643b5d3650c048">vectors_begin</a>();
<a name="l00767"></a>00767   <a class="code" href="classlibMesh_1_1System.php#a6a75b971c5614203f50d5a922df9253c">vectors_iterator</a> v_end = <a class="code" href="classlibMesh_1_1System.php#a8bad75f37fdc2e047d73830d182e1314">vectors_end</a>();
<a name="l00768"></a>00768   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> num = 0;
<a name="l00769"></a>00769   <span class="keywordflow">while</span>((num&lt;vec_num) &amp;&amp; (v!=v_end))
<a name="l00770"></a>00770     {
<a name="l00771"></a>00771       num++;
<a name="l00772"></a>00772       ++v;
<a name="l00773"></a>00773     }
<a name="l00774"></a>00774   libmesh_assert(v!=v_end);
<a name="l00775"></a>00775   <span class="keywordflow">return</span> *(v-&gt;second);
<a name="l00776"></a>00776 }
<a name="l00777"></a>00777 
<a name="l00778"></a>00778 
<a name="l00779"></a>00779 
<a name="l00780"></a><a class="code" href="classlibMesh_1_1System.php#a63a2a2e98a9932173e5b8607ab03687e">00780</a> <span class="keyword">const</span> std::string&amp; <a class="code" href="classlibMesh_1_1System.php#a63a2a2e98a9932173e5b8607ab03687e">System::vector_name</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> vec_num)
<a name="l00781"></a>00781 {
<a name="l00782"></a>00782   <a class="code" href="classlibMesh_1_1System.php#aa4c2b06e622c0a42bce85716cad92fbd">const_vectors_iterator</a> v = <a class="code" href="classlibMesh_1_1System.php#a293a39e0a532954f5c643b5d3650c048">vectors_begin</a>();
<a name="l00783"></a>00783   <a class="code" href="classlibMesh_1_1System.php#aa4c2b06e622c0a42bce85716cad92fbd">const_vectors_iterator</a> v_end = <a class="code" href="classlibMesh_1_1System.php#a8bad75f37fdc2e047d73830d182e1314">vectors_end</a>();
<a name="l00784"></a>00784   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> num = 0;
<a name="l00785"></a>00785   <span class="keywordflow">while</span>((num&lt;vec_num) &amp;&amp; (v!=v_end))
<a name="l00786"></a>00786     {
<a name="l00787"></a>00787       num++;
<a name="l00788"></a>00788       ++v;
<a name="l00789"></a>00789     }
<a name="l00790"></a>00790   libmesh_assert(v!=v_end);
<a name="l00791"></a>00791   <span class="keywordflow">return</span> v-&gt;first;
<a name="l00792"></a>00792 }
<a name="l00793"></a>00793 
<a name="l00794"></a>00794 
<a name="l00795"></a>00795 
<a name="l00796"></a><a class="code" href="classlibMesh_1_1System.php#a8af728122cdd5677dc5a78e698bd1b35">00796</a> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp; <a class="code" href="classlibMesh_1_1System.php#a8af728122cdd5677dc5a78e698bd1b35">System::add_sensitivity_solution</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)
<a name="l00797"></a>00797 {
<a name="l00798"></a>00798   <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> sensitivity_name;
<a name="l00799"></a>00799   sensitivity_name &lt;&lt; <span class="stringliteral">&quot;sensitivity_solution&quot;</span> &lt;&lt; i;
<a name="l00800"></a>00800 
<a name="l00801"></a>00801   <span class="keywordflow">return</span> this-&gt;<a class="code" href="classlibMesh_1_1System.php#a59ce4b808a4b8226da70e1cfa36dad7c">add_vector</a>(sensitivity_name.str());
<a name="l00802"></a>00802 }
<a name="l00803"></a>00803 
<a name="l00804"></a>00804 
<a name="l00805"></a><a class="code" href="classlibMesh_1_1System.php#a920173d7f09d6f17b4451f354b7bccac">00805</a> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp; <a class="code" href="classlibMesh_1_1System.php#a920173d7f09d6f17b4451f354b7bccac">System::get_sensitivity_solution</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)
<a name="l00806"></a>00806 {
<a name="l00807"></a>00807   <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> sensitivity_name;
<a name="l00808"></a>00808   sensitivity_name &lt;&lt; <span class="stringliteral">&quot;sensitivity_solution&quot;</span> &lt;&lt; i;
<a name="l00809"></a>00809 
<a name="l00810"></a>00810   <span class="keywordflow">return</span> this-&gt;<a class="code" href="classlibMesh_1_1System.php#a2ac8d1d590ae4b663bb7163c709c9e7a">get_vector</a>(sensitivity_name.str());
<a name="l00811"></a>00811 }
<a name="l00812"></a>00812 
<a name="l00813"></a>00813 
<a name="l00814"></a>00814 
<a name="l00815"></a><a class="code" href="classlibMesh_1_1System.php#a94373373f4ceb680968c8f8ebcac4bfd">00815</a> <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp; <a class="code" href="classlibMesh_1_1System.php#a920173d7f09d6f17b4451f354b7bccac">System::get_sensitivity_solution</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00816"></a>00816 <span class="keyword"></span>{
<a name="l00817"></a>00817   <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> sensitivity_name;
<a name="l00818"></a>00818   sensitivity_name &lt;&lt; <span class="stringliteral">&quot;sensitivity_solution&quot;</span> &lt;&lt; i;
<a name="l00819"></a>00819 
<a name="l00820"></a>00820   <span class="keywordflow">return</span> this-&gt;<a class="code" href="classlibMesh_1_1System.php#a2ac8d1d590ae4b663bb7163c709c9e7a">get_vector</a>(sensitivity_name.str());
<a name="l00821"></a>00821 }
<a name="l00822"></a>00822 
<a name="l00823"></a>00823 
<a name="l00824"></a>00824 
<a name="l00825"></a><a class="code" href="classlibMesh_1_1System.php#ae1922f73d344e6e1bea9100fec966e54">00825</a> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp; <a class="code" href="classlibMesh_1_1System.php#ae1922f73d344e6e1bea9100fec966e54">System::add_weighted_sensitivity_solution</a> ()
<a name="l00826"></a>00826 {
<a name="l00827"></a>00827   <span class="keywordflow">return</span> this-&gt;<a class="code" href="classlibMesh_1_1System.php#a59ce4b808a4b8226da70e1cfa36dad7c">add_vector</a>(<span class="stringliteral">&quot;weighted_sensitivity_solution&quot;</span>);
<a name="l00828"></a>00828 }
<a name="l00829"></a>00829 
<a name="l00830"></a>00830 
<a name="l00831"></a>00831 
<a name="l00832"></a><a class="code" href="classlibMesh_1_1System.php#ad4168ae004bc141639bb8b2b44de45cc">00832</a> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp; <a class="code" href="classlibMesh_1_1System.php#ad4168ae004bc141639bb8b2b44de45cc">System::get_weighted_sensitivity_solution</a> ()
<a name="l00833"></a>00833 {
<a name="l00834"></a>00834   <span class="keywordflow">return</span> this-&gt;<a class="code" href="classlibMesh_1_1System.php#a2ac8d1d590ae4b663bb7163c709c9e7a">get_vector</a>(<span class="stringliteral">&quot;weighted_sensitivity_solution&quot;</span>);
<a name="l00835"></a>00835 }
<a name="l00836"></a>00836 
<a name="l00837"></a>00837 
<a name="l00838"></a>00838 
<a name="l00839"></a><a class="code" href="classlibMesh_1_1System.php#ac08a4777e59167b26c810c75772e974a">00839</a> <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp; <a class="code" href="classlibMesh_1_1System.php#ad4168ae004bc141639bb8b2b44de45cc">System::get_weighted_sensitivity_solution</a> ()<span class="keyword"> const</span>
<a name="l00840"></a>00840 <span class="keyword"></span>{
<a name="l00841"></a>00841   <span class="keywordflow">return</span> this-&gt;<a class="code" href="classlibMesh_1_1System.php#a2ac8d1d590ae4b663bb7163c709c9e7a">get_vector</a>(<span class="stringliteral">&quot;weighted_sensitivity_solution&quot;</span>);
<a name="l00842"></a>00842 }
<a name="l00843"></a>00843 
<a name="l00844"></a>00844 
<a name="l00845"></a>00845 
<a name="l00846"></a><a class="code" href="classlibMesh_1_1System.php#ab5777831398d0a7a0d8ef2a231824989">00846</a> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp; <a class="code" href="classlibMesh_1_1System.php#ab5777831398d0a7a0d8ef2a231824989">System::add_adjoint_solution</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)
<a name="l00847"></a>00847 {
<a name="l00848"></a>00848   <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> adjoint_name;
<a name="l00849"></a>00849   adjoint_name &lt;&lt; <span class="stringliteral">&quot;adjoint_solution&quot;</span> &lt;&lt; i;
<a name="l00850"></a>00850 
<a name="l00851"></a>00851   <span class="keywordflow">return</span> this-&gt;<a class="code" href="classlibMesh_1_1System.php#a59ce4b808a4b8226da70e1cfa36dad7c">add_vector</a>(adjoint_name.str());
<a name="l00852"></a>00852 }
<a name="l00853"></a>00853 
<a name="l00854"></a>00854 
<a name="l00855"></a>00855 
<a name="l00856"></a><a class="code" href="classlibMesh_1_1System.php#aeaf02ff714b2d9b6aca4e8d696856529">00856</a> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp; <a class="code" href="classlibMesh_1_1System.php#aeaf02ff714b2d9b6aca4e8d696856529">System::get_adjoint_solution</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)
<a name="l00857"></a>00857 {
<a name="l00858"></a>00858   <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> adjoint_name;
<a name="l00859"></a>00859   adjoint_name &lt;&lt; <span class="stringliteral">&quot;adjoint_solution&quot;</span> &lt;&lt; i;
<a name="l00860"></a>00860 
<a name="l00861"></a>00861   <span class="keywordflow">return</span> this-&gt;<a class="code" href="classlibMesh_1_1System.php#a2ac8d1d590ae4b663bb7163c709c9e7a">get_vector</a>(adjoint_name.str());
<a name="l00862"></a>00862 }
<a name="l00863"></a>00863 
<a name="l00864"></a>00864 
<a name="l00865"></a>00865 
<a name="l00866"></a><a class="code" href="classlibMesh_1_1System.php#aff763590396fc13d20827142198592e7">00866</a> <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp; <a class="code" href="classlibMesh_1_1System.php#aeaf02ff714b2d9b6aca4e8d696856529">System::get_adjoint_solution</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00867"></a>00867 <span class="keyword"></span>{
<a name="l00868"></a>00868   <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> adjoint_name;
<a name="l00869"></a>00869   adjoint_name &lt;&lt; <span class="stringliteral">&quot;adjoint_solution&quot;</span> &lt;&lt; i;
<a name="l00870"></a>00870 
<a name="l00871"></a>00871   <span class="keywordflow">return</span> this-&gt;<a class="code" href="classlibMesh_1_1System.php#a2ac8d1d590ae4b663bb7163c709c9e7a">get_vector</a>(adjoint_name.str());
<a name="l00872"></a>00872 }
<a name="l00873"></a>00873 
<a name="l00874"></a>00874 
<a name="l00875"></a>00875 
<a name="l00876"></a><a class="code" href="classlibMesh_1_1System.php#a16e412144b3c5c1cc59cbb9e52b9ab05">00876</a> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp; <a class="code" href="classlibMesh_1_1System.php#a16e412144b3c5c1cc59cbb9e52b9ab05">System::add_weighted_sensitivity_adjoint_solution</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)
<a name="l00877"></a>00877 {
<a name="l00878"></a>00878   <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> adjoint_name;
<a name="l00879"></a>00879   adjoint_name &lt;&lt; <span class="stringliteral">&quot;weighted_sensitivity_adjoint_solution&quot;</span> &lt;&lt; i;
<a name="l00880"></a>00880 
<a name="l00881"></a>00881   <span class="keywordflow">return</span> this-&gt;<a class="code" href="classlibMesh_1_1System.php#a59ce4b808a4b8226da70e1cfa36dad7c">add_vector</a>(adjoint_name.str());
<a name="l00882"></a>00882 }
<a name="l00883"></a>00883 
<a name="l00884"></a>00884 
<a name="l00885"></a>00885 
<a name="l00886"></a><a class="code" href="classlibMesh_1_1System.php#a497665a8b66520f587e5e5102c94420c">00886</a> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp; <a class="code" href="classlibMesh_1_1System.php#a497665a8b66520f587e5e5102c94420c">System::get_weighted_sensitivity_adjoint_solution</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)
<a name="l00887"></a>00887 {
<a name="l00888"></a>00888   <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> adjoint_name;
<a name="l00889"></a>00889   adjoint_name &lt;&lt; <span class="stringliteral">&quot;weighted_sensitivity_adjoint_solution&quot;</span> &lt;&lt; i;
<a name="l00890"></a>00890 
<a name="l00891"></a>00891   <span class="keywordflow">return</span> this-&gt;<a class="code" href="classlibMesh_1_1System.php#a2ac8d1d590ae4b663bb7163c709c9e7a">get_vector</a>(adjoint_name.str());
<a name="l00892"></a>00892 }
<a name="l00893"></a>00893 
<a name="l00894"></a>00894 
<a name="l00895"></a>00895 
<a name="l00896"></a><a class="code" href="classlibMesh_1_1System.php#ab363af94629536786940958b38f38010">00896</a> <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp; <a class="code" href="classlibMesh_1_1System.php#a497665a8b66520f587e5e5102c94420c">System::get_weighted_sensitivity_adjoint_solution</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00897"></a>00897 <span class="keyword"></span>{
<a name="l00898"></a>00898   <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> adjoint_name;
<a name="l00899"></a>00899   adjoint_name &lt;&lt; <span class="stringliteral">&quot;weighted_sensitivity_adjoint_solution&quot;</span> &lt;&lt; i;
<a name="l00900"></a>00900 
<a name="l00901"></a>00901   <span class="keywordflow">return</span> this-&gt;<a class="code" href="classlibMesh_1_1System.php#a2ac8d1d590ae4b663bb7163c709c9e7a">get_vector</a>(adjoint_name.str());
<a name="l00902"></a>00902 }
<a name="l00903"></a>00903 
<a name="l00904"></a>00904 
<a name="l00905"></a>00905 
<a name="l00906"></a><a class="code" href="classlibMesh_1_1System.php#ab21c031f38c12ff111865623561b6687">00906</a> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp; <a class="code" href="classlibMesh_1_1System.php#ab21c031f38c12ff111865623561b6687">System::add_adjoint_rhs</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)
<a name="l00907"></a>00907 {
<a name="l00908"></a>00908   <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> adjoint_rhs_name;
<a name="l00909"></a>00909   adjoint_rhs_name &lt;&lt; <span class="stringliteral">&quot;adjoint_rhs&quot;</span> &lt;&lt; i;
<a name="l00910"></a>00910 
<a name="l00911"></a>00911   <span class="keywordflow">return</span> this-&gt;<a class="code" href="classlibMesh_1_1System.php#a59ce4b808a4b8226da70e1cfa36dad7c">add_vector</a>(adjoint_rhs_name.str(), <span class="keyword">false</span>);
<a name="l00912"></a>00912 }
<a name="l00913"></a>00913 
<a name="l00914"></a>00914 
<a name="l00915"></a>00915 
<a name="l00916"></a><a class="code" href="classlibMesh_1_1System.php#afe988921e219358881c49d1fa7303507">00916</a> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp; <a class="code" href="classlibMesh_1_1System.php#afe988921e219358881c49d1fa7303507">System::get_adjoint_rhs</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)
<a name="l00917"></a>00917 {
<a name="l00918"></a>00918   <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> adjoint_rhs_name;
<a name="l00919"></a>00919   adjoint_rhs_name &lt;&lt; <span class="stringliteral">&quot;adjoint_rhs&quot;</span> &lt;&lt; i;
<a name="l00920"></a>00920 
<a name="l00921"></a>00921   <span class="keywordflow">return</span> this-&gt;<a class="code" href="classlibMesh_1_1System.php#a2ac8d1d590ae4b663bb7163c709c9e7a">get_vector</a>(adjoint_rhs_name.str());
<a name="l00922"></a>00922 }
<a name="l00923"></a>00923 
<a name="l00924"></a>00924 
<a name="l00925"></a>00925 
<a name="l00926"></a><a class="code" href="classlibMesh_1_1System.php#a51faae6da9b7a003b5ad500f01d2d2e4">00926</a> <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp; <a class="code" href="classlibMesh_1_1System.php#afe988921e219358881c49d1fa7303507">System::get_adjoint_rhs</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00927"></a>00927 <span class="keyword"></span>{
<a name="l00928"></a>00928   <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> adjoint_rhs_name;
<a name="l00929"></a>00929   adjoint_rhs_name &lt;&lt; <span class="stringliteral">&quot;adjoint_rhs&quot;</span> &lt;&lt; i;
<a name="l00930"></a>00930 
<a name="l00931"></a>00931   <span class="keywordflow">return</span> this-&gt;<a class="code" href="classlibMesh_1_1System.php#a2ac8d1d590ae4b663bb7163c709c9e7a">get_vector</a>(adjoint_rhs_name.str());
<a name="l00932"></a>00932 }
<a name="l00933"></a>00933 
<a name="l00934"></a>00934 
<a name="l00935"></a>00935 
<a name="l00936"></a><a class="code" href="classlibMesh_1_1System.php#a65312b9004fc31ba812b7ec32515a2fa">00936</a> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp; <a class="code" href="classlibMesh_1_1System.php#a65312b9004fc31ba812b7ec32515a2fa">System::add_sensitivity_rhs</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)
<a name="l00937"></a>00937 {
<a name="l00938"></a>00938   <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> sensitivity_rhs_name;
<a name="l00939"></a>00939   sensitivity_rhs_name &lt;&lt; <span class="stringliteral">&quot;sensitivity_rhs&quot;</span> &lt;&lt; i;
<a name="l00940"></a>00940 
<a name="l00941"></a>00941   <span class="keywordflow">return</span> this-&gt;<a class="code" href="classlibMesh_1_1System.php#a59ce4b808a4b8226da70e1cfa36dad7c">add_vector</a>(sensitivity_rhs_name.str(), <span class="keyword">false</span>);
<a name="l00942"></a>00942 }
<a name="l00943"></a>00943 
<a name="l00944"></a>00944 
<a name="l00945"></a>00945 
<a name="l00946"></a><a class="code" href="classlibMesh_1_1System.php#aad3023ee4c1d7ff532fab06136eed63c">00946</a> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp; <a class="code" href="classlibMesh_1_1System.php#aad3023ee4c1d7ff532fab06136eed63c">System::get_sensitivity_rhs</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)
<a name="l00947"></a>00947 {
<a name="l00948"></a>00948   <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> sensitivity_rhs_name;
<a name="l00949"></a>00949   sensitivity_rhs_name &lt;&lt; <span class="stringliteral">&quot;sensitivity_rhs&quot;</span> &lt;&lt; i;
<a name="l00950"></a>00950 
<a name="l00951"></a>00951   <span class="keywordflow">return</span> this-&gt;<a class="code" href="classlibMesh_1_1System.php#a2ac8d1d590ae4b663bb7163c709c9e7a">get_vector</a>(sensitivity_rhs_name.str());
<a name="l00952"></a>00952 }
<a name="l00953"></a>00953 
<a name="l00954"></a>00954 
<a name="l00955"></a>00955 
<a name="l00956"></a><a class="code" href="classlibMesh_1_1System.php#a90ed3a6cb7e47b3caa7f9b4e8893874f">00956</a> <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp; <a class="code" href="classlibMesh_1_1System.php#aad3023ee4c1d7ff532fab06136eed63c">System::get_sensitivity_rhs</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00957"></a>00957 <span class="keyword"></span>{
<a name="l00958"></a>00958   <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> sensitivity_rhs_name;
<a name="l00959"></a>00959   sensitivity_rhs_name &lt;&lt; <span class="stringliteral">&quot;sensitivity_rhs&quot;</span> &lt;&lt; i;
<a name="l00960"></a>00960 
<a name="l00961"></a>00961   <span class="keywordflow">return</span> this-&gt;<a class="code" href="classlibMesh_1_1System.php#a2ac8d1d590ae4b663bb7163c709c9e7a">get_vector</a>(sensitivity_rhs_name.str());
<a name="l00962"></a>00962 }
<a name="l00963"></a>00963 
<a name="l00964"></a>00964 
<a name="l00965"></a>00965 
<a name="l00966"></a><a class="code" href="classlibMesh_1_1System.php#a9455625733b8137030b388772b094817">00966</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#a9455625733b8137030b388772b094817">System::add_variable</a> (<span class="keyword">const</span> std::string&amp; var,
<a name="l00967"></a>00967                                    <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; type,
<a name="l00968"></a>00968                                    <span class="keyword">const</span> std::set&lt;subdomain_id_type&gt; * <span class="keyword">const</span> active_subdomains)
<a name="l00969"></a>00969 {  
<a name="l00970"></a>00970   <span class="comment">// Make sure the variable isn&#39;t there already</span>
<a name="l00971"></a>00971   <span class="comment">// or if it is, that it&#39;s the type we want</span>
<a name="l00972"></a>00972   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> v=0; v&lt;this-&gt;<a class="code" href="classlibMesh_1_1System.php#a4cf032eda109fe32a7fcde672ef5726e">n_vars</a>(); v++)
<a name="l00973"></a>00973     <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1System.php#a9cddad5dd8b68389373567fddfbdb257">variable_name</a>(v) == var)
<a name="l00974"></a>00974       {
<a name="l00975"></a>00975         <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1System.php#ab321ab954fa1284069a647b311ff6d17">variable_type</a>(v) == type)
<a name="l00976"></a>00976           <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1System.php#a17fc76a7e9339dcc3c834a646169bf0e">_variables</a>[v].<a class="code" href="classlibMesh_1_1System.php#aee5caacb487b070842733f1c84b9a2fd">number</a>();
<a name="l00977"></a>00977 
<a name="l00978"></a>00978         <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: incompatible variable &quot;</span>
<a name="l00979"></a>00979                       &lt;&lt; var
<a name="l00980"></a>00980                       &lt;&lt; <span class="stringliteral">&quot; has already been added for this system!&quot;</span>
<a name="l00981"></a>00981                       &lt;&lt; std::endl;
<a name="l00982"></a>00982         libmesh_error();
<a name="l00983"></a>00983       }
<a name="l00984"></a>00984 
<a name="l00985"></a>00985   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> curr_n_vars = this-&gt;<a class="code" href="classlibMesh_1_1System.php#a4cf032eda109fe32a7fcde672ef5726e">n_vars</a>();                                              
<a name="l00986"></a>00986 
<a name="l00987"></a>00987   <span class="comment">// Add the variable to the list</span>
<a name="l00988"></a>00988   <a class="code" href="classlibMesh_1_1System.php#a17fc76a7e9339dcc3c834a646169bf0e">_variables</a>.push_back((active_subdomains == NULL) ?
<a name="l00989"></a>00989                        <a class="code" href="classlibMesh_1_1Variable.php">Variable</a>(var, curr_n_vars, type) :
<a name="l00990"></a>00990                        <a class="code" href="classlibMesh_1_1Variable.php">Variable</a>(var, curr_n_vars, type, *active_subdomains));
<a name="l00991"></a>00991 
<a name="l00992"></a>00992   libmesh_assert ((curr_n_vars+1) == this-&gt;<a class="code" href="classlibMesh_1_1System.php#a4cf032eda109fe32a7fcde672ef5726e">n_vars</a>());
<a name="l00993"></a>00993 
<a name="l00994"></a>00994   <a class="code" href="classlibMesh_1_1System.php#aca4105a9e0b687784fa38b95bd999d80">_variable_numbers</a>[var] = curr_n_vars;
<a name="l00995"></a>00995 
<a name="l00996"></a>00996   <span class="comment">// Add the variable to the _dof_map</span>
<a name="l00997"></a>00997   <a class="code" href="classlibMesh_1_1System.php#a7386701e1324744b8d08db251374926b">_dof_map</a>-&gt;add_variable (<a class="code" href="classlibMesh_1_1System.php#a17fc76a7e9339dcc3c834a646169bf0e">_variables</a>.back());
<a name="l00998"></a>00998 
<a name="l00999"></a>00999   <span class="comment">// Return the number of the new variable</span>
<a name="l01000"></a>01000   <span class="keywordflow">return</span> curr_n_vars;
<a name="l01001"></a>01001 }
<a name="l01002"></a>01002 
<a name="l01003"></a>01003 
<a name="l01004"></a>01004 
<a name="l01005"></a><a class="code" href="classlibMesh_1_1System.php#a65f15d740ded6472329144f3c9b3fef6">01005</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#a9455625733b8137030b388772b094817">System::add_variable</a> (<span class="keyword">const</span> std::string&amp; var,
<a name="l01006"></a>01006                                    <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> order,
<a name="l01007"></a>01007                                    <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5">FEFamily</a> family,
<a name="l01008"></a>01008                                    <span class="keyword">const</span> std::set&lt;subdomain_id_type&gt; * <span class="keyword">const</span> active_subdomains)
<a name="l01009"></a>01009 {
<a name="l01010"></a>01010   <span class="keywordflow">return</span> this-&gt;<a class="code" href="classlibMesh_1_1System.php#a9455625733b8137030b388772b094817">add_variable</a>(var, 
<a name="l01011"></a>01011                             <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>(order, family), 
<a name="l01012"></a>01012                             active_subdomains);
<a name="l01013"></a>01013 }
<a name="l01014"></a>01014 
<a name="l01015"></a>01015 
<a name="l01016"></a>01016 
<a name="l01017"></a><a class="code" href="classlibMesh_1_1System.php#a700306a949024804a0933b98f406a71b">01017</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1System.php#a700306a949024804a0933b98f406a71b">System::has_variable</a> (<span class="keyword">const</span> std::string&amp; var)<span class="keyword"> const</span>
<a name="l01018"></a>01018 <span class="keyword"></span>{
<a name="l01019"></a>01019   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1System.php#aca4105a9e0b687784fa38b95bd999d80">_variable_numbers</a>.count(var);
<a name="l01020"></a>01020 }
<a name="l01021"></a>01021 
<a name="l01022"></a>01022 
<a name="l01023"></a>01023 
<a name="l01024"></a><a class="code" href="classlibMesh_1_1System.php#aeda27e9696b02cf965e2340fc9e64857">01024</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#aeda27e9696b02cf965e2340fc9e64857">System::variable_number</a> (<span class="keyword">const</span> std::string&amp; var)<span class="keyword"> const</span>
<a name="l01025"></a>01025 <span class="keyword"></span>{
<a name="l01026"></a>01026   <span class="comment">// Make sure the variable exists</span>
<a name="l01027"></a>01027   std::map&lt;std::string, unsigned short int&gt;::const_iterator
<a name="l01028"></a>01028     pos = <a class="code" href="classlibMesh_1_1System.php#aca4105a9e0b687784fa38b95bd999d80">_variable_numbers</a>.find(var);
<a name="l01029"></a>01029   
<a name="l01030"></a>01030   <span class="keywordflow">if</span> (pos == <a class="code" href="classlibMesh_1_1System.php#aca4105a9e0b687784fa38b95bd999d80">_variable_numbers</a>.end())
<a name="l01031"></a>01031     {
<a name="l01032"></a>01032       <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: variable &quot;</span>
<a name="l01033"></a>01033                     &lt;&lt; var
<a name="l01034"></a>01034                     &lt;&lt; <span class="stringliteral">&quot; does not exist in this system!&quot;</span>
<a name="l01035"></a>01035                     &lt;&lt; std::endl;      
<a name="l01036"></a>01036       libmesh_error();
<a name="l01037"></a>01037     }
<a name="l01038"></a>01038   libmesh_assert (<a class="code" href="classlibMesh_1_1System.php#a17fc76a7e9339dcc3c834a646169bf0e">_variables</a>[pos-&gt;second].name() == var);
<a name="l01039"></a>01039 
<a name="l01040"></a>01040   <span class="keywordflow">return</span> pos-&gt;second;
<a name="l01041"></a>01041 }
<a name="l01042"></a>01042 
<a name="l01043"></a>01043 
<a name="l01044"></a><a class="code" href="classlibMesh_1_1System.php#a7184315a233256f4d8d0591d62b28f63">01044</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a7184315a233256f4d8d0591d62b28f63">System::local_dof_indices</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var, std::set&lt;unsigned int&gt; &amp; var_indices)<span class="keyword"> const</span>
<a name="l01045"></a>01045 <span class="keyword"></span>{
<a name="l01046"></a>01046   <span class="comment">// Make sure the set is clear</span>
<a name="l01047"></a>01047   var_indices.clear();
<a name="l01048"></a>01048 
<a name="l01049"></a>01049   std::vector&lt;unsigned int&gt; dof_indices;
<a name="l01050"></a>01050   
<a name="l01051"></a>01051   <span class="comment">// Begin the loop over the elements</span>
<a name="l01052"></a>01052   <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>       el     =
<a name="l01053"></a>01053     this-&gt;<a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">get_mesh</a>().<a class="code" href="classlibMesh_1_1MeshBase.php#a99742bad0b034a29ccae8c5a90c6f4aa">active_local_elements_begin</a>();
<a name="l01054"></a>01054   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end_el =
<a name="l01055"></a>01055     this-&gt;<a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">get_mesh</a>().<a class="code" href="classlibMesh_1_1MeshBase.php#a2e27f54d33f7539c0c06b36adae36cda">active_local_elements_end</a>();
<a name="l01056"></a>01056 
<a name="l01057"></a>01057   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> 
<a name="l01058"></a>01058     first_local = this-&gt;<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>().<a class="code" href="classlibMesh_1_1DofMap.php#ad2b15648e708f656a798bd642c3ca8e3">first_dof</a>(),
<a name="l01059"></a>01059     end_local   = this-&gt;<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>().<a class="code" href="classlibMesh_1_1DofMap.php#abf250ac3decfedbe00ddaeef85ed4de4">end_dof</a>();
<a name="l01060"></a>01060 
<a name="l01061"></a>01061   <span class="keywordflow">for</span> ( ; el != end_el; ++el)
<a name="l01062"></a>01062     {
<a name="l01063"></a>01063       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = *el;      
<a name="l01064"></a>01064       this-&gt;<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>().<a class="code" href="classlibMesh_1_1DofMap.php#a5dac22ba99a9da3563c00b7dfd2f07af">dof_indices</a> (elem, dof_indices, var);
<a name="l01065"></a>01065 
<a name="l01066"></a>01066       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;dof_indices.size(); i++)
<a name="l01067"></a>01067         {
<a name="l01068"></a>01068           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dof = dof_indices[i];
<a name="l01069"></a>01069 
<a name="l01070"></a>01070           <span class="comment">//If the dof is owned by the local processor</span>
<a name="l01071"></a>01071           <span class="keywordflow">if</span>(first_local &lt;= dof &amp;&amp; dof &lt; end_local)
<a name="l01072"></a>01072             var_indices.insert(dof_indices[i]);
<a name="l01073"></a>01073         }
<a name="l01074"></a>01074     }
<a name="l01075"></a>01075 }
<a name="l01076"></a>01076 
<a name="l01077"></a><a class="code" href="classlibMesh_1_1System.php#a1768b0db365db97ce4486167dca4efff">01077</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a1768b0db365db97ce4486167dca4efff">System::zero_variable</a> (<a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>&amp; v, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var_num)<span class="keyword"> const</span>
<a name="l01078"></a>01078 <span class="keyword"></span>{
<a name="l01079"></a>01079   <span class="comment">/* Make sure the call makes sense.  */</span>
<a name="l01080"></a>01080   libmesh_assert(var_num&lt;this-&gt;<a class="code" href="classlibMesh_1_1System.php#a4cf032eda109fe32a7fcde672ef5726e">n_vars</a>());
<a name="l01081"></a>01081 
<a name="l01082"></a>01082   <span class="comment">/* Get a reference to the mesh.  */</span>
<a name="l01083"></a>01083   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a> = this-&gt;<a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">get_mesh</a>();
<a name="l01084"></a>01084 
<a name="l01085"></a>01085   <span class="comment">/* Check which system we are.  */</span>
<a name="l01086"></a>01086   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sys_num = this-&gt;<a class="code" href="classlibMesh_1_1System.php#aee5caacb487b070842733f1c84b9a2fd">number</a>();
<a name="l01087"></a>01087 
<a name="l01088"></a>01088   <span class="comment">/* Loop over nodes.  */</span>
<a name="l01089"></a>01089   {
<a name="l01090"></a>01090     <a class="code" href="structlibMesh_1_1MeshBase_1_1const__node__iterator.php">MeshBase::const_node_iterator</a> it = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a7a87dbe56aaa89961e03d60a25a36e8b">local_nodes_begin</a>();
<a name="l01091"></a>01091     <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__node__iterator.php">MeshBase::const_node_iterator</a> end_it = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ad0daaecd9c183194a99609db6507198c">local_nodes_end</a>(); 
<a name="l01092"></a>01092     <span class="keywordflow">for</span> ( ; it != end_it; ++it)
<a name="l01093"></a>01093       {    
<a name="l01094"></a>01094         <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a>* node = *it;
<a name="l01095"></a>01095         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_comp = node-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a6710a2bb047a60ef54bfe702432114f8">n_comp</a>(sys_num,var_num);
<a name="l01096"></a>01096         <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_comp; i++)
<a name="l01097"></a>01097           {
<a name="l01098"></a>01098             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index = node-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a99664433bae4e638f8befc83cec4eeff">dof_number</a>(sys_num,var_num,i);
<a name="l01099"></a>01099             v.<a class="code" href="classlibMesh_1_1NumericVector.php#a51bd7e4c6afb223573ec051777133c9b">set</a>(index,0.0);
<a name="l01100"></a>01100           }
<a name="l01101"></a>01101       }
<a name="l01102"></a>01102   }
<a name="l01103"></a>01103 
<a name="l01104"></a>01104   <span class="comment">/* Loop over elements.  */</span>
<a name="l01105"></a>01105   {
<a name="l01106"></a>01106     <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> it = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a99742bad0b034a29ccae8c5a90c6f4aa">active_local_elements_begin</a>();
<a name="l01107"></a>01107     <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end_it = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a2e27f54d33f7539c0c06b36adae36cda">active_local_elements_end</a>(); 
<a name="l01108"></a>01108     <span class="keywordflow">for</span> ( ; it != end_it; ++it)
<a name="l01109"></a>01109       {    
<a name="l01110"></a>01110         <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = *it;
<a name="l01111"></a>01111         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_comp = elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a6710a2bb047a60ef54bfe702432114f8">n_comp</a>(sys_num,var_num);
<a name="l01112"></a>01112         <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_comp; i++)
<a name="l01113"></a>01113           {
<a name="l01114"></a>01114             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index = elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a99664433bae4e638f8befc83cec4eeff">dof_number</a>(sys_num,var_num,i);
<a name="l01115"></a>01115             v.<a class="code" href="classlibMesh_1_1NumericVector.php#a51bd7e4c6afb223573ec051777133c9b">set</a>(index,0.0);
<a name="l01116"></a>01116           }
<a name="l01117"></a>01117       }
<a name="l01118"></a>01118   }
<a name="l01119"></a>01119 }
<a name="l01120"></a>01120 
<a name="l01121"></a><a class="code" href="classlibMesh_1_1System.php#a9118db90385450eddb5738ce2f9ebec0">01121</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1System.php#a9118db90385450eddb5738ce2f9ebec0">System::discrete_var_norm</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>&amp; v,
<a name="l01122"></a>01122                                <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var,
<a name="l01123"></a>01123                                <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098">FEMNormType</a> norm_type)<span class="keyword"> const</span>
<a name="l01124"></a>01124 <span class="keyword"></span>{
<a name="l01125"></a>01125   std::set&lt;unsigned int&gt; var_indices;
<a name="l01126"></a>01126   <a class="code" href="classlibMesh_1_1System.php#a7184315a233256f4d8d0591d62b28f63">local_dof_indices</a>(var, var_indices);
<a name="l01127"></a>01127 
<a name="l01128"></a>01128   <span class="keywordflow">if</span>(norm_type == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098ad5b9182056de3e279abd0e8120c1c774">DISCRETE_L1</a>)
<a name="l01129"></a>01129     <span class="keywordflow">return</span> v.<a class="code" href="classlibMesh_1_1NumericVector.php#af561f729821ed58c47edb831c04d1910">subset_l1_norm</a>(var_indices);
<a name="l01130"></a>01130   <span class="keywordflow">if</span>(norm_type == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a482797897c042873f53453795347edb6">DISCRETE_L2</a>)
<a name="l01131"></a>01131     <span class="keywordflow">return</span> v.<a class="code" href="classlibMesh_1_1NumericVector.php#a7c28e73b0d19b29b425446466f0a3c78">subset_l2_norm</a>(var_indices);
<a name="l01132"></a>01132   <span class="keywordflow">if</span>(norm_type == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098ae354be98c29a8529ca57555180313292">DISCRETE_L_INF</a>)
<a name="l01133"></a>01133     <span class="keywordflow">return</span> v.<a class="code" href="classlibMesh_1_1NumericVector.php#a72e4e7c12301bb3b990b12491fabcfdd">subset_linfty_norm</a>(var_indices);
<a name="l01134"></a>01134   <span class="keywordflow">else</span>
<a name="l01135"></a>01135     libmesh_error();
<a name="l01136"></a>01136 }
<a name="l01137"></a>01137 
<a name="l01138"></a><a class="code" href="classlibMesh_1_1System.php#a3153155431e918a782fabedcaf58e4e6">01138</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1System.php#a3153155431e918a782fabedcaf58e4e6">System::calculate_norm</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>&amp; v,
<a name="l01139"></a>01139                             <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var,
<a name="l01140"></a>01140                             <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098">FEMNormType</a> norm_type)<span class="keyword"> const</span>
<a name="l01141"></a>01141 <span class="keyword"></span>{
<a name="l01142"></a>01142   <span class="comment">//short circuit to save time</span>
<a name="l01143"></a>01143   <span class="keywordflow">if</span>(norm_type == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098ad5b9182056de3e279abd0e8120c1c774">DISCRETE_L1</a> ||
<a name="l01144"></a>01144      norm_type == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a482797897c042873f53453795347edb6">DISCRETE_L2</a> ||
<a name="l01145"></a>01145      norm_type == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098ae354be98c29a8529ca57555180313292">DISCRETE_L_INF</a>)
<a name="l01146"></a>01146     <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1System.php#a9118db90385450eddb5738ce2f9ebec0">discrete_var_norm</a>(v,var,norm_type);
<a name="l01147"></a>01147 
<a name="l01148"></a>01148   <span class="comment">// Not a discrete norm</span>
<a name="l01149"></a>01149   std::vector&lt;FEMNormType&gt; norms(this-&gt;<a class="code" href="classlibMesh_1_1System.php#a4cf032eda109fe32a7fcde672ef5726e">n_vars</a>(), <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a81428a949c80fd4e4178fe53fa94ce92">L2</a>);
<a name="l01150"></a>01150   std::vector&lt;Real&gt; weights(this-&gt;<a class="code" href="classlibMesh_1_1System.php#a4cf032eda109fe32a7fcde672ef5726e">n_vars</a>(), 0.0);
<a name="l01151"></a>01151   norms[var] = norm_type;
<a name="l01152"></a>01152   weights[var] = 1.0;
<a name="l01153"></a>01153   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> val = this-&gt;<a class="code" href="classlibMesh_1_1System.php#a3153155431e918a782fabedcaf58e4e6">calculate_norm</a>(v, <a class="code" href="classlibMesh_1_1SystemNorm.php">SystemNorm</a>(norms, weights));
<a name="l01154"></a>01154   <span class="keywordflow">return</span> val;
<a name="l01155"></a>01155 }
<a name="l01156"></a>01156 
<a name="l01157"></a>01157 
<a name="l01158"></a>01158 
<a name="l01159"></a><a class="code" href="classlibMesh_1_1System.php#a1105a347b46aceaefb97e5e97ce7802d">01159</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1System.php#a3153155431e918a782fabedcaf58e4e6">System::calculate_norm</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>&amp; v,
<a name="l01160"></a>01160                             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1SystemNorm.php">SystemNorm</a> &amp;norm)<span class="keyword"> const</span>
<a name="l01161"></a>01161 <span class="keyword"></span>{
<a name="l01162"></a>01162   <span class="comment">// This function must be run on all processors at once</span>
<a name="l01163"></a>01163   parallel_only();
<a name="l01164"></a>01164 
<a name="l01165"></a>01165   START_LOG (<span class="stringliteral">&quot;calculate_norm()&quot;</span>, <span class="stringliteral">&quot;System&quot;</span>);
<a name="l01166"></a>01166 
<a name="l01167"></a>01167   <span class="comment">// Zero the norm before summation</span>
<a name="l01168"></a>01168   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> v_norm = 0.;
<a name="l01169"></a>01169 
<a name="l01170"></a>01170   <span class="keywordflow">if</span> (norm.<a class="code" href="classlibMesh_1_1SystemNorm.php#a31678e569cf9f6c1e4d13de2315b5d64">is_discrete</a>())
<a name="l01171"></a>01171     {
<a name="l01172"></a>01172       STOP_LOG (<span class="stringliteral">&quot;calculate_norm()&quot;</span>, <span class="stringliteral">&quot;System&quot;</span>);
<a name="l01173"></a>01173       <span class="comment">//Check to see if all weights are 1.0 and all types are equal</span>
<a name="l01174"></a>01174       <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098">FEMNormType</a> norm_type0 = norm.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(0);
<a name="l01175"></a>01175       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> check_var = 0;
<a name="l01176"></a>01176       <span class="keywordflow">for</span> (; check_var != this-&gt;<a class="code" href="classlibMesh_1_1System.php#a4cf032eda109fe32a7fcde672ef5726e">n_vars</a>(); ++check_var)
<a name="l01177"></a>01177         <span class="keywordflow">if</span>((norm.<a class="code" href="classlibMesh_1_1SystemNorm.php#ac8a59940264314511d0e4f253433e76b">weight</a>(check_var) != 1.0) || (norm.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(check_var) != norm_type0))
<a name="l01178"></a>01178           <span class="keywordflow">break</span>;
<a name="l01179"></a>01179 
<a name="l01180"></a>01180       <span class="comment">//All weights were 1.0 so just do the full vector discrete norm</span>
<a name="l01181"></a>01181       <span class="keywordflow">if</span>(check_var == this-&gt;<a class="code" href="classlibMesh_1_1System.php#a4cf032eda109fe32a7fcde672ef5726e">n_vars</a>())
<a name="l01182"></a>01182         {
<a name="l01183"></a>01183           <span class="keywordflow">if</span>(norm_type0 == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098ad5b9182056de3e279abd0e8120c1c774">DISCRETE_L1</a>)
<a name="l01184"></a>01184             <span class="keywordflow">return</span> v.<a class="code" href="classlibMesh_1_1NumericVector.php#a110a36d7800daa4bb8b91e35419d335d">l1_norm</a>();
<a name="l01185"></a>01185           <span class="keywordflow">if</span>(norm_type0 == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a482797897c042873f53453795347edb6">DISCRETE_L2</a>)
<a name="l01186"></a>01186             <span class="keywordflow">return</span> v.<a class="code" href="classlibMesh_1_1NumericVector.php#a7bbf5b5a75e7aafcbfc1ea19fbc51d73">l2_norm</a>();
<a name="l01187"></a>01187           <span class="keywordflow">if</span>(norm_type0 == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098ae354be98c29a8529ca57555180313292">DISCRETE_L_INF</a>)
<a name="l01188"></a>01188             <span class="keywordflow">return</span> v.<a class="code" href="classlibMesh_1_1NumericVector.php#a9dce53bc73ed63fa006bc5083a6922eb">linfty_norm</a>();
<a name="l01189"></a>01189           <span class="keywordflow">else</span>
<a name="l01190"></a>01190             libmesh_error();
<a name="l01191"></a>01191         }
<a name="l01192"></a>01192 
<a name="l01193"></a>01193       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var=0; var != this-&gt;<a class="code" href="classlibMesh_1_1System.php#a4cf032eda109fe32a7fcde672ef5726e">n_vars</a>(); ++var)
<a name="l01194"></a>01194         {
<a name="l01195"></a>01195           <span class="comment">// Skip any variables we don&#39;t need to integrate</span>
<a name="l01196"></a>01196           <span class="keywordflow">if</span> (norm.<a class="code" href="classlibMesh_1_1SystemNorm.php#ac8a59940264314511d0e4f253433e76b">weight</a>(var) == 0.0)
<a name="l01197"></a>01197             <span class="keywordflow">continue</span>;
<a name="l01198"></a>01198 
<a name="l01199"></a>01199           v_norm += norm.<a class="code" href="classlibMesh_1_1SystemNorm.php#ac8a59940264314511d0e4f253433e76b">weight</a>(var) * <a class="code" href="classlibMesh_1_1System.php#a9118db90385450eddb5738ce2f9ebec0">discrete_var_norm</a>(v, var, norm.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var));
<a name="l01200"></a>01200         }
<a name="l01201"></a>01201 
<a name="l01202"></a>01202       <span class="keywordflow">return</span> v_norm;
<a name="l01203"></a>01203     }
<a name="l01204"></a>01204 
<a name="l01205"></a>01205   <span class="comment">// Localize the potentially parallel vector</span>
<a name="l01206"></a>01206   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;Number&gt;</a> &gt; local_v = <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;::build</a>();
<a name="l01207"></a>01207   local_v-&gt;init(v.<a class="code" href="classlibMesh_1_1NumericVector.php#a86082d6030cb32700e7eeac6e7f26455">size</a>(), <span class="keyword">true</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa333690ccec0379e5dd4ccb60db5ea0c9">SERIAL</a>);
<a name="l01208"></a>01208   v.<a class="code" href="classlibMesh_1_1NumericVector.php#a7348b5b027adf716016354847e0df0b6">localize</a> (*local_v, <a class="code" href="classlibMesh_1_1System.php#a7386701e1324744b8d08db251374926b">_dof_map</a>-&gt;get_send_list()); 
<a name="l01209"></a>01209 
<a name="l01210"></a>01210   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim = this-&gt;<a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">get_mesh</a>().<a class="code" href="classlibMesh_1_1MeshBase.php#a1bc787d29f4c496f107aed988be4b9bf">mesh_dimension</a>();
<a name="l01211"></a>01211 
<a name="l01212"></a>01212   <span class="comment">// I&#39;m not sure how best to mix Hilbert norms on some variables (for</span>
<a name="l01213"></a>01213   <span class="comment">// which we&#39;ll want to square then sum then square root) with norms</span>
<a name="l01214"></a>01214   <span class="comment">// like L_inf (for which we&#39;ll just want to take an absolute value</span>
<a name="l01215"></a>01215   <span class="comment">// and then sum).</span>
<a name="l01216"></a>01216   <span class="keywordtype">bool</span> can_add_hilbert_norm = <span class="keyword">true</span>,
<a name="l01217"></a>01217        can_add_nonhilbert_norm = <span class="keyword">true</span>;
<a name="l01218"></a>01218 
<a name="l01219"></a>01219   <span class="comment">// Loop over all variables</span>
<a name="l01220"></a>01220   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var=0; var != this-&gt;<a class="code" href="classlibMesh_1_1System.php#a4cf032eda109fe32a7fcde672ef5726e">n_vars</a>(); ++var)
<a name="l01221"></a>01221     {
<a name="l01222"></a>01222       <span class="comment">// Skip any variables we don&#39;t need to integrate</span>
<a name="l01223"></a>01223       <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> norm_weight_sq = norm.<a class="code" href="classlibMesh_1_1SystemNorm.php#a6c84f8dbb0f519c5abef6a47ee0a4f23">weight_sq</a>(var);
<a name="l01224"></a>01224       <span class="keywordflow">if</span> (norm_weight_sq == 0.0)
<a name="l01225"></a>01225         <span class="keywordflow">continue</span>;
<a name="l01226"></a>01226       <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> norm_weight = norm.<a class="code" href="classlibMesh_1_1SystemNorm.php#ac8a59940264314511d0e4f253433e76b">weight</a>(var);
<a name="l01227"></a>01227 
<a name="l01228"></a>01228       <span class="comment">// Check for unimplemented norms (rather than just returning 0).</span>
<a name="l01229"></a>01229       <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098">FEMNormType</a> norm_type = norm.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var);
<a name="l01230"></a>01230       <span class="keywordflow">if</span>((norm_type==<a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a7a46908fc35e8855517abd137413214c">H1</a>) ||
<a name="l01231"></a>01231          (norm_type==<a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098ac7e590eaaaaf934b5c10d0497329a53b">H2</a>) ||
<a name="l01232"></a>01232          (norm_type==<a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a81428a949c80fd4e4178fe53fa94ce92">L2</a>) ||
<a name="l01233"></a>01233          (norm_type==<a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098aa9c1ddb21411ca64e2d3a671c7d1eedd">H1_SEMINORM</a>) ||
<a name="l01234"></a>01234          (norm_type==<a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a517739ce55228741cc19623e06670f23">H2_SEMINORM</a>))
<a name="l01235"></a>01235         {
<a name="l01236"></a>01236           <span class="keywordflow">if</span> (!can_add_hilbert_norm)
<a name="l01237"></a>01237             libmesh_not_implemented();
<a name="l01238"></a>01238           can_add_nonhilbert_norm = <span class="keyword">false</span>;
<a name="l01239"></a>01239         }
<a name="l01240"></a>01240       <span class="keywordflow">else</span> <span class="keywordflow">if</span> ((norm_type==<a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a51d6d223e50a3f1870c1c2182970543a">L1</a>) ||
<a name="l01241"></a>01241                (norm_type==<a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098aca29cedfeb6d15e888ac0c1c31d5ce21">L_INF</a>))
<a name="l01242"></a>01242         {
<a name="l01243"></a>01243           <span class="keywordflow">if</span> (!can_add_nonhilbert_norm)
<a name="l01244"></a>01244             libmesh_not_implemented();
<a name="l01245"></a>01245           can_add_hilbert_norm = <span class="keyword">false</span>;
<a name="l01246"></a>01246         }
<a name="l01247"></a>01247       <span class="keywordflow">else</span>
<a name="l01248"></a>01248         libmesh_not_implemented();
<a name="l01249"></a>01249 
<a name="l01250"></a>01250       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; fe_type = this-&gt;<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>().<a class="code" href="classlibMesh_1_1DofMap.php#a0c010bb250d4cd8d65794452f46d141a">variable_type</a>(var);
<a name="l01251"></a>01251       <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;QBase&gt;</a> qrule =
<a name="l01252"></a>01252         fe_type.<a class="code" href="classlibMesh_1_1FEType.php#a3f1da6f01808bcef1ee575b908f57dc4">default_quadrature_rule</a> (dim);
<a name="l01253"></a>01253       <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;FEBase&gt;</a> fe
<a name="l01254"></a>01254         (<a class="code" href="classlibMesh_1_1FEBase.php#aa6065b49a9dd684109a87770e514ff5d">FEBase::build</a>(dim, fe_type));
<a name="l01255"></a>01255       fe-&gt;attach_quadrature_rule (qrule.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>());
<a name="l01256"></a>01256 
<a name="l01257"></a>01257       <span class="keyword">const</span> std::vector&lt;Real&gt;&amp;               JxW = fe-&gt;get_JxW();
<a name="l01258"></a>01258       <span class="keyword">const</span> std::vector&lt;std::vector&lt;Real&gt; &gt;* phi = NULL;
<a name="l01259"></a>01259       <span class="keywordflow">if</span> (norm_type == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a7a46908fc35e8855517abd137413214c">H1</a> ||
<a name="l01260"></a>01260           norm_type == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098ac7e590eaaaaf934b5c10d0497329a53b">H2</a> ||
<a name="l01261"></a>01261           norm_type == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a81428a949c80fd4e4178fe53fa94ce92">L2</a> ||
<a name="l01262"></a>01262           norm_type == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a51d6d223e50a3f1870c1c2182970543a">L1</a> ||
<a name="l01263"></a>01263           norm_type == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098aca29cedfeb6d15e888ac0c1c31d5ce21">L_INF</a>)
<a name="l01264"></a>01264         phi = &amp;(fe-&gt;get_phi());
<a name="l01265"></a>01265 
<a name="l01266"></a>01266       <span class="keyword">const</span> std::vector&lt;std::vector&lt;RealGradient&gt; &gt;* dphi = NULL;
<a name="l01267"></a>01267       <span class="keywordflow">if</span> (norm_type == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a7a46908fc35e8855517abd137413214c">H1</a> ||
<a name="l01268"></a>01268           norm_type == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098ac7e590eaaaaf934b5c10d0497329a53b">H2</a> ||
<a name="l01269"></a>01269           norm_type == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098aa9c1ddb21411ca64e2d3a671c7d1eedd">H1_SEMINORM</a>)
<a name="l01270"></a>01270         dphi = &amp;(fe-&gt;get_dphi());
<a name="l01271"></a>01271 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l01272"></a>01272 <span class="preprocessor"></span>      <span class="keyword">const</span> std::vector&lt;std::vector&lt;RealTensor&gt; &gt;*   d2phi = NULL;
<a name="l01273"></a>01273       <span class="keywordflow">if</span> (norm_type == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098ac7e590eaaaaf934b5c10d0497329a53b">H2</a> ||
<a name="l01274"></a>01274           norm_type == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a517739ce55228741cc19623e06670f23">H2_SEMINORM</a>)
<a name="l01275"></a>01275         d2phi = &amp;(fe-&gt;get_d2phi());
<a name="l01276"></a>01276 <span class="preprocessor">#endif</span>
<a name="l01277"></a>01277 <span class="preprocessor"></span>
<a name="l01278"></a>01278       std::vector&lt;unsigned int&gt; dof_indices;
<a name="l01279"></a>01279 
<a name="l01280"></a>01280       <span class="comment">// Begin the loop over the elements</span>
<a name="l01281"></a>01281       <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>       el     =
<a name="l01282"></a>01282         this-&gt;<a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">get_mesh</a>().<a class="code" href="classlibMesh_1_1MeshBase.php#a99742bad0b034a29ccae8c5a90c6f4aa">active_local_elements_begin</a>();
<a name="l01283"></a>01283       <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end_el =
<a name="l01284"></a>01284         this-&gt;<a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">get_mesh</a>().<a class="code" href="classlibMesh_1_1MeshBase.php#a2e27f54d33f7539c0c06b36adae36cda">active_local_elements_end</a>();
<a name="l01285"></a>01285 
<a name="l01286"></a>01286       <span class="keywordflow">for</span> ( ; el != end_el; ++el)
<a name="l01287"></a>01287         {
<a name="l01288"></a>01288           <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = *el;
<a name="l01289"></a>01289 
<a name="l01290"></a>01290           fe-&gt;reinit (elem);
<a name="l01291"></a>01291 
<a name="l01292"></a>01292           this-&gt;<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>().<a class="code" href="classlibMesh_1_1DofMap.php#a5dac22ba99a9da3563c00b7dfd2f07af">dof_indices</a> (elem, dof_indices, var);
<a name="l01293"></a>01293 
<a name="l01294"></a>01294           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_qp = qrule-&gt;n_points();
<a name="l01295"></a>01295 
<a name="l01296"></a>01296           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_sf = dof_indices.size();
<a name="l01297"></a>01297 
<a name="l01298"></a>01298           <span class="comment">// Begin the loop over the Quadrature points.</span>
<a name="l01299"></a>01299           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp=0; qp&lt;n_qp; qp++)
<a name="l01300"></a>01300             {
<a name="l01301"></a>01301               <span class="keywordflow">if</span> (norm_type == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a51d6d223e50a3f1870c1c2182970543a">L1</a>)
<a name="l01302"></a>01302                 {
<a name="l01303"></a>01303                   <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> u_h = 0.;
<a name="l01304"></a>01304                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != n_sf; ++i)
<a name="l01305"></a>01305                     u_h += (*phi)[i][qp] * (*local_v)(dof_indices[i]);
<a name="l01306"></a>01306                   v_norm += norm_weight *
<a name="l01307"></a>01307                             JxW[qp] * std::abs(u_h);
<a name="l01308"></a>01308                 }
<a name="l01309"></a>01309 
<a name="l01310"></a>01310               <span class="keywordflow">if</span> (norm_type == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098aca29cedfeb6d15e888ac0c1c31d5ce21">L_INF</a>)
<a name="l01311"></a>01311                 {
<a name="l01312"></a>01312                   <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> u_h = 0.;
<a name="l01313"></a>01313                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != n_sf; ++i)
<a name="l01314"></a>01314                     u_h += (*phi)[i][qp] * (*local_v)(dof_indices[i]);
<a name="l01315"></a>01315                   v_norm = <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(v_norm, norm_weight * std::abs(u_h));
<a name="l01316"></a>01316                 }
<a name="l01317"></a>01317 
<a name="l01318"></a>01318               <span class="keywordflow">if</span> (norm_type == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a7a46908fc35e8855517abd137413214c">H1</a> ||
<a name="l01319"></a>01319                   norm_type == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098ac7e590eaaaaf934b5c10d0497329a53b">H2</a> ||
<a name="l01320"></a>01320                   norm_type == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a81428a949c80fd4e4178fe53fa94ce92">L2</a>)
<a name="l01321"></a>01321                 {
<a name="l01322"></a>01322                   <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> u_h = 0.;
<a name="l01323"></a>01323                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != n_sf; ++i)
<a name="l01324"></a>01324                     u_h += (*phi)[i][qp] * (*local_v)(dof_indices[i]);
<a name="l01325"></a>01325                   v_norm += norm_weight_sq *
<a name="l01326"></a>01326                             JxW[qp] * <a class="code" href="namespacelibMesh.php#a1ccf1226fe7f6e1611259752ff1ee29e">libmesh_norm</a>(u_h);
<a name="l01327"></a>01327                 }
<a name="l01328"></a>01328 
<a name="l01329"></a>01329               <span class="keywordflow">if</span> (norm_type == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a7a46908fc35e8855517abd137413214c">H1</a> ||
<a name="l01330"></a>01330                   norm_type == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098ac7e590eaaaaf934b5c10d0497329a53b">H2</a> ||
<a name="l01331"></a>01331                   norm_type == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098aa9c1ddb21411ca64e2d3a671c7d1eedd">H1_SEMINORM</a>)
<a name="l01332"></a>01332                 {
<a name="l01333"></a>01333                   <a class="code" href="classlibMesh_1_1VectorValue.php">Gradient</a> grad_u_h;
<a name="l01334"></a>01334                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != n_sf; ++i)
<a name="l01335"></a>01335                     grad_u_h.<a class="code" href="classlibMesh_1_1TypeVector.php#aaf2f65f39d9cdb06500baa2d571dc27f">add_scaled</a>((*dphi)[i][qp], (*local_v)(dof_indices[i]));
<a name="l01336"></a>01336                   v_norm += norm_weight_sq *
<a name="l01337"></a>01337                             JxW[qp] * grad_u_h.<a class="code" href="classlibMesh_1_1TypeVector.php#a6388a8db55ae02bdf8a72d0c4df45301">size_sq</a>();
<a name="l01338"></a>01338                 }
<a name="l01339"></a>01339 
<a name="l01340"></a>01340 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l01341"></a>01341 <span class="preprocessor"></span>              <span class="keywordflow">if</span> (norm_type == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098ac7e590eaaaaf934b5c10d0497329a53b">H2</a> ||
<a name="l01342"></a>01342                   norm_type == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a517739ce55228741cc19623e06670f23">H2_SEMINORM</a>)
<a name="l01343"></a>01343                 {
<a name="l01344"></a>01344                   <a class="code" href="classlibMesh_1_1TensorValue.php">Tensor</a> hess_u_h;
<a name="l01345"></a>01345                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != n_sf; ++i)
<a name="l01346"></a>01346                     hess_u_h.<a class="code" href="classlibMesh_1_1TypeTensor.php#adae55fa841255b47d85a5baf7a352ff6">add_scaled</a>((*d2phi)[i][qp], (*local_v)(dof_indices[i]));
<a name="l01347"></a>01347                   v_norm += norm_weight_sq *
<a name="l01348"></a>01348                             JxW[qp] * hess_u_h.<a class="code" href="classlibMesh_1_1TypeTensor.php#a3f195e163a89444e26e49398cbad1155">size_sq</a>();
<a name="l01349"></a>01349                 }
<a name="l01350"></a>01350 <span class="preprocessor">#endif</span>
<a name="l01351"></a>01351 <span class="preprocessor"></span>            }
<a name="l01352"></a>01352         }
<a name="l01353"></a>01353     }
<a name="l01354"></a>01354 
<a name="l01355"></a>01355   <a class="code" href="namespacelibMesh_1_1Parallel.php#a32ab26117222089e6540e66b05c06b1b">Parallel::sum</a>(v_norm);
<a name="l01356"></a>01356 
<a name="l01357"></a>01357   STOP_LOG (<span class="stringliteral">&quot;calculate_norm()&quot;</span>, <span class="stringliteral">&quot;System&quot;</span>);
<a name="l01358"></a>01358 
<a name="l01359"></a>01359   <span class="keywordflow">return</span> std::sqrt(v_norm);
<a name="l01360"></a>01360 }
<a name="l01361"></a>01361 
<a name="l01362"></a>01362 
<a name="l01363"></a>01363 
<a name="l01364"></a><a class="code" href="classlibMesh_1_1System.php#a4d4e901465589bb4d2f6a8ce19d4e2c5">01364</a> std::string <a class="code" href="classlibMesh_1_1System.php#a4d4e901465589bb4d2f6a8ce19d4e2c5">System::get_info</a>()<span class="keyword"> const</span>
<a name="l01365"></a>01365 <span class="keyword"></span>{
<a name="l01366"></a>01366   std::ostringstream <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">out</a>;
<a name="l01367"></a>01367 
<a name="l01368"></a>01368   
<a name="l01369"></a>01369   <span class="keyword">const</span> std::string&amp; sys_name = this-&gt;<a class="code" href="classlibMesh_1_1System.php#af80f6b2e508821ebd9c8fcb78d443f18">name</a>();
<a name="l01370"></a>01370       
<a name="l01371"></a>01371   out &lt;&lt; <span class="stringliteral">&quot;   System \&quot;&quot;</span> &lt;&lt; sys_name &lt;&lt; <span class="stringliteral">&quot;\&quot;\n&quot;</span>
<a name="l01372"></a>01372       &lt;&lt; <span class="stringliteral">&quot;    Type \&quot;&quot;</span>  &lt;&lt; this-&gt;<a class="code" href="classlibMesh_1_1System.php#af6548563b24dc5a00d12979b9869a4bf">system_type</a>() &lt;&lt; <span class="stringliteral">&quot;\&quot;\n&quot;</span>
<a name="l01373"></a>01373       &lt;&lt; <span class="stringliteral">&quot;    Variables=&quot;</span>;
<a name="l01374"></a>01374   
<a name="l01375"></a>01375   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> vn=0; vn&lt;this-&gt;<a class="code" href="classlibMesh_1_1System.php#a4cf032eda109fe32a7fcde672ef5726e">n_vars</a>(); vn++)
<a name="l01376"></a>01376       out &lt;&lt; <span class="stringliteral">&quot;\&quot;&quot;</span> &lt;&lt; this-&gt;<a class="code" href="classlibMesh_1_1System.php#a9cddad5dd8b68389373567fddfbdb257">variable_name</a>(vn) &lt;&lt; <span class="stringliteral">&quot;\&quot; &quot;</span>;
<a name="l01377"></a>01377      
<a name="l01378"></a>01378   out &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l01379"></a>01379 
<a name="l01380"></a>01380   out &lt;&lt; <span class="stringliteral">&quot;    Finite Element Types=&quot;</span>;
<a name="l01381"></a>01381 <span class="preprocessor">#ifndef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l01382"></a>01382 <span class="preprocessor"></span>  <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> vn=0; vn&lt;this-&gt;<a class="code" href="classlibMesh_1_1System.php#a4cf032eda109fe32a7fcde672ef5726e">n_vars</a>(); vn++)
<a name="l01383"></a>01383     out &lt;&lt; <span class="stringliteral">&quot;\&quot;&quot;</span>
<a name="l01384"></a>01384         &lt;&lt; <a class="code" href="namespacelibMesh_1_1Utility.php#a098fd61e717ccdc6e66a048756aba690">Utility::enum_to_string&lt;FEFamily&gt;</a>(this-&gt;<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>().<a class="code" href="classlibMesh_1_1DofMap.php#a0c010bb250d4cd8d65794452f46d141a">variable_type</a>(vn).<a class="code" href="classlibMesh_1_1FEType.php#ac437ba9b0a5253d6bf6f07ad277b9978">family</a>)
<a name="l01385"></a>01385         &lt;&lt; <span class="stringliteral">&quot;\&quot; &quot;</span>;  
<a name="l01386"></a>01386 <span class="preprocessor">#else</span>
<a name="l01387"></a>01387 <span class="preprocessor"></span>  <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> vn=0; vn&lt;this-&gt;<a class="code" href="classlibMesh_1_1System.php#a4cf032eda109fe32a7fcde672ef5726e">n_vars</a>(); vn++)
<a name="l01388"></a>01388     {
<a name="l01389"></a>01389       out &lt;&lt; <span class="stringliteral">&quot;\&quot;&quot;</span>
<a name="l01390"></a>01390           &lt;&lt; <a class="code" href="namespacelibMesh_1_1Utility.php#a098fd61e717ccdc6e66a048756aba690">Utility::enum_to_string&lt;FEFamily&gt;</a>(this-&gt;<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>().<a class="code" href="classlibMesh_1_1DofMap.php#a0c010bb250d4cd8d65794452f46d141a">variable_type</a>(vn).<a class="code" href="classlibMesh_1_1FEType.php#ac437ba9b0a5253d6bf6f07ad277b9978">family</a>)
<a name="l01391"></a>01391           &lt;&lt; <span class="stringliteral">&quot;\&quot;, \&quot;&quot;</span>
<a name="l01392"></a>01392           &lt;&lt; <a class="code" href="namespacelibMesh_1_1Utility.php#a098fd61e717ccdc6e66a048756aba690">Utility::enum_to_string&lt;FEFamily&gt;</a>(this-&gt;<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>().<a class="code" href="classlibMesh_1_1DofMap.php#a0c010bb250d4cd8d65794452f46d141a">variable_type</a>(vn).<a class="code" href="classlibMesh_1_1FEType.php#aa977e3f8f993257e1cc81896236ba366">radial_family</a>)
<a name="l01393"></a>01393           &lt;&lt; <span class="stringliteral">&quot;\&quot; &quot;</span>;
<a name="l01394"></a>01394     }
<a name="l01395"></a>01395 
<a name="l01396"></a>01396   out &lt;&lt; <span class="charliteral">&#39;\n&#39;</span> &lt;&lt; <span class="stringliteral">&quot;    Infinite Element Mapping=&quot;</span>;
<a name="l01397"></a>01397   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> vn=0; vn&lt;this-&gt;<a class="code" href="classlibMesh_1_1System.php#a4cf032eda109fe32a7fcde672ef5726e">n_vars</a>(); vn++)
<a name="l01398"></a>01398     out &lt;&lt; <span class="stringliteral">&quot;\&quot;&quot;</span>
<a name="l01399"></a>01399         &lt;&lt; <a class="code" href="namespacelibMesh_1_1Utility.php#af2a2c62725aea911682d97a44e48284b">Utility::enum_to_string&lt;InfMapType&gt;</a>(this-&gt;<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>().<a class="code" href="classlibMesh_1_1DofMap.php#a0c010bb250d4cd8d65794452f46d141a">variable_type</a>(vn).<a class="code" href="classlibMesh_1_1FEType.php#a1fb32083c8ab884440a2beb333b5236e">inf_map</a>)
<a name="l01400"></a>01400         &lt;&lt; <span class="stringliteral">&quot;\&quot; &quot;</span>;
<a name="l01401"></a>01401 <span class="preprocessor">#endif      </span>
<a name="l01402"></a>01402 <span class="preprocessor"></span>
<a name="l01403"></a>01403   out &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l01404"></a>01404       
<a name="l01405"></a>01405   out &lt;&lt; <span class="stringliteral">&quot;    Approximation Orders=&quot;</span>;
<a name="l01406"></a>01406   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> vn=0; vn&lt;this-&gt;<a class="code" href="classlibMesh_1_1System.php#a4cf032eda109fe32a7fcde672ef5726e">n_vars</a>(); vn++)
<a name="l01407"></a>01407     {
<a name="l01408"></a>01408 <span class="preprocessor">#ifndef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l01409"></a>01409 <span class="preprocessor"></span>      out &lt;&lt; <span class="stringliteral">&quot;\&quot;&quot;</span>
<a name="l01410"></a>01410           &lt;&lt; <a class="code" href="namespacelibMesh_1_1Utility.php#af3b09206217fc044ae5187e06488cd5d">Utility::enum_to_string&lt;Order&gt;</a>(this-&gt;<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>().<a class="code" href="classlibMesh_1_1DofMap.php#a0c010bb250d4cd8d65794452f46d141a">variable_type</a>(vn).<a class="code" href="classlibMesh_1_1FEType.php#aa2484e0f6721f3e34dedebccacc48ac1">order</a>)
<a name="l01411"></a>01411           &lt;&lt; <span class="stringliteral">&quot;\&quot; &quot;</span>;
<a name="l01412"></a>01412 <span class="preprocessor">#else</span>
<a name="l01413"></a>01413 <span class="preprocessor"></span>      out &lt;&lt; <span class="stringliteral">&quot;\&quot;&quot;</span>
<a name="l01414"></a>01414           &lt;&lt; <a class="code" href="namespacelibMesh_1_1Utility.php#af3b09206217fc044ae5187e06488cd5d">Utility::enum_to_string&lt;Order&gt;</a>(this-&gt;<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>().<a class="code" href="classlibMesh_1_1DofMap.php#a0c010bb250d4cd8d65794452f46d141a">variable_type</a>(vn).<a class="code" href="classlibMesh_1_1FEType.php#aa2484e0f6721f3e34dedebccacc48ac1">order</a>)
<a name="l01415"></a>01415           &lt;&lt; <span class="stringliteral">&quot;\&quot;, \&quot;&quot;</span>
<a name="l01416"></a>01416           &lt;&lt; <a class="code" href="namespacelibMesh_1_1Utility.php#af3b09206217fc044ae5187e06488cd5d">Utility::enum_to_string&lt;Order&gt;</a>(this-&gt;<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>().<a class="code" href="classlibMesh_1_1DofMap.php#a0c010bb250d4cd8d65794452f46d141a">variable_type</a>(vn).<a class="code" href="classlibMesh_1_1FEType.php#a140e81f4ae94ca119586b2533e042223">radial_order</a>)
<a name="l01417"></a>01417           &lt;&lt; <span class="stringliteral">&quot;\&quot; &quot;</span>;
<a name="l01418"></a>01418 <span class="preprocessor">#endif</span>
<a name="l01419"></a>01419 <span class="preprocessor"></span>    }
<a name="l01420"></a>01420 
<a name="l01421"></a>01421   out &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l01422"></a>01422       
<a name="l01423"></a>01423   out &lt;&lt; <span class="stringliteral">&quot;    n_dofs()=&quot;</span>             &lt;&lt; this-&gt;<a class="code" href="classlibMesh_1_1System.php#a90dbb901f00c14ff18399f4afabcebe5">n_dofs</a>()             &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l01424"></a>01424   out &lt;&lt; <span class="stringliteral">&quot;    n_local_dofs()=&quot;</span>       &lt;&lt; this-&gt;<a class="code" href="classlibMesh_1_1System.php#ae3aeb82e65b06789823d41da3c5df7a2">n_local_dofs</a>()       &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l01425"></a>01425 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l01426"></a>01426 <span class="preprocessor"></span>  out &lt;&lt; <span class="stringliteral">&quot;    n_constrained_dofs()=&quot;</span> &lt;&lt; this-&gt;<a class="code" href="classlibMesh_1_1System.php#af44e0a3ba6dee841752b85b0c2b64854">n_constrained_dofs</a>() &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l01427"></a>01427 <span class="preprocessor">#endif</span>
<a name="l01428"></a>01428 <span class="preprocessor"></span>
<a name="l01429"></a>01429   out &lt;&lt; <span class="stringliteral">&quot;    &quot;</span> &lt;&lt; <span class="stringliteral">&quot;n_vectors()=&quot;</span>  &lt;&lt; this-&gt;<a class="code" href="classlibMesh_1_1System.php#a46bd8cfb070bab2dc814c33749c8c21b">n_vectors</a>()  &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l01430"></a>01430 <span class="comment">//   out &lt;&lt; &quot;    &quot; &lt;&lt; &quot;n_additional_matrices()=&quot; &lt;&lt; this-&gt;n_additional_matrices() &lt;&lt; &#39;\n&#39;;</span>
<a name="l01431"></a>01431   
<a name="l01432"></a>01432   <span class="keywordflow">return</span> out.str();
<a name="l01433"></a>01433 }
<a name="l01434"></a>01434 
<a name="l01435"></a>01435 
<a name="l01436"></a>01436 
<a name="l01437"></a><a class="code" href="classlibMesh_1_1System.php#a69c99bee95fdfc5b9a38cac034861496">01437</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a69c99bee95fdfc5b9a38cac034861496">System::attach_init_function</a> (<span class="keywordtype">void</span> fptr(<a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es,
<a name="l01438"></a>01438                                              <span class="keyword">const</span> std::string&amp; <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>))
<a name="l01439"></a>01439 {
<a name="l01440"></a>01440   libmesh_assert (fptr != NULL);
<a name="l01441"></a>01441   
<a name="l01442"></a>01442   <a class="code" href="classlibMesh_1_1System.php#a56216973e780410f4ffaf2d45173543d">_init_system</a> = fptr;
<a name="l01443"></a>01443 }
<a name="l01444"></a>01444 
<a name="l01445"></a>01445 
<a name="l01446"></a>01446 
<a name="l01447"></a><a class="code" href="classlibMesh_1_1System.php#a611b54551324acd1f072a1f809f5843a">01447</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a611b54551324acd1f072a1f809f5843a">System::attach_assemble_function</a> (<span class="keywordtype">void</span> fptr(<a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es,
<a name="l01448"></a>01448                                                  <span class="keyword">const</span> std::string&amp; <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>))
<a name="l01449"></a>01449 {
<a name="l01450"></a>01450   libmesh_assert (fptr != NULL);
<a name="l01451"></a>01451   
<a name="l01452"></a>01452   <a class="code" href="classlibMesh_1_1System.php#a35977f13fb34bbccf0594fd88001d8ba">_assemble_system</a> = fptr;  
<a name="l01453"></a>01453 }
<a name="l01454"></a>01454 
<a name="l01455"></a>01455 
<a name="l01456"></a>01456 
<a name="l01457"></a><a class="code" href="classlibMesh_1_1System.php#a10381e68b0376de0772a5ba07982beba">01457</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a10381e68b0376de0772a5ba07982beba">System::attach_constraint_function</a>(<span class="keywordtype">void</span> fptr(<a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es,
<a name="l01458"></a>01458                                                   <span class="keyword">const</span> std::string&amp; <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>))
<a name="l01459"></a>01459 {
<a name="l01460"></a>01460   libmesh_assert (fptr != NULL);
<a name="l01461"></a>01461   
<a name="l01462"></a>01462   <a class="code" href="classlibMesh_1_1System.php#ab7185cc600110514edca5468e7eba9f8">_constrain_system</a> = fptr;  
<a name="l01463"></a>01463 }
<a name="l01464"></a>01464 
<a name="l01465"></a>01465 
<a name="l01466"></a>01466 
<a name="l01467"></a><a class="code" href="classlibMesh_1_1System.php#a6471fddc304ce4a3de018b4fbf821135">01467</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a6471fddc304ce4a3de018b4fbf821135">System::attach_QOI_function</a>(<span class="keywordtype">void</span> fptr(<a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp;,
<a name="l01468"></a>01468                                            <span class="keyword">const</span> std::string&amp;,
<a name="l01469"></a>01469                                            <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a>&amp;))
<a name="l01470"></a>01470 {
<a name="l01471"></a>01471   libmesh_assert (fptr != NULL);
<a name="l01472"></a>01472   
<a name="l01473"></a>01473   <a class="code" href="classlibMesh_1_1System.php#a96abb602a58389dccbaff1cdd2f63af2">_qoi_evaluate</a> = fptr;  
<a name="l01474"></a>01474 }
<a name="l01475"></a>01475 
<a name="l01476"></a>01476 
<a name="l01477"></a>01477 
<a name="l01478"></a><a class="code" href="classlibMesh_1_1System.php#a6674774a0f6eb6648a63901491cd1973">01478</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a6674774a0f6eb6648a63901491cd1973">System::attach_QOI_derivative</a>(<span class="keywordtype">void</span> fptr(<a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp;,
<a name="l01479"></a>01479                                              <span class="keyword">const</span> std::string&amp;,
<a name="l01480"></a>01480                                              <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a>&amp;))
<a name="l01481"></a>01481 {
<a name="l01482"></a>01482   libmesh_assert (fptr != NULL);
<a name="l01483"></a>01483   
<a name="l01484"></a>01484   <a class="code" href="classlibMesh_1_1System.php#a9c50c9fcb08d2170180694f1d11173bf">_qoi_evaluate_derivative</a> = fptr;  
<a name="l01485"></a>01485 }
<a name="l01486"></a>01486 
<a name="l01487"></a>01487 
<a name="l01488"></a>01488 
<a name="l01489"></a><a class="code" href="classlibMesh_1_1System.php#a5f7a3a1e154fe61af97e966f3ab34ae2">01489</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a5f7a3a1e154fe61af97e966f3ab34ae2">System::user_initialization</a> ()
<a name="l01490"></a>01490 {
<a name="l01491"></a>01491   <span class="comment">// Call the user-provided intialization function,</span>
<a name="l01492"></a>01492   <span class="comment">// if it was provided</span>
<a name="l01493"></a>01493   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1System.php#a56216973e780410f4ffaf2d45173543d">_init_system</a> != NULL)
<a name="l01494"></a>01494     this-&gt;<a class="code" href="classlibMesh_1_1System.php#a56216973e780410f4ffaf2d45173543d">_init_system</a> (<a class="code" href="classlibMesh_1_1System.php#a99c9ba78a233464c052accdcbcc17153">_equation_systems</a>, this-&gt;<a class="code" href="classlibMesh_1_1System.php#af80f6b2e508821ebd9c8fcb78d443f18">name</a>());
<a name="l01495"></a>01495 }
<a name="l01496"></a>01496 
<a name="l01497"></a>01497 
<a name="l01498"></a><a class="code" href="classlibMesh_1_1System.php#a792940ed6cca41b5dcaf878429a50253">01498</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a792940ed6cca41b5dcaf878429a50253">System::user_assembly</a> ()
<a name="l01499"></a>01499 {
<a name="l01500"></a>01500   <span class="comment">// Call the user-provided assembly function,</span>
<a name="l01501"></a>01501   <span class="comment">// if it was provided</span>
<a name="l01502"></a>01502   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1System.php#a35977f13fb34bbccf0594fd88001d8ba">_assemble_system</a> != NULL)
<a name="l01503"></a>01503     this-&gt;<a class="code" href="classlibMesh_1_1System.php#a35977f13fb34bbccf0594fd88001d8ba">_assemble_system</a> (<a class="code" href="classlibMesh_1_1System.php#a99c9ba78a233464c052accdcbcc17153">_equation_systems</a>, this-&gt;<a class="code" href="classlibMesh_1_1System.php#af80f6b2e508821ebd9c8fcb78d443f18">name</a>());
<a name="l01504"></a>01504 }
<a name="l01505"></a>01505 
<a name="l01506"></a>01506 
<a name="l01507"></a>01507 
<a name="l01508"></a><a class="code" href="classlibMesh_1_1System.php#a8e857fcc4af2756cdd0d16563dfbbe83">01508</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a8e857fcc4af2756cdd0d16563dfbbe83">System::user_constrain</a> ()
<a name="l01509"></a>01509 {
<a name="l01510"></a>01510   <span class="comment">// Call the user-provided constraint function, </span>
<a name="l01511"></a>01511   <span class="comment">// if it was provided</span>
<a name="l01512"></a>01512   <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1System.php#ab7185cc600110514edca5468e7eba9f8">_constrain_system</a>!= NULL)
<a name="l01513"></a>01513     this-&gt;<a class="code" href="classlibMesh_1_1System.php#ab7185cc600110514edca5468e7eba9f8">_constrain_system</a>(<a class="code" href="classlibMesh_1_1System.php#a99c9ba78a233464c052accdcbcc17153">_equation_systems</a>, this-&gt;<a class="code" href="classlibMesh_1_1System.php#af80f6b2e508821ebd9c8fcb78d443f18">name</a>());
<a name="l01514"></a>01514 }
<a name="l01515"></a>01515 
<a name="l01516"></a>01516 
<a name="l01517"></a>01517 
<a name="l01518"></a><a class="code" href="classlibMesh_1_1System.php#a3e75c1bd2055bb1bf9f5832a62c0039d">01518</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a3e75c1bd2055bb1bf9f5832a62c0039d">System::user_QOI</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a>&amp; qoi_indices)
<a name="l01519"></a>01519 {
<a name="l01520"></a>01520   <span class="comment">// Call the user-provided quantity of interest function, </span>
<a name="l01521"></a>01521   <span class="comment">// if it was provided</span>
<a name="l01522"></a>01522   <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1System.php#a96abb602a58389dccbaff1cdd2f63af2">_qoi_evaluate</a> != NULL)
<a name="l01523"></a>01523     this-&gt;<a class="code" href="classlibMesh_1_1System.php#a96abb602a58389dccbaff1cdd2f63af2">_qoi_evaluate</a>(<a class="code" href="classlibMesh_1_1System.php#a99c9ba78a233464c052accdcbcc17153">_equation_systems</a>, this-&gt;<a class="code" href="classlibMesh_1_1System.php#af80f6b2e508821ebd9c8fcb78d443f18">name</a>(), qoi_indices);
<a name="l01524"></a>01524 }
<a name="l01525"></a>01525 
<a name="l01526"></a>01526 
<a name="l01527"></a>01527 
<a name="l01528"></a><a class="code" href="classlibMesh_1_1System.php#ab181e4e31e37f117493cc3d0f74d0f25">01528</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#ab181e4e31e37f117493cc3d0f74d0f25">System::user_QOI_derivative</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a>&amp; qoi_indices)
<a name="l01529"></a>01529 {
<a name="l01530"></a>01530   <span class="comment">// Call the user-provided quantity of interest derivative, </span>
<a name="l01531"></a>01531   <span class="comment">// if it was provided</span>
<a name="l01532"></a>01532   <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1System.php#a9c50c9fcb08d2170180694f1d11173bf">_qoi_evaluate_derivative</a> != NULL)
<a name="l01533"></a>01533     this-&gt;<a class="code" href="classlibMesh_1_1System.php#a9c50c9fcb08d2170180694f1d11173bf">_qoi_evaluate_derivative</a>(<a class="code" href="classlibMesh_1_1System.php#a99c9ba78a233464c052accdcbcc17153">_equation_systems</a>, this-&gt;<a class="code" href="classlibMesh_1_1System.php#af80f6b2e508821ebd9c8fcb78d443f18">name</a>(), qoi_indices);
<a name="l01534"></a>01534 }
<a name="l01535"></a>01535 
<a name="l01536"></a>01536 
<a name="l01537"></a>01537 
<a name="l01538"></a><a class="code" href="classlibMesh_1_1System.php#af077a1b91c8b03020f2c6da41fcb72fb">01538</a> <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> <a class="code" href="classlibMesh_1_1System.php#af077a1b91c8b03020f2c6da41fcb72fb">System::point_value</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var, <a class="code" href="classlibMesh_1_1Point.php">Point</a> &amp;p)
<a name="l01539"></a>01539 {
<a name="l01540"></a>01540   <span class="comment">// This function must be called on every processor; there&#39;s no</span>
<a name="l01541"></a>01541   <span class="comment">// telling where in the partition p falls.</span>
<a name="l01542"></a>01542   parallel_only();
<a name="l01543"></a>01543 
<a name="l01544"></a>01544   <span class="comment">// Get a reference to the mesh object associated with the system object that calls this function</span>
<a name="l01545"></a>01545   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp;<a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a> = this-&gt;<a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">get_mesh</a>();
<a name="l01546"></a>01546 
<a name="l01547"></a>01547   <span class="comment">// Get the dimension of the mesh</span>
<a name="l01548"></a>01548   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1bc787d29f4c496f107aed988be4b9bf">mesh_dimension</a>();
<a name="l01549"></a>01549 
<a name="l01550"></a>01550   <span class="comment">// Use an existing PointLocator or create a new one</span>
<a name="l01551"></a>01551   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1PointLocatorBase.php">PointLocatorBase</a> &amp;locator = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a122877d5316f9035967c6ed10d86a520">point_locator</a>();
<a name="l01552"></a>01552   
<a name="l01553"></a>01553   <span class="comment">// Get a pointer to the element that contains P</span>
<a name="l01554"></a>01554   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *e = locator(p);
<a name="l01555"></a>01555 
<a name="l01556"></a>01556   <span class="comment">// Get ready to accumulate a value</span>
<a name="l01557"></a>01557   <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> u = 0;
<a name="l01558"></a>01558 
<a name="l01559"></a>01559   <span class="comment">// Make sure we got an element on our partition</span>
<a name="l01560"></a>01560   <span class="keywordtype">bool</span> I_found_p = <span class="keyword">false</span>;
<a name="l01561"></a>01561 
<a name="l01562"></a>01562   <span class="keywordflow">if</span> (e)
<a name="l01563"></a>01563     {
<a name="l01564"></a>01564       <span class="comment">// Get the dof map to get the proper indices for our computation</span>
<a name="l01565"></a>01565       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DofMap.php">DofMap</a>&amp; dof_map = this-&gt;<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>();
<a name="l01566"></a>01566 
<a name="l01567"></a>01567       <span class="comment">// Need dof_indices for phi[i][j]</span>
<a name="l01568"></a>01568       std::vector&lt;unsigned int&gt; dof_indices;
<a name="l01569"></a>01569 
<a name="l01570"></a>01570       <span class="comment">// Fill in the dof_indices for our element</span>
<a name="l01571"></a>01571       dof_map.<a class="code" href="classlibMesh_1_1DofMap.php#a5dac22ba99a9da3563c00b7dfd2f07af">dof_indices</a> (e, dof_indices, var);
<a name="l01572"></a>01572 
<a name="l01573"></a>01573       <span class="comment">// Calculate a value for p, if we have enough local and ghosted</span>
<a name="l01574"></a>01574       <span class="comment">// data to do so.</span>
<a name="l01575"></a>01575       <span class="keywordflow">if</span> (dof_map.<a class="code" href="classlibMesh_1_1DofMap.php#a6a93245255b86501e09ef377b73bf089">all_semilocal_indices</a>(dof_indices))
<a name="l01576"></a>01576         {
<a name="l01577"></a>01577           I_found_p = <span class="keyword">true</span>;
<a name="l01578"></a>01578 
<a name="l01579"></a>01579           <span class="comment">// Get the no of dofs assciated with this point</span>
<a name="l01580"></a>01580           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#a90dbb901f00c14ff18399f4afabcebe5">n_dofs</a>  = dof_indices.size();
<a name="l01581"></a>01581 
<a name="l01582"></a>01582           <a class="code" href="classlibMesh_1_1FEType.php">FEType</a> fe_type = dof_map.<a class="code" href="classlibMesh_1_1DofMap.php#a0c010bb250d4cd8d65794452f46d141a">variable_type</a>(0);
<a name="l01583"></a>01583 
<a name="l01584"></a>01584           <span class="comment">// Build a FE so we can calculate u(p)</span>
<a name="l01585"></a>01585           <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;FEBase&gt;</a> fe (<a class="code" href="classlibMesh_1_1FEBase.php#aa6065b49a9dd684109a87770e514ff5d">FEBase::build</a>(dim, fe_type));
<a name="l01586"></a>01586 
<a name="l01587"></a>01587           <span class="comment">// Map the physical co-ordinates to the master co-ordinates using the inverse_map from fe_interface.h</span>
<a name="l01588"></a>01588           <span class="comment">// Build a vector of point co-ordinates to send to reinit</span>
<a name="l01589"></a>01589           std::vector&lt;Point&gt; coor(1, <a class="code" href="classlibMesh_1_1FEInterface.php#aa4cd7cde33c7f4b7f873d2fdad6fb635">FEInterface::inverse_map</a>(dim, fe_type, e, p));
<a name="l01590"></a>01590 
<a name="l01591"></a>01591           <span class="comment">// Get the shape function values</span>
<a name="l01592"></a>01592           <span class="keyword">const</span> std::vector&lt;std::vector&lt;Real&gt; &gt;&amp; phi = fe-&gt;get_phi();
<a name="l01593"></a>01593     
<a name="l01594"></a>01594           <span class="comment">// Reinitialize the element and compute the shape function values at coor</span>
<a name="l01595"></a>01595           fe-&gt;reinit (e, &amp;coor);
<a name="l01596"></a>01596 
<a name="l01597"></a>01597           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> l=0; l&lt;<a class="code" href="classlibMesh_1_1System.php#a90dbb901f00c14ff18399f4afabcebe5">n_dofs</a>; l++)
<a name="l01598"></a>01598             {
<a name="l01599"></a>01599               u += phi[l][0]*this-&gt;<a class="code" href="classlibMesh_1_1System.php#adad8bac609ebbd85b0c6aaafb8d3371e">current_solution</a> (dof_indices[l]);
<a name="l01600"></a>01600             }
<a name="l01601"></a>01601         }
<a name="l01602"></a>01602     }
<a name="l01603"></a>01603 
<a name="l01604"></a>01604   <span class="comment">// If I have an element containing p, then let&#39;s let everyone know</span>
<a name="l01605"></a>01605   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> lowest_owner = I_found_p ? <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() : <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>();
<a name="l01606"></a>01606   <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">Parallel::min</a>(lowest_owner);
<a name="l01607"></a>01607 
<a name="l01608"></a>01608   <span class="comment">// If nobody admits owning the point, we have a problem.</span>
<a name="l01609"></a>01609   libmesh_assert(lowest_owner != <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>());
<a name="l01610"></a>01610 
<a name="l01611"></a>01611   <span class="comment">// Everybody should get their value from a processor that was able</span>
<a name="l01612"></a>01612   <span class="comment">// to compute it.</span>
<a name="l01613"></a>01613   <a class="code" href="namespacelibMesh_1_1Parallel.php#a0856815f9d1ce56771e340b45ef80e6c">Parallel::broadcast</a>(u, lowest_owner);
<a name="l01614"></a>01614   
<a name="l01615"></a>01615   <span class="keywordflow">return</span> u;
<a name="l01616"></a>01616 }
<a name="l01617"></a>01617 
<a name="l01618"></a><a class="code" href="classlibMesh_1_1System.php#a4e07b8705c855e9537944dd9f35ffd30">01618</a> <a class="code" href="classlibMesh_1_1VectorValue.php">Gradient</a> <a class="code" href="classlibMesh_1_1System.php#a4e07b8705c855e9537944dd9f35ffd30">System::point_gradient</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var, <a class="code" href="classlibMesh_1_1Point.php">Point</a> &amp;p)
<a name="l01619"></a>01619 {
<a name="l01620"></a>01620   <span class="comment">// This function must be called on every processor; there&#39;s no</span>
<a name="l01621"></a>01621   <span class="comment">// telling where in the partition p falls.</span>
<a name="l01622"></a>01622   parallel_only();
<a name="l01623"></a>01623 
<a name="l01624"></a>01624   <span class="comment">// Get a reference to the mesh object associated with the system object that calls this function</span>
<a name="l01625"></a>01625   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp;<a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a> = this-&gt;<a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">get_mesh</a>();
<a name="l01626"></a>01626 
<a name="l01627"></a>01627   <span class="comment">// Get the dimension of the mesh</span>
<a name="l01628"></a>01628   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1bc787d29f4c496f107aed988be4b9bf">mesh_dimension</a>();
<a name="l01629"></a>01629   
<a name="l01630"></a>01630   <span class="comment">// Use an existing PointLocator or create a new one</span>
<a name="l01631"></a>01631   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1PointLocatorBase.php">PointLocatorBase</a> &amp;locator = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a122877d5316f9035967c6ed10d86a520">point_locator</a>();
<a name="l01632"></a>01632   
<a name="l01633"></a>01633   <span class="comment">// Get a pointer to the element that contains P</span>
<a name="l01634"></a>01634   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *e = locator(p);
<a name="l01635"></a>01635 
<a name="l01636"></a>01636   <span class="comment">// Get ready to accumulate a gradient</span>
<a name="l01637"></a>01637   <a class="code" href="classlibMesh_1_1VectorValue.php">Gradient</a> grad_u;
<a name="l01638"></a>01638 
<a name="l01639"></a>01639   <span class="comment">// Make sure we got an element on our partition</span>
<a name="l01640"></a>01640   <span class="keywordtype">bool</span> I_found_p = <span class="keyword">false</span>;
<a name="l01641"></a>01641 
<a name="l01642"></a>01642   <span class="keywordflow">if</span> (e)
<a name="l01643"></a>01643     {
<a name="l01644"></a>01644       <span class="comment">// Get the dof map to get the proper indices for our computation</span>
<a name="l01645"></a>01645       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DofMap.php">DofMap</a>&amp; dof_map = this-&gt;<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>();
<a name="l01646"></a>01646 
<a name="l01647"></a>01647       <span class="comment">// Need dof_indices for phi[i][j]</span>
<a name="l01648"></a>01648       std::vector&lt;unsigned int&gt; dof_indices;
<a name="l01649"></a>01649 
<a name="l01650"></a>01650       <span class="comment">// Fill in the dof_indices for our element</span>
<a name="l01651"></a>01651       dof_map.<a class="code" href="classlibMesh_1_1DofMap.php#a5dac22ba99a9da3563c00b7dfd2f07af">dof_indices</a> (e, dof_indices, var);
<a name="l01652"></a>01652 
<a name="l01653"></a>01653       <span class="comment">// Calculate a value for p, if we have enough local and ghosted</span>
<a name="l01654"></a>01654       <span class="comment">// data to do so.</span>
<a name="l01655"></a>01655       <span class="keywordflow">if</span> (dof_map.<a class="code" href="classlibMesh_1_1DofMap.php#a6a93245255b86501e09ef377b73bf089">all_semilocal_indices</a>(dof_indices))
<a name="l01656"></a>01656         {
<a name="l01657"></a>01657           I_found_p = <span class="keyword">true</span>;
<a name="l01658"></a>01658 
<a name="l01659"></a>01659           <span class="comment">// Get the no of dofs assciated with this point</span>
<a name="l01660"></a>01660           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#a90dbb901f00c14ff18399f4afabcebe5">n_dofs</a>  = dof_indices.size();
<a name="l01661"></a>01661 
<a name="l01662"></a>01662           <a class="code" href="classlibMesh_1_1FEType.php">FEType</a> fe_type = dof_map.<a class="code" href="classlibMesh_1_1DofMap.php#a0c010bb250d4cd8d65794452f46d141a">variable_type</a>(0);
<a name="l01663"></a>01663     
<a name="l01664"></a>01664           <span class="comment">// Build a FE again so we can calculate u(p)</span>
<a name="l01665"></a>01665           <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;FEBase&gt;</a> fe (<a class="code" href="classlibMesh_1_1FEBase.php#aa6065b49a9dd684109a87770e514ff5d">FEBase::build</a>(dim, fe_type));
<a name="l01666"></a>01666 
<a name="l01667"></a>01667           <span class="comment">// Map the physical co-ordinates to the master co-ordinates using the inverse_map from fe_interface.h</span>
<a name="l01668"></a>01668           <span class="comment">// Build a vector of point co-ordinates to send to reinit</span>
<a name="l01669"></a>01669           std::vector&lt;Point&gt; coor(1, <a class="code" href="classlibMesh_1_1FEInterface.php#aa4cd7cde33c7f4b7f873d2fdad6fb635">FEInterface::inverse_map</a>(dim, fe_type, e, p));
<a name="l01670"></a>01670 
<a name="l01671"></a>01671           <span class="comment">// Get the values of the shape function derivatives</span>
<a name="l01672"></a>01672           <span class="keyword">const</span> std::vector&lt;std::vector&lt;RealGradient&gt; &gt;&amp;  dphi = fe-&gt;get_dphi();
<a name="l01673"></a>01673     
<a name="l01674"></a>01674           <span class="comment">// Reinitialize the element and compute the shape function values at coor</span>
<a name="l01675"></a>01675           fe-&gt;reinit (e, &amp;coor);
<a name="l01676"></a>01676 
<a name="l01677"></a>01677           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> l=0; l&lt;<a class="code" href="classlibMesh_1_1System.php#a90dbb901f00c14ff18399f4afabcebe5">n_dofs</a>; l++)
<a name="l01678"></a>01678             {
<a name="l01679"></a>01679               grad_u.<a class="code" href="classlibMesh_1_1TypeVector.php#aaf2f65f39d9cdb06500baa2d571dc27f">add_scaled</a> (dphi[l][0], this-&gt;<a class="code" href="classlibMesh_1_1System.php#adad8bac609ebbd85b0c6aaafb8d3371e">current_solution</a> (dof_indices[l]));
<a name="l01680"></a>01680             }
<a name="l01681"></a>01681         }
<a name="l01682"></a>01682     }
<a name="l01683"></a>01683 
<a name="l01684"></a>01684   <span class="comment">// If I have an element containing p, then let&#39;s let everyone know</span>
<a name="l01685"></a>01685   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> lowest_owner = I_found_p ? <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() : <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>();
<a name="l01686"></a>01686   <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">Parallel::min</a>(lowest_owner);
<a name="l01687"></a>01687 
<a name="l01688"></a>01688   <span class="comment">// If nobody admits owning the point, we have a problem.</span>
<a name="l01689"></a>01689   libmesh_assert(lowest_owner != <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>());
<a name="l01690"></a>01690 
<a name="l01691"></a>01691   <span class="comment">// Broadcast cannot handle Gradients so we create a vector </span>
<a name="l01692"></a>01692   <span class="comment">// that can be used to broadcast the computed gradient to the other procs</span>
<a name="l01693"></a>01693   std::vector&lt;Number&gt; gradient_vector(dim);
<a name="l01694"></a>01694   
<a name="l01695"></a>01695   <span class="comment">// Now loop over every dimension and fill this vector</span>
<a name="l01696"></a>01696   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;dim; i++)
<a name="l01697"></a>01697     {
<a name="l01698"></a>01698       gradient_vector[i] = grad_u(i);
<a name="l01699"></a>01699     }
<a name="l01700"></a>01700 
<a name="l01701"></a>01701   <span class="comment">// Everybody should get their value from a processor that was able</span>
<a name="l01702"></a>01702   <span class="comment">// to compute it.</span>
<a name="l01703"></a>01703   <a class="code" href="namespacelibMesh_1_1Parallel.php#a0856815f9d1ce56771e340b45ef80e6c">Parallel::broadcast</a>(gradient_vector, lowest_owner);
<a name="l01704"></a>01704   
<a name="l01705"></a>01705   <span class="comment">// Now unpack</span>
<a name="l01706"></a>01706   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i =0; i&lt;dim; i++)
<a name="l01707"></a>01707     {
<a name="l01708"></a>01708       grad_u(i) = gradient_vector[i];
<a name="l01709"></a>01709     }
<a name="l01710"></a>01710 
<a name="l01711"></a>01711   <span class="keywordflow">return</span> grad_u;
<a name="l01712"></a>01712 }
<a name="l01713"></a>01713 
<a name="l01714"></a>01714 
<a name="l01715"></a>01715 
<a name="l01716"></a>01716 <span class="comment">// We can only accumulate a hessian with --enable-second</span>
<a name="l01717"></a>01717 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l01718"></a><a class="code" href="classlibMesh_1_1System.php#a6ea18ca2d8af1292053329c6ced7c549">01718</a> <span class="preprocessor"></span><a class="code" href="classlibMesh_1_1TensorValue.php">Tensor</a> <a class="code" href="classlibMesh_1_1System.php#a6ea18ca2d8af1292053329c6ced7c549">System::point_hessian</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var, <a class="code" href="classlibMesh_1_1Point.php">Point</a> &amp;p)
<a name="l01719"></a>01719 {
<a name="l01720"></a>01720   <span class="comment">// This function must be called on every processor; there&#39;s no</span>
<a name="l01721"></a>01721   <span class="comment">// telling where in the partition p falls.</span>
<a name="l01722"></a>01722   parallel_only();
<a name="l01723"></a>01723 
<a name="l01724"></a>01724   <span class="comment">// Get a reference to the mesh object associated with the system object that calls this function</span>
<a name="l01725"></a>01725   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp;<a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a> = this-&gt;<a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">get_mesh</a>();
<a name="l01726"></a>01726 
<a name="l01727"></a>01727   <span class="comment">// Get the dimension of the mesh</span>
<a name="l01728"></a>01728   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1bc787d29f4c496f107aed988be4b9bf">mesh_dimension</a>();
<a name="l01729"></a>01729   
<a name="l01730"></a>01730   <span class="comment">// Use an existing PointLocator or create a new one</span>
<a name="l01731"></a>01731   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1PointLocatorBase.php">PointLocatorBase</a> &amp;locator = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a122877d5316f9035967c6ed10d86a520">point_locator</a>();
<a name="l01732"></a>01732   
<a name="l01733"></a>01733   <span class="comment">// Get a pointer to the element that contains P</span>
<a name="l01734"></a>01734   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *e = locator(p);
<a name="l01735"></a>01735 
<a name="l01736"></a>01736   <span class="comment">// Get ready to accumulate a hessian</span>
<a name="l01737"></a>01737   <a class="code" href="classlibMesh_1_1TensorValue.php">Tensor</a> hess_u;
<a name="l01738"></a>01738 
<a name="l01739"></a>01739   <span class="comment">// Make sure we got an element on our partition</span>
<a name="l01740"></a>01740   <span class="keywordtype">bool</span> I_found_p = <span class="keyword">false</span>;
<a name="l01741"></a>01741 
<a name="l01742"></a>01742   <span class="keywordflow">if</span> (e)
<a name="l01743"></a>01743     {
<a name="l01744"></a>01744       <span class="comment">// Get the dof map to get the proper indices for our computation</span>
<a name="l01745"></a>01745       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DofMap.php">DofMap</a>&amp; dof_map = this-&gt;<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>();
<a name="l01746"></a>01746 
<a name="l01747"></a>01747       <span class="comment">// Need dof_indices for phi[i][j]</span>
<a name="l01748"></a>01748       std::vector&lt;unsigned int&gt; dof_indices;
<a name="l01749"></a>01749 
<a name="l01750"></a>01750       <span class="comment">// Fill in the dof_indices for our element</span>
<a name="l01751"></a>01751       dof_map.<a class="code" href="classlibMesh_1_1DofMap.php#a5dac22ba99a9da3563c00b7dfd2f07af">dof_indices</a> (e, dof_indices, var);
<a name="l01752"></a>01752 
<a name="l01753"></a>01753       <span class="comment">// Calculate a value for p, if we have enough local and ghosted</span>
<a name="l01754"></a>01754       <span class="comment">// data to do so.</span>
<a name="l01755"></a>01755       <span class="keywordflow">if</span> (dof_map.<a class="code" href="classlibMesh_1_1DofMap.php#a6a93245255b86501e09ef377b73bf089">all_semilocal_indices</a>(dof_indices))
<a name="l01756"></a>01756         {
<a name="l01757"></a>01757           I_found_p = <span class="keyword">true</span>;
<a name="l01758"></a>01758 
<a name="l01759"></a>01759           <span class="comment">// Get the no of dofs assciated with this point</span>
<a name="l01760"></a>01760           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#a90dbb901f00c14ff18399f4afabcebe5">n_dofs</a>  = dof_indices.size();
<a name="l01761"></a>01761 
<a name="l01762"></a>01762           <a class="code" href="classlibMesh_1_1FEType.php">FEType</a> fe_type = dof_map.<a class="code" href="classlibMesh_1_1DofMap.php#a0c010bb250d4cd8d65794452f46d141a">variable_type</a>(0);
<a name="l01763"></a>01763     
<a name="l01764"></a>01764           <span class="comment">// Build a FE again so we can calculate u(p)</span>
<a name="l01765"></a>01765           <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;FEBase&gt;</a> fe (<a class="code" href="classlibMesh_1_1FEBase.php#aa6065b49a9dd684109a87770e514ff5d">FEBase::build</a>(dim, fe_type));
<a name="l01766"></a>01766 
<a name="l01767"></a>01767           <span class="comment">// Map the physical co-ordinates to the master co-ordinates using the inverse_map from fe_interface.h</span>
<a name="l01768"></a>01768           <span class="comment">// Build a vector of point co-ordinates to send to reinit</span>
<a name="l01769"></a>01769           std::vector&lt;Point&gt; coor(1, <a class="code" href="classlibMesh_1_1FEInterface.php#aa4cd7cde33c7f4b7f873d2fdad6fb635">FEInterface::inverse_map</a>(dim, fe_type, e, p));
<a name="l01770"></a>01770 
<a name="l01771"></a>01771           <span class="comment">// Get the values of the shape function derivatives</span>
<a name="l01772"></a>01772           <span class="keyword">const</span> std::vector&lt;std::vector&lt;RealTensor&gt; &gt;&amp;  d2phi = fe-&gt;get_d2phi();
<a name="l01773"></a>01773     
<a name="l01774"></a>01774           <span class="comment">// Reinitialize the element and compute the shape function values at coor</span>
<a name="l01775"></a>01775           fe-&gt;reinit (e, &amp;coor);
<a name="l01776"></a>01776 
<a name="l01777"></a>01777           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> l=0; l&lt;<a class="code" href="classlibMesh_1_1System.php#a90dbb901f00c14ff18399f4afabcebe5">n_dofs</a>; l++)
<a name="l01778"></a>01778             {
<a name="l01779"></a>01779               hess_u.<a class="code" href="classlibMesh_1_1TypeTensor.php#adae55fa841255b47d85a5baf7a352ff6">add_scaled</a> (d2phi[l][0], this-&gt;<a class="code" href="classlibMesh_1_1System.php#adad8bac609ebbd85b0c6aaafb8d3371e">current_solution</a> (dof_indices[l]));
<a name="l01780"></a>01780             }
<a name="l01781"></a>01781         }
<a name="l01782"></a>01782     }
<a name="l01783"></a>01783 
<a name="l01784"></a>01784   <span class="comment">// If I have an element containing p, then let&#39;s let everyone know</span>
<a name="l01785"></a>01785   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> lowest_owner = I_found_p ? <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() : <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>();
<a name="l01786"></a>01786   <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">Parallel::min</a>(lowest_owner);
<a name="l01787"></a>01787 
<a name="l01788"></a>01788   <span class="comment">// If nobody admits owning the point, we have a problem.</span>
<a name="l01789"></a>01789   libmesh_assert(lowest_owner != <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>());
<a name="l01790"></a>01790 
<a name="l01791"></a>01791   <span class="comment">// Broadcast cannot handle Gradients so we create a vector </span>
<a name="l01792"></a>01792   <span class="comment">// that can be used to broadcast the computed gradient to the other procs</span>
<a name="l01793"></a>01793   std::vector&lt;Number&gt; hessian_vector(dim*dim);
<a name="l01794"></a>01794   
<a name="l01795"></a>01795   <span class="comment">// Now loop over every dimension and fill this vector</span>
<a name="l01796"></a>01796   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;dim; i++)    
<a name="l01797"></a>01797       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;dim; j++)
<a name="l01798"></a>01798         hessian_vector[i*dim + j] = hess_u(i,j);
<a name="l01799"></a>01799     
<a name="l01800"></a>01800   <span class="comment">// Everybody should get their value from a processor that was able</span>
<a name="l01801"></a>01801   <span class="comment">// to compute it.</span>
<a name="l01802"></a>01802   <a class="code" href="namespacelibMesh_1_1Parallel.php#a0856815f9d1ce56771e340b45ef80e6c">Parallel::broadcast</a>(hessian_vector, lowest_owner);
<a name="l01803"></a>01803   
<a name="l01804"></a>01804   <span class="comment">// Now unpack</span>
<a name="l01805"></a>01805   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i =0; i&lt;dim; i++)
<a name="l01806"></a>01806     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;dim; j++)
<a name="l01807"></a>01807       hess_u(i,j) = hessian_vector[i*dim + j];
<a name="l01808"></a>01808     
<a name="l01809"></a>01809   <span class="keywordflow">return</span> hess_u;
<a name="l01810"></a>01810 }
<a name="l01811"></a>01811 <span class="preprocessor">#else</span>
<a name="l01812"></a>01812 <span class="preprocessor"></span><a class="code" href="classlibMesh_1_1TensorValue.php">Tensor</a> <a class="code" href="classlibMesh_1_1System.php#a6ea18ca2d8af1292053329c6ced7c549">System::point_hessian</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>, <a class="code" href="classlibMesh_1_1Point.php">Point</a> &amp;)
<a name="l01813"></a>01813 {
<a name="l01814"></a>01814   <span class="comment">// We can only accumulate a hessian with --enable-second</span>
<a name="l01815"></a>01815   libmesh_error();
<a name="l01816"></a>01816     
<a name="l01817"></a>01817   <span class="comment">// Avoid compiler warnings</span>
<a name="l01818"></a>01818   <span class="keywordflow">return</span> <a class="code" href="namespacelibMesh.php#a5f437145a24acdee8c954a449f6389af">Tensor</a>();
<a name="l01819"></a>01819 }
<a name="l01820"></a>01820 <span class="preprocessor">#endif // LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l01821"></a>01821 <span class="preprocessor"></span>
<a name="l01822"></a>01822 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
