<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_c3a49989e40b21e7508f29d2dc962def.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_94af86d0ee7ff5a2af0627e1a0ea6efa.php">systems</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">transient_rb_system.C</div>  </div>
</div>
<div class="contents">
<a href="transient__rb__system_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// rbOOmit: An implementation of the Certified Reduced Basis method.</span>
<a name="l00002"></a>00002 <span class="comment">// Copyright (C) 2009, 2010 David J. Knezevic</span>
<a name="l00003"></a>00003 
<a name="l00004"></a>00004 <span class="comment">// This file is part of rbOOmit.</span>
<a name="l00005"></a>00005 
<a name="l00006"></a>00006 <span class="comment">// rbOOmit is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// rbOOmit is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="comment">// LibMesh includes</span>
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#include &quot;<a class="code" href="numeric__vector_8h.php">numeric_vector.h</a>&quot;</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;<a class="code" href="sparse__matrix_8h.php">sparse_matrix.h</a>&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="code" href="dof__map_8h.php">dof_map.h</a>&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__logging_8h.php">libmesh_logging.h</a>&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="transient__rb__system_8h.php">transient_rb_system.h</a>&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="linear__solver_8h.php">linear_solver.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="o__string__stream_8h.php">o_string_stream.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="equation__systems_8h.php">equation_systems.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="gmv__io_8h.php">gmv_io.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="getpot_8h.php">getpot.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="dense__matrix_8h.php">dense_matrix.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="dense__vector_8h.php">dense_vector.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="xdr__cxx_8h.php">xdr_cxx.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="timestamp_8h.php">timestamp.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="parallel_8h.php">parallel.h</a>&quot;</span>
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="preprocessor">#include &lt;fstream&gt;</span>
<a name="l00039"></a>00039 <span class="preprocessor">#include &lt;sstream&gt;</span>
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 <span class="comment">// For checking for the existence of files</span>
<a name="l00042"></a>00042 <span class="preprocessor">#include &lt;sys/stat.h&gt;</span>
<a name="l00043"></a>00043 
<a name="l00044"></a>00044 <span class="comment">// Need SLEPc to get the POD eigenvalues</span>
<a name="l00045"></a>00045 <span class="preprocessor">#if defined(LIBMESH_HAVE_SLEPC)</span>
<a name="l00046"></a>00046 <span class="preprocessor"></span><span class="comment">// LAPACK include (via SLEPc)</span>
<a name="l00047"></a>00047 <span class="preprocessor">#include &lt;petscsys.h&gt;</span>
<a name="l00048"></a>00048 <span class="preprocessor">#include &lt;slepcblaslapack.h&gt;</span>
<a name="l00049"></a>00049 <span class="preprocessor">#endif // LIBMESH_HAVE_SLEPC</span>
<a name="l00050"></a>00050 <span class="preprocessor"></span>
<a name="l00051"></a>00051 <span class="keyword">namespace </span>libMesh
<a name="l00052"></a>00052 {
<a name="l00053"></a>00053 
<a name="l00054"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a332178f1af3116ae727fbcdcb03eb686">00054</a> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a332178f1af3116ae727fbcdcb03eb686">TransientRBSystem::TransientRBSystem</a> (<a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00055"></a>00055                     <span class="keyword">const</span> std::string&amp; <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>,
<a name="l00056"></a>00056                     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> number)
<a name="l00057"></a>00057   : <a class="code" href="classlibMesh_1_1System.php">Parent</a>(es, name, number),
<a name="l00058"></a>00058     L2_matrix(<a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix</a>&lt;<a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a>&gt;::build()),
<a name="l00059"></a>00059     nonzero_initialization(false),
<a name="l00060"></a>00060     init_filename(<span class="stringliteral">&quot;&quot;</span>),
<a name="l00061"></a>00061     dt(0.05),
<a name="l00062"></a>00062     euler_theta(1.),
<a name="l00063"></a>00063     _k(0),
<a name="l00064"></a>00064     _K(0),
<a name="l00065"></a>00065     POD_tol(-1.),
<a name="l00066"></a>00066     max_truth_solves(-1),
<a name="l00067"></a>00067     L2_assembly(NULL)
<a name="l00068"></a>00068 {
<a name="l00069"></a>00069   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#adbbe1db7bf9fd6a56b949147cd75d79f">old_RB_solution</a>.<a class="code" href="classlibMesh_1_1DenseVector.php#a08430ae781094632e8272cbb825d4f44">resize</a>(0);
<a name="l00070"></a>00070 
<a name="l00071"></a>00071   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a5f9a29b24cc7de2f92e0e1b8f5acbe71">temporal_data</a>.resize(0);
<a name="l00072"></a>00072 
<a name="l00073"></a>00073   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#aecf2610660c4023d6c993b4c08b64be4">initial_L2_error_all_N</a>.resize(0);
<a name="l00074"></a>00074 
<a name="l00075"></a>00075   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a400cfc38ee1a109d110230227d59b651">Fq_Mq_representor_norms</a>.clear();
<a name="l00076"></a>00076   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a4ab78d5be55e56ba7170868428592f51">Mq_Mq_representor_norms</a>.clear();
<a name="l00077"></a>00077   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ad2d68b220943632bcb8327ca1b388eae">Aq_Mq_representor_norms</a>.clear();
<a name="l00078"></a>00078   
<a name="l00079"></a>00079   <span class="comment">// Clear the theta and assembly vectors so that we can push_back</span>
<a name="l00080"></a>00080   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae1c7dff67ddddddb8b7f2bb96e78f4ec">theta_q_m_vector</a>.clear();
<a name="l00081"></a>00081   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ab0c9e56b352b41ae67ad085358b5606f">M_q_intrr_assembly_vector</a>.clear();
<a name="l00082"></a>00082   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a35b236bc4b078d83bd0cb58a4aeb274f">M_q_bndry_assembly_vector</a>.clear();
<a name="l00083"></a>00083 }
<a name="l00084"></a>00084 
<a name="l00085"></a>00085 
<a name="l00086"></a>00086 
<a name="l00087"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a66cc224cd6cf5b3fe6ea704dc956b101">00087</a> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a66cc224cd6cf5b3fe6ea704dc956b101">TransientRBSystem::~TransientRBSystem</a> ()
<a name="l00088"></a>00088 {
<a name="l00089"></a>00089   this-&gt;<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a7fd1249de92ea775b87fc6c26a193eb5">clear</a>();
<a name="l00090"></a>00090 }
<a name="l00091"></a>00091 
<a name="l00092"></a>00092 
<a name="l00093"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a7fd1249de92ea775b87fc6c26a193eb5">00093</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a7fd1249de92ea775b87fc6c26a193eb5">TransientRBSystem::clear</a>()
<a name="l00094"></a>00094 {
<a name="l00095"></a>00095   <a class="code" href="classlibMesh_1_1TransientSystem.php#aff00cbc23f30989911888cad863ee24b">Parent::clear</a>();
<a name="l00096"></a>00096   
<a name="l00097"></a>00097   <span class="comment">// clear the mass matrices</span>
<a name="l00098"></a>00098   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q=0; q&lt;<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>(); q++)
<a name="l00099"></a>00099   {
<a name="l00100"></a>00100     <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a9ba330e7121f7141b7ec495b3a2370be">M_q_vector</a>[q])
<a name="l00101"></a>00101     {
<a name="l00102"></a>00102       <span class="keyword">delete</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a9ba330e7121f7141b7ec495b3a2370be">M_q_vector</a>[q];
<a name="l00103"></a>00103       <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a9ba330e7121f7141b7ec495b3a2370be">M_q_vector</a>[q] = NULL;
<a name="l00104"></a>00104     }
<a name="l00105"></a>00105   }
<a name="l00106"></a>00106 
<a name="l00107"></a>00107   <span class="comment">// clear the temporal_data</span>
<a name="l00108"></a>00108   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a5f9a29b24cc7de2f92e0e1b8f5acbe71">temporal_data</a>.size(); i++)
<a name="l00109"></a>00109   {
<a name="l00110"></a>00110     <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a5f9a29b24cc7de2f92e0e1b8f5acbe71">temporal_data</a>[i])
<a name="l00111"></a>00111     {
<a name="l00112"></a>00112       <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a5f9a29b24cc7de2f92e0e1b8f5acbe71">temporal_data</a>[i]-&gt;clear();
<a name="l00113"></a>00113       <span class="keyword">delete</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a5f9a29b24cc7de2f92e0e1b8f5acbe71">temporal_data</a>[i];
<a name="l00114"></a>00114       <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a5f9a29b24cc7de2f92e0e1b8f5acbe71">temporal_data</a>[i] = NULL;
<a name="l00115"></a>00115     }
<a name="l00116"></a>00116   }
<a name="l00117"></a>00117   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a5f9a29b24cc7de2f92e0e1b8f5acbe71">temporal_data</a>.resize(0);
<a name="l00118"></a>00118 
<a name="l00119"></a>00119   <span class="comment">// Clear the basis-function-dependent data using a call to</span>
<a name="l00120"></a>00120   <span class="comment">// the non-virtual helper function</span>
<a name="l00121"></a>00121   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a5c843c30351d24f939389474310d770c">clear_basis_helper</a>();
<a name="l00122"></a>00122 }
<a name="l00123"></a>00123 
<a name="l00124"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#ac3af79dab200ccbb0c13ec4ee2343720">00124</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ac3af79dab200ccbb0c13ec4ee2343720">TransientRBSystem::clear_basis_function_dependent_data</a>()
<a name="l00125"></a>00125 {
<a name="l00126"></a>00126   <span class="comment">// Call non-virtual helper function that performs the clear</span>
<a name="l00127"></a>00127   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a5c843c30351d24f939389474310d770c">clear_basis_helper</a>();
<a name="l00128"></a>00128 
<a name="l00129"></a>00129   <a class="code" href="classlibMesh_1_1RBSystem.php#ad611f694e8d504268b101ea3266b590f">Parent::clear_basis_function_dependent_data</a>();
<a name="l00130"></a>00130 }
<a name="l00131"></a>00131 
<a name="l00132"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a5c843c30351d24f939389474310d770c">00132</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a5c843c30351d24f939389474310d770c">TransientRBSystem::clear_basis_helper</a>()
<a name="l00133"></a>00133 {
<a name="l00134"></a>00134   <span class="comment">// Finally delete the representors</span>
<a name="l00135"></a>00135   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_m=0; q_m&lt;<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>(); q_m++)
<a name="l00136"></a>00136   {
<a name="l00137"></a>00137     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a7b52b6d7cf4f4f9245464050e876d21b">M_q_representor</a>[q_m].size(); i++)
<a name="l00138"></a>00138     {
<a name="l00139"></a>00139       <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a7b52b6d7cf4f4f9245464050e876d21b">M_q_representor</a>[q_m][i])
<a name="l00140"></a>00140       {
<a name="l00141"></a>00141         <span class="keyword">delete</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a7b52b6d7cf4f4f9245464050e876d21b">M_q_representor</a>[q_m][i];
<a name="l00142"></a>00142         <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a7b52b6d7cf4f4f9245464050e876d21b">M_q_representor</a>[q_m][i] = NULL;
<a name="l00143"></a>00143       }
<a name="l00144"></a>00144     }
<a name="l00145"></a>00145   }
<a name="l00146"></a>00146 }
<a name="l00147"></a>00147 
<a name="l00148"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#aaff3a14e0f537aac7289e14239c0f3e5">00148</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#aaff3a14e0f537aac7289e14239c0f3e5">TransientRBSystem::init_data</a> ()
<a name="l00149"></a>00149 {
<a name="l00150"></a>00150   <span class="comment">// Indicate that we need to compute the RB</span>
<a name="l00151"></a>00151   <span class="comment">// inner product matrix in this case</span>
<a name="l00152"></a>00152   <a class="code" href="classlibMesh_1_1RBSystem.php#a52ba5c957ff8b7f85ae16707df632b67">compute_RB_inner_product</a> = <span class="keyword">true</span>;
<a name="l00153"></a>00153 
<a name="l00154"></a>00154   <span class="comment">// Read in data from parameters_filename</span>
<a name="l00155"></a>00155   GetPot infile(<a class="code" href="classlibMesh_1_1RBSystem.php#a3aa3cce2414d86488881e1bbe4adcd00">parameters_filename</a>);
<a name="l00156"></a>00156 
<a name="l00157"></a>00157   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#af0fbee2db2698376fe3a932c5a7bcc26">nonzero_initialization</a> = infile(<span class="stringliteral">&quot;nonzero_initialization&quot;</span>,<a class="code" href="classlibMesh_1_1TransientRBSystem.php#af0fbee2db2698376fe3a932c5a7bcc26">nonzero_initialization</a>);
<a name="l00158"></a>00158   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a7cfe02ecfa70244829bb835fc9f2eab6">init_filename</a> = infile(<span class="stringliteral">&quot;init_filename&quot;</span>,<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a7cfe02ecfa70244829bb835fc9f2eab6">init_filename</a>);
<a name="l00159"></a>00159 
<a name="l00160"></a>00160   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> K_in                    = infile(<span class="stringliteral">&quot;K&quot;</span>, <a class="code" href="classlibMesh_1_1TransientRBSystem.php#aac8858a7e9af6497f3c37a4b7956ca6a">_K</a>);
<a name="l00161"></a>00161   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> dt_in                     = infile(<span class="stringliteral">&quot;dt&quot;</span>, <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a04397bf3cc20ccd2bb5056c22b45c9f5">dt</a>);
<a name="l00162"></a>00162   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> euler_theta_in            = infile(<span class="stringliteral">&quot;euler_theta&quot;</span>, <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a5af426f9dc2b27772aef689c19fbf4b0">euler_theta</a>);
<a name="l00163"></a>00163   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> POD_tol_in                = infile(<span class="stringliteral">&quot;POD_tol&quot;</span>, <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ab631619490c50d5e4f7873b6800f5bf8">POD_tol</a>);
<a name="l00164"></a>00164   <span class="keyword">const</span> <span class="keywordtype">int</span> max_truth_solves_in        = infile(<span class="stringliteral">&quot;max_truth_solves&quot;</span>, <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a50ac30217ac9358f43981e9e04d930c9">max_truth_solves</a>);
<a name="l00165"></a>00165   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> delta_N_in        = infile(<span class="stringliteral">&quot;delta_N&quot;</span>, <a class="code" href="classlibMesh_1_1RBSystem.php#a36ba489bd3158bbff48a5607e1d21d30">delta_N</a>);
<a name="l00166"></a>00166 
<a name="l00167"></a>00167   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a287beb41c8dcc60c976eb4a95146ea84">set_K</a>(K_in);
<a name="l00168"></a>00168   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a64abf8bdf7b064b4704c09c8f4f50682">set_dt</a>(dt_in);
<a name="l00169"></a>00169   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a91b4d8e4e75b43cc4958945198a39efd">set_euler_theta</a>(euler_theta_in);
<a name="l00170"></a>00170   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#af3a1ec2ed58b491118a32521bf9d6b55">set_POD_tol</a>(POD_tol_in);
<a name="l00171"></a>00171   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae6b33671e8cc08ffa859f6c32ce15506">set_max_truth_solves</a>(max_truth_solves_in);
<a name="l00172"></a>00172   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a6a0ae338e9bb14d354ee6385cb5df85f">set_delta_N</a>(delta_N_in);
<a name="l00173"></a>00173 
<a name="l00174"></a>00174   <span class="comment">// We read this in here also (the member variable is initialized in RBSystem, but</span>
<a name="l00175"></a>00175   <span class="comment">// we need to know its value here as well in order to initialize properly)</span>
<a name="l00176"></a>00176   <a class="code" href="classlibMesh_1_1RBBase.php#a11c4b80a15c0e9ea1d822f5e04545059">initialize_calN_dependent_data</a> = infile(<span class="stringliteral">&quot;initialize_calN_dependent_data&quot;</span>,
<a name="l00177"></a>00177                                           <a class="code" href="classlibMesh_1_1RBBase.php#a11c4b80a15c0e9ea1d822f5e04545059">initialize_calN_dependent_data</a>);
<a name="l00178"></a>00178   <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBBase.php#a11c4b80a15c0e9ea1d822f5e04545059">initialize_calN_dependent_data</a>)
<a name="l00179"></a>00179   {
<a name="l00180"></a>00180     <span class="comment">// Call the Parent&#39;s initialization routine.</span>
<a name="l00181"></a>00181     <a class="code" href="classlibMesh_1_1TransientSystem.php#a125261b1215285f17cb24424b36e9ee4">Parent::init_data</a>();
<a name="l00182"></a>00182   }
<a name="l00183"></a>00183   <span class="keywordflow">else</span>
<a name="l00184"></a>00184   {
<a name="l00185"></a>00185     <span class="comment">// If we do not initialize calN-dependent data, then we</span>
<a name="l00186"></a>00186     <span class="comment">// must skip initialization of Parent (=TransientSystem&lt;RBSystem&gt;)</span>
<a name="l00187"></a>00187     <span class="comment">// and just initialize RBSystem.</span>
<a name="l00188"></a>00188     <a class="code" href="classlibMesh_1_1TransientRBSystem.php#aaff3a14e0f537aac7289e14239c0f3e5">RBSystem::init_data</a>();
<a name="l00189"></a>00189   }
<a name="l00190"></a>00190 
<a name="l00191"></a>00191   <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; std::endl &lt;&lt; <span class="stringliteral">&quot;TransientRBSystem parameters:&quot;</span> &lt;&lt; std::endl;
<a name="l00192"></a>00192   <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Q_m: &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>() &lt;&lt; std::endl;
<a name="l00193"></a>00193   <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Number of time-steps: &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a1d6afd63f9ec53e44cf75eb982df07c4">get_K</a>() &lt;&lt; std::endl;
<a name="l00194"></a>00194   <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;dt: &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ab5a283a3f305fd03ee1f8e25a5f11bbc">get_dt</a>() &lt;&lt; std::endl;
<a name="l00195"></a>00195   <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;euler_theta (time discretization parameter): &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a546f47bca2dec636e0fe9c095c3dc3dd">get_euler_theta</a>() &lt;&lt; std::endl;
<a name="l00196"></a>00196   <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a00d040b3d3e32c093838a49ae143dfc9">get_POD_tol</a>() &gt; 0.)
<a name="l00197"></a>00197     <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;POD_tol: &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a00d040b3d3e32c093838a49ae143dfc9">get_POD_tol</a>() &lt;&lt; std::endl;
<a name="l00198"></a>00198   <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a50ac30217ac9358f43981e9e04d930c9">max_truth_solves</a> &gt; 0)
<a name="l00199"></a>00199     <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Maximum number of truth solves: &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a50ac30217ac9358f43981e9e04d930c9">max_truth_solves</a> &lt;&lt; std::endl;
<a name="l00200"></a>00200   <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;delta_N (number of basis functions to add each POD-Greedy step): &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a6eb3788340334cf4bcf9d8fa788c31f8">get_delta_N</a>() &lt;&lt; std::endl;
<a name="l00201"></a>00201   <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1TransientRBSystem.php#af0fbee2db2698376fe3a932c5a7bcc26">nonzero_initialization</a>)
<a name="l00202"></a>00202   {
<a name="l00203"></a>00203     <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Reading initial condition from &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a7cfe02ecfa70244829bb835fc9f2eab6">init_filename</a> &lt;&lt; std::endl;
<a name="l00204"></a>00204   }
<a name="l00205"></a>00205   <span class="keywordflow">else</span>
<a name="l00206"></a>00206   {
<a name="l00207"></a>00207     <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Using zero initial condition&quot;</span> &lt;&lt; std::endl;
<a name="l00208"></a>00208   }
<a name="l00209"></a>00209   <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; std::endl;
<a name="l00210"></a>00210 }
<a name="l00211"></a>00211 
<a name="l00212"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae532258d3c072f941052e4e999665070">00212</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae532258d3c072f941052e4e999665070">TransientRBSystem::initialize_RB_system</a>(<span class="keywordtype">bool</span> online_mode)
<a name="l00213"></a>00213 {
<a name="l00214"></a>00214   <span class="comment">// Resize vectors for storing calN-dependent data but only</span>
<a name="l00215"></a>00215   <span class="comment">// initialize if initialize_calN_dependent_data == true</span>
<a name="l00216"></a>00216   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_time_levels = <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a1d6afd63f9ec53e44cf75eb982df07c4">get_K</a>()+1;
<a name="l00217"></a>00217   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a5f9a29b24cc7de2f92e0e1b8f5acbe71">temporal_data</a>.resize(n_time_levels);
<a name="l00218"></a>00218   
<a name="l00219"></a>00219   <span class="comment">// Resize vectors for storing calN-dependent data but only</span>
<a name="l00220"></a>00220   <span class="comment">// initialize if initialize_calN_dependent_data == true</span>
<a name="l00221"></a>00221   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a9ba330e7121f7141b7ec495b3a2370be">M_q_vector</a>.resize(<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>());
<a name="l00222"></a>00222   
<a name="l00223"></a>00223   <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBBase.php#a11c4b80a15c0e9ea1d822f5e04545059">initialize_calN_dependent_data</a>)
<a name="l00224"></a>00224   {
<a name="l00225"></a>00225     <span class="comment">// Only initialize the mass matrices if we</span>
<a name="l00226"></a>00226     <span class="comment">// are not in low-memory mode</span>
<a name="l00227"></a>00227     <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a>)
<a name="l00228"></a>00228     {
<a name="l00229"></a>00229       <a class="code" href="classlibMesh_1_1DofMap.php">DofMap</a>&amp; dof_map = this-&gt;<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>();
<a name="l00230"></a>00230 
<a name="l00231"></a>00231       dof_map.<a class="code" href="classlibMesh_1_1DofMap.php#aa10200782a0f8fe0c4d3f7bdf10cedc6">attach_matrix</a>(*<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a4e15721a62defb903900352ceb0ea367">L2_matrix</a>);
<a name="l00232"></a>00232       <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a4e15721a62defb903900352ceb0ea367">L2_matrix</a>-&gt;init();
<a name="l00233"></a>00233       <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a4e15721a62defb903900352ceb0ea367">L2_matrix</a>-&gt;zero();
<a name="l00234"></a>00234       
<a name="l00235"></a>00235       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q=0; q&lt;<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>(); q++)
<a name="l00236"></a>00236       {
<a name="l00237"></a>00237         <span class="comment">// Initialize the memory for the matrices</span>
<a name="l00238"></a>00238         <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a9ba330e7121f7141b7ec495b3a2370be">M_q_vector</a>[q] = <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;Number&gt;::build</a>().release();
<a name="l00239"></a>00239         dof_map.<a class="code" href="classlibMesh_1_1DofMap.php#aa10200782a0f8fe0c4d3f7bdf10cedc6">attach_matrix</a>(*<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a9ba330e7121f7141b7ec495b3a2370be">M_q_vector</a>[q]);
<a name="l00240"></a>00240         <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a9ba330e7121f7141b7ec495b3a2370be">M_q_vector</a>[q]-&gt;init();
<a name="l00241"></a>00241         <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a9ba330e7121f7141b7ec495b3a2370be">M_q_vector</a>[q]-&gt;zero();
<a name="l00242"></a>00242       }
<a name="l00243"></a>00243     }
<a name="l00244"></a>00244 
<a name="l00245"></a>00245     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_time_levels; i++)
<a name="l00246"></a>00246     {
<a name="l00247"></a>00247       <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a5f9a29b24cc7de2f92e0e1b8f5acbe71">temporal_data</a>[i] = (<a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;::build</a>().release());
<a name="l00248"></a>00248       <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a5f9a29b24cc7de2f92e0e1b8f5acbe71">temporal_data</a>[i]-&gt;init (this-&gt;<a class="code" href="classlibMesh_1_1System.php#a90dbb901f00c14ff18399f4afabcebe5">n_dofs</a>(), this-&gt;<a class="code" href="classlibMesh_1_1System.php#ae3aeb82e65b06789823d41da3c5df7a2">n_local_dofs</a>(), <span class="keyword">false</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">libMeshEnums::PARALLEL</a>);
<a name="l00249"></a>00249     }
<a name="l00250"></a>00250   }
<a name="l00251"></a>00251 
<a name="l00252"></a>00252   <a class="code" href="classlibMesh_1_1RBSystem.php#a5911f7b778db3b2791ca89d4e9820125">Parent::initialize_RB_system</a>(online_mode);
<a name="l00253"></a>00253   
<a name="l00254"></a>00254   <span class="comment">// Resize M_q_representor, has to be after Parent::init_data call</span>
<a name="l00255"></a>00255   <span class="comment">// since Nmax is read in in RBSystem</span>
<a name="l00256"></a>00256   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a7b52b6d7cf4f4f9245464050e876d21b">M_q_representor</a>.resize(<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>());
<a name="l00257"></a>00257   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_m=0; q_m&lt;<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>(); q_m++)
<a name="l00258"></a>00258   {
<a name="l00259"></a>00259     <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a7b52b6d7cf4f4f9245464050e876d21b">M_q_representor</a>[q_m].resize(<a class="code" href="classlibMesh_1_1RBSystem.php#ab47d6a963c4f68b5a3d1eea7905257f5">Nmax</a>);
<a name="l00260"></a>00260   }
<a name="l00261"></a>00261 
<a name="l00262"></a>00262 
<a name="l00263"></a>00263   <span class="comment">// Now allocate the N (i.e. RB) dependent data structures</span>
<a name="l00264"></a>00264 
<a name="l00265"></a>00265   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a8cbf1f70128f7a173eb169aebd0f496e">RB_L2_matrix</a>.<a class="code" href="classlibMesh_1_1DenseMatrix.php#ad967ca8d40990ed5cae9944a285a320d">resize</a>(<a class="code" href="classlibMesh_1_1RBSystem.php#ab47d6a963c4f68b5a3d1eea7905257f5">Nmax</a>,<a class="code" href="classlibMesh_1_1RBSystem.php#ab47d6a963c4f68b5a3d1eea7905257f5">Nmax</a>);
<a name="l00266"></a>00266 
<a name="l00267"></a>00267   <span class="comment">// Allocate dense matrices for RB solves</span>
<a name="l00268"></a>00268   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#aae9cbd15df988bcdf5cf2db5fcb24e5b">RB_M_q_vector</a>.resize(<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>());
<a name="l00269"></a>00269   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q=0; q&lt;<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>(); q++)
<a name="l00270"></a>00270   {
<a name="l00271"></a>00271     <span class="comment">// Initialize the memory for the RB matrices</span>
<a name="l00272"></a>00272     <a class="code" href="classlibMesh_1_1TransientRBSystem.php#aae9cbd15df988bcdf5cf2db5fcb24e5b">RB_M_q_vector</a>[q].resize(<a class="code" href="classlibMesh_1_1RBSystem.php#ab47d6a963c4f68b5a3d1eea7905257f5">Nmax</a>,<a class="code" href="classlibMesh_1_1RBSystem.php#ab47d6a963c4f68b5a3d1eea7905257f5">Nmax</a>);
<a name="l00273"></a>00273   }
<a name="l00274"></a>00274 
<a name="l00275"></a>00275   <span class="comment">// Initialize vectors for the norms of the representors</span>
<a name="l00276"></a>00276   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a400cfc38ee1a109d110230227d59b651">Fq_Mq_representor_norms</a>.resize(<a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>());
<a name="l00277"></a>00277   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>(); i++)
<a name="l00278"></a>00278   {
<a name="l00279"></a>00279     <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a400cfc38ee1a109d110230227d59b651">Fq_Mq_representor_norms</a>[i].resize(<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>());
<a name="l00280"></a>00280     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>(); j++)
<a name="l00281"></a>00281     {
<a name="l00282"></a>00282       <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a400cfc38ee1a109d110230227d59b651">Fq_Mq_representor_norms</a>[i][j].resize(<a class="code" href="classlibMesh_1_1RBSystem.php#ab47d6a963c4f68b5a3d1eea7905257f5">Nmax</a>);
<a name="l00283"></a>00283     }
<a name="l00284"></a>00284   }
<a name="l00285"></a>00285 
<a name="l00286"></a>00286   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Q_m_hat = <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>()*(<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>()+1)/2;
<a name="l00287"></a>00287   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a4ab78d5be55e56ba7170868428592f51">Mq_Mq_representor_norms</a>.resize(Q_m_hat);
<a name="l00288"></a>00288   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;Q_m_hat; i++)
<a name="l00289"></a>00289   {
<a name="l00290"></a>00290     <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a4ab78d5be55e56ba7170868428592f51">Mq_Mq_representor_norms</a>[i].resize(<a class="code" href="classlibMesh_1_1RBSystem.php#ab47d6a963c4f68b5a3d1eea7905257f5">Nmax</a>);
<a name="l00291"></a>00291     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#ab47d6a963c4f68b5a3d1eea7905257f5">Nmax</a>; j++)
<a name="l00292"></a>00292     {
<a name="l00293"></a>00293       <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a4ab78d5be55e56ba7170868428592f51">Mq_Mq_representor_norms</a>[i][j].resize(Nmax);
<a name="l00294"></a>00294     }
<a name="l00295"></a>00295   }
<a name="l00296"></a>00296 
<a name="l00297"></a>00297   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ad2d68b220943632bcb8327ca1b388eae">Aq_Mq_representor_norms</a>.resize(<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>());
<a name="l00298"></a>00298   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>(); i++)
<a name="l00299"></a>00299   {
<a name="l00300"></a>00300     <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ad2d68b220943632bcb8327ca1b388eae">Aq_Mq_representor_norms</a>[i].resize(<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>());
<a name="l00301"></a>00301     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>(); j++)
<a name="l00302"></a>00302     {
<a name="l00303"></a>00303       <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ad2d68b220943632bcb8327ca1b388eae">Aq_Mq_representor_norms</a>[i][j].resize(<a class="code" href="classlibMesh_1_1RBSystem.php#ab47d6a963c4f68b5a3d1eea7905257f5">Nmax</a>);
<a name="l00304"></a>00304       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k=0; k&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#ab47d6a963c4f68b5a3d1eea7905257f5">Nmax</a>; k++)
<a name="l00305"></a>00305       {
<a name="l00306"></a>00306         <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ad2d68b220943632bcb8327ca1b388eae">Aq_Mq_representor_norms</a>[i][j][k].resize(Nmax);
<a name="l00307"></a>00307       }
<a name="l00308"></a>00308     }
<a name="l00309"></a>00309   }
<a name="l00310"></a>00310 
<a name="l00311"></a>00311   <span class="comment">// Initialize the initial condition storage</span>
<a name="l00312"></a>00312   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a4b802536cffba3d792caf8f95ed04327">RB_initial_condition_all_N</a>.resize(<a class="code" href="classlibMesh_1_1RBSystem.php#ab47d6a963c4f68b5a3d1eea7905257f5">Nmax</a>);
<a name="l00313"></a>00313   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a4b802536cffba3d792caf8f95ed04327">RB_initial_condition_all_N</a>.size(); i++)
<a name="l00314"></a>00314   {
<a name="l00315"></a>00315     <span class="comment">// The i^th row holds a vector of lenght i+1</span>
<a name="l00316"></a>00316     <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a4b802536cffba3d792caf8f95ed04327">RB_initial_condition_all_N</a>[i].resize(i+1);
<a name="l00317"></a>00317   }
<a name="l00318"></a>00318 
<a name="l00319"></a>00319   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#aca06ad6a5b244bb6e8b76d53810e2eb6">RB_ic_proj_rhs_all_N</a>.<a class="code" href="classlibMesh_1_1DenseVector.php#a08430ae781094632e8272cbb825d4f44">resize</a>(<a class="code" href="classlibMesh_1_1RBSystem.php#ab47d6a963c4f68b5a3d1eea7905257f5">Nmax</a>);
<a name="l00320"></a>00320   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#aecf2610660c4023d6c993b4c08b64be4">initial_L2_error_all_N</a>.resize(<a class="code" href="classlibMesh_1_1RBSystem.php#ab47d6a963c4f68b5a3d1eea7905257f5">Nmax</a>);
<a name="l00321"></a>00321 
<a name="l00322"></a>00322   <span class="comment">// Resize the RB output vectors</span>
<a name="l00323"></a>00323   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ad5066d07edc5e25cb04b00fde9e72ec2">RB_outputs_all_k</a>.resize(<a class="code" href="classlibMesh_1_1RBSystem.php#a80b9e06a7c60b3bb2f5870b0ff66a2ca">get_n_outputs</a>());
<a name="l00324"></a>00324   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#aeb55ea3e37e65db40b8dd322f4bcb4a6">RB_output_error_bounds_all_k</a>.resize(<a class="code" href="classlibMesh_1_1RBSystem.php#a80b9e06a7c60b3bb2f5870b0ff66a2ca">get_n_outputs</a>());
<a name="l00325"></a>00325   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#a80b9e06a7c60b3bb2f5870b0ff66a2ca">get_n_outputs</a>(); n++)
<a name="l00326"></a>00326   {
<a name="l00327"></a>00327     <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ad5066d07edc5e25cb04b00fde9e72ec2">RB_outputs_all_k</a>[n].resize(<a class="code" href="classlibMesh_1_1TransientRBSystem.php#aac8858a7e9af6497f3c37a4b7956ca6a">_K</a>+1);
<a name="l00328"></a>00328     <a class="code" href="classlibMesh_1_1TransientRBSystem.php#aeb55ea3e37e65db40b8dd322f4bcb4a6">RB_output_error_bounds_all_k</a>[n].resize(<a class="code" href="classlibMesh_1_1TransientRBSystem.php#aac8858a7e9af6497f3c37a4b7956ca6a">_K</a>+1);
<a name="l00329"></a>00329   }
<a name="l00330"></a>00330 
<a name="l00331"></a>00331   <span class="comment">// and the truth output vectors</span>
<a name="l00332"></a>00332   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a58dda0affa01e49069a725153dcf5cc6">truth_outputs_all_k</a>.resize(<a class="code" href="classlibMesh_1_1RBSystem.php#a80b9e06a7c60b3bb2f5870b0ff66a2ca">get_n_outputs</a>());
<a name="l00333"></a>00333   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#a80b9e06a7c60b3bb2f5870b0ff66a2ca">get_n_outputs</a>(); n++)
<a name="l00334"></a>00334   {
<a name="l00335"></a>00335     <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a58dda0affa01e49069a725153dcf5cc6">truth_outputs_all_k</a>[n].resize(<a class="code" href="classlibMesh_1_1TransientRBSystem.php#aac8858a7e9af6497f3c37a4b7956ca6a">_K</a>+1);
<a name="l00336"></a>00336   }
<a name="l00337"></a>00337   
<a name="l00338"></a>00338   <span class="comment">// Now update RB_ic_proj_rhs_all_N if necessary.</span>
<a name="l00339"></a>00339   <span class="comment">// This allows us to compute the L2 projection</span>
<a name="l00340"></a>00340   <span class="comment">// of the initial condition into the RB space</span>
<a name="l00341"></a>00341   <span class="comment">// so that we can continue to enrich a given RB</span>
<a name="l00342"></a>00342   <span class="comment">// space.</span>
<a name="l00343"></a>00343   <span class="keywordflow">if</span>(!online_mode)
<a name="l00344"></a>00344     <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>() &gt; 0)
<a name="l00345"></a>00345     {
<a name="l00346"></a>00346       <span class="comment">// Load the initial condition into the solution vector</span>
<a name="l00347"></a>00347       <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ab455004dfc57c1a9454534ab1a761dbc">initialize_truth</a>();
<a name="l00348"></a>00348 
<a name="l00349"></a>00349       <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt; NumericVector&lt;Number&gt;</a> &gt; temp1 = <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;::build</a>();
<a name="l00350"></a>00350       temp1-&gt;init (this-&gt;<a class="code" href="classlibMesh_1_1System.php#a90dbb901f00c14ff18399f4afabcebe5">n_dofs</a>(), this-&gt;<a class="code" href="classlibMesh_1_1System.php#ae3aeb82e65b06789823d41da3c5df7a2">n_local_dofs</a>(), <span class="keyword">false</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">libMeshEnums::PARALLEL</a>);
<a name="l00351"></a>00351 
<a name="l00352"></a>00352       <span class="comment">// First compute the right-hand side vector for the L2 projection</span>
<a name="l00353"></a>00353       <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a>)
<a name="l00354"></a>00354       {
<a name="l00355"></a>00355         <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a4e15721a62defb903900352ceb0ea367">L2_matrix</a>-&gt;vector_mult(*temp1, *<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>);
<a name="l00356"></a>00356       }
<a name="l00357"></a>00357       <span class="keywordflow">else</span>
<a name="l00358"></a>00358       {
<a name="l00359"></a>00359         <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a0ee3e3816d13aeae07fe5212dda5f521">assemble_L2_matrix</a>(<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>);
<a name="l00360"></a>00360         <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#adaccc5857f1a5d5ca264ded0b8bfb986">vector_mult</a>(*temp1, *<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>);
<a name="l00361"></a>00361       }
<a name="l00362"></a>00362 
<a name="l00363"></a>00363       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>(); i++)
<a name="l00364"></a>00364       {
<a name="l00365"></a>00365         <a class="code" href="classlibMesh_1_1TransientRBSystem.php#aca06ad6a5b244bb6e8b76d53810e2eb6">RB_ic_proj_rhs_all_N</a>(i) = temp1-&gt;dot(*<a class="code" href="classlibMesh_1_1RBSystem.php#abfe6d67ed23243d225f12747f355f105">basis_functions</a>[i]);
<a name="l00366"></a>00366       }
<a name="l00367"></a>00367     }
<a name="l00368"></a>00368 }
<a name="l00369"></a>00369 
<a name="l00370"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a528a1bc40b5c1b63ee8c51375b1824dc">00370</a> <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;Number&gt;</a>* <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a528a1bc40b5c1b63ee8c51375b1824dc">TransientRBSystem::get_M_q</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q)
<a name="l00371"></a>00371 {
<a name="l00372"></a>00372   <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a>)
<a name="l00373"></a>00373   {
<a name="l00374"></a>00374     <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error: The affine matrices are not store in low-memory mode.&quot;</span> &lt;&lt; std::endl;
<a name="l00375"></a>00375     libmesh_error();
<a name="l00376"></a>00376   }
<a name="l00377"></a>00377 
<a name="l00378"></a>00378   <span class="keywordflow">if</span>(q &gt;= <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>())
<a name="l00379"></a>00379   {
<a name="l00380"></a>00380     <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error: We must have q &lt; Q_m in get_M_q.&quot;</span>
<a name="l00381"></a>00381                  &lt;&lt; std::endl;
<a name="l00382"></a>00382     libmesh_error();
<a name="l00383"></a>00383   }
<a name="l00384"></a>00384 
<a name="l00385"></a>00385   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a9ba330e7121f7141b7ec495b3a2370be">M_q_vector</a>[q];
<a name="l00386"></a>00386 }
<a name="l00387"></a>00387 
<a name="l00388"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a36a6aa3be4fb96b256cb9d664e5a2dfb">00388</a> <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a36a6aa3be4fb96b256cb9d664e5a2dfb">TransientRBSystem::eval_theta_q_m</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q)
<a name="l00389"></a>00389 {
<a name="l00390"></a>00390   <span class="keywordflow">if</span>(q &gt;= <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>())
<a name="l00391"></a>00391   {
<a name="l00392"></a>00392     <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error: We must have q &lt; Q_m in eval_theta_q_m.&quot;</span>
<a name="l00393"></a>00393                  &lt;&lt; std::endl;
<a name="l00394"></a>00394     libmesh_error();
<a name="l00395"></a>00395   }
<a name="l00396"></a>00396 
<a name="l00397"></a>00397   libmesh_assert(<a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae1c7dff67ddddddb8b7f2bb96e78f4ec">theta_q_m_vector</a>[q] != NULL);
<a name="l00398"></a>00398 
<a name="l00399"></a>00399   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae1c7dff67ddddddb8b7f2bb96e78f4ec">theta_q_m_vector</a>[q](*theta_data);
<a name="l00400"></a>00400 }
<a name="l00401"></a>00401 
<a name="l00402"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a0ee3e3816d13aeae07fe5212dda5f521">00402</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a0ee3e3816d13aeae07fe5212dda5f521">TransientRBSystem::assemble_L2_matrix</a>(<a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;Number&gt;</a>* input_matrix)
<a name="l00403"></a>00403 {
<a name="l00404"></a>00404   input_matrix-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#a966e0a6479f33c2518937e7d0f54602f">zero</a>();
<a name="l00405"></a>00405   <a class="code" href="classlibMesh_1_1RBSystem.php#a4a1243f45ea36fbd2a10ad6956c62deb">add_scaled_matrix_and_vector</a>(1., <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a046c9e8b526c6d8b4c8093c6dc35fbfa">L2_assembly</a>, NULL, input_matrix, NULL);
<a name="l00406"></a>00406 }
<a name="l00407"></a>00407 
<a name="l00408"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a9171ce91830a0ebfddb1666078552366">00408</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a9171ce91830a0ebfddb1666078552366">TransientRBSystem::assemble_mass_matrix</a>(<a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;Number&gt;</a>* input_matrix)
<a name="l00409"></a>00409 {
<a name="l00410"></a>00410   input_matrix-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#a966e0a6479f33c2518937e7d0f54602f">zero</a>();
<a name="l00411"></a>00411   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a380f4b25919a4c93733eed98862b8f7b">add_scaled_mass_matrix</a>(1., input_matrix);
<a name="l00412"></a>00412 }
<a name="l00413"></a>00413 
<a name="l00414"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a380f4b25919a4c93733eed98862b8f7b">00414</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a380f4b25919a4c93733eed98862b8f7b">TransientRBSystem::add_scaled_mass_matrix</a>(<a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> scalar, <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;Number&gt;</a>* input_matrix)
<a name="l00415"></a>00415 {
<a name="l00416"></a>00416   <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a>)
<a name="l00417"></a>00417   {
<a name="l00418"></a>00418     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q=0; q&lt;<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>(); q++)
<a name="l00419"></a>00419       input_matrix-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#a401beeed965b80425730050a61de5c21">add</a>(scalar * <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a36a6aa3be4fb96b256cb9d664e5a2dfb">eval_theta_q_m</a>(q), *<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a528a1bc40b5c1b63ee8c51375b1824dc">get_M_q</a>(q));
<a name="l00420"></a>00420   }
<a name="l00421"></a>00421   <span class="keywordflow">else</span>
<a name="l00422"></a>00422   {
<a name="l00423"></a>00423     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q=0; q&lt;<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>(); q++)
<a name="l00424"></a>00424       <a class="code" href="classlibMesh_1_1RBSystem.php#a4a1243f45ea36fbd2a10ad6956c62deb">add_scaled_matrix_and_vector</a>(scalar * <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a36a6aa3be4fb96b256cb9d664e5a2dfb">eval_theta_q_m</a>(q),
<a name="l00425"></a>00425                                    <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ab0c9e56b352b41ae67ad085358b5606f">M_q_intrr_assembly_vector</a>[q],
<a name="l00426"></a>00426                                    <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a35b236bc4b078d83bd0cb58a4aeb274f">M_q_bndry_assembly_vector</a>[q],
<a name="l00427"></a>00427                                    input_matrix,
<a name="l00428"></a>00428                                    NULL);
<a name="l00429"></a>00429   }
<a name="l00430"></a>00430 }
<a name="l00431"></a>00431 
<a name="l00432"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#aca376bda2868976ae336c53078c9d40c">00432</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#aca376bda2868976ae336c53078c9d40c">TransientRBSystem::mass_matrix_scaled_matvec</a>(<a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> scalar,
<a name="l00433"></a>00433                                                   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>&amp; dest,
<a name="l00434"></a>00434                                                   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>&amp; arg)
<a name="l00435"></a>00435 {
<a name="l00436"></a>00436   START_LOG(<span class="stringliteral">&quot;mass_matrix_scaled_matvec()&quot;</span>, <span class="stringliteral">&quot;TransientRBSystem&quot;</span>);
<a name="l00437"></a>00437   
<a name="l00438"></a>00438   dest.<a class="code" href="classlibMesh_1_1NumericVector.php#a85b3d4a53413e3745e6ecf1c8b96ca65">zero</a>();
<a name="l00439"></a>00439 
<a name="l00440"></a>00440   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt; NumericVector&lt;Number&gt;</a> &gt; temp_vec = <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;::build</a>();
<a name="l00441"></a>00441   temp_vec-&gt;init (this-&gt;<a class="code" href="classlibMesh_1_1System.php#a90dbb901f00c14ff18399f4afabcebe5">n_dofs</a>(), this-&gt;<a class="code" href="classlibMesh_1_1System.php#ae3aeb82e65b06789823d41da3c5df7a2">n_local_dofs</a>(), <span class="keyword">false</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">libMeshEnums::PARALLEL</a>);
<a name="l00442"></a>00442         
<a name="l00443"></a>00443   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q=0; q&lt;<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>(); q++)
<a name="l00444"></a>00444   {
<a name="l00445"></a>00445     <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a>)
<a name="l00446"></a>00446     {
<a name="l00447"></a>00447       <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a528a1bc40b5c1b63ee8c51375b1824dc">get_M_q</a>(q)-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#adaccc5857f1a5d5ca264ded0b8bfb986">vector_mult</a>(*temp_vec, arg);
<a name="l00448"></a>00448     }
<a name="l00449"></a>00449     <span class="keywordflow">else</span>
<a name="l00450"></a>00450     {
<a name="l00451"></a>00451       <a class="code" href="classlibMesh_1_1RBSystem.php#a568b302f96140c76530b9412c1b87b38">assemble_scaled_matvec</a>(1.,
<a name="l00452"></a>00452                              <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ab0c9e56b352b41ae67ad085358b5606f">M_q_intrr_assembly_vector</a>[q],
<a name="l00453"></a>00453                              <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a35b236bc4b078d83bd0cb58a4aeb274f">M_q_bndry_assembly_vector</a>[q],
<a name="l00454"></a>00454                              *temp_vec,
<a name="l00455"></a>00455                              arg);
<a name="l00456"></a>00456     }
<a name="l00457"></a>00457     dest.<a class="code" href="classlibMesh_1_1NumericVector.php#aaf343defd46de8557801dc56a2884506">add</a>(scalar * <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a36a6aa3be4fb96b256cb9d664e5a2dfb">eval_theta_q_m</a>(q), *temp_vec);
<a name="l00458"></a>00458   }
<a name="l00459"></a>00459 
<a name="l00460"></a>00460   STOP_LOG(<span class="stringliteral">&quot;mass_matrix_scaled_matvec()&quot;</span>, <span class="stringliteral">&quot;TransientRBSystem&quot;</span>);
<a name="l00461"></a>00461 }
<a name="l00462"></a>00462 
<a name="l00463"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#aaa040e14836cebced3a91a0fc7a63400">00463</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#aaa040e14836cebced3a91a0fc7a63400">TransientRBSystem::truth_assembly</a>()
<a name="l00464"></a>00464 {
<a name="l00465"></a>00465   START_LOG(<span class="stringliteral">&quot;truth_assembly()&quot;</span>, <span class="stringliteral">&quot;TransientRBSystem&quot;</span>);
<a name="l00466"></a>00466 
<a name="l00467"></a>00467   this-&gt;<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#a966e0a6479f33c2518937e7d0f54602f">zero</a>();
<a name="l00468"></a>00468   this-&gt;<a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a85b3d4a53413e3745e6ecf1c8b96ca65">zero</a>();
<a name="l00469"></a>00469 
<a name="l00470"></a>00470   <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a>)
<a name="l00471"></a>00471   {
<a name="l00472"></a>00472     <span class="comment">// We should have already assembled the matrices</span>
<a name="l00473"></a>00473     <span class="comment">// and vectors in the affine expansion, so</span>
<a name="l00474"></a>00474     <span class="comment">// just use them</span>
<a name="l00475"></a>00475 
<a name="l00476"></a>00476     <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a380f4b25919a4c93733eed98862b8f7b">add_scaled_mass_matrix</a>(1./<a class="code" href="classlibMesh_1_1TransientRBSystem.php#ab5a283a3f305fd03ee1f8e25a5f11bbc">get_dt</a>(), <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>);
<a name="l00477"></a>00477     <a class="code" href="classlibMesh_1_1TransientRBSystem.php#aca376bda2868976ae336c53078c9d40c">mass_matrix_scaled_matvec</a>(1./<a class="code" href="classlibMesh_1_1TransientRBSystem.php#ab5a283a3f305fd03ee1f8e25a5f11bbc">get_dt</a>(), *<a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a>, *<a class="code" href="classlibMesh_1_1System.php#a1e1bec53fb8d8a5a2163dbee844e8417">current_local_solution</a>);
<a name="l00478"></a>00478     
<a name="l00479"></a>00479     <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt; NumericVector&lt;Number&gt;</a> &gt; temp_vec = <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;::build</a>();
<a name="l00480"></a>00480     temp_vec-&gt;init (this-&gt;<a class="code" href="classlibMesh_1_1System.php#a90dbb901f00c14ff18399f4afabcebe5">n_dofs</a>(), this-&gt;<a class="code" href="classlibMesh_1_1System.php#ae3aeb82e65b06789823d41da3c5df7a2">n_local_dofs</a>(), <span class="keyword">false</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">libMeshEnums::PARALLEL</a>);
<a name="l00481"></a>00481 
<a name="l00482"></a>00482     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_a=0; q_a&lt;<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>(); q_a++)
<a name="l00483"></a>00483     {
<a name="l00484"></a>00484       <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#a401beeed965b80425730050a61de5c21">add</a>(<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a546f47bca2dec636e0fe9c095c3dc3dd">get_euler_theta</a>()*<a class="code" href="classlibMesh_1_1RBBase.php#aeeb46ce2b390bf820f954976ee9da7ce">eval_theta_q_a</a>(q_a), *<a class="code" href="classlibMesh_1_1RBSystem.php#aef1516ea2eb482f28578cab98bd53097">get_A_q</a>(q_a));
<a name="l00485"></a>00485 
<a name="l00486"></a>00486       <a class="code" href="classlibMesh_1_1RBSystem.php#aef1516ea2eb482f28578cab98bd53097">get_A_q</a>(q_a)-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#adaccc5857f1a5d5ca264ded0b8bfb986">vector_mult</a>(*temp_vec, *<a class="code" href="classlibMesh_1_1System.php#a1e1bec53fb8d8a5a2163dbee844e8417">current_local_solution</a>);
<a name="l00487"></a>00487       temp_vec-&gt;scale( -(1.-<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a546f47bca2dec636e0fe9c095c3dc3dd">get_euler_theta</a>())*<a class="code" href="classlibMesh_1_1RBBase.php#aeeb46ce2b390bf820f954976ee9da7ce">eval_theta_q_a</a>(q_a) );
<a name="l00488"></a>00488       <a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#aaf343defd46de8557801dc56a2884506">add</a>(*temp_vec);
<a name="l00489"></a>00489     }
<a name="l00490"></a>00490 
<a name="l00491"></a>00491     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_f=0; q_f&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>(); q_f++)
<a name="l00492"></a>00492     {
<a name="l00493"></a>00493       *temp_vec = *<a class="code" href="classlibMesh_1_1RBSystem.php#a1b3f04b60e3464d779c140c280e1010e">get_F_q</a>(q_f);
<a name="l00494"></a>00494       temp_vec-&gt;scale( <a class="code" href="classlibMesh_1_1RBSystem.php#a0fd951279c9b851ac38443156b4b18bd">eval_theta_q_f</a>(q_f) );
<a name="l00495"></a>00495       <a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#aaf343defd46de8557801dc56a2884506">add</a>(*temp_vec);
<a name="l00496"></a>00496     }
<a name="l00497"></a>00497     <a class="code" href="classlibMesh_1_1RBSystem.php#a85c25bbd66bed6e4111e44566e91b5ff">zero_dirichlet_dofs_on_rhs</a>();
<a name="l00498"></a>00498 
<a name="l00499"></a>00499     <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBSystem.php#a28b1348023897cb1517724d6ac30a21d">constrained_problem</a>)
<a name="l00500"></a>00500       <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#a401beeed965b80425730050a61de5c21">add</a>(1., *<a class="code" href="classlibMesh_1_1RBSystem.php#aa7a3439518c1b8a421a79064e819f5c8">constraint_matrix</a>);
<a name="l00501"></a>00501 
<a name="l00502"></a>00502   }
<a name="l00503"></a>00503   <span class="keywordflow">else</span>
<a name="l00504"></a>00504   {
<a name="l00505"></a>00505     <span class="comment">// In low memory mode we do not store the matrices</span>
<a name="l00506"></a>00506     <span class="comment">// from the affine expansion, so need to assemble</span>
<a name="l00507"></a>00507 
<a name="l00508"></a>00508     <span class="comment">// For efficiency (i.e. to avoid doing Q_a+Q_f loops</span>
<a name="l00509"></a>00509     <span class="comment">// over the mesh) we do not use add_scaled_matrix_and_vector</span>
<a name="l00510"></a>00510     <span class="comment">// here</span>
<a name="l00511"></a>00511 
<a name="l00512"></a>00512     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a> = this-&gt;<a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">get_mesh</a>();
<a name="l00513"></a>00513     
<a name="l00514"></a>00514     std::vector&lt;FEMContext*&gt; Mq_context(<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>());
<a name="l00515"></a>00515     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_m=0; q_m&lt;Mq_context.size(); q_m++)
<a name="l00516"></a>00516     {
<a name="l00517"></a>00517       Mq_context[q_m] = this-&gt;<a class="code" href="classlibMesh_1_1RBSystem.php#aab5505a99e58300d0e4e17b31943f162">build_context</a>().release();
<a name="l00518"></a>00518       this-&gt;<a class="code" href="classlibMesh_1_1RBSystem.php#a2a9e0cb788597d488aa73e9108147ef2">init_context</a>(*Mq_context[q_m]);
<a name="l00519"></a>00519     }
<a name="l00520"></a>00520 
<a name="l00521"></a>00521     std::vector&lt;FEMContext*&gt; Aq_context(<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>());
<a name="l00522"></a>00522     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_a=0; q_a&lt;Aq_context.size(); q_a++)
<a name="l00523"></a>00523     {
<a name="l00524"></a>00524       Aq_context[q_a] = this-&gt;<a class="code" href="classlibMesh_1_1RBSystem.php#aab5505a99e58300d0e4e17b31943f162">build_context</a>().release();
<a name="l00525"></a>00525       this-&gt;<a class="code" href="classlibMesh_1_1RBSystem.php#a2a9e0cb788597d488aa73e9108147ef2">init_context</a>(*Aq_context[q_a]);
<a name="l00526"></a>00526     }
<a name="l00527"></a>00527 
<a name="l00528"></a>00528     std::vector&lt;FEMContext*&gt; Fq_context(<a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>());
<a name="l00529"></a>00529     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_f=0; q_f&lt;Fq_context.size(); q_f++)
<a name="l00530"></a>00530     {
<a name="l00531"></a>00531       Fq_context[q_f] = this-&gt;<a class="code" href="classlibMesh_1_1RBSystem.php#aab5505a99e58300d0e4e17b31943f162">build_context</a>().release();
<a name="l00532"></a>00532       this-&gt;<a class="code" href="classlibMesh_1_1RBSystem.php#a2a9e0cb788597d488aa73e9108147ef2">init_context</a>(*Fq_context[q_f]);
<a name="l00533"></a>00533     }
<a name="l00534"></a>00534 
<a name="l00535"></a>00535     <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>       el     = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a99742bad0b034a29ccae8c5a90c6f4aa">active_local_elements_begin</a>();
<a name="l00536"></a>00536     <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end_el = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a2e27f54d33f7539c0c06b36adae36cda">active_local_elements_end</a>();
<a name="l00537"></a>00537 
<a name="l00538"></a>00538     <span class="keywordflow">for</span> ( ; el != end_el; ++el)
<a name="l00539"></a>00539     {
<a name="l00540"></a>00540       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_m=0; q_m&lt;<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>(); q_m++)
<a name="l00541"></a>00541       {
<a name="l00542"></a>00542         Mq_context[q_m]-&gt;pre_fe_reinit(*<span class="keyword">this</span>, *el);
<a name="l00543"></a>00543         Mq_context[q_m]-&gt;elem_fe_reinit();
<a name="l00544"></a>00544         <span class="keywordflow">if</span>( <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ab0c9e56b352b41ae67ad085358b5606f">M_q_intrr_assembly_vector</a>[q_m] != NULL )
<a name="l00545"></a>00545         {
<a name="l00546"></a>00546           this-&gt;<a class="code" href="classlibMesh_1_1TransientRBSystem.php#ab0c9e56b352b41ae67ad085358b5606f">M_q_intrr_assembly_vector</a>[q_m](*Mq_context[q_m], *<span class="keyword">this</span>);
<a name="l00547"></a>00547           <span class="comment">// Now overwrite the local matrix with a matrix multiplication</span>
<a name="l00548"></a>00548           Mq_context[q_m]-&gt;elem_jacobian.vector_mult(Mq_context[q_m]-&gt;elem_residual, Mq_context[q_m]-&gt;elem_solution);
<a name="l00549"></a>00549         }
<a name="l00550"></a>00550       }
<a name="l00551"></a>00551 
<a name="l00552"></a>00552       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_a=0; q_a&lt;<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>(); q_a++)
<a name="l00553"></a>00553       {
<a name="l00554"></a>00554         Aq_context[q_a]-&gt;pre_fe_reinit(*<span class="keyword">this</span>, *el);
<a name="l00555"></a>00555         Aq_context[q_a]-&gt;elem_fe_reinit();
<a name="l00556"></a>00556         <span class="keywordflow">if</span>( <a class="code" href="classlibMesh_1_1RBSystem.php#a2e5fa41dea513013a95ac9cdc5a61f0c">A_q_intrr_assembly_vector</a>[q_a] != NULL )
<a name="l00557"></a>00557         {
<a name="l00558"></a>00558           this-&gt;<a class="code" href="classlibMesh_1_1RBSystem.php#a2e5fa41dea513013a95ac9cdc5a61f0c">A_q_intrr_assembly_vector</a>[q_a](*Aq_context[q_a], *<span class="keyword">this</span>);
<a name="l00559"></a>00559           <span class="comment">// Now overwrite the local matrix with a matrix multiplication</span>
<a name="l00560"></a>00560           Aq_context[q_a]-&gt;elem_jacobian.vector_mult(Aq_context[q_a]-&gt;elem_residual, Aq_context[q_a]-&gt;elem_solution);
<a name="l00561"></a>00561         }
<a name="l00562"></a>00562       }
<a name="l00563"></a>00563 
<a name="l00564"></a>00564       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_f=0; q_f&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>(); q_f++)
<a name="l00565"></a>00565       {
<a name="l00566"></a>00566         Fq_context[q_f]-&gt;pre_fe_reinit(*<span class="keyword">this</span>, *el);
<a name="l00567"></a>00567         Fq_context[q_f]-&gt;elem_fe_reinit();
<a name="l00568"></a>00568         <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBSystem.php#afabf274dd4fced20cd745e982bbd6e83">F_q_intrr_assembly_vector</a>[q_f] != NULL)
<a name="l00569"></a>00569           this-&gt;<a class="code" href="classlibMesh_1_1RBSystem.php#afabf274dd4fced20cd745e982bbd6e83">F_q_intrr_assembly_vector</a>[q_f](*Fq_context[q_f], *<span class="keyword">this</span>);
<a name="l00570"></a>00570       }
<a name="l00571"></a>00571 
<a name="l00572"></a>00572       <span class="keywordflow">for</span> (Aq_context[0]-&gt;<a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a> = 0;
<a name="l00573"></a>00573             Aq_context[0]-&gt;side != Aq_context[0]-&gt;elem-&gt;n_sides();
<a name="l00574"></a>00574             ++Aq_context[0]-&gt;side)
<a name="l00575"></a>00575       {
<a name="l00576"></a>00576         <span class="comment">// May not need to apply fluxes on non-boundary elements</span>
<a name="l00577"></a>00577         <span class="keywordflow">if</span>( (Aq_context[0]-&gt;elem-&gt;neighbor(Aq_context[0]-&gt;side) != NULL) &amp;&amp; !<a class="code" href="classlibMesh_1_1RBSystem.php#ab76a069a5cb7bb72afe582be842d8e04">impose_internal_fluxes</a> )
<a name="l00578"></a>00578           <span class="keywordflow">continue</span>;
<a name="l00579"></a>00579 
<a name="l00580"></a>00580         <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_m=0; q_m&lt;<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>(); q_m++)
<a name="l00581"></a>00581         {
<a name="l00582"></a>00582           Mq_context[q_m]-&gt;side = Mq_context[0]-&gt;side;
<a name="l00583"></a>00583 
<a name="l00584"></a>00584           <span class="keywordflow">if</span>( <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a35b236bc4b078d83bd0cb58a4aeb274f">M_q_bndry_assembly_vector</a>[q_m] != NULL )
<a name="l00585"></a>00585           {
<a name="l00586"></a>00586             Mq_context[q_m]-&gt;side_fe_reinit();
<a name="l00587"></a>00587             this-&gt;<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a35b236bc4b078d83bd0cb58a4aeb274f">M_q_bndry_assembly_vector</a>[q_m](*Mq_context[q_m], *<span class="keyword">this</span>);
<a name="l00588"></a>00588           }
<a name="l00589"></a>00589         }
<a name="l00590"></a>00590 
<a name="l00591"></a>00591         <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_a=0; q_a&lt;<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>(); q_a++)
<a name="l00592"></a>00592         {
<a name="l00593"></a>00593           Aq_context[q_a]-&gt;side = Aq_context[0]-&gt;side;
<a name="l00594"></a>00594 
<a name="l00595"></a>00595           <span class="keywordflow">if</span>( <a class="code" href="classlibMesh_1_1RBSystem.php#af494bdce91a9247fae8014b49ff42296">A_q_bndry_assembly_vector</a>[q_a] != NULL )
<a name="l00596"></a>00596           {
<a name="l00597"></a>00597             Aq_context[q_a]-&gt;side_fe_reinit();
<a name="l00598"></a>00598             this-&gt;<a class="code" href="classlibMesh_1_1RBSystem.php#af494bdce91a9247fae8014b49ff42296">A_q_bndry_assembly_vector</a>[q_a](*Aq_context[q_a], *<span class="keyword">this</span>);
<a name="l00599"></a>00599           }
<a name="l00600"></a>00600         }
<a name="l00601"></a>00601 
<a name="l00602"></a>00602         <span class="comment">// Impose boundary terms, e.g. Neuman BCs</span>
<a name="l00603"></a>00603         <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_f=0; q_f&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>(); q_f++)
<a name="l00604"></a>00604         {
<a name="l00605"></a>00605           <span class="comment">// Update the side information for all contexts</span>
<a name="l00606"></a>00606           Fq_context[q_f]-&gt;side = Aq_context[0]-&gt;side;
<a name="l00607"></a>00607 
<a name="l00608"></a>00608           <span class="keywordflow">if</span>( <a class="code" href="classlibMesh_1_1RBSystem.php#aa9f3638bb29d1be5eb80a4555217d943">F_q_bndry_assembly_vector</a>[q_f] != NULL )
<a name="l00609"></a>00609           {
<a name="l00610"></a>00610             Fq_context[q_f]-&gt;side_fe_reinit();
<a name="l00611"></a>00611             this-&gt;<a class="code" href="classlibMesh_1_1RBSystem.php#aa9f3638bb29d1be5eb80a4555217d943">F_q_bndry_assembly_vector</a>[q_f](*Fq_context[q_f], *<span class="keyword">this</span>);
<a name="l00612"></a>00612           }
<a name="l00613"></a>00613         }
<a name="l00614"></a>00614       }
<a name="l00615"></a>00615 
<a name="l00616"></a>00616       <span class="comment">// Constrain the dofs to impose hanging node or periodic constraints</span>
<a name="l00617"></a>00617       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_m=0; q_m&lt;<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>(); q_m++)
<a name="l00618"></a>00618       {
<a name="l00619"></a>00619         this-&gt;<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>().<a class="code" href="classlibMesh_1_1DofMap.php#a97906aa49177873ed7ea9029dcb0cd4b">constrain_element_matrix_and_vector</a>
<a name="l00620"></a>00620           (Mq_context[q_m]-&gt;elem_jacobian, Mq_context[q_m]-&gt;elem_residual, Mq_context[q_m]-&gt;dof_indices);
<a name="l00621"></a>00621       }
<a name="l00622"></a>00622 
<a name="l00623"></a>00623       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_a=0; q_a&lt;<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>(); q_a++)
<a name="l00624"></a>00624       {
<a name="l00625"></a>00625         this-&gt;<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>().<a class="code" href="classlibMesh_1_1DofMap.php#a97906aa49177873ed7ea9029dcb0cd4b">constrain_element_matrix_and_vector</a>
<a name="l00626"></a>00626           (Aq_context[q_a]-&gt;elem_jacobian, Aq_context[q_a]-&gt;elem_residual, Aq_context[q_a]-&gt;dof_indices);
<a name="l00627"></a>00627       }
<a name="l00628"></a>00628 
<a name="l00629"></a>00629       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_f=0; q_f&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>(); q_f++)
<a name="l00630"></a>00630       {
<a name="l00631"></a>00631         this-&gt;<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>().<a class="code" href="classlibMesh_1_1DofMap.php#a97906aa49177873ed7ea9029dcb0cd4b">constrain_element_matrix_and_vector</a>
<a name="l00632"></a>00632           (Fq_context[q_f]-&gt;elem_jacobian, Fq_context[q_f]-&gt;elem_residual, Fq_context[q_f]-&gt;dof_indices);
<a name="l00633"></a>00633       }
<a name="l00634"></a>00634         
<a name="l00635"></a>00635       <span class="comment">// Apply Dirichlet boundary conditions, we assume zero Dirichlet BCs</span>
<a name="l00636"></a>00636       <span class="comment">// Note that this cannot be inside the side-loop since non-boundary</span>
<a name="l00637"></a>00637       <span class="comment">// elements may contain boundary dofs</span>
<a name="l00638"></a>00638       std::set&lt;unsigned int&gt;::const_iterator iter;
<a name="l00639"></a>00639       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;Aq_context[0]-&gt;dof_indices.size(); n++)
<a name="l00640"></a>00640       {
<a name="l00641"></a>00641         iter = <a class="code" href="classlibMesh_1_1RBBase.php#a1882c0df8f854a52376363461d402b76">global_dirichlet_dofs_set</a>.find( Aq_context[0]-&gt;dof_indices[n] );
<a name="l00642"></a>00642         <span class="keywordflow">if</span>(iter != <a class="code" href="classlibMesh_1_1RBBase.php#a1882c0df8f854a52376363461d402b76">global_dirichlet_dofs_set</a>.end())
<a name="l00643"></a>00643         {
<a name="l00644"></a>00644           <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_a=0; q_a&lt;<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>(); q_a++)
<a name="l00645"></a>00645           {
<a name="l00646"></a>00646             Aq_context[q_a]-&gt;elem_jacobian.condense
<a name="l00647"></a>00647               (n,n,0.,Aq_context[q_a]-&gt;elem_residual);
<a name="l00648"></a>00648           }
<a name="l00649"></a>00649 
<a name="l00650"></a>00650           <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_f=0; q_f&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>(); q_f++)
<a name="l00651"></a>00651           {
<a name="l00652"></a>00652             Fq_context[q_f]-&gt;elem_jacobian.condense
<a name="l00653"></a>00653               (n,n,0.,Fq_context[q_f]-&gt;elem_residual);
<a name="l00654"></a>00654           }
<a name="l00655"></a>00655 
<a name="l00656"></a>00656           <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_m=0; q_m&lt;<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>(); q_m++)
<a name="l00657"></a>00657           {
<a name="l00658"></a>00658             Mq_context[q_m]-&gt;elem_jacobian.condense
<a name="l00659"></a>00659               (n,n,0.,Mq_context[q_m]-&gt;elem_residual);
<a name="l00660"></a>00660           }
<a name="l00661"></a>00661         }
<a name="l00662"></a>00662       }
<a name="l00663"></a>00663 
<a name="l00664"></a>00664       <span class="comment">// Finally, add local matrices/vectors to the global system</span>
<a name="l00665"></a>00665       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_a=0; q_a&lt;<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>(); q_a++)
<a name="l00666"></a>00666       {
<a name="l00667"></a>00667         Aq_context[q_a]-&gt;elem_jacobian *= <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a546f47bca2dec636e0fe9c095c3dc3dd">get_euler_theta</a>()*<a class="code" href="classlibMesh_1_1RBBase.php#aeeb46ce2b390bf820f954976ee9da7ce">eval_theta_q_a</a>(q_a);
<a name="l00668"></a>00668         this-&gt;<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#a63c5ad2e110a1873c4fd8945ad7b7e3f">add_matrix</a> (Aq_context[q_a]-&gt;elem_jacobian,
<a name="l00669"></a>00669                                   Aq_context[q_a]-&gt;dof_indices);
<a name="l00670"></a>00670         Aq_context[q_a]-&gt;elem_residual *= -(1.-<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a546f47bca2dec636e0fe9c095c3dc3dd">get_euler_theta</a>())*<a class="code" href="classlibMesh_1_1RBBase.php#aeeb46ce2b390bf820f954976ee9da7ce">eval_theta_q_a</a>(q_a);
<a name="l00671"></a>00671         this-&gt;<a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#adbbff7081d24abefefad1497882b03ab">add_vector</a>    (Aq_context[q_a]-&gt;elem_residual,
<a name="l00672"></a>00672                                   Aq_context[q_a]-&gt;dof_indices);
<a name="l00673"></a>00673       }
<a name="l00674"></a>00674 
<a name="l00675"></a>00675       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_f=0; q_f&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>(); q_f++)
<a name="l00676"></a>00676       {
<a name="l00677"></a>00677         Fq_context[q_f]-&gt;elem_residual *= <a class="code" href="classlibMesh_1_1RBSystem.php#a0fd951279c9b851ac38443156b4b18bd">eval_theta_q_f</a>(q_f);
<a name="l00678"></a>00678         this-&gt;<a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#adbbff7081d24abefefad1497882b03ab">add_vector</a> (Fq_context[q_f]-&gt;elem_residual,
<a name="l00679"></a>00679                                Fq_context[q_f]-&gt;dof_indices);
<a name="l00680"></a>00680       }
<a name="l00681"></a>00681 
<a name="l00682"></a>00682       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_m=0; q_m&lt;<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>(); q_m++)
<a name="l00683"></a>00683       {
<a name="l00684"></a>00684         Mq_context[q_m]-&gt;elem_jacobian *= 1./<a class="code" href="classlibMesh_1_1TransientRBSystem.php#ab5a283a3f305fd03ee1f8e25a5f11bbc">get_dt</a>()*<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a36a6aa3be4fb96b256cb9d664e5a2dfb">eval_theta_q_m</a>(q_m);
<a name="l00685"></a>00685         this-&gt;<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#a63c5ad2e110a1873c4fd8945ad7b7e3f">add_matrix</a> (Mq_context[q_m]-&gt;elem_jacobian,
<a name="l00686"></a>00686                                   Mq_context[q_m]-&gt;dof_indices);
<a name="l00687"></a>00687         Mq_context[q_m]-&gt;elem_residual *= 1./<a class="code" href="classlibMesh_1_1TransientRBSystem.php#ab5a283a3f305fd03ee1f8e25a5f11bbc">get_dt</a>()*<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a36a6aa3be4fb96b256cb9d664e5a2dfb">eval_theta_q_m</a>(q_m);
<a name="l00688"></a>00688         this-&gt;<a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#adbbff7081d24abefefad1497882b03ab">add_vector</a>    (Mq_context[q_m]-&gt;elem_residual,
<a name="l00689"></a>00689                                   Mq_context[q_m]-&gt;dof_indices);
<a name="l00690"></a>00690       }
<a name="l00691"></a>00691     }
<a name="l00692"></a>00692 
<a name="l00693"></a>00693     <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBSystem.php#a28b1348023897cb1517724d6ac30a21d">constrained_problem</a>)
<a name="l00694"></a>00694       <a class="code" href="classlibMesh_1_1RBSystem.php#a4a1243f45ea36fbd2a10ad6956c62deb">add_scaled_matrix_and_vector</a>(1., <a class="code" href="classlibMesh_1_1RBSystem.php#a9c6da671e41886e26c7e88aae82f4358">constraint_assembly</a>, NULL, <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>, NULL);
<a name="l00695"></a>00695 
<a name="l00696"></a>00696     <span class="comment">// Delete all the ptrs to FEMContexts!</span>
<a name="l00697"></a>00697     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_a=0; q_a&lt;Aq_context.size(); q_a++)
<a name="l00698"></a>00698     {
<a name="l00699"></a>00699       <span class="keyword">delete</span> Aq_context[q_a];
<a name="l00700"></a>00700       Aq_context[q_a] = NULL;
<a name="l00701"></a>00701     }
<a name="l00702"></a>00702     Aq_context.clear();
<a name="l00703"></a>00703 
<a name="l00704"></a>00704     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_f=0; q_f&lt;Fq_context.size(); q_f++)
<a name="l00705"></a>00705     {
<a name="l00706"></a>00706       <span class="keyword">delete</span> Fq_context[q_f];
<a name="l00707"></a>00707       Fq_context[q_f] = NULL;
<a name="l00708"></a>00708     }
<a name="l00709"></a>00709     Fq_context.clear();
<a name="l00710"></a>00710 
<a name="l00711"></a>00711     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_m=0; q_m&lt;Mq_context.size(); q_m++)
<a name="l00712"></a>00712     {
<a name="l00713"></a>00713       <span class="keyword">delete</span> Mq_context[q_m];
<a name="l00714"></a>00714       Mq_context[q_m] = NULL;
<a name="l00715"></a>00715     }
<a name="l00716"></a>00716     Mq_context.clear();
<a name="l00717"></a>00717   }
<a name="l00718"></a>00718 
<a name="l00719"></a>00719   this-&gt;<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#a9a0781a7136e2f0f45b15cebef780522">close</a>();
<a name="l00720"></a>00720   this-&gt;<a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a42ea91bba70b3e7b27dad2a636ad31ae">close</a>();
<a name="l00721"></a>00721 
<a name="l00722"></a>00722   STOP_LOG(<span class="stringliteral">&quot;truth_assembly()&quot;</span>, <span class="stringliteral">&quot;TransientRBSystem&quot;</span>);
<a name="l00723"></a>00723 }
<a name="l00724"></a>00724 
<a name="l00725"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#ac6d66066090eb439c3c36b90c59e3655">00725</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ac6d66066090eb439c3c36b90c59e3655">TransientRBSystem::attach_L2_assembly</a>(<a class="code" href="namespacelibMesh.php#a18a170af3a9d5eff6f43eb3409d0e296">affine_assembly_fptr</a> L2_assembly_in)
<a name="l00726"></a>00726 {
<a name="l00727"></a>00727   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a046c9e8b526c6d8b4c8093c6dc35fbfa">L2_assembly</a> = L2_assembly_in;
<a name="l00728"></a>00728 }
<a name="l00729"></a>00729 
<a name="l00730"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#ad450ea11b4475aede2c56d90b0d55a0b">00730</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ad450ea11b4475aede2c56d90b0d55a0b">TransientRBSystem::attach_M_q</a>(<a class="code" href="namespacelibMesh.php#aa62736885c7a9bb67eda65b54ee20107">theta_q_fptr</a> theta_q_m,
<a name="l00731"></a>00731                                    <a class="code" href="namespacelibMesh.php#a18a170af3a9d5eff6f43eb3409d0e296">affine_assembly_fptr</a> M_q_intrr_assembly,
<a name="l00732"></a>00732                                    <a class="code" href="namespacelibMesh.php#a18a170af3a9d5eff6f43eb3409d0e296">affine_assembly_fptr</a> M_q_bndry_assembly)
<a name="l00733"></a>00733 {
<a name="l00734"></a>00734   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae1c7dff67ddddddb8b7f2bb96e78f4ec">theta_q_m_vector</a>.push_back(theta_q_m);
<a name="l00735"></a>00735   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ab0c9e56b352b41ae67ad085358b5606f">M_q_intrr_assembly_vector</a>.push_back(M_q_intrr_assembly);
<a name="l00736"></a>00736   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a35b236bc4b078d83bd0cb58a4aeb274f">M_q_bndry_assembly_vector</a>.push_back(M_q_bndry_assembly);
<a name="l00737"></a>00737 }
<a name="l00738"></a>00738 
<a name="l00739"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a0b6610b9ad630934520fa4581101668e">00739</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a0b6610b9ad630934520fa4581101668e">TransientRBSystem::assemble_Mq_matrix</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q, <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;Number&gt;</a>* input_matrix)
<a name="l00740"></a>00740 {
<a name="l00741"></a>00741   <span class="keywordflow">if</span>(q &gt;= <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>())
<a name="l00742"></a>00742   {
<a name="l00743"></a>00743     <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error: We must have q &lt; Q_m in assemble_Mq_matrix.&quot;</span>
<a name="l00744"></a>00744                  &lt;&lt; std::endl;
<a name="l00745"></a>00745     libmesh_error();
<a name="l00746"></a>00746   }
<a name="l00747"></a>00747 
<a name="l00748"></a>00748   input_matrix-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#a966e0a6479f33c2518937e7d0f54602f">zero</a>();
<a name="l00749"></a>00749   <a class="code" href="classlibMesh_1_1RBSystem.php#a4a1243f45ea36fbd2a10ad6956c62deb">add_scaled_matrix_and_vector</a>(1., <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ab0c9e56b352b41ae67ad085358b5606f">M_q_intrr_assembly_vector</a>[q], <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a35b236bc4b078d83bd0cb58a4aeb274f">M_q_bndry_assembly_vector</a>[q], input_matrix, NULL);
<a name="l00750"></a>00750 }
<a name="l00751"></a>00751 
<a name="l00752"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#af5a3140301d034e23caf1bd68a2e2209">00752</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#af5a3140301d034e23caf1bd68a2e2209">TransientRBSystem::assemble_all_affine_operators</a>()
<a name="l00753"></a>00753 {
<a name="l00754"></a>00754   <a class="code" href="classlibMesh_1_1RBSystem.php#af03382bc15075589cbfa15caf75b8b92">Parent::assemble_all_affine_operators</a>();
<a name="l00755"></a>00755 
<a name="l00756"></a>00756   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q=0; q&lt;<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>(); q++)
<a name="l00757"></a>00757     <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a0b6610b9ad630934520fa4581101668e">assemble_Mq_matrix</a>(q, <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a528a1bc40b5c1b63ee8c51375b1824dc">get_M_q</a>(q));
<a name="l00758"></a>00758 }
<a name="l00759"></a>00759 
<a name="l00760"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a597eb72e0f68b4759224f0c9efcdf6df">00760</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a597eb72e0f68b4759224f0c9efcdf6df">TransientRBSystem::assemble_misc_matrices</a>()
<a name="l00761"></a>00761 {
<a name="l00762"></a>00762   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a0ee3e3816d13aeae07fe5212dda5f521">assemble_L2_matrix</a>(<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a4e15721a62defb903900352ceb0ea367">L2_matrix</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>());
<a name="l00763"></a>00763 
<a name="l00764"></a>00764   <a class="code" href="classlibMesh_1_1RBSystem.php#a2fef453705e8c61cfe86eced45603dad">Parent::assemble_misc_matrices</a>();
<a name="l00765"></a>00765 }
<a name="l00766"></a>00766 
<a name="l00767"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a9be4b235602aceea66681766c0832210">00767</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a9be4b235602aceea66681766c0832210">TransientRBSystem::truth_solve</a>(<span class="keywordtype">int</span> write_interval)
<a name="l00768"></a>00768 {
<a name="l00769"></a>00769   START_LOG(<span class="stringliteral">&quot;truth_solve()&quot;</span>, <span class="stringliteral">&quot;TransientRBSystem&quot;</span>);
<a name="l00770"></a>00770 
<a name="l00771"></a>00771   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a> = <a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">get_mesh</a>();
<a name="l00772"></a>00772 
<a name="l00773"></a>00773 <span class="comment">//   // NumericVector for computing true L2 error</span>
<a name="l00774"></a>00774 <span class="comment">//   AutoPtr&lt; NumericVector&lt;Number&gt; &gt; temp = NumericVector&lt;Number&gt;::build();</span>
<a name="l00775"></a>00775 <span class="comment">//   temp-&gt;init (this-&gt;n_dofs(), this-&gt;n_local_dofs(), false, libMeshEnums::PARALLEL);</span>
<a name="l00776"></a>00776 
<a name="l00777"></a>00777   <span class="comment">// Apply initial condition again.</span>
<a name="l00778"></a>00778   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ab455004dfc57c1a9454534ab1a761dbc">initialize_truth</a>();
<a name="l00779"></a>00779   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a262def83281fa63888e8ed5e3b59d1b8">set_time_level</a>(0);
<a name="l00780"></a>00780 
<a name="l00781"></a>00781   <span class="comment">// Now compute the truth outputs</span>
<a name="l00782"></a>00782   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#a80b9e06a7c60b3bb2f5870b0ff66a2ca">get_n_outputs</a>(); n++)
<a name="l00783"></a>00783   {
<a name="l00784"></a>00784     <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a58dda0affa01e49069a725153dcf5cc6">truth_outputs_all_k</a>[n][<a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae8bf672ee83dac4058eb4deb5b660750">_k</a>] = 0.;
<a name="l00785"></a>00785     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_l=0; q_l&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#ab7f0b2268a9716189225e0446b519911">get_Q_l</a>(n); q_l++)
<a name="l00786"></a>00786     {
<a name="l00787"></a>00787       <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a58dda0affa01e49069a725153dcf5cc6">truth_outputs_all_k</a>[n][<a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae8bf672ee83dac4058eb4deb5b660750">_k</a>] += <a class="code" href="classlibMesh_1_1RBSystem.php#a3ab4b896903320a2b313f73efc2aaad1">eval_theta_q_l</a>(n,q_l)*<a class="code" href="classlibMesh_1_1RBSystem.php#a956b276ef7de8606c78698fcfa338343">get_output_vector</a>(n,q_l)-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a1f522c421b32b75ea4dc3de6d1a95000">dot</a>(*<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>);
<a name="l00788"></a>00788     }
<a name="l00789"></a>00789   }
<a name="l00790"></a>00790 
<a name="l00791"></a>00791   <span class="comment">// Load initial projection error into temporal_data dense matrix</span>
<a name="l00792"></a>00792   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a1d1eb4f1214b4e26a86137ed7ba38a13">set_error_temporal_data</a>();
<a name="l00793"></a>00793 
<a name="l00794"></a>00794   <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBSystem.php#a61f47d68b0df487674a9001d13d77c88">reuse_preconditioner</a>)
<a name="l00795"></a>00795   {
<a name="l00796"></a>00796     <span class="comment">// For the first solve, make sure we generate a new preconditioner</span>
<a name="l00797"></a>00797     <a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a7cc68891fa9f44ded49b9b84c057cb32">linear_solver</a>-&gt;same_preconditioner = <span class="keyword">false</span>;
<a name="l00798"></a>00798   }
<a name="l00799"></a>00799 
<a name="l00800"></a>00800   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> time_level=1; time_level&lt;=<a class="code" href="classlibMesh_1_1TransientRBSystem.php#aac8858a7e9af6497f3c37a4b7956ca6a">_K</a>; time_level++)
<a name="l00801"></a>00801   {
<a name="l00802"></a>00802     <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a262def83281fa63888e8ed5e3b59d1b8">set_time_level</a>(time_level); <span class="comment">// update the member variable _k</span>
<a name="l00803"></a>00803 
<a name="l00804"></a>00804     *<a class="code" href="classlibMesh_1_1TransientSystem.php#a61cfd7f2e0a4c5133beae4a0e8c69141">old_local_solution</a> = *<a class="code" href="classlibMesh_1_1System.php#a1e1bec53fb8d8a5a2163dbee844e8417">current_local_solution</a>;
<a name="l00805"></a>00805 
<a name="l00806"></a>00806     <span class="comment">// We assume that the truth assembly has been attached to the system</span>
<a name="l00807"></a>00807     <a class="code" href="classlibMesh_1_1TransientRBSystem.php#aaa040e14836cebced3a91a0fc7a63400">truth_assembly</a>();
<a name="l00808"></a>00808     <a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#af1de21a76860785bb1992280eb72b0db">solve</a>();
<a name="l00809"></a>00809 
<a name="l00810"></a>00810     <span class="comment">// Make sure we didn&#39;t max out the number of iterations</span>
<a name="l00811"></a>00811     <span class="keywordflow">if</span>( (this-&gt;<a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#af712dbf0e285c5ff4cc346daef05423c">n_linear_iterations</a>() &gt;=
<a name="l00812"></a>00812         this-&gt;<a class="code" href="classlibMesh_1_1System.php#ac5ca6b1f3adcfac56982982e90dc905b">get_equation_systems</a>().parameters.get&lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&gt;(<span class="stringliteral">&quot;linear solver maximum iterations&quot;</span>)) &amp;&amp;
<a name="l00813"></a>00813         (this-&gt;final_linear_residual() &gt;
<a name="l00814"></a>00814         this-&gt;<a class="code" href="classlibMesh_1_1System.php#ac5ca6b1f3adcfac56982982e90dc905b">get_equation_systems</a>().<a class="code" href="classlibMesh_1_1EquationSystems.php#a7c02be232f564967ca0804a7824adb53">parameters</a>.<a class="code" href="classlibMesh_1_1Parameters.php#ac7fa2054ee32db2c3979d48bd2103f20">get</a>&lt;<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>&gt;(<span class="stringliteral">&quot;linear solver tolerance&quot;</span>)) )
<a name="l00815"></a>00815     {
<a name="l00816"></a>00816       <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Warning: Linear solver may not have converged! Final linear residual = &quot;</span>
<a name="l00817"></a>00817                    &lt;&lt; this-&gt;<a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a86b5e2954d2a2e43014bcda8810239ac">final_linear_residual</a>() &lt;&lt; <span class="stringliteral">&quot;, number of iterations = &quot;</span>
<a name="l00818"></a>00818                    &lt;&lt; this-&gt;<a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#af712dbf0e285c5ff4cc346daef05423c">n_linear_iterations</a>() &lt;&lt; std::endl &lt;&lt; std::endl;
<a name="l00819"></a>00819 <span class="comment">//       libmesh_error();</span>
<a name="l00820"></a>00820     }
<a name="l00821"></a>00821 
<a name="l00822"></a>00822     <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBSystem.php#a61f47d68b0df487674a9001d13d77c88">reuse_preconditioner</a>)
<a name="l00823"></a>00823       {
<a name="l00824"></a>00824         <a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a7cc68891fa9f44ded49b9b84c057cb32">linear_solver</a>-&gt;same_preconditioner = <span class="keyword">true</span>;
<a name="l00825"></a>00825       }
<a name="l00826"></a>00826 
<a name="l00827"></a>00827     <span class="comment">// Now compute the truth outputs</span>
<a name="l00828"></a>00828     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#a80b9e06a7c60b3bb2f5870b0ff66a2ca">get_n_outputs</a>(); n++)
<a name="l00829"></a>00829     {
<a name="l00830"></a>00830       <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a58dda0affa01e49069a725153dcf5cc6">truth_outputs_all_k</a>[n][<a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae8bf672ee83dac4058eb4deb5b660750">_k</a>] = 0.;
<a name="l00831"></a>00831       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_l=0; q_l&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#ab7f0b2268a9716189225e0446b519911">get_Q_l</a>(n); q_l++)
<a name="l00832"></a>00832       {
<a name="l00833"></a>00833         <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a58dda0affa01e49069a725153dcf5cc6">truth_outputs_all_k</a>[n][<a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae8bf672ee83dac4058eb4deb5b660750">_k</a>] += <a class="code" href="classlibMesh_1_1RBSystem.php#a3ab4b896903320a2b313f73efc2aaad1">eval_theta_q_l</a>(n,q_l)*<a class="code" href="classlibMesh_1_1RBSystem.php#a956b276ef7de8606c78698fcfa338343">get_output_vector</a>(n,q_l)-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a1f522c421b32b75ea4dc3de6d1a95000">dot</a>(*<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>);
<a name="l00834"></a>00834       }
<a name="l00835"></a>00835     }
<a name="l00836"></a>00836 
<a name="l00837"></a>00837     <span class="comment">// load projection error into column _k of temporal_data matrix</span>
<a name="l00838"></a>00838     <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a1d1eb4f1214b4e26a86137ed7ba38a13">set_error_temporal_data</a>();
<a name="l00839"></a>00839 
<a name="l00840"></a>00840     <span class="keywordflow">if</span> ( (write_interval &gt; 0) &amp;&amp; (<a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae8bf672ee83dac4058eb4deb5b660750">_k</a>%write_interval == 0) )
<a name="l00841"></a>00841       {
<a name="l00842"></a>00842         <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; std::endl &lt;&lt; <span class="stringliteral">&quot;Truth solve, plotting time step &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae8bf672ee83dac4058eb4deb5b660750">_k</a> &lt;&lt; std::endl;
<a name="l00843"></a>00843 
<a name="l00844"></a>00844         <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l00845"></a>00845 
<a name="l00846"></a>00846         <span class="comment">// We write the file name in the gmv auto-read format.</span>
<a name="l00847"></a>00847         file_name &lt;&lt; <span class="stringliteral">&quot;truth.gmv.&quot;</span>;
<a name="l00848"></a>00848         OSSRealzeroright(file_name,3,0, <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae8bf672ee83dac4058eb4deb5b660750">_k</a>);
<a name="l00849"></a>00849 
<a name="l00850"></a>00850         <a class="code" href="classlibMesh_1_1GMVIO.php">GMVIO</a>(mesh).<a class="code" href="classlibMesh_1_1MeshOutput.php#a935598198649f4b831cd341ce91b3ccb">write_equation_systems</a> (file_name.str(),
<a name="l00851"></a>00851                                             this-&gt;<a class="code" href="classlibMesh_1_1System.php#ac5ca6b1f3adcfac56982982e90dc905b">get_equation_systems</a>());
<a name="l00852"></a>00852       }
<a name="l00853"></a>00853   }
<a name="l00854"></a>00854 
<a name="l00855"></a>00855   <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBSystem.php#a61f47d68b0df487674a9001d13d77c88">reuse_preconditioner</a>)
<a name="l00856"></a>00856     {
<a name="l00857"></a>00857       <a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a7cc68891fa9f44ded49b9b84c057cb32">linear_solver</a>-&gt;same_preconditioner = <span class="keyword">false</span>;
<a name="l00858"></a>00858     }
<a name="l00859"></a>00859 
<a name="l00860"></a>00860   <span class="comment">// Get the L2 norm of the truth solution at time-level _K</span>
<a name="l00861"></a>00861   <span class="comment">// Useful for normalizing our true error data</span>
<a name="l00862"></a>00862   <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a>)
<a name="l00863"></a>00863   {
<a name="l00864"></a>00864     <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a4e15721a62defb903900352ceb0ea367">L2_matrix</a>-&gt;vector_mult(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>, *<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>);
<a name="l00865"></a>00865   }
<a name="l00866"></a>00866   <span class="keywordflow">else</span>
<a name="l00867"></a>00867   {
<a name="l00868"></a>00868     <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a0ee3e3816d13aeae07fe5212dda5f521">assemble_L2_matrix</a>(<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>);
<a name="l00869"></a>00869     <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#adaccc5857f1a5d5ca264ded0b8bfb986">vector_mult</a>(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>, *<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>);
<a name="l00870"></a>00870   }
<a name="l00871"></a>00871 
<a name="l00872"></a>00872   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> final_truth_L2_norm = <a class="code" href="namespacelibMesh.php#aea33cac176f18504c5c4078407aadbb7">libmesh_real</a>(std::sqrt(<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>-&gt;dot(*<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>)));
<a name="l00873"></a>00873 
<a name="l00874"></a>00874 
<a name="l00875"></a>00875   STOP_LOG(<span class="stringliteral">&quot;truth_solve()&quot;</span>, <span class="stringliteral">&quot;TransientRBSystem&quot;</span>);
<a name="l00876"></a>00876 
<a name="l00877"></a>00877   <span class="keywordflow">return</span> final_truth_L2_norm;
<a name="l00878"></a>00878 }
<a name="l00879"></a>00879 
<a name="l00880"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a70c663d69b94e1389703b8442f8f46e0">00880</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a70c663d69b94e1389703b8442f8f46e0">TransientRBSystem::greedy_termination_test</a>(<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> training_greedy_error, <span class="keywordtype">int</span> count)
<a name="l00881"></a>00881 {
<a name="l00882"></a>00882   <span class="keywordflow">if</span> ( (<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a68d017bd7128cbce35e29b64924827a4">get_max_truth_solves</a>()&gt;0) &amp;&amp; (count &gt;= <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a68d017bd7128cbce35e29b64924827a4">get_max_truth_solves</a>()) )
<a name="l00883"></a>00883     {
<a name="l00884"></a>00884       <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Maximum number of truth solves reached: max = &quot;</span>
<a name="l00885"></a>00885                    &lt;&lt; count &lt;&lt; std::endl;
<a name="l00886"></a>00886       <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00887"></a>00887     }
<a name="l00888"></a>00888 
<a name="l00889"></a>00889   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a79eb03faea6389086e2ccbb032569243">Parent::greedy_termination_test</a>(training_greedy_error, count);
<a name="l00890"></a>00890 }
<a name="l00891"></a>00891 
<a name="l00892"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a1d1eb4f1214b4e26a86137ed7ba38a13">00892</a> <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a1d1eb4f1214b4e26a86137ed7ba38a13">TransientRBSystem::set_error_temporal_data</a>()
<a name="l00893"></a>00893 {
<a name="l00894"></a>00894   START_LOG(<span class="stringliteral">&quot;set_error_temporal_data()&quot;</span>, <span class="stringliteral">&quot;TransientRBSystem&quot;</span>);
<a name="l00895"></a>00895 
<a name="l00896"></a>00896   <span class="comment">// first compute the projection of solution onto the current</span>
<a name="l00897"></a>00897   <span class="comment">// RB space</span>
<a name="l00898"></a>00898 
<a name="l00899"></a>00899   <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBSystem.php#abfe6d67ed23243d225f12747f355f105">basis_functions</a>.size() == 0)
<a name="l00900"></a>00900   {
<a name="l00901"></a>00901     <span class="comment">// If the basis is empty, then the error is the solution itself</span>
<a name="l00902"></a>00902     <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a5f9a29b24cc7de2f92e0e1b8f5acbe71">temporal_data</a>[<a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae8bf672ee83dac4058eb4deb5b660750">_k</a>]-&gt;zero();
<a name="l00903"></a>00903     <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a5f9a29b24cc7de2f92e0e1b8f5acbe71">temporal_data</a>[<a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae8bf672ee83dac4058eb4deb5b660750">_k</a>]-&gt;add(1., *<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>);
<a name="l00904"></a>00904   }
<a name="l00905"></a>00905   <span class="keywordflow">else</span>
<a name="l00906"></a>00906   {
<a name="l00907"></a>00907     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> RB_size = <a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>();
<a name="l00908"></a>00908 
<a name="l00909"></a>00909     <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt; NumericVector&lt;Number&gt;</a> &gt; temp = <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;::build</a>();
<a name="l00910"></a>00910     temp-&gt;init (this-&gt;<a class="code" href="classlibMesh_1_1System.php#a90dbb901f00c14ff18399f4afabcebe5">n_dofs</a>(), this-&gt;<a class="code" href="classlibMesh_1_1System.php#ae3aeb82e65b06789823d41da3c5df7a2">n_local_dofs</a>(), <span class="keyword">false</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">libMeshEnums::PARALLEL</a>);
<a name="l00911"></a>00911 
<a name="l00912"></a>00912     <span class="comment">// First compute the right-hand side vector for the projection</span>
<a name="l00913"></a>00913     <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a>)
<a name="l00914"></a>00914     {
<a name="l00915"></a>00915       <a class="code" href="classlibMesh_1_1RBSystem.php#a330478ef4e1a158dc7b6f08530e10ff3">inner_product_matrix</a>-&gt;vector_mult(*temp, *<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>);
<a name="l00916"></a>00916     }
<a name="l00917"></a>00917     <span class="keywordflow">else</span>
<a name="l00918"></a>00918     {
<a name="l00919"></a>00919       <a class="code" href="classlibMesh_1_1RBSystem.php#a2bde84b5899642d6bb6ba2f6ac4a51f9">assemble_inner_product_matrix</a>(<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>);
<a name="l00920"></a>00920       <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#adaccc5857f1a5d5ca264ded0b8bfb986">vector_mult</a>(*temp, *<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>);
<a name="l00921"></a>00921     }
<a name="l00922"></a>00922 
<a name="l00923"></a>00923     <a class="code" href="classlibMesh_1_1RBSystem.php#a002530dbacbc566d7c86bad54ee1138d">zero_dirichlet_dofs_on_vector</a>(*temp);
<a name="l00924"></a>00924 
<a name="l00925"></a>00925     <span class="comment">// Do not assume that RB_stiffness matrix is diagonal,</span>
<a name="l00926"></a>00926     <span class="comment">// diagonality degrades as N increases</span>
<a name="l00927"></a>00927 
<a name="l00928"></a>00928     <span class="comment">// Get an appropriately sized copy of RB_inner_product_matrix</span>
<a name="l00929"></a>00929     <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Number&gt;</a> RB_inner_product_matrix_N(RB_size,RB_size);
<a name="l00930"></a>00930     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;RB_size; i++)
<a name="l00931"></a>00931       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;RB_size; j++)
<a name="l00932"></a>00932       {
<a name="l00933"></a>00933         RB_inner_product_matrix_N(i,j) = <a class="code" href="classlibMesh_1_1RBSystem.php#a5aeb48dc4ed2a429e89bdeffdd1f1564">RB_inner_product_matrix</a>(i,j);
<a name="l00934"></a>00934       }
<a name="l00935"></a>00935 
<a name="l00936"></a>00936     <span class="comment">// Compute the projection RHS</span>
<a name="l00937"></a>00937     <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> RB_proj_rhs(RB_size);
<a name="l00938"></a>00938     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;RB_size; i++)
<a name="l00939"></a>00939     {
<a name="l00940"></a>00940       RB_proj_rhs(i) = temp-&gt;dot(<a class="code" href="classlibMesh_1_1RBSystem.php#a9ded22447be4ab3c0724bd060bfd9899">get_bf</a>(i));
<a name="l00941"></a>00941     }
<a name="l00942"></a>00942 
<a name="l00943"></a>00943     <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> RB_proj(RB_size);
<a name="l00944"></a>00944 
<a name="l00945"></a>00945     <span class="comment">// Now solve the linear system</span>
<a name="l00946"></a>00946     RB_inner_product_matrix_N.<a class="code" href="classlibMesh_1_1DenseMatrix.php#a878b9bf0a49000c70acecd55fdcf8d74">lu_solve</a>(RB_proj_rhs, RB_proj);
<a name="l00947"></a>00947 
<a name="l00948"></a>00948     <span class="comment">// Load the RB projection into temp</span>
<a name="l00949"></a>00949     temp-&gt;zero();
<a name="l00950"></a>00950     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;RB_size; i++)
<a name="l00951"></a>00951     {
<a name="l00952"></a>00952       temp-&gt;add(RB_proj(i), <a class="code" href="classlibMesh_1_1RBSystem.php#a9ded22447be4ab3c0724bd060bfd9899">get_bf</a>(i));
<a name="l00953"></a>00953     }
<a name="l00954"></a>00954 
<a name="l00955"></a>00955     temp-&gt;add(-1., *<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>);
<a name="l00956"></a>00956 
<a name="l00957"></a>00957     <span class="comment">// Now temp holds the projection error, store in temporal_data</span>
<a name="l00958"></a>00958     *(<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a5f9a29b24cc7de2f92e0e1b8f5acbe71">temporal_data</a>[<a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae8bf672ee83dac4058eb4deb5b660750">_k</a>]) = *temp;
<a name="l00959"></a>00959   }
<a name="l00960"></a>00960 
<a name="l00961"></a>00961   STOP_LOG(<span class="stringliteral">&quot;set_error_temporal_data()&quot;</span>, <span class="stringliteral">&quot;TransientRBSystem&quot;</span>);
<a name="l00962"></a>00962 
<a name="l00963"></a>00963   <span class="comment">// return the square of the X norm of the truth solution</span>
<a name="l00964"></a>00964   <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a>)
<a name="l00965"></a>00965   {
<a name="l00966"></a>00966     <a class="code" href="classlibMesh_1_1RBSystem.php#a330478ef4e1a158dc7b6f08530e10ff3">inner_product_matrix</a>-&gt;vector_mult(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>,*<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>);
<a name="l00967"></a>00967   }
<a name="l00968"></a>00968   <span class="keywordflow">else</span>
<a name="l00969"></a>00969   {
<a name="l00970"></a>00970     <a class="code" href="classlibMesh_1_1RBSystem.php#a2bde84b5899642d6bb6ba2f6ac4a51f9">assemble_inner_product_matrix</a>(<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>);
<a name="l00971"></a>00971     <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#adaccc5857f1a5d5ca264ded0b8bfb986">vector_mult</a>(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>,*<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>);
<a name="l00972"></a>00972   }
<a name="l00973"></a>00973 
<a name="l00974"></a>00974   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;dot(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>);
<a name="l00975"></a>00975 }
<a name="l00976"></a>00976 
<a name="l00977"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#ab455004dfc57c1a9454534ab1a761dbc">00977</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ab455004dfc57c1a9454534ab1a761dbc">TransientRBSystem::initialize_truth</a> ()
<a name="l00978"></a>00978 {
<a name="l00979"></a>00979   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1TransientRBSystem.php#af0fbee2db2698376fe3a932c5a7bcc26">nonzero_initialization</a>)
<a name="l00980"></a>00980   {
<a name="l00981"></a>00981     <span class="comment">// Use System::read_serialized_data to read the initial condition</span>
<a name="l00982"></a>00982     <span class="comment">// into this-&gt;solution</span>
<a name="l00983"></a>00983     <a class="code" href="classlibMesh_1_1Xdr.php">Xdr</a> IC_data(<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a7cfe02ecfa70244829bb835fc9f2eab6">init_filename</a>, <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8acd5c7906bd7fea7650acc4c8cde09d48">READ</a>);
<a name="l00984"></a>00984     <a class="code" href="classlibMesh_1_1System.php#a3eb0dd9d3ef0453daf9b5eeff0819736">read_serialized_data</a>(IC_data, <span class="keyword">false</span>);
<a name="l00985"></a>00985   }
<a name="l00986"></a>00986   <span class="keywordflow">else</span>
<a name="l00987"></a>00987   {
<a name="l00988"></a>00988     <span class="comment">// Otherwise zero out the solution as a default</span>
<a name="l00989"></a>00989     this-&gt;<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;zero();
<a name="l00990"></a>00990   }
<a name="l00991"></a>00991   this-&gt;<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;close();
<a name="l00992"></a>00992   this-&gt;<a class="code" href="classlibMesh_1_1System.php#ab9d81ac9c1787c43fb87cf13d37741ee">update</a>();
<a name="l00993"></a>00993 }
<a name="l00994"></a>00994 
<a name="l00995"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#abc7508cfa934d11004a3c61914fb496a">00995</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#abc7508cfa934d11004a3c61914fb496a">TransientRBSystem::add_IC_to_RB_space</a>()
<a name="l00996"></a>00996 {
<a name="l00997"></a>00997   START_LOG(<span class="stringliteral">&quot;add_IC_to_RB_space()&quot;</span>, <span class="stringliteral">&quot;TransientRBSystem&quot;</span>);
<a name="l00998"></a>00998 
<a name="l00999"></a>00999   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>() &gt; 0)
<a name="l01000"></a>01000   {
<a name="l01001"></a>01001     <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Error: Should not call TransientRBSystem::add_IC_to_RB_space() &quot;</span>
<a name="l01002"></a>01002                  &lt;&lt; <span class="stringliteral">&quot;on a system that already contains basis functions.&quot;</span> &lt;&lt; std::endl;
<a name="l01003"></a>01003     libmesh_error();
<a name="l01004"></a>01004   }
<a name="l01005"></a>01005   <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1TransientRBSystem.php#af0fbee2db2698376fe3a932c5a7bcc26">nonzero_initialization</a>)
<a name="l01006"></a>01006   {
<a name="l01007"></a>01007     <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Error: Should not call TransientRBSystem::add_IC_to_RB_space() &quot;</span>
<a name="l01008"></a>01008                  &lt;&lt; <span class="stringliteral">&quot;when nonzero_initialization==false.&quot;</span> &lt;&lt; std::endl;
<a name="l01009"></a>01009     libmesh_error();
<a name="l01010"></a>01010   }
<a name="l01011"></a>01011 
<a name="l01012"></a>01012   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ab455004dfc57c1a9454534ab1a761dbc">initialize_truth</a>();
<a name="l01013"></a>01013 
<a name="l01014"></a>01014   <span class="comment">// load the new basis function into the basis_functions vector.</span>
<a name="l01015"></a>01015   <a class="code" href="classlibMesh_1_1RBSystem.php#abfe6d67ed23243d225f12747f355f105">basis_functions</a>.push_back( <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;::build</a>().release() );
<a name="l01016"></a>01016   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>&amp; current_bf = *(<a class="code" href="classlibMesh_1_1RBSystem.php#abfe6d67ed23243d225f12747f355f105">basis_functions</a>[<a class="code" href="classlibMesh_1_1RBSystem.php#abfe6d67ed23243d225f12747f355f105">basis_functions</a>.size()-1]);
<a name="l01017"></a>01017   current_bf.<a class="code" href="classlibMesh_1_1NumericVector.php#aba2b1e60a94162764c07732626a8231b">init</a> (this-&gt;<a class="code" href="classlibMesh_1_1System.php#a90dbb901f00c14ff18399f4afabcebe5">n_dofs</a>(), this-&gt;<a class="code" href="classlibMesh_1_1System.php#ae3aeb82e65b06789823d41da3c5df7a2">n_local_dofs</a>(), <span class="keyword">false</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">libMeshEnums::PARALLEL</a>);
<a name="l01018"></a>01018   current_bf = *<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>;
<a name="l01019"></a>01019 
<a name="l01020"></a>01020   <span class="comment">// We can just set the norm to 1.</span>
<a name="l01021"></a>01021   <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a>)
<a name="l01022"></a>01022   {
<a name="l01023"></a>01023     <a class="code" href="classlibMesh_1_1RBSystem.php#a330478ef4e1a158dc7b6f08530e10ff3">inner_product_matrix</a>-&gt;vector_mult(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>,*<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>);
<a name="l01024"></a>01024   }
<a name="l01025"></a>01025   <span class="keywordflow">else</span>
<a name="l01026"></a>01026   {
<a name="l01027"></a>01027     <a class="code" href="classlibMesh_1_1RBSystem.php#a2bde84b5899642d6bb6ba2f6ac4a51f9">assemble_inner_product_matrix</a>(<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>);
<a name="l01028"></a>01028     <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#adaccc5857f1a5d5ca264ded0b8bfb986">vector_mult</a>(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>,*<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>);
<a name="l01029"></a>01029   }
<a name="l01030"></a>01030   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> current_bf_norm = <a class="code" href="namespacelibMesh.php#aea33cac176f18504c5c4078407aadbb7">libmesh_real</a>(std::sqrt( current_bf.<a class="code" href="classlibMesh_1_1NumericVector.php#a1f522c421b32b75ea4dc3de6d1a95000">dot</a>(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>) ));
<a name="l01031"></a>01031   current_bf.<a class="code" href="classlibMesh_1_1NumericVector.php#a7efb30d08bd1bb55a91f66782238d648">scale</a>(1./current_bf_norm);
<a name="l01032"></a>01032 
<a name="l01033"></a>01033   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> saved_delta_N = <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a6eb3788340334cf4bcf9d8fa788c31f8">get_delta_N</a>();
<a name="l01034"></a>01034   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a6a0ae338e9bb14d354ee6385cb5df85f">set_delta_N</a>(1);
<a name="l01035"></a>01035   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae84573a528aea2088e92485998d83969">update_system</a>();
<a name="l01036"></a>01036   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a6a0ae338e9bb14d354ee6385cb5df85f">set_delta_N</a>(saved_delta_N);
<a name="l01037"></a>01037 
<a name="l01038"></a>01038   STOP_LOG(<span class="stringliteral">&quot;add_IC_to_RB_space()&quot;</span>, <span class="stringliteral">&quot;TransientRBSystem&quot;</span>);
<a name="l01039"></a>01039 }
<a name="l01040"></a>01040 
<a name="l01041"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a4787525ef1c9e18634fef8c8dc85ad6a">01041</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a4787525ef1c9e18634fef8c8dc85ad6a">TransientRBSystem::enrich_RB_space</a>()
<a name="l01042"></a>01042 {
<a name="l01043"></a>01043 <span class="comment">// Need SLEPc to get the POD eigenvalues</span>
<a name="l01044"></a>01044 <span class="preprocessor">#if defined(LIBMESH_HAVE_SLEPC)</span>
<a name="l01045"></a>01045 <span class="preprocessor"></span>  START_LOG(<span class="stringliteral">&quot;enrich_RB_space()&quot;</span>, <span class="stringliteral">&quot;TransientRBSystem&quot;</span>);
<a name="l01046"></a>01046 
<a name="l01047"></a>01047   <span class="comment">// With the &quot;method of snapshots&quot;, the size of</span>
<a name="l01048"></a>01048   <span class="comment">// the eigenproblem is determined by the number</span>
<a name="l01049"></a>01049   <span class="comment">// of time-steps (rather than the number of spatial dofs).</span>
<a name="l01050"></a>01050   <span class="keywordtype">int</span> eigen_size = <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a5f9a29b24cc7de2f92e0e1b8f5acbe71">temporal_data</a>.size();
<a name="l01051"></a>01051   <span class="keywordtype">int</span> LDA = eigen_size; <span class="comment">// The leading order of correlation_matrix</span>
<a name="l01052"></a>01052   std::vector&lt;Number&gt; correlation_matrix(LDA*eigen_size);
<a name="l01053"></a>01053 
<a name="l01054"></a>01054   <span class="comment">// set values of the correlation matrix</span>
<a name="l01055"></a>01055   <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a>)
<a name="l01056"></a>01056     <a class="code" href="classlibMesh_1_1RBSystem.php#a2bde84b5899642d6bb6ba2f6ac4a51f9">assemble_inner_product_matrix</a>(<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>);
<a name="l01057"></a>01057 
<a name="l01058"></a>01058   <span class="keywordflow">for</span>(<span class="keywordtype">int</span> i=0; i&lt;eigen_size; i++)
<a name="l01059"></a>01059   {
<a name="l01060"></a>01060     <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a>)
<a name="l01061"></a>01061     {
<a name="l01062"></a>01062       <a class="code" href="classlibMesh_1_1RBSystem.php#a330478ef4e1a158dc7b6f08530e10ff3">inner_product_matrix</a>-&gt;vector_mult(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>, *<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a5f9a29b24cc7de2f92e0e1b8f5acbe71">temporal_data</a>[i]);
<a name="l01063"></a>01063     }
<a name="l01064"></a>01064     <span class="keywordflow">else</span>
<a name="l01065"></a>01065     {
<a name="l01066"></a>01066       <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#adaccc5857f1a5d5ca264ded0b8bfb986">vector_mult</a>(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>, *<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a5f9a29b24cc7de2f92e0e1b8f5acbe71">temporal_data</a>[i]);
<a name="l01067"></a>01067     }
<a name="l01068"></a>01068 
<a name="l01069"></a>01069     <span class="keywordflow">for</span>(<span class="keywordtype">int</span> j=i; j&lt;eigen_size; j++)
<a name="l01070"></a>01070     {
<a name="l01071"></a>01071        <span class="comment">// Scale the inner products by the number of time-steps to normalize the</span>
<a name="l01072"></a>01072        <span class="comment">// POD energy norm appropriately</span>
<a name="l01073"></a>01073       <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> inner_prod = (<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a5f9a29b24cc7de2f92e0e1b8f5acbe71">temporal_data</a>[j]-&gt;dot(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>)) / (<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>)(<a class="code" href="classlibMesh_1_1TransientRBSystem.php#aac8858a7e9af6497f3c37a4b7956ca6a">_K</a>+1);
<a name="l01074"></a>01074 
<a name="l01075"></a>01075       <span class="comment">// Fill upper triangular part of correlation_matrix</span>
<a name="l01076"></a>01076       correlation_matrix[j*eigen_size+i] = inner_prod;
<a name="l01077"></a>01077     }
<a name="l01078"></a>01078   }
<a name="l01079"></a>01079 
<a name="l01080"></a>01080   <span class="comment">// Call the LAPACK eigensolver</span>
<a name="l01081"></a>01081   <span class="keywordtype">char</span> JOBZ = <span class="charliteral">&#39;V&#39;</span>; <span class="comment">// Compute eigenvectors and eigenvalues</span>
<a name="l01082"></a>01082   <span class="keywordtype">char</span> RANGE = <span class="charliteral">&#39;A&#39;</span>; <span class="comment">// Compute all eigenvalues</span>
<a name="l01083"></a>01083   <span class="keywordtype">char</span> UPLO = <span class="charliteral">&#39;U&#39;</span>; <span class="comment">// Upper triangular symmetric matrix</span>
<a name="l01084"></a>01084   
<a name="l01085"></a>01085   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> VL = 0.; <span class="comment">// Not used when RANGE = A</span>
<a name="l01086"></a>01086   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> VU = 0.; <span class="comment">// Not used when RANGE = A</span>
<a name="l01087"></a>01087   
<a name="l01088"></a>01088   <span class="keywordtype">int</span> IL = 0; <span class="comment">// Not used when RANGE = A</span>
<a name="l01089"></a>01089   <span class="keywordtype">int</span> IU = 0; <span class="comment">// Not used when RANGE = A</span>
<a name="l01090"></a>01090   
<a name="l01091"></a>01091   <span class="keywordtype">double</span> ABSTOL = 1.e-14; <span class="comment">// Absolute tolerance for eigensolver</span>
<a name="l01092"></a>01092   
<a name="l01093"></a>01093   <span class="keywordtype">int</span> M = 0; <span class="comment">// (output) The total number of evals found</span>
<a name="l01094"></a>01094   
<a name="l01095"></a>01095   std::vector&lt;Real&gt; W(eigen_size); <span class="comment">// (output) the eigenvalues</span>
<a name="l01096"></a>01096 
<a name="l01097"></a>01097   <span class="keywordtype">int</span> LDZ = eigen_size; <span class="comment">// The leading order of Z</span>
<a name="l01098"></a>01098   std::vector&lt;Number&gt; Z(LDZ*eigen_size); <span class="comment">// (output) the eigenvectors</span>
<a name="l01099"></a>01099 
<a name="l01100"></a>01100   std::vector&lt;int&gt; ISUPPZ(2*eigen_size); <span class="comment">// Indicates which evecs in Z are nonzero</span>
<a name="l01101"></a>01101   
<a name="l01102"></a>01102   <span class="comment">// Work array, sized according to lapack documentation</span>
<a name="l01103"></a>01103   <span class="keywordtype">int</span> LWORK = 26*eigen_size;
<a name="l01104"></a>01104   std::vector&lt;Number&gt; WORK(LWORK);
<a name="l01105"></a>01105   
<a name="l01106"></a>01106   <span class="comment">// Work array, sized according to lapack documentation</span>
<a name="l01107"></a>01107   <span class="keywordtype">int</span> LIWORK = 10*eigen_size;
<a name="l01108"></a>01108   std::vector&lt;int&gt; IWORK(LIWORK);
<a name="l01109"></a>01109   
<a name="l01110"></a>01110   <span class="keywordtype">int</span> INFO = 0;
<a name="l01111"></a>01111   
<a name="l01112"></a>01112 <span class="preprocessor">#ifdef LIBMESH_USE_REAL_NUMBERS // Use real numbers</span>
<a name="l01113"></a>01113 <span class="preprocessor"></span>  <span class="comment">// Call the eigensolver for symmetric eigenvalue problems.</span>
<a name="l01114"></a>01114   <span class="comment">// NOTE: evals in W are in ascending order</span>
<a name="l01115"></a>01115   LAPACKsyevr_(&amp;JOBZ, &amp;RANGE, &amp;UPLO, &amp;eigen_size, &amp;correlation_matrix[0],
<a name="l01116"></a>01116                &amp;LDA, &amp;VL, &amp;VU, &amp;IL, &amp;IU, &amp;ABSTOL, &amp;M, &amp;W[0], &amp;Z[0], &amp;LDZ,
<a name="l01117"></a>01117                &amp;ISUPPZ[0], &amp;WORK[0], &amp;LWORK, &amp;IWORK[0], &amp;LIWORK, &amp;INFO );
<a name="l01118"></a>01118 <span class="preprocessor">#endif</span>
<a name="l01119"></a>01119 <span class="preprocessor"></span>
<a name="l01120"></a>01120 <span class="preprocessor">#ifdef LIBMESH_USE_COMPLEX_NUMBERS // Use complex numbers</span>
<a name="l01121"></a>01121 <span class="preprocessor"></span>  <span class="comment">// Need some extra data in the complex case</span>
<a name="l01122"></a>01122   
<a name="l01123"></a>01123   <span class="comment">// Work array, sized according to lapack documentation</span>
<a name="l01124"></a>01124   <span class="keywordtype">int</span> LRWORK = 24*eigen_size;
<a name="l01125"></a>01125   std::vector&lt;Real&gt; RWORK(LRWORK);
<a name="l01126"></a>01126 
<a name="l01127"></a>01127   <span class="comment">// Call the eigensolver for symmetric eigenvalue problems.</span>
<a name="l01128"></a>01128   <span class="comment">// NOTE: evals in W are in ascending order</span>
<a name="l01129"></a>01129   LAPACKsyevr_(&amp;JOBZ, &amp;RANGE, &amp;UPLO, &amp;eigen_size, &amp;correlation_matrix[0],
<a name="l01130"></a>01130                &amp;LDA, &amp;VL, &amp;VU, &amp;IL, &amp;IU, &amp;ABSTOL, &amp;M, &amp;W[0], &amp;Z[0], &amp;LDZ,
<a name="l01131"></a>01131                &amp;ISUPPZ[0], &amp;WORK[0], &amp;LWORK, &amp;RWORK[0], &amp;LRWORK, &amp;IWORK[0],
<a name="l01132"></a>01132                &amp;LIWORK, &amp;INFO );
<a name="l01133"></a>01133 <span class="preprocessor">#endif</span>
<a name="l01134"></a>01134 <span class="preprocessor"></span>
<a name="l01135"></a>01135   <span class="keywordflow">if</span> (INFO != 0)
<a name="l01136"></a>01136   {
<a name="l01137"></a>01137     <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Error in LAPACK syev eigensolver routine, INFO = &quot;</span> &lt;&lt; INFO &lt;&lt; std::endl;
<a name="l01138"></a>01138     libmesh_error();
<a name="l01139"></a>01139   }
<a name="l01140"></a>01140 
<a name="l01141"></a>01141   <span class="comment">// eval and evec now hold the sorted eigenvalues/eigenvectors</span>
<a name="l01142"></a>01142   <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; std::endl &lt;&lt; <span class="stringliteral">&quot;POD Eigenvalues:&quot;</span> &lt;&lt; std::endl;
<a name="l01143"></a>01143   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;=2; i++)
<a name="l01144"></a>01144   {
<a name="l01145"></a>01145     <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;eigenvalue &quot;</span> &lt;&lt; i &lt;&lt; <span class="stringliteral">&quot; = &quot;</span> &lt;&lt; W[eigen_size-1-i] &lt;&lt; std::endl;
<a name="l01146"></a>01146   }
<a name="l01147"></a>01147   <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;eigenvalue K = &quot;</span> &lt;&lt; W[0] &lt;&lt; std::endl;
<a name="l01148"></a>01148   <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; std::endl;
<a name="l01149"></a>01149 
<a name="l01150"></a>01150   <span class="comment">// Now load the new basis functions</span>
<a name="l01151"></a>01151   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> count = 0;
<a name="l01152"></a>01152   <span class="keywordflow">while</span> (<span class="keyword">true</span>)
<a name="l01153"></a>01153     {
<a name="l01154"></a>01154       <span class="comment">// load the new basis function into the basis_functions vector.</span>
<a name="l01155"></a>01155       <a class="code" href="classlibMesh_1_1RBSystem.php#abfe6d67ed23243d225f12747f355f105">basis_functions</a>.push_back( <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;::build</a>().release() );
<a name="l01156"></a>01156       <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>&amp; current_bf = *(<a class="code" href="classlibMesh_1_1RBSystem.php#abfe6d67ed23243d225f12747f355f105">basis_functions</a>[<a class="code" href="classlibMesh_1_1RBSystem.php#abfe6d67ed23243d225f12747f355f105">basis_functions</a>.size()-1]);
<a name="l01157"></a>01157       current_bf.<a class="code" href="classlibMesh_1_1NumericVector.php#aba2b1e60a94162764c07732626a8231b">init</a> (this-&gt;<a class="code" href="classlibMesh_1_1System.php#a90dbb901f00c14ff18399f4afabcebe5">n_dofs</a>(), this-&gt;<a class="code" href="classlibMesh_1_1System.php#ae3aeb82e65b06789823d41da3c5df7a2">n_local_dofs</a>(), <span class="keyword">false</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">libMeshEnums::PARALLEL</a>);
<a name="l01158"></a>01158       current_bf.<a class="code" href="classlibMesh_1_1NumericVector.php#a85b3d4a53413e3745e6ecf1c8b96ca65">zero</a>();
<a name="l01159"></a>01159 
<a name="l01160"></a>01160       <span class="comment">// Perform the matrix multiplication of temporal data with</span>
<a name="l01161"></a>01161       <span class="comment">// the next POD eigenvector</span>
<a name="l01162"></a>01162       <span class="keywordflow">for</span>(<span class="keywordtype">int</span> j=0; j&lt;eigen_size; j++)
<a name="l01163"></a>01163         {
<a name="l01164"></a>01164           <span class="keywordtype">int</span> Z_row = j;
<a name="l01165"></a>01165           <span class="keywordtype">int</span> Z_col = (eigen_size-1-count);
<a name="l01166"></a>01166           <span class="keywordtype">int</span> Z_index = Z_col*eigen_size + Z_row;
<a name="l01167"></a>01167           current_bf.<a class="code" href="classlibMesh_1_1NumericVector.php#aaf343defd46de8557801dc56a2884506">add</a>(Z[Z_index], *<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a5f9a29b24cc7de2f92e0e1b8f5acbe71">temporal_data</a>[j]);
<a name="l01168"></a>01168         }
<a name="l01169"></a>01169 
<a name="l01170"></a>01170       <span class="comment">// We just set the norm to 1.</span>
<a name="l01171"></a>01171       <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a>)
<a name="l01172"></a>01172         {
<a name="l01173"></a>01173           <a class="code" href="classlibMesh_1_1RBSystem.php#a330478ef4e1a158dc7b6f08530e10ff3">inner_product_matrix</a>-&gt;vector_mult(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>,current_bf);
<a name="l01174"></a>01174         }
<a name="l01175"></a>01175       <span class="keywordflow">else</span>
<a name="l01176"></a>01176         {
<a name="l01177"></a>01177           <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#adaccc5857f1a5d5ca264ded0b8bfb986">vector_mult</a>(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>,current_bf);
<a name="l01178"></a>01178         }
<a name="l01179"></a>01179       <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> current_bf_norm = std::abs( std::sqrt( current_bf.<a class="code" href="classlibMesh_1_1NumericVector.php#a1f522c421b32b75ea4dc3de6d1a95000">dot</a>(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>) ) );
<a name="l01180"></a>01180       current_bf.<a class="code" href="classlibMesh_1_1NumericVector.php#a7efb30d08bd1bb55a91f66782238d648">scale</a>(1./current_bf_norm);
<a name="l01181"></a>01181 
<a name="l01182"></a>01182       <span class="comment">// Increment count here since we use the incremented counter</span>
<a name="l01183"></a>01183       <span class="comment">// in the if clauses below</span>
<a name="l01184"></a>01184       count++;
<a name="l01185"></a>01185 
<a name="l01186"></a>01186       <span class="comment">// If positive POD_tol, we use it to determine the number of basis functions</span>
<a name="l01187"></a>01187       <span class="comment">// to add, and then break the loop when POD_tol is satisfied, or after Nmax</span>
<a name="l01188"></a>01188       <span class="comment">// basis functions have been added. Else we break the loop after delta_N</span>
<a name="l01189"></a>01189       <span class="comment">// (or Nmax) new basis functions.</span>
<a name="l01190"></a>01190       <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1TransientRBSystem.php#ab631619490c50d5e4f7873b6800f5bf8">POD_tol</a> &gt; 0.)
<a name="l01191"></a>01191         {
<a name="l01192"></a>01192           <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a6a0ae338e9bb14d354ee6385cb5df85f">set_delta_N</a>(1);
<a name="l01193"></a>01193 
<a name="l01194"></a>01194           <span class="comment">// We need to define the updated RB system matrices before the RB solve</span>
<a name="l01195"></a>01195           <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae84573a528aea2088e92485998d83969">update_system</a>();
<a name="l01196"></a>01196           <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> error_bound = <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a59ff693a0090652026381ab8004731b2">RB_solve</a>(<a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>());
<a name="l01197"></a>01197 
<a name="l01198"></a>01198           <span class="keywordflow">if</span> ( (error_bound &lt;= <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ab631619490c50d5e4f7873b6800f5bf8">POD_tol</a>) || (<a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>()==<a class="code" href="classlibMesh_1_1RBSystem.php#a5acee637ff70dd65ec54de29241f0627">get_Nmax</a>()) )
<a name="l01199"></a>01199             {
<a name="l01200"></a>01200               <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a6a0ae338e9bb14d354ee6385cb5df85f">set_delta_N</a>(0);
<a name="l01201"></a>01201               <span class="keywordflow">break</span>;
<a name="l01202"></a>01202             }
<a name="l01203"></a>01203         }
<a name="l01204"></a>01204       <span class="keywordflow">else</span>
<a name="l01205"></a>01205         {
<a name="l01206"></a>01206           <span class="keywordflow">if</span> (count == <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a6eb3788340334cf4bcf9d8fa788c31f8">get_delta_N</a>())
<a name="l01207"></a>01207           {
<a name="l01208"></a>01208             <span class="keywordflow">break</span>;
<a name="l01209"></a>01209           }
<a name="l01210"></a>01210           <span class="keywordflow">else</span>
<a name="l01211"></a>01211           <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>()==<a class="code" href="classlibMesh_1_1RBSystem.php#a5acee637ff70dd65ec54de29241f0627">get_Nmax</a>())
<a name="l01212"></a>01212           {
<a name="l01213"></a>01213             <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a6a0ae338e9bb14d354ee6385cb5df85f">set_delta_N</a>(count);
<a name="l01214"></a>01214             <span class="keywordflow">break</span>;
<a name="l01215"></a>01215           }
<a name="l01216"></a>01216         }
<a name="l01217"></a>01217     }
<a name="l01218"></a>01218 
<a name="l01219"></a>01219   STOP_LOG(<span class="stringliteral">&quot;enrich_RB_space()&quot;</span>, <span class="stringliteral">&quot;TransientRBSystem&quot;</span>);
<a name="l01220"></a>01220 <span class="preprocessor">#else</span>
<a name="l01221"></a>01221 <span class="preprocessor"></span>  libmesh_not_implemented();
<a name="l01222"></a>01222 <span class="preprocessor">#endif</span>
<a name="l01223"></a>01223 <span class="preprocessor"></span>}
<a name="l01224"></a>01224 
<a name="l01225"></a>01225 
<a name="l01226"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae84573a528aea2088e92485998d83969">01226</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae84573a528aea2088e92485998d83969">TransientRBSystem::update_system</a>()
<a name="l01227"></a>01227 {
<a name="l01228"></a>01228   <span class="comment">// If delta_N is set to zero, there is nothing to update</span>
<a name="l01229"></a>01229   <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a6eb3788340334cf4bcf9d8fa788c31f8">get_delta_N</a>() == 0)
<a name="l01230"></a>01230     <span class="keywordflow">return</span>;
<a name="l01231"></a>01231 
<a name="l01232"></a>01232   <a class="code" href="classlibMesh_1_1RBSystem.php#af539556a1dac63314567b39e46fa9a08">Parent::update_system</a>();
<a name="l01233"></a>01233 
<a name="l01234"></a>01234   <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Updating RB initial conditions&quot;</span> &lt;&lt; std::endl;
<a name="l01235"></a>01235   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a465255c39194ff391528dfa0cff68995">update_RB_initial_condition_all_N</a>();
<a name="l01236"></a>01236 }
<a name="l01237"></a>01237 
<a name="l01238"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a59ff693a0090652026381ab8004731b2">01238</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a59ff693a0090652026381ab8004731b2">TransientRBSystem::RB_solve</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N)
<a name="l01239"></a>01239 {
<a name="l01240"></a>01240   START_LOG(<span class="stringliteral">&quot;RB_solve()&quot;</span>, <span class="stringliteral">&quot;TransientRBSystem&quot;</span>);
<a name="l01241"></a>01241 
<a name="l01242"></a>01242   <span class="keywordflow">if</span>(N &gt; <a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>())
<a name="l01243"></a>01243   {
<a name="l01244"></a>01244     <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: N cannot be larger than the number &quot;</span>
<a name="l01245"></a>01245                  &lt;&lt; <span class="stringliteral">&quot;of basis functions in RB_solve&quot;</span> &lt;&lt; std::endl;
<a name="l01246"></a>01246     libmesh_error();
<a name="l01247"></a>01247   }
<a name="l01248"></a>01248   <span class="keywordflow">if</span>(N==0)
<a name="l01249"></a>01249   {
<a name="l01250"></a>01250     <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: N must be greater than 0 in RB_solve&quot;</span> &lt;&lt; std::endl;
<a name="l01251"></a>01251     libmesh_error();
<a name="l01252"></a>01252   }
<a name="l01253"></a>01253 
<a name="l01254"></a>01254   <span class="comment">// First assemble the mass matrix</span>
<a name="l01255"></a>01255   <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Number&gt;</a> RB_mass_matrix_N(N,N);
<a name="l01256"></a>01256   RB_mass_matrix_N.<a class="code" href="classlibMesh_1_1DenseMatrix.php#ab3e7a4e199200d0f5875fd4a5082cb7c">zero</a>();
<a name="l01257"></a>01257   <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Number&gt;</a> RB_M_q_m;
<a name="l01258"></a>01258   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_m=0; q_m&lt;<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>(); q_m++)
<a name="l01259"></a>01259   {
<a name="l01260"></a>01260     <a class="code" href="classlibMesh_1_1TransientRBSystem.php#aae9cbd15df988bcdf5cf2db5fcb24e5b">RB_M_q_vector</a>[q_m].get_principal_submatrix(N, RB_M_q_m);
<a name="l01261"></a>01261     RB_mass_matrix_N.<a class="code" href="classlibMesh_1_1DenseMatrix.php#adf1b1e8773da47d9edaed6f12c6ceb9a">add</a>(<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a36a6aa3be4fb96b256cb9d664e5a2dfb">eval_theta_q_m</a>(q_m), RB_M_q_m);
<a name="l01262"></a>01262   }
<a name="l01263"></a>01263 
<a name="l01264"></a>01264   <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Number&gt;</a> RB_LHS_matrix(N,N);
<a name="l01265"></a>01265   RB_LHS_matrix.<a class="code" href="classlibMesh_1_1DenseMatrix.php#ab3e7a4e199200d0f5875fd4a5082cb7c">zero</a>();
<a name="l01266"></a>01266 
<a name="l01267"></a>01267   <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Number&gt;</a> RB_RHS_matrix(N,N);
<a name="l01268"></a>01268   RB_RHS_matrix.<a class="code" href="classlibMesh_1_1DenseMatrix.php#ab3e7a4e199200d0f5875fd4a5082cb7c">zero</a>();
<a name="l01269"></a>01269 
<a name="l01270"></a>01270   RB_LHS_matrix.<a class="code" href="classlibMesh_1_1DenseMatrix.php#adf1b1e8773da47d9edaed6f12c6ceb9a">add</a>(1./<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a04397bf3cc20ccd2bb5056c22b45c9f5">dt</a>, RB_mass_matrix_N);
<a name="l01271"></a>01271   RB_RHS_matrix.<a class="code" href="classlibMesh_1_1DenseMatrix.php#adf1b1e8773da47d9edaed6f12c6ceb9a">add</a>(1./<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a04397bf3cc20ccd2bb5056c22b45c9f5">dt</a>, RB_mass_matrix_N);
<a name="l01272"></a>01272 
<a name="l01273"></a>01273   <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Number&gt;</a> RB_A_q_a;
<a name="l01274"></a>01274   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_a=0; q_a&lt;<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>(); q_a++)
<a name="l01275"></a>01275   {
<a name="l01276"></a>01276     <a class="code" href="classlibMesh_1_1RBSystem.php#adadaf9a427ffbace640455436a4d4b26">RB_A_q_vector</a>[q_a].get_principal_submatrix(N, RB_A_q_a);
<a name="l01277"></a>01277 
<a name="l01278"></a>01278     RB_LHS_matrix.<a class="code" href="classlibMesh_1_1DenseMatrix.php#adf1b1e8773da47d9edaed6f12c6ceb9a">add</a>(       <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a5af426f9dc2b27772aef689c19fbf4b0">euler_theta</a>*<a class="code" href="classlibMesh_1_1RBBase.php#aeeb46ce2b390bf820f954976ee9da7ce">eval_theta_q_a</a>(q_a), RB_A_q_a);
<a name="l01279"></a>01279     RB_RHS_matrix.<a class="code" href="classlibMesh_1_1DenseMatrix.php#adf1b1e8773da47d9edaed6f12c6ceb9a">add</a>( -(1.-<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a5af426f9dc2b27772aef689c19fbf4b0">euler_theta</a>)*<a class="code" href="classlibMesh_1_1RBBase.php#aeeb46ce2b390bf820f954976ee9da7ce">eval_theta_q_a</a>(q_a), RB_A_q_a);
<a name="l01280"></a>01280   }
<a name="l01281"></a>01281 
<a name="l01282"></a>01282   <span class="comment">// Set system time level to 0</span>
<a name="l01283"></a>01283   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a8e91d71806a187bb38f888c6541654b5">error_bound_all_k</a>.resize(<a class="code" href="classlibMesh_1_1TransientRBSystem.php#aac8858a7e9af6497f3c37a4b7956ca6a">_K</a>+1);
<a name="l01284"></a>01284   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a262def83281fa63888e8ed5e3b59d1b8">set_time_level</a>(0); <span class="comment">// Sets the member variable _k to zero</span>
<a name="l01285"></a>01285 
<a name="l01286"></a>01286   <span class="comment">// Resize/clear the solution vector</span>
<a name="l01287"></a>01287   <a class="code" href="classlibMesh_1_1RBSystem.php#a201af52facfa4da38bc636ee2cf41c67">RB_solution</a>.<a class="code" href="classlibMesh_1_1DenseVector.php#a08430ae781094632e8272cbb825d4f44">resize</a>(N);
<a name="l01288"></a>01288 
<a name="l01289"></a>01289   <span class="comment">// Load the initial condition into RB_solution</span>
<a name="l01290"></a>01290   <a class="code" href="classlibMesh_1_1RBSystem.php#a201af52facfa4da38bc636ee2cf41c67">RB_solution</a> = <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a4b802536cffba3d792caf8f95ed04327">RB_initial_condition_all_N</a>[N-1];
<a name="l01291"></a>01291 
<a name="l01292"></a>01292   <span class="comment">// Resize/clear the old solution vector</span>
<a name="l01293"></a>01293   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#adbbe1db7bf9fd6a56b949147cd75d79f">old_RB_solution</a>.<a class="code" href="classlibMesh_1_1DenseVector.php#a08430ae781094632e8272cbb825d4f44">resize</a>(N);
<a name="l01294"></a>01294 
<a name="l01295"></a>01295   <span class="comment">// Initialize the RB rhs</span>
<a name="l01296"></a>01296   <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> RB_rhs(N);
<a name="l01297"></a>01297   RB_rhs.<a class="code" href="classlibMesh_1_1DenseVector.php#a23868ec54dca234e5893e41a8b510d68">zero</a>();
<a name="l01298"></a>01298 
<a name="l01299"></a>01299   <span class="comment">// Initialize the vectors storing solution data</span>
<a name="l01300"></a>01300   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a475a0b22e1808293b4d209f35f60914f">RB_temporal_solution_data</a>.resize(<a class="code" href="classlibMesh_1_1TransientRBSystem.php#aac8858a7e9af6497f3c37a4b7956ca6a">_K</a>+1);
<a name="l01301"></a>01301   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> time_level=0; time_level&lt;=<a class="code" href="classlibMesh_1_1TransientRBSystem.php#aac8858a7e9af6497f3c37a4b7956ca6a">_K</a>; time_level++)
<a name="l01302"></a>01302   {
<a name="l01303"></a>01303     <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a475a0b22e1808293b4d209f35f60914f">RB_temporal_solution_data</a>[time_level].resize(N);
<a name="l01304"></a>01304   }
<a name="l01305"></a>01305   <span class="comment">// and load the _k=0 data</span>
<a name="l01306"></a>01306   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a475a0b22e1808293b4d209f35f60914f">RB_temporal_solution_data</a>[<a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae8bf672ee83dac4058eb4deb5b660750">_k</a>] = <a class="code" href="classlibMesh_1_1RBSystem.php#a201af52facfa4da38bc636ee2cf41c67">RB_solution</a>;
<a name="l01307"></a>01307 
<a name="l01308"></a>01308   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> error_bound_sum = <a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">pow</a>( <a class="code" href="classlibMesh_1_1TransientRBSystem.php#aecf2610660c4023d6c993b4c08b64be4">initial_L2_error_all_N</a>[N-1], 2.);
<a name="l01309"></a>01309 
<a name="l01310"></a>01310   <span class="comment">// Set error bound at _k=0</span>
<a name="l01311"></a>01311   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a8e91d71806a187bb38f888c6541654b5">error_bound_all_k</a>[<a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae8bf672ee83dac4058eb4deb5b660750">_k</a>] = std::sqrt(error_bound_sum);
<a name="l01312"></a>01312 
<a name="l01313"></a>01313   <span class="comment">// Compute the outputs and associated error bounds at _k=0</span>
<a name="l01314"></a>01314   <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> RB_output_vector_N;
<a name="l01315"></a>01315   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#a80b9e06a7c60b3bb2f5870b0ff66a2ca">get_n_outputs</a>(); n++)
<a name="l01316"></a>01316   {
<a name="l01317"></a>01317     <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ad5066d07edc5e25cb04b00fde9e72ec2">RB_outputs_all_k</a>[n][<a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae8bf672ee83dac4058eb4deb5b660750">_k</a>] = 0.;
<a name="l01318"></a>01318     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_l=0; q_l&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#ab7f0b2268a9716189225e0446b519911">get_Q_l</a>(n); q_l++)
<a name="l01319"></a>01319     {
<a name="l01320"></a>01320       <a class="code" href="classlibMesh_1_1RBSystem.php#ab868a08069961fcde36a760e0094708a">RB_output_vectors</a>[n][q_l].get_principal_subvector(N, RB_output_vector_N);
<a name="l01321"></a>01321       <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ad5066d07edc5e25cb04b00fde9e72ec2">RB_outputs_all_k</a>[n][<a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae8bf672ee83dac4058eb4deb5b660750">_k</a>] += <a class="code" href="classlibMesh_1_1RBSystem.php#a3ab4b896903320a2b313f73efc2aaad1">eval_theta_q_l</a>(n,q_l)*RB_output_vector_N.<a class="code" href="classlibMesh_1_1DenseVector.php#a740926ab2815bb507a1e33b659414be1">dot</a>(<a class="code" href="classlibMesh_1_1RBSystem.php#a201af52facfa4da38bc636ee2cf41c67">RB_solution</a>);
<a name="l01322"></a>01322     }
<a name="l01323"></a>01323 
<a name="l01324"></a>01324     <a class="code" href="classlibMesh_1_1TransientRBSystem.php#aeb55ea3e37e65db40b8dd322f4bcb4a6">RB_output_error_bounds_all_k</a>[n][<a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae8bf672ee83dac4058eb4deb5b660750">_k</a>] = <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a8e91d71806a187bb38f888c6541654b5">error_bound_all_k</a>[<a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae8bf672ee83dac4058eb4deb5b660750">_k</a>] * <a class="code" href="classlibMesh_1_1RBSystem.php#a6cae03a0338b32c65938db1f805deb3c">eval_output_dual_norm</a>(n);
<a name="l01325"></a>01325   }
<a name="l01326"></a>01326 
<a name="l01327"></a>01327   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> alpha_LB = <a class="code" href="classlibMesh_1_1RBSystem.php#a572b94b57df61e1670254e91233e5c8a">get_SCM_lower_bound</a>();
<a name="l01328"></a>01328   
<a name="l01329"></a>01329   <span class="comment">// Precompute time-invariant parts of the dual norm of the residual.</span>
<a name="l01330"></a>01330   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a3fce0d07ebe196e79fd03727fef00c79">cache_online_residual_terms</a>(N);
<a name="l01331"></a>01331 
<a name="l01332"></a>01332   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> time_level=1; time_level&lt;=<a class="code" href="classlibMesh_1_1TransientRBSystem.php#aac8858a7e9af6497f3c37a4b7956ca6a">_K</a>; time_level++)
<a name="l01333"></a>01333   {
<a name="l01334"></a>01334     <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a262def83281fa63888e8ed5e3b59d1b8">set_time_level</a>(time_level); <span class="comment">// This updates the member variable _k</span>
<a name="l01335"></a>01335     <a class="code" href="classlibMesh_1_1TransientRBSystem.php#adbbe1db7bf9fd6a56b949147cd75d79f">old_RB_solution</a> = <a class="code" href="classlibMesh_1_1RBSystem.php#a201af52facfa4da38bc636ee2cf41c67">RB_solution</a>;
<a name="l01336"></a>01336 
<a name="l01337"></a>01337     <span class="comment">// Compute RB_rhs, as RB_LHS_matrix x old_RB_solution</span>
<a name="l01338"></a>01338     RB_RHS_matrix.<a class="code" href="classlibMesh_1_1DenseMatrix.php#a493649f63f70ca2adeaee645e26a4677">vector_mult</a>(RB_rhs, <a class="code" href="classlibMesh_1_1TransientRBSystem.php#adbbe1db7bf9fd6a56b949147cd75d79f">old_RB_solution</a>);
<a name="l01339"></a>01339 
<a name="l01340"></a>01340     <span class="comment">// Add forcing terms</span>
<a name="l01341"></a>01341     <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> RB_F_q_f;
<a name="l01342"></a>01342     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_f=0; q_f&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>(); q_f++)
<a name="l01343"></a>01343     {
<a name="l01344"></a>01344       <a class="code" href="classlibMesh_1_1RBSystem.php#ac2da8c5c36be49686429e74b4f9def1c">RB_F_q_vector</a>[q_f].get_principal_subvector(N, RB_F_q_f);
<a name="l01345"></a>01345       RB_rhs.<a class="code" href="classlibMesh_1_1DenseVector.php#ac131f04240149a0548e56a17adb7fb3f">add</a>(<a class="code" href="classlibMesh_1_1RBSystem.php#a0fd951279c9b851ac38443156b4b18bd">eval_theta_q_f</a>(q_f), RB_F_q_f);
<a name="l01346"></a>01346     }
<a name="l01347"></a>01347 
<a name="l01348"></a>01348     RB_LHS_matrix.<a class="code" href="classlibMesh_1_1DenseMatrix.php#a878b9bf0a49000c70acecd55fdcf8d74">lu_solve</a>(RB_rhs, <a class="code" href="classlibMesh_1_1RBSystem.php#a201af52facfa4da38bc636ee2cf41c67">RB_solution</a>);
<a name="l01349"></a>01349 
<a name="l01350"></a>01350     <span class="comment">// Save RB_solution for current time level</span>
<a name="l01351"></a>01351     <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a475a0b22e1808293b4d209f35f60914f">RB_temporal_solution_data</a>[<a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae8bf672ee83dac4058eb4deb5b660750">_k</a>] = <a class="code" href="classlibMesh_1_1RBSystem.php#a201af52facfa4da38bc636ee2cf41c67">RB_solution</a>;
<a name="l01352"></a>01352 
<a name="l01353"></a>01353     <span class="comment">// Evaluate the dual norm of the residual for RB_solution_vector</span>
<a name="l01354"></a>01354 <span class="comment">//    Real epsilon_N = uncached_compute_residual_dual_norm(N);</span>
<a name="l01355"></a>01355     <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> epsilon_N = <a class="code" href="classlibMesh_1_1TransientRBSystem.php#aa64721ef4384e8892eca0dca5c5e7774">compute_residual_dual_norm</a>(N);
<a name="l01356"></a>01356 
<a name="l01357"></a>01357     error_bound_sum += <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae9b4ca47590dc2975de08c73aa0e3a55">residual_scaling_numer</a>(alpha_LB) * <a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">pow</a>(epsilon_N, 2.);
<a name="l01358"></a>01358 
<a name="l01359"></a>01359     <span class="comment">// store error bound at time-level _k</span>
<a name="l01360"></a>01360     <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a8e91d71806a187bb38f888c6541654b5">error_bound_all_k</a>[<a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae8bf672ee83dac4058eb4deb5b660750">_k</a>] = std::sqrt(error_bound_sum/<a class="code" href="classlibMesh_1_1TransientRBSystem.php#aa638dbd9c57a34051024bc67309f7530">residual_scaling_denom</a>(alpha_LB));
<a name="l01361"></a>01361 
<a name="l01362"></a>01362     <span class="comment">// Now compute the outputs and associated errors</span>
<a name="l01363"></a>01363     <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> RB_output_vector_N;
<a name="l01364"></a>01364     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#a80b9e06a7c60b3bb2f5870b0ff66a2ca">get_n_outputs</a>(); n++)
<a name="l01365"></a>01365     {
<a name="l01366"></a>01366       <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ad5066d07edc5e25cb04b00fde9e72ec2">RB_outputs_all_k</a>[n][<a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae8bf672ee83dac4058eb4deb5b660750">_k</a>] = 0.;
<a name="l01367"></a>01367       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_l=0; q_l&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#ab7f0b2268a9716189225e0446b519911">get_Q_l</a>(n); q_l++)
<a name="l01368"></a>01368       {
<a name="l01369"></a>01369         <a class="code" href="classlibMesh_1_1RBSystem.php#ab868a08069961fcde36a760e0094708a">RB_output_vectors</a>[n][q_l].get_principal_subvector(N, RB_output_vector_N);
<a name="l01370"></a>01370         <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ad5066d07edc5e25cb04b00fde9e72ec2">RB_outputs_all_k</a>[n][<a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae8bf672ee83dac4058eb4deb5b660750">_k</a>] += <a class="code" href="classlibMesh_1_1RBSystem.php#a3ab4b896903320a2b313f73efc2aaad1">eval_theta_q_l</a>(n,q_l)*RB_output_vector_N.<a class="code" href="classlibMesh_1_1DenseVector.php#a740926ab2815bb507a1e33b659414be1">dot</a>(<a class="code" href="classlibMesh_1_1RBSystem.php#a201af52facfa4da38bc636ee2cf41c67">RB_solution</a>);
<a name="l01371"></a>01371       }
<a name="l01372"></a>01372 
<a name="l01373"></a>01373       <a class="code" href="classlibMesh_1_1TransientRBSystem.php#aeb55ea3e37e65db40b8dd322f4bcb4a6">RB_output_error_bounds_all_k</a>[n][<a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae8bf672ee83dac4058eb4deb5b660750">_k</a>] = <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a8e91d71806a187bb38f888c6541654b5">error_bound_all_k</a>[<a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae8bf672ee83dac4058eb4deb5b660750">_k</a>] * <a class="code" href="classlibMesh_1_1RBSystem.php#a6cae03a0338b32c65938db1f805deb3c">eval_output_dual_norm</a>(n);
<a name="l01374"></a>01374     }
<a name="l01375"></a>01375   }
<a name="l01376"></a>01376 
<a name="l01377"></a>01377   <span class="comment">// Now compute the L2 norm of the RB solution at time-level _K</span>
<a name="l01378"></a>01378   <span class="comment">// to normalize the error bound</span>
<a name="l01379"></a>01379   <span class="comment">// We reuse RB_rhs here</span>
<a name="l01380"></a>01380   <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Number&gt;</a> RB_L2_matrix_N;
<a name="l01381"></a>01381   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a8cbf1f70128f7a173eb169aebd0f496e">RB_L2_matrix</a>.<a class="code" href="classlibMesh_1_1DenseMatrix.php#abf62d6b34b155876279d8db1564a6e14">get_principal_submatrix</a>(N,RB_L2_matrix_N);
<a name="l01382"></a>01382   RB_L2_matrix_N.<a class="code" href="classlibMesh_1_1DenseMatrix.php#a493649f63f70ca2adeaee645e26a4677">vector_mult</a>(RB_rhs, <a class="code" href="classlibMesh_1_1RBSystem.php#a201af52facfa4da38bc636ee2cf41c67">RB_solution</a>);
<a name="l01383"></a>01383   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> final_RB_L2_norm = <a class="code" href="namespacelibMesh.php#aea33cac176f18504c5c4078407aadbb7">libmesh_real</a>(std::sqrt(<a class="code" href="classlibMesh_1_1RBSystem.php#a201af52facfa4da38bc636ee2cf41c67">RB_solution</a>.<a class="code" href="classlibMesh_1_1DenseVector.php#a740926ab2815bb507a1e33b659414be1">dot</a>(RB_rhs)));
<a name="l01384"></a>01384 
<a name="l01385"></a>01385   STOP_LOG(<span class="stringliteral">&quot;RB_solve()&quot;</span>, <span class="stringliteral">&quot;TransientRBSystem&quot;</span>);
<a name="l01386"></a>01386 
<a name="l01387"></a>01387   <span class="keywordflow">return</span> ( <a class="code" href="classlibMesh_1_1RBSystem.php#a56ab5090b2d6e6322742ade2772330e7">return_rel_error_bound</a> ? <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a8e91d71806a187bb38f888c6541654b5">error_bound_all_k</a>[<a class="code" href="classlibMesh_1_1TransientRBSystem.php#aac8858a7e9af6497f3c37a4b7956ca6a">_K</a>]/final_RB_L2_norm : <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a8e91d71806a187bb38f888c6541654b5">error_bound_all_k</a>[<a class="code" href="classlibMesh_1_1TransientRBSystem.php#aac8858a7e9af6497f3c37a4b7956ca6a">_K</a>] );
<a name="l01388"></a>01388 }
<a name="l01389"></a>01389 
<a name="l01390"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae9b4ca47590dc2975de08c73aa0e3a55">01390</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae9b4ca47590dc2975de08c73aa0e3a55">TransientRBSystem::residual_scaling_numer</a>(<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>)
<a name="l01391"></a>01391 {
<a name="l01392"></a>01392   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ab5a283a3f305fd03ee1f8e25a5f11bbc">get_dt</a>();
<a name="l01393"></a>01393 }
<a name="l01394"></a>01394 
<a name="l01395"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#aa638dbd9c57a34051024bc67309f7530">01395</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#aa638dbd9c57a34051024bc67309f7530">TransientRBSystem::residual_scaling_denom</a>(<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> alpha_LB)
<a name="l01396"></a>01396 {
<a name="l01397"></a>01397   <span class="keywordflow">return</span> alpha_LB;
<a name="l01398"></a>01398 }
<a name="l01399"></a>01399 
<a name="l01400"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a14c59681fde1890ec3d0e1fbc031b784">01400</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a14c59681fde1890ec3d0e1fbc031b784">TransientRBSystem::assemble_matrix_for_output_dual_solves</a>()
<a name="l01401"></a>01401 {
<a name="l01402"></a>01402   <span class="comment">// By default we use the L2 matrix for transient problems</span>
<a name="l01403"></a>01403   
<a name="l01404"></a>01404   <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a>)
<a name="l01405"></a>01405   {
<a name="l01406"></a>01406     <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#a966e0a6479f33c2518937e7d0f54602f">zero</a>();
<a name="l01407"></a>01407     <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#a401beeed965b80425730050a61de5c21">add</a>(1., *<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a4e15721a62defb903900352ceb0ea367">L2_matrix</a>);
<a name="l01408"></a>01408   }
<a name="l01409"></a>01409   <span class="keywordflow">else</span>
<a name="l01410"></a>01410   {
<a name="l01411"></a>01411     <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a0ee3e3816d13aeae07fe5212dda5f521">assemble_L2_matrix</a>(<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>);
<a name="l01412"></a>01412   }
<a name="l01413"></a>01413 }
<a name="l01414"></a>01414 
<a name="l01415"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#ad23a86810dc83165bb0ed2237fa6f521">01415</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ad23a86810dc83165bb0ed2237fa6f521">TransientRBSystem::load_RB_solution</a>()
<a name="l01416"></a>01416 {
<a name="l01417"></a>01417   START_LOG(<span class="stringliteral">&quot;load_RB_solution()&quot;</span>, <span class="stringliteral">&quot;TransientRBSystem&quot;</span>);
<a name="l01418"></a>01418 
<a name="l01419"></a>01419   <a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;zero();
<a name="l01420"></a>01420 
<a name="l01421"></a>01421   <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> RB_solution_vector_k = <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a475a0b22e1808293b4d209f35f60914f">RB_temporal_solution_data</a>[<a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae8bf672ee83dac4058eb4deb5b660750">_k</a>];
<a name="l01422"></a>01422 
<a name="l01423"></a>01423   <span class="keywordflow">if</span>(RB_solution_vector_k.<a class="code" href="classlibMesh_1_1DenseVector.php#ab124ecf2f46ee43b167f093b05d81fdb">size</a>() &gt; <a class="code" href="classlibMesh_1_1RBSystem.php#abfe6d67ed23243d225f12747f355f105">basis_functions</a>.size())
<a name="l01424"></a>01424   {
<a name="l01425"></a>01425     <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: System contains &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1RBSystem.php#abfe6d67ed23243d225f12747f355f105">basis_functions</a>.size() &lt;&lt; <span class="stringliteral">&quot; basis functions.&quot;</span>
<a name="l01426"></a>01426                  &lt;&lt; <span class="stringliteral">&quot; RB_solution vector constains &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1RBSystem.php#a201af52facfa4da38bc636ee2cf41c67">RB_solution</a>.<a class="code" href="classlibMesh_1_1DenseVector.php#ab124ecf2f46ee43b167f093b05d81fdb">size</a>() &lt;&lt; <span class="stringliteral">&quot; entries.&quot;</span>
<a name="l01427"></a>01427                  &lt;&lt; <span class="stringliteral">&quot; RB_solution in TransientRBSystem::load_RB_solution is too long!&quot;</span> &lt;&lt; std::endl;
<a name="l01428"></a>01428     libmesh_error();
<a name="l01429"></a>01429   }
<a name="l01430"></a>01430 
<a name="l01431"></a>01431   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;RB_solution_vector_k.<a class="code" href="classlibMesh_1_1DenseVector.php#ab124ecf2f46ee43b167f093b05d81fdb">size</a>(); i++)
<a name="l01432"></a>01432   {
<a name="l01433"></a>01433     <a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;add(RB_solution_vector_k(i), *<a class="code" href="classlibMesh_1_1RBSystem.php#abfe6d67ed23243d225f12747f355f105">basis_functions</a>[i]);
<a name="l01434"></a>01434   }
<a name="l01435"></a>01435 
<a name="l01436"></a>01436   <a class="code" href="classlibMesh_1_1System.php#ab9d81ac9c1787c43fb87cf13d37741ee">update</a>();
<a name="l01437"></a>01437 
<a name="l01438"></a>01438   STOP_LOG(<span class="stringliteral">&quot;load_RB_solution()&quot;</span>, <span class="stringliteral">&quot;TransientRBSystem&quot;</span>);
<a name="l01439"></a>01439 }
<a name="l01440"></a>01440 
<a name="l01441"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a0bd7a0e822ac88f71f9dd7baeef179a7">01441</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a0bd7a0e822ac88f71f9dd7baeef179a7">TransientRBSystem::update_RB_system_matrices</a>()
<a name="l01442"></a>01442 {
<a name="l01443"></a>01443   START_LOG(<span class="stringliteral">&quot;update_RB_system_matrices()&quot;</span>, <span class="stringliteral">&quot;TransientRBSystem&quot;</span>);
<a name="l01444"></a>01444 
<a name="l01445"></a>01445   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a0bd7a0e822ac88f71f9dd7baeef179a7">RBSystem::update_RB_system_matrices</a>();
<a name="l01446"></a>01446 
<a name="l01447"></a>01447   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> RB_size = <a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>();
<a name="l01448"></a>01448 
<a name="l01449"></a>01449   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt; NumericVector&lt;Number&gt;</a> &gt; temp = <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;::build</a>();
<a name="l01450"></a>01450   temp-&gt;init (this-&gt;<a class="code" href="classlibMesh_1_1System.php#a90dbb901f00c14ff18399f4afabcebe5">n_dofs</a>(), this-&gt;<a class="code" href="classlibMesh_1_1System.php#ae3aeb82e65b06789823d41da3c5df7a2">n_local_dofs</a>(), <span class="keyword">false</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">libMeshEnums::PARALLEL</a>);
<a name="l01451"></a>01451   
<a name="l01452"></a>01452   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=(RB_size-<a class="code" href="classlibMesh_1_1RBSystem.php#a36ba489bd3158bbff48a5607e1d21d30">delta_N</a>); i&lt;RB_size; i++)
<a name="l01453"></a>01453   {
<a name="l01454"></a>01454     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;RB_size; j++)
<a name="l01455"></a>01455     {
<a name="l01456"></a>01456       <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> value = 0.;
<a name="l01457"></a>01457       
<a name="l01458"></a>01458       <span class="comment">// Compute reduced L2 matrix</span>
<a name="l01459"></a>01459       temp-&gt;zero();
<a name="l01460"></a>01460       <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a>)
<a name="l01461"></a>01461       {
<a name="l01462"></a>01462         <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a4e15721a62defb903900352ceb0ea367">L2_matrix</a>-&gt;vector_mult(*temp, *<a class="code" href="classlibMesh_1_1RBSystem.php#abfe6d67ed23243d225f12747f355f105">basis_functions</a>[j]);
<a name="l01463"></a>01463       }
<a name="l01464"></a>01464       <span class="keywordflow">else</span>
<a name="l01465"></a>01465       {
<a name="l01466"></a>01466         <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a0ee3e3816d13aeae07fe5212dda5f521">assemble_L2_matrix</a>(<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>);
<a name="l01467"></a>01467         <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#adaccc5857f1a5d5ca264ded0b8bfb986">vector_mult</a>(*temp, *<a class="code" href="classlibMesh_1_1RBSystem.php#abfe6d67ed23243d225f12747f355f105">basis_functions</a>[j]);
<a name="l01468"></a>01468       }
<a name="l01469"></a>01469       value = <a class="code" href="classlibMesh_1_1RBSystem.php#abfe6d67ed23243d225f12747f355f105">basis_functions</a>[i]-&gt;dot(*temp);
<a name="l01470"></a>01470       <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a8cbf1f70128f7a173eb169aebd0f496e">RB_L2_matrix</a>(i,j) = value;
<a name="l01471"></a>01471       <span class="keywordflow">if</span>(i!=j)
<a name="l01472"></a>01472       {
<a name="l01473"></a>01473         <span class="comment">// The L2 matrix is assumed</span>
<a name="l01474"></a>01474         <span class="comment">// to be symmetric</span>
<a name="l01475"></a>01475         <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a8cbf1f70128f7a173eb169aebd0f496e">RB_L2_matrix</a>(j,i) = value;
<a name="l01476"></a>01476       }
<a name="l01477"></a>01477 
<a name="l01478"></a>01478       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_m=0; q_m&lt;<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>(); q_m++)
<a name="l01479"></a>01479       {
<a name="l01480"></a>01480         <span class="comment">// Compute reduced M_q matrix</span>
<a name="l01481"></a>01481         temp-&gt;zero();
<a name="l01482"></a>01482         <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a>)
<a name="l01483"></a>01483         {
<a name="l01484"></a>01484           <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a528a1bc40b5c1b63ee8c51375b1824dc">get_M_q</a>(q_m)-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#adaccc5857f1a5d5ca264ded0b8bfb986">vector_mult</a>(*temp, *<a class="code" href="classlibMesh_1_1RBSystem.php#abfe6d67ed23243d225f12747f355f105">basis_functions</a>[j]);
<a name="l01485"></a>01485         }
<a name="l01486"></a>01486         <span class="keywordflow">else</span>
<a name="l01487"></a>01487         {
<a name="l01488"></a>01488           <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a0b6610b9ad630934520fa4581101668e">assemble_Mq_matrix</a>(q_m,<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>);
<a name="l01489"></a>01489           <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#adaccc5857f1a5d5ca264ded0b8bfb986">vector_mult</a>(*temp, *<a class="code" href="classlibMesh_1_1RBSystem.php#abfe6d67ed23243d225f12747f355f105">basis_functions</a>[j]);
<a name="l01490"></a>01490         }
<a name="l01491"></a>01491 
<a name="l01492"></a>01492         value = (*<a class="code" href="classlibMesh_1_1RBSystem.php#abfe6d67ed23243d225f12747f355f105">basis_functions</a>[i]).dot(*temp);
<a name="l01493"></a>01493         <a class="code" href="classlibMesh_1_1TransientRBSystem.php#aae9cbd15df988bcdf5cf2db5fcb24e5b">RB_M_q_vector</a>[q_m](i,j) = value;
<a name="l01494"></a>01494 
<a name="l01495"></a>01495         <span class="keywordflow">if</span>(i!=j)
<a name="l01496"></a>01496         {
<a name="l01497"></a>01497           <span class="comment">// Each mass matrix term is assumed</span>
<a name="l01498"></a>01498           <span class="comment">// to be symmetric</span>
<a name="l01499"></a>01499           <a class="code" href="classlibMesh_1_1TransientRBSystem.php#aae9cbd15df988bcdf5cf2db5fcb24e5b">RB_M_q_vector</a>[q_m](j,i) = value;
<a name="l01500"></a>01500         }
<a name="l01501"></a>01501       }
<a name="l01502"></a>01502       
<a name="l01503"></a>01503     }
<a name="l01504"></a>01504   }
<a name="l01505"></a>01505 
<a name="l01506"></a>01506   STOP_LOG(<span class="stringliteral">&quot;update_RB_system_matrices()&quot;</span>, <span class="stringliteral">&quot;TransientRBSystem&quot;</span>);
<a name="l01507"></a>01507 }
<a name="l01508"></a>01508 
<a name="l01509"></a>01509 
<a name="l01510"></a>01510 
<a name="l01511"></a>01511 
<a name="l01512"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#af65ff4ed2f3257fa79a540aafd6d58bc">01512</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#af65ff4ed2f3257fa79a540aafd6d58bc">TransientRBSystem::update_residual_terms</a>(<span class="keywordtype">bool</span> compute_inner_products)
<a name="l01513"></a>01513 {
<a name="l01514"></a>01514   START_LOG(<span class="stringliteral">&quot;update_residual_terms()&quot;</span>, <span class="stringliteral">&quot;TransientRBSystem&quot;</span>);
<a name="l01515"></a>01515 
<a name="l01516"></a>01516   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#af65ff4ed2f3257fa79a540aafd6d58bc">RBSystem::update_residual_terms</a>(compute_inner_products);
<a name="l01517"></a>01517 
<a name="l01518"></a>01518   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> RB_size = <a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>();
<a name="l01519"></a>01519 
<a name="l01520"></a>01520   <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a>)
<a name="l01521"></a>01521   {
<a name="l01522"></a>01522     <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#a966e0a6479f33c2518937e7d0f54602f">zero</a>();
<a name="l01523"></a>01523     <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#a401beeed965b80425730050a61de5c21">add</a>(1., *<a class="code" href="classlibMesh_1_1RBSystem.php#a330478ef4e1a158dc7b6f08530e10ff3">inner_product_matrix</a>);
<a name="l01524"></a>01524     <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBSystem.php#a28b1348023897cb1517724d6ac30a21d">constrained_problem</a>)
<a name="l01525"></a>01525       <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#a401beeed965b80425730050a61de5c21">add</a>(1., *<a class="code" href="classlibMesh_1_1RBSystem.php#aa7a3439518c1b8a421a79064e819f5c8">constraint_matrix</a>);
<a name="l01526"></a>01526   }
<a name="l01527"></a>01527   <span class="keywordflow">else</span>
<a name="l01528"></a>01528   {
<a name="l01529"></a>01529     <a class="code" href="classlibMesh_1_1RBSystem.php#a2bde84b5899642d6bb6ba2f6ac4a51f9">assemble_inner_product_matrix</a>(<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>);
<a name="l01530"></a>01530     <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBSystem.php#a28b1348023897cb1517724d6ac30a21d">constrained_problem</a>)
<a name="l01531"></a>01531       <a class="code" href="classlibMesh_1_1RBSystem.php#a4a1243f45ea36fbd2a10ad6956c62deb">add_scaled_matrix_and_vector</a>(1., <a class="code" href="classlibMesh_1_1RBSystem.php#a9c6da671e41886e26c7e88aae82f4358">constraint_assembly</a>, NULL, <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>, NULL);
<a name="l01532"></a>01532   }
<a name="l01533"></a>01533 
<a name="l01534"></a>01534   <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBSystem.php#a61f47d68b0df487674a9001d13d77c88">reuse_preconditioner</a>)
<a name="l01535"></a>01535   {
<a name="l01536"></a>01536     <span class="comment">// For the first solve, make sure we generate a new preconditioner</span>
<a name="l01537"></a>01537     <span class="comment">// Actually, this is not necessary as we can use the preconditioner</span>
<a name="l01538"></a>01538     <span class="comment">// generated by RBSystem::update_residual_terms()</span>
<a name="l01539"></a>01539     <a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a7cc68891fa9f44ded49b9b84c057cb32">linear_solver</a>-&gt;same_preconditioner = <span class="keyword">true</span>;
<a name="l01540"></a>01540   }
<a name="l01541"></a>01541 
<a name="l01542"></a>01542   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_m=0; q_m&lt;<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>(); q_m++)
<a name="l01543"></a>01543   {
<a name="l01544"></a>01544     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=(RB_size-<a class="code" href="classlibMesh_1_1RBSystem.php#a36ba489bd3158bbff48a5607e1d21d30">delta_N</a>); i&lt;RB_size; i++)
<a name="l01545"></a>01545     {
<a name="l01546"></a>01546       <span class="comment">// Initialize the vectors when we need them</span>
<a name="l01547"></a>01547       <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a7b52b6d7cf4f4f9245464050e876d21b">M_q_representor</a>[q_m][i] = (<a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;::build</a>().release());
<a name="l01548"></a>01548       <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a7b52b6d7cf4f4f9245464050e876d21b">M_q_representor</a>[q_m][i]-&gt;init (this-&gt;<a class="code" href="classlibMesh_1_1System.php#a90dbb901f00c14ff18399f4afabcebe5">n_dofs</a>(), this-&gt;<a class="code" href="classlibMesh_1_1System.php#ae3aeb82e65b06789823d41da3c5df7a2">n_local_dofs</a>(), <span class="keyword">false</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">libMeshEnums::PARALLEL</a>);
<a name="l01549"></a>01549 
<a name="l01550"></a>01550       <a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a85b3d4a53413e3745e6ecf1c8b96ca65">zero</a>();
<a name="l01551"></a>01551       <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a>)
<a name="l01552"></a>01552       {
<a name="l01553"></a>01553         <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a9ba330e7121f7141b7ec495b3a2370be">M_q_vector</a>[q_m]-&gt;vector_mult(*<a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a>, *<a class="code" href="classlibMesh_1_1RBSystem.php#abfe6d67ed23243d225f12747f355f105">basis_functions</a>[i]);
<a name="l01554"></a>01554       }
<a name="l01555"></a>01555       <span class="keywordflow">else</span>
<a name="l01556"></a>01556       {
<a name="l01557"></a>01557         <a class="code" href="classlibMesh_1_1RBSystem.php#a568b302f96140c76530b9412c1b87b38">assemble_scaled_matvec</a>(1.,
<a name="l01558"></a>01558                                <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ab0c9e56b352b41ae67ad085358b5606f">M_q_intrr_assembly_vector</a>[q_m],
<a name="l01559"></a>01559                                <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a35b236bc4b078d83bd0cb58a4aeb274f">M_q_bndry_assembly_vector</a>[q_m],
<a name="l01560"></a>01560                                *<a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a>,
<a name="l01561"></a>01561                                *<a class="code" href="classlibMesh_1_1RBSystem.php#abfe6d67ed23243d225f12747f355f105">basis_functions</a>[i]);
<a name="l01562"></a>01562       }
<a name="l01563"></a>01563       <a class="code" href="classlibMesh_1_1RBSystem.php#a85c25bbd66bed6e4111e44566e91b5ff">zero_dirichlet_dofs_on_rhs</a>();
<a name="l01564"></a>01564 
<a name="l01565"></a>01565       <a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;zero();
<a name="l01566"></a>01566 
<a name="l01567"></a>01567       <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1RBSystem.php#adec856bc209f0533639d76767bd5ebbc">quiet</a>)
<a name="l01568"></a>01568         <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Starting solve i=&quot;</span>
<a name="l01569"></a>01569                      &lt;&lt; i &lt;&lt; <span class="stringliteral">&quot; in TransientRBSystem::update_residual_terms() at &quot;</span>
<a name="l01570"></a>01570                      &lt;&lt; <a class="code" href="namespacelibMesh_1_1Utility.php#a0e4485920eb5de9a47b6f8760a11361d">Utility::get_timestamp</a>() &lt;&lt; std::endl;
<a name="l01571"></a>01571       <a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#af1de21a76860785bb1992280eb72b0db">solve</a>();
<a name="l01572"></a>01572 
<a name="l01573"></a>01573       <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1RBSystem.php#adec856bc209f0533639d76767bd5ebbc">quiet</a>)
<a name="l01574"></a>01574         {
<a name="l01575"></a>01575           <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Finished solve i=&quot;</span>
<a name="l01576"></a>01576                        &lt;&lt; i &lt;&lt; <span class="stringliteral">&quot; in TransientRBSystem::update_residual_terms() at &quot;</span>
<a name="l01577"></a>01577                        &lt;&lt; <a class="code" href="namespacelibMesh_1_1Utility.php#a0e4485920eb5de9a47b6f8760a11361d">Utility::get_timestamp</a>() &lt;&lt; std::endl;
<a name="l01578"></a>01578 
<a name="l01579"></a>01579           <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; this-&gt;<a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#af712dbf0e285c5ff4cc346daef05423c">n_linear_iterations</a>()
<a name="l01580"></a>01580                        &lt;&lt; <span class="stringliteral">&quot; iterations, final residual &quot;</span>
<a name="l01581"></a>01581                        &lt;&lt; this-&gt;<a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a86b5e2954d2a2e43014bcda8810239ac">final_linear_residual</a>() &lt;&lt; std::endl;
<a name="l01582"></a>01582         }
<a name="l01583"></a>01583 
<a name="l01584"></a>01584       <span class="comment">// Make sure we didn&#39;t max out the number of iterations</span>
<a name="l01585"></a>01585       <span class="keywordflow">if</span>( (this-&gt;<a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#af712dbf0e285c5ff4cc346daef05423c">n_linear_iterations</a>() &gt;=
<a name="l01586"></a>01586           this-&gt;<a class="code" href="classlibMesh_1_1System.php#ac5ca6b1f3adcfac56982982e90dc905b">get_equation_systems</a>().parameters.get&lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&gt;(<span class="stringliteral">&quot;linear solver maximum iterations&quot;</span>)) &amp;&amp;
<a name="l01587"></a>01587           (this-&gt;final_linear_residual() &gt;
<a name="l01588"></a>01588           this-&gt;<a class="code" href="classlibMesh_1_1System.php#ac5ca6b1f3adcfac56982982e90dc905b">get_equation_systems</a>().<a class="code" href="classlibMesh_1_1EquationSystems.php#a7c02be232f564967ca0804a7824adb53">parameters</a>.<a class="code" href="classlibMesh_1_1Parameters.php#ac7fa2054ee32db2c3979d48bd2103f20">get</a>&lt;<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>&gt;(<span class="stringliteral">&quot;linear solver tolerance&quot;</span>)) )
<a name="l01589"></a>01589       {
<a name="l01590"></a>01590         <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Warning: Linear solver may not have converged! Final linear residual = &quot;</span>
<a name="l01591"></a>01591                      &lt;&lt; this-&gt;<a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a86b5e2954d2a2e43014bcda8810239ac">final_linear_residual</a>() &lt;&lt; <span class="stringliteral">&quot;, number of iterations = &quot;</span>
<a name="l01592"></a>01592                      &lt;&lt; this-&gt;<a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#af712dbf0e285c5ff4cc346daef05423c">n_linear_iterations</a>() &lt;&lt; std::endl &lt;&lt; std::endl;
<a name="l01593"></a>01593   <span class="comment">//       libmesh_error();</span>
<a name="l01594"></a>01594       }
<a name="l01595"></a>01595 
<a name="l01596"></a>01596       *<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a7b52b6d7cf4f4f9245464050e876d21b">M_q_representor</a>[q_m][i] = *<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>;
<a name="l01597"></a>01597 
<a name="l01598"></a>01598       <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBSystem.php#a61f47d68b0df487674a9001d13d77c88">reuse_preconditioner</a>)
<a name="l01599"></a>01599       {
<a name="l01600"></a>01600         <a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a7cc68891fa9f44ded49b9b84c057cb32">linear_solver</a>-&gt;same_preconditioner = <span class="keyword">true</span>;
<a name="l01601"></a>01601       }
<a name="l01602"></a>01602     }
<a name="l01603"></a>01603   }
<a name="l01604"></a>01604 
<a name="l01605"></a>01605   <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBSystem.php#a61f47d68b0df487674a9001d13d77c88">reuse_preconditioner</a>)
<a name="l01606"></a>01606   {
<a name="l01607"></a>01607     <a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a7cc68891fa9f44ded49b9b84c057cb32">linear_solver</a>-&gt;same_preconditioner = <span class="keyword">false</span>;
<a name="l01608"></a>01608   }
<a name="l01609"></a>01609 
<a name="l01610"></a>01610 
<a name="l01611"></a>01611   <span class="comment">// Now compute and store the inner products if requested</span>
<a name="l01612"></a>01612   <span class="keywordflow">if</span> (compute_inner_products)
<a name="l01613"></a>01613     {
<a name="l01614"></a>01614       <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a> &amp;&amp; <a class="code" href="classlibMesh_1_1RBSystem.php#a28b1348023897cb1517724d6ac30a21d">constrained_problem</a>)
<a name="l01615"></a>01615         <a class="code" href="classlibMesh_1_1RBSystem.php#a2bde84b5899642d6bb6ba2f6ac4a51f9">assemble_inner_product_matrix</a>(<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>);
<a name="l01616"></a>01616 
<a name="l01617"></a>01617       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_f=0; q_f&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>(); q_f++)
<a name="l01618"></a>01618         {
<a name="l01619"></a>01619           <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a>)
<a name="l01620"></a>01620             {
<a name="l01621"></a>01621               <a class="code" href="classlibMesh_1_1RBSystem.php#a330478ef4e1a158dc7b6f08530e10ff3">inner_product_matrix</a>-&gt;vector_mult(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>, *<a class="code" href="classlibMesh_1_1RBSystem.php#acd91cfaa84058427cda2885e4d6d30ce">F_q_representor</a>[q_f]);
<a name="l01622"></a>01622             }
<a name="l01623"></a>01623           <span class="keywordflow">else</span>
<a name="l01624"></a>01624             {
<a name="l01625"></a>01625               <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#adaccc5857f1a5d5ca264ded0b8bfb986">vector_mult</a>(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>, *<a class="code" href="classlibMesh_1_1RBSystem.php#acd91cfaa84058427cda2885e4d6d30ce">F_q_representor</a>[q_f]);
<a name="l01626"></a>01626             }
<a name="l01627"></a>01627 
<a name="l01628"></a>01628           <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=(RB_size-<a class="code" href="classlibMesh_1_1RBSystem.php#a36ba489bd3158bbff48a5607e1d21d30">delta_N</a>); i&lt;RB_size; i++)
<a name="l01629"></a>01629             {
<a name="l01630"></a>01630               <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_m=0; q_m&lt;<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>(); q_m++)
<a name="l01631"></a>01631                 {
<a name="l01632"></a>01632                   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a400cfc38ee1a109d110230227d59b651">Fq_Mq_representor_norms</a>[q_f][q_m][i] =
<a name="l01633"></a>01633                     <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a7b52b6d7cf4f4f9245464050e876d21b">M_q_representor</a>[q_m][i]-&gt;dot(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>);
<a name="l01634"></a>01634                 } <span class="comment">// end for q_m</span>
<a name="l01635"></a>01635             } <span class="comment">// end for i</span>
<a name="l01636"></a>01636         } <span class="comment">// end for q_f</span>
<a name="l01637"></a>01637 
<a name="l01638"></a>01638       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q=0;
<a name="l01639"></a>01639       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_m1=0; q_m1&lt;<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>(); q_m1++)
<a name="l01640"></a>01640         {
<a name="l01641"></a>01641           <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_m2=q_m1; q_m2&lt;<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>(); q_m2++)
<a name="l01642"></a>01642             {
<a name="l01643"></a>01643               <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=(RB_size-<a class="code" href="classlibMesh_1_1RBSystem.php#a36ba489bd3158bbff48a5607e1d21d30">delta_N</a>); i&lt;RB_size; i++)
<a name="l01644"></a>01644                 {
<a name="l01645"></a>01645                   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;RB_size; j++)
<a name="l01646"></a>01646                     {
<a name="l01647"></a>01647                       <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a>)
<a name="l01648"></a>01648                         {
<a name="l01649"></a>01649                           <a class="code" href="classlibMesh_1_1RBSystem.php#a330478ef4e1a158dc7b6f08530e10ff3">inner_product_matrix</a>-&gt;vector_mult(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>, *<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a7b52b6d7cf4f4f9245464050e876d21b">M_q_representor</a>[q_m2][j]);
<a name="l01650"></a>01650                         }
<a name="l01651"></a>01651                       <span class="keywordflow">else</span>
<a name="l01652"></a>01652                         {
<a name="l01653"></a>01653                           <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#adaccc5857f1a5d5ca264ded0b8bfb986">vector_mult</a>(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>, *<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a7b52b6d7cf4f4f9245464050e876d21b">M_q_representor</a>[q_m2][j]);
<a name="l01654"></a>01654                         }
<a name="l01655"></a>01655                       <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a4ab78d5be55e56ba7170868428592f51">Mq_Mq_representor_norms</a>[q][i][j] = <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a7b52b6d7cf4f4f9245464050e876d21b">M_q_representor</a>[q_m1][i]-&gt;dot(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>);
<a name="l01656"></a>01656 
<a name="l01657"></a>01657                       <span class="keywordflow">if</span>(i != j)
<a name="l01658"></a>01658                         {
<a name="l01659"></a>01659                           <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a>)
<a name="l01660"></a>01660                             {
<a name="l01661"></a>01661                               <a class="code" href="classlibMesh_1_1RBSystem.php#a330478ef4e1a158dc7b6f08530e10ff3">inner_product_matrix</a>-&gt;vector_mult(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>, *<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a7b52b6d7cf4f4f9245464050e876d21b">M_q_representor</a>[q_m2][i]);
<a name="l01662"></a>01662                             }
<a name="l01663"></a>01663                           <span class="keywordflow">else</span>
<a name="l01664"></a>01664                             {
<a name="l01665"></a>01665                               <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#adaccc5857f1a5d5ca264ded0b8bfb986">vector_mult</a>(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>, *<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a7b52b6d7cf4f4f9245464050e876d21b">M_q_representor</a>[q_m2][i]);
<a name="l01666"></a>01666                             }
<a name="l01667"></a>01667                           <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a4ab78d5be55e56ba7170868428592f51">Mq_Mq_representor_norms</a>[q][j][i] = <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a7b52b6d7cf4f4f9245464050e876d21b">M_q_representor</a>[q_m1][j]-&gt;dot(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>);
<a name="l01668"></a>01668                         }
<a name="l01669"></a>01669                     } <span class="comment">// end for j</span>
<a name="l01670"></a>01670                 } <span class="comment">// end for i</span>
<a name="l01671"></a>01671               q++;
<a name="l01672"></a>01672             } <span class="comment">// end for q_m2</span>
<a name="l01673"></a>01673         } <span class="comment">// end for q_m1</span>
<a name="l01674"></a>01674 
<a name="l01675"></a>01675 
<a name="l01676"></a>01676       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=(RB_size-<a class="code" href="classlibMesh_1_1RBSystem.php#a36ba489bd3158bbff48a5607e1d21d30">delta_N</a>); i&lt;RB_size; i++)
<a name="l01677"></a>01677         {
<a name="l01678"></a>01678           <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;RB_size; j++)
<a name="l01679"></a>01679             {
<a name="l01680"></a>01680               <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_a=0; q_a&lt;<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>(); q_a++)
<a name="l01681"></a>01681                 {
<a name="l01682"></a>01682                   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_m=0; q_m&lt;<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>(); q_m++)
<a name="l01683"></a>01683                     {
<a name="l01684"></a>01684                       <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a>)
<a name="l01685"></a>01685                         {
<a name="l01686"></a>01686                           <a class="code" href="classlibMesh_1_1RBSystem.php#a330478ef4e1a158dc7b6f08530e10ff3">inner_product_matrix</a>-&gt;vector_mult(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>, *<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a7b52b6d7cf4f4f9245464050e876d21b">M_q_representor</a>[q_m][j]);
<a name="l01687"></a>01687                         }
<a name="l01688"></a>01688                       <span class="keywordflow">else</span>
<a name="l01689"></a>01689                         {
<a name="l01690"></a>01690                           <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#adaccc5857f1a5d5ca264ded0b8bfb986">vector_mult</a>(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>, *<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a7b52b6d7cf4f4f9245464050e876d21b">M_q_representor</a>[q_m][j]);
<a name="l01691"></a>01691                         }
<a name="l01692"></a>01692                       <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ad2d68b220943632bcb8327ca1b388eae">Aq_Mq_representor_norms</a>[q_a][q_m][i][j] =
<a name="l01693"></a>01693                         <a class="code" href="classlibMesh_1_1RBSystem.php#a9c8fb2a4cb5b77e59e36bfff438aed01">A_q_representor</a>[q_a][i]-&gt;dot(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>);
<a name="l01694"></a>01694 
<a name="l01695"></a>01695                       <span class="keywordflow">if</span>(i != j)
<a name="l01696"></a>01696                         {
<a name="l01697"></a>01697                           <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a>)
<a name="l01698"></a>01698                             {
<a name="l01699"></a>01699                               <a class="code" href="classlibMesh_1_1RBSystem.php#a330478ef4e1a158dc7b6f08530e10ff3">inner_product_matrix</a>-&gt;vector_mult(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>, *<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a7b52b6d7cf4f4f9245464050e876d21b">M_q_representor</a>[q_m][i]);
<a name="l01700"></a>01700                             }
<a name="l01701"></a>01701                           <span class="keywordflow">else</span>
<a name="l01702"></a>01702                             {
<a name="l01703"></a>01703                               <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#adaccc5857f1a5d5ca264ded0b8bfb986">vector_mult</a>(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>, *<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a7b52b6d7cf4f4f9245464050e876d21b">M_q_representor</a>[q_m][i]);
<a name="l01704"></a>01704                             }
<a name="l01705"></a>01705                           <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ad2d68b220943632bcb8327ca1b388eae">Aq_Mq_representor_norms</a>[q_a][q_m][j][i] =
<a name="l01706"></a>01706                             <a class="code" href="classlibMesh_1_1RBSystem.php#a9c8fb2a4cb5b77e59e36bfff438aed01">A_q_representor</a>[q_a][j]-&gt;dot(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>);
<a name="l01707"></a>01707                         }
<a name="l01708"></a>01708                     } <span class="comment">// end for q_m</span>
<a name="l01709"></a>01709                 } <span class="comment">// end for q_a</span>
<a name="l01710"></a>01710             } <span class="comment">// end for j</span>
<a name="l01711"></a>01711         } <span class="comment">// end for i</span>
<a name="l01712"></a>01712     } <span class="comment">// end if (compute_inner_products)</span>
<a name="l01713"></a>01713 
<a name="l01714"></a>01714   STOP_LOG(<span class="stringliteral">&quot;update_residual_terms()&quot;</span>, <span class="stringliteral">&quot;TransientRBSystem&quot;</span>);
<a name="l01715"></a>01715 }
<a name="l01716"></a>01716 
<a name="l01717"></a>01717 
<a name="l01718"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a465255c39194ff391528dfa0cff68995">01718</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a465255c39194ff391528dfa0cff68995">TransientRBSystem::update_RB_initial_condition_all_N</a>()
<a name="l01719"></a>01719 {
<a name="l01720"></a>01720   START_LOG(<span class="stringliteral">&quot;update_RB_initial_condition_all_N()&quot;</span>, <span class="stringliteral">&quot;TransientRBSystem&quot;</span>);
<a name="l01721"></a>01721 
<a name="l01722"></a>01722   <span class="comment">// Load the initial condition into the solution vector</span>
<a name="l01723"></a>01723   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ab455004dfc57c1a9454534ab1a761dbc">initialize_truth</a>();
<a name="l01724"></a>01724 
<a name="l01725"></a>01725   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt; NumericVector&lt;Number&gt;</a> &gt; temp1 = <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;::build</a>();
<a name="l01726"></a>01726   temp1-&gt;init (this-&gt;<a class="code" href="classlibMesh_1_1System.php#a90dbb901f00c14ff18399f4afabcebe5">n_dofs</a>(), this-&gt;<a class="code" href="classlibMesh_1_1System.php#ae3aeb82e65b06789823d41da3c5df7a2">n_local_dofs</a>(), <span class="keyword">false</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">libMeshEnums::PARALLEL</a>);
<a name="l01727"></a>01727 
<a name="l01728"></a>01728   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt; NumericVector&lt;Number&gt;</a> &gt; temp2 = <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;::build</a>();
<a name="l01729"></a>01729   temp2-&gt;init (this-&gt;<a class="code" href="classlibMesh_1_1System.php#a90dbb901f00c14ff18399f4afabcebe5">n_dofs</a>(), this-&gt;<a class="code" href="classlibMesh_1_1System.php#ae3aeb82e65b06789823d41da3c5df7a2">n_local_dofs</a>(), <span class="keyword">false</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">libMeshEnums::PARALLEL</a>);
<a name="l01730"></a>01730 
<a name="l01731"></a>01731 
<a name="l01732"></a>01732   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> RB_size = <a class="code" href="classlibMesh_1_1RBSystem.php#abfe6d67ed23243d225f12747f355f105">basis_functions</a>.size();
<a name="l01733"></a>01733 
<a name="l01734"></a>01734   <span class="comment">// First compute the right-hand side vector for the L2 projection</span>
<a name="l01735"></a>01735   <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a>)
<a name="l01736"></a>01736   {
<a name="l01737"></a>01737     <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a4e15721a62defb903900352ceb0ea367">L2_matrix</a>-&gt;vector_mult(*temp1, *<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>);
<a name="l01738"></a>01738   }
<a name="l01739"></a>01739   <span class="keywordflow">else</span>
<a name="l01740"></a>01740   {
<a name="l01741"></a>01741     <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a0ee3e3816d13aeae07fe5212dda5f521">assemble_L2_matrix</a>(<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>);
<a name="l01742"></a>01742     <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#adaccc5857f1a5d5ca264ded0b8bfb986">vector_mult</a>(*temp1, *<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>);
<a name="l01743"></a>01743   }
<a name="l01744"></a>01744 
<a name="l01745"></a>01745   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=(RB_size-<a class="code" href="classlibMesh_1_1RBSystem.php#a36ba489bd3158bbff48a5607e1d21d30">delta_N</a>); i&lt;RB_size; i++)
<a name="l01746"></a>01746   {
<a name="l01747"></a>01747     <a class="code" href="classlibMesh_1_1TransientRBSystem.php#aca06ad6a5b244bb6e8b76d53810e2eb6">RB_ic_proj_rhs_all_N</a>(i) = temp1-&gt;dot(*<a class="code" href="classlibMesh_1_1RBSystem.php#abfe6d67ed23243d225f12747f355f105">basis_functions</a>[i]);
<a name="l01748"></a>01748   }
<a name="l01749"></a>01749 
<a name="l01750"></a>01750 
<a name="l01751"></a>01751   <span class="comment">// Now compute the projection for each N</span>
<a name="l01752"></a>01752   <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Number&gt;</a> RB_L2_matrix_N;
<a name="l01753"></a>01753   <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> RB_rhs_N;
<a name="l01754"></a>01754   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N=(RB_size-<a class="code" href="classlibMesh_1_1RBSystem.php#a36ba489bd3158bbff48a5607e1d21d30">delta_N</a>); N&lt;RB_size; N++)
<a name="l01755"></a>01755   {
<a name="l01756"></a>01756     <span class="comment">// We have to index here by N+1 since the loop index is zero-based.</span>
<a name="l01757"></a>01757     <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a8cbf1f70128f7a173eb169aebd0f496e">RB_L2_matrix</a>.<a class="code" href="classlibMesh_1_1DenseMatrix.php#abf62d6b34b155876279d8db1564a6e14">get_principal_submatrix</a>(N+1, RB_L2_matrix_N);
<a name="l01758"></a>01758     
<a name="l01759"></a>01759     <a class="code" href="classlibMesh_1_1TransientRBSystem.php#aca06ad6a5b244bb6e8b76d53810e2eb6">RB_ic_proj_rhs_all_N</a>.<a class="code" href="classlibMesh_1_1DenseVector.php#aacfb5c2e5aee056320aaae4c9dd22a55">get_principal_subvector</a>(N+1, RB_rhs_N);
<a name="l01760"></a>01760 
<a name="l01761"></a>01761     <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> RB_ic_N(N+1);
<a name="l01762"></a>01762 
<a name="l01763"></a>01763     <span class="comment">// Now solve the linear system</span>
<a name="l01764"></a>01764     RB_L2_matrix_N.<a class="code" href="classlibMesh_1_1DenseMatrix.php#a878b9bf0a49000c70acecd55fdcf8d74">lu_solve</a>(RB_rhs_N, RB_ic_N);
<a name="l01765"></a>01765 
<a name="l01766"></a>01766     <span class="comment">// Load RB_ic_N into RB_initial_condition_all_N</span>
<a name="l01767"></a>01767     <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a4b802536cffba3d792caf8f95ed04327">RB_initial_condition_all_N</a>[N] = RB_ic_N;
<a name="l01768"></a>01768 
<a name="l01769"></a>01769     <span class="comment">// Compute the L2 error for the RB initial condition</span>
<a name="l01770"></a>01770     <span class="comment">// This part is dependent on the truth space.</span>
<a name="l01771"></a>01771 
<a name="l01772"></a>01772     <span class="comment">// load the RB solution into temp1</span>
<a name="l01773"></a>01773     temp1-&gt;zero();
<a name="l01774"></a>01774     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;N+1; i++)
<a name="l01775"></a>01775     {
<a name="l01776"></a>01776       temp1-&gt;add(RB_ic_N(i), *<a class="code" href="classlibMesh_1_1RBSystem.php#abfe6d67ed23243d225f12747f355f105">basis_functions</a>[i]);
<a name="l01777"></a>01777     }
<a name="l01778"></a>01778 
<a name="l01779"></a>01779     <span class="comment">// subtract truth initial condition from RB_ic_N</span>
<a name="l01780"></a>01780     temp1-&gt;add(-1., *<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>);
<a name="l01781"></a>01781 
<a name="l01782"></a>01782     <span class="comment">// Compute L2 norm error, i.e. sqrt(M(solution,solution))</span>
<a name="l01783"></a>01783     temp2-&gt;zero();
<a name="l01784"></a>01784     <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a>)
<a name="l01785"></a>01785     {
<a name="l01786"></a>01786       <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a4e15721a62defb903900352ceb0ea367">L2_matrix</a>-&gt;vector_mult(*temp2, *temp1);
<a name="l01787"></a>01787     }
<a name="l01788"></a>01788     <span class="keywordflow">else</span>
<a name="l01789"></a>01789     {
<a name="l01790"></a>01790       <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#adaccc5857f1a5d5ca264ded0b8bfb986">vector_mult</a>(*temp2, *temp1);
<a name="l01791"></a>01791     }
<a name="l01792"></a>01792     <a class="code" href="classlibMesh_1_1TransientRBSystem.php#aecf2610660c4023d6c993b4c08b64be4">initial_L2_error_all_N</a>[N] = <a class="code" href="namespacelibMesh.php#aea33cac176f18504c5c4078407aadbb7">libmesh_real</a>(std::sqrt(temp2-&gt;dot(*temp1)));
<a name="l01793"></a>01793   }
<a name="l01794"></a>01794 
<a name="l01795"></a>01795   STOP_LOG(<span class="stringliteral">&quot;update_RB_initial_condition_all_N()&quot;</span>, <span class="stringliteral">&quot;TransientRBSystem&quot;</span>);
<a name="l01796"></a>01796 }
<a name="l01797"></a>01797 
<a name="l01798"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a3fce0d07ebe196e79fd03727fef00c79">01798</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a3fce0d07ebe196e79fd03727fef00c79">TransientRBSystem::cache_online_residual_terms</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N)
<a name="l01799"></a>01799 {
<a name="l01800"></a>01800   START_LOG(<span class="stringliteral">&quot;cache_online_residual_terms()&quot;</span>, <span class="stringliteral">&quot;TransientRBSystem&quot;</span>);
<a name="l01801"></a>01801 
<a name="l01802"></a>01802   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a3c019c5db106e9a6bd6975094e847b9c">cached_Fq_term</a> = 0.;
<a name="l01803"></a>01803   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q=0;
<a name="l01804"></a>01804   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_f1=0; q_f1&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>(); q_f1++)
<a name="l01805"></a>01805   {
<a name="l01806"></a>01806     <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> cached_theta_q_f1 = <a class="code" href="classlibMesh_1_1RBSystem.php#a0fd951279c9b851ac38443156b4b18bd">eval_theta_q_f</a>(q_f1);
<a name="l01807"></a>01807     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_f2=q_f1; q_f2&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>(); q_f2++)
<a name="l01808"></a>01808     {
<a name="l01809"></a>01809       <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> delta = (q_f1==q_f2) ? 1. : 2.;
<a name="l01810"></a>01810       <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a3c019c5db106e9a6bd6975094e847b9c">cached_Fq_term</a> += delta*cached_theta_q_f1*<a class="code" href="classlibMesh_1_1RBSystem.php#a0fd951279c9b851ac38443156b4b18bd">eval_theta_q_f</a>(q_f2) * <a class="code" href="classlibMesh_1_1RBSystem.php#a567c86950bb6d2ab2800ac0b14ed3dd2">Fq_representor_norms</a>[q];
<a name="l01811"></a>01811 
<a name="l01812"></a>01812       q++;
<a name="l01813"></a>01813     }
<a name="l01814"></a>01814   }
<a name="l01815"></a>01815 
<a name="l01816"></a>01816   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a4a0ff2eb1b7fe0c2ab1fec1c4b7aa252">cached_Fq_Aq_vector</a>.<a class="code" href="classlibMesh_1_1DenseVector.php#a08430ae781094632e8272cbb825d4f44">resize</a>(N);
<a name="l01817"></a>01817   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_f=0; q_f&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>(); q_f++)
<a name="l01818"></a>01818   {
<a name="l01819"></a>01819     <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> cached_theta_q_f = <a class="code" href="classlibMesh_1_1RBSystem.php#a0fd951279c9b851ac38443156b4b18bd">eval_theta_q_f</a>(q_f);
<a name="l01820"></a>01820     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_a=0; q_a&lt;<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>(); q_a++)
<a name="l01821"></a>01821     {
<a name="l01822"></a>01822       <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> cached_theta_q_a = <a class="code" href="classlibMesh_1_1RBBase.php#aeeb46ce2b390bf820f954976ee9da7ce">eval_theta_q_a</a>(q_a);
<a name="l01823"></a>01823       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;N; i++)
<a name="l01824"></a>01824       {
<a name="l01825"></a>01825         <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a4a0ff2eb1b7fe0c2ab1fec1c4b7aa252">cached_Fq_Aq_vector</a>(i) += 2.*cached_theta_q_f*cached_theta_q_a*
<a name="l01826"></a>01826                                   <a class="code" href="classlibMesh_1_1RBSystem.php#ac3d546a3eaa362377494da087e711608">Fq_Aq_representor_norms</a>[q_f][q_a][i];
<a name="l01827"></a>01827       }
<a name="l01828"></a>01828     }
<a name="l01829"></a>01829   }
<a name="l01830"></a>01830 
<a name="l01831"></a>01831   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#abc8120b0ce4b87f07ea535c19a7400ac">cached_Aq_Aq_matrix</a>.<a class="code" href="classlibMesh_1_1DenseMatrix.php#ad967ca8d40990ed5cae9944a285a320d">resize</a>(N,N);
<a name="l01832"></a>01832   q=0;
<a name="l01833"></a>01833   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_a1=0; q_a1&lt;<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>(); q_a1++)
<a name="l01834"></a>01834   {
<a name="l01835"></a>01835     <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> cached_theta_q_a1 = <a class="code" href="classlibMesh_1_1RBBase.php#aeeb46ce2b390bf820f954976ee9da7ce">eval_theta_q_a</a>(q_a1);
<a name="l01836"></a>01836     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_a2=q_a1; q_a2&lt;<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>(); q_a2++)
<a name="l01837"></a>01837     {
<a name="l01838"></a>01838       <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> cached_theta_q_a2 = <a class="code" href="classlibMesh_1_1RBBase.php#aeeb46ce2b390bf820f954976ee9da7ce">eval_theta_q_a</a>(q_a2);
<a name="l01839"></a>01839       <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> delta = (q_a1==q_a2) ? 1. : 2.;
<a name="l01840"></a>01840 
<a name="l01841"></a>01841       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;N; i++)
<a name="l01842"></a>01842       {
<a name="l01843"></a>01843         <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;N; j++)
<a name="l01844"></a>01844         {
<a name="l01845"></a>01845           <a class="code" href="classlibMesh_1_1TransientRBSystem.php#abc8120b0ce4b87f07ea535c19a7400ac">cached_Aq_Aq_matrix</a>(i,j) += delta*
<a name="l01846"></a>01846                                       cached_theta_q_a1*cached_theta_q_a2*
<a name="l01847"></a>01847                                       <a class="code" href="classlibMesh_1_1RBSystem.php#a668fed2dcb2e98adb2e7eea5bc7d853e">Aq_Aq_representor_norms</a>[q][i][j];
<a name="l01848"></a>01848         }
<a name="l01849"></a>01849       }
<a name="l01850"></a>01850       q++;
<a name="l01851"></a>01851     }
<a name="l01852"></a>01852   }
<a name="l01853"></a>01853 
<a name="l01854"></a>01854   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a81be81cd8209898f489c7960019aa79d">cached_Fq_Mq_vector</a>.<a class="code" href="classlibMesh_1_1DenseVector.php#a08430ae781094632e8272cbb825d4f44">resize</a>(N);
<a name="l01855"></a>01855   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_f=0; q_f&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>(); q_f++)
<a name="l01856"></a>01856   {
<a name="l01857"></a>01857     <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> cached_theta_q_f = <a class="code" href="classlibMesh_1_1RBSystem.php#a0fd951279c9b851ac38443156b4b18bd">eval_theta_q_f</a>(q_f);
<a name="l01858"></a>01858     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_m=0; q_m&lt;<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>(); q_m++)
<a name="l01859"></a>01859     {
<a name="l01860"></a>01860       <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> cached_theta_q_m = <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a36a6aa3be4fb96b256cb9d664e5a2dfb">eval_theta_q_m</a>(q_m);
<a name="l01861"></a>01861       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;N; i++)
<a name="l01862"></a>01862       {
<a name="l01863"></a>01863         <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a81be81cd8209898f489c7960019aa79d">cached_Fq_Mq_vector</a>(i) += 2.*cached_theta_q_f * cached_theta_q_m * <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a400cfc38ee1a109d110230227d59b651">Fq_Mq_representor_norms</a>[q_f][q_m][i];
<a name="l01864"></a>01864       }
<a name="l01865"></a>01865     }
<a name="l01866"></a>01866   }
<a name="l01867"></a>01867 
<a name="l01868"></a>01868   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a2154a1b8d3da64df7dd0a9b6ac1dc3b2">cached_Aq_Mq_matrix</a>.<a class="code" href="classlibMesh_1_1DenseMatrix.php#ad967ca8d40990ed5cae9944a285a320d">resize</a>(N,N);
<a name="l01869"></a>01869   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_a=0; q_a&lt;<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>(); q_a++)
<a name="l01870"></a>01870   {
<a name="l01871"></a>01871     <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> cached_theta_q_a = <a class="code" href="classlibMesh_1_1RBBase.php#aeeb46ce2b390bf820f954976ee9da7ce">eval_theta_q_a</a>(q_a);
<a name="l01872"></a>01872     
<a name="l01873"></a>01873     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_m=0; q_m&lt;<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>(); q_m++)
<a name="l01874"></a>01874     {
<a name="l01875"></a>01875       <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> cached_theta_q_m = <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a36a6aa3be4fb96b256cb9d664e5a2dfb">eval_theta_q_m</a>(q_m);
<a name="l01876"></a>01876       
<a name="l01877"></a>01877       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;N; i++)
<a name="l01878"></a>01878       {
<a name="l01879"></a>01879         <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;N; j++)
<a name="l01880"></a>01880         {
<a name="l01881"></a>01881           <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a2154a1b8d3da64df7dd0a9b6ac1dc3b2">cached_Aq_Mq_matrix</a>(i,j) += 2.*cached_theta_q_a*cached_theta_q_m*<a class="code" href="classlibMesh_1_1TransientRBSystem.php#ad2d68b220943632bcb8327ca1b388eae">Aq_Mq_representor_norms</a>[q_a][q_m][i][j];
<a name="l01882"></a>01882         }
<a name="l01883"></a>01883       }
<a name="l01884"></a>01884     }
<a name="l01885"></a>01885   }
<a name="l01886"></a>01886   
<a name="l01887"></a>01887   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a4e532c8f9567060bc9a37ce06d7e2760">cached_Mq_Mq_matrix</a>.<a class="code" href="classlibMesh_1_1DenseMatrix.php#ad967ca8d40990ed5cae9944a285a320d">resize</a>(N,N);
<a name="l01888"></a>01888   q=0;
<a name="l01889"></a>01889   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_m1=0; q_m1&lt;<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>(); q_m1++)
<a name="l01890"></a>01890   {
<a name="l01891"></a>01891     <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> cached_theta_q_m1 = <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a36a6aa3be4fb96b256cb9d664e5a2dfb">eval_theta_q_m</a>(q_m1);
<a name="l01892"></a>01892     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_m2=q_m1; q_m2&lt;<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>(); q_m2++)
<a name="l01893"></a>01893     {
<a name="l01894"></a>01894       <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> cached_theta_q_m2 = <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a36a6aa3be4fb96b256cb9d664e5a2dfb">eval_theta_q_m</a>(q_m2);
<a name="l01895"></a>01895       <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> delta = (q_m1==q_m2) ? 1. : 2.;
<a name="l01896"></a>01896 
<a name="l01897"></a>01897       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;N; i++)
<a name="l01898"></a>01898       {
<a name="l01899"></a>01899         <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;N; j++)
<a name="l01900"></a>01900         {
<a name="l01901"></a>01901           <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a4e532c8f9567060bc9a37ce06d7e2760">cached_Mq_Mq_matrix</a>(i,j) += delta*
<a name="l01902"></a>01902                                       cached_theta_q_m1*cached_theta_q_m2*
<a name="l01903"></a>01903                                       <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a4ab78d5be55e56ba7170868428592f51">Mq_Mq_representor_norms</a>[q][i][j];
<a name="l01904"></a>01904         }
<a name="l01905"></a>01905       }
<a name="l01906"></a>01906       q++;
<a name="l01907"></a>01907     }
<a name="l01908"></a>01908   }
<a name="l01909"></a>01909   
<a name="l01910"></a>01910   STOP_LOG(<span class="stringliteral">&quot;cache_online_residual_terms()&quot;</span>, <span class="stringliteral">&quot;TransientRBSystem&quot;</span>);
<a name="l01911"></a>01911 }
<a name="l01912"></a>01912 
<a name="l01913"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#aa64721ef4384e8892eca0dca5c5e7774">01913</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#aa64721ef4384e8892eca0dca5c5e7774">TransientRBSystem::compute_residual_dual_norm</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N)
<a name="l01914"></a>01914 {
<a name="l01915"></a>01915   START_LOG(<span class="stringliteral">&quot;compute_residual_dual_norm()&quot;</span>, <span class="stringliteral">&quot;TransientRBSystem&quot;</span>);
<a name="l01916"></a>01916 
<a name="l01917"></a>01917   <span class="comment">// This assembly assumes we have already called cache_online_residual_terms</span>
<a name="l01918"></a>01918   <span class="comment">// and that the RB_solve parameter is constant in time</span>
<a name="l01919"></a>01919 
<a name="l01920"></a>01920   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a04397bf3cc20ccd2bb5056c22b45c9f5">dt</a> = <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ab5a283a3f305fd03ee1f8e25a5f11bbc">get_dt</a>();
<a name="l01921"></a>01921 
<a name="l01922"></a>01922   <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> RB_u_euler_theta(N);
<a name="l01923"></a>01923   <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> mass_coeffs(N);
<a name="l01924"></a>01924   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;N; i++)
<a name="l01925"></a>01925   {
<a name="l01926"></a>01926     RB_u_euler_theta(i)  = <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a5af426f9dc2b27772aef689c19fbf4b0">euler_theta</a>*<a class="code" href="classlibMesh_1_1RBSystem.php#a201af52facfa4da38bc636ee2cf41c67">RB_solution</a>(i) + (1.-<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a5af426f9dc2b27772aef689c19fbf4b0">euler_theta</a>)*<a class="code" href="classlibMesh_1_1TransientRBSystem.php#adbbe1db7bf9fd6a56b949147cd75d79f">old_RB_solution</a>(i);
<a name="l01927"></a>01927     mass_coeffs(i) = -(<a class="code" href="classlibMesh_1_1RBSystem.php#a201af52facfa4da38bc636ee2cf41c67">RB_solution</a>(i) - <a class="code" href="classlibMesh_1_1TransientRBSystem.php#adbbe1db7bf9fd6a56b949147cd75d79f">old_RB_solution</a>(i))/dt;
<a name="l01928"></a>01928   }
<a name="l01929"></a>01929 
<a name="l01930"></a>01930   <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> residual_norm_sq = <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a3c019c5db106e9a6bd6975094e847b9c">cached_Fq_term</a>;
<a name="l01931"></a>01931   
<a name="l01932"></a>01932   residual_norm_sq += RB_u_euler_theta.<a class="code" href="classlibMesh_1_1DenseVector.php#a740926ab2815bb507a1e33b659414be1">dot</a>(<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a4a0ff2eb1b7fe0c2ab1fec1c4b7aa252">cached_Fq_Aq_vector</a>);
<a name="l01933"></a>01933   residual_norm_sq += mass_coeffs.<a class="code" href="classlibMesh_1_1DenseVector.php#a740926ab2815bb507a1e33b659414be1">dot</a>(<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a81be81cd8209898f489c7960019aa79d">cached_Fq_Mq_vector</a>);
<a name="l01934"></a>01934 
<a name="l01935"></a>01935   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;N; i++)
<a name="l01936"></a>01936     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;N; j++)
<a name="l01937"></a>01937     {
<a name="l01938"></a>01938       residual_norm_sq += RB_u_euler_theta(i)*RB_u_euler_theta(j)*<a class="code" href="classlibMesh_1_1TransientRBSystem.php#abc8120b0ce4b87f07ea535c19a7400ac">cached_Aq_Aq_matrix</a>(i,j);
<a name="l01939"></a>01939       residual_norm_sq += mass_coeffs(i)*mass_coeffs(j)*<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a4e532c8f9567060bc9a37ce06d7e2760">cached_Mq_Mq_matrix</a>(i,j);
<a name="l01940"></a>01940       residual_norm_sq += RB_u_euler_theta(i)*mass_coeffs(j)*<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a2154a1b8d3da64df7dd0a9b6ac1dc3b2">cached_Aq_Mq_matrix</a>(i,j);
<a name="l01941"></a>01941     }
<a name="l01942"></a>01942 
<a name="l01943"></a>01943 
<a name="l01944"></a>01944   <span class="keywordflow">if</span>(<a class="code" href="namespacelibMesh.php#aea33cac176f18504c5c4078407aadbb7">libmesh_real</a>(residual_norm_sq) &lt; 0)
<a name="l01945"></a>01945   {
<a name="l01946"></a>01946     <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Warning: Square of residual norm is negative &quot;</span>
<a name="l01947"></a>01947                  &lt;&lt; <span class="stringliteral">&quot;in TransientRBSystem::compute_residual_dual_norm()&quot;</span> &lt;&lt; std::endl;
<a name="l01948"></a>01948 
<a name="l01949"></a>01949     <span class="comment">// Sometimes this is negative due to rounding error,</span>
<a name="l01950"></a>01950     <span class="comment">// but error is on the order of 1.e-10, so shouldn&#39;t</span>
<a name="l01951"></a>01951     <span class="comment">// affect result</span>
<a name="l01952"></a>01952 <span class="comment">//    libmesh_error();</span>
<a name="l01953"></a>01953      residual_norm_sq = std::abs(residual_norm_sq);
<a name="l01954"></a>01954   }
<a name="l01955"></a>01955 
<a name="l01956"></a>01956   STOP_LOG(<span class="stringliteral">&quot;compute_residual_dual_norm()&quot;</span>, <span class="stringliteral">&quot;TransientRBSystem&quot;</span>);
<a name="l01957"></a>01957 
<a name="l01958"></a>01958   <span class="keywordflow">return</span> <a class="code" href="namespacelibMesh.php#aea33cac176f18504c5c4078407aadbb7">libmesh_real</a>(std::sqrt( residual_norm_sq ));
<a name="l01959"></a>01959 }
<a name="l01960"></a>01960 
<a name="l01961"></a>01961 
<a name="l01962"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a10c5a6e0813561fffc80d4cea195e814">01962</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a10c5a6e0813561fffc80d4cea195e814">TransientRBSystem::uncached_compute_residual_dual_norm</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N)
<a name="l01963"></a>01963 {
<a name="l01964"></a>01964   START_LOG(<span class="stringliteral">&quot;uncached_compute_residual_dual_norm()&quot;</span>, <span class="stringliteral">&quot;TransientRBSystem&quot;</span>);
<a name="l01965"></a>01965 
<a name="l01966"></a>01966 <span class="comment">//   // This is the &quot;slow&quot; way of computing the residual, but it is useful</span>
<a name="l01967"></a>01967 <span class="comment">//   // for validating the &quot;fast&quot; way.</span>
<a name="l01968"></a>01968 <span class="comment">//   // Note that this only works in serial since otherwise each processor will</span>
<a name="l01969"></a>01969 <span class="comment">//   // have a different parameter value during the Greedy training.</span>
<a name="l01970"></a>01970 <span class="comment">//</span>
<a name="l01971"></a>01971 <span class="comment">//   // Assemble the right-hand side to find the Reisz representor</span>
<a name="l01972"></a>01972 <span class="comment">//   // of the residual in the X norm</span>
<a name="l01973"></a>01973 <span class="comment">//   AutoPtr&lt; NumericVector&lt;Number&gt; &gt; RB_sol = NumericVector&lt;Number&gt;::build();</span>
<a name="l01974"></a>01974 <span class="comment">//   RB_sol-&gt;init (this-&gt;n_dofs(), this-&gt;n_local_dofs(), false, libMeshEnums::PARALLEL);</span>
<a name="l01975"></a>01975 <span class="comment">//   RB_sol-&gt;zero();</span>
<a name="l01976"></a>01976 <span class="comment">//</span>
<a name="l01977"></a>01977 <span class="comment">//   AutoPtr&lt; NumericVector&lt;Number&gt; &gt; ghosted_temp = NumericVector&lt;Number&gt;::build();</span>
<a name="l01978"></a>01978 <span class="comment">//   ghosted_temp-&gt;init (this-&gt;n_dofs(), this-&gt;n_local_dofs(),</span>
<a name="l01979"></a>01979 <span class="comment">//                       this-&gt;get_dof_map().get_send_list(), false,</span>
<a name="l01980"></a>01980 <span class="comment">//                       GHOSTED);</span>
<a name="l01981"></a>01981 <span class="comment">//</span>
<a name="l01982"></a>01982 <span class="comment">//   AutoPtr&lt; NumericVector&lt;Number&gt; &gt; parallel_temp = NumericVector&lt;Number&gt;::build();</span>
<a name="l01983"></a>01983 <span class="comment">//   parallel_temp-&gt;init (this-&gt;n_dofs(), this-&gt;n_local_dofs(), false, libMeshEnums::PARALLEL);</span>
<a name="l01984"></a>01984 <span class="comment">//</span>
<a name="l01985"></a>01985 <span class="comment">//   // Store current_local_solution, since we don&#39;t want to corrupt it</span>
<a name="l01986"></a>01986 <span class="comment">//   *ghosted_temp = *current_local_solution;</span>
<a name="l01987"></a>01987 <span class="comment">//</span>
<a name="l01988"></a>01988 <span class="comment">//   for(unsigned int i=0; i&lt;N; i++)</span>
<a name="l01989"></a>01989 <span class="comment">//   {</span>
<a name="l01990"></a>01990 <span class="comment">//     RB_sol-&gt;add(RB_solution(i), *basis_functions[i]);</span>
<a name="l01991"></a>01991 <span class="comment">//     parallel_temp-&gt;add(old_RB_solution(i), *basis_functions[i]);</span>
<a name="l01992"></a>01992 <span class="comment">//   }</span>
<a name="l01993"></a>01993 <span class="comment">//</span>
<a name="l01994"></a>01994 <span class="comment">//   // Load parallel_temp into current_local_solution in order to do assembly</span>
<a name="l01995"></a>01995 <span class="comment">//   const std::vector&lt;unsigned int&gt;&amp; send_list = this-&gt;get_dof_map().get_send_list();</span>
<a name="l01996"></a>01996 <span class="comment">//   parallel_temp-&gt;localize (*current_local_solution, send_list);</span>
<a name="l01997"></a>01997 <span class="comment">//</span>
<a name="l01998"></a>01998 <span class="comment">//   // Load the system_matrix</span>
<a name="l01999"></a>01999 <span class="comment">//   this-&gt;truth_assembly();</span>
<a name="l02000"></a>02000 <span class="comment">//</span>
<a name="l02001"></a>02001 <span class="comment">//   // Restore current_local_solution</span>
<a name="l02002"></a>02002 <span class="comment">//   *current_local_solution = *ghosted_temp;</span>
<a name="l02003"></a>02003 <span class="comment">//</span>
<a name="l02004"></a>02004 <span class="comment">//   matrix-&gt;vector_mult(*parallel_temp, *RB_sol);</span>
<a name="l02005"></a>02005 <span class="comment">//   rhs-&gt;add(-1., *parallel_temp);</span>
<a name="l02006"></a>02006 <span class="comment">//   rhs-&gt;close();</span>
<a name="l02007"></a>02007 <span class="comment">//</span>
<a name="l02008"></a>02008 <span class="comment">//   zero_dirichlet_dofs_on_rhs();</span>
<a name="l02009"></a>02009 <span class="comment">//</span>
<a name="l02010"></a>02010 <span class="comment">//   // Then solve the system to get the Reisz representor</span>
<a name="l02011"></a>02011 <span class="comment">//   matrix-&gt;zero();</span>
<a name="l02012"></a>02012 <span class="comment">//   if(!low_memory_mode)</span>
<a name="l02013"></a>02013 <span class="comment">//   {</span>
<a name="l02014"></a>02014 <span class="comment">//     matrix-&gt;add(1., *inner_product_matrix);</span>
<a name="l02015"></a>02015 <span class="comment">//     if(constrained_problem)</span>
<a name="l02016"></a>02016 <span class="comment">//       matrix-&gt;add(1., *constraint_matrix);</span>
<a name="l02017"></a>02017 <span class="comment">//   }</span>
<a name="l02018"></a>02018 <span class="comment">//   else</span>
<a name="l02019"></a>02019 <span class="comment">//   {</span>
<a name="l02020"></a>02020 <span class="comment">//     assemble_inner_product_matrix(matrix);</span>
<a name="l02021"></a>02021 <span class="comment">//     if(constrained_problem)</span>
<a name="l02022"></a>02022 <span class="comment">//       add_scaled_matrix_and_vector(1., constraint_assembly, NULL, matrix, NULL);</span>
<a name="l02023"></a>02023 <span class="comment">//   }</span>
<a name="l02024"></a>02024 <span class="comment">//</span>
<a name="l02025"></a>02025 <span class="comment">//</span>
<a name="l02026"></a>02026 <span class="comment">//   solution-&gt;zero();</span>
<a name="l02027"></a>02027 <span class="comment">//   solve();</span>
<a name="l02028"></a>02028 <span class="comment">//   // Make sure we didn&#39;t max out the number of iterations</span>
<a name="l02029"></a>02029 <span class="comment">//   if( (this-&gt;n_linear_iterations() &gt;=</span>
<a name="l02030"></a>02030 <span class="comment">//        this-&gt;get_equation_systems().parameters.get&lt;unsigned int&gt;(&quot;linear solver maximum iterations&quot;)) &amp;&amp;</span>
<a name="l02031"></a>02031 <span class="comment">//       (this-&gt;final_linear_residual() &gt;</span>
<a name="l02032"></a>02032 <span class="comment">//        this-&gt;get_equation_systems().parameters.get&lt;Real&gt;(&quot;linear solver tolerance&quot;)) )</span>
<a name="l02033"></a>02033 <span class="comment">//   {</span>
<a name="l02034"></a>02034 <span class="comment">//     libMesh::out &lt;&lt; &quot;Warning: Linear solver may not have converged! Final linear residual = &quot;</span>
<a name="l02035"></a>02035 <span class="comment">//                  &lt;&lt; this-&gt;final_linear_residual() &lt;&lt; &quot;, number of iterations = &quot;</span>
<a name="l02036"></a>02036 <span class="comment">//                  &lt;&lt; this-&gt;n_linear_iterations() &lt;&lt; std::endl &lt;&lt; std::endl;</span>
<a name="l02037"></a>02037 <span class="comment">// //     libmesh_error();</span>
<a name="l02038"></a>02038 <span class="comment">//   }</span>
<a name="l02039"></a>02039 <span class="comment">//</span>
<a name="l02040"></a>02040 <span class="comment">//  if(!low_memory_mode)</span>
<a name="l02041"></a>02041 <span class="comment">//  {</span>
<a name="l02042"></a>02042 <span class="comment">//    inner_product_matrix-&gt;vector_mult(*inner_product_storage_vector, *solution);</span>
<a name="l02043"></a>02043 <span class="comment">//  }</span>
<a name="l02044"></a>02044 <span class="comment">//  else</span>
<a name="l02045"></a>02045 <span class="comment">//  {</span>
<a name="l02046"></a>02046 <span class="comment">//    assemble_inner_product_matrix(matrix);</span>
<a name="l02047"></a>02047 <span class="comment">//    matrix-&gt;vector_mult(*inner_product_storage_vector, *solution);</span>
<a name="l02048"></a>02048 <span class="comment">//  }</span>
<a name="l02049"></a>02049 <span class="comment">//</span>
<a name="l02050"></a>02050 <span class="comment">//  Real slow_residual_norm_sq = solution-&gt;dot(*inner_product_storage_vector);</span>
<a name="l02051"></a>02051 
<a name="l02052"></a>02052 
<a name="l02053"></a>02053 
<a name="l02054"></a>02054 
<a name="l02055"></a>02055 
<a name="l02056"></a>02056   <span class="comment">// Use the stored representor inner product values</span>
<a name="l02057"></a>02057   <span class="comment">// to evaluate the residual norm</span>
<a name="l02058"></a>02058 
<a name="l02059"></a>02059   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a04397bf3cc20ccd2bb5056c22b45c9f5">dt</a> = <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ab5a283a3f305fd03ee1f8e25a5f11bbc">get_dt</a>();
<a name="l02060"></a>02060 
<a name="l02061"></a>02061   std::vector&lt;Number&gt; RB_u_euler_theta(N);
<a name="l02062"></a>02062   std::vector&lt;Number&gt; mass_coeffs(N);
<a name="l02063"></a>02063   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;N; i++)
<a name="l02064"></a>02064   {
<a name="l02065"></a>02065     RB_u_euler_theta[i]  = <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a5af426f9dc2b27772aef689c19fbf4b0">euler_theta</a>*<a class="code" href="classlibMesh_1_1RBSystem.php#a201af52facfa4da38bc636ee2cf41c67">RB_solution</a>(i) + (1.-<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a5af426f9dc2b27772aef689c19fbf4b0">euler_theta</a>)*<a class="code" href="classlibMesh_1_1TransientRBSystem.php#adbbe1db7bf9fd6a56b949147cd75d79f">old_RB_solution</a>(i);
<a name="l02066"></a>02066     mass_coeffs[i] = -(<a class="code" href="classlibMesh_1_1RBSystem.php#a201af52facfa4da38bc636ee2cf41c67">RB_solution</a>(i) - <a class="code" href="classlibMesh_1_1TransientRBSystem.php#adbbe1db7bf9fd6a56b949147cd75d79f">old_RB_solution</a>(i))/dt;
<a name="l02067"></a>02067   }
<a name="l02068"></a>02068 
<a name="l02069"></a>02069   <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> residual_norm_sq = 0.;
<a name="l02070"></a>02070 
<a name="l02071"></a>02071   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q=0;
<a name="l02072"></a>02072   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_f1=0; q_f1&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>(); q_f1++)
<a name="l02073"></a>02073   {
<a name="l02074"></a>02074     <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> cached_theta_q_f1 = <a class="code" href="classlibMesh_1_1RBSystem.php#a0fd951279c9b851ac38443156b4b18bd">eval_theta_q_f</a>(q_f1);
<a name="l02075"></a>02075     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_f2=q_f1; q_f2&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>(); q_f2++)
<a name="l02076"></a>02076     {
<a name="l02077"></a>02077       <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> delta = (q_f1==q_f2) ? 1. : 2.;
<a name="l02078"></a>02078       residual_norm_sq += delta*cached_theta_q_f1*<a class="code" href="classlibMesh_1_1RBSystem.php#a0fd951279c9b851ac38443156b4b18bd">eval_theta_q_f</a>(q_f2) * <a class="code" href="classlibMesh_1_1RBSystem.php#a567c86950bb6d2ab2800ac0b14ed3dd2">Fq_representor_norms</a>[q];
<a name="l02079"></a>02079 
<a name="l02080"></a>02080       q++;
<a name="l02081"></a>02081     }
<a name="l02082"></a>02082   }
<a name="l02083"></a>02083 
<a name="l02084"></a>02084   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_f=0; q_f&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>(); q_f++)
<a name="l02085"></a>02085   {
<a name="l02086"></a>02086     <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> cached_theta_q_f = <a class="code" href="classlibMesh_1_1RBSystem.php#a0fd951279c9b851ac38443156b4b18bd">eval_theta_q_f</a>(q_f);
<a name="l02087"></a>02087     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_a=0; q_a&lt;<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>(); q_a++)
<a name="l02088"></a>02088     {
<a name="l02089"></a>02089       <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> cached_theta_q_a = <a class="code" href="classlibMesh_1_1RBBase.php#aeeb46ce2b390bf820f954976ee9da7ce">eval_theta_q_a</a>(q_a);
<a name="l02090"></a>02090       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;N; i++)
<a name="l02091"></a>02091       {
<a name="l02092"></a>02092         residual_norm_sq += 2.*RB_u_euler_theta[i]*cached_theta_q_f*cached_theta_q_a*
<a name="l02093"></a>02093                                <a class="code" href="classlibMesh_1_1RBSystem.php#ac3d546a3eaa362377494da087e711608">Fq_Aq_representor_norms</a>[q_f][q_a][i];
<a name="l02094"></a>02094       }
<a name="l02095"></a>02095     }
<a name="l02096"></a>02096   }
<a name="l02097"></a>02097 
<a name="l02098"></a>02098   q=0;
<a name="l02099"></a>02099   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_a1=0; q_a1&lt;<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>(); q_a1++)
<a name="l02100"></a>02100   {
<a name="l02101"></a>02101     <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> cached_theta_q_a1 = <a class="code" href="classlibMesh_1_1RBBase.php#aeeb46ce2b390bf820f954976ee9da7ce">eval_theta_q_a</a>(q_a1);
<a name="l02102"></a>02102     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_a2=q_a1; q_a2&lt;<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>(); q_a2++)
<a name="l02103"></a>02103     {
<a name="l02104"></a>02104       <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> cached_theta_q_a2 = <a class="code" href="classlibMesh_1_1RBBase.php#aeeb46ce2b390bf820f954976ee9da7ce">eval_theta_q_a</a>(q_a2);
<a name="l02105"></a>02105       <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> delta = (q_a1==q_a2) ? 1. : 2.;
<a name="l02106"></a>02106 
<a name="l02107"></a>02107       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;N; i++)
<a name="l02108"></a>02108       {
<a name="l02109"></a>02109         <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;N; j++)
<a name="l02110"></a>02110         {
<a name="l02111"></a>02111           residual_norm_sq += delta*RB_u_euler_theta[i]*RB_u_euler_theta[j]*
<a name="l02112"></a>02112                               cached_theta_q_a1*cached_theta_q_a2*
<a name="l02113"></a>02113                               <a class="code" href="classlibMesh_1_1RBSystem.php#a668fed2dcb2e98adb2e7eea5bc7d853e">Aq_Aq_representor_norms</a>[q][i][j];
<a name="l02114"></a>02114         }
<a name="l02115"></a>02115       }
<a name="l02116"></a>02116       q++;
<a name="l02117"></a>02117     }
<a name="l02118"></a>02118   }
<a name="l02119"></a>02119 
<a name="l02120"></a>02120   <span class="comment">// Now add the terms due to the time-derivative</span>
<a name="l02121"></a>02121   q=0;
<a name="l02122"></a>02122   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_m1=0; q_m1&lt;<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>(); q_m1++)
<a name="l02123"></a>02123   {
<a name="l02124"></a>02124     <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> cached_theta_q_m1 = <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a36a6aa3be4fb96b256cb9d664e5a2dfb">eval_theta_q_m</a>(q_m1);
<a name="l02125"></a>02125     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_m2=q_m1; q_m2&lt;<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>(); q_m2++)
<a name="l02126"></a>02126     {
<a name="l02127"></a>02127       <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> cached_theta_q_m2 = <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a36a6aa3be4fb96b256cb9d664e5a2dfb">eval_theta_q_m</a>(q_m2);
<a name="l02128"></a>02128       <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> delta = (q_m1==q_m2) ? 1. : 2.;
<a name="l02129"></a>02129 
<a name="l02130"></a>02130       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;N; i++)
<a name="l02131"></a>02131       {
<a name="l02132"></a>02132         <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;N; j++)
<a name="l02133"></a>02133         {
<a name="l02134"></a>02134           residual_norm_sq += delta*mass_coeffs[i]*mass_coeffs[j]*
<a name="l02135"></a>02135                               cached_theta_q_m1*cached_theta_q_m2*
<a name="l02136"></a>02136                               <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a4ab78d5be55e56ba7170868428592f51">Mq_Mq_representor_norms</a>[q][i][j];
<a name="l02137"></a>02137         }
<a name="l02138"></a>02138       }
<a name="l02139"></a>02139       q++;
<a name="l02140"></a>02140     }
<a name="l02141"></a>02141   }
<a name="l02142"></a>02142 
<a name="l02143"></a>02143   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_f=0; q_f&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>(); q_f++)
<a name="l02144"></a>02144   {
<a name="l02145"></a>02145     <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> cached_theta_q_f = <a class="code" href="classlibMesh_1_1RBSystem.php#a0fd951279c9b851ac38443156b4b18bd">eval_theta_q_f</a>(q_f);
<a name="l02146"></a>02146     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_m=0; q_m&lt;<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>(); q_m++)
<a name="l02147"></a>02147     {
<a name="l02148"></a>02148       <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> cached_theta_q_m = <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a36a6aa3be4fb96b256cb9d664e5a2dfb">eval_theta_q_m</a>(q_m);
<a name="l02149"></a>02149       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;N; i++)
<a name="l02150"></a>02150       {
<a name="l02151"></a>02151         residual_norm_sq += 2.*mass_coeffs[i]*cached_theta_q_f * cached_theta_q_m * <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a400cfc38ee1a109d110230227d59b651">Fq_Mq_representor_norms</a>[q_f][q_m][i];
<a name="l02152"></a>02152       }
<a name="l02153"></a>02153     }
<a name="l02154"></a>02154   }
<a name="l02155"></a>02155 
<a name="l02156"></a>02156   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_a=0; q_a&lt;<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>(); q_a++)
<a name="l02157"></a>02157   {
<a name="l02158"></a>02158     <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> cached_theta_q_a = <a class="code" href="classlibMesh_1_1RBBase.php#aeeb46ce2b390bf820f954976ee9da7ce">eval_theta_q_a</a>(q_a);
<a name="l02159"></a>02159     
<a name="l02160"></a>02160     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_m=0; q_m&lt;<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>(); q_m++)
<a name="l02161"></a>02161     {
<a name="l02162"></a>02162       <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> cached_theta_q_m = <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a36a6aa3be4fb96b256cb9d664e5a2dfb">eval_theta_q_m</a>(q_m);
<a name="l02163"></a>02163       
<a name="l02164"></a>02164       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;N; i++)
<a name="l02165"></a>02165       {
<a name="l02166"></a>02166         <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;N; j++)
<a name="l02167"></a>02167         {
<a name="l02168"></a>02168           residual_norm_sq += 2.*RB_u_euler_theta[i]*mass_coeffs[j]*
<a name="l02169"></a>02169                                          cached_theta_q_a*cached_theta_q_m*
<a name="l02170"></a>02170                                          <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ad2d68b220943632bcb8327ca1b388eae">Aq_Mq_representor_norms</a>[q_a][q_m][i][j];
<a name="l02171"></a>02171         }
<a name="l02172"></a>02172       }
<a name="l02173"></a>02173     }
<a name="l02174"></a>02174   }
<a name="l02175"></a>02175   
<a name="l02176"></a>02176   <span class="keywordflow">if</span>(<a class="code" href="namespacelibMesh.php#aea33cac176f18504c5c4078407aadbb7">libmesh_real</a>(residual_norm_sq) &lt; 0)
<a name="l02177"></a>02177   {
<a name="l02178"></a>02178     <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Warning: Square of residual norm is negative &quot;</span>
<a name="l02179"></a>02179                  &lt;&lt; <span class="stringliteral">&quot;in TransientRBSystem::compute_residual_dual_norm()&quot;</span> &lt;&lt; std::endl;
<a name="l02180"></a>02180 
<a name="l02181"></a>02181     <span class="comment">// Sometimes this is negative due to rounding error,</span>
<a name="l02182"></a>02182     <span class="comment">// but error is on the order of 1.e-10, so shouldn&#39;t</span>
<a name="l02183"></a>02183     <span class="comment">// affect result</span>
<a name="l02184"></a>02184 <span class="comment">//    libmesh_error();</span>
<a name="l02185"></a>02185      residual_norm_sq = std::abs(residual_norm_sq);
<a name="l02186"></a>02186   }
<a name="l02187"></a>02187 
<a name="l02188"></a>02188 <span class="comment">//   libMesh::out &lt;&lt; &quot;slow residual_sq = &quot; &lt;&lt; slow_residual_norm_sq</span>
<a name="l02189"></a>02189 <span class="comment">//                &lt;&lt; &quot;, fast residual_sq = &quot; &lt;&lt; residual_norm_sq &lt;&lt; std::endl;</span>
<a name="l02190"></a>02190 
<a name="l02191"></a>02191   STOP_LOG(<span class="stringliteral">&quot;uncached_compute_residual_dual_norm()&quot;</span>, <span class="stringliteral">&quot;TransientRBSystem&quot;</span>);
<a name="l02192"></a>02192 
<a name="l02193"></a>02193   <span class="keywordflow">return</span> <a class="code" href="namespacelibMesh.php#aea33cac176f18504c5c4078407aadbb7">libmesh_real</a>(std::sqrt( residual_norm_sq ));
<a name="l02194"></a>02194 }
<a name="l02195"></a>02195 
<a name="l02196"></a>02196 
<a name="l02197"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a2616deed6f2ad941535bcaf7fb9505a5">02197</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a2616deed6f2ad941535bcaf7fb9505a5">TransientRBSystem::write_offline_data_to_files</a>(<span class="keyword">const</span> std::string&amp; directory_name)
<a name="l02198"></a>02198 {
<a name="l02199"></a>02199   START_LOG(<span class="stringliteral">&quot;write_offline_data_to_files()&quot;</span>, <span class="stringliteral">&quot;TransientRBSystem&quot;</span>);
<a name="l02200"></a>02200 
<a name="l02201"></a>02201   <a class="code" href="classlibMesh_1_1RBSystem.php#a9382ee8b327d3e7db7e867d9cfb24fc2">Parent::write_offline_data_to_files</a>(directory_name);
<a name="l02202"></a>02202 
<a name="l02203"></a>02203   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_bfs = <a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>();
<a name="l02204"></a>02204   libmesh_assert( n_bfs &lt;= <a class="code" href="classlibMesh_1_1RBSystem.php#ab47d6a963c4f68b5a3d1eea7905257f5">Nmax</a> );
<a name="l02205"></a>02205 
<a name="l02206"></a>02206   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> precision_level = 14;
<a name="l02207"></a>02207 
<a name="l02208"></a>02208   <span class="keywordflow">if</span>(<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l02209"></a>02209   {
<a name="l02210"></a>02210     <span class="comment">// Write out the L2 matrix</span>
<a name="l02211"></a>02211     std::ofstream RB_L2_matrix_out;
<a name="l02212"></a>02212     {
<a name="l02213"></a>02213       <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l02214"></a>02214       file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/RB_L2_matrix.dat&quot;</span>;
<a name="l02215"></a>02215       RB_L2_matrix_out.open(file_name.str().c_str());
<a name="l02216"></a>02216     }
<a name="l02217"></a>02217     RB_L2_matrix_out.precision(precision_level);
<a name="l02218"></a>02218     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_bfs; i++)
<a name="l02219"></a>02219     {
<a name="l02220"></a>02220       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;n_bfs; j++)
<a name="l02221"></a>02221       {
<a name="l02222"></a>02222         RB_L2_matrix_out &lt;&lt; std::scientific &lt;&lt; <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a8cbf1f70128f7a173eb169aebd0f496e">RB_L2_matrix</a>(i,j) &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l02223"></a>02223       }
<a name="l02224"></a>02224     }
<a name="l02225"></a>02225     RB_L2_matrix_out.close();
<a name="l02226"></a>02226           
<a name="l02227"></a>02227     <span class="comment">// Write out the M_q matrices</span>
<a name="l02228"></a>02228     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_m=0; q_m&lt;<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>(); q_m++)
<a name="l02229"></a>02229     {
<a name="l02230"></a>02230       <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l02231"></a>02231       file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/RB_M_&quot;</span>;
<a name="l02232"></a>02232       OSSRealzeroright(file_name,3,0,q_m);
<a name="l02233"></a>02233       file_name &lt;&lt; <span class="stringliteral">&quot;.dat&quot;</span>;
<a name="l02234"></a>02234       std::ofstream RB_M_q_m_out(file_name.str().c_str());
<a name="l02235"></a>02235 
<a name="l02236"></a>02236       <span class="keywordflow">if</span> ( !RB_M_q_m_out.good() )
<a name="l02237"></a>02237       {
<a name="l02238"></a>02238         <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening RB_M_&quot;</span> &lt;&lt; q_m &lt;&lt; <span class="stringliteral">&quot;.dat&quot;</span> &lt;&lt; std::endl;
<a name="l02239"></a>02239         libmesh_error();
<a name="l02240"></a>02240       }
<a name="l02241"></a>02241 
<a name="l02242"></a>02242       RB_M_q_m_out.precision(precision_level);
<a name="l02243"></a>02243       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_bfs; i++)
<a name="l02244"></a>02244       {
<a name="l02245"></a>02245         <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;n_bfs; j++)
<a name="l02246"></a>02246         {
<a name="l02247"></a>02247           RB_M_q_m_out &lt;&lt; std::scientific &lt;&lt; <a class="code" href="classlibMesh_1_1TransientRBSystem.php#aae9cbd15df988bcdf5cf2db5fcb24e5b">RB_M_q_vector</a>[q_m](i,j) &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l02248"></a>02248         }
<a name="l02249"></a>02249       }
<a name="l02250"></a>02250       RB_M_q_m_out.close();
<a name="l02251"></a>02251     }
<a name="l02252"></a>02252 
<a name="l02253"></a>02253     <span class="comment">// Write out the initial condition data</span>
<a name="l02254"></a>02254     <span class="comment">// and the initial L2 error for all N</span>
<a name="l02255"></a>02255     std::ofstream initial_conditions_out;
<a name="l02256"></a>02256     {
<a name="l02257"></a>02257       <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l02258"></a>02258       file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/initial_conditions.dat&quot;</span>;
<a name="l02259"></a>02259       initial_conditions_out.open(file_name.str().c_str());
<a name="l02260"></a>02260     }
<a name="l02261"></a>02261     std::ofstream initial_L2_error_out;
<a name="l02262"></a>02262     {
<a name="l02263"></a>02263       <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l02264"></a>02264       file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/initial_L2_error.dat&quot;</span>;
<a name="l02265"></a>02265       initial_L2_error_out.open(file_name.str().c_str());
<a name="l02266"></a>02266     }
<a name="l02267"></a>02267     <span class="keywordflow">if</span> (!initial_conditions_out.good() || !initial_L2_error_out.good())
<a name="l02268"></a>02268     {
<a name="l02269"></a>02269       <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening initial conditions output files&quot;</span> &lt;&lt; std::endl;
<a name="l02270"></a>02270       libmesh_error();
<a name="l02271"></a>02271     }
<a name="l02272"></a>02272 
<a name="l02273"></a>02273     initial_conditions_out.precision(precision_level);
<a name="l02274"></a>02274     initial_L2_error_out.precision(precision_level);
<a name="l02275"></a>02275 
<a name="l02276"></a>02276     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_bfs; i++)
<a name="l02277"></a>02277     {
<a name="l02278"></a>02278       initial_L2_error_out &lt;&lt; <a class="code" href="classlibMesh_1_1TransientRBSystem.php#aecf2610660c4023d6c993b4c08b64be4">initial_L2_error_all_N</a>[i] &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l02279"></a>02279       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;=i; j++)
<a name="l02280"></a>02280       {
<a name="l02281"></a>02281         initial_conditions_out &lt;&lt; std::scientific &lt;&lt; <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a4b802536cffba3d792caf8f95ed04327">RB_initial_condition_all_N</a>[i](j) &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l02282"></a>02282       }
<a name="l02283"></a>02283     }
<a name="l02284"></a>02284     initial_conditions_out.close();
<a name="l02285"></a>02285     initial_L2_error_out.close();
<a name="l02286"></a>02286 
<a name="l02287"></a>02287     <span class="comment">// Next write out the Fq_Mq representor norm data</span>
<a name="l02288"></a>02288     std::ofstream RB_Fq_Mq_norms_out;
<a name="l02289"></a>02289     {
<a name="l02290"></a>02290       <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l02291"></a>02291       file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/Fq_Mq_norms.dat&quot;</span>;
<a name="l02292"></a>02292       RB_Fq_Mq_norms_out.open(file_name.str().c_str());
<a name="l02293"></a>02293     }
<a name="l02294"></a>02294     <span class="keywordflow">if</span> ( !RB_Fq_Mq_norms_out.good() )
<a name="l02295"></a>02295     {
<a name="l02296"></a>02296       <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening Fq_Mq_norms.dat&quot;</span> &lt;&lt; std::endl;
<a name="l02297"></a>02297       libmesh_error();
<a name="l02298"></a>02298     }
<a name="l02299"></a>02299     RB_Fq_Mq_norms_out.precision(precision_level);
<a name="l02300"></a>02300     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_f=0; q_f&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>(); q_f++)
<a name="l02301"></a>02301     {
<a name="l02302"></a>02302       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_m=0; q_m&lt;<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>(); q_m++)
<a name="l02303"></a>02303       {
<a name="l02304"></a>02304         <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_bfs; i++)
<a name="l02305"></a>02305         {
<a name="l02306"></a>02306           RB_Fq_Mq_norms_out &lt;&lt; std::scientific &lt;&lt; <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a400cfc38ee1a109d110230227d59b651">Fq_Mq_representor_norms</a>[q_f][q_m][i] &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l02307"></a>02307         }
<a name="l02308"></a>02308       }
<a name="l02309"></a>02309     }
<a name="l02310"></a>02310     RB_Fq_Mq_norms_out.close();
<a name="l02311"></a>02311 
<a name="l02312"></a>02312     <span class="comment">// Next write out the Mq_Mq representor norm data</span>
<a name="l02313"></a>02313     std::ofstream RB_Mq_Mq_norms_out;
<a name="l02314"></a>02314     {
<a name="l02315"></a>02315       <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l02316"></a>02316       file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/Mq_Mq_norms.dat&quot;</span>;
<a name="l02317"></a>02317       RB_Mq_Mq_norms_out.open(file_name.str().c_str());
<a name="l02318"></a>02318     }
<a name="l02319"></a>02319     <span class="keywordflow">if</span> ( !RB_Mq_Mq_norms_out.good() )
<a name="l02320"></a>02320     {
<a name="l02321"></a>02321       <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening RB_Mq_Mq_norms_out.dat&quot;</span> &lt;&lt; std::endl;
<a name="l02322"></a>02322       libmesh_error();
<a name="l02323"></a>02323     }
<a name="l02324"></a>02324     RB_Mq_Mq_norms_out.precision(precision_level);
<a name="l02325"></a>02325     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Q_m_hat = <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>()*(<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>()+1)/2;
<a name="l02326"></a>02326     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q=0; q&lt;Q_m_hat; q++)
<a name="l02327"></a>02327     {
<a name="l02328"></a>02328       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_bfs; i++)
<a name="l02329"></a>02329       {
<a name="l02330"></a>02330         <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;n_bfs; j++)
<a name="l02331"></a>02331         {
<a name="l02332"></a>02332           RB_Mq_Mq_norms_out &lt;&lt; std::scientific &lt;&lt; <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a4ab78d5be55e56ba7170868428592f51">Mq_Mq_representor_norms</a>[q][i][j] &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l02333"></a>02333         }
<a name="l02334"></a>02334       }
<a name="l02335"></a>02335     }
<a name="l02336"></a>02336     RB_Mq_Mq_norms_out.close();
<a name="l02337"></a>02337 
<a name="l02338"></a>02338     <span class="comment">// Next write out the Aq_Mq representor norm data</span>
<a name="l02339"></a>02339     std::ofstream RB_Aq_Mq_norms_out;
<a name="l02340"></a>02340     {
<a name="l02341"></a>02341       <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l02342"></a>02342       file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/Aq_Mq_norms.dat&quot;</span>;
<a name="l02343"></a>02343       RB_Aq_Mq_norms_out.open(file_name.str().c_str());
<a name="l02344"></a>02344     }
<a name="l02345"></a>02345     <span class="keywordflow">if</span> ( !RB_Aq_Mq_norms_out.good() )
<a name="l02346"></a>02346     {
<a name="l02347"></a>02347       <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening Aq_Mq_norms.dat&quot;</span> &lt;&lt; std::endl;
<a name="l02348"></a>02348       libmesh_error();
<a name="l02349"></a>02349     }
<a name="l02350"></a>02350     RB_Aq_Mq_norms_out.precision(precision_level);
<a name="l02351"></a>02351     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_a=0; q_a&lt;<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>(); q_a++)
<a name="l02352"></a>02352     {
<a name="l02353"></a>02353       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_m=0; q_m&lt;<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>(); q_m++)
<a name="l02354"></a>02354       {
<a name="l02355"></a>02355         <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_bfs; i++)
<a name="l02356"></a>02356         {
<a name="l02357"></a>02357           <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;n_bfs; j++)
<a name="l02358"></a>02358           {
<a name="l02359"></a>02359             RB_Aq_Mq_norms_out &lt;&lt; std::scientific &lt;&lt; <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ad2d68b220943632bcb8327ca1b388eae">Aq_Mq_representor_norms</a>[q_a][q_m][i][j] &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l02360"></a>02360           }
<a name="l02361"></a>02361         }
<a name="l02362"></a>02362       }
<a name="l02363"></a>02363     }
<a name="l02364"></a>02364     RB_Aq_Mq_norms_out.close();
<a name="l02365"></a>02365   }
<a name="l02366"></a>02366 
<a name="l02367"></a>02367   <span class="comment">// Write out the residual representors to file if requested</span>
<a name="l02368"></a>02368   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1RBSystem.php#a5ac870aac52f838bd28ee088ddc095b0">store_representors</a>)
<a name="l02369"></a>02369     {
<a name="l02370"></a>02370       <span class="comment">// Write out the M_q_representors.  These are useful to have when restarting,</span>
<a name="l02371"></a>02371       <span class="comment">// so you don&#39;t have to recompute them all over again.  There should be</span>
<a name="l02372"></a>02372       <span class="comment">// this-&gt;get_n_basis_functions() of these.</span>
<a name="l02373"></a>02373       <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Writing out the M_q_representors...&quot;</span> &lt;&lt; std::endl;
<a name="l02374"></a>02374 
<a name="l02375"></a>02375       std::ostringstream file_name;
<a name="l02376"></a>02376       <span class="keyword">const</span> std::string residual_representor_suffix = (<a class="code" href="classlibMesh_1_1RBSystem.php#a399f7ee60adcc350ce7f27e8c60ed9de">write_binary_residual_representors</a> ? <span class="stringliteral">&quot;.xdr&quot;</span> : <span class="stringliteral">&quot;.dat&quot;</span>);
<a name="l02377"></a>02377 
<a name="l02378"></a>02378       <span class="comment">// Residual representors written out to their own separate directory</span>
<a name="l02379"></a>02379       std::string residual_representors_dir = <span class="stringliteral">&quot;residual_representors&quot;</span>;
<a name="l02380"></a>02380 
<a name="l02381"></a>02381       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> istop  = this-&gt;<a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>();
<a name="l02382"></a>02382       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> istart = istop-<a class="code" href="classlibMesh_1_1RBSystem.php#a36ba489bd3158bbff48a5607e1d21d30">delta_N</a>;
<a name="l02383"></a>02383 
<a name="l02384"></a>02384       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q=0; q&lt;<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a7b52b6d7cf4f4f9245464050e876d21b">M_q_representor</a>.size(); ++q)
<a name="l02385"></a>02385         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=istart; i&lt;istop; ++i)
<a name="l02386"></a>02386         {
<a name="l02387"></a>02387           <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Writing out M_q_representor[&quot;</span> &lt;&lt; q &lt;&lt; <span class="stringliteral">&quot;][&quot;</span> &lt;&lt; i &lt;&lt; <span class="stringliteral">&quot;]...&quot;</span> &lt;&lt; std::endl;
<a name="l02388"></a>02388           libmesh_assert(<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a7b52b6d7cf4f4f9245464050e876d21b">M_q_representor</a>[q][i] != NULL);
<a name="l02389"></a>02389 
<a name="l02390"></a>02390           file_name.str(<span class="stringliteral">&quot;&quot;</span>); <span class="comment">// reset filename</span>
<a name="l02391"></a>02391           file_name &lt;&lt; residual_representors_dir &lt;&lt; <span class="stringliteral">&quot;/M_q_representor&quot;</span> &lt;&lt; i &lt;&lt; residual_representor_suffix;
<a name="l02392"></a>02392 
<a name="l02393"></a>02393           {
<a name="l02394"></a>02394             <span class="comment">// No need to copy!</span>
<a name="l02395"></a>02395             <span class="comment">//*solution = *(M_q_representor[q][i]);</span>
<a name="l02396"></a>02396             <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a7b52b6d7cf4f4f9245464050e876d21b">M_q_representor</a>[q][i]-&gt;swap(*<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>);
<a name="l02397"></a>02397 
<a name="l02398"></a>02398             <a class="code" href="classlibMesh_1_1Xdr.php">Xdr</a> mr_data(file_name.str(),
<a name="l02399"></a>02399                         <a class="code" href="classlibMesh_1_1RBSystem.php#a399f7ee60adcc350ce7f27e8c60ed9de">write_binary_residual_representors</a> ? <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8ae5559170d41d912b449375bb4e3468f6">ENCODE</a> : <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a47f4bcd4fcf418da5ec74d3d8e2c3bc4">WRITE</a>);
<a name="l02400"></a>02400 
<a name="l02401"></a>02401             <a class="code" href="classlibMesh_1_1System.php#ae8063c135acc9c54240886e1ac3c9acd">write_serialized_data</a>(mr_data, <span class="keyword">false</span>);
<a name="l02402"></a>02402 
<a name="l02403"></a>02403             <span class="comment">// Synchronize before moving on</span>
<a name="l02404"></a>02404             <a class="code" href="namespacelibMesh_1_1Parallel.php#a95416053432ed0ab6d1231070bfebeff">Parallel::barrier</a>();
<a name="l02405"></a>02405 
<a name="l02406"></a>02406             <span class="comment">// Swap back.</span>
<a name="l02407"></a>02407             <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a7b52b6d7cf4f4f9245464050e876d21b">M_q_representor</a>[q][i]-&gt;swap(*<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>);
<a name="l02408"></a>02408 
<a name="l02409"></a>02409             <span class="comment">// TODO: bzip the resulting file?  See $LIBMESH_DIR/src/mesh/unstructured_mesh.C</span>
<a name="l02410"></a>02410             <span class="comment">// for the system call, be sure to do it only on one processor, etc.</span>
<a name="l02411"></a>02411           }
<a name="l02412"></a>02412         }
<a name="l02413"></a>02413     } <span class="comment">// end if store_representors</span>
<a name="l02414"></a>02414 
<a name="l02415"></a>02415   STOP_LOG(<span class="stringliteral">&quot;write_offline_data_to_files()&quot;</span>, <span class="stringliteral">&quot;TransientRBSystem&quot;</span>);
<a name="l02416"></a>02416 }
<a name="l02417"></a>02417 
<a name="l02418"></a>02418 
<a name="l02419"></a>02419 
<a name="l02420"></a>02420 
<a name="l02421"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a8d0eb6348fd67e5a619279fbdf41fa62">02421</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a8d0eb6348fd67e5a619279fbdf41fa62">TransientRBSystem::read_offline_data_from_files</a>(<span class="keyword">const</span> std::string&amp; directory_name)
<a name="l02422"></a>02422 {
<a name="l02423"></a>02423   START_LOG(<span class="stringliteral">&quot;read_offline_data_from_files()&quot;</span>, <span class="stringliteral">&quot;TransientRBSystem&quot;</span>);
<a name="l02424"></a>02424 
<a name="l02425"></a>02425   <a class="code" href="classlibMesh_1_1RBSystem.php#ad32589e604ce7562cc256741e87d7d3c">Parent::read_offline_data_from_files</a>(directory_name);
<a name="l02426"></a>02426 
<a name="l02427"></a>02427   <span class="comment">// First, find out how many basis functions we had when Greedy terminated</span>
<a name="l02428"></a>02428   <span class="comment">// This was set in RBSystem::read_offline_data_from_files</span>
<a name="l02429"></a>02429   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_bfs = this-&gt;<a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>();
<a name="l02430"></a>02430   
<a name="l02431"></a>02431   std::ifstream RB_L2_matrix_in;
<a name="l02432"></a>02432   {
<a name="l02433"></a>02433     <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l02434"></a>02434     file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/RB_L2_matrix.dat&quot;</span>;
<a name="l02435"></a>02435     RB_L2_matrix_in.open(file_name.str().c_str());
<a name="l02436"></a>02436   }
<a name="l02437"></a>02437   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_bfs; i++)
<a name="l02438"></a>02438   {
<a name="l02439"></a>02439     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;n_bfs; j++)
<a name="l02440"></a>02440     {
<a name="l02441"></a>02441       <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> value;
<a name="l02442"></a>02442       RB_L2_matrix_in &gt;&gt; value;
<a name="l02443"></a>02443       <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a8cbf1f70128f7a173eb169aebd0f496e">RB_L2_matrix</a>(i,j) = value;
<a name="l02444"></a>02444     }
<a name="l02445"></a>02445   }
<a name="l02446"></a>02446   RB_L2_matrix_in.close();
<a name="l02447"></a>02447 
<a name="l02448"></a>02448   <span class="comment">// Read in the M_q matrices</span>
<a name="l02449"></a>02449   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_m=0; q_m&lt;<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>(); q_m++)
<a name="l02450"></a>02450   {
<a name="l02451"></a>02451     <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l02452"></a>02452     file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/RB_M_&quot;</span>;
<a name="l02453"></a>02453     OSSRealzeroright(file_name,3,0,q_m);
<a name="l02454"></a>02454     file_name &lt;&lt; <span class="stringliteral">&quot;.dat&quot;</span>;
<a name="l02455"></a>02455     std::ifstream RB_M_q_m_in(file_name.str().c_str());
<a name="l02456"></a>02456 
<a name="l02457"></a>02457     <span class="keywordflow">if</span> ( !RB_M_q_m_in.good() )
<a name="l02458"></a>02458     {
<a name="l02459"></a>02459       <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening RB_M_&quot;</span> &lt;&lt; q_m &lt;&lt; <span class="stringliteral">&quot;.dat&quot;</span> &lt;&lt; std::endl;
<a name="l02460"></a>02460       libmesh_error();
<a name="l02461"></a>02461     }
<a name="l02462"></a>02462 
<a name="l02463"></a>02463     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_bfs; i++)
<a name="l02464"></a>02464     {
<a name="l02465"></a>02465       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;n_bfs; j++)
<a name="l02466"></a>02466       {
<a name="l02467"></a>02467         <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> value;
<a name="l02468"></a>02468         RB_M_q_m_in &gt;&gt; value;
<a name="l02469"></a>02469         <a class="code" href="classlibMesh_1_1TransientRBSystem.php#aae9cbd15df988bcdf5cf2db5fcb24e5b">RB_M_q_vector</a>[q_m](i,j) = value;
<a name="l02470"></a>02470       }
<a name="l02471"></a>02471     }
<a name="l02472"></a>02472     RB_M_q_m_in.close();
<a name="l02473"></a>02473   }
<a name="l02474"></a>02474 
<a name="l02475"></a>02475 
<a name="l02476"></a>02476   <span class="comment">// Read in the initial condition data</span>
<a name="l02477"></a>02477   <span class="comment">// and the initial L2 error for all N</span>
<a name="l02478"></a>02478   std::ifstream initial_conditions_in;
<a name="l02479"></a>02479   {
<a name="l02480"></a>02480     <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l02481"></a>02481     file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/initial_conditions.dat&quot;</span>;
<a name="l02482"></a>02482     initial_conditions_in.open(file_name.str().c_str());
<a name="l02483"></a>02483   }
<a name="l02484"></a>02484   std::ifstream initial_L2_error_in;
<a name="l02485"></a>02485   {
<a name="l02486"></a>02486     <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l02487"></a>02487     file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/initial_L2_error.dat&quot;</span>;
<a name="l02488"></a>02488     initial_L2_error_in.open(file_name.str().c_str());
<a name="l02489"></a>02489   }
<a name="l02490"></a>02490   <span class="keywordflow">if</span> (!initial_conditions_in.good() || !initial_L2_error_in.good())
<a name="l02491"></a>02491   {
<a name="l02492"></a>02492     <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening initial conditions output files&quot;</span> &lt;&lt; std::endl;
<a name="l02493"></a>02493     libmesh_error();
<a name="l02494"></a>02494   }
<a name="l02495"></a>02495 
<a name="l02496"></a>02496   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_bfs; i++)
<a name="l02497"></a>02497   {
<a name="l02498"></a>02498     initial_L2_error_in &gt;&gt; <a class="code" href="classlibMesh_1_1TransientRBSystem.php#aecf2610660c4023d6c993b4c08b64be4">initial_L2_error_all_N</a>[i];
<a name="l02499"></a>02499     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;=i; j++)
<a name="l02500"></a>02500     {
<a name="l02501"></a>02501       initial_conditions_in &gt;&gt; <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a4b802536cffba3d792caf8f95ed04327">RB_initial_condition_all_N</a>[i](j);
<a name="l02502"></a>02502     }
<a name="l02503"></a>02503   }
<a name="l02504"></a>02504   initial_conditions_in.close();
<a name="l02505"></a>02505   initial_L2_error_in.close();
<a name="l02506"></a>02506 
<a name="l02507"></a>02507   <span class="comment">// Next read in the Fq_Mq representor norm data</span>
<a name="l02508"></a>02508   std::ifstream RB_Fq_Mq_norms_in;
<a name="l02509"></a>02509   {
<a name="l02510"></a>02510     <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l02511"></a>02511     file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/Fq_Mq_norms.dat&quot;</span>;
<a name="l02512"></a>02512     RB_Fq_Mq_norms_in.open(file_name.str().c_str());
<a name="l02513"></a>02513   }
<a name="l02514"></a>02514   <span class="keywordflow">if</span> ( !RB_Fq_Mq_norms_in.good() )
<a name="l02515"></a>02515   {
<a name="l02516"></a>02516     <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening Fq_Mq_norms.dat&quot;</span> &lt;&lt; std::endl;
<a name="l02517"></a>02517     libmesh_error();
<a name="l02518"></a>02518   }
<a name="l02519"></a>02519   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_f=0; q_f&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>(); q_f++)
<a name="l02520"></a>02520   {
<a name="l02521"></a>02521     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_m=0; q_m&lt;<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>(); q_m++)
<a name="l02522"></a>02522     {
<a name="l02523"></a>02523       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_bfs; i++)
<a name="l02524"></a>02524       {
<a name="l02525"></a>02525         RB_Fq_Mq_norms_in &gt;&gt; <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a400cfc38ee1a109d110230227d59b651">Fq_Mq_representor_norms</a>[q_f][q_m][i];
<a name="l02526"></a>02526       }
<a name="l02527"></a>02527     }
<a name="l02528"></a>02528   }
<a name="l02529"></a>02529   RB_Fq_Mq_norms_in.close();
<a name="l02530"></a>02530 
<a name="l02531"></a>02531   <span class="comment">// Next read in the Mq_Mq representor norm data</span>
<a name="l02532"></a>02532   std::ifstream RB_Mq_Mq_norms_in;
<a name="l02533"></a>02533   {
<a name="l02534"></a>02534     <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l02535"></a>02535     file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/Mq_Mq_norms.dat&quot;</span>;
<a name="l02536"></a>02536     RB_Mq_Mq_norms_in.open(file_name.str().c_str());
<a name="l02537"></a>02537   }
<a name="l02538"></a>02538   <span class="keywordflow">if</span> ( !RB_Mq_Mq_norms_in.good() )
<a name="l02539"></a>02539   {
<a name="l02540"></a>02540     <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening RB_Mq_Mq_norms_in.dat&quot;</span> &lt;&lt; std::endl;
<a name="l02541"></a>02541     libmesh_error();
<a name="l02542"></a>02542   }
<a name="l02543"></a>02543   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Q_m_hat = <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>()*(<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>()+1)/2;
<a name="l02544"></a>02544   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q=0; q&lt;Q_m_hat; q++)
<a name="l02545"></a>02545   {
<a name="l02546"></a>02546     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_bfs; i++)
<a name="l02547"></a>02547     {
<a name="l02548"></a>02548       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;n_bfs; j++)
<a name="l02549"></a>02549       {
<a name="l02550"></a>02550         RB_Mq_Mq_norms_in &gt;&gt; <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a4ab78d5be55e56ba7170868428592f51">Mq_Mq_representor_norms</a>[q][i][j];
<a name="l02551"></a>02551       }
<a name="l02552"></a>02552     }
<a name="l02553"></a>02553   }
<a name="l02554"></a>02554   RB_Mq_Mq_norms_in.close();
<a name="l02555"></a>02555 
<a name="l02556"></a>02556   <span class="comment">// Next read in the Aq_Mq representor norm data</span>
<a name="l02557"></a>02557   std::ifstream RB_Aq_Mq_norms_in;
<a name="l02558"></a>02558   {
<a name="l02559"></a>02559     <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l02560"></a>02560     file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/Aq_Mq_norms.dat&quot;</span>;
<a name="l02561"></a>02561     RB_Aq_Mq_norms_in.open(file_name.str().c_str());
<a name="l02562"></a>02562   }
<a name="l02563"></a>02563   <span class="keywordflow">if</span> ( !RB_Aq_Mq_norms_in.good() )
<a name="l02564"></a>02564   {
<a name="l02565"></a>02565     <a class="code" href="namespacelibMesh.php#ab0817b8542b150bfa3fb23393df99f28">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening Aq_Mq_norms.dat&quot;</span> &lt;&lt; std::endl;
<a name="l02566"></a>02566     libmesh_error();
<a name="l02567"></a>02567   }
<a name="l02568"></a>02568   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_a=0; q_a&lt;<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>(); q_a++)
<a name="l02569"></a>02569   {
<a name="l02570"></a>02570     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_m=0; q_m&lt;<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>(); q_m++)
<a name="l02571"></a>02571     {
<a name="l02572"></a>02572       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_bfs; i++)
<a name="l02573"></a>02573       {
<a name="l02574"></a>02574         <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;n_bfs; j++)
<a name="l02575"></a>02575         {
<a name="l02576"></a>02576           RB_Aq_Mq_norms_in &gt;&gt; <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ad2d68b220943632bcb8327ca1b388eae">Aq_Mq_representor_norms</a>[q_a][q_m][i][j];
<a name="l02577"></a>02577         }
<a name="l02578"></a>02578       }
<a name="l02579"></a>02579     }
<a name="l02580"></a>02580   }
<a name="l02581"></a>02581   RB_Aq_Mq_norms_in.close();
<a name="l02582"></a>02582 
<a name="l02583"></a>02583   <span class="comment">// Read in the representors if requested</span>
<a name="l02584"></a>02584   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1RBSystem.php#a5ac870aac52f838bd28ee088ddc095b0">store_representors</a>)
<a name="l02585"></a>02585     {
<a name="l02586"></a>02586       <span class="keyword">const</span> std::string residual_representors_dir = <span class="stringliteral">&quot;residual_representors&quot;</span>;
<a name="l02587"></a>02587       <span class="keyword">const</span> std::string residual_representor_suffix =
<a name="l02588"></a>02588         (<a class="code" href="classlibMesh_1_1RBSystem.php#a6be264f3a81564aa2cf7144b54d74552">read_binary_residual_representors</a> ? <span class="stringliteral">&quot;.xdr&quot;</span> : <span class="stringliteral">&quot;.dat&quot;</span>);
<a name="l02589"></a>02589 
<a name="l02590"></a>02590       std::ostringstream file_name;
<a name="l02591"></a>02591       <span class="keyword">struct </span>stat stat_info;
<a name="l02592"></a>02592       
<a name="l02593"></a>02593 
<a name="l02594"></a>02594       <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Reading in the M_q_representors...&quot;</span> &lt;&lt; std::endl;
<a name="l02595"></a>02595 
<a name="l02596"></a>02596       <span class="comment">// Read in the A_q representors.  The class makes room for [Q_m][Nmax] of these.  We are going to</span>
<a name="l02597"></a>02597       <span class="comment">// read in [Q_m][this-&gt;get_n_basis_functions()].  FIXME:</span>
<a name="l02598"></a>02598       <span class="comment">// should we be worried about leaks in the locations where we&#39;re about to fill entries?</span>
<a name="l02599"></a>02599       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a7b52b6d7cf4f4f9245464050e876d21b">M_q_representor</a>.size(); ++i)
<a name="l02600"></a>02600         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a7b52b6d7cf4f4f9245464050e876d21b">M_q_representor</a>[i].size(); ++j)
<a name="l02601"></a>02601           {
<a name="l02602"></a>02602             <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a7b52b6d7cf4f4f9245464050e876d21b">M_q_representor</a>[i][j] != NULL)
<a name="l02603"></a>02603               {
<a name="l02604"></a>02604                 <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Error, must delete existing M_q_representor before reading in from file.&quot;</span>
<a name="l02605"></a>02605                              &lt;&lt; std::endl;
<a name="l02606"></a>02606                 libmesh_error();
<a name="l02607"></a>02607               }
<a name="l02608"></a>02608           }
<a name="l02609"></a>02609 
<a name="l02610"></a>02610       <span class="comment">// Now ready to read them in from file!</span>
<a name="l02611"></a>02611       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a7b52b6d7cf4f4f9245464050e876d21b">M_q_representor</a>.size(); ++i)
<a name="l02612"></a>02612         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;this-&gt;<a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>(); ++j)
<a name="l02613"></a>02613           {
<a name="l02614"></a>02614             file_name.str(<span class="stringliteral">&quot;&quot;</span>); <span class="comment">// reset filename</span>
<a name="l02615"></a>02615             file_name &lt;&lt; residual_representors_dir
<a name="l02616"></a>02616                       &lt;&lt; <span class="stringliteral">&quot;/M_q_representor&quot;</span> &lt;&lt; i &lt;&lt; <span class="stringliteral">&quot;_&quot;</span> &lt;&lt; j &lt;&lt; residual_representor_suffix;
<a name="l02617"></a>02617 
<a name="l02618"></a>02618             <span class="comment">// On processor zero check to be sure the file exists</span>
<a name="l02619"></a>02619             <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l02620"></a>02620             {
<a name="l02621"></a>02621               <span class="keywordtype">int</span> stat_result = stat(file_name.str().c_str(), &amp;stat_info);
<a name="l02622"></a>02622 
<a name="l02623"></a>02623               <span class="keywordflow">if</span> (stat_result != 0)
<a name="l02624"></a>02624                 {
<a name="l02625"></a>02625                   <a class="code" href="namespacelibMesh.php#a08e2b5dd30d71db9e43c52a5a631fdae">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;File does not exist: &quot;</span> &lt;&lt; file_name.str() &lt;&lt; std::endl;
<a name="l02626"></a>02626                   libmesh_error();
<a name="l02627"></a>02627                 }
<a name="l02628"></a>02628             }
<a name="l02629"></a>02629 
<a name="l02630"></a>02630             <a class="code" href="classlibMesh_1_1Xdr.php">Xdr</a> aqr_data(file_name.str(),
<a name="l02631"></a>02631                          <a class="code" href="classlibMesh_1_1RBSystem.php#a6be264f3a81564aa2cf7144b54d74552">read_binary_residual_representors</a> ? <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a2632308739033bf9f82ea90cdf92231e">DECODE</a> : <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8acd5c7906bd7fea7650acc4c8cde09d48">READ</a>);
<a name="l02632"></a>02632 
<a name="l02633"></a>02633             <a class="code" href="classlibMesh_1_1System.php#a3eb0dd9d3ef0453daf9b5eeff0819736">read_serialized_data</a>(aqr_data, <span class="keyword">false</span>);
<a name="l02634"></a>02634 
<a name="l02635"></a>02635             <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a7b52b6d7cf4f4f9245464050e876d21b">M_q_representor</a>[i][j] = <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;::build</a>().release();
<a name="l02636"></a>02636             <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a7b52b6d7cf4f4f9245464050e876d21b">M_q_representor</a>[i][j]-&gt;init (this-&gt;<a class="code" href="classlibMesh_1_1System.php#a90dbb901f00c14ff18399f4afabcebe5">n_dofs</a>(), this-&gt;<a class="code" href="classlibMesh_1_1System.php#ae3aeb82e65b06789823d41da3c5df7a2">n_local_dofs</a>(),
<a name="l02637"></a>02637                                          <span class="keyword">false</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">libMeshEnums::PARALLEL</a>);
<a name="l02638"></a>02638 
<a name="l02639"></a>02639             <span class="comment">// No need to copy, just swap</span>
<a name="l02640"></a>02640             <span class="comment">//*M_q_representor[i][j] = *solution;</span>
<a name="l02641"></a>02641             <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a7b52b6d7cf4f4f9245464050e876d21b">M_q_representor</a>[i][j]-&gt;swap(*<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>);
<a name="l02642"></a>02642           }
<a name="l02643"></a>02643     } <span class="comment">// end if (store_representors)</span>
<a name="l02644"></a>02644 
<a name="l02645"></a>02645   STOP_LOG(<span class="stringliteral">&quot;read_offline_data_from_files()&quot;</span>, <span class="stringliteral">&quot;TransientRBSystem&quot;</span>);
<a name="l02646"></a>02646 }
<a name="l02647"></a>02647 
<a name="l02648"></a>02648 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
